/*===========================================================================*/
/*   (Cfa/arithmetic.scm)                                                    */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/arithmetic.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
		obj_t BgL_dupz00;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_prezd2arithmeticzd2appz00_bgl
	{
		obj_t BgL_speczd2typeszd2;
	}                                *BgL_prezd2arithmeticzd2appz00_bglt;

	typedef struct BgL_arithmeticzd2appzd2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_speczd2typeszd2;
	}                          *BgL_arithmeticzd2appzd2_bglt;


	static obj_t
		BGl_z62cleanupzd2nodez12zd2funcal1577z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2switch1559z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00(obj_t);
	static obj_t
		BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2setzd2ex1565za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t
		BGl_z62nodezd2setupz12zd2prezd2arit1581za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_nodezd2setupza2z12z62zzcfa_setupz00(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	static obj_t BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62cleanupzd2nodez12zd2app1579z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2boxzd2se1573za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2sequen1549z70zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setupz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_iteratez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_loosez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
	extern BgL_approxz00_bglt
		BGl_makezd2typezd2approxz00zzcfa_approxz00(BgL_typez00_bglt);
	extern obj_t BGl_prezd2arithmeticzd2appz00zzcfa_info2z00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	static obj_t BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t);
	extern obj_t BGl_continuezd2cfaz12zc0zzcfa_iteratez00(obj_t);
	static obj_t BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00(obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2makezd2b1569za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2jumpzd2e1567za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_z62cleanupzd2nodez121546za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_gczd2rootszd2initz00zzcfa_arithmeticz00();
	static obj_t BGl_z62cleanupzd2nodez12zd2setq1553z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern BgL_approxz00_bglt BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
	static obj_t
		BGl_z62cleanupzd2nodez12zd2letzd2va1563za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2letzd2fu1561za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2appzd2ly1575za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2condit1555z70zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00();
	extern obj_t BGl_arithmeticzd2appzd2zzcfa_info2z00;
	extern obj_t BGl_typez00zztype_typez00;
	extern BgL_approxz00_bglt BGl_loosez12z12zzcfa_loosez00(BgL_approxz00_bglt,
		obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2boxzd2re1571za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
	static obj_t BGl_z62cleanupzd2nodez12zd2fail1557z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t BGl_z62cleanupzd2nodez12zd2sync1551z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static BgL_approxz00_bglt
		BGl_z62cfaz12zd2arithmeticzd2app1583z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_approxzd2setzd2typez12z12zzcfa_approxz00(BgL_approxz00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[3];


	   
		 
		DEFINE_STRING(BGl_string2133z00zzcfa_arithmeticz00,
		BgL_bgl_string2133za700za7za7c2161za7, "cleanup-node!1546", 17);
	      DEFINE_STRING(BGl_string2135z00zzcfa_arithmeticz00,
		BgL_bgl_string2135za700za7za7c2162za7, "cleanup-node!", 13);
	      DEFINE_STRING(BGl_string2152z00zzcfa_arithmeticz00,
		BgL_bgl_string2152za700za7za7c2163za7, "node-setup!", 11);
	      DEFINE_STRING(BGl_string2154z00zzcfa_arithmeticz00,
		BgL_bgl_string2154za700za7za7c2164za7, "cfa!::approx", 12);
	      DEFINE_STRING(BGl_string2155z00zzcfa_arithmeticz00,
		BgL_bgl_string2155za700za7za7c2165za7, "Illegal arithmetic node", 23);
	      DEFINE_STRING(BGl_string2156z00zzcfa_arithmeticz00,
		BgL_bgl_string2156za700za7za7c2166za7, "cfa_arithmetic", 14);
	      DEFINE_STRING(BGl_string2157z00zzcfa_arithmeticz00,
		BgL_bgl_string2157za700za7za7c2167za7, "all c-eq? arithmetic-app ", 25);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2132z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2168z00,
		BGl_z62cleanupzd2nodez121546za2zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2134z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2169z00,
		BGl_z62cleanupzd2nodez12zd2sequen1549z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2136z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2170z00,
		BGl_z62cleanupzd2nodez12zd2sync1551z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2137z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2171z00,
		BGl_z62cleanupzd2nodez12zd2setq1553z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2138z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2172z00,
		BGl_z62cleanupzd2nodez12zd2condit1555z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2139z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2173z00,
		BGl_z62cleanupzd2nodez12zd2fail1557z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2140z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2174z00,
		BGl_z62cleanupzd2nodez12zd2switch1559z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2141z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2175z00,
		BGl_z62cleanupzd2nodez12zd2letzd2fu1561za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2142z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2176z00,
		BGl_z62cleanupzd2nodez12zd2letzd2va1563za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2143z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2177z00,
		BGl_z62cleanupzd2nodez12zd2setzd2ex1565za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2144z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2178z00,
		BGl_z62cleanupzd2nodez12zd2jumpzd2e1567za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2145z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2179z00,
		BGl_z62cleanupzd2nodez12zd2makezd2b1569za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2146z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2180z00,
		BGl_z62cleanupzd2nodez12zd2boxzd2re1571za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2147z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2181z00,
		BGl_z62cleanupzd2nodez12zd2boxzd2se1573za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2148z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2182z00,
		BGl_z62cleanupzd2nodez12zd2appzd2ly1575za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2149z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2183z00,
		BGl_z62cleanupzd2nodez12zd2funcal1577z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2150z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2184z00,
		BGl_z62cleanupzd2nodez12zd2app1579z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2151z00zzcfa_arithmeticz00,
		BgL_bgl_za762nodeza7d2setupza72185za7,
		BGl_z62nodezd2setupz12zd2prezd2arit1581za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2153z00zzcfa_arithmeticz00,
		BgL_bgl_za762cfaza712za7d2arit2186za7,
		BGl_z62cfaz12zd2arithmeticzd2app1583z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2187z00,
		BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_cfaz12zd2envzc0zzcfa_cfaz00;
	extern obj_t BGl_nodezd2setupz12zd2envz12zzcfa_setupz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_cleanupzd2arithmeticzd2nodesz12zd2envzc0zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2ari2188z00,
		BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void *) (&BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long
		BgL_checksumz00_4102, char *BgL_fromz00_4103)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcfa_arithmeticz00();
					BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_cnstzd2initzd2zzcfa_arithmeticz00();
					BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_genericzd2initzd2zzcfa_arithmeticz00();
					BGl_methodzd2initzd2zzcfa_arithmeticz00();
					return BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_arithmetic");
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			{	/* Cfa/arithmetic.scm 28 */
				obj_t BgL_cportz00_3943;

				{	/* Cfa/arithmetic.scm 28 */
					obj_t BgL_stringz00_3951;

					BgL_stringz00_3951 = BGl_string2157z00zzcfa_arithmeticz00;
					{	/* Cfa/arithmetic.scm 28 */
						obj_t BgL_startz00_3952;

						BgL_startz00_3952 = BINT(((long) 0));
						{	/* Cfa/arithmetic.scm 28 */
							obj_t BgL_endz00_3953;

							BgL_endz00_3953 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_3951)));
							{	/* Cfa/arithmetic.scm 28 */

								BgL_cportz00_3943 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_3951, BgL_startz00_3952, BgL_endz00_3953);
				}}}}
				{
					long BgL_iz00_3944;

					BgL_iz00_3944 = ((long) 2);
				BgL_loopz00_3945:
					if ((BgL_iz00_3944 == ((long) -1)))
						{	/* Cfa/arithmetic.scm 28 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/arithmetic.scm 28 */
							{	/* Cfa/arithmetic.scm 28 */
								obj_t BgL_arg2159z00_3947;

								{	/* Cfa/arithmetic.scm 28 */

									{	/* Cfa/arithmetic.scm 28 */
										obj_t BgL_locationz00_3949;

										BgL_locationz00_3949 = BBOOL(((bool_t) 0));
										{	/* Cfa/arithmetic.scm 28 */

											BgL_arg2159z00_3947 =
												BGl_readz00zz__readerz00(BgL_cportz00_3943,
												BgL_locationz00_3949);
										}
									}
								}
								{	/* Cfa/arithmetic.scm 28 */
									int BgL_tmpz00_4131;

									BgL_tmpz00_4131 = (int) (BgL_iz00_3944);
									CNST_TABLE_SET(BgL_tmpz00_4131, BgL_arg2159z00_3947);
							}}
							{	/* Cfa/arithmetic.scm 28 */
								int BgL_auxz00_3950;

								BgL_auxz00_3950 = (int) ((BgL_iz00_3944 - ((long) 1)));
								{
									long BgL_iz00_4136;

									BgL_iz00_4136 = (long) (BgL_auxz00_3950);
									BgL_iz00_3944 = BgL_iz00_4136;
									goto BgL_loopz00_3945;
								}
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BNIL;
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cleanup-arithmetic-nodes! */
	BGL_EXPORTED_DEF obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t
		BgL_globalsz00_3)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 52 */
			{
				obj_t BgL_l1510z00_2779;

				BgL_l1510z00_2779 = BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00;
			BgL_zc3anonymousza31590ze3z83_2780:
				if (PAIRP(BgL_l1510z00_2779))
					{	/* Cfa/arithmetic.scm 63 */
						{	/* Cfa/arithmetic.scm 64 */
							obj_t BgL_nodez00_2782;

							BgL_nodez00_2782 = CAR(BgL_l1510z00_2779);
							{	/* Cfa/arithmetic.scm 65 */
								BgL_variablez00_bglt BgL_fz00_2784;

								BgL_fz00_2784 =
									(((BgL_varz00_bglt) COBJECT(
											(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_2782))))->
												BgL_funz00)))->BgL_variablez00);
								{	/* Cfa/arithmetic.scm 65 */
									BgL_valuez00_bglt BgL_valz00_2785;

									BgL_valz00_2785 =
										(((BgL_variablez00_bglt) COBJECT(BgL_fz00_2784))->
										BgL_valuez00);
									{	/* Cfa/arithmetic.scm 66 */

										{	/* Cfa/arithmetic.scm 68 */
											bool_t BgL_testz00_4147;

											{	/* Cfa/arithmetic.scm 68 */
												BgL_typez00_bglt BgL_arg1613z00_2788;

												BgL_arg1613z00_2788 =
													(((BgL_variablez00_bglt) COBJECT(BgL_fz00_2784))->
													BgL_typez00);
												BgL_testz00_4147 =
													(((obj_t) BgL_arg1613z00_2788) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_testz00_4147)
												{	/* Cfa/arithmetic.scm 69 */
													BgL_typez00_bglt BgL_vz00_3682;

													BgL_vz00_3682 =
														((BgL_typez00_bglt)
														BGl_za2objza2z00zztype_cachez00);
													((((BgL_variablez00_bglt) COBJECT(BgL_fz00_2784))->
															BgL_typez00) =
														((BgL_typez00_bglt) BgL_vz00_3682), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 68 */
													BFALSE;
												}
										}
										{	/* Cfa/arithmetic.scm 70 */
											bool_t BgL_testz00_4153;

											{	/* Cfa/arithmetic.scm 70 */
												BgL_typez00_bglt BgL_arg1620z00_2791;

												BgL_arg1620z00_2791 =
													(((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt) BgL_nodez00_2782)))->
													BgL_typez00);
												BgL_testz00_4153 =
													(((obj_t) BgL_arg1620z00_2791) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_testz00_4153)
												{	/* Cfa/arithmetic.scm 71 */
													BgL_typez00_bglt BgL_vz00_3685;

													BgL_vz00_3685 =
														((BgL_typez00_bglt)
														BGl_za2objza2z00zztype_cachez00);
													((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																		BgL_nodez00_2782)))->BgL_typez00) =
														((BgL_typez00_bglt) BgL_vz00_3685), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 70 */
													BFALSE;
												}
										}
										{	/* Cfa/arithmetic.scm 73 */
											bool_t BgL_testz00_4161;

											{	/* Cfa/arithmetic.scm 73 */
												bool_t BgL_res2082z00_3686;

												BgL_res2082z00_3686 =
													BGl_isazf3zf3zz__objectz00(
													((obj_t) BgL_valz00_2785), BGl_sfunz00zzast_varz00);
												BgL_testz00_4161 = BgL_res2082z00_3686;
											}
											if (BgL_testz00_4161)
												{	/* Cfa/arithmetic.scm 74 */
													obj_t BgL_arg1622z00_2793;

													{	/* Cfa/arithmetic.scm 74 */
														obj_t BgL_l1504z00_2794;

														BgL_l1504z00_2794 =
															(((BgL_sfunz00_bglt) COBJECT(
																	((BgL_sfunz00_bglt) BgL_valz00_2785)))->
															BgL_argsz00);
														if (NULLP(BgL_l1504z00_2794))
															{	/* Cfa/arithmetic.scm 74 */
																BgL_arg1622z00_2793 = BNIL;
															}
														else
															{	/* Cfa/arithmetic.scm 74 */
																obj_t BgL_head1506z00_2796;

																{	/* Cfa/arithmetic.scm 74 */
																	obj_t BgL_arg1638z00_2808;

																	{	/* Cfa/arithmetic.scm 74 */
																		obj_t BgL_arg1640z00_2809;

																		BgL_arg1640z00_2809 =
																			CAR(((obj_t) BgL_l1504z00_2794));
																		BgL_arg1638z00_2808 =
																			BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00
																			(BgL_arg1640z00_2809);
																	}
																	{	/* Cfa/arithmetic.scm 74 */
																		obj_t BgL_res2084z00_3690;

																		BgL_res2084z00_3690 =
																			MAKE_YOUNG_PAIR(BgL_arg1638z00_2808,
																			BNIL);
																		BgL_head1506z00_2796 = BgL_res2084z00_3690;
																	}
																}
																{	/* Cfa/arithmetic.scm 74 */
																	obj_t BgL_g1509z00_2797;

																	BgL_g1509z00_2797 =
																		CDR(((obj_t) BgL_l1504z00_2794));
																	{
																		obj_t BgL_l1504z00_2799;
																		obj_t BgL_tail1507z00_2800;

																		BgL_l1504z00_2799 = BgL_g1509z00_2797;
																		BgL_tail1507z00_2800 = BgL_head1506z00_2796;
																	BgL_zc3anonymousza31625ze3z83_2801:
																		if (NULLP(BgL_l1504z00_2799))
																			{	/* Cfa/arithmetic.scm 74 */
																				BgL_arg1622z00_2793 =
																					BgL_head1506z00_2796;
																			}
																		else
																			{	/* Cfa/arithmetic.scm 74 */
																				obj_t BgL_newtail1508z00_2803;

																				{	/* Cfa/arithmetic.scm 74 */
																					obj_t BgL_arg1629z00_2805;

																					{	/* Cfa/arithmetic.scm 74 */
																						obj_t BgL_arg1634z00_2806;

																						BgL_arg1634z00_2806 =
																							CAR(((obj_t) BgL_l1504z00_2799));
																						BgL_arg1629z00_2805 =
																							BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00
																							(BgL_arg1634z00_2806);
																					}
																					{	/* Cfa/arithmetic.scm 74 */
																						obj_t BgL_res2086z00_3694;

																						BgL_res2086z00_3694 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1629z00_2805, BNIL);
																						BgL_newtail1508z00_2803 =
																							BgL_res2086z00_3694;
																					}
																				}
																				SET_CDR(BgL_tail1507z00_2800,
																					BgL_newtail1508z00_2803);
																				{	/* Cfa/arithmetic.scm 74 */
																					obj_t BgL_arg1628z00_2804;

																					BgL_arg1628z00_2804 =
																						CDR(((obj_t) BgL_l1504z00_2799));
																					{
																						obj_t BgL_tail1507z00_4184;
																						obj_t BgL_l1504z00_4183;

																						BgL_l1504z00_4183 =
																							BgL_arg1628z00_2804;
																						BgL_tail1507z00_4184 =
																							BgL_newtail1508z00_2803;
																						BgL_tail1507z00_2800 =
																							BgL_tail1507z00_4184;
																						BgL_l1504z00_2799 =
																							BgL_l1504z00_4183;
																						goto
																							BgL_zc3anonymousza31625ze3z83_2801;
																					}
																				}
																			}
																	}
																}
															}
													}
													((((BgL_sfunz00_bglt) COBJECT(
																	((BgL_sfunz00_bglt) BgL_valz00_2785)))->
															BgL_argsz00) =
														((obj_t) BgL_arg1622z00_2793), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 75 */
													bool_t BgL_testz00_4187;

													{	/* Cfa/arithmetic.scm 75 */
														bool_t BgL_res2087z00_3698;

														BgL_res2087z00_3698 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_valz00_2785),
															BGl_cfunz00zzast_varz00);
														BgL_testz00_4187 = BgL_res2087z00_3698;
													}
													if (BgL_testz00_4187)
														{	/* Cfa/arithmetic.scm 76 */
															obj_t BgL_g1160z00_2811;

															BgL_g1160z00_2811 =
																(((BgL_cfunz00_bglt) COBJECT(
																		((BgL_cfunz00_bglt) BgL_valz00_2785)))->
																BgL_argszd2typezd2);
															{
																obj_t BgL_lz00_2813;

																{	/* Cfa/arithmetic.scm 76 */
																	bool_t BgL_tmpz00_4192;

																	BgL_lz00_2813 = BgL_g1160z00_2811;
																BgL_zc3anonymousza31642ze3z83_2814:
																	if (PAIRP(BgL_lz00_2813))
																		{	/* Cfa/arithmetic.scm 77 */
																			{	/* Cfa/arithmetic.scm 79 */
																				obj_t BgL_tmpz00_4195;

																				BgL_tmpz00_4195 =
																					BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00
																					(CAR(BgL_lz00_2813));
																				SET_CAR(BgL_lz00_2813, BgL_tmpz00_4195);
																			}
																			{
																				obj_t BgL_lz00_4199;

																				BgL_lz00_4199 = CDR(BgL_lz00_2813);
																				BgL_lz00_2813 = BgL_lz00_4199;
																				goto BgL_zc3anonymousza31642ze3z83_2814;
																			}
																		}
																	else
																		{	/* Cfa/arithmetic.scm 77 */
																			BgL_tmpz00_4192 = ((bool_t) 0);
																		}
																	BBOOL(BgL_tmpz00_4192);
																}
															}
														}
													else
														{	/* Cfa/arithmetic.scm 75 */
															BFALSE;
														}
												}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1510z00_4202;

							BgL_l1510z00_4202 = CDR(BgL_l1510z00_2779);
							BgL_l1510z00_2779 = BgL_l1510z00_4202;
							goto BgL_zc3anonymousza31590ze3z83_2780;
						}
					}
				else
					{	/* Cfa/arithmetic.scm 63 */
						((bool_t) 1);
					}
			}
			{
				obj_t BgL_l1512z00_2824;

				BgL_l1512z00_2824 = BgL_globalsz00_3;
			BgL_zc3anonymousza31656ze3z83_2825:
				if (PAIRP(BgL_l1512z00_2824))
					{	/* Cfa/arithmetic.scm 83 */
						{	/* Cfa/arithmetic.scm 83 */
							obj_t BgL_arg1659z00_2827;

							BgL_arg1659z00_2827 = CAR(BgL_l1512z00_2824);
							{	/* Cfa/arithmetic.scm 90 */
								BgL_valuez00_bglt BgL_funz00_3707;

								BgL_funz00_3707 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_arg1659z00_2827)))->
									BgL_valuez00);
								{	/* Cfa/arithmetic.scm 90 */
									obj_t BgL_bodyz00_3708;

									BgL_bodyz00_3708 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_funz00_3707)))->BgL_bodyz00);
									{	/* Cfa/arithmetic.scm 91 */

										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_bodyz00_3708));
									}
								}
							}
						}
						{
							obj_t BgL_l1512z00_4213;

							BgL_l1512z00_4213 = CDR(BgL_l1512z00_2824);
							BgL_l1512z00_2824 = BgL_l1512z00_4213;
							goto BgL_zc3anonymousza31656ze3z83_2825;
						}
					}
				else
					{	/* Cfa/arithmetic.scm 83 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_3;
		}
		BGL_FUNCTION_END;
	}



/* cleanup-type~0 */
	obj_t BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00(obj_t BgL_tz00_2830)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 62 */
			if (BGl_isazf3zf3zz__objectz00(BgL_tz00_2830, BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 55 */
					if ((BgL_tz00_2830 == BGl_za2_za2z00zztype_cachez00))
						{	/* Cfa/arithmetic.scm 56 */
							return BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Cfa/arithmetic.scm 56 */
							return BgL_tz00_2830;
						}
				}
			else
				{	/* Cfa/arithmetic.scm 55 */
					if (BGl_isazf3zf3zz__objectz00(BgL_tz00_2830,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 57 */
							{	/* Cfa/arithmetic.scm 58 */
								bool_t BgL_testz00_4221;

								{	/* Cfa/arithmetic.scm 58 */
									BgL_typez00_bglt BgL_arg1672z00_2837;

									BgL_arg1672z00_2837 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_tz00_2830))))->BgL_typez00);
									BgL_testz00_4221 =
										(
										((obj_t) BgL_arg1672z00_2837) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_testz00_4221)
									{	/* Cfa/arithmetic.scm 59 */
										BgL_typez00_bglt BgL_vz00_3675;

										BgL_vz00_3675 =
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00);
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt) BgL_tz00_2830))))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_3675), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 58 */
										BFALSE;
									}
							}
							return BgL_tz00_2830;
						}
					else
						{	/* Cfa/arithmetic.scm 57 */
							return BgL_tz00_2830;
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-arithmetic-nodes! */
	obj_t BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3877, obj_t BgL_globalsz00_3878)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 52 */
			return
				BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00
				(BgL_globalsz00_3878);
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_proc2132z00zzcfa_arithmeticz00, BGl_nodez00zzast_nodez00,
				BGl_string2133z00zzcfa_arithmeticz00);
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!1546 */
	obj_t BGl_z62cleanupzd2nodez121546za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3880, obj_t BgL_nodez00_3881)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 97 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cleanup-node! */
	obj_t BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 97 */
			{	/* Cfa/arithmetic.scm 97 */
				obj_t BgL_method1547z00_2845;

				{	/* Cfa/arithmetic.scm 97 */
					obj_t BgL_res2101z00_3760;

					{	/* Cfa/arithmetic.scm 97 */
						long BgL_objzd2classzd2numz00_3717;

						{	/* Cfa/arithmetic.scm 97 */
							long BgL_res2090z00_3720;

							BgL_res2090z00_3720 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
							BgL_objzd2classzd2numz00_3717 = BgL_res2090z00_3720;
						}
						{	/* Cfa/arithmetic.scm 97 */
							obj_t BgL_arg1756z00_3718;

							BgL_arg1756z00_3718 =
								PROCEDURE_REF(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
								(int) (((long) 1)));
							{	/* Cfa/arithmetic.scm 97 */
								int BgL_offsetz00_3722;

								BgL_offsetz00_3722 = (int) (BgL_objzd2classzd2numz00_3717);
								{	/* Cfa/arithmetic.scm 97 */
									long BgL_offsetz00_3723;

									BgL_offsetz00_3723 =
										((long) (BgL_offsetz00_3722) - OBJECT_TYPE);
									{	/* Cfa/arithmetic.scm 97 */
										long BgL_modz00_3724;

										{	/* Cfa/arithmetic.scm 97 */
											int BgL_arg1758z00_3725;

											BgL_arg1758z00_3725 = (int) (((long) 16));
											{	/* Cfa/arithmetic.scm 97 */
												long BgL_res2093z00_3735;

												{	/* Cfa/arithmetic.scm 97 */
													long BgL_tmpz00_4241;

													BgL_tmpz00_4241 = (long) (BgL_arg1758z00_3725);
													BgL_res2093z00_3735 =
														(BgL_offsetz00_3723 / BgL_tmpz00_4241);
												}
												BgL_modz00_3724 = BgL_res2093z00_3735;
										}}
										{	/* Cfa/arithmetic.scm 97 */
											long BgL_restz00_3726;

											{	/* Cfa/arithmetic.scm 97 */
												int BgL_arg1757z00_3727;

												BgL_arg1757z00_3727 = (int) (((long) 16));
												{	/* Cfa/arithmetic.scm 97 */
													long BgL_res2100z00_3755;

													{	/* Cfa/arithmetic.scm 97 */
														long BgL_n1z00_3737;
														long BgL_n2z00_3738;

														BgL_n1z00_3737 = BgL_offsetz00_3723;
														BgL_n2z00_3738 = (long) (BgL_arg1757z00_3727);
														{	/* Cfa/arithmetic.scm 97 */
															bool_t BgL_testz00_4246;

															{	/* Cfa/arithmetic.scm 97 */
																long BgL_arg1292z00_3740;

																BgL_arg1292z00_3740 =
																	(((BgL_n1z00_3737) | (BgL_n2z00_3738)) &
																	-2147483648);
																BgL_testz00_4246 =
																	(BgL_arg1292z00_3740 == ((long) 0));
															}
															if (BgL_testz00_4246)
																{	/* Cfa/arithmetic.scm 97 */
																	int32_t BgL_arg1285z00_3741;

																	{	/* Cfa/arithmetic.scm 97 */
																		int32_t BgL_arg1287z00_3742;
																		int32_t BgL_arg1290z00_3743;

																		{	/* Cfa/arithmetic.scm 97 */
																			int32_t BgL_res2096z00_3747;

																			BgL_res2096z00_3747 =
																				(int32_t) (BgL_n1z00_3737);
																			BgL_arg1287z00_3742 = BgL_res2096z00_3747;
																		}
																		{	/* Cfa/arithmetic.scm 97 */
																			int32_t BgL_res2097z00_3749;

																			BgL_res2097z00_3749 =
																				(int32_t) (BgL_n2z00_3738);
																			BgL_arg1290z00_3743 = BgL_res2097z00_3749;
																		}
																		BgL_arg1285z00_3741 =
																			(BgL_arg1287z00_3742 %
																			BgL_arg1290z00_3743);
																	}
																	{	/* Cfa/arithmetic.scm 97 */
																		long BgL_res2099z00_3754;

																		{	/* Cfa/arithmetic.scm 97 */
																			long BgL_arg1411z00_3751;

																			BgL_arg1411z00_3751 =
																				(long) (BgL_arg1285z00_3741);
																			{	/* Cfa/arithmetic.scm 97 */
																				long BgL_res2098z00_3753;

																				BgL_res2098z00_3753 =
																					(long) (BgL_arg1411z00_3751);
																				BgL_res2099z00_3754 =
																					BgL_res2098z00_3753;
																		}}
																		BgL_res2100z00_3755 = BgL_res2099z00_3754;
																}}
															else
																{	/* Cfa/arithmetic.scm 97 */
																	BgL_res2100z00_3755 =
																		(BgL_n1z00_3737 % BgL_n2z00_3738);
																}
														}
													}
													BgL_restz00_3726 = BgL_res2100z00_3755;
												}
											}
											{	/* Cfa/arithmetic.scm 97 */

												{	/* Cfa/arithmetic.scm 97 */
													obj_t BgL_bucketz00_3728;

													BgL_bucketz00_3728 =
														VECTOR_REF(
														((obj_t) BgL_arg1756z00_3718), BgL_modz00_3724);
													BgL_res2101z00_3760 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3728), BgL_restz00_3726);
												}
											}
										}
									}
								}
							}
						}
					}
					BgL_method1547z00_2845 = BgL_res2101z00_3760;
				}
				return
					PROCEDURE_ENTRY(BgL_method1547z00_2845) (BgL_method1547z00_2845,
					((obj_t) BgL_nodez00_5), BEOA);
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node! */
	obj_t BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00(obj_t BgL_envz00_3882,
		obj_t BgL_nodez00_3883)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 97 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				((BgL_nodez00_bglt) BgL_nodez00_3883));
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2134z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_syncz00zzast_nodez00, BGl_proc2136z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_setqz00zzast_nodez00, BGl_proc2137z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2138z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_failz00zzast_nodez00, BGl_proc2139z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_switchz00zzast_nodez00, BGl_proc2140z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2141z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2142z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2143z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2144z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2145z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2146z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2147z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2148z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2149z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_appz00zzast_nodez00, BGl_proc2150z00zzcfa_arithmeticz00,
				BGl_string2135z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_nodezd2setupz12zd2envz12zzcfa_setupz00,
				BGl_prezd2arithmeticzd2appz00zzcfa_info2z00,
				BGl_proc2151z00zzcfa_arithmeticz00,
				BGl_string2152z00zzcfa_arithmeticz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cfaz12zd2envzc0zzcfa_cfaz00, BGl_arithmeticzd2appzd2zzcfa_info2z00,
				BGl_proc2153z00zzcfa_arithmeticz00,
				BGl_string2154z00zzcfa_arithmeticz00);
		}
		BGL_FUNCTION_END;
	}



/* &cfa!-arithmetic-app1583 */
	BgL_approxz00_bglt
		BGl_z62cfaz12zd2arithmeticzd2app1583z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3902, obj_t BgL_nodez00_3903)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 287 */
			{
				obj_t BgL_argszd2approxzd2_3978;
				obj_t BgL_argszd2approxzd2_3968;
				obj_t BgL_typez00_3969;
				obj_t BgL_speczd2typeszd2_3970;
				obj_t BgL_argszd2approxzd2_3961;
				obj_t BgL_speczd2typeszd2_3962;

				{	/* Cfa/arithmetic.scm 328 */
					obj_t BgL_argszd2approxzd2_3984;

					{	/* Cfa/arithmetic.scm 328 */
						obj_t BgL_l1538z00_3985;

						BgL_l1538z00_3985 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt)
										((BgL_appz00_bglt) BgL_nodez00_3903))))->BgL_argsz00);
						if (NULLP(BgL_l1538z00_3985))
							{	/* Cfa/arithmetic.scm 328 */
								BgL_argszd2approxzd2_3984 = BNIL;
							}
						else
							{	/* Cfa/arithmetic.scm 328 */
								obj_t BgL_head1540z00_3986;

								{	/* Cfa/arithmetic.scm 328 */
									BgL_approxz00_bglt BgL_arg1873z00_3987;

									{	/* Cfa/arithmetic.scm 328 */
										obj_t BgL_arg1874z00_3988;

										BgL_arg1874z00_3988 = CAR(((obj_t) BgL_l1538z00_3985));
										BgL_arg1873z00_3987 =
											BGl_cfaz12z12zzcfa_cfaz00(
											((BgL_nodez00_bglt) BgL_arg1874z00_3988));
									}
									{	/* Cfa/arithmetic.scm 328 */
										obj_t BgL_res2126z00_3989;

										BgL_res2126z00_3989 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg1873z00_3987), BNIL);
										BgL_head1540z00_3986 = BgL_res2126z00_3989;
									}
								}
								{	/* Cfa/arithmetic.scm 328 */
									obj_t BgL_g1543z00_3990;

									BgL_g1543z00_3990 = CDR(((obj_t) BgL_l1538z00_3985));
									{
										obj_t BgL_l1538z00_3992;
										obj_t BgL_tail1541z00_3993;

										BgL_l1538z00_3992 = BgL_g1543z00_3990;
										BgL_tail1541z00_3993 = BgL_head1540z00_3986;
									BgL_zc3anonymousza31868ze3z83_3991:
										if (NULLP(BgL_l1538z00_3992))
											{	/* Cfa/arithmetic.scm 328 */
												BgL_argszd2approxzd2_3984 = BgL_head1540z00_3986;
											}
										else
											{	/* Cfa/arithmetic.scm 328 */
												obj_t BgL_newtail1542z00_3994;

												{	/* Cfa/arithmetic.scm 328 */
													BgL_approxz00_bglt BgL_arg1871z00_3995;

													{	/* Cfa/arithmetic.scm 328 */
														obj_t BgL_arg1872z00_3996;

														BgL_arg1872z00_3996 =
															CAR(((obj_t) BgL_l1538z00_3992));
														BgL_arg1871z00_3995 =
															BGl_cfaz12z12zzcfa_cfaz00(
															((BgL_nodez00_bglt) BgL_arg1872z00_3996));
													}
													{	/* Cfa/arithmetic.scm 328 */
														obj_t BgL_res2128z00_3997;

														BgL_res2128z00_3997 =
															MAKE_YOUNG_PAIR(
															((obj_t) BgL_arg1871z00_3995), BNIL);
														BgL_newtail1542z00_3994 = BgL_res2128z00_3997;
													}
												}
												SET_CDR(BgL_tail1541z00_3993, BgL_newtail1542z00_3994);
												{	/* Cfa/arithmetic.scm 328 */
													obj_t BgL_arg1870z00_3998;

													BgL_arg1870z00_3998 =
														CDR(((obj_t) BgL_l1538z00_3992));
													{
														obj_t BgL_tail1541z00_4309;
														obj_t BgL_l1538z00_4308;

														BgL_l1538z00_4308 = BgL_arg1870z00_3998;
														BgL_tail1541z00_4309 = BgL_newtail1542z00_3994;
														BgL_tail1541z00_3993 = BgL_tail1541z00_4309;
														BgL_l1538z00_3992 = BgL_l1538z00_4308;
														goto BgL_zc3anonymousza31868ze3z83_3991;
													}
												}
											}
									}
								}
							}
					}
					{	/* Cfa/arithmetic.scm 330 */
						obj_t BgL_tyz00_3999;

						BgL_argszd2approxzd2_3978 = BgL_argszd2approxzd2_3984;
						{
							obj_t BgL_argsz00_3980;

							BgL_argsz00_3980 = BgL_argszd2approxzd2_3978;
						BgL_loopz00_3979:
							if (NULLP(BgL_argsz00_3980))
								{	/* Cfa/arithmetic.scm 296 */
									BgL_tyz00_3999 = BFALSE;
								}
							else
								{	/* Cfa/arithmetic.scm 298 */
									obj_t BgL_tz00_3981;

									{	/* Cfa/arithmetic.scm 298 */
										BgL_typez00_bglt BgL_arg1882z00_3982;

										BgL_arg1882z00_3982 =
											(((BgL_approxz00_bglt) COBJECT(
													((BgL_approxz00_bglt)
														CAR(((obj_t) BgL_argsz00_3980)))))->BgL_typez00);
										if (
											(((obj_t) BgL_arg1882z00_3982) ==
												BGl_za2intza2z00zztype_cachez00))
											{	/* Cfa/arithmetic.scm 290 */
												BgL_tz00_3981 = BGl_za2longza2z00zztype_cachez00;
											}
										else
											{	/* Cfa/arithmetic.scm 290 */
												BgL_tz00_3981 = ((obj_t) BgL_arg1882z00_3982);
											}
									}
									if ((BgL_tz00_3981 == BGl_za2_za2z00zztype_cachez00))
										{	/* Cfa/arithmetic.scm 300 */
											obj_t BgL_arg1881z00_3983;

											BgL_arg1881z00_3983 = CDR(((obj_t) BgL_argsz00_3980));
											{
												obj_t BgL_argsz00_4324;

												BgL_argsz00_4324 = BgL_arg1881z00_3983;
												BgL_argsz00_3980 = BgL_argsz00_4324;
												goto BgL_loopz00_3979;
											}
										}
									else
										{	/* Cfa/arithmetic.scm 299 */
											BgL_tyz00_3999 = BgL_tz00_3981;
										}
								}
						}
						{	/* Cfa/arithmetic.scm 336 */
							bool_t BgL_testz00_4325;

							{	/* Cfa/arithmetic.scm 336 */
								obj_t BgL_arg1866z00_4000;

								{
									BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4326;

									{
										obj_t BgL_auxz00_4327;

										{	/* Cfa/arithmetic.scm 336 */
											BgL_objectz00_bglt BgL_tmpz00_4328;

											BgL_tmpz00_4328 =
												((BgL_objectz00_bglt)
												((BgL_appz00_bglt) BgL_nodez00_3903));
											BgL_auxz00_4327 = BGL_OBJECT_WIDENING(BgL_tmpz00_4328);
										}
										BgL_auxz00_4326 =
											((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4327);
									}
									BgL_arg1866z00_4000 =
										(((BgL_arithmeticzd2appzd2_bglt) COBJECT(BgL_auxz00_4326))->
										BgL_speczd2typeszd2);
								}
								BgL_argszd2approxzd2_3968 = BgL_argszd2approxzd2_3984;
								BgL_typez00_3969 = BgL_tyz00_3999;
								BgL_speczd2typeszd2_3970 = BgL_arg1866z00_4000;
								{	/* Cfa/arithmetic.scm 305 */
									bool_t BgL__ortest_1184z00_3971;

									if (CBOOL(BgL_typez00_3969))
										{	/* Cfa/arithmetic.scm 305 */
											BgL__ortest_1184z00_3971 = ((bool_t) 0);
										}
									else
										{	/* Cfa/arithmetic.scm 305 */
											BgL__ortest_1184z00_3971 = ((bool_t) 1);
										}
									if (BgL__ortest_1184z00_3971)
										{	/* Cfa/arithmetic.scm 305 */
											BgL_testz00_4325 = BgL__ortest_1184z00_3971;
										}
									else
										{	/* Cfa/arithmetic.scm 306 */
											obj_t BgL__andtest_1185z00_3972;

											BgL__andtest_1185z00_3972 =
												BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_typez00_3969, BgL_speczd2typeszd2_3970);
											if (CBOOL(BgL__andtest_1185z00_3972))
												{
													obj_t BgL_argsz00_3974;

													BgL_argsz00_3974 = BgL_argszd2approxzd2_3968;
												BgL_loopz00_3973:
													if (NULLP(BgL_argsz00_3974))
														{	/* Cfa/arithmetic.scm 308 */
															BgL_testz00_4325 = ((bool_t) 1);
														}
													else
														{	/* Cfa/arithmetic.scm 310 */
															obj_t BgL_tz00_3975;

															{	/* Cfa/arithmetic.scm 310 */
																BgL_typez00_bglt BgL_arg1891z00_3976;

																BgL_arg1891z00_3976 =
																	(((BgL_approxz00_bglt) COBJECT(
																			((BgL_approxz00_bglt)
																				CAR(
																					((obj_t) BgL_argsz00_3974)))))->
																	BgL_typez00);
																if ((((obj_t) BgL_arg1891z00_3976) ==
																		BGl_za2intza2z00zztype_cachez00))
																	{	/* Cfa/arithmetic.scm 290 */
																		BgL_tz00_3975 =
																			BGl_za2longza2z00zztype_cachez00;
																	}
																else
																	{	/* Cfa/arithmetic.scm 290 */
																		BgL_tz00_3975 =
																			((obj_t) BgL_arg1891z00_3976);
																	}
															}
															{	/* Cfa/arithmetic.scm 311 */
																bool_t BgL_testz00_4350;

																if ((BgL_tz00_3975 == BgL_typez00_3969))
																	{	/* Cfa/arithmetic.scm 311 */
																		BgL_testz00_4350 = ((bool_t) 1);
																	}
																else
																	{	/* Cfa/arithmetic.scm 311 */
																		BgL_testz00_4350 =
																			(BgL_tz00_3975 ==
																			BGl_za2_za2z00zztype_cachez00);
																	}
																if (BgL_testz00_4350)
																	{	/* Cfa/arithmetic.scm 312 */
																		obj_t BgL_arg1890z00_3977;

																		BgL_arg1890z00_3977 =
																			CDR(((obj_t) BgL_argsz00_3974));
																		{
																			obj_t BgL_argsz00_4356;

																			BgL_argsz00_4356 = BgL_arg1890z00_3977;
																			BgL_argsz00_3974 = BgL_argsz00_4356;
																			goto BgL_loopz00_3973;
																		}
																	}
																else
																	{	/* Cfa/arithmetic.scm 311 */
																		BgL_testz00_4325 = ((bool_t) 0);
																	}
															}
														}
												}
											else
												{	/* Cfa/arithmetic.scm 306 */
													BgL_testz00_4325 = ((bool_t) 0);
												}
										}
								}
							}
							if (BgL_testz00_4325)
								{	/* Cfa/arithmetic.scm 336 */
									{	/* Cfa/arithmetic.scm 339 */
										bool_t BgL_testz00_4357;

										{	/* Cfa/arithmetic.scm 339 */
											bool_t BgL_testz00_4358;

											{	/* Cfa/arithmetic.scm 339 */
												obj_t BgL_arg1847z00_4001;

												{
													BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4359;

													{
														obj_t BgL_auxz00_4360;

														{	/* Cfa/arithmetic.scm 339 */
															BgL_objectz00_bglt BgL_tmpz00_4361;

															BgL_tmpz00_4361 =
																((BgL_objectz00_bglt)
																((BgL_appz00_bglt) BgL_nodez00_3903));
															BgL_auxz00_4360 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_4361);
														}
														BgL_auxz00_4359 =
															((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4360);
													}
													BgL_arg1847z00_4001 =
														(((BgL_arithmeticzd2appzd2_bglt)
															COBJECT(BgL_auxz00_4359))->BgL_speczd2typeszd2);
												}
												BgL_argszd2approxzd2_3961 = BgL_argszd2approxzd2_3984;
												BgL_speczd2typeszd2_3962 = BgL_arg1847z00_4001;
												{
													obj_t BgL_argsz00_3964;

													BgL_argsz00_3964 = BgL_argszd2approxzd2_3961;
												BgL_loopz00_3963:
													if (NULLP(BgL_argsz00_3964))
														{	/* Cfa/arithmetic.scm 318 */
															BgL_testz00_4358 = ((bool_t) 1);
														}
													else
														{	/* Cfa/arithmetic.scm 320 */
															bool_t BgL_testz00_4369;

															{	/* Cfa/arithmetic.scm 320 */
																obj_t BgL_arg1901z00_3965;

																{	/* Cfa/arithmetic.scm 320 */
																	BgL_typez00_bglt BgL_arg1902z00_3966;

																	BgL_arg1902z00_3966 =
																		(((BgL_approxz00_bglt) COBJECT(
																				((BgL_approxz00_bglt)
																					CAR(
																						((obj_t) BgL_argsz00_3964)))))->
																		BgL_typez00);
																	if ((((obj_t) BgL_arg1902z00_3966) ==
																			BGl_za2intza2z00zztype_cachez00))
																		{	/* Cfa/arithmetic.scm 290 */
																			BgL_arg1901z00_3965 =
																				BGl_za2longza2z00zztype_cachez00;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 290 */
																			BgL_arg1901z00_3965 =
																				((obj_t) BgL_arg1902z00_3966);
																		}
																}
																BgL_testz00_4369 =
																	CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg1901z00_3965,
																		BgL_speczd2typeszd2_3962));
															}
															if (BgL_testz00_4369)
																{	/* Cfa/arithmetic.scm 321 */
																	obj_t BgL_arg1900z00_3967;

																	BgL_arg1900z00_3967 =
																		CDR(((obj_t) BgL_argsz00_3964));
																	{
																		obj_t BgL_argsz00_4382;

																		BgL_argsz00_4382 = BgL_arg1900z00_3967;
																		BgL_argsz00_3964 = BgL_argsz00_4382;
																		goto BgL_loopz00_3963;
																	}
																}
															else
																{	/* Cfa/arithmetic.scm 320 */
																	BgL_testz00_4358 = ((bool_t) 0);
																}
														}
												}
											}
											if (BgL_testz00_4358)
												{	/* Cfa/arithmetic.scm 340 */
													BgL_typez00_bglt BgL_arg1844z00_4002;

													{
														BgL_approxz00_bglt BgL_auxz00_4383;

														{
															BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4384;

															{
																obj_t BgL_auxz00_4385;

																{	/* Cfa/arithmetic.scm 340 */
																	BgL_objectz00_bglt BgL_tmpz00_4386;

																	BgL_tmpz00_4386 =
																		((BgL_objectz00_bglt)
																		((BgL_appz00_bglt) BgL_nodez00_3903));
																	BgL_auxz00_4385 =
																		BGL_OBJECT_WIDENING(BgL_tmpz00_4386);
																}
																BgL_auxz00_4384 =
																	((BgL_arithmeticzd2appzd2_bglt)
																	BgL_auxz00_4385);
															}
															BgL_auxz00_4383 =
																(((BgL_arithmeticzd2appzd2_bglt)
																	COBJECT(BgL_auxz00_4384))->BgL_approxz00);
														}
														BgL_arg1844z00_4002 =
															(((BgL_approxz00_bglt) COBJECT(BgL_auxz00_4383))->
															BgL_typez00);
													}
													BgL_testz00_4357 =
														(
														((obj_t) BgL_arg1844z00_4002) ==
														BGl_za2_za2z00zztype_cachez00);
												}
											else
												{	/* Cfa/arithmetic.scm 339 */
													BgL_testz00_4357 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_4357)
											{	/* Cfa/arithmetic.scm 339 */
												{	/* Cfa/arithmetic.scm 343 */
													BgL_approxz00_bglt BgL_arg1842z00_4003;

													{
														BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4395;

														{
															obj_t BgL_auxz00_4396;

															{	/* Cfa/arithmetic.scm 343 */
																BgL_objectz00_bglt BgL_tmpz00_4397;

																BgL_tmpz00_4397 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_nodez00_3903));
																BgL_auxz00_4396 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4397);
															}
															BgL_auxz00_4395 =
																((BgL_arithmeticzd2appzd2_bglt)
																BgL_auxz00_4396);
														}
														BgL_arg1842z00_4003 =
															(((BgL_arithmeticzd2appzd2_bglt)
																COBJECT(BgL_auxz00_4395))->BgL_approxz00);
													}
													BGl_approxzd2setzd2typez12z12zzcfa_approxz00
														(BgL_arg1842z00_4003,
														((BgL_typez00_bglt) BgL_tyz00_3999));
												}
												BGl_continuezd2cfaz12zc0zzcfa_iteratez00(CNST_TABLE_REF(
														((long) 0)));
											}
										else
											{	/* Cfa/arithmetic.scm 339 */
												BFALSE;
											}
									}
								}
							else
								{	/* Cfa/arithmetic.scm 345 */
									bool_t BgL_testz00_4407;

									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_globalz00_bglt)
																(((BgL_varz00_bglt) COBJECT(
																			(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_nodez00_3903))))->
																				BgL_funz00)))->BgL_variablez00)))))->
												BgL_idz00) == CNST_TABLE_REF(((long) 1))))
										{	/* Cfa/arithmetic.scm 345 */
											BgL_testz00_4407 = ((bool_t) 0);
										}
									else
										{	/* Cfa/arithmetic.scm 345 */
											BgL_testz00_4407 = ((bool_t) 1);
										}
									if (BgL_testz00_4407)
										{	/* Cfa/arithmetic.scm 345 */
											{
												obj_t BgL_l1544z00_4005;

												BgL_l1544z00_4005 = BgL_argszd2approxzd2_3984;
											BgL_zc3anonymousza31858ze3z83_4004:
												if (PAIRP(BgL_l1544z00_4005))
													{	/* Cfa/arithmetic.scm 346 */
														{	/* Cfa/arithmetic.scm 346 */
															obj_t BgL_az00_4006;

															BgL_az00_4006 = CAR(BgL_l1544z00_4005);
															BGl_loosez12z12zzcfa_loosez00(
																((BgL_approxz00_bglt) BgL_az00_4006),
																CNST_TABLE_REF(((long) 2)));
														}
														{
															obj_t BgL_l1544z00_4424;

															BgL_l1544z00_4424 = CDR(BgL_l1544z00_4005);
															BgL_l1544z00_4005 = BgL_l1544z00_4424;
															goto BgL_zc3anonymousza31858ze3z83_4004;
														}
													}
												else
													{	/* Cfa/arithmetic.scm 346 */
														((bool_t) 1);
													}
											}
											{	/* Cfa/arithmetic.scm 347 */
												BgL_approxz00_bglt BgL_arg1862z00_4007;

												{
													BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4426;

													{
														obj_t BgL_auxz00_4427;

														{	/* Cfa/arithmetic.scm 347 */
															BgL_objectz00_bglt BgL_tmpz00_4428;

															BgL_tmpz00_4428 =
																((BgL_objectz00_bglt)
																((BgL_appz00_bglt) BgL_nodez00_3903));
															BgL_auxz00_4427 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_4428);
														}
														BgL_auxz00_4426 =
															((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4427);
													}
													BgL_arg1862z00_4007 =
														(((BgL_arithmeticzd2appzd2_bglt)
															COBJECT(BgL_auxz00_4426))->BgL_approxz00);
												}
												BGl_approxzd2setzd2typez12z12zzcfa_approxz00
													(BgL_arg1862z00_4007,
													((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00));
											}
										}
									else
										{	/* Cfa/arithmetic.scm 345 */
											BFALSE;
										}
								}
						}
					}
				}
				{
					BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4436;

					{
						obj_t BgL_auxz00_4437;

						{	/* Cfa/arithmetic.scm 350 */
							BgL_objectz00_bglt BgL_tmpz00_4438;

							BgL_tmpz00_4438 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3903));
							BgL_auxz00_4437 = BGL_OBJECT_WIDENING(BgL_tmpz00_4438);
						}
						BgL_auxz00_4436 = ((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4437);
					}
					return
						(((BgL_arithmeticzd2appzd2_bglt) COBJECT(BgL_auxz00_4436))->
						BgL_approxz00);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &node-setup!-pre-arit1581 */
	obj_t BGl_z62nodezd2setupz12zd2prezd2arit1581za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3904, obj_t BgL_nodez00_3905)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 244 */
			{	/* Cfa/arithmetic.scm 255 */
				BgL_variablez00_bglt BgL_fz00_4009;

				BgL_fz00_4009 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3905))))->BgL_funz00)))->
					BgL_variablez00);
				{	/* Cfa/arithmetic.scm 255 */
					BgL_valuez00_bglt BgL_valz00_4010;

					BgL_valz00_4010 =
						(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->BgL_valuez00);
					{	/* Cfa/arithmetic.scm 256 */

						{	/* Cfa/arithmetic.scm 258 */
							bool_t BgL_testz00_4449;

							{	/* Cfa/arithmetic.scm 258 */
								BgL_typez00_bglt BgL_arg1801z00_4011;

								BgL_arg1801z00_4011 =
									(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
									BgL_typez00);
								BgL_testz00_4449 =
									(((obj_t) BgL_arg1801z00_4011) ==
									BGl_za2objza2z00zztype_cachez00);
							}
							if (BgL_testz00_4449)
								{	/* Cfa/arithmetic.scm 258 */
									{	/* Cfa/arithmetic.scm 261 */
										BgL_typez00_bglt BgL_vz00_4012;

										BgL_vz00_4012 =
											((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
										((((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_4012), BUNSPEC);
									}
									{	/* Cfa/arithmetic.scm 262 */
										BgL_typez00_bglt BgL_vz00_4013;

										BgL_vz00_4013 =
											((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
										((((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_3905))))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_4013), BUNSPEC);
									}
								}
							else
								{	/* Cfa/arithmetic.scm 258 */
									BFALSE;
								}
						}
						{	/* Cfa/arithmetic.scm 264 */
							bool_t BgL_testz00_4459;

							{	/* Cfa/arithmetic.scm 264 */
								bool_t BgL_res2111z00_4014;

								BgL_res2111z00_4014 =
									BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_valz00_4010), BGl_sfunz00zzast_varz00);
								BgL_testz00_4459 = BgL_res2111z00_4014;
							}
							if (BgL_testz00_4459)
								{	/* Cfa/arithmetic.scm 265 */
									obj_t BgL_arg1803z00_4015;

									{	/* Cfa/arithmetic.scm 265 */
										obj_t BgL_l1532z00_4016;

										BgL_l1532z00_4016 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_valz00_4010)))->BgL_argsz00);
										if (NULLP(BgL_l1532z00_4016))
											{	/* Cfa/arithmetic.scm 265 */
												BgL_arg1803z00_4015 = BNIL;
											}
										else
											{	/* Cfa/arithmetic.scm 265 */
												obj_t BgL_head1534z00_4017;

												{	/* Cfa/arithmetic.scm 265 */
													obj_t BgL_arg1810z00_4018;

													{	/* Cfa/arithmetic.scm 265 */
														obj_t BgL_arg1811z00_4019;

														BgL_arg1811z00_4019 =
															CAR(((obj_t) BgL_l1532z00_4016));
														BgL_arg1810z00_4018 =
															BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00
															(BgL_arg1811z00_4019);
													}
													{	/* Cfa/arithmetic.scm 265 */
														obj_t BgL_res2113z00_4020;

														BgL_res2113z00_4020 =
															MAKE_YOUNG_PAIR(BgL_arg1810z00_4018, BNIL);
														BgL_head1534z00_4017 = BgL_res2113z00_4020;
													}
												}
												{	/* Cfa/arithmetic.scm 265 */
													obj_t BgL_g1537z00_4021;

													BgL_g1537z00_4021 = CDR(((obj_t) BgL_l1532z00_4016));
													{
														obj_t BgL_l1532z00_4023;
														obj_t BgL_tail1535z00_4024;

														BgL_l1532z00_4023 = BgL_g1537z00_4021;
														BgL_tail1535z00_4024 = BgL_head1534z00_4017;
													BgL_zc3anonymousza31805ze3z83_4022:
														if (NULLP(BgL_l1532z00_4023))
															{	/* Cfa/arithmetic.scm 265 */
																BgL_arg1803z00_4015 = BgL_head1534z00_4017;
															}
														else
															{	/* Cfa/arithmetic.scm 265 */
																obj_t BgL_newtail1536z00_4025;

																{	/* Cfa/arithmetic.scm 265 */
																	obj_t BgL_arg1808z00_4026;

																	{	/* Cfa/arithmetic.scm 265 */
																		obj_t BgL_arg1809z00_4027;

																		BgL_arg1809z00_4027 =
																			CAR(((obj_t) BgL_l1532z00_4023));
																		BgL_arg1808z00_4026 =
																			BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00
																			(BgL_arg1809z00_4027);
																	}
																	{	/* Cfa/arithmetic.scm 265 */
																		obj_t BgL_res2115z00_4028;

																		BgL_res2115z00_4028 =
																			MAKE_YOUNG_PAIR(BgL_arg1808z00_4026,
																			BNIL);
																		BgL_newtail1536z00_4025 =
																			BgL_res2115z00_4028;
																	}
																}
																SET_CDR(BgL_tail1535z00_4024,
																	BgL_newtail1536z00_4025);
																{	/* Cfa/arithmetic.scm 265 */
																	obj_t BgL_arg1807z00_4029;

																	BgL_arg1807z00_4029 =
																		CDR(((obj_t) BgL_l1532z00_4023));
																	{
																		obj_t BgL_tail1535z00_4482;
																		obj_t BgL_l1532z00_4481;

																		BgL_l1532z00_4481 = BgL_arg1807z00_4029;
																		BgL_tail1535z00_4482 =
																			BgL_newtail1536z00_4025;
																		BgL_tail1535z00_4024 = BgL_tail1535z00_4482;
																		BgL_l1532z00_4023 = BgL_l1532z00_4481;
																		goto BgL_zc3anonymousza31805ze3z83_4022;
																	}
																}
															}
													}
												}
											}
									}
									((((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_valz00_4010)))->BgL_argsz00) =
										((obj_t) BgL_arg1803z00_4015), BUNSPEC);
								}
							else
								{	/* Cfa/arithmetic.scm 266 */
									bool_t BgL_testz00_4485;

									{	/* Cfa/arithmetic.scm 266 */
										bool_t BgL_res2116z00_4030;

										BgL_res2116z00_4030 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_valz00_4010), BGl_cfunz00zzast_varz00);
										BgL_testz00_4485 = BgL_res2116z00_4030;
									}
									if (BgL_testz00_4485)
										{	/* Cfa/arithmetic.scm 267 */
											obj_t BgL_g1178z00_4031;

											BgL_g1178z00_4031 =
												(((BgL_cfunz00_bglt) COBJECT(
														((BgL_cfunz00_bglt) BgL_valz00_4010)))->
												BgL_argszd2typezd2);
											{
												obj_t BgL_lz00_4033;

												BgL_lz00_4033 = BgL_g1178z00_4031;
											BgL_loopz00_4032:
												if (PAIRP(BgL_lz00_4033))
													{	/* Cfa/arithmetic.scm 269 */
														obj_t BgL_tmpz00_4492;

														BgL_tmpz00_4492 =
															BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00
															(CAR(BgL_lz00_4033));
														SET_CAR(BgL_lz00_4033, BgL_tmpz00_4492);
													}
												else
													{	/* Cfa/arithmetic.scm 270 */
														obj_t BgL_arg1817z00_4034;

														BgL_arg1817z00_4034 = CDR(((obj_t) BgL_lz00_4033));
														{
															obj_t BgL_lz00_4498;

															BgL_lz00_4498 = BgL_arg1817z00_4034;
															BgL_lz00_4033 = BgL_lz00_4498;
															goto BgL_loopz00_4032;
														}
													}
											}
										}
									else
										{	/* Cfa/arithmetic.scm 266 */
											BGl_errorz00zz__errorz00
												(BGl_string2152z00zzcfa_arithmeticz00,
												BGl_string2155z00zzcfa_arithmeticz00,
												((obj_t) ((BgL_appz00_bglt) BgL_nodez00_3905)));
										}
								}
						}
						BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 =
							MAKE_YOUNG_PAIR(
							((obj_t)
								((BgL_appz00_bglt) BgL_nodez00_3905)),
							BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00);
						{	/* Cfa/arithmetic.scm 275 */
							obj_t BgL_arg1818z00_4035;

							BgL_arg1818z00_4035 =
								(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3905))))->BgL_argsz00);
							BGl_nodezd2setupza2z12z62zzcfa_setupz00(BgL_arg1818z00_4035);
						}
						{	/* Cfa/arithmetic.scm 276 */
							obj_t BgL_speczd2typeszd2_4036;

							{
								BgL_prezd2arithmeticzd2appz00_bglt BgL_auxz00_4509;

								{
									obj_t BgL_auxz00_4510;

									{	/* Cfa/arithmetic.scm 276 */
										BgL_objectz00_bglt BgL_tmpz00_4511;

										BgL_tmpz00_4511 =
											((BgL_objectz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3905));
										BgL_auxz00_4510 = BGL_OBJECT_WIDENING(BgL_tmpz00_4511);
									}
									BgL_auxz00_4509 =
										((BgL_prezd2arithmeticzd2appz00_bglt) BgL_auxz00_4510);
								}
								BgL_speczd2typeszd2_4036 =
									(((BgL_prezd2arithmeticzd2appz00_bglt)
										COBJECT(BgL_auxz00_4509))->BgL_speczd2typeszd2);
							}
							{	/* Cfa/arithmetic.scm 276 */
								BgL_appz00_bglt BgL_nodez00_4037;

								{	/* Cfa/arithmetic.scm 277 */
									long BgL_arg1825z00_4038;

									{	/* Cfa/arithmetic.scm 277 */
										obj_t BgL_arg1826z00_4039;

										{	/* Cfa/arithmetic.scm 277 */
											obj_t BgL_arg1827z00_4040;

											{	/* Cfa/arithmetic.scm 277 */
												long BgL_arg1759z00_4041;

												{	/* Cfa/arithmetic.scm 277 */
													long BgL_arg1760z00_4042;

													{	/* Cfa/arithmetic.scm 277 */
														long BgL_res2118z00_4043;

														BgL_res2118z00_4043 =
															BGL_OBJECT_CLASS_NUM(
															((BgL_objectz00_bglt)
																((BgL_appz00_bglt) BgL_nodez00_3905)));
														BgL_arg1760z00_4042 = BgL_res2118z00_4043;
													}
													BgL_arg1759z00_4041 =
														(BgL_arg1760z00_4042 - OBJECT_TYPE);
												}
												BgL_arg1827z00_4040 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													BgL_arg1759z00_4041);
											}
											BgL_arg1826z00_4039 =
												BGl_classzd2superzd2zz__objectz00(BgL_arg1827z00_4040);
										}
										{	/* Cfa/arithmetic.scm 277 */
											long BgL_res2120z00_4044;

											{	/* Cfa/arithmetic.scm 277 */
												obj_t BgL_tmpz00_4523;

												BgL_tmpz00_4523 = ((obj_t) BgL_arg1826z00_4039);
												BgL_res2120z00_4044 = BGL_CLASS_INDEX(BgL_tmpz00_4523);
											}
											BgL_arg1825z00_4038 = BgL_res2120z00_4044;
									}}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3905)),
										BgL_arg1825z00_4038);
								}
								{	/* Cfa/arithmetic.scm 277 */
									BgL_objectz00_bglt BgL_tmpz00_4529;

									BgL_tmpz00_4529 =
										((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3905));
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4529, BFALSE);
								}
								BgL_nodez00_4037 = ((BgL_appz00_bglt) BgL_nodez00_3905);
								{	/* Cfa/arithmetic.scm 277 */

									{	/* Cfa/arithmetic.scm 278 */
										BgL_arithmeticzd2appzd2_bglt BgL_wide1182z00_4045;

										BgL_wide1182z00_4045 =
											((BgL_arithmeticzd2appzd2_bglt)
											BOBJECT(GC_MALLOC(sizeof(struct
														BgL_arithmeticzd2appzd2_bgl))));
										{	/* Cfa/arithmetic.scm 278 */
											obj_t BgL_auxz00_4539;
											BgL_objectz00_bglt BgL_tmpz00_4535;

											BgL_auxz00_4539 = ((obj_t) BgL_wide1182z00_4045);
											BgL_tmpz00_4535 =
												((BgL_objectz00_bglt)
												((BgL_appz00_bglt)
													((BgL_appz00_bglt) BgL_nodez00_4037)));
											BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4535, BgL_auxz00_4539);
										}
										{	/* Cfa/arithmetic.scm 278 */
											long BgL_arg1819z00_4046;

											{	/* Cfa/arithmetic.scm 278 */
												long BgL_res2121z00_4047;

												BgL_res2121z00_4047 =
													BGL_CLASS_INDEX
													(BGl_arithmeticzd2appzd2zzcfa_info2z00);
												BgL_arg1819z00_4046 = BgL_res2121z00_4047;
											}
											BGL_OBJECT_CLASS_NUM_SET(
												((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_4037))),
												BgL_arg1819z00_4046);
										}
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_4037)));
									}
									{
										BgL_approxz00_bglt BgL_auxz00_4558;
										BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4550;

										{	/* Cfa/arithmetic.scm 280 */
											bool_t BgL_testz00_4559;

											{	/* Cfa/arithmetic.scm 280 */
												BgL_typez00_bglt BgL_arg1823z00_4048;

												BgL_arg1823z00_4048 =
													(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
													BgL_typez00);
												BgL_testz00_4559 =
													(((obj_t) BgL_arg1823z00_4048) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_testz00_4559)
												{	/* Cfa/arithmetic.scm 280 */
													BgL_auxz00_4558 =
														BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
												}
											else
												{	/* Cfa/arithmetic.scm 282 */
													BgL_typez00_bglt BgL_arg1822z00_4049;

													BgL_arg1822z00_4049 =
														(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
														BgL_typez00);
													BgL_auxz00_4558 =
														BGl_makezd2typezd2approxz00zzcfa_approxz00
														(BgL_arg1822z00_4049);
												}
										}
										{
											obj_t BgL_auxz00_4551;

											{	/* Cfa/arithmetic.scm 280 */
												BgL_objectz00_bglt BgL_tmpz00_4552;

												BgL_tmpz00_4552 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_4037)));
												BgL_auxz00_4551 = BGL_OBJECT_WIDENING(BgL_tmpz00_4552);
											}
											BgL_auxz00_4550 =
												((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4551);
										}
										((((BgL_arithmeticzd2appzd2_bglt)
													COBJECT(BgL_auxz00_4550))->BgL_approxz00) =
											((BgL_approxz00_bglt) BgL_auxz00_4558), BUNSPEC);
									}
									{
										BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4567;

										{
											obj_t BgL_auxz00_4568;

											{	/* Cfa/arithmetic.scm 279 */
												BgL_objectz00_bglt BgL_tmpz00_4569;

												BgL_tmpz00_4569 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_4037)));
												BgL_auxz00_4568 = BGL_OBJECT_WIDENING(BgL_tmpz00_4569);
											}
											BgL_auxz00_4567 =
												((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4568);
										}
										((((BgL_arithmeticzd2appzd2_bglt)
													COBJECT(BgL_auxz00_4567))->BgL_speczd2typeszd2) =
											((obj_t) BgL_speczd2typeszd2_4036), BUNSPEC);
									}
									return
										((obj_t)
										((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_4037)));
								}
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* unspecified-type~0 */
	obj_t BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00(obj_t BgL_lz00_3077)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 253 */
			if (BGl_isazf3zf3zz__objectz00(BgL_lz00_3077, BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 247 */
					return BGl_za2_za2z00zztype_cachez00;
				}
			else
				{	/* Cfa/arithmetic.scm 247 */
					if (BGl_isazf3zf3zz__objectz00(BgL_lz00_3077,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 249 */
							{	/* Cfa/arithmetic.scm 250 */
								BgL_typez00_bglt BgL_vz00_3800;

								BgL_vz00_3800 =
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
								((((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_lz00_3077))))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_vz00_3800), BUNSPEC);
							}
							return BgL_lz00_3077;
						}
					else
						{	/* Cfa/arithmetic.scm 249 */
							return BgL_lz00_3077;
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-app1579 */
	obj_t BGl_z62cleanupzd2nodez12zd2app1579z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3906, obj_t BgL_nodez00_3907)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 231 */
			{	/* Cfa/arithmetic.scm 232 */
				bool_t BgL_tmpz00_4587;

				{	/* Cfa/arithmetic.scm 233 */
					BgL_varz00_bglt BgL_arg1792z00_4051;

					BgL_arg1792z00_4051 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3907)))->BgL_funz00);
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						((BgL_nodez00_bglt) BgL_arg1792z00_4051));
				}
				{	/* Cfa/arithmetic.scm 234 */
					obj_t BgL_g1531z00_4052;

					BgL_g1531z00_4052 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3907)))->BgL_argsz00);
					{
						obj_t BgL_l1529z00_4054;

						BgL_l1529z00_4054 = BgL_g1531z00_4052;
					BgL_zc3anonymousza31793ze3z83_4053:
						if (PAIRP(BgL_l1529z00_4054))
							{	/* Cfa/arithmetic.scm 234 */
								{	/* Cfa/arithmetic.scm 234 */
									obj_t BgL_arg1795z00_4055;

									BgL_arg1795z00_4055 = CAR(BgL_l1529z00_4054);
									BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
										((BgL_nodez00_bglt) BgL_arg1795z00_4055));
								}
								{
									obj_t BgL_l1529z00_4599;

									BgL_l1529z00_4599 = CDR(BgL_l1529z00_4054);
									BgL_l1529z00_4054 = BgL_l1529z00_4599;
									goto BgL_zc3anonymousza31793ze3z83_4053;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 234 */
								BgL_tmpz00_4587 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4587);
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-funcal1577 */
	obj_t BGl_z62cleanupzd2nodez12zd2funcal1577z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3908, obj_t BgL_nodez00_3909)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 223 */
			{	/* Cfa/arithmetic.scm 224 */
				bool_t BgL_tmpz00_4602;

				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_3909)))->BgL_funz00));
				{	/* Cfa/arithmetic.scm 226 */
					obj_t BgL_g1528z00_4057;

					BgL_g1528z00_4057 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_3909)))->BgL_argsz00);
					{
						obj_t BgL_l1526z00_4059;

						BgL_l1526z00_4059 = BgL_g1528z00_4057;
					BgL_zc3anonymousza31786ze3z83_4058:
						if (PAIRP(BgL_l1526z00_4059))
							{	/* Cfa/arithmetic.scm 226 */
								{	/* Cfa/arithmetic.scm 226 */
									obj_t BgL_arg1788z00_4060;

									BgL_arg1788z00_4060 = CAR(BgL_l1526z00_4059);
									BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
										((BgL_nodez00_bglt) BgL_arg1788z00_4060));
								}
								{
									obj_t BgL_l1526z00_4613;

									BgL_l1526z00_4613 = CDR(BgL_l1526z00_4059);
									BgL_l1526z00_4059 = BgL_l1526z00_4613;
									goto BgL_zc3anonymousza31786ze3z83_4058;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 226 */
								BgL_tmpz00_4602 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4602);
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-app-ly1575 */
	obj_t BGl_z62cleanupzd2nodez12zd2appzd2ly1575za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3910, obj_t BgL_nodez00_3911)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 215 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_3911)))->BgL_funz00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_3911)))->BgL_argz00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-box-se1573 */
	obj_t BGl_z62cleanupzd2nodez12zd2boxzd2se1573za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3912, obj_t BgL_nodez00_3913)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 207 */
			{	/* Cfa/arithmetic.scm 209 */
				BgL_varz00_bglt BgL_arg1781z00_4063;

				BgL_arg1781z00_4063 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3913)))->BgL_varz00);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					((BgL_nodez00_bglt) BgL_arg1781z00_4063));
			}
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3913)))->BgL_valuez00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-box-re1571 */
	obj_t BGl_z62cleanupzd2nodez12zd2boxzd2re1571za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3914, obj_t BgL_nodez00_3915)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 200 */
			{	/* Cfa/arithmetic.scm 202 */
				BgL_varz00_bglt BgL_arg1780z00_4065;

				BgL_arg1780z00_4065 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_3915)))->BgL_varz00);
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					((BgL_nodez00_bglt) BgL_arg1780z00_4065));
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-make-b1569 */
	obj_t BGl_z62cleanupzd2nodez12zd2makezd2b1569za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3916, obj_t BgL_nodez00_3917)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 193 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_3917)))->BgL_valuez00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-jump-e1567 */
	obj_t BGl_z62cleanupzd2nodez12zd2jumpzd2e1567za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3918, obj_t BgL_nodez00_3919)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 185 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3919)))->BgL_exitz00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3919)))->BgL_valuez00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-set-ex1565 */
	obj_t BGl_z62cleanupzd2nodez12zd2setzd2ex1565za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3920, obj_t BgL_nodez00_3921)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 177 */
			{	/* Cfa/arithmetic.scm 179 */
				BgL_varz00_bglt BgL_arg1775z00_4069;

				BgL_arg1775z00_4069 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3921)))->BgL_varz00);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					((BgL_nodez00_bglt) BgL_arg1775z00_4069));
			}
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3921)))->BgL_bodyz00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-let-va1563 */
	obj_t BGl_z62cleanupzd2nodez12zd2letzd2va1563za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3922, obj_t BgL_nodez00_3923)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 167 */
			{	/* Cfa/arithmetic.scm 169 */
				obj_t BgL_g1525z00_4071;

				BgL_g1525z00_4071 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_3923)))->BgL_bindingsz00);
				{
					obj_t BgL_l1523z00_4073;

					BgL_l1523z00_4073 = BgL_g1525z00_4071;
				BgL_zc3anonymousza31763ze3z83_4072:
					if (PAIRP(BgL_l1523z00_4073))
						{	/* Cfa/arithmetic.scm 169 */
							{	/* Cfa/arithmetic.scm 169 */
								obj_t BgL_bz00_4074;

								BgL_bz00_4074 = CAR(BgL_l1523z00_4073);
								{	/* Cfa/arithmetic.scm 169 */
									obj_t BgL_arg1765z00_4075;

									BgL_arg1765z00_4075 = CDR(((obj_t) BgL_bz00_4074));
									BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
										((BgL_nodez00_bglt) BgL_arg1765z00_4075));
								}
							}
							{
								obj_t BgL_l1523z00_4658;

								BgL_l1523z00_4658 = CDR(BgL_l1523z00_4073);
								BgL_l1523z00_4073 = BgL_l1523z00_4658;
								goto BgL_zc3anonymousza31763ze3z83_4072;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 169 */
							((bool_t) 1);
						}
				}
			}
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_3923)))->BgL_bodyz00));
			{	/* Cfa/arithmetic.scm 171 */
				bool_t BgL_testz00_4663;

				{	/* Cfa/arithmetic.scm 171 */
					BgL_typez00_bglt BgL_arg1773z00_4076;

					BgL_arg1773z00_4076 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2varzd2_bglt) BgL_nodez00_3923))))->BgL_typez00);
					BgL_testz00_4663 =
						(((obj_t) BgL_arg1773z00_4076) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_testz00_4663)
					{	/* Cfa/arithmetic.scm 171 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_letzd2varzd2_bglt) BgL_nodez00_3923))))->
								BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT((((BgL_letzd2varzd2_bglt)
													COBJECT(((BgL_letzd2varzd2_bglt) BgL_nodez00_3923)))->
												BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Cfa/arithmetic.scm 171 */
						return BFALSE;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-let-fu1561 */
	obj_t BGl_z62cleanupzd2nodez12zd2letzd2fu1561za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3924, obj_t BgL_nodez00_3925)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 157 */
			{	/* Cfa/arithmetic.scm 159 */
				obj_t BgL_g1522z00_4078;

				BgL_g1522z00_4078 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3925)))->BgL_localsz00);
				{
					obj_t BgL_l1520z00_4080;

					BgL_l1520z00_4080 = BgL_g1522z00_4078;
				BgL_zc3anonymousza31729ze3z83_4079:
					if (PAIRP(BgL_l1520z00_4080))
						{	/* Cfa/arithmetic.scm 159 */
							{	/* Cfa/arithmetic.scm 159 */
								obj_t BgL_arg1738z00_4081;

								BgL_arg1738z00_4081 = CAR(BgL_l1520z00_4080);
								{	/* Cfa/arithmetic.scm 90 */
									BgL_valuez00_bglt BgL_funz00_4082;

									BgL_funz00_4082 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt) BgL_arg1738z00_4081)))->
										BgL_valuez00);
									{	/* Cfa/arithmetic.scm 90 */
										obj_t BgL_bodyz00_4083;

										BgL_bodyz00_4083 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_funz00_4082)))->BgL_bodyz00);
										{	/* Cfa/arithmetic.scm 91 */

											BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
												((BgL_nodez00_bglt) BgL_bodyz00_4083));
										}
									}
								}
							}
							{
								obj_t BgL_l1520z00_4686;

								BgL_l1520z00_4686 = CDR(BgL_l1520z00_4080);
								BgL_l1520z00_4080 = BgL_l1520z00_4686;
								goto BgL_zc3anonymousza31729ze3z83_4079;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 159 */
							((bool_t) 1);
						}
				}
			}
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3925)))->BgL_bodyz00));
			{	/* Cfa/arithmetic.scm 161 */
				bool_t BgL_testz00_4691;

				{	/* Cfa/arithmetic.scm 161 */
					BgL_typez00_bglt BgL_arg1762z00_4084;

					BgL_arg1762z00_4084 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2funzd2_bglt) BgL_nodez00_3925))))->BgL_typez00);
					BgL_testz00_4691 =
						(((obj_t) BgL_arg1762z00_4084) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_testz00_4691)
					{	/* Cfa/arithmetic.scm 161 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_letzd2funzd2_bglt) BgL_nodez00_3925))))->
								BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT((((BgL_letzd2funzd2_bglt)
													COBJECT(((BgL_letzd2funzd2_bglt) BgL_nodez00_3925)))->
												BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Cfa/arithmetic.scm 161 */
						return BFALSE;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-switch1559 */
	obj_t BGl_z62cleanupzd2nodez12zd2switch1559z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3926, obj_t BgL_nodez00_3927)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 149 */
			{	/* Cfa/arithmetic.scm 150 */
				bool_t BgL_tmpz00_4703;

				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_3927)))->BgL_testz00));
				{	/* Cfa/arithmetic.scm 152 */
					obj_t BgL_g1519z00_4086;

					BgL_g1519z00_4086 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_3927)))->BgL_clausesz00);
					{
						obj_t BgL_l1517z00_4088;

						BgL_l1517z00_4088 = BgL_g1519z00_4086;
					BgL_zc3anonymousza31718ze3z83_4087:
						if (PAIRP(BgL_l1517z00_4088))
							{	/* Cfa/arithmetic.scm 152 */
								{	/* Cfa/arithmetic.scm 152 */
									obj_t BgL_clausez00_4089;

									BgL_clausez00_4089 = CAR(BgL_l1517z00_4088);
									{	/* Cfa/arithmetic.scm 152 */
										obj_t BgL_arg1725z00_4090;

										BgL_arg1725z00_4090 = CDR(((obj_t) BgL_clausez00_4089));
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1725z00_4090));
									}
								}
								{
									obj_t BgL_l1517z00_4716;

									BgL_l1517z00_4716 = CDR(BgL_l1517z00_4088);
									BgL_l1517z00_4088 = BgL_l1517z00_4716;
									goto BgL_zc3anonymousza31718ze3z83_4087;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 152 */
								BgL_tmpz00_4703 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4703);
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-fail1557 */
	obj_t BGl_z62cleanupzd2nodez12zd2fail1557z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3928, obj_t BgL_nodez00_3929)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 140 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3929)))->BgL_procz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3929)))->BgL_msgz00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3929)))->BgL_objz00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-condit1555 */
	obj_t BGl_z62cleanupzd2nodez12zd2condit1555z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3930, obj_t BgL_nodez00_3931)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 131 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3931)))->BgL_testz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3931)))->BgL_truez00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3931)))->BgL_falsez00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-setq1553 */
	obj_t BGl_z62cleanupzd2nodez12zd2setq1553z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3932, obj_t BgL_nodez00_3933)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 124 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_3933)))->BgL_valuez00));
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-sync1551 */
	obj_t BGl_z62cleanupzd2nodez12zd2sync1551z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3934, obj_t BgL_nodez00_3935)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 113 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3935)))->BgL_mutexz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3935)))->BgL_prelockz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3935)))->BgL_bodyz00));
			{	/* Cfa/arithmetic.scm 118 */
				bool_t BgL_testz00_4749;

				{	/* Cfa/arithmetic.scm 118 */
					BgL_typez00_bglt BgL_arg1703z00_4095;

					BgL_arg1703z00_4095 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_syncz00_bglt) BgL_nodez00_3935))))->BgL_typez00);
					BgL_testz00_4749 =
						(((obj_t) BgL_arg1703z00_4095) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_testz00_4749)
					{	/* Cfa/arithmetic.scm 118 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_syncz00_bglt) BgL_nodez00_3935))))->BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt)
															BgL_nodez00_3935)))->BgL_bodyz00)))->
									BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Cfa/arithmetic.scm 118 */
						return BFALSE;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &cleanup-node!-sequen1549 */
	obj_t BGl_z62cleanupzd2nodez12zd2sequen1549z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3936, obj_t BgL_nodez00_3937)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 103 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_3937)))->BgL_nodesz00)))
				{	/* Cfa/arithmetic.scm 105 */
					return BFALSE;
				}
			else
				{	/* Cfa/arithmetic.scm 105 */
					{	/* Cfa/arithmetic.scm 106 */
						obj_t BgL_g1516z00_4097;

						BgL_g1516z00_4097 =
							(((BgL_sequencez00_bglt) COBJECT(
									((BgL_sequencez00_bglt) BgL_nodez00_3937)))->BgL_nodesz00);
						{
							obj_t BgL_l1514z00_4099;

							BgL_l1514z00_4099 = BgL_g1516z00_4097;
						BgL_zc3anonymousza31676ze3z83_4098:
							if (PAIRP(BgL_l1514z00_4099))
								{	/* Cfa/arithmetic.scm 106 */
									{	/* Cfa/arithmetic.scm 106 */
										obj_t BgL_arg1680z00_4100;

										BgL_arg1680z00_4100 = CAR(BgL_l1514z00_4099);
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1680z00_4100));
									}
									{
										obj_t BgL_l1514z00_4772;

										BgL_l1514z00_4772 = CDR(BgL_l1514z00_4099);
										BgL_l1514z00_4099 = BgL_l1514z00_4772;
										goto BgL_zc3anonymousza31676ze3z83_4098;
									}
								}
							else
								{	/* Cfa/arithmetic.scm 106 */
									((bool_t) 1);
								}
						}
					}
					{	/* Cfa/arithmetic.scm 107 */
						bool_t BgL_testz00_4774;

						{	/* Cfa/arithmetic.scm 107 */
							BgL_typez00_bglt BgL_arg1689z00_4101;

							BgL_arg1689z00_4101 =
								(((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_sequencez00_bglt) BgL_nodez00_3937))))->
								BgL_typez00);
							BgL_testz00_4774 =
								(((obj_t) BgL_arg1689z00_4101) ==
								BGl_za2_za2z00zztype_cachez00);
						}
						if (BgL_testz00_4774)
							{	/* Cfa/arithmetic.scm 107 */
								return
									((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt)
													((BgL_sequencez00_bglt) BgL_nodez00_3937))))->
										BgL_typez00) =
									((BgL_typez00_bglt) (((BgL_nodez00_bglt)
												COBJECT(((BgL_nodez00_bglt)
														CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
																(((BgL_sequencez00_bglt)
																		COBJECT(((BgL_sequencez00_bglt)
																				BgL_nodez00_3937)))->
																	BgL_nodesz00))))))->BgL_typez00)), BUNSPEC);
							}
						else
							{	/* Cfa/arithmetic.scm 107 */
								return BFALSE;
							}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 3788352),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_loosez00(((long) 471177480),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_iteratez00(((long) 131412063),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 400853817),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_setupz00(((long) 168272122),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 468997863),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 324810626),
				BSTRING_TO_STRING(BGl_string2156z00zzcfa_arithmeticz00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
