/*===========================================================================*/
/*   (Sync/node.scm)                                                         */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Sync/node.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_mpopz00zzsync_nodez00 = BUNSPEC;
	extern obj_t BGl_za2synczd2profilingza2zd2zzengine_paramz00;
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzsync_nodez00();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_getexitdtopz00zzsync_nodez00 = BUNSPEC;
	static obj_t BGl_methodzd2initzd2zzsync_nodez00();
	static obj_t BGl_exitdzd2mutexzd2profilez00zzsync_nodez00 = BUNSPEC;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_mpushz00zzsync_nodez00 = BUNSPEC;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_synczd2ze3sequencez31zzsync_nodez00(BgL_syncz00_bglt);
	static obj_t BGl_mulockz00zzsync_nodez00 = BUNSPEC;
	static obj_t BGl_gczd2rootszd2initz00zzsync_nodez00();
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_failsafezd2synczf3z21zzsync_failsafez00(BgL_syncz00_bglt);
	static obj_t BGl_requirezd2initializa7ationz75zzsync_nodez00 = BUNSPEC;
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzsync_nodez00();
	static obj_t BGl_failsafezd2mutexzd2profilez00zzsync_nodez00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzsync_nodez00();
	static obj_t BGl_initzd2syncz12zc0zzsync_nodez00(obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_mlockz00zzsync_nodez00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_z62synczd2ze3sequencez53zzsync_nodez00(obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_mlockprelockz00zzsync_nodez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzsync_nodez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzsync_failsafez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_cplibz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	static obj_t BGl_cnstzd2initzd2zzsync_nodez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzsync_nodez00();
	extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t,
		BgL_typez00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzsync_nodez00();
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t
		BGl_setzd2variablezd2namez12z12zzbackend_cplibz00(BgL_variablez00_bglt);
	static obj_t __cnst[16];


	   
		 
		DEFINE_STRING(BGl_string1816z00zzsync_nodez00,
		BgL_bgl_string1816za700za7za7s1821za7, "sync_node", 9);
	      DEFINE_STRING(BGl_string1817z00zzsync_nodez00,
		BgL_bgl_string1817za700za7za7s1822za7,
		"top tmp value (@ exitd-pop-protect! __bexit) (@ exitd-push-protect! __bexit) $exitd-pop-protect! $exitd-push-protect! $failsafe-mutex-profile $exitd-mutex-profile c-saw c $mutex-unlock $mutex-lock-prelock $mutex-lock app $get-exitd-top ",
		236);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_synczd2ze3sequencezd2envze3zzsync_nodez00,
		BgL_bgl_za762syncza7d2za7e3seq1823za7,
		BGl_z62synczd2ze3sequencez53zzsync_nodez00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_mpopz00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_getexitdtopz00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_exitdzd2mutexzd2profilez00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_mpushz00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_mulockz00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_failsafezd2mutexzd2profilez00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_mlockz00zzsync_nodez00));
		     ADD_ROOT((void *) (&BGl_mlockprelockz00zzsync_nodez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzsync_nodez00(long
		BgL_checksumz00_2151, char *BgL_fromz00_2152)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzsync_nodez00))
				{
					BGl_requirezd2initializa7ationz75zzsync_nodez00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzsync_nodez00();
					BGl_libraryzd2moduleszd2initz00zzsync_nodez00();
					BGl_cnstzd2initzd2zzsync_nodez00();
					BGl_importedzd2moduleszd2initz00zzsync_nodez00();
					return BGl_toplevelzd2initzd2zzsync_nodez00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"sync_node");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "sync_node");
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			{	/* Sync/node.scm 18 */
				obj_t BgL_cportz00_2138;

				{	/* Sync/node.scm 18 */
					obj_t BgL_stringz00_2146;

					BgL_stringz00_2146 = BGl_string1817z00zzsync_nodez00;
					{	/* Sync/node.scm 18 */
						obj_t BgL_startz00_2147;

						BgL_startz00_2147 = BINT(((long) 0));
						{	/* Sync/node.scm 18 */
							obj_t BgL_endz00_2148;

							BgL_endz00_2148 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2146)));
							{	/* Sync/node.scm 18 */

								BgL_cportz00_2138 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2146, BgL_startz00_2147, BgL_endz00_2148);
				}}}}
				{
					long BgL_iz00_2139;

					BgL_iz00_2139 = ((long) 15);
				BgL_loopz00_2140:
					if ((BgL_iz00_2139 == ((long) -1)))
						{	/* Sync/node.scm 18 */
							return BUNSPEC;
						}
					else
						{	/* Sync/node.scm 18 */
							{	/* Sync/node.scm 18 */
								obj_t BgL_arg1819z00_2142;

								{	/* Sync/node.scm 18 */

									{	/* Sync/node.scm 18 */
										obj_t BgL_locationz00_2144;

										BgL_locationz00_2144 = BBOOL(((bool_t) 0));
										{	/* Sync/node.scm 18 */

											BgL_arg1819z00_2142 =
												BGl_readz00zz__readerz00(BgL_cportz00_2138,
												BgL_locationz00_2144);
										}
									}
								}
								{	/* Sync/node.scm 18 */
									int BgL_tmpz00_2177;

									BgL_tmpz00_2177 = (int) (BgL_iz00_2139);
									CNST_TABLE_SET(BgL_tmpz00_2177, BgL_arg1819z00_2142);
							}}
							{	/* Sync/node.scm 18 */
								int BgL_auxz00_2145;

								BgL_auxz00_2145 = (int) ((BgL_iz00_2139 - ((long) 1)));
								{
									long BgL_iz00_2182;

									BgL_iz00_2182 = (long) (BgL_auxz00_2145);
									BgL_iz00_2139 = BgL_iz00_2182;
									goto BgL_loopz00_2140;
								}
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			BGl_mlockz00zzsync_nodez00 = BFALSE;
			BGl_mlockprelockz00zzsync_nodez00 = BFALSE;
			BGl_mulockz00zzsync_nodez00 = BFALSE;
			BGl_mpushz00zzsync_nodez00 = BFALSE;
			BGl_mpopz00zzsync_nodez00 = BFALSE;
			BGl_getexitdtopz00zzsync_nodez00 = BFALSE;
			BGl_exitdzd2mutexzd2profilez00zzsync_nodez00 = BFALSE;
			return (BGl_failsafezd2mutexzd2profilez00zzsync_nodez00 =
				BFALSE, BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* init-sync! */
	obj_t BGl_initzd2syncz12zc0zzsync_nodez00(obj_t BgL_locz00_17)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 61 */
			if (CBOOL(BGl_mlockz00zzsync_nodez00))
				{	/* Sync/node.scm 62 */
					return BFALSE;
				}
			else
				{	/* Sync/node.scm 62 */
					BGl_getexitdtopz00zzsync_nodez00 =
						((obj_t)
						BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 0)), BNIL,
							BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					BGl_mlockz00zzsync_nodez00 =
						((obj_t) BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
									2)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					BGl_mlockprelockz00zzsync_nodez00 =
						((obj_t) BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
									3)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					BGl_mulockz00zzsync_nodez00 =
						((obj_t) BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
									4)), BNIL, BgL_locz00_17, CNST_TABLE_REF(((long) 1))));
					{	/* Sync/node.scm 67 */
						obj_t BgL_casezd2valuezd2_1666;

						{	/* Sync/node.scm 67 */
							obj_t BgL_arg1340z00_1672;

							BgL_arg1340z00_1672 = BGl_thezd2backendzd2zzbackend_backendz00();
							BgL_casezd2valuezd2_1666 =
								(((BgL_backendz00_bglt) COBJECT(
										((BgL_backendz00_bglt) BgL_arg1340z00_1672)))->
								BgL_languagez00);
						}
						{	/* Sync/node.scm 67 */
							bool_t BgL_testz00_2206;

							{	/* Sync/node.scm 67 */
								bool_t BgL__ortest_1108z00_1671;

								BgL__ortest_1108z00_1671 =
									(BgL_casezd2valuezd2_1666 == CNST_TABLE_REF(((long) 5)));
								if (BgL__ortest_1108z00_1671)
									{	/* Sync/node.scm 67 */
										BgL_testz00_2206 = BgL__ortest_1108z00_1671;
									}
								else
									{	/* Sync/node.scm 67 */
										BgL_testz00_2206 =
											(BgL_casezd2valuezd2_1666 == CNST_TABLE_REF(((long) 6)));
							}}
							if (BgL_testz00_2206)
								{	/* Sync/node.scm 67 */
									if (CBOOL(BGl_za2synczd2profilingza2zd2zzengine_paramz00))
										{	/* Sync/node.scm 69 */
											BGl_exitdzd2mutexzd2profilez00zzsync_nodez00 =
												((obj_t)
												BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF((
															(long) 7)), BNIL, BgL_locz00_17,
													CNST_TABLE_REF(((long) 1))));
											BGl_failsafezd2mutexzd2profilez00zzsync_nodez00 =
												((obj_t)
												BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF((
															(long) 8)), BNIL, BgL_locz00_17,
													CNST_TABLE_REF(((long) 1))));
											{	/* Sync/node.scm 74 */
												BgL_variablez00_bglt BgL_arg1334z00_1669;

												{	/* Sync/node.scm 74 */
													BgL_varz00_bglt BgL_oz00_2073;

													BgL_oz00_2073 =
														((BgL_varz00_bglt)
														BGl_exitdzd2mutexzd2profilez00zzsync_nodez00);
													BgL_arg1334z00_1669 =
														(((BgL_varz00_bglt) COBJECT(BgL_oz00_2073))->
														BgL_variablez00);
												}
												BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
													(BgL_arg1334z00_1669);
											}
											{	/* Sync/node.scm 75 */
												BgL_variablez00_bglt BgL_arg1338z00_1670;

												{	/* Sync/node.scm 75 */
													BgL_varz00_bglt BgL_oz00_2074;

													BgL_oz00_2074 =
														((BgL_varz00_bglt)
														BGl_failsafezd2mutexzd2profilez00zzsync_nodez00);
													BgL_arg1338z00_1670 =
														(((BgL_varz00_bglt) COBJECT(BgL_oz00_2074))->
														BgL_variablez00);
												}
												BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
													(BgL_arg1338z00_1670);
										}}
									else
										{	/* Sync/node.scm 69 */
											BFALSE;
										}
									BGl_mpushz00zzsync_nodez00 =
										((obj_t)
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
													9)), BNIL, BgL_locz00_17,
											CNST_TABLE_REF(((long) 1))));
									BGl_mpopz00zzsync_nodez00 =
										((obj_t)
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
													10)), BNIL, BgL_locz00_17,
											CNST_TABLE_REF(((long) 1))));
								}
							else
								{	/* Sync/node.scm 67 */
									BGl_mpushz00zzsync_nodez00 =
										((obj_t)
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
													11)), BNIL, BgL_locz00_17,
											CNST_TABLE_REF(((long) 1))));
									BGl_mpopz00zzsync_nodez00 =
										((obj_t)
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
													12)), BNIL, BgL_locz00_17,
											CNST_TABLE_REF(((long) 1))));
					}}}
					{	/* Sync/node.scm 81 */
						BgL_variablez00_bglt BgL_arg1341z00_1673;

						{	/* Sync/node.scm 81 */
							BgL_varz00_bglt BgL_oz00_2075;

							BgL_oz00_2075 =
								((BgL_varz00_bglt) BGl_getexitdtopz00zzsync_nodez00);
							BgL_arg1341z00_1673 =
								(((BgL_varz00_bglt) COBJECT(BgL_oz00_2075))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1341z00_1673);
					}
					{	/* Sync/node.scm 82 */
						BgL_variablez00_bglt BgL_arg1342z00_1674;

						{	/* Sync/node.scm 82 */
							BgL_varz00_bglt BgL_oz00_2076;

							BgL_oz00_2076 = ((BgL_varz00_bglt) BGl_mlockz00zzsync_nodez00);
							BgL_arg1342z00_1674 =
								(((BgL_varz00_bglt) COBJECT(BgL_oz00_2076))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1342z00_1674);
					}
					{	/* Sync/node.scm 83 */
						BgL_variablez00_bglt BgL_arg1343z00_1675;

						{	/* Sync/node.scm 83 */
							BgL_varz00_bglt BgL_oz00_2077;

							BgL_oz00_2077 =
								((BgL_varz00_bglt) BGl_mlockprelockz00zzsync_nodez00);
							BgL_arg1343z00_1675 =
								(((BgL_varz00_bglt) COBJECT(BgL_oz00_2077))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1343z00_1675);
					}
					{	/* Sync/node.scm 84 */
						BgL_variablez00_bglt BgL_arg1344z00_1676;

						{	/* Sync/node.scm 84 */
							BgL_varz00_bglt BgL_oz00_2078;

							BgL_oz00_2078 = ((BgL_varz00_bglt) BGl_mulockz00zzsync_nodez00);
							BgL_arg1344z00_1676 =
								(((BgL_varz00_bglt) COBJECT(BgL_oz00_2078))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1344z00_1676);
					}
					{	/* Sync/node.scm 85 */
						BgL_variablez00_bglt BgL_arg1345z00_1677;

						{	/* Sync/node.scm 85 */
							BgL_varz00_bglt BgL_oz00_2079;

							BgL_oz00_2079 = ((BgL_varz00_bglt) BGl_mpushz00zzsync_nodez00);
							BgL_arg1345z00_1677 =
								(((BgL_varz00_bglt) COBJECT(BgL_oz00_2079))->BgL_variablez00);
						}
						BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1345z00_1677);
					}
					{	/* Sync/node.scm 86 */
						BgL_variablez00_bglt BgL_arg1356z00_1678;

						{	/* Sync/node.scm 86 */
							BgL_varz00_bglt BgL_oz00_2080;

							BgL_oz00_2080 = ((BgL_varz00_bglt) BGl_mpopz00zzsync_nodez00);
							BgL_arg1356z00_1678 =
								(((BgL_varz00_bglt) COBJECT(BgL_oz00_2080))->BgL_variablez00);
						}
						return
							BGl_setzd2variablezd2namez12z12zzbackend_cplibz00
							(BgL_arg1356z00_1678);
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* sync->sequence */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_synczd2ze3sequencez31zzsync_nodez00(BgL_syncz00_bglt BgL_nodez00_18)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 111 */
			{
				BgL_syncz00_bglt BgL_nodez00_1754;
				BgL_syncz00_bglt BgL_nodez00_1708;
				BgL_letzd2varzd2_bglt BgL_nodez00_1699;
				obj_t BgL_locz00_1700;
				BgL_letzd2varzd2_bglt BgL_nodez00_1690;
				obj_t BgL_locz00_1691;

				{	/* Sync/node.scm 191 */
					obj_t BgL_arg1359z00_1685;

					BgL_arg1359z00_1685 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt) BgL_nodez00_18)))->BgL_locz00);
					BGl_initzd2syncz12zc0zzsync_nodez00(BgL_arg1359z00_1685);
				}
				if (CBOOL(BGl_failsafezd2synczf3z21zzsync_failsafez00(BgL_nodez00_18)))
					{
						BgL_sequencez00_bglt BgL_auxz00_2268;

						BgL_nodez00_1708 = BgL_nodez00_18;
						{	/* Sync/node.scm 130 */
							BgL_localz00_bglt BgL_tmpz00_1711;

							{	/* Sync/node.scm 130 */
								obj_t BgL_arg1542z00_1752;
								BgL_typez00_bglt BgL_arg1551z00_1753;

								BgL_arg1542z00_1752 =
									BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											14)));
								BgL_arg1551z00_1753 =
									(((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_nodez00_1708)))->BgL_typez00);
								BgL_tmpz00_1711 =
									BGl_makezd2localzd2svarz00zzast_localz00(BgL_arg1542z00_1752,
									BgL_arg1551z00_1753);
							}
							{	/* Sync/node.scm 130 */
								BgL_nodez00_bglt BgL_lockz00_1712;

								{	/* Sync/node.scm 131 */
									bool_t BgL_testz00_2274;

									{	/* Sync/node.scm 131 */
										BgL_nodez00_bglt BgL_arg1541z00_1751;

										BgL_arg1541z00_1751 =
											(((BgL_syncz00_bglt) COBJECT(BgL_nodez00_1708))->
											BgL_prelockz00);
										{	/* Sync/node.scm 131 */
											bool_t BgL_res1799z00_2085;

											BgL_res1799z00_2085 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_arg1541z00_1751),
												BGl_atomz00zzast_nodez00);
											BgL_testz00_2274 = BgL_res1799z00_2085;
									}}
									if (BgL_testz00_2274)
										{	/* Sync/node.scm 132 */
											obj_t BgL_arg1519z00_1741;
											obj_t BgL_arg1520z00_1742;

											{	/* Sync/node.scm 132 */
												obj_t BgL_arg1527z00_1743;

												{	/* Sync/node.scm 132 */
													BgL_nodez00_bglt BgL_arg1528z00_1744;

													BgL_arg1528z00_1744 =
														(((BgL_syncz00_bglt) COBJECT(BgL_nodez00_1708))->
														BgL_mutexz00);
													BgL_arg1527z00_1743 =
														MAKE_YOUNG_PAIR(((obj_t) BgL_arg1528z00_1744),
														BNIL);
												}
												BgL_arg1519z00_1741 =
													MAKE_YOUNG_PAIR(BGl_mlockz00zzsync_nodez00,
													BgL_arg1527z00_1743);
											}
											BgL_arg1520z00_1742 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_nodez00_1708)))->
												BgL_locz00);
											BgL_lockz00_1712 =
												BGl_applicationzd2ze3nodez31zzast_appz00
												(BgL_arg1519z00_1741, BNIL, BgL_arg1520z00_1742,
												CNST_TABLE_REF(((long) 13)));
										}
									else
										{	/* Sync/node.scm 133 */
											obj_t BgL_arg1531z00_1745;
											obj_t BgL_arg1532z00_1746;

											{	/* Sync/node.scm 133 */
												obj_t BgL_arg1536z00_1747;

												{	/* Sync/node.scm 133 */
													BgL_nodez00_bglt BgL_arg1537z00_1748;
													obj_t BgL_arg1539z00_1749;

													BgL_arg1537z00_1748 =
														(((BgL_syncz00_bglt) COBJECT(BgL_nodez00_1708))->
														BgL_mutexz00);
													{	/* Sync/node.scm 133 */
														BgL_nodez00_bglt BgL_arg1540z00_1750;

														BgL_arg1540z00_1750 =
															(((BgL_syncz00_bglt) COBJECT(BgL_nodez00_1708))->
															BgL_prelockz00);
														BgL_arg1539z00_1749 =
															MAKE_YOUNG_PAIR(((obj_t) BgL_arg1540z00_1750),
															BNIL);
													}
													BgL_arg1536z00_1747 =
														MAKE_YOUNG_PAIR(
														((obj_t) BgL_arg1537z00_1748), BgL_arg1539z00_1749);
												}
												BgL_arg1531z00_1745 =
													MAKE_YOUNG_PAIR(BGl_mlockprelockz00zzsync_nodez00,
													BgL_arg1536z00_1747);
											}
											BgL_arg1532z00_1746 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_nodez00_1708)))->
												BgL_locz00);
											BgL_lockz00_1712 =
												BGl_applicationzd2ze3nodez31zzast_appz00
												(BgL_arg1531z00_1745, BNIL, BgL_arg1532z00_1746,
												CNST_TABLE_REF(((long) 13)));
								}}
								{	/* Sync/node.scm 131 */
									BgL_nodez00_bglt BgL_unlockz00_1713;

									{	/* Sync/node.scm 134 */
										obj_t BgL_arg1501z00_1735;
										obj_t BgL_arg1506z00_1736;

										{	/* Sync/node.scm 134 */
											obj_t BgL_arg1507z00_1737;

											{	/* Sync/node.scm 134 */
												BgL_nodez00_bglt BgL_arg1511z00_1738;

												BgL_arg1511z00_1738 =
													(((BgL_syncz00_bglt) COBJECT(BgL_nodez00_1708))->
													BgL_mutexz00);
												BgL_arg1507z00_1737 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg1511z00_1738), BNIL);
											}
											BgL_arg1501z00_1735 =
												MAKE_YOUNG_PAIR(BGl_mulockz00zzsync_nodez00,
												BgL_arg1507z00_1737);
										}
										BgL_arg1506z00_1736 =
											(((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt) BgL_nodez00_1708)))->BgL_locz00);
										BgL_unlockz00_1713 =
											BGl_applicationzd2ze3nodez31zzast_appz00
											(BgL_arg1501z00_1735, BNIL, BgL_arg1506z00_1736,
											CNST_TABLE_REF(((long) 13)));
									}
									{	/* Sync/node.scm 134 */
										BgL_varz00_bglt BgL_vrefz00_1714;

										{	/* Sync/node.scm 135 */
											BgL_varz00_bglt BgL_new1111z00_1732;

											{	/* Sync/node.scm 136 */
												BgL_varz00_bglt BgL_new1110z00_1733;

												BgL_new1110z00_1733 =
													((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
																BgL_varz00_bgl))));
												{	/* Sync/node.scm 136 */
													long BgL_arg1488z00_1734;

													{	/* Sync/node.scm 136 */
														long BgL_res1800z00_2087;

														BgL_res1800z00_2087 =
															BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
														BgL_arg1488z00_1734 = BgL_res1800z00_2087;
													}
													BGL_OBJECT_CLASS_NUM_SET(
														((BgL_objectz00_bglt) BgL_new1110z00_1733),
														BgL_arg1488z00_1734);
												}
												BgL_new1111z00_1732 = BgL_new1110z00_1733;
											}
											((((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt) BgL_new1111z00_1732)))->
													BgL_locz00) =
												((obj_t) (((BgL_nodez00_bglt)
															COBJECT(((BgL_nodez00_bglt) BgL_nodez00_1708)))->
														BgL_locz00)), BUNSPEC);
											((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																BgL_new1111z00_1732)))->BgL_typez00) =
												((BgL_typez00_bglt) (((BgL_nodez00_bglt)
															COBJECT(((BgL_nodez00_bglt) BgL_nodez00_1708)))->
														BgL_typez00)), BUNSPEC);
											((((BgL_varz00_bglt) COBJECT(BgL_new1111z00_1732))->
													BgL_variablez00) =
												((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
														BgL_tmpz00_1711)), BUNSPEC);
											BgL_vrefz00_1714 = BgL_new1111z00_1732;
										}
										{	/* Sync/node.scm 135 */
											BgL_letzd2varzd2_bglt BgL_lbodyz00_1715;

											{	/* Sync/node.scm 139 */
												BgL_letzd2varzd2_bglt BgL_new1113z00_1721;

												{	/* Sync/node.scm 140 */
													BgL_letzd2varzd2_bglt BgL_new1112z00_1730;

													BgL_new1112z00_1730 =
														((BgL_letzd2varzd2_bglt)
														BOBJECT(GC_MALLOC(sizeof(struct
																	BgL_letzd2varzd2_bgl))));
													{	/* Sync/node.scm 140 */
														long BgL_arg1487z00_1731;

														{	/* Sync/node.scm 140 */
															long BgL_res1801z00_2091;

															BgL_res1801z00_2091 =
																BGL_CLASS_INDEX(BGl_letzd2varzd2zzast_nodez00);
															BgL_arg1487z00_1731 = BgL_res1801z00_2091;
														}
														BGL_OBJECT_CLASS_NUM_SET(
															((BgL_objectz00_bglt) BgL_new1112z00_1730),
															BgL_arg1487z00_1731);
													}
													{	/* Sync/node.scm 140 */
														BgL_objectz00_bglt BgL_tmpz00_2323;

														BgL_tmpz00_2323 =
															((BgL_objectz00_bglt) BgL_new1112z00_1730);
														BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2323, BFALSE);
													}
													BgL_new1113z00_1721 = BgL_new1112z00_1730;
												}
												((((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_new1113z00_1721)))->
														BgL_locz00) =
													((obj_t) (((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt)
																		BgL_nodez00_1708)))->BgL_locz00)), BUNSPEC);
												((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																	BgL_new1113z00_1721)))->BgL_typez00) =
													((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																COBJECT(((BgL_nodez00_bglt)
																		BgL_nodez00_1708)))->BgL_typez00)),
													BUNSPEC);
												((((BgL_nodezf2effectzf2_bglt)
															COBJECT(((BgL_nodezf2effectzf2_bglt)
																	BgL_new1113z00_1721)))->
														BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
												((((BgL_nodezf2effectzf2_bglt)
															COBJECT(((BgL_nodezf2effectzf2_bglt)
																	BgL_new1113z00_1721)))->BgL_keyz00) =
													((obj_t) BINT(((long) -1))), BUNSPEC);
												{
													obj_t BgL_auxz00_2339;

													{	/* Sync/node.scm 142 */
														obj_t BgL_arg1442z00_1722;

														{	/* Sync/node.scm 142 */
															BgL_nodez00_bglt BgL_arg1464z00_1724;

															BgL_arg1464z00_1724 =
																(((BgL_syncz00_bglt)
																	COBJECT(BgL_nodez00_1708))->BgL_bodyz00);
															BgL_arg1442z00_1722 =
																MAKE_YOUNG_PAIR(((obj_t) BgL_tmpz00_1711),
																((obj_t) BgL_arg1464z00_1724));
														}
														{	/* Sync/node.scm 142 */
															obj_t BgL_list1443z00_1723;

															BgL_list1443z00_1723 =
																MAKE_YOUNG_PAIR(BgL_arg1442z00_1722, BNIL);
															BgL_auxz00_2339 = BgL_list1443z00_1723;
													}}
													((((BgL_letzd2varzd2_bglt)
																COBJECT(BgL_new1113z00_1721))->
															BgL_bindingsz00) =
														((obj_t) BgL_auxz00_2339), BUNSPEC);
												}
												{
													BgL_nodez00_bglt BgL_auxz00_2346;

													{	/* Sync/node.scm 143 */
														BgL_sequencez00_bglt BgL_new1115z00_1725;

														{	/* Sync/node.scm 144 */
															BgL_sequencez00_bglt BgL_new1114z00_1728;

															BgL_new1114z00_1728 =
																((BgL_sequencez00_bglt)
																BOBJECT(GC_MALLOC(sizeof(struct
																			BgL_sequencez00_bgl))));
															{	/* Sync/node.scm 144 */
																long BgL_arg1486z00_1729;

																{	/* Sync/node.scm 144 */
																	long BgL_res1803z00_2096;

																	{	/* Sync/node.scm 144 */
																		obj_t BgL_classz00_2095;

																		BgL_classz00_2095 =
																			BGl_sequencez00zzast_nodez00;
																		BgL_res1803z00_2096 =
																			BGL_CLASS_INDEX(BgL_classz00_2095);
																	}
																	BgL_arg1486z00_1729 = BgL_res1803z00_2096;
																}
																BGL_OBJECT_CLASS_NUM_SET(
																	((BgL_objectz00_bglt) BgL_new1114z00_1728),
																	BgL_arg1486z00_1729);
															}
															{	/* Sync/node.scm 144 */
																BgL_objectz00_bglt BgL_tmpz00_2351;

																BgL_tmpz00_2351 =
																	((BgL_objectz00_bglt) BgL_new1114z00_1728);
																BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2351,
																	BFALSE);
															}
															BgL_new1115z00_1725 = BgL_new1114z00_1728;
														}
														((((BgL_nodez00_bglt) COBJECT(
																		((BgL_nodez00_bglt) BgL_new1115z00_1725)))->
																BgL_locz00) =
															((obj_t) (((BgL_nodez00_bglt)
																		COBJECT(((BgL_nodez00_bglt)
																				BgL_nodez00_1708)))->BgL_locz00)),
															BUNSPEC);
														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																			BgL_new1115z00_1725)))->BgL_typez00) =
															((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																		COBJECT(((BgL_nodez00_bglt)
																				BgL_nodez00_1708)))->BgL_typez00)),
															BUNSPEC);
														((((BgL_nodezf2effectzf2_bglt)
																	COBJECT(((BgL_nodezf2effectzf2_bglt)
																			BgL_new1115z00_1725)))->
																BgL_sidezd2effectzd2) =
															((obj_t) BUNSPEC), BUNSPEC);
														((((BgL_nodezf2effectzf2_bglt)
																	COBJECT(((BgL_nodezf2effectzf2_bglt)
																			BgL_new1115z00_1725)))->BgL_keyz00) =
															((obj_t) BINT(((long) -1))), BUNSPEC);
														{
															obj_t BgL_auxz00_2367;

															{	/* Sync/node.scm 146 */
																obj_t BgL_list1465z00_1726;

																{	/* Sync/node.scm 146 */
																	obj_t BgL_arg1469z00_1727;

																	BgL_arg1469z00_1727 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_vrefz00_1714), BNIL);
																	BgL_list1465z00_1726 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_unlockz00_1713),
																		BgL_arg1469z00_1727);
																}
																BgL_auxz00_2367 = BgL_list1465z00_1726;
															}
															((((BgL_sequencez00_bglt)
																		COBJECT(BgL_new1115z00_1725))->
																	BgL_nodesz00) =
																((obj_t) BgL_auxz00_2367), BUNSPEC);
														}
														((((BgL_sequencez00_bglt)
																	COBJECT(BgL_new1115z00_1725))->
																BgL_unsafez00) =
															((bool_t) ((bool_t) 0)), BUNSPEC);
														((((BgL_sequencez00_bglt)
																	COBJECT(BgL_new1115z00_1725))->BgL_metaz00) =
															((obj_t) BNIL), BUNSPEC);
														BgL_auxz00_2346 =
															((BgL_nodez00_bglt) BgL_new1115z00_1725);
													}
													((((BgL_letzd2varzd2_bglt)
																COBJECT(BgL_new1113z00_1721))->BgL_bodyz00) =
														((BgL_nodez00_bglt) BgL_auxz00_2346), BUNSPEC);
												}
												((((BgL_letzd2varzd2_bglt)
															COBJECT(BgL_new1113z00_1721))->
														BgL_removablezf3zf3) =
													((bool_t) ((bool_t) 1)), BUNSPEC);
												BgL_lbodyz00_1715 = BgL_new1113z00_1721;
											}
											{	/* Sync/node.scm 139 */

												{	/* Sync/node.scm 147 */
													BgL_sequencez00_bglt BgL_new1118z00_1716;

													{	/* Sync/node.scm 148 */
														BgL_sequencez00_bglt BgL_new1116z00_1719;

														BgL_new1116z00_1719 =
															((BgL_sequencez00_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_sequencez00_bgl))));
														{	/* Sync/node.scm 148 */
															long BgL_arg1441z00_1720;

															{	/* Sync/node.scm 148 */
																long BgL_res1805z00_2101;

																BgL_res1805z00_2101 =
																	BGL_CLASS_INDEX(BGl_sequencez00zzast_nodez00);
																BgL_arg1441z00_1720 = BgL_res1805z00_2101;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1116z00_1719),
																BgL_arg1441z00_1720);
														}
														{	/* Sync/node.scm 148 */
															BgL_objectz00_bglt BgL_tmpz00_2382;

															BgL_tmpz00_2382 =
																((BgL_objectz00_bglt) BgL_new1116z00_1719);
															BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2382, BFALSE);
														}
														BgL_new1118z00_1716 = BgL_new1116z00_1719;
													}
													((((BgL_nodez00_bglt) COBJECT(
																	((BgL_nodez00_bglt) BgL_new1118z00_1716)))->
															BgL_locz00) =
														((obj_t) (((BgL_nodez00_bglt)
																	COBJECT(((BgL_nodez00_bglt)
																			BgL_nodez00_1708)))->BgL_locz00)),
														BUNSPEC);
													((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																		BgL_new1118z00_1716)))->BgL_typez00) =
														((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																	COBJECT(((BgL_nodez00_bglt)
																			BgL_nodez00_1708)))->BgL_typez00)),
														BUNSPEC);
													((((BgL_nodezf2effectzf2_bglt)
																COBJECT(((BgL_nodezf2effectzf2_bglt)
																		BgL_new1118z00_1716)))->
															BgL_sidezd2effectzd2) =
														((obj_t) BUNSPEC), BUNSPEC);
													((((BgL_nodezf2effectzf2_bglt)
																COBJECT(((BgL_nodezf2effectzf2_bglt)
																		BgL_new1118z00_1716)))->BgL_keyz00) =
														((obj_t) BINT(((long) -1))), BUNSPEC);
													{
														obj_t BgL_auxz00_2398;

														{	/* Sync/node.scm 150 */
															obj_t BgL_arg1428z00_1717;

															{	/* Sync/node.scm 150 */
																obj_t BgL_arg1429z00_1718;

																BgL_arg1429z00_1718 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt) BgL_nodez00_1708)))->
																	BgL_locz00);
																BgL_nodez00_1699 = BgL_lbodyz00_1715;
																BgL_locz00_1700 = BgL_arg1429z00_1718;
																if (CBOOL
																	(BGl_failsafezd2mutexzd2profilez00zzsync_nodez00))
																	{	/* Sync/node.scm 123 */
																		BgL_nodez00_bglt BgL_arg1400z00_1703;

																		{	/* Sync/node.scm 123 */
																			obj_t BgL_arg1421z00_1706;

																			BgL_arg1421z00_1706 =
																				MAKE_YOUNG_PAIR
																				(BGl_failsafezd2mutexzd2profilez00zzsync_nodez00,
																				BNIL);
																			BgL_arg1400z00_1703 =
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_arg1421z00_1706, BNIL,
																				BgL_locz00_1700,
																				CNST_TABLE_REF(((long) 13)));
																		}
																		{	/* Sync/node.scm 123 */
																			obj_t BgL_list1401z00_1704;

																			{	/* Sync/node.scm 123 */
																				obj_t BgL_arg1418z00_1705;

																				BgL_arg1418z00_1705 =
																					MAKE_YOUNG_PAIR(
																					((obj_t) BgL_nodez00_1699), BNIL);
																				BgL_list1401z00_1704 =
																					MAKE_YOUNG_PAIR(
																					((obj_t) BgL_arg1400z00_1703),
																					BgL_arg1418z00_1705);
																			}
																			BgL_arg1428z00_1717 =
																				BgL_list1401z00_1704;
																	}}
																else
																	{	/* Sync/node.scm 124 */
																		obj_t BgL_list1422z00_1707;

																		BgL_list1422z00_1707 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_nodez00_1699), BNIL);
																		BgL_arg1428z00_1717 = BgL_list1422z00_1707;
																	}
															}
															BgL_auxz00_2398 =
																MAKE_YOUNG_PAIR(
																((obj_t) BgL_lockz00_1712),
																BgL_arg1428z00_1717);
														}
														((((BgL_sequencez00_bglt)
																	COBJECT(BgL_new1118z00_1716))->BgL_nodesz00) =
															((obj_t) BgL_auxz00_2398), BUNSPEC);
													}
													((((BgL_sequencez00_bglt)
																COBJECT(BgL_new1118z00_1716))->BgL_unsafez00) =
														((bool_t) ((bool_t) 0)), BUNSPEC);
													((((BgL_sequencez00_bglt)
																COBJECT(BgL_new1118z00_1716))->BgL_metaz00) =
														((obj_t) BNIL), BUNSPEC);
													BgL_auxz00_2268 = BgL_new1118z00_1716;
												}
											}
										}
									}
								}
							}
						}
						return ((BgL_nodez00_bglt) BgL_auxz00_2268);
					}
				else
					{
						BgL_letzd2varzd2_bglt BgL_auxz00_2418;

						BgL_nodez00_1754 = BgL_nodez00_18;
						{	/* Sync/node.scm 156 */
							BgL_localz00_bglt BgL_tmpz00_1757;

							{	/* Sync/node.scm 156 */
								obj_t BgL_arg1672z00_1824;
								BgL_typez00_bglt BgL_arg1673z00_1825;

								BgL_arg1672z00_1824 =
									BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											14)));
								BgL_arg1673z00_1825 =
									(((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_nodez00_1754)))->BgL_typez00);
								BgL_tmpz00_1757 =
									BGl_makezd2localzd2svarz00zzast_localz00(BgL_arg1672z00_1824,
									BgL_arg1673z00_1825);
							}
							{	/* Sync/node.scm 156 */
								BgL_localz00_bglt BgL_topz00_1758;

								{	/* Sync/node.scm 157 */
									obj_t BgL_arg1670z00_1823;

									BgL_arg1670z00_1823 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												15)));
									BgL_topz00_1758 =
										BGl_makezd2localzd2svarz00zzast_localz00
										(BgL_arg1670z00_1823,
										((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00));
								}
								{	/* Sync/node.scm 157 */
									BgL_varz00_bglt BgL_toprefz00_1759;

									{	/* Sync/node.scm 158 */
										BgL_varz00_bglt BgL_new1121z00_1820;

										{	/* Sync/node.scm 159 */
											BgL_varz00_bglt BgL_new1120z00_1821;

											BgL_new1120z00_1821 =
												((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
															BgL_varz00_bgl))));
											{	/* Sync/node.scm 159 */
												long BgL_arg1666z00_1822;

												{	/* Sync/node.scm 159 */
													long BgL_res1806z00_2105;

													BgL_res1806z00_2105 =
														BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
													BgL_arg1666z00_1822 = BgL_res1806z00_2105;
												}
												BGL_OBJECT_CLASS_NUM_SET(
													((BgL_objectz00_bglt) BgL_new1120z00_1821),
													BgL_arg1666z00_1822);
											}
											BgL_new1121z00_1820 = BgL_new1120z00_1821;
										}
										((((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_new1121z00_1820)))->
												BgL_locz00) =
											((obj_t) (((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																BgL_nodez00_1754)))->BgL_locz00)), BUNSPEC);
										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
															BgL_new1121z00_1820)))->BgL_typez00) =
											((BgL_typez00_bglt) ((BgL_typez00_bglt)
													BGl_za2objza2z00zztype_cachez00)), BUNSPEC);
										((((BgL_varz00_bglt) COBJECT(BgL_new1121z00_1820))->
												BgL_variablez00) =
											((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
													BgL_topz00_1758)), BUNSPEC);
										BgL_toprefz00_1759 = BgL_new1121z00_1820;
									}
									{	/* Sync/node.scm 158 */
										BgL_nodez00_bglt BgL_gettopz00_1760;

										{	/* Sync/node.scm 162 */
											obj_t BgL_arg1659z00_1818;
											obj_t BgL_arg1664z00_1819;

											BgL_arg1659z00_1818 =
												MAKE_YOUNG_PAIR(BGl_getexitdtopz00zzsync_nodez00, BNIL);
											BgL_arg1664z00_1819 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_nodez00_1754)))->
												BgL_locz00);
											BgL_gettopz00_1760 =
												BGl_applicationzd2ze3nodez31zzast_appz00
												(BgL_arg1659z00_1818, BNIL, BgL_arg1664z00_1819,
												CNST_TABLE_REF(((long) 13)));
										}
										{	/* Sync/node.scm 162 */
											BgL_nodez00_bglt BgL_lockz00_1761;

											{	/* Sync/node.scm 163 */
												bool_t BgL_testz00_2446;

												{	/* Sync/node.scm 163 */
													BgL_nodez00_bglt BgL_arg1656z00_1817;

													BgL_arg1656z00_1817 =
														(((BgL_syncz00_bglt) COBJECT(BgL_nodez00_1754))->
														BgL_prelockz00);
													{	/* Sync/node.scm 163 */
														bool_t BgL_res1807z00_2108;

														BgL_res1807z00_2108 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_arg1656z00_1817),
															BGl_atomz00zzast_nodez00);
														BgL_testz00_2446 = BgL_res1807z00_2108;
												}}
												if (BgL_testz00_2446)
													{	/* Sync/node.scm 164 */
														obj_t BgL_arg1637z00_1807;
														obj_t BgL_arg1638z00_1808;

														{	/* Sync/node.scm 164 */
															obj_t BgL_arg1640z00_1809;

															{	/* Sync/node.scm 164 */
																BgL_nodez00_bglt BgL_arg1641z00_1810;

																BgL_arg1641z00_1810 =
																	(((BgL_syncz00_bglt)
																		COBJECT(BgL_nodez00_1754))->BgL_mutexz00);
																BgL_arg1640z00_1809 =
																	MAKE_YOUNG_PAIR(((obj_t) BgL_arg1641z00_1810),
																	BNIL);
															}
															BgL_arg1637z00_1807 =
																MAKE_YOUNG_PAIR(BGl_mlockz00zzsync_nodez00,
																BgL_arg1640z00_1809);
														}
														BgL_arg1638z00_1808 =
															(((BgL_nodez00_bglt) COBJECT(
																	((BgL_nodez00_bglt) BgL_nodez00_1754)))->
															BgL_locz00);
														BgL_lockz00_1761 =
															BGl_applicationzd2ze3nodez31zzast_appz00
															(BgL_arg1637z00_1807, BNIL, BgL_arg1638z00_1808,
															CNST_TABLE_REF(((long) 13)));
													}
												else
													{	/* Sync/node.scm 165 */
														obj_t BgL_arg1642z00_1811;
														obj_t BgL_arg1647z00_1812;

														{	/* Sync/node.scm 165 */
															obj_t BgL_arg1648z00_1813;

															{	/* Sync/node.scm 165 */
																BgL_nodez00_bglt BgL_arg1650z00_1814;
																obj_t BgL_arg1652z00_1815;

																BgL_arg1650z00_1814 =
																	(((BgL_syncz00_bglt)
																		COBJECT(BgL_nodez00_1754))->BgL_mutexz00);
																{	/* Sync/node.scm 165 */
																	BgL_nodez00_bglt BgL_arg1655z00_1816;

																	BgL_arg1655z00_1816 =
																		(((BgL_syncz00_bglt)
																			COBJECT(BgL_nodez00_1754))->
																		BgL_prelockz00);
																	BgL_arg1652z00_1815 =
																		MAKE_YOUNG_PAIR(((obj_t)
																			BgL_arg1655z00_1816), BNIL);
																}
																BgL_arg1648z00_1813 =
																	MAKE_YOUNG_PAIR(
																	((obj_t) BgL_arg1650z00_1814),
																	BgL_arg1652z00_1815);
															}
															BgL_arg1642z00_1811 =
																MAKE_YOUNG_PAIR
																(BGl_mlockprelockz00zzsync_nodez00,
																BgL_arg1648z00_1813);
														}
														BgL_arg1647z00_1812 =
															(((BgL_nodez00_bglt) COBJECT(
																	((BgL_nodez00_bglt) BgL_nodez00_1754)))->
															BgL_locz00);
														BgL_lockz00_1761 =
															BGl_applicationzd2ze3nodez31zzast_appz00
															(BgL_arg1642z00_1811, BNIL, BgL_arg1647z00_1812,
															CNST_TABLE_REF(((long) 13)));
											}}
											{	/* Sync/node.scm 163 */
												BgL_nodez00_bglt BgL_pushz00_1762;

												{	/* Sync/node.scm 166 */
													obj_t BgL_arg1622z00_1800;
													obj_t BgL_arg1623z00_1801;

													{	/* Sync/node.scm 166 */
														obj_t BgL_arg1625z00_1802;

														{	/* Sync/node.scm 166 */
															obj_t BgL_arg1628z00_1803;

															{	/* Sync/node.scm 166 */
																BgL_nodez00_bglt BgL_arg1629z00_1804;

																BgL_arg1629z00_1804 =
																	(((BgL_syncz00_bglt)
																		COBJECT(BgL_nodez00_1754))->BgL_mutexz00);
																BgL_arg1628z00_1803 =
																	MAKE_YOUNG_PAIR(((obj_t) BgL_arg1629z00_1804),
																	BNIL);
															}
															BgL_arg1625z00_1802 =
																MAKE_YOUNG_PAIR(
																((obj_t) BgL_toprefz00_1759),
																BgL_arg1628z00_1803);
														}
														BgL_arg1622z00_1800 =
															MAKE_YOUNG_PAIR(BGl_mpushz00zzsync_nodez00,
															BgL_arg1625z00_1802);
													}
													BgL_arg1623z00_1801 =
														(((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_nodez00_1754)))->
														BgL_locz00);
													BgL_pushz00_1762 =
														BGl_applicationzd2ze3nodez31zzast_appz00
														(BgL_arg1622z00_1800, BNIL, BgL_arg1623z00_1801,
														CNST_TABLE_REF(((long) 13)));
												}
												{	/* Sync/node.scm 166 */
													BgL_nodez00_bglt BgL_popz00_1763;

													{	/* Sync/node.scm 167 */
														obj_t BgL_arg1613z00_1797;
														obj_t BgL_arg1616z00_1798;

														{	/* Sync/node.scm 167 */
															obj_t BgL_arg1620z00_1799;

															BgL_arg1620z00_1799 =
																MAKE_YOUNG_PAIR(
																((obj_t) BgL_toprefz00_1759), BNIL);
															BgL_arg1613z00_1797 =
																MAKE_YOUNG_PAIR(BGl_mpopz00zzsync_nodez00,
																BgL_arg1620z00_1799);
														}
														BgL_arg1616z00_1798 =
															(((BgL_nodez00_bglt) COBJECT(
																	((BgL_nodez00_bglt) BgL_nodez00_1754)))->
															BgL_locz00);
														BgL_popz00_1763 =
															BGl_applicationzd2ze3nodez31zzast_appz00
															(BgL_arg1613z00_1797, BNIL, BgL_arg1616z00_1798,
															CNST_TABLE_REF(((long) 13)));
													}
													{	/* Sync/node.scm 167 */
														BgL_nodez00_bglt BgL_unlockz00_1764;

														{	/* Sync/node.scm 168 */
															obj_t BgL_arg1589z00_1793;
															obj_t BgL_arg1590z00_1794;

															{	/* Sync/node.scm 168 */
																obj_t BgL_arg1609z00_1795;

																{	/* Sync/node.scm 168 */
																	BgL_nodez00_bglt BgL_arg1610z00_1796;

																	BgL_arg1610z00_1796 =
																		(((BgL_syncz00_bglt)
																			COBJECT(BgL_nodez00_1754))->BgL_mutexz00);
																	BgL_arg1609z00_1795 =
																		MAKE_YOUNG_PAIR(((obj_t)
																			BgL_arg1610z00_1796), BNIL);
																}
																BgL_arg1589z00_1793 =
																	MAKE_YOUNG_PAIR(BGl_mulockz00zzsync_nodez00,
																	BgL_arg1609z00_1795);
															}
															BgL_arg1590z00_1794 =
																(((BgL_nodez00_bglt) COBJECT(
																		((BgL_nodez00_bglt) BgL_nodez00_1754)))->
																BgL_locz00);
															BgL_unlockz00_1764 =
																BGl_applicationzd2ze3nodez31zzast_appz00
																(BgL_arg1589z00_1793, BNIL, BgL_arg1590z00_1794,
																CNST_TABLE_REF(((long) 13)));
														}
														{	/* Sync/node.scm 168 */
															BgL_varz00_bglt BgL_vrefz00_1765;

															{	/* Sync/node.scm 169 */
																BgL_varz00_bglt BgL_new1124z00_1790;

																{	/* Sync/node.scm 170 */
																	BgL_varz00_bglt BgL_new1122z00_1791;

																	BgL_new1122z00_1791 =
																		((BgL_varz00_bglt)
																		BOBJECT(GC_MALLOC(sizeof(struct
																					BgL_varz00_bgl))));
																	{	/* Sync/node.scm 170 */
																		long BgL_arg1585z00_1792;

																		{	/* Sync/node.scm 170 */
																			long BgL_res1808z00_2110;

																			BgL_res1808z00_2110 =
																				BGL_CLASS_INDEX
																				(BGl_varz00zzast_nodez00);
																			BgL_arg1585z00_1792 = BgL_res1808z00_2110;
																		}
																		BGL_OBJECT_CLASS_NUM_SET(
																			((BgL_objectz00_bglt)
																				BgL_new1122z00_1791),
																			BgL_arg1585z00_1792);
																	}
																	BgL_new1124z00_1790 = BgL_new1122z00_1791;
																}
																((((BgL_nodez00_bglt) COBJECT(
																				((BgL_nodez00_bglt)
																					BgL_new1124z00_1790)))->BgL_locz00) =
																	((obj_t) (((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_nodez00_1754)))->BgL_locz00)),
																	BUNSPEC);
																((((BgL_nodez00_bglt)
																			COBJECT(((BgL_nodez00_bglt)
																					BgL_new1124z00_1790)))->BgL_typez00) =
																	((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_nodez00_1754)))->BgL_typez00)),
																	BUNSPEC);
																((((BgL_varz00_bglt)
																			COBJECT(BgL_new1124z00_1790))->
																		BgL_variablez00) =
																	((BgL_variablez00_bglt) (
																			(BgL_variablez00_bglt) BgL_tmpz00_1757)),
																	BUNSPEC);
																BgL_vrefz00_1765 = BgL_new1124z00_1790;
															}
															{	/* Sync/node.scm 169 */
																BgL_letzd2varzd2_bglt BgL_lbodyz00_1766;

																{	/* Sync/node.scm 173 */
																	BgL_letzd2varzd2_bglt BgL_new1126z00_1778;

																	{	/* Sync/node.scm 174 */
																		BgL_letzd2varzd2_bglt BgL_new1125z00_1788;

																		BgL_new1125z00_1788 =
																			((BgL_letzd2varzd2_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_letzd2varzd2_bgl))));
																		{	/* Sync/node.scm 174 */
																			long BgL_arg1583z00_1789;

																			{	/* Sync/node.scm 174 */
																				long BgL_res1809z00_2114;

																				BgL_res1809z00_2114 =
																					BGL_CLASS_INDEX
																					(BGl_letzd2varzd2zzast_nodez00);
																				BgL_arg1583z00_1789 =
																					BgL_res1809z00_2114;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1125z00_1788),
																				BgL_arg1583z00_1789);
																		}
																		{	/* Sync/node.scm 174 */
																			BgL_objectz00_bglt BgL_tmpz00_2512;

																			BgL_tmpz00_2512 =
																				((BgL_objectz00_bglt)
																				BgL_new1125z00_1788);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2512,
																				BFALSE);
																		}
																		BgL_new1126z00_1778 = BgL_new1125z00_1788;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1126z00_1778)))->
																			BgL_locz00) =
																		((obj_t) (((BgL_nodez00_bglt)
																					COBJECT(((BgL_nodez00_bglt)
																							BgL_nodez00_1754)))->BgL_locz00)),
																		BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1126z00_1778)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																					COBJECT(((BgL_nodez00_bglt)
																							BgL_nodez00_1754)))->
																				BgL_typez00)), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				COBJECT(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1126z00_1778)))->
																			BgL_sidezd2effectzd2) =
																		((obj_t) BUNSPEC), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				COBJECT(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1126z00_1778)))->
																			BgL_keyz00) =
																		((obj_t) BINT(((long) -1))), BUNSPEC);
																	{
																		obj_t BgL_auxz00_2528;

																		{	/* Sync/node.scm 176 */
																			obj_t BgL_arg1568z00_1779;

																			{	/* Sync/node.scm 176 */
																				BgL_nodez00_bglt BgL_arg1572z00_1781;

																				BgL_arg1572z00_1781 =
																					(((BgL_syncz00_bglt)
																						COBJECT(BgL_nodez00_1754))->
																					BgL_bodyz00);
																				BgL_arg1568z00_1779 =
																					MAKE_YOUNG_PAIR(((obj_t)
																						BgL_tmpz00_1757),
																					((obj_t) BgL_arg1572z00_1781));
																			}
																			{	/* Sync/node.scm 176 */
																				obj_t BgL_list1569z00_1780;

																				BgL_list1569z00_1780 =
																					MAKE_YOUNG_PAIR(BgL_arg1568z00_1779,
																					BNIL);
																				BgL_auxz00_2528 = BgL_list1569z00_1780;
																		}}
																		((((BgL_letzd2varzd2_bglt)
																					COBJECT(BgL_new1126z00_1778))->
																				BgL_bindingsz00) =
																			((obj_t) BgL_auxz00_2528), BUNSPEC);
																	}
																	{
																		BgL_nodez00_bglt BgL_auxz00_2535;

																		{	/* Sync/node.scm 177 */
																			BgL_sequencez00_bglt BgL_new1129z00_1782;

																			{	/* Sync/node.scm 178 */
																				BgL_sequencez00_bglt
																					BgL_new1128z00_1786;
																				BgL_new1128z00_1786 =
																					((BgL_sequencez00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_sequencez00_bgl))));
																				{	/* Sync/node.scm 178 */
																					long BgL_arg1578z00_1787;

																					{	/* Sync/node.scm 178 */
																						long BgL_res1811z00_2119;

																						{	/* Sync/node.scm 178 */
																							obj_t BgL_classz00_2118;

																							BgL_classz00_2118 =
																								BGl_sequencez00zzast_nodez00;
																							BgL_res1811z00_2119 =
																								BGL_CLASS_INDEX
																								(BgL_classz00_2118);
																						}
																						BgL_arg1578z00_1787 =
																							BgL_res1811z00_2119;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1128z00_1786),
																						BgL_arg1578z00_1787);
																				}
																				{	/* Sync/node.scm 178 */
																					BgL_objectz00_bglt BgL_tmpz00_2540;

																					BgL_tmpz00_2540 =
																						((BgL_objectz00_bglt)
																						BgL_new1128z00_1786);
																					BGL_OBJECT_WIDENING_SET
																						(BgL_tmpz00_2540, BFALSE);
																				}
																				BgL_new1129z00_1782 =
																					BgL_new1128z00_1786;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1129z00_1782)))->
																					BgL_locz00) =
																				((obj_t) (((BgL_nodez00_bglt)
																							COBJECT(((BgL_nodez00_bglt)
																									BgL_nodez00_1754)))->
																						BgL_locz00)), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1129z00_1782)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																							COBJECT(((BgL_nodez00_bglt)
																									BgL_nodez00_1754)))->
																						BgL_typez00)), BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1129z00_1782)))->
																					BgL_sidezd2effectzd2) =
																				((obj_t) BUNSPEC), BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1129z00_1782)))->
																					BgL_keyz00) =
																				((obj_t) BINT(((long) -1))), BUNSPEC);
																			{
																				obj_t BgL_auxz00_2556;

																				{	/* Sync/node.scm 180 */
																					obj_t BgL_list1573z00_1783;

																					{	/* Sync/node.scm 180 */
																						obj_t BgL_arg1575z00_1784;

																						{	/* Sync/node.scm 180 */
																							obj_t BgL_arg1576z00_1785;

																							BgL_arg1576z00_1785 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_vrefz00_1765),
																								BNIL);
																							BgL_arg1575z00_1784 =
																								MAKE_YOUNG_PAIR(((obj_t)
																									BgL_unlockz00_1764),
																								BgL_arg1576z00_1785);
																						}
																						BgL_list1573z00_1783 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_popz00_1763),
																							BgL_arg1575z00_1784);
																					}
																					BgL_auxz00_2556 =
																						BgL_list1573z00_1783;
																				}
																				((((BgL_sequencez00_bglt)
																							COBJECT(BgL_new1129z00_1782))->
																						BgL_nodesz00) =
																					((obj_t) BgL_auxz00_2556), BUNSPEC);
																			}
																			((((BgL_sequencez00_bglt)
																						COBJECT(BgL_new1129z00_1782))->
																					BgL_unsafez00) =
																				((bool_t) ((bool_t) 0)), BUNSPEC);
																			((((BgL_sequencez00_bglt)
																						COBJECT(BgL_new1129z00_1782))->
																					BgL_metaz00) =
																				((obj_t) BNIL), BUNSPEC);
																			BgL_auxz00_2535 =
																				((BgL_nodez00_bglt)
																				BgL_new1129z00_1782);
																		}
																		((((BgL_letzd2varzd2_bglt)
																					COBJECT(BgL_new1126z00_1778))->
																				BgL_bodyz00) =
																			((BgL_nodez00_bglt) BgL_auxz00_2535),
																			BUNSPEC);
																	}
																	((((BgL_letzd2varzd2_bglt)
																				COBJECT(BgL_new1126z00_1778))->
																			BgL_removablezf3zf3) =
																		((bool_t) ((bool_t) 1)), BUNSPEC);
																	BgL_lbodyz00_1766 = BgL_new1126z00_1778;
																}
																{	/* Sync/node.scm 173 */

																	{	/* Sync/node.scm 181 */
																		BgL_letzd2varzd2_bglt BgL_new1132z00_1767;

																		{	/* Sync/node.scm 182 */
																			BgL_letzd2varzd2_bglt BgL_new1130z00_1776;

																			BgL_new1130z00_1776 =
																				((BgL_letzd2varzd2_bglt)
																				BOBJECT(GC_MALLOC(sizeof(struct
																							BgL_letzd2varzd2_bgl))));
																			{	/* Sync/node.scm 182 */
																				long BgL_arg1561z00_1777;

																				{	/* Sync/node.scm 182 */
																					long BgL_res1813z00_2124;

																					BgL_res1813z00_2124 =
																						BGL_CLASS_INDEX
																						(BGl_letzd2varzd2zzast_nodez00);
																					BgL_arg1561z00_1777 =
																						BgL_res1813z00_2124;
																				}
																				BGL_OBJECT_CLASS_NUM_SET(
																					((BgL_objectz00_bglt)
																						BgL_new1130z00_1776),
																					BgL_arg1561z00_1777);
																			}
																			{	/* Sync/node.scm 182 */
																				BgL_objectz00_bglt BgL_tmpz00_2573;

																				BgL_tmpz00_2573 =
																					((BgL_objectz00_bglt)
																					BgL_new1130z00_1776);
																				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2573,
																					BFALSE);
																			}
																			BgL_new1132z00_1767 = BgL_new1130z00_1776;
																		}
																		((((BgL_nodez00_bglt) COBJECT(
																						((BgL_nodez00_bglt)
																							BgL_new1132z00_1767)))->
																				BgL_locz00) =
																			((obj_t) (((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_nodez00_1754)))->
																					BgL_locz00)), BUNSPEC);
																		((((BgL_nodez00_bglt)
																					COBJECT(((BgL_nodez00_bglt)
																							BgL_new1132z00_1767)))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) (((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_nodez00_1754)))->
																					BgL_typez00)), BUNSPEC);
																		((((BgL_nodezf2effectzf2_bglt)
																					COBJECT(((BgL_nodezf2effectzf2_bglt)
																							BgL_new1132z00_1767)))->
																				BgL_sidezd2effectzd2) =
																			((obj_t) BUNSPEC), BUNSPEC);
																		((((BgL_nodezf2effectzf2_bglt)
																					COBJECT(((BgL_nodezf2effectzf2_bglt)
																							BgL_new1132z00_1767)))->
																				BgL_keyz00) =
																			((obj_t) BINT(((long) -1))), BUNSPEC);
																		{
																			obj_t BgL_auxz00_2589;

																			{	/* Sync/node.scm 184 */
																				obj_t BgL_arg1555z00_1768;

																				BgL_arg1555z00_1768 =
																					MAKE_YOUNG_PAIR(
																					((obj_t) BgL_topz00_1758),
																					((obj_t) BgL_gettopz00_1760));
																				{	/* Sync/node.scm 184 */
																					obj_t BgL_list1556z00_1769;

																					BgL_list1556z00_1769 =
																						MAKE_YOUNG_PAIR(BgL_arg1555z00_1768,
																						BNIL);
																					BgL_auxz00_2589 =
																						BgL_list1556z00_1769;
																			}}
																			((((BgL_letzd2varzd2_bglt)
																						COBJECT(BgL_new1132z00_1767))->
																					BgL_bindingsz00) =
																				((obj_t) BgL_auxz00_2589), BUNSPEC);
																		}
																		{
																			BgL_nodez00_bglt BgL_auxz00_2595;

																			{	/* Sync/node.scm 185 */
																				BgL_sequencez00_bglt
																					BgL_new1134z00_1770;
																				{	/* Sync/node.scm 186 */
																					BgL_sequencez00_bglt
																						BgL_new1133z00_1774;
																					BgL_new1133z00_1774 =
																						((BgL_sequencez00_bglt)
																						BOBJECT(GC_MALLOC(sizeof(struct
																									BgL_sequencez00_bgl))));
																					{	/* Sync/node.scm 186 */
																						long BgL_arg1560z00_1775;

																						{	/* Sync/node.scm 186 */
																							long BgL_res1815z00_2129;

																							{	/* Sync/node.scm 186 */
																								obj_t BgL_classz00_2128;

																								BgL_classz00_2128 =
																									BGl_sequencez00zzast_nodez00;
																								BgL_res1815z00_2129 =
																									BGL_CLASS_INDEX
																									(BgL_classz00_2128);
																							}
																							BgL_arg1560z00_1775 =
																								BgL_res1815z00_2129;
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1133z00_1774),
																							BgL_arg1560z00_1775);
																					}
																					{	/* Sync/node.scm 186 */
																						BgL_objectz00_bglt BgL_tmpz00_2600;

																						BgL_tmpz00_2600 =
																							((BgL_objectz00_bglt)
																							BgL_new1133z00_1774);
																						BGL_OBJECT_WIDENING_SET
																							(BgL_tmpz00_2600, BFALSE);
																					}
																					BgL_new1134z00_1770 =
																						BgL_new1133z00_1774;
																				}
																				((((BgL_nodez00_bglt) COBJECT(
																								((BgL_nodez00_bglt)
																									BgL_new1134z00_1770)))->
																						BgL_locz00) =
																					((obj_t) (((BgL_nodez00_bglt)
																								COBJECT(((BgL_nodez00_bglt)
																										BgL_nodez00_1754)))->
																							BgL_locz00)), BUNSPEC);
																				((((BgL_nodez00_bglt)
																							COBJECT(((BgL_nodez00_bglt)
																									BgL_new1134z00_1770)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) ((
																								(BgL_nodez00_bglt)
																								COBJECT(((BgL_nodez00_bglt)
																										BgL_nodez00_1754)))->
																							BgL_typez00)), BUNSPEC);
																				((((BgL_nodezf2effectzf2_bglt)
																							COBJECT((
																									(BgL_nodezf2effectzf2_bglt)
																									BgL_new1134z00_1770)))->
																						BgL_sidezd2effectzd2) =
																					((obj_t) BUNSPEC), BUNSPEC);
																				((((BgL_nodezf2effectzf2_bglt)
																							COBJECT((
																									(BgL_nodezf2effectzf2_bglt)
																									BgL_new1134z00_1770)))->
																						BgL_keyz00) =
																					((obj_t) BINT(((long) -1))), BUNSPEC);
																				{
																					obj_t BgL_auxz00_2616;

																					{	/* Sync/node.scm 188 */
																						obj_t BgL_arg1557z00_1771;

																						{	/* Sync/node.scm 188 */
																							obj_t BgL_arg1558z00_1772;

																							{	/* Sync/node.scm 188 */
																								obj_t BgL_arg1559z00_1773;

																								BgL_arg1559z00_1773 =
																									(((BgL_nodez00_bglt) COBJECT(
																											((BgL_nodez00_bglt)
																												BgL_nodez00_1754)))->
																									BgL_locz00);
																								BgL_nodez00_1690 =
																									BgL_lbodyz00_1766;
																								BgL_locz00_1691 =
																									BgL_arg1559z00_1773;
																								if (CBOOL
																									(BGl_exitdzd2mutexzd2profilez00zzsync_nodez00))
																									{	/* Sync/node.scm 118 */
																										BgL_nodez00_bglt
																											BgL_arg1372z00_1694;
																										{	/* Sync/node.scm 118 */
																											obj_t BgL_arg1392z00_1697;

																											BgL_arg1392z00_1697 =
																												MAKE_YOUNG_PAIR
																												(BGl_exitdzd2mutexzd2profilez00zzsync_nodez00,
																												BNIL);
																											BgL_arg1372z00_1694 =
																												BGl_applicationzd2ze3nodez31zzast_appz00
																												(BgL_arg1392z00_1697,
																												BNIL, BgL_locz00_1691,
																												CNST_TABLE_REF(((long)
																														13)));
																										}
																										{	/* Sync/node.scm 118 */
																											obj_t
																												BgL_list1373z00_1695;
																											{	/* Sync/node.scm 118 */
																												obj_t
																													BgL_arg1375z00_1696;
																												BgL_arg1375z00_1696 =
																													MAKE_YOUNG_PAIR((
																														(obj_t)
																														BgL_nodez00_1690),
																													BNIL);
																												BgL_list1373z00_1695 =
																													MAKE_YOUNG_PAIR((
																														(obj_t)
																														BgL_arg1372z00_1694),
																													BgL_arg1375z00_1696);
																											}
																											BgL_arg1558z00_1772 =
																												BgL_list1373z00_1695;
																									}}
																								else
																									{	/* Sync/node.scm 119 */
																										obj_t BgL_list1393z00_1698;

																										BgL_list1393z00_1698 =
																											MAKE_YOUNG_PAIR(
																											((obj_t)
																												BgL_nodez00_1690),
																											BNIL);
																										BgL_arg1558z00_1772 =
																											BgL_list1393z00_1698;
																									}
																							}
																							BgL_arg1557z00_1771 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_pushz00_1762),
																								BgL_arg1558z00_1772);
																						}
																						BgL_auxz00_2616 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_lockz00_1761),
																							BgL_arg1557z00_1771);
																					}
																					((((BgL_sequencez00_bglt)
																								COBJECT(BgL_new1134z00_1770))->
																							BgL_nodesz00) =
																						((obj_t) BgL_auxz00_2616), BUNSPEC);
																				}
																				((((BgL_sequencez00_bglt)
																							COBJECT(BgL_new1134z00_1770))->
																						BgL_unsafez00) =
																					((bool_t) ((bool_t) 0)), BUNSPEC);
																				((((BgL_sequencez00_bglt)
																							COBJECT(BgL_new1134z00_1770))->
																						BgL_metaz00) =
																					((obj_t) BNIL), BUNSPEC);
																				BgL_auxz00_2595 =
																					((BgL_nodez00_bglt)
																					BgL_new1134z00_1770);
																			}
																			((((BgL_letzd2varzd2_bglt)
																						COBJECT(BgL_new1132z00_1767))->
																					BgL_bodyz00) =
																				((BgL_nodez00_bglt) BgL_auxz00_2595),
																				BUNSPEC);
																		}
																		((((BgL_letzd2varzd2_bglt)
																					COBJECT(BgL_new1132z00_1767))->
																				BgL_removablezf3zf3) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																		BgL_auxz00_2418 = BgL_new1132z00_1767;
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
						return ((BgL_nodez00_bglt) BgL_auxz00_2418);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &sync->sequence */
	BgL_nodez00_bglt BGl_z62synczd2ze3sequencez53zzsync_nodez00(obj_t
		BgL_envz00_2133, obj_t BgL_nodez00_2134)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 111 */
			return
				BGl_synczd2ze3sequencez31zzsync_nodez00(
				((BgL_syncz00_bglt) BgL_nodez00_2134));
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzsync_nodez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Sync/node.scm 18 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 173709144),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 453414928),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 151271251),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 315247917),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 36886173),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzinline_appz00(((long) 148760855),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 460136018),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			BGl_modulezd2initializa7ationz75zzbackend_cplibz00(((long) 395792377),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
			return
				BGl_modulezd2initializa7ationz75zzsync_failsafez00(((long) 377892095),
				BSTRING_TO_STRING(BGl_string1816z00zzsync_nodez00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
