/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_z62zc3anonymousza31521ze3ze1zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00(BgL_nodez00_bglt);
	static obj_t BGl_z62zc3anonymousza31522ze3ze1zzast_sexpz00(obj_t);
	static obj_t BGl_objectzd2initzd2zzast_sexpz00();
	extern obj_t BGl_privatezd2nodezd2zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	extern obj_t BGl_castzd2sexpzd2typez00zzast_privatez00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza36886ze3ze1zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_sexpz00();
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
	static obj_t BGl_loopze70ze7zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letrecza2zd2ze3nodez93zzast_letz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(obj_t);
	BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	static bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	static obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	static obj_t BGl_liipze70ze7zzast_sexpz00(obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_castzd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t __cnst[46];


	   
		 
		DEFINE_STRING(BGl_string7972z00zzast_sexpz00,
		BgL_bgl_string7972za700za7za7a8009za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string7973z00zzast_sexpz00,
		BgL_bgl_string7973za700za7za7a8010za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string7974z00zzast_sexpz00,
		BgL_bgl_string7974za700za7za7a8011za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string7975z00zzast_sexpz00,
		BgL_bgl_string7975za700za7za7a8012za7, "Illegal `static-pragma' expression",
		34);
	      DEFINE_STRING(BGl_string7976z00zzast_sexpz00,
		BgL_bgl_string7976za700za7za7a8013za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string7977z00zzast_sexpz00,
		BgL_bgl_string7977za700za7za7a8014za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string7978z00zzast_sexpz00,
		BgL_bgl_string7978za700za7za7a8015za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string7979z00zzast_sexpz00,
		BgL_bgl_string7979za700za7za7a8016za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string7980z00zzast_sexpz00,
		BgL_bgl_string7980za700za7za7a8017za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string7981z00zzast_sexpz00,
		BgL_bgl_string7981za700za7za7a8018za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string7982z00zzast_sexpz00,
		BgL_bgl_string7982za700za7za7a8019za7, "Illegal ->", 10);
	      DEFINE_STRING(BGl_string7983z00zzast_sexpz00,
		BgL_bgl_string7983za700za7za7a8020za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string7984z00zzast_sexpz00,
		BgL_bgl_string7984za700za7za7a8021za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string7985z00zzast_sexpz00,
		BgL_bgl_string7985za700za7za7a8022za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string7986z00zzast_sexpz00,
		BgL_bgl_string7986za700za7za7a8023za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string7987z00zzast_sexpz00,
		BgL_bgl_string7987za700za7za7a8024za7, "Illegal atom in s-expression", 28);
	      DEFINE_STRING(BGl_string7988z00zzast_sexpz00,
		BgL_bgl_string7988za700za7za7a8025za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string7989z00zzast_sexpz00,
		BgL_bgl_string7989za700za7za7a8026za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string7990z00zzast_sexpz00,
		BgL_bgl_string7990za700za7za7a8027za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string7991z00zzast_sexpz00,
		BgL_bgl_string7991za700za7za7a8028za7,
		"Backend (~a) does not support external first class function", 59);
	      DEFINE_STRING(BGl_string7992z00zzast_sexpz00,
		BgL_bgl_string7992za700za7za7a8029za7, "Illegal pragma/effect", 21);
	      DEFINE_STRING(BGl_string7993z00zzast_sexpz00,
		BgL_bgl_string7993za700za7za7a8030za7, "Illegal free-pragma/effect", 26);
	      DEFINE_STRING(BGl_string7994z00zzast_sexpz00,
		BgL_bgl_string7994za700za7za7a8031za7, "Illegal lambda", 14);
	      DEFINE_STRING(BGl_string7995z00zzast_sexpz00,
		BgL_bgl_string7995za700za7za7a8032za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string7996z00zzast_sexpz00,
		BgL_bgl_string7996za700za7za7a8033za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string7997z00zzast_sexpz00,
		BgL_bgl_string7997za700za7za7a8034za7, "($1)", 4);
	      DEFINE_STRING(BGl_string7998z00zzast_sexpz00,
		BgL_bgl_string7998za700za7za7a8035za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string7999z00zzast_sexpz00,
		BgL_bgl_string7999za700za7za7a8036za7, "<", 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8037z00,
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762errorza7d2sexpza78038za7,
		BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_expzd2envzd2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl_za762makeza7d2anonym8039z00, va_generic_entry,
		BGl_z62makezd2anonymouszd2namez62zzast_sexpz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2localzd2envz00zzast_sexpz00,
		BgL_bgl_za762findza7d2localza78040za7, BGl_z62findzd2localzb0zzast_sexpz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762locationza7d2za7e8041za7,
		BGl_z62locationzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762sexpza7d2za7e3nod8042za7,
		BGl_z62sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762topza7d2levelza7d8043za7,
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl_za762sexpza7a2za7d2za7e38044z00,
		BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string8000z00zzast_sexpz00,
		BgL_bgl_string8000za700za7za7a8045za7, ":", 1);
	      DEFINE_STRING(BGl_string8001z00zzast_sexpz00,
		BgL_bgl_string8001za700za7za7a8046za7, "./", 2);
	      DEFINE_STRING(BGl_string8002z00zzast_sexpz00,
		BgL_bgl_string8002za700za7za7a8047za7, ">", 1);
	      DEFINE_STRING(BGl_string8003z00zzast_sexpz00,
		BgL_bgl_string8003za700za7za7a8048za7, "-", 1);
	      DEFINE_STRING(BGl_string8004z00zzast_sexpz00,
		BgL_bgl_string8004za700za7za7a8049za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string8005z00zzast_sexpz00,
		BgL_bgl_string8005za700za7za7a8050za7,
		"not mutex > bdb location pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) (@ define-primop-ref! __evenv) write car exp app cons :prelock apply synchronize jump-exit set-exit case failure free-pragma/effect static-pragma free-pragma pragma/effect letrec* labels letrec let define begin -> __r4_control_features_6_9 quote @ eval bool test set! pragma else (quote ()) lambda value if (value apply app set! test) ",
		431);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl_za762ifza7d2symza7b0za7za78051za7, BGl_z62ifzd2symzb0zzast_sexpz00,
		0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl_za762useza7d2variabl8052z00,
		BGl_z62usezd2variablez12za2zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8053z00,
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2sitesza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2ifza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2nameza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2resza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2stackza2zd2zzast_sexpz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_13753, char *BgL_fromz00_13754)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_sexpz00();
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					return BGl_toplevelzd2initzd2zzast_sexpz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "ast_sexp");
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_13740;

				{	/* Ast/sexp.scm 14 */
					obj_t BgL_stringz00_13748;

					BgL_stringz00_13748 = BGl_string8005z00zzast_sexpz00;
					{	/* Ast/sexp.scm 14 */
						obj_t BgL_startz00_13749;

						BgL_startz00_13749 = BINT(((long) 0));
						{	/* Ast/sexp.scm 14 */
							obj_t BgL_endz00_13750;

							BgL_endz00_13750 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_13748)));
							{	/* Ast/sexp.scm 14 */

								BgL_cportz00_13740 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_13748, BgL_startz00_13749, BgL_endz00_13750);
				}}}}
				{
					long BgL_iz00_13741;

					BgL_iz00_13741 = ((long) 45);
				BgL_loopz00_13742:
					if ((BgL_iz00_13741 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg8007z00_13744;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_13746;

										BgL_locationz00_13746 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg8007z00_13744 =
												BGl_readz00zz__readerz00(BgL_cportz00_13740,
												BgL_locationz00_13746);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_tmpz00_13792;

									BgL_tmpz00_13792 = (int) (BgL_iz00_13741);
									CNST_TABLE_SET(BgL_tmpz00_13792, BgL_arg8007z00_13744);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_13747;

								BgL_auxz00_13747 = (int) ((BgL_iz00_13741 - ((long) 1)));
								{
									long BgL_iz00_13797;

									BgL_iz00_13797 = (long) (BgL_auxz00_13747);
									BgL_iz00_13741 = BgL_iz00_13797;
									goto BgL_loopz00_13742;
								}
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17,
		obj_t BgL_locz00_18)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 65 */
			{

				{
					obj_t BgL_auxz00_13803;
					jmp_buf_t jmpbuf;
					void *BgL_an_exit1107z00_1675;

					if (SET_EXIT(BgL_an_exit1107z00_1675))
						{
							BgL_auxz00_13803 = BGL_EXIT_VALUE();
						}
					else
						{
#if( SIGSETJMP_SAVESIGS == 0 )
							bgl_restore_signal_handlers();
#endif

							BgL_an_exit1107z00_1675 = (void *) jmpbuf;
							{	/* Ast/sexp.scm 66 */

								PUSH_EXIT(BgL_an_exit1107z00_1675, ((long) 1));
								{	/* Ast/sexp.scm 66 */
									obj_t BgL_an_exitd1108z00_1676;

									BgL_an_exitd1108z00_1676 = ((obj_t) (&exitd));
									{	/* Ast/sexp.scm 66 */
										obj_t BgL_res1110z00_1679;

										{	/* Ast/sexp.scm 69 */
											obj_t BgL_zc3anonymousza31522ze3z83_13686;
											obj_t BgL_zc3anonymousza31521ze3z83_13687;

											BgL_zc3anonymousza31522ze3z83_13686 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31522ze3ze1zzast_sexpz00,
												(int) (((long) 0)), (int) (((long) 2)));
											BgL_zc3anonymousza31521ze3z83_13687 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31521ze3ze1zzast_sexpz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3anonymousza31522ze3z83_13686,
												(int) (((long) 0)), BgL_expz00_17);
											PROCEDURE_SET(BgL_zc3anonymousza31522ze3z83_13686,
												(int) (((long) 1)), BgL_locz00_18);
											PROCEDURE_SET(BgL_zc3anonymousza31521ze3z83_13687,
												(int) (((long) 0)), BgL_an_exitd1108z00_1676);
											BgL_res1110z00_1679 =
												BGl_withzd2exceptionzd2handlerz00zz__errorz00
												(BgL_zc3anonymousza31521ze3z83_13687,
												BgL_zc3anonymousza31522ze3z83_13686);
										}
										POP_EXIT();
										BgL_auxz00_13803 = BgL_res1110z00_1679;
							}}}
						}
					return ((BgL_nodez00_bglt) BgL_auxz00_13803);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &top-level-sexp->node */
	BgL_nodez00_bglt BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13688, obj_t BgL_expz00_13689, obj_t BgL_locz00_13690)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 65 */
			return
				BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13689,
				BgL_locz00_13690);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1522> */
	obj_t BGl_z62zc3anonymousza31522ze3ze1zzast_sexpz00(obj_t BgL_envz00_13691)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 71 */
			{	/* Ast/sexp.scm 72 */
				obj_t BgL_expz00_13692;
				obj_t BgL_locz00_13693;

				BgL_expz00_13692 = PROCEDURE_REF(BgL_envz00_13691, (int) (((long) 0)));
				BgL_locz00_13693 = PROCEDURE_REF(BgL_envz00_13691, (int) (((long) 1)));
				return
					((obj_t)
					BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13692, BNIL,
						BgL_locz00_13693, CNST_TABLE_REF(((long) 2))));
		}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1521> */
	obj_t BGl_z62zc3anonymousza31521ze3ze1zzast_sexpz00(obj_t BgL_envz00_13694,
		obj_t BgL_ez00_13696)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 68 */
			{	/* Ast/sexp.scm 69 */
				obj_t BgL_an_exitd1108z00_13695;

				BgL_an_exitd1108z00_13695 =
					PROCEDURE_REF(BgL_envz00_13694, (int) (((long) 0)));
				BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_13696);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1108z00_13695,
					BUNSPEC);
			}
		}
		BGL_FUNCTION_END;
	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 87 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}
		BGL_FUNCTION_END;
	}



/* &if-sym */
	obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t BgL_envz00_13697)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 87 */
			return BGl_ifzd2symzd2zzast_sexpz00();
		}
		BGL_FUNCTION_END;
	}



/* proc-or-lambda? */
	bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t BgL_ez00_20)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 99 */
			if (SYMBOLP(BgL_ez00_20))
				{	/* Ast/sexp.scm 100 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 100 */
					if (PAIRP(BgL_ez00_20))
						{	/* Ast/sexp.scm 100 */
							if ((CAR(BgL_ez00_20) == CNST_TABLE_REF(((long) 3))))
								{	/* Ast/sexp.scm 100 */
									obj_t BgL_tmpz00_13843;

									BgL_tmpz00_13843 = CDR(BgL_ez00_20);
									return PAIRP(BgL_tmpz00_13843);
								}
							else
								{	/* Ast/sexp.scm 100 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Ast/sexp.scm 100 */
							return ((bool_t) 0);
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 113 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_1701;
				obj_t BgL_lz00_1706;
				obj_t BgL_bodyz00_1710;
				obj_t BgL_lz00_1715;
				obj_t BgL_valz00_1716;
				obj_t BgL_bodyz00_1720;
				obj_t BgL_argsz00_1721;
				obj_t BgL_bindingsz00_1723;
				obj_t BgL_exprz00_1724;
				obj_t BgL_varz00_1728;
				obj_t BgL_bodyz00_1729;
				obj_t BgL_argz00_1730;
				obj_t BgL_varsz00_1732;
				obj_t BgL_bodyz00_1733;
				obj_t BgL_argsz00_1734;
				obj_t BgL_testz00_1736;
				obj_t BgL_proc1z00_1737;
				obj_t BgL_proc2z00_1738;
				obj_t BgL_argsz00_1739;
				obj_t BgL_testz00_1741;
				obj_t BgL_proc1z00_1742;
				obj_t BgL_proc2z00_1743;
				obj_t BgL_argsz00_1744;
				obj_t BgL_effectz00_1748;
				obj_t BgL_restz00_1749;
				obj_t BgL_effectz00_1753;
				obj_t BgL_restz00_1754;

				if (NULLP(BgL_expz00_21))
					{	/* Ast/sexp.scm 118 */
						{	/* Ast/sexp.scm 121 */
							BgL_nodez00_bglt BgL_res7294z00_9559;

							{	/* Ast/sexp.scm 717 */
								obj_t BgL_arg7100z00_9555;
								BgL_nodez00_bglt BgL_arg7101z00_9556;

								BgL_arg7100z00_9555 =
									BGl_shapez00zztools_shapez00
									(BGl_currentzd2functionzd2zztools_errorz00());
								BgL_arg7101z00_9556 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
									BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 716 */
									obj_t BgL_list7102z00_9558;

									BgL_list7102z00_9558 =
										MAKE_YOUNG_PAIR(((obj_t) BgL_arg7101z00_9556), BNIL);
									BgL_res7294z00_9559 =
										((BgL_nodez00_bglt)
										BGl_userzd2errorzf2locationz20zztools_errorz00
										(BgL_locz00_23, BgL_arg7100z00_9555,
											BGl_string7988z00zzast_sexpz00, BgL_expz00_21,
											BgL_list7102z00_9558));
							}}
							return BgL_res7294z00_9559;
						}
					}
				else
					{	/* Ast/sexp.scm 118 */
						if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
								BGl_nodez00zzast_nodez00))
							{
								obj_t BgL_auxz00_13859;

								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_externz00zzast_nodez00))
									{	/* Ast/sexp.scm 126 */
										obj_t BgL_l01340z00_8330;

										BgL_l01340z00_8330 =
											(((BgL_externz00_bglt) COBJECT(
													((BgL_externz00_bglt) BgL_expz00_21)))->
											BgL_exprza2za2);
										{
											obj_t BgL_l1339z00_8332;

											BgL_l1339z00_8332 = BgL_l01340z00_8330;
										BgL_zc3anonymousza36611ze3z83_8333:
											if (NULLP(BgL_l1339z00_8332))
												{	/* Ast/sexp.scm 126 */
													BgL_l01340z00_8330;
												}
											else
												{	/* Ast/sexp.scm 126 */
													{	/* Ast/sexp.scm 126 */
														BgL_nodez00_bglt BgL_arg6613z00_8335;

														{	/* Ast/sexp.scm 126 */
															obj_t BgL_ez00_8336;

															BgL_ez00_8336 = CAR(((obj_t) BgL_l1339z00_8332));
															{	/* Ast/sexp.scm 126 */
																obj_t BgL_arg6614z00_8337;

																BgL_arg6614z00_8337 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_externz00_bglt)
																					BgL_expz00_21))))->BgL_locz00);
																BgL_arg6613z00_8335 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8336, BgL_stackz00_22,
																	BgL_arg6614z00_8337,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 126 */
															obj_t BgL_auxz00_13875;
															obj_t BgL_tmpz00_13873;

															BgL_auxz00_13875 = ((obj_t) BgL_arg6613z00_8335);
															BgL_tmpz00_13873 = ((obj_t) BgL_l1339z00_8332);
															SET_CAR(BgL_tmpz00_13873, BgL_auxz00_13875);
													}}
													{	/* Ast/sexp.scm 126 */
														obj_t BgL_arg6615z00_8338;

														BgL_arg6615z00_8338 =
															CDR(((obj_t) BgL_l1339z00_8332));
														{
															obj_t BgL_l1339z00_13880;

															BgL_l1339z00_13880 = BgL_arg6615z00_8338;
															BgL_l1339z00_8332 = BgL_l1339z00_13880;
															goto BgL_zc3anonymousza36611ze3z83_8333;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 124 */
										BFALSE;
									}
								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_appz00zzast_nodez00))
									{	/* Ast/sexp.scm 129 */
										obj_t BgL_l01343z00_8342;

										BgL_l01343z00_8342 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_expz00_21)))->BgL_argsz00);
										{
											obj_t BgL_l1342z00_8344;

											BgL_l1342z00_8344 = BgL_l01343z00_8342;
										BgL_zc3anonymousza36617ze3z83_8345:
											if (NULLP(BgL_l1342z00_8344))
												{	/* Ast/sexp.scm 129 */
													BgL_l01343z00_8342;
												}
											else
												{	/* Ast/sexp.scm 129 */
													{	/* Ast/sexp.scm 129 */
														BgL_nodez00_bglt BgL_arg6619z00_8347;

														{	/* Ast/sexp.scm 129 */
															obj_t BgL_ez00_8348;

															BgL_ez00_8348 = CAR(((obj_t) BgL_l1342z00_8344));
															{	/* Ast/sexp.scm 129 */
																obj_t BgL_arg6620z00_8349;

																BgL_arg6620z00_8349 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_appz00_bglt) BgL_expz00_21))))->
																	BgL_locz00);
																BgL_arg6619z00_8347 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8348, BgL_stackz00_22,
																	BgL_arg6620z00_8349,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 129 */
															obj_t BgL_auxz00_13896;
															obj_t BgL_tmpz00_13894;

															BgL_auxz00_13896 = ((obj_t) BgL_arg6619z00_8347);
															BgL_tmpz00_13894 = ((obj_t) BgL_l1342z00_8344);
															SET_CAR(BgL_tmpz00_13894, BgL_auxz00_13896);
													}}
													{	/* Ast/sexp.scm 129 */
														obj_t BgL_arg6621z00_8350;

														BgL_arg6621z00_8350 =
															CDR(((obj_t) BgL_l1342z00_8344));
														{
															obj_t BgL_l1342z00_13901;

															BgL_l1342z00_13901 = BgL_arg6621z00_8350;
															BgL_l1342z00_8344 = BgL_l1342z00_13901;
															goto BgL_zc3anonymousza36617ze3z83_8345;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 127 */
										BFALSE;
									}
								BgL_auxz00_13859 = BgL_expz00_21;
								return ((BgL_nodez00_bglt) BgL_auxz00_13859);
							}
						else
							{	/* Ast/sexp.scm 118 */
								if (PAIRP(BgL_expz00_21))
									{	/* Ast/sexp.scm 118 */
										obj_t BgL_carzd2478zd2_1775;

										BgL_carzd2478zd2_1775 = CAR(BgL_expz00_21);
										if (SYMBOLP(BgL_carzd2478zd2_1775))
											{	/* Ast/sexp.scm 118 */
												bool_t BgL_testz00_13908;

												{	/* Ast/sexp.scm 118 */
													obj_t BgL__ortest_1143z00_5055;

													BgL__ortest_1143z00_5055 =
														BGl_findzd2localzd2zzast_sexpz00
														(BgL_carzd2478zd2_1775, BgL_stackz00_22);
													if (CBOOL(BgL__ortest_1143z00_5055))
														{	/* Ast/sexp.scm 118 */
															BgL_testz00_13908 =
																CBOOL(BgL__ortest_1143z00_5055);
														}
													else
														{	/* Ast/sexp.scm 118 */
															obj_t BgL_gz00_5056;

															BgL_gz00_5056 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd2478zd2_1775, BNIL);
															if (CBOOL(BgL_gz00_5056))
																{	/* Ast/sexp.scm 118 */
																	if (
																		((((BgL_globalz00_bglt) COBJECT(
																						((BgL_globalz00_bglt)
																							BgL_gz00_5056)))->
																				BgL_modulez00) ==
																			CNST_TABLE_REF(((long) 13))))
																		{	/* Ast/sexp.scm 118 */
																			BgL_testz00_13908 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 118 */
																			BgL_testz00_13908 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 118 */
																	BgL_testz00_13908 = ((bool_t) 0);
																}
														}
												}
												if (BgL_testz00_13908)
													{	/* Ast/sexp.scm 118 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21,
															BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
													}
												else
													{	/* Ast/sexp.scm 118 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 11))))
															{	/* Ast/sexp.scm 118 */
															BgL_tagzd2371zd2_1705:
																{	/* Ast/sexp.scm 170 */
																	obj_t BgL_locz00_8380;

																	BgL_locz00_8380 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_21, BgL_locz00_23);
																	{
																		obj_t BgL_namez00_8381;
																		obj_t BgL_modulez00_8382;

																		if (PAIRP(BgL_expz00_21))
																			{	/* Ast/sexp.scm 171 */
																				obj_t BgL_cdrzd262164zd2_8387;

																				BgL_cdrzd262164zd2_8387 =
																					CDR(BgL_expz00_21);
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 11))))
																					{	/* Ast/sexp.scm 171 */
																						if (PAIRP(BgL_cdrzd262164zd2_8387))
																							{	/* Ast/sexp.scm 171 */
																								obj_t BgL_carzd262167zd2_8391;
																								obj_t BgL_cdrzd262168zd2_8392;

																								BgL_carzd262167zd2_8391 =
																									CAR(BgL_cdrzd262164zd2_8387);
																								BgL_cdrzd262168zd2_8392 =
																									CDR(BgL_cdrzd262164zd2_8387);
																								if (SYMBOLP
																									(BgL_carzd262167zd2_8391))
																									{	/* Ast/sexp.scm 171 */
																										if (PAIRP
																											(BgL_cdrzd262168zd2_8392))
																											{	/* Ast/sexp.scm 171 */
																												obj_t
																													BgL_carzd262173zd2_8395;
																												BgL_carzd262173zd2_8395
																													=
																													CAR
																													(BgL_cdrzd262168zd2_8392);
																												if (SYMBOLP
																													(BgL_carzd262173zd2_8395))
																													{	/* Ast/sexp.scm 171 */
																														if (NULLP(CDR
																																(BgL_cdrzd262168zd2_8392)))
																															{	/* Ast/sexp.scm 171 */
																																BgL_namez00_8381
																																	=
																																	BgL_carzd262167zd2_8391;
																																BgL_modulez00_8382
																																	=
																																	BgL_carzd262173zd2_8395;
																																{	/* Ast/sexp.scm 173 */
																																	obj_t
																																		BgL_globalz00_8401;
																																	obj_t
																																		BgL_locz00_8402;
																																	BgL_globalz00_8401
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_8381,
																																		BgL_modulez00_8382);
																																	BgL_locz00_8402
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_namez00_8381,
																																		BgL_locz00_8380);
																																	if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_8401, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 176 */
																																			if (
																																				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_globalz00_8401)))->BgL_importz00) == CNST_TABLE_REF(((long) 10))))
																																				{	/* Ast/sexp.scm 179 */
																																					obj_t
																																						BgL_arg6653z00_8406;
																																					{	/* Ast/sexp.scm 179 */
																																						obj_t
																																							BgL_arg6654z00_8407;
																																						BgL_arg6654z00_8407
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BGl_atomz00zzast_nodez00,
																																							BNIL);
																																						BgL_arg6653z00_8406
																																							=
																																							MAKE_YOUNG_PAIR
																																							(CNST_TABLE_REF
																																							(((long) 10)), BgL_arg6654z00_8407);
																																					}
																																					{
																																						obj_t
																																							BgL_locz00_13961;
																																						obj_t
																																							BgL_expz00_13960;
																																						BgL_expz00_13960
																																							=
																																							BgL_arg6653z00_8406;
																																						BgL_locz00_13961
																																							=
																																							BgL_locz00_8402;
																																						BgL_locz00_23
																																							=
																																							BgL_locz00_13961;
																																						BgL_expz00_21
																																							=
																																							BgL_expz00_13960;
																																						goto
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 178 */
																																					return
																																						BGl_variablezd2ze3nodez31zzast_sexpz00
																																						(BgL_globalz00_8401,
																																						BgL_locz00_8402,
																																						BgL_sitez00_24);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 177 */
																																			BgL_nodez00_bglt
																																				BgL_res7311z00_9602;
																																			{	/* Ast/sexp.scm 717 */
																																				obj_t
																																					BgL_arg7100z00_9598;
																																				BgL_nodez00_bglt
																																					BgL_arg7101z00_9599;
																																				BgL_arg7100z00_9598
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BGl_currentzd2functionzd2zztools_errorz00
																																					());
																																				BgL_arg7101z00_9599
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(CNST_TABLE_REF
																																					(((long) 4)), BNIL, BgL_locz00_8402, CNST_TABLE_REF(((long) 2)));
																																				{	/* Ast/sexp.scm 716 */
																																					obj_t
																																						BgL_list7102z00_9601;
																																					BgL_list7102z00_9601
																																						=
																																						MAKE_YOUNG_PAIR
																																						(((obj_t) BgL_arg7101z00_9599), BNIL);
																																					BgL_res7311z00_9602
																																						=
																																						(
																																						(BgL_nodez00_bglt)
																																						BGl_userzd2errorzf2locationz20zztools_errorz00
																																						(BgL_locz00_8402,
																																							BgL_arg7100z00_9598,
																																							BGl_string7986z00zzast_sexpz00,
																																							BgL_expz00_21,
																																							BgL_list7102z00_9601));
																																			}}
																																			return
																																				BgL_res7311z00_9602;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 171 */
																															BgL_tagzd262157zd2_8384:
																																{	/* Ast/sexp.scm 183 */
																																	BgL_nodez00_bglt
																																		BgL_res7312z00_9608;
																																	{	/* Ast/sexp.scm 717 */
																																		obj_t
																																			BgL_arg7100z00_9604;
																																		BgL_nodez00_bglt
																																			BgL_arg7101z00_9605;
																																		BgL_arg7100z00_9604
																																			=
																																			BGl_shapez00zztools_shapez00
																																			(BGl_currentzd2functionzd2zztools_errorz00
																																			());
																																		BgL_arg7101z00_9605
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(CNST_TABLE_REF
																																			(((long)
																																					4)),
																																			BNIL,
																																			BgL_locz00_8380,
																																			CNST_TABLE_REF
																																			(((long)
																																					2)));
																																		{	/* Ast/sexp.scm 716 */
																																			obj_t
																																				BgL_list7102z00_9607;
																																			BgL_list7102z00_9607
																																				=
																																				MAKE_YOUNG_PAIR
																																				(((obj_t) BgL_arg7101z00_9605), BNIL);
																																			BgL_res7312z00_9608
																																				=
																																				(
																																				(BgL_nodez00_bglt)
																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																				(BgL_locz00_8380,
																																					BgL_arg7100z00_9604,
																																					BGl_string7985z00zzast_sexpz00,
																																					BgL_expz00_21,
																																					BgL_list7102z00_9607));
																																	}}
																																	return
																																		BgL_res7312z00_9608;
																																}
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 171 */
																														goto
																															BgL_tagzd262157zd2_8384;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 171 */
																												goto
																													BgL_tagzd262157zd2_8384;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 171 */
																										goto
																											BgL_tagzd262157zd2_8384;
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 171 */
																								goto BgL_tagzd262157zd2_8384;
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 171 */
																						goto BgL_tagzd262157zd2_8384;
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 171 */
																				goto BgL_tagzd262157zd2_8384;
																			}
																	}
																}
															}
														else
															{	/* Ast/sexp.scm 118 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 14))))
																	{	/* Ast/sexp.scm 118 */
																		BgL_lz00_1706 = CDR(BgL_expz00_21);
																	BgL_tagzd2372zd2_1707:
																		{	/* Ast/sexp.scm 186 */
																			bool_t BgL_testz00_13985;

																			if (PAIRP(BgL_lz00_1706))
																				{	/* Ast/sexp.scm 186 */
																					bool_t BgL_testz00_13988;

																					{	/* Ast/sexp.scm 186 */
																						obj_t BgL_tmpz00_13989;

																						BgL_tmpz00_13989 =
																							CDR(BgL_lz00_1706);
																						BgL_testz00_13988 =
																							PAIRP(BgL_tmpz00_13989);
																					}
																					if (BgL_testz00_13988)
																						{
																							obj_t BgL_l1344z00_8426;

																							BgL_l1344z00_8426 = BgL_lz00_1706;
																						BgL_zc3anonymousza36665ze3z83_8427:
																							if (NULLP(BgL_l1344z00_8426))
																								{	/* Ast/sexp.scm 186 */
																									BgL_testz00_13985 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Ast/sexp.scm 186 */
																									bool_t BgL_testz00_13994;

																									{	/* Ast/sexp.scm 186 */
																										obj_t BgL_tmpz00_13995;

																										BgL_tmpz00_13995 =
																											CAR(
																											((obj_t)
																												BgL_l1344z00_8426));
																										BgL_testz00_13994 =
																											SYMBOLP(BgL_tmpz00_13995);
																									}
																									if (BgL_testz00_13994)
																										{
																											obj_t BgL_l1344z00_13999;

																											BgL_l1344z00_13999 =
																												CDR(
																												((obj_t)
																													BgL_l1344z00_8426));
																											BgL_l1344z00_8426 =
																												BgL_l1344z00_13999;
																											goto
																												BgL_zc3anonymousza36665ze3z83_8427;
																										}
																									else
																										{	/* Ast/sexp.scm 186 */
																											BgL_testz00_13985 =
																												((bool_t) 0);
																										}
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 186 */
																							BgL_testz00_13985 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 186 */
																					BgL_testz00_13985 = ((bool_t) 0);
																				}
																			if (BgL_testz00_13985)
																				{	/* Ast/sexp.scm 186 */
																					return
																						BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00
																						(BgL_lz00_1706, BgL_expz00_21,
																						BgL_stackz00_22, BgL_locz00_23,
																						BgL_sitez00_24);
																				}
																			else
																				{	/* Ast/sexp.scm 188 */
																					BgL_nodez00_bglt BgL_res7323z00_9633;

																					{	/* Ast/sexp.scm 717 */
																						obj_t BgL_arg7100z00_9629;
																						BgL_nodez00_bglt
																							BgL_arg7101z00_9630;
																						BgL_arg7100z00_9629 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7101z00_9630 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 716 */
																							obj_t BgL_list7102z00_9632;

																							BgL_list7102z00_9632 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7101z00_9630),
																								BNIL);
																							BgL_res7323z00_9633 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg7100z00_9629,
																									BGl_string7982z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7102z00_9632));
																					}}
																					return BgL_res7323z00_9633;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 118 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 118 */
																			BgL_tagzd2373zd2_1708:
																				{
																					obj_t BgL_valuez00_8435;

																					if (PAIRP(BgL_expz00_21))
																						{	/* Ast/sexp.scm 118 */
																							obj_t BgL_cdrzd262184zd2_8440;

																							BgL_cdrzd262184zd2_8440 =
																								CDR(BgL_expz00_21);
																							if (PAIRP
																								(BgL_cdrzd262184zd2_8440))
																								{	/* Ast/sexp.scm 118 */
																									if (NULLP(CDR
																											(BgL_cdrzd262184zd2_8440)))
																										{	/* Ast/sexp.scm 118 */
																											BgL_valuez00_8435 =
																												CAR
																												(BgL_cdrzd262184zd2_8440);
																											{	/* Ast/sexp.scm 193 */
																												obj_t BgL_locz00_8446;

																												BgL_locz00_8446 =
																													BGl_findzd2locationzf2locz20zztools_locationz00
																													(BgL_expz00_21,
																													BgL_locz00_23);
																												if (NULLP
																													(BgL_valuez00_8435))
																													{	/* Ast/sexp.scm 196 */
																														BgL_literalz00_bglt
																															BgL_new1119z00_8448;
																														{	/* Ast/sexp.scm 197 */
																															BgL_literalz00_bglt
																																BgL_new1118z00_8450;
																															BgL_new1118z00_8450
																																=
																																(
																																(BgL_literalz00_bglt)
																																BOBJECT
																																(GC_MALLOC
																																	(sizeof(struct
																																			BgL_literalz00_bgl))));
																															{	/* Ast/sexp.scm 197 */
																																long
																																	BgL_arg6677z00_8451;
																																{	/* Ast/sexp.scm 197 */
																																	long
																																		BgL_res7325z00_9636;
																																	BgL_res7325z00_9636
																																		=
																																		BGL_CLASS_INDEX
																																		(BGl_literalz00zzast_nodez00);
																																	BgL_arg6677z00_8451
																																		=
																																		BgL_res7325z00_9636;
																																}
																																BGL_OBJECT_CLASS_NUM_SET
																																	(((BgL_objectz00_bglt) BgL_new1118z00_8450), BgL_arg6677z00_8451);
																															}
																															{	/* Ast/sexp.scm 197 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_14032;
																																BgL_tmpz00_14032
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	BgL_new1118z00_8450);
																																BGL_OBJECT_WIDENING_SET
																																	(BgL_tmpz00_14032,
																																	BFALSE);
																															}
																															BgL_new1119z00_8448
																																=
																																BgL_new1118z00_8450;
																														}
																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1119z00_8448)))->BgL_locz00) = ((obj_t) BgL_locz00_8446), BUNSPEC);
																														{
																															BgL_typez00_bglt
																																BgL_auxz00_14037;
																															{	/* Ast/sexp.scm 198 */
																																BgL_typez00_bglt
																																	BgL_arg6676z00_8449;
																																BgL_arg6676z00_8449
																																	=
																																	BGl_getzd2typezd2kwotez00zztype_typeofz00
																																	(BgL_valuez00_8435);
																																BgL_auxz00_14037
																																	=
																																	BGl_strictzd2nodezd2typez00zzast_nodez00
																																	(BgL_arg6676z00_8449,
																																	((BgL_typez00_bglt) BGl_za2bnilza2z00zztype_cachez00));
																															}
																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1119z00_8448)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14037), BUNSPEC);
																														}
																														((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_new1119z00_8448)))->BgL_valuez00) = ((obj_t) BNIL), BUNSPEC);
																														return
																															(
																															(BgL_nodez00_bglt)
																															BgL_new1119z00_8448);
																													}
																												else
																													{	/* Ast/sexp.scm 200 */
																														bool_t
																															BgL_testz00_14046;
																														if (PAIRP
																															(BgL_valuez00_8435))
																															{	/* Ast/sexp.scm 200 */
																																BgL_testz00_14046
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 200 */
																																if (VECTORP
																																	(BgL_valuez00_8435))
																																	{	/* Ast/sexp.scm 201 */
																																		BgL_testz00_14046
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 201 */
																																		if (BGL_HVECTORP(BgL_valuez00_8435))
																																			{	/* Ast/sexp.scm 202 */
																																				BgL_testz00_14046
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 202 */
																																				if (STRUCTP(BgL_valuez00_8435))
																																					{	/* Ast/sexp.scm 203 */
																																						BgL_testz00_14046
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 203 */
																																						if (SYMBOLP(BgL_valuez00_8435))
																																							{	/* Ast/sexp.scm 204 */
																																								BgL_testz00_14046
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 204 */
																																								BgL_testz00_14046
																																									=
																																									KEYWORDP
																																									(BgL_valuez00_8435);
																																							}
																																					}
																																			}
																																	}
																															}
																														if (BgL_testz00_14046)
																															{	/* Ast/sexp.scm 206 */
																																BgL_kwotez00_bglt
																																	BgL_new1121z00_8458;
																																{	/* Ast/sexp.scm 207 */
																																	BgL_kwotez00_bglt
																																		BgL_new1120z00_8460;
																																	BgL_new1120z00_8460
																																		=
																																		(
																																		(BgL_kwotez00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_kwotez00_bgl))));
																																	{	/* Ast/sexp.scm 207 */
																																		long
																																			BgL_arg6685z00_8461;
																																		{	/* Ast/sexp.scm 207 */
																																			long
																																				BgL_res7331z00_9645;
																																			BgL_res7331z00_9645
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_kwotez00zzast_nodez00);
																																			BgL_arg6685z00_8461
																																				=
																																				BgL_res7331z00_9645;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1120z00_8460), BgL_arg6685z00_8461);
																																	}
																																	{	/* Ast/sexp.scm 207 */
																																		BgL_objectz00_bglt
																																			BgL_tmpz00_14062;
																																		BgL_tmpz00_14062
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1120z00_8460);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_tmpz00_14062,
																																			BFALSE);
																																	}
																																	BgL_new1121z00_8458
																																		=
																																		BgL_new1120z00_8460;
																																}
																																((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1121z00_8458)))->BgL_locz00) = ((obj_t) BgL_locz00_8446), BUNSPEC);
																																{
																																	BgL_typez00_bglt
																																		BgL_auxz00_14067;
																																	{	/* Ast/sexp.scm 208 */
																																		BgL_typez00_bglt
																																			BgL_arg6684z00_8459;
																																		BgL_arg6684z00_8459
																																			=
																																			BGl_getzd2typezd2kwotez00zztype_typeofz00
																																			(BgL_valuez00_8435);
																																		BgL_auxz00_14067
																																			=
																																			BGl_strictzd2nodezd2typez00zzast_nodez00
																																			(BgL_arg6684z00_8459,
																																			((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00));
																																	}
																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1121z00_8458)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14067), BUNSPEC);
																																}
																																((((BgL_kwotez00_bglt) COBJECT(BgL_new1121z00_8458))->BgL_valuez00) = ((obj_t) BgL_valuez00_8435), BUNSPEC);
																																return
																																	(
																																	(BgL_nodez00_bglt)
																																	BgL_new1121z00_8458);
																															}
																														else
																															{	/* Ast/sexp.scm 210 */
																																bool_t
																																	BgL_testz00_14075;
																																if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_8435))
																																	{	/* Ast/sexp.scm 210 */
																																		BgL_testz00_14075
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 210 */
																																		if (STRINGP
																																			(BgL_valuez00_8435))
																																			{	/* Ast/sexp.scm 211 */
																																				BgL_testz00_14075
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 211 */
																																				if (CNSTP(BgL_valuez00_8435))
																																					{	/* Ast/sexp.scm 212 */
																																						BgL_testz00_14075
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 212 */
																																						if (CHARP(BgL_valuez00_8435))
																																							{	/* Ast/sexp.scm 216 */
																																								BgL_testz00_14075
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 216 */
																																								BgL_testz00_14075
																																									=
																																									BOOLEANP
																																									(BgL_valuez00_8435);
																																							}
																																					}
																																			}
																																	}
																																if (BgL_testz00_14075)
																																	{
																																		obj_t
																																			BgL_locz00_14086;
																																		obj_t
																																			BgL_expz00_14085;
																																		BgL_expz00_14085
																																			=
																																			BgL_valuez00_8435;
																																		BgL_locz00_14086
																																			=
																																			BgL_locz00_8446;
																																		BgL_locz00_23
																																			=
																																			BgL_locz00_14086;
																																		BgL_expz00_21
																																			=
																																			BgL_expz00_14085;
																																		goto
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																	}
																																else
																																	{	/* Ast/sexp.scm 220 */
																																		BgL_nodez00_bglt
																																			BgL_res7336z00_9657;
																																		{	/* Ast/sexp.scm 717 */
																																			obj_t
																																				BgL_arg7100z00_9653;
																																			BgL_nodez00_bglt
																																				BgL_arg7101z00_9654;
																																			BgL_arg7100z00_9653
																																				=
																																				BGl_shapez00zztools_shapez00
																																				(BGl_currentzd2functionzd2zztools_errorz00
																																				());
																																			BgL_arg7101z00_9654
																																				=
																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																				(CNST_TABLE_REF
																																				(((long)
																																						4)),
																																				BNIL,
																																				BgL_locz00_8446,
																																				CNST_TABLE_REF
																																				(((long)
																																						2)));
																																			{	/* Ast/sexp.scm 716 */
																																				obj_t
																																					BgL_list7102z00_9656;
																																				BgL_list7102z00_9656
																																					=
																																					MAKE_YOUNG_PAIR
																																					(((obj_t) BgL_arg7101z00_9654), BNIL);
																																				BgL_res7336z00_9657
																																					=
																																					(
																																					(BgL_nodez00_bglt)
																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																					(BgL_locz00_8446,
																																						BgL_arg7100z00_9653,
																																						BGl_string7984z00zzast_sexpz00,
																																						BgL_expz00_21,
																																						BgL_list7102z00_9656));
																																		}}
																																		return
																																			BgL_res7336z00_9657;
																																	}
																															}
																													}
																											}
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																										BgL_tagzd262179zd2_8437:
																											{	/* Ast/sexp.scm 222 */
																												BgL_nodez00_bglt
																													BgL_res7337z00_9663;
																												{	/* Ast/sexp.scm 717 */
																													obj_t
																														BgL_arg7100z00_9659;
																													BgL_nodez00_bglt
																														BgL_arg7101z00_9660;
																													BgL_arg7100z00_9659 =
																														BGl_shapez00zztools_shapez00
																														(BGl_currentzd2functionzd2zztools_errorz00
																														());
																													BgL_arg7101z00_9660 =
																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																														(CNST_TABLE_REF((
																																(long) 4)),
																														BNIL, BgL_locz00_23,
																														CNST_TABLE_REF((
																																(long) 2)));
																													{	/* Ast/sexp.scm 716 */
																														obj_t
																															BgL_list7102z00_9662;
																														BgL_list7102z00_9662
																															=
																															MAKE_YOUNG_PAIR((
																																(obj_t)
																																BgL_arg7101z00_9660),
																															BNIL);
																														BgL_res7337z00_9663
																															=
																															(
																															(BgL_nodez00_bglt)
																															BGl_userzd2errorzf2locationz20zztools_errorz00
																															(BgL_locz00_23,
																																BgL_arg7100z00_9659,
																																BGl_string7984z00zzast_sexpz00,
																																BgL_expz00_21,
																																BgL_list7102z00_9662));
																												}}
																												return
																													BgL_res7337z00_9663;
																											}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									goto BgL_tagzd262179zd2_8437;
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 118 */
																							goto BgL_tagzd262179zd2_8437;
																						}
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 118 */
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 15))))
																					{	/* Ast/sexp.scm 118 */
																						if (NULLP(CDR(BgL_expz00_21)))
																							{	/* Ast/sexp.scm 118 */
																							BgL_tagzd2374zd2_1709:
																								{
																									obj_t BgL_locz00_14114;
																									obj_t BgL_expz00_14113;

																									BgL_expz00_14113 = BUNSPEC;
																									BgL_locz00_14114 =
																										BGl_findzd2locationzf2locz20zztools_locationz00
																										(BgL_expz00_21,
																										BgL_locz00_23);
																									BgL_locz00_23 =
																										BgL_locz00_14114;
																									BgL_expz00_21 =
																										BgL_expz00_14113;
																									goto
																										BGl_sexpzd2ze3nodez31zzast_sexpz00;
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 118 */
																								obj_t BgL_arg1585z00_1797;

																								BgL_arg1585z00_1797 =
																									CDR(BgL_expz00_21);
																								{
																									BgL_sequencez00_bglt
																										BgL_auxz00_14117;
																									BgL_bodyz00_1710 =
																										BgL_arg1585z00_1797;
																								BgL_tagzd2375zd2_1711:
																									{	/* Ast/sexp.scm 227 */
																										obj_t BgL_locz00_8477;

																										BgL_locz00_8477 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_21,
																											BgL_locz00_23);
																										{	/* Ast/sexp.scm 227 */
																											obj_t BgL_nodesz00_8478;

																											BgL_nodesz00_8478 =
																												BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																												(BgL_bodyz00_1710,
																												BgL_stackz00_22,
																												BgL_locz00_8477,
																												BgL_sitez00_24);
																											{	/* Ast/sexp.scm 228 */

																												{	/* Ast/sexp.scm 229 */
																													BgL_sequencez00_bglt
																														BgL_new1124z00_8479;
																													{	/* Ast/sexp.scm 230 */
																														BgL_sequencez00_bglt
																															BgL_new1122z00_8480;
																														BgL_new1122z00_8480
																															=
																															(
																															(BgL_sequencez00_bglt)
																															BOBJECT(GC_MALLOC
																																(sizeof(struct
																																		BgL_sequencez00_bgl))));
																														{	/* Ast/sexp.scm 230 */
																															long
																																BgL_arg6692z00_8481;
																															{	/* Ast/sexp.scm 230 */
																																long
																																	BgL_res7341z00_9671;
																																BgL_res7341z00_9671
																																	=
																																	BGL_CLASS_INDEX
																																	(BGl_sequencez00zzast_nodez00);
																																BgL_arg6692z00_8481
																																	=
																																	BgL_res7341z00_9671;
																															}
																															BGL_OBJECT_CLASS_NUM_SET
																																(((BgL_objectz00_bglt) BgL_new1122z00_8480), BgL_arg6692z00_8481);
																														}
																														{	/* Ast/sexp.scm 230 */
																															BgL_objectz00_bglt
																																BgL_tmpz00_14124;
																															BgL_tmpz00_14124 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1122z00_8480);
																															BGL_OBJECT_WIDENING_SET
																																(BgL_tmpz00_14124,
																																BFALSE);
																														}
																														BgL_new1124z00_8479
																															=
																															BgL_new1122z00_8480;
																													}
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1124z00_8479)))->
																															BgL_locz00) =
																														((obj_t)
																															BgL_locz00_8477),
																														BUNSPEC);
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1124z00_8479)))->
																															BgL_typez00) =
																														((BgL_typez00_bglt)
																															((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1124z00_8479)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1124z00_8479)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1124z00_8479))->BgL_nodesz00) = ((obj_t) BgL_nodesz00_8478), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1124z00_8479))->BgL_unsafez00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1124z00_8479))->BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																													BgL_auxz00_14117 =
																														BgL_new1124z00_8479;
																									}}}}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14117);
																								}
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 118 */
																						obj_t BgL_carzd2610zd2_1799;
																						obj_t BgL_cdrzd2611zd2_1800;

																						BgL_carzd2610zd2_1799 =
																							CAR(BgL_expz00_21);
																						BgL_cdrzd2611zd2_1800 =
																							CDR(BgL_expz00_21);
																						{

																							if (
																								(BgL_carzd2610zd2_1799 ==
																									CNST_TABLE_REF(((long) 1))))
																								{
																									obj_t BgL_auxz00_14146;

																								BgL_kapzd2612zd2_1801:
																									if (PAIRP
																										(BgL_cdrzd2611zd2_1800))
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_cdrzd2615zd2_2548;
																											BgL_cdrzd2615zd2_2548 =
																												CDR
																												(BgL_cdrzd2611zd2_1800);
																											if (PAIRP
																												(BgL_cdrzd2615zd2_2548))
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_cdrzd2618zd2_2550;
																													BgL_cdrzd2618zd2_2550
																														=
																														CDR
																														(BgL_cdrzd2615zd2_2548);
																													if ((CAR
																															(BgL_cdrzd2615zd2_2548)
																															== BTRUE))
																														{	/* Ast/sexp.scm 118 */
																															if (PAIRP
																																(BgL_cdrzd2618zd2_2550))
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR
																																			(BgL_cdrzd2618zd2_2550)
																																			==
																																			BFALSE))
																																		{	/* Ast/sexp.scm 118 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd2618zd2_2550)))
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_sitez00_24
																																							==
																																							CNST_TABLE_REF
																																							(((long) 8))))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_arg2248z00_2560;
																																							BgL_arg2248z00_2560
																																								=
																																								CAR
																																								(BgL_cdrzd2611zd2_1800);
																																							BgL_auxz00_14146
																																								=
																																								(
																																								(obj_t)
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg2248z00_2560,
																																									BgL_stackz00_22,
																																									BgL_locz00_23,
																																									BgL_sitez00_24));
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd2637zd2_2561;
																																							BgL_carzd2637zd2_2561
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd2637zd2_2561 == CNST_TABLE_REF(((long) 1))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_14175;
																																								BgL_tagzd2377zd2_1714:
																																									{
																																										obj_t
																																											BgL_siz00_8482;
																																										obj_t
																																											BgL_alorsz00_8483;
																																										obj_t
																																											BgL_sinonz00_8484;
																																										obj_t
																																											BgL_siz00_8486;
																																										obj_t
																																											BgL_alorsz00_8487;
																																										if (PAIRP(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd262200zd2_8492;
																																												BgL_cdrzd262200zd2_8492
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												if (PAIRP(BgL_cdrzd262200zd2_8492))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd262205zd2_8494;
																																														BgL_cdrzd262205zd2_8494
																																															=
																																															CDR
																																															(BgL_cdrzd262200zd2_8492);
																																														if (PAIRP(BgL_cdrzd262205zd2_8494))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd262210zd2_8496;
																																																BgL_cdrzd262210zd2_8496
																																																	=
																																																	CDR
																																																	(BgL_cdrzd262205zd2_8494);
																																																if (PAIRP(BgL_cdrzd262210zd2_8496))
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (NULLP(CDR(BgL_cdrzd262210zd2_8496)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				BgL_siz00_8482
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262200zd2_8492);
																																																				BgL_alorsz00_8483
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262205zd2_8494);
																																																				BgL_sinonz00_8484
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262210zd2_8496);
																																																				{	/* Ast/sexp.scm 240 */
																																																					obj_t
																																																						BgL_ntz00_8511;
																																																					BgL_ntz00_8511
																																																						=
																																																						BGl_notzd2testzd2zzast_sexpz00
																																																						(BgL_siz00_8482);
																																																					if (CBOOL(BgL_ntz00_8511))
																																																						{	/* Ast/sexp.scm 241 */
																																																							{	/* Ast/sexp.scm 243 */
																																																								obj_t
																																																									BgL_arg6708z00_8512;
																																																								BgL_arg6708z00_8512
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 243 */
																																																									obj_t
																																																										BgL_tmpz00_14195;
																																																									BgL_tmpz00_14195
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6708z00_8512);
																																																									SET_CAR
																																																										(BgL_tmpz00_14195,
																																																										BgL_ntz00_8511);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 244 */
																																																								obj_t
																																																									BgL_arg6709z00_8513;
																																																								{	/* Ast/sexp.scm 244 */
																																																									obj_t
																																																										BgL_pairz00_9679;
																																																									BgL_pairz00_9679
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_arg6709z00_8513
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9679);
																																																								}
																																																								{	/* Ast/sexp.scm 244 */
																																																									obj_t
																																																										BgL_tmpz00_14201;
																																																									BgL_tmpz00_14201
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6709z00_8513);
																																																									SET_CAR
																																																										(BgL_tmpz00_14201,
																																																										BgL_sinonz00_8484);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 245 */
																																																								obj_t
																																																									BgL_arg6710z00_8514;
																																																								{	/* Ast/sexp.scm 245 */
																																																									obj_t
																																																										BgL_pairz00_9686;
																																																									{	/* Ast/sexp.scm 245 */
																																																										obj_t
																																																											BgL_pairz00_9685;
																																																										BgL_pairz00_9685
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_pairz00_9686
																																																											=
																																																											CDR
																																																											(BgL_pairz00_9685);
																																																									}
																																																									BgL_arg6710z00_8514
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9686);
																																																								}
																																																								{	/* Ast/sexp.scm 245 */
																																																									obj_t
																																																										BgL_tmpz00_14208;
																																																									BgL_tmpz00_14208
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6710z00_8514);
																																																									SET_CAR
																																																										(BgL_tmpz00_14208,
																																																										BgL_alorsz00_8483);
																																																								}
																																																							}
																																																							BgL_auxz00_14175
																																																								=
																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																								(BgL_expz00_21,
																																																								BgL_stackz00_22,
																																																								BgL_locz00_23,
																																																								BgL_sitez00_24);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 247 */
																																																							obj_t
																																																								BgL_locz00_8515;
																																																							BgL_locz00_8515
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 247 */
																																																								obj_t
																																																									BgL_cdlocz00_8516;
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_arg6730z00_8550;
																																																									BgL_arg6730z00_8550
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8516
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6730z00_8550,
																																																										BgL_locz00_8515);
																																																								}
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_cddlocz00_8517;
																																																									{	/* Ast/sexp.scm 249 */
																																																										obj_t
																																																											BgL_arg6729z00_8549;
																																																										{	/* Ast/sexp.scm 249 */
																																																											obj_t
																																																												BgL_pairz00_9692;
																																																											BgL_pairz00_9692
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6729z00_8549
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9692);
																																																										}
																																																										BgL_cddlocz00_8517
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6729z00_8549,
																																																											BgL_locz00_8515);
																																																									}
																																																									{	/* Ast/sexp.scm 249 */
																																																										obj_t
																																																											BgL_cdddlocz00_8518;
																																																										{	/* Ast/sexp.scm 250 */
																																																											obj_t
																																																												BgL_arg6728z00_8548;
																																																											{	/* Ast/sexp.scm 250 */
																																																												obj_t
																																																													BgL_pairz00_9698;
																																																												{	/* Ast/sexp.scm 250 */
																																																													obj_t
																																																														BgL_pairz00_9697;
																																																													BgL_pairz00_9697
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_pairz00_9698
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9697);
																																																												}
																																																												BgL_arg6728z00_8548
																																																													=
																																																													CDR
																																																													(BgL_pairz00_9698);
																																																											}
																																																											BgL_cdddlocz00_8518
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6728z00_8548,
																																																												BgL_locz00_8515);
																																																										}
																																																										{	/* Ast/sexp.scm 250 */
																																																											obj_t
																																																												BgL_lzd2sizd2_8519;
																																																											BgL_lzd2sizd2_8519
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_siz00_8482,
																																																												BgL_cdlocz00_8516);
																																																											{	/* Ast/sexp.scm 251 */
																																																												obj_t
																																																													BgL_lzd2alorszd2_8520;
																																																												BgL_lzd2alorszd2_8520
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_alorsz00_8483,
																																																													BgL_cddlocz00_8517);
																																																												{	/* Ast/sexp.scm 252 */
																																																													obj_t
																																																														BgL_lzd2sinonzd2_8521;
																																																													BgL_lzd2sinonzd2_8521
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_sinonz00_8484,
																																																														BgL_cdddlocz00_8518);
																																																													{	/* Ast/sexp.scm 253 */
																																																														BgL_nodez00_bglt
																																																															BgL_testz00_8522;
																																																														BgL_testz00_8522
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_siz00_8482,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_8515,
																																																															CNST_TABLE_REF
																																																															(((long) 8)));
																																																														{	/* Ast/sexp.scm 254 */

																																																															{	/* Ast/sexp.scm 256 */
																																																																bool_t
																																																																	BgL_testz00_14230;
																																																																{	/* Ast/sexp.scm 256 */
																																																																	bool_t
																																																																		BgL_res7342z00_9699;
																																																																	BgL_res7342z00_9699
																																																																		=
																																																																		BGl_isazf3zf3zz__objectz00
																																																																		(
																																																																		((obj_t) BgL_testz00_8522), BGl_atomz00zzast_nodez00);
																																																																	BgL_testz00_14230
																																																																		=
																																																																		BgL_res7342z00_9699;
																																																																}
																																																																if (BgL_testz00_14230)
																																																																	{	/* Ast/sexp.scm 256 */
																																																																		if (CBOOL((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_testz00_8522)))->BgL_valuez00)))
																																																																			{	/* Ast/sexp.scm 258 */
																																																																				BgL_auxz00_14175
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8483,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8520,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 258 */
																																																																				BgL_auxz00_14175
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_sinonz00_8484,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2sinonzd2_8521,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 261 */
																																																																		bool_t
																																																																			BgL_testz00_14241;
																																																																		{	/* Ast/sexp.scm 261 */
																																																																			bool_t
																																																																				BgL_res7343z00_9700;
																																																																			BgL_res7343z00_9700
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_testz00_8522), BGl_kwotez00zzast_nodez00);
																																																																			BgL_testz00_14241
																																																																				=
																																																																				BgL_res7343z00_9700;
																																																																		}
																																																																		if (BgL_testz00_14241)
																																																																			{	/* Ast/sexp.scm 261 */
																																																																				BgL_auxz00_14175
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8483,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8520,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 263 */
																																																																				bool_t
																																																																					BgL_testz00_14246;
																																																																				{	/* Ast/sexp.scm 263 */
																																																																					bool_t
																																																																						BgL_res7344z00_9701;
																																																																					BgL_res7344z00_9701
																																																																						=
																																																																						BGl_isazf3zf3zz__objectz00
																																																																						(
																																																																						((obj_t) BgL_testz00_8522), BGl_varz00zzast_nodez00);
																																																																					BgL_testz00_14246
																																																																						=
																																																																						BgL_res7344z00_9701;
																																																																				}
																																																																				if (BgL_testz00_14246)
																																																																					{	/* Ast/sexp.scm 264 */
																																																																						BgL_nodez00_bglt
																																																																							BgL_alorsz00_8528;
																																																																						BgL_nodez00_bglt
																																																																							BgL_sinonz00_8529;
																																																																						BgL_alorsz00_8528
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_alorsz00_8483,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2alorszd2_8520,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						BgL_sinonz00_8529
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_sinonz00_8484,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2sinonzd2_8521,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						{	/* Ast/sexp.scm 266 */
																																																																							BgL_conditionalz00_bglt
																																																																								BgL_new1128z00_8530;
																																																																							{	/* Ast/sexp.scm 267 */
																																																																								BgL_conditionalz00_bglt
																																																																									BgL_new1126z00_8531;
																																																																								BgL_new1126z00_8531
																																																																									=
																																																																									(
																																																																									(BgL_conditionalz00_bglt)
																																																																									BOBJECT
																																																																									(GC_MALLOC
																																																																										(sizeof
																																																																											(struct
																																																																												BgL_conditionalz00_bgl))));
																																																																								{	/* Ast/sexp.scm 267 */
																																																																									long
																																																																										BgL_arg6715z00_8532;
																																																																									{	/* Ast/sexp.scm 267 */
																																																																										long
																																																																											BgL_res7345z00_9703;
																																																																										BgL_res7345z00_9703
																																																																											=
																																																																											BGL_CLASS_INDEX
																																																																											(BGl_conditionalz00zzast_nodez00);
																																																																										BgL_arg6715z00_8532
																																																																											=
																																																																											BgL_res7345z00_9703;
																																																																									}
																																																																									BGL_OBJECT_CLASS_NUM_SET
																																																																										(
																																																																										((BgL_objectz00_bglt) BgL_new1126z00_8531), BgL_arg6715z00_8532);
																																																																								}
																																																																								{	/* Ast/sexp.scm 267 */
																																																																									BgL_objectz00_bglt
																																																																										BgL_tmpz00_14257;
																																																																									BgL_tmpz00_14257
																																																																										=
																																																																										(
																																																																										(BgL_objectz00_bglt)
																																																																										BgL_new1126z00_8531);
																																																																									BGL_OBJECT_WIDENING_SET
																																																																										(BgL_tmpz00_14257,
																																																																										BFALSE);
																																																																								}
																																																																								BgL_new1128z00_8530
																																																																									=
																																																																									BgL_new1126z00_8531;
																																																																							}
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1128z00_8530)))->BgL_locz00) = ((obj_t) BgL_locz00_8515), BUNSPEC);
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1128z00_8530)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1128z00_8530)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1128z00_8530)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1128z00_8530))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8522), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1128z00_8530))->BgL_truez00) = ((BgL_nodez00_bglt) BgL_alorsz00_8528), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1128z00_8530))->BgL_falsez00) = ((BgL_nodez00_bglt) BgL_sinonz00_8529), BUNSPEC);
																																																																							BgL_auxz00_14175
																																																																								=
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_new1128z00_8530);
																																																																					}}
																																																																				else
																																																																					{	/* Ast/sexp.scm 273 */
																																																																						obj_t
																																																																							BgL_vz00_8533;
																																																																						BgL_vz00_8533
																																																																							=
																																																																							BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																																							(BGl_gensymz00zz__r4_symbols_6_4z00
																																																																							(CNST_TABLE_REF
																																																																								(((long) 8))));
																																																																						{	/* Ast/sexp.scm 273 */
																																																																							obj_t
																																																																								BgL_varz00_8534;
																																																																							BgL_varz00_8534
																																																																								=
																																																																								BGl_makezd2typedzd2identz00zzast_identz00
																																																																								(BgL_vz00_8533,
																																																																								CNST_TABLE_REF
																																																																								(((long) 9)));
																																																																							{	/* Ast/sexp.scm 274 */
																																																																								obj_t
																																																																									BgL_nexpz00_8535;
																																																																								{	/* Ast/sexp.scm 275 */
																																																																									obj_t
																																																																										BgL_arg6723z00_8543;
																																																																									{	/* Ast/sexp.scm 275 */
																																																																										obj_t
																																																																											BgL_arg6724z00_8544;
																																																																										{	/* Ast/sexp.scm 275 */
																																																																											obj_t
																																																																												BgL_arg6725z00_8545;
																																																																											{	/* Ast/sexp.scm 275 */
																																																																												obj_t
																																																																													BgL_arg6726z00_8546;
																																																																												BgL_arg6726z00_8546
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_sinonz00_8484,
																																																																													BNIL);
																																																																												BgL_arg6725z00_8545
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_alorsz00_8483,
																																																																													BgL_arg6726z00_8546);
																																																																											}
																																																																											BgL_arg6724z00_8544
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_vz00_8533,
																																																																												BgL_arg6725z00_8545);
																																																																										}
																																																																										BgL_arg6723z00_8543
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(CNST_TABLE_REF
																																																																											(((long) 1)), BgL_arg6724z00_8544);
																																																																									}
																																																																									BgL_nexpz00_8535
																																																																										=
																																																																										BGl_epairifyzd2reczd2zztools_miscz00
																																																																										(BgL_arg6723z00_8543,
																																																																										BgL_expz00_21);
																																																																								}
																																																																								{	/* Ast/sexp.scm 275 */

																																																																									{	/* Ast/sexp.scm 276 */
																																																																										obj_t
																																																																											BgL_arg6716z00_8536;
																																																																										{	/* Ast/sexp.scm 276 */
																																																																											obj_t
																																																																												BgL_arg6717z00_8537;
																																																																											obj_t
																																																																												BgL_arg6718z00_8538;
																																																																											BgL_arg6717z00_8537
																																																																												=
																																																																												BGl_letzd2symzd2zzast_letz00
																																																																												();
																																																																											{	/* Ast/sexp.scm 276 */
																																																																												obj_t
																																																																													BgL_arg6719z00_8539;
																																																																												obj_t
																																																																													BgL_arg6720z00_8540;
																																																																												{	/* Ast/sexp.scm 276 */
																																																																													obj_t
																																																																														BgL_arg6721z00_8541;
																																																																													{	/* Ast/sexp.scm 276 */
																																																																														obj_t
																																																																															BgL_arg6722z00_8542;
																																																																														BgL_arg6722z00_8542
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_siz00_8482,
																																																																															BNIL);
																																																																														BgL_arg6721z00_8541
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_varz00_8534,
																																																																															BgL_arg6722z00_8542);
																																																																													}
																																																																													BgL_arg6719z00_8539
																																																																														=
																																																																														MAKE_YOUNG_PAIR
																																																																														(BgL_arg6721z00_8541,
																																																																														BNIL);
																																																																												}
																																																																												BgL_arg6720z00_8540
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_nexpz00_8535,
																																																																													BNIL);
																																																																												BgL_arg6718z00_8538
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_arg6719z00_8539,
																																																																													BgL_arg6720z00_8540);
																																																																											}
																																																																											BgL_arg6716z00_8536
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_arg6717z00_8537,
																																																																												BgL_arg6718z00_8538);
																																																																										}
																																																																										BGl_replacez12z12zztools_miscz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg6716z00_8536);
																																																																									}
																																																																									BgL_auxz00_14175
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(BgL_expz00_21,
																																																																										BgL_stackz00_22,
																																																																										BgL_locz00_8515,
																																																																										BgL_sitez00_24);
																																																			}}}}}}}}}}}}}}}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																			BgL_tagzd262191zd2_8489:
																																																				{	/* Ast/sexp.scm 282 */
																																																					BgL_nodez00_bglt
																																																						BgL_res7347z00_9717;
																																																					{	/* Ast/sexp.scm 717 */
																																																						obj_t
																																																							BgL_arg7100z00_9713;
																																																						BgL_nodez00_bglt
																																																							BgL_arg7101z00_9714;
																																																						BgL_arg7100z00_9713
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg7101z00_9714
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(CNST_TABLE_REF
																																																							(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																						{	/* Ast/sexp.scm 716 */
																																																							obj_t
																																																								BgL_list7102z00_9716;
																																																							BgL_list7102z00_9716
																																																								=
																																																								MAKE_YOUNG_PAIR
																																																								(
																																																								((obj_t) BgL_arg7101z00_9714), BNIL);
																																																							BgL_res7347z00_9717
																																																								=
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																								(BgL_locz00_23,
																																																									BgL_arg7100z00_9713,
																																																									BGl_string7983z00zzast_sexpz00,
																																																									BgL_expz00_21,
																																																									BgL_list7102z00_9716));
																																																					}}
																																																					BgL_auxz00_14175
																																																						=
																																																						BgL_res7347z00_9717;
																																																	}}}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd262235zd2_8505;
																																																		BgL_cdrzd262235zd2_8505
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd262200zd2_8492));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd262235zd2_8505))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6705z00_8508;
																																																				obj_t
																																																					BgL_arg6706z00_8509;
																																																				BgL_arg6705z00_8508
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262200zd2_8492));
																																																				BgL_arg6706z00_8509
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262235zd2_8505));
																																																				BgL_siz00_8486
																																																					=
																																																					BgL_arg6705z00_8508;
																																																				BgL_alorsz00_8487
																																																					=
																																																					BgL_arg6706z00_8509;
																																																				{	/* Ast/sexp.scm 279 */
																																																					obj_t
																																																						BgL_arg6731z00_8551;
																																																					obj_t
																																																						BgL_arg6732z00_8552;
																																																					{	/* Ast/sexp.scm 279 */
																																																						obj_t
																																																							BgL_pairz00_9709;
																																																						BgL_pairz00_9709
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_arg6731z00_8551
																																																							=
																																																							CDR
																																																							(BgL_pairz00_9709);
																																																					}
																																																					{	/* Ast/sexp.scm 279 */
																																																						obj_t
																																																							BgL_list6733z00_8553;
																																																						BgL_list6733z00_8553
																																																							=
																																																							MAKE_YOUNG_PAIR
																																																							(BUNSPEC,
																																																							BNIL);
																																																						BgL_arg6732z00_8552
																																																							=
																																																							BgL_list6733z00_8553;
																																																					}
																																																					{	/* Ast/sexp.scm 279 */
																																																						obj_t
																																																							BgL_tmpz00_14320;
																																																						BgL_tmpz00_14320
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_arg6731z00_8551);
																																																						SET_CDR
																																																							(BgL_tmpz00_14320,
																																																							BgL_arg6732z00_8552);
																																																					}
																																																				}
																																																				BgL_auxz00_14175
																																																					=
																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																					(BgL_expz00_21,
																																																					BgL_stackz00_22,
																																																					BgL_locz00_23,
																																																					BgL_sitez00_24);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_tagzd262191zd2_8489;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd262191zd2_8489;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_tagzd262191zd2_8489;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_tagzd262191zd2_8489;
																																											}
																																									}
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_14175);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd2637zd2_2561 == BGl_za2ifza2z00zzast_sexpz00))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_14327;
																																											goto
																																												BgL_tagzd2377zd2_1714;
																																											BgL_auxz00_14146
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_14327);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_14334;
																																												BgL_tagzd2379zd2_1718:
																																													{
																																														obj_t
																																															BgL_varz00_8580;
																																														obj_t
																																															BgL_valz00_8581;
																																														if (PAIRP(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd262265zd2_8586;
																																																BgL_cdrzd262265zd2_8586
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																if (PAIRP(BgL_cdrzd262265zd2_8586))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd262269zd2_8588;
																																																		BgL_cdrzd262269zd2_8588
																																																			=
																																																			CDR
																																																			(BgL_cdrzd262265zd2_8586);
																																																		if (PAIRP(BgL_cdrzd262269zd2_8588))
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (NULLP(CDR(BgL_cdrzd262269zd2_8588)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						BgL_varz00_8580
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262265zd2_8586);
																																																						BgL_valz00_8581
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262269zd2_8588);
																																																						{	/* Ast/sexp.scm 291 */
																																																							obj_t
																																																								BgL_locz00_8595;
																																																							BgL_locz00_8595
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 291 */
																																																								obj_t
																																																									BgL_cdlocz00_8596;
																																																								{	/* Ast/sexp.scm 292 */
																																																									obj_t
																																																										BgL_arg6765z00_8615;
																																																									BgL_arg6765z00_8615
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8596
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6765z00_8615,
																																																										BgL_locz00_8595);
																																																								}
																																																								{	/* Ast/sexp.scm 292 */
																																																									obj_t
																																																										BgL_cddlocz00_8597;
																																																									{	/* Ast/sexp.scm 293 */
																																																										obj_t
																																																											BgL_arg6764z00_8614;
																																																										{	/* Ast/sexp.scm 293 */
																																																											obj_t
																																																												BgL_pairz00_9753;
																																																											BgL_pairz00_9753
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6764z00_8614
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9753);
																																																										}
																																																										BgL_cddlocz00_8597
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6764z00_8614,
																																																											BgL_locz00_8595);
																																																									}
																																																									{	/* Ast/sexp.scm 293 */
																																																										obj_t
																																																											BgL_valzd2loczd2_8598;
																																																										BgL_valzd2loczd2_8598
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_valz00_8581,
																																																											BgL_cddlocz00_8597);
																																																										{	/* Ast/sexp.scm 294 */
																																																											BgL_nodez00_bglt
																																																												BgL_valz00_8599;
																																																											BgL_valz00_8599
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(BgL_valz00_8581,
																																																												BgL_stackz00_22,
																																																												BgL_valzd2loczd2_8598,
																																																												CNST_TABLE_REF
																																																												(((long) 2)));
																																																											{	/* Ast/sexp.scm 295 */

																																																												{	/* Ast/sexp.scm 296 */
																																																													BgL_nodez00_bglt
																																																														BgL_astz00_8600;
																																																													BgL_astz00_8600
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_varz00_8580,
																																																														BgL_stackz00_22,
																																																														BgL_cdlocz00_8596,
																																																														CNST_TABLE_REF
																																																														(((long) 7)));
																																																													{	/* Ast/sexp.scm 297 */
																																																														bool_t
																																																															BgL_testz00_14359;
																																																														{	/* Ast/sexp.scm 297 */
																																																															bool_t
																																																																BgL_res7359z00_9754;
																																																															BgL_res7359z00_9754
																																																																=
																																																																BGl_isazf3zf3zz__objectz00
																																																																(
																																																																((obj_t) BgL_astz00_8600), BGl_varz00zzast_nodez00);
																																																															BgL_testz00_14359
																																																																=
																																																																BgL_res7359z00_9754;
																																																														}
																																																														if (BgL_testz00_14359)
																																																															{	/* Ast/sexp.scm 299 */
																																																																bool_t
																																																																	BgL_testz00_14362;
																																																																{	/* Ast/sexp.scm 299 */
																																																																	bool_t
																																																																		BgL_testz00_14363;
																																																																	{	/* Ast/sexp.scm 299 */
																																																																		BgL_variablez00_bglt
																																																																			BgL_arg6763z00_8613;
																																																																		BgL_arg6763z00_8613
																																																																			=
																																																																			(
																																																																			((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8600)))->BgL_variablez00);
																																																																		{	/* Ast/sexp.scm 299 */
																																																																			bool_t
																																																																				BgL_res7360z00_9755;
																																																																			BgL_res7360z00_9755
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_arg6763z00_8613), BGl_globalz00zzast_varz00);
																																																																			BgL_testz00_14363
																																																																				=
																																																																				BgL_res7360z00_9755;
																																																																		}
																																																																	}
																																																																	if (BgL_testz00_14363)
																																																																		{	/* Ast/sexp.scm 300 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6762z00_8612;
																																																																			BgL_arg6762z00_8612
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8600)))->BgL_variablez00);
																																																																			BgL_testz00_14362
																																																																				=
																																																																				BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																																				(
																																																																				((BgL_globalz00_bglt) BgL_arg6762z00_8612));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 299 */
																																																																			BgL_testz00_14362
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_testz00_14362)
																																																																	{	/* Ast/sexp.scm 301 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7361z00_9761;
																																																																		{	/* Ast/sexp.scm 717 */
																																																																			obj_t
																																																																				BgL_arg7100z00_9757;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7101z00_9758;
																																																																			BgL_arg7100z00_9757
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7101z00_9758
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_cdlocz00_8596, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 716 */
																																																																				obj_t
																																																																					BgL_list7102z00_9760;
																																																																				BgL_list7102z00_9760
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7101z00_9758), BNIL);
																																																																				BgL_res7361z00_9761
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_cdlocz00_8596,
																																																																						BgL_arg7100z00_9757,
																																																																						BGl_string7980z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7102z00_9760));
																																																																		}}
																																																																		BgL_auxz00_14334
																																																																			=
																																																																			BgL_res7361z00_9761;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 303 */
																																																																		BgL_setqz00_bglt
																																																																			BgL_new1132z00_8608;
																																																																		{	/* Ast/sexp.scm 304 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1130z00_8609;
																																																																			BgL_new1130z00_8609
																																																																				=
																																																																				(
																																																																				(BgL_setqz00_bglt)
																																																																				BOBJECT
																																																																				(GC_MALLOC
																																																																					(sizeof
																																																																						(struct
																																																																							BgL_setqz00_bgl))));
																																																																			{	/* Ast/sexp.scm 304 */
																																																																				long
																																																																					BgL_arg6761z00_8610;
																																																																				{	/* Ast/sexp.scm 304 */
																																																																					long
																																																																						BgL_res7362z00_9763;
																																																																					BgL_res7362z00_9763
																																																																						=
																																																																						BGL_CLASS_INDEX
																																																																						(BGl_setqz00zzast_nodez00);
																																																																					BgL_arg6761z00_8610
																																																																						=
																																																																						BgL_res7362z00_9763;
																																																																				}
																																																																				BGL_OBJECT_CLASS_NUM_SET
																																																																					(
																																																																					((BgL_objectz00_bglt) BgL_new1130z00_8609), BgL_arg6761z00_8610);
																																																																			}
																																																																			{	/* Ast/sexp.scm 304 */
																																																																				BgL_objectz00_bglt
																																																																					BgL_tmpz00_14385;
																																																																				BgL_tmpz00_14385
																																																																					=
																																																																					(
																																																																					(BgL_objectz00_bglt)
																																																																					BgL_new1130z00_8609);
																																																																				BGL_OBJECT_WIDENING_SET
																																																																					(BgL_tmpz00_14385,
																																																																					BFALSE);
																																																																			}
																																																																			BgL_new1132z00_8608
																																																																				=
																																																																				BgL_new1130z00_8609;
																																																																		}
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1132z00_8608)))->BgL_locz00) = ((obj_t) BgL_locz00_8595), BUNSPEC);
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1132z00_8608)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1132z00_8608))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8600)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1132z00_8608))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8599), BUNSPEC);
																																																																		BgL_auxz00_14334
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_new1132z00_8608);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 308 */
																																																																BgL_nodez00_bglt
																																																																	BgL_res7363z00_9771;
																																																																{	/* Ast/sexp.scm 717 */
																																																																	obj_t
																																																																		BgL_arg7100z00_9767;
																																																																	BgL_nodez00_bglt
																																																																		BgL_arg7101z00_9768;
																																																																	BgL_arg7100z00_9767
																																																																		=
																																																																		BGl_shapez00zztools_shapez00
																																																																		(BGl_currentzd2functionzd2zztools_errorz00
																																																																		());
																																																																	BgL_arg7101z00_9768
																																																																		=
																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																		(CNST_TABLE_REF
																																																																		(((long) 4)), BNIL, BgL_locz00_8595, CNST_TABLE_REF(((long) 2)));
																																																																	{	/* Ast/sexp.scm 716 */
																																																																		obj_t
																																																																			BgL_list7102z00_9770;
																																																																		BgL_list7102z00_9770
																																																																			=
																																																																			MAKE_YOUNG_PAIR
																																																																			(
																																																																			((obj_t) BgL_arg7101z00_9768), BNIL);
																																																																		BgL_res7363z00_9771
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																			(BgL_locz00_8595,
																																																																				BgL_arg7100z00_9767,
																																																																				BGl_string7981z00zzast_sexpz00,
																																																																				BgL_expz00_21,
																																																																				BgL_list7102z00_9770));
																																																																}}
																																																																BgL_auxz00_14334
																																																																	=
																																																																	BgL_res7363z00_9771;
																																																					}}}}}}}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																					BgL_tagzd262258zd2_8583:
																																																						{	/* Ast/sexp.scm 312 */
																																																							obj_t
																																																								BgL_arg6766z00_8616;
																																																							BgL_arg6766z00_8616
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 311 */
																																																								BgL_nodez00_bglt
																																																									BgL_res7364z00_9777;
																																																								{	/* Ast/sexp.scm 717 */
																																																									obj_t
																																																										BgL_arg7100z00_9773;
																																																									BgL_nodez00_bglt
																																																										BgL_arg7101z00_9774;
																																																									BgL_arg7100z00_9773
																																																										=
																																																										BGl_shapez00zztools_shapez00
																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																										());
																																																									BgL_arg7101z00_9774
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(CNST_TABLE_REF
																																																										(((long) 4)), BNIL, BgL_arg6766z00_8616, CNST_TABLE_REF(((long) 2)));
																																																									{	/* Ast/sexp.scm 716 */
																																																										obj_t
																																																											BgL_list7102z00_9776;
																																																										BgL_list7102z00_9776
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(
																																																											((obj_t) BgL_arg7101z00_9774), BNIL);
																																																										BgL_res7364z00_9777
																																																											=
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																											(BgL_arg6766z00_8616,
																																																												BgL_arg7100z00_9773,
																																																												BGl_string7979z00zzast_sexpz00,
																																																												BgL_expz00_21,
																																																												BgL_list7102z00_9776));
																																																								}}
																																																								BgL_auxz00_14334
																																																									=
																																																									BgL_res7364z00_9777;
																																																			}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_tagzd262258zd2_8583;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_tagzd262258zd2_8583;
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd262258zd2_8583;
																																															}
																																													}
																																													BgL_auxz00_14146
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_14334);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_14424;
																																														BgL_tagzd2380zd2_1719:
																																															{
																																																obj_t
																																																	BgL_varz00_8617;
																																																obj_t
																																																	BgL_valz00_8618;
																																																if (PAIRP(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd262283zd2_8623;
																																																		BgL_cdrzd262283zd2_8623
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		if (PAIRP(BgL_cdrzd262283zd2_8623))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd262287zd2_8625;
																																																				BgL_cdrzd262287zd2_8625
																																																					=
																																																					CDR
																																																					(BgL_cdrzd262283zd2_8623);
																																																				if (PAIRP(BgL_cdrzd262287zd2_8625))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (NULLP(CDR(BgL_cdrzd262287zd2_8625)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								BgL_varz00_8617
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262283zd2_8623);
																																																								BgL_valz00_8618
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262287zd2_8625);
																																																								{	/* Ast/sexp.scm 319 */
																																																									obj_t
																																																										BgL_locz00_8632;
																																																									BgL_locz00_8632
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 319 */
																																																										obj_t
																																																											BgL_cdlocz00_8633;
																																																										{	/* Ast/sexp.scm 320 */
																																																											obj_t
																																																												BgL_arg6782z00_8648;
																																																											BgL_arg6782z00_8648
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdlocz00_8633
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6782z00_8648,
																																																												BgL_locz00_8632);
																																																										}
																																																										{	/* Ast/sexp.scm 320 */
																																																											obj_t
																																																												BgL_cddlocz00_8634;
																																																											{	/* Ast/sexp.scm 321 */
																																																												obj_t
																																																													BgL_arg6781z00_8647;
																																																												{	/* Ast/sexp.scm 321 */
																																																													obj_t
																																																														BgL_pairz00_9791;
																																																													BgL_pairz00_9791
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_arg6781z00_8647
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9791);
																																																												}
																																																												BgL_cddlocz00_8634
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_arg6781z00_8647,
																																																													BgL_locz00_8632);
																																																											}
																																																											{	/* Ast/sexp.scm 321 */
																																																												obj_t
																																																													BgL_valzd2loczd2_8635;
																																																												BgL_valzd2loczd2_8635
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_valz00_8618,
																																																													BgL_cddlocz00_8634);
																																																												{	/* Ast/sexp.scm 322 */
																																																													BgL_nodez00_bglt
																																																														BgL_valz00_8636;
																																																													BgL_valz00_8636
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_valz00_8618,
																																																														BgL_stackz00_22,
																																																														BgL_valzd2loczd2_8635,
																																																														CNST_TABLE_REF
																																																														(((long) 2)));
																																																													{	/* Ast/sexp.scm 323 */

																																																														{	/* Ast/sexp.scm 324 */
																																																															BgL_nodez00_bglt
																																																																BgL_astz00_8637;
																																																															BgL_astz00_8637
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_varz00_8617,
																																																																BgL_stackz00_22,
																																																																BgL_cdlocz00_8633,
																																																																CNST_TABLE_REF
																																																																(((long) 2)));
																																																															{	/* Ast/sexp.scm 325 */
																																																																bool_t
																																																																	BgL_testz00_14449;
																																																																{	/* Ast/sexp.scm 325 */
																																																																	bool_t
																																																																		BgL_testz00_14450;
																																																																	{	/* Ast/sexp.scm 325 */
																																																																		bool_t
																																																																			BgL_res7369z00_9792;
																																																																		BgL_res7369z00_9792
																																																																			=
																																																																			BGl_isazf3zf3zz__objectz00
																																																																			(
																																																																			((obj_t) BgL_astz00_8637), BGl_varz00zzast_nodez00);
																																																																		BgL_testz00_14450
																																																																			=
																																																																			BgL_res7369z00_9792;
																																																																	}
																																																																	if (BgL_testz00_14450)
																																																																		{	/* Ast/sexp.scm 325 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6780z00_8646;
																																																																			BgL_arg6780z00_8646
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8637)))->BgL_variablez00);
																																																																			{	/* Ast/sexp.scm 325 */
																																																																				bool_t
																																																																					BgL_res7370z00_9794;
																																																																				BgL_res7370z00_9794
																																																																					=
																																																																					BGl_isazf3zf3zz__objectz00
																																																																					(
																																																																					((obj_t) BgL_arg6780z00_8646), BGl_globalz00zzast_varz00);
																																																																				BgL_testz00_14449
																																																																					=
																																																																					BgL_res7370z00_9794;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 325 */
																																																																			BgL_testz00_14449
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_testz00_14449)
																																																																	{	/* Ast/sexp.scm 325 */
																																																																		{	/* Ast/sexp.scm 327 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6778z00_8641;
																																																																			BgL_arg6778z00_8641
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8637)))->BgL_variablez00);
																																																																			((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_arg6778z00_8641)))->BgL_srcz00) = ((obj_t) ((obj_t) BgL_valz00_8636)), BUNSPEC);
																																																																		}
																																																																		{	/* Ast/sexp.scm 328 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1134z00_8642;
																																																																			{	/* Ast/sexp.scm 329 */
																																																																				BgL_setqz00_bglt
																																																																					BgL_new1133z00_8643;
																																																																				BgL_new1133z00_8643
																																																																					=
																																																																					(
																																																																					(BgL_setqz00_bglt)
																																																																					BOBJECT
																																																																					(GC_MALLOC
																																																																						(sizeof
																																																																							(struct
																																																																								BgL_setqz00_bgl))));
																																																																				{	/* Ast/sexp.scm 329 */
																																																																					long
																																																																						BgL_arg6779z00_8644;
																																																																					{	/* Ast/sexp.scm 329 */
																																																																						long
																																																																							BgL_res7371z00_9798;
																																																																						BgL_res7371z00_9798
																																																																							=
																																																																							BGL_CLASS_INDEX
																																																																							(BGl_setqz00zzast_nodez00);
																																																																						BgL_arg6779z00_8644
																																																																							=
																																																																							BgL_res7371z00_9798;
																																																																					}
																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																						(
																																																																						((BgL_objectz00_bglt) BgL_new1133z00_8643), BgL_arg6779z00_8644);
																																																																				}
																																																																				{	/* Ast/sexp.scm 329 */
																																																																					BgL_objectz00_bglt
																																																																						BgL_tmpz00_14466;
																																																																					BgL_tmpz00_14466
																																																																						=
																																																																						(
																																																																						(BgL_objectz00_bglt)
																																																																						BgL_new1133z00_8643);
																																																																					BGL_OBJECT_WIDENING_SET
																																																																						(BgL_tmpz00_14466,
																																																																						BFALSE);
																																																																				}
																																																																				BgL_new1134z00_8642
																																																																					=
																																																																					BgL_new1133z00_8643;
																																																																			}
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1134z00_8642)))->BgL_locz00) = ((obj_t) BgL_locz00_8632), BUNSPEC);
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1134z00_8642)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1134z00_8642))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8637)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1134z00_8642))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8636), BUNSPEC);
																																																																			BgL_auxz00_14424
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_new1134z00_8642);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 333 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7372z00_9806;
																																																																		{	/* Ast/sexp.scm 717 */
																																																																			obj_t
																																																																				BgL_arg7100z00_9802;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7101z00_9803;
																																																																			BgL_arg7100z00_9802
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7101z00_9803
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_locz00_8632, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 716 */
																																																																				obj_t
																																																																					BgL_list7102z00_9805;
																																																																				BgL_list7102z00_9805
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7101z00_9803), BNIL);
																																																																				BgL_res7372z00_9806
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_locz00_8632,
																																																																						BgL_arg7100z00_9802,
																																																																						BGl_string7978z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7102z00_9805));
																																																																		}}
																																																																		BgL_auxz00_14424
																																																																			=
																																																																			BgL_res7372z00_9806;
																																																							}}}}}}}}}}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																							BgL_tagzd262276zd2_8620:
																																																								{	/* Ast/sexp.scm 337 */
																																																									obj_t
																																																										BgL_arg6783z00_8649;
																																																									BgL_arg6783z00_8649
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 336 */
																																																										BgL_nodez00_bglt
																																																											BgL_res7373z00_9812;
																																																										{	/* Ast/sexp.scm 717 */
																																																											obj_t
																																																												BgL_arg7100z00_9808;
																																																											BgL_nodez00_bglt
																																																												BgL_arg7101z00_9809;
																																																											BgL_arg7100z00_9808
																																																												=
																																																												BGl_shapez00zztools_shapez00
																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																												());
																																																											BgL_arg7101z00_9809
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(CNST_TABLE_REF
																																																												(((long) 4)), BNIL, BgL_arg6783z00_8649, CNST_TABLE_REF(((long) 2)));
																																																											{	/* Ast/sexp.scm 716 */
																																																												obj_t
																																																													BgL_list7102z00_9811;
																																																												BgL_list7102z00_9811
																																																													=
																																																													MAKE_YOUNG_PAIR
																																																													(
																																																													((obj_t) BgL_arg7101z00_9809), BNIL);
																																																												BgL_res7373z00_9812
																																																													=
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																													(BgL_arg6783z00_8649,
																																																														BgL_arg7100z00_9808,
																																																														BGl_string7977z00zzast_sexpz00,
																																																														BgL_expz00_21,
																																																														BgL_list7102z00_9811));
																																																										}}
																																																										BgL_auxz00_14424
																																																											=
																																																											BgL_res7373z00_9812;
																																																					}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_tagzd262276zd2_8620;
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_tagzd262276zd2_8620;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_tagzd262276zd2_8620;
																																																	}
																																															}
																																															BgL_auxz00_14146
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_14424);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd2706zd2_2568;
																																															BgL_carzd2706zd2_2568
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if (PAIRP(BgL_carzd2706zd2_2568))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd2709zd2_2570;
																																																	obj_t
																																																		BgL_cdrzd2710zd2_2571;
																																																	BgL_carzd2709zd2_2570
																																																		=
																																																		CAR
																																																		(BgL_carzd2706zd2_2568);
																																																	BgL_cdrzd2710zd2_2571
																																																		=
																																																		CDR
																																																		(BgL_carzd2706zd2_2568);
																																																	{

																																																		if ((BgL_carzd2709zd2_2570 == CNST_TABLE_REF(((long) 17))))
																																																			{	/* Ast/sexp.scm 118 */
																																																			BgL_kapzd2711zd2_2572:
																																																				if (PAIRP(BgL_cdrzd2710zd2_2571))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd2714zd2_2697;
																																																						BgL_cdrzd2714zd2_2697
																																																							=
																																																							CDR
																																																							(BgL_cdrzd2710zd2_2571);
																																																						if (PAIRP(BgL_cdrzd2714zd2_2697))
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (NULLP(CDR(BgL_cdrzd2714zd2_2697)))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2346z00_2701;
																																																										obj_t
																																																											BgL_arg2347z00_2702;
																																																										BgL_arg2346z00_2701
																																																											=
																																																											CAR
																																																											(BgL_cdrzd2714zd2_2697);
																																																										BgL_arg2347z00_2702
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_14520;
																																																											BgL_bodyz00_1720
																																																												=
																																																												BgL_arg2346z00_2701;
																																																											BgL_argsz00_1721
																																																												=
																																																												BgL_arg2347z00_2702;
																																																										BgL_tagzd2381zd2_1722:
																																																											{	/* Ast/sexp.scm 340 */
																																																												obj_t
																																																													BgL_letzd2partzd2_8650;
																																																												BgL_letzd2partzd2_8650
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 340 */
																																																													obj_t
																																																														BgL_nexpz00_8651;
																																																													{	/* Ast/sexp.scm 341 */
																																																														obj_t
																																																															BgL_arg6784z00_8652;
																																																														obj_t
																																																															BgL_arg6785z00_8653;
																																																														BgL_arg6784z00_8652
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_letzd2partzd2_8650));
																																																														{	/* Ast/sexp.scm 341 */
																																																															obj_t
																																																																BgL_arg6786z00_8654;
																																																															obj_t
																																																																BgL_arg6787z00_8655;
																																																															{	/* Ast/sexp.scm 341 */
																																																																obj_t
																																																																	BgL_pairz00_9827;
																																																																BgL_pairz00_9827
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_letzd2partzd2_8650));
																																																																BgL_arg6786z00_8654
																																																																	=
																																																																	CAR
																																																																	(BgL_pairz00_9827);
																																																															}
																																																															{	/* Ast/sexp.scm 341 */
																																																																obj_t
																																																																	BgL_arg6788z00_8656;
																																																																BgL_arg6788z00_8656
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_bodyz00_1720,
																																																																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																	(BgL_argsz00_1721,
																																																																		BNIL));
																																																																BgL_arg6787z00_8655
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_arg6788z00_8656,
																																																																	BNIL);
																																																															}
																																																															BgL_arg6785z00_8653
																																																																=
																																																																MAKE_YOUNG_PAIR
																																																																(BgL_arg6786z00_8654,
																																																																BgL_arg6787z00_8655);
																																																														}
																																																														BgL_nexpz00_8651
																																																															=
																																																															MAKE_YOUNG_PAIR
																																																															(BgL_arg6784z00_8652,
																																																															BgL_arg6785z00_8653);
																																																													}
																																																													{	/* Ast/sexp.scm 341 */

																																																														BgL_auxz00_14520
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_nexpz00_8651,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															BgL_sitez00_24);
																																																													}
																																																												}
																																																											}
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14520);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd2738zd2_2703;
																																																										BgL_cdrzd2738zd2_2703
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_14537;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2425z00_2814;
																																																												BgL_arg2425z00_2814
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_14537
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2425z00_2814));
																																																											}
																																																											if (BgL_testz00_14537)
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg2350z00_2706;
																																																													obj_t
																																																														BgL_arg2351z00_2707;
																																																													BgL_arg2350z00_2706
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2703));
																																																													BgL_arg2351z00_2707
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2703));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_14546;
																																																														BgL_bindingsz00_1723
																																																															=
																																																															BgL_arg2350z00_2706;
																																																														BgL_exprz00_1724
																																																															=
																																																															BgL_arg2351z00_2707;
																																																													BgL_tagzd2382zd2_1725:
																																																														{	/* Ast/sexp.scm 351 */
																																																															bool_t
																																																																BgL_testz00_14547;
																																																															if (PAIRP(BgL_bindingsz00_1723))
																																																																{	/* Ast/sexp.scm 351 */
																																																																	if (NULLP(CDR(BgL_bindingsz00_1723)))
																																																																		{	/* Ast/sexp.scm 351 */
																																																																			if (PAIRP(BgL_exprz00_1724))
																																																																				{	/* Ast/sexp.scm 352 */
																																																																					BgL_testz00_14547
																																																																						=
																																																																						NULLP
																																																																						(CDR
																																																																						(BgL_exprz00_1724));
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 352 */
																																																																					BgL_testz00_14547
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 351 */
																																																																			BgL_testz00_14547
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 351 */
																																																																	BgL_testz00_14547
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															if (BgL_testz00_14547)
																																																																{
																																																																	obj_t
																																																																		BgL_varz00_8665;
																																																																	obj_t
																																																																		BgL_exprz00_8666;
																																																																	obj_t
																																																																		BgL_idz00_8667;
																																																																	obj_t
																																																																		BgL_thenz00_8668;
																																																																	obj_t
																																																																		BgL_otherwisez00_8669;
																																																																	if (PAIRP(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 353 */
																																																																			obj_t
																																																																				BgL_cdrzd262306zd2_8673;
																																																																			BgL_cdrzd262306zd2_8673
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if (PAIRP(BgL_cdrzd262306zd2_8673))
																																																																				{	/* Ast/sexp.scm 353 */
																																																																					obj_t
																																																																						BgL_carzd262312zd2_8675;
																																																																					obj_t
																																																																						BgL_cdrzd262313zd2_8676;
																																																																					BgL_carzd262312zd2_8675
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd262306zd2_8673);
																																																																					BgL_cdrzd262313zd2_8676
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262306zd2_8673);
																																																																					if (PAIRP(BgL_carzd262312zd2_8675))
																																																																						{	/* Ast/sexp.scm 353 */
																																																																							obj_t
																																																																								BgL_carzd262316zd2_8678;
																																																																							BgL_carzd262316zd2_8678
																																																																								=
																																																																								CAR
																																																																								(BgL_carzd262312zd2_8675);
																																																																							if (PAIRP(BgL_carzd262316zd2_8678))
																																																																								{	/* Ast/sexp.scm 353 */
																																																																									obj_t
																																																																										BgL_cdrzd262321zd2_8680;
																																																																									BgL_cdrzd262321zd2_8680
																																																																										=
																																																																										CDR
																																																																										(BgL_carzd262316zd2_8678);
																																																																									if (PAIRP(BgL_cdrzd262321zd2_8680))
																																																																										{	/* Ast/sexp.scm 353 */
																																																																											if (NULLP(CDR(BgL_cdrzd262321zd2_8680)))
																																																																												{	/* Ast/sexp.scm 353 */
																																																																													if (NULLP(CDR(BgL_carzd262312zd2_8675)))
																																																																														{	/* Ast/sexp.scm 353 */
																																																																															if (PAIRP(BgL_cdrzd262313zd2_8676))
																																																																																{	/* Ast/sexp.scm 353 */
																																																																																	obj_t
																																																																																		BgL_carzd262330zd2_8687;
																																																																																	BgL_carzd262330zd2_8687
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd262313zd2_8676);
																																																																																	if (PAIRP(BgL_carzd262330zd2_8687))
																																																																																		{	/* Ast/sexp.scm 353 */
																																																																																			obj_t
																																																																																				BgL_cdrzd262336zd2_8689;
																																																																																			BgL_cdrzd262336zd2_8689
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_carzd262330zd2_8687);
																																																																																			if ((CAR(BgL_carzd262330zd2_8687) == CNST_TABLE_REF(((long) 1))))
																																																																																				{	/* Ast/sexp.scm 353 */
																																																																																					if (PAIRP(BgL_cdrzd262336zd2_8689))
																																																																																						{	/* Ast/sexp.scm 353 */
																																																																																							obj_t
																																																																																								BgL_carzd262340zd2_8693;
																																																																																							obj_t
																																																																																								BgL_cdrzd262341zd2_8694;
																																																																																							BgL_carzd262340zd2_8693
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_cdrzd262336zd2_8689);
																																																																																							BgL_cdrzd262341zd2_8694
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_cdrzd262336zd2_8689);
																																																																																							if (SYMBOLP(BgL_carzd262340zd2_8693))
																																																																																								{	/* Ast/sexp.scm 353 */
																																																																																									if (PAIRP(BgL_cdrzd262341zd2_8694))
																																																																																										{	/* Ast/sexp.scm 353 */
																																																																																											obj_t
																																																																																												BgL_cdrzd262348zd2_8697;
																																																																																											BgL_cdrzd262348zd2_8697
																																																																																												=
																																																																																												CDR
																																																																																												(BgL_cdrzd262341zd2_8694);
																																																																																											if (PAIRP(BgL_cdrzd262348zd2_8697))
																																																																																												{	/* Ast/sexp.scm 353 */
																																																																																													if (NULLP(CDR(BgL_cdrzd262348zd2_8697)))
																																																																																														{	/* Ast/sexp.scm 353 */
																																																																																															if (NULLP(CDR(BgL_cdrzd262313zd2_8676)))
																																																																																																{	/* Ast/sexp.scm 353 */
																																																																																																	BgL_varz00_8665
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_carzd262316zd2_8678);
																																																																																																	BgL_exprz00_8666
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262321zd2_8680);
																																																																																																	BgL_idz00_8667
																																																																																																		=
																																																																																																		BgL_carzd262340zd2_8693;
																																																																																																	BgL_thenz00_8668
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262341zd2_8694);
																																																																																																	BgL_otherwisez00_8669
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262348zd2_8697);
																																																																																																	{	/* Ast/sexp.scm 358 */
																																																																																																		obj_t
																																																																																																			BgL_ntz00_8712;
																																																																																																		BgL_ntz00_8712
																																																																																																			=
																																																																																																			BGl_notzd2testzd2zzast_sexpz00
																																																																																																			(BgL_exprz00_8666);
																																																																																																		{	/* Ast/sexp.scm 359 */
																																																																																																			bool_t
																																																																																																				BgL_testz00_14606;
																																																																																																			if (CBOOL(BgL_ntz00_8712))
																																																																																																				{	/* Ast/sexp.scm 359 */
																																																																																																					if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8667, BgL_otherwisez00_8669))
																																																																																																						{	/* Ast/sexp.scm 360 */
																																																																																																							BgL_testz00_14606
																																																																																																								=
																																																																																																								(
																																																																																																								(bool_t)
																																																																																																								0);
																																																																																																						}
																																																																																																					else
																																																																																																						{	/* Ast/sexp.scm 360 */
																																																																																																							if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8667, BgL_thenz00_8668))
																																																																																																								{	/* Ast/sexp.scm 361 */
																																																																																																									BgL_testz00_14606
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										0);
																																																																																																								}
																																																																																																							else
																																																																																																								{	/* Ast/sexp.scm 361 */
																																																																																																									BgL_testz00_14606
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										1);
																																																																																																								}
																																																																																																						}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 359 */
																																																																																																					BgL_testz00_14606
																																																																																																						=
																																																																																																						(
																																																																																																						(bool_t)
																																																																																																						0);
																																																																																																				}
																																																																																																			if (BgL_testz00_14606)
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					obj_t
																																																																																																						BgL_bindingz00_8716;
																																																																																																					obj_t
																																																																																																						BgL_bodyz00_8717;
																																																																																																					BgL_bindingz00_8716
																																																																																																						=
																																																																																																						CAR
																																																																																																						(
																																																																																																						((obj_t) BgL_bindingsz00_1723));
																																																																																																					{	/* Ast/sexp.scm 363 */
																																																																																																						obj_t
																																																																																																							BgL_pairz00_9840;
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9839;
																																																																																																							BgL_pairz00_9839
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_expz00_21));
																																																																																																							BgL_pairz00_9840
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9839);
																																																																																																						}
																																																																																																						BgL_bodyz00_8717
																																																																																																							=
																																																																																																							CAR
																																																																																																							(BgL_pairz00_9840);
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 364 */
																																																																																																						obj_t
																																																																																																							BgL_arg6829z00_8718;
																																																																																																						BgL_arg6829z00_8718
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_bindingz00_8716));
																																																																																																						{	/* Ast/sexp.scm 364 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14621;
																																																																																																							BgL_tmpz00_14621
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6829z00_8718);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14621,
																																																																																																								BgL_ntz00_8712);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 365 */
																																																																																																						obj_t
																																																																																																							BgL_arg6830z00_8719;
																																																																																																						{	/* Ast/sexp.scm 365 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9846;
																																																																																																							BgL_pairz00_9846
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_bodyz00_8717));
																																																																																																							BgL_arg6830z00_8719
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9846);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 365 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14627;
																																																																																																							BgL_tmpz00_14627
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6830z00_8719);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14627,
																																																																																																								BgL_otherwisez00_8669);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 366 */
																																																																																																						obj_t
																																																																																																							BgL_arg6831z00_8720;
																																																																																																						{	/* Ast/sexp.scm 366 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9853;
																																																																																																							{	/* Ast/sexp.scm 366 */
																																																																																																								obj_t
																																																																																																									BgL_pairz00_9852;
																																																																																																								BgL_pairz00_9852
																																																																																																									=
																																																																																																									CDR
																																																																																																									(
																																																																																																									((obj_t) BgL_bodyz00_8717));
																																																																																																								BgL_pairz00_9853
																																																																																																									=
																																																																																																									CDR
																																																																																																									(BgL_pairz00_9852);
																																																																																																							}
																																																																																																							BgL_arg6831z00_8720
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9853);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 366 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14634;
																																																																																																							BgL_tmpz00_14634
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6831z00_8720);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14634,
																																																																																																								BgL_thenz00_8668);
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 359 */
																																																																																																					BFALSE;
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 353 */
																																																																																																	BFALSE;
																																																																																																}
																																																																																														}
																																																																																													else
																																																																																														{	/* Ast/sexp.scm 353 */
																																																																																															BFALSE;
																																																																																														}
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 353 */
																																																																																													BFALSE;
																																																																																												}
																																																																																										}
																																																																																									else
																																																																																										{	/* Ast/sexp.scm 353 */
																																																																																											BFALSE;
																																																																																										}
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 353 */
																																																																																									BFALSE;
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 353 */
																																																																																							BFALSE;
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 353 */
																																																																																					BFALSE;
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 353 */
																																																																																			BFALSE;
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 353 */
																																																																																	BFALSE;
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 353 */
																																																																															BFALSE;
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 353 */
																																																																													BFALSE;
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 353 */
																																																																											BFALSE;
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 353 */
																																																																									BFALSE;
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 353 */
																																																																							BFALSE;
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 353 */
																																																																					BFALSE;
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 353 */
																																																																			BFALSE;
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 351 */
																																																																	BFALSE;
																																																																}
																																																														}
																																																														BgL_auxz00_14546
																																																															=
																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																															(BgL_expz00_21,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_14546);
																																																												}}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_testz00_14644;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2424z00_2813;
																																																														BgL_arg2424z00_2813
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_testz00_14644
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2424z00_2813));
																																																													}
																																																													if (BgL_testz00_14644)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_14649;
																																																														BgL_tagzd2384zd2_1727:
																																																															BgL_auxz00_14649 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_14649);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd2805zd2_2710;
																																																															BgL_carzd2805zd2_2710
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd2810zd2_2711;
																																																																BgL_cdrzd2810zd2_2711
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd2805zd2_2710));
																																																																if ((CAR(((obj_t) BgL_carzd2805zd2_2710)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg2357z00_2714;
																																																																		obj_t
																																																																			BgL_arg2358z00_2715;
																																																																		obj_t
																																																																			BgL_arg2359z00_2716;
																																																																		BgL_arg2357z00_2714
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2711));
																																																																		BgL_arg2358z00_2715
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2711));
																																																																		BgL_arg2359z00_2716
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_14668;
																																																																			BgL_varsz00_1732
																																																																				=
																																																																				BgL_arg2357z00_2714;
																																																																			BgL_bodyz00_1733
																																																																				=
																																																																				BgL_arg2358z00_2715;
																																																																			BgL_argsz00_1734
																																																																				=
																																																																				BgL_arg2359z00_2716;
																																																																		BgL_tagzd2386zd2_1735:
																																																																			{	/* Ast/sexp.scm 380 */
																																																																				obj_t
																																																																					BgL_locz00_8732;
																																																																				obj_t
																																																																					BgL_nexpz00_8733;
																																																																				BgL_locz00_8732
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_expz00_21,
																																																																					BgL_locz00_23);
																																																																				{	/* Ast/sexp.scm 381 */
																																																																					obj_t
																																																																						BgL_arg6836z00_8734;
																																																																					obj_t
																																																																						BgL_arg6837z00_8735;
																																																																					BgL_arg6836z00_8734
																																																																						=
																																																																						BGl_letzd2symzd2zzast_letz00
																																																																						();
																																																																					{	/* Ast/sexp.scm 384 */
																																																																						obj_t
																																																																							BgL_arg6838z00_8736;
																																																																						obj_t
																																																																							BgL_arg6839z00_8737;
																																																																						BgL_arg6838z00_8736
																																																																							=
																																																																							BGl_loopze70ze7zzast_sexpz00
																																																																							(BgL_expz00_21,
																																																																							BgL_locz00_23,
																																																																							BgL_varsz00_1732,
																																																																							BgL_argsz00_1734);
																																																																						{	/* Ast/sexp.scm 423 */
																																																																							obj_t
																																																																								BgL_arg6881z00_8787;
																																																																							{	/* Ast/sexp.scm 423 */
																																																																								obj_t
																																																																									BgL_arg6882z00_8788;
																																																																								obj_t
																																																																									BgL_arg6883z00_8789;
																																																																								BgL_arg6882z00_8788
																																																																									=
																																																																									BGl_shapez00zztools_shapez00
																																																																									(BGl_currentzd2functionzd2zztools_errorz00
																																																																									());
																																																																								BgL_arg6883z00_8789
																																																																									=
																																																																									BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																									(BgL_bodyz00_1733);
																																																																								{	/* Ast/sexp.scm 427 */
																																																																									obj_t
																																																																										BgL_zc3anonymousza36886ze3z83_13698;
																																																																									BgL_zc3anonymousza36886ze3z83_13698
																																																																										=
																																																																										MAKE_FX_PROCEDURE
																																																																										(BGl_z62zc3anonymousza36886ze3ze1zzast_sexpz00,
																																																																										(int)
																																																																										(((long) 3)), (int) (((long) 1)));
																																																																									PROCEDURE_SET
																																																																										(BgL_zc3anonymousza36886ze3z83_13698,
																																																																										(int)
																																																																										(((long) 0)), BgL_locz00_23);
																																																																									BgL_arg6881z00_8787
																																																																										=
																																																																										BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																																										(BgL_arg6882z00_8788,
																																																																										BgL_varsz00_1732,
																																																																										BgL_arg6883z00_8789,
																																																																										BgL_zc3anonymousza36886ze3z83_13698);
																																																																							}}
																																																																							BgL_arg6839z00_8737
																																																																								=
																																																																								MAKE_YOUNG_PAIR
																																																																								(BgL_arg6881z00_8787,
																																																																								BNIL);
																																																																						}
																																																																						BgL_arg6837z00_8735
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(BgL_arg6838z00_8736,
																																																																							BgL_arg6839z00_8737);
																																																																					}
																																																																					BgL_nexpz00_8733
																																																																						=
																																																																						MAKE_YOUNG_PAIR
																																																																						(BgL_arg6836z00_8734,
																																																																						BgL_arg6837z00_8735);
																																																																				}
																																																																				BgL_auxz00_14668
																																																																					=
																																																																					BGl_letzd2ze3nodez31zzast_letz00
																																																																					(BgL_nexpz00_8733,
																																																																					BgL_stackz00_22,
																																																																					BgL_locz00_8732,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_14668);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd2833zd2_2718;
																																																																		BgL_cdrzd2833zd2_2718
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd2839zd2_2719;
																																																																			BgL_cdrzd2839zd2_2719
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd2805zd2_2710));
																																																																			if ((CAR(((obj_t) BgL_carzd2805zd2_2710)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd2845zd2_2722;
																																																																					BgL_cdrzd2845zd2_2722
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd2839zd2_2719));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd2850zd2_2723;
																																																																						obj_t
																																																																							BgL_cdrzd2851zd2_2724;
																																																																						BgL_carzd2850zd2_2723
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2722));
																																																																						BgL_cdrzd2851zd2_2724
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2722));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2850zd2_2723))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (PAIRP(BgL_cdrzd2851zd2_2724))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd2858zd2_2727;
																																																																										BgL_carzd2858zd2_2727
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd2851zd2_2724);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2858zd2_2727))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (NULLP(CDR(BgL_cdrzd2851zd2_2724)))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_testz00_14712;
																																																																														{
																																																																															obj_t
																																																																																BgL_l1363z00_2760;
																																																																															BgL_l1363z00_2760
																																																																																=
																																																																																BgL_cdrzd2833zd2_2718;
																																																																														BgL_zc3anonymousza32383ze3z83_2761:
																																																																															if (NULLP(BgL_l1363z00_2760))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_14712
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_testz00_14715;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		bool_t
																																																																																			BgL_testz00_14716;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_tmpz00_14717;
																																																																																			BgL_tmpz00_14717
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_l1363z00_2760));
																																																																																			BgL_testz00_14716
																																																																																				=
																																																																																				PAIRP
																																																																																				(BgL_tmpz00_14717);
																																																																																		}
																																																																																		if (BgL_testz00_14716)
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_testz00_14715
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_testz00_14715
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																	}
																																																																																	if (BgL_testz00_14715)
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_l1363z00_14721;
																																																																																			BgL_l1363z00_14721
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_l1363z00_2760));
																																																																																			BgL_l1363z00_2760
																																																																																				=
																																																																																				BgL_l1363z00_14721;
																																																																																			goto
																																																																																				BgL_zc3anonymousza32383ze3z83_2761;
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_testz00_14712
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																}
																																																																														}
																																																																														if (BgL_testz00_14712)
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg2373z00_2743;
																																																																																BgL_arg2373z00_2743
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd2839zd2_2719));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14726;
																																																																																	BgL_testz00_1736
																																																																																		=
																																																																																		BgL_arg2373z00_2743;
																																																																																	BgL_proc1z00_1737
																																																																																		=
																																																																																		BgL_carzd2850zd2_2723;
																																																																																	BgL_proc2z00_1738
																																																																																		=
																																																																																		BgL_carzd2858zd2_2727;
																																																																																	BgL_argsz00_1739
																																																																																		=
																																																																																		BgL_cdrzd2833zd2_2718;
																																																																																BgL_tagzd2387zd2_1740:
																																																																																	{	/* Ast/sexp.scm 434 */
																																																																																		obj_t
																																																																																			BgL_nexpz00_8798;
																																																																																		{	/* Ast/sexp.scm 434 */
																																																																																			obj_t
																																																																																				BgL_arg6889z00_8800;
																																																																																			{	/* Ast/sexp.scm 434 */
																																																																																				obj_t
																																																																																					BgL_arg6890z00_8801;
																																																																																				{	/* Ast/sexp.scm 434 */
																																																																																					obj_t
																																																																																						BgL_arg6891z00_8802;
																																																																																					obj_t
																																																																																						BgL_arg6892z00_8803;
																																																																																					BgL_arg6891z00_8802
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_proc1z00_1737,
																																																																																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																						(BgL_argsz00_1739,
																																																																																							BNIL));
																																																																																					{	/* Ast/sexp.scm 434 */
																																																																																						obj_t
																																																																																							BgL_arg6894z00_8805;
																																																																																						BgL_arg6894z00_8805
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_proc2z00_1738,
																																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																							(BgL_argsz00_1739,
																																																																																								BNIL));
																																																																																						BgL_arg6892z00_8803
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_arg6894z00_8805,
																																																																																							BNIL);
																																																																																					}
																																																																																					BgL_arg6890z00_8801
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_arg6891z00_8802,
																																																																																						BgL_arg6892z00_8803);
																																																																																				}
																																																																																				BgL_arg6889z00_8800
																																																																																					=
																																																																																					MAKE_YOUNG_PAIR
																																																																																					(BgL_testz00_1736,
																																																																																					BgL_arg6890z00_8801);
																																																																																			}
																																																																																			BgL_nexpz00_8798
																																																																																				=
																																																																																				MAKE_YOUNG_PAIR
																																																																																				(CNST_TABLE_REF
																																																																																				(((long) 1)), BgL_arg6889z00_8800);
																																																																																		}
																																																																																		BgL_auxz00_14726
																																																																																			=
																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																			(BgL_nexpz00_8798,
																																																																																			BgL_stackz00_22,
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_locz00_23),
																																																																																			BgL_sitez00_24);
																																																																																	}
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14726);
																																																																															}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd2882zd2_2744;
																																																																																BgL_cdrzd2882zd2_2744
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd2889zd2_2745;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10098;
																																																																																		BgL_pairz00_10098
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_expz00_21));
																																																																																		BgL_cdrzd2889zd2_2745
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_pairz00_10098);
																																																																																	}
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd2896zd2_2746;
																																																																																		BgL_cdrzd2896zd2_2746
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd2889zd2_2745));
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_carzd2902zd2_2747;
																																																																																			BgL_carzd2902zd2_2747
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd2896zd2_2746));
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2902zd2_2747))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_carzd2909zd2_2749;
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_pairz00_10102;
																																																																																						BgL_pairz00_10102
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd2896zd2_2746));
																																																																																						BgL_carzd2909zd2_2749
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_pairz00_10102);
																																																																																					}
																																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2909zd2_2749))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd2882zd2_2744))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									obj_t
																																																																																										BgL_arg2377z00_2752;
																																																																																									BgL_arg2377z00_2752
																																																																																										=
																																																																																										CAR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd2889zd2_2745));
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14759;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_arg2377z00_2752;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_carzd2902zd2_2747;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_carzd2909zd2_2749;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_cdrzd2882zd2_2744;
																																																																																									BgL_tagzd2388zd2_1745:
																																																																																										{	/* Ast/sexp.scm 440 */
																																																																																											obj_t
																																																																																												BgL_tmpsz00_8807;
																																																																																											if (NULLP(BgL_argsz00_1744))
																																																																																												{	/* Ast/sexp.scm 440 */
																																																																																													BgL_tmpsz00_8807
																																																																																														=
																																																																																														BNIL;
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 440 */
																																																																																													obj_t
																																																																																														BgL_head1352z00_8851;
																																																																																													{	/* Ast/sexp.scm 440 */
																																																																																														obj_t
																																																																																															BgL_res7408z00_9913;
																																																																																														BgL_res7408z00_9913
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BNIL,
																																																																																															BNIL);
																																																																																														BgL_head1352z00_8851
																																																																																															=
																																																																																															BgL_res7408z00_9913;
																																																																																													}
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_l1350z00_8853;
																																																																																														obj_t
																																																																																															BgL_tail1353z00_8854;
																																																																																														BgL_l1350z00_8853
																																																																																															=
																																																																																															BgL_argsz00_1744;
																																																																																														BgL_tail1353z00_8854
																																																																																															=
																																																																																															BgL_head1352z00_8851;
																																																																																													BgL_zc3anonymousza36925ze3z83_8855:
																																																																																														if (NULLP(BgL_l1350z00_8853))
																																																																																															{	/* Ast/sexp.scm 440 */
																																																																																																BgL_tmpsz00_8807
																																																																																																	=
																																																																																																	CDR
																																																																																																	(BgL_head1352z00_8851);
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 440 */
																																																																																																obj_t
																																																																																																	BgL_newtail1354z00_8857;
																																																																																																{	/* Ast/sexp.scm 440 */
																																																																																																	obj_t
																																																																																																		BgL_arg6928z00_8859;
																																																																																																	{	/* Ast/sexp.scm 440 */

																																																																																																		{	/* Ast/sexp.scm 440 */

																																																																																																			BgL_arg6928z00_8859
																																																																																																				=
																																																																																																				BGl_gensymz00zz__r4_symbols_6_4z00
																																																																																																				(BFALSE);
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 440 */
																																																																																																		obj_t
																																																																																																			BgL_res7410z00_9917;
																																																																																																		BgL_res7410z00_9917
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_arg6928z00_8859,
																																																																																																			BNIL);
																																																																																																		BgL_newtail1354z00_8857
																																																																																																			=
																																																																																																			BgL_res7410z00_9917;
																																																																																																	}
																																																																																																}
																																																																																																SET_CDR
																																																																																																	(BgL_tail1353z00_8854,
																																																																																																	BgL_newtail1354z00_8857);
																																																																																																{	/* Ast/sexp.scm 440 */
																																																																																																	obj_t
																																																																																																		BgL_arg6927z00_8858;
																																																																																																	BgL_arg6927z00_8858
																																																																																																		=
																																																																																																		CDR
																																																																																																		(
																																																																																																		((obj_t) BgL_l1350z00_8853));
																																																																																																	{
																																																																																																		obj_t
																																																																																																			BgL_tail1353z00_14772;
																																																																																																		obj_t
																																																																																																			BgL_l1350z00_14771;
																																																																																																		BgL_l1350z00_14771
																																																																																																			=
																																																																																																			BgL_arg6927z00_8858;
																																																																																																		BgL_tail1353z00_14772
																																																																																																			=
																																																																																																			BgL_newtail1354z00_8857;
																																																																																																		BgL_tail1353z00_8854
																																																																																																			=
																																																																																																			BgL_tail1353z00_14772;
																																																																																																		BgL_l1350z00_8853
																																																																																																			=
																																																																																																			BgL_l1350z00_14771;
																																																																																																		goto
																																																																																																			BgL_zc3anonymousza36925ze3z83_8855;
																																																																																																	}
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											{	/* Ast/sexp.scm 440 */
																																																																																												obj_t
																																																																																													BgL_locz00_8808;
																																																																																												BgL_locz00_8808
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_expz00_21,
																																																																																													BgL_locz00_23);
																																																																																												{	/* Ast/sexp.scm 441 */
																																																																																													obj_t
																																																																																														BgL_nexpz00_8809;
																																																																																													{	/* Ast/sexp.scm 442 */
																																																																																														obj_t
																																																																																															BgL_arg6897z00_8811;
																																																																																														obj_t
																																																																																															BgL_arg6898z00_8812;
																																																																																														BgL_arg6897z00_8811
																																																																																															=
																																																																																															BGl_letzd2symzd2zzast_letz00
																																																																																															();
																																																																																														{	/* Ast/sexp.scm 442 */
																																																																																															obj_t
																																																																																																BgL_arg6899z00_8813;
																																																																																															obj_t
																																																																																																BgL_arg6900z00_8814;
																																																																																															if (NULLP(BgL_tmpsz00_8807))
																																																																																																{	/* Ast/sexp.scm 442 */
																																																																																																	BgL_arg6899z00_8813
																																																																																																		=
																																																																																																		BNIL;
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 442 */
																																																																																																	obj_t
																																																																																																		BgL_head1357z00_8818;
																																																																																																	{	/* Ast/sexp.scm 442 */
																																																																																																		obj_t
																																																																																																			BgL_arg6911z00_8836;
																																																																																																		{	/* Ast/sexp.scm 442 */
																																																																																																			obj_t
																																																																																																				BgL_arg6912z00_8837;
																																																																																																			obj_t
																																																																																																				BgL_arg6913z00_8838;
																																																																																																			BgL_arg6912z00_8837
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_tmpsz00_8807));
																																																																																																			BgL_arg6913z00_8838
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_argsz00_1744));
																																																																																																			{	/* Ast/sexp.scm 442 */
																																																																																																				obj_t
																																																																																																					BgL_list6914z00_8839;
																																																																																																				{	/* Ast/sexp.scm 442 */
																																																																																																					obj_t
																																																																																																						BgL_arg6915z00_8840;
																																																																																																					BgL_arg6915z00_8840
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6913z00_8838,
																																																																																																						BNIL);
																																																																																																					BgL_list6914z00_8839
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6912z00_8837,
																																																																																																						BgL_arg6915z00_8840);
																																																																																																				}
																																																																																																				BgL_arg6911z00_8836
																																																																																																					=
																																																																																																					BgL_list6914z00_8839;
																																																																																																			}
																																																																																																		}
																																																																																																		{	/* Ast/sexp.scm 442 */
																																																																																																			obj_t
																																																																																																				BgL_res7413z00_9924;
																																																																																																			BgL_res7413z00_9924
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6911z00_8836,
																																																																																																				BNIL);
																																																																																																			BgL_head1357z00_8818
																																																																																																				=
																																																																																																				BgL_res7413z00_9924;
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 442 */
																																																																																																		obj_t
																																																																																																			BgL_g1361z00_8819;
																																																																																																		obj_t
																																																																																																			BgL_g1362z00_8820;
																																																																																																		BgL_g1361z00_8819
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_tmpsz00_8807));
																																																																																																		BgL_g1362z00_8820
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_argsz00_1744));
																																																																																																		{
																																																																																																			obj_t
																																																																																																				BgL_ll1355z00_8822;
																																																																																																			obj_t
																																																																																																				BgL_ll1356z00_8823;
																																																																																																			obj_t
																																																																																																				BgL_tail1358z00_8824;
																																																																																																			BgL_ll1355z00_8822
																																																																																																				=
																																																																																																				BgL_g1361z00_8819;
																																																																																																			BgL_ll1356z00_8823
																																																																																																				=
																																																																																																				BgL_g1362z00_8820;
																																																																																																			BgL_tail1358z00_8824
																																																																																																				=
																																																																																																				BgL_head1357z00_8818;
																																																																																																		BgL_zc3anonymousza36902ze3z83_8825:
																																																																																																			if (NULLP(BgL_ll1355z00_8822))
																																																																																																				{	/* Ast/sexp.scm 442 */
																																																																																																					BgL_arg6899z00_8813
																																																																																																						=
																																																																																																						BgL_head1357z00_8818;
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 442 */
																																																																																																					obj_t
																																																																																																						BgL_newtail1359z00_8827;
																																																																																																					{	/* Ast/sexp.scm 442 */
																																																																																																						obj_t
																																																																																																							BgL_arg6906z00_8830;
																																																																																																						{	/* Ast/sexp.scm 442 */
																																																																																																							obj_t
																																																																																																								BgL_arg6907z00_8831;
																																																																																																							obj_t
																																																																																																								BgL_arg6908z00_8832;
																																																																																																							BgL_arg6907z00_8831
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1355z00_8822));
																																																																																																							BgL_arg6908z00_8832
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1356z00_8823));
																																																																																																							{	/* Ast/sexp.scm 442 */
																																																																																																								obj_t
																																																																																																									BgL_list6909z00_8833;
																																																																																																								{	/* Ast/sexp.scm 442 */
																																																																																																									obj_t
																																																																																																										BgL_arg6910z00_8834;
																																																																																																									BgL_arg6910z00_8834
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6908z00_8832,
																																																																																																										BNIL);
																																																																																																									BgL_list6909z00_8833
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6907z00_8831,
																																																																																																										BgL_arg6910z00_8834);
																																																																																																								}
																																																																																																								BgL_arg6906z00_8830
																																																																																																									=
																																																																																																									BgL_list6909z00_8833;
																																																																																																							}
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 442 */
																																																																																																							obj_t
																																																																																																								BgL_res7416z00_9931;
																																																																																																							BgL_res7416z00_9931
																																																																																																								=
																																																																																																								MAKE_YOUNG_PAIR
																																																																																																								(BgL_arg6906z00_8830,
																																																																																																								BNIL);
																																																																																																							BgL_newtail1359z00_8827
																																																																																																								=
																																																																																																								BgL_res7416z00_9931;
																																																																																																						}
																																																																																																					}
																																																																																																					SET_CDR
																																																																																																						(BgL_tail1358z00_8824,
																																																																																																						BgL_newtail1359z00_8827);
																																																																																																					{	/* Ast/sexp.scm 442 */
																																																																																																						obj_t
																																																																																																							BgL_arg6904z00_8828;
																																																																																																						obj_t
																																																																																																							BgL_arg6905z00_8829;
																																																																																																						BgL_arg6904z00_8828
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1355z00_8822));
																																																																																																						BgL_arg6905z00_8829
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1356z00_8823));
																																																																																																						{
																																																																																																							obj_t
																																																																																																								BgL_tail1358z00_14804;
																																																																																																							obj_t
																																																																																																								BgL_ll1356z00_14803;
																																																																																																							obj_t
																																																																																																								BgL_ll1355z00_14802;
																																																																																																							BgL_ll1355z00_14802
																																																																																																								=
																																																																																																								BgL_arg6904z00_8828;
																																																																																																							BgL_ll1356z00_14803
																																																																																																								=
																																																																																																								BgL_arg6905z00_8829;
																																																																																																							BgL_tail1358z00_14804
																																																																																																								=
																																																																																																								BgL_newtail1359z00_8827;
																																																																																																							BgL_tail1358z00_8824
																																																																																																								=
																																																																																																								BgL_tail1358z00_14804;
																																																																																																							BgL_ll1356z00_8823
																																																																																																								=
																																																																																																								BgL_ll1356z00_14803;
																																																																																																							BgL_ll1355z00_8822
																																																																																																								=
																																																																																																								BgL_ll1355z00_14802;
																																																																																																							goto
																																																																																																								BgL_zc3anonymousza36902ze3z83_8825;
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															{	/* Ast/sexp.scm 443 */
																																																																																																obj_t
																																																																																																	BgL_arg6916z00_8841;
																																																																																																{	/* Ast/sexp.scm 443 */
																																																																																																	obj_t
																																																																																																		BgL_arg6917z00_8842;
																																																																																																	{	/* Ast/sexp.scm 443 */
																																																																																																		obj_t
																																																																																																			BgL_arg6918z00_8843;
																																																																																																		{	/* Ast/sexp.scm 443 */
																																																																																																			obj_t
																																																																																																				BgL_arg6919z00_8844;
																																																																																																			obj_t
																																																																																																				BgL_arg6920z00_8845;
																																																																																																			BgL_arg6919z00_8844
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_proc1z00_1742,
																																																																																																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																				(BgL_tmpsz00_8807,
																																																																																																					BNIL));
																																																																																																			{	/* Ast/sexp.scm 443 */
																																																																																																				obj_t
																																																																																																					BgL_arg6922z00_8847;
																																																																																																				BgL_arg6922z00_8847
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_proc2z00_1743,
																																																																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																					(BgL_tmpsz00_8807,
																																																																																																						BNIL));
																																																																																																				BgL_arg6920z00_8845
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_arg6922z00_8847,
																																																																																																					BNIL);
																																																																																																			}
																																																																																																			BgL_arg6918z00_8843
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6919z00_8844,
																																																																																																				BgL_arg6920z00_8845);
																																																																																																		}
																																																																																																		BgL_arg6917z00_8842
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_testz00_1741,
																																																																																																			BgL_arg6918z00_8843);
																																																																																																	}
																																																																																																	BgL_arg6916z00_8841
																																																																																																		=
																																																																																																		MAKE_YOUNG_PAIR
																																																																																																		(CNST_TABLE_REF
																																																																																																		(((long) 1)), BgL_arg6917z00_8842);
																																																																																																}
																																																																																																BgL_arg6900z00_8814
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BgL_arg6916z00_8841,
																																																																																																	BNIL);
																																																																																															}
																																																																																															BgL_arg6898z00_8812
																																																																																																=
																																																																																																MAKE_YOUNG_PAIR
																																																																																																(BgL_arg6899z00_8813,
																																																																																																BgL_arg6900z00_8814);
																																																																																														}
																																																																																														BgL_nexpz00_8809
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BgL_arg6897z00_8811,
																																																																																															BgL_arg6898z00_8812);
																																																																																													}
																																																																																													{	/* Ast/sexp.scm 442 */

																																																																																														BgL_auxz00_14759
																																																																																															=
																																																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																																																															(BgL_nexpz00_8809,
																																																																																															BgL_stackz00_22,
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_expz00_21,
																																																																																																BgL_locz00_8808),
																																																																																															BgL_sitez00_24);
																																																																																										}}}}
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14759);
																																																																																								}}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																										{	/* Ast/sexp.scm 118 */
																																																																																										BgL_tagzd2403zd2_1769:
																																																																																											BgL_auxz00_14146 = BGl_privatezd2nodezd2zzast_privatez00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																										}
																																																																																									else
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_14823;
																																																																																										BgL_tagzd2404zd2_1770:
																																																																																											BgL_auxz00_14823 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																											BgL_auxz00_14146
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_14823);
																																																																																										}
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1769;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14828;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1770;
																																																																																									BgL_auxz00_14146
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14828);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14832;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14832);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	}
																																																																																}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_14836;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_14836);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd21185zd2_2771;
																																																																												BgL_cdrzd21185zd2_2771
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd21191zd2_2772;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10106;
																																																																														BgL_pairz00_10106
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd21191zd2_2772
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10106);
																																																																													}
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd21197zd2_2773;
																																																																														BgL_cdrzd21197zd2_2773
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd21191zd2_2772));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd21202zd2_2774;
																																																																															obj_t
																																																																																BgL_cdrzd21203zd2_2775;
																																																																															BgL_carzd21202zd2_2774
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2773));
																																																																															BgL_cdrzd21203zd2_2775
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2773));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21202zd2_2774))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd21208zd2_2777;
																																																																																	BgL_carzd21208zd2_2777
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd21203zd2_2775));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21208zd2_2777))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (NULLP(CDR(((obj_t) BgL_cdrzd21203zd2_2775))))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21185zd2_2771))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_arg2393z00_2782;
																																																																																							BgL_arg2393z00_2782
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd21191zd2_2772));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_14863;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_14867;
																																																																																									obj_t
																																																																																										BgL_proc2z00_14866;
																																																																																									obj_t
																																																																																										BgL_proc1z00_14865;
																																																																																									obj_t
																																																																																										BgL_testz00_14864;
																																																																																									BgL_testz00_14864
																																																																																										=
																																																																																										BgL_arg2393z00_2782;
																																																																																									BgL_proc1z00_14865
																																																																																										=
																																																																																										BgL_carzd21202zd2_2774;
																																																																																									BgL_proc2z00_14866
																																																																																										=
																																																																																										BgL_carzd21208zd2_2777;
																																																																																									BgL_argsz00_14867
																																																																																										=
																																																																																										BgL_cdrzd21185zd2_2771;
																																																																																									BgL_argsz00_1744
																																																																																										=
																																																																																										BgL_argsz00_14867;
																																																																																									BgL_proc2z00_1743
																																																																																										=
																																																																																										BgL_proc2z00_14866;
																																																																																									BgL_proc1z00_1742
																																																																																										=
																																																																																										BgL_proc1z00_14865;
																																																																																									BgL_testz00_1741
																																																																																										=
																																																																																										BgL_testz00_14864;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1745;
																																																																																								}
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_14863);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1769;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14871;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1770;
																																																																																									BgL_auxz00_14146
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14871);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14875;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14875);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14879;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14879);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_14883;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_14883);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_14887;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_14887);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd21541zd2_2790;
																																																																								BgL_cdrzd21541zd2_2790
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd21548zd2_2791;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_10116;
																																																																										BgL_pairz00_10116
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd21548zd2_2791
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10116);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd21555zd2_2792;
																																																																										BgL_cdrzd21555zd2_2792
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd21548zd2_2791));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd21561zd2_2793;
																																																																											obj_t
																																																																												BgL_cdrzd21562zd2_2794;
																																																																											BgL_carzd21561zd2_2793
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2792));
																																																																											BgL_cdrzd21562zd2_2794
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2792));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21561zd2_2793))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (PAIRP(BgL_cdrzd21562zd2_2794))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd21569zd2_2797;
																																																																															BgL_carzd21569zd2_2797
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd21562zd2_2794);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21569zd2_2797))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(BgL_cdrzd21562zd2_2794)))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21541zd2_2790))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2410z00_2802;
																																																																																					BgL_arg2410z00_2802
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd21548zd2_2791));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_14914;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_14918;
																																																																																							obj_t
																																																																																								BgL_proc2z00_14917;
																																																																																							obj_t
																																																																																								BgL_proc1z00_14916;
																																																																																							obj_t
																																																																																								BgL_testz00_14915;
																																																																																							BgL_testz00_14915
																																																																																								=
																																																																																								BgL_arg2410z00_2802;
																																																																																							BgL_proc1z00_14916
																																																																																								=
																																																																																								BgL_carzd21561zd2_2793;
																																																																																							BgL_proc2z00_14917
																																																																																								=
																																																																																								BgL_carzd21569zd2_2797;
																																																																																							BgL_argsz00_14918
																																																																																								=
																																																																																								BgL_cdrzd21541zd2_2790;
																																																																																							BgL_argsz00_1744
																																																																																								=
																																																																																								BgL_argsz00_14918;
																																																																																							BgL_proc2z00_1743
																																																																																								=
																																																																																								BgL_proc2z00_14917;
																																																																																							BgL_proc1z00_1742
																																																																																								=
																																																																																								BgL_proc1z00_14916;
																																																																																							BgL_testz00_1741
																																																																																								=
																																																																																								BgL_testz00_14915;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1745;
																																																																																						}
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_14914);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14922;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14922);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14926;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14926);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_14930;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_14930);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14934;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14934);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_14938;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_14938);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_14942;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_14942);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd21962zd2_2816;
																																																								BgL_cdrzd21962zd2_2816
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_14946;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2444z00_2833;
																																																										BgL_arg2444z00_2833
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_14946
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2444z00_2833));
																																																									}
																																																									if (BgL_testz00_14946)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg2431z00_2819;
																																																											obj_t
																																																												BgL_arg2432z00_2820;
																																																											BgL_arg2431z00_2819
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2816));
																																																											BgL_arg2432z00_2820
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2816));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_14955;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_14957;
																																																													obj_t
																																																														BgL_bindingsz00_14956;
																																																													BgL_bindingsz00_14956
																																																														=
																																																														BgL_arg2431z00_2819;
																																																													BgL_exprz00_14957
																																																														=
																																																														BgL_arg2432z00_2820;
																																																													BgL_exprz00_1724
																																																														=
																																																														BgL_exprz00_14957;
																																																													BgL_bindingsz00_1723
																																																														=
																																																														BgL_bindingsz00_14956;
																																																													goto
																																																														BgL_tagzd2382zd2_1725;
																																																												}
																																																												BgL_auxz00_14146
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_14955);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_14959;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2443z00_2832;
																																																												BgL_arg2443z00_2832
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_14959
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2443z00_2832));
																																																											}
																																																											if (BgL_testz00_14959)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_14964;
																																																													goto
																																																														BgL_tagzd2384zd2_1727;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_14964);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd22028zd2_2823;
																																																													BgL_carzd22028zd2_2823
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd22033zd2_2824;
																																																														BgL_cdrzd22033zd2_2824
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd22028zd2_2823));
																																																														if ((CAR(((obj_t) BgL_carzd22028zd2_2823)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg2437z00_2827;
																																																																obj_t
																																																																	BgL_arg2438z00_2828;
																																																																obj_t
																																																																	BgL_arg2439z00_2829;
																																																																BgL_arg2437z00_2827
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2824));
																																																																BgL_arg2438z00_2828
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2824));
																																																																BgL_arg2439z00_2829
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_14981;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_14984;
																																																																		obj_t
																																																																			BgL_bodyz00_14983;
																																																																		obj_t
																																																																			BgL_varsz00_14982;
																																																																		BgL_varsz00_14982
																																																																			=
																																																																			BgL_arg2437z00_2827;
																																																																		BgL_bodyz00_14983
																																																																			=
																																																																			BgL_arg2438z00_2828;
																																																																		BgL_argsz00_14984
																																																																			=
																																																																			BgL_arg2439z00_2829;
																																																																		BgL_argsz00_1734
																																																																			=
																																																																			BgL_argsz00_14984;
																																																																		BgL_bodyz00_1733
																																																																			=
																																																																			BgL_bodyz00_14983;
																																																																		BgL_varsz00_1732
																																																																			=
																																																																			BgL_varsz00_14982;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1735;
																																																																	}
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_14981);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_14988;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_14988);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd22144zd2_2834;
																																																						BgL_cdrzd22144zd2_2834
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_14992;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2453z00_2843;
																																																								BgL_arg2453z00_2843
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_14992
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2453z00_2843));
																																																							}
																																																							if (BgL_testz00_14992)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg2447z00_2837;
																																																									obj_t
																																																										BgL_arg2448z00_2838;
																																																									BgL_arg2447z00_2837
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2834));
																																																									BgL_arg2448z00_2838
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2834));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15001;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15003;
																																																											obj_t
																																																												BgL_bindingsz00_15002;
																																																											BgL_bindingsz00_15002
																																																												=
																																																												BgL_arg2447z00_2837;
																																																											BgL_exprz00_15003
																																																												=
																																																												BgL_arg2448z00_2838;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_15003;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_15002;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15001);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_15005;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2452z00_2842;
																																																										BgL_arg2452z00_2842
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_15005
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2452z00_2842));
																																																									}
																																																									if (BgL_testz00_15005)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15010;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15010);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_15014;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15014);
																																																												}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2709zd2_2570)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd2711zd2_2572;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if ((BgL_carzd2709zd2_2570 == CNST_TABLE_REF(((long) 18))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd2711zd2_2572;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if ((BgL_carzd2709zd2_2570 == CNST_TABLE_REF(((long) 19))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_kapzd2711zd2_2572;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd2709zd2_2570)))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_kapzd2711zd2_2572;
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd22316zd2_2578;
																																																												BgL_cdrzd22316zd2_2578
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_testz00_15030;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2341z00_2695;
																																																														BgL_arg2341z00_2695
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_testz00_15030
																																																															=
																																																															CBOOL
																																																															(BGl_letzd2symzf3z21zzast_letz00
																																																															(BgL_arg2341z00_2695));
																																																													}
																																																													if (BgL_testz00_15030)
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg2263z00_2581;
																																																															obj_t
																																																																BgL_arg2264z00_2582;
																																																															BgL_arg2263z00_2581
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2578));
																																																															BgL_arg2264z00_2582
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2578));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_15039;
																																																																{
																																																																	obj_t
																																																																		BgL_exprz00_15041;
																																																																	obj_t
																																																																		BgL_bindingsz00_15040;
																																																																	BgL_bindingsz00_15040
																																																																		=
																																																																		BgL_arg2263z00_2581;
																																																																	BgL_exprz00_15041
																																																																		=
																																																																		BgL_arg2264z00_2582;
																																																																	BgL_exprz00_1724
																																																																		=
																																																																		BgL_exprz00_15041;
																																																																	BgL_bindingsz00_1723
																																																																		=
																																																																		BgL_bindingsz00_15040;
																																																																	goto
																																																																		BgL_tagzd2382zd2_1725;
																																																																}
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_15039);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															bool_t
																																																																BgL_testz00_15043;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg2340z00_2694;
																																																																BgL_arg2340z00_2694
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_testz00_15043
																																																																	=
																																																																	CBOOL
																																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																																	(BgL_arg2340z00_2694));
																																																															}
																																																															if (BgL_testz00_15043)
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_15048;
																																																																	goto
																																																																		BgL_tagzd2384zd2_1727;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15048);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd22382zd2_2585;
																																																																	BgL_carzd22382zd2_2585
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd22387zd2_2586;
																																																																		BgL_cdrzd22387zd2_2586
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd22382zd2_2585));
																																																																		if ((CAR(((obj_t) BgL_carzd22382zd2_2585)) == CNST_TABLE_REF(((long) 3))))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd22387zd2_2586))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg2272z00_2590;
																																																																						obj_t
																																																																							BgL_arg2273z00_2591;
																																																																						obj_t
																																																																							BgL_arg2274z00_2592;
																																																																						BgL_arg2272z00_2590
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd22387zd2_2586);
																																																																						BgL_arg2273z00_2591
																																																																							=
																																																																							CDR
																																																																							(BgL_cdrzd22387zd2_2586);
																																																																						BgL_arg2274z00_2592
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15065;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_15068;
																																																																								obj_t
																																																																									BgL_bodyz00_15067;
																																																																								obj_t
																																																																									BgL_varsz00_15066;
																																																																								BgL_varsz00_15066
																																																																									=
																																																																									BgL_arg2272z00_2590;
																																																																								BgL_bodyz00_15067
																																																																									=
																																																																									BgL_arg2273z00_2591;
																																																																								BgL_argsz00_15068
																																																																									=
																																																																									BgL_arg2274z00_2592;
																																																																								BgL_argsz00_1734
																																																																									=
																																																																									BgL_argsz00_15068;
																																																																								BgL_bodyz00_1733
																																																																									=
																																																																									BgL_bodyz00_15067;
																																																																								BgL_varsz00_1732
																																																																									=
																																																																									BgL_varsz00_15066;
																																																																								goto
																																																																									BgL_tagzd2386zd2_1735;
																																																																							}
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15065);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_15072;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_15072);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd22494zd2_2595;
																																																																				BgL_cdrzd22494zd2_2595
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd22499zd2_2596;
																																																																					BgL_cdrzd22499zd2_2596
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_carzd22382zd2_2585));
																																																																					if ((CAR(((obj_t) BgL_carzd22382zd2_2585)) == CNST_TABLE_REF(((long) 1))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd22499zd2_2596))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd22504zd2_2600;
																																																																									BgL_cdrzd22504zd2_2600
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd22499zd2_2596);
																																																																									if (PAIRP(BgL_cdrzd22504zd2_2600))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd22508zd2_2602;
																																																																											obj_t
																																																																												BgL_cdrzd22509zd2_2603;
																																																																											BgL_carzd22508zd2_2602
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd22504zd2_2600);
																																																																											BgL_cdrzd22509zd2_2603
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd22504zd2_2600);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22508zd2_2602))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (PAIRP(BgL_cdrzd22509zd2_2603))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd22514zd2_2606;
																																																																															BgL_carzd22514zd2_2606
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd22509zd2_2603);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22514zd2_2606))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(BgL_cdrzd22509zd2_2603)))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			bool_t
																																																																																				BgL_testz00_15100;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1366z00_2639;
																																																																																				BgL_l1366z00_2639
																																																																																					=
																																																																																					BgL_cdrzd22494zd2_2595;
																																																																																			BgL_zc3anonymousza32302ze3z83_2640:
																																																																																				if (NULLP(BgL_l1366z00_2639))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						BgL_testz00_15100
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							1);
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						bool_t
																																																																																							BgL_testz00_15103;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							bool_t
																																																																																								BgL_testz00_15104;
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_tmpz00_15105;
																																																																																								BgL_tmpz00_15105
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_l1366z00_2639));
																																																																																								BgL_testz00_15104
																																																																																									=
																																																																																									PAIRP
																																																																																									(BgL_tmpz00_15105);
																																																																																							}
																																																																																							if (BgL_testz00_15104)
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									BgL_testz00_15103
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										0);
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									BgL_testz00_15103
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										1);
																																																																																								}
																																																																																						}
																																																																																						if (BgL_testz00_15103)
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_l1366z00_15109;
																																																																																								BgL_l1366z00_15109
																																																																																									=
																																																																																									CDR
																																																																																									(
																																																																																									((obj_t) BgL_l1366z00_2639));
																																																																																								BgL_l1366z00_2639
																																																																																									=
																																																																																									BgL_l1366z00_15109;
																																																																																								goto
																																																																																									BgL_zc3anonymousza32302ze3z83_2640;
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								BgL_testz00_15100
																																																																																									=
																																																																																									(
																																																																																									(bool_t)
																																																																																									0);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																			if (BgL_testz00_15100)
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2290z00_2622;
																																																																																					BgL_arg2290z00_2622
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_cdrzd22499zd2_2596);
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15113;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15117;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15116;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15115;
																																																																																							obj_t
																																																																																								BgL_testz00_15114;
																																																																																							BgL_testz00_15114
																																																																																								=
																																																																																								BgL_arg2290z00_2622;
																																																																																							BgL_proc1z00_15115
																																																																																								=
																																																																																								BgL_carzd22508zd2_2602;
																																																																																							BgL_proc2z00_15116
																																																																																								=
																																																																																								BgL_carzd22514zd2_2606;
																																																																																							BgL_argsz00_15117
																																																																																								=
																																																																																								BgL_cdrzd22494zd2_2595;
																																																																																							BgL_argsz00_1739
																																																																																								=
																																																																																								BgL_argsz00_15117;
																																																																																							BgL_proc2z00_1738
																																																																																								=
																																																																																								BgL_proc2z00_15116;
																																																																																							BgL_proc1z00_1737
																																																																																								=
																																																																																								BgL_proc1z00_15115;
																																																																																							BgL_testz00_1736
																																																																																								=
																																																																																								BgL_testz00_15114;
																																																																																							goto
																																																																																								BgL_tagzd2387zd2_1740;
																																																																																						}
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15113);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_cdrzd22539zd2_2623;
																																																																																					BgL_cdrzd22539zd2_2623
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_cdrzd22547zd2_2624;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10173;
																																																																																							BgL_pairz00_10173
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_expz00_21));
																																																																																							BgL_cdrzd22547zd2_2624
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_pairz00_10173);
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_cdrzd22555zd2_2625;
																																																																																							BgL_cdrzd22555zd2_2625
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd22547zd2_2624));
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_carzd22562zd2_2626;
																																																																																								BgL_carzd22562zd2_2626
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd22555zd2_2625));
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22562zd2_2626))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_carzd22571zd2_2628;
																																																																																										{	/* Ast/sexp.scm 118 */
																																																																																											obj_t
																																																																																												BgL_pairz00_10177;
																																																																																											BgL_pairz00_10177
																																																																																												=
																																																																																												CDR
																																																																																												(
																																																																																												((obj_t) BgL_cdrzd22555zd2_2625));
																																																																																											BgL_carzd22571zd2_2628
																																																																																												=
																																																																																												CAR
																																																																																												(BgL_pairz00_10177);
																																																																																										}
																																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22571zd2_2628))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22539zd2_2623))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														obj_t
																																																																																															BgL_arg2295z00_2631;
																																																																																														BgL_arg2295z00_2631
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_cdrzd22547zd2_2624));
																																																																																														{
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_auxz00_15139;
																																																																																															{
																																																																																																obj_t
																																																																																																	BgL_argsz00_15143;
																																																																																																obj_t
																																																																																																	BgL_proc2z00_15142;
																																																																																																obj_t
																																																																																																	BgL_proc1z00_15141;
																																																																																																obj_t
																																																																																																	BgL_testz00_15140;
																																																																																																BgL_testz00_15140
																																																																																																	=
																																																																																																	BgL_arg2295z00_2631;
																																																																																																BgL_proc1z00_15141
																																																																																																	=
																																																																																																	BgL_carzd22562zd2_2626;
																																																																																																BgL_proc2z00_15142
																																																																																																	=
																																																																																																	BgL_carzd22571zd2_2628;
																																																																																																BgL_argsz00_15143
																																																																																																	=
																																																																																																	BgL_cdrzd22539zd2_2623;
																																																																																																BgL_argsz00_1744
																																																																																																	=
																																																																																																	BgL_argsz00_15143;
																																																																																																BgL_proc2z00_1743
																																																																																																	=
																																																																																																	BgL_proc2z00_15142;
																																																																																																BgL_proc1z00_1742
																																																																																																	=
																																																																																																	BgL_proc1z00_15141;
																																																																																																BgL_testz00_1741
																																																																																																	=
																																																																																																	BgL_testz00_15140;
																																																																																																goto
																																																																																																	BgL_tagzd2388zd2_1745;
																																																																																															}
																																																																																															BgL_auxz00_14146
																																																																																																=
																																																																																																(
																																																																																																(obj_t)
																																																																																																BgL_auxz00_15139);
																																																																																														}
																																																																																													}
																																																																																												else
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																															{	/* Ast/sexp.scm 118 */
																																																																																																goto
																																																																																																	BgL_tagzd2403zd2_1769;
																																																																																															}
																																																																																														else
																																																																																															{
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_auxz00_15147;
																																																																																																goto
																																																																																																	BgL_tagzd2404zd2_1770;
																																																																																																BgL_auxz00_14146
																																																																																																	=
																																																																																																	(
																																																																																																	(obj_t)
																																																																																																	BgL_auxz00_15147);
																																																																																															}
																																																																																													}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1769;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15151;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1770;
																																																																																														BgL_auxz00_14146
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15151);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15155;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_14146
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15155);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15159;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15159);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd22849zd2_2650;
																																																																																	BgL_cdrzd22849zd2_2650
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd22856zd2_2651;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10181;
																																																																																			BgL_pairz00_10181
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd22856zd2_2651
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10181);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd22863zd2_2652;
																																																																																			BgL_cdrzd22863zd2_2652
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd22856zd2_2651));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd22869zd2_2653;
																																																																																				obj_t
																																																																																					BgL_cdrzd22870zd2_2654;
																																																																																				BgL_carzd22869zd2_2653
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2652));
																																																																																				BgL_cdrzd22870zd2_2654
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2652));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22869zd2_2653))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd22877zd2_2656;
																																																																																						BgL_carzd22877zd2_2656
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd22870zd2_2654));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22877zd2_2656))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd22870zd2_2654))))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22849zd2_2650))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												obj_t
																																																																																													BgL_arg2312z00_2661;
																																																																																												BgL_arg2312z00_2661
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd22856zd2_2651));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_15186;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_15190;
																																																																																														obj_t
																																																																																															BgL_proc2z00_15189;
																																																																																														obj_t
																																																																																															BgL_proc1z00_15188;
																																																																																														obj_t
																																																																																															BgL_testz00_15187;
																																																																																														BgL_testz00_15187
																																																																																															=
																																																																																															BgL_arg2312z00_2661;
																																																																																														BgL_proc1z00_15188
																																																																																															=
																																																																																															BgL_carzd22869zd2_2653;
																																																																																														BgL_proc2z00_15189
																																																																																															=
																																																																																															BgL_carzd22877zd2_2656;
																																																																																														BgL_argsz00_15190
																																																																																															=
																																																																																															BgL_cdrzd22849zd2_2650;
																																																																																														BgL_argsz00_1744
																																																																																															=
																																																																																															BgL_argsz00_15190;
																																																																																														BgL_proc2z00_1743
																																																																																															=
																																																																																															BgL_proc2z00_15189;
																																																																																														BgL_proc1z00_1742
																																																																																															=
																																																																																															BgL_proc1z00_15188;
																																																																																														BgL_testz00_1741
																																																																																															=
																																																																																															BgL_testz00_15187;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1745;
																																																																																													}
																																																																																													BgL_auxz00_14146
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_15186);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1769;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15194;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1770;
																																																																																														BgL_auxz00_14146
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15194);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15198;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_14146
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15198);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15202;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15202);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15206;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15206);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15210;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15210);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd23210zd2_2669;
																																																																													BgL_cdrzd23210zd2_2669
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd23216zd2_2670;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10191;
																																																																															BgL_pairz00_10191
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd23216zd2_2670
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10191);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd23222zd2_2671;
																																																																															BgL_cdrzd23222zd2_2671
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd23216zd2_2670));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd23227zd2_2672;
																																																																																obj_t
																																																																																	BgL_cdrzd23228zd2_2673;
																																																																																BgL_carzd23227zd2_2672
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2671));
																																																																																BgL_cdrzd23228zd2_2673
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2671));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23227zd2_2672))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (PAIRP(BgL_cdrzd23228zd2_2673))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd23233zd2_2676;
																																																																																				BgL_carzd23233zd2_2676
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_cdrzd23228zd2_2673);
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23233zd2_2676))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (NULLP(CDR(BgL_cdrzd23228zd2_2673)))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd23210zd2_2669))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg2327z00_2681;
																																																																																										BgL_arg2327z00_2681
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd23216zd2_2670));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_15237;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_15241;
																																																																																												obj_t
																																																																																													BgL_proc2z00_15240;
																																																																																												obj_t
																																																																																													BgL_proc1z00_15239;
																																																																																												obj_t
																																																																																													BgL_testz00_15238;
																																																																																												BgL_testz00_15238
																																																																																													=
																																																																																													BgL_arg2327z00_2681;
																																																																																												BgL_proc1z00_15239
																																																																																													=
																																																																																													BgL_carzd23227zd2_2672;
																																																																																												BgL_proc2z00_15240
																																																																																													=
																																																																																													BgL_carzd23233zd2_2676;
																																																																																												BgL_argsz00_15241
																																																																																													=
																																																																																													BgL_cdrzd23210zd2_2669;
																																																																																												BgL_argsz00_1744
																																																																																													=
																																																																																													BgL_argsz00_15241;
																																																																																												BgL_proc2z00_1743
																																																																																													=
																																																																																													BgL_proc2z00_15240;
																																																																																												BgL_proc1z00_1742
																																																																																													=
																																																																																													BgL_proc1z00_15239;
																																																																																												BgL_testz00_1741
																																																																																													=
																																																																																													BgL_testz00_15238;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1745;
																																																																																											}
																																																																																											BgL_auxz00_14146
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_15237);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15245;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_14146
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15245);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15249;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15249);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15253;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15253);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15257;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15257);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15261;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15261);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15265;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15265);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15269;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15269);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_15273;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_15273);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd23771zd2_2845;
																																																	BgL_cdrzd23771zd2_2845
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd2706zd2_2568 == CNST_TABLE_REF(((long) 17))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2455z00_2847;
																																																			obj_t
																																																				BgL_arg2456z00_2848;
																																																			BgL_arg2455z00_2847
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2845));
																																																			BgL_arg2456z00_2848
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2845));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_15284;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_15286;
																																																					obj_t
																																																						BgL_bindingsz00_15285;
																																																					BgL_bindingsz00_15285
																																																						=
																																																						BgL_arg2455z00_2847;
																																																					BgL_exprz00_15286
																																																						=
																																																						BgL_arg2456z00_2848;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_15286;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_15285;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_15284);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2706zd2_2568)))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg2458z00_2850;
																																																					obj_t
																																																						BgL_arg2459z00_2851;
																																																					BgL_arg2458z00_2850
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2845));
																																																					BgL_arg2459z00_2851
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2845));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_15295;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_15297;
																																																							obj_t
																																																								BgL_bindingsz00_15296;
																																																							BgL_bindingsz00_15296
																																																								=
																																																								BgL_arg2458z00_2850;
																																																							BgL_exprz00_15297
																																																								=
																																																								BgL_arg2459z00_2851;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_15297;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_15296;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_14146
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_15295);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((BgL_carzd2706zd2_2568 == CNST_TABLE_REF(((long) 18))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg2461z00_2853;
																																																							obj_t
																																																								BgL_arg2462z00_2854;
																																																							BgL_arg2461z00_2853
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2845));
																																																							BgL_arg2462z00_2854
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2845));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_15306;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_15308;
																																																									obj_t
																																																										BgL_bindingsz00_15307;
																																																									BgL_bindingsz00_15307
																																																										=
																																																										BgL_arg2461z00_2853;
																																																									BgL_exprz00_15308
																																																										=
																																																										BgL_arg2462z00_2854;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_15308;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_15307;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_15306);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15315;
																																																								BgL_tagzd2383zd2_1726:
																																																									BgL_auxz00_15315 = BGl_letrecza2zd2ze3nodez93zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15315);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd23808zd2_2857;
																																																									BgL_carzd23808zd2_2857
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((BgL_carzd23808zd2_2857 == CNST_TABLE_REF(((long) 19))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15324;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15324);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd23808zd2_2857)))
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15329;
																																																													goto
																																																														BgL_tagzd2384zd2_1727;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15329);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15336;
																																																														BgL_tagzd2389zd2_1746:
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_8863;
																																																																obj_t
																																																																	BgL_bodyz00_8864;
																																																																if (PAIRP(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd262362zd2_8869;
																																																																		BgL_cdrzd262362zd2_8869
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		if (PAIRP(BgL_cdrzd262362zd2_8869))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_argsz00_8863
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd262362zd2_8869);
																																																																				BgL_bodyz00_8864
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd262362zd2_8869);
																																																																				{	/* Ast/sexp.scm 450 */
																																																																					obj_t
																																																																						BgL_locz00_8873;
																																																																					obj_t
																																																																						BgL_funz00_8874;
																																																																					BgL_locz00_8873
																																																																						=
																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																						(BgL_expz00_21,
																																																																						BgL_locz00_23);
																																																																					BgL_funz00_8874
																																																																						=
																																																																						BGl_makezd2anonymouszd2namez00zzast_sexpz00
																																																																						(BgL_locz00_23,
																																																																						BNIL);
																																																																					{	/* Ast/sexp.scm 452 */
																																																																						obj_t
																																																																							BgL_arg6933z00_8875;
																																																																						{	/* Ast/sexp.scm 452 */
																																																																							obj_t
																																																																								BgL_arg6934z00_8876;
																																																																							obj_t
																																																																								BgL_arg6935z00_8877;
																																																																							BgL_arg6934z00_8876
																																																																								=
																																																																								BGl_labelszd2symzd2zzast_labelsz00
																																																																								();
																																																																							{	/* Ast/sexp.scm 452 */
																																																																								obj_t
																																																																									BgL_arg6936z00_8878;
																																																																								obj_t
																																																																									BgL_arg6937z00_8879;
																																																																								{	/* Ast/sexp.scm 452 */
																																																																									obj_t
																																																																										BgL_arg6938z00_8880;
																																																																									{	/* Ast/sexp.scm 452 */
																																																																										obj_t
																																																																											BgL_arg6939z00_8881;
																																																																										{	/* Ast/sexp.scm 452 */
																																																																											obj_t
																																																																												BgL_arg6940z00_8882;
																																																																											BgL_arg6940z00_8882
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																												(BgL_bodyz00_8864),
																																																																												BNIL);
																																																																											BgL_arg6939z00_8881
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_argsz00_8863,
																																																																												BgL_arg6940z00_8882);
																																																																										}
																																																																										BgL_arg6938z00_8880
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(BgL_funz00_8874,
																																																																											BgL_arg6939z00_8881);
																																																																									}
																																																																									BgL_arg6936z00_8878
																																																																										=
																																																																										MAKE_YOUNG_PAIR
																																																																										(BgL_arg6938z00_8880,
																																																																										BNIL);
																																																																								}
																																																																								BgL_arg6937z00_8879
																																																																									=
																																																																									MAKE_YOUNG_PAIR
																																																																									(BgL_funz00_8874,
																																																																									BNIL);
																																																																								BgL_arg6935z00_8877
																																																																									=
																																																																									MAKE_YOUNG_PAIR
																																																																									(BgL_arg6936z00_8878,
																																																																									BgL_arg6937z00_8879);
																																																																							}
																																																																							BgL_arg6933z00_8875
																																																																								=
																																																																								MAKE_YOUNG_PAIR
																																																																								(BgL_arg6934z00_8876,
																																																																								BgL_arg6935z00_8877);
																																																																						}
																																																																						BgL_auxz00_15336
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_arg6933z00_8875,
																																																																							BgL_stackz00_22,
																																																																							BgL_locz00_8873,
																																																																							BgL_sitez00_24);
																																																																					}
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																			BgL_tagzd262355zd2_8866:
																																																																				{	/* Ast/sexp.scm 459 */
																																																																					obj_t
																																																																						BgL_arg6943z00_8885;
																																																																					BgL_arg6943z00_8885
																																																																						=
																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																						(BgL_expz00_21,
																																																																						BgL_locz00_23);
																																																																					{	/* Ast/sexp.scm 457 */
																																																																						BgL_nodez00_bglt
																																																																							BgL_res7417z00_9940;
																																																																						{	/* Ast/sexp.scm 717 */
																																																																							obj_t
																																																																								BgL_arg7100z00_9936;
																																																																							BgL_nodez00_bglt
																																																																								BgL_arg7101z00_9937;
																																																																							BgL_arg7100z00_9936
																																																																								=
																																																																								BGl_shapez00zztools_shapez00
																																																																								(BGl_currentzd2functionzd2zztools_errorz00
																																																																								());
																																																																							BgL_arg7101z00_9937
																																																																								=
																																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																								(CNST_TABLE_REF
																																																																								(((long) 4)), BNIL, BgL_arg6943z00_8885, CNST_TABLE_REF(((long) 2)));
																																																																							{	/* Ast/sexp.scm 716 */
																																																																								obj_t
																																																																									BgL_list7102z00_9939;
																																																																								BgL_list7102z00_9939
																																																																									=
																																																																									MAKE_YOUNG_PAIR
																																																																									(
																																																																									((obj_t) BgL_arg7101z00_9937), BNIL);
																																																																								BgL_res7417z00_9940
																																																																									=
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																									(BgL_arg6943z00_8885,
																																																																										BgL_arg7100z00_9936,
																																																																										BGl_string7976z00zzast_sexpz00,
																																																																										BgL_expz00_21,
																																																																										BgL_list7102z00_9939));
																																																																						}}
																																																																						BgL_auxz00_15336
																																																																							=
																																																																							BgL_res7417z00_9940;
																																																																	}}}}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd262355zd2_8866;
																																																																	}
																																																															}
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15336);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15372;
																																																																BgL_tagzd2390zd2_1747:
																																																																	BgL_auxz00_15372 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15372);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd23888zd2_2864;
																																																																	BgL_cdrzd23888zd2_2864
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg2473z00_2867;
																																																																			obj_t
																																																																				BgL_arg2475z00_2868;
																																																																			BgL_arg2473z00_2867
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2864));
																																																																			BgL_arg2475z00_2868
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2864));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_15387;
																																																																				BgL_effectz00_1748
																																																																					=
																																																																					BgL_arg2473z00_2867;
																																																																				BgL_restz00_1749
																																																																					=
																																																																					BgL_arg2475z00_2868;
																																																																			BgL_tagzd2391zd2_1750:
																																																																				{	/* Ast/sexp.scm 466 */
																																																																					BgL_feffectz00_bglt
																																																																						BgL_arg6944z00_8886;
																																																																					obj_t
																																																																						BgL_arg6945z00_8887;
																																																																					BgL_arg6944z00_8886
																																																																						=
																																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																						(BgL_effectz00_1748);
																																																																					{	/* Ast/sexp.scm 467 */
																																																																						obj_t
																																																																							BgL_arg6946z00_8888;
																																																																						BgL_arg6946z00_8888
																																																																							=
																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																							(BgL_restz00_1749,
																																																																							BNIL);
																																																																						BgL_arg6945z00_8887
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(CNST_TABLE_REF
																																																																							(((long) 6)), BgL_arg6946z00_8888);
																																																																					}
																																																																					BgL_auxz00_15387
																																																																						=
																																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																						(
																																																																						((bool_t) 0), ((obj_t) BgL_arg6944z00_8886), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6945z00_8887, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																				}
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_15387);
																																																																		}}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15401;
																																																																				BgL_tagzd2392zd2_1751:
																																																																					BgL_auxz00_15401 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15401);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15410;
																																																																						BgL_tagzd2393zd2_1752:
																																																																							{	/* Ast/sexp.scm 473 */
																																																																								bool_t
																																																																									BgL_testz00_15411;
																																																																								if (NULLP(BgL_stackz00_22))
																																																																									{	/* Ast/sexp.scm 473 */
																																																																										BgL_testz00_15411
																																																																											=
																																																																											(BgL_sitez00_24
																																																																											==
																																																																											CNST_TABLE_REF
																																																																											(((long) 2)));
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 473 */
																																																																										BgL_testz00_15411
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								if (BgL_testz00_15411)
																																																																									{	/* Ast/sexp.scm 473 */
																																																																										{	/* Ast/sexp.scm 477 */
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg6949z00_8891;
																																																																											BgL_arg6949z00_8891
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																											BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00
																																																																												(BgL_arg6949z00_8891);
																																																																										}
																																																																										BgL_auxz00_15410
																																																																											=
																																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																											(BUNSPEC,
																																																																											BgL_stackz00_22,
																																																																											BgL_locz00_23,
																																																																											BgL_sitez00_24);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 474 */
																																																																										BgL_nodez00_bglt
																																																																											BgL_res7421z00_9952;
																																																																										{	/* Ast/sexp.scm 717 */
																																																																											obj_t
																																																																												BgL_arg7100z00_9948;
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg7101z00_9949;
																																																																											BgL_arg7100z00_9948
																																																																												=
																																																																												BGl_shapez00zztools_shapez00
																																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																																												());
																																																																											BgL_arg7101z00_9949
																																																																												=
																																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																												(CNST_TABLE_REF
																																																																												(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																																											{	/* Ast/sexp.scm 716 */
																																																																												obj_t
																																																																													BgL_list7102z00_9951;
																																																																												BgL_list7102z00_9951
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(
																																																																													((obj_t) BgL_arg7101z00_9949), BNIL);
																																																																												BgL_res7421z00_9952
																																																																													=
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																													(BgL_locz00_23,
																																																																														BgL_arg7100z00_9948,
																																																																														BGl_string7975z00zzast_sexpz00,
																																																																														BgL_expz00_21,
																																																																														BgL_list7102z00_9951));
																																																																										}}
																																																																										BgL_auxz00_15410
																																																																											=
																																																																											BgL_res7421z00_9952;
																																																																							}}
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15410);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg2483z00_2876;
																																																																									obj_t
																																																																										BgL_arg2484z00_2877;
																																																																									BgL_arg2483z00_2876
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2864));
																																																																									BgL_arg2484z00_2877
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2864));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15439;
																																																																										BgL_effectz00_1753
																																																																											=
																																																																											BgL_arg2483z00_2876;
																																																																										BgL_restz00_1754
																																																																											=
																																																																											BgL_arg2484z00_2877;
																																																																									BgL_tagzd2394zd2_1755:
																																																																										{	/* Ast/sexp.scm 482 */
																																																																											BgL_feffectz00_bglt
																																																																												BgL_arg6950z00_8893;
																																																																											obj_t
																																																																												BgL_arg6951z00_8894;
																																																																											BgL_arg6950z00_8893
																																																																												=
																																																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																												(BgL_effectz00_1753);
																																																																											{	/* Ast/sexp.scm 483 */
																																																																												obj_t
																																																																													BgL_arg6952z00_8895;
																																																																												BgL_arg6952z00_8895
																																																																													=
																																																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																													(BgL_restz00_1754,
																																																																													BNIL);
																																																																												BgL_arg6951z00_8894
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(CNST_TABLE_REF
																																																																													(((long) 6)), BgL_arg6952z00_8895);
																																																																											}
																																																																											BgL_auxz00_15439
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), ((obj_t) BgL_arg6950z00_8893), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6951z00_8894, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																										}
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15439);
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15453;
																																																																										BgL_tagzd2395zd2_1756:
																																																																											{
																																																																												obj_t
																																																																													BgL_procz00_8896;
																																																																												obj_t
																																																																													BgL_msgz00_8897;
																																																																												obj_t
																																																																													BgL_objz00_8898;
																																																																												if (PAIRP(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd262379zd2_8903;
																																																																														BgL_cdrzd262379zd2_8903
																																																																															=
																																																																															CDR
																																																																															(BgL_expz00_21);
																																																																														if (PAIRP(BgL_cdrzd262379zd2_8903))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd262384zd2_8905;
																																																																																BgL_cdrzd262384zd2_8905
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd262379zd2_8903);
																																																																																if (PAIRP(BgL_cdrzd262384zd2_8905))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd262389zd2_8907;
																																																																																		BgL_cdrzd262389zd2_8907
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262384zd2_8905);
																																																																																		if (PAIRP(BgL_cdrzd262389zd2_8907))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(BgL_cdrzd262389zd2_8907)))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg6959z00_8911;
																																																																																						obj_t
																																																																																							BgL_arg6960z00_8912;
																																																																																						obj_t
																																																																																							BgL_arg6961z00_8913;
																																																																																						BgL_arg6959z00_8911
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262379zd2_8903);
																																																																																						BgL_arg6960z00_8912
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262384zd2_8905);
																																																																																						BgL_arg6961z00_8913
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262389zd2_8907);
																																																																																						{
																																																																																							BgL_failz00_bglt
																																																																																								BgL_auxz00_15471;
																																																																																							BgL_procz00_8896
																																																																																								=
																																																																																								BgL_arg6959z00_8911;
																																																																																							BgL_msgz00_8897
																																																																																								=
																																																																																								BgL_arg6960z00_8912;
																																																																																							BgL_objz00_8898
																																																																																								=
																																																																																								BgL_arg6961z00_8913;
																																																																																							{	/* Ast/sexp.scm 488 */
																																																																																								obj_t
																																																																																									BgL_locz00_8915;
																																																																																								BgL_locz00_8915
																																																																																									=
																																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																									(BgL_expz00_21,
																																																																																									BgL_locz00_23);
																																																																																								{	/* Ast/sexp.scm 488 */
																																																																																									obj_t
																																																																																										BgL_cdlocz00_8916;
																																																																																									{	/* Ast/sexp.scm 489 */
																																																																																										obj_t
																																																																																											BgL_arg6966z00_8930;
																																																																																										BgL_arg6966z00_8930
																																																																																											=
																																																																																											CDR
																																																																																											(
																																																																																											((obj_t) BgL_expz00_21));
																																																																																										BgL_cdlocz00_8916
																																																																																											=
																																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																											(BgL_arg6966z00_8930,
																																																																																											BgL_locz00_8915);
																																																																																									}
																																																																																									{	/* Ast/sexp.scm 489 */
																																																																																										obj_t
																																																																																											BgL_cddlocz00_8917;
																																																																																										{	/* Ast/sexp.scm 490 */
																																																																																											obj_t
																																																																																												BgL_arg6965z00_8929;
																																																																																											{	/* Ast/sexp.scm 490 */
																																																																																												obj_t
																																																																																													BgL_pairz00_9957;
																																																																																												BgL_pairz00_9957
																																																																																													=
																																																																																													CDR
																																																																																													(
																																																																																													((obj_t) BgL_expz00_21));
																																																																																												BgL_arg6965z00_8929
																																																																																													=
																																																																																													CDR
																																																																																													(BgL_pairz00_9957);
																																																																																											}
																																																																																											BgL_cddlocz00_8917
																																																																																												=
																																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																												(BgL_arg6965z00_8929,
																																																																																												BgL_locz00_8915);
																																																																																										}
																																																																																										{	/* Ast/sexp.scm 490 */
																																																																																											obj_t
																																																																																												BgL_cdddlocz00_8918;
																																																																																											{	/* Ast/sexp.scm 491 */
																																																																																												obj_t
																																																																																													BgL_arg6964z00_8928;
																																																																																												{	/* Ast/sexp.scm 491 */
																																																																																													obj_t
																																																																																														BgL_pairz00_9963;
																																																																																													{	/* Ast/sexp.scm 491 */
																																																																																														obj_t
																																																																																															BgL_pairz00_9962;
																																																																																														BgL_pairz00_9962
																																																																																															=
																																																																																															CDR
																																																																																															(
																																																																																															((obj_t) BgL_expz00_21));
																																																																																														BgL_pairz00_9963
																																																																																															=
																																																																																															CDR
																																																																																															(BgL_pairz00_9962);
																																																																																													}
																																																																																													BgL_arg6964z00_8928
																																																																																														=
																																																																																														CDR
																																																																																														(BgL_pairz00_9963);
																																																																																												}
																																																																																												BgL_cdddlocz00_8918
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_arg6964z00_8928,
																																																																																													BgL_locz00_8915);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 491 */
																																																																																												obj_t
																																																																																													BgL_loczd2proczd2_8919;
																																																																																												BgL_loczd2proczd2_8919
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_procz00_8896,
																																																																																													BgL_cdlocz00_8916);
																																																																																												{	/* Ast/sexp.scm 492 */
																																																																																													obj_t
																																																																																														BgL_loczd2msgzd2_8920;
																																																																																													BgL_loczd2msgzd2_8920
																																																																																														=
																																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																														(BgL_msgz00_8897,
																																																																																														BgL_cddlocz00_8917);
																																																																																													{	/* Ast/sexp.scm 493 */
																																																																																														obj_t
																																																																																															BgL_loczd2objzd2_8921;
																																																																																														BgL_loczd2objzd2_8921
																																																																																															=
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_objz00_8898,
																																																																																															BgL_cdddlocz00_8918);
																																																																																														{	/* Ast/sexp.scm 494 */
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_procz00_8922;
																																																																																															BgL_procz00_8922
																																																																																																=
																																																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																(BgL_procz00_8896,
																																																																																																BgL_stackz00_22,
																																																																																																BgL_loczd2proczd2_8919,
																																																																																																CNST_TABLE_REF
																																																																																																(((long) 2)));
																																																																																															{	/* Ast/sexp.scm 495 */
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_msgz00_8923;
																																																																																																BgL_msgz00_8923
																																																																																																	=
																																																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																	(BgL_msgz00_8897,
																																																																																																	BgL_stackz00_22,
																																																																																																	BgL_loczd2msgzd2_8920,
																																																																																																	CNST_TABLE_REF
																																																																																																	(((long) 2)));
																																																																																																{	/* Ast/sexp.scm 496 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_objz00_8924;
																																																																																																	BgL_objz00_8924
																																																																																																		=
																																																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																		(BgL_objz00_8898,
																																																																																																		BgL_stackz00_22,
																																																																																																		BgL_loczd2objzd2_8921,
																																																																																																		CNST_TABLE_REF
																																																																																																		(((long) 2)));
																																																																																																	{	/* Ast/sexp.scm 497 */

																																																																																																		{	/* Ast/sexp.scm 498 */
																																																																																																			BgL_failz00_bglt
																																																																																																				BgL_new1139z00_8925;
																																																																																																			{	/* Ast/sexp.scm 499 */
																																																																																																				BgL_failz00_bglt
																																																																																																					BgL_new1138z00_8926;
																																																																																																				BgL_new1138z00_8926
																																																																																																					=
																																																																																																					(
																																																																																																					(BgL_failz00_bglt)
																																																																																																					BOBJECT
																																																																																																					(GC_MALLOC
																																																																																																						(sizeof
																																																																																																							(struct
																																																																																																								BgL_failz00_bgl))));
																																																																																																				{	/* Ast/sexp.scm 499 */
																																																																																																					long
																																																																																																						BgL_arg6963z00_8927;
																																																																																																					{	/* Ast/sexp.scm 499 */
																																																																																																						long
																																																																																																							BgL_res7422z00_9965;
																																																																																																						BgL_res7422z00_9965
																																																																																																							=
																																																																																																							BGL_CLASS_INDEX
																																																																																																							(BGl_failz00zzast_nodez00);
																																																																																																						BgL_arg6963z00_8927
																																																																																																							=
																																																																																																							BgL_res7422z00_9965;
																																																																																																					}
																																																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																																																						(
																																																																																																						((BgL_objectz00_bglt) BgL_new1138z00_8926), BgL_arg6963z00_8927);
																																																																																																				}
																																																																																																				{	/* Ast/sexp.scm 499 */
																																																																																																					BgL_objectz00_bglt
																																																																																																						BgL_tmpz00_15498;
																																																																																																					BgL_tmpz00_15498
																																																																																																						=
																																																																																																						(
																																																																																																						(BgL_objectz00_bglt)
																																																																																																						BgL_new1138z00_8926);
																																																																																																					BGL_OBJECT_WIDENING_SET
																																																																																																						(BgL_tmpz00_15498,
																																																																																																						BFALSE);
																																																																																																				}
																																																																																																				BgL_new1139z00_8925
																																																																																																					=
																																																																																																					BgL_new1138z00_8926;
																																																																																																			}
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1139z00_8925)))->BgL_locz00) = ((obj_t) BgL_locz00_8915), BUNSPEC);
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1139z00_8925)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00)), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1139z00_8925))->BgL_procz00) = ((BgL_nodez00_bglt) BgL_procz00_8922), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1139z00_8925))->BgL_msgz00) = ((BgL_nodez00_bglt) BgL_msgz00_8923), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1139z00_8925))->BgL_objz00) = ((BgL_nodez00_bglt) BgL_objz00_8924), BUNSPEC);
																																																																																																			BgL_auxz00_15471
																																																																																																				=
																																																																																																				BgL_new1139z00_8925;
																																																																																							}}}}}}}}}}}}
																																																																																							BgL_auxz00_15453
																																																																																								=
																																																																																								(
																																																																																								(BgL_nodez00_bglt)
																																																																																								BgL_auxz00_15471);
																																																																																					}}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																					BgL_tagzd262370zd2_8900:
																																																																																						{	/* Ast/sexp.scm 506 */
																																																																																							obj_t
																																																																																								BgL_arg6967z00_8931;
																																																																																							BgL_arg6967z00_8931
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_expz00_21,
																																																																																								BgL_locz00_23);
																																																																																							{	/* Ast/sexp.scm 505 */
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_res7423z00_9973;
																																																																																								{	/* Ast/sexp.scm 717 */
																																																																																									obj_t
																																																																																										BgL_arg7100z00_9969;
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_arg7101z00_9970;
																																																																																									BgL_arg7100z00_9969
																																																																																										=
																																																																																										BGl_shapez00zztools_shapez00
																																																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																																																										());
																																																																																									BgL_arg7101z00_9970
																																																																																										=
																																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																										(CNST_TABLE_REF
																																																																																										(((long) 4)), BNIL, BgL_arg6967z00_8931, CNST_TABLE_REF(((long) 2)));
																																																																																									{	/* Ast/sexp.scm 716 */
																																																																																										obj_t
																																																																																											BgL_list7102z00_9972;
																																																																																										BgL_list7102z00_9972
																																																																																											=
																																																																																											MAKE_YOUNG_PAIR
																																																																																											(
																																																																																											((obj_t) BgL_arg7101z00_9970), BNIL);
																																																																																										BgL_res7423z00_9973
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																											(BgL_arg6967z00_8931,
																																																																																												BgL_arg7100z00_9969,
																																																																																												BGl_string7974z00zzast_sexpz00,
																																																																																												BgL_expz00_21,
																																																																																												BgL_list7102z00_9972));
																																																																																								}}
																																																																																								BgL_auxz00_15453
																																																																																									=
																																																																																									BgL_res7423z00_9973;
																																																																																			}}}}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd262370zd2_8900;
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd262370zd2_8900;
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd262370zd2_8900;
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd262370zd2_8900;
																																																																													}
																																																																											}
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15453);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15526;
																																																																												BgL_tagzd2396zd2_1757:
																																																																													{
																																																																														obj_t
																																																																															BgL_testz00_8932;
																																																																														obj_t
																																																																															BgL_clausesz00_8933;
																																																																														if (PAIRP(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd262403zd2_8938;
																																																																																BgL_cdrzd262403zd2_8938
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_expz00_21);
																																																																																if (PAIRP(BgL_cdrzd262403zd2_8938))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_8932
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd262403zd2_8938);
																																																																																		BgL_clausesz00_8933
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262403zd2_8938);
																																																																																		{	/* Ast/sexp.scm 517 */
																																																																																			obj_t
																																																																																				BgL_locz00_8942;
																																																																																			BgL_locz00_8942
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 517 */
																																																																																				obj_t
																																																																																					BgL_cdlocz00_8943;
																																																																																				{	/* Ast/sexp.scm 518 */
																																																																																					obj_t
																																																																																						BgL_arg6997z00_8983;
																																																																																					BgL_arg6997z00_8983
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdlocz00_8943
																																																																																						=
																																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																						(BgL_arg6997z00_8983,
																																																																																						BgL_locz00_8942);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 518 */
																																																																																					obj_t
																																																																																						BgL_cddlocz00_8944;
																																																																																					{	/* Ast/sexp.scm 519 */
																																																																																						obj_t
																																																																																							BgL_arg6996z00_8982;
																																																																																						BgL_arg6996z00_8982
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_expz00_21));
																																																																																						BgL_cddlocz00_8944
																																																																																							=
																																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																							(BgL_arg6996z00_8982,
																																																																																							BgL_locz00_8942);
																																																																																					}
																																																																																					{	/* Ast/sexp.scm 519 */
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_testz00_8945;
																																																																																						{	/* Ast/sexp.scm 522 */
																																																																																							obj_t
																																																																																								BgL_arg6995z00_8981;
																																																																																							BgL_arg6995z00_8981
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_testz00_8932,
																																																																																								BgL_cdlocz00_8943);
																																																																																							BgL_testz00_8945
																																																																																								=
																																																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																								(BgL_testz00_8932,
																																																																																								BgL_stackz00_22,
																																																																																								BgL_arg6995z00_8981,
																																																																																								CNST_TABLE_REF
																																																																																								(((long) 2)));
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 520 */

																																																																																							{
																																																																																								obj_t
																																																																																									BgL_clsz00_8948;
																																																																																								obj_t
																																																																																									BgL_nclausesz00_8949;
																																																																																								BgL_clsz00_8948
																																																																																									=
																																																																																									BgL_clausesz00_8933;
																																																																																								BgL_nclausesz00_8949
																																																																																									=
																																																																																									BNIL;
																																																																																							BgL_zc3anonymousza36972ze3z83_8950:
																																																																																								if (NULLP(BgL_clsz00_8948))
																																																																																									{	/* Ast/sexp.scm 527 */
																																																																																										BgL_switchz00_bglt
																																																																																											BgL_new1142z00_8952;
																																																																																										{	/* Ast/sexp.scm 528 */
																																																																																											BgL_switchz00_bglt
																																																																																												BgL_new1141z00_8956;
																																																																																											BgL_new1141z00_8956
																																																																																												=
																																																																																												(
																																																																																												(BgL_switchz00_bglt)
																																																																																												BOBJECT
																																																																																												(GC_MALLOC
																																																																																													(sizeof
																																																																																														(struct
																																																																																															BgL_switchz00_bgl))));
																																																																																											{	/* Ast/sexp.scm 528 */
																																																																																												long
																																																																																													BgL_arg6977z00_8957;
																																																																																												{	/* Ast/sexp.scm 528 */
																																																																																													long
																																																																																														BgL_res7430z00_9990;
																																																																																													BgL_res7430z00_9990
																																																																																														=
																																																																																														BGL_CLASS_INDEX
																																																																																														(BGl_switchz00zzast_nodez00);
																																																																																													BgL_arg6977z00_8957
																																																																																														=
																																																																																														BgL_res7430z00_9990;
																																																																																												}
																																																																																												BGL_OBJECT_CLASS_NUM_SET
																																																																																													(
																																																																																													((BgL_objectz00_bglt) BgL_new1141z00_8956), BgL_arg6977z00_8957);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 528 */
																																																																																												BgL_objectz00_bglt
																																																																																													BgL_tmpz00_15548;
																																																																																												BgL_tmpz00_15548
																																																																																													=
																																																																																													(
																																																																																													(BgL_objectz00_bglt)
																																																																																													BgL_new1141z00_8956);
																																																																																												BGL_OBJECT_WIDENING_SET
																																																																																													(BgL_tmpz00_15548,
																																																																																													BFALSE);
																																																																																											}
																																																																																											BgL_new1142z00_8952
																																																																																												=
																																																																																												BgL_new1141z00_8956;
																																																																																										}
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1142z00_8952)))->BgL_locz00) = ((obj_t) BgL_locz00_8942), BUNSPEC);
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1142z00_8952)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1142z00_8952)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1142z00_8952)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1142z00_8952))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8945), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1142z00_8952))->BgL_clausesz00) = ((obj_t) bgl_reverse_bang(BgL_nclausesz00_8949)), BUNSPEC);
																																																																																										{
																																																																																											BgL_typez00_bglt
																																																																																												BgL_auxz00_15564;
																																																																																											{	/* Ast/sexp.scm 531 */
																																																																																												obj_t
																																																																																													BgL_arg6974z00_8953;
																																																																																												{	/* Ast/sexp.scm 531 */
																																																																																													obj_t
																																																																																														BgL_pairz00_9995;
																																																																																													{	/* Ast/sexp.scm 531 */
																																																																																														obj_t
																																																																																															BgL_pairz00_9994;
																																																																																														BgL_pairz00_9994
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_clausesz00_8933));
																																																																																														BgL_pairz00_9995
																																																																																															=
																																																																																															CAR
																																																																																															(BgL_pairz00_9994);
																																																																																													}
																																																																																													BgL_arg6974z00_8953
																																																																																														=
																																																																																														CAR
																																																																																														(BgL_pairz00_9995);
																																																																																												}
																																																																																												BgL_auxz00_15564
																																																																																													=
																																																																																													BGl_getzd2typezd2atomz00zztype_typeofz00
																																																																																													(BgL_arg6974z00_8953);
																																																																																											}
																																																																																											((((BgL_switchz00_bglt) COBJECT(BgL_new1142z00_8952))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt) BgL_auxz00_15564), BUNSPEC);
																																																																																										}
																																																																																										BgL_auxz00_15526
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BgL_new1142z00_8952);
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 533 */
																																																																																										obj_t
																																																																																											BgL_clausez00_8958;
																																																																																										BgL_clausez00_8958
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_clsz00_8948));
																																																																																										{	/* Ast/sexp.scm 533 */
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_bodyz00_8959;
																																																																																											{	/* Ast/sexp.scm 534 */
																																																																																												obj_t
																																																																																													BgL_arg6992z00_8977;
																																																																																												obj_t
																																																																																													BgL_arg6993z00_8978;
																																																																																												{	/* Ast/sexp.scm 534 */
																																																																																													obj_t
																																																																																														BgL_arg6994z00_8979;
																																																																																													BgL_arg6994z00_8979
																																																																																														=
																																																																																														CDR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8958));
																																																																																													BgL_arg6992z00_8977
																																																																																														=
																																																																																														BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																																														(BgL_arg6994z00_8979);
																																																																																												}
																																																																																												BgL_arg6993z00_8978
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_clausez00_8958,
																																																																																													BgL_cddlocz00_8944);
																																																																																												BgL_bodyz00_8959
																																																																																													=
																																																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																													(BgL_arg6992z00_8977,
																																																																																													BgL_stackz00_22,
																																																																																													BgL_arg6993z00_8978,
																																																																																													CNST_TABLE_REF
																																																																																													(((long) 2)));
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 534 */
																																																																																												obj_t
																																																																																													BgL_nclausez00_8960;
																																																																																												{	/* Ast/sexp.scm 538 */
																																																																																													obj_t
																																																																																														BgL_arg6991z00_8976;
																																																																																													BgL_arg6991z00_8976
																																																																																														=
																																																																																														CAR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8958));
																																																																																													BgL_nclausez00_8960
																																																																																														=
																																																																																														MAKE_YOUNG_PAIR
																																																																																														(BgL_arg6991z00_8976,
																																																																																														((obj_t) BgL_bodyz00_8959));
																																																																																												}
																																																																																												{	/* Ast/sexp.scm 538 */

																																																																																													{	/* Ast/sexp.scm 540 */
																																																																																														bool_t
																																																																																															BgL_testz00_15584;
																																																																																														if ((CAR(((obj_t) BgL_clausez00_8958)) == CNST_TABLE_REF(((long) 5))))
																																																																																															{	/* Ast/sexp.scm 540 */
																																																																																																if (NULLP(CDR(((obj_t) BgL_clsz00_8948))))
																																																																																																	{	/* Ast/sexp.scm 541 */
																																																																																																		BgL_testz00_15584
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			0);
																																																																																																	}
																																																																																																else
																																																																																																	{	/* Ast/sexp.scm 541 */
																																																																																																		BgL_testz00_15584
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			1);
																																																																																																	}
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 540 */
																																																																																																BgL_testz00_15584
																																																																																																	=
																																																																																																	(
																																																																																																	(bool_t)
																																																																																																	0);
																																																																																															}
																																																																																														if (BgL_testz00_15584)
																																																																																															{	/* Ast/sexp.scm 543 */
																																																																																																obj_t
																																																																																																	BgL_arg6985z00_8968;
																																																																																																BgL_arg6985z00_8968
																																																																																																	=
																																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																																	(BgL_expz00_21,
																																																																																																	BgL_locz00_8942);
																																																																																																{	/* Ast/sexp.scm 542 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_res7432z00_10007;
																																																																																																	{	/* Ast/sexp.scm 717 */
																																																																																																		obj_t
																																																																																																			BgL_arg7100z00_10003;
																																																																																																		BgL_nodez00_bglt
																																																																																																			BgL_arg7101z00_10004;
																																																																																																		BgL_arg7100z00_10003
																																																																																																			=
																																																																																																			BGl_shapez00zztools_shapez00
																																																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																																																			());
																																																																																																		BgL_arg7101z00_10004
																																																																																																			=
																																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																			(CNST_TABLE_REF
																																																																																																			(((long) 4)), BNIL, BgL_arg6985z00_8968, CNST_TABLE_REF(((long) 2)));
																																																																																																		{	/* Ast/sexp.scm 716 */
																																																																																																			obj_t
																																																																																																				BgL_list7102z00_10006;
																																																																																																			BgL_list7102z00_10006
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(
																																																																																																				((obj_t) BgL_arg7101z00_10004), BNIL);
																																																																																																			BgL_res7432z00_10007
																																																																																																				=
																																																																																																				(
																																																																																																				(BgL_nodez00_bglt)
																																																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																																				(BgL_arg6985z00_8968,
																																																																																																					BgL_arg7100z00_10003,
																																																																																																					BGl_string7973z00zzast_sexpz00,
																																																																																																					BgL_expz00_21,
																																																																																																					BgL_list7102z00_10006));
																																																																																																	}}
																																																																																																	BgL_auxz00_15526
																																																																																																		=
																																																																																																		BgL_res7432z00_10007;
																																																																																															}}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 544 */
																																																																																																obj_t
																																																																																																	BgL_arg6986z00_8969;
																																																																																																obj_t
																																																																																																	BgL_arg6987z00_8970;
																																																																																																BgL_arg6986z00_8969
																																																																																																	=
																																																																																																	CDR
																																																																																																	(
																																																																																																	((obj_t) BgL_clsz00_8948));
																																																																																																BgL_arg6987z00_8970
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BGl_epairifyz00zztools_miscz00
																																																																																																	(BgL_nclausez00_8960,
																																																																																																		BgL_clausez00_8958),
																																																																																																	BgL_nclausesz00_8949);
																																																																																																{
																																																																																																	obj_t
																																																																																																		BgL_nclausesz00_15609;
																																																																																																	obj_t
																																																																																																		BgL_clsz00_15608;
																																																																																																	BgL_clsz00_15608
																																																																																																		=
																																																																																																		BgL_arg6986z00_8969;
																																																																																																	BgL_nclausesz00_15609
																																																																																																		=
																																																																																																		BgL_arg6987z00_8970;
																																																																																																	BgL_nclausesz00_8949
																																																																																																		=
																																																																																																		BgL_nclausesz00_15609;
																																																																																																	BgL_clsz00_8948
																																																																																																		=
																																																																																																		BgL_clsz00_15608;
																																																																																																	goto
																																																																																																		BgL_zc3anonymousza36972ze3z83_8950;
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											}
																																																																																										}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																	BgL_tagzd262396zd2_8935:
																																																																																		{	/* Ast/sexp.scm 549 */
																																																																																			obj_t
																																																																																				BgL_arg6998z00_8984;
																																																																																			BgL_arg6998z00_8984
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 548 */
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_res7433z00_10014;
																																																																																				{	/* Ast/sexp.scm 717 */
																																																																																					obj_t
																																																																																						BgL_arg7100z00_10010;
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_arg7101z00_10011;
																																																																																					BgL_arg7100z00_10010
																																																																																						=
																																																																																						BGl_shapez00zztools_shapez00
																																																																																						(BGl_currentzd2functionzd2zztools_errorz00
																																																																																						());
																																																																																					BgL_arg7101z00_10011
																																																																																						=
																																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																						(CNST_TABLE_REF
																																																																																						(((long) 4)), BNIL, BgL_arg6998z00_8984, CNST_TABLE_REF(((long) 2)));
																																																																																					{	/* Ast/sexp.scm 716 */
																																																																																						obj_t
																																																																																							BgL_list7102z00_10013;
																																																																																						BgL_list7102z00_10013
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(
																																																																																							((obj_t) BgL_arg7101z00_10011), BNIL);
																																																																																						BgL_res7433z00_10014
																																																																																							=
																																																																																							(
																																																																																							(BgL_nodez00_bglt)
																																																																																							BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																							(BgL_arg6998z00_8984,
																																																																																								BgL_arg7100z00_10010,
																																																																																								BGl_string7973z00zzast_sexpz00,
																																																																																								BgL_expz00_21,
																																																																																								BgL_list7102z00_10013));
																																																																																				}}
																																																																																				BgL_auxz00_15526
																																																																																					=
																																																																																					BgL_res7433z00_10014;
																																																																															}}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd262396zd2_8935;
																																																																															}
																																																																													}
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15526);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																														{
																																																																															BgL_letzd2funzd2_bglt
																																																																																BgL_auxz00_15628;
																																																																														BgL_tagzd2397zd2_1758:
																																																																															BgL_auxz00_15628 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15628);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																																{
																																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																																		BgL_auxz00_15636;
																																																																																BgL_tagzd2398zd2_1759:
																																																																																	BgL_auxz00_15636 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15636);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd23965zd2_2886;
																																																																																	BgL_cdrzd23965zd2_2886
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2497z00_2889;
																																																																																			obj_t
																																																																																				BgL_arg2498z00_2890;
																																																																																			BgL_arg2497z00_2889
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2886));
																																																																																			BgL_arg2498z00_2890
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2886));
																																																																																			{	/* Ast/sexp.scm 563 */
																																																																																				obj_t
																																																																																					BgL_arg7000z00_10230;
																																																																																				BgL_arg7000z00_10230
																																																																																					=
																																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																					(BgL_expz00_21,
																																																																																					BgL_locz00_23);
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																					(BgL_expz00_21,
																																																																																						BgL_arg2497z00_2889,
																																																																																						CNST_TABLE_REF
																																																																																						(((long) 4)), BgL_arg2498z00_2890, BgL_stackz00_22, BgL_arg7000z00_10230, BgL_sitez00_24));
																																																																																		}}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15656;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15656);
																																																																																				}
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd23990zd2_2907;
																																					BgL_carzd23990zd2_2907
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd23990zd2_2907
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_15663;
																																							goto
																																								BgL_tagzd2377zd2_1714;
																																							BgL_auxz00_14146
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_15663);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd23990zd2_2907 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_15667;
																																									goto
																																										BgL_tagzd2377zd2_1714;
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_15667);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_15674;
																																											goto
																																												BgL_tagzd2379zd2_1718;
																																											BgL_auxz00_14146
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_15674);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_15681;
																																													goto
																																														BgL_tagzd2380zd2_1719;
																																													BgL_auxz00_14146
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_15681);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd24059zd2_2914;
																																													BgL_carzd24059zd2_2914
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd24059zd2_2914))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd24062zd2_2916;
																																															obj_t
																																																BgL_cdrzd24063zd2_2917;
																																															BgL_carzd24062zd2_2916
																																																=
																																																CAR
																																																(BgL_carzd24059zd2_2914);
																																															BgL_cdrzd24063zd2_2917
																																																=
																																																CDR
																																																(BgL_carzd24059zd2_2914);
																																															{

																																																if ((BgL_carzd24062zd2_2916 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 118 */
																																																	BgL_kapzd24064zd2_2918:
																																																		if (PAIRP(BgL_cdrzd24063zd2_2917))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd24067zd2_3043;
																																																				BgL_cdrzd24067zd2_3043
																																																					=
																																																					CDR
																																																					(BgL_cdrzd24063zd2_2917);
																																																				if (PAIRP(BgL_cdrzd24067zd2_3043))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (NULLP(CDR(BgL_cdrzd24067zd2_3043)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2630z00_3047;
																																																								obj_t
																																																									BgL_arg2632z00_3048;
																																																								BgL_arg2630z00_3047
																																																									=
																																																									CAR
																																																									(BgL_cdrzd24067zd2_3043);
																																																								BgL_arg2632z00_3048
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15703;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_15705;
																																																										obj_t
																																																											BgL_bodyz00_15704;
																																																										BgL_bodyz00_15704
																																																											=
																																																											BgL_arg2630z00_3047;
																																																										BgL_argsz00_15705
																																																											=
																																																											BgL_arg2632z00_3048;
																																																										BgL_argsz00_1721
																																																											=
																																																											BgL_argsz00_15705;
																																																										BgL_bodyz00_1720
																																																											=
																																																											BgL_bodyz00_15704;
																																																										goto
																																																											BgL_tagzd2381zd2_1722;
																																																									}
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15703);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd24091zd2_3049;
																																																								BgL_cdrzd24091zd2_3049
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_15709;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2705z00_3160;
																																																										BgL_arg2705z00_3160
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_15709
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2705z00_3160));
																																																									}
																																																									if (BgL_testz00_15709)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg2635z00_3052;
																																																											obj_t
																																																												BgL_arg2636z00_3053;
																																																											BgL_arg2635z00_3052
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3049));
																																																											BgL_arg2636z00_3053
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3049));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15718;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15720;
																																																													obj_t
																																																														BgL_bindingsz00_15719;
																																																													BgL_bindingsz00_15719
																																																														=
																																																														BgL_arg2635z00_3052;
																																																													BgL_exprz00_15720
																																																														=
																																																														BgL_arg2636z00_3053;
																																																													BgL_exprz00_1724
																																																														=
																																																														BgL_exprz00_15720;
																																																													BgL_bindingsz00_1723
																																																														=
																																																														BgL_bindingsz00_15719;
																																																													goto
																																																														BgL_tagzd2382zd2_1725;
																																																												}
																																																												BgL_auxz00_14146
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15718);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_15722;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2703z00_3159;
																																																												BgL_arg2703z00_3159
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_15722
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2703z00_3159));
																																																											}
																																																											if (BgL_testz00_15722)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15727;
																																																													goto
																																																														BgL_tagzd2384zd2_1727;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15727);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd24158zd2_3056;
																																																													BgL_carzd24158zd2_3056
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd24163zd2_3057;
																																																														BgL_cdrzd24163zd2_3057
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd24158zd2_3056));
																																																														if ((CAR(((obj_t) BgL_carzd24158zd2_3056)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg2642z00_3060;
																																																																obj_t
																																																																	BgL_arg2643z00_3061;
																																																																obj_t
																																																																	BgL_arg2644z00_3062;
																																																																BgL_arg2642z00_3060
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3057));
																																																																BgL_arg2643z00_3061
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3057));
																																																																BgL_arg2644z00_3062
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15744;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15747;
																																																																		obj_t
																																																																			BgL_bodyz00_15746;
																																																																		obj_t
																																																																			BgL_varsz00_15745;
																																																																		BgL_varsz00_15745
																																																																			=
																																																																			BgL_arg2642z00_3060;
																																																																		BgL_bodyz00_15746
																																																																			=
																																																																			BgL_arg2643z00_3061;
																																																																		BgL_argsz00_15747
																																																																			=
																																																																			BgL_arg2644z00_3062;
																																																																		BgL_argsz00_1734
																																																																			=
																																																																			BgL_argsz00_15747;
																																																																		BgL_bodyz00_1733
																																																																			=
																																																																			BgL_bodyz00_15746;
																																																																		BgL_varsz00_1732
																																																																			=
																																																																			BgL_varsz00_15745;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1735;
																																																																	}
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15744);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd24186zd2_3064;
																																																																BgL_cdrzd24186zd2_3064
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd24192zd2_3065;
																																																																	BgL_cdrzd24192zd2_3065
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd24158zd2_3056));
																																																																	if ((CAR(((obj_t) BgL_carzd24158zd2_3056)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd24198zd2_3068;
																																																																			BgL_cdrzd24198zd2_3068
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd24192zd2_3065));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd24203zd2_3069;
																																																																				obj_t
																																																																					BgL_cdrzd24204zd2_3070;
																																																																				BgL_carzd24203zd2_3069
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3068));
																																																																				BgL_cdrzd24204zd2_3070
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3068));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24203zd2_3069))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (PAIRP(BgL_cdrzd24204zd2_3070))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd24211zd2_3073;
																																																																								BgL_carzd24211zd2_3073
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd24204zd2_3070);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24211zd2_3073))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(BgL_cdrzd24204zd2_3070)))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_15774;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1369z00_3106;
																																																																													BgL_l1369z00_3106
																																																																														=
																																																																														BgL_cdrzd24186zd2_3064;
																																																																												BgL_zc3anonymousza32669ze3z83_3107:
																																																																													if (NULLP(BgL_l1369z00_3106))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_testz00_15774
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_testz00_15777;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_testz00_15778;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_15779;
																																																																																	BgL_tmpz00_15779
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1369z00_3106));
																																																																																	BgL_testz00_15778
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_15779);
																																																																																}
																																																																																if (BgL_testz00_15778)
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_15777
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_15777
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_testz00_15777)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1369z00_15783;
																																																																																	BgL_l1369z00_15783
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1369z00_3106));
																																																																																	BgL_l1369z00_3106
																																																																																		=
																																																																																		BgL_l1369z00_15783;
																																																																																	goto
																																																																																		BgL_zc3anonymousza32669ze3z83_3107;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_15774
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_testz00_15774)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg2658z00_3089;
																																																																														BgL_arg2658z00_3089
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd24192zd2_3065));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15788;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_15792;
																																																																																obj_t
																																																																																	BgL_proc2z00_15791;
																																																																																obj_t
																																																																																	BgL_proc1z00_15790;
																																																																																obj_t
																																																																																	BgL_testz00_15789;
																																																																																BgL_testz00_15789
																																																																																	=
																																																																																	BgL_arg2658z00_3089;
																																																																																BgL_proc1z00_15790
																																																																																	=
																																																																																	BgL_carzd24203zd2_3069;
																																																																																BgL_proc2z00_15791
																																																																																	=
																																																																																	BgL_carzd24211zd2_3073;
																																																																																BgL_argsz00_15792
																																																																																	=
																																																																																	BgL_cdrzd24186zd2_3064;
																																																																																BgL_argsz00_1739
																																																																																	=
																																																																																	BgL_argsz00_15792;
																																																																																BgL_proc2z00_1738
																																																																																	=
																																																																																	BgL_proc2z00_15791;
																																																																																BgL_proc1z00_1737
																																																																																	=
																																																																																	BgL_proc1z00_15790;
																																																																																BgL_testz00_1736
																																																																																	=
																																																																																	BgL_testz00_15789;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1740;
																																																																															}
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15788);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd24235zd2_3090;
																																																																														BgL_cdrzd24235zd2_3090
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd24242zd2_3091;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_10274;
																																																																																BgL_pairz00_10274
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd24242zd2_3091
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10274);
																																																																															}
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd24249zd2_3092;
																																																																																BgL_cdrzd24249zd2_3092
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd24242zd2_3091));
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd24255zd2_3093;
																																																																																	BgL_carzd24255zd2_3093
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd24249zd2_3092));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24255zd2_3093))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_carzd24262zd2_3095;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_pairz00_10278;
																																																																																				BgL_pairz00_10278
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd24249zd2_3092));
																																																																																				BgL_carzd24262zd2_3095
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_10278);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24262zd2_3095))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24235zd2_3090))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_arg2662z00_3098;
																																																																																							BgL_arg2662z00_3098
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd24242zd2_3091));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15814;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15818;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15817;
																																																																																									obj_t
																																																																																										BgL_proc1z00_15816;
																																																																																									obj_t
																																																																																										BgL_testz00_15815;
																																																																																									BgL_testz00_15815
																																																																																										=
																																																																																										BgL_arg2662z00_3098;
																																																																																									BgL_proc1z00_15816
																																																																																										=
																																																																																										BgL_carzd24255zd2_3093;
																																																																																									BgL_proc2z00_15817
																																																																																										=
																																																																																										BgL_carzd24262zd2_3095;
																																																																																									BgL_argsz00_15818
																																																																																										=
																																																																																										BgL_cdrzd24235zd2_3090;
																																																																																									BgL_argsz00_1744
																																																																																										=
																																																																																										BgL_argsz00_15818;
																																																																																									BgL_proc2z00_1743
																																																																																										=
																																																																																										BgL_proc2z00_15817;
																																																																																									BgL_proc1z00_1742
																																																																																										=
																																																																																										BgL_proc1z00_15816;
																																																																																									BgL_testz00_1741
																																																																																										=
																																																																																										BgL_testz00_15815;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1745;
																																																																																								}
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15814);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1769;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15822;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1770;
																																																																																									BgL_auxz00_14146
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15822);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15826;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15826);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15830;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15830);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_15834;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_15834);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd24538zd2_3117;
																																																																										BgL_cdrzd24538zd2_3117
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd24544zd2_3118;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_10282;
																																																																												BgL_pairz00_10282
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd24544zd2_3118
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10282);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd24550zd2_3119;
																																																																												BgL_cdrzd24550zd2_3119
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd24544zd2_3118));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd24555zd2_3120;
																																																																													obj_t
																																																																														BgL_cdrzd24556zd2_3121;
																																																																													BgL_carzd24555zd2_3120
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3119));
																																																																													BgL_cdrzd24556zd2_3121
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3119));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24555zd2_3120))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd24561zd2_3123;
																																																																															BgL_carzd24561zd2_3123
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd24556zd2_3121));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24561zd2_3123))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd24556zd2_3121))))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24538zd2_3117))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2678z00_3128;
																																																																																					BgL_arg2678z00_3128
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd24544zd2_3118));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15861;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15865;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15864;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15863;
																																																																																							obj_t
																																																																																								BgL_testz00_15862;
																																																																																							BgL_testz00_15862
																																																																																								=
																																																																																								BgL_arg2678z00_3128;
																																																																																							BgL_proc1z00_15863
																																																																																								=
																																																																																								BgL_carzd24555zd2_3120;
																																																																																							BgL_proc2z00_15864
																																																																																								=
																																																																																								BgL_carzd24561zd2_3123;
																																																																																							BgL_argsz00_15865
																																																																																								=
																																																																																								BgL_cdrzd24538zd2_3117;
																																																																																							BgL_argsz00_1744
																																																																																								=
																																																																																								BgL_argsz00_15865;
																																																																																							BgL_proc2z00_1743
																																																																																								=
																																																																																								BgL_proc2z00_15864;
																																																																																							BgL_proc1z00_1742
																																																																																								=
																																																																																								BgL_proc1z00_15863;
																																																																																							BgL_testz00_1741
																																																																																								=
																																																																																								BgL_testz00_15862;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1745;
																																																																																						}
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15861);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15869;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15869);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15873;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15873);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15877;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15877);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15881;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15881);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15885;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15885);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd24894zd2_3136;
																																																																						BgL_cdrzd24894zd2_3136
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd24901zd2_3137;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_10292;
																																																																								BgL_pairz00_10292
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd24901zd2_3137
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10292);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd24908zd2_3138;
																																																																								BgL_cdrzd24908zd2_3138
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd24901zd2_3137));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd24914zd2_3139;
																																																																									obj_t
																																																																										BgL_cdrzd24915zd2_3140;
																																																																									BgL_carzd24914zd2_3139
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3138));
																																																																									BgL_cdrzd24915zd2_3140
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3138));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24914zd2_3139))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd24915zd2_3140))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd24922zd2_3143;
																																																																													BgL_carzd24922zd2_3143
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd24915zd2_3140);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24922zd2_3143))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd24915zd2_3140)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24894zd2_3136))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2692z00_3148;
																																																																																			BgL_arg2692z00_3148
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd24901zd2_3137));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15912;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_15916;
																																																																																					obj_t
																																																																																						BgL_proc2z00_15915;
																																																																																					obj_t
																																																																																						BgL_proc1z00_15914;
																																																																																					obj_t
																																																																																						BgL_testz00_15913;
																																																																																					BgL_testz00_15913
																																																																																						=
																																																																																						BgL_arg2692z00_3148;
																																																																																					BgL_proc1z00_15914
																																																																																						=
																																																																																						BgL_carzd24914zd2_3139;
																																																																																					BgL_proc2z00_15915
																																																																																						=
																																																																																						BgL_carzd24922zd2_3143;
																																																																																					BgL_argsz00_15916
																																																																																						=
																																																																																						BgL_cdrzd24894zd2_3136;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_15916;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_15915;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_15914;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_15913;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15912);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15920;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15920);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15924;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15924);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15928;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15928);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15932;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15932);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15936;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15936);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15940;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15940);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd25315zd2_3162;
																																																						BgL_cdrzd25315zd2_3162
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_15944;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2722z00_3179;
																																																								BgL_arg2722z00_3179
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_15944
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2722z00_3179));
																																																							}
																																																							if (BgL_testz00_15944)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg2709z00_3165;
																																																									obj_t
																																																										BgL_arg2710z00_3166;
																																																									BgL_arg2709z00_3165
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3162));
																																																									BgL_arg2710z00_3166
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3162));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15953;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15955;
																																																											obj_t
																																																												BgL_bindingsz00_15954;
																																																											BgL_bindingsz00_15954
																																																												=
																																																												BgL_arg2709z00_3165;
																																																											BgL_exprz00_15955
																																																												=
																																																												BgL_arg2710z00_3166;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_15955;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_15954;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15953);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_15957;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2721z00_3178;
																																																										BgL_arg2721z00_3178
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_15957
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2721z00_3178));
																																																									}
																																																									if (BgL_testz00_15957)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15962;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15962);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd25381zd2_3169;
																																																											BgL_carzd25381zd2_3169
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd25386zd2_3170;
																																																												BgL_cdrzd25386zd2_3170
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd25381zd2_3169));
																																																												if ((CAR(((obj_t) BgL_carzd25381zd2_3169)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2715z00_3173;
																																																														obj_t
																																																															BgL_arg2716z00_3174;
																																																														obj_t
																																																															BgL_arg2718z00_3175;
																																																														BgL_arg2715z00_3173
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3170));
																																																														BgL_arg2716z00_3174
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3170));
																																																														BgL_arg2718z00_3175
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15979;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_15982;
																																																																obj_t
																																																																	BgL_bodyz00_15981;
																																																																obj_t
																																																																	BgL_varsz00_15980;
																																																																BgL_varsz00_15980
																																																																	=
																																																																	BgL_arg2715z00_3173;
																																																																BgL_bodyz00_15981
																																																																	=
																																																																	BgL_arg2716z00_3174;
																																																																BgL_argsz00_15982
																																																																	=
																																																																	BgL_arg2718z00_3175;
																																																																BgL_argsz00_1734
																																																																	=
																																																																	BgL_argsz00_15982;
																																																																BgL_bodyz00_1733
																																																																	=
																																																																	BgL_bodyz00_15981;
																																																																BgL_varsz00_1732
																																																																	=
																																																																	BgL_varsz00_15980;
																																																																goto
																																																																	BgL_tagzd2386zd2_1735;
																																																															}
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15979);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_15986;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_15986);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd25497zd2_3180;
																																																				BgL_cdrzd25497zd2_3180
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_15990;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg2732z00_3189;
																																																						BgL_arg2732z00_3189
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_15990
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg2732z00_3189));
																																																					}
																																																					if (BgL_testz00_15990)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg2726z00_3183;
																																																							obj_t
																																																								BgL_arg2727z00_3184;
																																																							BgL_arg2726z00_3183
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3180));
																																																							BgL_arg2727z00_3184
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3180));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_15999;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16001;
																																																									obj_t
																																																										BgL_bindingsz00_16000;
																																																									BgL_bindingsz00_16000
																																																										=
																																																										BgL_arg2726z00_3183;
																																																									BgL_exprz00_16001
																																																										=
																																																										BgL_arg2727z00_3184;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_16001;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_16000;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_15999);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_16003;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg2731z00_3188;
																																																								BgL_arg2731z00_3188
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_16003
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg2731z00_3188));
																																																							}
																																																							if (BgL_testz00_16003)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16008;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16008);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_16012;
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16012);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24062zd2_2916)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd24064zd2_2918;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd24062zd2_2916 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd24064zd2_2918;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if ((BgL_carzd24062zd2_2916 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd24064zd2_2918;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd24062zd2_2916)))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_kapzd24064zd2_2918;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd25669zd2_2924;
																																																										BgL_cdrzd25669zd2_2924
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_16028;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2624z00_3041;
																																																												BgL_arg2624z00_3041
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_16028
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2624z00_3041));
																																																											}
																																																											if (BgL_testz00_16028)
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg2537z00_2927;
																																																													obj_t
																																																														BgL_arg2541z00_2928;
																																																													BgL_arg2537z00_2927
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2924));
																																																													BgL_arg2541z00_2928
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2924));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16037;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_16039;
																																																															obj_t
																																																																BgL_bindingsz00_16038;
																																																															BgL_bindingsz00_16038
																																																																=
																																																																BgL_arg2537z00_2927;
																																																															BgL_exprz00_16039
																																																																=
																																																																BgL_arg2541z00_2928;
																																																															BgL_exprz00_1724
																																																																=
																																																																BgL_exprz00_16039;
																																																															BgL_bindingsz00_1723
																																																																=
																																																																BgL_bindingsz00_16038;
																																																															goto
																																																																BgL_tagzd2382zd2_1725;
																																																														}
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16037);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_testz00_16041;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2623z00_3040;
																																																														BgL_arg2623z00_3040
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_testz00_16041
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2623z00_3040));
																																																													}
																																																													if (BgL_testz00_16041)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_16046;
																																																															goto
																																																																BgL_tagzd2384zd2_1727;
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16046);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd25735zd2_2931;
																																																															BgL_carzd25735zd2_2931
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd25740zd2_2932;
																																																																BgL_cdrzd25740zd2_2932
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd25735zd2_2931));
																																																																if ((CAR(((obj_t) BgL_carzd25735zd2_2931)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd25740zd2_2932))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg2549z00_2936;
																																																																				obj_t
																																																																					BgL_arg2555z00_2937;
																																																																				obj_t
																																																																					BgL_arg2557z00_2938;
																																																																				BgL_arg2549z00_2936
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd25740zd2_2932);
																																																																				BgL_arg2555z00_2937
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd25740zd2_2932);
																																																																				BgL_arg2557z00_2938
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16063;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_16066;
																																																																						obj_t
																																																																							BgL_bodyz00_16065;
																																																																						obj_t
																																																																							BgL_varsz00_16064;
																																																																						BgL_varsz00_16064
																																																																							=
																																																																							BgL_arg2549z00_2936;
																																																																						BgL_bodyz00_16065
																																																																							=
																																																																							BgL_arg2555z00_2937;
																																																																						BgL_argsz00_16066
																																																																							=
																																																																							BgL_arg2557z00_2938;
																																																																						BgL_argsz00_1734
																																																																							=
																																																																							BgL_argsz00_16066;
																																																																						BgL_bodyz00_1733
																																																																							=
																																																																							BgL_bodyz00_16065;
																																																																						BgL_varsz00_1732
																																																																							=
																																																																							BgL_varsz00_16064;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1735;
																																																																					}
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16063);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_16070;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_16070);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd25847zd2_2941;
																																																																		BgL_cdrzd25847zd2_2941
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd25852zd2_2942;
																																																																			BgL_cdrzd25852zd2_2942
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd25735zd2_2931));
																																																																			if ((CAR(((obj_t) BgL_carzd25735zd2_2931)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd25852zd2_2942))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd25857zd2_2946;
																																																																							BgL_cdrzd25857zd2_2946
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd25852zd2_2942);
																																																																							if (PAIRP(BgL_cdrzd25857zd2_2946))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd25861zd2_2948;
																																																																									obj_t
																																																																										BgL_cdrzd25862zd2_2949;
																																																																									BgL_carzd25861zd2_2948
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd25857zd2_2946);
																																																																									BgL_cdrzd25862zd2_2949
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd25857zd2_2946);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25861zd2_2948))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd25862zd2_2949))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd25867zd2_2952;
																																																																													BgL_carzd25867zd2_2952
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd25862zd2_2949);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25867zd2_2952))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd25862zd2_2949)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_testz00_16098;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1372z00_2985;
																																																																																		BgL_l1372z00_2985
																																																																																			=
																																																																																			BgL_cdrzd25847zd2_2941;
																																																																																	BgL_zc3anonymousza32584ze3z83_2986:
																																																																																		if (NULLP(BgL_l1372z00_2985))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_testz00_16098
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				bool_t
																																																																																					BgL_testz00_16101;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					bool_t
																																																																																						BgL_testz00_16102;
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_16103;
																																																																																						BgL_tmpz00_16103
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1372z00_2985));
																																																																																						BgL_testz00_16102
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_16103);
																																																																																					}
																																																																																					if (BgL_testz00_16102)
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_testz00_16101
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_testz00_16101
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_testz00_16101)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1372z00_16107;
																																																																																						BgL_l1372z00_16107
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1372z00_2985));
																																																																																						BgL_l1372z00_2985
																																																																																							=
																																																																																							BgL_l1372z00_16107;
																																																																																						goto
																																																																																							BgL_zc3anonymousza32584ze3z83_2986;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						BgL_testz00_16098
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_testz00_16098)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg2574z00_2968;
																																																																																			BgL_arg2574z00_2968
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd25852zd2_2942);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16111;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16115;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16114;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16113;
																																																																																					obj_t
																																																																																						BgL_testz00_16112;
																																																																																					BgL_testz00_16112
																																																																																						=
																																																																																						BgL_arg2574z00_2968;
																																																																																					BgL_proc1z00_16113
																																																																																						=
																																																																																						BgL_carzd25861zd2_2948;
																																																																																					BgL_proc2z00_16114
																																																																																						=
																																																																																						BgL_carzd25867zd2_2952;
																																																																																					BgL_argsz00_16115
																																																																																						=
																																																																																						BgL_cdrzd25847zd2_2941;
																																																																																					BgL_argsz00_1739
																																																																																						=
																																																																																						BgL_argsz00_16115;
																																																																																					BgL_proc2z00_1738
																																																																																						=
																																																																																						BgL_proc2z00_16114;
																																																																																					BgL_proc1z00_1737
																																																																																						=
																																																																																						BgL_proc1z00_16113;
																																																																																					BgL_testz00_1736
																																																																																						=
																																																																																						BgL_testz00_16112;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1740;
																																																																																				}
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16111);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd25892zd2_2969;
																																																																																			BgL_cdrzd25892zd2_2969
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_cdrzd25900zd2_2970;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10349;
																																																																																					BgL_pairz00_10349
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd25900zd2_2970
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_10349);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_cdrzd25908zd2_2971;
																																																																																					BgL_cdrzd25908zd2_2971
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd25900zd2_2970));
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd25915zd2_2972;
																																																																																						BgL_carzd25915zd2_2972
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd25908zd2_2971));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25915zd2_2972))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_carzd25924zd2_2974;
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									obj_t
																																																																																										BgL_pairz00_10353;
																																																																																									BgL_pairz00_10353
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd25908zd2_2971));
																																																																																									BgL_carzd25924zd2_2974
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_10353);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25924zd2_2974))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd25892zd2_2969))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												obj_t
																																																																																													BgL_arg2578z00_2977;
																																																																																												BgL_arg2578z00_2977
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd25900zd2_2970));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_16137;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_16141;
																																																																																														obj_t
																																																																																															BgL_proc2z00_16140;
																																																																																														obj_t
																																																																																															BgL_proc1z00_16139;
																																																																																														obj_t
																																																																																															BgL_testz00_16138;
																																																																																														BgL_testz00_16138
																																																																																															=
																																																																																															BgL_arg2578z00_2977;
																																																																																														BgL_proc1z00_16139
																																																																																															=
																																																																																															BgL_carzd25915zd2_2972;
																																																																																														BgL_proc2z00_16140
																																																																																															=
																																																																																															BgL_carzd25924zd2_2974;
																																																																																														BgL_argsz00_16141
																																																																																															=
																																																																																															BgL_cdrzd25892zd2_2969;
																																																																																														BgL_argsz00_1744
																																																																																															=
																																																																																															BgL_argsz00_16141;
																																																																																														BgL_proc2z00_1743
																																																																																															=
																																																																																															BgL_proc2z00_16140;
																																																																																														BgL_proc1z00_1742
																																																																																															=
																																																																																															BgL_proc1z00_16139;
																																																																																														BgL_testz00_1741
																																																																																															=
																																																																																															BgL_testz00_16138;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1745;
																																																																																													}
																																																																																													BgL_auxz00_14146
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_16137);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1769;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_16145;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1770;
																																																																																														BgL_auxz00_14146
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_16145);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16149;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_14146
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16149);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16153;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16153);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16157;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16157);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd26202zd2_2996;
																																																																															BgL_cdrzd26202zd2_2996
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd26209zd2_2997;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10357;
																																																																																	BgL_pairz00_10357
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd26209zd2_2997
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10357);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd26216zd2_2998;
																																																																																	BgL_cdrzd26216zd2_2998
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd26209zd2_2997));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd26222zd2_2999;
																																																																																		obj_t
																																																																																			BgL_cdrzd26223zd2_3000;
																																																																																		BgL_carzd26222zd2_2999
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_2998));
																																																																																		BgL_cdrzd26223zd2_3000
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_2998));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26222zd2_2999))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd26230zd2_3002;
																																																																																				BgL_carzd26230zd2_3002
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd26223zd2_3000));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26230zd2_3002))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd26223zd2_3000))))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26202zd2_2996))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg2595z00_3007;
																																																																																										BgL_arg2595z00_3007
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd26209zd2_2997));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16184;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16188;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16187;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16186;
																																																																																												obj_t
																																																																																													BgL_testz00_16185;
																																																																																												BgL_testz00_16185
																																																																																													=
																																																																																													BgL_arg2595z00_3007;
																																																																																												BgL_proc1z00_16186
																																																																																													=
																																																																																													BgL_carzd26222zd2_2999;
																																																																																												BgL_proc2z00_16187
																																																																																													=
																																																																																													BgL_carzd26230zd2_3002;
																																																																																												BgL_argsz00_16188
																																																																																													=
																																																																																													BgL_cdrzd26202zd2_2996;
																																																																																												BgL_argsz00_1744
																																																																																													=
																																																																																													BgL_argsz00_16188;
																																																																																												BgL_proc2z00_1743
																																																																																													=
																																																																																													BgL_proc2z00_16187;
																																																																																												BgL_proc1z00_1742
																																																																																													=
																																																																																													BgL_proc1z00_16186;
																																																																																												BgL_testz00_1741
																																																																																													=
																																																																																													BgL_testz00_16185;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1745;
																																																																																											}
																																																																																											BgL_auxz00_14146
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16184);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16192;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_14146
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16192);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16196;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16196);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16200;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16200);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16204;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16204);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16208;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16208);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd26563zd2_3015;
																																																																											BgL_cdrzd26563zd2_3015
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd26569zd2_3016;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_10367;
																																																																													BgL_pairz00_10367
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd26569zd2_3016
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10367);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd26575zd2_3017;
																																																																													BgL_cdrzd26575zd2_3017
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd26569zd2_3016));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd26580zd2_3018;
																																																																														obj_t
																																																																															BgL_cdrzd26581zd2_3019;
																																																																														BgL_carzd26580zd2_3018
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3017));
																																																																														BgL_cdrzd26581zd2_3019
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3017));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26580zd2_3018))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (PAIRP(BgL_cdrzd26581zd2_3019))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd26586zd2_3022;
																																																																																		BgL_carzd26586zd2_3022
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd26581zd2_3019);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26586zd2_3022))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(BgL_cdrzd26581zd2_3019)))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26563zd2_3015))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg2609z00_3027;
																																																																																								BgL_arg2609z00_3027
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd26569zd2_3016));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_16235;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_16239;
																																																																																										obj_t
																																																																																											BgL_proc2z00_16238;
																																																																																										obj_t
																																																																																											BgL_proc1z00_16237;
																																																																																										obj_t
																																																																																											BgL_testz00_16236;
																																																																																										BgL_testz00_16236
																																																																																											=
																																																																																											BgL_arg2609z00_3027;
																																																																																										BgL_proc1z00_16237
																																																																																											=
																																																																																											BgL_carzd26580zd2_3018;
																																																																																										BgL_proc2z00_16238
																																																																																											=
																																																																																											BgL_carzd26586zd2_3022;
																																																																																										BgL_argsz00_16239
																																																																																											=
																																																																																											BgL_cdrzd26563zd2_3015;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_argsz00_16239;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_proc2z00_16238;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_proc1z00_16237;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_testz00_16236;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1745;
																																																																																									}
																																																																																									BgL_auxz00_14146
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_16235);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16243;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16243);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16247;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16247);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16251;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16251);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16255;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16255);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16259;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16259);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16263;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16263);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16267;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16267);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_16271;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_16271);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd27124zd2_3191;
																																															BgL_cdrzd27124zd2_3191
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd24059zd2_2914 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg2734z00_3193;
																																																	obj_t
																																																		BgL_arg2735z00_3194;
																																																	BgL_arg2734z00_3193
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3191));
																																																	BgL_arg2735z00_3194
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3191));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_16282;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_16284;
																																																			obj_t
																																																				BgL_bindingsz00_16283;
																																																			BgL_bindingsz00_16283
																																																				=
																																																				BgL_arg2734z00_3193;
																																																			BgL_exprz00_16284
																																																				=
																																																				BgL_arg2735z00_3194;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_16284;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_16283;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_16282);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24059zd2_2914)))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2737z00_3196;
																																																			obj_t
																																																				BgL_arg2738z00_3197;
																																																			BgL_arg2737z00_3196
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3191));
																																																			BgL_arg2738z00_3197
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3191));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_16293;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_16295;
																																																					obj_t
																																																						BgL_bindingsz00_16294;
																																																					BgL_bindingsz00_16294
																																																						=
																																																						BgL_arg2737z00_3196;
																																																					BgL_exprz00_16295
																																																						=
																																																						BgL_arg2738z00_3197;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_16295;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_16294;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_16293);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((BgL_carzd24059zd2_2914 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg2740z00_3199;
																																																					obj_t
																																																						BgL_arg2741z00_3200;
																																																					BgL_arg2740z00_3199
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3191));
																																																					BgL_arg2741z00_3200
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3191));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16304;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16306;
																																																							obj_t
																																																								BgL_bindingsz00_16305;
																																																							BgL_bindingsz00_16305
																																																								=
																																																								BgL_arg2740z00_3199;
																																																							BgL_exprz00_16306
																																																								=
																																																								BgL_arg2741z00_3200;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_16306;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_16305;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_14146
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16304);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16313;
																																																							goto
																																																								BgL_tagzd2383zd2_1726;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16313);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd27161zd2_3203;
																																																							BgL_carzd27161zd2_3203
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd27161zd2_3203 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16320;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16320);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27161zd2_3203)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16325;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16325);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16332;
																																																													goto
																																																														BgL_tagzd2389zd2_1746;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16332);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16339;
																																																															goto
																																																																BgL_tagzd2390zd2_1747;
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16339);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd27241zd2_3210;
																																																															BgL_cdrzd27241zd2_3210
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg2756z00_3213;
																																																																	obj_t
																																																																		BgL_arg2757z00_3214;
																																																																	BgL_arg2756z00_3213
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3210));
																																																																	BgL_arg2757z00_3214
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3210));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_16352;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_16354;
																																																																			obj_t
																																																																				BgL_effectz00_16353;
																																																																			BgL_effectz00_16353
																																																																				=
																																																																				BgL_arg2756z00_3213;
																																																																			BgL_restz00_16354
																																																																				=
																																																																				BgL_arg2757z00_3214;
																																																																			BgL_restz00_1749
																																																																				=
																																																																				BgL_restz00_16354;
																																																																			BgL_effectz00_1748
																																																																				=
																																																																				BgL_effectz00_16353;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1750;
																																																																		}
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_16352);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16361;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1751;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16361);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16368;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1752;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16368);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg2765z00_3222;
																																																																							obj_t
																																																																								BgL_arg2766z00_3223;
																																																																							BgL_arg2765z00_3222
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3210));
																																																																							BgL_arg2766z00_3223
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3210));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16379;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_16381;
																																																																									obj_t
																																																																										BgL_effectz00_16380;
																																																																									BgL_effectz00_16380
																																																																										=
																																																																										BgL_arg2765z00_3222;
																																																																									BgL_restz00_16381
																																																																										=
																																																																										BgL_arg2766z00_3223;
																																																																									BgL_restz00_1754
																																																																										=
																																																																										BgL_restz00_16381;
																																																																									BgL_effectz00_1753
																																																																										=
																																																																										BgL_effectz00_16380;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1755;
																																																																								}
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16379);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16388;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1756;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16388);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16395;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1757;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16395);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_16402;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1758;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16402);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_16409;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1759;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16409);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd27318zd2_3232;
																																																																															BgL_cdrzd27318zd2_3232
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg2791z00_3235;
																																																																																	obj_t
																																																																																		BgL_arg2792z00_3236;
																																																																																	BgL_arg2791z00_3235
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3232));
																																																																																	BgL_arg2792z00_3236
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3232));
																																																																																	{	/* Ast/sexp.scm 563 */
																																																																																		obj_t
																																																																																			BgL_arg7000z00_10406;
																																																																																		BgL_arg7000z00_10406
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg2791z00_3235,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg2792z00_3236, BgL_stackz00_22, BgL_arg7000z00_10406, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16428;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16428);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd27343zd2_3253;
																																			BgL_carzd27343zd2_3253
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd27343zd2_3253
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_16435;
																																					goto
																																						BgL_tagzd2377zd2_1714;
																																					BgL_auxz00_14146
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_16435);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd27343zd2_3253
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_16439;
																																							goto
																																								BgL_tagzd2377zd2_1714;
																																							BgL_auxz00_14146
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_16439);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_16446;
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_16446);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_16453;
																																											goto
																																												BgL_tagzd2380zd2_1719;
																																											BgL_auxz00_14146
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_16453);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd27412zd2_3260;
																																											BgL_carzd27412zd2_3260
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd27412zd2_3260))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd27415zd2_3262;
																																													obj_t
																																														BgL_cdrzd27416zd2_3263;
																																													BgL_carzd27415zd2_3262
																																														=
																																														CAR
																																														(BgL_carzd27412zd2_3260);
																																													BgL_cdrzd27416zd2_3263
																																														=
																																														CDR
																																														(BgL_carzd27412zd2_3260);
																																													{

																																														if ((BgL_carzd27415zd2_3262 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 118 */
																																															BgL_kapzd27417zd2_3264:
																																																if (PAIRP(BgL_cdrzd27416zd2_3263))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd27420zd2_3389;
																																																		BgL_cdrzd27420zd2_3389
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27416zd2_3263);
																																																		if (PAIRP(BgL_cdrzd27420zd2_3389))
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (NULLP(CDR(BgL_cdrzd27420zd2_3389)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg2949z00_3393;
																																																						obj_t
																																																							BgL_arg2951z00_3394;
																																																						BgL_arg2949z00_3393
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27420zd2_3389);
																																																						BgL_arg2951z00_3394
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16475;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_16477;
																																																								obj_t
																																																									BgL_bodyz00_16476;
																																																								BgL_bodyz00_16476
																																																									=
																																																									BgL_arg2949z00_3393;
																																																								BgL_argsz00_16477
																																																									=
																																																									BgL_arg2951z00_3394;
																																																								BgL_argsz00_1721
																																																									=
																																																									BgL_argsz00_16477;
																																																								BgL_bodyz00_1720
																																																									=
																																																									BgL_bodyz00_16476;
																																																								goto
																																																									BgL_tagzd2381zd2_1722;
																																																							}
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16475);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd27444zd2_3395;
																																																						BgL_cdrzd27444zd2_3395
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_16481;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3040z00_3506;
																																																								BgL_arg3040z00_3506
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_16481
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3040z00_3506));
																																																							}
																																																							if (BgL_testz00_16481)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg2954z00_3398;
																																																									obj_t
																																																										BgL_arg2955z00_3399;
																																																									BgL_arg2954z00_3398
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3395));
																																																									BgL_arg2955z00_3399
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3395));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16490;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16492;
																																																											obj_t
																																																												BgL_bindingsz00_16491;
																																																											BgL_bindingsz00_16491
																																																												=
																																																												BgL_arg2954z00_3398;
																																																											BgL_exprz00_16492
																																																												=
																																																												BgL_arg2955z00_3399;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_16492;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_16491;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16490);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_16494;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3038z00_3505;
																																																										BgL_arg3038z00_3505
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_16494
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3038z00_3505));
																																																									}
																																																									if (BgL_testz00_16494)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16499;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16499);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd27511zd2_3402;
																																																											BgL_carzd27511zd2_3402
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd27516zd2_3403;
																																																												BgL_cdrzd27516zd2_3403
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd27511zd2_3402));
																																																												if ((CAR(((obj_t) BgL_carzd27511zd2_3402)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg2961z00_3406;
																																																														obj_t
																																																															BgL_arg2963z00_3407;
																																																														obj_t
																																																															BgL_arg2964z00_3408;
																																																														BgL_arg2961z00_3406
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3403));
																																																														BgL_arg2963z00_3407
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3403));
																																																														BgL_arg2964z00_3408
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16516;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16519;
																																																																obj_t
																																																																	BgL_bodyz00_16518;
																																																																obj_t
																																																																	BgL_varsz00_16517;
																																																																BgL_varsz00_16517
																																																																	=
																																																																	BgL_arg2961z00_3406;
																																																																BgL_bodyz00_16518
																																																																	=
																																																																	BgL_arg2963z00_3407;
																																																																BgL_argsz00_16519
																																																																	=
																																																																	BgL_arg2964z00_3408;
																																																																BgL_argsz00_1734
																																																																	=
																																																																	BgL_argsz00_16519;
																																																																BgL_bodyz00_1733
																																																																	=
																																																																	BgL_bodyz00_16518;
																																																																BgL_varsz00_1732
																																																																	=
																																																																	BgL_varsz00_16517;
																																																																goto
																																																																	BgL_tagzd2386zd2_1735;
																																																															}
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16516);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd27539zd2_3410;
																																																														BgL_cdrzd27539zd2_3410
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd27545zd2_3411;
																																																															BgL_cdrzd27545zd2_3411
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd27511zd2_3402));
																																																															if ((CAR(((obj_t) BgL_carzd27511zd2_3402)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd27551zd2_3414;
																																																																	BgL_cdrzd27551zd2_3414
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27545zd2_3411));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd27556zd2_3415;
																																																																		obj_t
																																																																			BgL_cdrzd27557zd2_3416;
																																																																		BgL_carzd27556zd2_3415
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3414));
																																																																		BgL_cdrzd27557zd2_3416
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3414));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27556zd2_3415))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd27557zd2_3416))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd27564zd2_3419;
																																																																						BgL_carzd27564zd2_3419
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd27557zd2_3416);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27564zd2_3419))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(BgL_cdrzd27557zd2_3416)))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_testz00_16546;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1375z00_3452;
																																																																											BgL_l1375z00_3452
																																																																												=
																																																																												BgL_cdrzd27539zd2_3410;
																																																																										BgL_zc3anonymousza32991ze3z83_3453:
																																																																											if (NULLP(BgL_l1375z00_3452))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_testz00_16546
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_testz00_16549;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_testz00_16550;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_tmpz00_16551;
																																																																															BgL_tmpz00_16551
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1375z00_3452));
																																																																															BgL_testz00_16550
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_16551);
																																																																														}
																																																																														if (BgL_testz00_16550)
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_16549
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_16549
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_testz00_16549)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1375z00_16555;
																																																																															BgL_l1375z00_16555
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1375z00_3452));
																																																																															BgL_l1375z00_3452
																																																																																=
																																																																																BgL_l1375z00_16555;
																																																																															goto
																																																																																BgL_zc3anonymousza32991ze3z83_3453;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_testz00_16546
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_testz00_16546)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg2979z00_3435;
																																																																												BgL_arg2979z00_3435
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd27545zd2_3411));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16560;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_16564;
																																																																														obj_t
																																																																															BgL_proc2z00_16563;
																																																																														obj_t
																																																																															BgL_proc1z00_16562;
																																																																														obj_t
																																																																															BgL_testz00_16561;
																																																																														BgL_testz00_16561
																																																																															=
																																																																															BgL_arg2979z00_3435;
																																																																														BgL_proc1z00_16562
																																																																															=
																																																																															BgL_carzd27556zd2_3415;
																																																																														BgL_proc2z00_16563
																																																																															=
																																																																															BgL_carzd27564zd2_3419;
																																																																														BgL_argsz00_16564
																																																																															=
																																																																															BgL_cdrzd27539zd2_3410;
																																																																														BgL_argsz00_1739
																																																																															=
																																																																															BgL_argsz00_16564;
																																																																														BgL_proc2z00_1738
																																																																															=
																																																																															BgL_proc2z00_16563;
																																																																														BgL_proc1z00_1737
																																																																															=
																																																																															BgL_proc1z00_16562;
																																																																														BgL_testz00_1736
																																																																															=
																																																																															BgL_testz00_16561;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1740;
																																																																													}
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16560);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd27588zd2_3436;
																																																																												BgL_cdrzd27588zd2_3436
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd27595zd2_3437;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10450;
																																																																														BgL_pairz00_10450
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd27595zd2_3437
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10450);
																																																																													}
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd27602zd2_3438;
																																																																														BgL_cdrzd27602zd2_3438
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd27595zd2_3437));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd27608zd2_3439;
																																																																															BgL_carzd27608zd2_3439
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd27602zd2_3438));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27608zd2_3439))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd27615zd2_3441;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10454;
																																																																																		BgL_pairz00_10454
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd27602zd2_3438));
																																																																																		BgL_carzd27615zd2_3441
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_10454);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27615zd2_3441))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27588zd2_3436))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg2983z00_3444;
																																																																																					BgL_arg2983z00_3444
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd27595zd2_3437));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16586;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_16590;
																																																																																							obj_t
																																																																																								BgL_proc2z00_16589;
																																																																																							obj_t
																																																																																								BgL_proc1z00_16588;
																																																																																							obj_t
																																																																																								BgL_testz00_16587;
																																																																																							BgL_testz00_16587
																																																																																								=
																																																																																								BgL_arg2983z00_3444;
																																																																																							BgL_proc1z00_16588
																																																																																								=
																																																																																								BgL_carzd27608zd2_3439;
																																																																																							BgL_proc2z00_16589
																																																																																								=
																																																																																								BgL_carzd27615zd2_3441;
																																																																																							BgL_argsz00_16590
																																																																																								=
																																																																																								BgL_cdrzd27588zd2_3436;
																																																																																							BgL_argsz00_1744
																																																																																								=
																																																																																								BgL_argsz00_16590;
																																																																																							BgL_proc2z00_1743
																																																																																								=
																																																																																								BgL_proc2z00_16589;
																																																																																							BgL_proc1z00_1742
																																																																																								=
																																																																																								BgL_proc1z00_16588;
																																																																																							BgL_testz00_1741
																																																																																								=
																																																																																								BgL_testz00_16587;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1745;
																																																																																						}
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16586);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16594;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16594);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16598;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16598);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16602;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16602);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_16606;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_16606);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd27891zd2_3463;
																																																																								BgL_cdrzd27891zd2_3463
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd27897zd2_3464;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_10458;
																																																																										BgL_pairz00_10458
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd27897zd2_3464
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10458);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd27903zd2_3465;
																																																																										BgL_cdrzd27903zd2_3465
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd27897zd2_3464));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd27908zd2_3466;
																																																																											obj_t
																																																																												BgL_cdrzd27909zd2_3467;
																																																																											BgL_carzd27908zd2_3466
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3465));
																																																																											BgL_cdrzd27909zd2_3467
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3465));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27908zd2_3466))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd27914zd2_3469;
																																																																													BgL_carzd27914zd2_3469
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd27909zd2_3467));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27914zd2_3469))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd27909zd2_3467))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27891zd2_3463))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg3002z00_3474;
																																																																																			BgL_arg3002z00_3474
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd27897zd2_3464));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16633;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16637;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16636;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16635;
																																																																																					obj_t
																																																																																						BgL_testz00_16634;
																																																																																					BgL_testz00_16634
																																																																																						=
																																																																																						BgL_arg3002z00_3474;
																																																																																					BgL_proc1z00_16635
																																																																																						=
																																																																																						BgL_carzd27908zd2_3466;
																																																																																					BgL_proc2z00_16636
																																																																																						=
																																																																																						BgL_carzd27914zd2_3469;
																																																																																					BgL_argsz00_16637
																																																																																						=
																																																																																						BgL_cdrzd27891zd2_3463;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_16637;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_16636;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_16635;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_16634;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16633);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16641;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16641);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16645;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16645);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16649;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16649);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16653;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16653);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16657;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16657);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd28247zd2_3482;
																																																																				BgL_cdrzd28247zd2_3482
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd28254zd2_3483;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_10468;
																																																																						BgL_pairz00_10468
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd28254zd2_3483
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10468);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd28261zd2_3484;
																																																																						BgL_cdrzd28261zd2_3484
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd28254zd2_3483));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd28267zd2_3485;
																																																																							obj_t
																																																																								BgL_cdrzd28268zd2_3486;
																																																																							BgL_carzd28267zd2_3485
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3484));
																																																																							BgL_cdrzd28268zd2_3486
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3484));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28267zd2_3485))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd28268zd2_3486))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd28275zd2_3489;
																																																																											BgL_carzd28275zd2_3489
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd28268zd2_3486);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28275zd2_3489))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd28268zd2_3486)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd28247zd2_3482))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3024z00_3494;
																																																																																	BgL_arg3024z00_3494
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd28254zd2_3483));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16684;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16688;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16687;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16686;
																																																																																			obj_t
																																																																																				BgL_testz00_16685;
																																																																																			BgL_testz00_16685
																																																																																				=
																																																																																				BgL_arg3024z00_3494;
																																																																																			BgL_proc1z00_16686
																																																																																				=
																																																																																				BgL_carzd28267zd2_3485;
																																																																																			BgL_proc2z00_16687
																																																																																				=
																																																																																				BgL_carzd28275zd2_3489;
																																																																																			BgL_argsz00_16688
																																																																																				=
																																																																																				BgL_cdrzd28247zd2_3482;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_16688;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_16687;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_16686;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_16685;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16684);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16692;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16692);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16696;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16696);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16700;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16700);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16704;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16704);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16708;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16708);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16712;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16712);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd28668zd2_3508;
																																																				BgL_cdrzd28668zd2_3508
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_16716;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3058z00_3525;
																																																						BgL_arg3058z00_3525
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_16716
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3058z00_3525));
																																																					}
																																																					if (BgL_testz00_16716)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg3044z00_3511;
																																																							obj_t
																																																								BgL_arg3045z00_3512;
																																																							BgL_arg3044z00_3511
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3508));
																																																							BgL_arg3045z00_3512
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3508));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16725;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16727;
																																																									obj_t
																																																										BgL_bindingsz00_16726;
																																																									BgL_bindingsz00_16726
																																																										=
																																																										BgL_arg3044z00_3511;
																																																									BgL_exprz00_16727
																																																										=
																																																										BgL_arg3045z00_3512;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_16727;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_16726;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16725);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_16729;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3057z00_3524;
																																																								BgL_arg3057z00_3524
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_16729
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3057z00_3524));
																																																							}
																																																							if (BgL_testz00_16729)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16734;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16734);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd28734zd2_3515;
																																																									BgL_carzd28734zd2_3515
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd28739zd2_3516;
																																																										BgL_cdrzd28739zd2_3516
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd28734zd2_3515));
																																																										if ((CAR(((obj_t) BgL_carzd28734zd2_3515)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg3050z00_3519;
																																																												obj_t
																																																													BgL_arg3051z00_3520;
																																																												obj_t
																																																													BgL_arg3053z00_3521;
																																																												BgL_arg3050z00_3519
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3516));
																																																												BgL_arg3051z00_3520
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3516));
																																																												BgL_arg3053z00_3521
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16751;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_16754;
																																																														obj_t
																																																															BgL_bodyz00_16753;
																																																														obj_t
																																																															BgL_varsz00_16752;
																																																														BgL_varsz00_16752
																																																															=
																																																															BgL_arg3050z00_3519;
																																																														BgL_bodyz00_16753
																																																															=
																																																															BgL_arg3051z00_3520;
																																																														BgL_argsz00_16754
																																																															=
																																																															BgL_arg3053z00_3521;
																																																														BgL_argsz00_1734
																																																															=
																																																															BgL_argsz00_16754;
																																																														BgL_bodyz00_1733
																																																															=
																																																															BgL_bodyz00_16753;
																																																														BgL_varsz00_1732
																																																															=
																																																															BgL_varsz00_16752;
																																																														goto
																																																															BgL_tagzd2386zd2_1735;
																																																													}
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16751);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16758;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16758);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd28850zd2_3526;
																																																		BgL_cdrzd28850zd2_3526
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_16762;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3079z00_3535;
																																																				BgL_arg3079z00_3535
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_16762
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3079z00_3535));
																																																			}
																																																			if (BgL_testz00_16762)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3068z00_3529;
																																																					obj_t
																																																						BgL_arg3069z00_3530;
																																																					BgL_arg3068z00_3529
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3526));
																																																					BgL_arg3069z00_3530
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3526));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16771;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16773;
																																																							obj_t
																																																								BgL_bindingsz00_16772;
																																																							BgL_bindingsz00_16772
																																																								=
																																																								BgL_arg3068z00_3529;
																																																							BgL_exprz00_16773
																																																								=
																																																								BgL_arg3069z00_3530;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_16773;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_16772;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_14146
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16771);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_16775;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3078z00_3534;
																																																						BgL_arg3078z00_3534
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_16775
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3078z00_3534));
																																																					}
																																																					if (BgL_testz00_16775)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_16780;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16780);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2403zd2_1769;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_16784;
																																																									goto
																																																										BgL_tagzd2404zd2_1770;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16784);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27415zd2_3262)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd27417zd2_3264;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd27415zd2_3262 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd27417zd2_3264;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd27415zd2_3262 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd27417zd2_3264;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27415zd2_3262)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd27417zd2_3264;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd29022zd2_3270;
																																																								BgL_cdrzd29022zd2_3270
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_16800;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg2925z00_3387;
																																																										BgL_arg2925z00_3387
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_16800
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2925z00_3387));
																																																									}
																																																									if (BgL_testz00_16800)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg2830z00_3273;
																																																											obj_t
																																																												BgL_arg2831z00_3274;
																																																											BgL_arg2830z00_3273
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3270));
																																																											BgL_arg2831z00_3274
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3270));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_16809;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_16811;
																																																													obj_t
																																																														BgL_bindingsz00_16810;
																																																													BgL_bindingsz00_16810
																																																														=
																																																														BgL_arg2830z00_3273;
																																																													BgL_exprz00_16811
																																																														=
																																																														BgL_arg2831z00_3274;
																																																													BgL_exprz00_1724
																																																														=
																																																														BgL_exprz00_16811;
																																																													BgL_bindingsz00_1723
																																																														=
																																																														BgL_bindingsz00_16810;
																																																													goto
																																																														BgL_tagzd2382zd2_1725;
																																																												}
																																																												BgL_auxz00_14146
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_16809);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_16813;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg2924z00_3386;
																																																												BgL_arg2924z00_3386
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_16813
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2924z00_3386));
																																																											}
																																																											if (BgL_testz00_16813)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_16818;
																																																													goto
																																																														BgL_tagzd2384zd2_1727;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16818);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd29088zd2_3277;
																																																													BgL_carzd29088zd2_3277
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd29093zd2_3278;
																																																														BgL_cdrzd29093zd2_3278
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd29088zd2_3277));
																																																														if ((CAR(((obj_t) BgL_carzd29088zd2_3277)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd29093zd2_3278))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg2851z00_3282;
																																																																		obj_t
																																																																			BgL_arg2852z00_3283;
																																																																		obj_t
																																																																			BgL_arg2854z00_3284;
																																																																		BgL_arg2851z00_3282
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd29093zd2_3278);
																																																																		BgL_arg2852z00_3283
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd29093zd2_3278);
																																																																		BgL_arg2854z00_3284
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16835;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_16838;
																																																																				obj_t
																																																																					BgL_bodyz00_16837;
																																																																				obj_t
																																																																					BgL_varsz00_16836;
																																																																				BgL_varsz00_16836
																																																																					=
																																																																					BgL_arg2851z00_3282;
																																																																				BgL_bodyz00_16837
																																																																					=
																																																																					BgL_arg2852z00_3283;
																																																																				BgL_argsz00_16838
																																																																					=
																																																																					BgL_arg2854z00_3284;
																																																																				BgL_argsz00_1734
																																																																					=
																																																																					BgL_argsz00_16838;
																																																																				BgL_bodyz00_1733
																																																																					=
																																																																					BgL_bodyz00_16837;
																																																																				BgL_varsz00_1732
																																																																					=
																																																																					BgL_varsz00_16836;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1735;
																																																																			}
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16835);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_16842;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_16842);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd29200zd2_3287;
																																																																BgL_cdrzd29200zd2_3287
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd29205zd2_3288;
																																																																	BgL_cdrzd29205zd2_3288
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd29088zd2_3277));
																																																																	if ((CAR(((obj_t) BgL_carzd29088zd2_3277)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd29205zd2_3288))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd29210zd2_3292;
																																																																					BgL_cdrzd29210zd2_3292
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd29205zd2_3288);
																																																																					if (PAIRP(BgL_cdrzd29210zd2_3292))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd29214zd2_3294;
																																																																							obj_t
																																																																								BgL_cdrzd29215zd2_3295;
																																																																							BgL_carzd29214zd2_3294
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd29210zd2_3292);
																																																																							BgL_cdrzd29215zd2_3295
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd29210zd2_3292);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29214zd2_3294))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd29215zd2_3295))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd29220zd2_3298;
																																																																											BgL_carzd29220zd2_3298
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd29215zd2_3295);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29220zd2_3298))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd29215zd2_3295)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_testz00_16870;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1378z00_3331;
																																																																																BgL_l1378z00_3331
																																																																																	=
																																																																																	BgL_cdrzd29200zd2_3287;
																																																																															BgL_zc3anonymousza32882ze3z83_3332:
																																																																																if (NULLP(BgL_l1378z00_3331))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_16870
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		bool_t
																																																																																			BgL_testz00_16873;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			bool_t
																																																																																				BgL_testz00_16874;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_16875;
																																																																																				BgL_tmpz00_16875
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1378z00_3331));
																																																																																				BgL_testz00_16874
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_16875);
																																																																																			}
																																																																																			if (BgL_testz00_16874)
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_testz00_16873
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_testz00_16873
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_testz00_16873)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1378z00_16879;
																																																																																				BgL_l1378z00_16879
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1378z00_3331));
																																																																																				BgL_l1378z00_3331
																																																																																					=
																																																																																					BgL_l1378z00_16879;
																																																																																				goto
																																																																																					BgL_zc3anonymousza32882ze3z83_3332;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_testz00_16870
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_testz00_16870)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg2870z00_3314;
																																																																																	BgL_arg2870z00_3314
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd29205zd2_3288);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16883;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16887;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16886;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16885;
																																																																																			obj_t
																																																																																				BgL_testz00_16884;
																																																																																			BgL_testz00_16884
																																																																																				=
																																																																																				BgL_arg2870z00_3314;
																																																																																			BgL_proc1z00_16885
																																																																																				=
																																																																																				BgL_carzd29214zd2_3294;
																																																																																			BgL_proc2z00_16886
																																																																																				=
																																																																																				BgL_carzd29220zd2_3298;
																																																																																			BgL_argsz00_16887
																																																																																				=
																																																																																				BgL_cdrzd29200zd2_3287;
																																																																																			BgL_argsz00_1739
																																																																																				=
																																																																																				BgL_argsz00_16887;
																																																																																			BgL_proc2z00_1738
																																																																																				=
																																																																																				BgL_proc2z00_16886;
																																																																																			BgL_proc1z00_1737
																																																																																				=
																																																																																				BgL_proc1z00_16885;
																																																																																			BgL_testz00_1736
																																																																																				=
																																																																																				BgL_testz00_16884;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1740;
																																																																																		}
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16883);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd29245zd2_3315;
																																																																																	BgL_cdrzd29245zd2_3315
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd29253zd2_3316;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10525;
																																																																																			BgL_pairz00_10525
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd29253zd2_3316
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10525);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd29261zd2_3317;
																																																																																			BgL_cdrzd29261zd2_3317
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd29253zd2_3316));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd29268zd2_3318;
																																																																																				BgL_carzd29268zd2_3318
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd29261zd2_3317));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29268zd2_3318))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd29277zd2_3320;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10529;
																																																																																							BgL_pairz00_10529
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd29261zd2_3317));
																																																																																							BgL_carzd29277zd2_3320
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_10529);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29277zd2_3320))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29245zd2_3315))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg2874z00_3323;
																																																																																										BgL_arg2874z00_3323
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd29253zd2_3316));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16909;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16913;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16912;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16911;
																																																																																												obj_t
																																																																																													BgL_testz00_16910;
																																																																																												BgL_testz00_16910
																																																																																													=
																																																																																													BgL_arg2874z00_3323;
																																																																																												BgL_proc1z00_16911
																																																																																													=
																																																																																													BgL_carzd29268zd2_3318;
																																																																																												BgL_proc2z00_16912
																																																																																													=
																																																																																													BgL_carzd29277zd2_3320;
																																																																																												BgL_argsz00_16913
																																																																																													=
																																																																																													BgL_cdrzd29245zd2_3315;
																																																																																												BgL_argsz00_1744
																																																																																													=
																																																																																													BgL_argsz00_16913;
																																																																																												BgL_proc2z00_1743
																																																																																													=
																																																																																													BgL_proc2z00_16912;
																																																																																												BgL_proc1z00_1742
																																																																																													=
																																																																																													BgL_proc1z00_16911;
																																																																																												BgL_testz00_1741
																																																																																													=
																																																																																													BgL_testz00_16910;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1745;
																																																																																											}
																																																																																											BgL_auxz00_14146
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16909);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16917;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_14146
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16917);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16921;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16921);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16925;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16925);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16929;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16929);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd29555zd2_3342;
																																																																													BgL_cdrzd29555zd2_3342
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd29562zd2_3343;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10533;
																																																																															BgL_pairz00_10533
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd29562zd2_3343
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10533);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd29569zd2_3344;
																																																																															BgL_cdrzd29569zd2_3344
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd29562zd2_3343));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd29575zd2_3345;
																																																																																obj_t
																																																																																	BgL_cdrzd29576zd2_3346;
																																																																																BgL_carzd29575zd2_3345
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3344));
																																																																																BgL_cdrzd29576zd2_3346
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3344));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29575zd2_3345))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd29583zd2_3348;
																																																																																		BgL_carzd29583zd2_3348
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd29576zd2_3346));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29583zd2_3348))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd29576zd2_3346))))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29555zd2_3342))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg2892z00_3353;
																																																																																								BgL_arg2892z00_3353
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd29562zd2_3343));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_16956;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_16960;
																																																																																										obj_t
																																																																																											BgL_proc2z00_16959;
																																																																																										obj_t
																																																																																											BgL_proc1z00_16958;
																																																																																										obj_t
																																																																																											BgL_testz00_16957;
																																																																																										BgL_testz00_16957
																																																																																											=
																																																																																											BgL_arg2892z00_3353;
																																																																																										BgL_proc1z00_16958
																																																																																											=
																																																																																											BgL_carzd29575zd2_3345;
																																																																																										BgL_proc2z00_16959
																																																																																											=
																																																																																											BgL_carzd29583zd2_3348;
																																																																																										BgL_argsz00_16960
																																																																																											=
																																																																																											BgL_cdrzd29555zd2_3342;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_argsz00_16960;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_proc2z00_16959;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_proc1z00_16958;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_testz00_16957;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1745;
																																																																																									}
																																																																																									BgL_auxz00_14146
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_16956);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16964;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16964);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16968;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16968);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16972;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16972);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16976;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16976);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16980;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16980);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd29916zd2_3361;
																																																																									BgL_cdrzd29916zd2_3361
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd29922zd2_3362;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_10543;
																																																																											BgL_pairz00_10543
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd29922zd2_3362
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10543);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd29928zd2_3363;
																																																																											BgL_cdrzd29928zd2_3363
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd29922zd2_3362));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd29933zd2_3364;
																																																																												obj_t
																																																																													BgL_cdrzd29934zd2_3365;
																																																																												BgL_carzd29933zd2_3364
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3363));
																																																																												BgL_cdrzd29934zd2_3365
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3363));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29933zd2_3364))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (PAIRP(BgL_cdrzd29934zd2_3365))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd29939zd2_3368;
																																																																																BgL_carzd29939zd2_3368
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd29934zd2_3365);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29939zd2_3368))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(BgL_cdrzd29934zd2_3365)))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29916zd2_3361))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg2911z00_3373;
																																																																																						BgL_arg2911z00_3373
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd29922zd2_3362));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17007;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17011;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17010;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17009;
																																																																																								obj_t
																																																																																									BgL_testz00_17008;
																																																																																								BgL_testz00_17008
																																																																																									=
																																																																																									BgL_arg2911z00_3373;
																																																																																								BgL_proc1z00_17009
																																																																																									=
																																																																																									BgL_carzd29933zd2_3364;
																																																																																								BgL_proc2z00_17010
																																																																																									=
																																																																																									BgL_carzd29939zd2_3368;
																																																																																								BgL_argsz00_17011
																																																																																									=
																																																																																									BgL_cdrzd29916zd2_3361;
																																																																																								BgL_argsz00_1744
																																																																																									=
																																																																																									BgL_argsz00_17011;
																																																																																								BgL_proc2z00_1743
																																																																																									=
																																																																																									BgL_proc2z00_17010;
																																																																																								BgL_proc1z00_1742
																																																																																									=
																																																																																									BgL_proc1z00_17009;
																																																																																								BgL_testz00_1741
																																																																																									=
																																																																																									BgL_testz00_17008;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1745;
																																																																																							}
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17007);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17015;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17015);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17019;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17019);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17023;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17023);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17027;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17027);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17031;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17031);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17035;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17035);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17039;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17039);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17043;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17043);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_cdrzd210477zd2_3537;
																																													BgL_cdrzd210477zd2_3537
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd27412zd2_3260 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg3082z00_3539;
																																															obj_t
																																																BgL_arg3083z00_3540;
																																															BgL_arg3082z00_3539
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3537));
																																															BgL_arg3083z00_3540
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3537));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17054;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17056;
																																																	obj_t
																																																		BgL_bindingsz00_17055;
																																																	BgL_bindingsz00_17055
																																																		=
																																																		BgL_arg3082z00_3539;
																																																	BgL_exprz00_17056
																																																		=
																																																		BgL_arg3083z00_3540;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_17056;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_17055;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_14146
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17054);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27412zd2_3260)))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg3085z00_3542;
																																																	obj_t
																																																		BgL_arg3087z00_3543;
																																																	BgL_arg3085z00_3542
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3537));
																																																	BgL_arg3087z00_3543
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3537));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17065;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17067;
																																																			obj_t
																																																				BgL_bindingsz00_17066;
																																																			BgL_bindingsz00_17066
																																																				=
																																																				BgL_arg3085z00_3542;
																																																			BgL_exprz00_17067
																																																				=
																																																				BgL_arg3087z00_3543;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_17067;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_17066;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17065);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((BgL_carzd27412zd2_3260 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3089z00_3545;
																																																			obj_t
																																																				BgL_arg3090z00_3546;
																																																			BgL_arg3089z00_3545
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3537));
																																																			BgL_arg3090z00_3546
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3537));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17076;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17078;
																																																					obj_t
																																																						BgL_bindingsz00_17077;
																																																					BgL_bindingsz00_17077
																																																						=
																																																						BgL_arg3089z00_3545;
																																																					BgL_exprz00_17078
																																																						=
																																																						BgL_arg3090z00_3546;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_17078;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_17077;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17076);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17085;
																																																					goto
																																																						BgL_tagzd2383zd2_1726;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17085);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd210514zd2_3549;
																																																					BgL_carzd210514zd2_3549
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd210514zd2_3549 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17092;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17092);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210514zd2_3549)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17097;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17097);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17104;
																																																											goto
																																																												BgL_tagzd2389zd2_1746;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17104);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17111;
																																																													goto
																																																														BgL_tagzd2390zd2_1747;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17111);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd210594zd2_3556;
																																																													BgL_cdrzd210594zd2_3556
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg3103z00_3559;
																																																															obj_t
																																																																BgL_arg3104z00_3560;
																																																															BgL_arg3103z00_3559
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3556));
																																																															BgL_arg3104z00_3560
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3556));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_17124;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_17126;
																																																																	obj_t
																																																																		BgL_effectz00_17125;
																																																																	BgL_effectz00_17125
																																																																		=
																																																																		BgL_arg3103z00_3559;
																																																																	BgL_restz00_17126
																																																																		=
																																																																		BgL_arg3104z00_3560;
																																																																	BgL_restz00_1749
																																																																		=
																																																																		BgL_restz00_17126;
																																																																	BgL_effectz00_1748
																																																																		=
																																																																		BgL_effectz00_17125;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1750;
																																																																}
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_17124);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17133;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1751;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17133);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17140;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1752;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17140);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg3119z00_3568;
																																																																					obj_t
																																																																						BgL_arg3120z00_3569;
																																																																					BgL_arg3119z00_3568
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3556));
																																																																					BgL_arg3120z00_3569
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3556));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17151;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_17153;
																																																																							obj_t
																																																																								BgL_effectz00_17152;
																																																																							BgL_effectz00_17152
																																																																								=
																																																																								BgL_arg3119z00_3568;
																																																																							BgL_restz00_17153
																																																																								=
																																																																								BgL_arg3120z00_3569;
																																																																							BgL_restz00_1754
																																																																								=
																																																																								BgL_restz00_17153;
																																																																							BgL_effectz00_1753
																																																																								=
																																																																								BgL_effectz00_17152;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1755;
																																																																						}
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17151);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17160;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1756;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17160);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17167;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1757;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17167);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_17174;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1758;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17174);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_17181;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1759;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17181);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd210671zd2_3578;
																																																																													BgL_cdrzd210671zd2_3578
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3136z00_3581;
																																																																															obj_t
																																																																																BgL_arg3137z00_3582;
																																																																															BgL_arg3136z00_3581
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3578));
																																																																															BgL_arg3137z00_3582
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3578));
																																																																															{	/* Ast/sexp.scm 563 */
																																																																																obj_t
																																																																																	BgL_arg7000z00_10582;
																																																																																BgL_arg7000z00_10582
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3136z00_3581,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3137z00_3582, BgL_stackz00_22, BgL_arg7000z00_10582, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17200;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17200);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd210696zd2_3599;
																																	BgL_carzd210696zd2_3599
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd210696zd2_3599
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_17207;
																																			goto
																																				BgL_tagzd2377zd2_1714;
																																			BgL_auxz00_14146
																																				=
																																				((obj_t)
																																				BgL_auxz00_17207);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_carzd210696zd2_3599
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_17211;
																																					goto
																																						BgL_tagzd2377zd2_1714;
																																					BgL_auxz00_14146
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_17211);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_cdrzd210718zd2_3602;
																																					BgL_cdrzd210718zd2_3602
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd210721zd2_3605;
																																							obj_t
																																								BgL_cdrzd210722zd2_3606;
																																							BgL_carzd210721zd2_3605
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3602));
																																							BgL_cdrzd210722zd2_3606
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3602));
																																							if (PAIRP(BgL_carzd210721zd2_3605))
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(BgL_carzd210721zd2_3605) == CNST_TABLE_REF(((long) 14))))
																																										{	/* Ast/sexp.scm 118 */
																																											if (NULLP(CDR(((obj_t) BgL_cdrzd210722zd2_3606))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg3173z00_3612;
																																													obj_t
																																														BgL_arg3178z00_3613;
																																													BgL_arg3173z00_3612
																																														=
																																														CDR
																																														(BgL_carzd210721zd2_3605);
																																													BgL_arg3178z00_3613
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210722zd2_3606));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17237;
																																														BgL_lz00_1715
																																															=
																																															BgL_arg3173z00_3612;
																																														BgL_valz00_1716
																																															=
																																															BgL_arg3178z00_3613;
																																													BgL_tagzd2378zd2_1717:
																																														{	/* Ast/sexp.scm 285 */
																																															bool_t
																																																BgL_testz00_17238;
																																															if (PAIRP(BgL_lz00_1715))
																																																{	/* Ast/sexp.scm 285 */
																																																	bool_t
																																																		BgL_testz00_17241;
																																																	{	/* Ast/sexp.scm 285 */
																																																		obj_t
																																																			BgL_tmpz00_17242;
																																																		BgL_tmpz00_17242
																																																			=
																																																			CDR
																																																			(BgL_lz00_1715);
																																																		BgL_testz00_17241
																																																			=
																																																			PAIRP
																																																			(BgL_tmpz00_17242);
																																																	}
																																																	if (BgL_testz00_17241)
																																																		{
																																																			obj_t
																																																				BgL_l1347z00_8571;
																																																			BgL_l1347z00_8571
																																																				=
																																																				BgL_lz00_1715;
																																																		BgL_zc3anonymousza36743ze3z83_8572:
																																																			if (NULLP(BgL_l1347z00_8571))
																																																				{	/* Ast/sexp.scm 285 */
																																																					BgL_testz00_17238
																																																						=
																																																						(
																																																						(bool_t)
																																																						1);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 285 */
																																																					bool_t
																																																						BgL_testz00_17247;
																																																					{	/* Ast/sexp.scm 285 */
																																																						obj_t
																																																							BgL_tmpz00_17248;
																																																						BgL_tmpz00_17248
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_l1347z00_8571));
																																																						BgL_testz00_17247
																																																							=
																																																							SYMBOLP
																																																							(BgL_tmpz00_17248);
																																																					}
																																																					if (BgL_testz00_17247)
																																																						{
																																																							obj_t
																																																								BgL_l1347z00_17252;
																																																							BgL_l1347z00_17252
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_l1347z00_8571));
																																																							BgL_l1347z00_8571
																																																								=
																																																								BgL_l1347z00_17252;
																																																							goto
																																																								BgL_zc3anonymousza36743ze3z83_8572;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 285 */
																																																							BgL_testz00_17238
																																																								=
																																																								(
																																																								(bool_t)
																																																								0);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 285 */
																																																			BgL_testz00_17238
																																																				=
																																																				(
																																																				(bool_t)
																																																				0);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 285 */
																																																	BgL_testz00_17238
																																																		=
																																																		(
																																																		(bool_t)
																																																		0);
																																																}
																																															if (BgL_testz00_17238)
																																																{	/* Ast/sexp.scm 285 */
																																																	BgL_auxz00_17237
																																																		=
																																																		BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00
																																																		(BgL_lz00_1715,
																																																		BgL_valz00_1716,
																																																		BgL_expz00_21,
																																																		BgL_stackz00_22,
																																																		BgL_locz00_23,
																																																		BgL_sitez00_24);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 287 */
																																																	BgL_nodez00_bglt
																																																		BgL_res7358z00_9748;
																																																	{	/* Ast/sexp.scm 717 */
																																																		obj_t
																																																			BgL_arg7100z00_9744;
																																																		BgL_nodez00_bglt
																																																			BgL_arg7101z00_9745;
																																																		BgL_arg7100z00_9744
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg7101z00_9745
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 716 */
																																																			obj_t
																																																				BgL_list7102z00_9747;
																																																			BgL_list7102z00_9747
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_arg7101z00_9745), BNIL);
																																																			BgL_res7358z00_9748
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_locz00_23,
																																																					BgL_arg7100z00_9744,
																																																					BGl_string7982z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list7102z00_9747));
																																																	}}
																																																	BgL_auxz00_17237
																																																		=
																																																		BgL_res7358z00_9748;
																																														}}
																																														BgL_auxz00_14146
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17237);
																																												}}
																																											else
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_17266;
																																													goto
																																														BgL_tagzd2379zd2_1718;
																																													BgL_auxz00_14146
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_17266);
																																												}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_17268;
																																											goto
																																												BgL_tagzd2379zd2_1718;
																																											BgL_auxz00_14146
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_17268);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17270;
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17270);
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17277;
																																									goto
																																										BgL_tagzd2380zd2_1719;
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17277);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd210819zd2_3618;
																																									BgL_carzd210819zd2_3618
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd210819zd2_3618))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd210822zd2_3620;
																																											obj_t
																																												BgL_cdrzd210823zd2_3621;
																																											BgL_carzd210822zd2_3620
																																												=
																																												CAR
																																												(BgL_carzd210819zd2_3618);
																																											BgL_cdrzd210823zd2_3621
																																												=
																																												CDR
																																												(BgL_carzd210819zd2_3618);
																																											{

																																												if ((BgL_carzd210822zd2_3620 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 118 */
																																													BgL_kapzd210824zd2_3622:
																																														if (PAIRP(BgL_cdrzd210823zd2_3621))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd210827zd2_3747;
																																																BgL_cdrzd210827zd2_3747
																																																	=
																																																	CDR
																																																	(BgL_cdrzd210823zd2_3621);
																																																if (PAIRP(BgL_cdrzd210827zd2_3747))
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (NULLP(CDR(BgL_cdrzd210827zd2_3747)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3289z00_3751;
																																																				obj_t
																																																					BgL_arg3290z00_3752;
																																																				BgL_arg3289z00_3751
																																																					=
																																																					CAR
																																																					(BgL_cdrzd210827zd2_3747);
																																																				BgL_arg3290z00_3752
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17299;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_17301;
																																																						obj_t
																																																							BgL_bodyz00_17300;
																																																						BgL_bodyz00_17300
																																																							=
																																																							BgL_arg3289z00_3751;
																																																						BgL_argsz00_17301
																																																							=
																																																							BgL_arg3290z00_3752;
																																																						BgL_argsz00_1721
																																																							=
																																																							BgL_argsz00_17301;
																																																						BgL_bodyz00_1720
																																																							=
																																																							BgL_bodyz00_17300;
																																																						goto
																																																							BgL_tagzd2381zd2_1722;
																																																					}
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17299);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd210851zd2_3753;
																																																				BgL_cdrzd210851zd2_3753
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_17305;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3395z00_3864;
																																																						BgL_arg3395z00_3864
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_17305
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3395z00_3864));
																																																					}
																																																					if (BgL_testz00_17305)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg3308z00_3756;
																																																							obj_t
																																																								BgL_arg3317z00_3757;
																																																							BgL_arg3308z00_3756
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3753));
																																																							BgL_arg3317z00_3757
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3753));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_17314;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_17316;
																																																									obj_t
																																																										BgL_bindingsz00_17315;
																																																									BgL_bindingsz00_17315
																																																										=
																																																										BgL_arg3308z00_3756;
																																																									BgL_exprz00_17316
																																																										=
																																																										BgL_arg3317z00_3757;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_17316;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_17315;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_17314);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_17318;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3394z00_3863;
																																																								BgL_arg3394z00_3863
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_17318
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3394z00_3863));
																																																							}
																																																							if (BgL_testz00_17318)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17323;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17323);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd210918zd2_3760;
																																																									BgL_carzd210918zd2_3760
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd210923zd2_3761;
																																																										BgL_cdrzd210923zd2_3761
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd210918zd2_3760));
																																																										if ((CAR(((obj_t) BgL_carzd210918zd2_3760)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg3322z00_3764;
																																																												obj_t
																																																													BgL_arg3323z00_3765;
																																																												obj_t
																																																													BgL_arg3324z00_3766;
																																																												BgL_arg3322z00_3764
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3761));
																																																												BgL_arg3323z00_3765
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3761));
																																																												BgL_arg3324z00_3766
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17340;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_17343;
																																																														obj_t
																																																															BgL_bodyz00_17342;
																																																														obj_t
																																																															BgL_varsz00_17341;
																																																														BgL_varsz00_17341
																																																															=
																																																															BgL_arg3322z00_3764;
																																																														BgL_bodyz00_17342
																																																															=
																																																															BgL_arg3323z00_3765;
																																																														BgL_argsz00_17343
																																																															=
																																																															BgL_arg3324z00_3766;
																																																														BgL_argsz00_1734
																																																															=
																																																															BgL_argsz00_17343;
																																																														BgL_bodyz00_1733
																																																															=
																																																															BgL_bodyz00_17342;
																																																														BgL_varsz00_1732
																																																															=
																																																															BgL_varsz00_17341;
																																																														goto
																																																															BgL_tagzd2386zd2_1735;
																																																													}
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17340);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd210946zd2_3768;
																																																												BgL_cdrzd210946zd2_3768
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd210952zd2_3769;
																																																													BgL_cdrzd210952zd2_3769
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd210918zd2_3760));
																																																													if ((CAR(((obj_t) BgL_carzd210918zd2_3760)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd210958zd2_3772;
																																																															BgL_cdrzd210958zd2_3772
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210952zd2_3769));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd210963zd2_3773;
																																																																obj_t
																																																																	BgL_cdrzd210964zd2_3774;
																																																																BgL_carzd210963zd2_3773
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3772));
																																																																BgL_cdrzd210964zd2_3774
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3772));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210963zd2_3773))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd210964zd2_3774))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd210971zd2_3777;
																																																																				BgL_carzd210971zd2_3777
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd210964zd2_3774);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210971zd2_3777))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd210964zd2_3774)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_17370;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1381z00_3810;
																																																																									BgL_l1381z00_3810
																																																																										=
																																																																										BgL_cdrzd210946zd2_3768;
																																																																								BgL_zc3anonymousza33347ze3z83_3811:
																																																																									if (NULLP(BgL_l1381z00_3810))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_17370
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_17373;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_17374;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_17375;
																																																																													BgL_tmpz00_17375
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1381z00_3810));
																																																																													BgL_testz00_17374
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_17375);
																																																																												}
																																																																												if (BgL_testz00_17374)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_17373
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_17373
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_testz00_17373)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1381z00_17379;
																																																																													BgL_l1381z00_17379
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1381z00_3810));
																																																																													BgL_l1381z00_3810
																																																																														=
																																																																														BgL_l1381z00_17379;
																																																																													goto
																																																																														BgL_zc3anonymousza33347ze3z83_3811;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_testz00_17370
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_testz00_17370)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg3337z00_3793;
																																																																										BgL_arg3337z00_3793
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd210952zd2_3769));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17384;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_17388;
																																																																												obj_t
																																																																													BgL_proc2z00_17387;
																																																																												obj_t
																																																																													BgL_proc1z00_17386;
																																																																												obj_t
																																																																													BgL_testz00_17385;
																																																																												BgL_testz00_17385
																																																																													=
																																																																													BgL_arg3337z00_3793;
																																																																												BgL_proc1z00_17386
																																																																													=
																																																																													BgL_carzd210963zd2_3773;
																																																																												BgL_proc2z00_17387
																																																																													=
																																																																													BgL_carzd210971zd2_3777;
																																																																												BgL_argsz00_17388
																																																																													=
																																																																													BgL_cdrzd210946zd2_3768;
																																																																												BgL_argsz00_1739
																																																																													=
																																																																													BgL_argsz00_17388;
																																																																												BgL_proc2z00_1738
																																																																													=
																																																																													BgL_proc2z00_17387;
																																																																												BgL_proc1z00_1737
																																																																													=
																																																																													BgL_proc1z00_17386;
																																																																												BgL_testz00_1736
																																																																													=
																																																																													BgL_testz00_17385;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1740;
																																																																											}
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17384);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd210995zd2_3794;
																																																																										BgL_cdrzd210995zd2_3794
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd211002zd2_3795;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_10635;
																																																																												BgL_pairz00_10635
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd211002zd2_3795
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10635);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd211009zd2_3796;
																																																																												BgL_cdrzd211009zd2_3796
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd211002zd2_3795));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd211015zd2_3797;
																																																																													BgL_carzd211015zd2_3797
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd211009zd2_3796));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211015zd2_3797))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd211022zd2_3799;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_10639;
																																																																																BgL_pairz00_10639
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd211009zd2_3796));
																																																																																BgL_carzd211022zd2_3799
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_10639);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211022zd2_3799))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd210995zd2_3794))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg3341z00_3802;
																																																																																			BgL_arg3341z00_3802
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd211002zd2_3795));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17410;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_17414;
																																																																																					obj_t
																																																																																						BgL_proc2z00_17413;
																																																																																					obj_t
																																																																																						BgL_proc1z00_17412;
																																																																																					obj_t
																																																																																						BgL_testz00_17411;
																																																																																					BgL_testz00_17411
																																																																																						=
																																																																																						BgL_arg3341z00_3802;
																																																																																					BgL_proc1z00_17412
																																																																																						=
																																																																																						BgL_carzd211015zd2_3797;
																																																																																					BgL_proc2z00_17413
																																																																																						=
																																																																																						BgL_carzd211022zd2_3799;
																																																																																					BgL_argsz00_17414
																																																																																						=
																																																																																						BgL_cdrzd210995zd2_3794;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_17414;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_17413;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_17412;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_17411;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17410);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17418;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17418);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17422;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17422);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17426;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17426);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_17430;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_17430);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd211298zd2_3821;
																																																																						BgL_cdrzd211298zd2_3821
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd211304zd2_3822;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_10643;
																																																																								BgL_pairz00_10643
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd211304zd2_3822
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10643);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd211310zd2_3823;
																																																																								BgL_cdrzd211310zd2_3823
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd211304zd2_3822));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd211315zd2_3824;
																																																																									obj_t
																																																																										BgL_cdrzd211316zd2_3825;
																																																																									BgL_carzd211315zd2_3824
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3823));
																																																																									BgL_cdrzd211316zd2_3825
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3823));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211315zd2_3824))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd211321zd2_3827;
																																																																											BgL_carzd211321zd2_3827
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd211316zd2_3825));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211321zd2_3827))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd211316zd2_3825))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211298zd2_3821))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3356z00_3832;
																																																																																	BgL_arg3356z00_3832
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd211304zd2_3822));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17457;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_17461;
																																																																																			obj_t
																																																																																				BgL_proc2z00_17460;
																																																																																			obj_t
																																																																																				BgL_proc1z00_17459;
																																																																																			obj_t
																																																																																				BgL_testz00_17458;
																																																																																			BgL_testz00_17458
																																																																																				=
																																																																																				BgL_arg3356z00_3832;
																																																																																			BgL_proc1z00_17459
																																																																																				=
																																																																																				BgL_carzd211315zd2_3824;
																																																																																			BgL_proc2z00_17460
																																																																																				=
																																																																																				BgL_carzd211321zd2_3827;
																																																																																			BgL_argsz00_17461
																																																																																				=
																																																																																				BgL_cdrzd211298zd2_3821;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_17461;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_17460;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_17459;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_17458;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17457);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17465;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17465);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17469;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17469);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17473;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17473);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17477;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17477);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17481;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17481);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd211654zd2_3840;
																																																																		BgL_cdrzd211654zd2_3840
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd211661zd2_3841;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_10653;
																																																																				BgL_pairz00_10653
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd211661zd2_3841
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_10653);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd211668zd2_3842;
																																																																				BgL_cdrzd211668zd2_3842
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd211661zd2_3841));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd211674zd2_3843;
																																																																					obj_t
																																																																						BgL_cdrzd211675zd2_3844;
																																																																					BgL_carzd211674zd2_3843
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3842));
																																																																					BgL_cdrzd211675zd2_3844
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3842));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211674zd2_3843))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd211675zd2_3844))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd211682zd2_3847;
																																																																									BgL_carzd211682zd2_3847
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd211675zd2_3844);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211682zd2_3847))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd211675zd2_3844)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211654zd2_3840))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3370z00_3852;
																																																																															BgL_arg3370z00_3852
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd211661zd2_3841));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17508;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17512;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17511;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17510;
																																																																																	obj_t
																																																																																		BgL_testz00_17509;
																																																																																	BgL_testz00_17509
																																																																																		=
																																																																																		BgL_arg3370z00_3852;
																																																																																	BgL_proc1z00_17510
																																																																																		=
																																																																																		BgL_carzd211674zd2_3843;
																																																																																	BgL_proc2z00_17511
																																																																																		=
																																																																																		BgL_carzd211682zd2_3847;
																																																																																	BgL_argsz00_17512
																																																																																		=
																																																																																		BgL_cdrzd211654zd2_3840;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_17512;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_17511;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_17510;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_17509;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17508);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17516;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17516);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17520;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17520);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17524;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17524);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17528;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17528);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17532;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17532);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17536;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17536);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd212075zd2_3866;
																																																		BgL_cdrzd212075zd2_3866
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_17540;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3414z00_3883;
																																																				BgL_arg3414z00_3883
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_17540
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3414z00_3883));
																																																			}
																																																			if (BgL_testz00_17540)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3400z00_3869;
																																																					obj_t
																																																						BgL_arg3401z00_3870;
																																																					BgL_arg3400z00_3869
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3866));
																																																					BgL_arg3401z00_3870
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3866));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_17549;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_17551;
																																																							obj_t
																																																								BgL_bindingsz00_17550;
																																																							BgL_bindingsz00_17550
																																																								=
																																																								BgL_arg3400z00_3869;
																																																							BgL_exprz00_17551
																																																								=
																																																								BgL_arg3401z00_3870;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_17551;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_17550;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_14146
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_17549);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_17553;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3412z00_3882;
																																																						BgL_arg3412z00_3882
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_17553
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3412z00_3882));
																																																					}
																																																					if (BgL_testz00_17553)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17558;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17558);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd212141zd2_3873;
																																																							BgL_carzd212141zd2_3873
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd212146zd2_3874;
																																																								BgL_cdrzd212146zd2_3874
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd212141zd2_3873));
																																																								if ((CAR(((obj_t) BgL_carzd212141zd2_3873)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3407z00_3877;
																																																										obj_t
																																																											BgL_arg3408z00_3878;
																																																										obj_t
																																																											BgL_arg3409z00_3879;
																																																										BgL_arg3407z00_3877
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3874));
																																																										BgL_arg3408z00_3878
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3874));
																																																										BgL_arg3409z00_3879
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17575;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_17578;
																																																												obj_t
																																																													BgL_bodyz00_17577;
																																																												obj_t
																																																													BgL_varsz00_17576;
																																																												BgL_varsz00_17576
																																																													=
																																																													BgL_arg3407z00_3877;
																																																												BgL_bodyz00_17577
																																																													=
																																																													BgL_arg3408z00_3878;
																																																												BgL_argsz00_17578
																																																													=
																																																													BgL_arg3409z00_3879;
																																																												BgL_argsz00_1734
																																																													=
																																																													BgL_argsz00_17578;
																																																												BgL_bodyz00_1733
																																																													=
																																																													BgL_bodyz00_17577;
																																																												BgL_varsz00_1732
																																																													=
																																																													BgL_varsz00_17576;
																																																												goto
																																																													BgL_tagzd2386zd2_1735;
																																																											}
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17575);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_17582;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_14146
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_17582);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd212257zd2_3884;
																																																BgL_cdrzd212257zd2_3884
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_17586;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3424z00_3893;
																																																		BgL_arg3424z00_3893
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_17586
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3424z00_3893));
																																																	}
																																																	if (BgL_testz00_17586)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3417z00_3887;
																																																			obj_t
																																																				BgL_arg3418z00_3888;
																																																			BgL_arg3417z00_3887
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3884));
																																																			BgL_arg3418z00_3888
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3884));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17595;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17597;
																																																					obj_t
																																																						BgL_bindingsz00_17596;
																																																					BgL_bindingsz00_17596
																																																						=
																																																						BgL_arg3417z00_3887;
																																																					BgL_exprz00_17597
																																																						=
																																																						BgL_arg3418z00_3888;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_17597;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_17596;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17595);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_17599;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3423z00_3892;
																																																				BgL_arg3423z00_3892
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_17599
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3423z00_3892));
																																																			}
																																																			if (BgL_testz00_17599)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17604;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17604);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1769;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_17608;
																																																							goto
																																																								BgL_tagzd2404zd2_1770;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17608);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210822zd2_3620)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd210824zd2_3622;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd210822zd2_3620 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd210824zd2_3622;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd210822zd2_3620 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd210824zd2_3622;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210822zd2_3620)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd210824zd2_3622;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd212429zd2_3628;
																																																						BgL_cdrzd212429zd2_3628
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_17624;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3282z00_3745;
																																																								BgL_arg3282z00_3745
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_17624
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3282z00_3745));
																																																							}
																																																							if (BgL_testz00_17624)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg3194z00_3631;
																																																									obj_t
																																																										BgL_arg3196z00_3632;
																																																									BgL_arg3194z00_3631
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3628));
																																																									BgL_arg3196z00_3632
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3628));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_17633;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_17635;
																																																											obj_t
																																																												BgL_bindingsz00_17634;
																																																											BgL_bindingsz00_17634
																																																												=
																																																												BgL_arg3194z00_3631;
																																																											BgL_exprz00_17635
																																																												=
																																																												BgL_arg3196z00_3632;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_17635;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_17634;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_17633);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_17637;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3279z00_3744;
																																																										BgL_arg3279z00_3744
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_17637
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3279z00_3744));
																																																									}
																																																									if (BgL_testz00_17637)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_17642;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17642);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd212495zd2_3635;
																																																											BgL_carzd212495zd2_3635
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd212500zd2_3636;
																																																												BgL_cdrzd212500zd2_3636
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd212495zd2_3635));
																																																												if ((CAR(((obj_t) BgL_carzd212495zd2_3635)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd212500zd2_3636))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg3203z00_3640;
																																																																obj_t
																																																																	BgL_arg3204z00_3641;
																																																																obj_t
																																																																	BgL_arg3205z00_3642;
																																																																BgL_arg3203z00_3640
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd212500zd2_3636);
																																																																BgL_arg3204z00_3641
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd212500zd2_3636);
																																																																BgL_arg3205z00_3642
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17659;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_17662;
																																																																		obj_t
																																																																			BgL_bodyz00_17661;
																																																																		obj_t
																																																																			BgL_varsz00_17660;
																																																																		BgL_varsz00_17660
																																																																			=
																																																																			BgL_arg3203z00_3640;
																																																																		BgL_bodyz00_17661
																																																																			=
																																																																			BgL_arg3204z00_3641;
																																																																		BgL_argsz00_17662
																																																																			=
																																																																			BgL_arg3205z00_3642;
																																																																		BgL_argsz00_1734
																																																																			=
																																																																			BgL_argsz00_17662;
																																																																		BgL_bodyz00_1733
																																																																			=
																																																																			BgL_bodyz00_17661;
																																																																		BgL_varsz00_1732
																																																																			=
																																																																			BgL_varsz00_17660;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1735;
																																																																	}
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17659);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_17666;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_17666);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd212607zd2_3645;
																																																														BgL_cdrzd212607zd2_3645
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd212612zd2_3646;
																																																															BgL_cdrzd212612zd2_3646
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd212495zd2_3635));
																																																															if ((CAR(((obj_t) BgL_carzd212495zd2_3635)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd212612zd2_3646))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd212617zd2_3650;
																																																																			BgL_cdrzd212617zd2_3650
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd212612zd2_3646);
																																																																			if (PAIRP(BgL_cdrzd212617zd2_3650))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd212621zd2_3652;
																																																																					obj_t
																																																																						BgL_cdrzd212622zd2_3653;
																																																																					BgL_carzd212621zd2_3652
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd212617zd2_3650);
																																																																					BgL_cdrzd212622zd2_3653
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd212617zd2_3650);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212621zd2_3652))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd212622zd2_3653))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd212627zd2_3656;
																																																																									BgL_carzd212627zd2_3656
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd212622zd2_3653);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212627zd2_3656))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd212622zd2_3653)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_testz00_17694;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1384z00_3689;
																																																																														BgL_l1384z00_3689
																																																																															=
																																																																															BgL_cdrzd212607zd2_3645;
																																																																													BgL_zc3anonymousza33235ze3z83_3690:
																																																																														if (NULLP(BgL_l1384z00_3689))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_17694
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_testz00_17697;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_testz00_17698;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_17699;
																																																																																		BgL_tmpz00_17699
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1384z00_3689));
																																																																																		BgL_testz00_17698
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_17699);
																																																																																	}
																																																																																	if (BgL_testz00_17698)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_testz00_17697
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_testz00_17697
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_testz00_17697)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1384z00_17703;
																																																																																		BgL_l1384z00_17703
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1384z00_3689));
																																																																																		BgL_l1384z00_3689
																																																																																			=
																																																																																			BgL_l1384z00_17703;
																																																																																		goto
																																																																																			BgL_zc3anonymousza33235ze3z83_3690;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_17694
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_testz00_17694)
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3224z00_3672;
																																																																															BgL_arg3224z00_3672
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd212612zd2_3646);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17707;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17711;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17710;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17709;
																																																																																	obj_t
																																																																																		BgL_testz00_17708;
																																																																																	BgL_testz00_17708
																																																																																		=
																																																																																		BgL_arg3224z00_3672;
																																																																																	BgL_proc1z00_17709
																																																																																		=
																																																																																		BgL_carzd212621zd2_3652;
																																																																																	BgL_proc2z00_17710
																																																																																		=
																																																																																		BgL_carzd212627zd2_3656;
																																																																																	BgL_argsz00_17711
																																																																																		=
																																																																																		BgL_cdrzd212607zd2_3645;
																																																																																	BgL_argsz00_1739
																																																																																		=
																																																																																		BgL_argsz00_17711;
																																																																																	BgL_proc2z00_1738
																																																																																		=
																																																																																		BgL_proc2z00_17710;
																																																																																	BgL_proc1z00_1737
																																																																																		=
																																																																																		BgL_proc1z00_17709;
																																																																																	BgL_testz00_1736
																																																																																		=
																																																																																		BgL_testz00_17708;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1740;
																																																																																}
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17707);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd212652zd2_3673;
																																																																															BgL_cdrzd212652zd2_3673
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd212660zd2_3674;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10710;
																																																																																	BgL_pairz00_10710
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd212660zd2_3674
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10710);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd212668zd2_3675;
																																																																																	BgL_cdrzd212668zd2_3675
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd212660zd2_3674));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd212675zd2_3676;
																																																																																		BgL_carzd212675zd2_3676
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd212668zd2_3675));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212675zd2_3676))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd212684zd2_3678;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10714;
																																																																																					BgL_pairz00_10714
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd212668zd2_3675));
																																																																																					BgL_carzd212684zd2_3678
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_10714);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212684zd2_3678))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212652zd2_3673))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg3229z00_3681;
																																																																																								BgL_arg3229z00_3681
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd212660zd2_3674));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17733;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17737;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17736;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17735;
																																																																																										obj_t
																																																																																											BgL_testz00_17734;
																																																																																										BgL_testz00_17734
																																																																																											=
																																																																																											BgL_arg3229z00_3681;
																																																																																										BgL_proc1z00_17735
																																																																																											=
																																																																																											BgL_carzd212675zd2_3676;
																																																																																										BgL_proc2z00_17736
																																																																																											=
																																																																																											BgL_carzd212684zd2_3678;
																																																																																										BgL_argsz00_17737
																																																																																											=
																																																																																											BgL_cdrzd212652zd2_3673;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_argsz00_17737;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_proc2z00_17736;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_proc1z00_17735;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_testz00_17734;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1745;
																																																																																									}
																																																																																									BgL_auxz00_14146
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17733);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17741;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_14146
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17741);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17745;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17745);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17749;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17749);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17753;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17753);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd212962zd2_3700;
																																																																											BgL_cdrzd212962zd2_3700
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd212969zd2_3701;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_10718;
																																																																													BgL_pairz00_10718
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd212969zd2_3701
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10718);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd212976zd2_3702;
																																																																													BgL_cdrzd212976zd2_3702
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd212969zd2_3701));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd212982zd2_3703;
																																																																														obj_t
																																																																															BgL_cdrzd212983zd2_3704;
																																																																														BgL_carzd212982zd2_3703
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3702));
																																																																														BgL_cdrzd212983zd2_3704
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3702));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212982zd2_3703))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd212990zd2_3706;
																																																																																BgL_carzd212990zd2_3706
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd212983zd2_3704));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212990zd2_3706))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212983zd2_3704))))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212962zd2_3700))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg3252z00_3711;
																																																																																						BgL_arg3252z00_3711
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd212969zd2_3701));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17780;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17784;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17783;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17782;
																																																																																								obj_t
																																																																																									BgL_testz00_17781;
																																																																																								BgL_testz00_17781
																																																																																									=
																																																																																									BgL_arg3252z00_3711;
																																																																																								BgL_proc1z00_17782
																																																																																									=
																																																																																									BgL_carzd212982zd2_3703;
																																																																																								BgL_proc2z00_17783
																																																																																									=
																																																																																									BgL_carzd212990zd2_3706;
																																																																																								BgL_argsz00_17784
																																																																																									=
																																																																																									BgL_cdrzd212962zd2_3700;
																																																																																								BgL_argsz00_1744
																																																																																									=
																																																																																									BgL_argsz00_17784;
																																																																																								BgL_proc2z00_1743
																																																																																									=
																																																																																									BgL_proc2z00_17783;
																																																																																								BgL_proc1z00_1742
																																																																																									=
																																																																																									BgL_proc1z00_17782;
																																																																																								BgL_testz00_1741
																																																																																									=
																																																																																									BgL_testz00_17781;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1745;
																																																																																							}
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17780);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17788;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17788);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17792;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17792);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17796;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17796);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17800;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17800);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17804;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17804);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd213323zd2_3719;
																																																																							BgL_cdrzd213323zd2_3719
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd213329zd2_3720;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_10728;
																																																																									BgL_pairz00_10728
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd213329zd2_3720
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_10728);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd213335zd2_3721;
																																																																									BgL_cdrzd213335zd2_3721
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd213329zd2_3720));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd213340zd2_3722;
																																																																										obj_t
																																																																											BgL_cdrzd213341zd2_3723;
																																																																										BgL_carzd213340zd2_3722
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3721));
																																																																										BgL_cdrzd213341zd2_3723
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3721));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213340zd2_3722))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (PAIRP(BgL_cdrzd213341zd2_3723))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd213346zd2_3726;
																																																																														BgL_carzd213346zd2_3726
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd213341zd2_3723);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213346zd2_3726))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(BgL_cdrzd213341zd2_3723)))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd213323zd2_3719))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg3266z00_3731;
																																																																																				BgL_arg3266z00_3731
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd213329zd2_3720));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17831;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_17835;
																																																																																						obj_t
																																																																																							BgL_proc2z00_17834;
																																																																																						obj_t
																																																																																							BgL_proc1z00_17833;
																																																																																						obj_t
																																																																																							BgL_testz00_17832;
																																																																																						BgL_testz00_17832
																																																																																							=
																																																																																							BgL_arg3266z00_3731;
																																																																																						BgL_proc1z00_17833
																																																																																							=
																																																																																							BgL_carzd213340zd2_3722;
																																																																																						BgL_proc2z00_17834
																																																																																							=
																																																																																							BgL_carzd213346zd2_3726;
																																																																																						BgL_argsz00_17835
																																																																																							=
																																																																																							BgL_cdrzd213323zd2_3719;
																																																																																						BgL_argsz00_1744
																																																																																							=
																																																																																							BgL_argsz00_17835;
																																																																																						BgL_proc2z00_1743
																																																																																							=
																																																																																							BgL_proc2z00_17834;
																																																																																						BgL_proc1z00_1742
																																																																																							=
																																																																																							BgL_proc1z00_17833;
																																																																																						BgL_testz00_1741
																																																																																							=
																																																																																							BgL_testz00_17832;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1745;
																																																																																					}
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17831);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17839;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17839);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17843;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17843);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17847;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17847);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17851;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17851);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_17855;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_17855);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17859;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17859);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17863;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17863);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17867;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17867);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((BgL_carzd210819zd2_3618 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg3426z00_3897;
																																													obj_t
																																														BgL_arg3428z00_3898;
																																													BgL_arg3426z00_3897
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3602));
																																													BgL_arg3428z00_3898
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3602));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17876;
																																														{
																																															obj_t
																																																BgL_exprz00_17878;
																																															obj_t
																																																BgL_bindingsz00_17877;
																																															BgL_bindingsz00_17877
																																																=
																																																BgL_arg3426z00_3897;
																																															BgL_exprz00_17878
																																																=
																																																BgL_arg3428z00_3898;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_17878;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_17877;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_14146
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17876);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210819zd2_3618)))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg3430z00_3900;
																																															obj_t
																																																BgL_arg3431z00_3901;
																																															BgL_arg3430z00_3900
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3602));
																																															BgL_arg3431z00_3901
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3602));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17887;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17889;
																																																	obj_t
																																																		BgL_bindingsz00_17888;
																																																	BgL_bindingsz00_17888
																																																		=
																																																		BgL_arg3430z00_3900;
																																																	BgL_exprz00_17889
																																																		=
																																																		BgL_arg3431z00_3901;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_17889;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_17888;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_14146
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17887);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((BgL_carzd210819zd2_3618 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg3433z00_3903;
																																																	obj_t
																																																		BgL_arg3434z00_3904;
																																																	BgL_arg3433z00_3903
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3602));
																																																	BgL_arg3434z00_3904
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3602));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17898;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17900;
																																																			obj_t
																																																				BgL_bindingsz00_17899;
																																																			BgL_bindingsz00_17899
																																																				=
																																																				BgL_arg3433z00_3903;
																																																			BgL_exprz00_17900
																																																				=
																																																				BgL_arg3434z00_3904;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_17900;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_17899;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17898);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_17907;
																																																			goto
																																																				BgL_tagzd2383zd2_1726;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_17907);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd213921zd2_3907;
																																																			BgL_carzd213921zd2_3907
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd213921zd2_3907 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17914;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17914);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd213921zd2_3907)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17919;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17919);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_17926;
																																																									goto
																																																										BgL_tagzd2389zd2_1746;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17926);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17933;
																																																											goto
																																																												BgL_tagzd2390zd2_1747;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17933);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd214001zd2_3914;
																																																											BgL_cdrzd214001zd2_3914
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg3446z00_3917;
																																																													obj_t
																																																														BgL_arg3447z00_3918;
																																																													BgL_arg3446z00_3917
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3914));
																																																													BgL_arg3447z00_3918
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3914));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_17946;
																																																														{
																																																															obj_t
																																																																BgL_restz00_17948;
																																																															obj_t
																																																																BgL_effectz00_17947;
																																																															BgL_effectz00_17947
																																																																=
																																																																BgL_arg3446z00_3917;
																																																															BgL_restz00_17948
																																																																=
																																																																BgL_arg3447z00_3918;
																																																															BgL_restz00_1749
																																																																=
																																																																BgL_restz00_17948;
																																																															BgL_effectz00_1748
																																																																=
																																																																BgL_effectz00_17947;
																																																															goto
																																																																BgL_tagzd2391zd2_1750;
																																																														}
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_17946);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_17955;
																																																															goto
																																																																BgL_tagzd2392zd2_1751;
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_17955);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17962;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1752;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17962);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg3456z00_3926;
																																																																			obj_t
																																																																				BgL_arg3457z00_3927;
																																																																			BgL_arg3456z00_3926
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3914));
																																																																			BgL_arg3457z00_3927
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3914));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_17973;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_17975;
																																																																					obj_t
																																																																						BgL_effectz00_17974;
																																																																					BgL_effectz00_17974
																																																																						=
																																																																						BgL_arg3456z00_3926;
																																																																					BgL_restz00_17975
																																																																						=
																																																																						BgL_arg3457z00_3927;
																																																																					BgL_restz00_1754
																																																																						=
																																																																						BgL_restz00_17975;
																																																																					BgL_effectz00_1753
																																																																						=
																																																																						BgL_effectz00_17974;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1755;
																																																																				}
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_17973);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17982;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1756;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17982);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17989;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1757;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17989);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_17996;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1758;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17996);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_18003;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1759;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18003);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_testz00_18010;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_tmpz00_18011;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10766;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_10765;
																																																																																BgL_pairz00_10765
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_pairz00_10766
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10765);
																																																																															}
																																																																															BgL_tmpz00_18011
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10766);
																																																																														}
																																																																														BgL_testz00_18010
																																																																															=
																																																																															NULLP
																																																																															(BgL_tmpz00_18011);
																																																																													}
																																																																													if (BgL_testz00_18010)
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18017;
																																																																														BgL_tagzd2399zd2_1760:
																																																																															BgL_auxz00_18017 = BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18017);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18022;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18022);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd214094zd2_3946;
																																																																													BgL_cdrzd214094zd2_3946
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3480z00_3949;
																																																																															obj_t
																																																																																BgL_arg3481z00_3950;
																																																																															BgL_arg3480z00_3949
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3946));
																																																																															BgL_arg3481z00_3950
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3946));
																																																																															{	/* Ast/sexp.scm 563 */
																																																																																obj_t
																																																																																	BgL_arg7000z00_10772;
																																																																																BgL_arg7000z00_10772
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3480z00_3949,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3481z00_3950, BgL_stackz00_22, BgL_arg7000z00_10772, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18041;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18041);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd214119zd2_3967;
																															BgL_carzd214119zd2_3967
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd214119zd2_3967
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18048;
																																	goto
																																		BgL_tagzd2377zd2_1714;
																																	BgL_auxz00_14146
																																		=
																																		((obj_t)
																																		BgL_auxz00_18048);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(BgL_carzd214119zd2_3967
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18052;
																																			goto
																																				BgL_tagzd2377zd2_1714;
																																			BgL_auxz00_14146
																																				=
																																				((obj_t)
																																				BgL_auxz00_18052);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_cdrzd214141zd2_3970;
																																			BgL_cdrzd214141zd2_3970
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd214144zd2_3973;
																																					obj_t
																																						BgL_cdrzd214145zd2_3974;
																																					BgL_carzd214144zd2_3973
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd214141zd2_3970));
																																					BgL_cdrzd214145zd2_3974
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd214141zd2_3970));
																																					if (PAIRP(BgL_carzd214144zd2_3973))
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(BgL_carzd214144zd2_3973) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 118 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd214145zd2_3974))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg3511z00_3980;
																																											obj_t
																																												BgL_arg3513z00_3981;
																																											BgL_arg3511z00_3980
																																												=
																																												CDR
																																												(BgL_carzd214144zd2_3973);
																																											BgL_arg3513z00_3981
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214145zd2_3974));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18078;
																																												{
																																													obj_t
																																														BgL_valz00_18080;
																																													obj_t
																																														BgL_lz00_18079;
																																													BgL_lz00_18079
																																														=
																																														BgL_arg3511z00_3980;
																																													BgL_valz00_18080
																																														=
																																														BgL_arg3513z00_3981;
																																													BgL_valz00_1716
																																														=
																																														BgL_valz00_18080;
																																													BgL_lz00_1715
																																														=
																																														BgL_lz00_18079;
																																													goto
																																														BgL_tagzd2378zd2_1717;
																																												}
																																												BgL_auxz00_14146
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18078);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_18082;
																																											goto
																																												BgL_tagzd2379zd2_1718;
																																											BgL_auxz00_14146
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_18082);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_18084;
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_18084);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18086;
																																							goto
																																								BgL_tagzd2379zd2_1718;
																																							BgL_auxz00_14146
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18086);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18093;
																																							goto
																																								BgL_tagzd2380zd2_1719;
																																							BgL_auxz00_14146
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18093);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd214242zd2_3986;
																																							BgL_carzd214242zd2_3986
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd214242zd2_3986))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd214245zd2_3988;
																																									obj_t
																																										BgL_cdrzd214246zd2_3989;
																																									BgL_carzd214245zd2_3988
																																										=
																																										CAR
																																										(BgL_carzd214242zd2_3986);
																																									BgL_cdrzd214246zd2_3989
																																										=
																																										CDR
																																										(BgL_carzd214242zd2_3986);
																																									{

																																										if ((BgL_carzd214245zd2_3988 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 118 */
																																											BgL_kapzd214247zd2_3990:
																																												if (PAIRP(BgL_cdrzd214246zd2_3989))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd214250zd2_4115;
																																														BgL_cdrzd214250zd2_4115
																																															=
																																															CDR
																																															(BgL_cdrzd214246zd2_3989);
																																														if (PAIRP(BgL_cdrzd214250zd2_4115))
																																															{	/* Ast/sexp.scm 118 */
																																																if (NULLP(CDR(BgL_cdrzd214250zd2_4115)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3609z00_4119;
																																																		obj_t
																																																			BgL_arg3610z00_4120;
																																																		BgL_arg3609z00_4119
																																																			=
																																																			CAR
																																																			(BgL_cdrzd214250zd2_4115);
																																																		BgL_arg3610z00_4120
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18115;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_18117;
																																																				obj_t
																																																					BgL_bodyz00_18116;
																																																				BgL_bodyz00_18116
																																																					=
																																																					BgL_arg3609z00_4119;
																																																				BgL_argsz00_18117
																																																					=
																																																					BgL_arg3610z00_4120;
																																																				BgL_argsz00_1721
																																																					=
																																																					BgL_argsz00_18117;
																																																				BgL_bodyz00_1720
																																																					=
																																																					BgL_bodyz00_18116;
																																																				goto
																																																					BgL_tagzd2381zd2_1722;
																																																			}
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18115);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd214274zd2_4121;
																																																		BgL_cdrzd214274zd2_4121
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_18121;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3687z00_4232;
																																																				BgL_arg3687z00_4232
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_18121
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3687z00_4232));
																																																			}
																																																			if (BgL_testz00_18121)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3614z00_4124;
																																																					obj_t
																																																						BgL_arg3616z00_4125;
																																																					BgL_arg3614z00_4124
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4121));
																																																					BgL_arg3616z00_4125
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4121));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_18130;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_18132;
																																																							obj_t
																																																								BgL_bindingsz00_18131;
																																																							BgL_bindingsz00_18131
																																																								=
																																																								BgL_arg3614z00_4124;
																																																							BgL_exprz00_18132
																																																								=
																																																								BgL_arg3616z00_4125;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_18132;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_18131;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_14146
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_18130);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_18134;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3686z00_4231;
																																																						BgL_arg3686z00_4231
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_18134
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3686z00_4231));
																																																					}
																																																					if (BgL_testz00_18134)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18139;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18139);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd214341zd2_4128;
																																																							BgL_carzd214341zd2_4128
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd214346zd2_4129;
																																																								BgL_cdrzd214346zd2_4129
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd214341zd2_4128));
																																																								if ((CAR(((obj_t) BgL_carzd214341zd2_4128)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg3622z00_4132;
																																																										obj_t
																																																											BgL_arg3623z00_4133;
																																																										obj_t
																																																											BgL_arg3624z00_4134;
																																																										BgL_arg3622z00_4132
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4129));
																																																										BgL_arg3623z00_4133
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4129));
																																																										BgL_arg3624z00_4134
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_18156;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_18159;
																																																												obj_t
																																																													BgL_bodyz00_18158;
																																																												obj_t
																																																													BgL_varsz00_18157;
																																																												BgL_varsz00_18157
																																																													=
																																																													BgL_arg3622z00_4132;
																																																												BgL_bodyz00_18158
																																																													=
																																																													BgL_arg3623z00_4133;
																																																												BgL_argsz00_18159
																																																													=
																																																													BgL_arg3624z00_4134;
																																																												BgL_argsz00_1734
																																																													=
																																																													BgL_argsz00_18159;
																																																												BgL_bodyz00_1733
																																																													=
																																																													BgL_bodyz00_18158;
																																																												BgL_varsz00_1732
																																																													=
																																																													BgL_varsz00_18157;
																																																												goto
																																																													BgL_tagzd2386zd2_1735;
																																																											}
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_18156);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd214369zd2_4136;
																																																										BgL_cdrzd214369zd2_4136
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd214375zd2_4137;
																																																											BgL_cdrzd214375zd2_4137
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd214341zd2_4128));
																																																											if ((CAR(((obj_t) BgL_carzd214341zd2_4128)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd214381zd2_4140;
																																																													BgL_cdrzd214381zd2_4140
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214375zd2_4137));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd214386zd2_4141;
																																																														obj_t
																																																															BgL_cdrzd214387zd2_4142;
																																																														BgL_carzd214386zd2_4141
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4140));
																																																														BgL_cdrzd214387zd2_4142
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4140));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214386zd2_4141))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd214387zd2_4142))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd214394zd2_4145;
																																																																		BgL_carzd214394zd2_4145
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd214387zd2_4142);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214394zd2_4145))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd214387zd2_4142)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_18186;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1387z00_4178;
																																																																							BgL_l1387z00_4178
																																																																								=
																																																																								BgL_cdrzd214369zd2_4136;
																																																																						BgL_zc3anonymousza33649ze3z83_4179:
																																																																							if (NULLP(BgL_l1387z00_4178))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_18186
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_18189;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_testz00_18190;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_18191;
																																																																											BgL_tmpz00_18191
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1387z00_4178));
																																																																											BgL_testz00_18190
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_18191);
																																																																										}
																																																																										if (BgL_testz00_18190)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_18189
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_18189
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_testz00_18189)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1387z00_18195;
																																																																											BgL_l1387z00_18195
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1387z00_4178));
																																																																											BgL_l1387z00_4178
																																																																												=
																																																																												BgL_l1387z00_18195;
																																																																											goto
																																																																												BgL_zc3anonymousza33649ze3z83_4179;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_18186
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_testz00_18186)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg3639z00_4161;
																																																																								BgL_arg3639z00_4161
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd214375zd2_4137));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18200;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_18204;
																																																																										obj_t
																																																																											BgL_proc2z00_18203;
																																																																										obj_t
																																																																											BgL_proc1z00_18202;
																																																																										obj_t
																																																																											BgL_testz00_18201;
																																																																										BgL_testz00_18201
																																																																											=
																																																																											BgL_arg3639z00_4161;
																																																																										BgL_proc1z00_18202
																																																																											=
																																																																											BgL_carzd214386zd2_4141;
																																																																										BgL_proc2z00_18203
																																																																											=
																																																																											BgL_carzd214394zd2_4145;
																																																																										BgL_argsz00_18204
																																																																											=
																																																																											BgL_cdrzd214369zd2_4136;
																																																																										BgL_argsz00_1739
																																																																											=
																																																																											BgL_argsz00_18204;
																																																																										BgL_proc2z00_1738
																																																																											=
																																																																											BgL_proc2z00_18203;
																																																																										BgL_proc1z00_1737
																																																																											=
																																																																											BgL_proc1z00_18202;
																																																																										BgL_testz00_1736
																																																																											=
																																																																											BgL_testz00_18201;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1740;
																																																																									}
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18200);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd214418zd2_4162;
																																																																								BgL_cdrzd214418zd2_4162
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd214425zd2_4163;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_10825;
																																																																										BgL_pairz00_10825
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd214425zd2_4163
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10825);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd214432zd2_4164;
																																																																										BgL_cdrzd214432zd2_4164
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd214425zd2_4163));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd214438zd2_4165;
																																																																											BgL_carzd214438zd2_4165
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd214432zd2_4164));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214438zd2_4165))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd214445zd2_4167;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10829;
																																																																														BgL_pairz00_10829
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd214432zd2_4164));
																																																																														BgL_carzd214445zd2_4167
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_10829);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214445zd2_4167))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214418zd2_4162))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3643z00_4170;
																																																																																	BgL_arg3643z00_4170
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd214425zd2_4163));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18226;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_18230;
																																																																																			obj_t
																																																																																				BgL_proc2z00_18229;
																																																																																			obj_t
																																																																																				BgL_proc1z00_18228;
																																																																																			obj_t
																																																																																				BgL_testz00_18227;
																																																																																			BgL_testz00_18227
																																																																																				=
																																																																																				BgL_arg3643z00_4170;
																																																																																			BgL_proc1z00_18228
																																																																																				=
																																																																																				BgL_carzd214438zd2_4165;
																																																																																			BgL_proc2z00_18229
																																																																																				=
																																																																																				BgL_carzd214445zd2_4167;
																																																																																			BgL_argsz00_18230
																																																																																				=
																																																																																				BgL_cdrzd214418zd2_4162;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_18230;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_18229;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_18228;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_18227;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18226);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18234;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18234);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18238;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18238);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18242;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18242);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_18246;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_18246);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd214721zd2_4189;
																																																																				BgL_cdrzd214721zd2_4189
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd214727zd2_4190;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_10833;
																																																																						BgL_pairz00_10833
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd214727zd2_4190
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10833);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd214733zd2_4191;
																																																																						BgL_cdrzd214733zd2_4191
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd214727zd2_4190));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd214738zd2_4192;
																																																																							obj_t
																																																																								BgL_cdrzd214739zd2_4193;
																																																																							BgL_carzd214738zd2_4192
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4191));
																																																																							BgL_cdrzd214739zd2_4193
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4191));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214738zd2_4192))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd214744zd2_4195;
																																																																									BgL_carzd214744zd2_4195
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd214739zd2_4193));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214744zd2_4195))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd214739zd2_4193))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214721zd2_4189))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3659z00_4200;
																																																																															BgL_arg3659z00_4200
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214727zd2_4190));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18273;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_18277;
																																																																																	obj_t
																																																																																		BgL_proc2z00_18276;
																																																																																	obj_t
																																																																																		BgL_proc1z00_18275;
																																																																																	obj_t
																																																																																		BgL_testz00_18274;
																																																																																	BgL_testz00_18274
																																																																																		=
																																																																																		BgL_arg3659z00_4200;
																																																																																	BgL_proc1z00_18275
																																																																																		=
																																																																																		BgL_carzd214738zd2_4192;
																																																																																	BgL_proc2z00_18276
																																																																																		=
																																																																																		BgL_carzd214744zd2_4195;
																																																																																	BgL_argsz00_18277
																																																																																		=
																																																																																		BgL_cdrzd214721zd2_4189;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_18277;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_18276;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_18275;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_18274;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18273);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18281;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18281);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18285;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18285);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18289;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18289);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18293;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18293);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18297;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18297);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd215077zd2_4208;
																																																																BgL_cdrzd215077zd2_4208
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd215084zd2_4209;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_10843;
																																																																		BgL_pairz00_10843
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd215084zd2_4209
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_10843);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd215091zd2_4210;
																																																																		BgL_cdrzd215091zd2_4210
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd215084zd2_4209));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd215097zd2_4211;
																																																																			obj_t
																																																																				BgL_cdrzd215098zd2_4212;
																																																																			BgL_carzd215097zd2_4211
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4210));
																																																																			BgL_cdrzd215098zd2_4212
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4210));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215097zd2_4211))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd215098zd2_4212))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd215105zd2_4215;
																																																																							BgL_carzd215105zd2_4215
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd215098zd2_4212);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215105zd2_4215))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd215098zd2_4212)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd215077zd2_4208))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3674z00_4220;
																																																																													BgL_arg3674z00_4220
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd215084zd2_4209));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18324;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18328;
																																																																															obj_t
																																																																																BgL_proc2z00_18327;
																																																																															obj_t
																																																																																BgL_proc1z00_18326;
																																																																															obj_t
																																																																																BgL_testz00_18325;
																																																																															BgL_testz00_18325
																																																																																=
																																																																																BgL_arg3674z00_4220;
																																																																															BgL_proc1z00_18326
																																																																																=
																																																																																BgL_carzd215097zd2_4211;
																																																																															BgL_proc2z00_18327
																																																																																=
																																																																																BgL_carzd215105zd2_4215;
																																																																															BgL_argsz00_18328
																																																																																=
																																																																																BgL_cdrzd215077zd2_4208;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_18328;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_18327;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_18326;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_18325;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18324);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18332;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18332);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18336;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18336);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18340;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18340);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18344;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18344);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18348;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18348);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18352;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18352);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd215498zd2_4234;
																																																BgL_cdrzd215498zd2_4234
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_18356;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3705z00_4251;
																																																		BgL_arg3705z00_4251
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_18356
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3705z00_4251));
																																																	}
																																																	if (BgL_testz00_18356)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3692z00_4237;
																																																			obj_t
																																																				BgL_arg3693z00_4238;
																																																			BgL_arg3692z00_4237
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4234));
																																																			BgL_arg3693z00_4238
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4234));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18365;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18367;
																																																					obj_t
																																																						BgL_bindingsz00_18366;
																																																					BgL_bindingsz00_18366
																																																						=
																																																						BgL_arg3692z00_4237;
																																																					BgL_exprz00_18367
																																																						=
																																																						BgL_arg3693z00_4238;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_18367;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_18366;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18365);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_18369;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3704z00_4250;
																																																				BgL_arg3704z00_4250
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_18369
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3704z00_4250));
																																																			}
																																																			if (BgL_testz00_18369)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18374;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18374);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd215564zd2_4241;
																																																					BgL_carzd215564zd2_4241
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd215569zd2_4242;
																																																						BgL_cdrzd215569zd2_4242
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd215564zd2_4241));
																																																						if ((CAR(((obj_t) BgL_carzd215564zd2_4241)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3699z00_4245;
																																																								obj_t
																																																									BgL_arg3700z00_4246;
																																																								obj_t
																																																									BgL_arg3701z00_4247;
																																																								BgL_arg3699z00_4245
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4242));
																																																								BgL_arg3700z00_4246
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4242));
																																																								BgL_arg3701z00_4247
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18391;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_18394;
																																																										obj_t
																																																											BgL_bodyz00_18393;
																																																										obj_t
																																																											BgL_varsz00_18392;
																																																										BgL_varsz00_18392
																																																											=
																																																											BgL_arg3699z00_4245;
																																																										BgL_bodyz00_18393
																																																											=
																																																											BgL_arg3700z00_4246;
																																																										BgL_argsz00_18394
																																																											=
																																																											BgL_arg3701z00_4247;
																																																										BgL_argsz00_1734
																																																											=
																																																											BgL_argsz00_18394;
																																																										BgL_bodyz00_1733
																																																											=
																																																											BgL_bodyz00_18393;
																																																										BgL_varsz00_1732
																																																											=
																																																											BgL_varsz00_18392;
																																																										goto
																																																											BgL_tagzd2386zd2_1735;
																																																									}
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18391);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1769;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_18398;
																																																										goto
																																																											BgL_tagzd2404zd2_1770;
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_18398);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd215680zd2_4252;
																																														BgL_cdrzd215680zd2_4252
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_18402;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg3715z00_4261;
																																																BgL_arg3715z00_4261
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_18402
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg3715z00_4261));
																																															}
																																															if (BgL_testz00_18402)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg3708z00_4255;
																																																	obj_t
																																																		BgL_arg3710z00_4256;
																																																	BgL_arg3708z00_4255
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4252));
																																																	BgL_arg3710z00_4256
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4252));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18411;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18413;
																																																			obj_t
																																																				BgL_bindingsz00_18412;
																																																			BgL_bindingsz00_18412
																																																				=
																																																				BgL_arg3708z00_4255;
																																																			BgL_exprz00_18413
																																																				=
																																																				BgL_arg3710z00_4256;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_18413;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_18412;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18411);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_18415;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3714z00_4260;
																																																		BgL_arg3714z00_4260
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_18415
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg3714z00_4260));
																																																	}
																																																	if (BgL_testz00_18415)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18420;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18420);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1769;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_18424;
																																																					goto
																																																						BgL_tagzd2404zd2_1770;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18424);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214245zd2_3988)))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd214247zd2_3990;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd214245zd2_3988 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd214247zd2_3990;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd214245zd2_3988 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd214247zd2_3990;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd214245zd2_3988)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd214247zd2_3990;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd215852zd2_3996;
																																																				BgL_cdrzd215852zd2_3996
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_18440;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3604z00_4113;
																																																						BgL_arg3604z00_4113
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_18440
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3604z00_4113));
																																																					}
																																																					if (BgL_testz00_18440)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg3527z00_3999;
																																																							obj_t
																																																								BgL_arg3529z00_4000;
																																																							BgL_arg3527z00_3999
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_3996));
																																																							BgL_arg3529z00_4000
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_3996));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_18449;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_18451;
																																																									obj_t
																																																										BgL_bindingsz00_18450;
																																																									BgL_bindingsz00_18450
																																																										=
																																																										BgL_arg3527z00_3999;
																																																									BgL_exprz00_18451
																																																										=
																																																										BgL_arg3529z00_4000;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_18451;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_18450;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_18449);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_18453;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3603z00_4112;
																																																								BgL_arg3603z00_4112
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_18453
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3603z00_4112));
																																																							}
																																																							if (BgL_testz00_18453)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_18458;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18458);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd215918zd2_4003;
																																																									BgL_carzd215918zd2_4003
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd215923zd2_4004;
																																																										BgL_cdrzd215923zd2_4004
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd215918zd2_4003));
																																																										if ((CAR(((obj_t) BgL_carzd215918zd2_4003)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd215923zd2_4004))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg3535z00_4008;
																																																														obj_t
																																																															BgL_arg3537z00_4009;
																																																														obj_t
																																																															BgL_arg3538z00_4010;
																																																														BgL_arg3535z00_4008
																																																															=
																																																															CAR
																																																															(BgL_cdrzd215923zd2_4004);
																																																														BgL_arg3537z00_4009
																																																															=
																																																															CDR
																																																															(BgL_cdrzd215923zd2_4004);
																																																														BgL_arg3538z00_4010
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18475;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_18478;
																																																																obj_t
																																																																	BgL_bodyz00_18477;
																																																																obj_t
																																																																	BgL_varsz00_18476;
																																																																BgL_varsz00_18476
																																																																	=
																																																																	BgL_arg3535z00_4008;
																																																																BgL_bodyz00_18477
																																																																	=
																																																																	BgL_arg3537z00_4009;
																																																																BgL_argsz00_18478
																																																																	=
																																																																	BgL_arg3538z00_4010;
																																																																BgL_argsz00_1734
																																																																	=
																																																																	BgL_argsz00_18478;
																																																																BgL_bodyz00_1733
																																																																	=
																																																																	BgL_bodyz00_18477;
																																																																BgL_varsz00_1732
																																																																	=
																																																																	BgL_varsz00_18476;
																																																																goto
																																																																	BgL_tagzd2386zd2_1735;
																																																															}
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18475);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_18482;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_18482);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd216030zd2_4013;
																																																												BgL_cdrzd216030zd2_4013
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd216035zd2_4014;
																																																													BgL_cdrzd216035zd2_4014
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd215918zd2_4003));
																																																													if ((CAR(((obj_t) BgL_carzd215918zd2_4003)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (PAIRP(BgL_cdrzd216035zd2_4014))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd216040zd2_4018;
																																																																	BgL_cdrzd216040zd2_4018
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd216035zd2_4014);
																																																																	if (PAIRP(BgL_cdrzd216040zd2_4018))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd216044zd2_4020;
																																																																			obj_t
																																																																				BgL_cdrzd216045zd2_4021;
																																																																			BgL_carzd216044zd2_4020
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd216040zd2_4018);
																																																																			BgL_cdrzd216045zd2_4021
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd216040zd2_4018);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216044zd2_4020))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd216045zd2_4021))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd216050zd2_4024;
																																																																							BgL_carzd216050zd2_4024
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd216045zd2_4021);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216050zd2_4024))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd216045zd2_4021)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_18510;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1390z00_4057;
																																																																												BgL_l1390z00_4057
																																																																													=
																																																																													BgL_cdrzd216030zd2_4013;
																																																																											BgL_zc3anonymousza33564ze3z83_4058:
																																																																												if (NULLP(BgL_l1390z00_4057))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_18510
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_testz00_18513;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_testz00_18514;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_tmpz00_18515;
																																																																																BgL_tmpz00_18515
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1390z00_4057));
																																																																																BgL_testz00_18514
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_18515);
																																																																															}
																																																																															if (BgL_testz00_18514)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_18513
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_18513
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_testz00_18513)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1390z00_18519;
																																																																																BgL_l1390z00_18519
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1390z00_4057));
																																																																																BgL_l1390z00_4057
																																																																																	=
																																																																																	BgL_l1390z00_18519;
																																																																																goto
																																																																																	BgL_zc3anonymousza33564ze3z83_4058;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_18510
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_testz00_18510)
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3554z00_4040;
																																																																													BgL_arg3554z00_4040
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd216035zd2_4014);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18523;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18527;
																																																																															obj_t
																																																																																BgL_proc2z00_18526;
																																																																															obj_t
																																																																																BgL_proc1z00_18525;
																																																																															obj_t
																																																																																BgL_testz00_18524;
																																																																															BgL_testz00_18524
																																																																																=
																																																																																BgL_arg3554z00_4040;
																																																																															BgL_proc1z00_18525
																																																																																=
																																																																																BgL_carzd216044zd2_4020;
																																																																															BgL_proc2z00_18526
																																																																																=
																																																																																BgL_carzd216050zd2_4024;
																																																																															BgL_argsz00_18527
																																																																																=
																																																																																BgL_cdrzd216030zd2_4013;
																																																																															BgL_argsz00_1739
																																																																																=
																																																																																BgL_argsz00_18527;
																																																																															BgL_proc2z00_1738
																																																																																=
																																																																																BgL_proc2z00_18526;
																																																																															BgL_proc1z00_1737
																																																																																=
																																																																																BgL_proc1z00_18525;
																																																																															BgL_testz00_1736
																																																																																=
																																																																																BgL_testz00_18524;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1740;
																																																																														}
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18523);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd216075zd2_4041;
																																																																													BgL_cdrzd216075zd2_4041
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd216083zd2_4042;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_10900;
																																																																															BgL_pairz00_10900
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd216083zd2_4042
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10900);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd216091zd2_4043;
																																																																															BgL_cdrzd216091zd2_4043
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd216083zd2_4042));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd216098zd2_4044;
																																																																																BgL_carzd216098zd2_4044
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd216091zd2_4043));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216098zd2_4044))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd216107zd2_4046;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10904;
																																																																																			BgL_pairz00_10904
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd216091zd2_4043));
																																																																																			BgL_carzd216107zd2_4046
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_10904);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216107zd2_4046))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216075zd2_4041))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg3558z00_4049;
																																																																																						BgL_arg3558z00_4049
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd216083zd2_4042));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_18549;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_18553;
																																																																																								obj_t
																																																																																									BgL_proc2z00_18552;
																																																																																								obj_t
																																																																																									BgL_proc1z00_18551;
																																																																																								obj_t
																																																																																									BgL_testz00_18550;
																																																																																								BgL_testz00_18550
																																																																																									=
																																																																																									BgL_arg3558z00_4049;
																																																																																								BgL_proc1z00_18551
																																																																																									=
																																																																																									BgL_carzd216098zd2_4044;
																																																																																								BgL_proc2z00_18552
																																																																																									=
																																																																																									BgL_carzd216107zd2_4046;
																																																																																								BgL_argsz00_18553
																																																																																									=
																																																																																									BgL_cdrzd216075zd2_4041;
																																																																																								BgL_argsz00_1744
																																																																																									=
																																																																																									BgL_argsz00_18553;
																																																																																								BgL_proc2z00_1743
																																																																																									=
																																																																																									BgL_proc2z00_18552;
																																																																																								BgL_proc1z00_1742
																																																																																									=
																																																																																									BgL_proc1z00_18551;
																																																																																								BgL_testz00_1741
																																																																																									=
																																																																																									BgL_testz00_18550;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1745;
																																																																																							}
																																																																																							BgL_auxz00_14146
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_18549);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_18557;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_14146
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_18557);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18561;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18561);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18565;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18565);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18569;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18569);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd216385zd2_4068;
																																																																									BgL_cdrzd216385zd2_4068
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd216392zd2_4069;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_10908;
																																																																											BgL_pairz00_10908
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd216392zd2_4069
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10908);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd216399zd2_4070;
																																																																											BgL_cdrzd216399zd2_4070
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd216392zd2_4069));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd216405zd2_4071;
																																																																												obj_t
																																																																													BgL_cdrzd216406zd2_4072;
																																																																												BgL_carzd216405zd2_4071
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4070));
																																																																												BgL_cdrzd216406zd2_4072
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4070));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216405zd2_4071))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd216413zd2_4074;
																																																																														BgL_carzd216413zd2_4074
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd216406zd2_4072));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216413zd2_4074))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd216406zd2_4072))))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216385zd2_4068))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg3574z00_4079;
																																																																																				BgL_arg3574z00_4079
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd216392zd2_4069));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_18596;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_18600;
																																																																																						obj_t
																																																																																							BgL_proc2z00_18599;
																																																																																						obj_t
																																																																																							BgL_proc1z00_18598;
																																																																																						obj_t
																																																																																							BgL_testz00_18597;
																																																																																						BgL_testz00_18597
																																																																																							=
																																																																																							BgL_arg3574z00_4079;
																																																																																						BgL_proc1z00_18598
																																																																																							=
																																																																																							BgL_carzd216405zd2_4071;
																																																																																						BgL_proc2z00_18599
																																																																																							=
																																																																																							BgL_carzd216413zd2_4074;
																																																																																						BgL_argsz00_18600
																																																																																							=
																																																																																							BgL_cdrzd216385zd2_4068;
																																																																																						BgL_argsz00_1744
																																																																																							=
																																																																																							BgL_argsz00_18600;
																																																																																						BgL_proc2z00_1743
																																																																																							=
																																																																																							BgL_proc2z00_18599;
																																																																																						BgL_proc1z00_1742
																																																																																							=
																																																																																							BgL_proc1z00_18598;
																																																																																						BgL_testz00_1741
																																																																																							=
																																																																																							BgL_testz00_18597;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1745;
																																																																																					}
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_18596);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18604;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_14146
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18604);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18608;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18608);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18612;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18612);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18616;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18616);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18620;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18620);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd216746zd2_4087;
																																																																					BgL_cdrzd216746zd2_4087
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd216752zd2_4088;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_10918;
																																																																							BgL_pairz00_10918
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd216752zd2_4088
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_10918);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd216758zd2_4089;
																																																																							BgL_cdrzd216758zd2_4089
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd216752zd2_4088));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd216763zd2_4090;
																																																																								obj_t
																																																																									BgL_cdrzd216764zd2_4091;
																																																																								BgL_carzd216763zd2_4090
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4089));
																																																																								BgL_cdrzd216764zd2_4091
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4089));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216763zd2_4090))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (PAIRP(BgL_cdrzd216764zd2_4091))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd216769zd2_4094;
																																																																												BgL_carzd216769zd2_4094
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd216764zd2_4091);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216769zd2_4094))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (NULLP(CDR(BgL_cdrzd216764zd2_4091)))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216746zd2_4087))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg3588z00_4099;
																																																																																		BgL_arg3588z00_4099
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd216752zd2_4088));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18647;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_18651;
																																																																																				obj_t
																																																																																					BgL_proc2z00_18650;
																																																																																				obj_t
																																																																																					BgL_proc1z00_18649;
																																																																																				obj_t
																																																																																					BgL_testz00_18648;
																																																																																				BgL_testz00_18648
																																																																																					=
																																																																																					BgL_arg3588z00_4099;
																																																																																				BgL_proc1z00_18649
																																																																																					=
																																																																																					BgL_carzd216763zd2_4090;
																																																																																				BgL_proc2z00_18650
																																																																																					=
																																																																																					BgL_carzd216769zd2_4094;
																																																																																				BgL_argsz00_18651
																																																																																					=
																																																																																					BgL_cdrzd216746zd2_4087;
																																																																																				BgL_argsz00_1744
																																																																																					=
																																																																																					BgL_argsz00_18651;
																																																																																				BgL_proc2z00_1743
																																																																																					=
																																																																																					BgL_proc2z00_18650;
																																																																																				BgL_proc1z00_1742
																																																																																					=
																																																																																					BgL_proc1z00_18649;
																																																																																				BgL_testz00_1741
																																																																																					=
																																																																																					BgL_testz00_18648;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1745;
																																																																																			}
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18647);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18655;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18655);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18659;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18659);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18663;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18663);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18667;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18667);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18671;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18671);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18675;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18675);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18679;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18679);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18683;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18683);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd214242zd2_3986 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg3717z00_4265;
																																											obj_t
																																												BgL_arg3718z00_4266;
																																											BgL_arg3717z00_4265
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_3970));
																																											BgL_arg3718z00_4266
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_3970));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18692;
																																												{
																																													obj_t
																																														BgL_exprz00_18694;
																																													obj_t
																																														BgL_bindingsz00_18693;
																																													BgL_bindingsz00_18693
																																														=
																																														BgL_arg3717z00_4265;
																																													BgL_exprz00_18694
																																														=
																																														BgL_arg3718z00_4266;
																																													BgL_exprz00_1724
																																														=
																																														BgL_exprz00_18694;
																																													BgL_bindingsz00_1723
																																														=
																																														BgL_bindingsz00_18693;
																																													goto
																																														BgL_tagzd2382zd2_1725;
																																												}
																																												BgL_auxz00_14146
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18692);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214242zd2_3986)))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg3720z00_4268;
																																													obj_t
																																														BgL_arg3721z00_4269;
																																													BgL_arg3720z00_4268
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_3970));
																																													BgL_arg3721z00_4269
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_3970));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_18703;
																																														{
																																															obj_t
																																																BgL_exprz00_18705;
																																															obj_t
																																																BgL_bindingsz00_18704;
																																															BgL_bindingsz00_18704
																																																=
																																																BgL_arg3720z00_4268;
																																															BgL_exprz00_18705
																																																=
																																																BgL_arg3721z00_4269;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_18705;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_18704;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_14146
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_18703);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((BgL_carzd214242zd2_3986 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg3723z00_4271;
																																															obj_t
																																																BgL_arg3724z00_4272;
																																															BgL_arg3723z00_4271
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_3970));
																																															BgL_arg3724z00_4272
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_3970));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18714;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18716;
																																																	obj_t
																																																		BgL_bindingsz00_18715;
																																																	BgL_bindingsz00_18715
																																																		=
																																																		BgL_arg3723z00_4271;
																																																	BgL_exprz00_18716
																																																		=
																																																		BgL_arg3724z00_4272;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_18716;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_18715;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_14146
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18714);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18723;
																																																	goto
																																																		BgL_tagzd2383zd2_1726;
																																																	BgL_auxz00_14146
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18723);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd217344zd2_4275;
																																																	BgL_carzd217344zd2_4275
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd217344zd2_4275 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18730;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18730);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217344zd2_4275)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18735;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18735);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_18742;
																																																							goto
																																																								BgL_tagzd2389zd2_1746;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18742);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18749;
																																																									goto
																																																										BgL_tagzd2390zd2_1747;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18749);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd217424zd2_4282;
																																																									BgL_cdrzd217424zd2_4282
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg3736z00_4285;
																																																											obj_t
																																																												BgL_arg3737z00_4286;
																																																											BgL_arg3736z00_4285
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4282));
																																																											BgL_arg3737z00_4286
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4282));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_18762;
																																																												{
																																																													obj_t
																																																														BgL_restz00_18764;
																																																													obj_t
																																																														BgL_effectz00_18763;
																																																													BgL_effectz00_18763
																																																														=
																																																														BgL_arg3736z00_4285;
																																																													BgL_restz00_18764
																																																														=
																																																														BgL_arg3737z00_4286;
																																																													BgL_restz00_1749
																																																														=
																																																														BgL_restz00_18764;
																																																													BgL_effectz00_1748
																																																														=
																																																														BgL_effectz00_18763;
																																																													goto
																																																														BgL_tagzd2391zd2_1750;
																																																												}
																																																												BgL_auxz00_14146
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_18762);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_18771;
																																																													goto
																																																														BgL_tagzd2392zd2_1751;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_18771);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18778;
																																																															goto
																																																																BgL_tagzd2393zd2_1752;
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18778);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg3744z00_4294;
																																																																	obj_t
																																																																		BgL_arg3745z00_4295;
																																																																	BgL_arg3744z00_4294
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4282));
																																																																	BgL_arg3745z00_4295
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4282));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18789;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_18791;
																																																																			obj_t
																																																																				BgL_effectz00_18790;
																																																																			BgL_effectz00_18790
																																																																				=
																																																																				BgL_arg3744z00_4294;
																																																																			BgL_restz00_18791
																																																																				=
																																																																				BgL_arg3745z00_4295;
																																																																			BgL_restz00_1754
																																																																				=
																																																																				BgL_restz00_18791;
																																																																			BgL_effectz00_1753
																																																																				=
																																																																				BgL_effectz00_18790;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1755;
																																																																		}
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18789);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18798;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1756;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18798);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18805;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1757;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18805);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_18812;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1758;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18812);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_18819;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1759;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18819);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_18826;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_tmpz00_18827;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_10956;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_10955;
																																																																														BgL_pairz00_10955
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_10956
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10955);
																																																																													}
																																																																													BgL_tmpz00_18827
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10956);
																																																																												}
																																																																												BgL_testz00_18826
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_18827);
																																																																											}
																																																																											if (BgL_testz00_18826)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18833;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1760;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18833);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18837;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18837);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd217512zd2_4314;
																																																																											BgL_cdrzd217512zd2_4314
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd217518zd2_4317;
																																																																													BgL_cdrzd217518zd2_4317
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd217512zd2_4314));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd217524zd2_4318;
																																																																														BgL_cdrzd217524zd2_4318
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd217518zd2_4317));
																																																																														if ((CAR(((obj_t) BgL_cdrzd217518zd2_4317)) == CNST_TABLE_REF(((long) 31))))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (PAIRP(BgL_cdrzd217524zd2_4318))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg3769z00_4322;
																																																																																		obj_t
																																																																																			BgL_arg3770z00_4323;
																																																																																		obj_t
																																																																																			BgL_arg3771z00_4324;
																																																																																		BgL_arg3769z00_4322
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4314));
																																																																																		BgL_arg3770z00_4323
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd217524zd2_4318);
																																																																																		BgL_arg3771z00_4324
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd217524zd2_4318);
																																																																																		{	/* Ast/sexp.scm 561 */
																																																																																			obj_t
																																																																																				BgL_arg6999z00_10967;
																																																																																			BgL_arg6999z00_10967
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3769z00_4322,
																																																																																					BgL_arg3770z00_4323,
																																																																																					BgL_arg3771z00_4324,
																																																																																					BgL_stackz00_22,
																																																																																					BgL_arg6999z00_10967,
																																																																																					BgL_sitez00_24));
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg3772z00_4326;
																																																																																		obj_t
																																																																																			BgL_arg3773z00_4327;
																																																																																		BgL_arg3772z00_4326
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4314));
																																																																																		BgL_arg3773z00_4327
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4314));
																																																																																		{	/* Ast/sexp.scm 563 */
																																																																																			obj_t
																																																																																				BgL_arg7000z00_10971;
																																																																																			BgL_arg7000z00_10971
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3772z00_4326,
																																																																																					CNST_TABLE_REF
																																																																																					(((long) 4)), BgL_arg3773z00_4327, BgL_stackz00_22, BgL_arg7000z00_10971, BgL_sitez00_24));
																																																																															}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg3774z00_4329;
																																																																																obj_t
																																																																																	BgL_arg3775z00_4330;
																																																																																BgL_arg3774z00_4329
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4314));
																																																																																BgL_arg3775z00_4330
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4314));
																																																																																{	/* Ast/sexp.scm 563 */
																																																																																	obj_t
																																																																																		BgL_arg7000z00_10975;
																																																																																	BgL_arg7000z00_10975
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg3774z00_4329,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg3775z00_4330, BgL_stackz00_22, BgL_arg7000z00_10975, BgL_sitez00_24));
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18882;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18882);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_carzd217575zd2_4349;
																													BgL_carzd217575zd2_4349
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd217575zd2_4349
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_18889;
																															goto
																																BgL_tagzd2377zd2_1714;
																															BgL_auxz00_14146 =
																																((obj_t)
																																BgL_auxz00_18889);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(BgL_carzd217575zd2_4349
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18893;
																																	goto
																																		BgL_tagzd2377zd2_1714;
																																	BgL_auxz00_14146
																																		=
																																		((obj_t)
																																		BgL_auxz00_18893);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18900;
																																			goto
																																				BgL_tagzd2379zd2_1718;
																																			BgL_auxz00_14146
																																				=
																																				((obj_t)
																																				BgL_auxz00_18900);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_18907;
																																					goto
																																						BgL_tagzd2380zd2_1719;
																																					BgL_auxz00_14146
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_18907);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd217644zd2_4356;
																																					BgL_carzd217644zd2_4356
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd217644zd2_4356))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd217647zd2_4358;
																																							obj_t
																																								BgL_cdrzd217648zd2_4359;
																																							BgL_carzd217647zd2_4358
																																								=
																																								CAR
																																								(BgL_carzd217644zd2_4356);
																																							BgL_cdrzd217648zd2_4359
																																								=
																																								CDR
																																								(BgL_carzd217644zd2_4356);
																																							{

																																								if ((BgL_carzd217647zd2_4358 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 118 */
																																									BgL_kapzd217649zd2_4360:
																																										if (PAIRP(BgL_cdrzd217648zd2_4359))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd217652zd2_4542;
																																												BgL_cdrzd217652zd2_4542
																																													=
																																													CDR
																																													(BgL_cdrzd217648zd2_4359);
																																												if (PAIRP(BgL_cdrzd217652zd2_4542))
																																													{	/* Ast/sexp.scm 118 */
																																														if (NULLP(CDR(BgL_cdrzd217652zd2_4542)))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg3929z00_4546;
																																																obj_t
																																																	BgL_arg3930z00_4547;
																																																BgL_arg3929z00_4546
																																																	=
																																																	CAR
																																																	(BgL_cdrzd217652zd2_4542);
																																																BgL_arg3930z00_4547
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18929;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_18931;
																																																		obj_t
																																																			BgL_bodyz00_18930;
																																																		BgL_bodyz00_18930
																																																			=
																																																			BgL_arg3929z00_4546;
																																																		BgL_argsz00_18931
																																																			=
																																																			BgL_arg3930z00_4547;
																																																		BgL_argsz00_1721
																																																			=
																																																			BgL_argsz00_18931;
																																																		BgL_bodyz00_1720
																																																			=
																																																			BgL_bodyz00_18930;
																																																		goto
																																																			BgL_tagzd2381zd2_1722;
																																																	}
																																																	BgL_auxz00_14146
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18929);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd217676zd2_4548;
																																																BgL_cdrzd217676zd2_4548
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_18935;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg3999z00_4659;
																																																		BgL_arg3999z00_4659
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_18935
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3999z00_4659));
																																																	}
																																																	if (BgL_testz00_18935)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg3933z00_4551;
																																																			obj_t
																																																				BgL_arg3934z00_4552;
																																																			BgL_arg3933z00_4551
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4548));
																																																			BgL_arg3934z00_4552
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4548));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18944;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18946;
																																																					obj_t
																																																						BgL_bindingsz00_18945;
																																																					BgL_bindingsz00_18945
																																																						=
																																																						BgL_arg3933z00_4551;
																																																					BgL_exprz00_18946
																																																						=
																																																						BgL_arg3934z00_4552;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_18946;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_18945;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18944);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_18948;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3998z00_4658;
																																																				BgL_arg3998z00_4658
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_18948
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3998z00_4658));
																																																			}
																																																			if (BgL_testz00_18948)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18953;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18953);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd217743zd2_4555;
																																																					BgL_carzd217743zd2_4555
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd217748zd2_4556;
																																																						BgL_cdrzd217748zd2_4556
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd217743zd2_4555));
																																																						if ((CAR(((obj_t) BgL_carzd217743zd2_4555)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg3939z00_4559;
																																																								obj_t
																																																									BgL_arg3940z00_4560;
																																																								obj_t
																																																									BgL_arg3941z00_4561;
																																																								BgL_arg3939z00_4559
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4556));
																																																								BgL_arg3940z00_4560
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4556));
																																																								BgL_arg3941z00_4561
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18970;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_18973;
																																																										obj_t
																																																											BgL_bodyz00_18972;
																																																										obj_t
																																																											BgL_varsz00_18971;
																																																										BgL_varsz00_18971
																																																											=
																																																											BgL_arg3939z00_4559;
																																																										BgL_bodyz00_18972
																																																											=
																																																											BgL_arg3940z00_4560;
																																																										BgL_argsz00_18973
																																																											=
																																																											BgL_arg3941z00_4561;
																																																										BgL_argsz00_1734
																																																											=
																																																											BgL_argsz00_18973;
																																																										BgL_bodyz00_1733
																																																											=
																																																											BgL_bodyz00_18972;
																																																										BgL_varsz00_1732
																																																											=
																																																											BgL_varsz00_18971;
																																																										goto
																																																											BgL_tagzd2386zd2_1735;
																																																									}
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18970);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd217771zd2_4563;
																																																								BgL_cdrzd217771zd2_4563
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd217777zd2_4564;
																																																									BgL_cdrzd217777zd2_4564
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd217743zd2_4555));
																																																									if ((CAR(((obj_t) BgL_carzd217743zd2_4555)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd217783zd2_4567;
																																																											BgL_cdrzd217783zd2_4567
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217777zd2_4564));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd217788zd2_4568;
																																																												obj_t
																																																													BgL_cdrzd217789zd2_4569;
																																																												BgL_carzd217788zd2_4568
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4567));
																																																												BgL_cdrzd217789zd2_4569
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4567));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217788zd2_4568))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd217789zd2_4569))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd217796zd2_4572;
																																																																BgL_carzd217796zd2_4572
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd217789zd2_4569);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217796zd2_4572))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd217789zd2_4569)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_testz00_19000;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1393z00_4605;
																																																																					BgL_l1393z00_4605
																																																																						=
																																																																						BgL_cdrzd217771zd2_4563;
																																																																				BgL_zc3anonymousza33964ze3z83_4606:
																																																																					if (NULLP(BgL_l1393z00_4605))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_19000
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_testz00_19003;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_19004;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_tmpz00_19005;
																																																																									BgL_tmpz00_19005
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1393z00_4605));
																																																																									BgL_testz00_19004
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_19005);
																																																																								}
																																																																								if (BgL_testz00_19004)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_19003
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_19003
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_testz00_19003)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1393z00_19009;
																																																																									BgL_l1393z00_19009
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1393z00_4605));
																																																																									BgL_l1393z00_4605
																																																																										=
																																																																										BgL_l1393z00_19009;
																																																																									goto
																																																																										BgL_zc3anonymousza33964ze3z83_4606;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_19000
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_testz00_19000)
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg3954z00_4588;
																																																																						BgL_arg3954z00_4588
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd217777zd2_4564));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19014;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_19018;
																																																																								obj_t
																																																																									BgL_proc2z00_19017;
																																																																								obj_t
																																																																									BgL_proc1z00_19016;
																																																																								obj_t
																																																																									BgL_testz00_19015;
																																																																								BgL_testz00_19015
																																																																									=
																																																																									BgL_arg3954z00_4588;
																																																																								BgL_proc1z00_19016
																																																																									=
																																																																									BgL_carzd217788zd2_4568;
																																																																								BgL_proc2z00_19017
																																																																									=
																																																																									BgL_carzd217796zd2_4572;
																																																																								BgL_argsz00_19018
																																																																									=
																																																																									BgL_cdrzd217771zd2_4563;
																																																																								BgL_argsz00_1739
																																																																									=
																																																																									BgL_argsz00_19018;
																																																																								BgL_proc2z00_1738
																																																																									=
																																																																									BgL_proc2z00_19017;
																																																																								BgL_proc1z00_1737
																																																																									=
																																																																									BgL_proc1z00_19016;
																																																																								BgL_testz00_1736
																																																																									=
																																																																									BgL_testz00_19015;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1740;
																																																																							}
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19014);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd217820zd2_4589;
																																																																						BgL_cdrzd217820zd2_4589
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd217827zd2_4590;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11019;
																																																																								BgL_pairz00_11019
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd217827zd2_4590
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11019);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd217834zd2_4591;
																																																																								BgL_cdrzd217834zd2_4591
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd217827zd2_4590));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd217840zd2_4592;
																																																																									BgL_carzd217840zd2_4592
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd217834zd2_4591));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217840zd2_4592))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd217847zd2_4594;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11023;
																																																																												BgL_pairz00_11023
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd217834zd2_4591));
																																																																												BgL_carzd217847zd2_4594
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11023);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217847zd2_4594))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd217820zd2_4589))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3958z00_4597;
																																																																															BgL_arg3958z00_4597
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd217827zd2_4590));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19040;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19044;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19043;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19042;
																																																																																	obj_t
																																																																																		BgL_testz00_19041;
																																																																																	BgL_testz00_19041
																																																																																		=
																																																																																		BgL_arg3958z00_4597;
																																																																																	BgL_proc1z00_19042
																																																																																		=
																																																																																		BgL_carzd217840zd2_4592;
																																																																																	BgL_proc2z00_19043
																																																																																		=
																																																																																		BgL_carzd217847zd2_4594;
																																																																																	BgL_argsz00_19044
																																																																																		=
																																																																																		BgL_cdrzd217820zd2_4589;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_19044;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_19043;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_19042;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_19041;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19040);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19048;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19048);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19052;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19052);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19056;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19056);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19060;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19060);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd218123zd2_4616;
																																																																		BgL_cdrzd218123zd2_4616
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd218129zd2_4617;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11027;
																																																																				BgL_pairz00_11027
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd218129zd2_4617
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11027);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd218135zd2_4618;
																																																																				BgL_cdrzd218135zd2_4618
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd218129zd2_4617));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd218140zd2_4619;
																																																																					obj_t
																																																																						BgL_cdrzd218141zd2_4620;
																																																																					BgL_carzd218140zd2_4619
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4618));
																																																																					BgL_cdrzd218141zd2_4620
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4618));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218140zd2_4619))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd218146zd2_4622;
																																																																							BgL_carzd218146zd2_4622
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd218141zd2_4620));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218146zd2_4622))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd218141zd2_4620))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218123zd2_4616))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3973z00_4627;
																																																																													BgL_arg3973z00_4627
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd218129zd2_4617));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19087;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19091;
																																																																															obj_t
																																																																																BgL_proc2z00_19090;
																																																																															obj_t
																																																																																BgL_proc1z00_19089;
																																																																															obj_t
																																																																																BgL_testz00_19088;
																																																																															BgL_testz00_19088
																																																																																=
																																																																																BgL_arg3973z00_4627;
																																																																															BgL_proc1z00_19089
																																																																																=
																																																																																BgL_carzd218140zd2_4619;
																																																																															BgL_proc2z00_19090
																																																																																=
																																																																																BgL_carzd218146zd2_4622;
																																																																															BgL_argsz00_19091
																																																																																=
																																																																																BgL_cdrzd218123zd2_4616;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_19091;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_19090;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_19089;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_19088;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19087);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19095;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19095);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19099;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19099);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19103;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19103);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19107;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19107);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19111;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19111);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd218479zd2_4635;
																																																														BgL_cdrzd218479zd2_4635
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd218486zd2_4636;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_pairz00_11037;
																																																																BgL_pairz00_11037
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd218486zd2_4636
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11037);
																																																															}
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd218493zd2_4637;
																																																																BgL_cdrzd218493zd2_4637
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd218486zd2_4636));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd218499zd2_4638;
																																																																	obj_t
																																																																		BgL_cdrzd218500zd2_4639;
																																																																	BgL_carzd218499zd2_4638
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4637));
																																																																	BgL_cdrzd218500zd2_4639
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4637));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218499zd2_4638))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd218500zd2_4639))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd218507zd2_4642;
																																																																					BgL_carzd218507zd2_4642
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd218500zd2_4639);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218507zd2_4642))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd218500zd2_4639)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218479zd2_4635))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg3987z00_4647;
																																																																											BgL_arg3987z00_4647
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd218486zd2_4636));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19138;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19142;
																																																																													obj_t
																																																																														BgL_proc2z00_19141;
																																																																													obj_t
																																																																														BgL_proc1z00_19140;
																																																																													obj_t
																																																																														BgL_testz00_19139;
																																																																													BgL_testz00_19139
																																																																														=
																																																																														BgL_arg3987z00_4647;
																																																																													BgL_proc1z00_19140
																																																																														=
																																																																														BgL_carzd218499zd2_4638;
																																																																													BgL_proc2z00_19141
																																																																														=
																																																																														BgL_carzd218507zd2_4642;
																																																																													BgL_argsz00_19142
																																																																														=
																																																																														BgL_cdrzd218479zd2_4635;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_19142;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_19141;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_19140;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_19139;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19138);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19146;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19146);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19150;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19150);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19154;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19154);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19158;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19158);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_19162;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19162);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19166;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19166);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd218900zd2_4661;
																																														BgL_cdrzd218900zd2_4661
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_19170;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg4015z00_4678;
																																																BgL_arg4015z00_4678
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_19170
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg4015z00_4678));
																																															}
																																															if (BgL_testz00_19170)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4003z00_4664;
																																																	obj_t
																																																		BgL_arg4004z00_4665;
																																																	BgL_arg4003z00_4664
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4661));
																																																	BgL_arg4004z00_4665
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4661));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_19179;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_19181;
																																																			obj_t
																																																				BgL_bindingsz00_19180;
																																																			BgL_bindingsz00_19180
																																																				=
																																																				BgL_arg4003z00_4664;
																																																			BgL_exprz00_19181
																																																				=
																																																				BgL_arg4004z00_4665;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_19181;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_19180;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_19179);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_19183;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg4014z00_4677;
																																																		BgL_arg4014z00_4677
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_19183
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg4014z00_4677));
																																																	}
																																																	if (BgL_testz00_19183)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19188;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19188);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd218966zd2_4668;
																																																			BgL_carzd218966zd2_4668
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd218971zd2_4669;
																																																				BgL_cdrzd218971zd2_4669
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd218966zd2_4668));
																																																				if ((CAR(((obj_t) BgL_carzd218966zd2_4668)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg4009z00_4672;
																																																						obj_t
																																																							BgL_arg4010z00_4673;
																																																						obj_t
																																																							BgL_arg4011z00_4674;
																																																						BgL_arg4009z00_4672
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4669));
																																																						BgL_arg4010z00_4673
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4669));
																																																						BgL_arg4011z00_4674
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19205;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_19208;
																																																								obj_t
																																																									BgL_bodyz00_19207;
																																																								obj_t
																																																									BgL_varsz00_19206;
																																																								BgL_varsz00_19206
																																																									=
																																																									BgL_arg4009z00_4672;
																																																								BgL_bodyz00_19207
																																																									=
																																																									BgL_arg4010z00_4673;
																																																								BgL_argsz00_19208
																																																									=
																																																									BgL_arg4011z00_4674;
																																																								BgL_argsz00_1734
																																																									=
																																																									BgL_argsz00_19208;
																																																								BgL_bodyz00_1733
																																																									=
																																																									BgL_bodyz00_19207;
																																																								BgL_varsz00_1732
																																																									=
																																																									BgL_varsz00_19206;
																																																								goto
																																																									BgL_tagzd2386zd2_1735;
																																																							}
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19205);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1769;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_19212;
																																																								goto
																																																									BgL_tagzd2404zd2_1770;
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_19212);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd219082zd2_4679;
																																												BgL_cdrzd219082zd2_4679
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_testz00_19216;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg4024z00_4688;
																																														BgL_arg4024z00_4688
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_testz00_19216
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg4024z00_4688));
																																													}
																																													if (BgL_testz00_19216)
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4018z00_4682;
																																															obj_t
																																																BgL_arg4019z00_4683;
																																															BgL_arg4018z00_4682
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4679));
																																															BgL_arg4019z00_4683
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4679));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_19225;
																																																{
																																																	obj_t
																																																		BgL_exprz00_19227;
																																																	obj_t
																																																		BgL_bindingsz00_19226;
																																																	BgL_bindingsz00_19226
																																																		=
																																																		BgL_arg4018z00_4682;
																																																	BgL_exprz00_19227
																																																		=
																																																		BgL_arg4019z00_4683;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_19227;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_19226;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_14146
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19225);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_19229;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg4023z00_4687;
																																																BgL_arg4023z00_4687
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_19229
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg4023z00_4687));
																																															}
																																															if (BgL_testz00_19229)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19234;
																																																	goto
																																																		BgL_tagzd2384zd2_1727;
																																																	BgL_auxz00_14146
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19234);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1769;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_19238;
																																																			goto
																																																				BgL_tagzd2404zd2_1770;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19238);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217647zd2_4358)))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd217649zd2_4360;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd217647zd2_4358 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd217649zd2_4360;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd217647zd2_4358 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd217649zd2_4360;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217647zd2_4358)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd217649zd2_4360;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd219254zd2_4366;
																																																		BgL_cdrzd219254zd2_4366
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_19254;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg3924z00_4540;
																																																				BgL_arg3924z00_4540
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_19254
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3924z00_4540));
																																																			}
																																																			if (BgL_testz00_19254)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg3808z00_4369;
																																																					obj_t
																																																						BgL_arg3809z00_4370;
																																																					BgL_arg3808z00_4369
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4366));
																																																					BgL_arg3809z00_4370
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4366));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_19263;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_19265;
																																																							obj_t
																																																								BgL_bindingsz00_19264;
																																																							BgL_bindingsz00_19264
																																																								=
																																																								BgL_arg3808z00_4369;
																																																							BgL_exprz00_19265
																																																								=
																																																								BgL_arg3809z00_4370;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_19265;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_19264;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_14146
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_19263);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_19267;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg3923z00_4539;
																																																						BgL_arg3923z00_4539
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_19267
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3923z00_4539));
																																																					}
																																																					if (BgL_testz00_19267)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_19272;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19272);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd219307zd2_4373;
																																																							obj_t
																																																								BgL_cdrzd219308zd2_4374;
																																																							BgL_carzd219307zd2_4373
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							BgL_cdrzd219308zd2_4374
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd219312zd2_4375;
																																																								BgL_cdrzd219312zd2_4375
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd219307zd2_4373));
																																																								if ((CAR(((obj_t) BgL_carzd219307zd2_4373)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd219312zd2_4375))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd219315zd2_4379;
																																																												obj_t
																																																													BgL_cdrzd219316zd2_4380;
																																																												BgL_carzd219315zd2_4379
																																																													=
																																																													CAR
																																																													(BgL_cdrzd219312zd2_4375);
																																																												BgL_cdrzd219316zd2_4380
																																																													=
																																																													CDR
																																																													(BgL_cdrzd219312zd2_4375);
																																																												if (PAIRP(BgL_carzd219315zd2_4379))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (NULLP(CDR(BgL_carzd219315zd2_4379)))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd219316zd2_4380))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd219322zd2_4385;
																																																																		BgL_carzd219322zd2_4385
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd219316zd2_4380);
																																																																		if (PAIRP(BgL_carzd219322zd2_4385))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd219322zd2_4385))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd219316zd2_4380)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd219329zd2_4390;
																																																																								BgL_carzd219329zd2_4390
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd219308zd2_4374));
																																																																								if (PAIRP(BgL_carzd219329zd2_4390))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd219354zd2_4392;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_11085;
																																																																											BgL_pairz00_11085
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd219354zd2_4392
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_11085);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg3824z00_4393;
																																																																											obj_t
																																																																												BgL_arg3825z00_4394;
																																																																											obj_t
																																																																												BgL_arg3826z00_4395;
																																																																											BgL_arg3824z00_4393
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4392));
																																																																											BgL_arg3825z00_4394
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4392));
																																																																											BgL_arg3826z00_4395
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19317;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19320;
																																																																													obj_t
																																																																														BgL_bodyz00_19319;
																																																																													obj_t
																																																																														BgL_varsz00_19318;
																																																																													BgL_varsz00_19318
																																																																														=
																																																																														BgL_arg3824z00_4393;
																																																																													BgL_bodyz00_19319
																																																																														=
																																																																														BgL_arg3825z00_4394;
																																																																													BgL_argsz00_19320
																																																																														=
																																																																														BgL_arg3826z00_4395;
																																																																													BgL_argsz00_1734
																																																																														=
																																																																														BgL_argsz00_19320;
																																																																													BgL_bodyz00_1733
																																																																														=
																																																																														BgL_bodyz00_19319;
																																																																													BgL_varsz00_1732
																																																																														=
																																																																														BgL_varsz00_19318;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1735;
																																																																												}
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19317);
																																																																											}
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd219308zd2_4374))))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg3830z00_4399;
																																																																												BgL_arg3830z00_4399
																																																																													=
																																																																													CAR
																																																																													(BgL_carzd219315zd2_4379);
																																																																												{
																																																																													BgL_castz00_bglt
																																																																														BgL_auxz00_19327;
																																																																													BgL_varz00_1728
																																																																														=
																																																																														BgL_arg3830z00_4399;
																																																																													BgL_bodyz00_1729
																																																																														=
																																																																														BgL_carzd219322zd2_4385;
																																																																													BgL_argz00_1730
																																																																														=
																																																																														BgL_carzd219329zd2_4390;
																																																																												BgL_tagzd2385zd2_1731:
																																																																													{	/* Ast/sexp.scm 375 */
																																																																														BgL_castz00_bglt
																																																																															BgL_new1137z00_8728;
																																																																														{	/* Ast/sexp.scm 376 */
																																																																															BgL_castz00_bglt
																																																																																BgL_new1136z00_8730;
																																																																															BgL_new1136z00_8730
																																																																																=
																																																																																(
																																																																																(BgL_castz00_bglt)
																																																																																BOBJECT
																																																																																(GC_MALLOC
																																																																																	(sizeof
																																																																																		(struct
																																																																																			BgL_castz00_bgl))));
																																																																															{	/* Ast/sexp.scm 376 */
																																																																																long
																																																																																	BgL_arg6835z00_8731;
																																																																																{	/* Ast/sexp.scm 376 */
																																																																																	long
																																																																																		BgL_res7397z00_9890;
																																																																																	BgL_res7397z00_9890
																																																																																		=
																																																																																		BGL_CLASS_INDEX
																																																																																		(BGl_castz00zzast_nodez00);
																																																																																	BgL_arg6835z00_8731
																																																																																		=
																																																																																		BgL_res7397z00_9890;
																																																																																}
																																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																																	(
																																																																																	((BgL_objectz00_bglt) BgL_new1136z00_8730), BgL_arg6835z00_8731);
																																																																															}
																																																																															{	/* Ast/sexp.scm 376 */
																																																																																BgL_objectz00_bglt
																																																																																	BgL_tmpz00_19332;
																																																																																BgL_tmpz00_19332
																																																																																	=
																																																																																	(
																																																																																	(BgL_objectz00_bglt)
																																																																																	BgL_new1136z00_8730);
																																																																																BGL_OBJECT_WIDENING_SET
																																																																																	(BgL_tmpz00_19332,
																																																																																	BFALSE);
																																																																															}
																																																																															BgL_new1137z00_8728
																																																																																=
																																																																																BgL_new1136z00_8730;
																																																																														}
																																																																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1137z00_8728)))->BgL_locz00) = ((obj_t) BgL_locz00_23), BUNSPEC);
																																																																														{
																																																																															BgL_typez00_bglt
																																																																																BgL_auxz00_19337;
																																																																															{	/* Ast/sexp.scm 377 */
																																																																																obj_t
																																																																																	BgL_arg6834z00_8729;
																																																																																BgL_arg6834z00_8729
																																																																																	=
																																																																																	BGl_castzd2sexpzd2typez00zzast_privatez00
																																																																																	(BgL_bodyz00_1729);
																																																																																BgL_auxz00_19337
																																																																																	=
																																																																																	BGl_usezd2typez12zc0zztype_envz00
																																																																																	(BgL_arg6834z00_8729,
																																																																																	BgL_locz00_23);
																																																																															}
																																																																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1137z00_8728)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_19337), BUNSPEC);
																																																																														}
																																																																														((((BgL_castz00_bglt) COBJECT(BgL_new1137z00_8728))->BgL_argz00) = ((BgL_nodez00_bglt) BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_argz00_1730, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24)), BUNSPEC);
																																																																														BgL_auxz00_19327
																																																																															=
																																																																															BgL_new1137z00_8728;
																																																																													}
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19327);
																																																																											}}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd219382zd2_4400;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_11093;
																																																																													BgL_pairz00_11093
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd219382zd2_4400
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11093);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg3831z00_4401;
																																																																													obj_t
																																																																														BgL_arg3832z00_4402;
																																																																													obj_t
																																																																														BgL_arg3833z00_4403;
																																																																													BgL_arg3831z00_4401
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4400));
																																																																													BgL_arg3832z00_4402
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4400));
																																																																													BgL_arg3833z00_4403
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19354;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19357;
																																																																															obj_t
																																																																																BgL_bodyz00_19356;
																																																																															obj_t
																																																																																BgL_varsz00_19355;
																																																																															BgL_varsz00_19355
																																																																																=
																																																																																BgL_arg3831z00_4401;
																																																																															BgL_bodyz00_19356
																																																																																=
																																																																																BgL_arg3832z00_4402;
																																																																															BgL_argsz00_19357
																																																																																=
																																																																																BgL_arg3833z00_4403;
																																																																															BgL_argsz00_1734
																																																																																=
																																																																																BgL_argsz00_19357;
																																																																															BgL_bodyz00_1733
																																																																																=
																																																																																BgL_bodyz00_19356;
																																																																															BgL_varsz00_1732
																																																																																=
																																																																																BgL_varsz00_19355;
																																																																															goto
																																																																																BgL_tagzd2386zd2_1735;
																																																																														}
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19354);
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd219408zd2_4406;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_11098;
																																																																									BgL_pairz00_11098
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd219408zd2_4406
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_11098);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg3836z00_4407;
																																																																									obj_t
																																																																										BgL_arg3837z00_4408;
																																																																									obj_t
																																																																										BgL_arg3838z00_4409;
																																																																									BgL_arg3836z00_4407
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4406));
																																																																									BgL_arg3837z00_4408
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4406));
																																																																									BgL_arg3838z00_4409
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19368;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_19371;
																																																																											obj_t
																																																																												BgL_bodyz00_19370;
																																																																											obj_t
																																																																												BgL_varsz00_19369;
																																																																											BgL_varsz00_19369
																																																																												=
																																																																												BgL_arg3836z00_4407;
																																																																											BgL_bodyz00_19370
																																																																												=
																																																																												BgL_arg3837z00_4408;
																																																																											BgL_argsz00_19371
																																																																												=
																																																																												BgL_arg3838z00_4409;
																																																																											BgL_argsz00_1734
																																																																												=
																																																																												BgL_argsz00_19371;
																																																																											BgL_bodyz00_1733
																																																																												=
																																																																												BgL_bodyz00_19370;
																																																																											BgL_varsz00_1732
																																																																												=
																																																																												BgL_varsz00_19369;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1735;
																																																																										}
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19368);
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd219434zd2_4412;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_11103;
																																																																							BgL_pairz00_11103
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd219434zd2_4412
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11103);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg3841z00_4413;
																																																																							obj_t
																																																																								BgL_arg3842z00_4414;
																																																																							obj_t
																																																																								BgL_arg3843z00_4415;
																																																																							BgL_arg3841z00_4413
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4412));
																																																																							BgL_arg3842z00_4414
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4412));
																																																																							BgL_arg3843z00_4415
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19382;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_19385;
																																																																									obj_t
																																																																										BgL_bodyz00_19384;
																																																																									obj_t
																																																																										BgL_varsz00_19383;
																																																																									BgL_varsz00_19383
																																																																										=
																																																																										BgL_arg3841z00_4413;
																																																																									BgL_bodyz00_19384
																																																																										=
																																																																										BgL_arg3842z00_4414;
																																																																									BgL_argsz00_19385
																																																																										=
																																																																										BgL_arg3843z00_4415;
																																																																									BgL_argsz00_1734
																																																																										=
																																																																										BgL_argsz00_19385;
																																																																									BgL_bodyz00_1733
																																																																										=
																																																																										BgL_bodyz00_19384;
																																																																									BgL_varsz00_1732
																																																																										=
																																																																										BgL_varsz00_19383;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1735;
																																																																								}
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19382);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd219460zd2_4417;
																																																																				BgL_cdrzd219460zd2_4417
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_carzd219307zd2_4373));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg3845z00_4418;
																																																																					obj_t
																																																																						BgL_arg3846z00_4419;
																																																																					obj_t
																																																																						BgL_arg3847z00_4420;
																																																																					BgL_arg3845z00_4418
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4417));
																																																																					BgL_arg3846z00_4419
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4417));
																																																																					BgL_arg3847z00_4420
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19395;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_19398;
																																																																							obj_t
																																																																								BgL_bodyz00_19397;
																																																																							obj_t
																																																																								BgL_varsz00_19396;
																																																																							BgL_varsz00_19396
																																																																								=
																																																																								BgL_arg3845z00_4418;
																																																																							BgL_bodyz00_19397
																																																																								=
																																																																								BgL_arg3846z00_4419;
																																																																							BgL_argsz00_19398
																																																																								=
																																																																								BgL_arg3847z00_4420;
																																																																							BgL_argsz00_1734
																																																																								=
																																																																								BgL_argsz00_19398;
																																																																							BgL_bodyz00_1733
																																																																								=
																																																																								BgL_bodyz00_19397;
																																																																							BgL_varsz00_1732
																																																																								=
																																																																								BgL_varsz00_19396;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1735;
																																																																						}
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19395);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd219486zd2_4422;
																																																																		BgL_cdrzd219486zd2_4422
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd219307zd2_4373));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg3849z00_4423;
																																																																			obj_t
																																																																				BgL_arg3850z00_4424;
																																																																			obj_t
																																																																				BgL_arg3851z00_4425;
																																																																			BgL_arg3849z00_4423
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4422));
																																																																			BgL_arg3850z00_4424
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4422));
																																																																			BgL_arg3851z00_4425
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_19408;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_19411;
																																																																					obj_t
																																																																						BgL_bodyz00_19410;
																																																																					obj_t
																																																																						BgL_varsz00_19409;
																																																																					BgL_varsz00_19409
																																																																						=
																																																																						BgL_arg3849z00_4423;
																																																																					BgL_bodyz00_19410
																																																																						=
																																																																						BgL_arg3850z00_4424;
																																																																					BgL_argsz00_19411
																																																																						=
																																																																						BgL_arg3851z00_4425;
																																																																					BgL_argsz00_1734
																																																																						=
																																																																						BgL_argsz00_19411;
																																																																					BgL_bodyz00_1733
																																																																						=
																																																																						BgL_bodyz00_19410;
																																																																					BgL_varsz00_1732
																																																																						=
																																																																						BgL_varsz00_19409;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1735;
																																																																				}
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_19408);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd219512zd2_4427;
																																																																BgL_cdrzd219512zd2_4427
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd219307zd2_4373));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg3853z00_4428;
																																																																	obj_t
																																																																		BgL_arg3854z00_4429;
																																																																	obj_t
																																																																		BgL_arg3855z00_4430;
																																																																	BgL_arg3853z00_4428
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4427));
																																																																	BgL_arg3854z00_4429
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4427));
																																																																	BgL_arg3855z00_4430
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19421;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19424;
																																																																			obj_t
																																																																				BgL_bodyz00_19423;
																																																																			obj_t
																																																																				BgL_varsz00_19422;
																																																																			BgL_varsz00_19422
																																																																				=
																																																																				BgL_arg3853z00_4428;
																																																																			BgL_bodyz00_19423
																																																																				=
																																																																				BgL_arg3854z00_4429;
																																																																			BgL_argsz00_19424
																																																																				=
																																																																				BgL_arg3855z00_4430;
																																																																			BgL_argsz00_1734
																																																																				=
																																																																				BgL_argsz00_19424;
																																																																			BgL_bodyz00_1733
																																																																				=
																																																																				BgL_bodyz00_19423;
																																																																			BgL_varsz00_1732
																																																																				=
																																																																				BgL_varsz00_19422;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1735;
																																																																		}
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19421);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd219538zd2_4433;
																																																														BgL_cdrzd219538zd2_4433
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd219307zd2_4373));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg3858z00_4434;
																																																															obj_t
																																																																BgL_arg3859z00_4435;
																																																															obj_t
																																																																BgL_arg3860z00_4436;
																																																															BgL_arg3858z00_4434
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4433));
																																																															BgL_arg3859z00_4435
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4433));
																																																															BgL_arg3860z00_4436
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19434;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_19437;
																																																																	obj_t
																																																																		BgL_bodyz00_19436;
																																																																	obj_t
																																																																		BgL_varsz00_19435;
																																																																	BgL_varsz00_19435
																																																																		=
																																																																		BgL_arg3858z00_4434;
																																																																	BgL_bodyz00_19436
																																																																		=
																																																																		BgL_arg3859z00_4435;
																																																																	BgL_argsz00_19437
																																																																		=
																																																																		BgL_arg3860z00_4436;
																																																																	BgL_argsz00_1734
																																																																		=
																																																																		BgL_argsz00_19437;
																																																																	BgL_bodyz00_1733
																																																																		=
																																																																		BgL_bodyz00_19436;
																																																																	BgL_varsz00_1732
																																																																		=
																																																																		BgL_varsz00_19435;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1735;
																																																																}
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19434);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19441;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19441);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd219676zd2_4441;
																																																										BgL_cdrzd219676zd2_4441
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd219307zd2_4373));
																																																										if ((CAR(((obj_t) BgL_carzd219307zd2_4373)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd219676zd2_4441))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd219681zd2_4445;
																																																														BgL_cdrzd219681zd2_4445
																																																															=
																																																															CDR
																																																															(BgL_cdrzd219676zd2_4441);
																																																														if (PAIRP(BgL_cdrzd219681zd2_4445))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd219685zd2_4447;
																																																																obj_t
																																																																	BgL_cdrzd219686zd2_4448;
																																																																BgL_carzd219685zd2_4447
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd219681zd2_4445);
																																																																BgL_cdrzd219686zd2_4448
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd219681zd2_4445);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219685zd2_4447))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd219686zd2_4448))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd219691zd2_4451;
																																																																				BgL_carzd219691zd2_4451
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd219686zd2_4448);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219691zd2_4451))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd219686zd2_4448)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_19467;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1396z00_4484;
																																																																									BgL_l1396z00_4484
																																																																										=
																																																																										BgL_cdrzd219308zd2_4374;
																																																																								BgL_zc3anonymousza33887ze3z83_4485:
																																																																									if (NULLP(BgL_l1396z00_4484))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_19467
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_19470;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_19471;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_19472;
																																																																													BgL_tmpz00_19472
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1396z00_4484));
																																																																													BgL_testz00_19471
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_19472);
																																																																												}
																																																																												if (BgL_testz00_19471)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_19470
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_19470
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_testz00_19470)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1396z00_19476;
																																																																													BgL_l1396z00_19476
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1396z00_4484));
																																																																													BgL_l1396z00_4484
																																																																														=
																																																																														BgL_l1396z00_19476;
																																																																													goto
																																																																														BgL_zc3anonymousza33887ze3z83_4485;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_testz00_19467
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_testz00_19467)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg3877z00_4467;
																																																																										BgL_arg3877z00_4467
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd219676zd2_4441);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19480;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19484;
																																																																												obj_t
																																																																													BgL_proc2z00_19483;
																																																																												obj_t
																																																																													BgL_proc1z00_19482;
																																																																												obj_t
																																																																													BgL_testz00_19481;
																																																																												BgL_testz00_19481
																																																																													=
																																																																													BgL_arg3877z00_4467;
																																																																												BgL_proc1z00_19482
																																																																													=
																																																																													BgL_carzd219685zd2_4447;
																																																																												BgL_proc2z00_19483
																																																																													=
																																																																													BgL_carzd219691zd2_4451;
																																																																												BgL_argsz00_19484
																																																																													=
																																																																													BgL_cdrzd219308zd2_4374;
																																																																												BgL_argsz00_1739
																																																																													=
																																																																													BgL_argsz00_19484;
																																																																												BgL_proc2z00_1738
																																																																													=
																																																																													BgL_proc2z00_19483;
																																																																												BgL_proc1z00_1737
																																																																													=
																																																																													BgL_proc1z00_19482;
																																																																												BgL_testz00_1736
																																																																													=
																																																																													BgL_testz00_19481;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1740;
																																																																											}
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19480);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd219716zd2_4468;
																																																																										BgL_cdrzd219716zd2_4468
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd219724zd2_4469;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11147;
																																																																												BgL_pairz00_11147
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd219724zd2_4469
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11147);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd219732zd2_4470;
																																																																												BgL_cdrzd219732zd2_4470
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd219724zd2_4469));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd219739zd2_4471;
																																																																													BgL_carzd219739zd2_4471
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219732zd2_4470));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219739zd2_4471))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd219748zd2_4473;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_11151;
																																																																																BgL_pairz00_11151
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd219732zd2_4470));
																																																																																BgL_carzd219748zd2_4473
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11151);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219748zd2_4473))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd219716zd2_4468))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg3881z00_4476;
																																																																																			BgL_arg3881z00_4476
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd219724zd2_4469));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_19506;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_19510;
																																																																																					obj_t
																																																																																						BgL_proc2z00_19509;
																																																																																					obj_t
																																																																																						BgL_proc1z00_19508;
																																																																																					obj_t
																																																																																						BgL_testz00_19507;
																																																																																					BgL_testz00_19507
																																																																																						=
																																																																																						BgL_arg3881z00_4476;
																																																																																					BgL_proc1z00_19508
																																																																																						=
																																																																																						BgL_carzd219739zd2_4471;
																																																																																					BgL_proc2z00_19509
																																																																																						=
																																																																																						BgL_carzd219748zd2_4473;
																																																																																					BgL_argsz00_19510
																																																																																						=
																																																																																						BgL_cdrzd219716zd2_4468;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_19510;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_19509;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_19508;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_19507;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_14146
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_19506);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_19514;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_14146
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_19514);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19518;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19518);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19522;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19522);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19526;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19526);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd220026zd2_4495;
																																																																						BgL_cdrzd220026zd2_4495
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd220033zd2_4496;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11155;
																																																																								BgL_pairz00_11155
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd220033zd2_4496
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11155);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd220040zd2_4497;
																																																																								BgL_cdrzd220040zd2_4497
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd220033zd2_4496));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd220046zd2_4498;
																																																																									obj_t
																																																																										BgL_cdrzd220047zd2_4499;
																																																																									BgL_carzd220046zd2_4498
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4497));
																																																																									BgL_cdrzd220047zd2_4499
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4497));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220046zd2_4498))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd220054zd2_4501;
																																																																											BgL_carzd220054zd2_4501
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd220047zd2_4499));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220054zd2_4501))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd220047zd2_4499))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220026zd2_4495))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg3896z00_4506;
																																																																																	BgL_arg3896z00_4506
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd220033zd2_4496));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_19553;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_19557;
																																																																																			obj_t
																																																																																				BgL_proc2z00_19556;
																																																																																			obj_t
																																																																																				BgL_proc1z00_19555;
																																																																																			obj_t
																																																																																				BgL_testz00_19554;
																																																																																			BgL_testz00_19554
																																																																																				=
																																																																																				BgL_arg3896z00_4506;
																																																																																			BgL_proc1z00_19555
																																																																																				=
																																																																																				BgL_carzd220046zd2_4498;
																																																																																			BgL_proc2z00_19556
																																																																																				=
																																																																																				BgL_carzd220054zd2_4501;
																																																																																			BgL_argsz00_19557
																																																																																				=
																																																																																				BgL_cdrzd220026zd2_4495;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_19557;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_19556;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_19555;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_19554;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_14146
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_19553);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19561;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_14146
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19561);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19565;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19565);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19569;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19569);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19573;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19573);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19577;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19577);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd220387zd2_4514;
																																																																		BgL_cdrzd220387zd2_4514
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd220393zd2_4515;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11165;
																																																																				BgL_pairz00_11165
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd220393zd2_4515
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11165);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd220399zd2_4516;
																																																																				BgL_cdrzd220399zd2_4516
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd220393zd2_4515));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd220404zd2_4517;
																																																																					obj_t
																																																																						BgL_cdrzd220405zd2_4518;
																																																																					BgL_carzd220404zd2_4517
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4516));
																																																																					BgL_cdrzd220405zd2_4518
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4516));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220404zd2_4517))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd220405zd2_4518))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd220410zd2_4521;
																																																																									BgL_carzd220410zd2_4521
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd220405zd2_4518);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220410zd2_4521))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd220405zd2_4518)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220387zd2_4514))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg3910z00_4526;
																																																																															BgL_arg3910z00_4526
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd220393zd2_4515));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19604;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19608;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19607;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19606;
																																																																																	obj_t
																																																																																		BgL_testz00_19605;
																																																																																	BgL_testz00_19605
																																																																																		=
																																																																																		BgL_arg3910z00_4526;
																																																																																	BgL_proc1z00_19606
																																																																																		=
																																																																																		BgL_carzd220404zd2_4517;
																																																																																	BgL_proc2z00_19607
																																																																																		=
																																																																																		BgL_carzd220410zd2_4521;
																																																																																	BgL_argsz00_19608
																																																																																		=
																																																																																		BgL_cdrzd220387zd2_4514;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_19608;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_19607;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_19606;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_19605;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19604);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19612;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19612);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19616;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19616);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19620;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19620);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19624;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19624);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19628;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19628);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19632;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19632);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19636;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19636);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19640;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19640);
																																																													}
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_cdrzd220948zd2_4690;
																																							BgL_cdrzd220948zd2_4690
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd217644zd2_4356 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg4026z00_4692;
																																									obj_t
																																										BgL_arg4027z00_4693;
																																									BgL_arg4026z00_4692
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4690));
																																									BgL_arg4027z00_4693
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4690));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_19651;
																																										{
																																											obj_t
																																												BgL_exprz00_19653;
																																											obj_t
																																												BgL_bindingsz00_19652;
																																											BgL_bindingsz00_19652
																																												=
																																												BgL_arg4026z00_4692;
																																											BgL_exprz00_19653
																																												=
																																												BgL_arg4027z00_4693;
																																											BgL_exprz00_1724
																																												=
																																												BgL_exprz00_19653;
																																											BgL_bindingsz00_1723
																																												=
																																												BgL_bindingsz00_19652;
																																											goto
																																												BgL_tagzd2382zd2_1725;
																																										}
																																										BgL_auxz00_14146
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_19651);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217644zd2_4356)))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4029z00_4695;
																																											obj_t
																																												BgL_arg4030z00_4696;
																																											BgL_arg4029z00_4695
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4690));
																																											BgL_arg4030z00_4696
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4690));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_19662;
																																												{
																																													obj_t
																																														BgL_exprz00_19664;
																																													obj_t
																																														BgL_bindingsz00_19663;
																																													BgL_bindingsz00_19663
																																														=
																																														BgL_arg4029z00_4695;
																																													BgL_exprz00_19664
																																														=
																																														BgL_arg4030z00_4696;
																																													BgL_exprz00_1724
																																														=
																																														BgL_exprz00_19664;
																																													BgL_bindingsz00_1723
																																														=
																																														BgL_bindingsz00_19663;
																																													goto
																																														BgL_tagzd2382zd2_1725;
																																												}
																																												BgL_auxz00_14146
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_19662);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((BgL_carzd217644zd2_4356 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4032z00_4698;
																																													obj_t
																																														BgL_arg4033z00_4699;
																																													BgL_arg4032z00_4698
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4690));
																																													BgL_arg4033z00_4699
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4690));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_19673;
																																														{
																																															obj_t
																																																BgL_exprz00_19675;
																																															obj_t
																																																BgL_bindingsz00_19674;
																																															BgL_bindingsz00_19674
																																																=
																																																BgL_arg4032z00_4698;
																																															BgL_exprz00_19675
																																																=
																																																BgL_arg4033z00_4699;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_19675;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_19674;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_14146
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19673);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19682;
																																															goto
																																																BgL_tagzd2383zd2_1726;
																																															BgL_auxz00_14146
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19682);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd220985zd2_4702;
																																															BgL_carzd220985zd2_4702
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd220985zd2_4702 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19689;
																																																	goto
																																																		BgL_tagzd2384zd2_1727;
																																																	BgL_auxz00_14146
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19689);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd220985zd2_4702)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19694;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19694);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_19701;
																																																					goto
																																																						BgL_tagzd2389zd2_1746;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19701);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19708;
																																																							goto
																																																								BgL_tagzd2390zd2_1747;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19708);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd221065zd2_4709;
																																																							BgL_cdrzd221065zd2_4709
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg4044z00_4712;
																																																									obj_t
																																																										BgL_arg4045z00_4713;
																																																									BgL_arg4044z00_4712
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4709));
																																																									BgL_arg4045z00_4713
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4709));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_19721;
																																																										{
																																																											obj_t
																																																												BgL_restz00_19723;
																																																											obj_t
																																																												BgL_effectz00_19722;
																																																											BgL_effectz00_19722
																																																												=
																																																												BgL_arg4044z00_4712;
																																																											BgL_restz00_19723
																																																												=
																																																												BgL_arg4045z00_4713;
																																																											BgL_restz00_1749
																																																												=
																																																												BgL_restz00_19723;
																																																											BgL_effectz00_1748
																																																												=
																																																												BgL_effectz00_19722;
																																																											goto
																																																												BgL_tagzd2391zd2_1750;
																																																										}
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_19721);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_19730;
																																																											goto
																																																												BgL_tagzd2392zd2_1751;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_19730);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19737;
																																																													goto
																																																														BgL_tagzd2393zd2_1752;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19737);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg4052z00_4721;
																																																															obj_t
																																																																BgL_arg4053z00_4722;
																																																															BgL_arg4052z00_4721
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4709));
																																																															BgL_arg4053z00_4722
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4709));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19748;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_19750;
																																																																	obj_t
																																																																		BgL_effectz00_19749;
																																																																	BgL_effectz00_19749
																																																																		=
																																																																		BgL_arg4052z00_4721;
																																																																	BgL_restz00_19750
																																																																		=
																																																																		BgL_arg4053z00_4722;
																																																																	BgL_restz00_1754
																																																																		=
																																																																		BgL_restz00_19750;
																																																																	BgL_effectz00_1753
																																																																		=
																																																																		BgL_effectz00_19749;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1755;
																																																																}
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19748);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19757;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1756;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19757);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_19764;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1757;
																																																																			BgL_auxz00_14146
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_19764);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_19771;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1758;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19771);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_19778;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1759;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19778);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd221142zd2_4731;
																																																																							BgL_cdrzd221142zd2_4731
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg4064z00_4734;
																																																																									obj_t
																																																																										BgL_arg4065z00_4735;
																																																																									BgL_arg4064z00_4734
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4731));
																																																																									BgL_arg4065z00_4735
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4731));
																																																																									{	/* Ast/sexp.scm 563 */
																																																																										obj_t
																																																																											BgL_arg7000z00_11204;
																																																																										BgL_arg7000z00_11204
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																												BgL_arg4064z00_4734,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4065z00_4735, BgL_stackz00_22, BgL_arg7000z00_11204, BgL_sitez00_24));
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19797;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19797);
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_carzd221167zd2_4751;
																											BgL_carzd221167zd2_4751 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd221167zd2_4751
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_19804;
																													goto
																														BgL_tagzd2377zd2_1714;
																													BgL_auxz00_14146 =
																														((obj_t)
																														BgL_auxz00_19804);
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(BgL_carzd221167zd2_4751
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_19808;
																															goto
																																BgL_tagzd2377zd2_1714;
																															BgL_auxz00_14146 =
																																((obj_t)
																																BgL_auxz00_19808);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19815;
																																	goto
																																		BgL_tagzd2379zd2_1718;
																																	BgL_auxz00_14146
																																		=
																																		((obj_t)
																																		BgL_auxz00_19815);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19822;
																																			goto
																																				BgL_tagzd2380zd2_1719;
																																			BgL_auxz00_14146
																																				=
																																				((obj_t)
																																				BgL_auxz00_19822);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd221236zd2_4758;
																																			BgL_carzd221236zd2_4758
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd221236zd2_4758))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd221239zd2_4760;
																																					obj_t
																																						BgL_cdrzd221240zd2_4761;
																																					BgL_carzd221239zd2_4760
																																						=
																																						CAR
																																						(BgL_carzd221236zd2_4758);
																																					BgL_cdrzd221240zd2_4761
																																						=
																																						CDR
																																						(BgL_carzd221236zd2_4758);
																																					{

																																						if (
																																							(BgL_carzd221239zd2_4760
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 118 */
																																							BgL_kapzd221241zd2_4762:
																																								if (PAIRP(BgL_cdrzd221240zd2_4761))
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd221244zd2_4881;
																																										BgL_cdrzd221244zd2_4881
																																											=
																																											CDR
																																											(BgL_cdrzd221240zd2_4761);
																																										if (PAIRP(BgL_cdrzd221244zd2_4881))
																																											{	/* Ast/sexp.scm 118 */
																																												if (NULLP(CDR(BgL_cdrzd221244zd2_4881)))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg4167z00_4885;
																																														obj_t
																																															BgL_arg4168z00_4886;
																																														BgL_arg4167z00_4885
																																															=
																																															CAR
																																															(BgL_cdrzd221244zd2_4881);
																																														BgL_arg4168z00_4886
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19844;
																																															{
																																																obj_t
																																																	BgL_argsz00_19846;
																																																obj_t
																																																	BgL_bodyz00_19845;
																																																BgL_bodyz00_19845
																																																	=
																																																	BgL_arg4167z00_4885;
																																																BgL_argsz00_19846
																																																	=
																																																	BgL_arg4168z00_4886;
																																																BgL_argsz00_1721
																																																	=
																																																	BgL_argsz00_19846;
																																																BgL_bodyz00_1720
																																																	=
																																																	BgL_bodyz00_19845;
																																																goto
																																																	BgL_tagzd2381zd2_1722;
																																															}
																																															BgL_auxz00_14146
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19844);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_19848;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4232z00_4992;
																																															BgL_arg4232z00_4992
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_19848
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4232z00_4992));
																																														}
																																														if (BgL_testz00_19848)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_19853;
																																																goto
																																																	BgL_tagzd2384zd2_1727;
																																																BgL_auxz00_14146
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19853);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd221322zd2_4889;
																																																BgL_carzd221322zd2_4889
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd221327zd2_4890;
																																																	BgL_cdrzd221327zd2_4890
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd221322zd2_4889));
																																																	if ((CAR(((obj_t) BgL_carzd221322zd2_4889)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4173z00_4893;
																																																			obj_t
																																																				BgL_arg4174z00_4894;
																																																			obj_t
																																																				BgL_arg4175z00_4895;
																																																			BgL_arg4173z00_4893
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4890));
																																																			BgL_arg4174z00_4894
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4890));
																																																			BgL_arg4175z00_4895
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_19870;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_19873;
																																																					obj_t
																																																						BgL_bodyz00_19872;
																																																					obj_t
																																																						BgL_varsz00_19871;
																																																					BgL_varsz00_19871
																																																						=
																																																						BgL_arg4173z00_4893;
																																																					BgL_bodyz00_19872
																																																						=
																																																						BgL_arg4174z00_4894;
																																																					BgL_argsz00_19873
																																																						=
																																																						BgL_arg4175z00_4895;
																																																					BgL_argsz00_1734
																																																						=
																																																						BgL_argsz00_19873;
																																																					BgL_bodyz00_1733
																																																						=
																																																						BgL_bodyz00_19872;
																																																					BgL_varsz00_1732
																																																						=
																																																						BgL_varsz00_19871;
																																																					goto
																																																						BgL_tagzd2386zd2_1735;
																																																				}
																																																				BgL_auxz00_14146
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_19870);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd221350zd2_4897;
																																																			BgL_cdrzd221350zd2_4897
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd221356zd2_4898;
																																																				BgL_cdrzd221356zd2_4898
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd221322zd2_4889));
																																																				if ((CAR(((obj_t) BgL_carzd221322zd2_4889)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd221362zd2_4901;
																																																						BgL_cdrzd221362zd2_4901
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd221356zd2_4898));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd221367zd2_4902;
																																																							obj_t
																																																								BgL_cdrzd221368zd2_4903;
																																																							BgL_carzd221367zd2_4902
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4901));
																																																							BgL_cdrzd221368zd2_4903
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4901));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221367zd2_4902))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd221368zd2_4903))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd221375zd2_4906;
																																																											BgL_carzd221375zd2_4906
																																																												=
																																																												CAR
																																																												(BgL_cdrzd221368zd2_4903);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221375zd2_4906))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(BgL_cdrzd221368zd2_4903)))
																																																														{	/* Ast/sexp.scm 118 */
																																																															bool_t
																																																																BgL_testz00_19900;
																																																															{
																																																																obj_t
																																																																	BgL_l1399z00_4939;
																																																																BgL_l1399z00_4939
																																																																	=
																																																																	BgL_cdrzd221350zd2_4897;
																																																															BgL_zc3anonymousza34198ze3z83_4940:
																																																																if (NULLP(BgL_l1399z00_4939))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		BgL_testz00_19900
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_testz00_19903;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_testz00_19904;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_tmpz00_19905;
																																																																				BgL_tmpz00_19905
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1399z00_4939));
																																																																				BgL_testz00_19904
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_19905);
																																																																			}
																																																																			if (BgL_testz00_19904)
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_testz00_19903
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_testz00_19903
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_testz00_19903)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1399z00_19909;
																																																																				BgL_l1399z00_19909
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1399z00_4939));
																																																																				BgL_l1399z00_4939
																																																																					=
																																																																					BgL_l1399z00_19909;
																																																																				goto
																																																																					BgL_zc3anonymousza34198ze3z83_4940;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_testz00_19900
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_testz00_19900)
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg4188z00_4922;
																																																																	BgL_arg4188z00_4922
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd221356zd2_4898));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19914;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19918;
																																																																			obj_t
																																																																				BgL_proc2z00_19917;
																																																																			obj_t
																																																																				BgL_proc1z00_19916;
																																																																			obj_t
																																																																				BgL_testz00_19915;
																																																																			BgL_testz00_19915
																																																																				=
																																																																				BgL_arg4188z00_4922;
																																																																			BgL_proc1z00_19916
																																																																				=
																																																																				BgL_carzd221367zd2_4902;
																																																																			BgL_proc2z00_19917
																																																																				=
																																																																				BgL_carzd221375zd2_4906;
																																																																			BgL_argsz00_19918
																																																																				=
																																																																				BgL_cdrzd221350zd2_4897;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_argsz00_19918;
																																																																			BgL_proc2z00_1738
																																																																				=
																																																																				BgL_proc2z00_19917;
																																																																			BgL_proc1z00_1737
																																																																				=
																																																																				BgL_proc1z00_19916;
																																																																			BgL_testz00_1736
																																																																				=
																																																																				BgL_testz00_19915;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1740;
																																																																		}
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19914);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd221399zd2_4923;
																																																																	BgL_cdrzd221399zd2_4923
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd221406zd2_4924;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_pairz00_11244;
																																																																			BgL_pairz00_11244
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd221406zd2_4924
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11244);
																																																																		}
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd221413zd2_4925;
																																																																			BgL_cdrzd221413zd2_4925
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd221406zd2_4924));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd221419zd2_4926;
																																																																				BgL_carzd221419zd2_4926
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd221413zd2_4925));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221419zd2_4926))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd221426zd2_4928;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_11248;
																																																																							BgL_pairz00_11248
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd221413zd2_4925));
																																																																							BgL_carzd221426zd2_4928
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_11248);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221426zd2_4928))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221399zd2_4923))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4192z00_4931;
																																																																										BgL_arg4192z00_4931
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd221406zd2_4924));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19940;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19944;
																																																																												obj_t
																																																																													BgL_proc2z00_19943;
																																																																												obj_t
																																																																													BgL_proc1z00_19942;
																																																																												obj_t
																																																																													BgL_testz00_19941;
																																																																												BgL_testz00_19941
																																																																													=
																																																																													BgL_arg4192z00_4931;
																																																																												BgL_proc1z00_19942
																																																																													=
																																																																													BgL_carzd221419zd2_4926;
																																																																												BgL_proc2z00_19943
																																																																													=
																																																																													BgL_carzd221426zd2_4928;
																																																																												BgL_argsz00_19944
																																																																													=
																																																																													BgL_cdrzd221399zd2_4923;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_19944;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_19943;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_19942;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_19941;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1745;
																																																																											}
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19940);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19948;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19948);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19952;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19952);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19956;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19956);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19960;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19960);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd221702zd2_4950;
																																																													BgL_cdrzd221702zd2_4950
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd221708zd2_4951;
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_pairz00_11252;
																																																															BgL_pairz00_11252
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd221708zd2_4951
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11252);
																																																														}
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd221714zd2_4952;
																																																															BgL_cdrzd221714zd2_4952
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221708zd2_4951));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd221719zd2_4953;
																																																																obj_t
																																																																	BgL_cdrzd221720zd2_4954;
																																																																BgL_carzd221719zd2_4953
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4952));
																																																																BgL_cdrzd221720zd2_4954
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4952));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221719zd2_4953))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd221725zd2_4956;
																																																																		BgL_carzd221725zd2_4956
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd221720zd2_4954));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221725zd2_4956))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd221720zd2_4954))))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221702zd2_4950))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4207z00_4961;
																																																																								BgL_arg4207z00_4961
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd221708zd2_4951));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19987;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_19991;
																																																																										obj_t
																																																																											BgL_proc2z00_19990;
																																																																										obj_t
																																																																											BgL_proc1z00_19989;
																																																																										obj_t
																																																																											BgL_testz00_19988;
																																																																										BgL_testz00_19988
																																																																											=
																																																																											BgL_arg4207z00_4961;
																																																																										BgL_proc1z00_19989
																																																																											=
																																																																											BgL_carzd221719zd2_4953;
																																																																										BgL_proc2z00_19990
																																																																											=
																																																																											BgL_carzd221725zd2_4956;
																																																																										BgL_argsz00_19991
																																																																											=
																																																																											BgL_cdrzd221702zd2_4950;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_19991;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_19990;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_19989;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_19988;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1745;
																																																																									}
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19987);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19995;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_14146
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19995);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19999;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19999);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20003;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20003);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20007;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20007);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_20011;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_14146
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_20011);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd222058zd2_4969;
																																																									BgL_cdrzd222058zd2_4969
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd222065zd2_4970;
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_pairz00_11262;
																																																											BgL_pairz00_11262
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd222065zd2_4970
																																																												=
																																																												CDR
																																																												(BgL_pairz00_11262);
																																																										}
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd222072zd2_4971;
																																																											BgL_cdrzd222072zd2_4971
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd222065zd2_4970));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd222078zd2_4972;
																																																												obj_t
																																																													BgL_cdrzd222079zd2_4973;
																																																												BgL_carzd222078zd2_4972
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_4971));
																																																												BgL_cdrzd222079zd2_4973
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_4971));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222078zd2_4972))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd222079zd2_4973))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd222086zd2_4976;
																																																																BgL_carzd222086zd2_4976
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222079zd2_4973);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222086zd2_4976))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd222079zd2_4973)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd222058zd2_4969))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4221z00_4981;
																																																																						BgL_arg4221z00_4981
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd222065zd2_4970));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20038;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20042;
																																																																								obj_t
																																																																									BgL_proc2z00_20041;
																																																																								obj_t
																																																																									BgL_proc1z00_20040;
																																																																								obj_t
																																																																									BgL_testz00_20039;
																																																																								BgL_testz00_20039
																																																																									=
																																																																									BgL_arg4221z00_4981;
																																																																								BgL_proc1z00_20040
																																																																									=
																																																																									BgL_carzd222078zd2_4972;
																																																																								BgL_proc2z00_20041
																																																																									=
																																																																									BgL_carzd222086zd2_4976;
																																																																								BgL_argsz00_20042
																																																																									=
																																																																									BgL_cdrzd222058zd2_4969;
																																																																								BgL_argsz00_1744
																																																																									=
																																																																									BgL_argsz00_20042;
																																																																								BgL_proc2z00_1743
																																																																									=
																																																																									BgL_proc2z00_20041;
																																																																								BgL_proc1z00_1742
																																																																									=
																																																																									BgL_proc1z00_20040;
																																																																								BgL_testz00_1741
																																																																									=
																																																																									BgL_testz00_20039;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1745;
																																																																							}
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20038);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20046;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_14146
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20046);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20050;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20050);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20054;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_14146
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20054);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20058;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20058);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_20062;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_14146
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_20062);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1769;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20066;
																																																								goto
																																																									BgL_tagzd2404zd2_1770;
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20066);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_20068;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4243z00_5005;
																																													BgL_arg4243z00_5005
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_20068
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4243z00_5005));
																																												}
																																												if (BgL_testz00_20068)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_20073;
																																														goto
																																															BgL_tagzd2384zd2_1727;
																																														BgL_auxz00_14146
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20073);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_carzd222532zd2_4996;
																																														BgL_carzd222532zd2_4996
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd222537zd2_4997;
																																															BgL_cdrzd222537zd2_4997
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd222532zd2_4996));
																																															if ((CAR(((obj_t) BgL_carzd222532zd2_4996)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4238z00_5000;
																																																	obj_t
																																																		BgL_arg4239z00_5001;
																																																	obj_t
																																																		BgL_arg4240z00_5002;
																																																	BgL_arg4238z00_5000
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_4997));
																																																	BgL_arg4239z00_5001
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_4997));
																																																	BgL_arg4240z00_5002
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_20090;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_20093;
																																																			obj_t
																																																				BgL_bodyz00_20092;
																																																			obj_t
																																																				BgL_varsz00_20091;
																																																			BgL_varsz00_20091
																																																				=
																																																				BgL_arg4238z00_5000;
																																																			BgL_bodyz00_20092
																																																				=
																																																				BgL_arg4239z00_5001;
																																																			BgL_argsz00_20093
																																																				=
																																																				BgL_arg4240z00_5002;
																																																			BgL_argsz00_1734
																																																				=
																																																				BgL_argsz00_20093;
																																																			BgL_bodyz00_1733
																																																				=
																																																				BgL_bodyz00_20092;
																																																			BgL_varsz00_1732
																																																				=
																																																				BgL_varsz00_20091;
																																																			goto
																																																				BgL_tagzd2386zd2_1735;
																																																		}
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20090);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1769;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20097;
																																																			goto
																																																				BgL_tagzd2404zd2_1770;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20097);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_testz00_20099;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4247z00_5009;
																																											BgL_arg4247z00_5009
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_testz00_20099
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4247z00_5009));
																																										}
																																										if (BgL_testz00_20099)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_20104;
																																												goto
																																													BgL_tagzd2384zd2_1727;
																																												BgL_auxz00_14146
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_20104);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_tagzd2403zd2_1769;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_20108;
																																														goto
																																															BgL_tagzd2404zd2_1770;
																																														BgL_auxz00_14146
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20108);
																																													}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd221239zd2_4760)))
																																									{	/* Ast/sexp.scm 118 */
																																										goto
																																											BgL_kapzd221241zd2_4762;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd221239zd2_4760 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd221241zd2_4762;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd221239zd2_4760 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd221241zd2_4762;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd221239zd2_4760)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd221241zd2_4762;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_testz00_20122;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4162z00_4879;
																																																	BgL_arg4162z00_4879
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_testz00_20122
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4162z00_4879));
																																																}
																																																if (BgL_testz00_20122)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20127;
																																																		goto
																																																			BgL_tagzd2384zd2_1727;
																																																		BgL_auxz00_14146
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20127);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd222860zd2_4770;
																																																		BgL_carzd222860zd2_4770
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd222865zd2_4771;
																																																			BgL_cdrzd222865zd2_4771
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd222860zd2_4770));
																																																			if ((CAR(((obj_t) BgL_carzd222860zd2_4770)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (PAIRP(BgL_cdrzd222865zd2_4771))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg4098z00_4775;
																																																							obj_t
																																																								BgL_arg4099z00_4776;
																																																							obj_t
																																																								BgL_arg4100z00_4777;
																																																							BgL_arg4098z00_4775
																																																								=
																																																								CAR
																																																								(BgL_cdrzd222865zd2_4771);
																																																							BgL_arg4099z00_4776
																																																								=
																																																								CDR
																																																								(BgL_cdrzd222865zd2_4771);
																																																							BgL_arg4100z00_4777
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20144;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20147;
																																																									obj_t
																																																										BgL_bodyz00_20146;
																																																									obj_t
																																																										BgL_varsz00_20145;
																																																									BgL_varsz00_20145
																																																										=
																																																										BgL_arg4098z00_4775;
																																																									BgL_bodyz00_20146
																																																										=
																																																										BgL_arg4099z00_4776;
																																																									BgL_argsz00_20147
																																																										=
																																																										BgL_arg4100z00_4777;
																																																									BgL_argsz00_1734
																																																										=
																																																										BgL_argsz00_20147;
																																																									BgL_bodyz00_1733
																																																										=
																																																										BgL_bodyz00_20146;
																																																									BgL_varsz00_1732
																																																										=
																																																										BgL_varsz00_20145;
																																																									goto
																																																										BgL_tagzd2386zd2_1735;
																																																								}
																																																								BgL_auxz00_14146
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20144);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2403zd2_1769;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_20151;
																																																									goto
																																																										BgL_tagzd2404zd2_1770;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20151);
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd222972zd2_4780;
																																																					BgL_cdrzd222972zd2_4780
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd222977zd2_4781;
																																																						BgL_cdrzd222977zd2_4781
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd222860zd2_4770));
																																																						if ((CAR(((obj_t) BgL_carzd222860zd2_4770)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (PAIRP(BgL_cdrzd222977zd2_4781))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd222982zd2_4785;
																																																										BgL_cdrzd222982zd2_4785
																																																											=
																																																											CDR
																																																											(BgL_cdrzd222977zd2_4781);
																																																										if (PAIRP(BgL_cdrzd222982zd2_4785))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd222986zd2_4787;
																																																												obj_t
																																																													BgL_cdrzd222987zd2_4788;
																																																												BgL_carzd222986zd2_4787
																																																													=
																																																													CAR
																																																													(BgL_cdrzd222982zd2_4785);
																																																												BgL_cdrzd222987zd2_4788
																																																													=
																																																													CDR
																																																													(BgL_cdrzd222982zd2_4785);
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222986zd2_4787))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd222987zd2_4788))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd222992zd2_4791;
																																																																BgL_carzd222992zd2_4791
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222987zd2_4788);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222992zd2_4791))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd222987zd2_4788)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_testz00_20179;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1402z00_4824;
																																																																					BgL_l1402z00_4824
																																																																						=
																																																																						BgL_cdrzd222972zd2_4780;
																																																																				BgL_zc3anonymousza34126ze3z83_4825:
																																																																					if (NULLP(BgL_l1402z00_4824))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_20179
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_testz00_20182;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_20183;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_tmpz00_20184;
																																																																									BgL_tmpz00_20184
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1402z00_4824));
																																																																									BgL_testz00_20183
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_20184);
																																																																								}
																																																																								if (BgL_testz00_20183)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_20182
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_20182
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_testz00_20182)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1402z00_20188;
																																																																									BgL_l1402z00_20188
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1402z00_4824));
																																																																									BgL_l1402z00_4824
																																																																										=
																																																																										BgL_l1402z00_20188;
																																																																									goto
																																																																										BgL_zc3anonymousza34126ze3z83_4825;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_20179
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_testz00_20179)
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4116z00_4807;
																																																																						BgL_arg4116z00_4807
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd222977zd2_4781);
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20192;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20196;
																																																																								obj_t
																																																																									BgL_proc2z00_20195;
																																																																								obj_t
																																																																									BgL_proc1z00_20194;
																																																																								obj_t
																																																																									BgL_testz00_20193;
																																																																								BgL_testz00_20193
																																																																									=
																																																																									BgL_arg4116z00_4807;
																																																																								BgL_proc1z00_20194
																																																																									=
																																																																									BgL_carzd222986zd2_4787;
																																																																								BgL_proc2z00_20195
																																																																									=
																																																																									BgL_carzd222992zd2_4791;
																																																																								BgL_argsz00_20196
																																																																									=
																																																																									BgL_cdrzd222972zd2_4780;
																																																																								BgL_argsz00_1739
																																																																									=
																																																																									BgL_argsz00_20196;
																																																																								BgL_proc2z00_1738
																																																																									=
																																																																									BgL_proc2z00_20195;
																																																																								BgL_proc1z00_1737
																																																																									=
																																																																									BgL_proc1z00_20194;
																																																																								BgL_testz00_1736
																																																																									=
																																																																									BgL_testz00_20193;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1740;
																																																																							}
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20192);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd223017zd2_4808;
																																																																						BgL_cdrzd223017zd2_4808
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd223025zd2_4809;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11307;
																																																																								BgL_pairz00_11307
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd223025zd2_4809
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11307);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd223033zd2_4810;
																																																																								BgL_cdrzd223033zd2_4810
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd223025zd2_4809));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd223040zd2_4811;
																																																																									BgL_carzd223040zd2_4811
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd223033zd2_4810));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223040zd2_4811))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd223049zd2_4813;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11311;
																																																																												BgL_pairz00_11311
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd223033zd2_4810));
																																																																												BgL_carzd223049zd2_4813
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11311);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223049zd2_4813))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223017zd2_4808))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg4120z00_4816;
																																																																															BgL_arg4120z00_4816
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd223025zd2_4809));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20218;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_20222;
																																																																																	obj_t
																																																																																		BgL_proc2z00_20221;
																																																																																	obj_t
																																																																																		BgL_proc1z00_20220;
																																																																																	obj_t
																																																																																		BgL_testz00_20219;
																																																																																	BgL_testz00_20219
																																																																																		=
																																																																																		BgL_arg4120z00_4816;
																																																																																	BgL_proc1z00_20220
																																																																																		=
																																																																																		BgL_carzd223040zd2_4811;
																																																																																	BgL_proc2z00_20221
																																																																																		=
																																																																																		BgL_carzd223049zd2_4813;
																																																																																	BgL_argsz00_20222
																																																																																		=
																																																																																		BgL_cdrzd223017zd2_4808;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_20222;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_20221;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_20220;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_20219;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_14146
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20218);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20226;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_14146
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20226);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20230;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20230);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20234;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20234);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20238;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_14146
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20238);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd223327zd2_4835;
																																																																		BgL_cdrzd223327zd2_4835
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd223334zd2_4836;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11315;
																																																																				BgL_pairz00_11315
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd223334zd2_4836
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11315);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd223341zd2_4837;
																																																																				BgL_cdrzd223341zd2_4837
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd223334zd2_4836));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd223347zd2_4838;
																																																																					obj_t
																																																																						BgL_cdrzd223348zd2_4839;
																																																																					BgL_carzd223347zd2_4838
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4837));
																																																																					BgL_cdrzd223348zd2_4839
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4837));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223347zd2_4838))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd223355zd2_4841;
																																																																							BgL_carzd223355zd2_4841
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd223348zd2_4839));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223355zd2_4841))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd223348zd2_4839))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223327zd2_4835))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg4135z00_4846;
																																																																													BgL_arg4135z00_4846
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd223334zd2_4836));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20265;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_20269;
																																																																															obj_t
																																																																																BgL_proc2z00_20268;
																																																																															obj_t
																																																																																BgL_proc1z00_20267;
																																																																															obj_t
																																																																																BgL_testz00_20266;
																																																																															BgL_testz00_20266
																																																																																=
																																																																																BgL_arg4135z00_4846;
																																																																															BgL_proc1z00_20267
																																																																																=
																																																																																BgL_carzd223347zd2_4838;
																																																																															BgL_proc2z00_20268
																																																																																=
																																																																																BgL_carzd223355zd2_4841;
																																																																															BgL_argsz00_20269
																																																																																=
																																																																																BgL_cdrzd223327zd2_4835;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_20269;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_20268;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_20267;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_20266;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_14146
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20265);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20273;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_14146
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20273);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20277;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20277);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20281;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20281);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20285;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20285);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20289;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_14146
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20289);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd223688zd2_4854;
																																																														BgL_cdrzd223688zd2_4854
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd223694zd2_4855;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_pairz00_11325;
																																																																BgL_pairz00_11325
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd223694zd2_4855
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11325);
																																																															}
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd223700zd2_4856;
																																																																BgL_cdrzd223700zd2_4856
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd223694zd2_4855));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd223705zd2_4857;
																																																																	obj_t
																																																																		BgL_cdrzd223706zd2_4858;
																																																																	BgL_carzd223705zd2_4857
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4856));
																																																																	BgL_cdrzd223706zd2_4858
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4856));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223705zd2_4857))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd223706zd2_4858))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd223711zd2_4861;
																																																																					BgL_carzd223711zd2_4861
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd223706zd2_4858);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223711zd2_4861))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd223706zd2_4858)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223688zd2_4854))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg4149z00_4866;
																																																																											BgL_arg4149z00_4866
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd223694zd2_4855));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20316;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_20320;
																																																																													obj_t
																																																																														BgL_proc2z00_20319;
																																																																													obj_t
																																																																														BgL_proc1z00_20318;
																																																																													obj_t
																																																																														BgL_testz00_20317;
																																																																													BgL_testz00_20317
																																																																														=
																																																																														BgL_arg4149z00_4866;
																																																																													BgL_proc1z00_20318
																																																																														=
																																																																														BgL_carzd223705zd2_4857;
																																																																													BgL_proc2z00_20319
																																																																														=
																																																																														BgL_carzd223711zd2_4861;
																																																																													BgL_argsz00_20320
																																																																														=
																																																																														BgL_cdrzd223688zd2_4854;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_20320;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_20319;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_20318;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_20317;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																												BgL_auxz00_14146
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20316);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20324;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_14146
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20324);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20328;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_14146
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20328);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20332;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_14146
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20332);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20336;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_14146
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20336);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20340;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_14146
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20340);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_20344;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_14146
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_20344);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20348;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_14146
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20348);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1769;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_20352;
																																																										goto
																																																											BgL_tagzd2404zd2_1770;
																																																										BgL_auxz00_14146
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_20352);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd221236zd2_4758
																																							==
																																							CNST_TABLE_REF
																																							(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_20357;
																																							goto
																																								BgL_tagzd2383zd2_1726;
																																							BgL_auxz00_14146
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_20357);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd224273zd2_5012;
																																							BgL_carzd224273zd2_5012
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd224273zd2_5012 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_20364;
																																									goto
																																										BgL_tagzd2384zd2_1727;
																																									BgL_auxz00_14146
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_20364);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224273zd2_5012)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_20369;
																																											goto
																																												BgL_tagzd2384zd2_1727;
																																											BgL_auxz00_14146
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_20369);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20376;
																																													goto
																																														BgL_tagzd2389zd2_1746;
																																													BgL_auxz00_14146
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20376);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_20383;
																																															goto
																																																BgL_tagzd2390zd2_1747;
																																															BgL_auxz00_14146
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_20383);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_20390;
																																																	goto
																																																		BgL_tagzd2392zd2_1751;
																																																	BgL_auxz00_14146
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_20390);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20397;
																																																			goto
																																																				BgL_tagzd2393zd2_1752;
																																																			BgL_auxz00_14146
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20397);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_20404;
																																																					goto
																																																						BgL_tagzd2395zd2_1756;
																																																					BgL_auxz00_14146
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_20404);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_20411;
																																																							goto
																																																								BgL_tagzd2396zd2_1757;
																																																							BgL_auxz00_14146
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_20411);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_20418;
																																																									goto
																																																										BgL_tagzd2397zd2_1758;
																																																									BgL_auxz00_14146
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20418);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_20425;
																																																											goto
																																																												BgL_tagzd2398zd2_1759;
																																																											BgL_auxz00_14146
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_20425);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20435;
																																																														BgL_tagzd2402zd2_1768:
																																																															{	/* Ast/sexp.scm 567 */
																																																																obj_t
																																																																	BgL_arg7001z00_8987;
																																																																BgL_arg7001z00_8987
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 566 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res7436z00_10027;
																																																																	{	/* Ast/sexp.scm 717 */
																																																																		obj_t
																																																																			BgL_arg7100z00_10023;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg7101z00_10024;
																																																																		BgL_arg7100z00_10023
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg7101z00_10024
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_arg7001z00_8987, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 716 */
																																																																			obj_t
																																																																				BgL_list7102z00_10026;
																																																																			BgL_list7102z00_10026
																																																																				=
																																																																				MAKE_YOUNG_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg7101z00_10024), BNIL);
																																																																			BgL_res7436z00_10027
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_arg7001z00_8987,
																																																																					BgL_arg7100z00_10023,
																																																																					BGl_string7972z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list7102z00_10026));
																																																																	}}
																																																																	BgL_auxz00_20435
																																																																		=
																																																																		BgL_res7436z00_10027;
																																																															}}
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20435);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20449;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_14146
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20449);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20453;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_14146
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20453);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14146);
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									if (
																										(BgL_carzd2610zd2_1799 ==
																											BGl_za2ifza2z00zzast_sexpz00))
																										{
																											obj_t BgL_auxz00_20458;

																											goto
																												BgL_kapzd2612zd2_1801;
																											return ((BgL_nodez00_bglt)
																												BgL_auxz00_20458);
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											bool_t BgL_testz00_20460;

																											{	/* Ast/sexp.scm 118 */
																												obj_t
																													BgL_arg2237z00_2546;
																												BgL_arg2237z00_2546 =
																													CAR(BgL_expz00_21);
																												BgL_testz00_20460 =
																													(BgL_arg2237z00_2546
																													==
																													BGl_za2ifza2z00zzast_sexpz00);
																											}
																											if (BgL_testz00_20460)
																												{	/* Ast/sexp.scm 118 */
																													goto
																														BgL_tagzd2377zd2_1714;
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_cdrzd224445zd2_1806;
																													BgL_cdrzd224445zd2_1806
																														=
																														CDR(BgL_expz00_21);
																													if ((CAR
																															(BgL_expz00_21) ==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{	/* Ast/sexp.scm 118 */
																															if (PAIRP
																																(BgL_cdrzd224445zd2_1806))
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd224448zd2_1810;
																																	obj_t
																																		BgL_cdrzd224449zd2_1811;
																																	BgL_carzd224448zd2_1810
																																		=
																																		CAR
																																		(BgL_cdrzd224445zd2_1806);
																																	BgL_cdrzd224449zd2_1811
																																		=
																																		CDR
																																		(BgL_cdrzd224445zd2_1806);
																																	if (PAIRP
																																		(BgL_carzd224448zd2_1810))
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(CAR
																																					(BgL_carzd224448zd2_1810)
																																					==
																																					CNST_TABLE_REF
																																					(((long) 14))))
																																				{	/* Ast/sexp.scm 118 */
																																					if (PAIRP(BgL_cdrzd224449zd2_1811))
																																						{	/* Ast/sexp.scm 118 */
																																							if (NULLP(CDR(BgL_cdrzd224449zd2_1811)))
																																								{
																																									obj_t
																																										BgL_valz00_20485;
																																									obj_t
																																										BgL_lz00_20483;
																																									BgL_lz00_20483
																																										=
																																										CDR
																																										(BgL_carzd224448zd2_1810);
																																									BgL_valz00_20485
																																										=
																																										CAR
																																										(BgL_cdrzd224449zd2_1811);
																																									BgL_valz00_1716
																																										=
																																										BgL_valz00_20485;
																																									BgL_lz00_1715
																																										=
																																										BgL_lz00_20483;
																																									goto
																																										BgL_tagzd2378zd2_1717;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							goto
																																								BgL_tagzd2379zd2_1718;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					goto
																																						BgL_tagzd2379zd2_1718;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			goto
																																				BgL_tagzd2379zd2_1718;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	goto
																																		BgL_tagzd2379zd2_1718;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR
																																	(BgL_expz00_21)
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{	/* Ast/sexp.scm 118 */
																																	goto
																																		BgL_tagzd2380zd2_1719;
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd224574zd2_1824;
																																	BgL_carzd224574zd2_1824
																																		=
																																		CAR
																																		(BgL_expz00_21);
																																	if (PAIRP
																																		(BgL_carzd224574zd2_1824))
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd224577zd2_1826;
																																			obj_t
																																				BgL_cdrzd224578zd2_1827;
																																			BgL_carzd224577zd2_1826
																																				=
																																				CAR
																																				(BgL_carzd224574zd2_1824);
																																			BgL_cdrzd224578zd2_1827
																																				=
																																				CDR
																																				(BgL_carzd224574zd2_1824);
																																			{

																																				if (
																																					(BgL_carzd224577zd2_1826
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{
																																						obj_t
																																							BgL_auxz00_20499;
																																					BgL_kapzd224579zd2_1828:
																																						if (PAIRP(BgL_cdrzd224578zd2_1827))
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd224582zd2_2130;
																																								BgL_cdrzd224582zd2_2130
																																									=
																																									CDR
																																									(BgL_cdrzd224578zd2_1827);
																																								if (PAIRP(BgL_cdrzd224582zd2_2130))
																																									{	/* Ast/sexp.scm 118 */
																																										if (NULLP(CDR(BgL_cdrzd224582zd2_2130)))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg1919z00_2134;
																																												obj_t
																																													BgL_arg1920z00_2135;
																																												BgL_arg1919z00_2134
																																													=
																																													CAR
																																													(BgL_cdrzd224582zd2_2130);
																																												BgL_arg1920z00_2135
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20511;
																																													{
																																														obj_t
																																															BgL_argsz00_20513;
																																														obj_t
																																															BgL_bodyz00_20512;
																																														BgL_bodyz00_20512
																																															=
																																															BgL_arg1919z00_2134;
																																														BgL_argsz00_20513
																																															=
																																															BgL_arg1920z00_2135;
																																														BgL_argsz00_1721
																																															=
																																															BgL_argsz00_20513;
																																														BgL_bodyz00_1720
																																															=
																																															BgL_bodyz00_20512;
																																														goto
																																															BgL_tagzd2381zd2_1722;
																																													}
																																													BgL_auxz00_20499
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20511);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd224605zd2_2136;
																																												BgL_cdrzd224605zd2_2136
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{

																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_20517;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg1988z00_2246;
																																															BgL_arg1988z00_2246
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_20517
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg1988z00_2246));
																																														}
																																														if (BgL_testz00_20517)
																																															{	/* Ast/sexp.scm 118 */
																																																if (PAIRP(BgL_cdrzd224605zd2_2136))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg1990z00_2248;
																																																		obj_t
																																																			BgL_arg1991z00_2249;
																																																		BgL_arg1990z00_2248
																																																			=
																																																			CAR
																																																			(BgL_cdrzd224605zd2_2136);
																																																		BgL_arg1991z00_2249
																																																			=
																																																			CDR
																																																			(BgL_cdrzd224605zd2_2136);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20526;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_20528;
																																																				obj_t
																																																					BgL_bindingsz00_20527;
																																																				BgL_bindingsz00_20527
																																																					=
																																																					BgL_arg1990z00_2248;
																																																				BgL_exprz00_20528
																																																					=
																																																					BgL_arg1991z00_2249;
																																																				BgL_exprz00_1724
																																																					=
																																																					BgL_exprz00_20528;
																																																				BgL_bindingsz00_1723
																																																					=
																																																					BgL_bindingsz00_20527;
																																																				goto
																																																					BgL_tagzd2382zd2_1725;
																																																			}
																																																			BgL_auxz00_20499
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20526);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		bool_t
																																																			BgL_testz00_20530;
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2060z00_2355;
																																																			BgL_arg2060z00_2355
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_testz00_20530
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg2060z00_2355));
																																																		}
																																																		if (BgL_testz00_20530)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_20535;
																																																				goto
																																																					BgL_tagzd2384zd2_1727;
																																																				BgL_auxz00_20499
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20535);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_carzd224669zd2_2252;
																																																				BgL_carzd224669zd2_2252
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd224674zd2_2253;
																																																					BgL_cdrzd224674zd2_2253
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd224669zd2_2252));
																																																					if ((CAR(((obj_t) BgL_carzd224669zd2_2252)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg1998z00_2256;
																																																							obj_t
																																																								BgL_arg1999z00_2257;
																																																							obj_t
																																																								BgL_arg2000z00_2258;
																																																							BgL_arg1998z00_2256
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2253));
																																																							BgL_arg1999z00_2257
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2253));
																																																							BgL_arg2000z00_2258
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20552;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20555;
																																																									obj_t
																																																										BgL_bodyz00_20554;
																																																									obj_t
																																																										BgL_varsz00_20553;
																																																									BgL_varsz00_20553
																																																										=
																																																										BgL_arg1998z00_2256;
																																																									BgL_bodyz00_20554
																																																										=
																																																										BgL_arg1999z00_2257;
																																																									BgL_argsz00_20555
																																																										=
																																																										BgL_arg2000z00_2258;
																																																									BgL_argsz00_1734
																																																										=
																																																										BgL_argsz00_20555;
																																																									BgL_bodyz00_1733
																																																										=
																																																										BgL_bodyz00_20554;
																																																									BgL_varsz00_1732
																																																										=
																																																										BgL_varsz00_20553;
																																																									goto
																																																										BgL_tagzd2386zd2_1735;
																																																								}
																																																								BgL_auxz00_20499
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20552);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd224697zd2_2260;
																																																							BgL_cdrzd224697zd2_2260
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd224703zd2_2261;
																																																								BgL_cdrzd224703zd2_2261
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd224669zd2_2252));
																																																								if ((CAR(((obj_t) BgL_carzd224669zd2_2252)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd224709zd2_2264;
																																																										BgL_cdrzd224709zd2_2264
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd224703zd2_2261));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd224714zd2_2265;
																																																											obj_t
																																																												BgL_cdrzd224715zd2_2266;
																																																											BgL_carzd224714zd2_2265
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2264));
																																																											BgL_cdrzd224715zd2_2266
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2264));
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224714zd2_2265))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd224715zd2_2266))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd224722zd2_2269;
																																																															BgL_carzd224722zd2_2269
																																																																=
																																																																CAR
																																																																(BgL_cdrzd224715zd2_2266);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224722zd2_2269))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (NULLP(CDR(BgL_cdrzd224715zd2_2266)))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_testz00_20582;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1405z00_2302;
																																																																				BgL_l1405z00_2302
																																																																					=
																																																																					BgL_cdrzd224697zd2_2260;
																																																																			BgL_zc3anonymousza32026ze3z83_2303:
																																																																				if (NULLP(BgL_l1405z00_2302))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_testz00_20582
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_20585;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_testz00_20586;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_tmpz00_20587;
																																																																								BgL_tmpz00_20587
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1405z00_2302));
																																																																								BgL_testz00_20586
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_20587);
																																																																							}
																																																																							if (BgL_testz00_20586)
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_20585
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_20585
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_testz00_20585)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1405z00_20591;
																																																																								BgL_l1405z00_20591
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1405z00_2302));
																																																																								BgL_l1405z00_2302
																																																																									=
																																																																									BgL_l1405z00_20591;
																																																																								goto
																																																																									BgL_zc3anonymousza32026ze3z83_2303;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_20582
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_testz00_20582)
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg2014z00_2285;
																																																																					BgL_arg2014z00_2285
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd224703zd2_2261));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20596;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_20600;
																																																																							obj_t
																																																																								BgL_proc2z00_20599;
																																																																							obj_t
																																																																								BgL_proc1z00_20598;
																																																																							obj_t
																																																																								BgL_testz00_20597;
																																																																							BgL_testz00_20597
																																																																								=
																																																																								BgL_arg2014z00_2285;
																																																																							BgL_proc1z00_20598
																																																																								=
																																																																								BgL_carzd224714zd2_2265;
																																																																							BgL_proc2z00_20599
																																																																								=
																																																																								BgL_carzd224722zd2_2269;
																																																																							BgL_argsz00_20600
																																																																								=
																																																																								BgL_cdrzd224697zd2_2260;
																																																																							BgL_argsz00_1739
																																																																								=
																																																																								BgL_argsz00_20600;
																																																																							BgL_proc2z00_1738
																																																																								=
																																																																								BgL_proc2z00_20599;
																																																																							BgL_proc1z00_1737
																																																																								=
																																																																								BgL_proc1z00_20598;
																																																																							BgL_testz00_1736
																																																																								=
																																																																								BgL_testz00_20597;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1740;
																																																																						}
																																																																						BgL_auxz00_20499
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20596);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd224746zd2_2286;
																																																																					BgL_cdrzd224746zd2_2286
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd224753zd2_2287;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_11401;
																																																																							BgL_pairz00_11401
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd224753zd2_2287
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11401);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd224760zd2_2288;
																																																																							BgL_cdrzd224760zd2_2288
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd224753zd2_2287));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd224766zd2_2289;
																																																																								BgL_carzd224766zd2_2289
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd224760zd2_2288));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224766zd2_2289))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd224773zd2_2291;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_11405;
																																																																											BgL_pairz00_11405
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd224760zd2_2288));
																																																																											BgL_carzd224773zd2_2291
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_11405);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224773zd2_2291))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd224746zd2_2286))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg2018z00_2294;
																																																																														BgL_arg2018z00_2294
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd224753zd2_2287));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20622;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_20626;
																																																																																obj_t
																																																																																	BgL_proc2z00_20625;
																																																																																obj_t
																																																																																	BgL_proc1z00_20624;
																																																																																obj_t
																																																																																	BgL_testz00_20623;
																																																																																BgL_testz00_20623
																																																																																	=
																																																																																	BgL_arg2018z00_2294;
																																																																																BgL_proc1z00_20624
																																																																																	=
																																																																																	BgL_carzd224766zd2_2289;
																																																																																BgL_proc2z00_20625
																																																																																	=
																																																																																	BgL_carzd224773zd2_2291;
																																																																																BgL_argsz00_20626
																																																																																	=
																																																																																	BgL_cdrzd224746zd2_2286;
																																																																																BgL_argsz00_1744
																																																																																	=
																																																																																	BgL_argsz00_20626;
																																																																																BgL_proc2z00_1743
																																																																																	=
																																																																																	BgL_proc2z00_20625;
																																																																																BgL_proc1z00_1742
																																																																																	=
																																																																																	BgL_proc1z00_20624;
																																																																																BgL_testz00_1741
																																																																																	=
																																																																																	BgL_testz00_20623;
																																																																																goto
																																																																																	BgL_tagzd2388zd2_1745;
																																																																															}
																																																																															BgL_auxz00_20499
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20622);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20630;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_20499
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20630);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20634;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_20499
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20634);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20638;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_20499
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20638);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20642;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_20499
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20642);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd225049zd2_2313;
																																																																	BgL_cdrzd225049zd2_2313
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd225055zd2_2314;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_pairz00_11409;
																																																																			BgL_pairz00_11409
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd225055zd2_2314
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11409);
																																																																		}
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd225061zd2_2315;
																																																																			BgL_cdrzd225061zd2_2315
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225055zd2_2314));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd225066zd2_2316;
																																																																				obj_t
																																																																					BgL_cdrzd225067zd2_2317;
																																																																				BgL_carzd225066zd2_2316
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2315));
																																																																				BgL_cdrzd225067zd2_2317
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2315));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225066zd2_2316))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd225072zd2_2319;
																																																																						BgL_carzd225072zd2_2319
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225067zd2_2317));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225072zd2_2319))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd225067zd2_2317))))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225049zd2_2313))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg2035z00_2324;
																																																																												BgL_arg2035z00_2324
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225055zd2_2314));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20669;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20673;
																																																																														obj_t
																																																																															BgL_proc2z00_20672;
																																																																														obj_t
																																																																															BgL_proc1z00_20671;
																																																																														obj_t
																																																																															BgL_testz00_20670;
																																																																														BgL_testz00_20670
																																																																															=
																																																																															BgL_arg2035z00_2324;
																																																																														BgL_proc1z00_20671
																																																																															=
																																																																															BgL_carzd225066zd2_2316;
																																																																														BgL_proc2z00_20672
																																																																															=
																																																																															BgL_carzd225072zd2_2319;
																																																																														BgL_argsz00_20673
																																																																															=
																																																																															BgL_cdrzd225049zd2_2313;
																																																																														BgL_argsz00_1744
																																																																															=
																																																																															BgL_argsz00_20673;
																																																																														BgL_proc2z00_1743
																																																																															=
																																																																															BgL_proc2z00_20672;
																																																																														BgL_proc1z00_1742
																																																																															=
																																																																															BgL_proc1z00_20671;
																																																																														BgL_testz00_1741
																																																																															=
																																																																															BgL_testz00_20670;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1745;
																																																																													}
																																																																													BgL_auxz00_20499
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20669);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20677;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_20499
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20677);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20681;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_20499
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20681);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20685;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_20499
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20685);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20689;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_20499
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20689);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20693;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_20499
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20693);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd225405zd2_2332;
																																																													BgL_cdrzd225405zd2_2332
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd225412zd2_2333;
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_pairz00_11419;
																																																															BgL_pairz00_11419
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd225412zd2_2333
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11419);
																																																														}
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd225419zd2_2334;
																																																															BgL_cdrzd225419zd2_2334
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd225412zd2_2333));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd225425zd2_2335;
																																																																obj_t
																																																																	BgL_cdrzd225426zd2_2336;
																																																																BgL_carzd225425zd2_2335
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2334));
																																																																BgL_cdrzd225426zd2_2336
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2334));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225425zd2_2335))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd225426zd2_2336))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd225433zd2_2339;
																																																																				BgL_carzd225433zd2_2339
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd225426zd2_2336);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225433zd2_2339))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd225426zd2_2336)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225405zd2_2332))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg2049z00_2344;
																																																																										BgL_arg2049z00_2344
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd225412zd2_2333));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20720;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20724;
																																																																												obj_t
																																																																													BgL_proc2z00_20723;
																																																																												obj_t
																																																																													BgL_proc1z00_20722;
																																																																												obj_t
																																																																													BgL_testz00_20721;
																																																																												BgL_testz00_20721
																																																																													=
																																																																													BgL_arg2049z00_2344;
																																																																												BgL_proc1z00_20722
																																																																													=
																																																																													BgL_carzd225425zd2_2335;
																																																																												BgL_proc2z00_20723
																																																																													=
																																																																													BgL_carzd225433zd2_2339;
																																																																												BgL_argsz00_20724
																																																																													=
																																																																													BgL_cdrzd225405zd2_2332;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_20724;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_20723;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_20722;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_20721;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1745;
																																																																											}
																																																																											BgL_auxz00_20499
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20720);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20728;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_20499
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20728);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20732;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_20499
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20732);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20736;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_20499
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20736);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20740;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_20499
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20740);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20744;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_20499
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20744);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20748;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_20499
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20748);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_testz00_20750;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg1987z00_2245;
																																																	BgL_arg1987z00_2245
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_testz00_20750
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg1987z00_2245));
																																																}
																																																if (BgL_testz00_20750)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20755;
																																																		goto
																																																			BgL_tagzd2384zd2_1727;
																																																		BgL_auxz00_20499
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20755);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd225865zd2_2142;
																																																		BgL_carzd225865zd2_2142
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd225870zd2_2143;
																																																			BgL_cdrzd225870zd2_2143
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd225865zd2_2142));
																																																			if ((CAR(((obj_t) BgL_carzd225865zd2_2142)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg1927z00_2146;
																																																					obj_t
																																																						BgL_arg1928z00_2147;
																																																					obj_t
																																																						BgL_arg1929z00_2148;
																																																					BgL_arg1927z00_2146
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2143));
																																																					BgL_arg1928z00_2147
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2143));
																																																					BgL_arg1929z00_2148
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_20772;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_20775;
																																																							obj_t
																																																								BgL_bodyz00_20774;
																																																							obj_t
																																																								BgL_varsz00_20773;
																																																							BgL_varsz00_20773
																																																								=
																																																								BgL_arg1927z00_2146;
																																																							BgL_bodyz00_20774
																																																								=
																																																								BgL_arg1928z00_2147;
																																																							BgL_argsz00_20775
																																																								=
																																																								BgL_arg1929z00_2148;
																																																							BgL_argsz00_1734
																																																								=
																																																								BgL_argsz00_20775;
																																																							BgL_bodyz00_1733
																																																								=
																																																								BgL_bodyz00_20774;
																																																							BgL_varsz00_1732
																																																								=
																																																								BgL_varsz00_20773;
																																																							goto
																																																								BgL_tagzd2386zd2_1735;
																																																						}
																																																						BgL_auxz00_20499
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20772);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd225893zd2_2150;
																																																					BgL_cdrzd225893zd2_2150
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd225899zd2_2151;
																																																						BgL_cdrzd225899zd2_2151
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd225865zd2_2142));
																																																						if ((CAR(((obj_t) BgL_carzd225865zd2_2142)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd225905zd2_2154;
																																																								BgL_cdrzd225905zd2_2154
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd225899zd2_2151));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd225910zd2_2155;
																																																									obj_t
																																																										BgL_cdrzd225911zd2_2156;
																																																									BgL_carzd225910zd2_2155
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2154));
																																																									BgL_cdrzd225911zd2_2156
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2154));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225910zd2_2155))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd225911zd2_2156))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd225918zd2_2159;
																																																													BgL_carzd225918zd2_2159
																																																														=
																																																														CAR
																																																														(BgL_cdrzd225911zd2_2156);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225918zd2_2159))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (NULLP(CDR(BgL_cdrzd225911zd2_2156)))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	bool_t
																																																																		BgL_testz00_20802;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1408z00_2192;
																																																																		BgL_l1408z00_2192
																																																																			=
																																																																			BgL_cdrzd225893zd2_2150;
																																																																	BgL_zc3anonymousza31953ze3z83_2193:
																																																																		if (NULLP(BgL_l1408z00_2192))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_testz00_20802
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_testz00_20805;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_testz00_20806;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_tmpz00_20807;
																																																																						BgL_tmpz00_20807
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1408z00_2192));
																																																																						BgL_testz00_20806
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_20807);
																																																																					}
																																																																					if (BgL_testz00_20806)
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_20805
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_20805
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_testz00_20805)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1408z00_20811;
																																																																						BgL_l1408z00_20811
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1408z00_2192));
																																																																						BgL_l1408z00_2192
																																																																							=
																																																																							BgL_l1408z00_20811;
																																																																						goto
																																																																							BgL_zc3anonymousza31953ze3z83_2193;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_testz00_20802
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_testz00_20802)
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg1943z00_2175;
																																																																			BgL_arg1943z00_2175
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225899zd2_2151));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20816;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_20820;
																																																																					obj_t
																																																																						BgL_proc2z00_20819;
																																																																					obj_t
																																																																						BgL_proc1z00_20818;
																																																																					obj_t
																																																																						BgL_testz00_20817;
																																																																					BgL_testz00_20817
																																																																						=
																																																																						BgL_arg1943z00_2175;
																																																																					BgL_proc1z00_20818
																																																																						=
																																																																						BgL_carzd225910zd2_2155;
																																																																					BgL_proc2z00_20819
																																																																						=
																																																																						BgL_carzd225918zd2_2159;
																																																																					BgL_argsz00_20820
																																																																						=
																																																																						BgL_cdrzd225893zd2_2150;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_20820;
																																																																					BgL_proc2z00_1738
																																																																						=
																																																																						BgL_proc2z00_20819;
																																																																					BgL_proc1z00_1737
																																																																						=
																																																																						BgL_proc1z00_20818;
																																																																					BgL_testz00_1736
																																																																						=
																																																																						BgL_testz00_20817;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1740;
																																																																				}
																																																																				BgL_auxz00_20499
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20816);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd225942zd2_2176;
																																																																			BgL_cdrzd225942zd2_2176
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd225949zd2_2177;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_11454;
																																																																					BgL_pairz00_11454
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd225949zd2_2177
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_11454);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd225956zd2_2178;
																																																																					BgL_cdrzd225956zd2_2178
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd225949zd2_2177));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd225962zd2_2179;
																																																																						BgL_carzd225962zd2_2179
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225956zd2_2178));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225962zd2_2179))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd225969zd2_2181;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_11458;
																																																																									BgL_pairz00_11458
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd225956zd2_2178));
																																																																									BgL_carzd225969zd2_2181
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_11458);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225969zd2_2181))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225942zd2_2176))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg1947z00_2184;
																																																																												BgL_arg1947z00_2184
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225949zd2_2177));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20842;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20846;
																																																																														obj_t
																																																																															BgL_proc2z00_20845;
																																																																														obj_t
																																																																															BgL_proc1z00_20844;
																																																																														obj_t
																																																																															BgL_testz00_20843;
																																																																														BgL_testz00_20843
																																																																															=
																																																																															BgL_arg1947z00_2184;
																																																																														BgL_proc1z00_20844
																																																																															=
																																																																															BgL_carzd225962zd2_2179;
																																																																														BgL_proc2z00_20845
																																																																															=
																																																																															BgL_carzd225969zd2_2181;
																																																																														BgL_argsz00_20846
																																																																															=
																																																																															BgL_cdrzd225942zd2_2176;
																																																																														BgL_argsz00_1744
																																																																															=
																																																																															BgL_argsz00_20846;
																																																																														BgL_proc2z00_1743
																																																																															=
																																																																															BgL_proc2z00_20845;
																																																																														BgL_proc1z00_1742
																																																																															=
																																																																															BgL_proc1z00_20844;
																																																																														BgL_testz00_1741
																																																																															=
																																																																															BgL_testz00_20843;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1745;
																																																																													}
																																																																													BgL_auxz00_20499
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20842);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20850;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_20499
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20850);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20854;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_20499
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20854);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20858;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_20499
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20858);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_20862;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_20499
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_20862);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd226245zd2_2203;
																																																															BgL_cdrzd226245zd2_2203
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd226251zd2_2204;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_pairz00_11462;
																																																																	BgL_pairz00_11462
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd226251zd2_2204
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_11462);
																																																																}
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd226257zd2_2205;
																																																																	BgL_cdrzd226257zd2_2205
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd226251zd2_2204));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd226262zd2_2206;
																																																																		obj_t
																																																																			BgL_cdrzd226263zd2_2207;
																																																																		BgL_carzd226262zd2_2206
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2205));
																																																																		BgL_cdrzd226263zd2_2207
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2205));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226262zd2_2206))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd226268zd2_2209;
																																																																				BgL_carzd226268zd2_2209
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd226263zd2_2207));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226268zd2_2209))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd226263zd2_2207))))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226245zd2_2203))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg1962z00_2214;
																																																																										BgL_arg1962z00_2214
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd226251zd2_2204));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20889;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20893;
																																																																												obj_t
																																																																													BgL_proc2z00_20892;
																																																																												obj_t
																																																																													BgL_proc1z00_20891;
																																																																												obj_t
																																																																													BgL_testz00_20890;
																																																																												BgL_testz00_20890
																																																																													=
																																																																													BgL_arg1962z00_2214;
																																																																												BgL_proc1z00_20891
																																																																													=
																																																																													BgL_carzd226262zd2_2206;
																																																																												BgL_proc2z00_20892
																																																																													=
																																																																													BgL_carzd226268zd2_2209;
																																																																												BgL_argsz00_20893
																																																																													=
																																																																													BgL_cdrzd226245zd2_2203;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_20893;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_20892;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_20891;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_20890;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1745;
																																																																											}
																																																																											BgL_auxz00_20499
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20889);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20897;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_20499
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20897);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20901;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_20499
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20901);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20905;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_20499
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20905);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20909;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_20499
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20909);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20913;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_20499
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20913);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd226601zd2_2222;
																																																											BgL_cdrzd226601zd2_2222
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd226608zd2_2223;
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_pairz00_11472;
																																																													BgL_pairz00_11472
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd226608zd2_2223
																																																														=
																																																														CDR
																																																														(BgL_pairz00_11472);
																																																												}
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd226615zd2_2224;
																																																													BgL_cdrzd226615zd2_2224
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd226608zd2_2223));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd226621zd2_2225;
																																																														obj_t
																																																															BgL_cdrzd226622zd2_2226;
																																																														BgL_carzd226621zd2_2225
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2224));
																																																														BgL_cdrzd226622zd2_2226
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2224));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226621zd2_2225))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd226622zd2_2226))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd226629zd2_2229;
																																																																		BgL_carzd226629zd2_2229
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd226622zd2_2226);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226629zd2_2229))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd226622zd2_2226)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226601zd2_2222))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg1976z00_2234;
																																																																								BgL_arg1976z00_2234
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd226608zd2_2223));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20940;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_20944;
																																																																										obj_t
																																																																											BgL_proc2z00_20943;
																																																																										obj_t
																																																																											BgL_proc1z00_20942;
																																																																										obj_t
																																																																											BgL_testz00_20941;
																																																																										BgL_testz00_20941
																																																																											=
																																																																											BgL_arg1976z00_2234;
																																																																										BgL_proc1z00_20942
																																																																											=
																																																																											BgL_carzd226621zd2_2225;
																																																																										BgL_proc2z00_20943
																																																																											=
																																																																											BgL_carzd226629zd2_2229;
																																																																										BgL_argsz00_20944
																																																																											=
																																																																											BgL_cdrzd226601zd2_2222;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_20944;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_20943;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_20942;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_20941;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1745;
																																																																									}
																																																																									BgL_auxz00_20499
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20940);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20948;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_20499
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20948);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20952;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_20499
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20952);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20956;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_20499
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20956);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20960;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_20499
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20960);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20964;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_20499
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20964);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1769;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_20968;
																																																										goto
																																																											BgL_tagzd2404zd2_1770;
																																																										BgL_auxz00_20499
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_20968);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd227021zd2_2357;
																																										BgL_cdrzd227021zd2_2357
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_20972;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg2074z00_2373;
																																													BgL_arg2074z00_2373
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_20972
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg2074z00_2373));
																																												}
																																												if (BgL_testz00_20972)
																																													{	/* Ast/sexp.scm 118 */
																																														if (PAIRP(BgL_cdrzd227021zd2_2357))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg2076z00_2375;
																																																obj_t
																																																	BgL_arg2077z00_2376;
																																																BgL_arg2076z00_2375
																																																	=
																																																	CAR
																																																	(BgL_cdrzd227021zd2_2357);
																																																BgL_arg2077z00_2376
																																																	=
																																																	CDR
																																																	(BgL_cdrzd227021zd2_2357);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_20981;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_20983;
																																																		obj_t
																																																			BgL_bindingsz00_20982;
																																																		BgL_bindingsz00_20982
																																																			=
																																																			BgL_arg2076z00_2375;
																																																		BgL_exprz00_20983
																																																			=
																																																			BgL_arg2077z00_2376;
																																																		BgL_exprz00_1724
																																																			=
																																																			BgL_exprz00_20983;
																																																		BgL_bindingsz00_1723
																																																			=
																																																			BgL_bindingsz00_20982;
																																																		goto
																																																			BgL_tagzd2382zd2_1725;
																																																	}
																																																	BgL_auxz00_20499
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_20981);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_testz00_20985;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg2088z00_2388;
																																																	BgL_arg2088z00_2388
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_testz00_20985
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2088z00_2388));
																																																}
																																																if (BgL_testz00_20985)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20990;
																																																		goto
																																																			BgL_tagzd2384zd2_1727;
																																																		BgL_auxz00_20499
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20990);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd227084zd2_2379;
																																																		BgL_carzd227084zd2_2379
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd227089zd2_2380;
																																																			BgL_cdrzd227089zd2_2380
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd227084zd2_2379));
																																																			if ((CAR(((obj_t) BgL_carzd227084zd2_2379)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg2082z00_2383;
																																																					obj_t
																																																						BgL_arg2084z00_2384;
																																																					obj_t
																																																						BgL_arg2085z00_2385;
																																																					BgL_arg2082z00_2383
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2380));
																																																					BgL_arg2084z00_2384
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2380));
																																																					BgL_arg2085z00_2385
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_21007;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_21010;
																																																							obj_t
																																																								BgL_bodyz00_21009;
																																																							obj_t
																																																								BgL_varsz00_21008;
																																																							BgL_varsz00_21008
																																																								=
																																																								BgL_arg2082z00_2383;
																																																							BgL_bodyz00_21009
																																																								=
																																																								BgL_arg2084z00_2384;
																																																							BgL_argsz00_21010
																																																								=
																																																								BgL_arg2085z00_2385;
																																																							BgL_argsz00_1734
																																																								=
																																																								BgL_argsz00_21010;
																																																							BgL_bodyz00_1733
																																																								=
																																																								BgL_bodyz00_21009;
																																																							BgL_varsz00_1732
																																																								=
																																																								BgL_varsz00_21008;
																																																							goto
																																																								BgL_tagzd2386zd2_1735;
																																																						}
																																																						BgL_auxz00_20499
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21007);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1769;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21014;
																																																							goto
																																																								BgL_tagzd2404zd2_1770;
																																																							BgL_auxz00_20499
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21014);
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_21016;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg2073z00_2372;
																																															BgL_arg2073z00_2372
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_21016
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2073z00_2372));
																																														}
																																														if (BgL_testz00_21016)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21021;
																																																goto
																																																	BgL_tagzd2384zd2_1727;
																																																BgL_auxz00_20499
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21021);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd227238zd2_2363;
																																																BgL_carzd227238zd2_2363
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd227243zd2_2364;
																																																	BgL_cdrzd227243zd2_2364
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd227238zd2_2363));
																																																	if ((CAR(((obj_t) BgL_carzd227238zd2_2363)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg2068z00_2367;
																																																			obj_t
																																																				BgL_arg2069z00_2368;
																																																			obj_t
																																																				BgL_arg2070z00_2369;
																																																			BgL_arg2068z00_2367
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2364));
																																																			BgL_arg2069z00_2368
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2364));
																																																			BgL_arg2070z00_2369
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_21038;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_21041;
																																																					obj_t
																																																						BgL_bodyz00_21040;
																																																					obj_t
																																																						BgL_varsz00_21039;
																																																					BgL_varsz00_21039
																																																						=
																																																						BgL_arg2068z00_2367;
																																																					BgL_bodyz00_21040
																																																						=
																																																						BgL_arg2069z00_2368;
																																																					BgL_argsz00_21041
																																																						=
																																																						BgL_arg2070z00_2369;
																																																					BgL_argsz00_1734
																																																						=
																																																						BgL_argsz00_21041;
																																																					BgL_bodyz00_1733
																																																						=
																																																						BgL_bodyz00_21040;
																																																					BgL_varsz00_1732
																																																						=
																																																						BgL_varsz00_21039;
																																																					goto
																																																						BgL_tagzd2386zd2_1735;
																																																				}
																																																				BgL_auxz00_20499
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_21038);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1769;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21045;
																																																					goto
																																																						BgL_tagzd2404zd2_1770;
																																																					BgL_auxz00_20499
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21045);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd227353zd2_2389;
																																								BgL_cdrzd227353zd2_2389
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_testz00_21049;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg2097z00_2397;
																																											BgL_arg2097z00_2397
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_testz00_21049
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg2097z00_2397));
																																										}
																																										if (BgL_testz00_21049)
																																											{	/* Ast/sexp.scm 118 */
																																												if (PAIRP(BgL_cdrzd227353zd2_2389))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg2099z00_2399;
																																														obj_t
																																															BgL_arg2100z00_2400;
																																														BgL_arg2099z00_2399
																																															=
																																															CAR
																																															(BgL_cdrzd227353zd2_2389);
																																														BgL_arg2100z00_2400
																																															=
																																															CDR
																																															(BgL_cdrzd227353zd2_2389);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21058;
																																															{
																																																obj_t
																																																	BgL_exprz00_21060;
																																																obj_t
																																																	BgL_bindingsz00_21059;
																																																BgL_bindingsz00_21059
																																																	=
																																																	BgL_arg2099z00_2399;
																																																BgL_exprz00_21060
																																																	=
																																																	BgL_arg2100z00_2400;
																																																BgL_exprz00_1724
																																																	=
																																																	BgL_exprz00_21060;
																																																BgL_bindingsz00_1723
																																																	=
																																																	BgL_bindingsz00_21059;
																																																goto
																																																	BgL_tagzd2382zd2_1725;
																																															}
																																															BgL_auxz00_20499
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21058);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_21062;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg2105z00_2404;
																																															BgL_arg2105z00_2404
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_21062
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2105z00_2404));
																																														}
																																														if (BgL_testz00_21062)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21067;
																																																goto
																																																	BgL_tagzd2384zd2_1727;
																																																BgL_auxz00_20499
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21067);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_tagzd2403zd2_1769;
																																																	}
																																																else
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_21071;
																																																		goto
																																																			BgL_tagzd2404zd2_1770;
																																																		BgL_auxz00_20499
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21071);
																																																	}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_21073;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg2094z00_2396;
																																													BgL_arg2094z00_2396
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_21073
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg2094z00_2396));
																																												}
																																												if (BgL_testz00_21073)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_21078;
																																														goto
																																															BgL_tagzd2384zd2_1727;
																																														BgL_auxz00_20499
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_21078);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd2403zd2_1769;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_21082;
																																																goto
																																																	BgL_tagzd2404zd2_1770;
																																																BgL_auxz00_20499
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21082);
																																															}
																																													}
																																											}
																																									}
																																								}
																																							}
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_20499);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224577zd2_1826)))
																																							{
																																								obj_t
																																									BgL_auxz00_21088;
																																								goto
																																									BgL_kapzd224579zd2_1828;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_21088);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if ((BgL_carzd224577zd2_1826 == CNST_TABLE_REF(((long) 18))))
																																									{
																																										obj_t
																																											BgL_auxz00_21093;
																																										goto
																																											BgL_kapzd224579zd2_1828;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_21093);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd224577zd2_1826 == CNST_TABLE_REF(((long) 19))))
																																											{
																																												obj_t
																																													BgL_auxz00_21098;
																																												goto
																																													BgL_kapzd224579zd2_1828;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_21098);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224577zd2_1826)))
																																													{
																																														obj_t
																																															BgL_auxz00_21103;
																																														goto
																																															BgL_kapzd224579zd2_1828;
																																														return
																																															(
																																															(BgL_nodez00_bglt)
																																															BgL_auxz00_21103);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd227662zd2_1834;
																																														BgL_cdrzd227662zd2_1834
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{

																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_testz00_21106;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg1839z00_2013;
																																																	BgL_arg1839z00_2013
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_testz00_21106
																																																		=
																																																		CBOOL
																																																		(BGl_letzd2symzf3z21zzast_letz00
																																																		(BgL_arg1839z00_2013));
																																																}
																																																if (BgL_testz00_21106)
																																																	{
																																																		obj_t
																																																			BgL_auxz00_21110;
																																																		if (PAIRP(BgL_cdrzd227662zd2_1834))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg1841z00_2015;
																																																				obj_t
																																																					BgL_arg1842z00_2016;
																																																				BgL_arg1841z00_2015
																																																					=
																																																					CAR
																																																					(BgL_cdrzd227662zd2_1834);
																																																				BgL_arg1842z00_2016
																																																					=
																																																					CDR
																																																					(BgL_cdrzd227662zd2_1834);
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21115;
																																																					{
																																																						obj_t
																																																							BgL_exprz00_21117;
																																																						obj_t
																																																							BgL_bindingsz00_21116;
																																																						BgL_bindingsz00_21116
																																																							=
																																																							BgL_arg1841z00_2015;
																																																						BgL_exprz00_21117
																																																							=
																																																							BgL_arg1842z00_2016;
																																																						BgL_exprz00_1724
																																																							=
																																																							BgL_exprz00_21117;
																																																						BgL_bindingsz00_1723
																																																							=
																																																							BgL_bindingsz00_21116;
																																																						goto
																																																							BgL_tagzd2382zd2_1725;
																																																					}
																																																					BgL_auxz00_21110
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21115);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				bool_t
																																																					BgL_testz00_21119;
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg1914z00_2128;
																																																					BgL_arg1914z00_2128
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_testz00_21119
																																																						=
																																																						CBOOL
																																																						(BGl_labelszd2symzf3z21zzast_labelsz00
																																																						(BgL_arg1914z00_2128));
																																																				}
																																																				if (BgL_testz00_21119)
																																																					{
																																																						BgL_letzd2funzd2_bglt
																																																							BgL_auxz00_21124;
																																																						goto
																																																							BgL_tagzd2384zd2_1727;
																																																						BgL_auxz00_21110
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21124);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_carzd227725zd2_2019;
																																																						BgL_carzd227725zd2_2019
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd227730zd2_2020;
																																																							BgL_cdrzd227730zd2_2020
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd227725zd2_2019));
																																																							if ((CAR(((obj_t) BgL_carzd227725zd2_2019)) == CNST_TABLE_REF(((long) 3))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd227730zd2_2020))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg1849z00_2024;
																																																											obj_t
																																																												BgL_arg1850z00_2025;
																																																											obj_t
																																																												BgL_arg1851z00_2026;
																																																											BgL_arg1849z00_2024
																																																												=
																																																												CAR
																																																												(BgL_cdrzd227730zd2_2020);
																																																											BgL_arg1850z00_2025
																																																												=
																																																												CDR
																																																												(BgL_cdrzd227730zd2_2020);
																																																											BgL_arg1851z00_2026
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_21141;
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21144;
																																																													obj_t
																																																														BgL_bodyz00_21143;
																																																													obj_t
																																																														BgL_varsz00_21142;
																																																													BgL_varsz00_21142
																																																														=
																																																														BgL_arg1849z00_2024;
																																																													BgL_bodyz00_21143
																																																														=
																																																														BgL_arg1850z00_2025;
																																																													BgL_argsz00_21144
																																																														=
																																																														BgL_arg1851z00_2026;
																																																													BgL_argsz00_1734
																																																														=
																																																														BgL_argsz00_21144;
																																																													BgL_bodyz00_1733
																																																														=
																																																														BgL_bodyz00_21143;
																																																													BgL_varsz00_1732
																																																														=
																																																														BgL_varsz00_21142;
																																																													goto
																																																														BgL_tagzd2386zd2_1735;
																																																												}
																																																												BgL_auxz00_21110
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_21141);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_21148;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_21110
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21148);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd227837zd2_2029;
																																																									BgL_cdrzd227837zd2_2029
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd227842zd2_2030;
																																																										BgL_cdrzd227842zd2_2030
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd227725zd2_2019));
																																																										if ((CAR(((obj_t) BgL_carzd227725zd2_2019)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd227842zd2_2030))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd227847zd2_2034;
																																																														BgL_cdrzd227847zd2_2034
																																																															=
																																																															CDR
																																																															(BgL_cdrzd227842zd2_2030);
																																																														if (PAIRP(BgL_cdrzd227847zd2_2034))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd227851zd2_2036;
																																																																obj_t
																																																																	BgL_cdrzd227852zd2_2037;
																																																																BgL_carzd227851zd2_2036
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd227847zd2_2034);
																																																																BgL_cdrzd227852zd2_2037
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd227847zd2_2034);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227851zd2_2036))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd227852zd2_2037))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd227857zd2_2040;
																																																																				BgL_carzd227857zd2_2040
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd227852zd2_2037);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227857zd2_2040))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd227852zd2_2037)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_21176;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1411z00_2073;
																																																																									BgL_l1411z00_2073
																																																																										=
																																																																										BgL_cdrzd227837zd2_2029;
																																																																								BgL_zc3anonymousza31878ze3z83_2074:
																																																																									if (NULLP(BgL_l1411z00_2073))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_21176
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_21179;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_21180;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_21181;
																																																																													BgL_tmpz00_21181
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1411z00_2073));
																																																																													BgL_testz00_21180
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_21181);
																																																																												}
																																																																												if (BgL_testz00_21180)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_21179
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_21179
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_testz00_21179)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1411z00_21185;
																																																																													BgL_l1411z00_21185
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1411z00_2073));
																																																																													BgL_l1411z00_2073
																																																																														=
																																																																														BgL_l1411z00_21185;
																																																																													goto
																																																																														BgL_zc3anonymousza31878ze3z83_2074;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_testz00_21176
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_testz00_21176)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg1868z00_2056;
																																																																										BgL_arg1868z00_2056
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd227842zd2_2030);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21189;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_21193;
																																																																												obj_t
																																																																													BgL_proc2z00_21192;
																																																																												obj_t
																																																																													BgL_proc1z00_21191;
																																																																												obj_t
																																																																													BgL_testz00_21190;
																																																																												BgL_testz00_21190
																																																																													=
																																																																													BgL_arg1868z00_2056;
																																																																												BgL_proc1z00_21191
																																																																													=
																																																																													BgL_carzd227851zd2_2036;
																																																																												BgL_proc2z00_21192
																																																																													=
																																																																													BgL_carzd227857zd2_2040;
																																																																												BgL_argsz00_21193
																																																																													=
																																																																													BgL_cdrzd227837zd2_2029;
																																																																												BgL_argsz00_1739
																																																																													=
																																																																													BgL_argsz00_21193;
																																																																												BgL_proc2z00_1738
																																																																													=
																																																																													BgL_proc2z00_21192;
																																																																												BgL_proc1z00_1737
																																																																													=
																																																																													BgL_proc1z00_21191;
																																																																												BgL_testz00_1736
																																																																													=
																																																																													BgL_testz00_21190;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1740;
																																																																											}
																																																																											BgL_auxz00_21110
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21189);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd227882zd2_2057;
																																																																										BgL_cdrzd227882zd2_2057
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd227890zd2_2058;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11539;
																																																																												BgL_pairz00_11539
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd227890zd2_2058
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11539);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd227898zd2_2059;
																																																																												BgL_cdrzd227898zd2_2059
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd227890zd2_2058));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd227905zd2_2060;
																																																																													BgL_carzd227905zd2_2060
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd227898zd2_2059));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227905zd2_2060))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd227914zd2_2062;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_11543;
																																																																																BgL_pairz00_11543
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd227898zd2_2059));
																																																																																BgL_carzd227914zd2_2062
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11543);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227914zd2_2062))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd227882zd2_2057))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg1872z00_2065;
																																																																																			BgL_arg1872z00_2065
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd227890zd2_2058));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_21215;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_21219;
																																																																																					obj_t
																																																																																						BgL_proc2z00_21218;
																																																																																					obj_t
																																																																																						BgL_proc1z00_21217;
																																																																																					obj_t
																																																																																						BgL_testz00_21216;
																																																																																					BgL_testz00_21216
																																																																																						=
																																																																																						BgL_arg1872z00_2065;
																																																																																					BgL_proc1z00_21217
																																																																																						=
																																																																																						BgL_carzd227905zd2_2060;
																																																																																					BgL_proc2z00_21218
																																																																																						=
																																																																																						BgL_carzd227914zd2_2062;
																																																																																					BgL_argsz00_21219
																																																																																						=
																																																																																						BgL_cdrzd227882zd2_2057;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_21219;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_21218;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_21217;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_21216;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_21110
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_21215);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21223;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21110
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21223);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21227;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21110
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21227);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21231;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21110
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21231);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21235;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_21110
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21235);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd228192zd2_2084;
																																																																						BgL_cdrzd228192zd2_2084
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd228199zd2_2085;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11547;
																																																																								BgL_pairz00_11547
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd228199zd2_2085
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11547);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd228206zd2_2086;
																																																																								BgL_cdrzd228206zd2_2086
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd228199zd2_2085));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd228212zd2_2087;
																																																																									obj_t
																																																																										BgL_cdrzd228213zd2_2088;
																																																																									BgL_carzd228212zd2_2087
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2086));
																																																																									BgL_cdrzd228213zd2_2088
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2086));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228212zd2_2087))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd228220zd2_2090;
																																																																											BgL_carzd228220zd2_2090
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd228213zd2_2088));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228220zd2_2090))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd228213zd2_2088))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228192zd2_2084))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg1887z00_2095;
																																																																																	BgL_arg1887z00_2095
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd228199zd2_2085));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_21262;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_21266;
																																																																																			obj_t
																																																																																				BgL_proc2z00_21265;
																																																																																			obj_t
																																																																																				BgL_proc1z00_21264;
																																																																																			obj_t
																																																																																				BgL_testz00_21263;
																																																																																			BgL_testz00_21263
																																																																																				=
																																																																																				BgL_arg1887z00_2095;
																																																																																			BgL_proc1z00_21264
																																																																																				=
																																																																																				BgL_carzd228212zd2_2087;
																																																																																			BgL_proc2z00_21265
																																																																																				=
																																																																																				BgL_carzd228220zd2_2090;
																																																																																			BgL_argsz00_21266
																																																																																				=
																																																																																				BgL_cdrzd228192zd2_2084;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_21266;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_21265;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_21264;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_21263;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_21110
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_21262);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21270;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21110
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21270);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21274;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21110
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21274);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21278;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21110
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21278);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21282;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21110
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21282);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21286;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21110
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21286);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd228553zd2_2103;
																																																																		BgL_cdrzd228553zd2_2103
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd228559zd2_2104;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_11557;
																																																																				BgL_pairz00_11557
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd228559zd2_2104
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11557);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd228565zd2_2105;
																																																																				BgL_cdrzd228565zd2_2105
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd228559zd2_2104));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd228570zd2_2106;
																																																																					obj_t
																																																																						BgL_cdrzd228571zd2_2107;
																																																																					BgL_carzd228570zd2_2106
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2105));
																																																																					BgL_cdrzd228571zd2_2107
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2105));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228570zd2_2106))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd228571zd2_2107))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd228576zd2_2110;
																																																																									BgL_carzd228576zd2_2110
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd228571zd2_2107);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228576zd2_2110))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd228571zd2_2107)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228553zd2_2103))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg1901z00_2115;
																																																																															BgL_arg1901z00_2115
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd228559zd2_2104));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_21313;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21317;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21316;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21315;
																																																																																	obj_t
																																																																																		BgL_testz00_21314;
																																																																																	BgL_testz00_21314
																																																																																		=
																																																																																		BgL_arg1901z00_2115;
																																																																																	BgL_proc1z00_21315
																																																																																		=
																																																																																		BgL_carzd228570zd2_2106;
																																																																																	BgL_proc2z00_21316
																																																																																		=
																																																																																		BgL_carzd228576zd2_2110;
																																																																																	BgL_argsz00_21317
																																																																																		=
																																																																																		BgL_cdrzd228553zd2_2103;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_21317;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_21316;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_21315;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_21314;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_21110
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_21313);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21321;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21110
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21321);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21325;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21110
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21325);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21329;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21110
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21329);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21333;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21110
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21333);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_21337;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21110
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_21337);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21341;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_21110
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21341);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_21345;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21110
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_21345);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_21349;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_21110
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_21349);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_21110);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		bool_t
																																																			BgL_testz00_21352;
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg1838z00_2012;
																																																			BgL_arg1838z00_2012
																																																				=
																																																				CAR
																																																				(BgL_expz00_21);
																																																			BgL_testz00_21352
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg1838z00_2012));
																																																		}
																																																		if (BgL_testz00_21352)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_21356;
																																																				goto
																																																					BgL_tagzd2384zd2_1727;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_21356);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_carzd229139zd2_1840;
																																																				obj_t
																																																					BgL_cdrzd229140zd2_1841;
																																																				BgL_carzd229139zd2_1840
																																																					=
																																																					CAR
																																																					(BgL_expz00_21);
																																																				BgL_cdrzd229140zd2_1841
																																																					=
																																																					CDR
																																																					(BgL_expz00_21);
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd229144zd2_1842;
																																																					BgL_cdrzd229144zd2_1842
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd229139zd2_1840));
																																																					if ((CAR(((obj_t) BgL_carzd229139zd2_1840)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd229144zd2_1842))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd229147zd2_1846;
																																																									obj_t
																																																										BgL_cdrzd229148zd2_1847;
																																																									BgL_carzd229147zd2_1846
																																																										=
																																																										CAR
																																																										(BgL_cdrzd229144zd2_1842);
																																																									BgL_cdrzd229148zd2_1847
																																																										=
																																																										CDR
																																																										(BgL_cdrzd229144zd2_1842);
																																																									if (PAIRP(BgL_carzd229147zd2_1846))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (NULLP(CDR(BgL_carzd229147zd2_1846)))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd229148zd2_1847))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd229154zd2_1852;
																																																															BgL_carzd229154zd2_1852
																																																																=
																																																																CAR
																																																																(BgL_cdrzd229148zd2_1847);
																																																															if (PAIRP(BgL_carzd229154zd2_1852))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd229154zd2_1852))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (NULLP(CDR(BgL_cdrzd229148zd2_1847)))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd229140zd2_1841))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd229161zd2_1858;
																																																																							BgL_carzd229161zd2_1858
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229140zd2_1841);
																																																																							if (PAIRP(BgL_carzd229161zd2_1858))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd229185zd2_1860;
																																																																									BgL_cdrzd229185zd2_1860
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg1670z00_1861;
																																																																										obj_t
																																																																											BgL_arg1672z00_1862;
																																																																										obj_t
																																																																											BgL_arg1673z00_1863;
																																																																										BgL_arg1670z00_1861
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1860));
																																																																										BgL_arg1672z00_1862
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1860));
																																																																										BgL_arg1673z00_1863
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_21400;
																																																																											obj_t
																																																																												BgL_bodyz00_21399;
																																																																											obj_t
																																																																												BgL_varsz00_21398;
																																																																											BgL_varsz00_21398
																																																																												=
																																																																												BgL_arg1670z00_1861;
																																																																											BgL_bodyz00_21399
																																																																												=
																																																																												BgL_arg1672z00_1862;
																																																																											BgL_argsz00_21400
																																																																												=
																																																																												BgL_arg1673z00_1863;
																																																																											BgL_argsz00_1734
																																																																												=
																																																																												BgL_argsz00_21400;
																																																																											BgL_bodyz00_1733
																																																																												=
																																																																												BgL_bodyz00_21399;
																																																																											BgL_varsz00_1732
																																																																												=
																																																																												BgL_varsz00_21398;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1735;
																																																																										}
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd229140zd2_1841)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg1680z00_1867;
																																																																											BgL_arg1680z00_1867
																																																																												=
																																																																												CAR
																																																																												(BgL_carzd229147zd2_1846);
																																																																											{
																																																																												BgL_castz00_bglt
																																																																													BgL_auxz00_21405;
																																																																												{
																																																																													obj_t
																																																																														BgL_argz00_21408;
																																																																													obj_t
																																																																														BgL_bodyz00_21407;
																																																																													obj_t
																																																																														BgL_varz00_21406;
																																																																													BgL_varz00_21406
																																																																														=
																																																																														BgL_arg1680z00_1867;
																																																																													BgL_bodyz00_21407
																																																																														=
																																																																														BgL_carzd229154zd2_1852;
																																																																													BgL_argz00_21408
																																																																														=
																																																																														BgL_carzd229161zd2_1858;
																																																																													BgL_argz00_1730
																																																																														=
																																																																														BgL_argz00_21408;
																																																																													BgL_bodyz00_1729
																																																																														=
																																																																														BgL_bodyz00_21407;
																																																																													BgL_varz00_1728
																																																																														=
																																																																														BgL_varz00_21406;
																																																																													goto
																																																																														BgL_tagzd2385zd2_1731;
																																																																												}
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21405);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd229212zd2_1868;
																																																																											BgL_cdrzd229212zd2_1868
																																																																												=
																																																																												CDR
																																																																												(CAR
																																																																												(BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg1682z00_1869;
																																																																												obj_t
																																																																													BgL_arg1684z00_1870;
																																																																												obj_t
																																																																													BgL_arg1686z00_1871;
																																																																												BgL_arg1682z00_1869
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1868));
																																																																												BgL_arg1684z00_1870
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1868));
																																																																												BgL_arg1686z00_1871
																																																																													=
																																																																													CDR
																																																																													(BgL_expz00_21);
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21419;
																																																																													obj_t
																																																																														BgL_bodyz00_21418;
																																																																													obj_t
																																																																														BgL_varsz00_21417;
																																																																													BgL_varsz00_21417
																																																																														=
																																																																														BgL_arg1682z00_1869;
																																																																													BgL_bodyz00_21418
																																																																														=
																																																																														BgL_arg1684z00_1870;
																																																																													BgL_argsz00_21419
																																																																														=
																																																																														BgL_arg1686z00_1871;
																																																																													BgL_argsz00_1734
																																																																														=
																																																																														BgL_argsz00_21419;
																																																																													BgL_bodyz00_1733
																																																																														=
																																																																														BgL_bodyz00_21418;
																																																																													BgL_varsz00_1732
																																																																														=
																																																																														BgL_varsz00_21417;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1735;
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd229238zd2_1874;
																																																																							BgL_cdrzd229238zd2_1874
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg1689z00_1875;
																																																																								obj_t
																																																																									BgL_arg1691z00_1876;
																																																																								obj_t
																																																																									BgL_arg1692z00_1877;
																																																																								BgL_arg1689z00_1875
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1874));
																																																																								BgL_arg1691z00_1876
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1874));
																																																																								BgL_arg1692z00_1877
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_21429;
																																																																									obj_t
																																																																										BgL_bodyz00_21428;
																																																																									obj_t
																																																																										BgL_varsz00_21427;
																																																																									BgL_varsz00_21427
																																																																										=
																																																																										BgL_arg1689z00_1875;
																																																																									BgL_bodyz00_21428
																																																																										=
																																																																										BgL_arg1691z00_1876;
																																																																									BgL_argsz00_21429
																																																																										=
																																																																										BgL_arg1692z00_1877;
																																																																									BgL_argsz00_1734
																																																																										=
																																																																										BgL_argsz00_21429;
																																																																									BgL_bodyz00_1733
																																																																										=
																																																																										BgL_bodyz00_21428;
																																																																									BgL_varsz00_1732
																																																																										=
																																																																										BgL_varsz00_21427;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1735;
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd229264zd2_1879;
																																																																					BgL_cdrzd229264zd2_1879
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg1694z00_1880;
																																																																						obj_t
																																																																							BgL_arg1695z00_1881;
																																																																						obj_t
																																																																							BgL_arg1696z00_1882;
																																																																						BgL_arg1694z00_1880
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1879));
																																																																						BgL_arg1695z00_1881
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1879));
																																																																						BgL_arg1696z00_1882
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21439;
																																																																							obj_t
																																																																								BgL_bodyz00_21438;
																																																																							obj_t
																																																																								BgL_varsz00_21437;
																																																																							BgL_varsz00_21437
																																																																								=
																																																																								BgL_arg1694z00_1880;
																																																																							BgL_bodyz00_21438
																																																																								=
																																																																								BgL_arg1695z00_1881;
																																																																							BgL_argsz00_21439
																																																																								=
																																																																								BgL_arg1696z00_1882;
																																																																							BgL_argsz00_1734
																																																																								=
																																																																								BgL_argsz00_21439;
																																																																							BgL_bodyz00_1733
																																																																								=
																																																																								BgL_bodyz00_21438;
																																																																							BgL_varsz00_1732
																																																																								=
																																																																								BgL_varsz00_21437;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1735;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd229290zd2_1885;
																																																																			BgL_cdrzd229290zd2_1885
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg1704z00_1886;
																																																																				obj_t
																																																																					BgL_arg1705z00_1887;
																																																																				obj_t
																																																																					BgL_arg1706z00_1888;
																																																																				BgL_arg1704z00_1886
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1885));
																																																																				BgL_arg1705z00_1887
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1885));
																																																																				BgL_arg1706z00_1888
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_21449;
																																																																					obj_t
																																																																						BgL_bodyz00_21448;
																																																																					obj_t
																																																																						BgL_varsz00_21447;
																																																																					BgL_varsz00_21447
																																																																						=
																																																																						BgL_arg1704z00_1886;
																																																																					BgL_bodyz00_21448
																																																																						=
																																																																						BgL_arg1705z00_1887;
																																																																					BgL_argsz00_21449
																																																																						=
																																																																						BgL_arg1706z00_1888;
																																																																					BgL_argsz00_1734
																																																																						=
																																																																						BgL_argsz00_21449;
																																																																					BgL_bodyz00_1733
																																																																						=
																																																																						BgL_bodyz00_21448;
																																																																					BgL_varsz00_1732
																																																																						=
																																																																						BgL_varsz00_21447;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1735;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd229316zd2_1890;
																																																																	BgL_cdrzd229316zd2_1890
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd229139zd2_1840));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg1709z00_1891;
																																																																		obj_t
																																																																			BgL_arg1710z00_1892;
																																																																		obj_t
																																																																			BgL_arg1712z00_1893;
																																																																		BgL_arg1709z00_1891
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1890));
																																																																		BgL_arg1710z00_1892
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1890));
																																																																		BgL_arg1712z00_1893
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_21459;
																																																																			obj_t
																																																																				BgL_bodyz00_21458;
																																																																			obj_t
																																																																				BgL_varsz00_21457;
																																																																			BgL_varsz00_21457
																																																																				=
																																																																				BgL_arg1709z00_1891;
																																																																			BgL_bodyz00_21458
																																																																				=
																																																																				BgL_arg1710z00_1892;
																																																																			BgL_argsz00_21459
																																																																				=
																																																																				BgL_arg1712z00_1893;
																																																																			BgL_argsz00_1734
																																																																				=
																																																																				BgL_argsz00_21459;
																																																																			BgL_bodyz00_1733
																																																																				=
																																																																				BgL_bodyz00_21458;
																																																																			BgL_varsz00_1732
																																																																				=
																																																																				BgL_varsz00_21457;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1735;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd229342zd2_1895;
																																																															BgL_cdrzd229342zd2_1895
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd229139zd2_1840));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg1718z00_1896;
																																																																obj_t
																																																																	BgL_arg1725z00_1897;
																																																																obj_t
																																																																	BgL_arg1728z00_1898;
																																																																BgL_arg1718z00_1896
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1895));
																																																																BgL_arg1725z00_1897
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1895));
																																																																BgL_arg1728z00_1898
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_21469;
																																																																	obj_t
																																																																		BgL_bodyz00_21468;
																																																																	obj_t
																																																																		BgL_varsz00_21467;
																																																																	BgL_varsz00_21467
																																																																		=
																																																																		BgL_arg1718z00_1896;
																																																																	BgL_bodyz00_21468
																																																																		=
																																																																		BgL_arg1725z00_1897;
																																																																	BgL_argsz00_21469
																																																																		=
																																																																		BgL_arg1728z00_1898;
																																																																	BgL_argsz00_1734
																																																																		=
																																																																		BgL_argsz00_21469;
																																																																	BgL_bodyz00_1733
																																																																		=
																																																																		BgL_bodyz00_21468;
																																																																	BgL_varsz00_1732
																																																																		=
																																																																		BgL_varsz00_21467;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1735;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd229368zd2_1900;
																																																													BgL_cdrzd229368zd2_1900
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd229139zd2_1840));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg1738z00_1901;
																																																														obj_t
																																																															BgL_arg1749z00_1902;
																																																														obj_t
																																																															BgL_arg1751z00_1903;
																																																														BgL_arg1738z00_1901
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1900));
																																																														BgL_arg1749z00_1902
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1900));
																																																														BgL_arg1751z00_1903
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_21479;
																																																															obj_t
																																																																BgL_bodyz00_21478;
																																																															obj_t
																																																																BgL_varsz00_21477;
																																																															BgL_varsz00_21477
																																																																=
																																																																BgL_arg1738z00_1901;
																																																															BgL_bodyz00_21478
																																																																=
																																																																BgL_arg1749z00_1902;
																																																															BgL_argsz00_21479
																																																																=
																																																																BgL_arg1751z00_1903;
																																																															BgL_argsz00_1734
																																																																=
																																																																BgL_argsz00_21479;
																																																															BgL_bodyz00_1733
																																																																=
																																																																BgL_bodyz00_21478;
																																																															BgL_varsz00_1732
																																																																=
																																																																BgL_varsz00_21477;
																																																															goto
																																																																BgL_tagzd2386zd2_1735;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd229394zd2_1906;
																																																											BgL_cdrzd229394zd2_1906
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd229139zd2_1840));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg1762z00_1907;
																																																												obj_t
																																																													BgL_arg1763z00_1908;
																																																												obj_t
																																																													BgL_arg1765z00_1909;
																																																												BgL_arg1762z00_1907
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1906));
																																																												BgL_arg1763z00_1908
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1906));
																																																												BgL_arg1765z00_1909
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21489;
																																																													obj_t
																																																														BgL_bodyz00_21488;
																																																													obj_t
																																																														BgL_varsz00_21487;
																																																													BgL_varsz00_21487
																																																														=
																																																														BgL_arg1762z00_1907;
																																																													BgL_bodyz00_21488
																																																														=
																																																														BgL_arg1763z00_1908;
																																																													BgL_argsz00_21489
																																																														=
																																																														BgL_arg1765z00_1909;
																																																													BgL_argsz00_1734
																																																														=
																																																														BgL_argsz00_21489;
																																																													BgL_bodyz00_1733
																																																														=
																																																														BgL_bodyz00_21488;
																																																													BgL_varsz00_1732
																																																														=
																																																														BgL_varsz00_21487;
																																																													goto
																																																														BgL_tagzd2386zd2_1735;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21492;
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21492);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd229532zd2_1914;
																																																							BgL_cdrzd229532zd2_1914
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd229139zd2_1840));
																																																							if ((CAR(((obj_t) BgL_carzd229139zd2_1840)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd229532zd2_1914))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd229537zd2_1918;
																																																											BgL_cdrzd229537zd2_1918
																																																												=
																																																												CDR
																																																												(BgL_cdrzd229532zd2_1914);
																																																											if (PAIRP(BgL_cdrzd229537zd2_1918))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd229541zd2_1920;
																																																													obj_t
																																																														BgL_cdrzd229542zd2_1921;
																																																													BgL_carzd229541zd2_1920
																																																														=
																																																														CAR
																																																														(BgL_cdrzd229537zd2_1918);
																																																													BgL_cdrzd229542zd2_1921
																																																														=
																																																														CDR
																																																														(BgL_cdrzd229537zd2_1918);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229541zd2_1920))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (PAIRP(BgL_cdrzd229542zd2_1921))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd229547zd2_1924;
																																																																	BgL_carzd229547zd2_1924
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd229542zd2_1921);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229547zd2_1924))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (NULLP(CDR(BgL_cdrzd229542zd2_1921)))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_testz00_21518;
																																																																					{
																																																																						obj_t
																																																																							BgL_l1414z00_1957;
																																																																						BgL_l1414z00_1957
																																																																							=
																																																																							BgL_cdrzd229140zd2_1841;
																																																																					BgL_zc3anonymousza31795ze3z83_1958:
																																																																						if (NULLP(BgL_l1414z00_1957))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_21518
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_21521;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_21522;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_tmpz00_21523;
																																																																										BgL_tmpz00_21523
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_l1414z00_1957));
																																																																										BgL_testz00_21522
																																																																											=
																																																																											PAIRP
																																																																											(BgL_tmpz00_21523);
																																																																									}
																																																																									if (BgL_testz00_21522)
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_21521
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_21521
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																								}
																																																																								if (BgL_testz00_21521)
																																																																									{
																																																																										obj_t
																																																																											BgL_l1414z00_21527;
																																																																										BgL_l1414z00_21527
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_l1414z00_1957));
																																																																										BgL_l1414z00_1957
																																																																											=
																																																																											BgL_l1414z00_21527;
																																																																										goto
																																																																											BgL_zc3anonymousza31795ze3z83_1958;
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_21518
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																							}
																																																																					}
																																																																					if (BgL_testz00_21518)
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21534;
																																																																							obj_t
																																																																								BgL_proc2z00_21533;
																																																																							obj_t
																																																																								BgL_proc1z00_21532;
																																																																							obj_t
																																																																								BgL_testz00_21530;
																																																																							BgL_testz00_21530
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229532zd2_1914);
																																																																							BgL_proc1z00_21532
																																																																								=
																																																																								BgL_carzd229541zd2_1920;
																																																																							BgL_proc2z00_21533
																																																																								=
																																																																								BgL_carzd229547zd2_1924;
																																																																							BgL_argsz00_21534
																																																																								=
																																																																								BgL_cdrzd229140zd2_1841;
																																																																							BgL_argsz00_1739
																																																																								=
																																																																								BgL_argsz00_21534;
																																																																							BgL_proc2z00_1738
																																																																								=
																																																																								BgL_proc2z00_21533;
																																																																							BgL_proc1z00_1737
																																																																								=
																																																																								BgL_proc1z00_21532;
																																																																							BgL_testz00_1736
																																																																								=
																																																																								BgL_testz00_21530;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1740;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd229572zd2_1941;
																																																																							BgL_cdrzd229572zd2_1941
																																																																								=
																																																																								CDR
																																																																								(BgL_expz00_21);
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd229580zd2_1942;
																																																																								BgL_cdrzd229580zd2_1942
																																																																									=
																																																																									CDR
																																																																									(CAR
																																																																									(BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd229588zd2_1943;
																																																																									BgL_cdrzd229588zd2_1943
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd229580zd2_1942));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd229595zd2_1944;
																																																																										BgL_carzd229595zd2_1944
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229588zd2_1943));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229595zd2_1944))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd229604zd2_1946;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_11658;
																																																																													BgL_pairz00_11658
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd229588zd2_1943));
																																																																													BgL_carzd229604zd2_1946
																																																																														=
																																																																														CAR
																																																																														(BgL_pairz00_11658);
																																																																												}
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229604zd2_1946))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229572zd2_1941))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg1788z00_1949;
																																																																																BgL_arg1788z00_1949
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd229580zd2_1942));
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21556;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21555;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21554;
																																																																																	obj_t
																																																																																		BgL_testz00_21553;
																																																																																	BgL_testz00_21553
																																																																																		=
																																																																																		BgL_arg1788z00_1949;
																																																																																	BgL_proc1z00_21554
																																																																																		=
																																																																																		BgL_carzd229595zd2_1944;
																																																																																	BgL_proc2z00_21555
																																																																																		=
																																																																																		BgL_carzd229604zd2_1946;
																																																																																	BgL_argsz00_21556
																																																																																		=
																																																																																		BgL_cdrzd229572zd2_1941;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_21556;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_21555;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_21554;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_21553;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_auxz00_21559;
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																		return
																																																																																			(
																																																																																			(BgL_nodez00_bglt)
																																																																																			BgL_auxz00_21559);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21563;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21563);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21567;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21567);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_21571;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_21571);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd229882zd2_1968;
																																																																			BgL_cdrzd229882zd2_1968
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd229889zd2_1969;
																																																																				BgL_cdrzd229889zd2_1969
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd229896zd2_1970;
																																																																					BgL_cdrzd229896zd2_1970
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd229889zd2_1969));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd229902zd2_1971;
																																																																						obj_t
																																																																							BgL_cdrzd229903zd2_1972;
																																																																						BgL_carzd229902zd2_1971
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_1970));
																																																																						BgL_cdrzd229903zd2_1972
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_1970));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229902zd2_1971))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd229910zd2_1974;
																																																																								BgL_carzd229910zd2_1974
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229903zd2_1972));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229910zd2_1974))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd229903zd2_1972))))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229882zd2_1968))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg1807z00_1979;
																																																																														BgL_arg1807z00_1979
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd229889zd2_1969));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_21599;
																																																																															obj_t
																																																																																BgL_proc2z00_21598;
																																																																															obj_t
																																																																																BgL_proc1z00_21597;
																																																																															obj_t
																																																																																BgL_testz00_21596;
																																																																															BgL_testz00_21596
																																																																																=
																																																																																BgL_arg1807z00_1979;
																																																																															BgL_proc1z00_21597
																																																																																=
																																																																																BgL_carzd229902zd2_1971;
																																																																															BgL_proc2z00_21598
																																																																																=
																																																																																BgL_carzd229910zd2_1974;
																																																																															BgL_argsz00_21599
																																																																																=
																																																																																BgL_cdrzd229882zd2_1968;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_21599;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_21598;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_21597;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_21596;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21602;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21602);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21606;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21606);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21610;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21610);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21614;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21614);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_21618;
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21618);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd230243zd2_1987;
																																																															BgL_cdrzd230243zd2_1987
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd230249zd2_1988;
																																																																BgL_cdrzd230249zd2_1988
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd230255zd2_1989;
																																																																	BgL_cdrzd230255zd2_1989
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd230249zd2_1988));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd230260zd2_1990;
																																																																		obj_t
																																																																			BgL_cdrzd230261zd2_1991;
																																																																		BgL_carzd230260zd2_1990
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_1989));
																																																																		BgL_cdrzd230261zd2_1991
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_1989));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230260zd2_1990))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd230261zd2_1991))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd230266zd2_1994;
																																																																						BgL_carzd230266zd2_1994
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd230261zd2_1991);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230266zd2_1994))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(BgL_cdrzd230261zd2_1991)))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd230243zd2_1987))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg1822z00_1999;
																																																																												BgL_arg1822z00_1999
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd230249zd2_1988));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21646;
																																																																													obj_t
																																																																														BgL_proc2z00_21645;
																																																																													obj_t
																																																																														BgL_proc1z00_21644;
																																																																													obj_t
																																																																														BgL_testz00_21643;
																																																																													BgL_testz00_21643
																																																																														=
																																																																														BgL_arg1822z00_1999;
																																																																													BgL_proc1z00_21644
																																																																														=
																																																																														BgL_carzd230260zd2_1990;
																																																																													BgL_proc2z00_21645
																																																																														=
																																																																														BgL_carzd230266zd2_1994;
																																																																													BgL_argsz00_21646
																																																																														=
																																																																														BgL_cdrzd230243zd2_1987;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_21646;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_21645;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_21644;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_21643;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21649;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21649);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21653;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21653);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21657;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21657);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_21661;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_21661);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_21665;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_21665);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21669;
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21669);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_21673;
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_21673);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21677;
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21677);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{

																																			if (
																																				(BgL_carzd224574zd2_1824
																																					==
																																					CNST_TABLE_REF
																																					(((long) 17))))
																																				{
																																					obj_t
																																						BgL_auxz00_21682;
																																				BgL_kapzd230804zd2_2407:
																																					if (PAIRP(BgL_cdrzd224445zd2_1806))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_arg2193z00_2504;
																																							obj_t
																																								BgL_arg2194z00_2505;
																																							BgL_arg2193z00_2504
																																								=
																																								CAR
																																								(BgL_cdrzd224445zd2_1806);
																																							BgL_arg2194z00_2505
																																								=
																																								CDR
																																								(BgL_cdrzd224445zd2_1806);
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_21687;
																																								{
																																									obj_t
																																										BgL_exprz00_21689;
																																									obj_t
																																										BgL_bindingsz00_21688;
																																									BgL_bindingsz00_21688
																																										=
																																										BgL_arg2193z00_2504;
																																									BgL_exprz00_21689
																																										=
																																										BgL_arg2194z00_2505;
																																									BgL_exprz00_1724
																																										=
																																										BgL_exprz00_21689;
																																									BgL_bindingsz00_1723
																																										=
																																										BgL_bindingsz00_21688;
																																									goto
																																										BgL_tagzd2382zd2_1725;
																																								}
																																								BgL_auxz00_21682
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_21687);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_21696;
																																									goto
																																										BgL_tagzd2383zd2_1726;
																																									BgL_auxz00_21682
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_21696);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd230837zd2_2508;
																																									BgL_carzd230837zd2_2508
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if ((BgL_carzd230837zd2_2508 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_21703;
																																											goto
																																												BgL_tagzd2384zd2_1727;
																																											BgL_auxz00_21682
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_21703);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230837zd2_2508)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21708;
																																													goto
																																														BgL_tagzd2384zd2_1727;
																																													BgL_auxz00_21682
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_21708);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21715;
																																															goto
																																																BgL_tagzd2389zd2_1746;
																																															BgL_auxz00_21682
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21715);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21722;
																																																	goto
																																																		BgL_tagzd2390zd2_1747;
																																																	BgL_auxz00_21682
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21722);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_21729;
																																																			goto
																																																				BgL_tagzd2392zd2_1751;
																																																			BgL_auxz00_21682
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_21729);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21736;
																																																					goto
																																																						BgL_tagzd2393zd2_1752;
																																																					BgL_auxz00_21682
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21736);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21743;
																																																							goto
																																																								BgL_tagzd2395zd2_1756;
																																																							BgL_auxz00_21682
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21743);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_21750;
																																																									goto
																																																										BgL_tagzd2396zd2_1757;
																																																									BgL_auxz00_21682
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21750);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_21757;
																																																											goto
																																																												BgL_tagzd2397zd2_1758;
																																																											BgL_auxz00_21682
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21757);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																												{
																																																													BgL_jumpzd2exzd2itz00_bglt
																																																														BgL_auxz00_21764;
																																																													goto
																																																														BgL_tagzd2398zd2_1759;
																																																													BgL_auxz00_21682
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21764);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21774;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1768;
																																																																	BgL_auxz00_21682
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21774);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_21778;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21682
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_21778);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21782;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_21682
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21782);
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_21682);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224574zd2_1824)))
																																						{
																																							obj_t
																																								BgL_auxz00_21788;
																																							goto
																																								BgL_kapzd230804zd2_2407;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_21788);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd224574zd2_1824 == CNST_TABLE_REF(((long) 18))))
																																								{
																																									obj_t
																																										BgL_auxz00_21793;
																																									goto
																																										BgL_kapzd230804zd2_2407;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_21793);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																										{	/* Ast/sexp.scm 118 */
																																											goto
																																												BgL_tagzd2383zd2_1726;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd230998zd2_2413;
																																											BgL_carzd230998zd2_2413
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											if ((BgL_carzd230998zd2_2413 == CNST_TABLE_REF(((long) 19))))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21803;
																																													goto
																																														BgL_tagzd2384zd2_1727;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_21803);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230998zd2_2413)))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_21808;
																																															goto
																																																BgL_tagzd2384zd2_1727;
																																															return
																																																(
																																																(BgL_nodez00_bglt)
																																																BgL_auxz00_21808);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2389zd2_1746;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2390zd2_1747;
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd231077zd2_2420;
																																																			BgL_cdrzd231077zd2_2420
																																																				=
																																																				CDR
																																																				(BgL_expz00_21);
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (PAIRP(BgL_cdrzd231077zd2_2420))
																																																						{
																																																							obj_t
																																																								BgL_restz00_21827;
																																																							obj_t
																																																								BgL_effectz00_21825;
																																																							BgL_effectz00_21825
																																																								=
																																																								CAR
																																																								(BgL_cdrzd231077zd2_2420);
																																																							BgL_restz00_21827
																																																								=
																																																								CDR
																																																								(BgL_cdrzd231077zd2_2420);
																																																							BgL_restz00_1749
																																																								=
																																																								BgL_restz00_21827;
																																																							BgL_effectz00_1748
																																																								=
																																																								BgL_effectz00_21825;
																																																							goto
																																																								BgL_tagzd2391zd2_1750;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_21831;
																																																									goto
																																																										BgL_tagzd2403zd2_1769;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_21831);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2404zd2_1770;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2392zd2_1751;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2393zd2_1752;
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd231077zd2_2420))
																																																												{
																																																													obj_t
																																																														BgL_restz00_21849;
																																																													obj_t
																																																														BgL_effectz00_21847;
																																																													BgL_effectz00_21847
																																																														=
																																																														CAR
																																																														(BgL_cdrzd231077zd2_2420);
																																																													BgL_restz00_21849
																																																														=
																																																														CDR
																																																														(BgL_cdrzd231077zd2_2420);
																																																													BgL_restz00_1754
																																																														=
																																																														BgL_restz00_21849;
																																																													BgL_effectz00_1753
																																																														=
																																																														BgL_effectz00_21847;
																																																													goto
																																																														BgL_tagzd2394zd2_1755;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21853;
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21853);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2395zd2_1756;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2396zd2_1757;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_21867;
																																																																	goto
																																																																		BgL_tagzd2397zd2_1758;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_21867);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																		{
																																																																			BgL_jumpzd2exzd2itz00_bglt
																																																																				BgL_auxz00_21873;
																																																																			goto
																																																																				BgL_tagzd2398zd2_1759;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21873);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd231204zd2_2446;
																																																																			BgL_cdrzd231204zd2_2446
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd231204zd2_2446))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd231206zd2_2450;
																																																																							BgL_cdrzd231206zd2_2450
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd231204zd2_2446);
																																																																							if (PAIRP(BgL_cdrzd231206zd2_2450))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd231206zd2_2450)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2399zd2_1760;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_21890;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_21890);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21894;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21894);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_21898;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_21898);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd231204zd2_2446))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd231251zd2_2462;
																																																																									BgL_cdrzd231251zd2_2462
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd231204zd2_2446);
																																																																									if (PAIRP(BgL_cdrzd231251zd2_2462))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd231256zd2_2464;
																																																																											BgL_cdrzd231256zd2_2464
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd231251zd2_2462);
																																																																											if ((CAR(BgL_cdrzd231251zd2_2462) == CNST_TABLE_REF(((long) 31))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (PAIRP(BgL_cdrzd231256zd2_2464))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg2160z00_2468;
																																																																															obj_t
																																																																																BgL_arg2161z00_2469;
																																																																															obj_t
																																																																																BgL_arg2162z00_2470;
																																																																															BgL_arg2160z00_2468
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231204zd2_2446);
																																																																															BgL_arg2161z00_2469
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231256zd2_2464);
																																																																															BgL_arg2162z00_2470
																																																																																=
																																																																																CDR
																																																																																(BgL_cdrzd231256zd2_2464);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2160z00_2468,
																																																																																BgL_arg2161z00_2469,
																																																																																BgL_arg2162z00_2470,
																																																																																BgL_stackz00_22,
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_locz00_23),
																																																																																BgL_sitez00_24);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd231269zd2_2471;
																																																																															BgL_cdrzd231269zd2_2471
																																																																																=
																																																																																CDR
																																																																																(BgL_expz00_21);
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg2163z00_2472;
																																																																																obj_t
																																																																																	BgL_arg2164z00_2473;
																																																																																BgL_arg2163z00_2472
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2471));
																																																																																BgL_arg2164z00_2473
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2471));
																																																																																{	/* Ast/sexp.scm 563 */
																																																																																	obj_t
																																																																																		BgL_arg7000z00_11741;
																																																																																	BgL_arg7000z00_11741
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	return
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_arg2163z00_2472,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg2164z00_2473, BgL_stackz00_22, BgL_arg7000z00_11741, BgL_sitez00_24);
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd231284zd2_2474;
																																																																													BgL_cdrzd231284zd2_2474
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg2165z00_2475;
																																																																														obj_t
																																																																															BgL_arg2166z00_2476;
																																																																														BgL_arg2165z00_2475
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2474));
																																																																														BgL_arg2166z00_2476
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2474));
																																																																														{	/* Ast/sexp.scm 563 */
																																																																															obj_t
																																																																																BgL_arg7000z00_11745;
																																																																															BgL_arg7000z00_11745
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2165z00_2475,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg2166z00_2476, BgL_stackz00_22, BgL_arg7000z00_11745, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd231299zd2_2478;
																																																																											BgL_cdrzd231299zd2_2478
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg2168z00_2479;
																																																																												obj_t
																																																																													BgL_arg2169z00_2480;
																																																																												BgL_arg2168z00_2479
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2478));
																																																																												BgL_arg2169z00_2480
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2478));
																																																																												{	/* Ast/sexp.scm 563 */
																																																																													obj_t
																																																																														BgL_arg7000z00_11749;
																																																																													BgL_arg7000z00_11749
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg2168z00_2479,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg2169z00_2480, BgL_stackz00_22, BgL_arg7000z00_11749, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21947;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21947);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_expz00_21)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1768;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_21957;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_21957);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21961;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21961);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 118 */
												if (
													(BgL_carzd2478zd2_1775 ==
														CNST_TABLE_REF(((long) 11))))
													{	/* Ast/sexp.scm 118 */
														goto BgL_tagzd2371zd2_1705;
													}
												else
													{	/* Ast/sexp.scm 118 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 14))))
															{
																obj_t BgL_lz00_21970;

																BgL_lz00_21970 = CDR(BgL_expz00_21);
																BgL_lz00_1706 = BgL_lz00_21970;
																goto BgL_tagzd2372zd2_1707;
															}
														else
															{	/* Ast/sexp.scm 118 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 12))))
																	{	/* Ast/sexp.scm 118 */
																		goto BgL_tagzd2373zd2_1708;
																	}
																else
																	{	/* Ast/sexp.scm 118 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 15))))
																			{	/* Ast/sexp.scm 118 */
																				if (NULLP(CDR(BgL_expz00_21)))
																					{	/* Ast/sexp.scm 118 */
																						goto BgL_tagzd2374zd2_1709;
																					}
																				else
																					{	/* Ast/sexp.scm 118 */
																						obj_t BgL_arg4304z00_5071;

																						BgL_arg4304z00_5071 =
																							CDR(BgL_expz00_21);
																						{
																							BgL_sequencez00_bglt
																								BgL_auxz00_21984;
																							{
																								obj_t BgL_bodyz00_21985;

																								BgL_bodyz00_21985 =
																									BgL_arg4304z00_5071;
																								BgL_bodyz00_1710 =
																									BgL_bodyz00_21985;
																								goto BgL_tagzd2375zd2_1711;
																							}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_21984);
																						}
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 118 */
																				obj_t BgL_carzd231447zd2_5073;
																				obj_t BgL_cdrzd231448zd2_5074;

																				BgL_carzd231447zd2_5073 =
																					CAR(BgL_expz00_21);
																				BgL_cdrzd231448zd2_5074 =
																					CDR(BgL_expz00_21);
																				{

																					if (
																						(BgL_carzd231447zd2_5073 ==
																							CNST_TABLE_REF(((long) 1))))
																						{
																							obj_t BgL_auxz00_21992;

																						BgL_kapzd231449zd2_5075:
																							if (PAIRP
																								(BgL_cdrzd231448zd2_5074))
																								{	/* Ast/sexp.scm 118 */
																									obj_t BgL_cdrzd231452zd2_5822;

																									BgL_cdrzd231452zd2_5822 =
																										CDR
																										(BgL_cdrzd231448zd2_5074);
																									if (PAIRP
																										(BgL_cdrzd231452zd2_5822))
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_cdrzd231455zd2_5824;
																											BgL_cdrzd231455zd2_5824 =
																												CDR
																												(BgL_cdrzd231452zd2_5822);
																											if ((CAR
																													(BgL_cdrzd231452zd2_5822)
																													== BTRUE))
																												{	/* Ast/sexp.scm 118 */
																													if (PAIRP
																														(BgL_cdrzd231455zd2_5824))
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR
																																	(BgL_cdrzd231455zd2_5824)
																																	== BFALSE))
																																{	/* Ast/sexp.scm 118 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd231455zd2_5824)))
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_sitez00_24
																																					==
																																					CNST_TABLE_REF
																																					(((long) 8))))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_arg4844z00_5834;
																																					BgL_arg4844z00_5834
																																						=
																																						CAR
																																						(BgL_cdrzd231448zd2_5074);
																																					BgL_auxz00_21992
																																						=
																																						(
																																						(obj_t)
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_arg4844z00_5834,
																																							BgL_stackz00_22,
																																							BgL_locz00_23,
																																							BgL_sitez00_24));
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd231474zd2_5835;
																																					BgL_carzd231474zd2_5835
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd231474zd2_5835
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22021;
																																							goto
																																								BgL_tagzd2377zd2_1714;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22021);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd231474zd2_5835 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22025;
																																									goto
																																										BgL_tagzd2377zd2_1714;
																																									BgL_auxz00_21992
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22025);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22032;
																																											goto
																																												BgL_tagzd2379zd2_1718;
																																											BgL_auxz00_21992
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22032);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_22039;
																																													goto
																																														BgL_tagzd2380zd2_1719;
																																													BgL_auxz00_21992
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_22039);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd231543zd2_5842;
																																													BgL_carzd231543zd2_5842
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd231543zd2_5842))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd231546zd2_5844;
																																															obj_t
																																																BgL_cdrzd231547zd2_5845;
																																															BgL_carzd231546zd2_5844
																																																=
																																																CAR
																																																(BgL_carzd231543zd2_5842);
																																															BgL_cdrzd231547zd2_5845
																																																=
																																																CDR
																																																(BgL_carzd231543zd2_5842);
																																															{

																																																if ((BgL_carzd231546zd2_5844 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 118 */
																																																	BgL_kapzd231548zd2_5846:
																																																		if (PAIRP(BgL_cdrzd231547zd2_5845))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd231551zd2_5971;
																																																				BgL_cdrzd231551zd2_5971
																																																					=
																																																					CDR
																																																					(BgL_cdrzd231547zd2_5845);
																																																				if (PAIRP(BgL_cdrzd231551zd2_5971))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (NULLP(CDR(BgL_cdrzd231551zd2_5971)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg4936z00_5975;
																																																								obj_t
																																																									BgL_arg4937z00_5976;
																																																								BgL_arg4936z00_5975
																																																									=
																																																									CAR
																																																									(BgL_cdrzd231551zd2_5971);
																																																								BgL_arg4937z00_5976
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_22061;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_22063;
																																																										obj_t
																																																											BgL_bodyz00_22062;
																																																										BgL_bodyz00_22062
																																																											=
																																																											BgL_arg4936z00_5975;
																																																										BgL_argsz00_22063
																																																											=
																																																											BgL_arg4937z00_5976;
																																																										BgL_argsz00_1721
																																																											=
																																																											BgL_argsz00_22063;
																																																										BgL_bodyz00_1720
																																																											=
																																																											BgL_bodyz00_22062;
																																																										goto
																																																											BgL_tagzd2381zd2_1722;
																																																									}
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22061);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd231575zd2_5977;
																																																								BgL_cdrzd231575zd2_5977
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_22067;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5006z00_6088;
																																																										BgL_arg5006z00_6088
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_22067
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5006z00_6088));
																																																									}
																																																									if (BgL_testz00_22067)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg4940z00_5980;
																																																											obj_t
																																																												BgL_arg4941z00_5981;
																																																											BgL_arg4940z00_5980
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_5977));
																																																											BgL_arg4941z00_5981
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_5977));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_22076;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_22078;
																																																													obj_t
																																																														BgL_bindingsz00_22077;
																																																													BgL_bindingsz00_22077
																																																														=
																																																														BgL_arg4940z00_5980;
																																																													BgL_exprz00_22078
																																																														=
																																																														BgL_arg4941z00_5981;
																																																													BgL_exprz00_1724
																																																														=
																																																														BgL_exprz00_22078;
																																																													BgL_bindingsz00_1723
																																																														=
																																																														BgL_bindingsz00_22077;
																																																													goto
																																																														BgL_tagzd2382zd2_1725;
																																																												}
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_22076);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_22080;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5005z00_6087;
																																																												BgL_arg5005z00_6087
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_22080
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5005z00_6087));
																																																											}
																																																											if (BgL_testz00_22080)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_22085;
																																																													goto
																																																														BgL_tagzd2384zd2_1727;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22085);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd231642zd2_5984;
																																																													BgL_carzd231642zd2_5984
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd231647zd2_5985;
																																																														BgL_cdrzd231647zd2_5985
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd231642zd2_5984));
																																																														if ((CAR(((obj_t) BgL_carzd231642zd2_5984)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg4946z00_5988;
																																																																obj_t
																																																																	BgL_arg4947z00_5989;
																																																																obj_t
																																																																	BgL_arg4948z00_5990;
																																																																BgL_arg4946z00_5988
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_5985));
																																																																BgL_arg4947z00_5989
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_5985));
																																																																BgL_arg4948z00_5990
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_22102;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_22105;
																																																																		obj_t
																																																																			BgL_bodyz00_22104;
																																																																		obj_t
																																																																			BgL_varsz00_22103;
																																																																		BgL_varsz00_22103
																																																																			=
																																																																			BgL_arg4946z00_5988;
																																																																		BgL_bodyz00_22104
																																																																			=
																																																																			BgL_arg4947z00_5989;
																																																																		BgL_argsz00_22105
																																																																			=
																																																																			BgL_arg4948z00_5990;
																																																																		BgL_argsz00_1734
																																																																			=
																																																																			BgL_argsz00_22105;
																																																																		BgL_bodyz00_1733
																																																																			=
																																																																			BgL_bodyz00_22104;
																																																																		BgL_varsz00_1732
																																																																			=
																																																																			BgL_varsz00_22103;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1735;
																																																																	}
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_22102);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd231670zd2_5992;
																																																																BgL_cdrzd231670zd2_5992
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd231676zd2_5993;
																																																																	BgL_cdrzd231676zd2_5993
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd231642zd2_5984));
																																																																	if ((CAR(((obj_t) BgL_carzd231642zd2_5984)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd231682zd2_5996;
																																																																			BgL_cdrzd231682zd2_5996
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd231676zd2_5993));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd231687zd2_5997;
																																																																				obj_t
																																																																					BgL_cdrzd231688zd2_5998;
																																																																				BgL_carzd231687zd2_5997
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_5996));
																																																																				BgL_cdrzd231688zd2_5998
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_5996));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231687zd2_5997))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (PAIRP(BgL_cdrzd231688zd2_5998))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd231695zd2_6001;
																																																																								BgL_carzd231695zd2_6001
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd231688zd2_5998);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231695zd2_6001))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (NULLP(CDR(BgL_cdrzd231688zd2_5998)))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_22132;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1417z00_6034;
																																																																													BgL_l1417z00_6034
																																																																														=
																																																																														BgL_cdrzd231670zd2_5992;
																																																																												BgL_zc3anonymousza34971ze3z83_6035:
																																																																													if (NULLP(BgL_l1417z00_6034))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_testz00_22132
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_testz00_22135;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_testz00_22136;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_22137;
																																																																																	BgL_tmpz00_22137
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1417z00_6034));
																																																																																	BgL_testz00_22136
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_22137);
																																																																																}
																																																																																if (BgL_testz00_22136)
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_22135
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_22135
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_testz00_22135)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1417z00_22141;
																																																																																	BgL_l1417z00_22141
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1417z00_6034));
																																																																																	BgL_l1417z00_6034
																																																																																		=
																																																																																		BgL_l1417z00_22141;
																																																																																	goto
																																																																																		BgL_zc3anonymousza34971ze3z83_6035;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_22132
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_testz00_22132)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg4961z00_6017;
																																																																														BgL_arg4961z00_6017
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231676zd2_5993));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22146;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_22150;
																																																																																obj_t
																																																																																	BgL_proc2z00_22149;
																																																																																obj_t
																																																																																	BgL_proc1z00_22148;
																																																																																obj_t
																																																																																	BgL_testz00_22147;
																																																																																BgL_testz00_22147
																																																																																	=
																																																																																	BgL_arg4961z00_6017;
																																																																																BgL_proc1z00_22148
																																																																																	=
																																																																																	BgL_carzd231687zd2_5997;
																																																																																BgL_proc2z00_22149
																																																																																	=
																																																																																	BgL_carzd231695zd2_6001;
																																																																																BgL_argsz00_22150
																																																																																	=
																																																																																	BgL_cdrzd231670zd2_5992;
																																																																																BgL_argsz00_1739
																																																																																	=
																																																																																	BgL_argsz00_22150;
																																																																																BgL_proc2z00_1738
																																																																																	=
																																																																																	BgL_proc2z00_22149;
																																																																																BgL_proc1z00_1737
																																																																																	=
																																																																																	BgL_proc1z00_22148;
																																																																																BgL_testz00_1736
																																																																																	=
																																																																																	BgL_testz00_22147;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1740;
																																																																															}
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22146);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd231719zd2_6018;
																																																																														BgL_cdrzd231719zd2_6018
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd231726zd2_6019;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_11816;
																																																																																BgL_pairz00_11816
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd231726zd2_6019
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_11816);
																																																																															}
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd231733zd2_6020;
																																																																																BgL_cdrzd231733zd2_6020
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231726zd2_6019));
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd231739zd2_6021;
																																																																																	BgL_carzd231739zd2_6021
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd231733zd2_6020));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231739zd2_6021))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_carzd231746zd2_6023;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_pairz00_11820;
																																																																																				BgL_pairz00_11820
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd231733zd2_6020));
																																																																																				BgL_carzd231746zd2_6023
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_11820);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231746zd2_6023))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd231719zd2_6018))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_arg4965z00_6026;
																																																																																							BgL_arg4965z00_6026
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd231726zd2_6019));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22172;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_22176;
																																																																																									obj_t
																																																																																										BgL_proc2z00_22175;
																																																																																									obj_t
																																																																																										BgL_proc1z00_22174;
																																																																																									obj_t
																																																																																										BgL_testz00_22173;
																																																																																									BgL_testz00_22173
																																																																																										=
																																																																																										BgL_arg4965z00_6026;
																																																																																									BgL_proc1z00_22174
																																																																																										=
																																																																																										BgL_carzd231739zd2_6021;
																																																																																									BgL_proc2z00_22175
																																																																																										=
																																																																																										BgL_carzd231746zd2_6023;
																																																																																									BgL_argsz00_22176
																																																																																										=
																																																																																										BgL_cdrzd231719zd2_6018;
																																																																																									BgL_argsz00_1744
																																																																																										=
																																																																																										BgL_argsz00_22176;
																																																																																									BgL_proc2z00_1743
																																																																																										=
																																																																																										BgL_proc2z00_22175;
																																																																																									BgL_proc1z00_1742
																																																																																										=
																																																																																										BgL_proc1z00_22174;
																																																																																									BgL_testz00_1741
																																																																																										=
																																																																																										BgL_testz00_22173;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1745;
																																																																																								}
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22172);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1769;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22180;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1770;
																																																																																									BgL_auxz00_21992
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22180);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22184;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_21992
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22184);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22188;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22188);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_22192;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_22192);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd232022zd2_6045;
																																																																										BgL_cdrzd232022zd2_6045
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd232028zd2_6046;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_11824;
																																																																												BgL_pairz00_11824
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd232028zd2_6046
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11824);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd232034zd2_6047;
																																																																												BgL_cdrzd232034zd2_6047
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd232028zd2_6046));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd232039zd2_6048;
																																																																													obj_t
																																																																														BgL_cdrzd232040zd2_6049;
																																																																													BgL_carzd232039zd2_6048
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6047));
																																																																													BgL_cdrzd232040zd2_6049
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6047));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232039zd2_6048))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd232045zd2_6051;
																																																																															BgL_carzd232045zd2_6051
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd232040zd2_6049));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232045zd2_6051))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd232040zd2_6049))))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232022zd2_6045))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg4980z00_6056;
																																																																																					BgL_arg4980z00_6056
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd232028zd2_6046));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22219;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22223;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22222;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22221;
																																																																																							obj_t
																																																																																								BgL_testz00_22220;
																																																																																							BgL_testz00_22220
																																																																																								=
																																																																																								BgL_arg4980z00_6056;
																																																																																							BgL_proc1z00_22221
																																																																																								=
																																																																																								BgL_carzd232039zd2_6048;
																																																																																							BgL_proc2z00_22222
																																																																																								=
																																																																																								BgL_carzd232045zd2_6051;
																																																																																							BgL_argsz00_22223
																																																																																								=
																																																																																								BgL_cdrzd232022zd2_6045;
																																																																																							BgL_argsz00_1744
																																																																																								=
																																																																																								BgL_argsz00_22223;
																																																																																							BgL_proc2z00_1743
																																																																																								=
																																																																																								BgL_proc2z00_22222;
																																																																																							BgL_proc1z00_1742
																																																																																								=
																																																																																								BgL_proc1z00_22221;
																																																																																							BgL_testz00_1741
																																																																																								=
																																																																																								BgL_testz00_22220;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1745;
																																																																																						}
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22219);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22227;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_21992
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22227);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22231;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22231);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22235;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22235);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22239;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22239);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_22243;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_22243);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd232378zd2_6064;
																																																																						BgL_cdrzd232378zd2_6064
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd232385zd2_6065;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_11834;
																																																																								BgL_pairz00_11834
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd232385zd2_6065
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11834);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd232392zd2_6066;
																																																																								BgL_cdrzd232392zd2_6066
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd232385zd2_6065));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd232398zd2_6067;
																																																																									obj_t
																																																																										BgL_cdrzd232399zd2_6068;
																																																																									BgL_carzd232398zd2_6067
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6066));
																																																																									BgL_cdrzd232399zd2_6068
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6066));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232398zd2_6067))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd232399zd2_6068))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd232406zd2_6071;
																																																																													BgL_carzd232406zd2_6071
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd232399zd2_6068);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232406zd2_6071))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd232399zd2_6068)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232378zd2_6064))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg4994z00_6076;
																																																																																			BgL_arg4994z00_6076
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd232385zd2_6065));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22270;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22274;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22273;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22272;
																																																																																					obj_t
																																																																																						BgL_testz00_22271;
																																																																																					BgL_testz00_22271
																																																																																						=
																																																																																						BgL_arg4994z00_6076;
																																																																																					BgL_proc1z00_22272
																																																																																						=
																																																																																						BgL_carzd232398zd2_6067;
																																																																																					BgL_proc2z00_22273
																																																																																						=
																																																																																						BgL_carzd232406zd2_6071;
																																																																																					BgL_argsz00_22274
																																																																																						=
																																																																																						BgL_cdrzd232378zd2_6064;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_22274;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_22273;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_22272;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_22271;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22270);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22278;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22278);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22282;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22282);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22286;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22286);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22290;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22290);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22294;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22294);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22298;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22298);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd232799zd2_6090;
																																																						BgL_cdrzd232799zd2_6090
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_22302;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5022z00_6107;
																																																								BgL_arg5022z00_6107
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_22302
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5022z00_6107));
																																																							}
																																																							if (BgL_testz00_22302)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg5010z00_6093;
																																																									obj_t
																																																										BgL_arg5011z00_6094;
																																																									BgL_arg5010z00_6093
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6090));
																																																									BgL_arg5011z00_6094
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6090));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22311;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22313;
																																																											obj_t
																																																												BgL_bindingsz00_22312;
																																																											BgL_bindingsz00_22312
																																																												=
																																																												BgL_arg5010z00_6093;
																																																											BgL_exprz00_22313
																																																												=
																																																												BgL_arg5011z00_6094;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_22313;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_22312;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_21992
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22311);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_22315;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5021z00_6106;
																																																										BgL_arg5021z00_6106
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_22315
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5021z00_6106));
																																																									}
																																																									if (BgL_testz00_22315)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22320;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22320);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd232865zd2_6097;
																																																											BgL_carzd232865zd2_6097
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd232870zd2_6098;
																																																												BgL_cdrzd232870zd2_6098
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd232865zd2_6097));
																																																												if ((CAR(((obj_t) BgL_carzd232865zd2_6097)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg5016z00_6101;
																																																														obj_t
																																																															BgL_arg5017z00_6102;
																																																														obj_t
																																																															BgL_arg5018z00_6103;
																																																														BgL_arg5016z00_6101
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6098));
																																																														BgL_arg5017z00_6102
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6098));
																																																														BgL_arg5018z00_6103
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22337;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22340;
																																																																obj_t
																																																																	BgL_bodyz00_22339;
																																																																obj_t
																																																																	BgL_varsz00_22338;
																																																																BgL_varsz00_22338
																																																																	=
																																																																	BgL_arg5016z00_6101;
																																																																BgL_bodyz00_22339
																																																																	=
																																																																	BgL_arg5017z00_6102;
																																																																BgL_argsz00_22340
																																																																	=
																																																																	BgL_arg5018z00_6103;
																																																																BgL_argsz00_1734
																																																																	=
																																																																	BgL_argsz00_22340;
																																																																BgL_bodyz00_1733
																																																																	=
																																																																	BgL_bodyz00_22339;
																																																																BgL_varsz00_1732
																																																																	=
																																																																	BgL_varsz00_22338;
																																																																goto
																																																																	BgL_tagzd2386zd2_1735;
																																																															}
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22337);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_22344;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_22344);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd232981zd2_6108;
																																																				BgL_cdrzd232981zd2_6108
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_22348;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5031z00_6117;
																																																						BgL_arg5031z00_6117
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_22348
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5031z00_6117));
																																																					}
																																																					if (BgL_testz00_22348)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5025z00_6111;
																																																							obj_t
																																																								BgL_arg5026z00_6112;
																																																							BgL_arg5025z00_6111
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6108));
																																																							BgL_arg5026z00_6112
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6108));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_22357;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_22359;
																																																									obj_t
																																																										BgL_bindingsz00_22358;
																																																									BgL_bindingsz00_22358
																																																										=
																																																										BgL_arg5025z00_6111;
																																																									BgL_exprz00_22359
																																																										=
																																																										BgL_arg5026z00_6112;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_22359;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_22358;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_22357);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_22361;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5030z00_6116;
																																																								BgL_arg5030z00_6116
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_22361
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5030z00_6116));
																																																							}
																																																							if (BgL_testz00_22361)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22366;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22366);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_22370;
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22370);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231546zd2_5844)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd231548zd2_5846;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd231546zd2_5844 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd231548zd2_5846;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if ((BgL_carzd231546zd2_5844 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd231548zd2_5846;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd231546zd2_5844)))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_kapzd231548zd2_5846;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd233153zd2_5852;
																																																										BgL_cdrzd233153zd2_5852
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_22386;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg4931z00_5969;
																																																												BgL_arg4931z00_5969
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_22386
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg4931z00_5969));
																																																											}
																																																											if (BgL_testz00_22386)
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg4859z00_5855;
																																																													obj_t
																																																														BgL_arg4860z00_5856;
																																																													BgL_arg4859z00_5855
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5852));
																																																													BgL_arg4860z00_5856
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5852));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_22395;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_22397;
																																																															obj_t
																																																																BgL_bindingsz00_22396;
																																																															BgL_bindingsz00_22396
																																																																=
																																																																BgL_arg4859z00_5855;
																																																															BgL_exprz00_22397
																																																																=
																																																																BgL_arg4860z00_5856;
																																																															BgL_exprz00_1724
																																																																=
																																																																BgL_exprz00_22397;
																																																															BgL_bindingsz00_1723
																																																																=
																																																																BgL_bindingsz00_22396;
																																																															goto
																																																																BgL_tagzd2382zd2_1725;
																																																														}
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_22395);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_testz00_22399;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg4930z00_5968;
																																																														BgL_arg4930z00_5968
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_testz00_22399
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg4930z00_5968));
																																																													}
																																																													if (BgL_testz00_22399)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_22404;
																																																															goto
																																																																BgL_tagzd2384zd2_1727;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22404);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd233219zd2_5859;
																																																															BgL_carzd233219zd2_5859
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd233224zd2_5860;
																																																																BgL_cdrzd233224zd2_5860
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd233219zd2_5859));
																																																																if ((CAR(((obj_t) BgL_carzd233219zd2_5859)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd233224zd2_5860))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg4866z00_5864;
																																																																				obj_t
																																																																					BgL_arg4867z00_5865;
																																																																				obj_t
																																																																					BgL_arg4868z00_5866;
																																																																				BgL_arg4866z00_5864
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd233224zd2_5860);
																																																																				BgL_arg4867z00_5865
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd233224zd2_5860);
																																																																				BgL_arg4868z00_5866
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22421;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_22424;
																																																																						obj_t
																																																																							BgL_bodyz00_22423;
																																																																						obj_t
																																																																							BgL_varsz00_22422;
																																																																						BgL_varsz00_22422
																																																																							=
																																																																							BgL_arg4866z00_5864;
																																																																						BgL_bodyz00_22423
																																																																							=
																																																																							BgL_arg4867z00_5865;
																																																																						BgL_argsz00_22424
																																																																							=
																																																																							BgL_arg4868z00_5866;
																																																																						BgL_argsz00_1734
																																																																							=
																																																																							BgL_argsz00_22424;
																																																																						BgL_bodyz00_1733
																																																																							=
																																																																							BgL_bodyz00_22423;
																																																																						BgL_varsz00_1732
																																																																							=
																																																																							BgL_varsz00_22422;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1735;
																																																																					}
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22421);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_22428;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_22428);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd233331zd2_5869;
																																																																		BgL_cdrzd233331zd2_5869
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd233336zd2_5870;
																																																																			BgL_cdrzd233336zd2_5870
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd233219zd2_5859));
																																																																			if ((CAR(((obj_t) BgL_carzd233219zd2_5859)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd233336zd2_5870))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd233341zd2_5874;
																																																																							BgL_cdrzd233341zd2_5874
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd233336zd2_5870);
																																																																							if (PAIRP(BgL_cdrzd233341zd2_5874))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd233345zd2_5876;
																																																																									obj_t
																																																																										BgL_cdrzd233346zd2_5877;
																																																																									BgL_carzd233345zd2_5876
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd233341zd2_5874);
																																																																									BgL_cdrzd233346zd2_5877
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd233341zd2_5874);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233345zd2_5876))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd233346zd2_5877))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd233351zd2_5880;
																																																																													BgL_carzd233351zd2_5880
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd233346zd2_5877);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233351zd2_5880))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(BgL_cdrzd233346zd2_5877)))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_testz00_22456;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1420z00_5913;
																																																																																		BgL_l1420z00_5913
																																																																																			=
																																																																																			BgL_cdrzd233331zd2_5869;
																																																																																	BgL_zc3anonymousza34894ze3z83_5914:
																																																																																		if (NULLP(BgL_l1420z00_5913))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_testz00_22456
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				bool_t
																																																																																					BgL_testz00_22459;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					bool_t
																																																																																						BgL_testz00_22460;
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_22461;
																																																																																						BgL_tmpz00_22461
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1420z00_5913));
																																																																																						BgL_testz00_22460
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_22461);
																																																																																					}
																																																																																					if (BgL_testz00_22460)
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_testz00_22459
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							BgL_testz00_22459
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_testz00_22459)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1420z00_22465;
																																																																																						BgL_l1420z00_22465
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1420z00_5913));
																																																																																						BgL_l1420z00_5913
																																																																																							=
																																																																																							BgL_l1420z00_22465;
																																																																																						goto
																																																																																							BgL_zc3anonymousza34894ze3z83_5914;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						BgL_testz00_22456
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_testz00_22456)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg4884z00_5896;
																																																																																			BgL_arg4884z00_5896
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd233336zd2_5870);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22469;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22473;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22472;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22471;
																																																																																					obj_t
																																																																																						BgL_testz00_22470;
																																																																																					BgL_testz00_22470
																																																																																						=
																																																																																						BgL_arg4884z00_5896;
																																																																																					BgL_proc1z00_22471
																																																																																						=
																																																																																						BgL_carzd233345zd2_5876;
																																																																																					BgL_proc2z00_22472
																																																																																						=
																																																																																						BgL_carzd233351zd2_5880;
																																																																																					BgL_argsz00_22473
																																																																																						=
																																																																																						BgL_cdrzd233331zd2_5869;
																																																																																					BgL_argsz00_1739
																																																																																						=
																																																																																						BgL_argsz00_22473;
																																																																																					BgL_proc2z00_1738
																																																																																						=
																																																																																						BgL_proc2z00_22472;
																																																																																					BgL_proc1z00_1737
																																																																																						=
																																																																																						BgL_proc1z00_22471;
																																																																																					BgL_testz00_1736
																																																																																						=
																																																																																						BgL_testz00_22470;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1740;
																																																																																				}
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22469);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd233376zd2_5897;
																																																																																			BgL_cdrzd233376zd2_5897
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_cdrzd233384zd2_5898;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_11891;
																																																																																					BgL_pairz00_11891
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd233384zd2_5898
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_11891);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_cdrzd233392zd2_5899;
																																																																																					BgL_cdrzd233392zd2_5899
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd233384zd2_5898));
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd233399zd2_5900;
																																																																																						BgL_carzd233399zd2_5900
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd233392zd2_5899));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233399zd2_5900))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_carzd233408zd2_5902;
																																																																																								{	/* Ast/sexp.scm 118 */
																																																																																									obj_t
																																																																																										BgL_pairz00_11895;
																																																																																									BgL_pairz00_11895
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd233392zd2_5899));
																																																																																									BgL_carzd233408zd2_5902
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_11895);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233408zd2_5902))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233376zd2_5897))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												obj_t
																																																																																													BgL_arg4888z00_5905;
																																																																																												BgL_arg4888z00_5905
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd233384zd2_5898));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_22495;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_22499;
																																																																																														obj_t
																																																																																															BgL_proc2z00_22498;
																																																																																														obj_t
																																																																																															BgL_proc1z00_22497;
																																																																																														obj_t
																																																																																															BgL_testz00_22496;
																																																																																														BgL_testz00_22496
																																																																																															=
																																																																																															BgL_arg4888z00_5905;
																																																																																														BgL_proc1z00_22497
																																																																																															=
																																																																																															BgL_carzd233399zd2_5900;
																																																																																														BgL_proc2z00_22498
																																																																																															=
																																																																																															BgL_carzd233408zd2_5902;
																																																																																														BgL_argsz00_22499
																																																																																															=
																																																																																															BgL_cdrzd233376zd2_5897;
																																																																																														BgL_argsz00_1744
																																																																																															=
																																																																																															BgL_argsz00_22499;
																																																																																														BgL_proc2z00_1743
																																																																																															=
																																																																																															BgL_proc2z00_22498;
																																																																																														BgL_proc1z00_1742
																																																																																															=
																																																																																															BgL_proc1z00_22497;
																																																																																														BgL_testz00_1741
																																																																																															=
																																																																																															BgL_testz00_22496;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1745;
																																																																																													}
																																																																																													BgL_auxz00_21992
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_22495);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 118 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1769;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_22503;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1770;
																																																																																														BgL_auxz00_21992
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_22503);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22507;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_21992
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22507);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22511;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_21992
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22511);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22515;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22515);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd233686zd2_5924;
																																																																															BgL_cdrzd233686zd2_5924
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd233693zd2_5925;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_11899;
																																																																																	BgL_pairz00_11899
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd233693zd2_5925
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_11899);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd233700zd2_5926;
																																																																																	BgL_cdrzd233700zd2_5926
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd233693zd2_5925));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd233706zd2_5927;
																																																																																		obj_t
																																																																																			BgL_cdrzd233707zd2_5928;
																																																																																		BgL_carzd233706zd2_5927
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5926));
																																																																																		BgL_cdrzd233707zd2_5928
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5926));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233706zd2_5927))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd233714zd2_5930;
																																																																																				BgL_carzd233714zd2_5930
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd233707zd2_5928));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233714zd2_5930))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd233707zd2_5928))))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233686zd2_5924))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg4903z00_5935;
																																																																																										BgL_arg4903z00_5935
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd233693zd2_5925));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_22542;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_22546;
																																																																																												obj_t
																																																																																													BgL_proc2z00_22545;
																																																																																												obj_t
																																																																																													BgL_proc1z00_22544;
																																																																																												obj_t
																																																																																													BgL_testz00_22543;
																																																																																												BgL_testz00_22543
																																																																																													=
																																																																																													BgL_arg4903z00_5935;
																																																																																												BgL_proc1z00_22544
																																																																																													=
																																																																																													BgL_carzd233706zd2_5927;
																																																																																												BgL_proc2z00_22545
																																																																																													=
																																																																																													BgL_carzd233714zd2_5930;
																																																																																												BgL_argsz00_22546
																																																																																													=
																																																																																													BgL_cdrzd233686zd2_5924;
																																																																																												BgL_argsz00_1744
																																																																																													=
																																																																																													BgL_argsz00_22546;
																																																																																												BgL_proc2z00_1743
																																																																																													=
																																																																																													BgL_proc2z00_22545;
																																																																																												BgL_proc1z00_1742
																																																																																													=
																																																																																													BgL_proc1z00_22544;
																																																																																												BgL_testz00_1741
																																																																																													=
																																																																																													BgL_testz00_22543;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1745;
																																																																																											}
																																																																																											BgL_auxz00_21992
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_22542);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22550;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_21992
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22550);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22554;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_21992
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22554);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22558;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22558);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22562;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22562);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22566;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22566);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd234047zd2_5943;
																																																																											BgL_cdrzd234047zd2_5943
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd234053zd2_5944;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_11909;
																																																																													BgL_pairz00_11909
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd234053zd2_5944
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11909);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd234059zd2_5945;
																																																																													BgL_cdrzd234059zd2_5945
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd234053zd2_5944));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd234064zd2_5946;
																																																																														obj_t
																																																																															BgL_cdrzd234065zd2_5947;
																																																																														BgL_carzd234064zd2_5946
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5945));
																																																																														BgL_cdrzd234065zd2_5947
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5945));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234064zd2_5946))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (PAIRP(BgL_cdrzd234065zd2_5947))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd234070zd2_5950;
																																																																																		BgL_carzd234070zd2_5950
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd234065zd2_5947);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234070zd2_5950))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(BgL_cdrzd234065zd2_5947)))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd234047zd2_5943))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg4917z00_5955;
																																																																																								BgL_arg4917z00_5955
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd234053zd2_5944));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22593;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_22597;
																																																																																										obj_t
																																																																																											BgL_proc2z00_22596;
																																																																																										obj_t
																																																																																											BgL_proc1z00_22595;
																																																																																										obj_t
																																																																																											BgL_testz00_22594;
																																																																																										BgL_testz00_22594
																																																																																											=
																																																																																											BgL_arg4917z00_5955;
																																																																																										BgL_proc1z00_22595
																																																																																											=
																																																																																											BgL_carzd234064zd2_5946;
																																																																																										BgL_proc2z00_22596
																																																																																											=
																																																																																											BgL_carzd234070zd2_5950;
																																																																																										BgL_argsz00_22597
																																																																																											=
																																																																																											BgL_cdrzd234047zd2_5943;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_argsz00_22597;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_proc2z00_22596;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_proc1z00_22595;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_testz00_22594;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1745;
																																																																																									}
																																																																																									BgL_auxz00_21992
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22593);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22601;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_21992
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22601);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22605;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22605);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22609;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22609);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22613;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22613);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22617;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22617);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22621;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22621);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22625;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22625);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_22629;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_22629);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd234608zd2_6119;
																																															BgL_cdrzd234608zd2_6119
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd231543zd2_5842 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5033z00_6121;
																																																	obj_t
																																																		BgL_arg5034z00_6122;
																																																	BgL_arg5033z00_6121
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6119));
																																																	BgL_arg5034z00_6122
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6119));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_22640;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_22642;
																																																			obj_t
																																																				BgL_bindingsz00_22641;
																																																			BgL_bindingsz00_22641
																																																				=
																																																				BgL_arg5033z00_6121;
																																																			BgL_exprz00_22642
																																																				=
																																																				BgL_arg5034z00_6122;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_22642;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_22641;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_22640);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231543zd2_5842)))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5036z00_6124;
																																																			obj_t
																																																				BgL_arg5037z00_6125;
																																																			BgL_arg5036z00_6124
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6119));
																																																			BgL_arg5037z00_6125
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6119));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_22651;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_22653;
																																																					obj_t
																																																						BgL_bindingsz00_22652;
																																																					BgL_bindingsz00_22652
																																																						=
																																																						BgL_arg5036z00_6124;
																																																					BgL_exprz00_22653
																																																						=
																																																						BgL_arg5037z00_6125;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_22653;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_22652;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_21992
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_22651);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((BgL_carzd231543zd2_5842 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5039z00_6127;
																																																					obj_t
																																																						BgL_arg5040z00_6128;
																																																					BgL_arg5039z00_6127
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6119));
																																																					BgL_arg5040z00_6128
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6119));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_22662;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_22664;
																																																							obj_t
																																																								BgL_bindingsz00_22663;
																																																							BgL_bindingsz00_22663
																																																								=
																																																								BgL_arg5039z00_6127;
																																																							BgL_exprz00_22664
																																																								=
																																																								BgL_arg5040z00_6128;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_22664;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_22663;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_22662);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22671;
																																																							goto
																																																								BgL_tagzd2383zd2_1726;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22671);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd234645zd2_6131;
																																																							BgL_carzd234645zd2_6131
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd234645zd2_6131 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22678;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22678);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234645zd2_6131)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22683;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22683);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22690;
																																																													goto
																																																														BgL_tagzd2389zd2_1746;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22690);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22697;
																																																															goto
																																																																BgL_tagzd2390zd2_1747;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22697);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd234725zd2_6138;
																																																															BgL_cdrzd234725zd2_6138
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg5051z00_6141;
																																																																	obj_t
																																																																		BgL_arg5052z00_6142;
																																																																	BgL_arg5051z00_6141
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6138));
																																																																	BgL_arg5052z00_6142
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6138));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_22710;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_22712;
																																																																			obj_t
																																																																				BgL_effectz00_22711;
																																																																			BgL_effectz00_22711
																																																																				=
																																																																				BgL_arg5051z00_6141;
																																																																			BgL_restz00_22712
																																																																				=
																																																																				BgL_arg5052z00_6142;
																																																																			BgL_restz00_1749
																																																																				=
																																																																				BgL_restz00_22712;
																																																																			BgL_effectz00_1748
																																																																				=
																																																																				BgL_effectz00_22711;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1750;
																																																																		}
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_22710);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22719;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1751;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22719);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22726;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1752;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22726);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg5059z00_6150;
																																																																							obj_t
																																																																								BgL_arg5060z00_6151;
																																																																							BgL_arg5059z00_6150
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6138));
																																																																							BgL_arg5060z00_6151
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6138));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_22737;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_22739;
																																																																									obj_t
																																																																										BgL_effectz00_22738;
																																																																									BgL_effectz00_22738
																																																																										=
																																																																										BgL_arg5059z00_6150;
																																																																									BgL_restz00_22739
																																																																										=
																																																																										BgL_arg5060z00_6151;
																																																																									BgL_restz00_1754
																																																																										=
																																																																										BgL_restz00_22739;
																																																																									BgL_effectz00_1753
																																																																										=
																																																																										BgL_effectz00_22738;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1755;
																																																																								}
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_22737);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22746;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1756;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22746);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22753;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1757;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22753);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_22760;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1758;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22760);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_22767;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1759;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22767);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd234802zd2_6160;
																																																																															BgL_cdrzd234802zd2_6160
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5071z00_6163;
																																																																																	obj_t
																																																																																		BgL_arg5072z00_6164;
																																																																																	BgL_arg5071z00_6163
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6160));
																																																																																	BgL_arg5072z00_6164
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6160));
																																																																																	{	/* Ast/sexp.scm 563 */
																																																																																		obj_t
																																																																																			BgL_arg7000z00_11948;
																																																																																		BgL_arg7000z00_11948
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg5071z00_6163,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg5072z00_6164, BgL_stackz00_22, BgL_arg7000z00_11948, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22786;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22786);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd234827zd2_6181;
																																			BgL_carzd234827zd2_6181
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd234827zd2_6181
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_22793;
																																					goto
																																						BgL_tagzd2377zd2_1714;
																																					BgL_auxz00_21992
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_22793);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd234827zd2_6181
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22797;
																																							goto
																																								BgL_tagzd2377zd2_1714;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22797);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22804;
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																									BgL_auxz00_21992
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22804);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22811;
																																											goto
																																												BgL_tagzd2380zd2_1719;
																																											BgL_auxz00_21992
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22811);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd234896zd2_6188;
																																											BgL_carzd234896zd2_6188
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd234896zd2_6188))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd234899zd2_6190;
																																													obj_t
																																														BgL_cdrzd234900zd2_6191;
																																													BgL_carzd234899zd2_6190
																																														=
																																														CAR
																																														(BgL_carzd234896zd2_6188);
																																													BgL_cdrzd234900zd2_6191
																																														=
																																														CDR
																																														(BgL_carzd234896zd2_6188);
																																													{

																																														if ((BgL_carzd234899zd2_6190 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 118 */
																																															BgL_kapzd234901zd2_6192:
																																																if (PAIRP(BgL_cdrzd234900zd2_6191))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd234904zd2_6317;
																																																		BgL_cdrzd234904zd2_6317
																																																			=
																																																			CDR
																																																			(BgL_cdrzd234900zd2_6191);
																																																		if (PAIRP(BgL_cdrzd234904zd2_6317))
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (NULLP(CDR(BgL_cdrzd234904zd2_6317)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5179z00_6321;
																																																						obj_t
																																																							BgL_arg5180z00_6322;
																																																						BgL_arg5179z00_6321
																																																							=
																																																							CAR
																																																							(BgL_cdrzd234904zd2_6317);
																																																						BgL_arg5180z00_6322
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22833;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_22835;
																																																								obj_t
																																																									BgL_bodyz00_22834;
																																																								BgL_bodyz00_22834
																																																									=
																																																									BgL_arg5179z00_6321;
																																																								BgL_argsz00_22835
																																																									=
																																																									BgL_arg5180z00_6322;
																																																								BgL_argsz00_1721
																																																									=
																																																									BgL_argsz00_22835;
																																																								BgL_bodyz00_1720
																																																									=
																																																									BgL_bodyz00_22834;
																																																								goto
																																																									BgL_tagzd2381zd2_1722;
																																																							}
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22833);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd234928zd2_6323;
																																																						BgL_cdrzd234928zd2_6323
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_22839;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5249z00_6434;
																																																								BgL_arg5249z00_6434
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_22839
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5249z00_6434));
																																																							}
																																																							if (BgL_testz00_22839)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg5183z00_6326;
																																																									obj_t
																																																										BgL_arg5184z00_6327;
																																																									BgL_arg5183z00_6326
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6323));
																																																									BgL_arg5184z00_6327
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6323));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22848;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22850;
																																																											obj_t
																																																												BgL_bindingsz00_22849;
																																																											BgL_bindingsz00_22849
																																																												=
																																																												BgL_arg5183z00_6326;
																																																											BgL_exprz00_22850
																																																												=
																																																												BgL_arg5184z00_6327;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_22850;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_22849;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_21992
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22848);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_22852;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5248z00_6433;
																																																										BgL_arg5248z00_6433
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_22852
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5248z00_6433));
																																																									}
																																																									if (BgL_testz00_22852)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22857;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22857);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd234995zd2_6330;
																																																											BgL_carzd234995zd2_6330
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd235000zd2_6331;
																																																												BgL_cdrzd235000zd2_6331
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd234995zd2_6330));
																																																												if ((CAR(((obj_t) BgL_carzd234995zd2_6330)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg5189z00_6334;
																																																														obj_t
																																																															BgL_arg5190z00_6335;
																																																														obj_t
																																																															BgL_arg5191z00_6336;
																																																														BgL_arg5189z00_6334
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6331));
																																																														BgL_arg5190z00_6335
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6331));
																																																														BgL_arg5191z00_6336
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22874;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22877;
																																																																obj_t
																																																																	BgL_bodyz00_22876;
																																																																obj_t
																																																																	BgL_varsz00_22875;
																																																																BgL_varsz00_22875
																																																																	=
																																																																	BgL_arg5189z00_6334;
																																																																BgL_bodyz00_22876
																																																																	=
																																																																	BgL_arg5190z00_6335;
																																																																BgL_argsz00_22877
																																																																	=
																																																																	BgL_arg5191z00_6336;
																																																																BgL_argsz00_1734
																																																																	=
																																																																	BgL_argsz00_22877;
																																																																BgL_bodyz00_1733
																																																																	=
																																																																	BgL_bodyz00_22876;
																																																																BgL_varsz00_1732
																																																																	=
																																																																	BgL_varsz00_22875;
																																																																goto
																																																																	BgL_tagzd2386zd2_1735;
																																																															}
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22874);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd235023zd2_6338;
																																																														BgL_cdrzd235023zd2_6338
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd235029zd2_6339;
																																																															BgL_cdrzd235029zd2_6339
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd234995zd2_6330));
																																																															if ((CAR(((obj_t) BgL_carzd234995zd2_6330)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd235035zd2_6342;
																																																																	BgL_cdrzd235035zd2_6342
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd235029zd2_6339));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd235040zd2_6343;
																																																																		obj_t
																																																																			BgL_cdrzd235041zd2_6344;
																																																																		BgL_carzd235040zd2_6343
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6342));
																																																																		BgL_cdrzd235041zd2_6344
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6342));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235040zd2_6343))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (PAIRP(BgL_cdrzd235041zd2_6344))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd235048zd2_6347;
																																																																						BgL_carzd235048zd2_6347
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd235041zd2_6344);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235048zd2_6347))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(BgL_cdrzd235041zd2_6344)))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_testz00_22904;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1423z00_6380;
																																																																											BgL_l1423z00_6380
																																																																												=
																																																																												BgL_cdrzd235023zd2_6338;
																																																																										BgL_zc3anonymousza35214ze3z83_6381:
																																																																											if (NULLP(BgL_l1423z00_6380))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_testz00_22904
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_testz00_22907;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_testz00_22908;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_tmpz00_22909;
																																																																															BgL_tmpz00_22909
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1423z00_6380));
																																																																															BgL_testz00_22908
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_22909);
																																																																														}
																																																																														if (BgL_testz00_22908)
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_22907
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_22907
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_testz00_22907)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1423z00_22913;
																																																																															BgL_l1423z00_22913
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1423z00_6380));
																																																																															BgL_l1423z00_6380
																																																																																=
																																																																																BgL_l1423z00_22913;
																																																																															goto
																																																																																BgL_zc3anonymousza35214ze3z83_6381;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_testz00_22904
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_testz00_22904)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg5204z00_6363;
																																																																												BgL_arg5204z00_6363
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd235029zd2_6339));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22918;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_22922;
																																																																														obj_t
																																																																															BgL_proc2z00_22921;
																																																																														obj_t
																																																																															BgL_proc1z00_22920;
																																																																														obj_t
																																																																															BgL_testz00_22919;
																																																																														BgL_testz00_22919
																																																																															=
																																																																															BgL_arg5204z00_6363;
																																																																														BgL_proc1z00_22920
																																																																															=
																																																																															BgL_carzd235040zd2_6343;
																																																																														BgL_proc2z00_22921
																																																																															=
																																																																															BgL_carzd235048zd2_6347;
																																																																														BgL_argsz00_22922
																																																																															=
																																																																															BgL_cdrzd235023zd2_6338;
																																																																														BgL_argsz00_1739
																																																																															=
																																																																															BgL_argsz00_22922;
																																																																														BgL_proc2z00_1738
																																																																															=
																																																																															BgL_proc2z00_22921;
																																																																														BgL_proc1z00_1737
																																																																															=
																																																																															BgL_proc1z00_22920;
																																																																														BgL_testz00_1736
																																																																															=
																																																																															BgL_testz00_22919;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1740;
																																																																													}
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22918);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd235072zd2_6364;
																																																																												BgL_cdrzd235072zd2_6364
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd235079zd2_6365;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_11992;
																																																																														BgL_pairz00_11992
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd235079zd2_6365
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_11992);
																																																																													}
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd235086zd2_6366;
																																																																														BgL_cdrzd235086zd2_6366
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd235079zd2_6365));
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd235092zd2_6367;
																																																																															BgL_carzd235092zd2_6367
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd235086zd2_6366));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235092zd2_6367))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_carzd235099zd2_6369;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_pairz00_11996;
																																																																																		BgL_pairz00_11996
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd235086zd2_6366));
																																																																																		BgL_carzd235099zd2_6369
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_11996);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235099zd2_6369))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235072zd2_6364))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_arg5208z00_6372;
																																																																																					BgL_arg5208z00_6372
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd235079zd2_6365));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22944;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22948;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22947;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22946;
																																																																																							obj_t
																																																																																								BgL_testz00_22945;
																																																																																							BgL_testz00_22945
																																																																																								=
																																																																																								BgL_arg5208z00_6372;
																																																																																							BgL_proc1z00_22946
																																																																																								=
																																																																																								BgL_carzd235092zd2_6367;
																																																																																							BgL_proc2z00_22947
																																																																																								=
																																																																																								BgL_carzd235099zd2_6369;
																																																																																							BgL_argsz00_22948
																																																																																								=
																																																																																								BgL_cdrzd235072zd2_6364;
																																																																																							BgL_argsz00_1744
																																																																																								=
																																																																																								BgL_argsz00_22948;
																																																																																							BgL_proc2z00_1743
																																																																																								=
																																																																																								BgL_proc2z00_22947;
																																																																																							BgL_proc1z00_1742
																																																																																								=
																																																																																								BgL_proc1z00_22946;
																																																																																							BgL_testz00_1741
																																																																																								=
																																																																																								BgL_testz00_22945;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1745;
																																																																																						}
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22944);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1769;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22952;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1770;
																																																																																							BgL_auxz00_21992
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22952);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22956;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22956);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22960;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22960);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_22964;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_22964);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd235375zd2_6391;
																																																																								BgL_cdrzd235375zd2_6391
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd235381zd2_6392;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12000;
																																																																										BgL_pairz00_12000
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd235381zd2_6392
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12000);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd235387zd2_6393;
																																																																										BgL_cdrzd235387zd2_6393
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd235381zd2_6392));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd235392zd2_6394;
																																																																											obj_t
																																																																												BgL_cdrzd235393zd2_6395;
																																																																											BgL_carzd235392zd2_6394
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6393));
																																																																											BgL_cdrzd235393zd2_6395
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6393));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235392zd2_6394))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd235398zd2_6397;
																																																																													BgL_carzd235398zd2_6397
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd235393zd2_6395));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235398zd2_6397))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd235393zd2_6395))))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235375zd2_6391))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg5223z00_6402;
																																																																																			BgL_arg5223z00_6402
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd235381zd2_6392));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22991;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22995;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22994;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22993;
																																																																																					obj_t
																																																																																						BgL_testz00_22992;
																																																																																					BgL_testz00_22992
																																																																																						=
																																																																																						BgL_arg5223z00_6402;
																																																																																					BgL_proc1z00_22993
																																																																																						=
																																																																																						BgL_carzd235392zd2_6394;
																																																																																					BgL_proc2z00_22994
																																																																																						=
																																																																																						BgL_carzd235398zd2_6397;
																																																																																					BgL_argsz00_22995
																																																																																						=
																																																																																						BgL_cdrzd235375zd2_6391;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_22995;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_22994;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_22993;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_22992;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22991);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22999;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22999);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23003;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23003);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23007;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23007);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23011;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23011);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_23015;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_23015);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd235731zd2_6410;
																																																																				BgL_cdrzd235731zd2_6410
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd235738zd2_6411;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12010;
																																																																						BgL_pairz00_12010
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd235738zd2_6411
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12010);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd235745zd2_6412;
																																																																						BgL_cdrzd235745zd2_6412
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd235738zd2_6411));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd235751zd2_6413;
																																																																							obj_t
																																																																								BgL_cdrzd235752zd2_6414;
																																																																							BgL_carzd235751zd2_6413
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6412));
																																																																							BgL_cdrzd235752zd2_6414
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6412));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235751zd2_6413))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd235752zd2_6414))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd235759zd2_6417;
																																																																											BgL_carzd235759zd2_6417
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd235752zd2_6414);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235759zd2_6417))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd235752zd2_6414)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235731zd2_6410))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5237z00_6422;
																																																																																	BgL_arg5237z00_6422
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd235738zd2_6411));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23042;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23046;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23045;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23044;
																																																																																			obj_t
																																																																																				BgL_testz00_23043;
																																																																																			BgL_testz00_23043
																																																																																				=
																																																																																				BgL_arg5237z00_6422;
																																																																																			BgL_proc1z00_23044
																																																																																				=
																																																																																				BgL_carzd235751zd2_6413;
																																																																																			BgL_proc2z00_23045
																																																																																				=
																																																																																				BgL_carzd235759zd2_6417;
																																																																																			BgL_argsz00_23046
																																																																																				=
																																																																																				BgL_cdrzd235731zd2_6410;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_23046;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_23045;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_23044;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_23043;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23042);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23050;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23050);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23054;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23054);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23058;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23058);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23062;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23062);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23066;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23066);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23070;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23070);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd236152zd2_6436;
																																																				BgL_cdrzd236152zd2_6436
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_23074;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5265z00_6453;
																																																						BgL_arg5265z00_6453
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_23074
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5265z00_6453));
																																																					}
																																																					if (BgL_testz00_23074)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5253z00_6439;
																																																							obj_t
																																																								BgL_arg5254z00_6440;
																																																							BgL_arg5253z00_6439
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6436));
																																																							BgL_arg5254z00_6440
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6436));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23083;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23085;
																																																									obj_t
																																																										BgL_bindingsz00_23084;
																																																									BgL_bindingsz00_23084
																																																										=
																																																										BgL_arg5253z00_6439;
																																																									BgL_exprz00_23085
																																																										=
																																																										BgL_arg5254z00_6440;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_23085;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_23084;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23083);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_23087;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5264z00_6452;
																																																								BgL_arg5264z00_6452
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_23087
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5264z00_6452));
																																																							}
																																																							if (BgL_testz00_23087)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23092;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23092);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd236218zd2_6443;
																																																									BgL_carzd236218zd2_6443
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd236223zd2_6444;
																																																										BgL_cdrzd236223zd2_6444
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd236218zd2_6443));
																																																										if ((CAR(((obj_t) BgL_carzd236218zd2_6443)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5259z00_6447;
																																																												obj_t
																																																													BgL_arg5260z00_6448;
																																																												obj_t
																																																													BgL_arg5261z00_6449;
																																																												BgL_arg5259z00_6447
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6444));
																																																												BgL_arg5260z00_6448
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6444));
																																																												BgL_arg5261z00_6449
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23109;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23112;
																																																														obj_t
																																																															BgL_bodyz00_23111;
																																																														obj_t
																																																															BgL_varsz00_23110;
																																																														BgL_varsz00_23110
																																																															=
																																																															BgL_arg5259z00_6447;
																																																														BgL_bodyz00_23111
																																																															=
																																																															BgL_arg5260z00_6448;
																																																														BgL_argsz00_23112
																																																															=
																																																															BgL_arg5261z00_6449;
																																																														BgL_argsz00_1734
																																																															=
																																																															BgL_argsz00_23112;
																																																														BgL_bodyz00_1733
																																																															=
																																																															BgL_bodyz00_23111;
																																																														BgL_varsz00_1732
																																																															=
																																																															BgL_varsz00_23110;
																																																														goto
																																																															BgL_tagzd2386zd2_1735;
																																																													}
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23109);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_23116;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_23116);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd236334zd2_6454;
																																																		BgL_cdrzd236334zd2_6454
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_23120;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5274z00_6463;
																																																				BgL_arg5274z00_6463
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_23120
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5274z00_6463));
																																																			}
																																																			if (BgL_testz00_23120)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5268z00_6457;
																																																					obj_t
																																																						BgL_arg5269z00_6458;
																																																					BgL_arg5268z00_6457
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6454));
																																																					BgL_arg5269z00_6458
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6454));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23129;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23131;
																																																							obj_t
																																																								BgL_bindingsz00_23130;
																																																							BgL_bindingsz00_23130
																																																								=
																																																								BgL_arg5268z00_6457;
																																																							BgL_exprz00_23131
																																																								=
																																																								BgL_arg5269z00_6458;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_23131;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_23130;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23129);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_23133;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5273z00_6462;
																																																						BgL_arg5273z00_6462
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_23133
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5273z00_6462));
																																																					}
																																																					if (BgL_testz00_23133)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23138;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23138);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2403zd2_1769;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_23142;
																																																									goto
																																																										BgL_tagzd2404zd2_1770;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23142);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234899zd2_6190)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd234901zd2_6192;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd234899zd2_6190 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd234901zd2_6192;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if ((BgL_carzd234899zd2_6190 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd234901zd2_6192;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234899zd2_6190)))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_kapzd234901zd2_6192;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd236506zd2_6198;
																																																								BgL_cdrzd236506zd2_6198
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_23158;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5174z00_6315;
																																																										BgL_arg5174z00_6315
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_23158
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5174z00_6315));
																																																									}
																																																									if (BgL_testz00_23158)
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg5102z00_6201;
																																																											obj_t
																																																												BgL_arg5103z00_6202;
																																																											BgL_arg5102z00_6201
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6198));
																																																											BgL_arg5103z00_6202
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6198));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23167;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_23169;
																																																													obj_t
																																																														BgL_bindingsz00_23168;
																																																													BgL_bindingsz00_23168
																																																														=
																																																														BgL_arg5102z00_6201;
																																																													BgL_exprz00_23169
																																																														=
																																																														BgL_arg5103z00_6202;
																																																													BgL_exprz00_1724
																																																														=
																																																														BgL_exprz00_23169;
																																																													BgL_bindingsz00_1723
																																																														=
																																																														BgL_bindingsz00_23168;
																																																													goto
																																																														BgL_tagzd2382zd2_1725;
																																																												}
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23167);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											bool_t
																																																												BgL_testz00_23171;
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5173z00_6314;
																																																												BgL_arg5173z00_6314
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_testz00_23171
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5173z00_6314));
																																																											}
																																																											if (BgL_testz00_23171)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_23176;
																																																													goto
																																																														BgL_tagzd2384zd2_1727;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23176);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd236572zd2_6205;
																																																													BgL_carzd236572zd2_6205
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd236577zd2_6206;
																																																														BgL_cdrzd236577zd2_6206
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd236572zd2_6205));
																																																														if ((CAR(((obj_t) BgL_carzd236572zd2_6205)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd236577zd2_6206))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg5109z00_6210;
																																																																		obj_t
																																																																			BgL_arg5110z00_6211;
																																																																		obj_t
																																																																			BgL_arg5111z00_6212;
																																																																		BgL_arg5109z00_6210
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd236577zd2_6206);
																																																																		BgL_arg5110z00_6211
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd236577zd2_6206);
																																																																		BgL_arg5111z00_6212
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23193;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_23196;
																																																																				obj_t
																																																																					BgL_bodyz00_23195;
																																																																				obj_t
																																																																					BgL_varsz00_23194;
																																																																				BgL_varsz00_23194
																																																																					=
																																																																					BgL_arg5109z00_6210;
																																																																				BgL_bodyz00_23195
																																																																					=
																																																																					BgL_arg5110z00_6211;
																																																																				BgL_argsz00_23196
																																																																					=
																																																																					BgL_arg5111z00_6212;
																																																																				BgL_argsz00_1734
																																																																					=
																																																																					BgL_argsz00_23196;
																																																																				BgL_bodyz00_1733
																																																																					=
																																																																					BgL_bodyz00_23195;
																																																																				BgL_varsz00_1732
																																																																					=
																																																																					BgL_varsz00_23194;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1735;
																																																																			}
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23193);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_23200;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_23200);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd236684zd2_6215;
																																																																BgL_cdrzd236684zd2_6215
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd236689zd2_6216;
																																																																	BgL_cdrzd236689zd2_6216
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd236572zd2_6205));
																																																																	if ((CAR(((obj_t) BgL_carzd236572zd2_6205)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd236689zd2_6216))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd236694zd2_6220;
																																																																					BgL_cdrzd236694zd2_6220
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd236689zd2_6216);
																																																																					if (PAIRP(BgL_cdrzd236694zd2_6220))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd236698zd2_6222;
																																																																							obj_t
																																																																								BgL_cdrzd236699zd2_6223;
																																																																							BgL_carzd236698zd2_6222
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd236694zd2_6220);
																																																																							BgL_cdrzd236699zd2_6223
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd236694zd2_6220);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236698zd2_6222))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (PAIRP(BgL_cdrzd236699zd2_6223))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd236704zd2_6226;
																																																																											BgL_carzd236704zd2_6226
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd236699zd2_6223);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236704zd2_6226))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(BgL_cdrzd236699zd2_6223)))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_testz00_23228;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1426z00_6259;
																																																																																BgL_l1426z00_6259
																																																																																	=
																																																																																	BgL_cdrzd236684zd2_6215;
																																																																															BgL_zc3anonymousza35137ze3z83_6260:
																																																																																if (NULLP(BgL_l1426z00_6259))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_23228
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		bool_t
																																																																																			BgL_testz00_23231;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			bool_t
																																																																																				BgL_testz00_23232;
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_23233;
																																																																																				BgL_tmpz00_23233
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1426z00_6259));
																																																																																				BgL_testz00_23232
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_23233);
																																																																																			}
																																																																																			if (BgL_testz00_23232)
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_testz00_23231
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					BgL_testz00_23231
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_testz00_23231)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1426z00_23237;
																																																																																				BgL_l1426z00_23237
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1426z00_6259));
																																																																																				BgL_l1426z00_6259
																																																																																					=
																																																																																					BgL_l1426z00_23237;
																																																																																				goto
																																																																																					BgL_zc3anonymousza35137ze3z83_6260;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				BgL_testz00_23228
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_testz00_23228)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5127z00_6242;
																																																																																	BgL_arg5127z00_6242
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd236689zd2_6216);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23241;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23245;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23244;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23243;
																																																																																			obj_t
																																																																																				BgL_testz00_23242;
																																																																																			BgL_testz00_23242
																																																																																				=
																																																																																				BgL_arg5127z00_6242;
																																																																																			BgL_proc1z00_23243
																																																																																				=
																																																																																				BgL_carzd236698zd2_6222;
																																																																																			BgL_proc2z00_23244
																																																																																				=
																																																																																				BgL_carzd236704zd2_6226;
																																																																																			BgL_argsz00_23245
																																																																																				=
																																																																																				BgL_cdrzd236684zd2_6215;
																																																																																			BgL_argsz00_1739
																																																																																				=
																																																																																				BgL_argsz00_23245;
																																																																																			BgL_proc2z00_1738
																																																																																				=
																																																																																				BgL_proc2z00_23244;
																																																																																			BgL_proc1z00_1737
																																																																																				=
																																																																																				BgL_proc1z00_23243;
																																																																																			BgL_testz00_1736
																																																																																				=
																																																																																				BgL_testz00_23242;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1740;
																																																																																		}
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23241);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd236729zd2_6243;
																																																																																	BgL_cdrzd236729zd2_6243
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_cdrzd236737zd2_6244;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12067;
																																																																																			BgL_pairz00_12067
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd236737zd2_6244
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_12067);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_cdrzd236745zd2_6245;
																																																																																			BgL_cdrzd236745zd2_6245
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd236737zd2_6244));
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd236752zd2_6246;
																																																																																				BgL_carzd236752zd2_6246
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd236745zd2_6245));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236752zd2_6246))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_carzd236761zd2_6248;
																																																																																						{	/* Ast/sexp.scm 118 */
																																																																																							obj_t
																																																																																								BgL_pairz00_12071;
																																																																																							BgL_pairz00_12071
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd236745zd2_6245));
																																																																																							BgL_carzd236761zd2_6248
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_12071);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236761zd2_6248))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd236729zd2_6243))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										obj_t
																																																																																											BgL_arg5131z00_6251;
																																																																																										BgL_arg5131z00_6251
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd236737zd2_6244));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_23267;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_23271;
																																																																																												obj_t
																																																																																													BgL_proc2z00_23270;
																																																																																												obj_t
																																																																																													BgL_proc1z00_23269;
																																																																																												obj_t
																																																																																													BgL_testz00_23268;
																																																																																												BgL_testz00_23268
																																																																																													=
																																																																																													BgL_arg5131z00_6251;
																																																																																												BgL_proc1z00_23269
																																																																																													=
																																																																																													BgL_carzd236752zd2_6246;
																																																																																												BgL_proc2z00_23270
																																																																																													=
																																																																																													BgL_carzd236761zd2_6248;
																																																																																												BgL_argsz00_23271
																																																																																													=
																																																																																													BgL_cdrzd236729zd2_6243;
																																																																																												BgL_argsz00_1744
																																																																																													=
																																																																																													BgL_argsz00_23271;
																																																																																												BgL_proc2z00_1743
																																																																																													=
																																																																																													BgL_proc2z00_23270;
																																																																																												BgL_proc1z00_1742
																																																																																													=
																																																																																													BgL_proc1z00_23269;
																																																																																												BgL_testz00_1741
																																																																																													=
																																																																																													BgL_testz00_23268;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1745;
																																																																																											}
																																																																																											BgL_auxz00_21992
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_23267);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 118 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1769;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_23275;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1770;
																																																																																												BgL_auxz00_21992
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_23275);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23279;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_21992
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23279);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23283;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23283);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23287;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23287);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd237039zd2_6270;
																																																																													BgL_cdrzd237039zd2_6270
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd237046zd2_6271;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_12075;
																																																																															BgL_pairz00_12075
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd237046zd2_6271
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12075);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd237053zd2_6272;
																																																																															BgL_cdrzd237053zd2_6272
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd237046zd2_6271));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd237059zd2_6273;
																																																																																obj_t
																																																																																	BgL_cdrzd237060zd2_6274;
																																																																																BgL_carzd237059zd2_6273
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6272));
																																																																																BgL_cdrzd237060zd2_6274
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6272));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237059zd2_6273))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd237067zd2_6276;
																																																																																		BgL_carzd237067zd2_6276
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd237060zd2_6274));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237067zd2_6276))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd237060zd2_6274))))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237039zd2_6270))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg5146z00_6281;
																																																																																								BgL_arg5146z00_6281
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd237046zd2_6271));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_23314;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_23318;
																																																																																										obj_t
																																																																																											BgL_proc2z00_23317;
																																																																																										obj_t
																																																																																											BgL_proc1z00_23316;
																																																																																										obj_t
																																																																																											BgL_testz00_23315;
																																																																																										BgL_testz00_23315
																																																																																											=
																																																																																											BgL_arg5146z00_6281;
																																																																																										BgL_proc1z00_23316
																																																																																											=
																																																																																											BgL_carzd237059zd2_6273;
																																																																																										BgL_proc2z00_23317
																																																																																											=
																																																																																											BgL_carzd237067zd2_6276;
																																																																																										BgL_argsz00_23318
																																																																																											=
																																																																																											BgL_cdrzd237039zd2_6270;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_argsz00_23318;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_proc2z00_23317;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_proc1z00_23316;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_testz00_23315;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1745;
																																																																																									}
																																																																																									BgL_auxz00_21992
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_23314);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23322;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_21992
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23322);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23326;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23326);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23330;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23330);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23334;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23334);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23338;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23338);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd237400zd2_6289;
																																																																									BgL_cdrzd237400zd2_6289
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd237406zd2_6290;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12085;
																																																																											BgL_pairz00_12085
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd237406zd2_6290
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12085);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd237412zd2_6291;
																																																																											BgL_cdrzd237412zd2_6291
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd237406zd2_6290));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd237417zd2_6292;
																																																																												obj_t
																																																																													BgL_cdrzd237418zd2_6293;
																																																																												BgL_carzd237417zd2_6292
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6291));
																																																																												BgL_cdrzd237418zd2_6293
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6291));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237417zd2_6292))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (PAIRP(BgL_cdrzd237418zd2_6293))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd237423zd2_6296;
																																																																																BgL_carzd237423zd2_6296
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd237418zd2_6293);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237423zd2_6296))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(BgL_cdrzd237418zd2_6293)))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237400zd2_6289))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg5160z00_6301;
																																																																																						BgL_arg5160z00_6301
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd237406zd2_6290));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23365;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_23369;
																																																																																								obj_t
																																																																																									BgL_proc2z00_23368;
																																																																																								obj_t
																																																																																									BgL_proc1z00_23367;
																																																																																								obj_t
																																																																																									BgL_testz00_23366;
																																																																																								BgL_testz00_23366
																																																																																									=
																																																																																									BgL_arg5160z00_6301;
																																																																																								BgL_proc1z00_23367
																																																																																									=
																																																																																									BgL_carzd237417zd2_6292;
																																																																																								BgL_proc2z00_23368
																																																																																									=
																																																																																									BgL_carzd237423zd2_6296;
																																																																																								BgL_argsz00_23369
																																																																																									=
																																																																																									BgL_cdrzd237400zd2_6289;
																																																																																								BgL_argsz00_1744
																																																																																									=
																																																																																									BgL_argsz00_23369;
																																																																																								BgL_proc2z00_1743
																																																																																									=
																																																																																									BgL_proc2z00_23368;
																																																																																								BgL_proc1z00_1742
																																																																																									=
																																																																																									BgL_proc1z00_23367;
																																																																																								BgL_testz00_1741
																																																																																									=
																																																																																									BgL_testz00_23366;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1745;
																																																																																							}
																																																																																							BgL_auxz00_21992
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23365);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23373;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23373);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23377;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23377);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23381;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23381);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23385;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23385);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23389;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23389);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23393;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23393);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23397;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23397);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_23401;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_23401);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_cdrzd237961zd2_6465;
																																													BgL_cdrzd237961zd2_6465
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd234896zd2_6188 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg5276z00_6467;
																																															obj_t
																																																BgL_arg5277z00_6468;
																																															BgL_arg5276z00_6467
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6465));
																																															BgL_arg5277z00_6468
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6465));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_23412;
																																																{
																																																	obj_t
																																																		BgL_exprz00_23414;
																																																	obj_t
																																																		BgL_bindingsz00_23413;
																																																	BgL_bindingsz00_23413
																																																		=
																																																		BgL_arg5276z00_6467;
																																																	BgL_exprz00_23414
																																																		=
																																																		BgL_arg5277z00_6468;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_23414;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_23413;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_23412);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234896zd2_6188)))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5279z00_6470;
																																																	obj_t
																																																		BgL_arg5280z00_6471;
																																																	BgL_arg5279z00_6470
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6465));
																																																	BgL_arg5280z00_6471
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6465));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_23423;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_23425;
																																																			obj_t
																																																				BgL_bindingsz00_23424;
																																																			BgL_bindingsz00_23424
																																																				=
																																																				BgL_arg5279z00_6470;
																																																			BgL_exprz00_23425
																																																				=
																																																				BgL_arg5280z00_6471;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_23425;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_23424;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_23423);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((BgL_carzd234896zd2_6188 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5282z00_6473;
																																																			obj_t
																																																				BgL_arg5283z00_6474;
																																																			BgL_arg5282z00_6473
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6465));
																																																			BgL_arg5283z00_6474
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6465));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23434;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23436;
																																																					obj_t
																																																						BgL_bindingsz00_23435;
																																																					BgL_bindingsz00_23435
																																																						=
																																																						BgL_arg5282z00_6473;
																																																					BgL_exprz00_23436
																																																						=
																																																						BgL_arg5283z00_6474;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_23436;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_23435;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_21992
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23434);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23443;
																																																					goto
																																																						BgL_tagzd2383zd2_1726;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23443);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd237998zd2_6477;
																																																					BgL_carzd237998zd2_6477
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd237998zd2_6477 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23450;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23450);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd237998zd2_6477)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23455;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23455);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23462;
																																																											goto
																																																												BgL_tagzd2389zd2_1746;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23462);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23469;
																																																													goto
																																																														BgL_tagzd2390zd2_1747;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23469);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd238078zd2_6484;
																																																													BgL_cdrzd238078zd2_6484
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg5294z00_6487;
																																																															obj_t
																																																																BgL_arg5295z00_6488;
																																																															BgL_arg5294z00_6487
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6484));
																																																															BgL_arg5295z00_6488
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6484));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_23482;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_23484;
																																																																	obj_t
																																																																		BgL_effectz00_23483;
																																																																	BgL_effectz00_23483
																																																																		=
																																																																		BgL_arg5294z00_6487;
																																																																	BgL_restz00_23484
																																																																		=
																																																																		BgL_arg5295z00_6488;
																																																																	BgL_restz00_1749
																																																																		=
																																																																		BgL_restz00_23484;
																																																																	BgL_effectz00_1748
																																																																		=
																																																																		BgL_effectz00_23483;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1750;
																																																																}
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_23482);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23491;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1751;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23491);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23498;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1752;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23498);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg5302z00_6496;
																																																																					obj_t
																																																																						BgL_arg5303z00_6497;
																																																																					BgL_arg5302z00_6496
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6484));
																																																																					BgL_arg5303z00_6497
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6484));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23509;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_23511;
																																																																							obj_t
																																																																								BgL_effectz00_23510;
																																																																							BgL_effectz00_23510
																																																																								=
																																																																								BgL_arg5302z00_6496;
																																																																							BgL_restz00_23511
																																																																								=
																																																																								BgL_arg5303z00_6497;
																																																																							BgL_restz00_1754
																																																																								=
																																																																								BgL_restz00_23511;
																																																																							BgL_effectz00_1753
																																																																								=
																																																																								BgL_effectz00_23510;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1755;
																																																																						}
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23509);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23518;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1756;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23518);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23525;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1757;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23525);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_23532;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1758;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23532);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_23539;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1759;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23539);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd238155zd2_6506;
																																																																													BgL_cdrzd238155zd2_6506
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5314z00_6509;
																																																																															obj_t
																																																																																BgL_arg5315z00_6510;
																																																																															BgL_arg5314z00_6509
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6506));
																																																																															BgL_arg5315z00_6510
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6506));
																																																																															{	/* Ast/sexp.scm 563 */
																																																																																obj_t
																																																																																	BgL_arg7000z00_12124;
																																																																																BgL_arg7000z00_12124
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg5314z00_6509,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg5315z00_6510, BgL_stackz00_22, BgL_arg7000z00_12124, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23558;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23558);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd238180zd2_6527;
																																	BgL_carzd238180zd2_6527
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd238180zd2_6527
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_23565;
																																			goto
																																				BgL_tagzd2377zd2_1714;
																																			BgL_auxz00_21992
																																				=
																																				((obj_t)
																																				BgL_auxz00_23565);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_carzd238180zd2_6527
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_23569;
																																					goto
																																						BgL_tagzd2377zd2_1714;
																																					BgL_auxz00_21992
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_23569);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23576;
																																							goto
																																								BgL_tagzd2379zd2_1718;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23576);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_23583;
																																									goto
																																										BgL_tagzd2380zd2_1719;
																																									BgL_auxz00_21992
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_23583);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd238249zd2_6534;
																																									BgL_carzd238249zd2_6534
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd238249zd2_6534))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_carzd238252zd2_6536;
																																											obj_t
																																												BgL_cdrzd238253zd2_6537;
																																											BgL_carzd238252zd2_6536
																																												=
																																												CAR
																																												(BgL_carzd238249zd2_6534);
																																											BgL_cdrzd238253zd2_6537
																																												=
																																												CDR
																																												(BgL_carzd238249zd2_6534);
																																											{

																																												if ((BgL_carzd238252zd2_6536 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 118 */
																																													BgL_kapzd238254zd2_6538:
																																														if (PAIRP(BgL_cdrzd238253zd2_6537))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd238257zd2_6663;
																																																BgL_cdrzd238257zd2_6663
																																																	=
																																																	CDR
																																																	(BgL_cdrzd238253zd2_6537);
																																																if (PAIRP(BgL_cdrzd238257zd2_6663))
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (NULLP(CDR(BgL_cdrzd238257zd2_6663)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5423z00_6667;
																																																				obj_t
																																																					BgL_arg5424z00_6668;
																																																				BgL_arg5423z00_6667
																																																					=
																																																					CAR
																																																					(BgL_cdrzd238257zd2_6663);
																																																				BgL_arg5424z00_6668
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23605;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_23607;
																																																						obj_t
																																																							BgL_bodyz00_23606;
																																																						BgL_bodyz00_23606
																																																							=
																																																							BgL_arg5423z00_6667;
																																																						BgL_argsz00_23607
																																																							=
																																																							BgL_arg5424z00_6668;
																																																						BgL_argsz00_1721
																																																							=
																																																							BgL_argsz00_23607;
																																																						BgL_bodyz00_1720
																																																							=
																																																							BgL_bodyz00_23606;
																																																						goto
																																																							BgL_tagzd2381zd2_1722;
																																																					}
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23605);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd238281zd2_6669;
																																																				BgL_cdrzd238281zd2_6669
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_23611;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5494z00_6780;
																																																						BgL_arg5494z00_6780
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_23611
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5494z00_6780));
																																																					}
																																																					if (BgL_testz00_23611)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5427z00_6672;
																																																							obj_t
																																																								BgL_arg5428z00_6673;
																																																							BgL_arg5427z00_6672
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6669));
																																																							BgL_arg5428z00_6673
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6669));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23620;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23622;
																																																									obj_t
																																																										BgL_bindingsz00_23621;
																																																									BgL_bindingsz00_23621
																																																										=
																																																										BgL_arg5427z00_6672;
																																																									BgL_exprz00_23622
																																																										=
																																																										BgL_arg5428z00_6673;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_23622;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_23621;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23620);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_23624;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5493z00_6779;
																																																								BgL_arg5493z00_6779
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_23624
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5493z00_6779));
																																																							}
																																																							if (BgL_testz00_23624)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23629;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23629);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd238348zd2_6676;
																																																									BgL_carzd238348zd2_6676
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd238353zd2_6677;
																																																										BgL_cdrzd238353zd2_6677
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd238348zd2_6676));
																																																										if ((CAR(((obj_t) BgL_carzd238348zd2_6676)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5433z00_6680;
																																																												obj_t
																																																													BgL_arg5434z00_6681;
																																																												obj_t
																																																													BgL_arg5435z00_6682;
																																																												BgL_arg5433z00_6680
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6677));
																																																												BgL_arg5434z00_6681
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6677));
																																																												BgL_arg5435z00_6682
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23646;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23649;
																																																														obj_t
																																																															BgL_bodyz00_23648;
																																																														obj_t
																																																															BgL_varsz00_23647;
																																																														BgL_varsz00_23647
																																																															=
																																																															BgL_arg5433z00_6680;
																																																														BgL_bodyz00_23648
																																																															=
																																																															BgL_arg5434z00_6681;
																																																														BgL_argsz00_23649
																																																															=
																																																															BgL_arg5435z00_6682;
																																																														BgL_argsz00_1734
																																																															=
																																																															BgL_argsz00_23649;
																																																														BgL_bodyz00_1733
																																																															=
																																																															BgL_bodyz00_23648;
																																																														BgL_varsz00_1732
																																																															=
																																																															BgL_varsz00_23647;
																																																														goto
																																																															BgL_tagzd2386zd2_1735;
																																																													}
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23646);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd238376zd2_6684;
																																																												BgL_cdrzd238376zd2_6684
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd238382zd2_6685;
																																																													BgL_cdrzd238382zd2_6685
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd238348zd2_6676));
																																																													if ((CAR(((obj_t) BgL_carzd238348zd2_6676)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd238388zd2_6688;
																																																															BgL_cdrzd238388zd2_6688
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238382zd2_6685));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd238393zd2_6689;
																																																																obj_t
																																																																	BgL_cdrzd238394zd2_6690;
																																																																BgL_carzd238393zd2_6689
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6688));
																																																																BgL_cdrzd238394zd2_6690
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6688));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238393zd2_6689))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd238394zd2_6690))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd238401zd2_6693;
																																																																				BgL_carzd238401zd2_6693
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd238394zd2_6690);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238401zd2_6693))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd238394zd2_6690)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_23676;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1429z00_6726;
																																																																									BgL_l1429z00_6726
																																																																										=
																																																																										BgL_cdrzd238376zd2_6684;
																																																																								BgL_zc3anonymousza35458ze3z83_6727:
																																																																									if (NULLP(BgL_l1429z00_6726))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_23676
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_23679;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_23680;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_tmpz00_23681;
																																																																													BgL_tmpz00_23681
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1429z00_6726));
																																																																													BgL_testz00_23680
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_23681);
																																																																												}
																																																																												if (BgL_testz00_23680)
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_23679
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_23679
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_testz00_23679)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1429z00_23685;
																																																																													BgL_l1429z00_23685
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1429z00_6726));
																																																																													BgL_l1429z00_6726
																																																																														=
																																																																														BgL_l1429z00_23685;
																																																																													goto
																																																																														BgL_zc3anonymousza35458ze3z83_6727;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													BgL_testz00_23676
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_testz00_23676)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg5448z00_6709;
																																																																										BgL_arg5448z00_6709
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd238382zd2_6685));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23690;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_23694;
																																																																												obj_t
																																																																													BgL_proc2z00_23693;
																																																																												obj_t
																																																																													BgL_proc1z00_23692;
																																																																												obj_t
																																																																													BgL_testz00_23691;
																																																																												BgL_testz00_23691
																																																																													=
																																																																													BgL_arg5448z00_6709;
																																																																												BgL_proc1z00_23692
																																																																													=
																																																																													BgL_carzd238393zd2_6689;
																																																																												BgL_proc2z00_23693
																																																																													=
																																																																													BgL_carzd238401zd2_6693;
																																																																												BgL_argsz00_23694
																																																																													=
																																																																													BgL_cdrzd238376zd2_6684;
																																																																												BgL_argsz00_1739
																																																																													=
																																																																													BgL_argsz00_23694;
																																																																												BgL_proc2z00_1738
																																																																													=
																																																																													BgL_proc2z00_23693;
																																																																												BgL_proc1z00_1737
																																																																													=
																																																																													BgL_proc1z00_23692;
																																																																												BgL_testz00_1736
																																																																													=
																																																																													BgL_testz00_23691;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1740;
																																																																											}
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23690);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd238425zd2_6710;
																																																																										BgL_cdrzd238425zd2_6710
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd238432zd2_6711;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_12168;
																																																																												BgL_pairz00_12168
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd238432zd2_6711
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12168);
																																																																											}
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd238439zd2_6712;
																																																																												BgL_cdrzd238439zd2_6712
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd238432zd2_6711));
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd238445zd2_6713;
																																																																													BgL_carzd238445zd2_6713
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd238439zd2_6712));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238445zd2_6713))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_carzd238452zd2_6715;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_pairz00_12172;
																																																																																BgL_pairz00_12172
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd238439zd2_6712));
																																																																																BgL_carzd238452zd2_6715
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_12172);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238452zd2_6715))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238425zd2_6710))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_arg5452z00_6718;
																																																																																			BgL_arg5452z00_6718
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd238432zd2_6711));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23716;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23720;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23719;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23718;
																																																																																					obj_t
																																																																																						BgL_testz00_23717;
																																																																																					BgL_testz00_23717
																																																																																						=
																																																																																						BgL_arg5452z00_6718;
																																																																																					BgL_proc1z00_23718
																																																																																						=
																																																																																						BgL_carzd238445zd2_6713;
																																																																																					BgL_proc2z00_23719
																																																																																						=
																																																																																						BgL_carzd238452zd2_6715;
																																																																																					BgL_argsz00_23720
																																																																																						=
																																																																																						BgL_cdrzd238425zd2_6710;
																																																																																					BgL_argsz00_1744
																																																																																						=
																																																																																						BgL_argsz00_23720;
																																																																																					BgL_proc2z00_1743
																																																																																						=
																																																																																						BgL_proc2z00_23719;
																																																																																					BgL_proc1z00_1742
																																																																																						=
																																																																																						BgL_proc1z00_23718;
																																																																																					BgL_testz00_1741
																																																																																						=
																																																																																						BgL_testz00_23717;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1745;
																																																																																				}
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23716);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1769;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23724;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1770;
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23724);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23728;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23728);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23732;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23732);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_23736;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_23736);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd238728zd2_6737;
																																																																						BgL_cdrzd238728zd2_6737
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd238734zd2_6738;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_12176;
																																																																								BgL_pairz00_12176
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd238734zd2_6738
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12176);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd238740zd2_6739;
																																																																								BgL_cdrzd238740zd2_6739
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd238734zd2_6738));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd238745zd2_6740;
																																																																									obj_t
																																																																										BgL_cdrzd238746zd2_6741;
																																																																									BgL_carzd238745zd2_6740
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6739));
																																																																									BgL_cdrzd238746zd2_6741
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6739));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238745zd2_6740))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd238751zd2_6743;
																																																																											BgL_carzd238751zd2_6743
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd238746zd2_6741));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238751zd2_6743))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd238746zd2_6741))))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238728zd2_6737))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5468z00_6748;
																																																																																	BgL_arg5468z00_6748
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd238734zd2_6738));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23763;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23767;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23766;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23765;
																																																																																			obj_t
																																																																																				BgL_testz00_23764;
																																																																																			BgL_testz00_23764
																																																																																				=
																																																																																				BgL_arg5468z00_6748;
																																																																																			BgL_proc1z00_23765
																																																																																				=
																																																																																				BgL_carzd238745zd2_6740;
																																																																																			BgL_proc2z00_23766
																																																																																				=
																																																																																				BgL_carzd238751zd2_6743;
																																																																																			BgL_argsz00_23767
																																																																																				=
																																																																																				BgL_cdrzd238728zd2_6737;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_23767;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_23766;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_23765;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_23764;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23763);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23771;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23771);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23775;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23775);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23779;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23779);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23783;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23783);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23787;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23787);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd239084zd2_6756;
																																																																		BgL_cdrzd239084zd2_6756
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd239091zd2_6757;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_12186;
																																																																				BgL_pairz00_12186
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd239091zd2_6757
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12186);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd239098zd2_6758;
																																																																				BgL_cdrzd239098zd2_6758
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd239091zd2_6757));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd239104zd2_6759;
																																																																					obj_t
																																																																						BgL_cdrzd239105zd2_6760;
																																																																					BgL_carzd239104zd2_6759
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6758));
																																																																					BgL_cdrzd239105zd2_6760
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6758));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239104zd2_6759))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd239105zd2_6760))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd239112zd2_6763;
																																																																									BgL_carzd239112zd2_6763
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd239105zd2_6760);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239112zd2_6763))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd239105zd2_6760)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd239084zd2_6756))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5482z00_6768;
																																																																															BgL_arg5482z00_6768
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd239091zd2_6757));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23814;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_23818;
																																																																																	obj_t
																																																																																		BgL_proc2z00_23817;
																																																																																	obj_t
																																																																																		BgL_proc1z00_23816;
																																																																																	obj_t
																																																																																		BgL_testz00_23815;
																																																																																	BgL_testz00_23815
																																																																																		=
																																																																																		BgL_arg5482z00_6768;
																																																																																	BgL_proc1z00_23816
																																																																																		=
																																																																																		BgL_carzd239104zd2_6759;
																																																																																	BgL_proc2z00_23817
																																																																																		=
																																																																																		BgL_carzd239112zd2_6763;
																																																																																	BgL_argsz00_23818
																																																																																		=
																																																																																		BgL_cdrzd239084zd2_6756;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_23818;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_23817;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_23816;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_23815;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23814);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23822;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23822);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23826;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23826);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23830;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23830);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23834;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23834);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23838;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23838);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23842;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23842);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd239505zd2_6782;
																																																		BgL_cdrzd239505zd2_6782
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_23846;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5510z00_6799;
																																																				BgL_arg5510z00_6799
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_23846
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5510z00_6799));
																																																			}
																																																			if (BgL_testz00_23846)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5498z00_6785;
																																																					obj_t
																																																						BgL_arg5499z00_6786;
																																																					BgL_arg5498z00_6785
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6782));
																																																					BgL_arg5499z00_6786
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6782));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23855;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23857;
																																																							obj_t
																																																								BgL_bindingsz00_23856;
																																																							BgL_bindingsz00_23856
																																																								=
																																																								BgL_arg5498z00_6785;
																																																							BgL_exprz00_23857
																																																								=
																																																								BgL_arg5499z00_6786;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_23857;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_23856;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23855);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_23859;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5509z00_6798;
																																																						BgL_arg5509z00_6798
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_23859
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5509z00_6798));
																																																					}
																																																					if (BgL_testz00_23859)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23864;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23864);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd239571zd2_6789;
																																																							BgL_carzd239571zd2_6789
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd239576zd2_6790;
																																																								BgL_cdrzd239576zd2_6790
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd239571zd2_6789));
																																																								if ((CAR(((obj_t) BgL_carzd239571zd2_6789)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5504z00_6793;
																																																										obj_t
																																																											BgL_arg5505z00_6794;
																																																										obj_t
																																																											BgL_arg5506z00_6795;
																																																										BgL_arg5504z00_6793
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6790));
																																																										BgL_arg5505z00_6794
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6790));
																																																										BgL_arg5506z00_6795
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23881;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_23884;
																																																												obj_t
																																																													BgL_bodyz00_23883;
																																																												obj_t
																																																													BgL_varsz00_23882;
																																																												BgL_varsz00_23882
																																																													=
																																																													BgL_arg5504z00_6793;
																																																												BgL_bodyz00_23883
																																																													=
																																																													BgL_arg5505z00_6794;
																																																												BgL_argsz00_23884
																																																													=
																																																													BgL_arg5506z00_6795;
																																																												BgL_argsz00_1734
																																																													=
																																																													BgL_argsz00_23884;
																																																												BgL_bodyz00_1733
																																																													=
																																																													BgL_bodyz00_23883;
																																																												BgL_varsz00_1732
																																																													=
																																																													BgL_varsz00_23882;
																																																												goto
																																																													BgL_tagzd2386zd2_1735;
																																																											}
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23881);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23888;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23888);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd239687zd2_6800;
																																																BgL_cdrzd239687zd2_6800
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_23892;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5519z00_6809;
																																																		BgL_arg5519z00_6809
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_23892
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5519z00_6809));
																																																	}
																																																	if (BgL_testz00_23892)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5513z00_6803;
																																																			obj_t
																																																				BgL_arg5514z00_6804;
																																																			BgL_arg5513z00_6803
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6800));
																																																			BgL_arg5514z00_6804
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6800));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23901;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23903;
																																																					obj_t
																																																						BgL_bindingsz00_23902;
																																																					BgL_bindingsz00_23902
																																																						=
																																																						BgL_arg5513z00_6803;
																																																					BgL_exprz00_23903
																																																						=
																																																						BgL_arg5514z00_6804;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_23903;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_23902;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_21992
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23901);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_23905;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5518z00_6808;
																																																				BgL_arg5518z00_6808
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_23905
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5518z00_6808));
																																																			}
																																																			if (BgL_testz00_23905)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_23910;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23910);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1769;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_23914;
																																																							goto
																																																								BgL_tagzd2404zd2_1770;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23914);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238252zd2_6536)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd238254zd2_6538;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd238252zd2_6536 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd238254zd2_6538;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if ((BgL_carzd238252zd2_6536 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd238254zd2_6538;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd238252zd2_6536)))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_kapzd238254zd2_6538;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd239859zd2_6544;
																																																						BgL_cdrzd239859zd2_6544
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_23930;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5418z00_6661;
																																																								BgL_arg5418z00_6661
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_23930
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5418z00_6661));
																																																							}
																																																							if (BgL_testz00_23930)
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg5346z00_6547;
																																																									obj_t
																																																										BgL_arg5347z00_6548;
																																																									BgL_arg5346z00_6547
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6544));
																																																									BgL_arg5347z00_6548
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6544));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_23939;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_23941;
																																																											obj_t
																																																												BgL_bindingsz00_23940;
																																																											BgL_bindingsz00_23940
																																																												=
																																																												BgL_arg5346z00_6547;
																																																											BgL_exprz00_23941
																																																												=
																																																												BgL_arg5347z00_6548;
																																																											BgL_exprz00_1724
																																																												=
																																																												BgL_exprz00_23941;
																																																											BgL_bindingsz00_1723
																																																												=
																																																												BgL_bindingsz00_23940;
																																																											goto
																																																												BgL_tagzd2382zd2_1725;
																																																										}
																																																										BgL_auxz00_21992
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_23939);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									bool_t
																																																										BgL_testz00_23943;
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5417z00_6660;
																																																										BgL_arg5417z00_6660
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_testz00_23943
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5417z00_6660));
																																																									}
																																																									if (BgL_testz00_23943)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_23948;
																																																											goto
																																																												BgL_tagzd2384zd2_1727;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23948);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd239925zd2_6551;
																																																											BgL_carzd239925zd2_6551
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd239930zd2_6552;
																																																												BgL_cdrzd239930zd2_6552
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd239925zd2_6551));
																																																												if ((CAR(((obj_t) BgL_carzd239925zd2_6551)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd239930zd2_6552))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg5353z00_6556;
																																																																obj_t
																																																																	BgL_arg5354z00_6557;
																																																																obj_t
																																																																	BgL_arg5355z00_6558;
																																																																BgL_arg5353z00_6556
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd239930zd2_6552);
																																																																BgL_arg5354z00_6557
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd239930zd2_6552);
																																																																BgL_arg5355z00_6558
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23965;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_23968;
																																																																		obj_t
																																																																			BgL_bodyz00_23967;
																																																																		obj_t
																																																																			BgL_varsz00_23966;
																																																																		BgL_varsz00_23966
																																																																			=
																																																																			BgL_arg5353z00_6556;
																																																																		BgL_bodyz00_23967
																																																																			=
																																																																			BgL_arg5354z00_6557;
																																																																		BgL_argsz00_23968
																																																																			=
																																																																			BgL_arg5355z00_6558;
																																																																		BgL_argsz00_1734
																																																																			=
																																																																			BgL_argsz00_23968;
																																																																		BgL_bodyz00_1733
																																																																			=
																																																																			BgL_bodyz00_23967;
																																																																		BgL_varsz00_1732
																																																																			=
																																																																			BgL_varsz00_23966;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1735;
																																																																	}
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23965);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_23972;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_23972);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd240037zd2_6561;
																																																														BgL_cdrzd240037zd2_6561
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd240042zd2_6562;
																																																															BgL_cdrzd240042zd2_6562
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd239925zd2_6551));
																																																															if ((CAR(((obj_t) BgL_carzd239925zd2_6551)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd240042zd2_6562))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd240047zd2_6566;
																																																																			BgL_cdrzd240047zd2_6566
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd240042zd2_6562);
																																																																			if (PAIRP(BgL_cdrzd240047zd2_6566))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd240051zd2_6568;
																																																																					obj_t
																																																																						BgL_cdrzd240052zd2_6569;
																																																																					BgL_carzd240051zd2_6568
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd240047zd2_6566);
																																																																					BgL_cdrzd240052zd2_6569
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd240047zd2_6566);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240051zd2_6568))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (PAIRP(BgL_cdrzd240052zd2_6569))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd240057zd2_6572;
																																																																									BgL_carzd240057zd2_6572
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd240052zd2_6569);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240057zd2_6572))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(BgL_cdrzd240052zd2_6569)))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_testz00_24000;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1432z00_6605;
																																																																														BgL_l1432z00_6605
																																																																															=
																																																																															BgL_cdrzd240037zd2_6561;
																																																																													BgL_zc3anonymousza35381ze3z83_6606:
																																																																														if (NULLP(BgL_l1432z00_6605))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_24000
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																bool_t
																																																																																	BgL_testz00_24003;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	bool_t
																																																																																		BgL_testz00_24004;
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_24005;
																																																																																		BgL_tmpz00_24005
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1432z00_6605));
																																																																																		BgL_testz00_24004
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_24005);
																																																																																	}
																																																																																	if (BgL_testz00_24004)
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_testz00_24003
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			BgL_testz00_24003
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_testz00_24003)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1432z00_24009;
																																																																																		BgL_l1432z00_24009
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1432z00_6605));
																																																																																		BgL_l1432z00_6605
																																																																																			=
																																																																																			BgL_l1432z00_24009;
																																																																																		goto
																																																																																			BgL_zc3anonymousza35381ze3z83_6606;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		BgL_testz00_24000
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_testz00_24000)
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5371z00_6588;
																																																																															BgL_arg5371z00_6588
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd240042zd2_6562);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24013;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24017;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24016;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24015;
																																																																																	obj_t
																																																																																		BgL_testz00_24014;
																																																																																	BgL_testz00_24014
																																																																																		=
																																																																																		BgL_arg5371z00_6588;
																																																																																	BgL_proc1z00_24015
																																																																																		=
																																																																																		BgL_carzd240051zd2_6568;
																																																																																	BgL_proc2z00_24016
																																																																																		=
																																																																																		BgL_carzd240057zd2_6572;
																																																																																	BgL_argsz00_24017
																																																																																		=
																																																																																		BgL_cdrzd240037zd2_6561;
																																																																																	BgL_argsz00_1739
																																																																																		=
																																																																																		BgL_argsz00_24017;
																																																																																	BgL_proc2z00_1738
																																																																																		=
																																																																																		BgL_proc2z00_24016;
																																																																																	BgL_proc1z00_1737
																																																																																		=
																																																																																		BgL_proc1z00_24015;
																																																																																	BgL_testz00_1736
																																																																																		=
																																																																																		BgL_testz00_24014;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1740;
																																																																																}
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24013);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd240082zd2_6589;
																																																																															BgL_cdrzd240082zd2_6589
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_cdrzd240090zd2_6590;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12243;
																																																																																	BgL_pairz00_12243
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd240090zd2_6590
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_12243);
																																																																																}
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_cdrzd240098zd2_6591;
																																																																																	BgL_cdrzd240098zd2_6591
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd240090zd2_6590));
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd240105zd2_6592;
																																																																																		BgL_carzd240105zd2_6592
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd240098zd2_6591));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240105zd2_6592))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_carzd240114zd2_6594;
																																																																																				{	/* Ast/sexp.scm 118 */
																																																																																					obj_t
																																																																																						BgL_pairz00_12247;
																																																																																					BgL_pairz00_12247
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd240098zd2_6591));
																																																																																					BgL_carzd240114zd2_6594
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_12247);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240114zd2_6594))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240082zd2_6589))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								obj_t
																																																																																									BgL_arg5375z00_6597;
																																																																																								BgL_arg5375z00_6597
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd240090zd2_6590));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_24039;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_24043;
																																																																																										obj_t
																																																																																											BgL_proc2z00_24042;
																																																																																										obj_t
																																																																																											BgL_proc1z00_24041;
																																																																																										obj_t
																																																																																											BgL_testz00_24040;
																																																																																										BgL_testz00_24040
																																																																																											=
																																																																																											BgL_arg5375z00_6597;
																																																																																										BgL_proc1z00_24041
																																																																																											=
																																																																																											BgL_carzd240105zd2_6592;
																																																																																										BgL_proc2z00_24042
																																																																																											=
																																																																																											BgL_carzd240114zd2_6594;
																																																																																										BgL_argsz00_24043
																																																																																											=
																																																																																											BgL_cdrzd240082zd2_6589;
																																																																																										BgL_argsz00_1744
																																																																																											=
																																																																																											BgL_argsz00_24043;
																																																																																										BgL_proc2z00_1743
																																																																																											=
																																																																																											BgL_proc2z00_24042;
																																																																																										BgL_proc1z00_1742
																																																																																											=
																																																																																											BgL_proc1z00_24041;
																																																																																										BgL_testz00_1741
																																																																																											=
																																																																																											BgL_testz00_24040;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1745;
																																																																																									}
																																																																																									BgL_auxz00_21992
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_24039);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 118 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1769;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_24047;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1770;
																																																																																										BgL_auxz00_21992
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_24047);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24051;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24051);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24055;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24055);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24059;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24059);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd240392zd2_6616;
																																																																											BgL_cdrzd240392zd2_6616
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd240399zd2_6617;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_12251;
																																																																													BgL_pairz00_12251
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd240399zd2_6617
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12251);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd240406zd2_6618;
																																																																													BgL_cdrzd240406zd2_6618
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd240399zd2_6617));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd240412zd2_6619;
																																																																														obj_t
																																																																															BgL_cdrzd240413zd2_6620;
																																																																														BgL_carzd240412zd2_6619
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6618));
																																																																														BgL_cdrzd240413zd2_6620
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6618));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240412zd2_6619))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd240420zd2_6622;
																																																																																BgL_carzd240420zd2_6622
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd240413zd2_6620));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240420zd2_6622))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd240413zd2_6620))))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240392zd2_6616))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg5390z00_6627;
																																																																																						BgL_arg5390z00_6627
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd240399zd2_6617));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24086;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24090;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24089;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24088;
																																																																																								obj_t
																																																																																									BgL_testz00_24087;
																																																																																								BgL_testz00_24087
																																																																																									=
																																																																																									BgL_arg5390z00_6627;
																																																																																								BgL_proc1z00_24088
																																																																																									=
																																																																																									BgL_carzd240412zd2_6619;
																																																																																								BgL_proc2z00_24089
																																																																																									=
																																																																																									BgL_carzd240420zd2_6622;
																																																																																								BgL_argsz00_24090
																																																																																									=
																																																																																									BgL_cdrzd240392zd2_6616;
																																																																																								BgL_argsz00_1744
																																																																																									=
																																																																																									BgL_argsz00_24090;
																																																																																								BgL_proc2z00_1743
																																																																																									=
																																																																																									BgL_proc2z00_24089;
																																																																																								BgL_proc1z00_1742
																																																																																									=
																																																																																									BgL_proc1z00_24088;
																																																																																								BgL_testz00_1741
																																																																																									=
																																																																																									BgL_testz00_24087;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1745;
																																																																																							}
																																																																																							BgL_auxz00_21992
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24086);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24094;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24094);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24098;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24098);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24102;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24102);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24106;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24106);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24110;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24110);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd240753zd2_6635;
																																																																							BgL_cdrzd240753zd2_6635
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd240759zd2_6636;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_12261;
																																																																									BgL_pairz00_12261
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd240759zd2_6636
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12261);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd240765zd2_6637;
																																																																									BgL_cdrzd240765zd2_6637
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd240759zd2_6636));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd240770zd2_6638;
																																																																										obj_t
																																																																											BgL_cdrzd240771zd2_6639;
																																																																										BgL_carzd240770zd2_6638
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6637));
																																																																										BgL_cdrzd240771zd2_6639
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6637));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240770zd2_6638))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (PAIRP(BgL_cdrzd240771zd2_6639))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd240776zd2_6642;
																																																																														BgL_carzd240776zd2_6642
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd240771zd2_6639);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240776zd2_6642))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(BgL_cdrzd240771zd2_6639)))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240753zd2_6635))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg5404z00_6647;
																																																																																				BgL_arg5404z00_6647
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd240759zd2_6636));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24137;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24141;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24140;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24139;
																																																																																						obj_t
																																																																																							BgL_testz00_24138;
																																																																																						BgL_testz00_24138
																																																																																							=
																																																																																							BgL_arg5404z00_6647;
																																																																																						BgL_proc1z00_24139
																																																																																							=
																																																																																							BgL_carzd240770zd2_6638;
																																																																																						BgL_proc2z00_24140
																																																																																							=
																																																																																							BgL_carzd240776zd2_6642;
																																																																																						BgL_argsz00_24141
																																																																																							=
																																																																																							BgL_cdrzd240753zd2_6635;
																																																																																						BgL_argsz00_1744
																																																																																							=
																																																																																							BgL_argsz00_24141;
																																																																																						BgL_proc2z00_1743
																																																																																							=
																																																																																							BgL_proc2z00_24140;
																																																																																						BgL_proc1z00_1742
																																																																																							=
																																																																																							BgL_proc1z00_24139;
																																																																																						BgL_testz00_1741
																																																																																							=
																																																																																							BgL_testz00_24138;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1745;
																																																																																					}
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24137);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24145;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24145);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24149;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24149);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24153;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24153);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24157;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24157);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24161;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24161);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24165;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24165);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24169;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24169);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24173;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24173);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_cdrzd241314zd2_6811;
																																											BgL_cdrzd241314zd2_6811
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if ((BgL_carzd238249zd2_6534 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg5521z00_6813;
																																													obj_t
																																														BgL_arg5522z00_6814;
																																													BgL_arg5521z00_6813
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6811));
																																													BgL_arg5522z00_6814
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6811));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_24184;
																																														{
																																															obj_t
																																																BgL_exprz00_24186;
																																															obj_t
																																																BgL_bindingsz00_24185;
																																															BgL_bindingsz00_24185
																																																=
																																																BgL_arg5521z00_6813;
																																															BgL_exprz00_24186
																																																=
																																																BgL_arg5522z00_6814;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_24186;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_24185;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_21992
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_24184);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238249zd2_6534)))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg5524z00_6816;
																																															obj_t
																																																BgL_arg5525z00_6817;
																																															BgL_arg5524z00_6816
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6811));
																																															BgL_arg5525z00_6817
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6811));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_24195;
																																																{
																																																	obj_t
																																																		BgL_exprz00_24197;
																																																	obj_t
																																																		BgL_bindingsz00_24196;
																																																	BgL_bindingsz00_24196
																																																		=
																																																		BgL_arg5524z00_6816;
																																																	BgL_exprz00_24197
																																																		=
																																																		BgL_arg5525z00_6817;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_24197;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_24196;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_24195);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((BgL_carzd238249zd2_6534 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5527z00_6819;
																																																	obj_t
																																																		BgL_arg5528z00_6820;
																																																	BgL_arg5527z00_6819
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6811));
																																																	BgL_arg5528z00_6820
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6811));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24206;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24208;
																																																			obj_t
																																																				BgL_bindingsz00_24207;
																																																			BgL_bindingsz00_24207
																																																				=
																																																				BgL_arg5527z00_6819;
																																																			BgL_exprz00_24208
																																																				=
																																																				BgL_arg5528z00_6820;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_24208;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_24207;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24206);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24215;
																																																			goto
																																																				BgL_tagzd2383zd2_1726;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24215);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd241351zd2_6823;
																																																			BgL_carzd241351zd2_6823
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd241351zd2_6823 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24222;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24222);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241351zd2_6823)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24227;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24227);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24234;
																																																									goto
																																																										BgL_tagzd2389zd2_1746;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24234);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24241;
																																																											goto
																																																												BgL_tagzd2390zd2_1747;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24241);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd241431zd2_6830;
																																																											BgL_cdrzd241431zd2_6830
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg5539z00_6833;
																																																													obj_t
																																																														BgL_arg5540z00_6834;
																																																													BgL_arg5539z00_6833
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6830));
																																																													BgL_arg5540z00_6834
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6830));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_24254;
																																																														{
																																																															obj_t
																																																																BgL_restz00_24256;
																																																															obj_t
																																																																BgL_effectz00_24255;
																																																															BgL_effectz00_24255
																																																																=
																																																																BgL_arg5539z00_6833;
																																																															BgL_restz00_24256
																																																																=
																																																																BgL_arg5540z00_6834;
																																																															BgL_restz00_1749
																																																																=
																																																																BgL_restz00_24256;
																																																															BgL_effectz00_1748
																																																																=
																																																																BgL_effectz00_24255;
																																																															goto
																																																																BgL_tagzd2391zd2_1750;
																																																														}
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_24254);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24263;
																																																															goto
																																																																BgL_tagzd2392zd2_1751;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24263);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24270;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1752;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24270);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg5547z00_6842;
																																																																			obj_t
																																																																				BgL_arg5548z00_6843;
																																																																			BgL_arg5547z00_6842
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6830));
																																																																			BgL_arg5548z00_6843
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6830));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24281;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_24283;
																																																																					obj_t
																																																																						BgL_effectz00_24282;
																																																																					BgL_effectz00_24282
																																																																						=
																																																																						BgL_arg5547z00_6842;
																																																																					BgL_restz00_24283
																																																																						=
																																																																						BgL_arg5548z00_6843;
																																																																					BgL_restz00_1754
																																																																						=
																																																																						BgL_restz00_24283;
																																																																					BgL_effectz00_1753
																																																																						=
																																																																						BgL_effectz00_24282;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1755;
																																																																				}
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24281);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24290;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1756;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24290);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24297;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1757;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24297);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_24304;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1758;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24304);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_24311;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1759;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24311);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd241508zd2_6852;
																																																																											BgL_cdrzd241508zd2_6852
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5559z00_6855;
																																																																													obj_t
																																																																														BgL_arg5560z00_6856;
																																																																													BgL_arg5559z00_6855
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6852));
																																																																													BgL_arg5560z00_6856
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6852));
																																																																													{	/* Ast/sexp.scm 563 */
																																																																														obj_t
																																																																															BgL_arg7000z00_12300;
																																																																														BgL_arg7000z00_12300
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5559z00_6855,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5560z00_6856, BgL_stackz00_22, BgL_arg7000z00_12300, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24330;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24330);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd241533zd2_6873;
																															BgL_carzd241533zd2_6873
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd241533zd2_6873
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_24337;
																																	goto
																																		BgL_tagzd2377zd2_1714;
																																	BgL_auxz00_21992
																																		=
																																		((obj_t)
																																		BgL_auxz00_24337);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(BgL_carzd241533zd2_6873
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_24341;
																																			goto
																																				BgL_tagzd2377zd2_1714;
																																			BgL_auxz00_21992
																																				=
																																				((obj_t)
																																				BgL_auxz00_24341);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_cdrzd241555zd2_6876;
																																			BgL_cdrzd241555zd2_6876
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd241558zd2_6879;
																																					obj_t
																																						BgL_cdrzd241559zd2_6880;
																																					BgL_carzd241558zd2_6879
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd241555zd2_6876));
																																					BgL_cdrzd241559zd2_6880
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd241555zd2_6876));
																																					if (PAIRP(BgL_carzd241558zd2_6879))
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(BgL_carzd241558zd2_6879) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 118 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd241559zd2_6880))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg5586z00_6886;
																																											obj_t
																																												BgL_arg5587z00_6887;
																																											BgL_arg5586z00_6886
																																												=
																																												CDR
																																												(BgL_carzd241558zd2_6879);
																																											BgL_arg5587z00_6887
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241559zd2_6880));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_24367;
																																												{
																																													obj_t
																																														BgL_valz00_24369;
																																													obj_t
																																														BgL_lz00_24368;
																																													BgL_lz00_24368
																																														=
																																														BgL_arg5586z00_6886;
																																													BgL_valz00_24369
																																														=
																																														BgL_arg5587z00_6887;
																																													BgL_valz00_1716
																																														=
																																														BgL_valz00_24369;
																																													BgL_lz00_1715
																																														=
																																														BgL_lz00_24368;
																																													goto
																																														BgL_tagzd2378zd2_1717;
																																												}
																																												BgL_auxz00_21992
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_24367);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_24371;
																																											goto
																																												BgL_tagzd2379zd2_1718;
																																											BgL_auxz00_21992
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_24371);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_24373;
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																									BgL_auxz00_21992
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_24373);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24375;
																																							goto
																																								BgL_tagzd2379zd2_1718;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24375);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24382;
																																							goto
																																								BgL_tagzd2380zd2_1719;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24382);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd241656zd2_6892;
																																							BgL_carzd241656zd2_6892
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd241656zd2_6892))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd241659zd2_6894;
																																									obj_t
																																										BgL_cdrzd241660zd2_6895;
																																									BgL_carzd241659zd2_6894
																																										=
																																										CAR
																																										(BgL_carzd241656zd2_6892);
																																									BgL_cdrzd241660zd2_6895
																																										=
																																										CDR
																																										(BgL_carzd241656zd2_6892);
																																									{

																																										if ((BgL_carzd241659zd2_6894 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 118 */
																																											BgL_kapzd241661zd2_6896:
																																												if (PAIRP(BgL_cdrzd241660zd2_6895))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd241664zd2_7021;
																																														BgL_cdrzd241664zd2_7021
																																															=
																																															CDR
																																															(BgL_cdrzd241660zd2_6895);
																																														if (PAIRP(BgL_cdrzd241664zd2_7021))
																																															{	/* Ast/sexp.scm 118 */
																																																if (NULLP(CDR(BgL_cdrzd241664zd2_7021)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5677z00_7025;
																																																		obj_t
																																																			BgL_arg5678z00_7026;
																																																		BgL_arg5677z00_7025
																																																			=
																																																			CAR
																																																			(BgL_cdrzd241664zd2_7021);
																																																		BgL_arg5678z00_7026
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24404;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_24406;
																																																				obj_t
																																																					BgL_bodyz00_24405;
																																																				BgL_bodyz00_24405
																																																					=
																																																					BgL_arg5677z00_7025;
																																																				BgL_argsz00_24406
																																																					=
																																																					BgL_arg5678z00_7026;
																																																				BgL_argsz00_1721
																																																					=
																																																					BgL_argsz00_24406;
																																																				BgL_bodyz00_1720
																																																					=
																																																					BgL_bodyz00_24405;
																																																				goto
																																																					BgL_tagzd2381zd2_1722;
																																																			}
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24404);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd241688zd2_7027;
																																																		BgL_cdrzd241688zd2_7027
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_24410;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5747z00_7138;
																																																				BgL_arg5747z00_7138
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_24410
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5747z00_7138));
																																																			}
																																																			if (BgL_testz00_24410)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5681z00_7030;
																																																					obj_t
																																																						BgL_arg5682z00_7031;
																																																					BgL_arg5681z00_7030
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7027));
																																																					BgL_arg5682z00_7031
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7027));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_24419;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_24421;
																																																							obj_t
																																																								BgL_bindingsz00_24420;
																																																							BgL_bindingsz00_24420
																																																								=
																																																								BgL_arg5681z00_7030;
																																																							BgL_exprz00_24421
																																																								=
																																																								BgL_arg5682z00_7031;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_24421;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_24420;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_24419);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_24423;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5746z00_7137;
																																																						BgL_arg5746z00_7137
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_24423
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5746z00_7137));
																																																					}
																																																					if (BgL_testz00_24423)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24428;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24428);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd241755zd2_7034;
																																																							BgL_carzd241755zd2_7034
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd241760zd2_7035;
																																																								BgL_cdrzd241760zd2_7035
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd241755zd2_7034));
																																																								if ((CAR(((obj_t) BgL_carzd241755zd2_7034)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg5687z00_7038;
																																																										obj_t
																																																											BgL_arg5688z00_7039;
																																																										obj_t
																																																											BgL_arg5689z00_7040;
																																																										BgL_arg5687z00_7038
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7035));
																																																										BgL_arg5688z00_7039
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7035));
																																																										BgL_arg5689z00_7040
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24445;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_24448;
																																																												obj_t
																																																													BgL_bodyz00_24447;
																																																												obj_t
																																																													BgL_varsz00_24446;
																																																												BgL_varsz00_24446
																																																													=
																																																													BgL_arg5687z00_7038;
																																																												BgL_bodyz00_24447
																																																													=
																																																													BgL_arg5688z00_7039;
																																																												BgL_argsz00_24448
																																																													=
																																																													BgL_arg5689z00_7040;
																																																												BgL_argsz00_1734
																																																													=
																																																													BgL_argsz00_24448;
																																																												BgL_bodyz00_1733
																																																													=
																																																													BgL_bodyz00_24447;
																																																												BgL_varsz00_1732
																																																													=
																																																													BgL_varsz00_24446;
																																																												goto
																																																													BgL_tagzd2386zd2_1735;
																																																											}
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24445);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd241783zd2_7042;
																																																										BgL_cdrzd241783zd2_7042
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd241789zd2_7043;
																																																											BgL_cdrzd241789zd2_7043
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd241755zd2_7034));
																																																											if ((CAR(((obj_t) BgL_carzd241755zd2_7034)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd241795zd2_7046;
																																																													BgL_cdrzd241795zd2_7046
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241789zd2_7043));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd241800zd2_7047;
																																																														obj_t
																																																															BgL_cdrzd241801zd2_7048;
																																																														BgL_carzd241800zd2_7047
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7046));
																																																														BgL_cdrzd241801zd2_7048
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7046));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241800zd2_7047))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd241801zd2_7048))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd241808zd2_7051;
																																																																		BgL_carzd241808zd2_7051
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd241801zd2_7048);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241808zd2_7051))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd241801zd2_7048)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_24475;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1435z00_7084;
																																																																							BgL_l1435z00_7084
																																																																								=
																																																																								BgL_cdrzd241783zd2_7042;
																																																																						BgL_zc3anonymousza35712ze3z83_7085:
																																																																							if (NULLP(BgL_l1435z00_7084))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_24475
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_24478;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_testz00_24479;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_24480;
																																																																											BgL_tmpz00_24480
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1435z00_7084));
																																																																											BgL_testz00_24479
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_24480);
																																																																										}
																																																																										if (BgL_testz00_24479)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_24478
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_24478
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_testz00_24478)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1435z00_24484;
																																																																											BgL_l1435z00_24484
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1435z00_7084));
																																																																											BgL_l1435z00_7084
																																																																												=
																																																																												BgL_l1435z00_24484;
																																																																											goto
																																																																												BgL_zc3anonymousza35712ze3z83_7085;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_24475
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_testz00_24475)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg5702z00_7067;
																																																																								BgL_arg5702z00_7067
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd241789zd2_7043));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24489;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_24493;
																																																																										obj_t
																																																																											BgL_proc2z00_24492;
																																																																										obj_t
																																																																											BgL_proc1z00_24491;
																																																																										obj_t
																																																																											BgL_testz00_24490;
																																																																										BgL_testz00_24490
																																																																											=
																																																																											BgL_arg5702z00_7067;
																																																																										BgL_proc1z00_24491
																																																																											=
																																																																											BgL_carzd241800zd2_7047;
																																																																										BgL_proc2z00_24492
																																																																											=
																																																																											BgL_carzd241808zd2_7051;
																																																																										BgL_argsz00_24493
																																																																											=
																																																																											BgL_cdrzd241783zd2_7042;
																																																																										BgL_argsz00_1739
																																																																											=
																																																																											BgL_argsz00_24493;
																																																																										BgL_proc2z00_1738
																																																																											=
																																																																											BgL_proc2z00_24492;
																																																																										BgL_proc1z00_1737
																																																																											=
																																																																											BgL_proc1z00_24491;
																																																																										BgL_testz00_1736
																																																																											=
																																																																											BgL_testz00_24490;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1740;
																																																																									}
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24489);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd241832zd2_7068;
																																																																								BgL_cdrzd241832zd2_7068
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd241839zd2_7069;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12353;
																																																																										BgL_pairz00_12353
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd241839zd2_7069
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12353);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd241846zd2_7070;
																																																																										BgL_cdrzd241846zd2_7070
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd241839zd2_7069));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd241852zd2_7071;
																																																																											BgL_carzd241852zd2_7071
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd241846zd2_7070));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241852zd2_7071))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd241859zd2_7073;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12357;
																																																																														BgL_pairz00_12357
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd241846zd2_7070));
																																																																														BgL_carzd241859zd2_7073
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12357);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241859zd2_7073))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd241832zd2_7068))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg5706z00_7076;
																																																																																	BgL_arg5706z00_7076
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd241839zd2_7069));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24515;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_24519;
																																																																																			obj_t
																																																																																				BgL_proc2z00_24518;
																																																																																			obj_t
																																																																																				BgL_proc1z00_24517;
																																																																																			obj_t
																																																																																				BgL_testz00_24516;
																																																																																			BgL_testz00_24516
																																																																																				=
																																																																																				BgL_arg5706z00_7076;
																																																																																			BgL_proc1z00_24517
																																																																																				=
																																																																																				BgL_carzd241852zd2_7071;
																																																																																			BgL_proc2z00_24518
																																																																																				=
																																																																																				BgL_carzd241859zd2_7073;
																																																																																			BgL_argsz00_24519
																																																																																				=
																																																																																				BgL_cdrzd241832zd2_7068;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_24519;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_24518;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_24517;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_24516;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24515);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24523;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24523);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24527;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24527);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24531;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24531);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_24535;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_24535);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd242135zd2_7095;
																																																																				BgL_cdrzd242135zd2_7095
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd242141zd2_7096;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12361;
																																																																						BgL_pairz00_12361
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd242141zd2_7096
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12361);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd242147zd2_7097;
																																																																						BgL_cdrzd242147zd2_7097
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd242141zd2_7096));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd242152zd2_7098;
																																																																							obj_t
																																																																								BgL_cdrzd242153zd2_7099;
																																																																							BgL_carzd242152zd2_7098
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7097));
																																																																							BgL_cdrzd242153zd2_7099
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7097));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242152zd2_7098))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd242158zd2_7101;
																																																																									BgL_carzd242158zd2_7101
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd242153zd2_7099));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242158zd2_7101))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd242153zd2_7099))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242135zd2_7095))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5721z00_7106;
																																																																															BgL_arg5721z00_7106
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd242141zd2_7096));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24562;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24566;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24565;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24564;
																																																																																	obj_t
																																																																																		BgL_testz00_24563;
																																																																																	BgL_testz00_24563
																																																																																		=
																																																																																		BgL_arg5721z00_7106;
																																																																																	BgL_proc1z00_24564
																																																																																		=
																																																																																		BgL_carzd242152zd2_7098;
																																																																																	BgL_proc2z00_24565
																																																																																		=
																																																																																		BgL_carzd242158zd2_7101;
																																																																																	BgL_argsz00_24566
																																																																																		=
																																																																																		BgL_cdrzd242135zd2_7095;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_24566;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_24565;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_24564;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_24563;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24562);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24570;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24570);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24574;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24574);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24578;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24578);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24582;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24582);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24586;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24586);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd242491zd2_7114;
																																																																BgL_cdrzd242491zd2_7114
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd242498zd2_7115;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_12371;
																																																																		BgL_pairz00_12371
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd242498zd2_7115
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12371);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd242505zd2_7116;
																																																																		BgL_cdrzd242505zd2_7116
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd242498zd2_7115));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd242511zd2_7117;
																																																																			obj_t
																																																																				BgL_cdrzd242512zd2_7118;
																																																																			BgL_carzd242511zd2_7117
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7116));
																																																																			BgL_cdrzd242512zd2_7118
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7116));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242511zd2_7117))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd242512zd2_7118))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd242519zd2_7121;
																																																																							BgL_carzd242519zd2_7121
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd242512zd2_7118);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242519zd2_7121))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd242512zd2_7118)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242491zd2_7114))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5735z00_7126;
																																																																													BgL_arg5735z00_7126
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd242498zd2_7115));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24613;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24617;
																																																																															obj_t
																																																																																BgL_proc2z00_24616;
																																																																															obj_t
																																																																																BgL_proc1z00_24615;
																																																																															obj_t
																																																																																BgL_testz00_24614;
																																																																															BgL_testz00_24614
																																																																																=
																																																																																BgL_arg5735z00_7126;
																																																																															BgL_proc1z00_24615
																																																																																=
																																																																																BgL_carzd242511zd2_7117;
																																																																															BgL_proc2z00_24616
																																																																																=
																																																																																BgL_carzd242519zd2_7121;
																																																																															BgL_argsz00_24617
																																																																																=
																																																																																BgL_cdrzd242491zd2_7114;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_24617;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_24616;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_24615;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_24614;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24613);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24621;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24621);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24625;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24625);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24629;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24629);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24633;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24633);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24637;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24637);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24641;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24641);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd242912zd2_7140;
																																																BgL_cdrzd242912zd2_7140
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_24645;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5763z00_7157;
																																																		BgL_arg5763z00_7157
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_24645
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5763z00_7157));
																																																	}
																																																	if (BgL_testz00_24645)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5751z00_7143;
																																																			obj_t
																																																				BgL_arg5752z00_7144;
																																																			BgL_arg5751z00_7143
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7140));
																																																			BgL_arg5752z00_7144
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7140));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24654;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24656;
																																																					obj_t
																																																						BgL_bindingsz00_24655;
																																																					BgL_bindingsz00_24655
																																																						=
																																																						BgL_arg5751z00_7143;
																																																					BgL_exprz00_24656
																																																						=
																																																						BgL_arg5752z00_7144;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_24656;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_24655;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_21992
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24654);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_24658;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5762z00_7156;
																																																				BgL_arg5762z00_7156
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_24658
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5762z00_7156));
																																																			}
																																																			if (BgL_testz00_24658)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24663;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24663);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd242978zd2_7147;
																																																					BgL_carzd242978zd2_7147
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd242983zd2_7148;
																																																						BgL_cdrzd242983zd2_7148
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd242978zd2_7147));
																																																						if ((CAR(((obj_t) BgL_carzd242978zd2_7147)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5757z00_7151;
																																																								obj_t
																																																									BgL_arg5758z00_7152;
																																																								obj_t
																																																									BgL_arg5759z00_7153;
																																																								BgL_arg5757z00_7151
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7148));
																																																								BgL_arg5758z00_7152
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7148));
																																																								BgL_arg5759z00_7153
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24680;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_24683;
																																																										obj_t
																																																											BgL_bodyz00_24682;
																																																										obj_t
																																																											BgL_varsz00_24681;
																																																										BgL_varsz00_24681
																																																											=
																																																											BgL_arg5757z00_7151;
																																																										BgL_bodyz00_24682
																																																											=
																																																											BgL_arg5758z00_7152;
																																																										BgL_argsz00_24683
																																																											=
																																																											BgL_arg5759z00_7153;
																																																										BgL_argsz00_1734
																																																											=
																																																											BgL_argsz00_24683;
																																																										BgL_bodyz00_1733
																																																											=
																																																											BgL_bodyz00_24682;
																																																										BgL_varsz00_1732
																																																											=
																																																											BgL_varsz00_24681;
																																																										goto
																																																											BgL_tagzd2386zd2_1735;
																																																									}
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24680);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1769;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24687;
																																																										goto
																																																											BgL_tagzd2404zd2_1770;
																																																										BgL_auxz00_21992
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24687);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd243094zd2_7158;
																																														BgL_cdrzd243094zd2_7158
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_24691;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg5772z00_7167;
																																																BgL_arg5772z00_7167
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_24691
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg5772z00_7167));
																																															}
																																															if (BgL_testz00_24691)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg5766z00_7161;
																																																	obj_t
																																																		BgL_arg5767z00_7162;
																																																	BgL_arg5766z00_7161
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7158));
																																																	BgL_arg5767z00_7162
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7158));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24700;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24702;
																																																			obj_t
																																																				BgL_bindingsz00_24701;
																																																			BgL_bindingsz00_24701
																																																				=
																																																				BgL_arg5766z00_7161;
																																																			BgL_exprz00_24702
																																																				=
																																																				BgL_arg5767z00_7162;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_24702;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_24701;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24700);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_24704;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg5771z00_7166;
																																																		BgL_arg5771z00_7166
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_24704
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg5771z00_7166));
																																																	}
																																																	if (BgL_testz00_24704)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24709;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24709);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1769;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_24713;
																																																					goto
																																																						BgL_tagzd2404zd2_1770;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24713);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241659zd2_6894)))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd241661zd2_6896;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd241659zd2_6894 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd241661zd2_6896;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if ((BgL_carzd241659zd2_6894 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd241661zd2_6896;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241659zd2_6894)))
																																																			{	/* Ast/sexp.scm 118 */
																																																				goto
																																																					BgL_kapzd241661zd2_6896;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd243266zd2_6902;
																																																				BgL_cdrzd243266zd2_6902
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_24729;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5672z00_7019;
																																																						BgL_arg5672z00_7019
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_24729
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5672z00_7019));
																																																					}
																																																					if (BgL_testz00_24729)
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg5600z00_6905;
																																																							obj_t
																																																								BgL_arg5601z00_6906;
																																																							BgL_arg5600z00_6905
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6902));
																																																							BgL_arg5601z00_6906
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6902));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_24738;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_24740;
																																																									obj_t
																																																										BgL_bindingsz00_24739;
																																																									BgL_bindingsz00_24739
																																																										=
																																																										BgL_arg5600z00_6905;
																																																									BgL_exprz00_24740
																																																										=
																																																										BgL_arg5601z00_6906;
																																																									BgL_exprz00_1724
																																																										=
																																																										BgL_exprz00_24740;
																																																									BgL_bindingsz00_1723
																																																										=
																																																										BgL_bindingsz00_24739;
																																																									goto
																																																										BgL_tagzd2382zd2_1725;
																																																								}
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_24738);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							bool_t
																																																								BgL_testz00_24742;
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5671z00_7018;
																																																								BgL_arg5671z00_7018
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_testz00_24742
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5671z00_7018));
																																																							}
																																																							if (BgL_testz00_24742)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_24747;
																																																									goto
																																																										BgL_tagzd2384zd2_1727;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24747);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd243332zd2_6909;
																																																									BgL_carzd243332zd2_6909
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd243337zd2_6910;
																																																										BgL_cdrzd243337zd2_6910
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd243332zd2_6909));
																																																										if ((CAR(((obj_t) BgL_carzd243332zd2_6909)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd243337zd2_6910))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg5607z00_6914;
																																																														obj_t
																																																															BgL_arg5608z00_6915;
																																																														obj_t
																																																															BgL_arg5609z00_6916;
																																																														BgL_arg5607z00_6914
																																																															=
																																																															CAR
																																																															(BgL_cdrzd243337zd2_6910);
																																																														BgL_arg5608z00_6915
																																																															=
																																																															CDR
																																																															(BgL_cdrzd243337zd2_6910);
																																																														BgL_arg5609z00_6916
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24764;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_24767;
																																																																obj_t
																																																																	BgL_bodyz00_24766;
																																																																obj_t
																																																																	BgL_varsz00_24765;
																																																																BgL_varsz00_24765
																																																																	=
																																																																	BgL_arg5607z00_6914;
																																																																BgL_bodyz00_24766
																																																																	=
																																																																	BgL_arg5608z00_6915;
																																																																BgL_argsz00_24767
																																																																	=
																																																																	BgL_arg5609z00_6916;
																																																																BgL_argsz00_1734
																																																																	=
																																																																	BgL_argsz00_24767;
																																																																BgL_bodyz00_1733
																																																																	=
																																																																	BgL_bodyz00_24766;
																																																																BgL_varsz00_1732
																																																																	=
																																																																	BgL_varsz00_24765;
																																																																goto
																																																																	BgL_tagzd2386zd2_1735;
																																																															}
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24764);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_24771;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_24771);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd243444zd2_6919;
																																																												BgL_cdrzd243444zd2_6919
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd243449zd2_6920;
																																																													BgL_cdrzd243449zd2_6920
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd243332zd2_6909));
																																																													if ((CAR(((obj_t) BgL_carzd243332zd2_6909)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (PAIRP(BgL_cdrzd243449zd2_6920))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd243454zd2_6924;
																																																																	BgL_cdrzd243454zd2_6924
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd243449zd2_6920);
																																																																	if (PAIRP(BgL_cdrzd243454zd2_6924))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd243458zd2_6926;
																																																																			obj_t
																																																																				BgL_cdrzd243459zd2_6927;
																																																																			BgL_carzd243458zd2_6926
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd243454zd2_6924);
																																																																			BgL_cdrzd243459zd2_6927
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd243454zd2_6924);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243458zd2_6926))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd243459zd2_6927))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd243464zd2_6930;
																																																																							BgL_carzd243464zd2_6930
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd243459zd2_6927);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243464zd2_6930))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd243459zd2_6927)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_24799;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1438z00_6963;
																																																																												BgL_l1438z00_6963
																																																																													=
																																																																													BgL_cdrzd243444zd2_6919;
																																																																											BgL_zc3anonymousza35635ze3z83_6964:
																																																																												if (NULLP(BgL_l1438z00_6963))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_24799
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														bool_t
																																																																															BgL_testz00_24802;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															bool_t
																																																																																BgL_testz00_24803;
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_tmpz00_24804;
																																																																																BgL_tmpz00_24804
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1438z00_6963));
																																																																																BgL_testz00_24803
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_24804);
																																																																															}
																																																																															if (BgL_testz00_24803)
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_24802
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	BgL_testz00_24802
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_testz00_24802)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1438z00_24808;
																																																																																BgL_l1438z00_24808
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1438z00_6963));
																																																																																BgL_l1438z00_6963
																																																																																	=
																																																																																	BgL_l1438z00_24808;
																																																																																goto
																																																																																	BgL_zc3anonymousza35635ze3z83_6964;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																BgL_testz00_24799
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_testz00_24799)
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5625z00_6946;
																																																																													BgL_arg5625z00_6946
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd243449zd2_6920);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24812;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24816;
																																																																															obj_t
																																																																																BgL_proc2z00_24815;
																																																																															obj_t
																																																																																BgL_proc1z00_24814;
																																																																															obj_t
																																																																																BgL_testz00_24813;
																																																																															BgL_testz00_24813
																																																																																=
																																																																																BgL_arg5625z00_6946;
																																																																															BgL_proc1z00_24814
																																																																																=
																																																																																BgL_carzd243458zd2_6926;
																																																																															BgL_proc2z00_24815
																																																																																=
																																																																																BgL_carzd243464zd2_6930;
																																																																															BgL_argsz00_24816
																																																																																=
																																																																																BgL_cdrzd243444zd2_6919;
																																																																															BgL_argsz00_1739
																																																																																=
																																																																																BgL_argsz00_24816;
																																																																															BgL_proc2z00_1738
																																																																																=
																																																																																BgL_proc2z00_24815;
																																																																															BgL_proc1z00_1737
																																																																																=
																																																																																BgL_proc1z00_24814;
																																																																															BgL_testz00_1736
																																																																																=
																																																																																BgL_testz00_24813;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1740;
																																																																														}
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24812);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd243489zd2_6947;
																																																																													BgL_cdrzd243489zd2_6947
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_cdrzd243497zd2_6948;
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_pairz00_12428;
																																																																															BgL_pairz00_12428
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd243497zd2_6948
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12428);
																																																																														}
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_cdrzd243505zd2_6949;
																																																																															BgL_cdrzd243505zd2_6949
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd243497zd2_6948));
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd243512zd2_6950;
																																																																																BgL_carzd243512zd2_6950
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd243505zd2_6949));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243512zd2_6950))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_carzd243521zd2_6952;
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12432;
																																																																																			BgL_pairz00_12432
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd243505zd2_6949));
																																																																																			BgL_carzd243521zd2_6952
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_12432);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243521zd2_6952))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243489zd2_6947))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						obj_t
																																																																																							BgL_arg5629z00_6955;
																																																																																						BgL_arg5629z00_6955
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd243497zd2_6948));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24838;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24842;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24841;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24840;
																																																																																								obj_t
																																																																																									BgL_testz00_24839;
																																																																																								BgL_testz00_24839
																																																																																									=
																																																																																									BgL_arg5629z00_6955;
																																																																																								BgL_proc1z00_24840
																																																																																									=
																																																																																									BgL_carzd243512zd2_6950;
																																																																																								BgL_proc2z00_24841
																																																																																									=
																																																																																									BgL_carzd243521zd2_6952;
																																																																																								BgL_argsz00_24842
																																																																																									=
																																																																																									BgL_cdrzd243489zd2_6947;
																																																																																								BgL_argsz00_1744
																																																																																									=
																																																																																									BgL_argsz00_24842;
																																																																																								BgL_proc2z00_1743
																																																																																									=
																																																																																									BgL_proc2z00_24841;
																																																																																								BgL_proc1z00_1742
																																																																																									=
																																																																																									BgL_proc1z00_24840;
																																																																																								BgL_testz00_1741
																																																																																									=
																																																																																									BgL_testz00_24839;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1745;
																																																																																							}
																																																																																							BgL_auxz00_21992
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24838);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 118 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1769;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24846;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1770;
																																																																																								BgL_auxz00_21992
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24846);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24850;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24850);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24854;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24854);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24858;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24858);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd243799zd2_6974;
																																																																									BgL_cdrzd243799zd2_6974
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd243806zd2_6975;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12436;
																																																																											BgL_pairz00_12436
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd243806zd2_6975
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12436);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd243813zd2_6976;
																																																																											BgL_cdrzd243813zd2_6976
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd243806zd2_6975));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd243819zd2_6977;
																																																																												obj_t
																																																																													BgL_cdrzd243820zd2_6978;
																																																																												BgL_carzd243819zd2_6977
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_6976));
																																																																												BgL_cdrzd243820zd2_6978
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_6976));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243819zd2_6977))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd243827zd2_6980;
																																																																														BgL_carzd243827zd2_6980
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd243820zd2_6978));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243827zd2_6980))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd243820zd2_6978))))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243799zd2_6974))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg5644z00_6985;
																																																																																				BgL_arg5644z00_6985
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd243806zd2_6975));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24885;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24889;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24888;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24887;
																																																																																						obj_t
																																																																																							BgL_testz00_24886;
																																																																																						BgL_testz00_24886
																																																																																							=
																																																																																							BgL_arg5644z00_6985;
																																																																																						BgL_proc1z00_24887
																																																																																							=
																																																																																							BgL_carzd243819zd2_6977;
																																																																																						BgL_proc2z00_24888
																																																																																							=
																																																																																							BgL_carzd243827zd2_6980;
																																																																																						BgL_argsz00_24889
																																																																																							=
																																																																																							BgL_cdrzd243799zd2_6974;
																																																																																						BgL_argsz00_1744
																																																																																							=
																																																																																							BgL_argsz00_24889;
																																																																																						BgL_proc2z00_1743
																																																																																							=
																																																																																							BgL_proc2z00_24888;
																																																																																						BgL_proc1z00_1742
																																																																																							=
																																																																																							BgL_proc1z00_24887;
																																																																																						BgL_testz00_1741
																																																																																							=
																																																																																							BgL_testz00_24886;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1745;
																																																																																					}
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24885);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24893;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24893);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24897;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24897);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24901;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24901);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24905;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24905);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24909;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24909);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd244160zd2_6993;
																																																																					BgL_cdrzd244160zd2_6993
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd244166zd2_6994;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_12446;
																																																																							BgL_pairz00_12446
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd244166zd2_6994
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12446);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd244172zd2_6995;
																																																																							BgL_cdrzd244172zd2_6995
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd244166zd2_6994));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd244177zd2_6996;
																																																																								obj_t
																																																																									BgL_cdrzd244178zd2_6997;
																																																																								BgL_carzd244177zd2_6996
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_6995));
																																																																								BgL_cdrzd244178zd2_6997
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_6995));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244177zd2_6996))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (PAIRP(BgL_cdrzd244178zd2_6997))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd244183zd2_7000;
																																																																												BgL_carzd244183zd2_7000
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd244178zd2_6997);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244183zd2_7000))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (NULLP(CDR(BgL_cdrzd244178zd2_6997)))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd244160zd2_6993))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg5658z00_7005;
																																																																																		BgL_arg5658z00_7005
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd244166zd2_6994));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24936;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_24940;
																																																																																				obj_t
																																																																																					BgL_proc2z00_24939;
																																																																																				obj_t
																																																																																					BgL_proc1z00_24938;
																																																																																				obj_t
																																																																																					BgL_testz00_24937;
																																																																																				BgL_testz00_24937
																																																																																					=
																																																																																					BgL_arg5658z00_7005;
																																																																																				BgL_proc1z00_24938
																																																																																					=
																																																																																					BgL_carzd244177zd2_6996;
																																																																																				BgL_proc2z00_24939
																																																																																					=
																																																																																					BgL_carzd244183zd2_7000;
																																																																																				BgL_argsz00_24940
																																																																																					=
																																																																																					BgL_cdrzd244160zd2_6993;
																																																																																				BgL_argsz00_1744
																																																																																					=
																																																																																					BgL_argsz00_24940;
																																																																																				BgL_proc2z00_1743
																																																																																					=
																																																																																					BgL_proc2z00_24939;
																																																																																				BgL_proc1z00_1742
																																																																																					=
																																																																																					BgL_proc1z00_24938;
																																																																																				BgL_testz00_1741
																																																																																					=
																																																																																					BgL_testz00_24937;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1745;
																																																																																			}
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24936);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24944;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24944);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24948;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24948);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24952;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24952);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24956;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24956);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_24960;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_24960);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24964;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24964);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24968;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24968);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24972;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24972);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd241656zd2_6892 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg5774z00_7171;
																																											obj_t
																																												BgL_arg5775z00_7172;
																																											BgL_arg5774z00_7171
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6876));
																																											BgL_arg5775z00_7172
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6876));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_24981;
																																												{
																																													obj_t
																																														BgL_exprz00_24983;
																																													obj_t
																																														BgL_bindingsz00_24982;
																																													BgL_bindingsz00_24982
																																														=
																																														BgL_arg5774z00_7171;
																																													BgL_exprz00_24983
																																														=
																																														BgL_arg5775z00_7172;
																																													BgL_exprz00_1724
																																														=
																																														BgL_exprz00_24983;
																																													BgL_bindingsz00_1723
																																														=
																																														BgL_bindingsz00_24982;
																																													goto
																																														BgL_tagzd2382zd2_1725;
																																												}
																																												BgL_auxz00_21992
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_24981);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241656zd2_6892)))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg5777z00_7174;
																																													obj_t
																																														BgL_arg5778z00_7175;
																																													BgL_arg5777z00_7174
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6876));
																																													BgL_arg5778z00_7175
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6876));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_24992;
																																														{
																																															obj_t
																																																BgL_exprz00_24994;
																																															obj_t
																																																BgL_bindingsz00_24993;
																																															BgL_bindingsz00_24993
																																																=
																																																BgL_arg5777z00_7174;
																																															BgL_exprz00_24994
																																																=
																																																BgL_arg5778z00_7175;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_24994;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_24993;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_21992
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_24992);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((BgL_carzd241656zd2_6892 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg5780z00_7177;
																																															obj_t
																																																BgL_arg5781z00_7178;
																																															BgL_arg5780z00_7177
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6876));
																																															BgL_arg5781z00_7178
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6876));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25003;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25005;
																																																	obj_t
																																																		BgL_bindingsz00_25004;
																																																	BgL_bindingsz00_25004
																																																		=
																																																		BgL_arg5780z00_7177;
																																																	BgL_exprz00_25005
																																																		=
																																																		BgL_arg5781z00_7178;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_25005;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_25004;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25003);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25012;
																																																	goto
																																																		BgL_tagzd2383zd2_1726;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25012);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd244758zd2_7181;
																																																	BgL_carzd244758zd2_7181
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd244758zd2_7181 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25019;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25019);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd244758zd2_7181)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25024;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25024);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25031;
																																																							goto
																																																								BgL_tagzd2389zd2_1746;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25031);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25038;
																																																									goto
																																																										BgL_tagzd2390zd2_1747;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25038);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd244838zd2_7188;
																																																									BgL_cdrzd244838zd2_7188
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_arg5792z00_7191;
																																																											obj_t
																																																												BgL_arg5793z00_7192;
																																																											BgL_arg5792z00_7191
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7188));
																																																											BgL_arg5793z00_7192
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7188));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_25051;
																																																												{
																																																													obj_t
																																																														BgL_restz00_25053;
																																																													obj_t
																																																														BgL_effectz00_25052;
																																																													BgL_effectz00_25052
																																																														=
																																																														BgL_arg5792z00_7191;
																																																													BgL_restz00_25053
																																																														=
																																																														BgL_arg5793z00_7192;
																																																													BgL_restz00_1749
																																																														=
																																																														BgL_restz00_25053;
																																																													BgL_effectz00_1748
																																																														=
																																																														BgL_effectz00_25052;
																																																													goto
																																																														BgL_tagzd2391zd2_1750;
																																																												}
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_25051);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25060;
																																																													goto
																																																														BgL_tagzd2392zd2_1751;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25060);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25067;
																																																															goto
																																																																BgL_tagzd2393zd2_1752;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25067);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg5800z00_7200;
																																																																	obj_t
																																																																		BgL_arg5801z00_7201;
																																																																	BgL_arg5800z00_7200
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7188));
																																																																	BgL_arg5801z00_7201
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7188));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25078;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_25080;
																																																																			obj_t
																																																																				BgL_effectz00_25079;
																																																																			BgL_effectz00_25079
																																																																				=
																																																																				BgL_arg5800z00_7200;
																																																																			BgL_restz00_25080
																																																																				=
																																																																				BgL_arg5801z00_7201;
																																																																			BgL_restz00_1754
																																																																				=
																																																																				BgL_restz00_25080;
																																																																			BgL_effectz00_1753
																																																																				=
																																																																				BgL_effectz00_25079;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1755;
																																																																		}
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25078);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25087;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1756;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25087);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25094;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1757;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25094);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_25101;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1758;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25101);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_25108;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1759;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25108);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											bool_t
																																																																												BgL_testz00_25115;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_tmpz00_25116;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_12484;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12483;
																																																																														BgL_pairz00_12483
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_12484
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12483);
																																																																													}
																																																																													BgL_tmpz00_25116
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12484);
																																																																												}
																																																																												BgL_testz00_25115
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_25116);
																																																																											}
																																																																											if (BgL_testz00_25115)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25122;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1760;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25122);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25126;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25126);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd244931zd2_7220;
																																																																											BgL_cdrzd244931zd2_7220
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5822z00_7223;
																																																																													obj_t
																																																																														BgL_arg5823z00_7224;
																																																																													BgL_arg5822z00_7223
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7220));
																																																																													BgL_arg5823z00_7224
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7220));
																																																																													{	/* Ast/sexp.scm 563 */
																																																																														obj_t
																																																																															BgL_arg7000z00_12490;
																																																																														BgL_arg7000z00_12490
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5822z00_7223,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5823z00_7224, BgL_stackz00_22, BgL_arg7000z00_12490, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25145;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25145);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													obj_t
																														BgL_carzd244956zd2_7241;
																													BgL_carzd244956zd2_7241
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd244956zd2_7241
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_25152;
																															goto
																																BgL_tagzd2377zd2_1714;
																															BgL_auxz00_21992 =
																																((obj_t)
																																BgL_auxz00_25152);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(BgL_carzd244956zd2_7241
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_25156;
																																	goto
																																		BgL_tagzd2377zd2_1714;
																																	BgL_auxz00_21992
																																		=
																																		((obj_t)
																																		BgL_auxz00_25156);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_cdrzd244978zd2_7244;
																																	BgL_cdrzd244978zd2_7244
																																		=
																																		CDR(((obj_t)
																																			BgL_expz00_21));
																																	if ((CAR((
																																					(obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd244981zd2_7247;
																																			obj_t
																																				BgL_cdrzd244982zd2_7248;
																																			BgL_carzd244981zd2_7247
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7244));
																																			BgL_cdrzd244982zd2_7248
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7244));
																																			if (PAIRP
																																				(BgL_carzd244981zd2_7247))
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(BgL_carzd244981zd2_7247)
																																							==
																																							CNST_TABLE_REF
																																							(((long) 14))))
																																						{	/* Ast/sexp.scm 118 */
																																							if (NULLP(CDR(((obj_t) BgL_cdrzd244982zd2_7248))))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg5849z00_7254;
																																									obj_t
																																										BgL_arg5850z00_7255;
																																									BgL_arg5849z00_7254
																																										=
																																										CDR
																																										(BgL_carzd244981zd2_7247);
																																									BgL_arg5850z00_7255
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244982zd2_7248));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25182;
																																										{
																																											obj_t
																																												BgL_valz00_25184;
																																											obj_t
																																												BgL_lz00_25183;
																																											BgL_lz00_25183
																																												=
																																												BgL_arg5849z00_7254;
																																											BgL_valz00_25184
																																												=
																																												BgL_arg5850z00_7255;
																																											BgL_valz00_1716
																																												=
																																												BgL_valz00_25184;
																																											BgL_lz00_1715
																																												=
																																												BgL_lz00_25183;
																																											goto
																																												BgL_tagzd2378zd2_1717;
																																										}
																																										BgL_auxz00_21992
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25182);
																																									}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_25186;
																																									goto
																																										BgL_tagzd2379zd2_1718;
																																									BgL_auxz00_21992
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_25186);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_25188;
																																							goto
																																								BgL_tagzd2379zd2_1718;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_25188);
																																						}
																																				}
																																			else
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25190;
																																					goto
																																						BgL_tagzd2379zd2_1718;
																																					BgL_auxz00_21992
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25190);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25197;
																																					goto
																																						BgL_tagzd2380zd2_1719;
																																					BgL_auxz00_21992
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25197);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd245079zd2_7260;
																																					BgL_carzd245079zd2_7260
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd245079zd2_7260))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd245082zd2_7262;
																																							obj_t
																																								BgL_cdrzd245083zd2_7263;
																																							BgL_carzd245082zd2_7262
																																								=
																																								CAR
																																								(BgL_carzd245079zd2_7260);
																																							BgL_cdrzd245083zd2_7263
																																								=
																																								CDR
																																								(BgL_carzd245079zd2_7260);
																																							{

																																								if ((BgL_carzd245082zd2_7262 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 118 */
																																									BgL_kapzd245084zd2_7264:
																																										if (PAIRP(BgL_cdrzd245083zd2_7263))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd245087zd2_7389;
																																												BgL_cdrzd245087zd2_7389
																																													=
																																													CDR
																																													(BgL_cdrzd245083zd2_7263);
																																												if (PAIRP(BgL_cdrzd245087zd2_7389))
																																													{	/* Ast/sexp.scm 118 */
																																														if (NULLP(CDR(BgL_cdrzd245087zd2_7389)))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg5940z00_7393;
																																																obj_t
																																																	BgL_arg5941z00_7394;
																																																BgL_arg5940z00_7393
																																																	=
																																																	CAR
																																																	(BgL_cdrzd245087zd2_7389);
																																																BgL_arg5941z00_7394
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25219;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_25221;
																																																		obj_t
																																																			BgL_bodyz00_25220;
																																																		BgL_bodyz00_25220
																																																			=
																																																			BgL_arg5940z00_7393;
																																																		BgL_argsz00_25221
																																																			=
																																																			BgL_arg5941z00_7394;
																																																		BgL_argsz00_1721
																																																			=
																																																			BgL_argsz00_25221;
																																																		BgL_bodyz00_1720
																																																			=
																																																			BgL_bodyz00_25220;
																																																		goto
																																																			BgL_tagzd2381zd2_1722;
																																																	}
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25219);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd245111zd2_7395;
																																																BgL_cdrzd245111zd2_7395
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_25225;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6010z00_7506;
																																																		BgL_arg6010z00_7506
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_25225
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6010z00_7506));
																																																	}
																																																	if (BgL_testz00_25225)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg5944z00_7398;
																																																			obj_t
																																																				BgL_arg5945z00_7399;
																																																			BgL_arg5944z00_7398
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7395));
																																																			BgL_arg5945z00_7399
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7395));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_25234;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_25236;
																																																					obj_t
																																																						BgL_bindingsz00_25235;
																																																					BgL_bindingsz00_25235
																																																						=
																																																						BgL_arg5944z00_7398;
																																																					BgL_exprz00_25236
																																																						=
																																																						BgL_arg5945z00_7399;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_25236;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_25235;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_21992
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_25234);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_25238;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6009z00_7505;
																																																				BgL_arg6009z00_7505
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_25238
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6009z00_7505));
																																																			}
																																																			if (BgL_testz00_25238)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25243;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25243);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd245178zd2_7402;
																																																					BgL_carzd245178zd2_7402
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd245183zd2_7403;
																																																						BgL_cdrzd245183zd2_7403
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd245178zd2_7402));
																																																						if ((CAR(((obj_t) BgL_carzd245178zd2_7402)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_arg5950z00_7406;
																																																								obj_t
																																																									BgL_arg5951z00_7407;
																																																								obj_t
																																																									BgL_arg5952z00_7408;
																																																								BgL_arg5950z00_7406
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7403));
																																																								BgL_arg5951z00_7407
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7403));
																																																								BgL_arg5952z00_7408
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25260;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_25263;
																																																										obj_t
																																																											BgL_bodyz00_25262;
																																																										obj_t
																																																											BgL_varsz00_25261;
																																																										BgL_varsz00_25261
																																																											=
																																																											BgL_arg5950z00_7406;
																																																										BgL_bodyz00_25262
																																																											=
																																																											BgL_arg5951z00_7407;
																																																										BgL_argsz00_25263
																																																											=
																																																											BgL_arg5952z00_7408;
																																																										BgL_argsz00_1734
																																																											=
																																																											BgL_argsz00_25263;
																																																										BgL_bodyz00_1733
																																																											=
																																																											BgL_bodyz00_25262;
																																																										BgL_varsz00_1732
																																																											=
																																																											BgL_varsz00_25261;
																																																										goto
																																																											BgL_tagzd2386zd2_1735;
																																																									}
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25260);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd245206zd2_7410;
																																																								BgL_cdrzd245206zd2_7410
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd245212zd2_7411;
																																																									BgL_cdrzd245212zd2_7411
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd245178zd2_7402));
																																																									if ((CAR(((obj_t) BgL_carzd245178zd2_7402)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd245218zd2_7414;
																																																											BgL_cdrzd245218zd2_7414
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd245212zd2_7411));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd245223zd2_7415;
																																																												obj_t
																																																													BgL_cdrzd245224zd2_7416;
																																																												BgL_carzd245223zd2_7415
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7414));
																																																												BgL_cdrzd245224zd2_7416
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7414));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245223zd2_7415))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd245224zd2_7416))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd245231zd2_7419;
																																																																BgL_carzd245231zd2_7419
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd245224zd2_7416);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245231zd2_7419))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd245224zd2_7416)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_testz00_25290;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1441z00_7452;
																																																																					BgL_l1441z00_7452
																																																																						=
																																																																						BgL_cdrzd245206zd2_7410;
																																																																				BgL_zc3anonymousza35975ze3z83_7453:
																																																																					if (NULLP(BgL_l1441z00_7452))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_25290
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_testz00_25293;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								bool_t
																																																																									BgL_testz00_25294;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_tmpz00_25295;
																																																																									BgL_tmpz00_25295
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1441z00_7452));
																																																																									BgL_testz00_25294
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_25295);
																																																																								}
																																																																								if (BgL_testz00_25294)
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_25293
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										BgL_testz00_25293
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_testz00_25293)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1441z00_25299;
																																																																									BgL_l1441z00_25299
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1441z00_7452));
																																																																									BgL_l1441z00_7452
																																																																										=
																																																																										BgL_l1441z00_25299;
																																																																									goto
																																																																										BgL_zc3anonymousza35975ze3z83_7453;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_25290
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_testz00_25290)
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg5965z00_7435;
																																																																						BgL_arg5965z00_7435
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd245212zd2_7411));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25304;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_25308;
																																																																								obj_t
																																																																									BgL_proc2z00_25307;
																																																																								obj_t
																																																																									BgL_proc1z00_25306;
																																																																								obj_t
																																																																									BgL_testz00_25305;
																																																																								BgL_testz00_25305
																																																																									=
																																																																									BgL_arg5965z00_7435;
																																																																								BgL_proc1z00_25306
																																																																									=
																																																																									BgL_carzd245223zd2_7415;
																																																																								BgL_proc2z00_25307
																																																																									=
																																																																									BgL_carzd245231zd2_7419;
																																																																								BgL_argsz00_25308
																																																																									=
																																																																									BgL_cdrzd245206zd2_7410;
																																																																								BgL_argsz00_1739
																																																																									=
																																																																									BgL_argsz00_25308;
																																																																								BgL_proc2z00_1738
																																																																									=
																																																																									BgL_proc2z00_25307;
																																																																								BgL_proc1z00_1737
																																																																									=
																																																																									BgL_proc1z00_25306;
																																																																								BgL_testz00_1736
																																																																									=
																																																																									BgL_testz00_25305;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1740;
																																																																							}
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25304);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd245255zd2_7436;
																																																																						BgL_cdrzd245255zd2_7436
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd245262zd2_7437;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_pairz00_12543;
																																																																								BgL_pairz00_12543
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd245262zd2_7437
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12543);
																																																																							}
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd245269zd2_7438;
																																																																								BgL_cdrzd245269zd2_7438
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd245262zd2_7437));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd245275zd2_7439;
																																																																									BgL_carzd245275zd2_7439
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd245269zd2_7438));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245275zd2_7439))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd245282zd2_7441;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_12547;
																																																																												BgL_pairz00_12547
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd245269zd2_7438));
																																																																												BgL_carzd245282zd2_7441
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_12547);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245282zd2_7441))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245255zd2_7436))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg5969z00_7444;
																																																																															BgL_arg5969z00_7444
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd245262zd2_7437));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25330;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_25334;
																																																																																	obj_t
																																																																																		BgL_proc2z00_25333;
																																																																																	obj_t
																																																																																		BgL_proc1z00_25332;
																																																																																	obj_t
																																																																																		BgL_testz00_25331;
																																																																																	BgL_testz00_25331
																																																																																		=
																																																																																		BgL_arg5969z00_7444;
																																																																																	BgL_proc1z00_25332
																																																																																		=
																																																																																		BgL_carzd245275zd2_7439;
																																																																																	BgL_proc2z00_25333
																																																																																		=
																																																																																		BgL_carzd245282zd2_7441;
																																																																																	BgL_argsz00_25334
																																																																																		=
																																																																																		BgL_cdrzd245255zd2_7436;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_25334;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_25333;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_25332;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_25331;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25330);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25338;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25338);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25342;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25342);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25346;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25346);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_25350;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_25350);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd245558zd2_7463;
																																																																		BgL_cdrzd245558zd2_7463
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd245564zd2_7464;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_pairz00_12551;
																																																																				BgL_pairz00_12551
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd245564zd2_7464
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12551);
																																																																			}
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd245570zd2_7465;
																																																																				BgL_cdrzd245570zd2_7465
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd245564zd2_7464));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd245575zd2_7466;
																																																																					obj_t
																																																																						BgL_cdrzd245576zd2_7467;
																																																																					BgL_carzd245575zd2_7466
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7465));
																																																																					BgL_cdrzd245576zd2_7467
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7465));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245575zd2_7466))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd245581zd2_7469;
																																																																							BgL_carzd245581zd2_7469
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd245576zd2_7467));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245581zd2_7469))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd245576zd2_7467))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245558zd2_7463))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg5984z00_7474;
																																																																													BgL_arg5984z00_7474
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd245564zd2_7464));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25377;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_25381;
																																																																															obj_t
																																																																																BgL_proc2z00_25380;
																																																																															obj_t
																																																																																BgL_proc1z00_25379;
																																																																															obj_t
																																																																																BgL_testz00_25378;
																																																																															BgL_testz00_25378
																																																																																=
																																																																																BgL_arg5984z00_7474;
																																																																															BgL_proc1z00_25379
																																																																																=
																																																																																BgL_carzd245575zd2_7466;
																																																																															BgL_proc2z00_25380
																																																																																=
																																																																																BgL_carzd245581zd2_7469;
																																																																															BgL_argsz00_25381
																																																																																=
																																																																																BgL_cdrzd245558zd2_7463;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_25381;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_25380;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_25379;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_25378;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25377);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25385;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25385);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25389;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25389);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25393;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25393);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25397;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25397);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25401;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25401);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd245914zd2_7482;
																																																														BgL_cdrzd245914zd2_7482
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd245921zd2_7483;
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_pairz00_12561;
																																																																BgL_pairz00_12561
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd245921zd2_7483
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_12561);
																																																															}
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd245928zd2_7484;
																																																																BgL_cdrzd245928zd2_7484
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd245921zd2_7483));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd245934zd2_7485;
																																																																	obj_t
																																																																		BgL_cdrzd245935zd2_7486;
																																																																	BgL_carzd245934zd2_7485
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7484));
																																																																	BgL_cdrzd245935zd2_7486
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7484));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245934zd2_7485))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd245935zd2_7486))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd245942zd2_7489;
																																																																					BgL_carzd245942zd2_7489
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd245935zd2_7486);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245942zd2_7489))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd245935zd2_7486)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245914zd2_7482))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg5998z00_7494;
																																																																											BgL_arg5998z00_7494
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd245921zd2_7483));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25428;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25432;
																																																																													obj_t
																																																																														BgL_proc2z00_25431;
																																																																													obj_t
																																																																														BgL_proc1z00_25430;
																																																																													obj_t
																																																																														BgL_testz00_25429;
																																																																													BgL_testz00_25429
																																																																														=
																																																																														BgL_arg5998z00_7494;
																																																																													BgL_proc1z00_25430
																																																																														=
																																																																														BgL_carzd245934zd2_7485;
																																																																													BgL_proc2z00_25431
																																																																														=
																																																																														BgL_carzd245942zd2_7489;
																																																																													BgL_argsz00_25432
																																																																														=
																																																																														BgL_cdrzd245914zd2_7482;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_25432;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_25431;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_25430;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_25429;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25428);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25436;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25436);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25440;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25440);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25444;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25444);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25448;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25448);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25452;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25452);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25456;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25456);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd246335zd2_7508;
																																														BgL_cdrzd246335zd2_7508
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_25460;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6026z00_7525;
																																																BgL_arg6026z00_7525
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_25460
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6026z00_7525));
																																															}
																																															if (BgL_testz00_25460)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg6014z00_7511;
																																																	obj_t
																																																		BgL_arg6015z00_7512;
																																																	BgL_arg6014z00_7511
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7508));
																																																	BgL_arg6015z00_7512
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7508));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_25469;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_25471;
																																																			obj_t
																																																				BgL_bindingsz00_25470;
																																																			BgL_bindingsz00_25470
																																																				=
																																																				BgL_arg6014z00_7511;
																																																			BgL_exprz00_25471
																																																				=
																																																				BgL_arg6015z00_7512;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_25471;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_25470;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_25469);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_25473;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6025z00_7524;
																																																		BgL_arg6025z00_7524
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_25473
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6025z00_7524));
																																																	}
																																																	if (BgL_testz00_25473)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25478;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25478);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd246401zd2_7515;
																																																			BgL_carzd246401zd2_7515
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd246406zd2_7516;
																																																				BgL_cdrzd246406zd2_7516
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd246401zd2_7515));
																																																				if ((CAR(((obj_t) BgL_carzd246401zd2_7515)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg6020z00_7519;
																																																						obj_t
																																																							BgL_arg6021z00_7520;
																																																						obj_t
																																																							BgL_arg6022z00_7521;
																																																						BgL_arg6020z00_7519
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7516));
																																																						BgL_arg6021z00_7520
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7516));
																																																						BgL_arg6022z00_7521
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25495;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_25498;
																																																								obj_t
																																																									BgL_bodyz00_25497;
																																																								obj_t
																																																									BgL_varsz00_25496;
																																																								BgL_varsz00_25496
																																																									=
																																																									BgL_arg6020z00_7519;
																																																								BgL_bodyz00_25497
																																																									=
																																																									BgL_arg6021z00_7520;
																																																								BgL_argsz00_25498
																																																									=
																																																									BgL_arg6022z00_7521;
																																																								BgL_argsz00_1734
																																																									=
																																																									BgL_argsz00_25498;
																																																								BgL_bodyz00_1733
																																																									=
																																																									BgL_bodyz00_25497;
																																																								BgL_varsz00_1732
																																																									=
																																																									BgL_varsz00_25496;
																																																								goto
																																																									BgL_tagzd2386zd2_1735;
																																																							}
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25495);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1769;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_25502;
																																																								goto
																																																									BgL_tagzd2404zd2_1770;
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_25502);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd246517zd2_7526;
																																												BgL_cdrzd246517zd2_7526
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_testz00_25506;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6035z00_7535;
																																														BgL_arg6035z00_7535
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_testz00_25506
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6035z00_7535));
																																													}
																																													if (BgL_testz00_25506)
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6029z00_7529;
																																															obj_t
																																																BgL_arg6030z00_7530;
																																															BgL_arg6029z00_7529
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7526));
																																															BgL_arg6030z00_7530
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7526));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25515;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25517;
																																																	obj_t
																																																		BgL_bindingsz00_25516;
																																																	BgL_bindingsz00_25516
																																																		=
																																																		BgL_arg6029z00_7529;
																																																	BgL_exprz00_25517
																																																		=
																																																		BgL_arg6030z00_7530;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_25517;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_25516;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25515);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_25519;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6034z00_7534;
																																																BgL_arg6034z00_7534
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_25519
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6034z00_7534));
																																															}
																																															if (BgL_testz00_25519)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25524;
																																																	goto
																																																		BgL_tagzd2384zd2_1727;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25524);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1769;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_25528;
																																																			goto
																																																				BgL_tagzd2404zd2_1770;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25528);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245082zd2_7262)))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd245084zd2_7264;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd245082zd2_7262 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd245084zd2_7264;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if ((BgL_carzd245082zd2_7262 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd245084zd2_7264;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd245082zd2_7262)))
																																																	{	/* Ast/sexp.scm 118 */
																																																		goto
																																																			BgL_kapzd245084zd2_7264;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd246689zd2_7270;
																																																		BgL_cdrzd246689zd2_7270
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_25544;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg5935z00_7387;
																																																				BgL_arg5935z00_7387
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_25544
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5935z00_7387));
																																																			}
																																																			if (BgL_testz00_25544)
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg5863z00_7273;
																																																					obj_t
																																																						BgL_arg5864z00_7274;
																																																					BgL_arg5863z00_7273
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7270));
																																																					BgL_arg5864z00_7274
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7270));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_25553;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_25555;
																																																							obj_t
																																																								BgL_bindingsz00_25554;
																																																							BgL_bindingsz00_25554
																																																								=
																																																								BgL_arg5863z00_7273;
																																																							BgL_exprz00_25555
																																																								=
																																																								BgL_arg5864z00_7274;
																																																							BgL_exprz00_1724
																																																								=
																																																								BgL_exprz00_25555;
																																																							BgL_bindingsz00_1723
																																																								=
																																																								BgL_bindingsz00_25554;
																																																							goto
																																																								BgL_tagzd2382zd2_1725;
																																																						}
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_25553);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					bool_t
																																																						BgL_testz00_25557;
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg5934z00_7386;
																																																						BgL_arg5934z00_7386
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_testz00_25557
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5934z00_7386));
																																																					}
																																																					if (BgL_testz00_25557)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_25562;
																																																							goto
																																																								BgL_tagzd2384zd2_1727;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25562);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd246755zd2_7277;
																																																							BgL_carzd246755zd2_7277
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd246760zd2_7278;
																																																								BgL_cdrzd246760zd2_7278
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd246755zd2_7277));
																																																								if ((CAR(((obj_t) BgL_carzd246755zd2_7277)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd246760zd2_7278))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg5870z00_7282;
																																																												obj_t
																																																													BgL_arg5871z00_7283;
																																																												obj_t
																																																													BgL_arg5872z00_7284;
																																																												BgL_arg5870z00_7282
																																																													=
																																																													CAR
																																																													(BgL_cdrzd246760zd2_7278);
																																																												BgL_arg5871z00_7283
																																																													=
																																																													CDR
																																																													(BgL_cdrzd246760zd2_7278);
																																																												BgL_arg5872z00_7284
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25579;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_25582;
																																																														obj_t
																																																															BgL_bodyz00_25581;
																																																														obj_t
																																																															BgL_varsz00_25580;
																																																														BgL_varsz00_25580
																																																															=
																																																															BgL_arg5870z00_7282;
																																																														BgL_bodyz00_25581
																																																															=
																																																															BgL_arg5871z00_7283;
																																																														BgL_argsz00_25582
																																																															=
																																																															BgL_arg5872z00_7284;
																																																														BgL_argsz00_1734
																																																															=
																																																															BgL_argsz00_25582;
																																																														BgL_bodyz00_1733
																																																															=
																																																															BgL_bodyz00_25581;
																																																														BgL_varsz00_1732
																																																															=
																																																															BgL_varsz00_25580;
																																																														goto
																																																															BgL_tagzd2386zd2_1735;
																																																													}
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25579);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_25586;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_25586);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd246867zd2_7287;
																																																										BgL_cdrzd246867zd2_7287
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd246872zd2_7288;
																																																											BgL_cdrzd246872zd2_7288
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd246755zd2_7277));
																																																											if ((CAR(((obj_t) BgL_carzd246755zd2_7277)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd246872zd2_7288))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd246877zd2_7292;
																																																															BgL_cdrzd246877zd2_7292
																																																																=
																																																																CDR
																																																																(BgL_cdrzd246872zd2_7288);
																																																															if (PAIRP(BgL_cdrzd246877zd2_7292))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_carzd246881zd2_7294;
																																																																	obj_t
																																																																		BgL_cdrzd246882zd2_7295;
																																																																	BgL_carzd246881zd2_7294
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd246877zd2_7292);
																																																																	BgL_cdrzd246882zd2_7295
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd246877zd2_7292);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246881zd2_7294))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd246882zd2_7295))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd246887zd2_7298;
																																																																					BgL_carzd246887zd2_7298
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd246882zd2_7295);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246887zd2_7298))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd246882zd2_7295)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_25614;
																																																																									{
																																																																										obj_t
																																																																											BgL_l1444z00_7331;
																																																																										BgL_l1444z00_7331
																																																																											=
																																																																											BgL_cdrzd246867zd2_7287;
																																																																									BgL_zc3anonymousza35898ze3z83_7332:
																																																																										if (NULLP(BgL_l1444z00_7331))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_25614
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												bool_t
																																																																													BgL_testz00_25617;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													bool_t
																																																																														BgL_testz00_25618;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_tmpz00_25619;
																																																																														BgL_tmpz00_25619
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_l1444z00_7331));
																																																																														BgL_testz00_25618
																																																																															=
																																																																															PAIRP
																																																																															(BgL_tmpz00_25619);
																																																																													}
																																																																													if (BgL_testz00_25618)
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_testz00_25617
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															BgL_testz00_25617
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																												}
																																																																												if (BgL_testz00_25617)
																																																																													{
																																																																														obj_t
																																																																															BgL_l1444z00_25623;
																																																																														BgL_l1444z00_25623
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_l1444z00_7331));
																																																																														BgL_l1444z00_7331
																																																																															=
																																																																															BgL_l1444z00_25623;
																																																																														goto
																																																																															BgL_zc3anonymousza35898ze3z83_7332;
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														BgL_testz00_25614
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																											}
																																																																									}
																																																																									if (BgL_testz00_25614)
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg5888z00_7314;
																																																																											BgL_arg5888z00_7314
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd246872zd2_7288);
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25627;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25631;
																																																																													obj_t
																																																																														BgL_proc2z00_25630;
																																																																													obj_t
																																																																														BgL_proc1z00_25629;
																																																																													obj_t
																																																																														BgL_testz00_25628;
																																																																													BgL_testz00_25628
																																																																														=
																																																																														BgL_arg5888z00_7314;
																																																																													BgL_proc1z00_25629
																																																																														=
																																																																														BgL_carzd246881zd2_7294;
																																																																													BgL_proc2z00_25630
																																																																														=
																																																																														BgL_carzd246887zd2_7298;
																																																																													BgL_argsz00_25631
																																																																														=
																																																																														BgL_cdrzd246867zd2_7287;
																																																																													BgL_argsz00_1739
																																																																														=
																																																																														BgL_argsz00_25631;
																																																																													BgL_proc2z00_1738
																																																																														=
																																																																														BgL_proc2z00_25630;
																																																																													BgL_proc1z00_1737
																																																																														=
																																																																														BgL_proc1z00_25629;
																																																																													BgL_testz00_1736
																																																																														=
																																																																														BgL_testz00_25628;
																																																																													goto
																																																																														BgL_tagzd2387zd2_1740;
																																																																												}
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25627);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd246912zd2_7315;
																																																																											BgL_cdrzd246912zd2_7315
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd246920zd2_7316;
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_pairz00_12618;
																																																																													BgL_pairz00_12618
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd246920zd2_7316
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12618);
																																																																												}
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd246928zd2_7317;
																																																																													BgL_cdrzd246928zd2_7317
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd246920zd2_7316));
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_carzd246935zd2_7318;
																																																																														BgL_carzd246935zd2_7318
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd246928zd2_7317));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246935zd2_7318))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_carzd246944zd2_7320;
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12622;
																																																																																	BgL_pairz00_12622
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd246928zd2_7317));
																																																																																	BgL_carzd246944zd2_7320
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_pairz00_12622);
																																																																																}
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246944zd2_7320))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd246912zd2_7315))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				obj_t
																																																																																					BgL_arg5892z00_7323;
																																																																																				BgL_arg5892z00_7323
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd246920zd2_7316));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_25653;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_25657;
																																																																																						obj_t
																																																																																							BgL_proc2z00_25656;
																																																																																						obj_t
																																																																																							BgL_proc1z00_25655;
																																																																																						obj_t
																																																																																							BgL_testz00_25654;
																																																																																						BgL_testz00_25654
																																																																																							=
																																																																																							BgL_arg5892z00_7323;
																																																																																						BgL_proc1z00_25655
																																																																																							=
																																																																																							BgL_carzd246935zd2_7318;
																																																																																						BgL_proc2z00_25656
																																																																																							=
																																																																																							BgL_carzd246944zd2_7320;
																																																																																						BgL_argsz00_25657
																																																																																							=
																																																																																							BgL_cdrzd246912zd2_7315;
																																																																																						BgL_argsz00_1744
																																																																																							=
																																																																																							BgL_argsz00_25657;
																																																																																						BgL_proc2z00_1743
																																																																																							=
																																																																																							BgL_proc2z00_25656;
																																																																																						BgL_proc1z00_1742
																																																																																							=
																																																																																							BgL_proc1z00_25655;
																																																																																						BgL_testz00_1741
																																																																																							=
																																																																																							BgL_testz00_25654;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1745;
																																																																																					}
																																																																																					BgL_auxz00_21992
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_25653);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 118 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1769;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25661;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1770;
																																																																																						BgL_auxz00_21992
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25661);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25665;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25665);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25669;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25669);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25673;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25673);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd247222zd2_7342;
																																																																							BgL_cdrzd247222zd2_7342
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd247229zd2_7343;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_12626;
																																																																									BgL_pairz00_12626
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd247229zd2_7343
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12626);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd247236zd2_7344;
																																																																									BgL_cdrzd247236zd2_7344
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd247229zd2_7343));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd247242zd2_7345;
																																																																										obj_t
																																																																											BgL_cdrzd247243zd2_7346;
																																																																										BgL_carzd247242zd2_7345
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7344));
																																																																										BgL_cdrzd247243zd2_7346
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7344));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247242zd2_7345))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_carzd247250zd2_7348;
																																																																												BgL_carzd247250zd2_7348
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd247243zd2_7346));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247250zd2_7348))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (NULLP(CDR(((obj_t) BgL_cdrzd247243zd2_7346))))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247222zd2_7342))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		obj_t
																																																																																			BgL_arg5907z00_7353;
																																																																																		BgL_arg5907z00_7353
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd247229zd2_7343));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25700;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25704;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25703;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25702;
																																																																																				obj_t
																																																																																					BgL_testz00_25701;
																																																																																				BgL_testz00_25701
																																																																																					=
																																																																																					BgL_arg5907z00_7353;
																																																																																				BgL_proc1z00_25702
																																																																																					=
																																																																																					BgL_carzd247242zd2_7345;
																																																																																				BgL_proc2z00_25703
																																																																																					=
																																																																																					BgL_carzd247250zd2_7348;
																																																																																				BgL_argsz00_25704
																																																																																					=
																																																																																					BgL_cdrzd247222zd2_7342;
																																																																																				BgL_argsz00_1744
																																																																																					=
																																																																																					BgL_argsz00_25704;
																																																																																				BgL_proc2z00_1743
																																																																																					=
																																																																																					BgL_proc2z00_25703;
																																																																																				BgL_proc1z00_1742
																																																																																					=
																																																																																					BgL_proc1z00_25702;
																																																																																				BgL_testz00_1741
																																																																																					=
																																																																																					BgL_testz00_25701;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1745;
																																																																																			}
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25700);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 118 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1769;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25708;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1770;
																																																																																				BgL_auxz00_21992
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25708);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25712;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25712);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25716;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25716);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25720;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25720);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25724;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25724);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd247583zd2_7361;
																																																																			BgL_cdrzd247583zd2_7361
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd247589zd2_7362;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_12636;
																																																																					BgL_pairz00_12636
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd247589zd2_7362
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12636);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd247595zd2_7363;
																																																																					BgL_cdrzd247595zd2_7363
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd247589zd2_7362));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd247600zd2_7364;
																																																																						obj_t
																																																																							BgL_cdrzd247601zd2_7365;
																																																																						BgL_carzd247600zd2_7364
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7363));
																																																																						BgL_cdrzd247601zd2_7365
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7363));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247600zd2_7364))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (PAIRP(BgL_cdrzd247601zd2_7365))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd247606zd2_7368;
																																																																										BgL_carzd247606zd2_7368
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd247601zd2_7365);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247606zd2_7368))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (NULLP(CDR(BgL_cdrzd247601zd2_7365)))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247583zd2_7361))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg5921z00_7373;
																																																																																BgL_arg5921z00_7373
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd247589zd2_7362));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25751;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_argsz00_25755;
																																																																																		obj_t
																																																																																			BgL_proc2z00_25754;
																																																																																		obj_t
																																																																																			BgL_proc1z00_25753;
																																																																																		obj_t
																																																																																			BgL_testz00_25752;
																																																																																		BgL_testz00_25752
																																																																																			=
																																																																																			BgL_arg5921z00_7373;
																																																																																		BgL_proc1z00_25753
																																																																																			=
																																																																																			BgL_carzd247600zd2_7364;
																																																																																		BgL_proc2z00_25754
																																																																																			=
																																																																																			BgL_carzd247606zd2_7368;
																																																																																		BgL_argsz00_25755
																																																																																			=
																																																																																			BgL_cdrzd247583zd2_7361;
																																																																																		BgL_argsz00_1744
																																																																																			=
																																																																																			BgL_argsz00_25755;
																																																																																		BgL_proc2z00_1743
																																																																																			=
																																																																																			BgL_proc2z00_25754;
																																																																																		BgL_proc1z00_1742
																																																																																			=
																																																																																			BgL_proc1z00_25753;
																																																																																		BgL_testz00_1741
																																																																																			=
																																																																																			BgL_testz00_25752;
																																																																																		goto
																																																																																			BgL_tagzd2388zd2_1745;
																																																																																	}
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25751);
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 118 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1769;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25759;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1770;
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25759);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25763;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25763);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25767;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25767);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25771;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25771);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25775;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25775);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25779;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25779);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25783;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25783);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25787;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25787);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((BgL_carzd245079zd2_7260 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg6037z00_7539;
																																									obj_t
																																										BgL_arg6038z00_7540;
																																									BgL_arg6037z00_7539
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7244));
																																									BgL_arg6038z00_7540
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7244));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25796;
																																										{
																																											obj_t
																																												BgL_exprz00_25798;
																																											obj_t
																																												BgL_bindingsz00_25797;
																																											BgL_bindingsz00_25797
																																												=
																																												BgL_arg6037z00_7539;
																																											BgL_exprz00_25798
																																												=
																																												BgL_arg6038z00_7540;
																																											BgL_exprz00_1724
																																												=
																																												BgL_exprz00_25798;
																																											BgL_bindingsz00_1723
																																												=
																																												BgL_bindingsz00_25797;
																																											goto
																																												BgL_tagzd2382zd2_1725;
																																										}
																																										BgL_auxz00_21992
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25796);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245079zd2_7260)))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg6040z00_7542;
																																											obj_t
																																												BgL_arg6041z00_7543;
																																											BgL_arg6040z00_7542
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7244));
																																											BgL_arg6041z00_7543
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7244));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25807;
																																												{
																																													obj_t
																																														BgL_exprz00_25809;
																																													obj_t
																																														BgL_bindingsz00_25808;
																																													BgL_bindingsz00_25808
																																														=
																																														BgL_arg6040z00_7542;
																																													BgL_exprz00_25809
																																														=
																																														BgL_arg6041z00_7543;
																																													BgL_exprz00_1724
																																														=
																																														BgL_exprz00_25809;
																																													BgL_bindingsz00_1723
																																														=
																																														BgL_bindingsz00_25808;
																																													goto
																																														BgL_tagzd2382zd2_1725;
																																												}
																																												BgL_auxz00_21992
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25807);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((BgL_carzd245079zd2_7260 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg6043z00_7545;
																																													obj_t
																																														BgL_arg6044z00_7546;
																																													BgL_arg6043z00_7545
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7244));
																																													BgL_arg6044z00_7546
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7244));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25818;
																																														{
																																															obj_t
																																																BgL_exprz00_25820;
																																															obj_t
																																																BgL_bindingsz00_25819;
																																															BgL_bindingsz00_25819
																																																=
																																																BgL_arg6043z00_7545;
																																															BgL_exprz00_25820
																																																=
																																																BgL_arg6044z00_7546;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_25820;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_25819;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_21992
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25818);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_25827;
																																															goto
																																																BgL_tagzd2383zd2_1726;
																																															BgL_auxz00_21992
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25827);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_carzd248181zd2_7549;
																																															BgL_carzd248181zd2_7549
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd248181zd2_7549 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25834;
																																																	goto
																																																		BgL_tagzd2384zd2_1727;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25834);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248181zd2_7549)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25839;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25839);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_25846;
																																																					goto
																																																						BgL_tagzd2389zd2_1746;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25846);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25853;
																																																							goto
																																																								BgL_tagzd2390zd2_1747;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25853);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd248261zd2_7556;
																																																							BgL_cdrzd248261zd2_7556
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg6055z00_7559;
																																																									obj_t
																																																										BgL_arg6056z00_7560;
																																																									BgL_arg6055z00_7559
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7556));
																																																									BgL_arg6056z00_7560
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7556));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_25866;
																																																										{
																																																											obj_t
																																																												BgL_restz00_25868;
																																																											obj_t
																																																												BgL_effectz00_25867;
																																																											BgL_effectz00_25867
																																																												=
																																																												BgL_arg6055z00_7559;
																																																											BgL_restz00_25868
																																																												=
																																																												BgL_arg6056z00_7560;
																																																											BgL_restz00_1749
																																																												=
																																																												BgL_restz00_25868;
																																																											BgL_effectz00_1748
																																																												=
																																																												BgL_effectz00_25867;
																																																											goto
																																																												BgL_tagzd2391zd2_1750;
																																																										}
																																																										BgL_auxz00_21992
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_25866);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_25875;
																																																											goto
																																																												BgL_tagzd2392zd2_1751;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_25875);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25882;
																																																													goto
																																																														BgL_tagzd2393zd2_1752;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25882);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg6063z00_7568;
																																																															obj_t
																																																																BgL_arg6064z00_7569;
																																																															BgL_arg6063z00_7568
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7556));
																																																															BgL_arg6064z00_7569
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7556));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_25893;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_25895;
																																																																	obj_t
																																																																		BgL_effectz00_25894;
																																																																	BgL_effectz00_25894
																																																																		=
																																																																		BgL_arg6063z00_7568;
																																																																	BgL_restz00_25895
																																																																		=
																																																																		BgL_arg6064z00_7569;
																																																																	BgL_restz00_1754
																																																																		=
																																																																		BgL_restz00_25895;
																																																																	BgL_effectz00_1753
																																																																		=
																																																																		BgL_effectz00_25894;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1755;
																																																																}
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_25893);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25902;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1756;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25902);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25909;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1757;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25909);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_25916;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1758;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25916);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_25923;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1759;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25923);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_25930;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_tmpz00_25931;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12674;
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_pairz00_12673;
																																																																												BgL_pairz00_12673
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_pairz00_12674
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12673);
																																																																											}
																																																																											BgL_tmpz00_25931
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12674);
																																																																										}
																																																																										BgL_testz00_25930
																																																																											=
																																																																											NULLP
																																																																											(BgL_tmpz00_25931);
																																																																									}
																																																																									if (BgL_testz00_25930)
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25937;
																																																																											goto
																																																																												BgL_tagzd2399zd2_1760;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25937);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25941;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25941);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd248349zd2_7588;
																																																																									BgL_cdrzd248349zd2_7588
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd248355zd2_7591;
																																																																											BgL_cdrzd248355zd2_7591
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248349zd2_7588));
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_cdrzd248361zd2_7592;
																																																																												BgL_cdrzd248361zd2_7592
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd248355zd2_7591));
																																																																												if ((CAR(((obj_t) BgL_cdrzd248355zd2_7591)) == CNST_TABLE_REF(((long) 31))))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (PAIRP(BgL_cdrzd248361zd2_7592))
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg6088z00_7596;
																																																																																obj_t
																																																																																	BgL_arg6089z00_7597;
																																																																																obj_t
																																																																																	BgL_arg6090z00_7598;
																																																																																BgL_arg6088z00_7596
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7588));
																																																																																BgL_arg6089z00_7597
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd248361zd2_7592);
																																																																																BgL_arg6090z00_7598
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd248361zd2_7592);
																																																																																{	/* Ast/sexp.scm 561 */
																																																																																	obj_t
																																																																																		BgL_arg6999z00_12685;
																																																																																	BgL_arg6999z00_12685
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6088z00_7596,
																																																																																			BgL_arg6089z00_7597,
																																																																																			BgL_arg6090z00_7598,
																																																																																			BgL_stackz00_22,
																																																																																			BgL_arg6999z00_12685,
																																																																																			BgL_sitez00_24));
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																obj_t
																																																																																	BgL_arg6091z00_7600;
																																																																																obj_t
																																																																																	BgL_arg6092z00_7601;
																																																																																BgL_arg6091z00_7600
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7588));
																																																																																BgL_arg6092z00_7601
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7588));
																																																																																{	/* Ast/sexp.scm 563 */
																																																																																	obj_t
																																																																																		BgL_arg7000z00_12689;
																																																																																	BgL_arg7000z00_12689
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6091z00_7600,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg6092z00_7601, BgL_stackz00_22, BgL_arg7000z00_12689, BgL_sitez00_24));
																																																																													}}}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg6093z00_7603;
																																																																														obj_t
																																																																															BgL_arg6094z00_7604;
																																																																														BgL_arg6093z00_7603
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7588));
																																																																														BgL_arg6094z00_7604
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7588));
																																																																														{	/* Ast/sexp.scm 563 */
																																																																															obj_t
																																																																																BgL_arg7000z00_12693;
																																																																															BgL_arg7000z00_12693
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_arg6093z00_7603,
																																																																																	CNST_TABLE_REF
																																																																																	(((long) 4)), BgL_arg6094z00_7604, BgL_stackz00_22, BgL_arg7000z00_12693, BgL_sitez00_24));
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25986;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25986);
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_carzd248412zd2_7623;
																											BgL_carzd248412zd2_7623 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd248412zd2_7623
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_25993;
																													goto
																														BgL_tagzd2377zd2_1714;
																													BgL_auxz00_21992 =
																														((obj_t)
																														BgL_auxz00_25993);
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(BgL_carzd248412zd2_7623
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_25997;
																															goto
																																BgL_tagzd2377zd2_1714;
																															BgL_auxz00_21992 =
																																((obj_t)
																																BgL_auxz00_25997);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26004;
																																	goto
																																		BgL_tagzd2379zd2_1718;
																																	BgL_auxz00_21992
																																		=
																																		((obj_t)
																																		BgL_auxz00_26004);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_26011;
																																			goto
																																				BgL_tagzd2380zd2_1719;
																																			BgL_auxz00_21992
																																				=
																																				((obj_t)
																																				BgL_auxz00_26011);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd248481zd2_7630;
																																			BgL_carzd248481zd2_7630
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd248481zd2_7630))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd248484zd2_7632;
																																					obj_t
																																						BgL_cdrzd248485zd2_7633;
																																					BgL_carzd248484zd2_7632
																																						=
																																						CAR
																																						(BgL_carzd248481zd2_7630);
																																					BgL_cdrzd248485zd2_7633
																																						=
																																						CDR
																																						(BgL_carzd248481zd2_7630);
																																					{

																																						if (
																																							(BgL_carzd248484zd2_7632
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 118 */
																																							BgL_kapzd248486zd2_7634:
																																								if (PAIRP(BgL_cdrzd248485zd2_7633))
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd248489zd2_7816;
																																										BgL_cdrzd248489zd2_7816
																																											=
																																											CDR
																																											(BgL_cdrzd248485zd2_7633);
																																										if (PAIRP(BgL_cdrzd248489zd2_7816))
																																											{	/* Ast/sexp.scm 118 */
																																												if (NULLP(CDR(BgL_cdrzd248489zd2_7816)))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6248z00_7820;
																																														obj_t
																																															BgL_arg6249z00_7821;
																																														BgL_arg6248z00_7820
																																															=
																																															CAR
																																															(BgL_cdrzd248489zd2_7816);
																																														BgL_arg6249z00_7821
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_26033;
																																															{
																																																obj_t
																																																	BgL_argsz00_26035;
																																																obj_t
																																																	BgL_bodyz00_26034;
																																																BgL_bodyz00_26034
																																																	=
																																																	BgL_arg6248z00_7820;
																																																BgL_argsz00_26035
																																																	=
																																																	BgL_arg6249z00_7821;
																																																BgL_argsz00_1721
																																																	=
																																																	BgL_argsz00_26035;
																																																BgL_bodyz00_1720
																																																	=
																																																	BgL_bodyz00_26034;
																																																goto
																																																	BgL_tagzd2381zd2_1722;
																																															}
																																															BgL_auxz00_21992
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26033);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_cdrzd248513zd2_7822;
																																														BgL_cdrzd248513zd2_7822
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_26039;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6318z00_7933;
																																																BgL_arg6318z00_7933
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_26039
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6318z00_7933));
																																															}
																																															if (BgL_testz00_26039)
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg6252z00_7825;
																																																	obj_t
																																																		BgL_arg6253z00_7826;
																																																	BgL_arg6252z00_7825
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7822));
																																																	BgL_arg6253z00_7826
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7822));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_26048;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_26050;
																																																			obj_t
																																																				BgL_bindingsz00_26049;
																																																			BgL_bindingsz00_26049
																																																				=
																																																				BgL_arg6252z00_7825;
																																																			BgL_exprz00_26050
																																																				=
																																																				BgL_arg6253z00_7826;
																																																			BgL_exprz00_1724
																																																				=
																																																				BgL_exprz00_26050;
																																																			BgL_bindingsz00_1723
																																																				=
																																																				BgL_bindingsz00_26049;
																																																			goto
																																																				BgL_tagzd2382zd2_1725;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_26048);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_26052;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6317z00_7932;
																																																		BgL_arg6317z00_7932
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_26052
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6317z00_7932));
																																																	}
																																																	if (BgL_testz00_26052)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_26057;
																																																			goto
																																																				BgL_tagzd2384zd2_1727;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26057);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_carzd248580zd2_7829;
																																																			BgL_carzd248580zd2_7829
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd248585zd2_7830;
																																																				BgL_cdrzd248585zd2_7830
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd248580zd2_7829));
																																																				if ((CAR(((obj_t) BgL_carzd248580zd2_7829)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_arg6258z00_7833;
																																																						obj_t
																																																							BgL_arg6259z00_7834;
																																																						obj_t
																																																							BgL_arg6260z00_7835;
																																																						BgL_arg6258z00_7833
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7830));
																																																						BgL_arg6259z00_7834
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7830));
																																																						BgL_arg6260z00_7835
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_26074;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_26077;
																																																								obj_t
																																																									BgL_bodyz00_26076;
																																																								obj_t
																																																									BgL_varsz00_26075;
																																																								BgL_varsz00_26075
																																																									=
																																																									BgL_arg6258z00_7833;
																																																								BgL_bodyz00_26076
																																																									=
																																																									BgL_arg6259z00_7834;
																																																								BgL_argsz00_26077
																																																									=
																																																									BgL_arg6260z00_7835;
																																																								BgL_argsz00_1734
																																																									=
																																																									BgL_argsz00_26077;
																																																								BgL_bodyz00_1733
																																																									=
																																																									BgL_bodyz00_26076;
																																																								BgL_varsz00_1732
																																																									=
																																																									BgL_varsz00_26075;
																																																								goto
																																																									BgL_tagzd2386zd2_1735;
																																																							}
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_26074);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd248608zd2_7837;
																																																						BgL_cdrzd248608zd2_7837
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd248614zd2_7838;
																																																							BgL_cdrzd248614zd2_7838
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd248580zd2_7829));
																																																							if ((CAR(((obj_t) BgL_carzd248580zd2_7829)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd248620zd2_7841;
																																																									BgL_cdrzd248620zd2_7841
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248614zd2_7838));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd248625zd2_7842;
																																																										obj_t
																																																											BgL_cdrzd248626zd2_7843;
																																																										BgL_carzd248625zd2_7842
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7841));
																																																										BgL_cdrzd248626zd2_7843
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7841));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248625zd2_7842))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd248626zd2_7843))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd248633zd2_7846;
																																																														BgL_carzd248633zd2_7846
																																																															=
																																																															CAR
																																																															(BgL_cdrzd248626zd2_7843);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248633zd2_7846))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (NULLP(CDR(BgL_cdrzd248626zd2_7843)))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_testz00_26104;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1447z00_7879;
																																																																			BgL_l1447z00_7879
																																																																				=
																																																																				BgL_cdrzd248608zd2_7837;
																																																																		BgL_zc3anonymousza36283ze3z83_7880:
																																																																			if (NULLP(BgL_l1447z00_7879))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_testz00_26104
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_testz00_26107;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_26108;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_tmpz00_26109;
																																																																							BgL_tmpz00_26109
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1447z00_7879));
																																																																							BgL_testz00_26108
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_26109);
																																																																						}
																																																																						if (BgL_testz00_26108)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_26107
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_26107
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_testz00_26107)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1447z00_26113;
																																																																							BgL_l1447z00_26113
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1447z00_7879));
																																																																							BgL_l1447z00_7879
																																																																								=
																																																																								BgL_l1447z00_26113;
																																																																							goto
																																																																								BgL_zc3anonymousza36283ze3z83_7880;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_26104
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_testz00_26104)
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg6273z00_7862;
																																																																				BgL_arg6273z00_7862
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd248614zd2_7838));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26118;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_26122;
																																																																						obj_t
																																																																							BgL_proc2z00_26121;
																																																																						obj_t
																																																																							BgL_proc1z00_26120;
																																																																						obj_t
																																																																							BgL_testz00_26119;
																																																																						BgL_testz00_26119
																																																																							=
																																																																							BgL_arg6273z00_7862;
																																																																						BgL_proc1z00_26120
																																																																							=
																																																																							BgL_carzd248625zd2_7842;
																																																																						BgL_proc2z00_26121
																																																																							=
																																																																							BgL_carzd248633zd2_7846;
																																																																						BgL_argsz00_26122
																																																																							=
																																																																							BgL_cdrzd248608zd2_7837;
																																																																						BgL_argsz00_1739
																																																																							=
																																																																							BgL_argsz00_26122;
																																																																						BgL_proc2z00_1738
																																																																							=
																																																																							BgL_proc2z00_26121;
																																																																						BgL_proc1z00_1737
																																																																							=
																																																																							BgL_proc1z00_26120;
																																																																						BgL_testz00_1736
																																																																							=
																																																																							BgL_testz00_26119;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1740;
																																																																					}
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26118);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd248657zd2_7863;
																																																																				BgL_cdrzd248657zd2_7863
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd248664zd2_7864;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12737;
																																																																						BgL_pairz00_12737
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd248664zd2_7864
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12737);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd248671zd2_7865;
																																																																						BgL_cdrzd248671zd2_7865
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd248664zd2_7864));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd248677zd2_7866;
																																																																							BgL_carzd248677zd2_7866
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd248671zd2_7865));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248677zd2_7866))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd248684zd2_7868;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12741;
																																																																										BgL_pairz00_12741
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd248671zd2_7865));
																																																																										BgL_carzd248684zd2_7868
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_12741);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248684zd2_7868))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248657zd2_7863))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg6277z00_7871;
																																																																													BgL_arg6277z00_7871
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd248664zd2_7864));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26144;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26148;
																																																																															obj_t
																																																																																BgL_proc2z00_26147;
																																																																															obj_t
																																																																																BgL_proc1z00_26146;
																																																																															obj_t
																																																																																BgL_testz00_26145;
																																																																															BgL_testz00_26145
																																																																																=
																																																																																BgL_arg6277z00_7871;
																																																																															BgL_proc1z00_26146
																																																																																=
																																																																																BgL_carzd248677zd2_7866;
																																																																															BgL_proc2z00_26147
																																																																																=
																																																																																BgL_carzd248684zd2_7868;
																																																																															BgL_argsz00_26148
																																																																																=
																																																																																BgL_cdrzd248657zd2_7863;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_26148;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_26147;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_26146;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_26145;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26144);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26152;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26152);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26156;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26156);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26160;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26160);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26164;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26164);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd248960zd2_7890;
																																																																BgL_cdrzd248960zd2_7890
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd248966zd2_7891;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_12745;
																																																																		BgL_pairz00_12745
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd248966zd2_7891
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12745);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd248972zd2_7892;
																																																																		BgL_cdrzd248972zd2_7892
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd248966zd2_7891));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd248977zd2_7893;
																																																																			obj_t
																																																																				BgL_cdrzd248978zd2_7894;
																																																																			BgL_carzd248977zd2_7893
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7892));
																																																																			BgL_cdrzd248978zd2_7894
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7892));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248977zd2_7893))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd248983zd2_7896;
																																																																					BgL_carzd248983zd2_7896
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd248978zd2_7894));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248983zd2_7896))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd248978zd2_7894))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248960zd2_7890))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg6292z00_7901;
																																																																											BgL_arg6292z00_7901
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248966zd2_7891));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26191;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26195;
																																																																													obj_t
																																																																														BgL_proc2z00_26194;
																																																																													obj_t
																																																																														BgL_proc1z00_26193;
																																																																													obj_t
																																																																														BgL_testz00_26192;
																																																																													BgL_testz00_26192
																																																																														=
																																																																														BgL_arg6292z00_7901;
																																																																													BgL_proc1z00_26193
																																																																														=
																																																																														BgL_carzd248977zd2_7893;
																																																																													BgL_proc2z00_26194
																																																																														=
																																																																														BgL_carzd248983zd2_7896;
																																																																													BgL_argsz00_26195
																																																																														=
																																																																														BgL_cdrzd248960zd2_7890;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_26195;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_26194;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_26193;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_26192;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26191);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26199;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26199);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26203;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26203);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26207;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26207);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26211;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26211);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26215;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26215);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd249316zd2_7909;
																																																												BgL_cdrzd249316zd2_7909
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd249323zd2_7910;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_pairz00_12755;
																																																														BgL_pairz00_12755
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd249323zd2_7910
																																																															=
																																																															CDR
																																																															(BgL_pairz00_12755);
																																																													}
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd249330zd2_7911;
																																																														BgL_cdrzd249330zd2_7911
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd249323zd2_7910));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd249336zd2_7912;
																																																															obj_t
																																																																BgL_cdrzd249337zd2_7913;
																																																															BgL_carzd249336zd2_7912
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7911));
																																																															BgL_cdrzd249337zd2_7913
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7911));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249336zd2_7912))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd249337zd2_7913))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd249344zd2_7916;
																																																																			BgL_carzd249344zd2_7916
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd249337zd2_7913);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249344zd2_7916))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (NULLP(CDR(BgL_cdrzd249337zd2_7913)))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd249316zd2_7909))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg6306z00_7921;
																																																																									BgL_arg6306z00_7921
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd249323zd2_7910));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26242;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26246;
																																																																											obj_t
																																																																												BgL_proc2z00_26245;
																																																																											obj_t
																																																																												BgL_proc1z00_26244;
																																																																											obj_t
																																																																												BgL_testz00_26243;
																																																																											BgL_testz00_26243
																																																																												=
																																																																												BgL_arg6306z00_7921;
																																																																											BgL_proc1z00_26244
																																																																												=
																																																																												BgL_carzd249336zd2_7912;
																																																																											BgL_proc2z00_26245
																																																																												=
																																																																												BgL_carzd249344zd2_7916;
																																																																											BgL_argsz00_26246
																																																																												=
																																																																												BgL_cdrzd249316zd2_7909;
																																																																											BgL_argsz00_1744
																																																																												=
																																																																												BgL_argsz00_26246;
																																																																											BgL_proc2z00_1743
																																																																												=
																																																																												BgL_proc2z00_26245;
																																																																											BgL_proc1z00_1742
																																																																												=
																																																																												BgL_proc1z00_26244;
																																																																											BgL_testz00_1741
																																																																												=
																																																																												BgL_testz00_26243;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1745;
																																																																										}
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26242);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26250;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26250);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26254;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26254);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26258;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26258);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26262;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26262);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26266;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26266);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26270;
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26270);
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd249737zd2_7935;
																																												BgL_cdrzd249737zd2_7935
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_testz00_26274;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6334z00_7952;
																																														BgL_arg6334z00_7952
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_testz00_26274
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6334z00_7952));
																																													}
																																													if (BgL_testz00_26274)
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6322z00_7938;
																																															obj_t
																																																BgL_arg6323z00_7939;
																																															BgL_arg6322z00_7938
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7935));
																																															BgL_arg6323z00_7939
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7935));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_26283;
																																																{
																																																	obj_t
																																																		BgL_exprz00_26285;
																																																	obj_t
																																																		BgL_bindingsz00_26284;
																																																	BgL_bindingsz00_26284
																																																		=
																																																		BgL_arg6322z00_7938;
																																																	BgL_exprz00_26285
																																																		=
																																																		BgL_arg6323z00_7939;
																																																	BgL_exprz00_1724
																																																		=
																																																		BgL_exprz00_26285;
																																																	BgL_bindingsz00_1723
																																																		=
																																																		BgL_bindingsz00_26284;
																																																	goto
																																																		BgL_tagzd2382zd2_1725;
																																																}
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_26283);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															bool_t
																																																BgL_testz00_26287;
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg6333z00_7951;
																																																BgL_arg6333z00_7951
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_testz00_26287
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6333z00_7951));
																																															}
																																															if (BgL_testz00_26287)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26292;
																																																	goto
																																																		BgL_tagzd2384zd2_1727;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26292);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_carzd249803zd2_7942;
																																																	BgL_carzd249803zd2_7942
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd249808zd2_7943;
																																																		BgL_cdrzd249808zd2_7943
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd249803zd2_7942));
																																																		if ((CAR(((obj_t) BgL_carzd249803zd2_7942)) == CNST_TABLE_REF(((long) 3))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6328z00_7946;
																																																				obj_t
																																																					BgL_arg6329z00_7947;
																																																				obj_t
																																																					BgL_arg6330z00_7948;
																																																				BgL_arg6328z00_7946
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7943));
																																																				BgL_arg6329z00_7947
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7943));
																																																				BgL_arg6330z00_7948
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26309;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_26312;
																																																						obj_t
																																																							BgL_bodyz00_26311;
																																																						obj_t
																																																							BgL_varsz00_26310;
																																																						BgL_varsz00_26310
																																																							=
																																																							BgL_arg6328z00_7946;
																																																						BgL_bodyz00_26311
																																																							=
																																																							BgL_arg6329z00_7947;
																																																						BgL_argsz00_26312
																																																							=
																																																							BgL_arg6330z00_7948;
																																																						BgL_argsz00_1734
																																																							=
																																																							BgL_argsz00_26312;
																																																						BgL_bodyz00_1733
																																																							=
																																																							BgL_bodyz00_26311;
																																																						BgL_varsz00_1732
																																																							=
																																																							BgL_varsz00_26310;
																																																						goto
																																																							BgL_tagzd2386zd2_1735;
																																																					}
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26309);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_tagzd2403zd2_1769;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_26316;
																																																						goto
																																																							BgL_tagzd2404zd2_1770;
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_26316);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd249919zd2_7953;
																																										BgL_cdrzd249919zd2_7953
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{	/* Ast/sexp.scm 118 */
																																											bool_t
																																												BgL_testz00_26320;
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg6343z00_7962;
																																												BgL_arg6343z00_7962
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												BgL_testz00_26320
																																													=
																																													CBOOL
																																													(BGl_letzd2symzf3z21zzast_letz00
																																													(BgL_arg6343z00_7962));
																																											}
																																											if (BgL_testz00_26320)
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg6337z00_7956;
																																													obj_t
																																														BgL_arg6338z00_7957;
																																													BgL_arg6337z00_7956
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7953));
																																													BgL_arg6338z00_7957
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7953));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_26329;
																																														{
																																															obj_t
																																																BgL_exprz00_26331;
																																															obj_t
																																																BgL_bindingsz00_26330;
																																															BgL_bindingsz00_26330
																																																=
																																																BgL_arg6337z00_7956;
																																															BgL_exprz00_26331
																																																=
																																																BgL_arg6338z00_7957;
																																															BgL_exprz00_1724
																																																=
																																																BgL_exprz00_26331;
																																															BgL_bindingsz00_1723
																																																=
																																																BgL_bindingsz00_26330;
																																															goto
																																																BgL_tagzd2382zd2_1725;
																																														}
																																														BgL_auxz00_21992
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26329);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													bool_t
																																														BgL_testz00_26333;
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg6342z00_7961;
																																														BgL_arg6342z00_7961
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_testz00_26333
																																															=
																																															CBOOL
																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																															(BgL_arg6342z00_7961));
																																													}
																																													if (BgL_testz00_26333)
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26338;
																																															goto
																																																BgL_tagzd2384zd2_1727;
																																															BgL_auxz00_21992
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26338);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2403zd2_1769;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_26342;
																																																	goto
																																																		BgL_tagzd2404zd2_1770;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26342);
																																																}
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248484zd2_7632)))
																																									{	/* Ast/sexp.scm 118 */
																																										goto
																																											BgL_kapzd248486zd2_7634;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd248484zd2_7632 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd248486zd2_7634;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if ((BgL_carzd248484zd2_7632 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd248486zd2_7634;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248484zd2_7632)))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_kapzd248486zd2_7634;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_cdrzd250091zd2_7640;
																																																BgL_cdrzd250091zd2_7640
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	bool_t
																																																		BgL_testz00_26358;
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg6243z00_7814;
																																																		BgL_arg6243z00_7814
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_testz00_26358
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6243z00_7814));
																																																	}
																																																	if (BgL_testz00_26358)
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg6127z00_7643;
																																																			obj_t
																																																				BgL_arg6128z00_7644;
																																																			BgL_arg6127z00_7643
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7640));
																																																			BgL_arg6128z00_7644
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7640));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_26367;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_26369;
																																																					obj_t
																																																						BgL_bindingsz00_26368;
																																																					BgL_bindingsz00_26368
																																																						=
																																																						BgL_arg6127z00_7643;
																																																					BgL_exprz00_26369
																																																						=
																																																						BgL_arg6128z00_7644;
																																																					BgL_exprz00_1724
																																																						=
																																																						BgL_exprz00_26369;
																																																					BgL_bindingsz00_1723
																																																						=
																																																						BgL_bindingsz00_26368;
																																																					goto
																																																						BgL_tagzd2382zd2_1725;
																																																				}
																																																				BgL_auxz00_21992
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_26367);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			bool_t
																																																				BgL_testz00_26371;
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_arg6242z00_7813;
																																																				BgL_arg6242z00_7813
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_testz00_26371
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6242z00_7813));
																																																			}
																																																			if (BgL_testz00_26371)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_26376;
																																																					goto
																																																						BgL_tagzd2384zd2_1727;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26376);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd250144zd2_7647;
																																																					obj_t
																																																						BgL_cdrzd250145zd2_7648;
																																																					BgL_carzd250144zd2_7647
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_cdrzd250145zd2_7648
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd250149zd2_7649;
																																																						BgL_cdrzd250149zd2_7649
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd250144zd2_7647));
																																																						if ((CAR(((obj_t) BgL_carzd250144zd2_7647)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (PAIRP(BgL_cdrzd250149zd2_7649))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd250152zd2_7653;
																																																										obj_t
																																																											BgL_cdrzd250153zd2_7654;
																																																										BgL_carzd250152zd2_7653
																																																											=
																																																											CAR
																																																											(BgL_cdrzd250149zd2_7649);
																																																										BgL_cdrzd250153zd2_7654
																																																											=
																																																											CDR
																																																											(BgL_cdrzd250149zd2_7649);
																																																										if (PAIRP(BgL_carzd250152zd2_7653))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (NULLP(CDR(BgL_carzd250152zd2_7653)))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd250153zd2_7654))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd250159zd2_7659;
																																																																BgL_carzd250159zd2_7659
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd250153zd2_7654);
																																																																if (PAIRP(BgL_carzd250159zd2_7659))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd250159zd2_7659))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd250153zd2_7654)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd250166zd2_7664;
																																																																						BgL_carzd250166zd2_7664
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250145zd2_7648));
																																																																						if (PAIRP(BgL_carzd250166zd2_7664))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd250191zd2_7666;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_12803;
																																																																									BgL_pairz00_12803
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd250191zd2_7666
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12803);
																																																																								}
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg6143z00_7667;
																																																																									obj_t
																																																																										BgL_arg6144z00_7668;
																																																																									obj_t
																																																																										BgL_arg6145z00_7669;
																																																																									BgL_arg6143z00_7667
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7666));
																																																																									BgL_arg6144z00_7668
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7666));
																																																																									BgL_arg6145z00_7669
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26421;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26424;
																																																																											obj_t
																																																																												BgL_bodyz00_26423;
																																																																											obj_t
																																																																												BgL_varsz00_26422;
																																																																											BgL_varsz00_26422
																																																																												=
																																																																												BgL_arg6143z00_7667;
																																																																											BgL_bodyz00_26423
																																																																												=
																																																																												BgL_arg6144z00_7668;
																																																																											BgL_argsz00_26424
																																																																												=
																																																																												BgL_arg6145z00_7669;
																																																																											BgL_argsz00_1734
																																																																												=
																																																																												BgL_argsz00_26424;
																																																																											BgL_bodyz00_1733
																																																																												=
																																																																												BgL_bodyz00_26423;
																																																																											BgL_varsz00_1732
																																																																												=
																																																																												BgL_varsz00_26422;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1735;
																																																																										}
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26421);
																																																																									}
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd250145zd2_7648))))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg6149z00_7673;
																																																																										BgL_arg6149z00_7673
																																																																											=
																																																																											CAR
																																																																											(BgL_carzd250152zd2_7653);
																																																																										{
																																																																											BgL_castz00_bglt
																																																																												BgL_auxz00_26431;
																																																																											{
																																																																												obj_t
																																																																													BgL_argz00_26434;
																																																																												obj_t
																																																																													BgL_bodyz00_26433;
																																																																												obj_t
																																																																													BgL_varz00_26432;
																																																																												BgL_varz00_26432
																																																																													=
																																																																													BgL_arg6149z00_7673;
																																																																												BgL_bodyz00_26433
																																																																													=
																																																																													BgL_carzd250159zd2_7659;
																																																																												BgL_argz00_26434
																																																																													=
																																																																													BgL_carzd250166zd2_7664;
																																																																												BgL_argz00_1730
																																																																													=
																																																																													BgL_argz00_26434;
																																																																												BgL_bodyz00_1729
																																																																													=
																																																																													BgL_bodyz00_26433;
																																																																												BgL_varz00_1728
																																																																													=
																																																																													BgL_varz00_26432;
																																																																												goto
																																																																													BgL_tagzd2385zd2_1731;
																																																																											}
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26431);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd250219zd2_7674;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_12811;
																																																																											BgL_pairz00_12811
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd250219zd2_7674
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12811);
																																																																										}
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg6150z00_7675;
																																																																											obj_t
																																																																												BgL_arg6151z00_7676;
																																																																											obj_t
																																																																												BgL_arg6152z00_7677;
																																																																											BgL_arg6150z00_7675
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7674));
																																																																											BgL_arg6151z00_7676
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7674));
																																																																											BgL_arg6152z00_7677
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26445;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26448;
																																																																													obj_t
																																																																														BgL_bodyz00_26447;
																																																																													obj_t
																																																																														BgL_varsz00_26446;
																																																																													BgL_varsz00_26446
																																																																														=
																																																																														BgL_arg6150z00_7675;
																																																																													BgL_bodyz00_26447
																																																																														=
																																																																														BgL_arg6151z00_7676;
																																																																													BgL_argsz00_26448
																																																																														=
																																																																														BgL_arg6152z00_7677;
																																																																													BgL_argsz00_1734
																																																																														=
																																																																														BgL_argsz00_26448;
																																																																													BgL_bodyz00_1733
																																																																														=
																																																																														BgL_bodyz00_26447;
																																																																													BgL_varsz00_1732
																																																																														=
																																																																														BgL_varsz00_26446;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1735;
																																																																												}
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26445);
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd250245zd2_7680;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_12816;
																																																																							BgL_pairz00_12816
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd250245zd2_7680
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12816);
																																																																						}
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg6155z00_7681;
																																																																							obj_t
																																																																								BgL_arg6156z00_7682;
																																																																							obj_t
																																																																								BgL_arg6157z00_7683;
																																																																							BgL_arg6155z00_7681
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7680));
																																																																							BgL_arg6156z00_7682
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7680));
																																																																							BgL_arg6157z00_7683
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26459;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_26462;
																																																																									obj_t
																																																																										BgL_bodyz00_26461;
																																																																									obj_t
																																																																										BgL_varsz00_26460;
																																																																									BgL_varsz00_26460
																																																																										=
																																																																										BgL_arg6155z00_7681;
																																																																									BgL_bodyz00_26461
																																																																										=
																																																																										BgL_arg6156z00_7682;
																																																																									BgL_argsz00_26462
																																																																										=
																																																																										BgL_arg6157z00_7683;
																																																																									BgL_argsz00_1734
																																																																										=
																																																																										BgL_argsz00_26462;
																																																																									BgL_bodyz00_1733
																																																																										=
																																																																										BgL_bodyz00_26461;
																																																																									BgL_varsz00_1732
																																																																										=
																																																																										BgL_varsz00_26460;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1735;
																																																																								}
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26459);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd250271zd2_7686;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_12821;
																																																																					BgL_pairz00_12821
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd250271zd2_7686
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12821);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_arg6160z00_7687;
																																																																					obj_t
																																																																						BgL_arg6161z00_7688;
																																																																					obj_t
																																																																						BgL_arg6162z00_7689;
																																																																					BgL_arg6160z00_7687
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7686));
																																																																					BgL_arg6161z00_7688
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7686));
																																																																					BgL_arg6162z00_7689
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26473;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_26476;
																																																																							obj_t
																																																																								BgL_bodyz00_26475;
																																																																							obj_t
																																																																								BgL_varsz00_26474;
																																																																							BgL_varsz00_26474
																																																																								=
																																																																								BgL_arg6160z00_7687;
																																																																							BgL_bodyz00_26475
																																																																								=
																																																																								BgL_arg6161z00_7688;
																																																																							BgL_argsz00_26476
																																																																								=
																																																																								BgL_arg6162z00_7689;
																																																																							BgL_argsz00_1734
																																																																								=
																																																																								BgL_argsz00_26476;
																																																																							BgL_bodyz00_1733
																																																																								=
																																																																								BgL_bodyz00_26475;
																																																																							BgL_varsz00_1732
																																																																								=
																																																																								BgL_varsz00_26474;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1735;
																																																																						}
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26473);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd250297zd2_7691;
																																																																		BgL_cdrzd250297zd2_7691
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd250144zd2_7647));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg6164z00_7692;
																																																																			obj_t
																																																																				BgL_arg6165z00_7693;
																																																																			obj_t
																																																																				BgL_arg6166z00_7694;
																																																																			BgL_arg6164z00_7692
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7691));
																																																																			BgL_arg6165z00_7693
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7691));
																																																																			BgL_arg6166z00_7694
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26486;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_26489;
																																																																					obj_t
																																																																						BgL_bodyz00_26488;
																																																																					obj_t
																																																																						BgL_varsz00_26487;
																																																																					BgL_varsz00_26487
																																																																						=
																																																																						BgL_arg6164z00_7692;
																																																																					BgL_bodyz00_26488
																																																																						=
																																																																						BgL_arg6165z00_7693;
																																																																					BgL_argsz00_26489
																																																																						=
																																																																						BgL_arg6166z00_7694;
																																																																					BgL_argsz00_1734
																																																																						=
																																																																						BgL_argsz00_26489;
																																																																					BgL_bodyz00_1733
																																																																						=
																																																																						BgL_bodyz00_26488;
																																																																					BgL_varsz00_1732
																																																																						=
																																																																						BgL_varsz00_26487;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1735;
																																																																				}
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26486);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd250323zd2_7696;
																																																																BgL_cdrzd250323zd2_7696
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd250144zd2_7647));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg6168z00_7697;
																																																																	obj_t
																																																																		BgL_arg6169z00_7698;
																																																																	obj_t
																																																																		BgL_arg6170z00_7699;
																																																																	BgL_arg6168z00_7697
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7696));
																																																																	BgL_arg6169z00_7698
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7696));
																																																																	BgL_arg6170z00_7699
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_26499;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_26502;
																																																																			obj_t
																																																																				BgL_bodyz00_26501;
																																																																			obj_t
																																																																				BgL_varsz00_26500;
																																																																			BgL_varsz00_26500
																																																																				=
																																																																				BgL_arg6168z00_7697;
																																																																			BgL_bodyz00_26501
																																																																				=
																																																																				BgL_arg6169z00_7698;
																																																																			BgL_argsz00_26502
																																																																				=
																																																																				BgL_arg6170z00_7699;
																																																																			BgL_argsz00_1734
																																																																				=
																																																																				BgL_argsz00_26502;
																																																																			BgL_bodyz00_1733
																																																																				=
																																																																				BgL_bodyz00_26501;
																																																																			BgL_varsz00_1732
																																																																				=
																																																																				BgL_varsz00_26500;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1735;
																																																																		}
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_26499);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd250349zd2_7701;
																																																														BgL_cdrzd250349zd2_7701
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd250144zd2_7647));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg6172z00_7702;
																																																															obj_t
																																																																BgL_arg6173z00_7703;
																																																															obj_t
																																																																BgL_arg6174z00_7704;
																																																															BgL_arg6172z00_7702
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7701));
																																																															BgL_arg6173z00_7703
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7701));
																																																															BgL_arg6174z00_7704
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26512;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_26515;
																																																																	obj_t
																																																																		BgL_bodyz00_26514;
																																																																	obj_t
																																																																		BgL_varsz00_26513;
																																																																	BgL_varsz00_26513
																																																																		=
																																																																		BgL_arg6172z00_7702;
																																																																	BgL_bodyz00_26514
																																																																		=
																																																																		BgL_arg6173z00_7703;
																																																																	BgL_argsz00_26515
																																																																		=
																																																																		BgL_arg6174z00_7704;
																																																																	BgL_argsz00_1734
																																																																		=
																																																																		BgL_argsz00_26515;
																																																																	BgL_bodyz00_1733
																																																																		=
																																																																		BgL_bodyz00_26514;
																																																																	BgL_varsz00_1732
																																																																		=
																																																																		BgL_varsz00_26513;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1735;
																																																																}
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26512);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd250375zd2_7707;
																																																												BgL_cdrzd250375zd2_7707
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd250144zd2_7647));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg6177z00_7708;
																																																													obj_t
																																																														BgL_arg6178z00_7709;
																																																													obj_t
																																																														BgL_arg6179z00_7710;
																																																													BgL_arg6177z00_7708
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7707));
																																																													BgL_arg6178z00_7709
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7707));
																																																													BgL_arg6179z00_7710
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26525;
																																																														{
																																																															obj_t
																																																																BgL_argsz00_26528;
																																																															obj_t
																																																																BgL_bodyz00_26527;
																																																															obj_t
																																																																BgL_varsz00_26526;
																																																															BgL_varsz00_26526
																																																																=
																																																																BgL_arg6177z00_7708;
																																																															BgL_bodyz00_26527
																																																																=
																																																																BgL_arg6178z00_7709;
																																																															BgL_argsz00_26528
																																																																=
																																																																BgL_arg6179z00_7710;
																																																															BgL_argsz00_1734
																																																																=
																																																																BgL_argsz00_26528;
																																																															BgL_bodyz00_1733
																																																																=
																																																																BgL_bodyz00_26527;
																																																															BgL_varsz00_1732
																																																																=
																																																																BgL_varsz00_26526;
																																																															goto
																																																																BgL_tagzd2386zd2_1735;
																																																														}
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26525);
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26532;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26532);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd250513zd2_7715;
																																																								BgL_cdrzd250513zd2_7715
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd250144zd2_7647));
																																																								if ((CAR(((obj_t) BgL_carzd250144zd2_7647)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd250513zd2_7715))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd250518zd2_7719;
																																																												BgL_cdrzd250518zd2_7719
																																																													=
																																																													CDR
																																																													(BgL_cdrzd250513zd2_7715);
																																																												if (PAIRP(BgL_cdrzd250518zd2_7719))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd250522zd2_7721;
																																																														obj_t
																																																															BgL_cdrzd250523zd2_7722;
																																																														BgL_carzd250522zd2_7721
																																																															=
																																																															CAR
																																																															(BgL_cdrzd250518zd2_7719);
																																																														BgL_cdrzd250523zd2_7722
																																																															=
																																																															CDR
																																																															(BgL_cdrzd250518zd2_7719);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250522zd2_7721))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd250523zd2_7722))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd250528zd2_7725;
																																																																		BgL_carzd250528zd2_7725
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd250523zd2_7722);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250528zd2_7725))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd250523zd2_7722)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_26558;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1450z00_7758;
																																																																							BgL_l1450z00_7758
																																																																								=
																																																																								BgL_cdrzd250145zd2_7648;
																																																																						BgL_zc3anonymousza36206ze3z83_7759:
																																																																							if (NULLP(BgL_l1450z00_7758))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_26558
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_26561;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_testz00_26562;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_26563;
																																																																											BgL_tmpz00_26563
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1450z00_7758));
																																																																											BgL_testz00_26562
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_26563);
																																																																										}
																																																																										if (BgL_testz00_26562)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_26561
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_26561
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_testz00_26561)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1450z00_26567;
																																																																											BgL_l1450z00_26567
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1450z00_7758));
																																																																											BgL_l1450z00_7758
																																																																												=
																																																																												BgL_l1450z00_26567;
																																																																											goto
																																																																												BgL_zc3anonymousza36206ze3z83_7759;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_26558
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_testz00_26558)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg6196z00_7741;
																																																																								BgL_arg6196z00_7741
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd250513zd2_7715);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26571;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_26575;
																																																																										obj_t
																																																																											BgL_proc2z00_26574;
																																																																										obj_t
																																																																											BgL_proc1z00_26573;
																																																																										obj_t
																																																																											BgL_testz00_26572;
																																																																										BgL_testz00_26572
																																																																											=
																																																																											BgL_arg6196z00_7741;
																																																																										BgL_proc1z00_26573
																																																																											=
																																																																											BgL_carzd250522zd2_7721;
																																																																										BgL_proc2z00_26574
																																																																											=
																																																																											BgL_carzd250528zd2_7725;
																																																																										BgL_argsz00_26575
																																																																											=
																																																																											BgL_cdrzd250145zd2_7648;
																																																																										BgL_argsz00_1739
																																																																											=
																																																																											BgL_argsz00_26575;
																																																																										BgL_proc2z00_1738
																																																																											=
																																																																											BgL_proc2z00_26574;
																																																																										BgL_proc1z00_1737
																																																																											=
																																																																											BgL_proc1z00_26573;
																																																																										BgL_testz00_1736
																																																																											=
																																																																											BgL_testz00_26572;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1740;
																																																																									}
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26571);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd250553zd2_7742;
																																																																								BgL_cdrzd250553zd2_7742
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd250561zd2_7743;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_12865;
																																																																										BgL_pairz00_12865
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd250561zd2_7743
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12865);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd250569zd2_7744;
																																																																										BgL_cdrzd250569zd2_7744
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd250561zd2_7743));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd250576zd2_7745;
																																																																											BgL_carzd250576zd2_7745
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250569zd2_7744));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250576zd2_7745))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd250585zd2_7747;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_12869;
																																																																														BgL_pairz00_12869
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd250569zd2_7744));
																																																																														BgL_carzd250585zd2_7747
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12869);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250585zd2_7747))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250553zd2_7742))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg6200z00_7750;
																																																																																	BgL_arg6200z00_7750
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd250561zd2_7743));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_26597;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_26601;
																																																																																			obj_t
																																																																																				BgL_proc2z00_26600;
																																																																																			obj_t
																																																																																				BgL_proc1z00_26599;
																																																																																			obj_t
																																																																																				BgL_testz00_26598;
																																																																																			BgL_testz00_26598
																																																																																				=
																																																																																				BgL_arg6200z00_7750;
																																																																																			BgL_proc1z00_26599
																																																																																				=
																																																																																				BgL_carzd250576zd2_7745;
																																																																																			BgL_proc2z00_26600
																																																																																				=
																																																																																				BgL_carzd250585zd2_7747;
																																																																																			BgL_argsz00_26601
																																																																																				=
																																																																																				BgL_cdrzd250553zd2_7742;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_26601;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_26600;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_26599;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_26598;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_21992
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_26597);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_26605;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_21992
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_26605);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26609;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26609);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26613;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26613);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26617;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26617);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd250863zd2_7769;
																																																																				BgL_cdrzd250863zd2_7769
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd250870zd2_7770;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_12873;
																																																																						BgL_pairz00_12873
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd250870zd2_7770
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12873);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd250877zd2_7771;
																																																																						BgL_cdrzd250877zd2_7771
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250870zd2_7770));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd250883zd2_7772;
																																																																							obj_t
																																																																								BgL_cdrzd250884zd2_7773;
																																																																							BgL_carzd250883zd2_7772
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7771));
																																																																							BgL_cdrzd250884zd2_7773
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7771));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250883zd2_7772))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd250891zd2_7775;
																																																																									BgL_carzd250891zd2_7775
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250884zd2_7773));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250891zd2_7775))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd250884zd2_7773))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250863zd2_7769))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg6215z00_7780;
																																																																															BgL_arg6215z00_7780
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd250870zd2_7770));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_26644;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_26648;
																																																																																	obj_t
																																																																																		BgL_proc2z00_26647;
																																																																																	obj_t
																																																																																		BgL_proc1z00_26646;
																																																																																	obj_t
																																																																																		BgL_testz00_26645;
																																																																																	BgL_testz00_26645
																																																																																		=
																																																																																		BgL_arg6215z00_7780;
																																																																																	BgL_proc1z00_26646
																																																																																		=
																																																																																		BgL_carzd250883zd2_7772;
																																																																																	BgL_proc2z00_26647
																																																																																		=
																																																																																		BgL_carzd250891zd2_7775;
																																																																																	BgL_argsz00_26648
																																																																																		=
																																																																																		BgL_cdrzd250863zd2_7769;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_26648;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_26647;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_26646;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_26645;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_21992
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_26644);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26652;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_21992
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26652);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26656;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26656);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26660;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26660);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26664;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26664);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26668;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26668);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd251224zd2_7788;
																																																																BgL_cdrzd251224zd2_7788
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd251230zd2_7789;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_12883;
																																																																		BgL_pairz00_12883
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd251230zd2_7789
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12883);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd251236zd2_7790;
																																																																		BgL_cdrzd251236zd2_7790
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd251230zd2_7789));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd251241zd2_7791;
																																																																			obj_t
																																																																				BgL_cdrzd251242zd2_7792;
																																																																			BgL_carzd251241zd2_7791
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7790));
																																																																			BgL_cdrzd251242zd2_7792
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7790));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251241zd2_7791))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd251242zd2_7792))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd251247zd2_7795;
																																																																							BgL_carzd251247zd2_7795
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd251242zd2_7792);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251247zd2_7795))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd251242zd2_7792)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd251224zd2_7788))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg6229z00_7800;
																																																																													BgL_arg6229z00_7800
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd251230zd2_7789));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26695;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26699;
																																																																															obj_t
																																																																																BgL_proc2z00_26698;
																																																																															obj_t
																																																																																BgL_proc1z00_26697;
																																																																															obj_t
																																																																																BgL_testz00_26696;
																																																																															BgL_testz00_26696
																																																																																=
																																																																																BgL_arg6229z00_7800;
																																																																															BgL_proc1z00_26697
																																																																																=
																																																																																BgL_carzd251241zd2_7791;
																																																																															BgL_proc2z00_26698
																																																																																=
																																																																																BgL_carzd251247zd2_7795;
																																																																															BgL_argsz00_26699
																																																																																=
																																																																																BgL_cdrzd251224zd2_7788;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_26699;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_26698;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_26697;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_26696;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26695);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26703;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26703);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26707;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26707);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26711;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26711);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26715;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26715);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26719;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26719);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26723;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26723);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26727;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26727);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26731;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26731);
																																																											}
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_cdrzd251785zd2_7964;
																																					BgL_cdrzd251785zd2_7964
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd248481zd2_7630
																																							==
																																							CNST_TABLE_REF
																																							(((long) 17))))
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_arg6345z00_7966;
																																							obj_t
																																								BgL_arg6346z00_7967;
																																							BgL_arg6345z00_7966
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_7964));
																																							BgL_arg6346z00_7967
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_7964));
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_26742;
																																								{
																																									obj_t
																																										BgL_exprz00_26744;
																																									obj_t
																																										BgL_bindingsz00_26743;
																																									BgL_bindingsz00_26743
																																										=
																																										BgL_arg6345z00_7966;
																																									BgL_exprz00_26744
																																										=
																																										BgL_arg6346z00_7967;
																																									BgL_exprz00_1724
																																										=
																																										BgL_exprz00_26744;
																																									BgL_bindingsz00_1723
																																										=
																																										BgL_bindingsz00_26743;
																																									goto
																																										BgL_tagzd2382zd2_1725;
																																								}
																																								BgL_auxz00_21992
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_26742);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248481zd2_7630)))
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg6348z00_7969;
																																									obj_t
																																										BgL_arg6349z00_7970;
																																									BgL_arg6348z00_7969
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_7964));
																																									BgL_arg6349z00_7970
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_7964));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_26753;
																																										{
																																											obj_t
																																												BgL_exprz00_26755;
																																											obj_t
																																												BgL_bindingsz00_26754;
																																											BgL_bindingsz00_26754
																																												=
																																												BgL_arg6348z00_7969;
																																											BgL_exprz00_26755
																																												=
																																												BgL_arg6349z00_7970;
																																											BgL_exprz00_1724
																																												=
																																												BgL_exprz00_26755;
																																											BgL_bindingsz00_1723
																																												=
																																												BgL_bindingsz00_26754;
																																											goto
																																												BgL_tagzd2382zd2_1725;
																																										}
																																										BgL_auxz00_21992
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_26753);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((BgL_carzd248481zd2_7630 == CNST_TABLE_REF(((long) 18))))
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg6351z00_7972;
																																											obj_t
																																												BgL_arg6352z00_7973;
																																											BgL_arg6351z00_7972
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_7964));
																																											BgL_arg6352z00_7973
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_7964));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_26764;
																																												{
																																													obj_t
																																														BgL_exprz00_26766;
																																													obj_t
																																														BgL_bindingsz00_26765;
																																													BgL_bindingsz00_26765
																																														=
																																														BgL_arg6351z00_7972;
																																													BgL_exprz00_26766
																																														=
																																														BgL_arg6352z00_7973;
																																													BgL_exprz00_1724
																																														=
																																														BgL_exprz00_26766;
																																													BgL_bindingsz00_1723
																																														=
																																														BgL_bindingsz00_26765;
																																													goto
																																														BgL_tagzd2382zd2_1725;
																																												}
																																												BgL_auxz00_21992
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26764);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26773;
																																													goto
																																														BgL_tagzd2383zd2_1726;
																																													BgL_auxz00_21992
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26773);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_carzd251822zd2_7976;
																																													BgL_carzd251822zd2_7976
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd251822zd2_7976 == CNST_TABLE_REF(((long) 19))))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26780;
																																															goto
																																																BgL_tagzd2384zd2_1727;
																																															BgL_auxz00_21992
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26780);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd251822zd2_7976)))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26785;
																																																	goto
																																																		BgL_tagzd2384zd2_1727;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26785);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_26792;
																																																			goto
																																																				BgL_tagzd2389zd2_1746;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26792);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26799;
																																																					goto
																																																						BgL_tagzd2390zd2_1747;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26799);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd251902zd2_7983;
																																																					BgL_cdrzd251902zd2_7983
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_arg6363z00_7986;
																																																							obj_t
																																																								BgL_arg6364z00_7987;
																																																							BgL_arg6363z00_7986
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_7983));
																																																							BgL_arg6364z00_7987
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_7983));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_26812;
																																																								{
																																																									obj_t
																																																										BgL_restz00_26814;
																																																									obj_t
																																																										BgL_effectz00_26813;
																																																									BgL_effectz00_26813
																																																										=
																																																										BgL_arg6363z00_7986;
																																																									BgL_restz00_26814
																																																										=
																																																										BgL_arg6364z00_7987;
																																																									BgL_restz00_1749
																																																										=
																																																										BgL_restz00_26814;
																																																									BgL_effectz00_1748
																																																										=
																																																										BgL_effectz00_26813;
																																																									goto
																																																										BgL_tagzd2391zd2_1750;
																																																								}
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_26812);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_26821;
																																																									goto
																																																										BgL_tagzd2392zd2_1751;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_26821);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26828;
																																																											goto
																																																												BgL_tagzd2393zd2_1752;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26828);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_arg6371z00_7995;
																																																													obj_t
																																																														BgL_arg6372z00_7996;
																																																													BgL_arg6371z00_7995
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_7983));
																																																													BgL_arg6372z00_7996
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_7983));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26839;
																																																														{
																																																															obj_t
																																																																BgL_restz00_26841;
																																																															obj_t
																																																																BgL_effectz00_26840;
																																																															BgL_effectz00_26840
																																																																=
																																																																BgL_arg6371z00_7995;
																																																															BgL_restz00_26841
																																																																=
																																																																BgL_arg6372z00_7996;
																																																															BgL_restz00_1754
																																																																=
																																																																BgL_restz00_26841;
																																																															BgL_effectz00_1753
																																																																=
																																																																BgL_effectz00_26840;
																																																															goto
																																																																BgL_tagzd2394zd2_1755;
																																																														}
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26839);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_26848;
																																																															goto
																																																																BgL_tagzd2395zd2_1756;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_26848);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26855;
																																																																	goto
																																																																		BgL_tagzd2396zd2_1757;
																																																																	BgL_auxz00_21992
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26855);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																		{
																																																																			BgL_letzd2funzd2_bglt
																																																																				BgL_auxz00_26862;
																																																																			goto
																																																																				BgL_tagzd2397zd2_1758;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26862);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																				{
																																																																					BgL_jumpzd2exzd2itz00_bglt
																																																																						BgL_auxz00_26869;
																																																																					goto
																																																																						BgL_tagzd2398zd2_1759;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26869);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd251979zd2_8005;
																																																																					BgL_cdrzd251979zd2_8005
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_arg6383z00_8008;
																																																																							obj_t
																																																																								BgL_arg6384z00_8009;
																																																																							BgL_arg6383z00_8008
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8005));
																																																																							BgL_arg6384z00_8009
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8005));
																																																																							{	/* Ast/sexp.scm 563 */
																																																																								obj_t
																																																																									BgL_arg7000z00_12922;
																																																																								BgL_arg7000z00_12922
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																										BgL_arg6383z00_8008,
																																																																										CNST_TABLE_REF
																																																																										(((long) 4)), BgL_arg6384z00_8009, BgL_stackz00_22, BgL_arg7000z00_12922, BgL_sitez00_24));
																																																																						}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26888;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26888);
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									obj_t BgL_carzd252004zd2_8025;

																									BgL_carzd252004zd2_8025 =
																										CAR(
																										((obj_t) BgL_expz00_21));
																									if (
																										(BgL_carzd252004zd2_8025 ==
																											CNST_TABLE_REF(((long)
																													1))))
																										{
																											BgL_nodez00_bglt
																												BgL_auxz00_26895;
																											goto
																												BgL_tagzd2377zd2_1714;
																											BgL_auxz00_21992 =
																												((obj_t)
																												BgL_auxz00_26895);
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											if (
																												(BgL_carzd252004zd2_8025
																													==
																													BGl_za2ifza2z00zzast_sexpz00))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_26899;
																													goto
																														BgL_tagzd2377zd2_1714;
																													BgL_auxz00_21992 =
																														((obj_t)
																														BgL_auxz00_26899);
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(CAR(
																																((obj_t)
																																	BgL_expz00_21))
																															==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_26906;
																															goto
																																BgL_tagzd2379zd2_1718;
																															BgL_auxz00_21992 =
																																((obj_t)
																																BgL_auxz00_26906);
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26913;
																																	goto
																																		BgL_tagzd2380zd2_1719;
																																	BgL_auxz00_21992
																																		=
																																		((obj_t)
																																		BgL_auxz00_26913);
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd252073zd2_8032;
																																	BgL_carzd252073zd2_8032
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (PAIRP
																																		(BgL_carzd252073zd2_8032))
																																		{	/* Ast/sexp.scm 118 */
																																			obj_t
																																				BgL_carzd252076zd2_8034;
																																			obj_t
																																				BgL_cdrzd252077zd2_8035;
																																			BgL_carzd252076zd2_8034
																																				=
																																				CAR
																																				(BgL_carzd252073zd2_8032);
																																			BgL_cdrzd252077zd2_8035
																																				=
																																				CDR
																																				(BgL_carzd252073zd2_8032);
																																			{

																																				if (
																																					(BgL_carzd252076zd2_8034
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{	/* Ast/sexp.scm 118 */
																																					BgL_kapzd252078zd2_8036:
																																						if (PAIRP(BgL_cdrzd252077zd2_8035))
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd252081zd2_8155;
																																								BgL_cdrzd252081zd2_8155
																																									=
																																									CDR
																																									(BgL_cdrzd252077zd2_8035);
																																								if (PAIRP(BgL_cdrzd252081zd2_8155))
																																									{	/* Ast/sexp.scm 118 */
																																										if (NULLP(CDR(BgL_cdrzd252081zd2_8155)))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg6486z00_8159;
																																												obj_t
																																													BgL_arg6487z00_8160;
																																												BgL_arg6486z00_8159
																																													=
																																													CAR
																																													(BgL_cdrzd252081zd2_8155);
																																												BgL_arg6487z00_8160
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26935;
																																													{
																																														obj_t
																																															BgL_argsz00_26937;
																																														obj_t
																																															BgL_bodyz00_26936;
																																														BgL_bodyz00_26936
																																															=
																																															BgL_arg6486z00_8159;
																																														BgL_argsz00_26937
																																															=
																																															BgL_arg6487z00_8160;
																																														BgL_argsz00_1721
																																															=
																																															BgL_argsz00_26937;
																																														BgL_bodyz00_1720
																																															=
																																															BgL_bodyz00_26936;
																																														goto
																																															BgL_tagzd2381zd2_1722;
																																													}
																																													BgL_auxz00_21992
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26935);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_26939;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg6551z00_8266;
																																													BgL_arg6551z00_8266
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_26939
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg6551z00_8266));
																																												}
																																												if (BgL_testz00_26939)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_26944;
																																														goto
																																															BgL_tagzd2384zd2_1727;
																																														BgL_auxz00_21992
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26944);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_carzd252159zd2_8163;
																																														BgL_carzd252159zd2_8163
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd252164zd2_8164;
																																															BgL_cdrzd252164zd2_8164
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd252159zd2_8163));
																																															if ((CAR(((obj_t) BgL_carzd252159zd2_8163)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg6492z00_8167;
																																																	obj_t
																																																		BgL_arg6493z00_8168;
																																																	obj_t
																																																		BgL_arg6494z00_8169;
																																																	BgL_arg6492z00_8167
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8164));
																																																	BgL_arg6493z00_8168
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8164));
																																																	BgL_arg6494z00_8169
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_26961;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_26964;
																																																			obj_t
																																																				BgL_bodyz00_26963;
																																																			obj_t
																																																				BgL_varsz00_26962;
																																																			BgL_varsz00_26962
																																																				=
																																																				BgL_arg6492z00_8167;
																																																			BgL_bodyz00_26963
																																																				=
																																																				BgL_arg6493z00_8168;
																																																			BgL_argsz00_26964
																																																				=
																																																				BgL_arg6494z00_8169;
																																																			BgL_argsz00_1734
																																																				=
																																																				BgL_argsz00_26964;
																																																			BgL_bodyz00_1733
																																																				=
																																																				BgL_bodyz00_26963;
																																																			BgL_varsz00_1732
																																																				=
																																																				BgL_varsz00_26962;
																																																			goto
																																																				BgL_tagzd2386zd2_1735;
																																																		}
																																																		BgL_auxz00_21992
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_26961);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd252187zd2_8171;
																																																	BgL_cdrzd252187zd2_8171
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_cdrzd252193zd2_8172;
																																																		BgL_cdrzd252193zd2_8172
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd252159zd2_8163));
																																																		if ((CAR(((obj_t) BgL_carzd252159zd2_8163)) == CNST_TABLE_REF(((long) 1))))
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd252199zd2_8175;
																																																				BgL_cdrzd252199zd2_8175
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd252193zd2_8172));
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_carzd252204zd2_8176;
																																																					obj_t
																																																						BgL_cdrzd252205zd2_8177;
																																																					BgL_carzd252204zd2_8176
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8175));
																																																					BgL_cdrzd252205zd2_8177
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8175));
																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252204zd2_8176))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd252205zd2_8177))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd252212zd2_8180;
																																																									BgL_carzd252212zd2_8180
																																																										=
																																																										CAR
																																																										(BgL_cdrzd252205zd2_8177);
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252212zd2_8180))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (NULLP(CDR(BgL_cdrzd252205zd2_8177)))
																																																												{	/* Ast/sexp.scm 118 */
																																																													bool_t
																																																														BgL_testz00_26991;
																																																													{
																																																														obj_t
																																																															BgL_l1453z00_8213;
																																																														BgL_l1453z00_8213
																																																															=
																																																															BgL_cdrzd252187zd2_8171;
																																																													BgL_zc3anonymousza36517ze3z83_8214:
																																																														if (NULLP(BgL_l1453z00_8213))
																																																															{	/* Ast/sexp.scm 118 */
																																																																BgL_testz00_26991
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	1);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																bool_t
																																																																	BgL_testz00_26994;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	bool_t
																																																																		BgL_testz00_26995;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_tmpz00_26996;
																																																																		BgL_tmpz00_26996
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_l1453z00_8213));
																																																																		BgL_testz00_26995
																																																																			=
																																																																			PAIRP
																																																																			(BgL_tmpz00_26996);
																																																																	}
																																																																	if (BgL_testz00_26995)
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			BgL_testz00_26994
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			BgL_testz00_26994
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				1);
																																																																		}
																																																																}
																																																																if (BgL_testz00_26994)
																																																																	{
																																																																		obj_t
																																																																			BgL_l1453z00_27000;
																																																																		BgL_l1453z00_27000
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_l1453z00_8213));
																																																																		BgL_l1453z00_8213
																																																																			=
																																																																			BgL_l1453z00_27000;
																																																																		goto
																																																																			BgL_zc3anonymousza36517ze3z83_8214;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		BgL_testz00_26991
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																															}
																																																													}
																																																													if (BgL_testz00_26991)
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_arg6507z00_8196;
																																																															BgL_arg6507z00_8196
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd252193zd2_8172));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27005;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_27009;
																																																																	obj_t
																																																																		BgL_proc2z00_27008;
																																																																	obj_t
																																																																		BgL_proc1z00_27007;
																																																																	obj_t
																																																																		BgL_testz00_27006;
																																																																	BgL_testz00_27006
																																																																		=
																																																																		BgL_arg6507z00_8196;
																																																																	BgL_proc1z00_27007
																																																																		=
																																																																		BgL_carzd252204zd2_8176;
																																																																	BgL_proc2z00_27008
																																																																		=
																																																																		BgL_carzd252212zd2_8180;
																																																																	BgL_argsz00_27009
																																																																		=
																																																																		BgL_cdrzd252187zd2_8171;
																																																																	BgL_argsz00_1739
																																																																		=
																																																																		BgL_argsz00_27009;
																																																																	BgL_proc2z00_1738
																																																																		=
																																																																		BgL_proc2z00_27008;
																																																																	BgL_proc1z00_1737
																																																																		=
																																																																		BgL_proc1z00_27007;
																																																																	BgL_testz00_1736
																																																																		=
																																																																		BgL_testz00_27006;
																																																																	goto
																																																																		BgL_tagzd2387zd2_1740;
																																																																}
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27005);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd252236zd2_8197;
																																																															BgL_cdrzd252236zd2_8197
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd252243zd2_8198;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_pairz00_12962;
																																																																	BgL_pairz00_12962
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd252243zd2_8198
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_12962);
																																																																}
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd252250zd2_8199;
																																																																	BgL_cdrzd252250zd2_8199
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd252243zd2_8198));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd252256zd2_8200;
																																																																		BgL_carzd252256zd2_8200
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd252250zd2_8199));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252256zd2_8200))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd252263zd2_8202;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_12966;
																																																																					BgL_pairz00_12966
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd252250zd2_8199));
																																																																					BgL_carzd252263zd2_8202
																																																																						=
																																																																						CAR
																																																																						(BgL_pairz00_12966);
																																																																				}
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252263zd2_8202))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252236zd2_8197))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg6511z00_8205;
																																																																								BgL_arg6511z00_8205
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd252243zd2_8198));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27031;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27035;
																																																																										obj_t
																																																																											BgL_proc2z00_27034;
																																																																										obj_t
																																																																											BgL_proc1z00_27033;
																																																																										obj_t
																																																																											BgL_testz00_27032;
																																																																										BgL_testz00_27032
																																																																											=
																																																																											BgL_arg6511z00_8205;
																																																																										BgL_proc1z00_27033
																																																																											=
																																																																											BgL_carzd252256zd2_8200;
																																																																										BgL_proc2z00_27034
																																																																											=
																																																																											BgL_carzd252263zd2_8202;
																																																																										BgL_argsz00_27035
																																																																											=
																																																																											BgL_cdrzd252236zd2_8197;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_27035;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_27034;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_27033;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_27032;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1745;
																																																																									}
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27031);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27039;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27039);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27043;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27043);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27047;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27047);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27051;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27051);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd252539zd2_8224;
																																																											BgL_cdrzd252539zd2_8224
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd252545zd2_8225;
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_pairz00_12970;
																																																													BgL_pairz00_12970
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd252545zd2_8225
																																																														=
																																																														CDR
																																																														(BgL_pairz00_12970);
																																																												}
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd252551zd2_8226;
																																																													BgL_cdrzd252551zd2_8226
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd252545zd2_8225));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd252556zd2_8227;
																																																														obj_t
																																																															BgL_cdrzd252557zd2_8228;
																																																														BgL_carzd252556zd2_8227
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8226));
																																																														BgL_cdrzd252557zd2_8228
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8226));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252556zd2_8227))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd252562zd2_8230;
																																																																BgL_carzd252562zd2_8230
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd252557zd2_8228));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252562zd2_8230))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd252557zd2_8228))))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252539zd2_8224))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg6526z00_8235;
																																																																						BgL_arg6526z00_8235
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd252545zd2_8225));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27078;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_27082;
																																																																								obj_t
																																																																									BgL_proc2z00_27081;
																																																																								obj_t
																																																																									BgL_proc1z00_27080;
																																																																								obj_t
																																																																									BgL_testz00_27079;
																																																																								BgL_testz00_27079
																																																																									=
																																																																									BgL_arg6526z00_8235;
																																																																								BgL_proc1z00_27080
																																																																									=
																																																																									BgL_carzd252556zd2_8227;
																																																																								BgL_proc2z00_27081
																																																																									=
																																																																									BgL_carzd252562zd2_8230;
																																																																								BgL_argsz00_27082
																																																																									=
																																																																									BgL_cdrzd252539zd2_8224;
																																																																								BgL_argsz00_1744
																																																																									=
																																																																									BgL_argsz00_27082;
																																																																								BgL_proc2z00_1743
																																																																									=
																																																																									BgL_proc2z00_27081;
																																																																								BgL_proc1z00_1742
																																																																									=
																																																																									BgL_proc1z00_27080;
																																																																								BgL_testz00_1741
																																																																									=
																																																																									BgL_testz00_27079;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1745;
																																																																							}
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27078);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27086;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_21992
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27086);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27090;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27090);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27094;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27094);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27098;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27098);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_27102;
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																											BgL_auxz00_21992
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_27102);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd252895zd2_8243;
																																																							BgL_cdrzd252895zd2_8243
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd252902zd2_8244;
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_pairz00_12980;
																																																									BgL_pairz00_12980
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdrzd252902zd2_8244
																																																										=
																																																										CDR
																																																										(BgL_pairz00_12980);
																																																								}
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd252909zd2_8245;
																																																									BgL_cdrzd252909zd2_8245
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd252902zd2_8244));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd252915zd2_8246;
																																																										obj_t
																																																											BgL_cdrzd252916zd2_8247;
																																																										BgL_carzd252915zd2_8246
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8245));
																																																										BgL_cdrzd252916zd2_8247
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8245));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252915zd2_8246))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd252916zd2_8247))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd252923zd2_8250;
																																																														BgL_carzd252923zd2_8250
																																																															=
																																																															CAR
																																																															(BgL_cdrzd252916zd2_8247);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252923zd2_8250))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (NULLP(CDR(BgL_cdrzd252916zd2_8247)))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252895zd2_8243))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg6540z00_8255;
																																																																				BgL_arg6540z00_8255
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd252902zd2_8244));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27129;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27133;
																																																																						obj_t
																																																																							BgL_proc2z00_27132;
																																																																						obj_t
																																																																							BgL_proc1z00_27131;
																																																																						obj_t
																																																																							BgL_testz00_27130;
																																																																						BgL_testz00_27130
																																																																							=
																																																																							BgL_arg6540z00_8255;
																																																																						BgL_proc1z00_27131
																																																																							=
																																																																							BgL_carzd252915zd2_8246;
																																																																						BgL_proc2z00_27132
																																																																							=
																																																																							BgL_carzd252923zd2_8250;
																																																																						BgL_argsz00_27133
																																																																							=
																																																																							BgL_cdrzd252895zd2_8243;
																																																																						BgL_argsz00_1744
																																																																							=
																																																																							BgL_argsz00_27133;
																																																																						BgL_proc2z00_1743
																																																																							=
																																																																							BgL_proc2z00_27132;
																																																																						BgL_proc1z00_1742
																																																																							=
																																																																							BgL_proc1z00_27131;
																																																																						BgL_testz00_1741
																																																																							=
																																																																							BgL_testz00_27130;
																																																																						goto
																																																																							BgL_tagzd2388zd2_1745;
																																																																					}
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27129);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27137;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_21992
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27137);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27141;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27141);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27145;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_21992
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27145);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27149;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27149);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_27153;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_21992
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_27153);
																																																													}
																																																											}
																																																									}
																																																								}
																																																							}
																																																						}
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 118 */
																																																						goto
																																																							BgL_tagzd2403zd2_1769;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27157;
																																																						goto
																																																							BgL_tagzd2404zd2_1770;
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27157);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_testz00_27159;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg6562z00_8279;
																																											BgL_arg6562z00_8279
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_testz00_27159
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg6562z00_8279));
																																										}
																																										if (BgL_testz00_27159)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_27164;
																																												goto
																																													BgL_tagzd2384zd2_1727;
																																												BgL_auxz00_21992
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27164);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_carzd253369zd2_8270;
																																												BgL_carzd253369zd2_8270
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_cdrzd253374zd2_8271;
																																													BgL_cdrzd253374zd2_8271
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_carzd253369zd2_8270));
																																													if ((CAR(((obj_t) BgL_carzd253369zd2_8270)) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6557z00_8274;
																																															obj_t
																																																BgL_arg6558z00_8275;
																																															obj_t
																																																BgL_arg6559z00_8276;
																																															BgL_arg6557z00_8274
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8271));
																																															BgL_arg6558z00_8275
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8271));
																																															BgL_arg6559z00_8276
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_27181;
																																																{
																																																	obj_t
																																																		BgL_argsz00_27184;
																																																	obj_t
																																																		BgL_bodyz00_27183;
																																																	obj_t
																																																		BgL_varsz00_27182;
																																																	BgL_varsz00_27182
																																																		=
																																																		BgL_arg6557z00_8274;
																																																	BgL_bodyz00_27183
																																																		=
																																																		BgL_arg6558z00_8275;
																																																	BgL_argsz00_27184
																																																		=
																																																		BgL_arg6559z00_8276;
																																																	BgL_argsz00_1734
																																																		=
																																																		BgL_argsz00_27184;
																																																	BgL_bodyz00_1733
																																																		=
																																																		BgL_bodyz00_27183;
																																																	BgL_varsz00_1732
																																																		=
																																																		BgL_varsz00_27182;
																																																	goto
																																																		BgL_tagzd2386zd2_1735;
																																																}
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27181);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2403zd2_1769;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27188;
																																																	goto
																																																		BgL_tagzd2404zd2_1770;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27188);
																																																}
																																														}
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								bool_t
																																									BgL_testz00_27190;
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg6566z00_8283;
																																									BgL_arg6566z00_8283
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_testz00_27190
																																										=
																																										CBOOL
																																										(BGl_labelszd2symzf3z21zzast_labelsz00
																																										(BgL_arg6566z00_8283));
																																								}
																																								if (BgL_testz00_27190)
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_27195;
																																										goto
																																											BgL_tagzd2384zd2_1727;
																																										BgL_auxz00_21992
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_27195);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_tagzd2403zd2_1769;
																																											}
																																										else
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_27199;
																																												goto
																																													BgL_tagzd2404zd2_1770;
																																												BgL_auxz00_21992
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27199);
																																											}
																																									}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd252076zd2_8034)))
																																							{	/* Ast/sexp.scm 118 */
																																								goto
																																									BgL_kapzd252078zd2_8036;
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if ((BgL_carzd252076zd2_8034 == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 118 */
																																										goto
																																											BgL_kapzd252078zd2_8036;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if ((BgL_carzd252076zd2_8034 == CNST_TABLE_REF(((long) 19))))
																																											{	/* Ast/sexp.scm 118 */
																																												goto
																																													BgL_kapzd252078zd2_8036;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd252076zd2_8034)))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_kapzd252078zd2_8036;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_27213;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg6481z00_8153;
																																															BgL_arg6481z00_8153
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_27213
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg6481z00_8153));
																																														}
																																														if (BgL_testz00_27213)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27218;
																																																goto
																																																	BgL_tagzd2384zd2_1727;
																																																BgL_auxz00_21992
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27218);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd253697zd2_8044;
																																																BgL_carzd253697zd2_8044
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd253702zd2_8045;
																																																	BgL_cdrzd253702zd2_8045
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd253697zd2_8044));
																																																	if ((CAR(((obj_t) BgL_carzd253697zd2_8044)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (PAIRP(BgL_cdrzd253702zd2_8045))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg6417z00_8049;
																																																					obj_t
																																																						BgL_arg6418z00_8050;
																																																					obj_t
																																																						BgL_arg6419z00_8051;
																																																					BgL_arg6417z00_8049
																																																						=
																																																						CAR
																																																						(BgL_cdrzd253702zd2_8045);
																																																					BgL_arg6418z00_8050
																																																						=
																																																						CDR
																																																						(BgL_cdrzd253702zd2_8045);
																																																					BgL_arg6419z00_8051
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27235;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27238;
																																																							obj_t
																																																								BgL_bodyz00_27237;
																																																							obj_t
																																																								BgL_varsz00_27236;
																																																							BgL_varsz00_27236
																																																								=
																																																								BgL_arg6417z00_8049;
																																																							BgL_bodyz00_27237
																																																								=
																																																								BgL_arg6418z00_8050;
																																																							BgL_argsz00_27238
																																																								=
																																																								BgL_arg6419z00_8051;
																																																							BgL_argsz00_1734
																																																								=
																																																								BgL_argsz00_27238;
																																																							BgL_bodyz00_1733
																																																								=
																																																								BgL_bodyz00_27237;
																																																							BgL_varsz00_1732
																																																								=
																																																								BgL_varsz00_27236;
																																																							goto
																																																								BgL_tagzd2386zd2_1735;
																																																						}
																																																						BgL_auxz00_21992
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27235);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2403zd2_1769;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_27242;
																																																							goto
																																																								BgL_tagzd2404zd2_1770;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27242);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd253809zd2_8054;
																																																			BgL_cdrzd253809zd2_8054
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd253814zd2_8055;
																																																				BgL_cdrzd253814zd2_8055
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd253697zd2_8044));
																																																				if ((CAR(((obj_t) BgL_carzd253697zd2_8044)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (PAIRP(BgL_cdrzd253814zd2_8055))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd253819zd2_8059;
																																																								BgL_cdrzd253819zd2_8059
																																																									=
																																																									CDR
																																																									(BgL_cdrzd253814zd2_8055);
																																																								if (PAIRP(BgL_cdrzd253819zd2_8059))
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_carzd253823zd2_8061;
																																																										obj_t
																																																											BgL_cdrzd253824zd2_8062;
																																																										BgL_carzd253823zd2_8061
																																																											=
																																																											CAR
																																																											(BgL_cdrzd253819zd2_8059);
																																																										BgL_cdrzd253824zd2_8062
																																																											=
																																																											CDR
																																																											(BgL_cdrzd253819zd2_8059);
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253823zd2_8061))
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (PAIRP(BgL_cdrzd253824zd2_8062))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd253829zd2_8065;
																																																														BgL_carzd253829zd2_8065
																																																															=
																																																															CAR
																																																															(BgL_cdrzd253824zd2_8062);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253829zd2_8065))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (NULLP(CDR(BgL_cdrzd253824zd2_8062)))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_testz00_27270;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1456z00_8098;
																																																																			BgL_l1456z00_8098
																																																																				=
																																																																				BgL_cdrzd253809zd2_8054;
																																																																		BgL_zc3anonymousza36445ze3z83_8099:
																																																																			if (NULLP(BgL_l1456z00_8098))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_testz00_27270
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_testz00_27273;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_27274;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_tmpz00_27275;
																																																																							BgL_tmpz00_27275
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1456z00_8098));
																																																																							BgL_testz00_27274
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_27275);
																																																																						}
																																																																						if (BgL_testz00_27274)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_27273
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_27273
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_testz00_27273)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1456z00_27279;
																																																																							BgL_l1456z00_27279
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1456z00_8098));
																																																																							BgL_l1456z00_8098
																																																																								=
																																																																								BgL_l1456z00_27279;
																																																																							goto
																																																																								BgL_zc3anonymousza36445ze3z83_8099;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_27270
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_testz00_27270)
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg6435z00_8081;
																																																																				BgL_arg6435z00_8081
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd253814zd2_8055);
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27283;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27287;
																																																																						obj_t
																																																																							BgL_proc2z00_27286;
																																																																						obj_t
																																																																							BgL_proc1z00_27285;
																																																																						obj_t
																																																																							BgL_testz00_27284;
																																																																						BgL_testz00_27284
																																																																							=
																																																																							BgL_arg6435z00_8081;
																																																																						BgL_proc1z00_27285
																																																																							=
																																																																							BgL_carzd253823zd2_8061;
																																																																						BgL_proc2z00_27286
																																																																							=
																																																																							BgL_carzd253829zd2_8065;
																																																																						BgL_argsz00_27287
																																																																							=
																																																																							BgL_cdrzd253809zd2_8054;
																																																																						BgL_argsz00_1739
																																																																							=
																																																																							BgL_argsz00_27287;
																																																																						BgL_proc2z00_1738
																																																																							=
																																																																							BgL_proc2z00_27286;
																																																																						BgL_proc1z00_1737
																																																																							=
																																																																							BgL_proc1z00_27285;
																																																																						BgL_testz00_1736
																																																																							=
																																																																							BgL_testz00_27284;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1740;
																																																																					}
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27283);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd253854zd2_8082;
																																																																				BgL_cdrzd253854zd2_8082
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd253862zd2_8083;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_13025;
																																																																						BgL_pairz00_13025
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd253862zd2_8083
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13025);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd253870zd2_8084;
																																																																						BgL_cdrzd253870zd2_8084
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd253862zd2_8083));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd253877zd2_8085;
																																																																							BgL_carzd253877zd2_8085
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd253870zd2_8084));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253877zd2_8085))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd253886zd2_8087;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_13029;
																																																																										BgL_pairz00_13029
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd253870zd2_8084));
																																																																										BgL_carzd253886zd2_8087
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_13029);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253886zd2_8087))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd253854zd2_8082))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg6439z00_8090;
																																																																													BgL_arg6439z00_8090
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd253862zd2_8083));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27309;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_27313;
																																																																															obj_t
																																																																																BgL_proc2z00_27312;
																																																																															obj_t
																																																																																BgL_proc1z00_27311;
																																																																															obj_t
																																																																																BgL_testz00_27310;
																																																																															BgL_testz00_27310
																																																																																=
																																																																																BgL_arg6439z00_8090;
																																																																															BgL_proc1z00_27311
																																																																																=
																																																																																BgL_carzd253877zd2_8085;
																																																																															BgL_proc2z00_27312
																																																																																=
																																																																																BgL_carzd253886zd2_8087;
																																																																															BgL_argsz00_27313
																																																																																=
																																																																																BgL_cdrzd253854zd2_8082;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_27313;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_27312;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_27311;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_27310;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_21992
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27309);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27317;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_21992
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27317);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27321;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27321);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27325;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27325);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27329;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_21992
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27329);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd254164zd2_8109;
																																																																BgL_cdrzd254164zd2_8109
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd254171zd2_8110;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_13033;
																																																																		BgL_pairz00_13033
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd254171zd2_8110
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13033);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd254178zd2_8111;
																																																																		BgL_cdrzd254178zd2_8111
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd254171zd2_8110));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd254184zd2_8112;
																																																																			obj_t
																																																																				BgL_cdrzd254185zd2_8113;
																																																																			BgL_carzd254184zd2_8112
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8111));
																																																																			BgL_cdrzd254185zd2_8113
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8111));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254184zd2_8112))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd254192zd2_8115;
																																																																					BgL_carzd254192zd2_8115
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd254185zd2_8113));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254192zd2_8115))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd254185zd2_8113))))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254164zd2_8109))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_arg6454z00_8120;
																																																																											BgL_arg6454z00_8120
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd254171zd2_8110));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27356;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_27360;
																																																																													obj_t
																																																																														BgL_proc2z00_27359;
																																																																													obj_t
																																																																														BgL_proc1z00_27358;
																																																																													obj_t
																																																																														BgL_testz00_27357;
																																																																													BgL_testz00_27357
																																																																														=
																																																																														BgL_arg6454z00_8120;
																																																																													BgL_proc1z00_27358
																																																																														=
																																																																														BgL_carzd254184zd2_8112;
																																																																													BgL_proc2z00_27359
																																																																														=
																																																																														BgL_carzd254192zd2_8115;
																																																																													BgL_argsz00_27360
																																																																														=
																																																																														BgL_cdrzd254164zd2_8109;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_27360;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_27359;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_27358;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_27357;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																												BgL_auxz00_21992
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27356);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27364;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_21992
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27364);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27368;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27368);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27372;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27372);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27376;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27376);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27380;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_21992
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27380);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd254525zd2_8128;
																																																												BgL_cdrzd254525zd2_8128
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd254531zd2_8129;
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_pairz00_13043;
																																																														BgL_pairz00_13043
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd254531zd2_8129
																																																															=
																																																															CDR
																																																															(BgL_pairz00_13043);
																																																													}
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd254537zd2_8130;
																																																														BgL_cdrzd254537zd2_8130
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd254531zd2_8129));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd254542zd2_8131;
																																																															obj_t
																																																																BgL_cdrzd254543zd2_8132;
																																																															BgL_carzd254542zd2_8131
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8130));
																																																															BgL_cdrzd254543zd2_8132
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8130));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254542zd2_8131))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (PAIRP(BgL_cdrzd254543zd2_8132))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd254548zd2_8135;
																																																																			BgL_carzd254548zd2_8135
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd254543zd2_8132);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254548zd2_8135))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (NULLP(CDR(BgL_cdrzd254543zd2_8132)))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254525zd2_8128))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg6468z00_8140;
																																																																									BgL_arg6468z00_8140
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd254531zd2_8129));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27407;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_27411;
																																																																											obj_t
																																																																												BgL_proc2z00_27410;
																																																																											obj_t
																																																																												BgL_proc1z00_27409;
																																																																											obj_t
																																																																												BgL_testz00_27408;
																																																																											BgL_testz00_27408
																																																																												=
																																																																												BgL_arg6468z00_8140;
																																																																											BgL_proc1z00_27409
																																																																												=
																																																																												BgL_carzd254542zd2_8131;
																																																																											BgL_proc2z00_27410
																																																																												=
																																																																												BgL_carzd254548zd2_8135;
																																																																											BgL_argsz00_27411
																																																																												=
																																																																												BgL_cdrzd254525zd2_8128;
																																																																											BgL_argsz00_1744
																																																																												=
																																																																												BgL_argsz00_27411;
																																																																											BgL_proc2z00_1743
																																																																												=
																																																																												BgL_proc2z00_27410;
																																																																											BgL_proc1z00_1742
																																																																												=
																																																																												BgL_proc1z00_27409;
																																																																											BgL_testz00_1741
																																																																												=
																																																																												BgL_testz00_27408;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1745;
																																																																										}
																																																																										BgL_auxz00_21992
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27407);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27415;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_21992
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27415);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27419;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_21992
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27419);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27423;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_21992
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27423);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27427;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																					BgL_auxz00_21992
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27427);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27431;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_21992
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27431);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_27435;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_21992
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_27435);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1769;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27439;
																																																										goto
																																																											BgL_tagzd2404zd2_1770;
																																																										BgL_auxz00_21992
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27439);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1769;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_27443;
																																																								goto
																																																									BgL_tagzd2404zd2_1770;
																																																								BgL_auxz00_21992
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_27443);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (
																																				(BgL_carzd252073zd2_8032
																																					==
																																					CNST_TABLE_REF
																																					(((long) 20))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_27448;
																																					goto
																																						BgL_tagzd2383zd2_1726;
																																					BgL_auxz00_21992
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_27448);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_carzd255110zd2_8286;
																																					BgL_carzd255110zd2_8286
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd255110zd2_8286
																																							==
																																							CNST_TABLE_REF
																																							(((long) 19))))
																																						{
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_27455;
																																							goto
																																								BgL_tagzd2384zd2_1727;
																																							BgL_auxz00_21992
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_27455);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255110zd2_8286)))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_27460;
																																									goto
																																										BgL_tagzd2384zd2_1727;
																																									BgL_auxz00_21992
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_27460);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27467;
																																											goto
																																												BgL_tagzd2389zd2_1746;
																																											BgL_auxz00_21992
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27467);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27474;
																																													goto
																																														BgL_tagzd2390zd2_1747;
																																													BgL_auxz00_21992
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27474);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_27481;
																																															goto
																																																BgL_tagzd2392zd2_1751;
																																															BgL_auxz00_21992
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_27481);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27488;
																																																	goto
																																																		BgL_tagzd2393zd2_1752;
																																																	BgL_auxz00_21992
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27488);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_27495;
																																																			goto
																																																				BgL_tagzd2395zd2_1756;
																																																			BgL_auxz00_21992
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_27495);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_27502;
																																																					goto
																																																						BgL_tagzd2396zd2_1757;
																																																					BgL_auxz00_21992
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_27502);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_27509;
																																																							goto
																																																								BgL_tagzd2397zd2_1758;
																																																							BgL_auxz00_21992
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27509);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																								{
																																																									BgL_jumpzd2exzd2itz00_bglt
																																																										BgL_auxz00_27516;
																																																									goto
																																																										BgL_tagzd2398zd2_1759;
																																																									BgL_auxz00_21992
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_27516);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27526;
																																																													goto
																																																														BgL_tagzd2402zd2_1768;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27526);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27530;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_21992
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27530);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27534;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_21992
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27534);
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_21992);
																						}
																					else
																						{	/* Ast/sexp.scm 118 */
																							if (
																								(BgL_carzd231447zd2_5073 ==
																									BGl_za2ifza2z00zzast_sexpz00))
																								{
																									obj_t BgL_auxz00_27539;

																									goto BgL_kapzd231449zd2_5075;
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_27539);
																								}
																							else
																								{	/* Ast/sexp.scm 118 */
																									bool_t BgL_testz00_27541;

																									{	/* Ast/sexp.scm 118 */
																										obj_t BgL_arg4833z00_5820;

																										BgL_arg4833z00_5820 =
																											CAR(BgL_expz00_21);
																										BgL_testz00_27541 =
																											(BgL_arg4833z00_5820 ==
																											BGl_za2ifza2z00zzast_sexpz00);
																									}
																									if (BgL_testz00_27541)
																										{	/* Ast/sexp.scm 118 */
																											goto
																												BgL_tagzd2377zd2_1714;
																										}
																									else
																										{	/* Ast/sexp.scm 118 */
																											obj_t
																												BgL_cdrzd255282zd2_5080;
																											BgL_cdrzd255282zd2_5080 =
																												CDR(BgL_expz00_21);
																											if ((CAR(BgL_expz00_21) ==
																													CNST_TABLE_REF(((long)
																															7))))
																												{	/* Ast/sexp.scm 118 */
																													if (PAIRP
																														(BgL_cdrzd255282zd2_5080))
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd255285zd2_5084;
																															obj_t
																																BgL_cdrzd255286zd2_5085;
																															BgL_carzd255285zd2_5084
																																=
																																CAR
																																(BgL_cdrzd255282zd2_5080);
																															BgL_cdrzd255286zd2_5085
																																=
																																CDR
																																(BgL_cdrzd255282zd2_5080);
																															if (PAIRP
																																(BgL_carzd255285zd2_5084))
																																{	/* Ast/sexp.scm 118 */
																																	if (
																																		(CAR
																																			(BgL_carzd255285zd2_5084)
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					14))))
																																		{	/* Ast/sexp.scm 118 */
																																			if (PAIRP
																																				(BgL_cdrzd255286zd2_5085))
																																				{	/* Ast/sexp.scm 118 */
																																					if (NULLP(CDR(BgL_cdrzd255286zd2_5085)))
																																						{
																																							obj_t
																																								BgL_valz00_27566;
																																							obj_t
																																								BgL_lz00_27564;
																																							BgL_lz00_27564
																																								=
																																								CDR
																																								(BgL_carzd255285zd2_5084);
																																							BgL_valz00_27566
																																								=
																																								CAR
																																								(BgL_cdrzd255286zd2_5085);
																																							BgL_valz00_1716
																																								=
																																								BgL_valz00_27566;
																																							BgL_lz00_1715
																																								=
																																								BgL_lz00_27564;
																																							goto
																																								BgL_tagzd2378zd2_1717;
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							goto
																																								BgL_tagzd2379zd2_1718;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					goto
																																						BgL_tagzd2379zd2_1718;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			goto
																																				BgL_tagzd2379zd2_1718;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 118 */
																																	goto
																																		BgL_tagzd2379zd2_1718;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															goto
																																BgL_tagzd2379zd2_1718;
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 118 */
																													if (
																														(CAR(BgL_expz00_21)
																															==
																															CNST_TABLE_REF((
																																	(long) 16))))
																														{	/* Ast/sexp.scm 118 */
																															goto
																																BgL_tagzd2380zd2_1719;
																														}
																													else
																														{	/* Ast/sexp.scm 118 */
																															obj_t
																																BgL_carzd255411zd2_5098;
																															BgL_carzd255411zd2_5098
																																=
																																CAR
																																(BgL_expz00_21);
																															if (PAIRP
																																(BgL_carzd255411zd2_5098))
																																{	/* Ast/sexp.scm 118 */
																																	obj_t
																																		BgL_carzd255414zd2_5100;
																																	obj_t
																																		BgL_cdrzd255415zd2_5101;
																																	BgL_carzd255414zd2_5100
																																		=
																																		CAR
																																		(BgL_carzd255411zd2_5098);
																																	BgL_cdrzd255415zd2_5101
																																		=
																																		CDR
																																		(BgL_carzd255411zd2_5098);
																																	{

																																		if (
																																			(BgL_carzd255414zd2_5100
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{
																																				obj_t
																																					BgL_auxz00_27580;
																																			BgL_kapzd255416zd2_5102:
																																				if (PAIRP(BgL_cdrzd255415zd2_5101))
																																					{	/* Ast/sexp.scm 118 */
																																						obj_t
																																							BgL_cdrzd255419zd2_5404;
																																						BgL_cdrzd255419zd2_5404
																																							=
																																							CDR
																																							(BgL_cdrzd255415zd2_5101);
																																						if (PAIRP(BgL_cdrzd255419zd2_5404))
																																							{	/* Ast/sexp.scm 118 */
																																								if (NULLP(CDR(BgL_cdrzd255419zd2_5404)))
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_arg4530z00_5408;
																																										obj_t
																																											BgL_arg4531z00_5409;
																																										BgL_arg4530z00_5408
																																											=
																																											CAR
																																											(BgL_cdrzd255419zd2_5404);
																																										BgL_arg4531z00_5409
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27592;
																																											{
																																												obj_t
																																													BgL_argsz00_27594;
																																												obj_t
																																													BgL_bodyz00_27593;
																																												BgL_bodyz00_27593
																																													=
																																													BgL_arg4530z00_5408;
																																												BgL_argsz00_27594
																																													=
																																													BgL_arg4531z00_5409;
																																												BgL_argsz00_1721
																																													=
																																													BgL_argsz00_27594;
																																												BgL_bodyz00_1720
																																													=
																																													BgL_bodyz00_27593;
																																												goto
																																													BgL_tagzd2381zd2_1722;
																																											}
																																											BgL_auxz00_27580
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27592);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										obj_t
																																											BgL_cdrzd255442zd2_5410;
																																										BgL_cdrzd255442zd2_5410
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_27598;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4598z00_5520;
																																													BgL_arg4598z00_5520
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_27598
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg4598z00_5520));
																																												}
																																												if (BgL_testz00_27598)
																																													{	/* Ast/sexp.scm 118 */
																																														if (PAIRP(BgL_cdrzd255442zd2_5410))
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_arg4600z00_5522;
																																																obj_t
																																																	BgL_arg4601z00_5523;
																																																BgL_arg4600z00_5522
																																																	=
																																																	CAR
																																																	(BgL_cdrzd255442zd2_5410);
																																																BgL_arg4601z00_5523
																																																	=
																																																	CDR
																																																	(BgL_cdrzd255442zd2_5410);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27607;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_27609;
																																																		obj_t
																																																			BgL_bindingsz00_27608;
																																																		BgL_bindingsz00_27608
																																																			=
																																																			BgL_arg4600z00_5522;
																																																		BgL_exprz00_27609
																																																			=
																																																			BgL_arg4601z00_5523;
																																																		BgL_exprz00_1724
																																																			=
																																																			BgL_exprz00_27609;
																																																		BgL_bindingsz00_1723
																																																			=
																																																			BgL_bindingsz00_27608;
																																																		goto
																																																			BgL_tagzd2382zd2_1725;
																																																	}
																																																	BgL_auxz00_27580
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27607);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_testz00_27611;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4665z00_5629;
																																																	BgL_arg4665z00_5629
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_testz00_27611
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4665z00_5629));
																																																}
																																																if (BgL_testz00_27611)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_27616;
																																																		goto
																																																			BgL_tagzd2384zd2_1727;
																																																		BgL_auxz00_27580
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27616);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd255506zd2_5526;
																																																		BgL_carzd255506zd2_5526
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd255511zd2_5527;
																																																			BgL_cdrzd255511zd2_5527
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd255506zd2_5526));
																																																			if ((CAR(((obj_t) BgL_carzd255506zd2_5526)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_arg4606z00_5530;
																																																					obj_t
																																																						BgL_arg4607z00_5531;
																																																					obj_t
																																																						BgL_arg4608z00_5532;
																																																					BgL_arg4606z00_5530
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5527));
																																																					BgL_arg4607z00_5531
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5527));
																																																					BgL_arg4608z00_5532
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27633;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27636;
																																																							obj_t
																																																								BgL_bodyz00_27635;
																																																							obj_t
																																																								BgL_varsz00_27634;
																																																							BgL_varsz00_27634
																																																								=
																																																								BgL_arg4606z00_5530;
																																																							BgL_bodyz00_27635
																																																								=
																																																								BgL_arg4607z00_5531;
																																																							BgL_argsz00_27636
																																																								=
																																																								BgL_arg4608z00_5532;
																																																							BgL_argsz00_1734
																																																								=
																																																								BgL_argsz00_27636;
																																																							BgL_bodyz00_1733
																																																								=
																																																								BgL_bodyz00_27635;
																																																							BgL_varsz00_1732
																																																								=
																																																								BgL_varsz00_27634;
																																																							goto
																																																								BgL_tagzd2386zd2_1735;
																																																						}
																																																						BgL_auxz00_27580
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27633);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd255534zd2_5534;
																																																					BgL_cdrzd255534zd2_5534
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd255540zd2_5535;
																																																						BgL_cdrzd255540zd2_5535
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd255506zd2_5526));
																																																						if ((CAR(((obj_t) BgL_carzd255506zd2_5526)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd255546zd2_5538;
																																																								BgL_cdrzd255546zd2_5538
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd255540zd2_5535));
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_carzd255551zd2_5539;
																																																									obj_t
																																																										BgL_cdrzd255552zd2_5540;
																																																									BgL_carzd255551zd2_5539
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5538));
																																																									BgL_cdrzd255552zd2_5540
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5538));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255551zd2_5539))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd255552zd2_5540))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd255559zd2_5543;
																																																													BgL_carzd255559zd2_5543
																																																														=
																																																														CAR
																																																														(BgL_cdrzd255552zd2_5540);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255559zd2_5543))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (NULLP(CDR(BgL_cdrzd255552zd2_5540)))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	bool_t
																																																																		BgL_testz00_27663;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1459z00_5576;
																																																																		BgL_l1459z00_5576
																																																																			=
																																																																			BgL_cdrzd255534zd2_5534;
																																																																	BgL_zc3anonymousza34631ze3z83_5577:
																																																																		if (NULLP(BgL_l1459z00_5576))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_testz00_27663
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				bool_t
																																																																					BgL_testz00_27666;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					bool_t
																																																																						BgL_testz00_27667;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_tmpz00_27668;
																																																																						BgL_tmpz00_27668
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1459z00_5576));
																																																																						BgL_testz00_27667
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_27668);
																																																																					}
																																																																					if (BgL_testz00_27667)
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_27666
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							BgL_testz00_27666
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_testz00_27666)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1459z00_27672;
																																																																						BgL_l1459z00_27672
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1459z00_5576));
																																																																						BgL_l1459z00_5576
																																																																							=
																																																																							BgL_l1459z00_27672;
																																																																						goto
																																																																							BgL_zc3anonymousza34631ze3z83_5577;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_testz00_27663
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_testz00_27663)
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_arg4621z00_5559;
																																																																			BgL_arg4621z00_5559
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd255540zd2_5535));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27677;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_27681;
																																																																					obj_t
																																																																						BgL_proc2z00_27680;
																																																																					obj_t
																																																																						BgL_proc1z00_27679;
																																																																					obj_t
																																																																						BgL_testz00_27678;
																																																																					BgL_testz00_27678
																																																																						=
																																																																						BgL_arg4621z00_5559;
																																																																					BgL_proc1z00_27679
																																																																						=
																																																																						BgL_carzd255551zd2_5539;
																																																																					BgL_proc2z00_27680
																																																																						=
																																																																						BgL_carzd255559zd2_5543;
																																																																					BgL_argsz00_27681
																																																																						=
																																																																						BgL_cdrzd255534zd2_5534;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_27681;
																																																																					BgL_proc2z00_1738
																																																																						=
																																																																						BgL_proc2z00_27680;
																																																																					BgL_proc1z00_1737
																																																																						=
																																																																						BgL_proc1z00_27679;
																																																																					BgL_testz00_1736
																																																																						=
																																																																						BgL_testz00_27678;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1740;
																																																																				}
																																																																				BgL_auxz00_27580
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27677);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd255583zd2_5560;
																																																																			BgL_cdrzd255583zd2_5560
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd255590zd2_5561;
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_pairz00_13119;
																																																																					BgL_pairz00_13119
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd255590zd2_5561
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_13119);
																																																																				}
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd255597zd2_5562;
																																																																					BgL_cdrzd255597zd2_5562
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd255590zd2_5561));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd255603zd2_5563;
																																																																						BgL_carzd255603zd2_5563
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd255597zd2_5562));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255603zd2_5563))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd255610zd2_5565;
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_pairz00_13123;
																																																																									BgL_pairz00_13123
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd255597zd2_5562));
																																																																									BgL_carzd255610zd2_5565
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_13123);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255610zd2_5565))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255583zd2_5560))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg4625z00_5568;
																																																																												BgL_arg4625z00_5568
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd255590zd2_5561));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27703;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_27707;
																																																																														obj_t
																																																																															BgL_proc2z00_27706;
																																																																														obj_t
																																																																															BgL_proc1z00_27705;
																																																																														obj_t
																																																																															BgL_testz00_27704;
																																																																														BgL_testz00_27704
																																																																															=
																																																																															BgL_arg4625z00_5568;
																																																																														BgL_proc1z00_27705
																																																																															=
																																																																															BgL_carzd255603zd2_5563;
																																																																														BgL_proc2z00_27706
																																																																															=
																																																																															BgL_carzd255610zd2_5565;
																																																																														BgL_argsz00_27707
																																																																															=
																																																																															BgL_cdrzd255583zd2_5560;
																																																																														BgL_argsz00_1744
																																																																															=
																																																																															BgL_argsz00_27707;
																																																																														BgL_proc2z00_1743
																																																																															=
																																																																															BgL_proc2z00_27706;
																																																																														BgL_proc1z00_1742
																																																																															=
																																																																															BgL_proc1z00_27705;
																																																																														BgL_testz00_1741
																																																																															=
																																																																															BgL_testz00_27704;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1745;
																																																																													}
																																																																													BgL_auxz00_27580
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27703);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27711;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																														BgL_auxz00_27580
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27711);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27715;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_27580
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27715);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27719;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_27580
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27719);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1769;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27723;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1770;
																																																																			BgL_auxz00_27580
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27723);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd255886zd2_5587;
																																																															BgL_cdrzd255886zd2_5587
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd255892zd2_5588;
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_pairz00_13127;
																																																																	BgL_pairz00_13127
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd255892zd2_5588
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_13127);
																																																																}
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd255898zd2_5589;
																																																																	BgL_cdrzd255898zd2_5589
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd255892zd2_5588));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd255903zd2_5590;
																																																																		obj_t
																																																																			BgL_cdrzd255904zd2_5591;
																																																																		BgL_carzd255903zd2_5590
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5589));
																																																																		BgL_cdrzd255904zd2_5591
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5589));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255903zd2_5590))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd255909zd2_5593;
																																																																				BgL_carzd255909zd2_5593
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd255904zd2_5591));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255909zd2_5593))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd255904zd2_5591))))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255886zd2_5587))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4640z00_5598;
																																																																										BgL_arg4640z00_5598
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd255892zd2_5588));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27750;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27754;
																																																																												obj_t
																																																																													BgL_proc2z00_27753;
																																																																												obj_t
																																																																													BgL_proc1z00_27752;
																																																																												obj_t
																																																																													BgL_testz00_27751;
																																																																												BgL_testz00_27751
																																																																													=
																																																																													BgL_arg4640z00_5598;
																																																																												BgL_proc1z00_27752
																																																																													=
																																																																													BgL_carzd255903zd2_5590;
																																																																												BgL_proc2z00_27753
																																																																													=
																																																																													BgL_carzd255909zd2_5593;
																																																																												BgL_argsz00_27754
																																																																													=
																																																																													BgL_cdrzd255886zd2_5587;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_27754;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_27753;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_27752;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_27751;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1745;
																																																																											}
																																																																											BgL_auxz00_27580
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27750);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27758;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_27580
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27758);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27762;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_27580
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27762);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27766;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_27580
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27766);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27770;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_27580
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27770);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27774;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_27580
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27774);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd256242zd2_5606;
																																																											BgL_cdrzd256242zd2_5606
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd256249zd2_5607;
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_pairz00_13137;
																																																													BgL_pairz00_13137
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd256249zd2_5607
																																																														=
																																																														CDR
																																																														(BgL_pairz00_13137);
																																																												}
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd256256zd2_5608;
																																																													BgL_cdrzd256256zd2_5608
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd256249zd2_5607));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd256262zd2_5609;
																																																														obj_t
																																																															BgL_cdrzd256263zd2_5610;
																																																														BgL_carzd256262zd2_5609
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5608));
																																																														BgL_cdrzd256263zd2_5610
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5608));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256262zd2_5609))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd256263zd2_5610))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd256270zd2_5613;
																																																																		BgL_carzd256270zd2_5613
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd256263zd2_5610);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256270zd2_5613))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd256263zd2_5610)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256242zd2_5606))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4654z00_5618;
																																																																								BgL_arg4654z00_5618
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd256249zd2_5607));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27801;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27805;
																																																																										obj_t
																																																																											BgL_proc2z00_27804;
																																																																										obj_t
																																																																											BgL_proc1z00_27803;
																																																																										obj_t
																																																																											BgL_testz00_27802;
																																																																										BgL_testz00_27802
																																																																											=
																																																																											BgL_arg4654z00_5618;
																																																																										BgL_proc1z00_27803
																																																																											=
																																																																											BgL_carzd256262zd2_5609;
																																																																										BgL_proc2z00_27804
																																																																											=
																																																																											BgL_carzd256270zd2_5613;
																																																																										BgL_argsz00_27805
																																																																											=
																																																																											BgL_cdrzd256242zd2_5606;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_27805;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_27804;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_27803;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_27802;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1745;
																																																																									}
																																																																									BgL_auxz00_27580
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27801);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27809;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_27580
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27809);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27813;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_27580
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27813);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27817;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_27580
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27817);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27821;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_27580
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27821);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27825;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_27580
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27825);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 118 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 118 */
																																																										goto
																																																											BgL_tagzd2403zd2_1769;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27829;
																																																										goto
																																																											BgL_tagzd2404zd2_1770;
																																																										BgL_auxz00_27580
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27829);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_27831;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4597z00_5519;
																																															BgL_arg4597z00_5519
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_27831
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4597z00_5519));
																																														}
																																														if (BgL_testz00_27831)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27836;
																																																goto
																																																	BgL_tagzd2384zd2_1727;
																																																BgL_auxz00_27580
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27836);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd256702zd2_5416;
																																																BgL_carzd256702zd2_5416
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd256707zd2_5417;
																																																	BgL_cdrzd256707zd2_5417
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd256702zd2_5416));
																																																	if ((CAR(((obj_t) BgL_carzd256702zd2_5416)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4538z00_5420;
																																																			obj_t
																																																				BgL_arg4539z00_5421;
																																																			obj_t
																																																				BgL_arg4540z00_5422;
																																																			BgL_arg4538z00_5420
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5417));
																																																			BgL_arg4539z00_5421
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5417));
																																																			BgL_arg4540z00_5422
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_27853;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_27856;
																																																					obj_t
																																																						BgL_bodyz00_27855;
																																																					obj_t
																																																						BgL_varsz00_27854;
																																																					BgL_varsz00_27854
																																																						=
																																																						BgL_arg4538z00_5420;
																																																					BgL_bodyz00_27855
																																																						=
																																																						BgL_arg4539z00_5421;
																																																					BgL_argsz00_27856
																																																						=
																																																						BgL_arg4540z00_5422;
																																																					BgL_argsz00_1734
																																																						=
																																																						BgL_argsz00_27856;
																																																					BgL_bodyz00_1733
																																																						=
																																																						BgL_bodyz00_27855;
																																																					BgL_varsz00_1732
																																																						=
																																																						BgL_varsz00_27854;
																																																					goto
																																																						BgL_tagzd2386zd2_1735;
																																																				}
																																																				BgL_auxz00_27580
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27853);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd256730zd2_5424;
																																																			BgL_cdrzd256730zd2_5424
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_cdrzd256736zd2_5425;
																																																				BgL_cdrzd256736zd2_5425
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd256702zd2_5416));
																																																				if ((CAR(((obj_t) BgL_carzd256702zd2_5416)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 118 */
																																																						obj_t
																																																							BgL_cdrzd256742zd2_5428;
																																																						BgL_cdrzd256742zd2_5428
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd256736zd2_5425));
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd256747zd2_5429;
																																																							obj_t
																																																								BgL_cdrzd256748zd2_5430;
																																																							BgL_carzd256747zd2_5429
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5428));
																																																							BgL_cdrzd256748zd2_5430
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5428));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256747zd2_5429))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd256748zd2_5430))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd256755zd2_5433;
																																																											BgL_carzd256755zd2_5433
																																																												=
																																																												CAR
																																																												(BgL_cdrzd256748zd2_5430);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256755zd2_5433))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(BgL_cdrzd256748zd2_5430)))
																																																														{	/* Ast/sexp.scm 118 */
																																																															bool_t
																																																																BgL_testz00_27883;
																																																															{
																																																																obj_t
																																																																	BgL_l1462z00_5466;
																																																																BgL_l1462z00_5466
																																																																	=
																																																																	BgL_cdrzd256730zd2_5424;
																																																															BgL_zc3anonymousza34563ze3z83_5467:
																																																																if (NULLP(BgL_l1462z00_5466))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		BgL_testz00_27883
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		bool_t
																																																																			BgL_testz00_27886;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_testz00_27887;
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_tmpz00_27888;
																																																																				BgL_tmpz00_27888
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1462z00_5466));
																																																																				BgL_testz00_27887
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_27888);
																																																																			}
																																																																			if (BgL_testz00_27887)
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_testz00_27886
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					BgL_testz00_27886
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_testz00_27886)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1462z00_27892;
																																																																				BgL_l1462z00_27892
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1462z00_5466));
																																																																				BgL_l1462z00_5466
																																																																					=
																																																																					BgL_l1462z00_27892;
																																																																				goto
																																																																					BgL_zc3anonymousza34563ze3z83_5467;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				BgL_testz00_27883
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_testz00_27883)
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_arg4553z00_5449;
																																																																	BgL_arg4553z00_5449
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd256736zd2_5425));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27897;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_27901;
																																																																			obj_t
																																																																				BgL_proc2z00_27900;
																																																																			obj_t
																																																																				BgL_proc1z00_27899;
																																																																			obj_t
																																																																				BgL_testz00_27898;
																																																																			BgL_testz00_27898
																																																																				=
																																																																				BgL_arg4553z00_5449;
																																																																			BgL_proc1z00_27899
																																																																				=
																																																																				BgL_carzd256747zd2_5429;
																																																																			BgL_proc2z00_27900
																																																																				=
																																																																				BgL_carzd256755zd2_5433;
																																																																			BgL_argsz00_27901
																																																																				=
																																																																				BgL_cdrzd256730zd2_5424;
																																																																			BgL_argsz00_1739
																																																																				=
																																																																				BgL_argsz00_27901;
																																																																			BgL_proc2z00_1738
																																																																				=
																																																																				BgL_proc2z00_27900;
																																																																			BgL_proc1z00_1737
																																																																				=
																																																																				BgL_proc1z00_27899;
																																																																			BgL_testz00_1736
																																																																				=
																																																																				BgL_testz00_27898;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1740;
																																																																		}
																																																																		BgL_auxz00_27580
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27897);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd256779zd2_5450;
																																																																	BgL_cdrzd256779zd2_5450
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd256786zd2_5451;
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_pairz00_13172;
																																																																			BgL_pairz00_13172
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd256786zd2_5451
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_13172);
																																																																		}
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd256793zd2_5452;
																																																																			BgL_cdrzd256793zd2_5452
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd256786zd2_5451));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd256799zd2_5453;
																																																																				BgL_carzd256799zd2_5453
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd256793zd2_5452));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256799zd2_5453))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd256806zd2_5455;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_pairz00_13176;
																																																																							BgL_pairz00_13176
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd256793zd2_5452));
																																																																							BgL_carzd256806zd2_5455
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_13176);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256806zd2_5455))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256779zd2_5450))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4557z00_5458;
																																																																										BgL_arg4557z00_5458
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd256786zd2_5451));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27923;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27927;
																																																																												obj_t
																																																																													BgL_proc2z00_27926;
																																																																												obj_t
																																																																													BgL_proc1z00_27925;
																																																																												obj_t
																																																																													BgL_testz00_27924;
																																																																												BgL_testz00_27924
																																																																													=
																																																																													BgL_arg4557z00_5458;
																																																																												BgL_proc1z00_27925
																																																																													=
																																																																													BgL_carzd256799zd2_5453;
																																																																												BgL_proc2z00_27926
																																																																													=
																																																																													BgL_carzd256806zd2_5455;
																																																																												BgL_argsz00_27927
																																																																													=
																																																																													BgL_cdrzd256779zd2_5450;
																																																																												BgL_argsz00_1744
																																																																													=
																																																																													BgL_argsz00_27927;
																																																																												BgL_proc2z00_1743
																																																																													=
																																																																													BgL_proc2z00_27926;
																																																																												BgL_proc1z00_1742
																																																																													=
																																																																													BgL_proc1z00_27925;
																																																																												BgL_testz00_1741
																																																																													=
																																																																													BgL_testz00_27924;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1745;
																																																																											}
																																																																											BgL_auxz00_27580
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27923);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27931;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																												BgL_auxz00_27580
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27931);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27935;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_27580
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27935);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27939;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_27580
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27939);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_27943;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_27580
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_27943);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd257082zd2_5477;
																																																													BgL_cdrzd257082zd2_5477
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd257088zd2_5478;
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_pairz00_13180;
																																																															BgL_pairz00_13180
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd257088zd2_5478
																																																																=
																																																																CDR
																																																																(BgL_pairz00_13180);
																																																														}
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd257094zd2_5479;
																																																															BgL_cdrzd257094zd2_5479
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd257088zd2_5478));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd257099zd2_5480;
																																																																obj_t
																																																																	BgL_cdrzd257100zd2_5481;
																																																																BgL_carzd257099zd2_5480
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5479));
																																																																BgL_cdrzd257100zd2_5481
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5479));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257099zd2_5480))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd257105zd2_5483;
																																																																		BgL_carzd257105zd2_5483
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd257100zd2_5481));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257105zd2_5483))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd257100zd2_5481))))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257082zd2_5477))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4572z00_5488;
																																																																								BgL_arg4572z00_5488
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd257088zd2_5478));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27970;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27974;
																																																																										obj_t
																																																																											BgL_proc2z00_27973;
																																																																										obj_t
																																																																											BgL_proc1z00_27972;
																																																																										obj_t
																																																																											BgL_testz00_27971;
																																																																										BgL_testz00_27971
																																																																											=
																																																																											BgL_arg4572z00_5488;
																																																																										BgL_proc1z00_27972
																																																																											=
																																																																											BgL_carzd257099zd2_5480;
																																																																										BgL_proc2z00_27973
																																																																											=
																																																																											BgL_carzd257105zd2_5483;
																																																																										BgL_argsz00_27974
																																																																											=
																																																																											BgL_cdrzd257082zd2_5477;
																																																																										BgL_argsz00_1744
																																																																											=
																																																																											BgL_argsz00_27974;
																																																																										BgL_proc2z00_1743
																																																																											=
																																																																											BgL_proc2z00_27973;
																																																																										BgL_proc1z00_1742
																																																																											=
																																																																											BgL_proc1z00_27972;
																																																																										BgL_testz00_1741
																																																																											=
																																																																											BgL_testz00_27971;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1745;
																																																																									}
																																																																									BgL_auxz00_27580
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27970);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27978;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																										BgL_auxz00_27580
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27978);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27982;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_27580
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27982);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27986;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_27580
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27986);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27990;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_27580
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27990);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27994;
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																													BgL_auxz00_27580
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27994);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd257438zd2_5496;
																																																									BgL_cdrzd257438zd2_5496
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_cdrzd257445zd2_5497;
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_pairz00_13190;
																																																											BgL_pairz00_13190
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd257445zd2_5497
																																																												=
																																																												CDR
																																																												(BgL_pairz00_13190);
																																																										}
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd257452zd2_5498;
																																																											BgL_cdrzd257452zd2_5498
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd257445zd2_5497));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_carzd257458zd2_5499;
																																																												obj_t
																																																													BgL_cdrzd257459zd2_5500;
																																																												BgL_carzd257458zd2_5499
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5498));
																																																												BgL_cdrzd257459zd2_5500
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5498));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257458zd2_5499))
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (PAIRP(BgL_cdrzd257459zd2_5500))
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd257466zd2_5503;
																																																																BgL_carzd257466zd2_5503
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd257459zd2_5500);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257466zd2_5503))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (NULLP(CDR(BgL_cdrzd257459zd2_5500)))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257438zd2_5496))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4586z00_5508;
																																																																						BgL_arg4586z00_5508
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd257445zd2_5497));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28021;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_28025;
																																																																								obj_t
																																																																									BgL_proc2z00_28024;
																																																																								obj_t
																																																																									BgL_proc1z00_28023;
																																																																								obj_t
																																																																									BgL_testz00_28022;
																																																																								BgL_testz00_28022
																																																																									=
																																																																									BgL_arg4586z00_5508;
																																																																								BgL_proc1z00_28023
																																																																									=
																																																																									BgL_carzd257458zd2_5499;
																																																																								BgL_proc2z00_28024
																																																																									=
																																																																									BgL_carzd257466zd2_5503;
																																																																								BgL_argsz00_28025
																																																																									=
																																																																									BgL_cdrzd257438zd2_5496;
																																																																								BgL_argsz00_1744
																																																																									=
																																																																									BgL_argsz00_28025;
																																																																								BgL_proc2z00_1743
																																																																									=
																																																																									BgL_proc2z00_28024;
																																																																								BgL_proc1z00_1742
																																																																									=
																																																																									BgL_proc1z00_28023;
																																																																								BgL_testz00_1741
																																																																									=
																																																																									BgL_testz00_28022;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1745;
																																																																							}
																																																																							BgL_auxz00_27580
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28021);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28029;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_27580
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28029);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28033;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																						BgL_auxz00_27580
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28033);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28037;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_27580
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28037);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1769;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_28041;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1770;
																																																																		BgL_auxz00_27580
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_28041);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28045;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_27580
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28045);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 118 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 118 */
																																																								goto
																																																									BgL_tagzd2403zd2_1769;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_28049;
																																																								goto
																																																									BgL_tagzd2404zd2_1770;
																																																								BgL_auxz00_27580
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_28049);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								obj_t
																																									BgL_cdrzd257858zd2_5631;
																																								BgL_cdrzd257858zd2_5631
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_testz00_28053;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4679z00_5647;
																																											BgL_arg4679z00_5647
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_testz00_28053
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg4679z00_5647));
																																										}
																																										if (BgL_testz00_28053)
																																											{	/* Ast/sexp.scm 118 */
																																												if (PAIRP(BgL_cdrzd257858zd2_5631))
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_arg4681z00_5649;
																																														obj_t
																																															BgL_arg4682z00_5650;
																																														BgL_arg4681z00_5649
																																															=
																																															CAR
																																															(BgL_cdrzd257858zd2_5631);
																																														BgL_arg4682z00_5650
																																															=
																																															CDR
																																															(BgL_cdrzd257858zd2_5631);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28062;
																																															{
																																																obj_t
																																																	BgL_exprz00_28064;
																																																obj_t
																																																	BgL_bindingsz00_28063;
																																																BgL_bindingsz00_28063
																																																	=
																																																	BgL_arg4681z00_5649;
																																																BgL_exprz00_28064
																																																	=
																																																	BgL_arg4682z00_5650;
																																																BgL_exprz00_1724
																																																	=
																																																	BgL_exprz00_28064;
																																																BgL_bindingsz00_1723
																																																	=
																																																	BgL_bindingsz00_28063;
																																																goto
																																																	BgL_tagzd2382zd2_1725;
																																															}
																																															BgL_auxz00_27580
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28062);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_28066;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4692z00_5662;
																																															BgL_arg4692z00_5662
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_testz00_28066
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4692z00_5662));
																																														}
																																														if (BgL_testz00_28066)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_28071;
																																																goto
																																																	BgL_tagzd2384zd2_1727;
																																																BgL_auxz00_27580
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28071);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																obj_t
																																																	BgL_carzd257921zd2_5653;
																																																BgL_carzd257921zd2_5653
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd257926zd2_5654;
																																																	BgL_cdrzd257926zd2_5654
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd257921zd2_5653));
																																																	if ((CAR(((obj_t) BgL_carzd257921zd2_5653)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4687z00_5657;
																																																			obj_t
																																																				BgL_arg4688z00_5658;
																																																			obj_t
																																																				BgL_arg4689z00_5659;
																																																			BgL_arg4687z00_5657
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5654));
																																																			BgL_arg4688z00_5658
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5654));
																																																			BgL_arg4689z00_5659
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_28088;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_28091;
																																																					obj_t
																																																						BgL_bodyz00_28090;
																																																					obj_t
																																																						BgL_varsz00_28089;
																																																					BgL_varsz00_28089
																																																						=
																																																						BgL_arg4687z00_5657;
																																																					BgL_bodyz00_28090
																																																						=
																																																						BgL_arg4688z00_5658;
																																																					BgL_argsz00_28091
																																																						=
																																																						BgL_arg4689z00_5659;
																																																					BgL_argsz00_1734
																																																						=
																																																						BgL_argsz00_28091;
																																																					BgL_bodyz00_1733
																																																						=
																																																						BgL_bodyz00_28090;
																																																					BgL_varsz00_1732
																																																						=
																																																						BgL_varsz00_28089;
																																																					goto
																																																						BgL_tagzd2386zd2_1735;
																																																				}
																																																				BgL_auxz00_27580
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28088);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2403zd2_1769;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28095;
																																																					goto
																																																						BgL_tagzd2404zd2_1770;
																																																					BgL_auxz00_27580
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28095);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_28097;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4678z00_5646;
																																													BgL_arg4678z00_5646
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_28097
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4678z00_5646));
																																												}
																																												if (BgL_testz00_28097)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28102;
																																														goto
																																															BgL_tagzd2384zd2_1727;
																																														BgL_auxz00_27580
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28102);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														obj_t
																																															BgL_carzd258075zd2_5637;
																																														BgL_carzd258075zd2_5637
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_cdrzd258080zd2_5638;
																																															BgL_cdrzd258080zd2_5638
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd258075zd2_5637));
																																															if ((CAR(((obj_t) BgL_carzd258075zd2_5637)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4673z00_5641;
																																																	obj_t
																																																		BgL_arg4674z00_5642;
																																																	obj_t
																																																		BgL_arg4675z00_5643;
																																																	BgL_arg4673z00_5641
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5638));
																																																	BgL_arg4674z00_5642
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5638));
																																																	BgL_arg4675z00_5643
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_28119;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_28122;
																																																			obj_t
																																																				BgL_bodyz00_28121;
																																																			obj_t
																																																				BgL_varsz00_28120;
																																																			BgL_varsz00_28120
																																																				=
																																																				BgL_arg4673z00_5641;
																																																			BgL_bodyz00_28121
																																																				=
																																																				BgL_arg4674z00_5642;
																																																			BgL_argsz00_28122
																																																				=
																																																				BgL_arg4675z00_5643;
																																																			BgL_argsz00_1734
																																																				=
																																																				BgL_argsz00_28122;
																																																			BgL_bodyz00_1733
																																																				=
																																																				BgL_bodyz00_28121;
																																																			BgL_varsz00_1732
																																																				=
																																																				BgL_varsz00_28120;
																																																			goto
																																																				BgL_tagzd2386zd2_1735;
																																																		}
																																																		BgL_auxz00_27580
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_28119);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 118 */
																																																			goto
																																																				BgL_tagzd2403zd2_1769;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28126;
																																																			goto
																																																				BgL_tagzd2404zd2_1770;
																																																			BgL_auxz00_27580
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28126);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						obj_t
																																							BgL_cdrzd258190zd2_5663;
																																						BgL_cdrzd258190zd2_5663
																																							=
																																							CDR
																																							(((obj_t) BgL_expz00_21));
																																						{

																																							{	/* Ast/sexp.scm 118 */
																																								bool_t
																																									BgL_testz00_28130;
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_arg4699z00_5671;
																																									BgL_arg4699z00_5671
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_testz00_28130
																																										=
																																										CBOOL
																																										(BGl_letzd2symzf3z21zzast_letz00
																																										(BgL_arg4699z00_5671));
																																								}
																																								if (BgL_testz00_28130)
																																									{	/* Ast/sexp.scm 118 */
																																										if (PAIRP(BgL_cdrzd258190zd2_5663))
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_arg4701z00_5673;
																																												obj_t
																																													BgL_arg4702z00_5674;
																																												BgL_arg4701z00_5673
																																													=
																																													CAR
																																													(BgL_cdrzd258190zd2_5663);
																																												BgL_arg4702z00_5674
																																													=
																																													CDR
																																													(BgL_cdrzd258190zd2_5663);
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28139;
																																													{
																																														obj_t
																																															BgL_exprz00_28141;
																																														obj_t
																																															BgL_bindingsz00_28140;
																																														BgL_bindingsz00_28140
																																															=
																																															BgL_arg4701z00_5673;
																																														BgL_exprz00_28141
																																															=
																																															BgL_arg4702z00_5674;
																																														BgL_exprz00_1724
																																															=
																																															BgL_exprz00_28141;
																																														BgL_bindingsz00_1723
																																															=
																																															BgL_bindingsz00_28140;
																																														goto
																																															BgL_tagzd2382zd2_1725;
																																													}
																																													BgL_auxz00_27580
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28139);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												bool_t
																																													BgL_testz00_28143;
																																												{	/* Ast/sexp.scm 118 */
																																													obj_t
																																														BgL_arg4706z00_5678;
																																													BgL_arg4706z00_5678
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_testz00_28143
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4706z00_5678));
																																												}
																																												if (BgL_testz00_28143)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28148;
																																														goto
																																															BgL_tagzd2384zd2_1727;
																																														BgL_auxz00_27580
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28148);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 118 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 118 */
																																																goto
																																																	BgL_tagzd2403zd2_1769;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_28152;
																																																goto
																																																	BgL_tagzd2404zd2_1770;
																																																BgL_auxz00_27580
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28152);
																																															}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										bool_t
																																											BgL_testz00_28154;
																																										{	/* Ast/sexp.scm 118 */
																																											obj_t
																																												BgL_arg4698z00_5670;
																																											BgL_arg4698z00_5670
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_testz00_28154
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4698z00_5670));
																																										}
																																										if (BgL_testz00_28154)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_28159;
																																												goto
																																													BgL_tagzd2384zd2_1727;
																																												BgL_auxz00_27580
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_28159);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 118 */
																																														goto
																																															BgL_tagzd2403zd2_1769;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_28163;
																																														goto
																																															BgL_tagzd2404zd2_1770;
																																														BgL_auxz00_27580
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28163);
																																													}
																																											}
																																									}
																																							}
																																						}
																																					}
																																				return
																																					(
																																					(BgL_nodez00_bglt)
																																					BgL_auxz00_27580);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 118 */
																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd255414zd2_5100)))
																																					{
																																						obj_t
																																							BgL_auxz00_28169;
																																						goto
																																							BgL_kapzd255416zd2_5102;
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_28169);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 118 */
																																						if (
																																							(BgL_carzd255414zd2_5100
																																								==
																																								CNST_TABLE_REF
																																								(((long) 18))))
																																							{
																																								obj_t
																																									BgL_auxz00_28174;
																																								goto
																																									BgL_kapzd255416zd2_5102;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_28174);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 118 */
																																								if ((BgL_carzd255414zd2_5100 == CNST_TABLE_REF(((long) 19))))
																																									{
																																										obj_t
																																											BgL_auxz00_28179;
																																										goto
																																											BgL_kapzd255416zd2_5102;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_28179);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 118 */
																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255414zd2_5100)))
																																											{
																																												obj_t
																																													BgL_auxz00_28184;
																																												goto
																																													BgL_kapzd255416zd2_5102;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_28184);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 118 */
																																												obj_t
																																													BgL_cdrzd258499zd2_5108;
																																												BgL_cdrzd258499zd2_5108
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												{

																																													{	/* Ast/sexp.scm 118 */
																																														bool_t
																																															BgL_testz00_28187;
																																														{	/* Ast/sexp.scm 118 */
																																															obj_t
																																																BgL_arg4452z00_5287;
																																															BgL_arg4452z00_5287
																																																=
																																																CAR
																																																(BgL_expz00_21);
																																															BgL_testz00_28187
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg4452z00_5287));
																																														}
																																														if (BgL_testz00_28187)
																																															{
																																																obj_t
																																																	BgL_auxz00_28191;
																																																if (PAIRP(BgL_cdrzd258499zd2_5108))
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_arg4454z00_5289;
																																																		obj_t
																																																			BgL_arg4455z00_5290;
																																																		BgL_arg4454z00_5289
																																																			=
																																																			CAR
																																																			(BgL_cdrzd258499zd2_5108);
																																																		BgL_arg4455z00_5290
																																																			=
																																																			CDR
																																																			(BgL_cdrzd258499zd2_5108);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28196;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_28198;
																																																				obj_t
																																																					BgL_bindingsz00_28197;
																																																				BgL_bindingsz00_28197
																																																					=
																																																					BgL_arg4454z00_5289;
																																																				BgL_exprz00_28198
																																																					=
																																																					BgL_arg4455z00_5290;
																																																				BgL_exprz00_1724
																																																					=
																																																					BgL_exprz00_28198;
																																																				BgL_bindingsz00_1723
																																																					=
																																																					BgL_bindingsz00_28197;
																																																				goto
																																																					BgL_tagzd2382zd2_1725;
																																																			}
																																																			BgL_auxz00_28191
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28196);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		bool_t
																																																			BgL_testz00_28200;
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_arg4525z00_5402;
																																																			BgL_arg4525z00_5402
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_testz00_28200
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg4525z00_5402));
																																																		}
																																																		if (BgL_testz00_28200)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_28205;
																																																				goto
																																																					BgL_tagzd2384zd2_1727;
																																																				BgL_auxz00_28191
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28205);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 118 */
																																																				obj_t
																																																					BgL_carzd258562zd2_5293;
																																																				BgL_carzd258562zd2_5293
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd258567zd2_5294;
																																																					BgL_cdrzd258567zd2_5294
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd258562zd2_5293));
																																																					if ((CAR(((obj_t) BgL_carzd258562zd2_5293)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd258567zd2_5294))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_arg4461z00_5298;
																																																									obj_t
																																																										BgL_arg4462z00_5299;
																																																									obj_t
																																																										BgL_arg4463z00_5300;
																																																									BgL_arg4461z00_5298
																																																										=
																																																										CAR
																																																										(BgL_cdrzd258567zd2_5294);
																																																									BgL_arg4462z00_5299
																																																										=
																																																										CDR
																																																										(BgL_cdrzd258567zd2_5294);
																																																									BgL_arg4463z00_5300
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_28222;
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28225;
																																																											obj_t
																																																												BgL_bodyz00_28224;
																																																											obj_t
																																																												BgL_varsz00_28223;
																																																											BgL_varsz00_28223
																																																												=
																																																												BgL_arg4461z00_5298;
																																																											BgL_bodyz00_28224
																																																												=
																																																												BgL_arg4462z00_5299;
																																																											BgL_argsz00_28225
																																																												=
																																																												BgL_arg4463z00_5300;
																																																											BgL_argsz00_1734
																																																												=
																																																												BgL_argsz00_28225;
																																																											BgL_bodyz00_1733
																																																												=
																																																												BgL_bodyz00_28224;
																																																											BgL_varsz00_1732
																																																												=
																																																												BgL_varsz00_28223;
																																																											goto
																																																												BgL_tagzd2386zd2_1735;
																																																										}
																																																										BgL_auxz00_28191
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_28222);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_28229;
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																											BgL_auxz00_28191
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28229);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_cdrzd258674zd2_5303;
																																																							BgL_cdrzd258674zd2_5303
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 118 */
																																																								obj_t
																																																									BgL_cdrzd258679zd2_5304;
																																																								BgL_cdrzd258679zd2_5304
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd258562zd2_5293));
																																																								if ((CAR(((obj_t) BgL_carzd258562zd2_5293)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (PAIRP(BgL_cdrzd258679zd2_5304))
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_cdrzd258684zd2_5308;
																																																												BgL_cdrzd258684zd2_5308
																																																													=
																																																													CDR
																																																													(BgL_cdrzd258679zd2_5304);
																																																												if (PAIRP(BgL_cdrzd258684zd2_5308))
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_carzd258688zd2_5310;
																																																														obj_t
																																																															BgL_cdrzd258689zd2_5311;
																																																														BgL_carzd258688zd2_5310
																																																															=
																																																															CAR
																																																															(BgL_cdrzd258684zd2_5308);
																																																														BgL_cdrzd258689zd2_5311
																																																															=
																																																															CDR
																																																															(BgL_cdrzd258684zd2_5308);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258688zd2_5310))
																																																															{	/* Ast/sexp.scm 118 */
																																																																if (PAIRP(BgL_cdrzd258689zd2_5311))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_carzd258694zd2_5314;
																																																																		BgL_carzd258694zd2_5314
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd258689zd2_5311);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258694zd2_5314))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (NULLP(CDR(BgL_cdrzd258689zd2_5311)))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_28257;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1465z00_5347;
																																																																							BgL_l1465z00_5347
																																																																								=
																																																																								BgL_cdrzd258674zd2_5303;
																																																																						BgL_zc3anonymousza34489ze3z83_5348:
																																																																							if (NULLP(BgL_l1465z00_5347))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_28257
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									bool_t
																																																																										BgL_testz00_28260;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										bool_t
																																																																											BgL_testz00_28261;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_tmpz00_28262;
																																																																											BgL_tmpz00_28262
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1465z00_5347));
																																																																											BgL_testz00_28261
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_28262);
																																																																										}
																																																																										if (BgL_testz00_28261)
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_28260
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												BgL_testz00_28260
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_testz00_28260)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1465z00_28266;
																																																																											BgL_l1465z00_28266
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1465z00_5347));
																																																																											BgL_l1465z00_5347
																																																																												=
																																																																												BgL_l1465z00_28266;
																																																																											goto
																																																																												BgL_zc3anonymousza34489ze3z83_5348;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											BgL_testz00_28257
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_testz00_28257)
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4479z00_5330;
																																																																								BgL_arg4479z00_5330
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd258679zd2_5304);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28270;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28274;
																																																																										obj_t
																																																																											BgL_proc2z00_28273;
																																																																										obj_t
																																																																											BgL_proc1z00_28272;
																																																																										obj_t
																																																																											BgL_testz00_28271;
																																																																										BgL_testz00_28271
																																																																											=
																																																																											BgL_arg4479z00_5330;
																																																																										BgL_proc1z00_28272
																																																																											=
																																																																											BgL_carzd258688zd2_5310;
																																																																										BgL_proc2z00_28273
																																																																											=
																																																																											BgL_carzd258694zd2_5314;
																																																																										BgL_argsz00_28274
																																																																											=
																																																																											BgL_cdrzd258674zd2_5303;
																																																																										BgL_argsz00_1739
																																																																											=
																																																																											BgL_argsz00_28274;
																																																																										BgL_proc2z00_1738
																																																																											=
																																																																											BgL_proc2z00_28273;
																																																																										BgL_proc1z00_1737
																																																																											=
																																																																											BgL_proc1z00_28272;
																																																																										BgL_testz00_1736
																																																																											=
																																																																											BgL_testz00_28271;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1740;
																																																																									}
																																																																									BgL_auxz00_28191
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28270);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_cdrzd258719zd2_5331;
																																																																								BgL_cdrzd258719zd2_5331
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd258727zd2_5332;
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_pairz00_13257;
																																																																										BgL_pairz00_13257
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd258727zd2_5332
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_13257);
																																																																									}
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_cdrzd258735zd2_5333;
																																																																										BgL_cdrzd258735zd2_5333
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd258727zd2_5332));
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_carzd258742zd2_5334;
																																																																											BgL_carzd258742zd2_5334
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd258735zd2_5333));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258742zd2_5334))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_carzd258751zd2_5336;
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_pairz00_13261;
																																																																														BgL_pairz00_13261
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd258735zd2_5333));
																																																																														BgL_carzd258751zd2_5336
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_13261);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258751zd2_5336))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd258719zd2_5331))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	obj_t
																																																																																		BgL_arg4483z00_5339;
																																																																																	BgL_arg4483z00_5339
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd258727zd2_5332));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_28296;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_28300;
																																																																																			obj_t
																																																																																				BgL_proc2z00_28299;
																																																																																			obj_t
																																																																																				BgL_proc1z00_28298;
																																																																																			obj_t
																																																																																				BgL_testz00_28297;
																																																																																			BgL_testz00_28297
																																																																																				=
																																																																																				BgL_arg4483z00_5339;
																																																																																			BgL_proc1z00_28298
																																																																																				=
																																																																																				BgL_carzd258742zd2_5334;
																																																																																			BgL_proc2z00_28299
																																																																																				=
																																																																																				BgL_carzd258751zd2_5336;
																																																																																			BgL_argsz00_28300
																																																																																				=
																																																																																				BgL_cdrzd258719zd2_5331;
																																																																																			BgL_argsz00_1744
																																																																																				=
																																																																																				BgL_argsz00_28300;
																																																																																			BgL_proc2z00_1743
																																																																																				=
																																																																																				BgL_proc2z00_28299;
																																																																																			BgL_proc1z00_1742
																																																																																				=
																																																																																				BgL_proc1z00_28298;
																																																																																			BgL_testz00_1741
																																																																																				=
																																																																																				BgL_testz00_28297;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1745;
																																																																																		}
																																																																																		BgL_auxz00_28191
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_28296);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 118 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1769;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_28304;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1770;
																																																																																			BgL_auxz00_28191
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_28304);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28308;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_28191
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28308);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28312;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_28191
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28312);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28316;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																								BgL_auxz00_28191
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28316);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_cdrzd259029zd2_5358;
																																																																				BgL_cdrzd259029zd2_5358
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd259036zd2_5359;
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_pairz00_13265;
																																																																						BgL_pairz00_13265
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd259036zd2_5359
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13265);
																																																																					}
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd259043zd2_5360;
																																																																						BgL_cdrzd259043zd2_5360
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd259036zd2_5359));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd259049zd2_5361;
																																																																							obj_t
																																																																								BgL_cdrzd259050zd2_5362;
																																																																							BgL_carzd259049zd2_5361
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5360));
																																																																							BgL_cdrzd259050zd2_5362
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5360));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259049zd2_5361))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_carzd259057zd2_5364;
																																																																									BgL_carzd259057zd2_5364
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd259050zd2_5362));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259057zd2_5364))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd259050zd2_5362))))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259029zd2_5358))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															obj_t
																																																																																BgL_arg4498z00_5369;
																																																																															BgL_arg4498z00_5369
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd259036zd2_5359));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_28343;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_28347;
																																																																																	obj_t
																																																																																		BgL_proc2z00_28346;
																																																																																	obj_t
																																																																																		BgL_proc1z00_28345;
																																																																																	obj_t
																																																																																		BgL_testz00_28344;
																																																																																	BgL_testz00_28344
																																																																																		=
																																																																																		BgL_arg4498z00_5369;
																																																																																	BgL_proc1z00_28345
																																																																																		=
																																																																																		BgL_carzd259049zd2_5361;
																																																																																	BgL_proc2z00_28346
																																																																																		=
																																																																																		BgL_carzd259057zd2_5364;
																																																																																	BgL_argsz00_28347
																																																																																		=
																																																																																		BgL_cdrzd259029zd2_5358;
																																																																																	BgL_argsz00_1744
																																																																																		=
																																																																																		BgL_argsz00_28347;
																																																																																	BgL_proc2z00_1743
																																																																																		=
																																																																																		BgL_proc2z00_28346;
																																																																																	BgL_proc1z00_1742
																																																																																		=
																																																																																		BgL_proc1z00_28345;
																																																																																	BgL_testz00_1741
																																																																																		=
																																																																																		BgL_testz00_28344;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1745;
																																																																																}
																																																																																BgL_auxz00_28191
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_28343);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 118 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1769;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28351;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1770;
																																																																																	BgL_auxz00_28191
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28351);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28355;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_28191
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28355);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28359;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_28191
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28359);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28363;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_28191
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28363);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28367;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																				BgL_auxz00_28191
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28367);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_cdrzd259390zd2_5377;
																																																																BgL_cdrzd259390zd2_5377
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd259396zd2_5378;
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_pairz00_13275;
																																																																		BgL_pairz00_13275
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd259396zd2_5378
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13275);
																																																																	}
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd259402zd2_5379;
																																																																		BgL_cdrzd259402zd2_5379
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd259396zd2_5378));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_carzd259407zd2_5380;
																																																																			obj_t
																																																																				BgL_cdrzd259408zd2_5381;
																																																																			BgL_carzd259407zd2_5380
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5379));
																																																																			BgL_cdrzd259408zd2_5381
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5379));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259407zd2_5380))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd259408zd2_5381))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_carzd259413zd2_5384;
																																																																							BgL_carzd259413zd2_5384
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd259408zd2_5381);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259413zd2_5384))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (NULLP(CDR(BgL_cdrzd259408zd2_5381)))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259390zd2_5377))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg4512z00_5389;
																																																																													BgL_arg4512z00_5389
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd259396zd2_5378));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_28394;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28398;
																																																																															obj_t
																																																																																BgL_proc2z00_28397;
																																																																															obj_t
																																																																																BgL_proc1z00_28396;
																																																																															obj_t
																																																																																BgL_testz00_28395;
																																																																															BgL_testz00_28395
																																																																																=
																																																																																BgL_arg4512z00_5389;
																																																																															BgL_proc1z00_28396
																																																																																=
																																																																																BgL_carzd259407zd2_5380;
																																																																															BgL_proc2z00_28397
																																																																																=
																																																																																BgL_carzd259413zd2_5384;
																																																																															BgL_argsz00_28398
																																																																																=
																																																																																BgL_cdrzd259390zd2_5377;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_28398;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_28397;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_28396;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_28395;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																														BgL_auxz00_28191
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_28394);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 118 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1769;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28402;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1770;
																																																																															BgL_auxz00_28191
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28402);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1769;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28406;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1770;
																																																																													BgL_auxz00_28191
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28406);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28410;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																											BgL_auxz00_28191
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28410);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28414;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																									BgL_auxz00_28191
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28414);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28418;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																							BgL_auxz00_28191
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28418);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 118 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 118 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1769;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28422;
																																																																goto
																																																																	BgL_tagzd2404zd2_1770;
																																																																BgL_auxz00_28191
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28422);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 118 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 118 */
																																																														goto
																																																															BgL_tagzd2403zd2_1769;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_28426;
																																																														goto
																																																															BgL_tagzd2404zd2_1770;
																																																														BgL_auxz00_28191
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_28426);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 118 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 118 */
																																																												goto
																																																													BgL_tagzd2403zd2_1769;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_28430;
																																																												goto
																																																													BgL_tagzd2404zd2_1770;
																																																												BgL_auxz00_28191
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_28430);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																																return
																																																	(
																																																	(BgL_nodez00_bglt)
																																																	BgL_auxz00_28191);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 118 */
																																																bool_t
																																																	BgL_testz00_28433;
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_arg4451z00_5286;
																																																	BgL_arg4451z00_5286
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_testz00_28433
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4451z00_5286));
																																																}
																																																if (BgL_testz00_28433)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_28437;
																																																		goto
																																																			BgL_tagzd2384zd2_1727;
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_28437);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 118 */
																																																		obj_t
																																																			BgL_carzd259976zd2_5114;
																																																		obj_t
																																																			BgL_cdrzd259977zd2_5115;
																																																		BgL_carzd259976zd2_5114
																																																			=
																																																			CAR
																																																			(BgL_expz00_21);
																																																		BgL_cdrzd259977zd2_5115
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		{	/* Ast/sexp.scm 118 */
																																																			obj_t
																																																				BgL_cdrzd259981zd2_5116;
																																																			BgL_cdrzd259981zd2_5116
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd259976zd2_5114));
																																																			if ((CAR(((obj_t) BgL_carzd259976zd2_5114)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (PAIRP(BgL_cdrzd259981zd2_5116))
																																																						{	/* Ast/sexp.scm 118 */
																																																							obj_t
																																																								BgL_carzd259984zd2_5120;
																																																							obj_t
																																																								BgL_cdrzd259985zd2_5121;
																																																							BgL_carzd259984zd2_5120
																																																								=
																																																								CAR
																																																								(BgL_cdrzd259981zd2_5116);
																																																							BgL_cdrzd259985zd2_5121
																																																								=
																																																								CDR
																																																								(BgL_cdrzd259981zd2_5116);
																																																							if (PAIRP(BgL_carzd259984zd2_5120))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (NULLP(CDR(BgL_carzd259984zd2_5120)))
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (PAIRP(BgL_cdrzd259985zd2_5121))
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_carzd259991zd2_5126;
																																																													BgL_carzd259991zd2_5126
																																																														=
																																																														CAR
																																																														(BgL_cdrzd259985zd2_5121);
																																																													if (PAIRP(BgL_carzd259991zd2_5126))
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd259991zd2_5126))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (NULLP(CDR(BgL_cdrzd259985zd2_5121)))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd259977zd2_5115))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_carzd259998zd2_5132;
																																																																					BgL_carzd259998zd2_5132
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd259977zd2_5115);
																																																																					if (PAIRP(BgL_carzd259998zd2_5132))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd260022zd2_5134;
																																																																							BgL_cdrzd260022zd2_5134
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_arg4348z00_5135;
																																																																								obj_t
																																																																									BgL_arg4349z00_5136;
																																																																								obj_t
																																																																									BgL_arg4350z00_5137;
																																																																								BgL_arg4348z00_5135
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5134));
																																																																								BgL_arg4349z00_5136
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5134));
																																																																								BgL_arg4350z00_5137
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_28481;
																																																																									obj_t
																																																																										BgL_bodyz00_28480;
																																																																									obj_t
																																																																										BgL_varsz00_28479;
																																																																									BgL_varsz00_28479
																																																																										=
																																																																										BgL_arg4348z00_5135;
																																																																									BgL_bodyz00_28480
																																																																										=
																																																																										BgL_arg4349z00_5136;
																																																																									BgL_argsz00_28481
																																																																										=
																																																																										BgL_arg4350z00_5137;
																																																																									BgL_argsz00_1734
																																																																										=
																																																																										BgL_argsz00_28481;
																																																																									BgL_bodyz00_1733
																																																																										=
																																																																										BgL_bodyz00_28480;
																																																																									BgL_varsz00_1732
																																																																										=
																																																																										BgL_varsz00_28479;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1735;
																																																																								}
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd259977zd2_5115)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_arg4354z00_5141;
																																																																									BgL_arg4354z00_5141
																																																																										=
																																																																										CAR
																																																																										(BgL_carzd259984zd2_5120);
																																																																									{
																																																																										BgL_castz00_bglt
																																																																											BgL_auxz00_28486;
																																																																										{
																																																																											obj_t
																																																																												BgL_argz00_28489;
																																																																											obj_t
																																																																												BgL_bodyz00_28488;
																																																																											obj_t
																																																																												BgL_varz00_28487;
																																																																											BgL_varz00_28487
																																																																												=
																																																																												BgL_arg4354z00_5141;
																																																																											BgL_bodyz00_28488
																																																																												=
																																																																												BgL_carzd259991zd2_5126;
																																																																											BgL_argz00_28489
																																																																												=
																																																																												BgL_carzd259998zd2_5132;
																																																																											BgL_argz00_1730
																																																																												=
																																																																												BgL_argz00_28489;
																																																																											BgL_bodyz00_1729
																																																																												=
																																																																												BgL_bodyz00_28488;
																																																																											BgL_varz00_1728
																																																																												=
																																																																												BgL_varz00_28487;
																																																																											goto
																																																																												BgL_tagzd2385zd2_1731;
																																																																										}
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28486);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd260049zd2_5142;
																																																																									BgL_cdrzd260049zd2_5142
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4355z00_5143;
																																																																										obj_t
																																																																											BgL_arg4356z00_5144;
																																																																										obj_t
																																																																											BgL_arg4357z00_5145;
																																																																										BgL_arg4355z00_5143
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5142));
																																																																										BgL_arg4356z00_5144
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5142));
																																																																										BgL_arg4357z00_5145
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28500;
																																																																											obj_t
																																																																												BgL_bodyz00_28499;
																																																																											obj_t
																																																																												BgL_varsz00_28498;
																																																																											BgL_varsz00_28498
																																																																												=
																																																																												BgL_arg4355z00_5143;
																																																																											BgL_bodyz00_28499
																																																																												=
																																																																												BgL_arg4356z00_5144;
																																																																											BgL_argsz00_28500
																																																																												=
																																																																												BgL_arg4357z00_5145;
																																																																											BgL_argsz00_1734
																																																																												=
																																																																												BgL_argsz00_28500;
																																																																											BgL_bodyz00_1733
																																																																												=
																																																																												BgL_bodyz00_28499;
																																																																											BgL_varsz00_1732
																																																																												=
																																																																												BgL_varsz00_28498;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1735;
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd260075zd2_5148;
																																																																					BgL_cdrzd260075zd2_5148
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_arg4360z00_5149;
																																																																						obj_t
																																																																							BgL_arg4361z00_5150;
																																																																						obj_t
																																																																							BgL_arg4362z00_5151;
																																																																						BgL_arg4360z00_5149
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5148));
																																																																						BgL_arg4361z00_5150
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5148));
																																																																						BgL_arg4362z00_5151
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_28510;
																																																																							obj_t
																																																																								BgL_bodyz00_28509;
																																																																							obj_t
																																																																								BgL_varsz00_28508;
																																																																							BgL_varsz00_28508
																																																																								=
																																																																								BgL_arg4360z00_5149;
																																																																							BgL_bodyz00_28509
																																																																								=
																																																																								BgL_arg4361z00_5150;
																																																																							BgL_argsz00_28510
																																																																								=
																																																																								BgL_arg4362z00_5151;
																																																																							BgL_argsz00_1734
																																																																								=
																																																																								BgL_argsz00_28510;
																																																																							BgL_bodyz00_1733
																																																																								=
																																																																								BgL_bodyz00_28509;
																																																																							BgL_varsz00_1732
																																																																								=
																																																																								BgL_varsz00_28508;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1735;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd260101zd2_5153;
																																																																			BgL_cdrzd260101zd2_5153
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_arg4364z00_5154;
																																																																				obj_t
																																																																					BgL_arg4365z00_5155;
																																																																				obj_t
																																																																					BgL_arg4366z00_5156;
																																																																				BgL_arg4364z00_5154
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5153));
																																																																				BgL_arg4365z00_5155
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5153));
																																																																				BgL_arg4366z00_5156
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28520;
																																																																					obj_t
																																																																						BgL_bodyz00_28519;
																																																																					obj_t
																																																																						BgL_varsz00_28518;
																																																																					BgL_varsz00_28518
																																																																						=
																																																																						BgL_arg4364z00_5154;
																																																																					BgL_bodyz00_28519
																																																																						=
																																																																						BgL_arg4365z00_5155;
																																																																					BgL_argsz00_28520
																																																																						=
																																																																						BgL_arg4366z00_5156;
																																																																					BgL_argsz00_1734
																																																																						=
																																																																						BgL_argsz00_28520;
																																																																					BgL_bodyz00_1733
																																																																						=
																																																																						BgL_bodyz00_28519;
																																																																					BgL_varsz00_1732
																																																																						=
																																																																						BgL_varsz00_28518;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1735;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd260127zd2_5159;
																																																																	BgL_cdrzd260127zd2_5159
																																																																		=
																																																																		CDR
																																																																		(CAR
																																																																		(BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_arg4369z00_5160;
																																																																		obj_t
																																																																			BgL_arg4370z00_5161;
																																																																		obj_t
																																																																			BgL_arg4371z00_5162;
																																																																		BgL_arg4369z00_5160
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5159));
																																																																		BgL_arg4370z00_5161
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5159));
																																																																		BgL_arg4371z00_5162
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28530;
																																																																			obj_t
																																																																				BgL_bodyz00_28529;
																																																																			obj_t
																																																																				BgL_varsz00_28528;
																																																																			BgL_varsz00_28528
																																																																				=
																																																																				BgL_arg4369z00_5160;
																																																																			BgL_bodyz00_28529
																																																																				=
																																																																				BgL_arg4370z00_5161;
																																																																			BgL_argsz00_28530
																																																																				=
																																																																				BgL_arg4371z00_5162;
																																																																			BgL_argsz00_1734
																																																																				=
																																																																				BgL_argsz00_28530;
																																																																			BgL_bodyz00_1733
																																																																				=
																																																																				BgL_bodyz00_28529;
																																																																			BgL_varsz00_1732
																																																																				=
																																																																				BgL_varsz00_28528;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1735;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd260153zd2_5164;
																																																															BgL_cdrzd260153zd2_5164
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd259976zd2_5114));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_arg4373z00_5165;
																																																																obj_t
																																																																	BgL_arg4374z00_5166;
																																																																obj_t
																																																																	BgL_arg4375z00_5167;
																																																																BgL_arg4373z00_5165
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5164));
																																																																BgL_arg4374z00_5166
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5164));
																																																																BgL_arg4375z00_5167
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_28540;
																																																																	obj_t
																																																																		BgL_bodyz00_28539;
																																																																	obj_t
																																																																		BgL_varsz00_28538;
																																																																	BgL_varsz00_28538
																																																																		=
																																																																		BgL_arg4373z00_5165;
																																																																	BgL_bodyz00_28539
																																																																		=
																																																																		BgL_arg4374z00_5166;
																																																																	BgL_argsz00_28540
																																																																		=
																																																																		BgL_arg4375z00_5167;
																																																																	BgL_argsz00_1734
																																																																		=
																																																																		BgL_argsz00_28540;
																																																																	BgL_bodyz00_1733
																																																																		=
																																																																		BgL_bodyz00_28539;
																																																																	BgL_varsz00_1732
																																																																		=
																																																																		BgL_varsz00_28538;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1735;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd260179zd2_5169;
																																																													BgL_cdrzd260179zd2_5169
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd259976zd2_5114));
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_arg4377z00_5170;
																																																														obj_t
																																																															BgL_arg4378z00_5171;
																																																														obj_t
																																																															BgL_arg4379z00_5172;
																																																														BgL_arg4377z00_5170
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5169));
																																																														BgL_arg4378z00_5171
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5169));
																																																														BgL_arg4379z00_5172
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_28550;
																																																															obj_t
																																																																BgL_bodyz00_28549;
																																																															obj_t
																																																																BgL_varsz00_28548;
																																																															BgL_varsz00_28548
																																																																=
																																																																BgL_arg4377z00_5170;
																																																															BgL_bodyz00_28549
																																																																=
																																																																BgL_arg4378z00_5171;
																																																															BgL_argsz00_28550
																																																																=
																																																																BgL_arg4379z00_5172;
																																																															BgL_argsz00_1734
																																																																=
																																																																BgL_argsz00_28550;
																																																															BgL_bodyz00_1733
																																																																=
																																																																BgL_bodyz00_28549;
																																																															BgL_varsz00_1732
																																																																=
																																																																BgL_varsz00_28548;
																																																															goto
																																																																BgL_tagzd2386zd2_1735;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_cdrzd260205zd2_5174;
																																																											BgL_cdrzd260205zd2_5174
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd259976zd2_5114));
																																																											{	/* Ast/sexp.scm 118 */
																																																												obj_t
																																																													BgL_arg4381z00_5175;
																																																												obj_t
																																																													BgL_arg4382z00_5176;
																																																												obj_t
																																																													BgL_arg4383z00_5177;
																																																												BgL_arg4381z00_5175
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5174));
																																																												BgL_arg4382z00_5176
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5174));
																																																												BgL_arg4383z00_5177
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_28560;
																																																													obj_t
																																																														BgL_bodyz00_28559;
																																																													obj_t
																																																														BgL_varsz00_28558;
																																																													BgL_varsz00_28558
																																																														=
																																																														BgL_arg4381z00_5175;
																																																													BgL_bodyz00_28559
																																																														=
																																																														BgL_arg4382z00_5176;
																																																													BgL_argsz00_28560
																																																														=
																																																														BgL_arg4383z00_5177;
																																																													BgL_argsz00_1734
																																																														=
																																																														BgL_argsz00_28560;
																																																													BgL_bodyz00_1733
																																																														=
																																																														BgL_bodyz00_28559;
																																																													BgL_varsz00_1732
																																																														=
																																																														BgL_varsz00_28558;
																																																													goto
																																																														BgL_tagzd2386zd2_1735;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd260231zd2_5180;
																																																									BgL_cdrzd260231zd2_5180
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd259976zd2_5114));
																																																									{	/* Ast/sexp.scm 118 */
																																																										obj_t
																																																											BgL_arg4386z00_5181;
																																																										obj_t
																																																											BgL_arg4387z00_5182;
																																																										obj_t
																																																											BgL_arg4388z00_5183;
																																																										BgL_arg4386z00_5181
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5180));
																																																										BgL_arg4387z00_5182
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5180));
																																																										BgL_arg4388z00_5183
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28570;
																																																											obj_t
																																																												BgL_bodyz00_28569;
																																																											obj_t
																																																												BgL_varsz00_28568;
																																																											BgL_varsz00_28568
																																																												=
																																																												BgL_arg4386z00_5181;
																																																											BgL_bodyz00_28569
																																																												=
																																																												BgL_arg4387z00_5182;
																																																											BgL_argsz00_28570
																																																												=
																																																												BgL_arg4388z00_5183;
																																																											BgL_argsz00_1734
																																																												=
																																																												BgL_argsz00_28570;
																																																											BgL_bodyz00_1733
																																																												=
																																																												BgL_bodyz00_28569;
																																																											BgL_varsz00_1732
																																																												=
																																																												BgL_varsz00_28568;
																																																											goto
																																																												BgL_tagzd2386zd2_1735;
																																																										}
																																																									}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28573;
																																																									goto
																																																										BgL_tagzd2403zd2_1769;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28573);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2404zd2_1770;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					obj_t
																																																						BgL_cdrzd260369zd2_5188;
																																																					BgL_cdrzd260369zd2_5188
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd259976zd2_5114));
																																																					if ((CAR(((obj_t) BgL_carzd259976zd2_5114)) == CNST_TABLE_REF(((long) 1))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (PAIRP(BgL_cdrzd260369zd2_5188))
																																																								{	/* Ast/sexp.scm 118 */
																																																									obj_t
																																																										BgL_cdrzd260374zd2_5192;
																																																									BgL_cdrzd260374zd2_5192
																																																										=
																																																										CDR
																																																										(BgL_cdrzd260369zd2_5188);
																																																									if (PAIRP(BgL_cdrzd260374zd2_5192))
																																																										{	/* Ast/sexp.scm 118 */
																																																											obj_t
																																																												BgL_carzd260378zd2_5194;
																																																											obj_t
																																																												BgL_cdrzd260379zd2_5195;
																																																											BgL_carzd260378zd2_5194
																																																												=
																																																												CAR
																																																												(BgL_cdrzd260374zd2_5192);
																																																											BgL_cdrzd260379zd2_5195
																																																												=
																																																												CDR
																																																												(BgL_cdrzd260374zd2_5192);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260378zd2_5194))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (PAIRP(BgL_cdrzd260379zd2_5195))
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_carzd260384zd2_5198;
																																																															BgL_carzd260384zd2_5198
																																																																=
																																																																CAR
																																																																(BgL_cdrzd260379zd2_5195);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260384zd2_5198))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	if (NULLP(CDR(BgL_cdrzd260379zd2_5195)))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			bool_t
																																																																				BgL_testz00_28599;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1468z00_5231;
																																																																				BgL_l1468z00_5231
																																																																					=
																																																																					BgL_cdrzd259977zd2_5115;
																																																																			BgL_zc3anonymousza34415ze3z83_5232:
																																																																				if (NULLP(BgL_l1468z00_5231))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						BgL_testz00_28599
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						bool_t
																																																																							BgL_testz00_28602;
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							bool_t
																																																																								BgL_testz00_28603;
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_tmpz00_28604;
																																																																								BgL_tmpz00_28604
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1468z00_5231));
																																																																								BgL_testz00_28603
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_28604);
																																																																							}
																																																																							if (BgL_testz00_28603)
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_28602
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									BgL_testz00_28602
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_testz00_28602)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1468z00_28608;
																																																																								BgL_l1468z00_28608
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1468z00_5231));
																																																																								BgL_l1468z00_5231
																																																																									=
																																																																									BgL_l1468z00_28608;
																																																																								goto
																																																																									BgL_zc3anonymousza34415ze3z83_5232;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								BgL_testz00_28599
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_testz00_28599)
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28615;
																																																																					obj_t
																																																																						BgL_proc2z00_28614;
																																																																					obj_t
																																																																						BgL_proc1z00_28613;
																																																																					obj_t
																																																																						BgL_testz00_28611;
																																																																					BgL_testz00_28611
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd260369zd2_5188);
																																																																					BgL_proc1z00_28613
																																																																						=
																																																																						BgL_carzd260378zd2_5194;
																																																																					BgL_proc2z00_28614
																																																																						=
																																																																						BgL_carzd260384zd2_5198;
																																																																					BgL_argsz00_28615
																																																																						=
																																																																						BgL_cdrzd259977zd2_5115;
																																																																					BgL_argsz00_1739
																																																																						=
																																																																						BgL_argsz00_28615;
																																																																					BgL_proc2z00_1738
																																																																						=
																																																																						BgL_proc2z00_28614;
																																																																					BgL_proc1z00_1737
																																																																						=
																																																																						BgL_proc1z00_28613;
																																																																					BgL_testz00_1736
																																																																						=
																																																																						BgL_testz00_28611;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1740;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd260409zd2_5215;
																																																																					BgL_cdrzd260409zd2_5215
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_cdrzd260417zd2_5216;
																																																																						BgL_cdrzd260417zd2_5216
																																																																							=
																																																																							CDR
																																																																							(CAR
																																																																							(BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd260425zd2_5217;
																																																																							BgL_cdrzd260425zd2_5217
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd260417zd2_5216));
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								obj_t
																																																																									BgL_carzd260432zd2_5218;
																																																																								BgL_carzd260432zd2_5218
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260425zd2_5217));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260432zd2_5218))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_carzd260441zd2_5220;
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_pairz00_13376;
																																																																											BgL_pairz00_13376
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd260425zd2_5217));
																																																																											BgL_carzd260441zd2_5220
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_13376);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260441zd2_5220))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260409zd2_5215))
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg4409z00_5223;
																																																																														BgL_arg4409z00_5223
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd260417zd2_5216));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28637;
																																																																															obj_t
																																																																																BgL_proc2z00_28636;
																																																																															obj_t
																																																																																BgL_proc1z00_28635;
																																																																															obj_t
																																																																																BgL_testz00_28634;
																																																																															BgL_testz00_28634
																																																																																=
																																																																																BgL_arg4409z00_5223;
																																																																															BgL_proc1z00_28635
																																																																																=
																																																																																BgL_carzd260432zd2_5218;
																																																																															BgL_proc2z00_28636
																																																																																=
																																																																																BgL_carzd260441zd2_5220;
																																																																															BgL_argsz00_28637
																																																																																=
																																																																																BgL_cdrzd260409zd2_5215;
																																																																															BgL_argsz00_1744
																																																																																=
																																																																																BgL_argsz00_28637;
																																																																															BgL_proc2z00_1743
																																																																																=
																																																																																BgL_proc2z00_28636;
																																																																															BgL_proc1z00_1742
																																																																																=
																																																																																BgL_proc1z00_28635;
																																																																															BgL_testz00_1741
																																																																																=
																																																																																BgL_testz00_28634;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1745;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_28640;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1769;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_28640);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 118 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1770;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28644;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28644);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28648;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28648);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_28652;
																																																																					goto
																																																																						BgL_tagzd2403zd2_1769;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_28652);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					goto
																																																																						BgL_tagzd2404zd2_1770;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd260719zd2_5242;
																																																																	BgL_cdrzd260719zd2_5242
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		obj_t
																																																																			BgL_cdrzd260726zd2_5243;
																																																																		BgL_cdrzd260726zd2_5243
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			obj_t
																																																																				BgL_cdrzd260733zd2_5244;
																																																																			BgL_cdrzd260733zd2_5244
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd260726zd2_5243));
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd260739zd2_5245;
																																																																				obj_t
																																																																					BgL_cdrzd260740zd2_5246;
																																																																				BgL_carzd260739zd2_5245
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5244));
																																																																				BgL_cdrzd260740zd2_5246
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5244));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260739zd2_5245))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						obj_t
																																																																							BgL_carzd260747zd2_5248;
																																																																						BgL_carzd260747zd2_5248
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260740zd2_5246));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260747zd2_5248))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd260740zd2_5246))))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260719zd2_5242))
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg4424z00_5253;
																																																																												BgL_arg4424z00_5253
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd260726zd2_5243));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_28680;
																																																																													obj_t
																																																																														BgL_proc2z00_28679;
																																																																													obj_t
																																																																														BgL_proc1z00_28678;
																																																																													obj_t
																																																																														BgL_testz00_28677;
																																																																													BgL_testz00_28677
																																																																														=
																																																																														BgL_arg4424z00_5253;
																																																																													BgL_proc1z00_28678
																																																																														=
																																																																														BgL_carzd260739zd2_5245;
																																																																													BgL_proc2z00_28679
																																																																														=
																																																																														BgL_carzd260747zd2_5248;
																																																																													BgL_argsz00_28680
																																																																														=
																																																																														BgL_cdrzd260719zd2_5242;
																																																																													BgL_argsz00_1744
																																																																														=
																																																																														BgL_argsz00_28680;
																																																																													BgL_proc2z00_1743
																																																																														=
																																																																														BgL_proc2z00_28679;
																																																																													BgL_proc1z00_1742
																																																																														=
																																																																														BgL_proc1z00_28678;
																																																																													BgL_testz00_1741
																																																																														=
																																																																														BgL_testz00_28677;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1745;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28683;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1769;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28683);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1770;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28687;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28687);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28691;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28691);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28695;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28695);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_28699;
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28699);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													obj_t
																																																														BgL_cdrzd261080zd2_5261;
																																																													BgL_cdrzd261080zd2_5261
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													{	/* Ast/sexp.scm 118 */
																																																														obj_t
																																																															BgL_cdrzd261086zd2_5262;
																																																														BgL_cdrzd261086zd2_5262
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 118 */
																																																															obj_t
																																																																BgL_cdrzd261092zd2_5263;
																																																															BgL_cdrzd261092zd2_5263
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd261086zd2_5262));
																																																															{	/* Ast/sexp.scm 118 */
																																																																obj_t
																																																																	BgL_carzd261097zd2_5264;
																																																																obj_t
																																																																	BgL_cdrzd261098zd2_5265;
																																																																BgL_carzd261097zd2_5264
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5263));
																																																																BgL_cdrzd261098zd2_5265
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5263));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261097zd2_5264))
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (PAIRP(BgL_cdrzd261098zd2_5265))
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				obj_t
																																																																					BgL_carzd261103zd2_5268;
																																																																				BgL_carzd261103zd2_5268
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd261098zd2_5265);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261103zd2_5268))
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (NULLP(CDR(BgL_cdrzd261098zd2_5265)))
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd261080zd2_5261))
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4438z00_5273;
																																																																										BgL_arg4438z00_5273
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd261086zd2_5262));
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28727;
																																																																											obj_t
																																																																												BgL_proc2z00_28726;
																																																																											obj_t
																																																																												BgL_proc1z00_28725;
																																																																											obj_t
																																																																												BgL_testz00_28724;
																																																																											BgL_testz00_28724
																																																																												=
																																																																												BgL_arg4438z00_5273;
																																																																											BgL_proc1z00_28725
																																																																												=
																																																																												BgL_carzd261097zd2_5264;
																																																																											BgL_proc2z00_28726
																																																																												=
																																																																												BgL_carzd261103zd2_5268;
																																																																											BgL_argsz00_28727
																																																																												=
																																																																												BgL_cdrzd261080zd2_5261;
																																																																											BgL_argsz00_1744
																																																																												=
																																																																												BgL_argsz00_28727;
																																																																											BgL_proc2z00_1743
																																																																												=
																																																																												BgL_proc2z00_28726;
																																																																											BgL_proc1z00_1742
																																																																												=
																																																																												BgL_proc1z00_28725;
																																																																											BgL_testz00_1741
																																																																												=
																																																																												BgL_testz00_28724;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1745;
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28730;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1769;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28730);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1770;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28734;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1769;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28734);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1770;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28738;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1769;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28738);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 118 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1770;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_28742;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1769;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_28742);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 118 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1770;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 118 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_28746;
																																																																				goto
																																																																					BgL_tagzd2403zd2_1769;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_28746);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 118 */
																																																																				goto
																																																																					BgL_tagzd2404zd2_1770;
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28750;
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28750);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_28754;
																																																											goto
																																																												BgL_tagzd2403zd2_1769;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_28754);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2404zd2_1770;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28758;
																																																									goto
																																																										BgL_tagzd2403zd2_1769;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28758);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									goto
																																																										BgL_tagzd2404zd2_1770;
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																																}
																															else
																																{

																																	if (
																																		(BgL_carzd255411zd2_5098
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					17))))
																																		{
																																			obj_t
																																				BgL_auxz00_28763;
																																		BgL_kapzd261641zd2_5681:
																																			if (PAIRP
																																				(BgL_cdrzd255282zd2_5080))
																																				{	/* Ast/sexp.scm 118 */
																																					obj_t
																																						BgL_arg4792z00_5778;
																																					obj_t
																																						BgL_arg4793z00_5779;
																																					BgL_arg4792z00_5778
																																						=
																																						CAR
																																						(BgL_cdrzd255282zd2_5080);
																																					BgL_arg4793z00_5779
																																						=
																																						CDR
																																						(BgL_cdrzd255282zd2_5080);
																																					{
																																						BgL_nodez00_bglt
																																							BgL_auxz00_28768;
																																						{
																																							obj_t
																																								BgL_exprz00_28770;
																																							obj_t
																																								BgL_bindingsz00_28769;
																																							BgL_bindingsz00_28769
																																								=
																																								BgL_arg4792z00_5778;
																																							BgL_exprz00_28770
																																								=
																																								BgL_arg4793z00_5779;
																																							BgL_exprz00_1724
																																								=
																																								BgL_exprz00_28770;
																																							BgL_bindingsz00_1723
																																								=
																																								BgL_bindingsz00_28769;
																																							goto
																																								BgL_tagzd2382zd2_1725;
																																						}
																																						BgL_auxz00_28763
																																							=
																																							(
																																							(obj_t)
																																							BgL_auxz00_28768);
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_28777;
																																							goto
																																								BgL_tagzd2383zd2_1726;
																																							BgL_auxz00_28763
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_28777);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							obj_t
																																								BgL_carzd261674zd2_5782;
																																							BgL_carzd261674zd2_5782
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd261674zd2_5782 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_28784;
																																									goto
																																										BgL_tagzd2384zd2_1727;
																																									BgL_auxz00_28763
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_28784);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261674zd2_5782)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28789;
																																											goto
																																												BgL_tagzd2384zd2_1727;
																																											BgL_auxz00_28763
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_28789);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28796;
																																													goto
																																														BgL_tagzd2389zd2_1746;
																																													BgL_auxz00_28763
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28796);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28803;
																																															goto
																																																BgL_tagzd2390zd2_1747;
																																															BgL_auxz00_28763
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28803);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_28810;
																																																	goto
																																																		BgL_tagzd2392zd2_1751;
																																																	BgL_auxz00_28763
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_28810);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28817;
																																																			goto
																																																				BgL_tagzd2393zd2_1752;
																																																			BgL_auxz00_28763
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28817);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28824;
																																																					goto
																																																						BgL_tagzd2395zd2_1756;
																																																					BgL_auxz00_28763
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28824);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_28831;
																																																							goto
																																																								BgL_tagzd2396zd2_1757;
																																																							BgL_auxz00_28763
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_28831);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_28838;
																																																									goto
																																																										BgL_tagzd2397zd2_1758;
																																																									BgL_auxz00_28763
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_28838);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_28845;
																																																											goto
																																																												BgL_tagzd2398zd2_1759;
																																																											BgL_auxz00_28763
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28845);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28855;
																																																															goto
																																																																BgL_tagzd2402zd2_1768;
																																																															BgL_auxz00_28763
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28855);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 118 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1769;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_28859;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1770;
																																																																	BgL_auxz00_28763
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_28859);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 118 */
																																																															goto
																																																																BgL_tagzd2403zd2_1769;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28863;
																																																															goto
																																																																BgL_tagzd2404zd2_1770;
																																																															BgL_auxz00_28763
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28863);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			return
																																				(
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_28763);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 118 */
																																			if (CBOOL
																																				(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_carzd255411zd2_5098)))
																																				{
																																					obj_t
																																						BgL_auxz00_28869;
																																					goto
																																						BgL_kapzd261641zd2_5681;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_28869);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 118 */
																																					if (
																																						(BgL_carzd255411zd2_5098
																																							==
																																							CNST_TABLE_REF
																																							(((long) 18))))
																																						{
																																							obj_t
																																								BgL_auxz00_28874;
																																							goto
																																								BgL_kapzd261641zd2_5681;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_28874);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 118 */
																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																								{	/* Ast/sexp.scm 118 */
																																									goto
																																										BgL_tagzd2383zd2_1726;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 118 */
																																									obj_t
																																										BgL_carzd261835zd2_5687;
																																									BgL_carzd261835zd2_5687
																																										=
																																										CAR
																																										(BgL_expz00_21);
																																									if ((BgL_carzd261835zd2_5687 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28884;
																																											goto
																																												BgL_tagzd2384zd2_1727;
																																											return
																																												(
																																												(BgL_nodez00_bglt)
																																												BgL_auxz00_28884);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 118 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261835zd2_5687)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_28889;
																																													goto
																																														BgL_tagzd2384zd2_1727;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_28889);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 118 */
																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 118 */
																																															goto
																																																BgL_tagzd2389zd2_1746;
																																														}
																																													else
																																														{	/* Ast/sexp.scm 118 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																{	/* Ast/sexp.scm 118 */
																																																	goto
																																																		BgL_tagzd2390zd2_1747;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 118 */
																																																	obj_t
																																																		BgL_cdrzd261914zd2_5694;
																																																	BgL_cdrzd261914zd2_5694
																																																		=
																																																		CDR
																																																		(BgL_expz00_21);
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																		{	/* Ast/sexp.scm 118 */
																																																			if (PAIRP(BgL_cdrzd261914zd2_5694))
																																																				{
																																																					obj_t
																																																						BgL_restz00_28908;
																																																					obj_t
																																																						BgL_effectz00_28906;
																																																					BgL_effectz00_28906
																																																						=
																																																						CAR
																																																						(BgL_cdrzd261914zd2_5694);
																																																					BgL_restz00_28908
																																																						=
																																																						CDR
																																																						(BgL_cdrzd261914zd2_5694);
																																																					BgL_restz00_1749
																																																						=
																																																						BgL_restz00_28908;
																																																					BgL_effectz00_1748
																																																						=
																																																						BgL_effectz00_28906;
																																																					goto
																																																						BgL_tagzd2391zd2_1750;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{
																																																							obj_t
																																																								BgL_auxz00_28912;
																																																							goto
																																																								BgL_tagzd2403zd2_1769;
																																																							return
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BgL_auxz00_28912);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2404zd2_1770;
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 118 */
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																				{	/* Ast/sexp.scm 118 */
																																																					goto
																																																						BgL_tagzd2392zd2_1751;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 118 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																						{	/* Ast/sexp.scm 118 */
																																																							goto
																																																								BgL_tagzd2393zd2_1752;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 118 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																								{	/* Ast/sexp.scm 118 */
																																																									if (PAIRP(BgL_cdrzd261914zd2_5694))
																																																										{
																																																											obj_t
																																																												BgL_restz00_28930;
																																																											obj_t
																																																												BgL_effectz00_28928;
																																																											BgL_effectz00_28928
																																																												=
																																																												CAR
																																																												(BgL_cdrzd261914zd2_5694);
																																																											BgL_restz00_28930
																																																												=
																																																												CDR
																																																												(BgL_cdrzd261914zd2_5694);
																																																											BgL_restz00_1754
																																																												=
																																																												BgL_restz00_28930;
																																																											BgL_effectz00_1753
																																																												=
																																																												BgL_effectz00_28928;
																																																											goto
																																																												BgL_tagzd2394zd2_1755;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28934;
																																																													goto
																																																														BgL_tagzd2403zd2_1769;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28934);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2404zd2_1770;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 118 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																										{	/* Ast/sexp.scm 118 */
																																																											goto
																																																												BgL_tagzd2395zd2_1756;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 118 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																												{	/* Ast/sexp.scm 118 */
																																																													goto
																																																														BgL_tagzd2396zd2_1757;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 118 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_28948;
																																																															goto
																																																																BgL_tagzd2397zd2_1758;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_28948);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 118 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																{
																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																		BgL_auxz00_28954;
																																																																	goto
																																																																		BgL_tagzd2398zd2_1759;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28954);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 118 */
																																																																	obj_t
																																																																		BgL_cdrzd262041zd2_5720;
																																																																	BgL_cdrzd262041zd2_5720
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if (PAIRP(BgL_cdrzd262041zd2_5720))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					obj_t
																																																																						BgL_cdrzd262043zd2_5724;
																																																																					BgL_cdrzd262043zd2_5724
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262041zd2_5720);
																																																																					if (PAIRP(BgL_cdrzd262043zd2_5724))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_cdrzd262043zd2_5724)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2399zd2_1760;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_28971;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_28971);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_28975;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_28975);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_28979;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1769;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_28979);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1770;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 118 */
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (PAIRP(BgL_cdrzd262041zd2_5720))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							obj_t
																																																																								BgL_cdrzd262088zd2_5736;
																																																																							BgL_cdrzd262088zd2_5736
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd262041zd2_5720);
																																																																							if (PAIRP(BgL_cdrzd262088zd2_5736))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd262093zd2_5738;
																																																																									BgL_cdrzd262093zd2_5738
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd262088zd2_5736);
																																																																									if ((CAR(BgL_cdrzd262088zd2_5736) == CNST_TABLE_REF(((long) 31))))
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											if (PAIRP(BgL_cdrzd262093zd2_5738))
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_arg4759z00_5742;
																																																																													obj_t
																																																																														BgL_arg4760z00_5743;
																																																																													obj_t
																																																																														BgL_arg4761z00_5744;
																																																																													BgL_arg4759z00_5742
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262041zd2_5720);
																																																																													BgL_arg4760z00_5743
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262093zd2_5738);
																																																																													BgL_arg4761z00_5744
																																																																														=
																																																																														CDR
																																																																														(BgL_cdrzd262093zd2_5738);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4759z00_5742,
																																																																														BgL_arg4760z00_5743,
																																																																														BgL_arg4761z00_5744,
																																																																														BgL_stackz00_22,
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																															BgL_locz00_23),
																																																																														BgL_sitez00_24);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 118 */
																																																																													obj_t
																																																																														BgL_cdrzd262106zd2_5745;
																																																																													BgL_cdrzd262106zd2_5745
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 118 */
																																																																														obj_t
																																																																															BgL_arg4762z00_5746;
																																																																														obj_t
																																																																															BgL_arg4763z00_5747;
																																																																														BgL_arg4762z00_5746
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5745));
																																																																														BgL_arg4763z00_5747
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5745));
																																																																														{	/* Ast/sexp.scm 563 */
																																																																															obj_t
																																																																																BgL_arg7000z00_13459;
																																																																															BgL_arg7000z00_13459
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg4762z00_5746,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg4763z00_5747, BgL_stackz00_22, BgL_arg7000z00_13459, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											obj_t
																																																																												BgL_cdrzd262121zd2_5748;
																																																																											BgL_cdrzd262121zd2_5748
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 118 */
																																																																												obj_t
																																																																													BgL_arg4764z00_5749;
																																																																												obj_t
																																																																													BgL_arg4765z00_5750;
																																																																												BgL_arg4764z00_5749
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5748));
																																																																												BgL_arg4765z00_5750
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5748));
																																																																												{	/* Ast/sexp.scm 563 */
																																																																													obj_t
																																																																														BgL_arg7000z00_13463;
																																																																													BgL_arg7000z00_13463
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4764z00_5749,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg4765z00_5750, BgL_stackz00_22, BgL_arg7000z00_13463, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									obj_t
																																																																										BgL_cdrzd262136zd2_5752;
																																																																									BgL_cdrzd262136zd2_5752
																																																																										=
																																																																										CDR
																																																																										(BgL_expz00_21);
																																																																									{	/* Ast/sexp.scm 118 */
																																																																										obj_t
																																																																											BgL_arg4767z00_5753;
																																																																										obj_t
																																																																											BgL_arg4768z00_5754;
																																																																										BgL_arg4767z00_5753
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5752));
																																																																										BgL_arg4768z00_5754
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5752));
																																																																										{	/* Ast/sexp.scm 563 */
																																																																											obj_t
																																																																												BgL_arg7000z00_13467;
																																																																											BgL_arg7000z00_13467
																																																																												=
																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																												(BgL_expz00_21,
																																																																												BgL_locz00_23);
																																																																											return
																																																																												BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																												(BgL_expz00_21,
																																																																												BgL_arg4767z00_5753,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4768z00_5754, BgL_stackz00_22, BgL_arg7000z00_13467, BgL_sitez00_24);
																																																																						}}}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29028;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29028);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 118 */
																																																																					if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (NULLP(CDR(BgL_expz00_21)))
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1768;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29038;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1769;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29038);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 118 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1770;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 118 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29042;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1769;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29042);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 118 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1770;
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 118 */
										BgL_atomz00_1701 = BgL_expz00_21;
										{	/* Ast/sexp.scm 134 */
											bool_t BgL_testz00_29044;

											if (BGl_isazf3zf3zz__objectz00(BgL_atomz00_1701,
													BGl_localz00zzast_varz00))
												{	/* Ast/sexp.scm 134 */
													BgL_testz00_29044 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 134 */
													BgL_testz00_29044 =
														BGl_isazf3zf3zz__objectz00(BgL_atomz00_1701,
														BGl_globalz00zzast_varz00);
												}
											if (BgL_testz00_29044)
												{	/* Ast/sexp.scm 134 */
													return
														BGl_variablezd2ze3nodez31zzast_sexpz00
														(BgL_atomz00_1701, BgL_locz00_23, BgL_sitez00_24);
												}
											else
												{	/* Ast/sexp.scm 136 */
													bool_t BgL_testz00_29049;

													if (STRUCTP(BgL_atomz00_1701))
														{	/* Ast/sexp.scm 136 */
															BgL_testz00_29049 = ((bool_t) 1);
														}
													else
														{	/* Ast/sexp.scm 136 */
															if (VECTORP(BgL_atomz00_1701))
																{	/* Ast/sexp.scm 136 */
																	BgL_testz00_29049 = ((bool_t) 1);
																}
															else
																{	/* Ast/sexp.scm 136 */
																	if (BGL_OBJECTP(BgL_atomz00_1701))
																		{	/* Ast/sexp.scm 136 */
																			BgL_testz00_29049 = ((bool_t) 1);
																		}
																	else
																		{	/* Ast/sexp.scm 136 */
																			BgL_testz00_29049 =
																				PROCEDUREP(BgL_atomz00_1701);
																		}
																}
														}
													if (BgL_testz00_29049)
														{	/* Ast/sexp.scm 137 */
															BgL_nodez00_bglt BgL_res7305z00_9581;

															{	/* Ast/sexp.scm 717 */
																obj_t BgL_arg7100z00_9577;
																BgL_nodez00_bglt BgL_arg7101z00_9578;

																BgL_arg7100z00_9577 =
																	BGl_shapez00zztools_shapez00
																	(BGl_currentzd2functionzd2zztools_errorz00());
																BgL_arg7101z00_9578 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(CNST_TABLE_REF(((long) 4)), BNIL,
																	BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																{	/* Ast/sexp.scm 716 */
																	obj_t BgL_list7102z00_9580;

																	BgL_list7102z00_9580 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg7101z00_9578), BNIL);
																	BgL_res7305z00_9581 =
																		((BgL_nodez00_bglt)
																		BGl_userzd2errorzf2locationz20zztools_errorz00
																		(BgL_locz00_23, BgL_arg7100z00_9577,
																			BGl_string7987z00zzast_sexpz00,
																			BgL_expz00_21, BgL_list7102z00_9580));
															}}
															return BgL_res7305z00_9581;
														}
													else
														{	/* Ast/sexp.scm 136 */
															if (SYMBOLP(BgL_atomz00_1701))
																{	/* Ast/sexp.scm 143 */
																	obj_t BgL_g1115z00_8359;

																	BgL_g1115z00_8359 =
																		BGl_findzd2localzd2zzast_sexpz00
																		(BgL_atomz00_1701, BgL_stackz00_22);
																	if (CBOOL(BgL_g1115z00_8359))
																		{	/* Ast/sexp.scm 143 */
																			return
																				BGl_variablezd2ze3nodez31zzast_sexpz00
																				(BgL_g1115z00_8359, BgL_locz00_23,
																				BgL_sitez00_24);
																		}
																	else
																		{	/* Ast/sexp.scm 147 */
																			obj_t BgL_globalz00_8362;
																			obj_t BgL_locz00_8363;

																			BgL_globalz00_8362 =
																				BGl_findzd2globalzd2zzast_envz00
																				(BgL_atomz00_1701, BNIL);
																			BgL_locz00_8363 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_atomz00_1701, BgL_locz00_23);
																			if (BGl_isazf3zf3zz__objectz00
																				(BgL_globalz00_8362,
																					BGl_globalz00zzast_varz00))
																				{	/* Ast/sexp.scm 150 */
																					if (
																						((((BgL_globalz00_bglt) COBJECT(
																										((BgL_globalz00_bglt)
																											BgL_globalz00_8362)))->
																								BgL_importz00) ==
																							CNST_TABLE_REF(((long) 10))))
																						{	/* Ast/sexp.scm 153 */
																							obj_t BgL_arg6632z00_8367;

																							{	/* Ast/sexp.scm 153 */
																								obj_t BgL_arg6633z00_8368;

																								{	/* Ast/sexp.scm 153 */
																									obj_t BgL_arg6634z00_8369;

																									{	/* Ast/sexp.scm 153 */
																										obj_t BgL_arg6635z00_8370;

																										BgL_arg6635z00_8370 =
																											MAKE_YOUNG_PAIR
																											(BgL_atomz00_1701, BNIL);
																										BgL_arg6634z00_8369 =
																											MAKE_YOUNG_PAIR
																											(CNST_TABLE_REF(((long)
																													12)),
																											BgL_arg6635z00_8370);
																									}
																									BgL_arg6633z00_8368 =
																										MAKE_YOUNG_PAIR
																										(BgL_arg6634z00_8369, BNIL);
																								}
																								BgL_arg6632z00_8367 =
																									MAKE_YOUNG_PAIR(CNST_TABLE_REF
																									(((long) 10)),
																									BgL_arg6633z00_8368);
																							}
																							{
																								obj_t BgL_locz00_29088;
																								obj_t BgL_expz00_29087;

																								BgL_expz00_29087 =
																									BgL_arg6632z00_8367;
																								BgL_locz00_29088 =
																									BgL_locz00_8363;
																								BgL_locz00_23 =
																									BgL_locz00_29088;
																								BgL_expz00_21 =
																									BgL_expz00_29087;
																								goto
																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 152 */
																							return
																								BGl_variablezd2ze3nodez31zzast_sexpz00
																								(BgL_globalz00_8362,
																								BgL_locz00_8363,
																								BgL_sitez00_24);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 151 */
																					BgL_nodez00_bglt BgL_res7308z00_9590;

																					{	/* Ast/sexp.scm 717 */
																						obj_t BgL_arg7100z00_9586;
																						BgL_nodez00_bglt
																							BgL_arg7101z00_9587;
																						BgL_arg7100z00_9586 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7101z00_9587 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_8363,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 716 */
																							obj_t BgL_list7102z00_9589;

																							BgL_list7102z00_9589 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7101z00_9587),
																								BNIL);
																							BgL_res7308z00_9590 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_8363,
																									BgL_arg7100z00_9586,
																									BGl_string7986z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7102z00_9589));
																					}}
																					return BgL_res7308z00_9590;
																				}
																		}
																}
															else
																{	/* Ast/sexp.scm 139 */
																	BgL_literalz00_bglt BgL_new1114z00_8373;

																	{	/* Ast/sexp.scm 140 */
																		BgL_literalz00_bglt BgL_new1113z00_8374;

																		BgL_new1113z00_8374 =
																			((BgL_literalz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_literalz00_bgl))));
																		{	/* Ast/sexp.scm 140 */
																			long BgL_arg6638z00_8375;

																			{	/* Ast/sexp.scm 140 */
																				long BgL_res7309z00_9592;

																				BgL_res7309z00_9592 =
																					BGL_CLASS_INDEX
																					(BGl_literalz00zzast_nodez00);
																				BgL_arg6638z00_8375 =
																					BgL_res7309z00_9592;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1113z00_8374),
																				BgL_arg6638z00_8375);
																		}
																		{	/* Ast/sexp.scm 140 */
																			BgL_objectz00_bglt BgL_tmpz00_29103;

																			BgL_tmpz00_29103 =
																				((BgL_objectz00_bglt)
																				BgL_new1113z00_8374);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29103,
																				BFALSE);
																		}
																		BgL_new1114z00_8373 = BgL_new1113z00_8374;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1114z00_8373)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_23), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1114z00_8373)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2typezd2atomz00zztype_typeofz00
																			(BgL_atomz00_1701)), BUNSPEC);
																	((((BgL_atomz00_bglt)
																				COBJECT(((BgL_atomz00_bglt)
																						BgL_new1114z00_8373)))->
																			BgL_valuez00) =
																		((obj_t) BgL_atomz00_1701), BUNSPEC);
																	return ((BgL_nodez00_bglt)
																		BgL_new1114z00_8373);
																}
														}
												}
										}
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* liip~0 */
	obj_t BGl_liipze70ze7zzast_sexpz00(obj_t BgL_argsz00_8777)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 396 */
			if (NULLP(BgL_argsz00_8777))
				{	/* Ast/sexp.scm 397 */
					return CNST_TABLE_REF(((long) 4));
				}
			else
				{	/* Ast/sexp.scm 399 */
					obj_t BgL_arg6876z00_8780;

					{	/* Ast/sexp.scm 399 */
						obj_t BgL_arg6877z00_8781;
						obj_t BgL_arg6878z00_8782;

						BgL_arg6877z00_8781 = CAR(((obj_t) BgL_argsz00_8777));
						{	/* Ast/sexp.scm 400 */
							obj_t BgL_arg6879z00_8783;

							{	/* Ast/sexp.scm 400 */
								obj_t BgL_arg6880z00_8784;

								BgL_arg6880z00_8784 = CDR(((obj_t) BgL_argsz00_8777));
								BgL_arg6879z00_8783 =
									BGl_liipze70ze7zzast_sexpz00(BgL_arg6880z00_8784);
							}
							BgL_arg6878z00_8782 = MAKE_YOUNG_PAIR(BgL_arg6879z00_8783, BNIL);
						}
						BgL_arg6876z00_8780 =
							MAKE_YOUNG_PAIR(BgL_arg6877z00_8781, BgL_arg6878z00_8782);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 32)), BgL_arg6876z00_8780);
		}}
		BGL_FUNCTION_END;
	}



/* loop~0 */
	obj_t BGl_loopze70ze7zzast_sexpz00(obj_t BgL_expz00_13738,
		obj_t BgL_locz00_13737, obj_t BgL_varsz00_8739, obj_t BgL_argsz00_8740)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 381 */
		BGl_loopze70ze7zzast_sexpz00:
			if (NULLP(BgL_varsz00_8739))
				{	/* Ast/sexp.scm 384 */
					if (NULLP(BgL_argsz00_8740))
						{	/* Ast/sexp.scm 385 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 385 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_13737,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string7989z00zzast_sexpz00, BgL_expz00_13738, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 384 */
					if (PAIRP(BgL_varsz00_8739))
						{	/* Ast/sexp.scm 392 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(CAR
									(BgL_varsz00_8739)))
								{	/* Ast/sexp.scm 402 */
									obj_t BgL_argz00_8750;

									BgL_argz00_8750 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_8739));
									if (CBOOL(BgL_argz00_8750))
										{
											obj_t BgL_varsz00_29142;

											BgL_varsz00_29142 = BgL_argz00_8750;
											BgL_varsz00_8739 = BgL_varsz00_29142;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_29143;

											BgL_varsz00_29143 = BNIL;
											BgL_varsz00_8739 = BgL_varsz00_29143;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 407 */
									bool_t BgL_testz00_29144;

									{	/* Ast/sexp.scm 407 */
										obj_t BgL_tmpz00_29145;

										BgL_tmpz00_29145 = CAR(BgL_varsz00_8739);
										BgL_testz00_29144 = SYMBOLP(BgL_tmpz00_29145);
									}
									if (BgL_testz00_29144)
										{	/* Ast/sexp.scm 407 */
											if (NULLP(BgL_argsz00_8740))
												{	/* Ast/sexp.scm 413 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_13737,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string7989z00zzast_sexpz00, BgL_expz00_13738,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 420 */
													obj_t BgL_arg6856z00_8758;
													obj_t BgL_arg6857z00_8759;

													{	/* Ast/sexp.scm 420 */
														obj_t BgL_arg6858z00_8760;
														obj_t BgL_arg6859z00_8761;

														BgL_arg6858z00_8760 = CAR(BgL_varsz00_8739);
														BgL_arg6859z00_8761 =
															CAR(((obj_t) BgL_argsz00_8740));
														{	/* Ast/sexp.scm 420 */
															obj_t BgL_list6860z00_8762;

															{	/* Ast/sexp.scm 420 */
																obj_t BgL_arg6861z00_8763;

																BgL_arg6861z00_8763 =
																	MAKE_YOUNG_PAIR(BgL_arg6859z00_8761, BNIL);
																BgL_list6860z00_8762 =
																	MAKE_YOUNG_PAIR(BgL_arg6858z00_8760,
																	BgL_arg6861z00_8763);
															}
															BgL_arg6856z00_8758 = BgL_list6860z00_8762;
														}
													}
													{	/* Ast/sexp.scm 421 */
														obj_t BgL_arg6862z00_8764;
														obj_t BgL_arg6863z00_8765;

														BgL_arg6862z00_8764 = CDR(BgL_varsz00_8739);
														BgL_arg6863z00_8765 =
															CDR(((obj_t) BgL_argsz00_8740));
														BgL_arg6857z00_8759 =
															BGl_loopze70ze7zzast_sexpz00(BgL_expz00_13738,
															BgL_locz00_13737, BgL_arg6862z00_8764,
															BgL_arg6863z00_8765);
													}
													return
														MAKE_YOUNG_PAIR(BgL_arg6856z00_8758,
														BgL_arg6857z00_8759);
												}
										}
									else
										{	/* Ast/sexp.scm 407 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_13737,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string7990z00zzast_sexpz00, BgL_expz00_13738, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 397 */
							obj_t BgL_arg6869z00_8771;

							{	/* Ast/sexp.scm 397 */
								obj_t BgL_arg6871z00_8773;

								BgL_arg6871z00_8773 =
									BGl_liipze70ze7zzast_sexpz00(BgL_argsz00_8740);
								{	/* Ast/sexp.scm 394 */
									obj_t BgL_list6872z00_8774;

									{	/* Ast/sexp.scm 394 */
										obj_t BgL_arg6873z00_8775;

										BgL_arg6873z00_8775 =
											MAKE_YOUNG_PAIR(BgL_arg6871z00_8773, BNIL);
										BgL_list6872z00_8774 =
											MAKE_YOUNG_PAIR(BgL_varsz00_8739, BgL_arg6873z00_8775);
									}
									BgL_arg6869z00_8771 = BgL_list6872z00_8774;
								}
							}
							{	/* Ast/sexp.scm 393 */
								obj_t BgL_list6870z00_8772;

								BgL_list6870z00_8772 =
									MAKE_YOUNG_PAIR(BgL_arg6869z00_8771, BNIL);
								return BgL_list6870z00_8772;
							}
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* &sexp->node */
	BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t BgL_envz00_13699,
		obj_t BgL_expz00_13700, obj_t BgL_stackz00_13701, obj_t BgL_locz00_13702,
		obj_t BgL_sitez00_13703)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 113 */
			return
				BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13700, BgL_stackz00_13701,
				BgL_locz00_13702, BgL_sitez00_13703);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:6886> */
	obj_t BGl_z62zc3anonymousza36886ze3ze1zzast_sexpz00(obj_t BgL_envz00_13704,
		obj_t BgL_objz00_13706, obj_t BgL_procz00_13707, obj_t BgL_msgz00_13708)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 426 */
			return
				BGl_userzd2errorzf2locationz20zztools_errorz00(PROCEDURE_REF
				(BgL_envz00_13704, (int) (((long) 0))), BgL_objz00_13706,
				BgL_procz00_13707, BgL_msgz00_13708, BNIL);
		}
		BGL_FUNCTION_END;
	}



/* variable->node */
	BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t BgL_vz00_25,
		obj_t BgL_locz00_26, obj_t BgL_sitez00_27)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 582 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_vz00_25), BgL_locz00_26, BgL_sitez00_27);
			{	/* Ast/sexp.scm 584 */
				bool_t BgL_testz00_29176;

				if ((BgL_sitez00_27 == CNST_TABLE_REF(((long) 33))))
					{	/* Ast/sexp.scm 584 */
						BgL_testz00_29176 = ((bool_t) 0);
					}
				else
					{	/* Ast/sexp.scm 584 */
						BgL_valuez00_bglt BgL_arg7024z00_9019;

						BgL_arg7024z00_9019 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_vz00_25)))->BgL_valuez00);
						{	/* Ast/sexp.scm 584 */
							bool_t BgL_res7905z00_13472;

							BgL_res7905z00_13472 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg7024z00_9019), BGl_funz00zzast_varz00);
							BgL_testz00_29176 = BgL_res7905z00_13472;
						}
					}
				if (BgL_testz00_29176)
					{	/* Ast/sexp.scm 585 */
						bool_t BgL_testz00_29184;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_25,
								BGl_globalz00zzast_varz00))
							{	/* Ast/sexp.scm 586 */
								bool_t BgL_testz00_29187;

								{	/* Ast/sexp.scm 586 */
									BgL_valuez00_bglt BgL_arg7021z00_9013;

									BgL_arg7021z00_9013 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_25))))->BgL_valuez00);
									{	/* Ast/sexp.scm 586 */
										bool_t BgL_res7907z00_13475;

										BgL_res7907z00_13475 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg7021z00_9013), BGl_cfunz00zzast_varz00);
										BgL_testz00_29187 = BgL_res7907z00_13475;
									}
								}
								if (BgL_testz00_29187)
									{	/* Ast/sexp.scm 587 */
										bool_t BgL_testz00_29193;

										{	/* Ast/sexp.scm 587 */
											obj_t BgL_arg7020z00_9012;

											BgL_arg7020z00_9012 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_testz00_29193 =
												(((BgL_backendz00_bglt) COBJECT(
														((BgL_backendz00_bglt) BgL_arg7020z00_9012)))->
												BgL_foreignzd2closurezd2);
										}
										if (BgL_testz00_29193)
											{	/* Ast/sexp.scm 587 */
												BgL_testz00_29184 = ((bool_t) 0);
											}
										else
											{	/* Ast/sexp.scm 587 */
												if ((BgL_sitez00_27 == CNST_TABLE_REF(((long) 30))))
													{	/* Ast/sexp.scm 588 */
														BgL_testz00_29184 = ((bool_t) 0);
													}
												else
													{	/* Ast/sexp.scm 588 */
														BgL_testz00_29184 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Ast/sexp.scm 586 */
										BgL_testz00_29184 = ((bool_t) 0);
									}
							}
						else
							{	/* Ast/sexp.scm 585 */
								BgL_testz00_29184 = ((bool_t) 0);
							}
						if (BgL_testz00_29184)
							{	/* Ast/sexp.scm 590 */
								obj_t BgL_arg7014z00_9000;

								{	/* Ast/sexp.scm 590 */
									obj_t BgL_arg7015z00_9001;

									{	/* Ast/sexp.scm 590 */
										obj_t BgL_arg7017z00_9003;

										BgL_arg7017z00_9003 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_arg7015z00_9001 =
											(((BgL_backendz00_bglt) COBJECT(
													((BgL_backendz00_bglt) BgL_arg7017z00_9003)))->
											BgL_namez00);
									}
									{	/* Ast/sexp.scm 590 */
										obj_t BgL_list7016z00_9002;

										BgL_list7016z00_9002 =
											MAKE_YOUNG_PAIR(BgL_arg7015z00_9001, BNIL);
										BgL_arg7014z00_9000 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string7991z00zzast_sexpz00, BgL_list7016z00_9002);
									}
								}
								return
									BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
									(BgL_arg7014z00_9000, BGl_expzd2envzd2zz__r4_numbers_6_5z00,
									BgL_locz00_26);
							}
						else
							{	/* Ast/sexp.scm 591 */
								BgL_closurez00_bglt BgL_new1145z00_9004;

								{	/* Ast/sexp.scm 592 */
									BgL_closurez00_bglt BgL_new1144z00_9006;

									BgL_new1144z00_9006 =
										((BgL_closurez00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_closurez00_bgl))));
									{	/* Ast/sexp.scm 592 */
										long BgL_arg7019z00_9007;

										{	/* Ast/sexp.scm 592 */
											long BgL_res7910z00_13483;

											BgL_res7910z00_13483 =
												BGL_CLASS_INDEX(BGl_closurez00zzast_nodez00);
											BgL_arg7019z00_9007 = BgL_res7910z00_13483;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1144z00_9006),
											BgL_arg7019z00_9007);
									}
									BgL_new1145z00_9004 = BgL_new1144z00_9006;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1145z00_9004)))->
										BgL_locz00) = ((obj_t) BgL_locz00_26), BUNSPEC);
								{
									BgL_typez00_bglt BgL_auxz00_29212;

									{	/* Ast/sexp.scm 593 */
										BgL_typez00_bglt BgL_arg7018z00_9005;

										BgL_arg7018z00_9005 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_25)))->BgL_typez00);
										BgL_auxz00_29212 =
											BGl_strictzd2nodezd2typez00zzast_nodez00(
											((BgL_typez00_bglt)
												BGl_za2procedureza2z00zztype_cachez00),
											BgL_arg7018z00_9005);
									}
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt) BgL_new1145z00_9004)))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_auxz00_29212), BUNSPEC);
								}
								((((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_new1145z00_9004)))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_25)),
									BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1145z00_9004);
							}
					}
				else
					{	/* Ast/sexp.scm 595 */
						BgL_varz00_bglt BgL_new1147z00_9014;

						{	/* Ast/sexp.scm 596 */
							BgL_varz00_bglt BgL_new1146z00_9016;

							BgL_new1146z00_9016 =
								((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_varz00_bgl))));
							{	/* Ast/sexp.scm 596 */
								long BgL_arg7023z00_9017;

								{	/* Ast/sexp.scm 596 */
									long BgL_res7911z00_13488;

									BgL_res7911z00_13488 =
										BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
									BgL_arg7023z00_9017 = BgL_res7911z00_13488;
								}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1146z00_9016),
									BgL_arg7023z00_9017);
							}
							BgL_new1147z00_9014 = BgL_new1146z00_9016;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1147z00_9014)))->BgL_locz00) =
							((obj_t) BgL_locz00_26), BUNSPEC);
						{
							BgL_typez00_bglt BgL_auxz00_29229;

							{	/* Ast/sexp.scm 597 */
								BgL_typez00_bglt BgL_arg7022z00_9015;

								BgL_arg7022z00_9015 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_25)))->BgL_typez00);
								BgL_auxz00_29229 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00),
									BgL_arg7022z00_9015);
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1147z00_9014)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_29229), BUNSPEC);
						}
						((((BgL_varz00_bglt) COBJECT(BgL_new1147z00_9014))->
								BgL_variablez00) =
							((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_25)),
							BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1147z00_9014);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_28,
		obj_t BgL_stackz00_29, obj_t BgL_locz00_30, obj_t BgL_sitez00_31)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 603 */
			{	/* Ast/sexp.scm 604 */
				obj_t BgL_callerz00_9020;
				obj_t BgL_locz00_9021;

				BgL_callerz00_9020 = CAR(((obj_t) BgL_expz00_28));
				BgL_locz00_9021 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_28,
					BgL_locz00_30);
				if (SYMBOLP(BgL_callerz00_9020))
					{	/* Ast/sexp.scm 608 */
						obj_t BgL_pidz00_9023;

						BgL_pidz00_9023 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_9020,
							BgL_locz00_9021);
						{	/* Ast/sexp.scm 608 */
							obj_t BgL_idz00_9024;

							BgL_idz00_9024 = CAR(BgL_pidz00_9023);
							{	/* Ast/sexp.scm 609 */
								obj_t BgL_typez00_9025;

								BgL_typez00_9025 = CDR(BgL_pidz00_9023);
								{	/* Ast/sexp.scm 610 */

									if ((BgL_idz00_9024 == CNST_TABLE_REF(((long) 6))))
										{	/* Ast/sexp.scm 611 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, ((BgL_typez00_bglt) BgL_typez00_9025),
												BgL_expz00_28, BgL_stackz00_29, BgL_locz00_9021,
												BgL_sitez00_31);
										}
									else
										{	/* Ast/sexp.scm 611 */
											if ((BgL_idz00_9024 == CNST_TABLE_REF(((long) 21))))
												{	/* Ast/sexp.scm 615 */
													bool_t BgL_testz00_29255;

													{	/* Ast/sexp.scm 615 */
														obj_t BgL_tmpz00_29256;

														BgL_tmpz00_29256 = CDR(((obj_t) BgL_expz00_28));
														BgL_testz00_29255 = PAIRP(BgL_tmpz00_29256);
													}
													if (BgL_testz00_29255)
														{	/* Ast/sexp.scm 619 */
															BgL_feffectz00_bglt BgL_arg7030z00_9031;
															obj_t BgL_arg7031z00_9032;

															{	/* Ast/sexp.scm 619 */
																obj_t BgL_arg7032z00_9033;

																{	/* Ast/sexp.scm 619 */
																	obj_t BgL_pairz00_13505;

																	BgL_pairz00_13505 =
																		CDR(((obj_t) BgL_expz00_28));
																	BgL_arg7032z00_9033 = CAR(BgL_pairz00_13505);
																}
																BgL_arg7030z00_9031 =
																	BGl_parsezd2effectzd2zzeffect_feffectz00
																	(BgL_arg7032z00_9033);
															}
															{	/* Ast/sexp.scm 620 */
																obj_t BgL_arg7033z00_9034;
																obj_t BgL_arg7034z00_9035;

																{	/* Ast/sexp.scm 620 */
																	obj_t BgL_arg7035z00_9036;

																	BgL_arg7035z00_9036 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 34)),
																		BNIL);
																	BgL_arg7033z00_9034 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 35)),
																		BgL_arg7035z00_9036);
																}
																{	/* Ast/sexp.scm 620 */
																	obj_t BgL_auxz00_29268;

																	{	/* Ast/sexp.scm 620 */
																		obj_t BgL_pairz00_13509;

																		BgL_pairz00_13509 =
																			CDR(((obj_t) BgL_expz00_28));
																		BgL_auxz00_29268 = CDR(BgL_pairz00_13509);
																	}
																	BgL_arg7034z00_9035 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_auxz00_29268, BNIL);
																}
																BgL_arg7031z00_9032 =
																	MAKE_YOUNG_PAIR(BgL_arg7033z00_9034,
																	BgL_arg7034z00_9035);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), ((obj_t) BgL_arg7030z00_9031),
																((BgL_typez00_bglt) BgL_typez00_9025),
																BgL_arg7031z00_9032, BgL_stackz00_29,
																BgL_locz00_9021, BgL_sitez00_31);
														}
													else
														{	/* Ast/sexp.scm 618 */
															obj_t BgL_arg7037z00_9038;

															BgL_arg7037z00_9038 =
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_28, BgL_locz00_9021);
															{	/* Ast/sexp.scm 616 */
																BgL_nodez00_bglt BgL_res7916z00_13515;

																{	/* Ast/sexp.scm 717 */
																	obj_t BgL_arg7100z00_13511;
																	BgL_nodez00_bglt BgL_arg7101z00_13512;

																	BgL_arg7100z00_13511 =
																		BGl_shapez00zztools_shapez00
																		(BGl_currentzd2functionzd2zztools_errorz00
																		());
																	BgL_arg7101z00_13512 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 4)), BNIL,
																		BgL_arg7037z00_9038,
																		CNST_TABLE_REF(((long) 2)));
																	{	/* Ast/sexp.scm 716 */
																		obj_t BgL_list7102z00_13514;

																		BgL_list7102z00_13514 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_arg7101z00_13512), BNIL);
																		BgL_res7916z00_13515 =
																			((BgL_nodez00_bglt)
																			BGl_userzd2errorzf2locationz20zztools_errorz00
																			(BgL_arg7037z00_9038,
																				BgL_arg7100z00_13511,
																				BGl_string7992z00zzast_sexpz00,
																				BgL_expz00_28, BgL_list7102z00_13514));
																}}
																return BgL_res7916z00_13515;
															}
														}
												}
											else
												{	/* Ast/sexp.scm 611 */
													if ((BgL_idz00_9024 == CNST_TABLE_REF(((long) 22))))
														{	/* Ast/sexp.scm 611 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																((BgL_typez00_bglt) BgL_typez00_9025),
																BgL_expz00_28, BgL_stackz00_29, BgL_locz00_9021,
																BgL_sitez00_31);
														}
													else
														{	/* Ast/sexp.scm 611 */
															if (
																(BgL_idz00_9024 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 625 */
																	bool_t BgL_testz00_29295;

																	{	/* Ast/sexp.scm 625 */
																		obj_t BgL_tmpz00_29296;

																		BgL_tmpz00_29296 =
																			CDR(((obj_t) BgL_expz00_28));
																		BgL_testz00_29295 = PAIRP(BgL_tmpz00_29296);
																	}
																	if (BgL_testz00_29295)
																		{	/* Ast/sexp.scm 629 */
																			BgL_feffectz00_bglt BgL_arg7043z00_9044;
																			obj_t BgL_arg7044z00_9045;

																			{	/* Ast/sexp.scm 629 */
																				obj_t BgL_arg7045z00_9046;

																				{	/* Ast/sexp.scm 629 */
																					obj_t BgL_pairz00_13525;

																					BgL_pairz00_13525 =
																						CDR(((obj_t) BgL_expz00_28));
																					BgL_arg7045z00_9046 =
																						CAR(BgL_pairz00_13525);
																				}
																				BgL_arg7043z00_9044 =
																					BGl_parsezd2effectzd2zzeffect_feffectz00
																					(BgL_arg7045z00_9046);
																			}
																			{	/* Ast/sexp.scm 630 */
																				obj_t BgL_arg7046z00_9047;
																				obj_t BgL_arg7047z00_9048;

																				{	/* Ast/sexp.scm 630 */
																					obj_t BgL_arg7048z00_9049;

																					BgL_arg7048z00_9049 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 34)), BNIL);
																					BgL_arg7046z00_9047 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 35)),
																						BgL_arg7048z00_9049);
																				}
																				{	/* Ast/sexp.scm 630 */
																					obj_t BgL_auxz00_29308;

																					{	/* Ast/sexp.scm 630 */
																						obj_t BgL_pairz00_13529;

																						BgL_pairz00_13529 =
																							CDR(((obj_t) BgL_expz00_28));
																						BgL_auxz00_29308 =
																							CDR(BgL_pairz00_13529);
																					}
																					BgL_arg7047z00_9048 =
																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																						(BgL_auxz00_29308, BNIL);
																				}
																				BgL_arg7044z00_9045 =
																					MAKE_YOUNG_PAIR(BgL_arg7046z00_9047,
																					BgL_arg7047z00_9048);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				((obj_t) BgL_arg7043z00_9044),
																				((BgL_typez00_bglt) BgL_typez00_9025),
																				BgL_arg7044z00_9045, BgL_stackz00_29,
																				BgL_locz00_9021, BgL_sitez00_31);
																		}
																	else
																		{	/* Ast/sexp.scm 628 */
																			obj_t BgL_arg7050z00_9051;

																			BgL_arg7050z00_9051 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_28, BgL_locz00_9021);
																			{	/* Ast/sexp.scm 626 */
																				BgL_nodez00_bglt BgL_res7920z00_13535;

																				{	/* Ast/sexp.scm 717 */
																					obj_t BgL_arg7100z00_13531;
																					BgL_nodez00_bglt BgL_arg7101z00_13532;

																					BgL_arg7100z00_13531 =
																						BGl_shapez00zztools_shapez00
																						(BGl_currentzd2functionzd2zztools_errorz00
																						());
																					BgL_arg7101z00_13532 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(CNST_TABLE_REF(((long) 4)), BNIL,
																						BgL_arg7050z00_9051,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 716 */
																						obj_t BgL_list7102z00_13534;

																						BgL_list7102z00_13534 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_arg7101z00_13532),
																							BNIL);
																						BgL_res7920z00_13535 =
																							((BgL_nodez00_bglt)
																							BGl_userzd2errorzf2locationz20zztools_errorz00
																							(BgL_arg7050z00_9051,
																								BgL_arg7100z00_13531,
																								BGl_string7993z00zzast_sexpz00,
																								BgL_expz00_28,
																								BgL_list7102z00_13534));
																				}}
																				return BgL_res7920z00_13535;
																			}
																		}
																}
															else
																{	/* Ast/sexp.scm 611 */
																	if (
																		(BgL_idz00_9024 ==
																			CNST_TABLE_REF(((long) 3))))
																		{
																			obj_t BgL_argsz00_9054;
																			obj_t BgL_bodyz00_9055;

																			if (PAIRP(BgL_expz00_28))
																				{	/* Ast/sexp.scm 633 */
																					obj_t BgL_cdrzd262418zd2_9060;

																					BgL_cdrzd262418zd2_9060 =
																						CDR(BgL_expz00_28);
																					if (PAIRP(BgL_cdrzd262418zd2_9060))
																						{	/* Ast/sexp.scm 633 */
																							BgL_argsz00_9054 =
																								CAR(BgL_cdrzd262418zd2_9060);
																							BgL_bodyz00_9055 =
																								CDR(BgL_cdrzd262418zd2_9060);
																							{	/* Ast/sexp.scm 635 */
																								obj_t BgL_locz00_9064;

																								BgL_locz00_9064 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_28,
																									BgL_locz00_9021);
																								{	/* Ast/sexp.scm 635 */
																									obj_t BgL_funz00_9065;

																									BgL_funz00_9065 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													3))));
																									{	/* Ast/sexp.scm 636 */
																										obj_t BgL_tfunz00_9066;

																										if (BGl_bigloozd2typezf3z21zztype_typez00(((BgL_typez00_bglt) BgL_typez00_9025)))
																											{	/* Ast/sexp.scm 638 */
																												obj_t
																													BgL_arg7067z00_9077;
																												BgL_arg7067z00_9077 =
																													(((BgL_typez00_bglt)
																														COBJECT((
																																(BgL_typez00_bglt)
																																BgL_typez00_9025)))->
																													BgL_idz00);
																												BgL_tfunz00_9066 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_funz00_9065,
																													BgL_arg7067z00_9077);
																											}
																										else
																											{	/* Ast/sexp.scm 637 */
																												BgL_tfunz00_9066 =
																													BgL_funz00_9065;
																											}
																										{	/* Ast/sexp.scm 637 */

																											{	/* Ast/sexp.scm 641 */
																												obj_t
																													BgL_arg7057z00_9067;
																												{	/* Ast/sexp.scm 641 */
																													obj_t
																														BgL_arg7058z00_9068;
																													obj_t
																														BgL_arg7059z00_9069;
																													BgL_arg7058z00_9068 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 641 */
																														obj_t
																															BgL_arg7060z00_9070;
																														obj_t
																															BgL_arg7061z00_9071;
																														{	/* Ast/sexp.scm 641 */
																															obj_t
																																BgL_arg7062z00_9072;
																															{	/* Ast/sexp.scm 641 */
																																obj_t
																																	BgL_arg7063z00_9073;
																																{	/* Ast/sexp.scm 641 */
																																	obj_t
																																		BgL_arg7064z00_9074;
																																	BgL_arg7064z00_9074
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_9055),
																																		BNIL);
																																	BgL_arg7063z00_9073
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_argsz00_9054,
																																		BgL_arg7064z00_9074);
																																}
																																BgL_arg7062z00_9072
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_tfunz00_9066,
																																	BgL_arg7063z00_9073);
																															}
																															BgL_arg7060z00_9070
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_arg7062z00_9072,
																																BNIL);
																														}
																														BgL_arg7061z00_9071
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_funz00_9065,
																															BNIL);
																														BgL_arg7059z00_9069
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg7060z00_9070,
																															BgL_arg7061z00_9071);
																													}
																													BgL_arg7057z00_9067 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg7058z00_9068,
																														BgL_arg7059z00_9069);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg7057z00_9067,
																													BgL_stackz00_29,
																													BgL_locz00_9064,
																													BgL_sitez00_31);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 633 */
																						BgL_tagzd262411zd2_9057:
																							{	/* Ast/sexp.scm 647 */
																								BgL_nodez00_bglt
																									BgL_res7922z00_13544;
																								{	/* Ast/sexp.scm 717 */
																									obj_t BgL_arg7100z00_13540;
																									BgL_nodez00_bglt
																										BgL_arg7101z00_13541;
																									BgL_arg7100z00_13540 =
																										BGl_shapez00zztools_shapez00
																										(BGl_currentzd2functionzd2zztools_errorz00
																										());
																									BgL_arg7101z00_13541 =
																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																										(CNST_TABLE_REF(((long) 4)),
																										BNIL, BgL_locz00_9021,
																										CNST_TABLE_REF(((long) 2)));
																									{	/* Ast/sexp.scm 716 */
																										obj_t BgL_list7102z00_13543;

																										BgL_list7102z00_13543 =
																											MAKE_YOUNG_PAIR(
																											((obj_t)
																												BgL_arg7101z00_13541),
																											BNIL);
																										BgL_res7922z00_13544 =
																											((BgL_nodez00_bglt)
																											BGl_userzd2errorzf2locationz20zztools_errorz00
																											(BgL_locz00_9021,
																												BgL_arg7100z00_13540,
																												BGl_string7994z00zzast_sexpz00,
																												BgL_expz00_28,
																												BgL_list7102z00_13543));
																								}}
																								return BgL_res7922z00_13544;
																							}
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 633 */
																					goto BgL_tagzd262411zd2_9057;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 611 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_28, BgL_stackz00_29,
																				BgL_locz00_9021, BgL_sitez00_31);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 606 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_28,
							BgL_stackz00_29, BgL_locz00_9021, BgL_sitez00_31);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_32, obj_t BgL_stackz00_33, obj_t BgL_locz00_34,
		obj_t BgL_sitez00_35)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 655 */
			{
				obj_t BgL_expsz00_9081;
				obj_t BgL_resz00_9082;
				obj_t BgL_locz00_9083;

				BgL_expsz00_9081 = BgL_expza2za2_32;
				BgL_resz00_9082 = BNIL;
				BgL_locz00_9083 = BgL_locz00_34;
			BgL_zc3anonymousza37069ze3z83_9084:
				if (NULLP(BgL_expsz00_9081))
					{	/* Ast/sexp.scm 661 */
						BgL_nodez00_bglt BgL_res7926z00_13556;

						{	/* Ast/sexp.scm 717 */
							obj_t BgL_arg7100z00_13552;
							BgL_nodez00_bglt BgL_arg7101z00_13553;

							BgL_arg7100z00_13552 =
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00());
							BgL_arg7101z00_13553 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
								BNIL, BgL_locz00_9083, CNST_TABLE_REF(((long) 2)));
							{	/* Ast/sexp.scm 716 */
								obj_t BgL_list7102z00_13555;

								BgL_list7102z00_13555 =
									MAKE_YOUNG_PAIR(((obj_t) BgL_arg7101z00_13553), BNIL);
								BgL_res7926z00_13556 =
									((BgL_nodez00_bglt)
									BGl_userzd2errorzf2locationz20zztools_errorz00
									(BgL_locz00_9083, BgL_arg7100z00_13552,
										BGl_string7995z00zzast_sexpz00, BgL_expsz00_9081,
										BgL_list7102z00_13555));
						}}
						return ((obj_t) BgL_res7926z00_13556);
					}
				else
					{	/* Ast/sexp.scm 660 */
						if (NULLP(CDR(((obj_t) BgL_expsz00_9081))))
							{	/* Ast/sexp.scm 663 */
								obj_t BgL_locz00_9088;
								obj_t BgL_nsitez00_9089;

								{	/* Ast/sexp.scm 663 */
									obj_t BgL_arg7076z00_9093;
									obj_t BgL_arg7077z00_9094;

									BgL_arg7076z00_9093 = CAR(((obj_t) BgL_expsz00_9081));
									BgL_arg7077z00_9094 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9081, BgL_locz00_9083);
									BgL_locz00_9088 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7076z00_9093, BgL_arg7077z00_9094);
								}
								if ((BgL_sitez00_35 == CNST_TABLE_REF(((long) 33))))
									{	/* Ast/sexp.scm 665 */
										BgL_nsitez00_9089 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 665 */
										BgL_nsitez00_9089 = BgL_sitez00_35;
									}
								{	/* Ast/sexp.scm 666 */
									obj_t BgL_arg7073z00_9090;

									{	/* Ast/sexp.scm 666 */
										BgL_nodez00_bglt BgL_arg7074z00_9091;

										{	/* Ast/sexp.scm 666 */
											obj_t BgL_arg7075z00_9092;

											BgL_arg7075z00_9092 = CAR(((obj_t) BgL_expsz00_9081));
											BgL_arg7074z00_9091 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7075z00_9092,
												BgL_stackz00_33, BgL_locz00_9088, BgL_nsitez00_9089);
										}
										BgL_arg7073z00_9090 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7074z00_9091), BgL_resz00_9082);
									}
									return bgl_reverse_bang(BgL_arg7073z00_9090);
								}
							}
						else
							{	/* Ast/sexp.scm 668 */
								obj_t BgL_locz00_9096;

								{	/* Ast/sexp.scm 668 */
									obj_t BgL_arg7083z00_9101;
									obj_t BgL_arg7084z00_9102;

									BgL_arg7083z00_9101 = CAR(((obj_t) BgL_expsz00_9081));
									BgL_arg7084z00_9102 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9081, BgL_locz00_9083);
									BgL_locz00_9096 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7083z00_9101, BgL_arg7084z00_9102);
								}
								{	/* Ast/sexp.scm 670 */
									obj_t BgL_arg7079z00_9097;
									obj_t BgL_arg7080z00_9098;

									BgL_arg7079z00_9097 = CDR(((obj_t) BgL_expsz00_9081));
									{	/* Ast/sexp.scm 671 */
										BgL_nodez00_bglt BgL_arg7081z00_9099;

										{	/* Ast/sexp.scm 671 */
											obj_t BgL_arg7082z00_9100;

											BgL_arg7082z00_9100 = CAR(((obj_t) BgL_expsz00_9081));
											BgL_arg7081z00_9099 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7082z00_9100,
												BgL_stackz00_33, BgL_locz00_9096,
												CNST_TABLE_REF(((long) 2)));
										}
										BgL_arg7080z00_9098 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7081z00_9099), BgL_resz00_9082);
									}
									{
										obj_t BgL_locz00_29412;
										obj_t BgL_resz00_29411;
										obj_t BgL_expsz00_29410;

										BgL_expsz00_29410 = BgL_arg7079z00_9097;
										BgL_resz00_29411 = BgL_arg7080z00_9098;
										BgL_locz00_29412 = BgL_locz00_9096;
										BgL_locz00_9083 = BgL_locz00_29412;
										BgL_resz00_9082 = BgL_resz00_29411;
										BgL_expsz00_9081 = BgL_expsz00_29410;
										goto BgL_zc3anonymousza37069ze3z83_9084;
									}
								}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &sexp*->node */
	obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t BgL_envz00_13711,
		obj_t BgL_expza2za2_13712, obj_t BgL_stackz00_13713, obj_t BgL_locz00_13714,
		obj_t BgL_sitez00_13715)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 655 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_13712,
				BgL_stackz00_13713, BgL_locz00_13714, BgL_sitez00_13715);
		}
		BGL_FUNCTION_END;
	}



/* find-local */
	BGL_EXPORTED_DEF obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t BgL_namez00_36,
		obj_t BgL_stackz00_37)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 684 */
			{	/* Ast/sexp.scm 685 */
				bool_t BgL_testz00_29414;

				if ((BgL_namez00_36 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 685 */
						BgL_testz00_29414 =
							(BgL_stackz00_37 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 685 */
						BgL_testz00_29414 = ((bool_t) 0);
					}
				if (BgL_testz00_29414)
					{	/* Ast/sexp.scm 685 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 685 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_36;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_37;
						{
							obj_t BgL_stackz00_9108;

							BgL_stackz00_9108 = BgL_stackz00_37;
						BgL_zc3anonymousza37088ze3z83_9109:
							if (NULLP(BgL_stackz00_9108))
								{	/* Ast/sexp.scm 692 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 692 */
									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(
																	((obj_t) BgL_stackz00_9108))))))->
												BgL_idz00) == BgL_namez00_36))
										{	/* Ast/sexp.scm 695 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(((obj_t) BgL_stackz00_9108));
											return CAR(((obj_t) BgL_stackz00_9108));
										}
									else
										{	/* Ast/sexp.scm 699 */
											obj_t BgL_arg7093z00_9114;

											BgL_arg7093z00_9114 = CDR(((obj_t) BgL_stackz00_9108));
											{
												obj_t BgL_stackz00_29433;

												BgL_stackz00_29433 = BgL_arg7093z00_9114;
												BgL_stackz00_9108 = BgL_stackz00_29433;
												goto BgL_zc3anonymousza37088ze3z83_9109;
											}
										}
								}
						}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &find-local */
	obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t BgL_envz00_13716,
		obj_t BgL_namez00_13717, obj_t BgL_stackz00_13718)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 684 */
			return
				BGl_findzd2localzd2zzast_sexpz00(BgL_namez00_13717, BgL_stackz00_13718);
		}
		BGL_FUNCTION_END;
	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_38,
		obj_t BgL_locz00_39, obj_t BgL_sitez00_40)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 704 */
			if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 7))))
				{	/* Ast/sexp.scm 707 */
					obj_t BgL_vz00_13571;

					BgL_vz00_13571 = CNST_TABLE_REF(((long) 36));
					((((BgL_variablez00_bglt) COBJECT(BgL_varz00_38))->BgL_accessz00) =
						((obj_t) BgL_vz00_13571), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 706 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 708 */
				BgL_valuez00_bglt BgL_valz00_9120;

				BgL_valz00_9120 =
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_38))->BgL_valuez00);
				{	/* Ast/sexp.scm 709 */
					bool_t BgL_testz00_29441;

					if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 7))))
						{	/* Ast/sexp.scm 709 */
							bool_t BgL_res7929z00_13573;

							BgL_res7929z00_13573 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_9120), BGl_funz00zzast_varz00);
							BgL_testz00_29441 = BgL_res7929z00_13573;
						}
					else
						{	/* Ast/sexp.scm 709 */
							BgL_testz00_29441 = ((bool_t) 0);
						}
					if (BgL_testz00_29441)
						{	/* Ast/sexp.scm 710 */
							obj_t BgL_arg7099z00_9123;

							BgL_arg7099z00_9123 =
								BGl_shapez00zztools_shapez00(((obj_t) BgL_varz00_38));
							{	/* Ast/sexp.scm 710 */
								BgL_nodez00_bglt BgL_res7930z00_13579;

								{	/* Ast/sexp.scm 717 */
									obj_t BgL_arg7100z00_13575;
									BgL_nodez00_bglt BgL_arg7101z00_13576;

									BgL_arg7100z00_13575 =
										BGl_shapez00zztools_shapez00
										(BGl_currentzd2functionzd2zztools_errorz00());
									BgL_arg7101z00_13576 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												4)), BNIL, BgL_locz00_39, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 716 */
										obj_t BgL_list7102z00_13578;

										BgL_list7102z00_13578 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7101z00_13576), BNIL);
										BgL_res7930z00_13579 =
											((BgL_nodez00_bglt)
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_locz00_39, BgL_arg7100z00_13575,
												BGl_string7996z00zzast_sexpz00, BgL_arg7099z00_9123,
												BgL_list7102z00_13578));
								}}
								return ((obj_t) BgL_res7930z00_13579);
							}
						}
					else
						{	/* Ast/sexp.scm 709 */
							return BFALSE;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &use-variable! */
	obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t BgL_envz00_13719,
		obj_t BgL_varz00_13720, obj_t BgL_locz00_13721, obj_t BgL_sitez00_13722)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 704 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_varz00_13720), BgL_locz00_13721,
				BgL_sitez00_13722);
		}
		BGL_FUNCTION_END;
	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_41,
		obj_t BgL_expz00_42, obj_t BgL_locz00_43)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 715 */
			{	/* Ast/sexp.scm 717 */
				obj_t BgL_arg7100z00_9125;
				BgL_nodez00_bglt BgL_arg7101z00_9126;

				BgL_arg7100z00_9125 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg7101z00_9126 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)), BNIL,
					BgL_locz00_43, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 716 */
					obj_t BgL_list7102z00_9127;

					BgL_list7102z00_9127 =
						MAKE_YOUNG_PAIR(((obj_t) BgL_arg7101z00_9126), BNIL);
					return
						((BgL_nodez00_bglt)
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_43,
							BgL_arg7100z00_9125, BgL_msgz00_41, BgL_expz00_42,
							BgL_list7102z00_9127));
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &error-sexp->node */
	BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13723, obj_t BgL_msgz00_13724, obj_t BgL_expz00_13725,
		obj_t BgL_locz00_13726)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 715 */
			return
				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_13724,
				BgL_expz00_13725, BgL_locz00_13726);
		}
		BGL_FUNCTION_END;
	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_44, BgL_nodez00_bglt BgL_refz00_45)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 725 */
			{	/* Ast/sexp.scm 726 */
				BgL_nodez00_bglt BgL_funz00_9129;

				BgL_funz00_9129 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 37)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 727 */
					bool_t BgL_testz00_29474;

					{	/* Ast/sexp.scm 727 */
						bool_t BgL_res7931z00_13580;

						BgL_res7931z00_13580 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9129), BGl_varz00zzast_nodez00);
						BgL_testz00_29474 = BgL_res7931z00_13580;
					}
					if (BgL_testz00_29474)
						{	/* Ast/sexp.scm 728 */
							BgL_appz00_bglt BgL_new1151z00_9131;

							{	/* Ast/sexp.scm 728 */
								BgL_appz00_bglt BgL_new1150z00_9138;

								BgL_new1150z00_9138 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 728 */
									long BgL_arg7111z00_9139;

									{	/* Ast/sexp.scm 728 */
										long BgL_res7932z00_13582;

										BgL_res7932z00_13582 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7111z00_9139 = BgL_res7932z00_13582;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1150z00_9138),
										BgL_arg7111z00_9139);
								}
								{	/* Ast/sexp.scm 728 */
									BgL_objectz00_bglt BgL_tmpz00_29481;

									BgL_tmpz00_29481 = ((BgL_objectz00_bglt) BgL_new1150z00_9138);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29481, BFALSE);
								}
								BgL_new1151z00_9131 = BgL_new1150z00_9138;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1151z00_9131)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1151z00_9131)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1151z00_9131)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1151z00_9131)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1151z00_9131))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9129)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29496;

								{	/* Ast/sexp.scm 731 */
									BgL_nodez00_bglt BgL_arg7105z00_9132;

									{	/* Ast/sexp.scm 731 */
										obj_t BgL_arg7108z00_9135;

										{	/* Ast/sexp.scm 731 */
											obj_t BgL_arg7109z00_9136;

											{	/* Ast/sexp.scm 731 */
												obj_t BgL_arg7110z00_9137;

												BgL_arg7110z00_9137 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_44)))->
													BgL_idz00);
												BgL_arg7109z00_9136 =
													MAKE_YOUNG_PAIR(BgL_arg7110z00_9137, BNIL);
											}
											BgL_arg7108z00_9135 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7109z00_9136);
										}
										BgL_arg7105z00_9132 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7108z00_9135,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									{	/* Ast/sexp.scm 731 */
										obj_t BgL_list7106z00_9133;

										{	/* Ast/sexp.scm 731 */
											obj_t BgL_arg7107z00_9134;

											BgL_arg7107z00_9134 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_refz00_45), BNIL);
											BgL_list7106z00_9133 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7105z00_9132), BgL_arg7107z00_9134);
										}
										BgL_auxz00_29496 = BgL_list7106z00_9133;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1151z00_9131))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29496), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1151z00_9131);
						}
					else
						{	/* Ast/sexp.scm 727 */
							return BgL_funz00_9129;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &define-primop-ref->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13727, obj_t BgL_globalz00_13728, obj_t BgL_refz00_13729)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 725 */
			return
				BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13728),
				((BgL_nodez00_bglt) BgL_refz00_13729));
		}
		BGL_FUNCTION_END;
	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_46)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 737 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_46), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 739 */
				BgL_nodez00_bglt BgL_funz00_9140;

				BgL_funz00_9140 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 38)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 740 */
					bool_t BgL_testz00_29519;

					{	/* Ast/sexp.scm 740 */
						bool_t BgL_res7934z00_13587;

						BgL_res7934z00_13587 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9140), BGl_varz00zzast_nodez00);
						BgL_testz00_29519 = BgL_res7934z00_13587;
					}
					if (BgL_testz00_29519)
						{	/* Ast/sexp.scm 741 */
							BgL_appz00_bglt BgL_new1153z00_9142;

							{	/* Ast/sexp.scm 741 */
								BgL_appz00_bglt BgL_new1152z00_9150;

								BgL_new1152z00_9150 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 741 */
									long BgL_arg7120z00_9151;

									{	/* Ast/sexp.scm 741 */
										long BgL_res7935z00_13589;

										BgL_res7935z00_13589 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7120z00_9151 = BgL_res7935z00_13589;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1152z00_9150),
										BgL_arg7120z00_9151);
								}
								{	/* Ast/sexp.scm 741 */
									BgL_objectz00_bglt BgL_tmpz00_29526;

									BgL_tmpz00_29526 = ((BgL_objectz00_bglt) BgL_new1152z00_9150);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29526, BFALSE);
								}
								BgL_new1153z00_9142 = BgL_new1152z00_9150;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1153z00_9142)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1153z00_9142)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1153z00_9142)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1153z00_9142)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1153z00_9142))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9140)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29541;

								{	/* Ast/sexp.scm 744 */
									BgL_nodez00_bglt BgL_arg7113z00_9143;
									BgL_nodez00_bglt BgL_arg7114z00_9144;

									{	/* Ast/sexp.scm 744 */
										obj_t BgL_arg7117z00_9147;

										{	/* Ast/sexp.scm 744 */
											obj_t BgL_arg7118z00_9148;

											{	/* Ast/sexp.scm 744 */
												obj_t BgL_arg7119z00_9149;

												BgL_arg7119z00_9149 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_46)))->
													BgL_idz00);
												BgL_arg7118z00_9148 =
													MAKE_YOUNG_PAIR(BgL_arg7119z00_9149, BNIL);
											}
											BgL_arg7117z00_9147 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7118z00_9148);
										}
										BgL_arg7113z00_9143 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7117z00_9147,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									BgL_arg7114z00_9144 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(
										((obj_t) BgL_globalz00_46), BNIL, BFALSE,
										CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 744 */
										obj_t BgL_list7115z00_9145;

										{	/* Ast/sexp.scm 744 */
											obj_t BgL_arg7116z00_9146;

											BgL_arg7116z00_9146 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7114z00_9144), BNIL);
											BgL_list7115z00_9145 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7113z00_9143), BgL_arg7116z00_9146);
										}
										BgL_auxz00_29541 = BgL_list7115z00_9145;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1153z00_9142))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29541), BUNSPEC);
							}
							return ((BgL_nodez00_bglt) BgL_new1153z00_9142);
						}
					else
						{	/* Ast/sexp.scm 740 */
							return BgL_funz00_9140;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &define-primop->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13730, obj_t BgL_globalz00_13731)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 737 */
			return
				BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13731));
		}
		BGL_FUNCTION_END;
	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_47)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 751 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_47), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 753 */
				BgL_nodez00_bglt BgL_funz00_9152;

				BgL_funz00_9152 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 39)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 754 */
					bool_t BgL_testz00_29566;

					{	/* Ast/sexp.scm 754 */
						bool_t BgL_res7937z00_13594;

						BgL_res7937z00_13594 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9152), BGl_varz00zzast_nodez00);
						BgL_testz00_29566 = BgL_res7937z00_13594;
					}
					if (BgL_testz00_29566)
						{	/* Ast/sexp.scm 755 */
							obj_t BgL_exprz00_9154;

							{	/* Ast/sexp.scm 755 */
								bool_t BgL_testz00_29569;

								{	/* Ast/sexp.scm 755 */
									obj_t BgL_arg7129z00_9164;

									BgL_arg7129z00_9164 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									BgL_testz00_29569 =
										(((BgL_backendz00_bglt) COBJECT(
												((BgL_backendz00_bglt) BgL_arg7129z00_9164)))->
										BgL_pragmazd2supportzd2);
								}
								if (BgL_testz00_29569)
									{	/* Ast/sexp.scm 756 */
										obj_t BgL_arg7127z00_9162;

										{	/* Ast/sexp.scm 756 */
											obj_t BgL_arg7128z00_9163;

											BgL_arg7128z00_9163 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_globalz00_47), BNIL);
											BgL_arg7127z00_9162 =
												MAKE_YOUNG_PAIR(BGl_string7997z00zzast_sexpz00,
												BgL_arg7128z00_9163);
										}
										BgL_exprz00_9154 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 40)),
											BgL_arg7127z00_9162);
									}
								else
									{	/* Ast/sexp.scm 755 */
										BgL_exprz00_9154 = ((obj_t) BgL_globalz00_47);
									}
							}
							{	/* Ast/sexp.scm 758 */
								BgL_appz00_bglt BgL_new1156z00_9155;

								{	/* Ast/sexp.scm 758 */
									BgL_appz00_bglt BgL_new1155z00_9158;

									BgL_new1155z00_9158 =
										((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_appz00_bgl))));
									{	/* Ast/sexp.scm 758 */
										long BgL_arg7124z00_9159;

										{	/* Ast/sexp.scm 758 */
											long BgL_res7939z00_13599;

											BgL_res7939z00_13599 =
												BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
											BgL_arg7124z00_9159 = BgL_res7939z00_13599;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1155z00_9158),
											BgL_arg7124z00_9159);
									}
									{	/* Ast/sexp.scm 758 */
										BgL_objectz00_bglt BgL_tmpz00_29583;

										BgL_tmpz00_29583 =
											((BgL_objectz00_bglt) BgL_new1155z00_9158);
										BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29583, BFALSE);
									}
									BgL_new1156z00_9155 = BgL_new1155z00_9158;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1156z00_9155)))->
										BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
								((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
													BgL_new1156z00_9155)))->BgL_typez00) =
									((BgL_typez00_bglt)
										BGl_strictzd2nodezd2typez00zzast_nodez00(((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00),
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00))),
									BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1156z00_9155)))->BgL_sidezd2effectzd2) =
									((obj_t) BUNSPEC), BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1156z00_9155)))->BgL_keyz00) =
									((obj_t) BINT(((long) -1))), BUNSPEC);
								((((BgL_appz00_bglt) COBJECT(BgL_new1156z00_9155))->
										BgL_funz00) =
									((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9152)),
									BUNSPEC);
								{
									obj_t BgL_auxz00_29600;

									{	/* Ast/sexp.scm 761 */
										BgL_nodez00_bglt BgL_arg7122z00_9156;

										BgL_arg7122z00_9156 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_9154, BNIL,
											BFALSE, CNST_TABLE_REF(((long) 2)));
										{	/* Ast/sexp.scm 761 */
											obj_t BgL_list7123z00_9157;

											BgL_list7123z00_9157 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7122z00_9156), BNIL);
											BgL_auxz00_29600 = BgL_list7123z00_9157;
									}}
									((((BgL_appz00_bglt) COBJECT(BgL_new1156z00_9155))->
											BgL_argsz00) = ((obj_t) BgL_auxz00_29600), BUNSPEC);
								}
								return ((BgL_nodez00_bglt) BgL_new1156z00_9155);
							}
						}
					else
						{	/* Ast/sexp.scm 754 */
							return BgL_funz00_9152;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &location->node */
	BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13732, obj_t BgL_globalz00_13733)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 751 */
			return
				BGl_locationzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13733));
		}
		BGL_FUNCTION_END;
	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_48, obj_t BgL_prefz00_49)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 767 */
			{	/* Ast/sexp.scm 768 */
				obj_t BgL_prefz00_9165;

				{	/* Ast/sexp.scm 768 */
					bool_t BgL_testz00_29609;

					if (PAIRP(BgL_prefz00_49))
						{	/* Ast/sexp.scm 768 */
							obj_t BgL_tmpz00_29612;

							BgL_tmpz00_29612 = CAR(BgL_prefz00_49);
							BgL_testz00_29609 = STRINGP(BgL_tmpz00_29612);
						}
					else
						{	/* Ast/sexp.scm 768 */
							BgL_testz00_29609 = ((bool_t) 0);
						}
					if (BgL_testz00_29609)
						{	/* Ast/sexp.scm 768 */
							BgL_prefz00_9165 = CAR(BgL_prefz00_49);
						}
					else
						{	/* Ast/sexp.scm 768 */
							BgL_prefz00_9165 = BGl_string7998z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 771 */
					bool_t BgL_testz00_29616;

					if (STRUCTP(BgL_locz00_48))
						{	/* Ast/sexp.scm 771 */
							BgL_testz00_29616 =
								(STRUCT_KEY(BgL_locz00_48) == CNST_TABLE_REF(((long) 41)));
						}
					else
						{	/* Ast/sexp.scm 771 */
							BgL_testz00_29616 = ((bool_t) 0);
						}
					if (BgL_testz00_29616)
						{	/* Ast/sexp.scm 772 */
							obj_t BgL_filez00_9167;
							obj_t BgL_linez00_9168;
							obj_t BgL_basez00_9169;

							BgL_filez00_9167 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_48);
							BgL_linez00_9168 = STRUCT_REF(BgL_locz00_48, (int) (((long) 2)));
							{	/* Ast/sexp.scm 774 */
								obj_t BgL_arg7153z00_9198;

								BgL_arg7153z00_9198 =
									BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
									(BGl_string7999z00zzast_sexpz00, BgL_prefz00_9165,
										BGl_string8000z00zzast_sexpz00));
								{	/* Ast/sexp.scm 774 */
									obj_t BgL_res7945z00_13615;

									{	/* Ast/sexp.scm 774 */
										obj_t BgL_arg1419z00_13614;

										BgL_arg1419z00_13614 =
											SYMBOL_TO_STRING(BgL_arg7153z00_9198);
										BgL_res7945z00_13615 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1419z00_13614);
									}
									BgL_basez00_9169 = BgL_res7945z00_13615;
							}}
							{	/* Ast/sexp.scm 776 */
								bool_t BgL_testz00_29629;

								{	/* Ast/sexp.scm 776 */
									bool_t BgL_testz00_29630;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 1)))
										{	/* Ast/sexp.scm 777 */
											obj_t BgL_arg7151z00_9196;

											{	/* Ast/sexp.scm 777 */
												obj_t BgL_arg7152z00_9197;

												BgL_arg7152z00_9197 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												BgL_arg7151z00_9196 =
													(((BgL_backendz00_bglt) COBJECT(
															((BgL_backendz00_bglt) BgL_arg7152z00_9197)))->
													BgL_debugzd2supportzd2);
											}
											BgL_testz00_29630 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 42)), BgL_arg7151z00_9196));
										}
									else
										{	/* Ast/sexp.scm 776 */
											BgL_testz00_29630 = ((bool_t) 0);
										}
									if (BgL_testz00_29630)
										{	/* Ast/sexp.scm 776 */
											BgL_testz00_29629 = ((bool_t) 1);
										}
									else
										{	/* Ast/sexp.scm 776 */
											BgL_testz00_29629 =
												(
												(long)
												CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >=
												((long) 1));
								}}
								if (BgL_testz00_29629)
									{	/* Ast/sexp.scm 779 */
										obj_t BgL_filez00_9178;

										if (bigloo_strncmp(BgL_filez00_9167,
												BGl_string8001z00zzast_sexpz00, ((long) 2)))
											{	/* Ast/sexp.scm 779 */
												BgL_filez00_9178 =
													c_substring(BgL_filez00_9167, ((long) 2),
													STRING_LENGTH(BgL_filez00_9167));
											}
										else
											{	/* Ast/sexp.scm 779 */
												BgL_filez00_9178 = BgL_filez00_9167;
											}
										{	/* Ast/sexp.scm 784 */
											obj_t BgL_arg7138z00_9179;

											{	/* Ast/sexp.scm 784 */
												obj_t BgL_arg7139z00_9180;
												obj_t BgL_arg7140z00_9181;

												BgL_arg7139z00_9180 =
													BGl_stringzd2replacezd2zz__r4_strings_6_7z00
													(BgL_filez00_9178, (char) (((unsigned char) '.')),
													(char) (((unsigned char) ',')));
												{	/* Ast/sexp.scm 785 */

													BgL_arg7140z00_9181 =
														BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
														(BgL_linez00_9168, BINT(((long) 10)));
												}
												{	/* Ast/sexp.scm 783 */
													obj_t BgL_list7141z00_9182;

													{	/* Ast/sexp.scm 783 */
														obj_t BgL_arg7142z00_9183;

														{	/* Ast/sexp.scm 783 */
															obj_t BgL_arg7143z00_9184;

															{	/* Ast/sexp.scm 783 */
																obj_t BgL_arg7144z00_9185;

																{	/* Ast/sexp.scm 783 */
																	obj_t BgL_arg7145z00_9186;

																	{	/* Ast/sexp.scm 783 */
																		obj_t BgL_arg7146z00_9187;

																		BgL_arg7146z00_9187 =
																			MAKE_YOUNG_PAIR
																			(BGl_string8002z00zzast_sexpz00, BNIL);
																		BgL_arg7145z00_9186 =
																			MAKE_YOUNG_PAIR(BgL_arg7140z00_9181,
																			BgL_arg7146z00_9187);
																	}
																	BgL_arg7144z00_9185 =
																		MAKE_YOUNG_PAIR
																		(BGl_string8000z00zzast_sexpz00,
																		BgL_arg7145z00_9186);
																}
																BgL_arg7143z00_9184 =
																	MAKE_YOUNG_PAIR(BgL_arg7139z00_9180,
																	BgL_arg7144z00_9185);
															}
															BgL_arg7142z00_9183 =
																MAKE_YOUNG_PAIR(BGl_string8000z00zzast_sexpz00,
																BgL_arg7143z00_9184);
														}
														BgL_list7141z00_9182 =
															MAKE_YOUNG_PAIR(BgL_basez00_9169,
															BgL_arg7142z00_9183);
													}
													BgL_arg7138z00_9179 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list7141z00_9182);
											}}
											return bstring_to_symbol(BgL_arg7138z00_9179);
										}
									}
								else
									{	/* Ast/sexp.scm 788 */
										obj_t BgL_arg7149z00_9192;

										BgL_arg7149z00_9192 =
											BGl_stringzd2replacezd2zz__r4_strings_6_7z00(string_append
											(BgL_basez00_9169, BGl_string8002z00zzast_sexpz00),
											(char) (((unsigned char) '.')),
											(char) (((unsigned char) ',')));
										{	/* Ast/sexp.scm 788 */
											obj_t BgL_res7953z00_13634;

											BgL_res7953z00_13634 =
												bstring_to_symbol(((obj_t) BgL_arg7149z00_9192));
											return BgL_res7953z00_13634;
										}
									}
							}
						}
					else
						{	/* Ast/sexp.scm 789 */
							obj_t BgL_arg7155z00_9200;

							{	/* Ast/sexp.scm 789 */
								obj_t BgL_arg7156z00_9201;
								obj_t BgL_arg7157z00_9202;

								{	/* Ast/sexp.scm 789 */
									obj_t BgL_arg7158z00_9203;

									BgL_arg7158z00_9203 =
										BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
										(BGl_string7999z00zzast_sexpz00, BgL_prefz00_9165,
											BGl_string8003z00zzast_sexpz00));
									{	/* Ast/sexp.scm 789 */
										obj_t BgL_res7954z00_13637;

										{	/* Ast/sexp.scm 789 */
											obj_t BgL_arg1419z00_13636;

											BgL_arg1419z00_13636 =
												SYMBOL_TO_STRING(BgL_arg7158z00_9203);
											BgL_res7954z00_13637 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1419z00_13636);
										}
										BgL_arg7156z00_9201 = BgL_res7954z00_13637;
									}
								}
								{	/* Ast/sexp.scm 789 */
									obj_t BgL_res7955z00_13640;

									{	/* Ast/sexp.scm 789 */
										obj_t BgL_symbolz00_13638;

										BgL_symbolz00_13638 = CNST_TABLE_REF(((long) 43));
										{	/* Ast/sexp.scm 789 */
											obj_t BgL_arg1419z00_13639;

											BgL_arg1419z00_13639 =
												SYMBOL_TO_STRING(BgL_symbolz00_13638);
											BgL_res7955z00_13640 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1419z00_13639);
									}}
									BgL_arg7157z00_9202 = BgL_res7955z00_13640;
								}
								BgL_arg7155z00_9200 =
									string_append(BgL_arg7156z00_9201, BgL_arg7157z00_9202);
							}
							return bstring_to_symbol(BgL_arg7155z00_9200);
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &make-anonymous-name */
	obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t BgL_envz00_13734,
		obj_t BgL_locz00_13735, obj_t BgL_prefz00_13736)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 767 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_13735,
				BgL_prefz00_13736);
		}
		BGL_FUNCTION_END;
	}



/* synchronize->node */
	BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t
		BgL_expz00_50, obj_t BgL_mutexz00_51, obj_t BgL_prelockz00_52,
		obj_t BgL_bodyz00_53, obj_t BgL_stackz00_54, obj_t BgL_locz00_55,
		obj_t BgL_sitez00_56)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 794 */
			if (SYMBOLP(BgL_mutexz00_51))
				{	/* Ast/sexp.scm 796 */
					BgL_syncz00_bglt BgL_new1158z00_9211;

					{	/* Ast/sexp.scm 797 */
						BgL_syncz00_bglt BgL_new1157z00_9213;

						BgL_new1157z00_9213 =
							((BgL_syncz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_syncz00_bgl))));
						{	/* Ast/sexp.scm 797 */
							long BgL_arg7166z00_9214;

							{	/* Ast/sexp.scm 797 */
								long BgL_res7958z00_13645;

								BgL_res7958z00_13645 =
									BGL_CLASS_INDEX(BGl_syncz00zzast_nodez00);
								BgL_arg7166z00_9214 = BgL_res7958z00_13645;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1157z00_9213),
								BgL_arg7166z00_9214);
						}
						{	/* Ast/sexp.scm 797 */
							BgL_objectz00_bglt BgL_tmpz00_29681;

							BgL_tmpz00_29681 = ((BgL_objectz00_bglt) BgL_new1157z00_9213);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29681, BFALSE);
						}
						BgL_new1158z00_9211 = BgL_new1157z00_9213;
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_new1158z00_9211)))->BgL_locz00) =
						((obj_t) BgL_locz00_55), BUNSPEC);
					((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
										BgL_new1158z00_9211)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt)
								BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1158z00_9211))->BgL_mutexz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_mutexz00_51,
								BgL_stackz00_54, BgL_locz00_55, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1158z00_9211))->BgL_prelockz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_prelockz00_52,
								BgL_stackz00_54, BgL_locz00_55, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					{
						BgL_nodez00_bglt BgL_auxz00_29695;

						{	/* Ast/sexp.scm 801 */
							obj_t BgL_arg7165z00_9212;

							BgL_arg7165z00_9212 =
								BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_53);
							BgL_auxz00_29695 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7165z00_9212,
								BgL_stackz00_54, BgL_locz00_55, BgL_sitez00_56);
						}
						((((BgL_syncz00_bglt) COBJECT(BgL_new1158z00_9211))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_29695), BUNSPEC);
					}
					return ((BgL_nodez00_bglt) BgL_new1158z00_9211);
				}
			else
				{	/* Ast/sexp.scm 802 */
					obj_t BgL_vz00_9215;

					BgL_vz00_9215 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 44))));
					{	/* Ast/sexp.scm 802 */
						obj_t BgL_varz00_9216;

						BgL_varz00_9216 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_9215,
							CNST_TABLE_REF(((long) 44)));
						{	/* Ast/sexp.scm 803 */
							obj_t BgL_nexpz00_9217;

							{	/* Ast/sexp.scm 804 */
								obj_t BgL_arg7174z00_9225;

								{	/* Ast/sexp.scm 804 */
									obj_t BgL_arg7175z00_9226;

									BgL_arg7175z00_9226 =
										MAKE_YOUNG_PAIR(BgL_vz00_9215,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_bodyz00_53, BNIL));
									BgL_arg7174z00_9225 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 29)),
										BgL_arg7175z00_9226);
								}
								BgL_nexpz00_9217 =
									BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg7174z00_9225,
									BgL_expz00_50);
							}
							{	/* Ast/sexp.scm 804 */

								{	/* Ast/sexp.scm 805 */
									obj_t BgL_arg7167z00_9218;

									{	/* Ast/sexp.scm 805 */
										obj_t BgL_arg7168z00_9219;
										obj_t BgL_arg7169z00_9220;

										BgL_arg7168z00_9219 = BGl_letzd2symzd2zzast_letz00();
										{	/* Ast/sexp.scm 805 */
											obj_t BgL_arg7170z00_9221;
											obj_t BgL_arg7171z00_9222;

											{	/* Ast/sexp.scm 805 */
												obj_t BgL_arg7172z00_9223;

												{	/* Ast/sexp.scm 805 */
													obj_t BgL_arg7173z00_9224;

													BgL_arg7173z00_9224 =
														MAKE_YOUNG_PAIR(BgL_mutexz00_51, BNIL);
													BgL_arg7172z00_9223 =
														MAKE_YOUNG_PAIR(BgL_varz00_9216,
														BgL_arg7173z00_9224);
												}
												BgL_arg7170z00_9221 =
													MAKE_YOUNG_PAIR(BgL_arg7172z00_9223, BNIL);
											}
											BgL_arg7171z00_9222 =
												MAKE_YOUNG_PAIR(BgL_nexpz00_9217, BNIL);
											BgL_arg7169z00_9220 =
												MAKE_YOUNG_PAIR(BgL_arg7170z00_9221,
												BgL_arg7171z00_9222);
										}
										BgL_arg7167z00_9218 =
											MAKE_YOUNG_PAIR(BgL_arg7168z00_9219, BgL_arg7169z00_9220);
									}
									BGl_replacez12z12zztools_miscz00(BgL_expz00_50,
										BgL_arg7167z00_9218);
								}
								return
									BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_50,
									BgL_stackz00_54, BgL_locz00_55, BgL_sitez00_56);
							}
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* not-test */
	obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t BgL_testz00_57)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 814 */
			{
				obj_t BgL_bindingsz00_9233;
				obj_t BgL_exprz00_9234;

				if (PAIRP(BgL_testz00_57))
					{	/* Ast/sexp.scm 815 */
						obj_t BgL_cdrzd262435zd2_9239;

						BgL_cdrzd262435zd2_9239 = CDR(BgL_testz00_57);
						if ((CAR(BgL_testz00_57) == CNST_TABLE_REF(((long) 1))))
							{	/* Ast/sexp.scm 815 */
								if (PAIRP(BgL_cdrzd262435zd2_9239))
									{	/* Ast/sexp.scm 815 */
										obj_t BgL_cdrzd262438zd2_9243;

										BgL_cdrzd262438zd2_9243 = CDR(BgL_cdrzd262435zd2_9239);
										if (PAIRP(BgL_cdrzd262438zd2_9243))
											{	/* Ast/sexp.scm 815 */
												obj_t BgL_cdrzd262441zd2_9245;

												BgL_cdrzd262441zd2_9245 = CDR(BgL_cdrzd262438zd2_9243);
												if ((CAR(BgL_cdrzd262438zd2_9243) == BFALSE))
													{	/* Ast/sexp.scm 815 */
														if (PAIRP(BgL_cdrzd262441zd2_9245))
															{	/* Ast/sexp.scm 815 */
																if ((CAR(BgL_cdrzd262441zd2_9245) == BTRUE))
																	{	/* Ast/sexp.scm 815 */
																		if (NULLP(CDR(BgL_cdrzd262441zd2_9245)))
																			{	/* Ast/sexp.scm 815 */
																				return CAR(BgL_cdrzd262435zd2_9239);
																			}
																		else
																			{	/* Ast/sexp.scm 815 */
																				return BFALSE;
																			}
																	}
																else
																	{	/* Ast/sexp.scm 815 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 815 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 815 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 815 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 815 */
										return BFALSE;
									}
							}
						else
							{	/* Ast/sexp.scm 815 */
								if ((CAR(BgL_testz00_57) == CNST_TABLE_REF(((long) 45))))
									{	/* Ast/sexp.scm 815 */
										if (PAIRP(BgL_cdrzd262435zd2_9239))
											{	/* Ast/sexp.scm 815 */
												if (NULLP(CDR(BgL_cdrzd262435zd2_9239)))
													{	/* Ast/sexp.scm 815 */
														return CAR(BgL_cdrzd262435zd2_9239);
													}
												else
													{	/* Ast/sexp.scm 815 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 815 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 815 */
										obj_t BgL_cdrzd262515zd2_9265;

										BgL_cdrzd262515zd2_9265 = CDR(BgL_testz00_57);
										if ((CAR(BgL_testz00_57) == CNST_TABLE_REF(((long) 17))))
											{	/* Ast/sexp.scm 815 */
												if (PAIRP(BgL_cdrzd262515zd2_9265))
													{	/* Ast/sexp.scm 815 */
														obj_t BgL_cdrzd262519zd2_9269;

														BgL_cdrzd262519zd2_9269 =
															CDR(BgL_cdrzd262515zd2_9265);
														if (PAIRP(BgL_cdrzd262519zd2_9269))
															{	/* Ast/sexp.scm 815 */
																if (NULLP(CDR(BgL_cdrzd262519zd2_9269)))
																	{	/* Ast/sexp.scm 815 */
																		BgL_bindingsz00_9233 =
																			CAR(BgL_cdrzd262515zd2_9265);
																		BgL_exprz00_9234 =
																			CAR(BgL_cdrzd262519zd2_9269);
																		{	/* Ast/sexp.scm 821 */
																			obj_t BgL_ntz00_9279;

																			BgL_ntz00_9279 =
																				BGl_notzd2testzd2zzast_sexpz00
																				(BgL_exprz00_9234);
																			if (CBOOL(BgL_ntz00_9279))
																				{	/* Ast/sexp.scm 823 */
																					obj_t BgL_arg7213z00_9280;

																					{	/* Ast/sexp.scm 823 */
																						obj_t BgL_arg7214z00_9281;

																						{	/* Ast/sexp.scm 823 */
																							obj_t BgL_arg7215z00_9282;

																							BgL_arg7215z00_9282 =
																								MAKE_YOUNG_PAIR(BgL_ntz00_9279,
																								BNIL);
																							BgL_arg7214z00_9281 =
																								MAKE_YOUNG_PAIR
																								(BgL_bindingsz00_9233,
																								BgL_arg7215z00_9282);
																						}
																						BgL_arg7213z00_9280 =
																							MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																									(long) 17)),
																							BgL_arg7214z00_9281);
																					}
																					return
																						BGl_epairifyzd2reczd2zztools_miscz00
																						(BgL_arg7213z00_9280,
																						BgL_testz00_57);
																				}
																			else
																				{	/* Ast/sexp.scm 822 */
																					return BFALSE;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 815 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 815 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 815 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 815 */
												return BFALSE;
											}
									}
							}
					}
				else
					{	/* Ast/sexp.scm 815 */
						return BFALSE;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* used-in? */
	bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t BgL_idz00_58,
		obj_t BgL_exprz00_59)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 832 */
			if ((BgL_idz00_58 == BgL_exprz00_59))
				{	/* Ast/sexp.scm 834 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 834 */
					if (PAIRP(BgL_exprz00_59))
						{	/* Ast/sexp.scm 835 */
							if ((CAR(BgL_exprz00_59) == CNST_TABLE_REF(((long) 12))))
								{	/* Ast/sexp.scm 836 */
									return ((bool_t) 0);
								}
							else
								{	/* Ast/sexp.scm 836 */
									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00
										(BgL_exprz00_59))
										{
											obj_t BgL_list1472z00_9299;

											{	/* Ast/sexp.scm 838 */
												obj_t BgL_tmpz00_29787;

												BgL_list1472z00_9299 = BgL_exprz00_59;
											BgL_zc3anonymousza37226ze3z83_9300:
												if (PAIRP(BgL_list1472z00_9299))
													{	/* Ast/sexp.scm 838 */
														if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_58,
																CAR(BgL_list1472z00_9299)))
															{	/* Ast/sexp.scm 838 */
																BgL_tmpz00_29787 = CAR(BgL_list1472z00_9299);
															}
														else
															{
																obj_t BgL_list1472z00_29794;

																BgL_list1472z00_29794 =
																	CDR(BgL_list1472z00_9299);
																BgL_list1472z00_9299 = BgL_list1472z00_29794;
																goto BgL_zc3anonymousza37226ze3z83_9300;
															}
													}
												else
													{	/* Ast/sexp.scm 838 */
														BgL_tmpz00_29787 = BFALSE;
													}
												return CBOOL(BgL_tmpz00_29787);
											}
										}
									else
										{	/* Ast/sexp.scm 837 */
											return ((bool_t) 0);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 835 */
							return ((bool_t) 0);
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 301998274),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867955),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 173709144),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 428035925),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 156774043),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 129879154),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 419066125),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 277780830),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 135263837),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_objectz00(((long) 520121776),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string8004z00zzast_sexpz00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
