/*===========================================================================*/
/*   (Cfa/specialize.scm)                                                    */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/specialize.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_specializa7edzd2globalz75_bgl
	{
		obj_t BgL_fixz00;
	}                                *BgL_specializa7edzd2globalz75_bglt;


	static obj_t BGl_z62patchz12zd2funcall1395za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BUNSPEC;
	static BgL_appz00_bglt
		BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7(BgL_appz00_bglt);
	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_z62patchz12zd2kwote1381za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_z62patchz12zd2conditional1403za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t
		BGl_za2optimzd2cfazd2fixnumzd2arithmeticzf3za2z21zzengine_paramz00;
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzcfa_specializa7eza7();
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_za2brealza2z00zztype_cachez00;
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_za2specializa7ationszd2overflowza2z75zzcfa_specializa7eza7 =
		BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_specializa7ez12zb5zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_getzd2specializa7ationsz75zzcfa_specializa7eza7();
	static obj_t BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7();
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t
		BGl_za2specializa7ationszd2sanszd2overflowza2za7zzcfa_specializa7eza7 =
		BUNSPEC;
	static obj_t BGl_z62patchz12zd2fail1405za2zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_patchzd2funz12zc0zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	static obj_t BGl_z62specializa7ez12zd7zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62patchz12zd2cast1399za2zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t BGl_patchz12z12zzcfa_specializa7eza7(BgL_nodez00_bglt);
	static BgL_appz00_bglt
		BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(BgL_appz00_bglt);
	static obj_t BGl_patchza2z12zb0zzcfa_specializa7eza7(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzcfa_specializa7eza7();
	static obj_t BGl_z62zc3anonymousza31853ze3ze1zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_za2arithmeticzd2overflowza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2boxzd2ref1421z70zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62arithmeticzd2operatorzf3z43zzcfa_specializa7eza7(obj_t,
		obj_t);
	static BgL_globalz00_bglt BGl_z62lambda1848z62zzcfa_specializa7eza7(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_globalz00_bglt BGl_z62lambda1851z62zzcfa_specializa7eza7(obj_t,
		obj_t);
	static BgL_globalz00_bglt BGl_z62lambda1854z62zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	BGL_EXPORTED_DECL obj_t
		BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(BgL_globalz00_bglt);
	static obj_t BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t BGl_z62lambda1863z62zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_z62lambda1864z62zzcfa_specializa7eza7(obj_t, obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2closure1385za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_normaliza7ezd2getzd2typeze70z40zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static bool_t BGl_patchzd2treez12zc0zzcfa_specializa7eza7(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzcfa_specializa7eza7();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_z62patchz12zd2switch1407za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_z62patchz121376z70zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2atom1379za2zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	static obj_t BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
	extern obj_t
		BGl_za2optimzd2cfazd2flonumzd2arithmeticzf3za2z21zzengine_paramz00;
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	static obj_t
		BGl_z62patchz12zd2jumpzd2exzd2it1415za2zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2appzd2ly1393z70zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_z62patchz12zd2boxzd2setz121419z62zzcfa_specializa7eza7(obj_t,
		obj_t);
	static bool_t BGl_showzd2specializa7ez75zzcfa_specializa7eza7();
	static obj_t BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2makezd2box1417z70zzcfa_specializa7eza7(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2letzd2fun1409z70zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_za2realza2z00zztype_cachez00;
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7 =
		BUNSPEC;
	static obj_t BGl_z62patchz12zd2extern1397za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt,
		bool_t);
	static obj_t BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_z62patchz12zd2var1383za2zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2setq1401za2zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2app1423za2zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(BgL_globalz00_bglt);
	static bool_t BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7();
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t
		BGl_z62patchz12zd2setzd2exzd2it1413za2zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_specializa7eza7(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_specializa7edzd2globalz75zzcfa_specializa7eza7 = BUNSPEC;
	extern obj_t BGl_nodez00zzast_nodez00;
	static obj_t BGl_z62arithmeticzd2speczd2typesz62zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7();
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7();
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62patchz12zd2sync1391za2zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t
		BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_z62patchz12zd2letzd2var1411z70zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_z62patchz12zd2sequence1387za2zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_valuez00zzast_varz00;
	extern obj_t BGl_za2bintza2z00zztype_cachez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_za2bcharza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 =
		BUNSPEC;
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t
		BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_z62patchz12z70zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2068z00zzcfa_specializa7eza7,
		BgL_bgl_za762lambda1864za7622107z00,
		BGl_z62lambda1864z62zzcfa_specializa7eza7, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2069z00zzcfa_specializa7eza7,
		BgL_bgl_za762lambda1863za7622108z00,
		BGl_z62lambda1863z62zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2070z00zzcfa_specializa7eza7,
		BgL_bgl_za762lambda1854za7622109z00,
		BGl_z62lambda1854z62zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2071z00zzcfa_specializa7eza7,
		BgL_bgl_za762za7c3anonymousza72110za7,
		BGl_z62zc3anonymousza31853ze3ze1zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2072z00zzcfa_specializa7eza7,
		BgL_bgl_za762lambda1851za7622111z00,
		BGl_z62lambda1851z62zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2073z00zzcfa_specializa7eza7,
		BgL_bgl_za762lambda1848za7622112z00,
		BGl_z62lambda1848z62zzcfa_specializa7eza7, 0L, BUNSPEC, 21);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2075z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza7121376za72113za7,
		BGl_z62patchz121376z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2078z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2at2114za7,
		BGl_z62patchz12zd2atom1379za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2080z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2kw2115za7,
		BGl_z62patchz12zd2kwote1381za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2081z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2va2116za7,
		BGl_z62patchz12zd2var1383za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2082z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2cl2117za7,
		BGl_z62patchz12zd2closure1385za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2083z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2se2118za7,
		BGl_z62patchz12zd2sequence1387za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2084z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2sy2119za7,
		BGl_z62patchz12zd2sync1391za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2085z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2ap2120za7,
		BGl_z62patchz12zd2appzd2ly1393z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2086z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2fu2121za7,
		BGl_z62patchz12zd2funcall1395za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2087z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2ex2122za7,
		BGl_z62patchz12zd2extern1397za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2088z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2ca2123za7,
		BGl_z62patchz12zd2cast1399za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2089z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2se2124za7,
		BGl_z62patchz12zd2setq1401za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2090z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2co2125za7,
		BGl_z62patchz12zd2conditional1403za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2091z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2fa2126za7,
		BGl_z62patchz12zd2fail1405za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2092z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2sw2127za7,
		BGl_z62patchz12zd2switch1407za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2093z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2le2128za7,
		BGl_z62patchz12zd2letzd2fun1409z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2094z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2le2129za7,
		BGl_z62patchz12zd2letzd2var1411z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2095z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2se2130za7,
		BGl_z62patchz12zd2setzd2exzd2it1413za2zzcfa_specializa7eza7, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2096z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2ju2131za7,
		BGl_z62patchz12zd2jumpzd2exzd2it1415za2zzcfa_specializa7eza7, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2097z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2ma2132za7,
		BGl_z62patchz12zd2makezd2box1417z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2098z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2bo2133za7,
		BGl_z62patchz12zd2boxzd2setz121419z62zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2099z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2bo2134za7,
		BGl_z62patchz12zd2boxzd2ref1421z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_arithmeticzd2operatorzf3zd2envzf3zzcfa_specializa7eza7,
		BgL_bgl_za762arithmeticza7d22135z00,
		BGl_z62arithmeticzd2operatorzf3z43zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_specializa7ez12zd2envz67zzcfa_specializa7eza7,
		BgL_bgl_za762specializa7a7eza72136za7,
		BGl_z62specializa7ez12zd7zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2100z00zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za7d2ap2137za7,
		BGl_z62patchz12zd2app1423za2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_arithmeticzd2speczd2typeszd2envzd2zzcfa_specializa7eza7,
		BgL_bgl_za762arithmeticza7d22138z00,
		BGl_z62arithmeticzd2speczd2typesz62zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2056z00zzcfa_specializa7eza7,
		BgL_bgl_string2056za700za7za7c2139za7, "   . Specializing", 17);
	      DEFINE_STRING(BGl_string2057z00zzcfa_specializa7eza7,
		BgL_bgl_string2057za700za7za7c2140za7, ")\n", 2);
	      DEFINE_STRING(BGl_string2058z00zzcfa_specializa7eza7,
		BgL_bgl_string2058za700za7za7c2141za7, ": ", 2);
	      DEFINE_STRING(BGl_string2059z00zzcfa_specializa7eza7,
		BgL_bgl_string2059za700za7za7c2142za7, "        (-> ", 12);
	      DEFINE_STRING(BGl_string2060z00zzcfa_specializa7eza7,
		BgL_bgl_string2060za700za7za7c2143za7, "        (eq? ", 13);
	      DEFINE_STRING(BGl_string2061z00zzcfa_specializa7eza7,
		BgL_bgl_string2061za700za7za7c2144za7, "add-specialized-type!", 21);
	      DEFINE_STRING(BGl_string2062z00zzcfa_specializa7eza7,
		BgL_bgl_string2062za700za7za7c2145za7, "Unspecialized type", 18);
	      DEFINE_STRING(BGl_string2063z00zzcfa_specializa7eza7,
		BgL_bgl_string2063za700za7za7c2146za7, "install-specialize", 18);
	      DEFINE_STRING(BGl_string2064z00zzcfa_specializa7eza7,
		BgL_bgl_string2064za700za7za7c2147za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string2065z00zzcfa_specializa7eza7,
		BgL_bgl_string2065za700za7za7c2148za7, " -- ", 4);
	      DEFINE_STRING(BGl_string2066z00zzcfa_specializa7eza7,
		BgL_bgl_string2066za700za7za7c2149za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string2067z00zzcfa_specializa7eza7,
		BgL_bgl_string2067za700za7za7c2150za7, "install-specialize!", 19);
	      DEFINE_STRING(BGl_string2074z00zzcfa_specializa7eza7,
		BgL_bgl_string2074za700za7za7c2151za7, "", 0);
	      DEFINE_STRING(BGl_string2076z00zzcfa_specializa7eza7,
		BgL_bgl_string2076za700za7za7c2152za7, "patch!1376", 10);
	      DEFINE_STRING(BGl_string2077z00zzcfa_specializa7eza7,
		BgL_bgl_string2077za700za7za7c2153za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string2079z00zzcfa_specializa7eza7,
		BgL_bgl_string2079za700za7za7c2154za7, "patch!", 6);
	      DEFINE_STATIC_BGL_GENERIC(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
		BgL_bgl_za762patchza712za770za7za72155za7,
		BGl_z62patchz12z70zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string2101z00zzcfa_specializa7eza7,
		BgL_bgl_string2101za700za7za7c2156za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string2102z00zzcfa_specializa7eza7,
		BgL_bgl_string2102za700za7za7c2157za7, "cfa_specialize", 14);
	      DEFINE_STRING(BGl_string2103z00zzcfa_specializa7eza7,
		BgL_bgl_string2103za700za7za7c2158za7,
		"patch!1376 _ cfa_specialize specialized-global obj fix done c-eq? c-boxed-eq? foreign __r4_numbers_6_5_flonum __r4_numbers_6_5_fixnum ((|2+| (|2+| __r4_numbers_6_5) (+fl __r4_numbers_6_5_flonum) (+fx __r4_numbers_6_5_fixnum)) (|2-| (|2-| __r4_numbers_6_5) (-fl __r4_numbers_6_5_flonum) (-fx __r4_numbers_6_5_fixnum)) (2* (2* __r4_numbers_6_5) (*fl __r4_numbers_6_5_flonum) (*fx __r4_numbers_6_5_fixnum)) (abs (abs __r4_numbers_6_5) (absfl __r4_numbers_6_5_flonum) (absfx __r4_numbers_6_5_fixnum))) ((|2+| (|2+| __r4_numbers_6_5) (+fl __r4_numbers_6_5_flonum)) (|2-| (|2-| __r4_numbers_6_5) (-fl __r4_numbers_6_5_flonum)) (2* (2* __r4_numbers_6_5) (*fl __r4_numbers_6_5_flonum)) (2/ (2/ __r4_numbers_6_5) (/fl __r4_numbers_6_5_flonum)) (abs (abs __r4_numbers_6_5) (absfl __r4_numbers_6_5_flonum)) (c-eq? (c-eq? foreign) (=fx __r4_numbers_6_5_fixnum) (=fl __r4_numbers_6_5_flonum)) (2= (2= __r4_numbers_6_5) (=fx __r4_numbers_6_5_fixnum) (=fl __r4_numbers_6_5_flonum)) (2< (2< __r4_numbers_6_5) (<fx __r4_numbers_6_5_fixnum) ("
		"<fl __r4_numbers_6_5_flonum)) (2> (2> __r4_numbers_6_5) (>fx __r4_numbers_6_5_fixnum) (>fl __r4_numbers_6_5_flonum)) (2<= (2<= __r4_numbers_6_5) (<=fx __r4_numbers_6_5_fixnum) (<=fl __r4_numbers_6_5_flonum)) (2>= (2>= __r4_numbers_6_5) (>=fx __r4_numbers_6_5_fixnum) (>=fl __r4_numbers_6_5_flonum)) (zero? (zero? __r4_numbers_6_5) (zerofx? __r4_numbers_6_5_fixnum) (zerofl? __r4_numbers_6_5_flonum)) (positive? (positive? __r4_numbers_6_5) (positivefx? __r4_numbers_6_5_fixnum) (positivefl? __r4_numbers_6_5_flonum)) (negative? (negative? __r4_numbers_6_5) (negativefx? __r4_numbers_6_5_fixnum) (negativefl? __r4_numbers_6_5_flonum)) (log (log __r4_numbers_6_5) (logfl __r4_numbers_6_5_flonum)) (exp (exp __r4_numbers_6_5) (expfl __r4_numbers_6_5_flonum)) (sin (sin __r4_numbers_6_5) (sinfl __r4_numbers_6_5_flonum)) (cos (cos __r4_numbers_6_5) (cosfl __r4_numbers_6_5_flonum)) (tan (tan __r4_numbers_6_5) (tanfl __r4_numbers_6_5_flonum)) (atan (atan __r4_numbers_6_5) (atanfl __r4_numbers_6_5_flonum)) (asin (asin __r4_numb"
		"ers_6_5) (asinfl __r4_numbers_6_5_flonum)) (acos (acos __r4_numbers_6_5) (acosfl __r4_numbers_6_5_flonum)) (sqrt (sqrt __r4_numbers_6_5) (sqrtfl __r4_numbers_6_5_flonum))) ",
		2220);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2specializa7eza2za7zzcfa_specializa7eza7));
		   
			 ADD_ROOT((void
				*) (&BGl_za2specializa7ationszd2overflowza2z75zzcfa_specializa7eza7));
		     ADD_ROOT((void
				*)
			(&BGl_za2specializa7ationszd2sanszd2overflowza2za7zzcfa_specializa7eza7));
		     ADD_ROOT((void
				*) (&BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7));
		     ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7));
		     ADD_ROOT((void *) (&BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7));
		     ADD_ROOT((void *) (&BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7));
		   
			 ADD_ROOT((void
				*) (&BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7));
		     ADD_ROOT((void
				*) (&BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
		     ADD_ROOT((void
				*) (&BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_specializa7eza7(long
		BgL_checksumz00_2846, char *BgL_fromz00_2847)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7))
				{
					BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcfa_specializa7eza7();
					BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7();
					BGl_cnstzd2initzd2zzcfa_specializa7eza7();
					BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7();
					BGl_objectzd2initzd2zzcfa_specializa7eza7();
					BGl_genericzd2initzd2zzcfa_specializa7eza7();
					BGl_methodzd2initzd2zzcfa_specializa7eza7();
					return BGl_toplevelzd2initzd2zzcfa_specializa7eza7();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_specialize");
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			{	/* Cfa/specialize.scm 19 */
				obj_t BgL_cportz00_2724;

				{	/* Cfa/specialize.scm 19 */
					obj_t BgL_stringz00_2732;

					BgL_stringz00_2732 = BGl_string2103z00zzcfa_specializa7eza7;
					{	/* Cfa/specialize.scm 19 */
						obj_t BgL_startz00_2733;

						BgL_startz00_2733 = BINT(((long) 0));
						{	/* Cfa/specialize.scm 19 */
							obj_t BgL_endz00_2734;

							BgL_endz00_2734 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2732)));
							{	/* Cfa/specialize.scm 19 */

								BgL_cportz00_2724 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2732, BgL_startz00_2733, BgL_endz00_2734);
				}}}}
				{
					long BgL_iz00_2725;

					BgL_iz00_2725 = ((long) 13);
				BgL_loopz00_2726:
					if ((BgL_iz00_2725 == ((long) -1)))
						{	/* Cfa/specialize.scm 19 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/specialize.scm 19 */
							{	/* Cfa/specialize.scm 19 */
								obj_t BgL_arg2105z00_2728;

								{	/* Cfa/specialize.scm 19 */

									{	/* Cfa/specialize.scm 19 */
										obj_t BgL_locationz00_2730;

										BgL_locationz00_2730 = BBOOL(((bool_t) 0));
										{	/* Cfa/specialize.scm 19 */

											BgL_arg2105z00_2728 =
												BGl_readz00zz__readerz00(BgL_cportz00_2724,
												BgL_locationz00_2730);
										}
									}
								}
								{	/* Cfa/specialize.scm 19 */
									int BgL_tmpz00_2877;

									BgL_tmpz00_2877 = (int) (BgL_iz00_2725);
									CNST_TABLE_SET(BgL_tmpz00_2877, BgL_arg2105z00_2728);
							}}
							{	/* Cfa/specialize.scm 19 */
								int BgL_auxz00_2731;

								BgL_auxz00_2731 = (int) ((BgL_iz00_2725 - ((long) 1)));
								{
									long BgL_iz00_2882;

									BgL_iz00_2882 = (long) (BgL_auxz00_2731);
									BgL_iz00_2725 = BgL_iz00_2882;
									goto BgL_loopz00_2726;
								}
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 = BFALSE;
			BGl_za2specializa7ationszd2sanszd2overflowza2za7zzcfa_specializa7eza7 =
				CNST_TABLE_REF(((long) 0));
			BGl_za2specializa7ationszd2overflowza2z75zzcfa_specializa7eza7 =
				CNST_TABLE_REF(((long) 1));
			BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
			BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BNIL;
			BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 = BNIL;
			BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7 = BNIL;
			BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
			return BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
		}
		BGL_FUNCTION_END;
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzcfa_specializa7eza7(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		BGL_FUNCTION_BEGIN;
		{
			{
				obj_t BgL_headz00_1575;

				BgL_headz00_1575 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_1576;
					obj_t BgL_tailz00_1577;

					BgL_prevz00_1576 = BgL_headz00_1575;
					BgL_tailz00_1577 = BgL_l1z00_1;
				BgL_loopz00_1578:
					if (PAIRP(BgL_tailz00_1577))
						{
							obj_t BgL_newzd2prevzd2_1580;

							BgL_newzd2prevzd2_1580 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_1577), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_1576, BgL_newzd2prevzd2_1580);
							{
								obj_t BgL_tailz00_2894;
								obj_t BgL_prevz00_2893;

								BgL_prevz00_2893 = BgL_newzd2prevzd2_1580;
								BgL_tailz00_2894 = CDR(BgL_tailz00_1577);
								BgL_tailz00_1577 = BgL_tailz00_2894;
								BgL_prevz00_1576 = BgL_prevz00_2893;
								goto BgL_loopz00_1578;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_1575);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* specialize! */
	BGL_EXPORTED_DEF obj_t BGl_specializa7ez12zb5zzcfa_specializa7eza7(obj_t
		BgL_globalsz00_88)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 44 */
			if (BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7())
				{	/* Cfa/specialize.scm 45 */
					{	/* Cfa/specialize.scm 47 */
						obj_t BgL_g1356z00_1590;

						BgL_g1356z00_1590 =
							BGl_getzd2specializa7ationsz75zzcfa_specializa7eza7();
						{
							obj_t BgL_l1354z00_1592;

							BgL_l1354z00_1592 = BgL_g1356z00_1590;
						BgL_zc3anonymousza31444ze3z83_1593:
							if (PAIRP(BgL_l1354z00_1592))
								{	/* Cfa/specialize.scm 47 */
									BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(CAR
										(BgL_l1354z00_1592));
									{
										obj_t BgL_l1354z00_2904;

										BgL_l1354z00_2904 = CDR(BgL_l1354z00_1592);
										BgL_l1354z00_1592 = BgL_l1354z00_2904;
										goto BgL_zc3anonymousza31444ze3z83_1593;
									}
								}
							else
								{	/* Cfa/specialize.scm 47 */
									((bool_t) 1);
								}
						}
					}
					BGl_patchzd2treez12zc0zzcfa_specializa7eza7(BgL_globalsz00_88);
					BGl_showzd2specializa7ez75zzcfa_specializa7eza7();
					BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7();
				}
			else
				{	/* Cfa/specialize.scm 45 */
					BFALSE;
				}
			return BgL_globalsz00_88;
		}
		BGL_FUNCTION_END;
	}



/* &specialize! */
	obj_t BGl_z62specializa7ez12zd7zzcfa_specializa7eza7(obj_t BgL_envz00_2608,
		obj_t BgL_globalsz00_2609)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 44 */
			return BGl_specializa7ez12zb5zzcfa_specializa7eza7(BgL_globalsz00_2609);
		}
		BGL_FUNCTION_END;
	}



/* arithmetic-operator? */
	BGL_EXPORTED_DEF obj_t
		BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(BgL_globalz00_bglt
		BgL_globalz00_89)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 56 */
			{	/* Cfa/specialize.scm 58 */
				obj_t BgL_cellz00_1599;

				{	/* Cfa/specialize.scm 58 */
					obj_t BgL_arg1501z00_1604;
					obj_t BgL_arg1506z00_1605;

					BgL_arg1501z00_1604 =
						(((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt) BgL_globalz00_89)))->BgL_idz00);
					BgL_arg1506z00_1605 =
						BGl_getzd2specializa7ationsz75zzcfa_specializa7eza7();
					BgL_cellz00_1599 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1501z00_1604,
						BgL_arg1506z00_1605);
				}
				if (PAIRP(BgL_cellz00_1599))
					{	/* Cfa/specialize.scm 59 */
						bool_t BgL_tmpz00_2916;

						{	/* Cfa/specialize.scm 59 */
							obj_t BgL_tmpz00_2917;

							{	/* Cfa/specialize.scm 59 */
								obj_t BgL_pairz00_2348;

								BgL_pairz00_2348 = CAR(CDR(BgL_cellz00_1599));
								BgL_tmpz00_2917 = CAR(CDR(BgL_pairz00_2348));
							}
							BgL_tmpz00_2916 =
								(BgL_tmpz00_2917 ==
								(((BgL_globalz00_bglt) COBJECT(BgL_globalz00_89))->
									BgL_modulez00));
						}
						return BBOOL(BgL_tmpz00_2916);
					}
				else
					{	/* Cfa/specialize.scm 59 */
						return BFALSE;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &arithmetic-operator? */
	obj_t BGl_z62arithmeticzd2operatorzf3z43zzcfa_specializa7eza7(obj_t
		BgL_envz00_2610, obj_t BgL_globalz00_2611)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 56 */
			return
				BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(
				((BgL_globalz00_bglt) BgL_globalz00_2611));
		}
		BGL_FUNCTION_END;
	}



/* arithmetic-spec-types */
	BGL_EXPORTED_DEF obj_t
		BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(BgL_globalz00_bglt
		BgL_globalz00_90)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 67 */
			{	/* Cfa/specialize.scm 69 */
				obj_t BgL_cellz00_1607;

				{	/* Cfa/specialize.scm 69 */
					obj_t BgL_arg1542z00_1632;
					obj_t BgL_arg1551z00_1633;

					BgL_arg1542z00_1632 =
						(((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt) BgL_globalz00_90)))->BgL_idz00);
					BgL_arg1551z00_1633 =
						BGl_getzd2specializa7ationsz75zzcfa_specializa7eza7();
					BgL_cellz00_1607 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1542z00_1632,
						BgL_arg1551z00_1633);
				}
				if (PAIRP(BgL_cellz00_1607))
					{	/* Cfa/specialize.scm 72 */
						obj_t BgL_g1145z00_1609;

						BgL_g1145z00_1609 = CDR(CDR(BgL_cellz00_1607));
						{
							obj_t BgL_specz00_1612;
							obj_t BgL_typesz00_1613;

							BgL_specz00_1612 = BgL_g1145z00_1609;
							BgL_typesz00_1613 = BNIL;
						BgL_zc3anonymousza31508ze3z83_1614:
							if (NULLP(BgL_specz00_1612))
								{	/* Cfa/specialize.scm 75 */
									return BgL_typesz00_1613;
								}
							else
								{	/* Cfa/specialize.scm 77 */
									bool_t BgL_testz00_2937;

									if (CBOOL
										(BGl_za2optimzd2cfazd2fixnumzd2arithmeticzf3za2z21zzengine_paramz00))
										{	/* Cfa/specialize.scm 78 */
											obj_t BgL_tmpz00_2940;

											{	/* Cfa/specialize.scm 78 */
												obj_t BgL_pairz00_2359;

												BgL_pairz00_2359 = CAR(((obj_t) BgL_specz00_1612));
												BgL_tmpz00_2940 = CAR(CDR(BgL_pairz00_2359));
											}
											BgL_testz00_2937 =
												(BgL_tmpz00_2940 == CNST_TABLE_REF(((long) 2)));
										}
									else
										{	/* Cfa/specialize.scm 77 */
											BgL_testz00_2937 = ((bool_t) 0);
										}
									if (BgL_testz00_2937)
										{	/* Cfa/specialize.scm 79 */
											obj_t BgL_arg1519z00_1619;
											obj_t BgL_arg1520z00_1620;

											BgL_arg1519z00_1619 = CDR(((obj_t) BgL_specz00_1612));
											BgL_arg1520z00_1620 =
												MAKE_YOUNG_PAIR(BGl_za2longza2z00zztype_cachez00,
												BgL_typesz00_1613);
											{
												obj_t BgL_typesz00_2951;
												obj_t BgL_specz00_2950;

												BgL_specz00_2950 = BgL_arg1519z00_1619;
												BgL_typesz00_2951 = BgL_arg1520z00_1620;
												BgL_typesz00_1613 = BgL_typesz00_2951;
												BgL_specz00_1612 = BgL_specz00_2950;
												goto BgL_zc3anonymousza31508ze3z83_1614;
											}
										}
									else
										{	/* Cfa/specialize.scm 80 */
											bool_t BgL_testz00_2952;

											if (CBOOL
												(BGl_za2optimzd2cfazd2flonumzd2arithmeticzf3za2z21zzengine_paramz00))
												{	/* Cfa/specialize.scm 81 */
													obj_t BgL_tmpz00_2955;

													{	/* Cfa/specialize.scm 81 */
														obj_t BgL_pairz00_2365;

														BgL_pairz00_2365 = CAR(((obj_t) BgL_specz00_1612));
														BgL_tmpz00_2955 = CAR(CDR(BgL_pairz00_2365));
													}
													BgL_testz00_2952 =
														(BgL_tmpz00_2955 == CNST_TABLE_REF(((long) 3)));
												}
											else
												{	/* Cfa/specialize.scm 80 */
													BgL_testz00_2952 = ((bool_t) 0);
												}
											if (BgL_testz00_2952)
												{	/* Cfa/specialize.scm 82 */
													obj_t BgL_arg1531z00_1624;
													obj_t BgL_arg1532z00_1625;

													BgL_arg1531z00_1624 = CDR(((obj_t) BgL_specz00_1612));
													BgL_arg1532z00_1625 =
														MAKE_YOUNG_PAIR(BGl_za2realza2z00zztype_cachez00,
														BgL_typesz00_1613);
													{
														obj_t BgL_typesz00_2966;
														obj_t BgL_specz00_2965;

														BgL_specz00_2965 = BgL_arg1531z00_1624;
														BgL_typesz00_2966 = BgL_arg1532z00_1625;
														BgL_typesz00_1613 = BgL_typesz00_2966;
														BgL_specz00_1612 = BgL_specz00_2965;
														goto BgL_zc3anonymousza31508ze3z83_1614;
													}
												}
											else
												{	/* Cfa/specialize.scm 84 */
													obj_t BgL_arg1536z00_1626;

													BgL_arg1536z00_1626 = CDR(((obj_t) BgL_specz00_1612));
													{
														obj_t BgL_specz00_2969;

														BgL_specz00_2969 = BgL_arg1536z00_1626;
														BgL_specz00_1612 = BgL_specz00_2969;
														goto BgL_zc3anonymousza31508ze3z83_1614;
													}
												}
										}
								}
						}
					}
				else
					{	/* Cfa/specialize.scm 70 */
						return BNIL;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &arithmetic-spec-types */
	obj_t BGl_z62arithmeticzd2speczd2typesz62zzcfa_specializa7eza7(obj_t
		BgL_envz00_2612, obj_t BgL_globalz00_2613)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 67 */
			return
				BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(
				((BgL_globalz00_bglt) BgL_globalz00_2613));
		}
		BGL_FUNCTION_END;
	}



/* get-specializations */
	obj_t BGl_getzd2specializa7ationsz75zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 89 */
			if (CBOOL(BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7))
				{	/* Cfa/specialize.scm 91 */
					return BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7;
				}
			else
				{	/* Cfa/specialize.scm 91 */
					if (CBOOL(BGl_za2arithmeticzd2overflowza2zd2zzengine_paramz00))
						{	/* Cfa/specialize.scm 94 */
							BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 =
								CNST_TABLE_REF(((long) 0));
							return BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7;
						}
					else
						{	/* Cfa/specialize.scm 94 */
							BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 =
								BGl_appendzd221011zd2zzcfa_specializa7eza7(CNST_TABLE_REF((
										(long) 1)), CNST_TABLE_REF(((long) 0)));
							return BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7;
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* specialize-optimization? */
	bool_t BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 188 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 1)))
				{	/* Cfa/specialize.scm 189 */
					if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
						{	/* Cfa/specialize.scm 189 */
							return ((bool_t) 0);
						}
					else
						{	/* Cfa/specialize.scm 189 */
							return ((bool_t) 1);
						}
				}
			else
				{	/* Cfa/specialize.scm 189 */
					return ((bool_t) 0);
				}
		}
		BGL_FUNCTION_END;
	}



/* show-specialize */
	bool_t BGl_showzd2specializa7ez75zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 194 */
			{	/* Cfa/specialize.scm 195 */
				obj_t BgL_list1552z00_1635;

				{	/* Cfa/specialize.scm 195 */
					obj_t BgL_arg1555z00_1636;

					BgL_arg1555z00_1636 =
						MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
					BgL_list1552z00_1635 =
						MAKE_YOUNG_PAIR(BGl_string2056z00zzcfa_specializa7eza7,
						BgL_arg1555z00_1636);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1552z00_1635);
			}
			{
				obj_t BgL_l1357z00_1638;

				BgL_l1357z00_1638 =
					BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7;
			BgL_zc3anonymousza31556ze3z83_1639:
				if (PAIRP(BgL_l1357z00_1638))
					{	/* Cfa/specialize.scm 196 */
						{	/* Cfa/specialize.scm 197 */
							obj_t BgL_typezd2numzd2_1641;

							BgL_typezd2numzd2_1641 = CAR(BgL_l1357z00_1638);
							if (
								((long) CINT(CDR(
											((obj_t) BgL_typezd2numzd2_1641))) > ((long) 0)))
								{	/* Cfa/specialize.scm 198 */
									obj_t BgL_arg1561z00_1644;
									obj_t BgL_arg1568z00_1645;

									{	/* Cfa/specialize.scm 198 */
										obj_t BgL_arg1583z00_1651;

										BgL_arg1583z00_1651 = CAR(((obj_t) BgL_typezd2numzd2_1641));
										BgL_arg1561z00_1644 =
											BGl_shapez00zztools_shapez00(BgL_arg1583z00_1651);
									}
									BgL_arg1568z00_1645 = CDR(((obj_t) BgL_typezd2numzd2_1641));
									{	/* Cfa/specialize.scm 198 */
										obj_t BgL_list1569z00_1646;

										{	/* Cfa/specialize.scm 198 */
											obj_t BgL_arg1572z00_1647;

											{	/* Cfa/specialize.scm 198 */
												obj_t BgL_arg1575z00_1648;

												{	/* Cfa/specialize.scm 198 */
													obj_t BgL_arg1576z00_1649;

													{	/* Cfa/specialize.scm 198 */
														obj_t BgL_arg1578z00_1650;

														BgL_arg1578z00_1650 =
															MAKE_YOUNG_PAIR
															(BGl_string2057z00zzcfa_specializa7eza7, BNIL);
														BgL_arg1576z00_1649 =
															MAKE_YOUNG_PAIR(BgL_arg1568z00_1645,
															BgL_arg1578z00_1650);
													}
													BgL_arg1575z00_1648 =
														MAKE_YOUNG_PAIR
														(BGl_string2058z00zzcfa_specializa7eza7,
														BgL_arg1576z00_1649);
												}
												BgL_arg1572z00_1647 =
													MAKE_YOUNG_PAIR(BgL_arg1561z00_1644,
													BgL_arg1575z00_1648);
											}
											BgL_list1569z00_1646 =
												MAKE_YOUNG_PAIR(BGl_string2059z00zzcfa_specializa7eza7,
												BgL_arg1572z00_1647);
										}
										BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
											BgL_list1569z00_1646);
								}}
							else
								{	/* Cfa/specialize.scm 197 */
									BFALSE;
								}
						}
						{
							obj_t BgL_l1357z00_3010;

							BgL_l1357z00_3010 = CDR(BgL_l1357z00_1638);
							BgL_l1357z00_1638 = BgL_l1357z00_3010;
							goto BgL_zc3anonymousza31556ze3z83_1639;
						}
					}
				else
					{	/* Cfa/specialize.scm 196 */
						((bool_t) 1);
					}
			}
			{
				obj_t BgL_l1359z00_1656;

				BgL_l1359z00_1656 =
					BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7;
			BgL_zc3anonymousza31590ze3z83_1657:
				if (PAIRP(BgL_l1359z00_1656))
					{	/* Cfa/specialize.scm 201 */
						{	/* Cfa/specialize.scm 202 */
							obj_t BgL_typezd2numzd2_1659;

							BgL_typezd2numzd2_1659 = CAR(BgL_l1359z00_1656);
							if (
								((long) CINT(CDR(
											((obj_t) BgL_typezd2numzd2_1659))) > ((long) 0)))
								{	/* Cfa/specialize.scm 203 */
									obj_t BgL_arg1613z00_1662;
									obj_t BgL_arg1616z00_1663;

									{	/* Cfa/specialize.scm 203 */
										obj_t BgL_arg1628z00_1669;

										BgL_arg1628z00_1669 = CAR(((obj_t) BgL_typezd2numzd2_1659));
										BgL_arg1613z00_1662 =
											BGl_shapez00zztools_shapez00(BgL_arg1628z00_1669);
									}
									BgL_arg1616z00_1663 = CDR(((obj_t) BgL_typezd2numzd2_1659));
									{	/* Cfa/specialize.scm 203 */
										obj_t BgL_list1617z00_1664;

										{	/* Cfa/specialize.scm 203 */
											obj_t BgL_arg1620z00_1665;

											{	/* Cfa/specialize.scm 203 */
												obj_t BgL_arg1622z00_1666;

												{	/* Cfa/specialize.scm 203 */
													obj_t BgL_arg1623z00_1667;

													{	/* Cfa/specialize.scm 203 */
														obj_t BgL_arg1625z00_1668;

														BgL_arg1625z00_1668 =
															MAKE_YOUNG_PAIR
															(BGl_string2057z00zzcfa_specializa7eza7, BNIL);
														BgL_arg1623z00_1667 =
															MAKE_YOUNG_PAIR(BgL_arg1616z00_1663,
															BgL_arg1625z00_1668);
													}
													BgL_arg1622z00_1666 =
														MAKE_YOUNG_PAIR
														(BGl_string2058z00zzcfa_specializa7eza7,
														BgL_arg1623z00_1667);
												}
												BgL_arg1620z00_1665 =
													MAKE_YOUNG_PAIR(BgL_arg1613z00_1662,
													BgL_arg1622z00_1666);
											}
											BgL_list1617z00_1664 =
												MAKE_YOUNG_PAIR(BGl_string2060z00zzcfa_specializa7eza7,
												BgL_arg1620z00_1665);
										}
										BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
											BgL_list1617z00_1664);
								}}
							else
								{	/* Cfa/specialize.scm 202 */
									BFALSE;
								}
						}
						{
							obj_t BgL_l1359z00_3032;

							BgL_l1359z00_3032 = CDR(BgL_l1359z00_1656);
							BgL_l1359z00_1656 = BgL_l1359z00_3032;
							goto BgL_zc3anonymousza31590ze3z83_1657;
						}
					}
				else
					{	/* Cfa/specialize.scm 201 */
						return ((bool_t) 1);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* install-specialized-type! */
	obj_t BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t
		BgL_typez00_91)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 218 */
			{	/* Cfa/specialize.scm 219 */
				bool_t BgL_testz00_3034;

				{	/* Cfa/specialize.scm 219 */
					obj_t BgL_tmpz00_3035;

					BgL_tmpz00_3035 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_91,
						BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
					BgL_testz00_3034 = PAIRP(BgL_tmpz00_3035);
				}
				if (BgL_testz00_3034)
					{	/* Cfa/specialize.scm 219 */
						return BFALSE;
					}
				else
					{	/* Cfa/specialize.scm 219 */
						{	/* Cfa/specialize.scm 220 */
							obj_t BgL_arg1640z00_1675;

							BgL_arg1640z00_1675 =
								MAKE_YOUNG_PAIR(BgL_typez00_91, BINT(((long) 0)));
							BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 =
								MAKE_YOUNG_PAIR(BgL_arg1640z00_1675,
								BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
						}
						{	/* Cfa/specialize.scm 221 */
							obj_t BgL_list1641z00_1676;

							BgL_list1641z00_1676 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 4)), BNIL);
							BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 5)),
								BgL_list1641z00_1676);
						}
						{	/* Cfa/specialize.scm 222 */
							obj_t BgL_list1642z00_1677;

							BgL_list1642z00_1677 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 4)), BNIL);
							return (BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 6)),
									BgL_list1642z00_1677), BUNSPEC);
		}}}}
		BGL_FUNCTION_END;
	}



/* add-specialized-type! */
	obj_t BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t
		BgL_typez00_92)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 227 */
			{	/* Cfa/specialize.scm 228 */
				obj_t BgL_cellz00_1679;

				BgL_cellz00_1679 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_92,
					BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
				if (PAIRP(BgL_cellz00_1679))
					{	/* Cfa/specialize.scm 232 */
						long BgL_arg1650z00_1681;

						BgL_arg1650z00_1681 =
							(((long) 1) + (long) CINT(CDR(BgL_cellz00_1679)));
						{	/* Cfa/specialize.scm 232 */
							obj_t BgL_tmpz00_3055;

							BgL_tmpz00_3055 = BINT(BgL_arg1650z00_1681);
							return SET_CDR(BgL_cellz00_1679, BgL_tmpz00_3055);
						}
					}
				else
					{	/* Cfa/specialize.scm 229 */
						return
							BGl_internalzd2errorzd2zztools_errorz00
							(BGl_string2061z00zzcfa_specializa7eza7,
							BGl_string2062z00zzcfa_specializa7eza7,
							BGl_shapez00zztools_shapez00(BgL_typez00_92));
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* add-specialized-eq-type! */
	obj_t BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7(obj_t
		BgL_typez00_93)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 237 */
			{	/* Cfa/specialize.scm 238 */
				obj_t BgL_cellz00_1684;

				BgL_cellz00_1684 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_93,
					BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7);
				if (PAIRP(BgL_cellz00_1684))
					{	/* Cfa/specialize.scm 242 */
						long BgL_arg1659z00_1686;

						BgL_arg1659z00_1686 =
							(((long) 1) + (long) CINT(CDR(BgL_cellz00_1684)));
						{	/* Cfa/specialize.scm 242 */
							obj_t BgL_tmpz00_3066;

							BgL_tmpz00_3066 = BINT(BgL_arg1659z00_1686);
							return SET_CDR(BgL_cellz00_1684, BgL_tmpz00_3066);
						}
					}
				else
					{	/* Cfa/specialize.scm 241 */
						obj_t BgL_arg1666z00_1688;

						BgL_arg1666z00_1688 =
							MAKE_YOUNG_PAIR(BgL_typez00_93, BINT(((long) 1)));
						return (BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7
							=
							MAKE_YOUNG_PAIR(BgL_arg1666z00_1688,
								BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7),
							BUNSPEC);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* install-specialize! */
	obj_t BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(obj_t
		BgL_specz00_94)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 247 */
			{	/* Cfa/specialize.scm 248 */
				obj_t BgL_genz00_1689;

				{	/* Cfa/specialize.scm 248 */
					obj_t BgL_pairz00_2403;

					BgL_pairz00_2403 = CDR(((obj_t) BgL_specz00_94));
					BgL_genz00_1689 = CAR(BgL_pairz00_2403);
				}
				{	/* Cfa/specialize.scm 248 */
					obj_t BgL_fixesz00_1690;

					{	/* Cfa/specialize.scm 249 */
						obj_t BgL_pairz00_2407;

						BgL_pairz00_2407 = CDR(((obj_t) BgL_specz00_94));
						BgL_fixesz00_1690 = CDR(BgL_pairz00_2407);
					}
					{	/* Cfa/specialize.scm 249 */
						obj_t BgL_genzd2idzd2_1691;

						BgL_genzd2idzd2_1691 = CAR(((obj_t) BgL_genz00_1689));
						{	/* Cfa/specialize.scm 250 */
							obj_t BgL_genzd2modzd2_1692;

							{	/* Cfa/specialize.scm 251 */
								obj_t BgL_pairz00_2412;

								BgL_pairz00_2412 = CDR(((obj_t) BgL_genz00_1689));
								BgL_genzd2modzd2_1692 = CAR(BgL_pairz00_2412);
							}
							{	/* Cfa/specialize.scm 251 */
								obj_t BgL_genericz00_1693;

								BgL_genericz00_1693 =
									BGl_findzd2globalzf2modulez20zzast_envz00
									(BgL_genzd2idzd2_1691, BgL_genzd2modzd2_1692);
								{	/* Cfa/specialize.scm 252 */

									if (BGl_isazf3zf3zz__objectz00(BgL_genericz00_1693,
											BGl_globalz00zzast_varz00))
										{
											obj_t BgL_fixesz00_1697;
											obj_t BgL_resz00_1698;

											BgL_fixesz00_1697 = BgL_fixesz00_1690;
											BgL_resz00_1698 = BNIL;
										BgL_zc3anonymousza31668ze3z83_1699:
											if (NULLP(BgL_fixesz00_1697))
												{	/* Cfa/specialize.scm 256 */
													if (BGl_isazf3zf3zz__objectz00(BgL_genericz00_1693,
															BGl_specializa7edzd2globalz75zzcfa_specializa7eza7))
														{
															obj_t BgL_auxz00_3097;
															BgL_specializa7edzd2globalz75_bglt
																BgL_auxz00_3090;
															{	/* Cfa/specialize.scm 259 */
																obj_t BgL_arg1672z00_1703;

																{
																	BgL_specializa7edzd2globalz75_bglt
																		BgL_auxz00_3098;
																	{
																		obj_t BgL_auxz00_3099;

																		{	/* Cfa/specialize.scm 259 */
																			BgL_objectz00_bglt BgL_tmpz00_3100;

																			BgL_tmpz00_3100 =
																				((BgL_objectz00_bglt)
																				((BgL_globalz00_bglt)
																					BgL_genericz00_1693));
																			BgL_auxz00_3099 =
																				BGL_OBJECT_WIDENING(BgL_tmpz00_3100);
																		}
																		BgL_auxz00_3098 =
																			((BgL_specializa7edzd2globalz75_bglt)
																			BgL_auxz00_3099);
																	}
																	BgL_arg1672z00_1703 =
																		(((BgL_specializa7edzd2globalz75_bglt)
																			COBJECT(BgL_auxz00_3098))->BgL_fixz00);
																}
																BgL_auxz00_3097 =
																	BGl_appendzd221011zd2zzcfa_specializa7eza7
																	(BgL_arg1672z00_1703, BgL_resz00_1698);
															}
															{
																obj_t BgL_auxz00_3091;

																{	/* Cfa/specialize.scm 259 */
																	BgL_objectz00_bglt BgL_tmpz00_3092;

																	BgL_tmpz00_3092 =
																		((BgL_objectz00_bglt)
																		((BgL_globalz00_bglt) BgL_genericz00_1693));
																	BgL_auxz00_3091 =
																		BGL_OBJECT_WIDENING(BgL_tmpz00_3092);
																}
																BgL_auxz00_3090 =
																	((BgL_specializa7edzd2globalz75_bglt)
																	BgL_auxz00_3091);
															}
															return
																((((BgL_specializa7edzd2globalz75_bglt)
																		COBJECT(BgL_auxz00_3090))->BgL_fixz00) =
																((obj_t) BgL_auxz00_3097), BUNSPEC);
														}
													else
														{	/* Cfa/specialize.scm 257 */
															{	/* Cfa/specialize.scm 261 */
																BgL_specializa7edzd2globalz75_bglt
																	BgL_wide1153z00_1706;
																BgL_wide1153z00_1706 =
																	((BgL_specializa7edzd2globalz75_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_specializa7edzd2globalz75_bgl))));
																{	/* Cfa/specialize.scm 261 */
																	obj_t BgL_auxz00_3113;
																	BgL_objectz00_bglt BgL_tmpz00_3109;

																	BgL_auxz00_3113 =
																		((obj_t) BgL_wide1153z00_1706);
																	BgL_tmpz00_3109 =
																		((BgL_objectz00_bglt)
																		((BgL_globalz00_bglt)
																			((BgL_globalz00_bglt)
																				BgL_genericz00_1693)));
																	BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3109,
																		BgL_auxz00_3113);
																}
																{	/* Cfa/specialize.scm 261 */
																	long BgL_arg1673z00_1707;

																	{	/* Cfa/specialize.scm 261 */
																		long BgL_res2012z00_2417;

																		BgL_res2012z00_2417 =
																			BGL_CLASS_INDEX
																			(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
																		BgL_arg1673z00_1707 = BgL_res2012z00_2417;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt)
																			((BgL_globalz00_bglt)
																				((BgL_globalz00_bglt)
																					BgL_genericz00_1693))),
																		BgL_arg1673z00_1707);
																}
																((BgL_globalz00_bglt)
																	((BgL_globalz00_bglt)
																		((BgL_globalz00_bglt)
																			BgL_genericz00_1693)));
															}
															{
																BgL_specializa7edzd2globalz75_bglt
																	BgL_auxz00_3124;
																{
																	obj_t BgL_auxz00_3125;

																	{	/* Cfa/specialize.scm 262 */
																		BgL_objectz00_bglt BgL_tmpz00_3126;

																		BgL_tmpz00_3126 =
																			((BgL_objectz00_bglt)
																			((BgL_globalz00_bglt)
																				((BgL_globalz00_bglt)
																					BgL_genericz00_1693)));
																		BgL_auxz00_3125 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_3126);
																	}
																	BgL_auxz00_3124 =
																		((BgL_specializa7edzd2globalz75_bglt)
																		BgL_auxz00_3125);
																}
																((((BgL_specializa7edzd2globalz75_bglt)
																			COBJECT(BgL_auxz00_3124))->BgL_fixz00) =
																	((obj_t) BgL_resz00_1698), BUNSPEC);
															}
															((BgL_globalz00_bglt)
																((BgL_globalz00_bglt) BgL_genericz00_1693));
															return
																(BGl_za2specializa7eza2za7zzcfa_specializa7eza7
																=
																MAKE_YOUNG_PAIR(BgL_genericz00_1693,
																	BGl_za2specializa7eza2za7zzcfa_specializa7eza7),
																BUNSPEC);
														}
												}
											else
												{	/* Cfa/specialize.scm 264 */
													obj_t BgL_fixz00_1709;

													BgL_fixz00_1709 = CAR(((obj_t) BgL_fixesz00_1697));
													{	/* Cfa/specialize.scm 264 */
														obj_t BgL_idz00_1710;

														BgL_idz00_1710 = CAR(((obj_t) BgL_fixz00_1709));
														{	/* Cfa/specialize.scm 265 */
															obj_t BgL_modz00_1711;

															{	/* Cfa/specialize.scm 266 */
																obj_t BgL_pairz00_2425;

																BgL_pairz00_2425 =
																	CDR(((obj_t) BgL_fixz00_1709));
																BgL_modz00_1711 = CAR(BgL_pairz00_2425);
															}
															{	/* Cfa/specialize.scm 266 */
																obj_t BgL_globalz00_1712;

																BgL_globalz00_1712 =
																	BGl_findzd2globalzf2modulez20zzast_envz00
																	(BgL_idz00_1710, BgL_modz00_1711);
																{	/* Cfa/specialize.scm 267 */

																	if (BGl_isazf3zf3zz__objectz00
																		(BgL_globalz00_1712,
																			BGl_globalz00zzast_varz00))
																		{	/* Cfa/specialize.scm 269 */
																			BgL_valuez00_bglt BgL_valz00_1714;

																			BgL_valz00_1714 =
																				(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_globalz00_1712))))->
																				BgL_valuez00);
																			{	/* Cfa/specialize.scm 271 */
																				bool_t BgL_testz00_3149;

																				{	/* Cfa/specialize.scm 271 */
																					bool_t BgL_testz00_3150;

																					{	/* Cfa/specialize.scm 271 */
																						bool_t BgL_res2014z00_2428;

																						BgL_res2014z00_2428 =
																							BGl_isazf3zf3zz__objectz00(
																							((obj_t) BgL_valz00_1714),
																							BGl_sfunz00zzast_varz00);
																						BgL_testz00_3150 =
																							BgL_res2014z00_2428;
																					}
																					if (BgL_testz00_3150)
																						{	/* Cfa/specialize.scm 271 */
																							obj_t BgL_tmpz00_3153;

																							BgL_tmpz00_3153 =
																								(((BgL_sfunz00_bglt) COBJECT(
																										((BgL_sfunz00_bglt)
																											BgL_valz00_1714)))->
																								BgL_argsz00);
																							BgL_testz00_3149 =
																								PAIRP(BgL_tmpz00_3153);
																						}
																					else
																						{	/* Cfa/specialize.scm 271 */
																							BgL_testz00_3149 = ((bool_t) 0);
																						}
																				}
																				if (BgL_testz00_3149)
																					{	/* Cfa/specialize.scm 272 */
																						obj_t BgL_typez00_1718;

																						{	/* Cfa/specialize.scm 272 */
																							obj_t BgL_vz00_1722;

																							{	/* Cfa/specialize.scm 272 */
																								obj_t BgL_pairz00_2432;

																								BgL_pairz00_2432 =
																									(((BgL_sfunz00_bglt) COBJECT(
																											((BgL_sfunz00_bglt)
																												BgL_valz00_1714)))->
																									BgL_argsz00);
																								BgL_vz00_1722 =
																									CAR(BgL_pairz00_2432);
																							}
																							if (BGl_isazf3zf3zz__objectz00
																								(BgL_vz00_1722,
																									BGl_typez00zztype_typez00))
																								{	/* Cfa/specialize.scm 274 */
																									BgL_typez00_1718 =
																										BgL_vz00_1722;
																								}
																							else
																								{	/* Cfa/specialize.scm 274 */
																									if (BGl_isazf3zf3zz__objectz00
																										(BgL_vz00_1722,
																											BGl_localz00zzast_varz00))
																										{	/* Cfa/specialize.scm 276 */
																											BgL_typez00_1718 =
																												((obj_t)
																												(((BgL_variablez00_bglt)
																														COBJECT((
																																(BgL_variablez00_bglt)
																																((BgL_localz00_bglt) BgL_vz00_1722))))->BgL_typez00));
																										}
																									else
																										{	/* Cfa/specialize.scm 282 */
																											obj_t BgL_arg1688z00_1725;

																											BgL_arg1688z00_1725 =
																												(((BgL_variablez00_bglt)
																													COBJECT((
																															(BgL_variablez00_bglt)
																															((BgL_globalz00_bglt) BgL_globalz00_1712))))->BgL_idz00);
																											BgL_typez00_1718 =
																												BGl_internalzd2errorzd2zztools_errorz00
																												(BGl_string2063z00zzcfa_specializa7eza7,
																												BGl_string2064z00zzcfa_specializa7eza7,
																												BgL_arg1688z00_1725);
																										}
																								}
																						}
																						BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
																							(BgL_typez00_1718);
																						{	/* Cfa/specialize.scm 284 */
																							obj_t BgL_arg1680z00_1719;
																							obj_t BgL_arg1682z00_1720;

																							BgL_arg1680z00_1719 =
																								CDR(
																								((obj_t) BgL_fixesz00_1697));
																							{	/* Cfa/specialize.scm 285 */
																								obj_t BgL_arg1684z00_1721;

																								BgL_arg1684z00_1721 =
																									MAKE_YOUNG_PAIR
																									(BgL_typez00_1718,
																									BgL_globalz00_1712);
																								BgL_arg1682z00_1720 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1684z00_1721,
																									BgL_resz00_1698);
																							}
																							{
																								obj_t BgL_resz00_3178;
																								obj_t BgL_fixesz00_3177;

																								BgL_fixesz00_3177 =
																									BgL_arg1680z00_1719;
																								BgL_resz00_3178 =
																									BgL_arg1682z00_1720;
																								BgL_resz00_1698 =
																									BgL_resz00_3178;
																								BgL_fixesz00_1697 =
																									BgL_fixesz00_3177;
																								goto
																									BgL_zc3anonymousza31668ze3z83_1699;
																							}
																						}
																					}
																				else
																					{	/* Cfa/specialize.scm 286 */
																						bool_t BgL_testz00_3179;

																						{	/* Cfa/specialize.scm 286 */
																							bool_t BgL_testz00_3180;

																							{	/* Cfa/specialize.scm 286 */
																								bool_t BgL_res2018z00_2438;

																								BgL_res2018z00_2438 =
																									BGl_isazf3zf3zz__objectz00(
																									((obj_t) BgL_valz00_1714),
																									BGl_cfunz00zzast_varz00);
																								BgL_testz00_3180 =
																									BgL_res2018z00_2438;
																							}
																							if (BgL_testz00_3180)
																								{	/* Cfa/specialize.scm 286 */
																									obj_t BgL_tmpz00_3183;

																									BgL_tmpz00_3183 =
																										(((BgL_cfunz00_bglt)
																											COBJECT((
																													(BgL_cfunz00_bglt)
																													BgL_valz00_1714)))->
																										BgL_argszd2typezd2);
																									BgL_testz00_3179 =
																										PAIRP(BgL_tmpz00_3183);
																								}
																							else
																								{	/* Cfa/specialize.scm 286 */
																									BgL_testz00_3179 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_3179)
																							{	/* Cfa/specialize.scm 287 */
																								obj_t BgL_typez00_1730;

																								{	/* Cfa/specialize.scm 287 */
																									obj_t BgL_pairz00_2442;

																									BgL_pairz00_2442 =
																										(((BgL_cfunz00_bglt)
																											COBJECT((
																													(BgL_cfunz00_bglt)
																													BgL_valz00_1714)))->
																										BgL_argszd2typezd2);
																									BgL_typez00_1730 =
																										CAR(BgL_pairz00_2442);
																								}
																								BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
																									(BgL_typez00_1730);
																								{	/* Cfa/specialize.scm 289 */
																									obj_t BgL_arg1694z00_1731;
																									obj_t BgL_arg1695z00_1732;

																									BgL_arg1694z00_1731 =
																										CDR(
																										((obj_t)
																											BgL_fixesz00_1697));
																									{	/* Cfa/specialize.scm 290 */
																										obj_t BgL_arg1696z00_1733;

																										BgL_arg1696z00_1733 =
																											MAKE_YOUNG_PAIR
																											(BgL_typez00_1730,
																											BgL_globalz00_1712);
																										BgL_arg1695z00_1732 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1696z00_1733,
																											BgL_resz00_1698);
																									}
																									{
																										obj_t BgL_resz00_3196;
																										obj_t BgL_fixesz00_3195;

																										BgL_fixesz00_3195 =
																											BgL_arg1694z00_1731;
																										BgL_resz00_3196 =
																											BgL_arg1695z00_1732;
																										BgL_resz00_1698 =
																											BgL_resz00_3196;
																										BgL_fixesz00_1697 =
																											BgL_fixesz00_3195;
																										goto
																											BgL_zc3anonymousza31668ze3z83_1699;
																									}
																								}
																							}
																						else
																							{	/* Cfa/specialize.scm 286 */
																								return BFALSE;
																							}
																					}
																			}
																		}
																	else
																		{	/* Cfa/specialize.scm 268 */
																			{	/* Cfa/specialize.scm 295 */
																				obj_t BgL_arg1705z00_1739;

																				BgL_arg1705z00_1739 =
																					MAKE_YOUNG_PAIR(BgL_idz00_1710,
																					BgL_modz00_1711);
																				{	/* Cfa/specialize.scm 292 */
																					obj_t BgL_list1706z00_1740;

																					{	/* Cfa/specialize.scm 292 */
																						obj_t BgL_arg1707z00_1741;

																						{	/* Cfa/specialize.scm 292 */
																							obj_t BgL_arg1709z00_1742;

																							{	/* Cfa/specialize.scm 292 */
																								obj_t BgL_arg1710z00_1743;

																								BgL_arg1710z00_1743 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1705z00_1739, BNIL);
																								BgL_arg1709z00_1742 =
																									MAKE_YOUNG_PAIR
																									(BGl_string2065z00zzcfa_specializa7eza7,
																									BgL_arg1710z00_1743);
																							}
																							BgL_arg1707z00_1741 =
																								MAKE_YOUNG_PAIR
																								(BGl_string2066z00zzcfa_specializa7eza7,
																								BgL_arg1709z00_1742);
																						}
																						BgL_list1706z00_1740 =
																							MAKE_YOUNG_PAIR
																							(BGl_string2067z00zzcfa_specializa7eza7,
																							BgL_arg1707z00_1741);
																					}
																					BGl_warningz00zz__errorz00
																						(BgL_list1706z00_1740);
																				}
																			}
																			{	/* Cfa/specialize.scm 296 */
																				obj_t BgL_arg1712z00_1744;

																				BgL_arg1712z00_1744 =
																					CDR(((obj_t) BgL_fixesz00_1697));
																				{
																					obj_t BgL_fixesz00_3205;

																					BgL_fixesz00_3205 =
																						BgL_arg1712z00_1744;
																					BgL_fixesz00_1697 = BgL_fixesz00_3205;
																					goto
																						BgL_zc3anonymousza31668ze3z83_1699;
																				}
																			}
																		}
																}
															}
														}
													}
												}
										}
									else
										{	/* Cfa/specialize.scm 300 */
											obj_t BgL_arg1717z00_1746;

											BgL_arg1717z00_1746 =
												MAKE_YOUNG_PAIR(BgL_genzd2idzd2_1691,
												BgL_genzd2modzd2_1692);
											{	/* Cfa/specialize.scm 297 */
												obj_t BgL_list1718z00_1747;

												{	/* Cfa/specialize.scm 297 */
													obj_t BgL_arg1725z00_1748;

													{	/* Cfa/specialize.scm 297 */
														obj_t BgL_arg1728z00_1749;

														{	/* Cfa/specialize.scm 297 */
															obj_t BgL_arg1729z00_1750;

															BgL_arg1729z00_1750 =
																MAKE_YOUNG_PAIR(BgL_arg1717z00_1746, BNIL);
															BgL_arg1728z00_1749 =
																MAKE_YOUNG_PAIR
																(BGl_string2065z00zzcfa_specializa7eza7,
																BgL_arg1729z00_1750);
														}
														BgL_arg1725z00_1748 =
															MAKE_YOUNG_PAIR
															(BGl_string2066z00zzcfa_specializa7eza7,
															BgL_arg1728z00_1749);
													}
													BgL_list1718z00_1747 =
														MAKE_YOUNG_PAIR
														(BGl_string2067z00zzcfa_specializa7eza7,
														BgL_arg1725z00_1748);
												}
												return BGl_warningz00zz__errorz00(BgL_list1718z00_1747);
											}
										}
								}
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* uninstall-specializes! */
	obj_t BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 305 */
			BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 = BNIL;
			{
				obj_t BgL_l1361z00_1752;

				BgL_l1361z00_1752 = BGl_za2specializa7eza2za7zzcfa_specializa7eza7;
			BgL_zc3anonymousza31730ze3z83_1753:
				if (PAIRP(BgL_l1361z00_1752))
					{	/* Cfa/specialize.scm 307 */
						{	/* Cfa/specialize.scm 307 */
							obj_t BgL_oz00_1755;

							BgL_oz00_1755 = CAR(BgL_l1361z00_1752);
							{	/* Cfa/specialize.scm 307 */
								long BgL_arg1738z00_1757;

								{	/* Cfa/specialize.scm 307 */
									obj_t BgL_arg1749z00_1758;

									{	/* Cfa/specialize.scm 307 */
										obj_t BgL_arg1751z00_1759;

										{	/* Cfa/specialize.scm 307 */
											long BgL_arg1759z00_2448;

											{	/* Cfa/specialize.scm 307 */
												long BgL_arg1760z00_2449;

												{	/* Cfa/specialize.scm 307 */
													long BgL_res2021z00_2451;

													BgL_res2021z00_2451 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_oz00_1755));
													BgL_arg1760z00_2449 = BgL_res2021z00_2451;
												}
												BgL_arg1759z00_2448 =
													(BgL_arg1760z00_2449 - OBJECT_TYPE);
											}
											BgL_arg1751z00_1759 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												BgL_arg1759z00_2448);
										}
										BgL_arg1749z00_1758 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1751z00_1759);
									}
									{	/* Cfa/specialize.scm 307 */
										long BgL_res2023z00_2458;

										{	/* Cfa/specialize.scm 307 */
											obj_t BgL_tmpz00_3220;

											BgL_tmpz00_3220 = ((obj_t) BgL_arg1749z00_1758);
											BgL_res2023z00_2458 = BGL_CLASS_INDEX(BgL_tmpz00_3220);
										}
										BgL_arg1738z00_1757 = BgL_res2023z00_2458;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_oz00_1755), BgL_arg1738z00_1757);
							}
							{	/* Cfa/specialize.scm 307 */
								BgL_objectz00_bglt BgL_tmpz00_3225;

								BgL_tmpz00_3225 = ((BgL_objectz00_bglt) BgL_oz00_1755);
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3225, BFALSE);
							} BgL_oz00_1755;
						}
						{
							obj_t BgL_l1361z00_3228;

							BgL_l1361z00_3228 = CDR(BgL_l1361z00_1752);
							BgL_l1361z00_1752 = BgL_l1361z00_3228;
							goto BgL_zc3anonymousza31730ze3z83_1753;
						}
					}
				else
					{	/* Cfa/specialize.scm 307 */
						((bool_t) 1);
					}
			}
			return (BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BNIL, BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* patch-tree! */
	bool_t BGl_patchzd2treez12zc0zzcfa_specializa7eza7(obj_t BgL_globalsz00_95)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 313 */
			{
				obj_t BgL_l1363z00_1763;

				BgL_l1363z00_1763 = BgL_globalsz00_95;
			BgL_zc3anonymousza31753ze3z83_1764:
				if (PAIRP(BgL_l1363z00_1763))
					{	/* Cfa/specialize.scm 314 */
						BGl_patchzd2funz12zc0zzcfa_specializa7eza7(CAR(BgL_l1363z00_1763));
						{
							obj_t BgL_l1363z00_3234;

							BgL_l1363z00_3234 = CDR(BgL_l1363z00_1763);
							BgL_l1363z00_1763 = BgL_l1363z00_3234;
							goto BgL_zc3anonymousza31753ze3z83_1764;
						}
					}
				else
					{	/* Cfa/specialize.scm 314 */
						return ((bool_t) 1);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* patch-fun! */
	obj_t BGl_patchzd2funz12zc0zzcfa_specializa7eza7(obj_t BgL_variablez00_96)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 319 */
			{	/* Cfa/specialize.scm 320 */
				BgL_valuez00_bglt BgL_funz00_1769;

				BgL_funz00_1769 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_variablez00_96)))->BgL_valuez00);
				{	/* Cfa/specialize.scm 321 */
					obj_t BgL_arg1765z00_1770;

					{	/* Cfa/specialize.scm 321 */
						obj_t BgL_arg1766z00_1771;

						BgL_arg1766z00_1771 =
							(((BgL_sfunz00_bglt) COBJECT(
									((BgL_sfunz00_bglt) BgL_funz00_1769)))->BgL_bodyz00);
						BgL_arg1765z00_1770 =
							BGl_patchz12z12zzcfa_specializa7eza7(
							((BgL_nodez00_bglt) BgL_arg1766z00_1771));
					}
					return
						((((BgL_sfunz00_bglt) COBJECT(
									((BgL_sfunz00_bglt) BgL_funz00_1769)))->BgL_bodyz00) =
						((obj_t) BgL_arg1765z00_1770), BUNSPEC);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* patch*! */
	obj_t BGl_patchza2z12zb0zzcfa_specializa7eza7(obj_t BgL_nodeza2za2_119)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 526 */
			{
				obj_t BgL_nodeza2za2_1773;

				BgL_nodeza2za2_1773 = BgL_nodeza2za2_119;
			BgL_zc3anonymousza31767ze3z83_1774:
				if (NULLP(BgL_nodeza2za2_1773))
					{	/* Cfa/specialize.scm 528 */
						return CNST_TABLE_REF(((long) 7));
					}
				else
					{	/* Cfa/specialize.scm 528 */
						{	/* Cfa/specialize.scm 531 */
							obj_t BgL_arg1770z00_1776;

							{	/* Cfa/specialize.scm 531 */
								obj_t BgL_arg1771z00_1777;

								BgL_arg1771z00_1777 = CAR(((obj_t) BgL_nodeza2za2_1773));
								BgL_arg1770z00_1776 =
									BGl_patchz12z12zzcfa_specializa7eza7(
									((BgL_nodez00_bglt) BgL_arg1771z00_1777));
							}
							{	/* Cfa/specialize.scm 531 */
								obj_t BgL_tmpz00_3251;

								BgL_tmpz00_3251 = ((obj_t) BgL_nodeza2za2_1773);
								SET_CAR(BgL_tmpz00_3251, BgL_arg1770z00_1776);
							}
						}
						{	/* Cfa/specialize.scm 532 */
							obj_t BgL_arg1772z00_1778;

							BgL_arg1772z00_1778 = CDR(((obj_t) BgL_nodeza2za2_1773));
							{
								obj_t BgL_nodeza2za2_3256;

								BgL_nodeza2za2_3256 = BgL_arg1772z00_1778;
								BgL_nodeza2za2_1773 = BgL_nodeza2za2_3256;
								goto BgL_zc3anonymousza31767ze3z83_1774;
							}
						}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* specialize-app! */
	BgL_appz00_bglt
		BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(BgL_appz00_bglt
		BgL_nodez00_121)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 551 */
			if (NULLP((((BgL_appz00_bglt) COBJECT(BgL_nodez00_121))->BgL_argsz00)))
				{	/* Cfa/specialize.scm 560 */
					return BgL_nodez00_121;
				}
			else
				{	/* Cfa/specialize.scm 564 */
					obj_t BgL_typez00_1784;

					BgL_typez00_1784 =
						BGl_normaliza7ezd2getzd2typeze70z40zzcfa_specializa7eza7(CAR(
							(((BgL_appz00_bglt) COBJECT(BgL_nodez00_121))->BgL_argsz00)));
					{	/* Cfa/specialize.scm 564 */
						BgL_variablez00_bglt BgL_gloz00_1785;

						BgL_gloz00_1785 =
							(((BgL_varz00_bglt) COBJECT(
									(((BgL_appz00_bglt) COBJECT(BgL_nodez00_121))->BgL_funz00)))->
							BgL_variablez00);
						{	/* Cfa/specialize.scm 565 */
							obj_t BgL_specz00_1786;

							{	/* Cfa/specialize.scm 566 */
								obj_t BgL_auxz00_3265;

								{
									BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3266;

									{
										obj_t BgL_auxz00_3267;

										{	/* Cfa/specialize.scm 566 */
											BgL_objectz00_bglt BgL_tmpz00_3268;

											BgL_tmpz00_3268 =
												((BgL_objectz00_bglt)
												((BgL_globalz00_bglt) BgL_gloz00_1785));
											BgL_auxz00_3267 = BGL_OBJECT_WIDENING(BgL_tmpz00_3268);
										}
										BgL_auxz00_3266 =
											((BgL_specializa7edzd2globalz75_bglt) BgL_auxz00_3267);
									}
									BgL_auxz00_3265 =
										(((BgL_specializa7edzd2globalz75_bglt)
											COBJECT(BgL_auxz00_3266))->BgL_fixz00);
								}
								BgL_specz00_1786 =
									BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_1784,
									BgL_auxz00_3265);
							}
							{	/* Cfa/specialize.scm 566 */

								if (PAIRP(BgL_specz00_1786))
									{	/* Cfa/specialize.scm 568 */
										obj_t BgL_g1176z00_1788;

										BgL_g1176z00_1788 =
											CDR(
											(((BgL_appz00_bglt) COBJECT(BgL_nodez00_121))->
												BgL_argsz00));
										{
											obj_t BgL_argsz00_1790;

											BgL_argsz00_1790 = BgL_g1176z00_1788;
										BgL_zc3anonymousza31776ze3z83_1791:
											if (NULLP(BgL_argsz00_1790))
												{	/* Cfa/specialize.scm 570 */
													BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
														(BgL_typez00_1784);
													{	/* Cfa/specialize.scm 572 */
														BgL_varz00_bglt BgL_arg1778z00_1793;
														obj_t BgL_arg1779z00_1794;

														BgL_arg1778z00_1793 =
															(((BgL_appz00_bglt) COBJECT(BgL_nodez00_121))->
															BgL_funz00);
														BgL_arg1779z00_1794 =
															CDR(((obj_t) BgL_specz00_1786));
														((((BgL_varz00_bglt) COBJECT(BgL_arg1778z00_1793))->
																BgL_variablez00) =
															((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
																	BgL_arg1779z00_1794)), BUNSPEC);
													}
													{	/* Cfa/specialize.scm 573 */
														BgL_typez00_bglt BgL_ntz00_1795;

														BgL_ntz00_1795 =
															(((BgL_variablez00_bglt) COBJECT(
																	(((BgL_varz00_bglt) COBJECT(
																				(((BgL_appz00_bglt)
																						COBJECT(BgL_nodez00_121))->
																					BgL_funz00)))->BgL_variablez00)))->
															BgL_typez00);
														{	/* Cfa/specialize.scm 574 */
															BgL_typez00_bglt BgL_arg1780z00_1796;

															BgL_arg1780z00_1796 =
																BGl_strictzd2nodezd2typez00zzast_nodez00
																(BgL_ntz00_1795,
																((BgL_typez00_bglt) BgL_typez00_1784));
															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																				BgL_nodez00_121)))->BgL_typez00) =
																((BgL_typez00_bglt) BgL_arg1780z00_1796),
																BUNSPEC);
														}
													}
													return BgL_nodez00_121;
												}
											else
												{	/* Cfa/specialize.scm 576 */
													bool_t BgL_testz00_3294;

													{	/* Cfa/specialize.scm 576 */
														obj_t BgL_arg1788z00_1803;

														{	/* Cfa/specialize.scm 576 */
															obj_t BgL_arg1790z00_1804;

															BgL_arg1790z00_1804 =
																CAR(((obj_t) BgL_argsz00_1790));
															BgL_arg1788z00_1803 =
																BGl_normaliza7ezd2getzd2typeze70z40zzcfa_specializa7eza7
																(BgL_arg1790z00_1804);
														}
														BgL_testz00_3294 =
															(BgL_arg1788z00_1803 == BgL_typez00_1784);
													}
													if (BgL_testz00_3294)
														{	/* Cfa/specialize.scm 577 */
															obj_t BgL_arg1786z00_1802;

															BgL_arg1786z00_1802 =
																CDR(((obj_t) BgL_argsz00_1790));
															{
																obj_t BgL_argsz00_3301;

																BgL_argsz00_3301 = BgL_arg1786z00_1802;
																BgL_argsz00_1790 = BgL_argsz00_3301;
																goto BgL_zc3anonymousza31776ze3z83_1791;
															}
														}
													else
														{	/* Cfa/specialize.scm 576 */
															return
																BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7
																(BgL_nodez00_121);
														}
												}
										}
									}
								else
									{	/* Cfa/specialize.scm 567 */
										return
											BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7
											(BgL_nodez00_121);
									}
							}
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* normalize-get-type~0 */
	obj_t BGl_normaliza7ezd2getzd2typeze70z40zzcfa_specializa7eza7(obj_t
		BgL_valz00_1812)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 557 */
			{	/* Cfa/specialize.scm 554 */
				BgL_typez00_bglt BgL_tyz00_1814;

				BgL_tyz00_1814 =
					BGl_getzd2typezd2zztype_typeofz00(
					((BgL_nodez00_bglt) BgL_valz00_1812), ((bool_t) 0));
				if ((((obj_t) BgL_tyz00_1814) == BGl_za2intza2z00zztype_cachez00))
					{	/* Cfa/specialize.scm 555 */
						return BGl_za2longza2z00zztype_cachez00;
					}
				else
					{	/* Cfa/specialize.scm 555 */
						return ((obj_t) BgL_tyz00_1814);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* specialize-eq? */
	BgL_appz00_bglt
		BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7(BgL_appz00_bglt
		BgL_nodez00_122)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 590 */
			{
				BgL_appz00_bglt BgL_nodez00_1854;
				obj_t BgL_typez00_1855;

				{	/* Cfa/specialize.scm 597 */
					bool_t BgL_testz00_3310;

					{	/* Cfa/specialize.scm 597 */
						bool_t BgL_testz00_3311;

						{	/* Cfa/specialize.scm 597 */
							BgL_variablez00_bglt BgL_arg1834z00_1852;

							BgL_arg1834z00_1852 =
								(((BgL_varz00_bglt) COBJECT(
										(((BgL_appz00_bglt) COBJECT(BgL_nodez00_122))->
											BgL_funz00)))->BgL_variablez00);
							BgL_testz00_3311 =
								(((obj_t) BgL_arg1834z00_1852) ==
								BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7);
						}
						if (BgL_testz00_3311)
							{	/* Cfa/specialize.scm 598 */
								obj_t BgL_arg1833z00_1851;

								BgL_arg1833z00_1851 =
									BGl_thezd2backendzd2zzbackend_backendz00();
								BgL_testz00_3310 =
									(((BgL_backendz00_bglt) COBJECT(
											((BgL_backendz00_bglt) BgL_arg1833z00_1851)))->
									BgL_typedzd2eqzd2);
							}
						else
							{	/* Cfa/specialize.scm 597 */
								BgL_testz00_3310 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3310)
						{	/* Cfa/specialize.scm 600 */
							BgL_typez00_bglt BgL_t1z00_1826;
							BgL_typez00_bglt BgL_t2z00_1827;

							{	/* Cfa/specialize.scm 600 */
								obj_t BgL_arg1827z00_1846;

								BgL_arg1827z00_1846 =
									CAR(
									(((BgL_appz00_bglt) COBJECT(BgL_nodez00_122))->BgL_argsz00));
								BgL_t1z00_1826 =
									BGl_getzd2typezd2zztype_typeofz00(
									((BgL_nodez00_bglt) BgL_arg1827z00_1846), ((bool_t) 0));
							}
							{	/* Cfa/specialize.scm 601 */
								obj_t BgL_arg1831z00_1848;

								{	/* Cfa/specialize.scm 601 */
									obj_t BgL_pairz00_2497;

									BgL_pairz00_2497 =
										(((BgL_appz00_bglt) COBJECT(BgL_nodez00_122))->BgL_argsz00);
									BgL_arg1831z00_1848 = CAR(CDR(BgL_pairz00_2497));
								}
								BgL_t2z00_1827 =
									BGl_getzd2typezd2zztype_typeofz00(
									((BgL_nodez00_bglt) BgL_arg1831z00_1848), ((bool_t) 0));
							}
							{	/* Cfa/specialize.scm 603 */
								bool_t BgL_testz00_3328;

								if (
									(((obj_t) BgL_t1z00_1826) == BGl_za2objza2z00zztype_cachez00))
									{	/* Cfa/specialize.scm 603 */
										BgL_testz00_3328 =
											(
											((obj_t) BgL_t2z00_1827) ==
											BGl_za2objza2z00zztype_cachez00);
									}
								else
									{	/* Cfa/specialize.scm 603 */
										BgL_testz00_3328 = ((bool_t) 0);
									}
								if (BgL_testz00_3328)
									{	/* Cfa/specialize.scm 603 */
										BUNSPEC;
									}
								else
									{	/* Cfa/specialize.scm 603 */
										if (
											(((obj_t) BgL_t1z00_1826) ==
												BGl_za2bintza2z00zztype_cachez00))
											{	/* Cfa/specialize.scm 605 */
												if (
													(((obj_t) BgL_t2z00_1827) ==
														BGl_za2bintza2z00zztype_cachez00))
													{	/* Cfa/specialize.scm 606 */
														BgL_nodez00_1854 = BgL_nodez00_122;
														BgL_typez00_1855 = BGl_za2bintza2z00zztype_cachez00;
													BgL_zc3anonymousza31837ze3z83_1856:
														{	/* Cfa/specialize.scm 593 */
															bool_t BgL_testz00_3340;

															{	/* Cfa/specialize.scm 593 */
																bool_t BgL_res2029z00_2489;

																{	/* Cfa/specialize.scm 593 */
																	obj_t BgL_objz00_2488;

																	BgL_objz00_2488 =
																		BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7;
																	BgL_res2029z00_2489 =
																		BGl_isazf3zf3zz__objectz00(BgL_objz00_2488,
																		BGl_globalz00zzast_varz00);
																}
																BgL_testz00_3340 = BgL_res2029z00_2489;
															}
															if (BgL_testz00_3340)
																{	/* Cfa/specialize.scm 593 */
																	{	/* Cfa/specialize.scm 594 */
																		BgL_varz00_bglt BgL_arg1839z00_1858;

																		BgL_arg1839z00_1858 =
																			(((BgL_appz00_bglt)
																				COBJECT(BgL_nodez00_122))->BgL_funz00);
																		{	/* Cfa/specialize.scm 594 */
																			BgL_variablez00_bglt BgL_vz00_2491;

																			BgL_vz00_2491 =
																				((BgL_variablez00_bglt)
																				((BgL_globalz00_bglt)
																					BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7));
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_arg1839z00_1858))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) BgL_vz00_2491),
																				BUNSPEC);
																		}
																	}
																	BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7
																		(BgL_typez00_1855);
																}
															else
																{	/* Cfa/specialize.scm 593 */
																	BFALSE;
																}
														}
													}
												else
													{	/* Cfa/specialize.scm 606 */
														BFALSE;
													}
											}
										else
											{	/* Cfa/specialize.scm 605 */
												if (
													(((obj_t) BgL_t2z00_1827) ==
														BGl_za2bintza2z00zztype_cachez00))
													{	/* Cfa/specialize.scm 609 */
														BUNSPEC;
													}
												else
													{	/* Cfa/specialize.scm 609 */
														if (
															(((obj_t) BgL_t1z00_1826) ==
																BGl_za2brealza2z00zztype_cachez00))
															{	/* Cfa/specialize.scm 611 */
																if (
																	(((obj_t) BgL_t2z00_1827) ==
																		BGl_za2brealza2z00zztype_cachez00))
																	{
																		obj_t BgL_typez00_3357;
																		BgL_appz00_bglt BgL_nodez00_3356;

																		BgL_nodez00_3356 = BgL_nodez00_122;
																		BgL_typez00_3357 =
																			BGl_za2brealza2z00zztype_cachez00;
																		BgL_typez00_1855 = BgL_typez00_3357;
																		BgL_nodez00_1854 = BgL_nodez00_3356;
																		goto BgL_zc3anonymousza31837ze3z83_1856;
																	}
																else
																	{	/* Cfa/specialize.scm 612 */
																		BFALSE;
																	}
															}
														else
															{	/* Cfa/specialize.scm 611 */
																if (
																	(((obj_t) BgL_t2z00_1827) ==
																		BGl_za2brealza2z00zztype_cachez00))
																	{	/* Cfa/specialize.scm 615 */
																		BUNSPEC;
																	}
																else
																	{	/* Cfa/specialize.scm 615 */
																		if (
																			(((obj_t) BgL_t2z00_1827) ==
																				BGl_za2bintza2z00zztype_cachez00))
																			{	/* Cfa/specialize.scm 617 */
																				BUNSPEC;
																			}
																		else
																			{	/* Cfa/specialize.scm 617 */
																				if (
																					(((obj_t) BgL_t1z00_1826) ==
																						BGl_za2bcharza2z00zztype_cachez00))
																					{	/* Cfa/specialize.scm 619 */
																						if (
																							(((obj_t) BgL_t2z00_1827) ==
																								BGl_za2bcharza2z00zztype_cachez00))
																							{
																								obj_t BgL_typez00_3371;
																								BgL_appz00_bglt
																									BgL_nodez00_3370;
																								BgL_nodez00_3370 =
																									BgL_nodez00_122;
																								BgL_typez00_3371 =
																									BGl_za2bcharza2z00zztype_cachez00;
																								BgL_typez00_1855 =
																									BgL_typez00_3371;
																								BgL_nodez00_1854 =
																									BgL_nodez00_3370;
																								goto
																									BgL_zc3anonymousza31837ze3z83_1856;
																							}
																						else
																							{	/* Cfa/specialize.scm 620 */
																								BFALSE;
																							}
																					}
																				else
																					{	/* Cfa/specialize.scm 619 */
																						if (
																							(((obj_t) BgL_t2z00_1827) ==
																								BGl_za2bcharza2z00zztype_cachez00))
																							{	/* Cfa/specialize.scm 623 */
																								BUNSPEC;
																							}
																						else
																							{	/* Cfa/specialize.scm 625 */
																								bool_t BgL_testz00_3375;

																								if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_t1z00_1826))
																									{	/* Cfa/specialize.scm 625 */
																										BgL_testz00_3375 =
																											BGl_bigloozd2typezf3z21zztype_typez00
																											(BgL_t2z00_1827);
																									}
																								else
																									{	/* Cfa/specialize.scm 625 */
																										BgL_testz00_3375 =
																											((bool_t) 0);
																									}
																								if (BgL_testz00_3375)
																									{	/* Cfa/specialize.scm 627 */
																										BgL_typez00_bglt
																											BgL_arg1825z00_1842;
																										if ((((obj_t)
																													BgL_t1z00_1826) ==
																												BGl_za2objza2z00zztype_cachez00))
																											{	/* Cfa/specialize.scm 627 */
																												BgL_arg1825z00_1842 =
																													BgL_t2z00_1827;
																											}
																										else
																											{	/* Cfa/specialize.scm 627 */
																												BgL_arg1825z00_1842 =
																													BgL_t1z00_1826;
																											}
																										{
																											obj_t BgL_typez00_3383;
																											BgL_appz00_bglt
																												BgL_nodez00_3382;
																											BgL_nodez00_3382 =
																												BgL_nodez00_122;
																											BgL_typez00_3383 =
																												((obj_t)
																												BgL_arg1825z00_1842);
																											BgL_typez00_1855 =
																												BgL_typez00_3383;
																											BgL_nodez00_1854 =
																												BgL_nodez00_3382;
																											goto
																												BgL_zc3anonymousza31837ze3z83_1856;
																										}
																									}
																								else
																									{	/* Cfa/specialize.scm 625 */
																										BUNSPEC;
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
							return BgL_nodez00_122;
						}
					else
						{	/* Cfa/specialize.scm 597 */
							return BgL_nodez00_122;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			{	/* Cfa/specialize.scm 35 */
				obj_t BgL_arg1846z00_1864;
				obj_t BgL_arg1847z00_1865;

				{	/* Cfa/specialize.scm 35 */
					obj_t BgL_v1374z00_1907;

					BgL_v1374z00_1907 = create_vector(((long) 1));
					{	/* Cfa/specialize.scm 35 */
						obj_t BgL_arg1859z00_1908;

						BgL_arg1859z00_1908 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									8)), BGl_proc2069z00zzcfa_specializa7eza7,
							BGl_proc2068z00zzcfa_specializa7eza7, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 9)));
						VECTOR_SET(BgL_v1374z00_1907, ((long) 0), BgL_arg1859z00_1908);
					}
					BgL_arg1846z00_1864 = BgL_v1374z00_1907;
				}
				{	/* Cfa/specialize.scm 35 */
					obj_t BgL_v1375z00_1918;

					BgL_v1375z00_1918 = create_vector(((long) 0));
					BgL_arg1847z00_1865 = BgL_v1375z00_1918;
				}
				return (BGl_specializa7edzd2globalz75zzcfa_specializa7eza7 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 10)),
						CNST_TABLE_REF(((long) 11)), BGl_globalz00zzast_varz00,
						((long) 16878), BGl_proc2073z00zzcfa_specializa7eza7,
						BGl_proc2072z00zzcfa_specializa7eza7, BFALSE,
						BGl_proc2071z00zzcfa_specializa7eza7,
						BGl_proc2070z00zzcfa_specializa7eza7, BgL_arg1846z00_1864,
						BgL_arg1847z00_1865), BUNSPEC);
		}}
		BGL_FUNCTION_END;
	}



/* &lambda1854 */
	BgL_globalz00_bglt BGl_z62lambda1854z62zzcfa_specializa7eza7(obj_t
		BgL_envz00_2620, obj_t BgL_o1127z00_2621)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 35 */
			{	/* Cfa/specialize.scm 35 */
				long BgL_arg1855z00_2738;

				{	/* Cfa/specialize.scm 35 */
					obj_t BgL_arg1856z00_2739;

					{	/* Cfa/specialize.scm 35 */
						obj_t BgL_arg1858z00_2740;

						{	/* Cfa/specialize.scm 35 */
							long BgL_arg1759z00_2741;

							{	/* Cfa/specialize.scm 35 */
								long BgL_arg1760z00_2742;

								{	/* Cfa/specialize.scm 35 */
									long BgL_res2034z00_2743;

									BgL_res2034z00_2743 =
										BGL_OBJECT_CLASS_NUM(
										((BgL_objectz00_bglt)
											((BgL_globalz00_bglt) BgL_o1127z00_2621)));
									BgL_arg1760z00_2742 = BgL_res2034z00_2743;
								}
								BgL_arg1759z00_2741 = (BgL_arg1760z00_2742 - OBJECT_TYPE);
							}
							BgL_arg1858z00_2740 =
								VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
								BgL_arg1759z00_2741);
						}
						BgL_arg1856z00_2739 =
							BGl_classzd2superzd2zz__objectz00(BgL_arg1858z00_2740);
					}
					{	/* Cfa/specialize.scm 35 */
						long BgL_res2036z00_2744;

						{	/* Cfa/specialize.scm 35 */
							obj_t BgL_tmpz00_3400;

							BgL_tmpz00_3400 = ((obj_t) BgL_arg1856z00_2739);
							BgL_res2036z00_2744 = BGL_CLASS_INDEX(BgL_tmpz00_3400);
						}
						BgL_arg1855z00_2738 = BgL_res2036z00_2744;
				}}
				BGL_OBJECT_CLASS_NUM_SET(
					((BgL_objectz00_bglt)
						((BgL_globalz00_bglt) BgL_o1127z00_2621)), BgL_arg1855z00_2738);
			}
			{	/* Cfa/specialize.scm 35 */
				BgL_objectz00_bglt BgL_tmpz00_3406;

				BgL_tmpz00_3406 =
					((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_o1127z00_2621));
				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3406, BFALSE);
			}
			return ((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1127z00_2621));
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1853> */
	obj_t BGl_z62zc3anonymousza31853ze3ze1zzcfa_specializa7eza7(obj_t
		BgL_envz00_2622, obj_t BgL_new1126z00_2623)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 35 */
			{
				BgL_globalz00_bglt BgL_auxz00_3412;

				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_new1126z00_2623))))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 12))), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_3420;

					{	/* Cfa/specialize.scm 35 */
						obj_t BgL_classz00_2746;

						BgL_classz00_2746 = BGl_typez00zztype_typez00;
						{	/* Cfa/specialize.scm 35 */
							obj_t BgL__ortest_1105z00_2747;

							BgL__ortest_1105z00_2747 = BGL_CLASS_NIL(BgL_classz00_2746);
							if (CBOOL(BgL__ortest_1105z00_2747))
								{	/* Cfa/specialize.scm 35 */
									BgL_auxz00_3420 =
										((BgL_typez00_bglt) BgL__ortest_1105z00_2747);
								}
							else
								{	/* Cfa/specialize.scm 35 */
									BgL_auxz00_3420 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2746));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_globalz00_bglt) BgL_new1126z00_2623))))->
							BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_3420), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_3430;

					{	/* Cfa/specialize.scm 35 */
						obj_t BgL_classz00_2748;

						BgL_classz00_2748 = BGl_valuez00zzast_varz00;
						{	/* Cfa/specialize.scm 35 */
							obj_t BgL__ortest_1105z00_2749;

							BgL__ortest_1105z00_2749 = BGL_CLASS_NIL(BgL_classz00_2748);
							if (CBOOL(BgL__ortest_1105z00_2749))
								{	/* Cfa/specialize.scm 35 */
									BgL_auxz00_3430 =
										((BgL_valuez00_bglt) BgL__ortest_1105z00_2749);
								}
							else
								{	/* Cfa/specialize.scm 35 */
									BgL_auxz00_3430 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2748));
								}
						}
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_globalz00_bglt) BgL_new1126z00_2623))))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_3430), BUNSPEC);
				}
				((((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_new1126z00_2623))))->
						BgL_accessz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt)
							COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_modulez00) =
					((obj_t) CNST_TABLE_REF(((long) 12))), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_importz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_evaluablezf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_evalzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_libraryz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_pragmaz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_srcz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_jvmzd2typezd2namez00) =
					((obj_t) BGl_string2074z00zzcfa_specializa7eza7), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_initz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_globalz00_bglt)
							COBJECT(((BgL_globalz00_bglt) ((BgL_globalz00_bglt)
										BgL_new1126z00_2623))))->BgL_aliasz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3489;

					{
						obj_t BgL_auxz00_3490;

						{	/* Cfa/specialize.scm 35 */
							BgL_objectz00_bglt BgL_tmpz00_3491;

							BgL_tmpz00_3491 =
								((BgL_objectz00_bglt)
								((BgL_globalz00_bglt) BgL_new1126z00_2623));
							BgL_auxz00_3490 = BGL_OBJECT_WIDENING(BgL_tmpz00_3491);
						}
						BgL_auxz00_3489 =
							((BgL_specializa7edzd2globalz75_bglt) BgL_auxz00_3490);
					}
					((((BgL_specializa7edzd2globalz75_bglt) COBJECT(BgL_auxz00_3489))->
							BgL_fixz00) = ((obj_t) BUNSPEC), BUNSPEC);
				}
				BgL_auxz00_3412 = ((BgL_globalz00_bglt) BgL_new1126z00_2623);
				return ((obj_t) BgL_auxz00_3412);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1851 */
	BgL_globalz00_bglt BGl_z62lambda1851z62zzcfa_specializa7eza7(obj_t
		BgL_envz00_2624, obj_t BgL_o1123z00_2625)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 35 */
			{	/* Cfa/specialize.scm 35 */
				BgL_specializa7edzd2globalz75_bglt BgL_wide1125z00_2751;

				BgL_wide1125z00_2751 =
					((BgL_specializa7edzd2globalz75_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_specializa7edzd2globalz75_bgl))));
				{	/* Cfa/specialize.scm 35 */
					obj_t BgL_auxz00_3504;
					BgL_objectz00_bglt BgL_tmpz00_3500;

					BgL_auxz00_3504 = ((obj_t) BgL_wide1125z00_2751);
					BgL_tmpz00_3500 =
						((BgL_objectz00_bglt)
						((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1123z00_2625)));
					BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3500, BgL_auxz00_3504);
				}
				{	/* Cfa/specialize.scm 35 */
					long BgL_arg1852z00_2752;

					{	/* Cfa/specialize.scm 35 */
						long BgL_res2033z00_2753;

						BgL_res2033z00_2753 =
							BGL_CLASS_INDEX
							(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
						BgL_arg1852z00_2752 = BgL_res2033z00_2753;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt)
							((BgL_globalz00_bglt)
								((BgL_globalz00_bglt) BgL_o1123z00_2625))),
						BgL_arg1852z00_2752);
				}
				return
					((BgL_globalz00_bglt)
					((BgL_globalz00_bglt) ((BgL_globalz00_bglt) BgL_o1123z00_2625)));
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1848 */
	BgL_globalz00_bglt BGl_z62lambda1848z62zzcfa_specializa7eza7(obj_t
		BgL_envz00_2626, obj_t BgL_id1102z00_2627, obj_t BgL_name1103z00_2628,
		obj_t BgL_type1104z00_2629, obj_t BgL_value1105z00_2630,
		obj_t BgL_access1106z00_2631, obj_t BgL_fastzd2alpha1107zd2_2632,
		obj_t BgL_removable1108z00_2633, obj_t BgL_occurrence1109z00_2634,
		obj_t BgL_occurrencew1110z00_2635, obj_t BgL_userzf31111zf3_2636,
		obj_t BgL_module1112z00_2637, obj_t BgL_import1113z00_2638,
		obj_t BgL_evaluablezf31114zf3_2639, obj_t BgL_evalzf31115zf3_2640,
		obj_t BgL_library1116z00_2641, obj_t BgL_pragma1117z00_2642,
		obj_t BgL_src1118z00_2643, obj_t BgL_jvmzd2typezd2name1119z00_2644,
		obj_t BgL_init1120z00_2645, obj_t BgL_alias1121z00_2646,
		obj_t BgL_fix1122z00_2647)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 35 */
			{	/* Cfa/specialize.scm 35 */
				long BgL_occurrence1109z00_2757;
				long BgL_occurrencew1110z00_2758;
				bool_t BgL_userzf31111zf3_2759;
				bool_t BgL_evaluablezf31114zf3_2761;
				bool_t BgL_evalzf31115zf3_2762;

				BgL_occurrence1109z00_2757 = (long) CINT(BgL_occurrence1109z00_2634);
				BgL_occurrencew1110z00_2758 = (long) CINT(BgL_occurrencew1110z00_2635);
				BgL_userzf31111zf3_2759 = CBOOL(BgL_userzf31111zf3_2636);
				BgL_evaluablezf31114zf3_2761 = CBOOL(BgL_evaluablezf31114zf3_2639);
				BgL_evalzf31115zf3_2762 = CBOOL(BgL_evalzf31115zf3_2640);
				{	/* Cfa/specialize.scm 35 */
					BgL_globalz00_bglt BgL_new1183z00_2764;

					{	/* Cfa/specialize.scm 35 */
						BgL_globalz00_bglt BgL_tmp1180z00_2765;
						BgL_specializa7edzd2globalz75_bglt BgL_wide1181z00_2766;

						{
							BgL_globalz00_bglt BgL_auxz00_3520;

							{	/* Cfa/specialize.scm 35 */
								BgL_globalz00_bglt BgL_new1179z00_2767;

								BgL_new1179z00_2767 =
									((BgL_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_globalz00_bgl))));
								{	/* Cfa/specialize.scm 35 */
									long BgL_arg1850z00_2768;

									{	/* Cfa/specialize.scm 35 */
										long BgL_res2031z00_2769;

										BgL_res2031z00_2769 =
											BGL_CLASS_INDEX(BGl_globalz00zzast_varz00);
										BgL_arg1850z00_2768 = BgL_res2031z00_2769;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1179z00_2767),
										BgL_arg1850z00_2768);
								}
								{	/* Cfa/specialize.scm 35 */
									BgL_objectz00_bglt BgL_tmpz00_3525;

									BgL_tmpz00_3525 = ((BgL_objectz00_bglt) BgL_new1179z00_2767);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3525, BFALSE);
								}
								BgL_auxz00_3520 = BgL_new1179z00_2767;
							}
							BgL_tmp1180z00_2765 = ((BgL_globalz00_bglt) BgL_auxz00_3520);
						}
						BgL_wide1181z00_2766 =
							((BgL_specializa7edzd2globalz75_bglt)
							BOBJECT(GC_MALLOC(sizeof(struct
										BgL_specializa7edzd2globalz75_bgl))));
						{	/* Cfa/specialize.scm 35 */
							obj_t BgL_auxz00_3532;
							BgL_objectz00_bglt BgL_tmpz00_3530;

							BgL_auxz00_3532 = ((obj_t) BgL_wide1181z00_2766);
							BgL_tmpz00_3530 = ((BgL_objectz00_bglt) BgL_tmp1180z00_2765);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3530, BgL_auxz00_3532);
						}
						{	/* Cfa/specialize.scm 35 */
							long BgL_arg1849z00_2770;

							{	/* Cfa/specialize.scm 35 */
								long BgL_res2032z00_2771;

								BgL_res2032z00_2771 =
									BGL_CLASS_INDEX
									(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
								BgL_arg1849z00_2770 = BgL_res2032z00_2771;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_tmp1180z00_2765),
								BgL_arg1849z00_2770);
						}
						BgL_new1183z00_2764 = ((BgL_globalz00_bglt) BgL_tmp1180z00_2765);
					}
					((((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_new1183z00_2764)))->BgL_idz00) =
						((obj_t) ((obj_t) BgL_id1102z00_2627)), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_namez00) =
						((obj_t) BgL_name1103z00_2628), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_type1104z00_2629)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_valuez00) =
						((BgL_valuez00_bglt) ((BgL_valuez00_bglt) BgL_value1105z00_2630)),
						BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_accessz00) =
						((obj_t) BgL_access1106z00_2631), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1107zd2_2632), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_removablez00) =
						((obj_t) BgL_removable1108z00_2633), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_occurrencez00) =
						((long) BgL_occurrence1109z00_2757), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1110z00_2758), BUNSPEC);
					((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
										BgL_new1183z00_2764)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31111zf3_2759), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_modulez00) =
						((obj_t) ((obj_t) BgL_module1112z00_2637)), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_importz00) =
						((obj_t) BgL_import1113z00_2638), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_evaluablezf3zf3) =
						((bool_t) BgL_evaluablezf31114zf3_2761), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_evalzf3zf3) =
						((bool_t) BgL_evalzf31115zf3_2762), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_libraryz00) =
						((obj_t) BgL_library1116z00_2641), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_pragmaz00) =
						((obj_t) BgL_pragma1117z00_2642), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_srcz00) =
						((obj_t) BgL_src1118z00_2643), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_jvmzd2typezd2namez00) =
						((obj_t) ((obj_t) BgL_jvmzd2typezd2name1119z00_2644)), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_initz00) =
						((obj_t) BgL_init1120z00_2645), BUNSPEC);
					((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
										BgL_new1183z00_2764)))->BgL_aliasz00) =
						((obj_t) BgL_alias1121z00_2646), BUNSPEC);
					{
						BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3584;

						{
							obj_t BgL_auxz00_3585;

							{	/* Cfa/specialize.scm 35 */
								BgL_objectz00_bglt BgL_tmpz00_3586;

								BgL_tmpz00_3586 = ((BgL_objectz00_bglt) BgL_new1183z00_2764);
								BgL_auxz00_3585 = BGL_OBJECT_WIDENING(BgL_tmpz00_3586);
							}
							BgL_auxz00_3584 =
								((BgL_specializa7edzd2globalz75_bglt) BgL_auxz00_3585);
						}
						((((BgL_specializa7edzd2globalz75_bglt) COBJECT(BgL_auxz00_3584))->
								BgL_fixz00) = ((obj_t) BgL_fix1122z00_2647), BUNSPEC);
					}
					return BgL_new1183z00_2764;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1864 */
	obj_t BGl_z62lambda1864z62zzcfa_specializa7eza7(obj_t BgL_envz00_2648,
		obj_t BgL_oz00_2649, obj_t BgL_vz00_2650)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 35 */
			{
				BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3591;

				{
					obj_t BgL_auxz00_3592;

					{	/* Cfa/specialize.scm 35 */
						BgL_objectz00_bglt BgL_tmpz00_3593;

						BgL_tmpz00_3593 =
							((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_oz00_2649));
						BgL_auxz00_3592 = BGL_OBJECT_WIDENING(BgL_tmpz00_3593);
					}
					BgL_auxz00_3591 =
						((BgL_specializa7edzd2globalz75_bglt) BgL_auxz00_3592);
				}
				return
					((((BgL_specializa7edzd2globalz75_bglt) COBJECT(BgL_auxz00_3591))->
						BgL_fixz00) = ((obj_t) BgL_vz00_2650), BUNSPEC);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1863 */
	obj_t BGl_z62lambda1863z62zzcfa_specializa7eza7(obj_t BgL_envz00_2651,
		obj_t BgL_oz00_2652)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 35 */
			{
				BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3599;

				{
					obj_t BgL_auxz00_3600;

					{	/* Cfa/specialize.scm 35 */
						BgL_objectz00_bglt BgL_tmpz00_3601;

						BgL_tmpz00_3601 =
							((BgL_objectz00_bglt) ((BgL_globalz00_bglt) BgL_oz00_2652));
						BgL_auxz00_3600 = BGL_OBJECT_WIDENING(BgL_tmpz00_3601);
					}
					BgL_auxz00_3599 =
						((BgL_specializa7edzd2globalz75_bglt) BgL_auxz00_3600);
				}
				return
					(((BgL_specializa7edzd2globalz75_bglt) COBJECT(BgL_auxz00_3599))->
					BgL_fixz00);
			}
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_proc2075z00zzcfa_specializa7eza7, BGl_nodez00zzast_nodez00,
				BGl_string2076z00zzcfa_specializa7eza7);
		}
		BGL_FUNCTION_END;
	}



/* &patch!1376 */
	obj_t BGl_z62patchz121376z70zzcfa_specializa7eza7(obj_t BgL_envz00_2654,
		obj_t BgL_nodez00_2655)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 326 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 13)),
				BGl_string2077z00zzcfa_specializa7eza7,
				((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2655)));
		}
		BGL_FUNCTION_END;
	}



/* patch! */
	obj_t BGl_patchz12z12zzcfa_specializa7eza7(BgL_nodez00_bglt BgL_nodez00_97)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 326 */
			{	/* Cfa/specialize.scm 326 */
				obj_t BgL_method1377z00_1927;

				{	/* Cfa/specialize.scm 326 */
					obj_t BgL_res2048z00_2582;

					{	/* Cfa/specialize.scm 326 */
						long BgL_objzd2classzd2numz00_2539;

						{	/* Cfa/specialize.scm 326 */
							long BgL_res2037z00_2542;

							BgL_res2037z00_2542 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_97));
							BgL_objzd2classzd2numz00_2539 = BgL_res2037z00_2542;
						}
						{	/* Cfa/specialize.scm 326 */
							obj_t BgL_arg1756z00_2540;

							BgL_arg1756z00_2540 =
								PROCEDURE_REF(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
								(int) (((long) 1)));
							{	/* Cfa/specialize.scm 326 */
								int BgL_offsetz00_2544;

								BgL_offsetz00_2544 = (int) (BgL_objzd2classzd2numz00_2539);
								{	/* Cfa/specialize.scm 326 */
									long BgL_offsetz00_2545;

									BgL_offsetz00_2545 =
										((long) (BgL_offsetz00_2544) - OBJECT_TYPE);
									{	/* Cfa/specialize.scm 326 */
										long BgL_modz00_2546;

										{	/* Cfa/specialize.scm 326 */
											int BgL_arg1758z00_2547;

											BgL_arg1758z00_2547 = (int) (((long) 16));
											{	/* Cfa/specialize.scm 326 */
												long BgL_res2040z00_2557;

												{	/* Cfa/specialize.scm 326 */
													long BgL_tmpz00_3620;

													BgL_tmpz00_3620 = (long) (BgL_arg1758z00_2547);
													BgL_res2040z00_2557 =
														(BgL_offsetz00_2545 / BgL_tmpz00_3620);
												}
												BgL_modz00_2546 = BgL_res2040z00_2557;
										}}
										{	/* Cfa/specialize.scm 326 */
											long BgL_restz00_2548;

											{	/* Cfa/specialize.scm 326 */
												int BgL_arg1757z00_2549;

												BgL_arg1757z00_2549 = (int) (((long) 16));
												{	/* Cfa/specialize.scm 326 */
													long BgL_res2047z00_2577;

													{	/* Cfa/specialize.scm 326 */
														long BgL_n1z00_2559;
														long BgL_n2z00_2560;

														BgL_n1z00_2559 = BgL_offsetz00_2545;
														BgL_n2z00_2560 = (long) (BgL_arg1757z00_2549);
														{	/* Cfa/specialize.scm 326 */
															bool_t BgL_testz00_3625;

															{	/* Cfa/specialize.scm 326 */
																long BgL_arg1292z00_2562;

																BgL_arg1292z00_2562 =
																	(((BgL_n1z00_2559) | (BgL_n2z00_2560)) &
																	-2147483648);
																BgL_testz00_3625 =
																	(BgL_arg1292z00_2562 == ((long) 0));
															}
															if (BgL_testz00_3625)
																{	/* Cfa/specialize.scm 326 */
																	int32_t BgL_arg1285z00_2563;

																	{	/* Cfa/specialize.scm 326 */
																		int32_t BgL_arg1287z00_2564;
																		int32_t BgL_arg1290z00_2565;

																		{	/* Cfa/specialize.scm 326 */
																			int32_t BgL_res2043z00_2569;

																			BgL_res2043z00_2569 =
																				(int32_t) (BgL_n1z00_2559);
																			BgL_arg1287z00_2564 = BgL_res2043z00_2569;
																		}
																		{	/* Cfa/specialize.scm 326 */
																			int32_t BgL_res2044z00_2571;

																			BgL_res2044z00_2571 =
																				(int32_t) (BgL_n2z00_2560);
																			BgL_arg1290z00_2565 = BgL_res2044z00_2571;
																		}
																		BgL_arg1285z00_2563 =
																			(BgL_arg1287z00_2564 %
																			BgL_arg1290z00_2565);
																	}
																	{	/* Cfa/specialize.scm 326 */
																		long BgL_res2046z00_2576;

																		{	/* Cfa/specialize.scm 326 */
																			long BgL_arg1411z00_2573;

																			BgL_arg1411z00_2573 =
																				(long) (BgL_arg1285z00_2563);
																			{	/* Cfa/specialize.scm 326 */
																				long BgL_res2045z00_2575;

																				BgL_res2045z00_2575 =
																					(long) (BgL_arg1411z00_2573);
																				BgL_res2046z00_2576 =
																					BgL_res2045z00_2575;
																		}}
																		BgL_res2047z00_2577 = BgL_res2046z00_2576;
																}}
															else
																{	/* Cfa/specialize.scm 326 */
																	BgL_res2047z00_2577 =
																		(BgL_n1z00_2559 % BgL_n2z00_2560);
																}
														}
													}
													BgL_restz00_2548 = BgL_res2047z00_2577;
												}
											}
											{	/* Cfa/specialize.scm 326 */

												{	/* Cfa/specialize.scm 326 */
													obj_t BgL_bucketz00_2550;

													BgL_bucketz00_2550 =
														VECTOR_REF(
														((obj_t) BgL_arg1756z00_2540), BgL_modz00_2546);
													BgL_res2048z00_2582 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2550), BgL_restz00_2548);
												}
											}
										}
									}
								}
							}
						}
					}
					BgL_method1377z00_1927 = BgL_res2048z00_2582;
				}
				return
					PROCEDURE_ENTRY(BgL_method1377z00_1927) (BgL_method1377z00_1927,
					((obj_t) BgL_nodez00_97), BEOA);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch! */
	obj_t BGl_z62patchz12z70zzcfa_specializa7eza7(obj_t BgL_envz00_2656,
		obj_t BgL_nodez00_2657)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 326 */
			return
				BGl_patchz12z12zzcfa_specializa7eza7(
				((BgL_nodez00_bglt) BgL_nodez00_2657));
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_atomz00zzast_nodez00,
				BGl_proc2078z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_kwotez00zzast_nodez00,
				BGl_proc2080z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_varz00zzast_nodez00,
				BGl_proc2081z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_closurez00zzast_nodez00, BGl_proc2082z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_sequencez00zzast_nodez00, BGl_proc2083z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_syncz00zzast_nodez00,
				BGl_proc2084z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2085z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_funcallz00zzast_nodez00, BGl_proc2086z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_externz00zzast_nodez00,
				BGl_proc2087z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_castz00zzast_nodez00,
				BGl_proc2088z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_setqz00zzast_nodez00,
				BGl_proc2089z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_conditionalz00zzast_nodez00, BGl_proc2090z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_failz00zzast_nodez00,
				BGl_proc2091z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_switchz00zzast_nodez00,
				BGl_proc2092z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2093z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2094z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2095z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc2096z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2097z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2098z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2099z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_appz00zzast_nodez00,
				BGl_proc2100z00zzcfa_specializa7eza7,
				BGl_string2079z00zzcfa_specializa7eza7);
		}
		BGL_FUNCTION_END;
	}



/* &patch!-app1423 */
	obj_t BGl_z62patchz12zd2app1423za2zzcfa_specializa7eza7(obj_t BgL_envz00_2680,
		obj_t BgL_nodez00_2681)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 537 */
			{
				BgL_appz00_bglt BgL_auxz00_3667;

				BGl_patchza2z12zb0zzcfa_specializa7eza7(
					(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2681)))->BgL_argsz00));
				{
					BgL_varz00_bglt BgL_auxz00_3671;

					{	/* Cfa/specialize.scm 540 */
						BgL_varz00_bglt BgL_arg1929z00_2776;

						BgL_arg1929z00_2776 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nodez00_2681)))->BgL_funz00);
						BgL_auxz00_3671 =
							((BgL_varz00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(
								((BgL_nodez00_bglt) BgL_arg1929z00_2776)));
					}
					((((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nodez00_2681)))->BgL_funz00) =
						((BgL_varz00_bglt) BgL_auxz00_3671), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 541 */
					BgL_variablez00_bglt BgL_vz00_2777;

					BgL_vz00_2777 =
						(((BgL_varz00_bglt) COBJECT(
								(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_2681)))->BgL_funz00)))->
						BgL_variablez00);
					{	/* Cfa/specialize.scm 543 */
						bool_t BgL_testz00_3682;

						{	/* Cfa/specialize.scm 543 */
							bool_t BgL_res2052z00_2778;

							BgL_res2052z00_2778 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_vz00_2777),
								BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
							BgL_testz00_3682 = BgL_res2052z00_2778;
						}
						if (BgL_testz00_3682)
							{	/* Cfa/specialize.scm 543 */
								BgL_auxz00_3667 =
									BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(
									((BgL_appz00_bglt) BgL_nodez00_2681));
							}
						else
							{	/* Cfa/specialize.scm 543 */
								BgL_auxz00_3667 = ((BgL_appz00_bglt) BgL_nodez00_2681);
							}
					}
				}
				return ((obj_t) BgL_auxz00_3667);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-box-ref1421 */
	obj_t BGl_z62patchz12zd2boxzd2ref1421z70zzcfa_specializa7eza7(obj_t
		BgL_envz00_2682, obj_t BgL_nodez00_2683)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 518 */
			{
				BgL_boxzd2refzd2_bglt BgL_auxz00_3689;

				{
					BgL_varz00_bglt BgL_auxz00_3690;

					{	/* Cfa/specialize.scm 520 */
						BgL_varz00_bglt BgL_arg1927z00_2780;

						BgL_arg1927z00_2780 =
							(((BgL_boxzd2refzd2_bglt) COBJECT(
									((BgL_boxzd2refzd2_bglt) BgL_nodez00_2683)))->BgL_varz00);
						BgL_auxz00_3690 =
							((BgL_varz00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(
								((BgL_nodez00_bglt) BgL_arg1927z00_2780)));
					}
					((((BgL_boxzd2refzd2_bglt) COBJECT(
									((BgL_boxzd2refzd2_bglt) BgL_nodez00_2683)))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_3690), BUNSPEC);
				}
				BgL_auxz00_3689 = ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2683);
				return ((obj_t) BgL_auxz00_3689);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-box-set!1419 */
	obj_t BGl_z62patchz12zd2boxzd2setz121419z62zzcfa_specializa7eza7(obj_t
		BgL_envz00_2684, obj_t BgL_nodez00_2685)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 509 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_auxz00_3700;

				{
					BgL_varz00_bglt BgL_auxz00_3701;

					{	/* Cfa/specialize.scm 511 */
						BgL_varz00_bglt BgL_arg1925z00_2782;

						BgL_arg1925z00_2782 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685)))->BgL_varz00);
						BgL_auxz00_3701 =
							((BgL_varz00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(
								((BgL_nodez00_bglt) BgL_arg1925z00_2782)));
					}
					((((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685)))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_3701), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3709;

					{	/* Cfa/specialize.scm 512 */
						BgL_nodez00_bglt BgL_arg1926z00_2783;

						BgL_arg1926z00_2783 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685)))->
							BgL_valuez00);
						BgL_auxz00_3709 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1926z00_2783));
					}
					((((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685)))->
							BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3709), BUNSPEC);
				}
				BgL_auxz00_3700 = ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2685);
				return ((obj_t) BgL_auxz00_3700);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-make-box1417 */
	obj_t BGl_z62patchz12zd2makezd2box1417z70zzcfa_specializa7eza7(obj_t
		BgL_envz00_2686, obj_t BgL_nodez00_2687)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 501 */
			{
				BgL_makezd2boxzd2_bglt BgL_auxz00_3718;

				{
					BgL_nodez00_bglt BgL_auxz00_3719;

					{	/* Cfa/specialize.scm 503 */
						BgL_nodez00_bglt BgL_arg1924z00_2785;

						BgL_arg1924z00_2785 =
							(((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_2687)))->BgL_valuez00);
						BgL_auxz00_3719 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1924z00_2785));
					}
					((((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_2687)))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3719), BUNSPEC);
				}
				BgL_auxz00_3718 = ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2687);
				return ((obj_t) BgL_auxz00_3718);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-jump-ex-it1415 */
	obj_t BGl_z62patchz12zd2jumpzd2exzd2it1415za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2688, obj_t BgL_nodez00_2689)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 492 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3728;

				{
					BgL_nodez00_bglt BgL_auxz00_3729;

					{	/* Cfa/specialize.scm 494 */
						BgL_nodez00_bglt BgL_arg1922z00_2787;

						BgL_arg1922z00_2787 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2689)))->
							BgL_exitz00);
						BgL_auxz00_3729 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1922z00_2787));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2689)))->
							BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3729), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3736;

					{	/* Cfa/specialize.scm 495 */
						BgL_nodez00_bglt BgL_arg1923z00_2788;

						BgL_arg1923z00_2788 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2689)))->
							BgL_valuez00);
						BgL_auxz00_3736 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1923z00_2788));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2689)))->
							BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3736), BUNSPEC);
				}
				BgL_auxz00_3728 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2689);
				return ((obj_t) BgL_auxz00_3728);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-set-ex-it1413 */
	obj_t BGl_z62patchz12zd2setzd2exzd2it1413za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2690, obj_t BgL_nodez00_2691)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 483 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_auxz00_3745;

				{
					BgL_nodez00_bglt BgL_auxz00_3746;

					{	/* Cfa/specialize.scm 485 */
						BgL_nodez00_bglt BgL_arg1920z00_2790;

						BgL_arg1920z00_2790 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2691)))->
							BgL_bodyz00);
						BgL_auxz00_3746 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1920z00_2790));
					}
					((((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2691)))->
							BgL_bodyz00) = ((BgL_nodez00_bglt) BgL_auxz00_3746), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 486 */
					BgL_varz00_bglt BgL_arg1921z00_2791;

					BgL_arg1921z00_2791 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2691)))->BgL_varz00);
					BGl_patchz12z12zzcfa_specializa7eza7(
						((BgL_nodez00_bglt) BgL_arg1921z00_2791));
				}
				BgL_auxz00_3745 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2691);
				return ((obj_t) BgL_auxz00_3745);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-let-var1411 */
	obj_t BGl_z62patchz12zd2letzd2var1411z70zzcfa_specializa7eza7(obj_t
		BgL_envz00_2692, obj_t BgL_nodez00_2693)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 468 */
			{
				BgL_letzd2varzd2_bglt BgL_auxz00_3759;

				{	/* Cfa/specialize.scm 470 */
					obj_t BgL_g1373z00_2793;

					BgL_g1373z00_2793 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2693)))->BgL_bindingsz00);
					{
						obj_t BgL_l1371z00_2795;

						BgL_l1371z00_2795 = BgL_g1373z00_2793;
					BgL_zc3anonymousza31911ze3z83_2794:
						if (PAIRP(BgL_l1371z00_2795))
							{	/* Cfa/specialize.scm 470 */
								{	/* Cfa/specialize.scm 471 */
									obj_t BgL_bindingz00_2796;

									BgL_bindingz00_2796 = CAR(BgL_l1371z00_2795);
									{	/* Cfa/specialize.scm 471 */
										obj_t BgL_valz00_2797;

										BgL_valz00_2797 = CDR(((obj_t) BgL_bindingz00_2796));
										{	/* Cfa/specialize.scm 472 */
											obj_t BgL_arg1913z00_2798;

											BgL_arg1913z00_2798 =
												BGl_patchz12z12zzcfa_specializa7eza7(
												((BgL_nodez00_bglt) BgL_valz00_2797));
											{	/* Cfa/specialize.scm 472 */
												obj_t BgL_tmpz00_3769;

												BgL_tmpz00_3769 = ((obj_t) BgL_bindingz00_2796);
												SET_CDR(BgL_tmpz00_3769, BgL_arg1913z00_2798);
											}
										}
									}
								}
								{
									obj_t BgL_l1371z00_3772;

									BgL_l1371z00_3772 = CDR(BgL_l1371z00_2795);
									BgL_l1371z00_2795 = BgL_l1371z00_3772;
									goto BgL_zc3anonymousza31911ze3z83_2794;
								}
							}
						else
							{	/* Cfa/specialize.scm 470 */
								((bool_t) 1);
							}
					}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3774;

					{	/* Cfa/specialize.scm 474 */
						BgL_nodez00_bglt BgL_arg1916z00_2799;

						BgL_arg1916z00_2799 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_2693)))->BgL_bodyz00);
						BgL_auxz00_3774 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1916z00_2799));
					}
					((((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nodez00_2693)))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3774), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 475 */
					bool_t BgL_testz00_3781;

					{	/* Cfa/specialize.scm 475 */
						BgL_typez00_bglt BgL_arg1919z00_2800;

						BgL_arg1919z00_2800 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_letzd2varzd2_bglt) BgL_nodez00_2693))))->BgL_typez00);
						BgL_testz00_3781 =
							(
							((obj_t) BgL_arg1919z00_2800) == BGl_za2objza2z00zztype_cachez00);
					}
					if (BgL_testz00_3781)
						{	/* Cfa/specialize.scm 475 */
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												((BgL_letzd2varzd2_bglt) BgL_nodez00_2693))))->
									BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodez00_bglt)
										COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt)
													BgL_nodez00_2693))))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt) (
												(BgL_letzd2varzd2_bglt) BgL_nodez00_2693)),
										((bool_t) 0))), BUNSPEC);
						}
					else
						{	/* Cfa/specialize.scm 475 */
							BFALSE;
						}
				}
				BgL_auxz00_3759 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_2693);
				return ((obj_t) BgL_auxz00_3759);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-let-fun1409 */
	obj_t BGl_z62patchz12zd2letzd2fun1409z70zzcfa_specializa7eza7(obj_t
		BgL_envz00_2694, obj_t BgL_nodez00_2695)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 456 */
			{
				BgL_letzd2funzd2_bglt BgL_auxz00_3799;

				{	/* Cfa/specialize.scm 458 */
					obj_t BgL_g1370z00_2802;

					BgL_g1370z00_2802 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2695)))->BgL_localsz00);
					{
						obj_t BgL_l1368z00_2804;

						BgL_l1368z00_2804 = BgL_g1370z00_2802;
					BgL_zc3anonymousza31903ze3z83_2803:
						if (PAIRP(BgL_l1368z00_2804))
							{	/* Cfa/specialize.scm 458 */
								BGl_patchzd2funz12zc0zzcfa_specializa7eza7(CAR
									(BgL_l1368z00_2804));
								{
									obj_t BgL_l1368z00_3806;

									BgL_l1368z00_3806 = CDR(BgL_l1368z00_2804);
									BgL_l1368z00_2804 = BgL_l1368z00_3806;
									goto BgL_zc3anonymousza31903ze3z83_2803;
								}
							}
						else
							{	/* Cfa/specialize.scm 458 */
								((bool_t) 1);
							}
					}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3808;

					{	/* Cfa/specialize.scm 459 */
						BgL_nodez00_bglt BgL_arg1907z00_2805;

						BgL_arg1907z00_2805 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nodez00_2695)))->BgL_bodyz00);
						BgL_auxz00_3808 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1907z00_2805));
					}
					((((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nodez00_2695)))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3808), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 460 */
					bool_t BgL_testz00_3815;

					{	/* Cfa/specialize.scm 460 */
						BgL_typez00_bglt BgL_arg1910z00_2806;

						BgL_arg1910z00_2806 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_letzd2funzd2_bglt) BgL_nodez00_2695))))->BgL_typez00);
						BgL_testz00_3815 =
							(
							((obj_t) BgL_arg1910z00_2806) == BGl_za2objza2z00zztype_cachez00);
					}
					if (BgL_testz00_3815)
						{	/* Cfa/specialize.scm 460 */
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												((BgL_letzd2funzd2_bglt) BgL_nodez00_2695))))->
									BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodez00_bglt)
										COBJECT(((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt)
													BgL_nodez00_2695))))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt) (
												(BgL_letzd2funzd2_bglt) BgL_nodez00_2695)),
										((bool_t) 0))), BUNSPEC);
						}
					else
						{	/* Cfa/specialize.scm 460 */
							BFALSE;
						}
				}
				BgL_auxz00_3799 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_2695);
				return ((obj_t) BgL_auxz00_3799);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-switch1407 */
	obj_t BGl_z62patchz12zd2switch1407za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2696, obj_t BgL_nodez00_2697)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 445 */
			{
				BgL_switchz00_bglt BgL_auxz00_3833;

				{
					BgL_nodez00_bglt BgL_auxz00_3834;

					{	/* Cfa/specialize.scm 447 */
						BgL_nodez00_bglt BgL_arg1897z00_2808;

						BgL_arg1897z00_2808 =
							(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nodez00_2697)))->BgL_testz00);
						BgL_auxz00_3834 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1897z00_2808));
					}
					((((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nodez00_2697)))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3834), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 448 */
					obj_t BgL_g1367z00_2809;

					BgL_g1367z00_2809 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2697)))->BgL_clausesz00);
					{
						obj_t BgL_l1365z00_2811;

						BgL_l1365z00_2811 = BgL_g1367z00_2809;
					BgL_zc3anonymousza31898ze3z83_2810:
						if (PAIRP(BgL_l1365z00_2811))
							{	/* Cfa/specialize.scm 448 */
								{	/* Cfa/specialize.scm 449 */
									obj_t BgL_clausez00_2812;

									BgL_clausez00_2812 = CAR(BgL_l1365z00_2811);
									{	/* Cfa/specialize.scm 449 */
										obj_t BgL_arg1900z00_2813;

										{	/* Cfa/specialize.scm 449 */
											obj_t BgL_arg1901z00_2814;

											BgL_arg1901z00_2814 = CDR(((obj_t) BgL_clausez00_2812));
											BgL_arg1900z00_2813 =
												BGl_patchz12z12zzcfa_specializa7eza7(
												((BgL_nodez00_bglt) BgL_arg1901z00_2814));
										}
										{	/* Cfa/specialize.scm 449 */
											obj_t BgL_tmpz00_3850;

											BgL_tmpz00_3850 = ((obj_t) BgL_clausez00_2812);
											SET_CDR(BgL_tmpz00_3850, BgL_arg1900z00_2813);
										}
									}
								}
								{
									obj_t BgL_l1365z00_3853;

									BgL_l1365z00_3853 = CDR(BgL_l1365z00_2811);
									BgL_l1365z00_2811 = BgL_l1365z00_3853;
									goto BgL_zc3anonymousza31898ze3z83_2810;
								}
							}
						else
							{	/* Cfa/specialize.scm 448 */
								((bool_t) 1);
							}
					}
				}
				BgL_auxz00_3833 = ((BgL_switchz00_bglt) BgL_nodez00_2697);
				return ((obj_t) BgL_auxz00_3833);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-fail1405 */
	obj_t BGl_z62patchz12zd2fail1405za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2698, obj_t BgL_nodez00_2699)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 435 */
			{
				BgL_failz00_bglt BgL_auxz00_3857;

				{
					BgL_nodez00_bglt BgL_auxz00_3858;

					{	/* Cfa/specialize.scm 437 */
						BgL_nodez00_bglt BgL_arg1894z00_2816;

						BgL_arg1894z00_2816 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nodez00_2699)))->BgL_procz00);
						BgL_auxz00_3858 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1894z00_2816));
					}
					((((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nodez00_2699)))->BgL_procz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3858), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3865;

					{	/* Cfa/specialize.scm 438 */
						BgL_nodez00_bglt BgL_arg1895z00_2817;

						BgL_arg1895z00_2817 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nodez00_2699)))->BgL_msgz00);
						BgL_auxz00_3865 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1895z00_2817));
					}
					((((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nodez00_2699)))->BgL_msgz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3865), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3872;

					{	/* Cfa/specialize.scm 439 */
						BgL_nodez00_bglt BgL_arg1896z00_2818;

						BgL_arg1896z00_2818 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nodez00_2699)))->BgL_objz00);
						BgL_auxz00_3872 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1896z00_2818));
					}
					((((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nodez00_2699)))->BgL_objz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3872), BUNSPEC);
				}
				BgL_auxz00_3857 = ((BgL_failz00_bglt) BgL_nodez00_2699);
				return ((obj_t) BgL_auxz00_3857);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-conditional1403 */
	obj_t BGl_z62patchz12zd2conditional1403za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2700, obj_t BgL_nodez00_2701)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 422 */
			{
				BgL_conditionalz00_bglt BgL_auxz00_3881;

				{
					BgL_nodez00_bglt BgL_auxz00_3882;

					{	/* Cfa/specialize.scm 424 */
						BgL_nodez00_bglt BgL_arg1887z00_2820;

						BgL_arg1887z00_2820 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2701)))->BgL_testz00);
						BgL_auxz00_3882 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1887z00_2820));
					}
					((((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2701)))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3882), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3889;

					{	/* Cfa/specialize.scm 425 */
						BgL_nodez00_bglt BgL_arg1888z00_2821;

						BgL_arg1888z00_2821 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2701)))->BgL_truez00);
						BgL_auxz00_3889 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1888z00_2821));
					}
					((((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2701)))->BgL_truez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3889), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3896;

					{	/* Cfa/specialize.scm 426 */
						BgL_nodez00_bglt BgL_arg1890z00_2822;

						BgL_arg1890z00_2822 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2701)))->BgL_falsez00);
						BgL_auxz00_3896 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1890z00_2822));
					}
					((((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nodez00_2701)))->
							BgL_falsez00) = ((BgL_nodez00_bglt) BgL_auxz00_3896), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 427 */
					bool_t BgL_testz00_3903;

					{	/* Cfa/specialize.scm 427 */
						BgL_typez00_bglt BgL_arg1893z00_2823;

						BgL_arg1893z00_2823 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_conditionalz00_bglt) BgL_nodez00_2701))))->
							BgL_typez00);
						BgL_testz00_3903 =
							(((obj_t) BgL_arg1893z00_2823) ==
							BGl_za2objza2z00zztype_cachez00);
					}
					if (BgL_testz00_3903)
						{	/* Cfa/specialize.scm 427 */
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												((BgL_conditionalz00_bglt) BgL_nodez00_2701))))->
									BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodez00_bglt)
										COBJECT(((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt)
													BgL_nodez00_2701))))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt) (
												(BgL_conditionalz00_bglt) BgL_nodez00_2701)),
										((bool_t) 0))), BUNSPEC);
						}
					else
						{	/* Cfa/specialize.scm 427 */
							BFALSE;
						}
				}
				BgL_auxz00_3881 = ((BgL_conditionalz00_bglt) BgL_nodez00_2701);
				return ((obj_t) BgL_auxz00_3881);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-setq1401 */
	obj_t BGl_z62patchz12zd2setq1401za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2702, obj_t BgL_nodez00_2703)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 413 */
			{
				BgL_setqz00_bglt BgL_auxz00_3921;

				{
					BgL_nodez00_bglt BgL_auxz00_3922;

					{	/* Cfa/specialize.scm 415 */
						BgL_nodez00_bglt BgL_arg1884z00_2825;

						BgL_arg1884z00_2825 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_2703)))->BgL_valuez00);
						BgL_auxz00_3922 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1884z00_2825));
					}
					((((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_2703)))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3922), BUNSPEC);
				}
				{
					BgL_varz00_bglt BgL_auxz00_3929;

					{	/* Cfa/specialize.scm 416 */
						BgL_varz00_bglt BgL_arg1886z00_2826;

						BgL_arg1886z00_2826 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_2703)))->BgL_varz00);
						BgL_auxz00_3929 =
							((BgL_varz00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(
								((BgL_nodez00_bglt) BgL_arg1886z00_2826)));
					}
					((((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nodez00_2703)))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_3929), BUNSPEC);
				}
				BgL_auxz00_3921 = ((BgL_setqz00_bglt) BgL_nodez00_2703);
				return ((obj_t) BgL_auxz00_3921);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-cast1399 */
	obj_t BGl_z62patchz12zd2cast1399za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2704, obj_t BgL_nodez00_2705)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 405 */
			{
				BgL_castz00_bglt BgL_auxz00_3939;

				BGl_patchz12z12zzcfa_specializa7eza7(
					(((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nodez00_2705)))->BgL_argz00));
				BgL_auxz00_3939 = ((BgL_castz00_bglt) BgL_nodez00_2705);
				return ((obj_t) BgL_auxz00_3939);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-extern1397 */
	obj_t BGl_z62patchz12zd2extern1397za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2706, obj_t BgL_nodez00_2707)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 397 */
			{
				BgL_externz00_bglt BgL_auxz00_3945;

				BGl_patchza2z12zb0zzcfa_specializa7eza7(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_2707)))->BgL_exprza2za2));
				BgL_auxz00_3945 = ((BgL_externz00_bglt) BgL_nodez00_2707);
				return ((obj_t) BgL_auxz00_3945);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-funcall1395 */
	obj_t BGl_z62patchz12zd2funcall1395za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2708, obj_t BgL_nodez00_2709)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 388 */
			{
				BgL_funcallz00_bglt BgL_auxz00_3951;

				{
					BgL_nodez00_bglt BgL_auxz00_3952;

					{	/* Cfa/specialize.scm 390 */
						BgL_nodez00_bglt BgL_arg1880z00_2830;

						BgL_arg1880z00_2830 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nodez00_2709)))->BgL_funz00);
						BgL_auxz00_3952 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1880z00_2830));
					}
					((((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nodez00_2709)))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3952), BUNSPEC);
				}
				BGl_patchza2z12zb0zzcfa_specializa7eza7(
					(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2709)))->BgL_argsz00));
				BgL_auxz00_3951 = ((BgL_funcallz00_bglt) BgL_nodez00_2709);
				return ((obj_t) BgL_auxz00_3951);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-app-ly1393 */
	obj_t BGl_z62patchz12zd2appzd2ly1393z70zzcfa_specializa7eza7(obj_t
		BgL_envz00_2710, obj_t BgL_nodez00_2711)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 379 */
			{
				BgL_appzd2lyzd2_bglt BgL_auxz00_3964;

				{
					BgL_nodez00_bglt BgL_auxz00_3965;

					{	/* Cfa/specialize.scm 381 */
						BgL_nodez00_bglt BgL_arg1878z00_2832;

						BgL_arg1878z00_2832 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nodez00_2711)))->BgL_funz00);
						BgL_auxz00_3965 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1878z00_2832));
					}
					((((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nodez00_2711)))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3965), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3972;

					{	/* Cfa/specialize.scm 382 */
						BgL_nodez00_bglt BgL_arg1879z00_2833;

						BgL_arg1879z00_2833 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nodez00_2711)))->BgL_argz00);
						BgL_auxz00_3972 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1879z00_2833));
					}
					((((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nodez00_2711)))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3972), BUNSPEC);
				}
				BgL_auxz00_3964 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2711);
				return ((obj_t) BgL_auxz00_3964);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-sync1391 */
	obj_t BGl_z62patchz12zd2sync1391za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2712, obj_t BgL_nodez00_2713)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 366 */
			{
				BgL_syncz00_bglt BgL_auxz00_3981;

				{
					BgL_nodez00_bglt BgL_auxz00_3982;

					{	/* Cfa/specialize.scm 368 */
						BgL_nodez00_bglt BgL_arg1872z00_2835;

						BgL_arg1872z00_2835 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nodez00_2713)))->BgL_mutexz00);
						BgL_auxz00_3982 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1872z00_2835));
					}
					((((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nodez00_2713)))->BgL_mutexz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3982), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3989;

					{	/* Cfa/specialize.scm 369 */
						BgL_nodez00_bglt BgL_arg1873z00_2836;

						BgL_arg1873z00_2836 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nodez00_2713)))->BgL_prelockz00);
						BgL_auxz00_3989 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1873z00_2836));
					}
					((((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nodez00_2713)))->BgL_prelockz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3989), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3996;

					{	/* Cfa/specialize.scm 370 */
						BgL_nodez00_bglt BgL_arg1874z00_2837;

						BgL_arg1874z00_2837 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nodez00_2713)))->BgL_bodyz00);
						BgL_auxz00_3996 =
							((BgL_nodez00_bglt)
							BGl_patchz12z12zzcfa_specializa7eza7(BgL_arg1874z00_2837));
					}
					((((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nodez00_2713)))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3996), BUNSPEC);
				}
				{	/* Cfa/specialize.scm 371 */
					bool_t BgL_testz00_4003;

					{	/* Cfa/specialize.scm 371 */
						BgL_typez00_bglt BgL_arg1877z00_2838;

						BgL_arg1877z00_2838 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_syncz00_bglt) BgL_nodez00_2713))))->BgL_typez00);
						BgL_testz00_4003 =
							(
							((obj_t) BgL_arg1877z00_2838) == BGl_za2objza2z00zztype_cachez00);
					}
					if (BgL_testz00_4003)
						{	/* Cfa/specialize.scm 371 */
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												((BgL_syncz00_bglt) BgL_nodez00_2713))))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodez00_bglt)
										COBJECT(((BgL_nodez00_bglt) ((BgL_syncz00_bglt)
													BgL_nodez00_2713))))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt) (
												(BgL_syncz00_bglt) BgL_nodez00_2713)), ((bool_t) 0))),
								BUNSPEC);
						}
					else
						{	/* Cfa/specialize.scm 371 */
							BFALSE;
						}
				}
				BgL_auxz00_3981 = ((BgL_syncz00_bglt) BgL_nodez00_2713);
				return ((obj_t) BgL_auxz00_3981);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-sequence1387 */
	obj_t BGl_z62patchz12zd2sequence1387za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2714, obj_t BgL_nodez00_2715)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 355 */
			{
				BgL_sequencez00_bglt BgL_auxz00_4021;

				BGl_patchza2z12zb0zzcfa_specializa7eza7(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2715)))->BgL_nodesz00));
				{	/* Cfa/specialize.scm 358 */
					bool_t BgL_testz00_4025;

					{	/* Cfa/specialize.scm 358 */
						BgL_typez00_bglt BgL_arg1871z00_2840;

						BgL_arg1871z00_2840 =
							(((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt)
										((BgL_sequencez00_bglt) BgL_nodez00_2715))))->BgL_typez00);
						BgL_testz00_4025 =
							(
							((obj_t) BgL_arg1871z00_2840) == BGl_za2objza2z00zztype_cachez00);
					}
					if (BgL_testz00_4025)
						{	/* Cfa/specialize.scm 358 */
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt)
												((BgL_sequencez00_bglt) BgL_nodez00_2715))))->
									BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodez00_bglt)
										COBJECT(((BgL_nodez00_bglt) ((BgL_sequencez00_bglt)
													BgL_nodez00_2715))))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_getzd2typezd2zztype_typeofz00(((BgL_nodez00_bglt) (
												(BgL_sequencez00_bglt) BgL_nodez00_2715)),
										((bool_t) 0))), BUNSPEC);
						}
					else
						{	/* Cfa/specialize.scm 358 */
							BFALSE;
						}
				}
				BgL_auxz00_4021 = ((BgL_sequencez00_bglt) BgL_nodez00_2715);
				return ((obj_t) BgL_auxz00_4021);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-closure1385 */
	obj_t BGl_z62patchz12zd2closure1385za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2716, obj_t BgL_nodez00_2717)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 349 */
			{	/* Cfa/specialize.scm 350 */
				obj_t BgL_arg1866z00_2842;

				BgL_arg1866z00_2842 =
					BGl_shapez00zztools_shapez00(
					((obj_t) ((BgL_closurez00_bglt) BgL_nodez00_2717)));
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string2079z00zzcfa_specializa7eza7,
					BGl_string2101z00zzcfa_specializa7eza7, BgL_arg1866z00_2842);
			}
		}
		BGL_FUNCTION_END;
	}



/* &patch!-var1383 */
	obj_t BGl_z62patchz12zd2var1383za2zzcfa_specializa7eza7(obj_t BgL_envz00_2718,
		obj_t BgL_nodez00_2719)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 343 */
			return ((obj_t) ((BgL_varz00_bglt) BgL_nodez00_2719));
		}
		BGL_FUNCTION_END;
	}



/* &patch!-kwote1381 */
	obj_t BGl_z62patchz12zd2kwote1381za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2720, obj_t BgL_nodez00_2721)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 337 */
			return ((obj_t) ((BgL_kwotez00_bglt) BgL_nodez00_2721));
		}
		BGL_FUNCTION_END;
	}



/* &patch!-atom1379 */
	obj_t BGl_z62patchz12zd2atom1379za2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2722, obj_t BgL_nodez00_2723)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 331 */
			return ((obj_t) ((BgL_atomz00_bglt) BgL_nodez00_2723));
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Cfa/specialize.scm 19 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 173709144),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 20504962),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
			return
				BGl_modulezd2initializa7ationz75zzinline_walkz00(((long) 385476819),
				BSTRING_TO_STRING(BGl_string2102z00zzcfa_specializa7eza7));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
