/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1340z62zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2exter1326zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sequence1347z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zztrace_walkz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2condi1330zb0zztrace_walkz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2condition1363z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1338z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1336z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21342z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_pragmaz00zzast_nodez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1377z62zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setq1328zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2switch1369z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21387zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21391zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21393zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2funcall1355z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2cast1359z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2makezd2box1379zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121383za2zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62toplevelzd2tracezd2node1384z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2ref1381zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setq1361z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1322z62zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2funca1324zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_castz00zzast_nodez00;
	static bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1351z62zztrace_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2app1320zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2fun1371zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2node1313z62zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2appzd2ly1353zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_fqnameze70ze7zztrace_walkz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2sync1318zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2extern1357z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1375z62zztrace_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_z62findzd2lastzd2nodezd2fail1332zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2seque1316zb0zztrace_walkz00(obj_t,
		obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62tracezd2node1343zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2switc1334zb0zztrace_walkz00(obj_t,
		obj_t);
	extern bool_t BGl_userzd2symbolzf3z21zzast_identz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2var1373zb0zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sync1349z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2fail1366z62zztrace_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t __cnst[21];


	   
		 
		DEFINE_STRING(BGl_string2121z00zztrace_walkz00,
		BgL_bgl_string2121za700za7za7t2165za7, "toplevel-trace-node1384", 23);
	      DEFINE_STRING(BGl_string2123z00zztrace_walkz00,
		BgL_bgl_string2123za700za7za7t2166za7, "find-last-node", 14);
	      DEFINE_STRING(BGl_string2138z00zztrace_walkz00,
		BgL_bgl_string2138za700za7za7t2167za7, "trace-node", 10);
	      DEFINE_STRING(BGl_string2157z00zztrace_walkz00,
		BgL_bgl_string2157za700za7za7t2168za7, "toplevel-trace-node", 19);
	      DEFINE_STRING(BGl_string2160z00zztrace_walkz00,
		BgL_bgl_string2160za700za7za7t2169za7, "trace_walk", 10);
	      DEFINE_STRING(BGl_string2161z00zztrace_walkz00,
		BgL_bgl_string2161za700za7za7t2170za7,
		"|:| value let $env-pop-trace $env-push-trace current-dynamic-env dynamic-env quote at location env loc name aux generic-init method-init no-trace @ imported-modules-init toplevel-init pass-started ",
		197);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl_za762traceza7d2walkza72171za7,
		BGl_z62tracezd2walkz12za2zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2172za7,
		BGl_z62findzd2lastzd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2116z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2173za7,
		BGl_z62findzd2lastzd2node1313z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2118z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2node12174z00,
		BGl_z62tracezd2node1343zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2175z00,
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2120z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2176z00,
		BGl_z62toplevelzd2tracezd2node1384z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2122z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2177za7,
		BGl_z62findzd2lastzd2nodezd2seque1316zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2124z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2178za7,
		BGl_z62findzd2lastzd2nodezd2sync1318zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2125z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2179za7,
		BGl_z62findzd2lastzd2nodezd2app1320zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2126z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2180za7,
		BGl_z62findzd2lastzd2nodezd2appzd2l1322z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2127z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2181za7,
		BGl_z62findzd2lastzd2nodezd2funca1324zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2128z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2182za7,
		BGl_z62findzd2lastzd2nodezd2exter1326zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2129z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2183za7,
		BGl_z62findzd2lastzd2nodezd2setq1328zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2130z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2184za7,
		BGl_z62findzd2lastzd2nodezd2condi1330zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2131z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2185za7,
		BGl_z62findzd2lastzd2nodezd2fail1332zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2132z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2186za7,
		BGl_z62findzd2lastzd2nodezd2switc1334zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2133z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2187za7,
		BGl_z62findzd2lastzd2nodezd2letzd2v1336z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2134z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2188za7,
		BGl_z62findzd2lastzd2nodezd2letzd2f1338z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2135z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2189za7,
		BGl_z62findzd2lastzd2nodezd2setzd2e1340z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2136z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2190za7,
		BGl_z62findzd2lastzd2nodezd2jumpzd21342z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2137z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72191za7,
		BGl_z62tracezd2nodezd2sequence1347z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2139z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72192za7,
		BGl_z62tracezd2nodezd2sync1349z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2140z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72193za7,
		BGl_z62tracezd2nodezd2app1351z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2141z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72194za7,
		BGl_z62tracezd2nodezd2appzd2ly1353zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2142z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72195za7,
		BGl_z62tracezd2nodezd2funcall1355z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2143z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72196za7,
		BGl_z62tracezd2nodezd2extern1357z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2144z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72197za7,
		BGl_z62tracezd2nodezd2cast1359z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2145z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72198za7,
		BGl_z62tracezd2nodezd2setq1361z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2146z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72199za7,
		BGl_z62tracezd2nodezd2condition1363z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2147z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72200za7,
		BGl_z62tracezd2nodezd2fail1366z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2148z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72201za7,
		BGl_z62tracezd2nodezd2switch1369z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2149z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72202za7,
		BGl_z62tracezd2nodezd2letzd2fun1371zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2150z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72203za7,
		BGl_z62tracezd2nodezd2letzd2var1373zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2151z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72204za7,
		BGl_z62tracezd2nodezd2setzd2exzd2it1375z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2152z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72205za7,
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1377z62zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2153z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72206za7,
		BGl_z62tracezd2nodezd2makezd2box1379zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2154z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72207za7,
		BGl_z62tracezd2nodezd2boxzd2ref1381zb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2155z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72208za7,
		BGl_z62tracezd2nodezd2boxzd2setz121383za2zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2156z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2209z00,
		BGl_z62toplevelzd2tracezd2nodezd21387zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2158z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2210z00,
		BGl_z62toplevelzd2tracezd2nodezd21391zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2159z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2211z00,
		BGl_z62toplevelzd2tracezd2nodezd21393zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72212za7,
		BGl_z62tracezd2nodezb0zztrace_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2106z00zztrace_walkz00,
		BgL_bgl_string2106za700za7za7t2213za7, "Trace", 5);
	      DEFINE_STRING(BGl_string2107z00zztrace_walkz00,
		BgL_bgl_string2107za700za7za7t2214za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2108z00zztrace_walkz00,
		BgL_bgl_string2108za700za7za7t2215za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2109z00zztrace_walkz00,
		BgL_bgl_string2109za700za7za7t2216za7, " error", 6);
	      DEFINE_STRING(BGl_string2110z00zztrace_walkz00,
		BgL_bgl_string2110za700za7za7t2217za7, "s", 1);
	      DEFINE_STRING(BGl_string2111z00zztrace_walkz00,
		BgL_bgl_string2111za700za7za7t2218za7, "", 0);
	      DEFINE_STRING(BGl_string2112z00zztrace_walkz00,
		BgL_bgl_string2112za700za7za7t2219za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2113z00zztrace_walkz00,
		BgL_bgl_string2113za700za7za7t2220za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string2114z00zztrace_walkz00,
		BgL_bgl_string2114za700za7za7t2221za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string2115z00zztrace_walkz00,
		BgL_bgl_string2115za700za7za7t2222za7, "%import@", 8);
	      DEFINE_STRING(BGl_string2117z00zztrace_walkz00,
		BgL_bgl_string2117za700za7za7t2223za7, "find-last-node1313", 18);
	      DEFINE_STRING(BGl_string2119z00zztrace_walkz00,
		BgL_bgl_string2119za700za7za7t2224za7, "trace-node1343", 14);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zztrace_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_2947, char *BgL_fromz00_2948)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zztrace_walkz00();
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BGl_toplevelzd2initzd2zztrace_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "trace_walk");
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_2836;

				{	/* Trace/walk.scm 15 */
					obj_t BgL_stringz00_2844;

					BgL_stringz00_2844 = BGl_string2161z00zztrace_walkz00;
					{	/* Trace/walk.scm 15 */
						obj_t BgL_startz00_2845;

						BgL_startz00_2845 = BINT(((long) 0));
						{	/* Trace/walk.scm 15 */
							obj_t BgL_endz00_2846;

							BgL_endz00_2846 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2844)));
							{	/* Trace/walk.scm 15 */

								BgL_cportz00_2836 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2844, BgL_startz00_2845, BgL_endz00_2846);
				}}}}
				{
					long BgL_iz00_2837;

					BgL_iz00_2837 = ((long) 20);
				BgL_loopz00_2838:
					if ((BgL_iz00_2837 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg2163z00_2840;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_2842;

										BgL_locationz00_2842 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg2163z00_2840 =
												BGl_readz00zz__readerz00(BgL_cportz00_2836,
												BgL_locationz00_2842);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_tmpz00_2981;

									BgL_tmpz00_2981 = (int) (BgL_iz00_2837);
									CNST_TABLE_SET(BgL_tmpz00_2981, BgL_arg2163z00_2840);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_2843;

								BgL_auxz00_2843 = (int) ((BgL_iz00_2837 - ((long) 1)));
								{
									long BgL_iz00_2986;

									BgL_iz00_2986 = (long) (BgL_auxz00_2843);
									BgL_iz00_2837 = BgL_iz00_2986;
									goto BgL_loopz00_2838;
								}
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_17)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 38 */
			{	/* Trace/walk.scm 39 */
				obj_t BgL_list1429z00_1506;

				{	/* Trace/walk.scm 39 */
					obj_t BgL_arg1441z00_1507;

					{	/* Trace/walk.scm 39 */
						obj_t BgL_arg1442z00_1508;

						BgL_arg1442z00_1508 =
							MAKE_YOUNG_PAIR(BCHAR(((unsigned char) 10)), BNIL);
						BgL_arg1441z00_1507 =
							MAKE_YOUNG_PAIR(BGl_string2106z00zztrace_walkz00,
							BgL_arg1442z00_1508);
					}
					BgL_list1429z00_1506 =
						MAKE_YOUNG_PAIR(BGl_string2107z00zztrace_walkz00,
						BgL_arg1441z00_1507);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1429z00_1506);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string2106z00zztrace_walkz00;
			{	/* Trace/walk.scm 39 */
				obj_t BgL_g1105z00_1509;

				BgL_g1105z00_1509 = BNIL;
				{
					obj_t BgL_hooksz00_1512;
					obj_t BgL_hnamesz00_1513;

					BgL_hooksz00_1512 = BgL_g1105z00_1509;
					BgL_hnamesz00_1513 = BNIL;
				BgL_zc3anonymousza31443ze3z83_1514:
					if (NULLP(BgL_hooksz00_1512))
						{	/* Trace/walk.scm 39 */
							CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Trace/walk.scm 39 */
							bool_t BgL_testz00_2999;

							{	/* Trace/walk.scm 39 */
								obj_t BgL_fun1491z00_1521;

								BgL_fun1491z00_1521 = CAR(((obj_t) BgL_hooksz00_1512));
								BgL_testz00_2999 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1491z00_1521)
									(BgL_fun1491z00_1521, BEOA));
							}
							if (BgL_testz00_2999)
								{	/* Trace/walk.scm 39 */
									obj_t BgL_arg1464z00_1518;
									obj_t BgL_arg1469z00_1519;

									BgL_arg1464z00_1518 = CDR(((obj_t) BgL_hooksz00_1512));
									BgL_arg1469z00_1519 = CDR(((obj_t) BgL_hnamesz00_1513));
									{
										obj_t BgL_hnamesz00_3011;
										obj_t BgL_hooksz00_3010;

										BgL_hooksz00_3010 = BgL_arg1464z00_1518;
										BgL_hnamesz00_3011 = BgL_arg1469z00_1519;
										BgL_hnamesz00_1513 = BgL_hnamesz00_3011;
										BgL_hooksz00_1512 = BgL_hooksz00_3010;
										goto BgL_zc3anonymousza31443ze3z83_1514;
									}
								}
							else
								{	/* Trace/walk.scm 39 */
									obj_t BgL_arg1486z00_1520;

									BgL_arg1486z00_1520 = CAR(((obj_t) BgL_hnamesz00_1513));
									BGl_internalzd2errorzd2zztools_errorz00
										(BGl_string2106z00zztrace_walkz00,
										BGl_string2108z00zztrace_walkz00, BgL_arg1486z00_1520);
								}
						}
				}
			}
			{	/* Trace/walk.scm 45 */
				obj_t BgL_idz00_1524;

				BgL_idz00_1524 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 45 */
					obj_t BgL_gloz00_1525;

					{	/* Trace/walk.scm 46 */
						obj_t BgL_list1502z00_1529;

						BgL_list1502z00_1529 =
							MAKE_YOUNG_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_1525 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1524,
							BgL_list1502z00_1529);
					}
					{	/* Trace/walk.scm 46 */

						if (BGl_isazf3zf3zz__objectz00(BgL_gloz00_1525,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 48 */
								BgL_sfunz00_bglt BgL_i1107z00_1527;

								BgL_i1107z00_1527 =
									((BgL_sfunz00_bglt)
									(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_gloz00_1525))))->
										BgL_valuez00));
								{
									obj_t BgL_auxz00_3024;

									{	/* Trace/walk.scm 49 */
										obj_t BgL_arg1501z00_1528;

										BgL_arg1501z00_1528 =
											(((BgL_sfunz00_bglt) COBJECT(BgL_i1107z00_1527))->
											BgL_bodyz00);
										BgL_auxz00_3024 =
											((obj_t)
											BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((
													(BgL_nodez00_bglt) BgL_arg1501z00_1528)));
									}
									((((BgL_sfunz00_bglt) COBJECT(BgL_i1107z00_1527))->
											BgL_bodyz00) = ((obj_t) BgL_auxz00_3024), BUNSPEC);
								}
							}
						else
							{	/* Trace/walk.scm 47 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l1301z00_1531;

				BgL_l1301z00_1531 = BgL_globalsz00_17;
			BgL_zc3anonymousza31503ze3z83_1532:
				if (PAIRP(BgL_l1301z00_1531))
					{	/* Trace/walk.scm 51 */
						{	/* Trace/walk.scm 51 */
							obj_t BgL_vz00_1534;

							BgL_vz00_1534 = CAR(BgL_l1301z00_1531);
							BGl_tracezd2funz12zc0zztrace_walkz00(BgL_vz00_1534, BNIL,
								BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00);
						}
						{
							obj_t BgL_l1301z00_3034;

							BgL_l1301z00_3034 = CDR(BgL_l1301z00_1531);
							BgL_l1301z00_1531 = BgL_l1301z00_3034;
							goto BgL_zc3anonymousza31503ze3z83_1532;
						}
					}
				else
					{	/* Trace/walk.scm 51 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 52 */
					{	/* Trace/walk.scm 52 */
						obj_t BgL_port1303z00_1539;

						{	/* Trace/walk.scm 52 */
							obj_t BgL_res2021z00_2338;

							{	/* Trace/walk.scm 52 */
								obj_t BgL_tmpz00_3039;

								BgL_tmpz00_3039 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2021z00_2338 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3039);
							}
							BgL_port1303z00_1539 = BgL_res2021z00_2338;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1303z00_1539);
						bgl_display_string(BGl_string2109z00zztrace_walkz00,
							BgL_port1303z00_1539);
						{	/* Trace/walk.scm 52 */
							obj_t BgL_arg1511z00_1540;

							{	/* Trace/walk.scm 52 */
								bool_t BgL_testz00_3044;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 52 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Trace/walk.scm 52 */
												BgL_testz00_3044 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Trace/walk.scm 52 */
												BgL_testz00_3044 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Trace/walk.scm 52 */
										BgL_testz00_3044 = ((bool_t) 0);
									}
								if (BgL_testz00_3044)
									{	/* Trace/walk.scm 52 */
										BgL_arg1511z00_1540 = BGl_string2110z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 52 */
										BgL_arg1511z00_1540 = BGl_string2111z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1511z00_1540, BgL_port1303z00_1539);
						}
						bgl_display_string(BGl_string2112z00zztrace_walkz00,
							BgL_port1303z00_1539);
						bgl_display_char(((unsigned char) 10), BgL_port1303z00_1539);
					}
					{	/* Trace/walk.scm 52 */
						obj_t BgL_list1516z00_1546;

						BgL_list1516z00_1546 = MAKE_YOUNG_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1516z00_1546);
					}
				}
			else
				{	/* Trace/walk.scm 52 */
					obj_t BgL_g1111z00_1547;

					BgL_g1111z00_1547 = BNIL;
					{
						obj_t BgL_hooksz00_1550;
						obj_t BgL_hnamesz00_1551;

						BgL_hooksz00_1550 = BgL_g1111z00_1547;
						BgL_hnamesz00_1551 = BNIL;
					BgL_zc3anonymousza31517ze3z83_1552:
						if (NULLP(BgL_hooksz00_1550))
							{	/* Trace/walk.scm 52 */
								return BgL_globalsz00_17;
							}
						else
							{	/* Trace/walk.scm 52 */
								bool_t BgL_testz00_3061;

								{	/* Trace/walk.scm 52 */
									obj_t BgL_fun1532z00_1559;

									BgL_fun1532z00_1559 = CAR(((obj_t) BgL_hooksz00_1550));
									BgL_testz00_3061 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1532z00_1559)
										(BgL_fun1532z00_1559, BEOA));
								}
								if (BgL_testz00_3061)
									{	/* Trace/walk.scm 52 */
										obj_t BgL_arg1527z00_1556;
										obj_t BgL_arg1528z00_1557;

										BgL_arg1527z00_1556 = CDR(((obj_t) BgL_hooksz00_1550));
										BgL_arg1528z00_1557 = CDR(((obj_t) BgL_hnamesz00_1551));
										{
											obj_t BgL_hnamesz00_3073;
											obj_t BgL_hooksz00_3072;

											BgL_hooksz00_3072 = BgL_arg1527z00_1556;
											BgL_hnamesz00_3073 = BgL_arg1528z00_1557;
											BgL_hnamesz00_1551 = BgL_hnamesz00_3073;
											BgL_hooksz00_1550 = BgL_hooksz00_3072;
											goto BgL_zc3anonymousza31517ze3z83_1552;
										}
									}
								else
									{	/* Trace/walk.scm 52 */
										obj_t BgL_arg1531z00_1558;

										BgL_arg1531z00_1558 = CAR(((obj_t) BgL_hnamesz00_1551));
										return
											BGl_internalzd2errorzd2zztools_errorz00
											(BGl_za2currentzd2passza2zd2zzengine_passz00,
											BGl_string2113z00zztrace_walkz00, BgL_arg1531z00_1558);
									}
							}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* &trace-walk! */
	obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t BgL_envz00_2673,
		obj_t BgL_globalsz00_2674)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 38 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_2674);
		}
		BGL_FUNCTION_END;
	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_vz00_18)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 63 */
			{	/* Trace/walk.scm 65 */
				bool_t BgL_testz00_3078;

				if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18, BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 65 */
						BgL_testz00_3078 =
							(
							(((BgL_variablez00_bglt) COBJECT(
										((BgL_variablez00_bglt)
											((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
							CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 65 */
						BgL_testz00_3078 = ((bool_t) 0);
					}
				if (BgL_testz00_3078)
					{	/* Trace/walk.scm 66 */
						obj_t BgL_arg1539z00_1565;

						{	/* Trace/walk.scm 66 */
							obj_t BgL_arg1540z00_1566;
							obj_t BgL_arg1541z00_1567;

							{	/* Trace/walk.scm 66 */
								obj_t BgL_arg1542z00_1568;

								BgL_arg1542z00_1568 =
									bstring_to_symbol(BGl_string2114z00zztrace_walkz00);
								{	/* Trace/walk.scm 66 */
									obj_t BgL_res2028z00_2360;

									{	/* Trace/walk.scm 66 */
										obj_t BgL_arg1419z00_2359;

										BgL_arg1419z00_2359 = SYMBOL_TO_STRING(BgL_arg1542z00_1568);
										BgL_res2028z00_2360 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1419z00_2359);
									}
									BgL_arg1540z00_1566 = BgL_res2028z00_2360;
								}
							}
							{	/* Trace/walk.scm 66 */
								obj_t BgL_arg1551z00_1569;

								BgL_arg1551z00_1569 =
									(((BgL_globalz00_bglt) COBJECT(
											((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
								{	/* Trace/walk.scm 66 */
									obj_t BgL_res2029z00_2364;

									{	/* Trace/walk.scm 66 */
										obj_t BgL_arg1419z00_2363;

										BgL_arg1419z00_2363 = SYMBOL_TO_STRING(BgL_arg1551z00_1569);
										BgL_res2029z00_2364 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1419z00_2363);
									}
									BgL_arg1541z00_1567 = BgL_res2029z00_2364;
								}
							}
							BgL_arg1539z00_1565 =
								string_append(BgL_arg1540z00_1566, BgL_arg1541z00_1567);
						}
						return bstring_to_symbol(BgL_arg1539z00_1565);
					}
				else
					{	/* Trace/walk.scm 67 */
						bool_t BgL_testz00_3095;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 67 */
								BgL_testz00_3095 =
									(
									(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
									CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 67 */
								BgL_testz00_3095 = ((bool_t) 0);
							}
						if (BgL_testz00_3095)
							{	/* Trace/walk.scm 68 */
								obj_t BgL_arg1557z00_1573;

								{	/* Trace/walk.scm 68 */
									obj_t BgL_arg1558z00_1574;
									obj_t BgL_arg1559z00_1575;

									{	/* Trace/walk.scm 68 */
										obj_t BgL_arg1560z00_1576;

										BgL_arg1560z00_1576 =
											bstring_to_symbol(BGl_string2115z00zztrace_walkz00);
										{	/* Trace/walk.scm 68 */
											obj_t BgL_res2033z00_2373;

											{	/* Trace/walk.scm 68 */
												obj_t BgL_arg1419z00_2372;

												BgL_arg1419z00_2372 =
													SYMBOL_TO_STRING(BgL_arg1560z00_1576);
												BgL_res2033z00_2373 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1419z00_2372);
											}
											BgL_arg1558z00_1574 = BgL_res2033z00_2373;
										}
									}
									{	/* Trace/walk.scm 68 */
										obj_t BgL_arg1561z00_1577;

										BgL_arg1561z00_1577 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 68 */
											obj_t BgL_res2034z00_2377;

											{	/* Trace/walk.scm 68 */
												obj_t BgL_arg1419z00_2376;

												BgL_arg1419z00_2376 =
													SYMBOL_TO_STRING(BgL_arg1561z00_1577);
												BgL_res2034z00_2377 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1419z00_2376);
											}
											BgL_arg1559z00_1575 = BgL_res2034z00_2377;
										}
									}
									BgL_arg1557z00_1573 =
										string_append(BgL_arg1558z00_1574, BgL_arg1559z00_1575);
								}
								return bstring_to_symbol(BgL_arg1557z00_1573);
							}
						else
							{	/* Trace/walk.scm 67 */
								if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
										BGl_globalz00zzast_varz00))
									{	/* Trace/walk.scm 70 */
										obj_t BgL_arg1568z00_1579;
										obj_t BgL_arg1569z00_1580;

										BgL_arg1568z00_1579 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00);
										BgL_arg1569z00_1580 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 70 */
											obj_t BgL_list1570z00_1581;

											{	/* Trace/walk.scm 70 */
												obj_t BgL_arg1572z00_1582;

												{	/* Trace/walk.scm 70 */
													obj_t BgL_arg1575z00_1583;

													BgL_arg1575z00_1583 =
														MAKE_YOUNG_PAIR(BgL_arg1569z00_1580, BNIL);
													BgL_arg1572z00_1582 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
														BgL_arg1575z00_1583);
												}
												BgL_list1570z00_1581 =
													MAKE_YOUNG_PAIR(BgL_arg1568z00_1579,
													BgL_arg1572z00_1582);
											}
											return
												BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
												(BgL_list1570z00_1581);
										}
									}
								else
									{	/* Trace/walk.scm 69 */
										return
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_18)))->BgL_idz00);
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_19,
		obj_t BgL_stackz00_20, obj_t BgL_levelz00_21)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 80 */
			{	/* Trace/walk.scm 81 */
				BgL_valuez00_bglt BgL_funz00_1588;

				BgL_funz00_1588 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt) BgL_varz00_19)))->BgL_valuez00);
				{	/* Trace/walk.scm 81 */
					obj_t BgL_bodyz00_1589;

					BgL_bodyz00_1589 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_funz00_1588)))->BgL_bodyz00);
					{	/* Trace/walk.scm 82 */
						obj_t BgL_llocz00_1590;

						if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 84 */
								obj_t BgL_arg1664z00_1637;

								BgL_arg1664z00_1637 =
									BGl_findzd2lastzd2sexpz00zztrace_walkz00(
									(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_varz00_19)))->BgL_srcz00));
								BgL_llocz00_1590 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_arg1664z00_1637);
							}
						else
							{	/* Trace/walk.scm 85 */
								obj_t BgL_arg1670z00_1639;

								BgL_arg1670z00_1639 =
									BGl_findzd2lastzd2nodez00zztrace_walkz00(
									((BgL_nodez00_bglt) BgL_bodyz00_1589));
								BgL_llocz00_1590 =
									(((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_arg1670z00_1639)))->BgL_locz00);
							}
						{	/* Trace/walk.scm 83 */

							{	/* Trace/walk.scm 86 */
								bool_t BgL_testz00_3140;

								if (CBOOL(
										(((BgL_funz00_bglt) COBJECT(
													((BgL_funz00_bglt) BgL_funz00_1588)))->
											BgL_predicatezd2ofzd2)))
									{	/* Trace/walk.scm 86 */
										BgL_testz00_3140 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 86 */
										if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 4)),
													(((BgL_sfunz00_bglt) COBJECT(((BgL_sfunz00_bglt)
																	BgL_funz00_1588)))->BgL_propertyz00))))
											{	/* Trace/walk.scm 87 */
												BgL_testz00_3140 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 88 */
												obj_t BgL_arg1656z00_1634;

												BgL_arg1656z00_1634 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_varz00_19)))->
													BgL_idz00);
												BgL_testz00_3140 =
													BGl_userzd2symbolzf3z21zzast_identz00
													(BgL_arg1656z00_1634);
											}
									}
								if (BgL_testz00_3140)
									{	/* Trace/walk.scm 86 */
										BGl_enterzd2functionzd2zztools_errorz00
											(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19));
										{	/* Trace/walk.scm 90 */
											obj_t BgL_bdz00_1598;

											{	/* Trace/walk.scm 90 */
												bool_t BgL_testz00_3156;

												if (((long) CINT(BgL_levelz00_21) > ((long) 1)))
													{	/* Trace/walk.scm 90 */
														BgL_testz00_3156 = ((bool_t) 1);
													}
												else
													{	/* Trace/walk.scm 90 */
														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_globalz00zzast_varz00))
															{	/* Trace/walk.scm 92 */
																bool_t BgL__ortest_1114z00_1627;

																BgL__ortest_1114z00_1627 =
																	(
																	(((BgL_variablez00_bglt) COBJECT(
																				((BgL_variablez00_bglt)
																					((BgL_globalz00_bglt)
																						BgL_varz00_19))))->BgL_idz00) ==
																	CNST_TABLE_REF(((long) 1)));
																if (BgL__ortest_1114z00_1627)
																	{	/* Trace/walk.scm 92 */
																		BgL_testz00_3156 = BgL__ortest_1114z00_1627;
																	}
																else
																	{	/* Trace/walk.scm 93 */
																		bool_t BgL__ortest_1115z00_1628;

																		BgL__ortest_1115z00_1628 =
																			(
																			(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 5)));
																		if (BgL__ortest_1115z00_1628)
																			{	/* Trace/walk.scm 93 */
																				BgL_testz00_3156 =
																					BgL__ortest_1115z00_1628;
																			}
																		else
																			{	/* Trace/walk.scm 93 */
																				BgL_testz00_3156 =
																					(
																					(((BgL_variablez00_bglt) COBJECT(
																								((BgL_variablez00_bglt)
																									((BgL_globalz00_bglt)
																										BgL_varz00_19))))->
																						BgL_idz00) ==
																					CNST_TABLE_REF(((long) 6)));
															}}}
														else
															{	/* Trace/walk.scm 91 */
																BgL_testz00_3156 = ((bool_t) 0);
															}
													}
												if (BgL_testz00_3156)
													{	/* Trace/walk.scm 102 */
														bool_t BgL_testz00_3179;

														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_localz00zzast_varz00))
															{	/* Trace/walk.scm 102 */
																BgL_testz00_3179 = ((bool_t) 1);
															}
														else
															{	/* Trace/walk.scm 102 */
																if (
																	((((BgL_variablez00_bglt) COBJECT(
																					((BgL_variablez00_bglt)
																						((BgL_globalz00_bglt)
																							BgL_varz00_19))))->BgL_idz00) ==
																		CNST_TABLE_REF(((long) 5))))
																	{	/* Trace/walk.scm 103 */
																		BgL_testz00_3179 = ((bool_t) 1);
																	}
																else
																	{	/* Trace/walk.scm 103 */
																		BgL_testz00_3179 =
																			(
																			(((BgL_variablez00_bglt) COBJECT(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 6)));
															}}
														if (BgL_testz00_3179)
															{	/* Trace/walk.scm 105 */
																long BgL_arg1640z00_1618;

																BgL_arg1640z00_1618 =
																	((long) CINT(BgL_levelz00_21) - ((long) 1));
																BgL_bdz00_1598 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00(
																		((BgL_nodez00_bglt) BgL_bodyz00_1589),
																		BgL_stackz00_20,
																		BINT(BgL_arg1640z00_1618)));
															}
														else
															{	/* Trace/walk.scm 106 */
																obj_t BgL_arg1641z00_1619;
																long BgL_arg1642z00_1620;

																BgL_arg1641z00_1619 =
																	MAKE_YOUNG_PAIR(BgL_varz00_19,
																	BgL_stackz00_20);
																BgL_arg1642z00_1620 =
																	((long) CINT(BgL_levelz00_21) - ((long) 1));
																BgL_bdz00_1598 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00((
																			(BgL_nodez00_bglt) BgL_bodyz00_1589),
																		BgL_arg1641z00_1619,
																		BINT(BgL_arg1642z00_1620)));
													}}
												else
													{	/* Trace/walk.scm 90 */
														BgL_bdz00_1598 = BgL_bodyz00_1589;
													}
											}
											{	/* Trace/walk.scm 90 */
												BgL_typez00_bglt BgL_tz00_1599;

												{	/* Trace/walk.scm 108 */
													BgL_typez00_bglt BgL_arg1610z00_1602;
													BgL_typez00_bglt BgL_arg1613z00_1603;

													BgL_arg1610z00_1602 =
														(((BgL_nodez00_bglt) COBJECT(
																((BgL_nodez00_bglt) BgL_bodyz00_1589)))->
														BgL_typez00);
													BgL_arg1613z00_1603 =
														(((BgL_variablez00_bglt)
															COBJECT(((BgL_variablez00_bglt) BgL_varz00_19)))->
														BgL_typez00);
													BgL_tz00_1599 =
														BGl_strictzd2nodezd2typez00zzast_nodez00
														(BgL_arg1610z00_1602, BgL_arg1613z00_1603);
												}
												{	/* Trace/walk.scm 108 */
													obj_t BgL_idz00_1600;

													BgL_idz00_1600 =
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19);
													{	/* Trace/walk.scm 109 */
														BgL_letzd2varzd2_bglt BgL_nbodyz00_1601;

														BgL_nbodyz00_1601 =
															BGl_makezd2tracedzd2nodez00zztrace_walkz00(
															((BgL_nodez00_bglt) BgL_bdz00_1598),
															BgL_tz00_1599, BgL_idz00_1600, BgL_llocz00_1590,
															BgL_stackz00_20);
														{	/* Trace/walk.scm 110 */

															((((BgL_sfunz00_bglt) COBJECT(
																			((BgL_sfunz00_bglt) BgL_funz00_1588)))->
																	BgL_bodyz00) =
																((obj_t) ((obj_t) BgL_nbodyz00_1601)), BUNSPEC);
															return BGl_leavezd2functionzd2zztools_errorz00();
														}
													}
												}
											}
										}
									}
								else
									{	/* Trace/walk.scm 86 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_22)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 121 */
			{
				obj_t BgL_sexpz00_1641;
				obj_t BgL_resz00_1642;

				BgL_sexpz00_1641 = BgL_sexpz00_22;
				BgL_resz00_1642 = BgL_sexpz00_22;
			BgL_zc3anonymousza31671ze3z83_1643:
				if (PAIRP(BgL_sexpz00_1641))
					{	/* Trace/walk.scm 127 */
						bool_t BgL_testz00_3220;

						{	/* Trace/walk.scm 127 */
							obj_t BgL_tmpz00_3221;

							BgL_tmpz00_3221 = CDR(BgL_sexpz00_1641);
							BgL_testz00_3220 = PAIRP(BgL_tmpz00_3221);
						}
						if (BgL_testz00_3220)
							{
								obj_t BgL_resz00_3226;
								obj_t BgL_sexpz00_3224;

								BgL_sexpz00_3224 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1641);
								BgL_resz00_3226 = BgL_sexpz00_1641;
								BgL_resz00_1642 = BgL_resz00_3226;
								BgL_sexpz00_1641 = BgL_sexpz00_3224;
								goto BgL_zc3anonymousza31671ze3z83_1643;
							}
						else
							{
								obj_t BgL_resz00_3229;
								obj_t BgL_sexpz00_3227;

								BgL_sexpz00_3227 = CAR(BgL_sexpz00_1641);
								BgL_resz00_3229 = BgL_sexpz00_1641;
								BgL_resz00_1642 = BgL_resz00_3229;
								BgL_sexpz00_1641 = BgL_sexpz00_3227;
								goto BgL_zc3anonymousza31671ze3z83_1643;
							}
					}
				else
					{	/* Trace/walk.scm 125 */
						return BgL_resz00_1642;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_38,
		BgL_typez00_bglt BgL_typez00_39, obj_t BgL_symbolz00_40,
		obj_t BgL_llocz00_41, obj_t BgL_stackz00_42)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 244 */
			{	/* Trace/walk.scm 251 */
				obj_t BgL_locz00_1652;

				BgL_locz00_1652 =
					(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_38))->BgL_locz00);
				{	/* Trace/walk.scm 251 */
					obj_t BgL_auxz00_1653;

					BgL_auxz00_1653 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 7))));
					{	/* Trace/walk.scm 252 */
						obj_t BgL_tauxz00_1654;

						BgL_tauxz00_1654 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1653,
							(((BgL_typez00_bglt) COBJECT(BgL_typez00_39))->BgL_idz00));
						{	/* Trace/walk.scm 253 */
							obj_t BgL_tmp1z00_1655;

							BgL_tmp1z00_1655 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											8))));
							{	/* Trace/walk.scm 254 */
								obj_t BgL_tmp2z00_1656;

								BgL_tmp2z00_1656 =
									BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
									(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												9))));
								{	/* Trace/walk.scm 255 */
									obj_t BgL_tmp3z00_1657;

									BgL_tmp3z00_1657 =
										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
										(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
													10))));
									{	/* Trace/walk.scm 256 */
										obj_t BgL_symz00_1658;

										{	/* Trace/walk.scm 257 */
											bool_t BgL_testz00_3245;

											if (PAIRP(BgL_stackz00_42))
												{	/* Trace/walk.scm 257 */
													obj_t BgL_arg1780z00_1709;

													BgL_arg1780z00_1709 = CAR(BgL_stackz00_42);
													BgL_testz00_3245 =
														BGl_isazf3zf3zz__objectz00(BgL_arg1780z00_1709,
														BGl_variablez00zzast_varz00);
												}
											else
												{	/* Trace/walk.scm 257 */
													BgL_testz00_3245 = ((bool_t) 0);
												}
											if (BgL_testz00_3245)
												{	/* Trace/walk.scm 257 */
													BgL_symz00_1658 =
														BGl_fqnameze70ze7zztrace_walkz00(BgL_symbolz00_40,
														BgL_stackz00_42);
												}
											else
												{	/* Trace/walk.scm 257 */
													BgL_symz00_1658 = BgL_symbolz00_40;
												}
										}
										{	/* Trace/walk.scm 257 */
											obj_t BgL_lz00_1659;

											{	/* Trace/walk.scm 261 */
												bool_t BgL_testz00_3251;

												if (STRUCTP(BgL_locz00_1652))
													{	/* Trace/walk.scm 261 */
														BgL_testz00_3251 =
															(STRUCT_KEY(BgL_locz00_1652) ==
															CNST_TABLE_REF(((long) 11)));
													}
												else
													{	/* Trace/walk.scm 261 */
														BgL_testz00_3251 = ((bool_t) 0);
													}
												if (BgL_testz00_3251)
													{	/* Trace/walk.scm 262 */
														obj_t BgL_arg1772z00_1701;

														{	/* Trace/walk.scm 262 */
															obj_t BgL_arg1773z00_1702;
															obj_t BgL_arg1775z00_1703;

															BgL_arg1773z00_1702 =
																BGl_locationzd2fullzd2fnamez00zztools_locationz00
																(BgL_locz00_1652);
															BgL_arg1775z00_1703 =
																MAKE_YOUNG_PAIR(STRUCT_REF(BgL_locz00_1652,
																	(int) (((long) 1))), BNIL);
															BgL_arg1772z00_1701 =
																MAKE_YOUNG_PAIR(BgL_arg1773z00_1702,
																BgL_arg1775z00_1703);
														}
														BgL_lz00_1659 =
															MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
															BgL_arg1772z00_1701);
													}
												else
													{	/* Trace/walk.scm 261 */
														BgL_lz00_1659 = BFALSE;
													}
											}
											{	/* Trace/walk.scm 261 */
												obj_t BgL_expz00_1660;

												{	/* Trace/walk.scm 263 */
													obj_t BgL_arg1684z00_1664;

													{	/* Trace/walk.scm 263 */
														obj_t BgL_arg1686z00_1665;
														obj_t BgL_arg1687z00_1666;

														{	/* Trace/walk.scm 263 */
															obj_t BgL_arg1688z00_1667;
															obj_t BgL_arg1689z00_1668;

															{	/* Trace/walk.scm 263 */
																obj_t BgL_arg1691z00_1669;

																{	/* Trace/walk.scm 263 */
																	obj_t BgL_arg1692z00_1670;

																	{	/* Trace/walk.scm 263 */
																		obj_t BgL_arg1693z00_1671;

																		BgL_arg1693z00_1671 =
																			MAKE_YOUNG_PAIR(BgL_symz00_1658, BNIL);
																		BgL_arg1692z00_1670 =
																			MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																					13)), BgL_arg1693z00_1671);
																	}
																	BgL_arg1691z00_1669 =
																		MAKE_YOUNG_PAIR(BgL_arg1692z00_1670, BNIL);
																}
																BgL_arg1688z00_1667 =
																	MAKE_YOUNG_PAIR(BgL_tmp1z00_1655,
																	BgL_arg1691z00_1669);
															}
															{	/* Trace/walk.scm 264 */
																obj_t BgL_arg1694z00_1672;
																obj_t BgL_arg1695z00_1673;

																{	/* Trace/walk.scm 264 */
																	obj_t BgL_arg1696z00_1674;

																	{	/* Trace/walk.scm 264 */
																		obj_t BgL_arg1702z00_1675;

																		{	/* Trace/walk.scm 264 */
																			obj_t BgL_arg1703z00_1676;

																			BgL_arg1703z00_1676 =
																				MAKE_YOUNG_PAIR(BgL_lz00_1659, BNIL);
																			BgL_arg1702z00_1675 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						13)), BgL_arg1703z00_1676);
																		}
																		BgL_arg1696z00_1674 =
																			MAKE_YOUNG_PAIR(BgL_arg1702z00_1675,
																			BNIL);
																	}
																	BgL_arg1694z00_1672 =
																		MAKE_YOUNG_PAIR(BgL_tmp2z00_1656,
																		BgL_arg1696z00_1674);
																}
																{	/* Trace/walk.scm 265 */
																	obj_t BgL_arg1704z00_1677;

																	{	/* Trace/walk.scm 265 */
																		obj_t BgL_arg1705z00_1678;
																		obj_t BgL_arg1706z00_1679;

																		BgL_arg1705z00_1678 =
																			BGl_makezd2typedzd2identz00zzast_identz00
																			(BgL_tmp3z00_1657,
																			CNST_TABLE_REF(((long) 14)));
																		{	/* Trace/walk.scm 265 */
																			obj_t BgL_arg1707z00_1680;

																			BgL_arg1707z00_1680 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						15)), BNIL);
																			BgL_arg1706z00_1679 =
																				MAKE_YOUNG_PAIR(BgL_arg1707z00_1680,
																				BNIL);
																		}
																		BgL_arg1704z00_1677 =
																			MAKE_YOUNG_PAIR(BgL_arg1705z00_1678,
																			BgL_arg1706z00_1679);
																	}
																	BgL_arg1695z00_1673 =
																		MAKE_YOUNG_PAIR(BgL_arg1704z00_1677, BNIL);
																}
																BgL_arg1689z00_1668 =
																	MAKE_YOUNG_PAIR(BgL_arg1694z00_1672,
																	BgL_arg1695z00_1673);
															}
															BgL_arg1686z00_1665 =
																MAKE_YOUNG_PAIR(BgL_arg1688z00_1667,
																BgL_arg1689z00_1668);
														}
														{	/* Trace/walk.scm 267 */
															obj_t BgL_arg1709z00_1681;

															{	/* Trace/walk.scm 267 */
																obj_t BgL_arg1710z00_1682;

																{	/* Trace/walk.scm 267 */
																	obj_t BgL_arg1712z00_1683;

																	{	/* Trace/walk.scm 267 */
																		obj_t BgL_arg1717z00_1684;
																		obj_t BgL_arg1718z00_1685;

																		{	/* Trace/walk.scm 267 */
																			obj_t BgL_arg1725z00_1686;

																			{	/* Trace/walk.scm 267 */
																				obj_t BgL_arg1728z00_1687;

																				{	/* Trace/walk.scm 267 */
																					obj_t BgL_arg1729z00_1688;

																					BgL_arg1729z00_1688 =
																						MAKE_YOUNG_PAIR(BgL_tmp2z00_1656,
																						BNIL);
																					BgL_arg1728z00_1687 =
																						MAKE_YOUNG_PAIR(BgL_tmp1z00_1655,
																						BgL_arg1729z00_1688);
																				}
																				BgL_arg1725z00_1686 =
																					MAKE_YOUNG_PAIR(BgL_tmp3z00_1657,
																					BgL_arg1728z00_1687);
																			}
																			BgL_arg1717z00_1684 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						16)), BgL_arg1725z00_1686);
																		}
																		{	/* Trace/walk.scm 268 */
																			obj_t BgL_arg1738z00_1689;

																			{	/* Trace/walk.scm 268 */
																				obj_t BgL_arg1749z00_1690;

																				{	/* Trace/walk.scm 268 */
																					obj_t BgL_arg1751z00_1691;
																					obj_t BgL_arg1752z00_1692;

																					{	/* Trace/walk.scm 268 */
																						obj_t BgL_arg1754z00_1693;

																						{	/* Trace/walk.scm 268 */
																							obj_t BgL_arg1762z00_1694;

																							BgL_arg1762z00_1694 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_nodez00_38), BNIL);
																							BgL_arg1754z00_1693 =
																								MAKE_YOUNG_PAIR
																								(BgL_tauxz00_1654,
																								BgL_arg1762z00_1694);
																						}
																						BgL_arg1751z00_1691 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1754z00_1693, BNIL);
																					}
																					{	/* Trace/walk.scm 269 */
																						obj_t BgL_arg1763z00_1695;
																						obj_t BgL_arg1765z00_1696;

																						{	/* Trace/walk.scm 269 */
																							bool_t BgL_testz00_3292;

																							if (STRUCTP(BgL_llocz00_41))
																								{	/* Trace/walk.scm 269 */
																									BgL_testz00_3292 =
																										(STRUCT_KEY(BgL_llocz00_41)
																										==
																										CNST_TABLE_REF(((long)
																												11)));
																								}
																							else
																								{	/* Trace/walk.scm 269 */
																									BgL_testz00_3292 =
																										((bool_t) 0);
																								}
																							if (BgL_testz00_3292)
																								{	/* Trace/walk.scm 271 */
																									obj_t BgL_arg1767z00_1698;

																									{	/* Trace/walk.scm 271 */
																										obj_t BgL_res2052z00_2431;

																										BgL_res2052z00_2431 =
																											MAKE_YOUNG_EPAIR
																											(BgL_tmp3z00_1657, BNIL,
																											BgL_llocz00_41);
																										BgL_arg1767z00_1698 =
																											BgL_res2052z00_2431;
																									}
																									{	/* Trace/walk.scm 270 */
																										obj_t BgL_res2053z00_2433;

																										{	/* Trace/walk.scm 270 */
																											obj_t BgL_obj1z00_2432;

																											BgL_obj1z00_2432 =
																												CNST_TABLE_REF(((long)
																													17));
																											BgL_res2053z00_2433 =
																												MAKE_YOUNG_EPAIR
																												(BgL_obj1z00_2432,
																												BgL_arg1767z00_1698,
																												BgL_llocz00_41);
																										}
																										BgL_arg1763z00_1695 =
																											BgL_res2053z00_2433;
																								}}
																							else
																								{	/* Trace/walk.scm 273 */
																									obj_t BgL_arg1770z00_1699;

																									BgL_arg1770z00_1699 =
																										MAKE_YOUNG_PAIR
																										(BgL_tmp3z00_1657, BNIL);
																									BgL_arg1763z00_1695 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long)
																												17)),
																										BgL_arg1770z00_1699);
																						}}
																						BgL_arg1765z00_1696 =
																							MAKE_YOUNG_PAIR(BgL_auxz00_1653,
																							BNIL);
																						BgL_arg1752z00_1692 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1763z00_1695,
																							BgL_arg1765z00_1696);
																					}
																					BgL_arg1749z00_1690 =
																						MAKE_YOUNG_PAIR(BgL_arg1751z00_1691,
																						BgL_arg1752z00_1692);
																				}
																				BgL_arg1738z00_1689 =
																					MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																							18)), BgL_arg1749z00_1690);
																			}
																			BgL_arg1718z00_1685 =
																				MAKE_YOUNG_PAIR(BgL_arg1738z00_1689,
																				BNIL);
																		}
																		BgL_arg1712z00_1683 =
																			MAKE_YOUNG_PAIR(BgL_arg1717z00_1684,
																			BgL_arg1718z00_1685);
																	}
																	BgL_arg1710z00_1682 =
																		MAKE_YOUNG_PAIR(BNIL, BgL_arg1712z00_1683);
																}
																BgL_arg1709z00_1681 =
																	MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 18)),
																	BgL_arg1710z00_1682);
															}
															BgL_arg1687z00_1666 =
																MAKE_YOUNG_PAIR(BgL_arg1709z00_1681, BNIL);
														}
														BgL_arg1684z00_1664 =
															MAKE_YOUNG_PAIR(BgL_arg1686z00_1665,
															BgL_arg1687z00_1666);
													}
													BgL_expz00_1660 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 18)),
														BgL_arg1684z00_1664);
												}
												{	/* Trace/walk.scm 263 */
													BgL_nodez00_bglt BgL_nnodez00_1661;

													BgL_nnodez00_1661 =
														BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1660,
														BNIL, BgL_locz00_1652, CNST_TABLE_REF(((long) 19)));
													{	/* Trace/walk.scm 275 */

														{	/* Trace/walk.scm 276 */
															bool_t BgL_arg1680z00_1662;

															{	/* Trace/walk.scm 276 */
																obj_t BgL_arg1682z00_1663;

																BgL_arg1682z00_1663 =
																	BGl_thezd2backendzd2zzbackend_backendz00();
																BgL_arg1680z00_1662 =
																	(((BgL_backendz00_bglt) COBJECT(
																			((BgL_backendz00_bglt)
																				BgL_arg1682z00_1663)))->
																	BgL_removezd2emptyzd2letz00);
															}
															((((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_nnodez00_1661)))->
																	BgL_removablezf3zf3) =
																((bool_t) BgL_arg1680z00_1662), BUNSPEC);
														}
														return ((BgL_letzd2varzd2_bglt) BgL_nnodez00_1661);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* fqname~0 */
	obj_t BGl_fqnameze70ze7zztrace_walkz00(obj_t BgL_symz00_1715,
		obj_t BgL_stackz00_1716)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 249 */
			if (NULLP(BgL_stackz00_1716))
				{	/* Trace/walk.scm 247 */
					return BgL_symz00_1715;
				}
			else
				{	/* Trace/walk.scm 249 */
					obj_t BgL_arg1788z00_1719;

					{	/* Trace/walk.scm 249 */
						obj_t BgL_arg1793z00_1723;
						obj_t BgL_arg1794z00_1724;

						{	/* Trace/walk.scm 249 */
							obj_t BgL_arg1795z00_1725;

							BgL_arg1795z00_1725 = CAR(((obj_t) BgL_stackz00_1716));
							BgL_arg1793z00_1723 =
								BGl_tracezd2idzd2zztrace_walkz00(BgL_arg1795z00_1725);
						}
						BgL_arg1794z00_1724 = CDR(((obj_t) BgL_stackz00_1716));
						BgL_arg1788z00_1719 =
							BGl_fqnameze70ze7zztrace_walkz00(BgL_arg1793z00_1723,
							BgL_arg1794z00_1724);
					}
					{	/* Trace/walk.scm 249 */
						obj_t BgL_list1789z00_1720;

						{	/* Trace/walk.scm 249 */
							obj_t BgL_arg1790z00_1721;

							{	/* Trace/walk.scm 249 */
								obj_t BgL_arg1792z00_1722;

								BgL_arg1792z00_1722 =
									MAKE_YOUNG_PAIR(BgL_arg1788z00_1719, BNIL);
								BgL_arg1790z00_1721 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 20)),
									BgL_arg1792z00_1722);
							}
							BgL_list1789z00_1720 =
								MAKE_YOUNG_PAIR(BgL_symz00_1715, BgL_arg1790z00_1721);
						}
						return
							BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list1789z00_1720);
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* trace-node*! */
	bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_100,
		obj_t BgL_stackz00_101, obj_t BgL_levelz00_102)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 441 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_100))
				{	/* Trace/walk.scm 442 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 442 */
					{	/* Trace/walk.scm 443 */
						BgL_nodez00_bglt BgL_arg1798z00_1728;

						{	/* Trace/walk.scm 443 */
							obj_t BgL_arg1799z00_1729;

							BgL_arg1799z00_1729 = CAR(((obj_t) BgL_nodeza2za2_100));
							BgL_arg1798z00_1728 =
								BGl_tracezd2nodezd2zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1799z00_1729), BgL_stackz00_101,
								BgL_levelz00_102);
						}
						{	/* Trace/walk.scm 443 */
							obj_t BgL_auxz00_3347;
							obj_t BgL_tmpz00_3345;

							BgL_auxz00_3347 = ((obj_t) BgL_arg1798z00_1728);
							BgL_tmpz00_3345 = ((obj_t) BgL_nodeza2za2_100);
							SET_CAR(BgL_tmpz00_3345, BgL_auxz00_3347);
						}
					}
					{	/* Trace/walk.scm 444 */
						obj_t BgL_arg1800z00_1730;

						BgL_arg1800z00_1730 = CDR(((obj_t) BgL_nodeza2za2_100));
						{
							obj_t BgL_nodeza2za2_3352;

							BgL_nodeza2za2_3352 = BgL_arg1800z00_1730;
							BgL_nodeza2za2_100 = BgL_nodeza2za2_3352;
							goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* toplevel-trace-node*! */
	bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_107)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 492 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_107))
				{	/* Trace/walk.scm 493 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 493 */
					{	/* Trace/walk.scm 494 */
						BgL_nodez00_bglt BgL_arg1802z00_1732;

						{	/* Trace/walk.scm 494 */
							obj_t BgL_arg1803z00_1733;

							BgL_arg1803z00_1733 = CAR(((obj_t) BgL_nodeza2za2_107));
							BgL_arg1802z00_1732 =
								BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1803z00_1733));
						}
						{	/* Trace/walk.scm 494 */
							obj_t BgL_auxz00_3361;
							obj_t BgL_tmpz00_3359;

							BgL_auxz00_3361 = ((obj_t) BgL_arg1802z00_1732);
							BgL_tmpz00_3359 = ((obj_t) BgL_nodeza2za2_107);
							SET_CAR(BgL_tmpz00_3359, BgL_auxz00_3361);
						}
					}
					{	/* Trace/walk.scm 495 */
						obj_t BgL_arg1805z00_1734;

						BgL_arg1805z00_1734 = CDR(((obj_t) BgL_nodeza2za2_107));
						{
							obj_t BgL_nodeza2za2_3366;

							BgL_nodeza2za2_3366 = BgL_arg1805z00_1734;
							BgL_nodeza2za2_107 = BgL_nodeza2za2_3366;
							goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2116z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2117z00zztrace_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_proc2118z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2119z00zztrace_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2120z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2121z00zztrace_walkz00);
		}
		BGL_FUNCTION_END;
	}



/* &toplevel-trace-node1384 */
	obj_t BGl_z62toplevelzd2tracezd2node1384z62zztrace_walkz00(obj_t
		BgL_envz00_2678, obj_t BgL_nodez00_2679)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 449 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2679));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node1343 */
	obj_t BGl_z62tracezd2node1343zb0zztrace_walkz00(obj_t BgL_envz00_2680,
		obj_t BgL_nodez00_2681, obj_t BgL_stackz00_2682, obj_t BgL_levelz00_2683)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 282 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2681));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node1313 */
	obj_t BGl_z62findzd2lastzd2node1313z62zztrace_walkz00(obj_t BgL_envz00_2684,
		obj_t BgL_nodez00_2685)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 138 */
			return ((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2685));
		}
		BGL_FUNCTION_END;
	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_23)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 138 */
			{	/* Trace/walk.scm 138 */
				obj_t BgL_method1314z00_1749;

				{	/* Trace/walk.scm 138 */
					obj_t BgL_res2068z00_2491;

					{	/* Trace/walk.scm 138 */
						long BgL_objzd2classzd2numz00_2448;

						{	/* Trace/walk.scm 138 */
							long BgL_res2057z00_2451;

							BgL_res2057z00_2451 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_23));
							BgL_objzd2classzd2numz00_2448 = BgL_res2057z00_2451;
						}
						{	/* Trace/walk.scm 138 */
							obj_t BgL_arg1756z00_2449;

							BgL_arg1756z00_2449 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 138 */
								int BgL_offsetz00_2453;

								BgL_offsetz00_2453 = (int) (BgL_objzd2classzd2numz00_2448);
								{	/* Trace/walk.scm 138 */
									long BgL_offsetz00_2454;

									BgL_offsetz00_2454 =
										((long) (BgL_offsetz00_2453) - OBJECT_TYPE);
									{	/* Trace/walk.scm 138 */
										long BgL_modz00_2455;

										{	/* Trace/walk.scm 138 */
											int BgL_arg1758z00_2456;

											BgL_arg1758z00_2456 = (int) (((long) 16));
											{	/* Trace/walk.scm 138 */
												long BgL_res2060z00_2466;

												{	/* Trace/walk.scm 138 */
													long BgL_tmpz00_3384;

													BgL_tmpz00_3384 = (long) (BgL_arg1758z00_2456);
													BgL_res2060z00_2466 =
														(BgL_offsetz00_2454 / BgL_tmpz00_3384);
												}
												BgL_modz00_2455 = BgL_res2060z00_2466;
										}}
										{	/* Trace/walk.scm 138 */
											long BgL_restz00_2457;

											{	/* Trace/walk.scm 138 */
												int BgL_arg1757z00_2458;

												BgL_arg1757z00_2458 = (int) (((long) 16));
												{	/* Trace/walk.scm 138 */
													long BgL_res2067z00_2486;

													{	/* Trace/walk.scm 138 */
														long BgL_n1z00_2468;
														long BgL_n2z00_2469;

														BgL_n1z00_2468 = BgL_offsetz00_2454;
														BgL_n2z00_2469 = (long) (BgL_arg1757z00_2458);
														{	/* Trace/walk.scm 138 */
															bool_t BgL_testz00_3389;

															{	/* Trace/walk.scm 138 */
																long BgL_arg1292z00_2471;

																BgL_arg1292z00_2471 =
																	(((BgL_n1z00_2468) | (BgL_n2z00_2469)) &
																	-2147483648);
																BgL_testz00_3389 =
																	(BgL_arg1292z00_2471 == ((long) 0));
															}
															if (BgL_testz00_3389)
																{	/* Trace/walk.scm 138 */
																	int32_t BgL_arg1285z00_2472;

																	{	/* Trace/walk.scm 138 */
																		int32_t BgL_arg1287z00_2473;
																		int32_t BgL_arg1290z00_2474;

																		{	/* Trace/walk.scm 138 */
																			int32_t BgL_res2063z00_2478;

																			BgL_res2063z00_2478 =
																				(int32_t) (BgL_n1z00_2468);
																			BgL_arg1287z00_2473 = BgL_res2063z00_2478;
																		}
																		{	/* Trace/walk.scm 138 */
																			int32_t BgL_res2064z00_2480;

																			BgL_res2064z00_2480 =
																				(int32_t) (BgL_n2z00_2469);
																			BgL_arg1290z00_2474 = BgL_res2064z00_2480;
																		}
																		BgL_arg1285z00_2472 =
																			(BgL_arg1287z00_2473 %
																			BgL_arg1290z00_2474);
																	}
																	{	/* Trace/walk.scm 138 */
																		long BgL_res2066z00_2485;

																		{	/* Trace/walk.scm 138 */
																			long BgL_arg1411z00_2482;

																			BgL_arg1411z00_2482 =
																				(long) (BgL_arg1285z00_2472);
																			{	/* Trace/walk.scm 138 */
																				long BgL_res2065z00_2484;

																				BgL_res2065z00_2484 =
																					(long) (BgL_arg1411z00_2482);
																				BgL_res2066z00_2485 =
																					BgL_res2065z00_2484;
																		}}
																		BgL_res2067z00_2486 = BgL_res2066z00_2485;
																}}
															else
																{	/* Trace/walk.scm 138 */
																	BgL_res2067z00_2486 =
																		(BgL_n1z00_2468 % BgL_n2z00_2469);
																}
														}
													}
													BgL_restz00_2457 = BgL_res2067z00_2486;
												}
											}
											{	/* Trace/walk.scm 138 */

												{	/* Trace/walk.scm 138 */
													obj_t BgL_bucketz00_2459;

													BgL_bucketz00_2459 =
														VECTOR_REF(
														((obj_t) BgL_arg1756z00_2449), BgL_modz00_2455);
													BgL_res2068z00_2491 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2459), BgL_restz00_2457);
												}
											}
										}
									}
								}
							}
						}
					}
					BgL_method1314z00_1749 = BgL_res2068z00_2491;
				}
				return
					PROCEDURE_ENTRY(BgL_method1314z00_1749) (BgL_method1314z00_1749,
					((obj_t) BgL_nodez00_23), BEOA);
			}
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node */
	obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t BgL_envz00_2686,
		obj_t BgL_nodez00_2687)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 138 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2687));
		}
		BGL_FUNCTION_END;
	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_43, obj_t BgL_stackz00_44, obj_t BgL_levelz00_45)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 282 */
			{	/* Trace/walk.scm 282 */
				obj_t BgL_method1345z00_1750;

				{	/* Trace/walk.scm 282 */
					obj_t BgL_res2080z00_2536;

					{	/* Trace/walk.scm 282 */
						long BgL_objzd2classzd2numz00_2493;

						{	/* Trace/walk.scm 282 */
							long BgL_res2069z00_2496;

							BgL_res2069z00_2496 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_43));
							BgL_objzd2classzd2numz00_2493 = BgL_res2069z00_2496;
						}
						{	/* Trace/walk.scm 282 */
							obj_t BgL_arg1756z00_2494;

							BgL_arg1756z00_2494 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 282 */
								int BgL_offsetz00_2498;

								BgL_offsetz00_2498 = (int) (BgL_objzd2classzd2numz00_2493);
								{	/* Trace/walk.scm 282 */
									long BgL_offsetz00_2499;

									BgL_offsetz00_2499 =
										((long) (BgL_offsetz00_2498) - OBJECT_TYPE);
									{	/* Trace/walk.scm 282 */
										long BgL_modz00_2500;

										{	/* Trace/walk.scm 282 */
											int BgL_arg1758z00_2501;

											BgL_arg1758z00_2501 = (int) (((long) 16));
											{	/* Trace/walk.scm 282 */
												long BgL_res2072z00_2511;

												{	/* Trace/walk.scm 282 */
													long BgL_tmpz00_3417;

													BgL_tmpz00_3417 = (long) (BgL_arg1758z00_2501);
													BgL_res2072z00_2511 =
														(BgL_offsetz00_2499 / BgL_tmpz00_3417);
												}
												BgL_modz00_2500 = BgL_res2072z00_2511;
										}}
										{	/* Trace/walk.scm 282 */
											long BgL_restz00_2502;

											{	/* Trace/walk.scm 282 */
												int BgL_arg1757z00_2503;

												BgL_arg1757z00_2503 = (int) (((long) 16));
												{	/* Trace/walk.scm 282 */
													long BgL_res2079z00_2531;

													{	/* Trace/walk.scm 282 */
														long BgL_n1z00_2513;
														long BgL_n2z00_2514;

														BgL_n1z00_2513 = BgL_offsetz00_2499;
														BgL_n2z00_2514 = (long) (BgL_arg1757z00_2503);
														{	/* Trace/walk.scm 282 */
															bool_t BgL_testz00_3422;

															{	/* Trace/walk.scm 282 */
																long BgL_arg1292z00_2516;

																BgL_arg1292z00_2516 =
																	(((BgL_n1z00_2513) | (BgL_n2z00_2514)) &
																	-2147483648);
																BgL_testz00_3422 =
																	(BgL_arg1292z00_2516 == ((long) 0));
															}
															if (BgL_testz00_3422)
																{	/* Trace/walk.scm 282 */
																	int32_t BgL_arg1285z00_2517;

																	{	/* Trace/walk.scm 282 */
																		int32_t BgL_arg1287z00_2518;
																		int32_t BgL_arg1290z00_2519;

																		{	/* Trace/walk.scm 282 */
																			int32_t BgL_res2075z00_2523;

																			BgL_res2075z00_2523 =
																				(int32_t) (BgL_n1z00_2513);
																			BgL_arg1287z00_2518 = BgL_res2075z00_2523;
																		}
																		{	/* Trace/walk.scm 282 */
																			int32_t BgL_res2076z00_2525;

																			BgL_res2076z00_2525 =
																				(int32_t) (BgL_n2z00_2514);
																			BgL_arg1290z00_2519 = BgL_res2076z00_2525;
																		}
																		BgL_arg1285z00_2517 =
																			(BgL_arg1287z00_2518 %
																			BgL_arg1290z00_2519);
																	}
																	{	/* Trace/walk.scm 282 */
																		long BgL_res2078z00_2530;

																		{	/* Trace/walk.scm 282 */
																			long BgL_arg1411z00_2527;

																			BgL_arg1411z00_2527 =
																				(long) (BgL_arg1285z00_2517);
																			{	/* Trace/walk.scm 282 */
																				long BgL_res2077z00_2529;

																				BgL_res2077z00_2529 =
																					(long) (BgL_arg1411z00_2527);
																				BgL_res2078z00_2530 =
																					BgL_res2077z00_2529;
																		}}
																		BgL_res2079z00_2531 = BgL_res2078z00_2530;
																}}
															else
																{	/* Trace/walk.scm 282 */
																	BgL_res2079z00_2531 =
																		(BgL_n1z00_2513 % BgL_n2z00_2514);
																}
														}
													}
													BgL_restz00_2502 = BgL_res2079z00_2531;
												}
											}
											{	/* Trace/walk.scm 282 */

												{	/* Trace/walk.scm 282 */
													obj_t BgL_bucketz00_2504;

													BgL_bucketz00_2504 =
														VECTOR_REF(
														((obj_t) BgL_arg1756z00_2494), BgL_modz00_2500);
													BgL_res2080z00_2536 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2504), BgL_restz00_2502);
												}
											}
										}
									}
								}
							}
						}
					}
					BgL_method1345z00_1750 = BgL_res2080z00_2536;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1345z00_1750) (BgL_method1345z00_1750,
						((obj_t) BgL_nodez00_43), BgL_stackz00_44, BgL_levelz00_45, BEOA));
			}
		}
		BGL_FUNCTION_END;
	}



/* &trace-node */
	BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t BgL_envz00_2688,
		obj_t BgL_nodez00_2689, obj_t BgL_stackz00_2690, obj_t BgL_levelz00_2691)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 282 */
			return
				BGl_tracezd2nodezd2zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2689), BgL_stackz00_2690,
				BgL_levelz00_2691);
		}
		BGL_FUNCTION_END;
	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_103)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 449 */
			{	/* Trace/walk.scm 449 */
				obj_t BgL_method1385z00_1751;

				{	/* Trace/walk.scm 449 */
					obj_t BgL_res2092z00_2581;

					{	/* Trace/walk.scm 449 */
						long BgL_objzd2classzd2numz00_2538;

						{	/* Trace/walk.scm 449 */
							long BgL_res2081z00_2541;

							BgL_res2081z00_2541 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_103));
							BgL_objzd2classzd2numz00_2538 = BgL_res2081z00_2541;
						}
						{	/* Trace/walk.scm 449 */
							obj_t BgL_arg1756z00_2539;

							BgL_arg1756z00_2539 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 449 */
								int BgL_offsetz00_2543;

								BgL_offsetz00_2543 = (int) (BgL_objzd2classzd2numz00_2538);
								{	/* Trace/walk.scm 449 */
									long BgL_offsetz00_2544;

									BgL_offsetz00_2544 =
										((long) (BgL_offsetz00_2543) - OBJECT_TYPE);
									{	/* Trace/walk.scm 449 */
										long BgL_modz00_2545;

										{	/* Trace/walk.scm 449 */
											int BgL_arg1758z00_2546;

											BgL_arg1758z00_2546 = (int) (((long) 16));
											{	/* Trace/walk.scm 449 */
												long BgL_res2084z00_2556;

												{	/* Trace/walk.scm 449 */
													long BgL_tmpz00_3453;

													BgL_tmpz00_3453 = (long) (BgL_arg1758z00_2546);
													BgL_res2084z00_2556 =
														(BgL_offsetz00_2544 / BgL_tmpz00_3453);
												}
												BgL_modz00_2545 = BgL_res2084z00_2556;
										}}
										{	/* Trace/walk.scm 449 */
											long BgL_restz00_2547;

											{	/* Trace/walk.scm 449 */
												int BgL_arg1757z00_2548;

												BgL_arg1757z00_2548 = (int) (((long) 16));
												{	/* Trace/walk.scm 449 */
													long BgL_res2091z00_2576;

													{	/* Trace/walk.scm 449 */
														long BgL_n1z00_2558;
														long BgL_n2z00_2559;

														BgL_n1z00_2558 = BgL_offsetz00_2544;
														BgL_n2z00_2559 = (long) (BgL_arg1757z00_2548);
														{	/* Trace/walk.scm 449 */
															bool_t BgL_testz00_3458;

															{	/* Trace/walk.scm 449 */
																long BgL_arg1292z00_2561;

																BgL_arg1292z00_2561 =
																	(((BgL_n1z00_2558) | (BgL_n2z00_2559)) &
																	-2147483648);
																BgL_testz00_3458 =
																	(BgL_arg1292z00_2561 == ((long) 0));
															}
															if (BgL_testz00_3458)
																{	/* Trace/walk.scm 449 */
																	int32_t BgL_arg1285z00_2562;

																	{	/* Trace/walk.scm 449 */
																		int32_t BgL_arg1287z00_2563;
																		int32_t BgL_arg1290z00_2564;

																		{	/* Trace/walk.scm 449 */
																			int32_t BgL_res2087z00_2568;

																			BgL_res2087z00_2568 =
																				(int32_t) (BgL_n1z00_2558);
																			BgL_arg1287z00_2563 = BgL_res2087z00_2568;
																		}
																		{	/* Trace/walk.scm 449 */
																			int32_t BgL_res2088z00_2570;

																			BgL_res2088z00_2570 =
																				(int32_t) (BgL_n2z00_2559);
																			BgL_arg1290z00_2564 = BgL_res2088z00_2570;
																		}
																		BgL_arg1285z00_2562 =
																			(BgL_arg1287z00_2563 %
																			BgL_arg1290z00_2564);
																	}
																	{	/* Trace/walk.scm 449 */
																		long BgL_res2090z00_2575;

																		{	/* Trace/walk.scm 449 */
																			long BgL_arg1411z00_2572;

																			BgL_arg1411z00_2572 =
																				(long) (BgL_arg1285z00_2562);
																			{	/* Trace/walk.scm 449 */
																				long BgL_res2089z00_2574;

																				BgL_res2089z00_2574 =
																					(long) (BgL_arg1411z00_2572);
																				BgL_res2090z00_2575 =
																					BgL_res2089z00_2574;
																		}}
																		BgL_res2091z00_2576 = BgL_res2090z00_2575;
																}}
															else
																{	/* Trace/walk.scm 449 */
																	BgL_res2091z00_2576 =
																		(BgL_n1z00_2558 % BgL_n2z00_2559);
																}
														}
													}
													BgL_restz00_2547 = BgL_res2091z00_2576;
												}
											}
											{	/* Trace/walk.scm 449 */

												{	/* Trace/walk.scm 449 */
													obj_t BgL_bucketz00_2549;

													BgL_bucketz00_2549 =
														VECTOR_REF(
														((obj_t) BgL_arg1756z00_2539), BgL_modz00_2545);
													BgL_res2092z00_2581 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2549), BgL_restz00_2547);
												}
											}
										}
									}
								}
							}
						}
					}
					BgL_method1385z00_1751 = BgL_res2092z00_2581;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1385z00_1751) (BgL_method1385z00_1751,
						((obj_t) BgL_nodez00_103), BEOA));
			}
		}
		BGL_FUNCTION_END;
	}



/* &toplevel-trace-node */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t
		BgL_envz00_2692, obj_t BgL_nodez00_2693)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 449 */
			return
				BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2693));
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2122z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2124z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2125z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2126z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2127z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2128z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2129z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2130z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2131z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_switchz00zzast_nodez00, BGl_proc2132z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2133z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2134z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2135z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2136z00zztrace_walkz00,
				BGl_string2123z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2137z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2139z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2140z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2141z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2142z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc2143z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc2144z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc2145z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2146z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2147z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc2148z00zztrace_walkz00, BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2149z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2150z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2151z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2152z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2153z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2154z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2155z00zztrace_walkz00,
				BGl_string2138z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2156z00zztrace_walkz00,
				BGl_string2157z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2158z00zztrace_walkz00,
				BGl_string2157z00zztrace_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2159z00zztrace_walkz00,
				BGl_string2157z00zztrace_walkz00);
		}
		BGL_FUNCTION_END;
	}



/* &toplevel-trace-node-1393 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21393zb0zztrace_walkz00(obj_t
		BgL_envz00_2729, obj_t BgL_nodez00_2730)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 476 */
			{	/* Trace/walk.scm 478 */
				BgL_varz00_bglt BgL_i1133z00_2853;

				BgL_i1133z00_2853 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2730)))->BgL_varz00);
				{	/* Trace/walk.scm 479 */
					bool_t BgL_testz00_3516;

					{	/* Trace/walk.scm 479 */
						bool_t BgL_testz00_3517;

						{	/* Trace/walk.scm 479 */
							BgL_variablez00_bglt BgL_arg1950z00_2854;

							BgL_arg1950z00_2854 =
								(((BgL_varz00_bglt) COBJECT(BgL_i1133z00_2853))->
								BgL_variablez00);
							{	/* Trace/walk.scm 479 */
								bool_t BgL_res2101z00_2855;

								BgL_res2101z00_2855 =
									BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_arg1950z00_2854), BGl_globalz00zzast_varz00);
								BgL_testz00_3517 = BgL_res2101z00_2855;
							}
						}
						if (BgL_testz00_3517)
							{	/* Trace/walk.scm 480 */
								bool_t BgL_testz00_3521;

								{	/* Trace/walk.scm 480 */
									bool_t BgL_testz00_3522;

									{	/* Trace/walk.scm 480 */
										BgL_nodez00_bglt BgL_arg1948z00_2856;

										BgL_arg1948z00_2856 =
											(((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_2730)))->
											BgL_valuez00);
										{	/* Trace/walk.scm 480 */
											bool_t BgL_res2102z00_2857;

											BgL_res2102z00_2857 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_arg1948z00_2856),
												BGl_atomz00zzast_nodez00);
											BgL_testz00_3522 = BgL_res2102z00_2857;
										}
									}
									if (BgL_testz00_3522)
										{	/* Trace/walk.scm 480 */
											BgL_testz00_3521 = ((bool_t) 1);
										}
									else
										{	/* Trace/walk.scm 481 */
											bool_t BgL_testz00_3527;

											{	/* Trace/walk.scm 481 */
												BgL_nodez00_bglt BgL_arg1947z00_2858;

												BgL_arg1947z00_2858 =
													(((BgL_setqz00_bglt) COBJECT(
															((BgL_setqz00_bglt) BgL_nodez00_2730)))->
													BgL_valuez00);
												{	/* Trace/walk.scm 481 */
													bool_t BgL_res2103z00_2859;

													BgL_res2103z00_2859 =
														BGl_isazf3zf3zz__objectz00(
														((obj_t) BgL_arg1947z00_2858),
														BGl_varz00zzast_nodez00);
													BgL_testz00_3527 = BgL_res2103z00_2859;
												}
											}
											if (BgL_testz00_3527)
												{	/* Trace/walk.scm 481 */
													BgL_testz00_3521 = ((bool_t) 1);
												}
											else
												{	/* Trace/walk.scm 482 */
													bool_t BgL_testz00_3532;

													{	/* Trace/walk.scm 482 */
														BgL_nodez00_bglt BgL_arg1946z00_2860;

														BgL_arg1946z00_2860 =
															(((BgL_setqz00_bglt) COBJECT(
																	((BgL_setqz00_bglt) BgL_nodez00_2730)))->
															BgL_valuez00);
														{	/* Trace/walk.scm 482 */
															bool_t BgL_res2104z00_2861;

															BgL_res2104z00_2861 =
																BGl_isazf3zf3zz__objectz00(
																((obj_t) BgL_arg1946z00_2860),
																BGl_kwotez00zzast_nodez00);
															BgL_testz00_3532 = BgL_res2104z00_2861;
														}
													}
													if (BgL_testz00_3532)
														{	/* Trace/walk.scm 482 */
															BgL_testz00_3521 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 483 */
															BgL_nodez00_bglt BgL_arg1945z00_2862;

															BgL_arg1945z00_2862 =
																(((BgL_setqz00_bglt) COBJECT(
																		((BgL_setqz00_bglt) BgL_nodez00_2730)))->
																BgL_valuez00);
															{	/* Trace/walk.scm 483 */
																bool_t BgL_res2105z00_2863;

																BgL_res2105z00_2863 =
																	BGl_isazf3zf3zz__objectz00(
																	((obj_t) BgL_arg1945z00_2862),
																	BGl_pragmaz00zzast_nodez00);
																BgL_testz00_3521 = BgL_res2105z00_2863;
															}
														}
												}
										}
								}
								if (BgL_testz00_3521)
									{	/* Trace/walk.scm 480 */
										BgL_testz00_3516 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 480 */
										BgL_testz00_3516 = ((bool_t) 1);
									}
							}
						else
							{	/* Trace/walk.scm 479 */
								BgL_testz00_3516 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3516)
						{	/* Trace/walk.scm 484 */
							BgL_typez00_bglt BgL_tz00_2864;

							{	/* Trace/walk.scm 484 */
								BgL_typez00_bglt BgL_arg1940z00_2865;
								BgL_typez00_bglt BgL_arg1941z00_2866;

								BgL_arg1940z00_2865 =
									(((BgL_nodez00_bglt) COBJECT(
											(((BgL_setqz00_bglt) COBJECT(
														((BgL_setqz00_bglt) BgL_nodez00_2730)))->
												BgL_valuez00)))->BgL_typez00);
								BgL_arg1941z00_2866 =
									(((BgL_variablez00_bglt)
										COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) ((
															(BgL_varz00_bglt) COBJECT(BgL_i1133z00_2853))->
														BgL_variablez00)))))->BgL_typez00);
								BgL_tz00_2864 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_arg1940z00_2865,
									BgL_arg1941z00_2866);
							}
							{	/* Trace/walk.scm 484 */
								BgL_letzd2varzd2_bglt BgL_tracez00_2867;

								{	/* Trace/walk.scm 485 */
									BgL_nodez00_bglt BgL_arg1936z00_2868;
									obj_t BgL_arg1937z00_2869;
									obj_t BgL_arg1938z00_2870;

									BgL_arg1936z00_2868 =
										(((BgL_setqz00_bglt) COBJECT(
												((BgL_setqz00_bglt) BgL_nodez00_2730)))->BgL_valuez00);
									{	/* Trace/walk.scm 485 */
										BgL_variablez00_bglt BgL_arg1939z00_2871;

										BgL_arg1939z00_2871 =
											(((BgL_varz00_bglt) COBJECT(BgL_i1133z00_2853))->
											BgL_variablez00);
										BgL_arg1937z00_2869 =
											BGl_tracezd2idzd2zztrace_walkz00(((obj_t)
												BgL_arg1939z00_2871));
									}
									BgL_arg1938z00_2870 =
										(((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt)
													((BgL_setqz00_bglt) BgL_nodez00_2730))))->BgL_locz00);
									BgL_tracez00_2867 =
										BGl_makezd2tracedzd2nodez00zztrace_walkz00
										(BgL_arg1936z00_2868, BgL_tz00_2864, BgL_arg1937z00_2869,
										BgL_arg1938z00_2870, BNIL);
								}
								{	/* Trace/walk.scm 485 */

									((((BgL_setqz00_bglt) COBJECT(
													((BgL_setqz00_bglt) BgL_nodez00_2730)))->
											BgL_valuez00) =
										((BgL_nodez00_bglt) ((BgL_nodez00_bglt) BgL_tracez00_2867)),
										BUNSPEC);
								}
							}
						}
					else
						{	/* Trace/walk.scm 479 */
							BFALSE;
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nodez00_2730));
		}
		BGL_FUNCTION_END;
	}



/* &toplevel-trace-node-1391 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21391zb0zztrace_walkz00(obj_t
		BgL_envz00_2731, obj_t BgL_nodez00_2732)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 462 */
			((((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2732)))->BgL_mutexz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2732)))->
							BgL_mutexz00))), BUNSPEC);
			((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2732)))->
					BgL_prelockz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2732)))->
							BgL_prelockz00))), BUNSPEC);
			((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2732)))->
					BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
								COBJECT(((BgL_syncz00_bglt) BgL_nodez00_2732)))->BgL_bodyz00))),
				BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2732));
		}
		BGL_FUNCTION_END;
	}



/* &toplevel-trace-node-1387 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21387zb0zztrace_walkz00(obj_t
		BgL_envz00_2733, obj_t BgL_nodez00_2734)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 455 */
			BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2734)))->BgL_nodesz00));
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2734));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-box-set!1383 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121383za2zztrace_walkz00(obj_t
		BgL_envz00_2735, obj_t BgL_nodez00_2736, obj_t BgL_stackz00_2737,
		obj_t BgL_levelz00_2738)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 432 */
			{
				BgL_varz00_bglt BgL_auxz00_3585;

				{	/* Trace/walk.scm 434 */
					BgL_varz00_bglt BgL_arg1907z00_2875;

					BgL_arg1907z00_2875 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2736)))->BgL_varz00);
					BgL_auxz00_3585 =
						((BgL_varz00_bglt)
						BGl_tracezd2nodezd2zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1907z00_2875), BgL_stackz00_2737,
							BgL_levelz00_2738));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2736)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_3585), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3593;

				{	/* Trace/walk.scm 435 */
					BgL_nodez00_bglt BgL_arg1908z00_2876;

					BgL_arg1908z00_2876 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2736)))->BgL_valuez00);
					BgL_auxz00_3593 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1908z00_2876,
						BgL_stackz00_2737, BgL_levelz00_2738);
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2736)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3593), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2736));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-box-ref1381 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2boxzd2ref1381zb0zztrace_walkz00(obj_t
		BgL_envz00_2739, obj_t BgL_nodez00_2740, obj_t BgL_stackz00_2741,
		obj_t BgL_levelz00_2742)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 425 */
			{	/* Trace/walk.scm 426 */
				BgL_nodez00_bglt BgL_arg1905z00_2878;

				{	/* Trace/walk.scm 426 */
					BgL_varz00_bglt BgL_arg1906z00_2879;

					BgL_arg1906z00_2879 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2740)))->BgL_varz00);
					BgL_arg1905z00_2878 =
						BGl_tracezd2nodezd2zztrace_walkz00(
						((BgL_nodez00_bglt) BgL_arg1906z00_2879), BgL_stackz00_2741,
						BgL_levelz00_2742);
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2740)))->BgL_varz00) =
					((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_arg1905z00_2878)), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2740));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-make-box1379 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2makezd2box1379zb0zztrace_walkz00(obj_t
		BgL_envz00_2743, obj_t BgL_nodez00_2744, obj_t BgL_stackz00_2745,
		obj_t BgL_levelz00_2746)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 418 */
			((((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2744)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_makezd2boxzd2_bglt)
								COBJECT(((BgL_makezd2boxzd2_bglt) BgL_nodez00_2744)))->
							BgL_valuez00), BgL_stackz00_2745, BgL_levelz00_2746)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2744));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-jump-ex-i1377 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1377z62zztrace_walkz00(obj_t
		BgL_envz00_2747, obj_t BgL_nodez00_2748, obj_t BgL_stackz00_2749,
		obj_t BgL_levelz00_2750)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 409 */
			{
				BgL_nodez00_bglt BgL_auxz00_3617;

				{	/* Trace/walk.scm 411 */
					BgL_nodez00_bglt BgL_arg1901z00_2882;

					BgL_arg1901z00_2882 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2748)))->BgL_exitz00);
					BgL_auxz00_3617 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1901z00_2882,
						BgL_stackz00_2749, BgL_levelz00_2750);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2748)))->
						BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3617), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3623;

				{	/* Trace/walk.scm 412 */
					BgL_nodez00_bglt BgL_arg1902z00_2883;

					BgL_arg1902z00_2883 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2748)))->
						BgL_valuez00);
					BgL_auxz00_3623 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1902z00_2883,
						BgL_stackz00_2749, BgL_levelz00_2750);
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2748)))->
						BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3623), BUNSPEC);
			}
			return
				((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2748));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-set-ex-it1375 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1375z62zztrace_walkz00(obj_t
		BgL_envz00_2751, obj_t BgL_nodez00_2752, obj_t BgL_stackz00_2753,
		obj_t BgL_levelz00_2754)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 402 */
			((((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2752)))->BgL_bodyz00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setzd2exzd2itz00_bglt)
								COBJECT(((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2752)))->
							BgL_bodyz00), BgL_stackz00_2753, BgL_levelz00_2754)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt)
					BgL_nodez00_2752));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-let-var1373 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2var1373zb0zztrace_walkz00(obj_t
		BgL_envz00_2755, obj_t BgL_nodez00_2756, obj_t BgL_stackz00_2757,
		obj_t BgL_levelz00_2758)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 391 */
			{	/* Trace/walk.scm 393 */
				obj_t BgL_g1312z00_2886;

				BgL_g1312z00_2886 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2756)))->BgL_bindingsz00);
				{
					obj_t BgL_l1310z00_2888;

					BgL_l1310z00_2888 = BgL_g1312z00_2886;
				BgL_zc3anonymousza31893ze3z83_2887:
					if (PAIRP(BgL_l1310z00_2888))
						{	/* Trace/walk.scm 393 */
							{	/* Trace/walk.scm 394 */
								obj_t BgL_bindingz00_2889;

								BgL_bindingz00_2889 = CAR(BgL_l1310z00_2888);
								{	/* Trace/walk.scm 394 */
									BgL_nodez00_bglt BgL_arg1895z00_2890;

									{	/* Trace/walk.scm 394 */
										obj_t BgL_arg1896z00_2891;

										BgL_arg1896z00_2891 = CDR(((obj_t) BgL_bindingz00_2889));
										BgL_arg1895z00_2890 =
											BGl_tracezd2nodezd2zztrace_walkz00(
											((BgL_nodez00_bglt) BgL_arg1896z00_2891),
											BgL_stackz00_2757, BgL_levelz00_2758);
									}
									{	/* Trace/walk.scm 394 */
										obj_t BgL_auxz00_3649;
										obj_t BgL_tmpz00_3647;

										BgL_auxz00_3649 = ((obj_t) BgL_arg1895z00_2890);
										BgL_tmpz00_3647 = ((obj_t) BgL_bindingz00_2889);
										SET_CDR(BgL_tmpz00_3647, BgL_auxz00_3649);
									}
								}
							}
							{
								obj_t BgL_l1310z00_3652;

								BgL_l1310z00_3652 = CDR(BgL_l1310z00_2888);
								BgL_l1310z00_2888 = BgL_l1310z00_3652;
								goto BgL_zc3anonymousza31893ze3z83_2887;
							}
						}
					else
						{	/* Trace/walk.scm 393 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3654;

				{	/* Trace/walk.scm 396 */
					BgL_nodez00_bglt BgL_arg1898z00_2892;

					BgL_arg1898z00_2892 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2756)))->BgL_bodyz00);
					BgL_auxz00_3654 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1898z00_2892,
						BgL_stackz00_2757, BgL_levelz00_2758);
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_2756)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3654), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nodez00_2756));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-let-fun1371 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2fun1371zb0zztrace_walkz00(obj_t
		BgL_envz00_2759, obj_t BgL_nodez00_2760, obj_t BgL_stackz00_2761,
		obj_t BgL_levelz00_2762)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 382 */
			{	/* Trace/walk.scm 384 */
				obj_t BgL_g1309z00_2894;

				BgL_g1309z00_2894 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2760)))->BgL_localsz00);
				{
					obj_t BgL_l1307z00_2896;

					BgL_l1307z00_2896 = BgL_g1309z00_2894;
				BgL_zc3anonymousza31889ze3z83_2895:
					if (PAIRP(BgL_l1307z00_2896))
						{	/* Trace/walk.scm 384 */
							BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l1307z00_2896),
								BgL_stackz00_2761, BgL_levelz00_2762);
							{
								obj_t BgL_l1307z00_3668;

								BgL_l1307z00_3668 = CDR(BgL_l1307z00_2896);
								BgL_l1307z00_2896 = BgL_l1307z00_3668;
								goto BgL_zc3anonymousza31889ze3z83_2895;
							}
						}
					else
						{	/* Trace/walk.scm 384 */
							((bool_t) 1);
						}
				}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3670;

				{	/* Trace/walk.scm 385 */
					BgL_nodez00_bglt BgL_arg1892z00_2897;

					BgL_arg1892z00_2897 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2760)))->BgL_bodyz00);
					BgL_auxz00_3670 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1892z00_2897,
						BgL_stackz00_2761, BgL_levelz00_2762);
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nodez00_2760)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3670), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nodez00_2760));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-switch1369 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2switch1369z62zztrace_walkz00(obj_t
		BgL_envz00_2763, obj_t BgL_nodez00_2764, obj_t BgL_stackz00_2765,
		obj_t BgL_levelz00_2766)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 371 */
			{
				BgL_nodez00_bglt BgL_auxz00_3678;

				{	/* Trace/walk.scm 373 */
					BgL_nodez00_bglt BgL_arg1882z00_2899;

					BgL_arg1882z00_2899 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2764)))->BgL_testz00);
					BgL_auxz00_3678 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1882z00_2899,
						BgL_stackz00_2765, BgL_levelz00_2766);
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2764)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3678), BUNSPEC);
			}
			{	/* Trace/walk.scm 374 */
				obj_t BgL_g1306z00_2900;

				BgL_g1306z00_2900 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2764)))->BgL_clausesz00);
				{
					obj_t BgL_l1304z00_2902;

					BgL_l1304z00_2902 = BgL_g1306z00_2900;
				BgL_zc3anonymousza31883ze3z83_2901:
					if (PAIRP(BgL_l1304z00_2902))
						{	/* Trace/walk.scm 374 */
							{	/* Trace/walk.scm 375 */
								obj_t BgL_clausez00_2903;

								BgL_clausez00_2903 = CAR(BgL_l1304z00_2902);
								{	/* Trace/walk.scm 375 */
									BgL_nodez00_bglt BgL_arg1886z00_2904;

									{	/* Trace/walk.scm 375 */
										obj_t BgL_arg1887z00_2905;

										BgL_arg1887z00_2905 = CDR(((obj_t) BgL_clausez00_2903));
										BgL_arg1886z00_2904 =
											BGl_tracezd2nodezd2zztrace_walkz00(
											((BgL_nodez00_bglt) BgL_arg1887z00_2905),
											BgL_stackz00_2765, BgL_levelz00_2766);
									}
									{	/* Trace/walk.scm 375 */
										obj_t BgL_auxz00_3695;
										obj_t BgL_tmpz00_3693;

										BgL_auxz00_3695 = ((obj_t) BgL_arg1886z00_2904);
										BgL_tmpz00_3693 = ((obj_t) BgL_clausez00_2903);
										SET_CDR(BgL_tmpz00_3693, BgL_auxz00_3695);
									}
								}
							}
							{
								obj_t BgL_l1304z00_3698;

								BgL_l1304z00_3698 = CDR(BgL_l1304z00_2902);
								BgL_l1304z00_2902 = BgL_l1304z00_3698;
								goto BgL_zc3anonymousza31883ze3z83_2901;
							}
						}
					else
						{	/* Trace/walk.scm 374 */
							((bool_t) 1);
						}
				}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nodez00_2764));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-fail1366 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2fail1366z62zztrace_walkz00(obj_t
		BgL_envz00_2767, obj_t BgL_nodez00_2768, obj_t BgL_stackz00_2769,
		obj_t BgL_levelz00_2770)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 361 */
			{
				BgL_nodez00_bglt BgL_auxz00_3702;

				{	/* Trace/walk.scm 363 */
					BgL_nodez00_bglt BgL_arg1879z00_2907;

					BgL_arg1879z00_2907 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2768)))->BgL_procz00);
					BgL_auxz00_3702 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1879z00_2907,
						BgL_stackz00_2769, BgL_levelz00_2770);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2768)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3702), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3708;

				{	/* Trace/walk.scm 364 */
					BgL_nodez00_bglt BgL_arg1880z00_2908;

					BgL_arg1880z00_2908 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2768)))->BgL_msgz00);
					BgL_auxz00_3708 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1880z00_2908,
						BgL_stackz00_2769, BgL_levelz00_2770);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2768)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3708), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3714;

				{	/* Trace/walk.scm 365 */
					BgL_nodez00_bglt BgL_arg1881z00_2909;

					BgL_arg1881z00_2909 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2768)))->BgL_objz00);
					BgL_auxz00_3714 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1881z00_2909,
						BgL_stackz00_2769, BgL_levelz00_2770);
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nodez00_2768)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3714), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nodez00_2768));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-condition1363 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2condition1363z62zztrace_walkz00(obj_t
		BgL_envz00_2771, obj_t BgL_nodez00_2772, obj_t BgL_stackz00_2773,
		obj_t BgL_levelz00_2774)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 351 */
			{
				BgL_nodez00_bglt BgL_auxz00_3722;

				{	/* Trace/walk.scm 353 */
					BgL_nodez00_bglt BgL_arg1876z00_2911;

					BgL_arg1876z00_2911 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2772)))->BgL_testz00);
					BgL_auxz00_3722 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1876z00_2911,
						BgL_stackz00_2773, BgL_levelz00_2774);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2772)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3722), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3728;

				{	/* Trace/walk.scm 354 */
					BgL_nodez00_bglt BgL_arg1877z00_2912;

					BgL_arg1877z00_2912 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2772)))->BgL_truez00);
					BgL_auxz00_3728 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1877z00_2912,
						BgL_stackz00_2773, BgL_levelz00_2774);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2772)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3728), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3734;

				{	/* Trace/walk.scm 355 */
					BgL_nodez00_bglt BgL_arg1878z00_2913;

					BgL_arg1878z00_2913 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2772)))->BgL_falsez00);
					BgL_auxz00_3734 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1878z00_2913,
						BgL_stackz00_2773, BgL_levelz00_2774);
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nodez00_2772)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_3734), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nodez00_2772));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-setq1361 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2setq1361z62zztrace_walkz00(obj_t
		BgL_envz00_2775, obj_t BgL_nodez00_2776, obj_t BgL_stackz00_2777,
		obj_t BgL_levelz00_2778)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 344 */
			((((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2776)))->BgL_valuez00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setqz00_bglt)
								COBJECT(((BgL_setqz00_bglt) BgL_nodez00_2776)))->BgL_valuez00),
						BgL_stackz00_2777, BgL_levelz00_2778)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nodez00_2776));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-cast1359 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2cast1359z62zztrace_walkz00(obj_t
		BgL_envz00_2779, obj_t BgL_nodez00_2780, obj_t BgL_stackz00_2781,
		obj_t BgL_levelz00_2782)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 337 */
			((((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2780)))->BgL_argz00) =
				((BgL_nodez00_bglt)
					BGl_tracezd2nodezd2zztrace_walkz00((((BgL_castz00_bglt)
								COBJECT(((BgL_castz00_bglt) BgL_nodez00_2780)))->BgL_argz00),
						BgL_stackz00_2781, BgL_levelz00_2782)), BUNSPEC);
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nodez00_2780));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-extern1357 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2extern1357z62zztrace_walkz00(obj_t
		BgL_envz00_2783, obj_t BgL_nodez00_2784, obj_t BgL_stackz00_2785,
		obj_t BgL_levelz00_2786)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 330 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2784)))->BgL_exprza2za2),
				BgL_stackz00_2785, BgL_levelz00_2786);
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2784));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-funcall1355 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2funcall1355z62zztrace_walkz00(obj_t
		BgL_envz00_2787, obj_t BgL_nodez00_2788, obj_t BgL_stackz00_2789,
		obj_t BgL_levelz00_2790)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 321 */
			{
				BgL_nodez00_bglt BgL_auxz00_3761;

				{	/* Trace/walk.scm 323 */
					BgL_nodez00_bglt BgL_arg1869z00_2918;

					BgL_arg1869z00_2918 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2788)))->BgL_funz00);
					BgL_auxz00_3761 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1869z00_2918,
						BgL_stackz00_2789, BgL_levelz00_2790);
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2788)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3761), BUNSPEC);
			}
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2788)))->BgL_argsz00),
				BgL_stackz00_2789, BgL_levelz00_2790);
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2788));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-app-ly1353 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2appzd2ly1353zb0zztrace_walkz00(obj_t
		BgL_envz00_2791, obj_t BgL_nodez00_2792, obj_t BgL_stackz00_2793,
		obj_t BgL_levelz00_2794)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 312 */
			{
				BgL_nodez00_bglt BgL_auxz00_3772;

				{	/* Trace/walk.scm 314 */
					BgL_nodez00_bglt BgL_arg1866z00_2920;

					BgL_arg1866z00_2920 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2792)))->BgL_funz00);
					BgL_auxz00_3772 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1866z00_2920,
						BgL_stackz00_2793, BgL_levelz00_2794);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2792)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3772), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3778;

				{	/* Trace/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg1868z00_2921;

					BgL_arg1868z00_2921 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2792)))->BgL_argz00);
					BgL_auxz00_3778 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1868z00_2921,
						BgL_stackz00_2793, BgL_levelz00_2794);
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2792)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3778), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2792));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-app1351 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1351z62zztrace_walkz00(obj_t
		BgL_envz00_2795, obj_t BgL_nodez00_2796, obj_t BgL_stackz00_2797,
		obj_t BgL_levelz00_2798)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 305 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2796)))->BgL_argsz00),
				BgL_stackz00_2797, BgL_levelz00_2798);
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2796));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-sync1349 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sync1349z62zztrace_walkz00(obj_t
		BgL_envz00_2799, obj_t BgL_nodez00_2800, obj_t BgL_stackz00_2801,
		obj_t BgL_levelz00_2802)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 295 */
			{
				BgL_nodez00_bglt BgL_auxz00_3791;

				{	/* Trace/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg1862z00_2924;

					BgL_arg1862z00_2924 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2800)))->BgL_mutexz00);
					BgL_auxz00_3791 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1862z00_2924,
						BgL_stackz00_2801, BgL_levelz00_2802);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2800)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3791), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3797;

				{	/* Trace/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg1863z00_2925;

					BgL_arg1863z00_2925 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2800)))->BgL_prelockz00);
					BgL_auxz00_3797 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1863z00_2925,
						BgL_stackz00_2801, BgL_levelz00_2802);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2800)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3797), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_3803;

				{	/* Trace/walk.scm 299 */
					BgL_nodez00_bglt BgL_arg1864z00_2926;

					BgL_arg1864z00_2926 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2800)))->BgL_bodyz00);
					BgL_auxz00_3803 =
						BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1864z00_2926,
						BgL_stackz00_2801, BgL_levelz00_2802);
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nodez00_2800)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_3803), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nodez00_2800));
		}
		BGL_FUNCTION_END;
	}



/* &trace-node-sequence1347 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sequence1347z62zztrace_walkz00(obj_t
		BgL_envz00_2803, obj_t BgL_nodez00_2804, obj_t BgL_stackz00_2805,
		obj_t BgL_levelz00_2806)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 288 */
			BGl_tracezd2nodeza2z12z62zztrace_walkz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2804)))->BgL_nodesz00),
				BgL_stackz00_2805, BgL_levelz00_2806);
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nodez00_2804));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-jump-1342 */
	obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21342z62zztrace_walkz00(obj_t
		BgL_envz00_2807, obj_t BgL_nodez00_2808)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 238 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2808)))->BgL_valuez00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-set-e1340 */
	obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1340z62zztrace_walkz00(obj_t
		BgL_envz00_2809, obj_t BgL_nodez00_2810)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 232 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2810)))->BgL_bodyz00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-let-f1338 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1338z62zztrace_walkz00(obj_t
		BgL_envz00_2811, obj_t BgL_nodez00_2812)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 226 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2812)))->BgL_bodyz00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-let-v1336 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1336z62zztrace_walkz00(obj_t
		BgL_envz00_2813, obj_t BgL_nodez00_2814)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 220 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2814)))->BgL_bodyz00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-switc1334 */
	obj_t BGl_z62findzd2lastzd2nodezd2switc1334zb0zztrace_walkz00(obj_t
		BgL_envz00_2815, obj_t BgL_nodez00_2816)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 211 */
			{	/* Trace/walk.scm 213 */
				bool_t BgL_testz00_3828;

				{	/* Trace/walk.scm 213 */
					obj_t BgL_tmpz00_3829;

					BgL_tmpz00_3829 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_2816)))->BgL_clausesz00);
					BgL_testz00_3828 = PAIRP(BgL_tmpz00_3829);
				}
				if (BgL_testz00_3828)
					{	/* Trace/walk.scm 214 */
						obj_t BgL_arg1849z00_2933;

						BgL_arg1849z00_2933 =
							CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_switchz00_bglt) COBJECT(
											((BgL_switchz00_bglt) BgL_nodez00_2816)))->
									BgL_clausesz00)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1849z00_2933));
					}
				else
					{	/* Trace/walk.scm 213 */
						return
							BGl_findzd2lastzd2sexpz00zztrace_walkz00(
							((obj_t)
								(((BgL_switchz00_bglt) COBJECT(
											((BgL_switchz00_bglt) BgL_nodez00_2816)))->BgL_testz00)));
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-fail1332 */
	obj_t BGl_z62findzd2lastzd2nodezd2fail1332zb0zztrace_walkz00(obj_t
		BgL_envz00_2817, obj_t BgL_nodez00_2818)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 205 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2818)))->BgL_objz00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-condi1330 */
	obj_t BGl_z62findzd2lastzd2nodezd2condi1330zb0zztrace_walkz00(obj_t
		BgL_envz00_2819, obj_t BgL_nodez00_2820)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 199 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2820)))->BgL_falsez00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-setq1328 */
	obj_t BGl_z62findzd2lastzd2nodezd2setq1328zb0zztrace_walkz00(obj_t
		BgL_envz00_2821, obj_t BgL_nodez00_2822)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 193 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2822)))->BgL_valuez00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-exter1326 */
	obj_t BGl_z62findzd2lastzd2nodezd2exter1326zb0zztrace_walkz00(obj_t
		BgL_envz00_2823, obj_t BgL_nodez00_2824)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 184 */
			if (NULLP(
					(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nodez00_2824)))->BgL_exprza2za2)))
				{	/* Trace/walk.scm 186 */
					return ((obj_t) ((BgL_externz00_bglt) BgL_nodez00_2824));
				}
			else
				{	/* Trace/walk.scm 187 */
					obj_t BgL_arg1838z00_2938;

					BgL_arg1838z00_2938 =
						CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
							(((BgL_externz00_bglt) COBJECT(
										((BgL_externz00_bglt) BgL_nodez00_2824)))->
								BgL_exprza2za2)));
					return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
							BgL_arg1838z00_2938));
				}
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-funca1324 */
	obj_t BGl_z62findzd2lastzd2nodezd2funca1324zb0zztrace_walkz00(obj_t
		BgL_envz00_2825, obj_t BgL_nodez00_2826)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 175 */
			{	/* Trace/walk.scm 177 */
				bool_t BgL_testz00_3864;

				{	/* Trace/walk.scm 177 */
					obj_t BgL_tmpz00_3865;

					BgL_tmpz00_3865 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_2826)))->BgL_argsz00);
					BgL_testz00_3864 = PAIRP(BgL_tmpz00_3865);
				}
				if (BgL_testz00_3864)
					{	/* Trace/walk.scm 178 */
						obj_t BgL_arg1830z00_2940;

						BgL_arg1830z00_2940 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_funcallz00_bglt) COBJECT(
											((BgL_funcallz00_bglt) BgL_nodez00_2826)))->
									BgL_argsz00)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1830z00_2940));
					}
				else
					{	/* Trace/walk.scm 177 */
						return
							BGl_findzd2lastzd2nodez00zztrace_walkz00(
							(((BgL_funcallz00_bglt) COBJECT(
										((BgL_funcallz00_bglt) BgL_nodez00_2826)))->BgL_funz00));
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-app-l1322 */
	obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1322z62zztrace_walkz00(obj_t
		BgL_envz00_2827, obj_t BgL_nodez00_2828)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 169 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2828)))->BgL_argz00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-app1320 */
	obj_t BGl_z62findzd2lastzd2nodezd2app1320zb0zztrace_walkz00(obj_t
		BgL_envz00_2829, obj_t BgL_nodez00_2830)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 160 */
			{	/* Trace/walk.scm 162 */
				bool_t BgL_testz00_3881;

				{	/* Trace/walk.scm 162 */
					obj_t BgL_tmpz00_3882;

					BgL_tmpz00_3882 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_2830)))->BgL_argsz00);
					BgL_testz00_3881 = PAIRP(BgL_tmpz00_3882);
				}
				if (BgL_testz00_3881)
					{	/* Trace/walk.scm 163 */
						obj_t BgL_arg1820z00_2943;

						BgL_arg1820z00_2943 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nodez00_2830)))->BgL_argsz00)));
						return
							BGl_findzd2lastzd2nodez00zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1820z00_2943));
					}
				else
					{	/* Trace/walk.scm 162 */
						return ((obj_t) ((BgL_appz00_bglt) BgL_nodez00_2830));
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-sync1318 */
	obj_t BGl_z62findzd2lastzd2nodezd2sync1318zb0zztrace_walkz00(obj_t
		BgL_envz00_2831, obj_t BgL_nodez00_2832)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 153 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2832)))->BgL_bodyz00));
		}
		BGL_FUNCTION_END;
	}



/* &find-last-node-seque1316 */
	obj_t BGl_z62findzd2lastzd2nodezd2seque1316zb0zztrace_walkz00(obj_t
		BgL_envz00_2833, obj_t BgL_nodez00_2834)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 144 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_2834)))->BgL_nodesz00)))
				{	/* Trace/walk.scm 146 */
					return ((obj_t) ((BgL_sequencez00_bglt) BgL_nodez00_2834));
				}
			else
				{	/* Trace/walk.scm 147 */
					obj_t BgL_arg1812z00_2946;

					BgL_arg1812z00_2946 =
						CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
							(((BgL_sequencez00_bglt) COBJECT(
										((BgL_sequencez00_bglt) BgL_nodez00_2834)))->
								BgL_nodesz00)));
					return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
							BgL_arg1812z00_2946));
				}
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 506185397),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 36886173),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 173709144),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2160z00zztrace_walkz00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
