/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -srfi enable-resolv -srfi enable-gmp -srfi enable-unistring -srfi enable-pcre -O3 -fcfa-arithmetic -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_comp.scm -o objs/obj_p/Eval/evaluate_comp.o) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_z62zc3anonymousza31886ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5230z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5232z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5234z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5236z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5238z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32302ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32883ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32794ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5240z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5242z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5244z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5246z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5248z00zz__evaluate_compz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3anonymousza32036ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5250z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5252z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5254z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5256z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5258z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5260z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_symbol5262z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5264z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5266z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5268z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza33212ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32038ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza32797ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32959ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5270z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5272z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5274z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5276z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5278z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32306ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33019ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31996ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
static obj_t BGl_symbol5280z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33230ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32993ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
static obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t);
extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33070ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62run5101z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
static obj_t BGl_z62run5103z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5105z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5107z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5109z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza33146ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static long BGl_correctz00zz__evaluate_compz00(obj_t, long);
static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long, obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62run5111z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5113z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5115z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
static obj_t BGl_z62run5117z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5119z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33252ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
static obj_t BGl_z62run5121z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run5123z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5125z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5127z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5129z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5131z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5133z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5135z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5137z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5139z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32703ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33076ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_reset_profilez00zz__evaluate_compz00();
static obj_t BGl_z62zc3anonymousza32096ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5141z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5143z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
static obj_t BGl_z62run5145z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5147z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5149z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33166ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_labels1424zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5151z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5153z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5155z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5157z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5159z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33361ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33272ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33183ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5161z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5163z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5165z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5167z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5169z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5100z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5102z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5104z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5106z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5108z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run5171z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5173z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5175z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5177z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5179z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32723ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5110z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32707ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
static obj_t BGl_z62main5112z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5114z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5116z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5118z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62run5181z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32651ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5120z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33526ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5122z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5124z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5126z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5128z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62main5130z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5132z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5134z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5136z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5138z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
static obj_t BGl_z62compzd2ev_bindzd2exit1416z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
extern int bgl_debug();
static obj_t BGl_z62zc3anonymousza32815ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5140z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5142z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5144z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5146z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
static obj_t BGl_z62main5148z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
extern obj_t create_struct(obj_t, int);
static obj_t BGl_get_profilez00zz__evaluate_compz00();
static obj_t BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5150z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5152z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5154z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
static obj_t BGl_z62main5156z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5158z62zz__evaluate_compz00(obj_t, obj_t);
extern long bgl_list_length(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32671ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32655ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33295ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5160z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5162z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5164z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5166z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5168z62zz__evaluate_compz00(obj_t);
static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_withzd2handler1420z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza32834ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33563ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32818ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33458ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32729ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5170z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5172z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5174z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5176z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5178z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33475ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33386ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5180z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t);
static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_letza21412z12zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33581ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32909ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3anonymousza32691ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32675ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32659ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
static obj_t BGl_profzd2initzd2zz__evaluate_compz00();
extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
static obj_t BGl_z62zc3anonymousza32695ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32679ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32858ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33498ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5311z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long, obj_t, obj_t);
static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62zc3anonymousza32980ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol5328z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32400ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33040ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5330z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5332z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5334z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza33041ze3ze1zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3anonymousza32150ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_prog21408zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32699ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5186z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5188z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza33026ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static obj_t BGl_symbol5190z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5196z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62zc3anonymousza33205ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32152ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33027ze3ze1zz__evaluate_compz00(obj_t);
static obj_t BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33222ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33044ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza32228ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bgl_reverse_bang(obj_t);
static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
static obj_t BGl_z62zc3anonymousza33330ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32156ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza31800ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33315ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33153ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33137ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32068ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_goto1426zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_let1410zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza32352ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32263ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33065ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33244ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32191ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33173ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3anonymousza33408ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_synchroniza7e1422z17zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33263ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33191ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32446ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_app1428zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62zc3anonymousza32803ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5097z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5099z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32715ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33339ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32910ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32821ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32732ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31841ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32643ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
static obj_t BGl_zc3exitza33037ze3ze70z64zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3anonymousza33551ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33624ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32806ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl_z62zc3anonymousza31754ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33447ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32719ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
static obj_t BGl_z62zc3anonymousza31950ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31861ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32825ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32663ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31934ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32809ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33287ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_abs1430zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_letrec1414zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32915ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33377ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5096z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5098z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33645ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
static obj_t BGl_zc3exitza33020ze3ze70z64zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_z62zc3anonymousza32845ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32683ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33485ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62comp1385z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32935ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31777ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32015ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32863ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_unwindzd2prote1418z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31956ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza33398ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol5204z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5206z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5208z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
static obj_t BGl_z62zc3anonymousza32791ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5211z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5214z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5216z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5218z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32300ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32122ze3ze1zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_z62zc3anonymousza32938ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32687ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5220z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5222z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5224z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5226z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5228z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza33030ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_compz00(obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_bgl_za762za7c3lexintza7a1za75338z00, BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_compilezd2envzd2zz__evaluate_compz00, BgL_bgl_za762compileza762za7za7_5339z00, BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
DEFINE_STRING( BGl_string5200z00zz__evaluate_compz00, BgL_bgl_string5200za700za7za7_5340za7, "&compile", 8 );
DEFINE_STRING( BGl_string5201z00zz__evaluate_compz00, BgL_bgl_string5201za700za7za7_5341za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string5202z00zz__evaluate_compz00, BgL_bgl_string5202za700za7za7_5342za7, "expecting ~a, got ~a", 20 );
DEFINE_STRING( BGl_string5203z00zz__evaluate_compz00, BgL_bgl_string5203za700za7za7_5343za7, "wrong number of argument", 24 );
DEFINE_STRING( BGl_string5205z00zz__evaluate_compz00, BgL_bgl_string5205za700za7za7_5344za7, "mcell", 5 );
DEFINE_STRING( BGl_string5207z00zz__evaluate_compz00, BgL_bgl_string5207za700za7za7_5345za7, "internal", 8 );
extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
DEFINE_STRING( BGl_string5209z00zz__evaluate_compz00, BgL_bgl_string5209za700za7za7_5346za7, "impossible", 10 );
DEFINE_STRING( BGl_string5210z00zz__evaluate_compz00, BgL_bgl_string5210za700za7za7_5347za7, "procedure", 9 );
DEFINE_STRING( BGl_string5212z00zz__evaluate_compz00, BgL_bgl_string5212za700za7za7_5348za7, "user", 4 );
extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5213z00zz__evaluate_compz00, BgL_bgl_string5213za700za7za7_5349za7, "invalid byte code", 17 );
DEFINE_STRING( BGl_string5215z00zz__evaluate_compz00, BgL_bgl_string5215za700za7za7_5350za7, "+", 1 );
DEFINE_STRING( BGl_string5217z00zz__evaluate_compz00, BgL_bgl_string5217za700za7za7_5351za7, "number", 6 );
DEFINE_STRING( BGl_string5219z00zz__evaluate_compz00, BgL_bgl_string5219za700za7za7_5352za7, "-", 1 );
DEFINE_STRING( BGl_string5221z00zz__evaluate_compz00, BgL_bgl_string5221za700za7za7_5353za7, "*", 1 );
DEFINE_STRING( BGl_string5223z00zz__evaluate_compz00, BgL_bgl_string5223za700za7za7_5354za7, "/", 1 );
DEFINE_STRING( BGl_string5225z00zz__evaluate_compz00, BgL_bgl_string5225za700za7za7_5355za7, "<", 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_findzd2statezd2envz00zz__evaluate_compz00, BgL_bgl_za762findza7d2stateza75356za7, BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string5227z00zz__evaluate_compz00, BgL_bgl_string5227za700za7za7_5357za7, ">", 1 );
DEFINE_STRING( BGl_string5229z00zz__evaluate_compz00, BgL_bgl_string5229za700za7za7_5358za7, "<=", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5300z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5359z00, BGl_z62compzd2ev_letrec1414zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5301z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_bin5360z00, BGl_z62compzd2ev_bindzd2exit1416z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5302z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_unw5361z00, BGl_z62compzd2ev_unwindzd2prote1418z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5303z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_wit5362z00, BGl_z62compzd2ev_withzd2handler1420z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5304z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_syn5363z00, BGl_z62compzd2ev_synchroniza7e1422z17zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5305z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lab5364z00, BGl_z62compzd2ev_labels1424zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5306z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_got5365z00, BGl_z62compzd2ev_goto1426zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5231z00zz__evaluate_compz00, BgL_bgl_string5231za700za7za7_5366za7, ">=", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5307z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_app5367z00, BGl_z62compzd2ev_app1428zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5308z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_abs5368z00, BGl_z62compzd2ev_abs1430zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5233z00zz__evaluate_compz00, BgL_bgl_string5233za700za7za7_5369za7, "=", 1 );
DEFINE_STRING( BGl_string5235z00zz__evaluate_compz00, BgL_bgl_string5235za700za7za7_5370za7, "+fx", 3 );
DEFINE_STRING( BGl_string5237z00zz__evaluate_compz00, BgL_bgl_string5237za700za7za7_5371za7, "fixnum", 6 );
DEFINE_STRING( BGl_string5239z00zz__evaluate_compz00, BgL_bgl_string5239za700za7za7_5372za7, "-fx", 3 );
DEFINE_STRING( BGl_string5241z00zz__evaluate_compz00, BgL_bgl_string5241za700za7za7_5373za7, "*fx", 3 );
DEFINE_STRING( BGl_string5243z00zz__evaluate_compz00, BgL_bgl_string5243za700za7za7_5374za7, "/fx", 3 );
DEFINE_STRING( BGl_string5245z00zz__evaluate_compz00, BgL_bgl_string5245za700za7za7_5375za7, "<fx", 3 );
DEFINE_STRING( BGl_string5247z00zz__evaluate_compz00, BgL_bgl_string5247za700za7za7_5376za7, ">fx", 3 );
DEFINE_STRING( BGl_string5249z00zz__evaluate_compz00, BgL_bgl_string5249za700za7za7_5377za7, "<=fx", 4 );
extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5320z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75378za7, BGl_z62zc3anonymousza32791ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5321z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75379za7, BGl_z62zc3anonymousza32794ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5322z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75380za7, BGl_z62zc3anonymousza32797ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5323z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75381za7, BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5324z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75382za7, BGl_z62zc3anonymousza32803ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5325z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75383za7, BGl_z62zc3anonymousza32806ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5326z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75384za7, BGl_z62zc3anonymousza32809ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string5251z00zz__evaluate_compz00, BgL_bgl_string5251za700za7za7_5385za7, ">=fx", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5327z00zz__evaluate_compz00, BgL_bgl_za762za7c3anonymousza75386za7, BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string5253z00zz__evaluate_compz00, BgL_bgl_string5253za700za7za7_5387za7, "=fx", 3 );
DEFINE_STRING( BGl_string5255z00zz__evaluate_compz00, BgL_bgl_string5255za700za7za7_5388za7, "+fl", 3 );
DEFINE_STRING( BGl_string5257z00zz__evaluate_compz00, BgL_bgl_string5257za700za7za7_5389za7, "flonum", 6 );
DEFINE_STRING( BGl_string5259z00zz__evaluate_compz00, BgL_bgl_string5259za700za7za7_5390za7, "-fl", 3 );
DEFINE_STRING( BGl_string5261z00zz__evaluate_compz00, BgL_bgl_string5261za700za7za7_5391za7, "*fl", 3 );
DEFINE_STRING( BGl_string5263z00zz__evaluate_compz00, BgL_bgl_string5263za700za7za7_5392za7, "/fl", 3 );
DEFINE_STRING( BGl_string5265z00zz__evaluate_compz00, BgL_bgl_string5265za700za7za7_5393za7, "<fl", 3 );
DEFINE_STRING( BGl_string5267z00zz__evaluate_compz00, BgL_bgl_string5267za700za7za7_5394za7, ">fl", 3 );
DEFINE_STRING( BGl_string5269z00zz__evaluate_compz00, BgL_bgl_string5269za700za7za7_5395za7, "<=fl", 4 );
DEFINE_STRING( BGl_string5271z00zz__evaluate_compz00, BgL_bgl_string5271za700za7za7_5396za7, ">=fl", 4 );
DEFINE_STRING( BGl_string5273z00zz__evaluate_compz00, BgL_bgl_string5273za700za7za7_5397za7, "=fl", 3 );
DEFINE_STRING( BGl_string5275z00zz__evaluate_compz00, BgL_bgl_string5275za700za7za7_5398za7, "car", 3 );
DEFINE_STRING( BGl_string5277z00zz__evaluate_compz00, BgL_bgl_string5277za700za7za7_5399za7, "pair", 4 );
DEFINE_STRING( BGl_string5279z00zz__evaluate_compz00, BgL_bgl_string5279za700za7za7_5400za7, "cdr", 3 );
extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5281z00zz__evaluate_compz00, BgL_bgl_string5281za700za7za7_5401za7, "cadr", 4 );
DEFINE_STRING( BGl_string5283z00zz__evaluate_compz00, BgL_bgl_string5283za700za7za7_5402za7, "comp1385", 8 );
DEFINE_STRING( BGl_string5284z00zz__evaluate_compz00, BgL_bgl_string5284za700za7za7_5403za7, "internal error: not defined for", 31 );
DEFINE_STRING( BGl_string5285z00zz__evaluate_compz00, BgL_bgl_string5285za700za7za7_5404za7, "&comp", 5 );
DEFINE_STRING( BGl_string5287z00zz__evaluate_compz00, BgL_bgl_string5287za700za7za7_5405za7, "comp", 4 );
extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
DEFINE_STATIC_BGL_GENERIC( BGl_compzd2envzd2zz__evaluate_compz00, BgL_bgl_za762compza762za7za7__ev5406z00, BGl_z62compz62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5309z00zz__evaluate_compz00, BgL_bgl_string5309za700za7za7_5407za7, "internal error", 14 );
DEFINE_STRING( BGl_string5310z00zz__evaluate_compz00, BgL_bgl_string5310za700za7za7_5408za7, "must be dead code", 17 );
DEFINE_STRING( BGl_string5312z00zz__evaluate_compz00, BgL_bgl_string5312za700za7za7_5409za7, "notyet", 6 );
DEFINE_STRING( BGl_string5313z00zz__evaluate_compz00, BgL_bgl_string5313za700za7za7_5410za7, "synchronize", 11 );
DEFINE_STRING( BGl_string5314z00zz__evaluate_compz00, BgL_bgl_string5314za700za7za7_5411za7, "mutex", 5 );
DEFINE_STRING( BGl_string5315z00zz__evaluate_compz00, BgL_bgl_string5315za700za7za7_5412za7, "set!", 4 );
DEFINE_STRING( BGl_string5316z00zz__evaluate_compz00, BgL_bgl_string5316za700za7za7_5413za7, "read-only variable", 18 );
DEFINE_STRING( BGl_string5317z00zz__evaluate_compz00, BgL_bgl_string5317za700za7za7_5414za7, "\nRedefinition of compiled variable -- ", 38 );
DEFINE_STRING( BGl_string5318z00zz__evaluate_compz00, BgL_bgl_string5318za700za7za7_5415za7, "Unbound variable", 16 );
DEFINE_STRING( BGl_string5319z00zz__evaluate_compz00, BgL_bgl_string5319za700za7za7_5416za7, "Uninitialized variable", 22 );
DEFINE_STRING( BGl_string5329z00zz__evaluate_compz00, BgL_bgl_string5329za700za7za7_5417za7, "get_sp", 6 );
extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string5331z00zz__evaluate_compz00, BgL_bgl_string5331za700za7za7_5418za7, "reset_profile", 13 );
DEFINE_STRING( BGl_string5333z00zz__evaluate_compz00, BgL_bgl_string5333za700za7za7_5419za7, "get_profile", 11 );
DEFINE_STRING( BGl_string5335z00zz__evaluate_compz00, BgL_bgl_string5335za700za7za7_5420za7, "reset_stack", 11 );
DEFINE_STRING( BGl_string5336z00zz__evaluate_compz00, BgL_bgl_string5336za700za7za7_5421za7, "internal error: unknown command", 31 );
DEFINE_STRING( BGl_string5337z00zz__evaluate_compz00, BgL_bgl_string5337za700za7za7_5422za7, "__evaluate_comp", 15 );
DEFINE_STRING( BGl_string5187z00zz__evaluate_compz00, BgL_bgl_string5187za700za7za7_5423za7, "all", 3 );
DEFINE_STRING( BGl_string5189z00zz__evaluate_compz00, BgL_bgl_string5189za700za7za7_5424za7, "label-tag", 9 );
DEFINE_STRING( BGl_string5191z00zz__evaluate_compz00, BgL_bgl_string5191za700za7za7_5425za7, "bounce", 6 );
DEFINE_STRING( BGl_string5192z00zz__evaluate_compz00, BgL_bgl_string5192za700za7za7_5426za7, "non non non", 11 );
DEFINE_STRING( BGl_string5193z00zz__evaluate_compz00, BgL_bgl_string5193za700za7za7_5427za7, " in ", 4 );
DEFINE_STRING( BGl_string5194z00zz__evaluate_compz00, BgL_bgl_string5194za700za7za7_5428za7, "eval", 4 );
DEFINE_STRING( BGl_string5195z00zz__evaluate_compz00, BgL_bgl_string5195za700za7za7_5429za7, "internal error: not found", 25 );
DEFINE_STRING( BGl_string5197z00zz__evaluate_compz00, BgL_bgl_string5197za700za7za7_5430za7, "at", 2 );
DEFINE_STRING( BGl_string5198z00zz__evaluate_compz00, BgL_bgl_string5198za700za7za7_5431za7, "", 0 );
DEFINE_STRING( BGl_string5199z00zz__evaluate_compz00, BgL_bgl_string5199za700za7za7_5432za7, "/builddir/build/BUILD/bigloo4.3f/runtime/Eval/evaluate_comp.scm", 63 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5282z00zz__evaluate_compz00, BgL_bgl_za762comp1385za762za7za75433z00, BGl_z62comp1385z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5286z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_tra5434z00, BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5288z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_var5435z00, BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5289z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set5436z00, BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5290z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_glo5437z00, BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5291z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set5438z00, BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5292z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_def5439z00, BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5293z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lit5440z00, BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5294z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_if15441z00, BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5295z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_or15442z00, BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5296z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_and5443z00, BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5297z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_pro5444z00, BGl_z62compzd2ev_prog21408zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5298z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5445z00, BGl_z62compzd2ev_let1410zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5299z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5446z00, BGl_z62compzd2ev_letza21412z12zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol5230z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5232z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5234z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5236z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5238z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5240z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5242z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5244z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5246z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5248z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5250z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5252z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5254z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5256z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5258z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5260z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5262z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5264z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5266z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5268z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5270z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5272z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5274z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5276z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5278z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5280z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5311z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5328z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5330z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5332z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5334z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5186z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5188z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5190z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5196z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5204z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5206z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5208z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5211z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5214z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5216z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5218z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5220z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5222z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5224z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5226z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5228z00zz__evaluate_compz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_comp.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"append-21010\" \"BGl_appendzd221010zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"reset_profile\" \"Eval/evaluate_comp.scm\" 3738) \"BGl_reset_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"o->s~0\" \"Eval/evaluate_comp.scm\" 3991) \"BGl_ozd2ze3sze70zd6zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<lexint\" \"Eval/evaluate_comp.scm\" 3822) \"BGl_z62zc3lexintza1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"get_profile\" \"Eval/evaluate_comp.scm\" 4130) \"BGl_get_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~1\" \"Eval/evaluate_comp.scm\" 4155) \"BGl_recze71ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"index\" \"Eval/evaluate_comp.scm\" 4323) \"BGl_indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"_index\" \"Eval/evaluate_comp.scm\" 4474) \"BGl__indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"lname\" \"Eval/evaluate_comp.scm\" 5060) \"BGl_lnamez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"loc-type-error\" \"Eval/evaluate_comp.scm\" 5157) \"BGl_loczd2typezd2errorz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-state\" \"Eval/evaluate_comp.scm\" 5415) \"BGl_makezd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_findzd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_z62findzd2statezb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_compilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_z62compilez62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"global-fun-value\" \"Eval/evaluate_comp.scm\" 8623) \"BGl_globalzd2funzd2valuez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-goto-trampoline\" \"Eval/evaluate_comp.scm\" 17346) \"BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-boxes-args-on-sp\" \"Eval/evaluate_comp.scm\" 18720) \"BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"sub-stk\" \"Eval/evaluate_comp.scm\" 19328) \"BGl_subzd2stkzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-trampoline\" \"Eval/evaluate_comp.scm\" 19829) \"BGl_catchzd2trampolinezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"check-stack\" \"Eval/evaluate_comp.scm\" 20164) \"BGl_checkzd2stackzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-with-push\" \"Eval/evaluate_comp.scm\" 20234) \"BGl_compzd2withzd2pushz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~0\" \"Eval/evaluate_comp.scm\" 20479) \"BGl_recze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"subr-call-with-push\" \"Eval/evaluate_comp.scm\" 20642) \"BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-args-on-sp\" \"Eval/evaluate_comp.scm\" 20879) \"BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-nargs-on-sp\" \"Eval/evaluate_comp.scm\" 21039) \"BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"need-shift\" \"Eval/evaluate_comp.scm\" 23185) \"BGl_needzd2shiftzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-old-call\" \"Eval/evaluate_comp.scm\" 23450) \"BGl_compzd2oldzd2callz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1754>\" \"Eval/evaluate_comp.scm\" 23890) \"BGl_z62zc3anonymousza31754ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1777>\" \"Eval/evaluate_comp.scm\" 23890) \"BGl_z62zc3anonymousza31777ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1800>\" \"Eval/evaluate_comp.scm\" 24231) \"BGl_z62zc3anonymousza31800ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1820>\" \"Eval/evaluate_comp.scm\" 24231) \"BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1841>\" \"Eval/evaluate_comp.scm\" 23663) \"BGl_z62zc3anonymousza31841ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1861>\" \"Eval/evaluate_comp.scm\" 23663) \"BGl_z62zc3anonymousza31861ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call0\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_compzd2call0zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1884>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1886>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31886ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1890>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1904>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1920>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1934>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31934ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call1\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_compzd2call1zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1950>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31950ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1952>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1956>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31956ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1975>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1996>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza31996ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2015>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32015ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call2\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_compzd2call2zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2036>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32036ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2038>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32038ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2042>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2068>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32068ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2096>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32096ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2122>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32122ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call3\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_compzd2call3zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2150>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32150ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2152>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32152ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2156>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32156ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2191>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32191ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2228>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32228ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2263>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32263ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call4\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_compzd2call4zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2300>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32300ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2302>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32302ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2306>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32306ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2352>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32352ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2400>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32400ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2446>\" \"Eval/evaluate_comp.scm\" 28343) \"BGl_z62zc3anonymousza32446ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"is-constant-fun?\" \"Eval/evaluate_comp.scm\" 28401) \"BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile-float-arith\" \"Eval/evaluate_comp.scm\" 29045) \"BGl_compilezd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"eval-float-arith\" \"Eval/evaluate_comp.scm\" 30433) \"BGl_evalzd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"E~0\" \"Eval/evaluate_comp.scm\" 31265) \"BGl_Eze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"arith-expression\" \"Eval/evaluate_comp.scm\" 31282) \"BGl_arithzd2expressionzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2615>\" \"Eval/evaluate_comp.scm\" 31546) \"BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"inline-call\" \"Eval/evaluate_comp.scm\" 32473) \"BGl_inlinezd2callzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2619>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2623>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2627>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2631>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2635>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2639>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2643>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32643ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2647>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2651>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32651ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2655>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32655ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2659>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32659ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2663>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32663ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2667>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2671>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32671ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2675>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32675ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2679>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32679ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2683>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32683ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2687>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32687ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2691>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32691ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2695>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32695ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2699>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32699ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2703>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32703ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2707>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32707ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2711>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2715>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32715ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2719>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32719ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2723>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32723ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2727>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2729>\" \"Eval/evaluate_comp.scm\" 32816) \"BGl_z62zc3anonymousza32729ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2732>\" \"Eval/evaluate_comp.scm\" 32662) \"BGl_z62zc3anonymousza32732ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2735>\" \"Eval/evaluate_comp.scm\" 32662) \"BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2738>\" \"Eval/evaluate_comp.scm\" 32662) \"BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadr?\" \"Eval/evaluate_comp.scm\" 33050) \"BGl_cadrzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadrerrv\" \"Eval/evaluate_comp.scm\" 33106) \"BGl_cadrerrvz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"correct\" \"Eval/evaluate_comp.scm\" 34120) \"BGl_correctz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"bind-frame\" \"Eval/evaluate_comp.scm\" 34206) \"BGl_bindzd2framezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-boxes\" \"Eval/evaluate_comp.scm\" 38533) \"BGl_makezd2boxeszd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-collect\" \"Eval/evaluate_comp.scm\" 38789) \"BGl_freezd2collectzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-restore\" \"Eval/evaluate_comp.scm\" 39059) \"BGl_freezd2restorezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp1385\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62comp1385z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_compz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62compz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_abs1430\" \"Eval/evaluate_comp.scm\" 38059) \"BGl_z62compzd2ev_abs1430zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3526>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33526ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62mainz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62runz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3537>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5096\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5096z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5097\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5097z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3551>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33551ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5098\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5098z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5099\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5099z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3563>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33563ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5100\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5100z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5101\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5101z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3475>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33475ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5102\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5102z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5103\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5103z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3485>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33485ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5104\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5104z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5105\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5105z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3498>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33498ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5106\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5106z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5107\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5107z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3509>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5108\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5108z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5109\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5109z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3424>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5110\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5110z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5111\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5111z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3434>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5112\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5112z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5113\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5113z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3447>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33447ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5114\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5114z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5115\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5115z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3458>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33458ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5116\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5116z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5117\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5117z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3377>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33377ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5118\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5118z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5119\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5119z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3386>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33386ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5120\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5120z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5121\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5121z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3398>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33398ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5122\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5122z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5123\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5123z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3408>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33408ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5124\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5124z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5125\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5125z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3330>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33330ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5126\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5126z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5127\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5127z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3339>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33339ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5128\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5128z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5129\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5129z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3351>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5130\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5130z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5131\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5131z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3361>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33361ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5132\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5132z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5133\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5133z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3287>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33287ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5134\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5134z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5135\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5135z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3295>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33295ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5136\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5136z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5137\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5137z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3306>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5138\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5138z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5139\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5139z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3315>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33315ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5140\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5140z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5141\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5141z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3244>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33244ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5142\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5142z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5143\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5143z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3252>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33252ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5144\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5144z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5145\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5145z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3263>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33263ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5146\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5146z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5147\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5147z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3272>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33272ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5148\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5148z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5149\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5149z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3205>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33205ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5150\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5150z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5151\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5151z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3212>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33212ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5152\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5152z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5153\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5153z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3222>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33222ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5154\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5154z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5155\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5155z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3230>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33230ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5156\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5156z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5157\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5157z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3166>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33166ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5158\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5158z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5159\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5159z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3173>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33173ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5160\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5160z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5161\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5161z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3183>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33183ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5162\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5162z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5163\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5163z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3191>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33191ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5164\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5164z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5165\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5165z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3131>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5166\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5166z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5167\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5167z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3137>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33137ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5168\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5168z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5169\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5169z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3146>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33146ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5170\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5170z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5171\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5171z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3153>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33153ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5172\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5172z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5173\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5173z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3581>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33581ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5174\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5174z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5175\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5175z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3601>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5176\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5176z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5177\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5177z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3624>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33624ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5178\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5178z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5179\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5179z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3645>\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62zc3anonymousza33645ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5180\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62main5180z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5181\" \"Eval/evaluate_comp.scm\" 38490) \"BGl_z62run5181z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_app1428\" \"Eval/evaluate_comp.scm\" 33674) \"BGl_z62compzd2ev_app1428zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_goto1426\" \"Eval/evaluate_comp.scm\" 17686) \"BGl_z62compzd2ev_goto1426zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3070>\" \"Eval/evaluate_comp.scm\" 18311) \"BGl_z62zc3anonymousza33070ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3076>\" \"Eval/evaluate_comp.scm\" 18592) \"BGl_z62zc3anonymousza33076ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_labels1424\" \"Eval/evaluate_comp.scm\" 16611) \"BGl_z62compzd2ev_labels1424zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3065>\" \"Eval/evaluate_comp.scm\" 17284) \"BGl_z62zc3anonymousza33065ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_synchronize1422\" \"Eval/evaluate_comp.scm\" 15984) \"BGl_z62compzd2ev_synchroniza7e1422z17zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3044>\" \"Eval/evaluate_comp.scm\" 16194) \"BGl_z62zc3anonymousza33044ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_with-handler1420\" \"Eval/evaluate_comp.scm\" 15642) \"BGl_z62compzd2ev_withzd2handler1420z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3030>\" \"Eval/evaluate_comp.scm\" 15807) \"BGl_z62zc3anonymousza33030ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<exit:3037>~0\" \"Eval/evaluate_comp.scm\" 15914) \"BGl_zc3exitza33037ze3ze70z64zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3040>\" \"Eval/evaluate_comp.scm\" 15914) \"BGl_z62zc3anonymousza33040ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3041>\" \"Eval/evaluate_comp.scm\" 15914) \"BGl_z62zc3anonymousza33041ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_unwind-prote1418\" \"Eval/evaluate_comp.scm\" 15334) \"BGl_z62compzd2ev_unwindzd2prote1418z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3026>\" \"Eval/evaluate_comp.scm\" 15485) \"BGl_z62zc3anonymousza33026ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3027>\" \"Eval/evaluate_comp.scm\" 15554) \"BGl_z62zc3anonymousza33027ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_bind-exit1416\" \"Eval/evaluate_comp.scm\" 14879) \"BGl_z62compzd2ev_bindzd2exit1416z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:3019>\" \"Eval/evaluate_comp.scm\" 15118) \"BGl_z62zc3anonymousza33019ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<exit:3020>~0\" \"Eval/evaluate_comp.scm\" 15185) \"BGl_zc3exitza33020ze3ze70z64zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&exit\" \"Eval/evaluate_comp.scm\" 15185) \"BGl_z62exitz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_letrec1414\" \"Eval/evaluate_comp.scm\" 13826) \"BGl_z62compzd2ev_letrec1414zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2980>\" \"Eval/evaluate_comp.scm\" 14108) \"BGl_z62zc3anonymousza32980ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2993>\" \"Eval/evaluate_comp.scm\" 14464) \"BGl_z62zc3anonymousza32993ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let*1412\" \"Eval/evaluate_comp.scm\" 13331) \"BGl_z62compzd2ev_letza21412z12zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2959>\" \"Eval/evaluate_comp.scm\" 13566) \"BGl_z62zc3anonymousza32959ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let1410\" \"Eval/evaluate_comp.scm\" 12651) \"BGl_z62compzd2ev_let1410zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2938>\" \"Eval/evaluate_comp.scm\" 12978) \"BGl_z62zc3anonymousza32938ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_prog21408\" \"Eval/evaluate_comp.scm\" 12457) \"BGl_z62compzd2ev_prog21408zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2935>\" \"Eval/evaluate_comp.scm\" 12587) \"BGl_z62zc3anonymousza32935ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_and1406\" \"Eval/evaluate_comp.scm\" 12171) \"BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2925>\" \"Eval/evaluate_comp.scm\" 12302) \"BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_or1404\" \"Eval/evaluate_comp.scm\" 11913) \"BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2915>\" \"Eval/evaluate_comp.scm\" 12042) \"BGl_z62zc3anonymousza32915ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_if1402\" \"Eval/evaluate_comp.scm\" 11709) \"BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2910>\" \"Eval/evaluate_comp.scm\" 11846) \"BGl_z62zc3anonymousza32910ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_litt1400\" \"Eval/evaluate_comp.scm\" 11590) \"BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2909>\" \"Eval/evaluate_comp.scm\" 11669) \"BGl_z62zc3anonymousza32909ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_defglobal1398\" \"Eval/evaluate_comp.scm\" 10633) \"BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2883>\" \"Eval/evaluate_comp.scm\" 10759) \"BGl_z62zc3anonymousza32883ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setglobal1396\" \"Eval/evaluate_comp.scm\" 9772) \"BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2858>\" \"Eval/evaluate_comp.scm\" 9982) \"BGl_z62zc3anonymousza32858ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2863>\" \"Eval/evaluate_comp.scm\" 10155) \"BGl_z62zc3anonymousza32863ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2874>\" \"Eval/evaluate_comp.scm\" 10415) \"BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_global1394\" \"Eval/evaluate_comp.scm\" 8830) \"BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2832>\" \"Eval/evaluate_comp.scm\" 9018) \"BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2834>\" \"Eval/evaluate_comp.scm\" 9111) \"BGl_z62zc3anonymousza32834ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2845>\" \"Eval/evaluate_comp.scm\" 9364) \"BGl_z62zc3anonymousza32845ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setlocal1392\" \"Eval/evaluate_comp.scm\" 8242) \"BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2821>\" \"Eval/evaluate_comp.scm\" 8418) \"BGl_z62zc3anonymousza32821ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2825>\" \"Eval/evaluate_comp.scm\" 8525) \"BGl_z62zc3anonymousza32825ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_var1390\" \"Eval/evaluate_comp.scm\" 8097) \"BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2809>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32809ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2812>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2803>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32803ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2806>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32806ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2797>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32797ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2800>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2791>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32791ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2794>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32794ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2815>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32815ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2818>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3anonymousza32818ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_trap1388\" \"Eval/evaluate_comp.scm\" 7340) \"BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2782>\" \"Eval/evaluate_comp.scm\" 7442) \"BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long BgL_checksumz00_15063, char * BgL_fromz00_15064)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_compz00(); 
BGl_cnstzd2initzd2zz__evaluate_compz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_compz00(); 
BGl_genericzd2initzd2zz__evaluate_compz00(); 
BGl_methodzd2initzd2zz__evaluate_compz00(); 
BGl_toplevelzd2initzd2zz__evaluate_compz00(); 
return 
BGl_profzd2initzd2zz__evaluate_compz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
BGl_symbol5186z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5187z00zz__evaluate_compz00); 
BGl_symbol5188z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5189z00zz__evaluate_compz00); 
BGl_symbol5190z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5191z00zz__evaluate_compz00); 
BGl_symbol5196z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5197z00zz__evaluate_compz00); 
BGl_symbol5204z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5205z00zz__evaluate_compz00); 
BGl_symbol5206z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5207z00zz__evaluate_compz00); 
BGl_symbol5208z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5209z00zz__evaluate_compz00); 
BGl_symbol5211z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5212z00zz__evaluate_compz00); 
BGl_symbol5214z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5215z00zz__evaluate_compz00); 
BGl_symbol5216z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5217z00zz__evaluate_compz00); 
BGl_symbol5218z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5219z00zz__evaluate_compz00); 
BGl_symbol5220z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5221z00zz__evaluate_compz00); 
BGl_symbol5222z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5223z00zz__evaluate_compz00); 
BGl_symbol5224z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5225z00zz__evaluate_compz00); 
BGl_symbol5226z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5227z00zz__evaluate_compz00); 
BGl_symbol5228z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5229z00zz__evaluate_compz00); 
BGl_symbol5230z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5231z00zz__evaluate_compz00); 
BGl_symbol5232z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5233z00zz__evaluate_compz00); 
BGl_symbol5234z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5235z00zz__evaluate_compz00); 
BGl_symbol5236z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5237z00zz__evaluate_compz00); 
BGl_symbol5238z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5239z00zz__evaluate_compz00); 
BGl_symbol5240z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5241z00zz__evaluate_compz00); 
BGl_symbol5242z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5243z00zz__evaluate_compz00); 
BGl_symbol5244z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5245z00zz__evaluate_compz00); 
BGl_symbol5246z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5247z00zz__evaluate_compz00); 
BGl_symbol5248z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5249z00zz__evaluate_compz00); 
BGl_symbol5250z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5251z00zz__evaluate_compz00); 
BGl_symbol5252z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5253z00zz__evaluate_compz00); 
BGl_symbol5254z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5255z00zz__evaluate_compz00); 
BGl_symbol5256z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5257z00zz__evaluate_compz00); 
BGl_symbol5258z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5259z00zz__evaluate_compz00); 
BGl_symbol5260z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5261z00zz__evaluate_compz00); 
BGl_symbol5262z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5263z00zz__evaluate_compz00); 
BGl_symbol5264z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5265z00zz__evaluate_compz00); 
BGl_symbol5266z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5267z00zz__evaluate_compz00); 
BGl_symbol5268z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5269z00zz__evaluate_compz00); 
BGl_symbol5270z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5271z00zz__evaluate_compz00); 
BGl_symbol5272z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5273z00zz__evaluate_compz00); 
BGl_symbol5274z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5275z00zz__evaluate_compz00); 
BGl_symbol5276z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5277z00zz__evaluate_compz00); 
BGl_symbol5278z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5279z00zz__evaluate_compz00); 
BGl_symbol5280z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5281z00zz__evaluate_compz00); 
BGl_symbol5311z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5312z00zz__evaluate_compz00); 
BGl_symbol5328z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5329z00zz__evaluate_compz00); 
BGl_symbol5330z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5331z00zz__evaluate_compz00); 
BGl_symbol5332z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5333z00zz__evaluate_compz00); 
return ( 
BGl_symbol5334z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5335z00zz__evaluate_compz00), BUNSPEC) ;} 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
return 
write_bprof_table();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_arg1474z00_1349;
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_res3965z00_6389;
BgL_res3965z00_6389 = 
LONG_TO_LLONG(((long)0)); 
BgL_arg1474z00_1349 = BgL_res3965z00_6389; } 
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_list1475z00_1350;
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_arg1477z00_1351;
BgL_arg1477z00_1351 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1474z00_1349), BNIL); 
BgL_list1475z00_1350 = 
MAKE_YOUNG_PAIR(BGl_symbol5186z00zz__evaluate_compz00, BgL_arg1477z00_1351); } 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1475z00_1350; } } 
BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long)8192); 
BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol5188z00zz__evaluate_compz00, 
(int)(((long)0))); 
BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol5190z00zz__evaluate_compz00, 
(int)(((long)0))); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__evaluate_compz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{ BGL_FUNCTION_BEGIN;
{ 
{ 
obj_t BgL_headz00_1352;
BgL_headz00_1352 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_1353;obj_t BgL_tailz00_1354;
BgL_prevz00_1353 = BgL_headz00_1352; 
BgL_tailz00_1354 = BgL_l1z00_1; 
BgL_loopz00_1355:
if(
PAIRP(BgL_tailz00_1354))
{ 
obj_t BgL_newzd2prevzd2_1357;
BgL_newzd2prevzd2_1357 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_1354), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_1353, BgL_newzd2prevzd2_1357); 
{ 
obj_t BgL_tailz00_15139;obj_t BgL_prevz00_15138;
BgL_prevz00_15138 = BgL_newzd2prevzd2_1357; 
BgL_tailz00_15139 = 
CDR(BgL_tailz00_1354); 
BgL_tailz00_1354 = BgL_tailz00_15139; 
BgL_prevz00_1353 = BgL_prevz00_15138; 
goto BgL_loopz00_1355;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_1352);} } } 
BGL_FUNCTION_END;
}



/* reset_profile */
obj_t BGl_reset_profilez00zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 132 */
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_arg1498z00_1380;
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_res3972z00_6402;
BgL_res3972z00_6402 = 
LONG_TO_LLONG(((long)0)); 
BgL_arg1498z00_1380 = BgL_res3972z00_6402; } 
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_list1499z00_1381;
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_arg1500z00_1382;
BgL_arg1500z00_1382 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1498z00_1380), BNIL); 
BgL_list1499z00_1381 = 
MAKE_YOUNG_PAIR(BGl_symbol5186z00zz__evaluate_compz00, BgL_arg1500z00_1382); } 
return ( 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1499z00_1381, BUNSPEC) ;} } } 
BGL_FUNCTION_END;
}



/* o->s~0 */
obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1391)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 141 */
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1391))
{ /* Ieee/fixnum.scm 979 */

return 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)CINT(BgL_vz00_1391), ((long)10));}  else 
{ /* Eval/evaluate_comp.scm 138 */
if(
SYMBOLP(BgL_vz00_1391))
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_res3975z00_6407;
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_arg3815z00_6406;
BgL_arg3815z00_6406 = 
SYMBOL_TO_STRING(BgL_vz00_1391); 
BgL_res3975z00_6407 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg3815z00_6406); } 
return BgL_res3975z00_6407;}  else 
{ /* Eval/evaluate_comp.scm 139 */
if(
STRINGP(BgL_vz00_1391))
{ /* Eval/evaluate_comp.scm 140 */
return BgL_vz00_1391;}  else 
{ /* Eval/evaluate_comp.scm 140 */
return BGl_string5192z00zz__evaluate_compz00;} } } } 
BGL_FUNCTION_END;
}



/* &<lexint */
obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_10640, obj_t BgL_t1z00_10641, obj_t BgL_t2z00_10642)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 135 */
{ /* Eval/evaluate_comp.scm 138 */
bool_t BgL_tmpz00_15156;
{ /* Eval/evaluate_comp.scm 142 */
obj_t BgL_v1z00_12632;obj_t BgL_v2z00_12633;
BgL_v1z00_12632 = 
CAR(
((obj_t)BgL_t1z00_10641)); 
BgL_v2z00_12633 = 
CAR(
((obj_t)BgL_t2z00_10642)); 
{ /* Eval/evaluate_comp.scm 143 */
bool_t BgL_testz00_15161;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_12632))
{ /* Eval/evaluate_comp.scm 143 */
BgL_testz00_15161 = 
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v2z00_12633)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_testz00_15161 = ((bool_t)0)
; } 
if(BgL_testz00_15161)
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_15156 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_12632, BgL_v2z00_12633)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_15156 = 
bigloo_string_lt(
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v1z00_12632), 
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_12633))
; } } } 
return 
BBOOL(BgL_tmpz00_15156);} } 
BGL_FUNCTION_END;
}



/* get_profile */
obj_t BGl_get_profilez00zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 147 */
BGl_recze71ze7zz__evaluate_compz00(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00); 
return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;} 
BGL_FUNCTION_END;
}



/* rec~1 */
bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1400)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 148 */
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1511z00_1402;obj_t BgL_arg1512z00_1403;
BgL_arg1511z00_1402 = 
CDR(
((obj_t)BgL_tz00_1400)); 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1513z00_1404;
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_pairz00_6418;
BgL_pairz00_6418 = 
CDR(
((obj_t)BgL_tz00_1400)); 
BgL_arg1513z00_1404 = 
CDR(BgL_pairz00_6418); } 
BgL_arg1512z00_1403 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1513z00_1404); } 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_tmpz00_15177;
BgL_tmpz00_15177 = 
((obj_t)BgL_arg1511z00_1402); 
SET_CDR(BgL_tmpz00_15177, BgL_arg1512z00_1403); } } 
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_g1287z00_1405;
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_pairz00_6423;
BgL_pairz00_6423 = 
CDR(
((obj_t)BgL_tz00_1400)); 
BgL_g1287z00_1405 = 
CDR(BgL_pairz00_6423); } 
{ 
obj_t BgL_l1285z00_1407;
BgL_l1285z00_1407 = BgL_g1287z00_1405; 
BgL_zc3anonymousza31514ze3z83_1408:
if(
PAIRP(BgL_l1285z00_1407))
{ /* Eval/evaluate_comp.scm 150 */
BGl_recze71ze7zz__evaluate_compz00(
CAR(BgL_l1285z00_1407)); 
{ 
obj_t BgL_l1285z00_15187;
BgL_l1285z00_15187 = 
CDR(BgL_l1285z00_1407); 
BgL_l1285z00_1407 = BgL_l1285z00_15187; 
goto BgL_zc3anonymousza31514ze3z83_1408;} }  else 
{ /* Eval/evaluate_comp.scm 150 */
return ((bool_t)1);} } } } 
BGL_FUNCTION_END;
}



/* index */
obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 156 */
{ 
obj_t BgL_lz00_1415;long BgL_nz00_1416;
BgL_lz00_1415 = BgL_lz00_7; 
BgL_nz00_1416 = ((long)0); 
BgL_zc3anonymousza31518ze3z83_1417:
if(
NULLP(BgL_lz00_1415))
{ /* Eval/evaluate_comp.scm 158 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 158 */
if(
(BgL_xz00_6==
CAR(
((obj_t)BgL_lz00_1415))))
{ /* Eval/evaluate_comp.scm 159 */
return 
BINT(BgL_nz00_1416);}  else 
{ 
long BgL_nz00_15199;obj_t BgL_lz00_15196;
BgL_lz00_15196 = 
CDR(
((obj_t)BgL_lz00_1415)); 
BgL_nz00_15199 = 
(BgL_nz00_1416+((long)1)); 
BgL_nz00_1416 = BgL_nz00_15199; 
BgL_lz00_1415 = BgL_lz00_15196; 
goto BgL_zc3anonymousza31518ze3z83_1417;} } } } 
BGL_FUNCTION_END;
}



/* _index */
obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 163 */
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL__ortest_1076z00_1425;
BgL__ortest_1076z00_1425 = 
BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9); 
if(
CBOOL(BgL__ortest_1076z00_1425))
{ /* Eval/evaluate_comp.scm 164 */
return BgL__ortest_1076z00_1425;}  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1525z00_1426;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1528z00_1427;
if(
NULLP(BgL_lz00_9))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1528z00_1427 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_head1290z00_1433;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1541z00_1445;
BgL_arg1541z00_1445 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_lz00_9))); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_res3982z00_6434;
BgL_res3982z00_6434 = 
MAKE_YOUNG_PAIR(BgL_arg1541z00_1445, BNIL); 
BgL_head1290z00_1433 = BgL_res3982z00_6434; } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_g1293z00_1434;
BgL_g1293z00_1434 = 
CDR(
((obj_t)BgL_lz00_9)); 
{ 
obj_t BgL_l1288z00_1436;obj_t BgL_tail1291z00_1437;
BgL_l1288z00_1436 = BgL_g1293z00_1434; 
BgL_tail1291z00_1437 = BgL_head1290z00_1433; 
BgL_zc3anonymousza31533ze3z83_1438:
if(
NULLP(BgL_l1288z00_1436))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1528z00_1427 = BgL_head1290z00_1433; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_newtail1292z00_1440;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1538z00_1442;
BgL_arg1538z00_1442 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_l1288z00_1436))); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_res3984z00_6438;
BgL_res3984z00_6438 = 
MAKE_YOUNG_PAIR(BgL_arg1538z00_1442, BNIL); 
BgL_newtail1292z00_1440 = BgL_res3984z00_6438; } } 
SET_CDR(BgL_tail1291z00_1437, BgL_newtail1292z00_1440); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1537z00_1441;
BgL_arg1537z00_1441 = 
CDR(
((obj_t)BgL_l1288z00_1436)); 
{ 
obj_t BgL_tail1291z00_15222;obj_t BgL_l1288z00_15221;
BgL_l1288z00_15221 = BgL_arg1537z00_1441; 
BgL_tail1291z00_15222 = BgL_newtail1292z00_1440; 
BgL_tail1291z00_1437 = BgL_tail1291z00_15222; 
BgL_l1288z00_1436 = BgL_l1288z00_15221; 
goto BgL_zc3anonymousza31533ze3z83_1438;} } } } } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_list1529z00_1428;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1530z00_1429;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1531z00_1430;
BgL_arg1531z00_1430 = 
MAKE_YOUNG_PAIR(BgL_arg1528z00_1427, BNIL); 
BgL_arg1530z00_1429 = 
MAKE_YOUNG_PAIR(BGl_string5193z00zz__evaluate_compz00, BgL_arg1531z00_1430); } 
BgL_list1529z00_1428 = 
MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1530z00_1429); } 
BgL_arg1525z00_1426 = BgL_list1529z00_1428; } } 
return 
BGl_errorz00zz__errorz00(BGl_string5194z00zz__evaluate_compz00, BGl_string5195z00zz__evaluate_compz00, BgL_arg1525z00_1426);} } } 
BGL_FUNCTION_END;
}



/* lname */
obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 188 */
if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_16, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 189 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_16)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 189 */
return BgL_vz00_16;} } 
BGL_FUNCTION_END;
}



/* loc-type-error */
obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17, obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 193 */
{ 
obj_t BgL_fnamez00_1466;obj_t BgL_locz00_1467;
if(
PAIRP(BgL_locz00_20))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2194zd2_1472;
BgL_cdrzd2194zd2_1472 = 
CDR(BgL_locz00_20); 
if(
(
CAR(BgL_locz00_20)==BGl_symbol5196z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 194 */
if(
PAIRP(BgL_cdrzd2194zd2_1472))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2198zd2_1476;
BgL_cdrzd2198zd2_1476 = 
CDR(BgL_cdrzd2194zd2_1472); 
if(
PAIRP(BgL_cdrzd2198zd2_1476))
{ /* Eval/evaluate_comp.scm 194 */
if(
NULLP(
CDR(BgL_cdrzd2198zd2_1476)))
{ /* Eval/evaluate_comp.scm 194 */
BgL_fnamez00_1466 = 
CAR(BgL_cdrzd2194zd2_1472); 
BgL_locz00_1467 = 
CAR(BgL_cdrzd2198zd2_1476); 
return 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19, BgL_fnamez00_1466, BgL_locz00_1467);}  else 
{ /* Eval/evaluate_comp.scm 194 */
BgL_tagzd2187zd2_1469:
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1469;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1469;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1469;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1469;} } } 
BGL_FUNCTION_END;
}



/* make-state */
obj_t BGl_makezd2statezd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 206 */
{ /* Eval/evaluate_comp.scm 207 */
obj_t BgL_stkz00_1492;
BgL_stkz00_1492 = 
make_vector(((long)8192), BGl_string5198z00zz__evaluate_compz00); 
VECTOR_SET(BgL_stkz00_1492,((long)0),
BINT(((long)2))); 
return BgL_stkz00_1492;} } 
BGL_FUNCTION_END;
}



/* find-state */
BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 211 */
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_sz00_1493;
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_tmpz00_15252;
BgL_tmpz00_15252 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_sz00_1493 = 
BGL_ENV_EVSTATE(BgL_tmpz00_15252); } 
if(
VECTORP(BgL_sz00_1493))
{ /* Eval/evaluate_comp.scm 213 */
return BgL_sz00_1493;}  else 
{ /* Eval/evaluate_comp.scm 214 */
obj_t BgL_statez00_1495;
BgL_statez00_1495 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 215 */
obj_t BgL_tmpz00_15258;
BgL_tmpz00_15258 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_tmpz00_15258, BgL_statez00_1495); } 
return BgL_statez00_1495;} } } 
BGL_FUNCTION_END;
}



/* &find-state */
obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_10643)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 211 */
return 
BGl_findzd2statezd2zz__evaluate_compz00();} 
BGL_FUNCTION_END;
}



/* compile */
BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_34)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 273 */
return 
BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);} 
BGL_FUNCTION_END;
}



/* &compile */
obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_10644, obj_t BgL_ez00_10645)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 273 */
{ /* Eval/evaluate_comp.scm 274 */
BgL_ev_exprz00_bglt BgL_auxz00_15263;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_10645, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 274 */
BgL_auxz00_15263 = 
((BgL_ev_exprz00_bglt)BgL_ez00_10645)
; }  else 
{ 
obj_t BgL_auxz00_15267;
BgL_auxz00_15267 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string5199z00zz__evaluate_compz00, 
BINT(((long)7006)), BGl_string5200z00zz__evaluate_compz00, BGl_string5201z00zz__evaluate_compz00, BgL_ez00_10645); 
FAILURE(BgL_auxz00_15267,BFALSE,BFALSE);} 
return 
BGl_compilez00zz__evaluate_compz00(BgL_auxz00_15263);} } 
BGL_FUNCTION_END;
}



/* global-fun-value */
obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_43)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 332 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_gz00_1551;
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_arg1617z00_1552;obj_t BgL_arg1618z00_1553;
BgL_arg1617z00_1552 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_modz00); 
BgL_arg1618z00_1553 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_namez00); 
BgL_gz00_1551 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg1617z00_1552, BgL_arg1618z00_1553); } 
if(
CBOOL(BgL_gz00_1551))
{ /* Eval/evaluate_comp.scm 336 */
return 
VECTOR_REF(
((obj_t)BgL_gz00_1551),((long)2));}  else 
{ /* Eval/evaluate_comp.scm 336 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 333 */
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* catch-goto-trampoline */
obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t BgL_fz00_78, obj_t BgL_sz00_79)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 586 */
{ 
obj_t BgL_fz00_1563;
BgL_fz00_1563 = BgL_fz00_78; 
BgL_zc3anonymousza31627ze3z83_1564:
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_rz00_1565;
BgL_rz00_1565 = 
PROCEDURE_ENTRY(BgL_fz00_1563)(BgL_fz00_1563, BgL_sz00_79, BEOA); 
{ /* Eval/evaluate_comp.scm 592 */
bool_t BgL_testz00_15288;
if(
PROCEDUREP(BgL_rz00_1565))
{ /* Eval/evaluate_comp.scm 592 */
obj_t BgL_arg1639z00_1570;
BgL_arg1639z00_1570 = 
PROCEDURE_ATTR(BgL_rz00_1565); 
if(
STRUCTP(BgL_arg1639z00_1570))
{ /* Eval/evaluate_comp.scm 562 */
BgL_testz00_15288 = 
(
STRUCT_KEY(BgL_arg1639z00_1570)==BGl_symbol5188z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 562 */
BgL_testz00_15288 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 592 */
BgL_testz00_15288 = ((bool_t)0)
; } 
if(BgL_testz00_15288)
{ 
obj_t BgL_fz00_15296;
BgL_fz00_15296 = BgL_rz00_1565; 
BgL_fz00_1563 = BgL_fz00_15296; 
goto BgL_zc3anonymousza31627ze3z83_1564;}  else 
{ /* Eval/evaluate_comp.scm 592 */
return BgL_rz00_1565;} } } } } 
BGL_FUNCTION_END;
}



/* push-boxes-args-on-sp */
obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85, obj_t BgL_locz00_86)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 616 */
{ 
obj_t BgL_lz00_1573;obj_t BgL_bsz00_1574;long BgL_spz00_1575;
BgL_lz00_1573 = BgL_argsz00_83; 
BgL_bsz00_1574 = BgL_boxesz00_84; 
BgL_spz00_1575 = BgL_spz00_85; 
BgL_zc3anonymousza31640ze3z83_1576:
if(
NULLP(BgL_lz00_1573))
{ /* Eval/evaluate_comp.scm 618 */
if(
NULLP(BgL_bsz00_1574))
{ /* Eval/evaluate_comp.scm 619 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 622 */
obj_t BgL_arg1643z00_1579;
{ /* Eval/evaluate_comp.scm 622 */
long BgL_arg1644z00_1580;long BgL_arg1646z00_1581;
BgL_arg1644z00_1580 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1646z00_1581 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 621 */
obj_t BgL_list1647z00_1582;
{ /* Eval/evaluate_comp.scm 621 */
obj_t BgL_arg1648z00_1583;
BgL_arg1648z00_1583 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1646z00_1581), BNIL); 
BgL_list1647z00_1582 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1644z00_1580), BgL_arg1648z00_1583); } 
BgL_arg1643z00_1579 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string5202z00zz__evaluate_compz00, BgL_list1647z00_1582); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string5194z00zz__evaluate_compz00, BGl_string5203z00zz__evaluate_compz00, BgL_arg1643z00_1579);} }  else 
{ /* Eval/evaluate_comp.scm 618 */
if(
NULLP(BgL_bsz00_1574))
{ /* Eval/evaluate_comp.scm 626 */
obj_t BgL_arg1650z00_1585;
{ /* Eval/evaluate_comp.scm 626 */
long BgL_arg1651z00_1586;long BgL_arg1652z00_1587;
BgL_arg1651z00_1586 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1652z00_1587 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 625 */
obj_t BgL_list1653z00_1588;
{ /* Eval/evaluate_comp.scm 625 */
obj_t BgL_arg1654z00_1589;
BgL_arg1654z00_1589 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1652z00_1587), BNIL); 
BgL_list1653z00_1588 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1651z00_1586), BgL_arg1654z00_1589); } 
BgL_arg1650z00_1585 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string5202z00zz__evaluate_compz00, BgL_list1653z00_1588); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string5194z00zz__evaluate_compz00, BGl_string5203z00zz__evaluate_compz00, BgL_arg1650z00_1585);}  else 
{ /* Eval/evaluate_comp.scm 623 */
{ /* Eval/evaluate_comp.scm 629 */
obj_t BgL_arg1657z00_1590;
{ /* Eval/evaluate_comp.scm 629 */
obj_t BgL_vz00_1591;
{ /* Eval/evaluate_comp.scm 629 */
obj_t BgL_fun1659z00_1593;
BgL_fun1659z00_1593 = 
CAR(
((obj_t)BgL_lz00_1573)); 
BgL_vz00_1591 = 
PROCEDURE_ENTRY(BgL_fun1659z00_1593)(BgL_fun1659z00_1593, BgL_sz00_82, BEOA); } 
if(
CBOOL(
CAR(
((obj_t)BgL_bsz00_1574))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_6480;
BgL_newz00_6480 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_15331;
BgL_tmpz00_15331 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_6480, BgL_tmpz00_15331, BgL_vz00_1591); } 
BgL_arg1657z00_1590 = BgL_newz00_6480; }  else 
{ /* Eval/evaluate_comp.scm 630 */
BgL_arg1657z00_1590 = BgL_vz00_1591; } } 
VECTOR_SET(
((obj_t)BgL_sz00_82),BgL_spz00_1575,BgL_arg1657z00_1590); } 
{ /* Eval/evaluate_comp.scm 633 */
obj_t BgL_arg1660z00_1594;obj_t BgL_arg1661z00_1595;long BgL_arg1662z00_1596;
BgL_arg1660z00_1594 = 
CDR(
((obj_t)BgL_lz00_1573)); 
BgL_arg1661z00_1595 = 
CDR(
((obj_t)BgL_bsz00_1574)); 
BgL_arg1662z00_1596 = 
(BgL_spz00_1575+((long)1)); 
{ 
long BgL_spz00_15343;obj_t BgL_bsz00_15342;obj_t BgL_lz00_15341;
BgL_lz00_15341 = BgL_arg1660z00_1594; 
BgL_bsz00_15342 = BgL_arg1661z00_1595; 
BgL_spz00_15343 = BgL_arg1662z00_1596; 
BgL_spz00_1575 = BgL_spz00_15343; 
BgL_bsz00_1574 = BgL_bsz00_15342; 
BgL_lz00_1573 = BgL_lz00_15341; 
goto BgL_zc3anonymousza31640ze3z83_1576;} } } } } } 
BGL_FUNCTION_END;
}



/* sub-stk */
obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88, obj_t BgL_l2z00_89)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 638 */
BGl_subzd2stkzd2zz__evaluate_compz00:
if(
NULLP(BgL_l1z00_88))
{ /* Eval/evaluate_comp.scm 639 */
return BgL_l2z00_89;}  else 
{ /* Eval/evaluate_comp.scm 639 */
if(
(
CAR(
((obj_t)BgL_l1z00_88))==
CAR(
((obj_t)BgL_l2z00_89))))
{ /* Eval/evaluate_comp.scm 642 */
obj_t BgL_arg1667z00_1602;obj_t BgL_arg1668z00_1603;
BgL_arg1667z00_1602 = 
CDR(
((obj_t)BgL_l1z00_88)); 
BgL_arg1668z00_1603 = 
CDR(
((obj_t)BgL_l2z00_89)); 
{ 
obj_t BgL_l2z00_15357;obj_t BgL_l1z00_15356;
BgL_l1z00_15356 = BgL_arg1667z00_1602; 
BgL_l2z00_15357 = BgL_arg1668z00_1603; 
BgL_l2z00_89 = BgL_l2z00_15357; 
BgL_l1z00_88 = BgL_l1z00_15356; 
goto BGl_subzd2stkzd2zz__evaluate_compz00;} }  else 
{ /* Eval/evaluate_comp.scm 640 */
return 
BGl_errorz00zz__errorz00(BGl_string5194z00zz__evaluate_compz00, BGl_symbol5206z00zz__evaluate_compz00, BGl_symbol5208z00zz__evaluate_compz00);} } } 
BGL_FUNCTION_END;
}



/* catch-trampoline */
obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93, obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 662 */
{ /* Eval/evaluate_comp.scm 663 */
obj_t BgL_savedzd2bpzd2_1614;
BgL_savedzd2bpzd2_1614 = 
VECTOR_REF(
((obj_t)BgL_sz00_94),((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_bpz00_95); 
{ 
obj_t BgL_fz00_1616;
BgL_fz00_1616 = BgL_fz00_93; 
BgL_zc3anonymousza31678ze3z83_1617:
{ /* Eval/evaluate_comp.scm 666 */
obj_t BgL_rz00_1618;
BgL_rz00_1618 = 
PROCEDURE_ENTRY(BgL_fz00_1616)(BgL_fz00_1616, BgL_sz00_94, BEOA); 
{ /* Eval/evaluate_comp.scm 667 */
bool_t BgL_testz00_15367;
if(
PROCEDUREP(BgL_rz00_1618))
{ /* Eval/evaluate_comp.scm 667 */
obj_t BgL_arg1682z00_1623;
BgL_arg1682z00_1623 = 
PROCEDURE_ATTR(BgL_rz00_1618); 
if(
STRUCTP(BgL_arg1682z00_1623))
{ /* Eval/evaluate_comp.scm 647 */
BgL_testz00_15367 = 
(
STRUCT_KEY(BgL_arg1682z00_1623)==BGl_symbol5190z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 647 */
BgL_testz00_15367 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 667 */
BgL_testz00_15367 = ((bool_t)0)
; } 
if(BgL_testz00_15367)
{ 
obj_t BgL_fz00_15375;
BgL_fz00_15375 = BgL_rz00_1618; 
BgL_fz00_1616 = BgL_fz00_15375; 
goto BgL_zc3anonymousza31678ze3z83_1617;}  else 
{ /* Eval/evaluate_comp.scm 667 */
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_savedzd2bpzd2_1614); 
return BgL_rz00_1618;} } } } } } 
BGL_FUNCTION_END;
}



/* check-stack */
bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t BgL_sz00_114, obj_t BgL_bpz00_115, obj_t BgL_nz00_116)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 678 */
return 
(
(
(long)CINT(BgL_bpz00_115)+
(long)CINT(BgL_nz00_116))<
VECTOR_LENGTH(
((obj_t)BgL_sz00_114)));} 
BGL_FUNCTION_END;
}



/* comp-with-push */
obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117, obj_t BgL_stkz00_118)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 681 */
if(
NULLP(BgL_eza2za2_117))
{ /* Eval/evaluate_comp.scm 683 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 685 */
obj_t BgL_arg1693z00_1636;obj_t BgL_arg1694z00_1637;
{ /* Eval/evaluate_comp.scm 685 */
obj_t BgL_arg1696z00_1638;
BgL_arg1696z00_1638 = 
CAR(
((obj_t)BgL_eza2za2_117)); 
BgL_arg1693z00_1636 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1696z00_1638), BgL_stkz00_118); } 
{ /* Eval/evaluate_comp.scm 686 */
obj_t BgL_arg1697z00_1639;obj_t BgL_arg1698z00_1640;
BgL_arg1697z00_1639 = 
CDR(
((obj_t)BgL_eza2za2_117)); 
{ /* Eval/evaluate_comp.scm 686 */
obj_t BgL_arg1699z00_1641;
BgL_arg1699z00_1641 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
BgL_arg1698z00_1640 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_118, BgL_arg1699z00_1641); } 
BgL_arg1694z00_1637 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1697z00_1639, BgL_arg1698z00_1640); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1693z00_1636, BgL_arg1694z00_1637);} } 
BGL_FUNCTION_END;
}



/* rec~0 */
obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_12617, obj_t BgL_lz00_1643, long BgL_iz00_1644)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 689 */
if(
NULLP(BgL_lz00_1643))
{ /* Eval/evaluate_comp.scm 690 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 690 */
if(
(BgL_iz00_1644==((long)0)))
{ /* Eval/evaluate_comp.scm 691 */
return 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1643, BgL_stkz00_12617);}  else 
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1703z00_1648;obj_t BgL_arg1704z00_1649;
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1705z00_1650;
BgL_arg1705z00_1650 = 
CAR(
((obj_t)BgL_lz00_1643)); 
BgL_arg1703z00_1648 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1705z00_1650), BgL_stkz00_12617); } 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1706z00_1651;long BgL_arg1707z00_1652;
BgL_arg1706z00_1651 = 
CDR(
((obj_t)BgL_lz00_1643)); 
BgL_arg1707z00_1652 = 
(BgL_iz00_1644-((long)1)); 
BgL_arg1704z00_1649 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_12617, BgL_arg1706z00_1651, BgL_arg1707z00_1652); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1703z00_1648, BgL_arg1704z00_1649);} } } 
BGL_FUNCTION_END;
}



/* subr-call-with-push */
obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122, obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125, obj_t BgL_siza7eza7_126)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 695 */
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_argsz00_1654;
if(
NULLP(BgL_argsz00_124))
{ /* Eval/evaluate_comp.scm 697 */
BgL_argsz00_1654 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_head1339z00_1659;
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_res4017z00_6545;
BgL_res4017z00_6545 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1339z00_1659 = BgL_res4017z00_6545; } 
{ 
obj_t BgL_l1337z00_1661;obj_t BgL_tail1340z00_1662;
BgL_l1337z00_1661 = BgL_argsz00_124; 
BgL_tail1340z00_1662 = BgL_head1339z00_1659; 
BgL_zc3anonymousza31710ze3z83_1663:
if(
NULLP(BgL_l1337z00_1661))
{ /* Eval/evaluate_comp.scm 697 */
BgL_argsz00_1654 = 
CDR(BgL_head1339z00_1659); }  else 
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_newtail1341z00_1665;
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_arg1713z00_1667;
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_az00_1668;
BgL_az00_1668 = 
CAR(
((obj_t)BgL_l1337z00_1661)); 
BgL_arg1713z00_1667 = 
PROCEDURE_ENTRY(BgL_az00_1668)(BgL_az00_1668, BgL_sz00_122, BEOA); } 
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_res4019z00_6549;
BgL_res4019z00_6549 = 
MAKE_YOUNG_PAIR(BgL_arg1713z00_1667, BNIL); 
BgL_newtail1341z00_1665 = BgL_res4019z00_6549; } } 
SET_CDR(BgL_tail1340z00_1662, BgL_newtail1341z00_1665); 
{ /* Eval/evaluate_comp.scm 697 */
obj_t BgL_arg1712z00_1666;
BgL_arg1712z00_1666 = 
CDR(
((obj_t)BgL_l1337z00_1661)); 
{ 
obj_t BgL_tail1340z00_15427;obj_t BgL_l1337z00_15426;
BgL_l1337z00_15426 = BgL_arg1712z00_1666; 
BgL_tail1340z00_15427 = BgL_newtail1341z00_1665; 
BgL_tail1340z00_1662 = BgL_tail1340z00_15427; 
BgL_l1337z00_1661 = BgL_l1337z00_15426; 
goto BgL_zc3anonymousza31710ze3z83_1663;} } } } } 
{ /* Eval/evaluate_comp.scm 698 */
long BgL_arg1708z00_1655;
BgL_arg1708z00_1655 = 
(
(long)CINT(BgL_bpz00_125)+
(long)CINT(BgL_siza7eza7_126)); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),
BINT(BgL_arg1708z00_1655)); } 
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_za2za2resza2za2z00_1656;
BgL_za2za2resza2za2z00_1656 = 
apply(BgL_fz00_123, BgL_argsz00_1654); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),BgL_bpz00_125); 
return BgL_za2za2resza2za2z00_1656;} } } 
BGL_FUNCTION_END;
}



/* push-args-on-sp */
bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_sz00_127, obj_t BgL_argsz00_128, obj_t BgL_spz00_129)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 702 */
{ 
obj_t BgL_lz00_1671;obj_t BgL_spz00_1672;
BgL_lz00_1671 = BgL_argsz00_128; 
BgL_spz00_1672 = BgL_spz00_129; 
BgL_zc3anonymousza31714ze3z83_1673:
if(
NULLP(BgL_lz00_1671))
{ /* Eval/evaluate_comp.scm 704 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 704 */
{ /* Eval/evaluate_comp.scm 705 */
obj_t BgL_arg1716z00_1675;
{ /* Eval/evaluate_comp.scm 705 */
obj_t BgL_fun1717z00_1676;
BgL_fun1717z00_1676 = 
CAR(
((obj_t)BgL_lz00_1671)); 
BgL_arg1716z00_1675 = 
PROCEDURE_ENTRY(BgL_fun1717z00_1676)(BgL_fun1717z00_1676, BgL_sz00_127, BEOA); } 
{ /* Eval/evaluate_comp.scm 705 */
long BgL_kz00_6560;
BgL_kz00_6560 = 
(long)CINT(BgL_spz00_1672); 
VECTOR_SET(
((obj_t)BgL_sz00_127),BgL_kz00_6560,BgL_arg1716z00_1675); } } 
{ /* Eval/evaluate_comp.scm 706 */
obj_t BgL_arg1718z00_1677;long BgL_arg1719z00_1678;
BgL_arg1718z00_1677 = 
CDR(
((obj_t)BgL_lz00_1671)); 
BgL_arg1719z00_1678 = 
(
(long)CINT(BgL_spz00_1672)+((long)1)); 
{ 
obj_t BgL_spz00_15454;obj_t BgL_lz00_15453;
BgL_lz00_15453 = BgL_arg1718z00_1677; 
BgL_spz00_15454 = 
BINT(BgL_arg1719z00_1678); 
BgL_spz00_1672 = BgL_spz00_15454; 
BgL_lz00_1671 = BgL_lz00_15453; 
goto BgL_zc3anonymousza31714ze3z83_1673;} } } } } 
BGL_FUNCTION_END;
}



/* push-nargs-on-sp */
obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132, obj_t BgL_spz00_133)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 708 */
{ /* Eval/evaluate_comp.scm 709 */
long BgL_g1145z00_1680;
BgL_g1145z00_1680 = 
(((long)-1)-
(long)CINT(BgL_arityz00_130)); 
{ 
obj_t BgL_lz00_1682;obj_t BgL_spz00_1683;long BgL_nz00_1684;
BgL_lz00_1682 = BgL_argsz00_132; 
BgL_spz00_1683 = BgL_spz00_133; 
BgL_nz00_1684 = BgL_g1145z00_1680; 
BgL_zc3anonymousza31720ze3z83_1685:
if(
(BgL_nz00_1684==((long)0)))
{ 
obj_t BgL_lz00_1689;obj_t BgL_rz00_1690;
BgL_lz00_1689 = BgL_lz00_1682; 
BgL_rz00_1690 = BNIL; 
BgL_zc3anonymousza31722ze3z83_1691:
if(
NULLP(BgL_lz00_1689))
{ /* Eval/evaluate_comp.scm 713 */
obj_t BgL_arg1724z00_1693;
BgL_arg1724z00_1693 = 
bgl_reverse_bang(BgL_rz00_1690); 
{ /* Eval/evaluate_comp.scm 713 */
long BgL_kz00_6570;
BgL_kz00_6570 = 
(long)CINT(BgL_spz00_1683); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6570,BgL_arg1724z00_1693);} }  else 
{ /* Eval/evaluate_comp.scm 714 */
obj_t BgL_arg1725z00_1694;obj_t BgL_arg1726z00_1695;
BgL_arg1725z00_1694 = 
CDR(
((obj_t)BgL_lz00_1689)); 
{ /* Eval/evaluate_comp.scm 714 */
obj_t BgL_arg1727z00_1696;
{ /* Eval/evaluate_comp.scm 714 */
obj_t BgL_fun1728z00_1697;
BgL_fun1728z00_1697 = 
CAR(
((obj_t)BgL_lz00_1689)); 
BgL_arg1727z00_1696 = 
PROCEDURE_ENTRY(BgL_fun1728z00_1697)(BgL_fun1728z00_1697, BgL_sz00_131, BEOA); } 
BgL_arg1726z00_1695 = 
MAKE_YOUNG_PAIR(BgL_arg1727z00_1696, BgL_rz00_1690); } 
{ 
obj_t BgL_rz00_15476;obj_t BgL_lz00_15475;
BgL_lz00_15475 = BgL_arg1725z00_1694; 
BgL_rz00_15476 = BgL_arg1726z00_1695; 
BgL_rz00_1690 = BgL_rz00_15476; 
BgL_lz00_1689 = BgL_lz00_15475; 
goto BgL_zc3anonymousza31722ze3z83_1691;} } }  else 
{ /* Eval/evaluate_comp.scm 710 */
{ /* Eval/evaluate_comp.scm 715 */
obj_t BgL_arg1729z00_1699;
{ /* Eval/evaluate_comp.scm 715 */
obj_t BgL_fun1730z00_1700;
BgL_fun1730z00_1700 = 
CAR(
((obj_t)BgL_lz00_1682)); 
BgL_arg1729z00_1699 = 
PROCEDURE_ENTRY(BgL_fun1730z00_1700)(BgL_fun1730z00_1700, BgL_sz00_131, BEOA); } 
{ /* Eval/evaluate_comp.scm 715 */
long BgL_kz00_6575;
BgL_kz00_6575 = 
(long)CINT(BgL_spz00_1683); 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6575,BgL_arg1729z00_1699); } } 
{ /* Eval/evaluate_comp.scm 716 */
obj_t BgL_arg1731z00_1701;long BgL_arg1732z00_1702;long BgL_arg1733z00_1703;
BgL_arg1731z00_1701 = 
CDR(
((obj_t)BgL_lz00_1682)); 
BgL_arg1732z00_1702 = 
(
(long)CINT(BgL_spz00_1683)+((long)1)); 
BgL_arg1733z00_1703 = 
(BgL_nz00_1684-((long)1)); 
{ 
long BgL_nz00_15494;obj_t BgL_spz00_15492;obj_t BgL_lz00_15491;
BgL_lz00_15491 = BgL_arg1731z00_1701; 
BgL_spz00_15492 = 
BINT(BgL_arg1732z00_1702); 
BgL_nz00_15494 = BgL_arg1733z00_1703; 
BgL_nz00_1684 = BgL_nz00_15494; 
BgL_spz00_1683 = BgL_spz00_15492; 
BgL_lz00_1682 = BgL_lz00_15491; 
goto BgL_zc3anonymousza31720ze3z83_1685;} } } } } } 
BGL_FUNCTION_END;
}



/* need-shift */
bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134, obj_t BgL_stkz00_135)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 759 */
{ 
obj_t BgL_lz00_1706;obj_t BgL_stkz00_1707;
BgL_lz00_1706 = BgL_argsz00_134; 
BgL_stkz00_1707 = BgL_stkz00_135; 
BgL_zc3anonymousza31734ze3z83_1708:
{ /* Eval/evaluate_comp.scm 763 */
bool_t BgL_testz00_15495;
if(
NULLP(BgL_lz00_1706))
{ /* Eval/evaluate_comp.scm 763 */
BgL_testz00_15495 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 763 */
BgL_testz00_15495 = 
NULLP(BgL_stkz00_1707)
; } 
if(BgL_testz00_15495)
{ /* Eval/evaluate_comp.scm 763 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 765 */
bool_t BgL_testz00_15499;
{ /* Eval/evaluate_comp.scm 765 */
obj_t BgL_g1344z00_1725;
BgL_g1344z00_1725 = 
CDR(
((obj_t)BgL_lz00_1706)); 
{ 
obj_t BgL_l1342z00_1727;
{ /* Eval/evaluate_comp.scm 765 */
obj_t BgL_tmpz00_15502;
BgL_l1342z00_1727 = BgL_g1344z00_1725; 
BgL_zc3anonymousza31745ze3z83_1728:
if(
NULLP(BgL_l1342z00_1727))
{ /* Eval/evaluate_comp.scm 765 */
BgL_tmpz00_15502 = BFALSE
; }  else 
{ /* Eval/evaluate_comp.scm 765 */
obj_t BgL__ortest_1345z00_1730;
{ /* Eval/evaluate_comp.scm 765 */
obj_t BgL_ez00_1732;
BgL_ez00_1732 = 
CAR(
((obj_t)BgL_l1342z00_1727)); 
{ /* Eval/evaluate_comp.scm 765 */
obj_t BgL_arg1747z00_1733;obj_t BgL_arg1748z00_1734;
BgL_arg1747z00_1733 = 
CAR(
((obj_t)BgL_stkz00_1707)); 
BgL_arg1748z00_1734 = 
BGl_usez00zz__evaluate_usez00(
((BgL_ev_exprz00_bglt)BgL_ez00_1732), BNIL); 
BgL__ortest_1345z00_1730 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1747z00_1733, BgL_arg1748z00_1734); } } 
if(
CBOOL(BgL__ortest_1345z00_1730))
{ /* Eval/evaluate_comp.scm 765 */
BgL_tmpz00_15502 = BgL__ortest_1345z00_1730
; }  else 
{ /* Eval/evaluate_comp.scm 765 */
obj_t BgL_arg1746z00_1731;
BgL_arg1746z00_1731 = 
CDR(
((obj_t)BgL_l1342z00_1727)); 
{ 
obj_t BgL_l1342z00_15516;
BgL_l1342z00_15516 = BgL_arg1746z00_1731; 
BgL_l1342z00_1727 = BgL_l1342z00_15516; 
goto BgL_zc3anonymousza31745ze3z83_1728;} } } 
BgL_testz00_15499 = 
CBOOL(BgL_tmpz00_15502); } } } 
if(BgL_testz00_15499)
{ /* Eval/evaluate_comp.scm 765 */
return ((bool_t)1);}  else 
{ /* Eval/evaluate_comp.scm 767 */
obj_t BgL_arg1743z00_1723;obj_t BgL_arg1744z00_1724;
BgL_arg1743z00_1723 = 
CDR(
((obj_t)BgL_lz00_1706)); 
BgL_arg1744z00_1724 = 
CDR(
((obj_t)BgL_stkz00_1707)); 
{ 
obj_t BgL_stkz00_15523;obj_t BgL_lz00_15522;
BgL_lz00_15522 = BgL_arg1743z00_1723; 
BgL_stkz00_15523 = BgL_arg1744z00_1724; 
BgL_stkz00_1707 = BgL_stkz00_15523; 
BgL_lz00_1706 = BgL_lz00_15522; 
goto BgL_zc3anonymousza31734ze3z83_1708;} } } } } } 
BGL_FUNCTION_END;
}



/* comp-old-call */
obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_ez00_136, obj_t BgL_stkz00_137)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 769 */
{ /* Eval/evaluate_comp.scm 771 */
long BgL_siza7eza7_1739;long BgL_nbargsz00_1740;obj_t BgL_fz00_1741;obj_t BgL_symbzd2funzd2_1742;
BgL_siza7eza7_1739 = 
bgl_list_length(BgL_stkz00_137); 
BgL_nbargsz00_1740 = 
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00)); 
BgL_fz00_1741 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00), BgL_stkz00_137); 
BgL_symbzd2funzd2_1742 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00)); 
if(
CBOOL(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_tailzf3zf3)))
{ /* Eval/evaluate_comp.scm 773 */
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137))
{ /* Eval/evaluate_comp.scm 780 */
bool_t BgL_testz00_15537;
{ /* Eval/evaluate_comp.scm 780 */
int BgL_arg1797z00_1821;
BgL_arg1797z00_1821 = 
bgl_debug(); 
BgL_testz00_15537 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1797z00_1821), 
BINT(((long)0))); } 
if(BgL_testz00_15537)
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_argsz00_1748;
BgL_argsz00_1748 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_zc3anonymousza31754ze3z83_10646;
BgL_zc3anonymousza31754ze3z83_10646 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31754ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza31754ze3z83_10646, 
(int)(((long)0)), BgL_fz00_1741); 
PROCEDURE_SET(BgL_zc3anonymousza31754ze3z83_10646, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3anonymousza31754ze3z83_10646, 
(int)(((long)2)), BgL_symbzd2funzd2_1742); 
PROCEDURE_SET(BgL_zc3anonymousza31754ze3z83_10646, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1740)); 
PROCEDURE_SET(BgL_zc3anonymousza31754ze3z83_10646, 
(int)(((long)4)), BgL_argsz00_1748); 
PROCEDURE_SET(BgL_zc3anonymousza31754ze3z83_10646, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1739)); 
return BgL_zc3anonymousza31754ze3z83_10646;} }  else 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_argsz00_1786;
BgL_argsz00_1786 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_zc3anonymousza31777ze3z83_10647;
BgL_zc3anonymousza31777ze3z83_10647 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31777ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza31777ze3z83_10647, 
(int)(((long)0)), BgL_fz00_1741); 
PROCEDURE_SET(BgL_zc3anonymousza31777ze3z83_10647, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3anonymousza31777ze3z83_10647, 
(int)(((long)2)), BgL_symbzd2funzd2_1742); 
PROCEDURE_SET(BgL_zc3anonymousza31777ze3z83_10647, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1740)); 
PROCEDURE_SET(BgL_zc3anonymousza31777ze3z83_10647, 
(int)(((long)4)), BgL_argsz00_1786); 
PROCEDURE_SET(BgL_zc3anonymousza31777ze3z83_10647, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1739)); 
return BgL_zc3anonymousza31777ze3z83_10647;} } }  else 
{ /* Eval/evaluate_comp.scm 788 */
bool_t BgL_testz00_15582;
{ /* Eval/evaluate_comp.scm 788 */
int BgL_arg1837z00_1891;
BgL_arg1837z00_1891 = 
bgl_debug(); 
BgL_testz00_15582 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1837z00_1891), 
BINT(((long)0))); } 
if(BgL_testz00_15582)
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_argsz00_1824;
BgL_argsz00_1824 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1739); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_zc3anonymousza31800ze3z83_10648;
BgL_zc3anonymousza31800ze3z83_10648 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31800ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza31800ze3z83_10648, 
(int)(((long)0)), BgL_fz00_1741); 
PROCEDURE_SET(BgL_zc3anonymousza31800ze3z83_10648, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3anonymousza31800ze3z83_10648, 
(int)(((long)2)), BgL_symbzd2funzd2_1742); 
PROCEDURE_SET(BgL_zc3anonymousza31800ze3z83_10648, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1740)); 
PROCEDURE_SET(BgL_zc3anonymousza31800ze3z83_10648, 
(int)(((long)4)), BgL_argsz00_1824); 
return BgL_zc3anonymousza31800ze3z83_10648;} }  else 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_argsz00_1859;
BgL_argsz00_1859 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1739); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_zc3anonymousza31820ze3z83_10649;
BgL_zc3anonymousza31820ze3z83_10649 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza31820ze3z83_10649, 
(int)(((long)0)), BgL_fz00_1741); 
PROCEDURE_SET(BgL_zc3anonymousza31820ze3z83_10649, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3anonymousza31820ze3z83_10649, 
(int)(((long)2)), BgL_symbzd2funzd2_1742); 
PROCEDURE_SET(BgL_zc3anonymousza31820ze3z83_10649, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1740)); 
PROCEDURE_SET(BgL_zc3anonymousza31820ze3z83_10649, 
(int)(((long)4)), BgL_argsz00_1859); 
return BgL_zc3anonymousza31820ze3z83_10649;} } } }  else 
{ /* Eval/evaluate_comp.scm 774 */
bool_t BgL_testz00_15621;
{ /* Eval/evaluate_comp.scm 774 */
int BgL_arg1878z00_1962;
BgL_arg1878z00_1962 = 
bgl_debug(); 
BgL_testz00_15621 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1878z00_1962), 
BINT(((long)0))); } 
if(BgL_testz00_15621)
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_argsz00_1895;
BgL_argsz00_1895 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_zc3anonymousza31841ze3z83_10650;
BgL_zc3anonymousza31841ze3z83_10650 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31841ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza31841ze3z83_10650, 
(int)(((long)0)), BgL_fz00_1741); 
PROCEDURE_SET(BgL_zc3anonymousza31841ze3z83_10650, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3anonymousza31841ze3z83_10650, 
(int)(((long)2)), BgL_symbzd2funzd2_1742); 
PROCEDURE_SET(BgL_zc3anonymousza31841ze3z83_10650, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1740)); 
PROCEDURE_SET(BgL_zc3anonymousza31841ze3z83_10650, 
(int)(((long)4)), BgL_argsz00_1895); 
PROCEDURE_SET(BgL_zc3anonymousza31841ze3z83_10650, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1739)); 
return BgL_zc3anonymousza31841ze3z83_10650;} }  else 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_argsz00_1930;
BgL_argsz00_1930 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_zc3anonymousza31861ze3z83_10651;
BgL_zc3anonymousza31861ze3z83_10651 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31861ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza31861ze3z83_10651, 
(int)(((long)0)), BgL_fz00_1741); 
PROCEDURE_SET(BgL_zc3anonymousza31861ze3z83_10651, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3anonymousza31861ze3z83_10651, 
(int)(((long)2)), BgL_symbzd2funzd2_1742); 
PROCEDURE_SET(BgL_zc3anonymousza31861ze3z83_10651, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1740)); 
PROCEDURE_SET(BgL_zc3anonymousza31861ze3z83_10651, 
(int)(((long)4)), BgL_argsz00_1930); 
PROCEDURE_SET(BgL_zc3anonymousza31861ze3z83_10651, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1739)); 
return BgL_zc3anonymousza31861ze3z83_10651;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1754> */
obj_t BGl_z62zc3anonymousza31754ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10652, obj_t BgL_sz00_10659)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 780 */
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_fz00_10653;BgL_ev_appz00_bglt BgL_i1153z00_10654;obj_t BgL_symbzd2funzd2_10655;long BgL_nbargsz00_10656;obj_t BgL_argsz00_10657;long BgL_siza7eza7_10658;
BgL_fz00_10653 = 
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)0))); 
BgL_i1153z00_10654 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10655 = 
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)2))); 
BgL_nbargsz00_10656 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)3)))); 
BgL_argsz00_10657 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)4)))); 
BgL_siza7eza7_10658 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10652, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_bpz00_12638;
BgL_bpz00_12638 = 
VECTOR_REF(
((obj_t)BgL_sz00_10659),((long)0)); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_fz00_12639;
BgL_fz00_12639 = 
PROCEDURE_ENTRY(BgL_fz00_10653)(BgL_fz00_10653, BgL_sz00_10659, BEOA); 
if(
PROCEDUREP(BgL_fz00_12639))
{ /* Eval/evaluate_comp.scm 780 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 780 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10654))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12639); } 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_ufz00_12640;
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_tmpz00_15692;
BgL_tmpz00_15692 = 
((obj_t)BgL_fz00_12639); 
BgL_ufz00_12640 = 
PROCEDURE_ATTR(BgL_tmpz00_15692); } 
{ /* Eval/evaluate_comp.scm 780 */
bool_t BgL_testz00_15695;
if(
STRUCTP(BgL_ufz00_12640))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15695 = 
(
STRUCT_KEY(BgL_ufz00_12640)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15695 = ((bool_t)0)
; } 
if(BgL_testz00_15695)
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_arityz00_12641;obj_t BgL_runz00_12642;obj_t BgL_sfz00_12643;
BgL_arityz00_12641 = 
STRUCT_REF(BgL_ufz00_12640, 
(int)(((long)0))); 
BgL_runz00_12642 = 
STRUCT_REF(BgL_ufz00_12640, 
(int)(((long)1))); 
BgL_sfz00_12643 = 
STRUCT_REF(BgL_ufz00_12640, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 780 */
long BgL_spz00_12644;
BgL_spz00_12644 = 
(
(long)CINT(BgL_bpz00_12638)+BgL_siza7eza7_10658); 
if(
(
(long)CINT(BgL_arityz00_12641)==BgL_nbargsz00_10656))
{ /* Eval/evaluate_comp.scm 780 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10659, BgL_argsz00_10657, 
BINT(BgL_spz00_12644)); 
{ /* Eval/evaluate_comp.scm 784 */
long BgL_arg1759z00_12645;
BgL_arg1759z00_12645 = 
(BgL_spz00_12644+BgL_nbargsz00_10656); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10659, 
(long)CINT(BgL_bpz00_12638), BgL_sz00_10659, 
BINT(BgL_spz00_12644), 
BINT(BgL_arg1759z00_12645)); } }  else 
{ /* Eval/evaluate_comp.scm 780 */
bool_t BgL_testz00_15718;
if(
(
(long)CINT(BgL_arityz00_12641)>=((long)0)))
{ /* Eval/evaluate_comp.scm 780 */
BgL_testz00_15718 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 780 */
BgL_testz00_15718 = 
(
(long)CINT(BgL_arityz00_12641)<
(((long)-1)-BgL_nbargsz00_10656))
; } 
if(BgL_testz00_15718)
{ /* Eval/evaluate_comp.scm 780 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10654))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12640, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10656), 
CINT(BgL_arityz00_12641)); }  else 
{ /* Eval/evaluate_comp.scm 780 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12641, BgL_sz00_10659, BgL_argsz00_10657, 
BINT(BgL_spz00_12644)); 
{ /* Eval/evaluate_comp.scm 786 */
long BgL_arg1765z00_12646;
BgL_arg1765z00_12646 = 
(BgL_spz00_12644+
(((long)0)-
(long)CINT(BgL_arityz00_12641))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10659, 
(long)CINT(BgL_bpz00_12638), BgL_sz00_10659, 
BINT(BgL_spz00_12644), 
BINT(BgL_arg1765z00_12646)); } } } 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_z12denvz12_12647;
BgL_z12denvz12_12647 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_tmpz00_15741;
BgL_tmpz00_15741 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10654))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12647, BgL_tmpz00_15741); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10659, BgL_bpz00_12638, BgL_sfz00_12643))
{ /* Eval/evaluate_comp.scm 780 */
return BgL_runz00_12642;}  else 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_nsz00_12648;
BgL_nsz00_12648 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 780 */
long BgL_arg1770z00_12649;
BgL_arg1770z00_12649 = 
(
(long)CINT(BgL_bpz00_12638)+BgL_nbargsz00_10656); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12648, ((long)2), BgL_sz00_10659, BgL_bpz00_12638, 
BINT(BgL_arg1770z00_12649)); } 
VECTOR_SET(BgL_nsz00_12648,((long)1),BgL_sz00_10659); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12647, BgL_nsz00_12648); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_ez00_12650;
BgL_ez00_12650 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12650, BgL_sz00_10659); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_____rz00_12651;
BgL_____rz00_12651 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12642, BgL_nsz00_12648, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12650); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12647, BgL_sz00_10659); 
return BgL_____rz00_12651;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 780 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12639, 
(int)(BgL_nbargsz00_10656)))
{ /* Eval/evaluate_comp.scm 780 */
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_auxz00_15764;obj_t BgL_tmpz00_15762;
BgL_auxz00_15764 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10654))->BgL_locz00); 
BgL_tmpz00_15762 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15762, BgL_auxz00_15764); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10659, BgL_fz00_12639, BgL_argsz00_10657, BgL_bpz00_12638, 
BINT(BgL_siza7eza7_10658));}  else 
{ /* Eval/evaluate_comp.scm 780 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10654))->BgL_locz00), BgL_symbzd2funzd2_10655, 
(int)(BgL_nbargsz00_10656), 
PROCEDURE_ARITY(BgL_fz00_12639));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1777> */
obj_t BGl_z62zc3anonymousza31777ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10660, obj_t BgL_sz00_10667)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 780 */
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_fz00_10661;BgL_ev_appz00_bglt BgL_i1153z00_10662;obj_t BgL_symbzd2funzd2_10663;long BgL_nbargsz00_10664;obj_t BgL_argsz00_10665;long BgL_siza7eza7_10666;
BgL_fz00_10661 = 
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)0))); 
BgL_i1153z00_10662 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10663 = 
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)2))); 
BgL_nbargsz00_10664 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)3)))); 
BgL_argsz00_10665 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)4)))); 
BgL_siza7eza7_10666 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10660, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_bpz00_12652;
BgL_bpz00_12652 = 
VECTOR_REF(
((obj_t)BgL_sz00_10667),((long)0)); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_fz00_12653;
BgL_fz00_12653 = 
PROCEDURE_ENTRY(BgL_fz00_10661)(BgL_fz00_10661, BgL_sz00_10667, BEOA); 
if(
PROCEDUREP(BgL_fz00_12653))
{ /* Eval/evaluate_comp.scm 780 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 780 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10662))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12653); } 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_ufz00_12654;
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_tmpz00_15799;
BgL_tmpz00_15799 = 
((obj_t)BgL_fz00_12653); 
BgL_ufz00_12654 = 
PROCEDURE_ATTR(BgL_tmpz00_15799); } 
{ /* Eval/evaluate_comp.scm 780 */
bool_t BgL_testz00_15802;
if(
STRUCTP(BgL_ufz00_12654))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15802 = 
(
STRUCT_KEY(BgL_ufz00_12654)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15802 = ((bool_t)0)
; } 
if(BgL_testz00_15802)
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_arityz00_12655;obj_t BgL_runz00_12656;obj_t BgL_sfz00_12657;
BgL_arityz00_12655 = 
STRUCT_REF(BgL_ufz00_12654, 
(int)(((long)0))); 
BgL_runz00_12656 = 
STRUCT_REF(BgL_ufz00_12654, 
(int)(((long)1))); 
BgL_sfz00_12657 = 
STRUCT_REF(BgL_ufz00_12654, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 780 */
long BgL_spz00_12658;
BgL_spz00_12658 = 
(
(long)CINT(BgL_bpz00_12652)+BgL_siza7eza7_10666); 
if(
(
(long)CINT(BgL_arityz00_12655)==BgL_nbargsz00_10664))
{ /* Eval/evaluate_comp.scm 780 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10667, BgL_argsz00_10665, 
BINT(BgL_spz00_12658)); 
{ /* Eval/evaluate_comp.scm 784 */
long BgL_arg1782z00_12659;
BgL_arg1782z00_12659 = 
(BgL_spz00_12658+BgL_nbargsz00_10664); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10667, 
(long)CINT(BgL_bpz00_12652), BgL_sz00_10667, 
BINT(BgL_spz00_12658), 
BINT(BgL_arg1782z00_12659)); } }  else 
{ /* Eval/evaluate_comp.scm 780 */
bool_t BgL_testz00_15825;
if(
(
(long)CINT(BgL_arityz00_12655)>=((long)0)))
{ /* Eval/evaluate_comp.scm 780 */
BgL_testz00_15825 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 780 */
BgL_testz00_15825 = 
(
(long)CINT(BgL_arityz00_12655)<
(((long)-1)-BgL_nbargsz00_10664))
; } 
if(BgL_testz00_15825)
{ /* Eval/evaluate_comp.scm 780 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10662))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12654, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10664), 
CINT(BgL_arityz00_12655)); }  else 
{ /* Eval/evaluate_comp.scm 780 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12655, BgL_sz00_10667, BgL_argsz00_10665, 
BINT(BgL_spz00_12658)); 
{ /* Eval/evaluate_comp.scm 786 */
long BgL_arg1788z00_12660;
BgL_arg1788z00_12660 = 
(BgL_spz00_12658+
(((long)0)-
(long)CINT(BgL_arityz00_12655))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10667, 
(long)CINT(BgL_bpz00_12652), BgL_sz00_10667, 
BINT(BgL_spz00_12658), 
BINT(BgL_arg1788z00_12660)); } } } 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_z12denvz12_12661;
BgL_z12denvz12_12661 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10667, BgL_bpz00_12652, BgL_sfz00_12657))
{ /* Eval/evaluate_comp.scm 780 */
return BgL_runz00_12656;}  else 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_nsz00_12662;
BgL_nsz00_12662 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 780 */
long BgL_arg1792z00_12663;
BgL_arg1792z00_12663 = 
(
(long)CINT(BgL_bpz00_12652)+BgL_nbargsz00_10664); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12662, ((long)2), BgL_sz00_10667, BgL_bpz00_12652, 
BINT(BgL_arg1792z00_12663)); } 
VECTOR_SET(BgL_nsz00_12662,((long)1),BgL_sz00_10667); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12661, BgL_nsz00_12662); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_ez00_12664;
BgL_ez00_12664 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12664, BgL_sz00_10667); 
{ /* Eval/evaluate_comp.scm 780 */
obj_t BgL_____rz00_12665;
BgL_____rz00_12665 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12656, BgL_nsz00_12662, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12664); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12661, BgL_sz00_10667); 
return BgL_____rz00_12665;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 780 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12653, 
(int)(BgL_nbargsz00_10664)))
{ /* Eval/evaluate_comp.scm 780 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10667, BgL_fz00_12653, BgL_argsz00_10665, BgL_bpz00_12652, 
BINT(BgL_siza7eza7_10666));}  else 
{ /* Eval/evaluate_comp.scm 780 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10662))->BgL_locz00), BgL_symbzd2funzd2_10663, 
(int)(BgL_nbargsz00_10664), 
PROCEDURE_ARITY(BgL_fz00_12653));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1800> */
obj_t BGl_z62zc3anonymousza31800ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10668, obj_t BgL_sz00_10674)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 788 */
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_fz00_10669;BgL_ev_appz00_bglt BgL_i1153z00_10670;obj_t BgL_symbzd2funzd2_10671;long BgL_nbargsz00_10672;obj_t BgL_argsz00_10673;
BgL_fz00_10669 = 
PROCEDURE_REF(BgL_envz00_10668, 
(int)(((long)0))); 
BgL_i1153z00_10670 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10668, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10671 = 
PROCEDURE_REF(BgL_envz00_10668, 
(int)(((long)2))); 
BgL_nbargsz00_10672 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10668, 
(int)(((long)3)))); 
BgL_argsz00_10673 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10668, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_bpz00_12666;
BgL_bpz00_12666 = 
VECTOR_REF(
((obj_t)BgL_sz00_10674),((long)0)); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_fz00_12667;
BgL_fz00_12667 = 
PROCEDURE_ENTRY(BgL_fz00_10669)(BgL_fz00_10669, BgL_sz00_10674, BEOA); 
if(
PROCEDUREP(BgL_fz00_12667))
{ /* Eval/evaluate_comp.scm 788 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 788 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10670))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12667); } 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_ufz00_12668;
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_tmpz00_15895;
BgL_tmpz00_15895 = 
((obj_t)BgL_fz00_12667); 
BgL_ufz00_12668 = 
PROCEDURE_ATTR(BgL_tmpz00_15895); } 
{ /* Eval/evaluate_comp.scm 788 */
bool_t BgL_testz00_15898;
if(
STRUCTP(BgL_ufz00_12668))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15898 = 
(
STRUCT_KEY(BgL_ufz00_12668)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15898 = ((bool_t)0)
; } 
if(BgL_testz00_15898)
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_arityz00_12669;obj_t BgL_runz00_12670;obj_t BgL_sfz00_12671;
BgL_arityz00_12669 = 
STRUCT_REF(BgL_ufz00_12668, 
(int)(((long)0))); 
BgL_runz00_12670 = 
STRUCT_REF(BgL_ufz00_12668, 
(int)(((long)1))); 
BgL_sfz00_12671 = 
STRUCT_REF(BgL_ufz00_12668, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12669)==BgL_nbargsz00_10672))
{ /* Eval/evaluate_comp.scm 788 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10674, BgL_argsz00_10673, BgL_bpz00_12666)); }  else 
{ /* Eval/evaluate_comp.scm 788 */
bool_t BgL_testz00_15914;
if(
(
(long)CINT(BgL_arityz00_12669)>=((long)0)))
{ /* Eval/evaluate_comp.scm 788 */
BgL_testz00_15914 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 788 */
BgL_testz00_15914 = 
(
(long)CINT(BgL_arityz00_12669)<
(((long)-1)-BgL_nbargsz00_10672))
; } 
if(BgL_testz00_15914)
{ /* Eval/evaluate_comp.scm 788 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10670))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12668, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10672), 
CINT(BgL_arityz00_12669)); }  else 
{ /* Eval/evaluate_comp.scm 788 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12669, BgL_sz00_10674, BgL_argsz00_10673, BgL_bpz00_12666); } } 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_z12denvz12_12672;
BgL_z12denvz12_12672 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_tmpz00_15929;
BgL_tmpz00_15929 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10670))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12672, BgL_tmpz00_15929); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10674, BgL_bpz00_12666, BgL_sfz00_12671))
{ /* Eval/evaluate_comp.scm 788 */
return BgL_runz00_12670;}  else 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_nsz00_12673;
BgL_nsz00_12673 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 788 */
long BgL_arg1813z00_12674;
BgL_arg1813z00_12674 = 
(
(long)CINT(BgL_bpz00_12666)+BgL_nbargsz00_10672); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12673, ((long)2), BgL_sz00_10674, BgL_bpz00_12666, 
BINT(BgL_arg1813z00_12674)); } 
VECTOR_SET(BgL_nsz00_12673,((long)1),BgL_sz00_10674); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12672, BgL_nsz00_12673); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_ez00_12675;
BgL_ez00_12675 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12675, BgL_sz00_10674); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_____rz00_12676;
BgL_____rz00_12676 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12670, BgL_nsz00_12673, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12675); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12672, BgL_sz00_10674); 
return BgL_____rz00_12676;} } } } }  else 
{ /* Eval/evaluate_comp.scm 788 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12667, 
(int)(BgL_nbargsz00_10672)))
{ /* Eval/evaluate_comp.scm 788 */
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_auxz00_15952;obj_t BgL_tmpz00_15950;
BgL_auxz00_15952 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10670))->BgL_locz00); 
BgL_tmpz00_15950 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15950, BgL_auxz00_15952); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10674, BgL_fz00_12667, BgL_argsz00_10673, BgL_bpz00_12666, 
BINT(BgL_nbargsz00_10672));}  else 
{ /* Eval/evaluate_comp.scm 788 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10670))->BgL_locz00), BgL_symbzd2funzd2_10671, 
(int)(BgL_nbargsz00_10672), 
PROCEDURE_ARITY(BgL_fz00_12667));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1820> */
obj_t BGl_z62zc3anonymousza31820ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10675, obj_t BgL_sz00_10681)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 788 */
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_fz00_10676;BgL_ev_appz00_bglt BgL_i1153z00_10677;obj_t BgL_symbzd2funzd2_10678;long BgL_nbargsz00_10679;obj_t BgL_argsz00_10680;
BgL_fz00_10676 = 
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)0))); 
BgL_i1153z00_10677 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10678 = 
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)2))); 
BgL_nbargsz00_10679 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)3)))); 
BgL_argsz00_10680 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10675, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_bpz00_12677;
BgL_bpz00_12677 = 
VECTOR_REF(
((obj_t)BgL_sz00_10681),((long)0)); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_fz00_12678;
BgL_fz00_12678 = 
PROCEDURE_ENTRY(BgL_fz00_10676)(BgL_fz00_10676, BgL_sz00_10681, BEOA); 
if(
PROCEDUREP(BgL_fz00_12678))
{ /* Eval/evaluate_comp.scm 788 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 788 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10677))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12678); } 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_ufz00_12679;
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_tmpz00_15984;
BgL_tmpz00_15984 = 
((obj_t)BgL_fz00_12678); 
BgL_ufz00_12679 = 
PROCEDURE_ATTR(BgL_tmpz00_15984); } 
{ /* Eval/evaluate_comp.scm 788 */
bool_t BgL_testz00_15987;
if(
STRUCTP(BgL_ufz00_12679))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15987 = 
(
STRUCT_KEY(BgL_ufz00_12679)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_15987 = ((bool_t)0)
; } 
if(BgL_testz00_15987)
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_arityz00_12680;obj_t BgL_runz00_12681;obj_t BgL_sfz00_12682;
BgL_arityz00_12680 = 
STRUCT_REF(BgL_ufz00_12679, 
(int)(((long)0))); 
BgL_runz00_12681 = 
STRUCT_REF(BgL_ufz00_12679, 
(int)(((long)1))); 
BgL_sfz00_12682 = 
STRUCT_REF(BgL_ufz00_12679, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12680)==BgL_nbargsz00_10679))
{ /* Eval/evaluate_comp.scm 788 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10681, BgL_argsz00_10680, BgL_bpz00_12677)); }  else 
{ /* Eval/evaluate_comp.scm 788 */
bool_t BgL_testz00_16003;
if(
(
(long)CINT(BgL_arityz00_12680)>=((long)0)))
{ /* Eval/evaluate_comp.scm 788 */
BgL_testz00_16003 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 788 */
BgL_testz00_16003 = 
(
(long)CINT(BgL_arityz00_12680)<
(((long)-1)-BgL_nbargsz00_10679))
; } 
if(BgL_testz00_16003)
{ /* Eval/evaluate_comp.scm 788 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10677))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12679, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10679), 
CINT(BgL_arityz00_12680)); }  else 
{ /* Eval/evaluate_comp.scm 788 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12680, BgL_sz00_10681, BgL_argsz00_10680, BgL_bpz00_12677); } } 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_z12denvz12_12683;
BgL_z12denvz12_12683 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10681, BgL_bpz00_12677, BgL_sfz00_12682))
{ /* Eval/evaluate_comp.scm 788 */
return BgL_runz00_12681;}  else 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_nsz00_12684;
BgL_nsz00_12684 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 788 */
long BgL_arg1832z00_12685;
BgL_arg1832z00_12685 = 
(
(long)CINT(BgL_bpz00_12677)+BgL_nbargsz00_10679); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12684, ((long)2), BgL_sz00_10681, BgL_bpz00_12677, 
BINT(BgL_arg1832z00_12685)); } 
VECTOR_SET(BgL_nsz00_12684,((long)1),BgL_sz00_10681); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12683, BgL_nsz00_12684); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_ez00_12686;
BgL_ez00_12686 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12686, BgL_sz00_10681); 
{ /* Eval/evaluate_comp.scm 788 */
obj_t BgL_____rz00_12687;
BgL_____rz00_12687 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12681, BgL_nsz00_12684, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12686); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12683, BgL_sz00_10681); 
return BgL_____rz00_12687;} } } } }  else 
{ /* Eval/evaluate_comp.scm 788 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12678, 
(int)(BgL_nbargsz00_10679)))
{ /* Eval/evaluate_comp.scm 788 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10681, BgL_fz00_12678, BgL_argsz00_10680, BgL_bpz00_12677, 
BINT(BgL_nbargsz00_10679));}  else 
{ /* Eval/evaluate_comp.scm 788 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10677))->BgL_locz00), BgL_symbzd2funzd2_10678, 
(int)(BgL_nbargsz00_10679), 
PROCEDURE_ARITY(BgL_fz00_12678));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1841> */
obj_t BGl_z62zc3anonymousza31841ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10682, obj_t BgL_sz00_10689)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 774 */
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_fz00_10683;BgL_ev_appz00_bglt BgL_i1153z00_10684;obj_t BgL_symbzd2funzd2_10685;long BgL_nbargsz00_10686;obj_t BgL_argsz00_10687;long BgL_siza7eza7_10688;
BgL_fz00_10683 = 
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)0))); 
BgL_i1153z00_10684 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10685 = 
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)2))); 
BgL_nbargsz00_10686 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)3)))); 
BgL_argsz00_10687 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)4)))); 
BgL_siza7eza7_10688 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10682, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_bpz00_12688;
BgL_bpz00_12688 = 
VECTOR_REF(
((obj_t)BgL_sz00_10689),((long)0)); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_fz00_12689;
BgL_fz00_12689 = 
PROCEDURE_ENTRY(BgL_fz00_10683)(BgL_fz00_10683, BgL_sz00_10689, BEOA); 
if(
PROCEDUREP(BgL_fz00_12689))
{ /* Eval/evaluate_comp.scm 774 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 774 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10684))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12689); } 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_ufz00_12690;
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_tmpz00_16068;
BgL_tmpz00_16068 = 
((obj_t)BgL_fz00_12689); 
BgL_ufz00_12690 = 
PROCEDURE_ATTR(BgL_tmpz00_16068); } 
{ /* Eval/evaluate_comp.scm 774 */
bool_t BgL_testz00_16071;
if(
STRUCTP(BgL_ufz00_12690))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16071 = 
(
STRUCT_KEY(BgL_ufz00_12690)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16071 = ((bool_t)0)
; } 
if(BgL_testz00_16071)
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_arityz00_12691;obj_t BgL_runz00_12692;obj_t BgL_sfz00_12693;
BgL_arityz00_12691 = 
STRUCT_REF(BgL_ufz00_12690, 
(int)(((long)0))); 
BgL_runz00_12692 = 
STRUCT_REF(BgL_ufz00_12690, 
(int)(((long)1))); 
BgL_sfz00_12693 = 
STRUCT_REF(BgL_ufz00_12690, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 774 */
long BgL_spz00_12694;
BgL_spz00_12694 = 
(
(long)CINT(BgL_bpz00_12688)+BgL_siza7eza7_10688); 
if(
(
(long)CINT(BgL_arityz00_12691)==BgL_nbargsz00_10686))
{ /* Eval/evaluate_comp.scm 774 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10689, BgL_argsz00_10687, 
BINT(BgL_spz00_12694))); }  else 
{ /* Eval/evaluate_comp.scm 774 */
bool_t BgL_testz00_16090;
if(
(
(long)CINT(BgL_arityz00_12691)>=((long)0)))
{ /* Eval/evaluate_comp.scm 774 */
BgL_testz00_16090 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 774 */
BgL_testz00_16090 = 
(
(long)CINT(BgL_arityz00_12691)<
(((long)-1)-BgL_nbargsz00_10686))
; } 
if(BgL_testz00_16090)
{ /* Eval/evaluate_comp.scm 774 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10684))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12690, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10686), 
CINT(BgL_arityz00_12691)); }  else 
{ /* Eval/evaluate_comp.scm 774 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12691, BgL_sz00_10689, BgL_argsz00_10687, 
BINT(BgL_spz00_12694)); } } 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_z12denvz12_12695;
BgL_z12denvz12_12695 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_tmpz00_16106;
BgL_tmpz00_16106 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10684))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12695, BgL_tmpz00_16106); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10689, 
BINT(BgL_spz00_12694), BgL_sfz00_12693))
{ /* Eval/evaluate_comp.scm 774 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12692, BgL_sz00_10689, 
BINT(BgL_spz00_12694));}  else 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_nsz00_12696;
BgL_nsz00_12696 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 774 */
long BgL_arg1854z00_12697;
BgL_arg1854z00_12697 = 
(BgL_spz00_12694+BgL_nbargsz00_10686); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12696, ((long)2), BgL_sz00_10689, 
BINT(BgL_spz00_12694), 
BINT(BgL_arg1854z00_12697)); } 
VECTOR_SET(BgL_nsz00_12696,((long)1),BgL_sz00_10689); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12695, BgL_nsz00_12696); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_ez00_12698;
BgL_ez00_12698 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12698, BgL_sz00_10689); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_____rz00_12699;
BgL_____rz00_12699 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12692, BgL_nsz00_12696, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12698); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12695, BgL_sz00_10689); 
return BgL_____rz00_12699;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 774 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12689, 
(int)(BgL_nbargsz00_10686)))
{ /* Eval/evaluate_comp.scm 774 */
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_auxz00_16132;obj_t BgL_tmpz00_16130;
BgL_auxz00_16132 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10684))->BgL_locz00); 
BgL_tmpz00_16130 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16130, BgL_auxz00_16132); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10689, BgL_fz00_12689, BgL_argsz00_10687, BgL_bpz00_12688, 
BINT(BgL_siza7eza7_10688));}  else 
{ /* Eval/evaluate_comp.scm 774 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10684))->BgL_locz00), BgL_symbzd2funzd2_10685, 
(int)(BgL_nbargsz00_10686), 
PROCEDURE_ARITY(BgL_fz00_12689));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1861> */
obj_t BGl_z62zc3anonymousza31861ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10690, obj_t BgL_sz00_10697)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 774 */
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_fz00_10691;BgL_ev_appz00_bglt BgL_i1153z00_10692;obj_t BgL_symbzd2funzd2_10693;long BgL_nbargsz00_10694;obj_t BgL_argsz00_10695;long BgL_siza7eza7_10696;
BgL_fz00_10691 = 
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)0))); 
BgL_i1153z00_10692 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10693 = 
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)2))); 
BgL_nbargsz00_10694 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)3)))); 
BgL_argsz00_10695 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)4)))); 
BgL_siza7eza7_10696 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10690, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_bpz00_12700;
BgL_bpz00_12700 = 
VECTOR_REF(
((obj_t)BgL_sz00_10697),((long)0)); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_fz00_12701;
BgL_fz00_12701 = 
PROCEDURE_ENTRY(BgL_fz00_10691)(BgL_fz00_10691, BgL_sz00_10697, BEOA); 
if(
PROCEDUREP(BgL_fz00_12701))
{ /* Eval/evaluate_comp.scm 774 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 774 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10692))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12701); } 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_ufz00_12702;
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_tmpz00_16167;
BgL_tmpz00_16167 = 
((obj_t)BgL_fz00_12701); 
BgL_ufz00_12702 = 
PROCEDURE_ATTR(BgL_tmpz00_16167); } 
{ /* Eval/evaluate_comp.scm 774 */
bool_t BgL_testz00_16170;
if(
STRUCTP(BgL_ufz00_12702))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16170 = 
(
STRUCT_KEY(BgL_ufz00_12702)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16170 = ((bool_t)0)
; } 
if(BgL_testz00_16170)
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_arityz00_12703;obj_t BgL_runz00_12704;obj_t BgL_sfz00_12705;
BgL_arityz00_12703 = 
STRUCT_REF(BgL_ufz00_12702, 
(int)(((long)0))); 
BgL_runz00_12704 = 
STRUCT_REF(BgL_ufz00_12702, 
(int)(((long)1))); 
BgL_sfz00_12705 = 
STRUCT_REF(BgL_ufz00_12702, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 774 */
long BgL_spz00_12706;
BgL_spz00_12706 = 
(
(long)CINT(BgL_bpz00_12700)+BgL_siza7eza7_10696); 
if(
(
(long)CINT(BgL_arityz00_12703)==BgL_nbargsz00_10694))
{ /* Eval/evaluate_comp.scm 774 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10697, BgL_argsz00_10695, 
BINT(BgL_spz00_12706))); }  else 
{ /* Eval/evaluate_comp.scm 774 */
bool_t BgL_testz00_16189;
if(
(
(long)CINT(BgL_arityz00_12703)>=((long)0)))
{ /* Eval/evaluate_comp.scm 774 */
BgL_testz00_16189 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 774 */
BgL_testz00_16189 = 
(
(long)CINT(BgL_arityz00_12703)<
(((long)-1)-BgL_nbargsz00_10694))
; } 
if(BgL_testz00_16189)
{ /* Eval/evaluate_comp.scm 774 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10692))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12702, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10694), 
CINT(BgL_arityz00_12703)); }  else 
{ /* Eval/evaluate_comp.scm 774 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12703, BgL_sz00_10697, BgL_argsz00_10695, 
BINT(BgL_spz00_12706)); } } 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_z12denvz12_12707;
BgL_z12denvz12_12707 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10697, 
BINT(BgL_spz00_12706), BgL_sfz00_12705))
{ /* Eval/evaluate_comp.scm 774 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12704, BgL_sz00_10697, 
BINT(BgL_spz00_12706));}  else 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_nsz00_12708;
BgL_nsz00_12708 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 774 */
long BgL_arg1873z00_12709;
BgL_arg1873z00_12709 = 
(BgL_spz00_12706+BgL_nbargsz00_10694); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12708, ((long)2), BgL_sz00_10697, 
BINT(BgL_spz00_12706), 
BINT(BgL_arg1873z00_12709)); } 
VECTOR_SET(BgL_nsz00_12708,((long)1),BgL_sz00_10697); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12707, BgL_nsz00_12708); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_ez00_12710;
BgL_ez00_12710 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12710, BgL_sz00_10697); 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_____rz00_12711;
BgL_____rz00_12711 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12704, BgL_nsz00_12708, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12710); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12707, BgL_sz00_10697); 
return BgL_____rz00_12711;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 774 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12701, 
(int)(BgL_nbargsz00_10694)))
{ /* Eval/evaluate_comp.scm 774 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10697, BgL_fz00_12701, BgL_argsz00_10695, BgL_bpz00_12700, 
BINT(BgL_siza7eza7_10696));}  else 
{ /* Eval/evaluate_comp.scm 774 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10692))->BgL_locz00), BgL_symbzd2funzd2_10693, 
(int)(BgL_nbargsz00_10694), 
PROCEDURE_ARITY(BgL_fz00_12701));} } } } } } } } 
BGL_FUNCTION_END;
}



/* comp-call0 */
obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138, BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140, obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143, long BgL_siza7eza7_144)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_cfunz00_1966;
BgL_cfunz00_1966 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139, ((long)0), BgL_locz00_138, BgL_symbzd2funzd2_140); 
if(
CBOOL(BgL_cfunz00_1966))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16235;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg1887z00_1980;
BgL_arg1887z00_1980 = 
bgl_debug(); 
BgL_testz00_16235 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1887z00_1980), 
BINT(((long)0))); } 
if(BgL_testz00_16235)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31884ze3z83_10698;
BgL_zc3anonymousza31884ze3z83_10698 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_10698, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_10698, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3anonymousza31884ze3z83_10698, 
(int)(((long)2)), BgL_cfunz00_1966); 
return BgL_zc3anonymousza31884ze3z83_10698;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31886ze3z83_10699;
BgL_zc3anonymousza31886ze3z83_10699 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31886ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza31886ze3z83_10699, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3anonymousza31886ze3z83_10699, 
(int)(((long)1)), BgL_cfunz00_1966); 
return BgL_zc3anonymousza31886ze3z83_10699;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
CBOOL(BgL_tailzf3zf3_142))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16260;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg1917z00_2044;
BgL_arg1917z00_2044 = 
bgl_debug(); 
BgL_testz00_16260 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1917z00_2044), 
BINT(((long)0))); } 
if(BgL_testz00_16260)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31890ze3z83_10700;
BgL_zc3anonymousza31890ze3z83_10700 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza31890ze3z83_10700, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3anonymousza31890ze3z83_10700, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3anonymousza31890ze3z83_10700, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3anonymousza31890ze3z83_10700, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3anonymousza31890ze3z83_10700;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31904ze3z83_10701;
BgL_zc3anonymousza31904ze3z83_10701 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza31904ze3z83_10701, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3anonymousza31904ze3z83_10701, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3anonymousza31904ze3z83_10701, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3anonymousza31904ze3z83_10701, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3anonymousza31904ze3z83_10701;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16289;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg1947z00_2108;
BgL_arg1947z00_2108 = 
bgl_debug(); 
BgL_testz00_16289 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1947z00_2108), 
BINT(((long)0))); } 
if(BgL_testz00_16289)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31920ze3z83_10702;
BgL_zc3anonymousza31920ze3z83_10702 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza31920ze3z83_10702, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3anonymousza31920ze3z83_10702, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3anonymousza31920ze3z83_10702, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3anonymousza31920ze3z83_10702, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3anonymousza31920ze3z83_10702;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31934ze3z83_10703;
BgL_zc3anonymousza31934ze3z83_10703 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31934ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza31934ze3z83_10703, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3anonymousza31934ze3z83_10703, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3anonymousza31934ze3z83_10703, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3anonymousza31934ze3z83_10703, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3anonymousza31934ze3z83_10703;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1884> */
obj_t BGl_z62zc3anonymousza31884ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10704, obj_t BgL_sz00_10708)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_siza7eza7_10705;obj_t BgL_locz00_10706;obj_t BgL_cfunz00_10707;
BgL_siza7eza7_10705 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10704, 
(int)(((long)0)))); 
BgL_locz00_10706 = 
PROCEDURE_REF(BgL_envz00_10704, 
(int)(((long)1))); 
BgL_cfunz00_10707 = 
PROCEDURE_REF(BgL_envz00_10704, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12712;
BgL_bpz00_12712 = 
VECTOR_REF(
((obj_t)BgL_sz00_10708),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */

{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12713;
BgL_nbpz00_12713 = 
(
(long)CINT(BgL_bpz00_12712)+BgL_siza7eza7_10705); 
VECTOR_SET(
((obj_t)BgL_sz00_10708),((long)0),
BINT(BgL_nbpz00_12713)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16332;
BgL_tmpz00_16332 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16332, BgL_locz00_10706); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12714;
BgL_rz00_12714 = 
PROCEDURE_ENTRY(BgL_cfunz00_10707)(BgL_cfunz00_10707, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10708),((long)0),BgL_bpz00_12712); 
return BgL_rz00_12714;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1886> */
obj_t BGl_z62zc3anonymousza31886ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10709, obj_t BgL_sz00_10712)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_siza7eza7_10710;obj_t BgL_cfunz00_10711;
BgL_siza7eza7_10710 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10709, 
(int)(((long)0)))); 
BgL_cfunz00_10711 = 
PROCEDURE_REF(BgL_envz00_10709, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12715;
BgL_bpz00_12715 = 
VECTOR_REF(
((obj_t)BgL_sz00_10712),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */

{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12716;
BgL_nbpz00_12716 = 
(
(long)CINT(BgL_bpz00_12715)+BgL_siza7eza7_10710); 
VECTOR_SET(
((obj_t)BgL_sz00_10712),((long)0),
BINT(BgL_nbpz00_12716)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12717;
BgL_rz00_12717 = 
PROCEDURE_ENTRY(BgL_cfunz00_10711)(BgL_cfunz00_10711, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10712),((long)0),BgL_bpz00_12715); 
return BgL_rz00_12717;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1890> */
obj_t BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10713, obj_t BgL_sz00_10718)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10714;obj_t BgL_locz00_10715;obj_t BgL_symbzd2funzd2_10716;long BgL_siza7eza7_10717;
BgL_funz00_10714 = 
PROCEDURE_REF(BgL_envz00_10713, 
(int)(((long)0))); 
BgL_locz00_10715 = 
PROCEDURE_REF(BgL_envz00_10713, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10716 = 
PROCEDURE_REF(BgL_envz00_10713, 
(int)(((long)2))); 
BgL_siza7eza7_10717 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10713, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12718;
BgL_bpz00_12718 = 
VECTOR_REF(
((obj_t)BgL_sz00_10718),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12719;
BgL_fz00_12719 = 
PROCEDURE_ENTRY(BgL_funz00_10714)(BgL_funz00_10714, BgL_sz00_10718, BEOA); 
if(
PROCEDUREP(BgL_fz00_12719))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10715, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12719); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12720;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16375;
BgL_tmpz00_16375 = 
((obj_t)BgL_fz00_12719); 
BgL_ufz00_12720 = 
PROCEDURE_ATTR(BgL_tmpz00_16375); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16378;
if(
STRUCTP(BgL_ufz00_12720))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16378 = 
(
STRUCT_KEY(BgL_ufz00_12720)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16378 = ((bool_t)0)
; } 
if(BgL_testz00_16378)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12721;obj_t BgL_runz00_12722;obj_t BgL_sfz00_12723;
BgL_arityz00_12721 = 
STRUCT_REF(BgL_ufz00_12720, 
(int)(((long)0))); 
BgL_runz00_12722 = 
STRUCT_REF(BgL_ufz00_12720, 
(int)(((long)1))); 
BgL_sfz00_12723 = 
STRUCT_REF(BgL_ufz00_12720, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12721)==((long)0)))
{ /* Eval/evaluate_comp.scm 889 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12721))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12721)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1895z00_12726;obj_t BgL_arg1896z00_12727;
BgL_arg1895z00_12726 = 
(
(long)CINT(BgL_bpz00_12718)+((long)0)); 
BgL_arg1896z00_12727 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10718),BgL_arg1895z00_12726,BgL_arg1896z00_12727); } break;
default: 
BgL_case_else1169z00_12724:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg1898z00_12725;
BgL_arg1898z00_12725 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12720), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10715, BgL_arg1898z00_12725, 
(int)(((long)0)), 
CINT(BgL_arityz00_12721)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1169z00_12724;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12728;
BgL_z12denvz12_12728 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12728, BgL_locz00_10715); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10718, BgL_bpz00_12718, BgL_sfz00_12723))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_12722;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12729;
BgL_nsz00_12729 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1900z00_12730;
BgL_arg1900z00_12730 = 
(
(long)CINT(BgL_bpz00_12718)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12729, ((long)2), BgL_sz00_10718, BgL_bpz00_12718, 
BINT(BgL_arg1900z00_12730)); } 
VECTOR_SET(BgL_nsz00_12729,((long)1),BgL_sz00_10718); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12728, BgL_nsz00_12729); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12731;
BgL_ez00_12731 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12731, BgL_sz00_10718); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12732;
BgL_____rz00_12732 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12722, BgL_nsz00_12729, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12731); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12728, BgL_sz00_10718); 
return BgL_____rz00_12732;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12719, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12733;
BgL_nbpz00_12733 = 
(
(long)CINT(BgL_bpz00_12718)+BgL_siza7eza7_10717); 
VECTOR_SET(
((obj_t)BgL_sz00_10718),((long)0),
BINT(BgL_nbpz00_12733)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16431;
BgL_tmpz00_16431 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16431, BgL_locz00_10715); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12734;
BgL_rz00_12734 = 
PROCEDURE_ENTRY(BgL_fz00_12719)(BgL_fz00_12719, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10718),((long)0),BgL_bpz00_12718); 
return BgL_rz00_12734;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10715, BgL_symbzd2funzd2_10716, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12719));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1904> */
obj_t BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10719, obj_t BgL_sz00_10724)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10720;obj_t BgL_locz00_10721;obj_t BgL_symbzd2funzd2_10722;long BgL_siza7eza7_10723;
BgL_funz00_10720 = 
PROCEDURE_REF(BgL_envz00_10719, 
(int)(((long)0))); 
BgL_locz00_10721 = 
PROCEDURE_REF(BgL_envz00_10719, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10722 = 
PROCEDURE_REF(BgL_envz00_10719, 
(int)(((long)2))); 
BgL_siza7eza7_10723 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10719, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12735;
BgL_bpz00_12735 = 
VECTOR_REF(
((obj_t)BgL_sz00_10724),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12736;
BgL_fz00_12736 = 
PROCEDURE_ENTRY(BgL_funz00_10720)(BgL_funz00_10720, BgL_sz00_10724, BEOA); 
if(
PROCEDUREP(BgL_fz00_12736))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10721, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12736); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12737;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16460;
BgL_tmpz00_16460 = 
((obj_t)BgL_fz00_12736); 
BgL_ufz00_12737 = 
PROCEDURE_ATTR(BgL_tmpz00_16460); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16463;
if(
STRUCTP(BgL_ufz00_12737))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16463 = 
(
STRUCT_KEY(BgL_ufz00_12737)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16463 = ((bool_t)0)
; } 
if(BgL_testz00_16463)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12738;obj_t BgL_runz00_12739;obj_t BgL_sfz00_12740;
BgL_arityz00_12738 = 
STRUCT_REF(BgL_ufz00_12737, 
(int)(((long)0))); 
BgL_runz00_12739 = 
STRUCT_REF(BgL_ufz00_12737, 
(int)(((long)1))); 
BgL_sfz00_12740 = 
STRUCT_REF(BgL_ufz00_12737, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12738)==((long)0)))
{ /* Eval/evaluate_comp.scm 889 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12738))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12738)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1909z00_12743;obj_t BgL_arg1910z00_12744;
BgL_arg1909z00_12743 = 
(
(long)CINT(BgL_bpz00_12735)+((long)0)); 
BgL_arg1910z00_12744 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10724),BgL_arg1909z00_12743,BgL_arg1910z00_12744); } break;
default: 
BgL_case_else1171z00_12741:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg1912z00_12742;
BgL_arg1912z00_12742 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12737), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10721, BgL_arg1912z00_12742, 
(int)(((long)0)), 
CINT(BgL_arityz00_12738)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1171z00_12741;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12745;
BgL_z12denvz12_12745 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10724, BgL_bpz00_12735, BgL_sfz00_12740))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_12739;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12746;
BgL_nsz00_12746 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1914z00_12747;
BgL_arg1914z00_12747 = 
(
(long)CINT(BgL_bpz00_12735)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12746, ((long)2), BgL_sz00_10724, BgL_bpz00_12735, 
BINT(BgL_arg1914z00_12747)); } 
VECTOR_SET(BgL_nsz00_12746,((long)1),BgL_sz00_10724); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12745, BgL_nsz00_12746); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12748;
BgL_ez00_12748 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12748, BgL_sz00_10724); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12749;
BgL_____rz00_12749 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12739, BgL_nsz00_12746, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12748); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12745, BgL_sz00_10724); 
return BgL_____rz00_12749;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12736, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12750;
BgL_nbpz00_12750 = 
(
(long)CINT(BgL_bpz00_12735)+BgL_siza7eza7_10723); 
VECTOR_SET(
((obj_t)BgL_sz00_10724),((long)0),
BINT(BgL_nbpz00_12750)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12751;
BgL_rz00_12751 = 
PROCEDURE_ENTRY(BgL_fz00_12736)(BgL_fz00_12736, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10724),((long)0),BgL_bpz00_12735); 
return BgL_rz00_12751;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10721, BgL_symbzd2funzd2_10722, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12736));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1920> */
obj_t BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10725, obj_t BgL_sz00_10730)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10726;obj_t BgL_locz00_10727;obj_t BgL_symbzd2funzd2_10728;long BgL_siza7eza7_10729;
BgL_funz00_10726 = 
PROCEDURE_REF(BgL_envz00_10725, 
(int)(((long)0))); 
BgL_locz00_10727 = 
PROCEDURE_REF(BgL_envz00_10725, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10728 = 
PROCEDURE_REF(BgL_envz00_10725, 
(int)(((long)2))); 
BgL_siza7eza7_10729 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10725, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12752;
BgL_bpz00_12752 = 
VECTOR_REF(
((obj_t)BgL_sz00_10730),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12753;
BgL_fz00_12753 = 
PROCEDURE_ENTRY(BgL_funz00_10726)(BgL_funz00_10726, BgL_sz00_10730, BEOA); 
if(
PROCEDUREP(BgL_fz00_12753))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10727, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12753); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12754;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16541;
BgL_tmpz00_16541 = 
((obj_t)BgL_fz00_12753); 
BgL_ufz00_12754 = 
PROCEDURE_ATTR(BgL_tmpz00_16541); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16544;
if(
STRUCTP(BgL_ufz00_12754))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16544 = 
(
STRUCT_KEY(BgL_ufz00_12754)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16544 = ((bool_t)0)
; } 
if(BgL_testz00_16544)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12755;obj_t BgL_runz00_12756;obj_t BgL_sfz00_12757;
BgL_arityz00_12755 = 
STRUCT_REF(BgL_ufz00_12754, 
(int)(((long)0))); 
BgL_runz00_12756 = 
STRUCT_REF(BgL_ufz00_12754, 
(int)(((long)1))); 
BgL_sfz00_12757 = 
STRUCT_REF(BgL_ufz00_12754, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_12758;
BgL_spz00_12758 = 
(
(long)CINT(BgL_bpz00_12752)+BgL_siza7eza7_10729); 
if(
(
(long)CINT(BgL_arityz00_12755)==((long)0)))
{ /* Eval/evaluate_comp.scm 889 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12755))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12755)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1925z00_12761;obj_t BgL_arg1926z00_12762;
BgL_arg1925z00_12761 = 
(BgL_spz00_12758+((long)0)); 
BgL_arg1926z00_12762 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10730),BgL_arg1925z00_12761,BgL_arg1926z00_12762); } break;
default: 
BgL_case_else1173z00_12759:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg1928z00_12760;
BgL_arg1928z00_12760 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12754), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10727, BgL_arg1928z00_12760, 
(int)(((long)0)), 
CINT(BgL_arityz00_12755)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1173z00_12759;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12763;
BgL_z12denvz12_12763 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12763, BgL_locz00_10727); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10730, 
BINT(BgL_spz00_12758), BgL_sfz00_12757))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12756, BgL_sz00_10730, 
BINT(BgL_spz00_12758));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12764;
BgL_nsz00_12764 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1930z00_12765;
BgL_arg1930z00_12765 = 
(BgL_spz00_12758+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12764, ((long)2), BgL_sz00_10730, 
BINT(BgL_spz00_12758), 
BINT(BgL_arg1930z00_12765)); } 
VECTOR_SET(BgL_nsz00_12764,((long)1),BgL_sz00_10730); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12763, BgL_nsz00_12764); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12766;
BgL_ez00_12766 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12766, BgL_sz00_10730); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12767;
BgL_____rz00_12767 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12756, BgL_nsz00_12764, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12766); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12763, BgL_sz00_10730); 
return BgL_____rz00_12767;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12753, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12768;
BgL_nbpz00_12768 = 
(
(long)CINT(BgL_bpz00_12752)+BgL_siza7eza7_10729); 
VECTOR_SET(
((obj_t)BgL_sz00_10730),((long)0),
BINT(BgL_nbpz00_12768)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16601;
BgL_tmpz00_16601 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16601, BgL_locz00_10727); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12769;
BgL_rz00_12769 = 
PROCEDURE_ENTRY(BgL_fz00_12753)(BgL_fz00_12753, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10730),((long)0),BgL_bpz00_12752); 
return BgL_rz00_12769;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10727, BgL_symbzd2funzd2_10728, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12753));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1934> */
obj_t BGl_z62zc3anonymousza31934ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10731, obj_t BgL_sz00_10736)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10732;obj_t BgL_locz00_10733;obj_t BgL_symbzd2funzd2_10734;long BgL_siza7eza7_10735;
BgL_funz00_10732 = 
PROCEDURE_REF(BgL_envz00_10731, 
(int)(((long)0))); 
BgL_locz00_10733 = 
PROCEDURE_REF(BgL_envz00_10731, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10734 = 
PROCEDURE_REF(BgL_envz00_10731, 
(int)(((long)2))); 
BgL_siza7eza7_10735 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10731, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12770;
BgL_bpz00_12770 = 
VECTOR_REF(
((obj_t)BgL_sz00_10736),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12771;
BgL_fz00_12771 = 
PROCEDURE_ENTRY(BgL_funz00_10732)(BgL_funz00_10732, BgL_sz00_10736, BEOA); 
if(
PROCEDUREP(BgL_fz00_12771))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10733, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12771); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12772;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16630;
BgL_tmpz00_16630 = 
((obj_t)BgL_fz00_12771); 
BgL_ufz00_12772 = 
PROCEDURE_ATTR(BgL_tmpz00_16630); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16633;
if(
STRUCTP(BgL_ufz00_12772))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16633 = 
(
STRUCT_KEY(BgL_ufz00_12772)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16633 = ((bool_t)0)
; } 
if(BgL_testz00_16633)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12773;obj_t BgL_runz00_12774;obj_t BgL_sfz00_12775;
BgL_arityz00_12773 = 
STRUCT_REF(BgL_ufz00_12772, 
(int)(((long)0))); 
BgL_runz00_12774 = 
STRUCT_REF(BgL_ufz00_12772, 
(int)(((long)1))); 
BgL_sfz00_12775 = 
STRUCT_REF(BgL_ufz00_12772, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_12776;
BgL_spz00_12776 = 
(
(long)CINT(BgL_bpz00_12770)+BgL_siza7eza7_10735); 
if(
(
(long)CINT(BgL_arityz00_12773)==((long)0)))
{ /* Eval/evaluate_comp.scm 889 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12773))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12773)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1939z00_12779;obj_t BgL_arg1940z00_12780;
BgL_arg1939z00_12779 = 
(BgL_spz00_12776+((long)0)); 
BgL_arg1940z00_12780 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10736),BgL_arg1939z00_12779,BgL_arg1940z00_12780); } break;
default: 
BgL_case_else1175z00_12777:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg1942z00_12778;
BgL_arg1942z00_12778 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12772), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10733, BgL_arg1942z00_12778, 
(int)(((long)0)), 
CINT(BgL_arityz00_12773)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1175z00_12777;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12781;
BgL_z12denvz12_12781 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10736, 
BINT(BgL_spz00_12776), BgL_sfz00_12775))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12774, BgL_sz00_10736, 
BINT(BgL_spz00_12776));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12782;
BgL_nsz00_12782 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1944z00_12783;
BgL_arg1944z00_12783 = 
(BgL_spz00_12776+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12782, ((long)2), BgL_sz00_10736, 
BINT(BgL_spz00_12776), 
BINT(BgL_arg1944z00_12783)); } 
VECTOR_SET(BgL_nsz00_12782,((long)1),BgL_sz00_10736); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12781, BgL_nsz00_12782); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12784;
BgL_ez00_12784 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12784, BgL_sz00_10736); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12785;
BgL_____rz00_12785 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12774, BgL_nsz00_12782, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12784); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12781, BgL_sz00_10736); 
return BgL_____rz00_12785;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12771, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12786;
BgL_nbpz00_12786 = 
(
(long)CINT(BgL_bpz00_12770)+BgL_siza7eza7_10735); 
VECTOR_SET(
((obj_t)BgL_sz00_10736),((long)0),
BINT(BgL_nbpz00_12786)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12787;
BgL_rz00_12787 = 
PROCEDURE_ENTRY(BgL_fz00_12771)(BgL_fz00_12771, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10736),((long)0),BgL_bpz00_12770); 
return BgL_rz00_12787;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10733, BgL_symbzd2funzd2_10734, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12771));} } } } } } } } 
BGL_FUNCTION_END;
}



/* comp-call1 */
obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145, BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147, obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150, long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_cfunz00_2109;
BgL_cfunz00_2109 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146, ((long)1), BgL_locz00_145, BgL_symbzd2funzd2_147); 
if(
CBOOL(BgL_cfunz00_2109))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16700;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg1953z00_2125;
BgL_arg1953z00_2125 = 
bgl_debug(); 
BgL_testz00_16700 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1953z00_2125), 
BINT(((long)0))); } 
if(BgL_testz00_16700)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31950ze3z83_10737;
BgL_zc3anonymousza31950ze3z83_10737 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31950ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza31950ze3z83_10737, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3anonymousza31950ze3z83_10737, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3anonymousza31950ze3z83_10737, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3anonymousza31950ze3z83_10737, 
(int)(((long)3)), BgL_cfunz00_2109); 
return BgL_zc3anonymousza31950ze3z83_10737;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31952ze3z83_10738;
BgL_zc3anonymousza31952ze3z83_10738 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_10738, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_10738, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_10738, 
(int)(((long)2)), BgL_cfunz00_2109); 
return BgL_zc3anonymousza31952ze3z83_10738;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
CBOOL(BgL_tailzf3zf3_149))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16729;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg1993z00_2201;
BgL_arg1993z00_2201 = 
bgl_debug(); 
BgL_testz00_16729 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1993z00_2201), 
BINT(((long)0))); } 
if(BgL_testz00_16729)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31956ze3z83_10739;
BgL_zc3anonymousza31956ze3z83_10739 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31956ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza31956ze3z83_10739, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3anonymousza31956ze3z83_10739, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3anonymousza31956ze3z83_10739, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3anonymousza31956ze3z83_10739, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3anonymousza31956ze3z83_10739, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3anonymousza31956ze3z83_10739;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31975ze3z83_10740;
BgL_zc3anonymousza31975ze3z83_10740 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza31975ze3z83_10740, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3anonymousza31975ze3z83_10740, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3anonymousza31975ze3z83_10740, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3anonymousza31975ze3z83_10740, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3anonymousza31975ze3z83_10740, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3anonymousza31975ze3z83_10740;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16762;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2033z00_2277;
BgL_arg2033z00_2277 = 
bgl_debug(); 
BgL_testz00_16762 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2033z00_2277), 
BINT(((long)0))); } 
if(BgL_testz00_16762)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza31996ze3z83_10741;
BgL_zc3anonymousza31996ze3z83_10741 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31996ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza31996ze3z83_10741, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3anonymousza31996ze3z83_10741, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3anonymousza31996ze3z83_10741, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3anonymousza31996ze3z83_10741, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3anonymousza31996ze3z83_10741, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3anonymousza31996ze3z83_10741;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32015ze3z83_10742;
BgL_zc3anonymousza32015ze3z83_10742 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32015ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_10742, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_10742, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_10742, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_10742, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_10742, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3anonymousza32015ze3z83_10742;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1950> */
obj_t BGl_z62zc3anonymousza31950ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10743, obj_t BgL_sz00_10748)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10744;long BgL_siza7eza7_10745;obj_t BgL_locz00_10746;obj_t BgL_cfunz00_10747;
BgL_a1z00_10744 = 
PROCEDURE_REF(BgL_envz00_10743, 
(int)(((long)0))); 
BgL_siza7eza7_10745 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10743, 
(int)(((long)1)))); 
BgL_locz00_10746 = 
PROCEDURE_REF(BgL_envz00_10743, 
(int)(((long)2))); 
BgL_cfunz00_10747 = 
PROCEDURE_REF(BgL_envz00_10743, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12788;
BgL_bpz00_12788 = 
VECTOR_REF(
((obj_t)BgL_sz00_10748),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_12789;
BgL_a1z00_12789 = 
PROCEDURE_ENTRY(BgL_a1z00_10744)(BgL_a1z00_10744, BgL_sz00_10748, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12790;
BgL_nbpz00_12790 = 
(
(long)CINT(BgL_bpz00_12788)+BgL_siza7eza7_10745); 
VECTOR_SET(
((obj_t)BgL_sz00_10748),((long)0),
BINT(BgL_nbpz00_12790)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16815;
BgL_tmpz00_16815 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16815, BgL_locz00_10746); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12791;
BgL_rz00_12791 = 
PROCEDURE_ENTRY(BgL_cfunz00_10747)(BgL_cfunz00_10747, BgL_a1z00_12789, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10748),((long)0),BgL_bpz00_12788); 
return BgL_rz00_12791;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1952> */
obj_t BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10749, obj_t BgL_sz00_10753)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10750;long BgL_siza7eza7_10751;obj_t BgL_cfunz00_10752;
BgL_a1z00_10750 = 
PROCEDURE_REF(BgL_envz00_10749, 
(int)(((long)0))); 
BgL_siza7eza7_10751 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10749, 
(int)(((long)1)))); 
BgL_cfunz00_10752 = 
PROCEDURE_REF(BgL_envz00_10749, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12792;
BgL_bpz00_12792 = 
VECTOR_REF(
((obj_t)BgL_sz00_10753),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_12793;
BgL_a1z00_12793 = 
PROCEDURE_ENTRY(BgL_a1z00_10750)(BgL_a1z00_10750, BgL_sz00_10753, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12794;
BgL_nbpz00_12794 = 
(
(long)CINT(BgL_bpz00_12792)+BgL_siza7eza7_10751); 
VECTOR_SET(
((obj_t)BgL_sz00_10753),((long)0),
BINT(BgL_nbpz00_12794)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12795;
BgL_rz00_12795 = 
PROCEDURE_ENTRY(BgL_cfunz00_10752)(BgL_cfunz00_10752, BgL_a1z00_12793, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10753),((long)0),BgL_bpz00_12792); 
return BgL_rz00_12795;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1956> */
obj_t BGl_z62zc3anonymousza31956ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10754, obj_t BgL_sz00_10760)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10755;obj_t BgL_a1z00_10756;obj_t BgL_locz00_10757;obj_t BgL_symbzd2funzd2_10758;long BgL_siza7eza7_10759;
BgL_funz00_10755 = 
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)0))); 
BgL_a1z00_10756 = 
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)1))); 
BgL_locz00_10757 = 
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10758 = 
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)3))); 
BgL_siza7eza7_10759 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10754, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12796;
BgL_bpz00_12796 = 
VECTOR_REF(
((obj_t)BgL_sz00_10760),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12797;obj_t BgL_a1z00_12798;
BgL_fz00_12797 = 
PROCEDURE_ENTRY(BgL_funz00_10755)(BgL_funz00_10755, BgL_sz00_10760, BEOA); 
BgL_a1z00_12798 = 
PROCEDURE_ENTRY(BgL_a1z00_10756)(BgL_a1z00_10756, BgL_sz00_10760, BEOA); 
if(
PROCEDUREP(BgL_fz00_12797))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10757, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12797); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12799;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16872;
BgL_tmpz00_16872 = 
((obj_t)BgL_fz00_12797); 
BgL_ufz00_12799 = 
PROCEDURE_ATTR(BgL_tmpz00_16872); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16875;
if(
STRUCTP(BgL_ufz00_12799))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16875 = 
(
STRUCT_KEY(BgL_ufz00_12799)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16875 = ((bool_t)0)
; } 
if(BgL_testz00_16875)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12800;obj_t BgL_runz00_12801;obj_t BgL_sfz00_12802;
BgL_arityz00_12800 = 
STRUCT_REF(BgL_ufz00_12799, 
(int)(((long)0))); 
BgL_runz00_12801 = 
STRUCT_REF(BgL_ufz00_12799, 
(int)(((long)1))); 
BgL_sfz00_12802 = 
STRUCT_REF(BgL_ufz00_12799, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12800)==((long)1)))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1960z00_12803;
BgL_arg1960z00_12803 = 
(
(long)CINT(BgL_bpz00_12796)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10760),BgL_arg1960z00_12803,BgL_a1z00_12798); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12800))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12800)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1962z00_12806;obj_t BgL_arg1963z00_12807;
BgL_arg1962z00_12806 = 
(
(long)CINT(BgL_bpz00_12796)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list1964z00_12808;
BgL_list1964z00_12808 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12798, BNIL); 
BgL_arg1963z00_12807 = BgL_list1964z00_12808; } 
VECTOR_SET(
((obj_t)BgL_sz00_10760),BgL_arg1962z00_12806,BgL_arg1963z00_12807); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1965z00_12809;
BgL_arg1965z00_12809 = 
(
(long)CINT(BgL_bpz00_12796)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10760),BgL_arg1965z00_12809,BgL_a1z00_12798); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1966z00_12810;obj_t BgL_arg1967z00_12811;
BgL_arg1966z00_12810 = 
(
(long)CINT(BgL_bpz00_12796)+((long)1)); 
BgL_arg1967z00_12811 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10760),BgL_arg1966z00_12810,BgL_arg1967z00_12811); } break;
default: 
BgL_case_else1177z00_12804:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg1969z00_12805;
BgL_arg1969z00_12805 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12799), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10757, BgL_arg1969z00_12805, 
(int)(((long)1)), 
CINT(BgL_arityz00_12800)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1177z00_12804;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12812;
BgL_z12denvz12_12812 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12812, BgL_locz00_10757); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10760, BgL_bpz00_12796, BgL_sfz00_12802))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_12801;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12813;
BgL_nsz00_12813 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1971z00_12814;
BgL_arg1971z00_12814 = 
(
(long)CINT(BgL_bpz00_12796)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12813, ((long)2), BgL_sz00_10760, BgL_bpz00_12796, 
BINT(BgL_arg1971z00_12814)); } 
VECTOR_SET(BgL_nsz00_12813,((long)1),BgL_sz00_10760); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12812, BgL_nsz00_12813); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12815;
BgL_ez00_12815 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12815, BgL_sz00_10760); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12816;
BgL_____rz00_12816 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12801, BgL_nsz00_12813, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12815); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12812, BgL_sz00_10760); 
return BgL_____rz00_12816;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12797, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12817;
BgL_nbpz00_12817 = 
(
(long)CINT(BgL_bpz00_12796)+BgL_siza7eza7_10759); 
VECTOR_SET(
((obj_t)BgL_sz00_10760),((long)0),
BINT(BgL_nbpz00_12817)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16941;
BgL_tmpz00_16941 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16941, BgL_locz00_10757); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12818;
BgL_rz00_12818 = 
PROCEDURE_ENTRY(BgL_fz00_12797)(BgL_fz00_12797, BgL_a1z00_12798, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10760),((long)0),BgL_bpz00_12796); 
return BgL_rz00_12818;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10757, BgL_symbzd2funzd2_10758, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12797));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1975> */
obj_t BGl_z62zc3anonymousza31975ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10761, obj_t BgL_sz00_10767)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10762;obj_t BgL_a1z00_10763;obj_t BgL_locz00_10764;obj_t BgL_symbzd2funzd2_10765;long BgL_siza7eza7_10766;
BgL_funz00_10762 = 
PROCEDURE_REF(BgL_envz00_10761, 
(int)(((long)0))); 
BgL_a1z00_10763 = 
PROCEDURE_REF(BgL_envz00_10761, 
(int)(((long)1))); 
BgL_locz00_10764 = 
PROCEDURE_REF(BgL_envz00_10761, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10765 = 
PROCEDURE_REF(BgL_envz00_10761, 
(int)(((long)3))); 
BgL_siza7eza7_10766 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10761, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12819;
BgL_bpz00_12819 = 
VECTOR_REF(
((obj_t)BgL_sz00_10767),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12820;obj_t BgL_a1z00_12821;
BgL_fz00_12820 = 
PROCEDURE_ENTRY(BgL_funz00_10762)(BgL_funz00_10762, BgL_sz00_10767, BEOA); 
BgL_a1z00_12821 = 
PROCEDURE_ENTRY(BgL_a1z00_10763)(BgL_a1z00_10763, BgL_sz00_10767, BEOA); 
if(
PROCEDUREP(BgL_fz00_12820))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10764, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12820); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12822;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_16977;
BgL_tmpz00_16977 = 
((obj_t)BgL_fz00_12820); 
BgL_ufz00_12822 = 
PROCEDURE_ATTR(BgL_tmpz00_16977); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_16980;
if(
STRUCTP(BgL_ufz00_12822))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16980 = 
(
STRUCT_KEY(BgL_ufz00_12822)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_16980 = ((bool_t)0)
; } 
if(BgL_testz00_16980)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12823;obj_t BgL_runz00_12824;obj_t BgL_sfz00_12825;
BgL_arityz00_12823 = 
STRUCT_REF(BgL_ufz00_12822, 
(int)(((long)0))); 
BgL_runz00_12824 = 
STRUCT_REF(BgL_ufz00_12822, 
(int)(((long)1))); 
BgL_sfz00_12825 = 
STRUCT_REF(BgL_ufz00_12822, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12823)==((long)1)))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1979z00_12826;
BgL_arg1979z00_12826 = 
(
(long)CINT(BgL_bpz00_12819)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10767),BgL_arg1979z00_12826,BgL_a1z00_12821); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12823))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12823)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1981z00_12829;obj_t BgL_arg1982z00_12830;
BgL_arg1981z00_12829 = 
(
(long)CINT(BgL_bpz00_12819)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list1983z00_12831;
BgL_list1983z00_12831 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12821, BNIL); 
BgL_arg1982z00_12830 = BgL_list1983z00_12831; } 
VECTOR_SET(
((obj_t)BgL_sz00_10767),BgL_arg1981z00_12829,BgL_arg1982z00_12830); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1984z00_12832;
BgL_arg1984z00_12832 = 
(
(long)CINT(BgL_bpz00_12819)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10767),BgL_arg1984z00_12832,BgL_a1z00_12821); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1985z00_12833;obj_t BgL_arg1986z00_12834;
BgL_arg1985z00_12833 = 
(
(long)CINT(BgL_bpz00_12819)+((long)1)); 
BgL_arg1986z00_12834 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10767),BgL_arg1985z00_12833,BgL_arg1986z00_12834); } break;
default: 
BgL_case_else1179z00_12827:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg1988z00_12828;
BgL_arg1988z00_12828 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12822), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10764, BgL_arg1988z00_12828, 
(int)(((long)1)), 
CINT(BgL_arityz00_12823)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1179z00_12827;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12835;
BgL_z12denvz12_12835 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10767, BgL_bpz00_12819, BgL_sfz00_12825))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_12824;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12836;
BgL_nsz00_12836 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg1990z00_12837;
BgL_arg1990z00_12837 = 
(
(long)CINT(BgL_bpz00_12819)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12836, ((long)2), BgL_sz00_10767, BgL_bpz00_12819, 
BINT(BgL_arg1990z00_12837)); } 
VECTOR_SET(BgL_nsz00_12836,((long)1),BgL_sz00_10767); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12835, BgL_nsz00_12836); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12838;
BgL_ez00_12838 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12838, BgL_sz00_10767); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12839;
BgL_____rz00_12839 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12824, BgL_nsz00_12836, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12838); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12835, BgL_sz00_10767); 
return BgL_____rz00_12839;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12820, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12840;
BgL_nbpz00_12840 = 
(
(long)CINT(BgL_bpz00_12819)+BgL_siza7eza7_10766); 
VECTOR_SET(
((obj_t)BgL_sz00_10767),((long)0),
BINT(BgL_nbpz00_12840)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12841;
BgL_rz00_12841 = 
PROCEDURE_ENTRY(BgL_fz00_12820)(BgL_fz00_12820, BgL_a1z00_12821, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10767),((long)0),BgL_bpz00_12819); 
return BgL_rz00_12841;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10764, BgL_symbzd2funzd2_10765, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12820));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1996> */
obj_t BGl_z62zc3anonymousza31996ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10768, obj_t BgL_sz00_10774)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10769;obj_t BgL_a1z00_10770;obj_t BgL_locz00_10771;obj_t BgL_symbzd2funzd2_10772;long BgL_siza7eza7_10773;
BgL_funz00_10769 = 
PROCEDURE_REF(BgL_envz00_10768, 
(int)(((long)0))); 
BgL_a1z00_10770 = 
PROCEDURE_REF(BgL_envz00_10768, 
(int)(((long)1))); 
BgL_locz00_10771 = 
PROCEDURE_REF(BgL_envz00_10768, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10772 = 
PROCEDURE_REF(BgL_envz00_10768, 
(int)(((long)3))); 
BgL_siza7eza7_10773 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10768, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12842;
BgL_bpz00_12842 = 
VECTOR_REF(
((obj_t)BgL_sz00_10774),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12843;obj_t BgL_a1z00_12844;
BgL_fz00_12843 = 
PROCEDURE_ENTRY(BgL_funz00_10769)(BgL_funz00_10769, BgL_sz00_10774, BEOA); 
BgL_a1z00_12844 = 
PROCEDURE_ENTRY(BgL_a1z00_10770)(BgL_a1z00_10770, BgL_sz00_10774, BEOA); 
if(
PROCEDUREP(BgL_fz00_12843))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10771, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12843); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12845;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17078;
BgL_tmpz00_17078 = 
((obj_t)BgL_fz00_12843); 
BgL_ufz00_12845 = 
PROCEDURE_ATTR(BgL_tmpz00_17078); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17081;
if(
STRUCTP(BgL_ufz00_12845))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17081 = 
(
STRUCT_KEY(BgL_ufz00_12845)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17081 = ((bool_t)0)
; } 
if(BgL_testz00_17081)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12846;obj_t BgL_runz00_12847;obj_t BgL_sfz00_12848;
BgL_arityz00_12846 = 
STRUCT_REF(BgL_ufz00_12845, 
(int)(((long)0))); 
BgL_runz00_12847 = 
STRUCT_REF(BgL_ufz00_12845, 
(int)(((long)1))); 
BgL_sfz00_12848 = 
STRUCT_REF(BgL_ufz00_12845, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_12849;
BgL_spz00_12849 = 
(
(long)CINT(BgL_bpz00_12842)+BgL_siza7eza7_10773); 
if(
(
(long)CINT(BgL_arityz00_12846)==((long)1)))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2000z00_12850;
BgL_arg2000z00_12850 = 
(BgL_spz00_12849+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10774),BgL_arg2000z00_12850,BgL_a1z00_12844); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12846))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12846)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2002z00_12853;obj_t BgL_arg2003z00_12854;
BgL_arg2002z00_12853 = 
(BgL_spz00_12849+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2004z00_12855;
BgL_list2004z00_12855 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12844, BNIL); 
BgL_arg2003z00_12854 = BgL_list2004z00_12855; } 
VECTOR_SET(
((obj_t)BgL_sz00_10774),BgL_arg2002z00_12853,BgL_arg2003z00_12854); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2005z00_12856;
BgL_arg2005z00_12856 = 
(BgL_spz00_12849+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10774),BgL_arg2005z00_12856,BgL_a1z00_12844); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2006z00_12857;obj_t BgL_arg2007z00_12858;
BgL_arg2006z00_12857 = 
(BgL_spz00_12849+((long)1)); 
BgL_arg2007z00_12858 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10774),BgL_arg2006z00_12857,BgL_arg2007z00_12858); } break;
default: 
BgL_case_else1181z00_12851:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2009z00_12852;
BgL_arg2009z00_12852 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12845), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10771, BgL_arg2009z00_12852, 
(int)(((long)1)), 
CINT(BgL_arityz00_12846)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1181z00_12851;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12859;
BgL_z12denvz12_12859 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12859, BgL_locz00_10771); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10774, 
BINT(BgL_spz00_12849), BgL_sfz00_12848))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12847, BgL_sz00_10774, 
BINT(BgL_spz00_12849));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12860;
BgL_nsz00_12860 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2011z00_12861;
BgL_arg2011z00_12861 = 
(BgL_spz00_12849+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12860, ((long)2), BgL_sz00_10774, 
BINT(BgL_spz00_12849), 
BINT(BgL_arg2011z00_12861)); } 
VECTOR_SET(BgL_nsz00_12860,((long)1),BgL_sz00_10774); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12859, BgL_nsz00_12860); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12862;
BgL_ez00_12862 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12862, BgL_sz00_10774); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12863;
BgL_____rz00_12863 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12847, BgL_nsz00_12860, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12862); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12859, BgL_sz00_10774); 
return BgL_____rz00_12863;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12843, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12864;
BgL_nbpz00_12864 = 
(
(long)CINT(BgL_bpz00_12842)+BgL_siza7eza7_10773); 
VECTOR_SET(
((obj_t)BgL_sz00_10774),((long)0),
BINT(BgL_nbpz00_12864)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17148;
BgL_tmpz00_17148 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17148, BgL_locz00_10771); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12865;
BgL_rz00_12865 = 
PROCEDURE_ENTRY(BgL_fz00_12843)(BgL_fz00_12843, BgL_a1z00_12844, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10774),((long)0),BgL_bpz00_12842); 
return BgL_rz00_12865;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10771, BgL_symbzd2funzd2_10772, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12843));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2015> */
obj_t BGl_z62zc3anonymousza32015ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10775, obj_t BgL_sz00_10781)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10776;obj_t BgL_a1z00_10777;obj_t BgL_locz00_10778;obj_t BgL_symbzd2funzd2_10779;long BgL_siza7eza7_10780;
BgL_funz00_10776 = 
PROCEDURE_REF(BgL_envz00_10775, 
(int)(((long)0))); 
BgL_a1z00_10777 = 
PROCEDURE_REF(BgL_envz00_10775, 
(int)(((long)1))); 
BgL_locz00_10778 = 
PROCEDURE_REF(BgL_envz00_10775, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10779 = 
PROCEDURE_REF(BgL_envz00_10775, 
(int)(((long)3))); 
BgL_siza7eza7_10780 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10775, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12866;
BgL_bpz00_12866 = 
VECTOR_REF(
((obj_t)BgL_sz00_10781),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12867;obj_t BgL_a1z00_12868;
BgL_fz00_12867 = 
PROCEDURE_ENTRY(BgL_funz00_10776)(BgL_funz00_10776, BgL_sz00_10781, BEOA); 
BgL_a1z00_12868 = 
PROCEDURE_ENTRY(BgL_a1z00_10777)(BgL_a1z00_10777, BgL_sz00_10781, BEOA); 
if(
PROCEDUREP(BgL_fz00_12867))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10778, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12867); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12869;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17184;
BgL_tmpz00_17184 = 
((obj_t)BgL_fz00_12867); 
BgL_ufz00_12869 = 
PROCEDURE_ATTR(BgL_tmpz00_17184); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17187;
if(
STRUCTP(BgL_ufz00_12869))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17187 = 
(
STRUCT_KEY(BgL_ufz00_12869)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17187 = ((bool_t)0)
; } 
if(BgL_testz00_17187)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12870;obj_t BgL_runz00_12871;obj_t BgL_sfz00_12872;
BgL_arityz00_12870 = 
STRUCT_REF(BgL_ufz00_12869, 
(int)(((long)0))); 
BgL_runz00_12871 = 
STRUCT_REF(BgL_ufz00_12869, 
(int)(((long)1))); 
BgL_sfz00_12872 = 
STRUCT_REF(BgL_ufz00_12869, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_12873;
BgL_spz00_12873 = 
(
(long)CINT(BgL_bpz00_12866)+BgL_siza7eza7_10780); 
if(
(
(long)CINT(BgL_arityz00_12870)==((long)1)))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2019z00_12874;
BgL_arg2019z00_12874 = 
(BgL_spz00_12873+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10781),BgL_arg2019z00_12874,BgL_a1z00_12868); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12870))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12870)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2021z00_12877;obj_t BgL_arg2022z00_12878;
BgL_arg2021z00_12877 = 
(BgL_spz00_12873+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2023z00_12879;
BgL_list2023z00_12879 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12868, BNIL); 
BgL_arg2022z00_12878 = BgL_list2023z00_12879; } 
VECTOR_SET(
((obj_t)BgL_sz00_10781),BgL_arg2021z00_12877,BgL_arg2022z00_12878); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2024z00_12880;
BgL_arg2024z00_12880 = 
(BgL_spz00_12873+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10781),BgL_arg2024z00_12880,BgL_a1z00_12868); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2025z00_12881;obj_t BgL_arg2026z00_12882;
BgL_arg2025z00_12881 = 
(BgL_spz00_12873+((long)1)); 
BgL_arg2026z00_12882 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10781),BgL_arg2025z00_12881,BgL_arg2026z00_12882); } break;
default: 
BgL_case_else1183z00_12875:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2028z00_12876;
BgL_arg2028z00_12876 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12869), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10778, BgL_arg2028z00_12876, 
(int)(((long)1)), 
CINT(BgL_arityz00_12870)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1183z00_12875;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12883;
BgL_z12denvz12_12883 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10781, 
BINT(BgL_spz00_12873), BgL_sfz00_12872))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12871, BgL_sz00_10781, 
BINT(BgL_spz00_12873));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12884;
BgL_nsz00_12884 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2030z00_12885;
BgL_arg2030z00_12885 = 
(BgL_spz00_12873+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12884, ((long)2), BgL_sz00_10781, 
BINT(BgL_spz00_12873), 
BINT(BgL_arg2030z00_12885)); } 
VECTOR_SET(BgL_nsz00_12884,((long)1),BgL_sz00_10781); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12883, BgL_nsz00_12884); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12886;
BgL_ez00_12886 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12886, BgL_sz00_10781); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12887;
BgL_____rz00_12887 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12871, BgL_nsz00_12884, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12886); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12883, BgL_sz00_10781); 
return BgL_____rz00_12887;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12867, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12888;
BgL_nbpz00_12888 = 
(
(long)CINT(BgL_bpz00_12866)+BgL_siza7eza7_10780); 
VECTOR_SET(
((obj_t)BgL_sz00_10781),((long)0),
BINT(BgL_nbpz00_12888)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12889;
BgL_rz00_12889 = 
PROCEDURE_ENTRY(BgL_fz00_12867)(BgL_fz00_12867, BgL_a1z00_12868, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10781),((long)0),BgL_bpz00_12866); 
return BgL_rz00_12889;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10778, BgL_symbzd2funzd2_10779, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12867));} } } } } } } } 
BGL_FUNCTION_END;
}



/* comp-call2 */
obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153, BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155, obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158, long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_cfunz00_2278;
BgL_cfunz00_2278 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154, ((long)2), BgL_locz00_153, BgL_symbzd2funzd2_155); 
if(
CBOOL(BgL_cfunz00_2278))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17265;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2039z00_2296;
BgL_arg2039z00_2296 = 
bgl_debug(); 
BgL_testz00_17265 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2039z00_2296), 
BINT(((long)0))); } 
if(BgL_testz00_17265)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32036ze3z83_10782;
BgL_zc3anonymousza32036ze3z83_10782 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32036ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza32036ze3z83_10782, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3anonymousza32036ze3z83_10782, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3anonymousza32036ze3z83_10782, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3anonymousza32036ze3z83_10782, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3anonymousza32036ze3z83_10782, 
(int)(((long)4)), BgL_cfunz00_2278); 
return BgL_zc3anonymousza32036ze3z83_10782;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32038ze3z83_10783;
BgL_zc3anonymousza32038ze3z83_10783 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32038ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza32038ze3z83_10783, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3anonymousza32038ze3z83_10783, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3anonymousza32038ze3z83_10783, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3anonymousza32038ze3z83_10783, 
(int)(((long)3)), BgL_cfunz00_2278); 
return BgL_zc3anonymousza32038ze3z83_10783;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
CBOOL(BgL_tailzf3zf3_157))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17298;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2093z00_2388;
BgL_arg2093z00_2388 = 
bgl_debug(); 
BgL_testz00_17298 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2093z00_2388), 
BINT(((long)0))); } 
if(BgL_testz00_17298)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32042ze3z83_10784;
BgL_zc3anonymousza32042ze3z83_10784 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_10784, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_10784, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_10784, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_10784, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_10784, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3anonymousza32042ze3z83_10784, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3anonymousza32042ze3z83_10784;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32068ze3z83_10785;
BgL_zc3anonymousza32068ze3z83_10785 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32068ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza32068ze3z83_10785, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3anonymousza32068ze3z83_10785, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3anonymousza32068ze3z83_10785, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3anonymousza32068ze3z83_10785, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3anonymousza32068ze3z83_10785, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3anonymousza32068ze3z83_10785, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3anonymousza32068ze3z83_10785;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17335;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2147z00_2480;
BgL_arg2147z00_2480 = 
bgl_debug(); 
BgL_testz00_17335 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2147z00_2480), 
BINT(((long)0))); } 
if(BgL_testz00_17335)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32096ze3z83_10786;
BgL_zc3anonymousza32096ze3z83_10786 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32096ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_10786, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_10786, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_10786, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_10786, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_10786, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_10786, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3anonymousza32096ze3z83_10786;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32122ze3z83_10787;
BgL_zc3anonymousza32122ze3z83_10787 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32122ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_10787, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_10787, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_10787, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_10787, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_10787, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_10787, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3anonymousza32122ze3z83_10787;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2036> */
obj_t BGl_z62zc3anonymousza32036ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10788, obj_t BgL_sz00_10794)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10789;obj_t BgL_a2z00_10790;long BgL_siza7eza7_10791;obj_t BgL_locz00_10792;obj_t BgL_cfunz00_10793;
BgL_a1z00_10789 = 
PROCEDURE_REF(BgL_envz00_10788, 
(int)(((long)0))); 
BgL_a2z00_10790 = 
PROCEDURE_REF(BgL_envz00_10788, 
(int)(((long)1))); 
BgL_siza7eza7_10791 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10788, 
(int)(((long)2)))); 
BgL_locz00_10792 = 
PROCEDURE_REF(BgL_envz00_10788, 
(int)(((long)3))); 
BgL_cfunz00_10793 = 
PROCEDURE_REF(BgL_envz00_10788, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12890;
BgL_bpz00_12890 = 
VECTOR_REF(
((obj_t)BgL_sz00_10794),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_12891;obj_t BgL_a2z00_12892;
BgL_a1z00_12891 = 
PROCEDURE_ENTRY(BgL_a1z00_10789)(BgL_a1z00_10789, BgL_sz00_10794, BEOA); 
BgL_a2z00_12892 = 
PROCEDURE_ENTRY(BgL_a2z00_10790)(BgL_a2z00_10790, BgL_sz00_10794, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12893;
BgL_nbpz00_12893 = 
(
(long)CINT(BgL_bpz00_12890)+BgL_siza7eza7_10791); 
VECTOR_SET(
((obj_t)BgL_sz00_10794),((long)0),
BINT(BgL_nbpz00_12893)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17398;
BgL_tmpz00_17398 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17398, BgL_locz00_10792); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12894;
BgL_rz00_12894 = 
PROCEDURE_ENTRY(BgL_cfunz00_10793)(BgL_cfunz00_10793, BgL_a1z00_12891, BgL_a2z00_12892, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10794),((long)0),BgL_bpz00_12890); 
return BgL_rz00_12894;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2038> */
obj_t BGl_z62zc3anonymousza32038ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10795, obj_t BgL_sz00_10800)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10796;obj_t BgL_a2z00_10797;long BgL_siza7eza7_10798;obj_t BgL_cfunz00_10799;
BgL_a1z00_10796 = 
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)0))); 
BgL_a2z00_10797 = 
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)1))); 
BgL_siza7eza7_10798 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)2)))); 
BgL_cfunz00_10799 = 
PROCEDURE_REF(BgL_envz00_10795, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12895;
BgL_bpz00_12895 = 
VECTOR_REF(
((obj_t)BgL_sz00_10800),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_12896;obj_t BgL_a2z00_12897;
BgL_a1z00_12896 = 
PROCEDURE_ENTRY(BgL_a1z00_10796)(BgL_a1z00_10796, BgL_sz00_10800, BEOA); 
BgL_a2z00_12897 = 
PROCEDURE_ENTRY(BgL_a2z00_10797)(BgL_a2z00_10797, BgL_sz00_10800, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12898;
BgL_nbpz00_12898 = 
(
(long)CINT(BgL_bpz00_12895)+BgL_siza7eza7_10798); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),((long)0),
BINT(BgL_nbpz00_12898)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12899;
BgL_rz00_12899 = 
PROCEDURE_ENTRY(BgL_cfunz00_10799)(BgL_cfunz00_10799, BgL_a1z00_12896, BgL_a2z00_12897, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10800),((long)0),BgL_bpz00_12895); 
return BgL_rz00_12899;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2042> */
obj_t BGl_z62zc3anonymousza32042ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10801, obj_t BgL_sz00_10808)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10802;obj_t BgL_a1z00_10803;obj_t BgL_a2z00_10804;obj_t BgL_locz00_10805;obj_t BgL_symbzd2funzd2_10806;long BgL_siza7eza7_10807;
BgL_funz00_10802 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)0))); 
BgL_a1z00_10803 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)1))); 
BgL_a2z00_10804 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)2))); 
BgL_locz00_10805 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10806 = 
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)4))); 
BgL_siza7eza7_10807 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10801, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12900;
BgL_bpz00_12900 = 
VECTOR_REF(
((obj_t)BgL_sz00_10808),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12901;obj_t BgL_a1z00_12902;obj_t BgL_a2z00_12903;
BgL_fz00_12901 = 
PROCEDURE_ENTRY(BgL_funz00_10802)(BgL_funz00_10802, BgL_sz00_10808, BEOA); 
BgL_a1z00_12902 = 
PROCEDURE_ENTRY(BgL_a1z00_10803)(BgL_a1z00_10803, BgL_sz00_10808, BEOA); 
BgL_a2z00_12903 = 
PROCEDURE_ENTRY(BgL_a2z00_10804)(BgL_a2z00_10804, BgL_sz00_10808, BEOA); 
if(
PROCEDUREP(BgL_fz00_12901))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10805, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12901); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12904;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17469;
BgL_tmpz00_17469 = 
((obj_t)BgL_fz00_12901); 
BgL_ufz00_12904 = 
PROCEDURE_ATTR(BgL_tmpz00_17469); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17472;
if(
STRUCTP(BgL_ufz00_12904))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17472 = 
(
STRUCT_KEY(BgL_ufz00_12904)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17472 = ((bool_t)0)
; } 
if(BgL_testz00_17472)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12905;obj_t BgL_runz00_12906;obj_t BgL_sfz00_12907;
BgL_arityz00_12905 = 
STRUCT_REF(BgL_ufz00_12904, 
(int)(((long)0))); 
BgL_runz00_12906 = 
STRUCT_REF(BgL_ufz00_12904, 
(int)(((long)1))); 
BgL_sfz00_12907 = 
STRUCT_REF(BgL_ufz00_12904, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12905)==((long)2)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2046z00_12908;
BgL_arg2046z00_12908 = 
(
(long)CINT(BgL_bpz00_12900)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2046z00_12908,BgL_a1z00_12902); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2047z00_12909;
BgL_arg2047z00_12909 = 
(
(long)CINT(BgL_bpz00_12900)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2047z00_12909,BgL_a2z00_12903); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12905))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12905)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2049z00_12912;obj_t BgL_arg2050z00_12913;
BgL_arg2049z00_12912 = 
(
(long)CINT(BgL_bpz00_12900)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2051z00_12914;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2052z00_12915;
BgL_arg2052z00_12915 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12903, BNIL); 
BgL_list2051z00_12914 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12902, BgL_arg2052z00_12915); } 
BgL_arg2050z00_12913 = BgL_list2051z00_12914; } 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2049z00_12912,BgL_arg2050z00_12913); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2053z00_12916;
BgL_arg2053z00_12916 = 
(
(long)CINT(BgL_bpz00_12900)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2053z00_12916,BgL_a1z00_12902); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2054z00_12917;obj_t BgL_arg2055z00_12918;
BgL_arg2054z00_12917 = 
(
(long)CINT(BgL_bpz00_12900)+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2056z00_12919;
BgL_list2056z00_12919 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12903, BNIL); 
BgL_arg2055z00_12918 = BgL_list2056z00_12919; } 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2054z00_12917,BgL_arg2055z00_12918); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2057z00_12920;
BgL_arg2057z00_12920 = 
(
(long)CINT(BgL_bpz00_12900)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2057z00_12920,BgL_a1z00_12902); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2058z00_12921;
BgL_arg2058z00_12921 = 
(
(long)CINT(BgL_bpz00_12900)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2058z00_12921,BgL_a2z00_12903); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2059z00_12922;obj_t BgL_arg2060z00_12923;
BgL_arg2059z00_12922 = 
(
(long)CINT(BgL_bpz00_12900)+((long)2)); 
BgL_arg2060z00_12923 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10808),BgL_arg2059z00_12922,BgL_arg2060z00_12923); } break;
default: 
BgL_case_else1185z00_12910:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2062z00_12911;
BgL_arg2062z00_12911 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12904), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10805, BgL_arg2062z00_12911, 
(int)(((long)2)), 
CINT(BgL_arityz00_12905)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1185z00_12910;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12924;
BgL_z12denvz12_12924 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12924, BgL_locz00_10805); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10808, BgL_bpz00_12900, BgL_sfz00_12907))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_12906;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12925;
BgL_nsz00_12925 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2064z00_12926;
BgL_arg2064z00_12926 = 
(
(long)CINT(BgL_bpz00_12900)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12925, ((long)2), BgL_sz00_10808, BgL_bpz00_12900, 
BINT(BgL_arg2064z00_12926)); } 
VECTOR_SET(BgL_nsz00_12925,((long)1),BgL_sz00_10808); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12924, BgL_nsz00_12925); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12927;
BgL_ez00_12927 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12927, BgL_sz00_10808); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12928;
BgL_____rz00_12928 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12906, BgL_nsz00_12925, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12927); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12924, BgL_sz00_10808); 
return BgL_____rz00_12928;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12901, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12929;
BgL_nbpz00_12929 = 
(
(long)CINT(BgL_bpz00_12900)+BgL_siza7eza7_10807); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),((long)0),
BINT(BgL_nbpz00_12929)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17556;
BgL_tmpz00_17556 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17556, BgL_locz00_10805); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12930;
BgL_rz00_12930 = 
PROCEDURE_ENTRY(BgL_fz00_12901)(BgL_fz00_12901, BgL_a1z00_12902, BgL_a2z00_12903, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10808),((long)0),BgL_bpz00_12900); 
return BgL_rz00_12930;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10805, BgL_symbzd2funzd2_10806, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12901));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2068> */
obj_t BGl_z62zc3anonymousza32068ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10809, obj_t BgL_sz00_10816)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10810;obj_t BgL_a1z00_10811;obj_t BgL_a2z00_10812;obj_t BgL_locz00_10813;obj_t BgL_symbzd2funzd2_10814;long BgL_siza7eza7_10815;
BgL_funz00_10810 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)0))); 
BgL_a1z00_10811 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)1))); 
BgL_a2z00_10812 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)2))); 
BgL_locz00_10813 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10814 = 
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)4))); 
BgL_siza7eza7_10815 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10809, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12931;
BgL_bpz00_12931 = 
VECTOR_REF(
((obj_t)BgL_sz00_10816),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12932;obj_t BgL_a1z00_12933;obj_t BgL_a2z00_12934;
BgL_fz00_12932 = 
PROCEDURE_ENTRY(BgL_funz00_10810)(BgL_funz00_10810, BgL_sz00_10816, BEOA); 
BgL_a1z00_12933 = 
PROCEDURE_ENTRY(BgL_a1z00_10811)(BgL_a1z00_10811, BgL_sz00_10816, BEOA); 
BgL_a2z00_12934 = 
PROCEDURE_ENTRY(BgL_a2z00_10812)(BgL_a2z00_10812, BgL_sz00_10816, BEOA); 
if(
PROCEDUREP(BgL_fz00_12932))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10813, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12932); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12935;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17599;
BgL_tmpz00_17599 = 
((obj_t)BgL_fz00_12932); 
BgL_ufz00_12935 = 
PROCEDURE_ATTR(BgL_tmpz00_17599); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17602;
if(
STRUCTP(BgL_ufz00_12935))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17602 = 
(
STRUCT_KEY(BgL_ufz00_12935)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17602 = ((bool_t)0)
; } 
if(BgL_testz00_17602)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12936;obj_t BgL_runz00_12937;obj_t BgL_sfz00_12938;
BgL_arityz00_12936 = 
STRUCT_REF(BgL_ufz00_12935, 
(int)(((long)0))); 
BgL_runz00_12937 = 
STRUCT_REF(BgL_ufz00_12935, 
(int)(((long)1))); 
BgL_sfz00_12938 = 
STRUCT_REF(BgL_ufz00_12935, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12936)==((long)2)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2072z00_12939;
BgL_arg2072z00_12939 = 
(
(long)CINT(BgL_bpz00_12931)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2072z00_12939,BgL_a1z00_12933); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2073z00_12940;
BgL_arg2073z00_12940 = 
(
(long)CINT(BgL_bpz00_12931)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2073z00_12940,BgL_a2z00_12934); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12936))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12936)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2075z00_12943;obj_t BgL_arg2076z00_12944;
BgL_arg2075z00_12943 = 
(
(long)CINT(BgL_bpz00_12931)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2077z00_12945;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2078z00_12946;
BgL_arg2078z00_12946 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12934, BNIL); 
BgL_list2077z00_12945 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12933, BgL_arg2078z00_12946); } 
BgL_arg2076z00_12944 = BgL_list2077z00_12945; } 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2075z00_12943,BgL_arg2076z00_12944); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2079z00_12947;
BgL_arg2079z00_12947 = 
(
(long)CINT(BgL_bpz00_12931)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2079z00_12947,BgL_a1z00_12933); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2080z00_12948;obj_t BgL_arg2081z00_12949;
BgL_arg2080z00_12948 = 
(
(long)CINT(BgL_bpz00_12931)+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2082z00_12950;
BgL_list2082z00_12950 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12934, BNIL); 
BgL_arg2081z00_12949 = BgL_list2082z00_12950; } 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2080z00_12948,BgL_arg2081z00_12949); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2083z00_12951;
BgL_arg2083z00_12951 = 
(
(long)CINT(BgL_bpz00_12931)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2083z00_12951,BgL_a1z00_12933); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2084z00_12952;
BgL_arg2084z00_12952 = 
(
(long)CINT(BgL_bpz00_12931)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2084z00_12952,BgL_a2z00_12934); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2085z00_12953;obj_t BgL_arg2086z00_12954;
BgL_arg2085z00_12953 = 
(
(long)CINT(BgL_bpz00_12931)+((long)2)); 
BgL_arg2086z00_12954 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10816),BgL_arg2085z00_12953,BgL_arg2086z00_12954); } break;
default: 
BgL_case_else1187z00_12941:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2088z00_12942;
BgL_arg2088z00_12942 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12935), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10813, BgL_arg2088z00_12942, 
(int)(((long)2)), 
CINT(BgL_arityz00_12936)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1187z00_12941;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12955;
BgL_z12denvz12_12955 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10816, BgL_bpz00_12931, BgL_sfz00_12938))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_12937;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12956;
BgL_nsz00_12956 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2090z00_12957;
BgL_arg2090z00_12957 = 
(
(long)CINT(BgL_bpz00_12931)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12956, ((long)2), BgL_sz00_10816, BgL_bpz00_12931, 
BINT(BgL_arg2090z00_12957)); } 
VECTOR_SET(BgL_nsz00_12956,((long)1),BgL_sz00_10816); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12955, BgL_nsz00_12956); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12958;
BgL_ez00_12958 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12958, BgL_sz00_10816); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12959;
BgL_____rz00_12959 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12937, BgL_nsz00_12956, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12958); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12955, BgL_sz00_10816); 
return BgL_____rz00_12959;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12932, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12960;
BgL_nbpz00_12960 = 
(
(long)CINT(BgL_bpz00_12931)+BgL_siza7eza7_10815); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),((long)0),
BINT(BgL_nbpz00_12960)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12961;
BgL_rz00_12961 = 
PROCEDURE_ENTRY(BgL_fz00_12932)(BgL_fz00_12932, BgL_a1z00_12933, BgL_a2z00_12934, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10816),((long)0),BgL_bpz00_12931); 
return BgL_rz00_12961;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10813, BgL_symbzd2funzd2_10814, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12932));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2096> */
obj_t BGl_z62zc3anonymousza32096ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10817, obj_t BgL_sz00_10824)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10818;obj_t BgL_a1z00_10819;obj_t BgL_a2z00_10820;obj_t BgL_locz00_10821;obj_t BgL_symbzd2funzd2_10822;long BgL_siza7eza7_10823;
BgL_funz00_10818 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)0))); 
BgL_a1z00_10819 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)1))); 
BgL_a2z00_10820 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)2))); 
BgL_locz00_10821 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10822 = 
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)4))); 
BgL_siza7eza7_10823 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10817, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12962;
BgL_bpz00_12962 = 
VECTOR_REF(
((obj_t)BgL_sz00_10824),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12963;obj_t BgL_a1z00_12964;obj_t BgL_a2z00_12965;
BgL_fz00_12963 = 
PROCEDURE_ENTRY(BgL_funz00_10818)(BgL_funz00_10818, BgL_sz00_10824, BEOA); 
BgL_a1z00_12964 = 
PROCEDURE_ENTRY(BgL_a1z00_10819)(BgL_a1z00_10819, BgL_sz00_10824, BEOA); 
BgL_a2z00_12965 = 
PROCEDURE_ENTRY(BgL_a2z00_10820)(BgL_a2z00_10820, BgL_sz00_10824, BEOA); 
if(
PROCEDUREP(BgL_fz00_12963))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10821, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12963); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12966;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17725;
BgL_tmpz00_17725 = 
((obj_t)BgL_fz00_12963); 
BgL_ufz00_12966 = 
PROCEDURE_ATTR(BgL_tmpz00_17725); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17728;
if(
STRUCTP(BgL_ufz00_12966))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17728 = 
(
STRUCT_KEY(BgL_ufz00_12966)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17728 = ((bool_t)0)
; } 
if(BgL_testz00_17728)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12967;obj_t BgL_runz00_12968;obj_t BgL_sfz00_12969;
BgL_arityz00_12967 = 
STRUCT_REF(BgL_ufz00_12966, 
(int)(((long)0))); 
BgL_runz00_12968 = 
STRUCT_REF(BgL_ufz00_12966, 
(int)(((long)1))); 
BgL_sfz00_12969 = 
STRUCT_REF(BgL_ufz00_12966, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_12970;
BgL_spz00_12970 = 
(
(long)CINT(BgL_bpz00_12962)+BgL_siza7eza7_10823); 
if(
(
(long)CINT(BgL_arityz00_12967)==((long)2)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2100z00_12971;
BgL_arg2100z00_12971 = 
(BgL_spz00_12970+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2100z00_12971,BgL_a1z00_12964); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2101z00_12972;
BgL_arg2101z00_12972 = 
(BgL_spz00_12970+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2101z00_12972,BgL_a2z00_12965); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12967))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12967)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2103z00_12975;obj_t BgL_arg2104z00_12976;
BgL_arg2103z00_12975 = 
(BgL_spz00_12970+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2105z00_12977;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2106z00_12978;
BgL_arg2106z00_12978 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12965, BNIL); 
BgL_list2105z00_12977 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12964, BgL_arg2106z00_12978); } 
BgL_arg2104z00_12976 = BgL_list2105z00_12977; } 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2103z00_12975,BgL_arg2104z00_12976); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2107z00_12979;
BgL_arg2107z00_12979 = 
(BgL_spz00_12970+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2107z00_12979,BgL_a1z00_12964); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2108z00_12980;obj_t BgL_arg2109z00_12981;
BgL_arg2108z00_12980 = 
(BgL_spz00_12970+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2110z00_12982;
BgL_list2110z00_12982 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12965, BNIL); 
BgL_arg2109z00_12981 = BgL_list2110z00_12982; } 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2108z00_12980,BgL_arg2109z00_12981); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2111z00_12983;
BgL_arg2111z00_12983 = 
(BgL_spz00_12970+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2111z00_12983,BgL_a1z00_12964); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2112z00_12984;
BgL_arg2112z00_12984 = 
(BgL_spz00_12970+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2112z00_12984,BgL_a2z00_12965); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2113z00_12985;obj_t BgL_arg2114z00_12986;
BgL_arg2113z00_12985 = 
(BgL_spz00_12970+((long)2)); 
BgL_arg2114z00_12986 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10824),BgL_arg2113z00_12985,BgL_arg2114z00_12986); } break;
default: 
BgL_case_else1189z00_12973:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2116z00_12974;
BgL_arg2116z00_12974 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12966), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10821, BgL_arg2116z00_12974, 
(int)(((long)2)), 
CINT(BgL_arityz00_12967)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1189z00_12973;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_12987;
BgL_z12denvz12_12987 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12987, BgL_locz00_10821); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10824, 
BINT(BgL_spz00_12970), BgL_sfz00_12969))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12968, BgL_sz00_10824, 
BINT(BgL_spz00_12970));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_12988;
BgL_nsz00_12988 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2118z00_12989;
BgL_arg2118z00_12989 = 
(BgL_spz00_12970+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12988, ((long)2), BgL_sz00_10824, 
BINT(BgL_spz00_12970), 
BINT(BgL_arg2118z00_12989)); } 
VECTOR_SET(BgL_nsz00_12988,((long)1),BgL_sz00_10824); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12987, BgL_nsz00_12988); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_12990;
BgL_ez00_12990 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12990, BgL_sz00_10824); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_12991;
BgL_____rz00_12991 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12968, BgL_nsz00_12988, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12990); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12987, BgL_sz00_10824); 
return BgL_____rz00_12991;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12963, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_12992;
BgL_nbpz00_12992 = 
(
(long)CINT(BgL_bpz00_12962)+BgL_siza7eza7_10823); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),((long)0),
BINT(BgL_nbpz00_12992)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17809;
BgL_tmpz00_17809 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17809, BgL_locz00_10821); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_12993;
BgL_rz00_12993 = 
PROCEDURE_ENTRY(BgL_fz00_12963)(BgL_fz00_12963, BgL_a1z00_12964, BgL_a2z00_12965, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10824),((long)0),BgL_bpz00_12962); 
return BgL_rz00_12993;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10821, BgL_symbzd2funzd2_10822, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12963));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2122> */
obj_t BGl_z62zc3anonymousza32122ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10825, obj_t BgL_sz00_10832)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10826;obj_t BgL_a1z00_10827;obj_t BgL_a2z00_10828;obj_t BgL_locz00_10829;obj_t BgL_symbzd2funzd2_10830;long BgL_siza7eza7_10831;
BgL_funz00_10826 = 
PROCEDURE_REF(BgL_envz00_10825, 
(int)(((long)0))); 
BgL_a1z00_10827 = 
PROCEDURE_REF(BgL_envz00_10825, 
(int)(((long)1))); 
BgL_a2z00_10828 = 
PROCEDURE_REF(BgL_envz00_10825, 
(int)(((long)2))); 
BgL_locz00_10829 = 
PROCEDURE_REF(BgL_envz00_10825, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10830 = 
PROCEDURE_REF(BgL_envz00_10825, 
(int)(((long)4))); 
BgL_siza7eza7_10831 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10825, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_12994;
BgL_bpz00_12994 = 
VECTOR_REF(
((obj_t)BgL_sz00_10832),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_12995;obj_t BgL_a1z00_12996;obj_t BgL_a2z00_12997;
BgL_fz00_12995 = 
PROCEDURE_ENTRY(BgL_funz00_10826)(BgL_funz00_10826, BgL_sz00_10832, BEOA); 
BgL_a1z00_12996 = 
PROCEDURE_ENTRY(BgL_a1z00_10827)(BgL_a1z00_10827, BgL_sz00_10832, BEOA); 
BgL_a2z00_12997 = 
PROCEDURE_ENTRY(BgL_a2z00_10828)(BgL_a2z00_10828, BgL_sz00_10832, BEOA); 
if(
PROCEDUREP(BgL_fz00_12995))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10829, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_12995); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_12998;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_17852;
BgL_tmpz00_17852 = 
((obj_t)BgL_fz00_12995); 
BgL_ufz00_12998 = 
PROCEDURE_ATTR(BgL_tmpz00_17852); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17855;
if(
STRUCTP(BgL_ufz00_12998))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17855 = 
(
STRUCT_KEY(BgL_ufz00_12998)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_17855 = ((bool_t)0)
; } 
if(BgL_testz00_17855)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_12999;obj_t BgL_runz00_13000;obj_t BgL_sfz00_13001;
BgL_arityz00_12999 = 
STRUCT_REF(BgL_ufz00_12998, 
(int)(((long)0))); 
BgL_runz00_13000 = 
STRUCT_REF(BgL_ufz00_12998, 
(int)(((long)1))); 
BgL_sfz00_13001 = 
STRUCT_REF(BgL_ufz00_12998, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_13002;
BgL_spz00_13002 = 
(
(long)CINT(BgL_bpz00_12994)+BgL_siza7eza7_10831); 
if(
(
(long)CINT(BgL_arityz00_12999)==((long)2)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2126z00_13003;
BgL_arg2126z00_13003 = 
(BgL_spz00_13002+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2126z00_13003,BgL_a1z00_12996); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2127z00_13004;
BgL_arg2127z00_13004 = 
(BgL_spz00_13002+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2127z00_13004,BgL_a2z00_12997); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12999))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_12999)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2129z00_13007;obj_t BgL_arg2130z00_13008;
BgL_arg2129z00_13007 = 
(BgL_spz00_13002+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2131z00_13009;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2132z00_13010;
BgL_arg2132z00_13010 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12997, BNIL); 
BgL_list2131z00_13009 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12996, BgL_arg2132z00_13010); } 
BgL_arg2130z00_13008 = BgL_list2131z00_13009; } 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2129z00_13007,BgL_arg2130z00_13008); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2133z00_13011;
BgL_arg2133z00_13011 = 
(BgL_spz00_13002+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2133z00_13011,BgL_a1z00_12996); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2134z00_13012;obj_t BgL_arg2135z00_13013;
BgL_arg2134z00_13012 = 
(BgL_spz00_13002+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2136z00_13014;
BgL_list2136z00_13014 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12997, BNIL); 
BgL_arg2135z00_13013 = BgL_list2136z00_13014; } 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2134z00_13012,BgL_arg2135z00_13013); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2137z00_13015;
BgL_arg2137z00_13015 = 
(BgL_spz00_13002+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2137z00_13015,BgL_a1z00_12996); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2138z00_13016;
BgL_arg2138z00_13016 = 
(BgL_spz00_13002+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2138z00_13016,BgL_a2z00_12997); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2139z00_13017;obj_t BgL_arg2140z00_13018;
BgL_arg2139z00_13017 = 
(BgL_spz00_13002+((long)2)); 
BgL_arg2140z00_13018 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10832),BgL_arg2139z00_13017,BgL_arg2140z00_13018); } break;
default: 
BgL_case_else1191z00_13005:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2142z00_13006;
BgL_arg2142z00_13006 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12998), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10829, BgL_arg2142z00_13006, 
(int)(((long)2)), 
CINT(BgL_arityz00_12999)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1191z00_13005;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13019;
BgL_z12denvz12_13019 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10832, 
BINT(BgL_spz00_13002), BgL_sfz00_13001))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13000, BgL_sz00_10832, 
BINT(BgL_spz00_13002));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13020;
BgL_nsz00_13020 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2144z00_13021;
BgL_arg2144z00_13021 = 
(BgL_spz00_13002+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13020, ((long)2), BgL_sz00_10832, 
BINT(BgL_spz00_13002), 
BINT(BgL_arg2144z00_13021)); } 
VECTOR_SET(BgL_nsz00_13020,((long)1),BgL_sz00_10832); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13019, BgL_nsz00_13020); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13022;
BgL_ez00_13022 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13022, BgL_sz00_10832); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13023;
BgL_____rz00_13023 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13000, BgL_nsz00_13020, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13022); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13019, BgL_sz00_10832); 
return BgL_____rz00_13023;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12995, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13024;
BgL_nbpz00_13024 = 
(
(long)CINT(BgL_bpz00_12994)+BgL_siza7eza7_10831); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),((long)0),
BINT(BgL_nbpz00_13024)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13025;
BgL_rz00_13025 = 
PROCEDURE_ENTRY(BgL_fz00_12995)(BgL_fz00_12995, BgL_a1z00_12996, BgL_a2z00_12997, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10832),((long)0),BgL_bpz00_12994); 
return BgL_rz00_13025;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10829, BgL_symbzd2funzd2_10830, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12995));} } } } } } } } 
BGL_FUNCTION_END;
}



/* comp-call3 */
obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162, BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164, obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167, long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170, obj_t BgL_a3z00_171)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_cfunz00_2481;
BgL_cfunz00_2481 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163, ((long)3), BgL_locz00_162, BgL_symbzd2funzd2_164); 
if(
CBOOL(BgL_cfunz00_2481))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17948;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2153z00_2501;
BgL_arg2153z00_2501 = 
bgl_debug(); 
BgL_testz00_17948 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2153z00_2501), 
BINT(((long)0))); } 
if(BgL_testz00_17948)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32150ze3z83_10833;
BgL_zc3anonymousza32150ze3z83_10833 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32150ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza32150ze3z83_10833, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3anonymousza32150ze3z83_10833, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3anonymousza32150ze3z83_10833, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3anonymousza32150ze3z83_10833, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3anonymousza32150ze3z83_10833, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3anonymousza32150ze3z83_10833, 
(int)(((long)5)), BgL_cfunz00_2481); 
return BgL_zc3anonymousza32150ze3z83_10833;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32152ze3z83_10834;
BgL_zc3anonymousza32152ze3z83_10834 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32152ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza32152ze3z83_10834, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3anonymousza32152ze3z83_10834, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3anonymousza32152ze3z83_10834, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3anonymousza32152ze3z83_10834, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3anonymousza32152ze3z83_10834, 
(int)(((long)4)), BgL_cfunz00_2481); 
return BgL_zc3anonymousza32152ze3z83_10834;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
CBOOL(BgL_tailzf3zf3_166))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_17985;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2225z00_2613;
BgL_arg2225z00_2613 = 
bgl_debug(); 
BgL_testz00_17985 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2225z00_2613), 
BINT(((long)0))); } 
if(BgL_testz00_17985)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32156ze3z83_10835;
BgL_zc3anonymousza32156ze3z83_10835 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32156ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3anonymousza32156ze3z83_10835, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3anonymousza32156ze3z83_10835;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32191ze3z83_10836;
BgL_zc3anonymousza32191ze3z83_10836 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32191ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3anonymousza32191ze3z83_10836, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3anonymousza32191ze3z83_10836;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18026;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2297z00_2725;
BgL_arg2297z00_2725 = 
bgl_debug(); 
BgL_testz00_18026 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2297z00_2725), 
BINT(((long)0))); } 
if(BgL_testz00_18026)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32228ze3z83_10837;
BgL_zc3anonymousza32228ze3z83_10837 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32228ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3anonymousza32228ze3z83_10837, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3anonymousza32228ze3z83_10837;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32263ze3z83_10838;
BgL_zc3anonymousza32263ze3z83_10838 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32263ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3anonymousza32263ze3z83_10838, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3anonymousza32263ze3z83_10838;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2150> */
obj_t BGl_z62zc3anonymousza32150ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10839, obj_t BgL_sz00_10846)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10840;obj_t BgL_a2z00_10841;obj_t BgL_a3z00_10842;long BgL_siza7eza7_10843;obj_t BgL_locz00_10844;obj_t BgL_cfunz00_10845;
BgL_a1z00_10840 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)0))); 
BgL_a2z00_10841 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)1))); 
BgL_a3z00_10842 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)2))); 
BgL_siza7eza7_10843 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)3)))); 
BgL_locz00_10844 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)4))); 
BgL_cfunz00_10845 = 
PROCEDURE_REF(BgL_envz00_10839, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13026;
BgL_bpz00_13026 = 
VECTOR_REF(
((obj_t)BgL_sz00_10846),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_13027;obj_t BgL_a2z00_13028;obj_t BgL_a3z00_13029;
BgL_a1z00_13027 = 
PROCEDURE_ENTRY(BgL_a1z00_10840)(BgL_a1z00_10840, BgL_sz00_10846, BEOA); 
BgL_a2z00_13028 = 
PROCEDURE_ENTRY(BgL_a2z00_10841)(BgL_a2z00_10841, BgL_sz00_10846, BEOA); 
BgL_a3z00_13029 = 
PROCEDURE_ENTRY(BgL_a3z00_10842)(BgL_a3z00_10842, BgL_sz00_10846, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13030;
BgL_nbpz00_13030 = 
(
(long)CINT(BgL_bpz00_13026)+BgL_siza7eza7_10843); 
VECTOR_SET(
((obj_t)BgL_sz00_10846),((long)0),
BINT(BgL_nbpz00_13030)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18099;
BgL_tmpz00_18099 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18099, BgL_locz00_10844); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13031;
BgL_rz00_13031 = 
PROCEDURE_ENTRY(BgL_cfunz00_10845)(BgL_cfunz00_10845, BgL_a1z00_13027, BgL_a2z00_13028, BgL_a3z00_13029, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10846),((long)0),BgL_bpz00_13026); 
return BgL_rz00_13031;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2152> */
obj_t BGl_z62zc3anonymousza32152ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10847, obj_t BgL_sz00_10853)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10848;obj_t BgL_a2z00_10849;obj_t BgL_a3z00_10850;long BgL_siza7eza7_10851;obj_t BgL_cfunz00_10852;
BgL_a1z00_10848 = 
PROCEDURE_REF(BgL_envz00_10847, 
(int)(((long)0))); 
BgL_a2z00_10849 = 
PROCEDURE_REF(BgL_envz00_10847, 
(int)(((long)1))); 
BgL_a3z00_10850 = 
PROCEDURE_REF(BgL_envz00_10847, 
(int)(((long)2))); 
BgL_siza7eza7_10851 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10847, 
(int)(((long)3)))); 
BgL_cfunz00_10852 = 
PROCEDURE_REF(BgL_envz00_10847, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13032;
BgL_bpz00_13032 = 
VECTOR_REF(
((obj_t)BgL_sz00_10853),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_13033;obj_t BgL_a2z00_13034;obj_t BgL_a3z00_13035;
BgL_a1z00_13033 = 
PROCEDURE_ENTRY(BgL_a1z00_10848)(BgL_a1z00_10848, BgL_sz00_10853, BEOA); 
BgL_a2z00_13034 = 
PROCEDURE_ENTRY(BgL_a2z00_10849)(BgL_a2z00_10849, BgL_sz00_10853, BEOA); 
BgL_a3z00_13035 = 
PROCEDURE_ENTRY(BgL_a3z00_10850)(BgL_a3z00_10850, BgL_sz00_10853, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13036;
BgL_nbpz00_13036 = 
(
(long)CINT(BgL_bpz00_13032)+BgL_siza7eza7_10851); 
VECTOR_SET(
((obj_t)BgL_sz00_10853),((long)0),
BINT(BgL_nbpz00_13036)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13037;
BgL_rz00_13037 = 
PROCEDURE_ENTRY(BgL_cfunz00_10852)(BgL_cfunz00_10852, BgL_a1z00_13033, BgL_a2z00_13034, BgL_a3z00_13035, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10853),((long)0),BgL_bpz00_13032); 
return BgL_rz00_13037;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2156> */
obj_t BGl_z62zc3anonymousza32156ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10854, obj_t BgL_sz00_10862)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10855;obj_t BgL_a1z00_10856;obj_t BgL_a2z00_10857;obj_t BgL_a3z00_10858;obj_t BgL_locz00_10859;obj_t BgL_symbzd2funzd2_10860;long BgL_siza7eza7_10861;
BgL_funz00_10855 = 
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)0))); 
BgL_a1z00_10856 = 
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)1))); 
BgL_a2z00_10857 = 
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)2))); 
BgL_a3z00_10858 = 
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)3))); 
BgL_locz00_10859 = 
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10860 = 
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)5))); 
BgL_siza7eza7_10861 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10854, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13038;
BgL_bpz00_13038 = 
VECTOR_REF(
((obj_t)BgL_sz00_10862),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13039;obj_t BgL_a1z00_13040;obj_t BgL_a2z00_13041;obj_t BgL_a3z00_13042;
BgL_fz00_13039 = 
PROCEDURE_ENTRY(BgL_funz00_10855)(BgL_funz00_10855, BgL_sz00_10862, BEOA); 
BgL_a1z00_13040 = 
PROCEDURE_ENTRY(BgL_a1z00_10856)(BgL_a1z00_10856, BgL_sz00_10862, BEOA); 
BgL_a2z00_13041 = 
PROCEDURE_ENTRY(BgL_a2z00_10857)(BgL_a2z00_10857, BgL_sz00_10862, BEOA); 
BgL_a3z00_13042 = 
PROCEDURE_ENTRY(BgL_a3z00_10858)(BgL_a3z00_10858, BgL_sz00_10862, BEOA); 
if(
PROCEDUREP(BgL_fz00_13039))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10859, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13039); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13043;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18184;
BgL_tmpz00_18184 = 
((obj_t)BgL_fz00_13039); 
BgL_ufz00_13043 = 
PROCEDURE_ATTR(BgL_tmpz00_18184); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18187;
if(
STRUCTP(BgL_ufz00_13043))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18187 = 
(
STRUCT_KEY(BgL_ufz00_13043)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18187 = ((bool_t)0)
; } 
if(BgL_testz00_18187)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13044;obj_t BgL_runz00_13045;obj_t BgL_sfz00_13046;
BgL_arityz00_13044 = 
STRUCT_REF(BgL_ufz00_13043, 
(int)(((long)0))); 
BgL_runz00_13045 = 
STRUCT_REF(BgL_ufz00_13043, 
(int)(((long)1))); 
BgL_sfz00_13046 = 
STRUCT_REF(BgL_ufz00_13043, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13044)==((long)3)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2160z00_13047;
BgL_arg2160z00_13047 = 
(
(long)CINT(BgL_bpz00_13038)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2160z00_13047,BgL_a1z00_13040); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2161z00_13048;
BgL_arg2161z00_13048 = 
(
(long)CINT(BgL_bpz00_13038)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2161z00_13048,BgL_a2z00_13041); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2162z00_13049;
BgL_arg2162z00_13049 = 
(
(long)CINT(BgL_bpz00_13038)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2162z00_13049,BgL_a3z00_13042); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13044))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13044)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2164z00_13052;obj_t BgL_arg2165z00_13053;
BgL_arg2164z00_13052 = 
(
(long)CINT(BgL_bpz00_13038)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2166z00_13054;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2167z00_13055;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2168z00_13056;
BgL_arg2168z00_13056 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13042, BNIL); 
BgL_arg2167z00_13055 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13041, BgL_arg2168z00_13056); } 
BgL_list2166z00_13054 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13040, BgL_arg2167z00_13055); } 
BgL_arg2165z00_13053 = BgL_list2166z00_13054; } 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2164z00_13052,BgL_arg2165z00_13053); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2169z00_13057;
BgL_arg2169z00_13057 = 
(
(long)CINT(BgL_bpz00_13038)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2169z00_13057,BgL_a1z00_13040); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2170z00_13058;obj_t BgL_arg2171z00_13059;
BgL_arg2170z00_13058 = 
(
(long)CINT(BgL_bpz00_13038)+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2172z00_13060;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2173z00_13061;
BgL_arg2173z00_13061 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13042, BNIL); 
BgL_list2172z00_13060 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13041, BgL_arg2173z00_13061); } 
BgL_arg2171z00_13059 = BgL_list2172z00_13060; } 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2170z00_13058,BgL_arg2171z00_13059); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2174z00_13062;
BgL_arg2174z00_13062 = 
(
(long)CINT(BgL_bpz00_13038)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2174z00_13062,BgL_a1z00_13040); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2175z00_13063;
BgL_arg2175z00_13063 = 
(
(long)CINT(BgL_bpz00_13038)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2175z00_13063,BgL_a2z00_13041); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2176z00_13064;obj_t BgL_arg2177z00_13065;
BgL_arg2176z00_13064 = 
(
(long)CINT(BgL_bpz00_13038)+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2178z00_13066;
BgL_list2178z00_13066 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13042, BNIL); 
BgL_arg2177z00_13065 = BgL_list2178z00_13066; } 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2176z00_13064,BgL_arg2177z00_13065); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2179z00_13067;
BgL_arg2179z00_13067 = 
(
(long)CINT(BgL_bpz00_13038)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2179z00_13067,BgL_a1z00_13040); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2180z00_13068;
BgL_arg2180z00_13068 = 
(
(long)CINT(BgL_bpz00_13038)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2180z00_13068,BgL_a2z00_13041); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2181z00_13069;
BgL_arg2181z00_13069 = 
(
(long)CINT(BgL_bpz00_13038)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2181z00_13069,BgL_a3z00_13042); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2182z00_13070;obj_t BgL_arg2183z00_13071;
BgL_arg2182z00_13070 = 
(
(long)CINT(BgL_bpz00_13038)+((long)3)); 
BgL_arg2183z00_13071 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10862),BgL_arg2182z00_13070,BgL_arg2183z00_13071); } break;
default: 
BgL_case_else1193z00_13050:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2185z00_13051;
BgL_arg2185z00_13051 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13043), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10859, BgL_arg2185z00_13051, 
(int)(((long)3)), 
CINT(BgL_arityz00_13044)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1193z00_13050;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13072;
BgL_z12denvz12_13072 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13072, BgL_locz00_10859); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10862, BgL_bpz00_13038, BgL_sfz00_13046))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_13045;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13073;
BgL_nsz00_13073 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2187z00_13074;
BgL_arg2187z00_13074 = 
(
(long)CINT(BgL_bpz00_13038)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13073, ((long)2), BgL_sz00_10862, BgL_bpz00_13038, 
BINT(BgL_arg2187z00_13074)); } 
VECTOR_SET(BgL_nsz00_13073,((long)1),BgL_sz00_10862); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13072, BgL_nsz00_13073); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13075;
BgL_ez00_13075 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13075, BgL_sz00_10862); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13076;
BgL_____rz00_13076 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13045, BgL_nsz00_13073, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13075); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13072, BgL_sz00_10862); 
return BgL_____rz00_13076;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13039, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13077;
BgL_nbpz00_13077 = 
(
(long)CINT(BgL_bpz00_13038)+BgL_siza7eza7_10861); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),((long)0),
BINT(BgL_nbpz00_13077)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18294;
BgL_tmpz00_18294 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18294, BgL_locz00_10859); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13078;
BgL_rz00_13078 = 
PROCEDURE_ENTRY(BgL_fz00_13039)(BgL_fz00_13039, BgL_a1z00_13040, BgL_a2z00_13041, BgL_a3z00_13042, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10862),((long)0),BgL_bpz00_13038); 
return BgL_rz00_13078;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10859, BgL_symbzd2funzd2_10860, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13039));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2191> */
obj_t BGl_z62zc3anonymousza32191ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10863, obj_t BgL_sz00_10871)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10864;obj_t BgL_a1z00_10865;obj_t BgL_a2z00_10866;obj_t BgL_a3z00_10867;obj_t BgL_locz00_10868;obj_t BgL_symbzd2funzd2_10869;long BgL_siza7eza7_10870;
BgL_funz00_10864 = 
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)0))); 
BgL_a1z00_10865 = 
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)1))); 
BgL_a2z00_10866 = 
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)2))); 
BgL_a3z00_10867 = 
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)3))); 
BgL_locz00_10868 = 
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10869 = 
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)5))); 
BgL_siza7eza7_10870 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10863, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13079;
BgL_bpz00_13079 = 
VECTOR_REF(
((obj_t)BgL_sz00_10871),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13080;obj_t BgL_a1z00_13081;obj_t BgL_a2z00_13082;obj_t BgL_a3z00_13083;
BgL_fz00_13080 = 
PROCEDURE_ENTRY(BgL_funz00_10864)(BgL_funz00_10864, BgL_sz00_10871, BEOA); 
BgL_a1z00_13081 = 
PROCEDURE_ENTRY(BgL_a1z00_10865)(BgL_a1z00_10865, BgL_sz00_10871, BEOA); 
BgL_a2z00_13082 = 
PROCEDURE_ENTRY(BgL_a2z00_10866)(BgL_a2z00_10866, BgL_sz00_10871, BEOA); 
BgL_a3z00_13083 = 
PROCEDURE_ENTRY(BgL_a3z00_10867)(BgL_a3z00_10867, BgL_sz00_10871, BEOA); 
if(
PROCEDUREP(BgL_fz00_13080))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10868, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13080); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13084;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18344;
BgL_tmpz00_18344 = 
((obj_t)BgL_fz00_13080); 
BgL_ufz00_13084 = 
PROCEDURE_ATTR(BgL_tmpz00_18344); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18347;
if(
STRUCTP(BgL_ufz00_13084))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18347 = 
(
STRUCT_KEY(BgL_ufz00_13084)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18347 = ((bool_t)0)
; } 
if(BgL_testz00_18347)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13085;obj_t BgL_runz00_13086;obj_t BgL_sfz00_13087;
BgL_arityz00_13085 = 
STRUCT_REF(BgL_ufz00_13084, 
(int)(((long)0))); 
BgL_runz00_13086 = 
STRUCT_REF(BgL_ufz00_13084, 
(int)(((long)1))); 
BgL_sfz00_13087 = 
STRUCT_REF(BgL_ufz00_13084, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13085)==((long)3)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2195z00_13088;
BgL_arg2195z00_13088 = 
(
(long)CINT(BgL_bpz00_13079)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2195z00_13088,BgL_a1z00_13081); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2196z00_13089;
BgL_arg2196z00_13089 = 
(
(long)CINT(BgL_bpz00_13079)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2196z00_13089,BgL_a2z00_13082); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2197z00_13090;
BgL_arg2197z00_13090 = 
(
(long)CINT(BgL_bpz00_13079)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2197z00_13090,BgL_a3z00_13083); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13085))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13085)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2199z00_13093;obj_t BgL_arg2200z00_13094;
BgL_arg2199z00_13093 = 
(
(long)CINT(BgL_bpz00_13079)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2201z00_13095;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2202z00_13096;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2203z00_13097;
BgL_arg2203z00_13097 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13083, BNIL); 
BgL_arg2202z00_13096 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13082, BgL_arg2203z00_13097); } 
BgL_list2201z00_13095 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13081, BgL_arg2202z00_13096); } 
BgL_arg2200z00_13094 = BgL_list2201z00_13095; } 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2199z00_13093,BgL_arg2200z00_13094); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2204z00_13098;
BgL_arg2204z00_13098 = 
(
(long)CINT(BgL_bpz00_13079)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2204z00_13098,BgL_a1z00_13081); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2205z00_13099;obj_t BgL_arg2206z00_13100;
BgL_arg2205z00_13099 = 
(
(long)CINT(BgL_bpz00_13079)+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2207z00_13101;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2208z00_13102;
BgL_arg2208z00_13102 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13083, BNIL); 
BgL_list2207z00_13101 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13082, BgL_arg2208z00_13102); } 
BgL_arg2206z00_13100 = BgL_list2207z00_13101; } 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2205z00_13099,BgL_arg2206z00_13100); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2209z00_13103;
BgL_arg2209z00_13103 = 
(
(long)CINT(BgL_bpz00_13079)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2209z00_13103,BgL_a1z00_13081); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2210z00_13104;
BgL_arg2210z00_13104 = 
(
(long)CINT(BgL_bpz00_13079)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2210z00_13104,BgL_a2z00_13082); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2211z00_13105;obj_t BgL_arg2212z00_13106;
BgL_arg2211z00_13105 = 
(
(long)CINT(BgL_bpz00_13079)+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2213z00_13107;
BgL_list2213z00_13107 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13083, BNIL); 
BgL_arg2212z00_13106 = BgL_list2213z00_13107; } 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2211z00_13105,BgL_arg2212z00_13106); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2214z00_13108;
BgL_arg2214z00_13108 = 
(
(long)CINT(BgL_bpz00_13079)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2214z00_13108,BgL_a1z00_13081); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2215z00_13109;
BgL_arg2215z00_13109 = 
(
(long)CINT(BgL_bpz00_13079)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2215z00_13109,BgL_a2z00_13082); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2216z00_13110;
BgL_arg2216z00_13110 = 
(
(long)CINT(BgL_bpz00_13079)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2216z00_13110,BgL_a3z00_13083); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2217z00_13111;obj_t BgL_arg2218z00_13112;
BgL_arg2217z00_13111 = 
(
(long)CINT(BgL_bpz00_13079)+((long)3)); 
BgL_arg2218z00_13112 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10871),BgL_arg2217z00_13111,BgL_arg2218z00_13112); } break;
default: 
BgL_case_else1195z00_13091:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2220z00_13092;
BgL_arg2220z00_13092 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13084), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10868, BgL_arg2220z00_13092, 
(int)(((long)3)), 
CINT(BgL_arityz00_13085)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1195z00_13091;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13113;
BgL_z12denvz12_13113 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10871, BgL_bpz00_13079, BgL_sfz00_13087))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_13086;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13114;
BgL_nsz00_13114 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2222z00_13115;
BgL_arg2222z00_13115 = 
(
(long)CINT(BgL_bpz00_13079)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13114, ((long)2), BgL_sz00_10871, BgL_bpz00_13079, 
BINT(BgL_arg2222z00_13115)); } 
VECTOR_SET(BgL_nsz00_13114,((long)1),BgL_sz00_10871); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13113, BgL_nsz00_13114); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13116;
BgL_ez00_13116 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13116, BgL_sz00_10871); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13117;
BgL_____rz00_13117 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13086, BgL_nsz00_13114, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13116); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13113, BgL_sz00_10871); 
return BgL_____rz00_13117;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13080, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13118;
BgL_nbpz00_13118 = 
(
(long)CINT(BgL_bpz00_13079)+BgL_siza7eza7_10870); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),((long)0),
BINT(BgL_nbpz00_13118)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13119;
BgL_rz00_13119 = 
PROCEDURE_ENTRY(BgL_fz00_13080)(BgL_fz00_13080, BgL_a1z00_13081, BgL_a2z00_13082, BgL_a3z00_13083, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10871),((long)0),BgL_bpz00_13079); 
return BgL_rz00_13119;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10868, BgL_symbzd2funzd2_10869, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13080));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2228> */
obj_t BGl_z62zc3anonymousza32228ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10872, obj_t BgL_sz00_10880)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10873;obj_t BgL_a1z00_10874;obj_t BgL_a2z00_10875;obj_t BgL_a3z00_10876;obj_t BgL_locz00_10877;obj_t BgL_symbzd2funzd2_10878;long BgL_siza7eza7_10879;
BgL_funz00_10873 = 
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)0))); 
BgL_a1z00_10874 = 
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)1))); 
BgL_a2z00_10875 = 
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)2))); 
BgL_a3z00_10876 = 
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)3))); 
BgL_locz00_10877 = 
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10878 = 
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)5))); 
BgL_siza7eza7_10879 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10872, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13120;
BgL_bpz00_13120 = 
VECTOR_REF(
((obj_t)BgL_sz00_10880),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13121;obj_t BgL_a1z00_13122;obj_t BgL_a2z00_13123;obj_t BgL_a3z00_13124;
BgL_fz00_13121 = 
PROCEDURE_ENTRY(BgL_funz00_10873)(BgL_funz00_10873, BgL_sz00_10880, BEOA); 
BgL_a1z00_13122 = 
PROCEDURE_ENTRY(BgL_a1z00_10874)(BgL_a1z00_10874, BgL_sz00_10880, BEOA); 
BgL_a2z00_13123 = 
PROCEDURE_ENTRY(BgL_a2z00_10875)(BgL_a2z00_10875, BgL_sz00_10880, BEOA); 
BgL_a3z00_13124 = 
PROCEDURE_ENTRY(BgL_a3z00_10876)(BgL_a3z00_10876, BgL_sz00_10880, BEOA); 
if(
PROCEDUREP(BgL_fz00_13121))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10877, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13121); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13125;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18500;
BgL_tmpz00_18500 = 
((obj_t)BgL_fz00_13121); 
BgL_ufz00_13125 = 
PROCEDURE_ATTR(BgL_tmpz00_18500); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18503;
if(
STRUCTP(BgL_ufz00_13125))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18503 = 
(
STRUCT_KEY(BgL_ufz00_13125)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18503 = ((bool_t)0)
; } 
if(BgL_testz00_18503)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13126;obj_t BgL_runz00_13127;obj_t BgL_sfz00_13128;
BgL_arityz00_13126 = 
STRUCT_REF(BgL_ufz00_13125, 
(int)(((long)0))); 
BgL_runz00_13127 = 
STRUCT_REF(BgL_ufz00_13125, 
(int)(((long)1))); 
BgL_sfz00_13128 = 
STRUCT_REF(BgL_ufz00_13125, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_13129;
BgL_spz00_13129 = 
(
(long)CINT(BgL_bpz00_13120)+BgL_siza7eza7_10879); 
if(
(
(long)CINT(BgL_arityz00_13126)==((long)3)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2232z00_13130;
BgL_arg2232z00_13130 = 
(BgL_spz00_13129+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2232z00_13130,BgL_a1z00_13122); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2233z00_13131;
BgL_arg2233z00_13131 = 
(BgL_spz00_13129+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2233z00_13131,BgL_a2z00_13123); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2234z00_13132;
BgL_arg2234z00_13132 = 
(BgL_spz00_13129+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2234z00_13132,BgL_a3z00_13124); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13126))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13126)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2236z00_13135;obj_t BgL_arg2237z00_13136;
BgL_arg2236z00_13135 = 
(BgL_spz00_13129+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2238z00_13137;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2239z00_13138;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2240z00_13139;
BgL_arg2240z00_13139 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13124, BNIL); 
BgL_arg2239z00_13138 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13123, BgL_arg2240z00_13139); } 
BgL_list2238z00_13137 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13122, BgL_arg2239z00_13138); } 
BgL_arg2237z00_13136 = BgL_list2238z00_13137; } 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2236z00_13135,BgL_arg2237z00_13136); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2241z00_13140;
BgL_arg2241z00_13140 = 
(BgL_spz00_13129+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2241z00_13140,BgL_a1z00_13122); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2242z00_13141;obj_t BgL_arg2243z00_13142;
BgL_arg2242z00_13141 = 
(BgL_spz00_13129+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2244z00_13143;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2245z00_13144;
BgL_arg2245z00_13144 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13124, BNIL); 
BgL_list2244z00_13143 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13123, BgL_arg2245z00_13144); } 
BgL_arg2243z00_13142 = BgL_list2244z00_13143; } 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2242z00_13141,BgL_arg2243z00_13142); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2246z00_13145;
BgL_arg2246z00_13145 = 
(BgL_spz00_13129+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2246z00_13145,BgL_a1z00_13122); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2247z00_13146;
BgL_arg2247z00_13146 = 
(BgL_spz00_13129+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2247z00_13146,BgL_a2z00_13123); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2248z00_13147;obj_t BgL_arg2249z00_13148;
BgL_arg2248z00_13147 = 
(BgL_spz00_13129+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2250z00_13149;
BgL_list2250z00_13149 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13124, BNIL); 
BgL_arg2249z00_13148 = BgL_list2250z00_13149; } 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2248z00_13147,BgL_arg2249z00_13148); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2251z00_13150;
BgL_arg2251z00_13150 = 
(BgL_spz00_13129+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2251z00_13150,BgL_a1z00_13122); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2252z00_13151;
BgL_arg2252z00_13151 = 
(BgL_spz00_13129+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2252z00_13151,BgL_a2z00_13123); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2253z00_13152;
BgL_arg2253z00_13152 = 
(BgL_spz00_13129+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2253z00_13152,BgL_a3z00_13124); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2254z00_13153;obj_t BgL_arg2255z00_13154;
BgL_arg2254z00_13153 = 
(BgL_spz00_13129+((long)3)); 
BgL_arg2255z00_13154 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10880),BgL_arg2254z00_13153,BgL_arg2255z00_13154); } break;
default: 
BgL_case_else1197z00_13133:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2257z00_13134;
BgL_arg2257z00_13134 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13125), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10877, BgL_arg2257z00_13134, 
(int)(((long)3)), 
CINT(BgL_arityz00_13126)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1197z00_13133;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13155;
BgL_z12denvz12_13155 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13155, BgL_locz00_10877); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10880, 
BINT(BgL_spz00_13129), BgL_sfz00_13128))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13127, BgL_sz00_10880, 
BINT(BgL_spz00_13129));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13156;
BgL_nsz00_13156 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2259z00_13157;
BgL_arg2259z00_13157 = 
(BgL_spz00_13129+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13156, ((long)2), BgL_sz00_10880, 
BINT(BgL_spz00_13129), 
BINT(BgL_arg2259z00_13157)); } 
VECTOR_SET(BgL_nsz00_13156,((long)1),BgL_sz00_10880); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13155, BgL_nsz00_13156); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13158;
BgL_ez00_13158 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13158, BgL_sz00_10880); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13159;
BgL_____rz00_13159 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13127, BgL_nsz00_13156, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13158); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13155, BgL_sz00_10880); 
return BgL_____rz00_13159;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13121, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13160;
BgL_nbpz00_13160 = 
(
(long)CINT(BgL_bpz00_13120)+BgL_siza7eza7_10879); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),((long)0),
BINT(BgL_nbpz00_13160)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18602;
BgL_tmpz00_18602 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18602, BgL_locz00_10877); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13161;
BgL_rz00_13161 = 
PROCEDURE_ENTRY(BgL_fz00_13121)(BgL_fz00_13121, BgL_a1z00_13122, BgL_a2z00_13123, BgL_a3z00_13124, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10880),((long)0),BgL_bpz00_13120); 
return BgL_rz00_13161;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10877, BgL_symbzd2funzd2_10878, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13121));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2263> */
obj_t BGl_z62zc3anonymousza32263ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10881, obj_t BgL_sz00_10889)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10882;obj_t BgL_a1z00_10883;obj_t BgL_a2z00_10884;obj_t BgL_a3z00_10885;obj_t BgL_locz00_10886;obj_t BgL_symbzd2funzd2_10887;long BgL_siza7eza7_10888;
BgL_funz00_10882 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)0))); 
BgL_a1z00_10883 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)1))); 
BgL_a2z00_10884 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)2))); 
BgL_a3z00_10885 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)3))); 
BgL_locz00_10886 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10887 = 
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)5))); 
BgL_siza7eza7_10888 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10881, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13162;
BgL_bpz00_13162 = 
VECTOR_REF(
((obj_t)BgL_sz00_10889),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13163;obj_t BgL_a1z00_13164;obj_t BgL_a2z00_13165;obj_t BgL_a3z00_13166;
BgL_fz00_13163 = 
PROCEDURE_ENTRY(BgL_funz00_10882)(BgL_funz00_10882, BgL_sz00_10889, BEOA); 
BgL_a1z00_13164 = 
PROCEDURE_ENTRY(BgL_a1z00_10883)(BgL_a1z00_10883, BgL_sz00_10889, BEOA); 
BgL_a2z00_13165 = 
PROCEDURE_ENTRY(BgL_a2z00_10884)(BgL_a2z00_10884, BgL_sz00_10889, BEOA); 
BgL_a3z00_13166 = 
PROCEDURE_ENTRY(BgL_a3z00_10885)(BgL_a3z00_10885, BgL_sz00_10889, BEOA); 
if(
PROCEDUREP(BgL_fz00_13163))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10886, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13163); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13167;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18652;
BgL_tmpz00_18652 = 
((obj_t)BgL_fz00_13163); 
BgL_ufz00_13167 = 
PROCEDURE_ATTR(BgL_tmpz00_18652); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18655;
if(
STRUCTP(BgL_ufz00_13167))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18655 = 
(
STRUCT_KEY(BgL_ufz00_13167)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_18655 = ((bool_t)0)
; } 
if(BgL_testz00_18655)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13168;obj_t BgL_runz00_13169;obj_t BgL_sfz00_13170;
BgL_arityz00_13168 = 
STRUCT_REF(BgL_ufz00_13167, 
(int)(((long)0))); 
BgL_runz00_13169 = 
STRUCT_REF(BgL_ufz00_13167, 
(int)(((long)1))); 
BgL_sfz00_13170 = 
STRUCT_REF(BgL_ufz00_13167, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_13171;
BgL_spz00_13171 = 
(
(long)CINT(BgL_bpz00_13162)+BgL_siza7eza7_10888); 
if(
(
(long)CINT(BgL_arityz00_13168)==((long)3)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2267z00_13172;
BgL_arg2267z00_13172 = 
(BgL_spz00_13171+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2267z00_13172,BgL_a1z00_13164); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2268z00_13173;
BgL_arg2268z00_13173 = 
(BgL_spz00_13171+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2268z00_13173,BgL_a2z00_13165); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2269z00_13174;
BgL_arg2269z00_13174 = 
(BgL_spz00_13171+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2269z00_13174,BgL_a3z00_13166); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13168))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13168)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2271z00_13177;obj_t BgL_arg2272z00_13178;
BgL_arg2271z00_13177 = 
(BgL_spz00_13171+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2273z00_13179;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2274z00_13180;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2275z00_13181;
BgL_arg2275z00_13181 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13166, BNIL); 
BgL_arg2274z00_13180 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13165, BgL_arg2275z00_13181); } 
BgL_list2273z00_13179 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13164, BgL_arg2274z00_13180); } 
BgL_arg2272z00_13178 = BgL_list2273z00_13179; } 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2271z00_13177,BgL_arg2272z00_13178); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2276z00_13182;
BgL_arg2276z00_13182 = 
(BgL_spz00_13171+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2276z00_13182,BgL_a1z00_13164); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2277z00_13183;obj_t BgL_arg2278z00_13184;
BgL_arg2277z00_13183 = 
(BgL_spz00_13171+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2279z00_13185;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2280z00_13186;
BgL_arg2280z00_13186 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13166, BNIL); 
BgL_list2279z00_13185 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13165, BgL_arg2280z00_13186); } 
BgL_arg2278z00_13184 = BgL_list2279z00_13185; } 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2277z00_13183,BgL_arg2278z00_13184); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2281z00_13187;
BgL_arg2281z00_13187 = 
(BgL_spz00_13171+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2281z00_13187,BgL_a1z00_13164); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2282z00_13188;
BgL_arg2282z00_13188 = 
(BgL_spz00_13171+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2282z00_13188,BgL_a2z00_13165); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2283z00_13189;obj_t BgL_arg2284z00_13190;
BgL_arg2283z00_13189 = 
(BgL_spz00_13171+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2285z00_13191;
BgL_list2285z00_13191 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13166, BNIL); 
BgL_arg2284z00_13190 = BgL_list2285z00_13191; } 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2283z00_13189,BgL_arg2284z00_13190); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2286z00_13192;
BgL_arg2286z00_13192 = 
(BgL_spz00_13171+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2286z00_13192,BgL_a1z00_13164); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2287z00_13193;
BgL_arg2287z00_13193 = 
(BgL_spz00_13171+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2287z00_13193,BgL_a2z00_13165); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2288z00_13194;
BgL_arg2288z00_13194 = 
(BgL_spz00_13171+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2288z00_13194,BgL_a3z00_13166); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2289z00_13195;obj_t BgL_arg2290z00_13196;
BgL_arg2289z00_13195 = 
(BgL_spz00_13171+((long)3)); 
BgL_arg2290z00_13196 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10889),BgL_arg2289z00_13195,BgL_arg2290z00_13196); } break;
default: 
BgL_case_else1199z00_13175:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2292z00_13176;
BgL_arg2292z00_13176 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13167), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10886, BgL_arg2292z00_13176, 
(int)(((long)3)), 
CINT(BgL_arityz00_13168)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1199z00_13175;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13197;
BgL_z12denvz12_13197 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10889, 
BINT(BgL_spz00_13171), BgL_sfz00_13170))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13169, BgL_sz00_10889, 
BINT(BgL_spz00_13171));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13198;
BgL_nsz00_13198 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2294z00_13199;
BgL_arg2294z00_13199 = 
(BgL_spz00_13171+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13198, ((long)2), BgL_sz00_10889, 
BINT(BgL_spz00_13171), 
BINT(BgL_arg2294z00_13199)); } 
VECTOR_SET(BgL_nsz00_13198,((long)1),BgL_sz00_10889); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13197, BgL_nsz00_13198); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13200;
BgL_ez00_13200 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13200, BgL_sz00_10889); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13201;
BgL_____rz00_13201 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13169, BgL_nsz00_13198, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13200); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13197, BgL_sz00_10889); 
return BgL_____rz00_13201;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13163, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13202;
BgL_nbpz00_13202 = 
(
(long)CINT(BgL_bpz00_13162)+BgL_siza7eza7_10888); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),((long)0),
BINT(BgL_nbpz00_13202)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13203;
BgL_rz00_13203 = 
PROCEDURE_ENTRY(BgL_fz00_13163)(BgL_fz00_13163, BgL_a1z00_13164, BgL_a2z00_13165, BgL_a3z00_13166, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10889),((long)0),BgL_bpz00_13162); 
return BgL_rz00_13203;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10886, BgL_symbzd2funzd2_10887, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13163));} } } } } } } } 
BGL_FUNCTION_END;
}



/* comp-call4 */
obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172, BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174, obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177, long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180, obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_cfunz00_2726;
BgL_cfunz00_2726 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173, ((long)4), BgL_locz00_172, BgL_symbzd2funzd2_174); 
if(
CBOOL(BgL_cfunz00_2726))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18767;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2303z00_2748;
BgL_arg2303z00_2748 = 
bgl_debug(); 
BgL_testz00_18767 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2303z00_2748), 
BINT(((long)0))); } 
if(BgL_testz00_18767)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32300ze3z83_10890;
BgL_zc3anonymousza32300ze3z83_10890 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32300ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3anonymousza32300ze3z83_10890, 
(int)(((long)6)), BgL_cfunz00_2726); 
return BgL_zc3anonymousza32300ze3z83_10890;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32302ze3z83_10891;
BgL_zc3anonymousza32302ze3z83_10891 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32302ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza32302ze3z83_10891, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3anonymousza32302ze3z83_10891, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3anonymousza32302ze3z83_10891, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3anonymousza32302ze3z83_10891, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3anonymousza32302ze3z83_10891, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3anonymousza32302ze3z83_10891, 
(int)(((long)5)), BgL_cfunz00_2726); 
return BgL_zc3anonymousza32302ze3z83_10891;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
CBOOL(BgL_tailzf3zf3_176))
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18808;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2397z00_2884;
BgL_arg2397z00_2884 = 
bgl_debug(); 
BgL_testz00_18808 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2397z00_2884), 
BINT(((long)0))); } 
if(BgL_testz00_18808)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32306ze3z83_10892;
BgL_zc3anonymousza32306ze3z83_10892 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32306ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3anonymousza32306ze3z83_10892, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3anonymousza32306ze3z83_10892;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32352ze3z83_10893;
BgL_zc3anonymousza32352ze3z83_10893 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32352ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3anonymousza32352ze3z83_10893, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3anonymousza32352ze3z83_10893;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_18853;
{ /* Eval/evaluate_comp.scm 889 */
int BgL_arg2491z00_3020;
BgL_arg2491z00_3020 = 
bgl_debug(); 
BgL_testz00_18853 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2491z00_3020), 
BINT(((long)0))); } 
if(BgL_testz00_18853)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32400ze3z83_10894;
BgL_zc3anonymousza32400ze3z83_10894 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32400ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3anonymousza32400ze3z83_10894, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3anonymousza32400ze3z83_10894;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_zc3anonymousza32446ze3z83_10895;
BgL_zc3anonymousza32446ze3z83_10895 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32446ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3anonymousza32446ze3z83_10895, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3anonymousza32446ze3z83_10895;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2300> */
obj_t BGl_z62zc3anonymousza32300ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10896, obj_t BgL_sz00_10904)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10897;obj_t BgL_a2z00_10898;obj_t BgL_a3z00_10899;obj_t BgL_a4z00_10900;long BgL_siza7eza7_10901;obj_t BgL_locz00_10902;obj_t BgL_cfunz00_10903;
BgL_a1z00_10897 = 
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)0))); 
BgL_a2z00_10898 = 
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)1))); 
BgL_a3z00_10899 = 
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)2))); 
BgL_a4z00_10900 = 
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)3))); 
BgL_siza7eza7_10901 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)4)))); 
BgL_locz00_10902 = 
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)5))); 
BgL_cfunz00_10903 = 
PROCEDURE_REF(BgL_envz00_10896, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13204;
BgL_bpz00_13204 = 
VECTOR_REF(
((obj_t)BgL_sz00_10904),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_13205;obj_t BgL_a2z00_13206;obj_t BgL_a3z00_13207;obj_t BgL_a4z00_13208;
BgL_a1z00_13205 = 
PROCEDURE_ENTRY(BgL_a1z00_10897)(BgL_a1z00_10897, BgL_sz00_10904, BEOA); 
BgL_a2z00_13206 = 
PROCEDURE_ENTRY(BgL_a2z00_10898)(BgL_a2z00_10898, BgL_sz00_10904, BEOA); 
BgL_a3z00_13207 = 
PROCEDURE_ENTRY(BgL_a3z00_10899)(BgL_a3z00_10899, BgL_sz00_10904, BEOA); 
BgL_a4z00_13208 = 
PROCEDURE_ENTRY(BgL_a4z00_10900)(BgL_a4z00_10900, BgL_sz00_10904, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13209;
BgL_nbpz00_13209 = 
(
(long)CINT(BgL_bpz00_13204)+BgL_siza7eza7_10901); 
VECTOR_SET(
((obj_t)BgL_sz00_10904),((long)0),
BINT(BgL_nbpz00_13209)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_18936;
BgL_tmpz00_18936 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18936, BgL_locz00_10902); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13210;
BgL_rz00_13210 = 
PROCEDURE_ENTRY(BgL_cfunz00_10903)(BgL_cfunz00_10903, BgL_a1z00_13205, BgL_a2z00_13206, BgL_a3z00_13207, BgL_a4z00_13208, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10904),((long)0),BgL_bpz00_13204); 
return BgL_rz00_13210;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2302> */
obj_t BGl_z62zc3anonymousza32302ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10905, obj_t BgL_sz00_10912)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_10906;obj_t BgL_a2z00_10907;obj_t BgL_a3z00_10908;obj_t BgL_a4z00_10909;long BgL_siza7eza7_10910;obj_t BgL_cfunz00_10911;
BgL_a1z00_10906 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)0))); 
BgL_a2z00_10907 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)1))); 
BgL_a3z00_10908 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)2))); 
BgL_a4z00_10909 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)3))); 
BgL_siza7eza7_10910 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)4)))); 
BgL_cfunz00_10911 = 
PROCEDURE_REF(BgL_envz00_10905, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13211;
BgL_bpz00_13211 = 
VECTOR_REF(
((obj_t)BgL_sz00_10912),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_a1z00_13212;obj_t BgL_a2z00_13213;obj_t BgL_a3z00_13214;obj_t BgL_a4z00_13215;
BgL_a1z00_13212 = 
PROCEDURE_ENTRY(BgL_a1z00_10906)(BgL_a1z00_10906, BgL_sz00_10912, BEOA); 
BgL_a2z00_13213 = 
PROCEDURE_ENTRY(BgL_a2z00_10907)(BgL_a2z00_10907, BgL_sz00_10912, BEOA); 
BgL_a3z00_13214 = 
PROCEDURE_ENTRY(BgL_a3z00_10908)(BgL_a3z00_10908, BgL_sz00_10912, BEOA); 
BgL_a4z00_13215 = 
PROCEDURE_ENTRY(BgL_a4z00_10909)(BgL_a4z00_10909, BgL_sz00_10912, BEOA); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13216;
BgL_nbpz00_13216 = 
(
(long)CINT(BgL_bpz00_13211)+BgL_siza7eza7_10910); 
VECTOR_SET(
((obj_t)BgL_sz00_10912),((long)0),
BINT(BgL_nbpz00_13216)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13217;
BgL_rz00_13217 = 
PROCEDURE_ENTRY(BgL_cfunz00_10911)(BgL_cfunz00_10911, BgL_a1z00_13212, BgL_a2z00_13213, BgL_a3z00_13214, BgL_a4z00_13215, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10912),((long)0),BgL_bpz00_13211); 
return BgL_rz00_13217;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2306> */
obj_t BGl_z62zc3anonymousza32306ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10913, obj_t BgL_sz00_10922)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10914;obj_t BgL_a1z00_10915;obj_t BgL_a2z00_10916;obj_t BgL_a3z00_10917;obj_t BgL_a4z00_10918;obj_t BgL_locz00_10919;obj_t BgL_symbzd2funzd2_10920;long BgL_siza7eza7_10921;
BgL_funz00_10914 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)0))); 
BgL_a1z00_10915 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)1))); 
BgL_a2z00_10916 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)2))); 
BgL_a3z00_10917 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)3))); 
BgL_a4z00_10918 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)4))); 
BgL_locz00_10919 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10920 = 
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)6))); 
BgL_siza7eza7_10921 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10913, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13218;
BgL_bpz00_13218 = 
VECTOR_REF(
((obj_t)BgL_sz00_10922),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13219;obj_t BgL_a1z00_13220;obj_t BgL_a2z00_13221;obj_t BgL_a3z00_13222;obj_t BgL_a4z00_13223;
BgL_fz00_13219 = 
PROCEDURE_ENTRY(BgL_funz00_10914)(BgL_funz00_10914, BgL_sz00_10922, BEOA); 
BgL_a1z00_13220 = 
PROCEDURE_ENTRY(BgL_a1z00_10915)(BgL_a1z00_10915, BgL_sz00_10922, BEOA); 
BgL_a2z00_13221 = 
PROCEDURE_ENTRY(BgL_a2z00_10916)(BgL_a2z00_10916, BgL_sz00_10922, BEOA); 
BgL_a3z00_13222 = 
PROCEDURE_ENTRY(BgL_a3z00_10917)(BgL_a3z00_10917, BgL_sz00_10922, BEOA); 
BgL_a4z00_13223 = 
PROCEDURE_ENTRY(BgL_a4z00_10918)(BgL_a4z00_10918, BgL_sz00_10922, BEOA); 
if(
PROCEDUREP(BgL_fz00_13219))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10919, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13219); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13224;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_19035;
BgL_tmpz00_19035 = 
((obj_t)BgL_fz00_13219); 
BgL_ufz00_13224 = 
PROCEDURE_ATTR(BgL_tmpz00_19035); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_19038;
if(
STRUCTP(BgL_ufz00_13224))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19038 = 
(
STRUCT_KEY(BgL_ufz00_13224)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19038 = ((bool_t)0)
; } 
if(BgL_testz00_19038)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13225;obj_t BgL_runz00_13226;obj_t BgL_sfz00_13227;
BgL_arityz00_13225 = 
STRUCT_REF(BgL_ufz00_13224, 
(int)(((long)0))); 
BgL_runz00_13226 = 
STRUCT_REF(BgL_ufz00_13224, 
(int)(((long)1))); 
BgL_sfz00_13227 = 
STRUCT_REF(BgL_ufz00_13224, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13225)==((long)4)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2310z00_13228;
BgL_arg2310z00_13228 = 
(
(long)CINT(BgL_bpz00_13218)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2310z00_13228,BgL_a1z00_13220); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2311z00_13229;
BgL_arg2311z00_13229 = 
(
(long)CINT(BgL_bpz00_13218)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2311z00_13229,BgL_a2z00_13221); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2312z00_13230;
BgL_arg2312z00_13230 = 
(
(long)CINT(BgL_bpz00_13218)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2312z00_13230,BgL_a3z00_13222); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2313z00_13231;
BgL_arg2313z00_13231 = 
(
(long)CINT(BgL_bpz00_13218)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2313z00_13231,BgL_a4z00_13223); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13225))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13225)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2315z00_13234;obj_t BgL_arg2316z00_13235;
BgL_arg2315z00_13234 = 
(
(long)CINT(BgL_bpz00_13218)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2317z00_13236;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2318z00_13237;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2319z00_13238;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2320z00_13239;
BgL_arg2320z00_13239 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13223, BNIL); 
BgL_arg2319z00_13238 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13222, BgL_arg2320z00_13239); } 
BgL_arg2318z00_13237 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13221, BgL_arg2319z00_13238); } 
BgL_list2317z00_13236 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13220, BgL_arg2318z00_13237); } 
BgL_arg2316z00_13235 = BgL_list2317z00_13236; } 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2315z00_13234,BgL_arg2316z00_13235); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2321z00_13240;
BgL_arg2321z00_13240 = 
(
(long)CINT(BgL_bpz00_13218)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2321z00_13240,BgL_a1z00_13220); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2322z00_13241;obj_t BgL_arg2323z00_13242;
BgL_arg2322z00_13241 = 
(
(long)CINT(BgL_bpz00_13218)+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2324z00_13243;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2325z00_13244;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2326z00_13245;
BgL_arg2326z00_13245 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13223, BNIL); 
BgL_arg2325z00_13244 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13222, BgL_arg2326z00_13245); } 
BgL_list2324z00_13243 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13221, BgL_arg2325z00_13244); } 
BgL_arg2323z00_13242 = BgL_list2324z00_13243; } 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2322z00_13241,BgL_arg2323z00_13242); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2327z00_13246;
BgL_arg2327z00_13246 = 
(
(long)CINT(BgL_bpz00_13218)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2327z00_13246,BgL_a1z00_13220); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2328z00_13247;
BgL_arg2328z00_13247 = 
(
(long)CINT(BgL_bpz00_13218)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2328z00_13247,BgL_a2z00_13221); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2329z00_13248;obj_t BgL_arg2330z00_13249;
BgL_arg2329z00_13248 = 
(
(long)CINT(BgL_bpz00_13218)+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2331z00_13250;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2332z00_13251;
BgL_arg2332z00_13251 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13223, BNIL); 
BgL_list2331z00_13250 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13222, BgL_arg2332z00_13251); } 
BgL_arg2330z00_13249 = BgL_list2331z00_13250; } 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2329z00_13248,BgL_arg2330z00_13249); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2333z00_13252;
BgL_arg2333z00_13252 = 
(
(long)CINT(BgL_bpz00_13218)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2333z00_13252,BgL_a1z00_13220); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2334z00_13253;
BgL_arg2334z00_13253 = 
(
(long)CINT(BgL_bpz00_13218)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2334z00_13253,BgL_a2z00_13221); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2335z00_13254;
BgL_arg2335z00_13254 = 
(
(long)CINT(BgL_bpz00_13218)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2335z00_13254,BgL_a3z00_13222); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2336z00_13255;obj_t BgL_arg2337z00_13256;
BgL_arg2336z00_13255 = 
(
(long)CINT(BgL_bpz00_13218)+((long)3)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2338z00_13257;
BgL_list2338z00_13257 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13223, BNIL); 
BgL_arg2337z00_13256 = BgL_list2338z00_13257; } 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2336z00_13255,BgL_arg2337z00_13256); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2339z00_13258;
BgL_arg2339z00_13258 = 
(
(long)CINT(BgL_bpz00_13218)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2339z00_13258,BgL_a1z00_13220); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2340z00_13259;
BgL_arg2340z00_13259 = 
(
(long)CINT(BgL_bpz00_13218)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2340z00_13259,BgL_a2z00_13221); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2341z00_13260;
BgL_arg2341z00_13260 = 
(
(long)CINT(BgL_bpz00_13218)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2341z00_13260,BgL_a3z00_13222); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2342z00_13261;
BgL_arg2342z00_13261 = 
(
(long)CINT(BgL_bpz00_13218)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2342z00_13261,BgL_a4z00_13223); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2343z00_13262;obj_t BgL_arg2344z00_13263;
BgL_arg2343z00_13262 = 
(
(long)CINT(BgL_bpz00_13218)+((long)4)); 
BgL_arg2344z00_13263 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10922),BgL_arg2343z00_13262,BgL_arg2344z00_13263); } break;
default: 
BgL_case_else1201z00_13232:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2346z00_13233;
BgL_arg2346z00_13233 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13224), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10919, BgL_arg2346z00_13233, 
(int)(((long)4)), 
CINT(BgL_arityz00_13225)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1201z00_13232;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13264;
BgL_z12denvz12_13264 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13264, BgL_locz00_10919); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10922, BgL_bpz00_13218, BgL_sfz00_13227))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_13226;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13265;
BgL_nsz00_13265 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2348z00_13266;
BgL_arg2348z00_13266 = 
(
(long)CINT(BgL_bpz00_13218)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13265, ((long)2), BgL_sz00_10922, BgL_bpz00_13218, 
BINT(BgL_arg2348z00_13266)); } 
VECTOR_SET(BgL_nsz00_13265,((long)1),BgL_sz00_10922); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13264, BgL_nsz00_13265); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13267;
BgL_ez00_13267 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13267, BgL_sz00_10922); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13268;
BgL_____rz00_13268 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13226, BgL_nsz00_13265, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13267); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13264, BgL_sz00_10922); 
return BgL_____rz00_13268;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13219, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13269;
BgL_nbpz00_13269 = 
(
(long)CINT(BgL_bpz00_13218)+BgL_siza7eza7_10921); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),((long)0),
BINT(BgL_nbpz00_13269)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_19173;
BgL_tmpz00_19173 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19173, BgL_locz00_10919); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13270;
BgL_rz00_13270 = 
PROCEDURE_ENTRY(BgL_fz00_13219)(BgL_fz00_13219, BgL_a1z00_13220, BgL_a2z00_13221, BgL_a3z00_13222, BgL_a4z00_13223, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10922),((long)0),BgL_bpz00_13218); 
return BgL_rz00_13270;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10919, BgL_symbzd2funzd2_10920, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13219));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2352> */
obj_t BGl_z62zc3anonymousza32352ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10923, obj_t BgL_sz00_10932)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10924;obj_t BgL_a1z00_10925;obj_t BgL_a2z00_10926;obj_t BgL_a3z00_10927;obj_t BgL_a4z00_10928;obj_t BgL_locz00_10929;obj_t BgL_symbzd2funzd2_10930;long BgL_siza7eza7_10931;
BgL_funz00_10924 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)0))); 
BgL_a1z00_10925 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)1))); 
BgL_a2z00_10926 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)2))); 
BgL_a3z00_10927 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)3))); 
BgL_a4z00_10928 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)4))); 
BgL_locz00_10929 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10930 = 
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)6))); 
BgL_siza7eza7_10931 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10923, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13271;
BgL_bpz00_13271 = 
VECTOR_REF(
((obj_t)BgL_sz00_10932),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13272;obj_t BgL_a1z00_13273;obj_t BgL_a2z00_13274;obj_t BgL_a3z00_13275;obj_t BgL_a4z00_13276;
BgL_fz00_13272 = 
PROCEDURE_ENTRY(BgL_funz00_10924)(BgL_funz00_10924, BgL_sz00_10932, BEOA); 
BgL_a1z00_13273 = 
PROCEDURE_ENTRY(BgL_a1z00_10925)(BgL_a1z00_10925, BgL_sz00_10932, BEOA); 
BgL_a2z00_13274 = 
PROCEDURE_ENTRY(BgL_a2z00_10926)(BgL_a2z00_10926, BgL_sz00_10932, BEOA); 
BgL_a3z00_13275 = 
PROCEDURE_ENTRY(BgL_a3z00_10927)(BgL_a3z00_10927, BgL_sz00_10932, BEOA); 
BgL_a4z00_13276 = 
PROCEDURE_ENTRY(BgL_a4z00_10928)(BgL_a4z00_10928, BgL_sz00_10932, BEOA); 
if(
PROCEDUREP(BgL_fz00_13272))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10929, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13272); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13277;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_19230;
BgL_tmpz00_19230 = 
((obj_t)BgL_fz00_13272); 
BgL_ufz00_13277 = 
PROCEDURE_ATTR(BgL_tmpz00_19230); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_19233;
if(
STRUCTP(BgL_ufz00_13277))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19233 = 
(
STRUCT_KEY(BgL_ufz00_13277)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19233 = ((bool_t)0)
; } 
if(BgL_testz00_19233)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13278;obj_t BgL_runz00_13279;obj_t BgL_sfz00_13280;
BgL_arityz00_13278 = 
STRUCT_REF(BgL_ufz00_13277, 
(int)(((long)0))); 
BgL_runz00_13279 = 
STRUCT_REF(BgL_ufz00_13277, 
(int)(((long)1))); 
BgL_sfz00_13280 = 
STRUCT_REF(BgL_ufz00_13277, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13278)==((long)4)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2356z00_13281;
BgL_arg2356z00_13281 = 
(
(long)CINT(BgL_bpz00_13271)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2356z00_13281,BgL_a1z00_13273); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2357z00_13282;
BgL_arg2357z00_13282 = 
(
(long)CINT(BgL_bpz00_13271)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2357z00_13282,BgL_a2z00_13274); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2358z00_13283;
BgL_arg2358z00_13283 = 
(
(long)CINT(BgL_bpz00_13271)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2358z00_13283,BgL_a3z00_13275); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2359z00_13284;
BgL_arg2359z00_13284 = 
(
(long)CINT(BgL_bpz00_13271)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2359z00_13284,BgL_a4z00_13276); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13278))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13278)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2361z00_13287;obj_t BgL_arg2362z00_13288;
BgL_arg2361z00_13287 = 
(
(long)CINT(BgL_bpz00_13271)+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2363z00_13289;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2364z00_13290;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2365z00_13291;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2366z00_13292;
BgL_arg2366z00_13292 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13276, BNIL); 
BgL_arg2365z00_13291 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13275, BgL_arg2366z00_13292); } 
BgL_arg2364z00_13290 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13274, BgL_arg2365z00_13291); } 
BgL_list2363z00_13289 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13273, BgL_arg2364z00_13290); } 
BgL_arg2362z00_13288 = BgL_list2363z00_13289; } 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2361z00_13287,BgL_arg2362z00_13288); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2367z00_13293;
BgL_arg2367z00_13293 = 
(
(long)CINT(BgL_bpz00_13271)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2367z00_13293,BgL_a1z00_13273); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2368z00_13294;obj_t BgL_arg2369z00_13295;
BgL_arg2368z00_13294 = 
(
(long)CINT(BgL_bpz00_13271)+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2370z00_13296;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2371z00_13297;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2372z00_13298;
BgL_arg2372z00_13298 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13276, BNIL); 
BgL_arg2371z00_13297 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13275, BgL_arg2372z00_13298); } 
BgL_list2370z00_13296 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13274, BgL_arg2371z00_13297); } 
BgL_arg2369z00_13295 = BgL_list2370z00_13296; } 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2368z00_13294,BgL_arg2369z00_13295); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2373z00_13299;
BgL_arg2373z00_13299 = 
(
(long)CINT(BgL_bpz00_13271)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2373z00_13299,BgL_a1z00_13273); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2374z00_13300;
BgL_arg2374z00_13300 = 
(
(long)CINT(BgL_bpz00_13271)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2374z00_13300,BgL_a2z00_13274); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2375z00_13301;obj_t BgL_arg2376z00_13302;
BgL_arg2375z00_13301 = 
(
(long)CINT(BgL_bpz00_13271)+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2377z00_13303;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2378z00_13304;
BgL_arg2378z00_13304 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13276, BNIL); 
BgL_list2377z00_13303 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13275, BgL_arg2378z00_13304); } 
BgL_arg2376z00_13302 = BgL_list2377z00_13303; } 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2375z00_13301,BgL_arg2376z00_13302); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2379z00_13305;
BgL_arg2379z00_13305 = 
(
(long)CINT(BgL_bpz00_13271)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2379z00_13305,BgL_a1z00_13273); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2380z00_13306;
BgL_arg2380z00_13306 = 
(
(long)CINT(BgL_bpz00_13271)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2380z00_13306,BgL_a2z00_13274); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2381z00_13307;
BgL_arg2381z00_13307 = 
(
(long)CINT(BgL_bpz00_13271)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2381z00_13307,BgL_a3z00_13275); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2382z00_13308;obj_t BgL_arg2383z00_13309;
BgL_arg2382z00_13308 = 
(
(long)CINT(BgL_bpz00_13271)+((long)3)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2384z00_13310;
BgL_list2384z00_13310 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13276, BNIL); 
BgL_arg2383z00_13309 = BgL_list2384z00_13310; } 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2382z00_13308,BgL_arg2383z00_13309); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2385z00_13311;
BgL_arg2385z00_13311 = 
(
(long)CINT(BgL_bpz00_13271)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2385z00_13311,BgL_a1z00_13273); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2386z00_13312;
BgL_arg2386z00_13312 = 
(
(long)CINT(BgL_bpz00_13271)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2386z00_13312,BgL_a2z00_13274); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2387z00_13313;
BgL_arg2387z00_13313 = 
(
(long)CINT(BgL_bpz00_13271)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2387z00_13313,BgL_a3z00_13275); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2388z00_13314;
BgL_arg2388z00_13314 = 
(
(long)CINT(BgL_bpz00_13271)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2388z00_13314,BgL_a4z00_13276); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2389z00_13315;obj_t BgL_arg2390z00_13316;
BgL_arg2389z00_13315 = 
(
(long)CINT(BgL_bpz00_13271)+((long)4)); 
BgL_arg2390z00_13316 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10932),BgL_arg2389z00_13315,BgL_arg2390z00_13316); } break;
default: 
BgL_case_else1203z00_13285:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2392z00_13286;
BgL_arg2392z00_13286 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13277), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10929, BgL_arg2392z00_13286, 
(int)(((long)4)), 
CINT(BgL_arityz00_13278)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1203z00_13285;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13317;
BgL_z12denvz12_13317 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10932, BgL_bpz00_13271, BgL_sfz00_13280))
{ /* Eval/evaluate_comp.scm 889 */
return BgL_runz00_13279;}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13318;
BgL_nsz00_13318 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2394z00_13319;
BgL_arg2394z00_13319 = 
(
(long)CINT(BgL_bpz00_13271)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13318, ((long)2), BgL_sz00_10932, BgL_bpz00_13271, 
BINT(BgL_arg2394z00_13319)); } 
VECTOR_SET(BgL_nsz00_13318,((long)1),BgL_sz00_10932); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13317, BgL_nsz00_13318); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13320;
BgL_ez00_13320 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13320, BgL_sz00_10932); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13321;
BgL_____rz00_13321 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13279, BgL_nsz00_13318, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13320); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13317, BgL_sz00_10932); 
return BgL_____rz00_13321;} } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13272, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13322;
BgL_nbpz00_13322 = 
(
(long)CINT(BgL_bpz00_13271)+BgL_siza7eza7_10931); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),((long)0),
BINT(BgL_nbpz00_13322)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13323;
BgL_rz00_13323 = 
PROCEDURE_ENTRY(BgL_fz00_13272)(BgL_fz00_13272, BgL_a1z00_13273, BgL_a2z00_13274, BgL_a3z00_13275, BgL_a4z00_13276, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10932),((long)0),BgL_bpz00_13271); 
return BgL_rz00_13323;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10929, BgL_symbzd2funzd2_10930, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13272));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2400> */
obj_t BGl_z62zc3anonymousza32400ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10933, obj_t BgL_sz00_10942)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10934;obj_t BgL_a1z00_10935;obj_t BgL_a2z00_10936;obj_t BgL_a3z00_10937;obj_t BgL_a4z00_10938;obj_t BgL_locz00_10939;obj_t BgL_symbzd2funzd2_10940;long BgL_siza7eza7_10941;
BgL_funz00_10934 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)0))); 
BgL_a1z00_10935 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)1))); 
BgL_a2z00_10936 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)2))); 
BgL_a3z00_10937 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)3))); 
BgL_a4z00_10938 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)4))); 
BgL_locz00_10939 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10940 = 
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)6))); 
BgL_siza7eza7_10941 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10933, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13324;
BgL_bpz00_13324 = 
VECTOR_REF(
((obj_t)BgL_sz00_10942),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13325;obj_t BgL_a1z00_13326;obj_t BgL_a2z00_13327;obj_t BgL_a3z00_13328;obj_t BgL_a4z00_13329;
BgL_fz00_13325 = 
PROCEDURE_ENTRY(BgL_funz00_10934)(BgL_funz00_10934, BgL_sz00_10942, BEOA); 
BgL_a1z00_13326 = 
PROCEDURE_ENTRY(BgL_a1z00_10935)(BgL_a1z00_10935, BgL_sz00_10942, BEOA); 
BgL_a2z00_13327 = 
PROCEDURE_ENTRY(BgL_a2z00_10936)(BgL_a2z00_10936, BgL_sz00_10942, BEOA); 
BgL_a3z00_13328 = 
PROCEDURE_ENTRY(BgL_a3z00_10937)(BgL_a3z00_10937, BgL_sz00_10942, BEOA); 
BgL_a4z00_13329 = 
PROCEDURE_ENTRY(BgL_a4z00_10938)(BgL_a4z00_10938, BgL_sz00_10942, BEOA); 
if(
PROCEDUREP(BgL_fz00_13325))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10939, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13325); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13330;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_19421;
BgL_tmpz00_19421 = 
((obj_t)BgL_fz00_13325); 
BgL_ufz00_13330 = 
PROCEDURE_ATTR(BgL_tmpz00_19421); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_19424;
if(
STRUCTP(BgL_ufz00_13330))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19424 = 
(
STRUCT_KEY(BgL_ufz00_13330)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19424 = ((bool_t)0)
; } 
if(BgL_testz00_19424)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13331;obj_t BgL_runz00_13332;obj_t BgL_sfz00_13333;
BgL_arityz00_13331 = 
STRUCT_REF(BgL_ufz00_13330, 
(int)(((long)0))); 
BgL_runz00_13332 = 
STRUCT_REF(BgL_ufz00_13330, 
(int)(((long)1))); 
BgL_sfz00_13333 = 
STRUCT_REF(BgL_ufz00_13330, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_13334;
BgL_spz00_13334 = 
(
(long)CINT(BgL_bpz00_13324)+BgL_siza7eza7_10941); 
if(
(
(long)CINT(BgL_arityz00_13331)==((long)4)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2404z00_13335;
BgL_arg2404z00_13335 = 
(BgL_spz00_13334+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2404z00_13335,BgL_a1z00_13326); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2405z00_13336;
BgL_arg2405z00_13336 = 
(BgL_spz00_13334+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2405z00_13336,BgL_a2z00_13327); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2406z00_13337;
BgL_arg2406z00_13337 = 
(BgL_spz00_13334+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2406z00_13337,BgL_a3z00_13328); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2407z00_13338;
BgL_arg2407z00_13338 = 
(BgL_spz00_13334+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2407z00_13338,BgL_a4z00_13329); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13331))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13331)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2409z00_13341;obj_t BgL_arg2410z00_13342;
BgL_arg2409z00_13341 = 
(BgL_spz00_13334+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2411z00_13343;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2412z00_13344;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2413z00_13345;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2414z00_13346;
BgL_arg2414z00_13346 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13329, BNIL); 
BgL_arg2413z00_13345 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13328, BgL_arg2414z00_13346); } 
BgL_arg2412z00_13344 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13327, BgL_arg2413z00_13345); } 
BgL_list2411z00_13343 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13326, BgL_arg2412z00_13344); } 
BgL_arg2410z00_13342 = BgL_list2411z00_13343; } 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2409z00_13341,BgL_arg2410z00_13342); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2415z00_13347;
BgL_arg2415z00_13347 = 
(BgL_spz00_13334+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2415z00_13347,BgL_a1z00_13326); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2416z00_13348;obj_t BgL_arg2417z00_13349;
BgL_arg2416z00_13348 = 
(BgL_spz00_13334+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2418z00_13350;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2419z00_13351;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2420z00_13352;
BgL_arg2420z00_13352 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13329, BNIL); 
BgL_arg2419z00_13351 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13328, BgL_arg2420z00_13352); } 
BgL_list2418z00_13350 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13327, BgL_arg2419z00_13351); } 
BgL_arg2417z00_13349 = BgL_list2418z00_13350; } 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2416z00_13348,BgL_arg2417z00_13349); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2421z00_13353;
BgL_arg2421z00_13353 = 
(BgL_spz00_13334+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2421z00_13353,BgL_a1z00_13326); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2422z00_13354;
BgL_arg2422z00_13354 = 
(BgL_spz00_13334+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2422z00_13354,BgL_a2z00_13327); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2423z00_13355;obj_t BgL_arg2424z00_13356;
BgL_arg2423z00_13355 = 
(BgL_spz00_13334+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2425z00_13357;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2426z00_13358;
BgL_arg2426z00_13358 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13329, BNIL); 
BgL_list2425z00_13357 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13328, BgL_arg2426z00_13358); } 
BgL_arg2424z00_13356 = BgL_list2425z00_13357; } 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2423z00_13355,BgL_arg2424z00_13356); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2427z00_13359;
BgL_arg2427z00_13359 = 
(BgL_spz00_13334+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2427z00_13359,BgL_a1z00_13326); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2428z00_13360;
BgL_arg2428z00_13360 = 
(BgL_spz00_13334+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2428z00_13360,BgL_a2z00_13327); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2429z00_13361;
BgL_arg2429z00_13361 = 
(BgL_spz00_13334+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2429z00_13361,BgL_a3z00_13328); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2430z00_13362;obj_t BgL_arg2431z00_13363;
BgL_arg2430z00_13362 = 
(BgL_spz00_13334+((long)3)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2432z00_13364;
BgL_list2432z00_13364 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13329, BNIL); 
BgL_arg2431z00_13363 = BgL_list2432z00_13364; } 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2430z00_13362,BgL_arg2431z00_13363); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2433z00_13365;
BgL_arg2433z00_13365 = 
(BgL_spz00_13334+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2433z00_13365,BgL_a1z00_13326); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2434z00_13366;
BgL_arg2434z00_13366 = 
(BgL_spz00_13334+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2434z00_13366,BgL_a2z00_13327); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2435z00_13367;
BgL_arg2435z00_13367 = 
(BgL_spz00_13334+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2435z00_13367,BgL_a3z00_13328); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2436z00_13368;
BgL_arg2436z00_13368 = 
(BgL_spz00_13334+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2436z00_13368,BgL_a4z00_13329); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2437z00_13369;obj_t BgL_arg2438z00_13370;
BgL_arg2437z00_13369 = 
(BgL_spz00_13334+((long)4)); 
BgL_arg2438z00_13370 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10942),BgL_arg2437z00_13369,BgL_arg2438z00_13370); } break;
default: 
BgL_case_else1205z00_13339:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2440z00_13340;
BgL_arg2440z00_13340 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13330), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10939, BgL_arg2440z00_13340, 
(int)(((long)4)), 
CINT(BgL_arityz00_13331)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1205z00_13339;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13371;
BgL_z12denvz12_13371 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13371, BgL_locz00_10939); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10942, 
BINT(BgL_spz00_13334), BgL_sfz00_13333))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13332, BgL_sz00_10942, 
BINT(BgL_spz00_13334));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13372;
BgL_nsz00_13372 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2442z00_13373;
BgL_arg2442z00_13373 = 
(BgL_spz00_13334+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13372, ((long)2), BgL_sz00_10942, 
BINT(BgL_spz00_13334), 
BINT(BgL_arg2442z00_13373)); } 
VECTOR_SET(BgL_nsz00_13372,((long)1),BgL_sz00_10942); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13371, BgL_nsz00_13372); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13374;
BgL_ez00_13374 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13374, BgL_sz00_10942); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13375;
BgL_____rz00_13375 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13332, BgL_nsz00_13372, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13374); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13371, BgL_sz00_10942); 
return BgL_____rz00_13375;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13325, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13376;
BgL_nbpz00_13376 = 
(
(long)CINT(BgL_bpz00_13324)+BgL_siza7eza7_10941); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),((long)0),
BINT(BgL_nbpz00_13376)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_19545;
BgL_tmpz00_19545 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19545, BgL_locz00_10939); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13377;
BgL_rz00_13377 = 
PROCEDURE_ENTRY(BgL_fz00_13325)(BgL_fz00_13325, BgL_a1z00_13326, BgL_a2z00_13327, BgL_a3z00_13328, BgL_a4z00_13329, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10942),((long)0),BgL_bpz00_13324); 
return BgL_rz00_13377;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10939, BgL_symbzd2funzd2_10940, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13325));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2446> */
obj_t BGl_z62zc3anonymousza32446ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10943, obj_t BgL_sz00_10952)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_funz00_10944;obj_t BgL_a1z00_10945;obj_t BgL_a2z00_10946;obj_t BgL_a3z00_10947;obj_t BgL_a4z00_10948;obj_t BgL_locz00_10949;obj_t BgL_symbzd2funzd2_10950;long BgL_siza7eza7_10951;
BgL_funz00_10944 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)0))); 
BgL_a1z00_10945 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)1))); 
BgL_a2z00_10946 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)2))); 
BgL_a3z00_10947 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)3))); 
BgL_a4z00_10948 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)4))); 
BgL_locz00_10949 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10950 = 
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)6))); 
BgL_siza7eza7_10951 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10943, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_bpz00_13378;
BgL_bpz00_13378 = 
VECTOR_REF(
((obj_t)BgL_sz00_10952),((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_fz00_13379;obj_t BgL_a1z00_13380;obj_t BgL_a2z00_13381;obj_t BgL_a3z00_13382;obj_t BgL_a4z00_13383;
BgL_fz00_13379 = 
PROCEDURE_ENTRY(BgL_funz00_10944)(BgL_funz00_10944, BgL_sz00_10952, BEOA); 
BgL_a1z00_13380 = 
PROCEDURE_ENTRY(BgL_a1z00_10945)(BgL_a1z00_10945, BgL_sz00_10952, BEOA); 
BgL_a2z00_13381 = 
PROCEDURE_ENTRY(BgL_a2z00_10946)(BgL_a2z00_10946, BgL_sz00_10952, BEOA); 
BgL_a3z00_13382 = 
PROCEDURE_ENTRY(BgL_a3z00_10947)(BgL_a3z00_10947, BgL_sz00_10952, BEOA); 
BgL_a4z00_13383 = 
PROCEDURE_ENTRY(BgL_a4z00_10948)(BgL_a4z00_10948, BgL_sz00_10952, BEOA); 
if(
PROCEDUREP(BgL_fz00_13379))
{ /* Eval/evaluate_comp.scm 889 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 889 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10949, BGl_string5194z00zz__evaluate_compz00, BGl_string5210z00zz__evaluate_compz00, BgL_fz00_13379); } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ufz00_13384;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_tmpz00_19602;
BgL_tmpz00_19602 = 
((obj_t)BgL_fz00_13379); 
BgL_ufz00_13384 = 
PROCEDURE_ATTR(BgL_tmpz00_19602); } 
{ /* Eval/evaluate_comp.scm 889 */
bool_t BgL_testz00_19605;
if(
STRUCTP(BgL_ufz00_13384))
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19605 = 
(
STRUCT_KEY(BgL_ufz00_13384)==BGl_symbol5211z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 676 */
BgL_testz00_19605 = ((bool_t)0)
; } 
if(BgL_testz00_19605)
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arityz00_13385;obj_t BgL_runz00_13386;obj_t BgL_sfz00_13387;
BgL_arityz00_13385 = 
STRUCT_REF(BgL_ufz00_13384, 
(int)(((long)0))); 
BgL_runz00_13386 = 
STRUCT_REF(BgL_ufz00_13384, 
(int)(((long)1))); 
BgL_sfz00_13387 = 
STRUCT_REF(BgL_ufz00_13384, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_spz00_13388;
BgL_spz00_13388 = 
(
(long)CINT(BgL_bpz00_13378)+BgL_siza7eza7_10951); 
if(
(
(long)CINT(BgL_arityz00_13385)==((long)4)))
{ /* Eval/evaluate_comp.scm 889 */
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2450z00_13389;
BgL_arg2450z00_13389 = 
(BgL_spz00_13388+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2450z00_13389,BgL_a1z00_13380); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2451z00_13390;
BgL_arg2451z00_13390 = 
(BgL_spz00_13388+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2451z00_13390,BgL_a2z00_13381); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2452z00_13391;
BgL_arg2452z00_13391 = 
(BgL_spz00_13388+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2452z00_13391,BgL_a3z00_13382); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2453z00_13392;
BgL_arg2453z00_13392 = 
(BgL_spz00_13388+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2453z00_13392,BgL_a4z00_13383); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13385))
{ /* Eval/evaluate_comp.scm 889 */
switch( 
(long)CINT(BgL_arityz00_13385)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2455z00_13395;obj_t BgL_arg2456z00_13396;
BgL_arg2455z00_13395 = 
(BgL_spz00_13388+((long)0)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2457z00_13397;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2458z00_13398;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2459z00_13399;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2460z00_13400;
BgL_arg2460z00_13400 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13383, BNIL); 
BgL_arg2459z00_13399 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13382, BgL_arg2460z00_13400); } 
BgL_arg2458z00_13398 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13381, BgL_arg2459z00_13399); } 
BgL_list2457z00_13397 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13380, BgL_arg2458z00_13398); } 
BgL_arg2456z00_13396 = BgL_list2457z00_13397; } 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2455z00_13395,BgL_arg2456z00_13396); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2461z00_13401;
BgL_arg2461z00_13401 = 
(BgL_spz00_13388+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2461z00_13401,BgL_a1z00_13380); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2462z00_13402;obj_t BgL_arg2463z00_13403;
BgL_arg2462z00_13402 = 
(BgL_spz00_13388+((long)1)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2464z00_13404;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2465z00_13405;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2466z00_13406;
BgL_arg2466z00_13406 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13383, BNIL); 
BgL_arg2465z00_13405 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13382, BgL_arg2466z00_13406); } 
BgL_list2464z00_13404 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13381, BgL_arg2465z00_13405); } 
BgL_arg2463z00_13403 = BgL_list2464z00_13404; } 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2462z00_13402,BgL_arg2463z00_13403); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2467z00_13407;
BgL_arg2467z00_13407 = 
(BgL_spz00_13388+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2467z00_13407,BgL_a1z00_13380); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2468z00_13408;
BgL_arg2468z00_13408 = 
(BgL_spz00_13388+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2468z00_13408,BgL_a2z00_13381); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2469z00_13409;obj_t BgL_arg2470z00_13410;
BgL_arg2469z00_13409 = 
(BgL_spz00_13388+((long)2)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2471z00_13411;
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2472z00_13412;
BgL_arg2472z00_13412 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13383, BNIL); 
BgL_list2471z00_13411 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13382, BgL_arg2472z00_13412); } 
BgL_arg2470z00_13410 = BgL_list2471z00_13411; } 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2469z00_13409,BgL_arg2470z00_13410); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2473z00_13413;
BgL_arg2473z00_13413 = 
(BgL_spz00_13388+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2473z00_13413,BgL_a1z00_13380); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2474z00_13414;
BgL_arg2474z00_13414 = 
(BgL_spz00_13388+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2474z00_13414,BgL_a2z00_13381); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2475z00_13415;
BgL_arg2475z00_13415 = 
(BgL_spz00_13388+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2475z00_13415,BgL_a3z00_13382); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2476z00_13416;obj_t BgL_arg2477z00_13417;
BgL_arg2476z00_13416 = 
(BgL_spz00_13388+((long)3)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_list2478z00_13418;
BgL_list2478z00_13418 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13383, BNIL); 
BgL_arg2477z00_13417 = BgL_list2478z00_13418; } 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2476z00_13416,BgL_arg2477z00_13417); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2479z00_13419;
BgL_arg2479z00_13419 = 
(BgL_spz00_13388+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2479z00_13419,BgL_a1z00_13380); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2480z00_13420;
BgL_arg2480z00_13420 = 
(BgL_spz00_13388+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2480z00_13420,BgL_a2z00_13381); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2481z00_13421;
BgL_arg2481z00_13421 = 
(BgL_spz00_13388+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2481z00_13421,BgL_a3z00_13382); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2482z00_13422;
BgL_arg2482z00_13422 = 
(BgL_spz00_13388+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2482z00_13422,BgL_a4z00_13383); } 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2483z00_13423;obj_t BgL_arg2484z00_13424;
BgL_arg2483z00_13423 = 
(BgL_spz00_13388+((long)4)); 
BgL_arg2484z00_13424 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10952),BgL_arg2483z00_13423,BgL_arg2484z00_13424); } break;
default: 
BgL_case_else1207z00_13393:
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_arg2486z00_13394;
BgL_arg2486z00_13394 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13384), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10949, BgL_arg2486z00_13394, 
(int)(((long)4)), 
CINT(BgL_arityz00_13385)); } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
goto BgL_case_else1207z00_13393;} } 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_z12denvz12_13425;
BgL_z12denvz12_13425 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10952, 
BINT(BgL_spz00_13388), BgL_sfz00_13387))
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13386, BgL_sz00_10952, 
BINT(BgL_spz00_13388));}  else 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_nsz00_13426;
BgL_nsz00_13426 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 889 */
long BgL_arg2488z00_13427;
BgL_arg2488z00_13427 = 
(BgL_spz00_13388+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13426, ((long)2), BgL_sz00_10952, 
BINT(BgL_spz00_13388), 
BINT(BgL_arg2488z00_13427)); } 
VECTOR_SET(BgL_nsz00_13426,((long)1),BgL_sz00_10952); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13425, BgL_nsz00_13426); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_ez00_13428;
BgL_ez00_13428 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13428, BgL_sz00_10952); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_____rz00_13429;
BgL_____rz00_13429 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13386, BgL_nsz00_13426, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13428); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13425, BgL_sz00_10952); 
return BgL_____rz00_13429;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 889 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13379, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 889 */
long BgL_nbpz00_13430;
BgL_nbpz00_13430 = 
(
(long)CINT(BgL_bpz00_13378)+BgL_siza7eza7_10951); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),((long)0),
BINT(BgL_nbpz00_13430)); 
{ /* Eval/evaluate_comp.scm 889 */
obj_t BgL_rz00_13431;
BgL_rz00_13431 = 
PROCEDURE_ENTRY(BgL_fz00_13379)(BgL_fz00_13379, BgL_a1z00_13380, BgL_a2z00_13381, BgL_a3z00_13382, BgL_a4z00_13383, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10952),((long)0),BgL_bpz00_13378); 
return BgL_rz00_13431;} }  else 
{ /* Eval/evaluate_comp.scm 889 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10949, BgL_symbzd2funzd2_10950, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13379));} } } } } } } } 
BGL_FUNCTION_END;
}



/* is-constant-fun? */
obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185, obj_t BgL_symbzd2funzd2_186)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 892 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_gz00_3023;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2498z00_3031;obj_t BgL_arg2499z00_3032;
BgL_arg2498z00_3031 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_modz00); 
BgL_arg2499z00_3032 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_namez00); 
BgL_gz00_3023 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2498z00_3031, BgL_arg2499z00_3032); } 
if(
CBOOL(BgL_gz00_3023))
{ /* Eval/evaluate_comp.scm 898 */
bool_t BgL_testz00_19747;
{ /* Eval/evaluate_comp.scm 898 */
int BgL_arg2497z00_3030;
{ /* Eval/evaluate_comp.scm 898 */
int BgL_res4525z00_8166;
BgL_res4525z00_8166 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3023),((long)0))); 
BgL_arg2497z00_3030 = BgL_res4525z00_8166; } 
BgL_testz00_19747 = 
(
(long)(BgL_arg2497z00_3030)==((long)0)); } 
if(BgL_testz00_19747)
{ /* Eval/evaluate_comp.scm 899 */
obj_t BgL_valz00_3026;
BgL_valz00_3026 = 
VECTOR_REF(
((obj_t)BgL_gz00_3023),((long)2)); 
{ /* Eval/evaluate_comp.scm 900 */
bool_t BgL_testz00_19755;
if(
PROCEDUREP(BgL_valz00_3026))
{ /* Eval/evaluate_comp.scm 900 */
BgL_testz00_19755 = 
PROCEDURE_CORRECT_ARITYP(BgL_valz00_3026, 
(int)(BgL_nbargsz00_184))
; }  else 
{ /* Eval/evaluate_comp.scm 900 */
BgL_testz00_19755 = ((bool_t)0)
; } 
if(BgL_testz00_19755)
{ /* Eval/evaluate_comp.scm 900 */
return BgL_valz00_3026;}  else 
{ /* Eval/evaluate_comp.scm 900 */
return BFALSE;} } }  else 
{ /* Eval/evaluate_comp.scm 898 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 897 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 903 */
bool_t BgL_testz00_19760;
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 904 */
obj_t BgL_tmpz00_19764;
BgL_tmpz00_19764 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_testz00_19760 = 
PROCEDUREP(BgL_tmpz00_19764); }  else 
{ /* Eval/evaluate_comp.scm 903 */
BgL_testz00_19760 = ((bool_t)0)
; } 
if(BgL_testz00_19760)
{ /* Eval/evaluate_comp.scm 906 */
bool_t BgL_testz00_19768;
{ /* Eval/evaluate_comp.scm 906 */
obj_t BgL_arg2507z00_3042;
BgL_arg2507z00_3042 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_testz00_19768 = 
PROCEDURE_CORRECT_ARITYP(BgL_arg2507z00_3042, 
(int)(BgL_nbargsz00_184)); } 
if(BgL_testz00_19768)
{ /* Eval/evaluate_comp.scm 906 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00);}  else 
{ /* Eval/evaluate_comp.scm 908 */
int BgL_arg2505z00_3040;
{ /* Eval/evaluate_comp.scm 908 */
obj_t BgL_arg2506z00_3041;
BgL_arg2506z00_3041 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_arg2505z00_3040 = 
PROCEDURE_ARITY(BgL_arg2506z00_3041); } 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185, BgL_symbzd2funzd2_186, 
(int)(BgL_nbargsz00_184), BgL_arg2505z00_3040);} }  else 
{ /* Eval/evaluate_comp.scm 903 */
return BFALSE;} } } 
BGL_FUNCTION_END;
}



/* compile-float-arith */
obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_exprz00_187, obj_t BgL_stkz00_188)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 911 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 915 */
if(
INTEGERP(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00)))
{ /* Eval/evaluate_comp.scm 917 */
obj_t BgL_v1346z00_3051;
BgL_v1346z00_3051 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1346z00_3051,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 917 */
double BgL_arg2512z00_3052;
BgL_arg2512z00_3052 = 
(double)(
(long)CINT(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00))); 
VECTOR_SET(BgL_v1346z00_3051,((long)1),
DOUBLE_TO_REAL(BgL_arg2512z00_3052)); } 
return BgL_v1346z00_3051;}  else 
{ /* Eval/evaluate_comp.scm 918 */
bool_t BgL_testz00_19795;
{ /* Eval/evaluate_comp.scm 918 */
obj_t BgL_tmpz00_19796;
BgL_tmpz00_19796 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
BgL_testz00_19795 = 
REALP(BgL_tmpz00_19796); } 
if(BgL_testz00_19795)
{ /* Eval/evaluate_comp.scm 918 */
obj_t BgL_v1347z00_3056;
BgL_v1347z00_3056 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1347z00_3056,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 918 */
obj_t BgL_arg2516z00_3057;
BgL_arg2516z00_3057 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
VECTOR_SET(BgL_v1347z00_3056,((long)1),BgL_arg2516z00_3057); } 
return BgL_v1347z00_3056;}  else 
{ /* Eval/evaluate_comp.scm 919 */
obj_t BgL_v1348z00_3058;
BgL_v1348z00_3058 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1348z00_3058,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 919 */
obj_t BgL_arg2517z00_3059;
BgL_arg2517z00_3059 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_littz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1348z00_3058,((long)1),BgL_arg2517z00_3059); } 
return BgL_v1348z00_3058;} } }  else 
{ /* Eval/evaluate_comp.scm 915 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 920 */
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_exprz00_187)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 923 */
obj_t BgL_v1349z00_3065;
BgL_v1349z00_3065 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1349z00_3065,((long)0),
BINT(((long)3))); 
VECTOR_SET(BgL_v1349z00_3065,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1349z00_3065;}  else 
{ /* Eval/evaluate_comp.scm 924 */
obj_t BgL_v1350z00_3067;
BgL_v1350z00_3067 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1350z00_3067,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1350z00_3067,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1350z00_3067;} }  else 
{ /* Eval/evaluate_comp.scm 920 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 927 */
obj_t BgL_gz00_3071;
{ /* Eval/evaluate_comp.scm 927 */
obj_t BgL_arg2529z00_3079;obj_t BgL_arg2530z00_3080;
BgL_arg2529z00_3079 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_modz00); 
BgL_arg2530z00_3080 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_namez00); 
BgL_gz00_3071 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2529z00_3079, BgL_arg2530z00_3080); } 
if(
CBOOL(BgL_gz00_3071))
{ /* Eval/evaluate_comp.scm 929 */
bool_t BgL_testz00_19838;
{ /* Eval/evaluate_comp.scm 929 */
int BgL_arg2527z00_3076;
{ /* Eval/evaluate_comp.scm 929 */
int BgL_res4532z00_8189;
BgL_res4532z00_8189 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3071),((long)0))); 
BgL_arg2527z00_3076 = BgL_res4532z00_8189; } 
BgL_testz00_19838 = 
(
BINT(BgL_arg2527z00_3076)==
BINT(((long)1))); } 
if(BgL_testz00_19838)
{ /* Eval/evaluate_comp.scm 930 */
obj_t BgL_v1351z00_3074;
BgL_v1351z00_3074 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1351z00_3074,((long)0),
BINT(((long)4))); 
VECTOR_SET(BgL_v1351z00_3074,((long)1),BgL_gz00_3071); 
return BgL_v1351z00_3074;}  else 
{ /* Eval/evaluate_comp.scm 931 */
obj_t BgL_v1352z00_3075;
BgL_v1352z00_3075 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1352z00_3075,((long)0),
BINT(((long)5))); 
VECTOR_SET(BgL_v1352z00_3075,((long)1),BgL_gz00_3071); 
return BgL_v1352z00_3075;} }  else 
{ /* Eval/evaluate_comp.scm 932 */
obj_t BgL_v1353z00_3077;
BgL_v1353z00_3077 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1353z00_3077,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 932 */
obj_t BgL_arg2528z00_3078;
BgL_arg2528z00_3078 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_globalz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1353z00_3077,((long)1),BgL_arg2528z00_3078); } 
return BgL_v1353z00_3077;} }  else 
{ /* Eval/evaluate_comp.scm 925 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_appz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 935 */
obj_t BgL_fvalz00_3083;
{ /* Eval/evaluate_comp.scm 935 */
BgL_ev_exprz00_bglt BgL_arg2572z00_3131;
BgL_arg2572z00_3131 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_funz00); 
BgL_fvalz00_3083 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_arg2572z00_3131); } 
if(
(BgL_fvalz00_3083==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_v1354z00_3085;
BgL_v1354z00_3085 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1354z00_3085,((long)0),
BINT(((long)6))); 
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_arg2533z00_3086;
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_arg2534z00_3087;
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_pairz00_8197;
BgL_pairz00_8197 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2534z00_3087 = 
CAR(BgL_pairz00_8197); } 
BgL_arg2533z00_3086 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2534z00_3087, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1354z00_3085,((long)1),BgL_arg2533z00_3086); } 
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_arg2536z00_3089;
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_arg2537z00_3090;
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_pairz00_8199;
BgL_pairz00_8199 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2537z00_3090 = 
CAR(
CDR(BgL_pairz00_8199)); } 
BgL_arg2536z00_3089 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2537z00_3090, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1354z00_3085,((long)2),BgL_arg2536z00_3089); } 
return BgL_v1354z00_3085;}  else 
{ /* Eval/evaluate_comp.scm 937 */
if(
(BgL_fvalz00_3083==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_v1355z00_3093;
BgL_v1355z00_3093 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1355z00_3093,((long)0),
BINT(((long)7))); 
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_arg2540z00_3094;
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_arg2541z00_3095;
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_pairz00_8205;
BgL_pairz00_8205 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2541z00_3095 = 
CAR(BgL_pairz00_8205); } 
BgL_arg2540z00_3094 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2541z00_3095, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3093,((long)1),BgL_arg2540z00_3094); } 
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_arg2543z00_3097;
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_arg2544z00_3098;
{ /* Eval/evaluate_comp.scm 940 */
obj_t BgL_pairz00_8207;
BgL_pairz00_8207 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2544z00_3098 = 
CAR(
CDR(BgL_pairz00_8207)); } 
BgL_arg2543z00_3097 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2544z00_3098, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3093,((long)2),BgL_arg2543z00_3097); } 
return BgL_v1355z00_3093;}  else 
{ /* Eval/evaluate_comp.scm 939 */
if(
(BgL_fvalz00_3083==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_v1356z00_3101;
BgL_v1356z00_3101 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1356z00_3101,((long)0),
BINT(((long)8))); 
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_arg2547z00_3102;
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_arg2548z00_3103;
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_pairz00_8213;
BgL_pairz00_8213 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2548z00_3103 = 
CAR(BgL_pairz00_8213); } 
BgL_arg2547z00_3102 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2548z00_3103, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3101,((long)1),BgL_arg2547z00_3102); } 
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_arg2550z00_3105;
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_arg2551z00_3106;
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_pairz00_8215;
BgL_pairz00_8215 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2551z00_3106 = 
CAR(
CDR(BgL_pairz00_8215)); } 
BgL_arg2550z00_3105 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2551z00_3106, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3101,((long)2),BgL_arg2550z00_3105); } 
return BgL_v1356z00_3101;}  else 
{ /* Eval/evaluate_comp.scm 941 */
if(
(BgL_fvalz00_3083==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_v1357z00_3109;
BgL_v1357z00_3109 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1357z00_3109,((long)0),
BINT(((long)9))); 
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_arg2554z00_3110;
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_arg2555z00_3111;
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_pairz00_8221;
BgL_pairz00_8221 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2555z00_3111 = 
CAR(BgL_pairz00_8221); } 
BgL_arg2554z00_3110 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2555z00_3111, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3109,((long)1),BgL_arg2554z00_3110); } 
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_arg2557z00_3113;
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_arg2558z00_3114;
{ /* Eval/evaluate_comp.scm 944 */
obj_t BgL_pairz00_8223;
BgL_pairz00_8223 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2558z00_3114 = 
CAR(
CDR(BgL_pairz00_8223)); } 
BgL_arg2557z00_3113 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2558z00_3114, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3109,((long)2),BgL_arg2557z00_3113); } 
return BgL_v1357z00_3109;}  else 
{ /* Eval/evaluate_comp.scm 943 */
if(
(BgL_fvalz00_3083==BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 946 */
obj_t BgL_v1358z00_3117;
BgL_v1358z00_3117 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1358z00_3117,((long)0),
BINT(((long)10))); 
{ /* Eval/evaluate_comp.scm 946 */
obj_t BgL_arg2561z00_3118;
{ /* Eval/evaluate_comp.scm 946 */
obj_t BgL_arg2562z00_3119;
{ /* Eval/evaluate_comp.scm 946 */
obj_t BgL_pairz00_8229;
BgL_pairz00_8229 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2562z00_3119 = 
CAR(BgL_pairz00_8229); } 
BgL_arg2561z00_3118 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2562z00_3119), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1358z00_3117,((long)1),BgL_arg2561z00_3118); } 
return BgL_v1358z00_3117;}  else 
{ /* Eval/evaluate_comp.scm 945 */
if(
(BgL_fvalz00_3083==BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_v1359z00_3122;
BgL_v1359z00_3122 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1359z00_3122,((long)0),
BINT(((long)11))); 
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_arg2565z00_3123;
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_arg2566z00_3124;
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_pairz00_8232;
BgL_pairz00_8232 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2566z00_3124 = 
CAR(BgL_pairz00_8232); } 
BgL_arg2565z00_3123 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2566z00_3124), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1359z00_3122,((long)1),BgL_arg2565z00_3123); } 
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_arg2568z00_3126;
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_arg2569z00_3127;
{ /* Eval/evaluate_comp.scm 948 */
obj_t BgL_pairz00_8234;
BgL_pairz00_8234 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2569z00_3127 = 
CAR(
CDR(BgL_pairz00_8234)); } 
BgL_arg2568z00_3126 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2569z00_3127), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1359z00_3122,((long)2),BgL_arg2568z00_3126); } 
return BgL_v1359z00_3122;}  else 
{ /* Eval/evaluate_comp.scm 950 */
obj_t BgL_v1360z00_3129;
BgL_v1360z00_3129 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1360z00_3129,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 950 */
obj_t BgL_arg2571z00_3130;
BgL_arg2571z00_3130 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_appz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1360z00_3129,((long)1),BgL_arg2571z00_3130); } 
return BgL_v1360z00_3129;} } } } } } }  else 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_v1361z00_3132;
BgL_v1361z00_3132 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1361z00_3132,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2573z00_3133;
BgL_arg2573z00_3133 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_exprz00_187), BgL_stkz00_188); 
VECTOR_SET(BgL_v1361z00_3132,((long)1),BgL_arg2573z00_3133); } 
return BgL_v1361z00_3132;} } } } } 
BGL_FUNCTION_END;
}



/* eval-float-arith */
double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189, obj_t BgL_sz00_190)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 953 */
return 
REAL_TO_DOUBLE(
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190, BgL_bcz00_189));} 
BGL_FUNCTION_END;
}



/* E~0 */
obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_12615, obj_t BgL_bcz00_3138)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 968 */
{ 

{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_aux1217z00_3141;
BgL_aux1217z00_3141 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)0)); 
if(
INTEGERP(BgL_aux1217z00_3141))
{ /* Eval/evaluate_comp.scm 955 */
switch( 
(long)CINT(BgL_aux1217z00_3141)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 956 */
obj_t BgL_fun2577z00_3143;
BgL_fun2577z00_3143 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
return 
PROCEDURE_ENTRY(BgL_fun2577z00_3143)(BgL_fun2577z00_3143, BgL_sz00_12615, BEOA);} break;case ((long)1) : 

return 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1));break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 958 */
long BgL_arg2578z00_3144;
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_arg2579z00_3145;obj_t BgL_arg2580z00_3146;
BgL_arg2579z00_3145 = 
VECTOR_REF(
((obj_t)BgL_sz00_12615),((long)0)); 
BgL_arg2580z00_3146 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2578z00_3144 = 
(
(long)CINT(BgL_arg2579z00_3145)+
(long)CINT(BgL_arg2580z00_3146)); } 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12615),BgL_arg2578z00_3144);} break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 959 */
obj_t BgL_arg2581z00_3147;
{ /* Eval/evaluate_comp.scm 959 */
long BgL_arg2582z00_3148;
{ /* Eval/evaluate_comp.scm 959 */
obj_t BgL_arg2583z00_3149;obj_t BgL_arg2584z00_3150;
BgL_arg2583z00_3149 = 
VECTOR_REF(
((obj_t)BgL_sz00_12615),((long)0)); 
BgL_arg2584z00_3150 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2582z00_3148 = 
(
(long)CINT(BgL_arg2583z00_3149)+
(long)CINT(BgL_arg2584z00_3150)); } 
BgL_arg2581z00_3147 = 
VECTOR_REF(
((obj_t)BgL_sz00_12615),BgL_arg2582z00_3148); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2581z00_3147), 
(int)(((long)0)));} break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 960 */
obj_t BgL_arg2585z00_3151;
{ /* Eval/evaluate_comp.scm 960 */
obj_t BgL_arg2586z00_3152;
BgL_arg2586z00_3152 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2585z00_3151 = 
VECTOR_REF(
((obj_t)BgL_arg2586z00_3152),((long)2)); } 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2585z00_3151);} break;case ((long)5) : 

{ /* Eval/evaluate_comp.scm 961 */
obj_t BgL_arg2587z00_3153;
BgL_arg2587z00_3153 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_arg2587z00_3153),((long)2));} break;case ((long)6) : 

{ /* Eval/evaluate_comp.scm 962 */
obj_t BgL_arg2588z00_3154;obj_t BgL_arg2589z00_3155;
{ /* Eval/evaluate_comp.scm 962 */
obj_t BgL_arg2590z00_3156;
BgL_arg2590z00_3156 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2588z00_3154 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2590z00_3156); } 
{ /* Eval/evaluate_comp.scm 962 */
obj_t BgL_arg2591z00_3157;
BgL_arg2591z00_3157 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)2)); 
BgL_arg2589z00_3155 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2591z00_3157); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2588z00_3154)+
REAL_TO_DOUBLE(BgL_arg2589z00_3155)));} break;case ((long)7) : 

{ /* Eval/evaluate_comp.scm 963 */
obj_t BgL_arg2592z00_3158;obj_t BgL_arg2593z00_3159;
{ /* Eval/evaluate_comp.scm 963 */
obj_t BgL_arg2594z00_3160;
BgL_arg2594z00_3160 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2592z00_3158 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2594z00_3160); } 
{ /* Eval/evaluate_comp.scm 963 */
obj_t BgL_arg2595z00_3161;
BgL_arg2595z00_3161 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)2)); 
BgL_arg2593z00_3159 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2595z00_3161); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2592z00_3158)-
REAL_TO_DOUBLE(BgL_arg2593z00_3159)));} break;case ((long)8) : 

{ /* Eval/evaluate_comp.scm 964 */
obj_t BgL_arg2596z00_3162;obj_t BgL_arg2597z00_3163;
{ /* Eval/evaluate_comp.scm 964 */
obj_t BgL_arg2598z00_3164;
BgL_arg2598z00_3164 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2596z00_3162 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2598z00_3164); } 
{ /* Eval/evaluate_comp.scm 964 */
obj_t BgL_arg2599z00_3165;
BgL_arg2599z00_3165 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)2)); 
BgL_arg2597z00_3163 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2599z00_3165); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2596z00_3162)*
REAL_TO_DOUBLE(BgL_arg2597z00_3163)));} break;case ((long)9) : 

{ /* Eval/evaluate_comp.scm 965 */
obj_t BgL_arg2600z00_3166;obj_t BgL_arg2601z00_3167;
{ /* Eval/evaluate_comp.scm 965 */
obj_t BgL_arg2602z00_3168;
BgL_arg2602z00_3168 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2600z00_3166 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2602z00_3168); } 
{ /* Eval/evaluate_comp.scm 965 */
obj_t BgL_arg2603z00_3169;
BgL_arg2603z00_3169 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)2)); 
BgL_arg2601z00_3167 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12615, BgL_arg2603z00_3169); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2600z00_3166)/
REAL_TO_DOUBLE(BgL_arg2601z00_3167)));} break;case ((long)10) : 

{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2604z00_3170;
{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_fun2605z00_3171;
BgL_fun2605z00_3171 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2604z00_3170 = 
PROCEDURE_ENTRY(BgL_fun2605z00_3171)(BgL_fun2605z00_3171, BgL_sz00_12615, BEOA); } 
return 
DOUBLE_TO_REAL(
(double)(
(long)CINT(BgL_arg2604z00_3170)));} break;case ((long)11) : 

{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2606z00_3172;obj_t BgL_arg2607z00_3173;
{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_fun2608z00_3174;
BgL_fun2608z00_3174 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)1)); 
BgL_arg2606z00_3172 = 
PROCEDURE_ENTRY(BgL_fun2608z00_3174)(BgL_fun2608z00_3174, BgL_sz00_12615, BEOA); } 
{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_fun2609z00_3175;
BgL_fun2609z00_3175 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)2)); 
BgL_arg2607z00_3173 = 
PROCEDURE_ENTRY(BgL_fun2609z00_3175)(BgL_fun2609z00_3175, BgL_sz00_12615, BEOA); } 
{ /* Eval/evaluate_comp.scm 967 */
double BgL_tmpz00_20076;
{ /* Eval/evaluate_comp.scm 967 */
long BgL_tmpz00_20077;
BgL_tmpz00_20077 = 
(long)CINT(BgL_arg2607z00_3173); 
BgL_tmpz00_20076 = 
BGL_F64VREF(BgL_arg2606z00_3172, BgL_tmpz00_20077); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20076);} } break;
default: 
BgL_case_else1216z00_3140:
{ /* Eval/evaluate_comp.scm 968 */
obj_t BgL_arg2610z00_3176;
BgL_arg2610z00_3176 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3138),((long)0)); 
return 
BGl_errorz00zz__errorz00(BGl_string5194z00zz__evaluate_compz00, BGl_string5213z00zz__evaluate_compz00, BgL_arg2610z00_3176);} } }  else 
{ /* Eval/evaluate_comp.scm 955 */
goto BgL_case_else1216z00_3140;} } } } 
BGL_FUNCTION_END;
}



/* arith-expression */
obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_exprz00_191, obj_t BgL_stkz00_192)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 971 */
{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_fvalz00_3179;
BgL_fvalz00_3179 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_exprz00_191))->BgL_funz00)); 
{ /* Eval/evaluate_comp.scm 974 */
bool_t BgL_testz00_20088;
if(
(BgL_fvalz00_3179==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 974 */
BgL_testz00_20088 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 974 */
if(
(BgL_fvalz00_3179==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 974 */
BgL_testz00_20088 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 974 */
if(
(BgL_fvalz00_3179==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 974 */
BgL_testz00_20088 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 974 */
BgL_testz00_20088 = 
(BgL_fvalz00_3179==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00)
; } } } 
if(BgL_testz00_20088)
{ /* Eval/evaluate_comp.scm 975 */
obj_t BgL_bcz00_3184;
BgL_bcz00_3184 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
((obj_t)BgL_exprz00_191), BgL_stkz00_192); 
{ /* Eval/evaluate_comp.scm 976 */
obj_t BgL_zc3anonymousza32615ze3z83_10970;
BgL_zc3anonymousza32615ze3z83_10970 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32615ze3z83_10970, 
(int)(((long)0)), BgL_bcz00_3184); 
return BgL_zc3anonymousza32615ze3z83_10970;} }  else 
{ /* Eval/evaluate_comp.scm 974 */
return BFALSE;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2615> */
obj_t BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_10971, obj_t BgL_sz00_10973)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 976 */
{ /* Eval/evaluate_comp.scm 976 */
obj_t BgL_bcz00_10972;
BgL_bcz00_10972 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10971, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 976 */
double BgL_tmpz00_20106;
{ /* Eval/evaluate_comp.scm 976 */
obj_t BgL_bpz00_13432;
BgL_bpz00_13432 = 
VECTOR_REF(
((obj_t)BgL_sz00_10973),((long)0)); 
BgL_tmpz00_20106 = 
BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_10972, BgL_sz00_10973); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20106);} } } 
BGL_FUNCTION_END;
}



/* inline-call */
obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193, BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195, obj_t BgL_stkz00_196)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1005 */
{ /* Eval/evaluate_comp.scm 1006 */
obj_t BgL_valz00_3192;
BgL_valz00_3192 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194); 
if(
CBOOL(BgL_valz00_3192))
{ /* Eval/evaluate_comp.scm 1008 */
long BgL_nz00_3193;
BgL_nz00_3193 = 
bgl_list_length(BgL_argsz00_195); 
{ /* Eval/evaluate_comp.scm 1009 */
obj_t BgL__ortest_1223z00_3194;
if(
(BgL_nz00_3193==((long)1)))
{ /* Eval/evaluate_comp.scm 1010 */
obj_t BgL_a1z00_3485;
BgL_a1z00_3485 = 
CAR(
((obj_t)BgL_argsz00_195)); 
if(
(BgL_valz00_3192==BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_3487;
BgL_a1z00_3487 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3485), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_zc3anonymousza32732ze3z83_11003;
BgL_zc3anonymousza32732ze3z83_11003 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32732ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32732ze3z83_11003, 
(int)(((long)0)), BgL_a1z00_3487); 
PROCEDURE_SET(BgL_zc3anonymousza32732ze3z83_11003, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1223z00_3194 = BgL_zc3anonymousza32732ze3z83_11003; } }  else 
{ /* Eval/evaluate_comp.scm 1011 */
if(
(BgL_valz00_3192==BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_3494;
BgL_a1z00_3494 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3485), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_zc3anonymousza32735ze3z83_11004;
BgL_zc3anonymousza32735ze3z83_11004 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32735ze3z83_11004, 
(int)(((long)0)), BgL_a1z00_3494); 
PROCEDURE_SET(BgL_zc3anonymousza32735ze3z83_11004, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1223z00_3194 = BgL_zc3anonymousza32735ze3z83_11004; } }  else 
{ /* Eval/evaluate_comp.scm 1011 */
if(
(BgL_valz00_3192==BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_3501;
BgL_a1z00_3501 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3485), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_zc3anonymousza32738ze3z83_11005;
BgL_zc3anonymousza32738ze3z83_11005 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32738ze3z83_11005, 
(int)(((long)0)), BgL_a1z00_3501); 
PROCEDURE_SET(BgL_zc3anonymousza32738ze3z83_11005, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1223z00_3194 = BgL_zc3anonymousza32738ze3z83_11005; } }  else 
{ /* Eval/evaluate_comp.scm 1011 */
BgL__ortest_1223z00_3194 = BFALSE; } } } }  else 
{ /* Eval/evaluate_comp.scm 1009 */
BgL__ortest_1223z00_3194 = BFALSE; } 
if(
CBOOL(BgL__ortest_1223z00_3194))
{ /* Eval/evaluate_comp.scm 1009 */
return BgL__ortest_1223z00_3194;}  else 
{ /* Eval/evaluate_comp.scm 1009 */
if(
(BgL_nz00_3193==((long)2)))
{ /* Eval/evaluate_comp.scm 1013 */
obj_t BgL_a1z00_3196;obj_t BgL_a2z00_3197;
BgL_a1z00_3196 = 
CAR(
((obj_t)BgL_argsz00_195)); 
{ /* Eval/evaluate_comp.scm 1013 */
obj_t BgL_pairz00_8314;
BgL_pairz00_8314 = 
CDR(
((obj_t)BgL_argsz00_195)); 
BgL_a2z00_3197 = 
CAR(BgL_pairz00_8314); } 
if(
(BgL_valz00_3192==BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3199;obj_t BgL_a2z00_3200;
BgL_a1z00_3199 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3200 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32619ze3z83_10974;
BgL_zc3anonymousza32619ze3z83_10974 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32619ze3z83_10974, 
(int)(((long)0)), BgL_a1z00_3199); 
PROCEDURE_SET(BgL_zc3anonymousza32619ze3z83_10974, 
(int)(((long)1)), BgL_a2z00_3200); 
PROCEDURE_SET(BgL_zc3anonymousza32619ze3z83_10974, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32619ze3z83_10974;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3209;obj_t BgL_a2z00_3210;
BgL_a1z00_3209 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3210 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32623ze3z83_10975;
BgL_zc3anonymousza32623ze3z83_10975 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32623ze3z83_10975, 
(int)(((long)0)), BgL_a1z00_3209); 
PROCEDURE_SET(BgL_zc3anonymousza32623ze3z83_10975, 
(int)(((long)1)), BgL_a2z00_3210); 
PROCEDURE_SET(BgL_zc3anonymousza32623ze3z83_10975, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32623ze3z83_10975;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_za2zd2envz70zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3219;obj_t BgL_a2z00_3220;
BgL_a1z00_3219 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3220 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32627ze3z83_10976;
BgL_zc3anonymousza32627ze3z83_10976 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32627ze3z83_10976, 
(int)(((long)0)), BgL_a1z00_3219); 
PROCEDURE_SET(BgL_zc3anonymousza32627ze3z83_10976, 
(int)(((long)1)), BgL_a2z00_3220); 
PROCEDURE_SET(BgL_zc3anonymousza32627ze3z83_10976, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32627ze3z83_10976;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3229;obj_t BgL_a2z00_3230;
BgL_a1z00_3229 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3230 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32631ze3z83_10977;
BgL_zc3anonymousza32631ze3z83_10977 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32631ze3z83_10977, 
(int)(((long)0)), BgL_a1z00_3229); 
PROCEDURE_SET(BgL_zc3anonymousza32631ze3z83_10977, 
(int)(((long)1)), BgL_a2z00_3230); 
PROCEDURE_SET(BgL_zc3anonymousza32631ze3z83_10977, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32631ze3z83_10977;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3239;obj_t BgL_a2z00_3240;
BgL_a1z00_3239 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3240 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32635ze3z83_10978;
BgL_zc3anonymousza32635ze3z83_10978 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32635ze3z83_10978, 
(int)(((long)0)), BgL_a1z00_3239); 
PROCEDURE_SET(BgL_zc3anonymousza32635ze3z83_10978, 
(int)(((long)1)), BgL_a2z00_3240); 
PROCEDURE_SET(BgL_zc3anonymousza32635ze3z83_10978, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32635ze3z83_10978;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3249;obj_t BgL_a2z00_3250;
BgL_a1z00_3249 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3250 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32639ze3z83_10979;
BgL_zc3anonymousza32639ze3z83_10979 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32639ze3z83_10979, 
(int)(((long)0)), BgL_a1z00_3249); 
PROCEDURE_SET(BgL_zc3anonymousza32639ze3z83_10979, 
(int)(((long)1)), BgL_a2z00_3250); 
PROCEDURE_SET(BgL_zc3anonymousza32639ze3z83_10979, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32639ze3z83_10979;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3259;obj_t BgL_a2z00_3260;
BgL_a1z00_3259 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3260 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32643ze3z83_10980;
BgL_zc3anonymousza32643ze3z83_10980 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32643ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32643ze3z83_10980, 
(int)(((long)0)), BgL_a1z00_3259); 
PROCEDURE_SET(BgL_zc3anonymousza32643ze3z83_10980, 
(int)(((long)1)), BgL_a2z00_3260); 
PROCEDURE_SET(BgL_zc3anonymousza32643ze3z83_10980, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32643ze3z83_10980;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3269;obj_t BgL_a2z00_3270;
BgL_a1z00_3269 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3270 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32647ze3z83_10981;
BgL_zc3anonymousza32647ze3z83_10981 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32647ze3z83_10981, 
(int)(((long)0)), BgL_a1z00_3269); 
PROCEDURE_SET(BgL_zc3anonymousza32647ze3z83_10981, 
(int)(((long)1)), BgL_a2z00_3270); 
PROCEDURE_SET(BgL_zc3anonymousza32647ze3z83_10981, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32647ze3z83_10981;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3279;obj_t BgL_a2z00_3280;
BgL_a1z00_3279 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3280 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32651ze3z83_10982;
BgL_zc3anonymousza32651ze3z83_10982 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32651ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32651ze3z83_10982, 
(int)(((long)0)), BgL_a1z00_3279); 
PROCEDURE_SET(BgL_zc3anonymousza32651ze3z83_10982, 
(int)(((long)1)), BgL_a2z00_3280); 
PROCEDURE_SET(BgL_zc3anonymousza32651ze3z83_10982, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32651ze3z83_10982;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3289;obj_t BgL_a2z00_3290;
BgL_a1z00_3289 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3290 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32655ze3z83_10983;
BgL_zc3anonymousza32655ze3z83_10983 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32655ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32655ze3z83_10983, 
(int)(((long)0)), BgL_a1z00_3289); 
PROCEDURE_SET(BgL_zc3anonymousza32655ze3z83_10983, 
(int)(((long)1)), BgL_a2z00_3290); 
PROCEDURE_SET(BgL_zc3anonymousza32655ze3z83_10983, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32655ze3z83_10983;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3299;obj_t BgL_a2z00_3300;
BgL_a1z00_3299 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3300 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32659ze3z83_10984;
BgL_zc3anonymousza32659ze3z83_10984 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32659ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32659ze3z83_10984, 
(int)(((long)0)), BgL_a1z00_3299); 
PROCEDURE_SET(BgL_zc3anonymousza32659ze3z83_10984, 
(int)(((long)1)), BgL_a2z00_3300); 
PROCEDURE_SET(BgL_zc3anonymousza32659ze3z83_10984, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32659ze3z83_10984;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3309;obj_t BgL_a2z00_3310;
BgL_a1z00_3309 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3310 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32663ze3z83_10985;
BgL_zc3anonymousza32663ze3z83_10985 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32663ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32663ze3z83_10985, 
(int)(((long)0)), BgL_a1z00_3309); 
PROCEDURE_SET(BgL_zc3anonymousza32663ze3z83_10985, 
(int)(((long)1)), BgL_a2z00_3310); 
PROCEDURE_SET(BgL_zc3anonymousza32663ze3z83_10985, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32663ze3z83_10985;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3319;obj_t BgL_a2z00_3320;
BgL_a1z00_3319 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3320 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32667ze3z83_10986;
BgL_zc3anonymousza32667ze3z83_10986 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32667ze3z83_10986, 
(int)(((long)0)), BgL_a1z00_3319); 
PROCEDURE_SET(BgL_zc3anonymousza32667ze3z83_10986, 
(int)(((long)1)), BgL_a2z00_3320); 
PROCEDURE_SET(BgL_zc3anonymousza32667ze3z83_10986, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32667ze3z83_10986;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3329;obj_t BgL_a2z00_3330;
BgL_a1z00_3329 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3330 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32671ze3z83_10987;
BgL_zc3anonymousza32671ze3z83_10987 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32671ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32671ze3z83_10987, 
(int)(((long)0)), BgL_a1z00_3329); 
PROCEDURE_SET(BgL_zc3anonymousza32671ze3z83_10987, 
(int)(((long)1)), BgL_a2z00_3330); 
PROCEDURE_SET(BgL_zc3anonymousza32671ze3z83_10987, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32671ze3z83_10987;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3339;obj_t BgL_a2z00_3340;
BgL_a1z00_3339 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3340 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32675ze3z83_10988;
BgL_zc3anonymousza32675ze3z83_10988 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32675ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32675ze3z83_10988, 
(int)(((long)0)), BgL_a1z00_3339); 
PROCEDURE_SET(BgL_zc3anonymousza32675ze3z83_10988, 
(int)(((long)1)), BgL_a2z00_3340); 
PROCEDURE_SET(BgL_zc3anonymousza32675ze3z83_10988, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32675ze3z83_10988;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3349;obj_t BgL_a2z00_3350;
BgL_a1z00_3349 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3350 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32679ze3z83_10989;
BgL_zc3anonymousza32679ze3z83_10989 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32679ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32679ze3z83_10989, 
(int)(((long)0)), BgL_a1z00_3349); 
PROCEDURE_SET(BgL_zc3anonymousza32679ze3z83_10989, 
(int)(((long)1)), BgL_a2z00_3350); 
PROCEDURE_SET(BgL_zc3anonymousza32679ze3z83_10989, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32679ze3z83_10989;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3359;obj_t BgL_a2z00_3360;
BgL_a1z00_3359 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3360 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32683ze3z83_10990;
BgL_zc3anonymousza32683ze3z83_10990 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32683ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32683ze3z83_10990, 
(int)(((long)0)), BgL_a1z00_3359); 
PROCEDURE_SET(BgL_zc3anonymousza32683ze3z83_10990, 
(int)(((long)1)), BgL_a2z00_3360); 
PROCEDURE_SET(BgL_zc3anonymousza32683ze3z83_10990, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32683ze3z83_10990;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3369;obj_t BgL_a2z00_3370;
BgL_a1z00_3369 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3370 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32687ze3z83_10991;
BgL_zc3anonymousza32687ze3z83_10991 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32687ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32687ze3z83_10991, 
(int)(((long)0)), BgL_a1z00_3369); 
PROCEDURE_SET(BgL_zc3anonymousza32687ze3z83_10991, 
(int)(((long)1)), BgL_a2z00_3370); 
PROCEDURE_SET(BgL_zc3anonymousza32687ze3z83_10991, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32687ze3z83_10991;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3379;obj_t BgL_a2z00_3380;
BgL_a1z00_3379 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3380 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32691ze3z83_10992;
BgL_zc3anonymousza32691ze3z83_10992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32691ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32691ze3z83_10992, 
(int)(((long)0)), BgL_a1z00_3379); 
PROCEDURE_SET(BgL_zc3anonymousza32691ze3z83_10992, 
(int)(((long)1)), BgL_a2z00_3380); 
PROCEDURE_SET(BgL_zc3anonymousza32691ze3z83_10992, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32691ze3z83_10992;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3389;obj_t BgL_a2z00_3390;
BgL_a1z00_3389 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3390 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32695ze3z83_10993;
BgL_zc3anonymousza32695ze3z83_10993 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32695ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32695ze3z83_10993, 
(int)(((long)0)), BgL_a1z00_3389); 
PROCEDURE_SET(BgL_zc3anonymousza32695ze3z83_10993, 
(int)(((long)1)), BgL_a2z00_3390); 
PROCEDURE_SET(BgL_zc3anonymousza32695ze3z83_10993, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32695ze3z83_10993;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3399;obj_t BgL_a2z00_3400;
BgL_a1z00_3399 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3400 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32699ze3z83_10994;
BgL_zc3anonymousza32699ze3z83_10994 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32699ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32699ze3z83_10994, 
(int)(((long)0)), BgL_a1z00_3399); 
PROCEDURE_SET(BgL_zc3anonymousza32699ze3z83_10994, 
(int)(((long)1)), BgL_a2z00_3400); 
PROCEDURE_SET(BgL_zc3anonymousza32699ze3z83_10994, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32699ze3z83_10994;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3409;obj_t BgL_a2z00_3410;
BgL_a1z00_3409 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3410 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32703ze3z83_10995;
BgL_zc3anonymousza32703ze3z83_10995 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32703ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32703ze3z83_10995, 
(int)(((long)0)), BgL_a1z00_3409); 
PROCEDURE_SET(BgL_zc3anonymousza32703ze3z83_10995, 
(int)(((long)1)), BgL_a2z00_3410); 
PROCEDURE_SET(BgL_zc3anonymousza32703ze3z83_10995, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32703ze3z83_10995;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3419;obj_t BgL_a2z00_3420;
BgL_a1z00_3419 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3420 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32707ze3z83_10996;
BgL_zc3anonymousza32707ze3z83_10996 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32707ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32707ze3z83_10996, 
(int)(((long)0)), BgL_a1z00_3419); 
PROCEDURE_SET(BgL_zc3anonymousza32707ze3z83_10996, 
(int)(((long)1)), BgL_a2z00_3420); 
PROCEDURE_SET(BgL_zc3anonymousza32707ze3z83_10996, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32707ze3z83_10996;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3429;obj_t BgL_a2z00_3430;
BgL_a1z00_3429 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3430 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32711ze3z83_10997;
BgL_zc3anonymousza32711ze3z83_10997 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32711ze3z83_10997, 
(int)(((long)0)), BgL_a1z00_3429); 
PROCEDURE_SET(BgL_zc3anonymousza32711ze3z83_10997, 
(int)(((long)1)), BgL_a2z00_3430); 
PROCEDURE_SET(BgL_zc3anonymousza32711ze3z83_10997, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32711ze3z83_10997;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3439;obj_t BgL_a2z00_3440;
BgL_a1z00_3439 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3440 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32715ze3z83_10998;
BgL_zc3anonymousza32715ze3z83_10998 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32715ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32715ze3z83_10998, 
(int)(((long)0)), BgL_a1z00_3439); 
PROCEDURE_SET(BgL_zc3anonymousza32715ze3z83_10998, 
(int)(((long)1)), BgL_a2z00_3440); 
PROCEDURE_SET(BgL_zc3anonymousza32715ze3z83_10998, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32715ze3z83_10998;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3449;obj_t BgL_a2z00_3450;
BgL_a1z00_3449 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3450 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32719ze3z83_10999;
BgL_zc3anonymousza32719ze3z83_10999 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32719ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32719ze3z83_10999, 
(int)(((long)0)), BgL_a1z00_3449); 
PROCEDURE_SET(BgL_zc3anonymousza32719ze3z83_10999, 
(int)(((long)1)), BgL_a2z00_3450); 
PROCEDURE_SET(BgL_zc3anonymousza32719ze3z83_10999, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32719ze3z83_10999;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3459;obj_t BgL_a2z00_3460;
BgL_a1z00_3459 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3460 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32723ze3z83_11000;
BgL_zc3anonymousza32723ze3z83_11000 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32723ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32723ze3z83_11000, 
(int)(((long)0)), BgL_a1z00_3459); 
PROCEDURE_SET(BgL_zc3anonymousza32723ze3z83_11000, 
(int)(((long)1)), BgL_a2z00_3460); 
PROCEDURE_SET(BgL_zc3anonymousza32723ze3z83_11000, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3anonymousza32723ze3z83_11000;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3469;obj_t BgL_a2z00_3470;
BgL_a1z00_3469 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3470 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32727ze3z83_11001;
BgL_zc3anonymousza32727ze3z83_11001 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32727ze3z83_11001, 
(int)(((long)0)), BgL_a1z00_3469); 
PROCEDURE_SET(BgL_zc3anonymousza32727ze3z83_11001, 
(int)(((long)1)), BgL_a2z00_3470); 
return BgL_zc3anonymousza32727ze3z83_11001;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
if(
(BgL_valz00_3192==BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_3477;obj_t BgL_a2z00_3478;
BgL_a1z00_3477 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3196), BgL_stkz00_196); 
BgL_a2z00_3478 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3197), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_zc3anonymousza32729ze3z83_11002;
BgL_zc3anonymousza32729ze3z83_11002 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32729ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32729ze3z83_11002, 
(int)(((long)0)), BgL_a1z00_3477); 
PROCEDURE_SET(BgL_zc3anonymousza32729ze3z83_11002, 
(int)(((long)1)), BgL_a2z00_3478); 
return BgL_zc3anonymousza32729ze3z83_11002;} }  else 
{ /* Eval/evaluate_comp.scm 1014 */
return BFALSE;} } } } } } } } } } } } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate_comp.scm 1012 */
return BFALSE;} } } }  else 
{ /* Eval/evaluate_comp.scm 1007 */
return BFALSE;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2619> */
obj_t BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11006, obj_t BgL_sz00_11010)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11007;obj_t BgL_a2z00_11008;obj_t BgL_locz00_11009;
BgL_a1z00_11007 = 
PROCEDURE_REF(BgL_envz00_11006, 
(int)(((long)0))); 
BgL_a2z00_11008 = 
PROCEDURE_REF(BgL_envz00_11006, 
(int)(((long)1))); 
BgL_locz00_11009 = 
PROCEDURE_REF(BgL_envz00_11006, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13433;
BgL_bpz00_13433 = 
VECTOR_REF(
((obj_t)BgL_sz00_11010),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13434;obj_t BgL_a2z00_13435;
BgL_a1z00_13434 = 
PROCEDURE_ENTRY(BgL_a1z00_11007)(BgL_a1z00_11007, BgL_sz00_11010, BEOA); 
BgL_a2z00_13435 = 
PROCEDURE_ENTRY(BgL_a2z00_11008)(BgL_a2z00_11008, BgL_sz00_11010, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13434))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5214z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13434, BgL_locz00_11009); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13435))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5214z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13435, BgL_locz00_11009); } 
return 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_13434, BgL_a2z00_13435);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2623> */
obj_t BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11011, obj_t BgL_sz00_11015)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11012;obj_t BgL_a2z00_11013;obj_t BgL_locz00_11014;
BgL_a1z00_11012 = 
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)0))); 
BgL_a2z00_11013 = 
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)1))); 
BgL_locz00_11014 = 
PROCEDURE_REF(BgL_envz00_11011, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13436;
BgL_bpz00_13436 = 
VECTOR_REF(
((obj_t)BgL_sz00_11015),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13437;obj_t BgL_a2z00_13438;
BgL_a1z00_13437 = 
PROCEDURE_ENTRY(BgL_a1z00_11012)(BgL_a1z00_11012, BgL_sz00_11015, BEOA); 
BgL_a2z00_13438 = 
PROCEDURE_ENTRY(BgL_a2z00_11013)(BgL_a2z00_11013, BgL_sz00_11015, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13437))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5218z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13437, BgL_locz00_11014); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13438))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5218z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13438, BgL_locz00_11014); } 
return 
BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_13437, BgL_a2z00_13438);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2627> */
obj_t BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11016, obj_t BgL_sz00_11020)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11017;obj_t BgL_a2z00_11018;obj_t BgL_locz00_11019;
BgL_a1z00_11017 = 
PROCEDURE_REF(BgL_envz00_11016, 
(int)(((long)0))); 
BgL_a2z00_11018 = 
PROCEDURE_REF(BgL_envz00_11016, 
(int)(((long)1))); 
BgL_locz00_11019 = 
PROCEDURE_REF(BgL_envz00_11016, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13439;
BgL_bpz00_13439 = 
VECTOR_REF(
((obj_t)BgL_sz00_11020),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13440;obj_t BgL_a2z00_13441;
BgL_a1z00_13440 = 
PROCEDURE_ENTRY(BgL_a1z00_11017)(BgL_a1z00_11017, BgL_sz00_11020, BEOA); 
BgL_a2z00_13441 = 
PROCEDURE_ENTRY(BgL_a2z00_11018)(BgL_a2z00_11018, BgL_sz00_11020, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13440))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5220z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13440, BgL_locz00_11019); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13441))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5220z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13441, BgL_locz00_11019); } 
return 
BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_13440, BgL_a2z00_13441);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2631> */
obj_t BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11021, obj_t BgL_sz00_11025)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11022;obj_t BgL_a2z00_11023;obj_t BgL_locz00_11024;
BgL_a1z00_11022 = 
PROCEDURE_REF(BgL_envz00_11021, 
(int)(((long)0))); 
BgL_a2z00_11023 = 
PROCEDURE_REF(BgL_envz00_11021, 
(int)(((long)1))); 
BgL_locz00_11024 = 
PROCEDURE_REF(BgL_envz00_11021, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13442;
BgL_bpz00_13442 = 
VECTOR_REF(
((obj_t)BgL_sz00_11025),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13443;obj_t BgL_a2z00_13444;
BgL_a1z00_13443 = 
PROCEDURE_ENTRY(BgL_a1z00_11022)(BgL_a1z00_11022, BgL_sz00_11025, BEOA); 
BgL_a2z00_13444 = 
PROCEDURE_ENTRY(BgL_a2z00_11023)(BgL_a2z00_11023, BgL_sz00_11025, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13443))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5222z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13443, BgL_locz00_11024); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13444))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5222z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13444, BgL_locz00_11024); } 
return 
BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_13443, BgL_a2z00_13444);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2635> */
obj_t BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11026, obj_t BgL_sz00_11030)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11027;obj_t BgL_a2z00_11028;obj_t BgL_locz00_11029;
BgL_a1z00_11027 = 
PROCEDURE_REF(BgL_envz00_11026, 
(int)(((long)0))); 
BgL_a2z00_11028 = 
PROCEDURE_REF(BgL_envz00_11026, 
(int)(((long)1))); 
BgL_locz00_11029 = 
PROCEDURE_REF(BgL_envz00_11026, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20690;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13445;
BgL_bpz00_13445 = 
VECTOR_REF(
((obj_t)BgL_sz00_11030),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13446;obj_t BgL_a2z00_13447;
BgL_a1z00_13446 = 
PROCEDURE_ENTRY(BgL_a1z00_11027)(BgL_a1z00_11027, BgL_sz00_11030, BEOA); 
BgL_a2z00_13447 = 
PROCEDURE_ENTRY(BgL_a2z00_11028)(BgL_a2z00_11028, BgL_sz00_11030, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13446))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5224z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13446, BgL_locz00_11029); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13447))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5224z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13447, BgL_locz00_11029); } 
BgL_tmpz00_20690 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_13446, BgL_a2z00_13447); } } 
return 
BBOOL(BgL_tmpz00_20690);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2639> */
obj_t BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11031, obj_t BgL_sz00_11035)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11032;obj_t BgL_a2z00_11033;obj_t BgL_locz00_11034;
BgL_a1z00_11032 = 
PROCEDURE_REF(BgL_envz00_11031, 
(int)(((long)0))); 
BgL_a2z00_11033 = 
PROCEDURE_REF(BgL_envz00_11031, 
(int)(((long)1))); 
BgL_locz00_11034 = 
PROCEDURE_REF(BgL_envz00_11031, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20715;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13448;
BgL_bpz00_13448 = 
VECTOR_REF(
((obj_t)BgL_sz00_11035),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13449;obj_t BgL_a2z00_13450;
BgL_a1z00_13449 = 
PROCEDURE_ENTRY(BgL_a1z00_11032)(BgL_a1z00_11032, BgL_sz00_11035, BEOA); 
BgL_a2z00_13450 = 
PROCEDURE_ENTRY(BgL_a2z00_11033)(BgL_a2z00_11033, BgL_sz00_11035, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13449))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5226z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13449, BgL_locz00_11034); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13450))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5226z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13450, BgL_locz00_11034); } 
BgL_tmpz00_20715 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_13449, BgL_a2z00_13450); } } 
return 
BBOOL(BgL_tmpz00_20715);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2643> */
obj_t BGl_z62zc3anonymousza32643ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11036, obj_t BgL_sz00_11040)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11037;obj_t BgL_a2z00_11038;obj_t BgL_locz00_11039;
BgL_a1z00_11037 = 
PROCEDURE_REF(BgL_envz00_11036, 
(int)(((long)0))); 
BgL_a2z00_11038 = 
PROCEDURE_REF(BgL_envz00_11036, 
(int)(((long)1))); 
BgL_locz00_11039 = 
PROCEDURE_REF(BgL_envz00_11036, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20740;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13451;
BgL_bpz00_13451 = 
VECTOR_REF(
((obj_t)BgL_sz00_11040),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13452;obj_t BgL_a2z00_13453;
BgL_a1z00_13452 = 
PROCEDURE_ENTRY(BgL_a1z00_11037)(BgL_a1z00_11037, BgL_sz00_11040, BEOA); 
BgL_a2z00_13453 = 
PROCEDURE_ENTRY(BgL_a2z00_11038)(BgL_a2z00_11038, BgL_sz00_11040, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13452))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5228z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13452, BgL_locz00_11039); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13453))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5228z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13453, BgL_locz00_11039); } 
BgL_tmpz00_20740 = 
BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_13452, BgL_a2z00_13453); } } 
return 
BBOOL(BgL_tmpz00_20740);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2647> */
obj_t BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11041, obj_t BgL_sz00_11045)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11042;obj_t BgL_a2z00_11043;obj_t BgL_locz00_11044;
BgL_a1z00_11042 = 
PROCEDURE_REF(BgL_envz00_11041, 
(int)(((long)0))); 
BgL_a2z00_11043 = 
PROCEDURE_REF(BgL_envz00_11041, 
(int)(((long)1))); 
BgL_locz00_11044 = 
PROCEDURE_REF(BgL_envz00_11041, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20765;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13454;
BgL_bpz00_13454 = 
VECTOR_REF(
((obj_t)BgL_sz00_11045),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13455;obj_t BgL_a2z00_13456;
BgL_a1z00_13455 = 
PROCEDURE_ENTRY(BgL_a1z00_11042)(BgL_a1z00_11042, BgL_sz00_11045, BEOA); 
BgL_a2z00_13456 = 
PROCEDURE_ENTRY(BgL_a2z00_11043)(BgL_a2z00_11043, BgL_sz00_11045, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13455))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5230z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13455, BgL_locz00_11044); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13456))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5230z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13456, BgL_locz00_11044); } 
BgL_tmpz00_20765 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_13455, BgL_a2z00_13456); } } 
return 
BBOOL(BgL_tmpz00_20765);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2651> */
obj_t BGl_z62zc3anonymousza32651ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11046, obj_t BgL_sz00_11050)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11047;obj_t BgL_a2z00_11048;obj_t BgL_locz00_11049;
BgL_a1z00_11047 = 
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)0))); 
BgL_a2z00_11048 = 
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)1))); 
BgL_locz00_11049 = 
PROCEDURE_REF(BgL_envz00_11046, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20790;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13457;
BgL_bpz00_13457 = 
VECTOR_REF(
((obj_t)BgL_sz00_11050),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13458;obj_t BgL_a2z00_13459;
BgL_a1z00_13458 = 
PROCEDURE_ENTRY(BgL_a1z00_11047)(BgL_a1z00_11047, BgL_sz00_11050, BEOA); 
BgL_a2z00_13459 = 
PROCEDURE_ENTRY(BgL_a2z00_11048)(BgL_a2z00_11048, BgL_sz00_11050, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13458))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5232z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a1z00_13458, BgL_locz00_11049); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13459))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5232z00zz__evaluate_compz00, BGl_symbol5216z00zz__evaluate_compz00, BgL_a2z00_13459, BgL_locz00_11049); } 
BgL_tmpz00_20790 = 
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_13458, BgL_a2z00_13459); } } 
return 
BBOOL(BgL_tmpz00_20790);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2655> */
obj_t BGl_z62zc3anonymousza32655ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11051, obj_t BgL_sz00_11055)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11052;obj_t BgL_a2z00_11053;obj_t BgL_locz00_11054;
BgL_a1z00_11052 = 
PROCEDURE_REF(BgL_envz00_11051, 
(int)(((long)0))); 
BgL_a2z00_11053 = 
PROCEDURE_REF(BgL_envz00_11051, 
(int)(((long)1))); 
BgL_locz00_11054 = 
PROCEDURE_REF(BgL_envz00_11051, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
long BgL_tmpz00_20815;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13460;
BgL_bpz00_13460 = 
VECTOR_REF(
((obj_t)BgL_sz00_11055),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13461;obj_t BgL_a2z00_13462;
BgL_a1z00_13461 = 
PROCEDURE_ENTRY(BgL_a1z00_11052)(BgL_a1z00_11052, BgL_sz00_11055, BEOA); 
BgL_a2z00_13462 = 
PROCEDURE_ENTRY(BgL_a2z00_11053)(BgL_a2z00_11053, BgL_sz00_11055, BEOA); 
if(
INTEGERP(BgL_a1z00_13461))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5234z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13461, BgL_locz00_11054); } 
if(
INTEGERP(BgL_a2z00_13462))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5234z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13462, BgL_locz00_11054); } 
BgL_tmpz00_20815 = 
(
(long)CINT(BgL_a1z00_13461)+
(long)CINT(BgL_a2z00_13462)); } } 
return 
BINT(BgL_tmpz00_20815);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2659> */
obj_t BGl_z62zc3anonymousza32659ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11056, obj_t BgL_sz00_11060)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11057;obj_t BgL_a2z00_11058;obj_t BgL_locz00_11059;
BgL_a1z00_11057 = 
PROCEDURE_REF(BgL_envz00_11056, 
(int)(((long)0))); 
BgL_a2z00_11058 = 
PROCEDURE_REF(BgL_envz00_11056, 
(int)(((long)1))); 
BgL_locz00_11059 = 
PROCEDURE_REF(BgL_envz00_11056, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
long BgL_tmpz00_20842;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13463;
BgL_bpz00_13463 = 
VECTOR_REF(
((obj_t)BgL_sz00_11060),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13464;obj_t BgL_a2z00_13465;
BgL_a1z00_13464 = 
PROCEDURE_ENTRY(BgL_a1z00_11057)(BgL_a1z00_11057, BgL_sz00_11060, BEOA); 
BgL_a2z00_13465 = 
PROCEDURE_ENTRY(BgL_a2z00_11058)(BgL_a2z00_11058, BgL_sz00_11060, BEOA); 
if(
INTEGERP(BgL_a1z00_13464))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5238z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13464, BgL_locz00_11059); } 
if(
INTEGERP(BgL_a2z00_13465))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5238z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13465, BgL_locz00_11059); } 
BgL_tmpz00_20842 = 
(
(long)CINT(BgL_a1z00_13464)-
(long)CINT(BgL_a2z00_13465)); } } 
return 
BINT(BgL_tmpz00_20842);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2663> */
obj_t BGl_z62zc3anonymousza32663ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11061, obj_t BgL_sz00_11065)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11062;obj_t BgL_a2z00_11063;obj_t BgL_locz00_11064;
BgL_a1z00_11062 = 
PROCEDURE_REF(BgL_envz00_11061, 
(int)(((long)0))); 
BgL_a2z00_11063 = 
PROCEDURE_REF(BgL_envz00_11061, 
(int)(((long)1))); 
BgL_locz00_11064 = 
PROCEDURE_REF(BgL_envz00_11061, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
long BgL_tmpz00_20869;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13466;
BgL_bpz00_13466 = 
VECTOR_REF(
((obj_t)BgL_sz00_11065),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13467;obj_t BgL_a2z00_13468;
BgL_a1z00_13467 = 
PROCEDURE_ENTRY(BgL_a1z00_11062)(BgL_a1z00_11062, BgL_sz00_11065, BEOA); 
BgL_a2z00_13468 = 
PROCEDURE_ENTRY(BgL_a2z00_11063)(BgL_a2z00_11063, BgL_sz00_11065, BEOA); 
if(
INTEGERP(BgL_a1z00_13467))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5240z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13467, BgL_locz00_11064); } 
if(
INTEGERP(BgL_a2z00_13468))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5240z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13468, BgL_locz00_11064); } 
BgL_tmpz00_20869 = 
(
(long)CINT(BgL_a1z00_13467)*
(long)CINT(BgL_a2z00_13468)); } } 
return 
BINT(BgL_tmpz00_20869);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2667> */
obj_t BGl_z62zc3anonymousza32667ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11066, obj_t BgL_sz00_11070)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11067;obj_t BgL_a2z00_11068;obj_t BgL_locz00_11069;
BgL_a1z00_11067 = 
PROCEDURE_REF(BgL_envz00_11066, 
(int)(((long)0))); 
BgL_a2z00_11068 = 
PROCEDURE_REF(BgL_envz00_11066, 
(int)(((long)1))); 
BgL_locz00_11069 = 
PROCEDURE_REF(BgL_envz00_11066, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
long BgL_tmpz00_20896;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13469;
BgL_bpz00_13469 = 
VECTOR_REF(
((obj_t)BgL_sz00_11070),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13470;obj_t BgL_a2z00_13471;
BgL_a1z00_13470 = 
PROCEDURE_ENTRY(BgL_a1z00_11067)(BgL_a1z00_11067, BgL_sz00_11070, BEOA); 
BgL_a2z00_13471 = 
PROCEDURE_ENTRY(BgL_a2z00_11068)(BgL_a2z00_11068, BgL_sz00_11070, BEOA); 
if(
INTEGERP(BgL_a1z00_13470))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5242z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13470, BgL_locz00_11069); } 
if(
INTEGERP(BgL_a2z00_13471))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5242z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13471, BgL_locz00_11069); } 
BgL_tmpz00_20896 = 
(
(long)CINT(BgL_a1z00_13470)/
(long)CINT(BgL_a2z00_13471)); } } 
return 
BINT(BgL_tmpz00_20896);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2671> */
obj_t BGl_z62zc3anonymousza32671ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11071, obj_t BgL_sz00_11075)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11072;obj_t BgL_a2z00_11073;obj_t BgL_locz00_11074;
BgL_a1z00_11072 = 
PROCEDURE_REF(BgL_envz00_11071, 
(int)(((long)0))); 
BgL_a2z00_11073 = 
PROCEDURE_REF(BgL_envz00_11071, 
(int)(((long)1))); 
BgL_locz00_11074 = 
PROCEDURE_REF(BgL_envz00_11071, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20923;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13472;
BgL_bpz00_13472 = 
VECTOR_REF(
((obj_t)BgL_sz00_11075),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13473;obj_t BgL_a2z00_13474;
BgL_a1z00_13473 = 
PROCEDURE_ENTRY(BgL_a1z00_11072)(BgL_a1z00_11072, BgL_sz00_11075, BEOA); 
BgL_a2z00_13474 = 
PROCEDURE_ENTRY(BgL_a2z00_11073)(BgL_a2z00_11073, BgL_sz00_11075, BEOA); 
if(
INTEGERP(BgL_a1z00_13473))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5244z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13473, BgL_locz00_11074); } 
if(
INTEGERP(BgL_a2z00_13474))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5244z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13474, BgL_locz00_11074); } 
BgL_tmpz00_20923 = 
(
(long)CINT(BgL_a1z00_13473)<
(long)CINT(BgL_a2z00_13474)); } } 
return 
BBOOL(BgL_tmpz00_20923);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2675> */
obj_t BGl_z62zc3anonymousza32675ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11076, obj_t BgL_sz00_11080)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11077;obj_t BgL_a2z00_11078;obj_t BgL_locz00_11079;
BgL_a1z00_11077 = 
PROCEDURE_REF(BgL_envz00_11076, 
(int)(((long)0))); 
BgL_a2z00_11078 = 
PROCEDURE_REF(BgL_envz00_11076, 
(int)(((long)1))); 
BgL_locz00_11079 = 
PROCEDURE_REF(BgL_envz00_11076, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20950;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13475;
BgL_bpz00_13475 = 
VECTOR_REF(
((obj_t)BgL_sz00_11080),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13476;obj_t BgL_a2z00_13477;
BgL_a1z00_13476 = 
PROCEDURE_ENTRY(BgL_a1z00_11077)(BgL_a1z00_11077, BgL_sz00_11080, BEOA); 
BgL_a2z00_13477 = 
PROCEDURE_ENTRY(BgL_a2z00_11078)(BgL_a2z00_11078, BgL_sz00_11080, BEOA); 
if(
INTEGERP(BgL_a1z00_13476))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5246z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13476, BgL_locz00_11079); } 
if(
INTEGERP(BgL_a2z00_13477))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5246z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13477, BgL_locz00_11079); } 
BgL_tmpz00_20950 = 
(
(long)CINT(BgL_a1z00_13476)>
(long)CINT(BgL_a2z00_13477)); } } 
return 
BBOOL(BgL_tmpz00_20950);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2679> */
obj_t BGl_z62zc3anonymousza32679ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11081, obj_t BgL_sz00_11085)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11082;obj_t BgL_a2z00_11083;obj_t BgL_locz00_11084;
BgL_a1z00_11082 = 
PROCEDURE_REF(BgL_envz00_11081, 
(int)(((long)0))); 
BgL_a2z00_11083 = 
PROCEDURE_REF(BgL_envz00_11081, 
(int)(((long)1))); 
BgL_locz00_11084 = 
PROCEDURE_REF(BgL_envz00_11081, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_20977;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13478;
BgL_bpz00_13478 = 
VECTOR_REF(
((obj_t)BgL_sz00_11085),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13479;obj_t BgL_a2z00_13480;
BgL_a1z00_13479 = 
PROCEDURE_ENTRY(BgL_a1z00_11082)(BgL_a1z00_11082, BgL_sz00_11085, BEOA); 
BgL_a2z00_13480 = 
PROCEDURE_ENTRY(BgL_a2z00_11083)(BgL_a2z00_11083, BgL_sz00_11085, BEOA); 
if(
INTEGERP(BgL_a1z00_13479))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5248z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13479, BgL_locz00_11084); } 
if(
INTEGERP(BgL_a2z00_13480))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5248z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13480, BgL_locz00_11084); } 
BgL_tmpz00_20977 = 
(
(long)CINT(BgL_a1z00_13479)<=
(long)CINT(BgL_a2z00_13480)); } } 
return 
BBOOL(BgL_tmpz00_20977);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2683> */
obj_t BGl_z62zc3anonymousza32683ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11086, obj_t BgL_sz00_11090)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11087;obj_t BgL_a2z00_11088;obj_t BgL_locz00_11089;
BgL_a1z00_11087 = 
PROCEDURE_REF(BgL_envz00_11086, 
(int)(((long)0))); 
BgL_a2z00_11088 = 
PROCEDURE_REF(BgL_envz00_11086, 
(int)(((long)1))); 
BgL_locz00_11089 = 
PROCEDURE_REF(BgL_envz00_11086, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21004;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13481;
BgL_bpz00_13481 = 
VECTOR_REF(
((obj_t)BgL_sz00_11090),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13482;obj_t BgL_a2z00_13483;
BgL_a1z00_13482 = 
PROCEDURE_ENTRY(BgL_a1z00_11087)(BgL_a1z00_11087, BgL_sz00_11090, BEOA); 
BgL_a2z00_13483 = 
PROCEDURE_ENTRY(BgL_a2z00_11088)(BgL_a2z00_11088, BgL_sz00_11090, BEOA); 
if(
INTEGERP(BgL_a1z00_13482))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5250z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13482, BgL_locz00_11089); } 
if(
INTEGERP(BgL_a2z00_13483))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5250z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13483, BgL_locz00_11089); } 
BgL_tmpz00_21004 = 
(
(long)CINT(BgL_a1z00_13482)>=
(long)CINT(BgL_a2z00_13483)); } } 
return 
BBOOL(BgL_tmpz00_21004);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2687> */
obj_t BGl_z62zc3anonymousza32687ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11091, obj_t BgL_sz00_11095)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11092;obj_t BgL_a2z00_11093;obj_t BgL_locz00_11094;
BgL_a1z00_11092 = 
PROCEDURE_REF(BgL_envz00_11091, 
(int)(((long)0))); 
BgL_a2z00_11093 = 
PROCEDURE_REF(BgL_envz00_11091, 
(int)(((long)1))); 
BgL_locz00_11094 = 
PROCEDURE_REF(BgL_envz00_11091, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21031;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13484;
BgL_bpz00_13484 = 
VECTOR_REF(
((obj_t)BgL_sz00_11095),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13485;obj_t BgL_a2z00_13486;
BgL_a1z00_13485 = 
PROCEDURE_ENTRY(BgL_a1z00_11092)(BgL_a1z00_11092, BgL_sz00_11095, BEOA); 
BgL_a2z00_13486 = 
PROCEDURE_ENTRY(BgL_a2z00_11093)(BgL_a2z00_11093, BgL_sz00_11095, BEOA); 
if(
INTEGERP(BgL_a1z00_13485))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5252z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a1z00_13485, BgL_locz00_11094); } 
if(
INTEGERP(BgL_a2z00_13486))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5252z00zz__evaluate_compz00, BGl_symbol5236z00zz__evaluate_compz00, BgL_a2z00_13486, BgL_locz00_11094); } 
BgL_tmpz00_21031 = 
(
(long)CINT(BgL_a1z00_13485)==
(long)CINT(BgL_a2z00_13486)); } } 
return 
BBOOL(BgL_tmpz00_21031);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2691> */
obj_t BGl_z62zc3anonymousza32691ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11096, obj_t BgL_sz00_11100)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11097;obj_t BgL_a2z00_11098;obj_t BgL_locz00_11099;
BgL_a1z00_11097 = 
PROCEDURE_REF(BgL_envz00_11096, 
(int)(((long)0))); 
BgL_a2z00_11098 = 
PROCEDURE_REF(BgL_envz00_11096, 
(int)(((long)1))); 
BgL_locz00_11099 = 
PROCEDURE_REF(BgL_envz00_11096, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
double BgL_tmpz00_21058;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13487;
BgL_bpz00_13487 = 
VECTOR_REF(
((obj_t)BgL_sz00_11100),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13488;obj_t BgL_a2z00_13489;
BgL_a1z00_13488 = 
PROCEDURE_ENTRY(BgL_a1z00_11097)(BgL_a1z00_11097, BgL_sz00_11100, BEOA); 
BgL_a2z00_13489 = 
PROCEDURE_ENTRY(BgL_a2z00_11098)(BgL_a2z00_11098, BgL_sz00_11100, BEOA); 
if(
REALP(BgL_a1z00_13488))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5254z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13488, BgL_locz00_11099); } 
if(
REALP(BgL_a2z00_13489))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5254z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13489, BgL_locz00_11099); } 
BgL_tmpz00_21058 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13488)+
REAL_TO_DOUBLE(BgL_a2z00_13489)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21058);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2695> */
obj_t BGl_z62zc3anonymousza32695ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11101, obj_t BgL_sz00_11105)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11102;obj_t BgL_a2z00_11103;obj_t BgL_locz00_11104;
BgL_a1z00_11102 = 
PROCEDURE_REF(BgL_envz00_11101, 
(int)(((long)0))); 
BgL_a2z00_11103 = 
PROCEDURE_REF(BgL_envz00_11101, 
(int)(((long)1))); 
BgL_locz00_11104 = 
PROCEDURE_REF(BgL_envz00_11101, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
double BgL_tmpz00_21085;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13490;
BgL_bpz00_13490 = 
VECTOR_REF(
((obj_t)BgL_sz00_11105),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13491;obj_t BgL_a2z00_13492;
BgL_a1z00_13491 = 
PROCEDURE_ENTRY(BgL_a1z00_11102)(BgL_a1z00_11102, BgL_sz00_11105, BEOA); 
BgL_a2z00_13492 = 
PROCEDURE_ENTRY(BgL_a2z00_11103)(BgL_a2z00_11103, BgL_sz00_11105, BEOA); 
if(
REALP(BgL_a1z00_13491))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5258z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13491, BgL_locz00_11104); } 
if(
REALP(BgL_a2z00_13492))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5258z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13492, BgL_locz00_11104); } 
BgL_tmpz00_21085 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13491)-
REAL_TO_DOUBLE(BgL_a2z00_13492)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21085);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2699> */
obj_t BGl_z62zc3anonymousza32699ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11106, obj_t BgL_sz00_11110)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11107;obj_t BgL_a2z00_11108;obj_t BgL_locz00_11109;
BgL_a1z00_11107 = 
PROCEDURE_REF(BgL_envz00_11106, 
(int)(((long)0))); 
BgL_a2z00_11108 = 
PROCEDURE_REF(BgL_envz00_11106, 
(int)(((long)1))); 
BgL_locz00_11109 = 
PROCEDURE_REF(BgL_envz00_11106, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
double BgL_tmpz00_21112;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13493;
BgL_bpz00_13493 = 
VECTOR_REF(
((obj_t)BgL_sz00_11110),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13494;obj_t BgL_a2z00_13495;
BgL_a1z00_13494 = 
PROCEDURE_ENTRY(BgL_a1z00_11107)(BgL_a1z00_11107, BgL_sz00_11110, BEOA); 
BgL_a2z00_13495 = 
PROCEDURE_ENTRY(BgL_a2z00_11108)(BgL_a2z00_11108, BgL_sz00_11110, BEOA); 
if(
REALP(BgL_a1z00_13494))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5260z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13494, BgL_locz00_11109); } 
if(
REALP(BgL_a2z00_13495))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5260z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13495, BgL_locz00_11109); } 
BgL_tmpz00_21112 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13494)*
REAL_TO_DOUBLE(BgL_a2z00_13495)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21112);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2703> */
obj_t BGl_z62zc3anonymousza32703ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11111, obj_t BgL_sz00_11115)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11112;obj_t BgL_a2z00_11113;obj_t BgL_locz00_11114;
BgL_a1z00_11112 = 
PROCEDURE_REF(BgL_envz00_11111, 
(int)(((long)0))); 
BgL_a2z00_11113 = 
PROCEDURE_REF(BgL_envz00_11111, 
(int)(((long)1))); 
BgL_locz00_11114 = 
PROCEDURE_REF(BgL_envz00_11111, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
double BgL_tmpz00_21139;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13496;
BgL_bpz00_13496 = 
VECTOR_REF(
((obj_t)BgL_sz00_11115),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13497;obj_t BgL_a2z00_13498;
BgL_a1z00_13497 = 
PROCEDURE_ENTRY(BgL_a1z00_11112)(BgL_a1z00_11112, BgL_sz00_11115, BEOA); 
BgL_a2z00_13498 = 
PROCEDURE_ENTRY(BgL_a2z00_11113)(BgL_a2z00_11113, BgL_sz00_11115, BEOA); 
if(
REALP(BgL_a1z00_13497))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5262z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13497, BgL_locz00_11114); } 
if(
REALP(BgL_a2z00_13498))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5262z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13498, BgL_locz00_11114); } 
BgL_tmpz00_21139 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13497)/
REAL_TO_DOUBLE(BgL_a2z00_13498)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21139);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2707> */
obj_t BGl_z62zc3anonymousza32707ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11116, obj_t BgL_sz00_11120)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11117;obj_t BgL_a2z00_11118;obj_t BgL_locz00_11119;
BgL_a1z00_11117 = 
PROCEDURE_REF(BgL_envz00_11116, 
(int)(((long)0))); 
BgL_a2z00_11118 = 
PROCEDURE_REF(BgL_envz00_11116, 
(int)(((long)1))); 
BgL_locz00_11119 = 
PROCEDURE_REF(BgL_envz00_11116, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21166;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13499;
BgL_bpz00_13499 = 
VECTOR_REF(
((obj_t)BgL_sz00_11120),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13500;obj_t BgL_a2z00_13501;
BgL_a1z00_13500 = 
PROCEDURE_ENTRY(BgL_a1z00_11117)(BgL_a1z00_11117, BgL_sz00_11120, BEOA); 
BgL_a2z00_13501 = 
PROCEDURE_ENTRY(BgL_a2z00_11118)(BgL_a2z00_11118, BgL_sz00_11120, BEOA); 
if(
REALP(BgL_a1z00_13500))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5264z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13500, BgL_locz00_11119); } 
if(
REALP(BgL_a2z00_13501))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5264z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13501, BgL_locz00_11119); } 
BgL_tmpz00_21166 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13500)<
REAL_TO_DOUBLE(BgL_a2z00_13501)); } } 
return 
BBOOL(BgL_tmpz00_21166);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2711> */
obj_t BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11121, obj_t BgL_sz00_11125)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11122;obj_t BgL_a2z00_11123;obj_t BgL_locz00_11124;
BgL_a1z00_11122 = 
PROCEDURE_REF(BgL_envz00_11121, 
(int)(((long)0))); 
BgL_a2z00_11123 = 
PROCEDURE_REF(BgL_envz00_11121, 
(int)(((long)1))); 
BgL_locz00_11124 = 
PROCEDURE_REF(BgL_envz00_11121, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21193;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13502;
BgL_bpz00_13502 = 
VECTOR_REF(
((obj_t)BgL_sz00_11125),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13503;obj_t BgL_a2z00_13504;
BgL_a1z00_13503 = 
PROCEDURE_ENTRY(BgL_a1z00_11122)(BgL_a1z00_11122, BgL_sz00_11125, BEOA); 
BgL_a2z00_13504 = 
PROCEDURE_ENTRY(BgL_a2z00_11123)(BgL_a2z00_11123, BgL_sz00_11125, BEOA); 
if(
REALP(BgL_a1z00_13503))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5266z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13503, BgL_locz00_11124); } 
if(
REALP(BgL_a2z00_13504))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5266z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13504, BgL_locz00_11124); } 
BgL_tmpz00_21193 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13503)>
REAL_TO_DOUBLE(BgL_a2z00_13504)); } } 
return 
BBOOL(BgL_tmpz00_21193);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2715> */
obj_t BGl_z62zc3anonymousza32715ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11126, obj_t BgL_sz00_11130)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11127;obj_t BgL_a2z00_11128;obj_t BgL_locz00_11129;
BgL_a1z00_11127 = 
PROCEDURE_REF(BgL_envz00_11126, 
(int)(((long)0))); 
BgL_a2z00_11128 = 
PROCEDURE_REF(BgL_envz00_11126, 
(int)(((long)1))); 
BgL_locz00_11129 = 
PROCEDURE_REF(BgL_envz00_11126, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21220;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13505;
BgL_bpz00_13505 = 
VECTOR_REF(
((obj_t)BgL_sz00_11130),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13506;obj_t BgL_a2z00_13507;
BgL_a1z00_13506 = 
PROCEDURE_ENTRY(BgL_a1z00_11127)(BgL_a1z00_11127, BgL_sz00_11130, BEOA); 
BgL_a2z00_13507 = 
PROCEDURE_ENTRY(BgL_a2z00_11128)(BgL_a2z00_11128, BgL_sz00_11130, BEOA); 
if(
REALP(BgL_a1z00_13506))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5268z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13506, BgL_locz00_11129); } 
if(
REALP(BgL_a2z00_13507))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5268z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13507, BgL_locz00_11129); } 
BgL_tmpz00_21220 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13506)<=
REAL_TO_DOUBLE(BgL_a2z00_13507)); } } 
return 
BBOOL(BgL_tmpz00_21220);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2719> */
obj_t BGl_z62zc3anonymousza32719ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11131, obj_t BgL_sz00_11135)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11132;obj_t BgL_a2z00_11133;obj_t BgL_locz00_11134;
BgL_a1z00_11132 = 
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)0))); 
BgL_a2z00_11133 = 
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)1))); 
BgL_locz00_11134 = 
PROCEDURE_REF(BgL_envz00_11131, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21247;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13508;
BgL_bpz00_13508 = 
VECTOR_REF(
((obj_t)BgL_sz00_11135),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13509;obj_t BgL_a2z00_13510;
BgL_a1z00_13509 = 
PROCEDURE_ENTRY(BgL_a1z00_11132)(BgL_a1z00_11132, BgL_sz00_11135, BEOA); 
BgL_a2z00_13510 = 
PROCEDURE_ENTRY(BgL_a2z00_11133)(BgL_a2z00_11133, BgL_sz00_11135, BEOA); 
if(
REALP(BgL_a1z00_13509))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5270z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13509, BgL_locz00_11134); } 
if(
REALP(BgL_a2z00_13510))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5270z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13510, BgL_locz00_11134); } 
BgL_tmpz00_21247 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13509)>=
REAL_TO_DOUBLE(BgL_a2z00_13510)); } } 
return 
BBOOL(BgL_tmpz00_21247);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2723> */
obj_t BGl_z62zc3anonymousza32723ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11136, obj_t BgL_sz00_11140)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11137;obj_t BgL_a2z00_11138;obj_t BgL_locz00_11139;
BgL_a1z00_11137 = 
PROCEDURE_REF(BgL_envz00_11136, 
(int)(((long)0))); 
BgL_a2z00_11138 = 
PROCEDURE_REF(BgL_envz00_11136, 
(int)(((long)1))); 
BgL_locz00_11139 = 
PROCEDURE_REF(BgL_envz00_11136, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21274;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13511;
BgL_bpz00_13511 = 
VECTOR_REF(
((obj_t)BgL_sz00_11140),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13512;obj_t BgL_a2z00_13513;
BgL_a1z00_13512 = 
PROCEDURE_ENTRY(BgL_a1z00_11137)(BgL_a1z00_11137, BgL_sz00_11140, BEOA); 
BgL_a2z00_13513 = 
PROCEDURE_ENTRY(BgL_a2z00_11138)(BgL_a2z00_11138, BgL_sz00_11140, BEOA); 
if(
REALP(BgL_a1z00_13512))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5272z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a1z00_13512, BgL_locz00_11139); } 
if(
REALP(BgL_a2z00_13513))
{ /* Eval/evaluate_comp.scm 1014 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1014 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5272z00zz__evaluate_compz00, BGl_symbol5256z00zz__evaluate_compz00, BgL_a2z00_13513, BgL_locz00_11139); } 
BgL_tmpz00_21274 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13512)==
REAL_TO_DOUBLE(BgL_a2z00_13513)); } } 
return 
BBOOL(BgL_tmpz00_21274);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2727> */
obj_t BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11141, obj_t BgL_sz00_11144)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11142;obj_t BgL_a2z00_11143;
BgL_a1z00_11142 = 
PROCEDURE_REF(BgL_envz00_11141, 
(int)(((long)0))); 
BgL_a2z00_11143 = 
PROCEDURE_REF(BgL_envz00_11141, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1014 */
bool_t BgL_tmpz00_21299;
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13514;
BgL_bpz00_13514 = 
VECTOR_REF(
((obj_t)BgL_sz00_11144),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13515;obj_t BgL_a2z00_13516;
BgL_a1z00_13515 = 
PROCEDURE_ENTRY(BgL_a1z00_11142)(BgL_a1z00_11142, BgL_sz00_11144, BEOA); 
BgL_a2z00_13516 = 
PROCEDURE_ENTRY(BgL_a2z00_11143)(BgL_a2z00_11143, BgL_sz00_11144, BEOA); 
BgL_tmpz00_21299 = 
(BgL_a1z00_13515==BgL_a2z00_13516); } } 
return 
BBOOL(BgL_tmpz00_21299);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2729> */
obj_t BGl_z62zc3anonymousza32729ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11145, obj_t BgL_sz00_11148)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1014 */
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_11146;obj_t BgL_a2z00_11147;
BgL_a1z00_11146 = 
PROCEDURE_REF(BgL_envz00_11145, 
(int)(((long)0))); 
BgL_a2z00_11147 = 
PROCEDURE_REF(BgL_envz00_11145, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_bpz00_13517;
BgL_bpz00_13517 = 
VECTOR_REF(
((obj_t)BgL_sz00_11148),((long)0)); 
{ /* Eval/evaluate_comp.scm 1014 */
obj_t BgL_a1z00_13518;obj_t BgL_a2z00_13519;
BgL_a1z00_13518 = 
PROCEDURE_ENTRY(BgL_a1z00_11146)(BgL_a1z00_11146, BgL_sz00_11148, BEOA); 
BgL_a2z00_13519 = 
PROCEDURE_ENTRY(BgL_a2z00_11147)(BgL_a2z00_11147, BgL_sz00_11148, BEOA); 
return 
MAKE_YOUNG_PAIR(BgL_a1z00_13518, BgL_a2z00_13519);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2732> */
obj_t BGl_z62zc3anonymousza32732ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11149, obj_t BgL_sz00_11152)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1011 */
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_11150;obj_t BgL_locz00_11151;
BgL_a1z00_11150 = 
PROCEDURE_REF(BgL_envz00_11149, 
(int)(((long)0))); 
BgL_locz00_11151 = 
PROCEDURE_REF(BgL_envz00_11149, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_bpz00_13520;
BgL_bpz00_13520 = 
VECTOR_REF(
((obj_t)BgL_sz00_11152),((long)0)); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_13521;
BgL_a1z00_13521 = 
PROCEDURE_ENTRY(BgL_a1z00_11150)(BgL_a1z00_11150, BgL_sz00_11152, BEOA); 
if(
PAIRP(BgL_a1z00_13521))
{ /* Eval/evaluate_comp.scm 1011 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1011 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5274z00zz__evaluate_compz00, BGl_symbol5276z00zz__evaluate_compz00, BgL_a1z00_13521, BgL_locz00_11151); } 
return 
CAR(
((obj_t)BgL_a1z00_13521));} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2735> */
obj_t BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11153, obj_t BgL_sz00_11156)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1011 */
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_11154;obj_t BgL_locz00_11155;
BgL_a1z00_11154 = 
PROCEDURE_REF(BgL_envz00_11153, 
(int)(((long)0))); 
BgL_locz00_11155 = 
PROCEDURE_REF(BgL_envz00_11153, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_bpz00_13522;
BgL_bpz00_13522 = 
VECTOR_REF(
((obj_t)BgL_sz00_11156),((long)0)); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_13523;
BgL_a1z00_13523 = 
PROCEDURE_ENTRY(BgL_a1z00_11154)(BgL_a1z00_11154, BgL_sz00_11156, BEOA); 
if(
PAIRP(BgL_a1z00_13523))
{ /* Eval/evaluate_comp.scm 1011 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1011 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5278z00zz__evaluate_compz00, BGl_symbol5276z00zz__evaluate_compz00, BgL_a1z00_13523, BgL_locz00_11155); } 
return 
CDR(
((obj_t)BgL_a1z00_13523));} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2738> */
obj_t BGl_z62zc3anonymousza32738ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11157, obj_t BgL_sz00_11160)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1011 */
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_11158;obj_t BgL_locz00_11159;
BgL_a1z00_11158 = 
PROCEDURE_REF(BgL_envz00_11157, 
(int)(((long)0))); 
BgL_locz00_11159 = 
PROCEDURE_REF(BgL_envz00_11157, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_bpz00_13524;
BgL_bpz00_13524 = 
VECTOR_REF(
((obj_t)BgL_sz00_11160),((long)0)); 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_a1z00_13525;
BgL_a1z00_13525 = 
PROCEDURE_ENTRY(BgL_a1z00_11158)(BgL_a1z00_11158, BgL_sz00_11160, BEOA); 
if(
BGl_cadrzf3zf3zz__evaluate_compz00(BgL_a1z00_13525))
{ /* Eval/evaluate_comp.scm 1011 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_arg2740z00_13526;
BgL_arg2740z00_13526 = 
BGl_cadrerrvz00zz__evaluate_compz00(BgL_a1z00_13525); 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5280z00zz__evaluate_compz00, BGl_symbol5276z00zz__evaluate_compz00, BgL_arg2740z00_13526, BgL_locz00_11159); } 
{ /* Eval/evaluate_comp.scm 1011 */
obj_t BgL_pairz00_13527;
BgL_pairz00_13527 = 
CDR(
((obj_t)BgL_a1z00_13525)); 
return 
CAR(BgL_pairz00_13527);} } } } } 
BGL_FUNCTION_END;
}



/* cadr? */
bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t BgL_lz00_197)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1019 */
if(
PAIRP(BgL_lz00_197))
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_tmpz00_21376;
BgL_tmpz00_21376 = 
CDR(BgL_lz00_197); 
return 
PAIRP(BgL_tmpz00_21376);}  else 
{ /* Eval/evaluate_comp.scm 1020 */
return ((bool_t)0);} } 
BGL_FUNCTION_END;
}



/* cadrerrv */
obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t BgL_vz00_198)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1022 */
if(
PAIRP(BgL_vz00_198))
{ /* Eval/evaluate_comp.scm 1023 */
return 
CDR(BgL_vz00_198);}  else 
{ /* Eval/evaluate_comp.scm 1023 */
return BgL_vz00_198;} } 
BGL_FUNCTION_END;
}



/* correct */
long BGl_correctz00zz__evaluate_compz00(obj_t BgL_nz00_201, long BgL_donez00_202)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1051 */
if(
(
(long)CINT(BgL_nz00_201)<((long)0)))
{ /* Eval/evaluate_comp.scm 1052 */
return 
(
(long)CINT(BgL_nz00_201)+BgL_donez00_202);}  else 
{ /* Eval/evaluate_comp.scm 1052 */
return 
(
(long)CINT(BgL_nz00_201)-BgL_donez00_202);} } 
BGL_FUNCTION_END;
}



/* bind-frame */
obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203, obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206, obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1056 */
if(
(BgL_arityz00_206<((long)0)))
{ /* Eval/evaluate_comp.scm 1058 */
long BgL_g1233z00_3513;
BgL_g1233z00_3513 = 
(((long)-1)-BgL_arityz00_206); 
{ 
long BgL_rz00_3515;long BgL_spz00_3516;obj_t BgL_lz00_3517;
BgL_rz00_3515 = BgL_g1233z00_3513; 
BgL_spz00_3516 = BgL_spz00_205; 
BgL_lz00_3517 = BgL_valsz00_207; 
BgL_zc3anonymousza32745ze3z83_3518:
if(
(BgL_rz00_3515==((long)0)))
{ /* Eval/evaluate_comp.scm 1060 */
return 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3516,BgL_lz00_3517);}  else 
{ /* Eval/evaluate_comp.scm 1060 */
if(
PAIRP(BgL_lz00_3517))
{ /* Eval/evaluate_comp.scm 1062 */
{ /* Eval/evaluate_comp.scm 1065 */
obj_t BgL_arg2748z00_3521;
BgL_arg2748z00_3521 = 
CAR(BgL_lz00_3517); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3516,BgL_arg2748z00_3521); } 
{ 
obj_t BgL_lz00_21405;long BgL_spz00_21403;long BgL_rz00_21401;
BgL_rz00_21401 = 
(BgL_rz00_3515-((long)1)); 
BgL_spz00_21403 = 
(BgL_spz00_3516+((long)1)); 
BgL_lz00_21405 = 
CDR(BgL_lz00_3517); 
BgL_lz00_3517 = BgL_lz00_21405; 
BgL_spz00_3516 = BgL_spz00_21403; 
BgL_rz00_3515 = BgL_rz00_21401; 
goto BgL_zc3anonymousza32745ze3z83_3518;} }  else 
{ /* Eval/evaluate_comp.scm 1063 */
long BgL_arg2752z00_3525;
BgL_arg2752z00_3525 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2752z00_3525));} } } }  else 
{ 
long BgL_rz00_3528;long BgL_spz00_3529;obj_t BgL_lz00_3530;
BgL_rz00_3528 = BgL_arityz00_206; 
BgL_spz00_3529 = BgL_spz00_205; 
BgL_lz00_3530 = BgL_valsz00_207; 
BgL_zc3anonymousza32753ze3z83_3531:
if(
(BgL_rz00_3528==((long)0)))
{ /* Eval/evaluate_comp.scm 1069 */
if(
NULLP(BgL_lz00_3530))
{ /* Eval/evaluate_comp.scm 1070 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 1071 */
long BgL_arg2756z00_3534;
BgL_arg2756z00_3534 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2756z00_3534));} }  else 
{ /* Eval/evaluate_comp.scm 1069 */
if(
PAIRP(BgL_lz00_3530))
{ /* Eval/evaluate_comp.scm 1072 */
{ /* Eval/evaluate_comp.scm 1075 */
obj_t BgL_arg2758z00_3536;
BgL_arg2758z00_3536 = 
CAR(BgL_lz00_3530); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3529,BgL_arg2758z00_3536); } 
{ 
obj_t BgL_lz00_21428;long BgL_spz00_21426;long BgL_rz00_21424;
BgL_rz00_21424 = 
(BgL_rz00_3528-((long)1)); 
BgL_spz00_21426 = 
(BgL_spz00_3529+((long)1)); 
BgL_lz00_21428 = 
CDR(BgL_lz00_3530); 
BgL_lz00_3530 = BgL_lz00_21428; 
BgL_spz00_3529 = BgL_spz00_21426; 
BgL_rz00_3528 = BgL_rz00_21424; 
goto BgL_zc3anonymousza32753ze3z83_3531;} }  else 
{ /* Eval/evaluate_comp.scm 1073 */
long BgL_arg2762z00_3540;
BgL_arg2762z00_3540 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2762z00_3540));} } } } 
BGL_FUNCTION_END;
}



/* make-boxes */
bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211, obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1170 */
{ 
long BgL_iz00_3544;
BgL_iz00_3544 = ((long)0); 
BgL_zc3anonymousza32763ze3z83_3545:
{ /* Eval/evaluate_comp.scm 1173 */
long BgL_spz00_3546;
{ /* Eval/evaluate_comp.scm 1173 */
obj_t BgL_arg2767z00_3551;
BgL_arg2767z00_3551 = 
VECTOR_REF(
((obj_t)BgL_ibza2za2_212),BgL_iz00_3544); 
BgL_spz00_3546 = 
(
(long)CINT(BgL_bpz00_213)+
(long)CINT(BgL_arg2767z00_3551)); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg2764z00_3547;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg2765z00_3548;
BgL_arg2765z00_3548 = 
VECTOR_REF(
((obj_t)BgL_sz00_211),BgL_spz00_3546); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8484;
BgL_newz00_8484 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_21443;
BgL_tmpz00_21443 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8484, BgL_tmpz00_21443, BgL_arg2765z00_3548); } 
BgL_arg2764z00_3547 = BgL_newz00_8484; } } 
VECTOR_SET(
((obj_t)BgL_sz00_211),BgL_spz00_3546,BgL_arg2764z00_3547); } 
{ /* Eval/evaluate_comp.scm 1175 */
long BgL_niz00_3549;
BgL_niz00_3549 = 
(BgL_iz00_3544+((long)1)); 
if(
(BgL_niz00_3549<
VECTOR_LENGTH(
((obj_t)BgL_ibza2za2_212))))
{ 
long BgL_iz00_21453;
BgL_iz00_21453 = BgL_niz00_3549; 
BgL_iz00_3544 = BgL_iz00_21453; 
goto BgL_zc3anonymousza32763ze3z83_3545;}  else 
{ /* Eval/evaluate_comp.scm 1176 */
return ((bool_t)0);} } } } } 
BGL_FUNCTION_END;
}



/* free-collect */
obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214, obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1178 */
{ /* Eval/evaluate_comp.scm 1179 */
obj_t BgL_rz00_3554;
BgL_rz00_3554 = 
make_vector(
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216)), BUNSPEC); 
{ /* Eval/evaluate_comp.scm 1179 */

{ 
long BgL_iz00_3556;
BgL_iz00_3556 = ((long)0); 
BgL_zc3anonymousza32768ze3z83_3557:
if(
(BgL_iz00_3556>=
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216))))
{ /* Eval/evaluate_comp.scm 1181 */
return BgL_rz00_3554;}  else 
{ /* Eval/evaluate_comp.scm 1181 */
{ /* Eval/evaluate_comp.scm 1184 */
obj_t BgL_arg2770z00_3559;
{ /* Eval/evaluate_comp.scm 1184 */
long BgL_arg2771z00_3560;
{ /* Eval/evaluate_comp.scm 1184 */
obj_t BgL_arg2772z00_3561;
BgL_arg2772z00_3561 = 
VECTOR_REF(
((obj_t)BgL_iza2za2_216),BgL_iz00_3556); 
BgL_arg2771z00_3560 = 
(
(long)CINT(BgL_bpz00_215)+
(long)CINT(BgL_arg2772z00_3561)); } 
BgL_arg2770z00_3559 = 
VECTOR_REF(
((obj_t)BgL_sz00_214),BgL_arg2771z00_3560); } 
VECTOR_SET(BgL_rz00_3554,BgL_iz00_3556,BgL_arg2770z00_3559); } 
{ 
long BgL_iz00_21469;
BgL_iz00_21469 = 
(BgL_iz00_3556+((long)1)); 
BgL_iz00_3556 = BgL_iz00_21469; 
goto BgL_zc3anonymousza32768ze3z83_3557;} } } } } } 
BGL_FUNCTION_END;
}



/* free-restore */
bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217, obj_t BgL_valza2za2_218, long BgL_spz00_219)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1187 */
{ /* Eval/evaluate_comp.scm 1188 */
long BgL_stopz00_3565;
BgL_stopz00_3565 = 
(BgL_spz00_219+
VECTOR_LENGTH(
((obj_t)BgL_valza2za2_218))); 
{ 
long BgL_iz00_3567;long BgL_spz00_3568;
BgL_iz00_3567 = ((long)0); 
BgL_spz00_3568 = BgL_spz00_219; 
BgL_zc3anonymousza32775ze3z83_3569:
if(
(BgL_spz00_3568<BgL_stopz00_3565))
{ /* Eval/evaluate_comp.scm 1190 */
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2777z00_3571;
BgL_arg2777z00_3571 = 
VECTOR_REF(
((obj_t)BgL_valza2za2_218),BgL_iz00_3567); 
VECTOR_SET(
((obj_t)BgL_sz00_217),BgL_spz00_3568,BgL_arg2777z00_3571); } 
{ 
long BgL_spz00_21482;long BgL_iz00_21480;
BgL_iz00_21480 = 
(BgL_iz00_3567+((long)1)); 
BgL_spz00_21482 = 
(BgL_spz00_3568+((long)1)); 
BgL_spz00_3568 = BgL_spz00_21482; 
BgL_iz00_3567 = BgL_iz00_21480; 
goto BgL_zc3anonymousza32775ze3z83_3569;} }  else 
{ /* Eval/evaluate_comp.scm 1190 */
return ((bool_t)0);} } } } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_proc5282z00zz__evaluate_compz00, BGl_ev_exprz00zz__evaluate_typesz00, BGl_string5283z00zz__evaluate_compz00);} 
BGL_FUNCTION_END;
}



/* &comp1385 */
obj_t BGl_z62comp1385z62zz__evaluate_compz00(obj_t BgL_envz00_11246, obj_t BgL_ez00_11247, obj_t BgL_stkz00_11248)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 276 */
return 
BGl_errorz00zz__errorz00(BGl_string5194z00zz__evaluate_compz00, BGl_string5284z00zz__evaluate_compz00, 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_ez00_11247)));} 
BGL_FUNCTION_END;
}



/* comp */
obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35, obj_t BgL_stkz00_36)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_method1386z00_3581;
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_res4637z00_8568;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_objzd2classzd2numz00_8525;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4626z00_8528;
BgL_res4626z00_8528 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_ez00_35)); 
BgL_objzd2classzd2numz00_8525 = BgL_res4626z00_8528; } 
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_arg3959z00_8526;
BgL_arg3959z00_8526 = 
PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 276 */
int BgL_offsetz00_8530;
BgL_offsetz00_8530 = 
(int)(BgL_objzd2classzd2numz00_8525); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_offsetz00_8531;
BgL_offsetz00_8531 = 
(
(long)(BgL_offsetz00_8530)-OBJECT_TYPE); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_modz00_8532;
{ /* Eval/evaluate_comp.scm 276 */
int BgL_arg3961z00_8533;
BgL_arg3961z00_8533 = 
(int)(((long)16)); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4629z00_8543;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_tmpz00_21496;
BgL_tmpz00_21496 = 
(long)(BgL_arg3961z00_8533); 
BgL_res4629z00_8543 = 
(BgL_offsetz00_8531/BgL_tmpz00_21496); } 
BgL_modz00_8532 = BgL_res4629z00_8543; } } 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_restz00_8534;
{ /* Eval/evaluate_comp.scm 276 */
int BgL_arg3960z00_8535;
BgL_arg3960z00_8535 = 
(int)(((long)16)); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4636z00_8563;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_n1z00_8545;long BgL_n2z00_8546;
BgL_n1z00_8545 = BgL_offsetz00_8531; 
BgL_n2z00_8546 = 
(long)(BgL_arg3960z00_8535); 
{ /* Eval/evaluate_comp.scm 276 */
bool_t BgL_testz00_21501;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_arg3844z00_8548;
BgL_arg3844z00_8548 = 
(((BgL_n1z00_8545) | (BgL_n2z00_8546)) & -2147483648); 
BgL_testz00_21501 = 
(BgL_arg3844z00_8548==((long)0)); } 
if(BgL_testz00_21501)
{ /* Eval/evaluate_comp.scm 276 */
int32_t BgL_arg3841z00_8549;
{ /* Eval/evaluate_comp.scm 276 */
int32_t BgL_arg3842z00_8550;int32_t BgL_arg3843z00_8551;
{ /* Eval/evaluate_comp.scm 276 */
int32_t BgL_res4632z00_8555;
BgL_res4632z00_8555 = 
(int32_t)(BgL_n1z00_8545); 
BgL_arg3842z00_8550 = BgL_res4632z00_8555; } 
{ /* Eval/evaluate_comp.scm 276 */
int32_t BgL_res4633z00_8557;
BgL_res4633z00_8557 = 
(int32_t)(BgL_n2z00_8546); 
BgL_arg3843z00_8551 = BgL_res4633z00_8557; } 
BgL_arg3841z00_8549 = 
(BgL_arg3842z00_8550%BgL_arg3843z00_8551); } 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4635z00_8562;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_arg3935z00_8559;
BgL_arg3935z00_8559 = 
(long)(BgL_arg3841z00_8549); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4634z00_8561;
BgL_res4634z00_8561 = 
(long)(BgL_arg3935z00_8559); 
BgL_res4635z00_8562 = BgL_res4634z00_8561; } } 
BgL_res4636z00_8563 = BgL_res4635z00_8562; } }  else 
{ /* Eval/evaluate_comp.scm 276 */
BgL_res4636z00_8563 = 
(BgL_n1z00_8545%BgL_n2z00_8546); } } } 
BgL_restz00_8534 = BgL_res4636z00_8563; } } 
{ /* Eval/evaluate_comp.scm 276 */

{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_bucketz00_8536;
BgL_bucketz00_8536 = 
VECTOR_REF(
((obj_t)BgL_arg3959z00_8526),BgL_modz00_8532); 
BgL_res4637z00_8568 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_8536),BgL_restz00_8534); } } } } } } } } 
BgL_method1386z00_3581 = BgL_res4637z00_8568; } 
return 
PROCEDURE_ENTRY(BgL_method1386z00_3581)(BgL_method1386z00_3581, 
((obj_t)BgL_ez00_35), BgL_stkz00_36, BEOA);} } 
BGL_FUNCTION_END;
}



/* &comp */
obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_11249, obj_t BgL_ez00_11250, obj_t BgL_stkz00_11251)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
BgL_ev_exprz00_bglt BgL_auxz00_21520;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_11250, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 276 */
BgL_auxz00_21520 = 
((BgL_ev_exprz00_bglt)BgL_ez00_11250)
; }  else 
{ 
obj_t BgL_auxz00_21524;
BgL_auxz00_21524 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string5199z00zz__evaluate_compz00, 
BINT(((long)7022)), BGl_string5285z00zz__evaluate_compz00, BGl_string5201z00zz__evaluate_compz00, BgL_ez00_11250); 
FAILURE(BgL_auxz00_21524,BFALSE,BFALSE);} 
return 
BGl_compz00zz__evaluate_compz00(BgL_auxz00_21520, BgL_stkz00_11251);} } 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_trapz00zz__evaluate_typesz00, BGl_proc5286z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5288z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setlocalz00zz__evaluate_typesz00, BGl_proc5289z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_globalz00zz__evaluate_typesz00, BGl_proc5290z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setglobalz00zz__evaluate_typesz00, BGl_proc5291z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_defglobalz00zz__evaluate_typesz00, BGl_proc5292z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_littz00zz__evaluate_typesz00, BGl_proc5293z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5294z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5295z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5296z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_prog2z00zz__evaluate_typesz00, BGl_proc5297z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5298z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letza2za2zz__evaluate_typesz00, BGl_proc5299z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letrecz00zz__evaluate_typesz00, BGl_proc5300z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_bindzd2exitzd2zz__evaluate_typesz00, BGl_proc5301z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00, BGl_proc5302z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_withzd2handlerzd2zz__evaluate_typesz00, BGl_proc5303z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_synchroniza7eza7zz__evaluate_typesz00, BGl_proc5304z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_labelsz00zz__evaluate_typesz00, BGl_proc5305z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_gotoz00zz__evaluate_typesz00, BGl_proc5306z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5307z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5308z00zz__evaluate_compz00, BGl_string5287z00zz__evaluate_compz00);} 
BGL_FUNCTION_END;
}



/* &comp-ev_abs1430 */
obj_t BGl_z62compzd2ev_abs1430zb0zz__evaluate_compz00(obj_t BgL_envz00_11446, obj_t BgL_ez00_11447, obj_t BgL_stkz00_11448)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1158 */
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_ifreesz00_13530;obj_t BgL_iboxesz00_13531;long BgL_siza7eza7_13532;long BgL_siza7ezd2framez75_13533;obj_t BgL_nstkz00_13534;
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_arg3669z00_13535;
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_l1362z00_13536;
BgL_l1362z00_13536 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_freez00); 
if(
NULLP(BgL_l1362z00_13536))
{ /* Eval/evaluate_comp.scm 1160 */
BgL_arg3669z00_13535 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_head1364z00_13537;
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_res4727z00_13538;
BgL_res4727z00_13538 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1364z00_13537 = BgL_res4727z00_13538; } 
{ 
obj_t BgL_l1362z00_13540;obj_t BgL_tail1365z00_13541;
BgL_l1362z00_13540 = BgL_l1362z00_13536; 
BgL_tail1365z00_13541 = BgL_head1364z00_13537; 
BgL_zc3anonymousza33671ze3z83_13539:
if(
NULLP(BgL_l1362z00_13540))
{ /* Eval/evaluate_comp.scm 1160 */
BgL_arg3669z00_13535 = 
CDR(BgL_head1364z00_13537); }  else 
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_newtail1366z00_13542;
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_arg3674z00_13543;
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_vz00_13544;
BgL_vz00_13544 = 
CAR(
((obj_t)BgL_l1362z00_13540)); 
BgL_arg3674z00_13543 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13544, BgL_stkz00_11448); } 
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_res4729z00_13545;
BgL_res4729z00_13545 = 
MAKE_YOUNG_PAIR(BgL_arg3674z00_13543, BNIL); 
BgL_newtail1366z00_13542 = BgL_res4729z00_13545; } } 
SET_CDR(BgL_tail1365z00_13541, BgL_newtail1366z00_13542); 
{ /* Eval/evaluate_comp.scm 1160 */
obj_t BgL_arg3673z00_13546;
BgL_arg3673z00_13546 = 
CDR(
((obj_t)BgL_l1362z00_13540)); 
{ 
obj_t BgL_tail1365z00_21567;obj_t BgL_l1362z00_21566;
BgL_l1362z00_21566 = BgL_arg3673z00_13546; 
BgL_tail1365z00_21567 = BgL_newtail1366z00_13542; 
BgL_tail1365z00_13541 = BgL_tail1365z00_21567; 
BgL_l1362z00_13540 = BgL_l1362z00_21566; 
goto BgL_zc3anonymousza33671ze3z83_13539;} } } } } } 
BgL_ifreesz00_13530 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3669z00_13535); } 
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_arg3675z00_13547;
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_l1367z00_13548;
BgL_l1367z00_13548 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_boxesz00); 
if(
NULLP(BgL_l1367z00_13548))
{ /* Eval/evaluate_comp.scm 1161 */
BgL_arg3675z00_13547 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_head1369z00_13549;
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_res4731z00_13550;
BgL_res4731z00_13550 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1369z00_13549 = BgL_res4731z00_13550; } 
{ 
obj_t BgL_l1367z00_13552;obj_t BgL_tail1370z00_13553;
BgL_l1367z00_13552 = BgL_l1367z00_13548; 
BgL_tail1370z00_13553 = BgL_head1369z00_13549; 
BgL_zc3anonymousza33677ze3z83_13551:
if(
NULLP(BgL_l1367z00_13552))
{ /* Eval/evaluate_comp.scm 1161 */
BgL_arg3675z00_13547 = 
CDR(BgL_head1369z00_13549); }  else 
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_newtail1371z00_13554;
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_arg3680z00_13555;
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_vz00_13556;
BgL_vz00_13556 = 
CAR(
((obj_t)BgL_l1367z00_13552)); 
BgL_arg3680z00_13555 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13556, 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_varsz00)); } 
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_res4733z00_13557;
BgL_res4733z00_13557 = 
MAKE_YOUNG_PAIR(BgL_arg3680z00_13555, BNIL); 
BgL_newtail1371z00_13554 = BgL_res4733z00_13557; } } 
SET_CDR(BgL_tail1370z00_13553, BgL_newtail1371z00_13554); 
{ /* Eval/evaluate_comp.scm 1161 */
obj_t BgL_arg3679z00_13558;
BgL_arg3679z00_13558 = 
CDR(
((obj_t)BgL_l1367z00_13552)); 
{ 
obj_t BgL_tail1370z00_21587;obj_t BgL_l1367z00_21586;
BgL_l1367z00_21586 = BgL_arg3679z00_13558; 
BgL_tail1370z00_21587 = BgL_newtail1371z00_13554; 
BgL_tail1370z00_13553 = BgL_tail1370z00_21587; 
BgL_l1367z00_13552 = BgL_l1367z00_21586; 
goto BgL_zc3anonymousza33677ze3z83_13551;} } } } } } 
BgL_iboxesz00_13531 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3675z00_13547); } 
BgL_siza7eza7_13532 = 
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_varsz00)); 
BgL_siza7ezd2framez75_13533 = 
(
(long)(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_siza7eza7))+
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_freez00))); 
BgL_nstkz00_13534 = 
BGl_appendzd221010zd2zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_varsz00), 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_freez00)); 
{ /* Eval/evaluate_comp.scm 1165 */
obj_t BgL_bodyz00_13559;
BgL_bodyz00_13559 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_bodyz00), BgL_nstkz00_13534); 
{ 

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_aux1245z00_13565;
BgL_aux1245z00_13565 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11447)))->BgL_arityz00); 
if(
INTEGERP(BgL_aux1245z00_13565))
{ /* Eval/evaluate_comp.scm 1167 */
switch( 
(long)CINT(BgL_aux1245z00_13565)) { case ((long)0) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33131ze3z83_13566;
BgL_zc3anonymousza33131ze3z83_13566 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33131ze3z83_13566, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33131ze3z83_13566, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33131ze3z83_13566, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33131ze3z83_13566;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33137ze3z83_13567;
BgL_zc3anonymousza33137ze3z83_13567 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33137ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33137ze3z83_13567, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33137ze3z83_13567, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33137ze3z83_13567, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33137ze3z83_13567, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33137ze3z83_13567;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33146ze3z83_13568;
BgL_zc3anonymousza33146ze3z83_13568 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33146ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33146ze3z83_13568, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33146ze3z83_13568, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33146ze3z83_13568, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33146ze3z83_13568, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33146ze3z83_13568, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33146ze3z83_13568;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33153ze3z83_13569;
BgL_zc3anonymousza33153ze3z83_13569 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33153ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33153ze3z83_13569, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33153ze3z83_13569, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33153ze3z83_13569, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33153ze3z83_13569, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33153ze3z83_13569, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33153ze3z83_13569, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33153ze3z83_13569;} } break;case ((long)-1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33166ze3z83_13570;
BgL_zc3anonymousza33166ze3z83_13570 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33166ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33166ze3z83_13570, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33166ze3z83_13570, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33166ze3z83_13570, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33166ze3z83_13570;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33173ze3z83_13571;
BgL_zc3anonymousza33173ze3z83_13571 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33173ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33173ze3z83_13571, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33173ze3z83_13571, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33173ze3z83_13571, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33173ze3z83_13571, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33173ze3z83_13571;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33183ze3z83_13572;
BgL_zc3anonymousza33183ze3z83_13572 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33183ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33183ze3z83_13572, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33183ze3z83_13572, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33183ze3z83_13572, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33183ze3z83_13572, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33183ze3z83_13572, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33183ze3z83_13572;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33191ze3z83_13573;
BgL_zc3anonymousza33191ze3z83_13573 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33191ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33191ze3z83_13573, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33191ze3z83_13573, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33191ze3z83_13573, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33191ze3z83_13573, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33191ze3z83_13573, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33191ze3z83_13573, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33191ze3z83_13573;} } break;case ((long)1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33205ze3z83_13574;
BgL_zc3anonymousza33205ze3z83_13574 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33205ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33205ze3z83_13574, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33205ze3z83_13574, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33205ze3z83_13574, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33205ze3z83_13574;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33212ze3z83_13575;
BgL_zc3anonymousza33212ze3z83_13575 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33212ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33212ze3z83_13575, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33212ze3z83_13575, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33212ze3z83_13575, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33212ze3z83_13575, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33212ze3z83_13575;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33222ze3z83_13576;
BgL_zc3anonymousza33222ze3z83_13576 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33222ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33222ze3z83_13576, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33222ze3z83_13576, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33222ze3z83_13576, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33222ze3z83_13576, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33222ze3z83_13576, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33222ze3z83_13576;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33230ze3z83_13577;
BgL_zc3anonymousza33230ze3z83_13577 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33230ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33230ze3z83_13577, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33230ze3z83_13577, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33230ze3z83_13577, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33230ze3z83_13577, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33230ze3z83_13577, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33230ze3z83_13577, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33230ze3z83_13577;} } break;case ((long)-2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33244ze3z83_13578;
BgL_zc3anonymousza33244ze3z83_13578 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33244ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33244ze3z83_13578, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33244ze3z83_13578, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33244ze3z83_13578, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33244ze3z83_13578;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33252ze3z83_13579;
BgL_zc3anonymousza33252ze3z83_13579 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33252ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33252ze3z83_13579, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33252ze3z83_13579, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33252ze3z83_13579, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33252ze3z83_13579, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33252ze3z83_13579;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33263ze3z83_13580;
BgL_zc3anonymousza33263ze3z83_13580 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33263ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33263ze3z83_13580, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33263ze3z83_13580, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33263ze3z83_13580, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33263ze3z83_13580, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33263ze3z83_13580, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33263ze3z83_13580;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33272ze3z83_13581;
BgL_zc3anonymousza33272ze3z83_13581 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33272ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33272ze3z83_13581, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33272ze3z83_13581, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33272ze3z83_13581, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33272ze3z83_13581, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33272ze3z83_13581, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33272ze3z83_13581, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33272ze3z83_13581;} } break;case ((long)2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33287ze3z83_13582;
BgL_zc3anonymousza33287ze3z83_13582 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33287ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33287ze3z83_13582, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33287ze3z83_13582, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33287ze3z83_13582, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33287ze3z83_13582;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33295ze3z83_13583;
BgL_zc3anonymousza33295ze3z83_13583 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33295ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33295ze3z83_13583, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33295ze3z83_13583, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33295ze3z83_13583, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33295ze3z83_13583, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33295ze3z83_13583;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33306ze3z83_13584;
BgL_zc3anonymousza33306ze3z83_13584 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33306ze3z83_13584, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33306ze3z83_13584, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33306ze3z83_13584, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33306ze3z83_13584, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33306ze3z83_13584, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33306ze3z83_13584;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33315ze3z83_13585;
BgL_zc3anonymousza33315ze3z83_13585 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33315ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33315ze3z83_13585, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33315ze3z83_13585, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33315ze3z83_13585, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33315ze3z83_13585, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33315ze3z83_13585, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33315ze3z83_13585, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33315ze3z83_13585;} } break;case ((long)-3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33330ze3z83_13586;
BgL_zc3anonymousza33330ze3z83_13586 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33330ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33330ze3z83_13586, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33330ze3z83_13586, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33330ze3z83_13586, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33330ze3z83_13586;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33339ze3z83_13587;
BgL_zc3anonymousza33339ze3z83_13587 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33339ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33339ze3z83_13587, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33339ze3z83_13587, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33339ze3z83_13587, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33339ze3z83_13587, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33339ze3z83_13587;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33351ze3z83_13588;
BgL_zc3anonymousza33351ze3z83_13588 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33351ze3z83_13588, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33351ze3z83_13588, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33351ze3z83_13588, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33351ze3z83_13588, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33351ze3z83_13588, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33351ze3z83_13588;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33361ze3z83_13589;
BgL_zc3anonymousza33361ze3z83_13589 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33361ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33361ze3z83_13589, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33361ze3z83_13589, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33361ze3z83_13589, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33361ze3z83_13589, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33361ze3z83_13589, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33361ze3z83_13589, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33361ze3z83_13589;} } break;case ((long)3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33377ze3z83_13590;
BgL_zc3anonymousza33377ze3z83_13590 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33377ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33377ze3z83_13590, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33377ze3z83_13590, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33377ze3z83_13590, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33377ze3z83_13590;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33386ze3z83_13591;
BgL_zc3anonymousza33386ze3z83_13591 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33386ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33386ze3z83_13591, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33386ze3z83_13591, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33386ze3z83_13591, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33386ze3z83_13591, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33386ze3z83_13591;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33398ze3z83_13592;
BgL_zc3anonymousza33398ze3z83_13592 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33398ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33398ze3z83_13592, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33398ze3z83_13592, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33398ze3z83_13592, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33398ze3z83_13592, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33398ze3z83_13592, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33398ze3z83_13592;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33408ze3z83_13593;
BgL_zc3anonymousza33408ze3z83_13593 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33408ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33408ze3z83_13593, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33408ze3z83_13593, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33408ze3z83_13593, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33408ze3z83_13593, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33408ze3z83_13593, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33408ze3z83_13593, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33408ze3z83_13593;} } break;case ((long)-4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33424ze3z83_13594;
BgL_zc3anonymousza33424ze3z83_13594 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33424ze3z83_13594, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33424ze3z83_13594, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33424ze3z83_13594, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33424ze3z83_13594;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33434ze3z83_13595;
BgL_zc3anonymousza33434ze3z83_13595 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33434ze3z83_13595, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33434ze3z83_13595, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33434ze3z83_13595, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33434ze3z83_13595, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33434ze3z83_13595;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33447ze3z83_13596;
BgL_zc3anonymousza33447ze3z83_13596 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33447ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33447ze3z83_13596, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33447ze3z83_13596, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33447ze3z83_13596, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33447ze3z83_13596, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33447ze3z83_13596, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33447ze3z83_13596;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33458ze3z83_13597;
BgL_zc3anonymousza33458ze3z83_13597 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33458ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33458ze3z83_13597, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33458ze3z83_13597, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33458ze3z83_13597, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33458ze3z83_13597, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33458ze3z83_13597, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33458ze3z83_13597, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33458ze3z83_13597;} } break;case ((long)4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33475ze3z83_13598;
BgL_zc3anonymousza33475ze3z83_13598 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33475ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33475ze3z83_13598, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33475ze3z83_13598, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33475ze3z83_13598, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33475ze3z83_13598;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33485ze3z83_13599;
BgL_zc3anonymousza33485ze3z83_13599 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33485ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33485ze3z83_13599, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33485ze3z83_13599, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33485ze3z83_13599, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33485ze3z83_13599, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33485ze3z83_13599;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33498ze3z83_13600;
BgL_zc3anonymousza33498ze3z83_13600 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33498ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33498ze3z83_13600, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33498ze3z83_13600, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33498ze3z83_13600, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33498ze3z83_13600, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33498ze3z83_13600, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33498ze3z83_13600;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33509ze3z83_13601;
BgL_zc3anonymousza33509ze3z83_13601 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_13601, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_13601, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_13601, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_13601, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_13601, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_13601, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33509ze3z83_13601;} } break;case ((long)-5) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33526ze3z83_13602;
BgL_zc3anonymousza33526ze3z83_13602 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33526ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33526ze3z83_13602, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33526ze3z83_13602, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33526ze3z83_13602, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33526ze3z83_13602;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33537ze3z83_13603;
BgL_zc3anonymousza33537ze3z83_13603 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33537ze3z83_13603, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33537ze3z83_13603, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33537ze3z83_13603, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33537ze3z83_13603, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33537ze3z83_13603;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33551ze3z83_13604;
BgL_zc3anonymousza33551ze3z83_13604 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33551ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33551ze3z83_13604, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33551ze3z83_13604, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33551ze3z83_13604, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33551ze3z83_13604, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33551ze3z83_13604, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33551ze3z83_13604;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33563ze3z83_13605;
BgL_zc3anonymousza33563ze3z83_13605 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33563ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33563ze3z83_13605, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33563ze3z83_13605, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33563ze3z83_13605, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33563ze3z83_13605, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33563ze3z83_13605, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33563ze3z83_13605, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33563ze3z83_13605;} } break;
default: 
BgL_case_else1244z00_13560:
if(
(
VECTOR_LENGTH(BgL_ifreesz00_13530)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33581ze3z83_13561;
BgL_zc3anonymousza33581ze3z83_13561 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33581ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33581ze3z83_13561, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33581ze3z83_13561, 
(int)(((long)1)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33581ze3z83_13561, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33581ze3z83_13561;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33601ze3z83_13562;
BgL_zc3anonymousza33601ze3z83_13562 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33601ze3z83_13562, 
(int)(((long)0)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33601ze3z83_13562, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33601ze3z83_13562, 
(int)(((long)2)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33601ze3z83_13562, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33601ze3z83_13562;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13531)==((long)0)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33624ze3z83_13563;
BgL_zc3anonymousza33624ze3z83_13563 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33624ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33624ze3z83_13563, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33624ze3z83_13563, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33624ze3z83_13563, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33624ze3z83_13563, 
(int)(((long)3)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33624ze3z83_13563, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33624ze3z83_13563;}  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_zc3anonymousza33645ze3z83_13564;
BgL_zc3anonymousza33645ze3z83_13564 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33645ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza33645ze3z83_13564, 
(int)(((long)0)), BgL_ifreesz00_13530); 
PROCEDURE_SET(BgL_zc3anonymousza33645ze3z83_13564, 
(int)(((long)1)), BgL_iboxesz00_13531); 
PROCEDURE_SET(BgL_zc3anonymousza33645ze3z83_13564, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13532)); 
PROCEDURE_SET(BgL_zc3anonymousza33645ze3z83_13564, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11447))); 
PROCEDURE_SET(BgL_zc3anonymousza33645ze3z83_13564, 
(int)(((long)4)), BgL_bodyz00_13559); 
PROCEDURE_SET(BgL_zc3anonymousza33645ze3z83_13564, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13533)); 
return BgL_zc3anonymousza33645ze3z83_13564;} } } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
goto BgL_case_else1244z00_13560;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3526> */
obj_t BGl_z62zc3anonymousza33526ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11449, obj_t BgL_sz00_11453)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11450;obj_t BgL_bodyz00_11451;long BgL_siza7ezd2framez75_11452;
BgL_i1243z00_11450 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11449, 
(int)(((long)0)))); 
BgL_bodyz00_11451 = 
PROCEDURE_REF(BgL_envz00_11449, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11452 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11449, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13606;
BgL_bpz00_13606 = 
VECTOR_REF(
((obj_t)BgL_sz00_11453),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13607;
BgL_runz00_13607 = 
MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13607, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11450)); 
PROCEDURE_SET(BgL_runz00_13607, 
(int)(((long)1)), BgL_bodyz00_11451); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13608;
BgL_mainz00_13608 = 
MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13608, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11450)); 
PROCEDURE_SET(BgL_mainz00_13608, 
(int)(((long)1)), BgL_bodyz00_11451); 
PROCEDURE_SET(BgL_mainz00_13608, 
(int)(((long)2)), BgL_runz00_13607); 
PROCEDURE_SET(BgL_mainz00_13608, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11452)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13609;
BgL_objz00_13609 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13607, BgL_objz00_13609); BgL_objz00_13609; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3527z00_13610;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3528z00_13611;
BgL_arg3528z00_13611 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11450))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13612;
BgL_newz00_13612 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22429;
BgL_tmpz00_22429 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13612, BgL_tmpz00_22429, BgL_arg3528z00_13611); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22434;int BgL_tmpz00_22432;
BgL_auxz00_22434 = 
BINT(BgL_siza7ezd2framez75_11452); 
BgL_tmpz00_22432 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13612, BgL_tmpz00_22432, BgL_auxz00_22434); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22437;
BgL_tmpz00_22437 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13612, BgL_tmpz00_22437, BgL_runz00_13607); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22442;int BgL_tmpz00_22440;
BgL_auxz00_22442 = 
BINT(((long)-5)); 
BgL_tmpz00_22440 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13612, BgL_tmpz00_22440, BgL_auxz00_22442); } 
BgL_arg3527z00_13610 = BgL_newz00_13612; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13608, BgL_arg3527z00_13610); BgL_arg3527z00_13610; } 
return BgL_mainz00_13608;} } } } } } 
BGL_FUNCTION_END;
}



/* &main */
obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_11454, obj_t BgL_az00_11459, obj_t BgL_bz00_11460, obj_t BgL_cz00_11461, obj_t BgL_dz00_11462, obj_t BgL_lastz00_11463)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11457;long BgL_siza7ezd2framez75_11458;
BgL_runz00_11457 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11454, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11458 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11454, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13613;
BgL_sz00_13613 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13614;
BgL_bpz00_13614 = 
VECTOR_REF(
((obj_t)BgL_sz00_13613),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13613, BgL_bpz00_13614, 
BINT(BgL_siza7ezd2framez75_11458)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3531z00_13615;
BgL_arg3531z00_13615 = 
(
(long)CINT(BgL_bpz00_13614)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13613),BgL_arg3531z00_13615,BgL_az00_11459); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3532z00_13616;
BgL_arg3532z00_13616 = 
(
(long)CINT(BgL_bpz00_13614)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13613),BgL_arg3532z00_13616,BgL_bz00_11460); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3533z00_13617;
BgL_arg3533z00_13617 = 
(
(long)CINT(BgL_bpz00_13614)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13613),BgL_arg3533z00_13617,BgL_cz00_11461); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3534z00_13618;
BgL_arg3534z00_13618 = 
(
(long)CINT(BgL_bpz00_13614)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13613),BgL_arg3534z00_13618,BgL_dz00_11462); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3535z00_13619;
BgL_arg3535z00_13619 = 
(
(long)CINT(BgL_bpz00_13614)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13613),BgL_arg3535z00_13619,BgL_lastz00_11463); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13620;
BgL_ez00_13620 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13620, BgL_bpz00_13614); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13621;
BgL_accz00_13621 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11457, BgL_sz00_13613, BgL_bpz00_13614); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13620); 
VECTOR_SET(
((obj_t)BgL_sz00_13613),((long)0),BgL_bpz00_13614); 
return BgL_accz00_13621;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13622;
BgL_nsz00_13622 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13622,((long)1),BgL_sz00_13613); 
VECTOR_SET(BgL_nsz00_13622,((long)2),BgL_az00_11459); 
VECTOR_SET(BgL_nsz00_13622,((long)3),BgL_bz00_11460); 
VECTOR_SET(BgL_nsz00_13622,((long)4),BgL_cz00_11461); 
VECTOR_SET(BgL_nsz00_13622,((long)5),BgL_dz00_11462); 
VECTOR_SET(BgL_nsz00_13622,((long)6),BgL_lastz00_11463); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13623;
BgL_z12denvz12_13623 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13623, BgL_nsz00_13622); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13624;
BgL_ez00_13624 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13624, BgL_sz00_13613); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13625;
BgL_____rz00_13625 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11457, BgL_nsz00_13622, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13624); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13623, BgL_sz00_13613); 
return BgL_____rz00_13625;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run */
obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_11464, obj_t BgL_sz00_11467)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11465;obj_t BgL_bodyz00_11466;
BgL_i1243z00_11465 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11464, 
(int)(((long)0)))); 
BgL_bodyz00_11466 = 
PROCEDURE_REF(BgL_envz00_11464, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13626;
BgL_bpz00_13626 = 
VECTOR_REF(
((obj_t)BgL_sz00_11467),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13627;obj_t BgL_wherez00_13628;obj_t BgL_locz00_13629;
BgL_z12denvz12_13627 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13628 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11465))->BgL_wherez00); 
BgL_locz00_13629 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11465))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13627, BgL_wherez00_13628, BgL_locz00_13629); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13630;
BgL_za2za2resza2za2z00_13630 = 
PROCEDURE_ENTRY(BgL_bodyz00_11466)(BgL_bodyz00_11466, BgL_sz00_11467, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13627); 
return BgL_za2za2resza2za2z00_13630;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3537> */
obj_t BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11468, obj_t BgL_sz00_11473)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11469;BgL_ev_absz00_bglt BgL_i1243z00_11470;obj_t BgL_bodyz00_11471;long BgL_siza7ezd2framez75_11472;
BgL_iboxesz00_11469 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11468, 
(int)(((long)0)))); 
BgL_i1243z00_11470 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11468, 
(int)(((long)1)))); 
BgL_bodyz00_11471 = 
PROCEDURE_REF(BgL_envz00_11468, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11472 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11468, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13631;
BgL_bpz00_13631 = 
VECTOR_REF(
((obj_t)BgL_sz00_11473),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13632;
BgL_runz00_13632 = 
MAKE_FX_PROCEDURE(BGl_z62run5097z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13632, 
(int)(((long)0)), BgL_iboxesz00_11469); 
PROCEDURE_SET(BgL_runz00_13632, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11470)); 
PROCEDURE_SET(BgL_runz00_13632, 
(int)(((long)2)), BgL_bodyz00_11471); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13633;
BgL_mainz00_13633 = 
MAKE_VA_PROCEDURE(BGl_z62main5096z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13633, 
(int)(((long)0)), BgL_iboxesz00_11469); 
PROCEDURE_SET(BgL_mainz00_13633, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11470)); 
PROCEDURE_SET(BgL_mainz00_13633, 
(int)(((long)2)), BgL_bodyz00_11471); 
PROCEDURE_SET(BgL_mainz00_13633, 
(int)(((long)3)), BgL_runz00_13632); 
PROCEDURE_SET(BgL_mainz00_13633, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11472)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13634;
BgL_objz00_13634 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13632, BgL_objz00_13634); BgL_objz00_13634; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3538z00_13635;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3539z00_13636;
BgL_arg3539z00_13636 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11470))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13637;
BgL_newz00_13637 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22557;
BgL_tmpz00_22557 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13637, BgL_tmpz00_22557, BgL_arg3539z00_13636); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22562;int BgL_tmpz00_22560;
BgL_auxz00_22562 = 
BINT(BgL_siza7ezd2framez75_11472); 
BgL_tmpz00_22560 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13637, BgL_tmpz00_22560, BgL_auxz00_22562); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22565;
BgL_tmpz00_22565 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13637, BgL_tmpz00_22565, BgL_runz00_13632); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22570;int BgL_tmpz00_22568;
BgL_auxz00_22570 = 
BINT(((long)-5)); 
BgL_tmpz00_22568 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13637, BgL_tmpz00_22568, BgL_auxz00_22570); } 
BgL_arg3538z00_13635 = BgL_newz00_13637; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13633, BgL_arg3538z00_13635); BgL_arg3538z00_13635; } 
return BgL_mainz00_13633;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5096 */
obj_t BGl_z62main5096z62zz__evaluate_compz00(obj_t BgL_envz00_11474, obj_t BgL_az00_11480, obj_t BgL_bz00_11481, obj_t BgL_cz00_11482, obj_t BgL_dz00_11483, obj_t BgL_lastz00_11484)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11478;long BgL_siza7ezd2framez75_11479;
BgL_runz00_11478 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11474, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11479 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11474, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13638;
BgL_sz00_13638 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13639;
BgL_bpz00_13639 = 
VECTOR_REF(
((obj_t)BgL_sz00_13638),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13638, BgL_bpz00_13639, 
BINT(BgL_siza7ezd2framez75_11479)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3542z00_13640;
BgL_arg3542z00_13640 = 
(
(long)CINT(BgL_bpz00_13639)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13638),BgL_arg3542z00_13640,BgL_az00_11480); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3543z00_13641;
BgL_arg3543z00_13641 = 
(
(long)CINT(BgL_bpz00_13639)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13638),BgL_arg3543z00_13641,BgL_bz00_11481); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3544z00_13642;
BgL_arg3544z00_13642 = 
(
(long)CINT(BgL_bpz00_13639)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13638),BgL_arg3544z00_13642,BgL_cz00_11482); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3545z00_13643;
BgL_arg3545z00_13643 = 
(
(long)CINT(BgL_bpz00_13639)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13638),BgL_arg3545z00_13643,BgL_dz00_11483); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3546z00_13644;
BgL_arg3546z00_13644 = 
(
(long)CINT(BgL_bpz00_13639)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13638),BgL_arg3546z00_13644,BgL_lastz00_11484); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13645;
BgL_ez00_13645 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13645, BgL_bpz00_13639); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13646;
BgL_accz00_13646 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11478, BgL_sz00_13638, BgL_bpz00_13639); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13645); 
VECTOR_SET(
((obj_t)BgL_sz00_13638),((long)0),BgL_bpz00_13639); 
return BgL_accz00_13646;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13647;
BgL_nsz00_13647 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13647,((long)1),BgL_sz00_13638); 
VECTOR_SET(BgL_nsz00_13647,((long)2),BgL_az00_11480); 
VECTOR_SET(BgL_nsz00_13647,((long)3),BgL_bz00_11481); 
VECTOR_SET(BgL_nsz00_13647,((long)4),BgL_cz00_11482); 
VECTOR_SET(BgL_nsz00_13647,((long)5),BgL_dz00_11483); 
VECTOR_SET(BgL_nsz00_13647,((long)6),BgL_lastz00_11484); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13648;
BgL_z12denvz12_13648 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13648, BgL_nsz00_13647); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13649;
BgL_ez00_13649 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13649, BgL_sz00_13638); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13650;
BgL_____rz00_13650 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11478, BgL_nsz00_13647, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13649); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13648, BgL_sz00_13638); 
return BgL_____rz00_13650;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5097 */
obj_t BGl_z62run5097z62zz__evaluate_compz00(obj_t BgL_envz00_11485, obj_t BgL_sz00_11489)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11486;BgL_ev_absz00_bglt BgL_i1243z00_11487;obj_t BgL_bodyz00_11488;
BgL_iboxesz00_11486 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11485, 
(int)(((long)0)))); 
BgL_i1243z00_11487 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11485, 
(int)(((long)1)))); 
BgL_bodyz00_11488 = 
PROCEDURE_REF(BgL_envz00_11485, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13651;
BgL_bpz00_13651 = 
VECTOR_REF(
((obj_t)BgL_sz00_11489),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11489, BgL_iboxesz00_11486, BgL_bpz00_13651); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13652;obj_t BgL_wherez00_13653;obj_t BgL_locz00_13654;
BgL_z12denvz12_13652 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13653 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11487))->BgL_wherez00); 
BgL_locz00_13654 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11487))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13652, BgL_wherez00_13653, BgL_locz00_13654); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13655;
BgL_za2za2resza2za2z00_13655 = 
PROCEDURE_ENTRY(BgL_bodyz00_11488)(BgL_bodyz00_11488, BgL_sz00_11489, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13652); 
return BgL_za2za2resza2za2z00_13655;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3551> */
obj_t BGl_z62zc3anonymousza33551ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11490, obj_t BgL_sz00_11496)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11491;long BgL_siza7eza7_11492;BgL_ev_absz00_bglt BgL_i1243z00_11493;obj_t BgL_bodyz00_11494;long BgL_siza7ezd2framez75_11495;
BgL_ifreesz00_11491 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11490, 
(int)(((long)0)))); 
BgL_siza7eza7_11492 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11490, 
(int)(((long)1)))); 
BgL_i1243z00_11493 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11490, 
(int)(((long)2)))); 
BgL_bodyz00_11494 = 
PROCEDURE_REF(BgL_envz00_11490, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11495 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11490, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13656;
BgL_bpz00_13656 = 
VECTOR_REF(
((obj_t)BgL_sz00_11496),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13657;
BgL_valza2za2_13657 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11496, BgL_bpz00_13656, BgL_ifreesz00_11491); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13658;
BgL_runz00_13658 = 
MAKE_FX_PROCEDURE(BGl_z62run5099z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13658, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11492)); 
PROCEDURE_SET(BgL_runz00_13658, 
(int)(((long)1)), BgL_valza2za2_13657); 
PROCEDURE_SET(BgL_runz00_13658, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11493)); 
PROCEDURE_SET(BgL_runz00_13658, 
(int)(((long)3)), BgL_bodyz00_11494); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13659;
BgL_mainz00_13659 = 
MAKE_VA_PROCEDURE(BGl_z62main5098z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13659, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11492)); 
PROCEDURE_SET(BgL_mainz00_13659, 
(int)(((long)1)), BgL_valza2za2_13657); 
PROCEDURE_SET(BgL_mainz00_13659, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11493)); 
PROCEDURE_SET(BgL_mainz00_13659, 
(int)(((long)3)), BgL_bodyz00_11494); 
PROCEDURE_SET(BgL_mainz00_13659, 
(int)(((long)4)), BgL_runz00_13658); 
PROCEDURE_SET(BgL_mainz00_13659, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11495)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13660;
BgL_objz00_13660 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13658, BgL_objz00_13660); BgL_objz00_13660; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3552z00_13661;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3553z00_13662;
BgL_arg3553z00_13662 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11493))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13663;
BgL_newz00_13663 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22699;
BgL_tmpz00_22699 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13663, BgL_tmpz00_22699, BgL_arg3553z00_13662); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22704;int BgL_tmpz00_22702;
BgL_auxz00_22704 = 
BINT(BgL_siza7ezd2framez75_11495); 
BgL_tmpz00_22702 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13663, BgL_tmpz00_22702, BgL_auxz00_22704); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22707;
BgL_tmpz00_22707 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13663, BgL_tmpz00_22707, BgL_runz00_13658); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22712;int BgL_tmpz00_22710;
BgL_auxz00_22712 = 
BINT(((long)-5)); 
BgL_tmpz00_22710 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13663, BgL_tmpz00_22710, BgL_auxz00_22712); } 
BgL_arg3552z00_13661 = BgL_newz00_13663; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13659, BgL_arg3552z00_13661); BgL_arg3552z00_13661; } 
return BgL_mainz00_13659;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5098 */
obj_t BGl_z62main5098z62zz__evaluate_compz00(obj_t BgL_envz00_11497, obj_t BgL_az00_11504, obj_t BgL_bz00_11505, obj_t BgL_cz00_11506, obj_t BgL_dz00_11507, obj_t BgL_lastz00_11508)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11502;long BgL_siza7ezd2framez75_11503;
BgL_runz00_11502 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11497, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11503 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11497, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13664;
BgL_sz00_13664 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13665;
BgL_bpz00_13665 = 
VECTOR_REF(
((obj_t)BgL_sz00_13664),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13664, BgL_bpz00_13665, 
BINT(BgL_siza7ezd2framez75_11503)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3556z00_13666;
BgL_arg3556z00_13666 = 
(
(long)CINT(BgL_bpz00_13665)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13664),BgL_arg3556z00_13666,BgL_az00_11504); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3557z00_13667;
BgL_arg3557z00_13667 = 
(
(long)CINT(BgL_bpz00_13665)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13664),BgL_arg3557z00_13667,BgL_bz00_11505); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3558z00_13668;
BgL_arg3558z00_13668 = 
(
(long)CINT(BgL_bpz00_13665)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13664),BgL_arg3558z00_13668,BgL_cz00_11506); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3559z00_13669;
BgL_arg3559z00_13669 = 
(
(long)CINT(BgL_bpz00_13665)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13664),BgL_arg3559z00_13669,BgL_dz00_11507); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3560z00_13670;
BgL_arg3560z00_13670 = 
(
(long)CINT(BgL_bpz00_13665)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13664),BgL_arg3560z00_13670,BgL_lastz00_11508); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13671;
BgL_ez00_13671 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13671, BgL_bpz00_13665); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13672;
BgL_accz00_13672 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11502, BgL_sz00_13664, BgL_bpz00_13665); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13671); 
VECTOR_SET(
((obj_t)BgL_sz00_13664),((long)0),BgL_bpz00_13665); 
return BgL_accz00_13672;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13673;
BgL_nsz00_13673 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13673,((long)1),BgL_sz00_13664); 
VECTOR_SET(BgL_nsz00_13673,((long)2),BgL_az00_11504); 
VECTOR_SET(BgL_nsz00_13673,((long)3),BgL_bz00_11505); 
VECTOR_SET(BgL_nsz00_13673,((long)4),BgL_cz00_11506); 
VECTOR_SET(BgL_nsz00_13673,((long)5),BgL_dz00_11507); 
VECTOR_SET(BgL_nsz00_13673,((long)6),BgL_lastz00_11508); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13674;
BgL_z12denvz12_13674 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13674, BgL_nsz00_13673); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13675;
BgL_ez00_13675 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13675, BgL_sz00_13664); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13676;
BgL_____rz00_13676 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11502, BgL_nsz00_13673, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13675); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13674, BgL_sz00_13664); 
return BgL_____rz00_13676;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5099 */
obj_t BGl_z62run5099z62zz__evaluate_compz00(obj_t BgL_envz00_11509, obj_t BgL_sz00_11514)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_11510;obj_t BgL_valza2za2_11511;BgL_ev_absz00_bglt BgL_i1243z00_11512;obj_t BgL_bodyz00_11513;
BgL_siza7eza7_11510 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11509, 
(int)(((long)0)))); 
BgL_valza2za2_11511 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11509, 
(int)(((long)1)))); 
BgL_i1243z00_11512 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11509, 
(int)(((long)2)))); 
BgL_bodyz00_11513 = 
PROCEDURE_REF(BgL_envz00_11509, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13677;
BgL_bpz00_13677 = 
VECTOR_REF(
((obj_t)BgL_sz00_11514),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11514, BgL_valza2za2_11511, 
(
(long)CINT(BgL_bpz00_13677)+BgL_siza7eza7_11510)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13678;obj_t BgL_wherez00_13679;obj_t BgL_locz00_13680;
BgL_z12denvz12_13678 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13679 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11512))->BgL_wherez00); 
BgL_locz00_13680 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11512))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13678, BgL_wherez00_13679, BgL_locz00_13680); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13681;
BgL_za2za2resza2za2z00_13681 = 
PROCEDURE_ENTRY(BgL_bodyz00_11513)(BgL_bodyz00_11513, BgL_sz00_11514, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13678); 
return BgL_za2za2resza2za2z00_13681;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3563> */
obj_t BGl_z62zc3anonymousza33563ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11515, obj_t BgL_sz00_11522)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11516;obj_t BgL_iboxesz00_11517;long BgL_siza7eza7_11518;BgL_ev_absz00_bglt BgL_i1243z00_11519;obj_t BgL_bodyz00_11520;long BgL_siza7ezd2framez75_11521;
BgL_ifreesz00_11516 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)0)))); 
BgL_iboxesz00_11517 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)1)))); 
BgL_siza7eza7_11518 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)2)))); 
BgL_i1243z00_11519 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)3)))); 
BgL_bodyz00_11520 = 
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11521 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11515, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13682;
BgL_bpz00_13682 = 
VECTOR_REF(
((obj_t)BgL_sz00_11522),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13683;
BgL_valza2za2_13683 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11522, BgL_bpz00_13682, BgL_ifreesz00_11516); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13684;
BgL_runz00_13684 = 
MAKE_FX_PROCEDURE(BGl_z62run5101z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13684, 
(int)(((long)0)), BgL_iboxesz00_11517); 
PROCEDURE_SET(BgL_runz00_13684, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11518)); 
PROCEDURE_SET(BgL_runz00_13684, 
(int)(((long)2)), BgL_valza2za2_13683); 
PROCEDURE_SET(BgL_runz00_13684, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11519)); 
PROCEDURE_SET(BgL_runz00_13684, 
(int)(((long)4)), BgL_bodyz00_11520); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13685;
BgL_mainz00_13685 = 
MAKE_VA_PROCEDURE(BGl_z62main5100z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)0)), BgL_iboxesz00_11517); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11518)); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)2)), BgL_valza2za2_13683); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11519)); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)4)), BgL_bodyz00_11520); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)5)), BgL_runz00_13684); 
PROCEDURE_SET(BgL_mainz00_13685, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11521)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13686;
BgL_objz00_13686 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13684, BgL_objz00_13686); BgL_objz00_13686; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3564z00_13687;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3565z00_13688;
BgL_arg3565z00_13688 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11519))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13689;
BgL_newz00_13689 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22853;
BgL_tmpz00_22853 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13689, BgL_tmpz00_22853, BgL_arg3565z00_13688); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22858;int BgL_tmpz00_22856;
BgL_auxz00_22858 = 
BINT(BgL_siza7ezd2framez75_11521); 
BgL_tmpz00_22856 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13689, BgL_tmpz00_22856, BgL_auxz00_22858); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22861;
BgL_tmpz00_22861 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13689, BgL_tmpz00_22861, BgL_runz00_13684); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22866;int BgL_tmpz00_22864;
BgL_auxz00_22866 = 
BINT(((long)-5)); 
BgL_tmpz00_22864 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13689, BgL_tmpz00_22864, BgL_auxz00_22866); } 
BgL_arg3564z00_13687 = BgL_newz00_13689; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13685, BgL_arg3564z00_13687); BgL_arg3564z00_13687; } 
return BgL_mainz00_13685;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5100 */
obj_t BGl_z62main5100z62zz__evaluate_compz00(obj_t BgL_envz00_11523, obj_t BgL_az00_11531, obj_t BgL_bz00_11532, obj_t BgL_cz00_11533, obj_t BgL_dz00_11534, obj_t BgL_lastz00_11535)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11529;long BgL_siza7ezd2framez75_11530;
BgL_runz00_11529 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11523, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11530 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11523, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13690;
BgL_sz00_13690 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13691;
BgL_bpz00_13691 = 
VECTOR_REF(
((obj_t)BgL_sz00_13690),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13690, BgL_bpz00_13691, 
BINT(BgL_siza7ezd2framez75_11530)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3568z00_13692;
BgL_arg3568z00_13692 = 
(
(long)CINT(BgL_bpz00_13691)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13690),BgL_arg3568z00_13692,BgL_az00_11531); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3569z00_13693;
BgL_arg3569z00_13693 = 
(
(long)CINT(BgL_bpz00_13691)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13690),BgL_arg3569z00_13693,BgL_bz00_11532); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3570z00_13694;
BgL_arg3570z00_13694 = 
(
(long)CINT(BgL_bpz00_13691)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13690),BgL_arg3570z00_13694,BgL_cz00_11533); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3571z00_13695;
BgL_arg3571z00_13695 = 
(
(long)CINT(BgL_bpz00_13691)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13690),BgL_arg3571z00_13695,BgL_dz00_11534); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3572z00_13696;
BgL_arg3572z00_13696 = 
(
(long)CINT(BgL_bpz00_13691)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13690),BgL_arg3572z00_13696,BgL_lastz00_11535); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13697;
BgL_ez00_13697 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13697, BgL_bpz00_13691); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13698;
BgL_accz00_13698 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11529, BgL_sz00_13690, BgL_bpz00_13691); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13697); 
VECTOR_SET(
((obj_t)BgL_sz00_13690),((long)0),BgL_bpz00_13691); 
return BgL_accz00_13698;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13699;
BgL_nsz00_13699 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13699,((long)1),BgL_sz00_13690); 
VECTOR_SET(BgL_nsz00_13699,((long)2),BgL_az00_11531); 
VECTOR_SET(BgL_nsz00_13699,((long)3),BgL_bz00_11532); 
VECTOR_SET(BgL_nsz00_13699,((long)4),BgL_cz00_11533); 
VECTOR_SET(BgL_nsz00_13699,((long)5),BgL_dz00_11534); 
VECTOR_SET(BgL_nsz00_13699,((long)6),BgL_lastz00_11535); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13700;
BgL_z12denvz12_13700 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13700, BgL_nsz00_13699); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13701;
BgL_ez00_13701 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13701, BgL_sz00_13690); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13702;
BgL_____rz00_13702 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11529, BgL_nsz00_13699, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13701); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13700, BgL_sz00_13690); 
return BgL_____rz00_13702;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5101 */
obj_t BGl_z62run5101z62zz__evaluate_compz00(obj_t BgL_envz00_11536, obj_t BgL_sz00_11542)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11537;long BgL_siza7eza7_11538;obj_t BgL_valza2za2_11539;BgL_ev_absz00_bglt BgL_i1243z00_11540;obj_t BgL_bodyz00_11541;
BgL_iboxesz00_11537 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11536, 
(int)(((long)0)))); 
BgL_siza7eza7_11538 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11536, 
(int)(((long)1)))); 
BgL_valza2za2_11539 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11536, 
(int)(((long)2)))); 
BgL_i1243z00_11540 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11536, 
(int)(((long)3)))); 
BgL_bodyz00_11541 = 
PROCEDURE_REF(BgL_envz00_11536, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13703;
BgL_bpz00_13703 = 
VECTOR_REF(
((obj_t)BgL_sz00_11542),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11542, BgL_iboxesz00_11537, BgL_bpz00_13703); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11542, BgL_valza2za2_11539, 
(
(long)CINT(BgL_bpz00_13703)+BgL_siza7eza7_11538)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13704;obj_t BgL_wherez00_13705;obj_t BgL_locz00_13706;
BgL_z12denvz12_13704 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13705 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11540))->BgL_wherez00); 
BgL_locz00_13706 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11540))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13704, BgL_wherez00_13705, BgL_locz00_13706); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13707;
BgL_za2za2resza2za2z00_13707 = 
PROCEDURE_ENTRY(BgL_bodyz00_11541)(BgL_bodyz00_11541, BgL_sz00_11542, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13704); 
return BgL_za2za2resza2za2z00_13707;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3475> */
obj_t BGl_z62zc3anonymousza33475ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11543, obj_t BgL_sz00_11547)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11544;obj_t BgL_bodyz00_11545;long BgL_siza7ezd2framez75_11546;
BgL_i1243z00_11544 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11543, 
(int)(((long)0)))); 
BgL_bodyz00_11545 = 
PROCEDURE_REF(BgL_envz00_11543, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11546 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11543, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13708;
BgL_bpz00_13708 = 
VECTOR_REF(
((obj_t)BgL_sz00_11547),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13709;
BgL_runz00_13709 = 
MAKE_FX_PROCEDURE(BGl_z62run5103z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13709, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11544)); 
PROCEDURE_SET(BgL_runz00_13709, 
(int)(((long)1)), BgL_bodyz00_11545); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13710;
BgL_mainz00_13710 = 
MAKE_FX_PROCEDURE(BGl_z62main5102z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13710, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11544)); 
PROCEDURE_SET(BgL_mainz00_13710, 
(int)(((long)1)), BgL_bodyz00_11545); 
PROCEDURE_SET(BgL_mainz00_13710, 
(int)(((long)2)), BgL_runz00_13709); 
PROCEDURE_SET(BgL_mainz00_13710, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11546)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13711;
BgL_objz00_13711 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13709, BgL_objz00_13711); BgL_objz00_13711; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3476z00_13712;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3477z00_13713;
BgL_arg3477z00_13713 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11544))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13714;
BgL_newz00_13714 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22987;
BgL_tmpz00_22987 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13714, BgL_tmpz00_22987, BgL_arg3477z00_13713); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_22992;int BgL_tmpz00_22990;
BgL_auxz00_22992 = 
BINT(BgL_siza7ezd2framez75_11546); 
BgL_tmpz00_22990 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13714, BgL_tmpz00_22990, BgL_auxz00_22992); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_22995;
BgL_tmpz00_22995 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13714, BgL_tmpz00_22995, BgL_runz00_13709); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23000;int BgL_tmpz00_22998;
BgL_auxz00_23000 = 
BINT(((long)4)); 
BgL_tmpz00_22998 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13714, BgL_tmpz00_22998, BgL_auxz00_23000); } 
BgL_arg3476z00_13712 = BgL_newz00_13714; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13710, BgL_arg3476z00_13712); BgL_arg3476z00_13712; } 
return BgL_mainz00_13710;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5102 */
obj_t BGl_z62main5102z62zz__evaluate_compz00(obj_t BgL_envz00_11548, obj_t BgL_az00_11553, obj_t BgL_bz00_11554, obj_t BgL_cz00_11555, obj_t BgL_dz00_11556)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11551;long BgL_siza7ezd2framez75_11552;
BgL_runz00_11551 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11548, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11552 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11548, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13715;
BgL_sz00_13715 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13716;
BgL_bpz00_13716 = 
VECTOR_REF(
((obj_t)BgL_sz00_13715),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13715, BgL_bpz00_13716, 
BINT(BgL_siza7ezd2framez75_11552)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3480z00_13717;
BgL_arg3480z00_13717 = 
(
(long)CINT(BgL_bpz00_13716)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13715),BgL_arg3480z00_13717,BgL_az00_11553); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3481z00_13718;
BgL_arg3481z00_13718 = 
(
(long)CINT(BgL_bpz00_13716)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13715),BgL_arg3481z00_13718,BgL_bz00_11554); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3482z00_13719;
BgL_arg3482z00_13719 = 
(
(long)CINT(BgL_bpz00_13716)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13715),BgL_arg3482z00_13719,BgL_cz00_11555); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3483z00_13720;
BgL_arg3483z00_13720 = 
(
(long)CINT(BgL_bpz00_13716)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13715),BgL_arg3483z00_13720,BgL_dz00_11556); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13721;
BgL_ez00_13721 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13721, BgL_bpz00_13716); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13722;
BgL_accz00_13722 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11551, BgL_sz00_13715, BgL_bpz00_13716); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13721); 
VECTOR_SET(
((obj_t)BgL_sz00_13715),((long)0),BgL_bpz00_13716); 
return BgL_accz00_13722;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13723;
BgL_nsz00_13723 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13723,((long)1),BgL_sz00_13715); 
VECTOR_SET(BgL_nsz00_13723,((long)2),BgL_az00_11553); 
VECTOR_SET(BgL_nsz00_13723,((long)3),BgL_bz00_11554); 
VECTOR_SET(BgL_nsz00_13723,((long)4),BgL_cz00_11555); 
VECTOR_SET(BgL_nsz00_13723,((long)5),BgL_dz00_11556); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13724;
BgL_z12denvz12_13724 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13724, BgL_nsz00_13723); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13725;
BgL_ez00_13725 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13725, BgL_sz00_13715); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13726;
BgL_____rz00_13726 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11551, BgL_nsz00_13723, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13725); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13724, BgL_sz00_13715); 
return BgL_____rz00_13726;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5103 */
obj_t BGl_z62run5103z62zz__evaluate_compz00(obj_t BgL_envz00_11557, obj_t BgL_sz00_11560)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11558;obj_t BgL_bodyz00_11559;
BgL_i1243z00_11558 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11557, 
(int)(((long)0)))); 
BgL_bodyz00_11559 = 
PROCEDURE_REF(BgL_envz00_11557, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13727;
BgL_bpz00_13727 = 
VECTOR_REF(
((obj_t)BgL_sz00_11560),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13728;obj_t BgL_wherez00_13729;obj_t BgL_locz00_13730;
BgL_z12denvz12_13728 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13729 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11558))->BgL_wherez00); 
BgL_locz00_13730 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11558))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13728, BgL_wherez00_13729, BgL_locz00_13730); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13731;
BgL_za2za2resza2za2z00_13731 = 
PROCEDURE_ENTRY(BgL_bodyz00_11559)(BgL_bodyz00_11559, BgL_sz00_11560, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13728); 
return BgL_za2za2resza2za2z00_13731;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3485> */
obj_t BGl_z62zc3anonymousza33485ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11561, obj_t BgL_sz00_11566)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11562;BgL_ev_absz00_bglt BgL_i1243z00_11563;obj_t BgL_bodyz00_11564;long BgL_siza7ezd2framez75_11565;
BgL_iboxesz00_11562 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)0)))); 
BgL_i1243z00_11563 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)1)))); 
BgL_bodyz00_11564 = 
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11565 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13732;
BgL_bpz00_13732 = 
VECTOR_REF(
((obj_t)BgL_sz00_11566),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13733;
BgL_runz00_13733 = 
MAKE_FX_PROCEDURE(BGl_z62run5105z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13733, 
(int)(((long)0)), BgL_iboxesz00_11562); 
PROCEDURE_SET(BgL_runz00_13733, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11563)); 
PROCEDURE_SET(BgL_runz00_13733, 
(int)(((long)2)), BgL_bodyz00_11564); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13734;
BgL_mainz00_13734 = 
MAKE_FX_PROCEDURE(BGl_z62main5104z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13734, 
(int)(((long)0)), BgL_iboxesz00_11562); 
PROCEDURE_SET(BgL_mainz00_13734, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11563)); 
PROCEDURE_SET(BgL_mainz00_13734, 
(int)(((long)2)), BgL_bodyz00_11564); 
PROCEDURE_SET(BgL_mainz00_13734, 
(int)(((long)3)), BgL_runz00_13733); 
PROCEDURE_SET(BgL_mainz00_13734, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11565)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13735;
BgL_objz00_13735 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13733, BgL_objz00_13735); BgL_objz00_13735; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3486z00_13736;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3487z00_13737;
BgL_arg3487z00_13737 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11563))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13738;
BgL_newz00_13738 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23110;
BgL_tmpz00_23110 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13738, BgL_tmpz00_23110, BgL_arg3487z00_13737); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23115;int BgL_tmpz00_23113;
BgL_auxz00_23115 = 
BINT(BgL_siza7ezd2framez75_11565); 
BgL_tmpz00_23113 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13738, BgL_tmpz00_23113, BgL_auxz00_23115); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23118;
BgL_tmpz00_23118 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13738, BgL_tmpz00_23118, BgL_runz00_13733); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23123;int BgL_tmpz00_23121;
BgL_auxz00_23123 = 
BINT(((long)4)); 
BgL_tmpz00_23121 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13738, BgL_tmpz00_23121, BgL_auxz00_23123); } 
BgL_arg3486z00_13736 = BgL_newz00_13738; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13734, BgL_arg3486z00_13736); BgL_arg3486z00_13736; } 
return BgL_mainz00_13734;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5104 */
obj_t BGl_z62main5104z62zz__evaluate_compz00(obj_t BgL_envz00_11567, obj_t BgL_az00_11573, obj_t BgL_bz00_11574, obj_t BgL_cz00_11575, obj_t BgL_dz00_11576)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11571;long BgL_siza7ezd2framez75_11572;
BgL_runz00_11571 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11567, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11572 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11567, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13739;
BgL_sz00_13739 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13740;
BgL_bpz00_13740 = 
VECTOR_REF(
((obj_t)BgL_sz00_13739),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13739, BgL_bpz00_13740, 
BINT(BgL_siza7ezd2framez75_11572)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3490z00_13741;
BgL_arg3490z00_13741 = 
(
(long)CINT(BgL_bpz00_13740)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13739),BgL_arg3490z00_13741,BgL_az00_11573); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3491z00_13742;
BgL_arg3491z00_13742 = 
(
(long)CINT(BgL_bpz00_13740)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13739),BgL_arg3491z00_13742,BgL_bz00_11574); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3492z00_13743;
BgL_arg3492z00_13743 = 
(
(long)CINT(BgL_bpz00_13740)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13739),BgL_arg3492z00_13743,BgL_cz00_11575); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3493z00_13744;
BgL_arg3493z00_13744 = 
(
(long)CINT(BgL_bpz00_13740)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13739),BgL_arg3493z00_13744,BgL_dz00_11576); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13745;
BgL_ez00_13745 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13745, BgL_bpz00_13740); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13746;
BgL_accz00_13746 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11571, BgL_sz00_13739, BgL_bpz00_13740); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13745); 
VECTOR_SET(
((obj_t)BgL_sz00_13739),((long)0),BgL_bpz00_13740); 
return BgL_accz00_13746;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13747;
BgL_nsz00_13747 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13747,((long)1),BgL_sz00_13739); 
VECTOR_SET(BgL_nsz00_13747,((long)2),BgL_az00_11573); 
VECTOR_SET(BgL_nsz00_13747,((long)3),BgL_bz00_11574); 
VECTOR_SET(BgL_nsz00_13747,((long)4),BgL_cz00_11575); 
VECTOR_SET(BgL_nsz00_13747,((long)5),BgL_dz00_11576); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13748;
BgL_z12denvz12_13748 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13748, BgL_nsz00_13747); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13749;
BgL_ez00_13749 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13749, BgL_sz00_13739); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13750;
BgL_____rz00_13750 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11571, BgL_nsz00_13747, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13749); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13748, BgL_sz00_13739); 
return BgL_____rz00_13750;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5105 */
obj_t BGl_z62run5105z62zz__evaluate_compz00(obj_t BgL_envz00_11577, obj_t BgL_sz00_11581)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11578;BgL_ev_absz00_bglt BgL_i1243z00_11579;obj_t BgL_bodyz00_11580;
BgL_iboxesz00_11578 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11577, 
(int)(((long)0)))); 
BgL_i1243z00_11579 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11577, 
(int)(((long)1)))); 
BgL_bodyz00_11580 = 
PROCEDURE_REF(BgL_envz00_11577, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13751;
BgL_bpz00_13751 = 
VECTOR_REF(
((obj_t)BgL_sz00_11581),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11581, BgL_iboxesz00_11578, BgL_bpz00_13751); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13752;obj_t BgL_wherez00_13753;obj_t BgL_locz00_13754;
BgL_z12denvz12_13752 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13753 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11579))->BgL_wherez00); 
BgL_locz00_13754 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11579))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13752, BgL_wherez00_13753, BgL_locz00_13754); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13755;
BgL_za2za2resza2za2z00_13755 = 
PROCEDURE_ENTRY(BgL_bodyz00_11580)(BgL_bodyz00_11580, BgL_sz00_11581, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13752); 
return BgL_za2za2resza2za2z00_13755;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3498> */
obj_t BGl_z62zc3anonymousza33498ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11582, obj_t BgL_sz00_11588)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11583;long BgL_siza7eza7_11584;BgL_ev_absz00_bglt BgL_i1243z00_11585;obj_t BgL_bodyz00_11586;long BgL_siza7ezd2framez75_11587;
BgL_ifreesz00_11583 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11582, 
(int)(((long)0)))); 
BgL_siza7eza7_11584 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11582, 
(int)(((long)1)))); 
BgL_i1243z00_11585 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11582, 
(int)(((long)2)))); 
BgL_bodyz00_11586 = 
PROCEDURE_REF(BgL_envz00_11582, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11587 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11582, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13756;
BgL_bpz00_13756 = 
VECTOR_REF(
((obj_t)BgL_sz00_11588),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13757;
BgL_valza2za2_13757 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11588, BgL_bpz00_13756, BgL_ifreesz00_11583); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13758;
BgL_runz00_13758 = 
MAKE_FX_PROCEDURE(BGl_z62run5107z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13758, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11584)); 
PROCEDURE_SET(BgL_runz00_13758, 
(int)(((long)1)), BgL_valza2za2_13757); 
PROCEDURE_SET(BgL_runz00_13758, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11585)); 
PROCEDURE_SET(BgL_runz00_13758, 
(int)(((long)3)), BgL_bodyz00_11586); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13759;
BgL_mainz00_13759 = 
MAKE_FX_PROCEDURE(BGl_z62main5106z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13759, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11584)); 
PROCEDURE_SET(BgL_mainz00_13759, 
(int)(((long)1)), BgL_valza2za2_13757); 
PROCEDURE_SET(BgL_mainz00_13759, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11585)); 
PROCEDURE_SET(BgL_mainz00_13759, 
(int)(((long)3)), BgL_bodyz00_11586); 
PROCEDURE_SET(BgL_mainz00_13759, 
(int)(((long)4)), BgL_runz00_13758); 
PROCEDURE_SET(BgL_mainz00_13759, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11587)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13760;
BgL_objz00_13760 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13758, BgL_objz00_13760); BgL_objz00_13760; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3499z00_13761;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3500z00_13762;
BgL_arg3500z00_13762 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11585))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13763;
BgL_newz00_13763 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23247;
BgL_tmpz00_23247 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13763, BgL_tmpz00_23247, BgL_arg3500z00_13762); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23252;int BgL_tmpz00_23250;
BgL_auxz00_23252 = 
BINT(BgL_siza7ezd2framez75_11587); 
BgL_tmpz00_23250 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13763, BgL_tmpz00_23250, BgL_auxz00_23252); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23255;
BgL_tmpz00_23255 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13763, BgL_tmpz00_23255, BgL_runz00_13758); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23260;int BgL_tmpz00_23258;
BgL_auxz00_23260 = 
BINT(((long)4)); 
BgL_tmpz00_23258 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13763, BgL_tmpz00_23258, BgL_auxz00_23260); } 
BgL_arg3499z00_13761 = BgL_newz00_13763; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13759, BgL_arg3499z00_13761); BgL_arg3499z00_13761; } 
return BgL_mainz00_13759;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5106 */
obj_t BGl_z62main5106z62zz__evaluate_compz00(obj_t BgL_envz00_11589, obj_t BgL_az00_11596, obj_t BgL_bz00_11597, obj_t BgL_cz00_11598, obj_t BgL_dz00_11599)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11594;long BgL_siza7ezd2framez75_11595;
BgL_runz00_11594 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11589, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11595 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11589, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13764;
BgL_sz00_13764 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13765;
BgL_bpz00_13765 = 
VECTOR_REF(
((obj_t)BgL_sz00_13764),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13764, BgL_bpz00_13765, 
BINT(BgL_siza7ezd2framez75_11595)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3503z00_13766;
BgL_arg3503z00_13766 = 
(
(long)CINT(BgL_bpz00_13765)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13764),BgL_arg3503z00_13766,BgL_az00_11596); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3504z00_13767;
BgL_arg3504z00_13767 = 
(
(long)CINT(BgL_bpz00_13765)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13764),BgL_arg3504z00_13767,BgL_bz00_11597); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3505z00_13768;
BgL_arg3505z00_13768 = 
(
(long)CINT(BgL_bpz00_13765)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13764),BgL_arg3505z00_13768,BgL_cz00_11598); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3506z00_13769;
BgL_arg3506z00_13769 = 
(
(long)CINT(BgL_bpz00_13765)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13764),BgL_arg3506z00_13769,BgL_dz00_11599); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13770;
BgL_ez00_13770 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13770, BgL_bpz00_13765); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13771;
BgL_accz00_13771 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11594, BgL_sz00_13764, BgL_bpz00_13765); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13770); 
VECTOR_SET(
((obj_t)BgL_sz00_13764),((long)0),BgL_bpz00_13765); 
return BgL_accz00_13771;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13772;
BgL_nsz00_13772 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13772,((long)1),BgL_sz00_13764); 
VECTOR_SET(BgL_nsz00_13772,((long)2),BgL_az00_11596); 
VECTOR_SET(BgL_nsz00_13772,((long)3),BgL_bz00_11597); 
VECTOR_SET(BgL_nsz00_13772,((long)4),BgL_cz00_11598); 
VECTOR_SET(BgL_nsz00_13772,((long)5),BgL_dz00_11599); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13773;
BgL_z12denvz12_13773 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13773, BgL_nsz00_13772); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13774;
BgL_ez00_13774 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13774, BgL_sz00_13764); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13775;
BgL_____rz00_13775 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11594, BgL_nsz00_13772, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13774); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13773, BgL_sz00_13764); 
return BgL_____rz00_13775;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5107 */
obj_t BGl_z62run5107z62zz__evaluate_compz00(obj_t BgL_envz00_11600, obj_t BgL_sz00_11605)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_11601;obj_t BgL_valza2za2_11602;BgL_ev_absz00_bglt BgL_i1243z00_11603;obj_t BgL_bodyz00_11604;
BgL_siza7eza7_11601 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11600, 
(int)(((long)0)))); 
BgL_valza2za2_11602 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11600, 
(int)(((long)1)))); 
BgL_i1243z00_11603 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11600, 
(int)(((long)2)))); 
BgL_bodyz00_11604 = 
PROCEDURE_REF(BgL_envz00_11600, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13776;
BgL_bpz00_13776 = 
VECTOR_REF(
((obj_t)BgL_sz00_11605),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11605, BgL_valza2za2_11602, 
(
(long)CINT(BgL_bpz00_13776)+BgL_siza7eza7_11601)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13777;obj_t BgL_wherez00_13778;obj_t BgL_locz00_13779;
BgL_z12denvz12_13777 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13778 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11603))->BgL_wherez00); 
BgL_locz00_13779 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11603))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13777, BgL_wherez00_13778, BgL_locz00_13779); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13780;
BgL_za2za2resza2za2z00_13780 = 
PROCEDURE_ENTRY(BgL_bodyz00_11604)(BgL_bodyz00_11604, BgL_sz00_11605, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13777); 
return BgL_za2za2resza2za2z00_13780;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3509> */
obj_t BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11606, obj_t BgL_sz00_11613)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11607;obj_t BgL_iboxesz00_11608;long BgL_siza7eza7_11609;BgL_ev_absz00_bglt BgL_i1243z00_11610;obj_t BgL_bodyz00_11611;long BgL_siza7ezd2framez75_11612;
BgL_ifreesz00_11607 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)0)))); 
BgL_iboxesz00_11608 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)1)))); 
BgL_siza7eza7_11609 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)2)))); 
BgL_i1243z00_11610 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)3)))); 
BgL_bodyz00_11611 = 
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11612 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11606, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13781;
BgL_bpz00_13781 = 
VECTOR_REF(
((obj_t)BgL_sz00_11613),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13782;
BgL_valza2za2_13782 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11613, BgL_bpz00_13781, BgL_ifreesz00_11607); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13783;
BgL_runz00_13783 = 
MAKE_FX_PROCEDURE(BGl_z62run5109z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13783, 
(int)(((long)0)), BgL_iboxesz00_11608); 
PROCEDURE_SET(BgL_runz00_13783, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11609)); 
PROCEDURE_SET(BgL_runz00_13783, 
(int)(((long)2)), BgL_valza2za2_13782); 
PROCEDURE_SET(BgL_runz00_13783, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11610)); 
PROCEDURE_SET(BgL_runz00_13783, 
(int)(((long)4)), BgL_bodyz00_11611); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13784;
BgL_mainz00_13784 = 
MAKE_FX_PROCEDURE(BGl_z62main5108z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)0)), BgL_iboxesz00_11608); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11609)); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)2)), BgL_valza2za2_13782); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11610)); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)4)), BgL_bodyz00_11611); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)5)), BgL_runz00_13783); 
PROCEDURE_SET(BgL_mainz00_13784, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11612)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13785;
BgL_objz00_13785 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13783, BgL_objz00_13785); BgL_objz00_13785; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3510z00_13786;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3511z00_13787;
BgL_arg3511z00_13787 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11610))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13788;
BgL_newz00_13788 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23396;
BgL_tmpz00_23396 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13788, BgL_tmpz00_23396, BgL_arg3511z00_13787); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23401;int BgL_tmpz00_23399;
BgL_auxz00_23401 = 
BINT(BgL_siza7ezd2framez75_11612); 
BgL_tmpz00_23399 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13788, BgL_tmpz00_23399, BgL_auxz00_23401); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23404;
BgL_tmpz00_23404 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13788, BgL_tmpz00_23404, BgL_runz00_13783); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23409;int BgL_tmpz00_23407;
BgL_auxz00_23409 = 
BINT(((long)4)); 
BgL_tmpz00_23407 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13788, BgL_tmpz00_23407, BgL_auxz00_23409); } 
BgL_arg3510z00_13786 = BgL_newz00_13788; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13784, BgL_arg3510z00_13786); BgL_arg3510z00_13786; } 
return BgL_mainz00_13784;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5108 */
obj_t BGl_z62main5108z62zz__evaluate_compz00(obj_t BgL_envz00_11614, obj_t BgL_az00_11622, obj_t BgL_bz00_11623, obj_t BgL_cz00_11624, obj_t BgL_dz00_11625)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11620;long BgL_siza7ezd2framez75_11621;
BgL_runz00_11620 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11614, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11621 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11614, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13789;
BgL_sz00_13789 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13790;
BgL_bpz00_13790 = 
VECTOR_REF(
((obj_t)BgL_sz00_13789),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13789, BgL_bpz00_13790, 
BINT(BgL_siza7ezd2framez75_11621)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3514z00_13791;
BgL_arg3514z00_13791 = 
(
(long)CINT(BgL_bpz00_13790)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13789),BgL_arg3514z00_13791,BgL_az00_11622); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3515z00_13792;
BgL_arg3515z00_13792 = 
(
(long)CINT(BgL_bpz00_13790)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13789),BgL_arg3515z00_13792,BgL_bz00_11623); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3516z00_13793;
BgL_arg3516z00_13793 = 
(
(long)CINT(BgL_bpz00_13790)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13789),BgL_arg3516z00_13793,BgL_cz00_11624); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3517z00_13794;
BgL_arg3517z00_13794 = 
(
(long)CINT(BgL_bpz00_13790)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13789),BgL_arg3517z00_13794,BgL_dz00_11625); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13795;
BgL_ez00_13795 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13795, BgL_bpz00_13790); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13796;
BgL_accz00_13796 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11620, BgL_sz00_13789, BgL_bpz00_13790); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13795); 
VECTOR_SET(
((obj_t)BgL_sz00_13789),((long)0),BgL_bpz00_13790); 
return BgL_accz00_13796;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13797;
BgL_nsz00_13797 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13797,((long)1),BgL_sz00_13789); 
VECTOR_SET(BgL_nsz00_13797,((long)2),BgL_az00_11622); 
VECTOR_SET(BgL_nsz00_13797,((long)3),BgL_bz00_11623); 
VECTOR_SET(BgL_nsz00_13797,((long)4),BgL_cz00_11624); 
VECTOR_SET(BgL_nsz00_13797,((long)5),BgL_dz00_11625); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13798;
BgL_z12denvz12_13798 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13798, BgL_nsz00_13797); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13799;
BgL_ez00_13799 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13799, BgL_sz00_13789); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13800;
BgL_____rz00_13800 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11620, BgL_nsz00_13797, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13799); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13798, BgL_sz00_13789); 
return BgL_____rz00_13800;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5109 */
obj_t BGl_z62run5109z62zz__evaluate_compz00(obj_t BgL_envz00_11626, obj_t BgL_sz00_11632)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11627;long BgL_siza7eza7_11628;obj_t BgL_valza2za2_11629;BgL_ev_absz00_bglt BgL_i1243z00_11630;obj_t BgL_bodyz00_11631;
BgL_iboxesz00_11627 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11626, 
(int)(((long)0)))); 
BgL_siza7eza7_11628 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11626, 
(int)(((long)1)))); 
BgL_valza2za2_11629 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11626, 
(int)(((long)2)))); 
BgL_i1243z00_11630 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11626, 
(int)(((long)3)))); 
BgL_bodyz00_11631 = 
PROCEDURE_REF(BgL_envz00_11626, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13801;
BgL_bpz00_13801 = 
VECTOR_REF(
((obj_t)BgL_sz00_11632),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11632, BgL_iboxesz00_11627, BgL_bpz00_13801); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11632, BgL_valza2za2_11629, 
(
(long)CINT(BgL_bpz00_13801)+BgL_siza7eza7_11628)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13802;obj_t BgL_wherez00_13803;obj_t BgL_locz00_13804;
BgL_z12denvz12_13802 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13803 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11630))->BgL_wherez00); 
BgL_locz00_13804 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11630))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13802, BgL_wherez00_13803, BgL_locz00_13804); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13805;
BgL_za2za2resza2za2z00_13805 = 
PROCEDURE_ENTRY(BgL_bodyz00_11631)(BgL_bodyz00_11631, BgL_sz00_11632, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13802); 
return BgL_za2za2resza2za2z00_13805;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3424> */
obj_t BGl_z62zc3anonymousza33424ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11633, obj_t BgL_sz00_11637)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11634;obj_t BgL_bodyz00_11635;long BgL_siza7ezd2framez75_11636;
BgL_i1243z00_11634 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11633, 
(int)(((long)0)))); 
BgL_bodyz00_11635 = 
PROCEDURE_REF(BgL_envz00_11633, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11636 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11633, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13806;
BgL_bpz00_13806 = 
VECTOR_REF(
((obj_t)BgL_sz00_11637),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13807;
BgL_runz00_13807 = 
MAKE_FX_PROCEDURE(BGl_z62run5111z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13807, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11634)); 
PROCEDURE_SET(BgL_runz00_13807, 
(int)(((long)1)), BgL_bodyz00_11635); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13808;
BgL_mainz00_13808 = 
MAKE_VA_PROCEDURE(BGl_z62main5110z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13808, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11634)); 
PROCEDURE_SET(BgL_mainz00_13808, 
(int)(((long)1)), BgL_bodyz00_11635); 
PROCEDURE_SET(BgL_mainz00_13808, 
(int)(((long)2)), BgL_runz00_13807); 
PROCEDURE_SET(BgL_mainz00_13808, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11636)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13809;
BgL_objz00_13809 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13807, BgL_objz00_13809); BgL_objz00_13809; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3425z00_13810;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3426z00_13811;
BgL_arg3426z00_13811 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11634))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13812;
BgL_newz00_13812 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23525;
BgL_tmpz00_23525 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13812, BgL_tmpz00_23525, BgL_arg3426z00_13811); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23530;int BgL_tmpz00_23528;
BgL_auxz00_23530 = 
BINT(BgL_siza7ezd2framez75_11636); 
BgL_tmpz00_23528 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13812, BgL_tmpz00_23528, BgL_auxz00_23530); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23533;
BgL_tmpz00_23533 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13812, BgL_tmpz00_23533, BgL_runz00_13807); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23538;int BgL_tmpz00_23536;
BgL_auxz00_23538 = 
BINT(((long)-4)); 
BgL_tmpz00_23536 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13812, BgL_tmpz00_23536, BgL_auxz00_23538); } 
BgL_arg3425z00_13810 = BgL_newz00_13812; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13808, BgL_arg3425z00_13810); BgL_arg3425z00_13810; } 
return BgL_mainz00_13808;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5110 */
obj_t BGl_z62main5110z62zz__evaluate_compz00(obj_t BgL_envz00_11638, obj_t BgL_bz00_11643, obj_t BgL_cz00_11644, obj_t BgL_dz00_11645, obj_t BgL_lastz00_11646)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11641;long BgL_siza7ezd2framez75_11642;
BgL_runz00_11641 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11638, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11642 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11638, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13813;
BgL_sz00_13813 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13814;
BgL_bpz00_13814 = 
VECTOR_REF(
((obj_t)BgL_sz00_13813),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13813, BgL_bpz00_13814, 
BINT(BgL_siza7ezd2framez75_11642)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3429z00_13815;
BgL_arg3429z00_13815 = 
(
(long)CINT(BgL_bpz00_13814)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13813),BgL_arg3429z00_13815,BgL_bz00_11643); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3430z00_13816;
BgL_arg3430z00_13816 = 
(
(long)CINT(BgL_bpz00_13814)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13813),BgL_arg3430z00_13816,BgL_cz00_11644); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3431z00_13817;
BgL_arg3431z00_13817 = 
(
(long)CINT(BgL_bpz00_13814)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13813),BgL_arg3431z00_13817,BgL_dz00_11645); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3432z00_13818;
BgL_arg3432z00_13818 = 
(
(long)CINT(BgL_bpz00_13814)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13813),BgL_arg3432z00_13818,BgL_lastz00_11646); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13819;
BgL_ez00_13819 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13819, BgL_bpz00_13814); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13820;
BgL_accz00_13820 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11641, BgL_sz00_13813, BgL_bpz00_13814); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13819); 
VECTOR_SET(
((obj_t)BgL_sz00_13813),((long)0),BgL_bpz00_13814); 
return BgL_accz00_13820;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13821;
BgL_nsz00_13821 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13821,((long)1),BgL_sz00_13813); 
VECTOR_SET(BgL_nsz00_13821,((long)2),BgL_bz00_11643); 
VECTOR_SET(BgL_nsz00_13821,((long)3),BgL_cz00_11644); 
VECTOR_SET(BgL_nsz00_13821,((long)4),BgL_dz00_11645); 
VECTOR_SET(BgL_nsz00_13821,((long)5),BgL_lastz00_11646); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13822;
BgL_z12denvz12_13822 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13822, BgL_nsz00_13821); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13823;
BgL_ez00_13823 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13823, BgL_sz00_13813); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13824;
BgL_____rz00_13824 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11641, BgL_nsz00_13821, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13823); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13822, BgL_sz00_13813); 
return BgL_____rz00_13824;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5111 */
obj_t BGl_z62run5111z62zz__evaluate_compz00(obj_t BgL_envz00_11647, obj_t BgL_sz00_11650)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11648;obj_t BgL_bodyz00_11649;
BgL_i1243z00_11648 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11647, 
(int)(((long)0)))); 
BgL_bodyz00_11649 = 
PROCEDURE_REF(BgL_envz00_11647, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13825;
BgL_bpz00_13825 = 
VECTOR_REF(
((obj_t)BgL_sz00_11650),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13826;obj_t BgL_wherez00_13827;obj_t BgL_locz00_13828;
BgL_z12denvz12_13826 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13827 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11648))->BgL_wherez00); 
BgL_locz00_13828 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11648))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13826, BgL_wherez00_13827, BgL_locz00_13828); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13829;
BgL_za2za2resza2za2z00_13829 = 
PROCEDURE_ENTRY(BgL_bodyz00_11649)(BgL_bodyz00_11649, BgL_sz00_11650, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13826); 
return BgL_za2za2resza2za2z00_13829;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3434> */
obj_t BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11651, obj_t BgL_sz00_11656)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11652;BgL_ev_absz00_bglt BgL_i1243z00_11653;obj_t BgL_bodyz00_11654;long BgL_siza7ezd2framez75_11655;
BgL_iboxesz00_11652 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11651, 
(int)(((long)0)))); 
BgL_i1243z00_11653 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11651, 
(int)(((long)1)))); 
BgL_bodyz00_11654 = 
PROCEDURE_REF(BgL_envz00_11651, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11655 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11651, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13830;
BgL_bpz00_13830 = 
VECTOR_REF(
((obj_t)BgL_sz00_11656),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13831;
BgL_runz00_13831 = 
MAKE_FX_PROCEDURE(BGl_z62run5113z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13831, 
(int)(((long)0)), BgL_iboxesz00_11652); 
PROCEDURE_SET(BgL_runz00_13831, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11653)); 
PROCEDURE_SET(BgL_runz00_13831, 
(int)(((long)2)), BgL_bodyz00_11654); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13832;
BgL_mainz00_13832 = 
MAKE_VA_PROCEDURE(BGl_z62main5112z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13832, 
(int)(((long)0)), BgL_iboxesz00_11652); 
PROCEDURE_SET(BgL_mainz00_13832, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11653)); 
PROCEDURE_SET(BgL_mainz00_13832, 
(int)(((long)2)), BgL_bodyz00_11654); 
PROCEDURE_SET(BgL_mainz00_13832, 
(int)(((long)3)), BgL_runz00_13831); 
PROCEDURE_SET(BgL_mainz00_13832, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11655)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13833;
BgL_objz00_13833 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13831, BgL_objz00_13833); BgL_objz00_13833; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3435z00_13834;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3436z00_13835;
BgL_arg3436z00_13835 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11653))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13836;
BgL_newz00_13836 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23648;
BgL_tmpz00_23648 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13836, BgL_tmpz00_23648, BgL_arg3436z00_13835); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23653;int BgL_tmpz00_23651;
BgL_auxz00_23653 = 
BINT(BgL_siza7ezd2framez75_11655); 
BgL_tmpz00_23651 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13836, BgL_tmpz00_23651, BgL_auxz00_23653); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23656;
BgL_tmpz00_23656 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13836, BgL_tmpz00_23656, BgL_runz00_13831); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23661;int BgL_tmpz00_23659;
BgL_auxz00_23661 = 
BINT(((long)-4)); 
BgL_tmpz00_23659 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13836, BgL_tmpz00_23659, BgL_auxz00_23661); } 
BgL_arg3435z00_13834 = BgL_newz00_13836; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13832, BgL_arg3435z00_13834); BgL_arg3435z00_13834; } 
return BgL_mainz00_13832;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5112 */
obj_t BGl_z62main5112z62zz__evaluate_compz00(obj_t BgL_envz00_11657, obj_t BgL_bz00_11663, obj_t BgL_cz00_11664, obj_t BgL_dz00_11665, obj_t BgL_lastz00_11666)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11661;long BgL_siza7ezd2framez75_11662;
BgL_runz00_11661 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11657, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11662 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11657, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13837;
BgL_sz00_13837 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13838;
BgL_bpz00_13838 = 
VECTOR_REF(
((obj_t)BgL_sz00_13837),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13837, BgL_bpz00_13838, 
BINT(BgL_siza7ezd2framez75_11662)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3439z00_13839;
BgL_arg3439z00_13839 = 
(
(long)CINT(BgL_bpz00_13838)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13837),BgL_arg3439z00_13839,BgL_bz00_11663); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3440z00_13840;
BgL_arg3440z00_13840 = 
(
(long)CINT(BgL_bpz00_13838)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13837),BgL_arg3440z00_13840,BgL_cz00_11664); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3441z00_13841;
BgL_arg3441z00_13841 = 
(
(long)CINT(BgL_bpz00_13838)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13837),BgL_arg3441z00_13841,BgL_dz00_11665); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3442z00_13842;
BgL_arg3442z00_13842 = 
(
(long)CINT(BgL_bpz00_13838)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13837),BgL_arg3442z00_13842,BgL_lastz00_11666); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13843;
BgL_ez00_13843 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13843, BgL_bpz00_13838); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13844;
BgL_accz00_13844 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11661, BgL_sz00_13837, BgL_bpz00_13838); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13843); 
VECTOR_SET(
((obj_t)BgL_sz00_13837),((long)0),BgL_bpz00_13838); 
return BgL_accz00_13844;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13845;
BgL_nsz00_13845 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13845,((long)1),BgL_sz00_13837); 
VECTOR_SET(BgL_nsz00_13845,((long)2),BgL_bz00_11663); 
VECTOR_SET(BgL_nsz00_13845,((long)3),BgL_cz00_11664); 
VECTOR_SET(BgL_nsz00_13845,((long)4),BgL_dz00_11665); 
VECTOR_SET(BgL_nsz00_13845,((long)5),BgL_lastz00_11666); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13846;
BgL_z12denvz12_13846 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13846, BgL_nsz00_13845); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13847;
BgL_ez00_13847 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13847, BgL_sz00_13837); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13848;
BgL_____rz00_13848 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11661, BgL_nsz00_13845, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13847); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13846, BgL_sz00_13837); 
return BgL_____rz00_13848;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5113 */
obj_t BGl_z62run5113z62zz__evaluate_compz00(obj_t BgL_envz00_11667, obj_t BgL_sz00_11671)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11668;BgL_ev_absz00_bglt BgL_i1243z00_11669;obj_t BgL_bodyz00_11670;
BgL_iboxesz00_11668 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11667, 
(int)(((long)0)))); 
BgL_i1243z00_11669 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11667, 
(int)(((long)1)))); 
BgL_bodyz00_11670 = 
PROCEDURE_REF(BgL_envz00_11667, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13849;
BgL_bpz00_13849 = 
VECTOR_REF(
((obj_t)BgL_sz00_11671),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11671, BgL_iboxesz00_11668, BgL_bpz00_13849); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13850;obj_t BgL_wherez00_13851;obj_t BgL_locz00_13852;
BgL_z12denvz12_13850 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13851 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11669))->BgL_wherez00); 
BgL_locz00_13852 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11669))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13850, BgL_wherez00_13851, BgL_locz00_13852); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13853;
BgL_za2za2resza2za2z00_13853 = 
PROCEDURE_ENTRY(BgL_bodyz00_11670)(BgL_bodyz00_11670, BgL_sz00_11671, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13850); 
return BgL_za2za2resza2za2z00_13853;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3447> */
obj_t BGl_z62zc3anonymousza33447ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11672, obj_t BgL_sz00_11678)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11673;long BgL_siza7eza7_11674;BgL_ev_absz00_bglt BgL_i1243z00_11675;obj_t BgL_bodyz00_11676;long BgL_siza7ezd2framez75_11677;
BgL_ifreesz00_11673 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11672, 
(int)(((long)0)))); 
BgL_siza7eza7_11674 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11672, 
(int)(((long)1)))); 
BgL_i1243z00_11675 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11672, 
(int)(((long)2)))); 
BgL_bodyz00_11676 = 
PROCEDURE_REF(BgL_envz00_11672, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11677 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11672, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13854;
BgL_bpz00_13854 = 
VECTOR_REF(
((obj_t)BgL_sz00_11678),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13855;
BgL_valza2za2_13855 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11678, BgL_bpz00_13854, BgL_ifreesz00_11673); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13856;
BgL_runz00_13856 = 
MAKE_FX_PROCEDURE(BGl_z62run5115z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13856, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11674)); 
PROCEDURE_SET(BgL_runz00_13856, 
(int)(((long)1)), BgL_valza2za2_13855); 
PROCEDURE_SET(BgL_runz00_13856, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11675)); 
PROCEDURE_SET(BgL_runz00_13856, 
(int)(((long)3)), BgL_bodyz00_11676); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13857;
BgL_mainz00_13857 = 
MAKE_VA_PROCEDURE(BGl_z62main5114z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13857, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11674)); 
PROCEDURE_SET(BgL_mainz00_13857, 
(int)(((long)1)), BgL_valza2za2_13855); 
PROCEDURE_SET(BgL_mainz00_13857, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11675)); 
PROCEDURE_SET(BgL_mainz00_13857, 
(int)(((long)3)), BgL_bodyz00_11676); 
PROCEDURE_SET(BgL_mainz00_13857, 
(int)(((long)4)), BgL_runz00_13856); 
PROCEDURE_SET(BgL_mainz00_13857, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11677)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13858;
BgL_objz00_13858 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13856, BgL_objz00_13858); BgL_objz00_13858; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3448z00_13859;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3449z00_13860;
BgL_arg3449z00_13860 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11675))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13861;
BgL_newz00_13861 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23785;
BgL_tmpz00_23785 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13861, BgL_tmpz00_23785, BgL_arg3449z00_13860); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23790;int BgL_tmpz00_23788;
BgL_auxz00_23790 = 
BINT(BgL_siza7ezd2framez75_11677); 
BgL_tmpz00_23788 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13861, BgL_tmpz00_23788, BgL_auxz00_23790); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23793;
BgL_tmpz00_23793 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13861, BgL_tmpz00_23793, BgL_runz00_13856); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23798;int BgL_tmpz00_23796;
BgL_auxz00_23798 = 
BINT(((long)-4)); 
BgL_tmpz00_23796 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13861, BgL_tmpz00_23796, BgL_auxz00_23798); } 
BgL_arg3448z00_13859 = BgL_newz00_13861; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13857, BgL_arg3448z00_13859); BgL_arg3448z00_13859; } 
return BgL_mainz00_13857;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5114 */
obj_t BGl_z62main5114z62zz__evaluate_compz00(obj_t BgL_envz00_11679, obj_t BgL_bz00_11686, obj_t BgL_cz00_11687, obj_t BgL_dz00_11688, obj_t BgL_lastz00_11689)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11684;long BgL_siza7ezd2framez75_11685;
BgL_runz00_11684 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11679, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11685 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11679, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13862;
BgL_sz00_13862 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13863;
BgL_bpz00_13863 = 
VECTOR_REF(
((obj_t)BgL_sz00_13862),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13862, BgL_bpz00_13863, 
BINT(BgL_siza7ezd2framez75_11685)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3452z00_13864;
BgL_arg3452z00_13864 = 
(
(long)CINT(BgL_bpz00_13863)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13862),BgL_arg3452z00_13864,BgL_bz00_11686); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3453z00_13865;
BgL_arg3453z00_13865 = 
(
(long)CINT(BgL_bpz00_13863)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13862),BgL_arg3453z00_13865,BgL_cz00_11687); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3454z00_13866;
BgL_arg3454z00_13866 = 
(
(long)CINT(BgL_bpz00_13863)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13862),BgL_arg3454z00_13866,BgL_dz00_11688); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3455z00_13867;
BgL_arg3455z00_13867 = 
(
(long)CINT(BgL_bpz00_13863)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13862),BgL_arg3455z00_13867,BgL_lastz00_11689); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13868;
BgL_ez00_13868 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13868, BgL_bpz00_13863); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13869;
BgL_accz00_13869 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11684, BgL_sz00_13862, BgL_bpz00_13863); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13868); 
VECTOR_SET(
((obj_t)BgL_sz00_13862),((long)0),BgL_bpz00_13863); 
return BgL_accz00_13869;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13870;
BgL_nsz00_13870 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13870,((long)1),BgL_sz00_13862); 
VECTOR_SET(BgL_nsz00_13870,((long)2),BgL_bz00_11686); 
VECTOR_SET(BgL_nsz00_13870,((long)3),BgL_cz00_11687); 
VECTOR_SET(BgL_nsz00_13870,((long)4),BgL_dz00_11688); 
VECTOR_SET(BgL_nsz00_13870,((long)5),BgL_lastz00_11689); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13871;
BgL_z12denvz12_13871 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13871, BgL_nsz00_13870); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13872;
BgL_ez00_13872 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13872, BgL_sz00_13862); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13873;
BgL_____rz00_13873 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11684, BgL_nsz00_13870, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13872); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13871, BgL_sz00_13862); 
return BgL_____rz00_13873;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5115 */
obj_t BGl_z62run5115z62zz__evaluate_compz00(obj_t BgL_envz00_11690, obj_t BgL_sz00_11695)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_11691;obj_t BgL_valza2za2_11692;BgL_ev_absz00_bglt BgL_i1243z00_11693;obj_t BgL_bodyz00_11694;
BgL_siza7eza7_11691 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11690, 
(int)(((long)0)))); 
BgL_valza2za2_11692 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11690, 
(int)(((long)1)))); 
BgL_i1243z00_11693 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11690, 
(int)(((long)2)))); 
BgL_bodyz00_11694 = 
PROCEDURE_REF(BgL_envz00_11690, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13874;
BgL_bpz00_13874 = 
VECTOR_REF(
((obj_t)BgL_sz00_11695),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11695, BgL_valza2za2_11692, 
(
(long)CINT(BgL_bpz00_13874)+BgL_siza7eza7_11691)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13875;obj_t BgL_wherez00_13876;obj_t BgL_locz00_13877;
BgL_z12denvz12_13875 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13876 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11693))->BgL_wherez00); 
BgL_locz00_13877 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11693))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13875, BgL_wherez00_13876, BgL_locz00_13877); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13878;
BgL_za2za2resza2za2z00_13878 = 
PROCEDURE_ENTRY(BgL_bodyz00_11694)(BgL_bodyz00_11694, BgL_sz00_11695, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13875); 
return BgL_za2za2resza2za2z00_13878;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3458> */
obj_t BGl_z62zc3anonymousza33458ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11696, obj_t BgL_sz00_11703)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11697;obj_t BgL_iboxesz00_11698;long BgL_siza7eza7_11699;BgL_ev_absz00_bglt BgL_i1243z00_11700;obj_t BgL_bodyz00_11701;long BgL_siza7ezd2framez75_11702;
BgL_ifreesz00_11697 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)0)))); 
BgL_iboxesz00_11698 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)1)))); 
BgL_siza7eza7_11699 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)2)))); 
BgL_i1243z00_11700 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)3)))); 
BgL_bodyz00_11701 = 
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11702 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11696, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13879;
BgL_bpz00_13879 = 
VECTOR_REF(
((obj_t)BgL_sz00_11703),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13880;
BgL_valza2za2_13880 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11703, BgL_bpz00_13879, BgL_ifreesz00_11697); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13881;
BgL_runz00_13881 = 
MAKE_FX_PROCEDURE(BGl_z62run5117z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13881, 
(int)(((long)0)), BgL_iboxesz00_11698); 
PROCEDURE_SET(BgL_runz00_13881, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11699)); 
PROCEDURE_SET(BgL_runz00_13881, 
(int)(((long)2)), BgL_valza2za2_13880); 
PROCEDURE_SET(BgL_runz00_13881, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11700)); 
PROCEDURE_SET(BgL_runz00_13881, 
(int)(((long)4)), BgL_bodyz00_11701); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13882;
BgL_mainz00_13882 = 
MAKE_VA_PROCEDURE(BGl_z62main5116z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)0)), BgL_iboxesz00_11698); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11699)); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)2)), BgL_valza2za2_13880); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11700)); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)4)), BgL_bodyz00_11701); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)5)), BgL_runz00_13881); 
PROCEDURE_SET(BgL_mainz00_13882, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11702)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13883;
BgL_objz00_13883 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13881, BgL_objz00_13883); BgL_objz00_13883; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3459z00_13884;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3460z00_13885;
BgL_arg3460z00_13885 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11700))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13886;
BgL_newz00_13886 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23934;
BgL_tmpz00_23934 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13886, BgL_tmpz00_23934, BgL_arg3460z00_13885); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23939;int BgL_tmpz00_23937;
BgL_auxz00_23939 = 
BINT(BgL_siza7ezd2framez75_11702); 
BgL_tmpz00_23937 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13886, BgL_tmpz00_23937, BgL_auxz00_23939); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_23942;
BgL_tmpz00_23942 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13886, BgL_tmpz00_23942, BgL_runz00_13881); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_23947;int BgL_tmpz00_23945;
BgL_auxz00_23947 = 
BINT(((long)-4)); 
BgL_tmpz00_23945 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13886, BgL_tmpz00_23945, BgL_auxz00_23947); } 
BgL_arg3459z00_13884 = BgL_newz00_13886; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13882, BgL_arg3459z00_13884); BgL_arg3459z00_13884; } 
return BgL_mainz00_13882;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5116 */
obj_t BGl_z62main5116z62zz__evaluate_compz00(obj_t BgL_envz00_11704, obj_t BgL_bz00_11712, obj_t BgL_cz00_11713, obj_t BgL_dz00_11714, obj_t BgL_lastz00_11715)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11710;long BgL_siza7ezd2framez75_11711;
BgL_runz00_11710 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11704, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11711 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11704, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13887;
BgL_sz00_13887 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13888;
BgL_bpz00_13888 = 
VECTOR_REF(
((obj_t)BgL_sz00_13887),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13887, BgL_bpz00_13888, 
BINT(BgL_siza7ezd2framez75_11711)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3463z00_13889;
BgL_arg3463z00_13889 = 
(
(long)CINT(BgL_bpz00_13888)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13887),BgL_arg3463z00_13889,BgL_bz00_11712); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3464z00_13890;
BgL_arg3464z00_13890 = 
(
(long)CINT(BgL_bpz00_13888)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13887),BgL_arg3464z00_13890,BgL_cz00_11713); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3465z00_13891;
BgL_arg3465z00_13891 = 
(
(long)CINT(BgL_bpz00_13888)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13887),BgL_arg3465z00_13891,BgL_dz00_11714); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3466z00_13892;
BgL_arg3466z00_13892 = 
(
(long)CINT(BgL_bpz00_13888)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13887),BgL_arg3466z00_13892,BgL_lastz00_11715); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13893;
BgL_ez00_13893 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13893, BgL_bpz00_13888); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13894;
BgL_accz00_13894 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11710, BgL_sz00_13887, BgL_bpz00_13888); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13893); 
VECTOR_SET(
((obj_t)BgL_sz00_13887),((long)0),BgL_bpz00_13888); 
return BgL_accz00_13894;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13895;
BgL_nsz00_13895 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13895,((long)1),BgL_sz00_13887); 
VECTOR_SET(BgL_nsz00_13895,((long)2),BgL_bz00_11712); 
VECTOR_SET(BgL_nsz00_13895,((long)3),BgL_cz00_11713); 
VECTOR_SET(BgL_nsz00_13895,((long)4),BgL_dz00_11714); 
VECTOR_SET(BgL_nsz00_13895,((long)5),BgL_lastz00_11715); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13896;
BgL_z12denvz12_13896 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13896, BgL_nsz00_13895); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13897;
BgL_ez00_13897 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13897, BgL_sz00_13887); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13898;
BgL_____rz00_13898 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11710, BgL_nsz00_13895, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13897); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13896, BgL_sz00_13887); 
return BgL_____rz00_13898;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5117 */
obj_t BGl_z62run5117z62zz__evaluate_compz00(obj_t BgL_envz00_11716, obj_t BgL_sz00_11722)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11717;long BgL_siza7eza7_11718;obj_t BgL_valza2za2_11719;BgL_ev_absz00_bglt BgL_i1243z00_11720;obj_t BgL_bodyz00_11721;
BgL_iboxesz00_11717 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11716, 
(int)(((long)0)))); 
BgL_siza7eza7_11718 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11716, 
(int)(((long)1)))); 
BgL_valza2za2_11719 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11716, 
(int)(((long)2)))); 
BgL_i1243z00_11720 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11716, 
(int)(((long)3)))); 
BgL_bodyz00_11721 = 
PROCEDURE_REF(BgL_envz00_11716, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13899;
BgL_bpz00_13899 = 
VECTOR_REF(
((obj_t)BgL_sz00_11722),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11722, BgL_iboxesz00_11717, BgL_bpz00_13899); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11722, BgL_valza2za2_11719, 
(
(long)CINT(BgL_bpz00_13899)+BgL_siza7eza7_11718)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13900;obj_t BgL_wherez00_13901;obj_t BgL_locz00_13902;
BgL_z12denvz12_13900 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13901 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11720))->BgL_wherez00); 
BgL_locz00_13902 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11720))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13900, BgL_wherez00_13901, BgL_locz00_13902); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13903;
BgL_za2za2resza2za2z00_13903 = 
PROCEDURE_ENTRY(BgL_bodyz00_11721)(BgL_bodyz00_11721, BgL_sz00_11722, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13900); 
return BgL_za2za2resza2za2z00_13903;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3377> */
obj_t BGl_z62zc3anonymousza33377ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11723, obj_t BgL_sz00_11727)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11724;obj_t BgL_bodyz00_11725;long BgL_siza7ezd2framez75_11726;
BgL_i1243z00_11724 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11723, 
(int)(((long)0)))); 
BgL_bodyz00_11725 = 
PROCEDURE_REF(BgL_envz00_11723, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11726 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11723, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13904;
BgL_bpz00_13904 = 
VECTOR_REF(
((obj_t)BgL_sz00_11727),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13905;
BgL_runz00_13905 = 
MAKE_FX_PROCEDURE(BGl_z62run5119z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13905, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11724)); 
PROCEDURE_SET(BgL_runz00_13905, 
(int)(((long)1)), BgL_bodyz00_11725); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13906;
BgL_mainz00_13906 = 
MAKE_FX_PROCEDURE(BGl_z62main5118z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13906, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11724)); 
PROCEDURE_SET(BgL_mainz00_13906, 
(int)(((long)1)), BgL_bodyz00_11725); 
PROCEDURE_SET(BgL_mainz00_13906, 
(int)(((long)2)), BgL_runz00_13905); 
PROCEDURE_SET(BgL_mainz00_13906, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11726)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13907;
BgL_objz00_13907 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13905, BgL_objz00_13907); BgL_objz00_13907; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3378z00_13908;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3379z00_13909;
BgL_arg3379z00_13909 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11724))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13910;
BgL_newz00_13910 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24063;
BgL_tmpz00_24063 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13910, BgL_tmpz00_24063, BgL_arg3379z00_13909); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24068;int BgL_tmpz00_24066;
BgL_auxz00_24068 = 
BINT(BgL_siza7ezd2framez75_11726); 
BgL_tmpz00_24066 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13910, BgL_tmpz00_24066, BgL_auxz00_24068); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24071;
BgL_tmpz00_24071 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13910, BgL_tmpz00_24071, BgL_runz00_13905); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24076;int BgL_tmpz00_24074;
BgL_auxz00_24076 = 
BINT(((long)3)); 
BgL_tmpz00_24074 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13910, BgL_tmpz00_24074, BgL_auxz00_24076); } 
BgL_arg3378z00_13908 = BgL_newz00_13910; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13906, BgL_arg3378z00_13908); BgL_arg3378z00_13908; } 
return BgL_mainz00_13906;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5118 */
obj_t BGl_z62main5118z62zz__evaluate_compz00(obj_t BgL_envz00_11728, obj_t BgL_bz00_11733, obj_t BgL_cz00_11734, obj_t BgL_dz00_11735)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11731;long BgL_siza7ezd2framez75_11732;
BgL_runz00_11731 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11728, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11732 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11728, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13911;
BgL_sz00_13911 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13912;
BgL_bpz00_13912 = 
VECTOR_REF(
((obj_t)BgL_sz00_13911),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13911, BgL_bpz00_13912, 
BINT(BgL_siza7ezd2framez75_11732)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3382z00_13913;
BgL_arg3382z00_13913 = 
(
(long)CINT(BgL_bpz00_13912)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13911),BgL_arg3382z00_13913,BgL_bz00_11733); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3383z00_13914;
BgL_arg3383z00_13914 = 
(
(long)CINT(BgL_bpz00_13912)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13911),BgL_arg3383z00_13914,BgL_cz00_11734); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3384z00_13915;
BgL_arg3384z00_13915 = 
(
(long)CINT(BgL_bpz00_13912)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13911),BgL_arg3384z00_13915,BgL_dz00_11735); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13916;
BgL_ez00_13916 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13916, BgL_bpz00_13912); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13917;
BgL_accz00_13917 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11731, BgL_sz00_13911, BgL_bpz00_13912); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13916); 
VECTOR_SET(
((obj_t)BgL_sz00_13911),((long)0),BgL_bpz00_13912); 
return BgL_accz00_13917;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13918;
BgL_nsz00_13918 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13918,((long)1),BgL_sz00_13911); 
VECTOR_SET(BgL_nsz00_13918,((long)2),BgL_bz00_11733); 
VECTOR_SET(BgL_nsz00_13918,((long)3),BgL_cz00_11734); 
VECTOR_SET(BgL_nsz00_13918,((long)4),BgL_dz00_11735); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13919;
BgL_z12denvz12_13919 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13919, BgL_nsz00_13918); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13920;
BgL_ez00_13920 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13920, BgL_sz00_13911); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13921;
BgL_____rz00_13921 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11731, BgL_nsz00_13918, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13920); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13919, BgL_sz00_13911); 
return BgL_____rz00_13921;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5119 */
obj_t BGl_z62run5119z62zz__evaluate_compz00(obj_t BgL_envz00_11736, obj_t BgL_sz00_11739)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11737;obj_t BgL_bodyz00_11738;
BgL_i1243z00_11737 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11736, 
(int)(((long)0)))); 
BgL_bodyz00_11738 = 
PROCEDURE_REF(BgL_envz00_11736, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13922;
BgL_bpz00_13922 = 
VECTOR_REF(
((obj_t)BgL_sz00_11739),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13923;obj_t BgL_wherez00_13924;obj_t BgL_locz00_13925;
BgL_z12denvz12_13923 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13924 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11737))->BgL_wherez00); 
BgL_locz00_13925 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11737))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13923, BgL_wherez00_13924, BgL_locz00_13925); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13926;
BgL_za2za2resza2za2z00_13926 = 
PROCEDURE_ENTRY(BgL_bodyz00_11738)(BgL_bodyz00_11738, BgL_sz00_11739, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13923); 
return BgL_za2za2resza2za2z00_13926;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3386> */
obj_t BGl_z62zc3anonymousza33386ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11740, obj_t BgL_sz00_11745)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11741;BgL_ev_absz00_bglt BgL_i1243z00_11742;obj_t BgL_bodyz00_11743;long BgL_siza7ezd2framez75_11744;
BgL_iboxesz00_11741 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11740, 
(int)(((long)0)))); 
BgL_i1243z00_11742 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11740, 
(int)(((long)1)))); 
BgL_bodyz00_11743 = 
PROCEDURE_REF(BgL_envz00_11740, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11744 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11740, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13927;
BgL_bpz00_13927 = 
VECTOR_REF(
((obj_t)BgL_sz00_11745),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13928;
BgL_runz00_13928 = 
MAKE_FX_PROCEDURE(BGl_z62run5121z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13928, 
(int)(((long)0)), BgL_iboxesz00_11741); 
PROCEDURE_SET(BgL_runz00_13928, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11742)); 
PROCEDURE_SET(BgL_runz00_13928, 
(int)(((long)2)), BgL_bodyz00_11743); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13929;
BgL_mainz00_13929 = 
MAKE_FX_PROCEDURE(BGl_z62main5120z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13929, 
(int)(((long)0)), BgL_iboxesz00_11741); 
PROCEDURE_SET(BgL_mainz00_13929, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11742)); 
PROCEDURE_SET(BgL_mainz00_13929, 
(int)(((long)2)), BgL_bodyz00_11743); 
PROCEDURE_SET(BgL_mainz00_13929, 
(int)(((long)3)), BgL_runz00_13928); 
PROCEDURE_SET(BgL_mainz00_13929, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11744)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13930;
BgL_objz00_13930 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13928, BgL_objz00_13930); BgL_objz00_13930; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3387z00_13931;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3388z00_13932;
BgL_arg3388z00_13932 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11742))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13933;
BgL_newz00_13933 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24181;
BgL_tmpz00_24181 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13933, BgL_tmpz00_24181, BgL_arg3388z00_13932); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24186;int BgL_tmpz00_24184;
BgL_auxz00_24186 = 
BINT(BgL_siza7ezd2framez75_11744); 
BgL_tmpz00_24184 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13933, BgL_tmpz00_24184, BgL_auxz00_24186); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24189;
BgL_tmpz00_24189 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13933, BgL_tmpz00_24189, BgL_runz00_13928); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24194;int BgL_tmpz00_24192;
BgL_auxz00_24194 = 
BINT(((long)3)); 
BgL_tmpz00_24192 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13933, BgL_tmpz00_24192, BgL_auxz00_24194); } 
BgL_arg3387z00_13931 = BgL_newz00_13933; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13929, BgL_arg3387z00_13931); BgL_arg3387z00_13931; } 
return BgL_mainz00_13929;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5120 */
obj_t BGl_z62main5120z62zz__evaluate_compz00(obj_t BgL_envz00_11746, obj_t BgL_bz00_11752, obj_t BgL_cz00_11753, obj_t BgL_dz00_11754)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11750;long BgL_siza7ezd2framez75_11751;
BgL_runz00_11750 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11746, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11751 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11746, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13934;
BgL_sz00_13934 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13935;
BgL_bpz00_13935 = 
VECTOR_REF(
((obj_t)BgL_sz00_13934),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13934, BgL_bpz00_13935, 
BINT(BgL_siza7ezd2framez75_11751)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3391z00_13936;
BgL_arg3391z00_13936 = 
(
(long)CINT(BgL_bpz00_13935)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13934),BgL_arg3391z00_13936,BgL_bz00_11752); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3392z00_13937;
BgL_arg3392z00_13937 = 
(
(long)CINT(BgL_bpz00_13935)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13934),BgL_arg3392z00_13937,BgL_cz00_11753); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3393z00_13938;
BgL_arg3393z00_13938 = 
(
(long)CINT(BgL_bpz00_13935)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13934),BgL_arg3393z00_13938,BgL_dz00_11754); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13939;
BgL_ez00_13939 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13939, BgL_bpz00_13935); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13940;
BgL_accz00_13940 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11750, BgL_sz00_13934, BgL_bpz00_13935); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13939); 
VECTOR_SET(
((obj_t)BgL_sz00_13934),((long)0),BgL_bpz00_13935); 
return BgL_accz00_13940;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13941;
BgL_nsz00_13941 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13941,((long)1),BgL_sz00_13934); 
VECTOR_SET(BgL_nsz00_13941,((long)2),BgL_bz00_11752); 
VECTOR_SET(BgL_nsz00_13941,((long)3),BgL_cz00_11753); 
VECTOR_SET(BgL_nsz00_13941,((long)4),BgL_dz00_11754); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13942;
BgL_z12denvz12_13942 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13942, BgL_nsz00_13941); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13943;
BgL_ez00_13943 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13943, BgL_sz00_13934); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13944;
BgL_____rz00_13944 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11750, BgL_nsz00_13941, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13943); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13942, BgL_sz00_13934); 
return BgL_____rz00_13944;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5121 */
obj_t BGl_z62run5121z62zz__evaluate_compz00(obj_t BgL_envz00_11755, obj_t BgL_sz00_11759)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11756;BgL_ev_absz00_bglt BgL_i1243z00_11757;obj_t BgL_bodyz00_11758;
BgL_iboxesz00_11756 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11755, 
(int)(((long)0)))); 
BgL_i1243z00_11757 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11755, 
(int)(((long)1)))); 
BgL_bodyz00_11758 = 
PROCEDURE_REF(BgL_envz00_11755, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13945;
BgL_bpz00_13945 = 
VECTOR_REF(
((obj_t)BgL_sz00_11759),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11759, BgL_iboxesz00_11756, BgL_bpz00_13945); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13946;obj_t BgL_wherez00_13947;obj_t BgL_locz00_13948;
BgL_z12denvz12_13946 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13947 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11757))->BgL_wherez00); 
BgL_locz00_13948 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11757))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13946, BgL_wherez00_13947, BgL_locz00_13948); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_13949;
BgL_za2za2resza2za2z00_13949 = 
PROCEDURE_ENTRY(BgL_bodyz00_11758)(BgL_bodyz00_11758, BgL_sz00_11759, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13946); 
return BgL_za2za2resza2za2z00_13949;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3398> */
obj_t BGl_z62zc3anonymousza33398ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11760, obj_t BgL_sz00_11766)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11761;long BgL_siza7eza7_11762;BgL_ev_absz00_bglt BgL_i1243z00_11763;obj_t BgL_bodyz00_11764;long BgL_siza7ezd2framez75_11765;
BgL_ifreesz00_11761 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11760, 
(int)(((long)0)))); 
BgL_siza7eza7_11762 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11760, 
(int)(((long)1)))); 
BgL_i1243z00_11763 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11760, 
(int)(((long)2)))); 
BgL_bodyz00_11764 = 
PROCEDURE_REF(BgL_envz00_11760, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11765 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11760, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13950;
BgL_bpz00_13950 = 
VECTOR_REF(
((obj_t)BgL_sz00_11766),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13951;
BgL_valza2za2_13951 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11766, BgL_bpz00_13950, BgL_ifreesz00_11761); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13952;
BgL_runz00_13952 = 
MAKE_FX_PROCEDURE(BGl_z62run5123z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13952, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11762)); 
PROCEDURE_SET(BgL_runz00_13952, 
(int)(((long)1)), BgL_valza2za2_13951); 
PROCEDURE_SET(BgL_runz00_13952, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11763)); 
PROCEDURE_SET(BgL_runz00_13952, 
(int)(((long)3)), BgL_bodyz00_11764); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13953;
BgL_mainz00_13953 = 
MAKE_FX_PROCEDURE(BGl_z62main5122z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13953, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11762)); 
PROCEDURE_SET(BgL_mainz00_13953, 
(int)(((long)1)), BgL_valza2za2_13951); 
PROCEDURE_SET(BgL_mainz00_13953, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11763)); 
PROCEDURE_SET(BgL_mainz00_13953, 
(int)(((long)3)), BgL_bodyz00_11764); 
PROCEDURE_SET(BgL_mainz00_13953, 
(int)(((long)4)), BgL_runz00_13952); 
PROCEDURE_SET(BgL_mainz00_13953, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11765)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13954;
BgL_objz00_13954 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13952, BgL_objz00_13954); BgL_objz00_13954; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3399z00_13955;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3400z00_13956;
BgL_arg3400z00_13956 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11763))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13957;
BgL_newz00_13957 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24313;
BgL_tmpz00_24313 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13957, BgL_tmpz00_24313, BgL_arg3400z00_13956); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24318;int BgL_tmpz00_24316;
BgL_auxz00_24318 = 
BINT(BgL_siza7ezd2framez75_11765); 
BgL_tmpz00_24316 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13957, BgL_tmpz00_24316, BgL_auxz00_24318); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24321;
BgL_tmpz00_24321 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13957, BgL_tmpz00_24321, BgL_runz00_13952); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24326;int BgL_tmpz00_24324;
BgL_auxz00_24326 = 
BINT(((long)3)); 
BgL_tmpz00_24324 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13957, BgL_tmpz00_24324, BgL_auxz00_24326); } 
BgL_arg3399z00_13955 = BgL_newz00_13957; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13953, BgL_arg3399z00_13955); BgL_arg3399z00_13955; } 
return BgL_mainz00_13953;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5122 */
obj_t BGl_z62main5122z62zz__evaluate_compz00(obj_t BgL_envz00_11767, obj_t BgL_bz00_11774, obj_t BgL_cz00_11775, obj_t BgL_dz00_11776)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11772;long BgL_siza7ezd2framez75_11773;
BgL_runz00_11772 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11767, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11773 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11767, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13958;
BgL_sz00_13958 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13959;
BgL_bpz00_13959 = 
VECTOR_REF(
((obj_t)BgL_sz00_13958),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13958, BgL_bpz00_13959, 
BINT(BgL_siza7ezd2framez75_11773)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3403z00_13960;
BgL_arg3403z00_13960 = 
(
(long)CINT(BgL_bpz00_13959)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13958),BgL_arg3403z00_13960,BgL_bz00_11774); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3404z00_13961;
BgL_arg3404z00_13961 = 
(
(long)CINT(BgL_bpz00_13959)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13958),BgL_arg3404z00_13961,BgL_cz00_11775); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3405z00_13962;
BgL_arg3405z00_13962 = 
(
(long)CINT(BgL_bpz00_13959)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13958),BgL_arg3405z00_13962,BgL_dz00_11776); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13963;
BgL_ez00_13963 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13963, BgL_bpz00_13959); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13964;
BgL_accz00_13964 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11772, BgL_sz00_13958, BgL_bpz00_13959); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13963); 
VECTOR_SET(
((obj_t)BgL_sz00_13958),((long)0),BgL_bpz00_13959); 
return BgL_accz00_13964;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13965;
BgL_nsz00_13965 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13965,((long)1),BgL_sz00_13958); 
VECTOR_SET(BgL_nsz00_13965,((long)2),BgL_bz00_11774); 
VECTOR_SET(BgL_nsz00_13965,((long)3),BgL_cz00_11775); 
VECTOR_SET(BgL_nsz00_13965,((long)4),BgL_dz00_11776); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13966;
BgL_z12denvz12_13966 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13966, BgL_nsz00_13965); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13967;
BgL_ez00_13967 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13967, BgL_sz00_13958); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13968;
BgL_____rz00_13968 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11772, BgL_nsz00_13965, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13967); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13966, BgL_sz00_13958); 
return BgL_____rz00_13968;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5123 */
obj_t BGl_z62run5123z62zz__evaluate_compz00(obj_t BgL_envz00_11777, obj_t BgL_sz00_11782)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_11778;obj_t BgL_valza2za2_11779;BgL_ev_absz00_bglt BgL_i1243z00_11780;obj_t BgL_bodyz00_11781;
BgL_siza7eza7_11778 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11777, 
(int)(((long)0)))); 
BgL_valza2za2_11779 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11777, 
(int)(((long)1)))); 
BgL_i1243z00_11780 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11777, 
(int)(((long)2)))); 
BgL_bodyz00_11781 = 
PROCEDURE_REF(BgL_envz00_11777, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13969;
BgL_bpz00_13969 = 
VECTOR_REF(
((obj_t)BgL_sz00_11782),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11782, BgL_valza2za2_11779, 
(
(long)CINT(BgL_bpz00_13969)+BgL_siza7eza7_11778)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13970;obj_t BgL_wherez00_13971;obj_t BgL_locz00_13972;
BgL_z12denvz12_13970 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13971 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11780))->BgL_wherez00); 
BgL_locz00_13972 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11780))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13970, BgL_wherez00_13971, BgL_locz00_13972); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13973;
BgL_za2za2resza2za2z00_13973 = 
PROCEDURE_ENTRY(BgL_bodyz00_11781)(BgL_bodyz00_11781, BgL_sz00_11782, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13970); 
return BgL_za2za2resza2za2z00_13973;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3408> */
obj_t BGl_z62zc3anonymousza33408ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11783, obj_t BgL_sz00_11790)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11784;obj_t BgL_iboxesz00_11785;long BgL_siza7eza7_11786;BgL_ev_absz00_bglt BgL_i1243z00_11787;obj_t BgL_bodyz00_11788;long BgL_siza7ezd2framez75_11789;
BgL_ifreesz00_11784 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)0)))); 
BgL_iboxesz00_11785 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)1)))); 
BgL_siza7eza7_11786 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)2)))); 
BgL_i1243z00_11787 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)3)))); 
BgL_bodyz00_11788 = 
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11789 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11783, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13974;
BgL_bpz00_13974 = 
VECTOR_REF(
((obj_t)BgL_sz00_11790),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_13975;
BgL_valza2za2_13975 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11790, BgL_bpz00_13974, BgL_ifreesz00_11784); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13976;
BgL_runz00_13976 = 
MAKE_FX_PROCEDURE(BGl_z62run5125z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13976, 
(int)(((long)0)), BgL_iboxesz00_11785); 
PROCEDURE_SET(BgL_runz00_13976, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11786)); 
PROCEDURE_SET(BgL_runz00_13976, 
(int)(((long)2)), BgL_valza2za2_13975); 
PROCEDURE_SET(BgL_runz00_13976, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11787)); 
PROCEDURE_SET(BgL_runz00_13976, 
(int)(((long)4)), BgL_bodyz00_11788); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_13977;
BgL_mainz00_13977 = 
MAKE_FX_PROCEDURE(BGl_z62main5124z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)0)), BgL_iboxesz00_11785); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11786)); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)2)), BgL_valza2za2_13975); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11787)); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)4)), BgL_bodyz00_11788); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)5)), BgL_runz00_13976); 
PROCEDURE_SET(BgL_mainz00_13977, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11789)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_13978;
BgL_objz00_13978 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13976, BgL_objz00_13978); BgL_objz00_13978; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3409z00_13979;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3410z00_13980;
BgL_arg3410z00_13980 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11787))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_13981;
BgL_newz00_13981 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24457;
BgL_tmpz00_24457 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13981, BgL_tmpz00_24457, BgL_arg3410z00_13980); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24462;int BgL_tmpz00_24460;
BgL_auxz00_24462 = 
BINT(BgL_siza7ezd2framez75_11789); 
BgL_tmpz00_24460 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13981, BgL_tmpz00_24460, BgL_auxz00_24462); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24465;
BgL_tmpz00_24465 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13981, BgL_tmpz00_24465, BgL_runz00_13976); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24470;int BgL_tmpz00_24468;
BgL_auxz00_24470 = 
BINT(((long)3)); 
BgL_tmpz00_24468 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13981, BgL_tmpz00_24468, BgL_auxz00_24470); } 
BgL_arg3409z00_13979 = BgL_newz00_13981; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13977, BgL_arg3409z00_13979); BgL_arg3409z00_13979; } 
return BgL_mainz00_13977;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5124 */
obj_t BGl_z62main5124z62zz__evaluate_compz00(obj_t BgL_envz00_11791, obj_t BgL_bz00_11799, obj_t BgL_cz00_11800, obj_t BgL_dz00_11801)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11797;long BgL_siza7ezd2framez75_11798;
BgL_runz00_11797 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11791, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11798 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11791, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_13982;
BgL_sz00_13982 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13983;
BgL_bpz00_13983 = 
VECTOR_REF(
((obj_t)BgL_sz00_13982),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13982, BgL_bpz00_13983, 
BINT(BgL_siza7ezd2framez75_11798)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3413z00_13984;
BgL_arg3413z00_13984 = 
(
(long)CINT(BgL_bpz00_13983)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13982),BgL_arg3413z00_13984,BgL_bz00_11799); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3414z00_13985;
BgL_arg3414z00_13985 = 
(
(long)CINT(BgL_bpz00_13983)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13982),BgL_arg3414z00_13985,BgL_cz00_11800); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3415z00_13986;
BgL_arg3415z00_13986 = 
(
(long)CINT(BgL_bpz00_13983)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13982),BgL_arg3415z00_13986,BgL_dz00_11801); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13987;
BgL_ez00_13987 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13987, BgL_bpz00_13983); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_13988;
BgL_accz00_13988 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11797, BgL_sz00_13982, BgL_bpz00_13983); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13987); 
VECTOR_SET(
((obj_t)BgL_sz00_13982),((long)0),BgL_bpz00_13983); 
return BgL_accz00_13988;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_13989;
BgL_nsz00_13989 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13989,((long)1),BgL_sz00_13982); 
VECTOR_SET(BgL_nsz00_13989,((long)2),BgL_bz00_11799); 
VECTOR_SET(BgL_nsz00_13989,((long)3),BgL_cz00_11800); 
VECTOR_SET(BgL_nsz00_13989,((long)4),BgL_dz00_11801); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_13990;
BgL_z12denvz12_13990 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13990, BgL_nsz00_13989); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_13991;
BgL_ez00_13991 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13991, BgL_sz00_13982); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_13992;
BgL_____rz00_13992 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11797, BgL_nsz00_13989, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13991); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13990, BgL_sz00_13982); 
return BgL_____rz00_13992;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5125 */
obj_t BGl_z62run5125z62zz__evaluate_compz00(obj_t BgL_envz00_11802, obj_t BgL_sz00_11808)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11803;long BgL_siza7eza7_11804;obj_t BgL_valza2za2_11805;BgL_ev_absz00_bglt BgL_i1243z00_11806;obj_t BgL_bodyz00_11807;
BgL_iboxesz00_11803 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11802, 
(int)(((long)0)))); 
BgL_siza7eza7_11804 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11802, 
(int)(((long)1)))); 
BgL_valza2za2_11805 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11802, 
(int)(((long)2)))); 
BgL_i1243z00_11806 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11802, 
(int)(((long)3)))); 
BgL_bodyz00_11807 = 
PROCEDURE_REF(BgL_envz00_11802, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13993;
BgL_bpz00_13993 = 
VECTOR_REF(
((obj_t)BgL_sz00_11808),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11808, BgL_iboxesz00_11803, BgL_bpz00_13993); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11808, BgL_valza2za2_11805, 
(
(long)CINT(BgL_bpz00_13993)+BgL_siza7eza7_11804)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_13994;obj_t BgL_wherez00_13995;obj_t BgL_locz00_13996;
BgL_z12denvz12_13994 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13995 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11806))->BgL_wherez00); 
BgL_locz00_13996 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11806))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13994, BgL_wherez00_13995, BgL_locz00_13996); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_13997;
BgL_za2za2resza2za2z00_13997 = 
PROCEDURE_ENTRY(BgL_bodyz00_11807)(BgL_bodyz00_11807, BgL_sz00_11808, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13994); 
return BgL_za2za2resza2za2z00_13997;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3330> */
obj_t BGl_z62zc3anonymousza33330ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11809, obj_t BgL_sz00_11813)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11810;obj_t BgL_bodyz00_11811;long BgL_siza7ezd2framez75_11812;
BgL_i1243z00_11810 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11809, 
(int)(((long)0)))); 
BgL_bodyz00_11811 = 
PROCEDURE_REF(BgL_envz00_11809, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11812 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11809, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_13998;
BgL_bpz00_13998 = 
VECTOR_REF(
((obj_t)BgL_sz00_11813),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_13999;
BgL_runz00_13999 = 
MAKE_FX_PROCEDURE(BGl_z62run5127z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13999, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11810)); 
PROCEDURE_SET(BgL_runz00_13999, 
(int)(((long)1)), BgL_bodyz00_11811); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14000;
BgL_mainz00_14000 = 
MAKE_VA_PROCEDURE(BGl_z62main5126z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14000, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11810)); 
PROCEDURE_SET(BgL_mainz00_14000, 
(int)(((long)1)), BgL_bodyz00_11811); 
PROCEDURE_SET(BgL_mainz00_14000, 
(int)(((long)2)), BgL_runz00_13999); 
PROCEDURE_SET(BgL_mainz00_14000, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11812)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14001;
BgL_objz00_14001 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13999, BgL_objz00_14001); BgL_objz00_14001; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3331z00_14002;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3332z00_14003;
BgL_arg3332z00_14003 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11810))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14004;
BgL_newz00_14004 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24581;
BgL_tmpz00_24581 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14004, BgL_tmpz00_24581, BgL_arg3332z00_14003); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24586;int BgL_tmpz00_24584;
BgL_auxz00_24586 = 
BINT(BgL_siza7ezd2framez75_11812); 
BgL_tmpz00_24584 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14004, BgL_tmpz00_24584, BgL_auxz00_24586); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24589;
BgL_tmpz00_24589 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14004, BgL_tmpz00_24589, BgL_runz00_13999); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24594;int BgL_tmpz00_24592;
BgL_auxz00_24594 = 
BINT(((long)-3)); 
BgL_tmpz00_24592 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14004, BgL_tmpz00_24592, BgL_auxz00_24594); } 
BgL_arg3331z00_14002 = BgL_newz00_14004; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14000, BgL_arg3331z00_14002); BgL_arg3331z00_14002; } 
return BgL_mainz00_14000;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5126 */
obj_t BGl_z62main5126z62zz__evaluate_compz00(obj_t BgL_envz00_11814, obj_t BgL_cz00_11819, obj_t BgL_dz00_11820, obj_t BgL_lastz00_11821)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11817;long BgL_siza7ezd2framez75_11818;
BgL_runz00_11817 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11814, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11818 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11814, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14005;
BgL_sz00_14005 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14006;
BgL_bpz00_14006 = 
VECTOR_REF(
((obj_t)BgL_sz00_14005),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14005, BgL_bpz00_14006, 
BINT(BgL_siza7ezd2framez75_11818)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3335z00_14007;
BgL_arg3335z00_14007 = 
(
(long)CINT(BgL_bpz00_14006)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14005),BgL_arg3335z00_14007,BgL_cz00_11819); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3336z00_14008;
BgL_arg3336z00_14008 = 
(
(long)CINT(BgL_bpz00_14006)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14005),BgL_arg3336z00_14008,BgL_dz00_11820); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3337z00_14009;
BgL_arg3337z00_14009 = 
(
(long)CINT(BgL_bpz00_14006)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14005),BgL_arg3337z00_14009,BgL_lastz00_11821); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14010;
BgL_ez00_14010 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14010, BgL_bpz00_14006); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14011;
BgL_accz00_14011 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11817, BgL_sz00_14005, BgL_bpz00_14006); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14010); 
VECTOR_SET(
((obj_t)BgL_sz00_14005),((long)0),BgL_bpz00_14006); 
return BgL_accz00_14011;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14012;
BgL_nsz00_14012 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14012,((long)1),BgL_sz00_14005); 
VECTOR_SET(BgL_nsz00_14012,((long)2),BgL_cz00_11819); 
VECTOR_SET(BgL_nsz00_14012,((long)3),BgL_dz00_11820); 
VECTOR_SET(BgL_nsz00_14012,((long)4),BgL_lastz00_11821); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14013;
BgL_z12denvz12_14013 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14013, BgL_nsz00_14012); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14014;
BgL_ez00_14014 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14014, BgL_sz00_14005); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14015;
BgL_____rz00_14015 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11817, BgL_nsz00_14012, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14014); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14013, BgL_sz00_14005); 
return BgL_____rz00_14015;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5127 */
obj_t BGl_z62run5127z62zz__evaluate_compz00(obj_t BgL_envz00_11822, obj_t BgL_sz00_11825)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11823;obj_t BgL_bodyz00_11824;
BgL_i1243z00_11823 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11822, 
(int)(((long)0)))); 
BgL_bodyz00_11824 = 
PROCEDURE_REF(BgL_envz00_11822, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14016;
BgL_bpz00_14016 = 
VECTOR_REF(
((obj_t)BgL_sz00_11825),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14017;obj_t BgL_wherez00_14018;obj_t BgL_locz00_14019;
BgL_z12denvz12_14017 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14018 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11823))->BgL_wherez00); 
BgL_locz00_14019 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11823))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14017, BgL_wherez00_14018, BgL_locz00_14019); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14020;
BgL_za2za2resza2za2z00_14020 = 
PROCEDURE_ENTRY(BgL_bodyz00_11824)(BgL_bodyz00_11824, BgL_sz00_11825, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14017); 
return BgL_za2za2resza2za2z00_14020;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3339> */
obj_t BGl_z62zc3anonymousza33339ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11826, obj_t BgL_sz00_11831)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11827;BgL_ev_absz00_bglt BgL_i1243z00_11828;obj_t BgL_bodyz00_11829;long BgL_siza7ezd2framez75_11830;
BgL_iboxesz00_11827 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11826, 
(int)(((long)0)))); 
BgL_i1243z00_11828 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11826, 
(int)(((long)1)))); 
BgL_bodyz00_11829 = 
PROCEDURE_REF(BgL_envz00_11826, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11830 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11826, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14021;
BgL_bpz00_14021 = 
VECTOR_REF(
((obj_t)BgL_sz00_11831),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14022;
BgL_runz00_14022 = 
MAKE_FX_PROCEDURE(BGl_z62run5129z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14022, 
(int)(((long)0)), BgL_iboxesz00_11827); 
PROCEDURE_SET(BgL_runz00_14022, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11828)); 
PROCEDURE_SET(BgL_runz00_14022, 
(int)(((long)2)), BgL_bodyz00_11829); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14023;
BgL_mainz00_14023 = 
MAKE_VA_PROCEDURE(BGl_z62main5128z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14023, 
(int)(((long)0)), BgL_iboxesz00_11827); 
PROCEDURE_SET(BgL_mainz00_14023, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11828)); 
PROCEDURE_SET(BgL_mainz00_14023, 
(int)(((long)2)), BgL_bodyz00_11829); 
PROCEDURE_SET(BgL_mainz00_14023, 
(int)(((long)3)), BgL_runz00_14022); 
PROCEDURE_SET(BgL_mainz00_14023, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11830)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14024;
BgL_objz00_14024 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14022, BgL_objz00_14024); BgL_objz00_14024; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3340z00_14025;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3341z00_14026;
BgL_arg3341z00_14026 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11828))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14027;
BgL_newz00_14027 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24699;
BgL_tmpz00_24699 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14027, BgL_tmpz00_24699, BgL_arg3341z00_14026); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24704;int BgL_tmpz00_24702;
BgL_auxz00_24704 = 
BINT(BgL_siza7ezd2framez75_11830); 
BgL_tmpz00_24702 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14027, BgL_tmpz00_24702, BgL_auxz00_24704); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24707;
BgL_tmpz00_24707 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14027, BgL_tmpz00_24707, BgL_runz00_14022); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24712;int BgL_tmpz00_24710;
BgL_auxz00_24712 = 
BINT(((long)-3)); 
BgL_tmpz00_24710 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14027, BgL_tmpz00_24710, BgL_auxz00_24712); } 
BgL_arg3340z00_14025 = BgL_newz00_14027; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14023, BgL_arg3340z00_14025); BgL_arg3340z00_14025; } 
return BgL_mainz00_14023;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5128 */
obj_t BGl_z62main5128z62zz__evaluate_compz00(obj_t BgL_envz00_11832, obj_t BgL_cz00_11838, obj_t BgL_dz00_11839, obj_t BgL_lastz00_11840)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11836;long BgL_siza7ezd2framez75_11837;
BgL_runz00_11836 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11832, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11837 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11832, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14028;
BgL_sz00_14028 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14029;
BgL_bpz00_14029 = 
VECTOR_REF(
((obj_t)BgL_sz00_14028),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14028, BgL_bpz00_14029, 
BINT(BgL_siza7ezd2framez75_11837)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3344z00_14030;
BgL_arg3344z00_14030 = 
(
(long)CINT(BgL_bpz00_14029)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14028),BgL_arg3344z00_14030,BgL_cz00_11838); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3345z00_14031;
BgL_arg3345z00_14031 = 
(
(long)CINT(BgL_bpz00_14029)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14028),BgL_arg3345z00_14031,BgL_dz00_11839); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3346z00_14032;
BgL_arg3346z00_14032 = 
(
(long)CINT(BgL_bpz00_14029)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14028),BgL_arg3346z00_14032,BgL_lastz00_11840); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14033;
BgL_ez00_14033 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14033, BgL_bpz00_14029); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14034;
BgL_accz00_14034 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11836, BgL_sz00_14028, BgL_bpz00_14029); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14033); 
VECTOR_SET(
((obj_t)BgL_sz00_14028),((long)0),BgL_bpz00_14029); 
return BgL_accz00_14034;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14035;
BgL_nsz00_14035 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14035,((long)1),BgL_sz00_14028); 
VECTOR_SET(BgL_nsz00_14035,((long)2),BgL_cz00_11838); 
VECTOR_SET(BgL_nsz00_14035,((long)3),BgL_dz00_11839); 
VECTOR_SET(BgL_nsz00_14035,((long)4),BgL_lastz00_11840); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14036;
BgL_z12denvz12_14036 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14036, BgL_nsz00_14035); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14037;
BgL_ez00_14037 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14037, BgL_sz00_14028); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14038;
BgL_____rz00_14038 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11836, BgL_nsz00_14035, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14037); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14036, BgL_sz00_14028); 
return BgL_____rz00_14038;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5129 */
obj_t BGl_z62run5129z62zz__evaluate_compz00(obj_t BgL_envz00_11841, obj_t BgL_sz00_11845)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11842;BgL_ev_absz00_bglt BgL_i1243z00_11843;obj_t BgL_bodyz00_11844;
BgL_iboxesz00_11842 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11841, 
(int)(((long)0)))); 
BgL_i1243z00_11843 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11841, 
(int)(((long)1)))); 
BgL_bodyz00_11844 = 
PROCEDURE_REF(BgL_envz00_11841, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14039;
BgL_bpz00_14039 = 
VECTOR_REF(
((obj_t)BgL_sz00_11845),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11845, BgL_iboxesz00_11842, BgL_bpz00_14039); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14040;obj_t BgL_wherez00_14041;obj_t BgL_locz00_14042;
BgL_z12denvz12_14040 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14041 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11843))->BgL_wherez00); 
BgL_locz00_14042 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11843))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14040, BgL_wherez00_14041, BgL_locz00_14042); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14043;
BgL_za2za2resza2za2z00_14043 = 
PROCEDURE_ENTRY(BgL_bodyz00_11844)(BgL_bodyz00_11844, BgL_sz00_11845, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14040); 
return BgL_za2za2resza2za2z00_14043;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3351> */
obj_t BGl_z62zc3anonymousza33351ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11846, obj_t BgL_sz00_11852)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11847;long BgL_siza7eza7_11848;BgL_ev_absz00_bglt BgL_i1243z00_11849;obj_t BgL_bodyz00_11850;long BgL_siza7ezd2framez75_11851;
BgL_ifreesz00_11847 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11846, 
(int)(((long)0)))); 
BgL_siza7eza7_11848 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11846, 
(int)(((long)1)))); 
BgL_i1243z00_11849 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11846, 
(int)(((long)2)))); 
BgL_bodyz00_11850 = 
PROCEDURE_REF(BgL_envz00_11846, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11851 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11846, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14044;
BgL_bpz00_14044 = 
VECTOR_REF(
((obj_t)BgL_sz00_11852),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14045;
BgL_valza2za2_14045 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11852, BgL_bpz00_14044, BgL_ifreesz00_11847); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14046;
BgL_runz00_14046 = 
MAKE_FX_PROCEDURE(BGl_z62run5131z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14046, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11848)); 
PROCEDURE_SET(BgL_runz00_14046, 
(int)(((long)1)), BgL_valza2za2_14045); 
PROCEDURE_SET(BgL_runz00_14046, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11849)); 
PROCEDURE_SET(BgL_runz00_14046, 
(int)(((long)3)), BgL_bodyz00_11850); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14047;
BgL_mainz00_14047 = 
MAKE_VA_PROCEDURE(BGl_z62main5130z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14047, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11848)); 
PROCEDURE_SET(BgL_mainz00_14047, 
(int)(((long)1)), BgL_valza2za2_14045); 
PROCEDURE_SET(BgL_mainz00_14047, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11849)); 
PROCEDURE_SET(BgL_mainz00_14047, 
(int)(((long)3)), BgL_bodyz00_11850); 
PROCEDURE_SET(BgL_mainz00_14047, 
(int)(((long)4)), BgL_runz00_14046); 
PROCEDURE_SET(BgL_mainz00_14047, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11851)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14048;
BgL_objz00_14048 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14046, BgL_objz00_14048); BgL_objz00_14048; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3352z00_14049;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3353z00_14050;
BgL_arg3353z00_14050 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11849))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14051;
BgL_newz00_14051 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24831;
BgL_tmpz00_24831 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14051, BgL_tmpz00_24831, BgL_arg3353z00_14050); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24836;int BgL_tmpz00_24834;
BgL_auxz00_24836 = 
BINT(BgL_siza7ezd2framez75_11851); 
BgL_tmpz00_24834 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14051, BgL_tmpz00_24834, BgL_auxz00_24836); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24839;
BgL_tmpz00_24839 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14051, BgL_tmpz00_24839, BgL_runz00_14046); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24844;int BgL_tmpz00_24842;
BgL_auxz00_24844 = 
BINT(((long)-3)); 
BgL_tmpz00_24842 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14051, BgL_tmpz00_24842, BgL_auxz00_24844); } 
BgL_arg3352z00_14049 = BgL_newz00_14051; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14047, BgL_arg3352z00_14049); BgL_arg3352z00_14049; } 
return BgL_mainz00_14047;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5130 */
obj_t BGl_z62main5130z62zz__evaluate_compz00(obj_t BgL_envz00_11853, obj_t BgL_cz00_11860, obj_t BgL_dz00_11861, obj_t BgL_lastz00_11862)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11858;long BgL_siza7ezd2framez75_11859;
BgL_runz00_11858 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11853, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11859 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11853, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14052;
BgL_sz00_14052 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14053;
BgL_bpz00_14053 = 
VECTOR_REF(
((obj_t)BgL_sz00_14052),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14052, BgL_bpz00_14053, 
BINT(BgL_siza7ezd2framez75_11859)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3356z00_14054;
BgL_arg3356z00_14054 = 
(
(long)CINT(BgL_bpz00_14053)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14052),BgL_arg3356z00_14054,BgL_cz00_11860); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3357z00_14055;
BgL_arg3357z00_14055 = 
(
(long)CINT(BgL_bpz00_14053)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14052),BgL_arg3357z00_14055,BgL_dz00_11861); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3358z00_14056;
BgL_arg3358z00_14056 = 
(
(long)CINT(BgL_bpz00_14053)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14052),BgL_arg3358z00_14056,BgL_lastz00_11862); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14057;
BgL_ez00_14057 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14057, BgL_bpz00_14053); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14058;
BgL_accz00_14058 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11858, BgL_sz00_14052, BgL_bpz00_14053); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14057); 
VECTOR_SET(
((obj_t)BgL_sz00_14052),((long)0),BgL_bpz00_14053); 
return BgL_accz00_14058;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14059;
BgL_nsz00_14059 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14059,((long)1),BgL_sz00_14052); 
VECTOR_SET(BgL_nsz00_14059,((long)2),BgL_cz00_11860); 
VECTOR_SET(BgL_nsz00_14059,((long)3),BgL_dz00_11861); 
VECTOR_SET(BgL_nsz00_14059,((long)4),BgL_lastz00_11862); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14060;
BgL_z12denvz12_14060 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14060, BgL_nsz00_14059); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14061;
BgL_ez00_14061 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14061, BgL_sz00_14052); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14062;
BgL_____rz00_14062 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11858, BgL_nsz00_14059, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14061); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14060, BgL_sz00_14052); 
return BgL_____rz00_14062;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5131 */
obj_t BGl_z62run5131z62zz__evaluate_compz00(obj_t BgL_envz00_11863, obj_t BgL_sz00_11868)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_11864;obj_t BgL_valza2za2_11865;BgL_ev_absz00_bglt BgL_i1243z00_11866;obj_t BgL_bodyz00_11867;
BgL_siza7eza7_11864 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11863, 
(int)(((long)0)))); 
BgL_valza2za2_11865 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11863, 
(int)(((long)1)))); 
BgL_i1243z00_11866 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11863, 
(int)(((long)2)))); 
BgL_bodyz00_11867 = 
PROCEDURE_REF(BgL_envz00_11863, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14063;
BgL_bpz00_14063 = 
VECTOR_REF(
((obj_t)BgL_sz00_11868),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11868, BgL_valza2za2_11865, 
(
(long)CINT(BgL_bpz00_14063)+BgL_siza7eza7_11864)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14064;obj_t BgL_wherez00_14065;obj_t BgL_locz00_14066;
BgL_z12denvz12_14064 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14065 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11866))->BgL_wherez00); 
BgL_locz00_14066 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11866))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14064, BgL_wherez00_14065, BgL_locz00_14066); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14067;
BgL_za2za2resza2za2z00_14067 = 
PROCEDURE_ENTRY(BgL_bodyz00_11867)(BgL_bodyz00_11867, BgL_sz00_11868, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14064); 
return BgL_za2za2resza2za2z00_14067;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3361> */
obj_t BGl_z62zc3anonymousza33361ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11869, obj_t BgL_sz00_11876)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11870;obj_t BgL_iboxesz00_11871;long BgL_siza7eza7_11872;BgL_ev_absz00_bglt BgL_i1243z00_11873;obj_t BgL_bodyz00_11874;long BgL_siza7ezd2framez75_11875;
BgL_ifreesz00_11870 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)0)))); 
BgL_iboxesz00_11871 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)1)))); 
BgL_siza7eza7_11872 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)2)))); 
BgL_i1243z00_11873 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)3)))); 
BgL_bodyz00_11874 = 
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11875 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11869, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14068;
BgL_bpz00_14068 = 
VECTOR_REF(
((obj_t)BgL_sz00_11876),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14069;
BgL_valza2za2_14069 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11876, BgL_bpz00_14068, BgL_ifreesz00_11870); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14070;
BgL_runz00_14070 = 
MAKE_FX_PROCEDURE(BGl_z62run5133z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14070, 
(int)(((long)0)), BgL_iboxesz00_11871); 
PROCEDURE_SET(BgL_runz00_14070, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11872)); 
PROCEDURE_SET(BgL_runz00_14070, 
(int)(((long)2)), BgL_valza2za2_14069); 
PROCEDURE_SET(BgL_runz00_14070, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11873)); 
PROCEDURE_SET(BgL_runz00_14070, 
(int)(((long)4)), BgL_bodyz00_11874); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14071;
BgL_mainz00_14071 = 
MAKE_VA_PROCEDURE(BGl_z62main5132z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)0)), BgL_iboxesz00_11871); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11872)); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)2)), BgL_valza2za2_14069); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11873)); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)4)), BgL_bodyz00_11874); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)5)), BgL_runz00_14070); 
PROCEDURE_SET(BgL_mainz00_14071, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11875)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14072;
BgL_objz00_14072 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14070, BgL_objz00_14072); BgL_objz00_14072; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3362z00_14073;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3363z00_14074;
BgL_arg3363z00_14074 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11873))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14075;
BgL_newz00_14075 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24975;
BgL_tmpz00_24975 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14075, BgL_tmpz00_24975, BgL_arg3363z00_14074); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24980;int BgL_tmpz00_24978;
BgL_auxz00_24980 = 
BINT(BgL_siza7ezd2framez75_11875); 
BgL_tmpz00_24978 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14075, BgL_tmpz00_24978, BgL_auxz00_24980); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_24983;
BgL_tmpz00_24983 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14075, BgL_tmpz00_24983, BgL_runz00_14070); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_24988;int BgL_tmpz00_24986;
BgL_auxz00_24988 = 
BINT(((long)-3)); 
BgL_tmpz00_24986 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14075, BgL_tmpz00_24986, BgL_auxz00_24988); } 
BgL_arg3362z00_14073 = BgL_newz00_14075; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14071, BgL_arg3362z00_14073); BgL_arg3362z00_14073; } 
return BgL_mainz00_14071;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5132 */
obj_t BGl_z62main5132z62zz__evaluate_compz00(obj_t BgL_envz00_11877, obj_t BgL_cz00_11885, obj_t BgL_dz00_11886, obj_t BgL_lastz00_11887)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11883;long BgL_siza7ezd2framez75_11884;
BgL_runz00_11883 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11877, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11884 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11877, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14076;
BgL_sz00_14076 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14077;
BgL_bpz00_14077 = 
VECTOR_REF(
((obj_t)BgL_sz00_14076),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14076, BgL_bpz00_14077, 
BINT(BgL_siza7ezd2framez75_11884)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3366z00_14078;
BgL_arg3366z00_14078 = 
(
(long)CINT(BgL_bpz00_14077)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14076),BgL_arg3366z00_14078,BgL_cz00_11885); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3367z00_14079;
BgL_arg3367z00_14079 = 
(
(long)CINT(BgL_bpz00_14077)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14076),BgL_arg3367z00_14079,BgL_dz00_11886); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3368z00_14080;
BgL_arg3368z00_14080 = 
(
(long)CINT(BgL_bpz00_14077)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14076),BgL_arg3368z00_14080,BgL_lastz00_11887); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14081;
BgL_ez00_14081 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14081, BgL_bpz00_14077); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14082;
BgL_accz00_14082 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11883, BgL_sz00_14076, BgL_bpz00_14077); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14081); 
VECTOR_SET(
((obj_t)BgL_sz00_14076),((long)0),BgL_bpz00_14077); 
return BgL_accz00_14082;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14083;
BgL_nsz00_14083 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14083,((long)1),BgL_sz00_14076); 
VECTOR_SET(BgL_nsz00_14083,((long)2),BgL_cz00_11885); 
VECTOR_SET(BgL_nsz00_14083,((long)3),BgL_dz00_11886); 
VECTOR_SET(BgL_nsz00_14083,((long)4),BgL_lastz00_11887); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14084;
BgL_z12denvz12_14084 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14084, BgL_nsz00_14083); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14085;
BgL_ez00_14085 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14085, BgL_sz00_14076); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14086;
BgL_____rz00_14086 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11883, BgL_nsz00_14083, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14085); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14084, BgL_sz00_14076); 
return BgL_____rz00_14086;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5133 */
obj_t BGl_z62run5133z62zz__evaluate_compz00(obj_t BgL_envz00_11888, obj_t BgL_sz00_11894)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11889;long BgL_siza7eza7_11890;obj_t BgL_valza2za2_11891;BgL_ev_absz00_bglt BgL_i1243z00_11892;obj_t BgL_bodyz00_11893;
BgL_iboxesz00_11889 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11888, 
(int)(((long)0)))); 
BgL_siza7eza7_11890 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11888, 
(int)(((long)1)))); 
BgL_valza2za2_11891 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11888, 
(int)(((long)2)))); 
BgL_i1243z00_11892 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11888, 
(int)(((long)3)))); 
BgL_bodyz00_11893 = 
PROCEDURE_REF(BgL_envz00_11888, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14087;
BgL_bpz00_14087 = 
VECTOR_REF(
((obj_t)BgL_sz00_11894),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11894, BgL_iboxesz00_11889, BgL_bpz00_14087); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11894, BgL_valza2za2_11891, 
(
(long)CINT(BgL_bpz00_14087)+BgL_siza7eza7_11890)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14088;obj_t BgL_wherez00_14089;obj_t BgL_locz00_14090;
BgL_z12denvz12_14088 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14089 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11892))->BgL_wherez00); 
BgL_locz00_14090 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11892))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14088, BgL_wherez00_14089, BgL_locz00_14090); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14091;
BgL_za2za2resza2za2z00_14091 = 
PROCEDURE_ENTRY(BgL_bodyz00_11893)(BgL_bodyz00_11893, BgL_sz00_11894, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14088); 
return BgL_za2za2resza2za2z00_14091;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3287> */
obj_t BGl_z62zc3anonymousza33287ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11895, obj_t BgL_sz00_11899)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11896;obj_t BgL_bodyz00_11897;long BgL_siza7ezd2framez75_11898;
BgL_i1243z00_11896 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11895, 
(int)(((long)0)))); 
BgL_bodyz00_11897 = 
PROCEDURE_REF(BgL_envz00_11895, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11898 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11895, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14092;
BgL_bpz00_14092 = 
VECTOR_REF(
((obj_t)BgL_sz00_11899),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14093;
BgL_runz00_14093 = 
MAKE_FX_PROCEDURE(BGl_z62run5135z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14093, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11896)); 
PROCEDURE_SET(BgL_runz00_14093, 
(int)(((long)1)), BgL_bodyz00_11897); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14094;
BgL_mainz00_14094 = 
MAKE_FX_PROCEDURE(BGl_z62main5134z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14094, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11896)); 
PROCEDURE_SET(BgL_mainz00_14094, 
(int)(((long)1)), BgL_bodyz00_11897); 
PROCEDURE_SET(BgL_mainz00_14094, 
(int)(((long)2)), BgL_runz00_14093); 
PROCEDURE_SET(BgL_mainz00_14094, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11898)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14095;
BgL_objz00_14095 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14093, BgL_objz00_14095); BgL_objz00_14095; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3288z00_14096;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3289z00_14097;
BgL_arg3289z00_14097 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11896))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14098;
BgL_newz00_14098 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25099;
BgL_tmpz00_25099 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14098, BgL_tmpz00_25099, BgL_arg3289z00_14097); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25104;int BgL_tmpz00_25102;
BgL_auxz00_25104 = 
BINT(BgL_siza7ezd2framez75_11898); 
BgL_tmpz00_25102 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14098, BgL_tmpz00_25102, BgL_auxz00_25104); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25107;
BgL_tmpz00_25107 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14098, BgL_tmpz00_25107, BgL_runz00_14093); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25112;int BgL_tmpz00_25110;
BgL_auxz00_25112 = 
BINT(((long)2)); 
BgL_tmpz00_25110 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14098, BgL_tmpz00_25110, BgL_auxz00_25112); } 
BgL_arg3288z00_14096 = BgL_newz00_14098; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14094, BgL_arg3288z00_14096); BgL_arg3288z00_14096; } 
return BgL_mainz00_14094;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5134 */
obj_t BGl_z62main5134z62zz__evaluate_compz00(obj_t BgL_envz00_11900, obj_t BgL_cz00_11905, obj_t BgL_dz00_11906)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11903;long BgL_siza7ezd2framez75_11904;
BgL_runz00_11903 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11900, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11904 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11900, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14099;
BgL_sz00_14099 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14100;
BgL_bpz00_14100 = 
VECTOR_REF(
((obj_t)BgL_sz00_14099),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14099, BgL_bpz00_14100, 
BINT(BgL_siza7ezd2framez75_11904)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3292z00_14101;
BgL_arg3292z00_14101 = 
(
(long)CINT(BgL_bpz00_14100)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14099),BgL_arg3292z00_14101,BgL_cz00_11905); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3293z00_14102;
BgL_arg3293z00_14102 = 
(
(long)CINT(BgL_bpz00_14100)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14099),BgL_arg3293z00_14102,BgL_dz00_11906); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14103;
BgL_ez00_14103 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14103, BgL_bpz00_14100); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14104;
BgL_accz00_14104 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11903, BgL_sz00_14099, BgL_bpz00_14100); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14103); 
VECTOR_SET(
((obj_t)BgL_sz00_14099),((long)0),BgL_bpz00_14100); 
return BgL_accz00_14104;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14105;
BgL_nsz00_14105 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14105,((long)1),BgL_sz00_14099); 
VECTOR_SET(BgL_nsz00_14105,((long)2),BgL_cz00_11905); 
VECTOR_SET(BgL_nsz00_14105,((long)3),BgL_dz00_11906); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14106;
BgL_z12denvz12_14106 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14106, BgL_nsz00_14105); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14107;
BgL_ez00_14107 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14107, BgL_sz00_14099); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14108;
BgL_____rz00_14108 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11903, BgL_nsz00_14105, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14107); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14106, BgL_sz00_14099); 
return BgL_____rz00_14108;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5135 */
obj_t BGl_z62run5135z62zz__evaluate_compz00(obj_t BgL_envz00_11907, obj_t BgL_sz00_11910)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11908;obj_t BgL_bodyz00_11909;
BgL_i1243z00_11908 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11907, 
(int)(((long)0)))); 
BgL_bodyz00_11909 = 
PROCEDURE_REF(BgL_envz00_11907, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14109;
BgL_bpz00_14109 = 
VECTOR_REF(
((obj_t)BgL_sz00_11910),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14110;obj_t BgL_wherez00_14111;obj_t BgL_locz00_14112;
BgL_z12denvz12_14110 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14111 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11908))->BgL_wherez00); 
BgL_locz00_14112 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11908))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14110, BgL_wherez00_14111, BgL_locz00_14112); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14113;
BgL_za2za2resza2za2z00_14113 = 
PROCEDURE_ENTRY(BgL_bodyz00_11909)(BgL_bodyz00_11909, BgL_sz00_11910, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14110); 
return BgL_za2za2resza2za2z00_14113;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3295> */
obj_t BGl_z62zc3anonymousza33295ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11911, obj_t BgL_sz00_11916)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11912;BgL_ev_absz00_bglt BgL_i1243z00_11913;obj_t BgL_bodyz00_11914;long BgL_siza7ezd2framez75_11915;
BgL_iboxesz00_11912 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11911, 
(int)(((long)0)))); 
BgL_i1243z00_11913 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11911, 
(int)(((long)1)))); 
BgL_bodyz00_11914 = 
PROCEDURE_REF(BgL_envz00_11911, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11915 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11911, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14114;
BgL_bpz00_14114 = 
VECTOR_REF(
((obj_t)BgL_sz00_11916),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14115;
BgL_runz00_14115 = 
MAKE_FX_PROCEDURE(BGl_z62run5137z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14115, 
(int)(((long)0)), BgL_iboxesz00_11912); 
PROCEDURE_SET(BgL_runz00_14115, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11913)); 
PROCEDURE_SET(BgL_runz00_14115, 
(int)(((long)2)), BgL_bodyz00_11914); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14116;
BgL_mainz00_14116 = 
MAKE_FX_PROCEDURE(BGl_z62main5136z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14116, 
(int)(((long)0)), BgL_iboxesz00_11912); 
PROCEDURE_SET(BgL_mainz00_14116, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11913)); 
PROCEDURE_SET(BgL_mainz00_14116, 
(int)(((long)2)), BgL_bodyz00_11914); 
PROCEDURE_SET(BgL_mainz00_14116, 
(int)(((long)3)), BgL_runz00_14115); 
PROCEDURE_SET(BgL_mainz00_14116, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11915)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14117;
BgL_objz00_14117 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14115, BgL_objz00_14117); BgL_objz00_14117; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3296z00_14118;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3297z00_14119;
BgL_arg3297z00_14119 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11913))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14120;
BgL_newz00_14120 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25212;
BgL_tmpz00_25212 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14120, BgL_tmpz00_25212, BgL_arg3297z00_14119); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25217;int BgL_tmpz00_25215;
BgL_auxz00_25217 = 
BINT(BgL_siza7ezd2framez75_11915); 
BgL_tmpz00_25215 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14120, BgL_tmpz00_25215, BgL_auxz00_25217); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25220;
BgL_tmpz00_25220 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14120, BgL_tmpz00_25220, BgL_runz00_14115); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25225;int BgL_tmpz00_25223;
BgL_auxz00_25225 = 
BINT(((long)2)); 
BgL_tmpz00_25223 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14120, BgL_tmpz00_25223, BgL_auxz00_25225); } 
BgL_arg3296z00_14118 = BgL_newz00_14120; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14116, BgL_arg3296z00_14118); BgL_arg3296z00_14118; } 
return BgL_mainz00_14116;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5136 */
obj_t BGl_z62main5136z62zz__evaluate_compz00(obj_t BgL_envz00_11917, obj_t BgL_cz00_11923, obj_t BgL_dz00_11924)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11921;long BgL_siza7ezd2framez75_11922;
BgL_runz00_11921 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11917, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11922 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11917, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14121;
BgL_sz00_14121 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14122;
BgL_bpz00_14122 = 
VECTOR_REF(
((obj_t)BgL_sz00_14121),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14121, BgL_bpz00_14122, 
BINT(BgL_siza7ezd2framez75_11922)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3300z00_14123;
BgL_arg3300z00_14123 = 
(
(long)CINT(BgL_bpz00_14122)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14121),BgL_arg3300z00_14123,BgL_cz00_11923); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3301z00_14124;
BgL_arg3301z00_14124 = 
(
(long)CINT(BgL_bpz00_14122)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14121),BgL_arg3301z00_14124,BgL_dz00_11924); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14125;
BgL_ez00_14125 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14125, BgL_bpz00_14122); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14126;
BgL_accz00_14126 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11921, BgL_sz00_14121, BgL_bpz00_14122); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14125); 
VECTOR_SET(
((obj_t)BgL_sz00_14121),((long)0),BgL_bpz00_14122); 
return BgL_accz00_14126;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14127;
BgL_nsz00_14127 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14127,((long)1),BgL_sz00_14121); 
VECTOR_SET(BgL_nsz00_14127,((long)2),BgL_cz00_11923); 
VECTOR_SET(BgL_nsz00_14127,((long)3),BgL_dz00_11924); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14128;
BgL_z12denvz12_14128 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14128, BgL_nsz00_14127); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14129;
BgL_ez00_14129 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14129, BgL_sz00_14121); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14130;
BgL_____rz00_14130 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11921, BgL_nsz00_14127, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14129); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14128, BgL_sz00_14121); 
return BgL_____rz00_14130;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5137 */
obj_t BGl_z62run5137z62zz__evaluate_compz00(obj_t BgL_envz00_11925, obj_t BgL_sz00_11929)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11926;BgL_ev_absz00_bglt BgL_i1243z00_11927;obj_t BgL_bodyz00_11928;
BgL_iboxesz00_11926 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11925, 
(int)(((long)0)))); 
BgL_i1243z00_11927 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11925, 
(int)(((long)1)))); 
BgL_bodyz00_11928 = 
PROCEDURE_REF(BgL_envz00_11925, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14131;
BgL_bpz00_14131 = 
VECTOR_REF(
((obj_t)BgL_sz00_11929),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11929, BgL_iboxesz00_11926, BgL_bpz00_14131); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14132;obj_t BgL_wherez00_14133;obj_t BgL_locz00_14134;
BgL_z12denvz12_14132 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14133 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11927))->BgL_wherez00); 
BgL_locz00_14134 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11927))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14132, BgL_wherez00_14133, BgL_locz00_14134); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14135;
BgL_za2za2resza2za2z00_14135 = 
PROCEDURE_ENTRY(BgL_bodyz00_11928)(BgL_bodyz00_11928, BgL_sz00_11929, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14132); 
return BgL_za2za2resza2za2z00_14135;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3306> */
obj_t BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11930, obj_t BgL_sz00_11936)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11931;long BgL_siza7eza7_11932;BgL_ev_absz00_bglt BgL_i1243z00_11933;obj_t BgL_bodyz00_11934;long BgL_siza7ezd2framez75_11935;
BgL_ifreesz00_11931 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11930, 
(int)(((long)0)))); 
BgL_siza7eza7_11932 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11930, 
(int)(((long)1)))); 
BgL_i1243z00_11933 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11930, 
(int)(((long)2)))); 
BgL_bodyz00_11934 = 
PROCEDURE_REF(BgL_envz00_11930, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11935 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11930, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14136;
BgL_bpz00_14136 = 
VECTOR_REF(
((obj_t)BgL_sz00_11936),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14137;
BgL_valza2za2_14137 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11936, BgL_bpz00_14136, BgL_ifreesz00_11931); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14138;
BgL_runz00_14138 = 
MAKE_FX_PROCEDURE(BGl_z62run5139z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14138, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11932)); 
PROCEDURE_SET(BgL_runz00_14138, 
(int)(((long)1)), BgL_valza2za2_14137); 
PROCEDURE_SET(BgL_runz00_14138, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11933)); 
PROCEDURE_SET(BgL_runz00_14138, 
(int)(((long)3)), BgL_bodyz00_11934); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14139;
BgL_mainz00_14139 = 
MAKE_FX_PROCEDURE(BGl_z62main5138z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14139, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11932)); 
PROCEDURE_SET(BgL_mainz00_14139, 
(int)(((long)1)), BgL_valza2za2_14137); 
PROCEDURE_SET(BgL_mainz00_14139, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11933)); 
PROCEDURE_SET(BgL_mainz00_14139, 
(int)(((long)3)), BgL_bodyz00_11934); 
PROCEDURE_SET(BgL_mainz00_14139, 
(int)(((long)4)), BgL_runz00_14138); 
PROCEDURE_SET(BgL_mainz00_14139, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11935)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14140;
BgL_objz00_14140 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14138, BgL_objz00_14140); BgL_objz00_14140; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3307z00_14141;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3308z00_14142;
BgL_arg3308z00_14142 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11933))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14143;
BgL_newz00_14143 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25339;
BgL_tmpz00_25339 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14143, BgL_tmpz00_25339, BgL_arg3308z00_14142); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25344;int BgL_tmpz00_25342;
BgL_auxz00_25344 = 
BINT(BgL_siza7ezd2framez75_11935); 
BgL_tmpz00_25342 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14143, BgL_tmpz00_25342, BgL_auxz00_25344); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25347;
BgL_tmpz00_25347 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14143, BgL_tmpz00_25347, BgL_runz00_14138); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25352;int BgL_tmpz00_25350;
BgL_auxz00_25352 = 
BINT(((long)2)); 
BgL_tmpz00_25350 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14143, BgL_tmpz00_25350, BgL_auxz00_25352); } 
BgL_arg3307z00_14141 = BgL_newz00_14143; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14139, BgL_arg3307z00_14141); BgL_arg3307z00_14141; } 
return BgL_mainz00_14139;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5138 */
obj_t BGl_z62main5138z62zz__evaluate_compz00(obj_t BgL_envz00_11937, obj_t BgL_cz00_11944, obj_t BgL_dz00_11945)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11942;long BgL_siza7ezd2framez75_11943;
BgL_runz00_11942 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11937, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11943 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11937, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14144;
BgL_sz00_14144 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14145;
BgL_bpz00_14145 = 
VECTOR_REF(
((obj_t)BgL_sz00_14144),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14144, BgL_bpz00_14145, 
BINT(BgL_siza7ezd2framez75_11943)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3311z00_14146;
BgL_arg3311z00_14146 = 
(
(long)CINT(BgL_bpz00_14145)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14144),BgL_arg3311z00_14146,BgL_cz00_11944); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3312z00_14147;
BgL_arg3312z00_14147 = 
(
(long)CINT(BgL_bpz00_14145)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14144),BgL_arg3312z00_14147,BgL_dz00_11945); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14148;
BgL_ez00_14148 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14148, BgL_bpz00_14145); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14149;
BgL_accz00_14149 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11942, BgL_sz00_14144, BgL_bpz00_14145); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14148); 
VECTOR_SET(
((obj_t)BgL_sz00_14144),((long)0),BgL_bpz00_14145); 
return BgL_accz00_14149;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14150;
BgL_nsz00_14150 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14150,((long)1),BgL_sz00_14144); 
VECTOR_SET(BgL_nsz00_14150,((long)2),BgL_cz00_11944); 
VECTOR_SET(BgL_nsz00_14150,((long)3),BgL_dz00_11945); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14151;
BgL_z12denvz12_14151 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14151, BgL_nsz00_14150); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14152;
BgL_ez00_14152 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14152, BgL_sz00_14144); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14153;
BgL_____rz00_14153 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11942, BgL_nsz00_14150, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14152); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14151, BgL_sz00_14144); 
return BgL_____rz00_14153;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5139 */
obj_t BGl_z62run5139z62zz__evaluate_compz00(obj_t BgL_envz00_11946, obj_t BgL_sz00_11951)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_11947;obj_t BgL_valza2za2_11948;BgL_ev_absz00_bglt BgL_i1243z00_11949;obj_t BgL_bodyz00_11950;
BgL_siza7eza7_11947 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11946, 
(int)(((long)0)))); 
BgL_valza2za2_11948 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11946, 
(int)(((long)1)))); 
BgL_i1243z00_11949 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11946, 
(int)(((long)2)))); 
BgL_bodyz00_11950 = 
PROCEDURE_REF(BgL_envz00_11946, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14154;
BgL_bpz00_14154 = 
VECTOR_REF(
((obj_t)BgL_sz00_11951),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11951, BgL_valza2za2_11948, 
(
(long)CINT(BgL_bpz00_14154)+BgL_siza7eza7_11947)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14155;obj_t BgL_wherez00_14156;obj_t BgL_locz00_14157;
BgL_z12denvz12_14155 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14156 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11949))->BgL_wherez00); 
BgL_locz00_14157 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11949))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14155, BgL_wherez00_14156, BgL_locz00_14157); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14158;
BgL_za2za2resza2za2z00_14158 = 
PROCEDURE_ENTRY(BgL_bodyz00_11950)(BgL_bodyz00_11950, BgL_sz00_11951, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14155); 
return BgL_za2za2resza2za2z00_14158;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3315> */
obj_t BGl_z62zc3anonymousza33315ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11952, obj_t BgL_sz00_11959)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_11953;obj_t BgL_iboxesz00_11954;long BgL_siza7eza7_11955;BgL_ev_absz00_bglt BgL_i1243z00_11956;obj_t BgL_bodyz00_11957;long BgL_siza7ezd2framez75_11958;
BgL_ifreesz00_11953 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)0)))); 
BgL_iboxesz00_11954 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)1)))); 
BgL_siza7eza7_11955 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)2)))); 
BgL_i1243z00_11956 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)3)))); 
BgL_bodyz00_11957 = 
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11958 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11952, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14159;
BgL_bpz00_14159 = 
VECTOR_REF(
((obj_t)BgL_sz00_11959),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14160;
BgL_valza2za2_14160 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11959, BgL_bpz00_14159, BgL_ifreesz00_11953); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14161;
BgL_runz00_14161 = 
MAKE_FX_PROCEDURE(BGl_z62run5141z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14161, 
(int)(((long)0)), BgL_iboxesz00_11954); 
PROCEDURE_SET(BgL_runz00_14161, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11955)); 
PROCEDURE_SET(BgL_runz00_14161, 
(int)(((long)2)), BgL_valza2za2_14160); 
PROCEDURE_SET(BgL_runz00_14161, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11956)); 
PROCEDURE_SET(BgL_runz00_14161, 
(int)(((long)4)), BgL_bodyz00_11957); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14162;
BgL_mainz00_14162 = 
MAKE_FX_PROCEDURE(BGl_z62main5140z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)0)), BgL_iboxesz00_11954); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11955)); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)2)), BgL_valza2za2_14160); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11956)); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)4)), BgL_bodyz00_11957); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)5)), BgL_runz00_14161); 
PROCEDURE_SET(BgL_mainz00_14162, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11958)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14163;
BgL_objz00_14163 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14161, BgL_objz00_14163); BgL_objz00_14163; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3316z00_14164;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3317z00_14165;
BgL_arg3317z00_14165 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11956))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14166;
BgL_newz00_14166 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25478;
BgL_tmpz00_25478 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14166, BgL_tmpz00_25478, BgL_arg3317z00_14165); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25483;int BgL_tmpz00_25481;
BgL_auxz00_25483 = 
BINT(BgL_siza7ezd2framez75_11958); 
BgL_tmpz00_25481 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14166, BgL_tmpz00_25481, BgL_auxz00_25483); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25486;
BgL_tmpz00_25486 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14166, BgL_tmpz00_25486, BgL_runz00_14161); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25491;int BgL_tmpz00_25489;
BgL_auxz00_25491 = 
BINT(((long)2)); 
BgL_tmpz00_25489 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14166, BgL_tmpz00_25489, BgL_auxz00_25491); } 
BgL_arg3316z00_14164 = BgL_newz00_14166; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14162, BgL_arg3316z00_14164); BgL_arg3316z00_14164; } 
return BgL_mainz00_14162;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5140 */
obj_t BGl_z62main5140z62zz__evaluate_compz00(obj_t BgL_envz00_11960, obj_t BgL_cz00_11968, obj_t BgL_dz00_11969)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11966;long BgL_siza7ezd2framez75_11967;
BgL_runz00_11966 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11960, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11967 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11960, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14167;
BgL_sz00_14167 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14168;
BgL_bpz00_14168 = 
VECTOR_REF(
((obj_t)BgL_sz00_14167),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14167, BgL_bpz00_14168, 
BINT(BgL_siza7ezd2framez75_11967)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3320z00_14169;
BgL_arg3320z00_14169 = 
(
(long)CINT(BgL_bpz00_14168)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14167),BgL_arg3320z00_14169,BgL_cz00_11968); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3321z00_14170;
BgL_arg3321z00_14170 = 
(
(long)CINT(BgL_bpz00_14168)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14167),BgL_arg3321z00_14170,BgL_dz00_11969); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14171;
BgL_ez00_14171 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14171, BgL_bpz00_14168); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14172;
BgL_accz00_14172 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11966, BgL_sz00_14167, BgL_bpz00_14168); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14171); 
VECTOR_SET(
((obj_t)BgL_sz00_14167),((long)0),BgL_bpz00_14168); 
return BgL_accz00_14172;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14173;
BgL_nsz00_14173 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14173,((long)1),BgL_sz00_14167); 
VECTOR_SET(BgL_nsz00_14173,((long)2),BgL_cz00_11968); 
VECTOR_SET(BgL_nsz00_14173,((long)3),BgL_dz00_11969); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14174;
BgL_z12denvz12_14174 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14174, BgL_nsz00_14173); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14175;
BgL_ez00_14175 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14175, BgL_sz00_14167); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14176;
BgL_____rz00_14176 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11966, BgL_nsz00_14173, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14175); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14174, BgL_sz00_14167); 
return BgL_____rz00_14176;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5141 */
obj_t BGl_z62run5141z62zz__evaluate_compz00(obj_t BgL_envz00_11970, obj_t BgL_sz00_11976)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11971;long BgL_siza7eza7_11972;obj_t BgL_valza2za2_11973;BgL_ev_absz00_bglt BgL_i1243z00_11974;obj_t BgL_bodyz00_11975;
BgL_iboxesz00_11971 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11970, 
(int)(((long)0)))); 
BgL_siza7eza7_11972 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11970, 
(int)(((long)1)))); 
BgL_valza2za2_11973 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11970, 
(int)(((long)2)))); 
BgL_i1243z00_11974 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11970, 
(int)(((long)3)))); 
BgL_bodyz00_11975 = 
PROCEDURE_REF(BgL_envz00_11970, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14177;
BgL_bpz00_14177 = 
VECTOR_REF(
((obj_t)BgL_sz00_11976),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11976, BgL_iboxesz00_11971, BgL_bpz00_14177); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11976, BgL_valza2za2_11973, 
(
(long)CINT(BgL_bpz00_14177)+BgL_siza7eza7_11972)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14178;obj_t BgL_wherez00_14179;obj_t BgL_locz00_14180;
BgL_z12denvz12_14178 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14179 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11974))->BgL_wherez00); 
BgL_locz00_14180 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11974))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14178, BgL_wherez00_14179, BgL_locz00_14180); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14181;
BgL_za2za2resza2za2z00_14181 = 
PROCEDURE_ENTRY(BgL_bodyz00_11975)(BgL_bodyz00_11975, BgL_sz00_11976, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14178); 
return BgL_za2za2resza2za2z00_14181;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3244> */
obj_t BGl_z62zc3anonymousza33244ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11977, obj_t BgL_sz00_11981)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11978;obj_t BgL_bodyz00_11979;long BgL_siza7ezd2framez75_11980;
BgL_i1243z00_11978 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11977, 
(int)(((long)0)))); 
BgL_bodyz00_11979 = 
PROCEDURE_REF(BgL_envz00_11977, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11980 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11977, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14182;
BgL_bpz00_14182 = 
VECTOR_REF(
((obj_t)BgL_sz00_11981),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14183;
BgL_runz00_14183 = 
MAKE_FX_PROCEDURE(BGl_z62run5143z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14183, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11978)); 
PROCEDURE_SET(BgL_runz00_14183, 
(int)(((long)1)), BgL_bodyz00_11979); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14184;
BgL_mainz00_14184 = 
MAKE_VA_PROCEDURE(BGl_z62main5142z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14184, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11978)); 
PROCEDURE_SET(BgL_mainz00_14184, 
(int)(((long)1)), BgL_bodyz00_11979); 
PROCEDURE_SET(BgL_mainz00_14184, 
(int)(((long)2)), BgL_runz00_14183); 
PROCEDURE_SET(BgL_mainz00_14184, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11980)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14185;
BgL_objz00_14185 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14183, BgL_objz00_14185); BgL_objz00_14185; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3245z00_14186;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3246z00_14187;
BgL_arg3246z00_14187 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11978))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14188;
BgL_newz00_14188 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25597;
BgL_tmpz00_25597 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14188, BgL_tmpz00_25597, BgL_arg3246z00_14187); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25602;int BgL_tmpz00_25600;
BgL_auxz00_25602 = 
BINT(BgL_siza7ezd2framez75_11980); 
BgL_tmpz00_25600 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14188, BgL_tmpz00_25600, BgL_auxz00_25602); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25605;
BgL_tmpz00_25605 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14188, BgL_tmpz00_25605, BgL_runz00_14183); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25610;int BgL_tmpz00_25608;
BgL_auxz00_25610 = 
BINT(((long)-2)); 
BgL_tmpz00_25608 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14188, BgL_tmpz00_25608, BgL_auxz00_25610); } 
BgL_arg3245z00_14186 = BgL_newz00_14188; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14184, BgL_arg3245z00_14186); BgL_arg3245z00_14186; } 
return BgL_mainz00_14184;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5142 */
obj_t BGl_z62main5142z62zz__evaluate_compz00(obj_t BgL_envz00_11982, obj_t BgL_dz00_11987, obj_t BgL_lastz00_11988)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_11985;long BgL_siza7ezd2framez75_11986;
BgL_runz00_11985 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11982, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11986 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11982, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14189;
BgL_sz00_14189 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14190;
BgL_bpz00_14190 = 
VECTOR_REF(
((obj_t)BgL_sz00_14189),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14189, BgL_bpz00_14190, 
BINT(BgL_siza7ezd2framez75_11986)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3249z00_14191;
BgL_arg3249z00_14191 = 
(
(long)CINT(BgL_bpz00_14190)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14189),BgL_arg3249z00_14191,BgL_dz00_11987); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3250z00_14192;
BgL_arg3250z00_14192 = 
(
(long)CINT(BgL_bpz00_14190)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14189),BgL_arg3250z00_14192,BgL_lastz00_11988); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14193;
BgL_ez00_14193 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14193, BgL_bpz00_14190); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14194;
BgL_accz00_14194 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11985, BgL_sz00_14189, BgL_bpz00_14190); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14193); 
VECTOR_SET(
((obj_t)BgL_sz00_14189),((long)0),BgL_bpz00_14190); 
return BgL_accz00_14194;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14195;
BgL_nsz00_14195 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14195,((long)1),BgL_sz00_14189); 
VECTOR_SET(BgL_nsz00_14195,((long)2),BgL_dz00_11987); 
VECTOR_SET(BgL_nsz00_14195,((long)3),BgL_lastz00_11988); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14196;
BgL_z12denvz12_14196 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14196, BgL_nsz00_14195); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14197;
BgL_ez00_14197 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14197, BgL_sz00_14189); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14198;
BgL_____rz00_14198 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11985, BgL_nsz00_14195, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14197); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14196, BgL_sz00_14189); 
return BgL_____rz00_14198;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5143 */
obj_t BGl_z62run5143z62zz__evaluate_compz00(obj_t BgL_envz00_11989, obj_t BgL_sz00_11992)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_11990;obj_t BgL_bodyz00_11991;
BgL_i1243z00_11990 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11989, 
(int)(((long)0)))); 
BgL_bodyz00_11991 = 
PROCEDURE_REF(BgL_envz00_11989, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14199;
BgL_bpz00_14199 = 
VECTOR_REF(
((obj_t)BgL_sz00_11992),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14200;obj_t BgL_wherez00_14201;obj_t BgL_locz00_14202;
BgL_z12denvz12_14200 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14201 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11990))->BgL_wherez00); 
BgL_locz00_14202 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11990))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14200, BgL_wherez00_14201, BgL_locz00_14202); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14203;
BgL_za2za2resza2za2z00_14203 = 
PROCEDURE_ENTRY(BgL_bodyz00_11991)(BgL_bodyz00_11991, BgL_sz00_11992, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14200); 
return BgL_za2za2resza2za2z00_14203;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3252> */
obj_t BGl_z62zc3anonymousza33252ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_11993, obj_t BgL_sz00_11998)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_11994;BgL_ev_absz00_bglt BgL_i1243z00_11995;obj_t BgL_bodyz00_11996;long BgL_siza7ezd2framez75_11997;
BgL_iboxesz00_11994 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11993, 
(int)(((long)0)))); 
BgL_i1243z00_11995 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11993, 
(int)(((long)1)))); 
BgL_bodyz00_11996 = 
PROCEDURE_REF(BgL_envz00_11993, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11997 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11993, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14204;
BgL_bpz00_14204 = 
VECTOR_REF(
((obj_t)BgL_sz00_11998),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14205;
BgL_runz00_14205 = 
MAKE_FX_PROCEDURE(BGl_z62run5145z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14205, 
(int)(((long)0)), BgL_iboxesz00_11994); 
PROCEDURE_SET(BgL_runz00_14205, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11995)); 
PROCEDURE_SET(BgL_runz00_14205, 
(int)(((long)2)), BgL_bodyz00_11996); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14206;
BgL_mainz00_14206 = 
MAKE_VA_PROCEDURE(BGl_z62main5144z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14206, 
(int)(((long)0)), BgL_iboxesz00_11994); 
PROCEDURE_SET(BgL_mainz00_14206, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11995)); 
PROCEDURE_SET(BgL_mainz00_14206, 
(int)(((long)2)), BgL_bodyz00_11996); 
PROCEDURE_SET(BgL_mainz00_14206, 
(int)(((long)3)), BgL_runz00_14205); 
PROCEDURE_SET(BgL_mainz00_14206, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11997)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14207;
BgL_objz00_14207 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14205, BgL_objz00_14207); BgL_objz00_14207; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3253z00_14208;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3254z00_14209;
BgL_arg3254z00_14209 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11995))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14210;
BgL_newz00_14210 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25710;
BgL_tmpz00_25710 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14210, BgL_tmpz00_25710, BgL_arg3254z00_14209); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25715;int BgL_tmpz00_25713;
BgL_auxz00_25715 = 
BINT(BgL_siza7ezd2framez75_11997); 
BgL_tmpz00_25713 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14210, BgL_tmpz00_25713, BgL_auxz00_25715); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25718;
BgL_tmpz00_25718 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14210, BgL_tmpz00_25718, BgL_runz00_14205); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25723;int BgL_tmpz00_25721;
BgL_auxz00_25723 = 
BINT(((long)-2)); 
BgL_tmpz00_25721 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14210, BgL_tmpz00_25721, BgL_auxz00_25723); } 
BgL_arg3253z00_14208 = BgL_newz00_14210; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14206, BgL_arg3253z00_14208); BgL_arg3253z00_14208; } 
return BgL_mainz00_14206;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5144 */
obj_t BGl_z62main5144z62zz__evaluate_compz00(obj_t BgL_envz00_11999, obj_t BgL_dz00_12005, obj_t BgL_lastz00_12006)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12003;long BgL_siza7ezd2framez75_12004;
BgL_runz00_12003 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11999, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12004 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11999, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14211;
BgL_sz00_14211 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14212;
BgL_bpz00_14212 = 
VECTOR_REF(
((obj_t)BgL_sz00_14211),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14211, BgL_bpz00_14212, 
BINT(BgL_siza7ezd2framez75_12004)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3257z00_14213;
BgL_arg3257z00_14213 = 
(
(long)CINT(BgL_bpz00_14212)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14211),BgL_arg3257z00_14213,BgL_dz00_12005); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3258z00_14214;
BgL_arg3258z00_14214 = 
(
(long)CINT(BgL_bpz00_14212)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14211),BgL_arg3258z00_14214,BgL_lastz00_12006); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14215;
BgL_ez00_14215 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14215, BgL_bpz00_14212); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14216;
BgL_accz00_14216 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12003, BgL_sz00_14211, BgL_bpz00_14212); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14215); 
VECTOR_SET(
((obj_t)BgL_sz00_14211),((long)0),BgL_bpz00_14212); 
return BgL_accz00_14216;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14217;
BgL_nsz00_14217 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14217,((long)1),BgL_sz00_14211); 
VECTOR_SET(BgL_nsz00_14217,((long)2),BgL_dz00_12005); 
VECTOR_SET(BgL_nsz00_14217,((long)3),BgL_lastz00_12006); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14218;
BgL_z12denvz12_14218 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14218, BgL_nsz00_14217); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14219;
BgL_ez00_14219 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14219, BgL_sz00_14211); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14220;
BgL_____rz00_14220 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12003, BgL_nsz00_14217, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14219); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14218, BgL_sz00_14211); 
return BgL_____rz00_14220;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5145 */
obj_t BGl_z62run5145z62zz__evaluate_compz00(obj_t BgL_envz00_12007, obj_t BgL_sz00_12011)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12008;BgL_ev_absz00_bglt BgL_i1243z00_12009;obj_t BgL_bodyz00_12010;
BgL_iboxesz00_12008 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12007, 
(int)(((long)0)))); 
BgL_i1243z00_12009 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12007, 
(int)(((long)1)))); 
BgL_bodyz00_12010 = 
PROCEDURE_REF(BgL_envz00_12007, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14221;
BgL_bpz00_14221 = 
VECTOR_REF(
((obj_t)BgL_sz00_12011),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12011, BgL_iboxesz00_12008, BgL_bpz00_14221); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14222;obj_t BgL_wherez00_14223;obj_t BgL_locz00_14224;
BgL_z12denvz12_14222 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14223 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12009))->BgL_wherez00); 
BgL_locz00_14224 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12009))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14222, BgL_wherez00_14223, BgL_locz00_14224); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14225;
BgL_za2za2resza2za2z00_14225 = 
PROCEDURE_ENTRY(BgL_bodyz00_12010)(BgL_bodyz00_12010, BgL_sz00_12011, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14222); 
return BgL_za2za2resza2za2z00_14225;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3263> */
obj_t BGl_z62zc3anonymousza33263ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12012, obj_t BgL_sz00_12018)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12013;long BgL_siza7eza7_12014;BgL_ev_absz00_bglt BgL_i1243z00_12015;obj_t BgL_bodyz00_12016;long BgL_siza7ezd2framez75_12017;
BgL_ifreesz00_12013 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12012, 
(int)(((long)0)))); 
BgL_siza7eza7_12014 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12012, 
(int)(((long)1)))); 
BgL_i1243z00_12015 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12012, 
(int)(((long)2)))); 
BgL_bodyz00_12016 = 
PROCEDURE_REF(BgL_envz00_12012, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12017 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12012, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14226;
BgL_bpz00_14226 = 
VECTOR_REF(
((obj_t)BgL_sz00_12018),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14227;
BgL_valza2za2_14227 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12018, BgL_bpz00_14226, BgL_ifreesz00_12013); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14228;
BgL_runz00_14228 = 
MAKE_FX_PROCEDURE(BGl_z62run5147z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14228, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12014)); 
PROCEDURE_SET(BgL_runz00_14228, 
(int)(((long)1)), BgL_valza2za2_14227); 
PROCEDURE_SET(BgL_runz00_14228, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12015)); 
PROCEDURE_SET(BgL_runz00_14228, 
(int)(((long)3)), BgL_bodyz00_12016); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14229;
BgL_mainz00_14229 = 
MAKE_VA_PROCEDURE(BGl_z62main5146z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14229, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12014)); 
PROCEDURE_SET(BgL_mainz00_14229, 
(int)(((long)1)), BgL_valza2za2_14227); 
PROCEDURE_SET(BgL_mainz00_14229, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12015)); 
PROCEDURE_SET(BgL_mainz00_14229, 
(int)(((long)3)), BgL_bodyz00_12016); 
PROCEDURE_SET(BgL_mainz00_14229, 
(int)(((long)4)), BgL_runz00_14228); 
PROCEDURE_SET(BgL_mainz00_14229, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12017)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14230;
BgL_objz00_14230 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14228, BgL_objz00_14230); BgL_objz00_14230; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3264z00_14231;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3265z00_14232;
BgL_arg3265z00_14232 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12015))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14233;
BgL_newz00_14233 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25837;
BgL_tmpz00_25837 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14233, BgL_tmpz00_25837, BgL_arg3265z00_14232); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25842;int BgL_tmpz00_25840;
BgL_auxz00_25842 = 
BINT(BgL_siza7ezd2framez75_12017); 
BgL_tmpz00_25840 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14233, BgL_tmpz00_25840, BgL_auxz00_25842); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25845;
BgL_tmpz00_25845 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14233, BgL_tmpz00_25845, BgL_runz00_14228); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25850;int BgL_tmpz00_25848;
BgL_auxz00_25850 = 
BINT(((long)-2)); 
BgL_tmpz00_25848 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14233, BgL_tmpz00_25848, BgL_auxz00_25850); } 
BgL_arg3264z00_14231 = BgL_newz00_14233; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14229, BgL_arg3264z00_14231); BgL_arg3264z00_14231; } 
return BgL_mainz00_14229;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5146 */
obj_t BGl_z62main5146z62zz__evaluate_compz00(obj_t BgL_envz00_12019, obj_t BgL_dz00_12026, obj_t BgL_lastz00_12027)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12024;long BgL_siza7ezd2framez75_12025;
BgL_runz00_12024 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12019, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12025 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12019, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14234;
BgL_sz00_14234 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14235;
BgL_bpz00_14235 = 
VECTOR_REF(
((obj_t)BgL_sz00_14234),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14234, BgL_bpz00_14235, 
BINT(BgL_siza7ezd2framez75_12025)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3268z00_14236;
BgL_arg3268z00_14236 = 
(
(long)CINT(BgL_bpz00_14235)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14234),BgL_arg3268z00_14236,BgL_dz00_12026); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3269z00_14237;
BgL_arg3269z00_14237 = 
(
(long)CINT(BgL_bpz00_14235)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14234),BgL_arg3269z00_14237,BgL_lastz00_12027); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14238;
BgL_ez00_14238 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14238, BgL_bpz00_14235); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14239;
BgL_accz00_14239 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12024, BgL_sz00_14234, BgL_bpz00_14235); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14238); 
VECTOR_SET(
((obj_t)BgL_sz00_14234),((long)0),BgL_bpz00_14235); 
return BgL_accz00_14239;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14240;
BgL_nsz00_14240 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14240,((long)1),BgL_sz00_14234); 
VECTOR_SET(BgL_nsz00_14240,((long)2),BgL_dz00_12026); 
VECTOR_SET(BgL_nsz00_14240,((long)3),BgL_lastz00_12027); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14241;
BgL_z12denvz12_14241 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14241, BgL_nsz00_14240); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14242;
BgL_ez00_14242 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14242, BgL_sz00_14234); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14243;
BgL_____rz00_14243 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12024, BgL_nsz00_14240, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14242); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14241, BgL_sz00_14234); 
return BgL_____rz00_14243;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5147 */
obj_t BGl_z62run5147z62zz__evaluate_compz00(obj_t BgL_envz00_12028, obj_t BgL_sz00_12033)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_12029;obj_t BgL_valza2za2_12030;BgL_ev_absz00_bglt BgL_i1243z00_12031;obj_t BgL_bodyz00_12032;
BgL_siza7eza7_12029 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12028, 
(int)(((long)0)))); 
BgL_valza2za2_12030 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12028, 
(int)(((long)1)))); 
BgL_i1243z00_12031 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12028, 
(int)(((long)2)))); 
BgL_bodyz00_12032 = 
PROCEDURE_REF(BgL_envz00_12028, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14244;
BgL_bpz00_14244 = 
VECTOR_REF(
((obj_t)BgL_sz00_12033),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12033, BgL_valza2za2_12030, 
(
(long)CINT(BgL_bpz00_14244)+BgL_siza7eza7_12029)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14245;obj_t BgL_wherez00_14246;obj_t BgL_locz00_14247;
BgL_z12denvz12_14245 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14246 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12031))->BgL_wherez00); 
BgL_locz00_14247 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12031))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14245, BgL_wherez00_14246, BgL_locz00_14247); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14248;
BgL_za2za2resza2za2z00_14248 = 
PROCEDURE_ENTRY(BgL_bodyz00_12032)(BgL_bodyz00_12032, BgL_sz00_12033, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14245); 
return BgL_za2za2resza2za2z00_14248;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3272> */
obj_t BGl_z62zc3anonymousza33272ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12034, obj_t BgL_sz00_12041)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12035;obj_t BgL_iboxesz00_12036;long BgL_siza7eza7_12037;BgL_ev_absz00_bglt BgL_i1243z00_12038;obj_t BgL_bodyz00_12039;long BgL_siza7ezd2framez75_12040;
BgL_ifreesz00_12035 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)0)))); 
BgL_iboxesz00_12036 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)1)))); 
BgL_siza7eza7_12037 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)2)))); 
BgL_i1243z00_12038 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)3)))); 
BgL_bodyz00_12039 = 
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12040 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12034, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14249;
BgL_bpz00_14249 = 
VECTOR_REF(
((obj_t)BgL_sz00_12041),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14250;
BgL_valza2za2_14250 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12041, BgL_bpz00_14249, BgL_ifreesz00_12035); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14251;
BgL_runz00_14251 = 
MAKE_FX_PROCEDURE(BGl_z62run5149z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14251, 
(int)(((long)0)), BgL_iboxesz00_12036); 
PROCEDURE_SET(BgL_runz00_14251, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12037)); 
PROCEDURE_SET(BgL_runz00_14251, 
(int)(((long)2)), BgL_valza2za2_14250); 
PROCEDURE_SET(BgL_runz00_14251, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12038)); 
PROCEDURE_SET(BgL_runz00_14251, 
(int)(((long)4)), BgL_bodyz00_12039); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14252;
BgL_mainz00_14252 = 
MAKE_VA_PROCEDURE(BGl_z62main5148z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)0)), BgL_iboxesz00_12036); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12037)); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)2)), BgL_valza2za2_14250); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12038)); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)4)), BgL_bodyz00_12039); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)5)), BgL_runz00_14251); 
PROCEDURE_SET(BgL_mainz00_14252, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12040)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14253;
BgL_objz00_14253 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14251, BgL_objz00_14253); BgL_objz00_14253; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3273z00_14254;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3274z00_14255;
BgL_arg3274z00_14255 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12038))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14256;
BgL_newz00_14256 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25976;
BgL_tmpz00_25976 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14256, BgL_tmpz00_25976, BgL_arg3274z00_14255); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25981;int BgL_tmpz00_25979;
BgL_auxz00_25981 = 
BINT(BgL_siza7ezd2framez75_12040); 
BgL_tmpz00_25979 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14256, BgL_tmpz00_25979, BgL_auxz00_25981); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_25984;
BgL_tmpz00_25984 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14256, BgL_tmpz00_25984, BgL_runz00_14251); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_25989;int BgL_tmpz00_25987;
BgL_auxz00_25989 = 
BINT(((long)-2)); 
BgL_tmpz00_25987 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14256, BgL_tmpz00_25987, BgL_auxz00_25989); } 
BgL_arg3273z00_14254 = BgL_newz00_14256; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14252, BgL_arg3273z00_14254); BgL_arg3273z00_14254; } 
return BgL_mainz00_14252;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5148 */
obj_t BGl_z62main5148z62zz__evaluate_compz00(obj_t BgL_envz00_12042, obj_t BgL_dz00_12050, obj_t BgL_lastz00_12051)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12048;long BgL_siza7ezd2framez75_12049;
BgL_runz00_12048 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12042, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12049 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12042, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14257;
BgL_sz00_14257 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14258;
BgL_bpz00_14258 = 
VECTOR_REF(
((obj_t)BgL_sz00_14257),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14257, BgL_bpz00_14258, 
BINT(BgL_siza7ezd2framez75_12049)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3277z00_14259;
BgL_arg3277z00_14259 = 
(
(long)CINT(BgL_bpz00_14258)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14257),BgL_arg3277z00_14259,BgL_dz00_12050); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3278z00_14260;
BgL_arg3278z00_14260 = 
(
(long)CINT(BgL_bpz00_14258)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14257),BgL_arg3278z00_14260,BgL_lastz00_12051); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14261;
BgL_ez00_14261 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14261, BgL_bpz00_14258); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14262;
BgL_accz00_14262 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12048, BgL_sz00_14257, BgL_bpz00_14258); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14261); 
VECTOR_SET(
((obj_t)BgL_sz00_14257),((long)0),BgL_bpz00_14258); 
return BgL_accz00_14262;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14263;
BgL_nsz00_14263 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14263,((long)1),BgL_sz00_14257); 
VECTOR_SET(BgL_nsz00_14263,((long)2),BgL_dz00_12050); 
VECTOR_SET(BgL_nsz00_14263,((long)3),BgL_lastz00_12051); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14264;
BgL_z12denvz12_14264 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14264, BgL_nsz00_14263); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14265;
BgL_ez00_14265 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14265, BgL_sz00_14257); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14266;
BgL_____rz00_14266 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12048, BgL_nsz00_14263, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14265); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14264, BgL_sz00_14257); 
return BgL_____rz00_14266;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5149 */
obj_t BGl_z62run5149z62zz__evaluate_compz00(obj_t BgL_envz00_12052, obj_t BgL_sz00_12058)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12053;long BgL_siza7eza7_12054;obj_t BgL_valza2za2_12055;BgL_ev_absz00_bglt BgL_i1243z00_12056;obj_t BgL_bodyz00_12057;
BgL_iboxesz00_12053 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12052, 
(int)(((long)0)))); 
BgL_siza7eza7_12054 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12052, 
(int)(((long)1)))); 
BgL_valza2za2_12055 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12052, 
(int)(((long)2)))); 
BgL_i1243z00_12056 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12052, 
(int)(((long)3)))); 
BgL_bodyz00_12057 = 
PROCEDURE_REF(BgL_envz00_12052, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14267;
BgL_bpz00_14267 = 
VECTOR_REF(
((obj_t)BgL_sz00_12058),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12058, BgL_iboxesz00_12053, BgL_bpz00_14267); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12058, BgL_valza2za2_12055, 
(
(long)CINT(BgL_bpz00_14267)+BgL_siza7eza7_12054)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14268;obj_t BgL_wherez00_14269;obj_t BgL_locz00_14270;
BgL_z12denvz12_14268 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14269 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12056))->BgL_wherez00); 
BgL_locz00_14270 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12056))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14268, BgL_wherez00_14269, BgL_locz00_14270); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14271;
BgL_za2za2resza2za2z00_14271 = 
PROCEDURE_ENTRY(BgL_bodyz00_12057)(BgL_bodyz00_12057, BgL_sz00_12058, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14268); 
return BgL_za2za2resza2za2z00_14271;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3205> */
obj_t BGl_z62zc3anonymousza33205ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12059, obj_t BgL_sz00_12063)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12060;obj_t BgL_bodyz00_12061;long BgL_siza7ezd2framez75_12062;
BgL_i1243z00_12060 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12059, 
(int)(((long)0)))); 
BgL_bodyz00_12061 = 
PROCEDURE_REF(BgL_envz00_12059, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12062 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12059, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14272;
BgL_bpz00_14272 = 
VECTOR_REF(
((obj_t)BgL_sz00_12063),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14273;
BgL_runz00_14273 = 
MAKE_FX_PROCEDURE(BGl_z62run5151z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14273, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12060)); 
PROCEDURE_SET(BgL_runz00_14273, 
(int)(((long)1)), BgL_bodyz00_12061); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14274;
BgL_mainz00_14274 = 
MAKE_FX_PROCEDURE(BGl_z62main5150z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14274, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12060)); 
PROCEDURE_SET(BgL_mainz00_14274, 
(int)(((long)1)), BgL_bodyz00_12061); 
PROCEDURE_SET(BgL_mainz00_14274, 
(int)(((long)2)), BgL_runz00_14273); 
PROCEDURE_SET(BgL_mainz00_14274, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12062)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14275;
BgL_objz00_14275 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14273, BgL_objz00_14275); BgL_objz00_14275; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3206z00_14276;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3207z00_14277;
BgL_arg3207z00_14277 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12060))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14278;
BgL_newz00_14278 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26095;
BgL_tmpz00_26095 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14278, BgL_tmpz00_26095, BgL_arg3207z00_14277); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26100;int BgL_tmpz00_26098;
BgL_auxz00_26100 = 
BINT(BgL_siza7ezd2framez75_12062); 
BgL_tmpz00_26098 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14278, BgL_tmpz00_26098, BgL_auxz00_26100); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26103;
BgL_tmpz00_26103 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14278, BgL_tmpz00_26103, BgL_runz00_14273); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26108;int BgL_tmpz00_26106;
BgL_auxz00_26108 = 
BINT(((long)1)); 
BgL_tmpz00_26106 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14278, BgL_tmpz00_26106, BgL_auxz00_26108); } 
BgL_arg3206z00_14276 = BgL_newz00_14278; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14274, BgL_arg3206z00_14276); BgL_arg3206z00_14276; } 
return BgL_mainz00_14274;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5150 */
obj_t BGl_z62main5150z62zz__evaluate_compz00(obj_t BgL_envz00_12064, obj_t BgL_dz00_12069)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12067;long BgL_siza7ezd2framez75_12068;
BgL_runz00_12067 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12064, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12068 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12064, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14279;
BgL_sz00_14279 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14280;
BgL_bpz00_14280 = 
VECTOR_REF(
((obj_t)BgL_sz00_14279),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14279, BgL_bpz00_14280, 
BINT(BgL_siza7ezd2framez75_12068)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3210z00_14281;
BgL_arg3210z00_14281 = 
(
(long)CINT(BgL_bpz00_14280)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14279),BgL_arg3210z00_14281,BgL_dz00_12069); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14282;
BgL_ez00_14282 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14282, BgL_bpz00_14280); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14283;
BgL_accz00_14283 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12067, BgL_sz00_14279, BgL_bpz00_14280); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14282); 
VECTOR_SET(
((obj_t)BgL_sz00_14279),((long)0),BgL_bpz00_14280); 
return BgL_accz00_14283;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14284;
BgL_nsz00_14284 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14284,((long)1),BgL_sz00_14279); 
VECTOR_SET(BgL_nsz00_14284,((long)2),BgL_dz00_12069); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14285;
BgL_z12denvz12_14285 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14285, BgL_nsz00_14284); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14286;
BgL_ez00_14286 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14286, BgL_sz00_14279); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14287;
BgL_____rz00_14287 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12067, BgL_nsz00_14284, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14286); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14285, BgL_sz00_14279); 
return BgL_____rz00_14287;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5151 */
obj_t BGl_z62run5151z62zz__evaluate_compz00(obj_t BgL_envz00_12070, obj_t BgL_sz00_12073)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12071;obj_t BgL_bodyz00_12072;
BgL_i1243z00_12071 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12070, 
(int)(((long)0)))); 
BgL_bodyz00_12072 = 
PROCEDURE_REF(BgL_envz00_12070, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14288;
BgL_bpz00_14288 = 
VECTOR_REF(
((obj_t)BgL_sz00_12073),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14289;obj_t BgL_wherez00_14290;obj_t BgL_locz00_14291;
BgL_z12denvz12_14289 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14290 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12071))->BgL_wherez00); 
BgL_locz00_14291 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12071))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14289, BgL_wherez00_14290, BgL_locz00_14291); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14292;
BgL_za2za2resza2za2z00_14292 = 
PROCEDURE_ENTRY(BgL_bodyz00_12072)(BgL_bodyz00_12072, BgL_sz00_12073, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14289); 
return BgL_za2za2resza2za2z00_14292;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3212> */
obj_t BGl_z62zc3anonymousza33212ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12074, obj_t BgL_sz00_12079)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12075;BgL_ev_absz00_bglt BgL_i1243z00_12076;obj_t BgL_bodyz00_12077;long BgL_siza7ezd2framez75_12078;
BgL_iboxesz00_12075 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12074, 
(int)(((long)0)))); 
BgL_i1243z00_12076 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12074, 
(int)(((long)1)))); 
BgL_bodyz00_12077 = 
PROCEDURE_REF(BgL_envz00_12074, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12078 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12074, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14293;
BgL_bpz00_14293 = 
VECTOR_REF(
((obj_t)BgL_sz00_12079),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14294;
BgL_runz00_14294 = 
MAKE_FX_PROCEDURE(BGl_z62run5153z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14294, 
(int)(((long)0)), BgL_iboxesz00_12075); 
PROCEDURE_SET(BgL_runz00_14294, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12076)); 
PROCEDURE_SET(BgL_runz00_14294, 
(int)(((long)2)), BgL_bodyz00_12077); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14295;
BgL_mainz00_14295 = 
MAKE_FX_PROCEDURE(BGl_z62main5152z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14295, 
(int)(((long)0)), BgL_iboxesz00_12075); 
PROCEDURE_SET(BgL_mainz00_14295, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12076)); 
PROCEDURE_SET(BgL_mainz00_14295, 
(int)(((long)2)), BgL_bodyz00_12077); 
PROCEDURE_SET(BgL_mainz00_14295, 
(int)(((long)3)), BgL_runz00_14294); 
PROCEDURE_SET(BgL_mainz00_14295, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12078)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14296;
BgL_objz00_14296 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14294, BgL_objz00_14296); BgL_objz00_14296; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3213z00_14297;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3214z00_14298;
BgL_arg3214z00_14298 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12076))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14299;
BgL_newz00_14299 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26203;
BgL_tmpz00_26203 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14299, BgL_tmpz00_26203, BgL_arg3214z00_14298); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26208;int BgL_tmpz00_26206;
BgL_auxz00_26208 = 
BINT(BgL_siza7ezd2framez75_12078); 
BgL_tmpz00_26206 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14299, BgL_tmpz00_26206, BgL_auxz00_26208); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26211;
BgL_tmpz00_26211 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14299, BgL_tmpz00_26211, BgL_runz00_14294); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26216;int BgL_tmpz00_26214;
BgL_auxz00_26216 = 
BINT(((long)1)); 
BgL_tmpz00_26214 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14299, BgL_tmpz00_26214, BgL_auxz00_26216); } 
BgL_arg3213z00_14297 = BgL_newz00_14299; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14295, BgL_arg3213z00_14297); BgL_arg3213z00_14297; } 
return BgL_mainz00_14295;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5152 */
obj_t BGl_z62main5152z62zz__evaluate_compz00(obj_t BgL_envz00_12080, obj_t BgL_dz00_12086)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12084;long BgL_siza7ezd2framez75_12085;
BgL_runz00_12084 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12080, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12085 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12080, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14300;
BgL_sz00_14300 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14301;
BgL_bpz00_14301 = 
VECTOR_REF(
((obj_t)BgL_sz00_14300),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14300, BgL_bpz00_14301, 
BINT(BgL_siza7ezd2framez75_12085)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3217z00_14302;
BgL_arg3217z00_14302 = 
(
(long)CINT(BgL_bpz00_14301)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14300),BgL_arg3217z00_14302,BgL_dz00_12086); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14303;
BgL_ez00_14303 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14303, BgL_bpz00_14301); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14304;
BgL_accz00_14304 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12084, BgL_sz00_14300, BgL_bpz00_14301); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14303); 
VECTOR_SET(
((obj_t)BgL_sz00_14300),((long)0),BgL_bpz00_14301); 
return BgL_accz00_14304;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14305;
BgL_nsz00_14305 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14305,((long)1),BgL_sz00_14300); 
VECTOR_SET(BgL_nsz00_14305,((long)2),BgL_dz00_12086); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14306;
BgL_z12denvz12_14306 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14306, BgL_nsz00_14305); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14307;
BgL_ez00_14307 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14307, BgL_sz00_14300); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14308;
BgL_____rz00_14308 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12084, BgL_nsz00_14305, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14307); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14306, BgL_sz00_14300); 
return BgL_____rz00_14308;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5153 */
obj_t BGl_z62run5153z62zz__evaluate_compz00(obj_t BgL_envz00_12087, obj_t BgL_sz00_12091)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12088;BgL_ev_absz00_bglt BgL_i1243z00_12089;obj_t BgL_bodyz00_12090;
BgL_iboxesz00_12088 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12087, 
(int)(((long)0)))); 
BgL_i1243z00_12089 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12087, 
(int)(((long)1)))); 
BgL_bodyz00_12090 = 
PROCEDURE_REF(BgL_envz00_12087, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14309;
BgL_bpz00_14309 = 
VECTOR_REF(
((obj_t)BgL_sz00_12091),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12091, BgL_iboxesz00_12088, BgL_bpz00_14309); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14310;obj_t BgL_wherez00_14311;obj_t BgL_locz00_14312;
BgL_z12denvz12_14310 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14311 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12089))->BgL_wherez00); 
BgL_locz00_14312 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12089))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14310, BgL_wherez00_14311, BgL_locz00_14312); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14313;
BgL_za2za2resza2za2z00_14313 = 
PROCEDURE_ENTRY(BgL_bodyz00_12090)(BgL_bodyz00_12090, BgL_sz00_12091, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14310); 
return BgL_za2za2resza2za2z00_14313;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3222> */
obj_t BGl_z62zc3anonymousza33222ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12092, obj_t BgL_sz00_12098)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12093;long BgL_siza7eza7_12094;BgL_ev_absz00_bglt BgL_i1243z00_12095;obj_t BgL_bodyz00_12096;long BgL_siza7ezd2framez75_12097;
BgL_ifreesz00_12093 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12092, 
(int)(((long)0)))); 
BgL_siza7eza7_12094 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12092, 
(int)(((long)1)))); 
BgL_i1243z00_12095 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12092, 
(int)(((long)2)))); 
BgL_bodyz00_12096 = 
PROCEDURE_REF(BgL_envz00_12092, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12097 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12092, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14314;
BgL_bpz00_14314 = 
VECTOR_REF(
((obj_t)BgL_sz00_12098),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14315;
BgL_valza2za2_14315 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12098, BgL_bpz00_14314, BgL_ifreesz00_12093); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14316;
BgL_runz00_14316 = 
MAKE_FX_PROCEDURE(BGl_z62run5155z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14316, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12094)); 
PROCEDURE_SET(BgL_runz00_14316, 
(int)(((long)1)), BgL_valza2za2_14315); 
PROCEDURE_SET(BgL_runz00_14316, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12095)); 
PROCEDURE_SET(BgL_runz00_14316, 
(int)(((long)3)), BgL_bodyz00_12096); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14317;
BgL_mainz00_14317 = 
MAKE_FX_PROCEDURE(BGl_z62main5154z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14317, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12094)); 
PROCEDURE_SET(BgL_mainz00_14317, 
(int)(((long)1)), BgL_valza2za2_14315); 
PROCEDURE_SET(BgL_mainz00_14317, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12095)); 
PROCEDURE_SET(BgL_mainz00_14317, 
(int)(((long)3)), BgL_bodyz00_12096); 
PROCEDURE_SET(BgL_mainz00_14317, 
(int)(((long)4)), BgL_runz00_14316); 
PROCEDURE_SET(BgL_mainz00_14317, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12097)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14318;
BgL_objz00_14318 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14316, BgL_objz00_14318); BgL_objz00_14318; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3223z00_14319;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3224z00_14320;
BgL_arg3224z00_14320 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12095))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14321;
BgL_newz00_14321 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26325;
BgL_tmpz00_26325 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14321, BgL_tmpz00_26325, BgL_arg3224z00_14320); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26330;int BgL_tmpz00_26328;
BgL_auxz00_26330 = 
BINT(BgL_siza7ezd2framez75_12097); 
BgL_tmpz00_26328 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14321, BgL_tmpz00_26328, BgL_auxz00_26330); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26333;
BgL_tmpz00_26333 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14321, BgL_tmpz00_26333, BgL_runz00_14316); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26338;int BgL_tmpz00_26336;
BgL_auxz00_26338 = 
BINT(((long)1)); 
BgL_tmpz00_26336 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14321, BgL_tmpz00_26336, BgL_auxz00_26338); } 
BgL_arg3223z00_14319 = BgL_newz00_14321; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14317, BgL_arg3223z00_14319); BgL_arg3223z00_14319; } 
return BgL_mainz00_14317;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5154 */
obj_t BGl_z62main5154z62zz__evaluate_compz00(obj_t BgL_envz00_12099, obj_t BgL_dz00_12106)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12104;long BgL_siza7ezd2framez75_12105;
BgL_runz00_12104 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12099, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12105 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12099, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14322;
BgL_sz00_14322 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14323;
BgL_bpz00_14323 = 
VECTOR_REF(
((obj_t)BgL_sz00_14322),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14322, BgL_bpz00_14323, 
BINT(BgL_siza7ezd2framez75_12105)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3227z00_14324;
BgL_arg3227z00_14324 = 
(
(long)CINT(BgL_bpz00_14323)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14322),BgL_arg3227z00_14324,BgL_dz00_12106); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14325;
BgL_ez00_14325 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14325, BgL_bpz00_14323); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14326;
BgL_accz00_14326 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12104, BgL_sz00_14322, BgL_bpz00_14323); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14325); 
VECTOR_SET(
((obj_t)BgL_sz00_14322),((long)0),BgL_bpz00_14323); 
return BgL_accz00_14326;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14327;
BgL_nsz00_14327 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14327,((long)1),BgL_sz00_14322); 
VECTOR_SET(BgL_nsz00_14327,((long)2),BgL_dz00_12106); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14328;
BgL_z12denvz12_14328 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14328, BgL_nsz00_14327); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14329;
BgL_ez00_14329 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14329, BgL_sz00_14322); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14330;
BgL_____rz00_14330 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12104, BgL_nsz00_14327, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14329); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14328, BgL_sz00_14322); 
return BgL_____rz00_14330;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5155 */
obj_t BGl_z62run5155z62zz__evaluate_compz00(obj_t BgL_envz00_12107, obj_t BgL_sz00_12112)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_12108;obj_t BgL_valza2za2_12109;BgL_ev_absz00_bglt BgL_i1243z00_12110;obj_t BgL_bodyz00_12111;
BgL_siza7eza7_12108 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12107, 
(int)(((long)0)))); 
BgL_valza2za2_12109 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12107, 
(int)(((long)1)))); 
BgL_i1243z00_12110 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12107, 
(int)(((long)2)))); 
BgL_bodyz00_12111 = 
PROCEDURE_REF(BgL_envz00_12107, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14331;
BgL_bpz00_14331 = 
VECTOR_REF(
((obj_t)BgL_sz00_12112),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12112, BgL_valza2za2_12109, 
(
(long)CINT(BgL_bpz00_14331)+BgL_siza7eza7_12108)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14332;obj_t BgL_wherez00_14333;obj_t BgL_locz00_14334;
BgL_z12denvz12_14332 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14333 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12110))->BgL_wherez00); 
BgL_locz00_14334 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12110))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14332, BgL_wherez00_14333, BgL_locz00_14334); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14335;
BgL_za2za2resza2za2z00_14335 = 
PROCEDURE_ENTRY(BgL_bodyz00_12111)(BgL_bodyz00_12111, BgL_sz00_12112, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14332); 
return BgL_za2za2resza2za2z00_14335;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3230> */
obj_t BGl_z62zc3anonymousza33230ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12113, obj_t BgL_sz00_12120)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12114;obj_t BgL_iboxesz00_12115;long BgL_siza7eza7_12116;BgL_ev_absz00_bglt BgL_i1243z00_12117;obj_t BgL_bodyz00_12118;long BgL_siza7ezd2framez75_12119;
BgL_ifreesz00_12114 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)0)))); 
BgL_iboxesz00_12115 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)1)))); 
BgL_siza7eza7_12116 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)2)))); 
BgL_i1243z00_12117 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)3)))); 
BgL_bodyz00_12118 = 
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12119 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12113, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14336;
BgL_bpz00_14336 = 
VECTOR_REF(
((obj_t)BgL_sz00_12120),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14337;
BgL_valza2za2_14337 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12120, BgL_bpz00_14336, BgL_ifreesz00_12114); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14338;
BgL_runz00_14338 = 
MAKE_FX_PROCEDURE(BGl_z62run5157z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14338, 
(int)(((long)0)), BgL_iboxesz00_12115); 
PROCEDURE_SET(BgL_runz00_14338, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12116)); 
PROCEDURE_SET(BgL_runz00_14338, 
(int)(((long)2)), BgL_valza2za2_14337); 
PROCEDURE_SET(BgL_runz00_14338, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12117)); 
PROCEDURE_SET(BgL_runz00_14338, 
(int)(((long)4)), BgL_bodyz00_12118); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14339;
BgL_mainz00_14339 = 
MAKE_FX_PROCEDURE(BGl_z62main5156z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)0)), BgL_iboxesz00_12115); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12116)); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)2)), BgL_valza2za2_14337); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12117)); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)4)), BgL_bodyz00_12118); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)5)), BgL_runz00_14338); 
PROCEDURE_SET(BgL_mainz00_14339, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12119)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14340;
BgL_objz00_14340 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14338, BgL_objz00_14340); BgL_objz00_14340; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3231z00_14341;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3232z00_14342;
BgL_arg3232z00_14342 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12117))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14343;
BgL_newz00_14343 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26459;
BgL_tmpz00_26459 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14343, BgL_tmpz00_26459, BgL_arg3232z00_14342); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26464;int BgL_tmpz00_26462;
BgL_auxz00_26464 = 
BINT(BgL_siza7ezd2framez75_12119); 
BgL_tmpz00_26462 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14343, BgL_tmpz00_26462, BgL_auxz00_26464); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26467;
BgL_tmpz00_26467 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14343, BgL_tmpz00_26467, BgL_runz00_14338); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26472;int BgL_tmpz00_26470;
BgL_auxz00_26472 = 
BINT(((long)1)); 
BgL_tmpz00_26470 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14343, BgL_tmpz00_26470, BgL_auxz00_26472); } 
BgL_arg3231z00_14341 = BgL_newz00_14343; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14339, BgL_arg3231z00_14341); BgL_arg3231z00_14341; } 
return BgL_mainz00_14339;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5156 */
obj_t BGl_z62main5156z62zz__evaluate_compz00(obj_t BgL_envz00_12121, obj_t BgL_dz00_12129)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12127;long BgL_siza7ezd2framez75_12128;
BgL_runz00_12127 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12121, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12128 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12121, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14344;
BgL_sz00_14344 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14345;
BgL_bpz00_14345 = 
VECTOR_REF(
((obj_t)BgL_sz00_14344),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14344, BgL_bpz00_14345, 
BINT(BgL_siza7ezd2framez75_12128)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3235z00_14346;
BgL_arg3235z00_14346 = 
(
(long)CINT(BgL_bpz00_14345)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14344),BgL_arg3235z00_14346,BgL_dz00_12129); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14347;
BgL_ez00_14347 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14347, BgL_bpz00_14345); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14348;
BgL_accz00_14348 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12127, BgL_sz00_14344, BgL_bpz00_14345); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14347); 
VECTOR_SET(
((obj_t)BgL_sz00_14344),((long)0),BgL_bpz00_14345); 
return BgL_accz00_14348;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14349;
BgL_nsz00_14349 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14349,((long)1),BgL_sz00_14344); 
VECTOR_SET(BgL_nsz00_14349,((long)2),BgL_dz00_12129); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14350;
BgL_z12denvz12_14350 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14350, BgL_nsz00_14349); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14351;
BgL_ez00_14351 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14351, BgL_sz00_14344); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14352;
BgL_____rz00_14352 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12127, BgL_nsz00_14349, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14351); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14350, BgL_sz00_14344); 
return BgL_____rz00_14352;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5157 */
obj_t BGl_z62run5157z62zz__evaluate_compz00(obj_t BgL_envz00_12130, obj_t BgL_sz00_12136)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12131;long BgL_siza7eza7_12132;obj_t BgL_valza2za2_12133;BgL_ev_absz00_bglt BgL_i1243z00_12134;obj_t BgL_bodyz00_12135;
BgL_iboxesz00_12131 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12130, 
(int)(((long)0)))); 
BgL_siza7eza7_12132 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12130, 
(int)(((long)1)))); 
BgL_valza2za2_12133 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12130, 
(int)(((long)2)))); 
BgL_i1243z00_12134 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12130, 
(int)(((long)3)))); 
BgL_bodyz00_12135 = 
PROCEDURE_REF(BgL_envz00_12130, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14353;
BgL_bpz00_14353 = 
VECTOR_REF(
((obj_t)BgL_sz00_12136),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12136, BgL_iboxesz00_12131, BgL_bpz00_14353); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12136, BgL_valza2za2_12133, 
(
(long)CINT(BgL_bpz00_14353)+BgL_siza7eza7_12132)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14354;obj_t BgL_wherez00_14355;obj_t BgL_locz00_14356;
BgL_z12denvz12_14354 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14355 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12134))->BgL_wherez00); 
BgL_locz00_14356 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12134))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14354, BgL_wherez00_14355, BgL_locz00_14356); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14357;
BgL_za2za2resza2za2z00_14357 = 
PROCEDURE_ENTRY(BgL_bodyz00_12135)(BgL_bodyz00_12135, BgL_sz00_12136, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14354); 
return BgL_za2za2resza2za2z00_14357;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3166> */
obj_t BGl_z62zc3anonymousza33166ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12137, obj_t BgL_sz00_12141)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12138;obj_t BgL_bodyz00_12139;long BgL_siza7ezd2framez75_12140;
BgL_i1243z00_12138 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12137, 
(int)(((long)0)))); 
BgL_bodyz00_12139 = 
PROCEDURE_REF(BgL_envz00_12137, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12140 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12137, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14358;
BgL_bpz00_14358 = 
VECTOR_REF(
((obj_t)BgL_sz00_12141),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14359;
BgL_runz00_14359 = 
MAKE_FX_PROCEDURE(BGl_z62run5159z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14359, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12138)); 
PROCEDURE_SET(BgL_runz00_14359, 
(int)(((long)1)), BgL_bodyz00_12139); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14360;
BgL_mainz00_14360 = 
MAKE_VA_PROCEDURE(BGl_z62main5158z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14360, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12138)); 
PROCEDURE_SET(BgL_mainz00_14360, 
(int)(((long)1)), BgL_bodyz00_12139); 
PROCEDURE_SET(BgL_mainz00_14360, 
(int)(((long)2)), BgL_runz00_14359); 
PROCEDURE_SET(BgL_mainz00_14360, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12140)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14361;
BgL_objz00_14361 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14359, BgL_objz00_14361); BgL_objz00_14361; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3167z00_14362;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3168z00_14363;
BgL_arg3168z00_14363 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12138))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14364;
BgL_newz00_14364 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26573;
BgL_tmpz00_26573 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14364, BgL_tmpz00_26573, BgL_arg3168z00_14363); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26578;int BgL_tmpz00_26576;
BgL_auxz00_26578 = 
BINT(BgL_siza7ezd2framez75_12140); 
BgL_tmpz00_26576 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14364, BgL_tmpz00_26576, BgL_auxz00_26578); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26581;
BgL_tmpz00_26581 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14364, BgL_tmpz00_26581, BgL_runz00_14359); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26586;int BgL_tmpz00_26584;
BgL_auxz00_26586 = 
BINT(((long)-1)); 
BgL_tmpz00_26584 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14364, BgL_tmpz00_26584, BgL_auxz00_26586); } 
BgL_arg3167z00_14362 = BgL_newz00_14364; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14360, BgL_arg3167z00_14362); BgL_arg3167z00_14362; } 
return BgL_mainz00_14360;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5158 */
obj_t BGl_z62main5158z62zz__evaluate_compz00(obj_t BgL_envz00_12142, obj_t BgL_lastz00_12147)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12145;long BgL_siza7ezd2framez75_12146;
BgL_runz00_12145 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12142, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12146 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12142, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14365;
BgL_sz00_14365 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14366;
BgL_bpz00_14366 = 
VECTOR_REF(
((obj_t)BgL_sz00_14365),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14365, BgL_bpz00_14366, 
BINT(BgL_siza7ezd2framez75_12146)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3171z00_14367;
BgL_arg3171z00_14367 = 
(
(long)CINT(BgL_bpz00_14366)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14365),BgL_arg3171z00_14367,BgL_lastz00_12147); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14368;
BgL_ez00_14368 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14368, BgL_bpz00_14366); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14369;
BgL_accz00_14369 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12145, BgL_sz00_14365, BgL_bpz00_14366); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14368); 
VECTOR_SET(
((obj_t)BgL_sz00_14365),((long)0),BgL_bpz00_14366); 
return BgL_accz00_14369;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14370;
BgL_nsz00_14370 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14370,((long)1),BgL_sz00_14365); 
VECTOR_SET(BgL_nsz00_14370,((long)2),BgL_lastz00_12147); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14371;
BgL_z12denvz12_14371 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14371, BgL_nsz00_14370); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14372;
BgL_ez00_14372 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14372, BgL_sz00_14365); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14373;
BgL_____rz00_14373 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12145, BgL_nsz00_14370, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14372); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14371, BgL_sz00_14365); 
return BgL_____rz00_14373;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5159 */
obj_t BGl_z62run5159z62zz__evaluate_compz00(obj_t BgL_envz00_12148, obj_t BgL_sz00_12151)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12149;obj_t BgL_bodyz00_12150;
BgL_i1243z00_12149 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12148, 
(int)(((long)0)))); 
BgL_bodyz00_12150 = 
PROCEDURE_REF(BgL_envz00_12148, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14374;
BgL_bpz00_14374 = 
VECTOR_REF(
((obj_t)BgL_sz00_12151),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14375;obj_t BgL_wherez00_14376;obj_t BgL_locz00_14377;
BgL_z12denvz12_14375 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14376 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12149))->BgL_wherez00); 
BgL_locz00_14377 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12149))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14375, BgL_wherez00_14376, BgL_locz00_14377); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14378;
BgL_za2za2resza2za2z00_14378 = 
PROCEDURE_ENTRY(BgL_bodyz00_12150)(BgL_bodyz00_12150, BgL_sz00_12151, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14375); 
return BgL_za2za2resza2za2z00_14378;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3173> */
obj_t BGl_z62zc3anonymousza33173ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12152, obj_t BgL_sz00_12157)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12153;BgL_ev_absz00_bglt BgL_i1243z00_12154;obj_t BgL_bodyz00_12155;long BgL_siza7ezd2framez75_12156;
BgL_iboxesz00_12153 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12152, 
(int)(((long)0)))); 
BgL_i1243z00_12154 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12152, 
(int)(((long)1)))); 
BgL_bodyz00_12155 = 
PROCEDURE_REF(BgL_envz00_12152, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12156 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12152, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14379;
BgL_bpz00_14379 = 
VECTOR_REF(
((obj_t)BgL_sz00_12157),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14380;
BgL_runz00_14380 = 
MAKE_FX_PROCEDURE(BGl_z62run5161z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14380, 
(int)(((long)0)), BgL_iboxesz00_12153); 
PROCEDURE_SET(BgL_runz00_14380, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12154)); 
PROCEDURE_SET(BgL_runz00_14380, 
(int)(((long)2)), BgL_bodyz00_12155); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14381;
BgL_mainz00_14381 = 
MAKE_VA_PROCEDURE(BGl_z62main5160z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14381, 
(int)(((long)0)), BgL_iboxesz00_12153); 
PROCEDURE_SET(BgL_mainz00_14381, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12154)); 
PROCEDURE_SET(BgL_mainz00_14381, 
(int)(((long)2)), BgL_bodyz00_12155); 
PROCEDURE_SET(BgL_mainz00_14381, 
(int)(((long)3)), BgL_runz00_14380); 
PROCEDURE_SET(BgL_mainz00_14381, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12156)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14382;
BgL_objz00_14382 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14380, BgL_objz00_14382); BgL_objz00_14382; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3174z00_14383;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3175z00_14384;
BgL_arg3175z00_14384 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12154))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14385;
BgL_newz00_14385 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26681;
BgL_tmpz00_26681 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14385, BgL_tmpz00_26681, BgL_arg3175z00_14384); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26686;int BgL_tmpz00_26684;
BgL_auxz00_26686 = 
BINT(BgL_siza7ezd2framez75_12156); 
BgL_tmpz00_26684 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14385, BgL_tmpz00_26684, BgL_auxz00_26686); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26689;
BgL_tmpz00_26689 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14385, BgL_tmpz00_26689, BgL_runz00_14380); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26694;int BgL_tmpz00_26692;
BgL_auxz00_26694 = 
BINT(((long)-1)); 
BgL_tmpz00_26692 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14385, BgL_tmpz00_26692, BgL_auxz00_26694); } 
BgL_arg3174z00_14383 = BgL_newz00_14385; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14381, BgL_arg3174z00_14383); BgL_arg3174z00_14383; } 
return BgL_mainz00_14381;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5160 */
obj_t BGl_z62main5160z62zz__evaluate_compz00(obj_t BgL_envz00_12158, obj_t BgL_lastz00_12164)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12162;long BgL_siza7ezd2framez75_12163;
BgL_runz00_12162 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12158, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12163 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12158, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14386;
BgL_sz00_14386 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14387;
BgL_bpz00_14387 = 
VECTOR_REF(
((obj_t)BgL_sz00_14386),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14386, BgL_bpz00_14387, 
BINT(BgL_siza7ezd2framez75_12163)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3178z00_14388;
BgL_arg3178z00_14388 = 
(
(long)CINT(BgL_bpz00_14387)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14386),BgL_arg3178z00_14388,BgL_lastz00_12164); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14389;
BgL_ez00_14389 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14389, BgL_bpz00_14387); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14390;
BgL_accz00_14390 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12162, BgL_sz00_14386, BgL_bpz00_14387); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14389); 
VECTOR_SET(
((obj_t)BgL_sz00_14386),((long)0),BgL_bpz00_14387); 
return BgL_accz00_14390;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14391;
BgL_nsz00_14391 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14391,((long)1),BgL_sz00_14386); 
VECTOR_SET(BgL_nsz00_14391,((long)2),BgL_lastz00_12164); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14392;
BgL_z12denvz12_14392 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14392, BgL_nsz00_14391); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14393;
BgL_ez00_14393 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14393, BgL_sz00_14386); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14394;
BgL_____rz00_14394 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12162, BgL_nsz00_14391, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14393); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14392, BgL_sz00_14386); 
return BgL_____rz00_14394;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5161 */
obj_t BGl_z62run5161z62zz__evaluate_compz00(obj_t BgL_envz00_12165, obj_t BgL_sz00_12169)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12166;BgL_ev_absz00_bglt BgL_i1243z00_12167;obj_t BgL_bodyz00_12168;
BgL_iboxesz00_12166 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12165, 
(int)(((long)0)))); 
BgL_i1243z00_12167 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12165, 
(int)(((long)1)))); 
BgL_bodyz00_12168 = 
PROCEDURE_REF(BgL_envz00_12165, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14395;
BgL_bpz00_14395 = 
VECTOR_REF(
((obj_t)BgL_sz00_12169),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12169, BgL_iboxesz00_12166, BgL_bpz00_14395); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14396;obj_t BgL_wherez00_14397;obj_t BgL_locz00_14398;
BgL_z12denvz12_14396 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14397 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12167))->BgL_wherez00); 
BgL_locz00_14398 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12167))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14396, BgL_wherez00_14397, BgL_locz00_14398); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14399;
BgL_za2za2resza2za2z00_14399 = 
PROCEDURE_ENTRY(BgL_bodyz00_12168)(BgL_bodyz00_12168, BgL_sz00_12169, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14396); 
return BgL_za2za2resza2za2z00_14399;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3183> */
obj_t BGl_z62zc3anonymousza33183ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12170, obj_t BgL_sz00_12176)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12171;long BgL_siza7eza7_12172;BgL_ev_absz00_bglt BgL_i1243z00_12173;obj_t BgL_bodyz00_12174;long BgL_siza7ezd2framez75_12175;
BgL_ifreesz00_12171 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12170, 
(int)(((long)0)))); 
BgL_siza7eza7_12172 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12170, 
(int)(((long)1)))); 
BgL_i1243z00_12173 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12170, 
(int)(((long)2)))); 
BgL_bodyz00_12174 = 
PROCEDURE_REF(BgL_envz00_12170, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12175 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12170, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14400;
BgL_bpz00_14400 = 
VECTOR_REF(
((obj_t)BgL_sz00_12176),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14401;
BgL_valza2za2_14401 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12176, BgL_bpz00_14400, BgL_ifreesz00_12171); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14402;
BgL_runz00_14402 = 
MAKE_FX_PROCEDURE(BGl_z62run5163z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14402, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12172)); 
PROCEDURE_SET(BgL_runz00_14402, 
(int)(((long)1)), BgL_valza2za2_14401); 
PROCEDURE_SET(BgL_runz00_14402, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12173)); 
PROCEDURE_SET(BgL_runz00_14402, 
(int)(((long)3)), BgL_bodyz00_12174); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14403;
BgL_mainz00_14403 = 
MAKE_VA_PROCEDURE(BGl_z62main5162z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14403, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12172)); 
PROCEDURE_SET(BgL_mainz00_14403, 
(int)(((long)1)), BgL_valza2za2_14401); 
PROCEDURE_SET(BgL_mainz00_14403, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12173)); 
PROCEDURE_SET(BgL_mainz00_14403, 
(int)(((long)3)), BgL_bodyz00_12174); 
PROCEDURE_SET(BgL_mainz00_14403, 
(int)(((long)4)), BgL_runz00_14402); 
PROCEDURE_SET(BgL_mainz00_14403, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12175)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14404;
BgL_objz00_14404 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14402, BgL_objz00_14404); BgL_objz00_14404; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3184z00_14405;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3185z00_14406;
BgL_arg3185z00_14406 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12173))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14407;
BgL_newz00_14407 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26803;
BgL_tmpz00_26803 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14407, BgL_tmpz00_26803, BgL_arg3185z00_14406); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26808;int BgL_tmpz00_26806;
BgL_auxz00_26808 = 
BINT(BgL_siza7ezd2framez75_12175); 
BgL_tmpz00_26806 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14407, BgL_tmpz00_26806, BgL_auxz00_26808); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26811;
BgL_tmpz00_26811 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14407, BgL_tmpz00_26811, BgL_runz00_14402); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26816;int BgL_tmpz00_26814;
BgL_auxz00_26816 = 
BINT(((long)-1)); 
BgL_tmpz00_26814 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14407, BgL_tmpz00_26814, BgL_auxz00_26816); } 
BgL_arg3184z00_14405 = BgL_newz00_14407; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14403, BgL_arg3184z00_14405); BgL_arg3184z00_14405; } 
return BgL_mainz00_14403;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5162 */
obj_t BGl_z62main5162z62zz__evaluate_compz00(obj_t BgL_envz00_12177, obj_t BgL_lastz00_12184)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12182;long BgL_siza7ezd2framez75_12183;
BgL_runz00_12182 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12177, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12183 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12177, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14408;
BgL_sz00_14408 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14409;
BgL_bpz00_14409 = 
VECTOR_REF(
((obj_t)BgL_sz00_14408),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14408, BgL_bpz00_14409, 
BINT(BgL_siza7ezd2framez75_12183)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3188z00_14410;
BgL_arg3188z00_14410 = 
(
(long)CINT(BgL_bpz00_14409)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14408),BgL_arg3188z00_14410,BgL_lastz00_12184); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14411;
BgL_ez00_14411 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14411, BgL_bpz00_14409); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14412;
BgL_accz00_14412 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12182, BgL_sz00_14408, BgL_bpz00_14409); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14411); 
VECTOR_SET(
((obj_t)BgL_sz00_14408),((long)0),BgL_bpz00_14409); 
return BgL_accz00_14412;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14413;
BgL_nsz00_14413 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14413,((long)1),BgL_sz00_14408); 
VECTOR_SET(BgL_nsz00_14413,((long)2),BgL_lastz00_12184); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14414;
BgL_z12denvz12_14414 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14414, BgL_nsz00_14413); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14415;
BgL_ez00_14415 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14415, BgL_sz00_14408); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14416;
BgL_____rz00_14416 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12182, BgL_nsz00_14413, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14415); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14414, BgL_sz00_14408); 
return BgL_____rz00_14416;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5163 */
obj_t BGl_z62run5163z62zz__evaluate_compz00(obj_t BgL_envz00_12185, obj_t BgL_sz00_12190)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_12186;obj_t BgL_valza2za2_12187;BgL_ev_absz00_bglt BgL_i1243z00_12188;obj_t BgL_bodyz00_12189;
BgL_siza7eza7_12186 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12185, 
(int)(((long)0)))); 
BgL_valza2za2_12187 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12185, 
(int)(((long)1)))); 
BgL_i1243z00_12188 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12185, 
(int)(((long)2)))); 
BgL_bodyz00_12189 = 
PROCEDURE_REF(BgL_envz00_12185, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14417;
BgL_bpz00_14417 = 
VECTOR_REF(
((obj_t)BgL_sz00_12190),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12190, BgL_valza2za2_12187, 
(
(long)CINT(BgL_bpz00_14417)+BgL_siza7eza7_12186)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14418;obj_t BgL_wherez00_14419;obj_t BgL_locz00_14420;
BgL_z12denvz12_14418 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14419 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12188))->BgL_wherez00); 
BgL_locz00_14420 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12188))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14418, BgL_wherez00_14419, BgL_locz00_14420); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14421;
BgL_za2za2resza2za2z00_14421 = 
PROCEDURE_ENTRY(BgL_bodyz00_12189)(BgL_bodyz00_12189, BgL_sz00_12190, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14418); 
return BgL_za2za2resza2za2z00_14421;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3191> */
obj_t BGl_z62zc3anonymousza33191ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12191, obj_t BgL_sz00_12198)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12192;obj_t BgL_iboxesz00_12193;long BgL_siza7eza7_12194;BgL_ev_absz00_bglt BgL_i1243z00_12195;obj_t BgL_bodyz00_12196;long BgL_siza7ezd2framez75_12197;
BgL_ifreesz00_12192 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)0)))); 
BgL_iboxesz00_12193 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)1)))); 
BgL_siza7eza7_12194 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)2)))); 
BgL_i1243z00_12195 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)3)))); 
BgL_bodyz00_12196 = 
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12197 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12191, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14422;
BgL_bpz00_14422 = 
VECTOR_REF(
((obj_t)BgL_sz00_12198),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14423;
BgL_valza2za2_14423 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12198, BgL_bpz00_14422, BgL_ifreesz00_12192); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14424;
BgL_runz00_14424 = 
MAKE_FX_PROCEDURE(BGl_z62run5165z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14424, 
(int)(((long)0)), BgL_iboxesz00_12193); 
PROCEDURE_SET(BgL_runz00_14424, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12194)); 
PROCEDURE_SET(BgL_runz00_14424, 
(int)(((long)2)), BgL_valza2za2_14423); 
PROCEDURE_SET(BgL_runz00_14424, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12195)); 
PROCEDURE_SET(BgL_runz00_14424, 
(int)(((long)4)), BgL_bodyz00_12196); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14425;
BgL_mainz00_14425 = 
MAKE_VA_PROCEDURE(BGl_z62main5164z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)0)), BgL_iboxesz00_12193); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12194)); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)2)), BgL_valza2za2_14423); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12195)); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)4)), BgL_bodyz00_12196); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)5)), BgL_runz00_14424); 
PROCEDURE_SET(BgL_mainz00_14425, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12197)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14426;
BgL_objz00_14426 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14424, BgL_objz00_14426); BgL_objz00_14426; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3192z00_14427;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3193z00_14428;
BgL_arg3193z00_14428 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12195))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14429;
BgL_newz00_14429 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26937;
BgL_tmpz00_26937 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14429, BgL_tmpz00_26937, BgL_arg3193z00_14428); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26942;int BgL_tmpz00_26940;
BgL_auxz00_26942 = 
BINT(BgL_siza7ezd2framez75_12197); 
BgL_tmpz00_26940 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14429, BgL_tmpz00_26940, BgL_auxz00_26942); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_26945;
BgL_tmpz00_26945 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14429, BgL_tmpz00_26945, BgL_runz00_14424); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_26950;int BgL_tmpz00_26948;
BgL_auxz00_26950 = 
BINT(((long)-1)); 
BgL_tmpz00_26948 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14429, BgL_tmpz00_26948, BgL_auxz00_26950); } 
BgL_arg3192z00_14427 = BgL_newz00_14429; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14425, BgL_arg3192z00_14427); BgL_arg3192z00_14427; } 
return BgL_mainz00_14425;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5164 */
obj_t BGl_z62main5164z62zz__evaluate_compz00(obj_t BgL_envz00_12199, obj_t BgL_lastz00_12207)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12205;long BgL_siza7ezd2framez75_12206;
BgL_runz00_12205 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12199, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12206 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12199, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14430;
BgL_sz00_14430 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14431;
BgL_bpz00_14431 = 
VECTOR_REF(
((obj_t)BgL_sz00_14430),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14430, BgL_bpz00_14431, 
BINT(BgL_siza7ezd2framez75_12206)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3196z00_14432;
BgL_arg3196z00_14432 = 
(
(long)CINT(BgL_bpz00_14431)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14430),BgL_arg3196z00_14432,BgL_lastz00_12207); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14433;
BgL_ez00_14433 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14433, BgL_bpz00_14431); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14434;
BgL_accz00_14434 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12205, BgL_sz00_14430, BgL_bpz00_14431); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14433); 
VECTOR_SET(
((obj_t)BgL_sz00_14430),((long)0),BgL_bpz00_14431); 
return BgL_accz00_14434;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14435;
BgL_nsz00_14435 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14435,((long)1),BgL_sz00_14430); 
VECTOR_SET(BgL_nsz00_14435,((long)2),BgL_lastz00_12207); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14436;
BgL_z12denvz12_14436 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14436, BgL_nsz00_14435); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14437;
BgL_ez00_14437 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14437, BgL_sz00_14430); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14438;
BgL_____rz00_14438 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12205, BgL_nsz00_14435, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14437); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14436, BgL_sz00_14430); 
return BgL_____rz00_14438;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5165 */
obj_t BGl_z62run5165z62zz__evaluate_compz00(obj_t BgL_envz00_12208, obj_t BgL_sz00_12214)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12209;long BgL_siza7eza7_12210;obj_t BgL_valza2za2_12211;BgL_ev_absz00_bglt BgL_i1243z00_12212;obj_t BgL_bodyz00_12213;
BgL_iboxesz00_12209 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12208, 
(int)(((long)0)))); 
BgL_siza7eza7_12210 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12208, 
(int)(((long)1)))); 
BgL_valza2za2_12211 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12208, 
(int)(((long)2)))); 
BgL_i1243z00_12212 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12208, 
(int)(((long)3)))); 
BgL_bodyz00_12213 = 
PROCEDURE_REF(BgL_envz00_12208, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14439;
BgL_bpz00_14439 = 
VECTOR_REF(
((obj_t)BgL_sz00_12214),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12214, BgL_iboxesz00_12209, BgL_bpz00_14439); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12214, BgL_valza2za2_12211, 
(
(long)CINT(BgL_bpz00_14439)+BgL_siza7eza7_12210)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14440;obj_t BgL_wherez00_14441;obj_t BgL_locz00_14442;
BgL_z12denvz12_14440 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14441 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12212))->BgL_wherez00); 
BgL_locz00_14442 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12212))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14440, BgL_wherez00_14441, BgL_locz00_14442); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14443;
BgL_za2za2resza2za2z00_14443 = 
PROCEDURE_ENTRY(BgL_bodyz00_12213)(BgL_bodyz00_12213, BgL_sz00_12214, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14440); 
return BgL_za2za2resza2za2z00_14443;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3131> */
obj_t BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12215, obj_t BgL_sz00_12219)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12216;obj_t BgL_bodyz00_12217;long BgL_siza7ezd2framez75_12218;
BgL_i1243z00_12216 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12215, 
(int)(((long)0)))); 
BgL_bodyz00_12217 = 
PROCEDURE_REF(BgL_envz00_12215, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12218 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12215, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14444;
BgL_bpz00_14444 = 
VECTOR_REF(
((obj_t)BgL_sz00_12219),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14445;
BgL_runz00_14445 = 
MAKE_FX_PROCEDURE(BGl_z62run5167z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14445, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12216)); 
PROCEDURE_SET(BgL_runz00_14445, 
(int)(((long)1)), BgL_bodyz00_12217); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14446;
BgL_mainz00_14446 = 
MAKE_FX_PROCEDURE(BGl_z62main5166z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14446, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12216)); 
PROCEDURE_SET(BgL_mainz00_14446, 
(int)(((long)1)), BgL_bodyz00_12217); 
PROCEDURE_SET(BgL_mainz00_14446, 
(int)(((long)2)), BgL_runz00_14445); 
PROCEDURE_SET(BgL_mainz00_14446, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12218)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14447;
BgL_objz00_14447 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14445, BgL_objz00_14447); BgL_objz00_14447; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3132z00_14448;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3133z00_14449;
BgL_arg3133z00_14449 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12216))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14450;
BgL_newz00_14450 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27051;
BgL_tmpz00_27051 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14450, BgL_tmpz00_27051, BgL_arg3133z00_14449); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27056;int BgL_tmpz00_27054;
BgL_auxz00_27056 = 
BINT(BgL_siza7ezd2framez75_12218); 
BgL_tmpz00_27054 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14450, BgL_tmpz00_27054, BgL_auxz00_27056); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27059;
BgL_tmpz00_27059 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14450, BgL_tmpz00_27059, BgL_runz00_14445); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27064;int BgL_tmpz00_27062;
BgL_auxz00_27064 = 
BINT(((long)0)); 
BgL_tmpz00_27062 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14450, BgL_tmpz00_27062, BgL_auxz00_27064); } 
BgL_arg3132z00_14448 = BgL_newz00_14450; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14446, BgL_arg3132z00_14448); BgL_arg3132z00_14448; } 
return BgL_mainz00_14446;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5166 */
obj_t BGl_z62main5166z62zz__evaluate_compz00(obj_t BgL_envz00_12220)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12223;long BgL_siza7ezd2framez75_12224;
BgL_runz00_12223 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12220, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12224 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12220, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14451;
BgL_sz00_14451 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14452;
BgL_bpz00_14452 = 
VECTOR_REF(
((obj_t)BgL_sz00_14451),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14451, BgL_bpz00_14452, 
BINT(BgL_siza7ezd2framez75_12224)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14453;
BgL_ez00_14453 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14453, BgL_bpz00_14452); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14454;
BgL_accz00_14454 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12223, BgL_sz00_14451, BgL_bpz00_14452); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14453); 
VECTOR_SET(
((obj_t)BgL_sz00_14451),((long)0),BgL_bpz00_14452); 
return BgL_accz00_14454;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14455;
BgL_nsz00_14455 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14455,((long)1),BgL_sz00_14451); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14456;
BgL_z12denvz12_14456 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14456, BgL_nsz00_14455); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14457;
BgL_ez00_14457 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14457, BgL_sz00_14451); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14458;
BgL_____rz00_14458 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12223, BgL_nsz00_14455, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14457); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14456, BgL_sz00_14451); 
return BgL_____rz00_14458;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5167 */
obj_t BGl_z62run5167z62zz__evaluate_compz00(obj_t BgL_envz00_12225, obj_t BgL_sz00_12228)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12226;obj_t BgL_bodyz00_12227;
BgL_i1243z00_12226 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12225, 
(int)(((long)0)))); 
BgL_bodyz00_12227 = 
PROCEDURE_REF(BgL_envz00_12225, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14459;
BgL_bpz00_14459 = 
VECTOR_REF(
((obj_t)BgL_sz00_12228),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14460;obj_t BgL_wherez00_14461;obj_t BgL_locz00_14462;
BgL_z12denvz12_14460 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14461 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12226))->BgL_wherez00); 
BgL_locz00_14462 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12226))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14460, BgL_wherez00_14461, BgL_locz00_14462); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14463;
BgL_za2za2resza2za2z00_14463 = 
PROCEDURE_ENTRY(BgL_bodyz00_12227)(BgL_bodyz00_12227, BgL_sz00_12228, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14460); 
return BgL_za2za2resza2za2z00_14463;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3137> */
obj_t BGl_z62zc3anonymousza33137ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12229, obj_t BgL_sz00_12234)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12230;BgL_ev_absz00_bglt BgL_i1243z00_12231;obj_t BgL_bodyz00_12232;long BgL_siza7ezd2framez75_12233;
BgL_iboxesz00_12230 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12229, 
(int)(((long)0)))); 
BgL_i1243z00_12231 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12229, 
(int)(((long)1)))); 
BgL_bodyz00_12232 = 
PROCEDURE_REF(BgL_envz00_12229, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12233 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12229, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14464;
BgL_bpz00_14464 = 
VECTOR_REF(
((obj_t)BgL_sz00_12234),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14465;
BgL_runz00_14465 = 
MAKE_FX_PROCEDURE(BGl_z62run5169z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14465, 
(int)(((long)0)), BgL_iboxesz00_12230); 
PROCEDURE_SET(BgL_runz00_14465, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12231)); 
PROCEDURE_SET(BgL_runz00_14465, 
(int)(((long)2)), BgL_bodyz00_12232); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14466;
BgL_mainz00_14466 = 
MAKE_FX_PROCEDURE(BGl_z62main5168z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14466, 
(int)(((long)0)), BgL_iboxesz00_12230); 
PROCEDURE_SET(BgL_mainz00_14466, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12231)); 
PROCEDURE_SET(BgL_mainz00_14466, 
(int)(((long)2)), BgL_bodyz00_12232); 
PROCEDURE_SET(BgL_mainz00_14466, 
(int)(((long)3)), BgL_runz00_14465); 
PROCEDURE_SET(BgL_mainz00_14466, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12233)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14467;
BgL_objz00_14467 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14465, BgL_objz00_14467); BgL_objz00_14467; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3138z00_14468;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3139z00_14469;
BgL_arg3139z00_14469 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12231))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14470;
BgL_newz00_14470 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27154;
BgL_tmpz00_27154 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14470, BgL_tmpz00_27154, BgL_arg3139z00_14469); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27159;int BgL_tmpz00_27157;
BgL_auxz00_27159 = 
BINT(BgL_siza7ezd2framez75_12233); 
BgL_tmpz00_27157 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14470, BgL_tmpz00_27157, BgL_auxz00_27159); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27162;
BgL_tmpz00_27162 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14470, BgL_tmpz00_27162, BgL_runz00_14465); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27167;int BgL_tmpz00_27165;
BgL_auxz00_27167 = 
BINT(((long)0)); 
BgL_tmpz00_27165 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14470, BgL_tmpz00_27165, BgL_auxz00_27167); } 
BgL_arg3138z00_14468 = BgL_newz00_14470; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14466, BgL_arg3138z00_14468); BgL_arg3138z00_14468; } 
return BgL_mainz00_14466;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5168 */
obj_t BGl_z62main5168z62zz__evaluate_compz00(obj_t BgL_envz00_12235)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12239;long BgL_siza7ezd2framez75_12240;
BgL_runz00_12239 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12235, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12240 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12235, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14471;
BgL_sz00_14471 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14472;
BgL_bpz00_14472 = 
VECTOR_REF(
((obj_t)BgL_sz00_14471),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14471, BgL_bpz00_14472, 
BINT(BgL_siza7ezd2framez75_12240)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14473;
BgL_ez00_14473 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14473, BgL_bpz00_14472); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14474;
BgL_accz00_14474 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12239, BgL_sz00_14471, BgL_bpz00_14472); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14473); 
VECTOR_SET(
((obj_t)BgL_sz00_14471),((long)0),BgL_bpz00_14472); 
return BgL_accz00_14474;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14475;
BgL_nsz00_14475 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14475,((long)1),BgL_sz00_14471); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14476;
BgL_z12denvz12_14476 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14476, BgL_nsz00_14475); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14477;
BgL_ez00_14477 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14477, BgL_sz00_14471); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14478;
BgL_____rz00_14478 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12239, BgL_nsz00_14475, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14477); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14476, BgL_sz00_14471); 
return BgL_____rz00_14478;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5169 */
obj_t BGl_z62run5169z62zz__evaluate_compz00(obj_t BgL_envz00_12241, obj_t BgL_sz00_12245)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12242;BgL_ev_absz00_bglt BgL_i1243z00_12243;obj_t BgL_bodyz00_12244;
BgL_iboxesz00_12242 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12241, 
(int)(((long)0)))); 
BgL_i1243z00_12243 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12241, 
(int)(((long)1)))); 
BgL_bodyz00_12244 = 
PROCEDURE_REF(BgL_envz00_12241, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14479;
BgL_bpz00_14479 = 
VECTOR_REF(
((obj_t)BgL_sz00_12245),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12245, BgL_iboxesz00_12242, BgL_bpz00_14479); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14480;obj_t BgL_wherez00_14481;obj_t BgL_locz00_14482;
BgL_z12denvz12_14480 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14481 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12243))->BgL_wherez00); 
BgL_locz00_14482 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12243))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14480, BgL_wherez00_14481, BgL_locz00_14482); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14483;
BgL_za2za2resza2za2z00_14483 = 
PROCEDURE_ENTRY(BgL_bodyz00_12244)(BgL_bodyz00_12244, BgL_sz00_12245, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14480); 
return BgL_za2za2resza2za2z00_14483;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3146> */
obj_t BGl_z62zc3anonymousza33146ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12246, obj_t BgL_sz00_12252)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12247;long BgL_siza7eza7_12248;BgL_ev_absz00_bglt BgL_i1243z00_12249;obj_t BgL_bodyz00_12250;long BgL_siza7ezd2framez75_12251;
BgL_ifreesz00_12247 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12246, 
(int)(((long)0)))); 
BgL_siza7eza7_12248 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12246, 
(int)(((long)1)))); 
BgL_i1243z00_12249 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12246, 
(int)(((long)2)))); 
BgL_bodyz00_12250 = 
PROCEDURE_REF(BgL_envz00_12246, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12251 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12246, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14484;
BgL_bpz00_14484 = 
VECTOR_REF(
((obj_t)BgL_sz00_12252),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14485;
BgL_valza2za2_14485 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12252, BgL_bpz00_14484, BgL_ifreesz00_12247); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14486;
BgL_runz00_14486 = 
MAKE_FX_PROCEDURE(BGl_z62run5171z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14486, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12248)); 
PROCEDURE_SET(BgL_runz00_14486, 
(int)(((long)1)), BgL_valza2za2_14485); 
PROCEDURE_SET(BgL_runz00_14486, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12249)); 
PROCEDURE_SET(BgL_runz00_14486, 
(int)(((long)3)), BgL_bodyz00_12250); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14487;
BgL_mainz00_14487 = 
MAKE_FX_PROCEDURE(BGl_z62main5170z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14487, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12248)); 
PROCEDURE_SET(BgL_mainz00_14487, 
(int)(((long)1)), BgL_valza2za2_14485); 
PROCEDURE_SET(BgL_mainz00_14487, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12249)); 
PROCEDURE_SET(BgL_mainz00_14487, 
(int)(((long)3)), BgL_bodyz00_12250); 
PROCEDURE_SET(BgL_mainz00_14487, 
(int)(((long)4)), BgL_runz00_14486); 
PROCEDURE_SET(BgL_mainz00_14487, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12251)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14488;
BgL_objz00_14488 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14486, BgL_objz00_14488); BgL_objz00_14488; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3147z00_14489;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3148z00_14490;
BgL_arg3148z00_14490 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12249))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14491;
BgL_newz00_14491 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27271;
BgL_tmpz00_27271 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14491, BgL_tmpz00_27271, BgL_arg3148z00_14490); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27276;int BgL_tmpz00_27274;
BgL_auxz00_27276 = 
BINT(BgL_siza7ezd2framez75_12251); 
BgL_tmpz00_27274 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14491, BgL_tmpz00_27274, BgL_auxz00_27276); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27279;
BgL_tmpz00_27279 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14491, BgL_tmpz00_27279, BgL_runz00_14486); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27284;int BgL_tmpz00_27282;
BgL_auxz00_27284 = 
BINT(((long)0)); 
BgL_tmpz00_27282 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14491, BgL_tmpz00_27282, BgL_auxz00_27284); } 
BgL_arg3147z00_14489 = BgL_newz00_14491; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14487, BgL_arg3147z00_14489); BgL_arg3147z00_14489; } 
return BgL_mainz00_14487;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5170 */
obj_t BGl_z62main5170z62zz__evaluate_compz00(obj_t BgL_envz00_12253)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12258;long BgL_siza7ezd2framez75_12259;
BgL_runz00_12258 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12253, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12259 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12253, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14492;
BgL_sz00_14492 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14493;
BgL_bpz00_14493 = 
VECTOR_REF(
((obj_t)BgL_sz00_14492),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14492, BgL_bpz00_14493, 
BINT(BgL_siza7ezd2framez75_12259)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14494;
BgL_ez00_14494 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14494, BgL_bpz00_14493); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14495;
BgL_accz00_14495 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12258, BgL_sz00_14492, BgL_bpz00_14493); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14494); 
VECTOR_SET(
((obj_t)BgL_sz00_14492),((long)0),BgL_bpz00_14493); 
return BgL_accz00_14495;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14496;
BgL_nsz00_14496 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14496,((long)1),BgL_sz00_14492); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14497;
BgL_z12denvz12_14497 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14497, BgL_nsz00_14496); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14498;
BgL_ez00_14498 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14498, BgL_sz00_14492); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14499;
BgL_____rz00_14499 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12258, BgL_nsz00_14496, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14498); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14497, BgL_sz00_14492); 
return BgL_____rz00_14499;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5171 */
obj_t BGl_z62run5171z62zz__evaluate_compz00(obj_t BgL_envz00_12260, obj_t BgL_sz00_12265)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_12261;obj_t BgL_valza2za2_12262;BgL_ev_absz00_bglt BgL_i1243z00_12263;obj_t BgL_bodyz00_12264;
BgL_siza7eza7_12261 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12260, 
(int)(((long)0)))); 
BgL_valza2za2_12262 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12260, 
(int)(((long)1)))); 
BgL_i1243z00_12263 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12260, 
(int)(((long)2)))); 
BgL_bodyz00_12264 = 
PROCEDURE_REF(BgL_envz00_12260, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14500;
BgL_bpz00_14500 = 
VECTOR_REF(
((obj_t)BgL_sz00_12265),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12265, BgL_valza2za2_12262, 
(
(long)CINT(BgL_bpz00_14500)+BgL_siza7eza7_12261)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14501;obj_t BgL_wherez00_14502;obj_t BgL_locz00_14503;
BgL_z12denvz12_14501 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14502 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12263))->BgL_wherez00); 
BgL_locz00_14503 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12263))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14501, BgL_wherez00_14502, BgL_locz00_14503); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14504;
BgL_za2za2resza2za2z00_14504 = 
PROCEDURE_ENTRY(BgL_bodyz00_12264)(BgL_bodyz00_12264, BgL_sz00_12265, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14501); 
return BgL_za2za2resza2za2z00_14504;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3153> */
obj_t BGl_z62zc3anonymousza33153ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12266, obj_t BgL_sz00_12273)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12267;obj_t BgL_iboxesz00_12268;long BgL_siza7eza7_12269;BgL_ev_absz00_bglt BgL_i1243z00_12270;obj_t BgL_bodyz00_12271;long BgL_siza7ezd2framez75_12272;
BgL_ifreesz00_12267 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)0)))); 
BgL_iboxesz00_12268 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)1)))); 
BgL_siza7eza7_12269 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)2)))); 
BgL_i1243z00_12270 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)3)))); 
BgL_bodyz00_12271 = 
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12272 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12266, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14505;
BgL_bpz00_14505 = 
VECTOR_REF(
((obj_t)BgL_sz00_12273),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14506;
BgL_valza2za2_14506 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12273, BgL_bpz00_14505, BgL_ifreesz00_12267); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14507;
BgL_runz00_14507 = 
MAKE_FX_PROCEDURE(BGl_z62run5173z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14507, 
(int)(((long)0)), BgL_iboxesz00_12268); 
PROCEDURE_SET(BgL_runz00_14507, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12269)); 
PROCEDURE_SET(BgL_runz00_14507, 
(int)(((long)2)), BgL_valza2za2_14506); 
PROCEDURE_SET(BgL_runz00_14507, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12270)); 
PROCEDURE_SET(BgL_runz00_14507, 
(int)(((long)4)), BgL_bodyz00_12271); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14508;
BgL_mainz00_14508 = 
MAKE_FX_PROCEDURE(BGl_z62main5172z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)0)), BgL_iboxesz00_12268); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12269)); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)2)), BgL_valza2za2_14506); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12270)); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)4)), BgL_bodyz00_12271); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)5)), BgL_runz00_14507); 
PROCEDURE_SET(BgL_mainz00_14508, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12272)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14509;
BgL_objz00_14509 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14507, BgL_objz00_14509); BgL_objz00_14509; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3154z00_14510;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3155z00_14511;
BgL_arg3155z00_14511 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12270))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14512;
BgL_newz00_14512 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27400;
BgL_tmpz00_27400 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14512, BgL_tmpz00_27400, BgL_arg3155z00_14511); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27405;int BgL_tmpz00_27403;
BgL_auxz00_27405 = 
BINT(BgL_siza7ezd2framez75_12272); 
BgL_tmpz00_27403 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14512, BgL_tmpz00_27403, BgL_auxz00_27405); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27408;
BgL_tmpz00_27408 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14512, BgL_tmpz00_27408, BgL_runz00_14507); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27413;int BgL_tmpz00_27411;
BgL_auxz00_27413 = 
BINT(((long)0)); 
BgL_tmpz00_27411 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14512, BgL_tmpz00_27411, BgL_auxz00_27413); } 
BgL_arg3154z00_14510 = BgL_newz00_14512; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14508, BgL_arg3154z00_14510); BgL_arg3154z00_14510; } 
return BgL_mainz00_14508;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5172 */
obj_t BGl_z62main5172z62zz__evaluate_compz00(obj_t BgL_envz00_12274)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_12280;long BgL_siza7ezd2framez75_12281;
BgL_runz00_12280 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12281 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12274, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14513;
BgL_sz00_14513 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14514;
BgL_bpz00_14514 = 
VECTOR_REF(
((obj_t)BgL_sz00_14513),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14513, BgL_bpz00_14514, 
BINT(BgL_siza7ezd2framez75_12281)))
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14515;
BgL_ez00_14515 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14515, BgL_bpz00_14514); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14516;
BgL_accz00_14516 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12280, BgL_sz00_14513, BgL_bpz00_14514); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14515); 
VECTOR_SET(
((obj_t)BgL_sz00_14513),((long)0),BgL_bpz00_14514); 
return BgL_accz00_14516;} }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14517;
BgL_nsz00_14517 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14517,((long)1),BgL_sz00_14513); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14518;
BgL_z12denvz12_14518 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14518, BgL_nsz00_14517); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14519;
BgL_ez00_14519 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14519, BgL_sz00_14513); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14520;
BgL_____rz00_14520 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12280, BgL_nsz00_14517, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14519); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14518, BgL_sz00_14513); 
return BgL_____rz00_14520;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5173 */
obj_t BGl_z62run5173z62zz__evaluate_compz00(obj_t BgL_envz00_12282, obj_t BgL_sz00_12288)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12283;long BgL_siza7eza7_12284;obj_t BgL_valza2za2_12285;BgL_ev_absz00_bglt BgL_i1243z00_12286;obj_t BgL_bodyz00_12287;
BgL_iboxesz00_12283 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12282, 
(int)(((long)0)))); 
BgL_siza7eza7_12284 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12282, 
(int)(((long)1)))); 
BgL_valza2za2_12285 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12282, 
(int)(((long)2)))); 
BgL_i1243z00_12286 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12282, 
(int)(((long)3)))); 
BgL_bodyz00_12287 = 
PROCEDURE_REF(BgL_envz00_12282, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14521;
BgL_bpz00_14521 = 
VECTOR_REF(
((obj_t)BgL_sz00_12288),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12288, BgL_iboxesz00_12283, BgL_bpz00_14521); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12288, BgL_valza2za2_12285, 
(
(long)CINT(BgL_bpz00_14521)+BgL_siza7eza7_12284)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14522;obj_t BgL_wherez00_14523;obj_t BgL_locz00_14524;
BgL_z12denvz12_14522 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14523 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12286))->BgL_wherez00); 
BgL_locz00_14524 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12286))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14522, BgL_wherez00_14523, BgL_locz00_14524); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14525;
BgL_za2za2resza2za2z00_14525 = 
PROCEDURE_ENTRY(BgL_bodyz00_12287)(BgL_bodyz00_12287, BgL_sz00_12288, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14522); 
return BgL_za2za2resza2za2z00_14525;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3581> */
obj_t BGl_z62zc3anonymousza33581ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12289, obj_t BgL_sz00_12293)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12290;obj_t BgL_bodyz00_12291;long BgL_siza7ezd2framez75_12292;
BgL_i1243z00_12290 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12289, 
(int)(((long)0)))); 
BgL_bodyz00_12291 = 
PROCEDURE_REF(BgL_envz00_12289, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12292 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12289, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14526;
BgL_bpz00_14526 = 
VECTOR_REF(
((obj_t)BgL_sz00_12293),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14527;
BgL_runz00_14527 = 
MAKE_FX_PROCEDURE(BGl_z62run5175z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14527, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12290)); 
PROCEDURE_SET(BgL_runz00_14527, 
(int)(((long)1)), BgL_bodyz00_12291); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14528;
BgL_mainz00_14528 = 
MAKE_VA_PROCEDURE(BGl_z62main5174z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14528, 
(int)(((long)0)), BgL_bodyz00_12291); 
PROCEDURE_SET(BgL_mainz00_14528, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12290)); 
PROCEDURE_SET(BgL_mainz00_14528, 
(int)(((long)2)), BgL_runz00_14527); 
PROCEDURE_SET(BgL_mainz00_14528, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12292)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14529;
BgL_objz00_14529 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14527, BgL_objz00_14529); BgL_objz00_14529; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3582z00_14530;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3583z00_14531;obj_t BgL_arg3584z00_14532;
BgL_arg3583z00_14531 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12290))->BgL_arityz00); 
BgL_arg3584z00_14532 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12290))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14533;
BgL_newz00_14533 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27510;
BgL_tmpz00_27510 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14533, BgL_tmpz00_27510, BgL_arg3584z00_14532); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27515;int BgL_tmpz00_27513;
BgL_auxz00_27515 = 
BINT(BgL_siza7ezd2framez75_12292); 
BgL_tmpz00_27513 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14533, BgL_tmpz00_27513, BgL_auxz00_27515); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27518;
BgL_tmpz00_27518 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14533, BgL_tmpz00_27518, BgL_runz00_14527); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27521;
BgL_tmpz00_27521 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14533, BgL_tmpz00_27521, BgL_arg3583z00_14531); } 
BgL_arg3582z00_14530 = BgL_newz00_14533; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14528, BgL_arg3582z00_14530); BgL_arg3582z00_14530; } 
return BgL_mainz00_14528;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5174 */
obj_t BGl_z62main5174z62zz__evaluate_compz00(obj_t BgL_envz00_12294, obj_t BgL_az00_12299, obj_t BgL_bz00_12300, obj_t BgL_cz00_12301, obj_t BgL_dz00_12302, obj_t BgL_restz00_12303)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12296;obj_t BgL_runz00_12297;long BgL_siza7ezd2framez75_12298;
BgL_i1243z00_12296 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12294, 
(int)(((long)1)))); 
BgL_runz00_12297 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12294, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12298 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12294, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14534;
BgL_sz00_14534 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14535;
BgL_bpz00_14535 = 
VECTOR_REF(
((obj_t)BgL_sz00_14534),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14534, BgL_bpz00_14535, 
BINT(BgL_siza7ezd2framez75_12298)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3587z00_14536;
BgL_arg3587z00_14536 = 
(
(long)CINT(BgL_bpz00_14535)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14534),BgL_arg3587z00_14536,BgL_az00_12299); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3588z00_14537;
BgL_arg3588z00_14537 = 
(
(long)CINT(BgL_bpz00_14535)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14534),BgL_arg3588z00_14537,BgL_bz00_12300); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3589z00_14538;
BgL_arg3589z00_14538 = 
(
(long)CINT(BgL_bpz00_14535)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14534),BgL_arg3589z00_14538,BgL_cz00_12301); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3590z00_14539;
BgL_arg3590z00_14539 = 
(
(long)CINT(BgL_bpz00_14535)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14534),BgL_arg3590z00_14539,BgL_dz00_12302); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14534, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12296))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14535)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12296))->BgL_arityz00), ((long)4)), BgL_restz00_12303, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12296))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14540;
BgL_ez00_14540 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14540, BgL_bpz00_14535); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14541;
BgL_accz00_14541 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12297, BgL_sz00_14534, BgL_bpz00_14535); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14540); 
VECTOR_SET(
((obj_t)BgL_sz00_14534),((long)0),BgL_bpz00_14535); 
return BgL_accz00_14541;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14542;
BgL_nsz00_14542 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14542,((long)1),BgL_sz00_14534); 
VECTOR_SET(BgL_nsz00_14542,((long)2),BgL_az00_12299); 
VECTOR_SET(BgL_nsz00_14542,((long)3),BgL_bz00_12300); 
VECTOR_SET(BgL_nsz00_14542,((long)4),BgL_cz00_12301); 
VECTOR_SET(BgL_nsz00_14542,((long)5),BgL_dz00_12302); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14542, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12296))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12296))->BgL_arityz00), ((long)4)), BgL_restz00_12303, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12296))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14543;
BgL_z12denvz12_14543 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14543, BgL_nsz00_14542); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14544;
BgL_ez00_14544 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14544, BgL_sz00_14534); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14545;
BgL_____rz00_14545 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12297, BgL_nsz00_14542, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14544); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14543, BgL_sz00_14534); 
return BgL_____rz00_14545;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5175 */
obj_t BGl_z62run5175z62zz__evaluate_compz00(obj_t BgL_envz00_12304, obj_t BgL_sz00_12307)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12305;obj_t BgL_bodyz00_12306;
BgL_i1243z00_12305 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12304, 
(int)(((long)0)))); 
BgL_bodyz00_12306 = 
PROCEDURE_REF(BgL_envz00_12304, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14546;
BgL_bpz00_14546 = 
VECTOR_REF(
((obj_t)BgL_sz00_12307),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14547;obj_t BgL_wherez00_14548;obj_t BgL_locz00_14549;
BgL_z12denvz12_14547 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14548 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12305))->BgL_wherez00); 
BgL_locz00_14549 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12305))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14547, BgL_wherez00_14548, BgL_locz00_14549); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14550;
BgL_za2za2resza2za2z00_14550 = 
PROCEDURE_ENTRY(BgL_bodyz00_12306)(BgL_bodyz00_12306, BgL_sz00_12307, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14547); 
return BgL_za2za2resza2za2z00_14550;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3601> */
obj_t BGl_z62zc3anonymousza33601ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12308, obj_t BgL_sz00_12313)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12309;BgL_ev_absz00_bglt BgL_i1243z00_12310;obj_t BgL_bodyz00_12311;long BgL_siza7ezd2framez75_12312;
BgL_iboxesz00_12309 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12308, 
(int)(((long)0)))); 
BgL_i1243z00_12310 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12308, 
(int)(((long)1)))); 
BgL_bodyz00_12311 = 
PROCEDURE_REF(BgL_envz00_12308, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12312 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12308, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14551;
BgL_bpz00_14551 = 
VECTOR_REF(
((obj_t)BgL_sz00_12313),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */

{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14552;
BgL_runz00_14552 = 
MAKE_FX_PROCEDURE(BGl_z62run5177z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14552, 
(int)(((long)0)), BgL_iboxesz00_12309); 
PROCEDURE_SET(BgL_runz00_14552, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12310)); 
PROCEDURE_SET(BgL_runz00_14552, 
(int)(((long)2)), BgL_bodyz00_12311); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14553;
BgL_mainz00_14553 = 
MAKE_VA_PROCEDURE(BGl_z62main5176z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14553, 
(int)(((long)0)), BgL_iboxesz00_12309); 
PROCEDURE_SET(BgL_mainz00_14553, 
(int)(((long)1)), BgL_bodyz00_12311); 
PROCEDURE_SET(BgL_mainz00_14553, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12310)); 
PROCEDURE_SET(BgL_mainz00_14553, 
(int)(((long)3)), BgL_runz00_14552); 
PROCEDURE_SET(BgL_mainz00_14553, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12312)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14554;
BgL_objz00_14554 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14552, BgL_objz00_14554); BgL_objz00_14554; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3602z00_14555;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3603z00_14556;obj_t BgL_arg3604z00_14557;
BgL_arg3603z00_14556 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12310))->BgL_arityz00); 
BgL_arg3604z00_14557 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12310))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14558;
BgL_newz00_14558 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27647;
BgL_tmpz00_27647 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14558, BgL_tmpz00_27647, BgL_arg3604z00_14557); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27652;int BgL_tmpz00_27650;
BgL_auxz00_27652 = 
BINT(BgL_siza7ezd2framez75_12312); 
BgL_tmpz00_27650 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14558, BgL_tmpz00_27650, BgL_auxz00_27652); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27655;
BgL_tmpz00_27655 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14558, BgL_tmpz00_27655, BgL_runz00_14552); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27658;
BgL_tmpz00_27658 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14558, BgL_tmpz00_27658, BgL_arg3603z00_14556); } 
BgL_arg3602z00_14555 = BgL_newz00_14558; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14553, BgL_arg3602z00_14555); BgL_arg3602z00_14555; } 
return BgL_mainz00_14553;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5176 */
obj_t BGl_z62main5176z62zz__evaluate_compz00(obj_t BgL_envz00_12314, obj_t BgL_az00_12320, obj_t BgL_bz00_12321, obj_t BgL_cz00_12322, obj_t BgL_dz00_12323, obj_t BgL_restz00_12324)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12317;obj_t BgL_runz00_12318;long BgL_siza7ezd2framez75_12319;
BgL_i1243z00_12317 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12314, 
(int)(((long)2)))); 
BgL_runz00_12318 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12314, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12319 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12314, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14559;
BgL_sz00_14559 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14560;
BgL_bpz00_14560 = 
VECTOR_REF(
((obj_t)BgL_sz00_14559),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14559, BgL_bpz00_14560, 
BINT(BgL_siza7ezd2framez75_12319)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3607z00_14561;
BgL_arg3607z00_14561 = 
(
(long)CINT(BgL_bpz00_14560)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14559),BgL_arg3607z00_14561,BgL_az00_12320); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3608z00_14562;
BgL_arg3608z00_14562 = 
(
(long)CINT(BgL_bpz00_14560)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14559),BgL_arg3608z00_14562,BgL_bz00_12321); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3609z00_14563;
BgL_arg3609z00_14563 = 
(
(long)CINT(BgL_bpz00_14560)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14559),BgL_arg3609z00_14563,BgL_cz00_12322); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3610z00_14564;
BgL_arg3610z00_14564 = 
(
(long)CINT(BgL_bpz00_14560)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14559),BgL_arg3610z00_14564,BgL_dz00_12323); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14559, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12317))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14560)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12317))->BgL_arityz00), ((long)4)), BgL_restz00_12324, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12317))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14565;
BgL_ez00_14565 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14565, BgL_bpz00_14560); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14566;
BgL_accz00_14566 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12318, BgL_sz00_14559, BgL_bpz00_14560); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14565); 
VECTOR_SET(
((obj_t)BgL_sz00_14559),((long)0),BgL_bpz00_14560); 
return BgL_accz00_14566;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14567;
BgL_nsz00_14567 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14567,((long)1),BgL_sz00_14559); 
VECTOR_SET(BgL_nsz00_14567,((long)2),BgL_az00_12320); 
VECTOR_SET(BgL_nsz00_14567,((long)3),BgL_bz00_12321); 
VECTOR_SET(BgL_nsz00_14567,((long)4),BgL_cz00_12322); 
VECTOR_SET(BgL_nsz00_14567,((long)5),BgL_dz00_12323); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14567, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12317))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12317))->BgL_arityz00), ((long)4)), BgL_restz00_12324, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12317))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14568;
BgL_z12denvz12_14568 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14568, BgL_nsz00_14567); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14569;
BgL_ez00_14569 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14569, BgL_sz00_14559); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14570;
BgL_____rz00_14570 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12318, BgL_nsz00_14567, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14569); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14568, BgL_sz00_14559); 
return BgL_____rz00_14570;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5177 */
obj_t BGl_z62run5177z62zz__evaluate_compz00(obj_t BgL_envz00_12325, obj_t BgL_sz00_12329)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12326;BgL_ev_absz00_bglt BgL_i1243z00_12327;obj_t BgL_bodyz00_12328;
BgL_iboxesz00_12326 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12325, 
(int)(((long)0)))); 
BgL_i1243z00_12327 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12325, 
(int)(((long)1)))); 
BgL_bodyz00_12328 = 
PROCEDURE_REF(BgL_envz00_12325, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14571;
BgL_bpz00_14571 = 
VECTOR_REF(
((obj_t)BgL_sz00_12329),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12329, BgL_iboxesz00_12326, BgL_bpz00_14571); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14572;obj_t BgL_wherez00_14573;obj_t BgL_locz00_14574;
BgL_z12denvz12_14572 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14573 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12327))->BgL_wherez00); 
BgL_locz00_14574 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12327))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1167 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14572, BgL_wherez00_14573, BgL_locz00_14574); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_za2za2resza2za2z00_14575;
BgL_za2za2resza2za2z00_14575 = 
PROCEDURE_ENTRY(BgL_bodyz00_12328)(BgL_bodyz00_12328, BgL_sz00_12329, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14572); 
return BgL_za2za2resza2za2z00_14575;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3624> */
obj_t BGl_z62zc3anonymousza33624ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12330, obj_t BgL_sz00_12336)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12331;long BgL_siza7eza7_12332;BgL_ev_absz00_bglt BgL_i1243z00_12333;obj_t BgL_bodyz00_12334;long BgL_siza7ezd2framez75_12335;
BgL_ifreesz00_12331 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12330, 
(int)(((long)0)))); 
BgL_siza7eza7_12332 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12330, 
(int)(((long)1)))); 
BgL_i1243z00_12333 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12330, 
(int)(((long)2)))); 
BgL_bodyz00_12334 = 
PROCEDURE_REF(BgL_envz00_12330, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12335 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12330, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14576;
BgL_bpz00_14576 = 
VECTOR_REF(
((obj_t)BgL_sz00_12336),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14577;
BgL_valza2za2_14577 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12336, BgL_bpz00_14576, BgL_ifreesz00_12331); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14578;
BgL_runz00_14578 = 
MAKE_FX_PROCEDURE(BGl_z62run5179z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14578, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12332)); 
PROCEDURE_SET(BgL_runz00_14578, 
(int)(((long)1)), BgL_valza2za2_14577); 
PROCEDURE_SET(BgL_runz00_14578, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12333)); 
PROCEDURE_SET(BgL_runz00_14578, 
(int)(((long)3)), BgL_bodyz00_12334); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14579;
BgL_mainz00_14579 = 
MAKE_VA_PROCEDURE(BGl_z62main5178z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14579, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12332)); 
PROCEDURE_SET(BgL_mainz00_14579, 
(int)(((long)1)), BgL_valza2za2_14577); 
PROCEDURE_SET(BgL_mainz00_14579, 
(int)(((long)2)), BgL_bodyz00_12334); 
PROCEDURE_SET(BgL_mainz00_14579, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12333)); 
PROCEDURE_SET(BgL_mainz00_14579, 
(int)(((long)4)), BgL_runz00_14578); 
PROCEDURE_SET(BgL_mainz00_14579, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12335)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14580;
BgL_objz00_14580 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14578, BgL_objz00_14580); BgL_objz00_14580; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3625z00_14581;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3626z00_14582;obj_t BgL_arg3627z00_14583;
BgL_arg3626z00_14582 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12333))->BgL_arityz00); 
BgL_arg3627z00_14583 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12333))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14584;
BgL_newz00_14584 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27798;
BgL_tmpz00_27798 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14584, BgL_tmpz00_27798, BgL_arg3627z00_14583); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27803;int BgL_tmpz00_27801;
BgL_auxz00_27803 = 
BINT(BgL_siza7ezd2framez75_12335); 
BgL_tmpz00_27801 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14584, BgL_tmpz00_27801, BgL_auxz00_27803); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27806;
BgL_tmpz00_27806 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14584, BgL_tmpz00_27806, BgL_runz00_14578); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27809;
BgL_tmpz00_27809 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14584, BgL_tmpz00_27809, BgL_arg3626z00_14582); } 
BgL_arg3625z00_14581 = BgL_newz00_14584; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14579, BgL_arg3625z00_14581); BgL_arg3625z00_14581; } 
return BgL_mainz00_14579;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5178 */
obj_t BGl_z62main5178z62zz__evaluate_compz00(obj_t BgL_envz00_12337, obj_t BgL_az00_12344, obj_t BgL_bz00_12345, obj_t BgL_cz00_12346, obj_t BgL_dz00_12347, obj_t BgL_restz00_12348)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12341;obj_t BgL_runz00_12342;long BgL_siza7ezd2framez75_12343;
BgL_i1243z00_12341 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12337, 
(int)(((long)3)))); 
BgL_runz00_12342 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12337, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12343 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12337, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14585;
BgL_sz00_14585 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14586;
BgL_bpz00_14586 = 
VECTOR_REF(
((obj_t)BgL_sz00_14585),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14585, BgL_bpz00_14586, 
BINT(BgL_siza7ezd2framez75_12343)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3630z00_14587;
BgL_arg3630z00_14587 = 
(
(long)CINT(BgL_bpz00_14586)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14585),BgL_arg3630z00_14587,BgL_az00_12344); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3631z00_14588;
BgL_arg3631z00_14588 = 
(
(long)CINT(BgL_bpz00_14586)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14585),BgL_arg3631z00_14588,BgL_bz00_12345); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3632z00_14589;
BgL_arg3632z00_14589 = 
(
(long)CINT(BgL_bpz00_14586)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14585),BgL_arg3632z00_14589,BgL_cz00_12346); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3633z00_14590;
BgL_arg3633z00_14590 = 
(
(long)CINT(BgL_bpz00_14586)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14585),BgL_arg3633z00_14590,BgL_dz00_12347); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14585, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12341))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14586)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12341))->BgL_arityz00), ((long)4)), BgL_restz00_12348, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12341))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14591;
BgL_ez00_14591 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14591, BgL_bpz00_14586); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14592;
BgL_accz00_14592 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12342, BgL_sz00_14585, BgL_bpz00_14586); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14591); 
VECTOR_SET(
((obj_t)BgL_sz00_14585),((long)0),BgL_bpz00_14586); 
return BgL_accz00_14592;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14593;
BgL_nsz00_14593 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14593,((long)1),BgL_sz00_14585); 
VECTOR_SET(BgL_nsz00_14593,((long)2),BgL_az00_12344); 
VECTOR_SET(BgL_nsz00_14593,((long)3),BgL_bz00_12345); 
VECTOR_SET(BgL_nsz00_14593,((long)4),BgL_cz00_12346); 
VECTOR_SET(BgL_nsz00_14593,((long)5),BgL_dz00_12347); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14593, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12341))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12341))->BgL_arityz00), ((long)4)), BgL_restz00_12348, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12341))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14594;
BgL_z12denvz12_14594 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14594, BgL_nsz00_14593); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14595;
BgL_ez00_14595 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14595, BgL_sz00_14585); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14596;
BgL_____rz00_14596 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12342, BgL_nsz00_14593, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14595); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14594, BgL_sz00_14585); 
return BgL_____rz00_14596;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5179 */
obj_t BGl_z62run5179z62zz__evaluate_compz00(obj_t BgL_envz00_12349, obj_t BgL_sz00_12354)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_siza7eza7_12350;obj_t BgL_valza2za2_12351;BgL_ev_absz00_bglt BgL_i1243z00_12352;obj_t BgL_bodyz00_12353;
BgL_siza7eza7_12350 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12349, 
(int)(((long)0)))); 
BgL_valza2za2_12351 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12349, 
(int)(((long)1)))); 
BgL_i1243z00_12352 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12349, 
(int)(((long)2)))); 
BgL_bodyz00_12353 = 
PROCEDURE_REF(BgL_envz00_12349, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14597;
BgL_bpz00_14597 = 
VECTOR_REF(
((obj_t)BgL_sz00_12354),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12354, BgL_valza2za2_12351, 
(
(long)CINT(BgL_bpz00_14597)+BgL_siza7eza7_12350)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14598;obj_t BgL_wherez00_14599;obj_t BgL_locz00_14600;
BgL_z12denvz12_14598 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14599 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12352))->BgL_wherez00); 
BgL_locz00_14600 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12352))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14598, BgL_wherez00_14599, BgL_locz00_14600); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14601;
BgL_za2za2resza2za2z00_14601 = 
PROCEDURE_ENTRY(BgL_bodyz00_12353)(BgL_bodyz00_12353, BgL_sz00_12354, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14598); 
return BgL_za2za2resza2za2z00_14601;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3645> */
obj_t BGl_z62zc3anonymousza33645ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12355, obj_t BgL_sz00_12362)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_12356;obj_t BgL_iboxesz00_12357;long BgL_siza7eza7_12358;BgL_ev_absz00_bglt BgL_i1243z00_12359;obj_t BgL_bodyz00_12360;long BgL_siza7ezd2framez75_12361;
BgL_ifreesz00_12356 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)0)))); 
BgL_iboxesz00_12357 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)1)))); 
BgL_siza7eza7_12358 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)2)))); 
BgL_i1243z00_12359 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)3)))); 
BgL_bodyz00_12360 = 
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12361 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12355, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14602;
BgL_bpz00_14602 = 
VECTOR_REF(
((obj_t)BgL_sz00_12362),((long)0)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_valza2za2_14603;
BgL_valza2za2_14603 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12362, BgL_bpz00_14602, BgL_ifreesz00_12356); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_runz00_14604;
BgL_runz00_14604 = 
MAKE_FX_PROCEDURE(BGl_z62run5181z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14604, 
(int)(((long)0)), BgL_iboxesz00_12357); 
PROCEDURE_SET(BgL_runz00_14604, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12358)); 
PROCEDURE_SET(BgL_runz00_14604, 
(int)(((long)2)), BgL_valza2za2_14603); 
PROCEDURE_SET(BgL_runz00_14604, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12359)); 
PROCEDURE_SET(BgL_runz00_14604, 
(int)(((long)4)), BgL_bodyz00_12360); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_mainz00_14605;
BgL_mainz00_14605 = 
MAKE_VA_PROCEDURE(BGl_z62main5180z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)0)), BgL_iboxesz00_12357); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12358)); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)2)), BgL_valza2za2_14603); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)3)), BgL_bodyz00_12360); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)4)), 
((obj_t)BgL_i1243z00_12359)); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)5)), BgL_runz00_14604); 
PROCEDURE_SET(BgL_mainz00_14605, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12361)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_objz00_14606;
BgL_objz00_14606 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14604, BgL_objz00_14606); BgL_objz00_14606; } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3646z00_14607;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3647z00_14608;obj_t BgL_arg3648z00_14609;
BgL_arg3647z00_14608 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12359))->BgL_arityz00); 
BgL_arg3648z00_14609 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12359))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_newz00_14610;
BgL_newz00_14610 = 
create_struct(BGl_symbol5211z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27961;
BgL_tmpz00_27961 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14610, BgL_tmpz00_27961, BgL_arg3648z00_14609); } 
{ /* Eval/evaluate_comp.scm 676 */
obj_t BgL_auxz00_27966;int BgL_tmpz00_27964;
BgL_auxz00_27966 = 
BINT(BgL_siza7ezd2framez75_12361); 
BgL_tmpz00_27964 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14610, BgL_tmpz00_27964, BgL_auxz00_27966); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27969;
BgL_tmpz00_27969 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14610, BgL_tmpz00_27969, BgL_runz00_14604); } 
{ /* Eval/evaluate_comp.scm 676 */
int BgL_tmpz00_27972;
BgL_tmpz00_27972 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14610, BgL_tmpz00_27972, BgL_arg3647z00_14608); } 
BgL_arg3646z00_14607 = BgL_newz00_14610; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14605, BgL_arg3646z00_14607); BgL_arg3646z00_14607; } 
return BgL_mainz00_14605;} } } } } } 
BGL_FUNCTION_END;
}



/* &main5180 */
obj_t BGl_z62main5180z62zz__evaluate_compz00(obj_t BgL_envz00_12363, obj_t BgL_az00_12371, obj_t BgL_bz00_12372, obj_t BgL_cz00_12373, obj_t BgL_dz00_12374, obj_t BgL_restz00_12375)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
BgL_ev_absz00_bglt BgL_i1243z00_12368;obj_t BgL_runz00_12369;long BgL_siza7ezd2framez75_12370;
BgL_i1243z00_12368 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12363, 
(int)(((long)4)))); 
BgL_runz00_12369 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12363, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12370 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12363, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_sz00_14611;
BgL_sz00_14611 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14612;
BgL_bpz00_14612 = 
VECTOR_REF(
((obj_t)BgL_sz00_14611),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14611, BgL_bpz00_14612, 
BINT(BgL_siza7ezd2framez75_12370)))
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3651z00_14613;
BgL_arg3651z00_14613 = 
(
(long)CINT(BgL_bpz00_14612)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14611),BgL_arg3651z00_14613,BgL_az00_12371); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3652z00_14614;
BgL_arg3652z00_14614 = 
(
(long)CINT(BgL_bpz00_14612)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14611),BgL_arg3652z00_14614,BgL_bz00_12372); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3653z00_14615;
BgL_arg3653z00_14615 = 
(
(long)CINT(BgL_bpz00_14612)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14611),BgL_arg3653z00_14615,BgL_cz00_12373); } 
{ /* Eval/evaluate_comp.scm 1167 */
long BgL_arg3654z00_14616;
BgL_arg3654z00_14616 = 
(
(long)CINT(BgL_bpz00_14612)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14611),BgL_arg3654z00_14616,BgL_dz00_12374); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14611, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12368))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14612)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12368))->BgL_arityz00), ((long)4)), BgL_restz00_12375, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12368))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14617;
BgL_ez00_14617 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14617, BgL_bpz00_14612); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_accz00_14618;
BgL_accz00_14618 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12369, BgL_sz00_14611, BgL_bpz00_14612); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14617); 
VECTOR_SET(
((obj_t)BgL_sz00_14611),((long)0),BgL_bpz00_14612); 
return BgL_accz00_14618;} } }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_nsz00_14619;
BgL_nsz00_14619 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14619,((long)1),BgL_sz00_14611); 
VECTOR_SET(BgL_nsz00_14619,((long)2),BgL_az00_12371); 
VECTOR_SET(BgL_nsz00_14619,((long)3),BgL_bz00_12372); 
VECTOR_SET(BgL_nsz00_14619,((long)4),BgL_cz00_12373); 
VECTOR_SET(BgL_nsz00_14619,((long)5),BgL_dz00_12374); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14619, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12368))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12368))->BgL_arityz00), ((long)4)), BgL_restz00_12375, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12368))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_z12denvz12_14620;
BgL_z12denvz12_14620 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14620, BgL_nsz00_14619); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ez00_14621;
BgL_ez00_14621 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14621, BgL_sz00_14611); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_____rz00_14622;
BgL_____rz00_14622 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12369, BgL_nsz00_14619, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14621); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14620, BgL_sz00_14611); 
return BgL_____rz00_14622;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &run5181 */
obj_t BGl_z62run5181z62zz__evaluate_compz00(obj_t BgL_envz00_12376, obj_t BgL_sz00_12382)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1167 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_iboxesz00_12377;long BgL_siza7eza7_12378;obj_t BgL_valza2za2_12379;BgL_ev_absz00_bglt BgL_i1243z00_12380;obj_t BgL_bodyz00_12381;
BgL_iboxesz00_12377 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12376, 
(int)(((long)0)))); 
BgL_siza7eza7_12378 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12376, 
(int)(((long)1)))); 
BgL_valza2za2_12379 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12376, 
(int)(((long)2)))); 
BgL_i1243z00_12380 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12376, 
(int)(((long)3)))); 
BgL_bodyz00_12381 = 
PROCEDURE_REF(BgL_envz00_12376, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_bpz00_14623;
BgL_bpz00_14623 = 
VECTOR_REF(
((obj_t)BgL_sz00_12382),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12382, BgL_iboxesz00_12377, BgL_bpz00_14623); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12382, BgL_valza2za2_12379, 
(
(long)CINT(BgL_bpz00_14623)+BgL_siza7eza7_12378)); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_z12denvz12_14624;obj_t BgL_wherez00_14625;obj_t BgL_locz00_14626;
BgL_z12denvz12_14624 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14625 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12380))->BgL_wherez00); 
BgL_locz00_14626 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12380))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1088 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14624, BgL_wherez00_14625, BgL_locz00_14626); 
{ /* Eval/evaluate_comp.scm 1088 */
obj_t BgL_za2za2resza2za2z00_14627;
BgL_za2za2resza2za2z00_14627 = 
PROCEDURE_ENTRY(BgL_bodyz00_12381)(BgL_bodyz00_12381, BgL_sz00_12382, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14624); 
return BgL_za2za2resza2za2z00_14627;} } } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_app1428 */
obj_t BGl_z62compzd2ev_app1428zb0zz__evaluate_compz00(obj_t BgL_envz00_12383, obj_t BgL_ez00_12384, obj_t BgL_stkz00_12385)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 1037 */
{ /* Eval/evaluate_comp.scm 1039 */
obj_t BgL__ortest_1229z00_14629;
BgL__ortest_1229z00_14629 = 
BGl_arithzd2expressionzd2zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_12384), BgL_stkz00_12385); 
if(
CBOOL(BgL__ortest_1229z00_14629))
{ /* Eval/evaluate_comp.scm 1039 */
return BgL__ortest_1229z00_14629;}  else 
{ /* Eval/evaluate_comp.scm 1040 */
obj_t BgL__ortest_1230z00_14630;
BgL__ortest_1230z00_14630 = 
BGl_inlinezd2callzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_argsz00), BgL_stkz00_12385); 
if(
CBOOL(BgL__ortest_1230z00_14630))
{ /* Eval/evaluate_comp.scm 1040 */
return BgL__ortest_1230z00_14630;}  else 
{ /* Eval/evaluate_comp.scm 1040 */
if(
(
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_argsz00))>((long)4)))
{ /* Eval/evaluate_comp.scm 1041 */
return 
BGl_compzd2oldzd2callz00zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_12384), BgL_stkz00_12385);}  else 
{ /* Eval/evaluate_comp.scm 1043 */
obj_t BgL_fz00_14631;long BgL_siza7eza7_14632;obj_t BgL_symbzd2funzd2_14633;
BgL_fz00_14631 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), BgL_stkz00_12385); 
BgL_siza7eza7_14632 = 
bgl_list_length(BgL_stkz00_12385); 
BgL_symbzd2funzd2_14633 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00)); 
if(
NULLP(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_argsz00)))
{ /* Eval/evaluate_comp.scm 1044 */
return 
BGl_compzd2call0zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), BgL_symbzd2funzd2_14633, BgL_fz00_14631, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_tailzf3zf3), BgL_stkz00_12385, BgL_siza7eza7_14632);}  else 
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_a1z00_14634;obj_t BgL_argsz00_14635;
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_arg3115z00_14636;
BgL_arg3115z00_14636 = 
CAR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_argsz00)); 
BgL_a1z00_14634 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3115z00_14636), BgL_stkz00_12385); } 
BgL_argsz00_14635 = 
CDR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_argsz00)); 
if(
NULLP(BgL_argsz00_14635))
{ /* Eval/evaluate_comp.scm 1046 */
return 
BGl_compzd2call1zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), BgL_symbzd2funzd2_14633, BgL_fz00_14631, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_tailzf3zf3), BgL_stkz00_12385, BgL_siza7eza7_14632, BgL_a1z00_14634);}  else 
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_a2z00_14637;obj_t BgL_argsz00_14638;
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_arg3114z00_14639;
BgL_arg3114z00_14639 = 
CAR(
((obj_t)BgL_argsz00_14635)); 
BgL_a2z00_14637 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3114z00_14639), BgL_stkz00_12385); } 
BgL_argsz00_14638 = 
CDR(
((obj_t)BgL_argsz00_14635)); 
if(
NULLP(BgL_argsz00_14638))
{ /* Eval/evaluate_comp.scm 1046 */
return 
BGl_compzd2call2zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), BgL_symbzd2funzd2_14633, BgL_fz00_14631, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_tailzf3zf3), BgL_stkz00_12385, BgL_siza7eza7_14632, BgL_a1z00_14634, BgL_a2z00_14637);}  else 
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_a3z00_14640;obj_t BgL_argsz00_14641;
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_arg3113z00_14642;
BgL_arg3113z00_14642 = 
CAR(
((obj_t)BgL_argsz00_14638)); 
BgL_a3z00_14640 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3113z00_14642), BgL_stkz00_12385); } 
BgL_argsz00_14641 = 
CDR(
((obj_t)BgL_argsz00_14638)); 
if(
NULLP(BgL_argsz00_14641))
{ /* Eval/evaluate_comp.scm 1046 */
return 
BGl_compzd2call3zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), BgL_symbzd2funzd2_14633, BgL_fz00_14631, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_tailzf3zf3), BgL_stkz00_12385, BgL_siza7eza7_14632, BgL_a1z00_14634, BgL_a2z00_14637, BgL_a3z00_14640);}  else 
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_a4z00_14643;obj_t BgL_argsz00_14644;
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL_arg3112z00_14645;
BgL_arg3112z00_14645 = 
CAR(
((obj_t)BgL_argsz00_14641)); 
BgL_a4z00_14643 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3112z00_14645), BgL_stkz00_12385); } 
BgL_argsz00_14644 = 
CDR(
((obj_t)BgL_argsz00_14641)); 
if(
NULLP(BgL_argsz00_14644))
{ /* Eval/evaluate_comp.scm 1046 */
return 
BGl_compzd2call4zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_funz00), BgL_symbzd2funzd2_14633, BgL_fz00_14631, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12384)))->BgL_tailzf3zf3), BgL_stkz00_12385, BgL_siza7eza7_14632, BgL_a1z00_14634, BgL_a2z00_14637, BgL_a3z00_14640, BgL_a4z00_14643);}  else 
{ /* Eval/evaluate_comp.scm 1046 */
return 
BGl_errorz00zz__errorz00(BGl_string5194z00zz__evaluate_compz00, BGl_string5309z00zz__evaluate_compz00, BGl_string5310z00zz__evaluate_compz00);} } } } } } } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_goto1426 */
obj_t BGl_z62compzd2ev_goto1426zb0zz__evaluate_compz00(obj_t BgL_envz00_12386, obj_t BgL_ez00_12387, obj_t BgL_stkz00_12388)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 597 */
{ /* Eval/evaluate_comp.scm 600 */
obj_t BgL_slotz00_14649;long BgL_siza7eza7_14650;obj_t BgL_lstkz00_14651;
BgL_slotz00_14649 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_labelsz00)))->BgL_envz00)); 
BgL_siza7eza7_14650 = 
bgl_list_length(BgL_stkz00_12388); 
BgL_lstkz00_14651 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_labelsz00)))->BgL_stkz00); 
{ /* Eval/evaluate_comp.scm 602 */
long BgL_llstkz00_14652;obj_t BgL_substkz00_14653;obj_t BgL_boxesz00_14654;
BgL_llstkz00_14652 = 
bgl_list_length(BgL_lstkz00_14651); 
BgL_substkz00_14653 = 
BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_14651, BgL_stkz00_12388); 
{ /* Eval/evaluate_comp.scm 602 */
obj_t BgL_pairz00_14655;
BgL_pairz00_14655 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_labelsz00)))->BgL_boxesz00)); 
BgL_boxesz00_14654 = 
CDR(BgL_pairz00_14655); } 
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_argsz00), BgL_substkz00_14653))
{ /* Eval/evaluate_comp.scm 605 */
obj_t BgL_argsz00_14656;long BgL_nbargsz00_14657;
BgL_argsz00_14656 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_argsz00), BgL_stkz00_12388); 
BgL_nbargsz00_14657 = 
bgl_list_length(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_argsz00)); 
{ /* Eval/evaluate_comp.scm 606 */
obj_t BgL_zc3anonymousza33070ze3z83_14658;
BgL_zc3anonymousza33070ze3z83_14658 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33070ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14650)); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)1)), 
BINT(BgL_llstkz00_14652)); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_12387))); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)3)), BgL_argsz00_14656); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)4)), BgL_boxesz00_14654); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)5)), 
BINT(BgL_nbargsz00_14657)); 
PROCEDURE_SET(BgL_zc3anonymousza33070ze3z83_14658, 
(int)(((long)6)), BgL_slotz00_14649); 
return BgL_zc3anonymousza33070ze3z83_14658;} }  else 
{ /* Eval/evaluate_comp.scm 611 */
obj_t BgL_argsz00_14659;
{ /* Eval/evaluate_comp.scm 611 */
obj_t BgL_lz00_14660;long BgL_nz00_14661;
BgL_lz00_14660 = 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12387)))->BgL_argsz00); 
BgL_nz00_14661 = 
(BgL_siza7eza7_14650-BgL_llstkz00_14652); 
BgL_argsz00_14659 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_12388, BgL_lz00_14660, BgL_nz00_14661); } 
{ /* Eval/evaluate_comp.scm 612 */
obj_t BgL_zc3anonymousza33076ze3z83_14662;
BgL_zc3anonymousza33076ze3z83_14662 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33076ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3anonymousza33076ze3z83_14662, 
(int)(((long)0)), 
BINT(BgL_llstkz00_14652)); 
PROCEDURE_SET(BgL_zc3anonymousza33076ze3z83_14662, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_12387))); 
PROCEDURE_SET(BgL_zc3anonymousza33076ze3z83_14662, 
(int)(((long)2)), BgL_argsz00_14659); 
PROCEDURE_SET(BgL_zc3anonymousza33076ze3z83_14662, 
(int)(((long)3)), BgL_boxesz00_14654); 
PROCEDURE_SET(BgL_zc3anonymousza33076ze3z83_14662, 
(int)(((long)4)), BgL_slotz00_14649); 
return BgL_zc3anonymousza33076ze3z83_14662;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3070> */
obj_t BGl_z62zc3anonymousza33070ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12389, obj_t BgL_sz00_12397)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 606 */
{ /* Eval/evaluate_comp.scm 606 */
long BgL_siza7eza7_12390;long BgL_llstkz00_12391;BgL_ev_gotoz00_bglt BgL_i1141z00_12392;obj_t BgL_argsz00_12393;obj_t BgL_boxesz00_12394;long BgL_nbargsz00_12395;obj_t BgL_slotz00_12396;
BgL_siza7eza7_12390 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)0)))); 
BgL_llstkz00_12391 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)1)))); 
BgL_i1141z00_12392 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)2)))); 
BgL_argsz00_12393 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)3)))); 
BgL_boxesz00_12394 = 
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)4))); 
BgL_nbargsz00_12395 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)5)))); 
BgL_slotz00_12396 = 
PROCEDURE_REF(BgL_envz00_12389, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 606 */
obj_t BgL_bpz00_14663;
BgL_bpz00_14663 = 
VECTOR_REF(
((obj_t)BgL_sz00_12397),((long)0)); 
{ /* Eval/evaluate_comp.scm 607 */
long BgL_spz00_14664;long BgL_lspz00_14665;
BgL_spz00_14664 = 
(
(long)CINT(BgL_bpz00_14663)+BgL_siza7eza7_12390); 
BgL_lspz00_14665 = 
(
(long)CINT(BgL_bpz00_14663)+BgL_llstkz00_12391); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_12397, BgL_argsz00_12393, BgL_boxesz00_12394, BgL_spz00_14664, 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1141z00_12392))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 609 */
long BgL_arg3072z00_14666;
BgL_arg3072z00_14666 = 
(BgL_spz00_14664+BgL_nbargsz00_12395); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_12397, BgL_lspz00_14665, BgL_sz00_12397, 
BINT(BgL_spz00_14664), 
BINT(BgL_arg3072z00_14666)); } 
return 
CDR(
((obj_t)BgL_slotz00_12396));} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3076> */
obj_t BGl_z62zc3anonymousza33076ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12398, obj_t BgL_sz00_12404)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 612 */
{ /* Eval/evaluate_comp.scm 612 */
long BgL_llstkz00_12399;BgL_ev_gotoz00_bglt BgL_i1141z00_12400;obj_t BgL_argsz00_12401;obj_t BgL_boxesz00_12402;obj_t BgL_slotz00_12403;
BgL_llstkz00_12399 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12398, 
(int)(((long)0)))); 
BgL_i1141z00_12400 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_12398, 
(int)(((long)1)))); 
BgL_argsz00_12401 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12398, 
(int)(((long)2)))); 
BgL_boxesz00_12402 = 
PROCEDURE_REF(BgL_envz00_12398, 
(int)(((long)3))); 
BgL_slotz00_12403 = 
PROCEDURE_REF(BgL_envz00_12398, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 612 */
obj_t BgL_bpz00_14667;
BgL_bpz00_14667 = 
VECTOR_REF(
((obj_t)BgL_sz00_12404),((long)0)); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_12404, BgL_argsz00_12401, BgL_boxesz00_12402, 
(
(long)CINT(BgL_bpz00_14667)+BgL_llstkz00_12399), 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1141z00_12400))->BgL_locz00)); 
return 
CDR(
((obj_t)BgL_slotz00_12403));} } } 
BGL_FUNCTION_END;
}



/* &comp-ev_labels1424 */
obj_t BGl_z62compzd2ev_labels1424zb0zz__evaluate_compz00(obj_t BgL_envz00_12405, obj_t BgL_ez00_12406, obj_t BgL_stkz00_12407)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 565 */
{ 
obj_t BgL_fz00_14670;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12406)))->BgL_stkz00)=((obj_t)BgL_stkz00_12407),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_envz00_14672;
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_l1328z00_14673;
BgL_l1328z00_14673 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12406)))->BgL_varsz00); 
if(
NULLP(BgL_l1328z00_14673))
{ /* Eval/evaluate_comp.scm 572 */
BgL_envz00_14672 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_head1330z00_14674;
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_res4711z00_14675;
BgL_res4711z00_14675 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1330z00_14674 = BgL_res4711z00_14675; } 
{ 
obj_t BgL_l1328z00_14677;obj_t BgL_tail1331z00_14678;
BgL_l1328z00_14677 = BgL_l1328z00_14673; 
BgL_tail1331z00_14678 = BgL_head1330z00_14674; 
BgL_zc3anonymousza33061ze3z83_14676:
if(
NULLP(BgL_l1328z00_14677))
{ /* Eval/evaluate_comp.scm 572 */
BgL_envz00_14672 = 
CDR(BgL_head1330z00_14674); }  else 
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_newtail1332z00_14679;
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_arg3064z00_14680;
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_vz00_14681;
BgL_vz00_14681 = 
CAR(
((obj_t)BgL_l1328z00_14677)); 
BgL_arg3064z00_14680 = 
MAKE_YOUNG_PAIR(BgL_vz00_14681, BGl_symbol5311z00zz__evaluate_compz00); } 
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_res4713z00_14682;
BgL_res4713z00_14682 = 
MAKE_YOUNG_PAIR(BgL_arg3064z00_14680, BNIL); 
BgL_newtail1332z00_14679 = BgL_res4713z00_14682; } } 
SET_CDR(BgL_tail1331z00_14678, BgL_newtail1332z00_14679); 
{ /* Eval/evaluate_comp.scm 572 */
obj_t BgL_arg3063z00_14683;
BgL_arg3063z00_14683 = 
CDR(
((obj_t)BgL_l1328z00_14677)); 
{ 
obj_t BgL_tail1331z00_28314;obj_t BgL_l1328z00_28313;
BgL_l1328z00_28313 = BgL_arg3063z00_14683; 
BgL_tail1331z00_28314 = BgL_newtail1332z00_14679; 
BgL_tail1331z00_14678 = BgL_tail1331z00_28314; 
BgL_l1328z00_14677 = BgL_l1328z00_28313; 
goto BgL_zc3anonymousza33061ze3z83_14676;} } } } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12406)))->BgL_envz00)=((obj_t)BgL_envz00_14672),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 575 */
obj_t BgL_g1336z00_14684;
BgL_g1336z00_14684 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12406)))->BgL_valsz00); 
{ 
obj_t BgL_ll1333z00_14686;obj_t BgL_ll1334z00_14687;
BgL_ll1333z00_14686 = BgL_envz00_14672; 
BgL_ll1334z00_14687 = BgL_g1336z00_14684; 
BgL_zc3anonymousza33051ze3z83_14685:
if(
NULLP(BgL_ll1333z00_14686))
{ /* Eval/evaluate_comp.scm 575 */((bool_t)1); }  else 
{ /* Eval/evaluate_comp.scm 575 */
{ /* Eval/evaluate_comp.scm 577 */
obj_t BgL_slotz00_14688;obj_t BgL_valz00_14689;
BgL_slotz00_14688 = 
CAR(
((obj_t)BgL_ll1333z00_14686)); 
BgL_valz00_14689 = 
CAR(
((obj_t)BgL_ll1334z00_14687)); 
{ /* Eval/evaluate_comp.scm 578 */
obj_t BgL_arg3053z00_14690;
{ /* Eval/evaluate_comp.scm 578 */
obj_t BgL_arg3054z00_14691;
{ /* Eval/evaluate_comp.scm 578 */
obj_t BgL_arg3055z00_14692;obj_t BgL_arg3056z00_14693;
BgL_arg3055z00_14692 = 
CDR(
((obj_t)BgL_valz00_14689)); 
{ /* Eval/evaluate_comp.scm 578 */
obj_t BgL_arg3057z00_14694;
BgL_arg3057z00_14694 = 
CAR(
((obj_t)BgL_valz00_14689)); 
BgL_arg3056z00_14693 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12407, BgL_arg3057z00_14694); } 
BgL_arg3054z00_14691 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3055z00_14692), BgL_arg3056z00_14693); } 
BgL_fz00_14670 = BgL_arg3054z00_14691; 
{ /* Eval/evaluate_comp.scm 567 */
obj_t BgL_objz00_14671;
BgL_objz00_14671 = BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00; 
{ /* Eval/evaluate_comp.scm 567 */
obj_t BgL_tmpz00_28332;
BgL_tmpz00_28332 = 
((obj_t)BgL_fz00_14670); 
PROCEDURE_ATTR_SET(BgL_tmpz00_28332, BgL_objz00_14671); } BgL_objz00_14671; } 
BgL_arg3053z00_14690 = BgL_fz00_14670; } 
{ /* Eval/evaluate_comp.scm 577 */
obj_t BgL_tmpz00_28335;
BgL_tmpz00_28335 = 
((obj_t)BgL_slotz00_14688); 
SET_CDR(BgL_tmpz00_28335, BgL_arg3053z00_14690); } } } 
{ /* Eval/evaluate_comp.scm 575 */
obj_t BgL_arg3058z00_14695;obj_t BgL_arg3059z00_14696;
BgL_arg3058z00_14695 = 
CDR(
((obj_t)BgL_ll1333z00_14686)); 
BgL_arg3059z00_14696 = 
CDR(
((obj_t)BgL_ll1334z00_14687)); 
{ 
obj_t BgL_ll1334z00_28343;obj_t BgL_ll1333z00_28342;
BgL_ll1333z00_28342 = BgL_arg3058z00_14695; 
BgL_ll1334z00_28343 = BgL_arg3059z00_14696; 
BgL_ll1334z00_14687 = BgL_ll1334z00_28343; 
BgL_ll1333z00_14686 = BgL_ll1333z00_28342; 
goto BgL_zc3anonymousza33051ze3z83_14685;} } } } } } 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_bodyz00_14697;
BgL_bodyz00_14697 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12406)))->BgL_bodyz00), BgL_stkz00_12407); 
{ /* Eval/evaluate_comp.scm 583 */
obj_t BgL_zc3anonymousza33065ze3z83_14698;
BgL_zc3anonymousza33065ze3z83_14698 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33065ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza33065ze3z83_14698, 
(int)(((long)0)), BgL_bodyz00_14697); 
return BgL_zc3anonymousza33065ze3z83_14698;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3065> */
obj_t BGl_z62zc3anonymousza33065ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12408, obj_t BgL_sz00_12410)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 583 */
{ /* Eval/evaluate_comp.scm 583 */
obj_t BgL_bodyz00_12409;
BgL_bodyz00_12409 = 
PROCEDURE_REF(BgL_envz00_12408, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 583 */
obj_t BgL_bpz00_14699;
BgL_bpz00_14699 = 
VECTOR_REF(
((obj_t)BgL_sz00_12410),((long)0)); 
return 
BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(BgL_bodyz00_12409, BgL_sz00_12410);} } } 
BGL_FUNCTION_END;
}



/* &comp-ev_synchronize1422 */
obj_t BGl_z62compzd2ev_synchroniza7e1422z17zz__evaluate_compz00(obj_t BgL_envz00_12411, obj_t BgL_ez00_12412, obj_t BgL_stkz00_12413)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 545 */
{ /* Eval/evaluate_comp.scm 547 */
obj_t BgL_mutexz00_14701;obj_t BgL_prelockz00_14702;obj_t BgL_bodyz00_14703;
BgL_mutexz00_14701 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12412)))->BgL_mutexz00), BgL_stkz00_12413); 
BgL_prelockz00_14702 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12412)))->BgL_prelockz00), BgL_stkz00_12413); 
BgL_bodyz00_14703 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12412)))->BgL_bodyz00), BgL_stkz00_12413); 
{ /* Eval/evaluate_comp.scm 550 */
obj_t BgL_zc3anonymousza33044ze3z83_14704;
BgL_zc3anonymousza33044ze3z83_14704 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33044ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza33044ze3z83_14704, 
(int)(((long)0)), BgL_mutexz00_14701); 
PROCEDURE_SET(BgL_zc3anonymousza33044ze3z83_14704, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12412))); 
PROCEDURE_SET(BgL_zc3anonymousza33044ze3z83_14704, 
(int)(((long)2)), BgL_prelockz00_14702); 
PROCEDURE_SET(BgL_zc3anonymousza33044ze3z83_14704, 
(int)(((long)3)), BgL_bodyz00_14703); 
return BgL_zc3anonymousza33044ze3z83_14704;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3044> */
obj_t BGl_z62zc3anonymousza33044ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12414, obj_t BgL_sz00_12419)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 550 */
{ /* Eval/evaluate_comp.scm 550 */
obj_t BgL_mutexz00_12415;BgL_ev_synchroniza7eza7_bglt BgL_i1138z00_12416;obj_t BgL_prelockz00_12417;obj_t BgL_bodyz00_12418;
BgL_mutexz00_12415 = 
PROCEDURE_REF(BgL_envz00_12414, 
(int)(((long)0))); 
BgL_i1138z00_12416 = 
((BgL_ev_synchroniza7eza7_bglt)
PROCEDURE_REF(BgL_envz00_12414, 
(int)(((long)1)))); 
BgL_prelockz00_12417 = 
PROCEDURE_REF(BgL_envz00_12414, 
(int)(((long)2))); 
BgL_bodyz00_12418 = 
PROCEDURE_REF(BgL_envz00_12414, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 550 */
obj_t BgL_bpz00_14705;
BgL_bpz00_14705 = 
VECTOR_REF(
((obj_t)BgL_sz00_12419),((long)0)); 
{ /* Eval/evaluate_comp.scm 551 */
obj_t BgL_mz00_14706;
BgL_mz00_14706 = 
PROCEDURE_ENTRY(BgL_mutexz00_12415)(BgL_mutexz00_12415, BgL_sz00_12419, BEOA); 
{ /* Eval/evaluate_comp.scm 552 */
bool_t BgL_testz00_28394;
{ /* Eval/evaluate_comp.scm 552 */
bool_t BgL_res4708z00_14707;
BgL_res4708z00_14707 = 
BGL_MUTEXP(BgL_mz00_14706); 
BgL_testz00_28394 = BgL_res4708z00_14707; } 
if(BgL_testz00_28394)
{ /* Eval/evaluate_comp.scm 553 */
obj_t BgL_pz00_14708;
BgL_pz00_14708 = 
PROCEDURE_ENTRY(BgL_prelockz00_12417)(BgL_prelockz00_12417, BgL_sz00_12419, BEOA); 
{ /* Eval/evaluate_comp.scm 555 */
obj_t BgL_za2za2resza2za2z00_14709;
if(
PAIRP(BgL_pz00_14708))
{ /* Eval/evaluate_comp.scm 556 */
obj_t BgL_top5448z00_28403;
BgL_top5448z00_28403 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_14706, BgL_pz00_14708); 
BGL_EXITD_PUSH_PROTECT(BgL_top5448z00_28403, BgL_mz00_14706); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 556 */
obj_t BgL_tmp5447z00_28402;
BgL_tmp5447z00_28402 = 
PROCEDURE_ENTRY(BgL_bodyz00_12418)(BgL_bodyz00_12418, BgL_sz00_12419, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top5448z00_28403); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_14706); 
BgL_za2za2resza2za2z00_14709 = BgL_tmp5447z00_28402; } }  else 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_top5450z00_28414;
BgL_top5450z00_28414 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mz00_14706); 
BGL_EXITD_PUSH_PROTECT(BgL_top5450z00_28414, BgL_mz00_14706); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_tmp5449z00_28413;
BgL_tmp5449z00_28413 = 
PROCEDURE_ENTRY(BgL_bodyz00_12418)(BgL_bodyz00_12418, BgL_sz00_12419, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top5450z00_28414); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_14706); 
BgL_za2za2resza2za2z00_14709 = BgL_tmp5449z00_28413; } } 
VECTOR_SET(
((obj_t)BgL_sz00_12419),((long)0),BgL_bpz00_14705); 
return BgL_za2za2resza2za2z00_14709;} }  else 
{ /* Eval/evaluate_comp.scm 552 */
return 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_string5313z00zz__evaluate_compz00, BGl_string5314z00zz__evaluate_compz00, BgL_mz00_14706, 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_i1138z00_12416))->BgL_locz00));} } } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_with-handler1420 */
obj_t BGl_z62compzd2ev_withzd2handler1420z62zz__evaluate_compz00(obj_t BgL_envz00_12420, obj_t BgL_ez00_12421, obj_t BgL_stkz00_12422)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 536 */
{ /* Eval/evaluate_comp.scm 538 */
obj_t BgL_handlerz00_14711;obj_t BgL_bodyz00_14712;
BgL_handlerz00_14711 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_12421)))->BgL_handlerz00), BgL_stkz00_12422); 
BgL_bodyz00_14712 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_12421)))->BgL_bodyz00), BgL_stkz00_12422); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_zc3anonymousza33030ze3z83_14713;
BgL_zc3anonymousza33030ze3z83_14713 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33030ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza33030ze3z83_14713, 
(int)(((long)0)), BgL_handlerz00_14711); 
PROCEDURE_SET(BgL_zc3anonymousza33030ze3z83_14713, 
(int)(((long)1)), BgL_bodyz00_14712); 
return BgL_zc3anonymousza33030ze3z83_14713;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3030> */
obj_t BGl_z62zc3anonymousza33030ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12423, obj_t BgL_sz00_12426)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 539 */
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_handlerz00_12424;obj_t BgL_bodyz00_12425;
BgL_handlerz00_12424 = 
PROCEDURE_REF(BgL_envz00_12423, 
(int)(((long)0))); 
BgL_bodyz00_12425 = 
PROCEDURE_REF(BgL_envz00_12423, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_bpz00_14714;
BgL_bpz00_14714 = 
VECTOR_REF(
((obj_t)BgL_sz00_12426),((long)0)); 
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_hz00_14715;
BgL_hz00_14715 = 
PROCEDURE_ENTRY(BgL_handlerz00_12424)(BgL_handlerz00_12424, BgL_sz00_12426, BEOA); 
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_za2za2resza2za2z00_14716;
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_res1128z00_14717;
BgL_res1128z00_14717 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3exitza33037ze3ze70z64zz__evaluate_compz00(BgL_sz00_12426, BgL_bodyz00_12425, BgL_res1128z00_14717)))
{ /* Eval/evaluate_comp.scm 542 */
BgL_za2za2resza2za2z00_14716 = 
PROCEDURE_ENTRY(BgL_hz00_14715)(BgL_hz00_14715, 
CELL_REF(BgL_res1128z00_14717), BEOA); }  else 
{ /* Eval/evaluate_comp.scm 542 */
BgL_za2za2resza2za2z00_14716 = 
CELL_REF(BgL_res1128z00_14717); } } 
VECTOR_SET(
((obj_t)BgL_sz00_12426),((long)0),BgL_bpz00_14714); 
return BgL_za2za2resza2za2z00_14716;} } } } } 
BGL_FUNCTION_END;
}



/* <exit:3037>~0 */
obj_t BGl_zc3exitza33037ze3ze70z64zz__evaluate_compz00(obj_t BgL_sz00_12614, obj_t BgL_bodyz00_12613, obj_t BgL_res1128z00_12612)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 542 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1134z00_4197;
if( SET_EXIT(BgL_an_exit1134z00_4197) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1134z00_4197 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 542 */

PUSH_EXIT(BgL_an_exit1134z00_4197, ((long)1)); 
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_an_exitd1135z00_4198;
BgL_an_exitd1135z00_4198 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 542 */
bool_t BgL_res1137z00_4201;
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_ohs1126z00_4202;
BgL_ohs1126z00_4202 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_exitd1131z00_4203;
BgL_exitd1131z00_4203 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3anonymousza33041ze3z83_11394;
BgL_zc3anonymousza33041ze3z83_11394 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33041ze3ze1zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza33041ze3z83_11394, 
(int)(((long)0)), BgL_ohs1126z00_4202); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1131z00_4203, BgL_zc3anonymousza33041ze3z83_11394); 
{ /* Eval/evaluate_comp.scm 542 */
bool_t BgL_tmp1133z00_4205;
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_arg3038z00_4206;
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_zc3anonymousza33040ze3z83_11393;
BgL_zc3anonymousza33040ze3z83_11393 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33040ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza33040ze3z83_11393, 
(int)(((long)0)), 
((obj_t)BgL_res1128z00_12612)); 
PROCEDURE_SET(BgL_zc3anonymousza33040ze3z83_11393, 
(int)(((long)1)), BgL_an_exitd1135z00_4198); 
BgL_arg3038z00_4206 = 
MAKE_YOUNG_PAIR(BgL_zc3anonymousza33040ze3z83_11393, BgL_ohs1126z00_4202); } 
BGL_ERROR_HANDLER_SET(BgL_arg3038z00_4206); BUNSPEC; } 
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_auxz00_12428;
BgL_auxz00_12428 = 
PROCEDURE_ENTRY(BgL_bodyz00_12613)(BgL_bodyz00_12613, BgL_sz00_12614, BEOA); 
CELL_SET(BgL_res1128z00_12612, BgL_auxz00_12428); } 
BgL_tmp1133z00_4205 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1131z00_4203); 
BGl_z62zc3anonymousza33041ze3ze1zz__evaluate_compz00(BgL_zc3anonymousza33041ze3z83_11394); 
BgL_res1137z00_4201 = BgL_tmp1133z00_4205; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1137z00_4201);} } } 
} } 
BGL_FUNCTION_END;
}



/* &<anonymous:3040> */
obj_t BGl_z62zc3anonymousza33040ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12430, obj_t BgL_ez00_12433)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 542 */
{ /* Eval/evaluate_comp.scm 542 */
obj_t BgL_res1128z00_12431;obj_t BgL_an_exitd1135z00_12432;
BgL_res1128z00_12431 = 
PROCEDURE_REF(BgL_envz00_12430, 
(int)(((long)0))); 
BgL_an_exitd1135z00_12432 = 
PROCEDURE_REF(BgL_envz00_12430, 
(int)(((long)1))); 
CELL_SET(BgL_res1128z00_12431, BgL_ez00_12433); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1135z00_12432, BTRUE);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:3041> */
obj_t BGl_z62zc3anonymousza33041ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12435)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 542 */
{ 
obj_t BgL_ohs1126z00_12436;
BgL_ohs1126z00_12436 = 
PROCEDURE_REF(BgL_envz00_12435, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1126z00_12436); 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* &comp-ev_unwind-prote1418 */
obj_t BGl_z62compzd2ev_unwindzd2prote1418z62zz__evaluate_compz00(obj_t BgL_envz00_12437, obj_t BgL_ez00_12438, obj_t BgL_stkz00_12439)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 527 */
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_ez00_14719;obj_t BgL_bodyz00_14720;
BgL_ez00_14719 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_12438)))->BgL_ez00), BgL_stkz00_12439); 
BgL_bodyz00_14720 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_12438)))->BgL_bodyz00), BgL_stkz00_12439); 
{ /* Eval/evaluate_comp.scm 530 */
obj_t BgL_zc3anonymousza33026ze3z83_14721;
BgL_zc3anonymousza33026ze3z83_14721 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33026ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza33026ze3z83_14721, 
(int)(((long)0)), BgL_bodyz00_14720); 
PROCEDURE_SET(BgL_zc3anonymousza33026ze3z83_14721, 
(int)(((long)1)), BgL_ez00_14719); 
return BgL_zc3anonymousza33026ze3z83_14721;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3026> */
obj_t BGl_z62zc3anonymousza33026ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12440, obj_t BgL_sz00_12443)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 530 */
{ /* Eval/evaluate_comp.scm 530 */
obj_t BgL_bodyz00_12441;obj_t BgL_ez00_12442;
BgL_bodyz00_12441 = 
PROCEDURE_REF(BgL_envz00_12440, 
(int)(((long)0))); 
BgL_ez00_12442 = 
PROCEDURE_REF(BgL_envz00_12440, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 530 */
obj_t BgL_bpz00_14722;
BgL_bpz00_14722 = 
VECTOR_REF(
((obj_t)BgL_sz00_12443),((long)0)); 
{ /* Eval/evaluate_comp.scm 532 */
obj_t BgL_exitd1122z00_14723;
BgL_exitd1122z00_14723 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Eval/evaluate_comp.scm 533 */
obj_t BgL_zc3anonymousza33027ze3z83_14724;
BgL_zc3anonymousza33027ze3z83_14724 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33027ze3ze1zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33027ze3z83_14724, 
(int)(((long)0)), BgL_sz00_12443); 
PROCEDURE_SET(BgL_zc3anonymousza33027ze3z83_14724, 
(int)(((long)1)), BgL_bpz00_14722); 
PROCEDURE_SET(BgL_zc3anonymousza33027ze3z83_14724, 
(int)(((long)2)), BgL_bodyz00_12441); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1122z00_14723, BgL_zc3anonymousza33027ze3z83_14724); 
{ /* Eval/evaluate_comp.scm 532 */
obj_t BgL_tmp1124z00_14725;
BgL_tmp1124z00_14725 = 
PROCEDURE_ENTRY(BgL_ez00_12442)(BgL_ez00_12442, BgL_sz00_12443, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1122z00_14723); 
BGl_z62zc3anonymousza33027ze3ze1zz__evaluate_compz00(BgL_zc3anonymousza33027ze3z83_14724); 
return BgL_tmp1124z00_14725;} } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3027> */
obj_t BGl_z62zc3anonymousza33027ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12444)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 532 */
{ /* Eval/evaluate_comp.scm 533 */
obj_t BgL_sz00_12445;obj_t BgL_savedzd2bpzd2_12446;obj_t BgL_bodyz00_12447;
BgL_sz00_12445 = 
PROCEDURE_REF(BgL_envz00_12444, 
(int)(((long)0))); 
BgL_savedzd2bpzd2_12446 = 
PROCEDURE_REF(BgL_envz00_12444, 
(int)(((long)1))); 
BgL_bodyz00_12447 = 
PROCEDURE_REF(BgL_envz00_12444, 
(int)(((long)2))); 
VECTOR_SET(
((obj_t)BgL_sz00_12445),((long)0),BgL_savedzd2bpzd2_12446); 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12447)(BgL_bodyz00_12447, BgL_sz00_12445, BEOA);} } 
BGL_FUNCTION_END;
}



/* &comp-ev_bind-exit1416 */
obj_t BGl_z62compzd2ev_bindzd2exit1416z62zz__evaluate_compz00(obj_t BgL_envz00_12448, obj_t BgL_ez00_12449, obj_t BgL_stkz00_12450)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 516 */
{ /* Eval/evaluate_comp.scm 518 */
long BgL_siza7eza7_14727;obj_t BgL_nstkz00_14728;
BgL_siza7eza7_14727 = 
bgl_list_length(BgL_stkz00_12450); 
{ /* Eval/evaluate_comp.scm 518 */
obj_t BgL_arg3024z00_14729;
{ /* Eval/evaluate_comp.scm 518 */
BgL_ev_varz00_bglt BgL_arg3025z00_14730;
BgL_arg3025z00_14730 = 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12449)))->BgL_varz00); 
BgL_arg3024z00_14729 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg3025z00_14730), BNIL); } 
BgL_nstkz00_14728 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12450, BgL_arg3024z00_14729); } 
{ /* Eval/evaluate_comp.scm 519 */
obj_t BgL_bodyz00_14731;obj_t BgL_effzf3zf3_14732;
BgL_bodyz00_14731 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12449)))->BgL_bodyz00), BgL_nstkz00_14728); 
BgL_effzf3zf3_14732 = 
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12449)))->BgL_varz00)))->BgL_effz00); 
{ /* Eval/evaluate_comp.scm 520 */
obj_t BgL_zc3anonymousza33019ze3z83_14733;
BgL_zc3anonymousza33019ze3z83_14733 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza33019ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza33019ze3z83_14733, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14727)); 
PROCEDURE_SET(BgL_zc3anonymousza33019ze3z83_14733, 
(int)(((long)1)), BgL_effzf3zf3_14732); 
PROCEDURE_SET(BgL_zc3anonymousza33019ze3z83_14733, 
(int)(((long)2)), BgL_bodyz00_14731); 
return BgL_zc3anonymousza33019ze3z83_14733;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:3019> */
obj_t BGl_z62zc3anonymousza33019ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12451, obj_t BgL_sz00_12455)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 520 */
{ /* Eval/evaluate_comp.scm 520 */
long BgL_siza7eza7_12452;obj_t BgL_effzf3zf3_12453;obj_t BgL_bodyz00_12454;
BgL_siza7eza7_12452 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12451, 
(int)(((long)0)))); 
BgL_effzf3zf3_12453 = 
PROCEDURE_REF(BgL_envz00_12451, 
(int)(((long)1))); 
BgL_bodyz00_12454 = 
PROCEDURE_REF(BgL_envz00_12451, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 520 */
obj_t BgL_bpz00_14734;
BgL_bpz00_14734 = 
VECTOR_REF(
((obj_t)BgL_sz00_12455),((long)0)); 
{ /* Eval/evaluate_comp.scm 522 */
obj_t BgL_za2za2resza2za2z00_14735;
BgL_za2za2resza2za2z00_14735 = 
BGl_zc3exitza33020ze3ze70z64zz__evaluate_compz00(BgL_bodyz00_12454, BgL_sz00_12455, BgL_effzf3zf3_12453, BgL_siza7eza7_12452, BgL_bpz00_14734); 
VECTOR_SET(
((obj_t)BgL_sz00_12455),((long)0),BgL_bpz00_14734); 
return BgL_za2za2resza2za2z00_14735;} } } } 
BGL_FUNCTION_END;
}



/* <exit:3020>~0 */
obj_t BGl_zc3exitza33020ze3ze70z64zz__evaluate_compz00(obj_t BgL_bodyz00_12611, obj_t BgL_sz00_12610, obj_t BgL_effzf3zf3_12609, long BgL_siza7eza7_12608, obj_t BgL_bpz00_12607)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 522 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1117z00_4132;
if( SET_EXIT(BgL_an_exit1117z00_4132) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1117z00_4132 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 522 */

PUSH_EXIT(BgL_an_exit1117z00_4132, ((long)1)); 
{ /* Eval/evaluate_comp.scm 522 */
obj_t BgL_an_exitd1118z00_4133;
BgL_an_exitd1118z00_4133 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 522 */
obj_t BgL_exitz00_11400;
BgL_exitz00_11400 = 
MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_exitz00_11400, 
(int)(((long)0)), BgL_an_exitd1118z00_4133); 
{ /* Eval/evaluate_comp.scm 522 */
obj_t BgL_res1120z00_4136;
{ /* Eval/evaluate_comp.scm 523 */
long BgL_arg3021z00_4137;obj_t BgL_arg3022z00_4138;
BgL_arg3021z00_4137 = 
(
(long)CINT(BgL_bpz00_12607)+BgL_siza7eza7_12608); 
if(
CBOOL(BgL_effzf3zf3_12609))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8873;
BgL_newz00_8873 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28592;
BgL_tmpz00_28592 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8873, BgL_tmpz00_28592, BgL_exitz00_11400); } 
BgL_arg3022z00_4138 = BgL_newz00_8873; }  else 
{ /* Eval/evaluate_comp.scm 523 */
BgL_arg3022z00_4138 = BgL_exitz00_11400; } 
VECTOR_SET(
((obj_t)BgL_sz00_12610),BgL_arg3021z00_4137,BgL_arg3022z00_4138); } 
BgL_res1120z00_4136 = 
PROCEDURE_ENTRY(BgL_bodyz00_12611)(BgL_bodyz00_12611, BgL_sz00_12610, BEOA); 
POP_EXIT(); 
return BgL_res1120z00_4136;} } } } 
} } 
BGL_FUNCTION_END;
}



/* &exit */
obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_12456, obj_t BgL_val1119z00_12458)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 522 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
PROCEDURE_REF(BgL_envz00_12456, 
(int)(((long)0))), BgL_val1119z00_12458);} 
BGL_FUNCTION_END;
}



/* &comp-ev_letrec1414 */
obj_t BGl_z62compzd2ev_letrec1414zb0zz__evaluate_compz00(obj_t BgL_envz00_12459, obj_t BgL_ez00_12460, obj_t BgL_stkz00_12461)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 487 */
{ /* Eval/evaluate_comp.scm 489 */
long BgL_siza7eza7_14737;obj_t BgL_nstkz00_14738;
BgL_siza7eza7_14737 = 
bgl_list_length(BgL_stkz00_12461); 
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_arg3018z00_14739;
BgL_arg3018z00_14739 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12460))))->BgL_varsz00); 
BgL_nstkz00_14738 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12461, BgL_arg3018z00_14739); } 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_cvalsz00_14740;obj_t BgL_bodyz00_14741;
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_l1314z00_14742;
BgL_l1314z00_14742 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12460))))->BgL_valsz00); 
if(
NULLP(BgL_l1314z00_14742))
{ /* Eval/evaluate_comp.scm 490 */
BgL_cvalsz00_14740 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_head1316z00_14743;
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_res4687z00_14744;
BgL_res4687z00_14744 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1316z00_14743 = BgL_res4687z00_14744; } 
{ 
obj_t BgL_l1314z00_14746;obj_t BgL_tail1317z00_14747;
BgL_l1314z00_14746 = BgL_l1314z00_14742; 
BgL_tail1317z00_14747 = BgL_head1316z00_14743; 
BgL_zc3anonymousza33013ze3z83_14745:
if(
NULLP(BgL_l1314z00_14746))
{ /* Eval/evaluate_comp.scm 490 */
BgL_cvalsz00_14740 = 
CDR(BgL_head1316z00_14743); }  else 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_newtail1318z00_14748;
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_arg3016z00_14749;
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_vz00_14750;
BgL_vz00_14750 = 
CAR(
((obj_t)BgL_l1314z00_14746)); 
BgL_arg3016z00_14749 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_14750), BgL_nstkz00_14738); } 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_res4689z00_14751;
BgL_res4689z00_14751 = 
MAKE_YOUNG_PAIR(BgL_arg3016z00_14749, BNIL); 
BgL_newtail1318z00_14748 = BgL_res4689z00_14751; } } 
SET_CDR(BgL_tail1317z00_14747, BgL_newtail1318z00_14748); 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_arg3015z00_14752;
BgL_arg3015z00_14752 = 
CDR(
((obj_t)BgL_l1314z00_14746)); 
{ 
obj_t BgL_tail1317z00_28628;obj_t BgL_l1314z00_28627;
BgL_l1314z00_28627 = BgL_arg3015z00_14752; 
BgL_tail1317z00_28628 = BgL_newtail1318z00_14748; 
BgL_tail1317z00_14747 = BgL_tail1317z00_28628; 
BgL_l1314z00_14746 = BgL_l1314z00_28627; 
goto BgL_zc3anonymousza33013ze3z83_14745;} } } } } } 
{ /* Eval/evaluate_comp.scm 491 */
BgL_ev_exprz00_bglt BgL_arg3017z00_14753;
BgL_arg3017z00_14753 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12460))))->BgL_bodyz00); 
BgL_bodyz00_14741 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3017z00_14753, BgL_nstkz00_14738); } 
{ /* Eval/evaluate_comp.scm 492 */
bool_t BgL_testz00_28633;
{ 
obj_t BgL_l1319z00_14755;
BgL_l1319z00_14755 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12460))))->BgL_valsz00); 
BgL_zc3anonymousza33010ze3z83_14754:
if(
NULLP(BgL_l1319z00_14755))
{ /* Eval/evaluate_comp.scm 492 */
BgL_testz00_28633 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 492 */
bool_t BgL_testz00_28636;
{ /* Eval/evaluate_comp.scm 492 */
obj_t BgL_vz00_14756;
BgL_vz00_14756 = 
CAR(
((obj_t)BgL_l1319z00_14755)); 
BgL_testz00_28636 = 
BGl_isazf3zf3zz__objectz00(BgL_vz00_14756, BGl_ev_absz00zz__evaluate_typesz00); } 
if(BgL_testz00_28636)
{ 
obj_t BgL_l1319z00_28640;
BgL_l1319z00_28640 = 
CDR(
((obj_t)BgL_l1319z00_14755)); 
BgL_l1319z00_14755 = BgL_l1319z00_28640; 
goto BgL_zc3anonymousza33010ze3z83_14754;}  else 
{ /* Eval/evaluate_comp.scm 492 */
BgL_testz00_28633 = ((bool_t)0)
; } } } 
if(BgL_testz00_28633)
{ /* Eval/evaluate_comp.scm 493 */
obj_t BgL_zc3anonymousza32980ze3z83_14757;
BgL_zc3anonymousza32980ze3z83_14757 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32980ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32980ze3z83_14757, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14737)); 
PROCEDURE_SET(BgL_zc3anonymousza32980ze3z83_14757, 
(int)(((long)1)), BgL_cvalsz00_14740); 
PROCEDURE_SET(BgL_zc3anonymousza32980ze3z83_14757, 
(int)(((long)2)), BgL_bodyz00_14741); 
return BgL_zc3anonymousza32980ze3z83_14757;}  else 
{ /* Eval/evaluate_comp.scm 503 */
obj_t BgL_zc3anonymousza32993ze3z83_14758;
BgL_zc3anonymousza32993ze3z83_14758 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32993ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32993ze3z83_14758, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14737)); 
PROCEDURE_SET(BgL_zc3anonymousza32993ze3z83_14758, 
(int)(((long)1)), BgL_cvalsz00_14740); 
PROCEDURE_SET(BgL_zc3anonymousza32993ze3z83_14758, 
(int)(((long)2)), BgL_bodyz00_14741); 
return BgL_zc3anonymousza32993ze3z83_14758;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2980> */
obj_t BGl_z62zc3anonymousza32980ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12462, obj_t BgL_sz00_12466)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 493 */
{ /* Eval/evaluate_comp.scm 493 */
long BgL_siza7eza7_12463;obj_t BgL_cvalsz00_12464;obj_t BgL_bodyz00_12465;
BgL_siza7eza7_12463 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12462, 
(int)(((long)0)))); 
BgL_cvalsz00_12464 = 
PROCEDURE_REF(BgL_envz00_12462, 
(int)(((long)1))); 
BgL_bodyz00_12465 = 
PROCEDURE_REF(BgL_envz00_12462, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 493 */
obj_t BgL_bpz00_14759;
BgL_bpz00_14759 = 
VECTOR_REF(
((obj_t)BgL_sz00_12466),((long)0)); 
{ /* Eval/evaluate_comp.scm 494 */
long BgL_g1111z00_14760;
BgL_g1111z00_14760 = 
(
(long)CINT(BgL_bpz00_14759)+BgL_siza7eza7_12463); 
{ 
obj_t BgL_lz00_14762;long BgL_iz00_14763;
BgL_lz00_14762 = BgL_cvalsz00_12464; 
BgL_iz00_14763 = BgL_g1111z00_14760; 
BgL_recz00_14761:
if(
NULLP(BgL_lz00_14762))
{ /* Eval/evaluate_comp.scm 495 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 495 */
{ /* Eval/evaluate_comp.scm 496 */
obj_t BgL_arg2983z00_14764;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14765;
BgL_newz00_14765 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28681;
BgL_tmpz00_28681 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14765, BgL_tmpz00_28681, BUNSPEC); } 
BgL_arg2983z00_14764 = BgL_newz00_14765; } 
VECTOR_SET(
((obj_t)BgL_sz00_12466),BgL_iz00_14763,BgL_arg2983z00_14764); } 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg2984z00_14766;long BgL_arg2985z00_14767;
BgL_arg2984z00_14766 = 
CDR(
((obj_t)BgL_lz00_14762)); 
BgL_arg2985z00_14767 = 
(BgL_iz00_14763+((long)1)); 
{ 
long BgL_iz00_28690;obj_t BgL_lz00_28689;
BgL_lz00_28689 = BgL_arg2984z00_14766; 
BgL_iz00_28690 = BgL_arg2985z00_14767; 
BgL_iz00_14763 = BgL_iz00_28690; 
BgL_lz00_14762 = BgL_lz00_28689; 
goto BgL_recz00_14761;} } } } } 
{ /* Eval/evaluate_comp.scm 498 */
long BgL_g1112z00_14768;
BgL_g1112z00_14768 = 
(
(long)CINT(BgL_bpz00_14759)+BgL_siza7eza7_12463); 
{ 
obj_t BgL_lz00_14770;long BgL_iz00_14771;
BgL_lz00_14770 = BgL_cvalsz00_12464; 
BgL_iz00_14771 = BgL_g1112z00_14768; 
BgL_recz00_14769:
if(
NULLP(BgL_lz00_14770))
{ /* Eval/evaluate_comp.scm 499 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 499 */
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_arg2988z00_14772;obj_t BgL_arg2989z00_14773;
BgL_arg2988z00_14772 = 
VECTOR_REF(
((obj_t)BgL_sz00_12466),BgL_iz00_14771); 
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_fun2990z00_14774;
BgL_fun2990z00_14774 = 
CAR(
((obj_t)BgL_lz00_14770)); 
BgL_arg2989z00_14773 = 
PROCEDURE_ENTRY(BgL_fun2990z00_14774)(BgL_fun2990z00_14774, BgL_sz00_12466, BEOA); } 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28705;obj_t BgL_tmpz00_28703;
BgL_auxz00_28705 = 
(int)(((long)0)); 
BgL_tmpz00_28703 = 
((obj_t)BgL_arg2988z00_14772); 
STRUCT_SET(BgL_tmpz00_28703, BgL_auxz00_28705, BgL_arg2989z00_14773); } } 
{ /* Eval/evaluate_comp.scm 501 */
obj_t BgL_arg2991z00_14775;long BgL_arg2992z00_14776;
BgL_arg2991z00_14775 = 
CDR(
((obj_t)BgL_lz00_14770)); 
BgL_arg2992z00_14776 = 
(BgL_iz00_14771+((long)1)); 
{ 
long BgL_iz00_28712;obj_t BgL_lz00_28711;
BgL_lz00_28711 = BgL_arg2991z00_14775; 
BgL_iz00_28712 = BgL_arg2992z00_14776; 
BgL_iz00_14771 = BgL_iz00_28712; 
BgL_lz00_14770 = BgL_lz00_28711; 
goto BgL_recz00_14769;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12465)(BgL_bodyz00_12465, BgL_sz00_12466, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2993> */
obj_t BGl_z62zc3anonymousza32993ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12467, obj_t BgL_sz00_12471)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 503 */
{ /* Eval/evaluate_comp.scm 503 */
long BgL_siza7eza7_12468;obj_t BgL_cvalsz00_12469;obj_t BgL_bodyz00_12470;
BgL_siza7eza7_12468 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)0)))); 
BgL_cvalsz00_12469 = 
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)1))); 
BgL_bodyz00_12470 = 
PROCEDURE_REF(BgL_envz00_12467, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 503 */
obj_t BgL_bpz00_14777;
BgL_bpz00_14777 = 
VECTOR_REF(
((obj_t)BgL_sz00_12471),((long)0)); 
{ /* Eval/evaluate_comp.scm 504 */
long BgL_g1113z00_14778;
BgL_g1113z00_14778 = 
(
(long)CINT(BgL_bpz00_14777)+BgL_siza7eza7_12468); 
{ 
obj_t BgL_lz00_14780;long BgL_iz00_14781;
BgL_lz00_14780 = BgL_cvalsz00_12469; 
BgL_iz00_14781 = BgL_g1113z00_14778; 
BgL_recz00_14779:
if(
NULLP(BgL_lz00_14780))
{ /* Eval/evaluate_comp.scm 505 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 505 */
{ /* Eval/evaluate_comp.scm 506 */
obj_t BgL_arg2996z00_14782;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14783;
BgL_newz00_14783 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28732;
BgL_tmpz00_28732 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14783, BgL_tmpz00_28732, BUNSPEC); } 
BgL_arg2996z00_14782 = BgL_newz00_14783; } 
VECTOR_SET(
((obj_t)BgL_sz00_12471),BgL_iz00_14781,BgL_arg2996z00_14782); } 
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_arg2997z00_14784;long BgL_arg2998z00_14785;
BgL_arg2997z00_14784 = 
CDR(
((obj_t)BgL_lz00_14780)); 
BgL_arg2998z00_14785 = 
(BgL_iz00_14781+((long)1)); 
{ 
long BgL_iz00_28741;obj_t BgL_lz00_28740;
BgL_lz00_28740 = BgL_arg2997z00_14784; 
BgL_iz00_28741 = BgL_arg2998z00_14785; 
BgL_iz00_14781 = BgL_iz00_28741; 
BgL_lz00_14780 = BgL_lz00_28740; 
goto BgL_recz00_14779;} } } } } 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_rvalsz00_14786;
if(
NULLP(BgL_cvalsz00_12469))
{ /* Eval/evaluate_comp.scm 508 */
BgL_rvalsz00_14786 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_head1325z00_14787;
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_res4701z00_14788;
BgL_res4701z00_14788 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1325z00_14787 = BgL_res4701z00_14788; } 
{ 
obj_t BgL_l1323z00_14790;obj_t BgL_tail1326z00_14791;
BgL_l1323z00_14790 = BgL_cvalsz00_12469; 
BgL_tail1326z00_14791 = BgL_head1325z00_14787; 
BgL_zc3anonymousza33006ze3z83_14789:
if(
NULLP(BgL_l1323z00_14790))
{ /* Eval/evaluate_comp.scm 508 */
BgL_rvalsz00_14786 = 
CDR(BgL_head1325z00_14787); }  else 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_newtail1327z00_14792;
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_arg3009z00_14793;
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_vz00_14794;
BgL_vz00_14794 = 
CAR(
((obj_t)BgL_l1323z00_14790)); 
BgL_arg3009z00_14793 = 
PROCEDURE_ENTRY(BgL_vz00_14794)(BgL_vz00_14794, BgL_sz00_12471, BEOA); } 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_res4703z00_14795;
BgL_res4703z00_14795 = 
MAKE_YOUNG_PAIR(BgL_arg3009z00_14793, BNIL); 
BgL_newtail1327z00_14792 = BgL_res4703z00_14795; } } 
SET_CDR(BgL_tail1326z00_14791, BgL_newtail1327z00_14792); 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_arg3008z00_14796;
BgL_arg3008z00_14796 = 
CDR(
((obj_t)BgL_l1323z00_14790)); 
{ 
obj_t BgL_tail1326z00_28759;obj_t BgL_l1323z00_28758;
BgL_l1323z00_28758 = BgL_arg3008z00_14796; 
BgL_tail1326z00_28759 = BgL_newtail1327z00_14792; 
BgL_tail1326z00_14791 = BgL_tail1326z00_28759; 
BgL_l1323z00_14790 = BgL_l1323z00_28758; 
goto BgL_zc3anonymousza33006ze3z83_14789;} } } } } 
{ /* Eval/evaluate_comp.scm 509 */
long BgL_g1114z00_14797;
BgL_g1114z00_14797 = 
(
(long)CINT(BgL_bpz00_14777)+BgL_siza7eza7_12468); 
{ 
obj_t BgL_lz00_14799;long BgL_iz00_14800;
BgL_lz00_14799 = BgL_rvalsz00_14786; 
BgL_iz00_14800 = BgL_g1114z00_14797; 
BgL_recz00_14798:
if(
NULLP(BgL_lz00_14799))
{ /* Eval/evaluate_comp.scm 510 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 510 */
{ /* Eval/evaluate_comp.scm 511 */
obj_t BgL_arg3001z00_14801;obj_t BgL_arg3002z00_14802;
BgL_arg3001z00_14801 = 
VECTOR_REF(
((obj_t)BgL_sz00_12471),BgL_iz00_14800); 
BgL_arg3002z00_14802 = 
CAR(
((obj_t)BgL_lz00_14799)); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28770;obj_t BgL_tmpz00_28768;
BgL_auxz00_28770 = 
(int)(((long)0)); 
BgL_tmpz00_28768 = 
((obj_t)BgL_arg3001z00_14801); 
STRUCT_SET(BgL_tmpz00_28768, BgL_auxz00_28770, BgL_arg3002z00_14802); } } 
{ /* Eval/evaluate_comp.scm 512 */
obj_t BgL_arg3003z00_14803;long BgL_arg3004z00_14804;
BgL_arg3003z00_14803 = 
CDR(
((obj_t)BgL_lz00_14799)); 
BgL_arg3004z00_14804 = 
(BgL_iz00_14800+((long)1)); 
{ 
long BgL_iz00_28777;obj_t BgL_lz00_28776;
BgL_lz00_28776 = BgL_arg3003z00_14803; 
BgL_iz00_28777 = BgL_arg3004z00_14804; 
BgL_iz00_14800 = BgL_iz00_28777; 
BgL_lz00_14799 = BgL_lz00_28776; 
goto BgL_recz00_14798;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12470)(BgL_bodyz00_12470, BgL_sz00_12471, BEOA);} } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_let*1412 */
obj_t BGl_z62compzd2ev_letza21412z12zz__evaluate_compz00(obj_t BgL_envz00_12472, obj_t BgL_ez00_12473, obj_t BgL_stkz00_12474)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 474 */
{ /* Eval/evaluate_comp.scm 476 */
long BgL_siza7eza7_14806;obj_t BgL_nstkz00_14807;
BgL_siza7eza7_14806 = 
bgl_list_length(BgL_stkz00_12474); 
{ /* Eval/evaluate_comp.scm 476 */
obj_t BgL_arg2975z00_14808;
BgL_arg2975z00_14808 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12473))))->BgL_varsz00); 
BgL_nstkz00_14807 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12474, BgL_arg2975z00_14808); } 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_valsz00_14809;obj_t BgL_bodyz00_14810;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_l1309z00_14811;
BgL_l1309z00_14811 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12473))))->BgL_valsz00); 
if(
NULLP(BgL_l1309z00_14811))
{ /* Eval/evaluate_comp.scm 477 */
BgL_valsz00_14809 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_head1311z00_14812;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_res4680z00_14813;
BgL_res4680z00_14813 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1311z00_14812 = BgL_res4680z00_14813; } 
{ 
obj_t BgL_l1309z00_14815;obj_t BgL_tail1312z00_14816;
BgL_l1309z00_14815 = BgL_l1309z00_14811; 
BgL_tail1312z00_14816 = BgL_head1311z00_14812; 
BgL_zc3anonymousza32970ze3z83_14814:
if(
NULLP(BgL_l1309z00_14815))
{ /* Eval/evaluate_comp.scm 477 */
BgL_valsz00_14809 = 
CDR(BgL_head1311z00_14812); }  else 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_newtail1313z00_14817;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2973z00_14818;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_vz00_14819;
BgL_vz00_14819 = 
CAR(
((obj_t)BgL_l1309z00_14815)); 
BgL_arg2973z00_14818 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_14819), BgL_nstkz00_14807); } 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_res4682z00_14820;
BgL_res4682z00_14820 = 
MAKE_YOUNG_PAIR(BgL_arg2973z00_14818, BNIL); 
BgL_newtail1313z00_14817 = BgL_res4682z00_14820; } } 
SET_CDR(BgL_tail1312z00_14816, BgL_newtail1313z00_14817); 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2972z00_14821;
BgL_arg2972z00_14821 = 
CDR(
((obj_t)BgL_l1309z00_14815)); 
{ 
obj_t BgL_tail1312z00_28805;obj_t BgL_l1309z00_28804;
BgL_l1309z00_28804 = BgL_arg2972z00_14821; 
BgL_tail1312z00_28805 = BgL_newtail1313z00_14817; 
BgL_tail1312z00_14816 = BgL_tail1312z00_28805; 
BgL_l1309z00_14815 = BgL_l1309z00_28804; 
goto BgL_zc3anonymousza32970ze3z83_14814;} } } } } } 
{ /* Eval/evaluate_comp.scm 478 */
BgL_ev_exprz00_bglt BgL_arg2974z00_14822;
BgL_arg2974z00_14822 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12473))))->BgL_bodyz00); 
BgL_bodyz00_14810 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2974z00_14822, BgL_nstkz00_14807); } 
{ /* Eval/evaluate_comp.scm 479 */
obj_t BgL_zc3anonymousza32959ze3z83_14823;
BgL_zc3anonymousza32959ze3z83_14823 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32959ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza32959ze3z83_14823, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14806)); 
PROCEDURE_SET(BgL_zc3anonymousza32959ze3z83_14823, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_letza2za2_bglt)BgL_ez00_12473))); 
PROCEDURE_SET(BgL_zc3anonymousza32959ze3z83_14823, 
(int)(((long)2)), BgL_valsz00_14809); 
PROCEDURE_SET(BgL_zc3anonymousza32959ze3z83_14823, 
(int)(((long)3)), BgL_bodyz00_14810); 
return BgL_zc3anonymousza32959ze3z83_14823;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2959> */
obj_t BGl_z62zc3anonymousza32959ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12475, obj_t BgL_sz00_12480)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 479 */
{ /* Eval/evaluate_comp.scm 479 */
long BgL_siza7eza7_12476;BgL_ev_letza2za2_bglt BgL_i1108z00_12477;obj_t BgL_valsz00_12478;obj_t BgL_bodyz00_12479;
BgL_siza7eza7_12476 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12475, 
(int)(((long)0)))); 
BgL_i1108z00_12477 = 
((BgL_ev_letza2za2_bglt)
PROCEDURE_REF(BgL_envz00_12475, 
(int)(((long)1)))); 
BgL_valsz00_12478 = 
PROCEDURE_REF(BgL_envz00_12475, 
(int)(((long)2))); 
BgL_bodyz00_12479 = 
PROCEDURE_REF(BgL_envz00_12475, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 479 */
obj_t BgL_bpz00_14824;
BgL_bpz00_14824 = 
VECTOR_REF(
((obj_t)BgL_sz00_12480),((long)0)); 
{ /* Eval/evaluate_comp.scm 480 */
long BgL_g1109z00_14825;
BgL_g1109z00_14825 = 
(
(long)CINT(BgL_bpz00_14824)+BgL_siza7eza7_12476); 
{ 
obj_t BgL_lz00_14827;long BgL_iz00_14828;obj_t BgL_bza2za2_14829;
BgL_lz00_14827 = BgL_valsz00_12478; 
BgL_iz00_14828 = BgL_g1109z00_14825; 
BgL_bza2za2_14829 = 
(((BgL_ev_letza2za2_bglt)COBJECT(BgL_i1108z00_12477))->BgL_boxesz00); 
BgL_recz00_14826:
if(
NULLP(BgL_lz00_14827))
{ /* Eval/evaluate_comp.scm 481 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 481 */
{ /* Eval/evaluate_comp.scm 482 */
obj_t BgL_valz00_14830;
{ /* Eval/evaluate_comp.scm 482 */
obj_t BgL_fun2965z00_14831;
BgL_fun2965z00_14831 = 
CAR(
((obj_t)BgL_lz00_14827)); 
BgL_valz00_14830 = 
PROCEDURE_ENTRY(BgL_fun2965z00_14831)(BgL_fun2965z00_14831, BgL_sz00_12480, BEOA); } 
{ /* Eval/evaluate_comp.scm 483 */
obj_t BgL_arg2963z00_14832;
if(
CBOOL(
CAR(
((obj_t)BgL_bza2za2_14829))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14833;
BgL_newz00_14833 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28852;
BgL_tmpz00_28852 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14833, BgL_tmpz00_28852, BgL_valz00_14830); } 
BgL_arg2963z00_14832 = BgL_newz00_14833; }  else 
{ /* Eval/evaluate_comp.scm 483 */
BgL_arg2963z00_14832 = BgL_valz00_14830; } 
VECTOR_SET(
((obj_t)BgL_sz00_12480),BgL_iz00_14828,BgL_arg2963z00_14832); } } 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg2966z00_14834;long BgL_arg2967z00_14835;obj_t BgL_arg2968z00_14836;
BgL_arg2966z00_14834 = 
CDR(
((obj_t)BgL_lz00_14827)); 
BgL_arg2967z00_14835 = 
(BgL_iz00_14828+((long)1)); 
BgL_arg2968z00_14836 = 
CDR(
((obj_t)BgL_bza2za2_14829)); 
{ 
obj_t BgL_bza2za2_28864;long BgL_iz00_28863;obj_t BgL_lz00_28862;
BgL_lz00_28862 = BgL_arg2966z00_14834; 
BgL_iz00_28863 = BgL_arg2967z00_14835; 
BgL_bza2za2_28864 = BgL_arg2968z00_14836; 
BgL_bza2za2_14829 = BgL_bza2za2_28864; 
BgL_iz00_14828 = BgL_iz00_28863; 
BgL_lz00_14827 = BgL_lz00_28862; 
goto BgL_recz00_14826;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12479)(BgL_bodyz00_12479, BgL_sz00_12480, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &comp-ev_let1410 */
obj_t BGl_z62compzd2ev_let1410zb0zz__evaluate_compz00(obj_t BgL_envz00_12481, obj_t BgL_ez00_12482, obj_t BgL_stkz00_12483)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 455 */
{ /* Eval/evaluate_comp.scm 457 */
long BgL_siza7eza7_14838;obj_t BgL_nstkz00_14839;
BgL_siza7eza7_14838 = 
bgl_list_length(BgL_stkz00_12483); 
{ /* Eval/evaluate_comp.scm 457 */
obj_t BgL_arg2958z00_14840;
BgL_arg2958z00_14840 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12482))))->BgL_varsz00); 
BgL_nstkz00_14839 = 
BGl_appendzd221010zd2zz__evaluate_compz00(BgL_stkz00_12483, BgL_arg2958z00_14840); } 
{ /* Eval/evaluate_comp.scm 458 */
obj_t BgL_valsz00_14841;obj_t BgL_iboxesz00_14842;obj_t BgL_bodyz00_14843;
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_arg2951z00_14844;
BgL_arg2951z00_14844 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12482))))->BgL_valsz00); 
BgL_valsz00_14841 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg2951z00_14844, BgL_stkz00_12483); } 
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_l1304z00_14845;
BgL_l1304z00_14845 = 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_ez00_12482)))->BgL_boxesz00); 
if(
NULLP(BgL_l1304z00_14845))
{ /* Eval/evaluate_comp.scm 460 */
BgL_iboxesz00_14842 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_head1306z00_14846;
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_res4671z00_14847;
BgL_res4671z00_14847 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1306z00_14846 = BgL_res4671z00_14847; } 
{ 
obj_t BgL_l1304z00_14849;obj_t BgL_tail1307z00_14850;
BgL_l1304z00_14849 = BgL_l1304z00_14845; 
BgL_tail1307z00_14850 = BgL_head1306z00_14846; 
BgL_zc3anonymousza32953ze3z83_14848:
if(
NULLP(BgL_l1304z00_14849))
{ /* Eval/evaluate_comp.scm 460 */
BgL_iboxesz00_14842 = 
CDR(BgL_head1306z00_14846); }  else 
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_newtail1308z00_14851;
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_arg2956z00_14852;
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_vz00_14853;
BgL_vz00_14853 = 
CAR(
((obj_t)BgL_l1304z00_14849)); 
BgL_arg2956z00_14852 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_14853, BgL_nstkz00_14839); } 
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_res4673z00_14854;
BgL_res4673z00_14854 = 
MAKE_YOUNG_PAIR(BgL_arg2956z00_14852, BNIL); 
BgL_newtail1308z00_14851 = BgL_res4673z00_14854; } } 
SET_CDR(BgL_tail1307z00_14850, BgL_newtail1308z00_14851); 
{ /* Eval/evaluate_comp.scm 460 */
obj_t BgL_arg2955z00_14855;
BgL_arg2955z00_14855 = 
CDR(
((obj_t)BgL_l1304z00_14849)); 
{ 
obj_t BgL_tail1307z00_28895;obj_t BgL_l1304z00_28894;
BgL_l1304z00_28894 = BgL_arg2955z00_14855; 
BgL_tail1307z00_28895 = BgL_newtail1308z00_14851; 
BgL_tail1307z00_14850 = BgL_tail1307z00_28895; 
BgL_l1304z00_14849 = BgL_l1304z00_28894; 
goto BgL_zc3anonymousza32953ze3z83_14848;} } } } } } 
{ /* Eval/evaluate_comp.scm 461 */
BgL_ev_exprz00_bglt BgL_arg2957z00_14856;
BgL_arg2957z00_14856 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12482))))->BgL_bodyz00); 
BgL_bodyz00_14843 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2957z00_14856, BgL_nstkz00_14839); } 
{ /* Eval/evaluate_comp.scm 462 */
obj_t BgL_zc3anonymousza32938ze3z83_14857;
BgL_zc3anonymousza32938ze3z83_14857 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32938ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3anonymousza32938ze3z83_14857, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14838)); 
PROCEDURE_SET(BgL_zc3anonymousza32938ze3z83_14857, 
(int)(((long)1)), BgL_valsz00_14841); 
PROCEDURE_SET(BgL_zc3anonymousza32938ze3z83_14857, 
(int)(((long)2)), BgL_iboxesz00_14842); 
PROCEDURE_SET(BgL_zc3anonymousza32938ze3z83_14857, 
(int)(((long)3)), BgL_bodyz00_14843); 
return BgL_zc3anonymousza32938ze3z83_14857;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2938> */
obj_t BGl_z62zc3anonymousza32938ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12484, obj_t BgL_sz00_12489)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 462 */
{ /* Eval/evaluate_comp.scm 462 */
long BgL_siza7eza7_12485;obj_t BgL_valsz00_12486;obj_t BgL_iboxesz00_12487;obj_t BgL_bodyz00_12488;
BgL_siza7eza7_12485 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12484, 
(int)(((long)0)))); 
BgL_valsz00_12486 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12484, 
(int)(((long)1)))); 
BgL_iboxesz00_12487 = 
PROCEDURE_REF(BgL_envz00_12484, 
(int)(((long)2))); 
BgL_bodyz00_12488 = 
PROCEDURE_REF(BgL_envz00_12484, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 462 */
obj_t BgL_bpz00_14858;
BgL_bpz00_14858 = 
VECTOR_REF(
((obj_t)BgL_sz00_12489),((long)0)); 
{ /* Eval/evaluate_comp.scm 463 */
long BgL_g1107z00_14859;
BgL_g1107z00_14859 = 
(
(long)CINT(BgL_bpz00_14858)+BgL_siza7eza7_12485); 
{ 
obj_t BgL_lz00_14861;long BgL_iz00_14862;
BgL_lz00_14861 = BgL_valsz00_12486; 
BgL_iz00_14862 = BgL_g1107z00_14859; 
BgL_recz00_14860:
if(
NULLP(BgL_lz00_14861))
{ /* Eval/evaluate_comp.scm 464 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 464 */
{ /* Eval/evaluate_comp.scm 465 */
obj_t BgL_arg2941z00_14863;
{ /* Eval/evaluate_comp.scm 465 */
obj_t BgL_fun2942z00_14864;
BgL_fun2942z00_14864 = 
CAR(
((obj_t)BgL_lz00_14861)); 
BgL_arg2941z00_14863 = 
PROCEDURE_ENTRY(BgL_fun2942z00_14864)(BgL_fun2942z00_14864, BgL_sz00_12489, BEOA); } 
VECTOR_SET(
((obj_t)BgL_sz00_12489),BgL_iz00_14862,BgL_arg2941z00_14863); } 
{ /* Eval/evaluate_comp.scm 466 */
obj_t BgL_arg2943z00_14865;long BgL_arg2944z00_14866;
BgL_arg2943z00_14865 = 
CDR(
((obj_t)BgL_lz00_14861)); 
BgL_arg2944z00_14866 = 
(BgL_iz00_14862+((long)1)); 
{ 
long BgL_iz00_28940;obj_t BgL_lz00_28939;
BgL_lz00_28939 = BgL_arg2943z00_14865; 
BgL_iz00_28940 = BgL_arg2944z00_14866; 
BgL_iz00_14862 = BgL_iz00_28940; 
BgL_lz00_14861 = BgL_lz00_28939; 
goto BgL_recz00_14860;} } } } } 
{ 
obj_t BgL_lz00_14868;
BgL_lz00_14868 = BgL_iboxesz00_12487; 
BgL_recz00_14867:
if(
NULLP(BgL_lz00_14868))
{ /* Eval/evaluate_comp.scm 468 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 468 */
{ /* Eval/evaluate_comp.scm 469 */
long BgL_iz00_14869;
BgL_iz00_14869 = 
(
(long)CINT(BgL_bpz00_14858)+
(long)CINT(
CAR(
((obj_t)BgL_lz00_14868)))); 
{ /* Eval/evaluate_comp.scm 470 */
obj_t BgL_arg2947z00_14870;
{ /* Eval/evaluate_comp.scm 470 */
obj_t BgL_arg2948z00_14871;
BgL_arg2948z00_14871 = 
VECTOR_REF(
((obj_t)BgL_sz00_12489),BgL_iz00_14869); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14872;
BgL_newz00_14872 = 
create_struct(BGl_symbol5204z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28952;
BgL_tmpz00_28952 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14872, BgL_tmpz00_28952, BgL_arg2948z00_14871); } 
BgL_arg2947z00_14870 = BgL_newz00_14872; } } 
VECTOR_SET(
((obj_t)BgL_sz00_12489),BgL_iz00_14869,BgL_arg2947z00_14870); } } 
{ /* Eval/evaluate_comp.scm 471 */
obj_t BgL_arg2950z00_14873;
BgL_arg2950z00_14873 = 
CDR(
((obj_t)BgL_lz00_14868)); 
{ 
obj_t BgL_lz00_28959;
BgL_lz00_28959 = BgL_arg2950z00_14873; 
BgL_lz00_14868 = BgL_lz00_28959; 
goto BgL_recz00_14867;} } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12488)(BgL_bodyz00_12488, BgL_sz00_12489, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &comp-ev_prog21408 */
obj_t BGl_z62compzd2ev_prog21408zb0zz__evaluate_compz00(obj_t BgL_envz00_12490, obj_t BgL_ez00_12491, obj_t BgL_stkz00_12492)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 449 */
{ /* Eval/evaluate_comp.scm 451 */
obj_t BgL_e1z00_14875;obj_t BgL_e2z00_14876;
BgL_e1z00_14875 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_12491)))->BgL_e1z00), BgL_stkz00_12492); 
BgL_e2z00_14876 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_12491)))->BgL_e2z00), BgL_stkz00_12492); 
{ /* Eval/evaluate_comp.scm 452 */
obj_t BgL_zc3anonymousza32935ze3z83_14877;
BgL_zc3anonymousza32935ze3z83_14877 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32935ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32935ze3z83_14877, 
(int)(((long)0)), BgL_e1z00_14875); 
PROCEDURE_SET(BgL_zc3anonymousza32935ze3z83_14877, 
(int)(((long)1)), BgL_e2z00_14876); 
return BgL_zc3anonymousza32935ze3z83_14877;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2935> */
obj_t BGl_z62zc3anonymousza32935ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12493, obj_t BgL_sz00_12496)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 452 */
{ /* Eval/evaluate_comp.scm 452 */
obj_t BgL_e1z00_12494;obj_t BgL_e2z00_12495;
BgL_e1z00_12494 = 
PROCEDURE_REF(BgL_envz00_12493, 
(int)(((long)0))); 
BgL_e2z00_12495 = 
PROCEDURE_REF(BgL_envz00_12493, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 452 */
obj_t BgL_bpz00_14878;
BgL_bpz00_14878 = 
VECTOR_REF(
((obj_t)BgL_sz00_12496),((long)0)); 
PROCEDURE_ENTRY(BgL_e1z00_12494)(BgL_e1z00_12494, BgL_sz00_12496, BEOA); 
return 
PROCEDURE_ENTRY(BgL_e2z00_12495)(BgL_e2z00_12495, BgL_sz00_12496, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &comp-ev_and1406 */
obj_t BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00(obj_t BgL_envz00_12497, obj_t BgL_ez00_12498, obj_t BgL_stkz00_12499)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 439 */
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_argsz00_14880;
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_l1299z00_14881;
BgL_l1299z00_14881 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_ez00_12498))))->BgL_argsz00); 
if(
NULLP(BgL_l1299z00_14881))
{ /* Eval/evaluate_comp.scm 441 */
BgL_argsz00_14880 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_head1301z00_14882;
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_res4666z00_14883;
BgL_res4666z00_14883 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1301z00_14882 = BgL_res4666z00_14883; } 
{ 
obj_t BgL_l1299z00_14885;obj_t BgL_tail1302z00_14886;
BgL_l1299z00_14885 = BgL_l1299z00_14881; 
BgL_tail1302z00_14886 = BgL_head1301z00_14882; 
BgL_zc3anonymousza32931ze3z83_14884:
if(
NULLP(BgL_l1299z00_14885))
{ /* Eval/evaluate_comp.scm 441 */
BgL_argsz00_14880 = 
CDR(BgL_head1301z00_14882); }  else 
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_newtail1303z00_14887;
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_arg2934z00_14888;
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_ez00_14889;
BgL_ez00_14889 = 
CAR(
((obj_t)BgL_l1299z00_14885)); 
BgL_arg2934z00_14888 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_14889), BgL_stkz00_12499); } 
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_res4668z00_14890;
BgL_res4668z00_14890 = 
MAKE_YOUNG_PAIR(BgL_arg2934z00_14888, BNIL); 
BgL_newtail1303z00_14887 = BgL_res4668z00_14890; } } 
SET_CDR(BgL_tail1302z00_14886, BgL_newtail1303z00_14887); 
{ /* Eval/evaluate_comp.scm 441 */
obj_t BgL_arg2933z00_14891;
BgL_arg2933z00_14891 = 
CDR(
((obj_t)BgL_l1299z00_14885)); 
{ 
obj_t BgL_tail1302z00_29009;obj_t BgL_l1299z00_29008;
BgL_l1299z00_29008 = BgL_arg2933z00_14891; 
BgL_tail1302z00_29009 = BgL_newtail1303z00_14887; 
BgL_tail1302z00_14886 = BgL_tail1302z00_29009; 
BgL_l1299z00_14885 = BgL_l1299z00_29008; 
goto BgL_zc3anonymousza32931ze3z83_14884;} } } } } } 
{ /* Eval/evaluate_comp.scm 442 */
obj_t BgL_zc3anonymousza32925ze3z83_14892;
BgL_zc3anonymousza32925ze3z83_14892 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32925ze3z83_14892, 
(int)(((long)0)), BgL_argsz00_14880); 
return BgL_zc3anonymousza32925ze3z83_14892;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2925> */
obj_t BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12500, obj_t BgL_sz00_12502)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 442 */
{ /* Eval/evaluate_comp.scm 442 */
obj_t BgL_argsz00_12501;
BgL_argsz00_12501 = 
PROCEDURE_REF(BgL_envz00_12500, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 442 */
obj_t BgL_bpz00_14893;
BgL_bpz00_14893 = 
VECTOR_REF(
((obj_t)BgL_sz00_12502),((long)0)); 
{ 
obj_t BgL_lz00_14895;obj_t BgL_rz00_14896;
BgL_lz00_14895 = BgL_argsz00_12501; 
BgL_rz00_14896 = BTRUE; 
BgL_recz00_14894:
if(
NULLP(BgL_lz00_14895))
{ /* Eval/evaluate_comp.scm 444 */
return BgL_rz00_14896;}  else 
{ /* Eval/evaluate_comp.scm 446 */
obj_t BgL_vz00_14897;
{ /* Eval/evaluate_comp.scm 446 */
obj_t BgL_fun2929z00_14898;
BgL_fun2929z00_14898 = 
CAR(
((obj_t)BgL_lz00_14895)); 
BgL_vz00_14897 = 
PROCEDURE_ENTRY(BgL_fun2929z00_14898)(BgL_fun2929z00_14898, BgL_sz00_12502, BEOA); } 
if(
CBOOL(BgL_vz00_14897))
{ /* Eval/evaluate_comp.scm 447 */
obj_t BgL_arg2928z00_14899;
BgL_arg2928z00_14899 = 
CDR(
((obj_t)BgL_lz00_14895)); 
{ 
obj_t BgL_rz00_29032;obj_t BgL_lz00_29031;
BgL_lz00_29031 = BgL_arg2928z00_14899; 
BgL_rz00_29032 = BgL_vz00_14897; 
BgL_rz00_14896 = BgL_rz00_29032; 
BgL_lz00_14895 = BgL_lz00_29031; 
goto BgL_recz00_14894;} }  else 
{ /* Eval/evaluate_comp.scm 447 */
return BFALSE;} } } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_or1404 */
obj_t BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00(obj_t BgL_envz00_12503, obj_t BgL_ez00_12504, obj_t BgL_stkz00_12505)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 430 */
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_argsz00_14901;
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_l1294z00_14902;
BgL_l1294z00_14902 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_ez00_12504))))->BgL_argsz00); 
if(
NULLP(BgL_l1294z00_14902))
{ /* Eval/evaluate_comp.scm 432 */
BgL_argsz00_14901 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_head1296z00_14903;
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_res4661z00_14904;
BgL_res4661z00_14904 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1296z00_14903 = BgL_res4661z00_14904; } 
{ 
obj_t BgL_l1294z00_14906;obj_t BgL_tail1297z00_14907;
BgL_l1294z00_14906 = BgL_l1294z00_14902; 
BgL_tail1297z00_14907 = BgL_head1296z00_14903; 
BgL_zc3anonymousza32921ze3z83_14905:
if(
NULLP(BgL_l1294z00_14906))
{ /* Eval/evaluate_comp.scm 432 */
BgL_argsz00_14901 = 
CDR(BgL_head1296z00_14903); }  else 
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_newtail1298z00_14908;
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_arg2924z00_14909;
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_ez00_14910;
BgL_ez00_14910 = 
CAR(
((obj_t)BgL_l1294z00_14906)); 
BgL_arg2924z00_14909 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_14910), BgL_stkz00_12505); } 
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_res4663z00_14911;
BgL_res4663z00_14911 = 
MAKE_YOUNG_PAIR(BgL_arg2924z00_14909, BNIL); 
BgL_newtail1298z00_14908 = BgL_res4663z00_14911; } } 
SET_CDR(BgL_tail1297z00_14907, BgL_newtail1298z00_14908); 
{ /* Eval/evaluate_comp.scm 432 */
obj_t BgL_arg2923z00_14912;
BgL_arg2923z00_14912 = 
CDR(
((obj_t)BgL_l1294z00_14906)); 
{ 
obj_t BgL_tail1297z00_29051;obj_t BgL_l1294z00_29050;
BgL_l1294z00_29050 = BgL_arg2923z00_14912; 
BgL_tail1297z00_29051 = BgL_newtail1298z00_14908; 
BgL_tail1297z00_14907 = BgL_tail1297z00_29051; 
BgL_l1294z00_14906 = BgL_l1294z00_29050; 
goto BgL_zc3anonymousza32921ze3z83_14905;} } } } } } 
{ /* Eval/evaluate_comp.scm 433 */
obj_t BgL_zc3anonymousza32915ze3z83_14913;
BgL_zc3anonymousza32915ze3z83_14913 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32915ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32915ze3z83_14913, 
(int)(((long)0)), BgL_argsz00_14901); 
return BgL_zc3anonymousza32915ze3z83_14913;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2915> */
obj_t BGl_z62zc3anonymousza32915ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12506, obj_t BgL_sz00_12508)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 433 */
{ /* Eval/evaluate_comp.scm 433 */
obj_t BgL_argsz00_12507;
BgL_argsz00_12507 = 
PROCEDURE_REF(BgL_envz00_12506, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 433 */
obj_t BgL_bpz00_14914;
BgL_bpz00_14914 = 
VECTOR_REF(
((obj_t)BgL_sz00_12508),((long)0)); 
{ 
obj_t BgL_lz00_14916;
BgL_lz00_14916 = BgL_argsz00_12507; 
BgL_recz00_14915:
if(
NULLP(BgL_lz00_14916))
{ /* Eval/evaluate_comp.scm 435 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 437 */
obj_t BgL__ortest_1102z00_14917;
{ /* Eval/evaluate_comp.scm 437 */
obj_t BgL_fun2919z00_14918;
BgL_fun2919z00_14918 = 
CAR(
((obj_t)BgL_lz00_14916)); 
BgL__ortest_1102z00_14917 = 
PROCEDURE_ENTRY(BgL_fun2919z00_14918)(BgL_fun2919z00_14918, BgL_sz00_12508, BEOA); } 
if(
CBOOL(BgL__ortest_1102z00_14917))
{ /* Eval/evaluate_comp.scm 437 */
return BgL__ortest_1102z00_14917;}  else 
{ /* Eval/evaluate_comp.scm 437 */
obj_t BgL_arg2918z00_14919;
BgL_arg2918z00_14919 = 
CDR(
((obj_t)BgL_lz00_14916)); 
{ 
obj_t BgL_lz00_29073;
BgL_lz00_29073 = BgL_arg2918z00_14919; 
BgL_lz00_14916 = BgL_lz00_29073; 
goto BgL_recz00_14915;} } } } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_if1402 */
obj_t BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00(obj_t BgL_envz00_12509, obj_t BgL_ez00_12510, obj_t BgL_stkz00_12511)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 424 */
{ /* Eval/evaluate_comp.scm 426 */
obj_t BgL_pz00_14921;obj_t BgL_tz00_14922;obj_t BgL_ez00_14923;
BgL_pz00_14921 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12510)))->BgL_pz00), BgL_stkz00_12511); 
BgL_tz00_14922 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12510)))->BgL_tz00), BgL_stkz00_12511); 
BgL_ez00_14923 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12510)))->BgL_ez00), BgL_stkz00_12511); 
{ /* Eval/evaluate_comp.scm 427 */
obj_t BgL_zc3anonymousza32910ze3z83_14924;
BgL_zc3anonymousza32910ze3z83_14924 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32910ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32910ze3z83_14924, 
(int)(((long)0)), BgL_ez00_14923); 
PROCEDURE_SET(BgL_zc3anonymousza32910ze3z83_14924, 
(int)(((long)1)), BgL_tz00_14922); 
PROCEDURE_SET(BgL_zc3anonymousza32910ze3z83_14924, 
(int)(((long)2)), BgL_pz00_14921); 
return BgL_zc3anonymousza32910ze3z83_14924;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2910> */
obj_t BGl_z62zc3anonymousza32910ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12512, obj_t BgL_sz00_12516)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 427 */
{ /* Eval/evaluate_comp.scm 427 */
obj_t BgL_ez00_12513;obj_t BgL_tz00_12514;obj_t BgL_pz00_12515;
BgL_ez00_12513 = 
PROCEDURE_REF(BgL_envz00_12512, 
(int)(((long)0))); 
BgL_tz00_12514 = 
PROCEDURE_REF(BgL_envz00_12512, 
(int)(((long)1))); 
BgL_pz00_12515 = 
PROCEDURE_REF(BgL_envz00_12512, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 427 */
obj_t BgL_bpz00_14925;
BgL_bpz00_14925 = 
VECTOR_REF(
((obj_t)BgL_sz00_12516),((long)0)); 
if(
CBOOL(
PROCEDURE_ENTRY(BgL_pz00_12515)(BgL_pz00_12515, BgL_sz00_12516, BEOA)))
{ /* Eval/evaluate_comp.scm 428 */
return 
PROCEDURE_ENTRY(BgL_tz00_12514)(BgL_tz00_12514, BgL_sz00_12516, BEOA);}  else 
{ /* Eval/evaluate_comp.scm 428 */
return 
PROCEDURE_ENTRY(BgL_ez00_12513)(BgL_ez00_12513, BgL_sz00_12516, BEOA);} } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_litt1400 */
obj_t BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00(obj_t BgL_envz00_12517, obj_t BgL_ez00_12518, obj_t BgL_stkz00_12519)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 419 */
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_zc3anonymousza32909ze3z83_14927;
BgL_zc3anonymousza32909ze3z83_14927 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32909ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32909ze3z83_14927, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_littz00_bglt)BgL_ez00_12518))); 
return BgL_zc3anonymousza32909ze3z83_14927;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2909> */
obj_t BGl_z62zc3anonymousza32909ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12520, obj_t BgL_sz00_12522)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 421 */
{ /* Eval/evaluate_comp.scm 421 */
BgL_ev_littz00_bglt BgL_i1099z00_12521;
BgL_i1099z00_12521 = 
((BgL_ev_littz00_bglt)
PROCEDURE_REF(BgL_envz00_12520, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_bpz00_14928;
BgL_bpz00_14928 = 
VECTOR_REF(
((obj_t)BgL_sz00_12522),((long)0)); 
return 
(((BgL_ev_littz00_bglt)COBJECT(BgL_i1099z00_12521))->BgL_valuez00);} } } 
BGL_FUNCTION_END;
}



/* &comp-ev_defglobal1398 */
obj_t BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00(obj_t BgL_envz00_12523, obj_t BgL_ez00_12524, obj_t BgL_stkz00_12525)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 388 */
{ /* Eval/evaluate_comp.scm 390 */
obj_t BgL_ez00_14930;
{ /* Eval/evaluate_comp.scm 390 */
BgL_ev_exprz00_bglt BgL_arg2908z00_14931;
BgL_arg2908z00_14931 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_ez00_12524))))->BgL_ez00); 
BgL_ez00_14930 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2908z00_14931, BgL_stkz00_12525); } 
{ /* Eval/evaluate_comp.scm 391 */
obj_t BgL_zc3anonymousza32883ze3z83_14932;
BgL_zc3anonymousza32883ze3z83_14932 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32883ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32883ze3z83_14932, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_defglobalz00_bglt)BgL_ez00_12524))); 
PROCEDURE_SET(BgL_zc3anonymousza32883ze3z83_14932, 
(int)(((long)1)), BgL_ez00_14930); 
return BgL_zc3anonymousza32883ze3z83_14932;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2883> */
obj_t BGl_z62zc3anonymousza32883ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12526, obj_t BgL_sz00_12529)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 391 */
{ /* Eval/evaluate_comp.scm 391 */
BgL_ev_defglobalz00_bglt BgL_i1096z00_12527;obj_t BgL_ez00_12528;
BgL_i1096z00_12527 = 
((BgL_ev_defglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_12526, 
(int)(((long)0)))); 
BgL_ez00_12528 = 
PROCEDURE_REF(BgL_envz00_12526, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 391 */
obj_t BgL_bpz00_14933;
BgL_bpz00_14933 = 
VECTOR_REF(
((obj_t)BgL_sz00_12529),((long)0)); 
{ /* Eval/evaluate_comp.scm 392 */
obj_t BgL_gz00_14934;
{ /* Eval/evaluate_comp.scm 392 */
obj_t BgL_arg2906z00_14935;obj_t BgL_arg2907z00_14936;
BgL_arg2906z00_14935 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_modz00); 
BgL_arg2907z00_14936 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00); 
BgL_gz00_14934 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2906z00_14935, BgL_arg2907z00_14936); } 
if(
CBOOL(BgL_gz00_14934))
{ /* Eval/evaluate_comp.scm 394 */
{ 

{ /* Eval/evaluate_comp.scm 396 */
int BgL_aux1098z00_14940;
{ /* Eval/evaluate_comp.scm 396 */
int BgL_res4659z00_14941;
BgL_res4659z00_14941 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14934),((long)0))); 
BgL_aux1098z00_14940 = BgL_res4659z00_14941; } 
switch( 
(long)(BgL_aux1098z00_14940)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_arg2885z00_14942;obj_t BgL_arg2886z00_14943;
BgL_arg2885z00_14942 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_locz00); 
BgL_arg2886z00_14943 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2885z00_14942, BGl_string5315z00zz__evaluate_compz00, BGl_string5316z00zz__evaluate_compz00, BgL_arg2886z00_14943); } break;case ((long)1) : 

{ /* Eval/evaluate_comp.scm 400 */
obj_t BgL_arg2887z00_14944;obj_t BgL_arg2888z00_14945;
BgL_arg2887z00_14944 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_locz00); 
BgL_arg2888z00_14945 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00); 
{ /* Eval/evaluate_comp.scm 400 */
obj_t BgL_list2889z00_14946;
{ /* Eval/evaluate_comp.scm 400 */
obj_t BgL_arg2890z00_14947;
{ /* Eval/evaluate_comp.scm 400 */
obj_t BgL_arg2891z00_14948;
BgL_arg2891z00_14948 = 
MAKE_YOUNG_PAIR(BgL_arg2888z00_14945, BNIL); 
BgL_arg2890z00_14947 = 
MAKE_YOUNG_PAIR(BGl_string5317z00zz__evaluate_compz00, BgL_arg2891z00_14948); } 
BgL_list2889z00_14946 = 
MAKE_YOUNG_PAIR(BGl_string5194z00zz__evaluate_compz00, BgL_arg2890z00_14947); } 
BGl_evwarningz00zz__everrorz00(BgL_arg2887z00_14944, BgL_list2889z00_14946); } } 
{ /* Eval/evaluate_comp.scm 402 */
obj_t BgL_arg2892z00_14949;obj_t BgL_arg2893z00_14950;
BgL_arg2892z00_14949 = 
VECTOR_REF(
((obj_t)BgL_gz00_14934),((long)2)); 
BgL_arg2893z00_14950 = 
PROCEDURE_ENTRY(BgL_ez00_12528)(BgL_ez00_12528, BgL_sz00_12529, BEOA); 
__EVMEANING_ADDRESS_SET(BgL_arg2892z00_14949, BgL_arg2893z00_14950); } break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 404 */
obj_t BgL_arg2894z00_14951;
BgL_arg2894z00_14951 = 
PROCEDURE_ENTRY(BgL_ez00_12528)(BgL_ez00_12528, BgL_sz00_12529, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14934),((long)2),BgL_arg2894z00_14951); } break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 406 */
obj_t BgL_arg2895z00_14952;
BgL_arg2895z00_14952 = 
PROCEDURE_ENTRY(BgL_ez00_12528)(BgL_ez00_12528, BgL_sz00_12529, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14934),((long)2),BgL_arg2895z00_14952); } 
VECTOR_SET(
((obj_t)BgL_gz00_14934),((long)0),
BINT(((long)2))); break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 409 */
obj_t BgL_arg2896z00_14953;
BgL_arg2896z00_14953 = 
PROCEDURE_ENTRY(BgL_ez00_12528)(BgL_ez00_12528, BgL_sz00_12529, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14934),((long)2),BgL_arg2896z00_14953); } 
VECTOR_SET(
((obj_t)BgL_gz00_14934),((long)0),
BINT(((long)5))); break;
default: 
{ /* Eval/evaluate_comp.scm 412 */
obj_t BgL_arg2897z00_14938;obj_t BgL_arg2898z00_14939;
BgL_arg2897z00_14938 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_locz00); 
BgL_arg2898z00_14939 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2897z00_14938, BGl_string5315z00zz__evaluate_compz00, BGl_string5316z00zz__evaluate_compz00, BgL_arg2898z00_14939); } } } } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 414 */
obj_t BgL_gz00_14954;
{ /* Eval/evaluate_comp.scm 414 */
obj_t BgL_arg2903z00_14955;obj_t BgL_arg2904z00_14956;obj_t BgL_arg2905z00_14957;
BgL_arg2903z00_14955 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00); 
BgL_arg2904z00_14956 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_modz00); 
BgL_arg2905z00_14957 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 414 */
obj_t BgL_v1372z00_14958;
BgL_v1372z00_14958 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1372z00_14958,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1372z00_14958,((long)1),BgL_arg2903z00_14955); 
VECTOR_SET(BgL_v1372z00_14958,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1372z00_14958,((long)3),BgL_arg2904z00_14956); 
VECTOR_SET(BgL_v1372z00_14958,((long)4),BgL_arg2905z00_14957); 
BgL_gz00_14954 = BgL_v1372z00_14958; } } 
{ /* Eval/evaluate_comp.scm 415 */
obj_t BgL_arg2899z00_14959;
BgL_arg2899z00_14959 = 
PROCEDURE_ENTRY(BgL_ez00_12528)(BgL_ez00_12528, BgL_sz00_12529, BEOA); 
VECTOR_SET(BgL_gz00_14954,((long)2),BgL_arg2899z00_14959); } 
{ /* Eval/evaluate_comp.scm 416 */
obj_t BgL_arg2900z00_14960;obj_t BgL_arg2901z00_14961;obj_t BgL_arg2902z00_14962;
BgL_arg2900z00_14960 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_modz00); 
BgL_arg2901z00_14961 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00); 
BgL_arg2902z00_14962 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_locz00); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(BgL_arg2900z00_14960, BgL_arg2901z00_14961, BgL_gz00_14954, BgL_arg2902z00_14962); } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12527)))->BgL_namez00);} } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_setglobal1396 */
obj_t BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00(obj_t BgL_envz00_12530, obj_t BgL_ez00_12531, obj_t BgL_stkz00_12532)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 365 */
{ /* Eval/evaluate_comp.scm 367 */
obj_t BgL_gz00_14964;obj_t BgL_ez00_14965;
BgL_gz00_14964 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_namez00)); 
{ /* Eval/evaluate_comp.scm 367 */
BgL_ev_exprz00_bglt BgL_arg2882z00_14966;
BgL_arg2882z00_14966 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531))))->BgL_ez00); 
BgL_ez00_14965 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2882z00_14966, BgL_stkz00_12532); } 
if(
CBOOL(BgL_gz00_14964))
{ 

{ /* Eval/evaluate_comp.scm 369 */
int BgL_aux1095z00_14969;
{ /* Eval/evaluate_comp.scm 369 */
int BgL_res4658z00_14970;
BgL_res4658z00_14970 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14964),((long)0))); 
BgL_aux1095z00_14969 = BgL_res4658z00_14970; } 
switch( 
(long)(BgL_aux1095z00_14969)) { case ((long)1) : 

{ /* Eval/evaluate_comp.scm 371 */
obj_t BgL_zc3anonymousza32858ze3z83_14971;
BgL_zc3anonymousza32858ze3z83_14971 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32858ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32858ze3z83_14971, 
(int)(((long)0)), BgL_gz00_14964); 
PROCEDURE_SET(BgL_zc3anonymousza32858ze3z83_14971, 
(int)(((long)1)), BgL_ez00_14965); 
return BgL_zc3anonymousza32858ze3z83_14971;} break;case ((long)0) : 
case ((long)4) : 
case ((long)5) : 

return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_locz00), BGl_string5315z00zz__evaluate_compz00, BGl_string5316z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_namez00));break;
default: 
{ /* Eval/evaluate_comp.scm 376 */
obj_t BgL_zc3anonymousza32863ze3z83_14968;
BgL_zc3anonymousza32863ze3z83_14968 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32863ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32863ze3z83_14968, 
(int)(((long)0)), BgL_ez00_14965); 
PROCEDURE_SET(BgL_zc3anonymousza32863ze3z83_14968, 
(int)(((long)1)), BgL_gz00_14964); 
return BgL_zc3anonymousza32863ze3z83_14968;} } } }  else 
{ /* Eval/evaluate_comp.scm 377 */
obj_t BgL_slotz00_14972;
BgL_slotz00_14972 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 379 */
obj_t BgL_gz00_14973;
{ /* Eval/evaluate_comp.scm 379 */
obj_t BgL_arg2870z00_14974;obj_t BgL_arg2871z00_14975;obj_t BgL_arg2872z00_14976;
BgL_arg2870z00_14974 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_namez00); 
BgL_arg2871z00_14975 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_modz00); 
BgL_arg2872z00_14976 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 379 */
obj_t BgL_v1372z00_14977;
BgL_v1372z00_14977 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1372z00_14977,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1372z00_14977,((long)1),BgL_arg2870z00_14974); 
VECTOR_SET(BgL_v1372z00_14977,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1372z00_14977,((long)3),BgL_arg2871z00_14975); 
VECTOR_SET(BgL_v1372z00_14977,((long)4),BgL_arg2872z00_14976); 
BgL_gz00_14973 = BgL_v1372z00_14977; } } 
VECTOR_SET(BgL_gz00_14973,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_namez00), BgL_gz00_14973, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 378 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 382 */
obj_t BgL_zc3anonymousza32874ze3z83_14978;
BgL_zc3anonymousza32874ze3z83_14978 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3anonymousza32874ze3z83_14978, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_setglobalz00_bglt)BgL_ez00_12531))); 
PROCEDURE_SET(BgL_zc3anonymousza32874ze3z83_14978, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_14972)); 
PROCEDURE_SET(BgL_zc3anonymousza32874ze3z83_14978, 
(int)(((long)2)), BgL_ez00_14965); 
return BgL_zc3anonymousza32874ze3z83_14978;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2858> */
obj_t BGl_z62zc3anonymousza32858ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12535, obj_t BgL_sz00_12538)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 371 */
{ /* Eval/evaluate_comp.scm 371 */
obj_t BgL_gz00_12536;obj_t BgL_ez00_12537;
BgL_gz00_12536 = 
PROCEDURE_REF(BgL_envz00_12535, 
(int)(((long)0))); 
BgL_ez00_12537 = 
PROCEDURE_REF(BgL_envz00_12535, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 371 */
obj_t BgL_bpz00_14979;
BgL_bpz00_14979 = 
VECTOR_REF(
((obj_t)BgL_sz00_12538),((long)0)); 
{ /* Eval/evaluate_comp.scm 372 */
obj_t BgL_arg2859z00_14980;obj_t BgL_arg2860z00_14981;
BgL_arg2859z00_14980 = 
VECTOR_REF(
((obj_t)BgL_gz00_12536),((long)2)); 
BgL_arg2860z00_14981 = 
PROCEDURE_ENTRY(BgL_ez00_12537)(BgL_ez00_12537, BgL_sz00_12538, BEOA); 
return 
__EVMEANING_ADDRESS_SET(BgL_arg2859z00_14980, BgL_arg2860z00_14981);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2863> */
obj_t BGl_z62zc3anonymousza32863ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12539, obj_t BgL_sz00_12542)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 376 */
{ /* Eval/evaluate_comp.scm 376 */
obj_t BgL_ez00_12540;obj_t BgL_gz00_12541;
BgL_ez00_12540 = 
PROCEDURE_REF(BgL_envz00_12539, 
(int)(((long)0))); 
BgL_gz00_12541 = 
PROCEDURE_REF(BgL_envz00_12539, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 376 */
obj_t BgL_bpz00_14982;
BgL_bpz00_14982 = 
VECTOR_REF(
((obj_t)BgL_sz00_12542),((long)0)); 
{ /* Eval/evaluate_comp.scm 376 */
obj_t BgL_arg2864z00_14983;
BgL_arg2864z00_14983 = 
PROCEDURE_ENTRY(BgL_ez00_12540)(BgL_ez00_12540, BgL_sz00_12542, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_gz00_12541),((long)2),BgL_arg2864z00_14983);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2874> */
obj_t BGl_z62zc3anonymousza32874ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12543, obj_t BgL_sz00_12547)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 382 */
{ /* Eval/evaluate_comp.scm 382 */
BgL_ev_setglobalz00_bglt BgL_i1093z00_12544;obj_t BgL_slotz00_12545;obj_t BgL_ez00_12546;
BgL_i1093z00_12544 = 
((BgL_ev_setglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_12543, 
(int)(((long)0)))); 
BgL_slotz00_12545 = 
PROCEDURE_REF(BgL_envz00_12543, 
(int)(((long)1))); 
BgL_ez00_12546 = 
PROCEDURE_REF(BgL_envz00_12543, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 382 */
obj_t BgL_bpz00_14984;
BgL_bpz00_14984 = 
VECTOR_REF(
((obj_t)BgL_sz00_12547),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_12545)))
{ /* Eval/evaluate_comp.scm 383 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 383 */
{ /* Eval/evaluate_comp.scm 384 */
obj_t BgL_auxz00_14985;
BgL_auxz00_14985 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12544))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12544))->BgL_namez00)); 
CELL_SET(BgL_slotz00_12545, BgL_auxz00_14985); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_12545)))
{ /* Eval/evaluate_comp.scm 385 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 385 */
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12544))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5318z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12544))->BgL_namez00)); } } 
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_arg2879z00_14986;
BgL_arg2879z00_14986 = 
PROCEDURE_ENTRY(BgL_ez00_12546)(BgL_ez00_12546, BgL_sz00_12547, BEOA); 
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_evalzd2globalzd2_14987;
BgL_evalzd2globalzd2_14987 = 
CELL_REF(BgL_slotz00_12545); 
return 
VECTOR_SET(BgL_evalzd2globalzd2_14987,((long)2),BgL_arg2879z00_14986);} } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_global1394 */
obj_t BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00(obj_t BgL_envz00_12549, obj_t BgL_varz00_12550, obj_t BgL_stkz00_12551)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 339 */
{ /* Eval/evaluate_comp.scm 341 */
obj_t BgL_gz00_14989;
BgL_gz00_14989 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_namez00)); 
if(
CBOOL(BgL_gz00_14989))
{ /* Eval/evaluate_comp.scm 343 */
bool_t BgL_testz00_29366;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_arg2835z00_14990;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_res4654z00_14991;
BgL_res4654z00_14991 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14989),((long)0))); 
BgL_arg2835z00_14990 = BgL_res4654z00_14991; } 
BgL_testz00_29366 = 
(
BINT(BgL_arg2835z00_14990)==
BINT(((long)1))); } 
if(BgL_testz00_29366)
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_zc3anonymousza32832ze3z83_14992;
BgL_zc3anonymousza32832ze3z83_14992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32832ze3z83_14992, 
(int)(((long)0)), BgL_gz00_14989); 
return BgL_zc3anonymousza32832ze3z83_14992;}  else 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_zc3anonymousza32834ze3z83_14993;
BgL_zc3anonymousza32834ze3z83_14993 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32834ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32834ze3z83_14993, 
(int)(((long)0)), BgL_gz00_14989); 
return BgL_zc3anonymousza32834ze3z83_14993;} }  else 
{ /* Eval/evaluate_comp.scm 348 */
obj_t BgL_slotz00_14994;
BgL_slotz00_14994 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_gz00_14995;
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_arg2841z00_14996;obj_t BgL_arg2842z00_14997;obj_t BgL_arg2843z00_14998;
BgL_arg2841z00_14996 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_namez00); 
BgL_arg2842z00_14997 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_modz00); 
BgL_arg2843z00_14998 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_v1372z00_14999;
BgL_v1372z00_14999 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1372z00_14999,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1372z00_14999,((long)1),BgL_arg2841z00_14996); 
VECTOR_SET(BgL_v1372z00_14999,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1372z00_14999,((long)3),BgL_arg2842z00_14997); 
VECTOR_SET(BgL_v1372z00_14999,((long)4),BgL_arg2843z00_14998); 
BgL_gz00_14995 = BgL_v1372z00_14999; } } 
VECTOR_SET(BgL_gz00_14995,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_namez00), BgL_gz00_14995, 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12550)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 349 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_zc3anonymousza32845ze3z83_15000;
BgL_zc3anonymousza32845ze3z83_15000 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32845ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32845ze3z83_15000, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_globalz00_bglt)BgL_varz00_12550))); 
PROCEDURE_SET(BgL_zc3anonymousza32845ze3z83_15000, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_14994)); 
return BgL_zc3anonymousza32845ze3z83_15000;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2832> */
obj_t BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12554, obj_t BgL_sz00_12556)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 344 */
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_gz00_12555;
BgL_gz00_12555 = 
PROCEDURE_REF(BgL_envz00_12554, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_bpz00_15001;
BgL_bpz00_15001 = 
VECTOR_REF(
((obj_t)BgL_sz00_12556),((long)0)); 
{ /* Eval/evaluate_comp.scm 345 */
obj_t BgL_arg2833z00_15002;
BgL_arg2833z00_15002 = 
VECTOR_REF(
((obj_t)BgL_gz00_12555),((long)2)); 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2833z00_15002);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2834> */
obj_t BGl_z62zc3anonymousza32834ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12557, obj_t BgL_sz00_12559)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 346 */
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_gz00_12558;
BgL_gz00_12558 = 
PROCEDURE_REF(BgL_envz00_12557, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_bpz00_15003;
BgL_bpz00_15003 = 
VECTOR_REF(
((obj_t)BgL_sz00_12559),((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_gz00_12558),((long)2));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2845> */
obj_t BGl_z62zc3anonymousza32845ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12560, obj_t BgL_sz00_12563)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 353 */
{ /* Eval/evaluate_comp.scm 353 */
BgL_ev_globalz00_bglt BgL_i1092z00_12561;obj_t BgL_slotz00_12562;
BgL_i1092z00_12561 = 
((BgL_ev_globalz00_bglt)
PROCEDURE_REF(BgL_envz00_12560, 
(int)(((long)0)))); 
BgL_slotz00_12562 = 
PROCEDURE_REF(BgL_envz00_12560, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_bpz00_15004;
BgL_bpz00_15004 = 
VECTOR_REF(
((obj_t)BgL_sz00_12563),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_12562)))
{ /* Eval/evaluate_comp.scm 354 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 354 */
{ /* Eval/evaluate_comp.scm 355 */
obj_t BgL_auxz00_15005;
BgL_auxz00_15005 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12561))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12561))->BgL_namez00)); 
CELL_SET(BgL_slotz00_12562, BgL_auxz00_15005); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_12562)))
{ /* Eval/evaluate_comp.scm 356 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 356 */
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12561))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5318z00zz__evaluate_compz00, 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12561))->BgL_namez00)); } } 
{ /* Eval/evaluate_comp.scm 357 */
obj_t BgL_vz00_15006;
{ /* Eval/evaluate_comp.scm 357 */
obj_t BgL_evalzd2globalzd2_15007;
BgL_evalzd2globalzd2_15007 = 
CELL_REF(BgL_slotz00_12562); 
BgL_vz00_15006 = 
VECTOR_REF(BgL_evalzd2globalzd2_15007,((long)2)); } 
if(
(BgL_vz00_15006==BUNSPEC))
{ /* Eval/evaluate_comp.scm 359 */
int BgL_tz00_15008;
{ /* Eval/evaluate_comp.scm 359 */
int BgL_res4655z00_15009;
{ /* Eval/evaluate_comp.scm 359 */
obj_t BgL_evalzd2globalzd2_15010;
BgL_evalzd2globalzd2_15010 = 
CELL_REF(BgL_slotz00_12562); 
BgL_res4655z00_15009 = 
CINT(
VECTOR_REF(BgL_evalzd2globalzd2_15010,((long)0))); } 
BgL_tz00_15008 = BgL_res4655z00_15009; } 
{ /* Eval/evaluate_comp.scm 360 */
bool_t BgL_testz00_29454;
if(
(
(long)(BgL_tz00_15008)==((long)3)))
{ /* Eval/evaluate_comp.scm 360 */
BgL_testz00_29454 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 360 */
BgL_testz00_29454 = 
(
(long)(BgL_tz00_15008)==((long)4))
; } 
if(BgL_testz00_29454)
{ /* Eval/evaluate_comp.scm 360 */
return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12561))->BgL_locz00), BGl_string5194z00zz__evaluate_compz00, BGl_string5319z00zz__evaluate_compz00, 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12561))->BgL_namez00));}  else 
{ /* Eval/evaluate_comp.scm 360 */
return BgL_vz00_15006;} } }  else 
{ /* Eval/evaluate_comp.scm 358 */
return BgL_vz00_15006;} } } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_setlocal1392 */
obj_t BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00(obj_t BgL_envz00_12565, obj_t BgL_ez00_12566, obj_t BgL_stkz00_12567)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 321 */
{ /* Eval/evaluate_comp.scm 323 */
obj_t BgL_iz00_15012;obj_t BgL_ez00_15013;
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_varz00_bglt BgL_arg2828z00_15014;
BgL_arg2828z00_15014 = 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_12566)))->BgL_vz00); 
BgL_iz00_15012 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)BgL_arg2828z00_15014), BgL_stkz00_12567); } 
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_exprz00_bglt BgL_arg2829z00_15015;
BgL_arg2829z00_15015 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_ez00_12566))))->BgL_ez00); 
BgL_ez00_15013 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2829z00_15015, BgL_stkz00_12567); } 
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_12566)))->BgL_vz00)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_zc3anonymousza32821ze3z83_15016;
BgL_zc3anonymousza32821ze3z83_15016 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32821ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32821ze3z83_15016, 
(int)(((long)0)), BgL_iz00_15012); 
PROCEDURE_SET(BgL_zc3anonymousza32821ze3z83_15016, 
(int)(((long)1)), BgL_ez00_15013); 
return BgL_zc3anonymousza32821ze3z83_15016;}  else 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_zc3anonymousza32825ze3z83_15017;
BgL_zc3anonymousza32825ze3z83_15017 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32825ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32825ze3z83_15017, 
(int)(((long)0)), BgL_iz00_15012); 
PROCEDURE_SET(BgL_zc3anonymousza32825ze3z83_15017, 
(int)(((long)1)), BgL_ez00_15013); 
return BgL_zc3anonymousza32825ze3z83_15017;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2821> */
obj_t BGl_z62zc3anonymousza32821ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12568, obj_t BgL_sz00_12571)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 326 */
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_iz00_12569;obj_t BgL_ez00_12570;
BgL_iz00_12569 = 
PROCEDURE_REF(BgL_envz00_12568, 
(int)(((long)0))); 
BgL_ez00_12570 = 
PROCEDURE_REF(BgL_envz00_12568, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_bpz00_15018;
BgL_bpz00_15018 = 
VECTOR_REF(
((obj_t)BgL_sz00_12571),((long)0)); 
{ /* Eval/evaluate_comp.scm 327 */
obj_t BgL_arg2822z00_15019;obj_t BgL_arg2823z00_15020;
{ /* Eval/evaluate_comp.scm 327 */
long BgL_arg2824z00_15021;
BgL_arg2824z00_15021 = 
(
(long)CINT(BgL_bpz00_15018)+
(long)CINT(BgL_iz00_12569)); 
BgL_arg2822z00_15019 = 
VECTOR_REF(
((obj_t)BgL_sz00_12571),BgL_arg2824z00_15021); } 
BgL_arg2823z00_15020 = 
PROCEDURE_ENTRY(BgL_ez00_12570)(BgL_ez00_12570, BgL_sz00_12571, BEOA); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_xz00_15022;
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_29507;obj_t BgL_tmpz00_29505;
BgL_auxz00_29507 = 
(int)(((long)0)); 
BgL_tmpz00_29505 = 
((obj_t)BgL_arg2822z00_15019); 
BgL_xz00_15022 = 
STRUCT_SET(BgL_tmpz00_29505, BgL_auxz00_29507, BgL_arg2823z00_15020); } 
return BUNSPEC;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2825> */
obj_t BGl_z62zc3anonymousza32825ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12572, obj_t BgL_sz00_12575)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 328 */
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_iz00_12573;obj_t BgL_ez00_12574;
BgL_iz00_12573 = 
PROCEDURE_REF(BgL_envz00_12572, 
(int)(((long)0))); 
BgL_ez00_12574 = 
PROCEDURE_REF(BgL_envz00_12572, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_bpz00_15023;
BgL_bpz00_15023 = 
VECTOR_REF(
((obj_t)BgL_sz00_12575),((long)0)); 
{ /* Eval/evaluate_comp.scm 329 */
long BgL_arg2826z00_15024;obj_t BgL_arg2827z00_15025;
BgL_arg2826z00_15024 = 
(
(long)CINT(BgL_bpz00_15023)+
(long)CINT(BgL_iz00_12573)); 
BgL_arg2827z00_15025 = 
PROCEDURE_ENTRY(BgL_ez00_12574)(BgL_ez00_12574, BgL_sz00_12575, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_12575),BgL_arg2826z00_15024,BgL_arg2827z00_15025);} } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_var1390 */
obj_t BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00(obj_t BgL_envz00_12576, obj_t BgL_varz00_12577, obj_t BgL_stkz00_12578)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 316 */
{ /* Eval/evaluate_comp.scm 317 */
obj_t BgL_iz00_15027;
BgL_iz00_15027 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)
((BgL_ev_varz00_bglt)BgL_varz00_12577)), BgL_stkz00_12578); 
{ 

if(
INTEGERP(BgL_iz00_15027))
{ /* Eval/evaluate_comp.scm 319 */
switch( 
(long)CINT(BgL_iz00_15027)) { case ((long)0) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12577)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5320z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5321z00zz__evaluate_compz00;} break;case ((long)1) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12577)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5322z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5323z00zz__evaluate_compz00;} break;case ((long)2) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12577)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5324z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5325z00zz__evaluate_compz00;} break;case ((long)3) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12577)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5326z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5327z00zz__evaluate_compz00;} break;
default: 
BgL_case_else1087z00_15028:
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12577)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3anonymousza32815ze3z83_15029;
BgL_zc3anonymousza32815ze3z83_15029 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32815ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32815ze3z83_15029, 
(int)(((long)0)), BgL_iz00_15027); 
return BgL_zc3anonymousza32815ze3z83_15029;}  else 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3anonymousza32818ze3z83_15030;
BgL_zc3anonymousza32818ze3z83_15030 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32818ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32818ze3z83_15030, 
(int)(((long)0)), BgL_iz00_15027); 
return BgL_zc3anonymousza32818ze3z83_15030;} } }  else 
{ /* Eval/evaluate_comp.scm 319 */
goto BgL_case_else1087z00_15028;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2809> */
obj_t BGl_z62zc3anonymousza32809ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12579, obj_t BgL_sz00_12580)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15031;
BgL_bpz00_15031 = 
VECTOR_REF(
((obj_t)BgL_sz00_12580),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2810z00_15032;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2811z00_15033;
BgL_arg2811z00_15033 = 
(
(long)CINT(BgL_bpz00_15031)+((long)3)); 
BgL_arg2810z00_15032 = 
VECTOR_REF(
((obj_t)BgL_sz00_12580),BgL_arg2811z00_15033); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2810z00_15032), 
(int)(((long)0)));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2812> */
obj_t BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12581, obj_t BgL_sz00_12582)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15034;
BgL_bpz00_15034 = 
VECTOR_REF(
((obj_t)BgL_sz00_12582),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2813z00_15035;
BgL_arg2813z00_15035 = 
(
(long)CINT(BgL_bpz00_15034)+((long)3)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12582),BgL_arg2813z00_15035);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2803> */
obj_t BGl_z62zc3anonymousza32803ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12583, obj_t BgL_sz00_12584)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15036;
BgL_bpz00_15036 = 
VECTOR_REF(
((obj_t)BgL_sz00_12584),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2804z00_15037;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2805z00_15038;
BgL_arg2805z00_15038 = 
(
(long)CINT(BgL_bpz00_15036)+((long)2)); 
BgL_arg2804z00_15037 = 
VECTOR_REF(
((obj_t)BgL_sz00_12584),BgL_arg2805z00_15038); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2804z00_15037), 
(int)(((long)0)));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2806> */
obj_t BGl_z62zc3anonymousza32806ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12585, obj_t BgL_sz00_12586)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15039;
BgL_bpz00_15039 = 
VECTOR_REF(
((obj_t)BgL_sz00_12586),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2807z00_15040;
BgL_arg2807z00_15040 = 
(
(long)CINT(BgL_bpz00_15039)+((long)2)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12586),BgL_arg2807z00_15040);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2797> */
obj_t BGl_z62zc3anonymousza32797ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12587, obj_t BgL_sz00_12588)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15041;
BgL_bpz00_15041 = 
VECTOR_REF(
((obj_t)BgL_sz00_12588),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2798z00_15042;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2799z00_15043;
BgL_arg2799z00_15043 = 
(
(long)CINT(BgL_bpz00_15041)+((long)1)); 
BgL_arg2798z00_15042 = 
VECTOR_REF(
((obj_t)BgL_sz00_12588),BgL_arg2799z00_15043); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2798z00_15042), 
(int)(((long)0)));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2800> */
obj_t BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12589, obj_t BgL_sz00_12590)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15044;
BgL_bpz00_15044 = 
VECTOR_REF(
((obj_t)BgL_sz00_12590),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2801z00_15045;
BgL_arg2801z00_15045 = 
(
(long)CINT(BgL_bpz00_15044)+((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12590),BgL_arg2801z00_15045);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2791> */
obj_t BGl_z62zc3anonymousza32791ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12591, obj_t BgL_sz00_12592)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15046;
BgL_bpz00_15046 = 
VECTOR_REF(
((obj_t)BgL_sz00_12592),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2792z00_15047;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2793z00_15048;
BgL_arg2793z00_15048 = 
(
(long)CINT(BgL_bpz00_15046)+((long)0)); 
BgL_arg2792z00_15047 = 
VECTOR_REF(
((obj_t)BgL_sz00_12592),BgL_arg2793z00_15048); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2792z00_15047), 
(int)(((long)0)));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2794> */
obj_t BGl_z62zc3anonymousza32794ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12593, obj_t BgL_sz00_12594)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15049;
BgL_bpz00_15049 = 
VECTOR_REF(
((obj_t)BgL_sz00_12594),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2795z00_15050;
BgL_arg2795z00_15050 = 
(
(long)CINT(BgL_bpz00_15049)+((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12594),BgL_arg2795z00_15050);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2815> */
obj_t BGl_z62zc3anonymousza32815ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12595, obj_t BgL_sz00_12597)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_12596;
BgL_iz00_12596 = 
PROCEDURE_REF(BgL_envz00_12595, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15051;
BgL_bpz00_15051 = 
VECTOR_REF(
((obj_t)BgL_sz00_12597),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2816z00_15052;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2817z00_15053;
BgL_arg2817z00_15053 = 
(
(long)CINT(BgL_bpz00_15051)+
(long)CINT(BgL_iz00_12596)); 
BgL_arg2816z00_15052 = 
VECTOR_REF(
((obj_t)BgL_sz00_12597),BgL_arg2817z00_15053); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2816z00_15052), 
(int)(((long)0)));} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2818> */
obj_t BGl_z62zc3anonymousza32818ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12598, obj_t BgL_sz00_12600)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_12599;
BgL_iz00_12599 = 
PROCEDURE_REF(BgL_envz00_12598, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15054;
BgL_bpz00_15054 = 
VECTOR_REF(
((obj_t)BgL_sz00_12600),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2819z00_15055;
BgL_arg2819z00_15055 = 
(
(long)CINT(BgL_bpz00_15054)+
(long)CINT(BgL_iz00_12599)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12600),BgL_arg2819z00_15055);} } } } 
BGL_FUNCTION_END;
}



/* &comp-ev_trap1388 */
obj_t BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00(obj_t BgL_envz00_12601, obj_t BgL_ez00_12602, obj_t BgL_stkz00_12603)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 289 */
{ /* Eval/evaluate_comp.scm 291 */
obj_t BgL_ez00_15057;
{ /* Eval/evaluate_comp.scm 291 */
BgL_ev_exprz00_bglt BgL_arg2788z00_15058;
BgL_arg2788z00_15058 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_ez00_12602))))->BgL_ez00); 
BgL_ez00_15057 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2788z00_15058, BgL_stkz00_12603); } 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_zc3anonymousza32782ze3z83_15059;
BgL_zc3anonymousza32782ze3z83_15059 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32782ze3z83_15059, 
(int)(((long)0)), BgL_ez00_15057); 
return BgL_zc3anonymousza32782ze3z83_15059;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2782> */
obj_t BGl_z62zc3anonymousza32782ze3ze1zz__evaluate_compz00(obj_t BgL_envz00_12604, obj_t BgL_sz00_12606)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 292 */
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_ez00_12605;
BgL_ez00_12605 = 
PROCEDURE_REF(BgL_envz00_12604, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_bpz00_15060;
BgL_bpz00_15060 = 
VECTOR_REF(
((obj_t)BgL_sz00_12606),((long)0)); 
{ /* Eval/evaluate_comp.scm 293 */
obj_t BgL_cmdz00_15061;
BgL_cmdz00_15061 = 
PROCEDURE_ENTRY(BgL_ez00_12605)(BgL_ez00_12605, BgL_sz00_12606, BEOA); 
if(
(BgL_cmdz00_15061==BGl_symbol5328z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return BgL_bpz00_15060;}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15061==BGl_symbol5330z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_reset_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15061==BGl_symbol5332z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_get_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15061==BGl_symbol5334z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 302 */
obj_t BgL_arg2787z00_15062;
BgL_arg2787z00_15062 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
return 
VECTOR_SET(
((obj_t)BgL_arg2787z00_15062),((long)0),
BINT(((long)2)));}  else 
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_errorz00zz__errorz00(BGl_string5194z00zz__evaluate_compz00, BGl_string5336z00zz__evaluate_compz00, BgL_cmdz00_15061);} } } } } } } } 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_comp.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)430898742), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)180158922), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251314740), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)1047446), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__srfi4z00(((long)467924964), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)454272164), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)445908113), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)434692624), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-400105135), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)127905250), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942021), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220648206), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147622), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007149), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)23062368), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492754569), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872221), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)6183155), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long)193509656), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)20669940), 
BSTRING_TO_STRING(BGl_string5337z00zz__evaluate_compz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
