/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -srfi enable-resolv -srfi enable-gmp -srfi enable-unistring -srfi enable-pcre -O3 -fcfa-arithmetic -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_types.scm -o objs/obj_p/Eval/evaluate_types.o) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_z62zc3anonymousza31797ze3ze1zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1929z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1769z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2566z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1930z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1770z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1774z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1775z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1938z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1779z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2570z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2574z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1944z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31993ze3ze1zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1945z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1949z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1788z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2581z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2586z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1950z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1954z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1955z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1795z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2591z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31414ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2599z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1960z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1964z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1965z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1970z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1978z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1984z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1985z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62lambda1991z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1998z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31472ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31814ze3ze1zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31547ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31581ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1401z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31834ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1409z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1411z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31940ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31851ze3ze1zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1419z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32000ze3ze1zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1420z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1427z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1428z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
static obj_t BGl_z62lambda1433z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1434z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31675ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_globalz00_bglt BGl_z62lambda1442z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_typesz00(obj_t);
static BgL_ev_globalz00_bglt BGl_z62lambda1444z62zz__evaluate_typesz00(obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1607z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31765ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2401z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2406z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1450z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1451z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1615z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1455z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1456z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2410z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2416z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1461z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_setglobalz00_bglt BGl_z62lambda1623z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1462z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_setglobalz00_bglt BGl_z62lambda1625z62zz__evaluate_typesz00(obj_t);
static BgL_ev_littz00_bglt BGl_z62lambda1468z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2421z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2425z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_littz00_bglt BGl_z62lambda1470z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31695ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2430z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2434z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2438z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1640z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1641z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_letza2za2_bglt BGl_z62lambda1803z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_letza2za2_bglt BGl_z62lambda1805z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_ifz00_bglt BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_profzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62lambda1647z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_typesz00(obj_t);
static BgL_ev_ifz00_bglt BGl_z62lambda1486z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1648z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2604z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2442z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2447z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1652z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1653z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1498z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2613z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2451z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2618z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2456z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_letrecz00_bglt BGl_z62lambda1820z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_letrecz00_bglt BGl_z62lambda1822z62zz__evaluate_typesz00(obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1661z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1663z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2461z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2628z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2466z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_labelsz00_bglt BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t);
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1671z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1673z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1839z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2470z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2634z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2474z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2638z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2479z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1680z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1843z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1844z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1684z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1685z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1849z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2645z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2486z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31403ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1850z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1691z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1856z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1857z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2651z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2491z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2657z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2495z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1863z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1868z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1869z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2662z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2668z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31986ze3ze1zz__evaluate_typesz00(obj_t);
static BgL_ev_gotoz00_bglt BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_gotoz00_bglt BGl_z62lambda1878z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2672z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1884z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1889z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2681z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2683z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_symbol2688z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1890z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1894z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1895z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1899z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2693z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2698z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31515ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31534ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31429ze3ze1zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31446ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31715ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31910ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31627ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31807ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31735ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31557ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31665ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1504z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1505z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31488ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
static BgL_ev_listz00_bglt BGl_z62lambda1511z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_listz00_bglt BGl_z62lambda1513z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1520z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
extern obj_t BGl_objectz00zz__objectz00;
static BgL_ev_orz00_bglt BGl_z62lambda1529z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_orz00_bglt BGl_z62lambda1531z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31790ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1700z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1704z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1543z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1705z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2500z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1711z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1713z62zz__evaluate_typesz00(obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1553z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1719z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1399z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2511z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2516z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1562z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1724z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1563z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1725z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1567z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1568z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31599ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2520z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2524z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2529z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1731z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1733z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_typesz00(obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1577z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1739z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1579z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2538z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1900z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1740z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1744z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1745z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1908z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1587z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1749z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1588z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2542z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2706z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2382z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2708z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2384z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2549z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2388z00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1914z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1915z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1754z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1755z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_trapz00_bglt BGl_z62lambda1595z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1919z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_trapz00_bglt BGl_z62lambda1597z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2390z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2555z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2395z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2559z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2397z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1920z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1924z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2400z00zz__evaluate_typesz00, BgL_bgl_za762lambda1433za7622710z00, BGl_z62lambda1433z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72711za7, BGl_z62zc3anonymousza31414ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2404z00zz__evaluate_typesz00, BgL_bgl_za762lambda1411za7622712z00, BGl_z62lambda1411z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2405z00zz__evaluate_typesz00, BgL_bgl_za762lambda1409za7622713z00, BGl_z62lambda1409z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2408z00zz__evaluate_typesz00, BgL_bgl_za762lambda1451za7622714z00, BGl_z62lambda1451z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__evaluate_typesz00, BgL_bgl_za762lambda1450za7622715z00, BGl_z62lambda1450z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2412z00zz__evaluate_typesz00, BgL_bgl_za762lambda1456za7622716z00, BGl_z62lambda1456z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2413z00zz__evaluate_typesz00, BgL_bgl_za762lambda1455za7622717z00, BGl_z62lambda1455z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2501z00zz__evaluate_typesz00, BgL_bgl_string2501za700za7za7_2718za7, "ev_setlocal", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2414z00zz__evaluate_typesz00, BgL_bgl_za762lambda1462za7622719z00, BGl_z62lambda1462z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__evaluate_typesz00, BgL_bgl_za762lambda1461za7622720z00, BGl_z62lambda1461z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2418z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72721za7, BGl_z62zc3anonymousza31446ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2419z00zz__evaluate_typesz00, BgL_bgl_za762lambda1444za7622722z00, BGl_z62lambda1444z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2420z00zz__evaluate_typesz00, BgL_bgl_za762lambda1442za7622723z00, BGl_z62lambda1442z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__evaluate_typesz00, BgL_bgl_za762lambda1477za7622724z00, BGl_z62lambda1477z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__evaluate_typesz00, BgL_bgl_za762lambda1476za7622725z00, BGl_z62lambda1476z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2512z00zz__evaluate_typesz00, BgL_bgl_string2512za700za7za7_2726za7, "ev_setglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72727za7, BGl_z62zc3anonymousza31472ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__evaluate_typesz00, BgL_bgl_za762lambda1470za7622728z00, BGl_z62lambda1470z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2429z00zz__evaluate_typesz00, BgL_bgl_za762lambda1468za7622729z00, BGl_z62lambda1468z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2517z00zz__evaluate_typesz00, BgL_bgl_string2517za700za7za7_2730za7, "ev_defglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__evaluate_typesz00, BgL_bgl_za762lambda1493za7622731z00, BGl_z62lambda1493z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2433z00zz__evaluate_typesz00, BgL_bgl_za762lambda1492za7622732z00, BGl_z62lambda1492z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2521z00zz__evaluate_typesz00, BgL_bgl_string2521za700za7za7_2733za7, "var", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__evaluate_typesz00, BgL_bgl_za762lambda1499za7622734z00, BGl_z62lambda1499z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2437z00zz__evaluate_typesz00, BgL_bgl_za762lambda1498za7622735z00, BGl_z62lambda1498z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2525z00zz__evaluate_typesz00, BgL_bgl_string2525za700za7za7_2736za7, "body", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2601z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72737za7, BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2602z00zz__evaluate_typesz00, BgL_bgl_za762lambda1822za7622738z00, BGl_z62lambda1822z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__evaluate_typesz00, BgL_bgl_za762lambda1505za7622739z00, BGl_z62lambda1505z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2603z00zz__evaluate_typesz00, BgL_bgl_za762lambda1820za7622740z00, BGl_z62lambda1820z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__evaluate_typesz00, BgL_bgl_za762lambda1504za7622741z00, BGl_z62lambda1504z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2530z00zz__evaluate_typesz00, BgL_bgl_string2530za700za7za7_2742za7, "ev_bind-exit", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2606z00zz__evaluate_typesz00, BgL_bgl_za762lambda1839za7622743z00, BGl_z62lambda1839z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72744za7, BGl_z62zc3anonymousza31488ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2607z00zz__evaluate_typesz00, BgL_bgl_za762lambda1838za7622745z00, BGl_z62lambda1838z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2445z00zz__evaluate_typesz00, BgL_bgl_za762lambda1486za7622746z00, BGl_z62lambda1486z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2608z00zz__evaluate_typesz00, BgL_bgl_za762lambda1844za7622747z00, BGl_z62lambda1844z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2446z00zz__evaluate_typesz00, BgL_bgl_za762lambda1484za7622748z00, BGl_z62lambda1484z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2609z00zz__evaluate_typesz00, BgL_bgl_za762lambda1843za7622749z00, BGl_z62lambda1843z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2449z00zz__evaluate_typesz00, BgL_bgl_za762lambda1521za7622750z00, BGl_z62lambda1521z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2539z00zz__evaluate_typesz00, BgL_bgl_string2539za700za7za7_2751za7, "ev_unwind-protect", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2610z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72752za7, BGl_z62zc3anonymousza31851ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2611z00zz__evaluate_typesz00, BgL_bgl_za762lambda1850za7622753z00, BGl_z62lambda1850z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2612z00zz__evaluate_typesz00, BgL_bgl_za762lambda1849za7622754z00, BGl_z62lambda1849z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__evaluate_typesz00, BgL_bgl_za762lambda1520za7622755z00, BGl_z62lambda1520z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2615z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72756za7, BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2453z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72757za7, BGl_z62zc3anonymousza31515ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zz__evaluate_typesz00, BgL_bgl_za762lambda1857za7622758z00, BGl_z62lambda1857z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2454z00zz__evaluate_typesz00, BgL_bgl_za762lambda1513za7622759z00, BGl_z62lambda1513z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zz__evaluate_typesz00, BgL_bgl_za762lambda1856za7622760z00, BGl_z62lambda1856z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2455z00zz__evaluate_typesz00, BgL_bgl_za762lambda1511za7622761z00, BGl_z62lambda1511z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2543z00zz__evaluate_typesz00, BgL_bgl_string2543za700za7za7_2762za7, "handler", 7 );
DEFINE_STRING( BGl_string2707z00zz__evaluate_typesz00, BgL_bgl_string2707za700za7za7_2763za7, "ev_abs", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2458z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72764za7, BGl_z62zc3anonymousza31534ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2383z00zz__evaluate_typesz00, BgL_bgl_string2383za700za7za7_2765za7, "ev_expr", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__evaluate_typesz00, BgL_bgl_za762lambda1531za7622766z00, BGl_z62lambda1531z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2709z00zz__evaluate_typesz00, BgL_bgl_string2709za700za7za7_2767za7, "_", 1 );
DEFINE_STRING( BGl_string2385z00zz__evaluate_typesz00, BgL_bgl_string2385za700za7za7_2768za7, "__evaluate_types", 16 );
DEFINE_STRING( BGl_string2389z00zz__evaluate_typesz00, BgL_bgl_string2389za700za7za7_2769za7, "name", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zz__evaluate_typesz00, BgL_bgl_za762lambda1863za7622770z00, BGl_z62lambda1863z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2621z00zz__evaluate_typesz00, BgL_bgl_za762lambda1862za7622771z00, BGl_z62lambda1862z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2622z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72772za7, BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2460z00zz__evaluate_typesz00, BgL_bgl_za762lambda1529za7622773z00, BGl_z62lambda1529z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2623z00zz__evaluate_typesz00, BgL_bgl_za762lambda1869za7622774z00, BGl_z62lambda1869z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2624z00zz__evaluate_typesz00, BgL_bgl_za762lambda1868za7622775z00, BGl_z62lambda1868z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2625z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72776za7, BGl_z62zc3anonymousza31834ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2550z00zz__evaluate_typesz00, BgL_bgl_string2550za700za7za7_2777za7, "ev_with-handler", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2463z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72778za7, BGl_z62zc3anonymousza31547ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2626z00zz__evaluate_typesz00, BgL_bgl_za762lambda1832za7622779z00, BGl_z62lambda1832z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2464z00zz__evaluate_typesz00, BgL_bgl_za762lambda1545za7622780z00, BGl_z62lambda1545z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2627z00zz__evaluate_typesz00, BgL_bgl_za762lambda1830za7622781z00, BGl_z62lambda1830z62zz__evaluate_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2465z00zz__evaluate_typesz00, BgL_bgl_za762lambda1543za7622782z00, BGl_z62lambda1543z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2391z00zz__evaluate_typesz00, BgL_bgl_string2391za700za7za7_2783za7, "symbol", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2468z00zz__evaluate_typesz00, BgL_bgl_za762lambda1563za7622784z00, BGl_z62lambda1563z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2556z00zz__evaluate_typesz00, BgL_bgl_string2556za700za7za7_2785za7, "mutex", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2469z00zz__evaluate_typesz00, BgL_bgl_za762lambda1562za7622786z00, BGl_z62lambda1562z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2396z00zz__evaluate_typesz00, BgL_bgl_string2396za700za7za7_2787za7, "eff", 3 );
DEFINE_STRING( BGl_string2398z00zz__evaluate_typesz00, BgL_bgl_string2398za700za7za7_2788za7, "obj", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2630z00zz__evaluate_typesz00, BgL_bgl_za762lambda1885za7622789z00, BGl_z62lambda1885z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2631z00zz__evaluate_typesz00, BgL_bgl_za762lambda1884za7622790z00, BGl_z62lambda1884z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2632z00zz__evaluate_typesz00, BgL_bgl_za762lambda1890za7622791z00, BGl_z62lambda1890z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2633z00zz__evaluate_typesz00, BgL_bgl_za762lambda1889za7622792z00, BGl_z62lambda1889z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2472z00zz__evaluate_typesz00, BgL_bgl_za762lambda1568za7622793z00, BGl_z62lambda1568z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2560z00zz__evaluate_typesz00, BgL_bgl_string2560za700za7za7_2794za7, "prelock", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2473z00zz__evaluate_typesz00, BgL_bgl_za762lambda1567za7622795z00, BGl_z62lambda1567z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2636z00zz__evaluate_typesz00, BgL_bgl_za762lambda1895za7622796z00, BGl_z62lambda1895z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2637z00zz__evaluate_typesz00, BgL_bgl_za762lambda1894za7622797z00, BGl_z62lambda1894z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2476z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72798za7, BGl_z62zc3anonymousza31557ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2477z00zz__evaluate_typesz00, BgL_bgl_za762lambda1555za7622799z00, BGl_z62lambda1555z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2478z00zz__evaluate_typesz00, BgL_bgl_za762lambda1553za7622800z00, BGl_z62lambda1553z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2567z00zz__evaluate_typesz00, BgL_bgl_string2567za700za7za7_2801za7, "ev_synchronize", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2640z00zz__evaluate_typesz00, BgL_bgl_za762lambda1900za7622802z00, BGl_z62lambda1900z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2641z00zz__evaluate_typesz00, BgL_bgl_za762lambda1899za7622803z00, BGl_z62lambda1899z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2642z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72804za7, BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2643z00zz__evaluate_typesz00, BgL_bgl_za762lambda1878za7622805z00, BGl_z62lambda1878z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2481z00zz__evaluate_typesz00, BgL_bgl_za762lambda1588za7622806z00, BGl_z62lambda1588z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2644z00zz__evaluate_typesz00, BgL_bgl_za762lambda1876za7622807z00, BGl_z62lambda1876z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2482z00zz__evaluate_typesz00, BgL_bgl_za762lambda1587za7622808z00, BGl_z62lambda1587z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2483z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72809za7, BGl_z62zc3anonymousza31581ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2571z00zz__evaluate_typesz00, BgL_bgl_string2571za700za7za7_2810za7, "vars", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2484z00zz__evaluate_typesz00, BgL_bgl_za762lambda1579za7622811z00, BGl_z62lambda1579z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2647z00zz__evaluate_typesz00, BgL_bgl_za762lambda1915za7622812z00, BGl_z62lambda1915z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2485z00zz__evaluate_typesz00, BgL_bgl_za762lambda1577za7622813z00, BGl_z62lambda1577z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2648z00zz__evaluate_typesz00, BgL_bgl_za762lambda1914za7622814z00, BGl_z62lambda1914z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2649z00zz__evaluate_typesz00, BgL_bgl_za762lambda1920za7622815z00, BGl_z62lambda1920z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2575z00zz__evaluate_typesz00, BgL_bgl_string2575za700za7za7_2816za7, "vals", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2488z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72817za7, BGl_z62zc3anonymousza31599ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2489z00zz__evaluate_typesz00, BgL_bgl_za762lambda1597za7622818z00, BGl_z62lambda1597z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2650z00zz__evaluate_typesz00, BgL_bgl_za762lambda1919za7622819z00, BGl_z62lambda1919z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2490z00zz__evaluate_typesz00, BgL_bgl_za762lambda1595za7622820z00, BGl_z62lambda1595z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2653z00zz__evaluate_typesz00, BgL_bgl_za762lambda1925za7622821z00, BGl_z62lambda1925z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2654z00zz__evaluate_typesz00, BgL_bgl_za762lambda1924za7622822z00, BGl_z62lambda1924z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2655z00zz__evaluate_typesz00, BgL_bgl_za762lambda1930za7622823z00, BGl_z62lambda1930z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2493z00zz__evaluate_typesz00, BgL_bgl_za762lambda1615za7622824z00, BGl_z62lambda1615z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2656z00zz__evaluate_typesz00, BgL_bgl_za762lambda1929za7622825z00, BGl_z62lambda1929z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2494z00zz__evaluate_typesz00, BgL_bgl_za762lambda1614za7622826z00, BGl_z62lambda1614z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2582z00zz__evaluate_typesz00, BgL_bgl_string2582za700za7za7_2827za7, "ev_binder", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2659z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72828za7, BGl_z62zc3anonymousza31910ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2497z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72829za7, BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2498z00zz__evaluate_typesz00, BgL_bgl_za762lambda1607za7622830z00, BGl_z62lambda1607z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2499z00zz__evaluate_typesz00, BgL_bgl_za762lambda1605za7622831z00, BGl_z62lambda1605z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2587z00zz__evaluate_typesz00, BgL_bgl_string2587za700za7za7_2832za7, "boxes", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2660z00zz__evaluate_typesz00, BgL_bgl_za762lambda1908za7622833z00, BGl_z62lambda1908z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2661z00zz__evaluate_typesz00, BgL_bgl_za762lambda1906za7622834z00, BGl_z62lambda1906z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2664z00zz__evaluate_typesz00, BgL_bgl_za762lambda1945za7622835z00, BGl_z62lambda1945z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2665z00zz__evaluate_typesz00, BgL_bgl_za762lambda1944za7622836z00, BGl_z62lambda1944z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2666z00zz__evaluate_typesz00, BgL_bgl_za762lambda1950za7622837z00, BGl_z62lambda1950z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2667z00zz__evaluate_typesz00, BgL_bgl_za762lambda1949za7622838z00, BGl_z62lambda1949z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2592z00zz__evaluate_typesz00, BgL_bgl_string2592za700za7za7_2839za7, "ev_let", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2670z00zz__evaluate_typesz00, BgL_bgl_za762lambda1955za7622840z00, BGl_z62lambda1955z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2671z00zz__evaluate_typesz00, BgL_bgl_za762lambda1954za7622841z00, BGl_z62lambda1954z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2674z00zz__evaluate_typesz00, BgL_bgl_za762lambda1960za7622842z00, BGl_z62lambda1960z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2675z00zz__evaluate_typesz00, BgL_bgl_za762lambda1959za7622843z00, BGl_z62lambda1959z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2676z00zz__evaluate_typesz00, BgL_bgl_za762lambda1965za7622844z00, BGl_z62lambda1965z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2677z00zz__evaluate_typesz00, BgL_bgl_za762lambda1964za7622845z00, BGl_z62lambda1964z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2678z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72846za7, BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2679z00zz__evaluate_typesz00, BgL_bgl_za762lambda1971za7622847z00, BGl_z62lambda1971z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2680z00zz__evaluate_typesz00, BgL_bgl_za762lambda1970za7622848z00, BGl_z62lambda1970z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2685z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72849za7, BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2686z00zz__evaluate_typesz00, BgL_bgl_za762lambda1978za7622850z00, BGl_z62lambda1978z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2687z00zz__evaluate_typesz00, BgL_bgl_za762lambda1977za7622851z00, BGl_z62lambda1977z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2690z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72852za7, BGl_z62zc3anonymousza31986ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2691z00zz__evaluate_typesz00, BgL_bgl_za762lambda1985za7622853z00, BGl_z62lambda1985z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2692z00zz__evaluate_typesz00, BgL_bgl_za762lambda1984za7622854z00, BGl_z62lambda1984z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2695z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72855za7, BGl_z62zc3anonymousza31993ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2696z00zz__evaluate_typesz00, BgL_bgl_za762lambda1992za7622856z00, BGl_z62lambda1992z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2697z00zz__evaluate_typesz00, BgL_bgl_za762lambda1991za7622857z00, BGl_z62lambda1991z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2402z00zz__evaluate_typesz00, BgL_bgl_string2402za700za7za7_2858za7, "type", 4 );
DEFINE_STRING( BGl_string2407z00zz__evaluate_typesz00, BgL_bgl_string2407za700za7za7_2859za7, "ev_var", 6 );
DEFINE_STRING( BGl_string2411z00zz__evaluate_typesz00, BgL_bgl_string2411za700za7za7_2860za7, "loc", 3 );
DEFINE_STRING( BGl_string2417z00zz__evaluate_typesz00, BgL_bgl_string2417za700za7za7_2861za7, "mod", 3 );
DEFINE_STRING( BGl_string2422z00zz__evaluate_typesz00, BgL_bgl_string2422za700za7za7_2862za7, "ev_global", 9 );
DEFINE_STRING( BGl_string2426z00zz__evaluate_typesz00, BgL_bgl_string2426za700za7za7_2863za7, "value", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2502z00zz__evaluate_typesz00, BgL_bgl_za762lambda1641za7622864z00, BGl_z62lambda1641z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2503z00zz__evaluate_typesz00, BgL_bgl_za762lambda1640za7622865z00, BGl_z62lambda1640z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2504z00zz__evaluate_typesz00, BgL_bgl_za762lambda1648za7622866z00, BGl_z62lambda1648z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2505z00zz__evaluate_typesz00, BgL_bgl_za762lambda1647za7622867z00, BGl_z62lambda1647z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2506z00zz__evaluate_typesz00, BgL_bgl_za762lambda1653za7622868z00, BGl_z62lambda1653z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2431z00zz__evaluate_typesz00, BgL_bgl_string2431za700za7za7_2869za7, "ev_litt", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2507z00zz__evaluate_typesz00, BgL_bgl_za762lambda1652za7622870z00, BGl_z62lambda1652z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2508z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72871za7, BGl_z62zc3anonymousza31627ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2509z00zz__evaluate_typesz00, BgL_bgl_za762lambda1625za7622872z00, BGl_z62lambda1625z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2435z00zz__evaluate_typesz00, BgL_bgl_string2435za700za7za7_2873za7, "p", 1 );
DEFINE_STRING( BGl_string2439z00zz__evaluate_typesz00, BgL_bgl_string2439za700za7za7_2874za7, "t", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2510z00zz__evaluate_typesz00, BgL_bgl_za762lambda1623za7622875z00, BGl_z62lambda1623z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2600z00zz__evaluate_typesz00, BgL_bgl_string2600za700za7za7_2876za7, "ev_let*", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2513z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72877za7, BGl_z62zc3anonymousza31665ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2514z00zz__evaluate_typesz00, BgL_bgl_za762lambda1663za7622878z00, BGl_z62lambda1663z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2515z00zz__evaluate_typesz00, BgL_bgl_za762lambda1661za7622879z00, BGl_z62lambda1661z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2605z00zz__evaluate_typesz00, BgL_bgl_string2605za700za7za7_2880za7, "ev_letrec", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2518z00zz__evaluate_typesz00, BgL_bgl_za762lambda1680za7622881z00, BGl_z62lambda1680z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2443z00zz__evaluate_typesz00, BgL_bgl_string2443za700za7za7_2882za7, "e", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2519z00zz__evaluate_typesz00, BgL_bgl_za762lambda1679za7622883z00, BGl_z62lambda1679z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2448z00zz__evaluate_typesz00, BgL_bgl_string2448za700za7za7_2884za7, "ev_if", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2522z00zz__evaluate_typesz00, BgL_bgl_za762lambda1685za7622885z00, BGl_z62lambda1685z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2523z00zz__evaluate_typesz00, BgL_bgl_za762lambda1684za7622886z00, BGl_z62lambda1684z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72887za7, BGl_z62zc3anonymousza31675ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2614z00zz__evaluate_typesz00, BgL_bgl_string2614za700za7za7_2888za7, "env", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__evaluate_typesz00, BgL_bgl_za762lambda1673za7622889z00, BGl_z62lambda1673z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2452z00zz__evaluate_typesz00, BgL_bgl_string2452za700za7za7_2890za7, "args", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__evaluate_typesz00, BgL_bgl_za762lambda1671za7622891z00, BGl_z62lambda1671z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2619z00zz__evaluate_typesz00, BgL_bgl_string2619za700za7za7_2892za7, "stk", 3 );
DEFINE_STRING( BGl_string2457z00zz__evaluate_typesz00, BgL_bgl_string2457za700za7za7_2893za7, "ev_list", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__evaluate_typesz00, BgL_bgl_za762lambda1700za7622894z00, BGl_z62lambda1700z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__evaluate_typesz00, BgL_bgl_za762lambda1699za7622895z00, BGl_z62lambda1699z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2533z00zz__evaluate_typesz00, BgL_bgl_za762lambda1705za7622896z00, BGl_z62lambda1705z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2534z00zz__evaluate_typesz00, BgL_bgl_za762lambda1704za7622897z00, BGl_z62lambda1704z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2535z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72898za7, BGl_z62zc3anonymousza31695ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__evaluate_typesz00, BgL_bgl_za762lambda1693za7622899z00, BGl_z62lambda1693z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2537z00zz__evaluate_typesz00, BgL_bgl_za762lambda1691za7622900z00, BGl_z62lambda1691z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2462z00zz__evaluate_typesz00, BgL_bgl_string2462za700za7za7_2901za7, "ev_or", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2379z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72902za7, BGl_z62zc3anonymousza31403ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2629z00zz__evaluate_typesz00, BgL_bgl_string2629za700za7za7_2903za7, "ev_labels", 9 );
DEFINE_STRING( BGl_string2467z00zz__evaluate_typesz00, BgL_bgl_string2467za700za7za7_2904za7, "ev_and", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2700z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72905za7, BGl_z62zc3anonymousza32000ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2701z00zz__evaluate_typesz00, BgL_bgl_za762lambda1999za7622906z00, BGl_z62lambda1999z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2702z00zz__evaluate_typesz00, BgL_bgl_za762lambda1998za7622907z00, BGl_z62lambda1998z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2540z00zz__evaluate_typesz00, BgL_bgl_za762lambda1720za7622908z00, BGl_z62lambda1720z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2703z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72909za7, BGl_z62zc3anonymousza31940ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__evaluate_typesz00, BgL_bgl_za762lambda1719za7622910z00, BGl_z62lambda1719z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2704z00zz__evaluate_typesz00, BgL_bgl_za762lambda1938za7622911z00, BGl_z62lambda1938z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2380z00zz__evaluate_typesz00, BgL_bgl_za762lambda1401za7622912z00, BGl_z62lambda1401z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2705z00zz__evaluate_typesz00, BgL_bgl_za762lambda1936za7622913z00, BGl_z62lambda1936z62zz__evaluate_typesz00, 0L, BUNSPEC, 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2381z00zz__evaluate_typesz00, BgL_bgl_za762lambda1399za7622914z00, BGl_z62lambda1399z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2544z00zz__evaluate_typesz00, BgL_bgl_za762lambda1725za7622915z00, BGl_z62lambda1725z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2545z00zz__evaluate_typesz00, BgL_bgl_za762lambda1724za7622916z00, BGl_z62lambda1724z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72917za7, BGl_z62zc3anonymousza31715ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2471z00zz__evaluate_typesz00, BgL_bgl_string2471za700za7za7_2918za7, "e1", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2547z00zz__evaluate_typesz00, BgL_bgl_za762lambda1713za7622919z00, BGl_z62lambda1713z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2635z00zz__evaluate_typesz00, BgL_bgl_string2635za700za7za7_2920za7, "label", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2548z00zz__evaluate_typesz00, BgL_bgl_za762lambda1711za7622921z00, BGl_z62lambda1711z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2386z00zz__evaluate_typesz00, BgL_bgl_za762lambda1420za7622922z00, BGl_z62lambda1420z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2387z00zz__evaluate_typesz00, BgL_bgl_za762lambda1419za7622923z00, BGl_z62lambda1419z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2475z00zz__evaluate_typesz00, BgL_bgl_string2475za700za7za7_2924za7, "e2", 2 );
DEFINE_STRING( BGl_string2639z00zz__evaluate_typesz00, BgL_bgl_string2639za700za7za7_2925za7, "labels", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2551z00zz__evaluate_typesz00, BgL_bgl_za762lambda1740za7622926z00, BGl_z62lambda1740z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2552z00zz__evaluate_typesz00, BgL_bgl_za762lambda1739za7622927z00, BGl_z62lambda1739z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2553z00zz__evaluate_typesz00, BgL_bgl_za762lambda1745za7622928z00, BGl_z62lambda1745z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2554z00zz__evaluate_typesz00, BgL_bgl_za762lambda1744za7622929z00, BGl_z62lambda1744z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2392z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72930za7, BGl_z62zc3anonymousza31429ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2480z00zz__evaluate_typesz00, BgL_bgl_string2480za700za7za7_2931za7, "ev_prog2", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2393z00zz__evaluate_typesz00, BgL_bgl_za762lambda1428za7622932z00, BGl_z62lambda1428z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2394z00zz__evaluate_typesz00, BgL_bgl_za762lambda1427za7622933z00, BGl_z62lambda1427z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2557z00zz__evaluate_typesz00, BgL_bgl_za762lambda1750za7622934z00, BGl_z62lambda1750z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2558z00zz__evaluate_typesz00, BgL_bgl_za762lambda1749za7622935z00, BGl_z62lambda1749z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2646z00zz__evaluate_typesz00, BgL_bgl_string2646za700za7za7_2936za7, "ev_goto", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2399z00zz__evaluate_typesz00, BgL_bgl_za762lambda1434za7622937z00, BGl_z62lambda1434z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2487z00zz__evaluate_typesz00, BgL_bgl_string2487za700za7za7_2938za7, "ev_hook", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2561z00zz__evaluate_typesz00, BgL_bgl_za762lambda1755za7622939z00, BGl_z62lambda1755z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2562z00zz__evaluate_typesz00, BgL_bgl_za762lambda1754za7622940z00, BGl_z62lambda1754z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2563z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72941za7, BGl_z62zc3anonymousza31735ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2564z00zz__evaluate_typesz00, BgL_bgl_za762lambda1733za7622942z00, BGl_z62lambda1733z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2652z00zz__evaluate_typesz00, BgL_bgl_string2652za700za7za7_2943za7, "fun", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2565z00zz__evaluate_typesz00, BgL_bgl_za762lambda1731za7622944z00, BGl_z62lambda1731z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2492z00zz__evaluate_typesz00, BgL_bgl_string2492za700za7za7_2945za7, "ev_trap", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2568z00zz__evaluate_typesz00, BgL_bgl_za762lambda1770za7622946z00, BGl_z62lambda1770z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2569z00zz__evaluate_typesz00, BgL_bgl_za762lambda1769za7622947z00, BGl_z62lambda1769z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2658z00zz__evaluate_typesz00, BgL_bgl_string2658za700za7za7_2948za7, "tail?", 5 );
DEFINE_STRING( BGl_string2496z00zz__evaluate_typesz00, BgL_bgl_string2496za700za7za7_2949za7, "v", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2572z00zz__evaluate_typesz00, BgL_bgl_za762lambda1775za7622950z00, BGl_z62lambda1775z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2573z00zz__evaluate_typesz00, BgL_bgl_za762lambda1774za7622951z00, BGl_z62lambda1774z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2663z00zz__evaluate_typesz00, BgL_bgl_string2663za700za7za7_2952za7, "ev_app", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2576z00zz__evaluate_typesz00, BgL_bgl_za762lambda1780za7622953z00, BGl_z62lambda1780z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2577z00zz__evaluate_typesz00, BgL_bgl_za762lambda1779za7622954z00, BGl_z62lambda1779z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2578z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72955za7, BGl_z62zc3anonymousza31765ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2579z00zz__evaluate_typesz00, BgL_bgl_za762lambda1763za7622956z00, BGl_z62lambda1763z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2669z00zz__evaluate_typesz00, BgL_bgl_string2669za700za7za7_2957za7, "where", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2580z00zz__evaluate_typesz00, BgL_bgl_za762lambda1761za7622958z00, BGl_z62lambda1761z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2583z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72959za7, BGl_z62zc3anonymousza31797ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2584z00zz__evaluate_typesz00, BgL_bgl_za762lambda1796za7622960z00, BGl_z62lambda1796z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2585z00zz__evaluate_typesz00, BgL_bgl_za762lambda1795za7622961z00, BGl_z62lambda1795z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2673z00zz__evaluate_typesz00, BgL_bgl_string2673za700za7za7_2962za7, "arity", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2588z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72963za7, BGl_z62zc3anonymousza31790ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2589z00zz__evaluate_typesz00, BgL_bgl_za762lambda1788za7622964z00, BGl_z62lambda1788z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2590z00zz__evaluate_typesz00, BgL_bgl_za762lambda1786za7622965z00, BGl_z62lambda1786z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2593z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72966za7, BGl_z62zc3anonymousza31814ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2594z00zz__evaluate_typesz00, BgL_bgl_za762lambda1813za7622967z00, BGl_z62lambda1813z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2682z00zz__evaluate_typesz00, BgL_bgl_string2682za700za7za7_2968za7, "size", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2595z00zz__evaluate_typesz00, BgL_bgl_za762lambda1812za7622969z00, BGl_z62lambda1812z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2596z00zz__evaluate_typesz00, BgL_bgl_za762za7c3anonymousza72970za7, BGl_z62zc3anonymousza31807ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2684z00zz__evaluate_typesz00, BgL_bgl_string2684za700za7za7_2971za7, "int", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2597z00zz__evaluate_typesz00, BgL_bgl_za762lambda1805za7622972z00, BGl_z62lambda1805z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2598z00zz__evaluate_typesz00, BgL_bgl_za762lambda1803za7622973z00, BGl_z62lambda1803z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2689z00zz__evaluate_typesz00, BgL_bgl_string2689za700za7za7_2974za7, "bind", 4 );
DEFINE_STRING( BGl_string2694z00zz__evaluate_typesz00, BgL_bgl_string2694za700za7za7_2975za7, "free", 4 );
DEFINE_STRING( BGl_string2699z00zz__evaluate_typesz00, BgL_bgl_string2699za700za7za7_2976za7, "inner", 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol2566z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2570z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2574z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2581z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2586z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2591z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2599z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letrecz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_labelsz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_absz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_ifz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_gotoz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_orz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_varz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_andz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2401z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2406z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2410z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2416z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_appz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2421z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2425z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2430z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2434z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2438z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_synchroniza7eza7zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2604z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2442z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2447z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2613z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2451z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2618z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2456z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2461z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2628z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2466z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2470z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2634z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2474z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2638z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2479z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2645z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2486z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_defglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2651z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2491z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2657z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2495z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2662z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2668z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2672z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2681z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2683z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2688z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2693z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2698z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_prog2z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_bindzd2exitzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letza2za2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_trapz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_hookz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_globalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_binderz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_listz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_littz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_withzd2handlerzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_exprz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2500z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2511z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2516z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2520z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2524z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2529z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2538z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2542z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2706z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2382z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2708z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2384z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2549z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2388z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setlocalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2390z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2555z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2395z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2559z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2397z00zz__evaluate_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_types.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1940>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3anonymousza31940ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:2000>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3anonymousza32000ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1993>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3anonymousza31993ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1986>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3anonymousza31986ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1979>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1972>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1910>\" \"Eval/evaluate_types.scm\" 3265) \"BGl_z62zc3anonymousza31910ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1880>\" \"Eval/evaluate_types.scm\" 3154) \"BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1834>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3anonymousza31834ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1870>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1858>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1851>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3anonymousza31851ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1824>\" \"Eval/evaluate_types.scm\" 2908) \"BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1807>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3anonymousza31807ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1814>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3anonymousza31814ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1790>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3anonymousza31790ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1797>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3anonymousza31797ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1765>\" \"Eval/evaluate_types.scm\" 2713) \"BGl_z62zc3anonymousza31765ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1735>\" \"Eval/evaluate_types.scm\" 2587) \"BGl_z62zc3anonymousza31735ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1715>\" \"Eval/evaluate_types.scm\" 2505) \"BGl_z62zc3anonymousza31715ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1695>\" \"Eval/evaluate_types.scm\" 2427) \"BGl_z62zc3anonymousza31695ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1675>\" \"Eval/evaluate_types.scm\" 2353) \"BGl_z62zc3anonymousza31675ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1665>\" \"Eval/evaluate_types.scm\" 2314) \"BGl_z62zc3anonymousza31665ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1627>\" \"Eval/evaluate_types.scm\" 2226) \"BGl_z62zc3anonymousza31627ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1609>\" \"Eval/evaluate_types.scm\" 2176) \"BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1599>\" \"Eval/evaluate_types.scm\" 2147) \"BGl_z62zc3anonymousza31599ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1581>\" \"Eval/evaluate_types.scm\" 2100) \"BGl_z62zc3anonymousza31581ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1557>\" \"Eval/evaluate_types.scm\" 2032) \"BGl_z62zc3anonymousza31557ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1547>\" \"Eval/evaluate_types.scm\" 2004) \"BGl_z62zc3anonymousza31547ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1534>\" \"Eval/evaluate_types.scm\" 1977) \"BGl_z62zc3anonymousza31534ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1515>\" \"Eval/evaluate_types.scm\" 1936) \"BGl_z62zc3anonymousza31515ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1488>\" \"Eval/evaluate_types.scm\" 1855) \"BGl_z62zc3anonymousza31488ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1472>\" \"Eval/evaluate_types.scm\" 1813) \"BGl_z62zc3anonymousza31472ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1446>\" \"Eval/evaluate_types.scm\" 1723) \"BGl_z62zc3anonymousza31446ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1414>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3anonymousza31414ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1429>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3anonymousza31429ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<anonymous:1403>\" \"Eval/evaluate_types.scm\" 1612) \"BGl_z62zc3anonymousza31403ze3ze1zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long BgL_checksumz00_4291, char * BgL_fromz00_4292)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_typesz00(); 
BGl_cnstzd2initzd2zz__evaluate_typesz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00(); 
BGl_objectzd2initzd2zz__evaluate_typesz00(); 
return 
BGl_profzd2initzd2zz__evaluate_typesz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
BGl_symbol2382z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2383z00zz__evaluate_typesz00); 
BGl_symbol2384z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2385z00zz__evaluate_typesz00); 
BGl_symbol2388z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2389z00zz__evaluate_typesz00); 
BGl_symbol2390z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2391z00zz__evaluate_typesz00); 
BGl_symbol2395z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2396z00zz__evaluate_typesz00); 
BGl_symbol2397z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2398z00zz__evaluate_typesz00); 
BGl_symbol2401z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2402z00zz__evaluate_typesz00); 
BGl_symbol2406z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2407z00zz__evaluate_typesz00); 
BGl_symbol2410z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2411z00zz__evaluate_typesz00); 
BGl_symbol2416z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2417z00zz__evaluate_typesz00); 
BGl_symbol2421z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2422z00zz__evaluate_typesz00); 
BGl_symbol2425z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2426z00zz__evaluate_typesz00); 
BGl_symbol2430z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2431z00zz__evaluate_typesz00); 
BGl_symbol2434z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2435z00zz__evaluate_typesz00); 
BGl_symbol2438z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2439z00zz__evaluate_typesz00); 
BGl_symbol2442z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2443z00zz__evaluate_typesz00); 
BGl_symbol2447z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2448z00zz__evaluate_typesz00); 
BGl_symbol2451z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2452z00zz__evaluate_typesz00); 
BGl_symbol2456z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2457z00zz__evaluate_typesz00); 
BGl_symbol2461z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2462z00zz__evaluate_typesz00); 
BGl_symbol2466z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2467z00zz__evaluate_typesz00); 
BGl_symbol2470z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2471z00zz__evaluate_typesz00); 
BGl_symbol2474z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2475z00zz__evaluate_typesz00); 
BGl_symbol2479z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2480z00zz__evaluate_typesz00); 
BGl_symbol2486z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2487z00zz__evaluate_typesz00); 
BGl_symbol2491z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2492z00zz__evaluate_typesz00); 
BGl_symbol2495z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2496z00zz__evaluate_typesz00); 
BGl_symbol2500z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2501z00zz__evaluate_typesz00); 
BGl_symbol2511z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2512z00zz__evaluate_typesz00); 
BGl_symbol2516z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2517z00zz__evaluate_typesz00); 
BGl_symbol2520z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2521z00zz__evaluate_typesz00); 
BGl_symbol2524z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2525z00zz__evaluate_typesz00); 
BGl_symbol2529z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2530z00zz__evaluate_typesz00); 
BGl_symbol2538z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2539z00zz__evaluate_typesz00); 
BGl_symbol2542z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2543z00zz__evaluate_typesz00); 
BGl_symbol2549z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2550z00zz__evaluate_typesz00); 
BGl_symbol2555z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2556z00zz__evaluate_typesz00); 
BGl_symbol2559z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2560z00zz__evaluate_typesz00); 
BGl_symbol2566z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2567z00zz__evaluate_typesz00); 
BGl_symbol2570z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2571z00zz__evaluate_typesz00); 
BGl_symbol2574z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2575z00zz__evaluate_typesz00); 
BGl_symbol2581z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2582z00zz__evaluate_typesz00); 
BGl_symbol2586z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2587z00zz__evaluate_typesz00); 
BGl_symbol2591z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2592z00zz__evaluate_typesz00); 
BGl_symbol2599z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2600z00zz__evaluate_typesz00); 
BGl_symbol2604z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2605z00zz__evaluate_typesz00); 
BGl_symbol2613z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2614z00zz__evaluate_typesz00); 
BGl_symbol2618z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2619z00zz__evaluate_typesz00); 
BGl_symbol2628z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2629z00zz__evaluate_typesz00); 
BGl_symbol2634z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2635z00zz__evaluate_typesz00); 
BGl_symbol2638z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2639z00zz__evaluate_typesz00); 
BGl_symbol2645z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2646z00zz__evaluate_typesz00); 
BGl_symbol2651z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2652z00zz__evaluate_typesz00); 
BGl_symbol2657z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2658z00zz__evaluate_typesz00); 
BGl_symbol2662z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2663z00zz__evaluate_typesz00); 
BGl_symbol2668z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2669z00zz__evaluate_typesz00); 
BGl_symbol2672z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2673z00zz__evaluate_typesz00); 
BGl_symbol2681z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2682z00zz__evaluate_typesz00); 
BGl_symbol2683z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2684z00zz__evaluate_typesz00); 
BGl_symbol2688z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2689z00zz__evaluate_typesz00); 
BGl_symbol2693z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2694z00zz__evaluate_typesz00); 
BGl_symbol2698z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2699z00zz__evaluate_typesz00); 
BGl_symbol2706z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2707z00zz__evaluate_typesz00); 
return ( 
BGl_symbol2708z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2709z00zz__evaluate_typesz00), BUNSPEC) ;} 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
return 
write_bprof_table();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_arg1397z00_1057;obj_t BgL_arg1398z00_1058;
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1281z00_1068;
BgL_v1281z00_1068 = 
create_vector(((long)0)); 
BgL_arg1397z00_1057 = BgL_v1281z00_1068; } 
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1282z00_1069;
BgL_v1282z00_1069 = 
create_vector(((long)0)); 
BgL_arg1398z00_1058 = BgL_v1282z00_1069; } 
BGl_ev_exprz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2382z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00, ((long)36682), BGl_proc2381z00zz__evaluate_typesz00, BGl_proc2380z00zz__evaluate_typesz00, BFALSE, BGl_proc2379z00zz__evaluate_typesz00, BFALSE, BgL_arg1397z00_1057, BgL_arg1398z00_1058); } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_arg1407z00_1076;obj_t BgL_arg1408z00_1077;
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1283z00_1090;
BgL_v1283z00_1090 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1283z00_1090,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2388z00zz__evaluate_typesz00, BGl_proc2387z00zz__evaluate_typesz00, BGl_proc2386z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2390z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1283z00_1090,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2395z00zz__evaluate_typesz00, BGl_proc2394z00zz__evaluate_typesz00, BGl_proc2393z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2392z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1283z00_1090,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2401z00zz__evaluate_typesz00, BGl_proc2400z00zz__evaluate_typesz00, BGl_proc2399z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1407z00_1076 = BgL_v1283z00_1090; } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1284z00_1124;
BgL_v1284z00_1124 = 
create_vector(((long)0)); 
BgL_arg1408z00_1077 = BgL_v1284z00_1124; } 
BGl_ev_varz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2406z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)7285), BGl_proc2405z00zz__evaluate_typesz00, BGl_proc2404z00zz__evaluate_typesz00, BFALSE, BGl_proc2403z00zz__evaluate_typesz00, BFALSE, BgL_arg1407z00_1076, BgL_arg1408z00_1077); } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_arg1440z00_1131;obj_t BgL_arg1441z00_1132;
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1285z00_1145;
BgL_v1285z00_1145 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1285z00_1145,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2410z00zz__evaluate_typesz00, BGl_proc2409z00zz__evaluate_typesz00, BGl_proc2408z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1285z00_1145,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2388z00zz__evaluate_typesz00, BGl_proc2413z00zz__evaluate_typesz00, BGl_proc2412z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2390z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1285z00_1145,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2416z00zz__evaluate_typesz00, BGl_proc2415z00zz__evaluate_typesz00, BGl_proc2414z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1440z00_1131 = BgL_v1285z00_1145; } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1286z00_1176;
BgL_v1286z00_1176 = 
create_vector(((long)0)); 
BgL_arg1441z00_1132 = BgL_v1286z00_1176; } 
BGl_ev_globalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2421z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59175), BGl_proc2420z00zz__evaluate_typesz00, BGl_proc2419z00zz__evaluate_typesz00, BFALSE, BGl_proc2418z00zz__evaluate_typesz00, BFALSE, BgL_arg1440z00_1131, BgL_arg1441z00_1132); } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_arg1466z00_1183;obj_t BgL_arg1467z00_1184;
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1287z00_1195;
BgL_v1287z00_1195 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1287z00_1195,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2425z00zz__evaluate_typesz00, BGl_proc2424z00zz__evaluate_typesz00, BGl_proc2423z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1466z00_1183 = BgL_v1287z00_1195; } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1288z00_1206;
BgL_v1288z00_1206 = 
create_vector(((long)0)); 
BgL_arg1467z00_1184 = BgL_v1288z00_1206; } 
BGl_ev_littz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2430z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)42418), BGl_proc2429z00zz__evaluate_typesz00, BGl_proc2428z00zz__evaluate_typesz00, BFALSE, BGl_proc2427z00zz__evaluate_typesz00, BFALSE, BgL_arg1466z00_1183, BgL_arg1467z00_1184); } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_arg1482z00_1213;obj_t BgL_arg1483z00_1214;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1289z00_1227;
BgL_v1289z00_1227 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1289z00_1227,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2434z00zz__evaluate_typesz00, BGl_proc2433z00zz__evaluate_typesz00, BGl_proc2432z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1289z00_1227,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2438z00zz__evaluate_typesz00, BGl_proc2437z00zz__evaluate_typesz00, BGl_proc2436z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1289z00_1227,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2442z00zz__evaluate_typesz00, BGl_proc2441z00zz__evaluate_typesz00, BGl_proc2440z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1482z00_1213 = BgL_v1289z00_1227; } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1290z00_1258;
BgL_v1290z00_1258 = 
create_vector(((long)0)); 
BgL_arg1483z00_1214 = BgL_v1290z00_1258; } 
BGl_ev_ifz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2447z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)19099), BGl_proc2446z00zz__evaluate_typesz00, BGl_proc2445z00zz__evaluate_typesz00, BFALSE, BGl_proc2444z00zz__evaluate_typesz00, BFALSE, BgL_arg1482z00_1213, BgL_arg1483z00_1214); } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_arg1509z00_1265;obj_t BgL_arg1510z00_1266;
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1291z00_1277;
BgL_v1291z00_1277 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1291z00_1277,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2451z00zz__evaluate_typesz00, BGl_proc2450z00zz__evaluate_typesz00, BGl_proc2449z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1509z00_1265 = BgL_v1291z00_1277; } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1292z00_1288;
BgL_v1292z00_1288 = 
create_vector(((long)0)); 
BgL_arg1510z00_1266 = BgL_v1292z00_1288; } 
BGl_ev_listz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2456z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)39617), BGl_proc2455z00zz__evaluate_typesz00, BGl_proc2454z00zz__evaluate_typesz00, BFALSE, BGl_proc2453z00zz__evaluate_typesz00, BFALSE, BgL_arg1509z00_1265, BgL_arg1510z00_1266); } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_arg1525z00_1295;obj_t BgL_arg1528z00_1296;
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1293z00_1307;
BgL_v1293z00_1307 = 
create_vector(((long)0)); 
BgL_arg1525z00_1295 = BgL_v1293z00_1307; } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1294z00_1308;
BgL_v1294z00_1308 = 
create_vector(((long)0)); 
BgL_arg1528z00_1296 = BgL_v1294z00_1308; } 
BGl_ev_orz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2461z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)50334), BGl_proc2460z00zz__evaluate_typesz00, BGl_proc2459z00zz__evaluate_typesz00, BFALSE, BGl_proc2458z00zz__evaluate_typesz00, BFALSE, BgL_arg1525z00_1295, BgL_arg1528z00_1296); } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_arg1541z00_1315;obj_t BgL_arg1542z00_1316;
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1295z00_1327;
BgL_v1295z00_1327 = 
create_vector(((long)0)); 
BgL_arg1541z00_1315 = BgL_v1295z00_1327; } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1296z00_1328;
BgL_v1296z00_1328 = 
create_vector(((long)0)); 
BgL_arg1542z00_1316 = BgL_v1296z00_1328; } 
BGl_ev_andz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2466z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)26888), BGl_proc2465z00zz__evaluate_typesz00, BGl_proc2464z00zz__evaluate_typesz00, BFALSE, BGl_proc2463z00zz__evaluate_typesz00, BFALSE, BgL_arg1541z00_1315, BgL_arg1542z00_1316); } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_arg1551z00_1335;obj_t BgL_arg1552z00_1336;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1297z00_1348;
BgL_v1297z00_1348 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1297z00_1348,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2470z00zz__evaluate_typesz00, BGl_proc2469z00zz__evaluate_typesz00, BGl_proc2468z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1297z00_1348,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2474z00zz__evaluate_typesz00, BGl_proc2473z00zz__evaluate_typesz00, BGl_proc2472z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1551z00_1335 = BgL_v1297z00_1348; } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1298z00_1369;
BgL_v1298z00_1369 = 
create_vector(((long)0)); 
BgL_arg1552z00_1336 = BgL_v1298z00_1369; } 
BGl_ev_prog2z00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2479z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)14177), BGl_proc2478z00zz__evaluate_typesz00, BGl_proc2477z00zz__evaluate_typesz00, BFALSE, BGl_proc2476z00zz__evaluate_typesz00, BFALSE, BgL_arg1551z00_1335, BgL_arg1552z00_1336); } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_arg1574z00_1376;obj_t BgL_arg1576z00_1377;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1299z00_1388;
BgL_v1299z00_1388 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1299z00_1388,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2442z00zz__evaluate_typesz00, BGl_proc2482z00zz__evaluate_typesz00, BGl_proc2481z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1574z00_1376 = BgL_v1299z00_1388; } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1300z00_1399;
BgL_v1300z00_1399 = 
create_vector(((long)0)); 
BgL_arg1576z00_1377 = BgL_v1300z00_1399; } 
BGl_ev_hookz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2486z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)32125), BGl_proc2485z00zz__evaluate_typesz00, BGl_proc2484z00zz__evaluate_typesz00, BFALSE, BGl_proc2483z00zz__evaluate_typesz00, BFALSE, BgL_arg1574z00_1376, BgL_arg1576z00_1377); } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_arg1593z00_1406;obj_t BgL_arg1594z00_1407;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1301z00_1418;
BgL_v1301z00_1418 = 
create_vector(((long)0)); 
BgL_arg1593z00_1406 = BgL_v1301z00_1418; } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1302z00_1419;
BgL_v1302z00_1419 = 
create_vector(((long)0)); 
BgL_arg1594z00_1407 = BgL_v1302z00_1419; } 
BGl_ev_trapz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2491z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)24451), BGl_proc2490z00zz__evaluate_typesz00, BGl_proc2489z00zz__evaluate_typesz00, BFALSE, BGl_proc2488z00zz__evaluate_typesz00, BFALSE, BgL_arg1593z00_1406, BgL_arg1594z00_1407); } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_arg1603z00_1426;obj_t BgL_arg1604z00_1427;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1303z00_1439;
BgL_v1303z00_1439 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1303z00_1439,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2495z00zz__evaluate_typesz00, BGl_proc2494z00zz__evaluate_typesz00, BGl_proc2493z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
BgL_arg1603z00_1426 = BgL_v1303z00_1439; } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1304z00_1450;
BgL_v1304z00_1450 = 
create_vector(((long)0)); 
BgL_arg1604z00_1427 = BgL_v1304z00_1450; } 
BGl_ev_setlocalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2500z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)37950), BGl_proc2499z00zz__evaluate_typesz00, BGl_proc2498z00zz__evaluate_typesz00, BFALSE, BGl_proc2497z00zz__evaluate_typesz00, BFALSE, BgL_arg1603z00_1426, BgL_arg1604z00_1427); } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_arg1621z00_1457;obj_t BgL_arg1622z00_1458;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1305z00_1472;
BgL_v1305z00_1472 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1305z00_1472,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2410z00zz__evaluate_typesz00, BGl_proc2503z00zz__evaluate_typesz00, BGl_proc2502z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1305z00_1472,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2388z00zz__evaluate_typesz00, BGl_proc2505z00zz__evaluate_typesz00, BGl_proc2504z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2390z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1305z00_1472,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2416z00zz__evaluate_typesz00, BGl_proc2507z00zz__evaluate_typesz00, BGl_proc2506z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1621z00_1457 = BgL_v1305z00_1472; } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1306z00_1503;
BgL_v1306z00_1503 = 
create_vector(((long)0)); 
BgL_arg1622z00_1458 = BgL_v1306z00_1503; } 
BGl_ev_setglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2511z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)62117), BGl_proc2510z00zz__evaluate_typesz00, BGl_proc2509z00zz__evaluate_typesz00, BFALSE, BGl_proc2508z00zz__evaluate_typesz00, BFALSE, BgL_arg1621z00_1457, BgL_arg1622z00_1458); } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_arg1659z00_1510;obj_t BgL_arg1660z00_1511;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1307z00_1525;
BgL_v1307z00_1525 = 
create_vector(((long)0)); 
BgL_arg1659z00_1510 = BgL_v1307z00_1525; } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1308z00_1526;
BgL_v1308z00_1526 = 
create_vector(((long)0)); 
BgL_arg1660z00_1511 = BgL_v1308z00_1526; } 
BGl_ev_defglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2516z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_setglobalz00zz__evaluate_typesz00, ((long)36158), BGl_proc2515z00zz__evaluate_typesz00, BGl_proc2514z00zz__evaluate_typesz00, BFALSE, BGl_proc2513z00zz__evaluate_typesz00, BFALSE, BgL_arg1659z00_1510, BgL_arg1660z00_1511); } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_arg1669z00_1533;obj_t BgL_arg1670z00_1534;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1309z00_1546;
BgL_v1309z00_1546 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1309z00_1546,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2520z00zz__evaluate_typesz00, BGl_proc2519z00zz__evaluate_typesz00, BGl_proc2518z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1309z00_1546,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2523z00zz__evaluate_typesz00, BGl_proc2522z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1669z00_1533 = BgL_v1309z00_1546; } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1310z00_1567;
BgL_v1310z00_1567 = 
create_vector(((long)0)); 
BgL_arg1670z00_1534 = BgL_v1310z00_1567; } 
BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2529z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)10723), BGl_proc2528z00zz__evaluate_typesz00, BGl_proc2527z00zz__evaluate_typesz00, BFALSE, BGl_proc2526z00zz__evaluate_typesz00, BFALSE, BgL_arg1669z00_1533, BgL_arg1670z00_1534); } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_arg1689z00_1574;obj_t BgL_arg1690z00_1575;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1311z00_1587;
BgL_v1311z00_1587 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1311z00_1587,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2442z00zz__evaluate_typesz00, BGl_proc2532z00zz__evaluate_typesz00, BGl_proc2531z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1311z00_1587,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2534z00zz__evaluate_typesz00, BGl_proc2533z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1689z00_1574 = BgL_v1311z00_1587; } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1312z00_1608;
BgL_v1312z00_1608 = 
create_vector(((long)0)); 
BgL_arg1690z00_1575 = BgL_v1312z00_1608; } 
BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2538z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59644), BGl_proc2537z00zz__evaluate_typesz00, BGl_proc2536z00zz__evaluate_typesz00, BFALSE, BGl_proc2535z00zz__evaluate_typesz00, BFALSE, BgL_arg1689z00_1574, BgL_arg1690z00_1575); } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_arg1709z00_1615;obj_t BgL_arg1710z00_1616;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1313z00_1628;
BgL_v1313z00_1628 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1313z00_1628,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2542z00zz__evaluate_typesz00, BGl_proc2541z00zz__evaluate_typesz00, BGl_proc2540z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1313z00_1628,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2545z00zz__evaluate_typesz00, BGl_proc2544z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1709z00_1615 = BgL_v1313z00_1628; } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1314z00_1649;
BgL_v1314z00_1649 = 
create_vector(((long)0)); 
BgL_arg1710z00_1616 = BgL_v1314z00_1649; } 
BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2549z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)54033), BGl_proc2548z00zz__evaluate_typesz00, BGl_proc2547z00zz__evaluate_typesz00, BFALSE, BGl_proc2546z00zz__evaluate_typesz00, BFALSE, BgL_arg1709z00_1615, BgL_arg1710z00_1616); } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_arg1729z00_1656;obj_t BgL_arg1730z00_1657;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1315z00_1671;
BgL_v1315z00_1671 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1315z00_1671,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2410z00zz__evaluate_typesz00, BGl_proc2552z00zz__evaluate_typesz00, BGl_proc2551z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1315z00_1671,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2555z00zz__evaluate_typesz00, BGl_proc2554z00zz__evaluate_typesz00, BGl_proc2553z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1315z00_1671,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2559z00zz__evaluate_typesz00, BGl_proc2558z00zz__evaluate_typesz00, BGl_proc2557z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1315z00_1671,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2562z00zz__evaluate_typesz00, BGl_proc2561z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1729z00_1656 = BgL_v1315z00_1671; } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1316z00_1712;
BgL_v1316z00_1712 = 
create_vector(((long)0)); 
BgL_arg1730z00_1657 = BgL_v1316z00_1712; } 
BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2566z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)40653), BGl_proc2565z00zz__evaluate_typesz00, BGl_proc2564z00zz__evaluate_typesz00, BFALSE, BGl_proc2563z00zz__evaluate_typesz00, BFALSE, BgL_arg1729z00_1656, BgL_arg1730z00_1657); } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_arg1759z00_1719;obj_t BgL_arg1760z00_1720;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1317z00_1733;
BgL_v1317z00_1733 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1317z00_1733,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2570z00zz__evaluate_typesz00, BGl_proc2569z00zz__evaluate_typesz00, BGl_proc2568z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1317z00_1733,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2574z00zz__evaluate_typesz00, BGl_proc2573z00zz__evaluate_typesz00, BGl_proc2572z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1317z00_1733,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2577z00zz__evaluate_typesz00, BGl_proc2576z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1759z00_1719 = BgL_v1317z00_1733; } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1318z00_1764;
BgL_v1318z00_1764 = 
create_vector(((long)0)); 
BgL_arg1760z00_1720 = BgL_v1318z00_1764; } 
BGl_ev_binderz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2581z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)50341), BGl_proc2580z00zz__evaluate_typesz00, BGl_proc2579z00zz__evaluate_typesz00, BFALSE, BGl_proc2578z00zz__evaluate_typesz00, BFALSE, BgL_arg1759z00_1719, BgL_arg1760z00_1720); } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_arg1784z00_1771;obj_t BgL_arg1785z00_1772;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1319z00_1786;
BgL_v1319z00_1786 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1319z00_1786,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2586z00zz__evaluate_typesz00, BGl_proc2585z00zz__evaluate_typesz00, BGl_proc2584z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2583z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1784z00_1771 = BgL_v1319z00_1786; } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1320z00_1800;
BgL_v1320z00_1800 = 
create_vector(((long)0)); 
BgL_arg1785z00_1772 = BgL_v1320z00_1800; } 
BGl_ev_letz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2591z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)20484), BGl_proc2590z00zz__evaluate_typesz00, BGl_proc2589z00zz__evaluate_typesz00, BFALSE, BGl_proc2588z00zz__evaluate_typesz00, BFALSE, BgL_arg1784z00_1771, BgL_arg1785z00_1772); } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_arg1801z00_1807;obj_t BgL_arg1802z00_1808;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1321z00_1822;
BgL_v1321z00_1822 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1321z00_1822,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2586z00zz__evaluate_typesz00, BGl_proc2595z00zz__evaluate_typesz00, BGl_proc2594z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2593z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1801z00_1807 = BgL_v1321z00_1822; } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1322z00_1836;
BgL_v1322z00_1836 = 
create_vector(((long)0)); 
BgL_arg1802z00_1808 = BgL_v1322z00_1836; } 
BGl_ev_letza2za2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2599z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)9906), BGl_proc2598z00zz__evaluate_typesz00, BGl_proc2597z00zz__evaluate_typesz00, BFALSE, BGl_proc2596z00zz__evaluate_typesz00, BFALSE, BgL_arg1801z00_1807, BgL_arg1802z00_1808); } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_arg1818z00_1843;obj_t BgL_arg1819z00_1844;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1323z00_1857;
BgL_v1323z00_1857 = 
create_vector(((long)0)); 
BgL_arg1818z00_1843 = BgL_v1323z00_1857; } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1324z00_1858;
BgL_v1324z00_1858 = 
create_vector(((long)0)); 
BgL_arg1819z00_1844 = BgL_v1324z00_1858; } 
BGl_ev_letrecz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2604z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)43956), BGl_proc2603z00zz__evaluate_typesz00, BGl_proc2602z00zz__evaluate_typesz00, BFALSE, BGl_proc2601z00zz__evaluate_typesz00, BFALSE, BgL_arg1818z00_1843, BgL_arg1819z00_1844); } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_arg1828z00_1865;obj_t BgL_arg1829z00_1866;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1325z00_1882;
BgL_v1325z00_1882 = 
create_vector(((long)6)); 
VECTOR_SET(BgL_v1325z00_1882,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2570z00zz__evaluate_typesz00, BGl_proc2607z00zz__evaluate_typesz00, BGl_proc2606z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1325z00_1882,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2574z00zz__evaluate_typesz00, BGl_proc2609z00zz__evaluate_typesz00, BGl_proc2608z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1325z00_1882,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2613z00zz__evaluate_typesz00, BGl_proc2612z00zz__evaluate_typesz00, BGl_proc2611z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2610z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1325z00_1882,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2618z00zz__evaluate_typesz00, BGl_proc2617z00zz__evaluate_typesz00, BGl_proc2616z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2615z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1325z00_1882,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2621z00zz__evaluate_typesz00, BGl_proc2620z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1325z00_1882,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2586z00zz__evaluate_typesz00, BGl_proc2624z00zz__evaluate_typesz00, BGl_proc2623z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2622z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1828z00_1865 = BgL_v1325z00_1882; } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1326z00_1952;
BgL_v1326z00_1952 = 
create_vector(((long)0)); 
BgL_arg1829z00_1866 = BgL_v1326z00_1952; } 
BGl_ev_labelsz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2628z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)51941), BGl_proc2627z00zz__evaluate_typesz00, BGl_proc2626z00zz__evaluate_typesz00, BFALSE, BGl_proc2625z00zz__evaluate_typesz00, BFALSE, BgL_arg1828z00_1865, BgL_arg1829z00_1866); } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_arg1874z00_1959;obj_t BgL_arg1875z00_1960;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1327z00_1974;
BgL_v1327z00_1974 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1327z00_1974,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2410z00zz__evaluate_typesz00, BGl_proc2631z00zz__evaluate_typesz00, BGl_proc2630z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1974,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2634z00zz__evaluate_typesz00, BGl_proc2633z00zz__evaluate_typesz00, BGl_proc2632z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1974,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2638z00zz__evaluate_typesz00, BGl_proc2637z00zz__evaluate_typesz00, BGl_proc2636z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1974,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2451z00zz__evaluate_typesz00, BGl_proc2641z00zz__evaluate_typesz00, BGl_proc2640z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1874z00_1959 = BgL_v1327z00_1974; } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1328z00_2015;
BgL_v1328z00_2015 = 
create_vector(((long)0)); 
BgL_arg1875z00_1960 = BgL_v1328z00_2015; } 
BGl_ev_gotoz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2645z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)25746), BGl_proc2644z00zz__evaluate_typesz00, BGl_proc2643z00zz__evaluate_typesz00, BFALSE, BGl_proc2642z00zz__evaluate_typesz00, BFALSE, BgL_arg1874z00_1959, BgL_arg1875z00_1960); } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_arg1904z00_2022;obj_t BgL_arg1905z00_2023;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1329z00_2037;
BgL_v1329z00_2037 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1329z00_2037,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2410z00zz__evaluate_typesz00, BGl_proc2648z00zz__evaluate_typesz00, BGl_proc2647z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1329z00_2037,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2651z00zz__evaluate_typesz00, BGl_proc2650z00zz__evaluate_typesz00, BGl_proc2649z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1329z00_2037,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2451z00zz__evaluate_typesz00, BGl_proc2654z00zz__evaluate_typesz00, BGl_proc2653z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1329z00_2037,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2657z00zz__evaluate_typesz00, BGl_proc2656z00zz__evaluate_typesz00, BGl_proc2655z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1904z00_2022 = BgL_v1329z00_2037; } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1330z00_2078;
BgL_v1330z00_2078 = 
create_vector(((long)0)); 
BgL_arg1905z00_2023 = BgL_v1330z00_2078; } 
BGl_ev_appz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2662z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)55822), BGl_proc2661z00zz__evaluate_typesz00, BGl_proc2660z00zz__evaluate_typesz00, BFALSE, BGl_proc2659z00zz__evaluate_typesz00, BFALSE, BgL_arg1904z00_2022, BgL_arg1905z00_2023); } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_arg1934z00_2085;obj_t BgL_arg1935z00_2086;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1331z00_2106;
BgL_v1331z00_2106 = 
create_vector(((long)10)); 
VECTOR_SET(BgL_v1331z00_2106,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2410z00zz__evaluate_typesz00, BGl_proc2665z00zz__evaluate_typesz00, BGl_proc2664z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2668z00zz__evaluate_typesz00, BGl_proc2667z00zz__evaluate_typesz00, BGl_proc2666z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2672z00zz__evaluate_typesz00, BGl_proc2671z00zz__evaluate_typesz00, BGl_proc2670z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2570z00zz__evaluate_typesz00, BGl_proc2675z00zz__evaluate_typesz00, BGl_proc2674z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2524z00zz__evaluate_typesz00, BGl_proc2677z00zz__evaluate_typesz00, BGl_proc2676z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2681z00zz__evaluate_typesz00, BGl_proc2680z00zz__evaluate_typesz00, BGl_proc2679z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2678z00zz__evaluate_typesz00, BGl_symbol2683z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)6),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2688z00zz__evaluate_typesz00, BGl_proc2687z00zz__evaluate_typesz00, BGl_proc2686z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2685z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)7),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2693z00zz__evaluate_typesz00, BGl_proc2692z00zz__evaluate_typesz00, BGl_proc2691z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2690z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)8),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2698z00zz__evaluate_typesz00, BGl_proc2697z00zz__evaluate_typesz00, BGl_proc2696z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2695z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2106,((long)9),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2586z00zz__evaluate_typesz00, BGl_proc2702z00zz__evaluate_typesz00, BGl_proc2701z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2700z00zz__evaluate_typesz00, BGl_symbol2397z00zz__evaluate_typesz00)); 
BgL_arg1934z00_2085 = BgL_v1331z00_2106; } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1332z00_2222;
BgL_v1332z00_2222 = 
create_vector(((long)0)); 
BgL_arg1935z00_2086 = BgL_v1332z00_2222; } 
return ( 
BGl_ev_absz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2706z00zz__evaluate_typesz00, BGl_symbol2384z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)22827), BGl_proc2705z00zz__evaluate_typesz00, BGl_proc2704z00zz__evaluate_typesz00, BFALSE, BGl_proc2703z00zz__evaluate_typesz00, BFALSE, BgL_arg1934z00_2085, BgL_arg1935z00_2086), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1940> */
obj_t BGl_z62zc3anonymousza31940ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3376, obj_t BgL_new1189z00_3377)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
{ 
BgL_ev_absz00_bglt BgL_auxz00_4559;
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_wherez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_arityz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4568;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_classz00_3852;
BgL_classz00_3852 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL__ortest_1280z00_3853;
BgL__ortest_1280z00_3853 = 
BGL_CLASS_NIL(BgL_classz00_3852); 
if(
CBOOL(BgL__ortest_1280z00_3853))
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4568 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3853)
; }  else 
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4568 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3852))
; } } } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4568),BUNSPEC); } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_siza7eza7)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_bindz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_freez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_innerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1189z00_3377)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4559 = 
((BgL_ev_absz00_bglt)BgL_new1189z00_3377); 
return 
((obj_t)BgL_auxz00_4559);} } 
BGL_FUNCTION_END;
}



/* &lambda1938 */
BgL_ev_absz00_bglt BGl_z62lambda1938z62zz__evaluate_typesz00(obj_t BgL_envz00_3378)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1188z00_3854;
BgL_new1188z00_3854 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1939z00_3855;
{ /* Eval/evaluate_types.scm 122 */
long BgL_res2328z00_3856;
BgL_res2328z00_3856 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg1939z00_3855 = BgL_res2328z00_3856; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1188z00_3854), BgL_arg1939z00_3855); } 
return BgL_new1188z00_3854;} } 
BGL_FUNCTION_END;
}



/* &lambda1936 */
BgL_ev_absz00_bglt BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t BgL_envz00_3379, obj_t BgL_loc1178z00_3380, obj_t BgL_where1179z00_3381, obj_t BgL_arity1180z00_3382, obj_t BgL_vars1181z00_3383, obj_t BgL_body1182z00_3384, obj_t BgL_siza7e1183za7_3385, obj_t BgL_bind1184z00_3386, obj_t BgL_free1185z00_3387, obj_t BgL_inner1186z00_3388, obj_t BgL_boxes1187z00_3389)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_siza7e1183za7_3858;
BgL_siza7e1183za7_3858 = 
CINT(BgL_siza7e1183za7_3385); 
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1241z00_3859;
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1240z00_3860;
BgL_new1240z00_3860 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1937z00_3861;
{ /* Eval/evaluate_types.scm 122 */
long BgL_res2327z00_3862;
BgL_res2327z00_3862 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg1937z00_3861 = BgL_res2327z00_3862; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1240z00_3860), BgL_arg1937z00_3861); } 
BgL_new1241z00_3859 = BgL_new1240z00_3860; } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_locz00)=((obj_t)BgL_loc1178z00_3380),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_wherez00)=((obj_t)BgL_where1179z00_3381),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_arityz00)=((obj_t)BgL_arity1180z00_3382),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_varsz00)=((obj_t)BgL_vars1181z00_3383),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1182z00_3384)),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_siza7eza7)=((int)BgL_siza7e1183za7_3858),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_bindz00)=((obj_t)BgL_bind1184z00_3386),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_freez00)=((obj_t)BgL_free1185z00_3387),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_innerz00)=((obj_t)BgL_inner1186z00_3388),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1241z00_3859))->BgL_boxesz00)=((obj_t)BgL_boxes1187z00_3389),BUNSPEC); 
return BgL_new1241z00_3859;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2000> */
obj_t BGl_z62zc3anonymousza32000ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3390)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1999 */
obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t BgL_envz00_3391, obj_t BgL_oz00_3392, obj_t BgL_vz00_3393)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3392)))->BgL_boxesz00)=((obj_t)BgL_vz00_3393),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1998 */
obj_t BGl_z62lambda1998z62zz__evaluate_typesz00(obj_t BgL_envz00_3394, obj_t BgL_oz00_3395)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3395)))->BgL_boxesz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1993> */
obj_t BGl_z62zc3anonymousza31993ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3396)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1992 */
obj_t BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t BgL_envz00_3397, obj_t BgL_oz00_3398, obj_t BgL_vz00_3399)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3398)))->BgL_innerz00)=((obj_t)BgL_vz00_3399),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1991 */
obj_t BGl_z62lambda1991z62zz__evaluate_typesz00(obj_t BgL_envz00_3400, obj_t BgL_oz00_3401)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3401)))->BgL_innerz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1986> */
obj_t BGl_z62zc3anonymousza31986ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3402)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1985 */
obj_t BGl_z62lambda1985z62zz__evaluate_typesz00(obj_t BgL_envz00_3403, obj_t BgL_oz00_3404, obj_t BgL_vz00_3405)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3404)))->BgL_freez00)=((obj_t)BgL_vz00_3405),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1984 */
obj_t BGl_z62lambda1984z62zz__evaluate_typesz00(obj_t BgL_envz00_3406, obj_t BgL_oz00_3407)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3407)))->BgL_freez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1979> */
obj_t BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3408)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1978 */
obj_t BGl_z62lambda1978z62zz__evaluate_typesz00(obj_t BgL_envz00_3409, obj_t BgL_oz00_3410, obj_t BgL_vz00_3411)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3410)))->BgL_bindz00)=((obj_t)BgL_vz00_3411),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1977 */
obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t BgL_envz00_3412, obj_t BgL_oz00_3413)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3413)))->BgL_bindz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1972> */
obj_t BGl_z62zc3anonymousza31972ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3414)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1971 */
obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t BgL_envz00_3415, obj_t BgL_oz00_3416, obj_t BgL_vz00_3417)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_vz00_3872;
BgL_vz00_3872 = 
CINT(BgL_vz00_3417); 
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3416)))->BgL_siza7eza7)=((int)BgL_vz00_3872),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1970 */
obj_t BGl_z62lambda1970z62zz__evaluate_typesz00(obj_t BgL_envz00_3418, obj_t BgL_oz00_3419)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3419)))->BgL_siza7eza7));} 
BGL_FUNCTION_END;
}



/* &lambda1965 */
obj_t BGl_z62lambda1965z62zz__evaluate_typesz00(obj_t BgL_envz00_3420, obj_t BgL_oz00_3421, obj_t BgL_vz00_3422)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3421)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3422)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1964 */
BgL_ev_exprz00_bglt BGl_z62lambda1964z62zz__evaluate_typesz00(obj_t BgL_envz00_3423, obj_t BgL_oz00_3424)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3424)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &lambda1960 */
obj_t BGl_z62lambda1960z62zz__evaluate_typesz00(obj_t BgL_envz00_3425, obj_t BgL_oz00_3426, obj_t BgL_vz00_3427)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3426)))->BgL_varsz00)=((obj_t)BgL_vz00_3427),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1959 */
obj_t BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t BgL_envz00_3428, obj_t BgL_oz00_3429)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3429)))->BgL_varsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1955 */
obj_t BGl_z62lambda1955z62zz__evaluate_typesz00(obj_t BgL_envz00_3430, obj_t BgL_oz00_3431, obj_t BgL_vz00_3432)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3431)))->BgL_arityz00)=((obj_t)BgL_vz00_3432),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1954 */
obj_t BGl_z62lambda1954z62zz__evaluate_typesz00(obj_t BgL_envz00_3433, obj_t BgL_oz00_3434)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3434)))->BgL_arityz00);} 
BGL_FUNCTION_END;
}



/* &lambda1950 */
obj_t BGl_z62lambda1950z62zz__evaluate_typesz00(obj_t BgL_envz00_3435, obj_t BgL_oz00_3436, obj_t BgL_vz00_3437)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3436)))->BgL_wherez00)=((obj_t)BgL_vz00_3437),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1949 */
obj_t BGl_z62lambda1949z62zz__evaluate_typesz00(obj_t BgL_envz00_3438, obj_t BgL_oz00_3439)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3439)))->BgL_wherez00);} 
BGL_FUNCTION_END;
}



/* &lambda1945 */
obj_t BGl_z62lambda1945z62zz__evaluate_typesz00(obj_t BgL_envz00_3440, obj_t BgL_oz00_3441, obj_t BgL_vz00_3442)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3441)))->BgL_locz00)=((obj_t)BgL_vz00_3442),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1944 */
obj_t BGl_z62lambda1944z62zz__evaluate_typesz00(obj_t BgL_envz00_3443, obj_t BgL_oz00_3444)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3444)))->BgL_locz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1910> */
obj_t BGl_z62zc3anonymousza31910ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3445, obj_t BgL_new1176z00_3446)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
{ 
BgL_ev_appz00_bglt BgL_auxz00_4654;
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1176z00_3446)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4657;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_classz00_3886;
BgL_classz00_3886 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL__ortest_1280z00_3887;
BgL__ortest_1280z00_3887 = 
BGL_CLASS_NIL(BgL_classz00_3886); 
if(
CBOOL(BgL__ortest_1280z00_3887))
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4657 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3887)
; }  else 
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4657 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3886))
; } } } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1176z00_3446)))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4657),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1176z00_3446)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1176z00_3446)))->BgL_tailzf3zf3)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4654 = 
((BgL_ev_appz00_bglt)BgL_new1176z00_3446); 
return 
((obj_t)BgL_auxz00_4654);} } 
BGL_FUNCTION_END;
}



/* &lambda1908 */
BgL_ev_appz00_bglt BGl_z62lambda1908z62zz__evaluate_typesz00(obj_t BgL_envz00_3447)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1175z00_3888;
BgL_new1175z00_3888 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1909z00_3889;
{ /* Eval/evaluate_types.scm 119 */
long BgL_res2326z00_3890;
BgL_res2326z00_3890 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1909z00_3889 = BgL_res2326z00_3890; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1175z00_3888), BgL_arg1909z00_3889); } 
return BgL_new1175z00_3888;} } 
BGL_FUNCTION_END;
}



/* &lambda1906 */
BgL_ev_appz00_bglt BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t BgL_envz00_3448, obj_t BgL_loc1171z00_3449, obj_t BgL_fun1172z00_3450, obj_t BgL_args1173z00_3451, obj_t BgL_tailzf31174zf3_3452)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1239z00_3892;
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1238z00_3893;
BgL_new1238z00_3893 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1907z00_3894;
{ /* Eval/evaluate_types.scm 119 */
long BgL_res2325z00_3895;
BgL_res2325z00_3895 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1907z00_3894 = BgL_res2325z00_3895; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1238z00_3893), BgL_arg1907z00_3894); } 
BgL_new1239z00_3892 = BgL_new1238z00_3893; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1239z00_3892))->BgL_locz00)=((obj_t)BgL_loc1171z00_3449),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1239z00_3892))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_fun1172z00_3450)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1239z00_3892))->BgL_argsz00)=((obj_t)BgL_args1173z00_3451),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1239z00_3892))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf31174zf3_3452),BUNSPEC); 
return BgL_new1239z00_3892;} } 
BGL_FUNCTION_END;
}



/* &lambda1930 */
obj_t BGl_z62lambda1930z62zz__evaluate_typesz00(obj_t BgL_envz00_3453, obj_t BgL_oz00_3454, obj_t BgL_vz00_3455)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3454)))->BgL_tailzf3zf3)=((obj_t)BgL_vz00_3455),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1929 */
obj_t BGl_z62lambda1929z62zz__evaluate_typesz00(obj_t BgL_envz00_3456, obj_t BgL_oz00_3457)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3457)))->BgL_tailzf3zf3);} 
BGL_FUNCTION_END;
}



/* &lambda1925 */
obj_t BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t BgL_envz00_3458, obj_t BgL_oz00_3459, obj_t BgL_vz00_3460)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3459)))->BgL_argsz00)=((obj_t)BgL_vz00_3460),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1924 */
obj_t BGl_z62lambda1924z62zz__evaluate_typesz00(obj_t BgL_envz00_3461, obj_t BgL_oz00_3462)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3462)))->BgL_argsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1920 */
obj_t BGl_z62lambda1920z62zz__evaluate_typesz00(obj_t BgL_envz00_3463, obj_t BgL_oz00_3464, obj_t BgL_vz00_3465)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3464)))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3465)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1919 */
BgL_ev_exprz00_bglt BGl_z62lambda1919z62zz__evaluate_typesz00(obj_t BgL_envz00_3466, obj_t BgL_oz00_3467)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3467)))->BgL_funz00);} 
BGL_FUNCTION_END;
}



/* &lambda1915 */
obj_t BGl_z62lambda1915z62zz__evaluate_typesz00(obj_t BgL_envz00_3468, obj_t BgL_oz00_3469, obj_t BgL_vz00_3470)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3469)))->BgL_locz00)=((obj_t)BgL_vz00_3470),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1914 */
obj_t BGl_z62lambda1914z62zz__evaluate_typesz00(obj_t BgL_envz00_3471, obj_t BgL_oz00_3472)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3472)))->BgL_locz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1880> */
obj_t BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3473, obj_t BgL_new1169z00_3474)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
{ 
BgL_ev_gotoz00_bglt BgL_auxz00_4702;
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1169z00_3474)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_varz00_bglt BgL_auxz00_4705;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3906;
BgL_classz00_3906 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1280z00_3907;
BgL__ortest_1280z00_3907 = 
BGL_CLASS_NIL(BgL_classz00_3906); 
if(
CBOOL(BgL__ortest_1280z00_3907))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4705 = 
((BgL_ev_varz00_bglt)BgL__ortest_1280z00_3907)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4705 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3906))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1169z00_3474)))->BgL_labelz00)=((BgL_ev_varz00_bglt)BgL_auxz00_4705),BUNSPEC); } 
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4714;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3908;
BgL_classz00_3908 = BGl_ev_labelsz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1280z00_3909;
BgL__ortest_1280z00_3909 = 
BGL_CLASS_NIL(BgL_classz00_3908); 
if(
CBOOL(BgL__ortest_1280z00_3909))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4714 = 
((BgL_ev_labelsz00_bglt)BgL__ortest_1280z00_3909)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4714 = 
((BgL_ev_labelsz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3908))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1169z00_3474)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)BgL_auxz00_4714),BUNSPEC); } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1169z00_3474)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4702 = 
((BgL_ev_gotoz00_bglt)BgL_new1169z00_3474); 
return 
((obj_t)BgL_auxz00_4702);} } 
BGL_FUNCTION_END;
}



/* &lambda1878 */
BgL_ev_gotoz00_bglt BGl_z62lambda1878z62zz__evaluate_typesz00(obj_t BgL_envz00_3475)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1168z00_3910;
BgL_new1168z00_3910 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1879z00_3911;
{ /* Eval/evaluate_types.scm 114 */
long BgL_res2324z00_3912;
BgL_res2324z00_3912 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BgL_arg1879z00_3911 = BgL_res2324z00_3912; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1168z00_3910), BgL_arg1879z00_3911); } 
return BgL_new1168z00_3910;} } 
BGL_FUNCTION_END;
}



/* &lambda1876 */
BgL_ev_gotoz00_bglt BGl_z62lambda1876z62zz__evaluate_typesz00(obj_t BgL_envz00_3476, obj_t BgL_loc1164z00_3477, obj_t BgL_label1165z00_3478, obj_t BgL_labels1166z00_3479, obj_t BgL_args1167z00_3480)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1237z00_3915;
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1236z00_3916;
BgL_new1236z00_3916 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1877z00_3917;
{ /* Eval/evaluate_types.scm 114 */
long BgL_res2323z00_3918;
BgL_res2323z00_3918 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BgL_arg1877z00_3917 = BgL_res2323z00_3918; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1236z00_3916), BgL_arg1877z00_3917); } 
BgL_new1237z00_3915 = BgL_new1236z00_3916; } 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1237z00_3915))->BgL_locz00)=((obj_t)BgL_loc1164z00_3477),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1237z00_3915))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_label1165z00_3478)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1237z00_3915))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_labels1166z00_3479)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1237z00_3915))->BgL_argsz00)=((obj_t)BgL_args1167z00_3480),BUNSPEC); 
return BgL_new1237z00_3915;} } 
BGL_FUNCTION_END;
}



/* &lambda1900 */
obj_t BGl_z62lambda1900z62zz__evaluate_typesz00(obj_t BgL_envz00_3481, obj_t BgL_oz00_3482, obj_t BgL_vz00_3483)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3482)))->BgL_argsz00)=((obj_t)BgL_vz00_3483),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1899 */
obj_t BGl_z62lambda1899z62zz__evaluate_typesz00(obj_t BgL_envz00_3484, obj_t BgL_oz00_3485)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3485)))->BgL_argsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1895 */
obj_t BGl_z62lambda1895z62zz__evaluate_typesz00(obj_t BgL_envz00_3486, obj_t BgL_oz00_3487, obj_t BgL_vz00_3488)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3487)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_vz00_3488)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1894 */
BgL_ev_labelsz00_bglt BGl_z62lambda1894z62zz__evaluate_typesz00(obj_t BgL_envz00_3489, obj_t BgL_oz00_3490)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3490)))->BgL_labelsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1890 */
obj_t BGl_z62lambda1890z62zz__evaluate_typesz00(obj_t BgL_envz00_3491, obj_t BgL_oz00_3492, obj_t BgL_vz00_3493)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3492)))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3493)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1889 */
BgL_ev_varz00_bglt BGl_z62lambda1889z62zz__evaluate_typesz00(obj_t BgL_envz00_3494, obj_t BgL_oz00_3495)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3495)))->BgL_labelz00);} 
BGL_FUNCTION_END;
}



/* &lambda1885 */
obj_t BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t BgL_envz00_3496, obj_t BgL_oz00_3497, obj_t BgL_vz00_3498)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3497)))->BgL_locz00)=((obj_t)BgL_vz00_3498),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1884 */
obj_t BGl_z62lambda1884z62zz__evaluate_typesz00(obj_t BgL_envz00_3499, obj_t BgL_oz00_3500)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3500)))->BgL_locz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1834> */
obj_t BGl_z62zc3anonymousza31834ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3501, obj_t BgL_new1162z00_3502)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4759;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502)))->BgL_envz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502)))->BgL_stkz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4768;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_classz00_3930;
BgL_classz00_3930 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL__ortest_1280z00_3931;
BgL__ortest_1280z00_3931 = 
BGL_CLASS_NIL(BgL_classz00_3930); 
if(
CBOOL(BgL__ortest_1280z00_3931))
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4768 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3931)
; }  else 
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4768 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3930))
; } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4768),BUNSPEC); } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4759 = 
((BgL_ev_labelsz00_bglt)BgL_new1162z00_3502); 
return 
((obj_t)BgL_auxz00_4759);} } 
BGL_FUNCTION_END;
}



/* &lambda1832 */
BgL_ev_labelsz00_bglt BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t BgL_envz00_3503)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1161z00_3932;
BgL_new1161z00_3932 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1833z00_3933;
{ /* Eval/evaluate_types.scm 106 */
long BgL_res2322z00_3934;
BgL_res2322z00_3934 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BgL_arg1833z00_3933 = BgL_res2322z00_3934; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1161z00_3932), BgL_arg1833z00_3933); } 
return BgL_new1161z00_3932;} } 
BGL_FUNCTION_END;
}



/* &lambda1830 */
BgL_ev_labelsz00_bglt BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t BgL_envz00_3504, obj_t BgL_vars1155z00_3505, obj_t BgL_vals1156z00_3506, obj_t BgL_env1157z00_3507, obj_t BgL_stk1158z00_3508, obj_t BgL_body1159z00_3509, obj_t BgL_boxes1160z00_3510)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1235z00_3936;
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1234z00_3937;
BgL_new1234z00_3937 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1831z00_3938;
{ /* Eval/evaluate_types.scm 106 */
long BgL_res2321z00_3939;
BgL_res2321z00_3939 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BgL_arg1831z00_3938 = BgL_res2321z00_3939; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1234z00_3937), BgL_arg1831z00_3938); } 
BgL_new1235z00_3936 = BgL_new1234z00_3937; } 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1235z00_3936))->BgL_varsz00)=((obj_t)BgL_vars1155z00_3505),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1235z00_3936))->BgL_valsz00)=((obj_t)BgL_vals1156z00_3506),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1235z00_3936))->BgL_envz00)=((obj_t)BgL_env1157z00_3507),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1235z00_3936))->BgL_stkz00)=((obj_t)BgL_stk1158z00_3508),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1235z00_3936))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1159z00_3509)),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1235z00_3936))->BgL_boxesz00)=((obj_t)BgL_boxes1160z00_3510),BUNSPEC); 
return BgL_new1235z00_3936;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1870> */
obj_t BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3511)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1869 */
obj_t BGl_z62lambda1869z62zz__evaluate_typesz00(obj_t BgL_envz00_3512, obj_t BgL_oz00_3513, obj_t BgL_vz00_3514)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3513)))->BgL_boxesz00)=((obj_t)BgL_vz00_3514),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1868 */
obj_t BGl_z62lambda1868z62zz__evaluate_typesz00(obj_t BgL_envz00_3515, obj_t BgL_oz00_3516)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3516)))->BgL_boxesz00);} 
BGL_FUNCTION_END;
}



/* &lambda1863 */
obj_t BGl_z62lambda1863z62zz__evaluate_typesz00(obj_t BgL_envz00_3517, obj_t BgL_oz00_3518, obj_t BgL_vz00_3519)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3518)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3519)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1862 */
BgL_ev_exprz00_bglt BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t BgL_envz00_3520, obj_t BgL_oz00_3521)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3521)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1858> */
obj_t BGl_z62zc3anonymousza31858ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3522)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1857 */
obj_t BGl_z62lambda1857z62zz__evaluate_typesz00(obj_t BgL_envz00_3523, obj_t BgL_oz00_3524, obj_t BgL_vz00_3525)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3524)))->BgL_stkz00)=((obj_t)BgL_vz00_3525),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1856 */
obj_t BGl_z62lambda1856z62zz__evaluate_typesz00(obj_t BgL_envz00_3526, obj_t BgL_oz00_3527)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3527)))->BgL_stkz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1851> */
obj_t BGl_z62zc3anonymousza31851ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3528)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1850 */
obj_t BGl_z62lambda1850z62zz__evaluate_typesz00(obj_t BgL_envz00_3529, obj_t BgL_oz00_3530, obj_t BgL_vz00_3531)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3530)))->BgL_envz00)=((obj_t)BgL_vz00_3531),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1849 */
obj_t BGl_z62lambda1849z62zz__evaluate_typesz00(obj_t BgL_envz00_3532, obj_t BgL_oz00_3533)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3533)))->BgL_envz00);} 
BGL_FUNCTION_END;
}



/* &lambda1844 */
obj_t BGl_z62lambda1844z62zz__evaluate_typesz00(obj_t BgL_envz00_3534, obj_t BgL_oz00_3535, obj_t BgL_vz00_3536)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3535)))->BgL_valsz00)=((obj_t)BgL_vz00_3536),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1843 */
obj_t BGl_z62lambda1843z62zz__evaluate_typesz00(obj_t BgL_envz00_3537, obj_t BgL_oz00_3538)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3538)))->BgL_valsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1839 */
obj_t BGl_z62lambda1839z62zz__evaluate_typesz00(obj_t BgL_envz00_3539, obj_t BgL_oz00_3540, obj_t BgL_vz00_3541)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3540)))->BgL_varsz00)=((obj_t)BgL_vz00_3541),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1838 */
obj_t BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t BgL_envz00_3542, obj_t BgL_oz00_3543)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3543)))->BgL_varsz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1824> */
obj_t BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3544, obj_t BgL_new1153z00_3545)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 105 */
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_4821;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1153z00_3545))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1153z00_3545))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4828;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_classz00_3954;
BgL_classz00_3954 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL__ortest_1280z00_3955;
BgL__ortest_1280z00_3955 = 
BGL_CLASS_NIL(BgL_classz00_3954); 
if(
CBOOL(BgL__ortest_1280z00_3955))
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4828 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3955)
; }  else 
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4828 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3954))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1153z00_3545))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4828),BUNSPEC); } 
BgL_auxz00_4821 = 
((BgL_ev_letrecz00_bglt)BgL_new1153z00_3545); 
return 
((obj_t)BgL_auxz00_4821);} } 
BGL_FUNCTION_END;
}



/* &lambda1822 */
BgL_ev_letrecz00_bglt BGl_z62lambda1822z62zz__evaluate_typesz00(obj_t BgL_envz00_3546)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1152z00_3956;
BgL_new1152z00_3956 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1823z00_3957;
{ /* Eval/evaluate_types.scm 105 */
long BgL_res2320z00_3958;
BgL_res2320z00_3958 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg1823z00_3957 = BgL_res2320z00_3958; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1152z00_3956), BgL_arg1823z00_3957); } 
return BgL_new1152z00_3956;} } 
BGL_FUNCTION_END;
}



/* &lambda1820 */
BgL_ev_letrecz00_bglt BGl_z62lambda1820z62zz__evaluate_typesz00(obj_t BgL_envz00_3547, obj_t BgL_vars1149z00_3548, obj_t BgL_vals1150z00_3549, obj_t BgL_body1151z00_3550)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1233z00_3960;
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1232z00_3961;
BgL_new1232z00_3961 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1821z00_3962;
{ /* Eval/evaluate_types.scm 105 */
long BgL_res2319z00_3963;
BgL_res2319z00_3963 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg1821z00_3962 = BgL_res2319z00_3963; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1232z00_3961), BgL_arg1821z00_3962); } 
BgL_new1233z00_3960 = BgL_new1232z00_3961; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1233z00_3960)))->BgL_varsz00)=((obj_t)BgL_vars1149z00_3548),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1233z00_3960)))->BgL_valsz00)=((obj_t)BgL_vals1150z00_3549),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1233z00_3960)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1151z00_3550)),BUNSPEC); 
return BgL_new1233z00_3960;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1807> */
obj_t BGl_z62zc3anonymousza31807ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3551, obj_t BgL_new1147z00_3552)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 103 */
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_4855;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1147z00_3552))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1147z00_3552))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4862;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_classz00_3965;
BgL_classz00_3965 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL__ortest_1280z00_3966;
BgL__ortest_1280z00_3966 = 
BGL_CLASS_NIL(BgL_classz00_3965); 
if(
CBOOL(BgL__ortest_1280z00_3966))
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4862 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3966)
; }  else 
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4862 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3965))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1147z00_3552))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4862),BUNSPEC); } 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_new1147z00_3552)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4855 = 
((BgL_ev_letza2za2_bglt)BgL_new1147z00_3552); 
return 
((obj_t)BgL_auxz00_4855);} } 
BGL_FUNCTION_END;
}



/* &lambda1805 */
BgL_ev_letza2za2_bglt BGl_z62lambda1805z62zz__evaluate_typesz00(obj_t BgL_envz00_3553)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1146z00_3967;
BgL_new1146z00_3967 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1806z00_3968;
{ /* Eval/evaluate_types.scm 103 */
long BgL_res2318z00_3969;
BgL_res2318z00_3969 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg1806z00_3968 = BgL_res2318z00_3969; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1146z00_3967), BgL_arg1806z00_3968); } 
return BgL_new1146z00_3967;} } 
BGL_FUNCTION_END;
}



/* &lambda1803 */
BgL_ev_letza2za2_bglt BGl_z62lambda1803z62zz__evaluate_typesz00(obj_t BgL_envz00_3554, obj_t BgL_vars1142z00_3555, obj_t BgL_vals1143z00_3556, obj_t BgL_body1144z00_3557, obj_t BgL_boxes1145z00_3558)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1231z00_3971;
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1230z00_3972;
BgL_new1230z00_3972 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1804z00_3973;
{ /* Eval/evaluate_types.scm 103 */
long BgL_res2317z00_3974;
BgL_res2317z00_3974 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg1804z00_3973 = BgL_res2317z00_3974; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1230z00_3972), BgL_arg1804z00_3973); } 
BgL_new1231z00_3971 = BgL_new1230z00_3972; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1231z00_3971)))->BgL_varsz00)=((obj_t)BgL_vars1142z00_3555),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1231z00_3971)))->BgL_valsz00)=((obj_t)BgL_vals1143z00_3556),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1231z00_3971)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1144z00_3557)),BUNSPEC); 
((((BgL_ev_letza2za2_bglt)COBJECT(BgL_new1231z00_3971))->BgL_boxesz00)=((obj_t)BgL_boxes1145z00_3558),BUNSPEC); 
return BgL_new1231z00_3971;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1814> */
obj_t BGl_z62zc3anonymousza31814ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3559)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 103 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1813 */
obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t BgL_envz00_3560, obj_t BgL_oz00_3561, obj_t BgL_vz00_3562)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 103 */
return 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3561)))->BgL_boxesz00)=((obj_t)BgL_vz00_3562),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1812 */
obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t BgL_envz00_3563, obj_t BgL_oz00_3564)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 103 */
return 
(((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3564)))->BgL_boxesz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1790> */
obj_t BGl_z62zc3anonymousza31790ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3565, obj_t BgL_new1140z00_3566)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 101 */
{ 
BgL_ev_letz00_bglt BgL_auxz00_4896;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1140z00_3566))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1140z00_3566))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4903;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_classz00_3978;
BgL_classz00_3978 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL__ortest_1280z00_3979;
BgL__ortest_1280z00_3979 = 
BGL_CLASS_NIL(BgL_classz00_3978); 
if(
CBOOL(BgL__ortest_1280z00_3979))
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4903 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3979)
; }  else 
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4903 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3978))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1140z00_3566))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4903),BUNSPEC); } 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_new1140z00_3566)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4896 = 
((BgL_ev_letz00_bglt)BgL_new1140z00_3566); 
return 
((obj_t)BgL_auxz00_4896);} } 
BGL_FUNCTION_END;
}



/* &lambda1788 */
BgL_ev_letz00_bglt BGl_z62lambda1788z62zz__evaluate_typesz00(obj_t BgL_envz00_3567)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1139z00_3980;
BgL_new1139z00_3980 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1789z00_3981;
{ /* Eval/evaluate_types.scm 101 */
long BgL_res2316z00_3982;
BgL_res2316z00_3982 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg1789z00_3981 = BgL_res2316z00_3982; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1139z00_3980), BgL_arg1789z00_3981); } 
return BgL_new1139z00_3980;} } 
BGL_FUNCTION_END;
}



/* &lambda1786 */
BgL_ev_letz00_bglt BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t BgL_envz00_3568, obj_t BgL_vars1135z00_3569, obj_t BgL_vals1136z00_3570, obj_t BgL_body1137z00_3571, obj_t BgL_boxes1138z00_3572)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1229z00_3984;
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1228z00_3985;
BgL_new1228z00_3985 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1787z00_3986;
{ /* Eval/evaluate_types.scm 101 */
long BgL_res2315z00_3987;
BgL_res2315z00_3987 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg1787z00_3986 = BgL_res2315z00_3987; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1228z00_3985), BgL_arg1787z00_3986); } 
BgL_new1229z00_3984 = BgL_new1228z00_3985; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1229z00_3984)))->BgL_varsz00)=((obj_t)BgL_vars1135z00_3569),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1229z00_3984)))->BgL_valsz00)=((obj_t)BgL_vals1136z00_3570),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1229z00_3984)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1137z00_3571)),BUNSPEC); 
((((BgL_ev_letz00_bglt)COBJECT(BgL_new1229z00_3984))->BgL_boxesz00)=((obj_t)BgL_boxes1138z00_3572),BUNSPEC); 
return BgL_new1229z00_3984;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1797> */
obj_t BGl_z62zc3anonymousza31797ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3573)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 101 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1796 */
obj_t BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t BgL_envz00_3574, obj_t BgL_oz00_3575, obj_t BgL_vz00_3576)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 101 */
return 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3575)))->BgL_boxesz00)=((obj_t)BgL_vz00_3576),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1795 */
obj_t BGl_z62lambda1795z62zz__evaluate_typesz00(obj_t BgL_envz00_3577, obj_t BgL_oz00_3578)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 101 */
return 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3578)))->BgL_boxesz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1765> */
obj_t BGl_z62zc3anonymousza31765ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3579, obj_t BgL_new1133z00_3580)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
{ 
BgL_ev_binderz00_bglt BgL_auxz00_4937;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1133z00_3580)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1133z00_3580)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4942;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_classz00_3991;
BgL_classz00_3991 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL__ortest_1280z00_3992;
BgL__ortest_1280z00_3992 = 
BGL_CLASS_NIL(BgL_classz00_3991); 
if(
CBOOL(BgL__ortest_1280z00_3992))
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4942 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_3992)
; }  else 
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4942 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3991))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1133z00_3580)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4942),BUNSPEC); } 
BgL_auxz00_4937 = 
((BgL_ev_binderz00_bglt)BgL_new1133z00_3580); 
return 
((obj_t)BgL_auxz00_4937);} } 
BGL_FUNCTION_END;
}



/* &lambda1763 */
BgL_ev_binderz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t BgL_envz00_3581)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1132z00_3993;
BgL_new1132z00_3993 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1764z00_3994;
{ /* Eval/evaluate_types.scm 97 */
long BgL_res2314z00_3995;
BgL_res2314z00_3995 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BgL_arg1764z00_3994 = BgL_res2314z00_3995; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1132z00_3993), BgL_arg1764z00_3994); } 
return BgL_new1132z00_3993;} } 
BGL_FUNCTION_END;
}



/* &lambda1761 */
BgL_ev_binderz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t BgL_envz00_3582, obj_t BgL_vars1129z00_3583, obj_t BgL_vals1130z00_3584, obj_t BgL_body1131z00_3585)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1227z00_3997;
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1226z00_3998;
BgL_new1226z00_3998 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1762z00_3999;
{ /* Eval/evaluate_types.scm 97 */
long BgL_res2313z00_4000;
BgL_res2313z00_4000 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BgL_arg1762z00_3999 = BgL_res2313z00_4000; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1226z00_3998), BgL_arg1762z00_3999); } 
BgL_new1227z00_3997 = BgL_new1226z00_3998; } 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1227z00_3997))->BgL_varsz00)=((obj_t)BgL_vars1129z00_3583),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1227z00_3997))->BgL_valsz00)=((obj_t)BgL_vals1130z00_3584),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1227z00_3997))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1131z00_3585)),BUNSPEC); 
return BgL_new1227z00_3997;} } 
BGL_FUNCTION_END;
}



/* &lambda1780 */
obj_t BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t BgL_envz00_3586, obj_t BgL_oz00_3587, obj_t BgL_vz00_3588)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3587)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3588)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1779 */
BgL_ev_exprz00_bglt BGl_z62lambda1779z62zz__evaluate_typesz00(obj_t BgL_envz00_3589, obj_t BgL_oz00_3590)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3590)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &lambda1775 */
obj_t BGl_z62lambda1775z62zz__evaluate_typesz00(obj_t BgL_envz00_3591, obj_t BgL_oz00_3592, obj_t BgL_vz00_3593)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3592)))->BgL_valsz00)=((obj_t)BgL_vz00_3593),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1774 */
obj_t BGl_z62lambda1774z62zz__evaluate_typesz00(obj_t BgL_envz00_3594, obj_t BgL_oz00_3595)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3595)))->BgL_valsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1770 */
obj_t BGl_z62lambda1770z62zz__evaluate_typesz00(obj_t BgL_envz00_3596, obj_t BgL_oz00_3597, obj_t BgL_vz00_3598)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3597)))->BgL_varsz00)=((obj_t)BgL_vz00_3598),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1769 */
obj_t BGl_z62lambda1769z62zz__evaluate_typesz00(obj_t BgL_envz00_3599, obj_t BgL_oz00_3600)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3600)))->BgL_varsz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1735> */
obj_t BGl_z62zc3anonymousza31735ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3601, obj_t BgL_new1127z00_3602)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_4978;
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1127z00_3602)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4981;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4009;
BgL_classz00_4009 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1280z00_4010;
BgL__ortest_1280z00_4010 = 
BGL_CLASS_NIL(BgL_classz00_4009); 
if(
CBOOL(BgL__ortest_1280z00_4010))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4981 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4010)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4981 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4009))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1127z00_3602)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4981),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4990;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4011;
BgL_classz00_4011 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1280z00_4012;
BgL__ortest_1280z00_4012 = 
BGL_CLASS_NIL(BgL_classz00_4011); 
if(
CBOOL(BgL__ortest_1280z00_4012))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4990 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4012)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4990 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4011))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1127z00_3602)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4990),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4999;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4013;
BgL_classz00_4013 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1280z00_4014;
BgL__ortest_1280z00_4014 = 
BGL_CLASS_NIL(BgL_classz00_4013); 
if(
CBOOL(BgL__ortest_1280z00_4014))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4999 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4014)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4999 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4013))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1127z00_3602)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4999),BUNSPEC); } 
BgL_auxz00_4978 = 
((BgL_ev_synchroniza7eza7_bglt)BgL_new1127z00_3602); 
return 
((obj_t)BgL_auxz00_4978);} } 
BGL_FUNCTION_END;
}



/* &lambda1733 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1733z62zz__evaluate_typesz00(obj_t BgL_envz00_3603)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1126z00_4015;
BgL_new1126z00_4015 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1734z00_4016;
{ /* Eval/evaluate_types.scm 92 */
long BgL_res2312z00_4017;
BgL_res2312z00_4017 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg1734z00_4016 = BgL_res2312z00_4017; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_4015), BgL_arg1734z00_4016); } 
return BgL_new1126z00_4015;} } 
BGL_FUNCTION_END;
}



/* &lambda1731 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1731z62zz__evaluate_typesz00(obj_t BgL_envz00_3604, obj_t BgL_loc1122z00_3605, obj_t BgL_mutex1123z00_3606, obj_t BgL_prelock1124z00_3607, obj_t BgL_body1125z00_3608)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1225z00_4021;
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1224z00_4022;
BgL_new1224z00_4022 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1732z00_4023;
{ /* Eval/evaluate_types.scm 92 */
long BgL_res2311z00_4024;
BgL_res2311z00_4024 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg1732z00_4023 = BgL_res2311z00_4024; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1224z00_4022), BgL_arg1732z00_4023); } 
BgL_new1225z00_4021 = BgL_new1224z00_4022; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1225z00_4021))->BgL_locz00)=((obj_t)BgL_loc1122z00_3605),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1225z00_4021))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_mutex1123z00_3606)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1225z00_4021))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_prelock1124z00_3607)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1225z00_4021))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1125z00_3608)),BUNSPEC); 
return BgL_new1225z00_4021;} } 
BGL_FUNCTION_END;
}



/* &lambda1755 */
obj_t BGl_z62lambda1755z62zz__evaluate_typesz00(obj_t BgL_envz00_3609, obj_t BgL_oz00_3610, obj_t BgL_vz00_3611)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3610)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3611)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1754 */
BgL_ev_exprz00_bglt BGl_z62lambda1754z62zz__evaluate_typesz00(obj_t BgL_envz00_3612, obj_t BgL_oz00_3613)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3613)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &lambda1750 */
obj_t BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t BgL_envz00_3614, obj_t BgL_oz00_3615, obj_t BgL_vz00_3616)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3615)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3616)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1749 */
BgL_ev_exprz00_bglt BGl_z62lambda1749z62zz__evaluate_typesz00(obj_t BgL_envz00_3617, obj_t BgL_oz00_3618)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3618)))->BgL_prelockz00);} 
BGL_FUNCTION_END;
}



/* &lambda1745 */
obj_t BGl_z62lambda1745z62zz__evaluate_typesz00(obj_t BgL_envz00_3619, obj_t BgL_oz00_3620, obj_t BgL_vz00_3621)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3620)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3621)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1744 */
BgL_ev_exprz00_bglt BGl_z62lambda1744z62zz__evaluate_typesz00(obj_t BgL_envz00_3622, obj_t BgL_oz00_3623)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3623)))->BgL_mutexz00);} 
BGL_FUNCTION_END;
}



/* &lambda1740 */
obj_t BGl_z62lambda1740z62zz__evaluate_typesz00(obj_t BgL_envz00_3624, obj_t BgL_oz00_3625, obj_t BgL_vz00_3626)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3625)))->BgL_locz00)=((obj_t)BgL_vz00_3626),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1739 */
obj_t BGl_z62lambda1739z62zz__evaluate_typesz00(obj_t BgL_envz00_3627, obj_t BgL_oz00_3628)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3628)))->BgL_locz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1715> */
obj_t BGl_z62zc3anonymousza31715ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3629, obj_t BgL_new1120z00_3630)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_5044;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5045;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_4037;
BgL_classz00_4037 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1280z00_4038;
BgL__ortest_1280z00_4038 = 
BGL_CLASS_NIL(BgL_classz00_4037); 
if(
CBOOL(BgL__ortest_1280z00_4038))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5045 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4038)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5045 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4037))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1120z00_3630)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5045),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5054;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_4039;
BgL_classz00_4039 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1280z00_4040;
BgL__ortest_1280z00_4040 = 
BGL_CLASS_NIL(BgL_classz00_4039); 
if(
CBOOL(BgL__ortest_1280z00_4040))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5054 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4040)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5054 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4039))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1120z00_3630)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5054),BUNSPEC); } 
BgL_auxz00_5044 = 
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1120z00_3630); 
return 
((obj_t)BgL_auxz00_5044);} } 
BGL_FUNCTION_END;
}



/* &lambda1713 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1713z62zz__evaluate_typesz00(obj_t BgL_envz00_3631)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1119z00_4041;
BgL_new1119z00_4041 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1714z00_4042;
{ /* Eval/evaluate_types.scm 89 */
long BgL_res2310z00_4043;
BgL_res2310z00_4043 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg1714z00_4042 = BgL_res2310z00_4043; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_4041), BgL_arg1714z00_4042); } 
return BgL_new1119z00_4041;} } 
BGL_FUNCTION_END;
}



/* &lambda1711 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1711z62zz__evaluate_typesz00(obj_t BgL_envz00_3632, obj_t BgL_handler1117z00_3633, obj_t BgL_body1118z00_3634)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1223z00_4046;
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1222z00_4047;
BgL_new1222z00_4047 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1712z00_4048;
{ /* Eval/evaluate_types.scm 89 */
long BgL_res2309z00_4049;
BgL_res2309z00_4049 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg1712z00_4048 = BgL_res2309z00_4049; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1222z00_4047), BgL_arg1712z00_4048); } 
BgL_new1223z00_4046 = BgL_new1222z00_4047; } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1223z00_4046))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_handler1117z00_3633)),BUNSPEC); 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1223z00_4046))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1118z00_3634)),BUNSPEC); 
return BgL_new1223z00_4046;} } 
BGL_FUNCTION_END;
}



/* &lambda1725 */
obj_t BGl_z62lambda1725z62zz__evaluate_typesz00(obj_t BgL_envz00_3635, obj_t BgL_oz00_3636, obj_t BgL_vz00_3637)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3636)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3637)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1724 */
BgL_ev_exprz00_bglt BGl_z62lambda1724z62zz__evaluate_typesz00(obj_t BgL_envz00_3638, obj_t BgL_oz00_3639)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3639)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &lambda1720 */
obj_t BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t BgL_envz00_3640, obj_t BgL_oz00_3641, obj_t BgL_vz00_3642)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3641)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3642)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1719 */
BgL_ev_exprz00_bglt BGl_z62lambda1719z62zz__evaluate_typesz00(obj_t BgL_envz00_3643, obj_t BgL_oz00_3644)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3644)))->BgL_handlerz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1695> */
obj_t BGl_z62zc3anonymousza31695ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3645, obj_t BgL_new1115z00_3646)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_5087;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5088;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_4057;
BgL_classz00_4057 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1280z00_4058;
BgL__ortest_1280z00_4058 = 
BGL_CLASS_NIL(BgL_classz00_4057); 
if(
CBOOL(BgL__ortest_1280z00_4058))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5088 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4058)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5088 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4057))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1115z00_3646)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5088),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5097;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_4059;
BgL_classz00_4059 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1280z00_4060;
BgL__ortest_1280z00_4060 = 
BGL_CLASS_NIL(BgL_classz00_4059); 
if(
CBOOL(BgL__ortest_1280z00_4060))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5097 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4060)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5097 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4059))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1115z00_3646)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5097),BUNSPEC); } 
BgL_auxz00_5087 = 
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1115z00_3646); 
return 
((obj_t)BgL_auxz00_5087);} } 
BGL_FUNCTION_END;
}



/* &lambda1693 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t BgL_envz00_3647)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1114z00_4061;
BgL_new1114z00_4061 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1694z00_4062;
{ /* Eval/evaluate_types.scm 86 */
long BgL_res2308z00_4063;
BgL_res2308z00_4063 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg1694z00_4062 = BgL_res2308z00_4063; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1114z00_4061), BgL_arg1694z00_4062); } 
return BgL_new1114z00_4061;} } 
BGL_FUNCTION_END;
}



/* &lambda1691 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1691z62zz__evaluate_typesz00(obj_t BgL_envz00_3648, obj_t BgL_e1112z00_3649, obj_t BgL_body1113z00_3650)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1221z00_4066;
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1220z00_4067;
BgL_new1220z00_4067 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1692z00_4068;
{ /* Eval/evaluate_types.scm 86 */
long BgL_res2307z00_4069;
BgL_res2307z00_4069 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg1692z00_4068 = BgL_res2307z00_4069; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1220z00_4067), BgL_arg1692z00_4068); } 
BgL_new1221z00_4066 = BgL_new1220z00_4067; } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1221z00_4066))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1112z00_3649)),BUNSPEC); 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1221z00_4066))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1113z00_3650)),BUNSPEC); 
return BgL_new1221z00_4066;} } 
BGL_FUNCTION_END;
}



/* &lambda1705 */
obj_t BGl_z62lambda1705z62zz__evaluate_typesz00(obj_t BgL_envz00_3651, obj_t BgL_oz00_3652, obj_t BgL_vz00_3653)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3652)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3653)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1704 */
BgL_ev_exprz00_bglt BGl_z62lambda1704z62zz__evaluate_typesz00(obj_t BgL_envz00_3654, obj_t BgL_oz00_3655)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3655)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &lambda1700 */
obj_t BGl_z62lambda1700z62zz__evaluate_typesz00(obj_t BgL_envz00_3656, obj_t BgL_oz00_3657, obj_t BgL_vz00_3658)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3657)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3658)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1699 */
BgL_ev_exprz00_bglt BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t BgL_envz00_3659, obj_t BgL_oz00_3660)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3660)))->BgL_ez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1675> */
obj_t BGl_z62zc3anonymousza31675ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3661, obj_t BgL_new1110z00_3662)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_5130;
{ 
BgL_ev_varz00_bglt BgL_auxz00_5131;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_4077;
BgL_classz00_4077 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1280z00_4078;
BgL__ortest_1280z00_4078 = 
BGL_CLASS_NIL(BgL_classz00_4077); 
if(
CBOOL(BgL__ortest_1280z00_4078))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5131 = 
((BgL_ev_varz00_bglt)BgL__ortest_1280z00_4078)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5131 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4077))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1110z00_3662)))->BgL_varz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5131),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5140;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_4079;
BgL_classz00_4079 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1280z00_4080;
BgL__ortest_1280z00_4080 = 
BGL_CLASS_NIL(BgL_classz00_4079); 
if(
CBOOL(BgL__ortest_1280z00_4080))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5140 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4080)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5140 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4079))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1110z00_3662)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5140),BUNSPEC); } 
BgL_auxz00_5130 = 
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1110z00_3662); 
return 
((obj_t)BgL_auxz00_5130);} } 
BGL_FUNCTION_END;
}



/* &lambda1673 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1673z62zz__evaluate_typesz00(obj_t BgL_envz00_3663)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1109z00_4081;
BgL_new1109z00_4081 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1674z00_4082;
{ /* Eval/evaluate_types.scm 83 */
long BgL_res2306z00_4083;
BgL_res2306z00_4083 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg1674z00_4082 = BgL_res2306z00_4083; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_4081), BgL_arg1674z00_4082); } 
return BgL_new1109z00_4081;} } 
BGL_FUNCTION_END;
}



/* &lambda1671 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1671z62zz__evaluate_typesz00(obj_t BgL_envz00_3664, obj_t BgL_var1107z00_3665, obj_t BgL_body1108z00_3666)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1219z00_4086;
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1218z00_4087;
BgL_new1218z00_4087 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1672z00_4088;
{ /* Eval/evaluate_types.scm 83 */
long BgL_res2305z00_4089;
BgL_res2305z00_4089 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg1672z00_4088 = BgL_res2305z00_4089; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1218z00_4087), BgL_arg1672z00_4088); } 
BgL_new1219z00_4086 = BgL_new1218z00_4087; } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1219z00_4086))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_var1107z00_3665)),BUNSPEC); 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1219z00_4086))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1108z00_3666)),BUNSPEC); 
return BgL_new1219z00_4086;} } 
BGL_FUNCTION_END;
}



/* &lambda1685 */
obj_t BGl_z62lambda1685z62zz__evaluate_typesz00(obj_t BgL_envz00_3667, obj_t BgL_oz00_3668, obj_t BgL_vz00_3669)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3668)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3669)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1684 */
BgL_ev_exprz00_bglt BGl_z62lambda1684z62zz__evaluate_typesz00(obj_t BgL_envz00_3670, obj_t BgL_oz00_3671)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3671)))->BgL_bodyz00);} 
BGL_FUNCTION_END;
}



/* &lambda1680 */
obj_t BGl_z62lambda1680z62zz__evaluate_typesz00(obj_t BgL_envz00_3672, obj_t BgL_oz00_3673, obj_t BgL_vz00_3674)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3673)))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3674)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1679 */
BgL_ev_varz00_bglt BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t BgL_envz00_3675, obj_t BgL_oz00_3676)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3676)))->BgL_varz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1665> */
obj_t BGl_z62zc3anonymousza31665ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3677, obj_t BgL_new1105z00_3678)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 82 */
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5173;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5174;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_classz00_4097;
BgL_classz00_4097 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL__ortest_1280z00_4098;
BgL__ortest_1280z00_4098 = 
BGL_CLASS_NIL(BgL_classz00_4097); 
if(
CBOOL(BgL__ortest_1280z00_4098))
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5174 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4098)
; }  else 
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5174 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4097))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1105z00_3678))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5174),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1105z00_3678))))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1105z00_3678))))->BgL_namez00)=((obj_t)BGl_symbol2708z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1105z00_3678))))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5173 = 
((BgL_ev_defglobalz00_bglt)BgL_new1105z00_3678); 
return 
((obj_t)BgL_auxz00_5173);} } 
BGL_FUNCTION_END;
}



/* &lambda1663 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1663z62zz__evaluate_typesz00(obj_t BgL_envz00_3679)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1104z00_4099;
BgL_new1104z00_4099 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1664z00_4100;
{ /* Eval/evaluate_types.scm 82 */
long BgL_res2304z00_4101;
BgL_res2304z00_4101 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg1664z00_4100 = BgL_res2304z00_4101; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1104z00_4099), BgL_arg1664z00_4100); } 
return BgL_new1104z00_4099;} } 
BGL_FUNCTION_END;
}



/* &lambda1661 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1661z62zz__evaluate_typesz00(obj_t BgL_envz00_3680, obj_t BgL_e1100z00_3681, obj_t BgL_loc1101z00_3682, obj_t BgL_name1102z00_3683, obj_t BgL_mod1103z00_3684)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1217z00_4104;
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1216z00_4105;
BgL_new1216z00_4105 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1662z00_4106;
{ /* Eval/evaluate_types.scm 82 */
long BgL_res2303z00_4107;
BgL_res2303z00_4107 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg1662z00_4106 = BgL_res2303z00_4107; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1216z00_4105), BgL_arg1662z00_4106); } 
BgL_new1217z00_4104 = BgL_new1216z00_4105; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1217z00_4104)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1100z00_3681)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1217z00_4104)))->BgL_locz00)=((obj_t)BgL_loc1101z00_3682),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1217z00_4104)))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1102z00_3683)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1217z00_4104)))->BgL_modz00)=((obj_t)BgL_mod1103z00_3684),BUNSPEC); 
return BgL_new1217z00_4104;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1627> */
obj_t BGl_z62zc3anonymousza31627ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3685, obj_t BgL_new1098z00_3686)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_5213;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5214;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_classz00_4109;
BgL_classz00_4109 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL__ortest_1280z00_4110;
BgL__ortest_1280z00_4110 = 
BGL_CLASS_NIL(BgL_classz00_4109); 
if(
CBOOL(BgL__ortest_1280z00_4110))
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5214 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4110)
; }  else 
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5214 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4109))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_new1098z00_3686))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5214),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1098z00_3686)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1098z00_3686)))->BgL_namez00)=((obj_t)BGl_symbol2708z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1098z00_3686)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5213 = 
((BgL_ev_setglobalz00_bglt)BgL_new1098z00_3686); 
return 
((obj_t)BgL_auxz00_5213);} } 
BGL_FUNCTION_END;
}



/* &lambda1625 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1625z62zz__evaluate_typesz00(obj_t BgL_envz00_3687)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1097z00_4111;
BgL_new1097z00_4111 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1626z00_4112;
{ /* Eval/evaluate_types.scm 78 */
long BgL_res2302z00_4113;
BgL_res2302z00_4113 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg1626z00_4112 = BgL_res2302z00_4113; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1097z00_4111), BgL_arg1626z00_4112); } 
return BgL_new1097z00_4111;} } 
BGL_FUNCTION_END;
}



/* &lambda1623 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1623z62zz__evaluate_typesz00(obj_t BgL_envz00_3688, obj_t BgL_e1093z00_3689, obj_t BgL_loc1094z00_3690, obj_t BgL_name1095z00_3691, obj_t BgL_mod1096z00_3692)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1215z00_4116;
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1214z00_4117;
BgL_new1214z00_4117 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1624z00_4118;
{ /* Eval/evaluate_types.scm 78 */
long BgL_res2301z00_4119;
BgL_res2301z00_4119 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg1624z00_4118 = BgL_res2301z00_4119; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1214z00_4117), BgL_arg1624z00_4118); } 
BgL_new1215z00_4116 = BgL_new1214z00_4117; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1215z00_4116)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1093z00_3689)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1215z00_4116))->BgL_locz00)=((obj_t)BgL_loc1094z00_3690),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1215z00_4116))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1095z00_3691)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1215z00_4116))->BgL_modz00)=((obj_t)BgL_mod1096z00_3692),BUNSPEC); 
return BgL_new1215z00_4116;} } 
BGL_FUNCTION_END;
}



/* &lambda1653 */
obj_t BGl_z62lambda1653z62zz__evaluate_typesz00(obj_t BgL_envz00_3693, obj_t BgL_oz00_3694, obj_t BgL_vz00_3695)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3694)))->BgL_modz00)=((obj_t)BgL_vz00_3695),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1652 */
obj_t BGl_z62lambda1652z62zz__evaluate_typesz00(obj_t BgL_envz00_3696, obj_t BgL_oz00_3697)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3697)))->BgL_modz00);} 
BGL_FUNCTION_END;
}



/* &lambda1648 */
obj_t BGl_z62lambda1648z62zz__evaluate_typesz00(obj_t BgL_envz00_3698, obj_t BgL_oz00_3699, obj_t BgL_vz00_3700)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3699)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3700)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1647 */
obj_t BGl_z62lambda1647z62zz__evaluate_typesz00(obj_t BgL_envz00_3701, obj_t BgL_oz00_3702)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3702)))->BgL_namez00);} 
BGL_FUNCTION_END;
}



/* &lambda1641 */
obj_t BGl_z62lambda1641z62zz__evaluate_typesz00(obj_t BgL_envz00_3703, obj_t BgL_oz00_3704, obj_t BgL_vz00_3705)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3704)))->BgL_locz00)=((obj_t)BgL_vz00_3705),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1640 */
obj_t BGl_z62lambda1640z62zz__evaluate_typesz00(obj_t BgL_envz00_3706, obj_t BgL_oz00_3707)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3707)))->BgL_locz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1609> */
obj_t BGl_z62zc3anonymousza31609ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3708, obj_t BgL_new1091z00_3709)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 76 */
{ 
BgL_ev_setlocalz00_bglt BgL_auxz00_5260;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5261;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4128;
BgL_classz00_4128 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1280z00_4129;
BgL__ortest_1280z00_4129 = 
BGL_CLASS_NIL(BgL_classz00_4128); 
if(
CBOOL(BgL__ortest_1280z00_4129))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5261 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4129)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5261 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4128))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_new1091z00_3709))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5261),BUNSPEC); } 
{ 
BgL_ev_varz00_bglt BgL_auxz00_5271;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4130;
BgL_classz00_4130 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1280z00_4131;
BgL__ortest_1280z00_4131 = 
BGL_CLASS_NIL(BgL_classz00_4130); 
if(
CBOOL(BgL__ortest_1280z00_4131))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5271 = 
((BgL_ev_varz00_bglt)BgL__ortest_1280z00_4131)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5271 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4130))
; } } } 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_new1091z00_3709)))->BgL_vz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5271),BUNSPEC); } 
BgL_auxz00_5260 = 
((BgL_ev_setlocalz00_bglt)BgL_new1091z00_3709); 
return 
((obj_t)BgL_auxz00_5260);} } 
BGL_FUNCTION_END;
}



/* &lambda1607 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1607z62zz__evaluate_typesz00(obj_t BgL_envz00_3710)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1090z00_4132;
BgL_new1090z00_4132 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1608z00_4133;
{ /* Eval/evaluate_types.scm 76 */
long BgL_res2300z00_4134;
BgL_res2300z00_4134 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg1608z00_4133 = BgL_res2300z00_4134; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_4132), BgL_arg1608z00_4133); } 
return BgL_new1090z00_4132;} } 
BGL_FUNCTION_END;
}



/* &lambda1605 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1605z62zz__evaluate_typesz00(obj_t BgL_envz00_3711, obj_t BgL_e1088z00_3712, obj_t BgL_v1089z00_3713)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1213z00_4137;
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1212z00_4138;
BgL_new1212z00_4138 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1606z00_4139;
{ /* Eval/evaluate_types.scm 76 */
long BgL_res2299z00_4140;
BgL_res2299z00_4140 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg1606z00_4139 = BgL_res2299z00_4140; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1212z00_4138), BgL_arg1606z00_4139); } 
BgL_new1213z00_4137 = BgL_new1212z00_4138; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1213z00_4137)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1088z00_3712)),BUNSPEC); 
((((BgL_ev_setlocalz00_bglt)COBJECT(BgL_new1213z00_4137))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_v1089z00_3713)),BUNSPEC); 
return BgL_new1213z00_4137;} } 
BGL_FUNCTION_END;
}



/* &lambda1615 */
obj_t BGl_z62lambda1615z62zz__evaluate_typesz00(obj_t BgL_envz00_3714, obj_t BgL_oz00_3715, obj_t BgL_vz00_3716)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 76 */
return 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3715)))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3716)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1614 */
BgL_ev_varz00_bglt BGl_z62lambda1614z62zz__evaluate_typesz00(obj_t BgL_envz00_3717, obj_t BgL_oz00_3718)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 76 */
return 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3718)))->BgL_vz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1599> */
obj_t BGl_z62zc3anonymousza31599ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3719, obj_t BgL_new1086z00_3720)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 75 */
{ 
BgL_ev_trapz00_bglt BgL_auxz00_5300;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5301;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_classz00_4145;
BgL_classz00_4145 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL__ortest_1280z00_4146;
BgL__ortest_1280z00_4146 = 
BGL_CLASS_NIL(BgL_classz00_4145); 
if(
CBOOL(BgL__ortest_1280z00_4146))
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5301 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4146)
; }  else 
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5301 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4145))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_new1086z00_3720))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5301),BUNSPEC); } 
BgL_auxz00_5300 = 
((BgL_ev_trapz00_bglt)BgL_new1086z00_3720); 
return 
((obj_t)BgL_auxz00_5300);} } 
BGL_FUNCTION_END;
}



/* &lambda1597 */
BgL_ev_trapz00_bglt BGl_z62lambda1597z62zz__evaluate_typesz00(obj_t BgL_envz00_3721)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1085z00_4147;
BgL_new1085z00_4147 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1598z00_4148;
{ /* Eval/evaluate_types.scm 75 */
long BgL_res2298z00_4149;
BgL_res2298z00_4149 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg1598z00_4148 = BgL_res2298z00_4149; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1085z00_4147), BgL_arg1598z00_4148); } 
return BgL_new1085z00_4147;} } 
BGL_FUNCTION_END;
}



/* &lambda1595 */
BgL_ev_trapz00_bglt BGl_z62lambda1595z62zz__evaluate_typesz00(obj_t BgL_envz00_3722, obj_t BgL_e1084z00_3723)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1211z00_4151;
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1210z00_4152;
BgL_new1210z00_4152 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1596z00_4153;
{ /* Eval/evaluate_types.scm 75 */
long BgL_res2297z00_4154;
BgL_res2297z00_4154 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg1596z00_4153 = BgL_res2297z00_4154; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1210z00_4152), BgL_arg1596z00_4153); } 
BgL_new1211z00_4151 = BgL_new1210z00_4152; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1211z00_4151)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1084z00_3723)),BUNSPEC); 
return BgL_new1211z00_4151;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1581> */
obj_t BGl_z62zc3anonymousza31581ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3724, obj_t BgL_new1082z00_3725)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 73 */
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5324;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5325;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_classz00_4156;
BgL_classz00_4156 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL__ortest_1280z00_4157;
BgL__ortest_1280z00_4157 = 
BGL_CLASS_NIL(BgL_classz00_4156); 
if(
CBOOL(BgL__ortest_1280z00_4157))
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5325 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4157)
; }  else 
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5325 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4156))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1082z00_3725)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5325),BUNSPEC); } 
BgL_auxz00_5324 = 
((BgL_ev_hookz00_bglt)BgL_new1082z00_3725); 
return 
((obj_t)BgL_auxz00_5324);} } 
BGL_FUNCTION_END;
}



/* &lambda1579 */
BgL_ev_hookz00_bglt BGl_z62lambda1579z62zz__evaluate_typesz00(obj_t BgL_envz00_3726)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1081z00_4158;
BgL_new1081z00_4158 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1580z00_4159;
{ /* Eval/evaluate_types.scm 73 */
long BgL_res2296z00_4160;
BgL_res2296z00_4160 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BgL_arg1580z00_4159 = BgL_res2296z00_4160; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1081z00_4158), BgL_arg1580z00_4159); } 
return BgL_new1081z00_4158;} } 
BGL_FUNCTION_END;
}



/* &lambda1577 */
BgL_ev_hookz00_bglt BGl_z62lambda1577z62zz__evaluate_typesz00(obj_t BgL_envz00_3727, obj_t BgL_e1080z00_3728)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1209z00_4162;
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1208z00_4163;
BgL_new1208z00_4163 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1578z00_4164;
{ /* Eval/evaluate_types.scm 73 */
long BgL_res2295z00_4165;
BgL_res2295z00_4165 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BgL_arg1578z00_4164 = BgL_res2295z00_4165; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1208z00_4163), BgL_arg1578z00_4164); } 
BgL_new1209z00_4162 = BgL_new1208z00_4163; } 
((((BgL_ev_hookz00_bglt)COBJECT(BgL_new1209z00_4162))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1080z00_3728)),BUNSPEC); 
return BgL_new1209z00_4162;} } 
BGL_FUNCTION_END;
}



/* &lambda1588 */
obj_t BGl_z62lambda1588z62zz__evaluate_typesz00(obj_t BgL_envz00_3729, obj_t BgL_oz00_3730, obj_t BgL_vz00_3731)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 73 */
return 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3730)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3731)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1587 */
BgL_ev_exprz00_bglt BGl_z62lambda1587z62zz__evaluate_typesz00(obj_t BgL_envz00_3732, obj_t BgL_oz00_3733)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 73 */
return 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3733)))->BgL_ez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1557> */
obj_t BGl_z62zc3anonymousza31557ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3734, obj_t BgL_new1078z00_3735)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
{ 
BgL_ev_prog2z00_bglt BgL_auxz00_5351;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5352;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4170;
BgL_classz00_4170 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1280z00_4171;
BgL__ortest_1280z00_4171 = 
BGL_CLASS_NIL(BgL_classz00_4170); 
if(
CBOOL(BgL__ortest_1280z00_4171))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5352 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4171)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5352 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4170))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1078z00_3735)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5352),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5361;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4172;
BgL_classz00_4172 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1280z00_4173;
BgL__ortest_1280z00_4173 = 
BGL_CLASS_NIL(BgL_classz00_4172); 
if(
CBOOL(BgL__ortest_1280z00_4173))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5361 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4173)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5361 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4172))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1078z00_3735)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5361),BUNSPEC); } 
BgL_auxz00_5351 = 
((BgL_ev_prog2z00_bglt)BgL_new1078z00_3735); 
return 
((obj_t)BgL_auxz00_5351);} } 
BGL_FUNCTION_END;
}



/* &lambda1555 */
BgL_ev_prog2z00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t BgL_envz00_3736)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1077z00_4174;
BgL_new1077z00_4174 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1556z00_4175;
{ /* Eval/evaluate_types.scm 70 */
long BgL_res2294z00_4176;
BgL_res2294z00_4176 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1556z00_4175 = BgL_res2294z00_4176; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_4174), BgL_arg1556z00_4175); } 
return BgL_new1077z00_4174;} } 
BGL_FUNCTION_END;
}



/* &lambda1553 */
BgL_ev_prog2z00_bglt BGl_z62lambda1553z62zz__evaluate_typesz00(obj_t BgL_envz00_3737, obj_t BgL_e11075z00_3738, obj_t BgL_e21076z00_3739)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1207z00_4179;
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1206z00_4180;
BgL_new1206z00_4180 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1554z00_4181;
{ /* Eval/evaluate_types.scm 70 */
long BgL_res2293z00_4182;
BgL_res2293z00_4182 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1554z00_4181 = BgL_res2293z00_4182; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1206z00_4180), BgL_arg1554z00_4181); } 
BgL_new1207z00_4179 = BgL_new1206z00_4180; } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1207z00_4179))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e11075z00_3738)),BUNSPEC); 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1207z00_4179))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e21076z00_3739)),BUNSPEC); 
return BgL_new1207z00_4179;} } 
BGL_FUNCTION_END;
}



/* &lambda1568 */
obj_t BGl_z62lambda1568z62zz__evaluate_typesz00(obj_t BgL_envz00_3740, obj_t BgL_oz00_3741, obj_t BgL_vz00_3742)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3741)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3742)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1567 */
BgL_ev_exprz00_bglt BGl_z62lambda1567z62zz__evaluate_typesz00(obj_t BgL_envz00_3743, obj_t BgL_oz00_3744)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3744)))->BgL_e2z00);} 
BGL_FUNCTION_END;
}



/* &lambda1563 */
obj_t BGl_z62lambda1563z62zz__evaluate_typesz00(obj_t BgL_envz00_3745, obj_t BgL_oz00_3746, obj_t BgL_vz00_3747)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3746)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3747)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1562 */
BgL_ev_exprz00_bglt BGl_z62lambda1562z62zz__evaluate_typesz00(obj_t BgL_envz00_3748, obj_t BgL_oz00_3749)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3749)))->BgL_e1z00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1547> */
obj_t BGl_z62zc3anonymousza31547ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3750, obj_t BgL_new1073z00_3751)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 69 */
{ 
BgL_ev_andz00_bglt BgL_auxz00_5394;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_new1073z00_3751))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5394 = 
((BgL_ev_andz00_bglt)BgL_new1073z00_3751); 
return 
((obj_t)BgL_auxz00_5394);} } 
BGL_FUNCTION_END;
}



/* &lambda1545 */
BgL_ev_andz00_bglt BGl_z62lambda1545z62zz__evaluate_typesz00(obj_t BgL_envz00_3752)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1072z00_4190;
BgL_new1072z00_4190 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1546z00_4191;
{ /* Eval/evaluate_types.scm 69 */
long BgL_res2292z00_4192;
BgL_res2292z00_4192 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg1546z00_4191 = BgL_res2292z00_4192; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1072z00_4190), BgL_arg1546z00_4191); } 
return BgL_new1072z00_4190;} } 
BGL_FUNCTION_END;
}



/* &lambda1543 */
BgL_ev_andz00_bglt BGl_z62lambda1543z62zz__evaluate_typesz00(obj_t BgL_envz00_3753, obj_t BgL_args1071z00_3754)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1205z00_4193;
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1204z00_4194;
BgL_new1204z00_4194 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1544z00_4195;
{ /* Eval/evaluate_types.scm 69 */
long BgL_res2291z00_4196;
BgL_res2291z00_4196 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg1544z00_4195 = BgL_res2291z00_4196; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1204z00_4194), BgL_arg1544z00_4195); } 
BgL_new1205z00_4193 = BgL_new1204z00_4194; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1205z00_4193)))->BgL_argsz00)=((obj_t)BgL_args1071z00_3754),BUNSPEC); 
return BgL_new1205z00_4193;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1534> */
obj_t BGl_z62zc3anonymousza31534ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3755, obj_t BgL_new1069z00_3756)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 68 */
{ 
BgL_ev_orz00_bglt BgL_auxz00_5410;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_new1069z00_3756))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5410 = 
((BgL_ev_orz00_bglt)BgL_new1069z00_3756); 
return 
((obj_t)BgL_auxz00_5410);} } 
BGL_FUNCTION_END;
}



/* &lambda1531 */
BgL_ev_orz00_bglt BGl_z62lambda1531z62zz__evaluate_typesz00(obj_t BgL_envz00_3757)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1068z00_4198;
BgL_new1068z00_4198 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1533z00_4199;
{ /* Eval/evaluate_types.scm 68 */
long BgL_res2290z00_4200;
BgL_res2290z00_4200 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg1533z00_4199 = BgL_res2290z00_4200; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1068z00_4198), BgL_arg1533z00_4199); } 
return BgL_new1068z00_4198;} } 
BGL_FUNCTION_END;
}



/* &lambda1529 */
BgL_ev_orz00_bglt BGl_z62lambda1529z62zz__evaluate_typesz00(obj_t BgL_envz00_3758, obj_t BgL_args1067z00_3759)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1203z00_4201;
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1202z00_4202;
BgL_new1202z00_4202 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1530z00_4203;
{ /* Eval/evaluate_types.scm 68 */
long BgL_res2289z00_4204;
BgL_res2289z00_4204 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg1530z00_4203 = BgL_res2289z00_4204; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1202z00_4202), BgL_arg1530z00_4203); } 
BgL_new1203z00_4201 = BgL_new1202z00_4202; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1203z00_4201)))->BgL_argsz00)=((obj_t)BgL_args1067z00_3759),BUNSPEC); 
return BgL_new1203z00_4201;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1515> */
obj_t BGl_z62zc3anonymousza31515ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3760, obj_t BgL_new1065z00_3761)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 66 */
{ 
BgL_ev_listz00_bglt BgL_auxz00_5426;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1065z00_3761)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5426 = 
((BgL_ev_listz00_bglt)BgL_new1065z00_3761); 
return 
((obj_t)BgL_auxz00_5426);} } 
BGL_FUNCTION_END;
}



/* &lambda1513 */
BgL_ev_listz00_bglt BGl_z62lambda1513z62zz__evaluate_typesz00(obj_t BgL_envz00_3762)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1064z00_4206;
BgL_new1064z00_4206 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1514z00_4207;
{ /* Eval/evaluate_types.scm 66 */
long BgL_res2288z00_4208;
BgL_res2288z00_4208 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BgL_arg1514z00_4207 = BgL_res2288z00_4208; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_4206), BgL_arg1514z00_4207); } 
return BgL_new1064z00_4206;} } 
BGL_FUNCTION_END;
}



/* &lambda1511 */
BgL_ev_listz00_bglt BGl_z62lambda1511z62zz__evaluate_typesz00(obj_t BgL_envz00_3763, obj_t BgL_args1063z00_3764)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1201z00_4209;
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1200z00_4210;
BgL_new1200z00_4210 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1512z00_4211;
{ /* Eval/evaluate_types.scm 66 */
long BgL_res2287z00_4212;
BgL_res2287z00_4212 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BgL_arg1512z00_4211 = BgL_res2287z00_4212; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1200z00_4210), BgL_arg1512z00_4211); } 
BgL_new1201z00_4209 = BgL_new1200z00_4210; } 
((((BgL_ev_listz00_bglt)COBJECT(BgL_new1201z00_4209))->BgL_argsz00)=((obj_t)BgL_args1063z00_3764),BUNSPEC); 
return BgL_new1201z00_4209;} } 
BGL_FUNCTION_END;
}



/* &lambda1521 */
obj_t BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t BgL_envz00_3765, obj_t BgL_oz00_3766, obj_t BgL_vz00_3767)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 66 */
return 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3766)))->BgL_argsz00)=((obj_t)BgL_vz00_3767),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1520 */
obj_t BGl_z62lambda1520z62zz__evaluate_typesz00(obj_t BgL_envz00_3768, obj_t BgL_oz00_3769)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 66 */
return 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3769)))->BgL_argsz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1488> */
obj_t BGl_z62zc3anonymousza31488ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3770, obj_t BgL_new1061z00_3771)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5444;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5445;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4216;
BgL_classz00_4216 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1280z00_4217;
BgL__ortest_1280z00_4217 = 
BGL_CLASS_NIL(BgL_classz00_4216); 
if(
CBOOL(BgL__ortest_1280z00_4217))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5445 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4217)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5445 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4216))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1061z00_3771)))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5445),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5454;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4218;
BgL_classz00_4218 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1280z00_4219;
BgL__ortest_1280z00_4219 = 
BGL_CLASS_NIL(BgL_classz00_4218); 
if(
CBOOL(BgL__ortest_1280z00_4219))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5454 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4219)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5454 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4218))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1061z00_3771)))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5454),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5463;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4220;
BgL_classz00_4220 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1280z00_4221;
BgL__ortest_1280z00_4221 = 
BGL_CLASS_NIL(BgL_classz00_4220); 
if(
CBOOL(BgL__ortest_1280z00_4221))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5463 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1280z00_4221)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5463 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4220))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1061z00_3771)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5463),BUNSPEC); } 
BgL_auxz00_5444 = 
((BgL_ev_ifz00_bglt)BgL_new1061z00_3771); 
return 
((obj_t)BgL_auxz00_5444);} } 
BGL_FUNCTION_END;
}



/* &lambda1486 */
BgL_ev_ifz00_bglt BGl_z62lambda1486z62zz__evaluate_typesz00(obj_t BgL_envz00_3772)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1060z00_4222;
BgL_new1060z00_4222 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1487z00_4223;
{ /* Eval/evaluate_types.scm 62 */
long BgL_res2286z00_4224;
BgL_res2286z00_4224 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg1487z00_4223 = BgL_res2286z00_4224; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1060z00_4222), BgL_arg1487z00_4223); } 
return BgL_new1060z00_4222;} } 
BGL_FUNCTION_END;
}



/* &lambda1484 */
BgL_ev_ifz00_bglt BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t BgL_envz00_3773, obj_t BgL_p1057z00_3774, obj_t BgL_t1058z00_3775, obj_t BgL_e1059z00_3776)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1199z00_4228;
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1198z00_4229;
BgL_new1198z00_4229 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1485z00_4230;
{ /* Eval/evaluate_types.scm 62 */
long BgL_res2285z00_4231;
BgL_res2285z00_4231 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg1485z00_4230 = BgL_res2285z00_4231; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1198z00_4229), BgL_arg1485z00_4230); } 
BgL_new1199z00_4228 = BgL_new1198z00_4229; } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1199z00_4228))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_p1057z00_3774)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1199z00_4228))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_t1058z00_3775)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1199z00_4228))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1059z00_3776)),BUNSPEC); 
return BgL_new1199z00_4228;} } 
BGL_FUNCTION_END;
}



/* &lambda1505 */
obj_t BGl_z62lambda1505z62zz__evaluate_typesz00(obj_t BgL_envz00_3777, obj_t BgL_oz00_3778, obj_t BgL_vz00_3779)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3778)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3779)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1504 */
BgL_ev_exprz00_bglt BGl_z62lambda1504z62zz__evaluate_typesz00(obj_t BgL_envz00_3780, obj_t BgL_oz00_3781)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3781)))->BgL_ez00);} 
BGL_FUNCTION_END;
}



/* &lambda1499 */
obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t BgL_envz00_3782, obj_t BgL_oz00_3783, obj_t BgL_vz00_3784)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3783)))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3784)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1498 */
BgL_ev_exprz00_bglt BGl_z62lambda1498z62zz__evaluate_typesz00(obj_t BgL_envz00_3785, obj_t BgL_oz00_3786)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3786)))->BgL_tz00);} 
BGL_FUNCTION_END;
}



/* &lambda1493 */
obj_t BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t BgL_envz00_3787, obj_t BgL_oz00_3788, obj_t BgL_vz00_3789)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3788)))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3789)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1492 */
BgL_ev_exprz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t BgL_envz00_3790, obj_t BgL_oz00_3791)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3791)))->BgL_pz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1472> */
obj_t BGl_z62zc3anonymousza31472ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3792, obj_t BgL_new1055z00_3793)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 60 */
{ 
BgL_ev_littz00_bglt BgL_auxz00_5503;
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_new1055z00_3793)))->BgL_valuez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5503 = 
((BgL_ev_littz00_bglt)BgL_new1055z00_3793); 
return 
((obj_t)BgL_auxz00_5503);} } 
BGL_FUNCTION_END;
}



/* &lambda1470 */
BgL_ev_littz00_bglt BGl_z62lambda1470z62zz__evaluate_typesz00(obj_t BgL_envz00_3794)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1054z00_4242;
BgL_new1054z00_4242 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1471z00_4243;
{ /* Eval/evaluate_types.scm 60 */
long BgL_res2284z00_4244;
BgL_res2284z00_4244 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1471z00_4243 = BgL_res2284z00_4244; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1054z00_4242), BgL_arg1471z00_4243); } 
return BgL_new1054z00_4242;} } 
BGL_FUNCTION_END;
}



/* &lambda1468 */
BgL_ev_littz00_bglt BGl_z62lambda1468z62zz__evaluate_typesz00(obj_t BgL_envz00_3795, obj_t BgL_value1053z00_3796)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1197z00_4245;
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1196z00_4246;
BgL_new1196z00_4246 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1469z00_4247;
{ /* Eval/evaluate_types.scm 60 */
long BgL_res2283z00_4248;
BgL_res2283z00_4248 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1469z00_4247 = BgL_res2283z00_4248; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1196z00_4246), BgL_arg1469z00_4247); } 
BgL_new1197z00_4245 = BgL_new1196z00_4246; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1197z00_4245))->BgL_valuez00)=((obj_t)BgL_value1053z00_3796),BUNSPEC); 
return BgL_new1197z00_4245;} } 
BGL_FUNCTION_END;
}



/* &lambda1477 */
obj_t BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t BgL_envz00_3797, obj_t BgL_oz00_3798, obj_t BgL_vz00_3799)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 60 */
return 
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3798)))->BgL_valuez00)=((obj_t)BgL_vz00_3799),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1476 */
obj_t BGl_z62lambda1476z62zz__evaluate_typesz00(obj_t BgL_envz00_3800, obj_t BgL_oz00_3801)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 60 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3801)))->BgL_valuez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1446> */
obj_t BGl_z62zc3anonymousza31446ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3802, obj_t BgL_new1051z00_3803)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
{ 
BgL_ev_globalz00_bglt BgL_auxz00_5521;
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1051z00_3803)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1051z00_3803)))->BgL_namez00)=((obj_t)BGl_symbol2708z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1051z00_3803)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5521 = 
((BgL_ev_globalz00_bglt)BgL_new1051z00_3803); 
return 
((obj_t)BgL_auxz00_5521);} } 
BGL_FUNCTION_END;
}



/* &lambda1444 */
BgL_ev_globalz00_bglt BGl_z62lambda1444z62zz__evaluate_typesz00(obj_t BgL_envz00_3804)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1050z00_4252;
BgL_new1050z00_4252 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1445z00_4253;
{ /* Eval/evaluate_types.scm 55 */
long BgL_res2282z00_4254;
BgL_res2282z00_4254 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1445z00_4253 = BgL_res2282z00_4254; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1050z00_4252), BgL_arg1445z00_4253); } 
return BgL_new1050z00_4252;} } 
BGL_FUNCTION_END;
}



/* &lambda1442 */
BgL_ev_globalz00_bglt BGl_z62lambda1442z62zz__evaluate_typesz00(obj_t BgL_envz00_3805, obj_t BgL_loc1047z00_3806, obj_t BgL_name1048z00_3807, obj_t BgL_mod1049z00_3808)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1195z00_4256;
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1194z00_4257;
BgL_new1194z00_4257 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1443z00_4258;
{ /* Eval/evaluate_types.scm 55 */
long BgL_res2281z00_4259;
BgL_res2281z00_4259 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1443z00_4258 = BgL_res2281z00_4259; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1194z00_4257), BgL_arg1443z00_4258); } 
BgL_new1195z00_4256 = BgL_new1194z00_4257; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1195z00_4256))->BgL_locz00)=((obj_t)BgL_loc1047z00_3806),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1195z00_4256))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1048z00_3807)),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1195z00_4256))->BgL_modz00)=((obj_t)BgL_mod1049z00_3808),BUNSPEC); 
return BgL_new1195z00_4256;} } 
BGL_FUNCTION_END;
}



/* &lambda1462 */
obj_t BGl_z62lambda1462z62zz__evaluate_typesz00(obj_t BgL_envz00_3809, obj_t BgL_oz00_3810, obj_t BgL_vz00_3811)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3810)))->BgL_modz00)=((obj_t)BgL_vz00_3811),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1461 */
obj_t BGl_z62lambda1461z62zz__evaluate_typesz00(obj_t BgL_envz00_3812, obj_t BgL_oz00_3813)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3813)))->BgL_modz00);} 
BGL_FUNCTION_END;
}



/* &lambda1456 */
obj_t BGl_z62lambda1456z62zz__evaluate_typesz00(obj_t BgL_envz00_3814, obj_t BgL_oz00_3815, obj_t BgL_vz00_3816)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3815)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3816)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1455 */
obj_t BGl_z62lambda1455z62zz__evaluate_typesz00(obj_t BgL_envz00_3817, obj_t BgL_oz00_3818)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3818)))->BgL_namez00);} 
BGL_FUNCTION_END;
}



/* &lambda1451 */
obj_t BGl_z62lambda1451z62zz__evaluate_typesz00(obj_t BgL_envz00_3819, obj_t BgL_oz00_3820, obj_t BgL_vz00_3821)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3820)))->BgL_locz00)=((obj_t)BgL_vz00_3821),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1450 */
obj_t BGl_z62lambda1450z62zz__evaluate_typesz00(obj_t BgL_envz00_3822, obj_t BgL_oz00_3823)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3823)))->BgL_locz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1414> */
obj_t BGl_z62zc3anonymousza31414ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3824, obj_t BgL_new1045z00_3825)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
{ 
BgL_ev_varz00_bglt BgL_auxz00_5555;
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1045z00_3825)))->BgL_namez00)=((obj_t)BGl_symbol2708z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1045z00_3825)))->BgL_effz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1045z00_3825)))->BgL_typez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5555 = 
((BgL_ev_varz00_bglt)BgL_new1045z00_3825); 
return 
((obj_t)BgL_auxz00_5555);} } 
BGL_FUNCTION_END;
}



/* &lambda1411 */
BgL_ev_varz00_bglt BGl_z62lambda1411z62zz__evaluate_typesz00(obj_t BgL_envz00_3826)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1044z00_4268;
BgL_new1044z00_4268 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1413z00_4269;
{ /* Eval/evaluate_types.scm 51 */
long BgL_res2280z00_4270;
BgL_res2280z00_4270 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg1413z00_4269 = BgL_res2280z00_4270; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1044z00_4268), BgL_arg1413z00_4269); } 
return BgL_new1044z00_4268;} } 
BGL_FUNCTION_END;
}



/* &lambda1409 */
BgL_ev_varz00_bglt BGl_z62lambda1409z62zz__evaluate_typesz00(obj_t BgL_envz00_3827, obj_t BgL_name1041z00_3828, obj_t BgL_eff1042z00_3829, obj_t BgL_type1043z00_3830)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1193z00_4272;
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1192z00_4273;
BgL_new1192z00_4273 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1410z00_4274;
{ /* Eval/evaluate_types.scm 51 */
long BgL_res2279z00_4275;
BgL_res2279z00_4275 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg1410z00_4274 = BgL_res2279z00_4275; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1192z00_4273), BgL_arg1410z00_4274); } 
BgL_new1193z00_4272 = BgL_new1192z00_4273; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1193z00_4272))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1041z00_3828)),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1193z00_4272))->BgL_effz00)=((obj_t)BgL_eff1042z00_3829),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1193z00_4272))->BgL_typez00)=((obj_t)BgL_type1043z00_3830),BUNSPEC); 
return BgL_new1193z00_4272;} } 
BGL_FUNCTION_END;
}



/* &lambda1434 */
obj_t BGl_z62lambda1434z62zz__evaluate_typesz00(obj_t BgL_envz00_3831, obj_t BgL_oz00_3832, obj_t BgL_vz00_3833)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3832)))->BgL_typez00)=((obj_t)BgL_vz00_3833),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1433 */
obj_t BGl_z62lambda1433z62zz__evaluate_typesz00(obj_t BgL_envz00_3834, obj_t BgL_oz00_3835)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3835)))->BgL_typez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1429> */
obj_t BGl_z62zc3anonymousza31429ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3836)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1428 */
obj_t BGl_z62lambda1428z62zz__evaluate_typesz00(obj_t BgL_envz00_3837, obj_t BgL_oz00_3838, obj_t BgL_vz00_3839)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3838)))->BgL_effz00)=((obj_t)BgL_vz00_3839),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1427 */
obj_t BGl_z62lambda1427z62zz__evaluate_typesz00(obj_t BgL_envz00_3840, obj_t BgL_oz00_3841)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3841)))->BgL_effz00);} 
BGL_FUNCTION_END;
}



/* &lambda1420 */
obj_t BGl_z62lambda1420z62zz__evaluate_typesz00(obj_t BgL_envz00_3842, obj_t BgL_oz00_3843, obj_t BgL_vz00_3844)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3843)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3844)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1419 */
obj_t BGl_z62lambda1419z62zz__evaluate_typesz00(obj_t BgL_envz00_3845, obj_t BgL_oz00_3846)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3846)))->BgL_namez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1403> */
obj_t BGl_z62zc3anonymousza31403ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3847, obj_t BgL_new1039z00_3848)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 49 */
return 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_new1039z00_3848));} 
BGL_FUNCTION_END;
}



/* &lambda1401 */
BgL_ev_exprz00_bglt BGl_z62lambda1401z62zz__evaluate_typesz00(obj_t BgL_envz00_3849)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1038z00_4284;
BgL_new1038z00_4284 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1402z00_4285;
{ /* Eval/evaluate_types.scm 49 */
long BgL_res2278z00_4286;
BgL_res2278z00_4286 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BgL_arg1402z00_4285 = BgL_res2278z00_4286; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1038z00_4284), BgL_arg1402z00_4285); } 
return BgL_new1038z00_4284;} } 
BGL_FUNCTION_END;
}



/* &lambda1399 */
BgL_ev_exprz00_bglt BGl_z62lambda1399z62zz__evaluate_typesz00(obj_t BgL_envz00_3850)
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1191z00_4287;
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1190z00_4288;
BgL_new1190z00_4288 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1400z00_4289;
{ /* Eval/evaluate_types.scm 49 */
long BgL_res2277z00_4290;
BgL_res2277z00_4290 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BgL_arg1400z00_4289 = BgL_res2277z00_4290; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1190z00_4288), BgL_arg1400z00_4289); } 
BgL_new1191z00_4287 = BgL_new1190z00_4288; } 
return BgL_new1191z00_4287;} } 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Eval/evaluate_types.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046086), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)430898742), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)180158922), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135276775), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218210), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267792), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519932), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251314740), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936801), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439353001), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453939141), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)1047446), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967693), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)454272164), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)445908113), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)434692624), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155843), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198620800), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309430), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519430), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460262918), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-400105135), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614678), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927882), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151370), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)127905250), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540577), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00)); 
return 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988580), 
BSTRING_TO_STRING(BGl_string2385z00zz__evaluate_typesz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
