/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate.scm -indent -o objs/obj_u/Eval/evaluate.c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
	static BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern BgL_ev_exprz00_bglt
		BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
	static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
	extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	static obj_t BGl_objectzd2initzd2zz__evaluatez00();
	extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
	static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_z62zc3anonymousza31347ze3ze1zz__evaluatez00(obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
	extern obj_t make_vector(long, obj_t);
	static obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluatez00();
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
	extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
	static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t,
		obj_t);
	extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluatez00();
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	extern obj_t
		BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t,
		obj_t, bool_t);
	static obj_t BGl_symbol3154z00zz__evaluatez00 = BUNSPEC;
	extern obj_t c_substring(obj_t, long, long);
	extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol3162z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3164z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3166z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3167z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3169z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_symbol3171z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3173z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3175z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3177z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_loopze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_loopze71ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol3179z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3180z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3182z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3184z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3186z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3188z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3190z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3192z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3194z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3196z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3198z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, bool_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	extern obj_t bgl_reverse(obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluatez00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, bool_t);
	extern obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	extern obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
	extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_expandz00zz__expandz00(obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
	static obj_t BGl_symbol3200z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3202z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3204z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3206z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_symbol3208z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3210z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3212z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3214z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3216z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3218z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_keyword3265z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3220z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3222z00zz__evaluatez00 = BUNSPEC;
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_symbol3224z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3226z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
	static obj_t BGl_symbol3228z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol3232z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3234z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3237z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3239z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
	static obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int);
	static obj_t BGl_symbol3241z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3243z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3245z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3247z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3249z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3251z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3253z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3255z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3257z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3259z00zz__evaluatez00 = BUNSPEC;
	extern obj_t bstring_to_keyword(obj_t);
	static obj_t BGl_symbol3261z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3263z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3267z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, bool_t);
	static obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2bpz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3270z00,
		BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3201z00zz__evaluatez00,
		BgL_bgl_string3201za700za7za7_3271za7, "string", 6);
	      DEFINE_STRING(BGl_string3203z00zz__evaluatez00,
		BgL_bgl_string3203za700za7za7_3272za7, "bstring", 7);
	      DEFINE_STRING(BGl_string3205z00zz__evaluatez00,
		BgL_bgl_string3205za700za7za7_3273za7, "string?", 7);
	      DEFINE_STRING(BGl_string3207z00zz__evaluatez00,
		BgL_bgl_string3207za700za7za7_3274za7, "o", 1);
	      DEFINE_STRING(BGl_string3209z00zz__evaluatez00,
		BgL_bgl_string3209za700za7za7_3275za7, "quote", 5);
	      DEFINE_STRING(BGl_string3211z00zz__evaluatez00,
		BgL_bgl_string3211za700za7za7_3276za7, "class-exists", 12);
	      DEFINE_STRING(BGl_string3213z00zz__evaluatez00,
		BgL_bgl_string3213za700za7za7_3277za7, "c", 1);
	      DEFINE_STRING(BGl_string3215z00zz__evaluatez00,
		BgL_bgl_string3215za700za7za7_3278za7, "isa?", 4);
	      DEFINE_STRING(BGl_string3217z00zz__evaluatez00,
		BgL_bgl_string3217za700za7za7_3279za7, "if", 2);
	      DEFINE_STRING(BGl_string3219z00zz__evaluatez00,
		BgL_bgl_string3219za700za7za7_3280za7, "let", 3);
	      DEFINE_STRING(BGl_string3221z00zz__evaluatez00,
		BgL_bgl_string3221za700za7za7_3281za7, "lambda", 6);
	      DEFINE_STRING(BGl_string3223z00zz__evaluatez00,
		BgL_bgl_string3223za700za7za7_3282za7, "bigloo-type-error/location", 26);
	      DEFINE_STRING(BGl_string3225z00zz__evaluatez00,
		BgL_bgl_string3225za700za7za7_3283za7, "bigloo-type-error", 17);
	      DEFINE_STRING(BGl_string3227z00zz__evaluatez00,
		BgL_bgl_string3227za700za7za7_3284za7, "at", 2);
	      DEFINE_STRING(BGl_string3229z00zz__evaluatez00,
		BgL_bgl_string3229za700za7za7_3285za7, "tmp", 3);
	      DEFINE_STRING(BGl_string3230z00zz__evaluatez00,
		BgL_bgl_string3230za700za7za7_3286za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string3231z00zz__evaluatez00,
		BgL_bgl_string3231za700za7za7_3287za7, "Illegal form", 12);
	      DEFINE_STRING(BGl_string3233z00zz__evaluatez00,
		BgL_bgl_string3233za700za7za7_3288za7, "begin", 5);
	      DEFINE_STRING(BGl_string3235z00zz__evaluatez00,
		BgL_bgl_string3235za700za7za7_3289za7, " ", 1);
	      DEFINE_STRING(BGl_string3236z00zz__evaluatez00,
		BgL_bgl_string3236za700za7za7_3290za7,
		"Illegal non toplevel module declaration", 39);
	      DEFINE_STRING(BGl_string3238z00zz__evaluatez00,
		BgL_bgl_string3238za700za7za7_3291za7, "module", 6);
	      DEFINE_STRING(BGl_string3240z00zz__evaluatez00,
		BgL_bgl_string3240za700za7za7_3292za7, "@", 1);
	      DEFINE_STRING(BGl_string3242z00zz__evaluatez00,
		BgL_bgl_string3242za700za7za7_3293za7, "->", 2);
	      DEFINE_STRING(BGl_string3244z00zz__evaluatez00,
		BgL_bgl_string3244za700za7za7_3294za7, "trap", 4);
	      DEFINE_STRING(BGl_string3246z00zz__evaluatez00,
		BgL_bgl_string3246za700za7za7_3295za7, "or", 2);
	      DEFINE_STRING(BGl_string3248z00zz__evaluatez00,
		BgL_bgl_string3248za700za7za7_3296za7, "and", 3);
	      DEFINE_STRING(BGl_string3250z00zz__evaluatez00,
		BgL_bgl_string3250za700za7za7_3297za7, "let*", 4);
	      DEFINE_STRING(BGl_string3252z00zz__evaluatez00,
		BgL_bgl_string3252za700za7za7_3298za7, "letrec", 6);
	      DEFINE_STRING(BGl_string3254z00zz__evaluatez00,
		BgL_bgl_string3254za700za7za7_3299za7, "set!", 4);
	      DEFINE_STRING(BGl_string3256z00zz__evaluatez00,
		BgL_bgl_string3256za700za7za7_3300za7, "define", 6);
	      DEFINE_STRING(BGl_string3258z00zz__evaluatez00,
		BgL_bgl_string3258za700za7za7_3301za7, "bind-exit", 9);
	      DEFINE_STRING(BGl_string3260z00zz__evaluatez00,
		BgL_bgl_string3260za700za7za7_3302za7, "unwind-protect", 14);
	      DEFINE_STRING(BGl_string3262z00zz__evaluatez00,
		BgL_bgl_string3262za700za7za7_3303za7, "with-handler", 12);
	      DEFINE_STRING(BGl_string3264z00zz__evaluatez00,
		BgL_bgl_string3264za700za7za7_3304za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string3266z00zz__evaluatez00,
		BgL_bgl_string3266za700za7za7_3305za7, "prelock", 7);
	      DEFINE_STRING(BGl_string3268z00zz__evaluatez00,
		BgL_bgl_string3268za700za7za7_3306za7, "\\@", 2);
	      DEFINE_STRING(BGl_string3269z00zz__evaluatez00,
		BgL_bgl_string3269za700za7za7_3307za7, "__evaluate", 10);
	extern obj_t BGl_errorzd2envzd2zz__errorz00;
	   
		 
		DEFINE_STRING(BGl_string3148z00zz__evaluatez00,
		BgL_bgl_string3148za700za7za7_3308za7, "", 0);
	      DEFINE_STRING(BGl_string3149z00zz__evaluatez00,
		BgL_bgl_string3149za700za7za7_3309za7,
		"/tmp/bigloo/runtime/Eval/evaluate.scm", 37);
	      DEFINE_STRING(BGl_string3150z00zz__evaluatez00,
		BgL_bgl_string3150za700za7za7_3310za7, "&evaluate2-restore-bp!", 22);
	      DEFINE_STRING(BGl_string3151z00zz__evaluatez00,
		BgL_bgl_string3151za700za7za7_3311za7, "bint", 4);
	      DEFINE_STRING(BGl_string3152z00zz__evaluatez00,
		BgL_bgl_string3152za700za7za7_3312za7, "&evaluate2-restore-state!", 25);
	      DEFINE_STRING(BGl_string3153z00zz__evaluatez00,
		BgL_bgl_string3153za700za7za7_3313za7, "vector", 6);
	      DEFINE_STRING(BGl_string3155z00zz__evaluatez00,
		BgL_bgl_string3155za700za7za7_3314za7, "toplevel", 8);
	      DEFINE_STRING(BGl_string3156z00zz__evaluatez00,
		BgL_bgl_string3156za700za7za7_3315za7, "eval", 4);
	      DEFINE_STRING(BGl_string3157z00zz__evaluatez00,
		BgL_bgl_string3157za700za7za7_3316za7, "Bad syntax", 10);
	      DEFINE_STRING(BGl_string3158z00zz__evaluatez00,
		BgL_bgl_string3158za700za7za7_3317za7, "Class \"~a\" has no field \"~a\"",
		28);
	      DEFINE_STRING(BGl_string3159z00zz__evaluatez00,
		BgL_bgl_string3159za700za7za7_3318za7, "Static type not a class", 23);
	      DEFINE_STRING(BGl_string3160z00zz__evaluatez00,
		BgL_bgl_string3160za700za7za7_3319za7, "Variable unbound", 16);
	      DEFINE_STRING(BGl_string3161z00zz__evaluatez00,
		BgL_bgl_string3161za700za7za7_3320za7, "Field read-only", 15);
	      DEFINE_STRING(BGl_string3163z00zz__evaluatez00,
		BgL_bgl_string3163za700za7za7_3321za7, "pair", 4);
	      DEFINE_STRING(BGl_string3165z00zz__evaluatez00,
		BgL_bgl_string3165za700za7za7_3322za7, "pair?", 5);
	      DEFINE_STRING(BGl_string3168z00zz__evaluatez00,
		BgL_bgl_string3168za700za7za7_3323za7, "vector?", 7);
	      DEFINE_STRING(BGl_string3170z00zz__evaluatez00,
		BgL_bgl_string3170za700za7za7_3324za7, "symbol", 6);
	      DEFINE_STRING(BGl_string3172z00zz__evaluatez00,
		BgL_bgl_string3172za700za7za7_3325za7, "symbol?", 7);
	      DEFINE_STRING(BGl_string3174z00zz__evaluatez00,
		BgL_bgl_string3174za700za7za7_3326za7, "char", 4);
	      DEFINE_STRING(BGl_string3176z00zz__evaluatez00,
		BgL_bgl_string3176za700za7za7_3327za7, "char?", 5);
	      DEFINE_STRING(BGl_string3178z00zz__evaluatez00,
		BgL_bgl_string3178za700za7za7_3328za7, "int", 3);
	      DEFINE_STRING(BGl_string3181z00zz__evaluatez00,
		BgL_bgl_string3181za700za7za7_3329za7, "integer?", 8);
	      DEFINE_STRING(BGl_string3183z00zz__evaluatez00,
		BgL_bgl_string3183za700za7za7_3330za7, "real", 4);
	      DEFINE_STRING(BGl_string3185z00zz__evaluatez00,
		BgL_bgl_string3185za700za7za7_3331za7, "breal", 5);
	      DEFINE_STRING(BGl_string3187z00zz__evaluatez00,
		BgL_bgl_string3187za700za7za7_3332za7, "real?", 5);
	      DEFINE_STRING(BGl_string3189z00zz__evaluatez00,
		BgL_bgl_string3189za700za7za7_3333za7, "bool", 4);
	      DEFINE_STRING(BGl_string3191z00zz__evaluatez00,
		BgL_bgl_string3191za700za7za7_3334za7, "boolean?", 8);
	      DEFINE_STRING(BGl_string3193z00zz__evaluatez00,
		BgL_bgl_string3193za700za7za7_3335za7, "struct", 6);
	      DEFINE_STRING(BGl_string3195z00zz__evaluatez00,
		BgL_bgl_string3195za700za7za7_3336za7, "struct?", 7);
	      DEFINE_STRING(BGl_string3197z00zz__evaluatez00,
		BgL_bgl_string3197za700za7za7_3337za7, "class", 5);
	      DEFINE_STRING(BGl_string3199z00zz__evaluatez00,
		BgL_bgl_string3199za700za7za7_3338za7, "class?", 6);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762setza7d2evaluat3339z00,
		BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2statez12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3340z00,
		BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00,
		BgL_bgl_za762getza7d2evaluat3341z00,
		BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_evaluate2zd2envzd2zz__evaluatez00,
		BgL_bgl_za762evaluate2za762za73342za7, BGl_z62evaluate2z62zz__evaluatez00,
		0L, BUNSPEC, 3);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol3154z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3162z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3164z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3166z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3167z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3169z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3171z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3173z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3175z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3177z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3179z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3180z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3182z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3184z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3186z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3188z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3190z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3192z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3194z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3196z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3198z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3200z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3202z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3204z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3206z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3208z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3210z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3212z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3214z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3216z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3218z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_keyword3265z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3220z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3222z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3224z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3226z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3228z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3232z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3234z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3237z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3239z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3241z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3243z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3245z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3247z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3249z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3251z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3253z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3255z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3257z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3259z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3261z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3263z00zz__evaluatez00));
		     ADD_ROOT((void *) (&BGl_symbol3267z00zz__evaluatez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long
		BgL_checksumz00_4949, char *BgL_fromz00_4950)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluatez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluatez00();
					BGl_cnstzd2initzd2zz__evaluatez00();
					BGl_importedzd2moduleszd2initz00zz__evaluatez00();
					return BGl_methodzd2initzd2zz__evaluatez00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 15 */
			BGl_symbol3154z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3155z00zz__evaluatez00);
			BGl_symbol3162z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3163z00zz__evaluatez00);
			BGl_symbol3164z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3165z00zz__evaluatez00);
			BGl_symbol3166z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3153z00zz__evaluatez00);
			BGl_symbol3167z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3168z00zz__evaluatez00);
			BGl_symbol3169z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3170z00zz__evaluatez00);
			BGl_symbol3171z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3172z00zz__evaluatez00);
			BGl_symbol3173z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3174z00zz__evaluatez00);
			BGl_symbol3175z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3176z00zz__evaluatez00);
			BGl_symbol3177z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3178z00zz__evaluatez00);
			BGl_symbol3179z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3151z00zz__evaluatez00);
			BGl_symbol3180z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3181z00zz__evaluatez00);
			BGl_symbol3182z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3183z00zz__evaluatez00);
			BGl_symbol3184z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3185z00zz__evaluatez00);
			BGl_symbol3186z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3187z00zz__evaluatez00);
			BGl_symbol3188z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3189z00zz__evaluatez00);
			BGl_symbol3190z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3191z00zz__evaluatez00);
			BGl_symbol3192z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3193z00zz__evaluatez00);
			BGl_symbol3194z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3195z00zz__evaluatez00);
			BGl_symbol3196z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3197z00zz__evaluatez00);
			BGl_symbol3198z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3199z00zz__evaluatez00);
			BGl_symbol3200z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3201z00zz__evaluatez00);
			BGl_symbol3202z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3203z00zz__evaluatez00);
			BGl_symbol3204z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3205z00zz__evaluatez00);
			BGl_symbol3206z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3207z00zz__evaluatez00);
			BGl_symbol3208z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3209z00zz__evaluatez00);
			BGl_symbol3210z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3211z00zz__evaluatez00);
			BGl_symbol3212z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3213z00zz__evaluatez00);
			BGl_symbol3214z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3215z00zz__evaluatez00);
			BGl_symbol3216z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3217z00zz__evaluatez00);
			BGl_symbol3218z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3219z00zz__evaluatez00);
			BGl_symbol3220z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3221z00zz__evaluatez00);
			BGl_symbol3222z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3223z00zz__evaluatez00);
			BGl_symbol3224z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3225z00zz__evaluatez00);
			BGl_symbol3226z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3227z00zz__evaluatez00);
			BGl_symbol3228z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3229z00zz__evaluatez00);
			BGl_symbol3232z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3233z00zz__evaluatez00);
			BGl_symbol3234z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3235z00zz__evaluatez00);
			BGl_symbol3237z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3238z00zz__evaluatez00);
			BGl_symbol3239z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3240z00zz__evaluatez00);
			BGl_symbol3241z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3242z00zz__evaluatez00);
			BGl_symbol3243z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3244z00zz__evaluatez00);
			BGl_symbol3245z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3246z00zz__evaluatez00);
			BGl_symbol3247z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3248z00zz__evaluatez00);
			BGl_symbol3249z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3250z00zz__evaluatez00);
			BGl_symbol3251z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3252z00zz__evaluatez00);
			BGl_symbol3253z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3254z00zz__evaluatez00);
			BGl_symbol3255z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3256z00zz__evaluatez00);
			BGl_symbol3257z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3258z00zz__evaluatez00);
			BGl_symbol3259z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3260z00zz__evaluatez00);
			BGl_symbol3261z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3262z00zz__evaluatez00);
			BGl_symbol3263z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3264z00zz__evaluatez00);
			BGl_keyword3265z00zz__evaluatez00 =
				bstring_to_keyword(BGl_string3266z00zz__evaluatez00);
			return (BGl_symbol3267z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3268z00zz__evaluatez00), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 15 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		BGL_FUNCTION_BEGIN;
		{
			{
				obj_t BgL_headz00_1134;

				BgL_headz00_1134 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_3122;
					obj_t BgL_tailz00_3123;

					BgL_prevz00_3122 = BgL_headz00_1134;
					BgL_tailz00_3123 = BgL_l1z00_1;
				BgL_loopz00_3121:
					if (PAIRP(BgL_tailz00_3123))
						{
							obj_t BgL_newzd2prevzd2_3129;

							BgL_newzd2prevzd2_3129 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_3123), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_3122, BgL_newzd2prevzd2_3129);
							{
								obj_t BgL_tailz00_5020;
								obj_t BgL_prevz00_5019;

								BgL_prevz00_5019 = BgL_newzd2prevzd2_3129;
								BgL_tailz00_5020 = CDR(BgL_tailz00_3123);
								BgL_tailz00_3123 = BgL_tailz00_5020;
								BgL_prevz00_3122 = BgL_prevz00_5019;
								goto BgL_loopz00_3121;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1134);
			}
		}
		BGL_FUNCTION_END;
	}



/* untype-ident */
	obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 73 */
			{	/* Eval/evaluate.scm 74 */
				obj_t BgL_stringz00_1142;

				{	/* Eval/evaluate.scm 74 */
					obj_t BgL_res2770z00_3139;

					{	/* Eval/evaluate.scm 74 */
						obj_t BgL_arg2597z00_3138;

						BgL_arg2597z00_3138 = SYMBOL_TO_STRING(BgL_idz00_3);
						BgL_res2770z00_3139 =
							BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2597z00_3138);
					}
					BgL_stringz00_1142 = BgL_res2770z00_3139;
				}
				{	/* Eval/evaluate.scm 74 */
					long BgL_lenz00_1143;

					BgL_lenz00_1143 = STRING_LENGTH(BgL_stringz00_1142);
					{	/* Eval/evaluate.scm 75 */

						{
							long BgL_walkerz00_1145;

							BgL_walkerz00_1145 = ((long) 0);
						BgL_zc3anonymousza31310ze3z83_1146:
							if ((BgL_walkerz00_1145 == BgL_lenz00_1143))
								{	/* Eval/evaluate.scm 78 */
									return MAKE_YOUNG_PAIR(BgL_idz00_3, BFALSE);
								}
							else
								{	/* Eval/evaluate.scm 80 */
									bool_t BgL_testz00_5029;

									if (
										(STRING_REF(BgL_stringz00_1142,
												BgL_walkerz00_1145) == ((unsigned char) ':')))
										{	/* Eval/evaluate.scm 80 */
											if ((BgL_walkerz00_1145 < (BgL_lenz00_1143 - ((long) 1))))
												{	/* Eval/evaluate.scm 81 */
													BgL_testz00_5029 =
														(STRING_REF(BgL_stringz00_1142,
															(BgL_walkerz00_1145 + ((long) 1))) ==
														((unsigned char) ':'));
												}
											else
												{	/* Eval/evaluate.scm 81 */
													BgL_testz00_5029 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate.scm 80 */
											BgL_testz00_5029 = ((bool_t) 0);
										}
									if (BgL_testz00_5029)
										{	/* Eval/evaluate.scm 83 */
											obj_t BgL_arg1324z00_1157;
											obj_t BgL_arg1327z00_1158;

											BgL_arg1324z00_1157 =
												bstring_to_symbol(c_substring(BgL_stringz00_1142,
													((long) 0), BgL_walkerz00_1145));
											{	/* Eval/evaluate.scm 84 */
												obj_t BgL_arg1329z00_1160;

												{	/* Eval/evaluate.scm 84 */
													long BgL_arg1330z00_1161;

													BgL_arg1330z00_1161 =
														(BgL_walkerz00_1145 + ((long) 2));
													{	/* Ieee/string.scm 189 */
														long BgL_endz00_1164;

														BgL_endz00_1164 = STRING_LENGTH(BgL_stringz00_1142);
														{	/* Ieee/string.scm 189 */

															BgL_arg1329z00_1160 =
																BGl_substringz00zz__r4_strings_6_7z00
																(BgL_stringz00_1142, BgL_arg1330z00_1161,
																BgL_endz00_1164);
												}}}
												BgL_arg1327z00_1158 =
													bstring_to_symbol(BgL_arg1329z00_1160);
											}
											return
												MAKE_YOUNG_PAIR(BgL_arg1324z00_1157,
												BgL_arg1327z00_1158);
										}
									else
										{
											long BgL_walkerz00_5046;

											BgL_walkerz00_5046 = (BgL_walkerz00_1145 + ((long) 1));
											BgL_walkerz00_1145 = BgL_walkerz00_5046;
											goto BgL_zc3anonymousza31310ze3z83_1146;
										}
								}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* get-evaluation-context */
	BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 91 */
			{	/* Eval/evaluate.scm 92 */
				obj_t BgL_sz00_1173;

				BgL_sz00_1173 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 93 */
					obj_t BgL_bpz00_1174;

					BgL_bpz00_1174 = VECTOR_REF(((obj_t) BgL_sz00_1173), ((long) 0));
					{	/* Eval/evaluate.scm 94 */
						obj_t BgL_rz00_1175;

						BgL_rz00_1175 =
							make_vector(
							(long) CINT(BgL_bpz00_1174), BGl_string3148z00zz__evaluatez00);
						{
							long BgL_iz00_3188;

							BgL_iz00_3188 = ((long) 0);
						BgL_recz00_3187:
							if ((BgL_iz00_3188 < (long) CINT(BgL_bpz00_1174)))
								{	/* Eval/evaluate.scm 96 */
									{	/* Eval/evaluate.scm 97 */
										obj_t BgL_arg1340z00_3193;

										BgL_arg1340z00_3193 =
											VECTOR_REF(((obj_t) BgL_sz00_1173), BgL_iz00_3188);
										VECTOR_SET(BgL_rz00_1175, BgL_iz00_3188,
											BgL_arg1340z00_3193);
									}
									{
										long BgL_iz00_5059;

										BgL_iz00_5059 = (BgL_iz00_3188 + ((long) 1));
										BgL_iz00_3188 = BgL_iz00_5059;
										goto BgL_recz00_3187;
									}
								}
							else
								{	/* Eval/evaluate.scm 96 */
									((bool_t) 0);
								}
						}
						return BgL_rz00_1175;
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &get-evaluation-context */
	obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t
		BgL_envz00_4906)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 91 */
			return BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
		}
		BGL_FUNCTION_END;
	}



/* set-evaluation-context! */
	BGL_EXPORTED_DEF obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 104 */
			{	/* Eval/evaluate.scm 105 */
				obj_t BgL_sz00_1183;

				BgL_sz00_1183 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 106 */
					obj_t BgL_bpz00_1184;

					BgL_bpz00_1184 = VECTOR_REF(((obj_t) BgL_vz00_4), ((long) 0));
					{
						long BgL_iz00_3212;

						{	/* Eval/evaluate.scm 107 */
							bool_t BgL_tmpz00_5065;

							BgL_iz00_3212 = ((long) 0);
						BgL_recz00_3211:
							if ((BgL_iz00_3212 < (long) CINT(BgL_bpz00_1184)))
								{	/* Eval/evaluate.scm 108 */
									{	/* Eval/evaluate.scm 109 */
										obj_t BgL_arg1344z00_3217;

										BgL_arg1344z00_3217 =
											VECTOR_REF(((obj_t) BgL_vz00_4), BgL_iz00_3212);
										VECTOR_SET(
											((obj_t) BgL_sz00_1183), BgL_iz00_3212,
											BgL_arg1344z00_3217);
									}
									{
										long BgL_iz00_5073;

										BgL_iz00_5073 = (BgL_iz00_3212 + ((long) 1));
										BgL_iz00_3212 = BgL_iz00_5073;
										goto BgL_recz00_3211;
									}
								}
							else
								{	/* Eval/evaluate.scm 108 */
									BgL_tmpz00_5065 = ((bool_t) 0);
								}
							return BBOOL(BgL_tmpz00_5065);
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &set-evaluation-context! */
	obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t
		BgL_envz00_4907, obj_t BgL_vz00_4908)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 104 */
			return BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4908);
		}
		BGL_FUNCTION_END;
	}



/* evaluate2-restore-bp! */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int
		BgL_bpz00_5)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				obj_t BgL_sz00_3225;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_tmpz00_5077;

					BgL_tmpz00_5077 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_3225 = BGL_ENV_EVSTATE(BgL_tmpz00_5077);
				}
				return
					VECTOR_SET(((obj_t) BgL_sz00_3225), ((long) 0), BINT(BgL_bpz00_5));
		}}
		BGL_FUNCTION_END;
	}



/* &evaluate2-restore-bp! */
	obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t
		BgL_envz00_4909, obj_t BgL_bpz00_4910)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				int BgL_auxz00_5083;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_tmpz00_5084;

					if (INTEGERP(BgL_bpz00_4910))
						{	/* Eval/evaluate.scm 116 */
							BgL_tmpz00_5084 = BgL_bpz00_4910;
						}
					else
						{
							obj_t BgL_auxz00_5087;

							BgL_auxz00_5087 =
								BGl_typezd2errorzd2zz__errorz00
								(BGl_string3149z00zz__evaluatez00, BINT(((long) 3890)),
								BGl_string3150z00zz__evaluatez00,
								BGl_string3151z00zz__evaluatez00, BgL_bpz00_4910);
							FAILURE(BgL_auxz00_5087, BFALSE, BFALSE);
						}
					BgL_auxz00_5083 = CINT(BgL_tmpz00_5084);
				}
				return
					BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(BgL_auxz00_5083);
			}
		}
		BGL_FUNCTION_END;
	}



/* evaluate2-restore-state! */
	BGL_EXPORTED_DEF obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t BgL_statez00_6)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 124 */
				obj_t BgL_tmpz00_5093;

				BgL_tmpz00_5093 = BGL_CURRENT_DYNAMIC_ENV();
				return BGL_ENV_EVSTATE_SET(BgL_tmpz00_5093, BgL_statez00_6);
			}
		}
		BGL_FUNCTION_END;
	}



/* &evaluate2-restore-state! */
	obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t
		BgL_envz00_4911, obj_t BgL_statez00_4912)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 123 */
				obj_t BgL_auxz00_5096;

				if (VECTORP(BgL_statez00_4912))
					{	/* Eval/evaluate.scm 123 */
						BgL_auxz00_5096 = BgL_statez00_4912;
					}
				else
					{
						obj_t BgL_auxz00_5099;

						BgL_auxz00_5099 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string3149z00zz__evaluatez00,
							BINT(((long) 4240)), BGl_string3152z00zz__evaluatez00,
							BGl_string3153z00zz__evaluatez00, BgL_statez00_4912);
						FAILURE(BgL_auxz00_5099, BFALSE, BFALSE);
					}
				return
					BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(BgL_auxz00_5096);
			}
		}
		BGL_FUNCTION_END;
	}



/* evaluate2 */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_7,
		obj_t BgL_envz00_8, obj_t BgL_locz00_9)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 129 */
			{	/* Eval/evaluate.scm 130 */
				BgL_ev_exprz00_bglt BgL_astz00_1195;

				{	/* Eval/evaluate.scm 130 */
					obj_t BgL_arg1348z00_1205;

					BgL_arg1348z00_1205 =
						BGl_convz00zz__evaluatez00(BgL_sexpz00_7, BNIL, BgL_envz00_8,
						BFALSE, BGl_symbol3154z00zz__evaluatez00, BgL_locz00_9,
						((bool_t) 1));
					BgL_astz00_1195 =
						BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(((BgL_ev_exprz00_bglt)
							BgL_arg1348z00_1205));
				}
				BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_1195);
				{	/* Eval/evaluate.scm 132 */
					int BgL_nz00_1196;

					BgL_nz00_1196 =
						BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_1195);
					{	/* Eval/evaluate.scm 133 */
						obj_t BgL_fz00_1197;

						BgL_fz00_1197 = BGl_compilez00zz__evaluate_compz00(BgL_astz00_1195);
						{	/* Eval/evaluate.scm 134 */
							obj_t BgL_sz00_1198;

							BgL_sz00_1198 = BGl_findzd2statezd2zz__evaluate_compz00();
							{	/* Eval/evaluate.scm 135 */
								obj_t BgL_bpz00_1199;

								BgL_bpz00_1199 =
									VECTOR_REF(((obj_t) BgL_sz00_1198), ((long) 0));
								{	/* Eval/evaluate.scm 136 */
									obj_t BgL_exitd1064z00_1200;

									BgL_exitd1064z00_1200 = BGL_EXITD_TOP_AS_OBJ();
									{	/* Eval/evaluate.scm 138 */
										obj_t BgL_zc3anonymousza31347ze3z83_4913;

										BgL_zc3anonymousza31347ze3z83_4913 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31347ze3ze1zz__evaluatez00,
											(int) (((long) 0)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3anonymousza31347ze3z83_4913,
											(int) (((long) 0)), BgL_sz00_1198);
										PROCEDURE_SET(BgL_zc3anonymousza31347ze3z83_4913,
											(int) (((long) 1)), BgL_bpz00_1199);
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
											(BgL_exitd1064z00_1200,
											BgL_zc3anonymousza31347ze3z83_4913);
										{	/* Eval/evaluate.scm 137 */
											obj_t BgL_tmp1066z00_1202;

											BgL_tmp1066z00_1202 =
												PROCEDURE_ENTRY(BgL_fz00_1197) (BgL_fz00_1197,
												BgL_sz00_1198, BEOA);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_exitd1064z00_1200);
											VECTOR_SET(((obj_t) BgL_sz00_1198), ((long) 0),
												BgL_bpz00_1199);
											return BgL_tmp1066z00_1202;
										}
									}
								}
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &evaluate2 */
	obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4914,
		obj_t BgL_sexpz00_4915, obj_t BgL_envz00_4916, obj_t BgL_locz00_4917)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 129 */
			return
				BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4915, BgL_envz00_4916,
				BgL_locz00_4917);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1347> */
	obj_t BGl_z62zc3anonymousza31347ze3ze1zz__evaluatez00(obj_t BgL_envz00_4918)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 136 */
			{	/* Eval/evaluate.scm 138 */
				obj_t BgL_sz00_4919;
				obj_t BgL_bpz00_4920;

				BgL_sz00_4919 = PROCEDURE_REF(BgL_envz00_4918, (int) (((long) 0)));
				BgL_bpz00_4920 = PROCEDURE_REF(BgL_envz00_4918, (int) (((long) 1)));
				return VECTOR_SET(((obj_t) BgL_sz00_4919), ((long) 0), BgL_bpz00_4920);
		}}
		BGL_FUNCTION_END;
	}



/* get-location */
	obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_10,
		obj_t BgL_locz00_11)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 143 */
			{	/* Eval/evaluate.scm 144 */
				obj_t BgL__ortest_1067z00_3234;

				BgL__ortest_1067z00_3234 =
					BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_10);
				if (CBOOL(BgL__ortest_1067z00_3234))
					{	/* Eval/evaluate.scm 144 */
						return BgL__ortest_1067z00_3234;
					}
				else
					{	/* Eval/evaluate.scm 144 */
						return BgL_locz00_11;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* conv-var */
	obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_18,
		obj_t BgL_localsz00_19)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 163 */
			{
				obj_t BgL_lz00_1210;

				BgL_lz00_1210 = BgL_localsz00_19;
			BgL_zc3anonymousza31349ze3z83_1211:
				if (NULLP(BgL_lz00_1210))
					{	/* Eval/evaluate.scm 165 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate.scm 167 */
						obj_t BgL_rvz00_1213;

						BgL_rvz00_1213 = CAR(((obj_t) BgL_lz00_1210));
						if (
							(BgL_vz00_18 ==
								(((BgL_ev_varz00_bglt) COBJECT(
											((BgL_ev_varz00_bglt) BgL_rvz00_1213)))->BgL_namez00)))
							{	/* Eval/evaluate.scm 169 */
								return BgL_rvz00_1213;
							}
						else
							{
								obj_t BgL_lz00_5147;

								BgL_lz00_5147 = CDR(((obj_t) BgL_lz00_1210));
								BgL_lz00_1210 = BgL_lz00_5147;
								goto BgL_zc3anonymousza31349ze3z83_1211;
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* conv-begin */
	obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_20,
		obj_t BgL_localsz00_21, obj_t BgL_globalsz00_22, obj_t BgL_tailzf3zf3_23,
		obj_t BgL_wherez00_24, obj_t BgL_locz00_25, bool_t BgL_topzf3zf3_26)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 176 */
			{	/* Eval/evaluate.scm 177 */
				obj_t BgL_locz00_1220;

				{	/* Eval/evaluate.scm 144 */
					obj_t BgL__ortest_1067z00_3240;

					BgL__ortest_1067z00_3240 =
						BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lz00_20);
					if (CBOOL(BgL__ortest_1067z00_3240))
						{	/* Eval/evaluate.scm 144 */
							BgL_locz00_1220 = BgL__ortest_1067z00_3240;
						}
					else
						{	/* Eval/evaluate.scm 144 */
							BgL_locz00_1220 = BgL_locz00_25;
						}
				}
				{
					obj_t BgL_e1z00_1224;
					obj_t BgL_rz00_1225;

					if (NULLP(BgL_lz00_20))
						{
							BgL_ev_littz00_bglt BgL_auxz00_5155;

							{	/* Eval/evaluate.scm 180 */
								BgL_ev_littz00_bglt BgL_new1072z00_1237;

								{	/* Eval/evaluate.scm 181 */
									BgL_ev_littz00_bglt BgL_new1071z00_1238;

									BgL_new1071z00_1238 =
										((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 181 */
										long BgL_arg1363z00_1239;

										{	/* Eval/evaluate.scm 181 */
											long BgL_res2793z00_3242;

											BgL_res2793z00_3242 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg1363z00_1239 = BgL_res2793z00_3242;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1071z00_1238),
											BgL_arg1363z00_1239);
									}
									BgL_new1072z00_1237 = BgL_new1071z00_1238;
								}
								((((BgL_ev_littz00_bglt) COBJECT(BgL_new1072z00_1237))->
										BgL_valuez00) = ((obj_t) BUNSPEC), BUNSPEC);
								BgL_auxz00_5155 = BgL_new1072z00_1237;
							}
							return ((obj_t) BgL_auxz00_5155);
						}
					else
						{	/* Eval/evaluate.scm 178 */
							if (PAIRP(BgL_lz00_20))
								{	/* Eval/evaluate.scm 178 */
									if (NULLP(CDR(BgL_lz00_20)))
										{	/* Eval/evaluate.scm 178 */
											obj_t BgL_arg1359z00_1233;

											BgL_arg1359z00_1233 = CAR(BgL_lz00_20);
											{	/* Eval/evaluate.scm 183 */
												obj_t BgL_arg1364z00_3257;

												{	/* Eval/evaluate.scm 144 */
													obj_t BgL__ortest_1067z00_3258;

													BgL__ortest_1067z00_3258 =
														BGl_getzd2sourcezd2locationz00zz__readerz00
														(BgL_arg1359z00_1233);
													if (CBOOL(BgL__ortest_1067z00_3258))
														{	/* Eval/evaluate.scm 144 */
															BgL_arg1364z00_3257 = BgL__ortest_1067z00_3258;
														}
													else
														{	/* Eval/evaluate.scm 144 */
															BgL_arg1364z00_3257 = BgL_locz00_1220;
														}
												}
												return
													BGl_convz00zz__evaluatez00(BgL_arg1359z00_1233,
													BgL_localsz00_21, BgL_globalsz00_22,
													BgL_tailzf3zf3_23, BgL_wherez00_24,
													BgL_arg1364z00_3257, BgL_topzf3zf3_26);
											}
										}
									else
										{	/* Eval/evaluate.scm 178 */
											obj_t BgL_arg1360z00_1234;
											obj_t BgL_arg1361z00_1235;

											BgL_arg1360z00_1234 = CAR(BgL_lz00_20);
											BgL_arg1361z00_1235 = CDR(BgL_lz00_20);
											{
												BgL_ev_prog2z00_bglt BgL_auxz00_5174;

												BgL_e1z00_1224 = BgL_arg1360z00_1234;
												BgL_rz00_1225 = BgL_arg1361z00_1235;
												{	/* Eval/evaluate.scm 185 */
													BgL_ev_prog2z00_bglt BgL_new1074z00_1241;

													{	/* Eval/evaluate.scm 186 */
														BgL_ev_prog2z00_bglt BgL_new1073z00_1243;

														BgL_new1073z00_1243 =
															((BgL_ev_prog2z00_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_ev_prog2z00_bgl))));
														{	/* Eval/evaluate.scm 186 */
															long BgL_arg1366z00_1244;

															{	/* Eval/evaluate.scm 186 */
																long BgL_res2794z00_3248;

																BgL_res2794z00_3248 =
																	BGL_CLASS_INDEX
																	(BGl_ev_prog2z00zz__evaluate_typesz00);
																BgL_arg1366z00_1244 = BgL_res2794z00_3248;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1073z00_1243),
																BgL_arg1366z00_1244);
														}
														BgL_new1074z00_1241 = BgL_new1073z00_1243;
													}
													{
														BgL_ev_exprz00_bglt BgL_auxz00_5179;

														{	/* Eval/evaluate.scm 186 */
															obj_t BgL_arg1365z00_1242;

															{	/* Eval/evaluate.scm 144 */
																obj_t BgL__ortest_1067z00_3251;

																BgL__ortest_1067z00_3251 =
																	BGl_getzd2sourcezd2locationz00zz__readerz00
																	(BgL_e1z00_1224);
																if (CBOOL(BgL__ortest_1067z00_3251))
																	{	/* Eval/evaluate.scm 144 */
																		BgL_arg1365z00_1242 =
																			BgL__ortest_1067z00_3251;
																	}
																else
																	{	/* Eval/evaluate.scm 144 */
																		BgL_arg1365z00_1242 = BgL_locz00_1220;
																	}
															}
															BgL_auxz00_5179 =
																((BgL_ev_exprz00_bglt)
																BGl_convz00zz__evaluatez00(BgL_e1z00_1224,
																	BgL_localsz00_21, BgL_globalsz00_22, BFALSE,
																	BgL_wherez00_24, BgL_arg1365z00_1242,
																	BgL_topzf3zf3_26));
														}
														((((BgL_ev_prog2z00_bglt)
																	COBJECT(BgL_new1074z00_1241))->BgL_e1z00) =
															((BgL_ev_exprz00_bglt) BgL_auxz00_5179), BUNSPEC);
													}
													((((BgL_ev_prog2z00_bglt)
																COBJECT(BgL_new1074z00_1241))->BgL_e2z00) =
														((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
																BGl_convzd2beginzd2zz__evaluatez00
																(BgL_rz00_1225, BgL_localsz00_21,
																	BgL_globalsz00_22, BgL_tailzf3zf3_23,
																	BgL_wherez00_24, BgL_locz00_1220,
																	BgL_topzf3zf3_26))), BUNSPEC);
													BgL_auxz00_5174 = BgL_new1074z00_1241;
												}
												return ((obj_t) BgL_auxz00_5174);
											}
										}
								}
							else
								{	/* Eval/evaluate.scm 178 */
									return
										BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_1220,
										BGl_string3156z00zz__evaluatez00,
										BGl_string3157z00zz__evaluatez00, BgL_lz00_20);
								}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* conv-field-ref */
	obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_30,
		obj_t BgL_localsz00_31, obj_t BgL_globalsz00_32, obj_t BgL_tailzf3zf3_33,
		obj_t BgL_wherez00_34, obj_t BgL_locz00_35, bool_t BgL_topzf3zf3_36)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 203 */
			{	/* Eval/evaluate.scm 204 */
				obj_t BgL_lz00_1249;

				BgL_lz00_1249 = CDR(((obj_t) BgL_ez00_30));
				{	/* Eval/evaluate.scm 204 */
					obj_t BgL_vz00_1250;

					BgL_vz00_1250 =
						BGl_convzd2varzd2zz__evaluatez00(CAR(
							((obj_t) BgL_lz00_1249)), BgL_localsz00_31);
					{	/* Eval/evaluate.scm 205 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1250,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 208 */
								obj_t BgL_g1078z00_1253;
								obj_t BgL_g1079z00_1254;

								{	/* Eval/evaluate.scm 209 */
									obj_t BgL_arg1385z00_1277;

									BgL_arg1385z00_1277 =
										(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_vz00_1250)))->BgL_typez00);
									BgL_g1078z00_1253 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1385z00_1277);
								}
								BgL_g1079z00_1254 = CDR(((obj_t) BgL_lz00_1249));
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1256;
									obj_t BgL_klassz00_1257;
									obj_t BgL_fieldsz00_1258;

									BgL_nodez00_1256 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1250));
									BgL_klassz00_1257 = BgL_g1078z00_1253;
									BgL_fieldsz00_1258 = BgL_g1079z00_1254;
								BgL_zc3anonymousza31370ze3z83_1259:
									if (NULLP(BgL_fieldsz00_1258))
										{	/* Eval/evaluate.scm 212 */
											return ((obj_t) BgL_nodez00_1256);
										}
									else
										{	/* Eval/evaluate.scm 212 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1257))
												{	/* Eval/evaluate.scm 215 */
													obj_t BgL_fieldz00_1262;

													{	/* Eval/evaluate.scm 215 */
														obj_t BgL_arg1383z00_1273;

														BgL_arg1383z00_1273 =
															CAR(((obj_t) BgL_fieldsz00_1258));
														BgL_fieldz00_1262 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_1257, BgL_arg1383z00_1273);
													}
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1262))
														{	/* Eval/evaluate.scm 217 */
															BgL_ev_appz00_bglt BgL_nodez00_1264;

															{	/* Eval/evaluate.scm 271 */
																obj_t BgL_getz00_3274;

																BgL_getz00_3274 =
																	BGl_classzd2fieldzd2accessorz00zz__objectz00
																	(BgL_fieldz00_1262);
																{	/* Eval/evaluate.scm 272 */
																	BgL_ev_appz00_bglt BgL_new1086z00_3275;

																	{	/* Eval/evaluate.scm 273 */
																		BgL_ev_appz00_bglt BgL_new1085z00_3276;

																		BgL_new1085z00_3276 =
																			((BgL_ev_appz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_ev_appz00_bgl))));
																		{	/* Eval/evaluate.scm 273 */
																			long BgL_arg1423z00_3277;

																			{	/* Eval/evaluate.scm 273 */
																				long BgL_res2800z00_3283;

																				BgL_res2800z00_3283 =
																					BGL_CLASS_INDEX
																					(BGl_ev_appz00zz__evaluate_typesz00);
																				BgL_arg1423z00_3277 =
																					BgL_res2800z00_3283;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1085z00_3276),
																				BgL_arg1423z00_3277);
																		}
																		BgL_new1086z00_3275 = BgL_new1085z00_3276;
																	}
																	((((BgL_ev_appz00_bglt)
																				COBJECT(BgL_new1086z00_3275))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_35), BUNSPEC);
																	{
																		BgL_ev_exprz00_bglt BgL_auxz00_5219;

																		{	/* Eval/evaluate.scm 274 */
																			BgL_ev_littz00_bglt BgL_new1088z00_3278;

																			{	/* Eval/evaluate.scm 274 */
																				BgL_ev_littz00_bglt BgL_new1087z00_3279;

																				BgL_new1087z00_3279 =
																					((BgL_ev_littz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_ev_littz00_bgl))));
																				{	/* Eval/evaluate.scm 274 */
																					long BgL_arg1421z00_3280;

																					{	/* Eval/evaluate.scm 274 */
																						long BgL_res2801z00_3287;

																						{	/* Eval/evaluate.scm 274 */
																							obj_t BgL_classz00_3286;

																							BgL_classz00_3286 =
																								BGl_ev_littz00zz__evaluate_typesz00;
																							BgL_res2801z00_3287 =
																								BGL_CLASS_INDEX
																								(BgL_classz00_3286);
																						}
																						BgL_arg1421z00_3280 =
																							BgL_res2801z00_3287;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1087z00_3279),
																						BgL_arg1421z00_3280);
																				}
																				BgL_new1088z00_3278 =
																					BgL_new1087z00_3279;
																			}
																			((((BgL_ev_littz00_bglt)
																						COBJECT(BgL_new1088z00_3278))->
																					BgL_valuez00) =
																				((obj_t) BgL_getz00_3274), BUNSPEC);
																			BgL_auxz00_5219 =
																				((BgL_ev_exprz00_bglt)
																				BgL_new1088z00_3278);
																		}
																		((((BgL_ev_appz00_bglt)
																					COBJECT(BgL_new1086z00_3275))->
																				BgL_funz00) =
																			((BgL_ev_exprz00_bglt) BgL_auxz00_5219),
																			BUNSPEC);
																	}
																	{
																		obj_t BgL_auxz00_5227;

																		{	/* Eval/evaluate.scm 275 */
																			obj_t BgL_list1422z00_3281;

																			BgL_list1422z00_3281 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_nodez00_1256), BNIL);
																			BgL_auxz00_5227 = BgL_list1422z00_3281;
																		}
																		((((BgL_ev_appz00_bglt)
																					COBJECT(BgL_new1086z00_3275))->
																				BgL_argsz00) =
																			((obj_t) BgL_auxz00_5227), BUNSPEC);
																	}
																	((((BgL_ev_appz00_bglt)
																				COBJECT(BgL_new1086z00_3275))->
																			BgL_tailzf3zf3) =
																		((obj_t) BgL_tailzf3zf3_33), BUNSPEC);
																	BgL_nodez00_1264 = BgL_new1086z00_3275;
															}}
															{	/* Eval/evaluate.scm 220 */
																obj_t BgL_arg1374z00_1265;
																obj_t BgL_arg1375z00_1266;

																BgL_arg1374z00_1265 =
																	BGl_classzd2fieldzd2typez00zz__objectz00
																	(BgL_fieldz00_1262);
																BgL_arg1375z00_1266 =
																	CDR(((obj_t) BgL_fieldsz00_1258));
																{
																	obj_t BgL_fieldsz00_5238;
																	obj_t BgL_klassz00_5237;
																	BgL_ev_exprz00_bglt BgL_nodez00_5235;

																	BgL_nodez00_5235 =
																		((BgL_ev_exprz00_bglt) BgL_nodez00_1264);
																	BgL_klassz00_5237 = BgL_arg1374z00_1265;
																	BgL_fieldsz00_5238 = BgL_arg1375z00_1266;
																	BgL_fieldsz00_1258 = BgL_fieldsz00_5238;
																	BgL_klassz00_1257 = BgL_klassz00_5237;
																	BgL_nodez00_1256 = BgL_nodez00_5235;
																	goto BgL_zc3anonymousza31370ze3z83_1259;
																}
															}
														}
													else
														{	/* Eval/evaluate.scm 222 */
															obj_t BgL_arg1377z00_1267;
															obj_t BgL_arg1378z00_1268;

															BgL_arg1377z00_1267 =
																(((BgL_ev_varz00_bglt) COBJECT(
																		((BgL_ev_varz00_bglt) BgL_vz00_1250)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 223 */
																obj_t BgL_arg1379z00_1269;
																obj_t BgL_arg1380z00_1270;

																BgL_arg1379z00_1269 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1250)))->
																	BgL_typez00);
																BgL_arg1380z00_1270 =
																	CAR(((obj_t) BgL_fieldsz00_1258));
																{	/* Eval/evaluate.scm 223 */
																	obj_t BgL_list1381z00_1271;

																	{	/* Eval/evaluate.scm 223 */
																		obj_t BgL_arg1382z00_1272;

																		BgL_arg1382z00_1272 =
																			MAKE_YOUNG_PAIR(BgL_arg1380z00_1270,
																			BNIL);
																		BgL_list1381z00_1271 =
																			MAKE_YOUNG_PAIR(BgL_arg1379z00_1269,
																			BgL_arg1382z00_1272);
																	}
																	BgL_arg1378z00_1268 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string3158z00zz__evaluatez00,
																		BgL_list1381z00_1271);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_35, BgL_arg1377z00_1267,
																BgL_arg1378z00_1268, BgL_ez00_30);
														}
												}
											else
												{	/* Eval/evaluate.scm 226 */
													obj_t BgL_arg1384z00_1274;

													{	/* Eval/evaluate.scm 226 */
														obj_t BgL__ortest_1080z00_1275;

														BgL__ortest_1080z00_1275 =
															(((BgL_ev_varz00_bglt) COBJECT(
																	((BgL_ev_varz00_bglt) BgL_vz00_1250)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1080z00_1275))
															{	/* Eval/evaluate.scm 226 */
																BgL_arg1384z00_1274 = BgL__ortest_1080z00_1275;
															}
														else
															{	/* Eval/evaluate.scm 226 */
																BgL_arg1384z00_1274 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1250)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_35, BgL_arg1384z00_1274,
														BGl_string3159z00zz__evaluatez00, BgL_ez00_30);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 228 */
								obj_t BgL_arg1386z00_1278;

								{	/* Eval/evaluate.scm 228 */
									obj_t BgL_pairz00_3296;

									BgL_pairz00_3296 = CDR(((obj_t) BgL_ez00_30));
									BgL_arg1386z00_1278 = CAR(BgL_pairz00_3296);
								}
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35,
									BgL_arg1386z00_1278, BGl_string3160z00zz__evaluatez00,
									BgL_ez00_30);
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* conv-field-set */
	obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_37,
		obj_t BgL_e2z00_38, obj_t BgL_ez00_39, obj_t BgL_localsz00_40,
		obj_t BgL_globalsz00_41, obj_t BgL_tailzf3zf3_42, obj_t BgL_wherez00_43,
		obj_t BgL_locz00_44, bool_t BgL_topzf3zf3_45)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 233 */
			{	/* Eval/evaluate.scm 234 */
				obj_t BgL_vz00_1280;

				BgL_vz00_1280 =
					BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_37), BgL_localsz00_40);
				{	/* Eval/evaluate.scm 234 */
					obj_t BgL_e2z00_1281;

					BgL_e2z00_1281 =
						BGl_convz00zz__evaluatez00(BgL_e2z00_38, BgL_localsz00_40,
						BgL_globalsz00_41, BFALSE, BgL_wherez00_43, BgL_locz00_44,
						((bool_t) 0));
					{	/* Eval/evaluate.scm 235 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1280,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 238 */
								obj_t BgL_g1082z00_1284;
								obj_t BgL_g1083z00_1285;

								{	/* Eval/evaluate.scm 239 */
									obj_t BgL_arg1418z00_1316;

									BgL_arg1418z00_1316 =
										(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_vz00_1280)))->BgL_typez00);
									BgL_g1082z00_1284 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1418z00_1316);
								}
								BgL_g1083z00_1285 = CDR(BgL_lz00_37);
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1287;
									obj_t BgL_klassz00_1288;
									obj_t BgL_fieldsz00_1289;

									BgL_nodez00_1287 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1280));
									BgL_klassz00_1288 = BgL_g1082z00_1284;
									BgL_fieldsz00_1289 = BgL_g1083z00_1285;
								BgL_zc3anonymousza31389ze3z83_1290:
									if (NULLP(BgL_fieldsz00_1289))
										{	/* Eval/evaluate.scm 242 */
											return ((obj_t) BgL_nodez00_1287);
										}
									else
										{	/* Eval/evaluate.scm 242 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1288))
												{	/* Eval/evaluate.scm 245 */
													obj_t BgL_fieldz00_1293;

													{	/* Eval/evaluate.scm 245 */
														obj_t BgL_arg1412z00_1312;

														BgL_arg1412z00_1312 =
															CAR(((obj_t) BgL_fieldsz00_1289));
														BgL_fieldz00_1293 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_1288, BgL_arg1412z00_1312);
													}
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1293))
														{	/* Eval/evaluate.scm 246 */
															if (NULLP(CDR(((obj_t) BgL_fieldsz00_1289))))
																{	/* Eval/evaluate.scm 247 */
																	if (BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_1293))
																		{	/* Eval/evaluate.scm 250 */
																			obj_t BgL_arg1396z00_1298;

																			{	/* Eval/evaluate.scm 250 */
																				obj_t BgL_list1397z00_1299;

																				{	/* Eval/evaluate.scm 250 */
																					obj_t BgL_arg1398z00_1300;

																					BgL_arg1398z00_1300 =
																						MAKE_YOUNG_PAIR(BgL_e2z00_1281,
																						BNIL);
																					BgL_list1397z00_1299 =
																						MAKE_YOUNG_PAIR(((obj_t)
																							BgL_nodez00_1287),
																						BgL_arg1398z00_1300);
																				}
																				BgL_arg1396z00_1298 =
																					BgL_list1397z00_1299;
																			}
																			{	/* Eval/evaluate.scm 282 */
																				obj_t BgL_setz00_3304;

																				BgL_setz00_3304 =
																					BGl_classzd2fieldzd2mutatorz00zz__objectz00
																					(BgL_fieldz00_1293);
																				{	/* Eval/evaluate.scm 283 */
																					BgL_ev_appz00_bglt
																						BgL_new1090z00_3305;
																					{	/* Eval/evaluate.scm 284 */
																						BgL_ev_appz00_bglt
																							BgL_new1089z00_3306;
																						BgL_new1089z00_3306 =
																							((BgL_ev_appz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_appz00_bgl))));
																						{	/* Eval/evaluate.scm 284 */
																							long BgL_arg1425z00_3307;

																							{	/* Eval/evaluate.scm 284 */
																								long BgL_res2806z00_3312;

																								BgL_res2806z00_3312 =
																									BGL_CLASS_INDEX
																									(BGl_ev_appz00zz__evaluate_typesz00);
																								BgL_arg1425z00_3307 =
																									BgL_res2806z00_3312;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1089z00_3306),
																								BgL_arg1425z00_3307);
																						}
																						BgL_new1090z00_3305 =
																							BgL_new1089z00_3306;
																					}
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1090z00_3305))->
																							BgL_locz00) =
																						((obj_t) BgL_locz00_44), BUNSPEC);
																					{
																						BgL_ev_exprz00_bglt BgL_auxz00_5296;

																						{	/* Eval/evaluate.scm 285 */
																							BgL_ev_littz00_bglt
																								BgL_new1092z00_3308;
																							{	/* Eval/evaluate.scm 285 */
																								BgL_ev_littz00_bglt
																									BgL_new1091z00_3309;
																								BgL_new1091z00_3309 =
																									((BgL_ev_littz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 285 */
																									long BgL_arg1424z00_3310;

																									{	/* Eval/evaluate.scm 285 */
																										long BgL_res2807z00_3316;

																										{	/* Eval/evaluate.scm 285 */
																											obj_t BgL_classz00_3315;

																											BgL_classz00_3315 =
																												BGl_ev_littz00zz__evaluate_typesz00;
																											BgL_res2807z00_3316 =
																												BGL_CLASS_INDEX
																												(BgL_classz00_3315);
																										}
																										BgL_arg1424z00_3310 =
																											BgL_res2807z00_3316;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1091z00_3309),
																										BgL_arg1424z00_3310);
																								}
																								BgL_new1092z00_3308 =
																									BgL_new1091z00_3309;
																							}
																							((((BgL_ev_littz00_bglt)
																										COBJECT
																										(BgL_new1092z00_3308))->
																									BgL_valuez00) =
																								((obj_t) BgL_setz00_3304),
																								BUNSPEC);
																							BgL_auxz00_5296 =
																								((BgL_ev_exprz00_bglt)
																								BgL_new1092z00_3308);
																						}
																						((((BgL_ev_appz00_bglt)
																									COBJECT
																									(BgL_new1090z00_3305))->
																								BgL_funz00) =
																							((BgL_ev_exprz00_bglt)
																								BgL_auxz00_5296), BUNSPEC);
																					}
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1090z00_3305))->
																							BgL_argsz00) =
																						((obj_t) BgL_arg1396z00_1298),
																						BUNSPEC);
																					((((BgL_ev_appz00_bglt)
																								COBJECT(BgL_new1090z00_3305))->
																							BgL_tailzf3zf3) =
																						((obj_t) BgL_tailzf3zf3_42),
																						BUNSPEC);
																					return ((obj_t) BgL_new1090z00_3305);
																				}
																			}
																		}
																	else
																		{	/* Eval/evaluate.scm 251 */
																			obj_t BgL_arg1399z00_1301;

																			BgL_arg1399z00_1301 =
																				CAR(((obj_t) BgL_fieldsz00_1289));
																			return
																				BGl_evcompilezd2errorzd2zz__evcompilez00
																				(BgL_locz00_44, BgL_arg1399z00_1301,
																				BGl_string3161z00zz__evaluatez00,
																				BgL_ez00_39);
																		}
																}
															else
																{	/* Eval/evaluate.scm 254 */
																	BgL_ev_appz00_bglt BgL_nodez00_1302;

																	{	/* Eval/evaluate.scm 271 */
																		obj_t BgL_getz00_3320;

																		BgL_getz00_3320 =
																			BGl_classzd2fieldzd2accessorz00zz__objectz00
																			(BgL_fieldz00_1293);
																		{	/* Eval/evaluate.scm 272 */
																			BgL_ev_appz00_bglt BgL_new1086z00_3321;

																			{	/* Eval/evaluate.scm 273 */
																				BgL_ev_appz00_bglt BgL_new1085z00_3322;

																				BgL_new1085z00_3322 =
																					((BgL_ev_appz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_ev_appz00_bgl))));
																				{	/* Eval/evaluate.scm 273 */
																					long BgL_arg1423z00_3323;

																					{	/* Eval/evaluate.scm 273 */
																						long BgL_res2808z00_3329;

																						BgL_res2808z00_3329 =
																							BGL_CLASS_INDEX
																							(BGl_ev_appz00zz__evaluate_typesz00);
																						BgL_arg1423z00_3323 =
																							BgL_res2808z00_3329;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1085z00_3322),
																						BgL_arg1423z00_3323);
																				}
																				BgL_new1086z00_3321 =
																					BgL_new1085z00_3322;
																			}
																			((((BgL_ev_appz00_bglt)
																						COBJECT(BgL_new1086z00_3321))->
																					BgL_locz00) =
																				((obj_t) BgL_locz00_44), BUNSPEC);
																			{
																				BgL_ev_exprz00_bglt BgL_auxz00_5316;

																				{	/* Eval/evaluate.scm 274 */
																					BgL_ev_littz00_bglt
																						BgL_new1088z00_3324;
																					{	/* Eval/evaluate.scm 274 */
																						BgL_ev_littz00_bglt
																							BgL_new1087z00_3325;
																						BgL_new1087z00_3325 =
																							((BgL_ev_littz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_littz00_bgl))));
																						{	/* Eval/evaluate.scm 274 */
																							long BgL_arg1421z00_3326;

																							{	/* Eval/evaluate.scm 274 */
																								long BgL_res2809z00_3333;

																								{	/* Eval/evaluate.scm 274 */
																									obj_t BgL_classz00_3332;

																									BgL_classz00_3332 =
																										BGl_ev_littz00zz__evaluate_typesz00;
																									BgL_res2809z00_3333 =
																										BGL_CLASS_INDEX
																										(BgL_classz00_3332);
																								}
																								BgL_arg1421z00_3326 =
																									BgL_res2809z00_3333;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1087z00_3325),
																								BgL_arg1421z00_3326);
																						}
																						BgL_new1088z00_3324 =
																							BgL_new1087z00_3325;
																					}
																					((((BgL_ev_littz00_bglt)
																								COBJECT(BgL_new1088z00_3324))->
																							BgL_valuez00) =
																						((obj_t) BgL_getz00_3320), BUNSPEC);
																					BgL_auxz00_5316 =
																						((BgL_ev_exprz00_bglt)
																						BgL_new1088z00_3324);
																				}
																				((((BgL_ev_appz00_bglt)
																							COBJECT(BgL_new1086z00_3321))->
																						BgL_funz00) =
																					((BgL_ev_exprz00_bglt)
																						BgL_auxz00_5316), BUNSPEC);
																			}
																			{
																				obj_t BgL_auxz00_5324;

																				{	/* Eval/evaluate.scm 275 */
																					obj_t BgL_list1422z00_3327;

																					BgL_list1422z00_3327 =
																						MAKE_YOUNG_PAIR(
																						((obj_t) BgL_nodez00_1287), BNIL);
																					BgL_auxz00_5324 =
																						BgL_list1422z00_3327;
																				}
																				((((BgL_ev_appz00_bglt)
																							COBJECT(BgL_new1086z00_3321))->
																						BgL_argsz00) =
																					((obj_t) BgL_auxz00_5324), BUNSPEC);
																			}
																			((((BgL_ev_appz00_bglt)
																						COBJECT(BgL_new1086z00_3321))->
																					BgL_tailzf3zf3) =
																				((obj_t) BgL_tailzf3zf3_42), BUNSPEC);
																			BgL_nodez00_1302 = BgL_new1086z00_3321;
																	}}
																	{	/* Eval/evaluate.scm 257 */
																		obj_t BgL_arg1400z00_1303;
																		obj_t BgL_arg1401z00_1304;

																		BgL_arg1400z00_1303 =
																			BGl_classzd2fieldzd2typez00zz__objectz00
																			(BgL_fieldz00_1293);
																		BgL_arg1401z00_1304 =
																			CDR(((obj_t) BgL_fieldsz00_1289));
																		{
																			obj_t BgL_fieldsz00_5335;
																			obj_t BgL_klassz00_5334;
																			BgL_ev_exprz00_bglt BgL_nodez00_5332;

																			BgL_nodez00_5332 =
																				((BgL_ev_exprz00_bglt)
																				BgL_nodez00_1302);
																			BgL_klassz00_5334 = BgL_arg1400z00_1303;
																			BgL_fieldsz00_5335 = BgL_arg1401z00_1304;
																			BgL_fieldsz00_1289 = BgL_fieldsz00_5335;
																			BgL_klassz00_1288 = BgL_klassz00_5334;
																			BgL_nodez00_1287 = BgL_nodez00_5332;
																			goto BgL_zc3anonymousza31389ze3z83_1290;
																		}
																	}
																}
														}
													else
														{	/* Eval/evaluate.scm 259 */
															obj_t BgL_arg1403z00_1306;
															obj_t BgL_arg1404z00_1307;

															BgL_arg1403z00_1306 =
																(((BgL_ev_varz00_bglt) COBJECT(
																		((BgL_ev_varz00_bglt) BgL_vz00_1280)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 260 */
																obj_t BgL_arg1405z00_1308;
																obj_t BgL_arg1409z00_1309;

																BgL_arg1405z00_1308 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1280)))->
																	BgL_typez00);
																BgL_arg1409z00_1309 =
																	CAR(((obj_t) BgL_fieldsz00_1289));
																{	/* Eval/evaluate.scm 260 */
																	obj_t BgL_list1410z00_1310;

																	{	/* Eval/evaluate.scm 260 */
																		obj_t BgL_arg1411z00_1311;

																		BgL_arg1411z00_1311 =
																			MAKE_YOUNG_PAIR(BgL_arg1409z00_1309,
																			BNIL);
																		BgL_list1410z00_1310 =
																			MAKE_YOUNG_PAIR(BgL_arg1405z00_1308,
																			BgL_arg1411z00_1311);
																	}
																	BgL_arg1404z00_1307 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string3158z00zz__evaluatez00,
																		BgL_list1410z00_1310);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_44, BgL_arg1403z00_1306,
																BgL_arg1404z00_1307, BgL_ez00_39);
														}
												}
											else
												{	/* Eval/evaluate.scm 264 */
													obj_t BgL_arg1415z00_1313;

													{	/* Eval/evaluate.scm 264 */
														obj_t BgL__ortest_1084z00_1314;

														BgL__ortest_1084z00_1314 =
															(((BgL_ev_varz00_bglt) COBJECT(
																	((BgL_ev_varz00_bglt) BgL_vz00_1280)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1084z00_1314))
															{	/* Eval/evaluate.scm 264 */
																BgL_arg1415z00_1313 = BgL__ortest_1084z00_1314;
															}
														else
															{	/* Eval/evaluate.scm 264 */
																BgL_arg1415z00_1313 =
																	(((BgL_ev_varz00_bglt) COBJECT(
																			((BgL_ev_varz00_bglt) BgL_vz00_1280)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_44, BgL_arg1415z00_1313,
														BGl_string3159z00zz__evaluatez00, BgL_ez00_39);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 236 */
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44,
									CAR(BgL_lz00_37), BGl_string3160z00zz__evaluatez00,
									BgL_ez00_39);
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* type-check */
	obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t BgL_varz00_56,
		obj_t BgL_tnamez00_57, obj_t BgL_locz00_58, obj_t BgL_procnamez00_59,
		obj_t BgL_bodyz00_60)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 298 */
			if (SYMBOLP(BgL_tnamez00_57))
				{	/* Eval/evaluate.scm 301 */
					obj_t BgL_predz00_1337;

					if ((BgL_tnamez00_57 == BGl_symbol3162z00zz__evaluatez00))
						{	/* Eval/evaluate.scm 301 */
							BgL_predz00_1337 = BGl_symbol3164z00zz__evaluatez00;
						}
					else
						{	/* Eval/evaluate.scm 301 */
							if ((BgL_tnamez00_57 == BGl_symbol3166z00zz__evaluatez00))
								{	/* Eval/evaluate.scm 301 */
									BgL_predz00_1337 = BGl_symbol3167z00zz__evaluatez00;
								}
							else
								{	/* Eval/evaluate.scm 301 */
									if ((BgL_tnamez00_57 == BGl_symbol3169z00zz__evaluatez00))
										{	/* Eval/evaluate.scm 301 */
											BgL_predz00_1337 = BGl_symbol3171z00zz__evaluatez00;
										}
									else
										{	/* Eval/evaluate.scm 301 */
											if ((BgL_tnamez00_57 == BGl_symbol3173z00zz__evaluatez00))
												{	/* Eval/evaluate.scm 301 */
													BgL_predz00_1337 = BGl_symbol3175z00zz__evaluatez00;
												}
											else
												{	/* Eval/evaluate.scm 301 */
													bool_t BgL_testz00_5367;

													{	/* Eval/evaluate.scm 301 */
														bool_t BgL__ortest_1093z00_1413;

														BgL__ortest_1093z00_1413 =
															(BgL_tnamez00_57 ==
															BGl_symbol3177z00zz__evaluatez00);
														if (BgL__ortest_1093z00_1413)
															{	/* Eval/evaluate.scm 301 */
																BgL_testz00_5367 = BgL__ortest_1093z00_1413;
															}
														else
															{	/* Eval/evaluate.scm 301 */
																BgL_testz00_5367 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol3179z00zz__evaluatez00);
															}
													}
													if (BgL_testz00_5367)
														{	/* Eval/evaluate.scm 301 */
															BgL_predz00_1337 =
																BGl_symbol3180z00zz__evaluatez00;
														}
													else
														{	/* Eval/evaluate.scm 301 */
															bool_t BgL_testz00_5371;

															{	/* Eval/evaluate.scm 301 */
																bool_t BgL__ortest_1094z00_1412;

																BgL__ortest_1094z00_1412 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol3182z00zz__evaluatez00);
																if (BgL__ortest_1094z00_1412)
																	{	/* Eval/evaluate.scm 301 */
																		BgL_testz00_5371 = BgL__ortest_1094z00_1412;
																	}
																else
																	{	/* Eval/evaluate.scm 301 */
																		BgL_testz00_5371 =
																			(BgL_tnamez00_57 ==
																			BGl_symbol3184z00zz__evaluatez00);
																	}
															}
															if (BgL_testz00_5371)
																{	/* Eval/evaluate.scm 301 */
																	BgL_predz00_1337 =
																		BGl_symbol3186z00zz__evaluatez00;
																}
															else
																{	/* Eval/evaluate.scm 301 */
																	if (
																		(BgL_tnamez00_57 ==
																			BGl_symbol3188z00zz__evaluatez00))
																		{	/* Eval/evaluate.scm 301 */
																			BgL_predz00_1337 =
																				BGl_symbol3190z00zz__evaluatez00;
																		}
																	else
																		{	/* Eval/evaluate.scm 301 */
																			if (
																				(BgL_tnamez00_57 ==
																					BGl_symbol3192z00zz__evaluatez00))
																				{	/* Eval/evaluate.scm 301 */
																					BgL_predz00_1337 =
																						BGl_symbol3194z00zz__evaluatez00;
																				}
																			else
																				{	/* Eval/evaluate.scm 301 */
																					if (
																						(BgL_tnamez00_57 ==
																							BGl_symbol3196z00zz__evaluatez00))
																						{	/* Eval/evaluate.scm 301 */
																							BgL_predz00_1337 =
																								BGl_symbol3198z00zz__evaluatez00;
																						}
																					else
																						{	/* Eval/evaluate.scm 301 */
																							bool_t BgL_testz00_5381;

																							{	/* Eval/evaluate.scm 301 */
																								bool_t BgL__ortest_1095z00_1411;

																								BgL__ortest_1095z00_1411 =
																									(BgL_tnamez00_57 ==
																									BGl_symbol3200z00zz__evaluatez00);
																								if (BgL__ortest_1095z00_1411)
																									{	/* Eval/evaluate.scm 301 */
																										BgL_testz00_5381 =
																											BgL__ortest_1095z00_1411;
																									}
																								else
																									{	/* Eval/evaluate.scm 301 */
																										BgL_testz00_5381 =
																											(BgL_tnamez00_57 ==
																											BGl_symbol3202z00zz__evaluatez00);
																									}
																							}
																							if (BgL_testz00_5381)
																								{	/* Eval/evaluate.scm 301 */
																									BgL_predz00_1337 =
																										BGl_symbol3204z00zz__evaluatez00;
																								}
																							else
																								{	/* Eval/evaluate.scm 312 */
																									obj_t BgL_arg1476z00_1391;

																									{	/* Eval/evaluate.scm 312 */
																										obj_t BgL_arg1477z00_1392;
																										obj_t BgL_arg1478z00_1393;

																										BgL_arg1477z00_1392 =
																											MAKE_YOUNG_PAIR
																											(BGl_symbol3206z00zz__evaluatez00,
																											BNIL);
																										{	/* Eval/evaluate.scm 313 */
																											obj_t BgL_arg1479z00_1394;

																											{	/* Eval/evaluate.scm 313 */
																												obj_t
																													BgL_arg1480z00_1395;
																												{	/* Eval/evaluate.scm 313 */
																													obj_t
																														BgL_arg1481z00_1396;
																													obj_t
																														BgL_arg1482z00_1397;
																													{	/* Eval/evaluate.scm 313 */
																														obj_t
																															BgL_arg1483z00_1398;
																														{	/* Eval/evaluate.scm 313 */
																															obj_t
																																BgL_arg1484z00_1399;
																															{	/* Eval/evaluate.scm 313 */
																																obj_t
																																	BgL_arg1485z00_1400;
																																{	/* Eval/evaluate.scm 313 */
																																	obj_t
																																		BgL_arg1486z00_1401;
																																	{	/* Eval/evaluate.scm 313 */
																																		obj_t
																																			BgL_arg1487z00_1402;
																																		{	/* Eval/evaluate.scm 313 */
																																			obj_t
																																				BgL_arg1488z00_1403;
																																			BgL_arg1488z00_1403
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BgL_tnamez00_57,
																																				BNIL);
																																			BgL_arg1487z00_1402
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol3208z00zz__evaluatez00,
																																				BgL_arg1488z00_1403);
																																		}
																																		BgL_arg1486z00_1401
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BgL_arg1487z00_1402,
																																			BNIL);
																																	}
																																	BgL_arg1485z00_1400
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_symbol3210z00zz__evaluatez00,
																																		BgL_arg1486z00_1401);
																																}
																																BgL_arg1484z00_1399
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1485z00_1400,
																																	BNIL);
																															}
																															BgL_arg1483z00_1398
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_symbol3212z00zz__evaluatez00,
																																BgL_arg1484z00_1399);
																														}
																														BgL_arg1481z00_1396
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1483z00_1398,
																															BNIL);
																													}
																													{	/* Eval/evaluate.scm 314 */
																														obj_t
																															BgL_arg1489z00_1404;
																														{	/* Eval/evaluate.scm 314 */
																															obj_t
																																BgL_arg1491z00_1405;
																															{	/* Eval/evaluate.scm 314 */
																																obj_t
																																	BgL_arg1493z00_1406;
																																{	/* Eval/evaluate.scm 314 */
																																	obj_t
																																		BgL_arg1494z00_1407;
																																	obj_t
																																		BgL_arg1495z00_1408;
																																	{	/* Eval/evaluate.scm 314 */
																																		obj_t
																																			BgL_arg1496z00_1409;
																																		{	/* Eval/evaluate.scm 314 */
																																			obj_t
																																				BgL_arg1498z00_1410;
																																			BgL_arg1498z00_1410
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol3212z00zz__evaluatez00,
																																				BNIL);
																																			BgL_arg1496z00_1409
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BGl_symbol3206z00zz__evaluatez00,
																																				BgL_arg1498z00_1410);
																																		}
																																		BgL_arg1494z00_1407
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BGl_symbol3214z00zz__evaluatez00,
																																			BgL_arg1496z00_1409);
																																	}
																																	BgL_arg1495z00_1408
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BTRUE,
																																		BNIL);
																																	BgL_arg1493z00_1406
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_arg1494z00_1407,
																																		BgL_arg1495z00_1408);
																																}
																																BgL_arg1491z00_1405
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BGl_symbol3212z00zz__evaluatez00,
																																	BgL_arg1493z00_1406);
																															}
																															BgL_arg1489z00_1404
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_symbol3216z00zz__evaluatez00,
																																BgL_arg1491z00_1405);
																														}
																														BgL_arg1482z00_1397
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1489z00_1404,
																															BNIL);
																													}
																													BgL_arg1480z00_1395 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg1481z00_1396,
																														BgL_arg1482z00_1397);
																												}
																												BgL_arg1479z00_1394 =
																													MAKE_YOUNG_PAIR
																													(BGl_symbol3218z00zz__evaluatez00,
																													BgL_arg1480z00_1395);
																											}
																											BgL_arg1478z00_1393 =
																												MAKE_YOUNG_PAIR
																												(BgL_arg1479z00_1394,
																												BNIL);
																										}
																										BgL_arg1476z00_1391 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1477z00_1392,
																											BgL_arg1478z00_1393);
																									}
																									BgL_predz00_1337 =
																										MAKE_YOUNG_PAIR
																										(BGl_symbol3220z00zz__evaluatez00,
																										BgL_arg1476z00_1391);
																								}
																						}
																				}
																		}
																}
														}
												}
										}
								}
						}
					{	/* Eval/evaluate.scm 316 */
						obj_t BgL_arg1429z00_1338;

						{	/* Eval/evaluate.scm 316 */
							obj_t BgL_arg1432z00_1339;

							{	/* Eval/evaluate.scm 316 */
								obj_t BgL_arg1433z00_1340;
								obj_t BgL_arg1434z00_1341;

								{	/* Eval/evaluate.scm 316 */
									obj_t BgL_arg1435z00_1342;

									BgL_arg1435z00_1342 = MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL);
									BgL_arg1433z00_1340 =
										MAKE_YOUNG_PAIR(BgL_predz00_1337, BgL_arg1435z00_1342);
								}
								{	/* Eval/evaluate.scm 316 */
									obj_t BgL_arg1436z00_1343;

									{	/* Eval/evaluate.scm 316 */
										obj_t BgL_arg1437z00_1344;

										{
											obj_t BgL_fnamez00_1345;
											obj_t BgL_posz00_1346;

											if (PAIRP(BgL_locz00_58))
												{	/* Eval/evaluate.scm 316 */
													obj_t BgL_cdrzd2138zd2_1351;

													BgL_cdrzd2138zd2_1351 = CDR(BgL_locz00_58);
													if (
														(CAR(BgL_locz00_58) ==
															BGl_symbol3226z00zz__evaluatez00))
														{	/* Eval/evaluate.scm 316 */
															if (PAIRP(BgL_cdrzd2138zd2_1351))
																{	/* Eval/evaluate.scm 316 */
																	obj_t BgL_cdrzd2142zd2_1355;

																	BgL_cdrzd2142zd2_1355 =
																		CDR(BgL_cdrzd2138zd2_1351);
																	if (PAIRP(BgL_cdrzd2142zd2_1355))
																		{	/* Eval/evaluate.scm 316 */
																			if (NULLP(CDR(BgL_cdrzd2142zd2_1355)))
																				{	/* Eval/evaluate.scm 316 */
																					BgL_fnamez00_1345 =
																						CAR(BgL_cdrzd2138zd2_1351);
																					BgL_posz00_1346 =
																						CAR(BgL_cdrzd2142zd2_1355);
																					{	/* Eval/evaluate.scm 321 */
																						obj_t BgL_arg1450z00_1363;

																						{	/* Eval/evaluate.scm 321 */
																							obj_t BgL_arg1451z00_1364;
																							obj_t BgL_arg1452z00_1365;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 321 */
																									obj_t BgL_res2826z00_3395;

																									{	/* Eval/evaluate.scm 321 */
																										obj_t BgL_arg2597z00_3394;

																										BgL_arg2597z00_3394 =
																											SYMBOL_TO_STRING
																											(BgL_procnamez00_59);
																										BgL_res2826z00_3395 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2597z00_3394);
																									}
																									BgL_arg1451z00_1364 =
																										BgL_res2826z00_3395;
																								}
																							else
																								{	/* Eval/evaluate.scm 321 */
																									BgL_arg1451z00_1364 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 322 */
																								obj_t BgL_arg1455z00_1367;
																								obj_t BgL_arg1457z00_1368;

																								{	/* Eval/evaluate.scm 322 */
																									obj_t BgL_res2827z00_3398;

																									{	/* Eval/evaluate.scm 322 */
																										obj_t BgL_arg2597z00_3397;

																										BgL_arg2597z00_3397 =
																											SYMBOL_TO_STRING(
																											((obj_t)
																												BgL_tnamez00_57));
																										BgL_res2827z00_3398 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2597z00_3397);
																									}
																									BgL_arg1455z00_1367 =
																										BgL_res2827z00_3398;
																								}
																								{	/* Eval/evaluate.scm 320 */
																									obj_t BgL_arg1458z00_1369;

																									{	/* Eval/evaluate.scm 320 */
																										obj_t BgL_arg1459z00_1370;

																										BgL_arg1459z00_1370 =
																											MAKE_YOUNG_PAIR
																											(BgL_posz00_1346, BNIL);
																										BgL_arg1458z00_1369 =
																											MAKE_YOUNG_PAIR
																											(BgL_fnamez00_1345,
																											BgL_arg1459z00_1370);
																									}
																									BgL_arg1457z00_1368 =
																										MAKE_YOUNG_PAIR
																										(BgL_varz00_56,
																										BgL_arg1458z00_1369);
																								}
																								BgL_arg1452z00_1365 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1455z00_1367,
																									BgL_arg1457z00_1368);
																							}
																							BgL_arg1450z00_1363 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1451z00_1364,
																								BgL_arg1452z00_1365);
																						}
																						BgL_arg1437z00_1344 =
																							MAKE_YOUNG_PAIR
																							(BGl_symbol3222z00zz__evaluatez00,
																							BgL_arg1450z00_1363);
																					}
																				}
																			else
																				{	/* Eval/evaluate.scm 316 */
																				BgL_tagzd2131zd2_1348:
																					{	/* Eval/evaluate.scm 326 */
																						obj_t BgL_arg1460z00_1371;

																						{	/* Eval/evaluate.scm 326 */
																							obj_t BgL_arg1461z00_1372;
																							obj_t BgL_arg1462z00_1373;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 326 */
																									obj_t BgL_res2829z00_3402;

																									{	/* Eval/evaluate.scm 326 */
																										obj_t BgL_arg2597z00_3401;

																										BgL_arg2597z00_3401 =
																											SYMBOL_TO_STRING
																											(BgL_procnamez00_59);
																										BgL_res2829z00_3402 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2597z00_3401);
																									}
																									BgL_arg1461z00_1372 =
																										BgL_res2829z00_3402;
																								}
																							else
																								{	/* Eval/evaluate.scm 326 */
																									BgL_arg1461z00_1372 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 327 */
																								obj_t BgL_arg1464z00_1375;
																								obj_t BgL_arg1465z00_1376;

																								{	/* Eval/evaluate.scm 327 */
																									obj_t BgL_res2830z00_3405;

																									{	/* Eval/evaluate.scm 327 */
																										obj_t BgL_arg2597z00_3404;

																										BgL_arg2597z00_3404 =
																											SYMBOL_TO_STRING(
																											((obj_t)
																												BgL_tnamez00_57));
																										BgL_res2830z00_3405 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2597z00_3404);
																									}
																									BgL_arg1464z00_1375 =
																										BgL_res2830z00_3405;
																								}
																								BgL_arg1465z00_1376 =
																									MAKE_YOUNG_PAIR(BgL_varz00_56,
																									BNIL);
																								BgL_arg1462z00_1373 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1464z00_1375,
																									BgL_arg1465z00_1376);
																							}
																							BgL_arg1460z00_1371 =
																								MAKE_YOUNG_PAIR
																								(BgL_arg1461z00_1372,
																								BgL_arg1462z00_1373);
																						}
																						BgL_arg1437z00_1344 =
																							MAKE_YOUNG_PAIR
																							(BGl_symbol3224z00zz__evaluatez00,
																							BgL_arg1460z00_1371);
																					}
																				}
																		}
																	else
																		{	/* Eval/evaluate.scm 316 */
																			goto BgL_tagzd2131zd2_1348;
																		}
																}
															else
																{	/* Eval/evaluate.scm 316 */
																	goto BgL_tagzd2131zd2_1348;
																}
														}
													else
														{	/* Eval/evaluate.scm 316 */
															goto BgL_tagzd2131zd2_1348;
														}
												}
											else
												{	/* Eval/evaluate.scm 316 */
													goto BgL_tagzd2131zd2_1348;
												}
										}
										BgL_arg1436z00_1343 =
											MAKE_YOUNG_PAIR(BgL_arg1437z00_1344, BNIL);
									}
									BgL_arg1434z00_1341 =
										MAKE_YOUNG_PAIR(BgL_bodyz00_60, BgL_arg1436z00_1343);
								}
								BgL_arg1432z00_1339 =
									MAKE_YOUNG_PAIR(BgL_arg1433z00_1340, BgL_arg1434z00_1341);
							}
							BgL_arg1429z00_1338 =
								MAKE_YOUNG_PAIR(BGl_symbol3216z00zz__evaluatez00,
								BgL_arg1432z00_1339);
						}
						{	/* Eval/evaluate.scm 293 */
							obj_t BgL_arg1426z00_3416;
							obj_t BgL_arg1427z00_3417;

							BgL_arg1426z00_3416 = CAR(BgL_arg1429z00_1338);
							BgL_arg1427z00_3417 = CDR(BgL_arg1429z00_1338);
							{	/* Eval/evaluate.scm 293 */
								obj_t BgL_res2835z00_3420;

								BgL_res2835z00_3420 =
									MAKE_YOUNG_EPAIR(BgL_arg1426z00_3416, BgL_arg1427z00_3417,
									BgL_locz00_58);
								return BgL_res2835z00_3420;
							}
						}
					}
				}
			else
				{	/* Eval/evaluate.scm 300 */
					return BgL_bodyz00_60;
				}
		}
		BGL_FUNCTION_END;
	}



/* type-checks */
	obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t BgL_varsz00_61,
		obj_t BgL_srcsz00_62, obj_t BgL_bodyz00_63, obj_t BgL_locz00_64,
		obj_t BgL_procnamez00_65)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 334 */
			{	/* Eval/evaluate.scm 335 */
				bool_t BgL_testz00_5455;

				{	/* Eval/evaluate.scm 335 */
					int BgL_arg1509z00_1432;

					BgL_arg1509z00_1432 = bgl_debug();
					BgL_testz00_5455 = ((long) (BgL_arg1509z00_1432) <= ((long) 0));
				}
				if (BgL_testz00_5455)
					{	/* Eval/evaluate.scm 335 */
						return BgL_bodyz00_63;
					}
				else
					{	/* Eval/evaluate.scm 335 */
						return
							BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_63, BgL_procnamez00_65,
							BgL_locz00_64, BgL_varsz00_61, BgL_srcsz00_62);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* loop~1 */
	obj_t BGl_loopze71ze7zz__evaluatez00(obj_t BgL_bodyz00_4944,
		obj_t BgL_procnamez00_4943, obj_t BgL_locz00_4942, obj_t BgL_varsz00_1417,
		obj_t BgL_srcsz00_1418)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 337 */
		BGl_loopze71ze7zz__evaluatez00:
			if (NULLP(BgL_varsz00_1417))
				{	/* Eval/evaluate.scm 339 */
					return BgL_bodyz00_4944;
				}
			else
				{	/* Eval/evaluate.scm 341 */
					obj_t BgL_vz00_1421;

					BgL_vz00_1421 = CAR(((obj_t) BgL_varsz00_1417));
					{	/* Eval/evaluate.scm 341 */
						obj_t BgL_idz00_1422;

						BgL_idz00_1422 = CAR(((obj_t) BgL_vz00_1421));
						{	/* Eval/evaluate.scm 342 */
							obj_t BgL_tnamez00_1423;

							BgL_tnamez00_1423 = CDR(((obj_t) BgL_vz00_1421));
							{	/* Eval/evaluate.scm 343 */

								if (CBOOL(BgL_tnamez00_1423))
									{	/* Eval/evaluate.scm 345 */
										obj_t BgL_locz00_1424;

										{	/* Eval/evaluate.scm 345 */
											obj_t BgL_arg1506z00_1428;

											BgL_arg1506z00_1428 = CAR(((obj_t) BgL_srcsz00_1418));
											{	/* Eval/evaluate.scm 150 */
												obj_t BgL__ortest_1068z00_3428;

												BgL__ortest_1068z00_3428 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_arg1506z00_1428);
												if (CBOOL(BgL__ortest_1068z00_3428))
													{	/* Eval/evaluate.scm 150 */
														BgL_locz00_1424 = BgL__ortest_1068z00_3428;
													}
												else
													{	/* Eval/evaluate.scm 151 */
														obj_t BgL__ortest_1069z00_3429;

														BgL__ortest_1069z00_3429 =
															BGl_getzd2sourcezd2locationz00zz__readerz00
															(BgL_srcsz00_1418);
														if (CBOOL(BgL__ortest_1069z00_3429))
															{	/* Eval/evaluate.scm 151 */
																BgL_locz00_1424 = BgL__ortest_1069z00_3429;
															}
														else
															{	/* Eval/evaluate.scm 151 */
																BgL_locz00_1424 = BgL_locz00_4942;
															}
													}
											}
										}
										{	/* Eval/evaluate.scm 347 */
											obj_t BgL_arg1503z00_1425;

											{	/* Eval/evaluate.scm 347 */
												obj_t BgL_arg1504z00_1426;
												obj_t BgL_arg1505z00_1427;

												BgL_arg1504z00_1426 = CDR(((obj_t) BgL_varsz00_1417));
												BgL_arg1505z00_1427 = CDR(((obj_t) BgL_srcsz00_1418));
												BgL_arg1503z00_1425 =
													BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_4944,
													BgL_procnamez00_4943, BgL_locz00_4942,
													BgL_arg1504z00_1426, BgL_arg1505z00_1427);
											}
											return
												BGl_typezd2checkzd2zz__evaluatez00(BgL_idz00_1422,
												BgL_tnamez00_1423, BgL_locz00_1424,
												BgL_procnamez00_4943, BgL_arg1503z00_1425);
										}
									}
								else
									{	/* Eval/evaluate.scm 348 */
										obj_t BgL_arg1507z00_1429;
										obj_t BgL_arg1508z00_1430;

										BgL_arg1507z00_1429 = CDR(((obj_t) BgL_varsz00_1417));
										BgL_arg1508z00_1430 = CDR(((obj_t) BgL_srcsz00_1418));
										{
											obj_t BgL_srcsz00_5489;
											obj_t BgL_varsz00_5488;

											BgL_varsz00_5488 = BgL_arg1507z00_1429;
											BgL_srcsz00_5489 = BgL_arg1508z00_1430;
											BgL_srcsz00_1418 = BgL_srcsz00_5489;
											BgL_varsz00_1417 = BgL_varsz00_5488;
											goto BGl_loopze71ze7zz__evaluatez00;
										}
									}
							}
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* type-result */
	obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t BgL_typez00_66,
		obj_t BgL_bodyz00_67, obj_t BgL_locz00_68)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 353 */
			{	/* Eval/evaluate.scm 354 */
				bool_t BgL_testz00_5490;

				if (CBOOL(BgL_typez00_66))
					{	/* Eval/evaluate.scm 354 */
						int BgL_arg1527z00_1447;

						BgL_arg1527z00_1447 = bgl_debug();
						BgL_testz00_5490 = ((long) (BgL_arg1527z00_1447) >= ((long) 1));
					}
				else
					{	/* Eval/evaluate.scm 354 */
						BgL_testz00_5490 = ((bool_t) 0);
					}
				if (BgL_testz00_5490)
					{	/* Eval/evaluate.scm 355 */
						obj_t BgL_tmpz00_1435;

						BgL_tmpz00_1435 =
							BGl_gensymz00zz__r4_symbols_6_4z00
							(BGl_symbol3228z00zz__evaluatez00);
						{	/* Eval/evaluate.scm 357 */
							obj_t BgL_arg1512z00_1436;
							obj_t BgL_arg1513z00_1437;

							{	/* Eval/evaluate.scm 357 */
								obj_t BgL_arg1515z00_1438;

								{	/* Eval/evaluate.scm 357 */
									obj_t BgL_arg1516z00_1439;
									obj_t BgL_arg1518z00_1440;

									{	/* Eval/evaluate.scm 357 */
										obj_t BgL_arg1519z00_1441;

										{	/* Eval/evaluate.scm 357 */
											obj_t BgL_arg1520z00_1442;
											obj_t BgL_arg1523z00_1443;

											{	/* Eval/evaluate.scm 357 */
												obj_t BgL_arg1524z00_1444;

												{	/* Eval/evaluate.scm 357 */
													obj_t BgL_list1525z00_1445;

													{	/* Eval/evaluate.scm 357 */
														obj_t BgL_arg1526z00_1446;

														BgL_arg1526z00_1446 =
															MAKE_YOUNG_PAIR(BgL_typez00_66, BNIL);
														BgL_list1525z00_1445 =
															MAKE_YOUNG_PAIR(BgL_tmpz00_1435,
															BgL_arg1526z00_1446);
													}
													BgL_arg1524z00_1444 =
														BGl_formatz00zz__r4_output_6_10_3z00
														(BGl_string3230z00zz__evaluatez00,
														BgL_list1525z00_1445);
												}
												BgL_arg1520z00_1442 =
													bstring_to_symbol(BgL_arg1524z00_1444);
											}
											BgL_arg1523z00_1443 =
												MAKE_YOUNG_PAIR(BgL_bodyz00_67, BNIL);
											BgL_arg1519z00_1441 =
												MAKE_YOUNG_PAIR(BgL_arg1520z00_1442,
												BgL_arg1523z00_1443);
										}
										BgL_arg1516z00_1439 =
											MAKE_YOUNG_PAIR(BgL_arg1519z00_1441, BNIL);
									}
									BgL_arg1518z00_1440 = MAKE_YOUNG_PAIR(BgL_tmpz00_1435, BNIL);
									BgL_arg1515z00_1438 =
										MAKE_YOUNG_PAIR(BgL_arg1516z00_1439, BgL_arg1518z00_1440);
								}
								BgL_arg1512z00_1436 =
									MAKE_YOUNG_PAIR(BGl_symbol3218z00zz__evaluatez00,
									BgL_arg1515z00_1438);
							}
							{	/* Eval/evaluate.scm 144 */
								obj_t BgL__ortest_1067z00_3438;

								BgL__ortest_1067z00_3438 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_67);
								if (CBOOL(BgL__ortest_1067z00_3438))
									{	/* Eval/evaluate.scm 144 */
										BgL_arg1513z00_1437 = BgL__ortest_1067z00_3438;
									}
								else
									{	/* Eval/evaluate.scm 144 */
										BgL_arg1513z00_1437 = BgL_locz00_68;
									}
							}
							{	/* Eval/evaluate.scm 293 */
								obj_t BgL_arg1426z00_3439;
								obj_t BgL_arg1427z00_3440;

								BgL_arg1426z00_3439 = CAR(BgL_arg1512z00_1436);
								BgL_arg1427z00_3440 = CDR(BgL_arg1512z00_1436);
								{	/* Eval/evaluate.scm 293 */
									obj_t BgL_res2840z00_3443;

									BgL_res2840z00_3443 =
										MAKE_YOUNG_EPAIR(BgL_arg1426z00_3439, BgL_arg1427z00_3440,
										BgL_arg1513z00_1437);
									return BgL_res2840z00_3443;
								}
							}
						}
					}
				else
					{	/* Eval/evaluate.scm 354 */
						return BgL_bodyz00_67;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* conv */
	obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_69, obj_t BgL_localsz00_70,
		obj_t BgL_globalsz00_71, obj_t BgL_tailzf3zf3_72, obj_t BgL_wherez00_73,
		obj_t BgL_locz00_74, bool_t BgL_topzf3zf3_75)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 365 */
		BGl_convz00zz__evaluatez00:
			{
				obj_t BgL_xz00_1456;
				obj_t BgL_bahz00_1458;
				obj_t BgL_lz00_1463;
				obj_t BgL_funz00_1465;
				obj_t BgL_argsz00_1466;
				obj_t BgL_pz00_1472;
				obj_t BgL_tz00_1473;
				obj_t BgL_oz00_1474;
				obj_t BgL_pz00_1476;
				obj_t BgL_tz00_1477;
				obj_t BgL_bindsz00_1485;
				obj_t BgL_bodyz00_1486;
				obj_t BgL_bindsz00_1488;
				obj_t BgL_bodyz00_1489;
				obj_t BgL_bindsz00_1491;
				obj_t BgL_bodyz00_1492;
				obj_t BgL_lz00_1498;
				obj_t BgL_e2z00_1499;
				obj_t BgL_vz00_1501;
				obj_t BgL_ez00_1502;
				obj_t BgL_gvz00_1505;
				obj_t BgL_formalsz00_1506;
				obj_t BgL_bodyz00_1507;
				obj_t BgL_gvz00_1509;
				obj_t BgL_gez00_1510;
				obj_t BgL_vz00_1512;
				obj_t BgL_bodyz00_1513;
				obj_t BgL_mz00_1525;
				obj_t BgL_bodyz00_1526;
				obj_t BgL_fz00_1531;
				obj_t BgL_argsz00_1532;

				if (PAIRP(BgL_ez00_69))
					{	/* Eval/evaluate.scm 424 */
						if ((CAR(BgL_ez00_69) == BGl_symbol3237z00zz__evaluatez00))
							{	/* Eval/evaluate.scm 424 */
								BgL_bahz00_1458 = CDR(BgL_ez00_69);
								if (BgL_topzf3zf3_75)
									{	/* Eval/evaluate.scm 432 */
										obj_t BgL_formsz00_2316;

										{	/* Eval/evaluate.scm 432 */
											obj_t BgL_arg2235z00_2319;

											{	/* Eval/evaluate.scm 144 */
												obj_t BgL__ortest_1067z00_3495;

												BgL__ortest_1067z00_3495 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_ez00_69);
												if (CBOOL(BgL__ortest_1067z00_3495))
													{	/* Eval/evaluate.scm 144 */
														BgL_arg2235z00_2319 = BgL__ortest_1067z00_3495;
													}
												else
													{	/* Eval/evaluate.scm 144 */
														BgL_arg2235z00_2319 = BgL_locz00_74;
													}
											}
											BgL_formsz00_2316 =
												BGl_evmodulez00zz__evmodulez00(BgL_ez00_69,
												BgL_arg2235z00_2319);
										}
										{	/* Eval/evaluate.scm 433 */
											obj_t BgL_arg2232z00_2317;
											obj_t BgL_arg2234z00_2318;

											BgL_arg2232z00_2317 =
												BGl_expandz00zz__expandz00(BgL_formsz00_2316);
											BgL_arg2234z00_2318 = BGL_MODULE();
											{
												bool_t BgL_topzf3zf3_5529;
												obj_t BgL_wherez00_5528;
												obj_t BgL_tailzf3zf3_5527;
												obj_t BgL_globalsz00_5526;
												obj_t BgL_ez00_5525;

												BgL_ez00_5525 = BgL_arg2232z00_2317;
												BgL_globalsz00_5526 = BgL_arg2234z00_2318;
												BgL_tailzf3zf3_5527 = BgL_wherez00_73;
												BgL_wherez00_5528 = BFALSE;
												BgL_topzf3zf3_5529 = ((bool_t) 1);
												BgL_topzf3zf3_75 = BgL_topzf3zf3_5529;
												BgL_wherez00_73 = BgL_wherez00_5528;
												BgL_tailzf3zf3_72 = BgL_tailzf3zf3_5527;
												BgL_globalsz00_71 = BgL_globalsz00_5526;
												BgL_ez00_69 = BgL_ez00_5525;
												goto BGl_convz00zz__evaluatez00;
											}
										}
									}
								else
									{	/* Eval/evaluate.scm 431 */
										return
											BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74,
											BGl_string3156z00zz__evaluatez00,
											BGl_string3236z00zz__evaluatez00, BgL_ez00_69);
									}
							}
						else
							{	/* Eval/evaluate.scm 424 */
								obj_t BgL_cdrzd2249zd2_1540;

								BgL_cdrzd2249zd2_1540 = CDR(BgL_ez00_69);
								if ((CAR(BgL_ez00_69) == BGl_symbol3239z00zz__evaluatez00))
									{	/* Eval/evaluate.scm 424 */
										if (PAIRP(BgL_cdrzd2249zd2_1540))
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd2252zd2_1544;
												obj_t BgL_cdrzd2253zd2_1545;

												BgL_carzd2252zd2_1544 = CAR(BgL_cdrzd2249zd2_1540);
												BgL_cdrzd2253zd2_1545 = CDR(BgL_cdrzd2249zd2_1540);
												if (SYMBOLP(BgL_carzd2252zd2_1544))
													{	/* Eval/evaluate.scm 424 */
														if (PAIRP(BgL_cdrzd2253zd2_1545))
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_carzd2257zd2_1548;

																BgL_carzd2257zd2_1548 =
																	CAR(BgL_cdrzd2253zd2_1545);
																if (SYMBOLP(BgL_carzd2257zd2_1548))
																	{	/* Eval/evaluate.scm 424 */
																		if (NULLP(CDR(BgL_cdrzd2253zd2_1545)))
																			{	/* Eval/evaluate.scm 437 */
																				BgL_ev_globalz00_bglt
																					BgL_new1105z00_3894;
																				{	/* Eval/evaluate.scm 438 */
																					BgL_ev_globalz00_bglt
																						BgL_new1104z00_3895;
																					BgL_new1104z00_3895 =
																						((BgL_ev_globalz00_bglt)
																						BOBJECT(GC_MALLOC(sizeof(struct
																									BgL_ev_globalz00_bgl))));
																					{	/* Eval/evaluate.scm 438 */
																						long BgL_arg2236z00_3896;

																						{	/* Eval/evaluate.scm 438 */
																							long BgL_res2941z00_3898;

																							BgL_res2941z00_3898 =
																								BGL_CLASS_INDEX
																								(BGl_ev_globalz00zz__evaluate_typesz00);
																							BgL_arg2236z00_3896 =
																								BgL_res2941z00_3898;
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1104z00_3895),
																							BgL_arg2236z00_3896);
																					}
																					BgL_new1105z00_3894 =
																						BgL_new1104z00_3895;
																				}
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1105z00_3894))->
																						BgL_locz00) =
																					((obj_t) BgL_locz00_74), BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1105z00_3894))->
																						BgL_namez00) =
																					((obj_t) BgL_carzd2252zd2_1544),
																					BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							COBJECT(BgL_new1105z00_3894))->
																						BgL_modz00) =
																					((obj_t)
																						BGl_evalzd2findzd2modulez00zz__evmodulez00
																						(BgL_carzd2257zd2_1548)), BUNSPEC);
																				return ((obj_t) BgL_new1105z00_3894);
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_carzd2302zd2_1552;

																				BgL_carzd2302zd2_1552 =
																					CAR(BgL_ez00_69);
																				if (SYMBOLP(BgL_carzd2302zd2_1552))
																					{	/* Eval/evaluate.scm 424 */
																						if (CBOOL
																							(BGl_convzd2varzd2zz__evaluatez00
																								(BgL_carzd2302zd2_1552,
																									BgL_localsz00_70)))
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5565;
																								BgL_funz00_1465 =
																									BgL_carzd2302zd2_1552;
																								BgL_argsz00_1466 =
																									BgL_cdrzd2249zd2_1540;
																							BgL_tagzd2152zd2_1467:
																								{	/* Eval/evaluate.scm 449 */
																									obj_t BgL_funz00_2349;
																									obj_t BgL_argsz00_2350;

																									{	/* Eval/evaluate.scm 380 */
																										obj_t BgL_arg2389z00_3510;

																										{	/* Eval/evaluate.scm 144 */
																											obj_t
																												BgL__ortest_1067z00_3511;
																											BgL__ortest_1067z00_3511 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_funz00_1465);
																											if (CBOOL
																												(BgL__ortest_1067z00_3511))
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2389z00_3510 =
																														BgL__ortest_1067z00_3511;
																												}
																											else
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2389z00_3510 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2349 =
																											BGl_convz00zz__evaluatez00
																											(BgL_funz00_1465,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2389z00_3510,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2350 =
																										BGl_loopze70ze7zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1466);
																									{	/* Eval/evaluate.scm 450 */
																										BgL_ev_appz00_bglt
																											BgL_new1107z00_2351;
																										{	/* Eval/evaluate.scm 451 */
																											BgL_ev_appz00_bglt
																												BgL_new1106z00_2352;
																											BgL_new1106z00_2352 =
																												((BgL_ev_appz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 451 */
																												long
																													BgL_arg2251z00_2353;
																												{	/* Eval/evaluate.scm 451 */
																													long
																														BgL_res2862z00_3513;
																													BgL_res2862z00_3513 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2251z00_2353 =
																														BgL_res2862z00_3513;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1106z00_2352),
																													BgL_arg2251z00_2353);
																											}
																											BgL_new1107z00_2351 =
																												BgL_new1106z00_2352;
																										}
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1107z00_2351))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1107z00_2351))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2349)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1107z00_2351))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2350),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1107z00_2351))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5565 =
																											BgL_new1107z00_2351;
																								}}
																								return
																									((obj_t) BgL_auxz00_5565);
																							}
																						else
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5581;
																								BgL_fz00_1531 =
																									BgL_carzd2302zd2_1552;
																								BgL_argsz00_1532 =
																									BgL_cdrzd2249zd2_1540;
																							BgL_tagzd2175zd2_1533:
																								{	/* Eval/evaluate.scm 597 */
																									obj_t BgL_funz00_2615;
																									obj_t BgL_argsz00_2616;

																									{	/* Eval/evaluate.scm 380 */
																										obj_t BgL_arg2389z00_3874;

																										{	/* Eval/evaluate.scm 144 */
																											obj_t
																												BgL__ortest_1067z00_3875;
																											BgL__ortest_1067z00_3875 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_fz00_1531);
																											if (CBOOL
																												(BgL__ortest_1067z00_3875))
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2389z00_3874 =
																														BgL__ortest_1067z00_3875;
																												}
																											else
																												{	/* Eval/evaluate.scm 144 */
																													BgL_arg2389z00_3874 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2615 =
																											BGl_convz00zz__evaluatez00
																											(BgL_fz00_1531,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2389z00_3874,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2616 =
																										BGl_loopze70ze7zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1532);
																									{	/* Eval/evaluate.scm 598 */
																										BgL_ev_appz00_bglt
																											BgL_new1160z00_2617;
																										{	/* Eval/evaluate.scm 599 */
																											BgL_ev_appz00_bglt
																												BgL_new1159z00_2618;
																											BgL_new1159z00_2618 =
																												((BgL_ev_appz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 599 */
																												long
																													BgL_arg2382z00_2619;
																												{	/* Eval/evaluate.scm 599 */
																													long
																														BgL_res2934z00_3877;
																													BgL_res2934z00_3877 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2382z00_2619 =
																														BgL_res2934z00_3877;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1159z00_2618),
																													BgL_arg2382z00_2619);
																											}
																											BgL_new1160z00_2617 =
																												BgL_new1159z00_2618;
																										}
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1160z00_2617))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1160z00_2617))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2615)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1160z00_2617))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2616),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													COBJECT
																													(BgL_new1160z00_2617))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5581 =
																											BgL_new1160z00_2617;
																								}}
																								return
																									((obj_t) BgL_auxz00_5581);
																							}
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5597;

																						{
																							obj_t BgL_argsz00_5599;
																							obj_t BgL_fz00_5598;

																							BgL_fz00_5598 =
																								BgL_carzd2302zd2_1552;
																							BgL_argsz00_5599 =
																								BgL_cdrzd2249zd2_1540;
																							BgL_argsz00_1532 =
																								BgL_argsz00_5599;
																							BgL_fz00_1531 = BgL_fz00_5598;
																							goto BgL_tagzd2175zd2_1533;
																						}
																						return ((obj_t) BgL_auxz00_5597);
																					}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_carzd21005zd2_1563;

																		BgL_carzd21005zd2_1563 = CAR(BgL_ez00_69);
																		if (SYMBOLP(BgL_carzd21005zd2_1563))
																			{	/* Eval/evaluate.scm 424 */
																				if (CBOOL
																					(BGl_convzd2varzd2zz__evaluatez00
																						(BgL_carzd21005zd2_1563,
																							BgL_localsz00_70)))
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5607;

																						{
																							obj_t BgL_argsz00_5609;
																							obj_t BgL_funz00_5608;

																							BgL_funz00_5608 =
																								BgL_carzd21005zd2_1563;
																							BgL_argsz00_5609 =
																								BgL_cdrzd2249zd2_1540;
																							BgL_argsz00_1466 =
																								BgL_argsz00_5609;
																							BgL_funz00_1465 = BgL_funz00_5608;
																							goto BgL_tagzd2152zd2_1467;
																						}
																						return ((obj_t) BgL_auxz00_5607);
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5611;

																						{
																							obj_t BgL_argsz00_5613;
																							obj_t BgL_fz00_5612;

																							BgL_fz00_5612 =
																								BgL_carzd21005zd2_1563;
																							BgL_argsz00_5613 =
																								BgL_cdrzd2249zd2_1540;
																							BgL_argsz00_1532 =
																								BgL_argsz00_5613;
																							BgL_fz00_1531 = BgL_fz00_5612;
																							goto BgL_tagzd2175zd2_1533;
																						}
																						return ((obj_t) BgL_auxz00_5611);
																					}
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5615;

																				{
																					obj_t BgL_argsz00_5617;
																					obj_t BgL_fz00_5616;

																					BgL_fz00_5616 =
																						BgL_carzd21005zd2_1563;
																					BgL_argsz00_5617 =
																						BgL_cdrzd2249zd2_1540;
																					BgL_argsz00_1532 = BgL_argsz00_5617;
																					BgL_fz00_1531 = BgL_fz00_5616;
																					goto BgL_tagzd2175zd2_1533;
																				}
																				return ((obj_t) BgL_auxz00_5615);
																			}
																	}
															}
														else
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_carzd21708zd2_1573;

																BgL_carzd21708zd2_1573 = CAR(BgL_ez00_69);
																if (SYMBOLP(BgL_carzd21708zd2_1573))
																	{	/* Eval/evaluate.scm 424 */
																		if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																				(BgL_carzd21708zd2_1573,
																					BgL_localsz00_70)))
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5625;

																				{
																					obj_t BgL_argsz00_5627;
																					obj_t BgL_funz00_5626;

																					BgL_funz00_5626 =
																						BgL_carzd21708zd2_1573;
																					BgL_argsz00_5627 =
																						BgL_cdrzd2249zd2_1540;
																					BgL_argsz00_1466 = BgL_argsz00_5627;
																					BgL_funz00_1465 = BgL_funz00_5626;
																					goto BgL_tagzd2152zd2_1467;
																				}
																				return ((obj_t) BgL_auxz00_5625);
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5629;

																				{
																					obj_t BgL_argsz00_5631;
																					obj_t BgL_fz00_5630;

																					BgL_fz00_5630 =
																						BgL_carzd21708zd2_1573;
																					BgL_argsz00_5631 =
																						BgL_cdrzd2249zd2_1540;
																					BgL_argsz00_1532 = BgL_argsz00_5631;
																					BgL_fz00_1531 = BgL_fz00_5630;
																					goto BgL_tagzd2175zd2_1533;
																				}
																				return ((obj_t) BgL_auxz00_5629);
																			}
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5633;

																		{
																			obj_t BgL_argsz00_5635;
																			obj_t BgL_fz00_5634;

																			BgL_fz00_5634 = BgL_carzd21708zd2_1573;
																			BgL_argsz00_5635 = BgL_cdrzd2249zd2_1540;
																			BgL_argsz00_1532 = BgL_argsz00_5635;
																			BgL_fz00_1531 = BgL_fz00_5634;
																			goto BgL_tagzd2175zd2_1533;
																		}
																		return ((obj_t) BgL_auxz00_5633);
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 424 */
														obj_t BgL_carzd22411zd2_1583;

														BgL_carzd22411zd2_1583 = CAR(BgL_ez00_69);
														if (SYMBOLP(BgL_carzd22411zd2_1583))
															{	/* Eval/evaluate.scm 424 */
																if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																		(BgL_carzd22411zd2_1583, BgL_localsz00_70)))
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5643;

																		{
																			obj_t BgL_argsz00_5645;
																			obj_t BgL_funz00_5644;

																			BgL_funz00_5644 = BgL_carzd22411zd2_1583;
																			BgL_argsz00_5645 = BgL_cdrzd2249zd2_1540;
																			BgL_argsz00_1466 = BgL_argsz00_5645;
																			BgL_funz00_1465 = BgL_funz00_5644;
																			goto BgL_tagzd2152zd2_1467;
																		}
																		return ((obj_t) BgL_auxz00_5643);
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5647;

																		{
																			obj_t BgL_argsz00_5649;
																			obj_t BgL_fz00_5648;

																			BgL_fz00_5648 = BgL_carzd22411zd2_1583;
																			BgL_argsz00_5649 = BgL_cdrzd2249zd2_1540;
																			BgL_argsz00_1532 = BgL_argsz00_5649;
																			BgL_fz00_1531 = BgL_fz00_5648;
																			goto BgL_tagzd2175zd2_1533;
																		}
																		return ((obj_t) BgL_auxz00_5647);
																	}
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5651;

																{
																	obj_t BgL_argsz00_5653;
																	obj_t BgL_fz00_5652;

																	BgL_fz00_5652 = BgL_carzd22411zd2_1583;
																	BgL_argsz00_5653 = BgL_cdrzd2249zd2_1540;
																	BgL_argsz00_1532 = BgL_argsz00_5653;
																	BgL_fz00_1531 = BgL_fz00_5652;
																	goto BgL_tagzd2175zd2_1533;
																}
																return ((obj_t) BgL_auxz00_5651);
															}
													}
											}
										else
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd23114zd2_1593;

												BgL_carzd23114zd2_1593 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23114zd2_1593))
													{	/* Eval/evaluate.scm 424 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23114zd2_1593, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5661;

																{
																	obj_t BgL_argsz00_5663;
																	obj_t BgL_funz00_5662;

																	BgL_funz00_5662 = BgL_carzd23114zd2_1593;
																	BgL_argsz00_5663 = BgL_cdrzd2249zd2_1540;
																	BgL_argsz00_1466 = BgL_argsz00_5663;
																	BgL_funz00_1465 = BgL_funz00_5662;
																	goto BgL_tagzd2152zd2_1467;
																}
																return ((obj_t) BgL_auxz00_5661);
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5665;

																{
																	obj_t BgL_argsz00_5667;
																	obj_t BgL_fz00_5666;

																	BgL_fz00_5666 = BgL_carzd23114zd2_1593;
																	BgL_argsz00_5667 = BgL_cdrzd2249zd2_1540;
																	BgL_argsz00_1532 = BgL_argsz00_5667;
																	BgL_fz00_1531 = BgL_fz00_5666;
																	goto BgL_tagzd2175zd2_1533;
																}
																return ((obj_t) BgL_auxz00_5665);
															}
													}
												else
													{
														BgL_ev_appz00_bglt BgL_auxz00_5669;

														{
															obj_t BgL_argsz00_5671;
															obj_t BgL_fz00_5670;

															BgL_fz00_5670 = BgL_carzd23114zd2_1593;
															BgL_argsz00_5671 = BgL_cdrzd2249zd2_1540;
															BgL_argsz00_1532 = BgL_argsz00_5671;
															BgL_fz00_1531 = BgL_fz00_5670;
															goto BgL_tagzd2175zd2_1533;
														}
														return ((obj_t) BgL_auxz00_5669);
													}
											}
									}
								else
									{	/* Eval/evaluate.scm 424 */
										if ((CAR(BgL_ez00_69) == BGl_symbol3241z00zz__evaluatez00))
											{	/* Eval/evaluate.scm 424 */
												BgL_lz00_1463 = BgL_cdrzd2249zd2_1540;
												{	/* Eval/evaluate.scm 442 */
													bool_t BgL_testz00_5676;

													if (PAIRP(BgL_lz00_1463))
														{	/* Eval/evaluate.scm 442 */
															bool_t BgL_testz00_5679;

															{	/* Eval/evaluate.scm 442 */
																obj_t BgL_tmpz00_5680;

																BgL_tmpz00_5680 = CDR(BgL_lz00_1463);
																BgL_testz00_5679 = PAIRP(BgL_tmpz00_5680);
															}
															if (BgL_testz00_5679)
																{
																	obj_t BgL_l1209z00_2340;

																	BgL_l1209z00_2340 = BgL_lz00_1463;
																BgL_zc3anonymousza32246ze3z83_2341:
																	if (NULLP(BgL_l1209z00_2340))
																		{	/* Eval/evaluate.scm 442 */
																			BgL_testz00_5676 = ((bool_t) 1);
																		}
																	else
																		{	/* Eval/evaluate.scm 442 */
																			bool_t BgL_testz00_5685;

																			{	/* Eval/evaluate.scm 442 */
																				obj_t BgL_tmpz00_5686;

																				BgL_tmpz00_5686 =
																					CAR(((obj_t) BgL_l1209z00_2340));
																				BgL_testz00_5685 =
																					SYMBOLP(BgL_tmpz00_5686);
																			}
																			if (BgL_testz00_5685)
																				{
																					obj_t BgL_l1209z00_5690;

																					BgL_l1209z00_5690 =
																						CDR(((obj_t) BgL_l1209z00_2340));
																					BgL_l1209z00_2340 = BgL_l1209z00_5690;
																					goto
																						BgL_zc3anonymousza32246ze3z83_2341;
																				}
																			else
																				{	/* Eval/evaluate.scm 442 */
																					BgL_testz00_5676 = ((bool_t) 0);
																				}
																		}
																}
															else
																{	/* Eval/evaluate.scm 442 */
																	BgL_testz00_5676 = ((bool_t) 0);
																}
														}
													else
														{	/* Eval/evaluate.scm 442 */
															BgL_testz00_5676 = ((bool_t) 0);
														}
													if (BgL_testz00_5676)
														{	/* Eval/evaluate.scm 442 */
															return
																BGl_convzd2fieldzd2refz00zz__evaluatez00
																(BgL_ez00_69, BgL_localsz00_70,
																BgL_globalsz00_71, BgL_tailzf3zf3_72,
																BgL_wherez00_73, BgL_locz00_74,
																BgL_topzf3zf3_75);
														}
													else
														{	/* Eval/evaluate.scm 442 */
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_74,
																BGl_string3156z00zz__evaluatez00,
																BGl_string3231z00zz__evaluatez00, BgL_ez00_69);
														}
												}
											}
										else
											{	/* Eval/evaluate.scm 424 */
												obj_t BgL_carzd23820zd2_1606;

												BgL_carzd23820zd2_1606 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23820zd2_1606))
													{	/* Eval/evaluate.scm 424 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23820zd2_1606, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5701;

																{
																	obj_t BgL_argsz00_5703;
																	obj_t BgL_funz00_5702;

																	BgL_funz00_5702 = BgL_carzd23820zd2_1606;
																	BgL_argsz00_5703 = BgL_cdrzd2249zd2_1540;
																	BgL_argsz00_1466 = BgL_argsz00_5703;
																	BgL_funz00_1465 = BgL_funz00_5702;
																	goto BgL_tagzd2152zd2_1467;
																}
																return ((obj_t) BgL_auxz00_5701);
															}
														else
															{	/* Eval/evaluate.scm 424 */
																if (
																	(BgL_carzd23820zd2_1606 ==
																		BGl_symbol3243z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 424 */
																		if (PAIRP(BgL_cdrzd2249zd2_1540))
																			{	/* Eval/evaluate.scm 424 */
																				if (NULLP(CDR(BgL_cdrzd2249zd2_1540)))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1600z00_1617;

																						BgL_arg1600z00_1617 =
																							CAR(BgL_cdrzd2249zd2_1540);
																						{	/* Eval/evaluate.scm 456 */
																							BgL_ev_trapz00_bglt
																								BgL_new1109z00_3947;
																							{	/* Eval/evaluate.scm 457 */
																								BgL_ev_trapz00_bglt
																									BgL_new1108z00_3948;
																								BgL_new1108z00_3948 =
																									((BgL_ev_trapz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_trapz00_bgl))));
																								{	/* Eval/evaluate.scm 457 */
																									long BgL_arg2252z00_3949;

																									{	/* Eval/evaluate.scm 457 */
																										long BgL_res2950z00_3951;

																										BgL_res2950z00_3951 =
																											BGL_CLASS_INDEX
																											(BGl_ev_trapz00zz__evaluate_typesz00);
																										BgL_arg2252z00_3949 =
																											BgL_res2950z00_3951;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1108z00_3948),
																										BgL_arg2252z00_3949);
																								}
																								BgL_new1109z00_3947 =
																									BgL_new1108z00_3948;
																							}
																							{
																								BgL_ev_exprz00_bglt
																									BgL_auxz00_5717;
																								{	/* Eval/evaluate.scm 380 */
																									obj_t BgL_arg2389z00_3954;

																									BgL_arg2389z00_3954 =
																										BGl_getzd2locationzd2zz__evaluatez00
																										(BgL_arg1600z00_1617,
																										BgL_locz00_74);
																									BgL_auxz00_5717 =
																										((BgL_ev_exprz00_bglt)
																										BGl_uconvzf2locze70z15zz__evaluatez00
																										(BgL_wherez00_73,
																											BgL_globalsz00_71,
																											BgL_localsz00_70,
																											BgL_arg1600z00_1617,
																											BgL_arg2389z00_3954));
																								}
																								((((BgL_ev_hookz00_bglt)
																											COBJECT((
																													(BgL_ev_hookz00_bglt)
																													BgL_new1109z00_3947)))->
																										BgL_ez00) =
																									((BgL_ev_exprz00_bglt)
																										BgL_auxz00_5717), BUNSPEC);
																							}
																							return
																								((obj_t) BgL_new1109z00_3947);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1601z00_1618;
																						obj_t BgL_arg1602z00_1619;

																						BgL_arg1601z00_1618 =
																							CAR(BgL_ez00_69);
																						BgL_arg1602z00_1619 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5726;
																							{
																								obj_t BgL_argsz00_5728;
																								obj_t BgL_fz00_5727;

																								BgL_fz00_5727 =
																									BgL_arg1601z00_1618;
																								BgL_argsz00_5728 =
																									BgL_arg1602z00_1619;
																								BgL_argsz00_1532 =
																									BgL_argsz00_5728;
																								BgL_fz00_1531 = BgL_fz00_5727;
																								goto BgL_tagzd2175zd2_1533;
																							}
																							return ((obj_t) BgL_auxz00_5726);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1605z00_1621;
																				obj_t BgL_arg1606z00_1622;

																				BgL_arg1605z00_1621 = CAR(BgL_ez00_69);
																				BgL_arg1606z00_1622 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_5732;

																					{
																						obj_t BgL_argsz00_5734;
																						obj_t BgL_fz00_5733;

																						BgL_fz00_5733 = BgL_arg1605z00_1621;
																						BgL_argsz00_5734 =
																							BgL_arg1606z00_1622;
																						BgL_argsz00_1532 = BgL_argsz00_5734;
																						BgL_fz00_1531 = BgL_fz00_5733;
																						goto BgL_tagzd2175zd2_1533;
																					}
																					return ((obj_t) BgL_auxz00_5732);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_cdrzd24489zd2_1623;

																		BgL_cdrzd24489zd2_1623 = CDR(BgL_ez00_69);
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol3208z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 424 */
																				if (PAIRP(BgL_cdrzd24489zd2_1623))
																					{	/* Eval/evaluate.scm 424 */
																						if (NULLP(CDR
																								(BgL_cdrzd24489zd2_1623)))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1612z00_1629;

																								BgL_arg1612z00_1629 =
																									CAR(BgL_cdrzd24489zd2_1623);
																								{	/* Eval/evaluate.scm 459 */
																									BgL_ev_littz00_bglt
																										BgL_new1111z00_3965;
																									{	/* Eval/evaluate.scm 460 */
																										BgL_ev_littz00_bglt
																											BgL_new1110z00_3966;
																										BgL_new1110z00_3966 =
																											((BgL_ev_littz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_littz00_bgl))));
																										{	/* Eval/evaluate.scm 460 */
																											long BgL_arg2253z00_3967;

																											{	/* Eval/evaluate.scm 460 */
																												long
																													BgL_res2953z00_3969;
																												BgL_res2953z00_3969 =
																													BGL_CLASS_INDEX
																													(BGl_ev_littz00zz__evaluate_typesz00);
																												BgL_arg2253z00_3967 =
																													BgL_res2953z00_3969;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1110z00_3966),
																												BgL_arg2253z00_3967);
																										}
																										BgL_new1111z00_3965 =
																											BgL_new1110z00_3966;
																									}
																									((((BgL_ev_littz00_bglt)
																												COBJECT
																												(BgL_new1111z00_3965))->
																											BgL_valuez00) =
																										((obj_t)
																											BgL_arg1612z00_1629),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1111z00_3965);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1613z00_1630;

																								BgL_arg1613z00_1630 =
																									CAR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5753;
																									{
																										obj_t BgL_argsz00_5755;
																										obj_t BgL_fz00_5754;

																										BgL_fz00_5754 =
																											BgL_arg1613z00_1630;
																										BgL_argsz00_5755 =
																											BgL_cdrzd24489zd2_1623;
																										BgL_argsz00_1532 =
																											BgL_argsz00_5755;
																										BgL_fz00_1531 =
																											BgL_fz00_5754;
																										goto BgL_tagzd2175zd2_1533;
																									}
																									return
																										((obj_t) BgL_auxz00_5753);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1616z00_1633;

																						BgL_arg1616z00_1633 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5758;
																							{
																								obj_t BgL_argsz00_5760;
																								obj_t BgL_fz00_5759;

																								BgL_fz00_5759 =
																									BgL_arg1616z00_1633;
																								BgL_argsz00_5760 =
																									BgL_cdrzd24489zd2_1623;
																								BgL_argsz00_1532 =
																									BgL_argsz00_5760;
																								BgL_fz00_1531 = BgL_fz00_5759;
																								goto BgL_tagzd2175zd2_1533;
																							}
																							return ((obj_t) BgL_auxz00_5758);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol3216z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 424 */
																						if (PAIRP(BgL_cdrzd24489zd2_1623))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_cdrzd25099zd2_1639;

																								BgL_cdrzd25099zd2_1639 =
																									CDR(BgL_cdrzd24489zd2_1623);
																								if (PAIRP
																									(BgL_cdrzd25099zd2_1639))
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd25104zd2_1641;
																										BgL_cdrzd25104zd2_1641 =
																											CDR
																											(BgL_cdrzd25099zd2_1639);
																										if (PAIRP
																											(BgL_cdrzd25104zd2_1641))
																											{	/* Eval/evaluate.scm 424 */
																												if (NULLP(CDR
																														(BgL_cdrzd25104zd2_1641)))
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1632z00_1645;
																														obj_t
																															BgL_arg1633z00_1646;
																														obj_t
																															BgL_arg1634z00_1647;
																														BgL_arg1632z00_1645
																															=
																															CAR
																															(BgL_cdrzd24489zd2_1623);
																														BgL_arg1633z00_1646
																															=
																															CAR
																															(BgL_cdrzd25099zd2_1639);
																														BgL_arg1634z00_1647
																															=
																															CAR
																															(BgL_cdrzd25104zd2_1641);
																														{
																															BgL_ev_ifz00_bglt
																																BgL_auxz00_5779;
																															BgL_pz00_1472 =
																																BgL_arg1632z00_1645;
																															BgL_tz00_1473 =
																																BgL_arg1633z00_1646;
																															BgL_oz00_1474 =
																																BgL_arg1634z00_1647;
																														BgL_tagzd2155zd2_1475:
																															{	/* Eval/evaluate.scm 462 */
																																BgL_ev_ifz00_bglt
																																	BgL_new1113z00_2360;
																																{	/* Eval/evaluate.scm 463 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1112z00_2364;
																																	BgL_new1112z00_2364
																																		=
																																		(
																																		(BgL_ev_ifz00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_ev_ifz00_bgl))));
																																	{	/* Eval/evaluate.scm 463 */
																																		long
																																			BgL_arg2257z00_2365;
																																		{	/* Eval/evaluate.scm 463 */
																																			long
																																				BgL_res2865z00_3533;
																																			BgL_res2865z00_3533
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_ev_ifz00zz__evaluate_typesz00);
																																			BgL_arg2257z00_2365
																																				=
																																				BgL_res2865z00_3533;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1112z00_2364), BgL_arg2257z00_2365);
																																	}
																																	BgL_new1113z00_2360
																																		=
																																		BgL_new1112z00_2364;
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5784;
																																	{	/* Eval/evaluate.scm 463 */
																																		obj_t
																																			BgL_arg2254z00_2361;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1067z00_3536;
																																			BgL__ortest_1067z00_3536
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_pz00_1472);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_3536))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2254z00_2361
																																						=
																																						BgL__ortest_1067z00_3536;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2254z00_2361
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5784
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_pz00_1472,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BFALSE,
																																				BgL_wherez00_73,
																																				BgL_arg2254z00_2361,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1113z00_2360))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5784), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5791;
																																	{	/* Eval/evaluate.scm 464 */
																																		obj_t
																																			BgL_arg2255z00_2362;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1067z00_3537;
																																			BgL__ortest_1067z00_3537
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_tz00_1473);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_3537))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2255z00_2362
																																						=
																																						BgL__ortest_1067z00_3537;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2255z00_2362
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5791
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_tz00_1473,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2255z00_2362,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1113z00_2360))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5791), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5798;
																																	{	/* Eval/evaluate.scm 465 */
																																		obj_t
																																			BgL_arg2256z00_2363;
																																		{	/* Eval/evaluate.scm 144 */
																																			obj_t
																																				BgL__ortest_1067z00_3538;
																																			BgL__ortest_1067z00_3538
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_oz00_1474);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_3538))
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2256z00_2363
																																						=
																																						BgL__ortest_1067z00_3538;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 144 */
																																					BgL_arg2256z00_2363
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5798
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_oz00_1474,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2256z00_2363,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1113z00_2360))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5798), BUNSPEC);
																																}
																																BgL_auxz00_5779
																																	=
																																	BgL_new1113z00_2360;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5779);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1635z00_1648;
																														obj_t
																															BgL_arg1636z00_1649;
																														BgL_arg1635z00_1648
																															=
																															CAR(BgL_ez00_69);
																														BgL_arg1636z00_1649
																															=
																															CDR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_5808;
																															{
																																obj_t
																																	BgL_argsz00_5810;
																																obj_t
																																	BgL_fz00_5809;
																																BgL_fz00_5809 =
																																	BgL_arg1635z00_1648;
																																BgL_argsz00_5810
																																	=
																																	BgL_arg1636z00_1649;
																																BgL_argsz00_1532
																																	=
																																	BgL_argsz00_5810;
																																BgL_fz00_1531 =
																																	BgL_fz00_5809;
																																goto
																																	BgL_tagzd2175zd2_1533;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5808);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_cdrzd25402zd2_1651;
																												BgL_cdrzd25402zd2_1651 =
																													CDR(BgL_ez00_69);
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_cdrzd25408zd2_1652;
																													BgL_cdrzd25408zd2_1652
																														=
																														CDR(((obj_t)
																															BgL_cdrzd25402zd2_1651));
																													if (NULLP(CDR(((obj_t)
																																	BgL_cdrzd25408zd2_1652))))
																														{	/* Eval/evaluate.scm 424 */
																															obj_t
																																BgL_arg1640z00_1655;
																															obj_t
																																BgL_arg1641z00_1656;
																															BgL_arg1640z00_1655
																																=
																																CAR(((obj_t)
																																	BgL_cdrzd25402zd2_1651));
																															BgL_arg1641z00_1656
																																=
																																CAR(((obj_t)
																																	BgL_cdrzd25408zd2_1652));
																															{
																																BgL_ev_ifz00_bglt
																																	BgL_auxz00_5823;
																																BgL_pz00_1476 =
																																	BgL_arg1640z00_1655;
																																BgL_tz00_1477 =
																																	BgL_arg1641z00_1656;
																															BgL_tagzd2156zd2_1478:
																																{	/* Eval/evaluate.scm 467 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1115z00_2366;
																																	{	/* Eval/evaluate.scm 468 */
																																		BgL_ev_ifz00_bglt
																																			BgL_new1114z00_2370;
																																		BgL_new1114z00_2370
																																			=
																																			(
																																			(BgL_ev_ifz00_bglt)
																																			BOBJECT
																																			(GC_MALLOC
																																				(sizeof
																																					(struct
																																						BgL_ev_ifz00_bgl))));
																																		{	/* Eval/evaluate.scm 468 */
																																			long
																																				BgL_arg2261z00_2371;
																																			{	/* Eval/evaluate.scm 468 */
																																				long
																																					BgL_res2866z00_3540;
																																				BgL_res2866z00_3540
																																					=
																																					BGL_CLASS_INDEX
																																					(BGl_ev_ifz00zz__evaluate_typesz00);
																																				BgL_arg2261z00_2371
																																					=
																																					BgL_res2866z00_3540;
																																			}
																																			BGL_OBJECT_CLASS_NUM_SET
																																				(((BgL_objectz00_bglt) BgL_new1114z00_2370), BgL_arg2261z00_2371);
																																		}
																																		BgL_new1115z00_2366
																																			=
																																			BgL_new1114z00_2370;
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5828;
																																		{	/* Eval/evaluate.scm 468 */
																																			obj_t
																																				BgL_arg2258z00_2367;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1067z00_3543;
																																				BgL__ortest_1067z00_3543
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_pz00_1476);
																																				if (CBOOL(BgL__ortest_1067z00_3543))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2258z00_2367
																																							=
																																							BgL__ortest_1067z00_3543;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2258z00_2367
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5828
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_pz00_1476,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BFALSE,
																																					BgL_wherez00_73,
																																					BgL_arg2258z00_2367,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1115z00_2366))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5828), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5835;
																																		{	/* Eval/evaluate.scm 469 */
																																			obj_t
																																				BgL_arg2259z00_2368;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1067z00_3544;
																																				BgL__ortest_1067z00_3544
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_tz00_1477);
																																				if (CBOOL(BgL__ortest_1067z00_3544))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2259z00_2368
																																							=
																																							BgL__ortest_1067z00_3544;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2259z00_2368
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5835
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_tz00_1477,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2259z00_2368,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1115z00_2366))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5835), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5842;
																																		{	/* Eval/evaluate.scm 470 */
																																			obj_t
																																				BgL_arg2260z00_2369;
																																			{	/* Eval/evaluate.scm 144 */
																																				obj_t
																																					BgL__ortest_1067z00_3545;
																																				BgL__ortest_1067z00_3545
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BFALSE);
																																				if (CBOOL(BgL__ortest_1067z00_3545))
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2260z00_2369
																																							=
																																							BgL__ortest_1067z00_3545;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 144 */
																																						BgL_arg2260z00_2369
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5842
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_ez00_69,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2260z00_2369,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1115z00_2366))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5842), BUNSPEC);
																																	}
																																	BgL_auxz00_5823
																																		=
																																		BgL_new1115z00_2366;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5823);
																															}
																														}
																													else
																														{	/* Eval/evaluate.scm 424 */
																															obj_t
																																BgL_arg1642z00_1657;
																															BgL_arg1642z00_1657
																																=
																																CAR
																																(BgL_ez00_69);
																															{
																																BgL_ev_appz00_bglt
																																	BgL_auxz00_5851;
																																{
																																	obj_t
																																		BgL_argsz00_5853;
																																	obj_t
																																		BgL_fz00_5852;
																																	BgL_fz00_5852
																																		=
																																		BgL_arg1642z00_1657;
																																	BgL_argsz00_5853
																																		=
																																		BgL_cdrzd25402zd2_1651;
																																	BgL_argsz00_1532
																																		=
																																		BgL_argsz00_5853;
																																	BgL_fz00_1531
																																		=
																																		BgL_fz00_5852;
																																	goto
																																		BgL_tagzd2175zd2_1533;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5851);
																															}
																														}
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t BgL_arg1648z00_1660;
																										obj_t BgL_arg1649z00_1661;

																										BgL_arg1648z00_1660 =
																											CAR(BgL_ez00_69);
																										BgL_arg1649z00_1661 =
																											CDR(BgL_ez00_69);
																										{
																											BgL_ev_appz00_bglt
																												BgL_auxz00_5857;
																											{
																												obj_t BgL_argsz00_5859;
																												obj_t BgL_fz00_5858;

																												BgL_fz00_5858 =
																													BgL_arg1648z00_1660;
																												BgL_argsz00_5859 =
																													BgL_arg1649z00_1661;
																												BgL_argsz00_1532 =
																													BgL_argsz00_5859;
																												BgL_fz00_1531 =
																													BgL_fz00_5858;
																												goto
																													BgL_tagzd2175zd2_1533;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_5857);
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1650z00_1662;
																								obj_t BgL_arg1652z00_1663;

																								BgL_arg1650z00_1662 =
																									CAR(BgL_ez00_69);
																								BgL_arg1652z00_1663 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5863;
																									{
																										obj_t BgL_argsz00_5865;
																										obj_t BgL_fz00_5864;

																										BgL_fz00_5864 =
																											BgL_arg1650z00_1662;
																										BgL_argsz00_5865 =
																											BgL_arg1652z00_1663;
																										BgL_argsz00_1532 =
																											BgL_argsz00_5865;
																										BgL_fz00_1531 =
																											BgL_fz00_5864;
																										goto BgL_tagzd2175zd2_1533;
																									}
																									return
																										((obj_t) BgL_auxz00_5863);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol3245z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1657z00_1666;

																								BgL_arg1657z00_1666 =
																									CDR(BgL_ez00_69);
																								{	/* Eval/evaluate.scm 472 */
																									BgL_ev_orz00_bglt
																										BgL_new1118z00_4004;
																									{	/* Eval/evaluate.scm 473 */
																										BgL_ev_orz00_bglt
																											BgL_new1116z00_4005;
																										BgL_new1116z00_4005 =
																											((BgL_ev_orz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_orz00_bgl))));
																										{	/* Eval/evaluate.scm 473 */
																											long BgL_arg2262z00_4006;

																											{	/* Eval/evaluate.scm 473 */
																												long
																													BgL_res2959z00_4008;
																												BgL_res2959z00_4008 =
																													BGL_CLASS_INDEX
																													(BGl_ev_orz00zz__evaluate_typesz00);
																												BgL_arg2262z00_4006 =
																													BgL_res2959z00_4008;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1116z00_4005),
																												BgL_arg2262z00_4006);
																										}
																										BgL_new1118z00_4004 =
																											BgL_new1116z00_4005;
																									}
																									((((BgL_ev_listz00_bglt)
																												COBJECT((
																														(BgL_ev_listz00_bglt)
																														BgL_new1118z00_4004)))->
																											BgL_argsz00) =
																										((obj_t)
																											BGl_loopze70ze7zz__evaluatez00
																											(BgL_wherez00_73,
																												BgL_globalsz00_71,
																												BgL_localsz00_70,
																												BgL_locz00_74,
																												BgL_arg1657z00_1666)),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1118z00_4004);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol3247z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 424 */
																										obj_t BgL_arg1660z00_1669;

																										BgL_arg1660z00_1669 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 475 */
																											BgL_ev_andz00_bglt
																												BgL_new1120z00_4013;
																											{	/* Eval/evaluate.scm 476 */
																												BgL_ev_andz00_bglt
																													BgL_new1119z00_4014;
																												BgL_new1119z00_4014 =
																													((BgL_ev_andz00_bglt)
																													BOBJECT(GC_MALLOC
																														(sizeof(struct
																																BgL_ev_andz00_bgl))));
																												{	/* Eval/evaluate.scm 476 */
																													long
																														BgL_arg2263z00_4015;
																													{	/* Eval/evaluate.scm 476 */
																														long
																															BgL_res2960z00_4017;
																														BgL_res2960z00_4017
																															=
																															BGL_CLASS_INDEX
																															(BGl_ev_andz00zz__evaluate_typesz00);
																														BgL_arg2263z00_4015
																															=
																															BgL_res2960z00_4017;
																													}
																													BGL_OBJECT_CLASS_NUM_SET
																														(((BgL_objectz00_bglt) BgL_new1119z00_4014), BgL_arg2263z00_4015);
																												}
																												BgL_new1120z00_4013 =
																													BgL_new1119z00_4014;
																											}
																											((((BgL_ev_listz00_bglt)
																														COBJECT((
																																(BgL_ev_listz00_bglt)
																																BgL_new1120z00_4013)))->
																													BgL_argsz00) =
																												((obj_t)
																													BGl_loopze70ze7zz__evaluatez00
																													(BgL_wherez00_73,
																														BgL_globalsz00_71,
																														BgL_localsz00_70,
																														BgL_locz00_74,
																														BgL_arg1660z00_1669)),
																												BUNSPEC);
																											return ((obj_t)
																												BgL_new1120z00_4013);
																										}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										if (
																											(CAR(BgL_ez00_69) ==
																												BGl_symbol3232z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 424 */
																												return
																													BGl_convzd2beginzd2zz__evaluatez00
																													(CDR(BgL_ez00_69),
																													BgL_localsz00_70,
																													BgL_globalsz00_71,
																													BgL_tailzf3zf3_72,
																													BgL_wherez00_73,
																													BgL_locz00_74,
																													BgL_topzf3zf3_75);
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_cdrzd26301zd2_1673;
																												BgL_cdrzd26301zd2_1673 =
																													CDR(BgL_ez00_69);
																												if ((CAR(BgL_ez00_69) ==
																														BGl_symbol3218z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 424 */
																														if (PAIRP
																															(BgL_cdrzd26301zd2_1673))
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1669z00_1677;
																																obj_t
																																	BgL_arg1670z00_1678;
																																BgL_arg1669z00_1677
																																	=
																																	CAR
																																	(BgL_cdrzd26301zd2_1673);
																																BgL_arg1670z00_1678
																																	=
																																	CDR
																																	(BgL_cdrzd26301zd2_1673);
																																{
																																	BgL_ev_letz00_bglt
																																		BgL_auxz00_5904;
																																	BgL_bindsz00_1485
																																		=
																																		BgL_arg1669z00_1677;
																																	BgL_bodyz00_1486
																																		=
																																		BgL_arg1670z00_1678;
																																BgL_tagzd2160zd2_1487:
																																	{	/* Eval/evaluate.scm 480 */
																																		obj_t
																																			BgL_ubindsz00_2378;
																																		if (NULLP
																																			(BgL_bindsz00_1485))
																																			{	/* Eval/evaluate.scm 480 */
																																				BgL_ubindsz00_2378
																																					=
																																					BNIL;
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 480 */
																																				obj_t
																																					BgL_head1214z00_2423;
																																				{	/* Eval/evaluate.scm 480 */
																																					obj_t
																																						BgL_res2870z00_3561;
																																					BgL_res2870z00_3561
																																						=
																																						MAKE_YOUNG_PAIR
																																						(BNIL,
																																						BNIL);
																																					BgL_head1214z00_2423
																																						=
																																						BgL_res2870z00_3561;
																																				}
																																				{
																																					obj_t
																																						BgL_l1212z00_3589;
																																					obj_t
																																						BgL_tail1215z00_3590;
																																					BgL_l1212z00_3589
																																						=
																																						BgL_bindsz00_1485;
																																					BgL_tail1215z00_3590
																																						=
																																						BgL_head1214z00_2423;
																																				BgL_zc3anonymousza32284ze3z83_3588:
																																					if (NULLP(BgL_l1212z00_3589))
																																						{	/* Eval/evaluate.scm 480 */
																																							BgL_ubindsz00_2378
																																								=
																																								CDR
																																								(BgL_head1214z00_2423);
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 480 */
																																							obj_t
																																								BgL_newtail1216z00_3598;
																																							{	/* Eval/evaluate.scm 480 */
																																								obj_t
																																									BgL_arg2287z00_3599;
																																								{	/* Eval/evaluate.scm 480 */
																																									obj_t
																																										BgL_bz00_3600;
																																									BgL_bz00_3600
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_l1212z00_3589));
																																									{	/* Eval/evaluate.scm 480 */
																																										obj_t
																																											BgL_arg2288z00_3601;
																																										BgL_arg2288z00_3601
																																											=
																																											CAR
																																											(
																																											((obj_t) BgL_bz00_3600));
																																										BgL_arg2287z00_3599
																																											=
																																											BGl_untypezd2identzd2zz__evaluatez00
																																											(BgL_arg2288z00_3601);
																																									}
																																								}
																																								{	/* Eval/evaluate.scm 480 */
																																									obj_t
																																										BgL_res2876z00_3607;
																																									BgL_res2876z00_3607
																																										=
																																										MAKE_YOUNG_PAIR
																																										(BgL_arg2287z00_3599,
																																										BNIL);
																																									BgL_newtail1216z00_3598
																																										=
																																										BgL_res2876z00_3607;
																																								}
																																							}
																																							SET_CDR
																																								(BgL_tail1215z00_3590,
																																								BgL_newtail1216z00_3598);
																																							{	/* Eval/evaluate.scm 480 */
																																								obj_t
																																									BgL_arg2286z00_3602;
																																								BgL_arg2286z00_3602
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_l1212z00_3589));
																																								{
																																									obj_t
																																										BgL_tail1215z00_5921;
																																									obj_t
																																										BgL_l1212z00_5920;
																																									BgL_l1212z00_5920
																																										=
																																										BgL_arg2286z00_3602;
																																									BgL_tail1215z00_5921
																																										=
																																										BgL_newtail1216z00_3598;
																																									BgL_tail1215z00_3590
																																										=
																																										BgL_tail1215z00_5921;
																																									BgL_l1212z00_3589
																																										=
																																										BgL_l1212z00_5920;
																																									goto
																																										BgL_zc3anonymousza32284ze3z83_3588;
																																								}
																																							}
																																						}
																																				}
																																			}
																																		{	/* Eval/evaluate.scm 480 */
																																			obj_t
																																				BgL_varsz00_2379;
																																			if (NULLP
																																				(BgL_ubindsz00_2378))
																																				{	/* Eval/evaluate.scm 481 */
																																					BgL_varsz00_2379
																																						=
																																						BNIL;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 481 */
																																					obj_t
																																						BgL_head1219z00_2407;
																																					{	/* Eval/evaluate.scm 481 */
																																						obj_t
																																							BgL_res2878z00_3611;
																																						BgL_res2878z00_3611
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_head1219z00_2407
																																							=
																																							BgL_res2878z00_3611;
																																					}
																																					{
																																						obj_t
																																							BgL_l1217z00_2409;
																																						obj_t
																																							BgL_tail1220z00_2410;
																																						BgL_l1217z00_2409
																																							=
																																							BgL_ubindsz00_2378;
																																						BgL_tail1220z00_2410
																																							=
																																							BgL_head1219z00_2407;
																																					BgL_zc3anonymousza32278ze3z83_2411:
																																						if (NULLP(BgL_l1217z00_2409))
																																							{	/* Eval/evaluate.scm 481 */
																																								BgL_varsz00_2379
																																									=
																																									CDR
																																									(BgL_head1219z00_2407);
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 481 */
																																								obj_t
																																									BgL_newtail1221z00_2413;
																																								{	/* Eval/evaluate.scm 481 */
																																									BgL_ev_varz00_bglt
																																										BgL_arg2281z00_2415;
																																									{	/* Eval/evaluate.scm 481 */
																																										obj_t
																																											BgL_iz00_2416;
																																										BgL_iz00_2416
																																											=
																																											CAR
																																											(
																																											((obj_t) BgL_l1217z00_2409));
																																										{	/* Eval/evaluate.scm 482 */
																																											BgL_ev_varz00_bglt
																																												BgL_new1122z00_2417;
																																											{	/* Eval/evaluate.scm 484 */
																																												BgL_ev_varz00_bglt
																																													BgL_new1121z00_2418;
																																												BgL_new1121z00_2418
																																													=
																																													(
																																													(BgL_ev_varz00_bglt)
																																													BOBJECT
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_varz00_bgl))));
																																												{	/* Eval/evaluate.scm 484 */
																																													long
																																														BgL_arg2282z00_2419;
																																													{	/* Eval/evaluate.scm 484 */
																																														long
																																															BgL_res2880z00_3616;
																																														BgL_res2880z00_3616
																																															=
																																															BGL_CLASS_INDEX
																																															(BGl_ev_varz00zz__evaluate_typesz00);
																																														BgL_arg2282z00_2419
																																															=
																																															BgL_res2880z00_3616;
																																													}
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1121z00_2418), BgL_arg2282z00_2419);
																																												}
																																												BgL_new1122z00_2417
																																													=
																																													BgL_new1121z00_2418;
																																											}
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1122z00_2417))->BgL_namez00) = ((obj_t) CAR(((obj_t) BgL_iz00_2416))), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1122z00_2417))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) COBJECT(BgL_new1122z00_2417))->BgL_typez00) = ((obj_t) CDR(((obj_t) BgL_iz00_2416))), BUNSPEC);
																																											BgL_arg2281z00_2415
																																												=
																																												BgL_new1122z00_2417;
																																									}}
																																									{	/* Eval/evaluate.scm 481 */
																																										obj_t
																																											BgL_res2881z00_3621;
																																										BgL_res2881z00_3621
																																											=
																																											MAKE_YOUNG_PAIR
																																											(
																																											((obj_t) BgL_arg2281z00_2415), BNIL);
																																										BgL_newtail1221z00_2413
																																											=
																																											BgL_res2881z00_3621;
																																								}}
																																								SET_CDR
																																									(BgL_tail1220z00_2410,
																																									BgL_newtail1221z00_2413);
																																								{	/* Eval/evaluate.scm 481 */
																																									obj_t
																																										BgL_arg2280z00_2414;
																																									BgL_arg2280z00_2414
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_l1217z00_2409));
																																									{
																																										obj_t
																																											BgL_tail1220z00_5947;
																																										obj_t
																																											BgL_l1217z00_5946;
																																										BgL_l1217z00_5946
																																											=
																																											BgL_arg2280z00_2414;
																																										BgL_tail1220z00_5947
																																											=
																																											BgL_newtail1221z00_2413;
																																										BgL_tail1220z00_2410
																																											=
																																											BgL_tail1220z00_5947;
																																										BgL_l1217z00_2409
																																											=
																																											BgL_l1217z00_5946;
																																										goto
																																											BgL_zc3anonymousza32278ze3z83_2411;
																																									}
																																								}
																																							}
																																					}
																																				}
																																			{	/* Eval/evaluate.scm 481 */
																																				obj_t
																																					BgL_bodyz00_2380;
																																				{	/* Eval/evaluate.scm 486 */
																																					bool_t
																																						BgL_testz00_5948;
																																					{	/* Eval/evaluate.scm 486 */
																																						obj_t
																																							BgL_tmpz00_5949;
																																						BgL_tmpz00_5949
																																							=
																																							CDR
																																							(((obj_t) BgL_bodyz00_1486));
																																						BgL_testz00_5948
																																							=
																																							PAIRP
																																							(BgL_tmpz00_5949);
																																					}
																																					if (BgL_testz00_5948)
																																						{	/* Eval/evaluate.scm 486 */
																																							obj_t
																																								BgL_res2883z00_3627;
																																							BgL_res2883z00_3627
																																								=
																																								MAKE_YOUNG_EPAIR
																																								(BGl_symbol3232z00zz__evaluatez00,
																																								BgL_bodyz00_1486,
																																								BgL_locz00_74);
																																							BgL_bodyz00_2380
																																								=
																																								BgL_res2883z00_3627;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 486 */
																																							BgL_bodyz00_2380
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_bodyz00_1486));
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 486 */
																																					obj_t
																																						BgL_tbodyz00_2381;
																																					BgL_tbodyz00_2381
																																						=
																																						BGl_typezd2checkszd2zz__evaluatez00
																																						(BgL_ubindsz00_2378,
																																						BgL_bindsz00_1485,
																																						BgL_bodyz00_2380,
																																						BgL_locz00_74,
																																						BgL_wherez00_73);
																																					{	/* Eval/evaluate.scm 487 */

																																						{	/* Eval/evaluate.scm 488 */
																																							obj_t
																																								BgL_blocz00_2382;
																																							{	/* Eval/evaluate.scm 144 */
																																								obj_t
																																									BgL__ortest_1067z00_3629;
																																								BgL__ortest_1067z00_3629
																																									=
																																									BGl_getzd2sourcezd2locationz00zz__readerz00
																																									(BgL_bindsz00_1485);
																																								if (CBOOL(BgL__ortest_1067z00_3629))
																																									{	/* Eval/evaluate.scm 144 */
																																										BgL_blocz00_2382
																																											=
																																											BgL__ortest_1067z00_3629;
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 144 */
																																										BgL_blocz00_2382
																																											=
																																											BgL_locz00_74;
																																									}
																																							}
																																							{	/* Eval/evaluate.scm 489 */
																																								BgL_ev_letz00_bglt
																																									BgL_new1125z00_2383;
																																								{	/* Eval/evaluate.scm 490 */
																																									BgL_ev_letz00_bglt
																																										BgL_new1124z00_2400;
																																									BgL_new1124z00_2400
																																										=
																																										(
																																										(BgL_ev_letz00_bglt)
																																										BOBJECT
																																										(GC_MALLOC
																																											(sizeof
																																												(struct
																																													BgL_ev_letz00_bgl))));
																																									{	/* Eval/evaluate.scm 490 */
																																										long
																																											BgL_arg2273z00_2401;
																																										{	/* Eval/evaluate.scm 490 */
																																											long
																																												BgL_res2884z00_3631;
																																											BgL_res2884z00_3631
																																												=
																																												BGL_CLASS_INDEX
																																												(BGl_ev_letz00zz__evaluate_typesz00);
																																											BgL_arg2273z00_2401
																																												=
																																												BgL_res2884z00_3631;
																																										}
																																										BGL_OBJECT_CLASS_NUM_SET
																																											(
																																											((BgL_objectz00_bglt) BgL_new1124z00_2400), BgL_arg2273z00_2401);
																																									}
																																									BgL_new1125z00_2383
																																										=
																																										BgL_new1124z00_2400;
																																								}
																																								((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1125z00_2383)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2379), BUNSPEC);
																																								{
																																									obj_t
																																										BgL_auxz00_5966;
																																									if (NULLP(BgL_bindsz00_1485))
																																										{	/* Eval/evaluate.scm 491 */
																																											BgL_auxz00_5966
																																												=
																																												BNIL;
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 491 */
																																											obj_t
																																												BgL_head1224z00_2386;
																																											{	/* Eval/evaluate.scm 491 */
																																												obj_t
																																													BgL_res2886z00_3635;
																																												BgL_res2886z00_3635
																																													=
																																													MAKE_YOUNG_PAIR
																																													(BNIL,
																																													BNIL);
																																												BgL_head1224z00_2386
																																													=
																																													BgL_res2886z00_3635;
																																											}
																																											{
																																												obj_t
																																													BgL_l1222z00_2388;
																																												obj_t
																																													BgL_tail1225z00_2389;
																																												BgL_l1222z00_2388
																																													=
																																													BgL_bindsz00_1485;
																																												BgL_tail1225z00_2389
																																													=
																																													BgL_head1224z00_2386;
																																											BgL_zc3anonymousza32265ze3z83_2390:
																																												if (NULLP(BgL_l1222z00_2388))
																																													{	/* Eval/evaluate.scm 491 */
																																														BgL_auxz00_5966
																																															=
																																															CDR
																																															(BgL_head1224z00_2386);
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 491 */
																																														obj_t
																																															BgL_newtail1226z00_2392;
																																														{	/* Eval/evaluate.scm 491 */
																																															obj_t
																																																BgL_arg2269z00_2394;
																																															{	/* Eval/evaluate.scm 491 */
																																																obj_t
																																																	BgL_bz00_2395;
																																																BgL_bz00_2395
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_l1222z00_2388));
																																																{	/* Eval/evaluate.scm 492 */
																																																	obj_t
																																																		BgL_locz00_2396;
																																																	{	/* Eval/evaluate.scm 144 */
																																																		obj_t
																																																			BgL__ortest_1067z00_3639;
																																																		BgL__ortest_1067z00_3639
																																																			=
																																																			BGl_getzd2sourcezd2locationz00zz__readerz00
																																																			(BgL_bz00_2395);
																																																		if (CBOOL(BgL__ortest_1067z00_3639))
																																																			{	/* Eval/evaluate.scm 144 */
																																																				BgL_locz00_2396
																																																					=
																																																					BgL__ortest_1067z00_3639;
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 144 */
																																																				BgL_locz00_2396
																																																					=
																																																					BgL_blocz00_2382;
																																																			}
																																																	}
																																																	{	/* Eval/evaluate.scm 493 */
																																																		obj_t
																																																			BgL_arg2270z00_2397;
																																																		{	/* Eval/evaluate.scm 493 */
																																																			obj_t
																																																				BgL_pairz00_3643;
																																																			BgL_pairz00_3643
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_bz00_2395));
																																																			BgL_arg2270z00_2397
																																																				=
																																																				CAR
																																																				(BgL_pairz00_3643);
																																																		}
																																																		BgL_arg2269z00_2394
																																																			=
																																																			BGl_convz00zz__evaluatez00
																																																			(BgL_arg2270z00_2397,
																																																			BgL_localsz00_70,
																																																			BgL_globalsz00_71,
																																																			BFALSE,
																																																			BgL_wherez00_73,
																																																			BgL_locz00_2396,
																																																			((bool_t) 0));
																																																	}
																																																}
																																															}
																																															{	/* Eval/evaluate.scm 491 */
																																																obj_t
																																																	BgL_res2888z00_3644;
																																																BgL_res2888z00_3644
																																																	=
																																																	MAKE_YOUNG_PAIR
																																																	(BgL_arg2269z00_2394,
																																																	BNIL);
																																																BgL_newtail1226z00_2392
																																																	=
																																																	BgL_res2888z00_3644;
																																															}
																																														}
																																														SET_CDR
																																															(BgL_tail1225z00_2389,
																																															BgL_newtail1226z00_2392);
																																														{	/* Eval/evaluate.scm 491 */
																																															obj_t
																																																BgL_arg2267z00_2393;
																																															BgL_arg2267z00_2393
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_l1222z00_2388));
																																															{
																																																obj_t
																																																	BgL_tail1225z00_5988;
																																																obj_t
																																																	BgL_l1222z00_5987;
																																																BgL_l1222z00_5987
																																																	=
																																																	BgL_arg2267z00_2393;
																																																BgL_tail1225z00_5988
																																																	=
																																																	BgL_newtail1226z00_2392;
																																																BgL_tail1225z00_2389
																																																	=
																																																	BgL_tail1225z00_5988;
																																																BgL_l1222z00_2388
																																																	=
																																																	BgL_l1222z00_5987;
																																																goto
																																																	BgL_zc3anonymousza32265ze3z83_2390;
																																															}
																																														}
																																													}
																																											}
																																										}
																																									((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1125z00_2383)))->BgL_valsz00) = ((obj_t) BgL_auxz00_5966), BUNSPEC);
																																								}
																																								{
																																									BgL_ev_exprz00_bglt
																																										BgL_auxz00_5990;
																																									{	/* Eval/evaluate.scm 495 */
																																										obj_t
																																											BgL_arg2272z00_2399;
																																										BgL_arg2272z00_2399
																																											=
																																											BGl_appendzd221011zd2zz__evaluatez00
																																											(BgL_varsz00_2379,
																																											BgL_localsz00_70);
																																										BgL_auxz00_5990
																																											=
																																											(
																																											(BgL_ev_exprz00_bglt)
																																											BGl_convz00zz__evaluatez00
																																											(BgL_tbodyz00_2381,
																																												BgL_arg2272z00_2399,
																																												BgL_globalsz00_71,
																																												BgL_tailzf3zf3_72,
																																												BgL_wherez00_73,
																																												BgL_locz00_74,
																																												((bool_t) 0)));
																																									}
																																									((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1125z00_2383)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5990), BUNSPEC);
																																								}
																																								((((BgL_ev_letz00_bglt) COBJECT(BgL_new1125z00_2383))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																								BgL_auxz00_5904
																																									=
																																									BgL_new1125z00_2383;
																																							}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5904);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1671z00_1679;
																																BgL_arg1671z00_1679
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_5999;
																																	{
																																		obj_t
																																			BgL_argsz00_6001;
																																		obj_t
																																			BgL_fz00_6000;
																																		BgL_fz00_6000
																																			=
																																			BgL_arg1671z00_1679;
																																		BgL_argsz00_6001
																																			=
																																			BgL_cdrzd26301zd2_1673;
																																		BgL_argsz00_1532
																																			=
																																			BgL_argsz00_6001;
																																		BgL_fz00_1531
																																			=
																																			BgL_fz00_6000;
																																		goto
																																			BgL_tagzd2175zd2_1533;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5999);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														if (
																															(CAR(BgL_ez00_69)
																																==
																																BGl_symbol3249z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 424 */
																																if (PAIRP
																																	(BgL_cdrzd26301zd2_1673))
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1676z00_1685;
																																		obj_t
																																			BgL_arg1677z00_1686;
																																		BgL_arg1676z00_1685
																																			=
																																			CAR
																																			(BgL_cdrzd26301zd2_1673);
																																		BgL_arg1677z00_1686
																																			=
																																			CDR
																																			(BgL_cdrzd26301zd2_1673);
																																		{
																																			BgL_ev_letza2za2_bglt
																																				BgL_auxz00_6010;
																																			BgL_bindsz00_1488
																																				=
																																				BgL_arg1676z00_1685;
																																			BgL_bodyz00_1489
																																				=
																																				BgL_arg1677z00_1686;
																																		BgL_tagzd2161zd2_1490:
																																			{	/* Eval/evaluate.scm 503 */
																																				obj_t
																																					BgL_varsz00_2436;
																																				obj_t
																																					BgL_blocz00_2437;
																																				if (NULLP(BgL_bindsz00_1488))
																																					{	/* Eval/evaluate.scm 503 */
																																						BgL_varsz00_2436
																																							=
																																							BNIL;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 503 */
																																						obj_t
																																							BgL_head1229z00_2445;
																																						{	/* Eval/evaluate.scm 503 */
																																							obj_t
																																								BgL_res2891z00_3670;
																																							BgL_res2891z00_3670
																																								=
																																								MAKE_YOUNG_PAIR
																																								(BNIL,
																																								BNIL);
																																							BgL_head1229z00_2445
																																								=
																																								BgL_res2891z00_3670;
																																						}
																																						{
																																							obj_t
																																								BgL_l1227z00_2447;
																																							obj_t
																																								BgL_tail1230z00_2448;
																																							BgL_l1227z00_2447
																																								=
																																								BgL_bindsz00_1488;
																																							BgL_tail1230z00_2448
																																								=
																																								BgL_head1229z00_2445;
																																						BgL_zc3anonymousza32293ze3z83_2449:
																																							if (NULLP(BgL_l1227z00_2447))
																																								{	/* Eval/evaluate.scm 503 */
																																									BgL_varsz00_2436
																																										=
																																										CDR
																																										(BgL_head1229z00_2445);
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 503 */
																																									obj_t
																																										BgL_newtail1231z00_2451;
																																									{	/* Eval/evaluate.scm 503 */
																																										BgL_ev_varz00_bglt
																																											BgL_arg2296z00_2453;
																																										{	/* Eval/evaluate.scm 503 */
																																											obj_t
																																												BgL_bz00_2454;
																																											BgL_bz00_2454
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_l1227z00_2447));
																																											{	/* Eval/evaluate.scm 504 */
																																												obj_t
																																													BgL_iz00_2455;
																																												{	/* Eval/evaluate.scm 504 */
																																													obj_t
																																														BgL_arg2300z00_2459;
																																													BgL_arg2300z00_2459
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_bz00_2454));
																																													BgL_iz00_2455
																																														=
																																														BGl_untypezd2identzd2zz__evaluatez00
																																														(BgL_arg2300z00_2459);
																																												}
																																												{	/* Eval/evaluate.scm 505 */
																																													BgL_ev_varz00_bglt
																																														BgL_new1128z00_2456;
																																													{	/* Eval/evaluate.scm 507 */
																																														BgL_ev_varz00_bglt
																																															BgL_new1126z00_2457;
																																														BgL_new1126z00_2457
																																															=
																																															(
																																															(BgL_ev_varz00_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_varz00_bgl))));
																																														{	/* Eval/evaluate.scm 507 */
																																															long
																																																BgL_arg2299z00_2458;
																																															{	/* Eval/evaluate.scm 507 */
																																																long
																																																	BgL_res2893z00_3676;
																																																BgL_res2893z00_3676
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_varz00zz__evaluate_typesz00);
																																																BgL_arg2299z00_2458
																																																	=
																																																	BgL_res2893z00_3676;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1126z00_2457), BgL_arg2299z00_2458);
																																														}
																																														BgL_new1128z00_2456
																																															=
																																															BgL_new1126z00_2457;
																																													}
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1128z00_2456))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_2455)), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1128z00_2456))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) COBJECT(BgL_new1128z00_2456))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_2455)), BUNSPEC);
																																													BgL_arg2296z00_2453
																																														=
																																														BgL_new1128z00_2456;
																																										}}}
																																										{	/* Eval/evaluate.scm 503 */
																																											obj_t
																																												BgL_res2894z00_3681;
																																											BgL_res2894z00_3681
																																												=
																																												MAKE_YOUNG_PAIR
																																												(
																																												((obj_t) BgL_arg2296z00_2453), BNIL);
																																											BgL_newtail1231z00_2451
																																												=
																																												BgL_res2894z00_3681;
																																									}}
																																									SET_CDR
																																										(BgL_tail1230z00_2448,
																																										BgL_newtail1231z00_2451);
																																									{	/* Eval/evaluate.scm 503 */
																																										obj_t
																																											BgL_arg2295z00_2452;
																																										BgL_arg2295z00_2452
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_l1227z00_2447));
																																										{
																																											obj_t
																																												BgL_tail1230z00_6037;
																																											obj_t
																																												BgL_l1227z00_6036;
																																											BgL_l1227z00_6036
																																												=
																																												BgL_arg2295z00_2452;
																																											BgL_tail1230z00_6037
																																												=
																																												BgL_newtail1231z00_2451;
																																											BgL_tail1230z00_2448
																																												=
																																												BgL_tail1230z00_6037;
																																											BgL_l1227z00_2447
																																												=
																																												BgL_l1227z00_6036;
																																											goto
																																												BgL_zc3anonymousza32293ze3z83_2449;
																																										}
																																									}
																																								}
																																						}
																																					}
																																				{	/* Eval/evaluate.scm 144 */
																																					obj_t
																																						BgL__ortest_1067z00_3684;
																																					BgL__ortest_1067z00_3684
																																						=
																																						BGl_getzd2sourcezd2locationz00zz__readerz00
																																						(BgL_bindsz00_1488);
																																					if (CBOOL(BgL__ortest_1067z00_3684))
																																						{	/* Eval/evaluate.scm 144 */
																																							BgL_blocz00_2437
																																								=
																																								BgL__ortest_1067z00_3684;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 144 */
																																							BgL_blocz00_2437
																																								=
																																								BgL_locz00_74;
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 510 */
																																					BgL_ev_letza2za2_bglt
																																						BgL_new1130z00_2438;
																																					{	/* Eval/evaluate.scm 511 */
																																						BgL_ev_letza2za2_bglt
																																							BgL_new1129z00_2441;
																																						BgL_new1129z00_2441
																																							=
																																							(
																																							(BgL_ev_letza2za2_bglt)
																																							BOBJECT
																																							(GC_MALLOC
																																								(sizeof
																																									(struct
																																										BgL_ev_letza2za2_bgl))));
																																						{	/* Eval/evaluate.scm 511 */
																																							long
																																								BgL_arg2291z00_2442;
																																							{	/* Eval/evaluate.scm 511 */
																																								long
																																									BgL_res2895z00_3686;
																																								BgL_res2895z00_3686
																																									=
																																									BGL_CLASS_INDEX
																																									(BGl_ev_letza2za2zz__evaluate_typesz00);
																																								BgL_arg2291z00_2442
																																									=
																																									BgL_res2895z00_3686;
																																							}
																																							BGL_OBJECT_CLASS_NUM_SET
																																								(
																																								((BgL_objectz00_bglt) BgL_new1129z00_2441), BgL_arg2291z00_2442);
																																						}
																																						BgL_new1130z00_2438
																																							=
																																							BgL_new1129z00_2441;
																																					}
																																					((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1130z00_2438)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2436), BUNSPEC);
																																					((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1130z00_2438)))->BgL_valsz00) = ((obj_t) BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_bindsz00_1488, BgL_varsz00_2436, BgL_localsz00_70, BgL_blocz00_2437)), BUNSPEC);
																																					{
																																						BgL_ev_exprz00_bglt
																																							BgL_auxz00_6050;
																																						{	/* Eval/evaluate.scm 513 */
																																							obj_t
																																								BgL_arg2289z00_2439;
																																							{	/* Eval/evaluate.scm 513 */
																																								obj_t
																																									BgL_arg2290z00_2440;
																																								BgL_arg2290z00_2440
																																									=
																																									bgl_reverse
																																									(BgL_varsz00_2436);
																																								BgL_arg2289z00_2439
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_arg2290z00_2440,
																																									BgL_localsz00_70);
																																							}
																																							BgL_auxz00_6050
																																								=
																																								(
																																								(BgL_ev_exprz00_bglt)
																																								BGl_convzd2beginzd2zz__evaluatez00
																																								(BgL_bodyz00_1489,
																																									BgL_arg2289z00_2439,
																																									BgL_globalsz00_71,
																																									BgL_tailzf3zf3_72,
																																									BgL_wherez00_73,
																																									BgL_locz00_74,
																																									((bool_t) 0)));
																																						}
																																						((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1130z00_2438)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6050), BUNSPEC);
																																					}
																																					((((BgL_ev_letza2za2_bglt) COBJECT(BgL_new1130z00_2438))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																					BgL_auxz00_6010
																																						=
																																						BgL_new1130z00_2438;
																																			}}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6010);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1678z00_1687;
																																		obj_t
																																			BgL_arg1680z00_1688;
																																		BgL_arg1678z00_1687
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		BgL_arg1680z00_1688
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_6061;
																																			{
																																				obj_t
																																					BgL_argsz00_6063;
																																				obj_t
																																					BgL_fz00_6062;
																																				BgL_fz00_6062
																																					=
																																					BgL_arg1678z00_1687;
																																				BgL_argsz00_6063
																																					=
																																					BgL_arg1680z00_1688;
																																				BgL_argsz00_1532
																																					=
																																					BgL_argsz00_6063;
																																				BgL_fz00_1531
																																					=
																																					BgL_fz00_6062;
																																				goto
																																					BgL_tagzd2175zd2_1533;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6061);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_cdrzd26695zd2_1689;
																																BgL_cdrzd26695zd2_1689
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																if ((CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol3251z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 424 */
																																		if (PAIRP
																																			(BgL_cdrzd26695zd2_1689))
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_arg1684z00_1693;
																																				obj_t
																																					BgL_arg1685z00_1694;
																																				BgL_arg1684z00_1693
																																					=
																																					CAR
																																					(BgL_cdrzd26695zd2_1689);
																																				BgL_arg1685z00_1694
																																					=
																																					CDR
																																					(BgL_cdrzd26695zd2_1689);
																																				{
																																					BgL_ev_letrecz00_bglt
																																						BgL_auxz00_6073;
																																					BgL_bindsz00_1491
																																						=
																																						BgL_arg1684z00_1693;
																																					BgL_bodyz00_1492
																																						=
																																						BgL_arg1685z00_1694;
																																				BgL_tagzd2162zd2_1493:
																																					{	/* Eval/evaluate.scm 515 */
																																						obj_t
																																							BgL_ubindsz00_2477;
																																						if (NULLP(BgL_bindsz00_1491))
																																							{	/* Eval/evaluate.scm 515 */
																																								BgL_ubindsz00_2477
																																									=
																																									BNIL;
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 515 */
																																								obj_t
																																									BgL_head1234z00_2527;
																																								{	/* Eval/evaluate.scm 515 */
																																									obj_t
																																										BgL_res2897z00_3690;
																																									BgL_res2897z00_3690
																																										=
																																										MAKE_YOUNG_PAIR
																																										(BNIL,
																																										BNIL);
																																									BgL_head1234z00_2527
																																										=
																																										BgL_res2897z00_3690;
																																								}
																																								{
																																									obj_t
																																										BgL_l1232z00_3718;
																																									obj_t
																																										BgL_tail1235z00_3719;
																																									BgL_l1232z00_3718
																																										=
																																										BgL_bindsz00_1491;
																																									BgL_tail1235z00_3719
																																										=
																																										BgL_head1234z00_2527;
																																								BgL_zc3anonymousza32337ze3z83_3717:
																																									if (NULLP(BgL_l1232z00_3718))
																																										{	/* Eval/evaluate.scm 515 */
																																											BgL_ubindsz00_2477
																																												=
																																												CDR
																																												(BgL_head1234z00_2527);
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 515 */
																																											obj_t
																																												BgL_newtail1236z00_3727;
																																											{	/* Eval/evaluate.scm 515 */
																																												obj_t
																																													BgL_arg2340z00_3728;
																																												{	/* Eval/evaluate.scm 515 */
																																													obj_t
																																														BgL_bz00_3729;
																																													BgL_bz00_3729
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_l1232z00_3718));
																																													{	/* Eval/evaluate.scm 515 */
																																														obj_t
																																															BgL_arg2341z00_3730;
																																														BgL_arg2341z00_3730
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_bz00_3729));
																																														BgL_arg2340z00_3728
																																															=
																																															BGl_untypezd2identzd2zz__evaluatez00
																																															(BgL_arg2341z00_3730);
																																													}
																																												}
																																												{	/* Eval/evaluate.scm 515 */
																																													obj_t
																																														BgL_res2903z00_3736;
																																													BgL_res2903z00_3736
																																														=
																																														MAKE_YOUNG_PAIR
																																														(BgL_arg2340z00_3728,
																																														BNIL);
																																													BgL_newtail1236z00_3727
																																														=
																																														BgL_res2903z00_3736;
																																												}
																																											}
																																											SET_CDR
																																												(BgL_tail1235z00_3719,
																																												BgL_newtail1236z00_3727);
																																											{	/* Eval/evaluate.scm 515 */
																																												obj_t
																																													BgL_arg2339z00_3731;
																																												BgL_arg2339z00_3731
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_l1232z00_3718));
																																												{
																																													obj_t
																																														BgL_tail1235z00_6090;
																																													obj_t
																																														BgL_l1232z00_6089;
																																													BgL_l1232z00_6089
																																														=
																																														BgL_arg2339z00_3731;
																																													BgL_tail1235z00_6090
																																														=
																																														BgL_newtail1236z00_3727;
																																													BgL_tail1235z00_3719
																																														=
																																														BgL_tail1235z00_6090;
																																													BgL_l1232z00_3718
																																														=
																																														BgL_l1232z00_6089;
																																													goto
																																														BgL_zc3anonymousza32337ze3z83_3717;
																																												}
																																											}
																																										}
																																								}
																																							}
																																						{	/* Eval/evaluate.scm 515 */
																																							obj_t
																																								BgL_varsz00_2478;
																																							if (NULLP(BgL_ubindsz00_2477))
																																								{	/* Eval/evaluate.scm 516 */
																																									BgL_varsz00_2478
																																										=
																																										BNIL;
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 516 */
																																									obj_t
																																										BgL_head1239z00_2511;
																																									{	/* Eval/evaluate.scm 516 */
																																										obj_t
																																											BgL_res2905z00_3740;
																																										BgL_res2905z00_3740
																																											=
																																											MAKE_YOUNG_PAIR
																																											(BNIL,
																																											BNIL);
																																										BgL_head1239z00_2511
																																											=
																																											BgL_res2905z00_3740;
																																									}
																																									{
																																										obj_t
																																											BgL_l1237z00_2513;
																																										obj_t
																																											BgL_tail1240z00_2514;
																																										BgL_l1237z00_2513
																																											=
																																											BgL_ubindsz00_2477;
																																										BgL_tail1240z00_2514
																																											=
																																											BgL_head1239z00_2511;
																																									BgL_zc3anonymousza32331ze3z83_2515:
																																										if (NULLP(BgL_l1237z00_2513))
																																											{	/* Eval/evaluate.scm 516 */
																																												BgL_varsz00_2478
																																													=
																																													CDR
																																													(BgL_head1239z00_2511);
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 516 */
																																												obj_t
																																													BgL_newtail1241z00_2517;
																																												{	/* Eval/evaluate.scm 516 */
																																													BgL_ev_varz00_bglt
																																														BgL_arg2334z00_2519;
																																													{	/* Eval/evaluate.scm 516 */
																																														obj_t
																																															BgL_iz00_2520;
																																														BgL_iz00_2520
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_l1237z00_2513));
																																														{	/* Eval/evaluate.scm 517 */
																																															BgL_ev_varz00_bglt
																																																BgL_new1133z00_2521;
																																															{	/* Eval/evaluate.scm 519 */
																																																BgL_ev_varz00_bglt
																																																	BgL_new1132z00_2522;
																																																BgL_new1132z00_2522
																																																	=
																																																	(
																																																	(BgL_ev_varz00_bglt)
																																																	BOBJECT
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_varz00_bgl))));
																																																{	/* Eval/evaluate.scm 519 */
																																																	long
																																																		BgL_arg2335z00_2523;
																																																	{	/* Eval/evaluate.scm 519 */
																																																		long
																																																			BgL_res2907z00_3745;
																																																		BgL_res2907z00_3745
																																																			=
																																																			BGL_CLASS_INDEX
																																																			(BGl_ev_varz00zz__evaluate_typesz00);
																																																		BgL_arg2335z00_2523
																																																			=
																																																			BgL_res2907z00_3745;
																																																	}
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1132z00_2522), BgL_arg2335z00_2523);
																																																}
																																																BgL_new1133z00_2521
																																																	=
																																																	BgL_new1132z00_2522;
																																															}
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1133z00_2521))->BgL_namez00) = ((obj_t) CAR(((obj_t) BgL_iz00_2520))), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1133z00_2521))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) COBJECT(BgL_new1133z00_2521))->BgL_typez00) = ((obj_t) CDR(((obj_t) BgL_iz00_2520))), BUNSPEC);
																																															BgL_arg2334z00_2519
																																																=
																																																BgL_new1133z00_2521;
																																													}}
																																													{	/* Eval/evaluate.scm 516 */
																																														obj_t
																																															BgL_res2908z00_3750;
																																														BgL_res2908z00_3750
																																															=
																																															MAKE_YOUNG_PAIR
																																															(
																																															((obj_t) BgL_arg2334z00_2519), BNIL);
																																														BgL_newtail1241z00_2517
																																															=
																																															BgL_res2908z00_3750;
																																												}}
																																												SET_CDR
																																													(BgL_tail1240z00_2514,
																																													BgL_newtail1241z00_2517);
																																												{	/* Eval/evaluate.scm 516 */
																																													obj_t
																																														BgL_arg2333z00_2518;
																																													BgL_arg2333z00_2518
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_l1237z00_2513));
																																													{
																																														obj_t
																																															BgL_tail1240z00_6116;
																																														obj_t
																																															BgL_l1237z00_6115;
																																														BgL_l1237z00_6115
																																															=
																																															BgL_arg2333z00_2518;
																																														BgL_tail1240z00_6116
																																															=
																																															BgL_newtail1241z00_2517;
																																														BgL_tail1240z00_2514
																																															=
																																															BgL_tail1240z00_6116;
																																														BgL_l1237z00_2513
																																															=
																																															BgL_l1237z00_6115;
																																														goto
																																															BgL_zc3anonymousza32331ze3z83_2515;
																																													}
																																												}
																																											}
																																									}
																																								}
																																							{	/* Eval/evaluate.scm 516 */
																																								obj_t
																																									BgL_localsz00_2479;
																																								BgL_localsz00_2479
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_varsz00_2478,
																																									BgL_localsz00_70);
																																								{	/* Eval/evaluate.scm 521 */
																																									obj_t
																																										BgL_bodyz00_2480;
																																									{	/* Eval/evaluate.scm 522 */
																																										bool_t
																																											BgL_testz00_6118;
																																										{	/* Eval/evaluate.scm 522 */
																																											obj_t
																																												BgL_tmpz00_6119;
																																											BgL_tmpz00_6119
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_bodyz00_1492));
																																											BgL_testz00_6118
																																												=
																																												PAIRP
																																												(BgL_tmpz00_6119);
																																										}
																																										if (BgL_testz00_6118)
																																											{	/* Eval/evaluate.scm 522 */
																																												obj_t
																																													BgL_res2910z00_3756;
																																												BgL_res2910z00_3756
																																													=
																																													MAKE_YOUNG_EPAIR
																																													(BGl_symbol3232z00zz__evaluatez00,
																																													BgL_bodyz00_1492,
																																													BgL_locz00_74);
																																												BgL_bodyz00_2480
																																													=
																																													BgL_res2910z00_3756;
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 522 */
																																												BgL_bodyz00_2480
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_bodyz00_1492));
																																											}
																																									}
																																									{	/* Eval/evaluate.scm 522 */
																																										obj_t
																																											BgL_tbodyz00_2481;
																																										BgL_tbodyz00_2481
																																											=
																																											BGl_typezd2checkszd2zz__evaluatez00
																																											(BgL_ubindsz00_2477,
																																											BgL_bindsz00_1491,
																																											BgL_bodyz00_2480,
																																											BgL_locz00_74,
																																											BgL_wherez00_73);
																																										{	/* Eval/evaluate.scm 523 */
																																											obj_t
																																												BgL_blocz00_2482;
																																											{	/* Eval/evaluate.scm 144 */
																																												obj_t
																																													BgL__ortest_1067z00_3758;
																																												BgL__ortest_1067z00_3758
																																													=
																																													BGl_getzd2sourcezd2locationz00zz__readerz00
																																													(BgL_bindsz00_1491);
																																												if (CBOOL(BgL__ortest_1067z00_3758))
																																													{	/* Eval/evaluate.scm 144 */
																																														BgL_blocz00_2482
																																															=
																																															BgL__ortest_1067z00_3758;
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 144 */
																																														BgL_blocz00_2482
																																															=
																																															BgL_locz00_74;
																																													}
																																											}
																																											{	/* Eval/evaluate.scm 524 */

																																												{	/* Eval/evaluate.scm 525 */
																																													BgL_ev_letrecz00_bglt
																																														BgL_new1135z00_2483;
																																													{	/* Eval/evaluate.scm 526 */
																																														BgL_ev_letrecz00_bglt
																																															BgL_new1134z00_2504;
																																														BgL_new1134z00_2504
																																															=
																																															(
																																															(BgL_ev_letrecz00_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_letrecz00_bgl))));
																																														{	/* Eval/evaluate.scm 526 */
																																															long
																																																BgL_arg2326z00_2505;
																																															{	/* Eval/evaluate.scm 526 */
																																																long
																																																	BgL_res2911z00_3760;
																																																BgL_res2911z00_3760
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_letrecz00zz__evaluate_typesz00);
																																																BgL_arg2326z00_2505
																																																	=
																																																	BgL_res2911z00_3760;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1134z00_2504), BgL_arg2326z00_2505);
																																														}
																																														BgL_new1135z00_2483
																																															=
																																															BgL_new1134z00_2504;
																																													}
																																													((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1135z00_2483)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2478), BUNSPEC);
																																													{
																																														obj_t
																																															BgL_auxz00_6136;
																																														if (NULLP(BgL_bindsz00_1491))
																																															{	/* Eval/evaluate.scm 527 */
																																																BgL_auxz00_6136
																																																	=
																																																	BNIL;
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 527 */
																																																obj_t
																																																	BgL_head1244z00_2486;
																																																{	/* Eval/evaluate.scm 527 */
																																																	obj_t
																																																		BgL_res2913z00_3764;
																																																	BgL_res2913z00_3764
																																																		=
																																																		MAKE_YOUNG_PAIR
																																																		(BNIL,
																																																		BNIL);
																																																	BgL_head1244z00_2486
																																																		=
																																																		BgL_res2913z00_3764;
																																																}
																																																{
																																																	obj_t
																																																		BgL_l1242z00_2488;
																																																	obj_t
																																																		BgL_tail1245z00_2489;
																																																	BgL_l1242z00_2488
																																																		=
																																																		BgL_bindsz00_1491;
																																																	BgL_tail1245z00_2489
																																																		=
																																																		BgL_head1244z00_2486;
																																																BgL_zc3anonymousza32313ze3z83_2490:
																																																	if (NULLP(BgL_l1242z00_2488))
																																																		{	/* Eval/evaluate.scm 527 */
																																																			BgL_auxz00_6136
																																																				=
																																																				CDR
																																																				(BgL_head1244z00_2486);
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 527 */
																																																			obj_t
																																																				BgL_newtail1246z00_2492;
																																																			{	/* Eval/evaluate.scm 527 */
																																																				obj_t
																																																					BgL_arg2317z00_2494;
																																																				{	/* Eval/evaluate.scm 527 */
																																																					obj_t
																																																						BgL_bz00_2495;
																																																					BgL_bz00_2495
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_l1242z00_2488));
																																																					{	/* Eval/evaluate.scm 528 */
																																																						obj_t
																																																							BgL_arg2318z00_2496;
																																																						obj_t
																																																							BgL_arg2319z00_2497;
																																																						obj_t
																																																							BgL_arg2320z00_2498;
																																																						{	/* Eval/evaluate.scm 528 */
																																																							obj_t
																																																								BgL_pairz00_3771;
																																																							BgL_pairz00_3771
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_bz00_2495));
																																																							BgL_arg2318z00_2496
																																																								=
																																																								CAR
																																																								(BgL_pairz00_3771);
																																																						}
																																																						{	/* Eval/evaluate.scm 528 */
																																																							obj_t
																																																								BgL_arg2321z00_2499;
																																																							BgL_arg2321z00_2499
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_bz00_2495));
																																																							{	/* Eval/evaluate.scm 528 */
																																																								obj_t
																																																									BgL_list2322z00_2500;
																																																								{	/* Eval/evaluate.scm 528 */
																																																									obj_t
																																																										BgL_arg2323z00_2501;
																																																									{	/* Eval/evaluate.scm 528 */
																																																										obj_t
																																																											BgL_arg2324z00_2502;
																																																										BgL_arg2324z00_2502
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(BgL_wherez00_73,
																																																											BNIL);
																																																										BgL_arg2323z00_2501
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(BGl_symbol3234z00zz__evaluatez00,
																																																											BgL_arg2324z00_2502);
																																																									}
																																																									BgL_list2322z00_2500
																																																										=
																																																										MAKE_YOUNG_PAIR
																																																										(BgL_arg2321z00_2499,
																																																										BgL_arg2323z00_2501);
																																																								}
																																																								BgL_arg2319z00_2497
																																																									=
																																																									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																																																									(BgL_list2322z00_2500);
																																																							}
																																																						}
																																																						{	/* Eval/evaluate.scm 144 */
																																																							obj_t
																																																								BgL__ortest_1067z00_3773;
																																																							BgL__ortest_1067z00_3773
																																																								=
																																																								BGl_getzd2sourcezd2locationz00zz__readerz00
																																																								(BgL_bz00_2495);
																																																							if (CBOOL(BgL__ortest_1067z00_3773))
																																																								{	/* Eval/evaluate.scm 144 */
																																																									BgL_arg2320z00_2498
																																																										=
																																																										BgL__ortest_1067z00_3773;
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 144 */
																																																									BgL_arg2320z00_2498
																																																										=
																																																										BgL_blocz00_2482;
																																																								}
																																																						}
																																																						BgL_arg2317z00_2494
																																																							=
																																																							BGl_convz00zz__evaluatez00
																																																							(BgL_arg2318z00_2496,
																																																							BgL_localsz00_2479,
																																																							BgL_globalsz00_71,
																																																							BFALSE,
																																																							BgL_arg2319z00_2497,
																																																							BgL_arg2320z00_2498,
																																																							((bool_t) 0));
																																																					}
																																																				}
																																																				{	/* Eval/evaluate.scm 527 */
																																																					obj_t
																																																						BgL_res2915z00_3774;
																																																					BgL_res2915z00_3774
																																																						=
																																																						MAKE_YOUNG_PAIR
																																																						(BgL_arg2317z00_2494,
																																																						BNIL);
																																																					BgL_newtail1246z00_2492
																																																						=
																																																						BgL_res2915z00_3774;
																																																				}
																																																			}
																																																			SET_CDR
																																																				(BgL_tail1245z00_2489,
																																																				BgL_newtail1246z00_2492);
																																																			{	/* Eval/evaluate.scm 527 */
																																																				obj_t
																																																					BgL_arg2316z00_2493;
																																																				BgL_arg2316z00_2493
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_l1242z00_2488));
																																																				{
																																																					obj_t
																																																						BgL_tail1245z00_6164;
																																																					obj_t
																																																						BgL_l1242z00_6163;
																																																					BgL_l1242z00_6163
																																																						=
																																																						BgL_arg2316z00_2493;
																																																					BgL_tail1245z00_6164
																																																						=
																																																						BgL_newtail1246z00_2492;
																																																					BgL_tail1245z00_2489
																																																						=
																																																						BgL_tail1245z00_6164;
																																																					BgL_l1242z00_2488
																																																						=
																																																						BgL_l1242z00_6163;
																																																					goto
																																																						BgL_zc3anonymousza32313ze3z83_2490;
																																																				}
																																																			}
																																																		}
																																																}
																																															}
																																														((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1135z00_2483)))->BgL_valsz00) = ((obj_t) BgL_auxz00_6136), BUNSPEC);
																																													}
																																													((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt) BgL_new1135z00_2483)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convz00zz__evaluatez00(BgL_tbodyz00_2481, BgL_localsz00_2479, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													BgL_auxz00_6073
																																														=
																																														BgL_new1135z00_2483;
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_6073);
																																				}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_arg1686z00_1695;
																																				BgL_arg1686z00_1695
																																					=
																																					CAR
																																					(BgL_ez00_69);
																																				{
																																					BgL_ev_appz00_bglt
																																						BgL_auxz00_6172;
																																					{
																																						obj_t
																																							BgL_argsz00_6174;
																																						obj_t
																																							BgL_fz00_6173;
																																						BgL_fz00_6173
																																							=
																																							BgL_arg1686z00_1695;
																																						BgL_argsz00_6174
																																							=
																																							BgL_cdrzd26695zd2_1689;
																																						BgL_argsz00_1532
																																							=
																																							BgL_argsz00_6174;
																																						BgL_fz00_1531
																																							=
																																							BgL_fz00_6173;
																																						goto
																																							BgL_tagzd2175zd2_1533;
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_6172);
																																				}
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		if (
																																			(CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol3253z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 424 */
																																				if (PAIRP(BgL_cdrzd26695zd2_1689))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_carzd26869zd2_1701;
																																						obj_t
																																							BgL_cdrzd26870zd2_1702;
																																						BgL_carzd26869zd2_1701
																																							=
																																							CAR
																																							(BgL_cdrzd26695zd2_1689);
																																						BgL_cdrzd26870zd2_1702
																																							=
																																							CDR
																																							(BgL_cdrzd26695zd2_1689);
																																						if (PAIRP(BgL_carzd26869zd2_1701))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd26874zd2_1704;
																																								BgL_cdrzd26874zd2_1704
																																									=
																																									CDR
																																									(BgL_carzd26869zd2_1701);
																																								if ((CAR(BgL_carzd26869zd2_1701) == BGl_symbol3239z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd26874zd2_1704))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_carzd26877zd2_1708;
																																												obj_t
																																													BgL_cdrzd26878zd2_1709;
																																												BgL_carzd26877zd2_1708
																																													=
																																													CAR
																																													(BgL_cdrzd26874zd2_1704);
																																												BgL_cdrzd26878zd2_1709
																																													=
																																													CDR
																																													(BgL_cdrzd26874zd2_1704);
																																												if (SYMBOLP(BgL_carzd26877zd2_1708))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd26878zd2_1709))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_carzd26882zd2_1712;
																																																BgL_carzd26882zd2_1712
																																																	=
																																																	CAR
																																																	(BgL_cdrzd26878zd2_1709);
																																																if (SYMBOLP(BgL_carzd26882zd2_1712))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd26878zd2_1709)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (PAIRP(BgL_cdrzd26870zd2_1702))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						if (NULLP(CDR(BgL_cdrzd26870zd2_1702)))
																																																							{	/* Eval/evaluate.scm 424 */
																																																								obj_t
																																																									BgL_arg1704z00_1719;
																																																								BgL_arg1704z00_1719
																																																									=
																																																									CAR
																																																									(BgL_cdrzd26870zd2_1702);
																																																								{	/* Eval/evaluate.scm 531 */
																																																									BgL_ev_setglobalz00_bglt
																																																										BgL_new1137z00_4064;
																																																									{	/* Eval/evaluate.scm 535 */
																																																										BgL_ev_setglobalz00_bglt
																																																											BgL_new1136z00_4065;
																																																										BgL_new1136z00_4065
																																																											=
																																																											(
																																																											(BgL_ev_setglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_setglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 535 */
																																																											long
																																																												BgL_arg2342z00_4066;
																																																											{	/* Eval/evaluate.scm 535 */
																																																												long
																																																													BgL_res2973z00_4068;
																																																												BgL_res2973z00_4068
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2342z00_4066
																																																													=
																																																													BgL_res2973z00_4068;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1136z00_4065), BgL_arg2342z00_4066);
																																																										}
																																																										BgL_new1137z00_4064
																																																											=
																																																											BgL_new1136z00_4065;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6213;
																																																										{	/* Eval/evaluate.scm 380 */
																																																											obj_t
																																																												BgL_arg2389z00_4071;
																																																											BgL_arg2389z00_4071
																																																												=
																																																												BGl_getzd2locationzd2zz__evaluatez00
																																																												(BgL_arg1704z00_1719,
																																																												BgL_locz00_74);
																																																											BgL_auxz00_6213
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_uconvzf2locze70z15zz__evaluatez00
																																																												(BgL_wherez00_73,
																																																													BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_arg1704z00_1719,
																																																													BgL_arg2389z00_4071));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1137z00_4064)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6213), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1137z00_4064))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1137z00_4064))->BgL_namez00) = ((obj_t) BgL_carzd26877zd2_1708), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1137z00_4064))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd26882zd2_1712)), BUNSPEC);
																																																									return
																																																										(
																																																										(obj_t)
																																																										BgL_new1137z00_4064);
																																																								}
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 424 */
																																																								return
																																																									BGl_evcompilezd2errorzd2zz__evcompilez00
																																																									(BgL_locz00_74,
																																																									BGl_string3156z00zz__evaluatez00,
																																																									BGl_string3231z00zz__evaluatez00,
																																																									BgL_ez00_69);
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string3156z00zz__evaluatez00,
																																																							BGl_string3231z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_cdrzd26998zd2_1721;
																																																				BgL_cdrzd26998zd2_1721
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_cdrzd27002zd2_1722;
																																																					BgL_cdrzd27002zd2_1722
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd26998zd2_1721));
																																																					if (PAIRP(BgL_cdrzd27002zd2_1722))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							if (NULLP(CDR(BgL_cdrzd27002zd2_1722)))
																																																								{	/* Eval/evaluate.scm 424 */
																																																									obj_t
																																																										BgL_arg1709z00_1726;
																																																									obj_t
																																																										BgL_arg1710z00_1727;
																																																									BgL_arg1709z00_1726
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd26998zd2_1721));
																																																									BgL_arg1710z00_1727
																																																										=
																																																										CAR
																																																										(BgL_cdrzd27002zd2_1722);
																																																									{
																																																										BgL_ev_hookz00_bglt
																																																											BgL_auxz00_6237;
																																																										BgL_vz00_1501
																																																											=
																																																											BgL_arg1709z00_1726;
																																																										BgL_ez00_1502
																																																											=
																																																											BgL_arg1710z00_1727;
																																																									BgL_tagzd2165zd2_1503:
																																																										{	/* Eval/evaluate.scm 541 */
																																																											obj_t
																																																												BgL_cvz00_2568;
																																																											obj_t
																																																												BgL_ez00_2569;
																																																											BgL_cvz00_2568
																																																												=
																																																												BGl_convzd2varzd2zz__evaluatez00
																																																												(BgL_vz00_1501,
																																																												BgL_localsz00_70);
																																																											{	/* Eval/evaluate.scm 380 */
																																																												obj_t
																																																													BgL_arg2389z00_3793;
																																																												{	/* Eval/evaluate.scm 144 */
																																																													obj_t
																																																														BgL__ortest_1067z00_3794;
																																																													BgL__ortest_1067z00_3794
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_ez00_1502);
																																																													if (CBOOL(BgL__ortest_1067z00_3794))
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2389z00_3793
																																																																=
																																																																BgL__ortest_1067z00_3794;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2389z00_3793
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												BgL_ez00_2569
																																																													=
																																																													BGl_convz00zz__evaluatez00
																																																													(BgL_ez00_1502,
																																																													BgL_localsz00_70,
																																																													BgL_globalsz00_71,
																																																													BFALSE,
																																																													BgL_wherez00_73,
																																																													BgL_arg2389z00_3793,
																																																													((bool_t) 0));
																																																											}
																																																											if (CBOOL(BgL_cvz00_2568))
																																																												{	/* Eval/evaluate.scm 543 */
																																																													BgL_ev_setlocalz00_bglt
																																																														BgL_new1139z00_2570;
																																																													{	/* Eval/evaluate.scm 545 */
																																																														BgL_ev_setlocalz00_bglt
																																																															BgL_new1138z00_2571;
																																																														BgL_new1138z00_2571
																																																															=
																																																															(
																																																															(BgL_ev_setlocalz00_bglt)
																																																															BOBJECT
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setlocalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 545 */
																																																															long
																																																																BgL_arg2357z00_2572;
																																																															{	/* Eval/evaluate.scm 545 */
																																																																long
																																																																	BgL_res2921z00_3796;
																																																																BgL_res2921z00_3796
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setlocalz00zz__evaluate_typesz00);
																																																																BgL_arg2357z00_2572
																																																																	=
																																																																	BgL_res2921z00_3796;
																																																															}
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1138z00_2571), BgL_arg2357z00_2572);
																																																														}
																																																														BgL_new1139z00_2570
																																																															=
																																																															BgL_new1138z00_2571;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1139z00_2570)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2569)), BUNSPEC);
																																																													((((BgL_ev_setlocalz00_bglt) COBJECT(BgL_new1139z00_2570))->BgL_vz00) = ((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_cvz00_2568)), BUNSPEC);
																																																													BgL_auxz00_6237
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1139z00_2570);
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 546 */
																																																													BgL_ev_setglobalz00_bglt
																																																														BgL_new1141z00_2573;
																																																													{	/* Eval/evaluate.scm 550 */
																																																														BgL_ev_setglobalz00_bglt
																																																															BgL_new1140z00_2575;
																																																														BgL_new1140z00_2575
																																																															=
																																																															(
																																																															(BgL_ev_setglobalz00_bglt)
																																																															BOBJECT
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setglobalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 550 */
																																																															long
																																																																BgL_arg2359z00_2576;
																																																															{	/* Eval/evaluate.scm 550 */
																																																																long
																																																																	BgL_res2922z00_3800;
																																																																BgL_res2922z00_3800
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																																BgL_arg2359z00_2576
																																																																	=
																																																																	BgL_res2922z00_3800;
																																																															}
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1140z00_2575), BgL_arg2359z00_2576);
																																																														}
																																																														BgL_new1141z00_2573
																																																															=
																																																															BgL_new1140z00_2575;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1141z00_2573)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2569)), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1141z00_2573))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1141z00_2573))->BgL_namez00) = ((obj_t) BgL_vz00_1501), BUNSPEC);
																																																													{
																																																														obj_t
																																																															BgL_auxz00_6264;
																																																														if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																															{	/* Eval/evaluate.scm 549 */
																																																																BgL_auxz00_6264
																																																																	=
																																																																	BgL_globalsz00_71;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 549 */
																																																																BgL_auxz00_6264
																																																																	=
																																																																	BGL_MODULE
																																																																	();
																																																															}
																																																														((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1141z00_2573))->BgL_modz00) = ((obj_t) BgL_auxz00_6264), BUNSPEC);
																																																													}
																																																													BgL_auxz00_6237
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1141z00_2573);
																																																												}
																																																										}
																																																										return
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_6237);
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 424 */
																																																									return
																																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																																										(BgL_locz00_74,
																																																										BGl_string3156z00zz__evaluatez00,
																																																										BGl_string3231z00zz__evaluatez00,
																																																										BgL_ez00_69);
																																																								}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string3156z00zz__evaluatez00,
																																																								BGl_string3231z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd27059zd2_1730;
																																																		BgL_cdrzd27059zd2_1730
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_cdrzd27063zd2_1731;
																																																			BgL_cdrzd27063zd2_1731
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27059zd2_1730));
																																																			if (PAIRP(BgL_cdrzd27063zd2_1731))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					if (NULLP(CDR(BgL_cdrzd27063zd2_1731)))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							obj_t
																																																								BgL_arg1716z00_1735;
																																																							obj_t
																																																								BgL_arg1717z00_1736;
																																																							BgL_arg1716z00_1735
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd27059zd2_1730));
																																																							BgL_arg1717z00_1736
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27063zd2_1731);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_6284;
																																																								{
																																																									obj_t
																																																										BgL_ez00_6286;
																																																									obj_t
																																																										BgL_vz00_6285;
																																																									BgL_vz00_6285
																																																										=
																																																										BgL_arg1716z00_1735;
																																																									BgL_ez00_6286
																																																										=
																																																										BgL_arg1717z00_1736;
																																																									BgL_ez00_1502
																																																										=
																																																										BgL_ez00_6286;
																																																									BgL_vz00_1501
																																																										=
																																																										BgL_vz00_6285;
																																																									goto
																																																										BgL_tagzd2165zd2_1503;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_6284);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string3156z00zz__evaluatez00,
																																																								BGl_string3231z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3156z00zz__evaluatez00,
																																																						BGl_string3231z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27120zd2_1738;
																																																BgL_cdrzd27120zd2_1738
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_cdrzd27124zd2_1739;
																																																	BgL_cdrzd27124zd2_1739
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27120zd2_1738));
																																																	if (PAIRP(BgL_cdrzd27124zd2_1739))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			if (NULLP(CDR(BgL_cdrzd27124zd2_1739)))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_arg1722z00_1743;
																																																					obj_t
																																																						BgL_arg1723z00_1744;
																																																					BgL_arg1722z00_1743
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27120zd2_1738));
																																																					BgL_arg1723z00_1744
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27124zd2_1739);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_6301;
																																																						{
																																																							obj_t
																																																								BgL_ez00_6303;
																																																							obj_t
																																																								BgL_vz00_6302;
																																																							BgL_vz00_6302
																																																								=
																																																								BgL_arg1722z00_1743;
																																																							BgL_ez00_6303
																																																								=
																																																								BgL_arg1723z00_1744;
																																																							BgL_ez00_1502
																																																								=
																																																								BgL_ez00_6303;
																																																							BgL_vz00_1501
																																																								=
																																																								BgL_vz00_6302;
																																																							goto
																																																								BgL_tagzd2165zd2_1503;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_6301);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3156z00zz__evaluatez00,
																																																						BGl_string3231z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3156z00zz__evaluatez00,
																																																				BGl_string3231z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd27181zd2_1746;
																																														BgL_cdrzd27181zd2_1746
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_cdrzd27185zd2_1747;
																																															BgL_cdrzd27185zd2_1747
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd27181zd2_1746));
																																															if (PAIRP(BgL_cdrzd27185zd2_1747))
																																																{	/* Eval/evaluate.scm 424 */
																																																	if (NULLP(CDR(BgL_cdrzd27185zd2_1747)))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_arg1728z00_1751;
																																																			obj_t
																																																				BgL_arg1729z00_1752;
																																																			BgL_arg1728z00_1751
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27181zd2_1746));
																																																			BgL_arg1729z00_1752
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27185zd2_1747);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_6318;
																																																				{
																																																					obj_t
																																																						BgL_ez00_6320;
																																																					obj_t
																																																						BgL_vz00_6319;
																																																					BgL_vz00_6319
																																																						=
																																																						BgL_arg1728z00_1751;
																																																					BgL_ez00_6320
																																																						=
																																																						BgL_arg1729z00_1752;
																																																					BgL_ez00_1502
																																																						=
																																																						BgL_ez00_6320;
																																																					BgL_vz00_1501
																																																						=
																																																						BgL_vz00_6319;
																																																					goto
																																																						BgL_tagzd2165zd2_1503;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_6318);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3156z00zz__evaluatez00,
																																																				BGl_string3231z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3156z00zz__evaluatez00,
																																																		BGl_string3231z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd27242zd2_1754;
																																												BgL_cdrzd27242zd2_1754
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd27246zd2_1755;
																																													BgL_cdrzd27246zd2_1755
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd27242zd2_1754));
																																													if (PAIRP(BgL_cdrzd27246zd2_1755))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27246zd2_1755)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1735z00_1759;
																																																	obj_t
																																																		BgL_arg1736z00_1760;
																																																	BgL_arg1735z00_1759
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27242zd2_1754));
																																																	BgL_arg1736z00_1760
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27246zd2_1755);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6335;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6337;
																																																			obj_t
																																																				BgL_vz00_6336;
																																																			BgL_vz00_6336
																																																				=
																																																				BgL_arg1735z00_1759;
																																																			BgL_ez00_6337
																																																				=
																																																				BgL_arg1736z00_1760;
																																																			BgL_ez00_1502
																																																				=
																																																				BgL_ez00_6337;
																																																			BgL_vz00_1501
																																																				=
																																																				BgL_vz00_6336;
																																																			goto
																																																				BgL_tagzd2165zd2_1503;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6335);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3156z00zz__evaluatez00,
																																																		BGl_string3231z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd27290zd2_1762;
																																										BgL_cdrzd27290zd2_1762
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_carzd27293zd2_1763;
																																											obj_t
																																												BgL_cdrzd27294zd2_1764;
																																											BgL_carzd27293zd2_1763
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd27290zd2_1762));
																																											BgL_cdrzd27294zd2_1764
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd27290zd2_1762));
																																											if ((CAR(((obj_t) BgL_carzd27293zd2_1763)) == BGl_symbol3241z00zz__evaluatez00))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (PAIRP(BgL_cdrzd27294zd2_1764))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27294zd2_1764)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1743z00_1770;
																																																	obj_t
																																																		BgL_arg1744z00_1771;
																																																	BgL_arg1743z00_1770
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd27293zd2_1763));
																																																	BgL_arg1744z00_1771
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27294zd2_1764);
																																																	BgL_lz00_1498
																																																		=
																																																		BgL_arg1743z00_1770;
																																																	BgL_e2z00_1499
																																																		=
																																																		BgL_arg1744z00_1771;
																																																BgL_tagzd2164zd2_1500:
																																																	{	/* Eval/evaluate.scm 537 */
																																																		bool_t
																																																			BgL_testz00_6358;
																																																		if (PAIRP(BgL_lz00_1498))
																																																			{	/* Eval/evaluate.scm 537 */
																																																				bool_t
																																																					BgL_testz00_6361;
																																																				{	/* Eval/evaluate.scm 537 */
																																																					obj_t
																																																						BgL_tmpz00_6362;
																																																					BgL_tmpz00_6362
																																																						=
																																																						CDR
																																																						(BgL_lz00_1498);
																																																					BgL_testz00_6361
																																																						=
																																																						PAIRP
																																																						(BgL_tmpz00_6362);
																																																				}
																																																				if (BgL_testz00_6361)
																																																					{
																																																						obj_t
																																																							BgL_l1247z00_2559;
																																																						BgL_l1247z00_2559
																																																							=
																																																							BgL_lz00_1498;
																																																					BgL_zc3anonymousza32352ze3z83_2560:
																																																						if (NULLP(BgL_l1247z00_2559))
																																																							{	/* Eval/evaluate.scm 537 */
																																																								BgL_testz00_6358
																																																									=
																																																									(
																																																									(bool_t)
																																																									1);
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 537 */
																																																								bool_t
																																																									BgL_testz00_6367;
																																																								{	/* Eval/evaluate.scm 537 */
																																																									obj_t
																																																										BgL_tmpz00_6368;
																																																									BgL_tmpz00_6368
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_l1247z00_2559));
																																																									BgL_testz00_6367
																																																										=
																																																										SYMBOLP
																																																										(BgL_tmpz00_6368);
																																																								}
																																																								if (BgL_testz00_6367)
																																																									{
																																																										obj_t
																																																											BgL_l1247z00_6372;
																																																										BgL_l1247z00_6372
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_l1247z00_2559));
																																																										BgL_l1247z00_2559
																																																											=
																																																											BgL_l1247z00_6372;
																																																										goto
																																																											BgL_zc3anonymousza32352ze3z83_2560;
																																																									}
																																																								else
																																																									{	/* Eval/evaluate.scm 537 */
																																																										BgL_testz00_6358
																																																											=
																																																											(
																																																											(bool_t)
																																																											0);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 537 */
																																																						BgL_testz00_6358
																																																							=
																																																							(
																																																							(bool_t)
																																																							0);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 537 */
																																																				BgL_testz00_6358
																																																					=
																																																					(
																																																					(bool_t)
																																																					0);
																																																			}
																																																		if (BgL_testz00_6358)
																																																			{	/* Eval/evaluate.scm 537 */
																																																				return
																																																					BGl_convzd2fieldzd2setz00zz__evaluatez00
																																																					(BgL_lz00_1498,
																																																					BgL_e2z00_1499,
																																																					BgL_ez00_69,
																																																					BgL_localsz00_70,
																																																					BgL_globalsz00_71,
																																																					BgL_tailzf3zf3_72,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					BgL_topzf3zf3_75);
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 537 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string3156z00zz__evaluatez00,
																																																					BGl_string3231z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3156z00zz__evaluatez00,
																																																		BGl_string3231z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd27370zd2_1774;
																																													BgL_cdrzd27370zd2_1774
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd27290zd2_1762));
																																													if (PAIRP(BgL_cdrzd27370zd2_1774))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd27370zd2_1774)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg1749z00_1778;
																																																	obj_t
																																																		BgL_arg1750z00_1779;
																																																	BgL_arg1749z00_1778
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27290zd2_1762));
																																																	BgL_arg1750z00_1779
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27370zd2_1774);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6389;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6391;
																																																			obj_t
																																																				BgL_vz00_6390;
																																																			BgL_vz00_6390
																																																				=
																																																				BgL_arg1749z00_1778;
																																																			BgL_ez00_6391
																																																				=
																																																				BgL_arg1750z00_1779;
																																																			BgL_ez00_1502
																																																				=
																																																				BgL_ez00_6391;
																																																			BgL_vz00_1501
																																																				=
																																																				BgL_vz00_6390;
																																																			goto
																																																				BgL_tagzd2165zd2_1503;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6389);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3156z00zz__evaluatez00,
																																																		BGl_string3231z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd27427zd2_1783;
																																								BgL_cdrzd27427zd2_1783
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 424 */
																																									obj_t
																																										BgL_cdrzd27431zd2_1784;
																																									BgL_cdrzd27431zd2_1784
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd27427zd2_1783));
																																									if (PAIRP(BgL_cdrzd27431zd2_1784))
																																										{	/* Eval/evaluate.scm 424 */
																																											if (NULLP(CDR(BgL_cdrzd27431zd2_1784)))
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_arg1757z00_1788;
																																													obj_t
																																														BgL_arg1758z00_1789;
																																													BgL_arg1757z00_1788
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd27427zd2_1783));
																																													BgL_arg1758z00_1789
																																														=
																																														CAR
																																														(BgL_cdrzd27431zd2_1784);
																																													{
																																														BgL_ev_hookz00_bglt
																																															BgL_auxz00_6406;
																																														{
																																															obj_t
																																																BgL_ez00_6408;
																																															obj_t
																																																BgL_vz00_6407;
																																															BgL_vz00_6407
																																																=
																																																BgL_arg1757z00_1788;
																																															BgL_ez00_6408
																																																=
																																																BgL_arg1758z00_1789;
																																															BgL_ez00_1502
																																																=
																																																BgL_ez00_6408;
																																															BgL_vz00_1501
																																																=
																																																BgL_vz00_6407;
																																															goto
																																																BgL_tagzd2165zd2_1503;
																																														}
																																														return
																																															(
																																															(obj_t)
																																															BgL_auxz00_6406);
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3156z00zz__evaluatez00,
																																														BGl_string3231z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string3156z00zz__evaluatez00,
																																												BGl_string3231z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						return
																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																							(BgL_locz00_74,
																																							BGl_string3156z00zz__evaluatez00,
																																							BGl_string3231z00zz__evaluatez00,
																																							BgL_ez00_69);
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_cdrzd27552zd2_1791;
																																				BgL_cdrzd27552zd2_1791
																																					=
																																					CDR
																																					(BgL_ez00_69);
																																				if ((CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol3255z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 424 */
																																						if (PAIRP(BgL_cdrzd27552zd2_1791))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd27557zd2_1795;
																																								BgL_cdrzd27557zd2_1795
																																									=
																																									CDR
																																									(BgL_cdrzd27552zd2_1791);
																																								if (PAIRP(BgL_cdrzd27557zd2_1795))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd27561zd2_1797;
																																										BgL_carzd27561zd2_1797
																																											=
																																											CAR
																																											(BgL_cdrzd27557zd2_1795);
																																										if (PAIRP(BgL_carzd27561zd2_1797))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd27566zd2_1799;
																																												BgL_cdrzd27566zd2_1799
																																													=
																																													CDR
																																													(BgL_carzd27561zd2_1797);
																																												if ((CAR(BgL_carzd27561zd2_1797) == BGl_symbol3220z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd27566zd2_1799))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27570zd2_1803;
																																																BgL_cdrzd27570zd2_1803
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27566zd2_1799);
																																																if (PAIRP(BgL_cdrzd27570zd2_1803))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd27570zd2_1803)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd27557zd2_1795)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1775z00_1809;
																																																						obj_t
																																																							BgL_arg1776z00_1810;
																																																						obj_t
																																																							BgL_arg1777z00_1811;
																																																						BgL_arg1775z00_1809
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27552zd2_1791);
																																																						BgL_arg1776z00_1810
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27566zd2_1799);
																																																						BgL_arg1777z00_1811
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27570zd2_1803);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6443;
																																																							BgL_gvz00_1505
																																																								=
																																																								BgL_arg1775z00_1809;
																																																							BgL_formalsz00_1506
																																																								=
																																																								BgL_arg1776z00_1810;
																																																							BgL_bodyz00_1507
																																																								=
																																																								BgL_arg1777z00_1811;
																																																						BgL_tagzd2167zd2_1508:
																																																							{	/* Eval/evaluate.scm 554 */
																																																								obj_t
																																																									BgL_tidz00_2577;
																																																								BgL_tidz00_2577
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1505);
																																																								{	/* Eval/evaluate.scm 555 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1143z00_2578;
																																																									{	/* Eval/evaluate.scm 559 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1142z00_2581;
																																																										BgL_new1142z00_2581
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 559 */
																																																											long
																																																												BgL_arg2362z00_2582;
																																																											{	/* Eval/evaluate.scm 559 */
																																																												long
																																																													BgL_res2923z00_3804;
																																																												BgL_res2923z00_3804
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2362z00_2582
																																																													=
																																																													BgL_res2923z00_3804;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1142z00_2581), BgL_arg2362z00_2582);
																																																										}
																																																										BgL_new1143z00_2578
																																																											=
																																																											BgL_new1142z00_2581;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6449;
																																																										{	/* Eval/evaluate.scm 559 */
																																																											obj_t
																																																												BgL_arg2360z00_2579;
																																																											BgL_arg2360z00_2579
																																																												=
																																																												CDR
																																																												(BgL_tidz00_2577);
																																																											BgL_auxz00_6449
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_convzd2lambdaze70z35zz__evaluatez00
																																																												(BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_ez00_69,
																																																													BgL_locz00_74,
																																																													BgL_formalsz00_1506,
																																																													BgL_bodyz00_1507,
																																																													BgL_gvz00_1505,
																																																													BgL_arg2360z00_2579));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1143z00_2578)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6449), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1143z00_2578)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1143z00_2578)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2577)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6460;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 558 */
																																																												BgL_auxz00_6460
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 558 */
																																																												BgL_auxz00_6460
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1143z00_2578)))->BgL_modz00) = ((obj_t) BgL_auxz00_6460), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6443
																																																										=
																																																										BgL_new1143z00_2578;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6443);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1778z00_1812;
																																																						BgL_arg1778z00_1812
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6468;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6470;
																																																								obj_t
																																																									BgL_fz00_6469;
																																																								BgL_fz00_6469
																																																									=
																																																									BgL_arg1778z00_1812;
																																																								BgL_argsz00_6470
																																																									=
																																																									BgL_cdrzd27552zd2_1791;
																																																								BgL_argsz00_1532
																																																									=
																																																									BgL_argsz00_6470;
																																																								BgL_fz00_1531
																																																									=
																																																									BgL_fz00_6469;
																																																								goto
																																																									BgL_tagzd2175zd2_1533;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6468);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_cdrzd27670zd2_1816;
																																																				BgL_cdrzd27670zd2_1816
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd27552zd2_1791));
																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd27670zd2_1816))))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1783z00_1819;
																																																						obj_t
																																																							BgL_arg1784z00_1820;
																																																						BgL_arg1783z00_1819
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd27552zd2_1791));
																																																						BgL_arg1784z00_1820
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd27670zd2_1816));
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6482;
																																																							BgL_gvz00_1509
																																																								=
																																																								BgL_arg1783z00_1819;
																																																							BgL_gez00_1510
																																																								=
																																																								BgL_arg1784z00_1820;
																																																						BgL_tagzd2168zd2_1511:
																																																							{	/* Eval/evaluate.scm 561 */
																																																								obj_t
																																																									BgL_tidz00_2583;
																																																								BgL_tidz00_2583
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1509);
																																																								{	/* Eval/evaluate.scm 562 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1145z00_2584;
																																																									{	/* Eval/evaluate.scm 566 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1144z00_2589;
																																																										BgL_new1144z00_2589
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BOBJECT
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 566 */
																																																											long
																																																												BgL_arg2367z00_2590;
																																																											{	/* Eval/evaluate.scm 566 */
																																																												long
																																																													BgL_res2924z00_3810;
																																																												BgL_res2924z00_3810
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2367z00_2590
																																																													=
																																																													BgL_res2924z00_3810;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1144z00_2589), BgL_arg2367z00_2590);
																																																										}
																																																										BgL_new1145z00_2584
																																																											=
																																																											BgL_new1144z00_2589;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6488;
																																																										{	/* Eval/evaluate.scm 567 */
																																																											obj_t
																																																												BgL_arg2363z00_2585;
																																																											{	/* Eval/evaluate.scm 567 */
																																																												obj_t
																																																													BgL_arg2365z00_2587;
																																																												BgL_arg2365z00_2587
																																																													=
																																																													CDR
																																																													(BgL_tidz00_2583);
																																																												BgL_arg2363z00_2585
																																																													=
																																																													BGl_typezd2resultzd2zz__evaluatez00
																																																													(BgL_arg2365z00_2587,
																																																													BgL_gez00_1510,
																																																													BgL_locz00_74);
																																																											}
																																																											{	/* Eval/evaluate.scm 383 */
																																																												obj_t
																																																													BgL_arg2391z00_3814;
																																																												{	/* Eval/evaluate.scm 144 */
																																																													obj_t
																																																														BgL__ortest_1067z00_3815;
																																																													BgL__ortest_1067z00_3815
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_arg2363z00_2585);
																																																													if (CBOOL(BgL__ortest_1067z00_3815))
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2391z00_3814
																																																																=
																																																																BgL__ortest_1067z00_3815;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 144 */
																																																															BgL_arg2391z00_3814
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												{
																																																													obj_t
																																																														BgL_auxz00_6495;
																																																													{	/* Eval/evaluate.scm 374 */
																																																														obj_t
																																																															BgL_auxz00_6496;
																																																														if (BgL_topzf3zf3_75)
																																																															{	/* Eval/evaluate.scm 568 */
																																																																BgL_auxz00_6496
																																																																	=
																																																																	BgL_gvz00_1509;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 568 */
																																																																BgL_auxz00_6496
																																																																	=
																																																																	BgL_wherez00_73;
																																																															}
																																																														BgL_auxz00_6495
																																																															=
																																																															BGl_convz00zz__evaluatez00
																																																															(BgL_arg2363z00_2585,
																																																															BgL_localsz00_70,
																																																															BgL_globalsz00_71,
																																																															BFALSE,
																																																															BgL_auxz00_6496,
																																																															BgL_arg2391z00_3814,
																																																															((bool_t) 0));
																																																													}
																																																													BgL_auxz00_6488
																																																														=
																																																														(
																																																														(BgL_ev_exprz00_bglt)
																																																														BgL_auxz00_6495);
																																																												}
																																																											}
																																																										}
																																																										((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1145z00_2584)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6488), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1145z00_2584)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1145z00_2584)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2583)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6506;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 565 */
																																																												BgL_auxz00_6506
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 565 */
																																																												BgL_auxz00_6506
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt) BgL_new1145z00_2584)))->BgL_modz00) = ((obj_t) BgL_auxz00_6506), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6482
																																																										=
																																																										BgL_new1145z00_2584;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6482);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1785z00_1821;
																																																						obj_t
																																																							BgL_arg1786z00_1822;
																																																						BgL_arg1785z00_1821
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1786z00_1822
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6515;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6517;
																																																								obj_t
																																																									BgL_fz00_6516;
																																																								BgL_fz00_6516
																																																									=
																																																									BgL_arg1785z00_1821;
																																																								BgL_argsz00_6517
																																																									=
																																																									BgL_arg1786z00_1822;
																																																								BgL_argsz00_1532
																																																									=
																																																									BgL_argsz00_6517;
																																																								BgL_fz00_1531
																																																									=
																																																									BgL_fz00_6516;
																																																								goto
																																																									BgL_tagzd2175zd2_1533;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6515);
																																																						}
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd27757zd2_1826;
																																																		BgL_cdrzd27757zd2_1826
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd27552zd2_1791));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd27757zd2_1826))))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1794z00_1829;
																																																				obj_t
																																																					BgL_arg1795z00_1830;
																																																				BgL_arg1794z00_1829
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd27552zd2_1791));
																																																				BgL_arg1795z00_1830
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd27757zd2_1826));
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6529;
																																																					{
																																																						obj_t
																																																							BgL_gez00_6531;
																																																						obj_t
																																																							BgL_gvz00_6530;
																																																						BgL_gvz00_6530
																																																							=
																																																							BgL_arg1794z00_1829;
																																																						BgL_gez00_6531
																																																							=
																																																							BgL_arg1795z00_1830;
																																																						BgL_gez00_1510
																																																							=
																																																							BgL_gez00_6531;
																																																						BgL_gvz00_1509
																																																							=
																																																							BgL_gvz00_6530;
																																																						goto
																																																							BgL_tagzd2168zd2_1511;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6529);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1798z00_1831;
																																																				obj_t
																																																					BgL_arg1799z00_1832;
																																																				BgL_arg1798z00_1831
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1799z00_1832
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6535;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6537;
																																																						obj_t
																																																							BgL_fz00_6536;
																																																						BgL_fz00_6536
																																																							=
																																																							BgL_arg1798z00_1831;
																																																						BgL_argsz00_6537
																																																							=
																																																							BgL_arg1799z00_1832;
																																																						BgL_argsz00_1532
																																																							=
																																																							BgL_argsz00_6537;
																																																						BgL_fz00_1531
																																																							=
																																																							BgL_fz00_6536;
																																																						goto
																																																							BgL_tagzd2175zd2_1533;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6535);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd27844zd2_1835;
																																																BgL_cdrzd27844zd2_1835
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd27552zd2_1791));
																																																if (NULLP(CDR(((obj_t) BgL_cdrzd27844zd2_1835))))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1803z00_1838;
																																																		obj_t
																																																			BgL_arg1805z00_1839;
																																																		BgL_arg1803z00_1838
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd27552zd2_1791));
																																																		BgL_arg1805z00_1839
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd27844zd2_1835));
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_6549;
																																																			{
																																																				obj_t
																																																					BgL_gez00_6551;
																																																				obj_t
																																																					BgL_gvz00_6550;
																																																				BgL_gvz00_6550
																																																					=
																																																					BgL_arg1803z00_1838;
																																																				BgL_gez00_6551
																																																					=
																																																					BgL_arg1805z00_1839;
																																																				BgL_gez00_1510
																																																					=
																																																					BgL_gez00_6551;
																																																				BgL_gvz00_1509
																																																					=
																																																					BgL_gvz00_6550;
																																																				goto
																																																					BgL_tagzd2168zd2_1511;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6549);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1807z00_1840;
																																																		obj_t
																																																			BgL_arg1808z00_1841;
																																																		BgL_arg1807z00_1840
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1808z00_1841
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6555;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6557;
																																																				obj_t
																																																					BgL_fz00_6556;
																																																				BgL_fz00_6556
																																																					=
																																																					BgL_arg1807z00_1840;
																																																				BgL_argsz00_6557
																																																					=
																																																					BgL_arg1808z00_1841;
																																																				BgL_argsz00_1532
																																																					=
																																																					BgL_argsz00_6557;
																																																				BgL_fz00_1531
																																																					=
																																																					BgL_fz00_6556;
																																																				goto
																																																					BgL_tagzd2175zd2_1533;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6555);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd27931zd2_1844;
																																														BgL_cdrzd27931zd2_1844
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_cdrzd27552zd2_1791));
																																														if (NULLP(CDR(((obj_t) BgL_cdrzd27931zd2_1844))))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1812z00_1847;
																																																obj_t
																																																	BgL_arg1814z00_1848;
																																																BgL_arg1812z00_1847
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd27552zd2_1791));
																																																BgL_arg1814z00_1848
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd27931zd2_1844));
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_6569;
																																																	{
																																																		obj_t
																																																			BgL_gez00_6571;
																																																		obj_t
																																																			BgL_gvz00_6570;
																																																		BgL_gvz00_6570
																																																			=
																																																			BgL_arg1812z00_1847;
																																																		BgL_gez00_6571
																																																			=
																																																			BgL_arg1814z00_1848;
																																																		BgL_gez00_1510
																																																			=
																																																			BgL_gez00_6571;
																																																		BgL_gvz00_1509
																																																			=
																																																			BgL_gvz00_6570;
																																																		goto
																																																			BgL_tagzd2168zd2_1511;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6569);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1815z00_1849;
																																																obj_t
																																																	BgL_arg1816z00_1850;
																																																BgL_arg1815z00_1849
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1816z00_1850
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6575;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6577;
																																																		obj_t
																																																			BgL_fz00_6576;
																																																		BgL_fz00_6576
																																																			=
																																																			BgL_arg1815z00_1849;
																																																		BgL_argsz00_6577
																																																			=
																																																			BgL_arg1816z00_1850;
																																																		BgL_argsz00_1532
																																																			=
																																																			BgL_argsz00_6577;
																																																		BgL_fz00_1531
																																																			=
																																																			BgL_fz00_6576;
																																																		goto
																																																			BgL_tagzd2175zd2_1533;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6575);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd28018zd2_1854;
																																												BgL_cdrzd28018zd2_1854
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_cdrzd27552zd2_1791));
																																												if (NULLP(CDR(((obj_t) BgL_cdrzd28018zd2_1854))))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1821z00_1857;
																																														obj_t
																																															BgL_arg1822z00_1858;
																																														BgL_arg1821z00_1857
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd27552zd2_1791));
																																														BgL_arg1822z00_1858
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd28018zd2_1854));
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_6589;
																																															{
																																																obj_t
																																																	BgL_gez00_6591;
																																																obj_t
																																																	BgL_gvz00_6590;
																																																BgL_gvz00_6590
																																																	=
																																																	BgL_arg1821z00_1857;
																																																BgL_gez00_6591
																																																	=
																																																	BgL_arg1822z00_1858;
																																																BgL_gez00_1510
																																																	=
																																																	BgL_gez00_6591;
																																																BgL_gvz00_1509
																																																	=
																																																	BgL_gvz00_6590;
																																																goto
																																																	BgL_tagzd2168zd2_1511;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6589);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1823z00_1859;
																																														obj_t
																																															BgL_arg1825z00_1860;
																																														BgL_arg1823z00_1859
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1825z00_1860
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6595;
																																															{
																																																obj_t
																																																	BgL_argsz00_6597;
																																																obj_t
																																																	BgL_fz00_6596;
																																																BgL_fz00_6596
																																																	=
																																																	BgL_arg1823z00_1859;
																																																BgL_argsz00_6597
																																																	=
																																																	BgL_arg1825z00_1860;
																																																BgL_argsz00_1532
																																																	=
																																																	BgL_argsz00_6597;
																																																BgL_fz00_1531
																																																	=
																																																	BgL_fz00_6596;
																																																goto
																																																	BgL_tagzd2175zd2_1533;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6595);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg1827z00_1862;
																																										BgL_arg1827z00_1862
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6600;
																																											{
																																												obj_t
																																													BgL_argsz00_6602;
																																												obj_t
																																													BgL_fz00_6601;
																																												BgL_fz00_6601
																																													=
																																													BgL_arg1827z00_1862;
																																												BgL_argsz00_6602
																																													=
																																													BgL_cdrzd27552zd2_1791;
																																												BgL_argsz00_1532
																																													=
																																													BgL_argsz00_6602;
																																												BgL_fz00_1531
																																													=
																																													BgL_fz00_6601;
																																												goto
																																													BgL_tagzd2175zd2_1533;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6600);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg1831z00_1864;
																																								BgL_arg1831z00_1864
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_6605;
																																									{
																																										obj_t
																																											BgL_argsz00_6607;
																																										obj_t
																																											BgL_fz00_6606;
																																										BgL_fz00_6606
																																											=
																																											BgL_arg1831z00_1864;
																																										BgL_argsz00_6607
																																											=
																																											BgL_cdrzd27552zd2_1791;
																																										BgL_argsz00_1532
																																											=
																																											BgL_argsz00_6607;
																																										BgL_fz00_1531
																																											=
																																											BgL_fz00_6606;
																																										goto
																																											BgL_tagzd2175zd2_1533;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_6605);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol3257z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd27552zd2_1791))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd28260zd2_1870;
																																										BgL_carzd28260zd2_1870
																																											=
																																											CAR
																																											(BgL_cdrzd27552zd2_1791);
																																										if (PAIRP(BgL_carzd28260zd2_1870))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (NULLP(CDR(BgL_carzd28260zd2_1870)))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1840z00_1874;
																																														obj_t
																																															BgL_arg1841z00_1875;
																																														BgL_arg1840z00_1874
																																															=
																																															CAR
																																															(BgL_carzd28260zd2_1870);
																																														BgL_arg1841z00_1875
																																															=
																																															CDR
																																															(BgL_cdrzd27552zd2_1791);
																																														{
																																															BgL_ev_bindzd2exitzd2_bglt
																																																BgL_auxz00_6622;
																																															BgL_vz00_1512
																																																=
																																																BgL_arg1840z00_1874;
																																															BgL_bodyz00_1513
																																																=
																																																BgL_arg1841z00_1875;
																																														BgL_tagzd2169zd2_1514:
																																															{	/* Eval/evaluate.scm 570 */
																																																BgL_ev_varz00_bglt
																																																	BgL_varz00_2591;
																																																{	/* Eval/evaluate.scm 570 */
																																																	BgL_ev_varz00_bglt
																																																		BgL_new1147z00_2596;
																																																	{	/* Eval/evaluate.scm 570 */
																																																		BgL_ev_varz00_bglt
																																																			BgL_new1146z00_2597;
																																																		BgL_new1146z00_2597
																																																			=
																																																			(
																																																			(BgL_ev_varz00_bglt)
																																																			BOBJECT
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_varz00_bgl))));
																																																		{	/* Eval/evaluate.scm 570 */
																																																			long
																																																				BgL_arg2373z00_2598;
																																																			{	/* Eval/evaluate.scm 570 */
																																																				long
																																																					BgL_res2925z00_3818;
																																																				BgL_res2925z00_3818
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_varz00zz__evaluate_typesz00);
																																																				BgL_arg2373z00_2598
																																																					=
																																																					BgL_res2925z00_3818;
																																																			}
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1146z00_2597), BgL_arg2373z00_2598);
																																																		}
																																																		BgL_new1147z00_2596
																																																			=
																																																			BgL_new1146z00_2597;
																																																	}
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1147z00_2596))->BgL_namez00) = ((obj_t) BgL_vz00_1512), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1147z00_2596))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) COBJECT(BgL_new1147z00_2596))->BgL_typez00) = ((obj_t) BFALSE), BUNSPEC);
																																																	BgL_varz00_2591
																																																		=
																																																		BgL_new1147z00_2596;
																																																}
																																																{	/* Eval/evaluate.scm 571 */
																																																	BgL_ev_bindzd2exitzd2_bglt
																																																		BgL_new1149z00_2592;
																																																	{	/* Eval/evaluate.scm 572 */
																																																		BgL_ev_bindzd2exitzd2_bglt
																																																			BgL_new1148z00_2594;
																																																		BgL_new1148z00_2594
																																																			=
																																																			(
																																																			(BgL_ev_bindzd2exitzd2_bglt)
																																																			BOBJECT
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_bindzd2exitzd2_bgl))));
																																																		{	/* Eval/evaluate.scm 572 */
																																																			long
																																																				BgL_arg2370z00_2595;
																																																			{	/* Eval/evaluate.scm 572 */
																																																				long
																																																					BgL_res2926z00_3822;
																																																				BgL_res2926z00_3822
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
																																																				BgL_arg2370z00_2595
																																																					=
																																																					BgL_res2926z00_3822;
																																																			}
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1148z00_2594), BgL_arg2370z00_2595);
																																																		}
																																																		BgL_new1149z00_2592
																																																			=
																																																			BgL_new1148z00_2594;
																																																	}
																																																	((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1149z00_2592))->BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_varz00_2591), BUNSPEC);
																																																	{
																																																		BgL_ev_exprz00_bglt
																																																			BgL_auxz00_6635;
																																																		{	/* Eval/evaluate.scm 573 */
																																																			obj_t
																																																				BgL_arg2368z00_2593;
																																																			BgL_arg2368z00_2593
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_varz00_2591), BgL_localsz00_70);
																																																			BgL_auxz00_6635
																																																				=
																																																				(
																																																				(BgL_ev_exprz00_bglt)
																																																				BGl_convzd2beginzd2zz__evaluatez00
																																																				(BgL_bodyz00_1513,
																																																					BgL_arg2368z00_2593,
																																																					BgL_globalsz00_71,
																																																					BFALSE,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					((bool_t) 0)));
																																																		}
																																																		((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1149z00_2592))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6635), BUNSPEC);
																																																	}
																																																	BgL_auxz00_6622
																																																		=
																																																		BgL_new1149z00_2592;
																																															}}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6622);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1842z00_1876;
																																														obj_t
																																															BgL_arg1844z00_1877;
																																														BgL_arg1842z00_1876
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1844z00_1877
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6644;
																																															{
																																																obj_t
																																																	BgL_argsz00_6646;
																																																obj_t
																																																	BgL_fz00_6645;
																																																BgL_fz00_6645
																																																	=
																																																	BgL_arg1842z00_1876;
																																																BgL_argsz00_6646
																																																	=
																																																	BgL_arg1844z00_1877;
																																																BgL_argsz00_1532
																																																	=
																																																	BgL_argsz00_6646;
																																																BgL_fz00_1531
																																																	=
																																																	BgL_fz00_6645;
																																																goto
																																																	BgL_tagzd2175zd2_1533;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6644);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1847z00_1879;
																																												obj_t
																																													BgL_arg1849z00_1880;
																																												BgL_arg1847z00_1879
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg1849z00_1880
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6650;
																																													{
																																														obj_t
																																															BgL_argsz00_6652;
																																														obj_t
																																															BgL_fz00_6651;
																																														BgL_fz00_6651
																																															=
																																															BgL_arg1847z00_1879;
																																														BgL_argsz00_6652
																																															=
																																															BgL_arg1849z00_1880;
																																														BgL_argsz00_1532
																																															=
																																															BgL_argsz00_6652;
																																														BgL_fz00_1531
																																															=
																																															BgL_fz00_6651;
																																														goto
																																															BgL_tagzd2175zd2_1533;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6650);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg1850z00_1881;
																																										obj_t
																																											BgL_arg1851z00_1882;
																																										BgL_arg1850z00_1881
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg1851z00_1882
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6656;
																																											{
																																												obj_t
																																													BgL_argsz00_6658;
																																												obj_t
																																													BgL_fz00_6657;
																																												BgL_fz00_6657
																																													=
																																													BgL_arg1850z00_1881;
																																												BgL_argsz00_6658
																																													=
																																													BgL_arg1851z00_1882;
																																												BgL_argsz00_1532
																																													=
																																													BgL_argsz00_6658;
																																												BgL_fz00_1531
																																													=
																																													BgL_fz00_6657;
																																												goto
																																													BgL_tagzd2175zd2_1533;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6656);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd28425zd2_1883;
																																								BgL_cdrzd28425zd2_1883
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								if ((CAR(BgL_ez00_69) == BGl_symbol3259z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd28425zd2_1883))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1855z00_1887;
																																												obj_t
																																													BgL_arg1856z00_1888;
																																												BgL_arg1855z00_1887
																																													=
																																													CAR
																																													(BgL_cdrzd28425zd2_1883);
																																												BgL_arg1856z00_1888
																																													=
																																													CDR
																																													(BgL_cdrzd28425zd2_1883);
																																												{	/* Eval/evaluate.scm 575 */
																																													BgL_ev_unwindzd2protectzd2_bglt
																																														BgL_new1151z00_4215;
																																													{	/* Eval/evaluate.scm 576 */
																																														BgL_ev_unwindzd2protectzd2_bglt
																																															BgL_new1150z00_4216;
																																														BgL_new1150z00_4216
																																															=
																																															(
																																															(BgL_ev_unwindzd2protectzd2_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_unwindzd2protectzd2_bgl))));
																																														{	/* Eval/evaluate.scm 576 */
																																															long
																																																BgL_arg2374z00_4217;
																																															{	/* Eval/evaluate.scm 576 */
																																																long
																																																	BgL_res3006z00_4219;
																																																BgL_res3006z00_4219
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																																BgL_arg2374z00_4217
																																																	=
																																																	BgL_res3006z00_4219;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1150z00_4216), BgL_arg2374z00_4217);
																																														}
																																														BgL_new1151z00_4215
																																															=
																																															BgL_new1150z00_4216;
																																													}
																																													{
																																														BgL_ev_exprz00_bglt
																																															BgL_auxz00_6672;
																																														{	/* Eval/evaluate.scm 380 */
																																															obj_t
																																																BgL_arg2389z00_4222;
																																															BgL_arg2389z00_4222
																																																=
																																																BGl_getzd2locationzd2zz__evaluatez00
																																																(BgL_arg1855z00_1887,
																																																BgL_locz00_74);
																																															BgL_auxz00_6672
																																																=
																																																(
																																																(BgL_ev_exprz00_bglt)
																																																BGl_uconvzf2locze70z15zz__evaluatez00
																																																(BgL_wherez00_73,
																																																	BgL_globalsz00_71,
																																																	BgL_localsz00_70,
																																																	BgL_arg1855z00_1887,
																																																	BgL_arg2389z00_4222));
																																														}
																																														((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1151z00_4215))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6672), BUNSPEC);
																																													}
																																													((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1151z00_4215))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1856z00_1888, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													return
																																														(
																																														(obj_t)
																																														BgL_new1151z00_4215);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg1858z00_1889;
																																												BgL_arg1858z00_1889
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6682;
																																													{
																																														obj_t
																																															BgL_argsz00_6684;
																																														obj_t
																																															BgL_fz00_6683;
																																														BgL_fz00_6683
																																															=
																																															BgL_arg1858z00_1889;
																																														BgL_argsz00_6684
																																															=
																																															BgL_cdrzd28425zd2_1883;
																																														BgL_argsz00_1532
																																															=
																																															BgL_argsz00_6684;
																																														BgL_fz00_1531
																																															=
																																															BgL_fz00_6683;
																																														goto
																																															BgL_tagzd2175zd2_1533;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6682);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										if ((CAR(BgL_ez00_69) == BGl_symbol3261z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd28425zd2_1883))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1863z00_1895;
																																														obj_t
																																															BgL_arg1864z00_1896;
																																														BgL_arg1863z00_1895
																																															=
																																															CAR
																																															(BgL_cdrzd28425zd2_1883);
																																														BgL_arg1864z00_1896
																																															=
																																															CDR
																																															(BgL_cdrzd28425zd2_1883);
																																														{	/* Eval/evaluate.scm 579 */
																																															BgL_ev_withzd2handlerzd2_bglt
																																																BgL_new1153z00_4230;
																																															{	/* Eval/evaluate.scm 580 */
																																																BgL_ev_withzd2handlerzd2_bglt
																																																	BgL_new1152z00_4231;
																																																BgL_new1152z00_4231
																																																	=
																																																	(
																																																	(BgL_ev_withzd2handlerzd2_bglt)
																																																	BOBJECT
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_withzd2handlerzd2_bgl))));
																																																{	/* Eval/evaluate.scm 580 */
																																																	long
																																																		BgL_arg2375z00_4232;
																																																	{	/* Eval/evaluate.scm 580 */
																																																		long
																																																			BgL_res3008z00_4234;
																																																		BgL_res3008z00_4234
																																																			=
																																																			BGL_CLASS_INDEX
																																																			(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																		BgL_arg2375z00_4232
																																																			=
																																																			BgL_res3008z00_4234;
																																																	}
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1152z00_4231), BgL_arg2375z00_4232);
																																																}
																																																BgL_new1153z00_4230
																																																	=
																																																	BgL_new1152z00_4231;
																																															}
																																															{
																																																BgL_ev_exprz00_bglt
																																																	BgL_auxz00_6697;
																																																{	/* Eval/evaluate.scm 380 */
																																																	obj_t
																																																		BgL_arg2389z00_4237;
																																																	BgL_arg2389z00_4237
																																																		=
																																																		BGl_getzd2locationzd2zz__evaluatez00
																																																		(BgL_arg1863z00_1895,
																																																		BgL_locz00_74);
																																																	BgL_auxz00_6697
																																																		=
																																																		(
																																																		(BgL_ev_exprz00_bglt)
																																																		BGl_uconvzf2locze70z15zz__evaluatez00
																																																		(BgL_wherez00_73,
																																																			BgL_globalsz00_71,
																																																			BgL_localsz00_70,
																																																			BgL_arg1863z00_1895,
																																																			BgL_arg2389z00_4237));
																																																}
																																																((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1153z00_4230))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6697), BUNSPEC);
																																															}
																																															((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1153z00_4230))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1864z00_1896, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																															return
																																																(
																																																(obj_t)
																																																BgL_new1153z00_4230);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg1865z00_1897;
																																														obj_t
																																															BgL_arg1866z00_1898;
																																														BgL_arg1865z00_1897
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1866z00_1898
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6708;
																																															{
																																																obj_t
																																																	BgL_argsz00_6710;
																																																obj_t
																																																	BgL_fz00_6709;
																																																BgL_fz00_6709
																																																	=
																																																	BgL_arg1865z00_1897;
																																																BgL_argsz00_6710
																																																	=
																																																	BgL_arg1866z00_1898;
																																																BgL_argsz00_1532
																																																	=
																																																	BgL_argsz00_6710;
																																																BgL_fz00_1531
																																																	=
																																																	BgL_fz00_6709;
																																																goto
																																																	BgL_tagzd2175zd2_1533;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6708);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd28528zd2_1899;
																																												BgL_cdrzd28528zd2_1899
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												if ((CAR(BgL_ez00_69) == BGl_symbol3263z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd28528zd2_1899))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd28533zd2_1903;
																																																BgL_cdrzd28533zd2_1903
																																																	=
																																																	CDR
																																																	(BgL_cdrzd28528zd2_1899);
																																																if (PAIRP(BgL_cdrzd28533zd2_1903))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd28538zd2_1905;
																																																		BgL_cdrzd28538zd2_1905
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28533zd2_1903);
																																																		if ((CAR(BgL_cdrzd28533zd2_1903) == BGl_keyword3265z00zz__evaluatez00))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (PAIRP(BgL_cdrzd28538zd2_1905))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1875z00_1909;
																																																						obj_t
																																																							BgL_arg1876z00_1910;
																																																						obj_t
																																																							BgL_arg1877z00_1911;
																																																						BgL_arg1875z00_1909
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1899);
																																																						BgL_arg1876z00_1910
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28538zd2_1905);
																																																						BgL_arg1877z00_1911
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28538zd2_1905);
																																																						{	/* Eval/evaluate.scm 583 */
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_new1156z00_4251;
																																																							{	/* Eval/evaluate.scm 584 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1155z00_4252;
																																																								BgL_new1155z00_4252
																																																									=
																																																									(
																																																									(BgL_ev_synchroniza7eza7_bglt)
																																																									BOBJECT
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_synchroniza7eza7_bgl))));
																																																								{	/* Eval/evaluate.scm 584 */
																																																									long
																																																										BgL_arg2376z00_4253;
																																																									{	/* Eval/evaluate.scm 584 */
																																																										long
																																																											BgL_res3012z00_4255;
																																																										BgL_res3012z00_4255
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																										BgL_arg2376z00_4253
																																																											=
																																																											BgL_res3012z00_4255;
																																																									}
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1155z00_4252), BgL_arg2376z00_4253);
																																																								}
																																																								BgL_new1156z00_4251
																																																									=
																																																									BgL_new1155z00_4252;
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4251))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6735;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2389z00_4258;
																																																									BgL_arg2389z00_4258
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1875z00_1909,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6735
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1875z00_1909,
																																																											BgL_arg2389z00_4258));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4251))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6735), BUNSPEC);
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_6740;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2389z00_4259;
																																																									BgL_arg2389z00_4259
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1876z00_1910,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_6740
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1876z00_1910,
																																																											BgL_arg2389z00_4259));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4251))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6740), BUNSPEC);
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4251))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1877z00_1911, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1156z00_4251);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1878z00_1913;
																																																						obj_t
																																																							BgL_arg1879z00_1914;
																																																						BgL_arg1878z00_1913
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd28528zd2_1899));
																																																						BgL_arg1879z00_1914
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd28528zd2_1899));
																																																						{
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_auxz00_6753;
																																																							BgL_mz00_1525
																																																								=
																																																								BgL_arg1878z00_1913;
																																																							BgL_bodyz00_1526
																																																								=
																																																								BgL_arg1879z00_1914;
																																																						BgL_tagzd2173zd2_1527:
																																																							{	/* Eval/evaluate.scm 589 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1158z00_2608;
																																																								{	/* Eval/evaluate.scm 590 */
																																																									BgL_ev_synchroniza7eza7_bglt
																																																										BgL_new1157z00_2609;
																																																									BgL_new1157z00_2609
																																																										=
																																																										(
																																																										(BgL_ev_synchroniza7eza7_bglt)
																																																										BOBJECT
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_synchroniza7eza7_bgl))));
																																																									{	/* Eval/evaluate.scm 590 */
																																																										long
																																																											BgL_arg2377z00_2610;
																																																										{	/* Eval/evaluate.scm 590 */
																																																											long
																																																												BgL_res2930z00_3855;
																																																											BgL_res2930z00_3855
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																											BgL_arg2377z00_2610
																																																												=
																																																												BgL_res2930z00_3855;
																																																										}
																																																										BGL_OBJECT_CLASS_NUM_SET
																																																											(
																																																											((BgL_objectz00_bglt) BgL_new1157z00_2609), BgL_arg2377z00_2610);
																																																									}
																																																									BgL_new1158z00_2608
																																																										=
																																																										BgL_new1157z00_2609;
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1158z00_2608))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6759;
																																																									{	/* Eval/evaluate.scm 380 */
																																																										obj_t
																																																											BgL_arg2389z00_3858;
																																																										{	/* Eval/evaluate.scm 144 */
																																																											obj_t
																																																												BgL__ortest_1067z00_3859;
																																																											BgL__ortest_1067z00_3859
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_mz00_1525);
																																																											if (CBOOL(BgL__ortest_1067z00_3859))
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2389z00_3858
																																																														=
																																																														BgL__ortest_1067z00_3859;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2389z00_3858
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6759
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_mz00_1525,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2389z00_3858,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1158z00_2608))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6759), BUNSPEC);
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6766;
																																																									{	/* Eval/evaluate.scm 380 */
																																																										obj_t
																																																											BgL_arg2389z00_3860;
																																																										{	/* Eval/evaluate.scm 144 */
																																																											obj_t
																																																												BgL__ortest_1067z00_3861;
																																																											BgL__ortest_1067z00_3861
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BNIL);
																																																											if (CBOOL(BgL__ortest_1067z00_3861))
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2389z00_3860
																																																														=
																																																														BgL__ortest_1067z00_3861;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 144 */
																																																													BgL_arg2389z00_3860
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6766
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BNIL,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2389z00_3860,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1158z00_2608))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6766), BUNSPEC);
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1158z00_2608))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1526, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																								BgL_auxz00_6753
																																																									=
																																																									BgL_new1158z00_2608;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6753);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1880z00_1916;
																																																				obj_t
																																																					BgL_arg1881z00_1917;
																																																				BgL_arg1880z00_1916
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd28528zd2_1899));
																																																				BgL_arg1881z00_1917
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd28528zd2_1899));
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_6781;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6783;
																																																						obj_t
																																																							BgL_mz00_6782;
																																																						BgL_mz00_6782
																																																							=
																																																							BgL_arg1880z00_1916;
																																																						BgL_bodyz00_6783
																																																							=
																																																							BgL_arg1881z00_1917;
																																																						BgL_bodyz00_1526
																																																							=
																																																							BgL_bodyz00_6783;
																																																						BgL_mz00_1525
																																																							=
																																																							BgL_mz00_6782;
																																																						goto
																																																							BgL_tagzd2173zd2_1527;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6781);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1883z00_1920;
																																																		obj_t
																																																			BgL_arg1884z00_1921;
																																																		BgL_arg1883z00_1920
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd28528zd2_1899));
																																																		BgL_arg1884z00_1921
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd28528zd2_1899));
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_6789;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_6791;
																																																				obj_t
																																																					BgL_mz00_6790;
																																																				BgL_mz00_6790
																																																					=
																																																					BgL_arg1883z00_1920;
																																																				BgL_bodyz00_6791
																																																					=
																																																					BgL_arg1884z00_1921;
																																																				BgL_bodyz00_1526
																																																					=
																																																					BgL_bodyz00_6791;
																																																				BgL_mz00_1525
																																																					=
																																																					BgL_mz00_6790;
																																																				goto
																																																					BgL_tagzd2173zd2_1527;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6789);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1886z00_1922;
																																																BgL_arg1886z00_1922
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6794;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6796;
																																																		obj_t
																																																			BgL_fz00_6795;
																																																		BgL_fz00_6795
																																																			=
																																																			BgL_arg1886z00_1922;
																																																		BgL_argsz00_6796
																																																			=
																																																			BgL_cdrzd28528zd2_1899;
																																																		BgL_argsz00_1532
																																																			=
																																																			BgL_argsz00_6796;
																																																		BgL_fz00_1531
																																																			=
																																																			BgL_fz00_6795;
																																																		goto
																																																			BgL_tagzd2175zd2_1533;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6794);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														if ((CAR(BgL_ez00_69) == BGl_symbol3220z00zz__evaluatez00))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (PAIRP(BgL_cdrzd28528zd2_1899))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd28638zd2_1928;
																																																		BgL_cdrzd28638zd2_1928
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28528zd2_1899);
																																																		if (PAIRP(BgL_cdrzd28638zd2_1928))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd28638zd2_1928)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1894z00_1932;
																																																						obj_t
																																																							BgL_arg1895z00_1933;
																																																						BgL_arg1894z00_1932
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1899);
																																																						BgL_arg1895z00_1933
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28638zd2_1928);
																																																						{	/* Eval/evaluate.scm 595 */
																																																							obj_t
																																																								BgL_arg2378z00_4280;
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_arg2379z00_4281;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_arg2380z00_4282;
																																																									obj_t
																																																										BgL_arg2381z00_4283;
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_res3016z00_4286;
																																																										{	/* Eval/evaluate.scm 595 */
																																																											obj_t
																																																												BgL_symbolz00_4284;
																																																											BgL_symbolz00_4284
																																																												=
																																																												BGl_symbol3267z00zz__evaluatez00;
																																																											{	/* Eval/evaluate.scm 595 */
																																																												obj_t
																																																													BgL_arg2597z00_4285;
																																																												BgL_arg2597z00_4285
																																																													=
																																																													SYMBOL_TO_STRING
																																																													(BgL_symbolz00_4284);
																																																												BgL_res3016z00_4286
																																																													=
																																																													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																													(BgL_arg2597z00_4285);
																																																											}
																																																										}
																																																										BgL_arg2380z00_4282
																																																											=
																																																											BgL_res3016z00_4286;
																																																									}
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_res3017z00_4289;
																																																										{	/* Eval/evaluate.scm 595 */
																																																											obj_t
																																																												BgL_arg2597z00_4288;
																																																											BgL_arg2597z00_4288
																																																												=
																																																												SYMBOL_TO_STRING
																																																												(
																																																												((obj_t) BgL_wherez00_73));
																																																											BgL_res3017z00_4289
																																																												=
																																																												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																												(BgL_arg2597z00_4288);
																																																										}
																																																										BgL_arg2381z00_4283
																																																											=
																																																											BgL_res3017z00_4289;
																																																									}
																																																									BgL_arg2379z00_4281
																																																										=
																																																										string_append
																																																										(BgL_arg2380z00_4282,
																																																										BgL_arg2381z00_4283);
																																																								}
																																																								BgL_arg2378z00_4280
																																																									=
																																																									bstring_to_symbol
																																																									(BgL_arg2379z00_4281);
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BGl_convzd2lambdaze70z35zz__evaluatez00
																																																								(BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_ez00_69,
																																																									BgL_locz00_74,
																																																									BgL_arg1894z00_1932,
																																																									BgL_arg1895z00_1933,
																																																									BgL_arg2378z00_4280,
																																																									BFALSE));
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg1896z00_1934;
																																																						obj_t
																																																							BgL_arg1897z00_1935;
																																																						BgL_arg1896z00_1934
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1897z00_1935
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6822;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6824;
																																																								obj_t
																																																									BgL_fz00_6823;
																																																								BgL_fz00_6823
																																																									=
																																																									BgL_arg1896z00_1934;
																																																								BgL_argsz00_6824
																																																									=
																																																									BgL_arg1897z00_1935;
																																																								BgL_argsz00_1532
																																																									=
																																																									BgL_argsz00_6824;
																																																								BgL_fz00_1531
																																																									=
																																																									BgL_fz00_6823;
																																																								goto
																																																									BgL_tagzd2175zd2_1533;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6822);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg1899z00_1937;
																																																				obj_t
																																																					BgL_arg1900z00_1938;
																																																				BgL_arg1899z00_1937
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1900z00_1938
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6828;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6830;
																																																						obj_t
																																																							BgL_fz00_6829;
																																																						BgL_fz00_6829
																																																							=
																																																							BgL_arg1899z00_1937;
																																																						BgL_argsz00_6830
																																																							=
																																																							BgL_arg1900z00_1938;
																																																						BgL_argsz00_1532
																																																							=
																																																							BgL_argsz00_6830;
																																																						BgL_fz00_1531
																																																							=
																																																							BgL_fz00_6829;
																																																						goto
																																																							BgL_tagzd2175zd2_1533;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6828);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg1901z00_1939;
																																																		obj_t
																																																			BgL_arg1902z00_1940;
																																																		BgL_arg1901z00_1939
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1902z00_1940
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6834;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6836;
																																																				obj_t
																																																					BgL_fz00_6835;
																																																				BgL_fz00_6835
																																																					=
																																																					BgL_arg1901z00_1939;
																																																				BgL_argsz00_6836
																																																					=
																																																					BgL_arg1902z00_1940;
																																																				BgL_argsz00_1532
																																																					=
																																																					BgL_argsz00_6836;
																																																				BgL_fz00_1531
																																																					=
																																																					BgL_fz00_6835;
																																																				goto
																																																					BgL_tagzd2175zd2_1533;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6834);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg1903z00_1941;
																																																obj_t
																																																	BgL_arg1904z00_1942;
																																																BgL_arg1903z00_1941
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1904z00_1942
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6840;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6842;
																																																		obj_t
																																																			BgL_fz00_6841;
																																																		BgL_fz00_6841
																																																			=
																																																			BgL_arg1903z00_1941;
																																																		BgL_argsz00_6842
																																																			=
																																																			BgL_arg1904z00_1942;
																																																		BgL_argsz00_1532
																																																			=
																																																			BgL_argsz00_6842;
																																																		BgL_fz00_1531
																																																			=
																																																			BgL_fz00_6841;
																																																		goto
																																																			BgL_tagzd2175zd2_1533;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6840);
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 424 */
														if (
															(BgL_carzd23820zd2_1606 ==
																BGl_symbol3243z00zz__evaluatez00))
															{	/* Eval/evaluate.scm 424 */
																if (PAIRP(BgL_cdrzd2249zd2_1540))
																	{	/* Eval/evaluate.scm 424 */
																		if (NULLP(CDR(BgL_cdrzd2249zd2_1540)))
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1927z00_1966;

																				BgL_arg1927z00_1966 =
																					CAR(BgL_cdrzd2249zd2_1540);
																				{	/* Eval/evaluate.scm 456 */
																					BgL_ev_trapz00_bglt
																						BgL_new1109z00_4306;
																					{	/* Eval/evaluate.scm 457 */
																						BgL_ev_trapz00_bglt
																							BgL_new1108z00_4307;
																						BgL_new1108z00_4307 =
																							((BgL_ev_trapz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_ev_trapz00_bgl))));
																						{	/* Eval/evaluate.scm 457 */
																							long BgL_arg2252z00_4308;

																							{	/* Eval/evaluate.scm 457 */
																								long BgL_res3021z00_4310;

																								BgL_res3021z00_4310 =
																									BGL_CLASS_INDEX
																									(BGl_ev_trapz00zz__evaluate_typesz00);
																								BgL_arg2252z00_4308 =
																									BgL_res3021z00_4310;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1108z00_4307),
																								BgL_arg2252z00_4308);
																						}
																						BgL_new1109z00_4306 =
																							BgL_new1108z00_4307;
																					}
																					{
																						BgL_ev_exprz00_bglt BgL_auxz00_6856;

																						{	/* Eval/evaluate.scm 380 */
																							obj_t BgL_arg2389z00_4313;

																							BgL_arg2389z00_4313 =
																								BGl_getzd2locationzd2zz__evaluatez00
																								(BgL_arg1927z00_1966,
																								BgL_locz00_74);
																							BgL_auxz00_6856 =
																								((BgL_ev_exprz00_bglt)
																								BGl_uconvzf2locze70z15zz__evaluatez00
																								(BgL_wherez00_73,
																									BgL_globalsz00_71,
																									BgL_localsz00_70,
																									BgL_arg1927z00_1966,
																									BgL_arg2389z00_4313));
																						}
																						((((BgL_ev_hookz00_bglt) COBJECT(
																										((BgL_ev_hookz00_bglt)
																											BgL_new1109z00_4306)))->
																								BgL_ez00) =
																							((BgL_ev_exprz00_bglt)
																								BgL_auxz00_6856), BUNSPEC);
																					}
																					return ((obj_t) BgL_new1109z00_4306);
																				}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1928z00_1967;
																				obj_t BgL_arg1929z00_1968;

																				BgL_arg1928z00_1967 = CAR(BgL_ez00_69);
																				BgL_arg1929z00_1968 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6865;

																					{
																						obj_t BgL_argsz00_6867;
																						obj_t BgL_fz00_6866;

																						BgL_fz00_6866 = BgL_arg1928z00_1967;
																						BgL_argsz00_6867 =
																							BgL_arg1929z00_1968;
																						BgL_argsz00_1532 = BgL_argsz00_6867;
																						BgL_fz00_1531 = BgL_fz00_6866;
																						goto BgL_tagzd2175zd2_1533;
																					}
																					return ((obj_t) BgL_auxz00_6865);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		obj_t BgL_arg1931z00_1970;
																		obj_t BgL_arg1932z00_1971;

																		BgL_arg1931z00_1970 = CAR(BgL_ez00_69);
																		BgL_arg1932z00_1971 = CDR(BgL_ez00_69);
																		{
																			BgL_ev_appz00_bglt BgL_auxz00_6871;

																			{
																				obj_t BgL_argsz00_6873;
																				obj_t BgL_fz00_6872;

																				BgL_fz00_6872 = BgL_arg1931z00_1970;
																				BgL_argsz00_6873 = BgL_arg1932z00_1971;
																				BgL_argsz00_1532 = BgL_argsz00_6873;
																				BgL_fz00_1531 = BgL_fz00_6872;
																				goto BgL_tagzd2175zd2_1533;
																			}
																			return ((obj_t) BgL_auxz00_6871);
																		}
																	}
															}
														else
															{	/* Eval/evaluate.scm 424 */
																obj_t BgL_cdrzd29337zd2_1972;

																BgL_cdrzd29337zd2_1972 = CDR(BgL_ez00_69);
																if (
																	(CAR(BgL_ez00_69) ==
																		BGl_symbol3208z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 424 */
																		if (PAIRP(BgL_cdrzd29337zd2_1972))
																			{	/* Eval/evaluate.scm 424 */
																				if (NULLP(CDR(BgL_cdrzd29337zd2_1972)))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1938z00_1978;

																						BgL_arg1938z00_1978 =
																							CAR(BgL_cdrzd29337zd2_1972);
																						{	/* Eval/evaluate.scm 459 */
																							BgL_ev_littz00_bglt
																								BgL_new1111z00_4324;
																							{	/* Eval/evaluate.scm 460 */
																								BgL_ev_littz00_bglt
																									BgL_new1110z00_4325;
																								BgL_new1110z00_4325 =
																									((BgL_ev_littz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 460 */
																									long BgL_arg2253z00_4326;

																									{	/* Eval/evaluate.scm 460 */
																										long BgL_res3024z00_4328;

																										BgL_res3024z00_4328 =
																											BGL_CLASS_INDEX
																											(BGl_ev_littz00zz__evaluate_typesz00);
																										BgL_arg2253z00_4326 =
																											BgL_res3024z00_4328;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1110z00_4325),
																										BgL_arg2253z00_4326);
																								}
																								BgL_new1111z00_4324 =
																									BgL_new1110z00_4325;
																							}
																							((((BgL_ev_littz00_bglt)
																										COBJECT
																										(BgL_new1111z00_4324))->
																									BgL_valuez00) =
																								((obj_t) BgL_arg1938z00_1978),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1111z00_4324);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1939z00_1979;

																						BgL_arg1939z00_1979 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6892;
																							{
																								obj_t BgL_argsz00_6894;
																								obj_t BgL_fz00_6893;

																								BgL_fz00_6893 =
																									BgL_arg1939z00_1979;
																								BgL_argsz00_6894 =
																									BgL_cdrzd29337zd2_1972;
																								BgL_argsz00_1532 =
																									BgL_argsz00_6894;
																								BgL_fz00_1531 = BgL_fz00_6893;
																								goto BgL_tagzd2175zd2_1533;
																							}
																							return ((obj_t) BgL_auxz00_6892);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				obj_t BgL_arg1943z00_1982;

																				BgL_arg1943z00_1982 = CAR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6897;

																					{
																						obj_t BgL_argsz00_6899;
																						obj_t BgL_fz00_6898;

																						BgL_fz00_6898 = BgL_arg1943z00_1982;
																						BgL_argsz00_6899 =
																							BgL_cdrzd29337zd2_1972;
																						BgL_argsz00_1532 = BgL_argsz00_6899;
																						BgL_fz00_1531 = BgL_fz00_6898;
																						goto BgL_tagzd2175zd2_1533;
																					}
																					return ((obj_t) BgL_auxz00_6897);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 424 */
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol3216z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 424 */
																				if (PAIRP(BgL_cdrzd29337zd2_1972))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_cdrzd29947zd2_1988;

																						BgL_cdrzd29947zd2_1988 =
																							CDR(BgL_cdrzd29337zd2_1972);
																						if (PAIRP(BgL_cdrzd29947zd2_1988))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_cdrzd29952zd2_1990;

																								BgL_cdrzd29952zd2_1990 =
																									CDR(BgL_cdrzd29947zd2_1988);
																								if (PAIRP
																									(BgL_cdrzd29952zd2_1990))
																									{	/* Eval/evaluate.scm 424 */
																										if (NULLP(CDR
																												(BgL_cdrzd29952zd2_1990)))
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_arg1952z00_1994;
																												obj_t
																													BgL_arg1953z00_1995;
																												obj_t
																													BgL_arg1954z00_1996;
																												BgL_arg1952z00_1994 =
																													CAR
																													(BgL_cdrzd29337zd2_1972);
																												BgL_arg1953z00_1995 =
																													CAR
																													(BgL_cdrzd29947zd2_1988);
																												BgL_arg1954z00_1996 =
																													CAR
																													(BgL_cdrzd29952zd2_1990);
																												{
																													BgL_ev_ifz00_bglt
																														BgL_auxz00_6918;
																													{
																														obj_t BgL_oz00_6921;
																														obj_t BgL_tz00_6920;
																														obj_t BgL_pz00_6919;

																														BgL_pz00_6919 =
																															BgL_arg1952z00_1994;
																														BgL_tz00_6920 =
																															BgL_arg1953z00_1995;
																														BgL_oz00_6921 =
																															BgL_arg1954z00_1996;
																														BgL_oz00_1474 =
																															BgL_oz00_6921;
																														BgL_tz00_1473 =
																															BgL_tz00_6920;
																														BgL_pz00_1472 =
																															BgL_pz00_6919;
																														goto
																															BgL_tagzd2155zd2_1475;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6918);
																												}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												obj_t
																													BgL_arg1955z00_1997;
																												obj_t
																													BgL_arg1956z00_1998;
																												BgL_arg1955z00_1997 =
																													CAR(BgL_ez00_69);
																												BgL_arg1956z00_1998 =
																													CDR(BgL_ez00_69);
																												{
																													BgL_ev_appz00_bglt
																														BgL_auxz00_6925;
																													{
																														obj_t
																															BgL_argsz00_6927;
																														obj_t BgL_fz00_6926;

																														BgL_fz00_6926 =
																															BgL_arg1955z00_1997;
																														BgL_argsz00_6927 =
																															BgL_arg1956z00_1998;
																														BgL_argsz00_1532 =
																															BgL_argsz00_6927;
																														BgL_fz00_1531 =
																															BgL_fz00_6926;
																														goto
																															BgL_tagzd2175zd2_1533;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6925);
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd210250zd2_2000;
																										BgL_cdrzd210250zd2_2000 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 424 */
																											obj_t
																												BgL_cdrzd210256zd2_2001;
																											BgL_cdrzd210256zd2_2001 =
																												CDR(((obj_t)
																													BgL_cdrzd210250zd2_2000));
																											if (NULLP(CDR(((obj_t)
																															BgL_cdrzd210256zd2_2001))))
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_arg1960z00_2004;
																													obj_t
																														BgL_arg1961z00_2005;
																													BgL_arg1960z00_2004 =
																														CAR(((obj_t)
																															BgL_cdrzd210250zd2_2000));
																													BgL_arg1961z00_2005 =
																														CAR(((obj_t)
																															BgL_cdrzd210256zd2_2001));
																													{
																														BgL_ev_ifz00_bglt
																															BgL_auxz00_6940;
																														{
																															obj_t
																																BgL_tz00_6942;
																															obj_t
																																BgL_pz00_6941;
																															BgL_pz00_6941 =
																																BgL_arg1960z00_2004;
																															BgL_tz00_6942 =
																																BgL_arg1961z00_2005;
																															BgL_tz00_1477 =
																																BgL_tz00_6942;
																															BgL_pz00_1476 =
																																BgL_pz00_6941;
																															goto
																																BgL_tagzd2156zd2_1478;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6940);
																													}
																												}
																											else
																												{	/* Eval/evaluate.scm 424 */
																													obj_t
																														BgL_arg1962z00_2006;
																													BgL_arg1962z00_2006 =
																														CAR(BgL_ez00_69);
																													{
																														BgL_ev_appz00_bglt
																															BgL_auxz00_6945;
																														{
																															obj_t
																																BgL_argsz00_6947;
																															obj_t
																																BgL_fz00_6946;
																															BgL_fz00_6946 =
																																BgL_arg1962z00_2006;
																															BgL_argsz00_6947 =
																																BgL_cdrzd210250zd2_2000;
																															BgL_argsz00_1532 =
																																BgL_argsz00_6947;
																															BgL_fz00_1531 =
																																BgL_fz00_6946;
																															goto
																																BgL_tagzd2175zd2_1533;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6945);
																													}
																												}
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1965z00_2009;
																								obj_t BgL_arg1966z00_2010;

																								BgL_arg1965z00_2009 =
																									CAR(BgL_ez00_69);
																								BgL_arg1966z00_2010 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_6951;
																									{
																										obj_t BgL_argsz00_6953;
																										obj_t BgL_fz00_6952;

																										BgL_fz00_6952 =
																											BgL_arg1965z00_2009;
																										BgL_argsz00_6953 =
																											BgL_arg1966z00_2010;
																										BgL_argsz00_1532 =
																											BgL_argsz00_6953;
																										BgL_fz00_1531 =
																											BgL_fz00_6952;
																										goto BgL_tagzd2175zd2_1533;
																									}
																									return
																										((obj_t) BgL_auxz00_6951);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1968z00_2011;
																						obj_t BgL_arg1969z00_2012;

																						BgL_arg1968z00_2011 =
																							CAR(BgL_ez00_69);
																						BgL_arg1969z00_2012 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6957;
																							{
																								obj_t BgL_argsz00_6959;
																								obj_t BgL_fz00_6958;

																								BgL_fz00_6958 =
																									BgL_arg1968z00_2011;
																								BgL_argsz00_6959 =
																									BgL_arg1969z00_2012;
																								BgL_argsz00_1532 =
																									BgL_argsz00_6959;
																								BgL_fz00_1531 = BgL_fz00_6958;
																								goto BgL_tagzd2175zd2_1533;
																							}
																							return ((obj_t) BgL_auxz00_6957);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 424 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol3245z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 424 */
																						obj_t BgL_arg1972z00_2015;

																						BgL_arg1972z00_2015 =
																							CDR(BgL_ez00_69);
																						{	/* Eval/evaluate.scm 472 */
																							BgL_ev_orz00_bglt
																								BgL_new1118z00_4363;
																							{	/* Eval/evaluate.scm 473 */
																								BgL_ev_orz00_bglt
																									BgL_new1116z00_4364;
																								BgL_new1116z00_4364 =
																									((BgL_ev_orz00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_ev_orz00_bgl))));
																								{	/* Eval/evaluate.scm 473 */
																									long BgL_arg2262z00_4365;

																									{	/* Eval/evaluate.scm 473 */
																										long BgL_res3030z00_4367;

																										BgL_res3030z00_4367 =
																											BGL_CLASS_INDEX
																											(BGl_ev_orz00zz__evaluate_typesz00);
																										BgL_arg2262z00_4365 =
																											BgL_res3030z00_4367;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1116z00_4364),
																										BgL_arg2262z00_4365);
																								}
																								BgL_new1118z00_4363 =
																									BgL_new1116z00_4364;
																							}
																							((((BgL_ev_listz00_bglt) COBJECT(
																											((BgL_ev_listz00_bglt)
																												BgL_new1118z00_4363)))->
																									BgL_argsz00) =
																								((obj_t)
																									BGl_loopze70ze7zz__evaluatez00
																									(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_arg1972z00_2015)),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1118z00_4363);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 424 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol3247z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 424 */
																								obj_t BgL_arg1976z00_2018;

																								BgL_arg1976z00_2018 =
																									CDR(BgL_ez00_69);
																								{	/* Eval/evaluate.scm 475 */
																									BgL_ev_andz00_bglt
																										BgL_new1120z00_4372;
																									{	/* Eval/evaluate.scm 476 */
																										BgL_ev_andz00_bglt
																											BgL_new1119z00_4373;
																										BgL_new1119z00_4373 =
																											((BgL_ev_andz00_bglt)
																											BOBJECT(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_andz00_bgl))));
																										{	/* Eval/evaluate.scm 476 */
																											long BgL_arg2263z00_4374;

																											{	/* Eval/evaluate.scm 476 */
																												long
																													BgL_res3031z00_4376;
																												BgL_res3031z00_4376 =
																													BGL_CLASS_INDEX
																													(BGl_ev_andz00zz__evaluate_typesz00);
																												BgL_arg2263z00_4374 =
																													BgL_res3031z00_4376;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1119z00_4373),
																												BgL_arg2263z00_4374);
																										}
																										BgL_new1120z00_4372 =
																											BgL_new1119z00_4373;
																									}
																									((((BgL_ev_listz00_bglt)
																												COBJECT((
																														(BgL_ev_listz00_bglt)
																														BgL_new1120z00_4372)))->
																											BgL_argsz00) =
																										((obj_t)
																											BGl_loopze70ze7zz__evaluatez00
																											(BgL_wherez00_73,
																												BgL_globalsz00_71,
																												BgL_localsz00_70,
																												BgL_locz00_74,
																												BgL_arg1976z00_2018)),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1120z00_4372);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 424 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol3232z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 424 */
																										return
																											BGl_convzd2beginzd2zz__evaluatez00
																											(CDR(BgL_ez00_69),
																											BgL_localsz00_70,
																											BgL_globalsz00_71,
																											BgL_tailzf3zf3_72,
																											BgL_wherez00_73,
																											BgL_locz00_74,
																											BgL_topzf3zf3_75);
																									}
																								else
																									{	/* Eval/evaluate.scm 424 */
																										obj_t
																											BgL_cdrzd211149zd2_2022;
																										BgL_cdrzd211149zd2_2022 =
																											CDR(BgL_ez00_69);
																										if ((CAR(BgL_ez00_69) ==
																												BGl_symbol3218z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 424 */
																												if (PAIRP
																													(BgL_cdrzd211149zd2_2022))
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1983z00_2026;
																														obj_t
																															BgL_arg1984z00_2027;
																														BgL_arg1983z00_2026
																															=
																															CAR
																															(BgL_cdrzd211149zd2_2022);
																														BgL_arg1984z00_2027
																															=
																															CDR
																															(BgL_cdrzd211149zd2_2022);
																														{
																															BgL_ev_letz00_bglt
																																BgL_auxz00_6998;
																															{
																																obj_t
																																	BgL_bodyz00_7000;
																																obj_t
																																	BgL_bindsz00_6999;
																																BgL_bindsz00_6999
																																	=
																																	BgL_arg1983z00_2026;
																																BgL_bodyz00_7000
																																	=
																																	BgL_arg1984z00_2027;
																																BgL_bodyz00_1486
																																	=
																																	BgL_bodyz00_7000;
																																BgL_bindsz00_1485
																																	=
																																	BgL_bindsz00_6999;
																																goto
																																	BgL_tagzd2160zd2_1487;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_6998);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_arg1985z00_2028;
																														BgL_arg1985z00_2028
																															=
																															CAR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_7003;
																															{
																																obj_t
																																	BgL_argsz00_7005;
																																obj_t
																																	BgL_fz00_7004;
																																BgL_fz00_7004 =
																																	BgL_arg1985z00_2028;
																																BgL_argsz00_7005
																																	=
																																	BgL_cdrzd211149zd2_2022;
																																BgL_argsz00_1532
																																	=
																																	BgL_argsz00_7005;
																																BgL_fz00_1531 =
																																	BgL_fz00_7004;
																																goto
																																	BgL_tagzd2175zd2_1533;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_7003);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 424 */
																												if (
																													(CAR(BgL_ez00_69) ==
																														BGl_symbol3249z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 424 */
																														if (PAIRP
																															(BgL_cdrzd211149zd2_2022))
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1990z00_2034;
																																obj_t
																																	BgL_arg1991z00_2035;
																																BgL_arg1990z00_2034
																																	=
																																	CAR
																																	(BgL_cdrzd211149zd2_2022);
																																BgL_arg1991z00_2035
																																	=
																																	CDR
																																	(BgL_cdrzd211149zd2_2022);
																																{
																																	BgL_ev_letza2za2_bglt
																																		BgL_auxz00_7014;
																																	{
																																		obj_t
																																			BgL_bodyz00_7016;
																																		obj_t
																																			BgL_bindsz00_7015;
																																		BgL_bindsz00_7015
																																			=
																																			BgL_arg1990z00_2034;
																																		BgL_bodyz00_7016
																																			=
																																			BgL_arg1991z00_2035;
																																		BgL_bodyz00_1489
																																			=
																																			BgL_bodyz00_7016;
																																		BgL_bindsz00_1488
																																			=
																																			BgL_bindsz00_7015;
																																		goto
																																			BgL_tagzd2161zd2_1490;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_7014);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																obj_t
																																	BgL_arg1993z00_2036;
																																obj_t
																																	BgL_arg1994z00_2037;
																																BgL_arg1993z00_2036
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																BgL_arg1994z00_2037
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_7020;
																																	{
																																		obj_t
																																			BgL_argsz00_7022;
																																		obj_t
																																			BgL_fz00_7021;
																																		BgL_fz00_7021
																																			=
																																			BgL_arg1993z00_2036;
																																		BgL_argsz00_7022
																																			=
																																			BgL_arg1994z00_2037;
																																		BgL_argsz00_1532
																																			=
																																			BgL_argsz00_7022;
																																		BgL_fz00_1531
																																			=
																																			BgL_fz00_7021;
																																		goto
																																			BgL_tagzd2175zd2_1533;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_7020);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 424 */
																														obj_t
																															BgL_cdrzd211543zd2_2038;
																														BgL_cdrzd211543zd2_2038
																															=
																															CDR(BgL_ez00_69);
																														if ((CAR
																																(BgL_ez00_69) ==
																																BGl_symbol3251z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 424 */
																																if (PAIRP
																																	(BgL_cdrzd211543zd2_2038))
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg1998z00_2042;
																																		obj_t
																																			BgL_arg1999z00_2043;
																																		BgL_arg1998z00_2042
																																			=
																																			CAR
																																			(BgL_cdrzd211543zd2_2038);
																																		BgL_arg1999z00_2043
																																			=
																																			CDR
																																			(BgL_cdrzd211543zd2_2038);
																																		{
																																			BgL_ev_letrecz00_bglt
																																				BgL_auxz00_7032;
																																			{
																																				obj_t
																																					BgL_bodyz00_7034;
																																				obj_t
																																					BgL_bindsz00_7033;
																																				BgL_bindsz00_7033
																																					=
																																					BgL_arg1998z00_2042;
																																				BgL_bodyz00_7034
																																					=
																																					BgL_arg1999z00_2043;
																																				BgL_bodyz00_1492
																																					=
																																					BgL_bodyz00_7034;
																																				BgL_bindsz00_1491
																																					=
																																					BgL_bindsz00_7033;
																																				goto
																																					BgL_tagzd2162zd2_1493;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_7032);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_arg2000z00_2044;
																																		BgL_arg2000z00_2044
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_7037;
																																			{
																																				obj_t
																																					BgL_argsz00_7039;
																																				obj_t
																																					BgL_fz00_7038;
																																				BgL_fz00_7038
																																					=
																																					BgL_arg2000z00_2044;
																																				BgL_argsz00_7039
																																					=
																																					BgL_cdrzd211543zd2_2038;
																																				BgL_argsz00_1532
																																					=
																																					BgL_argsz00_7039;
																																				BgL_fz00_1531
																																					=
																																					BgL_fz00_7038;
																																				goto
																																					BgL_tagzd2175zd2_1533;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_7037);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 424 */
																																if (
																																	(CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol3253z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 424 */
																																		if (PAIRP
																																			(BgL_cdrzd211543zd2_2038))
																																			{	/* Eval/evaluate.scm 424 */
																																				obj_t
																																					BgL_carzd211717zd2_2050;
																																				obj_t
																																					BgL_cdrzd211718zd2_2051;
																																				BgL_carzd211717zd2_2050
																																					=
																																					CAR
																																					(BgL_cdrzd211543zd2_2038);
																																				BgL_cdrzd211718zd2_2051
																																					=
																																					CDR
																																					(BgL_cdrzd211543zd2_2038);
																																				if (PAIRP(BgL_carzd211717zd2_2050))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd211722zd2_2053;
																																						BgL_cdrzd211722zd2_2053
																																							=
																																							CDR
																																							(BgL_carzd211717zd2_2050);
																																						if (
																																							(CAR
																																								(BgL_carzd211717zd2_2050)
																																								==
																																								BGl_symbol3239z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd211722zd2_2053))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_carzd211725zd2_2057;
																																										obj_t
																																											BgL_cdrzd211726zd2_2058;
																																										BgL_carzd211725zd2_2057
																																											=
																																											CAR
																																											(BgL_cdrzd211722zd2_2053);
																																										BgL_cdrzd211726zd2_2058
																																											=
																																											CDR
																																											(BgL_cdrzd211722zd2_2053);
																																										if (SYMBOLP(BgL_carzd211725zd2_2057))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd211726zd2_2058))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_carzd211730zd2_2061;
																																														BgL_carzd211730zd2_2061
																																															=
																																															CAR
																																															(BgL_cdrzd211726zd2_2058);
																																														if (SYMBOLP(BgL_carzd211730zd2_2061))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (NULLP(CDR(BgL_cdrzd211726zd2_2058)))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (PAIRP(BgL_cdrzd211718zd2_2051))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				if (NULLP(CDR(BgL_cdrzd211718zd2_2051)))
																																																					{	/* Eval/evaluate.scm 424 */
																																																						obj_t
																																																							BgL_arg2019z00_2068;
																																																						BgL_arg2019z00_2068
																																																							=
																																																							CAR
																																																							(BgL_cdrzd211718zd2_2051);
																																																						{	/* Eval/evaluate.scm 531 */
																																																							BgL_ev_setglobalz00_bglt
																																																								BgL_new1137z00_4423;
																																																							{	/* Eval/evaluate.scm 535 */
																																																								BgL_ev_setglobalz00_bglt
																																																									BgL_new1136z00_4424;
																																																								BgL_new1136z00_4424
																																																									=
																																																									(
																																																									(BgL_ev_setglobalz00_bglt)
																																																									BOBJECT
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_setglobalz00_bgl))));
																																																								{	/* Eval/evaluate.scm 535 */
																																																									long
																																																										BgL_arg2342z00_4425;
																																																									{	/* Eval/evaluate.scm 535 */
																																																										long
																																																											BgL_res3044z00_4427;
																																																										BgL_res3044z00_4427
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																										BgL_arg2342z00_4425
																																																											=
																																																											BgL_res3044z00_4427;
																																																									}
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1136z00_4424), BgL_arg2342z00_4425);
																																																								}
																																																								BgL_new1137z00_4423
																																																									=
																																																									BgL_new1136z00_4424;
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_7078;
																																																								{	/* Eval/evaluate.scm 380 */
																																																									obj_t
																																																										BgL_arg2389z00_4430;
																																																									BgL_arg2389z00_4430
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg2019z00_2068,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_7078
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2locze70z15zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg2019z00_2068,
																																																											BgL_arg2389z00_4430));
																																																								}
																																																								((((BgL_ev_hookz00_bglt) COBJECT(((BgL_ev_hookz00_bglt) BgL_new1137z00_4423)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7078), BUNSPEC);
																																																							}
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1137z00_4423))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1137z00_4423))->BgL_namez00) = ((obj_t) BgL_carzd211725zd2_2057), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1137z00_4423))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd211730zd2_2061)), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1137z00_4423);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 424 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string3156z00zz__evaluatez00,
																																																							BGl_string3231z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string3156z00zz__evaluatez00,
																																																					BGl_string3231z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd211846zd2_2070;
																																																		BgL_cdrzd211846zd2_2070
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_cdrzd211850zd2_2071;
																																																			BgL_cdrzd211850zd2_2071
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd211846zd2_2070));
																																																			if (PAIRP(BgL_cdrzd211850zd2_2071))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					if (NULLP(CDR(BgL_cdrzd211850zd2_2071)))
																																																						{	/* Eval/evaluate.scm 424 */
																																																							obj_t
																																																								BgL_arg2025z00_2075;
																																																							obj_t
																																																								BgL_arg2026z00_2076;
																																																							BgL_arg2025z00_2075
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd211846zd2_2070));
																																																							BgL_arg2026z00_2076
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211850zd2_2071);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_7102;
																																																								{
																																																									obj_t
																																																										BgL_ez00_7104;
																																																									obj_t
																																																										BgL_vz00_7103;
																																																									BgL_vz00_7103
																																																										=
																																																										BgL_arg2025z00_2075;
																																																									BgL_ez00_7104
																																																										=
																																																										BgL_arg2026z00_2076;
																																																									BgL_ez00_1502
																																																										=
																																																										BgL_ez00_7104;
																																																									BgL_vz00_1501
																																																										=
																																																										BgL_vz00_7103;
																																																									goto
																																																										BgL_tagzd2165zd2_1503;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_7102);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 424 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string3156z00zz__evaluatez00,
																																																								BGl_string3231z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3156z00zz__evaluatez00,
																																																						BGl_string3231z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd211907zd2_2079;
																																																BgL_cdrzd211907zd2_2079
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_cdrzd211911zd2_2080;
																																																	BgL_cdrzd211911zd2_2080
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd211907zd2_2079));
																																																	if (PAIRP(BgL_cdrzd211911zd2_2080))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			if (NULLP(CDR(BgL_cdrzd211911zd2_2080)))
																																																				{	/* Eval/evaluate.scm 424 */
																																																					obj_t
																																																						BgL_arg2032z00_2084;
																																																					obj_t
																																																						BgL_arg2033z00_2085;
																																																					BgL_arg2032z00_2084
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd211907zd2_2079));
																																																					BgL_arg2033z00_2085
																																																						=
																																																						CAR
																																																						(BgL_cdrzd211911zd2_2080);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_7119;
																																																						{
																																																							obj_t
																																																								BgL_ez00_7121;
																																																							obj_t
																																																								BgL_vz00_7120;
																																																							BgL_vz00_7120
																																																								=
																																																								BgL_arg2032z00_2084;
																																																							BgL_ez00_7121
																																																								=
																																																								BgL_arg2033z00_2085;
																																																							BgL_ez00_1502
																																																								=
																																																								BgL_ez00_7121;
																																																							BgL_vz00_1501
																																																								=
																																																								BgL_vz00_7120;
																																																							goto
																																																								BgL_tagzd2165zd2_1503;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_7119);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 424 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string3156z00zz__evaluatez00,
																																																						BGl_string3231z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3156z00zz__evaluatez00,
																																																				BGl_string3231z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd211968zd2_2087;
																																														BgL_cdrzd211968zd2_2087
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_cdrzd211972zd2_2088;
																																															BgL_cdrzd211972zd2_2088
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd211968zd2_2087));
																																															if (PAIRP(BgL_cdrzd211972zd2_2088))
																																																{	/* Eval/evaluate.scm 424 */
																																																	if (NULLP(CDR(BgL_cdrzd211972zd2_2088)))
																																																		{	/* Eval/evaluate.scm 424 */
																																																			obj_t
																																																				BgL_arg2038z00_2092;
																																																			obj_t
																																																				BgL_arg2039z00_2093;
																																																			BgL_arg2038z00_2092
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd211968zd2_2087));
																																																			BgL_arg2039z00_2093
																																																				=
																																																				CAR
																																																				(BgL_cdrzd211972zd2_2088);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_7136;
																																																				{
																																																					obj_t
																																																						BgL_ez00_7138;
																																																					obj_t
																																																						BgL_vz00_7137;
																																																					BgL_vz00_7137
																																																						=
																																																						BgL_arg2038z00_2092;
																																																					BgL_ez00_7138
																																																						=
																																																						BgL_arg2039z00_2093;
																																																					BgL_ez00_1502
																																																						=
																																																						BgL_ez00_7138;
																																																					BgL_vz00_1501
																																																						=
																																																						BgL_vz00_7137;
																																																					goto
																																																						BgL_tagzd2165zd2_1503;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_7136);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 424 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string3156z00zz__evaluatez00,
																																																				BGl_string3231z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3156z00zz__evaluatez00,
																																																		BGl_string3231z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd212029zd2_2095;
																																												BgL_cdrzd212029zd2_2095
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 424 */
																																													obj_t
																																														BgL_cdrzd212033zd2_2096;
																																													BgL_cdrzd212033zd2_2096
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd212029zd2_2095));
																																													if (PAIRP(BgL_cdrzd212033zd2_2096))
																																														{	/* Eval/evaluate.scm 424 */
																																															if (NULLP(CDR(BgL_cdrzd212033zd2_2096)))
																																																{	/* Eval/evaluate.scm 424 */
																																																	obj_t
																																																		BgL_arg2046z00_2100;
																																																	obj_t
																																																		BgL_arg2047z00_2101;
																																																	BgL_arg2046z00_2100
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd212029zd2_2095));
																																																	BgL_arg2047z00_2101
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212033zd2_2096);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_7153;
																																																		{
																																																			obj_t
																																																				BgL_ez00_7155;
																																																			obj_t
																																																				BgL_vz00_7154;
																																																			BgL_vz00_7154
																																																				=
																																																				BgL_arg2046z00_2100;
																																																			BgL_ez00_7155
																																																				=
																																																				BgL_arg2047z00_2101;
																																																			BgL_ez00_1502
																																																				=
																																																				BgL_ez00_7155;
																																																			BgL_vz00_1501
																																																				=
																																																				BgL_vz00_7154;
																																																			goto
																																																				BgL_tagzd2165zd2_1503;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_7153);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 424 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string3156z00zz__evaluatez00,
																																																		BGl_string3231z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212090zd2_2103;
																																										BgL_cdrzd212090zd2_2103
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_cdrzd212094zd2_2104;
																																											BgL_cdrzd212094zd2_2104
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd212090zd2_2103));
																																											if (PAIRP(BgL_cdrzd212094zd2_2104))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212094zd2_2104)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2052z00_2108;
																																															obj_t
																																																BgL_arg2053z00_2109;
																																															BgL_arg2052z00_2108
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd212090zd2_2103));
																																															BgL_arg2053z00_2109
																																																=
																																																CAR
																																																(BgL_cdrzd212094zd2_2104);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_7170;
																																																{
																																																	obj_t
																																																		BgL_ez00_7172;
																																																	obj_t
																																																		BgL_vz00_7171;
																																																	BgL_vz00_7171
																																																		=
																																																		BgL_arg2052z00_2108;
																																																	BgL_ez00_7172
																																																		=
																																																		BgL_arg2053z00_2109;
																																																	BgL_ez00_1502
																																																		=
																																																		BgL_ez00_7172;
																																																	BgL_vz00_1501
																																																		=
																																																		BgL_vz00_7171;
																																																	goto
																																																		BgL_tagzd2165zd2_1503;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_7170);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3156z00zz__evaluatez00,
																																														BGl_string3231z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_cdrzd212138zd2_2111;
																																								BgL_cdrzd212138zd2_2111
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 424 */
																																									obj_t
																																										BgL_carzd212141zd2_2112;
																																									obj_t
																																										BgL_cdrzd212142zd2_2113;
																																									BgL_carzd212141zd2_2112
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd212138zd2_2111));
																																									BgL_cdrzd212142zd2_2113
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd212138zd2_2111));
																																									if ((CAR(((obj_t) BgL_carzd212141zd2_2112)) == BGl_symbol3241z00zz__evaluatez00))
																																										{	/* Eval/evaluate.scm 424 */
																																											if (PAIRP(BgL_cdrzd212142zd2_2113))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212142zd2_2113)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2061z00_2119;
																																															obj_t
																																																BgL_arg2062z00_2120;
																																															BgL_arg2061z00_2119
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd212141zd2_2112));
																																															BgL_arg2062z00_2120
																																																=
																																																CAR
																																																(BgL_cdrzd212142zd2_2113);
																																															{
																																																obj_t
																																																	BgL_e2z00_7194;
																																																obj_t
																																																	BgL_lz00_7193;
																																																BgL_lz00_7193
																																																	=
																																																	BgL_arg2061z00_2119;
																																																BgL_e2z00_7194
																																																	=
																																																	BgL_arg2062z00_2120;
																																																BgL_e2z00_1499
																																																	=
																																																	BgL_e2z00_7194;
																																																BgL_lz00_1498
																																																	=
																																																	BgL_lz00_7193;
																																																goto
																																																	BgL_tagzd2164zd2_1500;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3156z00zz__evaluatez00,
																																														BGl_string3231z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_cdrzd212218zd2_2123;
																																											BgL_cdrzd212218zd2_2123
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd212138zd2_2111));
																																											if (PAIRP(BgL_cdrzd212218zd2_2123))
																																												{	/* Eval/evaluate.scm 424 */
																																													if (NULLP(CDR(BgL_cdrzd212218zd2_2123)))
																																														{	/* Eval/evaluate.scm 424 */
																																															obj_t
																																																BgL_arg2067z00_2127;
																																															obj_t
																																																BgL_arg2068z00_2128;
																																															BgL_arg2067z00_2127
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd212138zd2_2111));
																																															BgL_arg2068z00_2128
																																																=
																																																CAR
																																																(BgL_cdrzd212218zd2_2123);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_7207;
																																																{
																																																	obj_t
																																																		BgL_ez00_7209;
																																																	obj_t
																																																		BgL_vz00_7208;
																																																	BgL_vz00_7208
																																																		=
																																																		BgL_arg2067z00_2127;
																																																	BgL_ez00_7209
																																																		=
																																																		BgL_arg2068z00_2128;
																																																	BgL_ez00_1502
																																																		=
																																																		BgL_ez00_7209;
																																																	BgL_vz00_1501
																																																		=
																																																		BgL_vz00_7208;
																																																	goto
																																																		BgL_tagzd2165zd2_1503;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_7207);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 424 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string3156z00zz__evaluatez00,
																																																BGl_string3231z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 424 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string3156z00zz__evaluatez00,
																																														BGl_string3231z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd212275zd2_2132;
																																						BgL_cdrzd212275zd2_2132
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						{	/* Eval/evaluate.scm 424 */
																																							obj_t
																																								BgL_cdrzd212279zd2_2133;
																																							BgL_cdrzd212279zd2_2133
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd212275zd2_2132));
																																							if (PAIRP(BgL_cdrzd212279zd2_2133))
																																								{	/* Eval/evaluate.scm 424 */
																																									if (NULLP(CDR(BgL_cdrzd212279zd2_2133)))
																																										{	/* Eval/evaluate.scm 424 */
																																											obj_t
																																												BgL_arg2075z00_2137;
																																											obj_t
																																												BgL_arg2076z00_2138;
																																											BgL_arg2075z00_2137
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd212275zd2_2132));
																																											BgL_arg2076z00_2138
																																												=
																																												CAR
																																												(BgL_cdrzd212279zd2_2133);
																																											{
																																												BgL_ev_hookz00_bglt
																																													BgL_auxz00_7224;
																																												{
																																													obj_t
																																														BgL_ez00_7226;
																																													obj_t
																																														BgL_vz00_7225;
																																													BgL_vz00_7225
																																														=
																																														BgL_arg2075z00_2137;
																																													BgL_ez00_7226
																																														=
																																														BgL_arg2076z00_2138;
																																													BgL_ez00_1502
																																														=
																																														BgL_ez00_7226;
																																													BgL_vz00_1501
																																														=
																																														BgL_vz00_7225;
																																													goto
																																														BgL_tagzd2165zd2_1503;
																																												}
																																												return
																																													(
																																													(obj_t)
																																													BgL_auxz00_7224);
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 424 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string3156z00zz__evaluatez00,
																																												BGl_string3231z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 424 */
																																									return
																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																										(BgL_locz00_74,
																																										BGl_string3156z00zz__evaluatez00,
																																										BGl_string3231z00zz__evaluatez00,
																																										BgL_ez00_69);
																																								}
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				return
																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																					(BgL_locz00_74,
																																					BGl_string3156z00zz__evaluatez00,
																																					BGl_string3231z00zz__evaluatez00,
																																					BgL_ez00_69);
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 424 */
																																		obj_t
																																			BgL_cdrzd212400zd2_2140;
																																		BgL_cdrzd212400zd2_2140
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		if ((CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol3255z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 424 */
																																				if (PAIRP(BgL_cdrzd212400zd2_2140))
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd212405zd2_2144;
																																						BgL_cdrzd212405zd2_2144
																																							=
																																							CDR
																																							(BgL_cdrzd212400zd2_2140);
																																						if (PAIRP(BgL_cdrzd212405zd2_2144))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_carzd212409zd2_2146;
																																								BgL_carzd212409zd2_2146
																																									=
																																									CAR
																																									(BgL_cdrzd212405zd2_2144);
																																								if (PAIRP(BgL_carzd212409zd2_2146))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212414zd2_2148;
																																										BgL_cdrzd212414zd2_2148
																																											=
																																											CDR
																																											(BgL_carzd212409zd2_2146);
																																										if ((CAR(BgL_carzd212409zd2_2146) == BGl_symbol3220z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd212414zd2_2148))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212418zd2_2152;
																																														BgL_cdrzd212418zd2_2152
																																															=
																																															CDR
																																															(BgL_cdrzd212414zd2_2148);
																																														if (PAIRP(BgL_cdrzd212418zd2_2152))
																																															{	/* Eval/evaluate.scm 424 */
																																																if (NULLP(CDR(BgL_cdrzd212418zd2_2152)))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd212405zd2_2144)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2092z00_2158;
																																																				obj_t
																																																					BgL_arg2093z00_2159;
																																																				obj_t
																																																					BgL_arg2094z00_2160;
																																																				BgL_arg2092z00_2158
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212400zd2_2140);
																																																				BgL_arg2093z00_2159
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212414zd2_2148);
																																																				BgL_arg2094z00_2160
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212418zd2_2152);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_7261;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7264;
																																																						obj_t
																																																							BgL_formalsz00_7263;
																																																						obj_t
																																																							BgL_gvz00_7262;
																																																						BgL_gvz00_7262
																																																							=
																																																							BgL_arg2092z00_2158;
																																																						BgL_formalsz00_7263
																																																							=
																																																							BgL_arg2093z00_2159;
																																																						BgL_bodyz00_7264
																																																							=
																																																							BgL_arg2094z00_2160;
																																																						BgL_bodyz00_1507
																																																							=
																																																							BgL_bodyz00_7264;
																																																						BgL_formalsz00_1506
																																																							=
																																																							BgL_formalsz00_7263;
																																																						BgL_gvz00_1505
																																																							=
																																																							BgL_gvz00_7262;
																																																						goto
																																																							BgL_tagzd2167zd2_1508;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7261);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2097z00_2161;
																																																				BgL_arg2097z00_2161
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7267;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7269;
																																																						obj_t
																																																							BgL_fz00_7268;
																																																						BgL_fz00_7268
																																																							=
																																																							BgL_arg2097z00_2161;
																																																						BgL_argsz00_7269
																																																							=
																																																							BgL_cdrzd212400zd2_2140;
																																																						BgL_argsz00_1532
																																																							=
																																																							BgL_argsz00_7269;
																																																						BgL_fz00_1531
																																																							=
																																																							BgL_fz00_7268;
																																																						goto
																																																							BgL_tagzd2175zd2_1533;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7267);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_cdrzd212518zd2_2165;
																																																		BgL_cdrzd212518zd2_2165
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd212400zd2_2140));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212518zd2_2165))))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2102z00_2168;
																																																				obj_t
																																																					BgL_arg2103z00_2169;
																																																				BgL_arg2102z00_2168
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd212400zd2_2140));
																																																				BgL_arg2103z00_2169
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd212518zd2_2165));
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_7281;
																																																					{
																																																						obj_t
																																																							BgL_gez00_7283;
																																																						obj_t
																																																							BgL_gvz00_7282;
																																																						BgL_gvz00_7282
																																																							=
																																																							BgL_arg2102z00_2168;
																																																						BgL_gez00_7283
																																																							=
																																																							BgL_arg2103z00_2169;
																																																						BgL_gez00_1510
																																																							=
																																																							BgL_gez00_7283;
																																																						BgL_gvz00_1509
																																																							=
																																																							BgL_gvz00_7282;
																																																						goto
																																																							BgL_tagzd2168zd2_1511;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7281);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2104z00_2170;
																																																				obj_t
																																																					BgL_arg2105z00_2171;
																																																				BgL_arg2104z00_2170
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2105z00_2171
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7287;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7289;
																																																						obj_t
																																																							BgL_fz00_7288;
																																																						BgL_fz00_7288
																																																							=
																																																							BgL_arg2104z00_2170;
																																																						BgL_argsz00_7289
																																																							=
																																																							BgL_arg2105z00_2171;
																																																						BgL_argsz00_1532
																																																							=
																																																							BgL_argsz00_7289;
																																																						BgL_fz00_1531
																																																							=
																																																							BgL_fz00_7288;
																																																						goto
																																																							BgL_tagzd2175zd2_1533;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7287);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd212605zd2_2175;
																																																BgL_cdrzd212605zd2_2175
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd212400zd2_2140));
																																																if (NULLP(CDR(((obj_t) BgL_cdrzd212605zd2_2175))))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2112z00_2178;
																																																		obj_t
																																																			BgL_arg2114z00_2179;
																																																		BgL_arg2112z00_2178
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd212400zd2_2140));
																																																		BgL_arg2114z00_2179
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd212605zd2_2175));
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_7301;
																																																			{
																																																				obj_t
																																																					BgL_gez00_7303;
																																																				obj_t
																																																					BgL_gvz00_7302;
																																																				BgL_gvz00_7302
																																																					=
																																																					BgL_arg2112z00_2178;
																																																				BgL_gez00_7303
																																																					=
																																																					BgL_arg2114z00_2179;
																																																				BgL_gez00_1510
																																																					=
																																																					BgL_gez00_7303;
																																																				BgL_gvz00_1509
																																																					=
																																																					BgL_gvz00_7302;
																																																				goto
																																																					BgL_tagzd2168zd2_1511;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7301);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2115z00_2180;
																																																		obj_t
																																																			BgL_arg2116z00_2181;
																																																		BgL_arg2115z00_2180
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2116z00_2181
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7307;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7309;
																																																				obj_t
																																																					BgL_fz00_7308;
																																																				BgL_fz00_7308
																																																					=
																																																					BgL_arg2115z00_2180;
																																																				BgL_argsz00_7309
																																																					=
																																																					BgL_arg2116z00_2181;
																																																				BgL_argsz00_1532
																																																					=
																																																					BgL_argsz00_7309;
																																																				BgL_fz00_1531
																																																					=
																																																					BgL_fz00_7308;
																																																				goto
																																																					BgL_tagzd2175zd2_1533;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7307);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd212692zd2_2184;
																																														BgL_cdrzd212692zd2_2184
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_cdrzd212400zd2_2140));
																																														if (NULLP(CDR(((obj_t) BgL_cdrzd212692zd2_2184))))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2120z00_2187;
																																																obj_t
																																																	BgL_arg2121z00_2188;
																																																BgL_arg2120z00_2187
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd212400zd2_2140));
																																																BgL_arg2121z00_2188
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd212692zd2_2184));
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_7321;
																																																	{
																																																		obj_t
																																																			BgL_gez00_7323;
																																																		obj_t
																																																			BgL_gvz00_7322;
																																																		BgL_gvz00_7322
																																																			=
																																																			BgL_arg2120z00_2187;
																																																		BgL_gez00_7323
																																																			=
																																																			BgL_arg2121z00_2188;
																																																		BgL_gez00_1510
																																																			=
																																																			BgL_gez00_7323;
																																																		BgL_gvz00_1509
																																																			=
																																																			BgL_gvz00_7322;
																																																		goto
																																																			BgL_tagzd2168zd2_1511;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7321);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2122z00_2189;
																																																obj_t
																																																	BgL_arg2123z00_2190;
																																																BgL_arg2122z00_2189
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2123z00_2190
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7327;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7329;
																																																		obj_t
																																																			BgL_fz00_7328;
																																																		BgL_fz00_7328
																																																			=
																																																			BgL_arg2122z00_2189;
																																																		BgL_argsz00_7329
																																																			=
																																																			BgL_arg2123z00_2190;
																																																		BgL_argsz00_1532
																																																			=
																																																			BgL_argsz00_7329;
																																																		BgL_fz00_1531
																																																			=
																																																			BgL_fz00_7328;
																																																		goto
																																																			BgL_tagzd2175zd2_1533;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7327);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_cdrzd212779zd2_2193;
																																												BgL_cdrzd212779zd2_2193
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_cdrzd212400zd2_2140));
																																												if (NULLP(CDR(((obj_t) BgL_cdrzd212779zd2_2193))))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2127z00_2196;
																																														obj_t
																																															BgL_arg2128z00_2197;
																																														BgL_arg2127z00_2196
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd212400zd2_2140));
																																														BgL_arg2128z00_2197
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_cdrzd212779zd2_2193));
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_7341;
																																															{
																																																obj_t
																																																	BgL_gez00_7343;
																																																obj_t
																																																	BgL_gvz00_7342;
																																																BgL_gvz00_7342
																																																	=
																																																	BgL_arg2127z00_2196;
																																																BgL_gez00_7343
																																																	=
																																																	BgL_arg2128z00_2197;
																																																BgL_gez00_1510
																																																	=
																																																	BgL_gez00_7343;
																																																BgL_gvz00_1509
																																																	=
																																																	BgL_gvz00_7342;
																																																goto
																																																	BgL_tagzd2168zd2_1511;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7341);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2129z00_2198;
																																														obj_t
																																															BgL_arg2131z00_2199;
																																														BgL_arg2129z00_2198
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2131z00_2199
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7347;
																																															{
																																																obj_t
																																																	BgL_argsz00_7349;
																																																obj_t
																																																	BgL_fz00_7348;
																																																BgL_fz00_7348
																																																	=
																																																	BgL_arg2129z00_2198;
																																																BgL_argsz00_7349
																																																	=
																																																	BgL_arg2131z00_2199;
																																																BgL_argsz00_1532
																																																	=
																																																	BgL_argsz00_7349;
																																																BgL_fz00_1531
																																																	=
																																																	BgL_fz00_7348;
																																																goto
																																																	BgL_tagzd2175zd2_1533;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7347);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd212866zd2_2203;
																																										BgL_cdrzd212866zd2_2203
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_cdrzd212400zd2_2140));
																																										if (NULLP(CDR(((obj_t) BgL_cdrzd212866zd2_2203))))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2136z00_2206;
																																												obj_t
																																													BgL_arg2137z00_2207;
																																												BgL_arg2136z00_2206
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_cdrzd212400zd2_2140));
																																												BgL_arg2137z00_2207
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_cdrzd212866zd2_2203));
																																												{
																																													BgL_ev_defglobalz00_bglt
																																														BgL_auxz00_7361;
																																													{
																																														obj_t
																																															BgL_gez00_7363;
																																														obj_t
																																															BgL_gvz00_7362;
																																														BgL_gvz00_7362
																																															=
																																															BgL_arg2136z00_2206;
																																														BgL_gez00_7363
																																															=
																																															BgL_arg2137z00_2207;
																																														BgL_gez00_1510
																																															=
																																															BgL_gez00_7363;
																																														BgL_gvz00_1509
																																															=
																																															BgL_gvz00_7362;
																																														goto
																																															BgL_tagzd2168zd2_1511;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7361);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2138z00_2208;
																																												obj_t
																																													BgL_arg2139z00_2209;
																																												BgL_arg2138z00_2208
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2139z00_2209
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7367;
																																													{
																																														obj_t
																																															BgL_argsz00_7369;
																																														obj_t
																																															BgL_fz00_7368;
																																														BgL_fz00_7368
																																															=
																																															BgL_arg2138z00_2208;
																																														BgL_argsz00_7369
																																															=
																																															BgL_arg2139z00_2209;
																																														BgL_argsz00_1532
																																															=
																																															BgL_argsz00_7369;
																																														BgL_fz00_1531
																																															=
																																															BgL_fz00_7368;
																																														goto
																																															BgL_tagzd2175zd2_1533;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7367);
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg2141z00_2211;
																																								BgL_arg2141z00_2211
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7372;
																																									{
																																										obj_t
																																											BgL_argsz00_7374;
																																										obj_t
																																											BgL_fz00_7373;
																																										BgL_fz00_7373
																																											=
																																											BgL_arg2141z00_2211;
																																										BgL_argsz00_7374
																																											=
																																											BgL_cdrzd212400zd2_2140;
																																										BgL_argsz00_1532
																																											=
																																											BgL_argsz00_7374;
																																										BgL_fz00_1531
																																											=
																																											BgL_fz00_7373;
																																										goto
																																											BgL_tagzd2175zd2_1533;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7372);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_arg2143z00_2213;
																																						BgL_arg2143z00_2213
																																							=
																																							CAR
																																							(BgL_ez00_69);
																																						{
																																							BgL_ev_appz00_bglt
																																								BgL_auxz00_7377;
																																							{
																																								obj_t
																																									BgL_argsz00_7379;
																																								obj_t
																																									BgL_fz00_7378;
																																								BgL_fz00_7378
																																									=
																																									BgL_arg2143z00_2213;
																																								BgL_argsz00_7379
																																									=
																																									BgL_cdrzd212400zd2_2140;
																																								BgL_argsz00_1532
																																									=
																																									BgL_argsz00_7379;
																																								BgL_fz00_1531
																																									=
																																									BgL_fz00_7378;
																																								goto
																																									BgL_tagzd2175zd2_1533;
																																							}
																																							return
																																								(
																																								(obj_t)
																																								BgL_auxz00_7377);
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 424 */
																																				if (
																																					(CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol3257z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 424 */
																																						if (PAIRP(BgL_cdrzd212400zd2_2140))
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_carzd213108zd2_2219;
																																								BgL_carzd213108zd2_2219
																																									=
																																									CAR
																																									(BgL_cdrzd212400zd2_2140);
																																								if (PAIRP(BgL_carzd213108zd2_2219))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (NULLP(CDR(BgL_carzd213108zd2_2219)))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2151z00_2223;
																																												obj_t
																																													BgL_arg2152z00_2224;
																																												BgL_arg2151z00_2223
																																													=
																																													CAR
																																													(BgL_carzd213108zd2_2219);
																																												BgL_arg2152z00_2224
																																													=
																																													CDR
																																													(BgL_cdrzd212400zd2_2140);
																																												{
																																													BgL_ev_bindzd2exitzd2_bglt
																																														BgL_auxz00_7394;
																																													{
																																														obj_t
																																															BgL_bodyz00_7396;
																																														obj_t
																																															BgL_vz00_7395;
																																														BgL_vz00_7395
																																															=
																																															BgL_arg2151z00_2223;
																																														BgL_bodyz00_7396
																																															=
																																															BgL_arg2152z00_2224;
																																														BgL_bodyz00_1513
																																															=
																																															BgL_bodyz00_7396;
																																														BgL_vz00_1512
																																															=
																																															BgL_vz00_7395;
																																														goto
																																															BgL_tagzd2169zd2_1514;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7394);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2153z00_2225;
																																												obj_t
																																													BgL_arg2154z00_2226;
																																												BgL_arg2153z00_2225
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2154z00_2226
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7400;
																																													{
																																														obj_t
																																															BgL_argsz00_7402;
																																														obj_t
																																															BgL_fz00_7401;
																																														BgL_fz00_7401
																																															=
																																															BgL_arg2153z00_2225;
																																														BgL_argsz00_7402
																																															=
																																															BgL_arg2154z00_2226;
																																														BgL_argsz00_1532
																																															=
																																															BgL_argsz00_7402;
																																														BgL_fz00_1531
																																															=
																																															BgL_fz00_7401;
																																														goto
																																															BgL_tagzd2175zd2_1533;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7400);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2156z00_2228;
																																										obj_t
																																											BgL_arg2157z00_2229;
																																										BgL_arg2156z00_2228
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg2157z00_2229
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7406;
																																											{
																																												obj_t
																																													BgL_argsz00_7408;
																																												obj_t
																																													BgL_fz00_7407;
																																												BgL_fz00_7407
																																													=
																																													BgL_arg2156z00_2228;
																																												BgL_argsz00_7408
																																													=
																																													BgL_arg2157z00_2229;
																																												BgL_argsz00_1532
																																													=
																																													BgL_argsz00_7408;
																																												BgL_fz00_1531
																																													=
																																													BgL_fz00_7407;
																																												goto
																																													BgL_tagzd2175zd2_1533;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7406);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								obj_t
																																									BgL_arg2158z00_2230;
																																								obj_t
																																									BgL_arg2159z00_2231;
																																								BgL_arg2158z00_2230
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								BgL_arg2159z00_2231
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7412;
																																									{
																																										obj_t
																																											BgL_argsz00_7414;
																																										obj_t
																																											BgL_fz00_7413;
																																										BgL_fz00_7413
																																											=
																																											BgL_arg2158z00_2230;
																																										BgL_argsz00_7414
																																											=
																																											BgL_arg2159z00_2231;
																																										BgL_argsz00_1532
																																											=
																																											BgL_argsz00_7414;
																																										BgL_fz00_1531
																																											=
																																											BgL_fz00_7413;
																																										goto
																																											BgL_tagzd2175zd2_1533;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7412);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 424 */
																																						obj_t
																																							BgL_cdrzd213273zd2_2232;
																																						BgL_cdrzd213273zd2_2232
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol3259z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 424 */
																																								if (PAIRP(BgL_cdrzd213273zd2_2232))
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2163z00_2236;
																																										obj_t
																																											BgL_arg2164z00_2237;
																																										BgL_arg2163z00_2236
																																											=
																																											CAR
																																											(BgL_cdrzd213273zd2_2232);
																																										BgL_arg2164z00_2237
																																											=
																																											CDR
																																											(BgL_cdrzd213273zd2_2232);
																																										{	/* Eval/evaluate.scm 575 */
																																											BgL_ev_unwindzd2protectzd2_bglt
																																												BgL_new1151z00_4574;
																																											{	/* Eval/evaluate.scm 576 */
																																												BgL_ev_unwindzd2protectzd2_bglt
																																													BgL_new1150z00_4575;
																																												BgL_new1150z00_4575
																																													=
																																													(
																																													(BgL_ev_unwindzd2protectzd2_bglt)
																																													BOBJECT
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_unwindzd2protectzd2_bgl))));
																																												{	/* Eval/evaluate.scm 576 */
																																													long
																																														BgL_arg2374z00_4576;
																																													{	/* Eval/evaluate.scm 576 */
																																														long
																																															BgL_res3077z00_4578;
																																														BgL_res3077z00_4578
																																															=
																																															BGL_CLASS_INDEX
																																															(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																														BgL_arg2374z00_4576
																																															=
																																															BgL_res3077z00_4578;
																																													}
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1150z00_4575), BgL_arg2374z00_4576);
																																												}
																																												BgL_new1151z00_4574
																																													=
																																													BgL_new1150z00_4575;
																																											}
																																											{
																																												BgL_ev_exprz00_bglt
																																													BgL_auxz00_7428;
																																												{	/* Eval/evaluate.scm 380 */
																																													obj_t
																																														BgL_arg2389z00_4581;
																																													BgL_arg2389z00_4581
																																														=
																																														BGl_getzd2locationzd2zz__evaluatez00
																																														(BgL_arg2163z00_2236,
																																														BgL_locz00_74);
																																													BgL_auxz00_7428
																																														=
																																														(
																																														(BgL_ev_exprz00_bglt)
																																														BGl_uconvzf2locze70z15zz__evaluatez00
																																														(BgL_wherez00_73,
																																															BgL_globalsz00_71,
																																															BgL_localsz00_70,
																																															BgL_arg2163z00_2236,
																																															BgL_arg2389z00_4581));
																																												}
																																												((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1151z00_4574))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7428), BUNSPEC);
																																											}
																																											((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1151z00_4574))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2164z00_2237, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																											return
																																												(
																																												(obj_t)
																																												BgL_new1151z00_4574);
																																										}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_arg2165z00_2238;
																																										BgL_arg2165z00_2238
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7438;
																																											{
																																												obj_t
																																													BgL_argsz00_7440;
																																												obj_t
																																													BgL_fz00_7439;
																																												BgL_fz00_7439
																																													=
																																													BgL_arg2165z00_2238;
																																												BgL_argsz00_7440
																																													=
																																													BgL_cdrzd213273zd2_2232;
																																												BgL_argsz00_1532
																																													=
																																													BgL_argsz00_7440;
																																												BgL_fz00_1531
																																													=
																																													BgL_fz00_7439;
																																												goto
																																													BgL_tagzd2175zd2_1533;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7438);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 424 */
																																								if ((CAR(BgL_ez00_69) == BGl_symbol3261z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 424 */
																																										if (PAIRP(BgL_cdrzd213273zd2_2232))
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2170z00_2244;
																																												obj_t
																																													BgL_arg2171z00_2245;
																																												BgL_arg2170z00_2244
																																													=
																																													CAR
																																													(BgL_cdrzd213273zd2_2232);
																																												BgL_arg2171z00_2245
																																													=
																																													CDR
																																													(BgL_cdrzd213273zd2_2232);
																																												{	/* Eval/evaluate.scm 579 */
																																													BgL_ev_withzd2handlerzd2_bglt
																																														BgL_new1153z00_4589;
																																													{	/* Eval/evaluate.scm 580 */
																																														BgL_ev_withzd2handlerzd2_bglt
																																															BgL_new1152z00_4590;
																																														BgL_new1152z00_4590
																																															=
																																															(
																																															(BgL_ev_withzd2handlerzd2_bglt)
																																															BOBJECT
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_withzd2handlerzd2_bgl))));
																																														{	/* Eval/evaluate.scm 580 */
																																															long
																																																BgL_arg2375z00_4591;
																																															{	/* Eval/evaluate.scm 580 */
																																																long
																																																	BgL_res3079z00_4593;
																																																BgL_res3079z00_4593
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																BgL_arg2375z00_4591
																																																	=
																																																	BgL_res3079z00_4593;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1152z00_4590), BgL_arg2375z00_4591);
																																														}
																																														BgL_new1153z00_4589
																																															=
																																															BgL_new1152z00_4590;
																																													}
																																													{
																																														BgL_ev_exprz00_bglt
																																															BgL_auxz00_7453;
																																														{	/* Eval/evaluate.scm 380 */
																																															obj_t
																																																BgL_arg2389z00_4596;
																																															BgL_arg2389z00_4596
																																																=
																																																BGl_getzd2locationzd2zz__evaluatez00
																																																(BgL_arg2170z00_2244,
																																																BgL_locz00_74);
																																															BgL_auxz00_7453
																																																=
																																																(
																																																(BgL_ev_exprz00_bglt)
																																																BGl_uconvzf2locze70z15zz__evaluatez00
																																																(BgL_wherez00_73,
																																																	BgL_globalsz00_71,
																																																	BgL_localsz00_70,
																																																	BgL_arg2170z00_2244,
																																																	BgL_arg2389z00_4596));
																																														}
																																														((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1153z00_4589))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7453), BUNSPEC);
																																													}
																																													((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1153z00_4589))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2171z00_2245, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													return
																																														(
																																														(obj_t)
																																														BgL_new1153z00_4589);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												obj_t
																																													BgL_arg2172z00_2246;
																																												obj_t
																																													BgL_arg2173z00_2247;
																																												BgL_arg2172z00_2246
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2173z00_2247
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7464;
																																													{
																																														obj_t
																																															BgL_argsz00_7466;
																																														obj_t
																																															BgL_fz00_7465;
																																														BgL_fz00_7465
																																															=
																																															BgL_arg2172z00_2246;
																																														BgL_argsz00_7466
																																															=
																																															BgL_arg2173z00_2247;
																																														BgL_argsz00_1532
																																															=
																																															BgL_argsz00_7466;
																																														BgL_fz00_1531
																																															=
																																															BgL_fz00_7465;
																																														goto
																																															BgL_tagzd2175zd2_1533;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7464);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 424 */
																																										obj_t
																																											BgL_cdrzd213376zd2_2248;
																																										BgL_cdrzd213376zd2_2248
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										if ((CAR(BgL_ez00_69) == BGl_symbol3263z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 424 */
																																												if (PAIRP(BgL_cdrzd213376zd2_2248))
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_cdrzd213381zd2_2252;
																																														BgL_cdrzd213381zd2_2252
																																															=
																																															CDR
																																															(BgL_cdrzd213376zd2_2248);
																																														if (PAIRP(BgL_cdrzd213381zd2_2252))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd213386zd2_2254;
																																																BgL_cdrzd213386zd2_2254
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213381zd2_2252);
																																																if ((CAR(BgL_cdrzd213381zd2_2252) == BGl_keyword3265z00zz__evaluatez00))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (PAIRP(BgL_cdrzd213386zd2_2254))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2181z00_2258;
																																																				obj_t
																																																					BgL_arg2182z00_2259;
																																																				obj_t
																																																					BgL_arg2183z00_2260;
																																																				BgL_arg2181z00_2258
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2248);
																																																				BgL_arg2182z00_2259
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213386zd2_2254);
																																																				BgL_arg2183z00_2260
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213386zd2_2254);
																																																				{	/* Eval/evaluate.scm 583 */
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_new1156z00_4610;
																																																					{	/* Eval/evaluate.scm 584 */
																																																						BgL_ev_synchroniza7eza7_bglt
																																																							BgL_new1155z00_4611;
																																																						BgL_new1155z00_4611
																																																							=
																																																							(
																																																							(BgL_ev_synchroniza7eza7_bglt)
																																																							BOBJECT
																																																							(GC_MALLOC
																																																								(sizeof
																																																									(struct
																																																										BgL_ev_synchroniza7eza7_bgl))));
																																																						{	/* Eval/evaluate.scm 584 */
																																																							long
																																																								BgL_arg2376z00_4612;
																																																							{	/* Eval/evaluate.scm 584 */
																																																								long
																																																									BgL_res3083z00_4614;
																																																								BgL_res3083z00_4614
																																																									=
																																																									BGL_CLASS_INDEX
																																																									(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																								BgL_arg2376z00_4612
																																																									=
																																																									BgL_res3083z00_4614;
																																																							}
																																																							BGL_OBJECT_CLASS_NUM_SET
																																																								(
																																																								((BgL_objectz00_bglt) BgL_new1155z00_4611), BgL_arg2376z00_4612);
																																																						}
																																																						BgL_new1156z00_4610
																																																							=
																																																							BgL_new1155z00_4611;
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4610))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_7491;
																																																						{	/* Eval/evaluate.scm 380 */
																																																							obj_t
																																																								BgL_arg2389z00_4617;
																																																							BgL_arg2389z00_4617
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg2181z00_2258,
																																																								BgL_locz00_74);
																																																							BgL_auxz00_7491
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2locze70z15zz__evaluatez00
																																																								(BgL_wherez00_73,
																																																									BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_arg2181z00_2258,
																																																									BgL_arg2389z00_4617));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4610))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7491), BUNSPEC);
																																																					}
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_7496;
																																																						{	/* Eval/evaluate.scm 380 */
																																																							obj_t
																																																								BgL_arg2389z00_4618;
																																																							BgL_arg2389z00_4618
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg2182z00_2259,
																																																								BgL_locz00_74);
																																																							BgL_auxz00_7496
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2locze70z15zz__evaluatez00
																																																								(BgL_wherez00_73,
																																																									BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_arg2182z00_2259,
																																																									BgL_arg2389z00_4618));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4610))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7496), BUNSPEC);
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1156z00_4610))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg2183z00_2260, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_new1156z00_4610);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2184z00_2262;
																																																				obj_t
																																																					BgL_arg2185z00_2263;
																																																				BgL_arg2184z00_2262
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd213376zd2_2248));
																																																				BgL_arg2185z00_2263
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd213376zd2_2248));
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_7509;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7511;
																																																						obj_t
																																																							BgL_mz00_7510;
																																																						BgL_mz00_7510
																																																							=
																																																							BgL_arg2184z00_2262;
																																																						BgL_bodyz00_7511
																																																							=
																																																							BgL_arg2185z00_2263;
																																																						BgL_bodyz00_1526
																																																							=
																																																							BgL_bodyz00_7511;
																																																						BgL_mz00_1525
																																																							=
																																																							BgL_mz00_7510;
																																																						goto
																																																							BgL_tagzd2173zd2_1527;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7509);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2186z00_2265;
																																																		obj_t
																																																			BgL_arg2187z00_2266;
																																																		BgL_arg2186z00_2265
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_cdrzd213376zd2_2248));
																																																		BgL_arg2187z00_2266
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd213376zd2_2248));
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_7517;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_7519;
																																																				obj_t
																																																					BgL_mz00_7518;
																																																				BgL_mz00_7518
																																																					=
																																																					BgL_arg2186z00_2265;
																																																				BgL_bodyz00_7519
																																																					=
																																																					BgL_arg2187z00_2266;
																																																				BgL_bodyz00_1526
																																																					=
																																																					BgL_bodyz00_7519;
																																																				BgL_mz00_1525
																																																					=
																																																					BgL_mz00_7518;
																																																				goto
																																																					BgL_tagzd2173zd2_1527;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7517);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2189z00_2269;
																																																obj_t
																																																	BgL_arg2190z00_2270;
																																																BgL_arg2189z00_2269
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_cdrzd213376zd2_2248));
																																																BgL_arg2190z00_2270
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_cdrzd213376zd2_2248));
																																																{
																																																	BgL_ev_synchroniza7eza7_bglt
																																																		BgL_auxz00_7525;
																																																	{
																																																		obj_t
																																																			BgL_bodyz00_7527;
																																																		obj_t
																																																			BgL_mz00_7526;
																																																		BgL_mz00_7526
																																																			=
																																																			BgL_arg2189z00_2269;
																																																		BgL_bodyz00_7527
																																																			=
																																																			BgL_arg2190z00_2270;
																																																		BgL_bodyz00_1526
																																																			=
																																																			BgL_bodyz00_7527;
																																																		BgL_mz00_1525
																																																			=
																																																			BgL_mz00_7526;
																																																		goto
																																																			BgL_tagzd2173zd2_1527;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7525);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2191z00_2271;
																																														BgL_arg2191z00_2271
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7530;
																																															{
																																																obj_t
																																																	BgL_argsz00_7532;
																																																obj_t
																																																	BgL_fz00_7531;
																																																BgL_fz00_7531
																																																	=
																																																	BgL_arg2191z00_2271;
																																																BgL_argsz00_7532
																																																	=
																																																	BgL_cdrzd213376zd2_2248;
																																																BgL_argsz00_1532
																																																	=
																																																	BgL_argsz00_7532;
																																																BgL_fz00_1531
																																																	=
																																																	BgL_fz00_7531;
																																																goto
																																																	BgL_tagzd2175zd2_1533;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7530);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 424 */
																																												if ((CAR(BgL_ez00_69) == BGl_symbol3220z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 424 */
																																														if (PAIRP(BgL_cdrzd213376zd2_2248))
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_cdrzd213486zd2_2277;
																																																BgL_cdrzd213486zd2_2277
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213376zd2_2248);
																																																if (PAIRP(BgL_cdrzd213486zd2_2277))
																																																	{	/* Eval/evaluate.scm 424 */
																																																		if (NULLP(CDR(BgL_cdrzd213486zd2_2277)))
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2199z00_2281;
																																																				obj_t
																																																					BgL_arg2200z00_2282;
																																																				BgL_arg2199z00_2281
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2248);
																																																				BgL_arg2200z00_2282
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213486zd2_2277);
																																																				{	/* Eval/evaluate.scm 595 */
																																																					obj_t
																																																						BgL_arg2378z00_4639;
																																																					{	/* Eval/evaluate.scm 595 */
																																																						obj_t
																																																							BgL_arg2379z00_4640;
																																																						{	/* Eval/evaluate.scm 595 */
																																																							obj_t
																																																								BgL_arg2380z00_4641;
																																																							obj_t
																																																								BgL_arg2381z00_4642;
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_res3087z00_4645;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_symbolz00_4643;
																																																									BgL_symbolz00_4643
																																																										=
																																																										BGl_symbol3267z00zz__evaluatez00;
																																																									{	/* Eval/evaluate.scm 595 */
																																																										obj_t
																																																											BgL_arg2597z00_4644;
																																																										BgL_arg2597z00_4644
																																																											=
																																																											SYMBOL_TO_STRING
																																																											(BgL_symbolz00_4643);
																																																										BgL_res3087z00_4645
																																																											=
																																																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																											(BgL_arg2597z00_4644);
																																																									}
																																																								}
																																																								BgL_arg2380z00_4641
																																																									=
																																																									BgL_res3087z00_4645;
																																																							}
																																																							{	/* Eval/evaluate.scm 595 */
																																																								obj_t
																																																									BgL_res3088z00_4648;
																																																								{	/* Eval/evaluate.scm 595 */
																																																									obj_t
																																																										BgL_arg2597z00_4647;
																																																									BgL_arg2597z00_4647
																																																										=
																																																										SYMBOL_TO_STRING
																																																										(
																																																										((obj_t) BgL_wherez00_73));
																																																									BgL_res3088z00_4648
																																																										=
																																																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																										(BgL_arg2597z00_4647);
																																																								}
																																																								BgL_arg2381z00_4642
																																																									=
																																																									BgL_res3088z00_4648;
																																																							}
																																																							BgL_arg2379z00_4640
																																																								=
																																																								string_append
																																																								(BgL_arg2380z00_4641,
																																																								BgL_arg2381z00_4642);
																																																						}
																																																						BgL_arg2378z00_4639
																																																							=
																																																							bstring_to_symbol
																																																							(BgL_arg2379z00_4640);
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BGl_convzd2lambdaze70z35zz__evaluatez00
																																																						(BgL_globalsz00_71,
																																																							BgL_localsz00_70,
																																																							BgL_ez00_69,
																																																							BgL_locz00_74,
																																																							BgL_arg2199z00_2281,
																																																							BgL_arg2200z00_2282,
																																																							BgL_arg2378z00_4639,
																																																							BFALSE));
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 424 */
																																																				obj_t
																																																					BgL_arg2201z00_2283;
																																																				obj_t
																																																					BgL_arg2202z00_2284;
																																																				BgL_arg2201z00_2283
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2202z00_2284
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7558;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7560;
																																																						obj_t
																																																							BgL_fz00_7559;
																																																						BgL_fz00_7559
																																																							=
																																																							BgL_arg2201z00_2283;
																																																						BgL_argsz00_7560
																																																							=
																																																							BgL_arg2202z00_2284;
																																																						BgL_argsz00_1532
																																																							=
																																																							BgL_argsz00_7560;
																																																						BgL_fz00_1531
																																																							=
																																																							BgL_fz00_7559;
																																																						goto
																																																							BgL_tagzd2175zd2_1533;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7558);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 424 */
																																																		obj_t
																																																			BgL_arg2204z00_2286;
																																																		obj_t
																																																			BgL_arg2205z00_2287;
																																																		BgL_arg2204z00_2286
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2205z00_2287
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7564;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7566;
																																																				obj_t
																																																					BgL_fz00_7565;
																																																				BgL_fz00_7565
																																																					=
																																																					BgL_arg2204z00_2286;
																																																				BgL_argsz00_7566
																																																					=
																																																					BgL_arg2205z00_2287;
																																																				BgL_argsz00_1532
																																																					=
																																																					BgL_argsz00_7566;
																																																				BgL_fz00_1531
																																																					=
																																																					BgL_fz00_7565;
																																																				goto
																																																					BgL_tagzd2175zd2_1533;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7564);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 424 */
																																																obj_t
																																																	BgL_arg2206z00_2288;
																																																obj_t
																																																	BgL_arg2207z00_2289;
																																																BgL_arg2206z00_2288
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2207z00_2289
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7570;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7572;
																																																		obj_t
																																																			BgL_fz00_7571;
																																																		BgL_fz00_7571
																																																			=
																																																			BgL_arg2206z00_2288;
																																																		BgL_argsz00_7572
																																																			=
																																																			BgL_arg2207z00_2289;
																																																		BgL_argsz00_1532
																																																			=
																																																			BgL_argsz00_7572;
																																																		BgL_fz00_1531
																																																			=
																																																			BgL_fz00_7571;
																																																		goto
																																																			BgL_tagzd2175zd2_1533;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7570);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 424 */
																																														obj_t
																																															BgL_arg2208z00_2290;
																																														obj_t
																																															BgL_arg2209z00_2291;
																																														BgL_arg2208z00_2290
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2209z00_2291
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7576;
																																															{
																																																obj_t
																																																	BgL_argsz00_7578;
																																																obj_t
																																																	BgL_fz00_7577;
																																																BgL_fz00_7577
																																																	=
																																																	BgL_arg2208z00_2290;
																																																BgL_argsz00_7578
																																																	=
																																																	BgL_arg2209z00_2291;
																																																BgL_argsz00_1532
																																																	=
																																																	BgL_argsz00_7578;
																																																BgL_fz00_1531
																																																	=
																																																	BgL_fz00_7577;
																																																goto
																																																	BgL_tagzd2175zd2_1533;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7576);
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
				else
					{	/* Eval/evaluate.scm 424 */
						BgL_xz00_1456 = BgL_ez00_69;
						if (SYMBOLP(BgL_xz00_1456))
							{	/* Eval/evaluate.scm 427 */
								obj_t BgL__ortest_1101z00_2312;

								BgL__ortest_1101z00_2312 =
									BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_1456,
									BgL_localsz00_70);
								if (CBOOL(BgL__ortest_1101z00_2312))
									{	/* Eval/evaluate.scm 427 */
										return BgL__ortest_1101z00_2312;
									}
								else
									{	/* Eval/evaluate.scm 195 */
										BgL_ev_globalz00_bglt BgL_new1076z00_3483;

										{	/* Eval/evaluate.scm 196 */
											BgL_ev_globalz00_bglt BgL_new1075z00_3484;

											BgL_new1075z00_3484 =
												((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
															BgL_ev_globalz00_bgl))));
											{	/* Eval/evaluate.scm 196 */
												long BgL_arg1368z00_3485;

												{	/* Eval/evaluate.scm 196 */
													long BgL_res2855z00_3488;

													BgL_res2855z00_3488 =
														BGL_CLASS_INDEX
														(BGl_ev_globalz00zz__evaluate_typesz00);
													BgL_arg1368z00_3485 = BgL_res2855z00_3488;
												}
												BGL_OBJECT_CLASS_NUM_SET(
													((BgL_objectz00_bglt) BgL_new1075z00_3484),
													BgL_arg1368z00_3485);
											}
											BgL_new1076z00_3483 = BgL_new1075z00_3484;
										}
										((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1076z00_3483))->
												BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
										((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1076z00_3483))->
												BgL_namez00) = ((obj_t) BgL_xz00_1456), BUNSPEC);
										{
											obj_t BgL_auxz00_7591;

											if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
												{	/* Eval/evaluate.scm 198 */
													BgL_auxz00_7591 = BgL_globalsz00_71;
												}
											else
												{	/* Eval/evaluate.scm 198 */
													BgL_auxz00_7591 = BGL_MODULE();
												}
											((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1076z00_3483))->
													BgL_modz00) = ((obj_t) BgL_auxz00_7591), BUNSPEC);
										}
										return ((obj_t) BgL_new1076z00_3483);
									}
							}
						else
							{	/* Eval/evaluate.scm 428 */
								BgL_ev_littz00_bglt BgL_new1103z00_2313;

								{	/* Eval/evaluate.scm 429 */
									BgL_ev_littz00_bglt BgL_new1102z00_2314;

									BgL_new1102z00_2314 =
										((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 429 */
										long BgL_arg2231z00_2315;

										{	/* Eval/evaluate.scm 429 */
											long BgL_res2856z00_3492;

											BgL_res2856z00_3492 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg2231z00_2315 = BgL_res2856z00_3492;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1102z00_2314),
											BgL_arg2231z00_2315);
									}
									BgL_new1103z00_2313 = BgL_new1102z00_2314;
								}
								((((BgL_ev_littz00_bglt) COBJECT(BgL_new1103z00_2313))->
										BgL_valuez00) = ((obj_t) BgL_xz00_1456), BUNSPEC);
								return ((obj_t) BgL_new1103z00_2313);
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* loop~0 */
	obj_t BGl_loopze70ze7zz__evaluatez00(obj_t BgL_wherez00_4928,
		obj_t BgL_globalsz00_4927, obj_t BgL_localsz00_4926, obj_t BgL_locz00_4925,
		obj_t BgL_esz00_2643)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 386 */
			if (NULLP(BgL_esz00_2643))
				{	/* Eval/evaluate.scm 387 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 389 */
					obj_t BgL_ez00_2646;

					BgL_ez00_2646 = CAR(((obj_t) BgL_esz00_2643));
					{	/* Eval/evaluate.scm 390 */
						obj_t BgL_arg2395z00_2647;
						obj_t BgL_arg2397z00_2648;

						{	/* Eval/evaluate.scm 390 */
							obj_t BgL_arg2398z00_2649;

							{	/* Eval/evaluate.scm 150 */
								obj_t BgL__ortest_1068z00_3450;

								BgL__ortest_1068z00_3450 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_ez00_2646);
								if (CBOOL(BgL__ortest_1068z00_3450))
									{	/* Eval/evaluate.scm 150 */
										BgL_arg2398z00_2649 = BgL__ortest_1068z00_3450;
									}
								else
									{	/* Eval/evaluate.scm 151 */
										obj_t BgL__ortest_1069z00_3451;

										BgL__ortest_1069z00_3451 =
											BGl_getzd2sourcezd2locationz00zz__readerz00
											(BgL_esz00_2643);
										if (CBOOL(BgL__ortest_1069z00_3451))
											{	/* Eval/evaluate.scm 151 */
												BgL_arg2398z00_2649 = BgL__ortest_1069z00_3451;
											}
										else
											{	/* Eval/evaluate.scm 151 */
												BgL_arg2398z00_2649 = BgL_locz00_4925;
											}
									}
							}
							BgL_arg2395z00_2647 =
								BGl_convz00zz__evaluatez00(BgL_ez00_2646, BgL_localsz00_4926,
								BgL_globalsz00_4927, BFALSE, BgL_wherez00_4928,
								BgL_arg2398z00_2649, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 391 */
							obj_t BgL_arg2399z00_2650;

							BgL_arg2399z00_2650 = CDR(((obj_t) BgL_esz00_2643));
							BgL_arg2397z00_2648 =
								BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_4928,
								BgL_globalsz00_4927, BgL_localsz00_4926, BgL_locz00_4925,
								BgL_arg2399z00_2650);
						}
						return MAKE_YOUNG_PAIR(BgL_arg2395z00_2647, BgL_arg2397z00_2648);
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* conv-vals~0 */
	obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t BgL_wherez00_4930,
		obj_t BgL_globalsz00_4929, obj_t BgL_lz00_2461, obj_t BgL_varsz00_2462,
		obj_t BgL_localsz00_2463, obj_t BgL_locz00_2464)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 502 */
			if (NULLP(BgL_lz00_2461))
				{	/* Eval/evaluate.scm 498 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 500 */
					obj_t BgL_locz00_3648;

					{	/* Eval/evaluate.scm 500 */
						obj_t BgL_arg2311z00_3649;

						BgL_arg2311z00_3649 = CAR(((obj_t) BgL_lz00_2461));
						{	/* Eval/evaluate.scm 144 */
							obj_t BgL__ortest_1067z00_3659;

							BgL__ortest_1067z00_3659 =
								BGl_getzd2sourcezd2locationz00zz__readerz00
								(BgL_arg2311z00_3649);
							if (CBOOL(BgL__ortest_1067z00_3659))
								{	/* Eval/evaluate.scm 144 */
									BgL_locz00_3648 = BgL__ortest_1067z00_3659;
								}
							else
								{	/* Eval/evaluate.scm 144 */
									BgL_locz00_3648 = BgL_locz00_2464;
								}
						}
					}
					{	/* Eval/evaluate.scm 501 */
						obj_t BgL_arg2303z00_3650;
						obj_t BgL_arg2304z00_3651;

						{	/* Eval/evaluate.scm 501 */
							obj_t BgL_arg2305z00_3652;

							{	/* Eval/evaluate.scm 501 */
								obj_t BgL_pairz00_3665;

								{	/* Eval/evaluate.scm 501 */
									obj_t BgL_pairz00_3664;

									BgL_pairz00_3664 = CAR(((obj_t) BgL_lz00_2461));
									BgL_pairz00_3665 = CDR(BgL_pairz00_3664);
								}
								BgL_arg2305z00_3652 = CAR(BgL_pairz00_3665);
							}
							BgL_arg2303z00_3650 =
								BGl_convz00zz__evaluatez00(BgL_arg2305z00_3652,
								BgL_localsz00_2463, BgL_globalsz00_4929, BFALSE,
								BgL_wherez00_4930, BgL_locz00_3648, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 502 */
							obj_t BgL_arg2306z00_3653;
							obj_t BgL_arg2307z00_3654;
							obj_t BgL_arg2309z00_3655;

							BgL_arg2306z00_3653 = CDR(((obj_t) BgL_lz00_2461));
							BgL_arg2307z00_3654 = CDR(((obj_t) BgL_varsz00_2462));
							{	/* Eval/evaluate.scm 502 */
								obj_t BgL_arg2310z00_3656;

								BgL_arg2310z00_3656 = CAR(((obj_t) BgL_varsz00_2462));
								BgL_arg2309z00_3655 =
									MAKE_YOUNG_PAIR(BgL_arg2310z00_3656, BgL_localsz00_2463);
							}
							BgL_arg2304z00_3651 =
								BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_4930,
								BgL_globalsz00_4929, BgL_arg2306z00_3653, BgL_arg2307z00_3654,
								BgL_arg2309z00_3655, BgL_locz00_3648);
						}
						return MAKE_YOUNG_PAIR(BgL_arg2303z00_3650, BgL_arg2304z00_3651);
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* conv-lambda~0 */
	BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t
		BgL_globalsz00_4934, obj_t BgL_localsz00_4933, obj_t BgL_ez00_4932,
		obj_t BgL_locz00_4931, obj_t BgL_formalsz00_2652, obj_t BgL_bodyz00_2653,
		obj_t BgL_wherez00_2654, obj_t BgL_typez00_2655)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 404 */
			{
				obj_t BgL_lz00_2686;

				{	/* Eval/evaluate.scm 406 */
					obj_t BgL_argsz00_2658;

					BgL_lz00_2686 =
						BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00
						(BgL_formalsz00_2652, BGl_errorzd2envzd2zz__errorz00, ((bool_t) 1));
					{
						obj_t BgL_rz00_2690;
						obj_t BgL_flatz00_2691;
						long BgL_arityz00_2692;

						BgL_rz00_2690 = BgL_lz00_2686;
						BgL_flatz00_2691 = BNIL;
						BgL_arityz00_2692 = ((long) 0);
					BgL_zc3anonymousza32416ze3z83_2693:
						if (NULLP(BgL_rz00_2690))
							{	/* Eval/evaluate.scm 399 */
								obj_t BgL_val0_1200z00_2695;

								BgL_val0_1200z00_2695 = bgl_reverse_bang(BgL_flatz00_2691);
								{	/* Eval/evaluate.scm 399 */
									int BgL_res2843z00_3454;

									{	/* Eval/evaluate.scm 399 */
										int BgL_tmpz00_7642;

										BgL_tmpz00_7642 = (int) (((long) 2));
										BgL_res2843z00_3454 =
											BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7642);
									} BgL_res2843z00_3454;
								}
								{	/* Eval/evaluate.scm 399 */
									obj_t BgL_auxz00_7647;
									int BgL_tmpz00_7645;

									BgL_auxz00_7647 = BINT(BgL_arityz00_2692);
									BgL_tmpz00_7645 = (int) (((long) 1));
									BGL_MVALUES_VAL_SET(BgL_tmpz00_7645, BgL_auxz00_7647);
								}
								BgL_argsz00_2658 = BgL_val0_1200z00_2695;
							}
						else
							{	/* Eval/evaluate.scm 398 */
								if (PAIRP(BgL_rz00_2690))
									{	/* Eval/evaluate.scm 403 */
										obj_t BgL_arg2419z00_2698;
										obj_t BgL_arg2420z00_2699;
										long BgL_arg2421z00_2700;

										BgL_arg2419z00_2698 = CDR(BgL_rz00_2690);
										BgL_arg2420z00_2699 =
											MAKE_YOUNG_PAIR(BGl_untypezd2identzd2zz__evaluatez00(CAR
												(BgL_rz00_2690)), BgL_flatz00_2691);
										BgL_arg2421z00_2700 = (BgL_arityz00_2692 + ((long) 1));
										{
											long BgL_arityz00_7659;
											obj_t BgL_flatz00_7658;
											obj_t BgL_rz00_7657;

											BgL_rz00_7657 = BgL_arg2419z00_2698;
											BgL_flatz00_7658 = BgL_arg2420z00_2699;
											BgL_arityz00_7659 = BgL_arg2421z00_2700;
											BgL_arityz00_2692 = BgL_arityz00_7659;
											BgL_flatz00_2691 = BgL_flatz00_7658;
											BgL_rz00_2690 = BgL_rz00_7657;
											goto BgL_zc3anonymousza32416ze3z83_2693;
										}
									}
								else
									{	/* Eval/evaluate.scm 401 */
										obj_t BgL_val0_1202z00_2703;
										long BgL_val1_1203z00_2704;

										{	/* Eval/evaluate.scm 401 */
											obj_t BgL_arg2425z00_2705;

											BgL_arg2425z00_2705 =
												MAKE_YOUNG_PAIR(BGl_untypezd2identzd2zz__evaluatez00
												(BgL_rz00_2690), BgL_flatz00_2691);
											BgL_val0_1202z00_2703 =
												bgl_reverse_bang(BgL_arg2425z00_2705);
										}
										BgL_val1_1203z00_2704 = (((long) -1) - BgL_arityz00_2692);
										{	/* Eval/evaluate.scm 401 */
											int BgL_res2847z00_3462;

											{	/* Eval/evaluate.scm 401 */
												int BgL_tmpz00_7664;

												BgL_tmpz00_7664 = (int) (((long) 2));
												BgL_res2847z00_3462 =
													BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7664);
											} BgL_res2847z00_3462;
										}
										{	/* Eval/evaluate.scm 401 */
											obj_t BgL_auxz00_7669;
											int BgL_tmpz00_7667;

											BgL_auxz00_7669 = BINT(BgL_val1_1203z00_2704);
											BgL_tmpz00_7667 = (int) (((long) 1));
											BGL_MVALUES_VAL_SET(BgL_tmpz00_7667, BgL_auxz00_7669);
										}
										BgL_argsz00_2658 = BgL_val0_1202z00_2703;
					}}}
					{	/* Eval/evaluate.scm 407 */
						obj_t BgL_arityz00_2659;

						{	/* Eval/evaluate.scm 408 */
							int BgL_tmpz00_7673;

							BgL_tmpz00_7673 = (int) (((long) 1));
							BgL_arityz00_2659 = BGL_MVALUES_VAL(BgL_tmpz00_7673);
						}
						{	/* Eval/evaluate.scm 408 */
							obj_t BgL_varsz00_2660;
							obj_t BgL_bodyz00_2661;
							obj_t BgL_nlocz00_2662;

							if (NULLP(BgL_argsz00_2658))
								{	/* Eval/evaluate.scm 408 */
									BgL_varsz00_2660 = BNIL;
								}
							else
								{	/* Eval/evaluate.scm 408 */
									obj_t BgL_head1206z00_2669;

									{	/* Eval/evaluate.scm 408 */
										obj_t BgL_res2849z00_3464;

										BgL_res2849z00_3464 = MAKE_YOUNG_PAIR(BNIL, BNIL);
										BgL_head1206z00_2669 = BgL_res2849z00_3464;
									}
									{
										obj_t BgL_l1204z00_2671;
										obj_t BgL_tail1207z00_2672;

										BgL_l1204z00_2671 = BgL_argsz00_2658;
										BgL_tail1207z00_2672 = BgL_head1206z00_2669;
									BgL_zc3anonymousza32404ze3z83_2673:
										if (NULLP(BgL_l1204z00_2671))
											{	/* Eval/evaluate.scm 408 */
												BgL_varsz00_2660 = CDR(BgL_head1206z00_2669);
											}
										else
											{	/* Eval/evaluate.scm 408 */
												obj_t BgL_newtail1208z00_2675;

												{	/* Eval/evaluate.scm 408 */
													BgL_ev_varz00_bglt BgL_arg2408z00_2677;

													{	/* Eval/evaluate.scm 408 */
														obj_t BgL_vz00_2678;

														BgL_vz00_2678 = CAR(((obj_t) BgL_l1204z00_2671));
														{	/* Eval/evaluate.scm 409 */
															BgL_ev_varz00_bglt BgL_new1098z00_2679;

															{	/* Eval/evaluate.scm 411 */
																BgL_ev_varz00_bglt BgL_new1097z00_2680;

																BgL_new1097z00_2680 =
																	((BgL_ev_varz00_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_ev_varz00_bgl))));
																{	/* Eval/evaluate.scm 411 */
																	long BgL_arg2409z00_2681;

																	{	/* Eval/evaluate.scm 411 */
																		long BgL_res2851z00_3469;

																		BgL_res2851z00_3469 =
																			BGL_CLASS_INDEX
																			(BGl_ev_varz00zz__evaluate_typesz00);
																		BgL_arg2409z00_2681 = BgL_res2851z00_3469;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1097z00_2680),
																		BgL_arg2409z00_2681);
																}
																BgL_new1098z00_2679 = BgL_new1097z00_2680;
															}
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1098z00_2679))->
																	BgL_namez00) =
																((obj_t) CAR(((obj_t) BgL_vz00_2678))),
																BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1098z00_2679))->BgL_effz00) =
																((obj_t) BFALSE), BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		COBJECT(BgL_new1098z00_2679))->
																	BgL_typez00) =
																((obj_t) CDR(((obj_t) BgL_vz00_2678))),
																BUNSPEC);
															BgL_arg2408z00_2677 = BgL_new1098z00_2679;
													}}
													{	/* Eval/evaluate.scm 408 */
														obj_t BgL_res2852z00_3474;

														BgL_res2852z00_3474 =
															MAKE_YOUNG_PAIR(
															((obj_t) BgL_arg2408z00_2677), BNIL);
														BgL_newtail1208z00_2675 = BgL_res2852z00_3474;
												}}
												SET_CDR(BgL_tail1207z00_2672, BgL_newtail1208z00_2675);
												{	/* Eval/evaluate.scm 408 */
													obj_t BgL_arg2407z00_2676;

													BgL_arg2407z00_2676 =
														CDR(((obj_t) BgL_l1204z00_2671));
													{
														obj_t BgL_tail1207z00_7701;
														obj_t BgL_l1204z00_7700;

														BgL_l1204z00_7700 = BgL_arg2407z00_2676;
														BgL_tail1207z00_7701 = BgL_newtail1208z00_2675;
														BgL_tail1207z00_2672 = BgL_tail1207z00_7701;
														BgL_l1204z00_2671 = BgL_l1204z00_7700;
														goto BgL_zc3anonymousza32404ze3z83_2673;
													}
												}
											}
									}
								}
							BgL_bodyz00_2661 =
								BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
								(BgL_ez00_4932, BgL_formalsz00_2652,
								BGl_typezd2checkszd2zz__evaluatez00(BgL_argsz00_2658,
									BgL_argsz00_2658,
									BGl_typezd2resultzd2zz__evaluatez00(BgL_typez00_2655,
										BgL_bodyz00_2653, BgL_locz00_4931), BgL_locz00_4931,
									BgL_wherez00_2654), BGl_errorzd2envzd2zz__errorz00);
							{	/* Eval/evaluate.scm 144 */
								obj_t BgL__ortest_1067z00_3477;

								BgL__ortest_1067z00_3477 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_2653);
								if (CBOOL(BgL__ortest_1067z00_3477))
									{	/* Eval/evaluate.scm 144 */
										BgL_nlocz00_2662 = BgL__ortest_1067z00_3477;
									}
								else
									{	/* Eval/evaluate.scm 144 */
										BgL_nlocz00_2662 = BgL_locz00_4931;
									}
							}
							{	/* Eval/evaluate.scm 417 */
								BgL_ev_absz00_bglt BgL_new1100z00_2663;

								{	/* Eval/evaluate.scm 418 */
									BgL_ev_absz00_bglt BgL_new1099z00_2665;

									BgL_new1099z00_2665 =
										((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_ev_absz00_bgl))));
									{	/* Eval/evaluate.scm 418 */
										long BgL_arg2402z00_2666;

										{	/* Eval/evaluate.scm 418 */
											long BgL_res2853z00_3479;

											BgL_res2853z00_3479 =
												BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
											BgL_arg2402z00_2666 = BgL_res2853z00_3479;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1099z00_2665),
											BgL_arg2402z00_2666);
									}
									BgL_new1100z00_2663 = BgL_new1099z00_2665;
								}
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_locz00) = ((obj_t) BgL_locz00_4931), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_wherez00) = ((obj_t) BgL_wherez00_2654), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_arityz00) = ((obj_t) BgL_arityz00_2659), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_varsz00) = ((obj_t) BgL_varsz00_2660), BUNSPEC);
								{
									BgL_ev_exprz00_bglt BgL_auxz00_7716;

									{	/* Eval/evaluate.scm 422 */
										obj_t BgL_arg2401z00_2664;

										BgL_arg2401z00_2664 =
											BGl_appendzd221011zd2zz__evaluatez00(BgL_varsz00_2660,
											BgL_localsz00_4933);
										BgL_auxz00_7716 =
											((BgL_ev_exprz00_bglt)
											BGl_convz00zz__evaluatez00(BgL_bodyz00_2661,
												BgL_arg2401z00_2664, BgL_globalsz00_4934, BTRUE,
												BgL_wherez00_2654, BgL_nlocz00_2662, ((bool_t) 0)));
									}
									((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
											BgL_bodyz00) =
										((BgL_ev_exprz00_bglt) BgL_auxz00_7716), BUNSPEC);
								}
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_siza7eza7) = ((int) (int) (((long) 0))), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_bindz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_freez00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_innerz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) COBJECT(BgL_new1100z00_2663))->
										BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
								return BgL_new1100z00_2663;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* uconv/loc~0 */
	obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4941,
		obj_t BgL_globalsz00_4940, obj_t BgL_localsz00_4939, obj_t BgL_ez00_2630,
		obj_t BgL_locz00_2631)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 377 */
			return
				BGl_convz00zz__evaluatez00(BgL_ez00_2630, BgL_localsz00_4939,
				BgL_globalsz00_4940, BFALSE, BgL_wherez00_4941, BgL_locz00_2631,
				((bool_t) 0));
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 430898742),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1047446),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 454272164),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					445908113), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					434692624), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long) 483789130),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)
					121298760), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)
					444000678), BSTRING_TO_STRING(BGl_string3269z00zz__evaluatez00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
