/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62zc3anonymousza32956ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33847ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3anonymousza33032ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33105ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32052ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31799ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5677z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5679z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33106ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32974ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32796ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5681z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5683z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5685z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62main5687z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5689z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33050ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33599ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5691z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5693z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5695z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5697z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5699z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33884ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33779ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32073ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33037ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza33796ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_or1407zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32979ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32075ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5801z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5803z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5805z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5807z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol5809z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32416ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32238ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t make_vector(long, obj_t);
	static obj_t BGl_symbol5811z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5813z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5815z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5817z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5819z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33502ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32360ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32166ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_symbol5821z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5823z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
	static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
	static obj_t BGl_symbol5825z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5827z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5829z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5831z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5833z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5835z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5837z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5839z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33148ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32079ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5841z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5843z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5845z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5847z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33432ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5849z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33181ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33343ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5851z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5853z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5855z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5857z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5859z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_labels1427zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5861z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33612ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33450ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32471ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33273ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33703ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31921ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32278ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5892z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32740ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33470ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33543ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33349ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62compzd2ev_bindzd2exit1419z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	extern int bgl_debug();
	static obj_t BGl_z62zc3anonymousza33528ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_global1397zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32816ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	extern long bgl_list_length(obj_t);
	static obj_t BGl_z62run5700z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5702z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5704z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5706z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5708z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza33902ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32922ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32760ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32744ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5710z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5712z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5714z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_withzd2handler1423z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5716z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5718z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33830ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32850ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5720z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5722z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5724z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5726z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5728z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33564ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5730z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5732z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5734z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5736z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5738z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letza21415z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32836ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33638ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32110ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33262ze3ze70z64zz__evaluate_compz00(obj_t, obj_t,
		obj_t, long, obj_t);
	static obj_t BGl_z62run5740z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5742z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62run5744z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5746z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5748z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33922ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32780ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33744ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32853ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32764ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33728ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32748ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_litt1403zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33002ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	static obj_t BGl_z62run5750z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5752z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5754z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5756z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5758z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32201ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62run5760z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5762z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32928ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5701z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33819ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5703z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5705z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5707z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5709z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32008ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32961ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31892ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32856ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5711z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5713z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5715z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5717z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5719z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3anonymousza33675ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32784ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31966ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5721z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32768ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5723z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5725z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5727z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5729z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31983ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5731z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5733z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5735z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5737z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5739z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32859ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5741z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5743z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5745z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_trap1391zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5747z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5749z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33872ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33945ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32965ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33694ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33767ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31985ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32949ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5751z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5753z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5755z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5757z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5759z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32788ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5761z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_prog21411zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_z62zc3anonymousza33858ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33221ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32968ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33206ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32315ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1399zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31989ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33118ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33966ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32986ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33151ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32139ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32989ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_let1413zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_goto1430zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5909z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32531ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32353ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5911z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5913z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5915z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33261ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5767z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5769z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3anonymousza32355ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_synchroniza7e1425z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_symbol5771z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5777z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33425ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33336ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32194ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33069ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5785z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33442ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5787z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5789z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	static obj_t BGl_symbol5792z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33621ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_symbol5795z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5797z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5799z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_var1393zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_app1432zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32820ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32804ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32197ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t bigloo_string_lt(obj_t, obj_t);
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza31915ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33284ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33519ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33268ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_and1409zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static obj_t BGl_z62zc3anonymousza33552ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33463ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33285ze3ze1zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3anonymousza33269ze3ze1zz__evaluate_compz00(obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32840ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32913ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33480ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32824ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32808ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31917ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32752ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31772ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_abs1434zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_letrec1417zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33806ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33717ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31935ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33288ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_if1405zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31847ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32844ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32828ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33663ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32772ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32756ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62comp1388z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62run5678z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33591ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33575ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33648ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1395zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32031ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62run5680z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5682z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5684z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5686z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5688z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33754ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_defglobal1401zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5690z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62compzd2ev_unwindzd2prote1421z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5692z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5694z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5696z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32953ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5698z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32848ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33488ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32792ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32776ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33281ze3ze70z64zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32971ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za75919z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_5920z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza75921za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5800z00zz__evaluate_compz00,
		BgL_bgl_string5800za700za7za7_5922za7, "-", 1);
	      DEFINE_STRING(BGl_string5802z00zz__evaluate_compz00,
		BgL_bgl_string5802za700za7za7_5923za7, "*", 1);
	      DEFINE_STRING(BGl_string5804z00zz__evaluate_compz00,
		BgL_bgl_string5804za700za7za7_5924za7, "/", 1);
	      DEFINE_STRING(BGl_string5806z00zz__evaluate_compz00,
		BgL_bgl_string5806za700za7za7_5925za7, "<", 1);
	      DEFINE_STRING(BGl_string5808z00zz__evaluate_compz00,
		BgL_bgl_string5808za700za7za7_5926za7, ">", 1);
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5810z00zz__evaluate_compz00,
		BgL_bgl_string5810za700za7za7_5927za7, "<=", 2);
	      DEFINE_STRING(BGl_string5812z00zz__evaluate_compz00,
		BgL_bgl_string5812za700za7za7_5928za7, ">=", 2);
	      DEFINE_STRING(BGl_string5814z00zz__evaluate_compz00,
		BgL_bgl_string5814za700za7za7_5929za7, "=", 1);
	      DEFINE_STRING(BGl_string5816z00zz__evaluate_compz00,
		BgL_bgl_string5816za700za7za7_5930za7, "+fx", 3);
	      DEFINE_STRING(BGl_string5818z00zz__evaluate_compz00,
		BgL_bgl_string5818za700za7za7_5931za7, "fixnum", 6);
	      DEFINE_STRING(BGl_string5820z00zz__evaluate_compz00,
		BgL_bgl_string5820za700za7za7_5932za7, "-fx", 3);
	      DEFINE_STRING(BGl_string5822z00zz__evaluate_compz00,
		BgL_bgl_string5822za700za7za7_5933za7, "*fx", 3);
	      DEFINE_STRING(BGl_string5824z00zz__evaluate_compz00,
		BgL_bgl_string5824za700za7za7_5934za7, "/fx", 3);
	      DEFINE_STRING(BGl_string5826z00zz__evaluate_compz00,
		BgL_bgl_string5826za700za7za7_5935za7, "<fx", 3);
	      DEFINE_STRING(BGl_string5828z00zz__evaluate_compz00,
		BgL_bgl_string5828za700za7za7_5936za7, ">fx", 3);
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5901z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75937za7,
		BGl_z62zc3anonymousza32922ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5902z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75938za7,
		BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5903z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75939za7,
		BGl_z62zc3anonymousza32928ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev5940z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5904z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75941za7,
		BGl_z62zc3anonymousza32949ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5905z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75942za7,
		BGl_z62zc3anonymousza32953ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5830z00zz__evaluate_compz00,
		BgL_bgl_string5830za700za7za7_5943za7, "<=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5906z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75944za7,
		BGl_z62zc3anonymousza32956ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5907z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75945za7,
		BGl_z62zc3anonymousza32961ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5832z00zz__evaluate_compz00,
		BgL_bgl_string5832za700za7za7_5946za7, ">=fx", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5908z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75947za7,
		BGl_z62zc3anonymousza32965ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5834z00zz__evaluate_compz00,
		BgL_bgl_string5834za700za7za7_5948za7, "=fx", 3);
	      DEFINE_STRING(BGl_string5836z00zz__evaluate_compz00,
		BgL_bgl_string5836za700za7za7_5949za7, "+fl", 3);
	      DEFINE_STRING(BGl_string5838z00zz__evaluate_compz00,
		BgL_bgl_string5838za700za7za7_5950za7, "flonum", 6);
	      DEFINE_STRING(BGl_string5840z00zz__evaluate_compz00,
		BgL_bgl_string5840za700za7za7_5951za7, "-fl", 3);
	      DEFINE_STRING(BGl_string5842z00zz__evaluate_compz00,
		BgL_bgl_string5842za700za7za7_5952za7, "*fl", 3);
	      DEFINE_STRING(BGl_string5844z00zz__evaluate_compz00,
		BgL_bgl_string5844za700za7za7_5953za7, "/fl", 3);
	      DEFINE_STRING(BGl_string5846z00zz__evaluate_compz00,
		BgL_bgl_string5846za700za7za7_5954za7, "<fl", 3);
	      DEFINE_STRING(BGl_string5848z00zz__evaluate_compz00,
		BgL_bgl_string5848za700za7za7_5955za7, ">fl", 3);
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5850z00zz__evaluate_compz00,
		BgL_bgl_string5850za700za7za7_5956za7, "<=fl", 4);
	      DEFINE_STRING(BGl_string5852z00zz__evaluate_compz00,
		BgL_bgl_string5852za700za7za7_5957za7, ">=fl", 4);
	      DEFINE_STRING(BGl_string5854z00zz__evaluate_compz00,
		BgL_bgl_string5854za700za7za7_5958za7, "=fl", 3);
	      DEFINE_STRING(BGl_string5856z00zz__evaluate_compz00,
		BgL_bgl_string5856za700za7za7_5959za7, "car", 3);
	      DEFINE_STRING(BGl_string5858z00zz__evaluate_compz00,
		BgL_bgl_string5858za700za7za7_5960za7, "pair", 4);
	      DEFINE_STRING(BGl_string5860z00zz__evaluate_compz00,
		BgL_bgl_string5860za700za7za7_5961za7, "cdr", 3);
	      DEFINE_STRING(BGl_string5862z00zz__evaluate_compz00,
		BgL_bgl_string5862za700za7za7_5962za7, "cadr", 4);
	      DEFINE_STRING(BGl_string5864z00zz__evaluate_compz00,
		BgL_bgl_string5864za700za7za7_5963za7, "comp1388", 8);
	      DEFINE_STRING(BGl_string5865z00zz__evaluate_compz00,
		BgL_bgl_string5865za700za7za7_5964za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string5866z00zz__evaluate_compz00,
		BgL_bgl_string5866za700za7za7_5965za7, "&comp", 5);
	      DEFINE_STRING(BGl_string5868z00zz__evaluate_compz00,
		BgL_bgl_string5868za700za7za7_5966za7, "comp", 4);
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5890z00zz__evaluate_compz00,
		BgL_bgl_string5890za700za7za7_5967za7, "internal error", 14);
	      DEFINE_STRING(BGl_string5891z00zz__evaluate_compz00,
		BgL_bgl_string5891za700za7za7_5968za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string5893z00zz__evaluate_compz00,
		BgL_bgl_string5893za700za7za7_5969za7, "notyet", 6);
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5894z00zz__evaluate_compz00,
		BgL_bgl_string5894za700za7za7_5970za7, "synchronize", 11);
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5895z00zz__evaluate_compz00,
		BgL_bgl_string5895za700za7za7_5971za7, "mutex", 5);
	      DEFINE_STRING(BGl_string5896z00zz__evaluate_compz00,
		BgL_bgl_string5896za700za7za7_5972za7, "set!", 4);
	      DEFINE_STRING(BGl_string5897z00zz__evaluate_compz00,
		BgL_bgl_string5897za700za7za7_5973za7, "read-only variable", 18);
	      DEFINE_STRING(BGl_string5898z00zz__evaluate_compz00,
		BgL_bgl_string5898za700za7za7_5974za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string5899z00zz__evaluate_compz00,
		BgL_bgl_string5899za700za7za7_5975za7, "Unbound variable", 16);
	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5900z00zz__evaluate_compz00,
		BgL_bgl_string5900za700za7za7_5976za7, "Uninitialized variable", 22);
	      DEFINE_STRING(BGl_string5910z00zz__evaluate_compz00,
		BgL_bgl_string5910za700za7za7_5977za7, "get_sp", 6);
	      DEFINE_STRING(BGl_string5912z00zz__evaluate_compz00,
		BgL_bgl_string5912za700za7za7_5978za7, "reset_profile", 13);
	      DEFINE_STRING(BGl_string5914z00zz__evaluate_compz00,
		BgL_bgl_string5914za700za7za7_5979za7, "get_profile", 11);
	      DEFINE_STRING(BGl_string5916z00zz__evaluate_compz00,
		BgL_bgl_string5916za700za7za7_5980za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string5917z00zz__evaluate_compz00,
		BgL_bgl_string5917za700za7za7_5981za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string5918z00zz__evaluate_compz00,
		BgL_bgl_string5918za700za7za7_5982za7, "__evaluate_comp", 15);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5768z00zz__evaluate_compz00,
		BgL_bgl_string5768za700za7za7_5983za7, "all", 3);
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5770z00zz__evaluate_compz00,
		BgL_bgl_string5770za700za7za7_5984za7, "label-tag", 9);
	      DEFINE_STRING(BGl_string5772z00zz__evaluate_compz00,
		BgL_bgl_string5772za700za7za7_5985za7, "bounce", 6);
	      DEFINE_STRING(BGl_string5773z00zz__evaluate_compz00,
		BgL_bgl_string5773za700za7za7_5986za7, "non non non", 11);
	      DEFINE_STRING(BGl_string5774z00zz__evaluate_compz00,
		BgL_bgl_string5774za700za7za7_5987za7, " in ", 4);
	      DEFINE_STRING(BGl_string5775z00zz__evaluate_compz00,
		BgL_bgl_string5775za700za7za7_5988za7, "eval", 4);
	      DEFINE_STRING(BGl_string5776z00zz__evaluate_compz00,
		BgL_bgl_string5776za700za7za7_5989za7, "internal error: not found", 25);
	      DEFINE_STRING(BGl_string5778z00zz__evaluate_compz00,
		BgL_bgl_string5778za700za7za7_5990za7, "at", 2);
	      DEFINE_STRING(BGl_string5779z00zz__evaluate_compz00,
		BgL_bgl_string5779za700za7za7_5991za7, "", 0);
	      DEFINE_STRING(BGl_string5780z00zz__evaluate_compz00,
		BgL_bgl_string5780za700za7za7_5992za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	      DEFINE_STRING(BGl_string5781z00zz__evaluate_compz00,
		BgL_bgl_string5781za700za7za7_5993za7, "&compile", 8);
	      DEFINE_STRING(BGl_string5782z00zz__evaluate_compz00,
		BgL_bgl_string5782za700za7za7_5994za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string5783z00zz__evaluate_compz00,
		BgL_bgl_string5783za700za7za7_5995za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string5784z00zz__evaluate_compz00,
		BgL_bgl_string5784za700za7za7_5996za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string5786z00zz__evaluate_compz00,
		BgL_bgl_string5786za700za7za7_5997za7, "mcell", 5);
	      DEFINE_STRING(BGl_string5788z00zz__evaluate_compz00,
		BgL_bgl_string5788za700za7za7_5998za7, "internal", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5863z00zz__evaluate_compz00,
		BgL_bgl_za762comp1388za762za7za75999z00,
		BGl_z62comp1388z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5790z00zz__evaluate_compz00,
		BgL_bgl_string5790za700za7za7_6000za7, "impossible", 10);
	      DEFINE_STRING(BGl_string5791z00zz__evaluate_compz00,
		BgL_bgl_string5791za700za7za7_6001za7, "procedure", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5867z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra6002z00,
		BGl_z62compzd2ev_trap1391zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5793z00zz__evaluate_compz00,
		BgL_bgl_string5793za700za7za7_6003za7, "user", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5869z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var6004z00,
		BGl_z62compzd2ev_var1393zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5794z00zz__evaluate_compz00,
		BgL_bgl_string5794za700za7za7_6005za7, "invalid byte code", 17);
	      DEFINE_STRING(BGl_string5796z00zz__evaluate_compz00,
		BgL_bgl_string5796za700za7za7_6006za7, "+", 1);
	      DEFINE_STRING(BGl_string5798z00zz__evaluate_compz00,
		BgL_bgl_string5798za700za7za7_6007za7, "number", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5870z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set6008z00,
		BGl_z62compzd2ev_setlocal1395zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5871z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo6009z00,
		BGl_z62compzd2ev_global1397zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5872z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set6010z00,
		BGl_z62compzd2ev_setglobal1399zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5873z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def6011z00,
		BGl_z62compzd2ev_defglobal1401zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5874z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit6012z00,
		BGl_z62compzd2ev_litt1403zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5875z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if16013z00,
		BGl_z62compzd2ev_if1405zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5876z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or16014z00,
		BGl_z62compzd2ev_or1407zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5877z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and6015z00,
		BGl_z62compzd2ev_and1409zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5878z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro6016z00,
		BGl_z62compzd2ev_prog21411zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5879z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let6017z00,
		BGl_z62compzd2ev_let1413zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5880z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let6018z00,
		BGl_z62compzd2ev_letza21415z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5881z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let6019z00,
		BGl_z62compzd2ev_letrec1417zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5882z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin6020z00,
		BGl_z62compzd2ev_bindzd2exit1419z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5883z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw6021z00,
		BGl_z62compzd2ev_unwindzd2prote1421z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5884z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit6022z00,
		BGl_z62compzd2ev_withzd2handler1423z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5885z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn6023z00,
		BGl_z62compzd2ev_synchroniza7e1425z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5886z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab6024z00,
		BGl_z62compzd2ev_labels1427zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5887z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got6025z00,
		BGl_z62compzd2ev_goto1430zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5888z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app6026z00,
		BGl_z62compzd2ev_app1432zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5889z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs6027z00,
		BGl_z62compzd2ev_abs1434zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol5801z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5803z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5805z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5807z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5809z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5811z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5813z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5815z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5817z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5819z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void *) (&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5821z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5823z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5825z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5827z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5829z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5831z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5833z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5835z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5837z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5839z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5841z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5843z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5845z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5847z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5849z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5851z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5853z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5855z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5857z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5859z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5861z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5892z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5909z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5911z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5913z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5915z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5767z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5769z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5771z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5777z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5785z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5787z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5789z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5792z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5795z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5797z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5799z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_18379, char *BgL_fromz00_18380)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_compz00();
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					return BGl_toplevelzd2initzd2zz__evaluate_compz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol5767z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5768z00zz__evaluate_compz00);
			BGl_symbol5769z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5770z00zz__evaluate_compz00);
			BGl_symbol5771z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5772z00zz__evaluate_compz00);
			BGl_symbol5777z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5778z00zz__evaluate_compz00);
			BGl_symbol5785z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5786z00zz__evaluate_compz00);
			BGl_symbol5787z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5788z00zz__evaluate_compz00);
			BGl_symbol5789z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5790z00zz__evaluate_compz00);
			BGl_symbol5792z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5793z00zz__evaluate_compz00);
			BGl_symbol5795z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5796z00zz__evaluate_compz00);
			BGl_symbol5797z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5798z00zz__evaluate_compz00);
			BGl_symbol5799z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5800z00zz__evaluate_compz00);
			BGl_symbol5801z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5802z00zz__evaluate_compz00);
			BGl_symbol5803z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5804z00zz__evaluate_compz00);
			BGl_symbol5805z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5806z00zz__evaluate_compz00);
			BGl_symbol5807z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5808z00zz__evaluate_compz00);
			BGl_symbol5809z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5810z00zz__evaluate_compz00);
			BGl_symbol5811z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5812z00zz__evaluate_compz00);
			BGl_symbol5813z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5814z00zz__evaluate_compz00);
			BGl_symbol5815z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5816z00zz__evaluate_compz00);
			BGl_symbol5817z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5818z00zz__evaluate_compz00);
			BGl_symbol5819z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5820z00zz__evaluate_compz00);
			BGl_symbol5821z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5822z00zz__evaluate_compz00);
			BGl_symbol5823z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5824z00zz__evaluate_compz00);
			BGl_symbol5825z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5826z00zz__evaluate_compz00);
			BGl_symbol5827z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5828z00zz__evaluate_compz00);
			BGl_symbol5829z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5830z00zz__evaluate_compz00);
			BGl_symbol5831z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5832z00zz__evaluate_compz00);
			BGl_symbol5833z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5834z00zz__evaluate_compz00);
			BGl_symbol5835z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5836z00zz__evaluate_compz00);
			BGl_symbol5837z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5838z00zz__evaluate_compz00);
			BGl_symbol5839z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5840z00zz__evaluate_compz00);
			BGl_symbol5841z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5842z00zz__evaluate_compz00);
			BGl_symbol5843z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5844z00zz__evaluate_compz00);
			BGl_symbol5845z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5846z00zz__evaluate_compz00);
			BGl_symbol5847z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5848z00zz__evaluate_compz00);
			BGl_symbol5849z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5850z00zz__evaluate_compz00);
			BGl_symbol5851z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5852z00zz__evaluate_compz00);
			BGl_symbol5853z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5854z00zz__evaluate_compz00);
			BGl_symbol5855z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5856z00zz__evaluate_compz00);
			BGl_symbol5857z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5858z00zz__evaluate_compz00);
			BGl_symbol5859z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5860z00zz__evaluate_compz00);
			BGl_symbol5861z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5862z00zz__evaluate_compz00);
			BGl_symbol5892z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5893z00zz__evaluate_compz00);
			BGl_symbol5909z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5910z00zz__evaluate_compz00);
			BGl_symbol5911z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5912z00zz__evaluate_compz00);
			BGl_symbol5913z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5914z00zz__evaluate_compz00);
			return (BGl_symbol5915z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5916z00zz__evaluate_compz00), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 114 */
				BGL_LONGLONG_T BgL_arg1478z00_1349;

				{	/* Eval/evaluate_comp.scm 114 */
					BGL_LONGLONG_T BgL_res4286z00_6389;

					BgL_res4286z00_6389 = LONG_TO_LLONG(((long) 0));
					BgL_arg1478z00_1349 = BgL_res4286z00_6389;
				}
				{	/* Eval/evaluate_comp.scm 114 */
					obj_t BgL_list1479z00_1350;

					{	/* Eval/evaluate_comp.scm 114 */
						obj_t BgL_arg1480z00_1351;

						BgL_arg1480z00_1351 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1478z00_1349), BNIL);
						BgL_list1479z00_1350 =
							MAKE_YOUNG_PAIR(BGl_symbol5767z00zz__evaluate_compz00,
							BgL_arg1480z00_1351);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1479z00_1350;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long) 8192);
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5769z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5771z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		BGL_FUNCTION_BEGIN;
		{
			{
				obj_t BgL_headz00_1352;

				BgL_headz00_1352 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_6414;
					obj_t BgL_tailz00_6415;

					BgL_prevz00_6414 = BgL_headz00_1352;
					BgL_tailz00_6415 = BgL_l1z00_1;
				BgL_loopz00_6413:
					if (PAIRP(BgL_tailz00_6415))
						{
							obj_t BgL_newzd2prevzd2_6421;

							BgL_newzd2prevzd2_6421 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_6415), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_6414, BgL_newzd2prevzd2_6421);
							{
								obj_t BgL_tailz00_18453;
								obj_t BgL_prevz00_18452;

								BgL_prevz00_18452 = BgL_newzd2prevzd2_6421;
								BgL_tailz00_18453 = CDR(BgL_tailz00_6415);
								BgL_tailz00_6415 = BgL_tailz00_18453;
								BgL_prevz00_6414 = BgL_prevz00_18452;
								goto BgL_loopz00_6413;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1352);
			}
		}
		BGL_FUNCTION_END;
	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 132 */
			{	/* Eval/evaluate_comp.scm 133 */
				BGL_LONGLONG_T BgL_arg1502z00_1380;

				{	/* Eval/evaluate_comp.scm 133 */
					BGL_LONGLONG_T BgL_res4295z00_6429;

					BgL_res4295z00_6429 = LONG_TO_LLONG(((long) 0));
					BgL_arg1502z00_1380 = BgL_res4295z00_6429;
				}
				{	/* Eval/evaluate_comp.scm 133 */
					obj_t BgL_list1503z00_1381;

					{	/* Eval/evaluate_comp.scm 133 */
						obj_t BgL_arg1504z00_1382;

						BgL_arg1504z00_1382 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1502z00_1380), BNIL);
						BgL_list1503z00_1381 =
							MAKE_YOUNG_PAIR(BGl_symbol5767z00zz__evaluate_compz00,
							BgL_arg1504z00_1382);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1503z00_1381, BUNSPEC);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* o->s~0 */
	obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1391)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 141 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1391))
				{	/* Ieee/fixnum.scm 979 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_1391), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 138 */
					if (SYMBOLP(BgL_vz00_1391))
						{	/* Eval/evaluate_comp.scm 139 */
							obj_t BgL_res4298z00_6434;

							{	/* Eval/evaluate_comp.scm 139 */
								obj_t BgL_arg4136z00_6433;

								BgL_arg4136z00_6433 = SYMBOL_TO_STRING(BgL_vz00_1391);
								BgL_res4298z00_6434 =
									BGl_stringzd2copyzd2zz__r4_strings_6_7z00
									(BgL_arg4136z00_6433);
							}
							return BgL_res4298z00_6434;
						}
					else
						{	/* Eval/evaluate_comp.scm 139 */
							if (STRINGP(BgL_vz00_1391))
								{	/* Eval/evaluate_comp.scm 140 */
									return BgL_vz00_1391;
								}
							else
								{	/* Eval/evaluate_comp.scm 140 */
									return BGl_string5773z00zz__evaluate_compz00;
								}
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_13565,
		obj_t BgL_t1z00_13566, obj_t BgL_t2z00_13567)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 138 */
				bool_t BgL_tmpz00_18470;

				{	/* Eval/evaluate_comp.scm 142 */
					obj_t BgL_v1z00_15556;
					obj_t BgL_v2z00_15557;

					BgL_v1z00_15556 = CAR(((obj_t) BgL_t1z00_13566));
					BgL_v2z00_15557 = CAR(((obj_t) BgL_t2z00_13567));
					{	/* Eval/evaluate_comp.scm 143 */
						bool_t BgL_testz00_18475;

						if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_15556))
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_testz00_18475 =
									BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BgL_v2z00_15557);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_testz00_18475 = ((bool_t) 0);
							}
						if (BgL_testz00_18475)
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18470 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_15556,
									BgL_v2z00_15557);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18470 =
									bigloo_string_lt(BGl_ozd2ze3sze70zd6zz__evaluate_compz00
									(BgL_v1z00_15556),
									BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_15557));
							}
					}
				}
				return BBOOL(BgL_tmpz00_18470);
			}
		}
		BGL_FUNCTION_END;
	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 147 */
			BGl_recze71ze7zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}
		BGL_FUNCTION_END;
	}



/* rec~1 */
	bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1400)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 148 */
			{	/* Eval/evaluate_comp.scm 149 */
				obj_t BgL_arg1515z00_1402;
				obj_t BgL_arg1516z00_1403;

				BgL_arg1515z00_1402 = CDR(((obj_t) BgL_tz00_1400));
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_arg1518z00_1404;

					{	/* Eval/evaluate_comp.scm 149 */
						obj_t BgL_pairz00_6445;

						BgL_pairz00_6445 = CDR(((obj_t) BgL_tz00_1400));
						BgL_arg1518z00_1404 = CDR(BgL_pairz00_6445);
					}
					BgL_arg1516z00_1403 =
						BGl_sortz00zz__r4_vectors_6_8z00
						(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1518z00_1404);
				}
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_tmpz00_18491;

					BgL_tmpz00_18491 = ((obj_t) BgL_arg1515z00_1402);
					SET_CDR(BgL_tmpz00_18491, BgL_arg1516z00_1403);
				}
			}
			{	/* Eval/evaluate_comp.scm 150 */
				obj_t BgL_g1290z00_1405;

				{	/* Eval/evaluate_comp.scm 150 */
					obj_t BgL_pairz00_6450;

					BgL_pairz00_6450 = CDR(((obj_t) BgL_tz00_1400));
					BgL_g1290z00_1405 = CDR(BgL_pairz00_6450);
				}
				{
					obj_t BgL_l1288z00_6464;

					BgL_l1288z00_6464 = BgL_g1290z00_1405;
				BgL_zc3anonymousza31519ze3z83_6463:
					if (PAIRP(BgL_l1288z00_6464))
						{	/* Eval/evaluate_comp.scm 150 */
							BGl_recze71ze7zz__evaluate_compz00(CAR(BgL_l1288z00_6464));
							{
								obj_t BgL_l1288z00_18501;

								BgL_l1288z00_18501 = CDR(BgL_l1288z00_6464);
								BgL_l1288z00_6464 = BgL_l1288z00_18501;
								goto BgL_zc3anonymousza31519ze3z83_6463;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 150 */
							return ((bool_t) 1);
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* index */
	obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 156 */
			{
				obj_t BgL_lz00_6495;
				long BgL_nz00_6496;

				BgL_lz00_6495 = BgL_lz00_7;
				BgL_nz00_6496 = ((long) 0);
			BgL_walkz00_6494:
				if (NULLP(BgL_lz00_6495))
					{	/* Eval/evaluate_comp.scm 158 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate_comp.scm 158 */
						if ((BgL_xz00_6 == CAR(((obj_t) BgL_lz00_6495))))
							{	/* Eval/evaluate_comp.scm 159 */
								return BINT(BgL_nz00_6496);
							}
						else
							{
								long BgL_nz00_18513;
								obj_t BgL_lz00_18510;

								BgL_lz00_18510 = CDR(((obj_t) BgL_lz00_6495));
								BgL_nz00_18513 = (BgL_nz00_6496 + ((long) 1));
								BgL_nz00_6496 = BgL_nz00_18513;
								BgL_lz00_6495 = BgL_lz00_18510;
								goto BgL_walkz00_6494;
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 163 */
			{	/* Eval/evaluate_comp.scm 164 */
				obj_t BgL__ortest_1078z00_1425;

				BgL__ortest_1078z00_1425 =
					BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9);
				if (CBOOL(BgL__ortest_1078z00_1425))
					{	/* Eval/evaluate_comp.scm 164 */
						return BgL__ortest_1078z00_1425;
					}
				else
					{	/* Eval/evaluate_comp.scm 164 */
						obj_t BgL_arg1535z00_1426;

						{	/* Eval/evaluate_comp.scm 164 */
							obj_t BgL_arg1536z00_1427;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 164 */
									BgL_arg1536z00_1427 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_head1293z00_1433;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1551z00_1445;

										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_arg1553z00_1446;

											BgL_arg1553z00_1446 = CAR(((obj_t) BgL_lz00_9));
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1553z00_1446,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1551z00_1445 =
														(((BgL_ev_varz00_bglt) COBJECT(
																((BgL_ev_varz00_bglt) BgL_arg1553z00_1446)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1551z00_1445 = BgL_arg1553z00_1446;
												}
										}
										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_res4311z00_6516;

											BgL_res4311z00_6516 =
												MAKE_YOUNG_PAIR(BgL_arg1551z00_1445, BNIL);
											BgL_head1293z00_1433 = BgL_res4311z00_6516;
										}
									}
									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_g1296z00_1434;

										BgL_g1296z00_1434 = CDR(((obj_t) BgL_lz00_9));
										{
											obj_t BgL_l1291z00_6541;
											obj_t BgL_tail1294z00_6542;

											BgL_l1291z00_6541 = BgL_g1296z00_1434;
											BgL_tail1294z00_6542 = BgL_head1293z00_1433;
										BgL_zc3anonymousza31542ze3z83_6540:
											if (NULLP(BgL_l1291z00_6541))
												{	/* Eval/evaluate_comp.scm 164 */
													BgL_arg1536z00_1427 = BgL_head1293z00_1433;
												}
											else
												{	/* Eval/evaluate_comp.scm 164 */
													obj_t BgL_newtail1295z00_6549;

													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1545z00_6550;

														BgL_arg1545z00_6550 =
															BGl_lnamez00zz__evaluate_compz00(CAR(
																((obj_t) BgL_l1291z00_6541)));
														{	/* Eval/evaluate_comp.scm 164 */
															obj_t BgL_res4317z00_6555;

															BgL_res4317z00_6555 =
																MAKE_YOUNG_PAIR(BgL_arg1545z00_6550, BNIL);
															BgL_newtail1295z00_6549 = BgL_res4317z00_6555;
														}
													}
													SET_CDR(BgL_tail1294z00_6542,
														BgL_newtail1295z00_6549);
													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1544z00_6552;

														BgL_arg1544z00_6552 =
															CDR(((obj_t) BgL_l1291z00_6541));
														{
															obj_t BgL_tail1294z00_18539;
															obj_t BgL_l1291z00_18538;

															BgL_l1291z00_18538 = BgL_arg1544z00_6552;
															BgL_tail1294z00_18539 = BgL_newtail1295z00_6549;
															BgL_tail1294z00_6542 = BgL_tail1294z00_18539;
															BgL_l1291z00_6541 = BgL_l1291z00_18538;
															goto BgL_zc3anonymousza31542ze3z83_6540;
														}
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 164 */
								obj_t BgL_list1537z00_1428;

								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_arg1539z00_1429;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1540z00_1430;

										BgL_arg1540z00_1430 =
											MAKE_YOUNG_PAIR(BgL_arg1536z00_1427, BNIL);
										BgL_arg1539z00_1429 =
											MAKE_YOUNG_PAIR(BGl_string5774z00zz__evaluate_compz00,
											BgL_arg1540z00_1430);
									}
									BgL_list1537z00_1428 =
										MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1539z00_1429);
								}
								BgL_arg1535z00_1426 = BgL_list1537z00_1428;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string5775z00zz__evaluate_compz00,
							BGl_string5776z00zz__evaluate_compz00, BgL_arg1535z00_1426);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 188 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 189 */
					return
						(((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 189 */
					return BgL_vz00_16;
				}
		}
		BGL_FUNCTION_END;
	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 193 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 194 */
					obj_t BgL_cdrzd2194zd2_1472;

					BgL_cdrzd2194zd2_1472 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol5777z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 194 */
							if (PAIRP(BgL_cdrzd2194zd2_1472))
								{	/* Eval/evaluate_comp.scm 194 */
									obj_t BgL_cdrzd2198zd2_1476;

									BgL_cdrzd2198zd2_1476 = CDR(BgL_cdrzd2194zd2_1472);
									if (PAIRP(BgL_cdrzd2198zd2_1476))
										{	/* Eval/evaluate_comp.scm 194 */
											if (NULLP(CDR(BgL_cdrzd2198zd2_1476)))
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2194zd2_1472),
														CAR(BgL_cdrzd2198zd2_1476));
												}
											else
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 194 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 194 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 194 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 194 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}
		BGL_FUNCTION_END;
	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 206 */
			{	/* Eval/evaluate_comp.scm 207 */
				obj_t BgL_stkz00_1492;

				BgL_stkz00_1492 =
					make_vector(((long) 8192), BGl_string5779z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1492, ((long) 0), BINT(((long) 2)));
				return BgL_stkz00_1492;
			}
		}
		BGL_FUNCTION_END;
	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 211 */
			{	/* Eval/evaluate_comp.scm 212 */
				obj_t BgL_sz00_1493;

				{	/* Eval/evaluate_comp.scm 212 */
					obj_t BgL_tmpz00_18573;

					BgL_tmpz00_18573 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1493 = BGL_ENV_EVSTATE(BgL_tmpz00_18573);
				}
				if (VECTORP(BgL_sz00_1493))
					{	/* Eval/evaluate_comp.scm 213 */
						return BgL_sz00_1493;
					}
				else
					{	/* Eval/evaluate_comp.scm 214 */
						obj_t BgL_statez00_1495;

						BgL_statez00_1495 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 215 */
							obj_t BgL_tmpz00_18579;

							BgL_tmpz00_18579 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_tmpz00_18579, BgL_statez00_1495);
						}
						return BgL_statez00_1495;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_13568)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 211 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}
		BGL_FUNCTION_END;
	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 273 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}
		BGL_FUNCTION_END;
	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_13569,
		obj_t BgL_ez00_13570)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 273 */
			{	/* Eval/evaluate_comp.scm 274 */
				BgL_ev_exprz00_bglt BgL_auxz00_18584;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_13570,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 274 */
						BgL_auxz00_18584 = ((BgL_ev_exprz00_bglt) BgL_ez00_13570);
					}
				else
					{
						obj_t BgL_auxz00_18588;

						BgL_auxz00_18588 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5780z00zz__evaluate_compz00, BINT(((long) 7006)),
							BGl_string5781z00zz__evaluate_compz00,
							BGl_string5782z00zz__evaluate_compz00, BgL_ez00_13570);
						FAILURE(BgL_auxz00_18588, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_18584);
			}
		}
		BGL_FUNCTION_END;
	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 332 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 335 */
					obj_t BgL_gz00_1551;

					{	/* Eval/evaluate_comp.scm 335 */
						obj_t BgL_arg1637z00_1552;
						obj_t BgL_arg1638z00_1553;

						BgL_arg1637z00_1552 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_modz00);
						BgL_arg1638z00_1553 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_namez00);
						BgL_gz00_1551 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg1637z00_1552, BgL_arg1638z00_1553);
					}
					if (CBOOL(BgL_gz00_1551))
						{	/* Eval/evaluate_comp.scm 336 */
							return VECTOR_REF(((obj_t) BgL_gz00_1551), ((long) 2));
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 333 */
					return BFALSE;
				}
		}
		BGL_FUNCTION_END;
	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 616 */
			{
				obj_t BgL_lz00_1573;
				obj_t BgL_bsz00_1574;
				long BgL_spz00_1575;

				BgL_lz00_1573 = BgL_argsz00_83;
				BgL_bsz00_1574 = BgL_boxesz00_84;
				BgL_spz00_1575 = BgL_spz00_85;
			BgL_zc3anonymousza31653ze3z83_1576:
				if (NULLP(BgL_lz00_1573))
					{	/* Eval/evaluate_comp.scm 618 */
						if (NULLP(BgL_bsz00_1574))
							{	/* Eval/evaluate_comp.scm 619 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 622 */
								obj_t BgL_arg1656z00_1579;

								{	/* Eval/evaluate_comp.scm 622 */
									long BgL_arg1657z00_1580;
									long BgL_arg1658z00_1581;

									BgL_arg1657z00_1580 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1658z00_1581 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 621 */
										obj_t BgL_list1659z00_1582;

										{	/* Eval/evaluate_comp.scm 621 */
											obj_t BgL_arg1660z00_1583;

											BgL_arg1660z00_1583 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1658z00_1581), BNIL);
											BgL_list1659z00_1582 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1657z00_1580),
												BgL_arg1660z00_1583);
										}
										BgL_arg1656z00_1579 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5783z00zz__evaluate_compz00,
											BgL_list1659z00_1582);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5784z00zz__evaluate_compz00, BgL_arg1656z00_1579);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 618 */
						if (NULLP(BgL_bsz00_1574))
							{	/* Eval/evaluate_comp.scm 626 */
								obj_t BgL_arg1664z00_1585;

								{	/* Eval/evaluate_comp.scm 626 */
									long BgL_arg1666z00_1586;
									long BgL_arg1667z00_1587;

									BgL_arg1666z00_1586 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1667z00_1587 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 625 */
										obj_t BgL_list1668z00_1588;

										{	/* Eval/evaluate_comp.scm 625 */
											obj_t BgL_arg1669z00_1589;

											BgL_arg1669z00_1589 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1667z00_1587), BNIL);
											BgL_list1668z00_1588 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1666z00_1586),
												BgL_arg1669z00_1589);
										}
										BgL_arg1664z00_1585 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5783z00zz__evaluate_compz00,
											BgL_list1668z00_1588);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5784z00zz__evaluate_compz00, BgL_arg1664z00_1585);
							}
						else
							{	/* Eval/evaluate_comp.scm 623 */
								{	/* Eval/evaluate_comp.scm 629 */
									obj_t BgL_arg1670z00_1590;

									{	/* Eval/evaluate_comp.scm 629 */
										obj_t BgL_vz00_1591;

										{	/* Eval/evaluate_comp.scm 629 */
											obj_t BgL_fun1672z00_1593;

											BgL_fun1672z00_1593 = CAR(((obj_t) BgL_lz00_1573));
											BgL_vz00_1591 =
												PROCEDURE_ENTRY(BgL_fun1672z00_1593)
												(BgL_fun1672z00_1593, BgL_sz00_82, BEOA);
										}
										if (CBOOL(CAR(((obj_t) BgL_bsz00_1574))))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_6605;

												BgL_newz00_6605 =
													create_struct(BGl_symbol5785z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_18639;

													BgL_tmpz00_18639 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_6605, BgL_tmpz00_18639,
														BgL_vz00_1591);
												}
												BgL_arg1670z00_1590 = BgL_newz00_6605;
											}
										else
											{	/* Eval/evaluate_comp.scm 630 */
												BgL_arg1670z00_1590 = BgL_vz00_1591;
											}
									}
									VECTOR_SET(
										((obj_t) BgL_sz00_82), BgL_spz00_1575, BgL_arg1670z00_1590);
								}
								{	/* Eval/evaluate_comp.scm 633 */
									obj_t BgL_arg1673z00_1594;
									obj_t BgL_arg1674z00_1595;
									long BgL_arg1675z00_1596;

									BgL_arg1673z00_1594 = CDR(((obj_t) BgL_lz00_1573));
									BgL_arg1674z00_1595 = CDR(((obj_t) BgL_bsz00_1574));
									BgL_arg1675z00_1596 = (BgL_spz00_1575 + ((long) 1));
									{
										long BgL_spz00_18651;
										obj_t BgL_bsz00_18650;
										obj_t BgL_lz00_18649;

										BgL_lz00_18649 = BgL_arg1673z00_1594;
										BgL_bsz00_18650 = BgL_arg1674z00_1595;
										BgL_spz00_18651 = BgL_arg1675z00_1596;
										BgL_spz00_1575 = BgL_spz00_18651;
										BgL_bsz00_1574 = BgL_bsz00_18650;
										BgL_lz00_1573 = BgL_lz00_18649;
										goto BgL_zc3anonymousza31653ze3z83_1576;
									}
								}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 638 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 639 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 639 */
					if ((CAR(((obj_t) BgL_l1z00_88)) == CAR(((obj_t) BgL_l2z00_89))))
						{	/* Eval/evaluate_comp.scm 642 */
							obj_t BgL_arg1680z00_1602;
							obj_t BgL_arg1681z00_1603;

							BgL_arg1680z00_1602 = CDR(((obj_t) BgL_l1z00_88));
							BgL_arg1681z00_1603 = CDR(((obj_t) BgL_l2z00_89));
							{
								obj_t BgL_l2z00_18665;
								obj_t BgL_l1z00_18664;

								BgL_l1z00_18664 = BgL_arg1680z00_1602;
								BgL_l2z00_18665 = BgL_arg1681z00_1603;
								BgL_l2z00_89 = BgL_l2z00_18665;
								BgL_l1z00_88 = BgL_l1z00_18664;
								goto BGl_subzd2stkzd2zz__evaluate_compz00;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 640 */
							return
								BGl_errorz00zz__errorz00(BGl_string5775z00zz__evaluate_compz00,
								BGl_symbol5787z00zz__evaluate_compz00,
								BGl_symbol5789z00zz__evaluate_compz00);
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 662 */
			{	/* Eval/evaluate_comp.scm 663 */
				obj_t BgL_savedzd2bpzd2_1614;

				BgL_savedzd2bpzd2_1614 = VECTOR_REF(((obj_t) BgL_sz00_94), ((long) 0));
				VECTOR_SET(((obj_t) BgL_sz00_94), ((long) 0), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1616;

					BgL_fz00_1616 = BgL_fz00_93;
				BgL_zc3anonymousza31692ze3z83_1617:
					{	/* Eval/evaluate_comp.scm 666 */
						obj_t BgL_rz00_1618;

						BgL_rz00_1618 =
							PROCEDURE_ENTRY(BgL_fz00_1616) (BgL_fz00_1616, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 667 */
							bool_t BgL_testz00_18675;

							if (PROCEDUREP(BgL_rz00_1618))
								{	/* Eval/evaluate_comp.scm 667 */
									obj_t BgL_arg1696z00_1623;

									BgL_arg1696z00_1623 = PROCEDURE_ATTR(BgL_rz00_1618);
									if (STRUCTP(BgL_arg1696z00_1623))
										{	/* Eval/evaluate_comp.scm 647 */
											BgL_testz00_18675 =
												(STRUCT_KEY(BgL_arg1696z00_1623) ==
												BGl_symbol5771z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 647 */
											BgL_testz00_18675 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 667 */
									BgL_testz00_18675 = ((bool_t) 0);
								}
							if (BgL_testz00_18675)
								{
									obj_t BgL_fz00_18683;

									BgL_fz00_18683 = BgL_rz00_1618;
									BgL_fz00_1616 = BgL_fz00_18683;
									goto BgL_zc3anonymousza31692ze3z83_1617;
								}
							else
								{	/* Eval/evaluate_comp.scm 667 */
									VECTOR_SET(
										((obj_t) BgL_sz00_94), ((long) 0), BgL_savedzd2bpzd2_1614);
									return BgL_rz00_1618;
								}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 681 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 683 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 685 */
					obj_t BgL_arg1707z00_1636;
					obj_t BgL_arg1709z00_1637;

					{	/* Eval/evaluate_comp.scm 685 */
						obj_t BgL_arg1710z00_1638;

						BgL_arg1710z00_1638 = CAR(((obj_t) BgL_eza2za2_117));
						BgL_arg1707z00_1636 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1710z00_1638), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 686 */
						obj_t BgL_arg1711z00_1639;
						obj_t BgL_arg1712z00_1640;

						BgL_arg1711z00_1639 = CDR(((obj_t) BgL_eza2za2_117));
						{	/* Eval/evaluate_comp.scm 686 */
							obj_t BgL_arg1713z00_1641;

							BgL_arg1713z00_1641 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1712z00_1640 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1713z00_1641);
						}
						BgL_arg1709z00_1637 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1711z00_1639,
							BgL_arg1712z00_1640);
					}
					return MAKE_YOUNG_PAIR(BgL_arg1707z00_1636, BgL_arg1709z00_1637);
				}
		}
		BGL_FUNCTION_END;
	}



/* rec~0 */
	obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_15541,
		obj_t BgL_lz00_1643, long BgL_iz00_1644)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 689 */
			if (NULLP(BgL_lz00_1643))
				{	/* Eval/evaluate_comp.scm 690 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 690 */
					if ((BgL_iz00_1644 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 691 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1643,
								BgL_stkz00_15541);
						}
					else
						{	/* Eval/evaluate_comp.scm 692 */
							obj_t BgL_arg1717z00_1648;
							obj_t BgL_arg1718z00_1649;

							{	/* Eval/evaluate_comp.scm 692 */
								obj_t BgL_arg1719z00_1650;

								BgL_arg1719z00_1650 = CAR(((obj_t) BgL_lz00_1643));
								BgL_arg1717z00_1648 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1719z00_1650),
									BgL_stkz00_15541);
							}
							{	/* Eval/evaluate_comp.scm 693 */
								obj_t BgL_arg1720z00_1651;
								long BgL_arg1722z00_1652;

								BgL_arg1720z00_1651 = CDR(((obj_t) BgL_lz00_1643));
								BgL_arg1722z00_1652 = (BgL_iz00_1644 - ((long) 1));
								BgL_arg1718z00_1649 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15541,
									BgL_arg1720z00_1651, BgL_arg1722z00_1652);
							}
							return MAKE_YOUNG_PAIR(BgL_arg1717z00_1648, BgL_arg1718z00_1649);
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		obj_t BgL_siza7eza7_126)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 695 */
			{	/* Eval/evaluate_comp.scm 697 */
				obj_t BgL_argsz00_1654;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 697 */
						BgL_argsz00_1654 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 697 */
						obj_t BgL_head1342z00_1659;

						{	/* Eval/evaluate_comp.scm 697 */
							obj_t BgL_res4350z00_6672;

							BgL_res4350z00_6672 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							BgL_head1342z00_1659 = BgL_res4350z00_6672;
						}
						{
							obj_t BgL_l1340z00_6696;
							obj_t BgL_tail1343z00_6697;

							BgL_l1340z00_6696 = BgL_argsz00_124;
							BgL_tail1343z00_6697 = BgL_head1342z00_1659;
						BgL_zc3anonymousza31725ze3z83_6695:
							if (NULLP(BgL_l1340z00_6696))
								{	/* Eval/evaluate_comp.scm 697 */
									BgL_argsz00_1654 = CDR(BgL_head1342z00_1659);
								}
							else
								{	/* Eval/evaluate_comp.scm 697 */
									obj_t BgL_newtail1344z00_6704;

									{	/* Eval/evaluate_comp.scm 697 */
										obj_t BgL_arg1728z00_6705;

										{	/* Eval/evaluate_comp.scm 697 */
											obj_t BgL_az00_6706;

											BgL_az00_6706 = CAR(((obj_t) BgL_l1340z00_6696));
											BgL_arg1728z00_6705 =
												PROCEDURE_ENTRY(BgL_az00_6706) (BgL_az00_6706,
												BgL_sz00_122, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 697 */
											obj_t BgL_res4356z00_6711;

											BgL_res4356z00_6711 =
												MAKE_YOUNG_PAIR(BgL_arg1728z00_6705, BNIL);
											BgL_newtail1344z00_6704 = BgL_res4356z00_6711;
										}
									}
									SET_CDR(BgL_tail1343z00_6697, BgL_newtail1344z00_6704);
									{	/* Eval/evaluate_comp.scm 697 */
										obj_t BgL_arg1727z00_6707;

										BgL_arg1727z00_6707 = CDR(((obj_t) BgL_l1340z00_6696));
										{
											obj_t BgL_tail1343z00_18729;
											obj_t BgL_l1340z00_18728;

											BgL_l1340z00_18728 = BgL_arg1727z00_6707;
											BgL_tail1343z00_18729 = BgL_newtail1344z00_6704;
											BgL_tail1343z00_6697 = BgL_tail1343z00_18729;
											BgL_l1340z00_6696 = BgL_l1340z00_18728;
											goto BgL_zc3anonymousza31725ze3z83_6695;
										}
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 698 */
					long BgL_arg1723z00_1655;

					BgL_arg1723z00_1655 =
						((long) CINT(BgL_bpz00_125) + (long) CINT(BgL_siza7eza7_126));
					VECTOR_SET(
						((obj_t) BgL_sz00_122), ((long) 0), BINT(BgL_arg1723z00_1655));
				}
				{	/* Eval/evaluate_comp.scm 699 */
					obj_t BgL_za2za2resza2za2z00_1656;

					BgL_za2za2resza2za2z00_1656 = apply(BgL_fz00_123, BgL_argsz00_1654);
					VECTOR_SET(((obj_t) BgL_sz00_122), ((long) 0), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1656;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 708 */
			{	/* Eval/evaluate_comp.scm 709 */
				long BgL_g1148z00_1680;

				BgL_g1148z00_1680 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1682;
					obj_t BgL_spz00_1683;
					long BgL_nz00_1684;

					BgL_lz00_1682 = BgL_argsz00_132;
					BgL_spz00_1683 = BgL_spz00_133;
					BgL_nz00_1684 = BgL_g1148z00_1680;
				BgL_zc3anonymousza31735ze3z83_1685:
					if ((BgL_nz00_1684 == ((long) 0)))
						{
							obj_t BgL_lz00_6798;
							obj_t BgL_rz00_6799;

							BgL_lz00_6798 = BgL_lz00_1682;
							BgL_rz00_6799 = BNIL;
						BgL_rec2z00_6797:
							if (NULLP(BgL_lz00_6798))
								{	/* Eval/evaluate_comp.scm 713 */
									obj_t BgL_arg1739z00_6807;

									BgL_arg1739z00_6807 = bgl_reverse_bang(BgL_rz00_6799);
									{	/* Eval/evaluate_comp.scm 713 */
										long BgL_kz00_6814;

										BgL_kz00_6814 = (long) CINT(BgL_spz00_1683);
										return
											VECTOR_SET(
											((obj_t) BgL_sz00_131), BgL_kz00_6814,
											BgL_arg1739z00_6807);
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 714 */
									obj_t BgL_arg1740z00_6808;
									obj_t BgL_arg1741z00_6809;

									BgL_arg1740z00_6808 = CDR(((obj_t) BgL_lz00_6798));
									{	/* Eval/evaluate_comp.scm 714 */
										obj_t BgL_arg1742z00_6810;

										{	/* Eval/evaluate_comp.scm 714 */
											obj_t BgL_fun1743z00_6811;

											BgL_fun1743z00_6811 = CAR(((obj_t) BgL_lz00_6798));
											BgL_arg1742z00_6810 =
												PROCEDURE_ENTRY(BgL_fun1743z00_6811)
												(BgL_fun1743z00_6811, BgL_sz00_131, BEOA);
										}
										BgL_arg1741z00_6809 =
											MAKE_YOUNG_PAIR(BgL_arg1742z00_6810, BgL_rz00_6799);
									}
									{
										obj_t BgL_rz00_18760;
										obj_t BgL_lz00_18759;

										BgL_lz00_18759 = BgL_arg1740z00_6808;
										BgL_rz00_18760 = BgL_arg1741z00_6809;
										BgL_rz00_6799 = BgL_rz00_18760;
										BgL_lz00_6798 = BgL_lz00_18759;
										goto BgL_rec2z00_6797;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 710 */
							{	/* Eval/evaluate_comp.scm 715 */
								obj_t BgL_arg1744z00_1699;

								{	/* Eval/evaluate_comp.scm 715 */
									obj_t BgL_fun1745z00_1700;

									BgL_fun1745z00_1700 = CAR(((obj_t) BgL_lz00_1682));
									BgL_arg1744z00_1699 =
										PROCEDURE_ENTRY(BgL_fun1745z00_1700) (BgL_fun1745z00_1700,
										BgL_sz00_131, BEOA);
								}
								{	/* Eval/evaluate_comp.scm 715 */
									long BgL_kz00_6819;

									BgL_kz00_6819 = (long) CINT(BgL_spz00_1683);
									VECTOR_SET(
										((obj_t) BgL_sz00_131), BgL_kz00_6819, BgL_arg1744z00_1699);
							}}
							{	/* Eval/evaluate_comp.scm 716 */
								obj_t BgL_arg1746z00_1701;
								long BgL_arg1747z00_1702;
								long BgL_arg1748z00_1703;

								BgL_arg1746z00_1701 = CDR(((obj_t) BgL_lz00_1682));
								BgL_arg1747z00_1702 =
									((long) CINT(BgL_spz00_1683) + ((long) 1));
								BgL_arg1748z00_1703 = (BgL_nz00_1684 - ((long) 1));
								{
									long BgL_nz00_18778;
									obj_t BgL_spz00_18776;
									obj_t BgL_lz00_18775;

									BgL_lz00_18775 = BgL_arg1746z00_1701;
									BgL_spz00_18776 = BINT(BgL_arg1747z00_1702);
									BgL_nz00_18778 = BgL_arg1748z00_1703;
									BgL_nz00_1684 = BgL_nz00_18778;
									BgL_spz00_1683 = BgL_spz00_18776;
									BgL_lz00_1682 = BgL_lz00_18775;
									goto BgL_zc3anonymousza31735ze3z83_1685;
								}
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 759 */
			{
				obj_t BgL_lz00_1706;
				obj_t BgL_stkz00_1707;

				BgL_lz00_1706 = BgL_argsz00_134;
				BgL_stkz00_1707 = BgL_stkz00_135;
			BgL_zc3anonymousza31749ze3z83_1708:
				{	/* Eval/evaluate_comp.scm 763 */
					bool_t BgL_testz00_18779;

					if (NULLP(BgL_lz00_1706))
						{	/* Eval/evaluate_comp.scm 763 */
							BgL_testz00_18779 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 763 */
							BgL_testz00_18779 = NULLP(BgL_stkz00_1707);
						}
					if (BgL_testz00_18779)
						{	/* Eval/evaluate_comp.scm 763 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 765 */
							bool_t BgL_testz00_18783;

							{	/* Eval/evaluate_comp.scm 765 */
								obj_t BgL_g1347z00_1725;

								BgL_g1347z00_1725 = CDR(((obj_t) BgL_lz00_1706));
								{
									obj_t BgL_l1345z00_1727;

									{	/* Eval/evaluate_comp.scm 765 */
										obj_t BgL_tmpz00_18786;

										BgL_l1345z00_1727 = BgL_g1347z00_1725;
									BgL_zc3anonymousza31760ze3z83_1728:
										if (NULLP(BgL_l1345z00_1727))
											{	/* Eval/evaluate_comp.scm 765 */
												BgL_tmpz00_18786 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 765 */
												obj_t BgL__ortest_1348z00_1730;

												{	/* Eval/evaluate_comp.scm 765 */
													obj_t BgL_ez00_1732;

													BgL_ez00_1732 = CAR(((obj_t) BgL_l1345z00_1727));
													{	/* Eval/evaluate_comp.scm 765 */
														obj_t BgL_arg1763z00_1733;
														obj_t BgL_arg1765z00_1734;

														BgL_arg1763z00_1733 =
															CAR(((obj_t) BgL_stkz00_1707));
														BgL_arg1765z00_1734 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1732), BNIL);
														BgL__ortest_1348z00_1730 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1763z00_1733, BgL_arg1765z00_1734);
													}
												}
												if (CBOOL(BgL__ortest_1348z00_1730))
													{	/* Eval/evaluate_comp.scm 765 */
														BgL_tmpz00_18786 = BgL__ortest_1348z00_1730;
													}
												else
													{	/* Eval/evaluate_comp.scm 765 */
														obj_t BgL_arg1762z00_1731;

														BgL_arg1762z00_1731 =
															CDR(((obj_t) BgL_l1345z00_1727));
														{
															obj_t BgL_l1345z00_18800;

															BgL_l1345z00_18800 = BgL_arg1762z00_1731;
															BgL_l1345z00_1727 = BgL_l1345z00_18800;
															goto BgL_zc3anonymousza31760ze3z83_1728;
														}
													}
											}
										BgL_testz00_18783 = CBOOL(BgL_tmpz00_18786);
									}
								}
							}
							if (BgL_testz00_18783)
								{	/* Eval/evaluate_comp.scm 765 */
									return ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 767 */
									obj_t BgL_arg1758z00_1723;
									obj_t BgL_arg1759z00_1724;

									BgL_arg1758z00_1723 = CDR(((obj_t) BgL_lz00_1706));
									BgL_arg1759z00_1724 = CDR(((obj_t) BgL_stkz00_1707));
									{
										obj_t BgL_stkz00_18807;
										obj_t BgL_lz00_18806;

										BgL_lz00_18806 = BgL_arg1758z00_1723;
										BgL_stkz00_18807 = BgL_arg1759z00_1724;
										BgL_stkz00_1707 = BgL_stkz00_18807;
										BgL_lz00_1706 = BgL_lz00_18806;
										goto BgL_zc3anonymousza31749ze3z83_1708;
									}
								}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 769 */
			{	/* Eval/evaluate_comp.scm 771 */
				long BgL_siza7eza7_1739;
				long BgL_nbargsz00_1740;
				obj_t BgL_fz00_1741;
				obj_t BgL_symbzd2funzd2_1742;

				BgL_siza7eza7_1739 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1740 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1741 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1742 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							COBJECT(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
							BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 773 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_testz00_18821;

								{	/* Eval/evaluate_comp.scm 780 */
									int BgL_arg1821z00_1821;

									BgL_arg1821z00_1821 = bgl_debug();
									BgL_testz00_18821 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1821z00_1821),
										BINT(((long) 0)));
								}
								if (BgL_testz00_18821)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_argsz00_1748;

										BgL_argsz00_1748 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_zc3anonymousza31772ze3z83_13571;

											BgL_zc3anonymousza31772ze3z83_13571 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31772ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_13571,
												(int) (((long) 0)), BgL_fz00_1741);
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_13571,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_13571,
												(int) (((long) 2)), BgL_symbzd2funzd2_1742);
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_13571,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1740));
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_13571,
												(int) (((long) 4)), BgL_argsz00_1748);
											PROCEDURE_SET(BgL_zc3anonymousza31772ze3z83_13571,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1739));
											return BgL_zc3anonymousza31772ze3z83_13571;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_argsz00_1786;

										BgL_argsz00_1786 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 780 */
											obj_t BgL_zc3anonymousza31799ze3z83_13572;

											BgL_zc3anonymousza31799ze3z83_13572 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31799ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_13572,
												(int) (((long) 0)), BgL_fz00_1741);
											PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_13572,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_13572,
												(int) (((long) 2)), BgL_symbzd2funzd2_1742);
											PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_13572,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1740));
											PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_13572,
												(int) (((long) 4)), BgL_argsz00_1786);
											PROCEDURE_SET(BgL_zc3anonymousza31799ze3z83_13572,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1739));
											return BgL_zc3anonymousza31799ze3z83_13572;
										}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_testz00_18866;

								{	/* Eval/evaluate_comp.scm 788 */
									int BgL_arg1865z00_1891;

									BgL_arg1865z00_1891 = bgl_debug();
									BgL_testz00_18866 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1865z00_1891),
										BINT(((long) 0)));
								}
								if (BgL_testz00_18866)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_argsz00_1824;

										BgL_argsz00_1824 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1739);
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_zc3anonymousza31824ze3z83_13573;

											BgL_zc3anonymousza31824ze3z83_13573 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3anonymousza31824ze3z83_13573,
												(int) (((long) 0)), BgL_fz00_1741);
											PROCEDURE_SET(BgL_zc3anonymousza31824ze3z83_13573,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31824ze3z83_13573,
												(int) (((long) 2)), BgL_symbzd2funzd2_1742);
											PROCEDURE_SET(BgL_zc3anonymousza31824ze3z83_13573,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1740));
											PROCEDURE_SET(BgL_zc3anonymousza31824ze3z83_13573,
												(int) (((long) 4)), BgL_argsz00_1824);
											return BgL_zc3anonymousza31824ze3z83_13573;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_argsz00_1859;

										BgL_argsz00_1859 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1739);
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_zc3anonymousza31847ze3z83_13574;

											BgL_zc3anonymousza31847ze3z83_13574 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza31847ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3anonymousza31847ze3z83_13574,
												(int) (((long) 0)), BgL_fz00_1741);
											PROCEDURE_SET(BgL_zc3anonymousza31847ze3z83_13574,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3anonymousza31847ze3z83_13574,
												(int) (((long) 2)), BgL_symbzd2funzd2_1742);
											PROCEDURE_SET(BgL_zc3anonymousza31847ze3z83_13574,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1740));
											PROCEDURE_SET(BgL_zc3anonymousza31847ze3z83_13574,
												(int) (((long) 4)), BgL_argsz00_1859);
											return BgL_zc3anonymousza31847ze3z83_13574;
										}
									}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 774 */
						bool_t BgL_testz00_18905;

						{	/* Eval/evaluate_comp.scm 774 */
							int BgL_arg1909z00_1962;

							BgL_arg1909z00_1962 = bgl_debug();
							BgL_testz00_18905 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1909z00_1962),
								BINT(((long) 0)));
						}
						if (BgL_testz00_18905)
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_argsz00_1895;

								BgL_argsz00_1895 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_zc3anonymousza31870ze3z83_13575;

									BgL_zc3anonymousza31870ze3z83_13575 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3anonymousza31870ze3z83_13575,
										(int) (((long) 0)), BgL_fz00_1741);
									PROCEDURE_SET(BgL_zc3anonymousza31870ze3z83_13575,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3anonymousza31870ze3z83_13575,
										(int) (((long) 2)), BgL_symbzd2funzd2_1742);
									PROCEDURE_SET(BgL_zc3anonymousza31870ze3z83_13575,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1740));
									PROCEDURE_SET(BgL_zc3anonymousza31870ze3z83_13575,
										(int) (((long) 4)), BgL_argsz00_1895);
									PROCEDURE_SET(BgL_zc3anonymousza31870ze3z83_13575,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1739));
									return BgL_zc3anonymousza31870ze3z83_13575;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_argsz00_1930;

								BgL_argsz00_1930 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_zc3anonymousza31892ze3z83_13576;

									BgL_zc3anonymousza31892ze3z83_13576 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31892ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3anonymousza31892ze3z83_13576,
										(int) (((long) 0)), BgL_fz00_1741);
									PROCEDURE_SET(BgL_zc3anonymousza31892ze3z83_13576,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3anonymousza31892ze3z83_13576,
										(int) (((long) 2)), BgL_symbzd2funzd2_1742);
									PROCEDURE_SET(BgL_zc3anonymousza31892ze3z83_13576,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1740));
									PROCEDURE_SET(BgL_zc3anonymousza31892ze3z83_13576,
										(int) (((long) 4)), BgL_argsz00_1930);
									PROCEDURE_SET(BgL_zc3anonymousza31892ze3z83_13576,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1739));
									return BgL_zc3anonymousza31892ze3z83_13576;
								}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1772> */
	obj_t BGl_z62zc3anonymousza31772ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13577, obj_t BgL_sz00_13584)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 780 */
			{	/* Eval/evaluate_comp.scm 780 */
				obj_t BgL_fz00_13578;
				BgL_ev_appz00_bglt BgL_i1156z00_13579;
				obj_t BgL_symbzd2funzd2_13580;
				long BgL_nbargsz00_13581;
				obj_t BgL_argsz00_13582;
				long BgL_siza7eza7_13583;

				BgL_fz00_13578 = PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 0)));
				BgL_i1156z00_13579 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 1))));
				BgL_symbzd2funzd2_13580 =
					PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 2)));
				BgL_nbargsz00_13581 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 3))));
				BgL_argsz00_13582 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 4))));
				BgL_siza7eza7_13583 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13577, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 780 */
					obj_t BgL_bpz00_15562;

					BgL_bpz00_15562 = VECTOR_REF(((obj_t) BgL_sz00_13584), ((long) 0));
					{	/* Eval/evaluate_comp.scm 780 */
						obj_t BgL_fz00_15563;

						BgL_fz00_15563 =
							PROCEDURE_ENTRY(BgL_fz00_13578) (BgL_fz00_13578, BgL_sz00_13584,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15563))
							{	/* Eval/evaluate_comp.scm 780 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 780 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13579))->
										BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15563);
							}
						{	/* Eval/evaluate_comp.scm 780 */
							obj_t BgL_ufz00_15564;

							{	/* Eval/evaluate_comp.scm 780 */
								obj_t BgL_tmpz00_18976;

								BgL_tmpz00_18976 = ((obj_t) BgL_fz00_15563);
								BgL_ufz00_15564 = PROCEDURE_ATTR(BgL_tmpz00_18976);
							}
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_testz00_18979;

								if (STRUCTP(BgL_ufz00_15564))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_18979 =
											(STRUCT_KEY(BgL_ufz00_15564) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_18979 = ((bool_t) 0);
									}
								if (BgL_testz00_18979)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_arityz00_15565;
										obj_t BgL_runz00_15566;
										obj_t BgL_sfz00_15567;

										BgL_arityz00_15565 =
											STRUCT_REF(BgL_ufz00_15564, (int) (((long) 0)));
										BgL_runz00_15566 =
											STRUCT_REF(BgL_ufz00_15564, (int) (((long) 1)));
										BgL_sfz00_15567 =
											STRUCT_REF(BgL_ufz00_15564, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 780 */
											long BgL_spz00_15568;

											BgL_spz00_15568 =
												((long) CINT(BgL_bpz00_15562) + BgL_siza7eza7_13583);
											if (
												((long) CINT(BgL_arityz00_15565) ==
													BgL_nbargsz00_13581))
												{	/* Eval/evaluate_comp.scm 780 */
													{
														obj_t BgL_lz00_15570;
														long BgL_spz00_15571;

														BgL_lz00_15570 = BgL_argsz00_13582;
														BgL_spz00_15571 = BgL_spz00_15568;
													BgL_recz00_15569:
														if (NULLP(BgL_lz00_15570))
															{	/* Eval/evaluate_comp.scm 704 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1731z00_15572;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1732z00_15573;

																		BgL_fun1732z00_15573 =
																			CAR(((obj_t) BgL_lz00_15570));
																		BgL_arg1731z00_15572 =
																			PROCEDURE_ENTRY(BgL_fun1732z00_15573)
																			(BgL_fun1732z00_15573, BgL_sz00_13584,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13584), BgL_spz00_15571,
																		BgL_arg1731z00_15572);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1733z00_15574;
																	long BgL_arg1734z00_15575;

																	BgL_arg1733z00_15574 =
																		CDR(((obj_t) BgL_lz00_15570));
																	BgL_arg1734z00_15575 =
																		(BgL_spz00_15571 + ((long) 1));
																	{
																		long BgL_spz00_19009;
																		obj_t BgL_lz00_19008;

																		BgL_lz00_19008 = BgL_arg1733z00_15574;
																		BgL_spz00_19009 = BgL_arg1734z00_15575;
																		BgL_spz00_15571 = BgL_spz00_19009;
																		BgL_lz00_15570 = BgL_lz00_19008;
																		goto BgL_recz00_15569;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 784 */
														long BgL_arg1778z00_15576;

														BgL_arg1778z00_15576 =
															(BgL_spz00_15568 + BgL_nbargsz00_13581);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13584, (long) CINT(BgL_bpz00_15562),
															BgL_sz00_13584, BINT(BgL_spz00_15568),
															BINT(BgL_arg1778z00_15576));
												}}
											else
												{	/* Eval/evaluate_comp.scm 780 */
													bool_t BgL_testz00_19015;

													if (((long) CINT(BgL_arityz00_15565) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_testz00_19015 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_testz00_19015 =
																(
																(long) CINT(BgL_arityz00_15565) <
																(((long) -1) - BgL_nbargsz00_13581));
														}
													if (BgL_testz00_19015)
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1156z00_13579))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15564, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13581),
																CINT(BgL_arityz00_15565));
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15565, BgL_sz00_13584,
																BgL_argsz00_13582, BINT(BgL_spz00_15568));
															{	/* Eval/evaluate_comp.scm 786 */
																long BgL_arg1784z00_15577;

																BgL_arg1784z00_15577 =
																	(BgL_spz00_15568 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15565)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13584, (long) CINT(BgL_bpz00_15562),
																	BgL_sz00_13584, BINT(BgL_spz00_15568),
																	BINT(BgL_arg1784z00_15577));
												}}}
											{	/* Eval/evaluate_comp.scm 780 */
												obj_t BgL_z12denvz12_15578;

												BgL_z12denvz12_15578 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 780 */
													obj_t BgL_tmpz00_19038;

													BgL_tmpz00_19038 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1156z00_13579))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15578,
														BgL_tmpz00_19038);
												}
												if (
													(((long) CINT(BgL_bpz00_15562) +
															(long) CINT(BgL_sfz00_15567)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13584))))
													{	/* Eval/evaluate_comp.scm 780 */
														return BgL_runz00_15566;
													}
												else
													{	/* Eval/evaluate_comp.scm 780 */
														obj_t BgL_nsz00_15579;

														BgL_nsz00_15579 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 780 */
															long BgL_arg1790z00_15580;

															BgL_arg1790z00_15580 =
																(
																(long) CINT(BgL_bpz00_15562) +
																BgL_nbargsz00_13581);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15579, ((long) 2), BgL_sz00_13584,
																BgL_bpz00_15562, BINT(BgL_arg1790z00_15580));
														}
														VECTOR_SET(BgL_nsz00_15579, ((long) 1),
															BgL_sz00_13584);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15578,
															BgL_nsz00_15579);
														{	/* Eval/evaluate_comp.scm 780 */
															obj_t BgL_ez00_15581;

															BgL_ez00_15581 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15581, BgL_sz00_13584);
															{	/* Eval/evaluate_comp.scm 780 */
																obj_t BgL_____rz00_15582;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15583;

																	BgL_savedzd2bpzd2_15583 =
																		VECTOR_REF(BgL_nsz00_15579, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15579, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15585;

																		BgL_fz00_15585 = BgL_runz00_15566;
																	BgL_recz00_15584:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15586;

																			BgL_rz00_15586 =
																				PROCEDURE_ENTRY(BgL_fz00_15585)
																				(BgL_fz00_15585, BgL_nsz00_15579, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_19064;

																				if (PROCEDUREP(BgL_rz00_15586))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15587;

																						BgL_arg1696z00_15587 =
																							PROCEDURE_ATTR(BgL_rz00_15586);
																						if (STRUCTP(BgL_arg1696z00_15587))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19064 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15587) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19064 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_19064 = ((bool_t) 0);
																					}
																				if (BgL_testz00_19064)
																					{
																						obj_t BgL_fz00_19072;

																						BgL_fz00_19072 = BgL_rz00_15586;
																						BgL_fz00_15585 = BgL_fz00_19072;
																						goto BgL_recz00_15584;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15579,
																							((long) 0),
																							BgL_savedzd2bpzd2_15583);
																						BgL_____rz00_15582 = BgL_rz00_15586;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15581);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15578,
																	BgL_sz00_13584);
																return BgL_____rz00_15582;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15563,
												(int) (BgL_nbargsz00_13581)))
											{	/* Eval/evaluate_comp.scm 780 */
												{	/* Eval/evaluate_comp.scm 780 */
													obj_t BgL_auxz00_19081;
													obj_t BgL_tmpz00_19079;

													BgL_auxz00_19081 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1156z00_13579))->BgL_locz00);
													BgL_tmpz00_19079 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19079,
														BgL_auxz00_19081);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13584, BgL_fz00_15563, BgL_argsz00_13582,
													BgL_bpz00_15562, BINT(BgL_siza7eza7_13583));
											}
										else
											{	/* Eval/evaluate_comp.scm 780 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13579))->
														BgL_locz00), BgL_symbzd2funzd2_13580,
													(int) (BgL_nbargsz00_13581),
													PROCEDURE_ARITY(BgL_fz00_15563));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1799> */
	obj_t BGl_z62zc3anonymousza31799ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13585, obj_t BgL_sz00_13592)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 780 */
			{	/* Eval/evaluate_comp.scm 780 */
				obj_t BgL_fz00_13586;
				BgL_ev_appz00_bglt BgL_i1156z00_13587;
				obj_t BgL_symbzd2funzd2_13588;
				long BgL_nbargsz00_13589;
				obj_t BgL_argsz00_13590;
				long BgL_siza7eza7_13591;

				BgL_fz00_13586 = PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 0)));
				BgL_i1156z00_13587 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 1))));
				BgL_symbzd2funzd2_13588 =
					PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 2)));
				BgL_nbargsz00_13589 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 3))));
				BgL_argsz00_13590 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 4))));
				BgL_siza7eza7_13591 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13585, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 780 */
					obj_t BgL_bpz00_15588;

					BgL_bpz00_15588 = VECTOR_REF(((obj_t) BgL_sz00_13592), ((long) 0));
					{	/* Eval/evaluate_comp.scm 780 */
						obj_t BgL_fz00_15589;

						BgL_fz00_15589 =
							PROCEDURE_ENTRY(BgL_fz00_13586) (BgL_fz00_13586, BgL_sz00_13592,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15589))
							{	/* Eval/evaluate_comp.scm 780 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 780 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13587))->
										BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15589);
							}
						{	/* Eval/evaluate_comp.scm 780 */
							obj_t BgL_ufz00_15590;

							{	/* Eval/evaluate_comp.scm 780 */
								obj_t BgL_tmpz00_19116;

								BgL_tmpz00_19116 = ((obj_t) BgL_fz00_15589);
								BgL_ufz00_15590 = PROCEDURE_ATTR(BgL_tmpz00_19116);
							}
							{	/* Eval/evaluate_comp.scm 780 */
								bool_t BgL_testz00_19119;

								if (STRUCTP(BgL_ufz00_15590))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19119 =
											(STRUCT_KEY(BgL_ufz00_15590) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19119 = ((bool_t) 0);
									}
								if (BgL_testz00_19119)
									{	/* Eval/evaluate_comp.scm 780 */
										obj_t BgL_arityz00_15591;
										obj_t BgL_runz00_15592;
										obj_t BgL_sfz00_15593;

										BgL_arityz00_15591 =
											STRUCT_REF(BgL_ufz00_15590, (int) (((long) 0)));
										BgL_runz00_15592 =
											STRUCT_REF(BgL_ufz00_15590, (int) (((long) 1)));
										BgL_sfz00_15593 =
											STRUCT_REF(BgL_ufz00_15590, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 780 */
											long BgL_spz00_15594;

											BgL_spz00_15594 =
												((long) CINT(BgL_bpz00_15588) + BgL_siza7eza7_13591);
											if (
												((long) CINT(BgL_arityz00_15591) ==
													BgL_nbargsz00_13589))
												{	/* Eval/evaluate_comp.scm 780 */
													{
														obj_t BgL_lz00_15596;
														long BgL_spz00_15597;

														BgL_lz00_15596 = BgL_argsz00_13590;
														BgL_spz00_15597 = BgL_spz00_15594;
													BgL_recz00_15595:
														if (NULLP(BgL_lz00_15596))
															{	/* Eval/evaluate_comp.scm 704 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1731z00_15598;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1732z00_15599;

																		BgL_fun1732z00_15599 =
																			CAR(((obj_t) BgL_lz00_15596));
																		BgL_arg1731z00_15598 =
																			PROCEDURE_ENTRY(BgL_fun1732z00_15599)
																			(BgL_fun1732z00_15599, BgL_sz00_13592,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13592), BgL_spz00_15597,
																		BgL_arg1731z00_15598);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1733z00_15600;
																	long BgL_arg1734z00_15601;

																	BgL_arg1733z00_15600 =
																		CDR(((obj_t) BgL_lz00_15596));
																	BgL_arg1734z00_15601 =
																		(BgL_spz00_15597 + ((long) 1));
																	{
																		long BgL_spz00_19149;
																		obj_t BgL_lz00_19148;

																		BgL_lz00_19148 = BgL_arg1733z00_15600;
																		BgL_spz00_19149 = BgL_arg1734z00_15601;
																		BgL_spz00_15597 = BgL_spz00_19149;
																		BgL_lz00_15596 = BgL_lz00_19148;
																		goto BgL_recz00_15595;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 784 */
														long BgL_arg1805z00_15602;

														BgL_arg1805z00_15602 =
															(BgL_spz00_15594 + BgL_nbargsz00_13589);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13592, (long) CINT(BgL_bpz00_15588),
															BgL_sz00_13592, BINT(BgL_spz00_15594),
															BINT(BgL_arg1805z00_15602));
												}}
											else
												{	/* Eval/evaluate_comp.scm 780 */
													bool_t BgL_testz00_19155;

													if (((long) CINT(BgL_arityz00_15591) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_testz00_19155 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BgL_testz00_19155 =
																(
																(long) CINT(BgL_arityz00_15591) <
																(((long) -1) - BgL_nbargsz00_13589));
														}
													if (BgL_testz00_19155)
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1156z00_13587))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15590, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13589),
																CINT(BgL_arityz00_15591));
														}
													else
														{	/* Eval/evaluate_comp.scm 780 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15591, BgL_sz00_13592,
																BgL_argsz00_13590, BINT(BgL_spz00_15594));
															{	/* Eval/evaluate_comp.scm 786 */
																long BgL_arg1811z00_15603;

																BgL_arg1811z00_15603 =
																	(BgL_spz00_15594 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15591)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13592, (long) CINT(BgL_bpz00_15588),
																	BgL_sz00_13592, BINT(BgL_spz00_15594),
																	BINT(BgL_arg1811z00_15603));
												}}}
											{	/* Eval/evaluate_comp.scm 780 */
												obj_t BgL_z12denvz12_15604;

												BgL_z12denvz12_15604 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_15588) +
															(long) CINT(BgL_sfz00_15593)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13592))))
													{	/* Eval/evaluate_comp.scm 780 */
														return BgL_runz00_15592;
													}
												else
													{	/* Eval/evaluate_comp.scm 780 */
														obj_t BgL_nsz00_15605;

														BgL_nsz00_15605 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 780 */
															long BgL_arg1816z00_15606;

															BgL_arg1816z00_15606 =
																(
																(long) CINT(BgL_bpz00_15588) +
																BgL_nbargsz00_13589);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15605, ((long) 2), BgL_sz00_13592,
																BgL_bpz00_15588, BINT(BgL_arg1816z00_15606));
														}
														VECTOR_SET(BgL_nsz00_15605, ((long) 1),
															BgL_sz00_13592);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15604,
															BgL_nsz00_15605);
														{	/* Eval/evaluate_comp.scm 780 */
															obj_t BgL_ez00_15607;

															BgL_ez00_15607 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15607, BgL_sz00_13592);
															{	/* Eval/evaluate_comp.scm 780 */
																obj_t BgL_____rz00_15608;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15609;

																	BgL_savedzd2bpzd2_15609 =
																		VECTOR_REF(BgL_nsz00_15605, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15605, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15611;

																		BgL_fz00_15611 = BgL_runz00_15592;
																	BgL_recz00_15610:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15612;

																			BgL_rz00_15612 =
																				PROCEDURE_ENTRY(BgL_fz00_15611)
																				(BgL_fz00_15611, BgL_nsz00_15605, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_19201;

																				if (PROCEDUREP(BgL_rz00_15612))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15613;

																						BgL_arg1696z00_15613 =
																							PROCEDURE_ATTR(BgL_rz00_15612);
																						if (STRUCTP(BgL_arg1696z00_15613))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19201 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15613) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19201 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_19201 = ((bool_t) 0);
																					}
																				if (BgL_testz00_19201)
																					{
																						obj_t BgL_fz00_19209;

																						BgL_fz00_19209 = BgL_rz00_15612;
																						BgL_fz00_15611 = BgL_fz00_19209;
																						goto BgL_recz00_15610;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15605,
																							((long) 0),
																							BgL_savedzd2bpzd2_15609);
																						BgL_____rz00_15608 = BgL_rz00_15612;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15607);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15604,
																	BgL_sz00_13592);
																return BgL_____rz00_15608;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 780 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15589,
												(int) (BgL_nbargsz00_13589)))
											{	/* Eval/evaluate_comp.scm 780 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13592, BgL_fz00_15589, BgL_argsz00_13590,
													BgL_bpz00_15588, BINT(BgL_siza7eza7_13591));
											}
										else
											{	/* Eval/evaluate_comp.scm 780 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13587))->
														BgL_locz00), BgL_symbzd2funzd2_13588,
													(int) (BgL_nbargsz00_13589),
													PROCEDURE_ARITY(BgL_fz00_15589));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1824> */
	obj_t BGl_z62zc3anonymousza31824ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13593, obj_t BgL_sz00_13599)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 788 */
			{	/* Eval/evaluate_comp.scm 788 */
				obj_t BgL_fz00_13594;
				BgL_ev_appz00_bglt BgL_i1156z00_13595;
				obj_t BgL_symbzd2funzd2_13596;
				long BgL_nbargsz00_13597;
				obj_t BgL_argsz00_13598;

				BgL_fz00_13594 = PROCEDURE_REF(BgL_envz00_13593, (int) (((long) 0)));
				BgL_i1156z00_13595 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13593, (int) (((long) 1))));
				BgL_symbzd2funzd2_13596 =
					PROCEDURE_REF(BgL_envz00_13593, (int) (((long) 2)));
				BgL_nbargsz00_13597 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13593, (int) (((long) 3))));
				BgL_argsz00_13598 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13593, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 788 */
					obj_t BgL_bpz00_15614;

					BgL_bpz00_15614 = VECTOR_REF(((obj_t) BgL_sz00_13599), ((long) 0));
					{	/* Eval/evaluate_comp.scm 788 */
						obj_t BgL_fz00_15615;

						BgL_fz00_15615 =
							PROCEDURE_ENTRY(BgL_fz00_13594) (BgL_fz00_13594, BgL_sz00_13599,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15615))
							{	/* Eval/evaluate_comp.scm 788 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13595))->
										BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15615);
							}
						{	/* Eval/evaluate_comp.scm 788 */
							obj_t BgL_ufz00_15616;

							{	/* Eval/evaluate_comp.scm 788 */
								obj_t BgL_tmpz00_19245;

								BgL_tmpz00_19245 = ((obj_t) BgL_fz00_15615);
								BgL_ufz00_15616 = PROCEDURE_ATTR(BgL_tmpz00_19245);
							}
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_testz00_19248;

								if (STRUCTP(BgL_ufz00_15616))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19248 =
											(STRUCT_KEY(BgL_ufz00_15616) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19248 = ((bool_t) 0);
									}
								if (BgL_testz00_19248)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_arityz00_15617;
										obj_t BgL_runz00_15618;
										obj_t BgL_sfz00_15619;

										BgL_arityz00_15617 =
											STRUCT_REF(BgL_ufz00_15616, (int) (((long) 0)));
										BgL_runz00_15618 =
											STRUCT_REF(BgL_ufz00_15616, (int) (((long) 1)));
										BgL_sfz00_15619 =
											STRUCT_REF(BgL_ufz00_15616, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15617) == BgL_nbargsz00_13597))
											{
												obj_t BgL_lz00_15621;
												obj_t BgL_spz00_15622;

												{	/* Eval/evaluate_comp.scm 703 */
													bool_t BgL_tmpz00_19262;

													BgL_lz00_15621 = BgL_argsz00_13598;
													BgL_spz00_15622 = BgL_bpz00_15614;
												BgL_recz00_15620:
													if (NULLP(BgL_lz00_15621))
														{	/* Eval/evaluate_comp.scm 704 */
															BgL_tmpz00_19262 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 704 */
															{	/* Eval/evaluate_comp.scm 705 */
																obj_t BgL_arg1731z00_15623;

																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_fun1732z00_15624;

																	BgL_fun1732z00_15624 =
																		CAR(((obj_t) BgL_lz00_15621));
																	BgL_arg1731z00_15623 =
																		PROCEDURE_ENTRY(BgL_fun1732z00_15624)
																		(BgL_fun1732z00_15624, BgL_sz00_13599,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 705 */
																	long BgL_kz00_15625;

																	BgL_kz00_15625 = (long) CINT(BgL_spz00_15622);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13599), BgL_kz00_15625,
																		BgL_arg1731z00_15623);
															}}
															{	/* Eval/evaluate_comp.scm 706 */
																obj_t BgL_arg1733z00_15626;
																long BgL_arg1734z00_15627;

																BgL_arg1733z00_15626 =
																	CDR(((obj_t) BgL_lz00_15621));
																BgL_arg1734z00_15627 =
																	((long) CINT(BgL_spz00_15622) + ((long) 1));
																{
																	obj_t BgL_spz00_19279;
																	obj_t BgL_lz00_19278;

																	BgL_lz00_19278 = BgL_arg1733z00_15626;
																	BgL_spz00_19279 = BINT(BgL_arg1734z00_15627);
																	BgL_spz00_15622 = BgL_spz00_19279;
																	BgL_lz00_15621 = BgL_lz00_19278;
																	goto BgL_recz00_15620;
																}
															}
														}
													BBOOL(BgL_tmpz00_19262);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												bool_t BgL_testz00_19282;

												if (((long) CINT(BgL_arityz00_15617) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_testz00_19282 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_testz00_19282 =
															(
															(long) CINT(BgL_arityz00_15617) <
															(((long) -1) - BgL_nbargsz00_13597));
													}
												if (BgL_testz00_19282)
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1156z00_13595))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15616, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13597),
															CINT(BgL_arityz00_15617));
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15617, BgL_sz00_13599,
															BgL_argsz00_13598, BgL_bpz00_15614);
													}
											}
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_z12denvz12_15628;

											BgL_z12denvz12_15628 = BGL_CURRENT_DYNAMIC_ENV();
											{	/* Eval/evaluate_comp.scm 788 */
												obj_t BgL_tmpz00_19297;

												BgL_tmpz00_19297 =
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13595))->
													BgL_locz00);
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15628,
													BgL_tmpz00_19297);
											}
											if (
												(((long) CINT(BgL_bpz00_15614) +
														(long) CINT(BgL_sfz00_15619)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13599))))
												{	/* Eval/evaluate_comp.scm 788 */
													return BgL_runz00_15618;
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_nsz00_15629;

													BgL_nsz00_15629 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 788 */
														long BgL_arg1838z00_15630;

														BgL_arg1838z00_15630 =
															(
															(long) CINT(BgL_bpz00_15614) +
															BgL_nbargsz00_13597);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15629, ((long) 2), BgL_sz00_13599,
															BgL_bpz00_15614, BINT(BgL_arg1838z00_15630));
													}
													VECTOR_SET(BgL_nsz00_15629, ((long) 1),
														BgL_sz00_13599);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15628,
														BgL_nsz00_15629);
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_ez00_15631;

														BgL_ez00_15631 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15631, BgL_sz00_13599);
														{	/* Eval/evaluate_comp.scm 788 */
															obj_t BgL_____rz00_15632;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15633;

																BgL_savedzd2bpzd2_15633 =
																	VECTOR_REF(BgL_nsz00_15629, ((long) 0));
																VECTOR_SET(BgL_nsz00_15629, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15635;

																	BgL_fz00_15635 = BgL_runz00_15618;
																BgL_recz00_15634:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15636;

																		BgL_rz00_15636 =
																			PROCEDURE_ENTRY(BgL_fz00_15635)
																			(BgL_fz00_15635, BgL_nsz00_15629, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_19323;

																			if (PROCEDUREP(BgL_rz00_15636))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15637;

																					BgL_arg1696z00_15637 =
																						PROCEDURE_ATTR(BgL_rz00_15636);
																					if (STRUCTP(BgL_arg1696z00_15637))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_19323 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15637) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_19323 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_19323 = ((bool_t) 0);
																				}
																			if (BgL_testz00_19323)
																				{
																					obj_t BgL_fz00_19331;

																					BgL_fz00_19331 = BgL_rz00_15636;
																					BgL_fz00_15635 = BgL_fz00_19331;
																					goto BgL_recz00_15634;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15629,
																						((long) 0),
																						BgL_savedzd2bpzd2_15633);
																					BgL_____rz00_15632 = BgL_rz00_15636;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15631);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15628,
																BgL_sz00_13599);
															return BgL_____rz00_15632;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15615,
												(int) (BgL_nbargsz00_13597)))
											{	/* Eval/evaluate_comp.scm 788 */
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_auxz00_19340;
													obj_t BgL_tmpz00_19338;

													BgL_auxz00_19340 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1156z00_13595))->BgL_locz00);
													BgL_tmpz00_19338 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19338,
														BgL_auxz00_19340);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13599, BgL_fz00_15615, BgL_argsz00_13598,
													BgL_bpz00_15614, BINT(BgL_nbargsz00_13597));
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13595))->
														BgL_locz00), BgL_symbzd2funzd2_13596,
													(int) (BgL_nbargsz00_13597),
													PROCEDURE_ARITY(BgL_fz00_15615));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1847> */
	obj_t BGl_z62zc3anonymousza31847ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13600, obj_t BgL_sz00_13606)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 788 */
			{	/* Eval/evaluate_comp.scm 788 */
				obj_t BgL_fz00_13601;
				BgL_ev_appz00_bglt BgL_i1156z00_13602;
				obj_t BgL_symbzd2funzd2_13603;
				long BgL_nbargsz00_13604;
				obj_t BgL_argsz00_13605;

				BgL_fz00_13601 = PROCEDURE_REF(BgL_envz00_13600, (int) (((long) 0)));
				BgL_i1156z00_13602 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13600, (int) (((long) 1))));
				BgL_symbzd2funzd2_13603 =
					PROCEDURE_REF(BgL_envz00_13600, (int) (((long) 2)));
				BgL_nbargsz00_13604 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13600, (int) (((long) 3))));
				BgL_argsz00_13605 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13600, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 788 */
					obj_t BgL_bpz00_15638;

					BgL_bpz00_15638 = VECTOR_REF(((obj_t) BgL_sz00_13606), ((long) 0));
					{	/* Eval/evaluate_comp.scm 788 */
						obj_t BgL_fz00_15639;

						BgL_fz00_15639 =
							PROCEDURE_ENTRY(BgL_fz00_13601) (BgL_fz00_13601, BgL_sz00_13606,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15639))
							{	/* Eval/evaluate_comp.scm 788 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 788 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13602))->
										BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15639);
							}
						{	/* Eval/evaluate_comp.scm 788 */
							obj_t BgL_ufz00_15640;

							{	/* Eval/evaluate_comp.scm 788 */
								obj_t BgL_tmpz00_19372;

								BgL_tmpz00_19372 = ((obj_t) BgL_fz00_15639);
								BgL_ufz00_15640 = PROCEDURE_ATTR(BgL_tmpz00_19372);
							}
							{	/* Eval/evaluate_comp.scm 788 */
								bool_t BgL_testz00_19375;

								if (STRUCTP(BgL_ufz00_15640))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19375 =
											(STRUCT_KEY(BgL_ufz00_15640) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19375 = ((bool_t) 0);
									}
								if (BgL_testz00_19375)
									{	/* Eval/evaluate_comp.scm 788 */
										obj_t BgL_arityz00_15641;
										obj_t BgL_runz00_15642;
										obj_t BgL_sfz00_15643;

										BgL_arityz00_15641 =
											STRUCT_REF(BgL_ufz00_15640, (int) (((long) 0)));
										BgL_runz00_15642 =
											STRUCT_REF(BgL_ufz00_15640, (int) (((long) 1)));
										BgL_sfz00_15643 =
											STRUCT_REF(BgL_ufz00_15640, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15641) == BgL_nbargsz00_13604))
											{
												obj_t BgL_lz00_15645;
												obj_t BgL_spz00_15646;

												{	/* Eval/evaluate_comp.scm 703 */
													bool_t BgL_tmpz00_19389;

													BgL_lz00_15645 = BgL_argsz00_13605;
													BgL_spz00_15646 = BgL_bpz00_15638;
												BgL_recz00_15644:
													if (NULLP(BgL_lz00_15645))
														{	/* Eval/evaluate_comp.scm 704 */
															BgL_tmpz00_19389 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 704 */
															{	/* Eval/evaluate_comp.scm 705 */
																obj_t BgL_arg1731z00_15647;

																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_fun1732z00_15648;

																	BgL_fun1732z00_15648 =
																		CAR(((obj_t) BgL_lz00_15645));
																	BgL_arg1731z00_15647 =
																		PROCEDURE_ENTRY(BgL_fun1732z00_15648)
																		(BgL_fun1732z00_15648, BgL_sz00_13606,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 705 */
																	long BgL_kz00_15649;

																	BgL_kz00_15649 = (long) CINT(BgL_spz00_15646);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13606), BgL_kz00_15649,
																		BgL_arg1731z00_15647);
															}}
															{	/* Eval/evaluate_comp.scm 706 */
																obj_t BgL_arg1733z00_15650;
																long BgL_arg1734z00_15651;

																BgL_arg1733z00_15650 =
																	CDR(((obj_t) BgL_lz00_15645));
																BgL_arg1734z00_15651 =
																	((long) CINT(BgL_spz00_15646) + ((long) 1));
																{
																	obj_t BgL_spz00_19406;
																	obj_t BgL_lz00_19405;

																	BgL_lz00_19405 = BgL_arg1733z00_15650;
																	BgL_spz00_19406 = BINT(BgL_arg1734z00_15651);
																	BgL_spz00_15646 = BgL_spz00_19406;
																	BgL_lz00_15645 = BgL_lz00_19405;
																	goto BgL_recz00_15644;
																}
															}
														}
													BBOOL(BgL_tmpz00_19389);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												bool_t BgL_testz00_19409;

												if (((long) CINT(BgL_arityz00_15641) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_testz00_19409 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BgL_testz00_19409 =
															(
															(long) CINT(BgL_arityz00_15641) <
															(((long) -1) - BgL_nbargsz00_13604));
													}
												if (BgL_testz00_19409)
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1156z00_13602))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15640, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13604),
															CINT(BgL_arityz00_15641));
													}
												else
													{	/* Eval/evaluate_comp.scm 788 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15641, BgL_sz00_13606,
															BgL_argsz00_13605, BgL_bpz00_15638);
													}
											}
										{	/* Eval/evaluate_comp.scm 788 */
											obj_t BgL_z12denvz12_15652;

											BgL_z12denvz12_15652 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15638) +
														(long) CINT(BgL_sfz00_15643)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13606))))
												{	/* Eval/evaluate_comp.scm 788 */
													return BgL_runz00_15642;
												}
											else
												{	/* Eval/evaluate_comp.scm 788 */
													obj_t BgL_nsz00_15653;

													BgL_nsz00_15653 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 788 */
														long BgL_arg1860z00_15654;

														BgL_arg1860z00_15654 =
															(
															(long) CINT(BgL_bpz00_15638) +
															BgL_nbargsz00_13604);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15653, ((long) 2), BgL_sz00_13606,
															BgL_bpz00_15638, BINT(BgL_arg1860z00_15654));
													}
													VECTOR_SET(BgL_nsz00_15653, ((long) 1),
														BgL_sz00_13606);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15652,
														BgL_nsz00_15653);
													{	/* Eval/evaluate_comp.scm 788 */
														obj_t BgL_ez00_15655;

														BgL_ez00_15655 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15655, BgL_sz00_13606);
														{	/* Eval/evaluate_comp.scm 788 */
															obj_t BgL_____rz00_15656;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15657;

																BgL_savedzd2bpzd2_15657 =
																	VECTOR_REF(BgL_nsz00_15653, ((long) 0));
																VECTOR_SET(BgL_nsz00_15653, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15659;

																	BgL_fz00_15659 = BgL_runz00_15642;
																BgL_recz00_15658:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15660;

																		BgL_rz00_15660 =
																			PROCEDURE_ENTRY(BgL_fz00_15659)
																			(BgL_fz00_15659, BgL_nsz00_15653, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_19447;

																			if (PROCEDUREP(BgL_rz00_15660))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15661;

																					BgL_arg1696z00_15661 =
																						PROCEDURE_ATTR(BgL_rz00_15660);
																					if (STRUCTP(BgL_arg1696z00_15661))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_19447 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15661) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_19447 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_19447 = ((bool_t) 0);
																				}
																			if (BgL_testz00_19447)
																				{
																					obj_t BgL_fz00_19455;

																					BgL_fz00_19455 = BgL_rz00_15660;
																					BgL_fz00_15659 = BgL_fz00_19455;
																					goto BgL_recz00_15658;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15653,
																						((long) 0),
																						BgL_savedzd2bpzd2_15657);
																					BgL_____rz00_15656 = BgL_rz00_15660;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15655);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15652,
																BgL_sz00_13606);
															return BgL_____rz00_15656;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 788 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15639,
												(int) (BgL_nbargsz00_13604)))
											{	/* Eval/evaluate_comp.scm 788 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13606, BgL_fz00_15639, BgL_argsz00_13605,
													BgL_bpz00_15638, BINT(BgL_nbargsz00_13604));
											}
										else
											{	/* Eval/evaluate_comp.scm 788 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13602))->
														BgL_locz00), BgL_symbzd2funzd2_13603,
													(int) (BgL_nbargsz00_13604),
													PROCEDURE_ARITY(BgL_fz00_15639));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1870> */
	obj_t BGl_z62zc3anonymousza31870ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13607, obj_t BgL_sz00_13614)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 774 */
			{	/* Eval/evaluate_comp.scm 774 */
				obj_t BgL_fz00_13608;
				BgL_ev_appz00_bglt BgL_i1156z00_13609;
				obj_t BgL_symbzd2funzd2_13610;
				long BgL_nbargsz00_13611;
				obj_t BgL_argsz00_13612;
				long BgL_siza7eza7_13613;

				BgL_fz00_13608 = PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 0)));
				BgL_i1156z00_13609 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 1))));
				BgL_symbzd2funzd2_13610 =
					PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 2)));
				BgL_nbargsz00_13611 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 3))));
				BgL_argsz00_13612 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 4))));
				BgL_siza7eza7_13613 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13607, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 774 */
					obj_t BgL_bpz00_15662;

					BgL_bpz00_15662 = VECTOR_REF(((obj_t) BgL_sz00_13614), ((long) 0));
					{	/* Eval/evaluate_comp.scm 774 */
						obj_t BgL_fz00_15663;

						BgL_fz00_15663 =
							PROCEDURE_ENTRY(BgL_fz00_13608) (BgL_fz00_13608, BgL_sz00_13614,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15663))
							{	/* Eval/evaluate_comp.scm 774 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13609))->
										BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15663);
							}
						{	/* Eval/evaluate_comp.scm 774 */
							obj_t BgL_ufz00_15664;

							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_tmpz00_19494;

								BgL_tmpz00_19494 = ((obj_t) BgL_fz00_15663);
								BgL_ufz00_15664 = PROCEDURE_ATTR(BgL_tmpz00_19494);
							}
							{	/* Eval/evaluate_comp.scm 774 */
								bool_t BgL_testz00_19497;

								if (STRUCTP(BgL_ufz00_15664))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19497 =
											(STRUCT_KEY(BgL_ufz00_15664) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19497 = ((bool_t) 0);
									}
								if (BgL_testz00_19497)
									{	/* Eval/evaluate_comp.scm 774 */
										obj_t BgL_arityz00_15665;
										obj_t BgL_runz00_15666;
										obj_t BgL_sfz00_15667;

										BgL_arityz00_15665 =
											STRUCT_REF(BgL_ufz00_15664, (int) (((long) 0)));
										BgL_runz00_15666 =
											STRUCT_REF(BgL_ufz00_15664, (int) (((long) 1)));
										BgL_sfz00_15667 =
											STRUCT_REF(BgL_ufz00_15664, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 774 */
											long BgL_spz00_15668;

											BgL_spz00_15668 =
												((long) CINT(BgL_bpz00_15662) + BgL_siza7eza7_13613);
											if (
												((long) CINT(BgL_arityz00_15665) ==
													BgL_nbargsz00_13611))
												{
													obj_t BgL_lz00_15670;
													long BgL_spz00_15671;

													{	/* Eval/evaluate_comp.scm 703 */
														bool_t BgL_tmpz00_19513;

														BgL_lz00_15670 = BgL_argsz00_13612;
														BgL_spz00_15671 = BgL_spz00_15668;
													BgL_recz00_15669:
														if (NULLP(BgL_lz00_15670))
															{	/* Eval/evaluate_comp.scm 704 */
																BgL_tmpz00_19513 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1731z00_15672;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1732z00_15673;

																		BgL_fun1732z00_15673 =
																			CAR(((obj_t) BgL_lz00_15670));
																		BgL_arg1731z00_15672 =
																			PROCEDURE_ENTRY(BgL_fun1732z00_15673)
																			(BgL_fun1732z00_15673, BgL_sz00_13614,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13614), BgL_spz00_15671,
																		BgL_arg1731z00_15672);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1733z00_15674;
																	long BgL_arg1734z00_15675;

																	BgL_arg1733z00_15674 =
																		CDR(((obj_t) BgL_lz00_15670));
																	BgL_arg1734z00_15675 =
																		(BgL_spz00_15671 + ((long) 1));
																	{
																		long BgL_spz00_19528;
																		obj_t BgL_lz00_19527;

																		BgL_lz00_19527 = BgL_arg1733z00_15674;
																		BgL_spz00_19528 = BgL_arg1734z00_15675;
																		BgL_spz00_15671 = BgL_spz00_19528;
																		BgL_lz00_15670 = BgL_lz00_19527;
																		goto BgL_recz00_15669;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19513);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 774 */
													bool_t BgL_testz00_19530;

													if (((long) CINT(BgL_arityz00_15665) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_testz00_19530 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_testz00_19530 =
																(
																(long) CINT(BgL_arityz00_15665) <
																(((long) -1) - BgL_nbargsz00_13611));
														}
													if (BgL_testz00_19530)
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1156z00_13609))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15664, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13611),
																CINT(BgL_arityz00_15665));
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15665, BgL_sz00_13614,
																BgL_argsz00_13612, BINT(BgL_spz00_15668));
														}
												}
											{	/* Eval/evaluate_comp.scm 774 */
												obj_t BgL_z12denvz12_15676;

												BgL_z12denvz12_15676 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 774 */
													obj_t BgL_tmpz00_19546;

													BgL_tmpz00_19546 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1156z00_13609))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15676,
														BgL_tmpz00_19546);
												}
												if (
													((BgL_spz00_15668 +
															(long) CINT(BgL_sfz00_15667)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13614))))
													{	/* Eval/evaluate_comp.scm 774 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15666, BgL_sz00_13614,
															BINT(BgL_spz00_15668));
													}
												else
													{	/* Eval/evaluate_comp.scm 774 */
														obj_t BgL_nsz00_15677;

														BgL_nsz00_15677 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 774 */
															long BgL_arg1883z00_15678;

															BgL_arg1883z00_15678 =
																(BgL_spz00_15668 + BgL_nbargsz00_13611);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15677, ((long) 2), BgL_sz00_13614,
																BINT(BgL_spz00_15668),
																BINT(BgL_arg1883z00_15678));
														}
														VECTOR_SET(BgL_nsz00_15677, ((long) 1),
															BgL_sz00_13614);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15676,
															BgL_nsz00_15677);
														{	/* Eval/evaluate_comp.scm 774 */
															obj_t BgL_ez00_15679;

															BgL_ez00_15679 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15679, BgL_sz00_13614);
															{	/* Eval/evaluate_comp.scm 774 */
																obj_t BgL_____rz00_15680;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15681;

																	BgL_savedzd2bpzd2_15681 =
																		VECTOR_REF(BgL_nsz00_15677, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15677, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15683;

																		BgL_fz00_15683 = BgL_runz00_15666;
																	BgL_recz00_15682:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15684;

																			BgL_rz00_15684 =
																				PROCEDURE_ENTRY(BgL_fz00_15683)
																				(BgL_fz00_15683, BgL_nsz00_15677, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_19573;

																				if (PROCEDUREP(BgL_rz00_15684))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15685;

																						BgL_arg1696z00_15685 =
																							PROCEDURE_ATTR(BgL_rz00_15684);
																						if (STRUCTP(BgL_arg1696z00_15685))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19573 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15685) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19573 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_19573 = ((bool_t) 0);
																					}
																				if (BgL_testz00_19573)
																					{
																						obj_t BgL_fz00_19581;

																						BgL_fz00_19581 = BgL_rz00_15684;
																						BgL_fz00_15683 = BgL_fz00_19581;
																						goto BgL_recz00_15682;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15677,
																							((long) 0),
																							BgL_savedzd2bpzd2_15681);
																						BgL_____rz00_15680 = BgL_rz00_15684;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15679);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15676,
																	BgL_sz00_13614);
																return BgL_____rz00_15680;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 774 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15663,
												(int) (BgL_nbargsz00_13611)))
											{	/* Eval/evaluate_comp.scm 774 */
												{	/* Eval/evaluate_comp.scm 774 */
													obj_t BgL_auxz00_19590;
													obj_t BgL_tmpz00_19588;

													BgL_auxz00_19590 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1156z00_13609))->BgL_locz00);
													BgL_tmpz00_19588 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19588,
														BgL_auxz00_19590);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13614, BgL_fz00_15663, BgL_argsz00_13612,
													BgL_bpz00_15662, BINT(BgL_siza7eza7_13613));
											}
										else
											{	/* Eval/evaluate_comp.scm 774 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13609))->
														BgL_locz00), BgL_symbzd2funzd2_13610,
													(int) (BgL_nbargsz00_13611),
													PROCEDURE_ARITY(BgL_fz00_15663));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1892> */
	obj_t BGl_z62zc3anonymousza31892ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13615, obj_t BgL_sz00_13622)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 774 */
			{	/* Eval/evaluate_comp.scm 774 */
				obj_t BgL_fz00_13616;
				BgL_ev_appz00_bglt BgL_i1156z00_13617;
				obj_t BgL_symbzd2funzd2_13618;
				long BgL_nbargsz00_13619;
				obj_t BgL_argsz00_13620;
				long BgL_siza7eza7_13621;

				BgL_fz00_13616 = PROCEDURE_REF(BgL_envz00_13615, (int) (((long) 0)));
				BgL_i1156z00_13617 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13615, (int) (((long) 1))));
				BgL_symbzd2funzd2_13618 =
					PROCEDURE_REF(BgL_envz00_13615, (int) (((long) 2)));
				BgL_nbargsz00_13619 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13615, (int) (((long) 3))));
				BgL_argsz00_13620 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13615, (int) (((long) 4))));
				BgL_siza7eza7_13621 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13615, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 774 */
					obj_t BgL_bpz00_15686;

					BgL_bpz00_15686 = VECTOR_REF(((obj_t) BgL_sz00_13622), ((long) 0));
					{	/* Eval/evaluate_comp.scm 774 */
						obj_t BgL_fz00_15687;

						BgL_fz00_15687 =
							PROCEDURE_ENTRY(BgL_fz00_13616) (BgL_fz00_13616, BgL_sz00_13622,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15687))
							{	/* Eval/evaluate_comp.scm 774 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 774 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13617))->
										BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15687);
							}
						{	/* Eval/evaluate_comp.scm 774 */
							obj_t BgL_ufz00_15688;

							{	/* Eval/evaluate_comp.scm 774 */
								obj_t BgL_tmpz00_19625;

								BgL_tmpz00_19625 = ((obj_t) BgL_fz00_15687);
								BgL_ufz00_15688 = PROCEDURE_ATTR(BgL_tmpz00_19625);
							}
							{	/* Eval/evaluate_comp.scm 774 */
								bool_t BgL_testz00_19628;

								if (STRUCTP(BgL_ufz00_15688))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19628 =
											(STRUCT_KEY(BgL_ufz00_15688) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19628 = ((bool_t) 0);
									}
								if (BgL_testz00_19628)
									{	/* Eval/evaluate_comp.scm 774 */
										obj_t BgL_arityz00_15689;
										obj_t BgL_runz00_15690;
										obj_t BgL_sfz00_15691;

										BgL_arityz00_15689 =
											STRUCT_REF(BgL_ufz00_15688, (int) (((long) 0)));
										BgL_runz00_15690 =
											STRUCT_REF(BgL_ufz00_15688, (int) (((long) 1)));
										BgL_sfz00_15691 =
											STRUCT_REF(BgL_ufz00_15688, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 774 */
											long BgL_spz00_15692;

											BgL_spz00_15692 =
												((long) CINT(BgL_bpz00_15686) + BgL_siza7eza7_13621);
											if (
												((long) CINT(BgL_arityz00_15689) ==
													BgL_nbargsz00_13619))
												{
													obj_t BgL_lz00_15694;
													long BgL_spz00_15695;

													{	/* Eval/evaluate_comp.scm 703 */
														bool_t BgL_tmpz00_19644;

														BgL_lz00_15694 = BgL_argsz00_13620;
														BgL_spz00_15695 = BgL_spz00_15692;
													BgL_recz00_15693:
														if (NULLP(BgL_lz00_15694))
															{	/* Eval/evaluate_comp.scm 704 */
																BgL_tmpz00_19644 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 704 */
																{	/* Eval/evaluate_comp.scm 705 */
																	obj_t BgL_arg1731z00_15696;

																	{	/* Eval/evaluate_comp.scm 705 */
																		obj_t BgL_fun1732z00_15697;

																		BgL_fun1732z00_15697 =
																			CAR(((obj_t) BgL_lz00_15694));
																		BgL_arg1731z00_15696 =
																			PROCEDURE_ENTRY(BgL_fun1732z00_15697)
																			(BgL_fun1732z00_15697, BgL_sz00_13622,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13622), BgL_spz00_15695,
																		BgL_arg1731z00_15696);
																}
																{	/* Eval/evaluate_comp.scm 706 */
																	obj_t BgL_arg1733z00_15698;
																	long BgL_arg1734z00_15699;

																	BgL_arg1733z00_15698 =
																		CDR(((obj_t) BgL_lz00_15694));
																	BgL_arg1734z00_15699 =
																		(BgL_spz00_15695 + ((long) 1));
																	{
																		long BgL_spz00_19659;
																		obj_t BgL_lz00_19658;

																		BgL_lz00_19658 = BgL_arg1733z00_15698;
																		BgL_spz00_19659 = BgL_arg1734z00_15699;
																		BgL_spz00_15695 = BgL_spz00_19659;
																		BgL_lz00_15694 = BgL_lz00_19658;
																		goto BgL_recz00_15693;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19644);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 774 */
													bool_t BgL_testz00_19661;

													if (((long) CINT(BgL_arityz00_15689) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_testz00_19661 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BgL_testz00_19661 =
																(
																(long) CINT(BgL_arityz00_15689) <
																(((long) -1) - BgL_nbargsz00_13619));
														}
													if (BgL_testz00_19661)
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1156z00_13617))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15688, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13619),
																CINT(BgL_arityz00_15689));
														}
													else
														{	/* Eval/evaluate_comp.scm 774 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15689, BgL_sz00_13622,
																BgL_argsz00_13620, BINT(BgL_spz00_15692));
														}
												}
											{	/* Eval/evaluate_comp.scm 774 */
												obj_t BgL_z12denvz12_15700;

												BgL_z12denvz12_15700 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15692 +
															(long) CINT(BgL_sfz00_15691)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13622))))
													{	/* Eval/evaluate_comp.scm 774 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15690, BgL_sz00_13622,
															BINT(BgL_spz00_15692));
													}
												else
													{	/* Eval/evaluate_comp.scm 774 */
														obj_t BgL_nsz00_15701;

														BgL_nsz00_15701 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 774 */
															long BgL_arg1904z00_15702;

															BgL_arg1904z00_15702 =
																(BgL_spz00_15692 + BgL_nbargsz00_13619);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15701, ((long) 2), BgL_sz00_13622,
																BINT(BgL_spz00_15692),
																BINT(BgL_arg1904z00_15702));
														}
														VECTOR_SET(BgL_nsz00_15701, ((long) 1),
															BgL_sz00_13622);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15700,
															BgL_nsz00_15701);
														{	/* Eval/evaluate_comp.scm 774 */
															obj_t BgL_ez00_15703;

															BgL_ez00_15703 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15703, BgL_sz00_13622);
															{	/* Eval/evaluate_comp.scm 774 */
																obj_t BgL_____rz00_15704;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15705;

																	BgL_savedzd2bpzd2_15705 =
																		VECTOR_REF(BgL_nsz00_15701, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15701, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15707;

																		BgL_fz00_15707 = BgL_runz00_15690;
																	BgL_recz00_15706:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15708;

																			BgL_rz00_15708 =
																				PROCEDURE_ENTRY(BgL_fz00_15707)
																				(BgL_fz00_15707, BgL_nsz00_15701, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_19701;

																				if (PROCEDUREP(BgL_rz00_15708))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15709;

																						BgL_arg1696z00_15709 =
																							PROCEDURE_ATTR(BgL_rz00_15708);
																						if (STRUCTP(BgL_arg1696z00_15709))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19701 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15709) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_19701 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_19701 = ((bool_t) 0);
																					}
																				if (BgL_testz00_19701)
																					{
																						obj_t BgL_fz00_19709;

																						BgL_fz00_19709 = BgL_rz00_15708;
																						BgL_fz00_15707 = BgL_fz00_19709;
																						goto BgL_recz00_15706;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15701,
																							((long) 0),
																							BgL_savedzd2bpzd2_15705);
																						BgL_____rz00_15704 = BgL_rz00_15708;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15703);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15700,
																	BgL_sz00_13622);
																return BgL_____rz00_15704;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 774 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15687,
												(int) (BgL_nbargsz00_13619)))
											{	/* Eval/evaluate_comp.scm 774 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13622, BgL_fz00_15687, BgL_argsz00_13620,
													BgL_bpz00_15686, BINT(BgL_siza7eza7_13621));
											}
										else
											{	/* Eval/evaluate_comp.scm 774 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1156z00_13617))->
														BgL_locz00), BgL_symbzd2funzd2_13618,
													(int) (BgL_nbargsz00_13619),
													PROCEDURE_ARITY(BgL_fz00_15687));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_1966;

				BgL_cfunz00_1966 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1966))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_19725;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg1918z00_1980;

							BgL_arg1918z00_1980 = bgl_debug();
							BgL_testz00_19725 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1918z00_1980),
								BINT(((long) 0)));
						}
						if (BgL_testz00_19725)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31915ze3z83_13623;

								BgL_zc3anonymousza31915ze3z83_13623 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31915ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza31915ze3z83_13623,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3anonymousza31915ze3z83_13623,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3anonymousza31915ze3z83_13623,
									(int) (((long) 2)), BgL_cfunz00_1966);
								return BgL_zc3anonymousza31915ze3z83_13623;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31917ze3z83_13624;

								BgL_zc3anonymousza31917ze3z83_13624 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31917ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3anonymousza31917ze3z83_13624,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3anonymousza31917ze3z83_13624,
									(int) (((long) 1)), BgL_cfunz00_1966);
								return BgL_zc3anonymousza31917ze3z83_13624;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_19750;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1948z00_2044;

									BgL_arg1948z00_2044 = bgl_debug();
									BgL_testz00_19750 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1948z00_2044),
										BINT(((long) 0)));
								}
								if (BgL_testz00_19750)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31921ze3z83_13625;

										BgL_zc3anonymousza31921ze3z83_13625 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31921ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31921ze3z83_13625,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31921ze3z83_13625,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31921ze3z83_13625,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31921ze3z83_13625,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31921ze3z83_13625;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31935ze3z83_13626;

										BgL_zc3anonymousza31935ze3z83_13626 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31935ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31935ze3z83_13626,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31935ze3z83_13626,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31935ze3z83_13626,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31935ze3z83_13626,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31935ze3z83_13626;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_19779;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg1980z00_2108;

									BgL_arg1980z00_2108 = bgl_debug();
									BgL_testz00_19779 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1980z00_2108),
										BINT(((long) 0)));
								}
								if (BgL_testz00_19779)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31952ze3z83_13627;

										BgL_zc3anonymousza31952ze3z83_13627 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_13627,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_13627,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_13627,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31952ze3z83_13627,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31952ze3z83_13627;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31966ze3z83_13628;

										BgL_zc3anonymousza31966ze3z83_13628 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31966ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3anonymousza31966ze3z83_13628,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3anonymousza31966ze3z83_13628,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3anonymousza31966ze3z83_13628,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3anonymousza31966ze3z83_13628,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3anonymousza31966ze3z83_13628;
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1915> */
	obj_t BGl_z62zc3anonymousza31915ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13629, obj_t BgL_sz00_13633)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				long BgL_siza7eza7_13630;
				obj_t BgL_locz00_13631;
				obj_t BgL_cfunz00_13632;

				BgL_siza7eza7_13630 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13629, (int) (((long) 0))));
				BgL_locz00_13631 = PROCEDURE_REF(BgL_envz00_13629, (int) (((long) 1)));
				BgL_cfunz00_13632 = PROCEDURE_REF(BgL_envz00_13629, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15710;

					BgL_bpz00_15710 = VECTOR_REF(((obj_t) BgL_sz00_13633), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */

						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15711;

							BgL_nbpz00_15711 =
								((long) CINT(BgL_bpz00_15710) + BgL_siza7eza7_13630);
							VECTOR_SET(
								((obj_t) BgL_sz00_13633), ((long) 0), BINT(BgL_nbpz00_15711));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_19822;

								BgL_tmpz00_19822 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19822, BgL_locz00_13631);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15712;

								BgL_rz00_15712 =
									PROCEDURE_ENTRY(BgL_cfunz00_13632) (BgL_cfunz00_13632, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13633), ((long) 0), BgL_bpz00_15710);
								return BgL_rz00_15712;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1917> */
	obj_t BGl_z62zc3anonymousza31917ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13634, obj_t BgL_sz00_13637)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				long BgL_siza7eza7_13635;
				obj_t BgL_cfunz00_13636;

				BgL_siza7eza7_13635 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13634, (int) (((long) 0))));
				BgL_cfunz00_13636 = PROCEDURE_REF(BgL_envz00_13634, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15713;

					BgL_bpz00_15713 = VECTOR_REF(((obj_t) BgL_sz00_13637), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */

						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15714;

							BgL_nbpz00_15714 =
								((long) CINT(BgL_bpz00_15713) + BgL_siza7eza7_13635);
							VECTOR_SET(
								((obj_t) BgL_sz00_13637), ((long) 0), BINT(BgL_nbpz00_15714));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15715;

								BgL_rz00_15715 =
									PROCEDURE_ENTRY(BgL_cfunz00_13636) (BgL_cfunz00_13636, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13637), ((long) 0), BgL_bpz00_15713);
								return BgL_rz00_15715;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1921> */
	obj_t BGl_z62zc3anonymousza31921ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13638, obj_t BgL_sz00_13643)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13639;
				obj_t BgL_locz00_13640;
				obj_t BgL_symbzd2funzd2_13641;
				long BgL_siza7eza7_13642;

				BgL_funz00_13639 = PROCEDURE_REF(BgL_envz00_13638, (int) (((long) 0)));
				BgL_locz00_13640 = PROCEDURE_REF(BgL_envz00_13638, (int) (((long) 1)));
				BgL_symbzd2funzd2_13641 =
					PROCEDURE_REF(BgL_envz00_13638, (int) (((long) 2)));
				BgL_siza7eza7_13642 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13638, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15716;

					BgL_bpz00_15716 = VECTOR_REF(((obj_t) BgL_sz00_13643), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15717;

						BgL_fz00_15717 =
							PROCEDURE_ENTRY(BgL_funz00_13639) (BgL_funz00_13639,
							BgL_sz00_13643, BEOA);
						if (PROCEDUREP(BgL_fz00_15717))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13640,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15717);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15718;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_19865;

								BgL_tmpz00_19865 = ((obj_t) BgL_fz00_15717);
								BgL_ufz00_15718 = PROCEDURE_ATTR(BgL_tmpz00_19865);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_19868;

								if (STRUCTP(BgL_ufz00_15718))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19868 =
											(STRUCT_KEY(BgL_ufz00_15718) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19868 = ((bool_t) 0);
									}
								if (BgL_testz00_19868)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15719;
										obj_t BgL_runz00_15720;
										obj_t BgL_sfz00_15721;

										BgL_arityz00_15719 =
											STRUCT_REF(BgL_ufz00_15718, (int) (((long) 0)));
										BgL_runz00_15720 =
											STRUCT_REF(BgL_ufz00_15718, (int) (((long) 1)));
										BgL_sfz00_15721 =
											STRUCT_REF(BgL_ufz00_15718, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15719) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 889 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15719))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15719))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1926z00_15722;
																	obj_t BgL_arg1927z00_15723;

																	BgL_arg1926z00_15722 =
																		((long) CINT(BgL_bpz00_15716) + ((long) 0));
																	BgL_arg1927z00_15723 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13643),
																		BgL_arg1926z00_15722, BgL_arg1927z00_15723);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13640, STRUCT_REF(BgL_ufz00_15718,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15719));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13640, STRUCT_REF(BgL_ufz00_15718,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15719));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15724;

											BgL_z12denvz12_15724 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15724,
												BgL_locz00_13640);
											if ((((long) CINT(BgL_bpz00_15716) +
														(long) CINT(BgL_sfz00_15721)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13643))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15720;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15725;

													BgL_nsz00_15725 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg1931z00_15726;

														BgL_arg1931z00_15726 =
															((long) CINT(BgL_bpz00_15716) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15725, ((long) 2), BgL_sz00_13643,
															BgL_bpz00_15716, BINT(BgL_arg1931z00_15726));
													}
													VECTOR_SET(BgL_nsz00_15725, ((long) 1),
														BgL_sz00_13643);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15724,
														BgL_nsz00_15725);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15727;

														BgL_ez00_15727 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15727, BgL_sz00_13643);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15728;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15729;

																BgL_savedzd2bpzd2_15729 =
																	VECTOR_REF(BgL_nsz00_15725, ((long) 0));
																VECTOR_SET(BgL_nsz00_15725, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15731;

																	BgL_fz00_15731 = BgL_runz00_15720;
																BgL_recz00_15730:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15732;

																		BgL_rz00_15732 =
																			PROCEDURE_ENTRY(BgL_fz00_15731)
																			(BgL_fz00_15731, BgL_nsz00_15725, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_19925;

																			if (PROCEDUREP(BgL_rz00_15732))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15733;

																					BgL_arg1696z00_15733 =
																						PROCEDURE_ATTR(BgL_rz00_15732);
																					if (STRUCTP(BgL_arg1696z00_15733))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_19925 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15733) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_19925 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_19925 = ((bool_t) 0);
																				}
																			if (BgL_testz00_19925)
																				{
																					obj_t BgL_fz00_19933;

																					BgL_fz00_19933 = BgL_rz00_15732;
																					BgL_fz00_15731 = BgL_fz00_19933;
																					goto BgL_recz00_15730;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15725,
																						((long) 0),
																						BgL_savedzd2bpzd2_15729);
																					BgL_____rz00_15728 = BgL_rz00_15732;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15727);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15724,
																BgL_sz00_13643);
															return BgL_____rz00_15728;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15717,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15734;

												BgL_nbpz00_15734 =
													((long) CINT(BgL_bpz00_15716) + BgL_siza7eza7_13642);
												VECTOR_SET(
													((obj_t) BgL_sz00_13643), ((long) 0),
													BINT(BgL_nbpz00_15734));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_19945;

													BgL_tmpz00_19945 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19945,
														BgL_locz00_13640);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15735;

													BgL_rz00_15735 =
														PROCEDURE_ENTRY(BgL_fz00_15717) (BgL_fz00_15717,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13643), ((long) 0),
														BgL_bpz00_15716);
													return BgL_rz00_15735;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13640,
													BgL_symbzd2funzd2_13641, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15717));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1935> */
	obj_t BGl_z62zc3anonymousza31935ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13644, obj_t BgL_sz00_13649)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13645;
				obj_t BgL_locz00_13646;
				obj_t BgL_symbzd2funzd2_13647;
				long BgL_siza7eza7_13648;

				BgL_funz00_13645 = PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 0)));
				BgL_locz00_13646 = PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 1)));
				BgL_symbzd2funzd2_13647 =
					PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 2)));
				BgL_siza7eza7_13648 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13644, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15736;

					BgL_bpz00_15736 = VECTOR_REF(((obj_t) BgL_sz00_13649), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15737;

						BgL_fz00_15737 =
							PROCEDURE_ENTRY(BgL_funz00_13645) (BgL_funz00_13645,
							BgL_sz00_13649, BEOA);
						if (PROCEDUREP(BgL_fz00_15737))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13646,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15737);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15738;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_19974;

								BgL_tmpz00_19974 = ((obj_t) BgL_fz00_15737);
								BgL_ufz00_15738 = PROCEDURE_ATTR(BgL_tmpz00_19974);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_19977;

								if (STRUCTP(BgL_ufz00_15738))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19977 =
											(STRUCT_KEY(BgL_ufz00_15738) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_19977 = ((bool_t) 0);
									}
								if (BgL_testz00_19977)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15739;
										obj_t BgL_runz00_15740;
										obj_t BgL_sfz00_15741;

										BgL_arityz00_15739 =
											STRUCT_REF(BgL_ufz00_15738, (int) (((long) 0)));
										BgL_runz00_15740 =
											STRUCT_REF(BgL_ufz00_15738, (int) (((long) 1)));
										BgL_sfz00_15741 =
											STRUCT_REF(BgL_ufz00_15738, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15739) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 889 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15739))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15739))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1940z00_15742;
																	obj_t BgL_arg1941z00_15743;

																	BgL_arg1940z00_15742 =
																		((long) CINT(BgL_bpz00_15736) + ((long) 0));
																	BgL_arg1941z00_15743 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13649),
																		BgL_arg1940z00_15742, BgL_arg1941z00_15743);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13646, STRUCT_REF(BgL_ufz00_15738,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15739));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13646, STRUCT_REF(BgL_ufz00_15738,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15739));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15744;

											BgL_z12denvz12_15744 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15736) +
														(long) CINT(BgL_sfz00_15741)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13649))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15740;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15745;

													BgL_nsz00_15745 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg1945z00_15746;

														BgL_arg1945z00_15746 =
															((long) CINT(BgL_bpz00_15736) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15745, ((long) 2), BgL_sz00_13649,
															BgL_bpz00_15736, BINT(BgL_arg1945z00_15746));
													}
													VECTOR_SET(BgL_nsz00_15745, ((long) 1),
														BgL_sz00_13649);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15744,
														BgL_nsz00_15745);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15747;

														BgL_ez00_15747 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15747, BgL_sz00_13649);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15748;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15749;

																BgL_savedzd2bpzd2_15749 =
																	VECTOR_REF(BgL_nsz00_15745, ((long) 0));
																VECTOR_SET(BgL_nsz00_15745, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15751;

																	BgL_fz00_15751 = BgL_runz00_15740;
																BgL_recz00_15750:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15752;

																		BgL_rz00_15752 =
																			PROCEDURE_ENTRY(BgL_fz00_15751)
																			(BgL_fz00_15751, BgL_nsz00_15745, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_20033;

																			if (PROCEDUREP(BgL_rz00_15752))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15753;

																					BgL_arg1696z00_15753 =
																						PROCEDURE_ATTR(BgL_rz00_15752);
																					if (STRUCTP(BgL_arg1696z00_15753))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_20033 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15753) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_20033 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_20033 = ((bool_t) 0);
																				}
																			if (BgL_testz00_20033)
																				{
																					obj_t BgL_fz00_20041;

																					BgL_fz00_20041 = BgL_rz00_15752;
																					BgL_fz00_15751 = BgL_fz00_20041;
																					goto BgL_recz00_15750;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15745,
																						((long) 0),
																						BgL_savedzd2bpzd2_15749);
																					BgL_____rz00_15748 = BgL_rz00_15752;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15747);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15744,
																BgL_sz00_13649);
															return BgL_____rz00_15748;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15737,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15754;

												BgL_nbpz00_15754 =
													((long) CINT(BgL_bpz00_15736) + BgL_siza7eza7_13648);
												VECTOR_SET(
													((obj_t) BgL_sz00_13649), ((long) 0),
													BINT(BgL_nbpz00_15754));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15755;

													BgL_rz00_15755 =
														PROCEDURE_ENTRY(BgL_fz00_15737) (BgL_fz00_15737,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13649), ((long) 0),
														BgL_bpz00_15736);
													return BgL_rz00_15755;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13646,
													BgL_symbzd2funzd2_13647, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15737));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1952> */
	obj_t BGl_z62zc3anonymousza31952ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13650, obj_t BgL_sz00_13655)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13651;
				obj_t BgL_locz00_13652;
				obj_t BgL_symbzd2funzd2_13653;
				long BgL_siza7eza7_13654;

				BgL_funz00_13651 = PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 0)));
				BgL_locz00_13652 = PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 1)));
				BgL_symbzd2funzd2_13653 =
					PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 2)));
				BgL_siza7eza7_13654 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13650, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15756;

					BgL_bpz00_15756 = VECTOR_REF(((obj_t) BgL_sz00_13655), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15757;

						BgL_fz00_15757 =
							PROCEDURE_ENTRY(BgL_funz00_13651) (BgL_funz00_13651,
							BgL_sz00_13655, BEOA);
						if (PROCEDUREP(BgL_fz00_15757))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13652,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15757);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15758;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20079;

								BgL_tmpz00_20079 = ((obj_t) BgL_fz00_15757);
								BgL_ufz00_15758 = PROCEDURE_ATTR(BgL_tmpz00_20079);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20082;

								if (STRUCTP(BgL_ufz00_15758))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20082 =
											(STRUCT_KEY(BgL_ufz00_15758) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20082 = ((bool_t) 0);
									}
								if (BgL_testz00_20082)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15759;
										obj_t BgL_runz00_15760;
										obj_t BgL_sfz00_15761;

										BgL_arityz00_15759 =
											STRUCT_REF(BgL_ufz00_15758, (int) (((long) 0)));
										BgL_runz00_15760 =
											STRUCT_REF(BgL_ufz00_15758, (int) (((long) 1)));
										BgL_sfz00_15761 =
											STRUCT_REF(BgL_ufz00_15758, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15762;

											BgL_spz00_15762 =
												((long) CINT(BgL_bpz00_15756) + BgL_siza7eza7_13654);
											if (((long) CINT(BgL_arityz00_15759) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 889 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15759))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15759))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1957z00_15763;
																		obj_t BgL_arg1958z00_15764;

																		BgL_arg1957z00_15763 =
																			(BgL_spz00_15762 + ((long) 0));
																		BgL_arg1958z00_15764 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13655),
																			BgL_arg1957z00_15763,
																			BgL_arg1958z00_15764);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13652,
																		STRUCT_REF(BgL_ufz00_15758,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15759));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13652, STRUCT_REF(BgL_ufz00_15758,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15759));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15765;

												BgL_z12denvz12_15765 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15765,
													BgL_locz00_13652);
												if (((BgL_spz00_15762 + (long) CINT(BgL_sfz00_15761)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13655))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15760, BgL_sz00_13655,
															BINT(BgL_spz00_15762));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15766;

														BgL_nsz00_15766 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1962z00_15767;

															BgL_arg1962z00_15767 =
																(BgL_spz00_15762 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15766, ((long) 2), BgL_sz00_13655,
																BINT(BgL_spz00_15762),
																BINT(BgL_arg1962z00_15767));
														}
														VECTOR_SET(BgL_nsz00_15766, ((long) 1),
															BgL_sz00_13655);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15765,
															BgL_nsz00_15766);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15768;

															BgL_ez00_15768 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15768, BgL_sz00_13655);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15769;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15770;

																	BgL_savedzd2bpzd2_15770 =
																		VECTOR_REF(BgL_nsz00_15766, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15766, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15772;

																		BgL_fz00_15772 = BgL_runz00_15760;
																	BgL_recz00_15771:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15773;

																			BgL_rz00_15773 =
																				PROCEDURE_ENTRY(BgL_fz00_15772)
																				(BgL_fz00_15772, BgL_nsz00_15766, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_20141;

																				if (PROCEDUREP(BgL_rz00_15773))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15774;

																						BgL_arg1696z00_15774 =
																							PROCEDURE_ATTR(BgL_rz00_15773);
																						if (STRUCTP(BgL_arg1696z00_15774))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20141 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15774) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20141 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_20141 = ((bool_t) 0);
																					}
																				if (BgL_testz00_20141)
																					{
																						obj_t BgL_fz00_20149;

																						BgL_fz00_20149 = BgL_rz00_15773;
																						BgL_fz00_15772 = BgL_fz00_20149;
																						goto BgL_recz00_15771;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15766,
																							((long) 0),
																							BgL_savedzd2bpzd2_15770);
																						BgL_____rz00_15769 = BgL_rz00_15773;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15768);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15765,
																	BgL_sz00_13655);
																return BgL_____rz00_15769;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15757,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15775;

												BgL_nbpz00_15775 =
													((long) CINT(BgL_bpz00_15756) + BgL_siza7eza7_13654);
												VECTOR_SET(
													((obj_t) BgL_sz00_13655), ((long) 0),
													BINT(BgL_nbpz00_15775));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_20161;

													BgL_tmpz00_20161 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20161,
														BgL_locz00_13652);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15776;

													BgL_rz00_15776 =
														PROCEDURE_ENTRY(BgL_fz00_15757) (BgL_fz00_15757,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13655), ((long) 0),
														BgL_bpz00_15756);
													return BgL_rz00_15776;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13652,
													BgL_symbzd2funzd2_13653, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15757));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1966> */
	obj_t BGl_z62zc3anonymousza31966ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13656, obj_t BgL_sz00_13661)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13657;
				obj_t BgL_locz00_13658;
				obj_t BgL_symbzd2funzd2_13659;
				long BgL_siza7eza7_13660;

				BgL_funz00_13657 = PROCEDURE_REF(BgL_envz00_13656, (int) (((long) 0)));
				BgL_locz00_13658 = PROCEDURE_REF(BgL_envz00_13656, (int) (((long) 1)));
				BgL_symbzd2funzd2_13659 =
					PROCEDURE_REF(BgL_envz00_13656, (int) (((long) 2)));
				BgL_siza7eza7_13660 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13656, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15777;

					BgL_bpz00_15777 = VECTOR_REF(((obj_t) BgL_sz00_13661), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15778;

						BgL_fz00_15778 =
							PROCEDURE_ENTRY(BgL_funz00_13657) (BgL_funz00_13657,
							BgL_sz00_13661, BEOA);
						if (PROCEDUREP(BgL_fz00_15778))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13658,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15778);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15779;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20190;

								BgL_tmpz00_20190 = ((obj_t) BgL_fz00_15778);
								BgL_ufz00_15779 = PROCEDURE_ATTR(BgL_tmpz00_20190);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20193;

								if (STRUCTP(BgL_ufz00_15779))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20193 =
											(STRUCT_KEY(BgL_ufz00_15779) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20193 = ((bool_t) 0);
									}
								if (BgL_testz00_20193)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15780;
										obj_t BgL_runz00_15781;
										obj_t BgL_sfz00_15782;

										BgL_arityz00_15780 =
											STRUCT_REF(BgL_ufz00_15779, (int) (((long) 0)));
										BgL_runz00_15781 =
											STRUCT_REF(BgL_ufz00_15779, (int) (((long) 1)));
										BgL_sfz00_15782 =
											STRUCT_REF(BgL_ufz00_15779, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15783;

											BgL_spz00_15783 =
												((long) CINT(BgL_bpz00_15777) + BgL_siza7eza7_13660);
											if (((long) CINT(BgL_arityz00_15780) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 889 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15780))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15780))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg1971z00_15784;
																		obj_t BgL_arg1972z00_15785;

																		BgL_arg1971z00_15784 =
																			(BgL_spz00_15783 + ((long) 0));
																		BgL_arg1972z00_15785 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13661),
																			BgL_arg1971z00_15784,
																			BgL_arg1972z00_15785);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13658,
																		STRUCT_REF(BgL_ufz00_15779,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15780));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13658, STRUCT_REF(BgL_ufz00_15779,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15780));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15786;

												BgL_z12denvz12_15786 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15783 +
															(long) CINT(BgL_sfz00_15782)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13661))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15781, BgL_sz00_13661,
															BINT(BgL_spz00_15783));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15787;

														BgL_nsz00_15787 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg1976z00_15788;

															BgL_arg1976z00_15788 =
																(BgL_spz00_15783 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15787, ((long) 2), BgL_sz00_13661,
																BINT(BgL_spz00_15783),
																BINT(BgL_arg1976z00_15788));
														}
														VECTOR_SET(BgL_nsz00_15787, ((long) 1),
															BgL_sz00_13661);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15786,
															BgL_nsz00_15787);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15789;

															BgL_ez00_15789 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15789, BgL_sz00_13661);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15790;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15791;

																	BgL_savedzd2bpzd2_15791 =
																		VECTOR_REF(BgL_nsz00_15787, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15787, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15793;

																		BgL_fz00_15793 = BgL_runz00_15781;
																	BgL_recz00_15792:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15794;

																			BgL_rz00_15794 =
																				PROCEDURE_ENTRY(BgL_fz00_15793)
																				(BgL_fz00_15793, BgL_nsz00_15787, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_20251;

																				if (PROCEDUREP(BgL_rz00_15794))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15795;

																						BgL_arg1696z00_15795 =
																							PROCEDURE_ATTR(BgL_rz00_15794);
																						if (STRUCTP(BgL_arg1696z00_15795))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20251 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15795) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20251 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_20251 = ((bool_t) 0);
																					}
																				if (BgL_testz00_20251)
																					{
																						obj_t BgL_fz00_20259;

																						BgL_fz00_20259 = BgL_rz00_15794;
																						BgL_fz00_15793 = BgL_fz00_20259;
																						goto BgL_recz00_15792;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15787,
																							((long) 0),
																							BgL_savedzd2bpzd2_15791);
																						BgL_____rz00_15790 = BgL_rz00_15794;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15789);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15786,
																	BgL_sz00_13661);
																return BgL_____rz00_15790;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15778,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15796;

												BgL_nbpz00_15796 =
													((long) CINT(BgL_bpz00_15777) + BgL_siza7eza7_13660);
												VECTOR_SET(
													((obj_t) BgL_sz00_13661), ((long) 0),
													BINT(BgL_nbpz00_15796));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15797;

													BgL_rz00_15797 =
														PROCEDURE_ENTRY(BgL_fz00_15778) (BgL_fz00_15778,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13661), ((long) 0),
														BgL_bpz00_15777);
													return BgL_rz00_15797;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13658,
													BgL_symbzd2funzd2_13659, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15778));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2109;

				BgL_cfunz00_2109 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_2109))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_20282;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg1986z00_2125;

							BgL_arg1986z00_2125 = bgl_debug();
							BgL_testz00_20282 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1986z00_2125),
								BINT(((long) 0)));
						}
						if (BgL_testz00_20282)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31983ze3z83_13662;

								BgL_zc3anonymousza31983ze3z83_13662 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31983ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3anonymousza31983ze3z83_13662,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3anonymousza31983ze3z83_13662,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3anonymousza31983ze3z83_13662,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3anonymousza31983ze3z83_13662,
									(int) (((long) 3)), BgL_cfunz00_2109);
								return BgL_zc3anonymousza31983ze3z83_13662;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza31985ze3z83_13663;

								BgL_zc3anonymousza31985ze3z83_13663 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza31985ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza31985ze3z83_13663,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3anonymousza31985ze3z83_13663,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3anonymousza31985ze3z83_13663,
									(int) (((long) 2)), BgL_cfunz00_2109);
								return BgL_zc3anonymousza31985ze3z83_13663;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20311;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2028z00_2201;

									BgL_arg2028z00_2201 = bgl_debug();
									BgL_testz00_20311 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2028z00_2201),
										BINT(((long) 0)));
								}
								if (BgL_testz00_20311)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza31989ze3z83_13664;

										BgL_zc3anonymousza31989ze3z83_13664 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31989ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza31989ze3z83_13664,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza31989ze3z83_13664,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza31989ze3z83_13664,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza31989ze3z83_13664,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza31989ze3z83_13664,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza31989ze3z83_13664;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32008ze3z83_13665;

										BgL_zc3anonymousza32008ze3z83_13665 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32008ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza32008ze3z83_13665,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza32008ze3z83_13665,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza32008ze3z83_13665,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza32008ze3z83_13665,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza32008ze3z83_13665,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza32008ze3z83_13665;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20344;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2070z00_2277;

									BgL_arg2070z00_2277 = bgl_debug();
									BgL_testz00_20344 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2070z00_2277),
										BINT(((long) 0)));
								}
								if (BgL_testz00_20344)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32031ze3z83_13666;

										BgL_zc3anonymousza32031ze3z83_13666 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32031ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza32031ze3z83_13666,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza32031ze3z83_13666,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza32031ze3z83_13666,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza32031ze3z83_13666,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza32031ze3z83_13666,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza32031ze3z83_13666;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32052ze3z83_13667;

										BgL_zc3anonymousza32052ze3z83_13667 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32052ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3anonymousza32052ze3z83_13667,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3anonymousza32052ze3z83_13667,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3anonymousza32052ze3z83_13667,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3anonymousza32052ze3z83_13667,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3anonymousza32052ze3z83_13667,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3anonymousza32052ze3z83_13667;
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1983> */
	obj_t BGl_z62zc3anonymousza31983ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13668, obj_t BgL_sz00_13673)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13669;
				long BgL_siza7eza7_13670;
				obj_t BgL_locz00_13671;
				obj_t BgL_cfunz00_13672;

				BgL_a1z00_13669 = PROCEDURE_REF(BgL_envz00_13668, (int) (((long) 0)));
				BgL_siza7eza7_13670 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13668, (int) (((long) 1))));
				BgL_locz00_13671 = PROCEDURE_REF(BgL_envz00_13668, (int) (((long) 2)));
				BgL_cfunz00_13672 = PROCEDURE_REF(BgL_envz00_13668, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15798;

					BgL_bpz00_15798 = VECTOR_REF(((obj_t) BgL_sz00_13673), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15799;

						BgL_a1z00_15799 =
							PROCEDURE_ENTRY(BgL_a1z00_13669) (BgL_a1z00_13669, BgL_sz00_13673,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15800;

							BgL_nbpz00_15800 =
								((long) CINT(BgL_bpz00_15798) + BgL_siza7eza7_13670);
							VECTOR_SET(
								((obj_t) BgL_sz00_13673), ((long) 0), BINT(BgL_nbpz00_15800));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20397;

								BgL_tmpz00_20397 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20397, BgL_locz00_13671);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15801;

								BgL_rz00_15801 =
									PROCEDURE_ENTRY(BgL_cfunz00_13672) (BgL_cfunz00_13672,
									BgL_a1z00_15799, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13673), ((long) 0),
									BgL_bpz00_15798);
								return BgL_rz00_15801;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1985> */
	obj_t BGl_z62zc3anonymousza31985ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13674, obj_t BgL_sz00_13678)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13675;
				long BgL_siza7eza7_13676;
				obj_t BgL_cfunz00_13677;

				BgL_a1z00_13675 = PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 0)));
				BgL_siza7eza7_13676 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 1))));
				BgL_cfunz00_13677 = PROCEDURE_REF(BgL_envz00_13674, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15802;

					BgL_bpz00_15802 = VECTOR_REF(((obj_t) BgL_sz00_13678), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15803;

						BgL_a1z00_15803 =
							PROCEDURE_ENTRY(BgL_a1z00_13675) (BgL_a1z00_13675, BgL_sz00_13678,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15804;

							BgL_nbpz00_15804 =
								((long) CINT(BgL_bpz00_15802) + BgL_siza7eza7_13676);
							VECTOR_SET(
								((obj_t) BgL_sz00_13678), ((long) 0), BINT(BgL_nbpz00_15804));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15805;

								BgL_rz00_15805 =
									PROCEDURE_ENTRY(BgL_cfunz00_13677) (BgL_cfunz00_13677,
									BgL_a1z00_15803, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13678), ((long) 0),
									BgL_bpz00_15802);
								return BgL_rz00_15805;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1989> */
	obj_t BGl_z62zc3anonymousza31989ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13679, obj_t BgL_sz00_13685)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13680;
				obj_t BgL_a1z00_13681;
				obj_t BgL_locz00_13682;
				obj_t BgL_symbzd2funzd2_13683;
				long BgL_siza7eza7_13684;

				BgL_funz00_13680 = PROCEDURE_REF(BgL_envz00_13679, (int) (((long) 0)));
				BgL_a1z00_13681 = PROCEDURE_REF(BgL_envz00_13679, (int) (((long) 1)));
				BgL_locz00_13682 = PROCEDURE_REF(BgL_envz00_13679, (int) (((long) 2)));
				BgL_symbzd2funzd2_13683 =
					PROCEDURE_REF(BgL_envz00_13679, (int) (((long) 3)));
				BgL_siza7eza7_13684 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13679, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15806;

					BgL_bpz00_15806 = VECTOR_REF(((obj_t) BgL_sz00_13685), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15807;
						obj_t BgL_a1z00_15808;

						BgL_fz00_15807 =
							PROCEDURE_ENTRY(BgL_funz00_13680) (BgL_funz00_13680,
							BgL_sz00_13685, BEOA);
						BgL_a1z00_15808 =
							PROCEDURE_ENTRY(BgL_a1z00_13681) (BgL_a1z00_13681, BgL_sz00_13685,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15807))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13682,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15807);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15809;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20454;

								BgL_tmpz00_20454 = ((obj_t) BgL_fz00_15807);
								BgL_ufz00_15809 = PROCEDURE_ATTR(BgL_tmpz00_20454);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20457;

								if (STRUCTP(BgL_ufz00_15809))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20457 =
											(STRUCT_KEY(BgL_ufz00_15809) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20457 = ((bool_t) 0);
									}
								if (BgL_testz00_20457)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15810;
										obj_t BgL_runz00_15811;
										obj_t BgL_sfz00_15812;

										BgL_arityz00_15810 =
											STRUCT_REF(BgL_ufz00_15809, (int) (((long) 0)));
										BgL_runz00_15811 =
											STRUCT_REF(BgL_ufz00_15809, (int) (((long) 1)));
										BgL_sfz00_15812 =
											STRUCT_REF(BgL_ufz00_15809, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15810) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_arg1993z00_15813;

												BgL_arg1993z00_15813 =
													((long) CINT(BgL_bpz00_15806) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13685), BgL_arg1993z00_15813,
													BgL_a1z00_15808);
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15810))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15810))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1995z00_15814;
																	obj_t BgL_arg1996z00_15815;

																	BgL_arg1995z00_15814 =
																		((long) CINT(BgL_bpz00_15806) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list1997z00_15816;

																		BgL_list1997z00_15816 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15808, BNIL);
																		BgL_arg1996z00_15815 =
																			BgL_list1997z00_15816;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13685),
																		BgL_arg1995z00_15814, BgL_arg1996z00_15815);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1998z00_15817;

																	BgL_arg1998z00_15817 =
																		((long) CINT(BgL_bpz00_15806) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13685),
																		BgL_arg1998z00_15817, BgL_a1z00_15808);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg1999z00_15818;
																	obj_t BgL_arg2000z00_15819;

																	BgL_arg1999z00_15818 =
																		((long) CINT(BgL_bpz00_15806) + ((long) 1));
																	BgL_arg2000z00_15819 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13685),
																		BgL_arg1999z00_15818, BgL_arg2000z00_15819);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13682, STRUCT_REF(BgL_ufz00_15809,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15810));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13682, STRUCT_REF(BgL_ufz00_15809,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15810));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15820;

											BgL_z12denvz12_15820 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15820,
												BgL_locz00_13682);
											if ((((long) CINT(BgL_bpz00_15806) +
														(long) CINT(BgL_sfz00_15812)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13685))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15811;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15821;

													BgL_nsz00_15821 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2004z00_15822;

														BgL_arg2004z00_15822 =
															((long) CINT(BgL_bpz00_15806) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15821, ((long) 2), BgL_sz00_13685,
															BgL_bpz00_15806, BINT(BgL_arg2004z00_15822));
													}
													VECTOR_SET(BgL_nsz00_15821, ((long) 1),
														BgL_sz00_13685);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15820,
														BgL_nsz00_15821);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15823;

														BgL_ez00_15823 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15823, BgL_sz00_13685);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15824;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15825;

																BgL_savedzd2bpzd2_15825 =
																	VECTOR_REF(BgL_nsz00_15821, ((long) 0));
																VECTOR_SET(BgL_nsz00_15821, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15827;

																	BgL_fz00_15827 = BgL_runz00_15811;
																BgL_recz00_15826:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15828;

																		BgL_rz00_15828 =
																			PROCEDURE_ENTRY(BgL_fz00_15827)
																			(BgL_fz00_15827, BgL_nsz00_15821, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_20527;

																			if (PROCEDUREP(BgL_rz00_15828))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15829;

																					BgL_arg1696z00_15829 =
																						PROCEDURE_ATTR(BgL_rz00_15828);
																					if (STRUCTP(BgL_arg1696z00_15829))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_20527 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15829) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_20527 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_20527 = ((bool_t) 0);
																				}
																			if (BgL_testz00_20527)
																				{
																					obj_t BgL_fz00_20535;

																					BgL_fz00_20535 = BgL_rz00_15828;
																					BgL_fz00_15827 = BgL_fz00_20535;
																					goto BgL_recz00_15826;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15821,
																						((long) 0),
																						BgL_savedzd2bpzd2_15825);
																					BgL_____rz00_15824 = BgL_rz00_15828;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15823);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15820,
																BgL_sz00_13685);
															return BgL_____rz00_15824;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15807,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15830;

												BgL_nbpz00_15830 =
													((long) CINT(BgL_bpz00_15806) + BgL_siza7eza7_13684);
												VECTOR_SET(
													((obj_t) BgL_sz00_13685), ((long) 0),
													BINT(BgL_nbpz00_15830));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_20547;

													BgL_tmpz00_20547 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20547,
														BgL_locz00_13682);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15831;

													BgL_rz00_15831 =
														PROCEDURE_ENTRY(BgL_fz00_15807) (BgL_fz00_15807,
														BgL_a1z00_15808, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13685), ((long) 0),
														BgL_bpz00_15806);
													return BgL_rz00_15831;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13682,
													BgL_symbzd2funzd2_13683, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15807));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2008> */
	obj_t BGl_z62zc3anonymousza32008ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13686, obj_t BgL_sz00_13692)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13687;
				obj_t BgL_a1z00_13688;
				obj_t BgL_locz00_13689;
				obj_t BgL_symbzd2funzd2_13690;
				long BgL_siza7eza7_13691;

				BgL_funz00_13687 = PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 0)));
				BgL_a1z00_13688 = PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 1)));
				BgL_locz00_13689 = PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 2)));
				BgL_symbzd2funzd2_13690 =
					PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 3)));
				BgL_siza7eza7_13691 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13686, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15832;

					BgL_bpz00_15832 = VECTOR_REF(((obj_t) BgL_sz00_13692), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15833;
						obj_t BgL_a1z00_15834;

						BgL_fz00_15833 =
							PROCEDURE_ENTRY(BgL_funz00_13687) (BgL_funz00_13687,
							BgL_sz00_13692, BEOA);
						BgL_a1z00_15834 =
							PROCEDURE_ENTRY(BgL_a1z00_13688) (BgL_a1z00_13688, BgL_sz00_13692,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15833))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13689,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15833);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15835;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20583;

								BgL_tmpz00_20583 = ((obj_t) BgL_fz00_15833);
								BgL_ufz00_15835 = PROCEDURE_ATTR(BgL_tmpz00_20583);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20586;

								if (STRUCTP(BgL_ufz00_15835))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20586 =
											(STRUCT_KEY(BgL_ufz00_15835) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20586 = ((bool_t) 0);
									}
								if (BgL_testz00_20586)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15836;
										obj_t BgL_runz00_15837;
										obj_t BgL_sfz00_15838;

										BgL_arityz00_15836 =
											STRUCT_REF(BgL_ufz00_15835, (int) (((long) 0)));
										BgL_runz00_15837 =
											STRUCT_REF(BgL_ufz00_15835, (int) (((long) 1)));
										BgL_sfz00_15838 =
											STRUCT_REF(BgL_ufz00_15835, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15836) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_arg2012z00_15839;

												BgL_arg2012z00_15839 =
													((long) CINT(BgL_bpz00_15832) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13692), BgL_arg2012z00_15839,
													BgL_a1z00_15834);
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15836))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15836))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2014z00_15840;
																	obj_t BgL_arg2015z00_15841;

																	BgL_arg2014z00_15840 =
																		((long) CINT(BgL_bpz00_15832) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2016z00_15842;

																		BgL_list2016z00_15842 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15834, BNIL);
																		BgL_arg2015z00_15841 =
																			BgL_list2016z00_15842;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13692),
																		BgL_arg2014z00_15840, BgL_arg2015z00_15841);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2017z00_15843;

																	BgL_arg2017z00_15843 =
																		((long) CINT(BgL_bpz00_15832) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13692),
																		BgL_arg2017z00_15843, BgL_a1z00_15834);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2018z00_15844;
																	obj_t BgL_arg2019z00_15845;

																	BgL_arg2018z00_15844 =
																		((long) CINT(BgL_bpz00_15832) + ((long) 1));
																	BgL_arg2019z00_15845 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13692),
																		BgL_arg2018z00_15844, BgL_arg2019z00_15845);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13689, STRUCT_REF(BgL_ufz00_15835,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15836));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13689, STRUCT_REF(BgL_ufz00_15835,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15836));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15846;

											BgL_z12denvz12_15846 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15832) +
														(long) CINT(BgL_sfz00_15838)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13692))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15837;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15847;

													BgL_nsz00_15847 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2025z00_15848;

														BgL_arg2025z00_15848 =
															((long) CINT(BgL_bpz00_15832) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15847, ((long) 2), BgL_sz00_13692,
															BgL_bpz00_15832, BINT(BgL_arg2025z00_15848));
													}
													VECTOR_SET(BgL_nsz00_15847, ((long) 1),
														BgL_sz00_13692);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15846,
														BgL_nsz00_15847);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15849;

														BgL_ez00_15849 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15849, BgL_sz00_13692);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15850;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15851;

																BgL_savedzd2bpzd2_15851 =
																	VECTOR_REF(BgL_nsz00_15847, ((long) 0));
																VECTOR_SET(BgL_nsz00_15847, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15853;

																	BgL_fz00_15853 = BgL_runz00_15837;
																BgL_recz00_15852:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15854;

																		BgL_rz00_15854 =
																			PROCEDURE_ENTRY(BgL_fz00_15853)
																			(BgL_fz00_15853, BgL_nsz00_15847, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_20655;

																			if (PROCEDUREP(BgL_rz00_15854))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15855;

																					BgL_arg1696z00_15855 =
																						PROCEDURE_ATTR(BgL_rz00_15854);
																					if (STRUCTP(BgL_arg1696z00_15855))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_20655 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15855) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_20655 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_20655 = ((bool_t) 0);
																				}
																			if (BgL_testz00_20655)
																				{
																					obj_t BgL_fz00_20663;

																					BgL_fz00_20663 = BgL_rz00_15854;
																					BgL_fz00_15853 = BgL_fz00_20663;
																					goto BgL_recz00_15852;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15847,
																						((long) 0),
																						BgL_savedzd2bpzd2_15851);
																					BgL_____rz00_15850 = BgL_rz00_15854;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15849);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15846,
																BgL_sz00_13692);
															return BgL_____rz00_15850;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15833,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15856;

												BgL_nbpz00_15856 =
													((long) CINT(BgL_bpz00_15832) + BgL_siza7eza7_13691);
												VECTOR_SET(
													((obj_t) BgL_sz00_13692), ((long) 0),
													BINT(BgL_nbpz00_15856));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15857;

													BgL_rz00_15857 =
														PROCEDURE_ENTRY(BgL_fz00_15833) (BgL_fz00_15833,
														BgL_a1z00_15834, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13692), ((long) 0),
														BgL_bpz00_15832);
													return BgL_rz00_15857;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13689,
													BgL_symbzd2funzd2_13690, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15833));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2031> */
	obj_t BGl_z62zc3anonymousza32031ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13693, obj_t BgL_sz00_13699)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13694;
				obj_t BgL_a1z00_13695;
				obj_t BgL_locz00_13696;
				obj_t BgL_symbzd2funzd2_13697;
				long BgL_siza7eza7_13698;

				BgL_funz00_13694 = PROCEDURE_REF(BgL_envz00_13693, (int) (((long) 0)));
				BgL_a1z00_13695 = PROCEDURE_REF(BgL_envz00_13693, (int) (((long) 1)));
				BgL_locz00_13696 = PROCEDURE_REF(BgL_envz00_13693, (int) (((long) 2)));
				BgL_symbzd2funzd2_13697 =
					PROCEDURE_REF(BgL_envz00_13693, (int) (((long) 3)));
				BgL_siza7eza7_13698 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13693, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15858;

					BgL_bpz00_15858 = VECTOR_REF(((obj_t) BgL_sz00_13699), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15859;
						obj_t BgL_a1z00_15860;

						BgL_fz00_15859 =
							PROCEDURE_ENTRY(BgL_funz00_13694) (BgL_funz00_13694,
							BgL_sz00_13699, BEOA);
						BgL_a1z00_15860 =
							PROCEDURE_ENTRY(BgL_a1z00_13695) (BgL_a1z00_13695, BgL_sz00_13699,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15859))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13696,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15859);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15861;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20708;

								BgL_tmpz00_20708 = ((obj_t) BgL_fz00_15859);
								BgL_ufz00_15861 = PROCEDURE_ATTR(BgL_tmpz00_20708);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20711;

								if (STRUCTP(BgL_ufz00_15861))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20711 =
											(STRUCT_KEY(BgL_ufz00_15861) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20711 = ((bool_t) 0);
									}
								if (BgL_testz00_20711)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15862;
										obj_t BgL_runz00_15863;
										obj_t BgL_sfz00_15864;

										BgL_arityz00_15862 =
											STRUCT_REF(BgL_ufz00_15861, (int) (((long) 0)));
										BgL_runz00_15863 =
											STRUCT_REF(BgL_ufz00_15861, (int) (((long) 1)));
										BgL_sfz00_15864 =
											STRUCT_REF(BgL_ufz00_15861, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15865;

											BgL_spz00_15865 =
												((long) CINT(BgL_bpz00_15858) + BgL_siza7eza7_13698);
											if (((long) CINT(BgL_arityz00_15862) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2035z00_15866;

													BgL_arg2035z00_15866 = (BgL_spz00_15865 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13699), BgL_arg2035z00_15866,
														BgL_a1z00_15860);
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15862))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15862))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2037z00_15867;
																		obj_t BgL_arg2038z00_15868;

																		BgL_arg2037z00_15867 =
																			(BgL_spz00_15865 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2039z00_15869;

																			BgL_list2039z00_15869 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15860, BNIL);
																			BgL_arg2038z00_15868 =
																				BgL_list2039z00_15869;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13699),
																			BgL_arg2037z00_15867,
																			BgL_arg2038z00_15868);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2040z00_15870;

																		BgL_arg2040z00_15870 =
																			(BgL_spz00_15865 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13699),
																			BgL_arg2040z00_15870, BgL_a1z00_15860);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2041z00_15871;
																		obj_t BgL_arg2044z00_15872;

																		BgL_arg2041z00_15871 =
																			(BgL_spz00_15865 + ((long) 1));
																		BgL_arg2044z00_15872 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13699),
																			BgL_arg2041z00_15871,
																			BgL_arg2044z00_15872);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13696,
																		STRUCT_REF(BgL_ufz00_15861,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15862));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13696, STRUCT_REF(BgL_ufz00_15861,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15862));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15873;

												BgL_z12denvz12_15873 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15873,
													BgL_locz00_13696);
												if (((BgL_spz00_15865 + (long) CINT(BgL_sfz00_15864)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13699))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15863, BgL_sz00_13699,
															BINT(BgL_spz00_15865));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15874;

														BgL_nsz00_15874 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2048z00_15875;

															BgL_arg2048z00_15875 =
																(BgL_spz00_15865 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15874, ((long) 2), BgL_sz00_13699,
																BINT(BgL_spz00_15865),
																BINT(BgL_arg2048z00_15875));
														}
														VECTOR_SET(BgL_nsz00_15874, ((long) 1),
															BgL_sz00_13699);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15873,
															BgL_nsz00_15874);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15876;

															BgL_ez00_15876 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15876, BgL_sz00_13699);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15877;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15878;

																	BgL_savedzd2bpzd2_15878 =
																		VECTOR_REF(BgL_nsz00_15874, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15874, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15880;

																		BgL_fz00_15880 = BgL_runz00_15863;
																	BgL_recz00_15879:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15881;

																			BgL_rz00_15881 =
																				PROCEDURE_ENTRY(BgL_fz00_15880)
																				(BgL_fz00_15880, BgL_nsz00_15874, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_20780;

																				if (PROCEDUREP(BgL_rz00_15881))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15882;

																						BgL_arg1696z00_15882 =
																							PROCEDURE_ATTR(BgL_rz00_15881);
																						if (STRUCTP(BgL_arg1696z00_15882))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20780 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15882) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20780 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_20780 = ((bool_t) 0);
																					}
																				if (BgL_testz00_20780)
																					{
																						obj_t BgL_fz00_20788;

																						BgL_fz00_20788 = BgL_rz00_15881;
																						BgL_fz00_15880 = BgL_fz00_20788;
																						goto BgL_recz00_15879;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15874,
																							((long) 0),
																							BgL_savedzd2bpzd2_15878);
																						BgL_____rz00_15877 = BgL_rz00_15881;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15876);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15873,
																	BgL_sz00_13699);
																return BgL_____rz00_15877;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15859,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15883;

												BgL_nbpz00_15883 =
													((long) CINT(BgL_bpz00_15858) + BgL_siza7eza7_13698);
												VECTOR_SET(
													((obj_t) BgL_sz00_13699), ((long) 0),
													BINT(BgL_nbpz00_15883));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_20800;

													BgL_tmpz00_20800 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20800,
														BgL_locz00_13696);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15884;

													BgL_rz00_15884 =
														PROCEDURE_ENTRY(BgL_fz00_15859) (BgL_fz00_15859,
														BgL_a1z00_15860, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13699), ((long) 0),
														BgL_bpz00_15858);
													return BgL_rz00_15884;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13696,
													BgL_symbzd2funzd2_13697, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15859));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2052> */
	obj_t BGl_z62zc3anonymousza32052ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13700, obj_t BgL_sz00_13706)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13701;
				obj_t BgL_a1z00_13702;
				obj_t BgL_locz00_13703;
				obj_t BgL_symbzd2funzd2_13704;
				long BgL_siza7eza7_13705;

				BgL_funz00_13701 = PROCEDURE_REF(BgL_envz00_13700, (int) (((long) 0)));
				BgL_a1z00_13702 = PROCEDURE_REF(BgL_envz00_13700, (int) (((long) 1)));
				BgL_locz00_13703 = PROCEDURE_REF(BgL_envz00_13700, (int) (((long) 2)));
				BgL_symbzd2funzd2_13704 =
					PROCEDURE_REF(BgL_envz00_13700, (int) (((long) 3)));
				BgL_siza7eza7_13705 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13700, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15885;

					BgL_bpz00_15885 = VECTOR_REF(((obj_t) BgL_sz00_13706), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15886;
						obj_t BgL_a1z00_15887;

						BgL_fz00_15886 =
							PROCEDURE_ENTRY(BgL_funz00_13701) (BgL_funz00_13701,
							BgL_sz00_13706, BEOA);
						BgL_a1z00_15887 =
							PROCEDURE_ENTRY(BgL_a1z00_13702) (BgL_a1z00_13702, BgL_sz00_13706,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15886))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13703,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15886);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15888;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_20836;

								BgL_tmpz00_20836 = ((obj_t) BgL_fz00_15886);
								BgL_ufz00_15888 = PROCEDURE_ATTR(BgL_tmpz00_20836);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20839;

								if (STRUCTP(BgL_ufz00_15888))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20839 =
											(STRUCT_KEY(BgL_ufz00_15888) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_20839 = ((bool_t) 0);
									}
								if (BgL_testz00_20839)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15889;
										obj_t BgL_runz00_15890;
										obj_t BgL_sfz00_15891;

										BgL_arityz00_15889 =
											STRUCT_REF(BgL_ufz00_15888, (int) (((long) 0)));
										BgL_runz00_15890 =
											STRUCT_REF(BgL_ufz00_15888, (int) (((long) 1)));
										BgL_sfz00_15891 =
											STRUCT_REF(BgL_ufz00_15888, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15892;

											BgL_spz00_15892 =
												((long) CINT(BgL_bpz00_15885) + BgL_siza7eza7_13705);
											if (((long) CINT(BgL_arityz00_15889) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2056z00_15893;

													BgL_arg2056z00_15893 = (BgL_spz00_15892 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13706), BgL_arg2056z00_15893,
														BgL_a1z00_15887);
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15889))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15889))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2058z00_15894;
																		obj_t BgL_arg2059z00_15895;

																		BgL_arg2058z00_15894 =
																			(BgL_spz00_15892 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2060z00_15896;

																			BgL_list2060z00_15896 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15887, BNIL);
																			BgL_arg2059z00_15895 =
																				BgL_list2060z00_15896;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13706),
																			BgL_arg2058z00_15894,
																			BgL_arg2059z00_15895);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2061z00_15897;

																		BgL_arg2061z00_15897 =
																			(BgL_spz00_15892 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13706),
																			BgL_arg2061z00_15897, BgL_a1z00_15887);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2062z00_15898;
																		obj_t BgL_arg2063z00_15899;

																		BgL_arg2062z00_15898 =
																			(BgL_spz00_15892 + ((long) 1));
																		BgL_arg2063z00_15899 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13706),
																			BgL_arg2062z00_15898,
																			BgL_arg2063z00_15899);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13703,
																		STRUCT_REF(BgL_ufz00_15888,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15889));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13703, STRUCT_REF(BgL_ufz00_15888,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15889));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_15900;

												BgL_z12denvz12_15900 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15892 +
															(long) CINT(BgL_sfz00_15891)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13706))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15890, BgL_sz00_13706,
															BINT(BgL_spz00_15892));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_15901;

														BgL_nsz00_15901 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2067z00_15902;

															BgL_arg2067z00_15902 =
																(BgL_spz00_15892 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15901, ((long) 2), BgL_sz00_13706,
																BINT(BgL_spz00_15892),
																BINT(BgL_arg2067z00_15902));
														}
														VECTOR_SET(BgL_nsz00_15901, ((long) 1),
															BgL_sz00_13706);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15900,
															BgL_nsz00_15901);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_15903;

															BgL_ez00_15903 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15903, BgL_sz00_13706);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_15904;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_15905;

																	BgL_savedzd2bpzd2_15905 =
																		VECTOR_REF(BgL_nsz00_15901, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15901, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15907;

																		BgL_fz00_15907 = BgL_runz00_15890;
																	BgL_recz00_15906:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_15908;

																			BgL_rz00_15908 =
																				PROCEDURE_ENTRY(BgL_fz00_15907)
																				(BgL_fz00_15907, BgL_nsz00_15901, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_20907;

																				if (PROCEDUREP(BgL_rz00_15908))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_15909;

																						BgL_arg1696z00_15909 =
																							PROCEDURE_ATTR(BgL_rz00_15908);
																						if (STRUCTP(BgL_arg1696z00_15909))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20907 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_15909) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_20907 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_20907 = ((bool_t) 0);
																					}
																				if (BgL_testz00_20907)
																					{
																						obj_t BgL_fz00_20915;

																						BgL_fz00_20915 = BgL_rz00_15908;
																						BgL_fz00_15907 = BgL_fz00_20915;
																						goto BgL_recz00_15906;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_15901,
																							((long) 0),
																							BgL_savedzd2bpzd2_15905);
																						BgL_____rz00_15904 = BgL_rz00_15908;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15903);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15900,
																	BgL_sz00_13706);
																return BgL_____rz00_15904;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15886,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15910;

												BgL_nbpz00_15910 =
													((long) CINT(BgL_bpz00_15885) + BgL_siza7eza7_13705);
												VECTOR_SET(
													((obj_t) BgL_sz00_13706), ((long) 0),
													BINT(BgL_nbpz00_15910));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15911;

													BgL_rz00_15911 =
														PROCEDURE_ENTRY(BgL_fz00_15886) (BgL_fz00_15886,
														BgL_a1z00_15887, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13706), ((long) 0),
														BgL_bpz00_15885);
													return BgL_rz00_15911;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13703,
													BgL_symbzd2funzd2_13704, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15886));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2278;

				BgL_cfunz00_2278 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_2278))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_20939;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2076z00_2296;

							BgL_arg2076z00_2296 = bgl_debug();
							BgL_testz00_20939 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2076z00_2296),
								BINT(((long) 0)));
						}
						if (BgL_testz00_20939)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32073ze3z83_13707;

								BgL_zc3anonymousza32073ze3z83_13707 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32073ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza32073ze3z83_13707,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3anonymousza32073ze3z83_13707,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3anonymousza32073ze3z83_13707,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3anonymousza32073ze3z83_13707,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3anonymousza32073ze3z83_13707,
									(int) (((long) 4)), BgL_cfunz00_2278);
								return BgL_zc3anonymousza32073ze3z83_13707;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32075ze3z83_13708;

								BgL_zc3anonymousza32075ze3z83_13708 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32075ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3anonymousza32075ze3z83_13708,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3anonymousza32075ze3z83_13708,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3anonymousza32075ze3z83_13708,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3anonymousza32075ze3z83_13708,
									(int) (((long) 3)), BgL_cfunz00_2278);
								return BgL_zc3anonymousza32075ze3z83_13708;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_20972;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2136z00_2388;

									BgL_arg2136z00_2388 = bgl_debug();
									BgL_testz00_20972 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2136z00_2388),
										BINT(((long) 0)));
								}
								if (BgL_testz00_20972)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32079ze3z83_13709;

										BgL_zc3anonymousza32079ze3z83_13709 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32079ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32079ze3z83_13709,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32079ze3z83_13709,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32079ze3z83_13709,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32079ze3z83_13709,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32079ze3z83_13709,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32079ze3z83_13709,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32079ze3z83_13709;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32110ze3z83_13710;

										BgL_zc3anonymousza32110ze3z83_13710 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32110ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32110ze3z83_13710,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32110ze3z83_13710,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32110ze3z83_13710,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32110ze3z83_13710,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32110ze3z83_13710,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32110ze3z83_13710,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32110ze3z83_13710;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21009;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2191z00_2480;

									BgL_arg2191z00_2480 = bgl_debug();
									BgL_testz00_21009 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2191z00_2480),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21009)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32139ze3z83_13711;

										BgL_zc3anonymousza32139ze3z83_13711 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32139ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32139ze3z83_13711,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32139ze3z83_13711,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32139ze3z83_13711,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32139ze3z83_13711,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32139ze3z83_13711,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32139ze3z83_13711,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32139ze3z83_13711;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32166ze3z83_13712;

										BgL_zc3anonymousza32166ze3z83_13712 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32166ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3anonymousza32166ze3z83_13712,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3anonymousza32166ze3z83_13712,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3anonymousza32166ze3z83_13712,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3anonymousza32166ze3z83_13712,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3anonymousza32166ze3z83_13712,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3anonymousza32166ze3z83_13712,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3anonymousza32166ze3z83_13712;
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2073> */
	obj_t BGl_z62zc3anonymousza32073ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13713, obj_t BgL_sz00_13719)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13714;
				obj_t BgL_a2z00_13715;
				long BgL_siza7eza7_13716;
				obj_t BgL_locz00_13717;
				obj_t BgL_cfunz00_13718;

				BgL_a1z00_13714 = PROCEDURE_REF(BgL_envz00_13713, (int) (((long) 0)));
				BgL_a2z00_13715 = PROCEDURE_REF(BgL_envz00_13713, (int) (((long) 1)));
				BgL_siza7eza7_13716 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13713, (int) (((long) 2))));
				BgL_locz00_13717 = PROCEDURE_REF(BgL_envz00_13713, (int) (((long) 3)));
				BgL_cfunz00_13718 = PROCEDURE_REF(BgL_envz00_13713, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15912;

					BgL_bpz00_15912 = VECTOR_REF(((obj_t) BgL_sz00_13719), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15913;
						obj_t BgL_a2z00_15914;

						BgL_a1z00_15913 =
							PROCEDURE_ENTRY(BgL_a1z00_13714) (BgL_a1z00_13714, BgL_sz00_13719,
							BEOA);
						BgL_a2z00_15914 =
							PROCEDURE_ENTRY(BgL_a2z00_13715) (BgL_a2z00_13715, BgL_sz00_13719,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15915;

							BgL_nbpz00_15915 =
								((long) CINT(BgL_bpz00_15912) + BgL_siza7eza7_13716);
							VECTOR_SET(
								((obj_t) BgL_sz00_13719), ((long) 0), BINT(BgL_nbpz00_15915));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21072;

								BgL_tmpz00_21072 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21072, BgL_locz00_13717);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15916;

								BgL_rz00_15916 =
									PROCEDURE_ENTRY(BgL_cfunz00_13718) (BgL_cfunz00_13718,
									BgL_a1z00_15913, BgL_a2z00_15914, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13719), ((long) 0),
									BgL_bpz00_15912);
								return BgL_rz00_15916;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2075> */
	obj_t BGl_z62zc3anonymousza32075ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13720, obj_t BgL_sz00_13725)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13721;
				obj_t BgL_a2z00_13722;
				long BgL_siza7eza7_13723;
				obj_t BgL_cfunz00_13724;

				BgL_a1z00_13721 = PROCEDURE_REF(BgL_envz00_13720, (int) (((long) 0)));
				BgL_a2z00_13722 = PROCEDURE_REF(BgL_envz00_13720, (int) (((long) 1)));
				BgL_siza7eza7_13723 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13720, (int) (((long) 2))));
				BgL_cfunz00_13724 = PROCEDURE_REF(BgL_envz00_13720, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15917;

					BgL_bpz00_15917 = VECTOR_REF(((obj_t) BgL_sz00_13725), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_15918;
						obj_t BgL_a2z00_15919;

						BgL_a1z00_15918 =
							PROCEDURE_ENTRY(BgL_a1z00_13721) (BgL_a1z00_13721, BgL_sz00_13725,
							BEOA);
						BgL_a2z00_15919 =
							PROCEDURE_ENTRY(BgL_a2z00_13722) (BgL_a2z00_13722, BgL_sz00_13725,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_15920;

							BgL_nbpz00_15920 =
								((long) CINT(BgL_bpz00_15917) + BgL_siza7eza7_13723);
							VECTOR_SET(
								((obj_t) BgL_sz00_13725), ((long) 0), BINT(BgL_nbpz00_15920));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_15921;

								BgL_rz00_15921 =
									PROCEDURE_ENTRY(BgL_cfunz00_13724) (BgL_cfunz00_13724,
									BgL_a1z00_15918, BgL_a2z00_15919, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13725), ((long) 0),
									BgL_bpz00_15917);
								return BgL_rz00_15921;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2079> */
	obj_t BGl_z62zc3anonymousza32079ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13726, obj_t BgL_sz00_13733)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13727;
				obj_t BgL_a1z00_13728;
				obj_t BgL_a2z00_13729;
				obj_t BgL_locz00_13730;
				obj_t BgL_symbzd2funzd2_13731;
				long BgL_siza7eza7_13732;

				BgL_funz00_13727 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 0)));
				BgL_a1z00_13728 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 1)));
				BgL_a2z00_13729 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 2)));
				BgL_locz00_13730 = PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 3)));
				BgL_symbzd2funzd2_13731 =
					PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 4)));
				BgL_siza7eza7_13732 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13726, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15922;

					BgL_bpz00_15922 = VECTOR_REF(((obj_t) BgL_sz00_13733), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15923;
						obj_t BgL_a1z00_15924;
						obj_t BgL_a2z00_15925;

						BgL_fz00_15923 =
							PROCEDURE_ENTRY(BgL_funz00_13727) (BgL_funz00_13727,
							BgL_sz00_13733, BEOA);
						BgL_a1z00_15924 =
							PROCEDURE_ENTRY(BgL_a1z00_13728) (BgL_a1z00_13728, BgL_sz00_13733,
							BEOA);
						BgL_a2z00_15925 =
							PROCEDURE_ENTRY(BgL_a2z00_13729) (BgL_a2z00_13729, BgL_sz00_13733,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15923))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13730,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15923);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15926;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21143;

								BgL_tmpz00_21143 = ((obj_t) BgL_fz00_15923);
								BgL_ufz00_15926 = PROCEDURE_ATTR(BgL_tmpz00_21143);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21146;

								if (STRUCTP(BgL_ufz00_15926))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21146 =
											(STRUCT_KEY(BgL_ufz00_15926) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21146 = ((bool_t) 0);
									}
								if (BgL_testz00_21146)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15927;
										obj_t BgL_runz00_15928;
										obj_t BgL_sfz00_15929;

										BgL_arityz00_15927 =
											STRUCT_REF(BgL_ufz00_15926, (int) (((long) 0)));
										BgL_runz00_15928 =
											STRUCT_REF(BgL_ufz00_15926, (int) (((long) 1)));
										BgL_sfz00_15929 =
											STRUCT_REF(BgL_ufz00_15926, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15927) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2084z00_15930;

													BgL_arg2084z00_15930 =
														((long) CINT(BgL_bpz00_15922) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13733), BgL_arg2084z00_15930,
														BgL_a1z00_15924);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2085z00_15931;

													BgL_arg2085z00_15931 =
														((long) CINT(BgL_bpz00_15922) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13733), BgL_arg2085z00_15931,
														BgL_a2z00_15925);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15927))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15927))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2087z00_15932;
																	obj_t BgL_arg2088z00_15933;

																	BgL_arg2087z00_15932 =
																		((long) CINT(BgL_bpz00_15922) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2089z00_15934;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2090z00_15935;

																			BgL_arg2090z00_15935 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15925, BNIL);
																			BgL_list2089z00_15934 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15924,
																				BgL_arg2090z00_15935);
																		}
																		BgL_arg2088z00_15933 =
																			BgL_list2089z00_15934;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2087z00_15932, BgL_arg2088z00_15933);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2091z00_15936;

																	BgL_arg2091z00_15936 =
																		((long) CINT(BgL_bpz00_15922) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2091z00_15936, BgL_a1z00_15924);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2092z00_15937;
																	obj_t BgL_arg2093z00_15938;

																	BgL_arg2092z00_15937 =
																		((long) CINT(BgL_bpz00_15922) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2094z00_15939;

																		BgL_list2094z00_15939 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15925, BNIL);
																		BgL_arg2093z00_15938 =
																			BgL_list2094z00_15939;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2092z00_15937, BgL_arg2093z00_15938);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2097z00_15940;

																	BgL_arg2097z00_15940 =
																		((long) CINT(BgL_bpz00_15922) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2097z00_15940, BgL_a1z00_15924);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2098z00_15941;

																	BgL_arg2098z00_15941 =
																		((long) CINT(BgL_bpz00_15922) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2098z00_15941, BgL_a2z00_15925);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2099z00_15942;
																	obj_t BgL_arg2100z00_15943;

																	BgL_arg2099z00_15942 =
																		((long) CINT(BgL_bpz00_15922) + ((long) 2));
																	BgL_arg2100z00_15943 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13733),
																		BgL_arg2099z00_15942, BgL_arg2100z00_15943);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13730, STRUCT_REF(BgL_ufz00_15926,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15927));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13730, STRUCT_REF(BgL_ufz00_15926,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15927));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15944;

											BgL_z12denvz12_15944 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15944,
												BgL_locz00_13730);
											if ((((long) CINT(BgL_bpz00_15922) +
														(long) CINT(BgL_sfz00_15929)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13733))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15928;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15945;

													BgL_nsz00_15945 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2104z00_15946;

														BgL_arg2104z00_15946 =
															((long) CINT(BgL_bpz00_15922) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15945, ((long) 2), BgL_sz00_13733,
															BgL_bpz00_15922, BINT(BgL_arg2104z00_15946));
													}
													VECTOR_SET(BgL_nsz00_15945, ((long) 1),
														BgL_sz00_13733);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15944,
														BgL_nsz00_15945);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15947;

														BgL_ez00_15947 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15947, BgL_sz00_13733);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15948;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15949;

																BgL_savedzd2bpzd2_15949 =
																	VECTOR_REF(BgL_nsz00_15945, ((long) 0));
																VECTOR_SET(BgL_nsz00_15945, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15951;

																	BgL_fz00_15951 = BgL_runz00_15928;
																BgL_recz00_15950:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15952;

																		BgL_rz00_15952 =
																			PROCEDURE_ENTRY(BgL_fz00_15951)
																			(BgL_fz00_15951, BgL_nsz00_15945, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_21234;

																			if (PROCEDUREP(BgL_rz00_15952))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15953;

																					BgL_arg1696z00_15953 =
																						PROCEDURE_ATTR(BgL_rz00_15952);
																					if (STRUCTP(BgL_arg1696z00_15953))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_21234 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15953) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_21234 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_21234 = ((bool_t) 0);
																				}
																			if (BgL_testz00_21234)
																				{
																					obj_t BgL_fz00_21242;

																					BgL_fz00_21242 = BgL_rz00_15952;
																					BgL_fz00_15951 = BgL_fz00_21242;
																					goto BgL_recz00_15950;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15945,
																						((long) 0),
																						BgL_savedzd2bpzd2_15949);
																					BgL_____rz00_15948 = BgL_rz00_15952;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15947);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15944,
																BgL_sz00_13733);
															return BgL_____rz00_15948;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15923,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15954;

												BgL_nbpz00_15954 =
													((long) CINT(BgL_bpz00_15922) + BgL_siza7eza7_13732);
												VECTOR_SET(
													((obj_t) BgL_sz00_13733), ((long) 0),
													BINT(BgL_nbpz00_15954));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_21254;

													BgL_tmpz00_21254 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21254,
														BgL_locz00_13730);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15955;

													BgL_rz00_15955 =
														PROCEDURE_ENTRY(BgL_fz00_15923) (BgL_fz00_15923,
														BgL_a1z00_15924, BgL_a2z00_15925, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13733), ((long) 0),
														BgL_bpz00_15922);
													return BgL_rz00_15955;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13730,
													BgL_symbzd2funzd2_13731, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15923));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2110> */
	obj_t BGl_z62zc3anonymousza32110ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13734, obj_t BgL_sz00_13741)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13735;
				obj_t BgL_a1z00_13736;
				obj_t BgL_a2z00_13737;
				obj_t BgL_locz00_13738;
				obj_t BgL_symbzd2funzd2_13739;
				long BgL_siza7eza7_13740;

				BgL_funz00_13735 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 0)));
				BgL_a1z00_13736 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 1)));
				BgL_a2z00_13737 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 2)));
				BgL_locz00_13738 = PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 3)));
				BgL_symbzd2funzd2_13739 =
					PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 4)));
				BgL_siza7eza7_13740 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13734, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15956;

					BgL_bpz00_15956 = VECTOR_REF(((obj_t) BgL_sz00_13741), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15957;
						obj_t BgL_a1z00_15958;
						obj_t BgL_a2z00_15959;

						BgL_fz00_15957 =
							PROCEDURE_ENTRY(BgL_funz00_13735) (BgL_funz00_13735,
							BgL_sz00_13741, BEOA);
						BgL_a1z00_15958 =
							PROCEDURE_ENTRY(BgL_a1z00_13736) (BgL_a1z00_13736, BgL_sz00_13741,
							BEOA);
						BgL_a2z00_15959 =
							PROCEDURE_ENTRY(BgL_a2z00_13737) (BgL_a2z00_13737, BgL_sz00_13741,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15957))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13738,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15957);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15960;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21297;

								BgL_tmpz00_21297 = ((obj_t) BgL_fz00_15957);
								BgL_ufz00_15960 = PROCEDURE_ATTR(BgL_tmpz00_21297);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21300;

								if (STRUCTP(BgL_ufz00_15960))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21300 =
											(STRUCT_KEY(BgL_ufz00_15960) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21300 = ((bool_t) 0);
									}
								if (BgL_testz00_21300)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15961;
										obj_t BgL_runz00_15962;
										obj_t BgL_sfz00_15963;

										BgL_arityz00_15961 =
											STRUCT_REF(BgL_ufz00_15960, (int) (((long) 0)));
										BgL_runz00_15962 =
											STRUCT_REF(BgL_ufz00_15960, (int) (((long) 1)));
										BgL_sfz00_15963 =
											STRUCT_REF(BgL_ufz00_15960, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15961) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2114z00_15964;

													BgL_arg2114z00_15964 =
														((long) CINT(BgL_bpz00_15956) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13741), BgL_arg2114z00_15964,
														BgL_a1z00_15958);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2115z00_15965;

													BgL_arg2115z00_15965 =
														((long) CINT(BgL_bpz00_15956) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13741), BgL_arg2115z00_15965,
														BgL_a2z00_15959);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_15961))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_15961))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2117z00_15966;
																	obj_t BgL_arg2118z00_15967;

																	BgL_arg2117z00_15966 =
																		((long) CINT(BgL_bpz00_15956) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2119z00_15968;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2120z00_15969;

																			BgL_arg2120z00_15969 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15959, BNIL);
																			BgL_list2119z00_15968 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15958,
																				BgL_arg2120z00_15969);
																		}
																		BgL_arg2118z00_15967 =
																			BgL_list2119z00_15968;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13741),
																		BgL_arg2117z00_15966, BgL_arg2118z00_15967);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2121z00_15970;

																	BgL_arg2121z00_15970 =
																		((long) CINT(BgL_bpz00_15956) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13741),
																		BgL_arg2121z00_15970, BgL_a1z00_15958);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2122z00_15971;
																	obj_t BgL_arg2123z00_15972;

																	BgL_arg2122z00_15971 =
																		((long) CINT(BgL_bpz00_15956) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2124z00_15973;

																		BgL_list2124z00_15973 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15959, BNIL);
																		BgL_arg2123z00_15972 =
																			BgL_list2124z00_15973;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13741),
																		BgL_arg2122z00_15971, BgL_arg2123z00_15972);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2125z00_15974;

																	BgL_arg2125z00_15974 =
																		((long) CINT(BgL_bpz00_15956) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13741),
																		BgL_arg2125z00_15974, BgL_a1z00_15958);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2126z00_15975;

																	BgL_arg2126z00_15975 =
																		((long) CINT(BgL_bpz00_15956) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13741),
																		BgL_arg2126z00_15975, BgL_a2z00_15959);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2127z00_15976;
																	obj_t BgL_arg2128z00_15977;

																	BgL_arg2127z00_15976 =
																		((long) CINT(BgL_bpz00_15956) + ((long) 2));
																	BgL_arg2128z00_15977 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13741),
																		BgL_arg2127z00_15976, BgL_arg2128z00_15977);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13738, STRUCT_REF(BgL_ufz00_15960,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15961));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13738, STRUCT_REF(BgL_ufz00_15960,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15961));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_15978;

											BgL_z12denvz12_15978 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15956) +
														(long) CINT(BgL_sfz00_15963)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13741))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_15962;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_15979;

													BgL_nsz00_15979 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2133z00_15980;

														BgL_arg2133z00_15980 =
															((long) CINT(BgL_bpz00_15956) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15979, ((long) 2), BgL_sz00_13741,
															BgL_bpz00_15956, BINT(BgL_arg2133z00_15980));
													}
													VECTOR_SET(BgL_nsz00_15979, ((long) 1),
														BgL_sz00_13741);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15978,
														BgL_nsz00_15979);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_15981;

														BgL_ez00_15981 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15981, BgL_sz00_13741);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_15982;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_15983;

																BgL_savedzd2bpzd2_15983 =
																	VECTOR_REF(BgL_nsz00_15979, ((long) 0));
																VECTOR_SET(BgL_nsz00_15979, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15985;

																	BgL_fz00_15985 = BgL_runz00_15962;
																BgL_recz00_15984:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_15986;

																		BgL_rz00_15986 =
																			PROCEDURE_ENTRY(BgL_fz00_15985)
																			(BgL_fz00_15985, BgL_nsz00_15979, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_21387;

																			if (PROCEDUREP(BgL_rz00_15986))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_15987;

																					BgL_arg1696z00_15987 =
																						PROCEDURE_ATTR(BgL_rz00_15986);
																					if (STRUCTP(BgL_arg1696z00_15987))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_21387 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_15987) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_21387 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_21387 = ((bool_t) 0);
																				}
																			if (BgL_testz00_21387)
																				{
																					obj_t BgL_fz00_21395;

																					BgL_fz00_21395 = BgL_rz00_15986;
																					BgL_fz00_15985 = BgL_fz00_21395;
																					goto BgL_recz00_15984;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_15979,
																						((long) 0),
																						BgL_savedzd2bpzd2_15983);
																					BgL_____rz00_15982 = BgL_rz00_15986;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15981);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15978,
																BgL_sz00_13741);
															return BgL_____rz00_15982;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15957,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_15988;

												BgL_nbpz00_15988 =
													((long) CINT(BgL_bpz00_15956) + BgL_siza7eza7_13740);
												VECTOR_SET(
													((obj_t) BgL_sz00_13741), ((long) 0),
													BINT(BgL_nbpz00_15988));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_15989;

													BgL_rz00_15989 =
														PROCEDURE_ENTRY(BgL_fz00_15957) (BgL_fz00_15957,
														BgL_a1z00_15958, BgL_a2z00_15959, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13741), ((long) 0),
														BgL_bpz00_15956);
													return BgL_rz00_15989;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13738,
													BgL_symbzd2funzd2_13739, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15957));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2139> */
	obj_t BGl_z62zc3anonymousza32139ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13742, obj_t BgL_sz00_13749)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13743;
				obj_t BgL_a1z00_13744;
				obj_t BgL_a2z00_13745;
				obj_t BgL_locz00_13746;
				obj_t BgL_symbzd2funzd2_13747;
				long BgL_siza7eza7_13748;

				BgL_funz00_13743 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 0)));
				BgL_a1z00_13744 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 1)));
				BgL_a2z00_13745 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 2)));
				BgL_locz00_13746 = PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 3)));
				BgL_symbzd2funzd2_13747 =
					PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 4)));
				BgL_siza7eza7_13748 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13742, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_15990;

					BgL_bpz00_15990 = VECTOR_REF(((obj_t) BgL_sz00_13749), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_15991;
						obj_t BgL_a1z00_15992;
						obj_t BgL_a2z00_15993;

						BgL_fz00_15991 =
							PROCEDURE_ENTRY(BgL_funz00_13743) (BgL_funz00_13743,
							BgL_sz00_13749, BEOA);
						BgL_a1z00_15992 =
							PROCEDURE_ENTRY(BgL_a1z00_13744) (BgL_a1z00_13744, BgL_sz00_13749,
							BEOA);
						BgL_a2z00_15993 =
							PROCEDURE_ENTRY(BgL_a2z00_13745) (BgL_a2z00_13745, BgL_sz00_13749,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15991))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13746,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_15991);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_15994;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21447;

								BgL_tmpz00_21447 = ((obj_t) BgL_fz00_15991);
								BgL_ufz00_15994 = PROCEDURE_ATTR(BgL_tmpz00_21447);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21450;

								if (STRUCTP(BgL_ufz00_15994))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21450 =
											(STRUCT_KEY(BgL_ufz00_15994) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21450 = ((bool_t) 0);
									}
								if (BgL_testz00_21450)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_15995;
										obj_t BgL_runz00_15996;
										obj_t BgL_sfz00_15997;

										BgL_arityz00_15995 =
											STRUCT_REF(BgL_ufz00_15994, (int) (((long) 0)));
										BgL_runz00_15996 =
											STRUCT_REF(BgL_ufz00_15994, (int) (((long) 1)));
										BgL_sfz00_15997 =
											STRUCT_REF(BgL_ufz00_15994, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_15998;

											BgL_spz00_15998 =
												((long) CINT(BgL_bpz00_15990) + BgL_siza7eza7_13748);
											if (((long) CINT(BgL_arityz00_15995) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2143z00_15999;

														BgL_arg2143z00_15999 =
															(BgL_spz00_15998 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13749), BgL_arg2143z00_15999,
															BgL_a1z00_15992);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2144z00_16000;

														BgL_arg2144z00_16000 =
															(BgL_spz00_15998 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13749), BgL_arg2144z00_16000,
															BgL_a2z00_15993);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_15995))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_15995))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2147z00_16001;
																		obj_t BgL_arg2148z00_16002;

																		BgL_arg2147z00_16001 =
																			(BgL_spz00_15998 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2149z00_16003;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2150z00_16004;

																				BgL_arg2150z00_16004 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_15993,
																					BNIL);
																				BgL_list2149z00_16003 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_15992,
																					BgL_arg2150z00_16004);
																			}
																			BgL_arg2148z00_16002 =
																				BgL_list2149z00_16003;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2147z00_16001,
																			BgL_arg2148z00_16002);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2151z00_16005;

																		BgL_arg2151z00_16005 =
																			(BgL_spz00_15998 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2151z00_16005, BgL_a1z00_15992);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2152z00_16006;
																		obj_t BgL_arg2153z00_16007;

																		BgL_arg2152z00_16006 =
																			(BgL_spz00_15998 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2154z00_16008;

																			BgL_list2154z00_16008 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15993, BNIL);
																			BgL_arg2153z00_16007 =
																				BgL_list2154z00_16008;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2152z00_16006,
																			BgL_arg2153z00_16007);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2155z00_16009;

																		BgL_arg2155z00_16009 =
																			(BgL_spz00_15998 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2155z00_16009, BgL_a1z00_15992);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2156z00_16010;

																		BgL_arg2156z00_16010 =
																			(BgL_spz00_15998 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2156z00_16010, BgL_a2z00_15993);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2157z00_16011;
																		obj_t BgL_arg2158z00_16012;

																		BgL_arg2157z00_16011 =
																			(BgL_spz00_15998 + ((long) 2));
																		BgL_arg2158z00_16012 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13749),
																			BgL_arg2157z00_16011,
																			BgL_arg2158z00_16012);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13746,
																		STRUCT_REF(BgL_ufz00_15994,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_15995));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13746, STRUCT_REF(BgL_ufz00_15994,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_15995));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16013;

												BgL_z12denvz12_16013 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16013,
													BgL_locz00_13746);
												if (((BgL_spz00_15998 + (long) CINT(BgL_sfz00_15997)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13749))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15996, BgL_sz00_13749,
															BINT(BgL_spz00_15998));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16014;

														BgL_nsz00_16014 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2162z00_16015;

															BgL_arg2162z00_16015 =
																(BgL_spz00_15998 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16014, ((long) 2), BgL_sz00_13749,
																BINT(BgL_spz00_15998),
																BINT(BgL_arg2162z00_16015));
														}
														VECTOR_SET(BgL_nsz00_16014, ((long) 1),
															BgL_sz00_13749);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16013,
															BgL_nsz00_16014);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16016;

															BgL_ez00_16016 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16016, BgL_sz00_13749);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16017;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16018;

																	BgL_savedzd2bpzd2_16018 =
																		VECTOR_REF(BgL_nsz00_16014, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16014, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16020;

																		BgL_fz00_16020 = BgL_runz00_15996;
																	BgL_recz00_16019:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16021;

																			BgL_rz00_16021 =
																				PROCEDURE_ENTRY(BgL_fz00_16020)
																				(BgL_fz00_16020, BgL_nsz00_16014, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_21533;

																				if (PROCEDUREP(BgL_rz00_16021))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_16022;

																						BgL_arg1696z00_16022 =
																							PROCEDURE_ATTR(BgL_rz00_16021);
																						if (STRUCTP(BgL_arg1696z00_16022))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21533 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_16022) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21533 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_21533 = ((bool_t) 0);
																					}
																				if (BgL_testz00_21533)
																					{
																						obj_t BgL_fz00_21541;

																						BgL_fz00_21541 = BgL_rz00_16021;
																						BgL_fz00_16020 = BgL_fz00_21541;
																						goto BgL_recz00_16019;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16014,
																							((long) 0),
																							BgL_savedzd2bpzd2_16018);
																						BgL_____rz00_16017 = BgL_rz00_16021;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16016);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16013,
																	BgL_sz00_13749);
																return BgL_____rz00_16017;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15991,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16023;

												BgL_nbpz00_16023 =
													((long) CINT(BgL_bpz00_15990) + BgL_siza7eza7_13748);
												VECTOR_SET(
													((obj_t) BgL_sz00_13749), ((long) 0),
													BINT(BgL_nbpz00_16023));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_21553;

													BgL_tmpz00_21553 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21553,
														BgL_locz00_13746);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16024;

													BgL_rz00_16024 =
														PROCEDURE_ENTRY(BgL_fz00_15991) (BgL_fz00_15991,
														BgL_a1z00_15992, BgL_a2z00_15993, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13749), ((long) 0),
														BgL_bpz00_15990);
													return BgL_rz00_16024;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13746,
													BgL_symbzd2funzd2_13747, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15991));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2166> */
	obj_t BGl_z62zc3anonymousza32166ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13750, obj_t BgL_sz00_13757)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13751;
				obj_t BgL_a1z00_13752;
				obj_t BgL_a2z00_13753;
				obj_t BgL_locz00_13754;
				obj_t BgL_symbzd2funzd2_13755;
				long BgL_siza7eza7_13756;

				BgL_funz00_13751 = PROCEDURE_REF(BgL_envz00_13750, (int) (((long) 0)));
				BgL_a1z00_13752 = PROCEDURE_REF(BgL_envz00_13750, (int) (((long) 1)));
				BgL_a2z00_13753 = PROCEDURE_REF(BgL_envz00_13750, (int) (((long) 2)));
				BgL_locz00_13754 = PROCEDURE_REF(BgL_envz00_13750, (int) (((long) 3)));
				BgL_symbzd2funzd2_13755 =
					PROCEDURE_REF(BgL_envz00_13750, (int) (((long) 4)));
				BgL_siza7eza7_13756 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13750, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16025;

					BgL_bpz00_16025 = VECTOR_REF(((obj_t) BgL_sz00_13757), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16026;
						obj_t BgL_a1z00_16027;
						obj_t BgL_a2z00_16028;

						BgL_fz00_16026 =
							PROCEDURE_ENTRY(BgL_funz00_13751) (BgL_funz00_13751,
							BgL_sz00_13757, BEOA);
						BgL_a1z00_16027 =
							PROCEDURE_ENTRY(BgL_a1z00_13752) (BgL_a1z00_13752, BgL_sz00_13757,
							BEOA);
						BgL_a2z00_16028 =
							PROCEDURE_ENTRY(BgL_a2z00_13753) (BgL_a2z00_13753, BgL_sz00_13757,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16026))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13754,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16026);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16029;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21596;

								BgL_tmpz00_21596 = ((obj_t) BgL_fz00_16026);
								BgL_ufz00_16029 = PROCEDURE_ATTR(BgL_tmpz00_21596);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21599;

								if (STRUCTP(BgL_ufz00_16029))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21599 =
											(STRUCT_KEY(BgL_ufz00_16029) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21599 = ((bool_t) 0);
									}
								if (BgL_testz00_21599)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16030;
										obj_t BgL_runz00_16031;
										obj_t BgL_sfz00_16032;

										BgL_arityz00_16030 =
											STRUCT_REF(BgL_ufz00_16029, (int) (((long) 0)));
										BgL_runz00_16031 =
											STRUCT_REF(BgL_ufz00_16029, (int) (((long) 1)));
										BgL_sfz00_16032 =
											STRUCT_REF(BgL_ufz00_16029, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16033;

											BgL_spz00_16033 =
												((long) CINT(BgL_bpz00_16025) + BgL_siza7eza7_13756);
											if (((long) CINT(BgL_arityz00_16030) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2170z00_16034;

														BgL_arg2170z00_16034 =
															(BgL_spz00_16033 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13757), BgL_arg2170z00_16034,
															BgL_a1z00_16027);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2171z00_16035;

														BgL_arg2171z00_16035 =
															(BgL_spz00_16033 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13757), BgL_arg2171z00_16035,
															BgL_a2z00_16028);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16030))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16030))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2173z00_16036;
																		obj_t BgL_arg2174z00_16037;

																		BgL_arg2173z00_16036 =
																			(BgL_spz00_16033 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2175z00_16038;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2176z00_16039;

																				BgL_arg2176z00_16039 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16028,
																					BNIL);
																				BgL_list2175z00_16038 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16027,
																					BgL_arg2176z00_16039);
																			}
																			BgL_arg2174z00_16037 =
																				BgL_list2175z00_16038;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13757),
																			BgL_arg2173z00_16036,
																			BgL_arg2174z00_16037);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2177z00_16040;

																		BgL_arg2177z00_16040 =
																			(BgL_spz00_16033 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13757),
																			BgL_arg2177z00_16040, BgL_a1z00_16027);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2178z00_16041;
																		obj_t BgL_arg2179z00_16042;

																		BgL_arg2178z00_16041 =
																			(BgL_spz00_16033 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2180z00_16043;

																			BgL_list2180z00_16043 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16028, BNIL);
																			BgL_arg2179z00_16042 =
																				BgL_list2180z00_16043;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13757),
																			BgL_arg2178z00_16041,
																			BgL_arg2179z00_16042);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2181z00_16044;

																		BgL_arg2181z00_16044 =
																			(BgL_spz00_16033 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13757),
																			BgL_arg2181z00_16044, BgL_a1z00_16027);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2182z00_16045;

																		BgL_arg2182z00_16045 =
																			(BgL_spz00_16033 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13757),
																			BgL_arg2182z00_16045, BgL_a2z00_16028);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2183z00_16046;
																		obj_t BgL_arg2184z00_16047;

																		BgL_arg2183z00_16046 =
																			(BgL_spz00_16033 + ((long) 2));
																		BgL_arg2184z00_16047 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13757),
																			BgL_arg2183z00_16046,
																			BgL_arg2184z00_16047);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13754,
																		STRUCT_REF(BgL_ufz00_16029,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_16030));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13754, STRUCT_REF(BgL_ufz00_16029,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_16030));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16048;

												BgL_z12denvz12_16048 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16033 +
															(long) CINT(BgL_sfz00_16032)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13757))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16031, BgL_sz00_13757,
															BINT(BgL_spz00_16033));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16049;

														BgL_nsz00_16049 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2188z00_16050;

															BgL_arg2188z00_16050 =
																(BgL_spz00_16033 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16049, ((long) 2), BgL_sz00_13757,
																BINT(BgL_spz00_16033),
																BINT(BgL_arg2188z00_16050));
														}
														VECTOR_SET(BgL_nsz00_16049, ((long) 1),
															BgL_sz00_13757);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16048,
															BgL_nsz00_16049);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16051;

															BgL_ez00_16051 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16051, BgL_sz00_13757);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16052;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16053;

																	BgL_savedzd2bpzd2_16053 =
																		VECTOR_REF(BgL_nsz00_16049, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16049, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16055;

																		BgL_fz00_16055 = BgL_runz00_16031;
																	BgL_recz00_16054:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16056;

																			BgL_rz00_16056 =
																				PROCEDURE_ENTRY(BgL_fz00_16055)
																				(BgL_fz00_16055, BgL_nsz00_16049, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_21681;

																				if (PROCEDUREP(BgL_rz00_16056))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_16057;

																						BgL_arg1696z00_16057 =
																							PROCEDURE_ATTR(BgL_rz00_16056);
																						if (STRUCTP(BgL_arg1696z00_16057))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21681 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_16057) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_21681 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_21681 = ((bool_t) 0);
																					}
																				if (BgL_testz00_21681)
																					{
																						obj_t BgL_fz00_21689;

																						BgL_fz00_21689 = BgL_rz00_16056;
																						BgL_fz00_16055 = BgL_fz00_21689;
																						goto BgL_recz00_16054;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16049,
																							((long) 0),
																							BgL_savedzd2bpzd2_16053);
																						BgL_____rz00_16052 = BgL_rz00_16056;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16051);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16048,
																	BgL_sz00_13757);
																return BgL_____rz00_16052;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16026,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16058;

												BgL_nbpz00_16058 =
													((long) CINT(BgL_bpz00_16025) + BgL_siza7eza7_13756);
												VECTOR_SET(
													((obj_t) BgL_sz00_13757), ((long) 0),
													BINT(BgL_nbpz00_16058));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16059;

													BgL_rz00_16059 =
														PROCEDURE_ENTRY(BgL_fz00_16026) (BgL_fz00_16026,
														BgL_a1z00_16027, BgL_a2z00_16028, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13757), ((long) 0),
														BgL_bpz00_16025);
													return BgL_rz00_16059;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13754,
													BgL_symbzd2funzd2_13755, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_16026));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2481;

				BgL_cfunz00_2481 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_2481))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_21714;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2198z00_2501;

							BgL_arg2198z00_2501 = bgl_debug();
							BgL_testz00_21714 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2198z00_2501),
								BINT(((long) 0)));
						}
						if (BgL_testz00_21714)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32194ze3z83_13758;

								BgL_zc3anonymousza32194ze3z83_13758 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32194ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3anonymousza32194ze3z83_13758,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3anonymousza32194ze3z83_13758,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3anonymousza32194ze3z83_13758,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3anonymousza32194ze3z83_13758,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3anonymousza32194ze3z83_13758,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3anonymousza32194ze3z83_13758,
									(int) (((long) 5)), BgL_cfunz00_2481);
								return BgL_zc3anonymousza32194ze3z83_13758;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32197ze3z83_13759;

								BgL_zc3anonymousza32197ze3z83_13759 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32197ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza32197ze3z83_13759,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3anonymousza32197ze3z83_13759,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3anonymousza32197ze3z83_13759,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3anonymousza32197ze3z83_13759,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3anonymousza32197ze3z83_13759,
									(int) (((long) 4)), BgL_cfunz00_2481);
								return BgL_zc3anonymousza32197ze3z83_13759;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21751;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2275z00_2613;

									BgL_arg2275z00_2613 = bgl_debug();
									BgL_testz00_21751 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2275z00_2613),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21751)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32201ze3z83_13760;

										BgL_zc3anonymousza32201ze3z83_13760 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32201ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32201ze3z83_13760,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32201ze3z83_13760;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32238ze3z83_13761;

										BgL_zc3anonymousza32238ze3z83_13761 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32238ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32238ze3z83_13761,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32238ze3z83_13761;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21792;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2350z00_2725;

									BgL_arg2350z00_2725 = bgl_debug();
									BgL_testz00_21792 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2350z00_2725),
										BINT(((long) 0)));
								}
								if (BgL_testz00_21792)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32278ze3z83_13762;

										BgL_zc3anonymousza32278ze3z83_13762 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32278ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32278ze3z83_13762,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32278ze3z83_13762;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32315ze3z83_13763;

										BgL_zc3anonymousza32315ze3z83_13763 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32315ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3anonymousza32315ze3z83_13763,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3anonymousza32315ze3z83_13763;
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2194> */
	obj_t BGl_z62zc3anonymousza32194ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13764, obj_t BgL_sz00_13771)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13765;
				obj_t BgL_a2z00_13766;
				obj_t BgL_a3z00_13767;
				long BgL_siza7eza7_13768;
				obj_t BgL_locz00_13769;
				obj_t BgL_cfunz00_13770;

				BgL_a1z00_13765 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 0)));
				BgL_a2z00_13766 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 1)));
				BgL_a3z00_13767 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 2)));
				BgL_siza7eza7_13768 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 3))));
				BgL_locz00_13769 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 4)));
				BgL_cfunz00_13770 = PROCEDURE_REF(BgL_envz00_13764, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16060;

					BgL_bpz00_16060 = VECTOR_REF(((obj_t) BgL_sz00_13771), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16061;
						obj_t BgL_a2z00_16062;
						obj_t BgL_a3z00_16063;

						BgL_a1z00_16061 =
							PROCEDURE_ENTRY(BgL_a1z00_13765) (BgL_a1z00_13765, BgL_sz00_13771,
							BEOA);
						BgL_a2z00_16062 =
							PROCEDURE_ENTRY(BgL_a2z00_13766) (BgL_a2z00_13766, BgL_sz00_13771,
							BEOA);
						BgL_a3z00_16063 =
							PROCEDURE_ENTRY(BgL_a3z00_13767) (BgL_a3z00_13767, BgL_sz00_13771,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16064;

							BgL_nbpz00_16064 =
								((long) CINT(BgL_bpz00_16060) + BgL_siza7eza7_13768);
							VECTOR_SET(
								((obj_t) BgL_sz00_13771), ((long) 0), BINT(BgL_nbpz00_16064));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21865;

								BgL_tmpz00_21865 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21865, BgL_locz00_13769);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16065;

								BgL_rz00_16065 =
									PROCEDURE_ENTRY(BgL_cfunz00_13770) (BgL_cfunz00_13770,
									BgL_a1z00_16061, BgL_a2z00_16062, BgL_a3z00_16063, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13771), ((long) 0),
									BgL_bpz00_16060);
								return BgL_rz00_16065;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2197> */
	obj_t BGl_z62zc3anonymousza32197ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13772, obj_t BgL_sz00_13778)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13773;
				obj_t BgL_a2z00_13774;
				obj_t BgL_a3z00_13775;
				long BgL_siza7eza7_13776;
				obj_t BgL_cfunz00_13777;

				BgL_a1z00_13773 = PROCEDURE_REF(BgL_envz00_13772, (int) (((long) 0)));
				BgL_a2z00_13774 = PROCEDURE_REF(BgL_envz00_13772, (int) (((long) 1)));
				BgL_a3z00_13775 = PROCEDURE_REF(BgL_envz00_13772, (int) (((long) 2)));
				BgL_siza7eza7_13776 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13772, (int) (((long) 3))));
				BgL_cfunz00_13777 = PROCEDURE_REF(BgL_envz00_13772, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16066;

					BgL_bpz00_16066 = VECTOR_REF(((obj_t) BgL_sz00_13778), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16067;
						obj_t BgL_a2z00_16068;
						obj_t BgL_a3z00_16069;

						BgL_a1z00_16067 =
							PROCEDURE_ENTRY(BgL_a1z00_13773) (BgL_a1z00_13773, BgL_sz00_13778,
							BEOA);
						BgL_a2z00_16068 =
							PROCEDURE_ENTRY(BgL_a2z00_13774) (BgL_a2z00_13774, BgL_sz00_13778,
							BEOA);
						BgL_a3z00_16069 =
							PROCEDURE_ENTRY(BgL_a3z00_13775) (BgL_a3z00_13775, BgL_sz00_13778,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16070;

							BgL_nbpz00_16070 =
								((long) CINT(BgL_bpz00_16066) + BgL_siza7eza7_13776);
							VECTOR_SET(
								((obj_t) BgL_sz00_13778), ((long) 0), BINT(BgL_nbpz00_16070));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16071;

								BgL_rz00_16071 =
									PROCEDURE_ENTRY(BgL_cfunz00_13777) (BgL_cfunz00_13777,
									BgL_a1z00_16067, BgL_a2z00_16068, BgL_a3z00_16069, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13778), ((long) 0),
									BgL_bpz00_16066);
								return BgL_rz00_16071;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2201> */
	obj_t BGl_z62zc3anonymousza32201ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13779, obj_t BgL_sz00_13787)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13780;
				obj_t BgL_a1z00_13781;
				obj_t BgL_a2z00_13782;
				obj_t BgL_a3z00_13783;
				obj_t BgL_locz00_13784;
				obj_t BgL_symbzd2funzd2_13785;
				long BgL_siza7eza7_13786;

				BgL_funz00_13780 = PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 0)));
				BgL_a1z00_13781 = PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 1)));
				BgL_a2z00_13782 = PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 2)));
				BgL_a3z00_13783 = PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 3)));
				BgL_locz00_13784 = PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 4)));
				BgL_symbzd2funzd2_13785 =
					PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 5)));
				BgL_siza7eza7_13786 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13779, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16072;

					BgL_bpz00_16072 = VECTOR_REF(((obj_t) BgL_sz00_13787), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16073;
						obj_t BgL_a1z00_16074;
						obj_t BgL_a2z00_16075;
						obj_t BgL_a3z00_16076;

						BgL_fz00_16073 =
							PROCEDURE_ENTRY(BgL_funz00_13780) (BgL_funz00_13780,
							BgL_sz00_13787, BEOA);
						BgL_a1z00_16074 =
							PROCEDURE_ENTRY(BgL_a1z00_13781) (BgL_a1z00_13781, BgL_sz00_13787,
							BEOA);
						BgL_a2z00_16075 =
							PROCEDURE_ENTRY(BgL_a2z00_13782) (BgL_a2z00_13782, BgL_sz00_13787,
							BEOA);
						BgL_a3z00_16076 =
							PROCEDURE_ENTRY(BgL_a3z00_13783) (BgL_a3z00_13783, BgL_sz00_13787,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16073))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13784,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16073);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16077;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_21950;

								BgL_tmpz00_21950 = ((obj_t) BgL_fz00_16073);
								BgL_ufz00_16077 = PROCEDURE_ATTR(BgL_tmpz00_21950);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_21953;

								if (STRUCTP(BgL_ufz00_16077))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21953 =
											(STRUCT_KEY(BgL_ufz00_16077) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_21953 = ((bool_t) 0);
									}
								if (BgL_testz00_21953)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16078;
										obj_t BgL_runz00_16079;
										obj_t BgL_sfz00_16080;

										BgL_arityz00_16078 =
											STRUCT_REF(BgL_ufz00_16077, (int) (((long) 0)));
										BgL_runz00_16079 =
											STRUCT_REF(BgL_ufz00_16077, (int) (((long) 1)));
										BgL_sfz00_16080 =
											STRUCT_REF(BgL_ufz00_16077, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16078) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2205z00_16081;

													BgL_arg2205z00_16081 =
														((long) CINT(BgL_bpz00_16072) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13787), BgL_arg2205z00_16081,
														BgL_a1z00_16074);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2206z00_16082;

													BgL_arg2206z00_16082 =
														((long) CINT(BgL_bpz00_16072) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13787), BgL_arg2206z00_16082,
														BgL_a2z00_16075);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2207z00_16083;

													BgL_arg2207z00_16083 =
														((long) CINT(BgL_bpz00_16072) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13787), BgL_arg2207z00_16083,
														BgL_a3z00_16076);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16078))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16078))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2209z00_16084;
																	obj_t BgL_arg2210z00_16085;

																	BgL_arg2209z00_16084 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2211z00_16086;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2212z00_16087;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2213z00_16088;

																				BgL_arg2213z00_16088 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16076,
																					BNIL);
																				BgL_arg2212z00_16087 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16075,
																					BgL_arg2213z00_16088);
																			}
																			BgL_list2211z00_16086 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16074,
																				BgL_arg2212z00_16087);
																		}
																		BgL_arg2210z00_16085 =
																			BgL_list2211z00_16086;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2209z00_16084, BgL_arg2210z00_16085);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2214z00_16089;

																	BgL_arg2214z00_16089 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2214z00_16089, BgL_a1z00_16074);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2215z00_16090;
																	obj_t BgL_arg2216z00_16091;

																	BgL_arg2215z00_16090 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2217z00_16092;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2218z00_16093;

																			BgL_arg2218z00_16093 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16076, BNIL);
																			BgL_list2217z00_16092 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16075,
																				BgL_arg2218z00_16093);
																		}
																		BgL_arg2216z00_16091 =
																			BgL_list2217z00_16092;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2215z00_16090, BgL_arg2216z00_16091);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2219z00_16094;

																	BgL_arg2219z00_16094 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2219z00_16094, BgL_a1z00_16074);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2220z00_16095;

																	BgL_arg2220z00_16095 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2220z00_16095, BgL_a2z00_16075);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2222z00_16096;
																	obj_t BgL_arg2223z00_16097;

																	BgL_arg2222z00_16096 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2224z00_16098;

																		BgL_list2224z00_16098 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16076, BNIL);
																		BgL_arg2223z00_16097 =
																			BgL_list2224z00_16098;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2222z00_16096, BgL_arg2223z00_16097);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2225z00_16099;

																	BgL_arg2225z00_16099 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2225z00_16099, BgL_a1z00_16074);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2226z00_16100;

																	BgL_arg2226z00_16100 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2226z00_16100, BgL_a2z00_16075);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2227z00_16101;

																	BgL_arg2227z00_16101 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2227z00_16101, BgL_a3z00_16076);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2228z00_16102;
																	obj_t BgL_arg2229z00_16103;

																	BgL_arg2228z00_16102 =
																		((long) CINT(BgL_bpz00_16072) + ((long) 3));
																	BgL_arg2229z00_16103 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13787),
																		BgL_arg2228z00_16102, BgL_arg2229z00_16103);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13784, STRUCT_REF(BgL_ufz00_16077,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16078));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13784, STRUCT_REF(BgL_ufz00_16077,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16078));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16104;

											BgL_z12denvz12_16104 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16104,
												BgL_locz00_13784);
											if ((((long) CINT(BgL_bpz00_16072) +
														(long) CINT(BgL_sfz00_16080)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13787))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16079;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16105;

													BgL_nsz00_16105 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2234z00_16106;

														BgL_arg2234z00_16106 =
															((long) CINT(BgL_bpz00_16072) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16105, ((long) 2), BgL_sz00_13787,
															BgL_bpz00_16072, BINT(BgL_arg2234z00_16106));
													}
													VECTOR_SET(BgL_nsz00_16105, ((long) 1),
														BgL_sz00_13787);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16104,
														BgL_nsz00_16105);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16107;

														BgL_ez00_16107 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16107, BgL_sz00_13787);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16108;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16109;

																BgL_savedzd2bpzd2_16109 =
																	VECTOR_REF(BgL_nsz00_16105, ((long) 0));
																VECTOR_SET(BgL_nsz00_16105, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16111;

																	BgL_fz00_16111 = BgL_runz00_16079;
																BgL_recz00_16110:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16112;

																		BgL_rz00_16112 =
																			PROCEDURE_ENTRY(BgL_fz00_16111)
																			(BgL_fz00_16111, BgL_nsz00_16105, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_22064;

																			if (PROCEDUREP(BgL_rz00_16112))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_16113;

																					BgL_arg1696z00_16113 =
																						PROCEDURE_ATTR(BgL_rz00_16112);
																					if (STRUCTP(BgL_arg1696z00_16113))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_22064 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_16113) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_22064 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_22064 = ((bool_t) 0);
																				}
																			if (BgL_testz00_22064)
																				{
																					obj_t BgL_fz00_22072;

																					BgL_fz00_22072 = BgL_rz00_16112;
																					BgL_fz00_16111 = BgL_fz00_22072;
																					goto BgL_recz00_16110;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16105,
																						((long) 0),
																						BgL_savedzd2bpzd2_16109);
																					BgL_____rz00_16108 = BgL_rz00_16112;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16107);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16104,
																BgL_sz00_13787);
															return BgL_____rz00_16108;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16073,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16114;

												BgL_nbpz00_16114 =
													((long) CINT(BgL_bpz00_16072) + BgL_siza7eza7_13786);
												VECTOR_SET(
													((obj_t) BgL_sz00_13787), ((long) 0),
													BINT(BgL_nbpz00_16114));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_22084;

													BgL_tmpz00_22084 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22084,
														BgL_locz00_13784);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16115;

													BgL_rz00_16115 =
														PROCEDURE_ENTRY(BgL_fz00_16073) (BgL_fz00_16073,
														BgL_a1z00_16074, BgL_a2z00_16075, BgL_a3z00_16076,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13787), ((long) 0),
														BgL_bpz00_16072);
													return BgL_rz00_16115;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13784,
													BgL_symbzd2funzd2_13785, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16073));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2238> */
	obj_t BGl_z62zc3anonymousza32238ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13788, obj_t BgL_sz00_13796)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13789;
				obj_t BgL_a1z00_13790;
				obj_t BgL_a2z00_13791;
				obj_t BgL_a3z00_13792;
				obj_t BgL_locz00_13793;
				obj_t BgL_symbzd2funzd2_13794;
				long BgL_siza7eza7_13795;

				BgL_funz00_13789 = PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 0)));
				BgL_a1z00_13790 = PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 1)));
				BgL_a2z00_13791 = PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 2)));
				BgL_a3z00_13792 = PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 3)));
				BgL_locz00_13793 = PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 4)));
				BgL_symbzd2funzd2_13794 =
					PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 5)));
				BgL_siza7eza7_13795 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13788, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16116;

					BgL_bpz00_16116 = VECTOR_REF(((obj_t) BgL_sz00_13796), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16117;
						obj_t BgL_a1z00_16118;
						obj_t BgL_a2z00_16119;
						obj_t BgL_a3z00_16120;

						BgL_fz00_16117 =
							PROCEDURE_ENTRY(BgL_funz00_13789) (BgL_funz00_13789,
							BgL_sz00_13796, BEOA);
						BgL_a1z00_16118 =
							PROCEDURE_ENTRY(BgL_a1z00_13790) (BgL_a1z00_13790, BgL_sz00_13796,
							BEOA);
						BgL_a2z00_16119 =
							PROCEDURE_ENTRY(BgL_a2z00_13791) (BgL_a2z00_13791, BgL_sz00_13796,
							BEOA);
						BgL_a3z00_16120 =
							PROCEDURE_ENTRY(BgL_a3z00_13792) (BgL_a3z00_13792, BgL_sz00_13796,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16117))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13793,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16117);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16121;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22134;

								BgL_tmpz00_22134 = ((obj_t) BgL_fz00_16117);
								BgL_ufz00_16121 = PROCEDURE_ATTR(BgL_tmpz00_22134);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22137;

								if (STRUCTP(BgL_ufz00_16121))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22137 =
											(STRUCT_KEY(BgL_ufz00_16121) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22137 = ((bool_t) 0);
									}
								if (BgL_testz00_22137)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16122;
										obj_t BgL_runz00_16123;
										obj_t BgL_sfz00_16124;

										BgL_arityz00_16122 =
											STRUCT_REF(BgL_ufz00_16121, (int) (((long) 0)));
										BgL_runz00_16123 =
											STRUCT_REF(BgL_ufz00_16121, (int) (((long) 1)));
										BgL_sfz00_16124 =
											STRUCT_REF(BgL_ufz00_16121, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16122) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2242z00_16125;

													BgL_arg2242z00_16125 =
														((long) CINT(BgL_bpz00_16116) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13796), BgL_arg2242z00_16125,
														BgL_a1z00_16118);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2243z00_16126;

													BgL_arg2243z00_16126 =
														((long) CINT(BgL_bpz00_16116) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13796), BgL_arg2243z00_16126,
														BgL_a2z00_16119);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2244z00_16127;

													BgL_arg2244z00_16127 =
														((long) CINT(BgL_bpz00_16116) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13796), BgL_arg2244z00_16127,
														BgL_a3z00_16120);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16122))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16122))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2246z00_16128;
																	obj_t BgL_arg2247z00_16129;

																	BgL_arg2246z00_16128 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2248z00_16130;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2250z00_16131;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2251z00_16132;

																				BgL_arg2251z00_16132 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16120,
																					BNIL);
																				BgL_arg2250z00_16131 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16119,
																					BgL_arg2251z00_16132);
																			}
																			BgL_list2248z00_16130 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16118,
																				BgL_arg2250z00_16131);
																		}
																		BgL_arg2247z00_16129 =
																			BgL_list2248z00_16130;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2246z00_16128, BgL_arg2247z00_16129);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2252z00_16133;

																	BgL_arg2252z00_16133 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2252z00_16133, BgL_a1z00_16118);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2253z00_16134;
																	obj_t BgL_arg2254z00_16135;

																	BgL_arg2253z00_16134 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2255z00_16136;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2256z00_16137;

																			BgL_arg2256z00_16137 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16120, BNIL);
																			BgL_list2255z00_16136 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16119,
																				BgL_arg2256z00_16137);
																		}
																		BgL_arg2254z00_16135 =
																			BgL_list2255z00_16136;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2253z00_16134, BgL_arg2254z00_16135);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2257z00_16138;

																	BgL_arg2257z00_16138 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2257z00_16138, BgL_a1z00_16118);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2258z00_16139;

																	BgL_arg2258z00_16139 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2258z00_16139, BgL_a2z00_16119);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2259z00_16140;
																	obj_t BgL_arg2260z00_16141;

																	BgL_arg2259z00_16140 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2261z00_16142;

																		BgL_list2261z00_16142 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16120, BNIL);
																		BgL_arg2260z00_16141 =
																			BgL_list2261z00_16142;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2259z00_16140, BgL_arg2260z00_16141);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2262z00_16143;

																	BgL_arg2262z00_16143 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2262z00_16143, BgL_a1z00_16118);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2263z00_16144;

																	BgL_arg2263z00_16144 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2263z00_16144, BgL_a2z00_16119);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2264z00_16145;

																	BgL_arg2264z00_16145 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2264z00_16145, BgL_a3z00_16120);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2266z00_16146;
																	obj_t BgL_arg2267z00_16147;

																	BgL_arg2266z00_16146 =
																		((long) CINT(BgL_bpz00_16116) + ((long) 3));
																	BgL_arg2267z00_16147 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13796),
																		BgL_arg2266z00_16146, BgL_arg2267z00_16147);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13793, STRUCT_REF(BgL_ufz00_16121,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16122));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13793, STRUCT_REF(BgL_ufz00_16121,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16122));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16148;

											BgL_z12denvz12_16148 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16116) +
														(long) CINT(BgL_sfz00_16124)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13796))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16123;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16149;

													BgL_nsz00_16149 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2272z00_16150;

														BgL_arg2272z00_16150 =
															((long) CINT(BgL_bpz00_16116) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16149, ((long) 2), BgL_sz00_13796,
															BgL_bpz00_16116, BINT(BgL_arg2272z00_16150));
													}
													VECTOR_SET(BgL_nsz00_16149, ((long) 1),
														BgL_sz00_13796);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16148,
														BgL_nsz00_16149);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16151;

														BgL_ez00_16151 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16151, BgL_sz00_13796);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16152;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16153;

																BgL_savedzd2bpzd2_16153 =
																	VECTOR_REF(BgL_nsz00_16149, ((long) 0));
																VECTOR_SET(BgL_nsz00_16149, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16155;

																	BgL_fz00_16155 = BgL_runz00_16123;
																BgL_recz00_16154:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16156;

																		BgL_rz00_16156 =
																			PROCEDURE_ENTRY(BgL_fz00_16155)
																			(BgL_fz00_16155, BgL_nsz00_16149, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_22247;

																			if (PROCEDUREP(BgL_rz00_16156))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_16157;

																					BgL_arg1696z00_16157 =
																						PROCEDURE_ATTR(BgL_rz00_16156);
																					if (STRUCTP(BgL_arg1696z00_16157))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_22247 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_16157) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_22247 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_22247 = ((bool_t) 0);
																				}
																			if (BgL_testz00_22247)
																				{
																					obj_t BgL_fz00_22255;

																					BgL_fz00_22255 = BgL_rz00_16156;
																					BgL_fz00_16155 = BgL_fz00_22255;
																					goto BgL_recz00_16154;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16149,
																						((long) 0),
																						BgL_savedzd2bpzd2_16153);
																					BgL_____rz00_16152 = BgL_rz00_16156;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16151);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16148,
																BgL_sz00_13796);
															return BgL_____rz00_16152;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16117,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16158;

												BgL_nbpz00_16158 =
													((long) CINT(BgL_bpz00_16116) + BgL_siza7eza7_13795);
												VECTOR_SET(
													((obj_t) BgL_sz00_13796), ((long) 0),
													BINT(BgL_nbpz00_16158));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16159;

													BgL_rz00_16159 =
														PROCEDURE_ENTRY(BgL_fz00_16117) (BgL_fz00_16117,
														BgL_a1z00_16118, BgL_a2z00_16119, BgL_a3z00_16120,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13796), ((long) 0),
														BgL_bpz00_16116);
													return BgL_rz00_16159;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13793,
													BgL_symbzd2funzd2_13794, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16117));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2278> */
	obj_t BGl_z62zc3anonymousza32278ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13797, obj_t BgL_sz00_13805)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13798;
				obj_t BgL_a1z00_13799;
				obj_t BgL_a2z00_13800;
				obj_t BgL_a3z00_13801;
				obj_t BgL_locz00_13802;
				obj_t BgL_symbzd2funzd2_13803;
				long BgL_siza7eza7_13804;

				BgL_funz00_13798 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 0)));
				BgL_a1z00_13799 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 1)));
				BgL_a2z00_13800 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 2)));
				BgL_a3z00_13801 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 3)));
				BgL_locz00_13802 = PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 4)));
				BgL_symbzd2funzd2_13803 =
					PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 5)));
				BgL_siza7eza7_13804 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13797, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16160;

					BgL_bpz00_16160 = VECTOR_REF(((obj_t) BgL_sz00_13805), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16161;
						obj_t BgL_a1z00_16162;
						obj_t BgL_a2z00_16163;
						obj_t BgL_a3z00_16164;

						BgL_fz00_16161 =
							PROCEDURE_ENTRY(BgL_funz00_13798) (BgL_funz00_13798,
							BgL_sz00_13805, BEOA);
						BgL_a1z00_16162 =
							PROCEDURE_ENTRY(BgL_a1z00_13799) (BgL_a1z00_13799, BgL_sz00_13805,
							BEOA);
						BgL_a2z00_16163 =
							PROCEDURE_ENTRY(BgL_a2z00_13800) (BgL_a2z00_13800, BgL_sz00_13805,
							BEOA);
						BgL_a3z00_16164 =
							PROCEDURE_ENTRY(BgL_a3z00_13801) (BgL_a3z00_13801, BgL_sz00_13805,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16161))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13802,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16161);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16165;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22314;

								BgL_tmpz00_22314 = ((obj_t) BgL_fz00_16161);
								BgL_ufz00_16165 = PROCEDURE_ATTR(BgL_tmpz00_22314);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22317;

								if (STRUCTP(BgL_ufz00_16165))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22317 =
											(STRUCT_KEY(BgL_ufz00_16165) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22317 = ((bool_t) 0);
									}
								if (BgL_testz00_22317)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16166;
										obj_t BgL_runz00_16167;
										obj_t BgL_sfz00_16168;

										BgL_arityz00_16166 =
											STRUCT_REF(BgL_ufz00_16165, (int) (((long) 0)));
										BgL_runz00_16167 =
											STRUCT_REF(BgL_ufz00_16165, (int) (((long) 1)));
										BgL_sfz00_16168 =
											STRUCT_REF(BgL_ufz00_16165, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16169;

											BgL_spz00_16169 =
												((long) CINT(BgL_bpz00_16160) + BgL_siza7eza7_13804);
											if (((long) CINT(BgL_arityz00_16166) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2282z00_16170;

														BgL_arg2282z00_16170 =
															(BgL_spz00_16169 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13805), BgL_arg2282z00_16170,
															BgL_a1z00_16162);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2283z00_16171;

														BgL_arg2283z00_16171 =
															(BgL_spz00_16169 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13805), BgL_arg2283z00_16171,
															BgL_a2z00_16163);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2284z00_16172;

														BgL_arg2284z00_16172 =
															(BgL_spz00_16169 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13805), BgL_arg2284z00_16172,
															BgL_a3z00_16164);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16166))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16166))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2286z00_16173;
																		obj_t BgL_arg2287z00_16174;

																		BgL_arg2286z00_16173 =
																			(BgL_spz00_16169 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2288z00_16175;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2289z00_16176;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2290z00_16177;

																					BgL_arg2290z00_16177 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16164,
																						BNIL);
																					BgL_arg2289z00_16176 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16163,
																						BgL_arg2290z00_16177);
																				}
																				BgL_list2288z00_16175 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16162,
																					BgL_arg2289z00_16176);
																			}
																			BgL_arg2287z00_16174 =
																				BgL_list2288z00_16175;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2286z00_16173,
																			BgL_arg2287z00_16174);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2291z00_16178;

																		BgL_arg2291z00_16178 =
																			(BgL_spz00_16169 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2291z00_16178, BgL_a1z00_16162);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2292z00_16179;
																		obj_t BgL_arg2293z00_16180;

																		BgL_arg2292z00_16179 =
																			(BgL_spz00_16169 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2294z00_16181;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2295z00_16182;

																				BgL_arg2295z00_16182 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16164,
																					BNIL);
																				BgL_list2294z00_16181 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16163,
																					BgL_arg2295z00_16182);
																			}
																			BgL_arg2293z00_16180 =
																				BgL_list2294z00_16181;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2292z00_16179,
																			BgL_arg2293z00_16180);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2296z00_16183;

																		BgL_arg2296z00_16183 =
																			(BgL_spz00_16169 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2296z00_16183, BgL_a1z00_16162);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2299z00_16184;

																		BgL_arg2299z00_16184 =
																			(BgL_spz00_16169 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2299z00_16184, BgL_a2z00_16163);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2300z00_16185;
																		obj_t BgL_arg2301z00_16186;

																		BgL_arg2300z00_16185 =
																			(BgL_spz00_16169 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2302z00_16187;

																			BgL_list2302z00_16187 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16164, BNIL);
																			BgL_arg2301z00_16186 =
																				BgL_list2302z00_16187;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2300z00_16185,
																			BgL_arg2301z00_16186);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2303z00_16188;

																		BgL_arg2303z00_16188 =
																			(BgL_spz00_16169 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2303z00_16188, BgL_a1z00_16162);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2304z00_16189;

																		BgL_arg2304z00_16189 =
																			(BgL_spz00_16169 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2304z00_16189, BgL_a2z00_16163);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2305z00_16190;

																		BgL_arg2305z00_16190 =
																			(BgL_spz00_16169 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2305z00_16190, BgL_a3z00_16164);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2306z00_16191;
																		obj_t BgL_arg2307z00_16192;

																		BgL_arg2306z00_16191 =
																			(BgL_spz00_16169 + ((long) 3));
																		BgL_arg2307z00_16192 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13805),
																			BgL_arg2306z00_16191,
																			BgL_arg2307z00_16192);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13802,
																		STRUCT_REF(BgL_ufz00_16165,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16166));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13802, STRUCT_REF(BgL_ufz00_16165,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16166));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16193;

												BgL_z12denvz12_16193 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16193,
													BgL_locz00_13802);
												if (((BgL_spz00_16169 + (long) CINT(BgL_sfz00_16168)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13805))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16167, BgL_sz00_13805,
															BINT(BgL_spz00_16169));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16194;

														BgL_nsz00_16194 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2311z00_16195;

															BgL_arg2311z00_16195 =
																(BgL_spz00_16169 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16194, ((long) 2), BgL_sz00_13805,
																BINT(BgL_spz00_16169),
																BINT(BgL_arg2311z00_16195));
														}
														VECTOR_SET(BgL_nsz00_16194, ((long) 1),
															BgL_sz00_13805);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16193,
															BgL_nsz00_16194);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16196;

															BgL_ez00_16196 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16196, BgL_sz00_13805);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16197;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16198;

																	BgL_savedzd2bpzd2_16198 =
																		VECTOR_REF(BgL_nsz00_16194, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16194, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16200;

																		BgL_fz00_16200 = BgL_runz00_16167;
																	BgL_recz00_16199:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16201;

																			BgL_rz00_16201 =
																				PROCEDURE_ENTRY(BgL_fz00_16200)
																				(BgL_fz00_16200, BgL_nsz00_16194, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_22418;

																				if (PROCEDUREP(BgL_rz00_16201))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_16202;

																						BgL_arg1696z00_16202 =
																							PROCEDURE_ATTR(BgL_rz00_16201);
																						if (STRUCTP(BgL_arg1696z00_16202))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22418 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_16202) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22418 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_22418 = ((bool_t) 0);
																					}
																				if (BgL_testz00_22418)
																					{
																						obj_t BgL_fz00_22426;

																						BgL_fz00_22426 = BgL_rz00_16201;
																						BgL_fz00_16200 = BgL_fz00_22426;
																						goto BgL_recz00_16199;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16194,
																							((long) 0),
																							BgL_savedzd2bpzd2_16198);
																						BgL_____rz00_16197 = BgL_rz00_16201;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16196);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16193,
																	BgL_sz00_13805);
																return BgL_____rz00_16197;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16161,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16203;

												BgL_nbpz00_16203 =
													((long) CINT(BgL_bpz00_16160) + BgL_siza7eza7_13804);
												VECTOR_SET(
													((obj_t) BgL_sz00_13805), ((long) 0),
													BINT(BgL_nbpz00_16203));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_22438;

													BgL_tmpz00_22438 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22438,
														BgL_locz00_13802);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16204;

													BgL_rz00_16204 =
														PROCEDURE_ENTRY(BgL_fz00_16161) (BgL_fz00_16161,
														BgL_a1z00_16162, BgL_a2z00_16163, BgL_a3z00_16164,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13805), ((long) 0),
														BgL_bpz00_16160);
													return BgL_rz00_16204;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13802,
													BgL_symbzd2funzd2_13803, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16161));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2315> */
	obj_t BGl_z62zc3anonymousza32315ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13806, obj_t BgL_sz00_13814)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13807;
				obj_t BgL_a1z00_13808;
				obj_t BgL_a2z00_13809;
				obj_t BgL_a3z00_13810;
				obj_t BgL_locz00_13811;
				obj_t BgL_symbzd2funzd2_13812;
				long BgL_siza7eza7_13813;

				BgL_funz00_13807 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 0)));
				BgL_a1z00_13808 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 1)));
				BgL_a2z00_13809 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 2)));
				BgL_a3z00_13810 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 3)));
				BgL_locz00_13811 = PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 4)));
				BgL_symbzd2funzd2_13812 =
					PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 5)));
				BgL_siza7eza7_13813 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13806, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16205;

					BgL_bpz00_16205 = VECTOR_REF(((obj_t) BgL_sz00_13814), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16206;
						obj_t BgL_a1z00_16207;
						obj_t BgL_a2z00_16208;
						obj_t BgL_a3z00_16209;

						BgL_fz00_16206 =
							PROCEDURE_ENTRY(BgL_funz00_13807) (BgL_funz00_13807,
							BgL_sz00_13814, BEOA);
						BgL_a1z00_16207 =
							PROCEDURE_ENTRY(BgL_a1z00_13808) (BgL_a1z00_13808, BgL_sz00_13814,
							BEOA);
						BgL_a2z00_16208 =
							PROCEDURE_ENTRY(BgL_a2z00_13809) (BgL_a2z00_13809, BgL_sz00_13814,
							BEOA);
						BgL_a3z00_16209 =
							PROCEDURE_ENTRY(BgL_a3z00_13810) (BgL_a3z00_13810, BgL_sz00_13814,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16206))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13811,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16206);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16210;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22488;

								BgL_tmpz00_22488 = ((obj_t) BgL_fz00_16206);
								BgL_ufz00_16210 = PROCEDURE_ATTR(BgL_tmpz00_22488);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22491;

								if (STRUCTP(BgL_ufz00_16210))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22491 =
											(STRUCT_KEY(BgL_ufz00_16210) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22491 = ((bool_t) 0);
									}
								if (BgL_testz00_22491)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16211;
										obj_t BgL_runz00_16212;
										obj_t BgL_sfz00_16213;

										BgL_arityz00_16211 =
											STRUCT_REF(BgL_ufz00_16210, (int) (((long) 0)));
										BgL_runz00_16212 =
											STRUCT_REF(BgL_ufz00_16210, (int) (((long) 1)));
										BgL_sfz00_16213 =
											STRUCT_REF(BgL_ufz00_16210, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16214;

											BgL_spz00_16214 =
												((long) CINT(BgL_bpz00_16205) + BgL_siza7eza7_13813);
											if (((long) CINT(BgL_arityz00_16211) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2319z00_16215;

														BgL_arg2319z00_16215 =
															(BgL_spz00_16214 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13814), BgL_arg2319z00_16215,
															BgL_a1z00_16207);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2320z00_16216;

														BgL_arg2320z00_16216 =
															(BgL_spz00_16214 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13814), BgL_arg2320z00_16216,
															BgL_a2z00_16208);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2321z00_16217;

														BgL_arg2321z00_16217 =
															(BgL_spz00_16214 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13814), BgL_arg2321z00_16217,
															BgL_a3z00_16209);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16211))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16211))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2323z00_16218;
																		obj_t BgL_arg2324z00_16219;

																		BgL_arg2323z00_16218 =
																			(BgL_spz00_16214 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2325z00_16220;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2326z00_16221;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2327z00_16222;

																					BgL_arg2327z00_16222 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16209,
																						BNIL);
																					BgL_arg2326z00_16221 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16208,
																						BgL_arg2327z00_16222);
																				}
																				BgL_list2325z00_16220 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16207,
																					BgL_arg2326z00_16221);
																			}
																			BgL_arg2324z00_16219 =
																				BgL_list2325z00_16220;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2323z00_16218,
																			BgL_arg2324z00_16219);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2329z00_16223;

																		BgL_arg2329z00_16223 =
																			(BgL_spz00_16214 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2329z00_16223, BgL_a1z00_16207);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2330z00_16224;
																		obj_t BgL_arg2331z00_16225;

																		BgL_arg2330z00_16224 =
																			(BgL_spz00_16214 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2332z00_16226;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2333z00_16227;

																				BgL_arg2333z00_16227 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16209,
																					BNIL);
																				BgL_list2332z00_16226 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16208,
																					BgL_arg2333z00_16227);
																			}
																			BgL_arg2331z00_16225 =
																				BgL_list2332z00_16226;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2330z00_16224,
																			BgL_arg2331z00_16225);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2334z00_16228;

																		BgL_arg2334z00_16228 =
																			(BgL_spz00_16214 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2334z00_16228, BgL_a1z00_16207);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2335z00_16229;

																		BgL_arg2335z00_16229 =
																			(BgL_spz00_16214 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2335z00_16229, BgL_a2z00_16208);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2336z00_16230;
																		obj_t BgL_arg2337z00_16231;

																		BgL_arg2336z00_16230 =
																			(BgL_spz00_16214 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2338z00_16232;

																			BgL_list2338z00_16232 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16209, BNIL);
																			BgL_arg2337z00_16231 =
																				BgL_list2338z00_16232;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2336z00_16230,
																			BgL_arg2337z00_16231);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2339z00_16233;

																		BgL_arg2339z00_16233 =
																			(BgL_spz00_16214 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2339z00_16233, BgL_a1z00_16207);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2340z00_16234;

																		BgL_arg2340z00_16234 =
																			(BgL_spz00_16214 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2340z00_16234, BgL_a2z00_16208);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2341z00_16235;

																		BgL_arg2341z00_16235 =
																			(BgL_spz00_16214 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2341z00_16235, BgL_a3z00_16209);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2342z00_16236;
																		obj_t BgL_arg2343z00_16237;

																		BgL_arg2342z00_16236 =
																			(BgL_spz00_16214 + ((long) 3));
																		BgL_arg2343z00_16237 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13814),
																			BgL_arg2342z00_16236,
																			BgL_arg2343z00_16237);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13811,
																		STRUCT_REF(BgL_ufz00_16210,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16211));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13811, STRUCT_REF(BgL_ufz00_16210,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16211));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16238;

												BgL_z12denvz12_16238 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16214 +
															(long) CINT(BgL_sfz00_16213)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13814))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16212, BgL_sz00_13814,
															BINT(BgL_spz00_16214));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16239;

														BgL_nsz00_16239 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2347z00_16240;

															BgL_arg2347z00_16240 =
																(BgL_spz00_16214 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16239, ((long) 2), BgL_sz00_13814,
																BINT(BgL_spz00_16214),
																BINT(BgL_arg2347z00_16240));
														}
														VECTOR_SET(BgL_nsz00_16239, ((long) 1),
															BgL_sz00_13814);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16238,
															BgL_nsz00_16239);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16241;

															BgL_ez00_16241 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16241, BgL_sz00_13814);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16242;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16243;

																	BgL_savedzd2bpzd2_16243 =
																		VECTOR_REF(BgL_nsz00_16239, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16239, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16245;

																		BgL_fz00_16245 = BgL_runz00_16212;
																	BgL_recz00_16244:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16246;

																			BgL_rz00_16246 =
																				PROCEDURE_ENTRY(BgL_fz00_16245)
																				(BgL_fz00_16245, BgL_nsz00_16239, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_22591;

																				if (PROCEDUREP(BgL_rz00_16246))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_16247;

																						BgL_arg1696z00_16247 =
																							PROCEDURE_ATTR(BgL_rz00_16246);
																						if (STRUCTP(BgL_arg1696z00_16247))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22591 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_16247) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_22591 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_22591 = ((bool_t) 0);
																					}
																				if (BgL_testz00_22591)
																					{
																						obj_t BgL_fz00_22599;

																						BgL_fz00_22599 = BgL_rz00_16246;
																						BgL_fz00_16245 = BgL_fz00_22599;
																						goto BgL_recz00_16244;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16239,
																							((long) 0),
																							BgL_savedzd2bpzd2_16243);
																						BgL_____rz00_16242 = BgL_rz00_16246;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16241);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16238,
																	BgL_sz00_13814);
																return BgL_____rz00_16242;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16206,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16248;

												BgL_nbpz00_16248 =
													((long) CINT(BgL_bpz00_16205) + BgL_siza7eza7_13813);
												VECTOR_SET(
													((obj_t) BgL_sz00_13814), ((long) 0),
													BINT(BgL_nbpz00_16248));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16249;

													BgL_rz00_16249 =
														PROCEDURE_ENTRY(BgL_fz00_16206) (BgL_fz00_16206,
														BgL_a1z00_16207, BgL_a2z00_16208, BgL_a3z00_16209,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13814), ((long) 0),
														BgL_bpz00_16205);
													return BgL_rz00_16249;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13811,
													BgL_symbzd2funzd2_13812, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16206));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_cfunz00_2726;

				BgL_cfunz00_2726 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_2726))
					{	/* Eval/evaluate_comp.scm 889 */
						bool_t BgL_testz00_22625;

						{	/* Eval/evaluate_comp.scm 889 */
							int BgL_arg2357z00_2748;

							BgL_arg2357z00_2748 = bgl_debug();
							BgL_testz00_22625 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2357z00_2748),
								BINT(((long) 0)));
						}
						if (BgL_testz00_22625)
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32353ze3z83_13815;

								BgL_zc3anonymousza32353ze3z83_13815 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32353ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3anonymousza32353ze3z83_13815,
									(int) (((long) 6)), BgL_cfunz00_2726);
								return BgL_zc3anonymousza32353ze3z83_13815;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_zc3anonymousza32355ze3z83_13816;

								BgL_zc3anonymousza32355ze3z83_13816 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32355ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3anonymousza32355ze3z83_13816,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3anonymousza32355ze3z83_13816,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3anonymousza32355ze3z83_13816,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3anonymousza32355ze3z83_13816,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3anonymousza32355ze3z83_13816,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3anonymousza32355ze3z83_13816,
									(int) (((long) 5)), BgL_cfunz00_2726);
								return BgL_zc3anonymousza32355ze3z83_13816;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 889 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22666;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2468z00_2884;

									BgL_arg2468z00_2884 = bgl_debug();
									BgL_testz00_22666 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2468z00_2884),
										BINT(((long) 0)));
								}
								if (BgL_testz00_22666)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32360ze3z83_13817;

										BgL_zc3anonymousza32360ze3z83_13817 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32360ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32360ze3z83_13817,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32360ze3z83_13817;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32416ze3z83_13818;

										BgL_zc3anonymousza32416ze3z83_13818 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32416ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32416ze3z83_13818,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32416ze3z83_13818;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22711;

								{	/* Eval/evaluate_comp.scm 889 */
									int BgL_arg2598z00_3020;

									BgL_arg2598z00_3020 = bgl_debug();
									BgL_testz00_22711 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2598z00_3020),
										BINT(((long) 0)));
								}
								if (BgL_testz00_22711)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32471ze3z83_13819;

										BgL_zc3anonymousza32471ze3z83_13819 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32471ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32471ze3z83_13819,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32471ze3z83_13819;
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_zc3anonymousza32531ze3z83_13820;

										BgL_zc3anonymousza32531ze3z83_13820 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza32531ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_13820,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3anonymousza32531ze3z83_13820;
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2353> */
	obj_t BGl_z62zc3anonymousza32353ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13821, obj_t BgL_sz00_13829)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13822;
				obj_t BgL_a2z00_13823;
				obj_t BgL_a3z00_13824;
				obj_t BgL_a4z00_13825;
				long BgL_siza7eza7_13826;
				obj_t BgL_locz00_13827;
				obj_t BgL_cfunz00_13828;

				BgL_a1z00_13822 = PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 0)));
				BgL_a2z00_13823 = PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 1)));
				BgL_a3z00_13824 = PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 2)));
				BgL_a4z00_13825 = PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 3)));
				BgL_siza7eza7_13826 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 4))));
				BgL_locz00_13827 = PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 5)));
				BgL_cfunz00_13828 = PROCEDURE_REF(BgL_envz00_13821, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16250;

					BgL_bpz00_16250 = VECTOR_REF(((obj_t) BgL_sz00_13829), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16251;
						obj_t BgL_a2z00_16252;
						obj_t BgL_a3z00_16253;
						obj_t BgL_a4z00_16254;

						BgL_a1z00_16251 =
							PROCEDURE_ENTRY(BgL_a1z00_13822) (BgL_a1z00_13822, BgL_sz00_13829,
							BEOA);
						BgL_a2z00_16252 =
							PROCEDURE_ENTRY(BgL_a2z00_13823) (BgL_a2z00_13823, BgL_sz00_13829,
							BEOA);
						BgL_a3z00_16253 =
							PROCEDURE_ENTRY(BgL_a3z00_13824) (BgL_a3z00_13824, BgL_sz00_13829,
							BEOA);
						BgL_a4z00_16254 =
							PROCEDURE_ENTRY(BgL_a4z00_13825) (BgL_a4z00_13825, BgL_sz00_13829,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16255;

							BgL_nbpz00_16255 =
								((long) CINT(BgL_bpz00_16250) + BgL_siza7eza7_13826);
							VECTOR_SET(
								((obj_t) BgL_sz00_13829), ((long) 0), BINT(BgL_nbpz00_16255));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22794;

								BgL_tmpz00_22794 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22794, BgL_locz00_13827);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16256;

								BgL_rz00_16256 =
									PROCEDURE_ENTRY(BgL_cfunz00_13828) (BgL_cfunz00_13828,
									BgL_a1z00_16251, BgL_a2z00_16252, BgL_a3z00_16253,
									BgL_a4z00_16254, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13829), ((long) 0),
									BgL_bpz00_16250);
								return BgL_rz00_16256;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2355> */
	obj_t BGl_z62zc3anonymousza32355ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13830, obj_t BgL_sz00_13837)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_a1z00_13831;
				obj_t BgL_a2z00_13832;
				obj_t BgL_a3z00_13833;
				obj_t BgL_a4z00_13834;
				long BgL_siza7eza7_13835;
				obj_t BgL_cfunz00_13836;

				BgL_a1z00_13831 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 0)));
				BgL_a2z00_13832 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 1)));
				BgL_a3z00_13833 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 2)));
				BgL_a4z00_13834 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 3)));
				BgL_siza7eza7_13835 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 4))));
				BgL_cfunz00_13836 = PROCEDURE_REF(BgL_envz00_13830, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16257;

					BgL_bpz00_16257 = VECTOR_REF(((obj_t) BgL_sz00_13837), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_a1z00_16258;
						obj_t BgL_a2z00_16259;
						obj_t BgL_a3z00_16260;
						obj_t BgL_a4z00_16261;

						BgL_a1z00_16258 =
							PROCEDURE_ENTRY(BgL_a1z00_13831) (BgL_a1z00_13831, BgL_sz00_13837,
							BEOA);
						BgL_a2z00_16259 =
							PROCEDURE_ENTRY(BgL_a2z00_13832) (BgL_a2z00_13832, BgL_sz00_13837,
							BEOA);
						BgL_a3z00_16260 =
							PROCEDURE_ENTRY(BgL_a3z00_13833) (BgL_a3z00_13833, BgL_sz00_13837,
							BEOA);
						BgL_a4z00_16261 =
							PROCEDURE_ENTRY(BgL_a4z00_13834) (BgL_a4z00_13834, BgL_sz00_13837,
							BEOA);
						{	/* Eval/evaluate_comp.scm 889 */
							long BgL_nbpz00_16262;

							BgL_nbpz00_16262 =
								((long) CINT(BgL_bpz00_16257) + BgL_siza7eza7_13835);
							VECTOR_SET(
								((obj_t) BgL_sz00_13837), ((long) 0), BINT(BgL_nbpz00_16262));
							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_rz00_16263;

								BgL_rz00_16263 =
									PROCEDURE_ENTRY(BgL_cfunz00_13836) (BgL_cfunz00_13836,
									BgL_a1z00_16258, BgL_a2z00_16259, BgL_a3z00_16260,
									BgL_a4z00_16261, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13837), ((long) 0),
									BgL_bpz00_16257);
								return BgL_rz00_16263;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2360> */
	obj_t BGl_z62zc3anonymousza32360ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13838, obj_t BgL_sz00_13847)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13839;
				obj_t BgL_a1z00_13840;
				obj_t BgL_a2z00_13841;
				obj_t BgL_a3z00_13842;
				obj_t BgL_a4z00_13843;
				obj_t BgL_locz00_13844;
				obj_t BgL_symbzd2funzd2_13845;
				long BgL_siza7eza7_13846;

				BgL_funz00_13839 = PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 0)));
				BgL_a1z00_13840 = PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 1)));
				BgL_a2z00_13841 = PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 2)));
				BgL_a3z00_13842 = PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 3)));
				BgL_a4z00_13843 = PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 4)));
				BgL_locz00_13844 = PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 5)));
				BgL_symbzd2funzd2_13845 =
					PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 6)));
				BgL_siza7eza7_13846 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13838, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16264;

					BgL_bpz00_16264 = VECTOR_REF(((obj_t) BgL_sz00_13847), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16265;
						obj_t BgL_a1z00_16266;
						obj_t BgL_a2z00_16267;
						obj_t BgL_a3z00_16268;
						obj_t BgL_a4z00_16269;

						BgL_fz00_16265 =
							PROCEDURE_ENTRY(BgL_funz00_13839) (BgL_funz00_13839,
							BgL_sz00_13847, BEOA);
						BgL_a1z00_16266 =
							PROCEDURE_ENTRY(BgL_a1z00_13840) (BgL_a1z00_13840, BgL_sz00_13847,
							BEOA);
						BgL_a2z00_16267 =
							PROCEDURE_ENTRY(BgL_a2z00_13841) (BgL_a2z00_13841, BgL_sz00_13847,
							BEOA);
						BgL_a3z00_16268 =
							PROCEDURE_ENTRY(BgL_a3z00_13842) (BgL_a3z00_13842, BgL_sz00_13847,
							BEOA);
						BgL_a4z00_16269 =
							PROCEDURE_ENTRY(BgL_a4z00_13843) (BgL_a4z00_13843, BgL_sz00_13847,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16265))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13844,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16265);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16270;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_22893;

								BgL_tmpz00_22893 = ((obj_t) BgL_fz00_16265);
								BgL_ufz00_16270 = PROCEDURE_ATTR(BgL_tmpz00_22893);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_22896;

								if (STRUCTP(BgL_ufz00_16270))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22896 =
											(STRUCT_KEY(BgL_ufz00_16270) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_22896 = ((bool_t) 0);
									}
								if (BgL_testz00_22896)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16271;
										obj_t BgL_runz00_16272;
										obj_t BgL_sfz00_16273;

										BgL_arityz00_16271 =
											STRUCT_REF(BgL_ufz00_16270, (int) (((long) 0)));
										BgL_runz00_16272 =
											STRUCT_REF(BgL_ufz00_16270, (int) (((long) 1)));
										BgL_sfz00_16273 =
											STRUCT_REF(BgL_ufz00_16270, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16271) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2364z00_16274;

													BgL_arg2364z00_16274 =
														((long) CINT(BgL_bpz00_16264) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13847), BgL_arg2364z00_16274,
														BgL_a1z00_16266);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2365z00_16275;

													BgL_arg2365z00_16275 =
														((long) CINT(BgL_bpz00_16264) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13847), BgL_arg2365z00_16275,
														BgL_a2z00_16267);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2366z00_16276;

													BgL_arg2366z00_16276 =
														((long) CINT(BgL_bpz00_16264) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13847), BgL_arg2366z00_16276,
														BgL_a3z00_16268);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2367z00_16277;

													BgL_arg2367z00_16277 =
														((long) CINT(BgL_bpz00_16264) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13847), BgL_arg2367z00_16277,
														BgL_a4z00_16269);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16271))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16271))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2370z00_16278;
																	obj_t BgL_arg2373z00_16279;

																	BgL_arg2370z00_16278 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2374z00_16280;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2375z00_16281;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2376z00_16282;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2377z00_16283;

																					BgL_arg2377z00_16283 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16269,
																						BNIL);
																					BgL_arg2376z00_16282 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16268,
																						BgL_arg2377z00_16283);
																				}
																				BgL_arg2375z00_16281 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16267,
																					BgL_arg2376z00_16282);
																			}
																			BgL_list2374z00_16280 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16266,
																				BgL_arg2375z00_16281);
																		}
																		BgL_arg2373z00_16279 =
																			BgL_list2374z00_16280;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2370z00_16278, BgL_arg2373z00_16279);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2378z00_16284;

																	BgL_arg2378z00_16284 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2378z00_16284, BgL_a1z00_16266);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2379z00_16285;
																	obj_t BgL_arg2380z00_16286;

																	BgL_arg2379z00_16285 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2381z00_16287;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2382z00_16288;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2383z00_16289;

																				BgL_arg2383z00_16289 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16269,
																					BNIL);
																				BgL_arg2382z00_16288 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16268,
																					BgL_arg2383z00_16289);
																			}
																			BgL_list2381z00_16287 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16267,
																				BgL_arg2382z00_16288);
																		}
																		BgL_arg2380z00_16286 =
																			BgL_list2381z00_16287;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2379z00_16285, BgL_arg2380z00_16286);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2384z00_16290;

																	BgL_arg2384z00_16290 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2384z00_16290, BgL_a1z00_16266);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2385z00_16291;

																	BgL_arg2385z00_16291 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2385z00_16291, BgL_a2z00_16267);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2386z00_16292;
																	obj_t BgL_arg2387z00_16293;

																	BgL_arg2386z00_16292 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2388z00_16294;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2389z00_16295;

																			BgL_arg2389z00_16295 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16269, BNIL);
																			BgL_list2388z00_16294 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16268,
																				BgL_arg2389z00_16295);
																		}
																		BgL_arg2387z00_16293 =
																			BgL_list2388z00_16294;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2386z00_16292, BgL_arg2387z00_16293);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2391z00_16296;

																	BgL_arg2391z00_16296 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2391z00_16296, BgL_a1z00_16266);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2393z00_16297;

																	BgL_arg2393z00_16297 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2393z00_16297, BgL_a2z00_16267);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2395z00_16298;

																	BgL_arg2395z00_16298 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2395z00_16298, BgL_a3z00_16268);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2397z00_16299;
																	obj_t BgL_arg2398z00_16300;

																	BgL_arg2397z00_16299 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2399z00_16301;

																		BgL_list2399z00_16301 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16269, BNIL);
																		BgL_arg2398z00_16300 =
																			BgL_list2399z00_16301;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2397z00_16299, BgL_arg2398z00_16300);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2401z00_16302;

																	BgL_arg2401z00_16302 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2401z00_16302, BgL_a1z00_16266);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2402z00_16303;

																	BgL_arg2402z00_16303 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2402z00_16303, BgL_a2z00_16267);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2403z00_16304;

																	BgL_arg2403z00_16304 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2403z00_16304, BgL_a3z00_16268);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2404z00_16305;

																	BgL_arg2404z00_16305 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2404z00_16305, BgL_a4z00_16269);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2405z00_16306;
																	obj_t BgL_arg2407z00_16307;

																	BgL_arg2405z00_16306 =
																		((long) CINT(BgL_bpz00_16264) + ((long) 4));
																	BgL_arg2407z00_16307 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13847),
																		BgL_arg2405z00_16306, BgL_arg2407z00_16307);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13844, STRUCT_REF(BgL_ufz00_16270,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16271));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13844, STRUCT_REF(BgL_ufz00_16270,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16271));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16308;

											BgL_z12denvz12_16308 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16308,
												BgL_locz00_13844);
											if ((((long) CINT(BgL_bpz00_16264) +
														(long) CINT(BgL_sfz00_16273)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13847))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16272;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16309;

													BgL_nsz00_16309 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2411z00_16310;

														BgL_arg2411z00_16310 =
															((long) CINT(BgL_bpz00_16264) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16309, ((long) 2), BgL_sz00_13847,
															BgL_bpz00_16264, BINT(BgL_arg2411z00_16310));
													}
													VECTOR_SET(BgL_nsz00_16309, ((long) 1),
														BgL_sz00_13847);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16308,
														BgL_nsz00_16309);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16311;

														BgL_ez00_16311 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16311, BgL_sz00_13847);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16312;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16313;

																BgL_savedzd2bpzd2_16313 =
																	VECTOR_REF(BgL_nsz00_16309, ((long) 0));
																VECTOR_SET(BgL_nsz00_16309, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16315;

																	BgL_fz00_16315 = BgL_runz00_16272;
																BgL_recz00_16314:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16316;

																		BgL_rz00_16316 =
																			PROCEDURE_ENTRY(BgL_fz00_16315)
																			(BgL_fz00_16315, BgL_nsz00_16309, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_23035;

																			if (PROCEDUREP(BgL_rz00_16316))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_16317;

																					BgL_arg1696z00_16317 =
																						PROCEDURE_ATTR(BgL_rz00_16316);
																					if (STRUCTP(BgL_arg1696z00_16317))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_23035 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_16317) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_23035 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_23035 = ((bool_t) 0);
																				}
																			if (BgL_testz00_23035)
																				{
																					obj_t BgL_fz00_23043;

																					BgL_fz00_23043 = BgL_rz00_16316;
																					BgL_fz00_16315 = BgL_fz00_23043;
																					goto BgL_recz00_16314;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16309,
																						((long) 0),
																						BgL_savedzd2bpzd2_16313);
																					BgL_____rz00_16312 = BgL_rz00_16316;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16311);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16308,
																BgL_sz00_13847);
															return BgL_____rz00_16312;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16265,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16318;

												BgL_nbpz00_16318 =
													((long) CINT(BgL_bpz00_16264) + BgL_siza7eza7_13846);
												VECTOR_SET(
													((obj_t) BgL_sz00_13847), ((long) 0),
													BINT(BgL_nbpz00_16318));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_23055;

													BgL_tmpz00_23055 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23055,
														BgL_locz00_13844);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16319;

													BgL_rz00_16319 =
														PROCEDURE_ENTRY(BgL_fz00_16265) (BgL_fz00_16265,
														BgL_a1z00_16266, BgL_a2z00_16267, BgL_a3z00_16268,
														BgL_a4z00_16269, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13847), ((long) 0),
														BgL_bpz00_16264);
													return BgL_rz00_16319;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13844,
													BgL_symbzd2funzd2_13845, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16265));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2416> */
	obj_t BGl_z62zc3anonymousza32416ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13848, obj_t BgL_sz00_13857)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13849;
				obj_t BgL_a1z00_13850;
				obj_t BgL_a2z00_13851;
				obj_t BgL_a3z00_13852;
				obj_t BgL_a4z00_13853;
				obj_t BgL_locz00_13854;
				obj_t BgL_symbzd2funzd2_13855;
				long BgL_siza7eza7_13856;

				BgL_funz00_13849 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 0)));
				BgL_a1z00_13850 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 1)));
				BgL_a2z00_13851 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 2)));
				BgL_a3z00_13852 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 3)));
				BgL_a4z00_13853 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 4)));
				BgL_locz00_13854 = PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 5)));
				BgL_symbzd2funzd2_13855 =
					PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 6)));
				BgL_siza7eza7_13856 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13848, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16320;

					BgL_bpz00_16320 = VECTOR_REF(((obj_t) BgL_sz00_13857), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16321;
						obj_t BgL_a1z00_16322;
						obj_t BgL_a2z00_16323;
						obj_t BgL_a3z00_16324;
						obj_t BgL_a4z00_16325;

						BgL_fz00_16321 =
							PROCEDURE_ENTRY(BgL_funz00_13849) (BgL_funz00_13849,
							BgL_sz00_13857, BEOA);
						BgL_a1z00_16322 =
							PROCEDURE_ENTRY(BgL_a1z00_13850) (BgL_a1z00_13850, BgL_sz00_13857,
							BEOA);
						BgL_a2z00_16323 =
							PROCEDURE_ENTRY(BgL_a2z00_13851) (BgL_a2z00_13851, BgL_sz00_13857,
							BEOA);
						BgL_a3z00_16324 =
							PROCEDURE_ENTRY(BgL_a3z00_13852) (BgL_a3z00_13852, BgL_sz00_13857,
							BEOA);
						BgL_a4z00_16325 =
							PROCEDURE_ENTRY(BgL_a4z00_13853) (BgL_a4z00_13853, BgL_sz00_13857,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16321))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13854,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16321);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16326;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_23112;

								BgL_tmpz00_23112 = ((obj_t) BgL_fz00_16321);
								BgL_ufz00_16326 = PROCEDURE_ATTR(BgL_tmpz00_23112);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_23115;

								if (STRUCTP(BgL_ufz00_16326))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_23115 =
											(STRUCT_KEY(BgL_ufz00_16326) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_23115 = ((bool_t) 0);
									}
								if (BgL_testz00_23115)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16327;
										obj_t BgL_runz00_16328;
										obj_t BgL_sfz00_16329;

										BgL_arityz00_16327 =
											STRUCT_REF(BgL_ufz00_16326, (int) (((long) 0)));
										BgL_runz00_16328 =
											STRUCT_REF(BgL_ufz00_16326, (int) (((long) 1)));
										BgL_sfz00_16329 =
											STRUCT_REF(BgL_ufz00_16326, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16327) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 889 */
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2420z00_16330;

													BgL_arg2420z00_16330 =
														((long) CINT(BgL_bpz00_16320) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13857), BgL_arg2420z00_16330,
														BgL_a1z00_16322);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2421z00_16331;

													BgL_arg2421z00_16331 =
														((long) CINT(BgL_bpz00_16320) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13857), BgL_arg2421z00_16331,
														BgL_a2z00_16323);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2423z00_16332;

													BgL_arg2423z00_16332 =
														((long) CINT(BgL_bpz00_16320) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13857), BgL_arg2423z00_16332,
														BgL_a3z00_16324);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													long BgL_arg2424z00_16333;

													BgL_arg2424z00_16333 =
														((long) CINT(BgL_bpz00_16320) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13857), BgL_arg2424z00_16333,
														BgL_a4z00_16325);
											}}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												if (INTEGERP(BgL_arityz00_16327))
													{	/* Eval/evaluate_comp.scm 889 */
														switch ((long) CINT(BgL_arityz00_16327))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2426z00_16334;
																	obj_t BgL_arg2429z00_16335;

																	BgL_arg2426z00_16334 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2430z00_16336;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2431z00_16337;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2432z00_16338;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2433z00_16339;

																					BgL_arg2433z00_16339 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16325,
																						BNIL);
																					BgL_arg2432z00_16338 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16324,
																						BgL_arg2433z00_16339);
																				}
																				BgL_arg2431z00_16337 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16323,
																					BgL_arg2432z00_16338);
																			}
																			BgL_list2430z00_16336 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16322,
																				BgL_arg2431z00_16337);
																		}
																		BgL_arg2429z00_16335 =
																			BgL_list2430z00_16336;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2426z00_16334, BgL_arg2429z00_16335);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2435z00_16340;

																	BgL_arg2435z00_16340 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2435z00_16340, BgL_a1z00_16322);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2436z00_16341;
																	obj_t BgL_arg2437z00_16342;

																	BgL_arg2436z00_16341 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2438z00_16343;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2439z00_16344;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2440z00_16345;

																				BgL_arg2440z00_16345 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16325,
																					BNIL);
																				BgL_arg2439z00_16344 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16324,
																					BgL_arg2440z00_16345);
																			}
																			BgL_list2438z00_16343 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16323,
																				BgL_arg2439z00_16344);
																		}
																		BgL_arg2437z00_16342 =
																			BgL_list2438z00_16343;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2436z00_16341, BgL_arg2437z00_16342);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2441z00_16346;

																	BgL_arg2441z00_16346 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2441z00_16346, BgL_a1z00_16322);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2443z00_16347;

																	BgL_arg2443z00_16347 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2443z00_16347, BgL_a2z00_16323);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2444z00_16348;
																	obj_t BgL_arg2445z00_16349;

																	BgL_arg2444z00_16348 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2446z00_16350;

																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_arg2447z00_16351;

																			BgL_arg2447z00_16351 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16325, BNIL);
																			BgL_list2446z00_16350 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16324,
																				BgL_arg2447z00_16351);
																		}
																		BgL_arg2445z00_16349 =
																			BgL_list2446z00_16350;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2444z00_16348, BgL_arg2445z00_16349);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2448z00_16352;

																	BgL_arg2448z00_16352 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2448z00_16352, BgL_a1z00_16322);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2449z00_16353;

																	BgL_arg2449z00_16353 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2449z00_16353, BgL_a2z00_16323);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2450z00_16354;

																	BgL_arg2450z00_16354 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2450z00_16354, BgL_a3z00_16324);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2452z00_16355;
																	obj_t BgL_arg2453z00_16356;

																	BgL_arg2452z00_16355 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 889 */
																		obj_t BgL_list2454z00_16357;

																		BgL_list2454z00_16357 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16325, BNIL);
																		BgL_arg2453z00_16356 =
																			BgL_list2454z00_16357;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2452z00_16355, BgL_arg2453z00_16356);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2455z00_16358;

																	BgL_arg2455z00_16358 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2455z00_16358, BgL_a1z00_16322);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2456z00_16359;

																	BgL_arg2456z00_16359 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2456z00_16359, BgL_a2z00_16323);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2457z00_16360;

																	BgL_arg2457z00_16360 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2457z00_16360, BgL_a3z00_16324);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2458z00_16361;

																	BgL_arg2458z00_16361 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2458z00_16361, BgL_a4z00_16325);
																}
																{	/* Eval/evaluate_comp.scm 889 */
																	long BgL_arg2459z00_16362;
																	obj_t BgL_arg2461z00_16363;

																	BgL_arg2459z00_16362 =
																		((long) CINT(BgL_bpz00_16320) + ((long) 4));
																	BgL_arg2461z00_16363 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13857),
																		BgL_arg2459z00_16362, BgL_arg2461z00_16363);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13854, STRUCT_REF(BgL_ufz00_16326,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16327));
													}}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13854, STRUCT_REF(BgL_ufz00_16326,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16327));
											}}
										{	/* Eval/evaluate_comp.scm 889 */
											obj_t BgL_z12denvz12_16364;

											BgL_z12denvz12_16364 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16320) +
														(long) CINT(BgL_sfz00_16329)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13857))))
												{	/* Eval/evaluate_comp.scm 889 */
													return BgL_runz00_16328;
												}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_nsz00_16365;

													BgL_nsz00_16365 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2465z00_16366;

														BgL_arg2465z00_16366 =
															((long) CINT(BgL_bpz00_16320) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16365, ((long) 2), BgL_sz00_13857,
															BgL_bpz00_16320, BINT(BgL_arg2465z00_16366));
													}
													VECTOR_SET(BgL_nsz00_16365, ((long) 1),
														BgL_sz00_13857);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16364,
														BgL_nsz00_16365);
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_ez00_16367;

														BgL_ez00_16367 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16367, BgL_sz00_13857);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_____rz00_16368;

															{	/* Eval/evaluate_comp.scm 663 */
																obj_t BgL_savedzd2bpzd2_16369;

																BgL_savedzd2bpzd2_16369 =
																	VECTOR_REF(BgL_nsz00_16365, ((long) 0));
																VECTOR_SET(BgL_nsz00_16365, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16371;

																	BgL_fz00_16371 = BgL_runz00_16328;
																BgL_recz00_16370:
																	{	/* Eval/evaluate_comp.scm 666 */
																		obj_t BgL_rz00_16372;

																		BgL_rz00_16372 =
																			PROCEDURE_ENTRY(BgL_fz00_16371)
																			(BgL_fz00_16371, BgL_nsz00_16365, BEOA);
																		{	/* Eval/evaluate_comp.scm 667 */
																			bool_t BgL_testz00_23253;

																			if (PROCEDUREP(BgL_rz00_16372))
																				{	/* Eval/evaluate_comp.scm 667 */
																					obj_t BgL_arg1696z00_16373;

																					BgL_arg1696z00_16373 =
																						PROCEDURE_ATTR(BgL_rz00_16372);
																					if (STRUCTP(BgL_arg1696z00_16373))
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_23253 =
																								(STRUCT_KEY
																								(BgL_arg1696z00_16373) ==
																								BGl_symbol5771z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 647 */
																							BgL_testz00_23253 = ((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					BgL_testz00_23253 = ((bool_t) 0);
																				}
																			if (BgL_testz00_23253)
																				{
																					obj_t BgL_fz00_23261;

																					BgL_fz00_23261 = BgL_rz00_16372;
																					BgL_fz00_16371 = BgL_fz00_23261;
																					goto BgL_recz00_16370;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 667 */
																					VECTOR_SET(BgL_nsz00_16365,
																						((long) 0),
																						BgL_savedzd2bpzd2_16369);
																					BgL_____rz00_16368 = BgL_rz00_16372;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16367);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16364,
																BgL_sz00_13857);
															return BgL_____rz00_16368;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16321,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16374;

												BgL_nbpz00_16374 =
													((long) CINT(BgL_bpz00_16320) + BgL_siza7eza7_13856);
												VECTOR_SET(
													((obj_t) BgL_sz00_13857), ((long) 0),
													BINT(BgL_nbpz00_16374));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16375;

													BgL_rz00_16375 =
														PROCEDURE_ENTRY(BgL_fz00_16321) (BgL_fz00_16321,
														BgL_a1z00_16322, BgL_a2z00_16323, BgL_a3z00_16324,
														BgL_a4z00_16325, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13857), ((long) 0),
														BgL_bpz00_16320);
													return BgL_rz00_16375;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13854,
													BgL_symbzd2funzd2_13855, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16321));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2471> */
	obj_t BGl_z62zc3anonymousza32471ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13858, obj_t BgL_sz00_13867)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13859;
				obj_t BgL_a1z00_13860;
				obj_t BgL_a2z00_13861;
				obj_t BgL_a3z00_13862;
				obj_t BgL_a4z00_13863;
				obj_t BgL_locz00_13864;
				obj_t BgL_symbzd2funzd2_13865;
				long BgL_siza7eza7_13866;

				BgL_funz00_13859 = PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 0)));
				BgL_a1z00_13860 = PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 1)));
				BgL_a2z00_13861 = PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 2)));
				BgL_a3z00_13862 = PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 3)));
				BgL_a4z00_13863 = PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 4)));
				BgL_locz00_13864 = PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 5)));
				BgL_symbzd2funzd2_13865 =
					PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 6)));
				BgL_siza7eza7_13866 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13858, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16376;

					BgL_bpz00_16376 = VECTOR_REF(((obj_t) BgL_sz00_13867), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16377;
						obj_t BgL_a1z00_16378;
						obj_t BgL_a2z00_16379;
						obj_t BgL_a3z00_16380;
						obj_t BgL_a4z00_16381;

						BgL_fz00_16377 =
							PROCEDURE_ENTRY(BgL_funz00_13859) (BgL_funz00_13859,
							BgL_sz00_13867, BEOA);
						BgL_a1z00_16378 =
							PROCEDURE_ENTRY(BgL_a1z00_13860) (BgL_a1z00_13860, BgL_sz00_13867,
							BEOA);
						BgL_a2z00_16379 =
							PROCEDURE_ENTRY(BgL_a2z00_13861) (BgL_a2z00_13861, BgL_sz00_13867,
							BEOA);
						BgL_a3z00_16380 =
							PROCEDURE_ENTRY(BgL_a3z00_13862) (BgL_a3z00_13862, BgL_sz00_13867,
							BEOA);
						BgL_a4z00_16381 =
							PROCEDURE_ENTRY(BgL_a4z00_13863) (BgL_a4z00_13863, BgL_sz00_13867,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16377))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13864,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16377);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16382;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_23327;

								BgL_tmpz00_23327 = ((obj_t) BgL_fz00_16377);
								BgL_ufz00_16382 = PROCEDURE_ATTR(BgL_tmpz00_23327);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_23330;

								if (STRUCTP(BgL_ufz00_16382))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_23330 =
											(STRUCT_KEY(BgL_ufz00_16382) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_23330 = ((bool_t) 0);
									}
								if (BgL_testz00_23330)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16383;
										obj_t BgL_runz00_16384;
										obj_t BgL_sfz00_16385;

										BgL_arityz00_16383 =
											STRUCT_REF(BgL_ufz00_16382, (int) (((long) 0)));
										BgL_runz00_16384 =
											STRUCT_REF(BgL_ufz00_16382, (int) (((long) 1)));
										BgL_sfz00_16385 =
											STRUCT_REF(BgL_ufz00_16382, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16386;

											BgL_spz00_16386 =
												((long) CINT(BgL_bpz00_16376) + BgL_siza7eza7_13866);
											if (((long) CINT(BgL_arityz00_16383) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2475z00_16387;

														BgL_arg2475z00_16387 =
															(BgL_spz00_16386 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13867), BgL_arg2475z00_16387,
															BgL_a1z00_16378);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2476z00_16388;

														BgL_arg2476z00_16388 =
															(BgL_spz00_16386 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13867), BgL_arg2476z00_16388,
															BgL_a2z00_16379);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2477z00_16389;

														BgL_arg2477z00_16389 =
															(BgL_spz00_16386 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13867), BgL_arg2477z00_16389,
															BgL_a3z00_16380);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2478z00_16390;

														BgL_arg2478z00_16390 =
															(BgL_spz00_16386 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13867), BgL_arg2478z00_16390,
															BgL_a4z00_16381);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16383))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16383))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2481z00_16391;
																		obj_t BgL_arg2482z00_16392;

																		BgL_arg2481z00_16391 =
																			(BgL_spz00_16386 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2483z00_16393;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2484z00_16394;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2485z00_16395;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2487z00_16396;

																						BgL_arg2487z00_16396 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16381,
																							BNIL);
																						BgL_arg2485z00_16395 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16380,
																							BgL_arg2487z00_16396);
																					}
																					BgL_arg2484z00_16394 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16379,
																						BgL_arg2485z00_16395);
																				}
																				BgL_list2483z00_16393 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16378,
																					BgL_arg2484z00_16394);
																			}
																			BgL_arg2482z00_16392 =
																				BgL_list2483z00_16393;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2481z00_16391,
																			BgL_arg2482z00_16392);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2489z00_16397;

																		BgL_arg2489z00_16397 =
																			(BgL_spz00_16386 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2489z00_16397, BgL_a1z00_16378);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2490z00_16398;
																		obj_t BgL_arg2491z00_16399;

																		BgL_arg2490z00_16398 =
																			(BgL_spz00_16386 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2492z00_16400;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2493z00_16401;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2497z00_16402;

																					BgL_arg2497z00_16402 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16381,
																						BNIL);
																					BgL_arg2493z00_16401 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16380,
																						BgL_arg2497z00_16402);
																				}
																				BgL_list2492z00_16400 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16379,
																					BgL_arg2493z00_16401);
																			}
																			BgL_arg2491z00_16399 =
																				BgL_list2492z00_16400;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2490z00_16398,
																			BgL_arg2491z00_16399);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2498z00_16403;

																		BgL_arg2498z00_16403 =
																			(BgL_spz00_16386 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2498z00_16403, BgL_a1z00_16378);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2499z00_16404;

																		BgL_arg2499z00_16404 =
																			(BgL_spz00_16386 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2499z00_16404, BgL_a2z00_16379);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2500z00_16405;
																		obj_t BgL_arg2501z00_16406;

																		BgL_arg2500z00_16405 =
																			(BgL_spz00_16386 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2502z00_16407;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2503z00_16408;

																				BgL_arg2503z00_16408 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16381,
																					BNIL);
																				BgL_list2502z00_16407 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16380,
																					BgL_arg2503z00_16408);
																			}
																			BgL_arg2501z00_16406 =
																				BgL_list2502z00_16407;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2500z00_16405,
																			BgL_arg2501z00_16406);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2505z00_16409;

																		BgL_arg2505z00_16409 =
																			(BgL_spz00_16386 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2505z00_16409, BgL_a1z00_16378);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2506z00_16410;

																		BgL_arg2506z00_16410 =
																			(BgL_spz00_16386 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2506z00_16410, BgL_a2z00_16379);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2507z00_16411;

																		BgL_arg2507z00_16411 =
																			(BgL_spz00_16386 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2507z00_16411, BgL_a3z00_16380);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2508z00_16412;
																		obj_t BgL_arg2509z00_16413;

																		BgL_arg2508z00_16412 =
																			(BgL_spz00_16386 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2510z00_16414;

																			BgL_list2510z00_16414 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16381, BNIL);
																			BgL_arg2509z00_16413 =
																				BgL_list2510z00_16414;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2508z00_16412,
																			BgL_arg2509z00_16413);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2511z00_16415;

																		BgL_arg2511z00_16415 =
																			(BgL_spz00_16386 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2511z00_16415, BgL_a1z00_16378);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2512z00_16416;

																		BgL_arg2512z00_16416 =
																			(BgL_spz00_16386 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2512z00_16416, BgL_a2z00_16379);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2513z00_16417;

																		BgL_arg2513z00_16417 =
																			(BgL_spz00_16386 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2513z00_16417, BgL_a3z00_16380);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2515z00_16418;

																		BgL_arg2515z00_16418 =
																			(BgL_spz00_16386 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2515z00_16418, BgL_a4z00_16381);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2516z00_16419;
																		obj_t BgL_arg2518z00_16420;

																		BgL_arg2516z00_16419 =
																			(BgL_spz00_16386 + ((long) 4));
																		BgL_arg2518z00_16420 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13867),
																			BgL_arg2516z00_16419,
																			BgL_arg2518z00_16420);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13864,
																		STRUCT_REF(BgL_ufz00_16382,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16383));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13864, STRUCT_REF(BgL_ufz00_16382,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16383));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16421;

												BgL_z12denvz12_16421 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16421,
													BgL_locz00_13864);
												if (((BgL_spz00_16386 + (long) CINT(BgL_sfz00_16385)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13867))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16384, BgL_sz00_13867,
															BINT(BgL_spz00_16386));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16422;

														BgL_nsz00_16422 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2526z00_16423;

															BgL_arg2526z00_16423 =
																(BgL_spz00_16386 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16422, ((long) 2), BgL_sz00_13867,
																BINT(BgL_spz00_16386),
																BINT(BgL_arg2526z00_16423));
														}
														VECTOR_SET(BgL_nsz00_16422, ((long) 1),
															BgL_sz00_13867);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16421,
															BgL_nsz00_16422);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16424;

															BgL_ez00_16424 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16424, BgL_sz00_13867);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16425;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16426;

																	BgL_savedzd2bpzd2_16426 =
																		VECTOR_REF(BgL_nsz00_16422, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16422, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16428;

																		BgL_fz00_16428 = BgL_runz00_16384;
																	BgL_recz00_16427:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16429;

																			BgL_rz00_16429 =
																				PROCEDURE_ENTRY(BgL_fz00_16428)
																				(BgL_fz00_16428, BgL_nsz00_16422, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_23453;

																				if (PROCEDUREP(BgL_rz00_16429))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_16430;

																						BgL_arg1696z00_16430 =
																							PROCEDURE_ATTR(BgL_rz00_16429);
																						if (STRUCTP(BgL_arg1696z00_16430))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23453 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_16430) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23453 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_23453 = ((bool_t) 0);
																					}
																				if (BgL_testz00_23453)
																					{
																						obj_t BgL_fz00_23461;

																						BgL_fz00_23461 = BgL_rz00_16429;
																						BgL_fz00_16428 = BgL_fz00_23461;
																						goto BgL_recz00_16427;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16422,
																							((long) 0),
																							BgL_savedzd2bpzd2_16426);
																						BgL_____rz00_16425 = BgL_rz00_16429;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16424);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16421,
																	BgL_sz00_13867);
																return BgL_____rz00_16425;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16377,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16431;

												BgL_nbpz00_16431 =
													((long) CINT(BgL_bpz00_16376) + BgL_siza7eza7_13866);
												VECTOR_SET(
													((obj_t) BgL_sz00_13867), ((long) 0),
													BINT(BgL_nbpz00_16431));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_tmpz00_23473;

													BgL_tmpz00_23473 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23473,
														BgL_locz00_13864);
												}
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16432;

													BgL_rz00_16432 =
														PROCEDURE_ENTRY(BgL_fz00_16377) (BgL_fz00_16377,
														BgL_a1z00_16378, BgL_a2z00_16379, BgL_a3z00_16380,
														BgL_a4z00_16381, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13867), ((long) 0),
														BgL_bpz00_16376);
													return BgL_rz00_16432;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13864,
													BgL_symbzd2funzd2_13865, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16377));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2531> */
	obj_t BGl_z62zc3anonymousza32531ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13868, obj_t BgL_sz00_13877)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 889 */
			{	/* Eval/evaluate_comp.scm 889 */
				obj_t BgL_funz00_13869;
				obj_t BgL_a1z00_13870;
				obj_t BgL_a2z00_13871;
				obj_t BgL_a3z00_13872;
				obj_t BgL_a4z00_13873;
				obj_t BgL_locz00_13874;
				obj_t BgL_symbzd2funzd2_13875;
				long BgL_siza7eza7_13876;

				BgL_funz00_13869 = PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 0)));
				BgL_a1z00_13870 = PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 1)));
				BgL_a2z00_13871 = PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 2)));
				BgL_a3z00_13872 = PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 3)));
				BgL_a4z00_13873 = PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 4)));
				BgL_locz00_13874 = PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 5)));
				BgL_symbzd2funzd2_13875 =
					PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 6)));
				BgL_siza7eza7_13876 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13868, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 889 */
					obj_t BgL_bpz00_16433;

					BgL_bpz00_16433 = VECTOR_REF(((obj_t) BgL_sz00_13877), ((long) 0));
					{	/* Eval/evaluate_comp.scm 889 */
						obj_t BgL_fz00_16434;
						obj_t BgL_a1z00_16435;
						obj_t BgL_a2z00_16436;
						obj_t BgL_a3z00_16437;
						obj_t BgL_a4z00_16438;

						BgL_fz00_16434 =
							PROCEDURE_ENTRY(BgL_funz00_13869) (BgL_funz00_13869,
							BgL_sz00_13877, BEOA);
						BgL_a1z00_16435 =
							PROCEDURE_ENTRY(BgL_a1z00_13870) (BgL_a1z00_13870, BgL_sz00_13877,
							BEOA);
						BgL_a2z00_16436 =
							PROCEDURE_ENTRY(BgL_a2z00_13871) (BgL_a2z00_13871, BgL_sz00_13877,
							BEOA);
						BgL_a3z00_16437 =
							PROCEDURE_ENTRY(BgL_a3z00_13872) (BgL_a3z00_13872, BgL_sz00_13877,
							BEOA);
						BgL_a4z00_16438 =
							PROCEDURE_ENTRY(BgL_a4z00_13873) (BgL_a4z00_13873, BgL_sz00_13877,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16434))
							{	/* Eval/evaluate_comp.scm 889 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 889 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13874,
									BGl_string5775z00zz__evaluate_compz00,
									BGl_string5791z00zz__evaluate_compz00, BgL_fz00_16434);
							}
						{	/* Eval/evaluate_comp.scm 889 */
							obj_t BgL_ufz00_16439;

							{	/* Eval/evaluate_comp.scm 889 */
								obj_t BgL_tmpz00_23530;

								BgL_tmpz00_23530 = ((obj_t) BgL_fz00_16434);
								BgL_ufz00_16439 = PROCEDURE_ATTR(BgL_tmpz00_23530);
							}
							{	/* Eval/evaluate_comp.scm 889 */
								bool_t BgL_testz00_23533;

								if (STRUCTP(BgL_ufz00_16439))
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_23533 =
											(STRUCT_KEY(BgL_ufz00_16439) ==
											BGl_symbol5792z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 676 */
										BgL_testz00_23533 = ((bool_t) 0);
									}
								if (BgL_testz00_23533)
									{	/* Eval/evaluate_comp.scm 889 */
										obj_t BgL_arityz00_16440;
										obj_t BgL_runz00_16441;
										obj_t BgL_sfz00_16442;

										BgL_arityz00_16440 =
											STRUCT_REF(BgL_ufz00_16439, (int) (((long) 0)));
										BgL_runz00_16441 =
											STRUCT_REF(BgL_ufz00_16439, (int) (((long) 1)));
										BgL_sfz00_16442 =
											STRUCT_REF(BgL_ufz00_16439, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 889 */
											long BgL_spz00_16443;

											BgL_spz00_16443 =
												((long) CINT(BgL_bpz00_16433) + BgL_siza7eza7_13876);
											if (((long) CINT(BgL_arityz00_16440) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 889 */
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2535z00_16444;

														BgL_arg2535z00_16444 =
															(BgL_spz00_16443 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13877), BgL_arg2535z00_16444,
															BgL_a1z00_16435);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2536z00_16445;

														BgL_arg2536z00_16445 =
															(BgL_spz00_16443 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13877), BgL_arg2536z00_16445,
															BgL_a2z00_16436);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2537z00_16446;

														BgL_arg2537z00_16446 =
															(BgL_spz00_16443 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13877), BgL_arg2537z00_16446,
															BgL_a3z00_16437);
													}
													{	/* Eval/evaluate_comp.scm 889 */
														long BgL_arg2541z00_16447;

														BgL_arg2541z00_16447 =
															(BgL_spz00_16443 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13877), BgL_arg2541z00_16447,
															BgL_a4z00_16438);
												}}
											else
												{	/* Eval/evaluate_comp.scm 889 */
													if (INTEGERP(BgL_arityz00_16440))
														{	/* Eval/evaluate_comp.scm 889 */
															switch ((long) CINT(BgL_arityz00_16440))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2545z00_16448;
																		obj_t BgL_arg2546z00_16449;

																		BgL_arg2545z00_16448 =
																			(BgL_spz00_16443 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2547z00_16450;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2549z00_16451;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2555z00_16452;

																					{	/* Eval/evaluate_comp.scm 889 */
																						obj_t BgL_arg2557z00_16453;

																						BgL_arg2557z00_16453 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16438,
																							BNIL);
																						BgL_arg2555z00_16452 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16437,
																							BgL_arg2557z00_16453);
																					}
																					BgL_arg2549z00_16451 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16436,
																						BgL_arg2555z00_16452);
																				}
																				BgL_list2547z00_16450 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16435,
																					BgL_arg2549z00_16451);
																			}
																			BgL_arg2546z00_16449 =
																				BgL_list2547z00_16450;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2545z00_16448,
																			BgL_arg2546z00_16449);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2560z00_16454;

																		BgL_arg2560z00_16454 =
																			(BgL_spz00_16443 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2560z00_16454, BgL_a1z00_16435);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2562z00_16455;
																		obj_t BgL_arg2563z00_16456;

																		BgL_arg2562z00_16455 =
																			(BgL_spz00_16443 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2564z00_16457;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2565z00_16458;

																				{	/* Eval/evaluate_comp.scm 889 */
																					obj_t BgL_arg2566z00_16459;

																					BgL_arg2566z00_16459 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16438,
																						BNIL);
																					BgL_arg2565z00_16458 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16437,
																						BgL_arg2566z00_16459);
																				}
																				BgL_list2564z00_16457 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16436,
																					BgL_arg2565z00_16458);
																			}
																			BgL_arg2563z00_16456 =
																				BgL_list2564z00_16457;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2562z00_16455,
																			BgL_arg2563z00_16456);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2567z00_16460;

																		BgL_arg2567z00_16460 =
																			(BgL_spz00_16443 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2567z00_16460, BgL_a1z00_16435);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2569z00_16461;

																		BgL_arg2569z00_16461 =
																			(BgL_spz00_16443 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2569z00_16461, BgL_a2z00_16436);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2570z00_16462;
																		obj_t BgL_arg2571z00_16463;

																		BgL_arg2570z00_16462 =
																			(BgL_spz00_16443 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2572z00_16464;

																			{	/* Eval/evaluate_comp.scm 889 */
																				obj_t BgL_arg2573z00_16465;

																				BgL_arg2573z00_16465 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16438,
																					BNIL);
																				BgL_list2572z00_16464 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16437,
																					BgL_arg2573z00_16465);
																			}
																			BgL_arg2571z00_16463 =
																				BgL_list2572z00_16464;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2570z00_16462,
																			BgL_arg2571z00_16463);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2574z00_16466;

																		BgL_arg2574z00_16466 =
																			(BgL_spz00_16443 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2574z00_16466, BgL_a1z00_16435);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2575z00_16467;

																		BgL_arg2575z00_16467 =
																			(BgL_spz00_16443 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2575z00_16467, BgL_a2z00_16436);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2577z00_16468;

																		BgL_arg2577z00_16468 =
																			(BgL_spz00_16443 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2577z00_16468, BgL_a3z00_16437);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2578z00_16469;
																		obj_t BgL_arg2579z00_16470;

																		BgL_arg2578z00_16469 =
																			(BgL_spz00_16443 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 889 */
																			obj_t BgL_list2580z00_16471;

																			BgL_list2580z00_16471 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16438, BNIL);
																			BgL_arg2579z00_16470 =
																				BgL_list2580z00_16471;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2578z00_16469,
																			BgL_arg2579z00_16470);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2581z00_16472;

																		BgL_arg2581z00_16472 =
																			(BgL_spz00_16443 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2581z00_16472, BgL_a1z00_16435);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2583z00_16473;

																		BgL_arg2583z00_16473 =
																			(BgL_spz00_16443 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2583z00_16473, BgL_a2z00_16436);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2584z00_16474;

																		BgL_arg2584z00_16474 =
																			(BgL_spz00_16443 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2584z00_16474, BgL_a3z00_16437);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2585z00_16475;

																		BgL_arg2585z00_16475 =
																			(BgL_spz00_16443 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2585z00_16475, BgL_a4z00_16438);
																	}
																	{	/* Eval/evaluate_comp.scm 889 */
																		long BgL_arg2586z00_16476;
																		obj_t BgL_arg2589z00_16477;

																		BgL_arg2586z00_16476 =
																			(BgL_spz00_16443 + ((long) 4));
																		BgL_arg2589z00_16477 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13877),
																			BgL_arg2586z00_16476,
																			BgL_arg2589z00_16477);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13874,
																		STRUCT_REF(BgL_ufz00_16439,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16440));
														}}
													else
														{	/* Eval/evaluate_comp.scm 889 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13874, STRUCT_REF(BgL_ufz00_16439,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16440));
												}}
											{	/* Eval/evaluate_comp.scm 889 */
												obj_t BgL_z12denvz12_16478;

												BgL_z12denvz12_16478 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16443 +
															(long) CINT(BgL_sfz00_16442)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13877))))
													{	/* Eval/evaluate_comp.scm 889 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16441, BgL_sz00_13877,
															BINT(BgL_spz00_16443));
													}
												else
													{	/* Eval/evaluate_comp.scm 889 */
														obj_t BgL_nsz00_16479;

														BgL_nsz00_16479 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 889 */
															long BgL_arg2594z00_16480;

															BgL_arg2594z00_16480 =
																(BgL_spz00_16443 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16479, ((long) 2), BgL_sz00_13877,
																BINT(BgL_spz00_16443),
																BINT(BgL_arg2594z00_16480));
														}
														VECTOR_SET(BgL_nsz00_16479, ((long) 1),
															BgL_sz00_13877);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16478,
															BgL_nsz00_16479);
														{	/* Eval/evaluate_comp.scm 889 */
															obj_t BgL_ez00_16481;

															BgL_ez00_16481 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16481, BgL_sz00_13877);
															{	/* Eval/evaluate_comp.scm 889 */
																obj_t BgL_____rz00_16482;

																{	/* Eval/evaluate_comp.scm 663 */
																	obj_t BgL_savedzd2bpzd2_16483;

																	BgL_savedzd2bpzd2_16483 =
																		VECTOR_REF(BgL_nsz00_16479, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16479, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16485;

																		BgL_fz00_16485 = BgL_runz00_16441;
																	BgL_recz00_16484:
																		{	/* Eval/evaluate_comp.scm 666 */
																			obj_t BgL_rz00_16486;

																			BgL_rz00_16486 =
																				PROCEDURE_ENTRY(BgL_fz00_16485)
																				(BgL_fz00_16485, BgL_nsz00_16479, BEOA);
																			{	/* Eval/evaluate_comp.scm 667 */
																				bool_t BgL_testz00_23655;

																				if (PROCEDUREP(BgL_rz00_16486))
																					{	/* Eval/evaluate_comp.scm 667 */
																						obj_t BgL_arg1696z00_16487;

																						BgL_arg1696z00_16487 =
																							PROCEDURE_ATTR(BgL_rz00_16486);
																						if (STRUCTP(BgL_arg1696z00_16487))
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23655 =
																									(STRUCT_KEY
																									(BgL_arg1696z00_16487) ==
																									BGl_symbol5771z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 647 */
																								BgL_testz00_23655 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						BgL_testz00_23655 = ((bool_t) 0);
																					}
																				if (BgL_testz00_23655)
																					{
																						obj_t BgL_fz00_23663;

																						BgL_fz00_23663 = BgL_rz00_16486;
																						BgL_fz00_16485 = BgL_fz00_23663;
																						goto BgL_recz00_16484;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 667 */
																						VECTOR_SET(BgL_nsz00_16479,
																							((long) 0),
																							BgL_savedzd2bpzd2_16483);
																						BgL_____rz00_16482 = BgL_rz00_16486;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16481);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16478,
																	BgL_sz00_13877);
																return BgL_____rz00_16482;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 889 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16434,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 889 */
												long BgL_nbpz00_16488;

												BgL_nbpz00_16488 =
													((long) CINT(BgL_bpz00_16433) + BgL_siza7eza7_13876);
												VECTOR_SET(
													((obj_t) BgL_sz00_13877), ((long) 0),
													BINT(BgL_nbpz00_16488));
												{	/* Eval/evaluate_comp.scm 889 */
													obj_t BgL_rz00_16489;

													BgL_rz00_16489 =
														PROCEDURE_ENTRY(BgL_fz00_16434) (BgL_fz00_16434,
														BgL_a1z00_16435, BgL_a2z00_16436, BgL_a3z00_16437,
														BgL_a4z00_16438, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13877), ((long) 0),
														BgL_bpz00_16433);
													return BgL_rz00_16489;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 889 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13874,
													BgL_symbzd2funzd2_13875, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16434));
		}}}}}}}}
		BGL_FUNCTION_END;
	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 892 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_gz00_3023;

					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_arg2606z00_3031;
						obj_t BgL_arg2607z00_3032;

						BgL_arg2606z00_3031 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_modz00);
						BgL_arg2607z00_3032 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_namez00);
						BgL_gz00_3023 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg2606z00_3031, BgL_arg2607z00_3032);
					}
					if (CBOOL(BgL_gz00_3023))
						{	/* Eval/evaluate_comp.scm 898 */
							bool_t BgL_testz00_23697;

							{	/* Eval/evaluate_comp.scm 898 */
								int BgL_arg2604z00_3030;

								{	/* Eval/evaluate_comp.scm 898 */
									int BgL_res4932z00_9306;

									BgL_res4932z00_9306 =
										CINT(VECTOR_REF(((obj_t) BgL_gz00_3023), ((long) 0)));
									BgL_arg2604z00_3030 = BgL_res4932z00_9306;
								}
								BgL_testz00_23697 =
									((long) (BgL_arg2604z00_3030) == ((long) 0));
							}
							if (BgL_testz00_23697)
								{	/* Eval/evaluate_comp.scm 899 */
									obj_t BgL_valz00_3026;

									BgL_valz00_3026 =
										VECTOR_REF(((obj_t) BgL_gz00_3023), ((long) 2));
									{	/* Eval/evaluate_comp.scm 900 */
										bool_t BgL_testz00_23705;

										if (PROCEDUREP(BgL_valz00_3026))
											{	/* Eval/evaluate_comp.scm 900 */
												BgL_testz00_23705 =
													PROCEDURE_CORRECT_ARITYP(BgL_valz00_3026,
													(int) (BgL_nbargsz00_184));
											}
										else
											{	/* Eval/evaluate_comp.scm 900 */
												BgL_testz00_23705 = ((bool_t) 0);
											}
										if (BgL_testz00_23705)
											{	/* Eval/evaluate_comp.scm 900 */
												return BgL_valz00_3026;
											}
										else
											{	/* Eval/evaluate_comp.scm 900 */
												return BFALSE;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 898 */
									return BFALSE;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 897 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 903 */
					bool_t BgL_testz00_23710;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 904 */
							obj_t BgL_tmpz00_23714;

							BgL_tmpz00_23714 =
								(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_testz00_23710 = PROCEDUREP(BgL_tmpz00_23714);
						}
					else
						{	/* Eval/evaluate_comp.scm 903 */
							BgL_testz00_23710 = ((bool_t) 0);
						}
					if (BgL_testz00_23710)
						{	/* Eval/evaluate_comp.scm 906 */
							bool_t BgL_testz00_23718;

							{	/* Eval/evaluate_comp.scm 906 */
								obj_t BgL_arg2616z00_3042;

								BgL_arg2616z00_3042 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								BgL_testz00_23718 =
									PROCEDURE_CORRECT_ARITYP(BgL_arg2616z00_3042,
									(int) (BgL_nbargsz00_184));
							}
							if (BgL_testz00_23718)
								{	/* Eval/evaluate_comp.scm 906 */
									return
										(((BgL_ev_littz00_bglt) COBJECT(
												((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 908 */
									int BgL_arg2613z00_3040;

									{	/* Eval/evaluate_comp.scm 908 */
										obj_t BgL_arg2614z00_3041;

										BgL_arg2614z00_3041 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_funz00_183)))->
											BgL_valuez00);
										BgL_arg2613z00_3040 = PROCEDURE_ARITY(BgL_arg2614z00_3041);
									}
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										BgL_arg2613z00_3040);
						}}
					else
						{	/* Eval/evaluate_comp.scm 903 */
							return BFALSE;
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 911 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 915 */
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 917 */
							obj_t BgL_v1349z00_3051;

							BgL_v1349z00_3051 = create_vector(((long) 2));
							VECTOR_SET(BgL_v1349z00_3051, ((long) 0), BINT(((long) 1)));
							{	/* Eval/evaluate_comp.scm 917 */
								double BgL_arg2622z00_3052;

								BgL_arg2622z00_3052 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00)));
								VECTOR_SET(BgL_v1349z00_3051, ((long) 1),
									DOUBLE_TO_REAL(BgL_arg2622z00_3052));
							}
							return BgL_v1349z00_3051;
						}
					else
						{	/* Eval/evaluate_comp.scm 918 */
							bool_t BgL_testz00_23745;

							{	/* Eval/evaluate_comp.scm 918 */
								obj_t BgL_tmpz00_23746;

								BgL_tmpz00_23746 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00);
								BgL_testz00_23745 = REALP(BgL_tmpz00_23746);
							}
							if (BgL_testz00_23745)
								{	/* Eval/evaluate_comp.scm 918 */
									obj_t BgL_v1350z00_3056;

									BgL_v1350z00_3056 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1350z00_3056, ((long) 0), BINT(((long) 1)));
									{	/* Eval/evaluate_comp.scm 918 */
										obj_t BgL_arg2626z00_3057;

										BgL_arg2626z00_3057 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00);
										VECTOR_SET(BgL_v1350z00_3056, ((long) 1),
											BgL_arg2626z00_3057);
									}
									return BgL_v1350z00_3056;
								}
							else
								{	/* Eval/evaluate_comp.scm 919 */
									obj_t BgL_v1351z00_3058;

									BgL_v1351z00_3058 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1351z00_3058, ((long) 0), BINT(((long) 0)));
									{	/* Eval/evaluate_comp.scm 919 */
										obj_t BgL_arg2627z00_3059;

										BgL_arg2627z00_3059 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1351z00_3058, ((long) 1),
											BgL_arg2627z00_3059);
									}
									return BgL_v1351z00_3058;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 915 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 920 */
							if (CBOOL(
									(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_exprz00_187)))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 923 */
									obj_t BgL_v1352z00_3065;

									BgL_v1352z00_3065 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1352z00_3065, ((long) 0), BINT(((long) 3)));
									VECTOR_SET(BgL_v1352z00_3065, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1352z00_3065;
								}
							else
								{	/* Eval/evaluate_comp.scm 924 */
									obj_t BgL_v1353z00_3067;

									BgL_v1353z00_3067 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1353z00_3067, ((long) 0), BINT(((long) 2)));
									VECTOR_SET(BgL_v1353z00_3067, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1353z00_3067;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 920 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 927 */
									obj_t BgL_gz00_3071;

									{	/* Eval/evaluate_comp.scm 927 */
										obj_t BgL_arg2641z00_3079;
										obj_t BgL_arg2642z00_3080;

										BgL_arg2641z00_3079 =
											(((BgL_ev_globalz00_bglt) COBJECT(
													((BgL_ev_globalz00_bglt) BgL_exprz00_187)))->
											BgL_modz00);
										BgL_arg2642z00_3080 =
											(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
														BgL_exprz00_187)))->BgL_namez00);
										BgL_gz00_3071 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00
											(BgL_arg2641z00_3079, BgL_arg2642z00_3080);
									}
									if (CBOOL(BgL_gz00_3071))
										{	/* Eval/evaluate_comp.scm 929 */
											bool_t BgL_testz00_23788;

											{	/* Eval/evaluate_comp.scm 929 */
												int BgL_arg2638z00_3076;

												{	/* Eval/evaluate_comp.scm 929 */
													int BgL_res4939z00_9329;

													BgL_res4939z00_9329 =
														CINT(VECTOR_REF(
															((obj_t) BgL_gz00_3071), ((long) 0)));
													BgL_arg2638z00_3076 = BgL_res4939z00_9329;
												}
												BgL_testz00_23788 =
													(BINT(BgL_arg2638z00_3076) == BINT(((long) 1)));
											}
											if (BgL_testz00_23788)
												{	/* Eval/evaluate_comp.scm 930 */
													obj_t BgL_v1354z00_3074;

													BgL_v1354z00_3074 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1354z00_3074, ((long) 0),
														BINT(((long) 4)));
													VECTOR_SET(BgL_v1354z00_3074, ((long) 1),
														BgL_gz00_3071);
													return BgL_v1354z00_3074;
												}
											else
												{	/* Eval/evaluate_comp.scm 931 */
													obj_t BgL_v1355z00_3075;

													BgL_v1355z00_3075 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1355z00_3075, ((long) 0),
														BINT(((long) 5)));
													VECTOR_SET(BgL_v1355z00_3075, ((long) 1),
														BgL_gz00_3071);
													return BgL_v1355z00_3075;
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 932 */
											obj_t BgL_v1356z00_3077;

											BgL_v1356z00_3077 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1356z00_3077, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 932 */
												obj_t BgL_arg2640z00_3078;

												BgL_arg2640z00_3078 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt)
														((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1356z00_3077, ((long) 1),
													BgL_arg2640z00_3078);
											}
											return BgL_v1356z00_3077;
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 925 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 935 */
											obj_t BgL_fvalz00_3083;

											{	/* Eval/evaluate_comp.scm 935 */
												BgL_ev_exprz00_bglt BgL_arg2689z00_3131;

												BgL_arg2689z00_3131 =
													(((BgL_ev_appz00_bglt) COBJECT(
															((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
													BgL_funz00);
												BgL_fvalz00_3083 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00
													(BgL_arg2689z00_3131);
											}
											if (
												(BgL_fvalz00_3083 ==
													BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
												{	/* Eval/evaluate_comp.scm 938 */
													obj_t BgL_v1357z00_3085;

													BgL_v1357z00_3085 = create_vector(((long) 3));
													VECTOR_SET(BgL_v1357z00_3085, ((long) 0),
														BINT(((long) 6)));
													{	/* Eval/evaluate_comp.scm 938 */
														obj_t BgL_arg2645z00_3086;

														{	/* Eval/evaluate_comp.scm 938 */
															obj_t BgL_arg2646z00_3087;

															{	/* Eval/evaluate_comp.scm 938 */
																obj_t BgL_pairz00_9337;

																BgL_pairz00_9337 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2646z00_3087 = CAR(BgL_pairz00_9337);
															}
															BgL_arg2645z00_3086 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2646z00_3087, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1357z00_3085, ((long) 1),
															BgL_arg2645z00_3086);
													}
													{	/* Eval/evaluate_comp.scm 938 */
														obj_t BgL_arg2649z00_3089;

														{	/* Eval/evaluate_comp.scm 938 */
															obj_t BgL_arg2650z00_3090;

															{	/* Eval/evaluate_comp.scm 938 */
																obj_t BgL_pairz00_9339;

																BgL_pairz00_9339 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2650z00_3090 =
																	CAR(CDR(BgL_pairz00_9339));
															}
															BgL_arg2649z00_3089 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2650z00_3090, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1357z00_3085, ((long) 2),
															BgL_arg2649z00_3089);
													}
													return BgL_v1357z00_3085;
												}
											else
												{	/* Eval/evaluate_comp.scm 937 */
													if (
														(BgL_fvalz00_3083 ==
															BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
														{	/* Eval/evaluate_comp.scm 940 */
															obj_t BgL_v1358z00_3093;

															BgL_v1358z00_3093 = create_vector(((long) 3));
															VECTOR_SET(BgL_v1358z00_3093, ((long) 0),
																BINT(((long) 7)));
															{	/* Eval/evaluate_comp.scm 940 */
																obj_t BgL_arg2653z00_3094;

																{	/* Eval/evaluate_comp.scm 940 */
																	obj_t BgL_arg2654z00_3095;

																	{	/* Eval/evaluate_comp.scm 940 */
																		obj_t BgL_pairz00_9345;

																		BgL_pairz00_9345 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2654z00_3095 = CAR(BgL_pairz00_9345);
																	}
																	BgL_arg2653z00_3094 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2654z00_3095, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1358z00_3093, ((long) 1),
																	BgL_arg2653z00_3094);
															}
															{	/* Eval/evaluate_comp.scm 940 */
																obj_t BgL_arg2656z00_3097;

																{	/* Eval/evaluate_comp.scm 940 */
																	obj_t BgL_arg2658z00_3098;

																	{	/* Eval/evaluate_comp.scm 940 */
																		obj_t BgL_pairz00_9347;

																		BgL_pairz00_9347 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2658z00_3098 =
																			CAR(CDR(BgL_pairz00_9347));
																	}
																	BgL_arg2656z00_3097 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2658z00_3098, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1358z00_3093, ((long) 2),
																	BgL_arg2656z00_3097);
															}
															return BgL_v1358z00_3093;
														}
													else
														{	/* Eval/evaluate_comp.scm 939 */
															if (
																(BgL_fvalz00_3083 ==
																	BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																{	/* Eval/evaluate_comp.scm 942 */
																	obj_t BgL_v1359z00_3101;

																	BgL_v1359z00_3101 = create_vector(((long) 3));
																	VECTOR_SET(BgL_v1359z00_3101, ((long) 0),
																		BINT(((long) 8)));
																	{	/* Eval/evaluate_comp.scm 942 */
																		obj_t BgL_arg2661z00_3102;

																		{	/* Eval/evaluate_comp.scm 942 */
																			obj_t BgL_arg2662z00_3103;

																			{	/* Eval/evaluate_comp.scm 942 */
																				obj_t BgL_pairz00_9353;

																				BgL_pairz00_9353 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2662z00_3103 =
																					CAR(BgL_pairz00_9353);
																			}
																			BgL_arg2661z00_3102 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2662z00_3103, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1359z00_3101, ((long) 1),
																			BgL_arg2661z00_3102);
																	}
																	{	/* Eval/evaluate_comp.scm 942 */
																		obj_t BgL_arg2664z00_3105;

																		{	/* Eval/evaluate_comp.scm 942 */
																			obj_t BgL_arg2666z00_3106;

																			{	/* Eval/evaluate_comp.scm 942 */
																				obj_t BgL_pairz00_9355;

																				BgL_pairz00_9355 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2666z00_3106 =
																					CAR(CDR(BgL_pairz00_9355));
																			}
																			BgL_arg2664z00_3105 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2666z00_3106, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1359z00_3101, ((long) 2),
																			BgL_arg2664z00_3105);
																	}
																	return BgL_v1359z00_3101;
																}
															else
																{	/* Eval/evaluate_comp.scm 941 */
																	if (
																		(BgL_fvalz00_3083 ==
																			BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																		{	/* Eval/evaluate_comp.scm 944 */
																			obj_t BgL_v1360z00_3109;

																			BgL_v1360z00_3109 =
																				create_vector(((long) 3));
																			VECTOR_SET(BgL_v1360z00_3109, ((long) 0),
																				BINT(((long) 9)));
																			{	/* Eval/evaluate_comp.scm 944 */
																				obj_t BgL_arg2669z00_3110;

																				{	/* Eval/evaluate_comp.scm 944 */
																					obj_t BgL_arg2670z00_3111;

																					{	/* Eval/evaluate_comp.scm 944 */
																						obj_t BgL_pairz00_9361;

																						BgL_pairz00_9361 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2670z00_3111 =
																							CAR(BgL_pairz00_9361);
																					}
																					BgL_arg2669z00_3110 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2670z00_3111,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1360z00_3109,
																					((long) 1), BgL_arg2669z00_3110);
																			}
																			{	/* Eval/evaluate_comp.scm 944 */
																				obj_t BgL_arg2673z00_3113;

																				{	/* Eval/evaluate_comp.scm 944 */
																					obj_t BgL_arg2674z00_3114;

																					{	/* Eval/evaluate_comp.scm 944 */
																						obj_t BgL_pairz00_9363;

																						BgL_pairz00_9363 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2674z00_3114 =
																							CAR(CDR(BgL_pairz00_9363));
																					}
																					BgL_arg2673z00_3113 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2674z00_3114,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1360z00_3109,
																					((long) 2), BgL_arg2673z00_3113);
																			}
																			return BgL_v1360z00_3109;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 943 */
																			if (
																				(BgL_fvalz00_3083 ==
																					BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 946 */
																					obj_t BgL_v1361z00_3117;

																					BgL_v1361z00_3117 =
																						create_vector(((long) 2));
																					VECTOR_SET(BgL_v1361z00_3117,
																						((long) 0), BINT(((long) 10)));
																					{	/* Eval/evaluate_comp.scm 946 */
																						obj_t BgL_arg2677z00_3118;

																						{	/* Eval/evaluate_comp.scm 946 */
																							obj_t BgL_arg2678z00_3119;

																							{	/* Eval/evaluate_comp.scm 946 */
																								obj_t BgL_pairz00_9369;

																								BgL_pairz00_9369 =
																									(((BgL_ev_appz00_bglt)
																										COBJECT((
																												(BgL_ev_appz00_bglt)
																												BgL_exprz00_187)))->
																									BgL_argsz00);
																								BgL_arg2678z00_3119 =
																									CAR(BgL_pairz00_9369);
																							}
																							BgL_arg2677z00_3118 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_arg2678z00_3119),
																								BgL_stkz00_188);
																						}
																						VECTOR_SET(BgL_v1361z00_3117,
																							((long) 1), BgL_arg2677z00_3118);
																					}
																					return BgL_v1361z00_3117;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 945 */
																					if (
																						(BgL_fvalz00_3083 ==
																							BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																						{	/* Eval/evaluate_comp.scm 948 */
																							obj_t BgL_v1362z00_3122;

																							BgL_v1362z00_3122 =
																								create_vector(((long) 3));
																							VECTOR_SET(BgL_v1362z00_3122,
																								((long) 0), BINT(((long) 11)));
																							{	/* Eval/evaluate_comp.scm 948 */
																								obj_t BgL_arg2681z00_3123;

																								{	/* Eval/evaluate_comp.scm 948 */
																									obj_t BgL_arg2683z00_3124;

																									{	/* Eval/evaluate_comp.scm 948 */
																										obj_t BgL_pairz00_9372;

																										BgL_pairz00_9372 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2683z00_3124 =
																											CAR(BgL_pairz00_9372);
																									}
																									BgL_arg2681z00_3123 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2683z00_3124),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1362z00_3122,
																									((long) 1),
																									BgL_arg2681z00_3123);
																							}
																							{	/* Eval/evaluate_comp.scm 948 */
																								obj_t BgL_arg2685z00_3126;

																								{	/* Eval/evaluate_comp.scm 948 */
																									obj_t BgL_arg2686z00_3127;

																									{	/* Eval/evaluate_comp.scm 948 */
																										obj_t BgL_pairz00_9374;

																										BgL_pairz00_9374 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2686z00_3127 =
																											CAR(CDR
																											(BgL_pairz00_9374));
																									}
																									BgL_arg2685z00_3126 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2686z00_3127),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1362z00_3122,
																									((long) 2),
																									BgL_arg2685z00_3126);
																							}
																							return BgL_v1362z00_3122;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 950 */
																							obj_t BgL_v1363z00_3129;

																							BgL_v1363z00_3129 =
																								create_vector(((long) 2));
																							VECTOR_SET(BgL_v1363z00_3129,
																								((long) 0), BINT(((long) 0)));
																							{	/* Eval/evaluate_comp.scm 950 */
																								obj_t BgL_arg2688z00_3130;

																								BgL_arg2688z00_3130 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt) (
																											(BgL_ev_appz00_bglt)
																											BgL_exprz00_187)),
																									BgL_stkz00_188);
																								VECTOR_SET(BgL_v1363z00_3129,
																									((long) 1),
																									BgL_arg2688z00_3130);
																							}
																							return BgL_v1363z00_3129;
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 951 */
											obj_t BgL_v1364z00_3132;

											BgL_v1364z00_3132 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1364z00_3132, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 951 */
												obj_t BgL_arg2690z00_3133;

												BgL_arg2690z00_3133 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1364z00_3132, ((long) 1),
													BgL_arg2690z00_3133);
											}
											return BgL_v1364z00_3132;
										}
								}
						}
				}
		}
		BGL_FUNCTION_END;
	}



/* eval-float-arith */
	double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189,
		obj_t BgL_sz00_190)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 953 */
			return
				REAL_TO_DOUBLE(BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190,
					BgL_bcz00_189));
		}
		BGL_FUNCTION_END;
	}



/* E~0 */
	obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_15540,
		obj_t BgL_bcz00_3138)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 968 */
			{	/* Eval/evaluate_comp.scm 955 */
				obj_t BgL_aux1220z00_3141;

				BgL_aux1220z00_3141 = VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 0));
				if (INTEGERP(BgL_aux1220z00_3141))
					{	/* Eval/evaluate_comp.scm 955 */
						switch ((long) CINT(BgL_aux1220z00_3141))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 956 */
									obj_t BgL_fun2694z00_3143;

									BgL_fun2694z00_3143 =
										VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
									return
										PROCEDURE_ENTRY(BgL_fun2694z00_3143) (BgL_fun2694z00_3143,
										BgL_sz00_15540, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 958 */
									long BgL_arg2695z00_3144;

									{	/* Eval/evaluate_comp.scm 958 */
										obj_t BgL_arg2696z00_3145;
										obj_t BgL_arg2697z00_3146;

										BgL_arg2696z00_3145 =
											VECTOR_REF(((obj_t) BgL_sz00_15540), ((long) 0));
										BgL_arg2697z00_3146 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2695z00_3144 =
											(
											(long) CINT(BgL_arg2696z00_3145) +
											(long) CINT(BgL_arg2697z00_3146));
									}
									return
										VECTOR_REF(((obj_t) BgL_sz00_15540), BgL_arg2695z00_3144);
								}
								break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 959 */
									obj_t BgL_arg2699z00_3147;

									{	/* Eval/evaluate_comp.scm 959 */
										long BgL_arg2700z00_3148;

										{	/* Eval/evaluate_comp.scm 959 */
											obj_t BgL_arg2701z00_3149;
											obj_t BgL_arg2702z00_3150;

											BgL_arg2701z00_3149 =
												VECTOR_REF(((obj_t) BgL_sz00_15540), ((long) 0));
											BgL_arg2702z00_3150 =
												VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
											BgL_arg2700z00_3148 =
												(
												(long) CINT(BgL_arg2701z00_3149) +
												(long) CINT(BgL_arg2702z00_3150));
										}
										BgL_arg2699z00_3147 =
											VECTOR_REF(((obj_t) BgL_sz00_15540), BgL_arg2700z00_3148);
									}
									return
										STRUCT_REF(
										((obj_t) BgL_arg2699z00_3147), (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 960 */
									obj_t BgL_arg2703z00_3151;

									{	/* Eval/evaluate_comp.scm 960 */
										obj_t BgL_arg2705z00_3152;

										BgL_arg2705z00_3152 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2703z00_3151 =
											VECTOR_REF(((obj_t) BgL_arg2705z00_3152), ((long) 2));
									}
									return __EVMEANING_ADDRESS_REF(BgL_arg2703z00_3151);
								}
								break;
							case ((long) 5):

								{	/* Eval/evaluate_comp.scm 961 */
									obj_t BgL_arg2706z00_3153;

									BgL_arg2706z00_3153 =
										VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
									return VECTOR_REF(((obj_t) BgL_arg2706z00_3153), ((long) 2));
								} break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 962 */
									obj_t BgL_arg2707z00_3154;
									obj_t BgL_arg2708z00_3155;

									{	/* Eval/evaluate_comp.scm 962 */
										obj_t BgL_arg2709z00_3156;

										BgL_arg2709z00_3156 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2707z00_3154 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2709z00_3156);
									}
									{	/* Eval/evaluate_comp.scm 962 */
										obj_t BgL_arg2710z00_3157;

										BgL_arg2710z00_3157 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 2));
										BgL_arg2708z00_3155 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2710z00_3157);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2707z00_3154) +
											REAL_TO_DOUBLE(BgL_arg2708z00_3155)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 963 */
									obj_t BgL_arg2711z00_3158;
									obj_t BgL_arg2712z00_3159;

									{	/* Eval/evaluate_comp.scm 963 */
										obj_t BgL_arg2713z00_3160;

										BgL_arg2713z00_3160 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2711z00_3158 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2713z00_3160);
									}
									{	/* Eval/evaluate_comp.scm 963 */
										obj_t BgL_arg2714z00_3161;

										BgL_arg2714z00_3161 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 2));
										BgL_arg2712z00_3159 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2714z00_3161);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2711z00_3158) -
											REAL_TO_DOUBLE(BgL_arg2712z00_3159)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 964 */
									obj_t BgL_arg2715z00_3162;
									obj_t BgL_arg2716z00_3163;

									{	/* Eval/evaluate_comp.scm 964 */
										obj_t BgL_arg2718z00_3164;

										BgL_arg2718z00_3164 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2715z00_3162 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2718z00_3164);
									}
									{	/* Eval/evaluate_comp.scm 964 */
										obj_t BgL_arg2719z00_3165;

										BgL_arg2719z00_3165 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 2));
										BgL_arg2716z00_3163 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2719z00_3165);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2715z00_3162) *
											REAL_TO_DOUBLE(BgL_arg2716z00_3163)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 965 */
									obj_t BgL_arg2720z00_3166;
									obj_t BgL_arg2721z00_3167;

									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2722z00_3168;

										BgL_arg2722z00_3168 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2720z00_3166 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2722z00_3168);
									}
									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2723z00_3169;

										BgL_arg2723z00_3169 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 2));
										BgL_arg2721z00_3167 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15540,
											BgL_arg2723z00_3169);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2720z00_3166) /
											REAL_TO_DOUBLE(BgL_arg2721z00_3167)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 966 */
									obj_t BgL_arg2724z00_3170;

									{	/* Eval/evaluate_comp.scm 966 */
										obj_t BgL_fun2725z00_3171;

										BgL_fun2725z00_3171 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2724z00_3170 =
											PROCEDURE_ENTRY(BgL_fun2725z00_3171) (BgL_fun2725z00_3171,
											BgL_sz00_15540, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2724z00_3170)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 967 */
									obj_t BgL_arg2726z00_3172;
									obj_t BgL_arg2727z00_3173;

									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_fun2728z00_3174;

										BgL_fun2728z00_3174 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 1));
										BgL_arg2726z00_3172 =
											PROCEDURE_ENTRY(BgL_fun2728z00_3174) (BgL_fun2728z00_3174,
											BgL_sz00_15540, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_fun2729z00_3175;

										BgL_fun2729z00_3175 =
											VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 2));
										BgL_arg2727z00_3173 =
											PROCEDURE_ENTRY(BgL_fun2729z00_3175) (BgL_fun2729z00_3175,
											BgL_sz00_15540, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 967 */
										double BgL_tmpz00_24026;

										{	/* Eval/evaluate_comp.scm 967 */
											long BgL_tmpz00_24027;

											BgL_tmpz00_24027 = (long) CINT(BgL_arg2727z00_3173);
											BgL_tmpz00_24026 =
												BGL_F64VREF(BgL_arg2726z00_3172, BgL_tmpz00_24027);
										}
										return DOUBLE_TO_REAL(BgL_tmpz00_24026);
									}
								}
								break;
							default:
								{	/* Eval/evaluate_comp.scm 968 */
									obj_t BgL_arg2730z00_9434;

									BgL_arg2730z00_9434 =
										VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 0));
									return
										BGl_errorz00zz__errorz00
										(BGl_string5775z00zz__evaluate_compz00,
										BGl_string5794z00zz__evaluate_compz00, BgL_arg2730z00_9434);
								}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 968 */
						obj_t BgL_arg2730z00_9436;

						BgL_arg2730z00_9436 =
							VECTOR_REF(((obj_t) BgL_bcz00_3138), ((long) 0));
						return
							BGl_errorz00zz__errorz00(BGl_string5775z00zz__evaluate_compz00,
							BGl_string5794z00zz__evaluate_compz00, BgL_arg2730z00_9436);
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 971 */
			{	/* Eval/evaluate_comp.scm 973 */
				obj_t BgL_fvalz00_3179;

				BgL_fvalz00_3179 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 974 */
					bool_t BgL_testz00_24041;

					if (
						(BgL_fvalz00_3179 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 974 */
							BgL_testz00_24041 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 974 */
							if (
								(BgL_fvalz00_3179 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 974 */
									BgL_testz00_24041 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 974 */
									if (
										(BgL_fvalz00_3179 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 974 */
											BgL_testz00_24041 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 974 */
											BgL_testz00_24041 =
												(BgL_fvalz00_3179 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_testz00_24041)
						{	/* Eval/evaluate_comp.scm 975 */
							obj_t BgL_bcz00_3184;

							BgL_bcz00_3184 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 976 */
								obj_t BgL_zc3anonymousza32735ze3z83_13895;

								BgL_zc3anonymousza32735ze3z83_13895 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3anonymousza32735ze3z83_13895,
									(int) (((long) 0)), BgL_bcz00_3184);
								return BgL_zc3anonymousza32735ze3z83_13895;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 974 */
							return BFALSE;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2735> */
	obj_t BGl_z62zc3anonymousza32735ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13896, obj_t BgL_sz00_13898)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 976 */
			{	/* Eval/evaluate_comp.scm 976 */
				obj_t BgL_bcz00_13897;

				BgL_bcz00_13897 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13896, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 976 */
					double BgL_tmpz00_24059;

					{	/* Eval/evaluate_comp.scm 976 */
						obj_t BgL_bpz00_16490;

						BgL_bpz00_16490 = VECTOR_REF(((obj_t) BgL_sz00_13898), ((long) 0));
						BgL_tmpz00_24059 =
							BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_13897,
							BgL_sz00_13898);
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_24059);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1005 */
			{	/* Eval/evaluate_comp.scm 1006 */
				obj_t BgL_valz00_3192;

				BgL_valz00_3192 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_3192))
					{	/* Eval/evaluate_comp.scm 1008 */
						long BgL_nz00_3193;

						BgL_nz00_3193 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 1009 */
							obj_t BgL__ortest_1226z00_3194;

							if ((BgL_nz00_3193 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 1010 */
									obj_t BgL_a1z00_3485;

									BgL_a1z00_3485 = CAR(((obj_t) BgL_argsz00_195));
									if (
										(BgL_valz00_3192 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 1011 */
											obj_t BgL_a1z00_3487;

											BgL_a1z00_3487 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_3485), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 1011 */
												obj_t BgL_zc3anonymousza32853ze3z83_13928;

												BgL_zc3anonymousza32853ze3z83_13928 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32853ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3anonymousza32853ze3z83_13928,
													(int) (((long) 0)), BgL_a1z00_3487);
												PROCEDURE_SET(BgL_zc3anonymousza32853ze3z83_13928,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1226z00_3194 =
													BgL_zc3anonymousza32853ze3z83_13928;
										}}
									else
										{	/* Eval/evaluate_comp.scm 1011 */
											if (
												(BgL_valz00_3192 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 1011 */
													obj_t BgL_a1z00_3494;

													BgL_a1z00_3494 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3485),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1011 */
														obj_t BgL_zc3anonymousza32856ze3z83_13929;

														BgL_zc3anonymousza32856ze3z83_13929 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza32856ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET(BgL_zc3anonymousza32856ze3z83_13929,
															(int) (((long) 0)), BgL_a1z00_3494);
														PROCEDURE_SET(BgL_zc3anonymousza32856ze3z83_13929,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1226z00_3194 =
															BgL_zc3anonymousza32856ze3z83_13929;
												}}
											else
												{	/* Eval/evaluate_comp.scm 1011 */
													if (
														(BgL_valz00_3192 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 1011 */
															obj_t BgL_a1z00_3501;

															BgL_a1z00_3501 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3485),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1011 */
																obj_t BgL_zc3anonymousza32859ze3z83_13930;

																BgL_zc3anonymousza32859ze3z83_13930 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza32859ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza32859ze3z83_13930,
																	(int) (((long) 0)), BgL_a1z00_3501);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32859ze3z83_13930,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1226z00_3194 =
																	BgL_zc3anonymousza32859ze3z83_13930;
														}}
													else
														{	/* Eval/evaluate_comp.scm 1011 */
															BgL__ortest_1226z00_3194 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1009 */
									BgL__ortest_1226z00_3194 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1226z00_3194))
								{	/* Eval/evaluate_comp.scm 1009 */
									return BgL__ortest_1226z00_3194;
								}
							else
								{	/* Eval/evaluate_comp.scm 1009 */
									if ((BgL_nz00_3193 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 1013 */
											obj_t BgL_a1z00_3196;
											obj_t BgL_a2z00_3197;

											BgL_a1z00_3196 = CAR(((obj_t) BgL_argsz00_195));
											{	/* Eval/evaluate_comp.scm 1013 */
												obj_t BgL_pairz00_9468;

												BgL_pairz00_9468 = CDR(((obj_t) BgL_argsz00_195));
												BgL_a2z00_3197 = CAR(BgL_pairz00_9468);
											}
											if (
												(BgL_valz00_3192 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 1014 */
													obj_t BgL_a1z00_3199;
													obj_t BgL_a2z00_3200;

													BgL_a1z00_3199 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3196),
														BgL_stkz00_196);
													BgL_a2z00_3200 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_3197),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1014 */
														obj_t BgL_zc3anonymousza32740ze3z83_13899;

														BgL_zc3anonymousza32740ze3z83_13899 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza32740ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET(BgL_zc3anonymousza32740ze3z83_13899,
															(int) (((long) 0)), BgL_a1z00_3199);
														PROCEDURE_SET(BgL_zc3anonymousza32740ze3z83_13899,
															(int) (((long) 1)), BgL_a2z00_3200);
														PROCEDURE_SET(BgL_zc3anonymousza32740ze3z83_13899,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3anonymousza32740ze3z83_13899;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 1014 */
													if (
														(BgL_valz00_3192 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 1014 */
															obj_t BgL_a1z00_3209;
															obj_t BgL_a2z00_3210;

															BgL_a1z00_3209 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3196),
																BgL_stkz00_196);
															BgL_a2z00_3210 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_3197),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1014 */
																obj_t BgL_zc3anonymousza32744ze3z83_13900;

																BgL_zc3anonymousza32744ze3z83_13900 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza32744ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza32744ze3z83_13900,
																	(int) (((long) 0)), BgL_a1z00_3209);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32744ze3z83_13900,
																	(int) (((long) 1)), BgL_a2z00_3210);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32744ze3z83_13900,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3anonymousza32744ze3z83_13900;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 1014 */
															if (
																(BgL_valz00_3192 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 1014 */
																	obj_t BgL_a1z00_3219;
																	obj_t BgL_a2z00_3220;

																	BgL_a1z00_3219 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_3196),
																		BgL_stkz00_196);
																	BgL_a2z00_3220 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_3197),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 1014 */
																		obj_t BgL_zc3anonymousza32748ze3z83_13901;

																		BgL_zc3anonymousza32748ze3z83_13901 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3anonymousza32748ze3ze1zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32748ze3z83_13901,
																			(int) (((long) 0)), BgL_a1z00_3219);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32748ze3z83_13901,
																			(int) (((long) 1)), BgL_a2z00_3220);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32748ze3z83_13901,
																			(int) (((long) 2)), BgL_locz00_193);
																		return BgL_zc3anonymousza32748ze3z83_13901;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 1014 */
																	if (
																		(BgL_valz00_3192 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 1014 */
																			obj_t BgL_a1z00_3229;
																			obj_t BgL_a2z00_3230;

																			BgL_a1z00_3229 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_3196),
																				BgL_stkz00_196);
																			BgL_a2z00_3230 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_3197),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 1014 */
																				obj_t
																					BgL_zc3anonymousza32752ze3z83_13902;
																				BgL_zc3anonymousza32752ze3z83_13902 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3anonymousza32752ze3ze1zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32752ze3z83_13902,
																					(int) (((long) 0)), BgL_a1z00_3229);
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32752ze3z83_13902,
																					(int) (((long) 1)), BgL_a2z00_3230);
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32752ze3z83_13902,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3anonymousza32752ze3z83_13902;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1014 */
																			if (
																				(BgL_valz00_3192 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 1014 */
																					obj_t BgL_a1z00_3239;
																					obj_t BgL_a2z00_3240;

																					BgL_a1z00_3239 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_3196), BgL_stkz00_196);
																					BgL_a2z00_3240 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_3197), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 1014 */
																						obj_t
																							BgL_zc3anonymousza32756ze3z83_13903;
																						BgL_zc3anonymousza32756ze3z83_13903
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3anonymousza32756ze3ze1zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32756ze3z83_13903,
																							(int) (((long) 0)),
																							BgL_a1z00_3239);
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32756ze3z83_13903,
																							(int) (((long) 1)),
																							BgL_a2z00_3240);
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32756ze3z83_13903,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3anonymousza32756ze3z83_13903;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1014 */
																					if (
																						(BgL_valz00_3192 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 1014 */
																							obj_t BgL_a1z00_3249;
																							obj_t BgL_a2z00_3250;

																							BgL_a1z00_3249 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_3196),
																								BgL_stkz00_196);
																							BgL_a2z00_3250 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_3197),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 1014 */
																								obj_t
																									BgL_zc3anonymousza32760ze3z83_13904;
																								BgL_zc3anonymousza32760ze3z83_13904
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3anonymousza32760ze3ze1zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32760ze3z83_13904,
																									(int) (((long) 0)),
																									BgL_a1z00_3249);
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32760ze3z83_13904,
																									(int) (((long) 1)),
																									BgL_a2z00_3250);
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32760ze3z83_13904,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3anonymousza32760ze3z83_13904;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 1014 */
																							if (
																								(BgL_valz00_3192 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 1014 */
																									obj_t BgL_a1z00_3259;
																									obj_t BgL_a2z00_3260;

																									BgL_a1z00_3259 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_3196),
																										BgL_stkz00_196);
																									BgL_a2z00_3260 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_3197),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 1014 */
																										obj_t
																											BgL_zc3anonymousza32764ze3z83_13905;
																										BgL_zc3anonymousza32764ze3z83_13905
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3anonymousza32764ze3ze1zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32764ze3z83_13905,
																											(int) (((long) 0)),
																											BgL_a1z00_3259);
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32764ze3z83_13905,
																											(int) (((long) 1)),
																											BgL_a2z00_3260);
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32764ze3z83_13905,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3anonymousza32764ze3z83_13905;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 1014 */
																									if (
																										(BgL_valz00_3192 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 1014 */
																											obj_t BgL_a1z00_3269;
																											obj_t BgL_a2z00_3270;

																											BgL_a1z00_3269 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_3196),
																												BgL_stkz00_196);
																											BgL_a2z00_3270 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_3197),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 1014 */
																												obj_t
																													BgL_zc3anonymousza32768ze3z83_13906;
																												BgL_zc3anonymousza32768ze3z83_13906
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3anonymousza32768ze3ze1zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32768ze3z83_13906,
																													(int) (((long) 0)),
																													BgL_a1z00_3269);
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32768ze3z83_13906,
																													(int) (((long) 1)),
																													BgL_a2z00_3270);
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32768ze3z83_13906,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3anonymousza32768ze3z83_13906;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 1014 */
																											if (
																												(BgL_valz00_3192 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 1014 */
																													obj_t BgL_a1z00_3279;
																													obj_t BgL_a2z00_3280;

																													BgL_a1z00_3279 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																													BgL_a2z00_3280 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 1014 */
																														obj_t
																															BgL_zc3anonymousza32772ze3z83_13907;
																														BgL_zc3anonymousza32772ze3z83_13907
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3anonymousza32772ze3ze1zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32772ze3z83_13907,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_3279);
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32772ze3z83_13907,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_3280);
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32772ze3z83_13907,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3anonymousza32772ze3z83_13907;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 1014 */
																													if (
																														(BgL_valz00_3192 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 1014 */
																															obj_t
																																BgL_a1z00_3289;
																															obj_t
																																BgL_a2z00_3290;
																															BgL_a1z00_3289 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																															BgL_a2z00_3290 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 1014 */
																																obj_t
																																	BgL_zc3anonymousza32776ze3z83_13908;
																																BgL_zc3anonymousza32776ze3z83_13908
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3anonymousza32776ze3ze1zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32776ze3z83_13908,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_3289);
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32776ze3z83_13908,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_3290);
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32776ze3z83_13908,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3anonymousza32776ze3z83_13908;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 1014 */
																															if (
																																(BgL_valz00_3192
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 1014 */
																																	obj_t
																																		BgL_a1z00_3299;
																																	obj_t
																																		BgL_a2z00_3300;
																																	BgL_a1z00_3299
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																	BgL_a2z00_3300
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 1014 */
																																		obj_t
																																			BgL_zc3anonymousza32780ze3z83_13909;
																																		BgL_zc3anonymousza32780ze3z83_13909
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3anonymousza32780ze3ze1zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32780ze3z83_13909,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_3299);
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32780ze3z83_13909,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_3300);
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32780ze3z83_13909,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3anonymousza32780ze3z83_13909;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 1014 */
																																	if (
																																		(BgL_valz00_3192
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 1014 */
																																			obj_t
																																				BgL_a1z00_3309;
																																			obj_t
																																				BgL_a2z00_3310;
																																			BgL_a1z00_3309
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																			BgL_a2z00_3310
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 1014 */
																																				obj_t
																																					BgL_zc3anonymousza32784ze3z83_13910;
																																				BgL_zc3anonymousza32784ze3z83_13910
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3anonymousza32784ze3ze1zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32784ze3z83_13910,
																																					(int)
																																					(((long) 0)), BgL_a1z00_3309);
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32784ze3z83_13910,
																																					(int)
																																					(((long) 1)), BgL_a2z00_3310);
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32784ze3z83_13910,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3anonymousza32784ze3z83_13910;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 1014 */
																																			if (
																																				(BgL_valz00_3192
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 1014 */
																																					obj_t
																																						BgL_a1z00_3319;
																																					obj_t
																																						BgL_a2z00_3320;
																																					BgL_a1z00_3319
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																					BgL_a2z00_3320
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 1014 */
																																						obj_t
																																							BgL_zc3anonymousza32788ze3z83_13911;
																																						BgL_zc3anonymousza32788ze3z83_13911
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3anonymousza32788ze3ze1zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32788ze3z83_13911,
																																							(int)
																																							(((long) 0)), BgL_a1z00_3319);
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32788ze3z83_13911,
																																							(int)
																																							(((long) 1)), BgL_a2z00_3320);
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32788ze3z83_13911,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3anonymousza32788ze3z83_13911;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 1014 */
																																					if (
																																						(BgL_valz00_3192
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 1014 */
																																							obj_t
																																								BgL_a1z00_3329;
																																							obj_t
																																								BgL_a2z00_3330;
																																							BgL_a1z00_3329
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																							BgL_a2z00_3330
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 1014 */
																																								obj_t
																																									BgL_zc3anonymousza32792ze3z83_13912;
																																								BgL_zc3anonymousza32792ze3z83_13912
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3anonymousza32792ze3ze1zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32792ze3z83_13912,
																																									(int)
																																									(((long) 0)), BgL_a1z00_3329);
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32792ze3z83_13912,
																																									(int)
																																									(((long) 1)), BgL_a2z00_3330);
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32792ze3z83_13912,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3anonymousza32792ze3z83_13912;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 1014 */
																																							if ((BgL_valz00_3192 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 1014 */
																																									obj_t
																																										BgL_a1z00_3339;
																																									obj_t
																																										BgL_a2z00_3340;
																																									BgL_a1z00_3339
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																									BgL_a2z00_3340
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 1014 */
																																										obj_t
																																											BgL_zc3anonymousza32796ze3z83_13913;
																																										BgL_zc3anonymousza32796ze3z83_13913
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3anonymousza32796ze3ze1zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32796ze3z83_13913,
																																											(int)
																																											(((long) 0)), BgL_a1z00_3339);
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32796ze3z83_13913,
																																											(int)
																																											(((long) 1)), BgL_a2z00_3340);
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32796ze3z83_13913,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3anonymousza32796ze3z83_13913;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 1014 */
																																									if ((BgL_valz00_3192 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 1014 */
																																											obj_t
																																												BgL_a1z00_3349;
																																											obj_t
																																												BgL_a2z00_3350;
																																											BgL_a1z00_3349
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																											BgL_a2z00_3350
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 1014 */
																																												obj_t
																																													BgL_zc3anonymousza32800ze3z83_13914;
																																												BgL_zc3anonymousza32800ze3z83_13914
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32800ze3z83_13914,
																																													(int)
																																													(((long) 0)), BgL_a1z00_3349);
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32800ze3z83_13914,
																																													(int)
																																													(((long) 1)), BgL_a2z00_3350);
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32800ze3z83_13914,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3anonymousza32800ze3z83_13914;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 1014 */
																																											if ((BgL_valz00_3192 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 1014 */
																																													obj_t
																																														BgL_a1z00_3359;
																																													obj_t
																																														BgL_a2z00_3360;
																																													BgL_a1z00_3359
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																													BgL_a2z00_3360
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 1014 */
																																														obj_t
																																															BgL_zc3anonymousza32804ze3z83_13915;
																																														BgL_zc3anonymousza32804ze3z83_13915
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3anonymousza32804ze3ze1zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32804ze3z83_13915,
																																															(int)
																																															(((long) 0)), BgL_a1z00_3359);
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32804ze3z83_13915,
																																															(int)
																																															(((long) 1)), BgL_a2z00_3360);
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32804ze3z83_13915,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3anonymousza32804ze3z83_13915;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 1014 */
																																													if ((BgL_valz00_3192 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 1014 */
																																															obj_t
																																																BgL_a1z00_3369;
																																															obj_t
																																																BgL_a2z00_3370;
																																															BgL_a1z00_3369
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																															BgL_a2z00_3370
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 1014 */
																																																obj_t
																																																	BgL_zc3anonymousza32808ze3z83_13916;
																																																BgL_zc3anonymousza32808ze3z83_13916
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3anonymousza32808ze3ze1zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32808ze3z83_13916,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_3369);
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32808ze3z83_13916,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_3370);
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32808ze3z83_13916,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3anonymousza32808ze3z83_13916;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 1014 */
																																															if ((BgL_valz00_3192 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																	obj_t
																																																		BgL_a1z00_3379;
																																																	obj_t
																																																		BgL_a2z00_3380;
																																																	BgL_a1z00_3379
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																	BgL_a2z00_3380
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 1014 */
																																																		obj_t
																																																			BgL_zc3anonymousza32812ze3z83_13917;
																																																		BgL_zc3anonymousza32812ze3z83_13917
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32812ze3z83_13917,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_3379);
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32812ze3z83_13917,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_3380);
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32812ze3z83_13917,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3anonymousza32812ze3z83_13917;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																	if ((BgL_valz00_3192 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																			obj_t
																																																				BgL_a1z00_3389;
																																																			obj_t
																																																				BgL_a2z00_3390;
																																																			BgL_a1z00_3389
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																			BgL_a2z00_3390
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 1014 */
																																																				obj_t
																																																					BgL_zc3anonymousza32816ze3z83_13918;
																																																				BgL_zc3anonymousza32816ze3z83_13918
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3anonymousza32816ze3ze1zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32816ze3z83_13918,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_3389);
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32816ze3z83_13918,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_3390);
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32816ze3z83_13918,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3anonymousza32816ze3z83_13918;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																			if ((BgL_valz00_3192 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																					obj_t
																																																						BgL_a1z00_3399;
																																																					obj_t
																																																						BgL_a2z00_3400;
																																																					BgL_a1z00_3399
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																					BgL_a2z00_3400
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 1014 */
																																																						obj_t
																																																							BgL_zc3anonymousza32820ze3z83_13919;
																																																						BgL_zc3anonymousza32820ze3z83_13919
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3anonymousza32820ze3ze1zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32820ze3z83_13919,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_3399);
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32820ze3z83_13919,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_3400);
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32820ze3z83_13919,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3anonymousza32820ze3z83_13919;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																					if ((BgL_valz00_3192 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 1014 */
																																																							obj_t
																																																								BgL_a1z00_3409;
																																																							obj_t
																																																								BgL_a2z00_3410;
																																																							BgL_a1z00_3409
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																							BgL_a2z00_3410
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 1014 */
																																																								obj_t
																																																									BgL_zc3anonymousza32824ze3z83_13920;
																																																								BgL_zc3anonymousza32824ze3z83_13920
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3anonymousza32824ze3ze1zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32824ze3z83_13920,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_3409);
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32824ze3z83_13920,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_3410);
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32824ze3z83_13920,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3anonymousza32824ze3z83_13920;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 1014 */
																																																							if ((BgL_valz00_3192 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 1014 */
																																																									obj_t
																																																										BgL_a1z00_3419;
																																																									obj_t
																																																										BgL_a2z00_3420;
																																																									BgL_a1z00_3419
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																									BgL_a2z00_3420
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 1014 */
																																																										obj_t
																																																											BgL_zc3anonymousza32828ze3z83_13921;
																																																										BgL_zc3anonymousza32828ze3z83_13921
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3anonymousza32828ze3ze1zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32828ze3z83_13921,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_3419);
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32828ze3z83_13921,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_3420);
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32828ze3z83_13921,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3anonymousza32828ze3z83_13921;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 1014 */
																																																									if ((BgL_valz00_3192 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 1014 */
																																																											obj_t
																																																												BgL_a1z00_3429;
																																																											obj_t
																																																												BgL_a2z00_3430;
																																																											BgL_a1z00_3429
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																											BgL_a2z00_3430
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 1014 */
																																																												obj_t
																																																													BgL_zc3anonymousza32832ze3z83_13922;
																																																												BgL_zc3anonymousza32832ze3z83_13922
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32832ze3z83_13922,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_3429);
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32832ze3z83_13922,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_3430);
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32832ze3z83_13922,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3anonymousza32832ze3z83_13922;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 1014 */
																																																											if ((BgL_valz00_3192 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 1014 */
																																																													obj_t
																																																														BgL_a1z00_3439;
																																																													obj_t
																																																														BgL_a2z00_3440;
																																																													BgL_a1z00_3439
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																													BgL_a2z00_3440
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 1014 */
																																																														obj_t
																																																															BgL_zc3anonymousza32836ze3z83_13923;
																																																														BgL_zc3anonymousza32836ze3z83_13923
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3anonymousza32836ze3ze1zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32836ze3z83_13923,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_3439);
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32836ze3z83_13923,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_3440);
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32836ze3z83_13923,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3anonymousza32836ze3z83_13923;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 1014 */
																																																													if ((BgL_valz00_3192 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 1014 */
																																																															obj_t
																																																																BgL_a1z00_3449;
																																																															obj_t
																																																																BgL_a2z00_3450;
																																																															BgL_a1z00_3449
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																															BgL_a2z00_3450
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 1014 */
																																																																obj_t
																																																																	BgL_zc3anonymousza32840ze3z83_13924;
																																																																BgL_zc3anonymousza32840ze3z83_13924
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3anonymousza32840ze3ze1zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32840ze3z83_13924,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_3449);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32840ze3z83_13924,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_3450);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32840ze3z83_13924,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3anonymousza32840ze3z83_13924;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 1014 */
																																																															if ((BgL_valz00_3192 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																																	obj_t
																																																																		BgL_a1z00_3459;
																																																																	obj_t
																																																																		BgL_a2z00_3460;
																																																																	BgL_a1z00_3459
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																																	BgL_a2z00_3460
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 1014 */
																																																																		obj_t
																																																																			BgL_zc3anonymousza32844ze3z83_13925;
																																																																		BgL_zc3anonymousza32844ze3z83_13925
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3anonymousza32844ze3ze1zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32844ze3z83_13925,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_3459);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32844ze3z83_13925,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_3460);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32844ze3z83_13925,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3anonymousza32844ze3z83_13925;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 1014 */
																																																																	if ((BgL_valz00_3192 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																																			obj_t
																																																																				BgL_a1z00_3469;
																																																																			obj_t
																																																																				BgL_a2z00_3470;
																																																																			BgL_a1z00_3469
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																																			BgL_a2z00_3470
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 1014 */
																																																																				obj_t
																																																																					BgL_zc3anonymousza32848ze3z83_13926;
																																																																				BgL_zc3anonymousza32848ze3z83_13926
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3anonymousza32848ze3ze1zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3anonymousza32848ze3z83_13926,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_3469);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3anonymousza32848ze3z83_13926,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_3470);
																																																																				return
																																																																					BgL_zc3anonymousza32848ze3z83_13926;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 1014 */
																																																																			if ((BgL_valz00_3192 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																																					obj_t
																																																																						BgL_a1z00_3477;
																																																																					obj_t
																																																																						BgL_a2z00_3478;
																																																																					BgL_a1z00_3477
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3196), BgL_stkz00_196);
																																																																					BgL_a2z00_3478
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3197), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 1014 */
																																																																						obj_t
																																																																							BgL_zc3anonymousza32850ze3z83_13927;
																																																																						BgL_zc3anonymousza32850ze3z83_13927
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3anonymousza32850ze3ze1zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3anonymousza32850ze3z83_13927,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_3477);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3anonymousza32850ze3z83_13927,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_3478);
																																																																						return
																																																																							BgL_zc3anonymousza32850ze3z83_13927;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 1014 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 1012 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 1007 */
						return BFALSE;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2740> */
	obj_t BGl_z62zc3anonymousza32740ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13931, obj_t BgL_sz00_13935)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13932;
				obj_t BgL_a2z00_13933;
				obj_t BgL_locz00_13934;

				BgL_a1z00_13932 = PROCEDURE_REF(BgL_envz00_13931, (int) (((long) 0)));
				BgL_a2z00_13933 = PROCEDURE_REF(BgL_envz00_13931, (int) (((long) 1)));
				BgL_locz00_13934 = PROCEDURE_REF(BgL_envz00_13931, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16491;

					BgL_bpz00_16491 = VECTOR_REF(((obj_t) BgL_sz00_13935), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16492;
						obj_t BgL_a2z00_16493;

						BgL_a1z00_16492 =
							PROCEDURE_ENTRY(BgL_a1z00_13932) (BgL_a1z00_13932, BgL_sz00_13935,
							BEOA);
						BgL_a2z00_16493 =
							PROCEDURE_ENTRY(BgL_a2z00_13933) (BgL_a2z00_13933, BgL_sz00_13935,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16492))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5795z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16492,
									BgL_locz00_13934);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16493))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5795z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16493,
									BgL_locz00_13934);
							}
						return
							BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_16492,
							BgL_a2z00_16493);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2744> */
	obj_t BGl_z62zc3anonymousza32744ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13936, obj_t BgL_sz00_13940)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13937;
				obj_t BgL_a2z00_13938;
				obj_t BgL_locz00_13939;

				BgL_a1z00_13937 = PROCEDURE_REF(BgL_envz00_13936, (int) (((long) 0)));
				BgL_a2z00_13938 = PROCEDURE_REF(BgL_envz00_13936, (int) (((long) 1)));
				BgL_locz00_13939 = PROCEDURE_REF(BgL_envz00_13936, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16494;

					BgL_bpz00_16494 = VECTOR_REF(((obj_t) BgL_sz00_13940), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16495;
						obj_t BgL_a2z00_16496;

						BgL_a1z00_16495 =
							PROCEDURE_ENTRY(BgL_a1z00_13937) (BgL_a1z00_13937, BgL_sz00_13940,
							BEOA);
						BgL_a2z00_16496 =
							PROCEDURE_ENTRY(BgL_a2z00_13938) (BgL_a2z00_13938, BgL_sz00_13940,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16495))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5799z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16495,
									BgL_locz00_13939);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16496))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5799z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16496,
									BgL_locz00_13939);
							}
						return
							BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_16495,
							BgL_a2z00_16496);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2748> */
	obj_t BGl_z62zc3anonymousza32748ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13941, obj_t BgL_sz00_13945)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13942;
				obj_t BgL_a2z00_13943;
				obj_t BgL_locz00_13944;

				BgL_a1z00_13942 = PROCEDURE_REF(BgL_envz00_13941, (int) (((long) 0)));
				BgL_a2z00_13943 = PROCEDURE_REF(BgL_envz00_13941, (int) (((long) 1)));
				BgL_locz00_13944 = PROCEDURE_REF(BgL_envz00_13941, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16497;

					BgL_bpz00_16497 = VECTOR_REF(((obj_t) BgL_sz00_13945), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16498;
						obj_t BgL_a2z00_16499;

						BgL_a1z00_16498 =
							PROCEDURE_ENTRY(BgL_a1z00_13942) (BgL_a1z00_13942, BgL_sz00_13945,
							BEOA);
						BgL_a2z00_16499 =
							PROCEDURE_ENTRY(BgL_a2z00_13943) (BgL_a2z00_13943, BgL_sz00_13945,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16498))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5801z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16498,
									BgL_locz00_13944);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16499))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5801z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16499,
									BgL_locz00_13944);
							}
						return
							BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_16498,
							BgL_a2z00_16499);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2752> */
	obj_t BGl_z62zc3anonymousza32752ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13946, obj_t BgL_sz00_13950)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13947;
				obj_t BgL_a2z00_13948;
				obj_t BgL_locz00_13949;

				BgL_a1z00_13947 = PROCEDURE_REF(BgL_envz00_13946, (int) (((long) 0)));
				BgL_a2z00_13948 = PROCEDURE_REF(BgL_envz00_13946, (int) (((long) 1)));
				BgL_locz00_13949 = PROCEDURE_REF(BgL_envz00_13946, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16500;

					BgL_bpz00_16500 = VECTOR_REF(((obj_t) BgL_sz00_13950), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16501;
						obj_t BgL_a2z00_16502;

						BgL_a1z00_16501 =
							PROCEDURE_ENTRY(BgL_a1z00_13947) (BgL_a1z00_13947, BgL_sz00_13950,
							BEOA);
						BgL_a2z00_16502 =
							PROCEDURE_ENTRY(BgL_a2z00_13948) (BgL_a2z00_13948, BgL_sz00_13950,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16501))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5803z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16501,
									BgL_locz00_13949);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16502))
							{	/* Eval/evaluate_comp.scm 1014 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1014 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5803z00zz__evaluate_compz00,
									BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16502,
									BgL_locz00_13949);
							}
						return
							BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_16501,
							BgL_a2z00_16502);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2756> */
	obj_t BGl_z62zc3anonymousza32756ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13951, obj_t BgL_sz00_13955)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13952;
				obj_t BgL_a2z00_13953;
				obj_t BgL_locz00_13954;

				BgL_a1z00_13952 = PROCEDURE_REF(BgL_envz00_13951, (int) (((long) 0)));
				BgL_a2z00_13953 = PROCEDURE_REF(BgL_envz00_13951, (int) (((long) 1)));
				BgL_locz00_13954 = PROCEDURE_REF(BgL_envz00_13951, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24643;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16503;

						BgL_bpz00_16503 = VECTOR_REF(((obj_t) BgL_sz00_13955), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16504;
							obj_t BgL_a2z00_16505;

							BgL_a1z00_16504 =
								PROCEDURE_ENTRY(BgL_a1z00_13952) (BgL_a1z00_13952,
								BgL_sz00_13955, BEOA);
							BgL_a2z00_16505 =
								PROCEDURE_ENTRY(BgL_a2z00_13953) (BgL_a2z00_13953,
								BgL_sz00_13955, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16504))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5805z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16504,
										BgL_locz00_13954);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16505))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5805z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16505,
										BgL_locz00_13954);
								}
							BgL_tmpz00_24643 =
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_16504,
								BgL_a2z00_16505);
						}
					}
					return BBOOL(BgL_tmpz00_24643);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2760> */
	obj_t BGl_z62zc3anonymousza32760ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13956, obj_t BgL_sz00_13960)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13957;
				obj_t BgL_a2z00_13958;
				obj_t BgL_locz00_13959;

				BgL_a1z00_13957 = PROCEDURE_REF(BgL_envz00_13956, (int) (((long) 0)));
				BgL_a2z00_13958 = PROCEDURE_REF(BgL_envz00_13956, (int) (((long) 1)));
				BgL_locz00_13959 = PROCEDURE_REF(BgL_envz00_13956, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24668;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16506;

						BgL_bpz00_16506 = VECTOR_REF(((obj_t) BgL_sz00_13960), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16507;
							obj_t BgL_a2z00_16508;

							BgL_a1z00_16507 =
								PROCEDURE_ENTRY(BgL_a1z00_13957) (BgL_a1z00_13957,
								BgL_sz00_13960, BEOA);
							BgL_a2z00_16508 =
								PROCEDURE_ENTRY(BgL_a2z00_13958) (BgL_a2z00_13958,
								BgL_sz00_13960, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16507))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5807z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16507,
										BgL_locz00_13959);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16508))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5807z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16508,
										BgL_locz00_13959);
								}
							BgL_tmpz00_24668 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_16507,
								BgL_a2z00_16508);
						}
					}
					return BBOOL(BgL_tmpz00_24668);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2764> */
	obj_t BGl_z62zc3anonymousza32764ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13961, obj_t BgL_sz00_13965)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13962;
				obj_t BgL_a2z00_13963;
				obj_t BgL_locz00_13964;

				BgL_a1z00_13962 = PROCEDURE_REF(BgL_envz00_13961, (int) (((long) 0)));
				BgL_a2z00_13963 = PROCEDURE_REF(BgL_envz00_13961, (int) (((long) 1)));
				BgL_locz00_13964 = PROCEDURE_REF(BgL_envz00_13961, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24693;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16509;

						BgL_bpz00_16509 = VECTOR_REF(((obj_t) BgL_sz00_13965), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16510;
							obj_t BgL_a2z00_16511;

							BgL_a1z00_16510 =
								PROCEDURE_ENTRY(BgL_a1z00_13962) (BgL_a1z00_13962,
								BgL_sz00_13965, BEOA);
							BgL_a2z00_16511 =
								PROCEDURE_ENTRY(BgL_a2z00_13963) (BgL_a2z00_13963,
								BgL_sz00_13965, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16510))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5809z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16510,
										BgL_locz00_13964);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16511))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5809z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16511,
										BgL_locz00_13964);
								}
							BgL_tmpz00_24693 =
								BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_16510,
								BgL_a2z00_16511);
						}
					}
					return BBOOL(BgL_tmpz00_24693);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2768> */
	obj_t BGl_z62zc3anonymousza32768ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13966, obj_t BgL_sz00_13970)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13967;
				obj_t BgL_a2z00_13968;
				obj_t BgL_locz00_13969;

				BgL_a1z00_13967 = PROCEDURE_REF(BgL_envz00_13966, (int) (((long) 0)));
				BgL_a2z00_13968 = PROCEDURE_REF(BgL_envz00_13966, (int) (((long) 1)));
				BgL_locz00_13969 = PROCEDURE_REF(BgL_envz00_13966, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24718;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16512;

						BgL_bpz00_16512 = VECTOR_REF(((obj_t) BgL_sz00_13970), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16513;
							obj_t BgL_a2z00_16514;

							BgL_a1z00_16513 =
								PROCEDURE_ENTRY(BgL_a1z00_13967) (BgL_a1z00_13967,
								BgL_sz00_13970, BEOA);
							BgL_a2z00_16514 =
								PROCEDURE_ENTRY(BgL_a2z00_13968) (BgL_a2z00_13968,
								BgL_sz00_13970, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16513))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5811z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16513,
										BgL_locz00_13969);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16514))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5811z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16514,
										BgL_locz00_13969);
								}
							BgL_tmpz00_24718 =
								BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_16513,
								BgL_a2z00_16514);
						}
					}
					return BBOOL(BgL_tmpz00_24718);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2772> */
	obj_t BGl_z62zc3anonymousza32772ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13971, obj_t BgL_sz00_13975)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13972;
				obj_t BgL_a2z00_13973;
				obj_t BgL_locz00_13974;

				BgL_a1z00_13972 = PROCEDURE_REF(BgL_envz00_13971, (int) (((long) 0)));
				BgL_a2z00_13973 = PROCEDURE_REF(BgL_envz00_13971, (int) (((long) 1)));
				BgL_locz00_13974 = PROCEDURE_REF(BgL_envz00_13971, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24743;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16515;

						BgL_bpz00_16515 = VECTOR_REF(((obj_t) BgL_sz00_13975), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16516;
							obj_t BgL_a2z00_16517;

							BgL_a1z00_16516 =
								PROCEDURE_ENTRY(BgL_a1z00_13972) (BgL_a1z00_13972,
								BgL_sz00_13975, BEOA);
							BgL_a2z00_16517 =
								PROCEDURE_ENTRY(BgL_a2z00_13973) (BgL_a2z00_13973,
								BgL_sz00_13975, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16516))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5813z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a1z00_16516,
										BgL_locz00_13974);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16517))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5813z00zz__evaluate_compz00,
										BGl_symbol5797z00zz__evaluate_compz00, BgL_a2z00_16517,
										BgL_locz00_13974);
								}
							BgL_tmpz00_24743 =
								BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_16516,
								BgL_a2z00_16517);
						}
					}
					return BBOOL(BgL_tmpz00_24743);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2776> */
	obj_t BGl_z62zc3anonymousza32776ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13976, obj_t BgL_sz00_13980)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13977;
				obj_t BgL_a2z00_13978;
				obj_t BgL_locz00_13979;

				BgL_a1z00_13977 = PROCEDURE_REF(BgL_envz00_13976, (int) (((long) 0)));
				BgL_a2z00_13978 = PROCEDURE_REF(BgL_envz00_13976, (int) (((long) 1)));
				BgL_locz00_13979 = PROCEDURE_REF(BgL_envz00_13976, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24768;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16518;

						BgL_bpz00_16518 = VECTOR_REF(((obj_t) BgL_sz00_13980), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16519;
							obj_t BgL_a2z00_16520;

							BgL_a1z00_16519 =
								PROCEDURE_ENTRY(BgL_a1z00_13977) (BgL_a1z00_13977,
								BgL_sz00_13980, BEOA);
							BgL_a2z00_16520 =
								PROCEDURE_ENTRY(BgL_a2z00_13978) (BgL_a2z00_13978,
								BgL_sz00_13980, BEOA);
							if (INTEGERP(BgL_a1z00_16519))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5815z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16519,
										BgL_locz00_13979);
								}
							if (INTEGERP(BgL_a2z00_16520))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5815z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16520,
										BgL_locz00_13979);
								}
							BgL_tmpz00_24768 =
								((long) CINT(BgL_a1z00_16519) + (long) CINT(BgL_a2z00_16520));
					}}
					return BINT(BgL_tmpz00_24768);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2780> */
	obj_t BGl_z62zc3anonymousza32780ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13981, obj_t BgL_sz00_13985)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13982;
				obj_t BgL_a2z00_13983;
				obj_t BgL_locz00_13984;

				BgL_a1z00_13982 = PROCEDURE_REF(BgL_envz00_13981, (int) (((long) 0)));
				BgL_a2z00_13983 = PROCEDURE_REF(BgL_envz00_13981, (int) (((long) 1)));
				BgL_locz00_13984 = PROCEDURE_REF(BgL_envz00_13981, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24795;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16521;

						BgL_bpz00_16521 = VECTOR_REF(((obj_t) BgL_sz00_13985), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16522;
							obj_t BgL_a2z00_16523;

							BgL_a1z00_16522 =
								PROCEDURE_ENTRY(BgL_a1z00_13982) (BgL_a1z00_13982,
								BgL_sz00_13985, BEOA);
							BgL_a2z00_16523 =
								PROCEDURE_ENTRY(BgL_a2z00_13983) (BgL_a2z00_13983,
								BgL_sz00_13985, BEOA);
							if (INTEGERP(BgL_a1z00_16522))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5819z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16522,
										BgL_locz00_13984);
								}
							if (INTEGERP(BgL_a2z00_16523))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5819z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16523,
										BgL_locz00_13984);
								}
							BgL_tmpz00_24795 =
								((long) CINT(BgL_a1z00_16522) - (long) CINT(BgL_a2z00_16523));
					}}
					return BINT(BgL_tmpz00_24795);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2784> */
	obj_t BGl_z62zc3anonymousza32784ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13986, obj_t BgL_sz00_13990)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13987;
				obj_t BgL_a2z00_13988;
				obj_t BgL_locz00_13989;

				BgL_a1z00_13987 = PROCEDURE_REF(BgL_envz00_13986, (int) (((long) 0)));
				BgL_a2z00_13988 = PROCEDURE_REF(BgL_envz00_13986, (int) (((long) 1)));
				BgL_locz00_13989 = PROCEDURE_REF(BgL_envz00_13986, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24822;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16524;

						BgL_bpz00_16524 = VECTOR_REF(((obj_t) BgL_sz00_13990), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16525;
							obj_t BgL_a2z00_16526;

							BgL_a1z00_16525 =
								PROCEDURE_ENTRY(BgL_a1z00_13987) (BgL_a1z00_13987,
								BgL_sz00_13990, BEOA);
							BgL_a2z00_16526 =
								PROCEDURE_ENTRY(BgL_a2z00_13988) (BgL_a2z00_13988,
								BgL_sz00_13990, BEOA);
							if (INTEGERP(BgL_a1z00_16525))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5821z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16525,
										BgL_locz00_13989);
								}
							if (INTEGERP(BgL_a2z00_16526))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5821z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16526,
										BgL_locz00_13989);
								}
							BgL_tmpz00_24822 =
								((long) CINT(BgL_a1z00_16525) * (long) CINT(BgL_a2z00_16526));
					}}
					return BINT(BgL_tmpz00_24822);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2788> */
	obj_t BGl_z62zc3anonymousza32788ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13991, obj_t BgL_sz00_13995)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13992;
				obj_t BgL_a2z00_13993;
				obj_t BgL_locz00_13994;

				BgL_a1z00_13992 = PROCEDURE_REF(BgL_envz00_13991, (int) (((long) 0)));
				BgL_a2z00_13993 = PROCEDURE_REF(BgL_envz00_13991, (int) (((long) 1)));
				BgL_locz00_13994 = PROCEDURE_REF(BgL_envz00_13991, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					long BgL_tmpz00_24849;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16527;

						BgL_bpz00_16527 = VECTOR_REF(((obj_t) BgL_sz00_13995), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16528;
							obj_t BgL_a2z00_16529;

							BgL_a1z00_16528 =
								PROCEDURE_ENTRY(BgL_a1z00_13992) (BgL_a1z00_13992,
								BgL_sz00_13995, BEOA);
							BgL_a2z00_16529 =
								PROCEDURE_ENTRY(BgL_a2z00_13993) (BgL_a2z00_13993,
								BgL_sz00_13995, BEOA);
							if (INTEGERP(BgL_a1z00_16528))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5823z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16528,
										BgL_locz00_13994);
								}
							if (INTEGERP(BgL_a2z00_16529))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5823z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16529,
										BgL_locz00_13994);
								}
							BgL_tmpz00_24849 =
								((long) CINT(BgL_a1z00_16528) / (long) CINT(BgL_a2z00_16529));
					}}
					return BINT(BgL_tmpz00_24849);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2792> */
	obj_t BGl_z62zc3anonymousza32792ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_13996, obj_t BgL_sz00_14000)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_13997;
				obj_t BgL_a2z00_13998;
				obj_t BgL_locz00_13999;

				BgL_a1z00_13997 = PROCEDURE_REF(BgL_envz00_13996, (int) (((long) 0)));
				BgL_a2z00_13998 = PROCEDURE_REF(BgL_envz00_13996, (int) (((long) 1)));
				BgL_locz00_13999 = PROCEDURE_REF(BgL_envz00_13996, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24876;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16530;

						BgL_bpz00_16530 = VECTOR_REF(((obj_t) BgL_sz00_14000), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16531;
							obj_t BgL_a2z00_16532;

							BgL_a1z00_16531 =
								PROCEDURE_ENTRY(BgL_a1z00_13997) (BgL_a1z00_13997,
								BgL_sz00_14000, BEOA);
							BgL_a2z00_16532 =
								PROCEDURE_ENTRY(BgL_a2z00_13998) (BgL_a2z00_13998,
								BgL_sz00_14000, BEOA);
							if (INTEGERP(BgL_a1z00_16531))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5825z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16531,
										BgL_locz00_13999);
								}
							if (INTEGERP(BgL_a2z00_16532))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5825z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16532,
										BgL_locz00_13999);
								}
							BgL_tmpz00_24876 =
								((long) CINT(BgL_a1z00_16531) < (long) CINT(BgL_a2z00_16532));
					}}
					return BBOOL(BgL_tmpz00_24876);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2796> */
	obj_t BGl_z62zc3anonymousza32796ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14001, obj_t BgL_sz00_14005)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14002;
				obj_t BgL_a2z00_14003;
				obj_t BgL_locz00_14004;

				BgL_a1z00_14002 = PROCEDURE_REF(BgL_envz00_14001, (int) (((long) 0)));
				BgL_a2z00_14003 = PROCEDURE_REF(BgL_envz00_14001, (int) (((long) 1)));
				BgL_locz00_14004 = PROCEDURE_REF(BgL_envz00_14001, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24903;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16533;

						BgL_bpz00_16533 = VECTOR_REF(((obj_t) BgL_sz00_14005), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16534;
							obj_t BgL_a2z00_16535;

							BgL_a1z00_16534 =
								PROCEDURE_ENTRY(BgL_a1z00_14002) (BgL_a1z00_14002,
								BgL_sz00_14005, BEOA);
							BgL_a2z00_16535 =
								PROCEDURE_ENTRY(BgL_a2z00_14003) (BgL_a2z00_14003,
								BgL_sz00_14005, BEOA);
							if (INTEGERP(BgL_a1z00_16534))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5827z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16534,
										BgL_locz00_14004);
								}
							if (INTEGERP(BgL_a2z00_16535))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5827z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16535,
										BgL_locz00_14004);
								}
							BgL_tmpz00_24903 =
								((long) CINT(BgL_a1z00_16534) > (long) CINT(BgL_a2z00_16535));
					}}
					return BBOOL(BgL_tmpz00_24903);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2800> */
	obj_t BGl_z62zc3anonymousza32800ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14006, obj_t BgL_sz00_14010)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14007;
				obj_t BgL_a2z00_14008;
				obj_t BgL_locz00_14009;

				BgL_a1z00_14007 = PROCEDURE_REF(BgL_envz00_14006, (int) (((long) 0)));
				BgL_a2z00_14008 = PROCEDURE_REF(BgL_envz00_14006, (int) (((long) 1)));
				BgL_locz00_14009 = PROCEDURE_REF(BgL_envz00_14006, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24930;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16536;

						BgL_bpz00_16536 = VECTOR_REF(((obj_t) BgL_sz00_14010), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16537;
							obj_t BgL_a2z00_16538;

							BgL_a1z00_16537 =
								PROCEDURE_ENTRY(BgL_a1z00_14007) (BgL_a1z00_14007,
								BgL_sz00_14010, BEOA);
							BgL_a2z00_16538 =
								PROCEDURE_ENTRY(BgL_a2z00_14008) (BgL_a2z00_14008,
								BgL_sz00_14010, BEOA);
							if (INTEGERP(BgL_a1z00_16537))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5829z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16537,
										BgL_locz00_14009);
								}
							if (INTEGERP(BgL_a2z00_16538))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5829z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16538,
										BgL_locz00_14009);
								}
							BgL_tmpz00_24930 =
								((long) CINT(BgL_a1z00_16537) <= (long) CINT(BgL_a2z00_16538));
					}}
					return BBOOL(BgL_tmpz00_24930);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2804> */
	obj_t BGl_z62zc3anonymousza32804ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14011, obj_t BgL_sz00_14015)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14012;
				obj_t BgL_a2z00_14013;
				obj_t BgL_locz00_14014;

				BgL_a1z00_14012 = PROCEDURE_REF(BgL_envz00_14011, (int) (((long) 0)));
				BgL_a2z00_14013 = PROCEDURE_REF(BgL_envz00_14011, (int) (((long) 1)));
				BgL_locz00_14014 = PROCEDURE_REF(BgL_envz00_14011, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24957;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16539;

						BgL_bpz00_16539 = VECTOR_REF(((obj_t) BgL_sz00_14015), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16540;
							obj_t BgL_a2z00_16541;

							BgL_a1z00_16540 =
								PROCEDURE_ENTRY(BgL_a1z00_14012) (BgL_a1z00_14012,
								BgL_sz00_14015, BEOA);
							BgL_a2z00_16541 =
								PROCEDURE_ENTRY(BgL_a2z00_14013) (BgL_a2z00_14013,
								BgL_sz00_14015, BEOA);
							if (INTEGERP(BgL_a1z00_16540))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5831z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16540,
										BgL_locz00_14014);
								}
							if (INTEGERP(BgL_a2z00_16541))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5831z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16541,
										BgL_locz00_14014);
								}
							BgL_tmpz00_24957 =
								((long) CINT(BgL_a1z00_16540) >= (long) CINT(BgL_a2z00_16541));
					}}
					return BBOOL(BgL_tmpz00_24957);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2808> */
	obj_t BGl_z62zc3anonymousza32808ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14016, obj_t BgL_sz00_14020)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14017;
				obj_t BgL_a2z00_14018;
				obj_t BgL_locz00_14019;

				BgL_a1z00_14017 = PROCEDURE_REF(BgL_envz00_14016, (int) (((long) 0)));
				BgL_a2z00_14018 = PROCEDURE_REF(BgL_envz00_14016, (int) (((long) 1)));
				BgL_locz00_14019 = PROCEDURE_REF(BgL_envz00_14016, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_24984;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16542;

						BgL_bpz00_16542 = VECTOR_REF(((obj_t) BgL_sz00_14020), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16543;
							obj_t BgL_a2z00_16544;

							BgL_a1z00_16543 =
								PROCEDURE_ENTRY(BgL_a1z00_14017) (BgL_a1z00_14017,
								BgL_sz00_14020, BEOA);
							BgL_a2z00_16544 =
								PROCEDURE_ENTRY(BgL_a2z00_14018) (BgL_a2z00_14018,
								BgL_sz00_14020, BEOA);
							if (INTEGERP(BgL_a1z00_16543))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5833z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a1z00_16543,
										BgL_locz00_14019);
								}
							if (INTEGERP(BgL_a2z00_16544))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5833z00zz__evaluate_compz00,
										BGl_symbol5817z00zz__evaluate_compz00, BgL_a2z00_16544,
										BgL_locz00_14019);
								}
							BgL_tmpz00_24984 =
								((long) CINT(BgL_a1z00_16543) == (long) CINT(BgL_a2z00_16544));
					}}
					return BBOOL(BgL_tmpz00_24984);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2812> */
	obj_t BGl_z62zc3anonymousza32812ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14021, obj_t BgL_sz00_14025)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14022;
				obj_t BgL_a2z00_14023;
				obj_t BgL_locz00_14024;

				BgL_a1z00_14022 = PROCEDURE_REF(BgL_envz00_14021, (int) (((long) 0)));
				BgL_a2z00_14023 = PROCEDURE_REF(BgL_envz00_14021, (int) (((long) 1)));
				BgL_locz00_14024 = PROCEDURE_REF(BgL_envz00_14021, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25011;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16545;

						BgL_bpz00_16545 = VECTOR_REF(((obj_t) BgL_sz00_14025), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16546;
							obj_t BgL_a2z00_16547;

							BgL_a1z00_16546 =
								PROCEDURE_ENTRY(BgL_a1z00_14022) (BgL_a1z00_14022,
								BgL_sz00_14025, BEOA);
							BgL_a2z00_16547 =
								PROCEDURE_ENTRY(BgL_a2z00_14023) (BgL_a2z00_14023,
								BgL_sz00_14025, BEOA);
							if (REALP(BgL_a1z00_16546))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5835z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16546,
										BgL_locz00_14024);
								}
							if (REALP(BgL_a2z00_16547))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5835z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16547,
										BgL_locz00_14024);
								}
							BgL_tmpz00_25011 =
								(REAL_TO_DOUBLE(BgL_a1z00_16546) +
								REAL_TO_DOUBLE(BgL_a2z00_16547));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25011);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2816> */
	obj_t BGl_z62zc3anonymousza32816ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14026, obj_t BgL_sz00_14030)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14027;
				obj_t BgL_a2z00_14028;
				obj_t BgL_locz00_14029;

				BgL_a1z00_14027 = PROCEDURE_REF(BgL_envz00_14026, (int) (((long) 0)));
				BgL_a2z00_14028 = PROCEDURE_REF(BgL_envz00_14026, (int) (((long) 1)));
				BgL_locz00_14029 = PROCEDURE_REF(BgL_envz00_14026, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25038;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16548;

						BgL_bpz00_16548 = VECTOR_REF(((obj_t) BgL_sz00_14030), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16549;
							obj_t BgL_a2z00_16550;

							BgL_a1z00_16549 =
								PROCEDURE_ENTRY(BgL_a1z00_14027) (BgL_a1z00_14027,
								BgL_sz00_14030, BEOA);
							BgL_a2z00_16550 =
								PROCEDURE_ENTRY(BgL_a2z00_14028) (BgL_a2z00_14028,
								BgL_sz00_14030, BEOA);
							if (REALP(BgL_a1z00_16549))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5839z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16549,
										BgL_locz00_14029);
								}
							if (REALP(BgL_a2z00_16550))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5839z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16550,
										BgL_locz00_14029);
								}
							BgL_tmpz00_25038 =
								(REAL_TO_DOUBLE(BgL_a1z00_16549) -
								REAL_TO_DOUBLE(BgL_a2z00_16550));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25038);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2820> */
	obj_t BGl_z62zc3anonymousza32820ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14031, obj_t BgL_sz00_14035)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14032;
				obj_t BgL_a2z00_14033;
				obj_t BgL_locz00_14034;

				BgL_a1z00_14032 = PROCEDURE_REF(BgL_envz00_14031, (int) (((long) 0)));
				BgL_a2z00_14033 = PROCEDURE_REF(BgL_envz00_14031, (int) (((long) 1)));
				BgL_locz00_14034 = PROCEDURE_REF(BgL_envz00_14031, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25065;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16551;

						BgL_bpz00_16551 = VECTOR_REF(((obj_t) BgL_sz00_14035), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16552;
							obj_t BgL_a2z00_16553;

							BgL_a1z00_16552 =
								PROCEDURE_ENTRY(BgL_a1z00_14032) (BgL_a1z00_14032,
								BgL_sz00_14035, BEOA);
							BgL_a2z00_16553 =
								PROCEDURE_ENTRY(BgL_a2z00_14033) (BgL_a2z00_14033,
								BgL_sz00_14035, BEOA);
							if (REALP(BgL_a1z00_16552))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5841z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16552,
										BgL_locz00_14034);
								}
							if (REALP(BgL_a2z00_16553))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5841z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16553,
										BgL_locz00_14034);
								}
							BgL_tmpz00_25065 =
								(REAL_TO_DOUBLE(BgL_a1z00_16552) *
								REAL_TO_DOUBLE(BgL_a2z00_16553));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25065);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2824> */
	obj_t BGl_z62zc3anonymousza32824ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14036, obj_t BgL_sz00_14040)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14037;
				obj_t BgL_a2z00_14038;
				obj_t BgL_locz00_14039;

				BgL_a1z00_14037 = PROCEDURE_REF(BgL_envz00_14036, (int) (((long) 0)));
				BgL_a2z00_14038 = PROCEDURE_REF(BgL_envz00_14036, (int) (((long) 1)));
				BgL_locz00_14039 = PROCEDURE_REF(BgL_envz00_14036, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					double BgL_tmpz00_25092;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16554;

						BgL_bpz00_16554 = VECTOR_REF(((obj_t) BgL_sz00_14040), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16555;
							obj_t BgL_a2z00_16556;

							BgL_a1z00_16555 =
								PROCEDURE_ENTRY(BgL_a1z00_14037) (BgL_a1z00_14037,
								BgL_sz00_14040, BEOA);
							BgL_a2z00_16556 =
								PROCEDURE_ENTRY(BgL_a2z00_14038) (BgL_a2z00_14038,
								BgL_sz00_14040, BEOA);
							if (REALP(BgL_a1z00_16555))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5843z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16555,
										BgL_locz00_14039);
								}
							if (REALP(BgL_a2z00_16556))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5843z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16556,
										BgL_locz00_14039);
								}
							BgL_tmpz00_25092 =
								(REAL_TO_DOUBLE(BgL_a1z00_16555) /
								REAL_TO_DOUBLE(BgL_a2z00_16556));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25092);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2828> */
	obj_t BGl_z62zc3anonymousza32828ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14041, obj_t BgL_sz00_14045)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14042;
				obj_t BgL_a2z00_14043;
				obj_t BgL_locz00_14044;

				BgL_a1z00_14042 = PROCEDURE_REF(BgL_envz00_14041, (int) (((long) 0)));
				BgL_a2z00_14043 = PROCEDURE_REF(BgL_envz00_14041, (int) (((long) 1)));
				BgL_locz00_14044 = PROCEDURE_REF(BgL_envz00_14041, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25119;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16557;

						BgL_bpz00_16557 = VECTOR_REF(((obj_t) BgL_sz00_14045), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16558;
							obj_t BgL_a2z00_16559;

							BgL_a1z00_16558 =
								PROCEDURE_ENTRY(BgL_a1z00_14042) (BgL_a1z00_14042,
								BgL_sz00_14045, BEOA);
							BgL_a2z00_16559 =
								PROCEDURE_ENTRY(BgL_a2z00_14043) (BgL_a2z00_14043,
								BgL_sz00_14045, BEOA);
							if (REALP(BgL_a1z00_16558))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5845z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16558,
										BgL_locz00_14044);
								}
							if (REALP(BgL_a2z00_16559))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5845z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16559,
										BgL_locz00_14044);
								}
							BgL_tmpz00_25119 =
								(REAL_TO_DOUBLE(BgL_a1z00_16558) <
								REAL_TO_DOUBLE(BgL_a2z00_16559));
						}
					}
					return BBOOL(BgL_tmpz00_25119);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2832> */
	obj_t BGl_z62zc3anonymousza32832ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14046, obj_t BgL_sz00_14050)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14047;
				obj_t BgL_a2z00_14048;
				obj_t BgL_locz00_14049;

				BgL_a1z00_14047 = PROCEDURE_REF(BgL_envz00_14046, (int) (((long) 0)));
				BgL_a2z00_14048 = PROCEDURE_REF(BgL_envz00_14046, (int) (((long) 1)));
				BgL_locz00_14049 = PROCEDURE_REF(BgL_envz00_14046, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25146;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16560;

						BgL_bpz00_16560 = VECTOR_REF(((obj_t) BgL_sz00_14050), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16561;
							obj_t BgL_a2z00_16562;

							BgL_a1z00_16561 =
								PROCEDURE_ENTRY(BgL_a1z00_14047) (BgL_a1z00_14047,
								BgL_sz00_14050, BEOA);
							BgL_a2z00_16562 =
								PROCEDURE_ENTRY(BgL_a2z00_14048) (BgL_a2z00_14048,
								BgL_sz00_14050, BEOA);
							if (REALP(BgL_a1z00_16561))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5847z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16561,
										BgL_locz00_14049);
								}
							if (REALP(BgL_a2z00_16562))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5847z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16562,
										BgL_locz00_14049);
								}
							BgL_tmpz00_25146 =
								(REAL_TO_DOUBLE(BgL_a1z00_16561) >
								REAL_TO_DOUBLE(BgL_a2z00_16562));
						}
					}
					return BBOOL(BgL_tmpz00_25146);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2836> */
	obj_t BGl_z62zc3anonymousza32836ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14051, obj_t BgL_sz00_14055)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14052;
				obj_t BgL_a2z00_14053;
				obj_t BgL_locz00_14054;

				BgL_a1z00_14052 = PROCEDURE_REF(BgL_envz00_14051, (int) (((long) 0)));
				BgL_a2z00_14053 = PROCEDURE_REF(BgL_envz00_14051, (int) (((long) 1)));
				BgL_locz00_14054 = PROCEDURE_REF(BgL_envz00_14051, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25173;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16563;

						BgL_bpz00_16563 = VECTOR_REF(((obj_t) BgL_sz00_14055), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16564;
							obj_t BgL_a2z00_16565;

							BgL_a1z00_16564 =
								PROCEDURE_ENTRY(BgL_a1z00_14052) (BgL_a1z00_14052,
								BgL_sz00_14055, BEOA);
							BgL_a2z00_16565 =
								PROCEDURE_ENTRY(BgL_a2z00_14053) (BgL_a2z00_14053,
								BgL_sz00_14055, BEOA);
							if (REALP(BgL_a1z00_16564))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5849z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16564,
										BgL_locz00_14054);
								}
							if (REALP(BgL_a2z00_16565))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5849z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16565,
										BgL_locz00_14054);
								}
							BgL_tmpz00_25173 =
								(REAL_TO_DOUBLE(BgL_a1z00_16564) <=
								REAL_TO_DOUBLE(BgL_a2z00_16565));
						}
					}
					return BBOOL(BgL_tmpz00_25173);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2840> */
	obj_t BGl_z62zc3anonymousza32840ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14056, obj_t BgL_sz00_14060)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14057;
				obj_t BgL_a2z00_14058;
				obj_t BgL_locz00_14059;

				BgL_a1z00_14057 = PROCEDURE_REF(BgL_envz00_14056, (int) (((long) 0)));
				BgL_a2z00_14058 = PROCEDURE_REF(BgL_envz00_14056, (int) (((long) 1)));
				BgL_locz00_14059 = PROCEDURE_REF(BgL_envz00_14056, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25200;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16566;

						BgL_bpz00_16566 = VECTOR_REF(((obj_t) BgL_sz00_14060), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16567;
							obj_t BgL_a2z00_16568;

							BgL_a1z00_16567 =
								PROCEDURE_ENTRY(BgL_a1z00_14057) (BgL_a1z00_14057,
								BgL_sz00_14060, BEOA);
							BgL_a2z00_16568 =
								PROCEDURE_ENTRY(BgL_a2z00_14058) (BgL_a2z00_14058,
								BgL_sz00_14060, BEOA);
							if (REALP(BgL_a1z00_16567))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5851z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16567,
										BgL_locz00_14059);
								}
							if (REALP(BgL_a2z00_16568))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5851z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16568,
										BgL_locz00_14059);
								}
							BgL_tmpz00_25200 =
								(REAL_TO_DOUBLE(BgL_a1z00_16567) >=
								REAL_TO_DOUBLE(BgL_a2z00_16568));
						}
					}
					return BBOOL(BgL_tmpz00_25200);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2844> */
	obj_t BGl_z62zc3anonymousza32844ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14061, obj_t BgL_sz00_14065)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14062;
				obj_t BgL_a2z00_14063;
				obj_t BgL_locz00_14064;

				BgL_a1z00_14062 = PROCEDURE_REF(BgL_envz00_14061, (int) (((long) 0)));
				BgL_a2z00_14063 = PROCEDURE_REF(BgL_envz00_14061, (int) (((long) 1)));
				BgL_locz00_14064 = PROCEDURE_REF(BgL_envz00_14061, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25227;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16569;

						BgL_bpz00_16569 = VECTOR_REF(((obj_t) BgL_sz00_14065), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16570;
							obj_t BgL_a2z00_16571;

							BgL_a1z00_16570 =
								PROCEDURE_ENTRY(BgL_a1z00_14062) (BgL_a1z00_14062,
								BgL_sz00_14065, BEOA);
							BgL_a2z00_16571 =
								PROCEDURE_ENTRY(BgL_a2z00_14063) (BgL_a2z00_14063,
								BgL_sz00_14065, BEOA);
							if (REALP(BgL_a1z00_16570))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5853z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a1z00_16570,
										BgL_locz00_14064);
								}
							if (REALP(BgL_a2z00_16571))
								{	/* Eval/evaluate_comp.scm 1014 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1014 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5853z00zz__evaluate_compz00,
										BGl_symbol5837z00zz__evaluate_compz00, BgL_a2z00_16571,
										BgL_locz00_14064);
								}
							BgL_tmpz00_25227 =
								(REAL_TO_DOUBLE(BgL_a1z00_16570) ==
								REAL_TO_DOUBLE(BgL_a2z00_16571));
						}
					}
					return BBOOL(BgL_tmpz00_25227);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2848> */
	obj_t BGl_z62zc3anonymousza32848ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14066, obj_t BgL_sz00_14069)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14067;
				obj_t BgL_a2z00_14068;

				BgL_a1z00_14067 = PROCEDURE_REF(BgL_envz00_14066, (int) (((long) 0)));
				BgL_a2z00_14068 = PROCEDURE_REF(BgL_envz00_14066, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1014 */
					bool_t BgL_tmpz00_25252;

					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_bpz00_16572;

						BgL_bpz00_16572 = VECTOR_REF(((obj_t) BgL_sz00_14069), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1014 */
							obj_t BgL_a1z00_16573;
							obj_t BgL_a2z00_16574;

							BgL_a1z00_16573 =
								PROCEDURE_ENTRY(BgL_a1z00_14067) (BgL_a1z00_14067,
								BgL_sz00_14069, BEOA);
							BgL_a2z00_16574 =
								PROCEDURE_ENTRY(BgL_a2z00_14068) (BgL_a2z00_14068,
								BgL_sz00_14069, BEOA);
							BgL_tmpz00_25252 = (BgL_a1z00_16573 == BgL_a2z00_16574);
					}}
					return BBOOL(BgL_tmpz00_25252);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2850> */
	obj_t BGl_z62zc3anonymousza32850ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14070, obj_t BgL_sz00_14073)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1014 */
			{	/* Eval/evaluate_comp.scm 1014 */
				obj_t BgL_a1z00_14071;
				obj_t BgL_a2z00_14072;

				BgL_a1z00_14071 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 0)));
				BgL_a2z00_14072 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1014 */
					obj_t BgL_bpz00_16575;

					BgL_bpz00_16575 = VECTOR_REF(((obj_t) BgL_sz00_14073), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1014 */
						obj_t BgL_a1z00_16576;
						obj_t BgL_a2z00_16577;

						BgL_a1z00_16576 =
							PROCEDURE_ENTRY(BgL_a1z00_14071) (BgL_a1z00_14071, BgL_sz00_14073,
							BEOA);
						BgL_a2z00_16577 =
							PROCEDURE_ENTRY(BgL_a2z00_14072) (BgL_a2z00_14072, BgL_sz00_14073,
							BEOA);
						return MAKE_YOUNG_PAIR(BgL_a1z00_16576, BgL_a2z00_16577);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2853> */
	obj_t BGl_z62zc3anonymousza32853ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14074, obj_t BgL_sz00_14077)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_14075;
				obj_t BgL_locz00_14076;

				BgL_a1z00_14075 = PROCEDURE_REF(BgL_envz00_14074, (int) (((long) 0)));
				BgL_locz00_14076 = PROCEDURE_REF(BgL_envz00_14074, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1011 */
					obj_t BgL_bpz00_16578;

					BgL_bpz00_16578 = VECTOR_REF(((obj_t) BgL_sz00_14077), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_a1z00_16579;

						BgL_a1z00_16579 =
							PROCEDURE_ENTRY(BgL_a1z00_14075) (BgL_a1z00_14075, BgL_sz00_14077,
							BEOA);
						if (PAIRP(BgL_a1z00_16579))
							{	/* Eval/evaluate_comp.scm 1011 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1011 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5855z00zz__evaluate_compz00,
									BGl_symbol5857z00zz__evaluate_compz00, BgL_a1z00_16579,
									BgL_locz00_14076);
							}
						return CAR(((obj_t) BgL_a1z00_16579));
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2856> */
	obj_t BGl_z62zc3anonymousza32856ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14078, obj_t BgL_sz00_14081)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_14079;
				obj_t BgL_locz00_14080;

				BgL_a1z00_14079 = PROCEDURE_REF(BgL_envz00_14078, (int) (((long) 0)));
				BgL_locz00_14080 = PROCEDURE_REF(BgL_envz00_14078, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1011 */
					obj_t BgL_bpz00_16580;

					BgL_bpz00_16580 = VECTOR_REF(((obj_t) BgL_sz00_14081), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_a1z00_16581;

						BgL_a1z00_16581 =
							PROCEDURE_ENTRY(BgL_a1z00_14079) (BgL_a1z00_14079, BgL_sz00_14081,
							BEOA);
						if (PAIRP(BgL_a1z00_16581))
							{	/* Eval/evaluate_comp.scm 1011 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1011 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5859z00zz__evaluate_compz00,
									BGl_symbol5857z00zz__evaluate_compz00, BgL_a1z00_16581,
									BgL_locz00_14080);
							}
						return CDR(((obj_t) BgL_a1z00_16581));
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2859> */
	obj_t BGl_z62zc3anonymousza32859ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14082, obj_t BgL_sz00_14085)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1011 */
			{	/* Eval/evaluate_comp.scm 1011 */
				obj_t BgL_a1z00_14083;
				obj_t BgL_locz00_14084;

				BgL_a1z00_14083 = PROCEDURE_REF(BgL_envz00_14082, (int) (((long) 0)));
				BgL_locz00_14084 = PROCEDURE_REF(BgL_envz00_14082, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1011 */
					obj_t BgL_bpz00_16582;

					BgL_bpz00_16582 = VECTOR_REF(((obj_t) BgL_sz00_14085), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1011 */
						obj_t BgL_a1z00_16583;

						BgL_a1z00_16583 =
							PROCEDURE_ENTRY(BgL_a1z00_14083) (BgL_a1z00_14083, BgL_sz00_14085,
							BEOA);
						{	/* Eval/evaluate_comp.scm 1011 */
							bool_t BgL_testz00_25320;

							if (PAIRP(BgL_a1z00_16583))
								{	/* Eval/evaluate_comp.scm 1020 */
									obj_t BgL_tmpz00_25323;

									BgL_tmpz00_25323 = CDR(BgL_a1z00_16583);
									BgL_testz00_25320 = PAIRP(BgL_tmpz00_25323);
								}
							else
								{	/* Eval/evaluate_comp.scm 1020 */
									BgL_testz00_25320 = ((bool_t) 0);
								}
							if (BgL_testz00_25320)
								{	/* Eval/evaluate_comp.scm 1011 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1011 */
									obj_t BgL_arg2861z00_16584;

									if (PAIRP(BgL_a1z00_16583))
										{	/* Eval/evaluate_comp.scm 1023 */
											BgL_arg2861z00_16584 = CDR(BgL_a1z00_16583);
										}
									else
										{	/* Eval/evaluate_comp.scm 1023 */
											BgL_arg2861z00_16584 = BgL_a1z00_16583;
										}
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5861z00zz__evaluate_compz00,
										BGl_symbol5857z00zz__evaluate_compz00, BgL_arg2861z00_16584,
										BgL_locz00_14084);
								}
						}
						{	/* Eval/evaluate_comp.scm 1011 */
							obj_t BgL_pairz00_16585;

							BgL_pairz00_16585 = CDR(((obj_t) BgL_a1z00_16583));
							return CAR(BgL_pairz00_16585);
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203,
		obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206,
		obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1056 */
			if ((BgL_arityz00_206 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1058 */
					long BgL_g1236z00_3513;

					BgL_g1236z00_3513 = (((long) -1) - BgL_arityz00_206);
					{
						long BgL_rz00_3515;
						long BgL_spz00_3516;
						obj_t BgL_lz00_3517;

						BgL_rz00_3515 = BgL_g1236z00_3513;
						BgL_spz00_3516 = BgL_spz00_205;
						BgL_lz00_3517 = BgL_valsz00_207;
					BgL_zc3anonymousza32867ze3z83_3518:
						if ((BgL_rz00_3515 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1060 */
								return
									VECTOR_SET(
									((obj_t) BgL_sz00_203), BgL_spz00_3516, BgL_lz00_3517);
							}
						else
							{	/* Eval/evaluate_comp.scm 1060 */
								if (PAIRP(BgL_lz00_3517))
									{	/* Eval/evaluate_comp.scm 1062 */
										{	/* Eval/evaluate_comp.scm 1065 */
											obj_t BgL_arg2870z00_3521;

											BgL_arg2870z00_3521 = CAR(BgL_lz00_3517);
											VECTOR_SET(
												((obj_t) BgL_sz00_203), BgL_spz00_3516,
												BgL_arg2870z00_3521);
										}
										{
											obj_t BgL_lz00_25349;
											long BgL_spz00_25347;
											long BgL_rz00_25345;

											BgL_rz00_25345 = (BgL_rz00_3515 - ((long) 1));
											BgL_spz00_25347 = (BgL_spz00_3516 + ((long) 1));
											BgL_lz00_25349 = CDR(BgL_lz00_3517);
											BgL_lz00_3517 = BgL_lz00_25349;
											BgL_spz00_3516 = BgL_spz00_25347;
											BgL_rz00_3515 = BgL_rz00_25345;
											goto BgL_zc3anonymousza32867ze3z83_3518;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1063 */
										long BgL_arg2875z00_3525;

										BgL_arg2875z00_3525 = bgl_list_length(BgL_valsz00_207);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
											BgL_wherez00_204, (int) (BgL_arityz00_206),
											(int) (BgL_arg2875z00_3525));
				}}}}
			else
				{
					long BgL_rz00_3528;
					long BgL_spz00_3529;
					obj_t BgL_lz00_3530;

					BgL_rz00_3528 = BgL_arityz00_206;
					BgL_spz00_3529 = BgL_spz00_205;
					BgL_lz00_3530 = BgL_valsz00_207;
				BgL_zc3anonymousza32876ze3z83_3531:
					if ((BgL_rz00_3528 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1069 */
							if (NULLP(BgL_lz00_3530))
								{	/* Eval/evaluate_comp.scm 1070 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1071 */
									long BgL_arg2879z00_3534;

									BgL_arg2879z00_3534 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2879z00_3534));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1069 */
							if (PAIRP(BgL_lz00_3530))
								{	/* Eval/evaluate_comp.scm 1072 */
									{	/* Eval/evaluate_comp.scm 1075 */
										obj_t BgL_arg2881z00_3536;

										BgL_arg2881z00_3536 = CAR(BgL_lz00_3530);
										VECTOR_SET(
											((obj_t) BgL_sz00_203), BgL_spz00_3529,
											BgL_arg2881z00_3536);
									}
									{
										obj_t BgL_lz00_25372;
										long BgL_spz00_25370;
										long BgL_rz00_25368;

										BgL_rz00_25368 = (BgL_rz00_3528 - ((long) 1));
										BgL_spz00_25370 = (BgL_spz00_3529 + ((long) 1));
										BgL_lz00_25372 = CDR(BgL_lz00_3530);
										BgL_lz00_3530 = BgL_lz00_25372;
										BgL_spz00_3529 = BgL_spz00_25370;
										BgL_rz00_3528 = BgL_rz00_25368;
										goto BgL_zc3anonymousza32876ze3z83_3531;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1073 */
									long BgL_arg2886z00_3540;

									BgL_arg2886z00_3540 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2886z00_3540));
		}}}}
		BGL_FUNCTION_END;
	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211,
		obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1170 */
			{
				long BgL_iz00_3544;

				BgL_iz00_3544 = ((long) 0);
			BgL_zc3anonymousza32887ze3z83_3545:
				{	/* Eval/evaluate_comp.scm 1173 */
					long BgL_spz00_3546;

					{	/* Eval/evaluate_comp.scm 1173 */
						obj_t BgL_arg2891z00_3551;

						BgL_arg2891z00_3551 =
							VECTOR_REF(((obj_t) BgL_ibza2za2_212), BgL_iz00_3544);
						BgL_spz00_3546 =
							((long) CINT(BgL_bpz00_213) + (long) CINT(BgL_arg2891z00_3551));
					}
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_arg2888z00_3547;

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_arg2889z00_3548;

							BgL_arg2889z00_3548 =
								VECTOR_REF(((obj_t) BgL_sz00_211), BgL_spz00_3546);
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_newz00_9648;

								BgL_newz00_9648 =
									create_struct(BGl_symbol5785z00zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_tmpz00_25387;

									BgL_tmpz00_25387 = (int) (((long) 0));
									STRUCT_SET(BgL_newz00_9648, BgL_tmpz00_25387,
										BgL_arg2889z00_3548);
								}
								BgL_arg2888z00_3547 = BgL_newz00_9648;
						}}
						VECTOR_SET(
							((obj_t) BgL_sz00_211), BgL_spz00_3546, BgL_arg2888z00_3547);
					}
					{	/* Eval/evaluate_comp.scm 1175 */
						long BgL_niz00_3549;

						BgL_niz00_3549 = (BgL_iz00_3544 + ((long) 1));
						if ((BgL_niz00_3549 < VECTOR_LENGTH(((obj_t) BgL_ibza2za2_212))))
							{
								long BgL_iz00_25397;

								BgL_iz00_25397 = BgL_niz00_3549;
								BgL_iz00_3544 = BgL_iz00_25397;
								goto BgL_zc3anonymousza32887ze3z83_3545;
							}
						else
							{	/* Eval/evaluate_comp.scm 1176 */
								return ((bool_t) 0);
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214,
		obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1178 */
			{	/* Eval/evaluate_comp.scm 1179 */
				obj_t BgL_rz00_3554;

				BgL_rz00_3554 =
					make_vector(VECTOR_LENGTH(((obj_t) BgL_iza2za2_216)), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 1179 */

					{
						long BgL_iz00_3556;

						BgL_iz00_3556 = ((long) 0);
					BgL_zc3anonymousza32892ze3z83_3557:
						if ((BgL_iz00_3556 >= VECTOR_LENGTH(((obj_t) BgL_iza2za2_216))))
							{	/* Eval/evaluate_comp.scm 1181 */
								return BgL_rz00_3554;
							}
						else
							{	/* Eval/evaluate_comp.scm 1181 */
								{	/* Eval/evaluate_comp.scm 1184 */
									obj_t BgL_arg2894z00_3559;

									{	/* Eval/evaluate_comp.scm 1184 */
										long BgL_arg2895z00_3560;

										{	/* Eval/evaluate_comp.scm 1184 */
											obj_t BgL_arg2896z00_3561;

											BgL_arg2896z00_3561 =
												VECTOR_REF(((obj_t) BgL_iza2za2_216), BgL_iz00_3556);
											BgL_arg2895z00_3560 =
												(
												(long) CINT(BgL_bpz00_215) +
												(long) CINT(BgL_arg2896z00_3561));
										}
										BgL_arg2894z00_3559 =
											VECTOR_REF(((obj_t) BgL_sz00_214), BgL_arg2895z00_3560);
									}
									VECTOR_SET(BgL_rz00_3554, BgL_iz00_3556, BgL_arg2894z00_3559);
								}
								{
									long BgL_iz00_25413;

									BgL_iz00_25413 = (BgL_iz00_3556 + ((long) 1));
									BgL_iz00_3556 = BgL_iz00_25413;
									goto BgL_zc3anonymousza32892ze3z83_3557;
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217,
		obj_t BgL_valza2za2_218, long BgL_spz00_219)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1187 */
			{	/* Eval/evaluate_comp.scm 1188 */
				long BgL_stopz00_3565;

				BgL_stopz00_3565 =
					(BgL_spz00_219 + VECTOR_LENGTH(((obj_t) BgL_valza2za2_218)));
				{
					long BgL_iz00_9708;
					long BgL_spz00_9709;

					BgL_iz00_9708 = ((long) 0);
					BgL_spz00_9709 = BgL_spz00_219;
				BgL_recz00_9707:
					if ((BgL_spz00_9709 < BgL_stopz00_3565))
						{	/* Eval/evaluate_comp.scm 1190 */
							{	/* Eval/evaluate_comp.scm 1191 */
								obj_t BgL_arg2902z00_9715;

								BgL_arg2902z00_9715 =
									VECTOR_REF(((obj_t) BgL_valza2za2_218), BgL_iz00_9708);
								VECTOR_SET(
									((obj_t) BgL_sz00_217), BgL_spz00_9709, BgL_arg2902z00_9715);
							}
							{
								long BgL_spz00_25426;
								long BgL_iz00_25424;

								BgL_iz00_25424 = (BgL_iz00_9708 + ((long) 1));
								BgL_spz00_25426 = (BgL_spz00_9709 + ((long) 1));
								BgL_spz00_9709 = BgL_spz00_25426;
								BgL_iz00_9708 = BgL_iz00_25424;
								goto BgL_recz00_9707;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1190 */
							return ((bool_t) 0);
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc5863z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string5864z00zz__evaluate_compz00);
		}
		BGL_FUNCTION_END;
	}



/* &comp1388 */
	obj_t BGl_z62comp1388z62zz__evaluate_compz00(obj_t BgL_envz00_14171,
		obj_t BgL_ez00_14172, obj_t BgL_stkz00_14173)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 276 */
			return
				BGl_errorz00zz__errorz00(BGl_string5775z00zz__evaluate_compz00,
				BGl_string5865z00zz__evaluate_compz00,
				((obj_t) ((BgL_ev_exprz00_bglt) BgL_ez00_14172)));
		}
		BGL_FUNCTION_END;
	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				obj_t BgL_method1389z00_3581;

				{	/* Eval/evaluate_comp.scm 276 */
					obj_t BgL_res5053z00_9773;

					{	/* Eval/evaluate_comp.scm 276 */
						long BgL_objzd2classzd2numz00_9730;

						{	/* Eval/evaluate_comp.scm 276 */
							long BgL_res5042z00_9733;

							BgL_res5042z00_9733 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_35));
							BgL_objzd2classzd2numz00_9730 = BgL_res5042z00_9733;
						}
						{	/* Eval/evaluate_comp.scm 276 */
							obj_t BgL_arg4280z00_9731;

							BgL_arg4280z00_9731 =
								PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_comp.scm 276 */
								int BgL_offsetz00_9735;

								BgL_offsetz00_9735 = (int) (BgL_objzd2classzd2numz00_9730);
								{	/* Eval/evaluate_comp.scm 276 */
									long BgL_offsetz00_9736;

									BgL_offsetz00_9736 =
										((long) (BgL_offsetz00_9735) - OBJECT_TYPE);
									{	/* Eval/evaluate_comp.scm 276 */
										long BgL_modz00_9737;

										{	/* Eval/evaluate_comp.scm 276 */
											int BgL_arg4282z00_9738;

											BgL_arg4282z00_9738 = (int) (((long) 16));
											{	/* Eval/evaluate_comp.scm 276 */
												long BgL_res5045z00_9748;

												{	/* Eval/evaluate_comp.scm 276 */
													long BgL_tmpz00_25440;

													BgL_tmpz00_25440 = (long) (BgL_arg4282z00_9738);
													BgL_res5045z00_9748 =
														(BgL_offsetz00_9736 / BgL_tmpz00_25440);
												}
												BgL_modz00_9737 = BgL_res5045z00_9748;
										}}
										{	/* Eval/evaluate_comp.scm 276 */
											long BgL_restz00_9739;

											{	/* Eval/evaluate_comp.scm 276 */
												int BgL_arg4281z00_9740;

												BgL_arg4281z00_9740 = (int) (((long) 16));
												{	/* Eval/evaluate_comp.scm 276 */
													long BgL_res5052z00_9768;

													{	/* Eval/evaluate_comp.scm 276 */
														long BgL_n1z00_9750;
														long BgL_n2z00_9751;

														BgL_n1z00_9750 = BgL_offsetz00_9736;
														BgL_n2z00_9751 = (long) (BgL_arg4281z00_9740);
														{	/* Eval/evaluate_comp.scm 276 */
															bool_t BgL_testz00_25445;

															{	/* Eval/evaluate_comp.scm 276 */
																long BgL_arg4165z00_9753;

																BgL_arg4165z00_9753 =
																	(((BgL_n1z00_9750) | (BgL_n2z00_9751)) &
																	-2147483648);
																BgL_testz00_25445 =
																	(BgL_arg4165z00_9753 == ((long) 0));
															}
															if (BgL_testz00_25445)
																{	/* Eval/evaluate_comp.scm 276 */
																	int32_t BgL_arg4162z00_9754;

																	{	/* Eval/evaluate_comp.scm 276 */
																		int32_t BgL_arg4163z00_9755;
																		int32_t BgL_arg4164z00_9756;

																		{	/* Eval/evaluate_comp.scm 276 */
																			int32_t BgL_res5048z00_9760;

																			BgL_res5048z00_9760 =
																				(int32_t) (BgL_n1z00_9750);
																			BgL_arg4163z00_9755 = BgL_res5048z00_9760;
																		}
																		{	/* Eval/evaluate_comp.scm 276 */
																			int32_t BgL_res5049z00_9762;

																			BgL_res5049z00_9762 =
																				(int32_t) (BgL_n2z00_9751);
																			BgL_arg4164z00_9756 = BgL_res5049z00_9762;
																		}
																		BgL_arg4162z00_9754 =
																			(BgL_arg4163z00_9755 %
																			BgL_arg4164z00_9756);
																	}
																	{	/* Eval/evaluate_comp.scm 276 */
																		long BgL_res5051z00_9767;

																		{	/* Eval/evaluate_comp.scm 276 */
																			long BgL_arg4256z00_9764;

																			BgL_arg4256z00_9764 =
																				(long) (BgL_arg4162z00_9754);
																			{	/* Eval/evaluate_comp.scm 276 */
																				long BgL_res5050z00_9766;

																				BgL_res5050z00_9766 =
																					(long) (BgL_arg4256z00_9764);
																				BgL_res5051z00_9767 =
																					BgL_res5050z00_9766;
																		}}
																		BgL_res5052z00_9768 = BgL_res5051z00_9767;
																}}
															else
																{	/* Eval/evaluate_comp.scm 276 */
																	BgL_res5052z00_9768 =
																		(BgL_n1z00_9750 % BgL_n2z00_9751);
																}
														}
													}
													BgL_restz00_9739 = BgL_res5052z00_9768;
												}
											}
											{	/* Eval/evaluate_comp.scm 276 */

												{	/* Eval/evaluate_comp.scm 276 */
													obj_t BgL_bucketz00_9741;

													BgL_bucketz00_9741 =
														VECTOR_REF(
														((obj_t) BgL_arg4280z00_9731), BgL_modz00_9737);
													BgL_res5053z00_9773 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_9741), BgL_restz00_9739);
												}
											}
										}
									}
								}
							}
						}
					}
					BgL_method1389z00_3581 = BgL_res5053z00_9773;
				}
				return
					PROCEDURE_ENTRY(BgL_method1389z00_3581) (BgL_method1389z00_3581,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_14174,
		obj_t BgL_ez00_14175, obj_t BgL_stkz00_14176)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				BgL_ev_exprz00_bglt BgL_auxz00_25464;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_14175,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 276 */
						BgL_auxz00_25464 = ((BgL_ev_exprz00_bglt) BgL_ez00_14175);
					}
				else
					{
						obj_t BgL_auxz00_25468;

						BgL_auxz00_25468 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5780z00zz__evaluate_compz00, BINT(((long) 7022)),
							BGl_string5866z00zz__evaluate_compz00,
							BGl_string5782z00zz__evaluate_compz00, BgL_ez00_14175);
						FAILURE(BgL_auxz00_25468, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_25464, BgL_stkz00_14176);
			}
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc5867z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5869z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc5870z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc5871z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc5872z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc5873z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc5874z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5875z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5876z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5877z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc5878z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5879z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc5880z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc5881z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc5882z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc5883z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc5884z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc5885z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc5886z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc5887z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5888z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5889z00zz__evaluate_compz00,
				BGl_string5868z00zz__evaluate_compz00);
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_abs1434 */
	obj_t BGl_z62compzd2ev_abs1434zb0zz__evaluate_compz00(obj_t BgL_envz00_14371,
		obj_t BgL_ez00_14372, obj_t BgL_stkz00_14373)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1158 */
			{	/* Eval/evaluate_comp.scm 1160 */
				obj_t BgL_ifreesz00_16588;
				obj_t BgL_iboxesz00_16589;
				long BgL_siza7eza7_16590;
				long BgL_siza7ezd2framez75_16591;
				obj_t BgL_nstkz00_16592;

				{	/* Eval/evaluate_comp.scm 1160 */
					obj_t BgL_arg3990z00_16593;

					{	/* Eval/evaluate_comp.scm 1160 */
						obj_t BgL_l1365z00_16594;

						BgL_l1365z00_16594 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_freez00);
						if (NULLP(BgL_l1365z00_16594))
							{	/* Eval/evaluate_comp.scm 1160 */
								BgL_arg3990z00_16593 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1160 */
								obj_t BgL_head1367z00_16595;

								{	/* Eval/evaluate_comp.scm 1160 */
									obj_t BgL_res5192z00_16596;

									BgL_res5192z00_16596 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1367z00_16595 = BgL_res5192z00_16596;
								}
								{
									obj_t BgL_l1365z00_16598;
									obj_t BgL_tail1368z00_16599;

									BgL_l1365z00_16598 = BgL_l1365z00_16594;
									BgL_tail1368z00_16599 = BgL_head1367z00_16595;
								BgL_zc3anonymousza33992ze3z83_16597:
									if (NULLP(BgL_l1365z00_16598))
										{	/* Eval/evaluate_comp.scm 1160 */
											BgL_arg3990z00_16593 = CDR(BgL_head1367z00_16595);
										}
									else
										{	/* Eval/evaluate_comp.scm 1160 */
											obj_t BgL_newtail1369z00_16600;

											{	/* Eval/evaluate_comp.scm 1160 */
												obj_t BgL_arg3995z00_16601;

												{	/* Eval/evaluate_comp.scm 1160 */
													obj_t BgL_vz00_16602;

													BgL_vz00_16602 = CAR(((obj_t) BgL_l1365z00_16598));
													BgL_arg3995z00_16601 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16602,
														BgL_stkz00_14373);
												}
												{	/* Eval/evaluate_comp.scm 1160 */
													obj_t BgL_res5198z00_16603;

													BgL_res5198z00_16603 =
														MAKE_YOUNG_PAIR(BgL_arg3995z00_16601, BNIL);
													BgL_newtail1369z00_16600 = BgL_res5198z00_16603;
												}
											}
											SET_CDR(BgL_tail1368z00_16599, BgL_newtail1369z00_16600);
											{	/* Eval/evaluate_comp.scm 1160 */
												obj_t BgL_arg3994z00_16604;

												BgL_arg3994z00_16604 =
													CDR(((obj_t) BgL_l1365z00_16598));
												{
													obj_t BgL_tail1368z00_25511;
													obj_t BgL_l1365z00_25510;

													BgL_l1365z00_25510 = BgL_arg3994z00_16604;
													BgL_tail1368z00_25511 = BgL_newtail1369z00_16600;
													BgL_tail1368z00_16599 = BgL_tail1368z00_25511;
													BgL_l1365z00_16598 = BgL_l1365z00_25510;
													goto BgL_zc3anonymousza33992ze3z83_16597;
												}
											}
										}
								}
							}
					}
					BgL_ifreesz00_16588 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3990z00_16593);
				}
				{	/* Eval/evaluate_comp.scm 1161 */
					obj_t BgL_arg3996z00_16605;

					{	/* Eval/evaluate_comp.scm 1161 */
						obj_t BgL_l1370z00_16606;

						BgL_l1370z00_16606 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_boxesz00);
						if (NULLP(BgL_l1370z00_16606))
							{	/* Eval/evaluate_comp.scm 1161 */
								BgL_arg3996z00_16605 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1161 */
								obj_t BgL_head1372z00_16607;

								{	/* Eval/evaluate_comp.scm 1161 */
									obj_t BgL_res5200z00_16608;

									BgL_res5200z00_16608 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1372z00_16607 = BgL_res5200z00_16608;
								}
								{
									obj_t BgL_l1370z00_16610;
									obj_t BgL_tail1373z00_16611;

									BgL_l1370z00_16610 = BgL_l1370z00_16606;
									BgL_tail1373z00_16611 = BgL_head1372z00_16607;
								BgL_zc3anonymousza33998ze3z83_16609:
									if (NULLP(BgL_l1370z00_16610))
										{	/* Eval/evaluate_comp.scm 1161 */
											BgL_arg3996z00_16605 = CDR(BgL_head1372z00_16607);
										}
									else
										{	/* Eval/evaluate_comp.scm 1161 */
											obj_t BgL_newtail1374z00_16612;

											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_arg4001z00_16613;

												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_vz00_16614;

													BgL_vz00_16614 = CAR(((obj_t) BgL_l1370z00_16610));
													BgL_arg4001z00_16613 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16614,
														(((BgL_ev_absz00_bglt) COBJECT(
																	((BgL_ev_absz00_bglt) BgL_ez00_14372)))->
															BgL_varsz00));
												}
												{	/* Eval/evaluate_comp.scm 1161 */
													obj_t BgL_res5202z00_16615;

													BgL_res5202z00_16615 =
														MAKE_YOUNG_PAIR(BgL_arg4001z00_16613, BNIL);
													BgL_newtail1374z00_16612 = BgL_res5202z00_16615;
												}
											}
											SET_CDR(BgL_tail1373z00_16611, BgL_newtail1374z00_16612);
											{	/* Eval/evaluate_comp.scm 1161 */
												obj_t BgL_arg4000z00_16616;

												BgL_arg4000z00_16616 =
													CDR(((obj_t) BgL_l1370z00_16610));
												{
													obj_t BgL_tail1373z00_25531;
													obj_t BgL_l1370z00_25530;

													BgL_l1370z00_25530 = BgL_arg4000z00_16616;
													BgL_tail1373z00_25531 = BgL_newtail1374z00_16612;
													BgL_tail1373z00_16611 = BgL_tail1373z00_25531;
													BgL_l1370z00_16610 = BgL_l1370z00_25530;
													goto BgL_zc3anonymousza33998ze3z83_16609;
												}
											}
										}
								}
							}
					}
					BgL_iboxesz00_16589 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3996z00_16605);
				}
				BgL_siza7eza7_16590 =
					bgl_list_length(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_varsz00));
				BgL_siza7ezd2framez75_16591 =
					(
					(long) (
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_siza7eza7)) +
					bgl_list_length(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_freez00)));
				BgL_nstkz00_16592 =
					BGl_appendzd221011zd2zz__evaluate_compz00(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_varsz00),
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_freez00));
				{	/* Eval/evaluate_comp.scm 1165 */
					obj_t BgL_bodyz00_16617;

					BgL_bodyz00_16617 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_bodyz00),
						BgL_nstkz00_16592);
					{

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_aux1248z00_16623;

							BgL_aux1248z00_16623 =
								(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_14372)))->BgL_arityz00);
							if (INTEGERP(BgL_aux1248z00_16623))
								{	/* Eval/evaluate_comp.scm 1167 */
									switch ((long) CINT(BgL_aux1248z00_16623))
										{
										case ((long) 0):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33425ze3z83_16624;

															BgL_zc3anonymousza33425ze3z83_16624 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33425ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33425ze3z83_16624,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33425ze3z83_16624,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33425ze3z83_16624,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33425ze3z83_16624;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33432ze3z83_16625;

															BgL_zc3anonymousza33432ze3z83_16625 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33432ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33432ze3z83_16625,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33432ze3z83_16625,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33432ze3z83_16625,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33432ze3z83_16625,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33432ze3z83_16625;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33442ze3z83_16626;

															BgL_zc3anonymousza33442ze3z83_16626 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33442ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33442ze3z83_16626,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33442ze3z83_16626,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33442ze3z83_16626,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33442ze3z83_16626,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33442ze3z83_16626,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33442ze3z83_16626;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33450ze3z83_16627;

															BgL_zc3anonymousza33450ze3z83_16627 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33450ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33450ze3z83_16627,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33450ze3z83_16627,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33450ze3z83_16627,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33450ze3z83_16627,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33450ze3z83_16627,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33450ze3z83_16627,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33450ze3z83_16627;
														}
												}
											break;
										case ((long) -1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33463ze3z83_16628;

															BgL_zc3anonymousza33463ze3z83_16628 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33463ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33463ze3z83_16628,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33463ze3z83_16628,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33463ze3z83_16628,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33463ze3z83_16628;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33470ze3z83_16629;

															BgL_zc3anonymousza33470ze3z83_16629 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33470ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33470ze3z83_16629,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33470ze3z83_16629,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33470ze3z83_16629,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33470ze3z83_16629,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33470ze3z83_16629;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33480ze3z83_16630;

															BgL_zc3anonymousza33480ze3z83_16630 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33480ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33480ze3z83_16630,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33480ze3z83_16630,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33480ze3z83_16630,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33480ze3z83_16630,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33480ze3z83_16630,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33480ze3z83_16630;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33488ze3z83_16631;

															BgL_zc3anonymousza33488ze3z83_16631 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33488ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33488ze3z83_16631,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33488ze3z83_16631,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33488ze3z83_16631,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33488ze3z83_16631,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33488ze3z83_16631,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33488ze3z83_16631,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33488ze3z83_16631;
														}
												}
											break;
										case ((long) 1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33502ze3z83_16632;

															BgL_zc3anonymousza33502ze3z83_16632 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33502ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33502ze3z83_16632,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33502ze3z83_16632,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33502ze3z83_16632,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33502ze3z83_16632;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33509ze3z83_16633;

															BgL_zc3anonymousza33509ze3z83_16633 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_16633,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_16633,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_16633,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33509ze3z83_16633,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33509ze3z83_16633;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33519ze3z83_16634;

															BgL_zc3anonymousza33519ze3z83_16634 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33519ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33519ze3z83_16634,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33519ze3z83_16634,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33519ze3z83_16634,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33519ze3z83_16634,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33519ze3z83_16634,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33519ze3z83_16634;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33528ze3z83_16635;

															BgL_zc3anonymousza33528ze3z83_16635 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33528ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33528ze3z83_16635,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33528ze3z83_16635,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33528ze3z83_16635,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33528ze3z83_16635,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33528ze3z83_16635,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33528ze3z83_16635,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33528ze3z83_16635;
														}
												}
											break;
										case ((long) -2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33543ze3z83_16636;

															BgL_zc3anonymousza33543ze3z83_16636 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33543ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33543ze3z83_16636,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33543ze3z83_16636,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33543ze3z83_16636,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33543ze3z83_16636;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33552ze3z83_16637;

															BgL_zc3anonymousza33552ze3z83_16637 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33552ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33552ze3z83_16637,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33552ze3z83_16637,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33552ze3z83_16637,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33552ze3z83_16637,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33552ze3z83_16637;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33564ze3z83_16638;

															BgL_zc3anonymousza33564ze3z83_16638 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33564ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33564ze3z83_16638,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33564ze3z83_16638,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33564ze3z83_16638,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33564ze3z83_16638,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33564ze3z83_16638,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33564ze3z83_16638;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33575ze3z83_16639;

															BgL_zc3anonymousza33575ze3z83_16639 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33575ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33575ze3z83_16639,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33575ze3z83_16639,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33575ze3z83_16639,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33575ze3z83_16639,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33575ze3z83_16639,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33575ze3z83_16639,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33575ze3z83_16639;
														}
												}
											break;
										case ((long) 2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33591ze3z83_16640;

															BgL_zc3anonymousza33591ze3z83_16640 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33591ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33591ze3z83_16640,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33591ze3z83_16640,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33591ze3z83_16640,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33591ze3z83_16640;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33599ze3z83_16641;

															BgL_zc3anonymousza33599ze3z83_16641 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33599ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33599ze3z83_16641,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33599ze3z83_16641,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33599ze3z83_16641,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33599ze3z83_16641,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33599ze3z83_16641;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33612ze3z83_16642;

															BgL_zc3anonymousza33612ze3z83_16642 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33612ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33612ze3z83_16642,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33612ze3z83_16642,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33612ze3z83_16642,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33612ze3z83_16642,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33612ze3z83_16642,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33612ze3z83_16642;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33621ze3z83_16643;

															BgL_zc3anonymousza33621ze3z83_16643 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33621ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33621ze3z83_16643,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33621ze3z83_16643,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33621ze3z83_16643,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33621ze3z83_16643,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33621ze3z83_16643,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33621ze3z83_16643,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33621ze3z83_16643;
														}
												}
											break;
										case ((long) -3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33638ze3z83_16644;

															BgL_zc3anonymousza33638ze3z83_16644 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33638ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33638ze3z83_16644,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33638ze3z83_16644,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33638ze3z83_16644,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33638ze3z83_16644;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33648ze3z83_16645;

															BgL_zc3anonymousza33648ze3z83_16645 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33648ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33648ze3z83_16645,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33648ze3z83_16645,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33648ze3z83_16645,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33648ze3z83_16645,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33648ze3z83_16645;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33663ze3z83_16646;

															BgL_zc3anonymousza33663ze3z83_16646 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33663ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33663ze3z83_16646,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33663ze3z83_16646,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33663ze3z83_16646,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33663ze3z83_16646,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33663ze3z83_16646,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33663ze3z83_16646;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33675ze3z83_16647;

															BgL_zc3anonymousza33675ze3z83_16647 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33675ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33675ze3z83_16647,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33675ze3z83_16647,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33675ze3z83_16647,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33675ze3z83_16647,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33675ze3z83_16647,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33675ze3z83_16647,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33675ze3z83_16647;
														}
												}
											break;
										case ((long) 3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33694ze3z83_16648;

															BgL_zc3anonymousza33694ze3z83_16648 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33694ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33694ze3z83_16648,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33694ze3z83_16648,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33694ze3z83_16648,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33694ze3z83_16648;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33703ze3z83_16649;

															BgL_zc3anonymousza33703ze3z83_16649 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33703ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33703ze3z83_16649,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33703ze3z83_16649,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33703ze3z83_16649,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33703ze3z83_16649,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33703ze3z83_16649;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33717ze3z83_16650;

															BgL_zc3anonymousza33717ze3z83_16650 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33717ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33717ze3z83_16650,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33717ze3z83_16650,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33717ze3z83_16650,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33717ze3z83_16650,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33717ze3z83_16650,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33717ze3z83_16650;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33728ze3z83_16651;

															BgL_zc3anonymousza33728ze3z83_16651 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33728ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_16651,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_16651,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_16651,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_16651,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_16651,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33728ze3z83_16651,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33728ze3z83_16651;
														}
												}
											break;
										case ((long) -4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33744ze3z83_16652;

															BgL_zc3anonymousza33744ze3z83_16652 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33744ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33744ze3z83_16652,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33744ze3z83_16652,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33744ze3z83_16652,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33744ze3z83_16652;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33754ze3z83_16653;

															BgL_zc3anonymousza33754ze3z83_16653 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33754ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33754ze3z83_16653,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33754ze3z83_16653,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33754ze3z83_16653,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33754ze3z83_16653,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33754ze3z83_16653;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33767ze3z83_16654;

															BgL_zc3anonymousza33767ze3z83_16654 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33767ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33767ze3z83_16654,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33767ze3z83_16654,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33767ze3z83_16654,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33767ze3z83_16654,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33767ze3z83_16654,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33767ze3z83_16654;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33779ze3z83_16655;

															BgL_zc3anonymousza33779ze3z83_16655 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33779ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33779ze3z83_16655,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33779ze3z83_16655,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33779ze3z83_16655,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33779ze3z83_16655,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33779ze3z83_16655,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33779ze3z83_16655,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33779ze3z83_16655;
														}
												}
											break;
										case ((long) 4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33796ze3z83_16656;

															BgL_zc3anonymousza33796ze3z83_16656 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33796ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33796ze3z83_16656,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33796ze3z83_16656,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33796ze3z83_16656,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33796ze3z83_16656;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33806ze3z83_16657;

															BgL_zc3anonymousza33806ze3z83_16657 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33806ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33806ze3z83_16657,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33806ze3z83_16657,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33806ze3z83_16657,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33806ze3z83_16657,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33806ze3z83_16657;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33819ze3z83_16658;

															BgL_zc3anonymousza33819ze3z83_16658 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33819ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33819ze3z83_16658,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33819ze3z83_16658,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33819ze3z83_16658,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33819ze3z83_16658,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33819ze3z83_16658,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33819ze3z83_16658;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33830ze3z83_16659;

															BgL_zc3anonymousza33830ze3z83_16659 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33830ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33830ze3z83_16659,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33830ze3z83_16659,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33830ze3z83_16659,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33830ze3z83_16659,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33830ze3z83_16659,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33830ze3z83_16659,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33830ze3z83_16659;
														}
												}
											break;
										case ((long) -5):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33847ze3z83_16660;

															BgL_zc3anonymousza33847ze3z83_16660 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33847ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33847ze3z83_16660,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33847ze3z83_16660,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33847ze3z83_16660,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33847ze3z83_16660;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33858ze3z83_16661;

															BgL_zc3anonymousza33858ze3z83_16661 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33858ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33858ze3z83_16661,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33858ze3z83_16661,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33858ze3z83_16661,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33858ze3z83_16661,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33858ze3z83_16661;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33872ze3z83_16662;

															BgL_zc3anonymousza33872ze3z83_16662 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33872ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33872ze3z83_16662,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33872ze3z83_16662,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33872ze3z83_16662,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33872ze3z83_16662,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33872ze3z83_16662,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33872ze3z83_16662;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33884ze3z83_16663;

															BgL_zc3anonymousza33884ze3z83_16663 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33884ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33884ze3z83_16663,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33884ze3z83_16663,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33884ze3z83_16663,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33884ze3z83_16663,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33884ze3z83_16663,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33884ze3z83_16663,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33884ze3z83_16663;
														}
												}
											break;
										default:
										BgL_case_else1247z00_16618:
											if ((VECTOR_LENGTH(BgL_ifreesz00_16588) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33902ze3z83_16619;

															BgL_zc3anonymousza33902ze3z83_16619 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33902ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET(BgL_zc3anonymousza33902ze3z83_16619,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33902ze3z83_16619,
																(int) (((long) 1)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33902ze3z83_16619,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33902ze3z83_16619;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33922ze3z83_16620;

															BgL_zc3anonymousza33922ze3z83_16620 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33922ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET(BgL_zc3anonymousza33922ze3z83_16620,
																(int) (((long) 0)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33922ze3z83_16620,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33922ze3z83_16620,
																(int) (((long) 2)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33922ze3z83_16620,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33922ze3z83_16620;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1167 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16589) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33945ze3z83_16621;

															BgL_zc3anonymousza33945ze3z83_16621 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33945ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET(BgL_zc3anonymousza33945ze3z83_16621,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33945ze3z83_16621,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33945ze3z83_16621,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33945ze3z83_16621,
																(int) (((long) 3)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33945ze3z83_16621,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33945ze3z83_16621;
														}
													else
														{	/* Eval/evaluate_comp.scm 1167 */
															obj_t BgL_zc3anonymousza33966ze3z83_16622;

															BgL_zc3anonymousza33966ze3z83_16622 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3anonymousza33966ze3ze1zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET(BgL_zc3anonymousza33966ze3z83_16622,
																(int) (((long) 0)), BgL_ifreesz00_16588);
															PROCEDURE_SET(BgL_zc3anonymousza33966ze3z83_16622,
																(int) (((long) 1)), BgL_iboxesz00_16589);
															PROCEDURE_SET(BgL_zc3anonymousza33966ze3z83_16622,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16590));
															PROCEDURE_SET(BgL_zc3anonymousza33966ze3z83_16622,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14372)));
															PROCEDURE_SET(BgL_zc3anonymousza33966ze3z83_16622,
																(int) (((long) 4)), BgL_bodyz00_16617);
															PROCEDURE_SET(BgL_zc3anonymousza33966ze3z83_16622,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16591));
															return BgL_zc3anonymousza33966ze3z83_16622;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1167 */
									goto BgL_case_else1247z00_16618;
								}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3847> */
	obj_t BGl_z62zc3anonymousza33847ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14374, obj_t BgL_sz00_14378)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14375;
				obj_t BgL_bodyz00_14376;
				long BgL_siza7ezd2framez75_14377;

				BgL_i1246z00_14375 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14374, (int) (((long) 0))));
				BgL_bodyz00_14376 = PROCEDURE_REF(BgL_envz00_14374, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14377 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14374, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16664;

					BgL_bpz00_16664 = VECTOR_REF(((obj_t) BgL_sz00_14378), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16665;

							BgL_runz00_16665 =
								MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16665,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14375));
							PROCEDURE_SET(BgL_runz00_16665,
								(int) (((long) 1)), BgL_bodyz00_14376);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16666;

								BgL_mainz00_16666 =
									MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16666,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14375));
								PROCEDURE_SET(BgL_mainz00_16666,
									(int) (((long) 1)), BgL_bodyz00_14376);
								PROCEDURE_SET(BgL_mainz00_16666,
									(int) (((long) 2)), BgL_runz00_16665);
								PROCEDURE_SET(BgL_mainz00_16666,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14377));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16667;

									BgL_objz00_16667 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16665, BgL_objz00_16667);
									BgL_objz00_16667;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3848z00_16668;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3849z00_16669;

										BgL_arg3849z00_16669 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14375))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16670;

											BgL_newz00_16670 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26373;

												BgL_tmpz00_26373 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16670, BgL_tmpz00_26373,
													BgL_arg3849z00_16669);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26378;
												int BgL_tmpz00_26376;

												BgL_auxz00_26378 = BINT(BgL_siza7ezd2framez75_14377);
												BgL_tmpz00_26376 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16670, BgL_tmpz00_26376,
													BgL_auxz00_26378);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26381;

												BgL_tmpz00_26381 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16670, BgL_tmpz00_26381,
													BgL_runz00_16665);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26386;
												int BgL_tmpz00_26384;

												BgL_auxz00_26386 = BINT(((long) -5));
												BgL_tmpz00_26384 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16670, BgL_tmpz00_26384,
													BgL_auxz00_26386);
											}
											BgL_arg3848z00_16668 = BgL_newz00_16670;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16666, BgL_arg3848z00_16668);
									BgL_arg3848z00_16668;
								}
								return BgL_mainz00_16666;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_14379,
		obj_t BgL_az00_14384, obj_t BgL_bz00_14385, obj_t BgL_cz00_14386,
		obj_t BgL_dz00_14387, obj_t BgL_lastz00_14388)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14382;
				long BgL_siza7ezd2framez75_14383;

				BgL_runz00_14382 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14379, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14383 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14379, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16671;

					BgL_sz00_16671 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16672;

						BgL_bpz00_16672 = VECTOR_REF(((obj_t) BgL_sz00_16671), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16672) + BgL_siza7ezd2framez75_14383) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16671))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3852z00_16673;

									BgL_arg3852z00_16673 =
										((long) CINT(BgL_bpz00_16672) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16671), BgL_arg3852z00_16673,
										BgL_az00_14384);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3853z00_16674;

									BgL_arg3853z00_16674 =
										((long) CINT(BgL_bpz00_16672) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16671), BgL_arg3853z00_16674,
										BgL_bz00_14385);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3854z00_16675;

									BgL_arg3854z00_16675 =
										((long) CINT(BgL_bpz00_16672) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16671), BgL_arg3854z00_16675,
										BgL_cz00_14386);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3855z00_16676;

									BgL_arg3855z00_16676 =
										((long) CINT(BgL_bpz00_16672) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16671), BgL_arg3855z00_16676,
										BgL_dz00_14387);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3856z00_16677;

									BgL_arg3856z00_16677 =
										((long) CINT(BgL_bpz00_16672) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16671), BgL_arg3856z00_16677,
										BgL_lastz00_14388);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16678;

									BgL_ez00_16678 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16678,
										BgL_bpz00_16672);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16679;

										BgL_accz00_16679 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14382, BgL_sz00_16671, BgL_bpz00_16672);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16678);
										VECTOR_SET(
											((obj_t) BgL_sz00_16671), ((long) 0), BgL_bpz00_16672);
										return BgL_accz00_16679;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16680;

								BgL_nsz00_16680 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16680, ((long) 1), BgL_sz00_16671);
								VECTOR_SET(BgL_nsz00_16680, ((long) 2), BgL_az00_14384);
								VECTOR_SET(BgL_nsz00_16680, ((long) 3), BgL_bz00_14385);
								VECTOR_SET(BgL_nsz00_16680, ((long) 4), BgL_cz00_14386);
								VECTOR_SET(BgL_nsz00_16680, ((long) 5), BgL_dz00_14387);
								VECTOR_SET(BgL_nsz00_16680, ((long) 6), BgL_lastz00_14388);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16681;

									BgL_z12denvz12_16681 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16681, BgL_nsz00_16680);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16682;

										BgL_ez00_16682 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16682,
											BgL_sz00_16671);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16683;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16684;

												BgL_savedzd2bpzd2_16684 =
													VECTOR_REF(BgL_nsz00_16680, ((long) 0));
												VECTOR_SET(BgL_nsz00_16680, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16686;

													BgL_fz00_16686 = BgL_runz00_14382;
												BgL_recz00_16685:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16687;

														BgL_rz00_16687 =
															PROCEDURE_ENTRY(BgL_fz00_16686) (BgL_fz00_16686,
															BgL_nsz00_16680, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_26449;

															if (PROCEDUREP(BgL_rz00_16687))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16688;

																	BgL_arg1696z00_16688 =
																		PROCEDURE_ATTR(BgL_rz00_16687);
																	if (STRUCTP(BgL_arg1696z00_16688))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26449 =
																				(STRUCT_KEY(BgL_arg1696z00_16688) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26449 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_26449 = ((bool_t) 0);
																}
															if (BgL_testz00_26449)
																{
																	obj_t BgL_fz00_26457;

																	BgL_fz00_26457 = BgL_rz00_16687;
																	BgL_fz00_16686 = BgL_fz00_26457;
																	goto BgL_recz00_16685;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16680, ((long) 0),
																		BgL_savedzd2bpzd2_16684);
																	BgL_____rz00_16683 = BgL_rz00_16687;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16682);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16681, BgL_sz00_16671);
											return BgL_____rz00_16683;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_14389,
		obj_t BgL_sz00_14392)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14390;
				obj_t BgL_bodyz00_14391;

				BgL_i1246z00_14390 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14389, (int) (((long) 0))));
				BgL_bodyz00_14391 = PROCEDURE_REF(BgL_envz00_14389, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16689;

					BgL_bpz00_16689 = VECTOR_REF(((obj_t) BgL_sz00_14392), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16690;
						obj_t BgL_wherez00_16691;
						obj_t BgL_locz00_16692;

						BgL_z12denvz12_16690 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16691 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14390))->
							BgL_wherez00);
						BgL_locz00_16692 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14390))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16690, BgL_wherez00_16691,
								BgL_locz00_16692);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16693;

								BgL_za2za2resza2za2z00_16693 =
									PROCEDURE_ENTRY(BgL_bodyz00_14391) (BgL_bodyz00_14391,
									BgL_sz00_14392, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16690);
								return BgL_za2za2resza2za2z00_16693;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3858> */
	obj_t BGl_z62zc3anonymousza33858ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14393, obj_t BgL_sz00_14398)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14394;
				BgL_ev_absz00_bglt BgL_i1246z00_14395;
				obj_t BgL_bodyz00_14396;
				long BgL_siza7ezd2framez75_14397;

				BgL_iboxesz00_14394 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14393, (int) (((long) 0))));
				BgL_i1246z00_14395 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14393, (int) (((long) 1))));
				BgL_bodyz00_14396 = PROCEDURE_REF(BgL_envz00_14393, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14397 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14393, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16694;

					BgL_bpz00_16694 = VECTOR_REF(((obj_t) BgL_sz00_14398), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16695;

							BgL_runz00_16695 =
								MAKE_FX_PROCEDURE(BGl_z62run5678z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16695,
								(int) (((long) 0)), BgL_iboxesz00_14394);
							PROCEDURE_SET(BgL_runz00_16695,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14395));
							PROCEDURE_SET(BgL_runz00_16695,
								(int) (((long) 2)), BgL_bodyz00_14396);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16696;

								BgL_mainz00_16696 =
									MAKE_VA_PROCEDURE(BGl_z62main5677z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16696,
									(int) (((long) 0)), BgL_iboxesz00_14394);
								PROCEDURE_SET(BgL_mainz00_16696,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14395));
								PROCEDURE_SET(BgL_mainz00_16696,
									(int) (((long) 2)), BgL_bodyz00_14396);
								PROCEDURE_SET(BgL_mainz00_16696,
									(int) (((long) 3)), BgL_runz00_16695);
								PROCEDURE_SET(BgL_mainz00_16696,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14397));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16697;

									BgL_objz00_16697 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16695, BgL_objz00_16697);
									BgL_objz00_16697;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3859z00_16698;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3860z00_16699;

										BgL_arg3860z00_16699 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14395))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16700;

											BgL_newz00_16700 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26519;

												BgL_tmpz00_26519 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16700, BgL_tmpz00_26519,
													BgL_arg3860z00_16699);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26524;
												int BgL_tmpz00_26522;

												BgL_auxz00_26524 = BINT(BgL_siza7ezd2framez75_14397);
												BgL_tmpz00_26522 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16700, BgL_tmpz00_26522,
													BgL_auxz00_26524);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26527;

												BgL_tmpz00_26527 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16700, BgL_tmpz00_26527,
													BgL_runz00_16695);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26532;
												int BgL_tmpz00_26530;

												BgL_auxz00_26532 = BINT(((long) -5));
												BgL_tmpz00_26530 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16700, BgL_tmpz00_26530,
													BgL_auxz00_26532);
											}
											BgL_arg3859z00_16698 = BgL_newz00_16700;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16696, BgL_arg3859z00_16698);
									BgL_arg3859z00_16698;
								}
								return BgL_mainz00_16696;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5677 */
	obj_t BGl_z62main5677z62zz__evaluate_compz00(obj_t BgL_envz00_14399,
		obj_t BgL_az00_14405, obj_t BgL_bz00_14406, obj_t BgL_cz00_14407,
		obj_t BgL_dz00_14408, obj_t BgL_lastz00_14409)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14403;
				long BgL_siza7ezd2framez75_14404;

				BgL_runz00_14403 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14399, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14404 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14399, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16701;

					BgL_sz00_16701 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16702;

						BgL_bpz00_16702 = VECTOR_REF(((obj_t) BgL_sz00_16701), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16702) + BgL_siza7ezd2framez75_14404) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16701))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3863z00_16703;

									BgL_arg3863z00_16703 =
										((long) CINT(BgL_bpz00_16702) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16701), BgL_arg3863z00_16703,
										BgL_az00_14405);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3864z00_16704;

									BgL_arg3864z00_16704 =
										((long) CINT(BgL_bpz00_16702) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16701), BgL_arg3864z00_16704,
										BgL_bz00_14406);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3865z00_16705;

									BgL_arg3865z00_16705 =
										((long) CINT(BgL_bpz00_16702) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16701), BgL_arg3865z00_16705,
										BgL_cz00_14407);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3866z00_16706;

									BgL_arg3866z00_16706 =
										((long) CINT(BgL_bpz00_16702) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16701), BgL_arg3866z00_16706,
										BgL_dz00_14408);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3867z00_16707;

									BgL_arg3867z00_16707 =
										((long) CINT(BgL_bpz00_16702) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16701), BgL_arg3867z00_16707,
										BgL_lastz00_14409);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16708;

									BgL_ez00_16708 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16708,
										BgL_bpz00_16702);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16709;

										BgL_accz00_16709 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14403, BgL_sz00_16701, BgL_bpz00_16702);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16708);
										VECTOR_SET(
											((obj_t) BgL_sz00_16701), ((long) 0), BgL_bpz00_16702);
										return BgL_accz00_16709;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16710;

								BgL_nsz00_16710 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16710, ((long) 1), BgL_sz00_16701);
								VECTOR_SET(BgL_nsz00_16710, ((long) 2), BgL_az00_14405);
								VECTOR_SET(BgL_nsz00_16710, ((long) 3), BgL_bz00_14406);
								VECTOR_SET(BgL_nsz00_16710, ((long) 4), BgL_cz00_14407);
								VECTOR_SET(BgL_nsz00_16710, ((long) 5), BgL_dz00_14408);
								VECTOR_SET(BgL_nsz00_16710, ((long) 6), BgL_lastz00_14409);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16711;

									BgL_z12denvz12_16711 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16711, BgL_nsz00_16710);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16712;

										BgL_ez00_16712 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16712,
											BgL_sz00_16701);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16713;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16714;

												BgL_savedzd2bpzd2_16714 =
													VECTOR_REF(BgL_nsz00_16710, ((long) 0));
												VECTOR_SET(BgL_nsz00_16710, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16716;

													BgL_fz00_16716 = BgL_runz00_14403;
												BgL_recz00_16715:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16717;

														BgL_rz00_16717 =
															PROCEDURE_ENTRY(BgL_fz00_16716) (BgL_fz00_16716,
															BgL_nsz00_16710, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_26595;

															if (PROCEDUREP(BgL_rz00_16717))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16718;

																	BgL_arg1696z00_16718 =
																		PROCEDURE_ATTR(BgL_rz00_16717);
																	if (STRUCTP(BgL_arg1696z00_16718))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26595 =
																				(STRUCT_KEY(BgL_arg1696z00_16718) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26595 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_26595 = ((bool_t) 0);
																}
															if (BgL_testz00_26595)
																{
																	obj_t BgL_fz00_26603;

																	BgL_fz00_26603 = BgL_rz00_16717;
																	BgL_fz00_16716 = BgL_fz00_26603;
																	goto BgL_recz00_16715;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16710, ((long) 0),
																		BgL_savedzd2bpzd2_16714);
																	BgL_____rz00_16713 = BgL_rz00_16717;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16712);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16711, BgL_sz00_16701);
											return BgL_____rz00_16713;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5678 */
	obj_t BGl_z62run5678z62zz__evaluate_compz00(obj_t BgL_envz00_14410,
		obj_t BgL_sz00_14414)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14411;
				BgL_ev_absz00_bglt BgL_i1246z00_14412;
				obj_t BgL_bodyz00_14413;

				BgL_iboxesz00_14411 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 0))));
				BgL_i1246z00_14412 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 1))));
				BgL_bodyz00_14413 = PROCEDURE_REF(BgL_envz00_14410, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16719;

					BgL_bpz00_16719 = VECTOR_REF(((obj_t) BgL_sz00_14414), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14414,
						BgL_iboxesz00_14411, BgL_bpz00_16719);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16720;
						obj_t BgL_wherez00_16721;
						obj_t BgL_locz00_16722;

						BgL_z12denvz12_16720 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16721 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14412))->
							BgL_wherez00);
						BgL_locz00_16722 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14412))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16720, BgL_wherez00_16721,
								BgL_locz00_16722);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16723;

								BgL_za2za2resza2za2z00_16723 =
									PROCEDURE_ENTRY(BgL_bodyz00_14413) (BgL_bodyz00_14413,
									BgL_sz00_14414, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16720);
								return BgL_za2za2resza2za2z00_16723;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3872> */
	obj_t BGl_z62zc3anonymousza33872ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14415, obj_t BgL_sz00_14421)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14416;
				long BgL_siza7eza7_14417;
				BgL_ev_absz00_bglt BgL_i1246z00_14418;
				obj_t BgL_bodyz00_14419;
				long BgL_siza7ezd2framez75_14420;

				BgL_ifreesz00_14416 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14415, (int) (((long) 0))));
				BgL_siza7eza7_14417 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14415, (int) (((long) 1))));
				BgL_i1246z00_14418 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14415, (int) (((long) 2))));
				BgL_bodyz00_14419 = PROCEDURE_REF(BgL_envz00_14415, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14420 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14415, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16724;

					BgL_bpz00_16724 = VECTOR_REF(((obj_t) BgL_sz00_14421), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16725;

						BgL_valza2za2_16725 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14421,
							BgL_bpz00_16724, BgL_ifreesz00_14416);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16726;

							BgL_runz00_16726 =
								MAKE_FX_PROCEDURE(BGl_z62run5680z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16726,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14417));
							PROCEDURE_SET(BgL_runz00_16726,
								(int) (((long) 1)), BgL_valza2za2_16725);
							PROCEDURE_SET(BgL_runz00_16726,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14418));
							PROCEDURE_SET(BgL_runz00_16726,
								(int) (((long) 3)), BgL_bodyz00_14419);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16727;

								BgL_mainz00_16727 =
									MAKE_VA_PROCEDURE(BGl_z62main5679z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16727,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14417));
								PROCEDURE_SET(BgL_mainz00_16727,
									(int) (((long) 1)), BgL_valza2za2_16725);
								PROCEDURE_SET(BgL_mainz00_16727,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14418));
								PROCEDURE_SET(BgL_mainz00_16727,
									(int) (((long) 3)), BgL_bodyz00_14419);
								PROCEDURE_SET(BgL_mainz00_16727,
									(int) (((long) 4)), BgL_runz00_16726);
								PROCEDURE_SET(BgL_mainz00_16727,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14420));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16728;

									BgL_objz00_16728 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16726, BgL_objz00_16728);
									BgL_objz00_16728;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3873z00_16729;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3874z00_16730;

										BgL_arg3874z00_16730 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14418))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16731;

											BgL_newz00_16731 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26679;

												BgL_tmpz00_26679 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16731, BgL_tmpz00_26679,
													BgL_arg3874z00_16730);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26684;
												int BgL_tmpz00_26682;

												BgL_auxz00_26684 = BINT(BgL_siza7ezd2framez75_14420);
												BgL_tmpz00_26682 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16731, BgL_tmpz00_26682,
													BgL_auxz00_26684);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26687;

												BgL_tmpz00_26687 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16731, BgL_tmpz00_26687,
													BgL_runz00_16726);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26692;
												int BgL_tmpz00_26690;

												BgL_auxz00_26692 = BINT(((long) -5));
												BgL_tmpz00_26690 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16731, BgL_tmpz00_26690,
													BgL_auxz00_26692);
											}
											BgL_arg3873z00_16729 = BgL_newz00_16731;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16727, BgL_arg3873z00_16729);
									BgL_arg3873z00_16729;
								}
								return BgL_mainz00_16727;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5679 */
	obj_t BGl_z62main5679z62zz__evaluate_compz00(obj_t BgL_envz00_14422,
		obj_t BgL_az00_14429, obj_t BgL_bz00_14430, obj_t BgL_cz00_14431,
		obj_t BgL_dz00_14432, obj_t BgL_lastz00_14433)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14427;
				long BgL_siza7ezd2framez75_14428;

				BgL_runz00_14427 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14422, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14428 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14422, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16732;

					BgL_sz00_16732 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16733;

						BgL_bpz00_16733 = VECTOR_REF(((obj_t) BgL_sz00_16732), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16733) + BgL_siza7ezd2framez75_14428) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16732))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3877z00_16734;

									BgL_arg3877z00_16734 =
										((long) CINT(BgL_bpz00_16733) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16732), BgL_arg3877z00_16734,
										BgL_az00_14429);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3878z00_16735;

									BgL_arg3878z00_16735 =
										((long) CINT(BgL_bpz00_16733) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16732), BgL_arg3878z00_16735,
										BgL_bz00_14430);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3879z00_16736;

									BgL_arg3879z00_16736 =
										((long) CINT(BgL_bpz00_16733) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16732), BgL_arg3879z00_16736,
										BgL_cz00_14431);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3880z00_16737;

									BgL_arg3880z00_16737 =
										((long) CINT(BgL_bpz00_16733) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16732), BgL_arg3880z00_16737,
										BgL_dz00_14432);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3881z00_16738;

									BgL_arg3881z00_16738 =
										((long) CINT(BgL_bpz00_16733) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16732), BgL_arg3881z00_16738,
										BgL_lastz00_14433);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16739;

									BgL_ez00_16739 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16739,
										BgL_bpz00_16733);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16740;

										BgL_accz00_16740 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14427, BgL_sz00_16732, BgL_bpz00_16733);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16739);
										VECTOR_SET(
											((obj_t) BgL_sz00_16732), ((long) 0), BgL_bpz00_16733);
										return BgL_accz00_16740;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16741;

								BgL_nsz00_16741 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16741, ((long) 1), BgL_sz00_16732);
								VECTOR_SET(BgL_nsz00_16741, ((long) 2), BgL_az00_14429);
								VECTOR_SET(BgL_nsz00_16741, ((long) 3), BgL_bz00_14430);
								VECTOR_SET(BgL_nsz00_16741, ((long) 4), BgL_cz00_14431);
								VECTOR_SET(BgL_nsz00_16741, ((long) 5), BgL_dz00_14432);
								VECTOR_SET(BgL_nsz00_16741, ((long) 6), BgL_lastz00_14433);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16742;

									BgL_z12denvz12_16742 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16742, BgL_nsz00_16741);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16743;

										BgL_ez00_16743 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16743,
											BgL_sz00_16732);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16744;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16745;

												BgL_savedzd2bpzd2_16745 =
													VECTOR_REF(BgL_nsz00_16741, ((long) 0));
												VECTOR_SET(BgL_nsz00_16741, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16747;

													BgL_fz00_16747 = BgL_runz00_14427;
												BgL_recz00_16746:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16748;

														BgL_rz00_16748 =
															PROCEDURE_ENTRY(BgL_fz00_16747) (BgL_fz00_16747,
															BgL_nsz00_16741, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_26755;

															if (PROCEDUREP(BgL_rz00_16748))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16749;

																	BgL_arg1696z00_16749 =
																		PROCEDURE_ATTR(BgL_rz00_16748);
																	if (STRUCTP(BgL_arg1696z00_16749))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26755 =
																				(STRUCT_KEY(BgL_arg1696z00_16749) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26755 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_26755 = ((bool_t) 0);
																}
															if (BgL_testz00_26755)
																{
																	obj_t BgL_fz00_26763;

																	BgL_fz00_26763 = BgL_rz00_16748;
																	BgL_fz00_16747 = BgL_fz00_26763;
																	goto BgL_recz00_16746;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16741, ((long) 0),
																		BgL_savedzd2bpzd2_16745);
																	BgL_____rz00_16744 = BgL_rz00_16748;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16743);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16742, BgL_sz00_16732);
											return BgL_____rz00_16744;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5680 */
	obj_t BGl_z62run5680z62zz__evaluate_compz00(obj_t BgL_envz00_14434,
		obj_t BgL_sz00_14439)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14435;
				obj_t BgL_valza2za2_14436;
				BgL_ev_absz00_bglt BgL_i1246z00_14437;
				obj_t BgL_bodyz00_14438;

				BgL_siza7eza7_14435 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14434, (int) (((long) 0))));
				BgL_valza2za2_14436 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14434, (int) (((long) 1))));
				BgL_i1246z00_14437 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14434, (int) (((long) 2))));
				BgL_bodyz00_14438 = PROCEDURE_REF(BgL_envz00_14434, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16750;

					BgL_bpz00_16750 = VECTOR_REF(((obj_t) BgL_sz00_14439), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14439,
						BgL_valza2za2_14436,
						((long) CINT(BgL_bpz00_16750) + BgL_siza7eza7_14435));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16751;
						obj_t BgL_wherez00_16752;
						obj_t BgL_locz00_16753;

						BgL_z12denvz12_16751 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16752 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14437))->
							BgL_wherez00);
						BgL_locz00_16753 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14437))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16751, BgL_wherez00_16752,
								BgL_locz00_16753);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16754;

								BgL_za2za2resza2za2z00_16754 =
									PROCEDURE_ENTRY(BgL_bodyz00_14438) (BgL_bodyz00_14438,
									BgL_sz00_14439, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16751);
								return BgL_za2za2resza2za2z00_16754;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3884> */
	obj_t BGl_z62zc3anonymousza33884ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14440, obj_t BgL_sz00_14447)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14441;
				obj_t BgL_iboxesz00_14442;
				long BgL_siza7eza7_14443;
				BgL_ev_absz00_bglt BgL_i1246z00_14444;
				obj_t BgL_bodyz00_14445;
				long BgL_siza7ezd2framez75_14446;

				BgL_ifreesz00_14441 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 0))));
				BgL_iboxesz00_14442 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 1))));
				BgL_siza7eza7_14443 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 2))));
				BgL_i1246z00_14444 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 3))));
				BgL_bodyz00_14445 = PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14446 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14440, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16755;

					BgL_bpz00_16755 = VECTOR_REF(((obj_t) BgL_sz00_14447), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16756;

						BgL_valza2za2_16756 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14447,
							BgL_bpz00_16755, BgL_ifreesz00_14441);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16757;

							BgL_runz00_16757 =
								MAKE_FX_PROCEDURE(BGl_z62run5682z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16757,
								(int) (((long) 0)), BgL_iboxesz00_14442);
							PROCEDURE_SET(BgL_runz00_16757,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14443));
							PROCEDURE_SET(BgL_runz00_16757,
								(int) (((long) 2)), BgL_valza2za2_16756);
							PROCEDURE_SET(BgL_runz00_16757,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14444));
							PROCEDURE_SET(BgL_runz00_16757,
								(int) (((long) 4)), BgL_bodyz00_14445);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16758;

								BgL_mainz00_16758 =
									MAKE_VA_PROCEDURE(BGl_z62main5681z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 0)), BgL_iboxesz00_14442);
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14443));
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 2)), BgL_valza2za2_16756);
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14444));
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 4)), BgL_bodyz00_14445);
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 5)), BgL_runz00_16757);
								PROCEDURE_SET(BgL_mainz00_16758,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14446));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16759;

									BgL_objz00_16759 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16757, BgL_objz00_16759);
									BgL_objz00_16759;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3885z00_16760;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3886z00_16761;

										BgL_arg3886z00_16761 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14444))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16762;

											BgL_newz00_16762 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26851;

												BgL_tmpz00_26851 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16762, BgL_tmpz00_26851,
													BgL_arg3886z00_16761);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26856;
												int BgL_tmpz00_26854;

												BgL_auxz00_26856 = BINT(BgL_siza7ezd2framez75_14446);
												BgL_tmpz00_26854 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16762, BgL_tmpz00_26854,
													BgL_auxz00_26856);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_26859;

												BgL_tmpz00_26859 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16762, BgL_tmpz00_26859,
													BgL_runz00_16757);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_26864;
												int BgL_tmpz00_26862;

												BgL_auxz00_26864 = BINT(((long) -5));
												BgL_tmpz00_26862 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16762, BgL_tmpz00_26862,
													BgL_auxz00_26864);
											}
											BgL_arg3885z00_16760 = BgL_newz00_16762;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16758, BgL_arg3885z00_16760);
									BgL_arg3885z00_16760;
								}
								return BgL_mainz00_16758;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5681 */
	obj_t BGl_z62main5681z62zz__evaluate_compz00(obj_t BgL_envz00_14448,
		obj_t BgL_az00_14456, obj_t BgL_bz00_14457, obj_t BgL_cz00_14458,
		obj_t BgL_dz00_14459, obj_t BgL_lastz00_14460)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14454;
				long BgL_siza7ezd2framez75_14455;

				BgL_runz00_14454 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14448, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14455 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14448, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16763;

					BgL_sz00_16763 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16764;

						BgL_bpz00_16764 = VECTOR_REF(((obj_t) BgL_sz00_16763), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16764) + BgL_siza7ezd2framez75_14455) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16763))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3889z00_16765;

									BgL_arg3889z00_16765 =
										((long) CINT(BgL_bpz00_16764) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16763), BgL_arg3889z00_16765,
										BgL_az00_14456);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3890z00_16766;

									BgL_arg3890z00_16766 =
										((long) CINT(BgL_bpz00_16764) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16763), BgL_arg3890z00_16766,
										BgL_bz00_14457);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3891z00_16767;

									BgL_arg3891z00_16767 =
										((long) CINT(BgL_bpz00_16764) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16763), BgL_arg3891z00_16767,
										BgL_cz00_14458);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3892z00_16768;

									BgL_arg3892z00_16768 =
										((long) CINT(BgL_bpz00_16764) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16763), BgL_arg3892z00_16768,
										BgL_dz00_14459);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3893z00_16769;

									BgL_arg3893z00_16769 =
										((long) CINT(BgL_bpz00_16764) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16763), BgL_arg3893z00_16769,
										BgL_lastz00_14460);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16770;

									BgL_ez00_16770 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16770,
										BgL_bpz00_16764);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16771;

										BgL_accz00_16771 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14454, BgL_sz00_16763, BgL_bpz00_16764);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16770);
										VECTOR_SET(
											((obj_t) BgL_sz00_16763), ((long) 0), BgL_bpz00_16764);
										return BgL_accz00_16771;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16772;

								BgL_nsz00_16772 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16772, ((long) 1), BgL_sz00_16763);
								VECTOR_SET(BgL_nsz00_16772, ((long) 2), BgL_az00_14456);
								VECTOR_SET(BgL_nsz00_16772, ((long) 3), BgL_bz00_14457);
								VECTOR_SET(BgL_nsz00_16772, ((long) 4), BgL_cz00_14458);
								VECTOR_SET(BgL_nsz00_16772, ((long) 5), BgL_dz00_14459);
								VECTOR_SET(BgL_nsz00_16772, ((long) 6), BgL_lastz00_14460);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16773;

									BgL_z12denvz12_16773 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16773, BgL_nsz00_16772);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16774;

										BgL_ez00_16774 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16774,
											BgL_sz00_16763);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16775;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16776;

												BgL_savedzd2bpzd2_16776 =
													VECTOR_REF(BgL_nsz00_16772, ((long) 0));
												VECTOR_SET(BgL_nsz00_16772, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16778;

													BgL_fz00_16778 = BgL_runz00_14454;
												BgL_recz00_16777:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16779;

														BgL_rz00_16779 =
															PROCEDURE_ENTRY(BgL_fz00_16778) (BgL_fz00_16778,
															BgL_nsz00_16772, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_26927;

															if (PROCEDUREP(BgL_rz00_16779))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16780;

																	BgL_arg1696z00_16780 =
																		PROCEDURE_ATTR(BgL_rz00_16779);
																	if (STRUCTP(BgL_arg1696z00_16780))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26927 =
																				(STRUCT_KEY(BgL_arg1696z00_16780) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_26927 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_26927 = ((bool_t) 0);
																}
															if (BgL_testz00_26927)
																{
																	obj_t BgL_fz00_26935;

																	BgL_fz00_26935 = BgL_rz00_16779;
																	BgL_fz00_16778 = BgL_fz00_26935;
																	goto BgL_recz00_16777;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16772, ((long) 0),
																		BgL_savedzd2bpzd2_16776);
																	BgL_____rz00_16775 = BgL_rz00_16779;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16774);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16773, BgL_sz00_16763);
											return BgL_____rz00_16775;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5682 */
	obj_t BGl_z62run5682z62zz__evaluate_compz00(obj_t BgL_envz00_14461,
		obj_t BgL_sz00_14467)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14462;
				long BgL_siza7eza7_14463;
				obj_t BgL_valza2za2_14464;
				BgL_ev_absz00_bglt BgL_i1246z00_14465;
				obj_t BgL_bodyz00_14466;

				BgL_iboxesz00_14462 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14461, (int) (((long) 0))));
				BgL_siza7eza7_14463 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14461, (int) (((long) 1))));
				BgL_valza2za2_14464 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14461, (int) (((long) 2))));
				BgL_i1246z00_14465 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14461, (int) (((long) 3))));
				BgL_bodyz00_14466 = PROCEDURE_REF(BgL_envz00_14461, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16781;

					BgL_bpz00_16781 = VECTOR_REF(((obj_t) BgL_sz00_14467), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14467,
						BgL_iboxesz00_14462, BgL_bpz00_16781);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14467,
						BgL_valza2za2_14464,
						((long) CINT(BgL_bpz00_16781) + BgL_siza7eza7_14463));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16782;
						obj_t BgL_wherez00_16783;
						obj_t BgL_locz00_16784;

						BgL_z12denvz12_16782 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16783 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14465))->
							BgL_wherez00);
						BgL_locz00_16784 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14465))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16782, BgL_wherez00_16783,
								BgL_locz00_16784);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16785;

								BgL_za2za2resza2za2z00_16785 =
									PROCEDURE_ENTRY(BgL_bodyz00_14466) (BgL_bodyz00_14466,
									BgL_sz00_14467, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16782);
								return BgL_za2za2resza2za2z00_16785;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3796> */
	obj_t BGl_z62zc3anonymousza33796ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14468, obj_t BgL_sz00_14472)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14469;
				obj_t BgL_bodyz00_14470;
				long BgL_siza7ezd2framez75_14471;

				BgL_i1246z00_14469 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14468, (int) (((long) 0))));
				BgL_bodyz00_14470 = PROCEDURE_REF(BgL_envz00_14468, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14471 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14468, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16786;

					BgL_bpz00_16786 = VECTOR_REF(((obj_t) BgL_sz00_14472), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16787;

							BgL_runz00_16787 =
								MAKE_FX_PROCEDURE(BGl_z62run5684z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16787,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14469));
							PROCEDURE_SET(BgL_runz00_16787,
								(int) (((long) 1)), BgL_bodyz00_14470);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16788;

								BgL_mainz00_16788 =
									MAKE_FX_PROCEDURE(BGl_z62main5683z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16788,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14469));
								PROCEDURE_SET(BgL_mainz00_16788,
									(int) (((long) 1)), BgL_bodyz00_14470);
								PROCEDURE_SET(BgL_mainz00_16788,
									(int) (((long) 2)), BgL_runz00_16787);
								PROCEDURE_SET(BgL_mainz00_16788,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14471));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16789;

									BgL_objz00_16789 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16787, BgL_objz00_16789);
									BgL_objz00_16789;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3797z00_16790;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3798z00_16791;

										BgL_arg3798z00_16791 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14469))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16792;

											BgL_newz00_16792 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27003;

												BgL_tmpz00_27003 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16792, BgL_tmpz00_27003,
													BgL_arg3798z00_16791);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27008;
												int BgL_tmpz00_27006;

												BgL_auxz00_27008 = BINT(BgL_siza7ezd2framez75_14471);
												BgL_tmpz00_27006 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16792, BgL_tmpz00_27006,
													BgL_auxz00_27008);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27011;

												BgL_tmpz00_27011 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16792, BgL_tmpz00_27011,
													BgL_runz00_16787);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27016;
												int BgL_tmpz00_27014;

												BgL_auxz00_27016 = BINT(((long) 4));
												BgL_tmpz00_27014 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16792, BgL_tmpz00_27014,
													BgL_auxz00_27016);
											}
											BgL_arg3797z00_16790 = BgL_newz00_16792;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16788, BgL_arg3797z00_16790);
									BgL_arg3797z00_16790;
								}
								return BgL_mainz00_16788;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5683 */
	obj_t BGl_z62main5683z62zz__evaluate_compz00(obj_t BgL_envz00_14473,
		obj_t BgL_az00_14478, obj_t BgL_bz00_14479, obj_t BgL_cz00_14480,
		obj_t BgL_dz00_14481)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14476;
				long BgL_siza7ezd2framez75_14477;

				BgL_runz00_14476 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14473, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14477 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14473, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16793;

					BgL_sz00_16793 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16794;

						BgL_bpz00_16794 = VECTOR_REF(((obj_t) BgL_sz00_16793), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16794) + BgL_siza7ezd2framez75_14477) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16793))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3801z00_16795;

									BgL_arg3801z00_16795 =
										((long) CINT(BgL_bpz00_16794) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16793), BgL_arg3801z00_16795,
										BgL_az00_14478);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3802z00_16796;

									BgL_arg3802z00_16796 =
										((long) CINT(BgL_bpz00_16794) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16793), BgL_arg3802z00_16796,
										BgL_bz00_14479);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3803z00_16797;

									BgL_arg3803z00_16797 =
										((long) CINT(BgL_bpz00_16794) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16793), BgL_arg3803z00_16797,
										BgL_cz00_14480);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3804z00_16798;

									BgL_arg3804z00_16798 =
										((long) CINT(BgL_bpz00_16794) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16793), BgL_arg3804z00_16798,
										BgL_dz00_14481);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16799;

									BgL_ez00_16799 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16799,
										BgL_bpz00_16794);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16800;

										BgL_accz00_16800 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14476, BgL_sz00_16793, BgL_bpz00_16794);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16799);
										VECTOR_SET(
											((obj_t) BgL_sz00_16793), ((long) 0), BgL_bpz00_16794);
										return BgL_accz00_16800;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16801;

								BgL_nsz00_16801 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16801, ((long) 1), BgL_sz00_16793);
								VECTOR_SET(BgL_nsz00_16801, ((long) 2), BgL_az00_14478);
								VECTOR_SET(BgL_nsz00_16801, ((long) 3), BgL_bz00_14479);
								VECTOR_SET(BgL_nsz00_16801, ((long) 4), BgL_cz00_14480);
								VECTOR_SET(BgL_nsz00_16801, ((long) 5), BgL_dz00_14481);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16802;

									BgL_z12denvz12_16802 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16802, BgL_nsz00_16801);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16803;

										BgL_ez00_16803 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16803,
											BgL_sz00_16793);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16804;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16805;

												BgL_savedzd2bpzd2_16805 =
													VECTOR_REF(BgL_nsz00_16801, ((long) 0));
												VECTOR_SET(BgL_nsz00_16801, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16807;

													BgL_fz00_16807 = BgL_runz00_14476;
												BgL_recz00_16806:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16808;

														BgL_rz00_16808 =
															PROCEDURE_ENTRY(BgL_fz00_16807) (BgL_fz00_16807,
															BgL_nsz00_16801, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27074;

															if (PROCEDUREP(BgL_rz00_16808))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16809;

																	BgL_arg1696z00_16809 =
																		PROCEDURE_ATTR(BgL_rz00_16808);
																	if (STRUCTP(BgL_arg1696z00_16809))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27074 =
																				(STRUCT_KEY(BgL_arg1696z00_16809) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27074 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27074 = ((bool_t) 0);
																}
															if (BgL_testz00_27074)
																{
																	obj_t BgL_fz00_27082;

																	BgL_fz00_27082 = BgL_rz00_16808;
																	BgL_fz00_16807 = BgL_fz00_27082;
																	goto BgL_recz00_16806;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16801, ((long) 0),
																		BgL_savedzd2bpzd2_16805);
																	BgL_____rz00_16804 = BgL_rz00_16808;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16803);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16802, BgL_sz00_16793);
											return BgL_____rz00_16804;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5684 */
	obj_t BGl_z62run5684z62zz__evaluate_compz00(obj_t BgL_envz00_14482,
		obj_t BgL_sz00_14485)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14483;
				obj_t BgL_bodyz00_14484;

				BgL_i1246z00_14483 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14482, (int) (((long) 0))));
				BgL_bodyz00_14484 = PROCEDURE_REF(BgL_envz00_14482, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16810;

					BgL_bpz00_16810 = VECTOR_REF(((obj_t) BgL_sz00_14485), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16811;
						obj_t BgL_wherez00_16812;
						obj_t BgL_locz00_16813;

						BgL_z12denvz12_16811 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16812 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14483))->
							BgL_wherez00);
						BgL_locz00_16813 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14483))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16811, BgL_wherez00_16812,
								BgL_locz00_16813);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16814;

								BgL_za2za2resza2za2z00_16814 =
									PROCEDURE_ENTRY(BgL_bodyz00_14484) (BgL_bodyz00_14484,
									BgL_sz00_14485, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16811);
								return BgL_za2za2resza2za2z00_16814;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3806> */
	obj_t BGl_z62zc3anonymousza33806ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14486, obj_t BgL_sz00_14491)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14487;
				BgL_ev_absz00_bglt BgL_i1246z00_14488;
				obj_t BgL_bodyz00_14489;
				long BgL_siza7ezd2framez75_14490;

				BgL_iboxesz00_14487 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14486, (int) (((long) 0))));
				BgL_i1246z00_14488 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14486, (int) (((long) 1))));
				BgL_bodyz00_14489 = PROCEDURE_REF(BgL_envz00_14486, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14490 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14486, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16815;

					BgL_bpz00_16815 = VECTOR_REF(((obj_t) BgL_sz00_14491), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16816;

							BgL_runz00_16816 =
								MAKE_FX_PROCEDURE(BGl_z62run5686z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16816,
								(int) (((long) 0)), BgL_iboxesz00_14487);
							PROCEDURE_SET(BgL_runz00_16816,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14488));
							PROCEDURE_SET(BgL_runz00_16816,
								(int) (((long) 2)), BgL_bodyz00_14489);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16817;

								BgL_mainz00_16817 =
									MAKE_FX_PROCEDURE(BGl_z62main5685z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16817,
									(int) (((long) 0)), BgL_iboxesz00_14487);
								PROCEDURE_SET(BgL_mainz00_16817,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14488));
								PROCEDURE_SET(BgL_mainz00_16817,
									(int) (((long) 2)), BgL_bodyz00_14489);
								PROCEDURE_SET(BgL_mainz00_16817,
									(int) (((long) 3)), BgL_runz00_16816);
								PROCEDURE_SET(BgL_mainz00_16817,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14490));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16818;

									BgL_objz00_16818 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16816, BgL_objz00_16818);
									BgL_objz00_16818;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3807z00_16819;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3808z00_16820;

										BgL_arg3808z00_16820 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14488))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16821;

											BgL_newz00_16821 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27144;

												BgL_tmpz00_27144 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16821, BgL_tmpz00_27144,
													BgL_arg3808z00_16820);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27149;
												int BgL_tmpz00_27147;

												BgL_auxz00_27149 = BINT(BgL_siza7ezd2framez75_14490);
												BgL_tmpz00_27147 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16821, BgL_tmpz00_27147,
													BgL_auxz00_27149);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27152;

												BgL_tmpz00_27152 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16821, BgL_tmpz00_27152,
													BgL_runz00_16816);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27157;
												int BgL_tmpz00_27155;

												BgL_auxz00_27157 = BINT(((long) 4));
												BgL_tmpz00_27155 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16821, BgL_tmpz00_27155,
													BgL_auxz00_27157);
											}
											BgL_arg3807z00_16819 = BgL_newz00_16821;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16817, BgL_arg3807z00_16819);
									BgL_arg3807z00_16819;
								}
								return BgL_mainz00_16817;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5685 */
	obj_t BGl_z62main5685z62zz__evaluate_compz00(obj_t BgL_envz00_14492,
		obj_t BgL_az00_14498, obj_t BgL_bz00_14499, obj_t BgL_cz00_14500,
		obj_t BgL_dz00_14501)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14496;
				long BgL_siza7ezd2framez75_14497;

				BgL_runz00_14496 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14492, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14497 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14492, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16822;

					BgL_sz00_16822 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16823;

						BgL_bpz00_16823 = VECTOR_REF(((obj_t) BgL_sz00_16822), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16823) + BgL_siza7ezd2framez75_14497) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16822))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3811z00_16824;

									BgL_arg3811z00_16824 =
										((long) CINT(BgL_bpz00_16823) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16822), BgL_arg3811z00_16824,
										BgL_az00_14498);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3812z00_16825;

									BgL_arg3812z00_16825 =
										((long) CINT(BgL_bpz00_16823) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16822), BgL_arg3812z00_16825,
										BgL_bz00_14499);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3813z00_16826;

									BgL_arg3813z00_16826 =
										((long) CINT(BgL_bpz00_16823) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16822), BgL_arg3813z00_16826,
										BgL_cz00_14500);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3814z00_16827;

									BgL_arg3814z00_16827 =
										((long) CINT(BgL_bpz00_16823) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16822), BgL_arg3814z00_16827,
										BgL_dz00_14501);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16828;

									BgL_ez00_16828 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16828,
										BgL_bpz00_16823);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16829;

										BgL_accz00_16829 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14496, BgL_sz00_16822, BgL_bpz00_16823);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16828);
										VECTOR_SET(
											((obj_t) BgL_sz00_16822), ((long) 0), BgL_bpz00_16823);
										return BgL_accz00_16829;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16830;

								BgL_nsz00_16830 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16830, ((long) 1), BgL_sz00_16822);
								VECTOR_SET(BgL_nsz00_16830, ((long) 2), BgL_az00_14498);
								VECTOR_SET(BgL_nsz00_16830, ((long) 3), BgL_bz00_14499);
								VECTOR_SET(BgL_nsz00_16830, ((long) 4), BgL_cz00_14500);
								VECTOR_SET(BgL_nsz00_16830, ((long) 5), BgL_dz00_14501);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16831;

									BgL_z12denvz12_16831 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16831, BgL_nsz00_16830);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16832;

										BgL_ez00_16832 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16832,
											BgL_sz00_16822);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16833;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16834;

												BgL_savedzd2bpzd2_16834 =
													VECTOR_REF(BgL_nsz00_16830, ((long) 0));
												VECTOR_SET(BgL_nsz00_16830, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16836;

													BgL_fz00_16836 = BgL_runz00_14496;
												BgL_recz00_16835:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16837;

														BgL_rz00_16837 =
															PROCEDURE_ENTRY(BgL_fz00_16836) (BgL_fz00_16836,
															BgL_nsz00_16830, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27215;

															if (PROCEDUREP(BgL_rz00_16837))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16838;

																	BgL_arg1696z00_16838 =
																		PROCEDURE_ATTR(BgL_rz00_16837);
																	if (STRUCTP(BgL_arg1696z00_16838))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27215 =
																				(STRUCT_KEY(BgL_arg1696z00_16838) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27215 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27215 = ((bool_t) 0);
																}
															if (BgL_testz00_27215)
																{
																	obj_t BgL_fz00_27223;

																	BgL_fz00_27223 = BgL_rz00_16837;
																	BgL_fz00_16836 = BgL_fz00_27223;
																	goto BgL_recz00_16835;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16830, ((long) 0),
																		BgL_savedzd2bpzd2_16834);
																	BgL_____rz00_16833 = BgL_rz00_16837;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16832);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16831, BgL_sz00_16822);
											return BgL_____rz00_16833;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5686 */
	obj_t BGl_z62run5686z62zz__evaluate_compz00(obj_t BgL_envz00_14502,
		obj_t BgL_sz00_14506)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14503;
				BgL_ev_absz00_bglt BgL_i1246z00_14504;
				obj_t BgL_bodyz00_14505;

				BgL_iboxesz00_14503 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14502, (int) (((long) 0))));
				BgL_i1246z00_14504 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14502, (int) (((long) 1))));
				BgL_bodyz00_14505 = PROCEDURE_REF(BgL_envz00_14502, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16839;

					BgL_bpz00_16839 = VECTOR_REF(((obj_t) BgL_sz00_14506), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14506,
						BgL_iboxesz00_14503, BgL_bpz00_16839);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16840;
						obj_t BgL_wherez00_16841;
						obj_t BgL_locz00_16842;

						BgL_z12denvz12_16840 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16841 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14504))->
							BgL_wherez00);
						BgL_locz00_16842 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14504))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16840, BgL_wherez00_16841,
								BgL_locz00_16842);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16843;

								BgL_za2za2resza2za2z00_16843 =
									PROCEDURE_ENTRY(BgL_bodyz00_14505) (BgL_bodyz00_14505,
									BgL_sz00_14506, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16840);
								return BgL_za2za2resza2za2z00_16843;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3819> */
	obj_t BGl_z62zc3anonymousza33819ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14507, obj_t BgL_sz00_14513)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14508;
				long BgL_siza7eza7_14509;
				BgL_ev_absz00_bglt BgL_i1246z00_14510;
				obj_t BgL_bodyz00_14511;
				long BgL_siza7ezd2framez75_14512;

				BgL_ifreesz00_14508 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 0))));
				BgL_siza7eza7_14509 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 1))));
				BgL_i1246z00_14510 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 2))));
				BgL_bodyz00_14511 = PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14512 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14507, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16844;

					BgL_bpz00_16844 = VECTOR_REF(((obj_t) BgL_sz00_14513), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16845;

						BgL_valza2za2_16845 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14513,
							BgL_bpz00_16844, BgL_ifreesz00_14508);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16846;

							BgL_runz00_16846 =
								MAKE_FX_PROCEDURE(BGl_z62run5688z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16846,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14509));
							PROCEDURE_SET(BgL_runz00_16846,
								(int) (((long) 1)), BgL_valza2za2_16845);
							PROCEDURE_SET(BgL_runz00_16846,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14510));
							PROCEDURE_SET(BgL_runz00_16846,
								(int) (((long) 3)), BgL_bodyz00_14511);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16847;

								BgL_mainz00_16847 =
									MAKE_FX_PROCEDURE(BGl_z62main5687z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16847,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14509));
								PROCEDURE_SET(BgL_mainz00_16847,
									(int) (((long) 1)), BgL_valza2za2_16845);
								PROCEDURE_SET(BgL_mainz00_16847,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14510));
								PROCEDURE_SET(BgL_mainz00_16847,
									(int) (((long) 3)), BgL_bodyz00_14511);
								PROCEDURE_SET(BgL_mainz00_16847,
									(int) (((long) 4)), BgL_runz00_16846);
								PROCEDURE_SET(BgL_mainz00_16847,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14512));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16848;

									BgL_objz00_16848 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16846, BgL_objz00_16848);
									BgL_objz00_16848;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3820z00_16849;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3821z00_16850;

										BgL_arg3821z00_16850 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14510))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16851;

											BgL_newz00_16851 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27299;

												BgL_tmpz00_27299 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16851, BgL_tmpz00_27299,
													BgL_arg3821z00_16850);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27304;
												int BgL_tmpz00_27302;

												BgL_auxz00_27304 = BINT(BgL_siza7ezd2framez75_14512);
												BgL_tmpz00_27302 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16851, BgL_tmpz00_27302,
													BgL_auxz00_27304);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27307;

												BgL_tmpz00_27307 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16851, BgL_tmpz00_27307,
													BgL_runz00_16846);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27312;
												int BgL_tmpz00_27310;

												BgL_auxz00_27312 = BINT(((long) 4));
												BgL_tmpz00_27310 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16851, BgL_tmpz00_27310,
													BgL_auxz00_27312);
											}
											BgL_arg3820z00_16849 = BgL_newz00_16851;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16847, BgL_arg3820z00_16849);
									BgL_arg3820z00_16849;
								}
								return BgL_mainz00_16847;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5687 */
	obj_t BGl_z62main5687z62zz__evaluate_compz00(obj_t BgL_envz00_14514,
		obj_t BgL_az00_14521, obj_t BgL_bz00_14522, obj_t BgL_cz00_14523,
		obj_t BgL_dz00_14524)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14519;
				long BgL_siza7ezd2framez75_14520;

				BgL_runz00_14519 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14514, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14520 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14514, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16852;

					BgL_sz00_16852 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16853;

						BgL_bpz00_16853 = VECTOR_REF(((obj_t) BgL_sz00_16852), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16853) + BgL_siza7ezd2framez75_14520) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16852))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3824z00_16854;

									BgL_arg3824z00_16854 =
										((long) CINT(BgL_bpz00_16853) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16852), BgL_arg3824z00_16854,
										BgL_az00_14521);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3825z00_16855;

									BgL_arg3825z00_16855 =
										((long) CINT(BgL_bpz00_16853) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16852), BgL_arg3825z00_16855,
										BgL_bz00_14522);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3826z00_16856;

									BgL_arg3826z00_16856 =
										((long) CINT(BgL_bpz00_16853) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16852), BgL_arg3826z00_16856,
										BgL_cz00_14523);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3827z00_16857;

									BgL_arg3827z00_16857 =
										((long) CINT(BgL_bpz00_16853) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16852), BgL_arg3827z00_16857,
										BgL_dz00_14524);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16858;

									BgL_ez00_16858 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16858,
										BgL_bpz00_16853);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16859;

										BgL_accz00_16859 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14519, BgL_sz00_16852, BgL_bpz00_16853);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16858);
										VECTOR_SET(
											((obj_t) BgL_sz00_16852), ((long) 0), BgL_bpz00_16853);
										return BgL_accz00_16859;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16860;

								BgL_nsz00_16860 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16860, ((long) 1), BgL_sz00_16852);
								VECTOR_SET(BgL_nsz00_16860, ((long) 2), BgL_az00_14521);
								VECTOR_SET(BgL_nsz00_16860, ((long) 3), BgL_bz00_14522);
								VECTOR_SET(BgL_nsz00_16860, ((long) 4), BgL_cz00_14523);
								VECTOR_SET(BgL_nsz00_16860, ((long) 5), BgL_dz00_14524);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16861;

									BgL_z12denvz12_16861 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16861, BgL_nsz00_16860);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16862;

										BgL_ez00_16862 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16862,
											BgL_sz00_16852);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16863;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16864;

												BgL_savedzd2bpzd2_16864 =
													VECTOR_REF(BgL_nsz00_16860, ((long) 0));
												VECTOR_SET(BgL_nsz00_16860, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16866;

													BgL_fz00_16866 = BgL_runz00_14519;
												BgL_recz00_16865:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16867;

														BgL_rz00_16867 =
															PROCEDURE_ENTRY(BgL_fz00_16866) (BgL_fz00_16866,
															BgL_nsz00_16860, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27370;

															if (PROCEDUREP(BgL_rz00_16867))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16868;

																	BgL_arg1696z00_16868 =
																		PROCEDURE_ATTR(BgL_rz00_16867);
																	if (STRUCTP(BgL_arg1696z00_16868))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27370 =
																				(STRUCT_KEY(BgL_arg1696z00_16868) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27370 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27370 = ((bool_t) 0);
																}
															if (BgL_testz00_27370)
																{
																	obj_t BgL_fz00_27378;

																	BgL_fz00_27378 = BgL_rz00_16867;
																	BgL_fz00_16866 = BgL_fz00_27378;
																	goto BgL_recz00_16865;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16860, ((long) 0),
																		BgL_savedzd2bpzd2_16864);
																	BgL_____rz00_16863 = BgL_rz00_16867;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16862);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16861, BgL_sz00_16852);
											return BgL_____rz00_16863;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5688 */
	obj_t BGl_z62run5688z62zz__evaluate_compz00(obj_t BgL_envz00_14525,
		obj_t BgL_sz00_14530)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14526;
				obj_t BgL_valza2za2_14527;
				BgL_ev_absz00_bglt BgL_i1246z00_14528;
				obj_t BgL_bodyz00_14529;

				BgL_siza7eza7_14526 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14525, (int) (((long) 0))));
				BgL_valza2za2_14527 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14525, (int) (((long) 1))));
				BgL_i1246z00_14528 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14525, (int) (((long) 2))));
				BgL_bodyz00_14529 = PROCEDURE_REF(BgL_envz00_14525, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16869;

					BgL_bpz00_16869 = VECTOR_REF(((obj_t) BgL_sz00_14530), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14530,
						BgL_valza2za2_14527,
						((long) CINT(BgL_bpz00_16869) + BgL_siza7eza7_14526));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16870;
						obj_t BgL_wherez00_16871;
						obj_t BgL_locz00_16872;

						BgL_z12denvz12_16870 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16871 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14528))->
							BgL_wherez00);
						BgL_locz00_16872 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14528))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16870, BgL_wherez00_16871,
								BgL_locz00_16872);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16873;

								BgL_za2za2resza2za2z00_16873 =
									PROCEDURE_ENTRY(BgL_bodyz00_14529) (BgL_bodyz00_14529,
									BgL_sz00_14530, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16870);
								return BgL_za2za2resza2za2z00_16873;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3830> */
	obj_t BGl_z62zc3anonymousza33830ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14531, obj_t BgL_sz00_14538)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14532;
				obj_t BgL_iboxesz00_14533;
				long BgL_siza7eza7_14534;
				BgL_ev_absz00_bglt BgL_i1246z00_14535;
				obj_t BgL_bodyz00_14536;
				long BgL_siza7ezd2framez75_14537;

				BgL_ifreesz00_14532 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 0))));
				BgL_iboxesz00_14533 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 1))));
				BgL_siza7eza7_14534 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 2))));
				BgL_i1246z00_14535 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 3))));
				BgL_bodyz00_14536 = PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14537 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14531, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16874;

					BgL_bpz00_16874 = VECTOR_REF(((obj_t) BgL_sz00_14538), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16875;

						BgL_valza2za2_16875 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14538,
							BgL_bpz00_16874, BgL_ifreesz00_14532);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16876;

							BgL_runz00_16876 =
								MAKE_FX_PROCEDURE(BGl_z62run5690z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16876,
								(int) (((long) 0)), BgL_iboxesz00_14533);
							PROCEDURE_SET(BgL_runz00_16876,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14534));
							PROCEDURE_SET(BgL_runz00_16876,
								(int) (((long) 2)), BgL_valza2za2_16875);
							PROCEDURE_SET(BgL_runz00_16876,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14535));
							PROCEDURE_SET(BgL_runz00_16876,
								(int) (((long) 4)), BgL_bodyz00_14536);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16877;

								BgL_mainz00_16877 =
									MAKE_FX_PROCEDURE(BGl_z62main5689z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 0)), BgL_iboxesz00_14533);
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14534));
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 2)), BgL_valza2za2_16875);
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14535));
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 4)), BgL_bodyz00_14536);
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 5)), BgL_runz00_16876);
								PROCEDURE_SET(BgL_mainz00_16877,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14537));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16878;

									BgL_objz00_16878 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16876, BgL_objz00_16878);
									BgL_objz00_16878;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3831z00_16879;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3832z00_16880;

										BgL_arg3832z00_16880 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14535))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16881;

											BgL_newz00_16881 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27466;

												BgL_tmpz00_27466 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16881, BgL_tmpz00_27466,
													BgL_arg3832z00_16880);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27471;
												int BgL_tmpz00_27469;

												BgL_auxz00_27471 = BINT(BgL_siza7ezd2framez75_14537);
												BgL_tmpz00_27469 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16881, BgL_tmpz00_27469,
													BgL_auxz00_27471);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27474;

												BgL_tmpz00_27474 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16881, BgL_tmpz00_27474,
													BgL_runz00_16876);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27479;
												int BgL_tmpz00_27477;

												BgL_auxz00_27479 = BINT(((long) 4));
												BgL_tmpz00_27477 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16881, BgL_tmpz00_27477,
													BgL_auxz00_27479);
											}
											BgL_arg3831z00_16879 = BgL_newz00_16881;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16877, BgL_arg3831z00_16879);
									BgL_arg3831z00_16879;
								}
								return BgL_mainz00_16877;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5689 */
	obj_t BGl_z62main5689z62zz__evaluate_compz00(obj_t BgL_envz00_14539,
		obj_t BgL_az00_14547, obj_t BgL_bz00_14548, obj_t BgL_cz00_14549,
		obj_t BgL_dz00_14550)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14545;
				long BgL_siza7ezd2framez75_14546;

				BgL_runz00_14545 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14539, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14546 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14539, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16882;

					BgL_sz00_16882 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16883;

						BgL_bpz00_16883 = VECTOR_REF(((obj_t) BgL_sz00_16882), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16883) + BgL_siza7ezd2framez75_14546) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16882))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3835z00_16884;

									BgL_arg3835z00_16884 =
										((long) CINT(BgL_bpz00_16883) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16882), BgL_arg3835z00_16884,
										BgL_az00_14547);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3836z00_16885;

									BgL_arg3836z00_16885 =
										((long) CINT(BgL_bpz00_16883) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16882), BgL_arg3836z00_16885,
										BgL_bz00_14548);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3837z00_16886;

									BgL_arg3837z00_16886 =
										((long) CINT(BgL_bpz00_16883) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16882), BgL_arg3837z00_16886,
										BgL_cz00_14549);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3838z00_16887;

									BgL_arg3838z00_16887 =
										((long) CINT(BgL_bpz00_16883) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16882), BgL_arg3838z00_16887,
										BgL_dz00_14550);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16888;

									BgL_ez00_16888 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16888,
										BgL_bpz00_16883);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16889;

										BgL_accz00_16889 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14545, BgL_sz00_16882, BgL_bpz00_16883);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16888);
										VECTOR_SET(
											((obj_t) BgL_sz00_16882), ((long) 0), BgL_bpz00_16883);
										return BgL_accz00_16889;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16890;

								BgL_nsz00_16890 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16890, ((long) 1), BgL_sz00_16882);
								VECTOR_SET(BgL_nsz00_16890, ((long) 2), BgL_az00_14547);
								VECTOR_SET(BgL_nsz00_16890, ((long) 3), BgL_bz00_14548);
								VECTOR_SET(BgL_nsz00_16890, ((long) 4), BgL_cz00_14549);
								VECTOR_SET(BgL_nsz00_16890, ((long) 5), BgL_dz00_14550);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16891;

									BgL_z12denvz12_16891 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16891, BgL_nsz00_16890);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16892;

										BgL_ez00_16892 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16892,
											BgL_sz00_16882);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16893;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16894;

												BgL_savedzd2bpzd2_16894 =
													VECTOR_REF(BgL_nsz00_16890, ((long) 0));
												VECTOR_SET(BgL_nsz00_16890, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16896;

													BgL_fz00_16896 = BgL_runz00_14545;
												BgL_recz00_16895:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16897;

														BgL_rz00_16897 =
															PROCEDURE_ENTRY(BgL_fz00_16896) (BgL_fz00_16896,
															BgL_nsz00_16890, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27537;

															if (PROCEDUREP(BgL_rz00_16897))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16898;

																	BgL_arg1696z00_16898 =
																		PROCEDURE_ATTR(BgL_rz00_16897);
																	if (STRUCTP(BgL_arg1696z00_16898))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27537 =
																				(STRUCT_KEY(BgL_arg1696z00_16898) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27537 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27537 = ((bool_t) 0);
																}
															if (BgL_testz00_27537)
																{
																	obj_t BgL_fz00_27545;

																	BgL_fz00_27545 = BgL_rz00_16897;
																	BgL_fz00_16896 = BgL_fz00_27545;
																	goto BgL_recz00_16895;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16890, ((long) 0),
																		BgL_savedzd2bpzd2_16894);
																	BgL_____rz00_16893 = BgL_rz00_16897;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16892);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16891, BgL_sz00_16882);
											return BgL_____rz00_16893;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5690 */
	obj_t BGl_z62run5690z62zz__evaluate_compz00(obj_t BgL_envz00_14551,
		obj_t BgL_sz00_14557)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14552;
				long BgL_siza7eza7_14553;
				obj_t BgL_valza2za2_14554;
				BgL_ev_absz00_bglt BgL_i1246z00_14555;
				obj_t BgL_bodyz00_14556;

				BgL_iboxesz00_14552 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14551, (int) (((long) 0))));
				BgL_siza7eza7_14553 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14551, (int) (((long) 1))));
				BgL_valza2za2_14554 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14551, (int) (((long) 2))));
				BgL_i1246z00_14555 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14551, (int) (((long) 3))));
				BgL_bodyz00_14556 = PROCEDURE_REF(BgL_envz00_14551, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16899;

					BgL_bpz00_16899 = VECTOR_REF(((obj_t) BgL_sz00_14557), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14557,
						BgL_iboxesz00_14552, BgL_bpz00_16899);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14557,
						BgL_valza2za2_14554,
						((long) CINT(BgL_bpz00_16899) + BgL_siza7eza7_14553));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16900;
						obj_t BgL_wherez00_16901;
						obj_t BgL_locz00_16902;

						BgL_z12denvz12_16900 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16901 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14555))->
							BgL_wherez00);
						BgL_locz00_16902 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14555))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16900, BgL_wherez00_16901,
								BgL_locz00_16902);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16903;

								BgL_za2za2resza2za2z00_16903 =
									PROCEDURE_ENTRY(BgL_bodyz00_14556) (BgL_bodyz00_14556,
									BgL_sz00_14557, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16900);
								return BgL_za2za2resza2za2z00_16903;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3744> */
	obj_t BGl_z62zc3anonymousza33744ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14558, obj_t BgL_sz00_14562)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14559;
				obj_t BgL_bodyz00_14560;
				long BgL_siza7ezd2framez75_14561;

				BgL_i1246z00_14559 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14558, (int) (((long) 0))));
				BgL_bodyz00_14560 = PROCEDURE_REF(BgL_envz00_14558, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14561 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14558, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16904;

					BgL_bpz00_16904 = VECTOR_REF(((obj_t) BgL_sz00_14562), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16905;

							BgL_runz00_16905 =
								MAKE_FX_PROCEDURE(BGl_z62run5692z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16905,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14559));
							PROCEDURE_SET(BgL_runz00_16905,
								(int) (((long) 1)), BgL_bodyz00_14560);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16906;

								BgL_mainz00_16906 =
									MAKE_VA_PROCEDURE(BGl_z62main5691z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16906,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14559));
								PROCEDURE_SET(BgL_mainz00_16906,
									(int) (((long) 1)), BgL_bodyz00_14560);
								PROCEDURE_SET(BgL_mainz00_16906,
									(int) (((long) 2)), BgL_runz00_16905);
								PROCEDURE_SET(BgL_mainz00_16906,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14561));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16907;

									BgL_objz00_16907 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16905, BgL_objz00_16907);
									BgL_objz00_16907;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3745z00_16908;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3746z00_16909;

										BgL_arg3746z00_16909 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14559))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16910;

											BgL_newz00_16910 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27613;

												BgL_tmpz00_27613 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16910, BgL_tmpz00_27613,
													BgL_arg3746z00_16909);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27618;
												int BgL_tmpz00_27616;

												BgL_auxz00_27618 = BINT(BgL_siza7ezd2framez75_14561);
												BgL_tmpz00_27616 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16910, BgL_tmpz00_27616,
													BgL_auxz00_27618);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27621;

												BgL_tmpz00_27621 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16910, BgL_tmpz00_27621,
													BgL_runz00_16905);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27626;
												int BgL_tmpz00_27624;

												BgL_auxz00_27626 = BINT(((long) -4));
												BgL_tmpz00_27624 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16910, BgL_tmpz00_27624,
													BgL_auxz00_27626);
											}
											BgL_arg3745z00_16908 = BgL_newz00_16910;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16906, BgL_arg3745z00_16908);
									BgL_arg3745z00_16908;
								}
								return BgL_mainz00_16906;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5691 */
	obj_t BGl_z62main5691z62zz__evaluate_compz00(obj_t BgL_envz00_14563,
		obj_t BgL_bz00_14568, obj_t BgL_cz00_14569, obj_t BgL_dz00_14570,
		obj_t BgL_lastz00_14571)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14566;
				long BgL_siza7ezd2framez75_14567;

				BgL_runz00_14566 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14563, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14567 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14563, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16911;

					BgL_sz00_16911 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16912;

						BgL_bpz00_16912 = VECTOR_REF(((obj_t) BgL_sz00_16911), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16912) + BgL_siza7ezd2framez75_14567) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16911))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3749z00_16913;

									BgL_arg3749z00_16913 =
										((long) CINT(BgL_bpz00_16912) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16911), BgL_arg3749z00_16913,
										BgL_bz00_14568);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3750z00_16914;

									BgL_arg3750z00_16914 =
										((long) CINT(BgL_bpz00_16912) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16911), BgL_arg3750z00_16914,
										BgL_cz00_14569);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3751z00_16915;

									BgL_arg3751z00_16915 =
										((long) CINT(BgL_bpz00_16912) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16911), BgL_arg3751z00_16915,
										BgL_dz00_14570);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3752z00_16916;

									BgL_arg3752z00_16916 =
										((long) CINT(BgL_bpz00_16912) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16911), BgL_arg3752z00_16916,
										BgL_lastz00_14571);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16917;

									BgL_ez00_16917 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16917,
										BgL_bpz00_16912);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16918;

										BgL_accz00_16918 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14566, BgL_sz00_16911, BgL_bpz00_16912);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16917);
										VECTOR_SET(
											((obj_t) BgL_sz00_16911), ((long) 0), BgL_bpz00_16912);
										return BgL_accz00_16918;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16919;

								BgL_nsz00_16919 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16919, ((long) 1), BgL_sz00_16911);
								VECTOR_SET(BgL_nsz00_16919, ((long) 2), BgL_bz00_14568);
								VECTOR_SET(BgL_nsz00_16919, ((long) 3), BgL_cz00_14569);
								VECTOR_SET(BgL_nsz00_16919, ((long) 4), BgL_dz00_14570);
								VECTOR_SET(BgL_nsz00_16919, ((long) 5), BgL_lastz00_14571);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16920;

									BgL_z12denvz12_16920 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16920, BgL_nsz00_16919);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16921;

										BgL_ez00_16921 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16921,
											BgL_sz00_16911);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16922;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16923;

												BgL_savedzd2bpzd2_16923 =
													VECTOR_REF(BgL_nsz00_16919, ((long) 0));
												VECTOR_SET(BgL_nsz00_16919, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16925;

													BgL_fz00_16925 = BgL_runz00_14566;
												BgL_recz00_16924:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16926;

														BgL_rz00_16926 =
															PROCEDURE_ENTRY(BgL_fz00_16925) (BgL_fz00_16925,
															BgL_nsz00_16919, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27684;

															if (PROCEDUREP(BgL_rz00_16926))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16927;

																	BgL_arg1696z00_16927 =
																		PROCEDURE_ATTR(BgL_rz00_16926);
																	if (STRUCTP(BgL_arg1696z00_16927))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27684 =
																				(STRUCT_KEY(BgL_arg1696z00_16927) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27684 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27684 = ((bool_t) 0);
																}
															if (BgL_testz00_27684)
																{
																	obj_t BgL_fz00_27692;

																	BgL_fz00_27692 = BgL_rz00_16926;
																	BgL_fz00_16925 = BgL_fz00_27692;
																	goto BgL_recz00_16924;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16919, ((long) 0),
																		BgL_savedzd2bpzd2_16923);
																	BgL_____rz00_16922 = BgL_rz00_16926;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16921);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16920, BgL_sz00_16911);
											return BgL_____rz00_16922;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5692 */
	obj_t BGl_z62run5692z62zz__evaluate_compz00(obj_t BgL_envz00_14572,
		obj_t BgL_sz00_14575)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14573;
				obj_t BgL_bodyz00_14574;

				BgL_i1246z00_14573 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14572, (int) (((long) 0))));
				BgL_bodyz00_14574 = PROCEDURE_REF(BgL_envz00_14572, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16928;

					BgL_bpz00_16928 = VECTOR_REF(((obj_t) BgL_sz00_14575), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16929;
						obj_t BgL_wherez00_16930;
						obj_t BgL_locz00_16931;

						BgL_z12denvz12_16929 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16930 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14573))->
							BgL_wherez00);
						BgL_locz00_16931 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14573))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16929, BgL_wherez00_16930,
								BgL_locz00_16931);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16932;

								BgL_za2za2resza2za2z00_16932 =
									PROCEDURE_ENTRY(BgL_bodyz00_14574) (BgL_bodyz00_14574,
									BgL_sz00_14575, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16929);
								return BgL_za2za2resza2za2z00_16932;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3754> */
	obj_t BGl_z62zc3anonymousza33754ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14576, obj_t BgL_sz00_14581)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14577;
				BgL_ev_absz00_bglt BgL_i1246z00_14578;
				obj_t BgL_bodyz00_14579;
				long BgL_siza7ezd2framez75_14580;

				BgL_iboxesz00_14577 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14576, (int) (((long) 0))));
				BgL_i1246z00_14578 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14576, (int) (((long) 1))));
				BgL_bodyz00_14579 = PROCEDURE_REF(BgL_envz00_14576, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14580 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14576, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16933;

					BgL_bpz00_16933 = VECTOR_REF(((obj_t) BgL_sz00_14581), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16934;

							BgL_runz00_16934 =
								MAKE_FX_PROCEDURE(BGl_z62run5694z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16934,
								(int) (((long) 0)), BgL_iboxesz00_14577);
							PROCEDURE_SET(BgL_runz00_16934,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14578));
							PROCEDURE_SET(BgL_runz00_16934,
								(int) (((long) 2)), BgL_bodyz00_14579);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16935;

								BgL_mainz00_16935 =
									MAKE_VA_PROCEDURE(BGl_z62main5693z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16935,
									(int) (((long) 0)), BgL_iboxesz00_14577);
								PROCEDURE_SET(BgL_mainz00_16935,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14578));
								PROCEDURE_SET(BgL_mainz00_16935,
									(int) (((long) 2)), BgL_bodyz00_14579);
								PROCEDURE_SET(BgL_mainz00_16935,
									(int) (((long) 3)), BgL_runz00_16934);
								PROCEDURE_SET(BgL_mainz00_16935,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14580));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16936;

									BgL_objz00_16936 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16934, BgL_objz00_16936);
									BgL_objz00_16936;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3755z00_16937;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3756z00_16938;

										BgL_arg3756z00_16938 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14578))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16939;

											BgL_newz00_16939 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27754;

												BgL_tmpz00_27754 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16939, BgL_tmpz00_27754,
													BgL_arg3756z00_16938);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27759;
												int BgL_tmpz00_27757;

												BgL_auxz00_27759 = BINT(BgL_siza7ezd2framez75_14580);
												BgL_tmpz00_27757 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16939, BgL_tmpz00_27757,
													BgL_auxz00_27759);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27762;

												BgL_tmpz00_27762 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16939, BgL_tmpz00_27762,
													BgL_runz00_16934);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27767;
												int BgL_tmpz00_27765;

												BgL_auxz00_27767 = BINT(((long) -4));
												BgL_tmpz00_27765 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16939, BgL_tmpz00_27765,
													BgL_auxz00_27767);
											}
											BgL_arg3755z00_16937 = BgL_newz00_16939;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16935, BgL_arg3755z00_16937);
									BgL_arg3755z00_16937;
								}
								return BgL_mainz00_16935;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5693 */
	obj_t BGl_z62main5693z62zz__evaluate_compz00(obj_t BgL_envz00_14582,
		obj_t BgL_bz00_14588, obj_t BgL_cz00_14589, obj_t BgL_dz00_14590,
		obj_t BgL_lastz00_14591)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14586;
				long BgL_siza7ezd2framez75_14587;

				BgL_runz00_14586 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14582, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14587 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14582, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16940;

					BgL_sz00_16940 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16941;

						BgL_bpz00_16941 = VECTOR_REF(((obj_t) BgL_sz00_16940), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16941) + BgL_siza7ezd2framez75_14587) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16940))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3759z00_16942;

									BgL_arg3759z00_16942 =
										((long) CINT(BgL_bpz00_16941) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16940), BgL_arg3759z00_16942,
										BgL_bz00_14588);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3760z00_16943;

									BgL_arg3760z00_16943 =
										((long) CINT(BgL_bpz00_16941) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16940), BgL_arg3760z00_16943,
										BgL_cz00_14589);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3761z00_16944;

									BgL_arg3761z00_16944 =
										((long) CINT(BgL_bpz00_16941) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16940), BgL_arg3761z00_16944,
										BgL_dz00_14590);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3762z00_16945;

									BgL_arg3762z00_16945 =
										((long) CINT(BgL_bpz00_16941) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16940), BgL_arg3762z00_16945,
										BgL_lastz00_14591);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16946;

									BgL_ez00_16946 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16946,
										BgL_bpz00_16941);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16947;

										BgL_accz00_16947 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14586, BgL_sz00_16940, BgL_bpz00_16941);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16946);
										VECTOR_SET(
											((obj_t) BgL_sz00_16940), ((long) 0), BgL_bpz00_16941);
										return BgL_accz00_16947;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16948;

								BgL_nsz00_16948 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16948, ((long) 1), BgL_sz00_16940);
								VECTOR_SET(BgL_nsz00_16948, ((long) 2), BgL_bz00_14588);
								VECTOR_SET(BgL_nsz00_16948, ((long) 3), BgL_cz00_14589);
								VECTOR_SET(BgL_nsz00_16948, ((long) 4), BgL_dz00_14590);
								VECTOR_SET(BgL_nsz00_16948, ((long) 5), BgL_lastz00_14591);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16949;

									BgL_z12denvz12_16949 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16949, BgL_nsz00_16948);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16950;

										BgL_ez00_16950 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16950,
											BgL_sz00_16940);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16951;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16952;

												BgL_savedzd2bpzd2_16952 =
													VECTOR_REF(BgL_nsz00_16948, ((long) 0));
												VECTOR_SET(BgL_nsz00_16948, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16954;

													BgL_fz00_16954 = BgL_runz00_14586;
												BgL_recz00_16953:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16955;

														BgL_rz00_16955 =
															PROCEDURE_ENTRY(BgL_fz00_16954) (BgL_fz00_16954,
															BgL_nsz00_16948, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27825;

															if (PROCEDUREP(BgL_rz00_16955))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16956;

																	BgL_arg1696z00_16956 =
																		PROCEDURE_ATTR(BgL_rz00_16955);
																	if (STRUCTP(BgL_arg1696z00_16956))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27825 =
																				(STRUCT_KEY(BgL_arg1696z00_16956) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27825 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27825 = ((bool_t) 0);
																}
															if (BgL_testz00_27825)
																{
																	obj_t BgL_fz00_27833;

																	BgL_fz00_27833 = BgL_rz00_16955;
																	BgL_fz00_16954 = BgL_fz00_27833;
																	goto BgL_recz00_16953;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16948, ((long) 0),
																		BgL_savedzd2bpzd2_16952);
																	BgL_____rz00_16951 = BgL_rz00_16955;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16950);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16949, BgL_sz00_16940);
											return BgL_____rz00_16951;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5694 */
	obj_t BGl_z62run5694z62zz__evaluate_compz00(obj_t BgL_envz00_14592,
		obj_t BgL_sz00_14596)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14593;
				BgL_ev_absz00_bglt BgL_i1246z00_14594;
				obj_t BgL_bodyz00_14595;

				BgL_iboxesz00_14593 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14592, (int) (((long) 0))));
				BgL_i1246z00_14594 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14592, (int) (((long) 1))));
				BgL_bodyz00_14595 = PROCEDURE_REF(BgL_envz00_14592, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16957;

					BgL_bpz00_16957 = VECTOR_REF(((obj_t) BgL_sz00_14596), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14596,
						BgL_iboxesz00_14593, BgL_bpz00_16957);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_16958;
						obj_t BgL_wherez00_16959;
						obj_t BgL_locz00_16960;

						BgL_z12denvz12_16958 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16959 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14594))->
							BgL_wherez00);
						BgL_locz00_16960 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14594))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16958, BgL_wherez00_16959,
								BgL_locz00_16960);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_16961;

								BgL_za2za2resza2za2z00_16961 =
									PROCEDURE_ENTRY(BgL_bodyz00_14595) (BgL_bodyz00_14595,
									BgL_sz00_14596, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16958);
								return BgL_za2za2resza2za2z00_16961;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3767> */
	obj_t BGl_z62zc3anonymousza33767ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14597, obj_t BgL_sz00_14603)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14598;
				long BgL_siza7eza7_14599;
				BgL_ev_absz00_bglt BgL_i1246z00_14600;
				obj_t BgL_bodyz00_14601;
				long BgL_siza7ezd2framez75_14602;

				BgL_ifreesz00_14598 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 0))));
				BgL_siza7eza7_14599 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 1))));
				BgL_i1246z00_14600 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 2))));
				BgL_bodyz00_14601 = PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14602 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14597, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16962;

					BgL_bpz00_16962 = VECTOR_REF(((obj_t) BgL_sz00_14603), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16963;

						BgL_valza2za2_16963 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14603,
							BgL_bpz00_16962, BgL_ifreesz00_14598);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16964;

							BgL_runz00_16964 =
								MAKE_FX_PROCEDURE(BGl_z62run5696z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16964,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14599));
							PROCEDURE_SET(BgL_runz00_16964,
								(int) (((long) 1)), BgL_valza2za2_16963);
							PROCEDURE_SET(BgL_runz00_16964,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14600));
							PROCEDURE_SET(BgL_runz00_16964,
								(int) (((long) 3)), BgL_bodyz00_14601);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16965;

								BgL_mainz00_16965 =
									MAKE_VA_PROCEDURE(BGl_z62main5695z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16965,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14599));
								PROCEDURE_SET(BgL_mainz00_16965,
									(int) (((long) 1)), BgL_valza2za2_16963);
								PROCEDURE_SET(BgL_mainz00_16965,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14600));
								PROCEDURE_SET(BgL_mainz00_16965,
									(int) (((long) 3)), BgL_bodyz00_14601);
								PROCEDURE_SET(BgL_mainz00_16965,
									(int) (((long) 4)), BgL_runz00_16964);
								PROCEDURE_SET(BgL_mainz00_16965,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14602));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16966;

									BgL_objz00_16966 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16964, BgL_objz00_16966);
									BgL_objz00_16966;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3768z00_16967;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3769z00_16968;

										BgL_arg3769z00_16968 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14600))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16969;

											BgL_newz00_16969 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27909;

												BgL_tmpz00_27909 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16969, BgL_tmpz00_27909,
													BgL_arg3769z00_16968);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27914;
												int BgL_tmpz00_27912;

												BgL_auxz00_27914 = BINT(BgL_siza7ezd2framez75_14602);
												BgL_tmpz00_27912 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16969, BgL_tmpz00_27912,
													BgL_auxz00_27914);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_27917;

												BgL_tmpz00_27917 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16969, BgL_tmpz00_27917,
													BgL_runz00_16964);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_27922;
												int BgL_tmpz00_27920;

												BgL_auxz00_27922 = BINT(((long) -4));
												BgL_tmpz00_27920 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16969, BgL_tmpz00_27920,
													BgL_auxz00_27922);
											}
											BgL_arg3768z00_16967 = BgL_newz00_16969;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16965, BgL_arg3768z00_16967);
									BgL_arg3768z00_16967;
								}
								return BgL_mainz00_16965;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5695 */
	obj_t BGl_z62main5695z62zz__evaluate_compz00(obj_t BgL_envz00_14604,
		obj_t BgL_bz00_14611, obj_t BgL_cz00_14612, obj_t BgL_dz00_14613,
		obj_t BgL_lastz00_14614)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14609;
				long BgL_siza7ezd2framez75_14610;

				BgL_runz00_14609 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14604, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14610 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14604, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_16970;

					BgL_sz00_16970 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_16971;

						BgL_bpz00_16971 = VECTOR_REF(((obj_t) BgL_sz00_16970), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16971) + BgL_siza7ezd2framez75_14610) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16970))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3772z00_16972;

									BgL_arg3772z00_16972 =
										((long) CINT(BgL_bpz00_16971) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16970), BgL_arg3772z00_16972,
										BgL_bz00_14611);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3773z00_16973;

									BgL_arg3773z00_16973 =
										((long) CINT(BgL_bpz00_16971) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16970), BgL_arg3773z00_16973,
										BgL_cz00_14612);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3774z00_16974;

									BgL_arg3774z00_16974 =
										((long) CINT(BgL_bpz00_16971) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16970), BgL_arg3774z00_16974,
										BgL_dz00_14613);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3775z00_16975;

									BgL_arg3775z00_16975 =
										((long) CINT(BgL_bpz00_16971) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16970), BgL_arg3775z00_16975,
										BgL_lastz00_14614);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_16976;

									BgL_ez00_16976 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16976,
										BgL_bpz00_16971);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_16977;

										BgL_accz00_16977 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14609, BgL_sz00_16970, BgL_bpz00_16971);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16976);
										VECTOR_SET(
											((obj_t) BgL_sz00_16970), ((long) 0), BgL_bpz00_16971);
										return BgL_accz00_16977;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_16978;

								BgL_nsz00_16978 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16978, ((long) 1), BgL_sz00_16970);
								VECTOR_SET(BgL_nsz00_16978, ((long) 2), BgL_bz00_14611);
								VECTOR_SET(BgL_nsz00_16978, ((long) 3), BgL_cz00_14612);
								VECTOR_SET(BgL_nsz00_16978, ((long) 4), BgL_dz00_14613);
								VECTOR_SET(BgL_nsz00_16978, ((long) 5), BgL_lastz00_14614);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_16979;

									BgL_z12denvz12_16979 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16979, BgL_nsz00_16978);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_16980;

										BgL_ez00_16980 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16980,
											BgL_sz00_16970);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_16981;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_16982;

												BgL_savedzd2bpzd2_16982 =
													VECTOR_REF(BgL_nsz00_16978, ((long) 0));
												VECTOR_SET(BgL_nsz00_16978, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16984;

													BgL_fz00_16984 = BgL_runz00_14609;
												BgL_recz00_16983:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_16985;

														BgL_rz00_16985 =
															PROCEDURE_ENTRY(BgL_fz00_16984) (BgL_fz00_16984,
															BgL_nsz00_16978, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_27980;

															if (PROCEDUREP(BgL_rz00_16985))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_16986;

																	BgL_arg1696z00_16986 =
																		PROCEDURE_ATTR(BgL_rz00_16985);
																	if (STRUCTP(BgL_arg1696z00_16986))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27980 =
																				(STRUCT_KEY(BgL_arg1696z00_16986) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_27980 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_27980 = ((bool_t) 0);
																}
															if (BgL_testz00_27980)
																{
																	obj_t BgL_fz00_27988;

																	BgL_fz00_27988 = BgL_rz00_16985;
																	BgL_fz00_16984 = BgL_fz00_27988;
																	goto BgL_recz00_16983;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_16978, ((long) 0),
																		BgL_savedzd2bpzd2_16982);
																	BgL_____rz00_16981 = BgL_rz00_16985;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16980);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16979, BgL_sz00_16970);
											return BgL_____rz00_16981;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5696 */
	obj_t BGl_z62run5696z62zz__evaluate_compz00(obj_t BgL_envz00_14615,
		obj_t BgL_sz00_14620)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14616;
				obj_t BgL_valza2za2_14617;
				BgL_ev_absz00_bglt BgL_i1246z00_14618;
				obj_t BgL_bodyz00_14619;

				BgL_siza7eza7_14616 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14615, (int) (((long) 0))));
				BgL_valza2za2_14617 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14615, (int) (((long) 1))));
				BgL_i1246z00_14618 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14615, (int) (((long) 2))));
				BgL_bodyz00_14619 = PROCEDURE_REF(BgL_envz00_14615, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16987;

					BgL_bpz00_16987 = VECTOR_REF(((obj_t) BgL_sz00_14620), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14620,
						BgL_valza2za2_14617,
						((long) CINT(BgL_bpz00_16987) + BgL_siza7eza7_14616));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_16988;
						obj_t BgL_wherez00_16989;
						obj_t BgL_locz00_16990;

						BgL_z12denvz12_16988 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16989 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14618))->
							BgL_wherez00);
						BgL_locz00_16990 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14618))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16988, BgL_wherez00_16989,
								BgL_locz00_16990);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_16991;

								BgL_za2za2resza2za2z00_16991 =
									PROCEDURE_ENTRY(BgL_bodyz00_14619) (BgL_bodyz00_14619,
									BgL_sz00_14620, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16988);
								return BgL_za2za2resza2za2z00_16991;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3779> */
	obj_t BGl_z62zc3anonymousza33779ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14621, obj_t BgL_sz00_14628)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14622;
				obj_t BgL_iboxesz00_14623;
				long BgL_siza7eza7_14624;
				BgL_ev_absz00_bglt BgL_i1246z00_14625;
				obj_t BgL_bodyz00_14626;
				long BgL_siza7ezd2framez75_14627;

				BgL_ifreesz00_14622 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 0))));
				BgL_iboxesz00_14623 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 1))));
				BgL_siza7eza7_14624 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 2))));
				BgL_i1246z00_14625 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 3))));
				BgL_bodyz00_14626 = PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14627 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14621, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_16992;

					BgL_bpz00_16992 = VECTOR_REF(((obj_t) BgL_sz00_14628), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_16993;

						BgL_valza2za2_16993 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14628,
							BgL_bpz00_16992, BgL_ifreesz00_14622);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_16994;

							BgL_runz00_16994 =
								MAKE_FX_PROCEDURE(BGl_z62run5698z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16994,
								(int) (((long) 0)), BgL_iboxesz00_14623);
							PROCEDURE_SET(BgL_runz00_16994,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14624));
							PROCEDURE_SET(BgL_runz00_16994,
								(int) (((long) 2)), BgL_valza2za2_16993);
							PROCEDURE_SET(BgL_runz00_16994,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14625));
							PROCEDURE_SET(BgL_runz00_16994,
								(int) (((long) 4)), BgL_bodyz00_14626);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_16995;

								BgL_mainz00_16995 =
									MAKE_VA_PROCEDURE(BGl_z62main5697z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 0)), BgL_iboxesz00_14623);
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14624));
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 2)), BgL_valza2za2_16993);
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14625));
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 4)), BgL_bodyz00_14626);
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 5)), BgL_runz00_16994);
								PROCEDURE_SET(BgL_mainz00_16995,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14627));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_16996;

									BgL_objz00_16996 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16994, BgL_objz00_16996);
									BgL_objz00_16996;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3780z00_16997;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3781z00_16998;

										BgL_arg3781z00_16998 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14625))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_16999;

											BgL_newz00_16999 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28076;

												BgL_tmpz00_28076 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16999, BgL_tmpz00_28076,
													BgL_arg3781z00_16998);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28081;
												int BgL_tmpz00_28079;

												BgL_auxz00_28081 = BINT(BgL_siza7ezd2framez75_14627);
												BgL_tmpz00_28079 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16999, BgL_tmpz00_28079,
													BgL_auxz00_28081);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28084;

												BgL_tmpz00_28084 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16999, BgL_tmpz00_28084,
													BgL_runz00_16994);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28089;
												int BgL_tmpz00_28087;

												BgL_auxz00_28089 = BINT(((long) -4));
												BgL_tmpz00_28087 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16999, BgL_tmpz00_28087,
													BgL_auxz00_28089);
											}
											BgL_arg3780z00_16997 = BgL_newz00_16999;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16995, BgL_arg3780z00_16997);
									BgL_arg3780z00_16997;
								}
								return BgL_mainz00_16995;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5697 */
	obj_t BGl_z62main5697z62zz__evaluate_compz00(obj_t BgL_envz00_14629,
		obj_t BgL_bz00_14637, obj_t BgL_cz00_14638, obj_t BgL_dz00_14639,
		obj_t BgL_lastz00_14640)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14635;
				long BgL_siza7ezd2framez75_14636;

				BgL_runz00_14635 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14629, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14636 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14629, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17000;

					BgL_sz00_17000 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17001;

						BgL_bpz00_17001 = VECTOR_REF(((obj_t) BgL_sz00_17000), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17001) + BgL_siza7ezd2framez75_14636) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17000))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3784z00_17002;

									BgL_arg3784z00_17002 =
										((long) CINT(BgL_bpz00_17001) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17000), BgL_arg3784z00_17002,
										BgL_bz00_14637);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3785z00_17003;

									BgL_arg3785z00_17003 =
										((long) CINT(BgL_bpz00_17001) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17000), BgL_arg3785z00_17003,
										BgL_cz00_14638);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3786z00_17004;

									BgL_arg3786z00_17004 =
										((long) CINT(BgL_bpz00_17001) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17000), BgL_arg3786z00_17004,
										BgL_dz00_14639);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3787z00_17005;

									BgL_arg3787z00_17005 =
										((long) CINT(BgL_bpz00_17001) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17000), BgL_arg3787z00_17005,
										BgL_lastz00_14640);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17006;

									BgL_ez00_17006 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17006,
										BgL_bpz00_17001);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17007;

										BgL_accz00_17007 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14635, BgL_sz00_17000, BgL_bpz00_17001);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17006);
										VECTOR_SET(
											((obj_t) BgL_sz00_17000), ((long) 0), BgL_bpz00_17001);
										return BgL_accz00_17007;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17008;

								BgL_nsz00_17008 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17008, ((long) 1), BgL_sz00_17000);
								VECTOR_SET(BgL_nsz00_17008, ((long) 2), BgL_bz00_14637);
								VECTOR_SET(BgL_nsz00_17008, ((long) 3), BgL_cz00_14638);
								VECTOR_SET(BgL_nsz00_17008, ((long) 4), BgL_dz00_14639);
								VECTOR_SET(BgL_nsz00_17008, ((long) 5), BgL_lastz00_14640);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17009;

									BgL_z12denvz12_17009 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17009, BgL_nsz00_17008);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17010;

										BgL_ez00_17010 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17010,
											BgL_sz00_17000);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17011;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17012;

												BgL_savedzd2bpzd2_17012 =
													VECTOR_REF(BgL_nsz00_17008, ((long) 0));
												VECTOR_SET(BgL_nsz00_17008, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17014;

													BgL_fz00_17014 = BgL_runz00_14635;
												BgL_recz00_17013:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17015;

														BgL_rz00_17015 =
															PROCEDURE_ENTRY(BgL_fz00_17014) (BgL_fz00_17014,
															BgL_nsz00_17008, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_28147;

															if (PROCEDUREP(BgL_rz00_17015))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17016;

																	BgL_arg1696z00_17016 =
																		PROCEDURE_ATTR(BgL_rz00_17015);
																	if (STRUCTP(BgL_arg1696z00_17016))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28147 =
																				(STRUCT_KEY(BgL_arg1696z00_17016) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28147 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_28147 = ((bool_t) 0);
																}
															if (BgL_testz00_28147)
																{
																	obj_t BgL_fz00_28155;

																	BgL_fz00_28155 = BgL_rz00_17015;
																	BgL_fz00_17014 = BgL_fz00_28155;
																	goto BgL_recz00_17013;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17008, ((long) 0),
																		BgL_savedzd2bpzd2_17012);
																	BgL_____rz00_17011 = BgL_rz00_17015;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17010);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17009, BgL_sz00_17000);
											return BgL_____rz00_17011;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5698 */
	obj_t BGl_z62run5698z62zz__evaluate_compz00(obj_t BgL_envz00_14641,
		obj_t BgL_sz00_14647)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14642;
				long BgL_siza7eza7_14643;
				obj_t BgL_valza2za2_14644;
				BgL_ev_absz00_bglt BgL_i1246z00_14645;
				obj_t BgL_bodyz00_14646;

				BgL_iboxesz00_14642 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 0))));
				BgL_siza7eza7_14643 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 1))));
				BgL_valza2za2_14644 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 2))));
				BgL_i1246z00_14645 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 3))));
				BgL_bodyz00_14646 = PROCEDURE_REF(BgL_envz00_14641, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17017;

					BgL_bpz00_17017 = VECTOR_REF(((obj_t) BgL_sz00_14647), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14647,
						BgL_iboxesz00_14642, BgL_bpz00_17017);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14647,
						BgL_valza2za2_14644,
						((long) CINT(BgL_bpz00_17017) + BgL_siza7eza7_14643));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17018;
						obj_t BgL_wherez00_17019;
						obj_t BgL_locz00_17020;

						BgL_z12denvz12_17018 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17019 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14645))->
							BgL_wherez00);
						BgL_locz00_17020 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14645))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17018, BgL_wherez00_17019,
								BgL_locz00_17020);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17021;

								BgL_za2za2resza2za2z00_17021 =
									PROCEDURE_ENTRY(BgL_bodyz00_14646) (BgL_bodyz00_14646,
									BgL_sz00_14647, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17018);
								return BgL_za2za2resza2za2z00_17021;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3694> */
	obj_t BGl_z62zc3anonymousza33694ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14648, obj_t BgL_sz00_14652)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14649;
				obj_t BgL_bodyz00_14650;
				long BgL_siza7ezd2framez75_14651;

				BgL_i1246z00_14649 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14648, (int) (((long) 0))));
				BgL_bodyz00_14650 = PROCEDURE_REF(BgL_envz00_14648, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14651 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14648, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17022;

					BgL_bpz00_17022 = VECTOR_REF(((obj_t) BgL_sz00_14652), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17023;

							BgL_runz00_17023 =
								MAKE_FX_PROCEDURE(BGl_z62run5700z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17023,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14649));
							PROCEDURE_SET(BgL_runz00_17023,
								(int) (((long) 1)), BgL_bodyz00_14650);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17024;

								BgL_mainz00_17024 =
									MAKE_FX_PROCEDURE(BGl_z62main5699z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17024,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14649));
								PROCEDURE_SET(BgL_mainz00_17024,
									(int) (((long) 1)), BgL_bodyz00_14650);
								PROCEDURE_SET(BgL_mainz00_17024,
									(int) (((long) 2)), BgL_runz00_17023);
								PROCEDURE_SET(BgL_mainz00_17024,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14651));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17025;

									BgL_objz00_17025 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17023, BgL_objz00_17025);
									BgL_objz00_17025;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3695z00_17026;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3696z00_17027;

										BgL_arg3696z00_17027 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14649))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17028;

											BgL_newz00_17028 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28223;

												BgL_tmpz00_28223 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17028, BgL_tmpz00_28223,
													BgL_arg3696z00_17027);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28228;
												int BgL_tmpz00_28226;

												BgL_auxz00_28228 = BINT(BgL_siza7ezd2framez75_14651);
												BgL_tmpz00_28226 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17028, BgL_tmpz00_28226,
													BgL_auxz00_28228);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28231;

												BgL_tmpz00_28231 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17028, BgL_tmpz00_28231,
													BgL_runz00_17023);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28236;
												int BgL_tmpz00_28234;

												BgL_auxz00_28236 = BINT(((long) 3));
												BgL_tmpz00_28234 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17028, BgL_tmpz00_28234,
													BgL_auxz00_28236);
											}
											BgL_arg3695z00_17026 = BgL_newz00_17028;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17024, BgL_arg3695z00_17026);
									BgL_arg3695z00_17026;
								}
								return BgL_mainz00_17024;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5699 */
	obj_t BGl_z62main5699z62zz__evaluate_compz00(obj_t BgL_envz00_14653,
		obj_t BgL_bz00_14658, obj_t BgL_cz00_14659, obj_t BgL_dz00_14660)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14656;
				long BgL_siza7ezd2framez75_14657;

				BgL_runz00_14656 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14653, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14657 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14653, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17029;

					BgL_sz00_17029 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17030;

						BgL_bpz00_17030 = VECTOR_REF(((obj_t) BgL_sz00_17029), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17030) + BgL_siza7ezd2framez75_14657) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17029))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3699z00_17031;

									BgL_arg3699z00_17031 =
										((long) CINT(BgL_bpz00_17030) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17029), BgL_arg3699z00_17031,
										BgL_bz00_14658);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3700z00_17032;

									BgL_arg3700z00_17032 =
										((long) CINT(BgL_bpz00_17030) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17029), BgL_arg3700z00_17032,
										BgL_cz00_14659);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3701z00_17033;

									BgL_arg3701z00_17033 =
										((long) CINT(BgL_bpz00_17030) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17029), BgL_arg3701z00_17033,
										BgL_dz00_14660);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17034;

									BgL_ez00_17034 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17034,
										BgL_bpz00_17030);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17035;

										BgL_accz00_17035 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14656, BgL_sz00_17029, BgL_bpz00_17030);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17034);
										VECTOR_SET(
											((obj_t) BgL_sz00_17029), ((long) 0), BgL_bpz00_17030);
										return BgL_accz00_17035;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17036;

								BgL_nsz00_17036 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17036, ((long) 1), BgL_sz00_17029);
								VECTOR_SET(BgL_nsz00_17036, ((long) 2), BgL_bz00_14658);
								VECTOR_SET(BgL_nsz00_17036, ((long) 3), BgL_cz00_14659);
								VECTOR_SET(BgL_nsz00_17036, ((long) 4), BgL_dz00_14660);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17037;

									BgL_z12denvz12_17037 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17037, BgL_nsz00_17036);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17038;

										BgL_ez00_17038 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17038,
											BgL_sz00_17029);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17039;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17040;

												BgL_savedzd2bpzd2_17040 =
													VECTOR_REF(BgL_nsz00_17036, ((long) 0));
												VECTOR_SET(BgL_nsz00_17036, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17042;

													BgL_fz00_17042 = BgL_runz00_14656;
												BgL_recz00_17041:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17043;

														BgL_rz00_17043 =
															PROCEDURE_ENTRY(BgL_fz00_17042) (BgL_fz00_17042,
															BgL_nsz00_17036, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_28289;

															if (PROCEDUREP(BgL_rz00_17043))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17044;

																	BgL_arg1696z00_17044 =
																		PROCEDURE_ATTR(BgL_rz00_17043);
																	if (STRUCTP(BgL_arg1696z00_17044))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28289 =
																				(STRUCT_KEY(BgL_arg1696z00_17044) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28289 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_28289 = ((bool_t) 0);
																}
															if (BgL_testz00_28289)
																{
																	obj_t BgL_fz00_28297;

																	BgL_fz00_28297 = BgL_rz00_17043;
																	BgL_fz00_17042 = BgL_fz00_28297;
																	goto BgL_recz00_17041;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17036, ((long) 0),
																		BgL_savedzd2bpzd2_17040);
																	BgL_____rz00_17039 = BgL_rz00_17043;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17038);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17037, BgL_sz00_17029);
											return BgL_____rz00_17039;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5700 */
	obj_t BGl_z62run5700z62zz__evaluate_compz00(obj_t BgL_envz00_14661,
		obj_t BgL_sz00_14664)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14662;
				obj_t BgL_bodyz00_14663;

				BgL_i1246z00_14662 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 0))));
				BgL_bodyz00_14663 = PROCEDURE_REF(BgL_envz00_14661, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17045;

					BgL_bpz00_17045 = VECTOR_REF(((obj_t) BgL_sz00_14664), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17046;
						obj_t BgL_wherez00_17047;
						obj_t BgL_locz00_17048;

						BgL_z12denvz12_17046 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17047 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14662))->
							BgL_wherez00);
						BgL_locz00_17048 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14662))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17046, BgL_wherez00_17047,
								BgL_locz00_17048);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17049;

								BgL_za2za2resza2za2z00_17049 =
									PROCEDURE_ENTRY(BgL_bodyz00_14663) (BgL_bodyz00_14663,
									BgL_sz00_14664, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17046);
								return BgL_za2za2resza2za2z00_17049;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3703> */
	obj_t BGl_z62zc3anonymousza33703ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14665, obj_t BgL_sz00_14670)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14666;
				BgL_ev_absz00_bglt BgL_i1246z00_14667;
				obj_t BgL_bodyz00_14668;
				long BgL_siza7ezd2framez75_14669;

				BgL_iboxesz00_14666 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14665, (int) (((long) 0))));
				BgL_i1246z00_14667 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14665, (int) (((long) 1))));
				BgL_bodyz00_14668 = PROCEDURE_REF(BgL_envz00_14665, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14669 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14665, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17050;

					BgL_bpz00_17050 = VECTOR_REF(((obj_t) BgL_sz00_14670), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17051;

							BgL_runz00_17051 =
								MAKE_FX_PROCEDURE(BGl_z62run5702z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17051,
								(int) (((long) 0)), BgL_iboxesz00_14666);
							PROCEDURE_SET(BgL_runz00_17051,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14667));
							PROCEDURE_SET(BgL_runz00_17051,
								(int) (((long) 2)), BgL_bodyz00_14668);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17052;

								BgL_mainz00_17052 =
									MAKE_FX_PROCEDURE(BGl_z62main5701z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17052,
									(int) (((long) 0)), BgL_iboxesz00_14666);
								PROCEDURE_SET(BgL_mainz00_17052,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14667));
								PROCEDURE_SET(BgL_mainz00_17052,
									(int) (((long) 2)), BgL_bodyz00_14668);
								PROCEDURE_SET(BgL_mainz00_17052,
									(int) (((long) 3)), BgL_runz00_17051);
								PROCEDURE_SET(BgL_mainz00_17052,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14669));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17053;

									BgL_objz00_17053 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17051, BgL_objz00_17053);
									BgL_objz00_17053;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3704z00_17054;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3705z00_17055;

										BgL_arg3705z00_17055 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14667))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17056;

											BgL_newz00_17056 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28359;

												BgL_tmpz00_28359 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17056, BgL_tmpz00_28359,
													BgL_arg3705z00_17055);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28364;
												int BgL_tmpz00_28362;

												BgL_auxz00_28364 = BINT(BgL_siza7ezd2framez75_14669);
												BgL_tmpz00_28362 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17056, BgL_tmpz00_28362,
													BgL_auxz00_28364);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28367;

												BgL_tmpz00_28367 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17056, BgL_tmpz00_28367,
													BgL_runz00_17051);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28372;
												int BgL_tmpz00_28370;

												BgL_auxz00_28372 = BINT(((long) 3));
												BgL_tmpz00_28370 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17056, BgL_tmpz00_28370,
													BgL_auxz00_28372);
											}
											BgL_arg3704z00_17054 = BgL_newz00_17056;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17052, BgL_arg3704z00_17054);
									BgL_arg3704z00_17054;
								}
								return BgL_mainz00_17052;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5701 */
	obj_t BGl_z62main5701z62zz__evaluate_compz00(obj_t BgL_envz00_14671,
		obj_t BgL_bz00_14677, obj_t BgL_cz00_14678, obj_t BgL_dz00_14679)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14675;
				long BgL_siza7ezd2framez75_14676;

				BgL_runz00_14675 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14671, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14676 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14671, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17057;

					BgL_sz00_17057 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17058;

						BgL_bpz00_17058 = VECTOR_REF(((obj_t) BgL_sz00_17057), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17058) + BgL_siza7ezd2framez75_14676) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17057))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3708z00_17059;

									BgL_arg3708z00_17059 =
										((long) CINT(BgL_bpz00_17058) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17057), BgL_arg3708z00_17059,
										BgL_bz00_14677);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3710z00_17060;

									BgL_arg3710z00_17060 =
										((long) CINT(BgL_bpz00_17058) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17057), BgL_arg3710z00_17060,
										BgL_cz00_14678);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3711z00_17061;

									BgL_arg3711z00_17061 =
										((long) CINT(BgL_bpz00_17058) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17057), BgL_arg3711z00_17061,
										BgL_dz00_14679);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17062;

									BgL_ez00_17062 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17062,
										BgL_bpz00_17058);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17063;

										BgL_accz00_17063 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14675, BgL_sz00_17057, BgL_bpz00_17058);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17062);
										VECTOR_SET(
											((obj_t) BgL_sz00_17057), ((long) 0), BgL_bpz00_17058);
										return BgL_accz00_17063;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17064;

								BgL_nsz00_17064 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17064, ((long) 1), BgL_sz00_17057);
								VECTOR_SET(BgL_nsz00_17064, ((long) 2), BgL_bz00_14677);
								VECTOR_SET(BgL_nsz00_17064, ((long) 3), BgL_cz00_14678);
								VECTOR_SET(BgL_nsz00_17064, ((long) 4), BgL_dz00_14679);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17065;

									BgL_z12denvz12_17065 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17065, BgL_nsz00_17064);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17066;

										BgL_ez00_17066 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17066,
											BgL_sz00_17057);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17067;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17068;

												BgL_savedzd2bpzd2_17068 =
													VECTOR_REF(BgL_nsz00_17064, ((long) 0));
												VECTOR_SET(BgL_nsz00_17064, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17070;

													BgL_fz00_17070 = BgL_runz00_14675;
												BgL_recz00_17069:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17071;

														BgL_rz00_17071 =
															PROCEDURE_ENTRY(BgL_fz00_17070) (BgL_fz00_17070,
															BgL_nsz00_17064, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_28425;

															if (PROCEDUREP(BgL_rz00_17071))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17072;

																	BgL_arg1696z00_17072 =
																		PROCEDURE_ATTR(BgL_rz00_17071);
																	if (STRUCTP(BgL_arg1696z00_17072))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28425 =
																				(STRUCT_KEY(BgL_arg1696z00_17072) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28425 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_28425 = ((bool_t) 0);
																}
															if (BgL_testz00_28425)
																{
																	obj_t BgL_fz00_28433;

																	BgL_fz00_28433 = BgL_rz00_17071;
																	BgL_fz00_17070 = BgL_fz00_28433;
																	goto BgL_recz00_17069;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17064, ((long) 0),
																		BgL_savedzd2bpzd2_17068);
																	BgL_____rz00_17067 = BgL_rz00_17071;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17066);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17065, BgL_sz00_17057);
											return BgL_____rz00_17067;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5702 */
	obj_t BGl_z62run5702z62zz__evaluate_compz00(obj_t BgL_envz00_14680,
		obj_t BgL_sz00_14684)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14681;
				BgL_ev_absz00_bglt BgL_i1246z00_14682;
				obj_t BgL_bodyz00_14683;

				BgL_iboxesz00_14681 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14680, (int) (((long) 0))));
				BgL_i1246z00_14682 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14680, (int) (((long) 1))));
				BgL_bodyz00_14683 = PROCEDURE_REF(BgL_envz00_14680, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17073;

					BgL_bpz00_17073 = VECTOR_REF(((obj_t) BgL_sz00_14684), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14684,
						BgL_iboxesz00_14681, BgL_bpz00_17073);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17074;
						obj_t BgL_wherez00_17075;
						obj_t BgL_locz00_17076;

						BgL_z12denvz12_17074 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17075 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14682))->
							BgL_wherez00);
						BgL_locz00_17076 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14682))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17074, BgL_wherez00_17075,
								BgL_locz00_17076);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17077;

								BgL_za2za2resza2za2z00_17077 =
									PROCEDURE_ENTRY(BgL_bodyz00_14683) (BgL_bodyz00_14683,
									BgL_sz00_14684, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17074);
								return BgL_za2za2resza2za2z00_17077;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3717> */
	obj_t BGl_z62zc3anonymousza33717ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14685, obj_t BgL_sz00_14691)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14686;
				long BgL_siza7eza7_14687;
				BgL_ev_absz00_bglt BgL_i1246z00_14688;
				obj_t BgL_bodyz00_14689;
				long BgL_siza7ezd2framez75_14690;

				BgL_ifreesz00_14686 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14685, (int) (((long) 0))));
				BgL_siza7eza7_14687 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14685, (int) (((long) 1))));
				BgL_i1246z00_14688 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14685, (int) (((long) 2))));
				BgL_bodyz00_14689 = PROCEDURE_REF(BgL_envz00_14685, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14690 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14685, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17078;

					BgL_bpz00_17078 = VECTOR_REF(((obj_t) BgL_sz00_14691), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17079;

						BgL_valza2za2_17079 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14691,
							BgL_bpz00_17078, BgL_ifreesz00_14686);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17080;

							BgL_runz00_17080 =
								MAKE_FX_PROCEDURE(BGl_z62run5704z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17080,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14687));
							PROCEDURE_SET(BgL_runz00_17080,
								(int) (((long) 1)), BgL_valza2za2_17079);
							PROCEDURE_SET(BgL_runz00_17080,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14688));
							PROCEDURE_SET(BgL_runz00_17080,
								(int) (((long) 3)), BgL_bodyz00_14689);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17081;

								BgL_mainz00_17081 =
									MAKE_FX_PROCEDURE(BGl_z62main5703z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17081,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14687));
								PROCEDURE_SET(BgL_mainz00_17081,
									(int) (((long) 1)), BgL_valza2za2_17079);
								PROCEDURE_SET(BgL_mainz00_17081,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14688));
								PROCEDURE_SET(BgL_mainz00_17081,
									(int) (((long) 3)), BgL_bodyz00_14689);
								PROCEDURE_SET(BgL_mainz00_17081,
									(int) (((long) 4)), BgL_runz00_17080);
								PROCEDURE_SET(BgL_mainz00_17081,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14690));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17082;

									BgL_objz00_17082 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17080, BgL_objz00_17082);
									BgL_objz00_17082;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3718z00_17083;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3720z00_17084;

										BgL_arg3720z00_17084 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14688))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17085;

											BgL_newz00_17085 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28509;

												BgL_tmpz00_28509 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17085, BgL_tmpz00_28509,
													BgL_arg3720z00_17084);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28514;
												int BgL_tmpz00_28512;

												BgL_auxz00_28514 = BINT(BgL_siza7ezd2framez75_14690);
												BgL_tmpz00_28512 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17085, BgL_tmpz00_28512,
													BgL_auxz00_28514);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28517;

												BgL_tmpz00_28517 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17085, BgL_tmpz00_28517,
													BgL_runz00_17080);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28522;
												int BgL_tmpz00_28520;

												BgL_auxz00_28522 = BINT(((long) 3));
												BgL_tmpz00_28520 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17085, BgL_tmpz00_28520,
													BgL_auxz00_28522);
											}
											BgL_arg3718z00_17083 = BgL_newz00_17085;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17081, BgL_arg3718z00_17083);
									BgL_arg3718z00_17083;
								}
								return BgL_mainz00_17081;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5703 */
	obj_t BGl_z62main5703z62zz__evaluate_compz00(obj_t BgL_envz00_14692,
		obj_t BgL_bz00_14699, obj_t BgL_cz00_14700, obj_t BgL_dz00_14701)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14697;
				long BgL_siza7ezd2framez75_14698;

				BgL_runz00_14697 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14692, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14698 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14692, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17086;

					BgL_sz00_17086 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17087;

						BgL_bpz00_17087 = VECTOR_REF(((obj_t) BgL_sz00_17086), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17087) + BgL_siza7ezd2framez75_14698) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17086))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3723z00_17088;

									BgL_arg3723z00_17088 =
										((long) CINT(BgL_bpz00_17087) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17086), BgL_arg3723z00_17088,
										BgL_bz00_14699);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3724z00_17089;

									BgL_arg3724z00_17089 =
										((long) CINT(BgL_bpz00_17087) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17086), BgL_arg3724z00_17089,
										BgL_cz00_14700);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3725z00_17090;

									BgL_arg3725z00_17090 =
										((long) CINT(BgL_bpz00_17087) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17086), BgL_arg3725z00_17090,
										BgL_dz00_14701);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17091;

									BgL_ez00_17091 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17091,
										BgL_bpz00_17087);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17092;

										BgL_accz00_17092 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14697, BgL_sz00_17086, BgL_bpz00_17087);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17091);
										VECTOR_SET(
											((obj_t) BgL_sz00_17086), ((long) 0), BgL_bpz00_17087);
										return BgL_accz00_17092;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17093;

								BgL_nsz00_17093 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17093, ((long) 1), BgL_sz00_17086);
								VECTOR_SET(BgL_nsz00_17093, ((long) 2), BgL_bz00_14699);
								VECTOR_SET(BgL_nsz00_17093, ((long) 3), BgL_cz00_14700);
								VECTOR_SET(BgL_nsz00_17093, ((long) 4), BgL_dz00_14701);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17094;

									BgL_z12denvz12_17094 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17094, BgL_nsz00_17093);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17095;

										BgL_ez00_17095 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17095,
											BgL_sz00_17086);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17096;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17097;

												BgL_savedzd2bpzd2_17097 =
													VECTOR_REF(BgL_nsz00_17093, ((long) 0));
												VECTOR_SET(BgL_nsz00_17093, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17099;

													BgL_fz00_17099 = BgL_runz00_14697;
												BgL_recz00_17098:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17100;

														BgL_rz00_17100 =
															PROCEDURE_ENTRY(BgL_fz00_17099) (BgL_fz00_17099,
															BgL_nsz00_17093, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_28575;

															if (PROCEDUREP(BgL_rz00_17100))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17101;

																	BgL_arg1696z00_17101 =
																		PROCEDURE_ATTR(BgL_rz00_17100);
																	if (STRUCTP(BgL_arg1696z00_17101))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28575 =
																				(STRUCT_KEY(BgL_arg1696z00_17101) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28575 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_28575 = ((bool_t) 0);
																}
															if (BgL_testz00_28575)
																{
																	obj_t BgL_fz00_28583;

																	BgL_fz00_28583 = BgL_rz00_17100;
																	BgL_fz00_17099 = BgL_fz00_28583;
																	goto BgL_recz00_17098;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17093, ((long) 0),
																		BgL_savedzd2bpzd2_17097);
																	BgL_____rz00_17096 = BgL_rz00_17100;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17095);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17094, BgL_sz00_17086);
											return BgL_____rz00_17096;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5704 */
	obj_t BGl_z62run5704z62zz__evaluate_compz00(obj_t BgL_envz00_14702,
		obj_t BgL_sz00_14707)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14703;
				obj_t BgL_valza2za2_14704;
				BgL_ev_absz00_bglt BgL_i1246z00_14705;
				obj_t BgL_bodyz00_14706;

				BgL_siza7eza7_14703 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14702, (int) (((long) 0))));
				BgL_valza2za2_14704 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14702, (int) (((long) 1))));
				BgL_i1246z00_14705 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14702, (int) (((long) 2))));
				BgL_bodyz00_14706 = PROCEDURE_REF(BgL_envz00_14702, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17102;

					BgL_bpz00_17102 = VECTOR_REF(((obj_t) BgL_sz00_14707), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14707,
						BgL_valza2za2_14704,
						((long) CINT(BgL_bpz00_17102) + BgL_siza7eza7_14703));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17103;
						obj_t BgL_wherez00_17104;
						obj_t BgL_locz00_17105;

						BgL_z12denvz12_17103 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17104 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14705))->
							BgL_wherez00);
						BgL_locz00_17105 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14705))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17103, BgL_wherez00_17104,
								BgL_locz00_17105);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17106;

								BgL_za2za2resza2za2z00_17106 =
									PROCEDURE_ENTRY(BgL_bodyz00_14706) (BgL_bodyz00_14706,
									BgL_sz00_14707, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17103);
								return BgL_za2za2resza2za2z00_17106;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3728> */
	obj_t BGl_z62zc3anonymousza33728ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14708, obj_t BgL_sz00_14715)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14709;
				obj_t BgL_iboxesz00_14710;
				long BgL_siza7eza7_14711;
				BgL_ev_absz00_bglt BgL_i1246z00_14712;
				obj_t BgL_bodyz00_14713;
				long BgL_siza7ezd2framez75_14714;

				BgL_ifreesz00_14709 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 0))));
				BgL_iboxesz00_14710 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 1))));
				BgL_siza7eza7_14711 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 2))));
				BgL_i1246z00_14712 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 3))));
				BgL_bodyz00_14713 = PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14714 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14708, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17107;

					BgL_bpz00_17107 = VECTOR_REF(((obj_t) BgL_sz00_14715), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17108;

						BgL_valza2za2_17108 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14715,
							BgL_bpz00_17107, BgL_ifreesz00_14709);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17109;

							BgL_runz00_17109 =
								MAKE_FX_PROCEDURE(BGl_z62run5706z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17109,
								(int) (((long) 0)), BgL_iboxesz00_14710);
							PROCEDURE_SET(BgL_runz00_17109,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14711));
							PROCEDURE_SET(BgL_runz00_17109,
								(int) (((long) 2)), BgL_valza2za2_17108);
							PROCEDURE_SET(BgL_runz00_17109,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14712));
							PROCEDURE_SET(BgL_runz00_17109,
								(int) (((long) 4)), BgL_bodyz00_14713);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17110;

								BgL_mainz00_17110 =
									MAKE_FX_PROCEDURE(BGl_z62main5705z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 0)), BgL_iboxesz00_14710);
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14711));
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 2)), BgL_valza2za2_17108);
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14712));
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 4)), BgL_bodyz00_14713);
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 5)), BgL_runz00_17109);
								PROCEDURE_SET(BgL_mainz00_17110,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14714));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17111;

									BgL_objz00_17111 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17109, BgL_objz00_17111);
									BgL_objz00_17111;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3729z00_17112;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3730z00_17113;

										BgL_arg3730z00_17113 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14712))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17114;

											BgL_newz00_17114 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28671;

												BgL_tmpz00_28671 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17114, BgL_tmpz00_28671,
													BgL_arg3730z00_17113);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28676;
												int BgL_tmpz00_28674;

												BgL_auxz00_28676 = BINT(BgL_siza7ezd2framez75_14714);
												BgL_tmpz00_28674 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17114, BgL_tmpz00_28674,
													BgL_auxz00_28676);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28679;

												BgL_tmpz00_28679 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17114, BgL_tmpz00_28679,
													BgL_runz00_17109);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28684;
												int BgL_tmpz00_28682;

												BgL_auxz00_28684 = BINT(((long) 3));
												BgL_tmpz00_28682 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17114, BgL_tmpz00_28682,
													BgL_auxz00_28684);
											}
											BgL_arg3729z00_17112 = BgL_newz00_17114;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17110, BgL_arg3729z00_17112);
									BgL_arg3729z00_17112;
								}
								return BgL_mainz00_17110;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5705 */
	obj_t BGl_z62main5705z62zz__evaluate_compz00(obj_t BgL_envz00_14716,
		obj_t BgL_bz00_14724, obj_t BgL_cz00_14725, obj_t BgL_dz00_14726)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14722;
				long BgL_siza7ezd2framez75_14723;

				BgL_runz00_14722 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14716, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14723 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14716, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17115;

					BgL_sz00_17115 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17116;

						BgL_bpz00_17116 = VECTOR_REF(((obj_t) BgL_sz00_17115), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17116) + BgL_siza7ezd2framez75_14723) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17115))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3733z00_17117;

									BgL_arg3733z00_17117 =
										((long) CINT(BgL_bpz00_17116) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17115), BgL_arg3733z00_17117,
										BgL_bz00_14724);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3734z00_17118;

									BgL_arg3734z00_17118 =
										((long) CINT(BgL_bpz00_17116) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17115), BgL_arg3734z00_17118,
										BgL_cz00_14725);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3735z00_17119;

									BgL_arg3735z00_17119 =
										((long) CINT(BgL_bpz00_17116) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17115), BgL_arg3735z00_17119,
										BgL_dz00_14726);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17120;

									BgL_ez00_17120 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17120,
										BgL_bpz00_17116);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17121;

										BgL_accz00_17121 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14722, BgL_sz00_17115, BgL_bpz00_17116);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17120);
										VECTOR_SET(
											((obj_t) BgL_sz00_17115), ((long) 0), BgL_bpz00_17116);
										return BgL_accz00_17121;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17122;

								BgL_nsz00_17122 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17122, ((long) 1), BgL_sz00_17115);
								VECTOR_SET(BgL_nsz00_17122, ((long) 2), BgL_bz00_14724);
								VECTOR_SET(BgL_nsz00_17122, ((long) 3), BgL_cz00_14725);
								VECTOR_SET(BgL_nsz00_17122, ((long) 4), BgL_dz00_14726);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17123;

									BgL_z12denvz12_17123 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17123, BgL_nsz00_17122);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17124;

										BgL_ez00_17124 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17124,
											BgL_sz00_17115);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17125;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17126;

												BgL_savedzd2bpzd2_17126 =
													VECTOR_REF(BgL_nsz00_17122, ((long) 0));
												VECTOR_SET(BgL_nsz00_17122, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17128;

													BgL_fz00_17128 = BgL_runz00_14722;
												BgL_recz00_17127:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17129;

														BgL_rz00_17129 =
															PROCEDURE_ENTRY(BgL_fz00_17128) (BgL_fz00_17128,
															BgL_nsz00_17122, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_28737;

															if (PROCEDUREP(BgL_rz00_17129))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17130;

																	BgL_arg1696z00_17130 =
																		PROCEDURE_ATTR(BgL_rz00_17129);
																	if (STRUCTP(BgL_arg1696z00_17130))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28737 =
																				(STRUCT_KEY(BgL_arg1696z00_17130) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28737 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_28737 = ((bool_t) 0);
																}
															if (BgL_testz00_28737)
																{
																	obj_t BgL_fz00_28745;

																	BgL_fz00_28745 = BgL_rz00_17129;
																	BgL_fz00_17128 = BgL_fz00_28745;
																	goto BgL_recz00_17127;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17122, ((long) 0),
																		BgL_savedzd2bpzd2_17126);
																	BgL_____rz00_17125 = BgL_rz00_17129;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17124);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17123, BgL_sz00_17115);
											return BgL_____rz00_17125;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5706 */
	obj_t BGl_z62run5706z62zz__evaluate_compz00(obj_t BgL_envz00_14727,
		obj_t BgL_sz00_14733)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14728;
				long BgL_siza7eza7_14729;
				obj_t BgL_valza2za2_14730;
				BgL_ev_absz00_bglt BgL_i1246z00_14731;
				obj_t BgL_bodyz00_14732;

				BgL_iboxesz00_14728 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 0))));
				BgL_siza7eza7_14729 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 1))));
				BgL_valza2za2_14730 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 2))));
				BgL_i1246z00_14731 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 3))));
				BgL_bodyz00_14732 = PROCEDURE_REF(BgL_envz00_14727, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17131;

					BgL_bpz00_17131 = VECTOR_REF(((obj_t) BgL_sz00_14733), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14733,
						BgL_iboxesz00_14728, BgL_bpz00_17131);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14733,
						BgL_valza2za2_14730,
						((long) CINT(BgL_bpz00_17131) + BgL_siza7eza7_14729));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17132;
						obj_t BgL_wherez00_17133;
						obj_t BgL_locz00_17134;

						BgL_z12denvz12_17132 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17133 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14731))->
							BgL_wherez00);
						BgL_locz00_17134 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14731))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17132, BgL_wherez00_17133,
								BgL_locz00_17134);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17135;

								BgL_za2za2resza2za2z00_17135 =
									PROCEDURE_ENTRY(BgL_bodyz00_14732) (BgL_bodyz00_14732,
									BgL_sz00_14733, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17132);
								return BgL_za2za2resza2za2z00_17135;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3638> */
	obj_t BGl_z62zc3anonymousza33638ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14734, obj_t BgL_sz00_14738)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14735;
				obj_t BgL_bodyz00_14736;
				long BgL_siza7ezd2framez75_14737;

				BgL_i1246z00_14735 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14734, (int) (((long) 0))));
				BgL_bodyz00_14736 = PROCEDURE_REF(BgL_envz00_14734, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14737 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14734, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17136;

					BgL_bpz00_17136 = VECTOR_REF(((obj_t) BgL_sz00_14738), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17137;

							BgL_runz00_17137 =
								MAKE_FX_PROCEDURE(BGl_z62run5708z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17137,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14735));
							PROCEDURE_SET(BgL_runz00_17137,
								(int) (((long) 1)), BgL_bodyz00_14736);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17138;

								BgL_mainz00_17138 =
									MAKE_VA_PROCEDURE(BGl_z62main5707z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17138,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14735));
								PROCEDURE_SET(BgL_mainz00_17138,
									(int) (((long) 1)), BgL_bodyz00_14736);
								PROCEDURE_SET(BgL_mainz00_17138,
									(int) (((long) 2)), BgL_runz00_17137);
								PROCEDURE_SET(BgL_mainz00_17138,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14737));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17139;

									BgL_objz00_17139 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17137, BgL_objz00_17139);
									BgL_objz00_17139;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3639z00_17140;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3640z00_17141;

										BgL_arg3640z00_17141 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14735))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17142;

											BgL_newz00_17142 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28813;

												BgL_tmpz00_28813 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17142, BgL_tmpz00_28813,
													BgL_arg3640z00_17141);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28818;
												int BgL_tmpz00_28816;

												BgL_auxz00_28818 = BINT(BgL_siza7ezd2framez75_14737);
												BgL_tmpz00_28816 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17142, BgL_tmpz00_28816,
													BgL_auxz00_28818);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28821;

												BgL_tmpz00_28821 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17142, BgL_tmpz00_28821,
													BgL_runz00_17137);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28826;
												int BgL_tmpz00_28824;

												BgL_auxz00_28826 = BINT(((long) -3));
												BgL_tmpz00_28824 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17142, BgL_tmpz00_28824,
													BgL_auxz00_28826);
											}
											BgL_arg3639z00_17140 = BgL_newz00_17142;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17138, BgL_arg3639z00_17140);
									BgL_arg3639z00_17140;
								}
								return BgL_mainz00_17138;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5707 */
	obj_t BGl_z62main5707z62zz__evaluate_compz00(obj_t BgL_envz00_14739,
		obj_t BgL_cz00_14744, obj_t BgL_dz00_14745, obj_t BgL_lastz00_14746)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14742;
				long BgL_siza7ezd2framez75_14743;

				BgL_runz00_14742 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14739, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14743 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14739, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17143;

					BgL_sz00_17143 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17144;

						BgL_bpz00_17144 = VECTOR_REF(((obj_t) BgL_sz00_17143), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17144) + BgL_siza7ezd2framez75_14743) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17143))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3643z00_17145;

									BgL_arg3643z00_17145 =
										((long) CINT(BgL_bpz00_17144) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17143), BgL_arg3643z00_17145,
										BgL_cz00_14744);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3645z00_17146;

									BgL_arg3645z00_17146 =
										((long) CINT(BgL_bpz00_17144) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17143), BgL_arg3645z00_17146,
										BgL_dz00_14745);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3646z00_17147;

									BgL_arg3646z00_17147 =
										((long) CINT(BgL_bpz00_17144) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17143), BgL_arg3646z00_17147,
										BgL_lastz00_14746);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17148;

									BgL_ez00_17148 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17148,
										BgL_bpz00_17144);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17149;

										BgL_accz00_17149 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14742, BgL_sz00_17143, BgL_bpz00_17144);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17148);
										VECTOR_SET(
											((obj_t) BgL_sz00_17143), ((long) 0), BgL_bpz00_17144);
										return BgL_accz00_17149;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17150;

								BgL_nsz00_17150 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17150, ((long) 1), BgL_sz00_17143);
								VECTOR_SET(BgL_nsz00_17150, ((long) 2), BgL_cz00_14744);
								VECTOR_SET(BgL_nsz00_17150, ((long) 3), BgL_dz00_14745);
								VECTOR_SET(BgL_nsz00_17150, ((long) 4), BgL_lastz00_14746);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17151;

									BgL_z12denvz12_17151 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17151, BgL_nsz00_17150);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17152;

										BgL_ez00_17152 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17152,
											BgL_sz00_17143);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17153;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17154;

												BgL_savedzd2bpzd2_17154 =
													VECTOR_REF(BgL_nsz00_17150, ((long) 0));
												VECTOR_SET(BgL_nsz00_17150, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17156;

													BgL_fz00_17156 = BgL_runz00_14742;
												BgL_recz00_17155:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17157;

														BgL_rz00_17157 =
															PROCEDURE_ENTRY(BgL_fz00_17156) (BgL_fz00_17156,
															BgL_nsz00_17150, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_28879;

															if (PROCEDUREP(BgL_rz00_17157))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17158;

																	BgL_arg1696z00_17158 =
																		PROCEDURE_ATTR(BgL_rz00_17157);
																	if (STRUCTP(BgL_arg1696z00_17158))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28879 =
																				(STRUCT_KEY(BgL_arg1696z00_17158) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_28879 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_28879 = ((bool_t) 0);
																}
															if (BgL_testz00_28879)
																{
																	obj_t BgL_fz00_28887;

																	BgL_fz00_28887 = BgL_rz00_17157;
																	BgL_fz00_17156 = BgL_fz00_28887;
																	goto BgL_recz00_17155;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17150, ((long) 0),
																		BgL_savedzd2bpzd2_17154);
																	BgL_____rz00_17153 = BgL_rz00_17157;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17152);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17151, BgL_sz00_17143);
											return BgL_____rz00_17153;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5708 */
	obj_t BGl_z62run5708z62zz__evaluate_compz00(obj_t BgL_envz00_14747,
		obj_t BgL_sz00_14750)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14748;
				obj_t BgL_bodyz00_14749;

				BgL_i1246z00_14748 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 0))));
				BgL_bodyz00_14749 = PROCEDURE_REF(BgL_envz00_14747, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17159;

					BgL_bpz00_17159 = VECTOR_REF(((obj_t) BgL_sz00_14750), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17160;
						obj_t BgL_wherez00_17161;
						obj_t BgL_locz00_17162;

						BgL_z12denvz12_17160 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17161 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14748))->
							BgL_wherez00);
						BgL_locz00_17162 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14748))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17160, BgL_wherez00_17161,
								BgL_locz00_17162);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17163;

								BgL_za2za2resza2za2z00_17163 =
									PROCEDURE_ENTRY(BgL_bodyz00_14749) (BgL_bodyz00_14749,
									BgL_sz00_14750, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17160);
								return BgL_za2za2resza2za2z00_17163;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3648> */
	obj_t BGl_z62zc3anonymousza33648ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14751, obj_t BgL_sz00_14756)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14752;
				BgL_ev_absz00_bglt BgL_i1246z00_14753;
				obj_t BgL_bodyz00_14754;
				long BgL_siza7ezd2framez75_14755;

				BgL_iboxesz00_14752 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14751, (int) (((long) 0))));
				BgL_i1246z00_14753 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14751, (int) (((long) 1))));
				BgL_bodyz00_14754 = PROCEDURE_REF(BgL_envz00_14751, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14755 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14751, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17164;

					BgL_bpz00_17164 = VECTOR_REF(((obj_t) BgL_sz00_14756), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17165;

							BgL_runz00_17165 =
								MAKE_FX_PROCEDURE(BGl_z62run5710z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17165,
								(int) (((long) 0)), BgL_iboxesz00_14752);
							PROCEDURE_SET(BgL_runz00_17165,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14753));
							PROCEDURE_SET(BgL_runz00_17165,
								(int) (((long) 2)), BgL_bodyz00_14754);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17166;

								BgL_mainz00_17166 =
									MAKE_VA_PROCEDURE(BGl_z62main5709z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17166,
									(int) (((long) 0)), BgL_iboxesz00_14752);
								PROCEDURE_SET(BgL_mainz00_17166,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14753));
								PROCEDURE_SET(BgL_mainz00_17166,
									(int) (((long) 2)), BgL_bodyz00_14754);
								PROCEDURE_SET(BgL_mainz00_17166,
									(int) (((long) 3)), BgL_runz00_17165);
								PROCEDURE_SET(BgL_mainz00_17166,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14755));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17167;

									BgL_objz00_17167 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17165, BgL_objz00_17167);
									BgL_objz00_17167;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3649z00_17168;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3651z00_17169;

										BgL_arg3651z00_17169 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14753))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17170;

											BgL_newz00_17170 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28949;

												BgL_tmpz00_28949 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17170, BgL_tmpz00_28949,
													BgL_arg3651z00_17169);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28954;
												int BgL_tmpz00_28952;

												BgL_auxz00_28954 = BINT(BgL_siza7ezd2framez75_14755);
												BgL_tmpz00_28952 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17170, BgL_tmpz00_28952,
													BgL_auxz00_28954);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_28957;

												BgL_tmpz00_28957 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17170, BgL_tmpz00_28957,
													BgL_runz00_17165);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_28962;
												int BgL_tmpz00_28960;

												BgL_auxz00_28962 = BINT(((long) -3));
												BgL_tmpz00_28960 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17170, BgL_tmpz00_28960,
													BgL_auxz00_28962);
											}
											BgL_arg3649z00_17168 = BgL_newz00_17170;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17166, BgL_arg3649z00_17168);
									BgL_arg3649z00_17168;
								}
								return BgL_mainz00_17166;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5709 */
	obj_t BGl_z62main5709z62zz__evaluate_compz00(obj_t BgL_envz00_14757,
		obj_t BgL_cz00_14763, obj_t BgL_dz00_14764, obj_t BgL_lastz00_14765)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14761;
				long BgL_siza7ezd2framez75_14762;

				BgL_runz00_14761 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14757, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14762 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14757, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17171;

					BgL_sz00_17171 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17172;

						BgL_bpz00_17172 = VECTOR_REF(((obj_t) BgL_sz00_17171), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17172) + BgL_siza7ezd2framez75_14762) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17171))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3654z00_17173;

									BgL_arg3654z00_17173 =
										((long) CINT(BgL_bpz00_17172) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17171), BgL_arg3654z00_17173,
										BgL_cz00_14763);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3655z00_17174;

									BgL_arg3655z00_17174 =
										((long) CINT(BgL_bpz00_17172) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17171), BgL_arg3655z00_17174,
										BgL_dz00_14764);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3656z00_17175;

									BgL_arg3656z00_17175 =
										((long) CINT(BgL_bpz00_17172) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17171), BgL_arg3656z00_17175,
										BgL_lastz00_14765);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17176;

									BgL_ez00_17176 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17176,
										BgL_bpz00_17172);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17177;

										BgL_accz00_17177 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14761, BgL_sz00_17171, BgL_bpz00_17172);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17176);
										VECTOR_SET(
											((obj_t) BgL_sz00_17171), ((long) 0), BgL_bpz00_17172);
										return BgL_accz00_17177;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17178;

								BgL_nsz00_17178 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17178, ((long) 1), BgL_sz00_17171);
								VECTOR_SET(BgL_nsz00_17178, ((long) 2), BgL_cz00_14763);
								VECTOR_SET(BgL_nsz00_17178, ((long) 3), BgL_dz00_14764);
								VECTOR_SET(BgL_nsz00_17178, ((long) 4), BgL_lastz00_14765);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17179;

									BgL_z12denvz12_17179 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17179, BgL_nsz00_17178);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17180;

										BgL_ez00_17180 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17180,
											BgL_sz00_17171);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17181;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17182;

												BgL_savedzd2bpzd2_17182 =
													VECTOR_REF(BgL_nsz00_17178, ((long) 0));
												VECTOR_SET(BgL_nsz00_17178, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17184;

													BgL_fz00_17184 = BgL_runz00_14761;
												BgL_recz00_17183:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17185;

														BgL_rz00_17185 =
															PROCEDURE_ENTRY(BgL_fz00_17184) (BgL_fz00_17184,
															BgL_nsz00_17178, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29015;

															if (PROCEDUREP(BgL_rz00_17185))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17186;

																	BgL_arg1696z00_17186 =
																		PROCEDURE_ATTR(BgL_rz00_17185);
																	if (STRUCTP(BgL_arg1696z00_17186))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29015 =
																				(STRUCT_KEY(BgL_arg1696z00_17186) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29015 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29015 = ((bool_t) 0);
																}
															if (BgL_testz00_29015)
																{
																	obj_t BgL_fz00_29023;

																	BgL_fz00_29023 = BgL_rz00_17185;
																	BgL_fz00_17184 = BgL_fz00_29023;
																	goto BgL_recz00_17183;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17178, ((long) 0),
																		BgL_savedzd2bpzd2_17182);
																	BgL_____rz00_17181 = BgL_rz00_17185;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17180);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17179, BgL_sz00_17171);
											return BgL_____rz00_17181;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5710 */
	obj_t BGl_z62run5710z62zz__evaluate_compz00(obj_t BgL_envz00_14766,
		obj_t BgL_sz00_14770)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14767;
				BgL_ev_absz00_bglt BgL_i1246z00_14768;
				obj_t BgL_bodyz00_14769;

				BgL_iboxesz00_14767 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14766, (int) (((long) 0))));
				BgL_i1246z00_14768 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14766, (int) (((long) 1))));
				BgL_bodyz00_14769 = PROCEDURE_REF(BgL_envz00_14766, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17187;

					BgL_bpz00_17187 = VECTOR_REF(((obj_t) BgL_sz00_14770), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14770,
						BgL_iboxesz00_14767, BgL_bpz00_17187);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17188;
						obj_t BgL_wherez00_17189;
						obj_t BgL_locz00_17190;

						BgL_z12denvz12_17188 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17189 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14768))->
							BgL_wherez00);
						BgL_locz00_17190 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14768))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17188, BgL_wherez00_17189,
								BgL_locz00_17190);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17191;

								BgL_za2za2resza2za2z00_17191 =
									PROCEDURE_ENTRY(BgL_bodyz00_14769) (BgL_bodyz00_14769,
									BgL_sz00_14770, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17188);
								return BgL_za2za2resza2za2z00_17191;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3663> */
	obj_t BGl_z62zc3anonymousza33663ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14771, obj_t BgL_sz00_14777)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14772;
				long BgL_siza7eza7_14773;
				BgL_ev_absz00_bglt BgL_i1246z00_14774;
				obj_t BgL_bodyz00_14775;
				long BgL_siza7ezd2framez75_14776;

				BgL_ifreesz00_14772 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14771, (int) (((long) 0))));
				BgL_siza7eza7_14773 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14771, (int) (((long) 1))));
				BgL_i1246z00_14774 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14771, (int) (((long) 2))));
				BgL_bodyz00_14775 = PROCEDURE_REF(BgL_envz00_14771, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14776 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14771, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17192;

					BgL_bpz00_17192 = VECTOR_REF(((obj_t) BgL_sz00_14777), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17193;

						BgL_valza2za2_17193 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14777,
							BgL_bpz00_17192, BgL_ifreesz00_14772);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17194;

							BgL_runz00_17194 =
								MAKE_FX_PROCEDURE(BGl_z62run5712z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17194,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14773));
							PROCEDURE_SET(BgL_runz00_17194,
								(int) (((long) 1)), BgL_valza2za2_17193);
							PROCEDURE_SET(BgL_runz00_17194,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14774));
							PROCEDURE_SET(BgL_runz00_17194,
								(int) (((long) 3)), BgL_bodyz00_14775);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17195;

								BgL_mainz00_17195 =
									MAKE_VA_PROCEDURE(BGl_z62main5711z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17195,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14773));
								PROCEDURE_SET(BgL_mainz00_17195,
									(int) (((long) 1)), BgL_valza2za2_17193);
								PROCEDURE_SET(BgL_mainz00_17195,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14774));
								PROCEDURE_SET(BgL_mainz00_17195,
									(int) (((long) 3)), BgL_bodyz00_14775);
								PROCEDURE_SET(BgL_mainz00_17195,
									(int) (((long) 4)), BgL_runz00_17194);
								PROCEDURE_SET(BgL_mainz00_17195,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14776));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17196;

									BgL_objz00_17196 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17194, BgL_objz00_17196);
									BgL_objz00_17196;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3664z00_17197;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3665z00_17198;

										BgL_arg3665z00_17198 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14774))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17199;

											BgL_newz00_17199 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29099;

												BgL_tmpz00_29099 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17199, BgL_tmpz00_29099,
													BgL_arg3665z00_17198);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29104;
												int BgL_tmpz00_29102;

												BgL_auxz00_29104 = BINT(BgL_siza7ezd2framez75_14776);
												BgL_tmpz00_29102 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17199, BgL_tmpz00_29102,
													BgL_auxz00_29104);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29107;

												BgL_tmpz00_29107 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17199, BgL_tmpz00_29107,
													BgL_runz00_17194);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29112;
												int BgL_tmpz00_29110;

												BgL_auxz00_29112 = BINT(((long) -3));
												BgL_tmpz00_29110 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17199, BgL_tmpz00_29110,
													BgL_auxz00_29112);
											}
											BgL_arg3664z00_17197 = BgL_newz00_17199;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17195, BgL_arg3664z00_17197);
									BgL_arg3664z00_17197;
								}
								return BgL_mainz00_17195;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5711 */
	obj_t BGl_z62main5711z62zz__evaluate_compz00(obj_t BgL_envz00_14778,
		obj_t BgL_cz00_14785, obj_t BgL_dz00_14786, obj_t BgL_lastz00_14787)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14783;
				long BgL_siza7ezd2framez75_14784;

				BgL_runz00_14783 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14778, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14784 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14778, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17200;

					BgL_sz00_17200 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17201;

						BgL_bpz00_17201 = VECTOR_REF(((obj_t) BgL_sz00_17200), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17201) + BgL_siza7ezd2framez75_14784) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17200))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3669z00_17202;

									BgL_arg3669z00_17202 =
										((long) CINT(BgL_bpz00_17201) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17200), BgL_arg3669z00_17202,
										BgL_cz00_14785);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3671z00_17203;

									BgL_arg3671z00_17203 =
										((long) CINT(BgL_bpz00_17201) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17200), BgL_arg3671z00_17203,
										BgL_dz00_14786);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3672z00_17204;

									BgL_arg3672z00_17204 =
										((long) CINT(BgL_bpz00_17201) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17200), BgL_arg3672z00_17204,
										BgL_lastz00_14787);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17205;

									BgL_ez00_17205 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17205,
										BgL_bpz00_17201);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17206;

										BgL_accz00_17206 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14783, BgL_sz00_17200, BgL_bpz00_17201);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17205);
										VECTOR_SET(
											((obj_t) BgL_sz00_17200), ((long) 0), BgL_bpz00_17201);
										return BgL_accz00_17206;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17207;

								BgL_nsz00_17207 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17207, ((long) 1), BgL_sz00_17200);
								VECTOR_SET(BgL_nsz00_17207, ((long) 2), BgL_cz00_14785);
								VECTOR_SET(BgL_nsz00_17207, ((long) 3), BgL_dz00_14786);
								VECTOR_SET(BgL_nsz00_17207, ((long) 4), BgL_lastz00_14787);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17208;

									BgL_z12denvz12_17208 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17208, BgL_nsz00_17207);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17209;

										BgL_ez00_17209 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17209,
											BgL_sz00_17200);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17210;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17211;

												BgL_savedzd2bpzd2_17211 =
													VECTOR_REF(BgL_nsz00_17207, ((long) 0));
												VECTOR_SET(BgL_nsz00_17207, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17213;

													BgL_fz00_17213 = BgL_runz00_14783;
												BgL_recz00_17212:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17214;

														BgL_rz00_17214 =
															PROCEDURE_ENTRY(BgL_fz00_17213) (BgL_fz00_17213,
															BgL_nsz00_17207, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29165;

															if (PROCEDUREP(BgL_rz00_17214))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17215;

																	BgL_arg1696z00_17215 =
																		PROCEDURE_ATTR(BgL_rz00_17214);
																	if (STRUCTP(BgL_arg1696z00_17215))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29165 =
																				(STRUCT_KEY(BgL_arg1696z00_17215) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29165 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29165 = ((bool_t) 0);
																}
															if (BgL_testz00_29165)
																{
																	obj_t BgL_fz00_29173;

																	BgL_fz00_29173 = BgL_rz00_17214;
																	BgL_fz00_17213 = BgL_fz00_29173;
																	goto BgL_recz00_17212;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17207, ((long) 0),
																		BgL_savedzd2bpzd2_17211);
																	BgL_____rz00_17210 = BgL_rz00_17214;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17209);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17208, BgL_sz00_17200);
											return BgL_____rz00_17210;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5712 */
	obj_t BGl_z62run5712z62zz__evaluate_compz00(obj_t BgL_envz00_14788,
		obj_t BgL_sz00_14793)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14789;
				obj_t BgL_valza2za2_14790;
				BgL_ev_absz00_bglt BgL_i1246z00_14791;
				obj_t BgL_bodyz00_14792;

				BgL_siza7eza7_14789 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14788, (int) (((long) 0))));
				BgL_valza2za2_14790 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14788, (int) (((long) 1))));
				BgL_i1246z00_14791 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14788, (int) (((long) 2))));
				BgL_bodyz00_14792 = PROCEDURE_REF(BgL_envz00_14788, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17216;

					BgL_bpz00_17216 = VECTOR_REF(((obj_t) BgL_sz00_14793), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14793,
						BgL_valza2za2_14790,
						((long) CINT(BgL_bpz00_17216) + BgL_siza7eza7_14789));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17217;
						obj_t BgL_wherez00_17218;
						obj_t BgL_locz00_17219;

						BgL_z12denvz12_17217 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17218 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14791))->
							BgL_wherez00);
						BgL_locz00_17219 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14791))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17217, BgL_wherez00_17218,
								BgL_locz00_17219);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17220;

								BgL_za2za2resza2za2z00_17220 =
									PROCEDURE_ENTRY(BgL_bodyz00_14792) (BgL_bodyz00_14792,
									BgL_sz00_14793, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17217);
								return BgL_za2za2resza2za2z00_17220;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3675> */
	obj_t BGl_z62zc3anonymousza33675ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14794, obj_t BgL_sz00_14801)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14795;
				obj_t BgL_iboxesz00_14796;
				long BgL_siza7eza7_14797;
				BgL_ev_absz00_bglt BgL_i1246z00_14798;
				obj_t BgL_bodyz00_14799;
				long BgL_siza7ezd2framez75_14800;

				BgL_ifreesz00_14795 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 0))));
				BgL_iboxesz00_14796 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 1))));
				BgL_siza7eza7_14797 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 2))));
				BgL_i1246z00_14798 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 3))));
				BgL_bodyz00_14799 = PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14800 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14794, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17221;

					BgL_bpz00_17221 = VECTOR_REF(((obj_t) BgL_sz00_14801), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17222;

						BgL_valza2za2_17222 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14801,
							BgL_bpz00_17221, BgL_ifreesz00_14795);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17223;

							BgL_runz00_17223 =
								MAKE_FX_PROCEDURE(BGl_z62run5714z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17223,
								(int) (((long) 0)), BgL_iboxesz00_14796);
							PROCEDURE_SET(BgL_runz00_17223,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14797));
							PROCEDURE_SET(BgL_runz00_17223,
								(int) (((long) 2)), BgL_valza2za2_17222);
							PROCEDURE_SET(BgL_runz00_17223,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14798));
							PROCEDURE_SET(BgL_runz00_17223,
								(int) (((long) 4)), BgL_bodyz00_14799);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17224;

								BgL_mainz00_17224 =
									MAKE_VA_PROCEDURE(BGl_z62main5713z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 0)), BgL_iboxesz00_14796);
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14797));
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 2)), BgL_valza2za2_17222);
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14798));
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 4)), BgL_bodyz00_14799);
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 5)), BgL_runz00_17223);
								PROCEDURE_SET(BgL_mainz00_17224,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14800));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17225;

									BgL_objz00_17225 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17223, BgL_objz00_17225);
									BgL_objz00_17225;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3676z00_17226;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3678z00_17227;

										BgL_arg3678z00_17227 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14798))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17228;

											BgL_newz00_17228 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29261;

												BgL_tmpz00_29261 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17228, BgL_tmpz00_29261,
													BgL_arg3678z00_17227);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29266;
												int BgL_tmpz00_29264;

												BgL_auxz00_29266 = BINT(BgL_siza7ezd2framez75_14800);
												BgL_tmpz00_29264 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17228, BgL_tmpz00_29264,
													BgL_auxz00_29266);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29269;

												BgL_tmpz00_29269 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17228, BgL_tmpz00_29269,
													BgL_runz00_17223);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29274;
												int BgL_tmpz00_29272;

												BgL_auxz00_29274 = BINT(((long) -3));
												BgL_tmpz00_29272 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17228, BgL_tmpz00_29272,
													BgL_auxz00_29274);
											}
											BgL_arg3676z00_17226 = BgL_newz00_17228;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17224, BgL_arg3676z00_17226);
									BgL_arg3676z00_17226;
								}
								return BgL_mainz00_17224;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5713 */
	obj_t BGl_z62main5713z62zz__evaluate_compz00(obj_t BgL_envz00_14802,
		obj_t BgL_cz00_14810, obj_t BgL_dz00_14811, obj_t BgL_lastz00_14812)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14808;
				long BgL_siza7ezd2framez75_14809;

				BgL_runz00_14808 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14802, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14809 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14802, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17229;

					BgL_sz00_17229 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17230;

						BgL_bpz00_17230 = VECTOR_REF(((obj_t) BgL_sz00_17229), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17230) + BgL_siza7ezd2framez75_14809) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17229))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3681z00_17231;

									BgL_arg3681z00_17231 =
										((long) CINT(BgL_bpz00_17230) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17229), BgL_arg3681z00_17231,
										BgL_cz00_14810);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3682z00_17232;

									BgL_arg3682z00_17232 =
										((long) CINT(BgL_bpz00_17230) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17229), BgL_arg3682z00_17232,
										BgL_dz00_14811);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3683z00_17233;

									BgL_arg3683z00_17233 =
										((long) CINT(BgL_bpz00_17230) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17229), BgL_arg3683z00_17233,
										BgL_lastz00_14812);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17234;

									BgL_ez00_17234 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17234,
										BgL_bpz00_17230);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17235;

										BgL_accz00_17235 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14808, BgL_sz00_17229, BgL_bpz00_17230);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17234);
										VECTOR_SET(
											((obj_t) BgL_sz00_17229), ((long) 0), BgL_bpz00_17230);
										return BgL_accz00_17235;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17236;

								BgL_nsz00_17236 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17236, ((long) 1), BgL_sz00_17229);
								VECTOR_SET(BgL_nsz00_17236, ((long) 2), BgL_cz00_14810);
								VECTOR_SET(BgL_nsz00_17236, ((long) 3), BgL_dz00_14811);
								VECTOR_SET(BgL_nsz00_17236, ((long) 4), BgL_lastz00_14812);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17237;

									BgL_z12denvz12_17237 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17237, BgL_nsz00_17236);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17238;

										BgL_ez00_17238 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17238,
											BgL_sz00_17229);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17239;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17240;

												BgL_savedzd2bpzd2_17240 =
													VECTOR_REF(BgL_nsz00_17236, ((long) 0));
												VECTOR_SET(BgL_nsz00_17236, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17242;

													BgL_fz00_17242 = BgL_runz00_14808;
												BgL_recz00_17241:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17243;

														BgL_rz00_17243 =
															PROCEDURE_ENTRY(BgL_fz00_17242) (BgL_fz00_17242,
															BgL_nsz00_17236, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29327;

															if (PROCEDUREP(BgL_rz00_17243))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17244;

																	BgL_arg1696z00_17244 =
																		PROCEDURE_ATTR(BgL_rz00_17243);
																	if (STRUCTP(BgL_arg1696z00_17244))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29327 =
																				(STRUCT_KEY(BgL_arg1696z00_17244) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29327 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29327 = ((bool_t) 0);
																}
															if (BgL_testz00_29327)
																{
																	obj_t BgL_fz00_29335;

																	BgL_fz00_29335 = BgL_rz00_17243;
																	BgL_fz00_17242 = BgL_fz00_29335;
																	goto BgL_recz00_17241;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17236, ((long) 0),
																		BgL_savedzd2bpzd2_17240);
																	BgL_____rz00_17239 = BgL_rz00_17243;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17238);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17237, BgL_sz00_17229);
											return BgL_____rz00_17239;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5714 */
	obj_t BGl_z62run5714z62zz__evaluate_compz00(obj_t BgL_envz00_14813,
		obj_t BgL_sz00_14819)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14814;
				long BgL_siza7eza7_14815;
				obj_t BgL_valza2za2_14816;
				BgL_ev_absz00_bglt BgL_i1246z00_14817;
				obj_t BgL_bodyz00_14818;

				BgL_iboxesz00_14814 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14813, (int) (((long) 0))));
				BgL_siza7eza7_14815 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14813, (int) (((long) 1))));
				BgL_valza2za2_14816 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14813, (int) (((long) 2))));
				BgL_i1246z00_14817 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14813, (int) (((long) 3))));
				BgL_bodyz00_14818 = PROCEDURE_REF(BgL_envz00_14813, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17245;

					BgL_bpz00_17245 = VECTOR_REF(((obj_t) BgL_sz00_14819), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14819,
						BgL_iboxesz00_14814, BgL_bpz00_17245);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14819,
						BgL_valza2za2_14816,
						((long) CINT(BgL_bpz00_17245) + BgL_siza7eza7_14815));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17246;
						obj_t BgL_wherez00_17247;
						obj_t BgL_locz00_17248;

						BgL_z12denvz12_17246 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17247 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14817))->
							BgL_wherez00);
						BgL_locz00_17248 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14817))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17246, BgL_wherez00_17247,
								BgL_locz00_17248);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17249;

								BgL_za2za2resza2za2z00_17249 =
									PROCEDURE_ENTRY(BgL_bodyz00_14818) (BgL_bodyz00_14818,
									BgL_sz00_14819, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17246);
								return BgL_za2za2resza2za2z00_17249;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3591> */
	obj_t BGl_z62zc3anonymousza33591ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14820, obj_t BgL_sz00_14824)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14821;
				obj_t BgL_bodyz00_14822;
				long BgL_siza7ezd2framez75_14823;

				BgL_i1246z00_14821 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14820, (int) (((long) 0))));
				BgL_bodyz00_14822 = PROCEDURE_REF(BgL_envz00_14820, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14823 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14820, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17250;

					BgL_bpz00_17250 = VECTOR_REF(((obj_t) BgL_sz00_14824), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17251;

							BgL_runz00_17251 =
								MAKE_FX_PROCEDURE(BGl_z62run5716z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17251,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14821));
							PROCEDURE_SET(BgL_runz00_17251,
								(int) (((long) 1)), BgL_bodyz00_14822);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17252;

								BgL_mainz00_17252 =
									MAKE_FX_PROCEDURE(BGl_z62main5715z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17252,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14821));
								PROCEDURE_SET(BgL_mainz00_17252,
									(int) (((long) 1)), BgL_bodyz00_14822);
								PROCEDURE_SET(BgL_mainz00_17252,
									(int) (((long) 2)), BgL_runz00_17251);
								PROCEDURE_SET(BgL_mainz00_17252,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14823));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17253;

									BgL_objz00_17253 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17251, BgL_objz00_17253);
									BgL_objz00_17253;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3592z00_17254;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3593z00_17255;

										BgL_arg3593z00_17255 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14821))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17256;

											BgL_newz00_17256 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29403;

												BgL_tmpz00_29403 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17256, BgL_tmpz00_29403,
													BgL_arg3593z00_17255);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29408;
												int BgL_tmpz00_29406;

												BgL_auxz00_29408 = BINT(BgL_siza7ezd2framez75_14823);
												BgL_tmpz00_29406 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17256, BgL_tmpz00_29406,
													BgL_auxz00_29408);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29411;

												BgL_tmpz00_29411 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17256, BgL_tmpz00_29411,
													BgL_runz00_17251);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29416;
												int BgL_tmpz00_29414;

												BgL_auxz00_29416 = BINT(((long) 2));
												BgL_tmpz00_29414 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17256, BgL_tmpz00_29414,
													BgL_auxz00_29416);
											}
											BgL_arg3592z00_17254 = BgL_newz00_17256;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17252, BgL_arg3592z00_17254);
									BgL_arg3592z00_17254;
								}
								return BgL_mainz00_17252;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5715 */
	obj_t BGl_z62main5715z62zz__evaluate_compz00(obj_t BgL_envz00_14825,
		obj_t BgL_cz00_14830, obj_t BgL_dz00_14831)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14828;
				long BgL_siza7ezd2framez75_14829;

				BgL_runz00_14828 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14825, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14829 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14825, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17257;

					BgL_sz00_17257 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17258;

						BgL_bpz00_17258 = VECTOR_REF(((obj_t) BgL_sz00_17257), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17258) + BgL_siza7ezd2framez75_14829) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17257))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3596z00_17259;

									BgL_arg3596z00_17259 =
										((long) CINT(BgL_bpz00_17258) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17257), BgL_arg3596z00_17259,
										BgL_cz00_14830);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3597z00_17260;

									BgL_arg3597z00_17260 =
										((long) CINT(BgL_bpz00_17258) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17257), BgL_arg3597z00_17260,
										BgL_dz00_14831);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17261;

									BgL_ez00_17261 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17261,
										BgL_bpz00_17258);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17262;

										BgL_accz00_17262 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14828, BgL_sz00_17257, BgL_bpz00_17258);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17261);
										VECTOR_SET(
											((obj_t) BgL_sz00_17257), ((long) 0), BgL_bpz00_17258);
										return BgL_accz00_17262;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17263;

								BgL_nsz00_17263 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17263, ((long) 1), BgL_sz00_17257);
								VECTOR_SET(BgL_nsz00_17263, ((long) 2), BgL_cz00_14830);
								VECTOR_SET(BgL_nsz00_17263, ((long) 3), BgL_dz00_14831);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17264;

									BgL_z12denvz12_17264 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17264, BgL_nsz00_17263);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17265;

										BgL_ez00_17265 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17265,
											BgL_sz00_17257);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17266;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17267;

												BgL_savedzd2bpzd2_17267 =
													VECTOR_REF(BgL_nsz00_17263, ((long) 0));
												VECTOR_SET(BgL_nsz00_17263, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17269;

													BgL_fz00_17269 = BgL_runz00_14828;
												BgL_recz00_17268:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17270;

														BgL_rz00_17270 =
															PROCEDURE_ENTRY(BgL_fz00_17269) (BgL_fz00_17269,
															BgL_nsz00_17263, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29464;

															if (PROCEDUREP(BgL_rz00_17270))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17271;

																	BgL_arg1696z00_17271 =
																		PROCEDURE_ATTR(BgL_rz00_17270);
																	if (STRUCTP(BgL_arg1696z00_17271))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29464 =
																				(STRUCT_KEY(BgL_arg1696z00_17271) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29464 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29464 = ((bool_t) 0);
																}
															if (BgL_testz00_29464)
																{
																	obj_t BgL_fz00_29472;

																	BgL_fz00_29472 = BgL_rz00_17270;
																	BgL_fz00_17269 = BgL_fz00_29472;
																	goto BgL_recz00_17268;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17263, ((long) 0),
																		BgL_savedzd2bpzd2_17267);
																	BgL_____rz00_17266 = BgL_rz00_17270;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17265);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17264, BgL_sz00_17257);
											return BgL_____rz00_17266;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5716 */
	obj_t BGl_z62run5716z62zz__evaluate_compz00(obj_t BgL_envz00_14832,
		obj_t BgL_sz00_14835)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14833;
				obj_t BgL_bodyz00_14834;

				BgL_i1246z00_14833 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14832, (int) (((long) 0))));
				BgL_bodyz00_14834 = PROCEDURE_REF(BgL_envz00_14832, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17272;

					BgL_bpz00_17272 = VECTOR_REF(((obj_t) BgL_sz00_14835), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17273;
						obj_t BgL_wherez00_17274;
						obj_t BgL_locz00_17275;

						BgL_z12denvz12_17273 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17274 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14833))->
							BgL_wherez00);
						BgL_locz00_17275 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14833))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17273, BgL_wherez00_17274,
								BgL_locz00_17275);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17276;

								BgL_za2za2resza2za2z00_17276 =
									PROCEDURE_ENTRY(BgL_bodyz00_14834) (BgL_bodyz00_14834,
									BgL_sz00_14835, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17273);
								return BgL_za2za2resza2za2z00_17276;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3599> */
	obj_t BGl_z62zc3anonymousza33599ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14836, obj_t BgL_sz00_14841)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14837;
				BgL_ev_absz00_bglt BgL_i1246z00_14838;
				obj_t BgL_bodyz00_14839;
				long BgL_siza7ezd2framez75_14840;

				BgL_iboxesz00_14837 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14836, (int) (((long) 0))));
				BgL_i1246z00_14838 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14836, (int) (((long) 1))));
				BgL_bodyz00_14839 = PROCEDURE_REF(BgL_envz00_14836, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14840 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14836, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17277;

					BgL_bpz00_17277 = VECTOR_REF(((obj_t) BgL_sz00_14841), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17278;

							BgL_runz00_17278 =
								MAKE_FX_PROCEDURE(BGl_z62run5718z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17278,
								(int) (((long) 0)), BgL_iboxesz00_14837);
							PROCEDURE_SET(BgL_runz00_17278,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14838));
							PROCEDURE_SET(BgL_runz00_17278,
								(int) (((long) 2)), BgL_bodyz00_14839);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17279;

								BgL_mainz00_17279 =
									MAKE_FX_PROCEDURE(BGl_z62main5717z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17279,
									(int) (((long) 0)), BgL_iboxesz00_14837);
								PROCEDURE_SET(BgL_mainz00_17279,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14838));
								PROCEDURE_SET(BgL_mainz00_17279,
									(int) (((long) 2)), BgL_bodyz00_14839);
								PROCEDURE_SET(BgL_mainz00_17279,
									(int) (((long) 3)), BgL_runz00_17278);
								PROCEDURE_SET(BgL_mainz00_17279,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14840));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17280;

									BgL_objz00_17280 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17278, BgL_objz00_17280);
									BgL_objz00_17280;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3600z00_17281;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3602z00_17282;

										BgL_arg3602z00_17282 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14838))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17283;

											BgL_newz00_17283 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29534;

												BgL_tmpz00_29534 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17283, BgL_tmpz00_29534,
													BgL_arg3602z00_17282);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29539;
												int BgL_tmpz00_29537;

												BgL_auxz00_29539 = BINT(BgL_siza7ezd2framez75_14840);
												BgL_tmpz00_29537 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17283, BgL_tmpz00_29537,
													BgL_auxz00_29539);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29542;

												BgL_tmpz00_29542 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17283, BgL_tmpz00_29542,
													BgL_runz00_17278);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29547;
												int BgL_tmpz00_29545;

												BgL_auxz00_29547 = BINT(((long) 2));
												BgL_tmpz00_29545 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17283, BgL_tmpz00_29545,
													BgL_auxz00_29547);
											}
											BgL_arg3600z00_17281 = BgL_newz00_17283;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17279, BgL_arg3600z00_17281);
									BgL_arg3600z00_17281;
								}
								return BgL_mainz00_17279;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5717 */
	obj_t BGl_z62main5717z62zz__evaluate_compz00(obj_t BgL_envz00_14842,
		obj_t BgL_cz00_14848, obj_t BgL_dz00_14849)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14846;
				long BgL_siza7ezd2framez75_14847;

				BgL_runz00_14846 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14842, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14847 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14842, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17284;

					BgL_sz00_17284 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17285;

						BgL_bpz00_17285 = VECTOR_REF(((obj_t) BgL_sz00_17284), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17285) + BgL_siza7ezd2framez75_14847) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17284))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3606z00_17286;

									BgL_arg3606z00_17286 =
										((long) CINT(BgL_bpz00_17285) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17284), BgL_arg3606z00_17286,
										BgL_cz00_14848);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3607z00_17287;

									BgL_arg3607z00_17287 =
										((long) CINT(BgL_bpz00_17285) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17284), BgL_arg3607z00_17287,
										BgL_dz00_14849);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17288;

									BgL_ez00_17288 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17288,
										BgL_bpz00_17285);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17289;

										BgL_accz00_17289 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14846, BgL_sz00_17284, BgL_bpz00_17285);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17288);
										VECTOR_SET(
											((obj_t) BgL_sz00_17284), ((long) 0), BgL_bpz00_17285);
										return BgL_accz00_17289;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17290;

								BgL_nsz00_17290 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17290, ((long) 1), BgL_sz00_17284);
								VECTOR_SET(BgL_nsz00_17290, ((long) 2), BgL_cz00_14848);
								VECTOR_SET(BgL_nsz00_17290, ((long) 3), BgL_dz00_14849);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17291;

									BgL_z12denvz12_17291 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17291, BgL_nsz00_17290);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17292;

										BgL_ez00_17292 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17292,
											BgL_sz00_17284);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17293;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17294;

												BgL_savedzd2bpzd2_17294 =
													VECTOR_REF(BgL_nsz00_17290, ((long) 0));
												VECTOR_SET(BgL_nsz00_17290, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17296;

													BgL_fz00_17296 = BgL_runz00_14846;
												BgL_recz00_17295:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17297;

														BgL_rz00_17297 =
															PROCEDURE_ENTRY(BgL_fz00_17296) (BgL_fz00_17296,
															BgL_nsz00_17290, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29595;

															if (PROCEDUREP(BgL_rz00_17297))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17298;

																	BgL_arg1696z00_17298 =
																		PROCEDURE_ATTR(BgL_rz00_17297);
																	if (STRUCTP(BgL_arg1696z00_17298))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29595 =
																				(STRUCT_KEY(BgL_arg1696z00_17298) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29595 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29595 = ((bool_t) 0);
																}
															if (BgL_testz00_29595)
																{
																	obj_t BgL_fz00_29603;

																	BgL_fz00_29603 = BgL_rz00_17297;
																	BgL_fz00_17296 = BgL_fz00_29603;
																	goto BgL_recz00_17295;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17290, ((long) 0),
																		BgL_savedzd2bpzd2_17294);
																	BgL_____rz00_17293 = BgL_rz00_17297;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17292);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17291, BgL_sz00_17284);
											return BgL_____rz00_17293;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5718 */
	obj_t BGl_z62run5718z62zz__evaluate_compz00(obj_t BgL_envz00_14850,
		obj_t BgL_sz00_14854)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14851;
				BgL_ev_absz00_bglt BgL_i1246z00_14852;
				obj_t BgL_bodyz00_14853;

				BgL_iboxesz00_14851 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14850, (int) (((long) 0))));
				BgL_i1246z00_14852 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14850, (int) (((long) 1))));
				BgL_bodyz00_14853 = PROCEDURE_REF(BgL_envz00_14850, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17299;

					BgL_bpz00_17299 = VECTOR_REF(((obj_t) BgL_sz00_14854), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14854,
						BgL_iboxesz00_14851, BgL_bpz00_17299);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17300;
						obj_t BgL_wherez00_17301;
						obj_t BgL_locz00_17302;

						BgL_z12denvz12_17300 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17301 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14852))->
							BgL_wherez00);
						BgL_locz00_17302 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14852))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17300, BgL_wherez00_17301,
								BgL_locz00_17302);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17303;

								BgL_za2za2resza2za2z00_17303 =
									PROCEDURE_ENTRY(BgL_bodyz00_14853) (BgL_bodyz00_14853,
									BgL_sz00_14854, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17300);
								return BgL_za2za2resza2za2z00_17303;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3612> */
	obj_t BGl_z62zc3anonymousza33612ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14855, obj_t BgL_sz00_14861)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14856;
				long BgL_siza7eza7_14857;
				BgL_ev_absz00_bglt BgL_i1246z00_14858;
				obj_t BgL_bodyz00_14859;
				long BgL_siza7ezd2framez75_14860;

				BgL_ifreesz00_14856 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14855, (int) (((long) 0))));
				BgL_siza7eza7_14857 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14855, (int) (((long) 1))));
				BgL_i1246z00_14858 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14855, (int) (((long) 2))));
				BgL_bodyz00_14859 = PROCEDURE_REF(BgL_envz00_14855, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14860 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14855, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17304;

					BgL_bpz00_17304 = VECTOR_REF(((obj_t) BgL_sz00_14861), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17305;

						BgL_valza2za2_17305 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14861,
							BgL_bpz00_17304, BgL_ifreesz00_14856);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17306;

							BgL_runz00_17306 =
								MAKE_FX_PROCEDURE(BGl_z62run5720z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17306,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14857));
							PROCEDURE_SET(BgL_runz00_17306,
								(int) (((long) 1)), BgL_valza2za2_17305);
							PROCEDURE_SET(BgL_runz00_17306,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14858));
							PROCEDURE_SET(BgL_runz00_17306,
								(int) (((long) 3)), BgL_bodyz00_14859);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17307;

								BgL_mainz00_17307 =
									MAKE_FX_PROCEDURE(BGl_z62main5719z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17307,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14857));
								PROCEDURE_SET(BgL_mainz00_17307,
									(int) (((long) 1)), BgL_valza2za2_17305);
								PROCEDURE_SET(BgL_mainz00_17307,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14858));
								PROCEDURE_SET(BgL_mainz00_17307,
									(int) (((long) 3)), BgL_bodyz00_14859);
								PROCEDURE_SET(BgL_mainz00_17307,
									(int) (((long) 4)), BgL_runz00_17306);
								PROCEDURE_SET(BgL_mainz00_17307,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14860));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17308;

									BgL_objz00_17308 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17306, BgL_objz00_17308);
									BgL_objz00_17308;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3613z00_17309;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3614z00_17310;

										BgL_arg3614z00_17310 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14858))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17311;

											BgL_newz00_17311 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29679;

												BgL_tmpz00_29679 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17311, BgL_tmpz00_29679,
													BgL_arg3614z00_17310);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29684;
												int BgL_tmpz00_29682;

												BgL_auxz00_29684 = BINT(BgL_siza7ezd2framez75_14860);
												BgL_tmpz00_29682 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17311, BgL_tmpz00_29682,
													BgL_auxz00_29684);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29687;

												BgL_tmpz00_29687 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17311, BgL_tmpz00_29687,
													BgL_runz00_17306);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29692;
												int BgL_tmpz00_29690;

												BgL_auxz00_29692 = BINT(((long) 2));
												BgL_tmpz00_29690 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17311, BgL_tmpz00_29690,
													BgL_auxz00_29692);
											}
											BgL_arg3613z00_17309 = BgL_newz00_17311;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17307, BgL_arg3613z00_17309);
									BgL_arg3613z00_17309;
								}
								return BgL_mainz00_17307;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5719 */
	obj_t BGl_z62main5719z62zz__evaluate_compz00(obj_t BgL_envz00_14862,
		obj_t BgL_cz00_14869, obj_t BgL_dz00_14870)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14867;
				long BgL_siza7ezd2framez75_14868;

				BgL_runz00_14867 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14862, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14868 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14862, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17312;

					BgL_sz00_17312 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17313;

						BgL_bpz00_17313 = VECTOR_REF(((obj_t) BgL_sz00_17312), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17313) + BgL_siza7ezd2framez75_14868) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17312))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3617z00_17314;

									BgL_arg3617z00_17314 =
										((long) CINT(BgL_bpz00_17313) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17312), BgL_arg3617z00_17314,
										BgL_cz00_14869);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3618z00_17315;

									BgL_arg3618z00_17315 =
										((long) CINT(BgL_bpz00_17313) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17312), BgL_arg3618z00_17315,
										BgL_dz00_14870);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17316;

									BgL_ez00_17316 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17316,
										BgL_bpz00_17313);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17317;

										BgL_accz00_17317 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14867, BgL_sz00_17312, BgL_bpz00_17313);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17316);
										VECTOR_SET(
											((obj_t) BgL_sz00_17312), ((long) 0), BgL_bpz00_17313);
										return BgL_accz00_17317;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17318;

								BgL_nsz00_17318 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17318, ((long) 1), BgL_sz00_17312);
								VECTOR_SET(BgL_nsz00_17318, ((long) 2), BgL_cz00_14869);
								VECTOR_SET(BgL_nsz00_17318, ((long) 3), BgL_dz00_14870);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17319;

									BgL_z12denvz12_17319 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17319, BgL_nsz00_17318);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17320;

										BgL_ez00_17320 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17320,
											BgL_sz00_17312);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17321;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17322;

												BgL_savedzd2bpzd2_17322 =
													VECTOR_REF(BgL_nsz00_17318, ((long) 0));
												VECTOR_SET(BgL_nsz00_17318, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17324;

													BgL_fz00_17324 = BgL_runz00_14867;
												BgL_recz00_17323:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17325;

														BgL_rz00_17325 =
															PROCEDURE_ENTRY(BgL_fz00_17324) (BgL_fz00_17324,
															BgL_nsz00_17318, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29740;

															if (PROCEDUREP(BgL_rz00_17325))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17326;

																	BgL_arg1696z00_17326 =
																		PROCEDURE_ATTR(BgL_rz00_17325);
																	if (STRUCTP(BgL_arg1696z00_17326))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29740 =
																				(STRUCT_KEY(BgL_arg1696z00_17326) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29740 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29740 = ((bool_t) 0);
																}
															if (BgL_testz00_29740)
																{
																	obj_t BgL_fz00_29748;

																	BgL_fz00_29748 = BgL_rz00_17325;
																	BgL_fz00_17324 = BgL_fz00_29748;
																	goto BgL_recz00_17323;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17318, ((long) 0),
																		BgL_savedzd2bpzd2_17322);
																	BgL_____rz00_17321 = BgL_rz00_17325;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17320);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17319, BgL_sz00_17312);
											return BgL_____rz00_17321;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5720 */
	obj_t BGl_z62run5720z62zz__evaluate_compz00(obj_t BgL_envz00_14871,
		obj_t BgL_sz00_14876)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14872;
				obj_t BgL_valza2za2_14873;
				BgL_ev_absz00_bglt BgL_i1246z00_14874;
				obj_t BgL_bodyz00_14875;

				BgL_siza7eza7_14872 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 0))));
				BgL_valza2za2_14873 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 1))));
				BgL_i1246z00_14874 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 2))));
				BgL_bodyz00_14875 = PROCEDURE_REF(BgL_envz00_14871, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17327;

					BgL_bpz00_17327 = VECTOR_REF(((obj_t) BgL_sz00_14876), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14876,
						BgL_valza2za2_14873,
						((long) CINT(BgL_bpz00_17327) + BgL_siza7eza7_14872));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17328;
						obj_t BgL_wherez00_17329;
						obj_t BgL_locz00_17330;

						BgL_z12denvz12_17328 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17329 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14874))->
							BgL_wherez00);
						BgL_locz00_17330 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14874))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17328, BgL_wherez00_17329,
								BgL_locz00_17330);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17331;

								BgL_za2za2resza2za2z00_17331 =
									PROCEDURE_ENTRY(BgL_bodyz00_14875) (BgL_bodyz00_14875,
									BgL_sz00_14876, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17328);
								return BgL_za2za2resza2za2z00_17331;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3621> */
	obj_t BGl_z62zc3anonymousza33621ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14877, obj_t BgL_sz00_14884)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14878;
				obj_t BgL_iboxesz00_14879;
				long BgL_siza7eza7_14880;
				BgL_ev_absz00_bglt BgL_i1246z00_14881;
				obj_t BgL_bodyz00_14882;
				long BgL_siza7ezd2framez75_14883;

				BgL_ifreesz00_14878 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 0))));
				BgL_iboxesz00_14879 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 1))));
				BgL_siza7eza7_14880 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 2))));
				BgL_i1246z00_14881 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 3))));
				BgL_bodyz00_14882 = PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14883 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14877, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17332;

					BgL_bpz00_17332 = VECTOR_REF(((obj_t) BgL_sz00_14884), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17333;

						BgL_valza2za2_17333 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14884,
							BgL_bpz00_17332, BgL_ifreesz00_14878);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17334;

							BgL_runz00_17334 =
								MAKE_FX_PROCEDURE(BGl_z62run5722z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17334,
								(int) (((long) 0)), BgL_iboxesz00_14879);
							PROCEDURE_SET(BgL_runz00_17334,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14880));
							PROCEDURE_SET(BgL_runz00_17334,
								(int) (((long) 2)), BgL_valza2za2_17333);
							PROCEDURE_SET(BgL_runz00_17334,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14881));
							PROCEDURE_SET(BgL_runz00_17334,
								(int) (((long) 4)), BgL_bodyz00_14882);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17335;

								BgL_mainz00_17335 =
									MAKE_FX_PROCEDURE(BGl_z62main5721z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 0)), BgL_iboxesz00_14879);
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14880));
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 2)), BgL_valza2za2_17333);
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14881));
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 4)), BgL_bodyz00_14882);
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 5)), BgL_runz00_17334);
								PROCEDURE_SET(BgL_mainz00_17335,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14883));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17336;

									BgL_objz00_17336 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17334, BgL_objz00_17336);
									BgL_objz00_17336;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3622z00_17337;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3623z00_17338;

										BgL_arg3623z00_17338 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14881))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17339;

											BgL_newz00_17339 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29836;

												BgL_tmpz00_29836 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17339, BgL_tmpz00_29836,
													BgL_arg3623z00_17338);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29841;
												int BgL_tmpz00_29839;

												BgL_auxz00_29841 = BINT(BgL_siza7ezd2framez75_14883);
												BgL_tmpz00_29839 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17339, BgL_tmpz00_29839,
													BgL_auxz00_29841);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29844;

												BgL_tmpz00_29844 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17339, BgL_tmpz00_29844,
													BgL_runz00_17334);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29849;
												int BgL_tmpz00_29847;

												BgL_auxz00_29849 = BINT(((long) 2));
												BgL_tmpz00_29847 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17339, BgL_tmpz00_29847,
													BgL_auxz00_29849);
											}
											BgL_arg3622z00_17337 = BgL_newz00_17339;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17335, BgL_arg3622z00_17337);
									BgL_arg3622z00_17337;
								}
								return BgL_mainz00_17335;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5721 */
	obj_t BGl_z62main5721z62zz__evaluate_compz00(obj_t BgL_envz00_14885,
		obj_t BgL_cz00_14893, obj_t BgL_dz00_14894)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14891;
				long BgL_siza7ezd2framez75_14892;

				BgL_runz00_14891 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14885, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14892 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14885, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17340;

					BgL_sz00_17340 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17341;

						BgL_bpz00_17341 = VECTOR_REF(((obj_t) BgL_sz00_17340), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17341) + BgL_siza7ezd2framez75_14892) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17340))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3626z00_17342;

									BgL_arg3626z00_17342 =
										((long) CINT(BgL_bpz00_17341) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17340), BgL_arg3626z00_17342,
										BgL_cz00_14893);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3627z00_17343;

									BgL_arg3627z00_17343 =
										((long) CINT(BgL_bpz00_17341) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17340), BgL_arg3627z00_17343,
										BgL_dz00_14894);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17344;

									BgL_ez00_17344 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17344,
										BgL_bpz00_17341);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17345;

										BgL_accz00_17345 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14891, BgL_sz00_17340, BgL_bpz00_17341);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17344);
										VECTOR_SET(
											((obj_t) BgL_sz00_17340), ((long) 0), BgL_bpz00_17341);
										return BgL_accz00_17345;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17346;

								BgL_nsz00_17346 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17346, ((long) 1), BgL_sz00_17340);
								VECTOR_SET(BgL_nsz00_17346, ((long) 2), BgL_cz00_14893);
								VECTOR_SET(BgL_nsz00_17346, ((long) 3), BgL_dz00_14894);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17347;

									BgL_z12denvz12_17347 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17347, BgL_nsz00_17346);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17348;

										BgL_ez00_17348 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17348,
											BgL_sz00_17340);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17349;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17350;

												BgL_savedzd2bpzd2_17350 =
													VECTOR_REF(BgL_nsz00_17346, ((long) 0));
												VECTOR_SET(BgL_nsz00_17346, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17352;

													BgL_fz00_17352 = BgL_runz00_14891;
												BgL_recz00_17351:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17353;

														BgL_rz00_17353 =
															PROCEDURE_ENTRY(BgL_fz00_17352) (BgL_fz00_17352,
															BgL_nsz00_17346, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_29897;

															if (PROCEDUREP(BgL_rz00_17353))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17354;

																	BgL_arg1696z00_17354 =
																		PROCEDURE_ATTR(BgL_rz00_17353);
																	if (STRUCTP(BgL_arg1696z00_17354))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29897 =
																				(STRUCT_KEY(BgL_arg1696z00_17354) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_29897 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_29897 = ((bool_t) 0);
																}
															if (BgL_testz00_29897)
																{
																	obj_t BgL_fz00_29905;

																	BgL_fz00_29905 = BgL_rz00_17353;
																	BgL_fz00_17352 = BgL_fz00_29905;
																	goto BgL_recz00_17351;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17346, ((long) 0),
																		BgL_savedzd2bpzd2_17350);
																	BgL_____rz00_17349 = BgL_rz00_17353;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17348);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17347, BgL_sz00_17340);
											return BgL_____rz00_17349;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5722 */
	obj_t BGl_z62run5722z62zz__evaluate_compz00(obj_t BgL_envz00_14895,
		obj_t BgL_sz00_14901)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14896;
				long BgL_siza7eza7_14897;
				obj_t BgL_valza2za2_14898;
				BgL_ev_absz00_bglt BgL_i1246z00_14899;
				obj_t BgL_bodyz00_14900;

				BgL_iboxesz00_14896 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14895, (int) (((long) 0))));
				BgL_siza7eza7_14897 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14895, (int) (((long) 1))));
				BgL_valza2za2_14898 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14895, (int) (((long) 2))));
				BgL_i1246z00_14899 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14895, (int) (((long) 3))));
				BgL_bodyz00_14900 = PROCEDURE_REF(BgL_envz00_14895, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17355;

					BgL_bpz00_17355 = VECTOR_REF(((obj_t) BgL_sz00_14901), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14901,
						BgL_iboxesz00_14896, BgL_bpz00_17355);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14901,
						BgL_valza2za2_14898,
						((long) CINT(BgL_bpz00_17355) + BgL_siza7eza7_14897));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17356;
						obj_t BgL_wherez00_17357;
						obj_t BgL_locz00_17358;

						BgL_z12denvz12_17356 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17357 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14899))->
							BgL_wherez00);
						BgL_locz00_17358 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14899))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17356, BgL_wherez00_17357,
								BgL_locz00_17358);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17359;

								BgL_za2za2resza2za2z00_17359 =
									PROCEDURE_ENTRY(BgL_bodyz00_14900) (BgL_bodyz00_14900,
									BgL_sz00_14901, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17356);
								return BgL_za2za2resza2za2z00_17359;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3543> */
	obj_t BGl_z62zc3anonymousza33543ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14902, obj_t BgL_sz00_14906)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14903;
				obj_t BgL_bodyz00_14904;
				long BgL_siza7ezd2framez75_14905;

				BgL_i1246z00_14903 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14902, (int) (((long) 0))));
				BgL_bodyz00_14904 = PROCEDURE_REF(BgL_envz00_14902, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14905 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14902, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17360;

					BgL_bpz00_17360 = VECTOR_REF(((obj_t) BgL_sz00_14906), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17361;

							BgL_runz00_17361 =
								MAKE_FX_PROCEDURE(BGl_z62run5724z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17361,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14903));
							PROCEDURE_SET(BgL_runz00_17361,
								(int) (((long) 1)), BgL_bodyz00_14904);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17362;

								BgL_mainz00_17362 =
									MAKE_VA_PROCEDURE(BGl_z62main5723z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17362,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14903));
								PROCEDURE_SET(BgL_mainz00_17362,
									(int) (((long) 1)), BgL_bodyz00_14904);
								PROCEDURE_SET(BgL_mainz00_17362,
									(int) (((long) 2)), BgL_runz00_17361);
								PROCEDURE_SET(BgL_mainz00_17362,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14905));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17363;

									BgL_objz00_17363 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17361, BgL_objz00_17363);
									BgL_objz00_17363;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3545z00_17364;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3546z00_17365;

										BgL_arg3546z00_17365 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14903))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17366;

											BgL_newz00_17366 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29973;

												BgL_tmpz00_29973 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17366, BgL_tmpz00_29973,
													BgL_arg3546z00_17365);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29978;
												int BgL_tmpz00_29976;

												BgL_auxz00_29978 = BINT(BgL_siza7ezd2framez75_14905);
												BgL_tmpz00_29976 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17366, BgL_tmpz00_29976,
													BgL_auxz00_29978);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_29981;

												BgL_tmpz00_29981 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17366, BgL_tmpz00_29981,
													BgL_runz00_17361);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_29986;
												int BgL_tmpz00_29984;

												BgL_auxz00_29986 = BINT(((long) -2));
												BgL_tmpz00_29984 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17366, BgL_tmpz00_29984,
													BgL_auxz00_29986);
											}
											BgL_arg3545z00_17364 = BgL_newz00_17366;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17362, BgL_arg3545z00_17364);
									BgL_arg3545z00_17364;
								}
								return BgL_mainz00_17362;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5723 */
	obj_t BGl_z62main5723z62zz__evaluate_compz00(obj_t BgL_envz00_14907,
		obj_t BgL_dz00_14912, obj_t BgL_lastz00_14913)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14910;
				long BgL_siza7ezd2framez75_14911;

				BgL_runz00_14910 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14907, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14911 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14907, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17367;

					BgL_sz00_17367 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17368;

						BgL_bpz00_17368 = VECTOR_REF(((obj_t) BgL_sz00_17367), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17368) + BgL_siza7ezd2framez75_14911) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17367))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3549z00_17369;

									BgL_arg3549z00_17369 =
										((long) CINT(BgL_bpz00_17368) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17367), BgL_arg3549z00_17369,
										BgL_dz00_14912);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3550z00_17370;

									BgL_arg3550z00_17370 =
										((long) CINT(BgL_bpz00_17368) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17367), BgL_arg3550z00_17370,
										BgL_lastz00_14913);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17371;

									BgL_ez00_17371 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17371,
										BgL_bpz00_17368);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17372;

										BgL_accz00_17372 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14910, BgL_sz00_17367, BgL_bpz00_17368);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17371);
										VECTOR_SET(
											((obj_t) BgL_sz00_17367), ((long) 0), BgL_bpz00_17368);
										return BgL_accz00_17372;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17373;

								BgL_nsz00_17373 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17373, ((long) 1), BgL_sz00_17367);
								VECTOR_SET(BgL_nsz00_17373, ((long) 2), BgL_dz00_14912);
								VECTOR_SET(BgL_nsz00_17373, ((long) 3), BgL_lastz00_14913);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17374;

									BgL_z12denvz12_17374 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17374, BgL_nsz00_17373);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17375;

										BgL_ez00_17375 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17375,
											BgL_sz00_17367);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17376;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17377;

												BgL_savedzd2bpzd2_17377 =
													VECTOR_REF(BgL_nsz00_17373, ((long) 0));
												VECTOR_SET(BgL_nsz00_17373, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17379;

													BgL_fz00_17379 = BgL_runz00_14910;
												BgL_recz00_17378:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17380;

														BgL_rz00_17380 =
															PROCEDURE_ENTRY(BgL_fz00_17379) (BgL_fz00_17379,
															BgL_nsz00_17373, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30034;

															if (PROCEDUREP(BgL_rz00_17380))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17381;

																	BgL_arg1696z00_17381 =
																		PROCEDURE_ATTR(BgL_rz00_17380);
																	if (STRUCTP(BgL_arg1696z00_17381))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30034 =
																				(STRUCT_KEY(BgL_arg1696z00_17381) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30034 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30034 = ((bool_t) 0);
																}
															if (BgL_testz00_30034)
																{
																	obj_t BgL_fz00_30042;

																	BgL_fz00_30042 = BgL_rz00_17380;
																	BgL_fz00_17379 = BgL_fz00_30042;
																	goto BgL_recz00_17378;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17373, ((long) 0),
																		BgL_savedzd2bpzd2_17377);
																	BgL_____rz00_17376 = BgL_rz00_17380;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17375);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17374, BgL_sz00_17367);
											return BgL_____rz00_17376;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5724 */
	obj_t BGl_z62run5724z62zz__evaluate_compz00(obj_t BgL_envz00_14914,
		obj_t BgL_sz00_14917)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14915;
				obj_t BgL_bodyz00_14916;

				BgL_i1246z00_14915 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14914, (int) (((long) 0))));
				BgL_bodyz00_14916 = PROCEDURE_REF(BgL_envz00_14914, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17382;

					BgL_bpz00_17382 = VECTOR_REF(((obj_t) BgL_sz00_14917), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17383;
						obj_t BgL_wherez00_17384;
						obj_t BgL_locz00_17385;

						BgL_z12denvz12_17383 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17384 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14915))->
							BgL_wherez00);
						BgL_locz00_17385 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14915))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17383, BgL_wherez00_17384,
								BgL_locz00_17385);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17386;

								BgL_za2za2resza2za2z00_17386 =
									PROCEDURE_ENTRY(BgL_bodyz00_14916) (BgL_bodyz00_14916,
									BgL_sz00_14917, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17383);
								return BgL_za2za2resza2za2z00_17386;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3552> */
	obj_t BGl_z62zc3anonymousza33552ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14918, obj_t BgL_sz00_14923)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14919;
				BgL_ev_absz00_bglt BgL_i1246z00_14920;
				obj_t BgL_bodyz00_14921;
				long BgL_siza7ezd2framez75_14922;

				BgL_iboxesz00_14919 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14918, (int) (((long) 0))));
				BgL_i1246z00_14920 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14918, (int) (((long) 1))));
				BgL_bodyz00_14921 = PROCEDURE_REF(BgL_envz00_14918, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14922 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14918, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17387;

					BgL_bpz00_17387 = VECTOR_REF(((obj_t) BgL_sz00_14923), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17388;

							BgL_runz00_17388 =
								MAKE_FX_PROCEDURE(BGl_z62run5726z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17388,
								(int) (((long) 0)), BgL_iboxesz00_14919);
							PROCEDURE_SET(BgL_runz00_17388,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_14920));
							PROCEDURE_SET(BgL_runz00_17388,
								(int) (((long) 2)), BgL_bodyz00_14921);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17389;

								BgL_mainz00_17389 =
									MAKE_VA_PROCEDURE(BGl_z62main5725z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17389,
									(int) (((long) 0)), BgL_iboxesz00_14919);
								PROCEDURE_SET(BgL_mainz00_17389,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_14920));
								PROCEDURE_SET(BgL_mainz00_17389,
									(int) (((long) 2)), BgL_bodyz00_14921);
								PROCEDURE_SET(BgL_mainz00_17389,
									(int) (((long) 3)), BgL_runz00_17388);
								PROCEDURE_SET(BgL_mainz00_17389,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14922));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17390;

									BgL_objz00_17390 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17388, BgL_objz00_17390);
									BgL_objz00_17390;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3553z00_17391;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3554z00_17392;

										BgL_arg3554z00_17392 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14920))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17393;

											BgL_newz00_17393 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30104;

												BgL_tmpz00_30104 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17393, BgL_tmpz00_30104,
													BgL_arg3554z00_17392);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30109;
												int BgL_tmpz00_30107;

												BgL_auxz00_30109 = BINT(BgL_siza7ezd2framez75_14922);
												BgL_tmpz00_30107 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17393, BgL_tmpz00_30107,
													BgL_auxz00_30109);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30112;

												BgL_tmpz00_30112 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17393, BgL_tmpz00_30112,
													BgL_runz00_17388);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30117;
												int BgL_tmpz00_30115;

												BgL_auxz00_30117 = BINT(((long) -2));
												BgL_tmpz00_30115 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17393, BgL_tmpz00_30115,
													BgL_auxz00_30117);
											}
											BgL_arg3553z00_17391 = BgL_newz00_17393;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17389, BgL_arg3553z00_17391);
									BgL_arg3553z00_17391;
								}
								return BgL_mainz00_17389;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5725 */
	obj_t BGl_z62main5725z62zz__evaluate_compz00(obj_t BgL_envz00_14924,
		obj_t BgL_dz00_14930, obj_t BgL_lastz00_14931)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14928;
				long BgL_siza7ezd2framez75_14929;

				BgL_runz00_14928 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14924, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14929 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14924, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17394;

					BgL_sz00_17394 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17395;

						BgL_bpz00_17395 = VECTOR_REF(((obj_t) BgL_sz00_17394), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17395) + BgL_siza7ezd2framez75_14929) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17394))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3557z00_17396;

									BgL_arg3557z00_17396 =
										((long) CINT(BgL_bpz00_17395) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17394), BgL_arg3557z00_17396,
										BgL_dz00_14930);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3558z00_17397;

									BgL_arg3558z00_17397 =
										((long) CINT(BgL_bpz00_17395) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17394), BgL_arg3558z00_17397,
										BgL_lastz00_14931);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17398;

									BgL_ez00_17398 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17398,
										BgL_bpz00_17395);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17399;

										BgL_accz00_17399 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14928, BgL_sz00_17394, BgL_bpz00_17395);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17398);
										VECTOR_SET(
											((obj_t) BgL_sz00_17394), ((long) 0), BgL_bpz00_17395);
										return BgL_accz00_17399;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17400;

								BgL_nsz00_17400 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17400, ((long) 1), BgL_sz00_17394);
								VECTOR_SET(BgL_nsz00_17400, ((long) 2), BgL_dz00_14930);
								VECTOR_SET(BgL_nsz00_17400, ((long) 3), BgL_lastz00_14931);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17401;

									BgL_z12denvz12_17401 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17401, BgL_nsz00_17400);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17402;

										BgL_ez00_17402 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17402,
											BgL_sz00_17394);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17403;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17404;

												BgL_savedzd2bpzd2_17404 =
													VECTOR_REF(BgL_nsz00_17400, ((long) 0));
												VECTOR_SET(BgL_nsz00_17400, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17406;

													BgL_fz00_17406 = BgL_runz00_14928;
												BgL_recz00_17405:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17407;

														BgL_rz00_17407 =
															PROCEDURE_ENTRY(BgL_fz00_17406) (BgL_fz00_17406,
															BgL_nsz00_17400, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30165;

															if (PROCEDUREP(BgL_rz00_17407))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17408;

																	BgL_arg1696z00_17408 =
																		PROCEDURE_ATTR(BgL_rz00_17407);
																	if (STRUCTP(BgL_arg1696z00_17408))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30165 =
																				(STRUCT_KEY(BgL_arg1696z00_17408) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30165 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30165 = ((bool_t) 0);
																}
															if (BgL_testz00_30165)
																{
																	obj_t BgL_fz00_30173;

																	BgL_fz00_30173 = BgL_rz00_17407;
																	BgL_fz00_17406 = BgL_fz00_30173;
																	goto BgL_recz00_17405;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17400, ((long) 0),
																		BgL_savedzd2bpzd2_17404);
																	BgL_____rz00_17403 = BgL_rz00_17407;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17402);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17401, BgL_sz00_17394);
											return BgL_____rz00_17403;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5726 */
	obj_t BGl_z62run5726z62zz__evaluate_compz00(obj_t BgL_envz00_14932,
		obj_t BgL_sz00_14936)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14933;
				BgL_ev_absz00_bglt BgL_i1246z00_14934;
				obj_t BgL_bodyz00_14935;

				BgL_iboxesz00_14933 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14932, (int) (((long) 0))));
				BgL_i1246z00_14934 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14932, (int) (((long) 1))));
				BgL_bodyz00_14935 = PROCEDURE_REF(BgL_envz00_14932, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17409;

					BgL_bpz00_17409 = VECTOR_REF(((obj_t) BgL_sz00_14936), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14936,
						BgL_iboxesz00_14933, BgL_bpz00_17409);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17410;
						obj_t BgL_wherez00_17411;
						obj_t BgL_locz00_17412;

						BgL_z12denvz12_17410 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17411 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14934))->
							BgL_wherez00);
						BgL_locz00_17412 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14934))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17410, BgL_wherez00_17411,
								BgL_locz00_17412);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17413;

								BgL_za2za2resza2za2z00_17413 =
									PROCEDURE_ENTRY(BgL_bodyz00_14935) (BgL_bodyz00_14935,
									BgL_sz00_14936, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17410);
								return BgL_za2za2resza2za2z00_17413;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3564> */
	obj_t BGl_z62zc3anonymousza33564ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14937, obj_t BgL_sz00_14943)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14938;
				long BgL_siza7eza7_14939;
				BgL_ev_absz00_bglt BgL_i1246z00_14940;
				obj_t BgL_bodyz00_14941;
				long BgL_siza7ezd2framez75_14942;

				BgL_ifreesz00_14938 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14937, (int) (((long) 0))));
				BgL_siza7eza7_14939 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14937, (int) (((long) 1))));
				BgL_i1246z00_14940 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14937, (int) (((long) 2))));
				BgL_bodyz00_14941 = PROCEDURE_REF(BgL_envz00_14937, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14942 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14937, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17414;

					BgL_bpz00_17414 = VECTOR_REF(((obj_t) BgL_sz00_14943), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17415;

						BgL_valza2za2_17415 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14943,
							BgL_bpz00_17414, BgL_ifreesz00_14938);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17416;

							BgL_runz00_17416 =
								MAKE_FX_PROCEDURE(BGl_z62run5728z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17416,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14939));
							PROCEDURE_SET(BgL_runz00_17416,
								(int) (((long) 1)), BgL_valza2za2_17415);
							PROCEDURE_SET(BgL_runz00_17416,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_14940));
							PROCEDURE_SET(BgL_runz00_17416,
								(int) (((long) 3)), BgL_bodyz00_14941);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17417;

								BgL_mainz00_17417 =
									MAKE_VA_PROCEDURE(BGl_z62main5727z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17417,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14939));
								PROCEDURE_SET(BgL_mainz00_17417,
									(int) (((long) 1)), BgL_valza2za2_17415);
								PROCEDURE_SET(BgL_mainz00_17417,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_14940));
								PROCEDURE_SET(BgL_mainz00_17417,
									(int) (((long) 3)), BgL_bodyz00_14941);
								PROCEDURE_SET(BgL_mainz00_17417,
									(int) (((long) 4)), BgL_runz00_17416);
								PROCEDURE_SET(BgL_mainz00_17417,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14942));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17418;

									BgL_objz00_17418 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17416, BgL_objz00_17418);
									BgL_objz00_17418;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3565z00_17419;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3566z00_17420;

										BgL_arg3566z00_17420 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14940))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17421;

											BgL_newz00_17421 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30249;

												BgL_tmpz00_30249 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17421, BgL_tmpz00_30249,
													BgL_arg3566z00_17420);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30254;
												int BgL_tmpz00_30252;

												BgL_auxz00_30254 = BINT(BgL_siza7ezd2framez75_14942);
												BgL_tmpz00_30252 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17421, BgL_tmpz00_30252,
													BgL_auxz00_30254);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30257;

												BgL_tmpz00_30257 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17421, BgL_tmpz00_30257,
													BgL_runz00_17416);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30262;
												int BgL_tmpz00_30260;

												BgL_auxz00_30262 = BINT(((long) -2));
												BgL_tmpz00_30260 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17421, BgL_tmpz00_30260,
													BgL_auxz00_30262);
											}
											BgL_arg3565z00_17419 = BgL_newz00_17421;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17417, BgL_arg3565z00_17419);
									BgL_arg3565z00_17419;
								}
								return BgL_mainz00_17417;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5727 */
	obj_t BGl_z62main5727z62zz__evaluate_compz00(obj_t BgL_envz00_14944,
		obj_t BgL_dz00_14951, obj_t BgL_lastz00_14952)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14949;
				long BgL_siza7ezd2framez75_14950;

				BgL_runz00_14949 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14944, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14950 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14944, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17422;

					BgL_sz00_17422 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17423;

						BgL_bpz00_17423 = VECTOR_REF(((obj_t) BgL_sz00_17422), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17423) + BgL_siza7ezd2framez75_14950) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17422))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3569z00_17424;

									BgL_arg3569z00_17424 =
										((long) CINT(BgL_bpz00_17423) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17422), BgL_arg3569z00_17424,
										BgL_dz00_14951);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3571z00_17425;

									BgL_arg3571z00_17425 =
										((long) CINT(BgL_bpz00_17423) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17422), BgL_arg3571z00_17425,
										BgL_lastz00_14952);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17426;

									BgL_ez00_17426 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17426,
										BgL_bpz00_17423);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17427;

										BgL_accz00_17427 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14949, BgL_sz00_17422, BgL_bpz00_17423);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17426);
										VECTOR_SET(
											((obj_t) BgL_sz00_17422), ((long) 0), BgL_bpz00_17423);
										return BgL_accz00_17427;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17428;

								BgL_nsz00_17428 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17428, ((long) 1), BgL_sz00_17422);
								VECTOR_SET(BgL_nsz00_17428, ((long) 2), BgL_dz00_14951);
								VECTOR_SET(BgL_nsz00_17428, ((long) 3), BgL_lastz00_14952);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17429;

									BgL_z12denvz12_17429 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17429, BgL_nsz00_17428);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17430;

										BgL_ez00_17430 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17430,
											BgL_sz00_17422);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17431;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17432;

												BgL_savedzd2bpzd2_17432 =
													VECTOR_REF(BgL_nsz00_17428, ((long) 0));
												VECTOR_SET(BgL_nsz00_17428, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17434;

													BgL_fz00_17434 = BgL_runz00_14949;
												BgL_recz00_17433:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17435;

														BgL_rz00_17435 =
															PROCEDURE_ENTRY(BgL_fz00_17434) (BgL_fz00_17434,
															BgL_nsz00_17428, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30310;

															if (PROCEDUREP(BgL_rz00_17435))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17436;

																	BgL_arg1696z00_17436 =
																		PROCEDURE_ATTR(BgL_rz00_17435);
																	if (STRUCTP(BgL_arg1696z00_17436))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30310 =
																				(STRUCT_KEY(BgL_arg1696z00_17436) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30310 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30310 = ((bool_t) 0);
																}
															if (BgL_testz00_30310)
																{
																	obj_t BgL_fz00_30318;

																	BgL_fz00_30318 = BgL_rz00_17435;
																	BgL_fz00_17434 = BgL_fz00_30318;
																	goto BgL_recz00_17433;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17428, ((long) 0),
																		BgL_savedzd2bpzd2_17432);
																	BgL_____rz00_17431 = BgL_rz00_17435;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17430);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17429, BgL_sz00_17422);
											return BgL_____rz00_17431;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5728 */
	obj_t BGl_z62run5728z62zz__evaluate_compz00(obj_t BgL_envz00_14953,
		obj_t BgL_sz00_14958)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_14954;
				obj_t BgL_valza2za2_14955;
				BgL_ev_absz00_bglt BgL_i1246z00_14956;
				obj_t BgL_bodyz00_14957;

				BgL_siza7eza7_14954 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 0))));
				BgL_valza2za2_14955 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 1))));
				BgL_i1246z00_14956 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 2))));
				BgL_bodyz00_14957 = PROCEDURE_REF(BgL_envz00_14953, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17437;

					BgL_bpz00_17437 = VECTOR_REF(((obj_t) BgL_sz00_14958), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14958,
						BgL_valza2za2_14955,
						((long) CINT(BgL_bpz00_17437) + BgL_siza7eza7_14954));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17438;
						obj_t BgL_wherez00_17439;
						obj_t BgL_locz00_17440;

						BgL_z12denvz12_17438 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17439 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14956))->
							BgL_wherez00);
						BgL_locz00_17440 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14956))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17438, BgL_wherez00_17439,
								BgL_locz00_17440);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17441;

								BgL_za2za2resza2za2z00_17441 =
									PROCEDURE_ENTRY(BgL_bodyz00_14957) (BgL_bodyz00_14957,
									BgL_sz00_14958, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17438);
								return BgL_za2za2resza2za2z00_17441;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3575> */
	obj_t BGl_z62zc3anonymousza33575ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14959, obj_t BgL_sz00_14966)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_14960;
				obj_t BgL_iboxesz00_14961;
				long BgL_siza7eza7_14962;
				BgL_ev_absz00_bglt BgL_i1246z00_14963;
				obj_t BgL_bodyz00_14964;
				long BgL_siza7ezd2framez75_14965;

				BgL_ifreesz00_14960 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 0))));
				BgL_iboxesz00_14961 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 1))));
				BgL_siza7eza7_14962 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 2))));
				BgL_i1246z00_14963 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 3))));
				BgL_bodyz00_14964 = PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14965 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14959, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17442;

					BgL_bpz00_17442 = VECTOR_REF(((obj_t) BgL_sz00_14966), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17443;

						BgL_valza2za2_17443 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14966,
							BgL_bpz00_17442, BgL_ifreesz00_14960);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17444;

							BgL_runz00_17444 =
								MAKE_FX_PROCEDURE(BGl_z62run5730z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17444,
								(int) (((long) 0)), BgL_iboxesz00_14961);
							PROCEDURE_SET(BgL_runz00_17444,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14962));
							PROCEDURE_SET(BgL_runz00_17444,
								(int) (((long) 2)), BgL_valza2za2_17443);
							PROCEDURE_SET(BgL_runz00_17444,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_14963));
							PROCEDURE_SET(BgL_runz00_17444,
								(int) (((long) 4)), BgL_bodyz00_14964);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17445;

								BgL_mainz00_17445 =
									MAKE_VA_PROCEDURE(BGl_z62main5729z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 0)), BgL_iboxesz00_14961);
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14962));
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 2)), BgL_valza2za2_17443);
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_14963));
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 4)), BgL_bodyz00_14964);
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 5)), BgL_runz00_17444);
								PROCEDURE_SET(BgL_mainz00_17445,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14965));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17446;

									BgL_objz00_17446 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17444, BgL_objz00_17446);
									BgL_objz00_17446;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3576z00_17447;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3577z00_17448;

										BgL_arg3577z00_17448 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14963))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17449;

											BgL_newz00_17449 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30406;

												BgL_tmpz00_30406 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17449, BgL_tmpz00_30406,
													BgL_arg3577z00_17448);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30411;
												int BgL_tmpz00_30409;

												BgL_auxz00_30411 = BINT(BgL_siza7ezd2framez75_14965);
												BgL_tmpz00_30409 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17449, BgL_tmpz00_30409,
													BgL_auxz00_30411);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30414;

												BgL_tmpz00_30414 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17449, BgL_tmpz00_30414,
													BgL_runz00_17444);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30419;
												int BgL_tmpz00_30417;

												BgL_auxz00_30419 = BINT(((long) -2));
												BgL_tmpz00_30417 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17449, BgL_tmpz00_30417,
													BgL_auxz00_30419);
											}
											BgL_arg3576z00_17447 = BgL_newz00_17449;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17445, BgL_arg3576z00_17447);
									BgL_arg3576z00_17447;
								}
								return BgL_mainz00_17445;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5729 */
	obj_t BGl_z62main5729z62zz__evaluate_compz00(obj_t BgL_envz00_14967,
		obj_t BgL_dz00_14975, obj_t BgL_lastz00_14976)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14973;
				long BgL_siza7ezd2framez75_14974;

				BgL_runz00_14973 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14967, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14974 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14967, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17450;

					BgL_sz00_17450 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17451;

						BgL_bpz00_17451 = VECTOR_REF(((obj_t) BgL_sz00_17450), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17451) + BgL_siza7ezd2framez75_14974) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17450))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3580z00_17452;

									BgL_arg3580z00_17452 =
										((long) CINT(BgL_bpz00_17451) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17450), BgL_arg3580z00_17452,
										BgL_dz00_14975);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3581z00_17453;

									BgL_arg3581z00_17453 =
										((long) CINT(BgL_bpz00_17451) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17450), BgL_arg3581z00_17453,
										BgL_lastz00_14976);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17454;

									BgL_ez00_17454 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17454,
										BgL_bpz00_17451);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17455;

										BgL_accz00_17455 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14973, BgL_sz00_17450, BgL_bpz00_17451);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17454);
										VECTOR_SET(
											((obj_t) BgL_sz00_17450), ((long) 0), BgL_bpz00_17451);
										return BgL_accz00_17455;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17456;

								BgL_nsz00_17456 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17456, ((long) 1), BgL_sz00_17450);
								VECTOR_SET(BgL_nsz00_17456, ((long) 2), BgL_dz00_14975);
								VECTOR_SET(BgL_nsz00_17456, ((long) 3), BgL_lastz00_14976);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17457;

									BgL_z12denvz12_17457 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17457, BgL_nsz00_17456);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17458;

										BgL_ez00_17458 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17458,
											BgL_sz00_17450);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17459;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17460;

												BgL_savedzd2bpzd2_17460 =
													VECTOR_REF(BgL_nsz00_17456, ((long) 0));
												VECTOR_SET(BgL_nsz00_17456, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17462;

													BgL_fz00_17462 = BgL_runz00_14973;
												BgL_recz00_17461:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17463;

														BgL_rz00_17463 =
															PROCEDURE_ENTRY(BgL_fz00_17462) (BgL_fz00_17462,
															BgL_nsz00_17456, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30467;

															if (PROCEDUREP(BgL_rz00_17463))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17464;

																	BgL_arg1696z00_17464 =
																		PROCEDURE_ATTR(BgL_rz00_17463);
																	if (STRUCTP(BgL_arg1696z00_17464))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30467 =
																				(STRUCT_KEY(BgL_arg1696z00_17464) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30467 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30467 = ((bool_t) 0);
																}
															if (BgL_testz00_30467)
																{
																	obj_t BgL_fz00_30475;

																	BgL_fz00_30475 = BgL_rz00_17463;
																	BgL_fz00_17462 = BgL_fz00_30475;
																	goto BgL_recz00_17461;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17456, ((long) 0),
																		BgL_savedzd2bpzd2_17460);
																	BgL_____rz00_17459 = BgL_rz00_17463;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17458);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17457, BgL_sz00_17450);
											return BgL_____rz00_17459;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5730 */
	obj_t BGl_z62run5730z62zz__evaluate_compz00(obj_t BgL_envz00_14977,
		obj_t BgL_sz00_14983)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_14978;
				long BgL_siza7eza7_14979;
				obj_t BgL_valza2za2_14980;
				BgL_ev_absz00_bglt BgL_i1246z00_14981;
				obj_t BgL_bodyz00_14982;

				BgL_iboxesz00_14978 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14977, (int) (((long) 0))));
				BgL_siza7eza7_14979 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14977, (int) (((long) 1))));
				BgL_valza2za2_14980 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14977, (int) (((long) 2))));
				BgL_i1246z00_14981 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14977, (int) (((long) 3))));
				BgL_bodyz00_14982 = PROCEDURE_REF(BgL_envz00_14977, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17465;

					BgL_bpz00_17465 = VECTOR_REF(((obj_t) BgL_sz00_14983), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14983,
						BgL_iboxesz00_14978, BgL_bpz00_17465);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14983,
						BgL_valza2za2_14980,
						((long) CINT(BgL_bpz00_17465) + BgL_siza7eza7_14979));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17466;
						obj_t BgL_wherez00_17467;
						obj_t BgL_locz00_17468;

						BgL_z12denvz12_17466 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17467 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14981))->
							BgL_wherez00);
						BgL_locz00_17468 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14981))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17466, BgL_wherez00_17467,
								BgL_locz00_17468);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17469;

								BgL_za2za2resza2za2z00_17469 =
									PROCEDURE_ENTRY(BgL_bodyz00_14982) (BgL_bodyz00_14982,
									BgL_sz00_14983, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17466);
								return BgL_za2za2resza2za2z00_17469;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3502> */
	obj_t BGl_z62zc3anonymousza33502ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14984, obj_t BgL_sz00_14988)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14985;
				obj_t BgL_bodyz00_14986;
				long BgL_siza7ezd2framez75_14987;

				BgL_i1246z00_14985 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14984, (int) (((long) 0))));
				BgL_bodyz00_14986 = PROCEDURE_REF(BgL_envz00_14984, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14987 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14984, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17470;

					BgL_bpz00_17470 = VECTOR_REF(((obj_t) BgL_sz00_14988), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17471;

							BgL_runz00_17471 =
								MAKE_FX_PROCEDURE(BGl_z62run5732z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17471,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_14985));
							PROCEDURE_SET(BgL_runz00_17471,
								(int) (((long) 1)), BgL_bodyz00_14986);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17472;

								BgL_mainz00_17472 =
									MAKE_FX_PROCEDURE(BGl_z62main5731z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17472,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_14985));
								PROCEDURE_SET(BgL_mainz00_17472,
									(int) (((long) 1)), BgL_bodyz00_14986);
								PROCEDURE_SET(BgL_mainz00_17472,
									(int) (((long) 2)), BgL_runz00_17471);
								PROCEDURE_SET(BgL_mainz00_17472,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14987));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17473;

									BgL_objz00_17473 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17471, BgL_objz00_17473);
									BgL_objz00_17473;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3503z00_17474;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3504z00_17475;

										BgL_arg3504z00_17475 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14985))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17476;

											BgL_newz00_17476 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30543;

												BgL_tmpz00_30543 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17476, BgL_tmpz00_30543,
													BgL_arg3504z00_17475);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30548;
												int BgL_tmpz00_30546;

												BgL_auxz00_30548 = BINT(BgL_siza7ezd2framez75_14987);
												BgL_tmpz00_30546 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17476, BgL_tmpz00_30546,
													BgL_auxz00_30548);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30551;

												BgL_tmpz00_30551 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17476, BgL_tmpz00_30551,
													BgL_runz00_17471);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30556;
												int BgL_tmpz00_30554;

												BgL_auxz00_30556 = BINT(((long) 1));
												BgL_tmpz00_30554 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17476, BgL_tmpz00_30554,
													BgL_auxz00_30556);
											}
											BgL_arg3503z00_17474 = BgL_newz00_17476;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17472, BgL_arg3503z00_17474);
									BgL_arg3503z00_17474;
								}
								return BgL_mainz00_17472;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5731 */
	obj_t BGl_z62main5731z62zz__evaluate_compz00(obj_t BgL_envz00_14989,
		obj_t BgL_dz00_14994)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_14992;
				long BgL_siza7ezd2framez75_14993;

				BgL_runz00_14992 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14989, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14993 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14989, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17477;

					BgL_sz00_17477 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17478;

						BgL_bpz00_17478 = VECTOR_REF(((obj_t) BgL_sz00_17477), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17478) + BgL_siza7ezd2framez75_14993) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17477))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3507z00_17479;

									BgL_arg3507z00_17479 =
										((long) CINT(BgL_bpz00_17478) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17477), BgL_arg3507z00_17479,
										BgL_dz00_14994);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17480;

									BgL_ez00_17480 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17480,
										BgL_bpz00_17478);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17481;

										BgL_accz00_17481 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14992, BgL_sz00_17477, BgL_bpz00_17478);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17480);
										VECTOR_SET(
											((obj_t) BgL_sz00_17477), ((long) 0), BgL_bpz00_17478);
										return BgL_accz00_17481;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17482;

								BgL_nsz00_17482 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17482, ((long) 1), BgL_sz00_17477);
								VECTOR_SET(BgL_nsz00_17482, ((long) 2), BgL_dz00_14994);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17483;

									BgL_z12denvz12_17483 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17483, BgL_nsz00_17482);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17484;

										BgL_ez00_17484 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17484,
											BgL_sz00_17477);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17485;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17486;

												BgL_savedzd2bpzd2_17486 =
													VECTOR_REF(BgL_nsz00_17482, ((long) 0));
												VECTOR_SET(BgL_nsz00_17482, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17488;

													BgL_fz00_17488 = BgL_runz00_14992;
												BgL_recz00_17487:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17489;

														BgL_rz00_17489 =
															PROCEDURE_ENTRY(BgL_fz00_17488) (BgL_fz00_17488,
															BgL_nsz00_17482, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30599;

															if (PROCEDUREP(BgL_rz00_17489))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17490;

																	BgL_arg1696z00_17490 =
																		PROCEDURE_ATTR(BgL_rz00_17489);
																	if (STRUCTP(BgL_arg1696z00_17490))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30599 =
																				(STRUCT_KEY(BgL_arg1696z00_17490) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30599 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30599 = ((bool_t) 0);
																}
															if (BgL_testz00_30599)
																{
																	obj_t BgL_fz00_30607;

																	BgL_fz00_30607 = BgL_rz00_17489;
																	BgL_fz00_17488 = BgL_fz00_30607;
																	goto BgL_recz00_17487;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17482, ((long) 0),
																		BgL_savedzd2bpzd2_17486);
																	BgL_____rz00_17485 = BgL_rz00_17489;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17484);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17483, BgL_sz00_17477);
											return BgL_____rz00_17485;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5732 */
	obj_t BGl_z62run5732z62zz__evaluate_compz00(obj_t BgL_envz00_14995,
		obj_t BgL_sz00_14998)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_14996;
				obj_t BgL_bodyz00_14997;

				BgL_i1246z00_14996 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14995, (int) (((long) 0))));
				BgL_bodyz00_14997 = PROCEDURE_REF(BgL_envz00_14995, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17491;

					BgL_bpz00_17491 = VECTOR_REF(((obj_t) BgL_sz00_14998), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17492;
						obj_t BgL_wherez00_17493;
						obj_t BgL_locz00_17494;

						BgL_z12denvz12_17492 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17493 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14996))->
							BgL_wherez00);
						BgL_locz00_17494 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_14996))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17492, BgL_wherez00_17493,
								BgL_locz00_17494);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17495;

								BgL_za2za2resza2za2z00_17495 =
									PROCEDURE_ENTRY(BgL_bodyz00_14997) (BgL_bodyz00_14997,
									BgL_sz00_14998, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17492);
								return BgL_za2za2resza2za2z00_17495;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3509> */
	obj_t BGl_z62zc3anonymousza33509ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_14999, obj_t BgL_sz00_15004)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15000;
				BgL_ev_absz00_bglt BgL_i1246z00_15001;
				obj_t BgL_bodyz00_15002;
				long BgL_siza7ezd2framez75_15003;

				BgL_iboxesz00_15000 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14999, (int) (((long) 0))));
				BgL_i1246z00_15001 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14999, (int) (((long) 1))));
				BgL_bodyz00_15002 = PROCEDURE_REF(BgL_envz00_14999, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15003 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14999, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17496;

					BgL_bpz00_17496 = VECTOR_REF(((obj_t) BgL_sz00_15004), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17497;

							BgL_runz00_17497 =
								MAKE_FX_PROCEDURE(BGl_z62run5734z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17497,
								(int) (((long) 0)), BgL_iboxesz00_15000);
							PROCEDURE_SET(BgL_runz00_17497,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_15001));
							PROCEDURE_SET(BgL_runz00_17497,
								(int) (((long) 2)), BgL_bodyz00_15002);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17498;

								BgL_mainz00_17498 =
									MAKE_FX_PROCEDURE(BGl_z62main5733z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17498,
									(int) (((long) 0)), BgL_iboxesz00_15000);
								PROCEDURE_SET(BgL_mainz00_17498,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_15001));
								PROCEDURE_SET(BgL_mainz00_17498,
									(int) (((long) 2)), BgL_bodyz00_15002);
								PROCEDURE_SET(BgL_mainz00_17498,
									(int) (((long) 3)), BgL_runz00_17497);
								PROCEDURE_SET(BgL_mainz00_17498,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15003));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17499;

									BgL_objz00_17499 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17497, BgL_objz00_17499);
									BgL_objz00_17499;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3510z00_17500;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3511z00_17501;

										BgL_arg3511z00_17501 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15001))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17502;

											BgL_newz00_17502 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30669;

												BgL_tmpz00_30669 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17502, BgL_tmpz00_30669,
													BgL_arg3511z00_17501);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30674;
												int BgL_tmpz00_30672;

												BgL_auxz00_30674 = BINT(BgL_siza7ezd2framez75_15003);
												BgL_tmpz00_30672 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17502, BgL_tmpz00_30672,
													BgL_auxz00_30674);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30677;

												BgL_tmpz00_30677 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17502, BgL_tmpz00_30677,
													BgL_runz00_17497);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30682;
												int BgL_tmpz00_30680;

												BgL_auxz00_30682 = BINT(((long) 1));
												BgL_tmpz00_30680 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17502, BgL_tmpz00_30680,
													BgL_auxz00_30682);
											}
											BgL_arg3510z00_17500 = BgL_newz00_17502;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17498, BgL_arg3510z00_17500);
									BgL_arg3510z00_17500;
								}
								return BgL_mainz00_17498;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5733 */
	obj_t BGl_z62main5733z62zz__evaluate_compz00(obj_t BgL_envz00_15005,
		obj_t BgL_dz00_15011)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15009;
				long BgL_siza7ezd2framez75_15010;

				BgL_runz00_15009 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15005, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15010 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15005, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17503;

					BgL_sz00_17503 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17504;

						BgL_bpz00_17504 = VECTOR_REF(((obj_t) BgL_sz00_17503), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17504) + BgL_siza7ezd2framez75_15010) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17503))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3514z00_17505;

									BgL_arg3514z00_17505 =
										((long) CINT(BgL_bpz00_17504) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17503), BgL_arg3514z00_17505,
										BgL_dz00_15011);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17506;

									BgL_ez00_17506 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17506,
										BgL_bpz00_17504);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17507;

										BgL_accz00_17507 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15009, BgL_sz00_17503, BgL_bpz00_17504);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17506);
										VECTOR_SET(
											((obj_t) BgL_sz00_17503), ((long) 0), BgL_bpz00_17504);
										return BgL_accz00_17507;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17508;

								BgL_nsz00_17508 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17508, ((long) 1), BgL_sz00_17503);
								VECTOR_SET(BgL_nsz00_17508, ((long) 2), BgL_dz00_15011);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17509;

									BgL_z12denvz12_17509 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17509, BgL_nsz00_17508);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17510;

										BgL_ez00_17510 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17510,
											BgL_sz00_17503);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17511;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17512;

												BgL_savedzd2bpzd2_17512 =
													VECTOR_REF(BgL_nsz00_17508, ((long) 0));
												VECTOR_SET(BgL_nsz00_17508, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17514;

													BgL_fz00_17514 = BgL_runz00_15009;
												BgL_recz00_17513:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17515;

														BgL_rz00_17515 =
															PROCEDURE_ENTRY(BgL_fz00_17514) (BgL_fz00_17514,
															BgL_nsz00_17508, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30725;

															if (PROCEDUREP(BgL_rz00_17515))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17516;

																	BgL_arg1696z00_17516 =
																		PROCEDURE_ATTR(BgL_rz00_17515);
																	if (STRUCTP(BgL_arg1696z00_17516))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30725 =
																				(STRUCT_KEY(BgL_arg1696z00_17516) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30725 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30725 = ((bool_t) 0);
																}
															if (BgL_testz00_30725)
																{
																	obj_t BgL_fz00_30733;

																	BgL_fz00_30733 = BgL_rz00_17515;
																	BgL_fz00_17514 = BgL_fz00_30733;
																	goto BgL_recz00_17513;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17508, ((long) 0),
																		BgL_savedzd2bpzd2_17512);
																	BgL_____rz00_17511 = BgL_rz00_17515;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17510);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17509, BgL_sz00_17503);
											return BgL_____rz00_17511;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5734 */
	obj_t BGl_z62run5734z62zz__evaluate_compz00(obj_t BgL_envz00_15012,
		obj_t BgL_sz00_15016)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15013;
				BgL_ev_absz00_bglt BgL_i1246z00_15014;
				obj_t BgL_bodyz00_15015;

				BgL_iboxesz00_15013 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15012, (int) (((long) 0))));
				BgL_i1246z00_15014 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15012, (int) (((long) 1))));
				BgL_bodyz00_15015 = PROCEDURE_REF(BgL_envz00_15012, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17517;

					BgL_bpz00_17517 = VECTOR_REF(((obj_t) BgL_sz00_15016), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15016,
						BgL_iboxesz00_15013, BgL_bpz00_17517);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17518;
						obj_t BgL_wherez00_17519;
						obj_t BgL_locz00_17520;

						BgL_z12denvz12_17518 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17519 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15014))->
							BgL_wherez00);
						BgL_locz00_17520 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15014))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17518, BgL_wherez00_17519,
								BgL_locz00_17520);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17521;

								BgL_za2za2resza2za2z00_17521 =
									PROCEDURE_ENTRY(BgL_bodyz00_15015) (BgL_bodyz00_15015,
									BgL_sz00_15016, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17518);
								return BgL_za2za2resza2za2z00_17521;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3519> */
	obj_t BGl_z62zc3anonymousza33519ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15017, obj_t BgL_sz00_15023)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15018;
				long BgL_siza7eza7_15019;
				BgL_ev_absz00_bglt BgL_i1246z00_15020;
				obj_t BgL_bodyz00_15021;
				long BgL_siza7ezd2framez75_15022;

				BgL_ifreesz00_15018 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15017, (int) (((long) 0))));
				BgL_siza7eza7_15019 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15017, (int) (((long) 1))));
				BgL_i1246z00_15020 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15017, (int) (((long) 2))));
				BgL_bodyz00_15021 = PROCEDURE_REF(BgL_envz00_15017, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15022 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15017, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17522;

					BgL_bpz00_17522 = VECTOR_REF(((obj_t) BgL_sz00_15023), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17523;

						BgL_valza2za2_17523 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15023,
							BgL_bpz00_17522, BgL_ifreesz00_15018);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17524;

							BgL_runz00_17524 =
								MAKE_FX_PROCEDURE(BGl_z62run5736z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17524,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15019));
							PROCEDURE_SET(BgL_runz00_17524,
								(int) (((long) 1)), BgL_valza2za2_17523);
							PROCEDURE_SET(BgL_runz00_17524,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_15020));
							PROCEDURE_SET(BgL_runz00_17524,
								(int) (((long) 3)), BgL_bodyz00_15021);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17525;

								BgL_mainz00_17525 =
									MAKE_FX_PROCEDURE(BGl_z62main5735z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17525,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15019));
								PROCEDURE_SET(BgL_mainz00_17525,
									(int) (((long) 1)), BgL_valza2za2_17523);
								PROCEDURE_SET(BgL_mainz00_17525,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_15020));
								PROCEDURE_SET(BgL_mainz00_17525,
									(int) (((long) 3)), BgL_bodyz00_15021);
								PROCEDURE_SET(BgL_mainz00_17525,
									(int) (((long) 4)), BgL_runz00_17524);
								PROCEDURE_SET(BgL_mainz00_17525,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15022));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17526;

									BgL_objz00_17526 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17524, BgL_objz00_17526);
									BgL_objz00_17526;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3521z00_17527;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3522z00_17528;

										BgL_arg3522z00_17528 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15020))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17529;

											BgL_newz00_17529 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30809;

												BgL_tmpz00_30809 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17529, BgL_tmpz00_30809,
													BgL_arg3522z00_17528);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30814;
												int BgL_tmpz00_30812;

												BgL_auxz00_30814 = BINT(BgL_siza7ezd2framez75_15022);
												BgL_tmpz00_30812 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17529, BgL_tmpz00_30812,
													BgL_auxz00_30814);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30817;

												BgL_tmpz00_30817 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17529, BgL_tmpz00_30817,
													BgL_runz00_17524);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30822;
												int BgL_tmpz00_30820;

												BgL_auxz00_30822 = BINT(((long) 1));
												BgL_tmpz00_30820 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17529, BgL_tmpz00_30820,
													BgL_auxz00_30822);
											}
											BgL_arg3521z00_17527 = BgL_newz00_17529;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17525, BgL_arg3521z00_17527);
									BgL_arg3521z00_17527;
								}
								return BgL_mainz00_17525;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5735 */
	obj_t BGl_z62main5735z62zz__evaluate_compz00(obj_t BgL_envz00_15024,
		obj_t BgL_dz00_15031)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15029;
				long BgL_siza7ezd2framez75_15030;

				BgL_runz00_15029 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15024, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15030 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15024, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17530;

					BgL_sz00_17530 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17531;

						BgL_bpz00_17531 = VECTOR_REF(((obj_t) BgL_sz00_17530), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17531) + BgL_siza7ezd2framez75_15030) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17530))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3525z00_17532;

									BgL_arg3525z00_17532 =
										((long) CINT(BgL_bpz00_17531) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17530), BgL_arg3525z00_17532,
										BgL_dz00_15031);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17533;

									BgL_ez00_17533 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17533,
										BgL_bpz00_17531);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17534;

										BgL_accz00_17534 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15029, BgL_sz00_17530, BgL_bpz00_17531);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17533);
										VECTOR_SET(
											((obj_t) BgL_sz00_17530), ((long) 0), BgL_bpz00_17531);
										return BgL_accz00_17534;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17535;

								BgL_nsz00_17535 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17535, ((long) 1), BgL_sz00_17530);
								VECTOR_SET(BgL_nsz00_17535, ((long) 2), BgL_dz00_15031);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17536;

									BgL_z12denvz12_17536 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17536, BgL_nsz00_17535);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17537;

										BgL_ez00_17537 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17537,
											BgL_sz00_17530);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17538;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17539;

												BgL_savedzd2bpzd2_17539 =
													VECTOR_REF(BgL_nsz00_17535, ((long) 0));
												VECTOR_SET(BgL_nsz00_17535, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17541;

													BgL_fz00_17541 = BgL_runz00_15029;
												BgL_recz00_17540:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17542;

														BgL_rz00_17542 =
															PROCEDURE_ENTRY(BgL_fz00_17541) (BgL_fz00_17541,
															BgL_nsz00_17535, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_30865;

															if (PROCEDUREP(BgL_rz00_17542))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17543;

																	BgL_arg1696z00_17543 =
																		PROCEDURE_ATTR(BgL_rz00_17542);
																	if (STRUCTP(BgL_arg1696z00_17543))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30865 =
																				(STRUCT_KEY(BgL_arg1696z00_17543) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_30865 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_30865 = ((bool_t) 0);
																}
															if (BgL_testz00_30865)
																{
																	obj_t BgL_fz00_30873;

																	BgL_fz00_30873 = BgL_rz00_17542;
																	BgL_fz00_17541 = BgL_fz00_30873;
																	goto BgL_recz00_17540;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17535, ((long) 0),
																		BgL_savedzd2bpzd2_17539);
																	BgL_____rz00_17538 = BgL_rz00_17542;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17537);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17536, BgL_sz00_17530);
											return BgL_____rz00_17538;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5736 */
	obj_t BGl_z62run5736z62zz__evaluate_compz00(obj_t BgL_envz00_15032,
		obj_t BgL_sz00_15037)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15033;
				obj_t BgL_valza2za2_15034;
				BgL_ev_absz00_bglt BgL_i1246z00_15035;
				obj_t BgL_bodyz00_15036;

				BgL_siza7eza7_15033 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15032, (int) (((long) 0))));
				BgL_valza2za2_15034 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15032, (int) (((long) 1))));
				BgL_i1246z00_15035 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15032, (int) (((long) 2))));
				BgL_bodyz00_15036 = PROCEDURE_REF(BgL_envz00_15032, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17544;

					BgL_bpz00_17544 = VECTOR_REF(((obj_t) BgL_sz00_15037), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15037,
						BgL_valza2za2_15034,
						((long) CINT(BgL_bpz00_17544) + BgL_siza7eza7_15033));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17545;
						obj_t BgL_wherez00_17546;
						obj_t BgL_locz00_17547;

						BgL_z12denvz12_17545 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17546 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15035))->
							BgL_wherez00);
						BgL_locz00_17547 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15035))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17545, BgL_wherez00_17546,
								BgL_locz00_17547);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17548;

								BgL_za2za2resza2za2z00_17548 =
									PROCEDURE_ENTRY(BgL_bodyz00_15036) (BgL_bodyz00_15036,
									BgL_sz00_15037, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17545);
								return BgL_za2za2resza2za2z00_17548;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3528> */
	obj_t BGl_z62zc3anonymousza33528ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15038, obj_t BgL_sz00_15045)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15039;
				obj_t BgL_iboxesz00_15040;
				long BgL_siza7eza7_15041;
				BgL_ev_absz00_bglt BgL_i1246z00_15042;
				obj_t BgL_bodyz00_15043;
				long BgL_siza7ezd2framez75_15044;

				BgL_ifreesz00_15039 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 0))));
				BgL_iboxesz00_15040 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 1))));
				BgL_siza7eza7_15041 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 2))));
				BgL_i1246z00_15042 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 3))));
				BgL_bodyz00_15043 = PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15044 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15038, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17549;

					BgL_bpz00_17549 = VECTOR_REF(((obj_t) BgL_sz00_15045), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17550;

						BgL_valza2za2_17550 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15045,
							BgL_bpz00_17549, BgL_ifreesz00_15039);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17551;

							BgL_runz00_17551 =
								MAKE_FX_PROCEDURE(BGl_z62run5738z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17551,
								(int) (((long) 0)), BgL_iboxesz00_15040);
							PROCEDURE_SET(BgL_runz00_17551,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15041));
							PROCEDURE_SET(BgL_runz00_17551,
								(int) (((long) 2)), BgL_valza2za2_17550);
							PROCEDURE_SET(BgL_runz00_17551,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_15042));
							PROCEDURE_SET(BgL_runz00_17551,
								(int) (((long) 4)), BgL_bodyz00_15043);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17552;

								BgL_mainz00_17552 =
									MAKE_FX_PROCEDURE(BGl_z62main5737z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 0)), BgL_iboxesz00_15040);
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15041));
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 2)), BgL_valza2za2_17550);
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_15042));
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 4)), BgL_bodyz00_15043);
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 5)), BgL_runz00_17551);
								PROCEDURE_SET(BgL_mainz00_17552,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15044));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17553;

									BgL_objz00_17553 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17551, BgL_objz00_17553);
									BgL_objz00_17553;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3529z00_17554;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3530z00_17555;

										BgL_arg3530z00_17555 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15042))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17556;

											BgL_newz00_17556 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30961;

												BgL_tmpz00_30961 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17556, BgL_tmpz00_30961,
													BgL_arg3530z00_17555);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30966;
												int BgL_tmpz00_30964;

												BgL_auxz00_30966 = BINT(BgL_siza7ezd2framez75_15044);
												BgL_tmpz00_30964 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17556, BgL_tmpz00_30964,
													BgL_auxz00_30966);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_30969;

												BgL_tmpz00_30969 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17556, BgL_tmpz00_30969,
													BgL_runz00_17551);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_30974;
												int BgL_tmpz00_30972;

												BgL_auxz00_30974 = BINT(((long) 1));
												BgL_tmpz00_30972 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17556, BgL_tmpz00_30972,
													BgL_auxz00_30974);
											}
											BgL_arg3529z00_17554 = BgL_newz00_17556;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17552, BgL_arg3529z00_17554);
									BgL_arg3529z00_17554;
								}
								return BgL_mainz00_17552;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5737 */
	obj_t BGl_z62main5737z62zz__evaluate_compz00(obj_t BgL_envz00_15046,
		obj_t BgL_dz00_15054)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15052;
				long BgL_siza7ezd2framez75_15053;

				BgL_runz00_15052 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15046, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15053 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15046, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17557;

					BgL_sz00_17557 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17558;

						BgL_bpz00_17558 = VECTOR_REF(((obj_t) BgL_sz00_17557), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17558) + BgL_siza7ezd2framez75_15053) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17557))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3533z00_17559;

									BgL_arg3533z00_17559 =
										((long) CINT(BgL_bpz00_17558) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17557), BgL_arg3533z00_17559,
										BgL_dz00_15054);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17560;

									BgL_ez00_17560 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17560,
										BgL_bpz00_17558);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17561;

										BgL_accz00_17561 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15052, BgL_sz00_17557, BgL_bpz00_17558);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17560);
										VECTOR_SET(
											((obj_t) BgL_sz00_17557), ((long) 0), BgL_bpz00_17558);
										return BgL_accz00_17561;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17562;

								BgL_nsz00_17562 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17562, ((long) 1), BgL_sz00_17557);
								VECTOR_SET(BgL_nsz00_17562, ((long) 2), BgL_dz00_15054);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17563;

									BgL_z12denvz12_17563 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17563, BgL_nsz00_17562);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17564;

										BgL_ez00_17564 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17564,
											BgL_sz00_17557);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17565;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17566;

												BgL_savedzd2bpzd2_17566 =
													VECTOR_REF(BgL_nsz00_17562, ((long) 0));
												VECTOR_SET(BgL_nsz00_17562, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17568;

													BgL_fz00_17568 = BgL_runz00_15052;
												BgL_recz00_17567:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17569;

														BgL_rz00_17569 =
															PROCEDURE_ENTRY(BgL_fz00_17568) (BgL_fz00_17568,
															BgL_nsz00_17562, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31017;

															if (PROCEDUREP(BgL_rz00_17569))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17570;

																	BgL_arg1696z00_17570 =
																		PROCEDURE_ATTR(BgL_rz00_17569);
																	if (STRUCTP(BgL_arg1696z00_17570))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31017 =
																				(STRUCT_KEY(BgL_arg1696z00_17570) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31017 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31017 = ((bool_t) 0);
																}
															if (BgL_testz00_31017)
																{
																	obj_t BgL_fz00_31025;

																	BgL_fz00_31025 = BgL_rz00_17569;
																	BgL_fz00_17568 = BgL_fz00_31025;
																	goto BgL_recz00_17567;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17562, ((long) 0),
																		BgL_savedzd2bpzd2_17566);
																	BgL_____rz00_17565 = BgL_rz00_17569;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17564);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17563, BgL_sz00_17557);
											return BgL_____rz00_17565;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5738 */
	obj_t BGl_z62run5738z62zz__evaluate_compz00(obj_t BgL_envz00_15055,
		obj_t BgL_sz00_15061)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15056;
				long BgL_siza7eza7_15057;
				obj_t BgL_valza2za2_15058;
				BgL_ev_absz00_bglt BgL_i1246z00_15059;
				obj_t BgL_bodyz00_15060;

				BgL_iboxesz00_15056 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15055, (int) (((long) 0))));
				BgL_siza7eza7_15057 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15055, (int) (((long) 1))));
				BgL_valza2za2_15058 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15055, (int) (((long) 2))));
				BgL_i1246z00_15059 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15055, (int) (((long) 3))));
				BgL_bodyz00_15060 = PROCEDURE_REF(BgL_envz00_15055, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17571;

					BgL_bpz00_17571 = VECTOR_REF(((obj_t) BgL_sz00_15061), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15061,
						BgL_iboxesz00_15056, BgL_bpz00_17571);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15061,
						BgL_valza2za2_15058,
						((long) CINT(BgL_bpz00_17571) + BgL_siza7eza7_15057));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17572;
						obj_t BgL_wherez00_17573;
						obj_t BgL_locz00_17574;

						BgL_z12denvz12_17572 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17573 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15059))->
							BgL_wherez00);
						BgL_locz00_17574 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15059))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17572, BgL_wherez00_17573,
								BgL_locz00_17574);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17575;

								BgL_za2za2resza2za2z00_17575 =
									PROCEDURE_ENTRY(BgL_bodyz00_15060) (BgL_bodyz00_15060,
									BgL_sz00_15061, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17572);
								return BgL_za2za2resza2za2z00_17575;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3463> */
	obj_t BGl_z62zc3anonymousza33463ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15062, obj_t BgL_sz00_15066)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15063;
				obj_t BgL_bodyz00_15064;
				long BgL_siza7ezd2framez75_15065;

				BgL_i1246z00_15063 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15062, (int) (((long) 0))));
				BgL_bodyz00_15064 = PROCEDURE_REF(BgL_envz00_15062, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15065 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15062, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17576;

					BgL_bpz00_17576 = VECTOR_REF(((obj_t) BgL_sz00_15066), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17577;

							BgL_runz00_17577 =
								MAKE_FX_PROCEDURE(BGl_z62run5740z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17577,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_15063));
							PROCEDURE_SET(BgL_runz00_17577,
								(int) (((long) 1)), BgL_bodyz00_15064);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17578;

								BgL_mainz00_17578 =
									MAKE_VA_PROCEDURE(BGl_z62main5739z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17578,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_15063));
								PROCEDURE_SET(BgL_mainz00_17578,
									(int) (((long) 1)), BgL_bodyz00_15064);
								PROCEDURE_SET(BgL_mainz00_17578,
									(int) (((long) 2)), BgL_runz00_17577);
								PROCEDURE_SET(BgL_mainz00_17578,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15065));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17579;

									BgL_objz00_17579 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17577, BgL_objz00_17579);
									BgL_objz00_17579;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3464z00_17580;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3465z00_17581;

										BgL_arg3465z00_17581 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15063))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17582;

											BgL_newz00_17582 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31093;

												BgL_tmpz00_31093 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17582, BgL_tmpz00_31093,
													BgL_arg3465z00_17581);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31098;
												int BgL_tmpz00_31096;

												BgL_auxz00_31098 = BINT(BgL_siza7ezd2framez75_15065);
												BgL_tmpz00_31096 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17582, BgL_tmpz00_31096,
													BgL_auxz00_31098);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31101;

												BgL_tmpz00_31101 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17582, BgL_tmpz00_31101,
													BgL_runz00_17577);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31106;
												int BgL_tmpz00_31104;

												BgL_auxz00_31106 = BINT(((long) -1));
												BgL_tmpz00_31104 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17582, BgL_tmpz00_31104,
													BgL_auxz00_31106);
											}
											BgL_arg3464z00_17580 = BgL_newz00_17582;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17578, BgL_arg3464z00_17580);
									BgL_arg3464z00_17580;
								}
								return BgL_mainz00_17578;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5739 */
	obj_t BGl_z62main5739z62zz__evaluate_compz00(obj_t BgL_envz00_15067,
		obj_t BgL_lastz00_15072)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15070;
				long BgL_siza7ezd2framez75_15071;

				BgL_runz00_15070 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15067, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15071 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15067, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17583;

					BgL_sz00_17583 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17584;

						BgL_bpz00_17584 = VECTOR_REF(((obj_t) BgL_sz00_17583), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17584) + BgL_siza7ezd2framez75_15071) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17583))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3468z00_17585;

									BgL_arg3468z00_17585 =
										((long) CINT(BgL_bpz00_17584) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17583), BgL_arg3468z00_17585,
										BgL_lastz00_15072);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17586;

									BgL_ez00_17586 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17586,
										BgL_bpz00_17584);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17587;

										BgL_accz00_17587 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15070, BgL_sz00_17583, BgL_bpz00_17584);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17586);
										VECTOR_SET(
											((obj_t) BgL_sz00_17583), ((long) 0), BgL_bpz00_17584);
										return BgL_accz00_17587;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17588;

								BgL_nsz00_17588 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17588, ((long) 1), BgL_sz00_17583);
								VECTOR_SET(BgL_nsz00_17588, ((long) 2), BgL_lastz00_15072);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17589;

									BgL_z12denvz12_17589 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17589, BgL_nsz00_17588);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17590;

										BgL_ez00_17590 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17590,
											BgL_sz00_17583);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17591;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17592;

												BgL_savedzd2bpzd2_17592 =
													VECTOR_REF(BgL_nsz00_17588, ((long) 0));
												VECTOR_SET(BgL_nsz00_17588, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17594;

													BgL_fz00_17594 = BgL_runz00_15070;
												BgL_recz00_17593:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17595;

														BgL_rz00_17595 =
															PROCEDURE_ENTRY(BgL_fz00_17594) (BgL_fz00_17594,
															BgL_nsz00_17588, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31149;

															if (PROCEDUREP(BgL_rz00_17595))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17596;

																	BgL_arg1696z00_17596 =
																		PROCEDURE_ATTR(BgL_rz00_17595);
																	if (STRUCTP(BgL_arg1696z00_17596))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31149 =
																				(STRUCT_KEY(BgL_arg1696z00_17596) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31149 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31149 = ((bool_t) 0);
																}
															if (BgL_testz00_31149)
																{
																	obj_t BgL_fz00_31157;

																	BgL_fz00_31157 = BgL_rz00_17595;
																	BgL_fz00_17594 = BgL_fz00_31157;
																	goto BgL_recz00_17593;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17588, ((long) 0),
																		BgL_savedzd2bpzd2_17592);
																	BgL_____rz00_17591 = BgL_rz00_17595;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17590);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17589, BgL_sz00_17583);
											return BgL_____rz00_17591;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5740 */
	obj_t BGl_z62run5740z62zz__evaluate_compz00(obj_t BgL_envz00_15073,
		obj_t BgL_sz00_15076)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15074;
				obj_t BgL_bodyz00_15075;

				BgL_i1246z00_15074 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15073, (int) (((long) 0))));
				BgL_bodyz00_15075 = PROCEDURE_REF(BgL_envz00_15073, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17597;

					BgL_bpz00_17597 = VECTOR_REF(((obj_t) BgL_sz00_15076), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17598;
						obj_t BgL_wherez00_17599;
						obj_t BgL_locz00_17600;

						BgL_z12denvz12_17598 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17599 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15074))->
							BgL_wherez00);
						BgL_locz00_17600 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15074))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17598, BgL_wherez00_17599,
								BgL_locz00_17600);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17601;

								BgL_za2za2resza2za2z00_17601 =
									PROCEDURE_ENTRY(BgL_bodyz00_15075) (BgL_bodyz00_15075,
									BgL_sz00_15076, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17598);
								return BgL_za2za2resza2za2z00_17601;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3470> */
	obj_t BGl_z62zc3anonymousza33470ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15077, obj_t BgL_sz00_15082)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15078;
				BgL_ev_absz00_bglt BgL_i1246z00_15079;
				obj_t BgL_bodyz00_15080;
				long BgL_siza7ezd2framez75_15081;

				BgL_iboxesz00_15078 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15077, (int) (((long) 0))));
				BgL_i1246z00_15079 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15077, (int) (((long) 1))));
				BgL_bodyz00_15080 = PROCEDURE_REF(BgL_envz00_15077, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15081 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15077, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17602;

					BgL_bpz00_17602 = VECTOR_REF(((obj_t) BgL_sz00_15082), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17603;

							BgL_runz00_17603 =
								MAKE_FX_PROCEDURE(BGl_z62run5742z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17603,
								(int) (((long) 0)), BgL_iboxesz00_15078);
							PROCEDURE_SET(BgL_runz00_17603,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_15079));
							PROCEDURE_SET(BgL_runz00_17603,
								(int) (((long) 2)), BgL_bodyz00_15080);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17604;

								BgL_mainz00_17604 =
									MAKE_VA_PROCEDURE(BGl_z62main5741z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17604,
									(int) (((long) 0)), BgL_iboxesz00_15078);
								PROCEDURE_SET(BgL_mainz00_17604,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_15079));
								PROCEDURE_SET(BgL_mainz00_17604,
									(int) (((long) 2)), BgL_bodyz00_15080);
								PROCEDURE_SET(BgL_mainz00_17604,
									(int) (((long) 3)), BgL_runz00_17603);
								PROCEDURE_SET(BgL_mainz00_17604,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15081));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17605;

									BgL_objz00_17605 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17603, BgL_objz00_17605);
									BgL_objz00_17605;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3471z00_17606;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3472z00_17607;

										BgL_arg3472z00_17607 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15079))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17608;

											BgL_newz00_17608 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31219;

												BgL_tmpz00_31219 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17608, BgL_tmpz00_31219,
													BgL_arg3472z00_17607);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31224;
												int BgL_tmpz00_31222;

												BgL_auxz00_31224 = BINT(BgL_siza7ezd2framez75_15081);
												BgL_tmpz00_31222 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17608, BgL_tmpz00_31222,
													BgL_auxz00_31224);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31227;

												BgL_tmpz00_31227 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17608, BgL_tmpz00_31227,
													BgL_runz00_17603);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31232;
												int BgL_tmpz00_31230;

												BgL_auxz00_31232 = BINT(((long) -1));
												BgL_tmpz00_31230 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17608, BgL_tmpz00_31230,
													BgL_auxz00_31232);
											}
											BgL_arg3471z00_17606 = BgL_newz00_17608;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17604, BgL_arg3471z00_17606);
									BgL_arg3471z00_17606;
								}
								return BgL_mainz00_17604;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5741 */
	obj_t BGl_z62main5741z62zz__evaluate_compz00(obj_t BgL_envz00_15083,
		obj_t BgL_lastz00_15089)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15087;
				long BgL_siza7ezd2framez75_15088;

				BgL_runz00_15087 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15083, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15088 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15083, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17609;

					BgL_sz00_17609 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17610;

						BgL_bpz00_17610 = VECTOR_REF(((obj_t) BgL_sz00_17609), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17610) + BgL_siza7ezd2framez75_15088) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17609))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3475z00_17611;

									BgL_arg3475z00_17611 =
										((long) CINT(BgL_bpz00_17610) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17609), BgL_arg3475z00_17611,
										BgL_lastz00_15089);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17612;

									BgL_ez00_17612 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17612,
										BgL_bpz00_17610);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17613;

										BgL_accz00_17613 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15087, BgL_sz00_17609, BgL_bpz00_17610);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17612);
										VECTOR_SET(
											((obj_t) BgL_sz00_17609), ((long) 0), BgL_bpz00_17610);
										return BgL_accz00_17613;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17614;

								BgL_nsz00_17614 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17614, ((long) 1), BgL_sz00_17609);
								VECTOR_SET(BgL_nsz00_17614, ((long) 2), BgL_lastz00_15089);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17615;

									BgL_z12denvz12_17615 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17615, BgL_nsz00_17614);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17616;

										BgL_ez00_17616 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17616,
											BgL_sz00_17609);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17617;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17618;

												BgL_savedzd2bpzd2_17618 =
													VECTOR_REF(BgL_nsz00_17614, ((long) 0));
												VECTOR_SET(BgL_nsz00_17614, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17620;

													BgL_fz00_17620 = BgL_runz00_15087;
												BgL_recz00_17619:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17621;

														BgL_rz00_17621 =
															PROCEDURE_ENTRY(BgL_fz00_17620) (BgL_fz00_17620,
															BgL_nsz00_17614, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31275;

															if (PROCEDUREP(BgL_rz00_17621))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17622;

																	BgL_arg1696z00_17622 =
																		PROCEDURE_ATTR(BgL_rz00_17621);
																	if (STRUCTP(BgL_arg1696z00_17622))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31275 =
																				(STRUCT_KEY(BgL_arg1696z00_17622) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31275 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31275 = ((bool_t) 0);
																}
															if (BgL_testz00_31275)
																{
																	obj_t BgL_fz00_31283;

																	BgL_fz00_31283 = BgL_rz00_17621;
																	BgL_fz00_17620 = BgL_fz00_31283;
																	goto BgL_recz00_17619;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17614, ((long) 0),
																		BgL_savedzd2bpzd2_17618);
																	BgL_____rz00_17617 = BgL_rz00_17621;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17616);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17615, BgL_sz00_17609);
											return BgL_____rz00_17617;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5742 */
	obj_t BGl_z62run5742z62zz__evaluate_compz00(obj_t BgL_envz00_15090,
		obj_t BgL_sz00_15094)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15091;
				BgL_ev_absz00_bglt BgL_i1246z00_15092;
				obj_t BgL_bodyz00_15093;

				BgL_iboxesz00_15091 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15090, (int) (((long) 0))));
				BgL_i1246z00_15092 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15090, (int) (((long) 1))));
				BgL_bodyz00_15093 = PROCEDURE_REF(BgL_envz00_15090, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17623;

					BgL_bpz00_17623 = VECTOR_REF(((obj_t) BgL_sz00_15094), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15094,
						BgL_iboxesz00_15091, BgL_bpz00_17623);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17624;
						obj_t BgL_wherez00_17625;
						obj_t BgL_locz00_17626;

						BgL_z12denvz12_17624 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17625 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15092))->
							BgL_wherez00);
						BgL_locz00_17626 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15092))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17624, BgL_wherez00_17625,
								BgL_locz00_17626);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17627;

								BgL_za2za2resza2za2z00_17627 =
									PROCEDURE_ENTRY(BgL_bodyz00_15093) (BgL_bodyz00_15093,
									BgL_sz00_15094, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17624);
								return BgL_za2za2resza2za2z00_17627;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3480> */
	obj_t BGl_z62zc3anonymousza33480ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15095, obj_t BgL_sz00_15101)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15096;
				long BgL_siza7eza7_15097;
				BgL_ev_absz00_bglt BgL_i1246z00_15098;
				obj_t BgL_bodyz00_15099;
				long BgL_siza7ezd2framez75_15100;

				BgL_ifreesz00_15096 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15095, (int) (((long) 0))));
				BgL_siza7eza7_15097 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15095, (int) (((long) 1))));
				BgL_i1246z00_15098 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15095, (int) (((long) 2))));
				BgL_bodyz00_15099 = PROCEDURE_REF(BgL_envz00_15095, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15100 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15095, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17628;

					BgL_bpz00_17628 = VECTOR_REF(((obj_t) BgL_sz00_15101), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17629;

						BgL_valza2za2_17629 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15101,
							BgL_bpz00_17628, BgL_ifreesz00_15096);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17630;

							BgL_runz00_17630 =
								MAKE_FX_PROCEDURE(BGl_z62run5744z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17630,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15097));
							PROCEDURE_SET(BgL_runz00_17630,
								(int) (((long) 1)), BgL_valza2za2_17629);
							PROCEDURE_SET(BgL_runz00_17630,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_15098));
							PROCEDURE_SET(BgL_runz00_17630,
								(int) (((long) 3)), BgL_bodyz00_15099);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17631;

								BgL_mainz00_17631 =
									MAKE_VA_PROCEDURE(BGl_z62main5743z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17631,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15097));
								PROCEDURE_SET(BgL_mainz00_17631,
									(int) (((long) 1)), BgL_valza2za2_17629);
								PROCEDURE_SET(BgL_mainz00_17631,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_15098));
								PROCEDURE_SET(BgL_mainz00_17631,
									(int) (((long) 3)), BgL_bodyz00_15099);
								PROCEDURE_SET(BgL_mainz00_17631,
									(int) (((long) 4)), BgL_runz00_17630);
								PROCEDURE_SET(BgL_mainz00_17631,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15100));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17632;

									BgL_objz00_17632 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17630, BgL_objz00_17632);
									BgL_objz00_17632;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3481z00_17633;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3482z00_17634;

										BgL_arg3482z00_17634 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15098))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17635;

											BgL_newz00_17635 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31359;

												BgL_tmpz00_31359 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17635, BgL_tmpz00_31359,
													BgL_arg3482z00_17634);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31364;
												int BgL_tmpz00_31362;

												BgL_auxz00_31364 = BINT(BgL_siza7ezd2framez75_15100);
												BgL_tmpz00_31362 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17635, BgL_tmpz00_31362,
													BgL_auxz00_31364);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31367;

												BgL_tmpz00_31367 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17635, BgL_tmpz00_31367,
													BgL_runz00_17630);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31372;
												int BgL_tmpz00_31370;

												BgL_auxz00_31372 = BINT(((long) -1));
												BgL_tmpz00_31370 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17635, BgL_tmpz00_31370,
													BgL_auxz00_31372);
											}
											BgL_arg3481z00_17633 = BgL_newz00_17635;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17631, BgL_arg3481z00_17633);
									BgL_arg3481z00_17633;
								}
								return BgL_mainz00_17631;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5743 */
	obj_t BGl_z62main5743z62zz__evaluate_compz00(obj_t BgL_envz00_15102,
		obj_t BgL_lastz00_15109)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15107;
				long BgL_siza7ezd2framez75_15108;

				BgL_runz00_15107 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15102, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15108 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15102, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17636;

					BgL_sz00_17636 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17637;

						BgL_bpz00_17637 = VECTOR_REF(((obj_t) BgL_sz00_17636), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17637) + BgL_siza7ezd2framez75_15108) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17636))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3485z00_17638;

									BgL_arg3485z00_17638 =
										((long) CINT(BgL_bpz00_17637) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17636), BgL_arg3485z00_17638,
										BgL_lastz00_15109);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17639;

									BgL_ez00_17639 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17639,
										BgL_bpz00_17637);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17640;

										BgL_accz00_17640 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15107, BgL_sz00_17636, BgL_bpz00_17637);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17639);
										VECTOR_SET(
											((obj_t) BgL_sz00_17636), ((long) 0), BgL_bpz00_17637);
										return BgL_accz00_17640;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17641;

								BgL_nsz00_17641 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17641, ((long) 1), BgL_sz00_17636);
								VECTOR_SET(BgL_nsz00_17641, ((long) 2), BgL_lastz00_15109);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17642;

									BgL_z12denvz12_17642 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17642, BgL_nsz00_17641);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17643;

										BgL_ez00_17643 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17643,
											BgL_sz00_17636);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17644;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17645;

												BgL_savedzd2bpzd2_17645 =
													VECTOR_REF(BgL_nsz00_17641, ((long) 0));
												VECTOR_SET(BgL_nsz00_17641, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17647;

													BgL_fz00_17647 = BgL_runz00_15107;
												BgL_recz00_17646:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17648;

														BgL_rz00_17648 =
															PROCEDURE_ENTRY(BgL_fz00_17647) (BgL_fz00_17647,
															BgL_nsz00_17641, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31415;

															if (PROCEDUREP(BgL_rz00_17648))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17649;

																	BgL_arg1696z00_17649 =
																		PROCEDURE_ATTR(BgL_rz00_17648);
																	if (STRUCTP(BgL_arg1696z00_17649))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31415 =
																				(STRUCT_KEY(BgL_arg1696z00_17649) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31415 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31415 = ((bool_t) 0);
																}
															if (BgL_testz00_31415)
																{
																	obj_t BgL_fz00_31423;

																	BgL_fz00_31423 = BgL_rz00_17648;
																	BgL_fz00_17647 = BgL_fz00_31423;
																	goto BgL_recz00_17646;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17641, ((long) 0),
																		BgL_savedzd2bpzd2_17645);
																	BgL_____rz00_17644 = BgL_rz00_17648;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17643);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17642, BgL_sz00_17636);
											return BgL_____rz00_17644;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5744 */
	obj_t BGl_z62run5744z62zz__evaluate_compz00(obj_t BgL_envz00_15110,
		obj_t BgL_sz00_15115)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15111;
				obj_t BgL_valza2za2_15112;
				BgL_ev_absz00_bglt BgL_i1246z00_15113;
				obj_t BgL_bodyz00_15114;

				BgL_siza7eza7_15111 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15110, (int) (((long) 0))));
				BgL_valza2za2_15112 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15110, (int) (((long) 1))));
				BgL_i1246z00_15113 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15110, (int) (((long) 2))));
				BgL_bodyz00_15114 = PROCEDURE_REF(BgL_envz00_15110, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17650;

					BgL_bpz00_17650 = VECTOR_REF(((obj_t) BgL_sz00_15115), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15115,
						BgL_valza2za2_15112,
						((long) CINT(BgL_bpz00_17650) + BgL_siza7eza7_15111));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17651;
						obj_t BgL_wherez00_17652;
						obj_t BgL_locz00_17653;

						BgL_z12denvz12_17651 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17652 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15113))->
							BgL_wherez00);
						BgL_locz00_17653 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15113))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17651, BgL_wherez00_17652,
								BgL_locz00_17653);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17654;

								BgL_za2za2resza2za2z00_17654 =
									PROCEDURE_ENTRY(BgL_bodyz00_15114) (BgL_bodyz00_15114,
									BgL_sz00_15115, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17651);
								return BgL_za2za2resza2za2z00_17654;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3488> */
	obj_t BGl_z62zc3anonymousza33488ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15116, obj_t BgL_sz00_15123)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15117;
				obj_t BgL_iboxesz00_15118;
				long BgL_siza7eza7_15119;
				BgL_ev_absz00_bglt BgL_i1246z00_15120;
				obj_t BgL_bodyz00_15121;
				long BgL_siza7ezd2framez75_15122;

				BgL_ifreesz00_15117 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 0))));
				BgL_iboxesz00_15118 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 1))));
				BgL_siza7eza7_15119 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 2))));
				BgL_i1246z00_15120 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 3))));
				BgL_bodyz00_15121 = PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15122 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15116, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17655;

					BgL_bpz00_17655 = VECTOR_REF(((obj_t) BgL_sz00_15123), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17656;

						BgL_valza2za2_17656 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15123,
							BgL_bpz00_17655, BgL_ifreesz00_15117);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17657;

							BgL_runz00_17657 =
								MAKE_FX_PROCEDURE(BGl_z62run5746z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17657,
								(int) (((long) 0)), BgL_iboxesz00_15118);
							PROCEDURE_SET(BgL_runz00_17657,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15119));
							PROCEDURE_SET(BgL_runz00_17657,
								(int) (((long) 2)), BgL_valza2za2_17656);
							PROCEDURE_SET(BgL_runz00_17657,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_15120));
							PROCEDURE_SET(BgL_runz00_17657,
								(int) (((long) 4)), BgL_bodyz00_15121);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17658;

								BgL_mainz00_17658 =
									MAKE_VA_PROCEDURE(BGl_z62main5745z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 0)), BgL_iboxesz00_15118);
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15119));
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 2)), BgL_valza2za2_17656);
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_15120));
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 4)), BgL_bodyz00_15121);
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 5)), BgL_runz00_17657);
								PROCEDURE_SET(BgL_mainz00_17658,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15122));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17659;

									BgL_objz00_17659 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17657, BgL_objz00_17659);
									BgL_objz00_17659;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3489z00_17660;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3490z00_17661;

										BgL_arg3490z00_17661 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15120))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17662;

											BgL_newz00_17662 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31511;

												BgL_tmpz00_31511 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17662, BgL_tmpz00_31511,
													BgL_arg3490z00_17661);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31516;
												int BgL_tmpz00_31514;

												BgL_auxz00_31516 = BINT(BgL_siza7ezd2framez75_15122);
												BgL_tmpz00_31514 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17662, BgL_tmpz00_31514,
													BgL_auxz00_31516);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31519;

												BgL_tmpz00_31519 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17662, BgL_tmpz00_31519,
													BgL_runz00_17657);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31524;
												int BgL_tmpz00_31522;

												BgL_auxz00_31524 = BINT(((long) -1));
												BgL_tmpz00_31522 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17662, BgL_tmpz00_31522,
													BgL_auxz00_31524);
											}
											BgL_arg3489z00_17660 = BgL_newz00_17662;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17658, BgL_arg3489z00_17660);
									BgL_arg3489z00_17660;
								}
								return BgL_mainz00_17658;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5745 */
	obj_t BGl_z62main5745z62zz__evaluate_compz00(obj_t BgL_envz00_15124,
		obj_t BgL_lastz00_15132)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15130;
				long BgL_siza7ezd2framez75_15131;

				BgL_runz00_15130 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15124, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15131 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15124, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17663;

					BgL_sz00_17663 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17664;

						BgL_bpz00_17664 = VECTOR_REF(((obj_t) BgL_sz00_17663), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17664) + BgL_siza7ezd2framez75_15131) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17663))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3493z00_17665;

									BgL_arg3493z00_17665 =
										((long) CINT(BgL_bpz00_17664) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17663), BgL_arg3493z00_17665,
										BgL_lastz00_15132);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17666;

									BgL_ez00_17666 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17666,
										BgL_bpz00_17664);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17667;

										BgL_accz00_17667 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15130, BgL_sz00_17663, BgL_bpz00_17664);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17666);
										VECTOR_SET(
											((obj_t) BgL_sz00_17663), ((long) 0), BgL_bpz00_17664);
										return BgL_accz00_17667;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17668;

								BgL_nsz00_17668 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17668, ((long) 1), BgL_sz00_17663);
								VECTOR_SET(BgL_nsz00_17668, ((long) 2), BgL_lastz00_15132);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17669;

									BgL_z12denvz12_17669 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17669, BgL_nsz00_17668);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17670;

										BgL_ez00_17670 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17670,
											BgL_sz00_17663);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17671;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17672;

												BgL_savedzd2bpzd2_17672 =
													VECTOR_REF(BgL_nsz00_17668, ((long) 0));
												VECTOR_SET(BgL_nsz00_17668, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17674;

													BgL_fz00_17674 = BgL_runz00_15130;
												BgL_recz00_17673:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17675;

														BgL_rz00_17675 =
															PROCEDURE_ENTRY(BgL_fz00_17674) (BgL_fz00_17674,
															BgL_nsz00_17668, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31567;

															if (PROCEDUREP(BgL_rz00_17675))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17676;

																	BgL_arg1696z00_17676 =
																		PROCEDURE_ATTR(BgL_rz00_17675);
																	if (STRUCTP(BgL_arg1696z00_17676))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31567 =
																				(STRUCT_KEY(BgL_arg1696z00_17676) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31567 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31567 = ((bool_t) 0);
																}
															if (BgL_testz00_31567)
																{
																	obj_t BgL_fz00_31575;

																	BgL_fz00_31575 = BgL_rz00_17675;
																	BgL_fz00_17674 = BgL_fz00_31575;
																	goto BgL_recz00_17673;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17668, ((long) 0),
																		BgL_savedzd2bpzd2_17672);
																	BgL_____rz00_17671 = BgL_rz00_17675;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17670);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17669, BgL_sz00_17663);
											return BgL_____rz00_17671;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5746 */
	obj_t BGl_z62run5746z62zz__evaluate_compz00(obj_t BgL_envz00_15133,
		obj_t BgL_sz00_15139)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15134;
				long BgL_siza7eza7_15135;
				obj_t BgL_valza2za2_15136;
				BgL_ev_absz00_bglt BgL_i1246z00_15137;
				obj_t BgL_bodyz00_15138;

				BgL_iboxesz00_15134 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15133, (int) (((long) 0))));
				BgL_siza7eza7_15135 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15133, (int) (((long) 1))));
				BgL_valza2za2_15136 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15133, (int) (((long) 2))));
				BgL_i1246z00_15137 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15133, (int) (((long) 3))));
				BgL_bodyz00_15138 = PROCEDURE_REF(BgL_envz00_15133, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17677;

					BgL_bpz00_17677 = VECTOR_REF(((obj_t) BgL_sz00_15139), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15139,
						BgL_iboxesz00_15134, BgL_bpz00_17677);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15139,
						BgL_valza2za2_15136,
						((long) CINT(BgL_bpz00_17677) + BgL_siza7eza7_15135));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17678;
						obj_t BgL_wherez00_17679;
						obj_t BgL_locz00_17680;

						BgL_z12denvz12_17678 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17679 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15137))->
							BgL_wherez00);
						BgL_locz00_17680 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15137))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17678, BgL_wherez00_17679,
								BgL_locz00_17680);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17681;

								BgL_za2za2resza2za2z00_17681 =
									PROCEDURE_ENTRY(BgL_bodyz00_15138) (BgL_bodyz00_15138,
									BgL_sz00_15139, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17678);
								return BgL_za2za2resza2za2z00_17681;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3425> */
	obj_t BGl_z62zc3anonymousza33425ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15140, obj_t BgL_sz00_15144)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15141;
				obj_t BgL_bodyz00_15142;
				long BgL_siza7ezd2framez75_15143;

				BgL_i1246z00_15141 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15140, (int) (((long) 0))));
				BgL_bodyz00_15142 = PROCEDURE_REF(BgL_envz00_15140, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15143 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15140, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17682;

					BgL_bpz00_17682 = VECTOR_REF(((obj_t) BgL_sz00_15144), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17683;

							BgL_runz00_17683 =
								MAKE_FX_PROCEDURE(BGl_z62run5748z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17683,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_15141));
							PROCEDURE_SET(BgL_runz00_17683,
								(int) (((long) 1)), BgL_bodyz00_15142);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17684;

								BgL_mainz00_17684 =
									MAKE_FX_PROCEDURE(BGl_z62main5747z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17684,
									(int) (((long) 0)), ((obj_t) BgL_i1246z00_15141));
								PROCEDURE_SET(BgL_mainz00_17684,
									(int) (((long) 1)), BgL_bodyz00_15142);
								PROCEDURE_SET(BgL_mainz00_17684,
									(int) (((long) 2)), BgL_runz00_17683);
								PROCEDURE_SET(BgL_mainz00_17684,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15143));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17685;

									BgL_objz00_17685 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17683, BgL_objz00_17685);
									BgL_objz00_17685;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3426z00_17686;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3428z00_17687;

										BgL_arg3428z00_17687 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15141))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17688;

											BgL_newz00_17688 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31643;

												BgL_tmpz00_31643 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17688, BgL_tmpz00_31643,
													BgL_arg3428z00_17687);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31648;
												int BgL_tmpz00_31646;

												BgL_auxz00_31648 = BINT(BgL_siza7ezd2framez75_15143);
												BgL_tmpz00_31646 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17688, BgL_tmpz00_31646,
													BgL_auxz00_31648);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31651;

												BgL_tmpz00_31651 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17688, BgL_tmpz00_31651,
													BgL_runz00_17683);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31656;
												int BgL_tmpz00_31654;

												BgL_auxz00_31656 = BINT(((long) 0));
												BgL_tmpz00_31654 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17688, BgL_tmpz00_31654,
													BgL_auxz00_31656);
											}
											BgL_arg3426z00_17686 = BgL_newz00_17688;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17684, BgL_arg3426z00_17686);
									BgL_arg3426z00_17686;
								}
								return BgL_mainz00_17684;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5747 */
	obj_t BGl_z62main5747z62zz__evaluate_compz00(obj_t BgL_envz00_15145)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15148;
				long BgL_siza7ezd2framez75_15149;

				BgL_runz00_15148 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15145, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15149 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15145, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17689;

					BgL_sz00_17689 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17690;

						BgL_bpz00_17690 = VECTOR_REF(((obj_t) BgL_sz00_17689), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17690) + BgL_siza7ezd2framez75_15149) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17689))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17691;

								BgL_ez00_17691 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17691,
									BgL_bpz00_17690);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17692;

									BgL_accz00_17692 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15148, BgL_sz00_17689, BgL_bpz00_17690);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17691);
									VECTOR_SET(
										((obj_t) BgL_sz00_17689), ((long) 0), BgL_bpz00_17690);
									return BgL_accz00_17692;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17693;

								BgL_nsz00_17693 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17693, ((long) 1), BgL_sz00_17689);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17694;

									BgL_z12denvz12_17694 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17694, BgL_nsz00_17693);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17695;

										BgL_ez00_17695 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17695,
											BgL_sz00_17689);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17696;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17697;

												BgL_savedzd2bpzd2_17697 =
													VECTOR_REF(BgL_nsz00_17693, ((long) 0));
												VECTOR_SET(BgL_nsz00_17693, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17699;

													BgL_fz00_17699 = BgL_runz00_15148;
												BgL_recz00_17698:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17700;

														BgL_rz00_17700 =
															PROCEDURE_ENTRY(BgL_fz00_17699) (BgL_fz00_17699,
															BgL_nsz00_17693, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31694;

															if (PROCEDUREP(BgL_rz00_17700))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17701;

																	BgL_arg1696z00_17701 =
																		PROCEDURE_ATTR(BgL_rz00_17700);
																	if (STRUCTP(BgL_arg1696z00_17701))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31694 =
																				(STRUCT_KEY(BgL_arg1696z00_17701) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31694 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31694 = ((bool_t) 0);
																}
															if (BgL_testz00_31694)
																{
																	obj_t BgL_fz00_31702;

																	BgL_fz00_31702 = BgL_rz00_17700;
																	BgL_fz00_17699 = BgL_fz00_31702;
																	goto BgL_recz00_17698;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17693, ((long) 0),
																		BgL_savedzd2bpzd2_17697);
																	BgL_____rz00_17696 = BgL_rz00_17700;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17695);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17694, BgL_sz00_17689);
											return BgL_____rz00_17696;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5748 */
	obj_t BGl_z62run5748z62zz__evaluate_compz00(obj_t BgL_envz00_15150,
		obj_t BgL_sz00_15153)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15151;
				obj_t BgL_bodyz00_15152;

				BgL_i1246z00_15151 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15150, (int) (((long) 0))));
				BgL_bodyz00_15152 = PROCEDURE_REF(BgL_envz00_15150, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17702;

					BgL_bpz00_17702 = VECTOR_REF(((obj_t) BgL_sz00_15153), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17703;
						obj_t BgL_wherez00_17704;
						obj_t BgL_locz00_17705;

						BgL_z12denvz12_17703 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17704 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15151))->
							BgL_wherez00);
						BgL_locz00_17705 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15151))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17703, BgL_wherez00_17704,
								BgL_locz00_17705);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17706;

								BgL_za2za2resza2za2z00_17706 =
									PROCEDURE_ENTRY(BgL_bodyz00_15152) (BgL_bodyz00_15152,
									BgL_sz00_15153, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17703);
								return BgL_za2za2resza2za2z00_17706;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3432> */
	obj_t BGl_z62zc3anonymousza33432ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15154, obj_t BgL_sz00_15159)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15155;
				BgL_ev_absz00_bglt BgL_i1246z00_15156;
				obj_t BgL_bodyz00_15157;
				long BgL_siza7ezd2framez75_15158;

				BgL_iboxesz00_15155 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 0))));
				BgL_i1246z00_15156 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 1))));
				BgL_bodyz00_15157 = PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15158 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17707;

					BgL_bpz00_17707 = VECTOR_REF(((obj_t) BgL_sz00_15159), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17708;

							BgL_runz00_17708 =
								MAKE_FX_PROCEDURE(BGl_z62run5750z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17708,
								(int) (((long) 0)), BgL_iboxesz00_15155);
							PROCEDURE_SET(BgL_runz00_17708,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_15156));
							PROCEDURE_SET(BgL_runz00_17708,
								(int) (((long) 2)), BgL_bodyz00_15157);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17709;

								BgL_mainz00_17709 =
									MAKE_FX_PROCEDURE(BGl_z62main5749z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17709,
									(int) (((long) 0)), BgL_iboxesz00_15155);
								PROCEDURE_SET(BgL_mainz00_17709,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_15156));
								PROCEDURE_SET(BgL_mainz00_17709,
									(int) (((long) 2)), BgL_bodyz00_15157);
								PROCEDURE_SET(BgL_mainz00_17709,
									(int) (((long) 3)), BgL_runz00_17708);
								PROCEDURE_SET(BgL_mainz00_17709,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15158));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17710;

									BgL_objz00_17710 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17708, BgL_objz00_17710);
									BgL_objz00_17710;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3433z00_17711;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3434z00_17712;

										BgL_arg3434z00_17712 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15156))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17713;

											BgL_newz00_17713 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31764;

												BgL_tmpz00_31764 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17713, BgL_tmpz00_31764,
													BgL_arg3434z00_17712);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31769;
												int BgL_tmpz00_31767;

												BgL_auxz00_31769 = BINT(BgL_siza7ezd2framez75_15158);
												BgL_tmpz00_31767 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17713, BgL_tmpz00_31767,
													BgL_auxz00_31769);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31772;

												BgL_tmpz00_31772 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17713, BgL_tmpz00_31772,
													BgL_runz00_17708);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31777;
												int BgL_tmpz00_31775;

												BgL_auxz00_31777 = BINT(((long) 0));
												BgL_tmpz00_31775 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17713, BgL_tmpz00_31775,
													BgL_auxz00_31777);
											}
											BgL_arg3433z00_17711 = BgL_newz00_17713;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17709, BgL_arg3433z00_17711);
									BgL_arg3433z00_17711;
								}
								return BgL_mainz00_17709;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5749 */
	obj_t BGl_z62main5749z62zz__evaluate_compz00(obj_t BgL_envz00_15160)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15164;
				long BgL_siza7ezd2framez75_15165;

				BgL_runz00_15164 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15160, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15165 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15160, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17714;

					BgL_sz00_17714 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17715;

						BgL_bpz00_17715 = VECTOR_REF(((obj_t) BgL_sz00_17714), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17715) + BgL_siza7ezd2framez75_15165) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17714))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17716;

								BgL_ez00_17716 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17716,
									BgL_bpz00_17715);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17717;

									BgL_accz00_17717 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15164, BgL_sz00_17714, BgL_bpz00_17715);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17716);
									VECTOR_SET(
										((obj_t) BgL_sz00_17714), ((long) 0), BgL_bpz00_17715);
									return BgL_accz00_17717;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17718;

								BgL_nsz00_17718 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17718, ((long) 1), BgL_sz00_17714);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17719;

									BgL_z12denvz12_17719 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17719, BgL_nsz00_17718);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17720;

										BgL_ez00_17720 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17720,
											BgL_sz00_17714);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17721;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17722;

												BgL_savedzd2bpzd2_17722 =
													VECTOR_REF(BgL_nsz00_17718, ((long) 0));
												VECTOR_SET(BgL_nsz00_17718, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17724;

													BgL_fz00_17724 = BgL_runz00_15164;
												BgL_recz00_17723:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17725;

														BgL_rz00_17725 =
															PROCEDURE_ENTRY(BgL_fz00_17724) (BgL_fz00_17724,
															BgL_nsz00_17718, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31815;

															if (PROCEDUREP(BgL_rz00_17725))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17726;

																	BgL_arg1696z00_17726 =
																		PROCEDURE_ATTR(BgL_rz00_17725);
																	if (STRUCTP(BgL_arg1696z00_17726))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31815 =
																				(STRUCT_KEY(BgL_arg1696z00_17726) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31815 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31815 = ((bool_t) 0);
																}
															if (BgL_testz00_31815)
																{
																	obj_t BgL_fz00_31823;

																	BgL_fz00_31823 = BgL_rz00_17725;
																	BgL_fz00_17724 = BgL_fz00_31823;
																	goto BgL_recz00_17723;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17718, ((long) 0),
																		BgL_savedzd2bpzd2_17722);
																	BgL_____rz00_17721 = BgL_rz00_17725;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17720);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17719, BgL_sz00_17714);
											return BgL_____rz00_17721;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5750 */
	obj_t BGl_z62run5750z62zz__evaluate_compz00(obj_t BgL_envz00_15166,
		obj_t BgL_sz00_15170)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15167;
				BgL_ev_absz00_bglt BgL_i1246z00_15168;
				obj_t BgL_bodyz00_15169;

				BgL_iboxesz00_15167 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15166, (int) (((long) 0))));
				BgL_i1246z00_15168 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15166, (int) (((long) 1))));
				BgL_bodyz00_15169 = PROCEDURE_REF(BgL_envz00_15166, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17727;

					BgL_bpz00_17727 = VECTOR_REF(((obj_t) BgL_sz00_15170), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15170,
						BgL_iboxesz00_15167, BgL_bpz00_17727);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17728;
						obj_t BgL_wherez00_17729;
						obj_t BgL_locz00_17730;

						BgL_z12denvz12_17728 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17729 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15168))->
							BgL_wherez00);
						BgL_locz00_17730 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15168))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17728, BgL_wherez00_17729,
								BgL_locz00_17730);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17731;

								BgL_za2za2resza2za2z00_17731 =
									PROCEDURE_ENTRY(BgL_bodyz00_15169) (BgL_bodyz00_15169,
									BgL_sz00_15170, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17728);
								return BgL_za2za2resza2za2z00_17731;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3442> */
	obj_t BGl_z62zc3anonymousza33442ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15171, obj_t BgL_sz00_15177)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15172;
				long BgL_siza7eza7_15173;
				BgL_ev_absz00_bglt BgL_i1246z00_15174;
				obj_t BgL_bodyz00_15175;
				long BgL_siza7ezd2framez75_15176;

				BgL_ifreesz00_15172 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15171, (int) (((long) 0))));
				BgL_siza7eza7_15173 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15171, (int) (((long) 1))));
				BgL_i1246z00_15174 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15171, (int) (((long) 2))));
				BgL_bodyz00_15175 = PROCEDURE_REF(BgL_envz00_15171, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15176 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15171, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17732;

					BgL_bpz00_17732 = VECTOR_REF(((obj_t) BgL_sz00_15177), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17733;

						BgL_valza2za2_17733 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15177,
							BgL_bpz00_17732, BgL_ifreesz00_15172);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17734;

							BgL_runz00_17734 =
								MAKE_FX_PROCEDURE(BGl_z62run5752z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17734,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15173));
							PROCEDURE_SET(BgL_runz00_17734,
								(int) (((long) 1)), BgL_valza2za2_17733);
							PROCEDURE_SET(BgL_runz00_17734,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_15174));
							PROCEDURE_SET(BgL_runz00_17734,
								(int) (((long) 3)), BgL_bodyz00_15175);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17735;

								BgL_mainz00_17735 =
									MAKE_FX_PROCEDURE(BGl_z62main5751z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17735,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15173));
								PROCEDURE_SET(BgL_mainz00_17735,
									(int) (((long) 1)), BgL_valza2za2_17733);
								PROCEDURE_SET(BgL_mainz00_17735,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_15174));
								PROCEDURE_SET(BgL_mainz00_17735,
									(int) (((long) 3)), BgL_bodyz00_15175);
								PROCEDURE_SET(BgL_mainz00_17735,
									(int) (((long) 4)), BgL_runz00_17734);
								PROCEDURE_SET(BgL_mainz00_17735,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15176));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17736;

									BgL_objz00_17736 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17734, BgL_objz00_17736);
									BgL_objz00_17736;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3444z00_17737;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3445z00_17738;

										BgL_arg3445z00_17738 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15174))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17739;

											BgL_newz00_17739 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31899;

												BgL_tmpz00_31899 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17739, BgL_tmpz00_31899,
													BgL_arg3445z00_17738);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31904;
												int BgL_tmpz00_31902;

												BgL_auxz00_31904 = BINT(BgL_siza7ezd2framez75_15176);
												BgL_tmpz00_31902 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17739, BgL_tmpz00_31902,
													BgL_auxz00_31904);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_31907;

												BgL_tmpz00_31907 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17739, BgL_tmpz00_31907,
													BgL_runz00_17734);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_31912;
												int BgL_tmpz00_31910;

												BgL_auxz00_31912 = BINT(((long) 0));
												BgL_tmpz00_31910 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17739, BgL_tmpz00_31910,
													BgL_auxz00_31912);
											}
											BgL_arg3444z00_17737 = BgL_newz00_17739;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17735, BgL_arg3444z00_17737);
									BgL_arg3444z00_17737;
								}
								return BgL_mainz00_17735;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5751 */
	obj_t BGl_z62main5751z62zz__evaluate_compz00(obj_t BgL_envz00_15178)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15183;
				long BgL_siza7ezd2framez75_15184;

				BgL_runz00_15183 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15178, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15184 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15178, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17740;

					BgL_sz00_17740 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17741;

						BgL_bpz00_17741 = VECTOR_REF(((obj_t) BgL_sz00_17740), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17741) + BgL_siza7ezd2framez75_15184) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17740))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17742;

								BgL_ez00_17742 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17742,
									BgL_bpz00_17741);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17743;

									BgL_accz00_17743 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15183, BgL_sz00_17740, BgL_bpz00_17741);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17742);
									VECTOR_SET(
										((obj_t) BgL_sz00_17740), ((long) 0), BgL_bpz00_17741);
									return BgL_accz00_17743;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17744;

								BgL_nsz00_17744 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17744, ((long) 1), BgL_sz00_17740);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17745;

									BgL_z12denvz12_17745 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17745, BgL_nsz00_17744);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17746;

										BgL_ez00_17746 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17746,
											BgL_sz00_17740);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17747;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17748;

												BgL_savedzd2bpzd2_17748 =
													VECTOR_REF(BgL_nsz00_17744, ((long) 0));
												VECTOR_SET(BgL_nsz00_17744, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17750;

													BgL_fz00_17750 = BgL_runz00_15183;
												BgL_recz00_17749:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17751;

														BgL_rz00_17751 =
															PROCEDURE_ENTRY(BgL_fz00_17750) (BgL_fz00_17750,
															BgL_nsz00_17744, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_31950;

															if (PROCEDUREP(BgL_rz00_17751))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17752;

																	BgL_arg1696z00_17752 =
																		PROCEDURE_ATTR(BgL_rz00_17751);
																	if (STRUCTP(BgL_arg1696z00_17752))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31950 =
																				(STRUCT_KEY(BgL_arg1696z00_17752) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_31950 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_31950 = ((bool_t) 0);
																}
															if (BgL_testz00_31950)
																{
																	obj_t BgL_fz00_31958;

																	BgL_fz00_31958 = BgL_rz00_17751;
																	BgL_fz00_17750 = BgL_fz00_31958;
																	goto BgL_recz00_17749;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17744, ((long) 0),
																		BgL_savedzd2bpzd2_17748);
																	BgL_____rz00_17747 = BgL_rz00_17751;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17746);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17745, BgL_sz00_17740);
											return BgL_____rz00_17747;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5752 */
	obj_t BGl_z62run5752z62zz__evaluate_compz00(obj_t BgL_envz00_15185,
		obj_t BgL_sz00_15190)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15186;
				obj_t BgL_valza2za2_15187;
				BgL_ev_absz00_bglt BgL_i1246z00_15188;
				obj_t BgL_bodyz00_15189;

				BgL_siza7eza7_15186 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15185, (int) (((long) 0))));
				BgL_valza2za2_15187 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15185, (int) (((long) 1))));
				BgL_i1246z00_15188 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15185, (int) (((long) 2))));
				BgL_bodyz00_15189 = PROCEDURE_REF(BgL_envz00_15185, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17753;

					BgL_bpz00_17753 = VECTOR_REF(((obj_t) BgL_sz00_15190), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15190,
						BgL_valza2za2_15187,
						((long) CINT(BgL_bpz00_17753) + BgL_siza7eza7_15186));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17754;
						obj_t BgL_wherez00_17755;
						obj_t BgL_locz00_17756;

						BgL_z12denvz12_17754 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17755 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15188))->
							BgL_wherez00);
						BgL_locz00_17756 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15188))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17754, BgL_wherez00_17755,
								BgL_locz00_17756);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17757;

								BgL_za2za2resza2za2z00_17757 =
									PROCEDURE_ENTRY(BgL_bodyz00_15189) (BgL_bodyz00_15189,
									BgL_sz00_15190, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17754);
								return BgL_za2za2resza2za2z00_17757;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3450> */
	obj_t BGl_z62zc3anonymousza33450ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15191, obj_t BgL_sz00_15198)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15192;
				obj_t BgL_iboxesz00_15193;
				long BgL_siza7eza7_15194;
				BgL_ev_absz00_bglt BgL_i1246z00_15195;
				obj_t BgL_bodyz00_15196;
				long BgL_siza7ezd2framez75_15197;

				BgL_ifreesz00_15192 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 0))));
				BgL_iboxesz00_15193 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 1))));
				BgL_siza7eza7_15194 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 2))));
				BgL_i1246z00_15195 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 3))));
				BgL_bodyz00_15196 = PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15197 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15191, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17758;

					BgL_bpz00_17758 = VECTOR_REF(((obj_t) BgL_sz00_15198), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17759;

						BgL_valza2za2_17759 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15198,
							BgL_bpz00_17758, BgL_ifreesz00_15192);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17760;

							BgL_runz00_17760 =
								MAKE_FX_PROCEDURE(BGl_z62run5754z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17760,
								(int) (((long) 0)), BgL_iboxesz00_15193);
							PROCEDURE_SET(BgL_runz00_17760,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15194));
							PROCEDURE_SET(BgL_runz00_17760,
								(int) (((long) 2)), BgL_valza2za2_17759);
							PROCEDURE_SET(BgL_runz00_17760,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_15195));
							PROCEDURE_SET(BgL_runz00_17760,
								(int) (((long) 4)), BgL_bodyz00_15196);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17761;

								BgL_mainz00_17761 =
									MAKE_FX_PROCEDURE(BGl_z62main5753z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 0)), BgL_iboxesz00_15193);
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15194));
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 2)), BgL_valza2za2_17759);
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_15195));
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 4)), BgL_bodyz00_15196);
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 5)), BgL_runz00_17760);
								PROCEDURE_SET(BgL_mainz00_17761,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15197));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17762;

									BgL_objz00_17762 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17760, BgL_objz00_17762);
									BgL_objz00_17762;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3451z00_17763;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3452z00_17764;

										BgL_arg3452z00_17764 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15195))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17765;

											BgL_newz00_17765 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32046;

												BgL_tmpz00_32046 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17765, BgL_tmpz00_32046,
													BgL_arg3452z00_17764);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32051;
												int BgL_tmpz00_32049;

												BgL_auxz00_32051 = BINT(BgL_siza7ezd2framez75_15197);
												BgL_tmpz00_32049 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17765, BgL_tmpz00_32049,
													BgL_auxz00_32051);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32054;

												BgL_tmpz00_32054 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17765, BgL_tmpz00_32054,
													BgL_runz00_17760);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32059;
												int BgL_tmpz00_32057;

												BgL_auxz00_32059 = BINT(((long) 0));
												BgL_tmpz00_32057 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17765, BgL_tmpz00_32057,
													BgL_auxz00_32059);
											}
											BgL_arg3451z00_17763 = BgL_newz00_17765;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17761, BgL_arg3451z00_17763);
									BgL_arg3451z00_17763;
								}
								return BgL_mainz00_17761;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5753 */
	obj_t BGl_z62main5753z62zz__evaluate_compz00(obj_t BgL_envz00_15199)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_runz00_15205;
				long BgL_siza7ezd2framez75_15206;

				BgL_runz00_15205 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15206 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15199, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17766;

					BgL_sz00_17766 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17767;

						BgL_bpz00_17767 = VECTOR_REF(((obj_t) BgL_sz00_17766), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17767) + BgL_siza7ezd2framez75_15206) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17766))))
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_ez00_17768;

								BgL_ez00_17768 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17768,
									BgL_bpz00_17767);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_accz00_17769;

									BgL_accz00_17769 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15205, BgL_sz00_17766, BgL_bpz00_17767);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17768);
									VECTOR_SET(
										((obj_t) BgL_sz00_17766), ((long) 0), BgL_bpz00_17767);
									return BgL_accz00_17769;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17770;

								BgL_nsz00_17770 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17770, ((long) 1), BgL_sz00_17766);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17771;

									BgL_z12denvz12_17771 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17771, BgL_nsz00_17770);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17772;

										BgL_ez00_17772 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17772,
											BgL_sz00_17766);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17773;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17774;

												BgL_savedzd2bpzd2_17774 =
													VECTOR_REF(BgL_nsz00_17770, ((long) 0));
												VECTOR_SET(BgL_nsz00_17770, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17776;

													BgL_fz00_17776 = BgL_runz00_15205;
												BgL_recz00_17775:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17777;

														BgL_rz00_17777 =
															PROCEDURE_ENTRY(BgL_fz00_17776) (BgL_fz00_17776,
															BgL_nsz00_17770, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_32097;

															if (PROCEDUREP(BgL_rz00_17777))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17778;

																	BgL_arg1696z00_17778 =
																		PROCEDURE_ATTR(BgL_rz00_17777);
																	if (STRUCTP(BgL_arg1696z00_17778))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32097 =
																				(STRUCT_KEY(BgL_arg1696z00_17778) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32097 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_32097 = ((bool_t) 0);
																}
															if (BgL_testz00_32097)
																{
																	obj_t BgL_fz00_32105;

																	BgL_fz00_32105 = BgL_rz00_17777;
																	BgL_fz00_17776 = BgL_fz00_32105;
																	goto BgL_recz00_17775;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17770, ((long) 0),
																		BgL_savedzd2bpzd2_17774);
																	BgL_____rz00_17773 = BgL_rz00_17777;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17772);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17771, BgL_sz00_17766);
											return BgL_____rz00_17773;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5754 */
	obj_t BGl_z62run5754z62zz__evaluate_compz00(obj_t BgL_envz00_15207,
		obj_t BgL_sz00_15213)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15208;
				long BgL_siza7eza7_15209;
				obj_t BgL_valza2za2_15210;
				BgL_ev_absz00_bglt BgL_i1246z00_15211;
				obj_t BgL_bodyz00_15212;

				BgL_iboxesz00_15208 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15207, (int) (((long) 0))));
				BgL_siza7eza7_15209 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15207, (int) (((long) 1))));
				BgL_valza2za2_15210 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15207, (int) (((long) 2))));
				BgL_i1246z00_15211 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15207, (int) (((long) 3))));
				BgL_bodyz00_15212 = PROCEDURE_REF(BgL_envz00_15207, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17779;

					BgL_bpz00_17779 = VECTOR_REF(((obj_t) BgL_sz00_15213), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15213,
						BgL_iboxesz00_15208, BgL_bpz00_17779);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15213,
						BgL_valza2za2_15210,
						((long) CINT(BgL_bpz00_17779) + BgL_siza7eza7_15209));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17780;
						obj_t BgL_wherez00_17781;
						obj_t BgL_locz00_17782;

						BgL_z12denvz12_17780 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17781 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15211))->
							BgL_wherez00);
						BgL_locz00_17782 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15211))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17780, BgL_wherez00_17781,
								BgL_locz00_17782);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17783;

								BgL_za2za2resza2za2z00_17783 =
									PROCEDURE_ENTRY(BgL_bodyz00_15212) (BgL_bodyz00_15212,
									BgL_sz00_15213, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17780);
								return BgL_za2za2resza2za2z00_17783;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3902> */
	obj_t BGl_z62zc3anonymousza33902ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15214, obj_t BgL_sz00_15218)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15215;
				obj_t BgL_bodyz00_15216;
				long BgL_siza7ezd2framez75_15217;

				BgL_i1246z00_15215 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15214, (int) (((long) 0))));
				BgL_bodyz00_15216 = PROCEDURE_REF(BgL_envz00_15214, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15217 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15214, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17784;

					BgL_bpz00_17784 = VECTOR_REF(((obj_t) BgL_sz00_15218), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17785;

							BgL_runz00_17785 =
								MAKE_FX_PROCEDURE(BGl_z62run5756z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17785,
								(int) (((long) 0)), ((obj_t) BgL_i1246z00_15215));
							PROCEDURE_SET(BgL_runz00_17785,
								(int) (((long) 1)), BgL_bodyz00_15216);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17786;

								BgL_mainz00_17786 =
									MAKE_VA_PROCEDURE(BGl_z62main5755z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17786,
									(int) (((long) 0)), BgL_bodyz00_15216);
								PROCEDURE_SET(BgL_mainz00_17786,
									(int) (((long) 1)), ((obj_t) BgL_i1246z00_15215));
								PROCEDURE_SET(BgL_mainz00_17786,
									(int) (((long) 2)), BgL_runz00_17785);
								PROCEDURE_SET(BgL_mainz00_17786,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15217));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17787;

									BgL_objz00_17787 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17785, BgL_objz00_17787);
									BgL_objz00_17787;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3903z00_17788;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3904z00_17789;
										obj_t BgL_arg3905z00_17790;

										BgL_arg3904z00_17789 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15215))->
											BgL_arityz00);
										BgL_arg3905z00_17790 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15215))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17791;

											BgL_newz00_17791 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32174;

												BgL_tmpz00_32174 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17791, BgL_tmpz00_32174,
													BgL_arg3905z00_17790);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32179;
												int BgL_tmpz00_32177;

												BgL_auxz00_32179 = BINT(BgL_siza7ezd2framez75_15217);
												BgL_tmpz00_32177 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17791, BgL_tmpz00_32177,
													BgL_auxz00_32179);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32182;

												BgL_tmpz00_32182 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17791, BgL_tmpz00_32182,
													BgL_runz00_17785);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32185;

												BgL_tmpz00_32185 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17791, BgL_tmpz00_32185,
													BgL_arg3904z00_17789);
											}
											BgL_arg3903z00_17788 = BgL_newz00_17791;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17786, BgL_arg3903z00_17788);
									BgL_arg3903z00_17788;
								}
								return BgL_mainz00_17786;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5755 */
	obj_t BGl_z62main5755z62zz__evaluate_compz00(obj_t BgL_envz00_15219,
		obj_t BgL_az00_15224, obj_t BgL_bz00_15225, obj_t BgL_cz00_15226,
		obj_t BgL_dz00_15227, obj_t BgL_restz00_15228)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15221;
				obj_t BgL_runz00_15222;
				long BgL_siza7ezd2framez75_15223;

				BgL_i1246z00_15221 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15219, (int) (((long) 1))));
				BgL_runz00_15222 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15219, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15223 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15219, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17792;

					BgL_sz00_17792 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17793;

						BgL_bpz00_17793 = VECTOR_REF(((obj_t) BgL_sz00_17792), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17793) + BgL_siza7ezd2framez75_15223) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17792))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3908z00_17794;

									BgL_arg3908z00_17794 =
										((long) CINT(BgL_bpz00_17793) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17792), BgL_arg3908z00_17794,
										BgL_az00_15224);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3909z00_17795;

									BgL_arg3909z00_17795 =
										((long) CINT(BgL_bpz00_17793) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17792), BgL_arg3909z00_17795,
										BgL_bz00_15225);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3910z00_17796;

									BgL_arg3910z00_17796 =
										((long) CINT(BgL_bpz00_17793) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17792), BgL_arg3910z00_17796,
										BgL_cz00_15226);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3911z00_17797;

									BgL_arg3911z00_17797 =
										((long) CINT(BgL_bpz00_17793) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17792), BgL_arg3911z00_17797,
										BgL_dz00_15227);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3912z00_17798;
									long BgL_arg3913z00_17799;
									long BgL_arg3914z00_17800;
									obj_t BgL_arg3915z00_17801;

									BgL_arg3912z00_17798 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15221))->
										BgL_wherez00);
									BgL_arg3913z00_17799 =
										((long) CINT(BgL_bpz00_17793) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3916z00_17802;

										BgL_arg3916z00_17802 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15221))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3916z00_17802) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3914z00_17800 =
													((long) CINT(BgL_arg3916z00_17802) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3914z00_17800 =
													((long) CINT(BgL_arg3916z00_17802) - ((long) 4));
									}}
									BgL_arg3915z00_17801 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15221))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17792,
										BgL_arg3912z00_17798, BgL_arg3913z00_17799,
										BgL_arg3914z00_17800, BgL_restz00_15228,
										BgL_arg3915z00_17801);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17803;

									BgL_ez00_17803 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17803,
										BgL_bpz00_17793);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17804;

										BgL_accz00_17804 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15222, BgL_sz00_17792, BgL_bpz00_17793);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17803);
										VECTOR_SET(
											((obj_t) BgL_sz00_17792), ((long) 0), BgL_bpz00_17793);
										return BgL_accz00_17804;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17805;

								BgL_nsz00_17805 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17805, ((long) 1), BgL_sz00_17792);
								VECTOR_SET(BgL_nsz00_17805, ((long) 2), BgL_az00_15224);
								VECTOR_SET(BgL_nsz00_17805, ((long) 3), BgL_bz00_15225);
								VECTOR_SET(BgL_nsz00_17805, ((long) 4), BgL_cz00_15226);
								VECTOR_SET(BgL_nsz00_17805, ((long) 5), BgL_dz00_15227);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3917z00_17806;
									long BgL_arg3918z00_17807;
									obj_t BgL_arg3919z00_17808;

									BgL_arg3917z00_17806 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15221))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3920z00_17809;

										BgL_arg3920z00_17809 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15221))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3920z00_17809) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3918z00_17807 =
													((long) CINT(BgL_arg3920z00_17809) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3918z00_17807 =
													((long) CINT(BgL_arg3920z00_17809) - ((long) 4));
									}}
									BgL_arg3919z00_17808 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15221))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17805,
										BgL_arg3917z00_17806, ((long) 6), BgL_arg3918z00_17807,
										BgL_restz00_15228, BgL_arg3919z00_17808);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17810;

									BgL_z12denvz12_17810 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17810, BgL_nsz00_17805);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17811;

										BgL_ez00_17811 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17811,
											BgL_sz00_17792);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17812;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17813;

												BgL_savedzd2bpzd2_17813 =
													VECTOR_REF(BgL_nsz00_17805, ((long) 0));
												VECTOR_SET(BgL_nsz00_17805, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17815;

													BgL_fz00_17815 = BgL_runz00_15222;
												BgL_recz00_17814:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17816;

														BgL_rz00_17816 =
															PROCEDURE_ENTRY(BgL_fz00_17815) (BgL_fz00_17815,
															BgL_nsz00_17805, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_32270;

															if (PROCEDUREP(BgL_rz00_17816))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17817;

																	BgL_arg1696z00_17817 =
																		PROCEDURE_ATTR(BgL_rz00_17816);
																	if (STRUCTP(BgL_arg1696z00_17817))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32270 =
																				(STRUCT_KEY(BgL_arg1696z00_17817) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32270 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_32270 = ((bool_t) 0);
																}
															if (BgL_testz00_32270)
																{
																	obj_t BgL_fz00_32278;

																	BgL_fz00_32278 = BgL_rz00_17816;
																	BgL_fz00_17815 = BgL_fz00_32278;
																	goto BgL_recz00_17814;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17805, ((long) 0),
																		BgL_savedzd2bpzd2_17813);
																	BgL_____rz00_17812 = BgL_rz00_17816;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17811);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17810, BgL_sz00_17792);
											return BgL_____rz00_17812;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5756 */
	obj_t BGl_z62run5756z62zz__evaluate_compz00(obj_t BgL_envz00_15229,
		obj_t BgL_sz00_15232)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15230;
				obj_t BgL_bodyz00_15231;

				BgL_i1246z00_15230 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15229, (int) (((long) 0))));
				BgL_bodyz00_15231 = PROCEDURE_REF(BgL_envz00_15229, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17818;

					BgL_bpz00_17818 = VECTOR_REF(((obj_t) BgL_sz00_15232), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17819;
						obj_t BgL_wherez00_17820;
						obj_t BgL_locz00_17821;

						BgL_z12denvz12_17819 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17820 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15230))->
							BgL_wherez00);
						BgL_locz00_17821 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15230))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17819, BgL_wherez00_17820,
								BgL_locz00_17821);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17822;

								BgL_za2za2resza2za2z00_17822 =
									PROCEDURE_ENTRY(BgL_bodyz00_15231) (BgL_bodyz00_15231,
									BgL_sz00_15232, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17819);
								return BgL_za2za2resza2za2z00_17822;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3922> */
	obj_t BGl_z62zc3anonymousza33922ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15233, obj_t BgL_sz00_15238)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15234;
				BgL_ev_absz00_bglt BgL_i1246z00_15235;
				obj_t BgL_bodyz00_15236;
				long BgL_siza7ezd2framez75_15237;

				BgL_iboxesz00_15234 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15233, (int) (((long) 0))));
				BgL_i1246z00_15235 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15233, (int) (((long) 1))));
				BgL_bodyz00_15236 = PROCEDURE_REF(BgL_envz00_15233, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15237 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15233, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17823;

					BgL_bpz00_17823 = VECTOR_REF(((obj_t) BgL_sz00_15238), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */

						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17824;

							BgL_runz00_17824 =
								MAKE_FX_PROCEDURE(BGl_z62run5758z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17824,
								(int) (((long) 0)), BgL_iboxesz00_15234);
							PROCEDURE_SET(BgL_runz00_17824,
								(int) (((long) 1)), ((obj_t) BgL_i1246z00_15235));
							PROCEDURE_SET(BgL_runz00_17824,
								(int) (((long) 2)), BgL_bodyz00_15236);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17825;

								BgL_mainz00_17825 =
									MAKE_VA_PROCEDURE(BGl_z62main5757z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17825,
									(int) (((long) 0)), BgL_iboxesz00_15234);
								PROCEDURE_SET(BgL_mainz00_17825,
									(int) (((long) 1)), BgL_bodyz00_15236);
								PROCEDURE_SET(BgL_mainz00_17825,
									(int) (((long) 2)), ((obj_t) BgL_i1246z00_15235));
								PROCEDURE_SET(BgL_mainz00_17825,
									(int) (((long) 3)), BgL_runz00_17824);
								PROCEDURE_SET(BgL_mainz00_17825,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15237));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17826;

									BgL_objz00_17826 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17824, BgL_objz00_17826);
									BgL_objz00_17826;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3923z00_17827;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3924z00_17828;
										obj_t BgL_arg3925z00_17829;

										BgL_arg3924z00_17828 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15235))->
											BgL_arityz00);
										BgL_arg3925z00_17829 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15235))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17830;

											BgL_newz00_17830 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32341;

												BgL_tmpz00_32341 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17830, BgL_tmpz00_32341,
													BgL_arg3925z00_17829);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32346;
												int BgL_tmpz00_32344;

												BgL_auxz00_32346 = BINT(BgL_siza7ezd2framez75_15237);
												BgL_tmpz00_32344 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17830, BgL_tmpz00_32344,
													BgL_auxz00_32346);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32349;

												BgL_tmpz00_32349 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17830, BgL_tmpz00_32349,
													BgL_runz00_17824);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32352;

												BgL_tmpz00_32352 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17830, BgL_tmpz00_32352,
													BgL_arg3924z00_17828);
											}
											BgL_arg3923z00_17827 = BgL_newz00_17830;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17825, BgL_arg3923z00_17827);
									BgL_arg3923z00_17827;
								}
								return BgL_mainz00_17825;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5757 */
	obj_t BGl_z62main5757z62zz__evaluate_compz00(obj_t BgL_envz00_15239,
		obj_t BgL_az00_15245, obj_t BgL_bz00_15246, obj_t BgL_cz00_15247,
		obj_t BgL_dz00_15248, obj_t BgL_restz00_15249)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15242;
				obj_t BgL_runz00_15243;
				long BgL_siza7ezd2framez75_15244;

				BgL_i1246z00_15242 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15239, (int) (((long) 2))));
				BgL_runz00_15243 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15239, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15244 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15239, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17831;

					BgL_sz00_17831 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17832;

						BgL_bpz00_17832 = VECTOR_REF(((obj_t) BgL_sz00_17831), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17832) + BgL_siza7ezd2framez75_15244) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17831))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3928z00_17833;

									BgL_arg3928z00_17833 =
										((long) CINT(BgL_bpz00_17832) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17831), BgL_arg3928z00_17833,
										BgL_az00_15245);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3929z00_17834;

									BgL_arg3929z00_17834 =
										((long) CINT(BgL_bpz00_17832) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17831), BgL_arg3929z00_17834,
										BgL_bz00_15246);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3930z00_17835;

									BgL_arg3930z00_17835 =
										((long) CINT(BgL_bpz00_17832) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17831), BgL_arg3930z00_17835,
										BgL_cz00_15247);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3931z00_17836;

									BgL_arg3931z00_17836 =
										((long) CINT(BgL_bpz00_17832) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17831), BgL_arg3931z00_17836,
										BgL_dz00_15248);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3932z00_17837;
									long BgL_arg3933z00_17838;
									long BgL_arg3934z00_17839;
									obj_t BgL_arg3935z00_17840;

									BgL_arg3932z00_17837 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15242))->
										BgL_wherez00);
									BgL_arg3933z00_17838 =
										((long) CINT(BgL_bpz00_17832) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3936z00_17841;

										BgL_arg3936z00_17841 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15242))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3936z00_17841) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3934z00_17839 =
													((long) CINT(BgL_arg3936z00_17841) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3934z00_17839 =
													((long) CINT(BgL_arg3936z00_17841) - ((long) 4));
									}}
									BgL_arg3935z00_17840 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15242))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17831,
										BgL_arg3932z00_17837, BgL_arg3933z00_17838,
										BgL_arg3934z00_17839, BgL_restz00_15249,
										BgL_arg3935z00_17840);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17842;

									BgL_ez00_17842 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17842,
										BgL_bpz00_17832);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17843;

										BgL_accz00_17843 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15243, BgL_sz00_17831, BgL_bpz00_17832);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17842);
										VECTOR_SET(
											((obj_t) BgL_sz00_17831), ((long) 0), BgL_bpz00_17832);
										return BgL_accz00_17843;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17844;

								BgL_nsz00_17844 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17844, ((long) 1), BgL_sz00_17831);
								VECTOR_SET(BgL_nsz00_17844, ((long) 2), BgL_az00_15245);
								VECTOR_SET(BgL_nsz00_17844, ((long) 3), BgL_bz00_15246);
								VECTOR_SET(BgL_nsz00_17844, ((long) 4), BgL_cz00_15247);
								VECTOR_SET(BgL_nsz00_17844, ((long) 5), BgL_dz00_15248);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3937z00_17845;
									long BgL_arg3938z00_17846;
									obj_t BgL_arg3939z00_17847;

									BgL_arg3937z00_17845 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15242))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3940z00_17848;

										BgL_arg3940z00_17848 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15242))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3940z00_17848) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3938z00_17846 =
													((long) CINT(BgL_arg3940z00_17848) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3938z00_17846 =
													((long) CINT(BgL_arg3940z00_17848) - ((long) 4));
									}}
									BgL_arg3939z00_17847 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15242))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17844,
										BgL_arg3937z00_17845, ((long) 6), BgL_arg3938z00_17846,
										BgL_restz00_15249, BgL_arg3939z00_17847);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17849;

									BgL_z12denvz12_17849 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17849, BgL_nsz00_17844);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17850;

										BgL_ez00_17850 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17850,
											BgL_sz00_17831);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17851;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17852;

												BgL_savedzd2bpzd2_17852 =
													VECTOR_REF(BgL_nsz00_17844, ((long) 0));
												VECTOR_SET(BgL_nsz00_17844, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17854;

													BgL_fz00_17854 = BgL_runz00_15243;
												BgL_recz00_17853:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17855;

														BgL_rz00_17855 =
															PROCEDURE_ENTRY(BgL_fz00_17854) (BgL_fz00_17854,
															BgL_nsz00_17844, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_32437;

															if (PROCEDUREP(BgL_rz00_17855))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17856;

																	BgL_arg1696z00_17856 =
																		PROCEDURE_ATTR(BgL_rz00_17855);
																	if (STRUCTP(BgL_arg1696z00_17856))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32437 =
																				(STRUCT_KEY(BgL_arg1696z00_17856) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32437 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_32437 = ((bool_t) 0);
																}
															if (BgL_testz00_32437)
																{
																	obj_t BgL_fz00_32445;

																	BgL_fz00_32445 = BgL_rz00_17855;
																	BgL_fz00_17854 = BgL_fz00_32445;
																	goto BgL_recz00_17853;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17844, ((long) 0),
																		BgL_savedzd2bpzd2_17852);
																	BgL_____rz00_17851 = BgL_rz00_17855;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17850);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17849, BgL_sz00_17831);
											return BgL_____rz00_17851;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5758 */
	obj_t BGl_z62run5758z62zz__evaluate_compz00(obj_t BgL_envz00_15250,
		obj_t BgL_sz00_15254)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15251;
				BgL_ev_absz00_bglt BgL_i1246z00_15252;
				obj_t BgL_bodyz00_15253;

				BgL_iboxesz00_15251 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 0))));
				BgL_i1246z00_15252 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 1))));
				BgL_bodyz00_15253 = PROCEDURE_REF(BgL_envz00_15250, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17857;

					BgL_bpz00_17857 = VECTOR_REF(((obj_t) BgL_sz00_15254), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15254,
						BgL_iboxesz00_15251, BgL_bpz00_17857);
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_z12denvz12_17858;
						obj_t BgL_wherez00_17859;
						obj_t BgL_locz00_17860;

						BgL_z12denvz12_17858 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17859 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15252))->
							BgL_wherez00);
						BgL_locz00_17860 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15252))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1167 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17858, BgL_wherez00_17859,
								BgL_locz00_17860);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_za2za2resza2za2z00_17861;

								BgL_za2za2resza2za2z00_17861 =
									PROCEDURE_ENTRY(BgL_bodyz00_15253) (BgL_bodyz00_15253,
									BgL_sz00_15254, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17858);
								return BgL_za2za2resza2za2z00_17861;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3945> */
	obj_t BGl_z62zc3anonymousza33945ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15255, obj_t BgL_sz00_15261)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15256;
				long BgL_siza7eza7_15257;
				BgL_ev_absz00_bglt BgL_i1246z00_15258;
				obj_t BgL_bodyz00_15259;
				long BgL_siza7ezd2framez75_15260;

				BgL_ifreesz00_15256 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15255, (int) (((long) 0))));
				BgL_siza7eza7_15257 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15255, (int) (((long) 1))));
				BgL_i1246z00_15258 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15255, (int) (((long) 2))));
				BgL_bodyz00_15259 = PROCEDURE_REF(BgL_envz00_15255, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15260 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15255, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17862;

					BgL_bpz00_17862 = VECTOR_REF(((obj_t) BgL_sz00_15261), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17863;

						BgL_valza2za2_17863 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15261,
							BgL_bpz00_17862, BgL_ifreesz00_15256);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17864;

							BgL_runz00_17864 =
								MAKE_FX_PROCEDURE(BGl_z62run5760z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17864,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15257));
							PROCEDURE_SET(BgL_runz00_17864,
								(int) (((long) 1)), BgL_valza2za2_17863);
							PROCEDURE_SET(BgL_runz00_17864,
								(int) (((long) 2)), ((obj_t) BgL_i1246z00_15258));
							PROCEDURE_SET(BgL_runz00_17864,
								(int) (((long) 3)), BgL_bodyz00_15259);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17865;

								BgL_mainz00_17865 =
									MAKE_VA_PROCEDURE(BGl_z62main5759z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17865,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15257));
								PROCEDURE_SET(BgL_mainz00_17865,
									(int) (((long) 1)), BgL_valza2za2_17863);
								PROCEDURE_SET(BgL_mainz00_17865,
									(int) (((long) 2)), BgL_bodyz00_15259);
								PROCEDURE_SET(BgL_mainz00_17865,
									(int) (((long) 3)), ((obj_t) BgL_i1246z00_15258));
								PROCEDURE_SET(BgL_mainz00_17865,
									(int) (((long) 4)), BgL_runz00_17864);
								PROCEDURE_SET(BgL_mainz00_17865,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15260));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17866;

									BgL_objz00_17866 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17864, BgL_objz00_17866);
									BgL_objz00_17866;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3946z00_17867;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3947z00_17868;
										obj_t BgL_arg3948z00_17869;

										BgL_arg3947z00_17868 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15258))->
											BgL_arityz00);
										BgL_arg3948z00_17869 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15258))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17870;

											BgL_newz00_17870 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32522;

												BgL_tmpz00_32522 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17870, BgL_tmpz00_32522,
													BgL_arg3948z00_17869);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32527;
												int BgL_tmpz00_32525;

												BgL_auxz00_32527 = BINT(BgL_siza7ezd2framez75_15260);
												BgL_tmpz00_32525 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17870, BgL_tmpz00_32525,
													BgL_auxz00_32527);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32530;

												BgL_tmpz00_32530 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17870, BgL_tmpz00_32530,
													BgL_runz00_17864);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32533;

												BgL_tmpz00_32533 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17870, BgL_tmpz00_32533,
													BgL_arg3947z00_17868);
											}
											BgL_arg3946z00_17867 = BgL_newz00_17870;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17865, BgL_arg3946z00_17867);
									BgL_arg3946z00_17867;
								}
								return BgL_mainz00_17865;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5759 */
	obj_t BGl_z62main5759z62zz__evaluate_compz00(obj_t BgL_envz00_15262,
		obj_t BgL_az00_15269, obj_t BgL_bz00_15270, obj_t BgL_cz00_15271,
		obj_t BgL_dz00_15272, obj_t BgL_restz00_15273)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15266;
				obj_t BgL_runz00_15267;
				long BgL_siza7ezd2framez75_15268;

				BgL_i1246z00_15266 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15262, (int) (((long) 3))));
				BgL_runz00_15267 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15262, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15268 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15262, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17871;

					BgL_sz00_17871 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17872;

						BgL_bpz00_17872 = VECTOR_REF(((obj_t) BgL_sz00_17871), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17872) + BgL_siza7ezd2framez75_15268) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17871))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3951z00_17873;

									BgL_arg3951z00_17873 =
										((long) CINT(BgL_bpz00_17872) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17871), BgL_arg3951z00_17873,
										BgL_az00_15269);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3952z00_17874;

									BgL_arg3952z00_17874 =
										((long) CINT(BgL_bpz00_17872) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17871), BgL_arg3952z00_17874,
										BgL_bz00_15270);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3953z00_17875;

									BgL_arg3953z00_17875 =
										((long) CINT(BgL_bpz00_17872) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17871), BgL_arg3953z00_17875,
										BgL_cz00_15271);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3954z00_17876;

									BgL_arg3954z00_17876 =
										((long) CINT(BgL_bpz00_17872) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17871), BgL_arg3954z00_17876,
										BgL_dz00_15272);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3955z00_17877;
									long BgL_arg3956z00_17878;
									long BgL_arg3957z00_17879;
									obj_t BgL_arg3958z00_17880;

									BgL_arg3955z00_17877 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15266))->
										BgL_wherez00);
									BgL_arg3956z00_17878 =
										((long) CINT(BgL_bpz00_17872) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3959z00_17881;

										BgL_arg3959z00_17881 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15266))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3959z00_17881) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3957z00_17879 =
													((long) CINT(BgL_arg3959z00_17881) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3957z00_17879 =
													((long) CINT(BgL_arg3959z00_17881) - ((long) 4));
									}}
									BgL_arg3958z00_17880 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15266))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17871,
										BgL_arg3955z00_17877, BgL_arg3956z00_17878,
										BgL_arg3957z00_17879, BgL_restz00_15273,
										BgL_arg3958z00_17880);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17882;

									BgL_ez00_17882 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17882,
										BgL_bpz00_17872);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17883;

										BgL_accz00_17883 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15267, BgL_sz00_17871, BgL_bpz00_17872);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17882);
										VECTOR_SET(
											((obj_t) BgL_sz00_17871), ((long) 0), BgL_bpz00_17872);
										return BgL_accz00_17883;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17884;

								BgL_nsz00_17884 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17884, ((long) 1), BgL_sz00_17871);
								VECTOR_SET(BgL_nsz00_17884, ((long) 2), BgL_az00_15269);
								VECTOR_SET(BgL_nsz00_17884, ((long) 3), BgL_bz00_15270);
								VECTOR_SET(BgL_nsz00_17884, ((long) 4), BgL_cz00_15271);
								VECTOR_SET(BgL_nsz00_17884, ((long) 5), BgL_dz00_15272);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3960z00_17885;
									long BgL_arg3961z00_17886;
									obj_t BgL_arg3962z00_17887;

									BgL_arg3960z00_17885 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15266))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3963z00_17888;

										BgL_arg3963z00_17888 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15266))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3963z00_17888) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3961z00_17886 =
													((long) CINT(BgL_arg3963z00_17888) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3961z00_17886 =
													((long) CINT(BgL_arg3963z00_17888) - ((long) 4));
									}}
									BgL_arg3962z00_17887 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15266))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17884,
										BgL_arg3960z00_17885, ((long) 6), BgL_arg3961z00_17886,
										BgL_restz00_15273, BgL_arg3962z00_17887);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17889;

									BgL_z12denvz12_17889 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17889, BgL_nsz00_17884);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17890;

										BgL_ez00_17890 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17890,
											BgL_sz00_17871);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17891;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17892;

												BgL_savedzd2bpzd2_17892 =
													VECTOR_REF(BgL_nsz00_17884, ((long) 0));
												VECTOR_SET(BgL_nsz00_17884, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17894;

													BgL_fz00_17894 = BgL_runz00_15267;
												BgL_recz00_17893:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17895;

														BgL_rz00_17895 =
															PROCEDURE_ENTRY(BgL_fz00_17894) (BgL_fz00_17894,
															BgL_nsz00_17884, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_32618;

															if (PROCEDUREP(BgL_rz00_17895))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17896;

																	BgL_arg1696z00_17896 =
																		PROCEDURE_ATTR(BgL_rz00_17895);
																	if (STRUCTP(BgL_arg1696z00_17896))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32618 =
																				(STRUCT_KEY(BgL_arg1696z00_17896) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32618 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_32618 = ((bool_t) 0);
																}
															if (BgL_testz00_32618)
																{
																	obj_t BgL_fz00_32626;

																	BgL_fz00_32626 = BgL_rz00_17895;
																	BgL_fz00_17894 = BgL_fz00_32626;
																	goto BgL_recz00_17893;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17884, ((long) 0),
																		BgL_savedzd2bpzd2_17892);
																	BgL_____rz00_17891 = BgL_rz00_17895;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17890);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17889, BgL_sz00_17871);
											return BgL_____rz00_17891;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5760 */
	obj_t BGl_z62run5760z62zz__evaluate_compz00(obj_t BgL_envz00_15274,
		obj_t BgL_sz00_15279)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				long BgL_siza7eza7_15275;
				obj_t BgL_valza2za2_15276;
				BgL_ev_absz00_bglt BgL_i1246z00_15277;
				obj_t BgL_bodyz00_15278;

				BgL_siza7eza7_15275 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15274, (int) (((long) 0))));
				BgL_valza2za2_15276 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15274, (int) (((long) 1))));
				BgL_i1246z00_15277 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15274, (int) (((long) 2))));
				BgL_bodyz00_15278 = PROCEDURE_REF(BgL_envz00_15274, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17897;

					BgL_bpz00_17897 = VECTOR_REF(((obj_t) BgL_sz00_15279), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15279,
						BgL_valza2za2_15276,
						((long) CINT(BgL_bpz00_17897) + BgL_siza7eza7_15275));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17898;
						obj_t BgL_wherez00_17899;
						obj_t BgL_locz00_17900;

						BgL_z12denvz12_17898 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17899 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15277))->
							BgL_wherez00);
						BgL_locz00_17900 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15277))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17898, BgL_wherez00_17899,
								BgL_locz00_17900);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17901;

								BgL_za2za2resza2za2z00_17901 =
									PROCEDURE_ENTRY(BgL_bodyz00_15278) (BgL_bodyz00_15278,
									BgL_sz00_15279, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17898);
								return BgL_za2za2resza2za2z00_17901;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3966> */
	obj_t BGl_z62zc3anonymousza33966ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15280, obj_t BgL_sz00_15287)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_15281;
				obj_t BgL_iboxesz00_15282;
				long BgL_siza7eza7_15283;
				BgL_ev_absz00_bglt BgL_i1246z00_15284;
				obj_t BgL_bodyz00_15285;
				long BgL_siza7ezd2framez75_15286;

				BgL_ifreesz00_15281 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 0))));
				BgL_iboxesz00_15282 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 1))));
				BgL_siza7eza7_15283 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 2))));
				BgL_i1246z00_15284 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 3))));
				BgL_bodyz00_15285 = PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15286 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15280, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17902;

					BgL_bpz00_17902 = VECTOR_REF(((obj_t) BgL_sz00_15287), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_valza2za2_17903;

						BgL_valza2za2_17903 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15287,
							BgL_bpz00_17902, BgL_ifreesz00_15281);
						{	/* Eval/evaluate_comp.scm 1167 */
							obj_t BgL_runz00_17904;

							BgL_runz00_17904 =
								MAKE_FX_PROCEDURE(BGl_z62run5762z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17904,
								(int) (((long) 0)), BgL_iboxesz00_15282);
							PROCEDURE_SET(BgL_runz00_17904,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15283));
							PROCEDURE_SET(BgL_runz00_17904,
								(int) (((long) 2)), BgL_valza2za2_17903);
							PROCEDURE_SET(BgL_runz00_17904,
								(int) (((long) 3)), ((obj_t) BgL_i1246z00_15284));
							PROCEDURE_SET(BgL_runz00_17904,
								(int) (((long) 4)), BgL_bodyz00_15285);
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_mainz00_17905;

								BgL_mainz00_17905 =
									MAKE_VA_PROCEDURE(BGl_z62main5761z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 0)), BgL_iboxesz00_15282);
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15283));
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 2)), BgL_valza2za2_17903);
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 3)), BgL_bodyz00_15285);
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 4)), ((obj_t) BgL_i1246z00_15284));
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 5)), BgL_runz00_17904);
								PROCEDURE_SET(BgL_mainz00_17905,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15286));
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_objz00_17906;

									BgL_objz00_17906 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17904, BgL_objz00_17906);
									BgL_objz00_17906;
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3967z00_17907;

									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3968z00_17908;
										obj_t BgL_arg3969z00_17909;

										BgL_arg3968z00_17908 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15284))->
											BgL_arityz00);
										BgL_arg3969z00_17909 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15284))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 676 */
											obj_t BgL_newz00_17910;

											BgL_newz00_17910 =
												create_struct(BGl_symbol5792z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32715;

												BgL_tmpz00_32715 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17910, BgL_tmpz00_32715,
													BgL_arg3969z00_17909);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												obj_t BgL_auxz00_32720;
												int BgL_tmpz00_32718;

												BgL_auxz00_32720 = BINT(BgL_siza7ezd2framez75_15286);
												BgL_tmpz00_32718 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17910, BgL_tmpz00_32718,
													BgL_auxz00_32720);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32723;

												BgL_tmpz00_32723 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17910, BgL_tmpz00_32723,
													BgL_runz00_17904);
											}
											{	/* Eval/evaluate_comp.scm 676 */
												int BgL_tmpz00_32726;

												BgL_tmpz00_32726 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17910, BgL_tmpz00_32726,
													BgL_arg3968z00_17908);
											}
											BgL_arg3967z00_17907 = BgL_newz00_17910;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17905, BgL_arg3967z00_17907);
									BgL_arg3967z00_17907;
								}
								return BgL_mainz00_17905;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &main5761 */
	obj_t BGl_z62main5761z62zz__evaluate_compz00(obj_t BgL_envz00_15288,
		obj_t BgL_az00_15296, obj_t BgL_bz00_15297, obj_t BgL_cz00_15298,
		obj_t BgL_dz00_15299, obj_t BgL_restz00_15300)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				BgL_ev_absz00_bglt BgL_i1246z00_15293;
				obj_t BgL_runz00_15294;
				long BgL_siza7ezd2framez75_15295;

				BgL_i1246z00_15293 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15288, (int) (((long) 4))));
				BgL_runz00_15294 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15288, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15295 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15288, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_sz00_17911;

					BgL_sz00_17911 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_bpz00_17912;

						BgL_bpz00_17912 = VECTOR_REF(((obj_t) BgL_sz00_17911), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17912) + BgL_siza7ezd2framez75_15295) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17911))))
							{	/* Eval/evaluate_comp.scm 1167 */
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3972z00_17913;

									BgL_arg3972z00_17913 =
										((long) CINT(BgL_bpz00_17912) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17911), BgL_arg3972z00_17913,
										BgL_az00_15296);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3973z00_17914;

									BgL_arg3973z00_17914 =
										((long) CINT(BgL_bpz00_17912) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17911), BgL_arg3973z00_17914,
										BgL_bz00_15297);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3974z00_17915;

									BgL_arg3974z00_17915 =
										((long) CINT(BgL_bpz00_17912) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17911), BgL_arg3974z00_17915,
										BgL_cz00_15298);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									long BgL_arg3975z00_17916;

									BgL_arg3975z00_17916 =
										((long) CINT(BgL_bpz00_17912) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17911), BgL_arg3975z00_17916,
										BgL_dz00_15299);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3976z00_17917;
									long BgL_arg3977z00_17918;
									long BgL_arg3978z00_17919;
									obj_t BgL_arg3979z00_17920;

									BgL_arg3976z00_17917 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15293))->
										BgL_wherez00);
									BgL_arg3977z00_17918 =
										((long) CINT(BgL_bpz00_17912) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3980z00_17921;

										BgL_arg3980z00_17921 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15293))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3980z00_17921) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3978z00_17919 =
													((long) CINT(BgL_arg3980z00_17921) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3978z00_17919 =
													((long) CINT(BgL_arg3980z00_17921) - ((long) 4));
									}}
									BgL_arg3979z00_17920 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15293))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17911,
										BgL_arg3976z00_17917, BgL_arg3977z00_17918,
										BgL_arg3978z00_17919, BgL_restz00_15300,
										BgL_arg3979z00_17920);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_ez00_17922;

									BgL_ez00_17922 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17922,
										BgL_bpz00_17912);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_accz00_17923;

										BgL_accz00_17923 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15294, BgL_sz00_17911, BgL_bpz00_17912);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17922);
										VECTOR_SET(
											((obj_t) BgL_sz00_17911), ((long) 0), BgL_bpz00_17912);
										return BgL_accz00_17923;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_nsz00_17924;

								BgL_nsz00_17924 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17924, ((long) 1), BgL_sz00_17911);
								VECTOR_SET(BgL_nsz00_17924, ((long) 2), BgL_az00_15296);
								VECTOR_SET(BgL_nsz00_17924, ((long) 3), BgL_bz00_15297);
								VECTOR_SET(BgL_nsz00_17924, ((long) 4), BgL_cz00_15298);
								VECTOR_SET(BgL_nsz00_17924, ((long) 5), BgL_dz00_15299);
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_arg3981z00_17925;
									long BgL_arg3982z00_17926;
									obj_t BgL_arg3983z00_17927;

									BgL_arg3981z00_17925 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15293))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_arg3984z00_17928;

										BgL_arg3984z00_17928 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15293))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3984z00_17928) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3982z00_17926 =
													((long) CINT(BgL_arg3984z00_17928) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1052 */
												BgL_arg3982z00_17926 =
													((long) CINT(BgL_arg3984z00_17928) - ((long) 4));
									}}
									BgL_arg3983z00_17927 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15293))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17924,
										BgL_arg3981z00_17925, ((long) 6), BgL_arg3982z00_17926,
										BgL_restz00_15300, BgL_arg3983z00_17927);
								}
								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_z12denvz12_17929;

									BgL_z12denvz12_17929 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17929, BgL_nsz00_17924);
									{	/* Eval/evaluate_comp.scm 1167 */
										obj_t BgL_ez00_17930;

										BgL_ez00_17930 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17930,
											BgL_sz00_17911);
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_____rz00_17931;

											{	/* Eval/evaluate_comp.scm 663 */
												obj_t BgL_savedzd2bpzd2_17932;

												BgL_savedzd2bpzd2_17932 =
													VECTOR_REF(BgL_nsz00_17924, ((long) 0));
												VECTOR_SET(BgL_nsz00_17924, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17934;

													BgL_fz00_17934 = BgL_runz00_15294;
												BgL_recz00_17933:
													{	/* Eval/evaluate_comp.scm 666 */
														obj_t BgL_rz00_17935;

														BgL_rz00_17935 =
															PROCEDURE_ENTRY(BgL_fz00_17934) (BgL_fz00_17934,
															BgL_nsz00_17924, BEOA);
														{	/* Eval/evaluate_comp.scm 667 */
															bool_t BgL_testz00_32811;

															if (PROCEDUREP(BgL_rz00_17935))
																{	/* Eval/evaluate_comp.scm 667 */
																	obj_t BgL_arg1696z00_17936;

																	BgL_arg1696z00_17936 =
																		PROCEDURE_ATTR(BgL_rz00_17935);
																	if (STRUCTP(BgL_arg1696z00_17936))
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32811 =
																				(STRUCT_KEY(BgL_arg1696z00_17936) ==
																				BGl_symbol5771z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 647 */
																			BgL_testz00_32811 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	BgL_testz00_32811 = ((bool_t) 0);
																}
															if (BgL_testz00_32811)
																{
																	obj_t BgL_fz00_32819;

																	BgL_fz00_32819 = BgL_rz00_17935;
																	BgL_fz00_17934 = BgL_fz00_32819;
																	goto BgL_recz00_17933;
																}
															else
																{	/* Eval/evaluate_comp.scm 667 */
																	VECTOR_SET(BgL_nsz00_17924, ((long) 0),
																		BgL_savedzd2bpzd2_17932);
																	BgL_____rz00_17931 = BgL_rz00_17935;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17930);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17929, BgL_sz00_17911);
											return BgL_____rz00_17931;
										}
									}
								}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &run5762 */
	obj_t BGl_z62run5762z62zz__evaluate_compz00(obj_t BgL_envz00_15301,
		obj_t BgL_sz00_15307)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1167 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_iboxesz00_15302;
				long BgL_siza7eza7_15303;
				obj_t BgL_valza2za2_15304;
				BgL_ev_absz00_bglt BgL_i1246z00_15305;
				obj_t BgL_bodyz00_15306;

				BgL_iboxesz00_15302 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15301, (int) (((long) 0))));
				BgL_siza7eza7_15303 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15301, (int) (((long) 1))));
				BgL_valza2za2_15304 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15301, (int) (((long) 2))));
				BgL_i1246z00_15305 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15301, (int) (((long) 3))));
				BgL_bodyz00_15306 = PROCEDURE_REF(BgL_envz00_15301, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_bpz00_17937;

					BgL_bpz00_17937 = VECTOR_REF(((obj_t) BgL_sz00_15307), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15307,
						BgL_iboxesz00_15302, BgL_bpz00_17937);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15307,
						BgL_valza2za2_15304,
						((long) CINT(BgL_bpz00_17937) + BgL_siza7eza7_15303));
					{	/* Eval/evaluate_comp.scm 1088 */
						obj_t BgL_z12denvz12_17938;
						obj_t BgL_wherez00_17939;
						obj_t BgL_locz00_17940;

						BgL_z12denvz12_17938 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17939 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15305))->
							BgL_wherez00);
						BgL_locz00_17940 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1246z00_15305))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1088 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17938, BgL_wherez00_17939,
								BgL_locz00_17940);
							{	/* Eval/evaluate_comp.scm 1088 */
								obj_t BgL_za2za2resza2za2z00_17941;

								BgL_za2za2resza2za2z00_17941 =
									PROCEDURE_ENTRY(BgL_bodyz00_15306) (BgL_bodyz00_15306,
									BgL_sz00_15307, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17938);
								return BgL_za2za2resza2za2z00_17941;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_app1432 */
	obj_t BGl_z62compzd2ev_app1432zb0zz__evaluate_compz00(obj_t BgL_envz00_15308,
		obj_t BgL_ez00_15309, obj_t BgL_stkz00_15310)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 1037 */
			{	/* Eval/evaluate_comp.scm 1039 */
				obj_t BgL__ortest_1232z00_17943;

				BgL__ortest_1232z00_17943 =
					BGl_arithzd2expressionzd2zz__evaluate_compz00(
					((BgL_ev_appz00_bglt) BgL_ez00_15309), BgL_stkz00_15310);
				if (CBOOL(BgL__ortest_1232z00_17943))
					{	/* Eval/evaluate_comp.scm 1039 */
						return BgL__ortest_1232z00_17943;
					}
				else
					{	/* Eval/evaluate_comp.scm 1040 */
						obj_t BgL__ortest_1233z00_17944;

						BgL__ortest_1233z00_17944 =
							BGl_inlinezd2callzd2zz__evaluate_compz00(
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15309)))->BgL_locz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15309)))->BgL_funz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15309)))->BgL_argsz00),
							BgL_stkz00_15310);
						if (CBOOL(BgL__ortest_1233z00_17944))
							{	/* Eval/evaluate_comp.scm 1040 */
								return BgL__ortest_1233z00_17944;
							}
						else
							{	/* Eval/evaluate_comp.scm 1040 */
								if (
									(bgl_list_length(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
												BgL_argsz00)) > ((long) 4)))
									{	/* Eval/evaluate_comp.scm 1041 */
										return
											BGl_compzd2oldzd2callz00zz__evaluate_compz00(
											((BgL_ev_appz00_bglt) BgL_ez00_15309), BgL_stkz00_15310);
									}
								else
									{	/* Eval/evaluate_comp.scm 1043 */
										obj_t BgL_fz00_17945;
										long BgL_siza7eza7_17946;
										obj_t BgL_symbzd2funzd2_17947;

										BgL_fz00_17945 =
											BGl_compz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
												BgL_funz00), BgL_stkz00_15310);
										BgL_siza7eza7_17946 = bgl_list_length(BgL_stkz00_15310);
										BgL_symbzd2funzd2_17947 =
											BGl_uncompilez00zz__evaluate_uncompz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
												BgL_funz00));
										if (NULLP((((BgL_ev_appz00_bglt)
														COBJECT(((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
													BgL_argsz00)))
											{	/* Eval/evaluate_comp.scm 1044 */
												return
													BGl_compzd2call0zd2zz__evaluate_compz00(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
														BgL_locz00),
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15309)))->BgL_funz00),
													BgL_symbzd2funzd2_17947, BgL_fz00_17945,
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15309)))->BgL_tailzf3zf3),
													BgL_stkz00_15310, BgL_siza7eza7_17946);
											}
										else
											{	/* Eval/evaluate_comp.scm 1046 */
												obj_t BgL_a1z00_17948;
												obj_t BgL_argsz00_17949;

												{	/* Eval/evaluate_comp.scm 1046 */
													obj_t BgL_arg3405z00_17950;

													BgL_arg3405z00_17950 =
														CAR(
														(((BgL_ev_appz00_bglt) COBJECT(
																	((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
															BgL_argsz00));
													BgL_a1z00_17948 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg3405z00_17950),
														BgL_stkz00_15310);
												}
												BgL_argsz00_17949 =
													CDR(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
														BgL_argsz00));
												if (NULLP(BgL_argsz00_17949))
													{	/* Eval/evaluate_comp.scm 1046 */
														return
															BGl_compzd2call1zd2zz__evaluate_compz00(
															(((BgL_ev_appz00_bglt) COBJECT(
																		((BgL_ev_appz00_bglt) BgL_ez00_15309)))->
																BgL_locz00),
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15309)))->BgL_funz00),
															BgL_symbzd2funzd2_17947, BgL_fz00_17945,
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15309)))->BgL_tailzf3zf3),
															BgL_stkz00_15310, BgL_siza7eza7_17946,
															BgL_a1z00_17948);
													}
												else
													{	/* Eval/evaluate_comp.scm 1046 */
														obj_t BgL_a2z00_17951;
														obj_t BgL_argsz00_17952;

														{	/* Eval/evaluate_comp.scm 1046 */
															obj_t BgL_arg3404z00_17953;

															BgL_arg3404z00_17953 =
																CAR(((obj_t) BgL_argsz00_17949));
															BgL_a2z00_17951 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_arg3404z00_17953),
																BgL_stkz00_15310);
														}
														BgL_argsz00_17952 =
															CDR(((obj_t) BgL_argsz00_17949));
														if (NULLP(BgL_argsz00_17952))
															{	/* Eval/evaluate_comp.scm 1046 */
																return
																	BGl_compzd2call2zd2zz__evaluate_compz00(
																	(((BgL_ev_appz00_bglt) COBJECT(
																				((BgL_ev_appz00_bglt)
																					BgL_ez00_15309)))->BgL_locz00),
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15309)))->BgL_funz00),
																	BgL_symbzd2funzd2_17947, BgL_fz00_17945,
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15309)))->BgL_tailzf3zf3),
																	BgL_stkz00_15310, BgL_siza7eza7_17946,
																	BgL_a1z00_17948, BgL_a2z00_17951);
															}
														else
															{	/* Eval/evaluate_comp.scm 1046 */
																obj_t BgL_a3z00_17954;
																obj_t BgL_argsz00_17955;

																{	/* Eval/evaluate_comp.scm 1046 */
																	obj_t BgL_arg3402z00_17956;

																	BgL_arg3402z00_17956 =
																		CAR(((obj_t) BgL_argsz00_17952));
																	BgL_a3z00_17954 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt)
																			BgL_arg3402z00_17956), BgL_stkz00_15310);
																}
																BgL_argsz00_17955 =
																	CDR(((obj_t) BgL_argsz00_17952));
																if (NULLP(BgL_argsz00_17955))
																	{	/* Eval/evaluate_comp.scm 1046 */
																		return
																			BGl_compzd2call3zd2zz__evaluate_compz00(
																			(((BgL_ev_appz00_bglt) COBJECT(
																						((BgL_ev_appz00_bglt)
																							BgL_ez00_15309)))->BgL_locz00),
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15309)))->BgL_funz00),
																			BgL_symbzd2funzd2_17947, BgL_fz00_17945,
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15309)))->
																				BgL_tailzf3zf3), BgL_stkz00_15310,
																			BgL_siza7eza7_17946, BgL_a1z00_17948,
																			BgL_a2z00_17951, BgL_a3z00_17954);
																	}
																else
																	{	/* Eval/evaluate_comp.scm 1046 */
																		obj_t BgL_a4z00_17957;
																		obj_t BgL_argsz00_17958;

																		{	/* Eval/evaluate_comp.scm 1046 */
																			obj_t BgL_arg3401z00_17959;

																			BgL_arg3401z00_17959 =
																				CAR(((obj_t) BgL_argsz00_17955));
																			BgL_a4z00_17957 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt)
																					BgL_arg3401z00_17959),
																				BgL_stkz00_15310);
																		}
																		BgL_argsz00_17958 =
																			CDR(((obj_t) BgL_argsz00_17955));
																		if (NULLP(BgL_argsz00_17958))
																			{	/* Eval/evaluate_comp.scm 1046 */
																				return
																					BGl_compzd2call4zd2zz__evaluate_compz00
																					((((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15309)))->
																						BgL_locz00),
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15309)))->
																						BgL_funz00),
																					BgL_symbzd2funzd2_17947,
																					BgL_fz00_17945,
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15309)))->
																						BgL_tailzf3zf3), BgL_stkz00_15310,
																					BgL_siza7eza7_17946, BgL_a1z00_17948,
																					BgL_a2z00_17951, BgL_a3z00_17954,
																					BgL_a4z00_17957);
																			}
																		else
																			{	/* Eval/evaluate_comp.scm 1046 */
																				return
																					BGl_errorz00zz__errorz00
																					(BGl_string5775z00zz__evaluate_compz00,
																					BGl_string5890z00zz__evaluate_compz00,
																					BGl_string5891z00zz__evaluate_compz00);
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_goto1430 */
	obj_t BGl_z62compzd2ev_goto1430zb0zz__evaluate_compz00(obj_t BgL_envz00_15311,
		obj_t BgL_ez00_15312, obj_t BgL_stkz00_15313)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 597 */
			{	/* Eval/evaluate_comp.scm 600 */
				obj_t BgL_slotz00_17963;
				long BgL_siza7eza7_17964;
				obj_t BgL_lstkz00_17965;

				BgL_slotz00_17963 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
					((obj_t)
						(((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->BgL_labelz00)),
					(((BgL_ev_labelsz00_bglt) COBJECT(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->
									BgL_labelsz00)))->BgL_envz00));
				BgL_siza7eza7_17964 = bgl_list_length(BgL_stkz00_15313);
				BgL_lstkz00_17965 =
					(((BgL_ev_labelsz00_bglt) COBJECT(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->BgL_labelsz00)))->
					BgL_stkz00);
				{	/* Eval/evaluate_comp.scm 602 */
					long BgL_llstkz00_17966;
					obj_t BgL_substkz00_17967;
					obj_t BgL_boxesz00_17968;

					BgL_llstkz00_17966 = bgl_list_length(BgL_lstkz00_17965);
					BgL_substkz00_17967 =
						BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_17965,
						BgL_stkz00_15313);
					{	/* Eval/evaluate_comp.scm 602 */
						obj_t BgL_pairz00_17969;

						BgL_pairz00_17969 =
							BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
							((obj_t)
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->BgL_labelz00)),
							(((BgL_ev_labelsz00_bglt) COBJECT(
										(((BgL_ev_gotoz00_bglt) COBJECT(
													((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->
											BgL_labelsz00)))->BgL_boxesz00));
						BgL_boxesz00_17968 = CDR(BgL_pairz00_17969);
					}
					if (BGl_needzd2shiftzd2zz__evaluate_compz00(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->BgL_argsz00),
							BgL_substkz00_17967))
						{	/* Eval/evaluate_comp.scm 605 */
							obj_t BgL_argsz00_17970;
							long BgL_nbargsz00_17971;

							BgL_argsz00_17970 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->BgL_argsz00),
								BgL_stkz00_15313);
							BgL_nbargsz00_17971 =
								bgl_list_length((((BgL_ev_gotoz00_bglt)
										COBJECT(((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->
									BgL_argsz00));
							{	/* Eval/evaluate_comp.scm 606 */
								obj_t BgL_zc3anonymousza33343ze3z83_17972;

								BgL_zc3anonymousza33343ze3z83_17972 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza33343ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17964));
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 1)), BINT(BgL_llstkz00_17966));
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 2)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15312)));
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 3)), BgL_argsz00_17970);
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 4)), BgL_boxesz00_17968);
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 5)), BINT(BgL_nbargsz00_17971));
								PROCEDURE_SET(BgL_zc3anonymousza33343ze3z83_17972,
									(int) (((long) 6)), BgL_slotz00_17963);
								return BgL_zc3anonymousza33343ze3z83_17972;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 611 */
							obj_t BgL_argsz00_17973;

							{	/* Eval/evaluate_comp.scm 611 */
								obj_t BgL_lz00_17974;
								long BgL_nz00_17975;

								BgL_lz00_17974 =
									(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15312)))->BgL_argsz00);
								BgL_nz00_17975 = (BgL_siza7eza7_17964 - BgL_llstkz00_17966);
								BgL_argsz00_17973 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15313,
									BgL_lz00_17974, BgL_nz00_17975);
							}
							{	/* Eval/evaluate_comp.scm 612 */
								obj_t BgL_zc3anonymousza33349ze3z83_17976;

								BgL_zc3anonymousza33349ze3z83_17976 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza33349ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza33349ze3z83_17976,
									(int) (((long) 0)), BINT(BgL_llstkz00_17966));
								PROCEDURE_SET(BgL_zc3anonymousza33349ze3z83_17976,
									(int) (((long) 1)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15312)));
								PROCEDURE_SET(BgL_zc3anonymousza33349ze3z83_17976,
									(int) (((long) 2)), BgL_argsz00_17973);
								PROCEDURE_SET(BgL_zc3anonymousza33349ze3z83_17976,
									(int) (((long) 3)), BgL_boxesz00_17968);
								PROCEDURE_SET(BgL_zc3anonymousza33349ze3z83_17976,
									(int) (((long) 4)), BgL_slotz00_17963);
								return BgL_zc3anonymousza33349ze3z83_17976;
							}
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3343> */
	obj_t BGl_z62zc3anonymousza33343ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15314, obj_t BgL_sz00_15322)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 606 */
			{	/* Eval/evaluate_comp.scm 606 */
				long BgL_siza7eza7_15315;
				long BgL_llstkz00_15316;
				BgL_ev_gotoz00_bglt BgL_i1144z00_15317;
				obj_t BgL_argsz00_15318;
				obj_t BgL_boxesz00_15319;
				long BgL_nbargsz00_15320;
				obj_t BgL_slotz00_15321;

				BgL_siza7eza7_15315 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 0))));
				BgL_llstkz00_15316 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 1))));
				BgL_i1144z00_15317 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 2))));
				BgL_argsz00_15318 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 3))));
				BgL_boxesz00_15319 =
					PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 4)));
				BgL_nbargsz00_15320 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 5))));
				BgL_slotz00_15321 = PROCEDURE_REF(BgL_envz00_15314, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 606 */
					obj_t BgL_bpz00_17977;

					BgL_bpz00_17977 = VECTOR_REF(((obj_t) BgL_sz00_15322), ((long) 0));
					{	/* Eval/evaluate_comp.scm 607 */
						long BgL_spz00_17978;
						long BgL_lspz00_17979;

						BgL_spz00_17978 =
							((long) CINT(BgL_bpz00_17977) + BgL_siza7eza7_15315);
						BgL_lspz00_17979 =
							((long) CINT(BgL_bpz00_17977) + BgL_llstkz00_15316);
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_15322, BgL_argsz00_15318, BgL_boxesz00_15319,
							BgL_spz00_17978,
							(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1144z00_15317))->
								BgL_locz00));
						{	/* Eval/evaluate_comp.scm 609 */
							long BgL_arg3345z00_17980;

							BgL_arg3345z00_17980 = (BgL_spz00_17978 + BgL_nbargsz00_15320);
							BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_15322,
								BgL_lspz00_17979, BgL_sz00_15322, BINT(BgL_spz00_17978),
								BINT(BgL_arg3345z00_17980));
						}
						return CDR(((obj_t) BgL_slotz00_15321));
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3349> */
	obj_t BGl_z62zc3anonymousza33349ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15323, obj_t BgL_sz00_15329)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 612 */
			{	/* Eval/evaluate_comp.scm 612 */
				long BgL_llstkz00_15324;
				BgL_ev_gotoz00_bglt BgL_i1144z00_15325;
				obj_t BgL_argsz00_15326;
				obj_t BgL_boxesz00_15327;
				obj_t BgL_slotz00_15328;

				BgL_llstkz00_15324 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15323, (int) (((long) 0))));
				BgL_i1144z00_15325 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15323, (int) (((long) 1))));
				BgL_argsz00_15326 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15323, (int) (((long) 2))));
				BgL_boxesz00_15327 =
					PROCEDURE_REF(BgL_envz00_15323, (int) (((long) 3)));
				BgL_slotz00_15328 = PROCEDURE_REF(BgL_envz00_15323, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 612 */
					obj_t BgL_bpz00_17981;

					BgL_bpz00_17981 = VECTOR_REF(((obj_t) BgL_sz00_15329), ((long) 0));
					BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
						(BgL_sz00_15329, BgL_argsz00_15326, BgL_boxesz00_15327,
						((long) CINT(BgL_bpz00_17981) + BgL_llstkz00_15324),
						(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1144z00_15325))->BgL_locz00));
					return CDR(((obj_t) BgL_slotz00_15328));
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_labels1427 */
	obj_t BGl_z62compzd2ev_labels1427zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15330, obj_t BgL_ez00_15331, obj_t BgL_stkz00_15332)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 565 */
			((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_ez00_15331)))->BgL_stkz00) =
				((obj_t) BgL_stkz00_15332), BUNSPEC);
			{	/* Eval/evaluate_comp.scm 572 */
				obj_t BgL_envz00_17983;

				{	/* Eval/evaluate_comp.scm 572 */
					obj_t BgL_l1331z00_17984;

					BgL_l1331z00_17984 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15331)))->BgL_varsz00);
					if (NULLP(BgL_l1331z00_17984))
						{	/* Eval/evaluate_comp.scm 572 */
							BgL_envz00_17983 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 572 */
							obj_t BgL_head1333z00_17985;

							{	/* Eval/evaluate_comp.scm 572 */
								obj_t BgL_res5169z00_17986;

								BgL_res5169z00_17986 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1333z00_17985 = BgL_res5169z00_17986;
							}
							{
								obj_t BgL_l1331z00_17988;
								obj_t BgL_tail1334z00_17989;

								BgL_l1331z00_17988 = BgL_l1331z00_17984;
								BgL_tail1334z00_17989 = BgL_head1333z00_17985;
							BgL_zc3anonymousza33332ze3z83_17987:
								if (NULLP(BgL_l1331z00_17988))
									{	/* Eval/evaluate_comp.scm 572 */
										BgL_envz00_17983 = CDR(BgL_head1333z00_17985);
									}
								else
									{	/* Eval/evaluate_comp.scm 572 */
										obj_t BgL_newtail1335z00_17990;

										{	/* Eval/evaluate_comp.scm 572 */
											obj_t BgL_arg3335z00_17991;

											{	/* Eval/evaluate_comp.scm 572 */
												obj_t BgL_vz00_17992;

												BgL_vz00_17992 = CAR(((obj_t) BgL_l1331z00_17988));
												BgL_arg3335z00_17991 =
													MAKE_YOUNG_PAIR(BgL_vz00_17992,
													BGl_symbol5892z00zz__evaluate_compz00);
											}
											{	/* Eval/evaluate_comp.scm 572 */
												obj_t BgL_res5175z00_17993;

												BgL_res5175z00_17993 =
													MAKE_YOUNG_PAIR(BgL_arg3335z00_17991, BNIL);
												BgL_newtail1335z00_17990 = BgL_res5175z00_17993;
											}
										}
										SET_CDR(BgL_tail1334z00_17989, BgL_newtail1335z00_17990);
										{	/* Eval/evaluate_comp.scm 572 */
											obj_t BgL_arg3334z00_17994;

											BgL_arg3334z00_17994 = CDR(((obj_t) BgL_l1331z00_17988));
											{
												obj_t BgL_tail1334z00_33098;
												obj_t BgL_l1331z00_33097;

												BgL_l1331z00_33097 = BgL_arg3334z00_17994;
												BgL_tail1334z00_33098 = BgL_newtail1335z00_17990;
												BgL_tail1334z00_17989 = BgL_tail1334z00_33098;
												BgL_l1331z00_17988 = BgL_l1331z00_33097;
												goto BgL_zc3anonymousza33332ze3z83_17987;
											}
										}
									}
							}
						}
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15331)))->BgL_envz00) =
					((obj_t) BgL_envz00_17983), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 575 */
					obj_t BgL_g1339z00_17995;

					BgL_g1339z00_17995 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15331)))->BgL_valsz00);
					{
						obj_t BgL_ll1336z00_17997;
						obj_t BgL_ll1337z00_17998;

						BgL_ll1336z00_17997 = BgL_envz00_17983;
						BgL_ll1337z00_17998 = BgL_g1339z00_17995;
					BgL_zc3anonymousza33319ze3z83_17996:
						if (NULLP(BgL_ll1336z00_17997))
							{	/* Eval/evaluate_comp.scm 575 */
								((bool_t) 1);
							}
						else
							{	/* Eval/evaluate_comp.scm 575 */
								{	/* Eval/evaluate_comp.scm 577 */
									obj_t BgL_slotz00_17999;
									obj_t BgL_valz00_18000;

									BgL_slotz00_17999 = CAR(((obj_t) BgL_ll1336z00_17997));
									BgL_valz00_18000 = CAR(((obj_t) BgL_ll1337z00_17998));
									{	/* Eval/evaluate_comp.scm 578 */
										obj_t BgL_arg3321z00_18001;

										{	/* Eval/evaluate_comp.scm 578 */
											obj_t BgL_arg3322z00_18002;

											{	/* Eval/evaluate_comp.scm 578 */
												obj_t BgL_arg3323z00_18003;
												obj_t BgL_arg3324z00_18004;

												BgL_arg3323z00_18003 = CDR(((obj_t) BgL_valz00_18000));
												{	/* Eval/evaluate_comp.scm 578 */
													obj_t BgL_arg3325z00_18005;

													BgL_arg3325z00_18005 =
														CAR(((obj_t) BgL_valz00_18000));
													BgL_arg3324z00_18004 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_15332, BgL_arg3325z00_18005);
												}
												BgL_arg3322z00_18002 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_arg3323z00_18003),
													BgL_arg3324z00_18004);
											}
											{	/* Eval/evaluate_comp.scm 567 */
												obj_t BgL_objz00_18006;

												BgL_objz00_18006 =
													BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
												{	/* Eval/evaluate_comp.scm 567 */
													obj_t BgL_tmpz00_33116;

													BgL_tmpz00_33116 = ((obj_t) BgL_arg3322z00_18002);
													PROCEDURE_ATTR_SET(BgL_tmpz00_33116,
														BgL_objz00_18006);
												}
												BgL_objz00_18006;
											}
											BgL_arg3321z00_18001 = BgL_arg3322z00_18002;
										}
										{	/* Eval/evaluate_comp.scm 577 */
											obj_t BgL_tmpz00_33119;

											BgL_tmpz00_33119 = ((obj_t) BgL_slotz00_17999);
											SET_CDR(BgL_tmpz00_33119, BgL_arg3321z00_18001);
										}
									}
								}
								{	/* Eval/evaluate_comp.scm 575 */
									obj_t BgL_arg3329z00_18007;
									obj_t BgL_arg3330z00_18008;

									BgL_arg3329z00_18007 = CDR(((obj_t) BgL_ll1336z00_17997));
									BgL_arg3330z00_18008 = CDR(((obj_t) BgL_ll1337z00_17998));
									{
										obj_t BgL_ll1337z00_33127;
										obj_t BgL_ll1336z00_33126;

										BgL_ll1336z00_33126 = BgL_arg3329z00_18007;
										BgL_ll1337z00_33127 = BgL_arg3330z00_18008;
										BgL_ll1337z00_17998 = BgL_ll1337z00_33127;
										BgL_ll1336z00_17997 = BgL_ll1336z00_33126;
										goto BgL_zc3anonymousza33319ze3z83_17996;
									}
								}
							}
					}
				}
			}
			{	/* Eval/evaluate_comp.scm 582 */
				obj_t BgL_bodyz00_18009;

				BgL_bodyz00_18009 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15331)))->BgL_bodyz00),
					BgL_stkz00_15332);
				{	/* Eval/evaluate_comp.scm 583 */
					obj_t BgL_zc3anonymousza33336ze3z83_18010;

					BgL_zc3anonymousza33336ze3z83_18010 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33336ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33336ze3z83_18010, (int) (((long) 0)),
						BgL_bodyz00_18009);
					return BgL_zc3anonymousza33336ze3z83_18010;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3336> */
	obj_t BGl_z62zc3anonymousza33336ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15333, obj_t BgL_sz00_15335)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 583 */
			{	/* Eval/evaluate_comp.scm 583 */
				obj_t BgL_bodyz00_15334;

				BgL_bodyz00_15334 = PROCEDURE_REF(BgL_envz00_15333, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 583 */
					obj_t BgL_bpz00_18011;

					BgL_bpz00_18011 = VECTOR_REF(((obj_t) BgL_sz00_15335), ((long) 0));
					{
						obj_t BgL_fz00_18013;

						BgL_fz00_18013 = BgL_bodyz00_15334;
					BgL_recz00_18012:
						{	/* Eval/evaluate_comp.scm 590 */
							obj_t BgL_rz00_18014;

							BgL_rz00_18014 =
								PROCEDURE_ENTRY(BgL_fz00_18013) (BgL_fz00_18013, BgL_sz00_15335,
								BEOA);
							{	/* Eval/evaluate_comp.scm 592 */
								bool_t BgL_testz00_33144;

								if (PROCEDUREP(BgL_rz00_18014))
									{	/* Eval/evaluate_comp.scm 592 */
										obj_t BgL_arg1652z00_18015;

										BgL_arg1652z00_18015 = PROCEDURE_ATTR(BgL_rz00_18014);
										if (STRUCTP(BgL_arg1652z00_18015))
											{	/* Eval/evaluate_comp.scm 562 */
												BgL_testz00_33144 =
													(STRUCT_KEY(BgL_arg1652z00_18015) ==
													BGl_symbol5769z00zz__evaluate_compz00);
											}
										else
											{	/* Eval/evaluate_comp.scm 562 */
												BgL_testz00_33144 = ((bool_t) 0);
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 592 */
										BgL_testz00_33144 = ((bool_t) 0);
									}
								if (BgL_testz00_33144)
									{
										obj_t BgL_fz00_33152;

										BgL_fz00_33152 = BgL_rz00_18014;
										BgL_fz00_18013 = BgL_fz00_33152;
										goto BgL_recz00_18012;
									}
								else
									{	/* Eval/evaluate_comp.scm 592 */
										return BgL_rz00_18014;
									}
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_synchronize1425 */
	obj_t BGl_z62compzd2ev_synchroniza7e1425z17zz__evaluate_compz00(obj_t
		BgL_envz00_15336, obj_t BgL_ez00_15337, obj_t BgL_stkz00_15338)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 545 */
			{	/* Eval/evaluate_comp.scm 547 */
				obj_t BgL_mutexz00_18017;
				obj_t BgL_prelockz00_18018;
				obj_t BgL_bodyz00_18019;

				BgL_mutexz00_18017 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15337)))->
						BgL_mutexz00), BgL_stkz00_15338);
				BgL_prelockz00_18018 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15337)))->
						BgL_prelockz00), BgL_stkz00_15338);
				BgL_bodyz00_18019 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15337)))->
						BgL_bodyz00), BgL_stkz00_15338);
				{	/* Eval/evaluate_comp.scm 550 */
					obj_t BgL_zc3anonymousza33288ze3z83_18020;

					BgL_zc3anonymousza33288ze3z83_18020 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33288ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 4)));
					PROCEDURE_SET(BgL_zc3anonymousza33288ze3z83_18020, (int) (((long) 0)),
						BgL_mutexz00_18017);
					PROCEDURE_SET(BgL_zc3anonymousza33288ze3z83_18020, (int) (((long) 1)),
						((obj_t) ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15337)));
					PROCEDURE_SET(BgL_zc3anonymousza33288ze3z83_18020, (int) (((long) 2)),
						BgL_prelockz00_18018);
					PROCEDURE_SET(BgL_zc3anonymousza33288ze3z83_18020, (int) (((long) 3)),
						BgL_bodyz00_18019);
					return BgL_zc3anonymousza33288ze3z83_18020;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3288> */
	obj_t BGl_z62zc3anonymousza33288ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15339, obj_t BgL_sz00_15344)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 550 */
			{	/* Eval/evaluate_comp.scm 550 */
				obj_t BgL_mutexz00_15340;
				BgL_ev_synchroniza7eza7_bglt BgL_i1141z00_15341;
				obj_t BgL_prelockz00_15342;
				obj_t BgL_bodyz00_15343;

				BgL_mutexz00_15340 =
					PROCEDURE_REF(BgL_envz00_15339, (int) (((long) 0)));
				BgL_i1141z00_15341 =
					((BgL_ev_synchroniza7eza7_bglt)
					PROCEDURE_REF(BgL_envz00_15339, (int) (((long) 1))));
				BgL_prelockz00_15342 =
					PROCEDURE_REF(BgL_envz00_15339, (int) (((long) 2)));
				BgL_bodyz00_15343 = PROCEDURE_REF(BgL_envz00_15339, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 550 */
					obj_t BgL_bpz00_18021;

					BgL_bpz00_18021 = VECTOR_REF(((obj_t) BgL_sz00_15344), ((long) 0));
					{	/* Eval/evaluate_comp.scm 551 */
						obj_t BgL_mz00_18022;

						BgL_mz00_18022 =
							PROCEDURE_ENTRY(BgL_mutexz00_15340) (BgL_mutexz00_15340,
							BgL_sz00_15344, BEOA);
						{	/* Eval/evaluate_comp.scm 552 */
							bool_t BgL_testz00_33190;

							{	/* Eval/evaluate_comp.scm 552 */
								bool_t BgL_res5166z00_18023;

								BgL_res5166z00_18023 = BGL_MUTEXP(BgL_mz00_18022);
								BgL_testz00_33190 = BgL_res5166z00_18023;
							}
							if (BgL_testz00_33190)
								{	/* Eval/evaluate_comp.scm 553 */
									obj_t BgL_pz00_18024;

									BgL_pz00_18024 =
										PROCEDURE_ENTRY(BgL_prelockz00_15342) (BgL_prelockz00_15342,
										BgL_sz00_15344, BEOA);
									{	/* Eval/evaluate_comp.scm 555 */
										obj_t BgL_za2za2resza2za2z00_18025;

										if (PAIRP(BgL_pz00_18024))
											{	/* Eval/evaluate_comp.scm 556 */
												obj_t BgL_top6029z00_33199;

												BgL_top6029z00_33199 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_18022, BgL_pz00_18024);
												BGL_EXITD_PUSH_PROTECT(BgL_top6029z00_33199,
													BgL_mz00_18022);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 556 */
													obj_t BgL_tmp6028z00_33198;

													BgL_tmp6028z00_33198 =
														PROCEDURE_ENTRY(BgL_bodyz00_15343)
														(BgL_bodyz00_15343, BgL_sz00_15344, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6029z00_33199);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_18022);
													BgL_za2za2resza2za2z00_18025 = BgL_tmp6028z00_33198;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 557 */
												obj_t BgL_top6031z00_33210;

												BgL_top6031z00_33210 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK(BgL_mz00_18022);
												BGL_EXITD_PUSH_PROTECT(BgL_top6031z00_33210,
													BgL_mz00_18022);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 557 */
													obj_t BgL_tmp6030z00_33209;

													BgL_tmp6030z00_33209 =
														PROCEDURE_ENTRY(BgL_bodyz00_15343)
														(BgL_bodyz00_15343, BgL_sz00_15344, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6031z00_33210);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_18022);
													BgL_za2za2resza2za2z00_18025 = BgL_tmp6030z00_33209;
												}
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15344), ((long) 0), BgL_bpz00_18021);
										return BgL_za2za2resza2za2z00_18025;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 552 */
									return
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_string5894z00zz__evaluate_compz00,
										BGl_string5895z00zz__evaluate_compz00, BgL_mz00_18022,
										(((BgL_ev_synchroniza7eza7_bglt)
												COBJECT(BgL_i1141z00_15341))->BgL_locz00));
								}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_with-handler1423 */
	obj_t BGl_z62compzd2ev_withzd2handler1423z62zz__evaluate_compz00(obj_t
		BgL_envz00_15345, obj_t BgL_ez00_15346, obj_t BgL_stkz00_15347)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 536 */
			{	/* Eval/evaluate_comp.scm 538 */
				obj_t BgL_handlerz00_18027;
				obj_t BgL_bodyz00_18028;

				BgL_handlerz00_18027 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
								((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15346)))->
						BgL_handlerz00), BgL_stkz00_15347);
				BgL_bodyz00_18028 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
							COBJECT(((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15346)))->
						BgL_bodyz00), BgL_stkz00_15347);
				{	/* Eval/evaluate_comp.scm 539 */
					obj_t BgL_zc3anonymousza33273ze3z83_18029;

					BgL_zc3anonymousza33273ze3z83_18029 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33273ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3anonymousza33273ze3z83_18029, (int) (((long) 0)),
						BgL_handlerz00_18027);
					PROCEDURE_SET(BgL_zc3anonymousza33273ze3z83_18029, (int) (((long) 1)),
						BgL_bodyz00_18028);
					return BgL_zc3anonymousza33273ze3z83_18029;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3273> */
	obj_t BGl_z62zc3anonymousza33273ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15348, obj_t BgL_sz00_15351)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 539 */
			{	/* Eval/evaluate_comp.scm 539 */
				obj_t BgL_handlerz00_15349;
				obj_t BgL_bodyz00_15350;

				BgL_handlerz00_15349 =
					PROCEDURE_REF(BgL_envz00_15348, (int) (((long) 0)));
				BgL_bodyz00_15350 = PROCEDURE_REF(BgL_envz00_15348, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 539 */
					obj_t BgL_bpz00_18030;

					BgL_bpz00_18030 = VECTOR_REF(((obj_t) BgL_sz00_15351), ((long) 0));
					{	/* Eval/evaluate_comp.scm 540 */
						obj_t BgL_hz00_18031;

						BgL_hz00_18031 =
							PROCEDURE_ENTRY(BgL_handlerz00_15349) (BgL_handlerz00_15349,
							BgL_sz00_15351, BEOA);
						{	/* Eval/evaluate_comp.scm 542 */
							obj_t BgL_za2za2resza2za2z00_18032;

							{	/* Eval/evaluate_comp.scm 542 */
								obj_t BgL_res1131z00_18033;

								BgL_res1131z00_18033 = MAKE_CELL(BUNSPEC);
								if (CBOOL(BGl_zc3exitza33281ze3ze70z64zz__evaluate_compz00
										(BgL_sz00_15351, BgL_bodyz00_15350, BgL_res1131z00_18033)))
									{	/* Eval/evaluate_comp.scm 542 */
										BgL_za2za2resza2za2z00_18032 =
											PROCEDURE_ENTRY(BgL_hz00_18031) (BgL_hz00_18031,
											CELL_REF(BgL_res1131z00_18033), BEOA);
									}
								else
									{	/* Eval/evaluate_comp.scm 542 */
										BgL_za2za2resza2za2z00_18032 =
											CELL_REF(BgL_res1131z00_18033);
									}
							}
							VECTOR_SET(((obj_t) BgL_sz00_15351), ((long) 0), BgL_bpz00_18030);
							return BgL_za2za2resza2za2z00_18032;
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* <exit:3281>~0 */
	obj_t BGl_zc3exitza33281ze3ze70z64zz__evaluate_compz00(obj_t BgL_sz00_15539,
		obj_t BgL_bodyz00_15538, obj_t BgL_res1131z00_15537)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 542 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1137z00_4197;

			if (SET_EXIT(BgL_an_exit1137z00_4197))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1137z00_4197 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 542 */

						PUSH_EXIT(BgL_an_exit1137z00_4197, ((long) 1));
						{	/* Eval/evaluate_comp.scm 542 */
							obj_t BgL_an_exitd1138z00_4198;

							BgL_an_exitd1138z00_4198 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 542 */
								bool_t BgL_res1140z00_4201;

								{	/* Eval/evaluate_comp.scm 542 */
									obj_t BgL_ohs1129z00_4202;

									BgL_ohs1129z00_4202 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 542 */
										obj_t BgL_exitd1134z00_4203;

										BgL_exitd1134z00_4203 = ((obj_t) (&exitd));
										{
											obj_t BgL_zc3anonymousza33285ze3z83_14318;

											BgL_zc3anonymousza33285ze3z83_14318 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza33285ze3ze1zz__evaluate_compz00,
												(int) (((long) 0)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3anonymousza33285ze3z83_14318,
												(int) (((long) 0)), BgL_ohs1129z00_4202);
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_exitd1134z00_4203,
												BgL_zc3anonymousza33285ze3z83_14318);
											{	/* Eval/evaluate_comp.scm 542 */
												bool_t BgL_tmp1136z00_4205;

												{	/* Eval/evaluate_comp.scm 542 */
													obj_t BgL_arg3282z00_4206;

													{	/* Eval/evaluate_comp.scm 542 */
														obj_t BgL_zc3anonymousza33284ze3z83_14319;

														BgL_zc3anonymousza33284ze3z83_14319 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza33284ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET(BgL_zc3anonymousza33284ze3z83_14319,
															(int) (((long) 0)),
															((obj_t) BgL_res1131z00_15537));
														PROCEDURE_SET(BgL_zc3anonymousza33284ze3z83_14319,
															(int) (((long) 1)), BgL_an_exitd1138z00_4198);
														BgL_arg3282z00_4206 =
															MAKE_YOUNG_PAIR
															(BgL_zc3anonymousza33284ze3z83_14319,
															BgL_ohs1129z00_4202);
													}
													BGL_ERROR_HANDLER_SET(BgL_arg3282z00_4206);
													BUNSPEC;
												}
												{	/* Eval/evaluate_comp.scm 542 */
													obj_t BgL_auxz00_15353;

													BgL_auxz00_15353 =
														PROCEDURE_ENTRY(BgL_bodyz00_15538)
														(BgL_bodyz00_15538, BgL_sz00_15539, BEOA);
													CELL_SET(BgL_res1131z00_15537, BgL_auxz00_15353);
												}
												BgL_tmp1136z00_4205 = ((bool_t) 0);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_exitd1134z00_4203);
												BGL_ERROR_HANDLER_SET(BgL_ohs1129z00_4202);
												BUNSPEC;
												BgL_res1140z00_4201 = BgL_tmp1136z00_4205;
								}}}}
								POP_EXIT();
								return BBOOL(BgL_res1140z00_4201);
							}
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3284> */
	obj_t BGl_z62zc3anonymousza33284ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15355, obj_t BgL_ez00_15358)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 542 */
			{	/* Eval/evaluate_comp.scm 542 */
				obj_t BgL_res1131z00_15356;
				obj_t BgL_an_exitd1138z00_15357;

				BgL_res1131z00_15356 =
					PROCEDURE_REF(BgL_envz00_15355, (int) (((long) 0)));
				BgL_an_exitd1138z00_15357 =
					PROCEDURE_REF(BgL_envz00_15355, (int) (((long) 1)));
				CELL_SET(BgL_res1131z00_15356, BgL_ez00_15358);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1138z00_15357,
					BTRUE);
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3285> */
	obj_t BGl_z62zc3anonymousza33285ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15360)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 542 */
			{
				obj_t BgL_ohs1129z00_15361;

				BgL_ohs1129z00_15361 =
					PROCEDURE_REF(BgL_envz00_15360, (int) (((long) 0)));
				BGL_ERROR_HANDLER_SET(BgL_ohs1129z00_15361);
				return BUNSPEC;
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_unwind-prote1421 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1421z62zz__evaluate_compz00(obj_t
		BgL_envz00_15362, obj_t BgL_ez00_15363, obj_t BgL_stkz00_15364)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 527 */
			{	/* Eval/evaluate_comp.scm 529 */
				obj_t BgL_ez00_18035;
				obj_t BgL_bodyz00_18036;

				BgL_ez00_18035 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
								((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15363)))->BgL_ez00),
					BgL_stkz00_15364);
				BgL_bodyz00_18036 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
							COBJECT(((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15363)))->
						BgL_bodyz00), BgL_stkz00_15364);
				{	/* Eval/evaluate_comp.scm 530 */
					obj_t BgL_zc3anonymousza33268ze3z83_18037;

					BgL_zc3anonymousza33268ze3z83_18037 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33268ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3anonymousza33268ze3z83_18037, (int) (((long) 0)),
						BgL_bodyz00_18036);
					PROCEDURE_SET(BgL_zc3anonymousza33268ze3z83_18037, (int) (((long) 1)),
						BgL_ez00_18035);
					return BgL_zc3anonymousza33268ze3z83_18037;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3268> */
	obj_t BGl_z62zc3anonymousza33268ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15365, obj_t BgL_sz00_15368)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 530 */
			{	/* Eval/evaluate_comp.scm 530 */
				obj_t BgL_bodyz00_15366;
				obj_t BgL_ez00_15367;

				BgL_bodyz00_15366 = PROCEDURE_REF(BgL_envz00_15365, (int) (((long) 0)));
				BgL_ez00_15367 = PROCEDURE_REF(BgL_envz00_15365, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 530 */
					obj_t BgL_bpz00_18038;

					BgL_bpz00_18038 = VECTOR_REF(((obj_t) BgL_sz00_15368), ((long) 0));
					{	/* Eval/evaluate_comp.scm 532 */
						obj_t BgL_exitd1125z00_18039;

						BgL_exitd1125z00_18039 = BGL_EXITD_TOP_AS_OBJ();
						{	/* Eval/evaluate_comp.scm 533 */
							obj_t BgL_zc3anonymousza33269ze3z83_18040;

							BgL_zc3anonymousza33269ze3z83_18040 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza33269ze3ze1zz__evaluate_compz00,
								(int) (((long) 0)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3anonymousza33269ze3z83_18040,
								(int) (((long) 0)), BgL_sz00_15368);
							PROCEDURE_SET(BgL_zc3anonymousza33269ze3z83_18040,
								(int) (((long) 1)), BgL_bpz00_18038);
							PROCEDURE_SET(BgL_zc3anonymousza33269ze3z83_18040,
								(int) (((long) 2)), BgL_bodyz00_15366);
							BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
								(BgL_exitd1125z00_18039, BgL_zc3anonymousza33269ze3z83_18040);
							{	/* Eval/evaluate_comp.scm 532 */
								obj_t BgL_tmp1127z00_18041;

								BgL_tmp1127z00_18041 =
									PROCEDURE_ENTRY(BgL_ez00_15367) (BgL_ez00_15367,
									BgL_sz00_15368, BEOA);
								BGl_exitdzd2popzd2protectz12z12zz__bexitz00
									(BgL_exitd1125z00_18039);
								VECTOR_SET(((obj_t) BgL_sz00_15368), ((long) 0),
									BgL_bpz00_18038);
								PROCEDURE_ENTRY(BgL_bodyz00_15366) (BgL_bodyz00_15366,
									BgL_sz00_15368, BEOA);
								return BgL_tmp1127z00_18041;
							}
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3269> */
	obj_t BGl_z62zc3anonymousza33269ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15369)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 532 */
			{	/* Eval/evaluate_comp.scm 533 */
				obj_t BgL_sz00_15370;
				obj_t BgL_savedzd2bpzd2_15371;
				obj_t BgL_bodyz00_15372;

				BgL_sz00_15370 = PROCEDURE_REF(BgL_envz00_15369, (int) (((long) 0)));
				BgL_savedzd2bpzd2_15371 =
					PROCEDURE_REF(BgL_envz00_15369, (int) (((long) 1)));
				BgL_bodyz00_15372 = PROCEDURE_REF(BgL_envz00_15369, (int) (((long) 2)));
				VECTOR_SET(
					((obj_t) BgL_sz00_15370), ((long) 0), BgL_savedzd2bpzd2_15371);
				return
					PROCEDURE_ENTRY(BgL_bodyz00_15372) (BgL_bodyz00_15372, BgL_sz00_15370,
					BEOA);
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_bind-exit1419 */
	obj_t BGl_z62compzd2ev_bindzd2exit1419z62zz__evaluate_compz00(obj_t
		BgL_envz00_15373, obj_t BgL_ez00_15374, obj_t BgL_stkz00_15375)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 516 */
			{	/* Eval/evaluate_comp.scm 518 */
				long BgL_siza7eza7_18043;
				obj_t BgL_nstkz00_18044;

				BgL_siza7eza7_18043 = bgl_list_length(BgL_stkz00_15375);
				{	/* Eval/evaluate_comp.scm 518 */
					obj_t BgL_arg3266z00_18045;

					{	/* Eval/evaluate_comp.scm 518 */
						BgL_ev_varz00_bglt BgL_arg3267z00_18046;

						BgL_arg3267z00_18046 =
							(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15374)))->BgL_varz00);
						BgL_arg3266z00_18045 =
							MAKE_YOUNG_PAIR(((obj_t) BgL_arg3267z00_18046), BNIL);
					}
					BgL_nstkz00_18044 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15375,
						BgL_arg3266z00_18045);
				}
				{	/* Eval/evaluate_comp.scm 519 */
					obj_t BgL_bodyz00_18047;
					obj_t BgL_effzf3zf3_18048;

					BgL_bodyz00_18047 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15374)))->BgL_bodyz00),
						BgL_nstkz00_18044);
					BgL_effzf3zf3_18048 =
						(((BgL_ev_varz00_bglt) COBJECT((((BgL_ev_bindzd2exitzd2_bglt)
										COBJECT(((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15374)))->
									BgL_varz00)))->BgL_effz00);
					{	/* Eval/evaluate_comp.scm 520 */
						obj_t BgL_zc3anonymousza33261ze3z83_18049;

						BgL_zc3anonymousza33261ze3z83_18049 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33261ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3anonymousza33261ze3z83_18049,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18043));
						PROCEDURE_SET(BgL_zc3anonymousza33261ze3z83_18049,
							(int) (((long) 1)), BgL_effzf3zf3_18048);
						PROCEDURE_SET(BgL_zc3anonymousza33261ze3z83_18049,
							(int) (((long) 2)), BgL_bodyz00_18047);
						return BgL_zc3anonymousza33261ze3z83_18049;
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3261> */
	obj_t BGl_z62zc3anonymousza33261ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15376, obj_t BgL_sz00_15380)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 520 */
			{	/* Eval/evaluate_comp.scm 520 */
				long BgL_siza7eza7_15377;
				obj_t BgL_effzf3zf3_15378;
				obj_t BgL_bodyz00_15379;

				BgL_siza7eza7_15377 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 0))));
				BgL_effzf3zf3_15378 =
					PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 1)));
				BgL_bodyz00_15379 = PROCEDURE_REF(BgL_envz00_15376, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 520 */
					obj_t BgL_bpz00_18050;

					BgL_bpz00_18050 = VECTOR_REF(((obj_t) BgL_sz00_15380), ((long) 0));
					{	/* Eval/evaluate_comp.scm 522 */
						obj_t BgL_za2za2resza2za2z00_18051;

						BgL_za2za2resza2za2z00_18051 =
							BGl_zc3exitza33262ze3ze70z64zz__evaluate_compz00
							(BgL_bodyz00_15379, BgL_sz00_15380, BgL_effzf3zf3_15378,
							BgL_siza7eza7_15377, BgL_bpz00_18050);
						VECTOR_SET(((obj_t) BgL_sz00_15380), ((long) 0), BgL_bpz00_18050);
						return BgL_za2za2resza2za2z00_18051;
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* <exit:3262>~0 */
	obj_t BGl_zc3exitza33262ze3ze70z64zz__evaluate_compz00(obj_t
		BgL_bodyz00_15536, obj_t BgL_sz00_15535, obj_t BgL_effzf3zf3_15534,
		long BgL_siza7eza7_15533, obj_t BgL_bpz00_15532)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 522 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1120z00_4132;

			if (SET_EXIT(BgL_an_exit1120z00_4132))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1120z00_4132 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 522 */

						PUSH_EXIT(BgL_an_exit1120z00_4132, ((long) 1));
						{	/* Eval/evaluate_comp.scm 522 */
							obj_t BgL_an_exitd1121z00_4133;

							BgL_an_exitd1121z00_4133 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 522 */
								obj_t BgL_exitz00_14325;

								BgL_exitz00_14325 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_14325,
									(int) (((long) 0)), BgL_an_exitd1121z00_4133);
								{	/* Eval/evaluate_comp.scm 522 */
									obj_t BgL_res1123z00_4136;

									{	/* Eval/evaluate_comp.scm 523 */
										long BgL_arg3263z00_4137;
										obj_t BgL_arg3264z00_4138;

										BgL_arg3263z00_4137 =
											((long) CINT(BgL_bpz00_15532) + BgL_siza7eza7_15533);
										if (CBOOL(BgL_effzf3zf3_15534))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_10511;

												BgL_newz00_10511 =
													create_struct(BGl_symbol5785z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33393;

													BgL_tmpz00_33393 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10511, BgL_tmpz00_33393,
														BgL_exitz00_14325);
												}
												BgL_arg3264z00_4138 = BgL_newz00_10511;
											}
										else
											{	/* Eval/evaluate_comp.scm 523 */
												BgL_arg3264z00_4138 = BgL_exitz00_14325;
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15535), BgL_arg3263z00_4137,
											BgL_arg3264z00_4138);
									}
									BgL_res1123z00_4136 =
										PROCEDURE_ENTRY(BgL_bodyz00_15536) (BgL_bodyz00_15536,
										BgL_sz00_15535, BEOA);
									POP_EXIT();
									return BgL_res1123z00_4136;
								}
							}
						}
					}
				}
		}
		BGL_FUNCTION_END;
	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_15381,
		obj_t BgL_val1122z00_15383)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 522 */
			return
				BGl_unwindzd2untilz12zc0zz__bexitz00(PROCEDURE_REF(BgL_envz00_15381,
					(int) (((long) 0))), BgL_val1122z00_15383);
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_letrec1417 */
	obj_t BGl_z62compzd2ev_letrec1417zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15384, obj_t BgL_ez00_15385, obj_t BgL_stkz00_15386)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 487 */
			{	/* Eval/evaluate_comp.scm 489 */
				long BgL_siza7eza7_18053;
				obj_t BgL_nstkz00_18054;

				BgL_siza7eza7_18053 = bgl_list_length(BgL_stkz00_15386);
				{	/* Eval/evaluate_comp.scm 489 */
					obj_t BgL_arg3260z00_18055;

					BgL_arg3260z00_18055 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_ez00_15385))))->BgL_varsz00);
					BgL_nstkz00_18054 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15386,
						BgL_arg3260z00_18055);
				}
				{	/* Eval/evaluate_comp.scm 490 */
					obj_t BgL_cvalsz00_18056;
					obj_t BgL_bodyz00_18057;

					{	/* Eval/evaluate_comp.scm 490 */
						obj_t BgL_l1317z00_18058;

						BgL_l1317z00_18058 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15385))))->BgL_valsz00);
						if (NULLP(BgL_l1317z00_18058))
							{	/* Eval/evaluate_comp.scm 490 */
								BgL_cvalsz00_18056 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 490 */
								obj_t BgL_head1319z00_18059;

								{	/* Eval/evaluate_comp.scm 490 */
									obj_t BgL_res5125z00_18060;

									BgL_res5125z00_18060 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1319z00_18059 = BgL_res5125z00_18060;
								}
								{
									obj_t BgL_l1317z00_18062;
									obj_t BgL_tail1320z00_18063;

									BgL_l1317z00_18062 = BgL_l1317z00_18058;
									BgL_tail1320z00_18063 = BgL_head1319z00_18059;
								BgL_zc3anonymousza33254ze3z83_18061:
									if (NULLP(BgL_l1317z00_18062))
										{	/* Eval/evaluate_comp.scm 490 */
											BgL_cvalsz00_18056 = CDR(BgL_head1319z00_18059);
										}
									else
										{	/* Eval/evaluate_comp.scm 490 */
											obj_t BgL_newtail1321z00_18064;

											{	/* Eval/evaluate_comp.scm 490 */
												obj_t BgL_arg3258z00_18065;

												{	/* Eval/evaluate_comp.scm 490 */
													obj_t BgL_vz00_18066;

													BgL_vz00_18066 = CAR(((obj_t) BgL_l1317z00_18062));
													BgL_arg3258z00_18065 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18066),
														BgL_nstkz00_18054);
												}
												{	/* Eval/evaluate_comp.scm 490 */
													obj_t BgL_res5131z00_18067;

													BgL_res5131z00_18067 =
														MAKE_YOUNG_PAIR(BgL_arg3258z00_18065, BNIL);
													BgL_newtail1321z00_18064 = BgL_res5131z00_18067;
												}
											}
											SET_CDR(BgL_tail1320z00_18063, BgL_newtail1321z00_18064);
											{	/* Eval/evaluate_comp.scm 490 */
												obj_t BgL_arg3256z00_18068;

												BgL_arg3256z00_18068 =
													CDR(((obj_t) BgL_l1317z00_18062));
												{
													obj_t BgL_tail1320z00_33429;
													obj_t BgL_l1317z00_33428;

													BgL_l1317z00_33428 = BgL_arg3256z00_18068;
													BgL_tail1320z00_33429 = BgL_newtail1321z00_18064;
													BgL_tail1320z00_18063 = BgL_tail1320z00_33429;
													BgL_l1317z00_18062 = BgL_l1317z00_33428;
													goto BgL_zc3anonymousza33254ze3z83_18061;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 491 */
						BgL_ev_exprz00_bglt BgL_arg3259z00_18069;

						BgL_arg3259z00_18069 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15385))))->BgL_bodyz00);
						BgL_bodyz00_18057 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3259z00_18069,
							BgL_nstkz00_18054);
					}
					{	/* Eval/evaluate_comp.scm 492 */
						bool_t BgL_testz00_33434;

						{
							obj_t BgL_l1322z00_18071;

							BgL_l1322z00_18071 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letrecz00_bglt) BgL_ez00_15385))))->BgL_valsz00);
						BgL_zc3anonymousza33248ze3z83_18070:
							if (NULLP(BgL_l1322z00_18071))
								{	/* Eval/evaluate_comp.scm 492 */
									BgL_testz00_33434 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 492 */
									bool_t BgL_testz00_33437;

									{	/* Eval/evaluate_comp.scm 492 */
										obj_t BgL_vz00_18072;

										BgL_vz00_18072 = CAR(((obj_t) BgL_l1322z00_18071));
										BgL_testz00_33437 =
											BGl_isazf3zf3zz__objectz00(BgL_vz00_18072,
											BGl_ev_absz00zz__evaluate_typesz00);
									}
									if (BgL_testz00_33437)
										{
											obj_t BgL_l1322z00_33441;

											BgL_l1322z00_33441 = CDR(((obj_t) BgL_l1322z00_18071));
											BgL_l1322z00_18071 = BgL_l1322z00_33441;
											goto BgL_zc3anonymousza33248ze3z83_18070;
										}
									else
										{	/* Eval/evaluate_comp.scm 492 */
											BgL_testz00_33434 = ((bool_t) 0);
										}
								}
						}
						if (BgL_testz00_33434)
							{	/* Eval/evaluate_comp.scm 493 */
								obj_t BgL_zc3anonymousza33206ze3z83_18073;

								BgL_zc3anonymousza33206ze3z83_18073 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza33206ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza33206ze3z83_18073,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18053));
								PROCEDURE_SET(BgL_zc3anonymousza33206ze3z83_18073,
									(int) (((long) 1)), BgL_cvalsz00_18056);
								PROCEDURE_SET(BgL_zc3anonymousza33206ze3z83_18073,
									(int) (((long) 2)), BgL_bodyz00_18057);
								return BgL_zc3anonymousza33206ze3z83_18073;
							}
						else
							{	/* Eval/evaluate_comp.scm 503 */
								obj_t BgL_zc3anonymousza33221ze3z83_18074;

								BgL_zc3anonymousza33221ze3z83_18074 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza33221ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza33221ze3z83_18074,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18053));
								PROCEDURE_SET(BgL_zc3anonymousza33221ze3z83_18074,
									(int) (((long) 1)), BgL_cvalsz00_18056);
								PROCEDURE_SET(BgL_zc3anonymousza33221ze3z83_18074,
									(int) (((long) 2)), BgL_bodyz00_18057);
								return BgL_zc3anonymousza33221ze3z83_18074;
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3206> */
	obj_t BGl_z62zc3anonymousza33206ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15387, obj_t BgL_sz00_15391)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 493 */
			{	/* Eval/evaluate_comp.scm 493 */
				long BgL_siza7eza7_15388;
				obj_t BgL_cvalsz00_15389;
				obj_t BgL_bodyz00_15390;

				BgL_siza7eza7_15388 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15387, (int) (((long) 0))));
				BgL_cvalsz00_15389 =
					PROCEDURE_REF(BgL_envz00_15387, (int) (((long) 1)));
				BgL_bodyz00_15390 = PROCEDURE_REF(BgL_envz00_15387, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 493 */
					obj_t BgL_bpz00_18075;

					BgL_bpz00_18075 = VECTOR_REF(((obj_t) BgL_sz00_15391), ((long) 0));
					{	/* Eval/evaluate_comp.scm 494 */
						long BgL_g1114z00_18076;

						BgL_g1114z00_18076 =
							((long) CINT(BgL_bpz00_18075) + BgL_siza7eza7_15388);
						{
							obj_t BgL_lz00_18078;
							long BgL_iz00_18079;

							BgL_lz00_18078 = BgL_cvalsz00_15389;
							BgL_iz00_18079 = BgL_g1114z00_18076;
						BgL_recz00_18077:
							if (NULLP(BgL_lz00_18078))
								{	/* Eval/evaluate_comp.scm 495 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 495 */
									{	/* Eval/evaluate_comp.scm 496 */
										obj_t BgL_arg3209z00_18080;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18081;

											BgL_newz00_18081 =
												create_struct(BGl_symbol5785z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33482;

												BgL_tmpz00_33482 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18081, BgL_tmpz00_33482, BUNSPEC);
											}
											BgL_arg3209z00_18080 = BgL_newz00_18081;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15391), BgL_iz00_18079,
											BgL_arg3209z00_18080);
									}
									{	/* Eval/evaluate_comp.scm 497 */
										obj_t BgL_arg3211z00_18082;
										long BgL_arg3212z00_18083;

										BgL_arg3211z00_18082 = CDR(((obj_t) BgL_lz00_18078));
										BgL_arg3212z00_18083 = (BgL_iz00_18079 + ((long) 1));
										{
											long BgL_iz00_33491;
											obj_t BgL_lz00_33490;

											BgL_lz00_33490 = BgL_arg3211z00_18082;
											BgL_iz00_33491 = BgL_arg3212z00_18083;
											BgL_iz00_18079 = BgL_iz00_33491;
											BgL_lz00_18078 = BgL_lz00_33490;
											goto BgL_recz00_18077;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 498 */
						long BgL_g1115z00_18084;

						BgL_g1115z00_18084 =
							((long) CINT(BgL_bpz00_18075) + BgL_siza7eza7_15388);
						{
							obj_t BgL_lz00_18086;
							long BgL_iz00_18087;

							BgL_lz00_18086 = BgL_cvalsz00_15389;
							BgL_iz00_18087 = BgL_g1115z00_18084;
						BgL_recz00_18085:
							if (NULLP(BgL_lz00_18086))
								{	/* Eval/evaluate_comp.scm 499 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 499 */
									{	/* Eval/evaluate_comp.scm 500 */
										obj_t BgL_arg3215z00_18088;
										obj_t BgL_arg3216z00_18089;

										BgL_arg3215z00_18088 =
											VECTOR_REF(((obj_t) BgL_sz00_15391), BgL_iz00_18087);
										{	/* Eval/evaluate_comp.scm 500 */
											obj_t BgL_fun3217z00_18090;

											BgL_fun3217z00_18090 = CAR(((obj_t) BgL_lz00_18086));
											BgL_arg3216z00_18089 =
												PROCEDURE_ENTRY(BgL_fun3217z00_18090)
												(BgL_fun3217z00_18090, BgL_sz00_15391, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 202 */
											int BgL_auxz00_33506;
											obj_t BgL_tmpz00_33504;

											BgL_auxz00_33506 = (int) (((long) 0));
											BgL_tmpz00_33504 = ((obj_t) BgL_arg3215z00_18088);
											STRUCT_SET(BgL_tmpz00_33504, BgL_auxz00_33506,
												BgL_arg3216z00_18089);
									}}
									{	/* Eval/evaluate_comp.scm 501 */
										obj_t BgL_arg3219z00_18091;
										long BgL_arg3220z00_18092;

										BgL_arg3219z00_18091 = CDR(((obj_t) BgL_lz00_18086));
										BgL_arg3220z00_18092 = (BgL_iz00_18087 + ((long) 1));
										{
											long BgL_iz00_33513;
											obj_t BgL_lz00_33512;

											BgL_lz00_33512 = BgL_arg3219z00_18091;
											BgL_iz00_33513 = BgL_arg3220z00_18092;
											BgL_iz00_18087 = BgL_iz00_33513;
											BgL_lz00_18086 = BgL_lz00_33512;
											goto BgL_recz00_18085;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15390) (BgL_bodyz00_15390,
						BgL_sz00_15391, BEOA);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3221> */
	obj_t BGl_z62zc3anonymousza33221ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15392, obj_t BgL_sz00_15396)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 503 */
			{	/* Eval/evaluate_comp.scm 503 */
				long BgL_siza7eza7_15393;
				obj_t BgL_cvalsz00_15394;
				obj_t BgL_bodyz00_15395;

				BgL_siza7eza7_15393 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 0))));
				BgL_cvalsz00_15394 =
					PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 1)));
				BgL_bodyz00_15395 = PROCEDURE_REF(BgL_envz00_15392, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 503 */
					obj_t BgL_bpz00_18093;

					BgL_bpz00_18093 = VECTOR_REF(((obj_t) BgL_sz00_15396), ((long) 0));
					{	/* Eval/evaluate_comp.scm 504 */
						long BgL_g1116z00_18094;

						BgL_g1116z00_18094 =
							((long) CINT(BgL_bpz00_18093) + BgL_siza7eza7_15393);
						{
							obj_t BgL_lz00_18096;
							long BgL_iz00_18097;

							BgL_lz00_18096 = BgL_cvalsz00_15394;
							BgL_iz00_18097 = BgL_g1116z00_18094;
						BgL_recz00_18095:
							if (NULLP(BgL_lz00_18096))
								{	/* Eval/evaluate_comp.scm 505 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 505 */
									{	/* Eval/evaluate_comp.scm 506 */
										obj_t BgL_arg3224z00_18098;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18099;

											BgL_newz00_18099 =
												create_struct(BGl_symbol5785z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33533;

												BgL_tmpz00_33533 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18099, BgL_tmpz00_33533, BUNSPEC);
											}
											BgL_arg3224z00_18098 = BgL_newz00_18099;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15396), BgL_iz00_18097,
											BgL_arg3224z00_18098);
									}
									{	/* Eval/evaluate_comp.scm 507 */
										obj_t BgL_arg3226z00_18100;
										long BgL_arg3229z00_18101;

										BgL_arg3226z00_18100 = CDR(((obj_t) BgL_lz00_18096));
										BgL_arg3229z00_18101 = (BgL_iz00_18097 + ((long) 1));
										{
											long BgL_iz00_33542;
											obj_t BgL_lz00_33541;

											BgL_lz00_33541 = BgL_arg3226z00_18100;
											BgL_iz00_33542 = BgL_arg3229z00_18101;
											BgL_iz00_18097 = BgL_iz00_33542;
											BgL_lz00_18096 = BgL_lz00_33541;
											goto BgL_recz00_18095;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 508 */
						obj_t BgL_rvalsz00_18102;

						if (NULLP(BgL_cvalsz00_15394))
							{	/* Eval/evaluate_comp.scm 508 */
								BgL_rvalsz00_18102 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 508 */
								obj_t BgL_head1328z00_18103;

								{	/* Eval/evaluate_comp.scm 508 */
									obj_t BgL_res5151z00_18104;

									BgL_res5151z00_18104 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1328z00_18103 = BgL_res5151z00_18104;
								}
								{
									obj_t BgL_l1326z00_18106;
									obj_t BgL_tail1329z00_18107;

									BgL_l1326z00_18106 = BgL_cvalsz00_15394;
									BgL_tail1329z00_18107 = BgL_head1328z00_18103;
								BgL_zc3anonymousza33239ze3z83_18105:
									if (NULLP(BgL_l1326z00_18106))
										{	/* Eval/evaluate_comp.scm 508 */
											BgL_rvalsz00_18102 = CDR(BgL_head1328z00_18103);
										}
									else
										{	/* Eval/evaluate_comp.scm 508 */
											obj_t BgL_newtail1330z00_18108;

											{	/* Eval/evaluate_comp.scm 508 */
												obj_t BgL_arg3247z00_18109;

												{	/* Eval/evaluate_comp.scm 508 */
													obj_t BgL_vz00_18110;

													BgL_vz00_18110 = CAR(((obj_t) BgL_l1326z00_18106));
													BgL_arg3247z00_18109 =
														PROCEDURE_ENTRY(BgL_vz00_18110) (BgL_vz00_18110,
														BgL_sz00_15396, BEOA);
												}
												{	/* Eval/evaluate_comp.scm 508 */
													obj_t BgL_res5157z00_18111;

													BgL_res5157z00_18111 =
														MAKE_YOUNG_PAIR(BgL_arg3247z00_18109, BNIL);
													BgL_newtail1330z00_18108 = BgL_res5157z00_18111;
												}
											}
											SET_CDR(BgL_tail1329z00_18107, BgL_newtail1330z00_18108);
											{	/* Eval/evaluate_comp.scm 508 */
												obj_t BgL_arg3241z00_18112;

												BgL_arg3241z00_18112 =
													CDR(((obj_t) BgL_l1326z00_18106));
												{
													obj_t BgL_tail1329z00_33560;
													obj_t BgL_l1326z00_33559;

													BgL_l1326z00_33559 = BgL_arg3241z00_18112;
													BgL_tail1329z00_33560 = BgL_newtail1330z00_18108;
													BgL_tail1329z00_18107 = BgL_tail1329z00_33560;
													BgL_l1326z00_18106 = BgL_l1326z00_33559;
													goto BgL_zc3anonymousza33239ze3z83_18105;
												}
											}
										}
								}
							}
						{	/* Eval/evaluate_comp.scm 509 */
							long BgL_g1117z00_18113;

							BgL_g1117z00_18113 =
								((long) CINT(BgL_bpz00_18093) + BgL_siza7eza7_15393);
							{
								obj_t BgL_lz00_18115;
								long BgL_iz00_18116;

								BgL_lz00_18115 = BgL_rvalsz00_18102;
								BgL_iz00_18116 = BgL_g1117z00_18113;
							BgL_recz00_18114:
								if (NULLP(BgL_lz00_18115))
									{	/* Eval/evaluate_comp.scm 510 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 510 */
										{	/* Eval/evaluate_comp.scm 511 */
											obj_t BgL_arg3232z00_18117;
											obj_t BgL_arg3234z00_18118;

											BgL_arg3232z00_18117 =
												VECTOR_REF(((obj_t) BgL_sz00_15396), BgL_iz00_18116);
											BgL_arg3234z00_18118 = CAR(((obj_t) BgL_lz00_18115));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_auxz00_33571;
												obj_t BgL_tmpz00_33569;

												BgL_auxz00_33571 = (int) (((long) 0));
												BgL_tmpz00_33569 = ((obj_t) BgL_arg3232z00_18117);
												STRUCT_SET(BgL_tmpz00_33569, BgL_auxz00_33571,
													BgL_arg3234z00_18118);
										}}
										{	/* Eval/evaluate_comp.scm 512 */
											obj_t BgL_arg3235z00_18119;
											long BgL_arg3237z00_18120;

											BgL_arg3235z00_18119 = CDR(((obj_t) BgL_lz00_18115));
											BgL_arg3237z00_18120 = (BgL_iz00_18116 + ((long) 1));
											{
												long BgL_iz00_33578;
												obj_t BgL_lz00_33577;

												BgL_lz00_33577 = BgL_arg3235z00_18119;
												BgL_iz00_33578 = BgL_arg3237z00_18120;
												BgL_iz00_18116 = BgL_iz00_33578;
												BgL_lz00_18115 = BgL_lz00_33577;
												goto BgL_recz00_18114;
											}
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_15395) (BgL_bodyz00_15395,
							BgL_sz00_15396, BEOA);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_let*1415 */
	obj_t BGl_z62compzd2ev_letza21415z12zz__evaluate_compz00(obj_t
		BgL_envz00_15397, obj_t BgL_ez00_15398, obj_t BgL_stkz00_15399)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 474 */
			{	/* Eval/evaluate_comp.scm 476 */
				long BgL_siza7eza7_18122;
				obj_t BgL_nstkz00_18123;

				BgL_siza7eza7_18122 = bgl_list_length(BgL_stkz00_15399);
				{	/* Eval/evaluate_comp.scm 476 */
					obj_t BgL_arg3201z00_18124;

					BgL_arg3201z00_18124 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_ez00_15398))))->BgL_varsz00);
					BgL_nstkz00_18123 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15399,
						BgL_arg3201z00_18124);
				}
				{	/* Eval/evaluate_comp.scm 477 */
					obj_t BgL_valsz00_18125;
					obj_t BgL_bodyz00_18126;

					{	/* Eval/evaluate_comp.scm 477 */
						obj_t BgL_l1312z00_18127;

						BgL_l1312z00_18127 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15398))))->BgL_valsz00);
						if (NULLP(BgL_l1312z00_18127))
							{	/* Eval/evaluate_comp.scm 477 */
								BgL_valsz00_18125 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 477 */
								obj_t BgL_head1314z00_18128;

								{	/* Eval/evaluate_comp.scm 477 */
									obj_t BgL_res5114z00_18129;

									BgL_res5114z00_18129 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1314z00_18128 = BgL_res5114z00_18129;
								}
								{
									obj_t BgL_l1312z00_18131;
									obj_t BgL_tail1315z00_18132;

									BgL_l1312z00_18131 = BgL_l1312z00_18127;
									BgL_tail1315z00_18132 = BgL_head1314z00_18128;
								BgL_zc3anonymousza33195ze3z83_18130:
									if (NULLP(BgL_l1312z00_18131))
										{	/* Eval/evaluate_comp.scm 477 */
											BgL_valsz00_18125 = CDR(BgL_head1314z00_18128);
										}
									else
										{	/* Eval/evaluate_comp.scm 477 */
											obj_t BgL_newtail1316z00_18133;

											{	/* Eval/evaluate_comp.scm 477 */
												obj_t BgL_arg3198z00_18134;

												{	/* Eval/evaluate_comp.scm 477 */
													obj_t BgL_vz00_18135;

													BgL_vz00_18135 = CAR(((obj_t) BgL_l1312z00_18131));
													BgL_arg3198z00_18134 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18135),
														BgL_nstkz00_18123);
												}
												{	/* Eval/evaluate_comp.scm 477 */
													obj_t BgL_res5120z00_18136;

													BgL_res5120z00_18136 =
														MAKE_YOUNG_PAIR(BgL_arg3198z00_18134, BNIL);
													BgL_newtail1316z00_18133 = BgL_res5120z00_18136;
												}
											}
											SET_CDR(BgL_tail1315z00_18132, BgL_newtail1316z00_18133);
											{	/* Eval/evaluate_comp.scm 477 */
												obj_t BgL_arg3197z00_18137;

												BgL_arg3197z00_18137 =
													CDR(((obj_t) BgL_l1312z00_18131));
												{
													obj_t BgL_tail1315z00_33606;
													obj_t BgL_l1312z00_33605;

													BgL_l1312z00_33605 = BgL_arg3197z00_18137;
													BgL_tail1315z00_33606 = BgL_newtail1316z00_18133;
													BgL_tail1315z00_18132 = BgL_tail1315z00_33606;
													BgL_l1312z00_18131 = BgL_l1312z00_33605;
													goto BgL_zc3anonymousza33195ze3z83_18130;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 478 */
						BgL_ev_exprz00_bglt BgL_arg3200z00_18138;

						BgL_arg3200z00_18138 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15398))))->BgL_bodyz00);
						BgL_bodyz00_18126 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3200z00_18138,
							BgL_nstkz00_18123);
					}
					{	/* Eval/evaluate_comp.scm 479 */
						obj_t BgL_zc3anonymousza33181ze3z83_18139;

						BgL_zc3anonymousza33181ze3z83_18139 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33181ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3anonymousza33181ze3z83_18139,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18122));
						PROCEDURE_SET(BgL_zc3anonymousza33181ze3z83_18139,
							(int) (((long) 1)),
							((obj_t) ((BgL_ev_letza2za2_bglt) BgL_ez00_15398)));
						PROCEDURE_SET(BgL_zc3anonymousza33181ze3z83_18139,
							(int) (((long) 2)), BgL_valsz00_18125);
						PROCEDURE_SET(BgL_zc3anonymousza33181ze3z83_18139,
							(int) (((long) 3)), BgL_bodyz00_18126);
						return BgL_zc3anonymousza33181ze3z83_18139;
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3181> */
	obj_t BGl_z62zc3anonymousza33181ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15400, obj_t BgL_sz00_15405)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 479 */
			{	/* Eval/evaluate_comp.scm 479 */
				long BgL_siza7eza7_15401;
				BgL_ev_letza2za2_bglt BgL_i1111z00_15402;
				obj_t BgL_valsz00_15403;
				obj_t BgL_bodyz00_15404;

				BgL_siza7eza7_15401 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15400, (int) (((long) 0))));
				BgL_i1111z00_15402 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_15400, (int) (((long) 1))));
				BgL_valsz00_15403 = PROCEDURE_REF(BgL_envz00_15400, (int) (((long) 2)));
				BgL_bodyz00_15404 = PROCEDURE_REF(BgL_envz00_15400, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 479 */
					obj_t BgL_bpz00_18140;

					BgL_bpz00_18140 = VECTOR_REF(((obj_t) BgL_sz00_15405), ((long) 0));
					{	/* Eval/evaluate_comp.scm 480 */
						long BgL_g1112z00_18141;

						BgL_g1112z00_18141 =
							((long) CINT(BgL_bpz00_18140) + BgL_siza7eza7_15401);
						{
							obj_t BgL_lz00_18143;
							long BgL_iz00_18144;
							obj_t BgL_bza2za2_18145;

							BgL_lz00_18143 = BgL_valsz00_15403;
							BgL_iz00_18144 = BgL_g1112z00_18141;
							BgL_bza2za2_18145 =
								(((BgL_ev_letza2za2_bglt) COBJECT(BgL_i1111z00_15402))->
								BgL_boxesz00);
						BgL_recz00_18142:
							if (NULLP(BgL_lz00_18143))
								{	/* Eval/evaluate_comp.scm 481 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 481 */
									{	/* Eval/evaluate_comp.scm 482 */
										obj_t BgL_valz00_18146;

										{	/* Eval/evaluate_comp.scm 482 */
											obj_t BgL_fun3187z00_18147;

											BgL_fun3187z00_18147 = CAR(((obj_t) BgL_lz00_18143));
											BgL_valz00_18146 =
												PROCEDURE_ENTRY(BgL_fun3187z00_18147)
												(BgL_fun3187z00_18147, BgL_sz00_15405, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 483 */
											obj_t BgL_arg3185z00_18148;

											if (CBOOL(CAR(((obj_t) BgL_bza2za2_18145))))
												{	/* Eval/evaluate_comp.scm 202 */
													obj_t BgL_newz00_18149;

													BgL_newz00_18149 =
														create_struct(BGl_symbol5785z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Eval/evaluate_comp.scm 202 */
														int BgL_tmpz00_33653;

														BgL_tmpz00_33653 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_18149, BgL_tmpz00_33653,
															BgL_valz00_18146);
													}
													BgL_arg3185z00_18148 = BgL_newz00_18149;
												}
											else
												{	/* Eval/evaluate_comp.scm 483 */
													BgL_arg3185z00_18148 = BgL_valz00_18146;
												}
											VECTOR_SET(
												((obj_t) BgL_sz00_15405), BgL_iz00_18144,
												BgL_arg3185z00_18148);
										}
									}
									{	/* Eval/evaluate_comp.scm 484 */
										obj_t BgL_arg3189z00_18150;
										long BgL_arg3192z00_18151;
										obj_t BgL_arg3193z00_18152;

										BgL_arg3189z00_18150 = CDR(((obj_t) BgL_lz00_18143));
										BgL_arg3192z00_18151 = (BgL_iz00_18144 + ((long) 1));
										BgL_arg3193z00_18152 = CDR(((obj_t) BgL_bza2za2_18145));
										{
											obj_t BgL_bza2za2_33665;
											long BgL_iz00_33664;
											obj_t BgL_lz00_33663;

											BgL_lz00_33663 = BgL_arg3189z00_18150;
											BgL_iz00_33664 = BgL_arg3192z00_18151;
											BgL_bza2za2_33665 = BgL_arg3193z00_18152;
											BgL_bza2za2_18145 = BgL_bza2za2_33665;
											BgL_iz00_18144 = BgL_iz00_33664;
											BgL_lz00_18143 = BgL_lz00_33663;
											goto BgL_recz00_18142;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15404) (BgL_bodyz00_15404,
						BgL_sz00_15405, BEOA);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_let1413 */
	obj_t BGl_z62compzd2ev_let1413zb0zz__evaluate_compz00(obj_t BgL_envz00_15406,
		obj_t BgL_ez00_15407, obj_t BgL_stkz00_15408)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 455 */
			{	/* Eval/evaluate_comp.scm 457 */
				long BgL_siza7eza7_18154;
				obj_t BgL_nstkz00_18155;

				BgL_siza7eza7_18154 = bgl_list_length(BgL_stkz00_15408);
				{	/* Eval/evaluate_comp.scm 457 */
					obj_t BgL_arg3180z00_18156;

					BgL_arg3180z00_18156 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_ez00_15407))))->BgL_varsz00);
					BgL_nstkz00_18155 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15408,
						BgL_arg3180z00_18156);
				}
				{	/* Eval/evaluate_comp.scm 458 */
					obj_t BgL_valsz00_18157;
					obj_t BgL_iboxesz00_18158;
					obj_t BgL_bodyz00_18159;

					{	/* Eval/evaluate_comp.scm 459 */
						obj_t BgL_arg3168z00_18160;

						BgL_arg3168z00_18160 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15407))))->BgL_valsz00);
						BgL_valsz00_18157 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00
							(BgL_arg3168z00_18160, BgL_stkz00_15408);
					}
					{	/* Eval/evaluate_comp.scm 460 */
						obj_t BgL_l1307z00_18161;

						BgL_l1307z00_18161 =
							(((BgL_ev_letz00_bglt) COBJECT(
									((BgL_ev_letz00_bglt) BgL_ez00_15407)))->BgL_boxesz00);
						if (NULLP(BgL_l1307z00_18161))
							{	/* Eval/evaluate_comp.scm 460 */
								BgL_iboxesz00_18158 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 460 */
								obj_t BgL_head1309z00_18162;

								{	/* Eval/evaluate_comp.scm 460 */
									obj_t BgL_res5097z00_18163;

									BgL_res5097z00_18163 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1309z00_18162 = BgL_res5097z00_18163;
								}
								{
									obj_t BgL_l1307z00_18165;
									obj_t BgL_tail1310z00_18166;

									BgL_l1307z00_18165 = BgL_l1307z00_18161;
									BgL_tail1310z00_18166 = BgL_head1309z00_18162;
								BgL_zc3anonymousza33170ze3z83_18164:
									if (NULLP(BgL_l1307z00_18165))
										{	/* Eval/evaluate_comp.scm 460 */
											BgL_iboxesz00_18158 = CDR(BgL_head1309z00_18162);
										}
									else
										{	/* Eval/evaluate_comp.scm 460 */
											obj_t BgL_newtail1311z00_18167;

											{	/* Eval/evaluate_comp.scm 460 */
												obj_t BgL_arg3178z00_18168;

												{	/* Eval/evaluate_comp.scm 460 */
													obj_t BgL_vz00_18169;

													BgL_vz00_18169 = CAR(((obj_t) BgL_l1307z00_18165));
													BgL_arg3178z00_18168 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_18169,
														BgL_nstkz00_18155);
												}
												{	/* Eval/evaluate_comp.scm 460 */
													obj_t BgL_res5103z00_18170;

													BgL_res5103z00_18170 =
														MAKE_YOUNG_PAIR(BgL_arg3178z00_18168, BNIL);
													BgL_newtail1311z00_18167 = BgL_res5103z00_18170;
												}
											}
											SET_CDR(BgL_tail1310z00_18166, BgL_newtail1311z00_18167);
											{	/* Eval/evaluate_comp.scm 460 */
												obj_t BgL_arg3173z00_18171;

												BgL_arg3173z00_18171 =
													CDR(((obj_t) BgL_l1307z00_18165));
												{
													obj_t BgL_tail1310z00_33696;
													obj_t BgL_l1307z00_33695;

													BgL_l1307z00_33695 = BgL_arg3173z00_18171;
													BgL_tail1310z00_33696 = BgL_newtail1311z00_18167;
													BgL_tail1310z00_18166 = BgL_tail1310z00_33696;
													BgL_l1307z00_18165 = BgL_l1307z00_33695;
													goto BgL_zc3anonymousza33170ze3z83_18164;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 461 */
						BgL_ev_exprz00_bglt BgL_arg3179z00_18172;

						BgL_arg3179z00_18172 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15407))))->BgL_bodyz00);
						BgL_bodyz00_18159 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3179z00_18172,
							BgL_nstkz00_18155);
					}
					{	/* Eval/evaluate_comp.scm 462 */
						obj_t BgL_zc3anonymousza33151ze3z83_18173;

						BgL_zc3anonymousza33151ze3z83_18173 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza33151ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3anonymousza33151ze3z83_18173,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18154));
						PROCEDURE_SET(BgL_zc3anonymousza33151ze3z83_18173,
							(int) (((long) 1)), BgL_valsz00_18157);
						PROCEDURE_SET(BgL_zc3anonymousza33151ze3z83_18173,
							(int) (((long) 2)), BgL_iboxesz00_18158);
						PROCEDURE_SET(BgL_zc3anonymousza33151ze3z83_18173,
							(int) (((long) 3)), BgL_bodyz00_18159);
						return BgL_zc3anonymousza33151ze3z83_18173;
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3151> */
	obj_t BGl_z62zc3anonymousza33151ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15409, obj_t BgL_sz00_15414)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 462 */
			{	/* Eval/evaluate_comp.scm 462 */
				long BgL_siza7eza7_15410;
				obj_t BgL_valsz00_15411;
				obj_t BgL_iboxesz00_15412;
				obj_t BgL_bodyz00_15413;

				BgL_siza7eza7_15410 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15409, (int) (((long) 0))));
				BgL_valsz00_15411 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15409, (int) (((long) 1))));
				BgL_iboxesz00_15412 =
					PROCEDURE_REF(BgL_envz00_15409, (int) (((long) 2)));
				BgL_bodyz00_15413 = PROCEDURE_REF(BgL_envz00_15409, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 462 */
					obj_t BgL_bpz00_18174;

					BgL_bpz00_18174 = VECTOR_REF(((obj_t) BgL_sz00_15414), ((long) 0));
					{	/* Eval/evaluate_comp.scm 463 */
						long BgL_g1110z00_18175;

						BgL_g1110z00_18175 =
							((long) CINT(BgL_bpz00_18174) + BgL_siza7eza7_15410);
						{
							obj_t BgL_lz00_18177;
							long BgL_iz00_18178;

							BgL_lz00_18177 = BgL_valsz00_15411;
							BgL_iz00_18178 = BgL_g1110z00_18175;
						BgL_recz00_18176:
							if (NULLP(BgL_lz00_18177))
								{	/* Eval/evaluate_comp.scm 464 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 464 */
									{	/* Eval/evaluate_comp.scm 465 */
										obj_t BgL_arg3154z00_18179;

										{	/* Eval/evaluate_comp.scm 465 */
											obj_t BgL_fun3155z00_18180;

											BgL_fun3155z00_18180 = CAR(((obj_t) BgL_lz00_18177));
											BgL_arg3154z00_18179 =
												PROCEDURE_ENTRY(BgL_fun3155z00_18180)
												(BgL_fun3155z00_18180, BgL_sz00_15414, BEOA);
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15414), BgL_iz00_18178,
											BgL_arg3154z00_18179);
									}
									{	/* Eval/evaluate_comp.scm 466 */
										obj_t BgL_arg3156z00_18181;
										long BgL_arg3159z00_18182;

										BgL_arg3156z00_18181 = CDR(((obj_t) BgL_lz00_18177));
										BgL_arg3159z00_18182 = (BgL_iz00_18178 + ((long) 1));
										{
											long BgL_iz00_33741;
											obj_t BgL_lz00_33740;

											BgL_lz00_33740 = BgL_arg3156z00_18181;
											BgL_iz00_33741 = BgL_arg3159z00_18182;
											BgL_iz00_18178 = BgL_iz00_33741;
											BgL_lz00_18177 = BgL_lz00_33740;
											goto BgL_recz00_18176;
										}
									}
								}
						}
					}
					{
						obj_t BgL_lz00_18184;

						BgL_lz00_18184 = BgL_iboxesz00_15412;
					BgL_recz00_18183:
						if (NULLP(BgL_lz00_18184))
							{	/* Eval/evaluate_comp.scm 468 */
								((bool_t) 0);
							}
						else
							{	/* Eval/evaluate_comp.scm 468 */
								{	/* Eval/evaluate_comp.scm 469 */
									long BgL_iz00_18185;

									BgL_iz00_18185 =
										(
										(long) CINT(BgL_bpz00_18174) +
										(long) CINT(CAR(((obj_t) BgL_lz00_18184))));
									{	/* Eval/evaluate_comp.scm 470 */
										obj_t BgL_arg3162z00_18186;

										{	/* Eval/evaluate_comp.scm 470 */
											obj_t BgL_arg3164z00_18187;

											BgL_arg3164z00_18187 =
												VECTOR_REF(((obj_t) BgL_sz00_15414), BgL_iz00_18185);
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_18188;

												BgL_newz00_18188 =
													create_struct(BGl_symbol5785z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33753;

													BgL_tmpz00_33753 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_18188, BgL_tmpz00_33753,
														BgL_arg3164z00_18187);
												}
												BgL_arg3162z00_18186 = BgL_newz00_18188;
										}}
										VECTOR_SET(
											((obj_t) BgL_sz00_15414), BgL_iz00_18185,
											BgL_arg3162z00_18186);
								}}
								{	/* Eval/evaluate_comp.scm 471 */
									obj_t BgL_arg3167z00_18189;

									BgL_arg3167z00_18189 = CDR(((obj_t) BgL_lz00_18184));
									{
										obj_t BgL_lz00_33760;

										BgL_lz00_33760 = BgL_arg3167z00_18189;
										BgL_lz00_18184 = BgL_lz00_33760;
										goto BgL_recz00_18183;
									}
								}
							}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15413) (BgL_bodyz00_15413,
						BgL_sz00_15414, BEOA);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_prog21411 */
	obj_t BGl_z62compzd2ev_prog21411zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15415, obj_t BgL_ez00_15416, obj_t BgL_stkz00_15417)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 449 */
			{	/* Eval/evaluate_comp.scm 451 */
				obj_t BgL_e1z00_18191;
				obj_t BgL_e2z00_18192;

				BgL_e1z00_18191 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_15416)))->BgL_e1z00),
					BgL_stkz00_15417);
				BgL_e2z00_18192 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
							COBJECT(((BgL_ev_prog2z00_bglt) BgL_ez00_15416)))->BgL_e2z00),
					BgL_stkz00_15417);
				{	/* Eval/evaluate_comp.scm 452 */
					obj_t BgL_zc3anonymousza33148ze3z83_18193;

					BgL_zc3anonymousza33148ze3z83_18193 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33148ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3anonymousza33148ze3z83_18193, (int) (((long) 0)),
						BgL_e1z00_18191);
					PROCEDURE_SET(BgL_zc3anonymousza33148ze3z83_18193, (int) (((long) 1)),
						BgL_e2z00_18192);
					return BgL_zc3anonymousza33148ze3z83_18193;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3148> */
	obj_t BGl_z62zc3anonymousza33148ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15418, obj_t BgL_sz00_15421)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 452 */
			{	/* Eval/evaluate_comp.scm 452 */
				obj_t BgL_e1z00_15419;
				obj_t BgL_e2z00_15420;

				BgL_e1z00_15419 = PROCEDURE_REF(BgL_envz00_15418, (int) (((long) 0)));
				BgL_e2z00_15420 = PROCEDURE_REF(BgL_envz00_15418, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 452 */
					obj_t BgL_bpz00_18194;

					BgL_bpz00_18194 = VECTOR_REF(((obj_t) BgL_sz00_15421), ((long) 0));
					PROCEDURE_ENTRY(BgL_e1z00_15419) (BgL_e1z00_15419, BgL_sz00_15421,
						BEOA);
					return PROCEDURE_ENTRY(BgL_e2z00_15420) (BgL_e2z00_15420,
						BgL_sz00_15421, BEOA);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_and1409 */
	obj_t BGl_z62compzd2ev_and1409zb0zz__evaluate_compz00(obj_t BgL_envz00_15422,
		obj_t BgL_ez00_15423, obj_t BgL_stkz00_15424)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 439 */
			{	/* Eval/evaluate_comp.scm 441 */
				obj_t BgL_argsz00_18196;

				{	/* Eval/evaluate_comp.scm 441 */
					obj_t BgL_l1302z00_18197;

					BgL_l1302z00_18197 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_ez00_15423))))->BgL_argsz00);
					if (NULLP(BgL_l1302z00_18197))
						{	/* Eval/evaluate_comp.scm 441 */
							BgL_argsz00_18196 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 441 */
							obj_t BgL_head1304z00_18198;

							{	/* Eval/evaluate_comp.scm 441 */
								obj_t BgL_res5086z00_18199;

								BgL_res5086z00_18199 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1304z00_18198 = BgL_res5086z00_18199;
							}
							{
								obj_t BgL_l1302z00_18201;
								obj_t BgL_tail1305z00_18202;

								BgL_l1302z00_18201 = BgL_l1302z00_18197;
								BgL_tail1305z00_18202 = BgL_head1304z00_18198;
							BgL_zc3anonymousza33139ze3z83_18200:
								if (NULLP(BgL_l1302z00_18201))
									{	/* Eval/evaluate_comp.scm 441 */
										BgL_argsz00_18196 = CDR(BgL_head1304z00_18198);
									}
								else
									{	/* Eval/evaluate_comp.scm 441 */
										obj_t BgL_newtail1306z00_18203;

										{	/* Eval/evaluate_comp.scm 441 */
											obj_t BgL_arg3147z00_18204;

											{	/* Eval/evaluate_comp.scm 441 */
												obj_t BgL_ez00_18205;

												BgL_ez00_18205 = CAR(((obj_t) BgL_l1302z00_18201));
												BgL_arg3147z00_18204 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18205),
													BgL_stkz00_15424);
											}
											{	/* Eval/evaluate_comp.scm 441 */
												obj_t BgL_res5092z00_18206;

												BgL_res5092z00_18206 =
													MAKE_YOUNG_PAIR(BgL_arg3147z00_18204, BNIL);
												BgL_newtail1306z00_18203 = BgL_res5092z00_18206;
											}
										}
										SET_CDR(BgL_tail1305z00_18202, BgL_newtail1306z00_18203);
										{	/* Eval/evaluate_comp.scm 441 */
											obj_t BgL_arg3146z00_18207;

											BgL_arg3146z00_18207 = CDR(((obj_t) BgL_l1302z00_18201));
											{
												obj_t BgL_tail1305z00_33810;
												obj_t BgL_l1302z00_33809;

												BgL_l1302z00_33809 = BgL_arg3146z00_18207;
												BgL_tail1305z00_33810 = BgL_newtail1306z00_18203;
												BgL_tail1305z00_18202 = BgL_tail1305z00_33810;
												BgL_l1302z00_18201 = BgL_l1302z00_33809;
												goto BgL_zc3anonymousza33139ze3z83_18200;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 442 */
					obj_t BgL_zc3anonymousza33131ze3z83_18208;

					BgL_zc3anonymousza33131ze3z83_18208 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33131ze3z83_18208, (int) (((long) 0)),
						BgL_argsz00_18196);
					return BgL_zc3anonymousza33131ze3z83_18208;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3131> */
	obj_t BGl_z62zc3anonymousza33131ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15425, obj_t BgL_sz00_15427)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 442 */
			{	/* Eval/evaluate_comp.scm 442 */
				obj_t BgL_argsz00_15426;

				BgL_argsz00_15426 = PROCEDURE_REF(BgL_envz00_15425, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 442 */
					obj_t BgL_bpz00_18209;

					BgL_bpz00_18209 = VECTOR_REF(((obj_t) BgL_sz00_15427), ((long) 0));
					{
						obj_t BgL_lz00_18211;
						obj_t BgL_rz00_18212;

						BgL_lz00_18211 = BgL_argsz00_15426;
						BgL_rz00_18212 = BTRUE;
					BgL_recz00_18210:
						if (NULLP(BgL_lz00_18211))
							{	/* Eval/evaluate_comp.scm 444 */
								return BgL_rz00_18212;
							}
						else
							{	/* Eval/evaluate_comp.scm 446 */
								obj_t BgL_vz00_18213;

								{	/* Eval/evaluate_comp.scm 446 */
									obj_t BgL_fun3137z00_18214;

									BgL_fun3137z00_18214 = CAR(((obj_t) BgL_lz00_18211));
									BgL_vz00_18213 =
										PROCEDURE_ENTRY(BgL_fun3137z00_18214) (BgL_fun3137z00_18214,
										BgL_sz00_15427, BEOA);
								}
								if (CBOOL(BgL_vz00_18213))
									{	/* Eval/evaluate_comp.scm 447 */
										obj_t BgL_arg3136z00_18215;

										BgL_arg3136z00_18215 = CDR(((obj_t) BgL_lz00_18211));
										{
											obj_t BgL_rz00_33833;
											obj_t BgL_lz00_33832;

											BgL_lz00_33832 = BgL_arg3136z00_18215;
											BgL_rz00_33833 = BgL_vz00_18213;
											BgL_rz00_18212 = BgL_rz00_33833;
											BgL_lz00_18211 = BgL_lz00_33832;
											goto BgL_recz00_18210;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 447 */
										return BFALSE;
									}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_or1407 */
	obj_t BGl_z62compzd2ev_or1407zb0zz__evaluate_compz00(obj_t BgL_envz00_15428,
		obj_t BgL_ez00_15429, obj_t BgL_stkz00_15430)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 430 */
			{	/* Eval/evaluate_comp.scm 432 */
				obj_t BgL_argsz00_18217;

				{	/* Eval/evaluate_comp.scm 432 */
					obj_t BgL_l1297z00_18218;

					BgL_l1297z00_18218 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_ez00_15429))))->BgL_argsz00);
					if (NULLP(BgL_l1297z00_18218))
						{	/* Eval/evaluate_comp.scm 432 */
							BgL_argsz00_18217 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 432 */
							obj_t BgL_head1299z00_18219;

							{	/* Eval/evaluate_comp.scm 432 */
								obj_t BgL_res5077z00_18220;

								BgL_res5077z00_18220 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1299z00_18219 = BgL_res5077z00_18220;
							}
							{
								obj_t BgL_l1297z00_18222;
								obj_t BgL_tail1300z00_18223;

								BgL_l1297z00_18222 = BgL_l1297z00_18218;
								BgL_tail1300z00_18223 = BgL_head1299z00_18219;
							BgL_zc3anonymousza33124ze3z83_18221:
								if (NULLP(BgL_l1297z00_18222))
									{	/* Eval/evaluate_comp.scm 432 */
										BgL_argsz00_18217 = CDR(BgL_head1299z00_18219);
									}
								else
									{	/* Eval/evaluate_comp.scm 432 */
										obj_t BgL_newtail1301z00_18224;

										{	/* Eval/evaluate_comp.scm 432 */
											obj_t BgL_arg3130z00_18225;

											{	/* Eval/evaluate_comp.scm 432 */
												obj_t BgL_ez00_18226;

												BgL_ez00_18226 = CAR(((obj_t) BgL_l1297z00_18222));
												BgL_arg3130z00_18225 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18226),
													BgL_stkz00_15430);
											}
											{	/* Eval/evaluate_comp.scm 432 */
												obj_t BgL_res5083z00_18227;

												BgL_res5083z00_18227 =
													MAKE_YOUNG_PAIR(BgL_arg3130z00_18225, BNIL);
												BgL_newtail1301z00_18224 = BgL_res5083z00_18227;
											}
										}
										SET_CDR(BgL_tail1300z00_18223, BgL_newtail1301z00_18224);
										{	/* Eval/evaluate_comp.scm 432 */
											obj_t BgL_arg3128z00_18228;

											BgL_arg3128z00_18228 = CDR(((obj_t) BgL_l1297z00_18222));
											{
												obj_t BgL_tail1300z00_33852;
												obj_t BgL_l1297z00_33851;

												BgL_l1297z00_33851 = BgL_arg3128z00_18228;
												BgL_tail1300z00_33852 = BgL_newtail1301z00_18224;
												BgL_tail1300z00_18223 = BgL_tail1300z00_33852;
												BgL_l1297z00_18222 = BgL_l1297z00_33851;
												goto BgL_zc3anonymousza33124ze3z83_18221;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 433 */
					obj_t BgL_zc3anonymousza33118ze3z83_18229;

					BgL_zc3anonymousza33118ze3z83_18229 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33118ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33118ze3z83_18229, (int) (((long) 0)),
						BgL_argsz00_18217);
					return BgL_zc3anonymousza33118ze3z83_18229;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3118> */
	obj_t BGl_z62zc3anonymousza33118ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15431, obj_t BgL_sz00_15433)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 433 */
			{	/* Eval/evaluate_comp.scm 433 */
				obj_t BgL_argsz00_15432;

				BgL_argsz00_15432 = PROCEDURE_REF(BgL_envz00_15431, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 433 */
					obj_t BgL_bpz00_18230;

					BgL_bpz00_18230 = VECTOR_REF(((obj_t) BgL_sz00_15433), ((long) 0));
					{
						obj_t BgL_lz00_18232;

						BgL_lz00_18232 = BgL_argsz00_15432;
					BgL_recz00_18231:
						if (NULLP(BgL_lz00_18232))
							{	/* Eval/evaluate_comp.scm 435 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 437 */
								obj_t BgL__ortest_1105z00_18233;

								{	/* Eval/evaluate_comp.scm 437 */
									obj_t BgL_fun3122z00_18234;

									BgL_fun3122z00_18234 = CAR(((obj_t) BgL_lz00_18232));
									BgL__ortest_1105z00_18233 =
										PROCEDURE_ENTRY(BgL_fun3122z00_18234) (BgL_fun3122z00_18234,
										BgL_sz00_15433, BEOA);
								}
								if (CBOOL(BgL__ortest_1105z00_18233))
									{	/* Eval/evaluate_comp.scm 437 */
										return BgL__ortest_1105z00_18233;
									}
								else
									{	/* Eval/evaluate_comp.scm 437 */
										obj_t BgL_arg3121z00_18235;

										BgL_arg3121z00_18235 = CDR(((obj_t) BgL_lz00_18232));
										{
											obj_t BgL_lz00_33874;

											BgL_lz00_33874 = BgL_arg3121z00_18235;
											BgL_lz00_18232 = BgL_lz00_33874;
											goto BgL_recz00_18231;
										}
									}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_if1405 */
	obj_t BGl_z62compzd2ev_if1405zb0zz__evaluate_compz00(obj_t BgL_envz00_15434,
		obj_t BgL_ez00_15435, obj_t BgL_stkz00_15436)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 424 */
			{	/* Eval/evaluate_comp.scm 426 */
				obj_t BgL_pz00_18237;
				obj_t BgL_tz00_18238;
				obj_t BgL_ez00_18239;

				BgL_pz00_18237 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_ifz00_bglt) COBJECT(
								((BgL_ev_ifz00_bglt) BgL_ez00_15435)))->BgL_pz00),
					BgL_stkz00_15436);
				BgL_tz00_18238 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15435)))->BgL_tz00),
					BgL_stkz00_15436);
				BgL_ez00_18239 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15435)))->BgL_ez00),
					BgL_stkz00_15436);
				{	/* Eval/evaluate_comp.scm 427 */
					obj_t BgL_zc3anonymousza33106ze3z83_18240;

					BgL_zc3anonymousza33106ze3z83_18240 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33106ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 3)));
					PROCEDURE_SET(BgL_zc3anonymousza33106ze3z83_18240, (int) (((long) 0)),
						BgL_ez00_18239);
					PROCEDURE_SET(BgL_zc3anonymousza33106ze3z83_18240, (int) (((long) 1)),
						BgL_tz00_18238);
					PROCEDURE_SET(BgL_zc3anonymousza33106ze3z83_18240, (int) (((long) 2)),
						BgL_pz00_18237);
					return BgL_zc3anonymousza33106ze3z83_18240;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3106> */
	obj_t BGl_z62zc3anonymousza33106ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15437, obj_t BgL_sz00_15441)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 427 */
			{	/* Eval/evaluate_comp.scm 427 */
				obj_t BgL_ez00_15438;
				obj_t BgL_tz00_15439;
				obj_t BgL_pz00_15440;

				BgL_ez00_15438 = PROCEDURE_REF(BgL_envz00_15437, (int) (((long) 0)));
				BgL_tz00_15439 = PROCEDURE_REF(BgL_envz00_15437, (int) (((long) 1)));
				BgL_pz00_15440 = PROCEDURE_REF(BgL_envz00_15437, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 427 */
					obj_t BgL_bpz00_18241;

					BgL_bpz00_18241 = VECTOR_REF(((obj_t) BgL_sz00_15441), ((long) 0));
					if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_15440) (BgL_pz00_15440,
								BgL_sz00_15441, BEOA)))
						{	/* Eval/evaluate_comp.scm 428 */
							return
								PROCEDURE_ENTRY(BgL_tz00_15439) (BgL_tz00_15439, BgL_sz00_15441,
								BEOA);
						}
					else
						{	/* Eval/evaluate_comp.scm 428 */
							return
								PROCEDURE_ENTRY(BgL_ez00_15438) (BgL_ez00_15438, BgL_sz00_15441,
								BEOA);
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_litt1403 */
	obj_t BGl_z62compzd2ev_litt1403zb0zz__evaluate_compz00(obj_t BgL_envz00_15442,
		obj_t BgL_ez00_15443, obj_t BgL_stkz00_15444)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 419 */
			{	/* Eval/evaluate_comp.scm 421 */
				obj_t BgL_zc3anonymousza33105ze3z83_18243;

				BgL_zc3anonymousza33105ze3z83_18243 =
					MAKE_FX_PROCEDURE
					(BGl_z62zc3anonymousza33105ze3ze1zz__evaluate_compz00,
					(int) (((long) 1)), (int) (((long) 1)));
				PROCEDURE_SET(BgL_zc3anonymousza33105ze3z83_18243, (int) (((long) 0)),
					((obj_t) ((BgL_ev_littz00_bglt) BgL_ez00_15443)));
				return BgL_zc3anonymousza33105ze3z83_18243;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3105> */
	obj_t BGl_z62zc3anonymousza33105ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15445, obj_t BgL_sz00_15447)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 421 */
			{	/* Eval/evaluate_comp.scm 421 */
				BgL_ev_littz00_bglt BgL_i1102z00_15446;

				BgL_i1102z00_15446 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_15445, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 421 */
					obj_t BgL_bpz00_18244;

					BgL_bpz00_18244 = VECTOR_REF(((obj_t) BgL_sz00_15447), ((long) 0));
					return
						(((BgL_ev_littz00_bglt) COBJECT(BgL_i1102z00_15446))->BgL_valuez00);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_defglobal1401 */
	obj_t BGl_z62compzd2ev_defglobal1401zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15448, obj_t BgL_ez00_15449, obj_t BgL_stkz00_15450)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 388 */
			{	/* Eval/evaluate_comp.scm 390 */
				obj_t BgL_ez00_18246;

				{	/* Eval/evaluate_comp.scm 390 */
					BgL_ev_exprz00_bglt BgL_arg3104z00_18247;

					BgL_arg3104z00_18247 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_ez00_15449))))->BgL_ez00);
					BgL_ez00_18246 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3104z00_18247,
						BgL_stkz00_15450);
				}
				{	/* Eval/evaluate_comp.scm 391 */
					obj_t BgL_zc3anonymousza33069ze3z83_18248;

					BgL_zc3anonymousza33069ze3z83_18248 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza33069ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3anonymousza33069ze3z83_18248, (int) (((long) 0)),
						((obj_t) ((BgL_ev_defglobalz00_bglt) BgL_ez00_15449)));
					PROCEDURE_SET(BgL_zc3anonymousza33069ze3z83_18248, (int) (((long) 1)),
						BgL_ez00_18246);
					return BgL_zc3anonymousza33069ze3z83_18248;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3069> */
	obj_t BGl_z62zc3anonymousza33069ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15451, obj_t BgL_sz00_15454)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 391 */
			{	/* Eval/evaluate_comp.scm 391 */
				BgL_ev_defglobalz00_bglt BgL_i1099z00_15452;
				obj_t BgL_ez00_15453;

				BgL_i1099z00_15452 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15451, (int) (((long) 0))));
				BgL_ez00_15453 = PROCEDURE_REF(BgL_envz00_15451, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 391 */
					obj_t BgL_bpz00_18249;

					BgL_bpz00_18249 = VECTOR_REF(((obj_t) BgL_sz00_15454), ((long) 0));
					{	/* Eval/evaluate_comp.scm 392 */
						obj_t BgL_gz00_18250;

						{	/* Eval/evaluate_comp.scm 392 */
							obj_t BgL_arg3101z00_18251;
							obj_t BgL_arg3103z00_18252;

							BgL_arg3101z00_18251 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(
										((BgL_ev_setglobalz00_bglt) BgL_i1099z00_15452)))->
								BgL_modz00);
							BgL_arg3103z00_18252 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
											BgL_i1099z00_15452)))->BgL_namez00);
							BgL_gz00_18250 =
								BGl_evmodulezd2findzd2globalz00zz__evmodulez00
								(BgL_arg3101z00_18251, BgL_arg3103z00_18252);
						}
						if (CBOOL(BgL_gz00_18250))
							{	/* Eval/evaluate_comp.scm 394 */
								{

									{	/* Eval/evaluate_comp.scm 396 */
										int BgL_aux1101z00_18256;

										{	/* Eval/evaluate_comp.scm 396 */
											int BgL_res5075z00_18257;

											BgL_res5075z00_18257 =
												CINT(VECTOR_REF(((obj_t) BgL_gz00_18250), ((long) 0)));
											BgL_aux1101z00_18256 = BgL_res5075z00_18257;
										}
										switch ((long) (BgL_aux1101z00_18256))
											{
											case ((long) 0):

												{	/* Eval/evaluate_comp.scm 398 */
													obj_t BgL_arg3075z00_18258;
													obj_t BgL_arg3076z00_18259;

													BgL_arg3075z00_18258 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1099z00_15452)))->BgL_locz00);
													BgL_arg3076z00_18259 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1099z00_15452)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3075z00_18258,
														BGl_string5896z00zz__evaluate_compz00,
														BGl_string5897z00zz__evaluate_compz00,
														BgL_arg3076z00_18259);
												} break;
											case ((long) 1):

												{	/* Eval/evaluate_comp.scm 400 */
													obj_t BgL_arg3077z00_18260;
													obj_t BgL_arg3078z00_18261;

													BgL_arg3077z00_18260 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1099z00_15452)))->BgL_locz00);
													BgL_arg3078z00_18261 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1099z00_15452)))->BgL_namez00);
													{	/* Eval/evaluate_comp.scm 400 */
														obj_t BgL_list3079z00_18262;

														{	/* Eval/evaluate_comp.scm 400 */
															obj_t BgL_arg3080z00_18263;

															{	/* Eval/evaluate_comp.scm 400 */
																obj_t BgL_arg3082z00_18264;

																BgL_arg3082z00_18264 =
																	MAKE_YOUNG_PAIR(BgL_arg3078z00_18261, BNIL);
																BgL_arg3080z00_18263 =
																	MAKE_YOUNG_PAIR
																	(BGl_string5898z00zz__evaluate_compz00,
																	BgL_arg3082z00_18264);
															}
															BgL_list3079z00_18262 =
																MAKE_YOUNG_PAIR
																(BGl_string5775z00zz__evaluate_compz00,
																BgL_arg3080z00_18263);
														}
														BGl_evwarningz00zz__everrorz00(BgL_arg3077z00_18260,
															BgL_list3079z00_18262);
												}}
												{	/* Eval/evaluate_comp.scm 402 */
													obj_t BgL_arg3083z00_18265;
													obj_t BgL_arg3084z00_18266;

													BgL_arg3083z00_18265 =
														VECTOR_REF(((obj_t) BgL_gz00_18250), ((long) 2));
													BgL_arg3084z00_18266 =
														PROCEDURE_ENTRY(BgL_ez00_15453) (BgL_ez00_15453,
														BgL_sz00_15454, BEOA);
													__EVMEANING_ADDRESS_SET(BgL_arg3083z00_18265,
														BgL_arg3084z00_18266);
												} break;
											case ((long) 2):

												{	/* Eval/evaluate_comp.scm 404 */
													obj_t BgL_arg3085z00_18267;

													BgL_arg3085z00_18267 =
														PROCEDURE_ENTRY(BgL_ez00_15453) (BgL_ez00_15453,
														BgL_sz00_15454, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18250), ((long) 2),
														BgL_arg3085z00_18267);
												} break;
											case ((long) 3):

												{	/* Eval/evaluate_comp.scm 406 */
													obj_t BgL_arg3087z00_18268;

													BgL_arg3087z00_18268 =
														PROCEDURE_ENTRY(BgL_ez00_15453) (BgL_ez00_15453,
														BgL_sz00_15454, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18250), ((long) 2),
														BgL_arg3087z00_18268);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18250), ((long) 0),
													BINT(((long) 2)));
												break;
											case ((long) 4):

												{	/* Eval/evaluate_comp.scm 409 */
													obj_t BgL_arg3088z00_18269;

													BgL_arg3088z00_18269 =
														PROCEDURE_ENTRY(BgL_ez00_15453) (BgL_ez00_15453,
														BgL_sz00_15454, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18250), ((long) 2),
														BgL_arg3088z00_18269);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18250), ((long) 0),
													BINT(((long) 5)));
												break;
											default:
												{	/* Eval/evaluate_comp.scm 412 */
													obj_t BgL_arg3089z00_18254;
													obj_t BgL_arg3090z00_18255;

													BgL_arg3089z00_18254 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1099z00_15452)))->BgL_locz00);
													BgL_arg3090z00_18255 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1099z00_15452)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3089z00_18254,
														BGl_string5896z00zz__evaluate_compz00,
														BGl_string5897z00zz__evaluate_compz00,
														BgL_arg3090z00_18255);
												}
											}
									}
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1099z00_15452)))->
									BgL_namez00);
							}
						else
							{	/* Eval/evaluate_comp.scm 414 */
								obj_t BgL_gz00_18270;

								{	/* Eval/evaluate_comp.scm 414 */
									obj_t BgL_arg3097z00_18271;
									obj_t BgL_arg3098z00_18272;
									obj_t BgL_arg3099z00_18273;

									BgL_arg3097z00_18271 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1099z00_15452)))->
										BgL_namez00);
									BgL_arg3098z00_18272 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1099z00_15452)))->BgL_modz00);
									BgL_arg3099z00_18273 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1099z00_15452)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 414 */
										obj_t BgL_v1375z00_18274;

										BgL_v1375z00_18274 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1375z00_18274, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1375z00_18274, ((long) 1),
											BgL_arg3097z00_18271);
										VECTOR_SET(BgL_v1375z00_18274, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1375z00_18274, ((long) 3),
											BgL_arg3098z00_18272);
										VECTOR_SET(BgL_v1375z00_18274, ((long) 4),
											BgL_arg3099z00_18273);
										BgL_gz00_18270 = BgL_v1375z00_18274;
								}}
								{	/* Eval/evaluate_comp.scm 415 */
									obj_t BgL_arg3091z00_18275;

									BgL_arg3091z00_18275 =
										PROCEDURE_ENTRY(BgL_ez00_15453) (BgL_ez00_15453,
										BgL_sz00_15454, BEOA);
									VECTOR_SET(BgL_gz00_18270, ((long) 2), BgL_arg3091z00_18275);
								}
								{	/* Eval/evaluate_comp.scm 416 */
									obj_t BgL_arg3092z00_18276;
									obj_t BgL_arg3093z00_18277;
									obj_t BgL_arg3094z00_18278;

									BgL_arg3092z00_18276 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1099z00_15452)))->
										BgL_modz00);
									BgL_arg3093z00_18277 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1099z00_15452)))->BgL_namez00);
									BgL_arg3094z00_18278 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1099z00_15452)))->BgL_locz00);
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
										(BgL_arg3092z00_18276, BgL_arg3093z00_18277, BgL_gz00_18270,
										BgL_arg3094z00_18278);
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1099z00_15452)))->
									BgL_namez00);
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_setglobal1399 */
	obj_t BGl_z62compzd2ev_setglobal1399zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15455, obj_t BgL_ez00_15456, obj_t BgL_stkz00_15457)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 365 */
			{	/* Eval/evaluate_comp.scm 367 */
				obj_t BgL_gz00_18280;
				obj_t BgL_ez00_18281;

				BgL_gz00_18280 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->BgL_modz00),
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->BgL_namez00));
				{	/* Eval/evaluate_comp.scm 367 */
					BgL_ev_exprz00_bglt BgL_arg3068z00_18282;

					BgL_arg3068z00_18282 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setglobalz00_bglt) BgL_ez00_15456))))->BgL_ez00);
					BgL_ez00_18281 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3068z00_18282,
						BgL_stkz00_15457);
				}
				if (CBOOL(BgL_gz00_18280))
					{

						{	/* Eval/evaluate_comp.scm 369 */
							int BgL_aux1098z00_18285;

							{	/* Eval/evaluate_comp.scm 369 */
								int BgL_res5074z00_18286;

								BgL_res5074z00_18286 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18280), ((long) 0)));
								BgL_aux1098z00_18285 = BgL_res5074z00_18286;
							}
							switch ((long) (BgL_aux1098z00_18285))
								{
								case ((long) 1):

									{	/* Eval/evaluate_comp.scm 371 */
										obj_t BgL_zc3anonymousza33032ze3z83_18287;

										BgL_zc3anonymousza33032ze3z83_18287 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza33032ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3anonymousza33032ze3z83_18287,
											(int) (((long) 0)), BgL_gz00_18280);
										PROCEDURE_SET(BgL_zc3anonymousza33032ze3z83_18287,
											(int) (((long) 1)), BgL_ez00_18281);
										return BgL_zc3anonymousza33032ze3z83_18287;
									}
									break;
								case ((long) 0):
								case ((long) 4):
								case ((long) 5):

									return
										BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(
													((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
											BgL_locz00), BGl_string5896z00zz__evaluate_compz00,
										BGl_string5897z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt)
												COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
											BgL_namez00));
									break;
								default:
									{	/* Eval/evaluate_comp.scm 376 */
										obj_t BgL_zc3anonymousza33037ze3z83_18284;

										BgL_zc3anonymousza33037ze3z83_18284 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza33037ze3ze1zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3anonymousza33037ze3z83_18284,
											(int) (((long) 0)), BgL_ez00_18281);
										PROCEDURE_SET(BgL_zc3anonymousza33037ze3z83_18284,
											(int) (((long) 1)), BgL_gz00_18280);
										return BgL_zc3anonymousza33037ze3z83_18284;
									}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 377 */
						obj_t BgL_slotz00_18288;

						BgL_slotz00_18288 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 379 */
								obj_t BgL_gz00_18289;

								{	/* Eval/evaluate_comp.scm 379 */
									obj_t BgL_arg3045z00_18290;
									obj_t BgL_arg3046z00_18291;
									obj_t BgL_arg3048z00_18292;

									BgL_arg3045z00_18290 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
										BgL_namez00);
									BgL_arg3046z00_18291 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
										BgL_modz00);
									BgL_arg3048z00_18292 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
										BgL_locz00);
									{	/* Eval/evaluate_comp.scm 379 */
										obj_t BgL_v1375z00_18293;

										BgL_v1375z00_18293 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1375z00_18293, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1375z00_18293, ((long) 1),
											BgL_arg3045z00_18290);
										VECTOR_SET(BgL_v1375z00_18293, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1375z00_18293, ((long) 3),
											BgL_arg3046z00_18291);
										VECTOR_SET(BgL_v1375z00_18293, ((long) 4),
											BgL_arg3048z00_18292);
										BgL_gz00_18289 = BgL_v1375z00_18293;
								}}
								VECTOR_SET(BgL_gz00_18289, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
										BgL_namez00), BgL_gz00_18289,
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)))->
										BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 378 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 382 */
							obj_t BgL_zc3anonymousza33050ze3z83_18294;

							BgL_zc3anonymousza33050ze3z83_18294 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza33050ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3anonymousza33050ze3z83_18294,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_setglobalz00_bglt) BgL_ez00_15456)));
							PROCEDURE_SET(BgL_zc3anonymousza33050ze3z83_18294,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18288));
							PROCEDURE_SET(BgL_zc3anonymousza33050ze3z83_18294,
								(int) (((long) 2)), BgL_ez00_18281);
							return BgL_zc3anonymousza33050ze3z83_18294;
						}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3032> */
	obj_t BGl_z62zc3anonymousza33032ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15460, obj_t BgL_sz00_15463)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 371 */
			{	/* Eval/evaluate_comp.scm 371 */
				obj_t BgL_gz00_15461;
				obj_t BgL_ez00_15462;

				BgL_gz00_15461 = PROCEDURE_REF(BgL_envz00_15460, (int) (((long) 0)));
				BgL_ez00_15462 = PROCEDURE_REF(BgL_envz00_15460, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 371 */
					obj_t BgL_bpz00_18295;

					BgL_bpz00_18295 = VECTOR_REF(((obj_t) BgL_sz00_15463), ((long) 0));
					{	/* Eval/evaluate_comp.scm 372 */
						obj_t BgL_arg3033z00_18296;
						obj_t BgL_arg3034z00_18297;

						BgL_arg3033z00_18296 =
							VECTOR_REF(((obj_t) BgL_gz00_15461), ((long) 2));
						BgL_arg3034z00_18297 =
							PROCEDURE_ENTRY(BgL_ez00_15462) (BgL_ez00_15462, BgL_sz00_15463,
							BEOA);
						return __EVMEANING_ADDRESS_SET(BgL_arg3033z00_18296,
							BgL_arg3034z00_18297);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3037> */
	obj_t BGl_z62zc3anonymousza33037ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15464, obj_t BgL_sz00_15467)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 376 */
			{	/* Eval/evaluate_comp.scm 376 */
				obj_t BgL_ez00_15465;
				obj_t BgL_gz00_15466;

				BgL_ez00_15465 = PROCEDURE_REF(BgL_envz00_15464, (int) (((long) 0)));
				BgL_gz00_15466 = PROCEDURE_REF(BgL_envz00_15464, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 376 */
					obj_t BgL_bpz00_18298;

					BgL_bpz00_18298 = VECTOR_REF(((obj_t) BgL_sz00_15467), ((long) 0));
					{	/* Eval/evaluate_comp.scm 376 */
						obj_t BgL_arg3038z00_18299;

						BgL_arg3038z00_18299 =
							PROCEDURE_ENTRY(BgL_ez00_15465) (BgL_ez00_15465, BgL_sz00_15467,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_gz00_15466), ((long) 2),
							BgL_arg3038z00_18299);
		}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3050> */
	obj_t BGl_z62zc3anonymousza33050ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15468, obj_t BgL_sz00_15472)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 382 */
			{	/* Eval/evaluate_comp.scm 382 */
				BgL_ev_setglobalz00_bglt BgL_i1096z00_15469;
				obj_t BgL_slotz00_15470;
				obj_t BgL_ez00_15471;

				BgL_i1096z00_15469 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15468, (int) (((long) 0))));
				BgL_slotz00_15470 = PROCEDURE_REF(BgL_envz00_15468, (int) (((long) 1)));
				BgL_ez00_15471 = PROCEDURE_REF(BgL_envz00_15468, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 382 */
					obj_t BgL_bpz00_18300;

					BgL_bpz00_18300 = VECTOR_REF(((obj_t) BgL_sz00_15472), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15470)))
						{	/* Eval/evaluate_comp.scm 383 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 383 */
							{	/* Eval/evaluate_comp.scm 384 */
								obj_t BgL_auxz00_18301;

								BgL_auxz00_18301 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1096z00_15469))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1096z00_15469))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15470, BgL_auxz00_18301);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15470)))
								{	/* Eval/evaluate_comp.scm 385 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 385 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1096z00_15469))->
											BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
										BGl_string5899z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1096z00_15469))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 386 */
						obj_t BgL_arg3057z00_18302;

						BgL_arg3057z00_18302 =
							PROCEDURE_ENTRY(BgL_ez00_15471) (BgL_ez00_15471, BgL_sz00_15472,
							BEOA);
						{	/* Eval/evaluate_comp.scm 386 */
							obj_t BgL_evalzd2globalzd2_18303;

							BgL_evalzd2globalzd2_18303 = CELL_REF(BgL_slotz00_15470);
							return
								VECTOR_SET(BgL_evalzd2globalzd2_18303, ((long) 2),
								BgL_arg3057z00_18302);
		}}}}}
		BGL_FUNCTION_END;
	}



/* &comp-ev_global1397 */
	obj_t BGl_z62compzd2ev_global1397zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15474, obj_t BgL_varz00_15475, obj_t BgL_stkz00_15476)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 339 */
			{	/* Eval/evaluate_comp.scm 341 */
				obj_t BgL_gz00_18305;

				BgL_gz00_18305 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15475)))->BgL_modz00),
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15475)))->BgL_namez00));
				if (CBOOL(BgL_gz00_18305))
					{	/* Eval/evaluate_comp.scm 343 */
						bool_t BgL_testz00_34167;

						{	/* Eval/evaluate_comp.scm 343 */
							int BgL_arg2990z00_18306;

							{	/* Eval/evaluate_comp.scm 343 */
								int BgL_res5070z00_18307;

								BgL_res5070z00_18307 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18305), ((long) 0)));
								BgL_arg2990z00_18306 = BgL_res5070z00_18307;
							}
							BgL_testz00_34167 =
								(BINT(BgL_arg2990z00_18306) == BINT(((long) 1)));
						}
						if (BgL_testz00_34167)
							{	/* Eval/evaluate_comp.scm 344 */
								obj_t BgL_zc3anonymousza32986ze3z83_18308;

								BgL_zc3anonymousza32986ze3z83_18308 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32986ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3anonymousza32986ze3z83_18308,
									(int) (((long) 0)), BgL_gz00_18305);
								return BgL_zc3anonymousza32986ze3z83_18308;
							}
						else
							{	/* Eval/evaluate_comp.scm 346 */
								obj_t BgL_zc3anonymousza32989ze3z83_18309;

								BgL_zc3anonymousza32989ze3z83_18309 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32989ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3anonymousza32989ze3z83_18309,
									(int) (((long) 0)), BgL_gz00_18305);
								return BgL_zc3anonymousza32989ze3z83_18309;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 348 */
						obj_t BgL_slotz00_18310;

						BgL_slotz00_18310 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_globalz00_bglt) COBJECT(
											((BgL_ev_globalz00_bglt) BgL_varz00_15475)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 350 */
								obj_t BgL_gz00_18311;

								{	/* Eval/evaluate_comp.scm 350 */
									obj_t BgL_arg2997z00_18312;
									obj_t BgL_arg2999z00_18313;
									obj_t BgL_arg3000z00_18314;

									BgL_arg2997z00_18312 =
										(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15475)))->
										BgL_namez00);
									BgL_arg2999z00_18313 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15475)))->BgL_modz00);
									BgL_arg3000z00_18314 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15475)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 350 */
										obj_t BgL_v1375z00_18315;

										BgL_v1375z00_18315 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1375z00_18315, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1375z00_18315, ((long) 1),
											BgL_arg2997z00_18312);
										VECTOR_SET(BgL_v1375z00_18315, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1375z00_18315, ((long) 3),
											BgL_arg2999z00_18313);
										VECTOR_SET(BgL_v1375z00_18315, ((long) 4),
											BgL_arg3000z00_18314);
										BgL_gz00_18311 = BgL_v1375z00_18315;
								}}
								VECTOR_SET(BgL_gz00_18311, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15475)))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15475)))->BgL_namez00), BgL_gz00_18311,
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15475)))->BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 349 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 353 */
							obj_t BgL_zc3anonymousza33002ze3z83_18316;

							BgL_zc3anonymousza33002ze3z83_18316 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza33002ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3anonymousza33002ze3z83_18316,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_globalz00_bglt) BgL_varz00_15475)));
							PROCEDURE_SET(BgL_zc3anonymousza33002ze3z83_18316,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18310));
							return BgL_zc3anonymousza33002ze3z83_18316;
						}
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2986> */
	obj_t BGl_z62zc3anonymousza32986ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15479, obj_t BgL_sz00_15481)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 344 */
			{	/* Eval/evaluate_comp.scm 344 */
				obj_t BgL_gz00_15480;

				BgL_gz00_15480 = PROCEDURE_REF(BgL_envz00_15479, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 344 */
					obj_t BgL_bpz00_18317;

					BgL_bpz00_18317 = VECTOR_REF(((obj_t) BgL_sz00_15481), ((long) 0));
					{	/* Eval/evaluate_comp.scm 345 */
						obj_t BgL_arg2988z00_18318;

						BgL_arg2988z00_18318 =
							VECTOR_REF(((obj_t) BgL_gz00_15480), ((long) 2));
						return __EVMEANING_ADDRESS_REF(BgL_arg2988z00_18318);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2989> */
	obj_t BGl_z62zc3anonymousza32989ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15482, obj_t BgL_sz00_15484)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 346 */
			{	/* Eval/evaluate_comp.scm 346 */
				obj_t BgL_gz00_15483;

				BgL_gz00_15483 = PROCEDURE_REF(BgL_envz00_15482, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 346 */
					obj_t BgL_bpz00_18319;

					BgL_bpz00_18319 = VECTOR_REF(((obj_t) BgL_sz00_15484), ((long) 0));
					return VECTOR_REF(((obj_t) BgL_gz00_15483), ((long) 2));
		}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:3002> */
	obj_t BGl_z62zc3anonymousza33002ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15485, obj_t BgL_sz00_15488)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 353 */
			{	/* Eval/evaluate_comp.scm 353 */
				BgL_ev_globalz00_bglt BgL_i1095z00_15486;
				obj_t BgL_slotz00_15487;

				BgL_i1095z00_15486 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15485, (int) (((long) 0))));
				BgL_slotz00_15487 = PROCEDURE_REF(BgL_envz00_15485, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 353 */
					obj_t BgL_bpz00_18320;

					BgL_bpz00_18320 = VECTOR_REF(((obj_t) BgL_sz00_15488), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15487)))
						{	/* Eval/evaluate_comp.scm 354 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 354 */
							{	/* Eval/evaluate_comp.scm 355 */
								obj_t BgL_auxz00_18321;

								BgL_auxz00_18321 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1095z00_15486))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1095z00_15486))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15487, BgL_auxz00_18321);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15487)))
								{	/* Eval/evaluate_comp.scm 356 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 356 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1095z00_15486))->
											BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
										BGl_string5899z00zz__evaluate_compz00,
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1095z00_15486))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 357 */
						obj_t BgL_vz00_18322;

						{	/* Eval/evaluate_comp.scm 357 */
							obj_t BgL_evalzd2globalzd2_18323;

							BgL_evalzd2globalzd2_18323 = CELL_REF(BgL_slotz00_15487);
							BgL_vz00_18322 =
								VECTOR_REF(BgL_evalzd2globalzd2_18323, ((long) 2));
						}
						if ((BgL_vz00_18322 == BUNSPEC))
							{	/* Eval/evaluate_comp.scm 359 */
								int BgL_tz00_18324;

								{	/* Eval/evaluate_comp.scm 359 */
									int BgL_res5071z00_18325;

									{	/* Eval/evaluate_comp.scm 359 */
										obj_t BgL_evalzd2globalzd2_18326;

										BgL_evalzd2globalzd2_18326 = CELL_REF(BgL_slotz00_15487);
										BgL_res5071z00_18325 =
											CINT(VECTOR_REF(BgL_evalzd2globalzd2_18326, ((long) 0)));
									}
									BgL_tz00_18324 = BgL_res5071z00_18325;
								}
								{	/* Eval/evaluate_comp.scm 360 */
									bool_t BgL_testz00_34255;

									if (((long) (BgL_tz00_18324) == ((long) 3)))
										{	/* Eval/evaluate_comp.scm 360 */
											BgL_testz00_34255 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 360 */
											BgL_testz00_34255 =
												((long) (BgL_tz00_18324) == ((long) 4));
										}
									if (BgL_testz00_34255)
										{	/* Eval/evaluate_comp.scm 360 */
											return
												BGl_everrorz00zz__everrorz00(
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1095z00_15486))->
													BgL_locz00), BGl_string5775z00zz__evaluate_compz00,
												BGl_string5900z00zz__evaluate_compz00,
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1095z00_15486))->
													BgL_namez00));
										}
									else
										{	/* Eval/evaluate_comp.scm 360 */
											return BgL_vz00_18322;
										}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 358 */
								return BgL_vz00_18322;
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_setlocal1395 */
	obj_t BGl_z62compzd2ev_setlocal1395zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15490, obj_t BgL_ez00_15491, obj_t BgL_stkz00_15492)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 321 */
			{	/* Eval/evaluate_comp.scm 323 */
				obj_t BgL_iz00_18328;
				obj_t BgL_ez00_18329;

				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_varz00_bglt BgL_arg2982z00_18330;

					BgL_arg2982z00_18330 =
						(((BgL_ev_setlocalz00_bglt) COBJECT(
								((BgL_ev_setlocalz00_bglt) BgL_ez00_15491)))->BgL_vz00);
					BgL_iz00_18328 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_arg2982z00_18330), BgL_stkz00_15492);
				}
				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_exprz00_bglt BgL_arg2983z00_18331;

					BgL_arg2983z00_18331 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setlocalz00_bglt) BgL_ez00_15491))))->BgL_ez00);
					BgL_ez00_18329 =
						BGl_compz00zz__evaluate_compz00(BgL_arg2983z00_18331,
						BgL_stkz00_15492);
				}
				if (CBOOL(
						(((BgL_ev_varz00_bglt) COBJECT(
									(((BgL_ev_setlocalz00_bglt) COBJECT(
												((BgL_ev_setlocalz00_bglt) BgL_ez00_15491)))->
										BgL_vz00)))->BgL_effz00)))
					{	/* Eval/evaluate_comp.scm 326 */
						obj_t BgL_zc3anonymousza32974ze3z83_18332;

						BgL_zc3anonymousza32974ze3z83_18332 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32974ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32974ze3z83_18332,
							(int) (((long) 0)), BgL_iz00_18328);
						PROCEDURE_SET(BgL_zc3anonymousza32974ze3z83_18332,
							(int) (((long) 1)), BgL_ez00_18329);
						return BgL_zc3anonymousza32974ze3z83_18332;
					}
				else
					{	/* Eval/evaluate_comp.scm 328 */
						obj_t BgL_zc3anonymousza32979ze3z83_18333;

						BgL_zc3anonymousza32979ze3z83_18333 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32979ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32979ze3z83_18333,
							(int) (((long) 0)), BgL_iz00_18328);
						PROCEDURE_SET(BgL_zc3anonymousza32979ze3z83_18333,
							(int) (((long) 1)), BgL_ez00_18329);
						return BgL_zc3anonymousza32979ze3z83_18333;
					}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2974> */
	obj_t BGl_z62zc3anonymousza32974ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15493, obj_t BgL_sz00_15496)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 326 */
			{	/* Eval/evaluate_comp.scm 326 */
				obj_t BgL_iz00_15494;
				obj_t BgL_ez00_15495;

				BgL_iz00_15494 = PROCEDURE_REF(BgL_envz00_15493, (int) (((long) 0)));
				BgL_ez00_15495 = PROCEDURE_REF(BgL_envz00_15493, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 326 */
					obj_t BgL_bpz00_18334;

					BgL_bpz00_18334 = VECTOR_REF(((obj_t) BgL_sz00_15496), ((long) 0));
					{	/* Eval/evaluate_comp.scm 327 */
						obj_t BgL_arg2976z00_18335;
						obj_t BgL_arg2977z00_18336;

						{	/* Eval/evaluate_comp.scm 327 */
							long BgL_arg2978z00_18337;

							BgL_arg2978z00_18337 =
								((long) CINT(BgL_bpz00_18334) + (long) CINT(BgL_iz00_15494));
							BgL_arg2976z00_18335 =
								VECTOR_REF(((obj_t) BgL_sz00_15496), BgL_arg2978z00_18337);
						}
						BgL_arg2977z00_18336 =
							PROCEDURE_ENTRY(BgL_ez00_15495) (BgL_ez00_15495, BgL_sz00_15496,
							BEOA);
						{	/* Eval/evaluate_comp.scm 202 */
							obj_t BgL_xz00_18338;

							{	/* Eval/evaluate_comp.scm 202 */
								int BgL_auxz00_34308;
								obj_t BgL_tmpz00_34306;

								BgL_auxz00_34308 = (int) (((long) 0));
								BgL_tmpz00_34306 = ((obj_t) BgL_arg2976z00_18335);
								BgL_xz00_18338 =
									STRUCT_SET(BgL_tmpz00_34306, BgL_auxz00_34308,
									BgL_arg2977z00_18336);
							}
							return BUNSPEC;
						}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2979> */
	obj_t BGl_z62zc3anonymousza32979ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15497, obj_t BgL_sz00_15500)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 328 */
			{	/* Eval/evaluate_comp.scm 328 */
				obj_t BgL_iz00_15498;
				obj_t BgL_ez00_15499;

				BgL_iz00_15498 = PROCEDURE_REF(BgL_envz00_15497, (int) (((long) 0)));
				BgL_ez00_15499 = PROCEDURE_REF(BgL_envz00_15497, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 328 */
					obj_t BgL_bpz00_18339;

					BgL_bpz00_18339 = VECTOR_REF(((obj_t) BgL_sz00_15500), ((long) 0));
					{	/* Eval/evaluate_comp.scm 329 */
						long BgL_arg2980z00_18340;
						obj_t BgL_arg2981z00_18341;

						BgL_arg2980z00_18340 =
							((long) CINT(BgL_bpz00_18339) + (long) CINT(BgL_iz00_15498));
						BgL_arg2981z00_18341 =
							PROCEDURE_ENTRY(BgL_ez00_15499) (BgL_ez00_15499, BgL_sz00_15500,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_sz00_15500), BgL_arg2980z00_18340,
							BgL_arg2981z00_18341);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_var1393 */
	obj_t BGl_z62compzd2ev_var1393zb0zz__evaluate_compz00(obj_t BgL_envz00_15501,
		obj_t BgL_varz00_15502, obj_t BgL_stkz00_15503)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 316 */
			{	/* Eval/evaluate_comp.scm 317 */
				obj_t BgL_iz00_18343;

				BgL_iz00_18343 =
					BGl__indexz00zz__evaluate_compz00(
					((obj_t) ((BgL_ev_varz00_bglt) BgL_varz00_15502)), BgL_stkz00_15503);
				{

					if (INTEGERP(BgL_iz00_18343))
						{	/* Eval/evaluate_comp.scm 319 */
							switch ((long) CINT(BgL_iz00_18343))
								{
								case ((long) 0):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15502)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5901z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5902z00zz__evaluate_compz00;
										}
									break;
								case ((long) 1):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15502)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5903z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5904z00zz__evaluate_compz00;
										}
									break;
								case ((long) 2):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15502)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5905z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5906z00zz__evaluate_compz00;
										}
									break;
								case ((long) 3):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15502)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5907z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5908z00zz__evaluate_compz00;
										}
									break;
								default:
								BgL_case_else1090z00_18344:
									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15502)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3anonymousza32968ze3z83_18345;

											BgL_zc3anonymousza32968ze3z83_18345 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza32968ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3anonymousza32968ze3z83_18345,
												(int) (((long) 0)), BgL_iz00_18343);
											return BgL_zc3anonymousza32968ze3z83_18345;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3anonymousza32971ze3z83_18346;

											BgL_zc3anonymousza32971ze3z83_18346 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza32971ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3anonymousza32971ze3z83_18346,
												(int) (((long) 0)), BgL_iz00_18343);
											return BgL_zc3anonymousza32971ze3z83_18346;
										}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 319 */
							goto BgL_case_else1090z00_18344;
						}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2961> */
	obj_t BGl_z62zc3anonymousza32961ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15504, obj_t BgL_sz00_15505)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18347;

				BgL_bpz00_18347 = VECTOR_REF(((obj_t) BgL_sz00_15505), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2963z00_18348;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2964z00_18349;

						BgL_arg2964z00_18349 = ((long) CINT(BgL_bpz00_18347) + ((long) 3));
						BgL_arg2963z00_18348 =
							VECTOR_REF(((obj_t) BgL_sz00_15505), BgL_arg2964z00_18349);
					}
					return STRUCT_REF(((obj_t) BgL_arg2963z00_18348), (int) (((long) 0)));
		}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2965> */
	obj_t BGl_z62zc3anonymousza32965ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15506, obj_t BgL_sz00_15507)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18350;

				BgL_bpz00_18350 = VECTOR_REF(((obj_t) BgL_sz00_15507), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2966z00_18351;

					BgL_arg2966z00_18351 = ((long) CINT(BgL_bpz00_18350) + ((long) 3));
					return VECTOR_REF(((obj_t) BgL_sz00_15507), BgL_arg2966z00_18351);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2953> */
	obj_t BGl_z62zc3anonymousza32953ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15508, obj_t BgL_sz00_15509)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18352;

				BgL_bpz00_18352 = VECTOR_REF(((obj_t) BgL_sz00_15509), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2954z00_18353;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2955z00_18354;

						BgL_arg2955z00_18354 = ((long) CINT(BgL_bpz00_18352) + ((long) 2));
						BgL_arg2954z00_18353 =
							VECTOR_REF(((obj_t) BgL_sz00_15509), BgL_arg2955z00_18354);
					}
					return STRUCT_REF(((obj_t) BgL_arg2954z00_18353), (int) (((long) 0)));
		}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2956> */
	obj_t BGl_z62zc3anonymousza32956ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15510, obj_t BgL_sz00_15511)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18355;

				BgL_bpz00_18355 = VECTOR_REF(((obj_t) BgL_sz00_15511), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2959z00_18356;

					BgL_arg2959z00_18356 = ((long) CINT(BgL_bpz00_18355) + ((long) 2));
					return VECTOR_REF(((obj_t) BgL_sz00_15511), BgL_arg2959z00_18356);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2928> */
	obj_t BGl_z62zc3anonymousza32928ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15512, obj_t BgL_sz00_15513)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18357;

				BgL_bpz00_18357 = VECTOR_REF(((obj_t) BgL_sz00_15513), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2947z00_18358;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2948z00_18359;

						BgL_arg2948z00_18359 = ((long) CINT(BgL_bpz00_18357) + ((long) 1));
						BgL_arg2947z00_18358 =
							VECTOR_REF(((obj_t) BgL_sz00_15513), BgL_arg2948z00_18359);
					}
					return STRUCT_REF(((obj_t) BgL_arg2947z00_18358), (int) (((long) 0)));
		}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2949> */
	obj_t BGl_z62zc3anonymousza32949ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15514, obj_t BgL_sz00_15515)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18360;

				BgL_bpz00_18360 = VECTOR_REF(((obj_t) BgL_sz00_15515), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2951z00_18361;

					BgL_arg2951z00_18361 = ((long) CINT(BgL_bpz00_18360) + ((long) 1));
					return VECTOR_REF(((obj_t) BgL_sz00_15515), BgL_arg2951z00_18361);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2922> */
	obj_t BGl_z62zc3anonymousza32922ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15516, obj_t BgL_sz00_15517)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18362;

				BgL_bpz00_18362 = VECTOR_REF(((obj_t) BgL_sz00_15517), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg2923z00_18363;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2924z00_18364;

						BgL_arg2924z00_18364 = ((long) CINT(BgL_bpz00_18362) + ((long) 0));
						BgL_arg2923z00_18363 =
							VECTOR_REF(((obj_t) BgL_sz00_15517), BgL_arg2924z00_18364);
					}
					return STRUCT_REF(((obj_t) BgL_arg2923z00_18363), (int) (((long) 0)));
		}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2925> */
	obj_t BGl_z62zc3anonymousza32925ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15518, obj_t BgL_sz00_15519)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18365;

				BgL_bpz00_18365 = VECTOR_REF(((obj_t) BgL_sz00_15519), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg2926z00_18366;

					BgL_arg2926z00_18366 = ((long) CINT(BgL_bpz00_18365) + ((long) 0));
					return VECTOR_REF(((obj_t) BgL_sz00_15519), BgL_arg2926z00_18366);
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2968> */
	obj_t BGl_z62zc3anonymousza32968ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15520, obj_t BgL_sz00_15522)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15521;

				BgL_iz00_15521 = PROCEDURE_REF(BgL_envz00_15520, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18367;

					BgL_bpz00_18367 = VECTOR_REF(((obj_t) BgL_sz00_15522), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg2969z00_18368;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg2970z00_18369;

							BgL_arg2970z00_18369 =
								((long) CINT(BgL_bpz00_18367) + (long) CINT(BgL_iz00_15521));
							BgL_arg2969z00_18368 =
								VECTOR_REF(((obj_t) BgL_sz00_15522), BgL_arg2970z00_18369);
						}
						return
							STRUCT_REF(((obj_t) BgL_arg2969z00_18368), (int) (((long) 0)));
		}}}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2971> */
	obj_t BGl_z62zc3anonymousza32971ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15523, obj_t BgL_sz00_15525)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15524;

				BgL_iz00_15524 = PROCEDURE_REF(BgL_envz00_15523, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18370;

					BgL_bpz00_18370 = VECTOR_REF(((obj_t) BgL_sz00_15525), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg2972z00_18371;

						BgL_arg2972z00_18371 =
							((long) CINT(BgL_bpz00_18370) + (long) CINT(BgL_iz00_15524));
						return VECTOR_REF(((obj_t) BgL_sz00_15525), BgL_arg2972z00_18371);
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &comp-ev_trap1391 */
	obj_t BGl_z62compzd2ev_trap1391zb0zz__evaluate_compz00(obj_t BgL_envz00_15526,
		obj_t BgL_ez00_15527, obj_t BgL_stkz00_15528)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 289 */
			{	/* Eval/evaluate_comp.scm 291 */
				obj_t BgL_ez00_18373;

				{	/* Eval/evaluate_comp.scm 291 */
					BgL_ev_exprz00_bglt BgL_arg2919z00_18374;

					BgL_arg2919z00_18374 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_trapz00_bglt) BgL_ez00_15527))))->BgL_ez00);
					BgL_ez00_18373 =
						BGl_compz00zz__evaluate_compz00(BgL_arg2919z00_18374,
						BgL_stkz00_15528);
				}
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_zc3anonymousza32913ze3z83_18375;

					BgL_zc3anonymousza32913ze3z83_18375 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza32913ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza32913ze3z83_18375, (int) (((long) 0)),
						BgL_ez00_18373);
					return BgL_zc3anonymousza32913ze3z83_18375;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2913> */
	obj_t BGl_z62zc3anonymousza32913ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15529, obj_t BgL_sz00_15531)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 292 */
			{	/* Eval/evaluate_comp.scm 292 */
				obj_t BgL_ez00_15530;

				BgL_ez00_15530 = PROCEDURE_REF(BgL_envz00_15529, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_bpz00_18376;

					BgL_bpz00_18376 = VECTOR_REF(((obj_t) BgL_sz00_15531), ((long) 0));
					{	/* Eval/evaluate_comp.scm 293 */
						obj_t BgL_cmdz00_18377;

						BgL_cmdz00_18377 =
							PROCEDURE_ENTRY(BgL_ez00_15530) (BgL_ez00_15530, BgL_sz00_15531,
							BEOA);
						if ((BgL_cmdz00_18377 == BGl_symbol5909z00zz__evaluate_compz00))
							{	/* Eval/evaluate_comp.scm 294 */
								return BgL_bpz00_18376;
							}
						else
							{	/* Eval/evaluate_comp.scm 294 */
								if ((BgL_cmdz00_18377 == BGl_symbol5911z00zz__evaluate_compz00))
									{	/* Eval/evaluate_comp.scm 294 */
										return BGl_reset_profilez00zz__evaluate_compz00();
									}
								else
									{	/* Eval/evaluate_comp.scm 294 */
										if (
											(BgL_cmdz00_18377 ==
												BGl_symbol5913z00zz__evaluate_compz00))
											{	/* Eval/evaluate_comp.scm 294 */
												return BGl_get_profilez00zz__evaluate_compz00();
											}
										else
											{	/* Eval/evaluate_comp.scm 294 */
												if (
													(BgL_cmdz00_18377 ==
														BGl_symbol5915z00zz__evaluate_compz00))
													{	/* Eval/evaluate_comp.scm 302 */
														obj_t BgL_arg2918z00_18378;

														BgL_arg2918z00_18378 =
															BGl_findzd2statezd2zz__evaluate_compz00();
														return
															VECTOR_SET(
															((obj_t) BgL_arg2918z00_18378), ((long) 0),
															BINT(((long) 2)));
													}
												else
													{	/* Eval/evaluate_comp.scm 294 */
														return
															BGl_errorz00zz__errorz00
															(BGl_string5775z00zz__evaluate_compz00,
															BGl_string5917z00zz__evaluate_compz00,
															BgL_cmdz00_18377);
													}
											}
									}
							}
					}
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 430898742),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1047446),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 467924964),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 454272164),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					445908113), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					434692624), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988580),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669940), BSTRING_TO_STRING(BGl_string5918z00zz__evaluate_compz00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
