/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 20 Jun 2019 08:51:31 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.3f -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_types.scm -indent -o objs/obj_u/Eval/evaluate_types.c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_symbol2724z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2728z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2567z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_appz00_bglt BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_appz00_bglt BGl_z62lambda1933z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_binderz00_bglt BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_binderz00_bglt BGl_z62lambda1774z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1939z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2572z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_symbol2737z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2576z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2739z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1940z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1781z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1945z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1785z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2580z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2744z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2585z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2749z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1951z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1794z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1956z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2754z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2594z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2598z00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_z62lambda1963z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_absz00_bglt BGl_z62lambda1965z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2762z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2764z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1972z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1978z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1987z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
	static BgL_ev_exprz00_bglt BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1993z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31701ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31450ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31540ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31435ze3ze1zz__evaluate_typesz00(obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31615ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
	BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31723ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31813ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31564ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31743ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31492ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31638ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31671ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31833ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31477ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1401z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1403z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1416z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1419z62zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1425z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1426z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32001ze3ze1zz__evaluate_typesz00(obj_t);
	extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
	static obj_t BGl_z62lambda1433z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1434z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1439z62zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_trapz00_bglt BGl_z62lambda1601z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1440z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_globalz00_bglt BGl_z62lambda1446z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_globalz00_bglt BGl_z62lambda1448z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31587ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1610z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1613z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1454z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1455z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1460z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1461z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1623z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1624z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1465z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31856ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1466z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_littz00_bglt BGl_z62lambda1472z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1634z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_littz00_bglt BGl_z62lambda1474z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2438z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letz00_bglt BGl_z62lambda1802z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1804z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1481z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1643z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1482z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1644z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31874ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1649z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_ifz00_bglt BGl_z62lambda1488z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2440z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2605z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2444z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2446z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_ifz00_bglt BGl_z62lambda1490z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1657z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_letza2za2_bglt BGl_z62lambda1819z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1496z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1658z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1497z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2611z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2451z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2615z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2453z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2457z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letza2za2_bglt BGl_z62lambda1821z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1667z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1669z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2622z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2462z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2626z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2466z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32009ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1831z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1677z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2630z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2472z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2637z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2477z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32026ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1841z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1843z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31894ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31967ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1685z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1686z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2642z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2481z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2647z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2486z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1690z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1691z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1854z62zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1697z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2490z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2655z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2494z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2498z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1867z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2660z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31421ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2669z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31405ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1872z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1873z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1879z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2674z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1880z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1886z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2684z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_z62lambda1892z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1893z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2690z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2694z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
	BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31603ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
		BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31519ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2000z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2007z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2008z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31554ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2015z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2016z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31806ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda2024z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2025z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31823ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda2031z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2032z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31681ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1503z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1507z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1508z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
	static BgL_ev_listz00_bglt BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_listz00_bglt BGl_z62lambda1516z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31845ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
		BUNSPEC;
	static obj_t BGl_z62lambda1525z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31935ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	extern obj_t BGl_objectz00zz__objectz00;
	static BgL_ev_orz00_bglt BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_orz00_bglt BGl_z62lambda1538z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1705z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1706z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2503z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2507z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1711z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1712z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1552z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31881ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1718z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31776ze3ze1zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2512z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2517z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1560z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1562z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1727z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1569z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2522z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2526z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1570z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1732z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1733z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1574z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1575z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1739z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol2530z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2535z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_gotoz00_bglt BGl_z62lambda1900z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_gotoz00_bglt BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1741z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1908z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1585z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1747z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1909z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2701z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2542z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2707z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2547z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32033ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza32017ze3ze1zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_varz00_bglt BGl_z62lambda1913z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1752z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1914z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1591z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1753z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1592z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1919z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1758z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_trapz00_bglt BGl_z62lambda1598z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_symbol2713z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2551z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2718z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2556z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1920z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1924z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1764z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string2504z00zz__evaluate_typesz00,
		BgL_bgl_string2504za700za7za7_2766za7, "ev_if", 5);
	      DEFINE_STRING(BGl_string2508z00zz__evaluate_typesz00,
		BgL_bgl_string2508za700za7za7_2767za7, "args", 4);
	      DEFINE_STRING(BGl_string2513z00zz__evaluate_typesz00,
		BgL_bgl_string2513za700za7za7_2768za7, "ev_list", 7);
	      DEFINE_STRING(BGl_string2518z00zz__evaluate_typesz00,
		BgL_bgl_string2518za700za7za7_2769za7, "ev_or", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2435z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72770za7,
		BGl_z62zc3anonymousza31405ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2523z00zz__evaluate_typesz00,
		BgL_bgl_string2523za700za7za7_2771za7, "ev_and", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2436z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1403za7622772z00,
		BGl_z62lambda1403z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2437z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1401za7622773z00,
		BGl_z62lambda1401z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2527z00zz__evaluate_typesz00,
		BgL_bgl_string2527za700za7za7_2774za7, "e1", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2600z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1733za7622775z00,
		BGl_z62lambda1733z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2601z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1732za7622776z00,
		BGl_z62lambda1732z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2602z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72777za7,
		BGl_z62zc3anonymousza31723ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2603z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1720za7622778z00,
		BGl_z62lambda1720z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2604z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1718za7622779z00,
		BGl_z62lambda1718z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2442z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1426za7622780z00,
		BGl_z62lambda1426z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2443z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1425za7622781z00,
		BGl_z62lambda1425z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2531z00zz__evaluate_typesz00,
		BgL_bgl_string2531za700za7za7_2782za7, "e2", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2607z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1748za7622783z00,
		BGl_z62lambda1748z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2608z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1747za7622784z00,
		BGl_z62lambda1747z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2609z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1753za7622785z00,
		BGl_z62lambda1753z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2448z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72786za7,
		BGl_z62zc3anonymousza31435ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2536z00zz__evaluate_typesz00,
		BgL_bgl_string2536za700za7za7_2787za7, "ev_prog2", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2449z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1434za7622788z00,
		BGl_z62lambda1434z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2610z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1752za7622789z00,
		BGl_z62lambda1752z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2450z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1433za7622790z00,
		BGl_z62lambda1433z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2613z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1758za7622791z00,
		BGl_z62lambda1758z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2614z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1757za7622792z00,
		BGl_z62lambda1757z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2702z00zz__evaluate_typesz00,
		BgL_bgl_string2702za700za7za7_2793za7, "ev_goto", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2617z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1764za7622794z00,
		BGl_z62lambda1764z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2455z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1440za7622795z00,
		BGl_z62lambda1440z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2618z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1763za7622796z00,
		BGl_z62lambda1763z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2543z00zz__evaluate_typesz00,
		BgL_bgl_string2543za700za7za7_2797za7, "ev_hook", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2456z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1439za7622798z00,
		BGl_z62lambda1439z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2619z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72799za7,
		BGl_z62zc3anonymousza31743ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2708z00zz__evaluate_typesz00,
		BgL_bgl_string2708za700za7za7_2800za7, "fun", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2459z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72801za7,
		BGl_z62zc3anonymousza31421ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2548z00zz__evaluate_typesz00,
		BgL_bgl_string2548za700za7za7_2802za7, "ev_trap", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2620z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1741za7622803z00,
		BGl_z62lambda1741z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2621z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1739za7622804z00,
		BGl_z62lambda1739z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2460z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1419za7622805z00,
		BGl_z62lambda1419z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2461z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1416za7622806z00,
		BGl_z62lambda1416z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2624z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1781za7622807z00,
		BGl_z62lambda1781z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2625z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1780za7622808z00,
		BGl_z62lambda1780z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2464z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1455za7622809z00,
		BGl_z62lambda1455z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2714z00zz__evaluate_typesz00,
		BgL_bgl_string2714za700za7za7_2810za7, "tail?", 5);
	      DEFINE_STRING(BGl_string2552z00zz__evaluate_typesz00,
		BgL_bgl_string2552za700za7za7_2811za7, "v", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2465z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1454za7622812z00,
		BGl_z62lambda1454z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2628z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1786za7622813z00,
		BGl_z62lambda1786z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2629z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1785za7622814z00,
		BGl_z62lambda1785z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2468z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1461za7622815z00,
		BGl_z62lambda1461z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2469z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1460za7622816z00,
		BGl_z62lambda1460z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2719z00zz__evaluate_typesz00,
		BgL_bgl_string2719za700za7za7_2817za7, "ev_app", 6);
	      DEFINE_STRING(BGl_string2557z00zz__evaluate_typesz00,
		BgL_bgl_string2557za700za7za7_2818za7, "ev_setlocal", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2632z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1794za7622819z00,
		BGl_z62lambda1794z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2470z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1466za7622820z00,
		BGl_z62lambda1466z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2633z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1793za7622821z00,
		BGl_z62lambda1793z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2471z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1465za7622822z00,
		BGl_z62lambda1465z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2634z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72823za7,
		BGl_z62zc3anonymousza31776ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2635z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1774za7622824z00,
		BGl_z62lambda1774z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2636z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1772za7622825z00,
		BGl_z62lambda1772z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2474z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72826za7,
		BGl_z62zc3anonymousza31450ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2475z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1448za7622827z00,
		BGl_z62lambda1448z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2725z00zz__evaluate_typesz00,
		BgL_bgl_string2725za700za7za7_2828za7, "where", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2476z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1446za7622829z00,
		BGl_z62lambda1446z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2639z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72830za7,
		BGl_z62zc3anonymousza31813ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2479z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1482za7622831z00,
		BGl_z62lambda1482z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2729z00zz__evaluate_typesz00,
		BgL_bgl_string2729za700za7za7_2832za7, "arity", 5);
	      DEFINE_STRING(BGl_string2568z00zz__evaluate_typesz00,
		BgL_bgl_string2568za700za7za7_2833za7, "ev_setglobal", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2640z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1812za7622834z00,
		BGl_z62lambda1812z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2641z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1811za7622835z00,
		BGl_z62lambda1811z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2480z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1481za7622836z00,
		BGl_z62lambda1481z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2644z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72837za7,
		BGl_z62zc3anonymousza31806ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2645z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1804za7622838z00,
		BGl_z62lambda1804z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2483z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72839za7,
		BGl_z62zc3anonymousza31477ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2646z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1802za7622840z00,
		BGl_z62lambda1802z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2484z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1474za7622841z00,
		BGl_z62lambda1474z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2485z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1472za7622842z00,
		BGl_z62lambda1472z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2573z00zz__evaluate_typesz00,
		BgL_bgl_string2573za700za7za7_2843za7, "ev_defglobal", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2649z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72844za7,
		BGl_z62zc3anonymousza31833ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2488z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1497za7622845z00,
		BGl_z62lambda1497z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2738z00zz__evaluate_typesz00,
		BgL_bgl_string2738za700za7za7_2846za7, "size", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2489z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1496za7622847z00,
		BGl_z62lambda1496z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2577z00zz__evaluate_typesz00,
		BgL_bgl_string2577za700za7za7_2848za7, "var", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2650z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1832za7622849z00,
		BGl_z62lambda1832z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2651z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1831za7622850z00,
		BGl_z62lambda1831z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2652z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72851za7,
		BGl_z62zc3anonymousza31823ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2740z00zz__evaluate_typesz00,
		BgL_bgl_string2740za700za7za7_2852za7, "int", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2653z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1821za7622853z00,
		BGl_z62lambda1821z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2654z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1819za7622854z00,
		BGl_z62lambda1819z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2492z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1503za7622855z00,
		BGl_z62lambda1503z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2493z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1502za7622856z00,
		BGl_z62lambda1502z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2581z00zz__evaluate_typesz00,
		BgL_bgl_string2581za700za7za7_2857za7, "body", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2657z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72858za7,
		BGl_z62zc3anonymousza31845ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2745z00zz__evaluate_typesz00,
		BgL_bgl_string2745za700za7za7_2859za7, "bind", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2658z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1843za7622860z00,
		BGl_z62lambda1843z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2496z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1508za7622861z00,
		BGl_z62lambda1508z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2659z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1841za7622862z00,
		BGl_z62lambda1841z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2497z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1507za7622863z00,
		BGl_z62lambda1507z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2586z00zz__evaluate_typesz00,
		BgL_bgl_string2586za700za7za7_2864za7, "ev_bind-exit", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2662z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1862za7622865z00,
		BGl_z62lambda1862z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2750z00zz__evaluate_typesz00,
		BgL_bgl_string2750za700za7za7_2866za7, "free", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2663z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1861za7622867z00,
		BGl_z62lambda1861z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2664z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1867za7622868z00,
		BGl_z62lambda1867z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2665z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1866za7622869z00,
		BGl_z62lambda1866z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2666z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72870za7,
		BGl_z62zc3anonymousza31874ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2667z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1873za7622871z00,
		BGl_z62lambda1873z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2755z00zz__evaluate_typesz00,
		BgL_bgl_string2755za700za7za7_2872za7, "inner", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2668z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1872za7622873z00,
		BGl_z62lambda1872z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2595z00zz__evaluate_typesz00,
		BgL_bgl_string2595za700za7za7_2874za7, "ev_unwind-protect", 17);
	      DEFINE_STRING(BGl_string2599z00zz__evaluate_typesz00,
		BgL_bgl_string2599za700za7za7_2875za7, "handler", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2671z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72876za7,
		BGl_z62zc3anonymousza31881ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2672z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1880za7622877z00,
		BGl_z62lambda1880z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2673z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1879za7622878z00,
		BGl_z62lambda1879z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2763z00zz__evaluate_typesz00,
		BgL_bgl_string2763za700za7za7_2879za7, "ev_abs", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2676z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1886za7622880z00,
		BGl_z62lambda1886z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2677z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1885za7622881z00,
		BGl_z62lambda1885z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2765z00zz__evaluate_typesz00,
		BgL_bgl_string2765za700za7za7_2882za7, "_", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2678z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72883za7,
		BGl_z62zc3anonymousza31894ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2679z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1893za7622884z00,
		BGl_z62lambda1893z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2680z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1892za7622885z00,
		BGl_z62lambda1892z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2681z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72886za7,
		BGl_z62zc3anonymousza31856ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2682z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1854za7622887z00,
		BGl_z62lambda1854z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2683z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1852za7622888z00,
		BGl_z62lambda1852z62zz__evaluate_typesz00, 0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2686z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1909za7622889z00,
		BGl_z62lambda1909z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2687z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1908za7622890z00,
		BGl_z62lambda1908z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2688z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1914za7622891z00,
		BGl_z62lambda1914z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2689z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1913za7622892z00,
		BGl_z62lambda1913z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2692z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1920za7622893z00,
		BGl_z62lambda1920z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2693z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1919za7622894z00,
		BGl_z62lambda1919z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2696z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1925za7622895z00,
		BGl_z62lambda1925z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2697z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1924za7622896z00,
		BGl_z62lambda1924z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2698z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72897za7,
		BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2699z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1902za7622898z00,
		BGl_z62lambda1902z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2500z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72899za7,
		BGl_z62zc3anonymousza31492ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2501z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1490za7622900z00,
		BGl_z62lambda1490z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2502z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1488za7622901z00,
		BGl_z62lambda1488z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2505z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1526za7622902z00,
		BGl_z62lambda1526z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2506z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1525za7622903z00,
		BGl_z62lambda1525z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2509z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72904za7,
		BGl_z62zc3anonymousza31519ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2439z00zz__evaluate_typesz00,
		BgL_bgl_string2439za700za7za7_2905za7, "ev_expr", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2510z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1516za7622906z00,
		BGl_z62lambda1516z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2511z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1514za7622907z00,
		BGl_z62lambda1514z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2514z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72908za7,
		BGl_z62zc3anonymousza31540ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2515z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1538za7622909z00,
		BGl_z62lambda1538z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2516z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1536za7622910z00,
		BGl_z62lambda1536z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2441z00zz__evaluate_typesz00,
		BgL_bgl_string2441za700za7za7_2911za7, "__evaluate_types", 16);
	      DEFINE_STRING(BGl_string2606z00zz__evaluate_typesz00,
		BgL_bgl_string2606za700za7za7_2912za7, "ev_with-handler", 15);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2519z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72913za7,
		BGl_z62zc3anonymousza31554ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2445z00zz__evaluate_typesz00,
		BgL_bgl_string2445za700za7za7_2914za7, "name", 4);
	      DEFINE_STRING(BGl_string2447z00zz__evaluate_typesz00,
		BgL_bgl_string2447za700za7za7_2915za7, "symbol", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2520z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1552za7622916z00,
		BGl_z62lambda1552z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2521z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1547za7622917z00,
		BGl_z62lambda1547z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2524z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1570za7622918z00,
		BGl_z62lambda1570z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2612z00zz__evaluate_typesz00,
		BgL_bgl_string2612za700za7za7_2919za7, "mutex", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2525z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1569za7622920z00,
		BGl_z62lambda1569z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2452z00zz__evaluate_typesz00,
		BgL_bgl_string2452za700za7za7_2921za7, "eff", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2528z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1575za7622922z00,
		BGl_z62lambda1575z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2616z00zz__evaluate_typesz00,
		BgL_bgl_string2616za700za7za7_2923za7, "prelock", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2529z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1574za7622924z00,
		BGl_z62lambda1574z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2454z00zz__evaluate_typesz00,
		BgL_bgl_string2454za700za7za7_2925za7, "obj", 3);
	      DEFINE_STRING(BGl_string2458z00zz__evaluate_typesz00,
		BgL_bgl_string2458za700za7za7_2926za7, "type", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2532z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72927za7,
		BGl_z62zc3anonymousza31564ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2533z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1562za7622928z00,
		BGl_z62lambda1562z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2534z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1560za7622929z00,
		BGl_z62lambda1560z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2623z00zz__evaluate_typesz00,
		BgL_bgl_string2623za700za7za7_2930za7, "ev_synchronize", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2537z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1592za7622931z00,
		BGl_z62lambda1592z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2538z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1591za7622932z00,
		BGl_z62lambda1591z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2463z00zz__evaluate_typesz00,
		BgL_bgl_string2463za700za7za7_2933za7, "ev_var", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2539z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72934za7,
		BGl_z62zc3anonymousza31587ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2627z00zz__evaluate_typesz00,
		BgL_bgl_string2627za700za7za7_2935za7, "vars", 4);
	      DEFINE_STRING(BGl_string2467z00zz__evaluate_typesz00,
		BgL_bgl_string2467za700za7za7_2936za7, "loc", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2700z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1900za7622937z00,
		BGl_z62lambda1900z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2540z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1585za7622938z00,
		BGl_z62lambda1585z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2703z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1940za7622939z00,
		BGl_z62lambda1940z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2541z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1583za7622940z00,
		BGl_z62lambda1583z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2704z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1939za7622941z00,
		BGl_z62lambda1939z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2705z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1946za7622942z00,
		BGl_z62lambda1946z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2706z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1945za7622943z00,
		BGl_z62lambda1945z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2631z00zz__evaluate_typesz00,
		BgL_bgl_string2631za700za7za7_2944za7, "vals", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2544z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72945za7,
		BGl_z62zc3anonymousza31603ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2545z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1601za7622946z00,
		BGl_z62lambda1601z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2546z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1598za7622947z00,
		BGl_z62lambda1598z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2709z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1952za7622948z00,
		BGl_z62lambda1952z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2473z00zz__evaluate_typesz00,
		BgL_bgl_string2473za700za7za7_2949za7, "mod", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2549z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1624za7622950z00,
		BGl_z62lambda1624z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2638z00zz__evaluate_typesz00,
		BgL_bgl_string2638za700za7za7_2951za7, "ev_binder", 9);
	      DEFINE_STRING(BGl_string2478z00zz__evaluate_typesz00,
		BgL_bgl_string2478za700za7za7_2952za7, "ev_global", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2710z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1951za7622953z00,
		BGl_z62lambda1951z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2711z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1957za7622954z00,
		BGl_z62lambda1957z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2712z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1956za7622955z00,
		BGl_z62lambda1956z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2550z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1623za7622956z00,
		BGl_z62lambda1623z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2715z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72957za7,
		BGl_z62zc3anonymousza31935ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2553z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72958za7,
		BGl_z62zc3anonymousza31615ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2716z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1933za7622959z00,
		BGl_z62lambda1933z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2554z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1613za7622960z00,
		BGl_z62lambda1613z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2717z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1931za7622961z00,
		BGl_z62lambda1931z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2555z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1610za7622962z00,
		BGl_z62lambda1610z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2643z00zz__evaluate_typesz00,
		BgL_bgl_string2643za700za7za7_2963za7, "boxes", 5);
	      DEFINE_STRING(BGl_string2482z00zz__evaluate_typesz00,
		BgL_bgl_string2482za700za7za7_2964za7, "value", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2558z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1644za7622965z00,
		BGl_z62lambda1644z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2559z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1643za7622966z00,
		BGl_z62lambda1643z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2648z00zz__evaluate_typesz00,
		BgL_bgl_string2648za700za7za7_2967za7, "ev_let", 6);
	      DEFINE_STRING(BGl_string2487z00zz__evaluate_typesz00,
		BgL_bgl_string2487za700za7za7_2968za7, "ev_litt", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2720z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1972za7622969z00,
		BGl_z62lambda1972z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2721z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1971za7622970z00,
		BGl_z62lambda1971z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2722z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1978za7622971z00,
		BGl_z62lambda1978z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2560z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1650za7622972z00,
		BGl_z62lambda1650z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2723z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1977za7622973z00,
		BGl_z62lambda1977z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2561z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1649za7622974z00,
		BGl_z62lambda1649z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2562z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1658za7622975z00,
		BGl_z62lambda1658z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2563z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1657za7622976z00,
		BGl_z62lambda1657z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2726z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1983za7622977z00,
		BGl_z62lambda1983z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2564z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72978za7,
		BGl_z62zc3anonymousza31638ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2727z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1982za7622979z00,
		BGl_z62lambda1982z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2565z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1636za7622980z00,
		BGl_z62lambda1636z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2566z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1634za7622981z00,
		BGl_z62lambda1634z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2491z00zz__evaluate_typesz00,
		BgL_bgl_string2491za700za7za7_2982za7, "p", 1);
	      DEFINE_STRING(BGl_string2656z00zz__evaluate_typesz00,
		BgL_bgl_string2656za700za7za7_2983za7, "ev_let*", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2569z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72984za7,
		BGl_z62zc3anonymousza31671ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2495z00zz__evaluate_typesz00,
		BgL_bgl_string2495za700za7za7_2985za7, "t", 1);
	      DEFINE_STRING(BGl_string2499z00zz__evaluate_typesz00,
		BgL_bgl_string2499za700za7za7_2986za7, "e", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2730z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1988za7622987z00,
		BGl_z62lambda1988z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2731z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1987za7622988z00,
		BGl_z62lambda1987z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2732z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1993za7622989z00,
		BGl_z62lambda1993z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2570z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1669za7622990z00,
		BGl_z62lambda1669z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2733z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1992za7622991z00,
		BGl_z62lambda1992z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2571z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1667za7622992z00,
		BGl_z62lambda1667z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2734z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72993za7,
		BGl_z62zc3anonymousza32001ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2735z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2000za7622994z00,
		BGl_z62lambda2000z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2736z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1999za7622995z00,
		BGl_z62lambda1999z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2661z00zz__evaluate_typesz00,
		BgL_bgl_string2661za700za7za7_2996za7, "ev_letrec", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2574z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1686za7622997z00,
		BGl_z62lambda1686z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2575z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1685za7622998z00,
		BGl_z62lambda1685z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2578z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1691za7622999z00,
		BGl_z62lambda1691z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2579z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1690za7623000z00,
		BGl_z62lambda1690z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2741z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73001za7,
		BGl_z62zc3anonymousza32009ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2742z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2008za7623002z00,
		BGl_z62lambda2008z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2743z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2007za7623003z00,
		BGl_z62lambda2007z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2582z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73004za7,
		BGl_z62zc3anonymousza31681ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2670z00zz__evaluate_typesz00,
		BgL_bgl_string2670za700za7za7_3005za7, "env", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2583z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1679za7623006z00,
		BGl_z62lambda1679z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2746z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73007za7,
		BGl_z62zc3anonymousza32017ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2584z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1677za7623008z00,
		BGl_z62lambda1677z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2747z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2016za7623009z00,
		BGl_z62lambda2016z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2748z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2015za7623010z00,
		BGl_z62lambda2015z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2587z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1706za7623011z00,
		BGl_z62lambda1706z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2675z00zz__evaluate_typesz00,
		BgL_bgl_string2675za700za7za7_3012za7, "stk", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2588z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1705za7623013z00,
		BGl_z62lambda1705z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2589z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1712za7623014z00,
		BGl_z62lambda1712z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2751z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73015za7,
		BGl_z62zc3anonymousza32026ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2752z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2025za7623016z00,
		BGl_z62lambda2025z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2590z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1711za7623017z00,
		BGl_z62lambda1711z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2753z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2024za7623018z00,
		BGl_z62lambda2024z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2591z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73019za7,
		BGl_z62zc3anonymousza31701ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2592z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1699za7623020z00,
		BGl_z62lambda1699z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2593z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1697za7623021z00,
		BGl_z62lambda1697z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2756z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73022za7,
		BGl_z62zc3anonymousza32033ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2757z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2032za7623023z00,
		BGl_z62lambda2032z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2758z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2031za7623024z00,
		BGl_z62lambda2031z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2596z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1728za7623025z00,
		BGl_z62lambda1728z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2759z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza73026za7,
		BGl_z62zc3anonymousza31967ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2597z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1727za7623027z00,
		BGl_z62lambda1727z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2685z00zz__evaluate_typesz00,
		BgL_bgl_string2685za700za7za7_3028za7, "ev_labels", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2760z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1965za7623029z00,
		BGl_z62lambda1965z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2761z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1963za7623030z00,
		BGl_z62lambda1963z62zz__evaluate_typesz00, 0L, BUNSPEC, 10);
	      DEFINE_STRING(BGl_string2691z00zz__evaluate_typesz00,
		BgL_bgl_string2691za700za7za7_3031za7, "label", 5);
	      DEFINE_STRING(BGl_string2695z00zz__evaluate_typesz00,
		BgL_bgl_string2695za700za7za7_3032za7, "labels", 6);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_symbol2724z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2728z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2567z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2572z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2737z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2576z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2739z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2580z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2744z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2585z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2749z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2754z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2594z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2598z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_letrecz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2762z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2764z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_letz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_labelsz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_absz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_ifz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_gotoz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_orz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_varz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_andz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_appz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2438z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_synchroniza7eza7zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2440z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2605z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2444z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2446z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2611z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2451z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2615z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2453z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2457z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2622z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2462z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2626z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2466z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2630z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2472z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2637z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2477z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2642z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2481z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2647z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2486z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_defglobalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2490z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2655z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2494z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2498z00zz__evaluate_typesz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2660z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2669z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2674z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2684z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2690z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2694z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_prog2z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_bindzd2exitzd2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_letza2za2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_trapz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_setglobalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_hookz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_globalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_binderz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_listz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_littz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_withzd2handlerzd2zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_exprz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2503z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2507z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2512z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2517z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2522z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2526z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2530z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2535z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2701z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2542z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2707z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2547z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_ev_setlocalz00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2713z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2551z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2718z00zz__evaluate_typesz00));
		     ADD_ROOT((void *) (&BGl_symbol2556z00zz__evaluate_typesz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long
		BgL_checksumz00_4418, char *BgL_fromz00_4419)
	{
		BGL_FUNCTION_BEGIN;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
					BGl_cnstzd2initzd2zz__evaluate_typesz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
					BGl_objectzd2initzd2zz__evaluate_typesz00();
					return BGl_toplevelzd2initzd2zz__evaluate_typesz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
		BGL_FUNCTION_END;
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			BGl_symbol2438z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2439z00zz__evaluate_typesz00);
			BGl_symbol2440z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2441z00zz__evaluate_typesz00);
			BGl_symbol2444z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2445z00zz__evaluate_typesz00);
			BGl_symbol2446z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2447z00zz__evaluate_typesz00);
			BGl_symbol2451z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2452z00zz__evaluate_typesz00);
			BGl_symbol2453z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2454z00zz__evaluate_typesz00);
			BGl_symbol2457z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2458z00zz__evaluate_typesz00);
			BGl_symbol2462z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2463z00zz__evaluate_typesz00);
			BGl_symbol2466z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2467z00zz__evaluate_typesz00);
			BGl_symbol2472z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2473z00zz__evaluate_typesz00);
			BGl_symbol2477z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2478z00zz__evaluate_typesz00);
			BGl_symbol2481z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2482z00zz__evaluate_typesz00);
			BGl_symbol2486z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2487z00zz__evaluate_typesz00);
			BGl_symbol2490z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2491z00zz__evaluate_typesz00);
			BGl_symbol2494z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2495z00zz__evaluate_typesz00);
			BGl_symbol2498z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2499z00zz__evaluate_typesz00);
			BGl_symbol2503z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2504z00zz__evaluate_typesz00);
			BGl_symbol2507z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2508z00zz__evaluate_typesz00);
			BGl_symbol2512z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2513z00zz__evaluate_typesz00);
			BGl_symbol2517z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2518z00zz__evaluate_typesz00);
			BGl_symbol2522z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2523z00zz__evaluate_typesz00);
			BGl_symbol2526z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2527z00zz__evaluate_typesz00);
			BGl_symbol2530z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2531z00zz__evaluate_typesz00);
			BGl_symbol2535z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2536z00zz__evaluate_typesz00);
			BGl_symbol2542z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2543z00zz__evaluate_typesz00);
			BGl_symbol2547z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2548z00zz__evaluate_typesz00);
			BGl_symbol2551z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2552z00zz__evaluate_typesz00);
			BGl_symbol2556z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2557z00zz__evaluate_typesz00);
			BGl_symbol2567z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2568z00zz__evaluate_typesz00);
			BGl_symbol2572z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2573z00zz__evaluate_typesz00);
			BGl_symbol2576z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2577z00zz__evaluate_typesz00);
			BGl_symbol2580z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2581z00zz__evaluate_typesz00);
			BGl_symbol2585z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2586z00zz__evaluate_typesz00);
			BGl_symbol2594z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2595z00zz__evaluate_typesz00);
			BGl_symbol2598z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2599z00zz__evaluate_typesz00);
			BGl_symbol2605z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2606z00zz__evaluate_typesz00);
			BGl_symbol2611z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2612z00zz__evaluate_typesz00);
			BGl_symbol2615z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2616z00zz__evaluate_typesz00);
			BGl_symbol2622z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2623z00zz__evaluate_typesz00);
			BGl_symbol2626z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2627z00zz__evaluate_typesz00);
			BGl_symbol2630z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2631z00zz__evaluate_typesz00);
			BGl_symbol2637z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2638z00zz__evaluate_typesz00);
			BGl_symbol2642z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2643z00zz__evaluate_typesz00);
			BGl_symbol2647z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2648z00zz__evaluate_typesz00);
			BGl_symbol2655z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2656z00zz__evaluate_typesz00);
			BGl_symbol2660z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2661z00zz__evaluate_typesz00);
			BGl_symbol2669z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2670z00zz__evaluate_typesz00);
			BGl_symbol2674z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2675z00zz__evaluate_typesz00);
			BGl_symbol2684z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2685z00zz__evaluate_typesz00);
			BGl_symbol2690z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2691z00zz__evaluate_typesz00);
			BGl_symbol2694z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2695z00zz__evaluate_typesz00);
			BGl_symbol2701z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2702z00zz__evaluate_typesz00);
			BGl_symbol2707z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2708z00zz__evaluate_typesz00);
			BGl_symbol2713z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2714z00zz__evaluate_typesz00);
			BGl_symbol2718z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2719z00zz__evaluate_typesz00);
			BGl_symbol2724z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2725z00zz__evaluate_typesz00);
			BGl_symbol2728z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2729z00zz__evaluate_typesz00);
			BGl_symbol2737z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2738z00zz__evaluate_typesz00);
			BGl_symbol2739z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2740z00zz__evaluate_typesz00);
			BGl_symbol2744z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2745z00zz__evaluate_typesz00);
			BGl_symbol2749z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2750z00zz__evaluate_typesz00);
			BGl_symbol2754z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2755z00zz__evaluate_typesz00);
			BGl_symbol2762z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2763z00zz__evaluate_typesz00);
			return (BGl_symbol2764z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2765z00zz__evaluate_typesz00), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			return bgl_gc_roots_register();
		}
		BGL_FUNCTION_END;
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			{	/* Eval/evaluate_types.scm 49 */
				obj_t BgL_arg1399z00_1057;
				obj_t BgL_arg1400z00_1058;

				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1286z00_1068;

					BgL_v1286z00_1068 = create_vector(((long) 0));
					BgL_arg1399z00_1057 = BgL_v1286z00_1068;
				}
				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1287z00_1069;

					BgL_v1287z00_1069 = create_vector(((long) 0));
					BgL_arg1400z00_1058 = BgL_v1287z00_1069;
				}
				BGl_ev_exprz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2438z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00,
					((long) 36682), BGl_proc2437z00zz__evaluate_typesz00,
					BGl_proc2436z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2435z00zz__evaluate_typesz00, BFALSE, BgL_arg1399z00_1057,
					BgL_arg1400z00_1058);
			}
			{	/* Eval/evaluate_types.scm 51 */
				obj_t BgL_arg1412z00_1076;
				obj_t BgL_arg1415z00_1077;

				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1288z00_1090;

					BgL_v1288z00_1090 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1288z00_1090, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2444z00zz__evaluate_typesz00,
							BGl_proc2443z00zz__evaluate_typesz00,
							BGl_proc2442z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2446z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1288z00_1090, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2451z00zz__evaluate_typesz00,
							BGl_proc2450z00zz__evaluate_typesz00,
							BGl_proc2449z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2448z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1288z00_1090, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2457z00zz__evaluate_typesz00,
							BGl_proc2456z00zz__evaluate_typesz00,
							BGl_proc2455z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1412z00_1076 = BgL_v1288z00_1090;
				}
				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1289z00_1124;

					BgL_v1289z00_1124 = create_vector(((long) 0));
					BgL_arg1415z00_1077 = BgL_v1289z00_1124;
				}
				BGl_ev_varz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2462z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 7285),
					BGl_proc2461z00zz__evaluate_typesz00,
					BGl_proc2460z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2459z00zz__evaluate_typesz00, BFALSE, BgL_arg1412z00_1076,
					BgL_arg1415z00_1077);
			}
			{	/* Eval/evaluate_types.scm 55 */
				obj_t BgL_arg1444z00_1131;
				obj_t BgL_arg1445z00_1132;

				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1290z00_1145;

					BgL_v1290z00_1145 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1290z00_1145, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2466z00zz__evaluate_typesz00,
							BGl_proc2465z00zz__evaluate_typesz00,
							BGl_proc2464z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1290z00_1145, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2444z00zz__evaluate_typesz00,
							BGl_proc2469z00zz__evaluate_typesz00,
							BGl_proc2468z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2446z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1290z00_1145, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2472z00zz__evaluate_typesz00,
							BGl_proc2471z00zz__evaluate_typesz00,
							BGl_proc2470z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1444z00_1131 = BgL_v1290z00_1145;
				}
				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1291z00_1176;

					BgL_v1291z00_1176 = create_vector(((long) 0));
					BgL_arg1445z00_1132 = BgL_v1291z00_1176;
				}
				BGl_ev_globalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2477z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59175),
					BGl_proc2476z00zz__evaluate_typesz00,
					BGl_proc2475z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2474z00zz__evaluate_typesz00, BFALSE, BgL_arg1444z00_1131,
					BgL_arg1445z00_1132);
			}
			{	/* Eval/evaluate_types.scm 60 */
				obj_t BgL_arg1470z00_1183;
				obj_t BgL_arg1471z00_1184;

				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1292z00_1195;

					BgL_v1292z00_1195 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1292z00_1195, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2481z00zz__evaluate_typesz00,
							BGl_proc2480z00zz__evaluate_typesz00,
							BGl_proc2479z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1470z00_1183 = BgL_v1292z00_1195;
				}
				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1293z00_1206;

					BgL_v1293z00_1206 = create_vector(((long) 0));
					BgL_arg1471z00_1184 = BgL_v1293z00_1206;
				}
				BGl_ev_littz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2486z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 42418),
					BGl_proc2485z00zz__evaluate_typesz00,
					BGl_proc2484z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2483z00zz__evaluate_typesz00, BFALSE, BgL_arg1470z00_1183,
					BgL_arg1471z00_1184);
			}
			{	/* Eval/evaluate_types.scm 62 */
				obj_t BgL_arg1486z00_1213;
				obj_t BgL_arg1487z00_1214;

				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1294z00_1227;

					BgL_v1294z00_1227 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1294z00_1227, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2490z00zz__evaluate_typesz00,
							BGl_proc2489z00zz__evaluate_typesz00,
							BGl_proc2488z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1294z00_1227, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2494z00zz__evaluate_typesz00,
							BGl_proc2493z00zz__evaluate_typesz00,
							BGl_proc2492z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1294z00_1227, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2498z00zz__evaluate_typesz00,
							BGl_proc2497z00zz__evaluate_typesz00,
							BGl_proc2496z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1486z00_1213 = BgL_v1294z00_1227;
				}
				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1295z00_1258;

					BgL_v1295z00_1258 = create_vector(((long) 0));
					BgL_arg1487z00_1214 = BgL_v1295z00_1258;
				}
				BGl_ev_ifz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2503z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 19099),
					BGl_proc2502z00zz__evaluate_typesz00,
					BGl_proc2501z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2500z00zz__evaluate_typesz00, BFALSE, BgL_arg1486z00_1213,
					BgL_arg1487z00_1214);
			}
			{	/* Eval/evaluate_types.scm 66 */
				obj_t BgL_arg1512z00_1265;
				obj_t BgL_arg1513z00_1266;

				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1296z00_1277;

					BgL_v1296z00_1277 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1296z00_1277, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2507z00zz__evaluate_typesz00,
							BGl_proc2506z00zz__evaluate_typesz00,
							BGl_proc2505z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1512z00_1265 = BgL_v1296z00_1277;
				}
				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1297z00_1288;

					BgL_v1297z00_1288 = create_vector(((long) 0));
					BgL_arg1513z00_1266 = BgL_v1297z00_1288;
				}
				BGl_ev_listz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2512z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 39617),
					BGl_proc2511z00zz__evaluate_typesz00,
					BGl_proc2510z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2509z00zz__evaluate_typesz00, BFALSE, BgL_arg1512z00_1265,
					BgL_arg1513z00_1266);
			}
			{	/* Eval/evaluate_types.scm 68 */
				obj_t BgL_arg1532z00_1295;
				obj_t BgL_arg1535z00_1296;

				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1298z00_1307;

					BgL_v1298z00_1307 = create_vector(((long) 0));
					BgL_arg1532z00_1295 = BgL_v1298z00_1307;
				}
				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1299z00_1308;

					BgL_v1299z00_1308 = create_vector(((long) 0));
					BgL_arg1535z00_1296 = BgL_v1299z00_1308;
				}
				BGl_ev_orz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2517z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 50334),
					BGl_proc2516z00zz__evaluate_typesz00,
					BGl_proc2515z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2514z00zz__evaluate_typesz00, BFALSE, BgL_arg1532z00_1295,
					BgL_arg1535z00_1296);
			}
			{	/* Eval/evaluate_types.scm 69 */
				obj_t BgL_arg1545z00_1315;
				obj_t BgL_arg1546z00_1316;

				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1300z00_1327;

					BgL_v1300z00_1327 = create_vector(((long) 0));
					BgL_arg1545z00_1315 = BgL_v1300z00_1327;
				}
				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1301z00_1328;

					BgL_v1301z00_1328 = create_vector(((long) 0));
					BgL_arg1546z00_1316 = BgL_v1301z00_1328;
				}
				BGl_ev_andz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2522z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 26888),
					BGl_proc2521z00zz__evaluate_typesz00,
					BGl_proc2520z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2519z00zz__evaluate_typesz00, BFALSE, BgL_arg1545z00_1315,
					BgL_arg1546z00_1316);
			}
			{	/* Eval/evaluate_types.scm 70 */
				obj_t BgL_arg1558z00_1335;
				obj_t BgL_arg1559z00_1336;

				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1302z00_1348;

					BgL_v1302z00_1348 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1302z00_1348, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2526z00zz__evaluate_typesz00,
							BGl_proc2525z00zz__evaluate_typesz00,
							BGl_proc2524z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1302z00_1348, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2530z00zz__evaluate_typesz00,
							BGl_proc2529z00zz__evaluate_typesz00,
							BGl_proc2528z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1558z00_1335 = BgL_v1302z00_1348;
				}
				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1303z00_1369;

					BgL_v1303z00_1369 = create_vector(((long) 0));
					BgL_arg1559z00_1336 = BgL_v1303z00_1369;
				}
				BGl_ev_prog2z00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2535z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 14177),
					BGl_proc2534z00zz__evaluate_typesz00,
					BGl_proc2533z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2532z00zz__evaluate_typesz00, BFALSE, BgL_arg1558z00_1335,
					BgL_arg1559z00_1336);
			}
			{	/* Eval/evaluate_types.scm 73 */
				obj_t BgL_arg1581z00_1376;
				obj_t BgL_arg1582z00_1377;

				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1304z00_1388;

					BgL_v1304z00_1388 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1304z00_1388, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2498z00zz__evaluate_typesz00,
							BGl_proc2538z00zz__evaluate_typesz00,
							BGl_proc2537z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1581z00_1376 = BgL_v1304z00_1388;
				}
				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1305z00_1399;

					BgL_v1305z00_1399 = create_vector(((long) 0));
					BgL_arg1582z00_1377 = BgL_v1305z00_1399;
				}
				BGl_ev_hookz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2542z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 32125),
					BGl_proc2541z00zz__evaluate_typesz00,
					BGl_proc2540z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2539z00zz__evaluate_typesz00, BFALSE, BgL_arg1581z00_1376,
					BgL_arg1582z00_1377);
			}
			{	/* Eval/evaluate_types.scm 75 */
				obj_t BgL_arg1596z00_1406;
				obj_t BgL_arg1597z00_1407;

				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1306z00_1418;

					BgL_v1306z00_1418 = create_vector(((long) 0));
					BgL_arg1596z00_1406 = BgL_v1306z00_1418;
				}
				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1307z00_1419;

					BgL_v1307z00_1419 = create_vector(((long) 0));
					BgL_arg1597z00_1407 = BgL_v1307z00_1419;
				}
				BGl_ev_trapz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2547z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 24451),
					BGl_proc2546z00zz__evaluate_typesz00,
					BGl_proc2545z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2544z00zz__evaluate_typesz00, BFALSE, BgL_arg1596z00_1406,
					BgL_arg1597z00_1407);
			}
			{	/* Eval/evaluate_types.scm 76 */
				obj_t BgL_arg1608z00_1426;
				obj_t BgL_arg1609z00_1427;

				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1308z00_1439;

					BgL_v1308z00_1439 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1308z00_1439, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2551z00zz__evaluate_typesz00,
							BGl_proc2550z00zz__evaluate_typesz00,
							BGl_proc2549z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					BgL_arg1608z00_1426 = BgL_v1308z00_1439;
				}
				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1309z00_1450;

					BgL_v1309z00_1450 = create_vector(((long) 0));
					BgL_arg1609z00_1427 = BgL_v1309z00_1450;
				}
				BGl_ev_setlocalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2556z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 37950),
					BGl_proc2555z00zz__evaluate_typesz00,
					BGl_proc2554z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2553z00zz__evaluate_typesz00, BFALSE, BgL_arg1608z00_1426,
					BgL_arg1609z00_1427);
			}
			{	/* Eval/evaluate_types.scm 78 */
				obj_t BgL_arg1632z00_1457;
				obj_t BgL_arg1633z00_1458;

				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1310z00_1472;

					BgL_v1310z00_1472 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1310z00_1472, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2466z00zz__evaluate_typesz00,
							BGl_proc2559z00zz__evaluate_typesz00,
							BGl_proc2558z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1310z00_1472, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2444z00zz__evaluate_typesz00,
							BGl_proc2561z00zz__evaluate_typesz00,
							BGl_proc2560z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2446z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1310z00_1472, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2472z00zz__evaluate_typesz00,
							BGl_proc2563z00zz__evaluate_typesz00,
							BGl_proc2562z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1632z00_1457 = BgL_v1310z00_1472;
				}
				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1311z00_1503;

					BgL_v1311z00_1503 = create_vector(((long) 0));
					BgL_arg1633z00_1458 = BgL_v1311z00_1503;
				}
				BGl_ev_setglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2567z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 62117),
					BGl_proc2566z00zz__evaluate_typesz00,
					BGl_proc2565z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2564z00zz__evaluate_typesz00, BFALSE, BgL_arg1632z00_1457,
					BgL_arg1633z00_1458);
			}
			{	/* Eval/evaluate_types.scm 82 */
				obj_t BgL_arg1664z00_1510;
				obj_t BgL_arg1666z00_1511;

				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1312z00_1525;

					BgL_v1312z00_1525 = create_vector(((long) 0));
					BgL_arg1664z00_1510 = BgL_v1312z00_1525;
				}
				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1313z00_1526;

					BgL_v1313z00_1526 = create_vector(((long) 0));
					BgL_arg1666z00_1511 = BgL_v1313z00_1526;
				}
				BGl_ev_defglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2572z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_setglobalz00zz__evaluate_typesz00, ((long) 36158),
					BGl_proc2571z00zz__evaluate_typesz00,
					BGl_proc2570z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2569z00zz__evaluate_typesz00, BFALSE, BgL_arg1664z00_1510,
					BgL_arg1666z00_1511);
			}
			{	/* Eval/evaluate_types.scm 83 */
				obj_t BgL_arg1675z00_1533;
				obj_t BgL_arg1676z00_1534;

				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1314z00_1546;

					BgL_v1314z00_1546 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1314z00_1546, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2576z00zz__evaluate_typesz00,
							BGl_proc2575z00zz__evaluate_typesz00,
							BGl_proc2574z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1314z00_1546, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2579z00zz__evaluate_typesz00,
							BGl_proc2578z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1675z00_1533 = BgL_v1314z00_1546;
				}
				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1315z00_1567;

					BgL_v1315z00_1567 = create_vector(((long) 0));
					BgL_arg1676z00_1534 = BgL_v1315z00_1567;
				}
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2585z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 10723),
					BGl_proc2584z00zz__evaluate_typesz00,
					BGl_proc2583z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2582z00zz__evaluate_typesz00, BFALSE, BgL_arg1675z00_1533,
					BgL_arg1676z00_1534);
			}
			{	/* Eval/evaluate_types.scm 86 */
				obj_t BgL_arg1695z00_1574;
				obj_t BgL_arg1696z00_1575;

				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1316z00_1587;

					BgL_v1316z00_1587 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1316z00_1587, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2498z00zz__evaluate_typesz00,
							BGl_proc2588z00zz__evaluate_typesz00,
							BGl_proc2587z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1316z00_1587, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2590z00zz__evaluate_typesz00,
							BGl_proc2589z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1695z00_1574 = BgL_v1316z00_1587;
				}
				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1317z00_1608;

					BgL_v1317z00_1608 = create_vector(((long) 0));
					BgL_arg1696z00_1575 = BgL_v1317z00_1608;
				}
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2594z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59644),
					BGl_proc2593z00zz__evaluate_typesz00,
					BGl_proc2592z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2591z00zz__evaluate_typesz00, BFALSE, BgL_arg1695z00_1574,
					BgL_arg1696z00_1575);
			}
			{	/* Eval/evaluate_types.scm 89 */
				obj_t BgL_arg1716z00_1615;
				obj_t BgL_arg1717z00_1616;

				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1318z00_1628;

					BgL_v1318z00_1628 = create_vector(((long) 2));
					VECTOR_SET(BgL_v1318z00_1628, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2598z00zz__evaluate_typesz00,
							BGl_proc2597z00zz__evaluate_typesz00,
							BGl_proc2596z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1318z00_1628, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2601z00zz__evaluate_typesz00,
							BGl_proc2600z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1716z00_1615 = BgL_v1318z00_1628;
				}
				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1319z00_1649;

					BgL_v1319z00_1649 = create_vector(((long) 0));
					BgL_arg1717z00_1616 = BgL_v1319z00_1649;
				}
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2605z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 54033),
					BGl_proc2604z00zz__evaluate_typesz00,
					BGl_proc2603z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2602z00zz__evaluate_typesz00, BFALSE, BgL_arg1716z00_1615,
					BgL_arg1717z00_1616);
			}
			{	/* Eval/evaluate_types.scm 92 */
				obj_t BgL_arg1737z00_1656;
				obj_t BgL_arg1738z00_1657;

				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1320z00_1671;

					BgL_v1320z00_1671 = create_vector(((long) 4));
					VECTOR_SET(BgL_v1320z00_1671, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2466z00zz__evaluate_typesz00,
							BGl_proc2608z00zz__evaluate_typesz00,
							BGl_proc2607z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1320z00_1671, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2611z00zz__evaluate_typesz00,
							BGl_proc2610z00zz__evaluate_typesz00,
							BGl_proc2609z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1320z00_1671, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2615z00zz__evaluate_typesz00,
							BGl_proc2614z00zz__evaluate_typesz00,
							BGl_proc2613z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1320z00_1671, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2618z00zz__evaluate_typesz00,
							BGl_proc2617z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1737z00_1656 = BgL_v1320z00_1671;
				}
				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1321z00_1712;

					BgL_v1321z00_1712 = create_vector(((long) 0));
					BgL_arg1738z00_1657 = BgL_v1321z00_1712;
				}
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2622z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 40653),
					BGl_proc2621z00zz__evaluate_typesz00,
					BGl_proc2620z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2619z00zz__evaluate_typesz00, BFALSE, BgL_arg1737z00_1656,
					BgL_arg1738z00_1657);
			}
			{	/* Eval/evaluate_types.scm 97 */
				obj_t BgL_arg1770z00_1719;
				obj_t BgL_arg1771z00_1720;

				{	/* Eval/evaluate_types.scm 97 */
					obj_t BgL_v1322z00_1733;

					BgL_v1322z00_1733 = create_vector(((long) 3));
					VECTOR_SET(BgL_v1322z00_1733, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2626z00zz__evaluate_typesz00,
							BGl_proc2625z00zz__evaluate_typesz00,
							BGl_proc2624z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1322z00_1733, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2630z00zz__evaluate_typesz00,
							BGl_proc2629z00zz__evaluate_typesz00,
							BGl_proc2628z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1322z00_1733, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2633z00zz__evaluate_typesz00,
							BGl_proc2632z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1770z00_1719 = BgL_v1322z00_1733;
				}
				{	/* Eval/evaluate_types.scm 97 */
					obj_t BgL_v1323z00_1764;

					BgL_v1323z00_1764 = create_vector(((long) 0));
					BgL_arg1771z00_1720 = BgL_v1323z00_1764;
				}
				BGl_ev_binderz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2637z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 50341),
					BGl_proc2636z00zz__evaluate_typesz00,
					BGl_proc2635z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2634z00zz__evaluate_typesz00, BFALSE, BgL_arg1770z00_1719,
					BgL_arg1771z00_1720);
			}
			{	/* Eval/evaluate_types.scm 101 */
				obj_t BgL_arg1800z00_1771;
				obj_t BgL_arg1801z00_1772;

				{	/* Eval/evaluate_types.scm 101 */
					obj_t BgL_v1324z00_1786;

					BgL_v1324z00_1786 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1324z00_1786, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2642z00zz__evaluate_typesz00,
							BGl_proc2641z00zz__evaluate_typesz00,
							BGl_proc2640z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2639z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1800z00_1771 = BgL_v1324z00_1786;
				}
				{	/* Eval/evaluate_types.scm 101 */
					obj_t BgL_v1325z00_1800;

					BgL_v1325z00_1800 = create_vector(((long) 0));
					BgL_arg1801z00_1772 = BgL_v1325z00_1800;
				}
				BGl_ev_letz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2647z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 20484),
					BGl_proc2646z00zz__evaluate_typesz00,
					BGl_proc2645z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2644z00zz__evaluate_typesz00, BFALSE, BgL_arg1800z00_1771,
					BgL_arg1801z00_1772);
			}
			{	/* Eval/evaluate_types.scm 103 */
				obj_t BgL_arg1817z00_1807;
				obj_t BgL_arg1818z00_1808;

				{	/* Eval/evaluate_types.scm 103 */
					obj_t BgL_v1326z00_1822;

					BgL_v1326z00_1822 = create_vector(((long) 1));
					VECTOR_SET(BgL_v1326z00_1822, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2642z00zz__evaluate_typesz00,
							BGl_proc2651z00zz__evaluate_typesz00,
							BGl_proc2650z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2649z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1817z00_1807 = BgL_v1326z00_1822;
				}
				{	/* Eval/evaluate_types.scm 103 */
					obj_t BgL_v1327z00_1836;

					BgL_v1327z00_1836 = create_vector(((long) 0));
					BgL_arg1818z00_1808 = BgL_v1327z00_1836;
				}
				BGl_ev_letza2za2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2655z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 9906),
					BGl_proc2654z00zz__evaluate_typesz00,
					BGl_proc2653z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2652z00zz__evaluate_typesz00, BFALSE, BgL_arg1817z00_1807,
					BgL_arg1818z00_1808);
			}
			{	/* Eval/evaluate_types.scm 105 */
				obj_t BgL_arg1839z00_1843;
				obj_t BgL_arg1840z00_1844;

				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1328z00_1857;

					BgL_v1328z00_1857 = create_vector(((long) 0));
					BgL_arg1839z00_1843 = BgL_v1328z00_1857;
				}
				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1329z00_1858;

					BgL_v1329z00_1858 = create_vector(((long) 0));
					BgL_arg1840z00_1844 = BgL_v1329z00_1858;
				}
				BGl_ev_letrecz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2660z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 43956),
					BGl_proc2659z00zz__evaluate_typesz00,
					BGl_proc2658z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2657z00zz__evaluate_typesz00, BFALSE, BgL_arg1839z00_1843,
					BgL_arg1840z00_1844);
			}
			{	/* Eval/evaluate_types.scm 106 */
				obj_t BgL_arg1850z00_1865;
				obj_t BgL_arg1851z00_1866;

				{	/* Eval/evaluate_types.scm 106 */
					obj_t BgL_v1330z00_1882;

					BgL_v1330z00_1882 = create_vector(((long) 6));
					VECTOR_SET(BgL_v1330z00_1882, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2626z00zz__evaluate_typesz00,
							BGl_proc2663z00zz__evaluate_typesz00,
							BGl_proc2662z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1330z00_1882, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2630z00zz__evaluate_typesz00,
							BGl_proc2665z00zz__evaluate_typesz00,
							BGl_proc2664z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1330z00_1882, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2669z00zz__evaluate_typesz00,
							BGl_proc2668z00zz__evaluate_typesz00,
							BGl_proc2667z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2666z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1330z00_1882, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2674z00zz__evaluate_typesz00,
							BGl_proc2673z00zz__evaluate_typesz00,
							BGl_proc2672z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2671z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1330z00_1882, ((long) 4),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2677z00zz__evaluate_typesz00,
							BGl_proc2676z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1330z00_1882, ((long) 5),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2642z00zz__evaluate_typesz00,
							BGl_proc2680z00zz__evaluate_typesz00,
							BGl_proc2679z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2678z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1850z00_1865 = BgL_v1330z00_1882;
				}
				{	/* Eval/evaluate_types.scm 106 */
					obj_t BgL_v1331z00_1952;

					BgL_v1331z00_1952 = create_vector(((long) 0));
					BgL_arg1851z00_1866 = BgL_v1331z00_1952;
				}
				BGl_ev_labelsz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2684z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 51941),
					BGl_proc2683z00zz__evaluate_typesz00,
					BGl_proc2682z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2681z00zz__evaluate_typesz00, BFALSE, BgL_arg1850z00_1865,
					BgL_arg1851z00_1866);
			}
			{	/* Eval/evaluate_types.scm 114 */
				obj_t BgL_arg1898z00_1959;
				obj_t BgL_arg1899z00_1960;

				{	/* Eval/evaluate_types.scm 114 */
					obj_t BgL_v1332z00_1974;

					BgL_v1332z00_1974 = create_vector(((long) 4));
					VECTOR_SET(BgL_v1332z00_1974, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2466z00zz__evaluate_typesz00,
							BGl_proc2687z00zz__evaluate_typesz00,
							BGl_proc2686z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1332z00_1974, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2690z00zz__evaluate_typesz00,
							BGl_proc2689z00zz__evaluate_typesz00,
							BGl_proc2688z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1332z00_1974, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2694z00zz__evaluate_typesz00,
							BGl_proc2693z00zz__evaluate_typesz00,
							BGl_proc2692z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1332z00_1974, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2507z00zz__evaluate_typesz00,
							BGl_proc2697z00zz__evaluate_typesz00,
							BGl_proc2696z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1898z00_1959 = BgL_v1332z00_1974;
				}
				{	/* Eval/evaluate_types.scm 114 */
					obj_t BgL_v1333z00_2015;

					BgL_v1333z00_2015 = create_vector(((long) 0));
					BgL_arg1899z00_1960 = BgL_v1333z00_2015;
				}
				BGl_ev_gotoz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2701z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 25746),
					BGl_proc2700z00zz__evaluate_typesz00,
					BGl_proc2699z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2698z00zz__evaluate_typesz00, BFALSE, BgL_arg1898z00_1959,
					BgL_arg1899z00_1960);
			}
			{	/* Eval/evaluate_types.scm 119 */
				obj_t BgL_arg1929z00_2022;
				obj_t BgL_arg1930z00_2023;

				{	/* Eval/evaluate_types.scm 119 */
					obj_t BgL_v1334z00_2037;

					BgL_v1334z00_2037 = create_vector(((long) 4));
					VECTOR_SET(BgL_v1334z00_2037, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2466z00zz__evaluate_typesz00,
							BGl_proc2704z00zz__evaluate_typesz00,
							BGl_proc2703z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1334z00_2037, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2707z00zz__evaluate_typesz00,
							BGl_proc2706z00zz__evaluate_typesz00,
							BGl_proc2705z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1334z00_2037, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2507z00zz__evaluate_typesz00,
							BGl_proc2710z00zz__evaluate_typesz00,
							BGl_proc2709z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1334z00_2037, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2713z00zz__evaluate_typesz00,
							BGl_proc2712z00zz__evaluate_typesz00,
							BGl_proc2711z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1929z00_2022 = BgL_v1334z00_2037;
				}
				{	/* Eval/evaluate_types.scm 119 */
					obj_t BgL_v1335z00_2078;

					BgL_v1335z00_2078 = create_vector(((long) 0));
					BgL_arg1930z00_2023 = BgL_v1335z00_2078;
				}
				BGl_ev_appz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2718z00zz__evaluate_typesz00,
					BGl_symbol2440z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 55822),
					BGl_proc2717z00zz__evaluate_typesz00,
					BGl_proc2716z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2715z00zz__evaluate_typesz00, BFALSE, BgL_arg1929z00_2022,
					BgL_arg1930z00_2023);
			}
			{	/* Eval/evaluate_types.scm 122 */
				obj_t BgL_arg1961z00_2085;
				obj_t BgL_arg1962z00_2086;

				{	/* Eval/evaluate_types.scm 122 */
					obj_t BgL_v1336z00_2106;

					BgL_v1336z00_2106 = create_vector(((long) 10));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 0),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2466z00zz__evaluate_typesz00,
							BGl_proc2721z00zz__evaluate_typesz00,
							BGl_proc2720z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 1),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2724z00zz__evaluate_typesz00,
							BGl_proc2723z00zz__evaluate_typesz00,
							BGl_proc2722z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 2),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2728z00zz__evaluate_typesz00,
							BGl_proc2727z00zz__evaluate_typesz00,
							BGl_proc2726z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 3),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2626z00zz__evaluate_typesz00,
							BGl_proc2731z00zz__evaluate_typesz00,
							BGl_proc2730z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 4),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2580z00zz__evaluate_typesz00,
							BGl_proc2733z00zz__evaluate_typesz00,
							BGl_proc2732z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 5),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2737z00zz__evaluate_typesz00,
							BGl_proc2736z00zz__evaluate_typesz00,
							BGl_proc2735z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2734z00zz__evaluate_typesz00,
							BGl_symbol2739z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 6),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2744z00zz__evaluate_typesz00,
							BGl_proc2743z00zz__evaluate_typesz00,
							BGl_proc2742z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2741z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 7),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2749z00zz__evaluate_typesz00,
							BGl_proc2748z00zz__evaluate_typesz00,
							BGl_proc2747z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2746z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 8),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2754z00zz__evaluate_typesz00,
							BGl_proc2753z00zz__evaluate_typesz00,
							BGl_proc2752z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2751z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1336z00_2106, ((long) 9),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2642z00zz__evaluate_typesz00,
							BGl_proc2758z00zz__evaluate_typesz00,
							BGl_proc2757z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2756z00zz__evaluate_typesz00,
							BGl_symbol2453z00zz__evaluate_typesz00));
					BgL_arg1961z00_2085 = BgL_v1336z00_2106;
				}
				{	/* Eval/evaluate_types.scm 122 */
					obj_t BgL_v1337z00_2222;

					BgL_v1337z00_2222 = create_vector(((long) 0));
					BgL_arg1962z00_2086 = BgL_v1337z00_2222;
				}
				return (BGl_ev_absz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2762z00zz__evaluate_typesz00,
						BGl_symbol2440z00zz__evaluate_typesz00,
						BGl_ev_exprz00zz__evaluate_typesz00, ((long) 22827),
						BGl_proc2761z00zz__evaluate_typesz00,
						BGl_proc2760z00zz__evaluate_typesz00, BFALSE,
						BGl_proc2759z00zz__evaluate_typesz00, BFALSE, BgL_arg1961z00_2085,
						BgL_arg1962z00_2086), BUNSPEC);
		}}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1967> */
	obj_t BGl_z62zc3anonymousza31967ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3503, obj_t BgL_new1193z00_3504)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			{
				BgL_ev_absz00_bglt BgL_auxz00_4685;

				((((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_new1193z00_3504)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_wherez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_arityz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4694;

					{	/* Eval/evaluate_types.scm 122 */
						obj_t BgL_classz00_3979;

						BgL_classz00_3979 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 122 */
							obj_t BgL__ortest_1285z00_3980;

							BgL__ortest_1285z00_3980 = BGL_CLASS_NIL(BgL_classz00_3979);
							if (CBOOL(BgL__ortest_1285z00_3980))
								{	/* Eval/evaluate_types.scm 122 */
									BgL_auxz00_4694 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_3980);
								}
							else
								{	/* Eval/evaluate_types.scm 122 */
									BgL_auxz00_4694 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_3979));
								}
						}
					}
					((((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_new1193z00_3504)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4694), BUNSPEC);
				}
				((((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_new1193z00_3504)))->BgL_siza7eza7) =
					((int) (int) (((long) 0))), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_bindz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_freez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_innerz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) COBJECT(((BgL_ev_absz00_bglt)
									BgL_new1193z00_3504)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4685 = ((BgL_ev_absz00_bglt) BgL_new1193z00_3504);
				return ((obj_t) BgL_auxz00_4685);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1965 */
	BgL_ev_absz00_bglt BGl_z62lambda1965z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3505)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				BgL_ev_absz00_bglt BgL_new1192z00_3981;

				BgL_new1192z00_3981 =
					((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_absz00_bgl))));
				{	/* Eval/evaluate_types.scm 122 */
					long BgL_arg1966z00_3982;

					{	/* Eval/evaluate_types.scm 122 */
						long BgL_res2384z00_3983;

						BgL_res2384z00_3983 =
							BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
						BgL_arg1966z00_3982 = BgL_res2384z00_3983;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1192z00_3981), BgL_arg1966z00_3982);
				}
				return BgL_new1192z00_3981;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1963 */
	BgL_ev_absz00_bglt BGl_z62lambda1963z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3506, obj_t BgL_loc1182z00_3507, obj_t BgL_where1183z00_3508,
		obj_t BgL_arity1184z00_3509, obj_t BgL_vars1185z00_3510,
		obj_t BgL_body1186z00_3511, obj_t BgL_siza7e1187za7_3512,
		obj_t BgL_bind1188z00_3513, obj_t BgL_free1189z00_3514,
		obj_t BgL_inner1190z00_3515, obj_t BgL_boxes1191z00_3516)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				int BgL_siza7e1187za7_3985;

				BgL_siza7e1187za7_3985 = CINT(BgL_siza7e1187za7_3512);
				{	/* Eval/evaluate_types.scm 122 */
					BgL_ev_absz00_bglt BgL_new1246z00_3986;

					{	/* Eval/evaluate_types.scm 122 */
						BgL_ev_absz00_bglt BgL_new1245z00_3987;

						BgL_new1245z00_3987 =
							((BgL_ev_absz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_ev_absz00_bgl))));
						{	/* Eval/evaluate_types.scm 122 */
							long BgL_arg1964z00_3988;

							{	/* Eval/evaluate_types.scm 122 */
								long BgL_res2383z00_3989;

								BgL_res2383z00_3989 =
									BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
								BgL_arg1964z00_3988 = BgL_res2383z00_3989;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1245z00_3987),
								BgL_arg1964z00_3988);
						}
						BgL_new1246z00_3986 = BgL_new1245z00_3987;
					}
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_locz00) =
						((obj_t) BgL_loc1182z00_3507), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_wherez00) =
						((obj_t) BgL_where1183z00_3508), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_arityz00) =
						((obj_t) BgL_arity1184z00_3509), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_varsz00) =
						((obj_t) BgL_vars1185z00_3510), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
								BgL_body1186z00_3511)), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->
							BgL_siza7eza7) = ((int) BgL_siza7e1187za7_3985), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_bindz00) =
						((obj_t) BgL_bind1188z00_3513), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_freez00) =
						((obj_t) BgL_free1189z00_3514), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_innerz00) =
						((obj_t) BgL_inner1190z00_3515), BUNSPEC);
					((((BgL_ev_absz00_bglt) COBJECT(BgL_new1246z00_3986))->BgL_boxesz00) =
						((obj_t) BgL_boxes1191z00_3516), BUNSPEC);
					return BgL_new1246z00_3986;
				}
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2033> */
	obj_t BGl_z62zc3anonymousza32033ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3517)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda2032 */
	obj_t BGl_z62lambda2032z62zz__evaluate_typesz00(obj_t BgL_envz00_3518,
		obj_t BgL_oz00_3519, obj_t BgL_vz00_3520)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3519)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3520), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda2031 */
	obj_t BGl_z62lambda2031z62zz__evaluate_typesz00(obj_t BgL_envz00_3521,
		obj_t BgL_oz00_3522)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3522)))->BgL_boxesz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2026> */
	obj_t BGl_z62zc3anonymousza32026ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3523)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda2025 */
	obj_t BGl_z62lambda2025z62zz__evaluate_typesz00(obj_t BgL_envz00_3524,
		obj_t BgL_oz00_3525, obj_t BgL_vz00_3526)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3525)))->BgL_innerz00) =
				((obj_t) BgL_vz00_3526), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda2024 */
	obj_t BGl_z62lambda2024z62zz__evaluate_typesz00(obj_t BgL_envz00_3527,
		obj_t BgL_oz00_3528)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3528)))->BgL_innerz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2017> */
	obj_t BGl_z62zc3anonymousza32017ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3529)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda2016 */
	obj_t BGl_z62lambda2016z62zz__evaluate_typesz00(obj_t BgL_envz00_3530,
		obj_t BgL_oz00_3531, obj_t BgL_vz00_3532)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3531)))->BgL_freez00) =
				((obj_t) BgL_vz00_3532), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda2015 */
	obj_t BGl_z62lambda2015z62zz__evaluate_typesz00(obj_t BgL_envz00_3533,
		obj_t BgL_oz00_3534)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3534)))->BgL_freez00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2009> */
	obj_t BGl_z62zc3anonymousza32009ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3535)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda2008 */
	obj_t BGl_z62lambda2008z62zz__evaluate_typesz00(obj_t BgL_envz00_3536,
		obj_t BgL_oz00_3537, obj_t BgL_vz00_3538)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3537)))->BgL_bindz00) =
				((obj_t) BgL_vz00_3538), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda2007 */
	obj_t BGl_z62lambda2007z62zz__evaluate_typesz00(obj_t BgL_envz00_3539,
		obj_t BgL_oz00_3540)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3540)))->BgL_bindz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:2001> */
	obj_t BGl_z62zc3anonymousza32001ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3541)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return BINT(((long) 0));
		}
		BGL_FUNCTION_END;
	}



/* &lambda2000 */
	obj_t BGl_z62lambda2000z62zz__evaluate_typesz00(obj_t BgL_envz00_3542,
		obj_t BgL_oz00_3543, obj_t BgL_vz00_3544)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			{	/* Eval/evaluate_types.scm 122 */
				int BgL_vz00_3999;

				BgL_vz00_3999 = CINT(BgL_vz00_3544);
				return
					((((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_oz00_3543)))->BgL_siza7eza7) =
					((int) BgL_vz00_3999), BUNSPEC);
		}}
		BGL_FUNCTION_END;
	}



/* &lambda1999 */
	obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t BgL_envz00_3545,
		obj_t BgL_oz00_3546)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				BINT(
				(((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3546)))->BgL_siza7eza7));
		}
		BGL_FUNCTION_END;
	}



/* &lambda1993 */
	obj_t BGl_z62lambda1993z62zz__evaluate_typesz00(obj_t BgL_envz00_3547,
		obj_t BgL_oz00_3548, obj_t BgL_vz00_3549)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3548)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3549)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1992 */
	BgL_ev_exprz00_bglt BGl_z62lambda1992z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3550, obj_t BgL_oz00_3551)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3551)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1988 */
	obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t BgL_envz00_3552,
		obj_t BgL_oz00_3553, obj_t BgL_vz00_3554)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3553)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3554), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1987 */
	obj_t BGl_z62lambda1987z62zz__evaluate_typesz00(obj_t BgL_envz00_3555,
		obj_t BgL_oz00_3556)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3556)))->BgL_varsz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1983 */
	obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t BgL_envz00_3557,
		obj_t BgL_oz00_3558, obj_t BgL_vz00_3559)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3558)))->BgL_arityz00) =
				((obj_t) BgL_vz00_3559), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1982 */
	obj_t BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t BgL_envz00_3560,
		obj_t BgL_oz00_3561)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3561)))->BgL_arityz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1978 */
	obj_t BGl_z62lambda1978z62zz__evaluate_typesz00(obj_t BgL_envz00_3562,
		obj_t BgL_oz00_3563, obj_t BgL_vz00_3564)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3563)))->BgL_wherez00) =
				((obj_t) BgL_vz00_3564), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1977 */
	obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t BgL_envz00_3565,
		obj_t BgL_oz00_3566)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3566)))->BgL_wherez00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1972 */
	obj_t BGl_z62lambda1972z62zz__evaluate_typesz00(obj_t BgL_envz00_3567,
		obj_t BgL_oz00_3568, obj_t BgL_vz00_3569)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				((((BgL_ev_absz00_bglt) COBJECT(
							((BgL_ev_absz00_bglt) BgL_oz00_3568)))->BgL_locz00) =
				((obj_t) BgL_vz00_3569), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1971 */
	obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t BgL_envz00_3570,
		obj_t BgL_oz00_3571)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 122 */
			return
				(((BgL_ev_absz00_bglt) COBJECT(
						((BgL_ev_absz00_bglt) BgL_oz00_3571)))->BgL_locz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1935> */
	obj_t BGl_z62zc3anonymousza31935ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3572, obj_t BgL_new1180z00_3573)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			{
				BgL_ev_appz00_bglt BgL_auxz00_4780;

				((((BgL_ev_appz00_bglt) COBJECT(
								((BgL_ev_appz00_bglt) BgL_new1180z00_3573)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4783;

					{	/* Eval/evaluate_types.scm 119 */
						obj_t BgL_classz00_4013;

						BgL_classz00_4013 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 119 */
							obj_t BgL__ortest_1285z00_4014;

							BgL__ortest_1285z00_4014 = BGL_CLASS_NIL(BgL_classz00_4013);
							if (CBOOL(BgL__ortest_1285z00_4014))
								{	/* Eval/evaluate_types.scm 119 */
									BgL_auxz00_4783 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4014);
								}
							else
								{	/* Eval/evaluate_types.scm 119 */
									BgL_auxz00_4783 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4013));
								}
						}
					}
					((((BgL_ev_appz00_bglt) COBJECT(
									((BgL_ev_appz00_bglt) BgL_new1180z00_3573)))->BgL_funz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4783), BUNSPEC);
				}
				((((BgL_ev_appz00_bglt) COBJECT(
								((BgL_ev_appz00_bglt) BgL_new1180z00_3573)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
									BgL_new1180z00_3573)))->BgL_tailzf3zf3) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4780 = ((BgL_ev_appz00_bglt) BgL_new1180z00_3573);
				return ((obj_t) BgL_auxz00_4780);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1933 */
	BgL_ev_appz00_bglt BGl_z62lambda1933z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3574)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			{	/* Eval/evaluate_types.scm 119 */
				BgL_ev_appz00_bglt BgL_new1179z00_4015;

				BgL_new1179z00_4015 =
					((BgL_ev_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_appz00_bgl))));
				{	/* Eval/evaluate_types.scm 119 */
					long BgL_arg1934z00_4016;

					{	/* Eval/evaluate_types.scm 119 */
						long BgL_res2382z00_4017;

						BgL_res2382z00_4017 =
							BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
						BgL_arg1934z00_4016 = BgL_res2382z00_4017;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1179z00_4015), BgL_arg1934z00_4016);
				}
				return BgL_new1179z00_4015;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1931 */
	BgL_ev_appz00_bglt BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3575, obj_t BgL_loc1174z00_3576, obj_t BgL_fun1176z00_3577,
		obj_t BgL_args1177z00_3578, obj_t BgL_tailzf31178zf3_3579)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			{	/* Eval/evaluate_types.scm 119 */
				BgL_ev_appz00_bglt BgL_new1243z00_4019;

				{	/* Eval/evaluate_types.scm 119 */
					BgL_ev_appz00_bglt BgL_new1242z00_4020;

					BgL_new1242z00_4020 =
						((BgL_ev_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_appz00_bgl))));
					{	/* Eval/evaluate_types.scm 119 */
						long BgL_arg1932z00_4021;

						{	/* Eval/evaluate_types.scm 119 */
							long BgL_res2381z00_4022;

							BgL_res2381z00_4022 =
								BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
							BgL_arg1932z00_4021 = BgL_res2381z00_4022;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1242z00_4020), BgL_arg1932z00_4021);
					}
					BgL_new1243z00_4019 = BgL_new1242z00_4020;
				}
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1243z00_4019))->BgL_locz00) =
					((obj_t) BgL_loc1174z00_3576), BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1243z00_4019))->BgL_funz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_fun1176z00_3577)),
					BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1243z00_4019))->BgL_argsz00) =
					((obj_t) BgL_args1177z00_3578), BUNSPEC);
				((((BgL_ev_appz00_bglt) COBJECT(BgL_new1243z00_4019))->BgL_tailzf3zf3) =
					((obj_t) BgL_tailzf31178zf3_3579), BUNSPEC);
				return BgL_new1243z00_4019;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1957 */
	obj_t BGl_z62lambda1957z62zz__evaluate_typesz00(obj_t BgL_envz00_3580,
		obj_t BgL_oz00_3581, obj_t BgL_vz00_3582)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3581)))->BgL_tailzf3zf3) =
				((obj_t) BgL_vz00_3582), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1956 */
	obj_t BGl_z62lambda1956z62zz__evaluate_typesz00(obj_t BgL_envz00_3583,
		obj_t BgL_oz00_3584)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3584)))->BgL_tailzf3zf3);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1952 */
	obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t BgL_envz00_3585,
		obj_t BgL_oz00_3586, obj_t BgL_vz00_3587)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3586)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3587), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1951 */
	obj_t BGl_z62lambda1951z62zz__evaluate_typesz00(obj_t BgL_envz00_3588,
		obj_t BgL_oz00_3589)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3589)))->BgL_argsz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1946 */
	obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t BgL_envz00_3590,
		obj_t BgL_oz00_3591, obj_t BgL_vz00_3592)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3591)))->BgL_funz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3592)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1945 */
	BgL_ev_exprz00_bglt BGl_z62lambda1945z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3593, obj_t BgL_oz00_3594)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3594)))->BgL_funz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1940 */
	obj_t BGl_z62lambda1940z62zz__evaluate_typesz00(obj_t BgL_envz00_3595,
		obj_t BgL_oz00_3596, obj_t BgL_vz00_3597)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				((((BgL_ev_appz00_bglt) COBJECT(
							((BgL_ev_appz00_bglt) BgL_oz00_3596)))->BgL_locz00) =
				((obj_t) BgL_vz00_3597), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1939 */
	obj_t BGl_z62lambda1939z62zz__evaluate_typesz00(obj_t BgL_envz00_3598,
		obj_t BgL_oz00_3599)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 119 */
			return
				(((BgL_ev_appz00_bglt) COBJECT(
						((BgL_ev_appz00_bglt) BgL_oz00_3599)))->BgL_locz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1904> */
	obj_t BGl_z62zc3anonymousza31904ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3600, obj_t BgL_new1172z00_3601)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			{
				BgL_ev_gotoz00_bglt BgL_auxz00_4828;

				((((BgL_ev_gotoz00_bglt) COBJECT(
								((BgL_ev_gotoz00_bglt) BgL_new1172z00_3601)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_varz00_bglt BgL_auxz00_4831;

					{	/* Eval/evaluate_types.scm 114 */
						obj_t BgL_classz00_4033;

						BgL_classz00_4033 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 114 */
							obj_t BgL__ortest_1285z00_4034;

							BgL__ortest_1285z00_4034 = BGL_CLASS_NIL(BgL_classz00_4033);
							if (CBOOL(BgL__ortest_1285z00_4034))
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4831 =
										((BgL_ev_varz00_bglt) BgL__ortest_1285z00_4034);
								}
							else
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4831 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4033));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_new1172z00_3601)))->BgL_labelz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_4831), BUNSPEC);
				}
				{
					BgL_ev_labelsz00_bglt BgL_auxz00_4840;

					{	/* Eval/evaluate_types.scm 114 */
						obj_t BgL_classz00_4035;

						BgL_classz00_4035 = BGl_ev_labelsz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 114 */
							obj_t BgL__ortest_1285z00_4036;

							BgL__ortest_1285z00_4036 = BGL_CLASS_NIL(BgL_classz00_4035);
							if (CBOOL(BgL__ortest_1285z00_4036))
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4840 =
										((BgL_ev_labelsz00_bglt) BgL__ortest_1285z00_4036);
								}
							else
								{	/* Eval/evaluate_types.scm 114 */
									BgL_auxz00_4840 =
										((BgL_ev_labelsz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4035));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_new1172z00_3601)))->
							BgL_labelsz00) =
						((BgL_ev_labelsz00_bglt) BgL_auxz00_4840), BUNSPEC);
				}
				((((BgL_ev_gotoz00_bglt) COBJECT(
								((BgL_ev_gotoz00_bglt) BgL_new1172z00_3601)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4828 = ((BgL_ev_gotoz00_bglt) BgL_new1172z00_3601);
				return ((obj_t) BgL_auxz00_4828);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1902 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3602)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			{	/* Eval/evaluate_types.scm 114 */
				BgL_ev_gotoz00_bglt BgL_new1171z00_4037;

				BgL_new1171z00_4037 =
					((BgL_ev_gotoz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_gotoz00_bgl))));
				{	/* Eval/evaluate_types.scm 114 */
					long BgL_arg1903z00_4038;

					{	/* Eval/evaluate_types.scm 114 */
						long BgL_res2380z00_4039;

						BgL_res2380z00_4039 =
							BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
						BgL_arg1903z00_4038 = BgL_res2380z00_4039;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1171z00_4037), BgL_arg1903z00_4038);
				}
				return BgL_new1171z00_4037;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1900 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1900z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3603, obj_t BgL_loc1167z00_3604, obj_t BgL_label1168z00_3605,
		obj_t BgL_labels1169z00_3606, obj_t BgL_args1170z00_3607)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			{	/* Eval/evaluate_types.scm 114 */
				BgL_ev_gotoz00_bglt BgL_new1241z00_4042;

				{	/* Eval/evaluate_types.scm 114 */
					BgL_ev_gotoz00_bglt BgL_new1240z00_4043;

					BgL_new1240z00_4043 =
						((BgL_ev_gotoz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_gotoz00_bgl))));
					{	/* Eval/evaluate_types.scm 114 */
						long BgL_arg1901z00_4044;

						{	/* Eval/evaluate_types.scm 114 */
							long BgL_res2379z00_4045;

							BgL_res2379z00_4045 =
								BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
							BgL_arg1901z00_4044 = BgL_res2379z00_4045;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1240z00_4043), BgL_arg1901z00_4044);
					}
					BgL_new1241z00_4042 = BgL_new1240z00_4043;
				}
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1241z00_4042))->BgL_locz00) =
					((obj_t) BgL_loc1167z00_3604), BUNSPEC);
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1241z00_4042))->BgL_labelz00) =
					((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_label1168z00_3605)),
					BUNSPEC);
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1241z00_4042))->BgL_labelsz00) =
					((BgL_ev_labelsz00_bglt) ((BgL_ev_labelsz00_bglt)
							BgL_labels1169z00_3606)), BUNSPEC);
				((((BgL_ev_gotoz00_bglt) COBJECT(BgL_new1241z00_4042))->BgL_argsz00) =
					((obj_t) BgL_args1170z00_3607), BUNSPEC);
				return BgL_new1241z00_4042;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1925 */
	obj_t BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t BgL_envz00_3608,
		obj_t BgL_oz00_3609, obj_t BgL_vz00_3610)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3609)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3610), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1924 */
	obj_t BGl_z62lambda1924z62zz__evaluate_typesz00(obj_t BgL_envz00_3611,
		obj_t BgL_oz00_3612)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3612)))->BgL_argsz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1920 */
	obj_t BGl_z62lambda1920z62zz__evaluate_typesz00(obj_t BgL_envz00_3613,
		obj_t BgL_oz00_3614, obj_t BgL_vz00_3615)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3614)))->BgL_labelsz00) =
				((BgL_ev_labelsz00_bglt) ((BgL_ev_labelsz00_bglt) BgL_vz00_3615)),
				BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1919 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1919z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3616, obj_t BgL_oz00_3617)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3617)))->BgL_labelsz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1914 */
	obj_t BGl_z62lambda1914z62zz__evaluate_typesz00(obj_t BgL_envz00_3618,
		obj_t BgL_oz00_3619, obj_t BgL_vz00_3620)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3619)))->BgL_labelz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3620)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1913 */
	BgL_ev_varz00_bglt BGl_z62lambda1913z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3621, obj_t BgL_oz00_3622)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3622)))->BgL_labelz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1909 */
	obj_t BGl_z62lambda1909z62zz__evaluate_typesz00(obj_t BgL_envz00_3623,
		obj_t BgL_oz00_3624, obj_t BgL_vz00_3625)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				((((BgL_ev_gotoz00_bglt) COBJECT(
							((BgL_ev_gotoz00_bglt) BgL_oz00_3624)))->BgL_locz00) =
				((obj_t) BgL_vz00_3625), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1908 */
	obj_t BGl_z62lambda1908z62zz__evaluate_typesz00(obj_t BgL_envz00_3626,
		obj_t BgL_oz00_3627)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 114 */
			return
				(((BgL_ev_gotoz00_bglt) COBJECT(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3627)))->BgL_locz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1856> */
	obj_t BGl_z62zc3anonymousza31856ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3628, obj_t BgL_new1165z00_3629)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			{
				BgL_ev_labelsz00_bglt BgL_auxz00_4885;

				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_new1165z00_3629)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(((BgL_ev_labelsz00_bglt)
									BgL_new1165z00_3629)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(((BgL_ev_labelsz00_bglt)
									BgL_new1165z00_3629)))->BgL_envz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(((BgL_ev_labelsz00_bglt)
									BgL_new1165z00_3629)))->BgL_stkz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4894;

					{	/* Eval/evaluate_types.scm 106 */
						obj_t BgL_classz00_4057;

						BgL_classz00_4057 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 106 */
							obj_t BgL__ortest_1285z00_4058;

							BgL__ortest_1285z00_4058 = BGL_CLASS_NIL(BgL_classz00_4057);
							if (CBOOL(BgL__ortest_1285z00_4058))
								{	/* Eval/evaluate_types.scm 106 */
									BgL_auxz00_4894 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4058);
								}
							else
								{	/* Eval/evaluate_types.scm 106 */
									BgL_auxz00_4894 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4057));
								}
						}
					}
					((((BgL_ev_labelsz00_bglt) COBJECT(
									((BgL_ev_labelsz00_bglt) BgL_new1165z00_3629)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4894), BUNSPEC);
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_new1165z00_3629)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4885 = ((BgL_ev_labelsz00_bglt) BgL_new1165z00_3629);
				return ((obj_t) BgL_auxz00_4885);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1854 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1854z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3630)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			{	/* Eval/evaluate_types.scm 106 */
				BgL_ev_labelsz00_bglt BgL_new1164z00_4059;

				BgL_new1164z00_4059 =
					((BgL_ev_labelsz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_labelsz00_bgl))));
				{	/* Eval/evaluate_types.scm 106 */
					long BgL_arg1855z00_4060;

					{	/* Eval/evaluate_types.scm 106 */
						long BgL_res2378z00_4061;

						BgL_res2378z00_4061 =
							BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
						BgL_arg1855z00_4060 = BgL_res2378z00_4061;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1164z00_4059), BgL_arg1855z00_4060);
				}
				return BgL_new1164z00_4059;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1852 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3631, obj_t BgL_vars1158z00_3632, obj_t BgL_vals1159z00_3633,
		obj_t BgL_env1160z00_3634, obj_t BgL_stk1161z00_3635,
		obj_t BgL_body1162z00_3636, obj_t BgL_boxes1163z00_3637)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			{	/* Eval/evaluate_types.scm 106 */
				BgL_ev_labelsz00_bglt BgL_new1239z00_4063;

				{	/* Eval/evaluate_types.scm 106 */
					BgL_ev_labelsz00_bglt BgL_new1238z00_4064;

					BgL_new1238z00_4064 =
						((BgL_ev_labelsz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_labelsz00_bgl))));
					{	/* Eval/evaluate_types.scm 106 */
						long BgL_arg1853z00_4065;

						{	/* Eval/evaluate_types.scm 106 */
							long BgL_res2377z00_4066;

							BgL_res2377z00_4066 =
								BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
							BgL_arg1853z00_4065 = BgL_res2377z00_4066;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1238z00_4064), BgL_arg1853z00_4065);
					}
					BgL_new1239z00_4063 = BgL_new1238z00_4064;
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1239z00_4063))->BgL_varsz00) =
					((obj_t) BgL_vars1158z00_3632), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1239z00_4063))->BgL_valsz00) =
					((obj_t) BgL_vals1159z00_3633), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1239z00_4063))->BgL_envz00) =
					((obj_t) BgL_env1160z00_3634), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1239z00_4063))->BgL_stkz00) =
					((obj_t) BgL_stk1161z00_3635), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1239z00_4063))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1162z00_3636)),
					BUNSPEC);
				((((BgL_ev_labelsz00_bglt) COBJECT(BgL_new1239z00_4063))->
						BgL_boxesz00) = ((obj_t) BgL_boxes1163z00_3637), BUNSPEC);
				return BgL_new1239z00_4063;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1894> */
	obj_t BGl_z62zc3anonymousza31894ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3638)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda1893 */
	obj_t BGl_z62lambda1893z62zz__evaluate_typesz00(obj_t BgL_envz00_3639,
		obj_t BgL_oz00_3640, obj_t BgL_vz00_3641)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3640)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3641), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1892 */
	obj_t BGl_z62lambda1892z62zz__evaluate_typesz00(obj_t BgL_envz00_3642,
		obj_t BgL_oz00_3643)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3643)))->BgL_boxesz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1886 */
	obj_t BGl_z62lambda1886z62zz__evaluate_typesz00(obj_t BgL_envz00_3644,
		obj_t BgL_oz00_3645, obj_t BgL_vz00_3646)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3645)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3646)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1885 */
	BgL_ev_exprz00_bglt BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3647, obj_t BgL_oz00_3648)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3648)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1881> */
	obj_t BGl_z62zc3anonymousza31881ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3649)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda1880 */
	obj_t BGl_z62lambda1880z62zz__evaluate_typesz00(obj_t BgL_envz00_3650,
		obj_t BgL_oz00_3651, obj_t BgL_vz00_3652)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3651)))->BgL_stkz00) =
				((obj_t) BgL_vz00_3652), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1879 */
	obj_t BGl_z62lambda1879z62zz__evaluate_typesz00(obj_t BgL_envz00_3653,
		obj_t BgL_oz00_3654)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3654)))->BgL_stkz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1874> */
	obj_t BGl_z62zc3anonymousza31874ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3655)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda1873 */
	obj_t BGl_z62lambda1873z62zz__evaluate_typesz00(obj_t BgL_envz00_3656,
		obj_t BgL_oz00_3657, obj_t BgL_vz00_3658)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3657)))->BgL_envz00) =
				((obj_t) BgL_vz00_3658), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1872 */
	obj_t BGl_z62lambda1872z62zz__evaluate_typesz00(obj_t BgL_envz00_3659,
		obj_t BgL_oz00_3660)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3660)))->BgL_envz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1867 */
	obj_t BGl_z62lambda1867z62zz__evaluate_typesz00(obj_t BgL_envz00_3661,
		obj_t BgL_oz00_3662, obj_t BgL_vz00_3663)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3662)))->BgL_valsz00) =
				((obj_t) BgL_vz00_3663), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1866 */
	obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t BgL_envz00_3664,
		obj_t BgL_oz00_3665)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3665)))->BgL_valsz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1862 */
	obj_t BGl_z62lambda1862z62zz__evaluate_typesz00(obj_t BgL_envz00_3666,
		obj_t BgL_oz00_3667, obj_t BgL_vz00_3668)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_oz00_3667)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3668), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1861 */
	obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t BgL_envz00_3669,
		obj_t BgL_oz00_3670)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 106 */
			return
				(((BgL_ev_labelsz00_bglt) COBJECT(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3670)))->BgL_varsz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1845> */
	obj_t BGl_z62zc3anonymousza31845ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3671, obj_t BgL_new1156z00_3672)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 105 */
			{
				BgL_ev_letrecz00_bglt BgL_auxz00_4947;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_new1156z00_3672))))->
						BgL_varsz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt)
							COBJECT(((BgL_ev_binderz00_bglt) ((BgL_ev_letrecz00_bglt)
										BgL_new1156z00_3672))))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4954;

					{	/* Eval/evaluate_types.scm 105 */
						obj_t BgL_classz00_4081;

						BgL_classz00_4081 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 105 */
							obj_t BgL__ortest_1285z00_4082;

							BgL__ortest_1285z00_4082 = BGL_CLASS_NIL(BgL_classz00_4081);
							if (CBOOL(BgL__ortest_1285z00_4082))
								{	/* Eval/evaluate_types.scm 105 */
									BgL_auxz00_4954 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4082);
								}
							else
								{	/* Eval/evaluate_types.scm 105 */
									BgL_auxz00_4954 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4081));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_new1156z00_3672))))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4954), BUNSPEC);
				}
				BgL_auxz00_4947 = ((BgL_ev_letrecz00_bglt) BgL_new1156z00_3672);
				return ((obj_t) BgL_auxz00_4947);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1843 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1843z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3673)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_letrecz00_bglt BgL_new1155z00_4083;

				BgL_new1155z00_4083 =
					((BgL_ev_letrecz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_letrecz00_bgl))));
				{	/* Eval/evaluate_types.scm 105 */
					long BgL_arg1844z00_4084;

					{	/* Eval/evaluate_types.scm 105 */
						long BgL_res2376z00_4085;

						BgL_res2376z00_4085 =
							BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
						BgL_arg1844z00_4084 = BgL_res2376z00_4085;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1155z00_4083), BgL_arg1844z00_4084);
				}
				return BgL_new1155z00_4083;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1841 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1841z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3674, obj_t BgL_vars1151z00_3675, obj_t BgL_vals1152z00_3676,
		obj_t BgL_body1153z00_3677)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_letrecz00_bglt BgL_new1237z00_4087;

				{	/* Eval/evaluate_types.scm 105 */
					BgL_ev_letrecz00_bglt BgL_new1236z00_4088;

					BgL_new1236z00_4088 =
						((BgL_ev_letrecz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_letrecz00_bgl))));
					{	/* Eval/evaluate_types.scm 105 */
						long BgL_arg1842z00_4089;

						{	/* Eval/evaluate_types.scm 105 */
							long BgL_res2375z00_4090;

							BgL_res2375z00_4090 =
								BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
							BgL_arg1842z00_4089 = BgL_res2375z00_4090;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1236z00_4088), BgL_arg1842z00_4089);
					}
					BgL_new1237z00_4087 = BgL_new1236z00_4088;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1237z00_4087)))->BgL_varsz00) =
					((obj_t) BgL_vars1151z00_3675), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1237z00_4087)))->BgL_valsz00) =
					((obj_t) BgL_vals1152z00_3676), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1237z00_4087)))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1153z00_3677)),
					BUNSPEC);
				return BgL_new1237z00_4087;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1823> */
	obj_t BGl_z62zc3anonymousza31823ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3678, obj_t BgL_new1149z00_3679)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 103 */
			{
				BgL_ev_letza2za2_bglt BgL_auxz00_4981;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_new1149z00_3679))))->
						BgL_varsz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt)
							COBJECT(((BgL_ev_binderz00_bglt) ((BgL_ev_letza2za2_bglt)
										BgL_new1149z00_3679))))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4988;

					{	/* Eval/evaluate_types.scm 103 */
						obj_t BgL_classz00_4092;

						BgL_classz00_4092 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 103 */
							obj_t BgL__ortest_1285z00_4093;

							BgL__ortest_1285z00_4093 = BGL_CLASS_NIL(BgL_classz00_4092);
							if (CBOOL(BgL__ortest_1285z00_4093))
								{	/* Eval/evaluate_types.scm 103 */
									BgL_auxz00_4988 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4093);
								}
							else
								{	/* Eval/evaluate_types.scm 103 */
									BgL_auxz00_4988 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4092));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_new1149z00_3679))))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4988), BUNSPEC);
				}
				((((BgL_ev_letza2za2_bglt) COBJECT(
								((BgL_ev_letza2za2_bglt) BgL_new1149z00_3679)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_4981 = ((BgL_ev_letza2za2_bglt) BgL_new1149z00_3679);
				return ((obj_t) BgL_auxz00_4981);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1821 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1821z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3680)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 103 */
			{	/* Eval/evaluate_types.scm 103 */
				BgL_ev_letza2za2_bglt BgL_new1148z00_4094;

				BgL_new1148z00_4094 =
					((BgL_ev_letza2za2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_letza2za2_bgl))));
				{	/* Eval/evaluate_types.scm 103 */
					long BgL_arg1822z00_4095;

					{	/* Eval/evaluate_types.scm 103 */
						long BgL_res2374z00_4096;

						BgL_res2374z00_4096 =
							BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
						BgL_arg1822z00_4095 = BgL_res2374z00_4096;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1148z00_4094), BgL_arg1822z00_4095);
				}
				return BgL_new1148z00_4094;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1819 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1819z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3681, obj_t BgL_vars1144z00_3682, obj_t BgL_vals1145z00_3683,
		obj_t BgL_body1146z00_3684, obj_t BgL_boxes1147z00_3685)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 103 */
			{	/* Eval/evaluate_types.scm 103 */
				BgL_ev_letza2za2_bglt BgL_new1235z00_4098;

				{	/* Eval/evaluate_types.scm 103 */
					BgL_ev_letza2za2_bglt BgL_new1234z00_4099;

					BgL_new1234z00_4099 =
						((BgL_ev_letza2za2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_letza2za2_bgl))));
					{	/* Eval/evaluate_types.scm 103 */
						long BgL_arg1820z00_4100;

						{	/* Eval/evaluate_types.scm 103 */
							long BgL_res2373z00_4101;

							BgL_res2373z00_4101 =
								BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
							BgL_arg1820z00_4100 = BgL_res2373z00_4101;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1234z00_4099), BgL_arg1820z00_4100);
					}
					BgL_new1235z00_4098 = BgL_new1234z00_4099;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1235z00_4098)))->BgL_varsz00) =
					((obj_t) BgL_vars1144z00_3682), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1235z00_4098)))->BgL_valsz00) =
					((obj_t) BgL_vals1145z00_3683), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1235z00_4098)))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1146z00_3684)),
					BUNSPEC);
				((((BgL_ev_letza2za2_bglt) COBJECT(BgL_new1235z00_4098))->
						BgL_boxesz00) = ((obj_t) BgL_boxes1147z00_3685), BUNSPEC);
				return BgL_new1235z00_4098;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1833> */
	obj_t BGl_z62zc3anonymousza31833ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3686)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 103 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda1832 */
	obj_t BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t BgL_envz00_3687,
		obj_t BgL_oz00_3688, obj_t BgL_vz00_3689)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 103 */
			return
				((((BgL_ev_letza2za2_bglt) COBJECT(
							((BgL_ev_letza2za2_bglt) BgL_oz00_3688)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3689), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1831 */
	obj_t BGl_z62lambda1831z62zz__evaluate_typesz00(obj_t BgL_envz00_3690,
		obj_t BgL_oz00_3691)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 103 */
			return
				(((BgL_ev_letza2za2_bglt) COBJECT(
						((BgL_ev_letza2za2_bglt) BgL_oz00_3691)))->BgL_boxesz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1806> */
	obj_t BGl_z62zc3anonymousza31806ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3692, obj_t BgL_new1142z00_3693)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 101 */
			{
				BgL_ev_letz00_bglt BgL_auxz00_5022;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_new1142z00_3693))))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt)
							COBJECT(((BgL_ev_binderz00_bglt) ((BgL_ev_letz00_bglt)
										BgL_new1142z00_3693))))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5029;

					{	/* Eval/evaluate_types.scm 101 */
						obj_t BgL_classz00_4105;

						BgL_classz00_4105 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 101 */
							obj_t BgL__ortest_1285z00_4106;

							BgL__ortest_1285z00_4106 = BGL_CLASS_NIL(BgL_classz00_4105);
							if (CBOOL(BgL__ortest_1285z00_4106))
								{	/* Eval/evaluate_types.scm 101 */
									BgL_auxz00_5029 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4106);
								}
							else
								{	/* Eval/evaluate_types.scm 101 */
									BgL_auxz00_5029 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4105));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_new1142z00_3693))))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5029), BUNSPEC);
				}
				((((BgL_ev_letz00_bglt) COBJECT(
								((BgL_ev_letz00_bglt) BgL_new1142z00_3693)))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5022 = ((BgL_ev_letz00_bglt) BgL_new1142z00_3693);
				return ((obj_t) BgL_auxz00_5022);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1804 */
	BgL_ev_letz00_bglt BGl_z62lambda1804z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3694)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 101 */
			{	/* Eval/evaluate_types.scm 101 */
				BgL_ev_letz00_bglt BgL_new1141z00_4107;

				BgL_new1141z00_4107 =
					((BgL_ev_letz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_letz00_bgl))));
				{	/* Eval/evaluate_types.scm 101 */
					long BgL_arg1805z00_4108;

					{	/* Eval/evaluate_types.scm 101 */
						long BgL_res2372z00_4109;

						BgL_res2372z00_4109 =
							BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
						BgL_arg1805z00_4108 = BgL_res2372z00_4109;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1141z00_4107), BgL_arg1805z00_4108);
				}
				return BgL_new1141z00_4107;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1802 */
	BgL_ev_letz00_bglt BGl_z62lambda1802z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3695, obj_t BgL_vars1137z00_3696, obj_t BgL_vals1138z00_3697,
		obj_t BgL_body1139z00_3698, obj_t BgL_boxes1140z00_3699)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 101 */
			{	/* Eval/evaluate_types.scm 101 */
				BgL_ev_letz00_bglt BgL_new1233z00_4111;

				{	/* Eval/evaluate_types.scm 101 */
					BgL_ev_letz00_bglt BgL_new1232z00_4112;

					BgL_new1232z00_4112 =
						((BgL_ev_letz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_letz00_bgl))));
					{	/* Eval/evaluate_types.scm 101 */
						long BgL_arg1803z00_4113;

						{	/* Eval/evaluate_types.scm 101 */
							long BgL_res2371z00_4114;

							BgL_res2371z00_4114 =
								BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
							BgL_arg1803z00_4113 = BgL_res2371z00_4114;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1232z00_4112), BgL_arg1803z00_4113);
					}
					BgL_new1233z00_4111 = BgL_new1232z00_4112;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1233z00_4111)))->BgL_varsz00) =
					((obj_t) BgL_vars1137z00_3696), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1233z00_4111)))->BgL_valsz00) =
					((obj_t) BgL_vals1138z00_3697), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1233z00_4111)))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1139z00_3698)),
					BUNSPEC);
				((((BgL_ev_letz00_bglt) COBJECT(BgL_new1233z00_4111))->BgL_boxesz00) =
					((obj_t) BgL_boxes1140z00_3699), BUNSPEC);
				return BgL_new1233z00_4111;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1813> */
	obj_t BGl_z62zc3anonymousza31813ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3700)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 101 */
			return BNIL;
		}
		BGL_FUNCTION_END;
	}



/* &lambda1812 */
	obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t BgL_envz00_3701,
		obj_t BgL_oz00_3702, obj_t BgL_vz00_3703)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 101 */
			return
				((((BgL_ev_letz00_bglt) COBJECT(
							((BgL_ev_letz00_bglt) BgL_oz00_3702)))->BgL_boxesz00) =
				((obj_t) BgL_vz00_3703), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1811 */
	obj_t BGl_z62lambda1811z62zz__evaluate_typesz00(obj_t BgL_envz00_3704,
		obj_t BgL_oz00_3705)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 101 */
			return
				(((BgL_ev_letz00_bglt) COBJECT(
						((BgL_ev_letz00_bglt) BgL_oz00_3705)))->BgL_boxesz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1776> */
	obj_t BGl_z62zc3anonymousza31776ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3706, obj_t BgL_new1135z00_3707)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			{
				BgL_ev_binderz00_bglt BgL_auxz00_5063;

				((((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt) BgL_new1135z00_3707)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(((BgL_ev_binderz00_bglt)
									BgL_new1135z00_3707)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5068;

					{	/* Eval/evaluate_types.scm 97 */
						obj_t BgL_classz00_4118;

						BgL_classz00_4118 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 97 */
							obj_t BgL__ortest_1285z00_4119;

							BgL__ortest_1285z00_4119 = BGL_CLASS_NIL(BgL_classz00_4118);
							if (CBOOL(BgL__ortest_1285z00_4119))
								{	/* Eval/evaluate_types.scm 97 */
									BgL_auxz00_5068 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4119);
								}
							else
								{	/* Eval/evaluate_types.scm 97 */
									BgL_auxz00_5068 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4118));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt) BgL_new1135z00_3707)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5068), BUNSPEC);
				}
				BgL_auxz00_5063 = ((BgL_ev_binderz00_bglt) BgL_new1135z00_3707);
				return ((obj_t) BgL_auxz00_5063);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1774 */
	BgL_ev_binderz00_bglt BGl_z62lambda1774z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3708)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			{	/* Eval/evaluate_types.scm 97 */
				BgL_ev_binderz00_bglt BgL_new1134z00_4120;

				BgL_new1134z00_4120 =
					((BgL_ev_binderz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_binderz00_bgl))));
				{	/* Eval/evaluate_types.scm 97 */
					long BgL_arg1775z00_4121;

					{	/* Eval/evaluate_types.scm 97 */
						long BgL_res2370z00_4122;

						BgL_res2370z00_4122 =
							BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
						BgL_arg1775z00_4121 = BgL_res2370z00_4122;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1134z00_4120), BgL_arg1775z00_4121);
				}
				return BgL_new1134z00_4120;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1772 */
	BgL_ev_binderz00_bglt BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3709, obj_t BgL_vars1131z00_3710, obj_t BgL_vals1132z00_3711,
		obj_t BgL_body1133z00_3712)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			{	/* Eval/evaluate_types.scm 97 */
				BgL_ev_binderz00_bglt BgL_new1231z00_4124;

				{	/* Eval/evaluate_types.scm 97 */
					BgL_ev_binderz00_bglt BgL_new1230z00_4125;

					BgL_new1230z00_4125 =
						((BgL_ev_binderz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_binderz00_bgl))));
					{	/* Eval/evaluate_types.scm 97 */
						long BgL_arg1773z00_4126;

						{	/* Eval/evaluate_types.scm 97 */
							long BgL_res2369z00_4127;

							BgL_res2369z00_4127 =
								BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
							BgL_arg1773z00_4126 = BgL_res2369z00_4127;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1230z00_4125), BgL_arg1773z00_4126);
					}
					BgL_new1231z00_4124 = BgL_new1230z00_4125;
				}
				((((BgL_ev_binderz00_bglt) COBJECT(BgL_new1231z00_4124))->BgL_varsz00) =
					((obj_t) BgL_vars1131z00_3710), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(BgL_new1231z00_4124))->BgL_valsz00) =
					((obj_t) BgL_vals1132z00_3711), BUNSPEC);
				((((BgL_ev_binderz00_bglt) COBJECT(BgL_new1231z00_4124))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1133z00_3712)),
					BUNSPEC);
				return BgL_new1231z00_4124;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1794 */
	obj_t BGl_z62lambda1794z62zz__evaluate_typesz00(obj_t BgL_envz00_3713,
		obj_t BgL_oz00_3714, obj_t BgL_vz00_3715)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) COBJECT(
							((BgL_ev_binderz00_bglt) BgL_oz00_3714)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3715)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1793 */
	BgL_ev_exprz00_bglt BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3716, obj_t BgL_oz00_3717)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) COBJECT(
						((BgL_ev_binderz00_bglt) BgL_oz00_3717)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1786 */
	obj_t BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t BgL_envz00_3718,
		obj_t BgL_oz00_3719, obj_t BgL_vz00_3720)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) COBJECT(
							((BgL_ev_binderz00_bglt) BgL_oz00_3719)))->BgL_valsz00) =
				((obj_t) BgL_vz00_3720), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1785 */
	obj_t BGl_z62lambda1785z62zz__evaluate_typesz00(obj_t BgL_envz00_3721,
		obj_t BgL_oz00_3722)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) COBJECT(
						((BgL_ev_binderz00_bglt) BgL_oz00_3722)))->BgL_valsz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1781 */
	obj_t BGl_z62lambda1781z62zz__evaluate_typesz00(obj_t BgL_envz00_3723,
		obj_t BgL_oz00_3724, obj_t BgL_vz00_3725)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			return
				((((BgL_ev_binderz00_bglt) COBJECT(
							((BgL_ev_binderz00_bglt) BgL_oz00_3724)))->BgL_varsz00) =
				((obj_t) BgL_vz00_3725), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1780 */
	obj_t BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t BgL_envz00_3726,
		obj_t BgL_oz00_3727)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 97 */
			return
				(((BgL_ev_binderz00_bglt) COBJECT(
						((BgL_ev_binderz00_bglt) BgL_oz00_3727)))->BgL_varsz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1743> */
	obj_t BGl_z62zc3anonymousza31743ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3728, obj_t BgL_new1129z00_3729)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			{
				BgL_ev_synchroniza7eza7_bglt BgL_auxz00_5104;

				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_new1129z00_3729)))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5107;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_4136;

						BgL_classz00_4136 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1285z00_4137;

							BgL__ortest_1285z00_4137 = BGL_CLASS_NIL(BgL_classz00_4136);
							if (CBOOL(BgL__ortest_1285z00_4137))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_5107 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4137);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_5107 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4136));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_new1129z00_3729)))->
							BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5107), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5116;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_4138;

						BgL_classz00_4138 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1285z00_4139;

							BgL__ortest_1285z00_4139 = BGL_CLASS_NIL(BgL_classz00_4138);
							if (CBOOL(BgL__ortest_1285z00_4139))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_5116 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4139);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_5116 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4138));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_new1129z00_3729)))->
							BgL_prelockz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5116), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5125;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_4140;

						BgL_classz00_4140 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 92 */
							obj_t BgL__ortest_1285z00_4141;

							BgL__ortest_1285z00_4141 = BGL_CLASS_NIL(BgL_classz00_4140);
							if (CBOOL(BgL__ortest_1285z00_4141))
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_5125 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4141);
								}
							else
								{	/* Eval/evaluate_types.scm 92 */
									BgL_auxz00_5125 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4140));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
									((BgL_ev_synchroniza7eza7_bglt) BgL_new1129z00_3729)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5125), BUNSPEC);
				}
				BgL_auxz00_5104 = ((BgL_ev_synchroniza7eza7_bglt) BgL_new1129z00_3729);
				return ((obj_t) BgL_auxz00_5104);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1741 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1741z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3730)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_new1128z00_4142;

				BgL_new1128z00_4142 =
					((BgL_ev_synchroniza7eza7_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_synchroniza7eza7_bgl))));
				{	/* Eval/evaluate_types.scm 92 */
					long BgL_arg1742z00_4143;

					{	/* Eval/evaluate_types.scm 92 */
						long BgL_res2368z00_4144;

						BgL_res2368z00_4144 =
							BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
						BgL_arg1742z00_4143 = BgL_res2368z00_4144;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1128z00_4142), BgL_arg1742z00_4143);
				}
				return BgL_new1128z00_4142;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1739 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1739z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3731, obj_t BgL_loc1123z00_3732, obj_t BgL_mutex1124z00_3733,
		obj_t BgL_prelock1125z00_3734, obj_t BgL_body1126z00_3735)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_new1229z00_4148;

				{	/* Eval/evaluate_types.scm 92 */
					BgL_ev_synchroniza7eza7_bglt BgL_new1228z00_4149;

					BgL_new1228z00_4149 =
						((BgL_ev_synchroniza7eza7_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_synchroniza7eza7_bgl))));
					{	/* Eval/evaluate_types.scm 92 */
						long BgL_arg1740z00_4150;

						{	/* Eval/evaluate_types.scm 92 */
							long BgL_res2367z00_4151;

							BgL_res2367z00_4151 =
								BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
							BgL_arg1740z00_4150 = BgL_res2367z00_4151;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1228z00_4149), BgL_arg1740z00_4150);
					}
					BgL_new1229z00_4148 = BgL_new1228z00_4149;
				}
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1229z00_4148))->
						BgL_locz00) = ((obj_t) BgL_loc1123z00_3732), BUNSPEC);
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1229z00_4148))->
						BgL_mutexz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_mutex1124z00_3733)),
					BUNSPEC);
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1229z00_4148))->
						BgL_prelockz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
							BgL_prelock1125z00_3734)), BUNSPEC);
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(BgL_new1229z00_4148))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1126z00_3735)),
					BUNSPEC);
				return BgL_new1229z00_4148;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1764 */
	obj_t BGl_z62lambda1764z62zz__evaluate_typesz00(obj_t BgL_envz00_3736,
		obj_t BgL_oz00_3737, obj_t BgL_vz00_3738)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3737)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3738)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1763 */
	BgL_ev_exprz00_bglt BGl_z62lambda1763z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3739, obj_t BgL_oz00_3740)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3740)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1758 */
	obj_t BGl_z62lambda1758z62zz__evaluate_typesz00(obj_t BgL_envz00_3741,
		obj_t BgL_oz00_3742, obj_t BgL_vz00_3743)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3742)))->
					BgL_prelockz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3743)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1757 */
	BgL_ev_exprz00_bglt BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3744, obj_t BgL_oz00_3745)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3745)))->BgL_prelockz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1753 */
	obj_t BGl_z62lambda1753z62zz__evaluate_typesz00(obj_t BgL_envz00_3746,
		obj_t BgL_oz00_3747, obj_t BgL_vz00_3748)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3747)))->BgL_mutexz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3748)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1752 */
	BgL_ev_exprz00_bglt BGl_z62lambda1752z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3749, obj_t BgL_oz00_3750)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3750)))->BgL_mutexz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1748 */
	obj_t BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t BgL_envz00_3751,
		obj_t BgL_oz00_3752, obj_t BgL_vz00_3753)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				((((BgL_ev_synchroniza7eza7_bglt) COBJECT(
							((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3752)))->BgL_locz00) =
				((obj_t) BgL_vz00_3753), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1747 */
	obj_t BGl_z62lambda1747z62zz__evaluate_typesz00(obj_t BgL_envz00_3754,
		obj_t BgL_oz00_3755)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3755)))->BgL_locz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1723> */
	obj_t BGl_z62zc3anonymousza31723ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3756, obj_t BgL_new1121z00_3757)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			{
				BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_5170;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5171;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_4164;

						BgL_classz00_4164 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 89 */
							obj_t BgL__ortest_1285z00_4165;

							BgL__ortest_1285z00_4165 = BGL_CLASS_NIL(BgL_classz00_4164);
							if (CBOOL(BgL__ortest_1285z00_4165))
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5171 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4165);
								}
							else
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5171 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4164));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
									((BgL_ev_withzd2handlerzd2_bglt) BgL_new1121z00_3757)))->
							BgL_handlerz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5171), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5180;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_4166;

						BgL_classz00_4166 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 89 */
							obj_t BgL__ortest_1285z00_4167;

							BgL__ortest_1285z00_4167 = BGL_CLASS_NIL(BgL_classz00_4166);
							if (CBOOL(BgL__ortest_1285z00_4167))
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5180 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4167);
								}
							else
								{	/* Eval/evaluate_types.scm 89 */
									BgL_auxz00_5180 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4166));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
									((BgL_ev_withzd2handlerzd2_bglt) BgL_new1121z00_3757)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5180), BUNSPEC);
				}
				BgL_auxz00_5170 = ((BgL_ev_withzd2handlerzd2_bglt) BgL_new1121z00_3757);
				return ((obj_t) BgL_auxz00_5170);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1720 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1720z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3758)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			{	/* Eval/evaluate_types.scm 89 */
				BgL_ev_withzd2handlerzd2_bglt BgL_new1120z00_4168;

				BgL_new1120z00_4168 =
					((BgL_ev_withzd2handlerzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_withzd2handlerzd2_bgl))));
				{	/* Eval/evaluate_types.scm 89 */
					long BgL_arg1722z00_4169;

					{	/* Eval/evaluate_types.scm 89 */
						long BgL_res2366z00_4170;

						BgL_res2366z00_4170 =
							BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
						BgL_arg1722z00_4169 = BgL_res2366z00_4170;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1120z00_4168), BgL_arg1722z00_4169);
				}
				return BgL_new1120z00_4168;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1718 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1718z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3759, obj_t BgL_handler1118z00_3760, obj_t BgL_body1119z00_3761)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			{	/* Eval/evaluate_types.scm 89 */
				BgL_ev_withzd2handlerzd2_bglt BgL_new1227z00_4173;

				{	/* Eval/evaluate_types.scm 89 */
					BgL_ev_withzd2handlerzd2_bglt BgL_new1226z00_4174;

					BgL_new1226z00_4174 =
						((BgL_ev_withzd2handlerzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_withzd2handlerzd2_bgl))));
					{	/* Eval/evaluate_types.scm 89 */
						long BgL_arg1719z00_4175;

						{	/* Eval/evaluate_types.scm 89 */
							long BgL_res2365z00_4176;

							BgL_res2365z00_4176 =
								BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
							BgL_arg1719z00_4175 = BgL_res2365z00_4176;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1226z00_4174), BgL_arg1719z00_4175);
					}
					BgL_new1227z00_4173 = BgL_new1226z00_4174;
				}
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1227z00_4173))->
						BgL_handlerz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
							BgL_handler1118z00_3760)), BUNSPEC);
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(BgL_new1227z00_4173))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1119z00_3761)),
					BUNSPEC);
				return BgL_new1227z00_4173;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1733 */
	obj_t BGl_z62lambda1733z62zz__evaluate_typesz00(obj_t BgL_envz00_3762,
		obj_t BgL_oz00_3763, obj_t BgL_vz00_3764)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			return
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
							((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3763)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3764)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1732 */
	BgL_ev_exprz00_bglt BGl_z62lambda1732z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3765, obj_t BgL_oz00_3766)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3766)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1728 */
	obj_t BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t BgL_envz00_3767,
		obj_t BgL_oz00_3768, obj_t BgL_vz00_3769)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			return
				((((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
							((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3768)))->
					BgL_handlerz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3769)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1727 */
	BgL_ev_exprz00_bglt BGl_z62lambda1727z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3770, obj_t BgL_oz00_3771)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3771)))->BgL_handlerz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1701> */
	obj_t BGl_z62zc3anonymousza31701ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3772, obj_t BgL_new1116z00_3773)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			{
				BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_5213;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5214;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_4184;

						BgL_classz00_4184 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 86 */
							obj_t BgL__ortest_1285z00_4185;

							BgL__ortest_1285z00_4185 = BGL_CLASS_NIL(BgL_classz00_4184);
							if (CBOOL(BgL__ortest_1285z00_4185))
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5214 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4185);
								}
							else
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5214 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4184));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
									((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1116z00_3773)))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5214), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5223;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_4186;

						BgL_classz00_4186 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 86 */
							obj_t BgL__ortest_1285z00_4187;

							BgL__ortest_1285z00_4187 = BGL_CLASS_NIL(BgL_classz00_4186);
							if (CBOOL(BgL__ortest_1285z00_4187))
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5223 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4187);
								}
							else
								{	/* Eval/evaluate_types.scm 86 */
									BgL_auxz00_5223 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4186));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
									((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1116z00_3773)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5223), BUNSPEC);
				}
				BgL_auxz00_5213 =
					((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1116z00_3773);
				return ((obj_t) BgL_auxz00_5213);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1699 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t BgL_envz00_3774)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			{	/* Eval/evaluate_types.scm 86 */
				BgL_ev_unwindzd2protectzd2_bglt BgL_new1115z00_4188;

				BgL_new1115z00_4188 =
					((BgL_ev_unwindzd2protectzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_unwindzd2protectzd2_bgl))));
				{	/* Eval/evaluate_types.scm 86 */
					long BgL_arg1700z00_4189;

					{	/* Eval/evaluate_types.scm 86 */
						long BgL_res2364z00_4190;

						BgL_res2364z00_4190 =
							BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
						BgL_arg1700z00_4189 = BgL_res2364z00_4190;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1115z00_4188), BgL_arg1700z00_4189);
				}
				return BgL_new1115z00_4188;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1697 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1697z62zz__evaluate_typesz00(obj_t BgL_envz00_3775,
		obj_t BgL_e1113z00_3776, obj_t BgL_body1114z00_3777)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			{	/* Eval/evaluate_types.scm 86 */
				BgL_ev_unwindzd2protectzd2_bglt BgL_new1225z00_4193;

				{	/* Eval/evaluate_types.scm 86 */
					BgL_ev_unwindzd2protectzd2_bglt BgL_new1224z00_4194;

					BgL_new1224z00_4194 =
						((BgL_ev_unwindzd2protectzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_unwindzd2protectzd2_bgl))));
					{	/* Eval/evaluate_types.scm 86 */
						long BgL_arg1698z00_4195;

						{	/* Eval/evaluate_types.scm 86 */
							long BgL_res2363z00_4196;

							BgL_res2363z00_4196 =
								BGL_CLASS_INDEX
								(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
							BgL_arg1698z00_4195 = BgL_res2363z00_4196;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1224z00_4194), BgL_arg1698z00_4195);
					}
					BgL_new1225z00_4193 = BgL_new1224z00_4194;
				}
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1225z00_4193))->
						BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1113z00_3776)),
					BUNSPEC);
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(BgL_new1225z00_4193))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1114z00_3777)),
					BUNSPEC);
				return BgL_new1225z00_4193;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1712 */
	obj_t BGl_z62lambda1712z62zz__evaluate_typesz00(obj_t BgL_envz00_3778,
		obj_t BgL_oz00_3779, obj_t BgL_vz00_3780)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			return
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
							((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3779)))->
					BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3780)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1711 */
	BgL_ev_exprz00_bglt BGl_z62lambda1711z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3781, obj_t BgL_oz00_3782)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3782)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1706 */
	obj_t BGl_z62lambda1706z62zz__evaluate_typesz00(obj_t BgL_envz00_3783,
		obj_t BgL_oz00_3784, obj_t BgL_vz00_3785)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			return
				((((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
							((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3784)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3785)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1705 */
	BgL_ev_exprz00_bglt BGl_z62lambda1705z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3786, obj_t BgL_oz00_3787)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3787)))->BgL_ez00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1681> */
	obj_t BGl_z62zc3anonymousza31681ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3788, obj_t BgL_new1111z00_3789)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			{
				BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_5256;

				{
					BgL_ev_varz00_bglt BgL_auxz00_5257;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_4204;

						BgL_classz00_4204 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 83 */
							obj_t BgL__ortest_1285z00_4205;

							BgL__ortest_1285z00_4205 = BGL_CLASS_NIL(BgL_classz00_4204);
							if (CBOOL(BgL__ortest_1285z00_4205))
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5257 =
										((BgL_ev_varz00_bglt) BgL__ortest_1285z00_4205);
								}
							else
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5257 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4204));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_new1111z00_3789)))->
							BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_auxz00_5257), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5266;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_4206;

						BgL_classz00_4206 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 83 */
							obj_t BgL__ortest_1285z00_4207;

							BgL__ortest_1285z00_4207 = BGL_CLASS_NIL(BgL_classz00_4206);
							if (CBOOL(BgL__ortest_1285z00_4207))
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5266 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4207);
								}
							else
								{	/* Eval/evaluate_types.scm 83 */
									BgL_auxz00_5266 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4206));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_new1111z00_3789)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5266), BUNSPEC);
				}
				BgL_auxz00_5256 = ((BgL_ev_bindzd2exitzd2_bglt) BgL_new1111z00_3789);
				return ((obj_t) BgL_auxz00_5256);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1679 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1679z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3790)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			{	/* Eval/evaluate_types.scm 83 */
				BgL_ev_bindzd2exitzd2_bglt BgL_new1110z00_4208;

				BgL_new1110z00_4208 =
					((BgL_ev_bindzd2exitzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_bindzd2exitzd2_bgl))));
				{	/* Eval/evaluate_types.scm 83 */
					long BgL_arg1680z00_4209;

					{	/* Eval/evaluate_types.scm 83 */
						long BgL_res2362z00_4210;

						BgL_res2362z00_4210 =
							BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
						BgL_arg1680z00_4209 = BgL_res2362z00_4210;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1110z00_4208), BgL_arg1680z00_4209);
				}
				return BgL_new1110z00_4208;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1677 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1677z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3791, obj_t BgL_var1108z00_3792, obj_t BgL_body1109z00_3793)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			{	/* Eval/evaluate_types.scm 83 */
				BgL_ev_bindzd2exitzd2_bglt BgL_new1223z00_4213;

				{	/* Eval/evaluate_types.scm 83 */
					BgL_ev_bindzd2exitzd2_bglt BgL_new1222z00_4214;

					BgL_new1222z00_4214 =
						((BgL_ev_bindzd2exitzd2_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_bindzd2exitzd2_bgl))));
					{	/* Eval/evaluate_types.scm 83 */
						long BgL_arg1678z00_4215;

						{	/* Eval/evaluate_types.scm 83 */
							long BgL_res2361z00_4216;

							BgL_res2361z00_4216 =
								BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
							BgL_arg1678z00_4215 = BgL_res2361z00_4216;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1222z00_4214), BgL_arg1678z00_4215);
					}
					BgL_new1223z00_4213 = BgL_new1222z00_4214;
				}
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1223z00_4213))->
						BgL_varz00) =
					((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_var1108z00_3792)),
					BUNSPEC);
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(BgL_new1223z00_4213))->
						BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_body1109z00_3793)),
					BUNSPEC);
				return BgL_new1223z00_4213;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1691 */
	obj_t BGl_z62lambda1691z62zz__evaluate_typesz00(obj_t BgL_envz00_3794,
		obj_t BgL_oz00_3795, obj_t BgL_vz00_3796)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			return
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
							((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3795)))->BgL_bodyz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3796)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1690 */
	BgL_ev_exprz00_bglt BGl_z62lambda1690z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3797, obj_t BgL_oz00_3798)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3798)))->BgL_bodyz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1686 */
	obj_t BGl_z62lambda1686z62zz__evaluate_typesz00(obj_t BgL_envz00_3799,
		obj_t BgL_oz00_3800, obj_t BgL_vz00_3801)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			return
				((((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
							((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3800)))->BgL_varz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3801)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1685 */
	BgL_ev_varz00_bglt BGl_z62lambda1685z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3802, obj_t BgL_oz00_3803)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3803)))->BgL_varz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1671> */
	obj_t BGl_z62zc3anonymousza31671ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3804, obj_t BgL_new1106z00_3805)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 82 */
			{
				BgL_ev_defglobalz00_bglt BgL_auxz00_5299;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5300;

					{	/* Eval/evaluate_types.scm 82 */
						obj_t BgL_classz00_4224;

						BgL_classz00_4224 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 82 */
							obj_t BgL__ortest_1285z00_4225;

							BgL__ortest_1285z00_4225 = BGL_CLASS_NIL(BgL_classz00_4224);
							if (CBOOL(BgL__ortest_1285z00_4225))
								{	/* Eval/evaluate_types.scm 82 */
									BgL_auxz00_5300 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4225);
								}
							else
								{	/* Eval/evaluate_types.scm 82 */
									BgL_auxz00_5300 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4224));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_defglobalz00_bglt) BgL_new1106z00_3805))))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5300), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_new1106z00_3805))))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt)
							COBJECT(((BgL_ev_setglobalz00_bglt) ((BgL_ev_defglobalz00_bglt)
										BgL_new1106z00_3805))))->BgL_namez00) =
					((obj_t) BGl_symbol2764z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt)
							COBJECT(((BgL_ev_setglobalz00_bglt) ((BgL_ev_defglobalz00_bglt)
										BgL_new1106z00_3805))))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5299 = ((BgL_ev_defglobalz00_bglt) BgL_new1106z00_3805);
				return ((obj_t) BgL_auxz00_5299);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1669 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1669z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3806)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 82 */
			{	/* Eval/evaluate_types.scm 82 */
				BgL_ev_defglobalz00_bglt BgL_new1105z00_4226;

				BgL_new1105z00_4226 =
					((BgL_ev_defglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_defglobalz00_bgl))));
				{	/* Eval/evaluate_types.scm 82 */
					long BgL_arg1670z00_4227;

					{	/* Eval/evaluate_types.scm 82 */
						long BgL_res2360z00_4228;

						BgL_res2360z00_4228 =
							BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
						BgL_arg1670z00_4227 = BgL_res2360z00_4228;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1105z00_4226), BgL_arg1670z00_4227);
				}
				return BgL_new1105z00_4226;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1667 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1667z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3807, obj_t BgL_e1101z00_3808, obj_t BgL_loc1102z00_3809,
		obj_t BgL_name1103z00_3810, obj_t BgL_mod1104z00_3811)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 82 */
			{	/* Eval/evaluate_types.scm 82 */
				BgL_ev_defglobalz00_bglt BgL_new1221z00_4231;

				{	/* Eval/evaluate_types.scm 82 */
					BgL_ev_defglobalz00_bglt BgL_new1220z00_4232;

					BgL_new1220z00_4232 =
						((BgL_ev_defglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_defglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 82 */
						long BgL_arg1668z00_4233;

						{	/* Eval/evaluate_types.scm 82 */
							long BgL_res2359z00_4234;

							BgL_res2359z00_4234 =
								BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
							BgL_arg1668z00_4233 = BgL_res2359z00_4234;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1220z00_4232), BgL_arg1668z00_4233);
					}
					BgL_new1221z00_4231 = BgL_new1220z00_4232;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1221z00_4231)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1101z00_3808)),
					BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1221z00_4231)))->BgL_locz00) =
					((obj_t) BgL_loc1102z00_3809), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1221z00_4231)))->BgL_namez00) =
					((obj_t) ((obj_t) BgL_name1103z00_3810)), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1221z00_4231)))->BgL_modz00) =
					((obj_t) BgL_mod1104z00_3811), BUNSPEC);
				return BgL_new1221z00_4231;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1638> */
	obj_t BGl_z62zc3anonymousza31638ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3812, obj_t BgL_new1099z00_3813)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			{
				BgL_ev_setglobalz00_bglt BgL_auxz00_5339;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5340;

					{	/* Eval/evaluate_types.scm 78 */
						obj_t BgL_classz00_4236;

						BgL_classz00_4236 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 78 */
							obj_t BgL__ortest_1285z00_4237;

							BgL__ortest_1285z00_4237 = BGL_CLASS_NIL(BgL_classz00_4236);
							if (CBOOL(BgL__ortest_1285z00_4237))
								{	/* Eval/evaluate_types.scm 78 */
									BgL_auxz00_5340 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4237);
								}
							else
								{	/* Eval/evaluate_types.scm 78 */
									BgL_auxz00_5340 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4236));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_setglobalz00_bglt) BgL_new1099z00_3813))))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5340), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_new1099z00_3813)))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1099z00_3813)))->BgL_namez00) =
					((obj_t) BGl_symbol2764z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
									BgL_new1099z00_3813)))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5339 = ((BgL_ev_setglobalz00_bglt) BgL_new1099z00_3813);
				return ((obj_t) BgL_auxz00_5339);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1636 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3814)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_new1098z00_4238;

				BgL_new1098z00_4238 =
					((BgL_ev_setglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_setglobalz00_bgl))));
				{	/* Eval/evaluate_types.scm 78 */
					long BgL_arg1637z00_4239;

					{	/* Eval/evaluate_types.scm 78 */
						long BgL_res2358z00_4240;

						BgL_res2358z00_4240 =
							BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
						BgL_arg1637z00_4239 = BgL_res2358z00_4240;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1098z00_4238), BgL_arg1637z00_4239);
				}
				return BgL_new1098z00_4238;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1634 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1634z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3815, obj_t BgL_e1094z00_3816, obj_t BgL_loc1095z00_3817,
		obj_t BgL_name1096z00_3818, obj_t BgL_mod1097z00_3819)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_new1219z00_4243;

				{	/* Eval/evaluate_types.scm 78 */
					BgL_ev_setglobalz00_bglt BgL_new1218z00_4244;

					BgL_new1218z00_4244 =
						((BgL_ev_setglobalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_setglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 78 */
						long BgL_arg1635z00_4245;

						{	/* Eval/evaluate_types.scm 78 */
							long BgL_res2357z00_4246;

							BgL_res2357z00_4246 =
								BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
							BgL_arg1635z00_4245 = BgL_res2357z00_4246;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1218z00_4244), BgL_arg1635z00_4245);
					}
					BgL_new1219z00_4243 = BgL_new1218z00_4244;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1219z00_4243)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1094z00_3816)),
					BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1219z00_4243))->
						BgL_locz00) = ((obj_t) BgL_loc1095z00_3817), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1219z00_4243))->
						BgL_namez00) = ((obj_t) ((obj_t) BgL_name1096z00_3818)), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) COBJECT(BgL_new1219z00_4243))->
						BgL_modz00) = ((obj_t) BgL_mod1097z00_3819), BUNSPEC);
				return BgL_new1219z00_4243;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1658 */
	obj_t BGl_z62lambda1658z62zz__evaluate_typesz00(obj_t BgL_envz00_3820,
		obj_t BgL_oz00_3821, obj_t BgL_vz00_3822)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) COBJECT(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3821)))->BgL_modz00) =
				((obj_t) BgL_vz00_3822), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1657 */
	obj_t BGl_z62lambda1657z62zz__evaluate_typesz00(obj_t BgL_envz00_3823,
		obj_t BgL_oz00_3824)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) COBJECT(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3824)))->BgL_modz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1650 */
	obj_t BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t BgL_envz00_3825,
		obj_t BgL_oz00_3826, obj_t BgL_vz00_3827)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) COBJECT(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3826)))->BgL_namez00) =
				((obj_t) ((obj_t) BgL_vz00_3827)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1649 */
	obj_t BGl_z62lambda1649z62zz__evaluate_typesz00(obj_t BgL_envz00_3828,
		obj_t BgL_oz00_3829)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) COBJECT(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3829)))->BgL_namez00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1644 */
	obj_t BGl_z62lambda1644z62zz__evaluate_typesz00(obj_t BgL_envz00_3830,
		obj_t BgL_oz00_3831, obj_t BgL_vz00_3832)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			return
				((((BgL_ev_setglobalz00_bglt) COBJECT(
							((BgL_ev_setglobalz00_bglt) BgL_oz00_3831)))->BgL_locz00) =
				((obj_t) BgL_vz00_3832), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1643 */
	obj_t BGl_z62lambda1643z62zz__evaluate_typesz00(obj_t BgL_envz00_3833,
		obj_t BgL_oz00_3834)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) COBJECT(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3834)))->BgL_locz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1615> */
	obj_t BGl_z62zc3anonymousza31615ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3835, obj_t BgL_new1092z00_3836)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_setlocalz00_bglt BgL_auxz00_5386;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5387;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_4255;

						BgL_classz00_4255 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 76 */
							obj_t BgL__ortest_1285z00_4256;

							BgL__ortest_1285z00_4256 = BGL_CLASS_NIL(BgL_classz00_4255);
							if (CBOOL(BgL__ortest_1285z00_4256))
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5387 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4256);
								}
							else
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5387 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4255));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_setlocalz00_bglt) BgL_new1092z00_3836))))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5387), BUNSPEC);
				}
				{
					BgL_ev_varz00_bglt BgL_auxz00_5397;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_4257;

						BgL_classz00_4257 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 76 */
							obj_t BgL__ortest_1285z00_4258;

							BgL__ortest_1285z00_4258 = BGL_CLASS_NIL(BgL_classz00_4257);
							if (CBOOL(BgL__ortest_1285z00_4258))
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5397 =
										((BgL_ev_varz00_bglt) BgL__ortest_1285z00_4258);
								}
							else
								{	/* Eval/evaluate_types.scm 76 */
									BgL_auxz00_5397 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4257));
								}
						}
					}
					((((BgL_ev_setlocalz00_bglt) COBJECT(
									((BgL_ev_setlocalz00_bglt) BgL_new1092z00_3836)))->BgL_vz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_5397), BUNSPEC);
				}
				BgL_auxz00_5386 = ((BgL_ev_setlocalz00_bglt) BgL_new1092z00_3836);
				return ((obj_t) BgL_auxz00_5386);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1613 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1613z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3837)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 76 */
			{	/* Eval/evaluate_types.scm 76 */
				BgL_ev_setlocalz00_bglt BgL_new1091z00_4259;

				BgL_new1091z00_4259 =
					((BgL_ev_setlocalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_setlocalz00_bgl))));
				{	/* Eval/evaluate_types.scm 76 */
					long BgL_arg1614z00_4260;

					{	/* Eval/evaluate_types.scm 76 */
						long BgL_res2356z00_4261;

						BgL_res2356z00_4261 =
							BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
						BgL_arg1614z00_4260 = BgL_res2356z00_4261;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1091z00_4259), BgL_arg1614z00_4260);
				}
				return BgL_new1091z00_4259;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1610 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1610z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3838, obj_t BgL_e1089z00_3839, obj_t BgL_v1090z00_3840)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 76 */
			{	/* Eval/evaluate_types.scm 76 */
				BgL_ev_setlocalz00_bglt BgL_new1217z00_4264;

				{	/* Eval/evaluate_types.scm 76 */
					BgL_ev_setlocalz00_bglt BgL_new1216z00_4265;

					BgL_new1216z00_4265 =
						((BgL_ev_setlocalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_setlocalz00_bgl))));
					{	/* Eval/evaluate_types.scm 76 */
						long BgL_arg1612z00_4266;

						{	/* Eval/evaluate_types.scm 76 */
							long BgL_res2355z00_4267;

							BgL_res2355z00_4267 =
								BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
							BgL_arg1612z00_4266 = BgL_res2355z00_4267;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1216z00_4265), BgL_arg1612z00_4266);
					}
					BgL_new1217z00_4264 = BgL_new1216z00_4265;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1217z00_4264)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1089z00_3839)),
					BUNSPEC);
				((((BgL_ev_setlocalz00_bglt) COBJECT(BgL_new1217z00_4264))->BgL_vz00) =
					((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_v1090z00_3840)),
					BUNSPEC);
				return BgL_new1217z00_4264;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1624 */
	obj_t BGl_z62lambda1624z62zz__evaluate_typesz00(obj_t BgL_envz00_3841,
		obj_t BgL_oz00_3842, obj_t BgL_vz00_3843)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 76 */
			return
				((((BgL_ev_setlocalz00_bglt) COBJECT(
							((BgL_ev_setlocalz00_bglt) BgL_oz00_3842)))->BgL_vz00) =
				((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_vz00_3843)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1623 */
	BgL_ev_varz00_bglt BGl_z62lambda1623z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3844, obj_t BgL_oz00_3845)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 76 */
			return
				(((BgL_ev_setlocalz00_bglt) COBJECT(
						((BgL_ev_setlocalz00_bglt) BgL_oz00_3845)))->BgL_vz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1603> */
	obj_t BGl_z62zc3anonymousza31603ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3846, obj_t BgL_new1087z00_3847)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 75 */
			{
				BgL_ev_trapz00_bglt BgL_auxz00_5426;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5427;

					{	/* Eval/evaluate_types.scm 75 */
						obj_t BgL_classz00_4272;

						BgL_classz00_4272 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 75 */
							obj_t BgL__ortest_1285z00_4273;

							BgL__ortest_1285z00_4273 = BGL_CLASS_NIL(BgL_classz00_4272);
							if (CBOOL(BgL__ortest_1285z00_4273))
								{	/* Eval/evaluate_types.scm 75 */
									BgL_auxz00_5427 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4273);
								}
							else
								{	/* Eval/evaluate_types.scm 75 */
									BgL_auxz00_5427 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4272));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt)
										((BgL_ev_trapz00_bglt) BgL_new1087z00_3847))))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5427), BUNSPEC);
				}
				BgL_auxz00_5426 = ((BgL_ev_trapz00_bglt) BgL_new1087z00_3847);
				return ((obj_t) BgL_auxz00_5426);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1601 */
	BgL_ev_trapz00_bglt BGl_z62lambda1601z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3848)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 75 */
			{	/* Eval/evaluate_types.scm 75 */
				BgL_ev_trapz00_bglt BgL_new1086z00_4274;

				BgL_new1086z00_4274 =
					((BgL_ev_trapz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_trapz00_bgl))));
				{	/* Eval/evaluate_types.scm 75 */
					long BgL_arg1602z00_4275;

					{	/* Eval/evaluate_types.scm 75 */
						long BgL_res2354z00_4276;

						BgL_res2354z00_4276 =
							BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
						BgL_arg1602z00_4275 = BgL_res2354z00_4276;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1086z00_4274), BgL_arg1602z00_4275);
				}
				return BgL_new1086z00_4274;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1598 */
	BgL_ev_trapz00_bglt BGl_z62lambda1598z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3849, obj_t BgL_e1085z00_3850)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 75 */
			{	/* Eval/evaluate_types.scm 75 */
				BgL_ev_trapz00_bglt BgL_new1215z00_4278;

				{	/* Eval/evaluate_types.scm 75 */
					BgL_ev_trapz00_bglt BgL_new1214z00_4279;

					BgL_new1214z00_4279 =
						((BgL_ev_trapz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_trapz00_bgl))));
					{	/* Eval/evaluate_types.scm 75 */
						long BgL_arg1600z00_4280;

						{	/* Eval/evaluate_types.scm 75 */
							long BgL_res2353z00_4281;

							BgL_res2353z00_4281 =
								BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
							BgL_arg1600z00_4280 = BgL_res2353z00_4281;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1214z00_4279), BgL_arg1600z00_4280);
					}
					BgL_new1215z00_4278 = BgL_new1214z00_4279;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt) BgL_new1215z00_4278)))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1085z00_3850)),
					BUNSPEC);
				return BgL_new1215z00_4278;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1587> */
	obj_t BGl_z62zc3anonymousza31587ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3851, obj_t BgL_new1083z00_3852)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 73 */
			{
				BgL_ev_hookz00_bglt BgL_auxz00_5450;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5451;

					{	/* Eval/evaluate_types.scm 73 */
						obj_t BgL_classz00_4283;

						BgL_classz00_4283 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 73 */
							obj_t BgL__ortest_1285z00_4284;

							BgL__ortest_1285z00_4284 = BGL_CLASS_NIL(BgL_classz00_4283);
							if (CBOOL(BgL__ortest_1285z00_4284))
								{	/* Eval/evaluate_types.scm 73 */
									BgL_auxz00_5451 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4284);
								}
							else
								{	/* Eval/evaluate_types.scm 73 */
									BgL_auxz00_5451 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4283));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) COBJECT(
									((BgL_ev_hookz00_bglt) BgL_new1083z00_3852)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5451), BUNSPEC);
				}
				BgL_auxz00_5450 = ((BgL_ev_hookz00_bglt) BgL_new1083z00_3852);
				return ((obj_t) BgL_auxz00_5450);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1585 */
	BgL_ev_hookz00_bglt BGl_z62lambda1585z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3853)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 73 */
			{	/* Eval/evaluate_types.scm 73 */
				BgL_ev_hookz00_bglt BgL_new1082z00_4285;

				BgL_new1082z00_4285 =
					((BgL_ev_hookz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_hookz00_bgl))));
				{	/* Eval/evaluate_types.scm 73 */
					long BgL_arg1586z00_4286;

					{	/* Eval/evaluate_types.scm 73 */
						long BgL_res2352z00_4287;

						BgL_res2352z00_4287 =
							BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
						BgL_arg1586z00_4286 = BgL_res2352z00_4287;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1082z00_4285), BgL_arg1586z00_4286);
				}
				return BgL_new1082z00_4285;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1583 */
	BgL_ev_hookz00_bglt BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3854, obj_t BgL_e1081z00_3855)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 73 */
			{	/* Eval/evaluate_types.scm 73 */
				BgL_ev_hookz00_bglt BgL_new1213z00_4289;

				{	/* Eval/evaluate_types.scm 73 */
					BgL_ev_hookz00_bglt BgL_new1212z00_4290;

					BgL_new1212z00_4290 =
						((BgL_ev_hookz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_hookz00_bgl))));
					{	/* Eval/evaluate_types.scm 73 */
						long BgL_arg1584z00_4291;

						{	/* Eval/evaluate_types.scm 73 */
							long BgL_res2351z00_4292;

							BgL_res2351z00_4292 =
								BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
							BgL_arg1584z00_4291 = BgL_res2351z00_4292;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1212z00_4290), BgL_arg1584z00_4291);
					}
					BgL_new1213z00_4289 = BgL_new1212z00_4290;
				}
				((((BgL_ev_hookz00_bglt) COBJECT(BgL_new1213z00_4289))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1081z00_3855)),
					BUNSPEC);
				return BgL_new1213z00_4289;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1592 */
	obj_t BGl_z62lambda1592z62zz__evaluate_typesz00(obj_t BgL_envz00_3856,
		obj_t BgL_oz00_3857, obj_t BgL_vz00_3858)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 73 */
			return
				((((BgL_ev_hookz00_bglt) COBJECT(
							((BgL_ev_hookz00_bglt) BgL_oz00_3857)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3858)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1591 */
	BgL_ev_exprz00_bglt BGl_z62lambda1591z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3859, obj_t BgL_oz00_3860)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 73 */
			return
				(((BgL_ev_hookz00_bglt) COBJECT(
						((BgL_ev_hookz00_bglt) BgL_oz00_3860)))->BgL_ez00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1564> */
	obj_t BGl_z62zc3anonymousza31564ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3861, obj_t BgL_new1079z00_3862)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			{
				BgL_ev_prog2z00_bglt BgL_auxz00_5477;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5478;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_4297;

						BgL_classz00_4297 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 70 */
							obj_t BgL__ortest_1285z00_4298;

							BgL__ortest_1285z00_4298 = BGL_CLASS_NIL(BgL_classz00_4297);
							if (CBOOL(BgL__ortest_1285z00_4298))
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5478 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4298);
								}
							else
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5478 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4297));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) COBJECT(
									((BgL_ev_prog2z00_bglt) BgL_new1079z00_3862)))->BgL_e1z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5478), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5487;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_4299;

						BgL_classz00_4299 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 70 */
							obj_t BgL__ortest_1285z00_4300;

							BgL__ortest_1285z00_4300 = BGL_CLASS_NIL(BgL_classz00_4299);
							if (CBOOL(BgL__ortest_1285z00_4300))
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5487 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4300);
								}
							else
								{	/* Eval/evaluate_types.scm 70 */
									BgL_auxz00_5487 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4299));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) COBJECT(
									((BgL_ev_prog2z00_bglt) BgL_new1079z00_3862)))->BgL_e2z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5487), BUNSPEC);
				}
				BgL_auxz00_5477 = ((BgL_ev_prog2z00_bglt) BgL_new1079z00_3862);
				return ((obj_t) BgL_auxz00_5477);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1562 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1562z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3863)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			{	/* Eval/evaluate_types.scm 70 */
				BgL_ev_prog2z00_bglt BgL_new1078z00_4301;

				BgL_new1078z00_4301 =
					((BgL_ev_prog2z00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_prog2z00_bgl))));
				{	/* Eval/evaluate_types.scm 70 */
					long BgL_arg1563z00_4302;

					{	/* Eval/evaluate_types.scm 70 */
						long BgL_res2350z00_4303;

						BgL_res2350z00_4303 =
							BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
						BgL_arg1563z00_4302 = BgL_res2350z00_4303;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1078z00_4301), BgL_arg1563z00_4302);
				}
				return BgL_new1078z00_4301;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1560 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1560z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3864, obj_t BgL_e11076z00_3865, obj_t BgL_e21077z00_3866)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			{	/* Eval/evaluate_types.scm 70 */
				BgL_ev_prog2z00_bglt BgL_new1211z00_4306;

				{	/* Eval/evaluate_types.scm 70 */
					BgL_ev_prog2z00_bglt BgL_new1210z00_4307;

					BgL_new1210z00_4307 =
						((BgL_ev_prog2z00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_prog2z00_bgl))));
					{	/* Eval/evaluate_types.scm 70 */
						long BgL_arg1561z00_4308;

						{	/* Eval/evaluate_types.scm 70 */
							long BgL_res2349z00_4309;

							BgL_res2349z00_4309 =
								BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
							BgL_arg1561z00_4308 = BgL_res2349z00_4309;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1210z00_4307), BgL_arg1561z00_4308);
					}
					BgL_new1211z00_4306 = BgL_new1210z00_4307;
				}
				((((BgL_ev_prog2z00_bglt) COBJECT(BgL_new1211z00_4306))->BgL_e1z00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e11076z00_3865)),
					BUNSPEC);
				((((BgL_ev_prog2z00_bglt) COBJECT(BgL_new1211z00_4306))->BgL_e2z00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e21077z00_3866)),
					BUNSPEC);
				return BgL_new1211z00_4306;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1575 */
	obj_t BGl_z62lambda1575z62zz__evaluate_typesz00(obj_t BgL_envz00_3867,
		obj_t BgL_oz00_3868, obj_t BgL_vz00_3869)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			return
				((((BgL_ev_prog2z00_bglt) COBJECT(
							((BgL_ev_prog2z00_bglt) BgL_oz00_3868)))->BgL_e2z00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3869)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1574 */
	BgL_ev_exprz00_bglt BGl_z62lambda1574z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3870, obj_t BgL_oz00_3871)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) COBJECT(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3871)))->BgL_e2z00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1570 */
	obj_t BGl_z62lambda1570z62zz__evaluate_typesz00(obj_t BgL_envz00_3872,
		obj_t BgL_oz00_3873, obj_t BgL_vz00_3874)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			return
				((((BgL_ev_prog2z00_bglt) COBJECT(
							((BgL_ev_prog2z00_bglt) BgL_oz00_3873)))->BgL_e1z00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3874)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1569 */
	BgL_ev_exprz00_bglt BGl_z62lambda1569z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3875, obj_t BgL_oz00_3876)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) COBJECT(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3876)))->BgL_e1z00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1554> */
	obj_t BGl_z62zc3anonymousza31554ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3877, obj_t BgL_new1074z00_3878)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 69 */
			{
				BgL_ev_andz00_bglt BgL_auxz00_5520;

				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_new1074z00_3878))))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5520 = ((BgL_ev_andz00_bglt) BgL_new1074z00_3878);
				return ((obj_t) BgL_auxz00_5520);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1552 */
	BgL_ev_andz00_bglt BGl_z62lambda1552z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3879)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 69 */
			{	/* Eval/evaluate_types.scm 69 */
				BgL_ev_andz00_bglt BgL_new1073z00_4317;

				BgL_new1073z00_4317 =
					((BgL_ev_andz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_andz00_bgl))));
				{	/* Eval/evaluate_types.scm 69 */
					long BgL_arg1553z00_4318;

					{	/* Eval/evaluate_types.scm 69 */
						long BgL_res2348z00_4319;

						BgL_res2348z00_4319 =
							BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
						BgL_arg1553z00_4318 = BgL_res2348z00_4319;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1073z00_4317), BgL_arg1553z00_4318);
				}
				return BgL_new1073z00_4317;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1547 */
	BgL_ev_andz00_bglt BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3880, obj_t BgL_args1072z00_3881)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 69 */
			{	/* Eval/evaluate_types.scm 69 */
				BgL_ev_andz00_bglt BgL_new1209z00_4320;

				{	/* Eval/evaluate_types.scm 69 */
					BgL_ev_andz00_bglt BgL_new1208z00_4321;

					BgL_new1208z00_4321 =
						((BgL_ev_andz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_andz00_bgl))));
					{	/* Eval/evaluate_types.scm 69 */
						long BgL_arg1551z00_4322;

						{	/* Eval/evaluate_types.scm 69 */
							long BgL_res2347z00_4323;

							BgL_res2347z00_4323 =
								BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
							BgL_arg1551z00_4322 = BgL_res2347z00_4323;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1208z00_4321), BgL_arg1551z00_4322);
					}
					BgL_new1209z00_4320 = BgL_new1208z00_4321;
				}
				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt) BgL_new1209z00_4320)))->BgL_argsz00) =
					((obj_t) BgL_args1072z00_3881), BUNSPEC);
				return BgL_new1209z00_4320;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1540> */
	obj_t BGl_z62zc3anonymousza31540ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3882, obj_t BgL_new1070z00_3883)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 68 */
			{
				BgL_ev_orz00_bglt BgL_auxz00_5536;

				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_new1070z00_3883))))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5536 = ((BgL_ev_orz00_bglt) BgL_new1070z00_3883);
				return ((obj_t) BgL_auxz00_5536);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1538 */
	BgL_ev_orz00_bglt BGl_z62lambda1538z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3884)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 68 */
			{	/* Eval/evaluate_types.scm 68 */
				BgL_ev_orz00_bglt BgL_new1069z00_4325;

				BgL_new1069z00_4325 =
					((BgL_ev_orz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_orz00_bgl))));
				{	/* Eval/evaluate_types.scm 68 */
					long BgL_arg1539z00_4326;

					{	/* Eval/evaluate_types.scm 68 */
						long BgL_res2346z00_4327;

						BgL_res2346z00_4327 =
							BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
						BgL_arg1539z00_4326 = BgL_res2346z00_4327;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1069z00_4325), BgL_arg1539z00_4326);
				}
				return BgL_new1069z00_4325;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1536 */
	BgL_ev_orz00_bglt BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3885, obj_t BgL_args1068z00_3886)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 68 */
			{	/* Eval/evaluate_types.scm 68 */
				BgL_ev_orz00_bglt BgL_new1207z00_4328;

				{	/* Eval/evaluate_types.scm 68 */
					BgL_ev_orz00_bglt BgL_new1206z00_4329;

					BgL_new1206z00_4329 =
						((BgL_ev_orz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_orz00_bgl))));
					{	/* Eval/evaluate_types.scm 68 */
						long BgL_arg1537z00_4330;

						{	/* Eval/evaluate_types.scm 68 */
							long BgL_res2345z00_4331;

							BgL_res2345z00_4331 =
								BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
							BgL_arg1537z00_4330 = BgL_res2345z00_4331;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1206z00_4329), BgL_arg1537z00_4330);
					}
					BgL_new1207z00_4328 = BgL_new1206z00_4329;
				}
				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt) BgL_new1207z00_4328)))->BgL_argsz00) =
					((obj_t) BgL_args1068z00_3886), BUNSPEC);
				return BgL_new1207z00_4328;
			}
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1519> */
	obj_t BGl_z62zc3anonymousza31519ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3887, obj_t BgL_new1066z00_3888)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 66 */
			{
				BgL_ev_listz00_bglt BgL_auxz00_5552;

				((((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt) BgL_new1066z00_3888)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5552 = ((BgL_ev_listz00_bglt) BgL_new1066z00_3888);
				return ((obj_t) BgL_auxz00_5552);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1516 */
	BgL_ev_listz00_bglt BGl_z62lambda1516z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3889)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 66 */
			{	/* Eval/evaluate_types.scm 66 */
				BgL_ev_listz00_bglt BgL_new1065z00_4333;

				BgL_new1065z00_4333 =
					((BgL_ev_listz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_listz00_bgl))));
				{	/* Eval/evaluate_types.scm 66 */
					long BgL_arg1518z00_4334;

					{	/* Eval/evaluate_types.scm 66 */
						long BgL_res2344z00_4335;

						BgL_res2344z00_4335 =
							BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
						BgL_arg1518z00_4334 = BgL_res2344z00_4335;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1065z00_4333), BgL_arg1518z00_4334);
				}
				return BgL_new1065z00_4333;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1514 */
	BgL_ev_listz00_bglt BGl_z62lambda1514z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3890, obj_t BgL_args1064z00_3891)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 66 */
			{	/* Eval/evaluate_types.scm 66 */
				BgL_ev_listz00_bglt BgL_new1205z00_4336;

				{	/* Eval/evaluate_types.scm 66 */
					BgL_ev_listz00_bglt BgL_new1204z00_4337;

					BgL_new1204z00_4337 =
						((BgL_ev_listz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_listz00_bgl))));
					{	/* Eval/evaluate_types.scm 66 */
						long BgL_arg1515z00_4338;

						{	/* Eval/evaluate_types.scm 66 */
							long BgL_res2343z00_4339;

							BgL_res2343z00_4339 =
								BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
							BgL_arg1515z00_4338 = BgL_res2343z00_4339;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1204z00_4337), BgL_arg1515z00_4338);
					}
					BgL_new1205z00_4336 = BgL_new1204z00_4337;
				}
				((((BgL_ev_listz00_bglt) COBJECT(BgL_new1205z00_4336))->BgL_argsz00) =
					((obj_t) BgL_args1064z00_3891), BUNSPEC);
				return BgL_new1205z00_4336;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1526 */
	obj_t BGl_z62lambda1526z62zz__evaluate_typesz00(obj_t BgL_envz00_3892,
		obj_t BgL_oz00_3893, obj_t BgL_vz00_3894)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 66 */
			return
				((((BgL_ev_listz00_bglt) COBJECT(
							((BgL_ev_listz00_bglt) BgL_oz00_3893)))->BgL_argsz00) =
				((obj_t) BgL_vz00_3894), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1525 */
	obj_t BGl_z62lambda1525z62zz__evaluate_typesz00(obj_t BgL_envz00_3895,
		obj_t BgL_oz00_3896)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 66 */
			return
				(((BgL_ev_listz00_bglt) COBJECT(
						((BgL_ev_listz00_bglt) BgL_oz00_3896)))->BgL_argsz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1492> */
	obj_t BGl_z62zc3anonymousza31492ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3897, obj_t BgL_new1062z00_3898)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			{
				BgL_ev_ifz00_bglt BgL_auxz00_5570;

				{
					BgL_ev_exprz00_bglt BgL_auxz00_5571;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_4343;

						BgL_classz00_4343 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1285z00_4344;

							BgL__ortest_1285z00_4344 = BGL_CLASS_NIL(BgL_classz00_4343);
							if (CBOOL(BgL__ortest_1285z00_4344))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5571 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4344);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5571 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4343));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_new1062z00_3898)))->BgL_pz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5571), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5580;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_4345;

						BgL_classz00_4345 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1285z00_4346;

							BgL__ortest_1285z00_4346 = BGL_CLASS_NIL(BgL_classz00_4345);
							if (CBOOL(BgL__ortest_1285z00_4346))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5580 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4346);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5580 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4345));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_new1062z00_3898)))->BgL_tz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5580), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5589;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_4347;

						BgL_classz00_4347 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Eval/evaluate_types.scm 62 */
							obj_t BgL__ortest_1285z00_4348;

							BgL__ortest_1285z00_4348 = BGL_CLASS_NIL(BgL_classz00_4347);
							if (CBOOL(BgL__ortest_1285z00_4348))
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5589 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1285z00_4348);
								}
							else
								{	/* Eval/evaluate_types.scm 62 */
									BgL_auxz00_5589 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_4347));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) COBJECT(
									((BgL_ev_ifz00_bglt) BgL_new1062z00_3898)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5589), BUNSPEC);
				}
				BgL_auxz00_5570 = ((BgL_ev_ifz00_bglt) BgL_new1062z00_3898);
				return ((obj_t) BgL_auxz00_5570);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1490 */
	BgL_ev_ifz00_bglt BGl_z62lambda1490z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3899)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_new1061z00_4349;

				BgL_new1061z00_4349 =
					((BgL_ev_ifz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_ifz00_bgl))));
				{	/* Eval/evaluate_types.scm 62 */
					long BgL_arg1491z00_4350;

					{	/* Eval/evaluate_types.scm 62 */
						long BgL_res2342z00_4351;

						BgL_res2342z00_4351 =
							BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
						BgL_arg1491z00_4350 = BgL_res2342z00_4351;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1061z00_4349), BgL_arg1491z00_4350);
				}
				return BgL_new1061z00_4349;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1488 */
	BgL_ev_ifz00_bglt BGl_z62lambda1488z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3900, obj_t BgL_p1058z00_3901, obj_t BgL_t1059z00_3902,
		obj_t BgL_e1060z00_3903)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_new1203z00_4355;

				{	/* Eval/evaluate_types.scm 62 */
					BgL_ev_ifz00_bglt BgL_new1202z00_4356;

					BgL_new1202z00_4356 =
						((BgL_ev_ifz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_ifz00_bgl))));
					{	/* Eval/evaluate_types.scm 62 */
						long BgL_arg1489z00_4357;

						{	/* Eval/evaluate_types.scm 62 */
							long BgL_res2341z00_4358;

							BgL_res2341z00_4358 =
								BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
							BgL_arg1489z00_4357 = BgL_res2341z00_4358;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1202z00_4356), BgL_arg1489z00_4357);
					}
					BgL_new1203z00_4355 = BgL_new1202z00_4356;
				}
				((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1203z00_4355))->BgL_pz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_p1058z00_3901)),
					BUNSPEC);
				((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1203z00_4355))->BgL_tz00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_t1059z00_3902)),
					BUNSPEC);
				((((BgL_ev_ifz00_bglt) COBJECT(BgL_new1203z00_4355))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_e1060z00_3903)),
					BUNSPEC);
				return BgL_new1203z00_4355;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1508 */
	obj_t BGl_z62lambda1508z62zz__evaluate_typesz00(obj_t BgL_envz00_3904,
		obj_t BgL_oz00_3905, obj_t BgL_vz00_3906)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) COBJECT(
							((BgL_ev_ifz00_bglt) BgL_oz00_3905)))->BgL_ez00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3906)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1507 */
	BgL_ev_exprz00_bglt BGl_z62lambda1507z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3907, obj_t BgL_oz00_3908)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) COBJECT(
						((BgL_ev_ifz00_bglt) BgL_oz00_3908)))->BgL_ez00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1503 */
	obj_t BGl_z62lambda1503z62zz__evaluate_typesz00(obj_t BgL_envz00_3909,
		obj_t BgL_oz00_3910, obj_t BgL_vz00_3911)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) COBJECT(
							((BgL_ev_ifz00_bglt) BgL_oz00_3910)))->BgL_tz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3911)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1502 */
	BgL_ev_exprz00_bglt BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3912, obj_t BgL_oz00_3913)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) COBJECT(
						((BgL_ev_ifz00_bglt) BgL_oz00_3913)))->BgL_tz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1497 */
	obj_t BGl_z62lambda1497z62zz__evaluate_typesz00(obj_t BgL_envz00_3914,
		obj_t BgL_oz00_3915, obj_t BgL_vz00_3916)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			return
				((((BgL_ev_ifz00_bglt) COBJECT(
							((BgL_ev_ifz00_bglt) BgL_oz00_3915)))->BgL_pz00) =
				((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_vz00_3916)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1496 */
	BgL_ev_exprz00_bglt BGl_z62lambda1496z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3917, obj_t BgL_oz00_3918)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) COBJECT(
						((BgL_ev_ifz00_bglt) BgL_oz00_3918)))->BgL_pz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1477> */
	obj_t BGl_z62zc3anonymousza31477ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3919, obj_t BgL_new1056z00_3920)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 60 */
			{
				BgL_ev_littz00_bglt BgL_auxz00_5629;

				((((BgL_ev_littz00_bglt) COBJECT(
								((BgL_ev_littz00_bglt) BgL_new1056z00_3920)))->BgL_valuez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5629 = ((BgL_ev_littz00_bglt) BgL_new1056z00_3920);
				return ((obj_t) BgL_auxz00_5629);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1474 */
	BgL_ev_littz00_bglt BGl_z62lambda1474z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3921)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 60 */
			{	/* Eval/evaluate_types.scm 60 */
				BgL_ev_littz00_bglt BgL_new1055z00_4369;

				BgL_new1055z00_4369 =
					((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_littz00_bgl))));
				{	/* Eval/evaluate_types.scm 60 */
					long BgL_arg1476z00_4370;

					{	/* Eval/evaluate_types.scm 60 */
						long BgL_res2340z00_4371;

						BgL_res2340z00_4371 =
							BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
						BgL_arg1476z00_4370 = BgL_res2340z00_4371;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1055z00_4369), BgL_arg1476z00_4370);
				}
				return BgL_new1055z00_4369;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1472 */
	BgL_ev_littz00_bglt BGl_z62lambda1472z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3922, obj_t BgL_value1054z00_3923)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 60 */
			{	/* Eval/evaluate_types.scm 60 */
				BgL_ev_littz00_bglt BgL_new1201z00_4372;

				{	/* Eval/evaluate_types.scm 60 */
					BgL_ev_littz00_bglt BgL_new1200z00_4373;

					BgL_new1200z00_4373 =
						((BgL_ev_littz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_littz00_bgl))));
					{	/* Eval/evaluate_types.scm 60 */
						long BgL_arg1473z00_4374;

						{	/* Eval/evaluate_types.scm 60 */
							long BgL_res2339z00_4375;

							BgL_res2339z00_4375 =
								BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
							BgL_arg1473z00_4374 = BgL_res2339z00_4375;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1200z00_4373), BgL_arg1473z00_4374);
					}
					BgL_new1201z00_4372 = BgL_new1200z00_4373;
				}
				((((BgL_ev_littz00_bglt) COBJECT(BgL_new1201z00_4372))->BgL_valuez00) =
					((obj_t) BgL_value1054z00_3923), BUNSPEC);
				return BgL_new1201z00_4372;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1482 */
	obj_t BGl_z62lambda1482z62zz__evaluate_typesz00(obj_t BgL_envz00_3924,
		obj_t BgL_oz00_3925, obj_t BgL_vz00_3926)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 60 */
			return
				((((BgL_ev_littz00_bglt) COBJECT(
							((BgL_ev_littz00_bglt) BgL_oz00_3925)))->BgL_valuez00) =
				((obj_t) BgL_vz00_3926), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1481 */
	obj_t BGl_z62lambda1481z62zz__evaluate_typesz00(obj_t BgL_envz00_3927,
		obj_t BgL_oz00_3928)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 60 */
			return
				(((BgL_ev_littz00_bglt) COBJECT(
						((BgL_ev_littz00_bglt) BgL_oz00_3928)))->BgL_valuez00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1450> */
	obj_t BGl_z62zc3anonymousza31450ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3929, obj_t BgL_new1052z00_3930)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			{
				BgL_ev_globalz00_bglt BgL_auxz00_5647;

				((((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_new1052z00_3930)))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
									BgL_new1052z00_3930)))->BgL_namez00) =
					((obj_t) BGl_symbol2764z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
									BgL_new1052z00_3930)))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5647 = ((BgL_ev_globalz00_bglt) BgL_new1052z00_3930);
				return ((obj_t) BgL_auxz00_5647);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1448 */
	BgL_ev_globalz00_bglt BGl_z62lambda1448z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3931)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_new1051z00_4379;

				BgL_new1051z00_4379 =
					((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_globalz00_bgl))));
				{	/* Eval/evaluate_types.scm 55 */
					long BgL_arg1449z00_4380;

					{	/* Eval/evaluate_types.scm 55 */
						long BgL_res2338z00_4381;

						BgL_res2338z00_4381 =
							BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
						BgL_arg1449z00_4380 = BgL_res2338z00_4381;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1051z00_4379), BgL_arg1449z00_4380);
				}
				return BgL_new1051z00_4379;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1446 */
	BgL_ev_globalz00_bglt BGl_z62lambda1446z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3932, obj_t BgL_loc1048z00_3933, obj_t BgL_name1049z00_3934,
		obj_t BgL_mod1050z00_3935)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_new1199z00_4383;

				{	/* Eval/evaluate_types.scm 55 */
					BgL_ev_globalz00_bglt BgL_new1198z00_4384;

					BgL_new1198z00_4384 =
						((BgL_ev_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_globalz00_bgl))));
					{	/* Eval/evaluate_types.scm 55 */
						long BgL_arg1447z00_4385;

						{	/* Eval/evaluate_types.scm 55 */
							long BgL_res2337z00_4386;

							BgL_res2337z00_4386 =
								BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
							BgL_arg1447z00_4385 = BgL_res2337z00_4386;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1198z00_4384), BgL_arg1447z00_4385);
					}
					BgL_new1199z00_4383 = BgL_new1198z00_4384;
				}
				((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1199z00_4383))->BgL_locz00) =
					((obj_t) BgL_loc1048z00_3933), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1199z00_4383))->BgL_namez00) =
					((obj_t) ((obj_t) BgL_name1049z00_3934)), BUNSPEC);
				((((BgL_ev_globalz00_bglt) COBJECT(BgL_new1199z00_4383))->BgL_modz00) =
					((obj_t) BgL_mod1050z00_3935), BUNSPEC);
				return BgL_new1199z00_4383;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1466 */
	obj_t BGl_z62lambda1466z62zz__evaluate_typesz00(obj_t BgL_envz00_3936,
		obj_t BgL_oz00_3937, obj_t BgL_vz00_3938)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) COBJECT(
							((BgL_ev_globalz00_bglt) BgL_oz00_3937)))->BgL_modz00) =
				((obj_t) BgL_vz00_3938), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1465 */
	obj_t BGl_z62lambda1465z62zz__evaluate_typesz00(obj_t BgL_envz00_3939,
		obj_t BgL_oz00_3940)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_oz00_3940)))->BgL_modz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1461 */
	obj_t BGl_z62lambda1461z62zz__evaluate_typesz00(obj_t BgL_envz00_3941,
		obj_t BgL_oz00_3942, obj_t BgL_vz00_3943)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) COBJECT(
							((BgL_ev_globalz00_bglt) BgL_oz00_3942)))->BgL_namez00) = ((obj_t)
					((obj_t) BgL_vz00_3943)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1460 */
	obj_t BGl_z62lambda1460z62zz__evaluate_typesz00(obj_t BgL_envz00_3944,
		obj_t BgL_oz00_3945)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_oz00_3945)))->BgL_namez00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1455 */
	obj_t BGl_z62lambda1455z62zz__evaluate_typesz00(obj_t BgL_envz00_3946,
		obj_t BgL_oz00_3947, obj_t BgL_vz00_3948)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			return
				((((BgL_ev_globalz00_bglt) COBJECT(
							((BgL_ev_globalz00_bglt) BgL_oz00_3947)))->BgL_locz00) =
				((obj_t) BgL_vz00_3948), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1454 */
	obj_t BGl_z62lambda1454z62zz__evaluate_typesz00(obj_t BgL_envz00_3949,
		obj_t BgL_oz00_3950)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) COBJECT(
						((BgL_ev_globalz00_bglt) BgL_oz00_3950)))->BgL_locz00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1421> */
	obj_t BGl_z62zc3anonymousza31421ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3951, obj_t BgL_new1046z00_3952)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			{
				BgL_ev_varz00_bglt BgL_auxz00_5681;

				((((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_new1046z00_3952)))->BgL_namez00) =
					((obj_t) BGl_symbol2764z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(((BgL_ev_varz00_bglt)
									BgL_new1046z00_3952)))->BgL_effz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(((BgL_ev_varz00_bglt)
									BgL_new1046z00_3952)))->BgL_typez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				BgL_auxz00_5681 = ((BgL_ev_varz00_bglt) BgL_new1046z00_3952);
				return ((obj_t) BgL_auxz00_5681);
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1419 */
	BgL_ev_varz00_bglt BGl_z62lambda1419z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3953)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_new1045z00_4395;

				BgL_new1045z00_4395 =
					((BgL_ev_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_varz00_bgl))));
				{	/* Eval/evaluate_types.scm 51 */
					long BgL_arg1420z00_4396;

					{	/* Eval/evaluate_types.scm 51 */
						long BgL_res2336z00_4397;

						BgL_res2336z00_4397 =
							BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
						BgL_arg1420z00_4396 = BgL_res2336z00_4397;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1045z00_4395), BgL_arg1420z00_4396);
				}
				return BgL_new1045z00_4395;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1416 */
	BgL_ev_varz00_bglt BGl_z62lambda1416z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3954, obj_t BgL_name1042z00_3955, obj_t BgL_eff1043z00_3956,
		obj_t BgL_type1044z00_3957)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_new1197z00_4399;

				{	/* Eval/evaluate_types.scm 51 */
					BgL_ev_varz00_bglt BgL_new1196z00_4400;

					BgL_new1196z00_4400 =
						((BgL_ev_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_varz00_bgl))));
					{	/* Eval/evaluate_types.scm 51 */
						long BgL_arg1418z00_4401;

						{	/* Eval/evaluate_types.scm 51 */
							long BgL_res2335z00_4402;

							BgL_res2335z00_4402 =
								BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
							BgL_arg1418z00_4401 = BgL_res2335z00_4402;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1196z00_4400), BgL_arg1418z00_4401);
					}
					BgL_new1197z00_4399 = BgL_new1196z00_4400;
				}
				((((BgL_ev_varz00_bglt) COBJECT(BgL_new1197z00_4399))->BgL_namez00) =
					((obj_t) ((obj_t) BgL_name1042z00_3955)), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(BgL_new1197z00_4399))->BgL_effz00) =
					((obj_t) BgL_eff1043z00_3956), BUNSPEC);
				((((BgL_ev_varz00_bglt) COBJECT(BgL_new1197z00_4399))->BgL_typez00) =
					((obj_t) BgL_type1044z00_3957), BUNSPEC);
				return BgL_new1197z00_4399;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1440 */
	obj_t BGl_z62lambda1440z62zz__evaluate_typesz00(obj_t BgL_envz00_3958,
		obj_t BgL_oz00_3959, obj_t BgL_vz00_3960)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) COBJECT(
							((BgL_ev_varz00_bglt) BgL_oz00_3959)))->BgL_typez00) =
				((obj_t) BgL_vz00_3960), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1439 */
	obj_t BGl_z62lambda1439z62zz__evaluate_typesz00(obj_t BgL_envz00_3961,
		obj_t BgL_oz00_3962)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_oz00_3962)))->BgL_typez00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1435> */
	obj_t BGl_z62zc3anonymousza31435ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3963)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return BBOOL(((bool_t) 0));
		}
		BGL_FUNCTION_END;
	}



/* &lambda1434 */
	obj_t BGl_z62lambda1434z62zz__evaluate_typesz00(obj_t BgL_envz00_3964,
		obj_t BgL_oz00_3965, obj_t BgL_vz00_3966)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) COBJECT(
							((BgL_ev_varz00_bglt) BgL_oz00_3965)))->BgL_effz00) =
				((obj_t) BgL_vz00_3966), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1433 */
	obj_t BGl_z62lambda1433z62zz__evaluate_typesz00(obj_t BgL_envz00_3967,
		obj_t BgL_oz00_3968)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_oz00_3968)))->BgL_effz00);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1426 */
	obj_t BGl_z62lambda1426z62zz__evaluate_typesz00(obj_t BgL_envz00_3969,
		obj_t BgL_oz00_3970, obj_t BgL_vz00_3971)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return
				((((BgL_ev_varz00_bglt) COBJECT(
							((BgL_ev_varz00_bglt) BgL_oz00_3970)))->BgL_namez00) = ((obj_t)
					((obj_t) BgL_vz00_3971)), BUNSPEC);
		}
		BGL_FUNCTION_END;
	}



/* &lambda1425 */
	obj_t BGl_z62lambda1425z62zz__evaluate_typesz00(obj_t BgL_envz00_3972,
		obj_t BgL_oz00_3973)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) COBJECT(
						((BgL_ev_varz00_bglt) BgL_oz00_3973)))->BgL_namez00);
		}
		BGL_FUNCTION_END;
	}



/* &<anonymous:1405> */
	obj_t BGl_z62zc3anonymousza31405ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3974, obj_t BgL_new1040z00_3975)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 49 */
			return ((obj_t) ((BgL_ev_exprz00_bglt) BgL_new1040z00_3975));
		}
		BGL_FUNCTION_END;
	}



/* &lambda1403 */
	BgL_ev_exprz00_bglt BGl_z62lambda1403z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3976)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 49 */
			{	/* Eval/evaluate_types.scm 49 */
				BgL_ev_exprz00_bglt BgL_new1039z00_4411;

				BgL_new1039z00_4411 =
					((BgL_ev_exprz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
								BgL_ev_exprz00_bgl))));
				{	/* Eval/evaluate_types.scm 49 */
					long BgL_arg1404z00_4412;

					{	/* Eval/evaluate_types.scm 49 */
						long BgL_res2334z00_4413;

						BgL_res2334z00_4413 =
							BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
						BgL_arg1404z00_4412 = BgL_res2334z00_4413;
					}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_new1039z00_4411), BgL_arg1404z00_4412);
				}
				return BgL_new1039z00_4411;
			}
		}
		BGL_FUNCTION_END;
	}



/* &lambda1401 */
	BgL_ev_exprz00_bglt BGl_z62lambda1401z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3977)
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 49 */
			{	/* Eval/evaluate_types.scm 49 */
				BgL_ev_exprz00_bglt BgL_new1195z00_4414;

				{	/* Eval/evaluate_types.scm 49 */
					BgL_ev_exprz00_bglt BgL_new1194z00_4415;

					BgL_new1194z00_4415 =
						((BgL_ev_exprz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
									BgL_ev_exprz00_bgl))));
					{	/* Eval/evaluate_types.scm 49 */
						long BgL_arg1402z00_4416;

						{	/* Eval/evaluate_types.scm 49 */
							long BgL_res2333z00_4417;

							BgL_res2333z00_4417 =
								BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
							BgL_arg1402z00_4416 = BgL_res2333z00_4417;
						}
						BGL_OBJECT_CLASS_NUM_SET(
							((BgL_objectz00_bglt) BgL_new1194z00_4415), BgL_arg1402z00_4416);
					}
					BgL_new1195z00_4414 = BgL_new1194z00_4415;
				}
				return BgL_new1195z00_4414;
			}
		}
		BGL_FUNCTION_END;
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
		BGL_FUNCTION_END;
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
	{
		BGL_FUNCTION_BEGIN;
		{	/* Eval/evaluate_types.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046086),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 430898742),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 180158922),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251314740),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439353001),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1047446),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967693),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 454272164),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					445908113),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					434692624),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460262918),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -400105135),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614678), BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 127905250),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540577),
				BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
			return BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					86988580), BSTRING_TO_STRING(BGl_string2441z00zz__evaluate_typesz00));
		}
		BGL_FUNCTION_END;
	}

#ifdef __cplusplus
}
#endif
